#include <asm/io.h>
#include <asm/arch/io.h>

unsigned char rtd_inb(unsigned int addr)
{
	if (addr < (RBUS_BASE_VIRT_OLD+RBUS_BASE_SIZE) && addr >= RBUS_BASE_VIRT_OLD)
		return __raw_readb(addr-RBUS_BASE_VIRT_OLD+RBUS_BASE_VIRT);
	else if (addr < (SPI_FLASH_BASE_VIRT_OLD+SPI_FLASH_BASE_SIZE) && addr >= SPI_FLASH_BASE_VIRT_OLD)
		return __raw_readb(addr-SPI_FLASH_BASE_VIRT_OLD+SPI_FLASH_BASE_VIRT);
	else
		return __raw_readb(addr);
}
unsigned short rtd_inw(unsigned int addr)
{
	if (addr < (RBUS_BASE_VIRT_OLD+RBUS_BASE_SIZE) && addr >= RBUS_BASE_VIRT_OLD)
		return __raw_readw(addr-RBUS_BASE_VIRT_OLD+RBUS_BASE_VIRT);
	else if (addr < (SPI_FLASH_BASE_VIRT_OLD+SPI_FLASH_BASE_SIZE) && addr >= SPI_FLASH_BASE_VIRT_OLD)
		return __raw_readw(addr-SPI_FLASH_BASE_VIRT_OLD+SPI_FLASH_BASE_VIRT);
	else
		return __raw_readw(addr);
}
unsigned int rtd_inl(unsigned int addr)
{
	if (addr < (RBUS_BASE_VIRT_OLD+RBUS_BASE_SIZE) && addr >= RBUS_BASE_VIRT_OLD)
		return __raw_readl(addr-RBUS_BASE_VIRT_OLD+RBUS_BASE_VIRT);
	else if (addr < (SPI_FLASH_BASE_VIRT_OLD+SPI_FLASH_BASE_SIZE) && addr >= SPI_FLASH_BASE_VIRT_OLD)
		return __raw_readl(addr-SPI_FLASH_BASE_VIRT_OLD+SPI_FLASH_BASE_VIRT);
	else
		return __raw_readl(addr);
}
void rtd_outb(unsigned int addr, unsigned char val)
{
	if (addr < (RBUS_BASE_VIRT_OLD+RBUS_BASE_SIZE) && addr >= RBUS_BASE_VIRT_OLD)
		__raw_writeb(val,addr-RBUS_BASE_VIRT_OLD+RBUS_BASE_VIRT);
	else if (addr < (SPI_FLASH_BASE_VIRT_OLD+SPI_FLASH_BASE_SIZE) && addr >= SPI_FLASH_BASE_VIRT_OLD)
		__raw_writeb(val, addr-SPI_FLASH_BASE_VIRT_OLD+SPI_FLASH_BASE_VIRT);
	else
		__raw_writeb(val,addr);
}
void rtd_outw(unsigned int addr, unsigned short val)
{
	if (addr < (RBUS_BASE_VIRT_OLD+RBUS_BASE_SIZE) && addr >= RBUS_BASE_VIRT_OLD)
		__raw_writew(val,addr-RBUS_BASE_VIRT_OLD+RBUS_BASE_VIRT);
	else if (addr < (SPI_FLASH_BASE_VIRT_OLD+SPI_FLASH_BASE_SIZE) && addr >= SPI_FLASH_BASE_VIRT_OLD)
		__raw_writew(val, addr-SPI_FLASH_BASE_VIRT_OLD+SPI_FLASH_BASE_VIRT);
	else
		__raw_writew(val,addr);
}
void rtd_outl(unsigned int addr, unsigned int val)
{
	if (addr < (RBUS_BASE_VIRT_OLD+RBUS_BASE_SIZE) && addr >= 0xb8000000)
		__raw_writel(val,addr-RBUS_BASE_VIRT_OLD+RBUS_BASE_VIRT);
	else if (addr < (SPI_FLASH_BASE_VIRT_OLD+SPI_FLASH_BASE_SIZE) && addr >= SPI_FLASH_BASE_VIRT_OLD)
		__raw_writel(val, addr-SPI_FLASH_BASE_VIRT_OLD+SPI_FLASH_BASE_VIRT);
	else
		__raw_writel(val,addr);
}

void rtd_part_outl(unsigned int addr, unsigned int B, unsigned int C, unsigned int D)
{
    unsigned int X,A,value;
	X=(1<<(B-C+1))-1;
	A=rtd_inl(addr);
	value = (A & (~(X<<C))) | (D<<C);
	rtd_outl(addr,value);
}

unsigned int rtd_part_inl(unsigned int addr, unsigned int B, unsigned int C)
{
    unsigned int X,A;
	X=(1<<(B-C+1))-1;
	A=rtd_inl(addr);
    return (A>>C)&X;
}

unsigned int part_value(unsigned int value, unsigned int B, unsigned int C)
{
	unsigned int X,A;
	X=(1<<(B-C+1))-1;
	A=value;
    return (A>>C)&X;
}

