#ifndef _GDMA_SCALE_COEF_H_
#define _GDMA_SCALE_COEF_H_

#define GDMA_NUM_COEFF_RATIOS     32

#ifndef CONFIG_SUPPORT_SCALER
typedef struct {
	short Osd_shpnr_en;
	short peaking_en;
	short EMF_en;
	short EMF_Range;
	short Seg0_Offset;
	short Seg1_Offset;
	short Seg2_Offset;
	short Seg0_Gain_Sel;
	short Seg1_Gain_Sel;
	short Seg2_Gain_Sel;
	short EMF_fixextent;
	short EMF_Shift;
	short C0;
	short C1;
	short C2;
	short Gain_Blr;
	short Gain_Pos;
	short Gain_Neg;
	short HV_Pos;
	short HV_Neg;
	short LV;

} DRV_OSD_sharp;

DRV_OSD_sharp gVipOSD_sharp[] = {
	/* 0:Osd_shpnr_en 	1:peaking_en		2:EMF_en		3:EMF_Range		4:Seg0_Offset */
	/* 5:Seg1_Offset		6:Seg2_Offset		7:Seg0_Gain_Sel		8:Seg1_Gain_Sel */
	/* 9:Seg2_Gain_Sel	10:EMF_fixextent	11:EMF_Shift	12:C0	13:C1 */
	/*14:C2				15:Gain_Blr		16:Gain_Pos	17:Gain_Neg	18:HV_Pos */
	/*19:HV_Neg			20:LV */
/*	 0,	1	2	3	4	5	6	7	8	9	10	11	12	13	14	15	16	17	18	19	20 */
	{0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0},
	{1,	1,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	128,	-64,	0,	0,	30,	30,	100,	100,	0},
	{1,	1,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	128,	-64,	0,	0,	40,	40,	100,	100,	0},
	{1,	1,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	128,	-64,	0,	0,	50,	50,	100,	100,	0},
	{1,	1,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	128,	-64,	0,	0,	60,	60,	100,	100,	0},
	{1,	1,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	128,	-64,	0,	0,	70,	70,	100,	100,	0},
	{1,	1,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	128,	-64,	0,	0,	80,	80,	100,	100,	0},
	{1,	1,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	128,	-64,	0,	0,	90,	90,	100,	100,	0},
	{1,	1,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	128,	-64,	0,	0,	100,	100,	100,	100,	0},

};
#endif


const unsigned int GDMA_ScaleRatio[GDMA_NUM_COEFF_RATIOS]
= {0x3800, 0x4800, 0x5000, 0x5800, 0x6000, 0x6800, 0x7000, 0x7800, 0x8000, 0x8800, 0x9000, 0x9800, 0xa000, 0xa800, 0xb000, 0xb800, 0xc000, 0xc800, 0xd000, 0xd800, 0xe000, 0xe800, 0xf000, 0xf800, 0x12000, 0x14000, 0x16000, 0x18000, 0x1a000, 0x1c000, 0x1e000, 0x20000 }
;

const short GDMA_coef_4t8p_ratio[GDMA_NUM_COEFF_RATIOS][4][4]
= {
/* for all upscale ratio */
/* 4taps-- Vertical sampling */
{
    {   -8,   256,    16,    -8 },
    {  -24,   240,    48,    -8 },
    {  -28,   212,    88,   -16 },
    {  -28,   176,   132,   -24 },
},

/* I=8, D=9, wp= 0.111, ws= 0.122, alpha= 0.100 */
/* 4taps-- Vertical sampling */
{
    {  -24,   241,     5,    34 },
    {  -47,   249,    46,     8 },
    {  -60,   237,    99,   -20 },
    {  -59,   204,   155,   -44 },
},
/* I=8, D=10, wp= 0.100, ws= 0.110, alpha= 0.100 */
/* 4taps-- Vertical sampling */
{
    {   -1,   222,    28,     7 },
    {  -26,   230,    67,   -15 },
    {  -44,   223,   113,   -36 },
    {  -53,   198,   160,   -49 },
},
/* I=8, D=11, wp= 0.091, ws= 0.100, alpha= 0.100 */
/* 4taps-- Vertical sampling */
{
    {   22,   208,    47,   -21 },
    {   -4,   212,    82,   -34 },
    {  -25,   204,   120,   -43 },
    {  -40,   186,   156,   -46 },
},
/* I=8, D=12, wp= 0.083, ws= 0.092, alpha= 0.100 */
/* 4taps-- Vertical sampling */
{
    {   36,   198,    62,   -40 },
    {   12,   197,    92,   -45 },
    {   -9,   188,   122,   -45 },
    {  -27,   172,   150,   -39 },
},
/* I=8, D=13, wp= 0.077, ws= 0.085, alpha= 0.100 */
/* 4taps-- Vertical sampling */
{
    {   47,   190,    72,   -53 },
    {   24,   186,    97,   -51 },
    {    2,   177,   121,   -44 },
    {  -17,   163,   143,   -33 },
},
/* I=8, D=14, wp= 0.071, ws= 0.079, alpha= 0.100 */
/* 4taps-- Vertical sampling */
{
    {   55,   184,    78,   -61 },
    {   32,   176,   100,   -52 },
    {   10,   167,   120,   -41 },
    {   -9,   154,   138,   -27 },
},
/* I=8, D=15, wp= 0.067, ws= 0.073, alpha= 0.100 */
/* 4taps-- Vertical sampling */
{
    {   61,   178,    82,   -65 },
    {   38,   169,   101,   -52 },
    {   16,   160,   118,   -38 },
    {   -3,   146,   134,   -21 },
},
/* I=8, D=16, wp= 0.063, ws= 0.069, alpha= 0.100 */
/* 4taps-- Vertical sampling */
{
    {   65,   172,    85,   -66 },
    {   42,   163,   101,   -50 },
    {   21,   153,   116,   -34 },
    {    1,   142,   130,   -17 },
},
/* I=8, D=17, wp= 0.059, ws= 0.065, alpha= 0.100 */
/* 4taps-- Vertical sampling */
{
    {   67,   167,    87,   -65 },
    {   45,   158,   101,   -48 },
    {   25,   147,   114,   -30 },
    {    6,   137,   126,   -13 },
},
/* I=8, D=18, wp= 0.056, ws= 0.061, alpha= 0.100 */
/* 4taps-- Vertical sampling */
{
    {   69,   162,    88,   -63 },
    {   48,   152,   100,   -44 },
    {   28,   142,   112,   -26 },
    {   10,   133,   122,    -9 },
},
/* I=8, D=19, wp= 0.053, ws= 0.058, alpha= 0.100 */
/* 4taps-- Vertical sampling */
{
    {   71,   156,    88,   -59 },
    {   50,   147,    99,   -40 },
    {   31,   137,   110,   -22 },
    {   13,   129,   119,    -5 },
},
/* I=8, D=20, wp= 0.050, ws= 0.055, alpha= 0.100 */
/* 4taps-- Vertical sampling */
{
    {   72,   151,    88,   -55 },
    {   52,   142,    98,   -36 },
    {   34,   133,   107,   -18 },
    {   16,   125,   116,    -1 },
},
/* I=8, D=21, wp= 0.048, ws= 0.052, alpha= 0.100 */
/* 4taps-- Vertical sampling */
{
    {   72,   147,    87,   -50 },
    {   53,   138,    96,   -31 },
    {   36,   128,   105,   -13 },
    {   19,   121,   113,     3 },
},
/* I=8, D=22, wp= 0.045, ws= 0.050, alpha= 0.100 */
/* 4taps-- Vertical sampling */
{
    {   73,   140,    87,   -44 },
    {   55,   132,    95,   -26 },
    {   38,   125,   102,    -9 },
    {   23,   116,   110,     7 },
},
/* I=8, D=23, wp= 0.043, ws= 0.048, alpha= 0.100 */
/* 4taps-- Vertical sampling */
{
    {   73,   135,    86,   -38 },
    {   56,   127,    93,   -20 },
    {   40,   120,   100,    -4 },
    {   25,   113,   107,    11 },
},
/* I=8, D=24, wp= 0.042, ws= 0.046, alpha= 0.100 */
/* 4taps-- Vertical sampling */
{
    {   73,   129,    85,   -31 },
    {   57,   123,    91,   -15 },
    {   42,   117,    97,     0 },
    {   28,   109,   104,    15 },
},
/* I=8, D=25, wp= 0.040, ws= 0.044, alpha= 0.100 */
/* 4taps-- Vertical sampling */
{
    {   72,   125,    83,   -24 },
    {   58,   118,    89,    -9 },
    {   44,   112,    95,     5 },
    {   31,   106,   101,    18 },
},
/* I=8, D=26, wp= 0.038, ws= 0.042, alpha= 0.100 */
/* 4taps-- Vertical sampling */
{
    {   72,   120,    82,   -18 },
    {   59,   114,    87,    -4 },
    {   46,   108,    93,     9 },
    {   34,   102,    98,    22 },
},
/* I=8, D=27, wp= 0.037, ws= 0.041, alpha= 0.100 */
/* 4taps-- Vertical sampling */
{
    {   72,   114,    81,   -11 },
    {   59,   109,    86,     2 },
    {   48,   104,    90,    14 },
    {   36,   100,    95,    25 },
},
/* I=8, D=28, wp= 0.036, ws= 0.039, alpha= 0.100 */
/* 4taps-- Vertical sampling */
{
    {   71,   111,    79,    -5 },
    {   60,   105,    84,     7 },
    {   49,   101,    88,    18 },
    {   39,    97,    92,    28 },
},
/* I=8, D=29, wp= 0.034, ws= 0.038, alpha= 0.100 */
/* 4taps-- Vertical sampling */
{
    {   71,   106,    78,     1 },
    {   60,   102,    82,    12 },
    {   51,    97,    86,    22 },
    {   41,    94,    90,    31 },
},
/* I=8, D=30, wp= 0.033, ws= 0.037, alpha= 0.100 */
/* 4taps-- Vertical sampling */
{
    {   70,   103,    77,     6 },
    {   61,    98,    81,    16 },
    {   52,    95,    84,    25 },
    {   43,    91,    88,    34 },
},
/* I=8, D=31, wp= 0.032, ws= 0.035, alpha= 0.100 */
/* 4taps-- Vertical sampling */
{
    {   70,    99,    76,    11 },
    {   61,    96,    79,    20 },
    {   53,    92,    82,    29 },
    {   45,    88,    86,    37 },
},


/* I=8, D=36, wp= 0.028, ws= 0.031, alpha= 0.100 */
/* 4taps-- Vertical sampling */
{
    {   68,    86,    72,    30 },
    {   62,    84,    74,    36 },
    {   57,    82,    76,    41 },
    {   52,    79,    78,    47 },
},
/* I=8, D=40, wp= 0.025, ws= 0.028, alpha= 0.100 */
/* 4taps-- Vertical sampling */
{
    {   67,    79,    70,    40 },
    {   63,    78,    71,    44 },
    {   59,    76,    73,    48 },
    {   55,    76,    74,    51 },
},
/* I=8, D=44, wp= 0.023, ws= 0.025, alpha= 0.100 */
/* 4taps-- Vertical sampling */
{
    {   66,    76,    68,    46 },
    {   63,    75,    69,    49 },
    {   60,    74,    70,    52 },
    {   57,    72,    72,    55 },
},
/* I=8, D=48, wp= 0.021, ws= 0.023, alpha= 0.100 */
/* 4taps-- Vertical sampling */
{
    {   66,    73,    67,    50 },
    {   63,    73,    68,    52 },
    {   61,    72,    69,    54 },
    {   59,    70,    70,    57 },
},
/* I=8, D=52, wp= 0.019, ws= 0.021, alpha= 0.100 */
/* 4taps-- Vertical sampling */
{
    {   65,    71,    67,    53 },
    {   64,    70,    67,    55 },
    {   62,    70,    68,    56 },
    {   60,    69,    69,    58 },
},
/* I=8, D=56, wp= 0.018, ws= 0.020, alpha= 0.100 */
/* 4taps-- Vertical sampling */
{
    {   65,    70,    66,    55 },
    {   64,    69,    67,    56 },
    {   62,    69,    67,    58 },
    {   61,    68,    68,    59 },
},
/* I=8, D=60, wp= 0.017, ws= 0.018, alpha= 0.100 */
/* 4taps-- Vertical sampling */
{
    {   65,    69,    66,    56 },
    {   64,    68,    66,    58 },
    {   63,    67,    67,    59 },
    {   61,    68,    67,    60 },
},
/* I=8, D=64, wp= 0.016, ws= 0.017, alpha= 0.100 */
/* 4taps-- Vertical sampling */
{
    {   65,    67,    66,    58 },
    {   64,    67,    66,    59 },
    {   63,    67,    66,    60 },
    {   62,    66,    67,    61 },
},

}
;

const short GDMA_coef_2t8p_swap[8]
= {
  0x2e8, 0x203,
  0x6d6, 0x4a5,
  0xb5b, 0x92a,
  0xdfd, 0xd18
}
;
#endif

