#include <common.h>

#ifndef __PANEL_CONFIG_PARAM_H__
#define __PANEL_CONFIG_PARAM_H__

typedef unsigned char UINT8;
typedef unsigned short UINT16;
typedef unsigned int UINT32;

#ifdef CONFIG_CUSTOM_SN_PANEL
#include <panel_config_parameter_sn.h>

#endif

typedef struct _PANEL_CONFIG_PARAMETER{

	UINT8 iCONFIG_DISPLAY_PORT:2;				//0: single port, 1: double port, 2:4 port
	UINT8 iCONFIG_DISPLAY_COLOR_BITS:2;			//0: 30bits, 1:24 bits, 2: 18bits
	UINT8 iCONFIG_DISPLAY_EVEN_RSV1_BIT:1;		//0: Indicate 0, 1: Indicate 1
	UINT8 iCONFIG_DISPLAY_ODD_RSV1_BIT:1;		//0: Indicate 0, 1: Indicate 1
	UINT8 iCONFIG_DISPLAY_BITMAPPING_TABLE:1;	//0: Table1, 1:Table2
	UINT8 iCONFIG_DISPLAY_PORTAB_SWAP:1;		//0: No Swap, 1: Swap , 4 port lvds has 24 type mapping tables
	//1 byte

	UINT8 iCONFIG_DISPLAY_RED_BLUE_SWAP:1;		//0: No Swap, 1: Swap
	UINT8 iCONFIG_DISPLAY_MSB_LSB_SWAP:1;		//0: No Swap, 1: Swap
	UINT8 iCONFIG_DISPLAY_SKEW_DATA_OUTPUT:1;	//0: Disable, 1: Skew data output
	UINT8 iCONFIG_DISPLAY_OUTPUT_INVERSE:1;		//0: No Swap, 1: Swap
	UINT8 iCONFIG_DISPLAY_VERTICAL_SYNC_NORMAL:1;
	UINT8 iCONFIG_DISPLAY_HORIZONTAL_SYNC_NORMAL:1;
	UINT8 iCONFIG_DISPLAY_RATIO_4X3:2;
	//2 bytes

	UINT16 iCONFIG_DISPLAY_CLOCK_MAX;		//119
	UINT16 iCONFIG_DISPLAY_CLOCK_MIN;
	UINT8 iCONFIG_DISPLAY_REFRESH_RATE;			//75
	UINT32 iCONFIG_DISPLAY_CLOCK_TYPICAL;		//70*1000000 // hsliao 20081008
        //11 bytes

	UINT16 iCONFIG_DISP_HORIZONTAL_TOTAL;		//(1688 -1)
	UINT16 iCONFIG_DISP_VERTICAL_TOTAL;			//(1066 - 1)
        //15 bytes

	UINT8 iCONFIG_DISP_HSYNC_WIDTH;				//(32 - 1)
	UINT8 iCONFIG_DISP_VSYNC_LENGTH;			//(6 - 1)
        //17 bytes

	UINT16 iCONFIG_DISP_DEN_STA_HPOS;			//200//201//32
	UINT16 iCONFIG_DISP_DEN_END_HPOS;// 				1480//1482//1312
	UINT16 iCONFIG_DISP_DEN_STA_VPOS;// 				16//frank@1118 Change 5bits to 16 bits to solve overflow problem
	UINT16 iCONFIG_DISP_DEN_END_VPOS;// 				1040
        //25 bytes

	UINT16 iCONFIG_DISP_ACT_STA_HPOS:3;// 				0
	UINT16 iCONFIG_DISP_ACT_END_HPOS:13;// 				1280
	UINT16 iCONFIG_DISP_ACT_STA_VPOS:3;// 				0
	UINT16 iCONFIG_DISP_ACT_END_VPOS:13;// 				1024
        //33 bytes

	UINT16 iCONFIG_DISP_HSYNC_LASTLINE;// 				(1688 - 1)
	UINT8 iCONFIG_DISP_DCLK_DELAY;// 					0
	UINT8 _iCONFIG_DISP_ACT_STA_BIOS;// 				0x00
	UINT8 iCONFIG_DEFAULT_DPLL_M_DIVIDER;//			0x68 //hpwang 20071119 set default DCLK=(27*104/8)/2/2=87.75MHz
	UINT8 iCONFIG_DEFAULT_DPLL_N_DIVIDER;//			0x18
        //39 bytes

	UINT16 iPANEL_TO_LVDS_ON_ms;//						50 // Delay(T1+T2): Panel Power --> LVDS Signal
	UINT16 iLVDS_TO_LIGHT_ON_ms;//						200 // Delay(T3):    Settings: LVDS Signal --> Backlight On

	UINT16 iLIGHT_TO_LDVS_OFF_ms;//					200 // Delay(T4):    Turn Off backlight and delay to turn off LVDS signal
	UINT16 iLVDS_TO_PANEL_OFF_ms;//					40 // Delay(T5+T6): LVDS Signal Off --> Panel Power Off
        //47 bytes

	UINT16 iPANEL_OFF_TO_ON_ms;//						1000 // Delay(T7):    Totally Off --> Next On
	UINT16 iCONFIG_BACKLIGHT_PWM_FREQ;//				10000
	UINT8 iCONFIG_BACKLIGHT_PWM_DUTY;//				10
	UINT8 iFIX_LAST_LINE_ENABLE;//				0
	UINT8 iFIX_LAST_LINE_4X_ENABLE;//				0
	UINT8 iVFLIP;//									0
        //55 bytes

	UINT8 iPICASSO_CONTROL_ON;
	UINT8 i3D_DISPLAY_SUPPORT;
	UINT8 i3D_LINE_ALTERNATIVE_SUPPORT;
	UINT8 i3D_PR_OUTPUT_LR_SWAP;
	UINT8 i3D_SG_OUTPUT_120HZ_ON;
	UINT8 i3D_SG_24HZ_OUTPUT_FHD_ON;
	UINT8 iSCALER_2D_3D_CVT_HWSHIFT_ENABLE;
        //62 bytes

	//append new parameters 2012-3-21
	UINT16 iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MIN;
	UINT16 iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MAX;
	UINT16 iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN;
	UINT16 iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX;
        //70 bytes

	UINT8 iCONFIG_LVDS_4_PORTS_INDEX;
	UINT8 iCONFIG_LVDS_PN_SWAP;
	UINT8 iCONFIG_LVDS_MIRROR;
        //73 bytes

	UINT32 iCONFIG_DISPLAY_PORT_CONFIG1;
	UINT32 iCONFIG_DISPLAY_PORT_CONFIG2;
	UINT8 iCONFIG_SR_MODE;
	UINT8 iCONFIG_SR_PIXEL_MODE;
	UINT8 iCONFIG_SFG_SEG_NUM;
	UINT8 iCONFIG_SFG_PORT_NUM;
	UINT8 iCONFIG_PANEL_TYPE;	// (0:LVDS 2k1k only), (1: VBY_ONE 4k2K), (2: LVDS 4k2k+2k1k (NEED define CUSTOM INDEX))
	UINT8 iCONFIG_PANEL_CUSTOM_INDEX; // 0: none, 1: M3_CMI_55, 2: PA168_AU55,
        //87 bytes

	UINT8 i3D_DISPLAY_TIMING;
	// 88 byte
	
        UINT8 iCONFIG_CUSTOMER_PANEL_ID;

	//Reserve for new parameters
	UINT16 iCONFIG_DISP_RESVER05;
	UINT32 iCONFIG_DISP_RESVER06; //sizeof is 100byte now. don't add more item
        //95 bytes
	UINT16 iPANEL_WIDTH_MM;
	UINT16 iPANEL_HEIGHT_MM;
	UINT16 iBACKLIGHT_PWM_48HZ_FREQ;
	UINT16 iBACKLIGHT_PWM_50HZ_FREQ;
	UINT16 iBACKLIGHT_PWM_60HZ_FREQ; 

	//96 bytes
#ifdef CONFIG_CUSTOM_SN_PANEL
	//105 bytes
	UINT32 iPixelClk60Hz;
	UINT16 iHTotal60Hz;
	UINT16 iVTotal60Hz;
	UINT8  iHSyncWidth_60Hz;
	UINT8  iVSyncWidth_60Hz;
	UINT16 iHFrontPorch_60Hz;
	UINT16 iHbackPorch_60Hz;
	UINT16 iVFrontPorch_60Hz;
	UINT16 iVbackPorch_60Hz;

	UINT32 iPixelClk50Hz;
	UINT16 iHTotal50Hz;
	UINT16 iVTotal50Hz;
	UINT8  iHSyncWidth_50Hz;
	UINT8  iVSyncWidth_50Hz;
	UINT16 iHFrontPorch_50Hz;
	UINT16 iHbackPorch_50Hz;
	UINT16 iVFrontPorch_50Hz;
	UINT16 iVbackPorch_50Hz;

	UINT32 iPixelClk48Hz;
	UINT16 iHTotal48Hz;
	UINT16 iVTotal48Hz;
	UINT8 iHSyncWidth_48Hz;
	UINT8 iVSyncWidth_48Hz;
	UINT16 iHFrontPorch_48Hz;
	UINT16 iHbackPorch_48Hz;
	UINT16 iVFrontPorch_48Hz;
	UINT16 iVbackPorch_48Hz;
#ifdef CONFIG_TCON_LESS
	UINT8  iTcon_Index;
	//160 byte
	char iBuf[31];
#else
	//159 byte
	char iBuf[32];
#endif
	//191 byte
#endif	
#ifdef CONFIG_CUSTOMER_TV010
	char sPanelName[40];
#else
	char sPanelName[32];
#endif
#ifdef CONFIG_CUSTOM_SN_PANEL//611 byte
	//UINT8 iSnBin_Data[SN_BIN_LEN];	
	SN_PANEL_INFO snInfo;
#endif

#ifdef CONFIG_CUSTOMER_TV010
	////for TV010
	UINT8 iCONFIG_BACKLIGHT_DUTYMAX;
	UINT8 iCONFIG_BACKLIGHT_DUTYMIN;
	UINT8 iCONFIG_PANEL_GAMMA_TYPE;

    UINT8 iCONFIG_TCON_MODE0:2;
    UINT8 iCONFIG_TCON_MODE1:2;
    UINT8 iCONFIG_HDREN:2;
    UINT8 iCONFIG_LDEN:2;

    UINT8 iCONFIG_PANELSIZE;
    UINT8 iCONFIG_IPWMFeq;
    UINT8 iCONFIG_IPWMDuty;
    UINT8 iCONFIG_VPWMFeq;
    UINT8 iCONFIG_VPWMDuty;

    UINT8 iCONFIG_SSC_Enable:1;
    UINT8 iCONFIG_SSC_Freq:6;
    UINT8 iCONFIG_EYE_TX_Enable:1;
    UINT8 iCONFIG_SSC_Level:4;  // 0.5 x level
    UINT8 iCONFIG_TCON_TYPE:4;

    UINT8 iCONFIG_Enable_FLL_Clock_Adjust:1;
    UINT8 iCONFIG_FLL_NEW_MODE_SYNTHESISN_Val:3;
    UINT8 iCONFIG_Fix_last_line_systhesisn_ratio:4;

    UINT8 iCONFIG_LD_Alogorithm_Soc;
    UINT16 iCONFIG_LD_Partition_Amount;

    UINT32 iCONFIG_OFFRS_TIMEOUT;

    UINT32 iCONFIG_LD_Enable:1;
    UINT32 iCONFIG_LD_SPIDecoderMcuInPower_Enable:1;
    UINT32 iCONFIG_EYE_TX_Amplitude_Current:4;
    UINT32 iCONFIG_EYE_TX_Termination_Res:2;
    UINT32 iCONFIG_EYE_TX_Bias_Voltage:3;
    UINT32 iCONFIG_EYE_TX_Emphasis_Current:3;
    UINT32 iCONFIG_EYE_TX_Output_Enable:6;
    UINT32 iCONFIG_Force60Hz_Nosignal_PlayPic:1;
    UINT32 iCONFIG_SSC_FineTune_Enable:1;
    UINT32 iCONFIG_FORCE_HDR_VIVID_Enable:1;
    UINT32 iCONFIG_VIP_HDR_3DLUT_ENABLE:1;
    UINT32 iCONFIG_EYE_EPI_TX_Enable:1;
    UINT32 iCONFIG_RESERVE01:7;

    UINT8 iCONFIG_buf[24];
	////
#endif
} __attribute__((aligned(4))) PANEL_CONFIG_PARAMETER;

#if defined(USE_PANEL_CONFIG_PARAM_EXTEND_FOR_TV035)
typedef struct _C_PANEL_CONFIG_PARAM_EXTEND{

	UINT8 iCONFIG_CUSTOMER_PANEL_ID;
	UINT8 iCONFIG_CUSTOMER_PANEL_INDEX;
	UINT8 iCONFIG_CUSTOMER_HDR;
	UINT8 iCONFIG_CUSTOMER_LD;
	
	UINT8 iCONFIG_CUSTOMER_OLED;
	UINT8 iCONFIG_CUSTOMER_AMP;
	UINT8 iCONFIG_CUSTOMER_PANEL_EN_AND_PWM_ON_FLIP;
	UINT8 iCONFIG_CUSTOMER_BACKLIGHT_ACT_MAX;
	
	UINT8 iCONFIG_CUSTOMER_BACKLIGHT_ACT_MIN;
	UINT8 iCONFIG_CUSTOMER_ENERGY_SAVING;
	UINT8 iCONFIG_CUSTOMER_ENERGY_SAVING_RATIO;
	UINT8 iCONFIG_CUSTOMER_SPEAKER_OUTPUT;
	UINT8 iCONFIG_PLATFORM_EYE;// for eye

	UINT8 iCONFIG_CUSTOMER_RESVER04;
	UINT8 iCONFIG_CUSTOMER_RESVER05;
	UINT8 iCONFIG_CUSTOMER_RESVER06;

	UINT16 iCONFIG_CUSTOMER_DISP_RESVER01;
	UINT16 iCONFIG_CUSTOMER_DISP_RESVER02;
	UINT16 iCONFIG_CUSTOMER_DISP_RESVER03;
	UINT16 iCONFIG_CUSTOMER_DISP_RESVER04;
	UINT16 iCONFIG_CUSTOMER_DISP_RESVER05;
	UINT16 iCONFIG_CUSTOMER_DISP_RESVER06;
	UINT16 iCONFIG_CUSTOMER_DISP_RESVER07;
	UINT16 iCONFIG_CUSTOMER_DISP_RESVER08;

	UINT32 iCONFIG_CUSTOMER_DISP_RESVER_32_01;
	UINT32 iCONFIG_CUSTOMER_DISP_RESVER_32_02;
	UINT32 iCONFIG_CUSTOMER_DISP_RESVER_32_03;
	UINT32 iCONFIG_CUSTOMER_DISP_RESVER_32_04;
	UINT32 iCONFIG_CUSTOMER_DISP_RESVER_32_05;
	UINT32 iCONFIG_CUSTOMER_DISP_RESVER_32_06;
	UINT32 iCONFIG_CUSTOMER_DISP_RESVER_32_07;
	UINT32 iCONFIG_CUSTOMER_DISP_RESVER_32_08;


	char sPanel_disp_Name[32];
}__attribute__((aligned(4))) C_PANEL_CONFIG_PARAM_EXTEND;
extern struct _C_PANEL_CONFIG_PARAM_EXTEND  default_c_panel_param_extend;

#endif
extern struct _PANEL_CONFIG_PARAMETER  default_panel_parameter;

#endif//#ifndef __PANEL_CONFIG_PARAM_H__

