#ifndef _DISEQC_h_
#define _DISEQC_h_

#include <asm/arch/io.h>

#define  DISEQC_DSCU_CTL														 0x18070000
#define  DISEQC_DSCU_CTL_tx_env_mode_mask										 (0x40000000)
#define  DISEQC_DSCU_CTL_dsc_pol_od_ctrl_mask                                    (0x20000000)
#define  DISEQC_DSCU_CTL_dsc_22k_od_ctrl_mask                                    (0x10000000)
#define  DISEQC_DSCU_CTL_eorm_timeout_reg_mask                                   (0x0F000000)
#define  DISEQC_DSCU_CTL_mili_second_define_mask                                 (0x00FFFFE0)
#define  DISEQC_DSCU_CTL_lnb_pol_mask                                            (0x00000010)
#define  DISEQC_DSCU_CTL_int_en_mask                                             (0x00000008)
#define  DISEQC_DSCU_CTL_level_mask                                              (0x00000006)
#define  DISEQC_DSCU_CTL_tx_env_mode(data)										 (0x40000000&((data)<<30))
#define  DISEQC_DSCU_CTL_dsc_pol_od_ctrl(data)                                   (0x20000000&((data)<<29))
#define  DISEQC_DSCU_CTL_dsc_22k_od_ctrl(data)                                   (0x10000000&((data)<<28))
#define  DISEQC_DSCU_CTL_eorm_timeout_reg(data)                                  (0x0F000000&((data)<<24))
#define  DISEQC_DSCU_CTL_mili_second_define(data)                                (0x00FFFFE0&((data)<<5))
#define  DISEQC_DSCU_CTL_lnb_pol(data)                                           (0x00000010&((data)<<4))
#define  DISEQC_DSCU_CTL_int_en(data)                                            (0x00000008&((data)<<3))
#define  DISEQC_DSCU_CTL_level(data)                                             (0x00000006&((data)<<1))
#define  DISEQC_DSCU_CTL_get_tx_env_mode_ctrl(data)                              ((0x40000000&(data))>>30)
#define  DISEQC_DSCU_CTL_get_dsc_pol_od_ctrl(data)                               ((0x20000000&(data))>>29)
#define  DISEQC_DSCU_CTL_get_dsc_22k_od_ctrl(data)                               ((0x10000000&(data))>>28)
#define  DISEQC_DSCU_CTL_get_eorm_timeout_reg(data)                              ((0x0F000000&(data))>>24)
#define  DISEQC_DSCU_CTL_get_mili_second_define(data)                            ((0x00FFFFE0&(data))>>5)
#define  DISEQC_DSCU_CTL_get_lnb_pol(data)                                       ((0x00000010&(data))>>4)
#define  DISEQC_DSCU_CTL_get_int_en(data)                                        ((0x00000008&(data))>>3)
#define  DISEQC_DSCU_CTL_get_level(data)                                         ((0x00000006&(data))>>1)

#define  DISEQC_DSCU_TX_CTL														 0x18070004
#define  DISEQC_DSCU_TX_CTL_loop_back_mode_mask                                  (0x80000000)
#define  DISEQC_DSCU_TX_CTL_listen_dly_mask                                      (0x78000000)
#define  DISEQC_DSCU_TX_CTL_third_bit_mask                                       (0x07C00000)
#define  DISEQC_DSCU_TX_CTL_eot_len_mask                                         (0x003E0000)
#define  DISEQC_DSCU_TX_CTL_tx_pty_mask                                          (0x00010000)
#define  DISEQC_DSCU_TX_CTL_xmt_mode_mask                                        (0x0000C000)
#define  DISEQC_DSCU_TX_CTL_msg_len_mask                                         (0x00003800)
#define  DISEQC_DSCU_TX_CTL_tx_go_mask                                           (0x00000400)
#define  DISEQC_DSCU_TX_CTL_tone_div_mask                                        (0x000003FF)
#define  DISEQC_DSCU_TX_CTL_loop_back_mode(data)                                 (0x80000000&((data)<<31))
#define  DISEQC_DSCU_TX_CTL_listen_dly(data)                                     (0x78000000&((data)<<27))
#define  DISEQC_DSCU_TX_CTL_third_bit(data)                                      (0x07C00000&((data)<<22))
#define  DISEQC_DSCU_TX_CTL_eot_len(data)                                        (0x003E0000&((data)<<17))
#define  DISEQC_DSCU_TX_CTL_tx_pty(data)                                         (0x00010000&((data)<<16))
#define  DISEQC_DSCU_TX_CTL_xmt_mode(data)                                       (0x0000C000&((data)<<14))
#define  DISEQC_DSCU_TX_CTL_msg_len(data)                                        (0x00003800&((data)<<11))
#define  DISEQC_DSCU_TX_CTL_tx_go(data)                                          (0x00000400&((data)<<10))
#define  DISEQC_DSCU_TX_CTL_tone_div(data)                                       (0x000003FF&(data))
#define  DISEQC_DSCU_TX_CTL_get_loop_back_mode(data)                             ((0x80000000&(data))>>31)
#define  DISEQC_DSCU_TX_CTL_get_listen_dly(data)                                 ((0x78000000&(data))>>27)
#define  DISEQC_DSCU_TX_CTL_get_third_bit(data)                                  ((0x07C00000&(data))>>22)
#define  DISEQC_DSCU_TX_CTL_get_eot_len(data)                                    ((0x003E0000&(data))>>17)
#define  DISEQC_DSCU_TX_CTL_get_tx_pty(data)                                     ((0x00010000&(data))>>16)
#define  DISEQC_DSCU_TX_CTL_get_xmt_mode(data)                                   ((0x0000C000&(data))>>14)
#define  DISEQC_DSCU_TX_CTL_get_msg_len(data)                                    ((0x00003800&(data))>>11)
#define  DISEQC_DSCU_TX_CTL_get_tx_go(data)                                      ((0x00000400&(data))>>10)
#define  DISEQC_DSCU_TX_CTL_get_tone_div(data)                                   (0x000003FF&(data))

#define  DISEQC_DSCU_RX_CTL                                                      0x18070008
#define  DISEQC_DSCU_RX_CTL_median_flt_en_mask                                   (0x80000000)
#define  DISEQC_DSCU_RX_CTL_dscu_exp_win_mask                                    (0x7FE00000)
#define  DISEQC_DSCU_RX_CTL_silence_threshold_mask                               (0x001FF800)
#define  DISEQC_DSCU_RX_CTL_to_val_mask                                          (0x000007F8)
#define  DISEQC_DSCU_RX_CTL_to_chk_mask                                          (0x00000004)
#define  DISEQC_DSCU_RX_CTL_rx_pty_mask                                          (0x00000002)
#define  DISEQC_DSCU_RX_CTL_median_flt_en(data)                                  (0x80000000&((data)<<31))
#define  DISEQC_DSCU_RX_CTL_dscu_exp_win(data)                                   (0x7FE00000&((data)<<21))
#define  DISEQC_DSCU_RX_CTL_silence_threshold(data)                              (0x001FF800&((data)<<11))
#define  DISEQC_DSCU_RX_CTL_to_val(data)                                         (0x000007F8&((data)<<3))
#define  DISEQC_DSCU_RX_CTL_to_chk(data)                                         (0x00000004&((data)<<2))
#define  DISEQC_DSCU_RX_CTL_rx_pty(data)                                         (0x00000002&((data)<<1))
#define  DISEQC_DSCU_RX_CTL_get_median_flt_en(data)                              ((0x80000000&(data))>>31)
#define  DISEQC_DSCU_RX_CTL_get_dscu_exp_win(data)                               ((0x7FE00000&(data))>>21)
#define  DISEQC_DSCU_RX_CTL_get_silence_threshold(data)                          ((0x001FF800&(data))>>11)
#define  DISEQC_DSCU_RX_CTL_get_to_val(data)                                     ((0x000007F8&(data))>>3)
#define  DISEQC_DSCU_RX_CTL_get_to_chk(data)                                     ((0x00000004&(data))>>2)
#define  DISEQC_DSCU_RX_CTL_get_rx_pty(data)                                     ((0x00000002&(data))>>1)

#define  DISEQC_DSCU_INTR_ENA                                                    0x1807000C
#define  DISEQC_DSCU_INTR_ENA_to_interrupt_ena_mask                              (0x00000040)
#define  DISEQC_DSCU_INTR_ENA_tx_msg_done_ena_mask                               (0x00000020)
#define  DISEQC_DSCU_INTR_ENA_tx_done_ena_mask                                   (0x00000010)
#define  DISEQC_DSCU_INTR_ENA_rx_full_ena_mask                                   (0x00000004)
#define  DISEQC_DSCU_INTR_ENA_eorm_ena_mask                                      (0x00000002)
#define  DISEQC_DSCU_INTR_ENA_incoming_ena_mask                                  (0x00000001)
#define  DISEQC_DSCU_INTR_ENA_to_interrupt_ena(data)                             (0x00000040&((data)<<6))
#define  DISEQC_DSCU_INTR_ENA_tx_msg_done_ena(data)                              (0x00000020&((data)<<5))
#define  DISEQC_DSCU_INTR_ENA_tx_done_ena(data)                                  (0x00000010&((data)<<4))
#define  DISEQC_DSCU_INTR_ENA_rx_full_ena(data)                                  (0x00000004&((data)<<2))
#define  DISEQC_DSCU_INTR_ENA_eorm_ena(data)                                     (0x00000002&((data)<<1))
#define  DISEQC_DSCU_INTR_ENA_incoming_ena(data)                                 (0x00000001&(data))
#define  DISEQC_DSCU_INTR_ENA_get_to_interrupt_ena(data)                         ((0x00000040&(data))>>6)
#define  DISEQC_DSCU_INTR_ENA_get_tx_msg_done_ena(data)                          ((0x00000020&(data))>>5)
#define  DISEQC_DSCU_INTR_ENA_get_tx_done_ena(data)                              ((0x00000010&(data))>>4)
#define  DISEQC_DSCU_INTR_ENA_get_rx_full_ena(data)                              ((0x00000004&(data))>>2)
#define  DISEQC_DSCU_INTR_ENA_get_eorm_ena(data)                                 ((0x00000002&(data))>>1)
#define  DISEQC_DSCU_INTR_ENA_get_incoming_ena(data)                             (0x00000001&(data))

#define  DISEQC_DSCU_INTR                                                        0x18070010
#define  DISEQC_DSCU_INTR_to_interrupt_int_mask                                  (0x00000040)
#define  DISEQC_DSCU_INTR_tx_msg_done_int_mask                                   (0x00000020)
#define  DISEQC_DSCU_INTR_tx_done_int_mask                                       (0x00000010)
#define  DISEQC_DSCU_INTR_rx_full_int_mask                                       (0x00000004)
#define  DISEQC_DSCU_INTR_eorm_int_mask                                          (0x00000002)
#define  DISEQC_DSCU_INTR_incoming_int_mask                                      (0x00000001)
#define  DISEQC_DSCU_INTR_to_interrupt_int(data)                                 (0x00000040&((data)<<6))
#define  DISEQC_DSCU_INTR_tx_msg_done_int(data)                                  (0x00000020&((data)<<5))
#define  DISEQC_DSCU_INTR_tx_done_int(data)                                      (0x00000010&((data)<<4))
#define  DISEQC_DSCU_INTR_rx_full_int(data)                                      (0x00000004&((data)<<2))
#define  DISEQC_DSCU_INTR_eorm_int(data)                                         (0x00000002&((data)<<1))
#define  DISEQC_DSCU_INTR_incoming_int(data)                                     (0x00000001&(data))
#define  DISEQC_DSCU_INTR_get_to_interrupt_int(data)                             ((0x00000040&(data))>>6)
#define  DISEQC_DSCU_INTR_get_tx_msg_done_int(data)                              ((0x00000020&(data))>>5)
#define  DISEQC_DSCU_INTR_get_tx_done_int(data)                                  ((0x00000010&(data))>>4)
#define  DISEQC_DSCU_INTR_get_rx_full_int(data)                                  ((0x00000004&(data))>>2)
#define  DISEQC_DSCU_INTR_get_eorm_int(data)                                     ((0x00000002&(data))>>1)
#define  DISEQC_DSCU_INTR_get_incoming_int(data)                                 (0x00000001&(data))
#define	 DISEQC_DSCU_INTR_CLEAN_ALL												 0x00000000

#define  DISEQC_DSCU_RX_STATUS                                                   0x18070014
#define  DISEQC_DSCU_RX_STATUS_to_interrupt_mask                                 (0x00000080)
#define  DISEQC_DSCU_RX_STATUS_rx_count_mask                                     (0x00000078)
#define  DISEQC_DSCU_RX_STATUS_rx_full_mask                                      (0x00000004)
#define  DISEQC_DSCU_RX_STATUS_eorm_mask                                         (0x00000002)
#define  DISEQC_DSCU_RX_STATUS_incoming_mask                                     (0x00000001)
#define  DISEQC_DSCU_RX_STATUS_to_interrupt(data)                                (0x00000080&((data)<<7))
#define  DISEQC_DSCU_RX_STATUS_rx_count(data)                                    (0x00000078&((data)<<3))
#define  DISEQC_DSCU_RX_STATUS_rx_full(data)                                     (0x00000004&((data)<<2))
#define  DISEQC_DSCU_RX_STATUS_eorm(data)                                        (0x00000002&((data)<<1))
#define  DISEQC_DSCU_RX_STATUS_incoming(data)                                    (0x00000001&(data))
#define  DISEQC_DSCU_RX_STATUS_get_to_interrupt(data)                            ((0x00000080&(data))>>7)
#define  DISEQC_DSCU_RX_STATUS_get_rx_count(data)                                ((0x00000078&(data))>>3)
#define  DISEQC_DSCU_RX_STATUS_get_rx_full(data)                                 ((0x00000004&(data))>>2)
#define  DISEQC_DSCU_RX_STATUS_get_eorm(data)                                    ((0x00000002&(data))>>1)
#define  DISEQC_DSCU_RX_STATUS_get_incoming(data)                                (0x00000001&(data))

#define  DISEQC_DSCU_TX_STATUS                                                   0x18070018
#define  DISEQC_DSCU_TX_STATUS_tx_count_mask                                     (0x00000078)
#define  DISEQC_DSCU_TX_STATUS_tx_msg_done_mask                                  (0x00000004)
#define  DISEQC_DSCU_TX_STATUS_tx_done_mask                                      (0x00000002)
#define  DISEQC_DSCU_TX_STATUS_tx_busy_mask                                      (0x00000001)
#define  DISEQC_DSCU_TX_STATUS_tx_count(data)                                    (0x00000078&((data)<<3))
#define  DISEQC_DSCU_TX_STATUS_tx_msg_done(data)                                 (0x00000004&((data)<<2))
#define  DISEQC_DSCU_TX_STATUS_tx_done(data)                                     (0x00000002&((data)<<1))
#define  DISEQC_DSCU_TX_STATUS_tx_busy(data)                                     (0x00000001&(data))
#define  DISEQC_DSCU_TX_STATUS_get_tx_count(data)                                ((0x00000078&(data))>>3)
#define  DISEQC_DSCU_TX_STATUS_get_tx_msg_done(data)                             ((0x00000004&(data))>>2)
#define  DISEQC_DSCU_TX_STATUS_get_tx_done(data)                                 ((0x00000002&(data))>>1)
#define  DISEQC_DSCU_TX_STATUS_get_tx_busy(data)                                 (0x00000001&(data))

#define  DISEQC_DSCU_TX_BUF0                                                     0x1807001C
#define  DISEQC_DSCU_TX_BUF0_dscu_tx_buf_0_mask                                  (0x000000FF)
#define  DISEQC_DSCU_TX_BUF0_dscu_tx_buf_0(data)                                 (0x000000FF&(data))
#define  DISEQC_DSCU_TX_BUF0_get_dscu_tx_buf_0(data)                             (0x000000FF&(data))

#define  DISEQC_DSCU_TX_BUF1                                                     0x18070020
#define  DISEQC_DSCU_TX_BUF1_dscu_tx_buf_1_mask                                  (0x000000FF)
#define  DISEQC_DSCU_TX_BUF1_dscu_tx_buf_1(data)                                 (0x000000FF&(data))
#define  DISEQC_DSCU_TX_BUF1_get_dscu_tx_buf_1(data)                             (0x000000FF&(data))

#define  DISEQC_DSCU_TX_BUF2                                                     0x18070024
#define  DISEQC_DSCU_TX_BUF2_dscu_tx_buf_2_mask                                  (0x000000FF)
#define  DISEQC_DSCU_TX_BUF2_dscu_tx_buf_2(data)                                 (0x000000FF&(data))
#define  DISEQC_DSCU_TX_BUF2_get_dscu_tx_buf_2(data)                             (0x000000FF&(data))

#define  DISEQC_DSCU_TX_BUF3                                                     0x18070028
#define  DISEQC_DSCU_TX_BUF3_dscu_tx_buf_3_mask                                  (0x000000FF)
#define  DISEQC_DSCU_TX_BUF3_dscu_tx_buf_3(data)                                 (0x000000FF&(data))
#define  DISEQC_DSCU_TX_BUF3_get_dscu_tx_buf_3(data)                             (0x000000FF&(data))

#define  DISEQC_DSCU_TX_BUF4                                                     0x1807002C
#define  DISEQC_DSCU_TX_BUF4_dscu_tx_buf_4_mask                                  (0x000000FF)
#define  DISEQC_DSCU_TX_BUF4_dscu_tx_buf_4(data)                                 (0x000000FF&(data))
#define  DISEQC_DSCU_TX_BUF4_get_dscu_tx_buf_4(data)                             (0x000000FF&(data))

#define  DISEQC_DSCU_TX_BUF5                                                     0x18070030
#define  DISEQC_DSCU_TX_BUF5_dscu_tx_buf_5_mask                                  (0x000000FF)
#define  DISEQC_DSCU_TX_BUF5_dscu_tx_buf_5(data)                                 (0x000000FF&(data))
#define  DISEQC_DSCU_TX_BUF5_get_dscu_tx_buf_5(data)                             (0x000000FF&(data))

#define  DISEQC_DSCU_TX_BUF6                                                     0x18070034
#define  DISEQC_DSCU_TX_BUF6_dscu_tx_buf_6_mask                                  (0x000000FF)
#define  DISEQC_DSCU_TX_BUF6_dscu_tx_buf_6(data)                                 (0x000000FF&(data))
#define  DISEQC_DSCU_TX_BUF6_get_dscu_tx_buf_6(data)                             (0x000000FF&(data))

#define  DISEQC_DSCU_TX_BUF7                                                     0x18070038
#define  DISEQC_DSCU_TX_BUF7_dscu_tx_buf_7_mask                                  (0x000000FF)
#define  DISEQC_DSCU_TX_BUF7_dscu_tx_buf_7(data)                                 (0x000000FF&(data))
#define  DISEQC_DSCU_TX_BUF7_get_dscu_tx_buf_7(data)                             (0x000000FF&(data))

#define  DISEQC_DSCU_RX_BUF0                                                     0x1807003C
#define  DISEQC_DSCU_RX_BUF0_perr0_mask                                          (0x00000200)
#define  DISEQC_DSCU_RX_BUF0_pty0_mask                                           (0x00000100)
#define  DISEQC_DSCU_RX_BUF0_byte0_mask                                          (0x000000FF)
#define  DISEQC_DSCU_RX_BUF0_perr0(data)                                         (0x00000200&((data)<<9))
#define  DISEQC_DSCU_RX_BUF0_pty0(data)                                          (0x00000100&((data)<<8))
#define  DISEQC_DSCU_RX_BUF0_byte0(data)                                         (0x000000FF&(data))
#define  DISEQC_DSCU_RX_BUF0_get_perr0(data)                                     ((0x00000200&(data))>>9)
#define  DISEQC_DSCU_RX_BUF0_get_pty0(data)                                      ((0x00000100&(data))>>8)
#define  DISEQC_DSCU_RX_BUF0_get_byte0(data)                                     (0x000000FF&(data))

#define  DISEQC_DSCU_RX_BUF1                                                     0x18070040
#define  DISEQC_DSCU_RX_BUF1_perr1_mask                                          (0x00000200)
#define  DISEQC_DSCU_RX_BUF1_pty1_mask                                           (0x00000100)
#define  DISEQC_DSCU_RX_BUF1_byte1_mask                                          (0x000000FF)
#define  DISEQC_DSCU_RX_BUF1_perr1(data)                                         (0x00000200&((data)<<9))
#define  DISEQC_DSCU_RX_BUF1_pty1(data)                                          (0x00000100&((data)<<8))
#define  DISEQC_DSCU_RX_BUF1_byte1(data)                                         (0x000000FF&(data))
#define  DISEQC_DSCU_RX_BUF1_get_perr1(data)                                     ((0x00000200&(data))>>9)
#define  DISEQC_DSCU_RX_BUF1_get_pty1(data)                                      ((0x00000100&(data))>>8)
#define  DISEQC_DSCU_RX_BUF1_get_byte1(data)                                     (0x000000FF&(data))

#define  DISEQC_DSCU_RX_BUF2                                                     0x18070044
#define  DISEQC_DSCU_RX_BUF2_perr2_mask                                          (0x00000200)
#define  DISEQC_DSCU_RX_BUF2_pty2_mask                                           (0x00000100)
#define  DISEQC_DSCU_RX_BUF2_byte2_mask                                          (0x000000FF)
#define  DISEQC_DSCU_RX_BUF2_perr2(data)                                         (0x00000200&((data)<<9))
#define  DISEQC_DSCU_RX_BUF2_pty2(data)                                          (0x00000100&((data)<<8))
#define  DISEQC_DSCU_RX_BUF2_byte2(data)                                         (0x000000FF&(data))
#define  DISEQC_DSCU_RX_BUF2_get_perr2(data)                                     ((0x00000200&(data))>>9)
#define  DISEQC_DSCU_RX_BUF2_get_pty2(data)                                      ((0x00000100&(data))>>8)
#define  DISEQC_DSCU_RX_BUF2_get_byte2(data)                                     (0x000000FF&(data))

#define  DISEQC_DSCU_RX_BUF3                                                     0x18070048
#define  DISEQC_DSCU_RX_BUF3_perr3_mask                                          (0x00000200)
#define  DISEQC_DSCU_RX_BUF3_pty3_mask                                           (0x00000100)
#define  DISEQC_DSCU_RX_BUF3_byte3_mask                                          (0x000000FF)
#define  DISEQC_DSCU_RX_BUF3_perr3(data)                                         (0x00000200&((data)<<9))
#define  DISEQC_DSCU_RX_BUF3_pty3(data)                                          (0x00000100&((data)<<8))
#define  DISEQC_DSCU_RX_BUF3_byte3(data)                                         (0x000000FF&(data))
#define  DISEQC_DSCU_RX_BUF3_get_perr3(data)                                     ((0x00000200&(data))>>9)
#define  DISEQC_DSCU_RX_BUF3_get_pty3(data)                                      ((0x00000100&(data))>>8)
#define  DISEQC_DSCU_RX_BUF3_get_byte3(data)                                     (0x000000FF&(data))

#define  DISEQC_DSCU_RX_BUF4                                                     0x1807004C
#define  DISEQC_DSCU_RX_BUF4_perr4_mask                                          (0x00000200)
#define  DISEQC_DSCU_RX_BUF4_pty4_mask                                           (0x00000100)
#define  DISEQC_DSCU_RX_BUF4_byte4_mask                                          (0x000000FF)
#define  DISEQC_DSCU_RX_BUF4_perr4(data)                                         (0x00000200&((data)<<9))
#define  DISEQC_DSCU_RX_BUF4_pty4(data)                                          (0x00000100&((data)<<8))
#define  DISEQC_DSCU_RX_BUF4_byte4(data)                                         (0x000000FF&(data))
#define  DISEQC_DSCU_RX_BUF4_get_perr4(data)                                     ((0x00000200&(data))>>9)
#define  DISEQC_DSCU_RX_BUF4_get_pty4(data)                                      ((0x00000100&(data))>>8)
#define  DISEQC_DSCU_RX_BUF4_get_byte4(data)                                     (0x000000FF&(data))

#define  DISEQC_DSCU_RX_BUF5                                                     0x18070050
#define  DISEQC_DSCU_RX_BUF5_perr5_mask                                          (0x00000200)
#define  DISEQC_DSCU_RX_BUF5_pty5_mask                                           (0x00000100)
#define  DISEQC_DSCU_RX_BUF5_byte5_mask                                          (0x000000FF)
#define  DISEQC_DSCU_RX_BUF5_perr5(data)                                         (0x00000200&((data)<<9))
#define  DISEQC_DSCU_RX_BUF5_pty5(data)                                          (0x00000100&((data)<<8))
#define  DISEQC_DSCU_RX_BUF5_byte5(data)                                         (0x000000FF&(data))
#define  DISEQC_DSCU_RX_BUF5_get_perr5(data)                                     ((0x00000200&(data))>>9)
#define  DISEQC_DSCU_RX_BUF5_get_pty5(data)                                      ((0x00000100&(data))>>8)
#define  DISEQC_DSCU_RX_BUF5_get_byte5(data)                                     (0x000000FF&(data))

#define  DISEQC_DSCU_RX_BUF6                                                     0x18070054
#define  DISEQC_DSCU_RX_BUF6_perr6_mask                                          (0x00000200)
#define  DISEQC_DSCU_RX_BUF6_pty6_mask                                           (0x00000100)
#define  DISEQC_DSCU_RX_BUF6_byte6_mask                                          (0x000000FF)
#define  DISEQC_DSCU_RX_BUF6_perr6(data)                                         (0x00000200&((data)<<9))
#define  DISEQC_DSCU_RX_BUF6_pty6(data)                                          (0x00000100&((data)<<8))
#define  DISEQC_DSCU_RX_BUF6_byte6(data)                                         (0x000000FF&(data))
#define  DISEQC_DSCU_RX_BUF6_get_perr6(data)                                     ((0x00000200&(data))>>9)
#define  DISEQC_DSCU_RX_BUF6_get_pty6(data)                                      ((0x00000100&(data))>>8)
#define  DISEQC_DSCU_RX_BUF6_get_byte6(data)                                     (0x000000FF&(data))

#define  DISEQC_DSCU_RX_BUF7                                                     0x18070058
#define  DISEQC_DSCU_RX_BUF7_perr7_mask                                          (0x00000200)
#define  DISEQC_DSCU_RX_BUF7_pty7_mask                                           (0x00000100)
#define  DISEQC_DSCU_RX_BUF7_byte7_mask                                          (0x000000FF)
#define  DISEQC_DSCU_RX_BUF7_perr7(data)                                         (0x00000200&((data)<<9))
#define  DISEQC_DSCU_RX_BUF7_pty7(data)                                          (0x00000100&((data)<<8))
#define  DISEQC_DSCU_RX_BUF7_byte7(data)                                         (0x000000FF&(data))
#define  DISEQC_DSCU_RX_BUF7_get_perr7(data)                                     ((0x00000200&(data))>>9)
#define  DISEQC_DSCU_RX_BUF7_get_pty7(data)                                      ((0x00000100&(data))>>8)
#define  DISEQC_DSCU_RX_BUF7_get_byte7(data)                                     (0x000000FF&(data))

#define  DISEQC_DSCU_FLT                                                         0x1807005C
#define  DISEQC_DSCU_FLT_high_low_time_window_mask                               (0x0007F000)
#define  DISEQC_DSCU_FLT_threshold_mask                                          (0x00000FFC)
#define  DISEQC_DSCU_FLT_src_mask                                                (0x00000003)
#define  DISEQC_DSCU_FLT_high_low_time_window(data)                              (0x0007F000&((data)<<12))
#define  DISEQC_DSCU_FLT_threshold(data)                                         (0x00000FFC&((data)<<2))
#define  DISEQC_DSCU_FLT_src(data)                                               (0x00000003&(data))
#define  DISEQC_DSCU_FLT_get_high_low_time_window(data)                          ((0x0007F000&(data))>>12)
#define  DISEQC_DSCU_FLT_get_threshold(data)                                     ((0x00000FFC&(data))>>2)
#define  DISEQC_DSCU_FLT_get_src(data)                                           (0x00000003&(data))

#define  DISEQC_DSCU_INIT_EXP_WIN                                                0x18070060
#define  DISEQC_DSCU_INIT_EXP_WIN_initial_expected_window_mask                   (0x001FFFFF)
#define  DISEQC_DSCU_INIT_EXP_WIN_initial_expected_window(data)                  (0x001FFFFF&(data))
#define  DISEQC_DSCU_INIT_EXP_WIN_get_initial_expected_window(data)              (0x001FFFFF&(data))

#define  DISEQC_DSCU_PM_SEL                                                      0x18070064
#define  DISEQC_DSCU_PM_SEL_dsc_pm_sel_mask                                      (0x00000003)
#define  DISEQC_DSCU_PM_SEL_dsc_pm_sel(data)                                     (0x00000003&(data))
#define  DISEQC_DSCU_PM_SEL_get_dsc_pm_sel(data)                                 (0x00000003&(data))

//Register:DSCUL_CTL
#define DSCU_CTL                            DISEQC_DSCU_CTL
#define TX_ENV_MODE_MASK                    DISEQC_DSCU_CTL_tx_env_mode_mask
#define TX_ENV_MODE(x)						DISEQC_DSCU_CTL_tx_env_mode(x)
#define DSC_POL_OPEN_DRAIN_CTRL_MASK        DISEQC_DSCU_CTL_dsc_pol_od_ctrl_mask
#define DSC_POL_OPEN_DRAIN_CTRL(x)			DISEQC_DSCU_CTL_dsc_pol_od_ctrl(x)
#define DSC_22K_OPEN_DRAIN_CTRL_MASK        DISEQC_DSCU_CTL_dsc_22k_od_ctrl_mask
#define DSC_22K_OPEN_DRAIN_CTRL(x)			DISEQC_DSCU_CTL_dsc_22k_od_ctrl(x)
#define EORM_TIMEOUT_REG_MASK               DISEQC_DSCU_CTL_eorm_timeout_reg_mask
#define EORM_TIMEOUT_REG(x)                 DISEQC_DSCU_CTL_eorm_timeout_reg(x)
#define MILI_SEC_DEF_MASK                   DISEQC_DSCU_CTL_mili_second_define_mask
#define MILI_SEC_DEF(x)                     DISEQC_DSCU_CTL_mili_second_define(x)
#define LNB_POL_MASK                        DISEQC_DSCU_CTL_lnb_pol_mask
#define LNB_POL(x)                          DISEQC_DSCU_CTL_lnb_pol(x)
#define INT_EN_MASK                         DISEQC_DSCU_CTL_int_en_mask
#define INT_EN(x)                           DISEQC_DSCU_CTL_int_en(x)
#define LEVEL_MASK                          DISEQC_DSCU_CTL_level_mask
#define LEVEL(x)							DISEQC_DSCU_CTL_level(x)

//Register:DSCU_TX_CTL
#define DSCU_TX_CTL                         DISEQC_DSCU_TX_CTL
#define LOOP_BACK_MODE_MASK                 DISEQC_DSCU_TX_CTL_loop_back_mode_mask
#define LOOP_BACK_MODE(x)                   DISEQC_DSCU_TX_CTL_loop_back_mode(x)
#define LISTEN_DELAY_MASK                   DISEQC_DSCU_TX_CTL_listen_dly_mask
#define LISTEN_DELAY(x)                     DISEQC_DSCU_TX_CTL_listen_dly(x)
#define THIRD_BIT_MASK                      DISEQC_DSCU_TX_CTL_third_bit_mask
#define THIRD_BIT(x)                        DISEQC_DSCU_TX_CTL_third_bit(x)
#define EOT_LEN_MASK                        DISEQC_DSCU_TX_CTL_eot_len_mask
#define EOT_LEN(x)                          DISEQC_DSCU_TX_CTL_eot_len(x)
#define TX_PARITY_MASK                      DISEQC_DSCU_TX_CTL_tx_pty_mask
#define TX_PARITY(x)                        DISEQC_DSCU_TX_CTL_tx_pty(x)
#define XMT_MODE_MASK                       DISEQC_DSCU_TX_CTL_xmt_mode_mask
#define XMT_MODE(x)                         DISEQC_DSCU_TX_CTL_xmt_mode(x)
#define MSG_LEN_MASKE                       DISEQC_DSCU_TX_CTL_msg_len_mask
#define MSG_LEN(x)                          DISEQC_DSCU_TX_CTL_msg_len(x)
#define TX_GO_MASK                          DISEQC_DSCU_TX_CTL_tx_go_mask
#define TX_GO(x)                            DISEQC_DSCU_TX_CTL_tx_go(x)
#define TONE_DIV_MASK                       DISEQC_DSCU_TX_CTL_tone_div_mask
#define TONE_DIV(x)                         DISEQC_DSCU_TX_CTL_tone_div(x)

//Register:DSCU_RX_CTL
#define DSCU_RX_CTL                         DISEQC_DSCU_RX_CTL
#define MEDIAN_FLT_EN_MASK                  DISEQC_DSCU_RX_CTL_median_flt_en_mask
#define MEDIAN_FLT_EN(x)                    DISEQC_DSCU_RX_CTL_median_flt_en(x)
#define DSCU_EXP_WIN_MASK                   DISEQC_DSCU_RX_CTL_dscu_exp_win_mask
#define DSCU_EXP_WIN(x)                     DISEQC_DSCU_RX_CTL_dscu_exp_win(x)
#define SILENCE_THRESHOLD_MAKS              DISEQC_DSCU_RX_CTL_silence_threshold_mask
#define SILENCE_THRESHOLD(x)                DISEQC_DSCU_RX_CTL_silence_threshold(x)
#define TO_VAL_MASK                         DISEQC_DSCU_RX_CTL_to_val_mask
#define TO_VAL(x)                           DISEQC_DSCU_RX_CTL_to_val(x)
#define TO_CHK_MASK                         DISEQC_DSCU_RX_CTL_to_chk_mask
#define TO_CHK(x)                           DISEQC_DSCU_RX_CTL_to_chk(x)
#define RX_PARITY_MASK                      DISEQC_DSCU_RX_CTL_rx_pty_mask
#define RX_PARITY(x)                        DISEQC_DSCU_RX_CTL_rx_pty(x)

//Register:DSCU_INTR_ENA
#define DSCU_INTR_ENA                       DISEQC_DSCU_INTR_ENA
#define TO_INT_ENA_MASK                     DISEQC_DSCU_INTR_ENA_to_interrupt_ena_mask
#define TO_INT_ENA                          DISEQC_DSCU_INTR_ENA_to_interrupt_ena(1)
#define TX_MSG_DONE_ENA_MASK                DISEQC_DSCU_INTR_ENA_tx_msg_done_ena_mask
#define TX_MSG_DONE_ENA                     DISEQC_DSCU_INTR_ENA_tx_msg_done_ena(1)
#define TX_DONE_ENA_MASK                    DISEQC_DSCU_INTR_ENA_tx_done_ena_mask
#define TX_DONE_ENA                         DISEQC_DSCU_INTR_ENA_tx_done_ena(1)
#define RX_FULL_ENA_MASK                    DISEQC_DSCU_INTR_ENA_rx_full_ena_mask
#define RX_FULL_ENA                         DISEQC_DSCU_INTR_ENA_rx_full_ena(1)
#define EORM_ENA_MASK                       DISEQC_DSCU_INTR_ENA_eorm_ena_mask
#define EORM_ENA                            DISEQC_DSCU_INTR_ENA_eorm_ena(1)
#define INCOMING_ENA_MASK                   DISEQC_DSCU_INTR_ENA_incoming_ena_mask
#define INCOMING_ENA                        DISEQC_DSCU_INTR_ENA_incoming_ena(1)

//Register:DSCU_INTR
#define DSCU_INTR                           DISEQC_DSCU_INTR
#define TO_INTR_INT_MASK                    DISEQC_DSCU_INTR_to_interrupt_int_mask
#define TO_INTR_INT_GET(x)                  DISEQC_DSCU_INTR_get_to_interrupt_int(x)
#define TX_MSG_DONE_INT_MASK                DISEQC_DSCU_INTR_tx_msg_done_int_mask
#define TX_MSG_DONE_INT_GET(x)              DISEQC_DSCU_INTR_get_tx_msg_done_int(x)
#define TX_DONE_INT_MASK                    DISEQC_DSCU_INTR_tx_done_int_mask
#define TX_DONE_INT_GET(x)                  DISEQC_DSCU_INTR_get_tx_done_int(x)
#define RX_FULL_INT_MASK                    DISEQC_DSCU_INTR_rx_full_int_mask
#define RX_FULL_INT_GET(x)                  DISEQC_DSCU_INTR_get_rx_full_int(x)
#define RX_EORM_INT_MASK                    DISEQC_DSCU_INTR_eorm_int_mask
#define RX_EORM_INT_GET(x)                  DISEQC_DSCU_INTR_get_eorm_int(x)
#define RX_INCOMING_INT_MASK                DISEQC_DSCU_INTR_incoming_int
#define RX_INCOMING_INT_GET(x)              DISEQC_DSCU_INTR_get_incoming_int(x)
#define	INTR_CLEAN_ALL						DISEQC_DSCU_INTR_CLEAN_ALL

//Register:DSCU_RX_STATUS
#define DSCU_RX_STATUS                      DISEQC_DSCU_RX_STATUS
#define RX_TO_INTERRUPT_MASK                DISEQC_DSCU_RX_STATUS_to_interrupt_mask
#define RX_TO_INTERRUPT_GET(x)              DISEQC_DSCU_RX_STATUS_get_to_interrupt(x)
#define RX_COUNT_MASK                       DISEQC_DSCU_RX_STATUS_rx_count_mask
#define RX_COUNT_GET(x)                     DISEQC_DSCU_RX_STATUS_get_rx_count(x)
#define RX_FULL_MASK                        DISEQC_DSCU_RX_STATUS_rx_full_mask
#define RX_FULL_GET(x)                      DISEQC_DSCU_RX_STATUS_get_rx_full(x)
#define RX_EROM_MASK                        DISEQC_DSCU_RX_STATUS_eorm_mask
#define RX_EROM_GET(x)                      DISEQC_DSCU_RX_STATUS_get_eorm(x)
#define RX_INCOMING_MASK                    DISEQC_DSCU_RX_STATUS_incoming_mask
#define RX_INCOMING_GET(x)                  DISEQC_DSCU_RX_STATUS_get_incoming(x)

//Register:DSCU_TX_STATUS
#define DSCU_TX_STATUS                      DISEQC_DSCU_TX_STATUS
#define TX_COUNT_MASK                       DISEQC_DSCU_TX_STATUS_tx_count_mask
#define TX_COUNT_GET(x)                     DISEQC_DSCU_TX_STATUS_get_tx_count(x)
#define TX_MSG_DONE_MASK                    DISEQC_DSCU_TX_STATUS_tx_msg_done_mask
#define TX_MSG_DONE_GET(x)                  DISEQC_DSCU_TX_STATUS_get_tx_msg_done(x)
#define TX_DONE_MASK                        DISEQC_DSCU_TX_STATUS_tx_done_mask
#define TX_DONE_GET(x)                      DISEQC_DSCU_TX_STATUS_get_tx_done(x)
#define TX_BUSY_MASK                        DISEQC_DSCU_TX_STATUS_tx_busy_mask
#define TX_BUSY_GET(x)                      DISEQC_DSCU_TX_STATUS_get_tx_busy(x)

//Register:DSCU_TX_BUF
#define TX_BUF0                             DISEQC_DSCU_TX_BUF0
#define TX_BUF0_MASK                        DISEQC_DSCU_TX_BUF0_dscu_tx_buf_0_mask
#define TX_BUF0_SET(x)                      DISEQC_DSCU_TX_BUF0_dscu_tx_buf_0(x)
#define TX_BUF0_GET(x)                      DISEQC_DSCU_TX_BUF0_get_dscu_tx_buf_0(x)
#define TX_BUF1                             DISEQC_DSCU_TX_BUF1
#define TX_BUF1_MASK                        DISEQC_DSCU_TX_BUF1_dscu_tx_buf_1_mask
#define TX_BUF1_SET(x)                      DISEQC_DSCU_TX_BUF1_dscu_tx_buf_1(x)
#define TX_BUF1_GET(x)                      DISEQC_DSCU_TX_BUF1_get_dscu_tx_buf_1(x)
#define TX_BUF2                             DISEQC_DSCU_TX_BUF2
#define TX_BUF2_MASK                        DISEQC_DSCU_TX_BUF2_dscu_tx_buf_2_mask
#define TX_BUF2_SET(x)                      DISEQC_DSCU_TX_BUF2_dscu_tx_buf_2(x)
#define TX_BUF2_GET(x)                      DISEQC_DSCU_TX_BUF2_get_dscu_tx_buf_2(x)
#define TX_BUF3                             DISEQC_DSCU_TX_BUF3
#define TX_BUF3_MASK                        DISEQC_DSCU_TX_BUF3_dscu_tx_buf_3_mask
#define TX_BUF3_SET(x)                      DISEQC_DSCU_TX_BUF3_dscu_tx_buf_3(x)
#define TX_BUF3_GET(x)                      DISEQC_DSCU_TX_BUF3_get_dscu_tx_buf_3(x)
#define TX_BUF4                             DISEQC_DSCU_TX_BUF4
#define TX_BUF4_MASK                        DISEQC_DSCU_TX_BUF4_dscu_tx_buf_4_mask
#define TX_BUF4_SET(x)                      DISEQC_DSCU_TX_BUF4_dscu_tx_buf_4(x)
#define TX_BUF4_GET(x)                      DISEQC_DSCU_TX_BUF4_get_dscu_tx_buf_4(x)
#define TX_BUF5                             DISEQC_DSCU_TX_BUF5
#define TX_BUF5_MASK                        DISEQC_DSCU_TX_BUF5_dscu_tx_buf_5_mask
#define TX_BUF5_SET(x)                      DISEQC_DSCU_TX_BUF5_dscu_tx_buf_5(x)
#define TX_BUF5_GET(x)                      DISEQC_DSCU_TX_BUF5_get_dscu_tx_buf_5(x)
#define TX_BUF6                             DISEQC_DSCU_TX_BUF6
#define TX_BUF6_MASK                        DISEQC_DSCU_TX_BUF6_dscu_tx_buf_6_mask
#define TX_BUF6_SET(x)                      DISEQC_DSCU_TX_BUF6_dscu_tx_buf_6(x)
#define TX_BUF6_GET(x)                      DISEQC_DSCU_TX_BUF6_get_dscu_tx_buf_6(x)
#define TX_BUF7                             DISEQC_DSCU_TX_BUF7
#define TX_BUF7_MASK                        DISEQC_DSCU_TX_BUF7_dscu_tx_buf_7_mask
#define TX_BUF7_SET(x)                      DISEQC_DSCU_TX_BUF7_dscu_tx_buf_7(x)
#define TX_BUF7_GET(x)                      DISEQC_DSCU_TX_BUF7_get_dscu_tx_buf_7(x)

//Register:DSCU_RX_BUF
#define RX_BUF0                             DISEQC_DSCU_RX_BUF0
#define RX_BUF0_MASK                        DISEQC_DSCU_RX_BUF0_byte0_mask
#define RX_BUF0_GET(x)                      DISEQC_DSCU_RX_BUF0_get_byte0(x)
#define RX_BUF1                             DISEQC_DSCU_RX_BUF1
#define RX_BUF1_MASK                        DISEQC_DSCU_RX_BUF1_byte1_mask
#define RX_BUF1_GET(x)                      DISEQC_DSCU_RX_BUF1_get_byte1(x)
#define RX_BUF2                             DISEQC_DSCU_RX_BUF2
#define RX_BUF2_MASK                        DISEQC_DSCU_RX_BUF2_byte2_mask
#define RX_BUF2_GET(x)                      DISEQC_DSCU_RX_BUF2_get_byte2(x)
#define RX_BUF3                             DISEQC_DSCU_RX_BUF3
#define RX_BUF3_MASK                        DISEQC_DSCU_RX_BUF3_byte3_mask
#define RX_BUF3_GET(x)                      DISEQC_DSCU_RX_BUF3_get_byte3(x)
#define RX_BUF4                             DISEQC_DSCU_RX_BUF4
#define RX_BUF4_MASK                        DISEQC_DSCU_RX_BUF4_byte4_mask
#define RX_BUF4_GET(x)                      DISEQC_DSCU_RX_BUF4_get_byte4(x)
#define RX_BUF5                             DISEQC_DSCU_RX_BUF5
#define RX_BUF5_MASK                        DISEQC_DSCU_RX_BUF5_byte5_mask
#define RX_BUF5_GET(x)                      DISEQC_DSCU_RX_BUF5_get_byte5(x)
#define RX_BUF6                             DISEQC_DSCU_RX_BUF6
#define RX_BUF6_MASK                        DISEQC_DSCU_RX_BUF6_byte6_mask
#define RX_BUF6_GET(x)                      DISEQC_DSCU_RX_BUF6_get_byte6(x)
#define RX_BUF7                             DISEQC_DSCU_RX_BUF7
#define RX_BUF7_MASK                        DISEQC_DSCU_RX_BUF7_byte7_mask
#define RX_BUF7_GET(x)                      DISEQC_DSCU_RX_BUF7_get_byte7(x)

//Register:DSCU_INIT_EXP_WIN
#define DSCU_INIT_EXP_WIN                   DISEQC_DSCU_INIT_EXP_WIN
#define INITIAL_EXPECT_WIN_MASK             DISEQC_DSCU_INIT_EXP_WIN_initial_expected_window_mask
#define INITIAL_EXPECT_WIN(x)               DISEQC_DSCU_INIT_EXP_WIN_initial_expected_window(x)

//Register:DSCU_PM_SEL
#define DSCU_PM_SEL                         DISEQC_DSCU_PM_SEL
#define DSC_PM_SEL_MASK                     DISEQC_DSCU_PM_SEL_dsc_pm_sel_mask
#define DSC_PM_SEL(x)                       DISEQC_DSCU_PM_SEL_dsc_pm_sel(x)

#define SUCCESS 0
#define FAIL	-1

#define write_reg32(addr, val)      rtd_outl(addr, val)
#define read_reg32(addr)            rtd_inl(addr)

enum {
    MODULATED_TONE_BURST = 0,
    UN_MODULATED_TONE_BURST = 1,
    DISEQC_MESSAGE = 2,
    CONTINUOUS_TONE = 3
};      
        
enum {
    TX_STOP = 0,
    TX_START = 1
};
#endif /* _pwm_h_ */
