#include <qc_verify_common.h>
#include <rbusCRTReg.h>

#include <asm/arch/system.h>
#include <asm/arch/fw_info.h>
#include "sys_reg_reg.h"
/*
#ifdef MIPS_AUDIO_GDB_VECTOR_A1_ADDR
#ifdef CONFIG_ACPU2_SUPPORT
#define ACPU_NR2
#endif
#endif
*/
#define ACPU_A1   0
#define ACPU_A2   1
#if defined(Config_Embedded_Audio_FW_TRUE)
#define ACPU_FW_QC_RESULT_SADDR 	(0x05000000)
#define ACPU_FW_QC_RESULT_DEFAULT	(0x2452544b)
#define ACPU_FW_QC_RESULT_SUCCESS	(0x444F4E45)
#define ACPU_FW_QC_TIMEOUT_MS		(10000)
#endif //defined(Config_Embedded_Audio_FW_TRUE)

#define ACPU_QC_ENTRY_CODE_ADDR		(0x01700000)
#define ACPU_QC1_ENTRY_CODE_ADDR    (0x1a500000)
#define ACPU_QC_RESULT_SADDR		(0x01780000)
#define ACPU_QC_RESULT_DEFAULT		(0x00000000)
#define ACPU_QC_RESULT_SUCCESS		(0x00cafe00)
#define ACPU_QC_RESULT_FAILED		(0xca0000fe)
#define ACPU_QC_PATTERN_SADDR		(0x01800000)
#define ACPU_QC_PATTERN_BYTES		(0x00080000)
#define ACPU_QC_PATTERN_MAGIC		(0xa5a5aa55)
#define ACPU_QC_TIMEOUT_MS			(3000)

#define ACPU_JUMP_ADDR_reg			(0xb806012c)
#define REG_HW_SEMAPHORE			(0xb801a000)
#define ACPU_DONE_REG                       (0x18006070)
#define ACPU_DONE_FLAG                     (0x23792379)
#define ACPU_MAX_WAIT_CNT              (50)
#if 0
extern int _f_a_entry_qc_img, _e_a_entry_qc_img;
extern int _f_a_entry_qc1_img, _e_a_entry_qc1_img;
extern void enable_audio2_clock(void);
extern void disable_acpu_clock(void);


/*********************************************
 *
 *********************************************/
static void ACPU_QC_prepare_pattern(void)
{
	unsigned int *ptr_pattern = (unsigned int *)ACPU_QC_PATTERN_SADDR;
	unsigned int *ptr_result = (unsigned int *)ACPU_QC_RESULT_SADDR;
	unsigned int i = 0;

	printf("Write Pattern at 0x%x (0->0x%x)\n", ACPU_QC_PATTERN_SADDR, ACPU_QC_PATTERN_BYTES);

	for (i = 0;i < ACPU_QC_PATTERN_BYTES;i++)
	{
		*ptr_pattern = SWAPEND32(i);
		ptr_pattern++;
	}

	*ptr_result = SWAPEND32(ACPU_QC_RESULT_DEFAULT);
}

/*********************************************
 *
 *********************************************/
static unsigned int ACPU_QC_verify_pattern(void)
{
	unsigned int *ptr_pattern = (unsigned int *)ACPU_QC_PATTERN_SADDR;
	unsigned int i = 0;
	unsigned int magic_pattern;

	printf("Verify Pattern at 0x%x (0->0x%x)\n", ACPU_QC_PATTERN_SADDR, ACPU_QC_PATTERN_BYTES);

	magic_pattern = SWAPEND32(ACPU_QC_PATTERN_MAGIC);

	flush_dcache_all();

	for (i = 0;i < ACPU_QC_PATTERN_BYTES;i++)
	{
		if (*ptr_pattern != magic_pattern)
		{
			printf("Verify FAILED at [%d]: 0x%x != 0x%x\n", i, *ptr_pattern, magic_pattern);
			return 1;
		}

		if (i % 0x800 == 0)
			printf(".");

		ptr_pattern++;
	}

	printf("done\n");

	return 0;
}

/*********************************************
 *
 *********************************************/
static void ACPU_QC_prepare_a_entry_qc(void)
{
	unsigned char *a,*b;

	a = (unsigned char *)&_e_a_entry_qc_img;
	b = (unsigned char *)&_f_a_entry_qc_img;

	memcpy((unsigned char *)ACPU_QC_ENTRY_CODE_ADDR, b, a-b);

       rtd_outl(ACPU_JUMP_ADDR_reg, ACPU_QC_ENTRY_CODE_ADDR | MIPS_KSEG0BASE);
}

static void ACPU_QC_prepare_a_entry_qc1(void)
{
	unsigned char *a,*b;

	a = (unsigned char *)&_e_a_entry_qc1_img;
	b = (unsigned char *)&_f_a_entry_qc1_img;
       printf("a %x , b %x\n",(unsigned int)*a,(unsigned int)*b);
	memcpy((unsigned char *)ACPU_QC1_ENTRY_CODE_ADDR, b, a-b);

       rtd_outl(ACPU_JUMP_ADDR_reg, ACPU_QC1_ENTRY_CODE_ADDR | MIPS_KSEG0BASE);
}
/*********************************************
 *
 *********************************************/
static void ACPU_QC_enable_clock(u8 u8APU_NR)
{


	//hold hw semaphore
	rtd_outl(REG_HW_SEMAPHORE, 0x1);
#ifndef ACPU_NR2
#if 0
	// rst = 0
	rtd_clearbits(CRT_SYS_SRST0_reg, _BIT12);

	// clk = 1
	rtd_setbits(CRT_SYS_CLKEN0_reg, _BIT12);

	// clk = 0
	rtd_clearbits(CRT_SYS_CLKEN0_reg, _BIT12);

	// rst = 0
	rtd_clearbits(CRT_SYS_SRST0_reg, _BIT12);
	udelay(10);

	// rst = 1
	rtd_setbits(CRT_SYS_SRST0_reg, _BIT12);
	udelay(10);

	// clk = 1
	rtd_setbits(CRT_SYS_CLKEN0_reg, _BIT12);
#else
                enable_audio_clock();
#endif
#else
       if(ACPU_A1)
                enable_audio_clock();
       else
                enable_audio2_clock();
#endif
	//release hw semaphore
	rtd_outl(REG_HW_SEMAPHORE, 0x0);
}

/*********************************************
 *
 *********************************************/
static void ACPU_QC_disable_clock(void)
{
#ifndef ACPU_NR2

        disable_acpu_clock();
#if 0
	// clk = 0
	rtd_clearbits(CRT_SYS_CLKEN0_reg, _BIT12);

	// rst = 0
	rtd_clearbits(CRT_SYS_SRST0_reg, _BIT12);
#endif
#else
        disable_acpu_clock();
#endif
}

/*********************************************
 *
 *********************************************/
static void ACPU_QC_wait_result(int *ret)
{
	unsigned int timeout_cnt = ACPU_QC_TIMEOUT_MS;
	unsigned int result_acpu = 0;

	while(timeout_cnt) {

		flush_dcache_all();

		result_acpu = SWAPEND32(*(unsigned int *)ACPU_QC_RESULT_SADDR);

		if (result_acpu != ACPU_QC_RESULT_DEFAULT)
		{
			printf("Adone\n");
			break;
		}

		timeout_cnt--;
		mdelay(1);
	}

	switch(result_acpu){
		case ACPU_QC_RESULT_SUCCESS:
			*ret = ACPU_QC_verify_pattern();
			break;

		case ACPU_QC_RESULT_FAILED:
			printf("ACPU test failed.\n");
			*ret = 1;
			break;

		case ACPU_QC_RESULT_DEFAULT:
			printf("ACPU test timeout.(timeout:%d ms)\n", ACPU_QC_TIMEOUT_MS);
			*ret = 1;
			break;

		default:
			printf("ACPU test unknown result.(result:0x%x)\n", result_acpu);
			*ret = 1;
			break;
	}
}

/*********************************************
 *
 *********************************************/
static int ACPU_QC_run(int *ret)
{
	unsigned int done_flag = 0;
	int wait_cnt = 0;
#if 0
	// init test pattern
	ACPU_QC_prepare_pattern();
  
	// copy a_entry_qc
	ACPU_QC_prepare_a_entry_qc();

	// flush cache before enable ACPU
	flush_dcache_all();

	// enable clock
	ACPU_QC_enable_clock(ACPU_A1);
      
	//  wait result
	ACPU_QC_wait_result(ret);

	// disable clock
	ACPU_QC_disable_clock();
#endif
#ifdef ACPU_NR2
      printf("=================ACPU2 Verify ===============\n");
	// init test pattern
	ACPU_QC_prepare_pattern();
  
	// copy a_entry_qc
	ACPU_QC_prepare_a_entry_qc();

	// flush cache before enable ACPU
	flush_dcache_all();

	// enable clock
	ACPU_QC_enable_clock(ACPU_A2);
	//  wait result
	ACPU_QC_wait_result(ret);
    
	// disable clock
	ACPU_QC_disable_clock();

#endif
    printf("load audio fw \n");
    // verify audio pattern
    ACPU_QC_prepare_a_entry_qc1();
	// flush cache before enable ACPU
	flush_dcache_all();

	// enable clock
	ACPU_QC_enable_clock(ACPU_A1);
	while(1)
	{
		done_flag = rtd_inl(ACPU_DONE_REG);
		if(done_flag == ACPU_DONE_FLAG)
		{
			*ret = 0;
			 break;
		}
		mdelay(100);
		wait_cnt++;
		if(wait_cnt > ACPU_MAX_WAIT_CNT)
		{
			*ret = 1;
			break;
		}
	}
	// disable clock
	ACPU_QC_disable_clock();  
return 0;
}
#else

#define  MD_MD_REG_MODE_AC                                                      0x1800B280
#define  MD_MD_REG_CMD3_AC                                                      0x1800B290
#define  MD_MD_REG_CMD4_AC                                                      0x1800B294
#define  MD_MD_BBS_key                                                          0x1800B2A0
#define  MD_MD_BBS_result_byte                                                  0x1800B2A4
#define  MD_MD_BBS_result_bit                                                   0x1800B2A8
typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  bbs_en:1;
        RBus_UInt32  res1:3;
        RBus_UInt32  bbs_bits:2;
        RBus_UInt32  bbs_match:1;
        RBus_UInt32  cmd_err:1;
        RBus_UInt32  res2:24;
    };
}md_md_reg_mode_ac_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  saddr:32;
    };
}md_md_reg_cmd3_ac_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  length_seq:32;
    };
}md_md_reg_cmd4_ac_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  value:32;
    };
}md_md_bbs_key_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  addr:32;
    };
}md_md_bbs_result_byte_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  addr:3;
        RBus_UInt32  res1:29;
    };
}md_md_bbs_result_bit_RBUS;

int Test_MDBBS_enable(int addr_phy, int length, int search_bits, int pattern)
{
	md_md_reg_cmd3_ac_RBUS bbs_cmd3;
	md_md_reg_cmd4_ac_RBUS bbs_cmd4;
	md_md_bbs_key_RBUS bbs_key;
	md_md_reg_mode_ac_RBUS bbs_mode;

	bbs_mode.regValue = rtd_inl(MD_MD_REG_MODE_AC);
	bbs_cmd3.regValue = rtd_inl(MD_MD_REG_CMD3_AC);
	bbs_cmd4.regValue = rtd_inl(MD_MD_REG_CMD4_AC);
	bbs_key.regValue = rtd_inl(MD_MD_BBS_key);

	bbs_cmd3.saddr      = addr_phy;
	bbs_cmd4.length_seq = length;
	bbs_key.value       = pattern;
	if (search_bits == 32) {
		bbs_mode.bbs_bits = 3;
	} else if (search_bits == 16) {
		bbs_mode.bbs_bits = 1;
	} else if (search_bits == 24) {
		bbs_mode.bbs_bits = 2;
	} else if (search_bits == 8) {
		bbs_mode.bbs_bits = 0;
	} else {
		return 1;
	}

	rtd_outl(MD_MD_REG_MODE_AC, bbs_mode.regValue);
	rtd_outl(MD_MD_REG_CMD3_AC, bbs_cmd3.regValue);
	rtd_outl(MD_MD_REG_CMD4_AC, bbs_cmd4.regValue);
	rtd_outl(MD_MD_BBS_key, bbs_key.regValue);

	bbs_mode.bbs_en = 1;
	rtd_outl(MD_MD_REG_MODE_AC, bbs_mode.regValue);

	return 0;
}

int array_golden[16] = {
	0x11223344, 0xF8724E1F, 0x11223344, 0x11228888,
	0x11223344, 0x11223344, 0x11220B77, 0x11223344,
	0x11223344, 0x11223344, 0x11223344, 0x11223344,
	0x11223344, 0x11223344, 0x11223344, 0x30303344,
};
#define MDBBS_TEST_DST_ADDR (0x01500000+0x100000)

int Test_MDBBS(void)
{
	int array_test_phy;
	array_test_phy = (int)array_golden;

	md_md_reg_mode_ac_RBUS bbs_mode;
	md_md_bbs_result_byte_RBUS bbs_result_byte;
	md_md_bbs_result_bit_RBUS bbs_result_bit;

	sys_reg_sys_srst4_RBUS SRST4;
	SRST4.regValue    = 0;
	SRST4.rstn_md_bbs = 1;
	SRST4.write_data  = 1;
	rtd_outl(SYS_REG_SYS_SRST4_reg, SRST4.regValue);
	sys_reg_sys_clken4_RBUS CLKEN4;
	CLKEN4.regValue     = 0;
	CLKEN4.clken_md_bbs = 1;
	CLKEN4.write_data   = 1;
	rtd_outl(SYS_REG_SYS_CLKEN4_reg, CLKEN4.regValue);


	Test_MDBBS_enable(array_test_phy, 16*sizeof(int), 32, 0xF8724E1F);
	while (1) {
		udelay(10);
		bbs_mode.regValue = rtd_inl(MD_MD_REG_MODE_AC);
		if(bbs_mode.bbs_en == 0) {
			break;
		}
	}
	bbs_mode.regValue        = rtd_inl(MD_MD_REG_MODE_AC);
	bbs_result_byte.regValue = rtd_inl(MD_MD_BBS_result_byte);
	bbs_result_bit.regValue  = rtd_inl(MD_MD_BBS_result_bit);
	/*printf("[BBS] 32bit, pattern F8724E1F, match %d byte %x, bit %x\n",bbs_mode.bbs_match, bbs_result_byte.addr, bbs_result_bit.addr);*/
	if (!(bbs_mode.bbs_match && bbs_result_byte.addr == (unsigned int)(array_test_phy+4))) {
		printf("[BBS][ERROR] 32bit, pattern F8724E1F, match %d byte %x, bit %x\n",bbs_mode.bbs_match, bbs_result_byte.addr, bbs_result_bit.addr);
		printf("%x: %x\n",array_test_phy+4,array_golden[1]);
		return 1;
	} else {
		/*printf("[BBS][PASS] 32bit, pattern F8724E1F\n");*/
	}

	Test_MDBBS_enable(array_test_phy, 16*sizeof(int), 16, 0x0B77);
	while (1) {
		udelay(10);
		bbs_mode.regValue = rtd_inl(MD_MD_REG_MODE_AC);
		if(bbs_mode.bbs_en == 0) {
			break;
		}
	}
	bbs_mode.regValue        = rtd_inl(MD_MD_REG_MODE_AC);
	bbs_result_byte.regValue = rtd_inl(MD_MD_BBS_result_byte);
	bbs_result_bit.regValue  = rtd_inl(MD_MD_BBS_result_bit);
	/*printf("[BBS] 16bit, pattern 0B77, match %d byte %x, bit %x\n",bbs_mode.bbs_match, bbs_result_byte.addr, bbs_result_bit.addr);*/
	if (!(bbs_mode.bbs_match && bbs_result_byte.addr == (unsigned int)(array_test_phy+24))) {
		printf("[BBS][ERROR] 16bit, pattern 0B77, match %d byte %x, bit %x\n",bbs_mode.bbs_match, bbs_result_byte.addr, bbs_result_bit.addr);
		printf("%x: %x\n",array_test_phy+4,array_golden[6]);
		return 1;
	} else {
		/*printf("[BBS][PASS] 16bit, pattern 0B77\n");*/
	}

	Test_MDBBS_enable(array_test_phy, 16*sizeof(int), 16, 0x5566);
	while (1) {
		udelay(10);
		bbs_mode.regValue = rtd_inl(MD_MD_REG_MODE_AC);
		if(bbs_mode.bbs_en == 0) {
			break;
		}
	}
	bbs_mode.regValue        = rtd_inl(MD_MD_REG_MODE_AC);
	bbs_result_byte.regValue = rtd_inl(MD_MD_BBS_result_byte);
	bbs_result_bit.regValue  = rtd_inl(MD_MD_BBS_result_bit);
	/*printf("[BBS] 16bit, pattern 5566, match %d byte %x, bit %x\n",bbs_mode.bbs_match, bbs_result_byte.addr, bbs_result_bit.addr);*/
	if (bbs_mode.bbs_match) {
		printf("[BBS][ERROR] 16bit, pattern 5566, match %d byte %x, bit %x\n",bbs_mode.bbs_match, bbs_result_byte.addr, bbs_result_bit.addr);
		return 1;
	} else {
		/*printf("[BBS][PASS] non-exist pattern\n");*/
	}
	return 0;
}
#endif


/*********************************************
 *
 *********************************************/
int QC_Verifier_ACPU(void)
{
	int ret = 0;
	int loop = 0;

	debug("%s\n", __FUNCTION__);

#if 0
	ACPU_QC_run(&ret);
#else
	for(loop = 0; loop < 5; loop++) {
		ret = Test_MDBBS();
		if (ret != 0)
			break;
	}
#endif

	if (ret == 0)
	{
		printf("QC_ACPU verify success.\n");
		return SUCCESS;
	}
	else
	{
		printf("QC_ACPU verify FAILED!!!!!\n");
		return FAILED;
	}
}
