
#include <command.h>
#include <common.h>
#include <asm/arch/mcp.h>
#include <asm/arch/factorylib_ro.h>
#include <asm/arch/system.h>
#include <qc_verify_common.h>
#include <malloc.h>
#if defined(CONFIG_SYS_RTK_NAND_FLASH)
 #include <linux/mtd/nand.h>
 #include <nand.h>
#endif

/* Definitions */

// Needed only for the size_t and WORDSIZE type definition below
#include <stddef.h>
//#include <stdlib.h>
#if defined(CONFIG_RTD287X_QC) || defined(CONFIG_RTD287XP_QC) || defined(CONFIG_RTD287X_23x23_QC)
#if CONFIG_QC_MULTI_CORE_TEST
#define CONFIG_RTD287X_QC_NON_DCACHE
#endif
#endif

//#define OUTFB_SIZE  (1024*1024)
#define LOOP_CNT     1

int outfb_size_to_verify = 0;
void *pattern_ptr=0;
void *pattern_golden_ptr=0;

#define EMMC_QC_EXTERND_DATA_1_ADDR               0x01300000 // offset 18MB outlite_21_oc.bin
#define EMMC_QC_EXTERND_DATA_2_ADDR				  0x02300000 // offset 22 MB outfb_21.bin
#define EMMC_QC_EXTERND_DATA_1_BLK_ADDR           (EMMC_QC_EXTERND_DATA_1_ADDR>>9) //
#define EMMC_QC_EXTERND_DATA_2_BLK_ADDR           (EMMC_QC_EXTERND_DATA_2_ADDR>>9) //
#define EMMC_TMP_BUFFER                         0x15000000 //0x1500000
#define EMMC_BLOCK_SIZE             (512UL)
#define NAND_QC_GCPU1_BLK_ADDR			80	
#define NAND_QC_GCPU2_BLK_ADDR			208
#define BLOCK_QC_GPU1				0x90
#define BLOCK_QC_GPU2				0x91
#define NAND_TMP_BUFFER				0x15000000

#define ROUND_UP(x,y) (((x)+(y)-1)&~((y)-1))
#define GPU_PATTERN_ADDR          0x15100000 //0x5000000
#define GPU_PATTERN_GOLDEN_ADDR   0x15b00000 //0x6000000
#define GPU_PATTERN_OUT_ADDR      0x16400000 //0x7000000
//extern unsigned char outlite_11[] ;
//extern unsigned char outlite_5[] ;
//extern unsigned char outlite_12_oc[] ;
//extern unsigned char outfb_12[];
//extern int outfb_12_size;

#define IMG_TRUE                        (1)
#define IMG_FALSE                       (0)
#define IMG_NULL                        NULL
#define IMG_BOOL                        int
#define IMG_UINT32                      unsigned int
#define IMG_INT32                       signed int
#define IMG_UINT64                      unsigned long long
#define IMG_INT64                       long long
#define IMG_PUINT32                     IMG_UINT32 *
#define IMG_PUINT64                     IMG_UINT64 *
#define IMG_UINT8                       unsigned char
#define IMG_PUINT8                      IMG_UINT8 *
#define IMG_VOID                        void
#define IMG_PVOID                       IMG_VOID *
#ifdef WIN32							
#define IMG_I64PR "I64"							// This defines the string which printf requires to print a 64bit value.
#else
#define IMG_I64PR "ll"
#endif

/* Most/Least significant 32 bit from 64 bit double word */
#define HI32(data64)		  ((unsigned int)(data64 >> 32))
#define LO32(data64)		  ((unsigned int)(data64 & 0xFFFFFFFF))


#define SYS_REG_BASE			(0x18000000)

#if defined(CONFIG_RTD287X_QC) || defined(CONFIG_RTD287XP_QC) || defined(CONFIG_RTD287X_23x23_QC)
#define REG_GPU_BASE           (0x18100000)
#else
#define REG_GPU_BASE           (0x18040000)
#endif

// This is an integer which is the same size as a
// pointer and may need to be changed
#define IMG_UINTPTR                   size_t

#define PDL_SIGNATURE1                  (0x504D4450)
#define PDL_SIGNATURE2                  (0x504F5453)
#define PDL_SIGNATURE_MASK              (0xF0FFFFFF)
#define PDL_SIGNATURE_COMPSCRIPT_HSTART	(0x41545348)
#define PDL_SIGNATURE_COMPSCRIPT_HEND	(0x444E4548)

#define	PDL_CHECK_FUNC_EQ               (0)
#define	PDL_CHECK_FUNC_LT               (1)
#define	PDL_CHECK_FUNC_LE               (2)
#define	PDL_CHECK_FUNC_GT               (3)
#define	PDL_CHECK_FUNC_GE               (4)
#define	PDL_CHECK_FUNC_NE               (5)

#define PDL_POLLCOUNT_INFINITE          (0xFFFFFFFF)

#if defined(CONFIG_RTD287X_QC) || defined(CONFIG_RTD287XP_QC) || defined(CONFIG_RTD287X_23x23_QC)
#define NUMBER_OF_INTERNAL_REGS         (64)
#else
#define NUMBER_OF_INTERNAL_REGS         (10)
#endif
#define PDL_SCRIPT_NO					psScriptCB->pui32Script[1]

/* Abstraction macros */
IMG_BOOL g_ret=IMG_TRUE;
int BIF_count = 0;
#if !defined(EMU_TARGET)
/*
The functions and operations below should be checked for correct
behaviour on the target system, and alternative implementations
coded as appropriate.
*/

#define PDL_INIT() \
    PDL_DefaultInit()

#define PDL_ASSERT(_pScript) \
    PDL_DefaultAssert(_pScript)

#define PDL_SUCCESS() \
    PDL_DefaultSuccessExit()

#define PDL_FAIL() \
    PDL_DefaultFailExit()
#if  defined(CONFIG_RTD287X_QC) || defined(CONFIG_RTD287XP_QC) || defined(CONFIG_RTD287X_23x23_QC)
#define WriteReg(_addr, _data) \
{   rtd_outl(_addr,_data); }
//{  *(volatile IMG_PUINT32)(_addr) = _data; }

#define ReadReg(_addr, _to) \
{  *(IMG_PUINT32)_to = rtd_inl(_addr);}
//{  *(IMG_PUINT32)_to = (*(volatile IMG_PUINT32)(_addr)); }

#define SysWriteReg(_addr, _data) \
{   rtd_outl(_addr,_data); }
//{  *(volatile IMG_PUINT32)(_addr) = _data;  }

#define SysReadReg(_addr, _to) \
{  *(IMG_PUINT32)_to = rtd_inl(_addr);}
//{  *(IMG_PUINT32)_to = (*(volatile IMG_PUINT32)(_addr));  }


#define WriteMem(_addr, _data) \
{    *(volatile IMG_PUINT32)(IMG_UINTPTR)(_addr) = _data; }

#define ReadMem(_addr, _dataptr) \
{    *(volatile IMG_PUINT32)(IMG_UINTPTR)(_dataptr) = *(volatile IMG_PUINT32)(IMG_UINTPTR)(_addr); }

#define ReadMemByte(_addr, _dataptr) \
{  *(volatile IMG_PUINT8)(IMG_UINTPTR)(_dataptr) = *(volatile IMG_PUINT8)(IMG_UINTPTR)(_addr); }

#define ReadMemLog(_addr, _dataptr) \
{ *(volatile IMG_PUINT32)(IMG_UINTPTR)(_dataptr) = *(volatile IMG_PUINT32)(IMG_UINTPTR)(_addr); }


#define WriteReg64(_addr, _data) \
{ IMG_UINT32 ui32ValueLow, ui32ValueHigh;ui32ValueLow = _data & 0xffffffff; ui32ValueHigh = ((IMG_UINT64) (_data >> 32)) & 0xffffffff;rtd_outl(((IMG_PUINT32)(_addr)),ui32ValueLow);rtd_outl(((IMG_PUINT32)(_addr)+1),ui32ValueHigh);}
//{ printf("w & r reg64_low=%x reg64_high=%x\n",rtd_inl((IMG_PUINT32)(_addr)),rtd_inl((IMG_PUINT32)(_addr)+1));}

#define ReadReg64(_addr, _to) \
{ IMG_UINT32 ui32ValueLow, ui32ValueHigh; ui32ValueLow = rtd_inl((IMG_PUINT32)(_addr)); ui32ValueHigh = rtd_inl((IMG_PUINT32)(_addr+1)); *(IMG_PUINT64)_to = (ui32ValueHigh<<32) | ui32ValueLow;}
//{ printf("r reg64_addr=%llx\n",_addr); *(volatile IMG_UINT64)to = (((rtd_inl((IMG_PUINT32)(_addr+1)) << 32)) | (rtd_inl((IMG_PUINT32)(_addr))));} \
//{ printf("r reg64_addr=%llx\n",_addr);*(IMG_PUINT64)_to = (*(volatile IMG_PUINT64)(IMG_UINTPTR)(_addr)); printf("r done reg64=%x\n",_addr);}


#define WriteMem64(_addr, _data)\
    { *(volatile IMG_PUINT64)(IMG_UINTPTR)(_addr) = _data; }
//{  printf("w Mem64=%x\n",_addr);IMG_UINT32 ui32ValueLow, ui32ValueHigh;ui32ValueLow = _data & 0xffffffff; ui32ValueHigh = ((IMG_UINT64) (_data >> 32)) & 0xffffffff;*(volatile IMG_PUINT32)(IMG_UINTPTR)(_addr) = ui32ValueLow;*(volatile IMG_PUINT32)((IMG_PUINT32)(_addr)+1) = ui32ValueHigh;}0

#define ReadMem64(_addr, _dataptr) \
    { *(volatile IMG_PUINT64)(IMG_UINTPTR)(_dataptr) = *(volatile IMG_PUINT64)(IMG_UINTPTR)(_addr); }
//{ printf("r mem64=%x\n",_addr); *(volatile IMG_PUINT64)(IMG_UINTPTR)(_dataptr) = *(volatile IMG_PUINT64)(IMG_UINTPTR)(_addr); printf("r done mem64=%x\n",_addr);}


// The 'to' is the physical address into which the data is to be loaded
// The 'from' is a pointer to the start of the data in the script which is to be copied
// The count is the number of Bytes to be copied
#define CopyMem(_to, _from, _count) \
{  memcpy((volatile IMG_PUINT32)_to, (volatile IMG_PUINT32)_from, _count); }

// The 'to' is the physical address into which the data is to be copied
// The 'from' is a pointer to the start of the data in the script which is to be loaded
// The count is the number of Bytes to be copied
#define SaveMem(_to, _from, _count) \
{   memcpy((volatile IMG_PUINT32)_to, (volatile IMG_PUINT32)_from, _count); }

#if defined(CONFIG_RTD287X_QC) || defined(CONFIG_RTD287XP_QC) || defined(CONFIG_RTD287X_23x23_QC)
#define FillMem(_to, _byte, _count) \
{ printf("FillMem=%x %x\n",_to,_count); memset((volatile IMG_PUINT32)_to, _byte, _count); }
#endif

#define WriteSlavePort(_addr, _data) \
{  *(volatile IMG_PUINT32)(_addr) = _data; }
#else
#define WriteReg(_addr, _data) \
{  *(volatile IMG_PUINT32)(_addr) = _data; }

#define ReadReg(_addr, _to) \
{  *(IMG_PUINT32)_to = rtd_inl(_addr);}
//{  *(IMG_PUINT32)_to = (*(volatile IMG_PUINT32)(_addr)); }

#define SysWriteReg(_addr, _data) \
{  rtd_outl(_addr,_data); }
//{  *(volatile IMG_PUINT32)(_addr) = _data;  }

#define SysReadReg(_addr, _to) \
{  *(IMG_PUINT32)_to = (*(volatile IMG_PUINT32)(_addr));  }


#define WriteMem(_addr, _data) \
{  *(volatile IMG_PUINT32)(IMG_UINTPTR)(_addr) = _data; }

#define ReadMem(_addr, _dataptr) \
{  *(volatile IMG_PUINT32)(IMG_UINTPTR)(_dataptr) = *(volatile IMG_PUINT32)(IMG_UINTPTR)(_addr); }

#define ReadMemByte(_addr, _dataptr) \
{  *(volatile IMG_PUINT8)(IMG_UINTPTR)(_dataptr) = *(volatile IMG_PUINT8)(IMG_UINTPTR)(_addr); }

#define ReadMemLog(_addr, _dataptr) \
{  *(volatile IMG_PUINT32)(IMG_UINTPTR)(_dataptr) = *(volatile IMG_PUINT32)(IMG_UINTPTR)(_addr); }


#define WriteReg64(_addr, _data) \
{ IMG_UINT32 ui32ValueLow, ui32ValueHigh;ui32ValueLow = _data & 0xffffffff; ui32ValueHigh = ((IMG_UINT64) (_data >> 32)) & 0xffffffff;rtd_outl(((IMG_PUINT32)(_addr)),ui32ValueLow);rtd_outl(((IMG_PUINT32)(_addr)+1),ui32ValueHigh);}

#define ReadReg64(_addr, _to) \
{ printf("r reg64=%x\n",_addr);*(IMG_PUINT64)_to = (*(volatile IMG_PUINT64)(IMG_UINTPTR)(_addr)); printf("r done reg64=%x\n",_addr);}

#define WriteMem64(_addr, _data)\
{  IMG_UINT32 ui32ValueLow, ui32ValueHigh;ui32ValueLow = _data & 0xffffffff; ui32ValueHigh = ((IMG_UINT64) (_data >> 32)) & 0xffffffff;*(volatile IMG_PUINT32)(IMG_UINTPTR)(_addr) = ui32ValueLow;*(volatile IMG_PUINT32)((IMG_PUINT32)(_addr)+1) = ui32ValueHigh; }

#define ReadMem64(_addr, _dataptr) \
{ printf("r mem64=%x\n",_addr); *(volatile IMG_PUINT64)(IMG_UINTPTR)(_dataptr) = *(volatile IMG_PUINT64)(IMG_UINTPTR)(_addr); printf("r done mem64=%x\n",_addr);}

// The 'to' is the physical address into which the data is to be loaded
// The 'from' is a pointer to the start of the data in the script which is to be copied
// The count is the number of Bytes to be copied
#define CopyMem(_to, _from, _count) \
{  memcpy((volatile IMG_PUINT32)_to, (volatile IMG_PUINT32)_from, _count); }

// The 'to' is the physical address into which the data is to be copied
// The 'from' is a pointer to the start of the data in the script which is to be loaded
// The count is the number of Bytes to be copied
#define SaveMem(_to, _from, _count) \
{  memcpy((volatile IMG_PUINT32)_to, (volatile IMG_PUINT32)_from, _count);  }

#define WriteSlavePort(_addr, _data) \
{  *(volatile IMG_PUINT32)(_addr) = _data; }

#endif
#define Delay(_delay) \  
    { IMG_UINT32 i, j = 0; for (i = 0; i < _delay; i++){ udelay(1);j++; } }

// Add a printf like function here for verbose printout
#define VERBOSE_OUTPUT(_cmd, _command_script)

// Add a printf like function here for error message printout
#define ERROR_OUTPUT(_output) \
    printf(_output)

#else

#include "pdlemudefs.h"
#include "binlite_macros.h"

#define VERBOSE_OUTPUT_ENABLED \
    ((gui32BinLitePlayerFlags & BINLITE_VERBOSE_OUTPUT_MASK) != 0)

#define VERBOSE_OUTPUT(_cmd, _command_script) \
    if (VERBOSE_OUTPUT_ENABLED) { GENERATE_ASCII_DUMP_##_cmd(_command_script); }

#define ERROR_OUTPUT(_text) \
    printf(_text)

#endif /* EMU_TARGET */

#if !defined(TAL_PDUMPL_NO_OPTIMISE)
// Flag which tells the optimiser not to optimise this command
#define	TAL_PDUMPL_NO_OPTIMISE	(0x80000000)
#endif /* TAL_PDUMPL_NO_OPTIMISE */

#if !defined(ADDR64)
#define ADDR64(_addr32)         *(IMG_UINT64 *)(&_addr32)
#endif /* ADDR64 */

#if !defined(DATA64)
#define DATA64(_data32)			*(IMG_UINT64*)(&_data32)
#endif /* DATA64 */

#define MAX_PDUMPLTESTS         (8)
#define MAX_PDUMPLSCRIPTS       (32)
#define MAX_SEMAPHORES          (64)
#define MAX_SYNC_IDS            (32) //(64)
#define NO_SYSSYNC_IDS          (64)


#define SYS_SGX_REG_OFFSET                  0x0
#define SYS_SGX_REG_SIZE 	            0xFFFF

#define REG_GPU_IDLE_STATUS   (REG_GPU_BASE + 0xE000)
#define REG_GPU_CONFIG        (REG_GPU_BASE + 0xE004)
#define REG_GPU_RESET         (REG_GPU_BASE + 0xE008)
#define REG_GPU_CLKEN         (REG_GPU_BASE + 0xE00C)
#define REG_GPU_PWR           (REG_GPU_BASE + 0xE090)
#define REG_GPU_ISO           (REG_GPU_BASE + 0xE094)
#define REG_GPU_PWR_ST        (REG_GPU_BASE + 0xE098)
#define REG_GPU_PWR_CONFIG    (REG_GPU_BASE + 0xE09C)
#define REG_GPU_ENDIAN        (REG_GPU_BASE + 0xE048)


#define REG_GPU_IDLE_STATUS_OFF       (0xE000)
#define REG_GPU_CONFIG_OFF            (0xE004)
#define REG_GPU_RESET_OFF             (0xE008)
#define REG_GPU_CLKEN_OFF             (0xE00C)
#define REG_GPU_PWR_OFF               (0xE090)
#define REG_GPU_ISO_OFF               (0xE094)
#define REG_GPU_PWR_ST_OFF            (0xE098)
#define REG_GPU_PWR_CONFIG_OFF        (0xE09C)
#define REG_GPU_ENDIAN_OFF            (0xE048)


#define SYS_REG_GPU_SRST0_OFFSET	0x0100
#define SYS_REG_GPU_SRST0_BIT		_BIT19

#define SYS_REG_GPU_RESET_OFFSET	0x0104
#define SYS_REG_GPU_RESET_BIT		_BIT19
#define SYS_REG_GPU_CLK_OFFSET	        0x0114
#define SYS_REG_GPU_CLK_BIT		_BIT3
#define SYS_REG_GPU_DVFS_OFFSET         0x0448
#define SYS_REG_GPU_DVFS_OE_BIT         _BIT0
#define SYS_REG_GPU_DVFS_OE_DONE_BIT    _BIT1
#define SYS_REG_GPU_PLL_GPU2_OFFSET     0x0454

/* Typedef etc */
typedef struct PDL_tag_sScriptCB
{
	IMG_UINT32	ui32ScriptId;			/*<! Script Identifier */
	IMG_UINT32	ui32TestId;				/*<! Test Identifier */

	IMG_PUINT32	pui32ScriptBase;		/*<! The base of the script */
	IMG_PUINT32	pui32Script;			/*<! Points to the current position in the script */
	IMG_BOOL	bEOF;					/*<! Indicates whether the end of script has been reached */
	
	IMG_UINT32	ui32FileID;				/*<! File ID in the last command */
	IMG_UINT32	ui32LineNum;			/*<! Line number in the last command */

	/* Synchronisation information */
	IMG_UINT32	ui32DisabledSyncs;		/*<! Sync Enable info */
	IMG_BOOL	bWaiting;				/*<! Is the script waiting for sync?	    */
	IMG_UINT32	ui32SyncWaiting;		/*<! The number of the sync the script is waiting for */
	IMG_UINT32	ui32SemaWaiting;		/*<! The number of the Semaphore the script is waiting for */

	/* POLL Information */
	IMG_BOOL	bPollPending;           /*<! Is POLL command pending for this CB?   */
	IMG_UINT32	ui32LoopCount;			/*<! The number of times the POL was executed */
	IMG_UINT32	ui32Delay;
	IMG_UINT32	ui32TimeCount;			/*<! Counting the time between polls		*/	

	IMG_UINT32	ui32SabFileID;			/*<! File ID in the last SAB command */
	IMG_UINT32	ui32SabLineNum;			/*<! Line number in the last SAB command */
	IMG_UINT32	ui32SabSize;			/*<! Size of current SAB command (cummulates with SABs from same line in pdump2) */
	IMG_PUINT32	pui32SabSize;			/*<! Pointer to SAB size for current command */

	/* Extra Information */
	IMG_PVOID	pvInfo;
} PDL_sScriptCB, * PDL_psScriptCB;

typedef struct PDL_tag_sTestCB
{
	IMG_UINT32	ui32NumScripts;
	IMG_INT32	ai32Semaphores[MAX_SEMAPHORES];
	IMG_UINT32	aui32SystemSyncId[NO_SYSSYNC_IDS];
} PDL_sTestCB, * PDL_psTestCB;

// Script function callback
typedef IMG_VOID (*PDL_pfnScriptFunction)(PDL_psScriptCB psScriptCB);

/* Global data */

/*==========================================================================================*/
/*																							*/
/*		pvScriptPointer MUST be set to either 0x00000000 to just run the system checks		*/
/*		or the address at which the Pdump Player Lite binary script has been loaded.		*/
/*																							*/
/*==========================================================================================*/

                    volatile    IMG_PVOID		pvScriptPointer	= (volatile IMG_PVOID)(IMG_UINTPTR)(GPU_PATTERN_ADDR);

            // pui8SABOutput is the address at which to dump the SAB output
			IMG_PUINT8		pui8SABOutput = (IMG_PUINT8)(IMG_UINTPTR)(GPU_PATTERN_OUT_ADDR);
      
//#define IGNORE_CHECKS      
	        unsigned int *golden_ptr = (IMG_PUINT8)(IMG_UINTPTR)(GPU_PATTERN_GOLDEN_ADDR);
			unsigned int *outptr = (IMG_PUINT8)(IMG_UINTPTR)(GPU_PATTERN_OUT_ADDR);

//#define IGNORE_CHECKS      

			IMG_UINT32		ui32CheckLittleEndian = 0x01020304;

			int				gbl_argc;
			char **			gbl_argv;

			IMG_UINT32		gui32BinLitePlayerFlags = 0;

			IMG_UINT64		aui64InternalRegisters[MAX_PDUMPLSCRIPTS][NUMBER_OF_INTERNAL_REGS];

			PDL_sScriptCB   asScriptCB[MAX_PDUMPLSCRIPTS];
			IMG_UINT32		gui32NumScripts = 0;
			
			PDL_sTestCB		asTestCB[MAX_PDUMPLTESTS];
			IMG_UINT32		gui32NumTests = 0;

			IMG_UINT32		_ui32SysSyncId = 32;
			IMG_PUINT32		pui32SABOrigin;

/******************************************************************************/
/*																			  */
/*		Function prototypes													  */
/*																			  */
/******************************************************************************/
IMG_UINT32 GetSysSyncId(PDL_psScriptCB psScriptCB, IMG_UINT32 ui32SyncId);

/******************************************************************************/
/*                                                                            */
/*		Prototypes and look-up table for script processing functions		  */
/*																			  */
/******************************************************************************/
IMG_VOID PDL_WriteRegister(PDL_psScriptCB psScriptCB);
IMG_VOID PDL_WriteMemory(PDL_psScriptCB psScriptCB);
IMG_VOID PDL_WriteSlavePort(PDL_psScriptCB psScriptCB);

IMG_VOID PDL_ReadRegister(PDL_psScriptCB psScriptCB);
IMG_VOID PDL_ReadMemory(PDL_psScriptCB psScriptCB);

IMG_VOID PDL_PollRegister(PDL_psScriptCB psScriptCB);
IMG_VOID PDL_PollMemory(PDL_psScriptCB psScriptCB);

IMG_VOID PDL_LoadWordsToRegister(PDL_psScriptCB psScriptCB);
IMG_VOID PDL_LoadBytesToMemory(PDL_psScriptCB psScriptCB);
IMG_VOID PDL_LoadWordsToSlavePort(PDL_psScriptCB psScriptCB);
#if defined(CONFIG_RTD287X_QC) || defined(CONFIG_RTD287XP_QC) || defined(CONFIG_RTD287X_23x23_QC)
IMG_VOID PDL_FillMem(PDL_psScriptCB psScriptCB);
#endif
IMG_VOID PDL_Idle(PDL_psScriptCB psScriptCB);

IMG_VOID PDL_MemCircularBufferPoll(PDL_psScriptCB psScriptCB);


IMG_VOID PDL_WriteIntRegToRegister(PDL_psScriptCB psScriptCB);
IMG_VOID PDL_WriteIntRegToMemory(PDL_psScriptCB psScriptCB);
IMG_VOID PDL_ReadRegisterToIntReg(PDL_psScriptCB psScriptCB);
IMG_VOID PDL_ReadMemoryToIntReg(PDL_psScriptCB psScriptCB);
#if 1 // defined(CONFIG_RTD287X_QC) || defined(CONFIG_RTD287XP_QC)
IMG_VOID PDL_IntRegMOV(PDL_psScriptCB psScriptCB);
IMG_VOID PDL_IntRegAND(PDL_psScriptCB psScriptCB);
IMG_VOID PDL_IntRegOR(PDL_psScriptCB psScriptCB);
IMG_VOID PDL_IntRegXOR(PDL_psScriptCB psScriptCB);
IMG_VOID PDL_IntRegNOT(PDL_psScriptCB psScriptCB);
IMG_VOID PDL_IntRegSHR(PDL_psScriptCB psScriptCB);
IMG_VOID PDL_IntRegSHL(PDL_psScriptCB psScriptCB);
IMG_VOID PDL_IntRegADD(PDL_psScriptCB psScriptCB);
IMG_VOID PDL_IntRegSUB(PDL_psScriptCB psScriptCB);
IMG_VOID PDL_IntRegMUL(PDL_psScriptCB psScriptCB);
IMG_VOID PDL_IntRegIMUL(PDL_psScriptCB psScriptCB);
IMG_VOID PDL_IntRegDIV(PDL_psScriptCB psScriptCB);
IMG_VOID PDL_IntRegIDIV(PDL_psScriptCB psScriptCB);
IMG_VOID PDL_IntRegMOD(PDL_psScriptCB psScriptCB);
IMG_VOID PDL_IntRegEQU(PDL_psScriptCB psScriptCB);
IMG_VOID PDL_IntRegLT(PDL_psScriptCB psScriptCB);
IMG_VOID PDL_IntRegLTE(PDL_psScriptCB psScriptCB);
IMG_VOID PDL_IntRegGT(PDL_psScriptCB psScriptCB);
IMG_VOID PDL_IntRegGTE(PDL_psScriptCB psScriptCB);
IMG_VOID PDL_IntRegNEQ(PDL_psScriptCB psScriptCB);
#endif
IMG_VOID PDL_IntRegMOV_IntReg(PDL_psScriptCB psScriptCB);
IMG_VOID PDL_IntRegAND_IntReg(PDL_psScriptCB psScriptCB);
IMG_VOID PDL_IntRegOR_IntReg(PDL_psScriptCB psScriptCB);
IMG_VOID PDL_IntRegXOR_IntReg(PDL_psScriptCB psScriptCB);
IMG_VOID PDL_IntRegSHR_IntReg(PDL_psScriptCB psScriptCB);
IMG_VOID PDL_IntRegSHL_IntReg(PDL_psScriptCB psScriptCB);
IMG_VOID PDL_IntRegADD_IntReg(PDL_psScriptCB psScriptCB);
IMG_VOID PDL_IntRegSUB_IntReg(PDL_psScriptCB psScriptCB);
IMG_VOID PDL_IntRegMUL_IntReg(PDL_psScriptCB psScriptCB);
IMG_VOID PDL_IntRegIMUL_IntReg(PDL_psScriptCB psScriptCB);
IMG_VOID PDL_IntRegDIV_IntReg(PDL_psScriptCB psScriptCB);
IMG_VOID PDL_IntRegIDIV_IntReg(PDL_psScriptCB psScriptCB);
IMG_VOID PDL_IntRegMOD_IntReg(PDL_psScriptCB psScriptCB);
IMG_VOID PDL_IntRegEQU_IntReg(PDL_psScriptCB psScriptCB);
IMG_VOID PDL_IntRegLT_IntReg(PDL_psScriptCB psScriptCB);
IMG_VOID PDL_IntRegLTE_IntReg(PDL_psScriptCB psScriptCB);
IMG_VOID PDL_IntRegGT_IntReg(PDL_psScriptCB psScriptCB);
IMG_VOID PDL_IntRegGTE_IntReg(PDL_psScriptCB psScriptCB);
IMG_VOID PDL_IntRegNEQ_IntReg(PDL_psScriptCB psScriptCB);

IMG_VOID PDL_RegCircularBufferPoll(PDL_psScriptCB psScriptCB);
IMG_VOID PDL_Sync(PDL_psScriptCB psScriptCB);
IMG_VOID PDL_Lock(PDL_psScriptCB psScriptCB);
IMG_VOID PDL_Unlock(PDL_psScriptCB psScriptCB);

IMG_VOID PDL_WriteMemory64(PDL_psScriptCB psScriptCB);
IMG_VOID PDL_ReadMemory64(PDL_psScriptCB psScriptCB);
IMG_VOID PDL_PollMemory64(PDL_psScriptCB psScriptCB);
IMG_VOID PDL_LoadBytesToMemory64(PDL_psScriptCB psScriptCB);
IMG_VOID PDL_MemCircularBufferPoll64(PDL_psScriptCB psScriptCB);
IMG_VOID PDL_WriteIntRegToMemory64(PDL_psScriptCB psScriptCB);
IMG_VOID PDL_ReadMemoryToIntReg64(PDL_psScriptCB psScriptCB);
#if defined(CONFIG_RTD287X_QC) || defined(CONFIG_RTD287XP_QC) || defined(CONFIG_RTD287X_23x23_QC)
IMG_VOID PDL_FillMem64(PDL_psScriptCB psScriptCB);
#else
IMG_VOID PDL_IntRegMOV64(PDL_psScriptCB psScriptCB);
#endif
IMG_VOID PDL_Padding(PDL_psScriptCB psScriptCB);
IMG_VOID PDL_SaveBytesFromMemory(PDL_psScriptCB psScriptCB);
IMG_VOID PDL_SaveBytesFromMemory64(PDL_psScriptCB psScriptCB);

IMG_VOID PDL_WriteRegister64(PDL_psScriptCB psScriptCB);
IMG_VOID PDL_ReadRegister64(PDL_psScriptCB psScriptCB);
IMG_VOID PDL_WriteIntRegToRegister64(PDL_psScriptCB psScriptCB);
IMG_VOID PDL_ReadRegister64ToIntReg(PDL_psScriptCB psScriptCB);
IMG_VOID PDL_PollRegister64(PDL_psScriptCB psScriptCB);

IMG_VOID PDL_Write64Register64(PDL_psScriptCB psScriptCB);
IMG_VOID PDL_Write64Memory64(PDL_psScriptCB psScriptCB);
IMG_VOID PDL_Read64Register64(PDL_psScriptCB psScriptCB);
IMG_VOID PDL_Read64Memory64(PDL_psScriptCB psScriptCB);
IMG_VOID PDL_Poll64Register64(PDL_psScriptCB psScriptCB);
IMG_VOID PDL_Poll64Memory64(PDL_psScriptCB psScriptCB);
IMG_VOID PDL_Write64IntRegToRegister64(PDL_psScriptCB psScriptCB);
IMG_VOID PDL_Write64IntRegToMemory64(PDL_psScriptCB psScriptCB);
IMG_VOID PDL_Read64Register64ToIntReg(PDL_psScriptCB psScriptCB);
IMG_VOID PDL_Read64Memory64ToIntReg(PDL_psScriptCB psScriptCB);
#if defined(CONFIG_RTD287X_QC) || defined(CONFIG_RTD287XP_QC) || defined(CONFIG_RTD287X_23x23_QC)
IMG_VOID PDL_NULL(PDL_psScriptCB psScriptCB);
#endif
PDL_pfnScriptFunction pfnScriptFunction[] =
{
	&PDL_WriteRegister,				
	&PDL_WriteMemory,				
	&PDL_WriteSlavePort,				

	&PDL_ReadRegister,
	&PDL_ReadMemory,

	&PDL_PollRegister,
	&PDL_PollMemory,

	&PDL_LoadBytesToMemory,
	&PDL_LoadWordsToRegister,
	&PDL_LoadWordsToSlavePort,

	&PDL_Idle,

	&PDL_MemCircularBufferPoll,

	&PDL_WriteIntRegToRegister,
	&PDL_WriteIntRegToMemory,
	&PDL_ReadRegisterToIntReg,
	&PDL_ReadMemoryToIntReg,
#if 1 //defined(CONFIG_RTD287X_QC) || defined(CONFIG_RTD287XP_QC)	
	&PDL_IntRegMOV,
	&PDL_IntRegAND,
	&PDL_IntRegOR,
	&PDL_IntRegXOR,
	&PDL_IntRegNOT,
	&PDL_IntRegSHR,
	&PDL_IntRegSHL,
	&PDL_IntRegADD,
	&PDL_IntRegSUB,
	&PDL_IntRegMUL,
	&PDL_IntRegIMUL,
	&PDL_IntRegDIV,
	&PDL_IntRegIDIV,
	&PDL_IntRegMOD,
	&PDL_IntRegEQU,
	&PDL_IntRegLT,
	&PDL_IntRegLTE,
	&PDL_IntRegGT,
	&PDL_IntRegGTE,
	&PDL_IntRegNEQ,
#endif
	&PDL_RegCircularBufferPoll,

	&PDL_Sync,
	&PDL_Lock,
	&PDL_Unlock,

	&PDL_WriteMemory64,
	&PDL_ReadMemory64,
	&PDL_PollMemory64,
	&PDL_LoadBytesToMemory64,
	&PDL_MemCircularBufferPoll64,
	&PDL_WriteIntRegToMemory64,
	&PDL_ReadMemoryToIntReg64,
#if defined(CONFIG_RTD287X_QC) || defined(CONFIG_RTD287XP_QC) || defined(CONFIG_RTD287X_23x23_QC)
	&PDL_IntRegMOV,
#else
	&PDL_IntRegMOV64,
#endif
	&PDL_Padding,
	&PDL_SaveBytesFromMemory,
	&PDL_SaveBytesFromMemory64,
	
	&PDL_WriteRegister64,
	&PDL_ReadRegister64,
	&PDL_WriteIntRegToRegister64,
	&PDL_ReadRegister64ToIntReg,
	&PDL_PollRegister64	,

	&PDL_Write64Register64,
	&PDL_Write64Memory64,
	&PDL_Read64Register64,
	&PDL_Read64Memory64,
	&PDL_Poll64Register64,
	&PDL_Poll64Memory64,
	&PDL_Write64IntRegToRegister64,
	&PDL_Write64IntRegToMemory64,
	&PDL_Read64Register64ToIntReg,
#if defined(CONFIG_RTD287X_QC) || defined(CONFIG_RTD287XP_QC) || defined(CONFIG_RTD287X_23x23_QC)
	&PDL_Read64Memory64ToIntReg,

    &PDL_FillMem,
    &PDL_FillMem64,

	&PDL_IntRegMOV_IntReg,
	&PDL_IntRegAND_IntReg,
	&PDL_IntRegOR_IntReg,
	&PDL_IntRegXOR_IntReg,
    &PDL_NULL,
	&PDL_IntRegSHR_IntReg,
	&PDL_IntRegSHL_IntReg,
	&PDL_IntRegADD_IntReg,
	&PDL_IntRegSUB_IntReg,
	&PDL_IntRegMUL_IntReg,
	&PDL_IntRegIMUL_IntReg,
	&PDL_IntRegDIV_IntReg,
	&PDL_IntRegIDIV_IntReg,
	&PDL_IntRegMOD_IntReg,
	&PDL_IntRegEQU_IntReg,
	&PDL_IntRegLT_IntReg,
	&PDL_IntRegLTE_IntReg,
	&PDL_IntRegGT_IntReg,
	&PDL_IntRegGTE_IntReg,
	&PDL_IntRegNEQ_IntReg,
#else
	&PDL_Read64Memory64ToIntReg
#endif
	/* etc */
};

static unsigned int align_to_boundary(unsigned int size, unsigned int block_size)
{
	return (size % block_size ? size / block_size + 1 : size / block_size);
}
IMG_UINT32 ui32MaxScriptFunction = sizeof(pfnScriptFunction) / sizeof(PDL_pfnScriptFunction) - 1;

int QC_Copy_emmc_Pattern_data(unsigned int qc_buf_1,unsigned int qc_buf_2)
{
	int ret = 0;
	char cmd[256] = {0};
	unsigned int *ptr;
	unsigned int index = 0, block_no, data_size;
	unsigned int block_cnt;

	printf("======================%s start copy test pattern  ======================\n", __FUNCTION__);

	/* read from eMMC */
	//read header


	snprintf(cmd, sizeof(cmd), "mmc read 0x%x 0x%x 0x%x", EMMC_TMP_BUFFER, EMMC_QC_EXTERND_DATA_1_BLK_ADDR, 1);
	printf("run cmd => %s\n", cmd);	
	if ((ret = run_command(cmd, 0))) {
		printf("command error\n");
		goto copy_end;
	}	

	ptr = (unsigned int *)(EMMC_TMP_BUFFER);

	if (*ptr++ != 0x12345678) {
		printf("error magic no.\nno GPU code on flash\n");
		goto copy_end;
	}
	data_size = *ptr;

	block_cnt = align_to_boundary(data_size,EMMC_BLOCK_SIZE);
	block_no = EMMC_QC_EXTERND_DATA_1_BLK_ADDR + 1; // body = header +1

	printf("index = 0x%x, block_no = 0x%x, block_cnt = 0x%x, data_size = 0x%x\n", index, block_no, block_cnt, data_size);


	//read body
	snprintf(cmd, sizeof(cmd), "mmc read 0x%x 0x%x 0x%x", qc_buf_1, block_no, block_cnt);
	printf("run cmd ===> %s\n", cmd);
	if ((ret = run_command(cmd, 0))) {
		printf("command error\n");

		goto copy_end;
	}
	printf("======================%s end copy test pattern  %d======================\n", __FUNCTION__, ret);
	printf("======================%s start copy golden pattern  ======================\n", __FUNCTION__);
	/* read from eMMC */
	//read header

	snprintf(cmd, sizeof(cmd), "mmc read 0x%x 0x%x 0x%x", EMMC_TMP_BUFFER, EMMC_QC_EXTERND_DATA_2_BLK_ADDR, 1);
	printf("run cmd => %s\n", cmd);	
	if ((ret = run_command(cmd, 0))) {
		printf("command error\n");
		goto copy_end;
	}	
	
	ptr = (unsigned int *)(EMMC_TMP_BUFFER);
	
	if (*ptr++ != 0x12345678) {
		printf("error magic no.\nno VE code on flash\n");
		free(pattern_golden_ptr);
		goto copy_end;
	}
	data_size = *ptr;
	outfb_size_to_verify = data_size;
	
	block_cnt = align_to_boundary(data_size,EMMC_BLOCK_SIZE);
	block_no = EMMC_QC_EXTERND_DATA_2_BLK_ADDR + 1; // body = header +1	
	printf("index = 0x%x, block_no = 0x%x, block_cnt = 0x%x, data_size = 0x%x\n", index, block_no, block_cnt, data_size);
	
	//read body
	snprintf(cmd, sizeof(cmd), "mmc read 0x%x 0x%x 0x%x", qc_buf_2, block_no, block_cnt);
	printf("run cmd ===> %s\n", cmd);
	if ((ret = run_command(cmd, 0))) {
		printf("command error\n");
		goto copy_end;
	}	
	printf("======================%s end copy golden pattern  %d======================\n", __FUNCTION__, ret);
copy_end:

	return (ret == 0) ? SUCCESS:FAILED;
}


int QC_Copy_nand_Pattern_data(unsigned int qc_buf_1,unsigned int qc_buf_2)
{
	int ret = 0;
#ifdef CONFIG_SYS_RTK_NAND_FLASH
	int blk_addr = 0,hdr_size = 0;
	unsigned int start_addr = 0,*qc_ptr = NULL,buf_size = 0;
	nand_info_t *nand =&nand_info[0];
	/*read header content*/
	blk_addr = nand->scan_block_tag(nand, NAND_QC_GCPU1_BLK_ADDR,20,0,BLOCK_QC_GPU1);
	if(blk_addr == 0){
		printf("[ERR] %s %d: Scan block-tag failed!!!\n", __FUNCTION__,__LINE__);
		return -1;
	}else{
		printf("[OK] %s %d:Scan %d block-tag 0x%x ok!!\n", __FUNCTION__,__LINE__,
			NAND_QC_GCPU1_BLK_ADDR,BLOCK_QC_GPU1);
	}
	hdr_size = ((512+nand->oobblock-1)/nand->oobblock)*nand->oobblock;
	start_addr = blk_addr* (nand->erasesize);
	if((ret = nand->rescue_image_read(nand, 
		(unsigned char *)NAND_TMP_BUFFER, start_addr, 
			blk_addr, 0, BLOCK_QC_GPU1)) < 0){
		printf("[ERR] %s: %d get image content err!!\n", __FUNCTION__,__LINE__);
		return ret;
	}
	
	/*read buffer content*/
	qc_ptr = (unsigned int *)NAND_TMP_BUFFER;
	if(*qc_ptr++ != 0x12345678)
	{
		printf("error magic no.\nno qc_ve_pattern on flash\n");
		return ret;
	}
	buf_size = *qc_ptr;
	ret = nand->rescue_image_read(nand, (unsigned char *)NAND_TMP_BUFFER, start_addr, 
			hdr_size+buf_size, 0, BLOCK_QC_GPU1);
	if(ret == 0){
		memcpy((unsigned char *)qc_buf_1,(unsigned char *)(NAND_TMP_BUFFER+hdr_size),
				buf_size);
	}else{
		return ret;
	}

	/*read header content*/
	blk_addr = nand->scan_block_tag(nand, NAND_QC_GCPU2_BLK_ADDR,20,0,BLOCK_QC_GPU2);
	if(blk_addr == 0){
		printf("[ERR] %s %d: Scan block-tag failed!!!\n", __FUNCTION__,__LINE__);
		return -1;
	}else{
		printf("[OK] %s %d:Scan %d block-tag 0x%x ok!!\n", __FUNCTION__,__LINE__,
			NAND_QC_GCPU2_BLK_ADDR,BLOCK_QC_GPU2);
	}
	hdr_size = ((512+nand->oobblock-1)/nand->oobblock)*nand->oobblock;
	start_addr = blk_addr* (nand->erasesize);
	if((ret = nand->rescue_image_read(nand, 
		(unsigned char *)NAND_TMP_BUFFER, start_addr, 
			blk_addr, 0, BLOCK_QC_GPU2)) < 0){
		printf("[ERR] %s: %d get image content err!!\n", __FUNCTION__,__LINE__);
		return ret;
	}
	
	/*read buffer content*/
	qc_ptr = (unsigned int *)NAND_TMP_BUFFER;
	if(*qc_ptr++ != 0x12345678)
	{
		printf("error magic no.\nno qc_ve_pattern on flash\n");
		return ret;
	}
	buf_size = *qc_ptr;
	outfb_size_to_verify = buf_size;
	ret = nand->rescue_image_read(nand, (unsigned char *)NAND_TMP_BUFFER, start_addr, 
			hdr_size+buf_size, 0, BLOCK_QC_GPU2);
	if(ret == 0){
		memcpy((unsigned char *)qc_buf_2,(unsigned char *)(NAND_TMP_BUFFER+hdr_size),
				buf_size);
	}
#endif
	return ret;
}

int QC_Copy_Pattern_data(unsigned int qc_buf_1,unsigned int qc_buf_2)
{
	int ret = 0;
#ifdef CONFIG_SYS_RTK_NAND_FLASH
	ret = QC_Copy_nand_Pattern_data(qc_buf_1,qc_buf_2);
#else
	ret = QC_Copy_emmc_Pattern_data(qc_buf_1,qc_buf_2);
#endif
	return ret;

}


/******************************************************************************/
/*                                                                            */
/*		Default abstraction functions                                         */
/*																			  */
/******************************************************************************/
#if 0
IMG_VOID WriteReg(IMG_PUINT32 _addr,IMG_UINT32 _data)
{
	*(volatile IMG_PUINT32)GET_MAPPED_RBUS_ADDR(_addr) = _data;
}
IMG_VOID ReadReg(IMG_PUINT32 _addr,IMG_PUINT32 _to )
{
	*(IMG_PUINT32)_to =  (*(volatile IMG_PUINT32)GET_MAPPED_RBUS_ADDR(_addr));  
}
#endif
#if !defined(EMU_TARGET)

IMG_VOID PDL_DefaultInit(IMG_VOID)
{
    int count;

#if defined(CONFIG_RTD287X_QC) || defined(CONFIG_RTD287XP_QC) || defined(CONFIG_RTD287X_23x23_QC)
#if 1
	//rtd_outl(0xB8000448, 0x01e20286);
	//rtd_outl(0xB8000454, 0x00981503); 

    rtd_maskl(SYS_REG_BASE+SYS_REG_GPU_DVFS_OFFSET, ~(SYS_REG_GPU_DVFS_OE_BIT), 0);
    // set PLLGPU_OC_EN=1
    rtd_setbits(SYS_REG_BASE+SYS_REG_GPU_DVFS_OFFSET,SYS_REG_GPU_DVFS_OE_BIT);
    count = 0;
    while((rtd_inl(SYS_REG_BASE+SYS_REG_GPU_DVFS_OFFSET) & _BIT1) != _BIT1){
        Delay(1000);
        if(count ++ > 100)
            break;
    }  
#endif
	
    //enable GPU CLK
    rtd_setbits(SYS_REG_BASE+SYS_REG_GPU_CLK_OFFSET,_BIT3|_BIT0);
    Delay(1000);
	//disable GPU RESET
    rtd_setbits(SYS_REG_BASE+SYS_REG_GPU_RESET_OFFSET,_BIT3|_BIT0);
    Delay(1000);
	
	
    // enable sw mode
    //reg = SysReadHWReg((IMG_PVOID)REG_GPU_BASE, REG_GPU_PWR_CONFIG_OFF) | (_BIT4);
	//printf("func=%s line=%d addr=%x\n",__FUNCTION__,__LINE__,REG_GPU_BASE+REG_GPU_PWR_CONFIG_OFF);
	
    rtd_setbits(REG_GPU_BASE+REG_GPU_PWR_CONFIG_OFF,_BIT4);
	//printf("func=%s line=%d \n",__FUNCTION__,__LINE__);

    //reg = SysReadHWReg((IMG_PVOID)REG_GPU_BASE, REG_GPU_PWR_OFF) | (_BIT0|_BIT1);
    //SysWriteHWReg((IMG_PVOID)REG_GPU_BASE, REG_GPU_PWR_OFF, reg);
    rtd_setbits(REG_GPU_BASE+REG_GPU_PWR_OFF,_BIT0);
    rtd_setbits(REG_GPU_BASE+REG_GPU_PWR_OFF,_BIT1);
    count = 0;
    while((rtd_inl(REG_GPU_BASE+0xE098) & (_BIT1|_BIT0)) != (_BIT1|_BIT0)){
		Delay(1000);
        if(count ++ > 100)
            break;
    }
    //SysWriteHWReg((IMG_PVOID)REG_GPU_BASE, 0xE0a0, 0x0);
    rtd_maskl(REG_GPU_BASE+0xE0a0, ~(_BIT1|_BIT0), 0);
	//printf("func=%s line=%d \n",__FUNCTION__,__LINE__);	
    //SysWriteHWReg((IMG_PVOID)REG_GPU_BASE, 0xE094, 0x3);
    rtd_setbits(REG_GPU_BASE+0xE094,(_BIT1));
    rtd_setbits(REG_GPU_BASE+0xE094,(_BIT0));
	//printf("func=%s line=%d \n",__FUNCTION__,__LINE__);
    rtd_setbits(REG_GPU_BASE+REG_GPU_CLKEN_OFF,(_BIT0|_BIT1|_BIT2));
	//printf("func=%s line=%d \n",__FUNCTION__,__LINE__);
    rtd_setbits(REG_GPU_BASE+REG_GPU_ENDIAN_OFF,(_BIT0));
	//printf("func=%s line=%d \n",__FUNCTION__,__LINE__);
    rtd_setbits(REG_GPU_BASE+REG_GPU_RESET_OFF,(_BIT0));
	//printf("func=%s line=%d \n",__FUNCTION__,__LINE__);
#else
    //rtd_setbits(0xb805c010, _BIT8);
    //rtd_maskl(offset, andMask, orMask)
    
    //reg = SysReadHWReg((IMG_PVOID)SYS_REG_BASE, SYS_REG_GPU_DVFS_OFFSET) & ~(SYS_REG_GPU_DVFS_OE_BIT);
    //SysWriteHWReg((IMG_PVOID)SYS_REG_BASE, SYS_REG_GPU_DVFS_OFFSET, reg);
    //printk("GPU_DVFS[%x]        0x%x\n", 0xb8000448, SysReadHWReg((IMG_PVOID)SYS_REG_BASE, SYS_REG_GPU_DVFS_OFFSET)) ;    
    rtd_maskl(SYS_REG_BASE+SYS_REG_GPU_DVFS_OFFSET, ~(SYS_REG_GPU_DVFS_OE_BIT), 0);


    // set PLLGPU_OC_EN=1
    //rtd_outl(0xB8000448, 0x01e20287);
    //reg = SysReadHWReg((IMG_PVOID)SYS_REG_BASE, SYS_REG_GPU_DVFS_OFFSET) | (SYS_REG_GPU_DVFS_OE_BIT);
    //SysWriteHWReg((IMG_PVOID)SYS_REG_BASE, SYS_REG_GPU_DVFS_OFFSET, reg);
    rtd_setbits(SYS_REG_BASE+SYS_REG_GPU_DVFS_OFFSET,SYS_REG_GPU_DVFS_OE_BIT);

    count = 0;
    while((rtd_inl(SYS_REG_BASE+SYS_REG_GPU_DVFS_OFFSET) & _BIT1) != _BIT1){
        Delay(1000);
        if(count ++ > 100)
            break;
    }  

    //disable GPU SRST0 RESET
    //reg = SysReadHWReg((IMG_PVOID)SYS_REG_BASE, SYS_REG_GPU_SRST0_OFFSET) | (_BIT19);
    //SysWriteHWReg((IMG_PVOID)SYS_REG_BASE, SYS_REG_GPU_SRST0_OFFSET, reg);
    rtd_setbits(SYS_REG_BASE+SYS_REG_GPU_SRST0_OFFSET,_BIT19);
    Delay(1000);

    //enable GPU CLK
    //reg = SysReadHWReg((IMG_PVOID)SYS_REG_BASE, SYS_REG_GPU_CLK_OFFSET) | (_BIT3);
    //SysWriteHWReg((IMG_PVOID)SYS_REG_BASE, SYS_REG_GPU_CLK_OFFSET, reg);
    rtd_setbits(SYS_REG_BASE+SYS_REG_GPU_CLK_OFFSET,_BIT3);
    Delay(1000);

   //disable GPU RESET
    //reg = SysReadHWReg((IMG_PVOID)SYS_REG_BASE, SYS_REG_GPU_RESET_OFFSET) | (_BIT3);
    //SysWriteHWReg((IMG_PVOID)SYS_REG_BASE, SYS_REG_GPU_RESET_OFFSET, reg);
    rtd_setbits(SYS_REG_BASE+SYS_REG_GPU_RESET_OFFSET,_BIT3);
    Delay(1000);
    
    // enable sw mode
    //reg = SysReadHWReg((IMG_PVOID)REG_GPU_BASE, REG_GPU_PWR_CONFIG_OFF) | (_BIT4);
    rtd_setbits(REG_GPU_BASE+REG_GPU_PWR_CONFIG_OFF,_BIT4);


    //reg = SysReadHWReg((IMG_PVOID)REG_GPU_BASE, REG_GPU_PWR_OFF) | (_BIT0|_BIT1);
    //SysWriteHWReg((IMG_PVOID)REG_GPU_BASE, REG_GPU_PWR_OFF, reg);
    rtd_setbits(REG_GPU_BASE+REG_GPU_PWR_OFF,_BIT0);
    rtd_setbits(REG_GPU_BASE+REG_GPU_PWR_OFF,_BIT1);
    count = 0;
    while((rtd_inl(REG_GPU_BASE+0xE098) & (_BIT1|_BIT0)) != (_BIT1|_BIT0)){
	Delay(1000);
        if(count ++ > 100)
            break;
    }
    //SysWriteHWReg((IMG_PVOID)REG_GPU_BASE, 0xE0a0, 0x0);
    rtd_maskl(REG_GPU_BASE+0xE0a0, ~(_BIT1|_BIT0), 0);

    //SysWriteHWReg((IMG_PVOID)REG_GPU_BASE, 0xE094, 0x3);
    rtd_setbits(REG_GPU_BASE+0xE094,(_BIT1));
    rtd_setbits(REG_GPU_BASE+0xE094,(_BIT0));

    //reg = SysReadHWReg((IMG_PVOID)REG_GPU_BASE, REG_GPU_CLKEN_OFF) | (_BIT0|_BIT1|_BIT2);
    //SysWriteHWReg((IMG_PVOID)REG_GPU_BASE, REG_GPU_CLKEN_OFF, reg);
    rtd_setbits(REG_GPU_BASE+REG_GPU_CLKEN_OFF,(_BIT0|_BIT1|_BIT2));

    //reg = SysReadHWReg((IMG_PVOID)REG_GPU_BASE, REG_GPU_ENDIAN_OFF) | (_BIT0);
    //SysWriteHWReg((IMG_PVOID)REG_GPU_BASE, REG_GPU_ENDIAN_OFF, reg);
    rtd_setbits(REG_GPU_BASE+REG_GPU_ENDIAN_OFF,(_BIT0));

    //reg = SysReadHWReg((IMG_PVOID)REG_GPU_BASE, REG_GPU_RESET_OFF) | (_BIT0);
    //SysWriteHWReg((IMG_PVOID)REG_GPU_BASE, REG_GPU_RESET_OFF, reg);
    rtd_setbits(REG_GPU_BASE+REG_GPU_RESET_OFF,(_BIT0));

    //rtd_outl(0xb80438c0,0);

    //rtd_outl(0xb80438c4,0x8882AF00);
#endif
}

IMG_VOID PDL_DefaultAssert(IMG_PUINT32 pui32Script)
{
    printf("GPU Test Fail !! \n");
    printf("GPU Test Fail !! \n");
    printf("GPU Test Fail !! \n");
    printf("GPU Test Fail !! \n");
	g_ret = IMG_FALSE;
	/* Add any specific error code here */
/* eg
    // Write error message to memory message window
    WriteMem( 0x47FFFFF0, 0xdead0bad );  
    // Write File ID to memory message window
    WriteMem( 0x47FFFFF4, pui32Script[1]);
    // Write Script Line No to memory message window
    WriteMem( 0x47FFFFF8, pui32Script[2]);
    exit -1;

*/
	//assert(0);
}

IMG_VOID PDL_DefaultSuccessExit(IMG_VOID)
{
#if 1
	int size,i;
	
	int golden_ptr_offset=5;
	
	if (pui8SABOutput)
	{
		outptr +=golden_ptr_offset;		
		size = outfb_size_to_verify / 4;
           
 
		for(i=0;i<size;i++){
			if(*(golden_ptr+i) != *(outptr+i)){
				printf(" *(%x)=%x  ",(golden_ptr+i),*(unsigned int *)(golden_ptr+i));
				printf(" *(%x)=%x \n",(outptr+i),*(unsigned int *)(outptr+i));
				printf("error:GPU compare data Failed!! \n");
				printf("GPU compare data Failed!! \n");
				g_ret = IMG_FALSE;
				break;
			}
		}

	}

        if(g_ret == IMG_TRUE)
        {
		printf("GPU compare data Success!! \n");
         }
#else
	int size,i;
	unsigned int *golden_ptr, *outptr;
	//if pui8SABOutput != 0, compare data
	if (pui8SABOutput)
	{
        printf("GPU compare data !! \n");
		golden_ptr = (unsigned int *)outfb_6;
		outptr = (unsigned int *)pui8SABOutput;
	    size = outfb_size_to_verify / 4;
	    for(i=10;i<size;i++){
			if(*(golden_ptr+i) != *(outptr+i)){
		        printf("GPU compare data Failed!! \n");
			}
		}
	printf("GPU compare data Success!! \n");
	}
#endif
    //printf("GPU Test Success !! \n");
	
    //printf("GPU Test Success !! \n");
	/* Add an appropriate implementation of "exit - success" here */
	/* eg
	WriteMem( 0x47FFFFF0, 0xdead0000 );
	*/
	//exit(0);
}

#endif /* EMU_TARGET */

/******************************************************************************/
/*                                                                            */
/*		Operation functions for internal register commands with 3 operands    */
/*																			  */
/******************************************************************************/

/* Function prototype */
typedef IMG_UINT64 (*PDL_pfnIntRegOpFunction)(IMG_UINT64 ui64Op1, IMG_UINT64 ui64Op2);

/* Common function used to process internal register commands with 3 operands */
#if defined(CONFIG_RTD287X_QC) || defined(CONFIG_RTD287XP_QC) || defined(CONFIG_RTD287X_23x23_QC)
IMG_VOID PDL_IntRegThreeOperandCmd(PDL_psScriptCB psScriptCB, PDL_pfnIntRegOpFunction pfnIntRegOpFunction, IMG_BOOL intRegOperand);
#else
IMG_VOID PDL_IntRegThreeOperandCmd(PDL_psScriptCB psScriptCB, PDL_pfnIntRegOpFunction pfnIntRegOpFunction);
#endif
IMG_UINT64 PDL_IntRegOpAND(IMG_UINT64 ui64Op1, IMG_UINT64 ui64Op2)
{
	return (ui64Op1 & ui64Op2);
}

IMG_UINT64 PDL_IntRegOpOR(IMG_UINT64 ui64Op1, IMG_UINT64 ui64Op2)
{
	return (ui64Op1 | ui64Op2);
}

IMG_UINT64 PDL_IntRegOpXOR(IMG_UINT64 ui64Op1, IMG_UINT64 ui64Op2)
{
	return (ui64Op1 ^ ui64Op2);
}

IMG_UINT64 PDL_IntRegOpSHR(IMG_UINT64 ui64Op1, IMG_UINT64 ui64Op2)
{
	return (ui64Op1 >> ui64Op2);
}

IMG_UINT64 PDL_IntRegOpSHL(IMG_UINT64 ui64Op1, IMG_UINT64 ui64Op2)
{
	return (ui64Op1 << ui64Op2);
}

IMG_UINT64 PDL_IntRegOpADD(IMG_UINT64 ui64Op1, IMG_UINT64 ui64Op2)
{
	return (ui64Op1 + ui64Op2);
}

IMG_UINT64 PDL_IntRegOpSUB(IMG_UINT64 ui64Op1, IMG_UINT64 ui64Op2)
{
	return (ui64Op1 - ui64Op2);
}

IMG_UINT64 PDL_IntRegOpMUL(IMG_UINT64 ui64Op1, IMG_UINT64 ui64Op2)
{
	return (ui64Op1 * ui64Op2);
}

IMG_UINT64 PDL_IntRegOpIMUL(IMG_UINT64 ui64Op1, IMG_UINT64 ui64Op2)
{
	return (IMG_UINT64)((IMG_UINT64)ui64Op1 * (IMG_UINT64)ui64Op2);
}

IMG_UINT64 PDL_IntRegOpDIV(IMG_UINT64 ui64Op1, IMG_UINT64 ui64Op2)
{
	return (ui64Op1 / ui64Op2);
}

IMG_UINT64 PDL_IntRegOpIDIV(IMG_UINT64 ui64Op1, IMG_UINT64 ui64Op2)
{
	return (IMG_UINT64)((IMG_UINT64)ui64Op1 / (IMG_UINT64)ui64Op2);
}

IMG_UINT64 PDL_IntRegOpMOD(IMG_UINT64 ui64Op1, IMG_UINT64 ui64Op2)
{
	return (ui64Op1 % ui64Op2);
}

IMG_UINT64 PDL_IntRegOpEQU(IMG_UINT64 ui64Op1, IMG_UINT64 ui64Op2)
{
	return (ui64Op1 == ui64Op2);
}

IMG_UINT64 PDL_IntRegOpLT(IMG_UINT64 ui64Op1, IMG_UINT64 ui64Op2)
{
	return (ui64Op1 < ui64Op2);
}

IMG_UINT64 PDL_IntRegOpLTE(IMG_UINT64 ui64Op1, IMG_UINT64 ui64Op2)
{
	return (ui64Op1 <= ui64Op2);
}

IMG_UINT64 PDL_IntRegOpGT(IMG_UINT64 ui64Op1, IMG_UINT64 ui64Op2)
{
	return (ui64Op1 > ui64Op2);
}

IMG_UINT64 PDL_IntRegOpGTE(IMG_UINT64 ui64Op1, IMG_UINT64 ui64Op2)
{
	return (ui64Op1 >= ui64Op2);
}

IMG_UINT64 PDL_IntRegOpNEQ(IMG_UINT64 ui64Op1, IMG_UINT64 ui64Op2)
{
	return (ui64Op1 != ui64Op2);
}

/******************************************************************************/
/*                                                                            */
/*		Script processing functions                                           */
/*																			  */
/******************************************************************************/
#if defined(CONFIG_RTD287X_QC) || defined(CONFIG_RTD287XP_QC) || defined(CONFIG_RTD287X_23x23_QC)
IMG_VOID PDL_NULL(PDL_psScriptCB psScriptCB)
{
	// Should never be run

	PDL_ASSERT(psScriptCB->pui32Script);
}
#endif
/********************/
/*		"WRW"		*/
/********************/
IMG_VOID PDL_WriteRegister(PDL_psScriptCB psScriptCB)
{
	/*
	psScriptCB->pui32Script[0]	=	"write register" (0x00000000)
	psScriptCB->pui32Script[1]	=	file id
	psScriptCB->pui32Script[2]	=	line number
	psScriptCB->pui32Script[3]	=	address
	psScriptCB->pui32Script[4]	=	value
	*/

	VERBOSE_OUTPUT(WRW_REG, psScriptCB->pui32Script);

	WriteReg(psScriptCB->pui32Script[3], psScriptCB->pui32Script[4]);
	
	/* Advance script pointer and exit */
	psScriptCB->pui32Script += 5;
}	

IMG_VOID PDL_WriteMemory(PDL_psScriptCB psScriptCB)
{
	/*
	psScriptCB->pui32Script[0]	=	"write memory" (0x00000001)
	psScriptCB->pui32Script[1]	=	file id
	psScriptCB->pui32Script[2]	=	line number
	psScriptCB->pui32Script[3]	=	address
	psScriptCB->pui32Script[4]	=	value
	*/
    
	VERBOSE_OUTPUT(WRW_MEM, psScriptCB->pui32Script);

	WriteMem(psScriptCB->pui32Script[3], psScriptCB->pui32Script[4]);
	
	/* Advance script pointer and exit */
	psScriptCB->pui32Script += 5;
}	

IMG_VOID PDL_WriteSlavePort(PDL_psScriptCB psScriptCB)
{
	/*
	psScriptCB->pui32Script[0]	=	"write slave port" (0x00000002)
	psScriptCB->pui32Script[1]	=	file id
	psScriptCB->pui32Script[2]	=	line number
	psScriptCB->pui32Script[3]	=	address
	psScriptCB->pui32Script[4]	=	value
	*/

	VERBOSE_OUTPUT(WRW_SLV, psScriptCB->pui32Script);

	PDL_ASSERT(psScriptCB->pui32Script); // Slave ports have been deprecated
	/* Advance script pointer and exit */
	psScriptCB->pui32Script += 5;
}

/********************/
/*		"RDW"		*/
/********************/
IMG_VOID PDL_ReadRegister(PDL_psScriptCB psScriptCB)
{
	IMG_UINT32 ui32Temp;
        IMG_UINT32 ui32PageDirBaseAddr;
  	IMG_UINT32 ui32PageTableBaseAddr;
 	IMG_UINT32 ui32FaultAddr;
        IMG_UINT32 ui32PageDirIndex;
        IMG_UINT32 ui32PageTableIndex;
	/*
	psScriptCB->pui32Script[0]	=	"read register" (0x00000003)
	psScriptCB->pui32Script[1]	=	file id
	psScriptCB->pui32Script[2]	=	line number
	psScriptCB->pui32Script[3]	=	address
	*/

	VERBOSE_OUTPUT(RDW_REG, psScriptCB->pui32Script);

	ReadReg(psScriptCB->pui32Script[3], &ui32Temp);
	//printf("Read SGX Register addr=0X%x  value=0X%x \n",psScriptCB->pui32Script[3],ui32Temp);
        if( psScriptCB->pui32Script[3] == 0x18040C50 )
        {
           printf("page directory 7 base addr: 0x%x \n", ui32Temp);
           ui32PageDirBaseAddr=ui32Temp & 0xFFFFFFF0;
           ReadReg(0x18040C08,&ui32Temp);
           if(ui32Temp)
	       {
           	ui32FaultAddr=ui32Temp & 0xFFFFF000;
           }
           else
           {
             	Delay(50000);
         	    ReadReg(0x18040C08,&ui32Temp);
                if(ui32Temp)
                {
                   printf("Delay to get EUR_BIF_FAULT value: 0x%x \n",ui32Temp);
                   ui32FaultAddr=ui32Temp & 0xFFFFF000;
				   g_ret=IMG_FALSE;
				   return;
                }
                else
                {
                   printf("hardcode EUR_BIF_FAULT value:\n");
                   ui32FaultAddr=0xF200D000;
				   g_ret=IMG_FALSE;
   				   return;
                }
           }
           ui32PageDirIndex = ui32FaultAddr >> 22;
           ui32PageTableIndex = (ui32FaultAddr & 0x003FF000) >> 12;
           ReadMem( ui32PageDirBaseAddr+ui32PageDirIndex*4 , &ui32Temp);
           printf("dump page dir entry addr: 0x%x value: 0x%x \n",ui32PageDirBaseAddr+ui32PageDirIndex*4,ui32Temp);
           ui32PageTableBaseAddr = ui32Temp & 0xFFFFF000;
           ReadMem( ui32PageTableBaseAddr+ui32PageTableIndex*4 , &ui32Temp);
           printf("dump page table entry addr: 0x%x value: 0x%x \n",ui32PageTableBaseAddr+ui32PageTableIndex*4,ui32Temp);
           Delay(50000);
           printf("Dump Dev virt addr 0xF200D000:\n");
           ui32FaultAddr=0xF200D000;
           ui32PageDirIndex = ui32FaultAddr >> 22;
           ui32PageTableIndex = (ui32FaultAddr & 0x003FF000) >> 12;
           ReadMem( ui32PageDirBaseAddr+ui32PageDirIndex*4 , &ui32Temp);
           printf("dump page dir entry addr: 0x%x value: 0x%x \n",ui32PageDirBaseAddr+ui32PageDirIndex*4,ui32Temp);
           ui32PageTableBaseAddr = ui32Temp & 0xFFFFF000;
           ReadMem( ui32PageTableBaseAddr+ui32PageTableIndex*4 , &ui32Temp);
           printf("dump page table entry addr: 0x%x value: 0x%x \n",ui32PageTableBaseAddr+ui32PageTableIndex*4,ui32Temp);
        }
	/* Advance script pointer and exit */
	psScriptCB->pui32Script += 4;
}	

IMG_VOID PDL_ReadMemory(PDL_psScriptCB psScriptCB)
{
	IMG_UINT32 ui32Temp;

	/*
	psScriptCB->pui32Script[0]	=	"read memory" (0x00000004)
	psScriptCB->pui32Script[1]	=	file id
	psScriptCB->pui32Script[2]	=	line number
	psScriptCB->pui32Script[3]	=	address
	*/

	VERBOSE_OUTPUT(RDW_MEM, psScriptCB->pui32Script);

	ReadMem(psScriptCB->pui32Script[3], &ui32Temp);
	
	/* Advance script pointer and exit */
	psScriptCB->pui32Script += 4;
}	

/********************/
/*		"POL"		*/
/********************/
typedef enum
{
	PDL_POLL_REG,
	PDL_POLL_REG64,
	PDL_POLL64_REG64,
	PDL_POLL_MEM,
	PDL_POLL_MEM64,
	PDL_POLL64_MEM64
} PDL_ePollTarget;

IMG_VOID PDL_Poll(PDL_psScriptCB psScriptCB, PDL_ePollTarget ePollTarget)
{
	IMG_UINT64  ui64Temp;
	IMG_UINT64  ui64FoxTemp;
	IMG_UINT32  ui32Temp;
	IMG_BOOL    bContinuePolling	= IMG_TRUE;
	IMG_BOOL	bPollCountExceeded	= IMG_FALSE;
	IMG_BOOL	bPollFailed			= IMG_TRUE;
	IMG_UINT64	ui64Address = 0;
	IMG_UINT64	ui64RequiredValue = 0;
	IMG_UINT64	ui64EnableMask = 0;
	IMG_UINT32	ui32Address = 0;
	IMG_UINT32	ui32CheckFuncId = 0;
	IMG_UINT32	ui32PollCount = 0;
	IMG_UINT32	ui32Delay = 0;

        IMG_UINT32 ui32FoxTemp;
        IMG_UINT8  ui8Temp0;
        IMG_UINT8  ui8Temp1;
        IMG_UINT8  ui8Temp2;
        IMG_UINT8  ui8Temp3;
        IMG_UINT8  ui8Temp4;
        IMG_UINT8  ui8Temp5;
        IMG_UINT8  ui8Temp6;
        IMG_UINT8  ui8Temp7;
        IMG_UINT8  ui8Temp8;
        IMG_UINT8  ui8Temp9;
        IMG_UINT8  ui8Temp10;
        IMG_UINT8  ui8Temp11;
        IMG_UINT8  ui8Temp12;
        IMG_UINT8  ui8Temp13;
        IMG_UINT8  ui8Temp14;
        IMG_UINT8  ui8Temp15;
        IMG_PUINT8 ui8StartAddr;
        static IMG_UINT32 ui32DumpCnt = 0;
	/*
	psScriptCB->pui32Script[0]	=	"poll register" (0x00000005)
	psScriptCB->pui32Script[1]	=	file id
	psScriptCB->pui32Script[2]	=	line number
	psScriptCB->pui32Script[3]	=	address
	psScriptCB->pui32Script[4]	=	required value
	psScriptCB->pui32Script[5]	=	enable mask
	psScriptCB->pui32Script[6]	=	check function id
	psScriptCB->pui32Script[7]	=	poll count
	psScriptCB->pui32Script[8]	=	delay
	*/
	ui64FoxTemp = 0x1122334455667788;
	ui64FoxTemp -= 0x22;

    //printf("func=%s line=%d ..... ePollTarget=%d ui64FoxTemp=%08x%08x\n",__FUNCTION__,__LINE__,ePollTarget,HI32(ui64FoxTemp),LO32(ui64FoxTemp));
	switch (ePollTarget)
	{
		case PDL_POLL64_MEM64:
		case PDL_POLL64_REG64:
			ui64Address			= ADDR64(psScriptCB->pui32Script[3]);
			ui64RequiredValue	= DATA64(psScriptCB->pui32Script[5]);
			ui64EnableMask		= DATA64(psScriptCB->pui32Script[7]);
			ui32CheckFuncId		= psScriptCB->pui32Script[9];
			ui32PollCount		= psScriptCB->pui32Script[10];
			ui32Delay			= psScriptCB->pui32Script[11];
			break;		
		case PDL_POLL_MEM64:
		case PDL_POLL_REG64:
			ui64Address			= ADDR64(psScriptCB->pui32Script[3]);
			ui64RequiredValue	= psScriptCB->pui32Script[5];
			ui64EnableMask		= psScriptCB->pui32Script[6];
			ui32CheckFuncId		= psScriptCB->pui32Script[7];
			ui32PollCount		= psScriptCB->pui32Script[8];
			ui32Delay			= psScriptCB->pui32Script[9];
			break;
			
		case PDL_POLL_MEM:
		case PDL_POLL_REG:
			ui64Address			= psScriptCB->pui32Script[3];
			ui64RequiredValue	= psScriptCB->pui32Script[4];
			ui64EnableMask		= psScriptCB->pui32Script[5];
			ui32CheckFuncId		= psScriptCB->pui32Script[6];
			ui32PollCount		= psScriptCB->pui32Script[7];
			ui32Delay			= psScriptCB->pui32Script[8];
			break;
		default:
			PDL_ASSERT(psScriptCB->pui32Script);
            break;
	}

	/* Is this the first time we execute this POLL command? */
	if (!psScriptCB->bPollPending)
	{
		psScriptCB->bPollPending = IMG_TRUE;
		psScriptCB->ui32LoopCount = 0;
		psScriptCB->ui32Delay = ui32Delay;
	}

	ui64RequiredValue &= ui64EnableMask;

	ui64Temp = ~ui64RequiredValue;
    //printf("func=%s line=%d ..... ui64RequiredValue=%08x%08x ui64Temp=%08x%08x ui64Address=%08x%08x\n",__FUNCTION__,__LINE__,HI32(ui64RequiredValue),LO32(ui64RequiredValue),HI32(ui64Temp),LO32(ui64Temp),HI32(ui64Address),LO32(ui64Address));	
	
	while (bContinuePolling)
	{
		switch(ePollTarget)
		{
            case PDL_POLL_REG:
            case PDL_POLL_REG64:
                ReadReg(ui64Address, &ui32Temp);
                ui64Temp = ui32Temp;
                break;
            case PDL_POLL64_REG64:
                ReadReg64(ui64Address, &ui64Temp);
                break;
            case PDL_POLL_MEM:
            case PDL_POLL_MEM64:
                ReadMem(ui64Address, &ui32Temp);
				ui32Address = ui64Address;
				ReadMemLog(ui32Address, &ui32Temp);
		        //printf("func=%s line=%d ..... ui32Temp=%x ui64Address=%08x%08x ui32Address=%08x\n",__FUNCTION__,__LINE__,ui32Temp,HI32(ui64Address),LO32(ui64Address),ui32Address);	
                ui64Temp = ui32Temp;
                break;
            case PDL_POLL64_MEM64:
                ReadMem64(ui64Address, &ui64Temp);
                break;
		}

		ui64Temp &= ui64EnableMask;
        
                //printf("func=%s line=%d ..... ui64RequiredValue=%08x%08x ui64Temp=%08x%08x\n",__FUNCTION__,__LINE__,HI32(ui64RequiredValue),LO32(ui64RequiredValue),HI32(ui64Temp),LO32(ui64Temp));	
		//printf("func=%s line=%d ..... ui32CheckFuncId=%d\n",__FUNCTION__,__LINE__,ui32CheckFuncId);	
		switch (ui32CheckFuncId)
		{
			case PDL_CHECK_FUNC_EQ:
			{
				//printf("func=%s line=%d ui64Temp=%llx ui64RequiredValue=%llx\n",__FUNCTION__,__LINE__,ui64Temp,ui64RequiredValue);
				if (ui64Temp == ui64RequiredValue)
				{
					bContinuePolling = IMG_FALSE;
					bPollFailed = IMG_FALSE;
				}
                                else
                                {
                                  #if 0
     				               ReadReg(0x18040C08,&ui32FoxTemp);
                                   printf("check BIF_FAULT value:0x%x\n",ui32FoxTemp);
								   if(ui32FoxTemp != 0)
								   {
									   PDL_ASSERT(0);
									   g_ret = IMG_FALSE;
									   return;
								   }
								   if(BIF_count ++ > 30){
									   g_ret = IMG_FALSE;
									   return;
								   }
                                   ReadReg(0X18040B10,&ui32FoxTemp);
                                   printf("check USE0_SERV_EVENT value:0x%x\n",ui32FoxTemp);
                                #endif
                                   if(ui32DumpCnt)
                                   {
                                      ui8StartAddr = 0X7000000;							  
                                      while( ui8StartAddr <= 0x7015200 )
                                      {
                                        ReadMemByte(ui8StartAddr,&ui8Temp0);
					ReadMemByte(ui8StartAddr+1,&ui8Temp1);
                                        ReadMemByte(ui8StartAddr+2,&ui8Temp2);
					ReadMemByte(ui8StartAddr+3,&ui8Temp3);
                                        ReadMemByte(ui8StartAddr+4,&ui8Temp4);
					ReadMemByte(ui8StartAddr+5,&ui8Temp5);
                                        ReadMemByte(ui8StartAddr+6,&ui8Temp6);
					ReadMemByte(ui8StartAddr+7,&ui8Temp7);
                                        ReadMemByte(ui8StartAddr+8,&ui8Temp8);
					ReadMemByte(ui8StartAddr+9,&ui8Temp9);
                                        ReadMemByte(ui8StartAddr+10,&ui8Temp10);
					ReadMemByte(ui8StartAddr+11,&ui8Temp11);
                                        ReadMemByte(ui8StartAddr+12,&ui8Temp12);
					ReadMemByte(ui8StartAddr+13,&ui8Temp13);
                                        ReadMemByte(ui8StartAddr+14,&ui8Temp14);
					ReadMemByte(ui8StartAddr+15,&ui8Temp15);
                                        printf("0x%x: 0x%x 0x%x 0x%x 0x%x 0x%x 0x%x 0x%x 0x%x 0x%x 0x%x 0x%x 0x%x 0x%x 0x%x 0x%x 0x%x\n",ui8StartAddr
                                        ,ui8Temp0,ui8Temp1,ui8Temp2,ui8Temp3,ui8Temp4,ui8Temp5,ui8Temp6,ui8Temp7
                                        ,ui8Temp8,ui8Temp9,ui8Temp10,ui8Temp11,ui8Temp12,ui8Temp13,ui8Temp14,ui8Temp15);
                                        ui8StartAddr+=0x10;
                                      }
                                      ui32DumpCnt-=1;
                                   }
                    
                                }
				break;
			}
			case PDL_CHECK_FUNC_LT:
			{
				if (ui64Temp < ui64RequiredValue)
				{
					bContinuePolling = IMG_FALSE;
					bPollFailed = IMG_FALSE;
				}
				break;
			}
			case PDL_CHECK_FUNC_LE:
			{
				if (ui64Temp <= ui64RequiredValue)
				{
					bContinuePolling = IMG_FALSE;
					bPollFailed = IMG_FALSE;
				}
				break;
			}
			case PDL_CHECK_FUNC_GT:
			{
				if (ui64Temp > ui64RequiredValue)
				{
					bContinuePolling = IMG_FALSE;
					bPollFailed = IMG_FALSE;
				}
				break;
			}
			case PDL_CHECK_FUNC_GE:
			{
				if (ui64Temp >= ui64RequiredValue)
				{
					bContinuePolling = IMG_FALSE;
					bPollFailed = IMG_FALSE;
				}
				break;
			}
			case PDL_CHECK_FUNC_NE:
			{
				if (ui64Temp != ui64RequiredValue)
				{
					bContinuePolling = IMG_FALSE;
					bPollFailed = IMG_FALSE;
				}
				break;
			}
			default:
			{
				ERROR_OUTPUT("Unrecognised Function Id\n");
				PDL_ASSERT(psScriptCB->pui32Script);
                break;
			}
		}

		/* Still going? */
		if (bContinuePolling)
		{
			psScriptCB->ui32LoopCount++;
 			
			/* have we exceeded the POL Count */
			if ((psScriptCB->ui32LoopCount >= ui32PollCount) && (ui32PollCount != PDL_POLLCOUNT_INFINITE))
			{
				bPollCountExceeded = IMG_TRUE;
				bContinuePolling = IMG_FALSE;
			}
			/* If the number of scripts is more than 1 then we do not continue polling */
			else if (gui32NumScripts > 1)
			{
				bPollCountExceeded = IMG_FALSE;
				bContinuePolling = IMG_FALSE;
			}
			else if (ui32Delay)
            {
                Delay(ui32Delay);
            }
		}
	}	
    //printf("func=%s line=%d ..... \n",__FUNCTION__,__LINE__);
	if (bPollFailed && !bPollCountExceeded)
	{
                //printf("func=%s line=%d bPollFailed ..... \n",__FUNCTION__,__LINE__);
		/* Reset the time count to 0 */
		psScriptCB->ui32TimeCount = 0;
		/* We do not advance the script - it will be parsed again on next call to this function */
	}
	else
	{
		if (bPollFailed)
		{
                //printf("func=%s line=%d bPollFailed==1 ..... \n",__FUNCTION__,__LINE__);
			ERROR_OUTPUT("Poll Failed\n");
			PDL_ASSERT(psScriptCB->pui32Script);
		}
		
		/* Ready to move on */
		psScriptCB->bPollPending = IMG_FALSE;

		/* Advance script pointer and exit */
		switch (ePollTarget)
		{
			case PDL_POLL64_MEM64:
			case PDL_POLL64_REG64:
				psScriptCB->pui32Script += 12;
				break;
			case PDL_POLL_MEM64:
			case PDL_POLL_REG64:
				psScriptCB->pui32Script += 10;
				break;
			case PDL_POLL_MEM:
			case PDL_POLL_REG:
				psScriptCB->pui32Script += 9;
                break;
		}
	}

}

IMG_VOID PDL_PollRegister(PDL_psScriptCB psScriptCB)
{
	if (!psScriptCB->bPollPending)
		VERBOSE_OUTPUT(POL_REG, psScriptCB->pui32Script);
	
	PDL_Poll( psScriptCB, PDL_POLL_REG );
}	

IMG_VOID PDL_PollMemory(PDL_psScriptCB psScriptCB)
{
	if (!psScriptCB->bPollPending)
		VERBOSE_OUTPUT(POL_MEM, psScriptCB->pui32Script);
	
	PDL_Poll( psScriptCB, PDL_POLL_MEM );
}	

/********************/
/*		"LDW/B"		*/
/********************/
IMG_VOID PDL_LoadBytesToMemory(PDL_psScriptCB psScriptCB)
{
	IMG_UINT32 ui32DataSize = psScriptCB->pui32Script[4];

	/*
	psScriptCB->pui32Script[0]	=	"load bytes to memory" (0x00000007)
	psScriptCB->pui32Script[1]	=	file id
	psScriptCB->pui32Script[2]	=	line number
	psScriptCB->pui32Script[3]	=	address
	psScriptCB->pui32Script[4]	=	size (in bytes)
	psScriptCB->pui32Script[5]	=	data[1], data[2], data[3], data[4],
	psScriptCB->pui32Script[6]	=	data[5], data[6], data[7], data[8],
	...
	...
	*/

	VERBOSE_OUTPUT(LDB_MEM, psScriptCB->pui32Script);
	
	CopyMem(psScriptCB->pui32Script[3], &psScriptCB->pui32Script[5], ui32DataSize);

	/* Advance script pointer and exit (round byte count up and convert to word count)  */
	ui32DataSize += 3;
	ui32DataSize >>= 2;
	psScriptCB->pui32Script += (5 + ui32DataSize);
}	

IMG_VOID PDL_LoadWordsToRegister(PDL_psScriptCB psScriptCB)
{
	IMG_UINT32 ui32Address = psScriptCB->pui32Script[3];
	IMG_UINT32 ui32DataSize = psScriptCB->pui32Script[4];
	IMG_UINT32 i, j;

	/*
	psScriptCB->pui32Script[0]	=	"load words to register" (0x00000008)
	psScriptCB->pui32Script[1]	=	file id
	psScriptCB->pui32Script[2]	=	line number
	psScriptCB->pui32Script[3]	=	address
	psScriptCB->pui32Script[4]	=	size
	psScriptCB->pui32Script[5]	=	data[1]
	psScriptCB->pui32Script[6]	=	data[2]
	...
	...
	psScriptCB->pui32Script[size + 2 ]	=	data[size]
	
	*/

	VERBOSE_OUTPUT(LDW_REG, psScriptCB->pui32Script);
	
	for (i = 0, j = 5; i < ui32DataSize; i++, j++)
		WriteReg((ui32Address + i * sizeof(IMG_UINT32)), psScriptCB->pui32Script[j]);

	/* Advance script pointer and exit */
	psScriptCB->pui32Script += (5 + ui32DataSize);
}	

IMG_VOID PDL_LoadWordsToSlavePort(PDL_psScriptCB psScriptCB)
{
	IMG_UINT32 ui32Address = psScriptCB->pui32Script[3];
	IMG_UINT32 ui32DataSize = psScriptCB->pui32Script[4];
	IMG_UINT32 i, j;

	/*
	psScriptCB->pui32Script[0]	=	"load words to slave port" (0x00000009)
	psScriptCB->pui32Script[1]	=	file id
	psScriptCB->pui32Script[2]	=	line number
	psScriptCB->pui32Script[3]	=	address
	psScriptCB->pui32Script[4]	=	size
	psScriptCB->pui32Script[5]	=	data[1]
	psScriptCB->pui32Script[6]	=	data[2]
	...
	...
	psScriptCB->pui32Script[size + 2 ]	=	data[size]
	
	*/

	VERBOSE_OUTPUT(LDW_SLV, psScriptCB->pui32Script);
	
	for (i = 0, j = 5; i < ui32DataSize; i++, j++)
		WriteReg((ui32Address + i * sizeof(IMG_UINT32)), psScriptCB->pui32Script[j]);

	/* Advance script pointer and exit */
	psScriptCB->pui32Script += (5 + ui32DataSize);
}	
#if defined(CONFIG_RTD287X_QC) || defined(CONFIG_RTD287XP_QC) || defined(CONFIG_RTD287X_23x23_QC)
IMG_VOID PDL_FillMem(PDL_psScriptCB psScriptCB)
{
	/*
	psScriptCB->pui32Script[0]	=	"fill memory" (0x00000042)
	psScriptCB->pui32Script[1]	=	file id
	psScriptCB->pui32Script[2]	=	line number
	psScriptCB->pui32Script[3]	=	address
    psScriptCB->pui32Script[4]	=	byte
	psScriptCB->pui32Script[5]	=	size (in bytes)
	*/

	VERBOSE_OUTPUT(FILL_MEM, psScriptCB->pui32Script);
	
	FillMem(psScriptCB->pui32Script[3], (IMG_UINT8)psScriptCB->pui32Script[4],
			psScriptCB->pui32Script[5]);
    
	/* Advance script pointer and exit */
	psScriptCB->pui32Script += 6;
}
#endif
/********************/
/*		"IDL"		*/
/********************/
IMG_VOID PDL_Idle(PDL_psScriptCB psScriptCB)
{
	/*
	psScriptCB->pui32Script[0]	=	"idle" (0x0000000A)
	psScriptCB->pui32Script[1]	=	file id
	psScriptCB->pui32Script[2]	=	line number
	psScriptCB->pui32Script[3]	=	idle cycle count
	*/

	VERBOSE_OUTPUT(IDL, psScriptCB->pui32Script);
	
	Delay(psScriptCB->pui32Script[3]);

	/* Advance script pointer and exit */
	psScriptCB->pui32Script += 4;
}	

/********************/
/*		"CBP"		*/
/********************/
IMG_VOID PDL_MemCircularBufferPoll(PDL_psScriptCB psScriptCB)
{
	IMG_UINT32 ui32RoffAddr			  = psScriptCB->pui32Script[3];
	IMG_UINT32 ui32WoffValue		  = psScriptCB->pui32Script[4];
	IMG_UINT32 ui32RequiredPacketSize = psScriptCB->pui32Script[5];
	IMG_UINT32 ui32CircularBufferSize = psScriptCB->pui32Script[6];
    IMG_UINT32 ui32RoffValue;
	IMG_UINT32 ui32FreeSpace;
	IMG_BOOL bContinue                = IMG_TRUE;
	IMG_BOOL bCBPCompleted            = IMG_FALSE;	

	/*
	psScriptCB->pui32Script[0]	=	"circular buffer poll" (0x0000000B)
	psScriptCB->pui32Script[1]	=	file id
	psScriptCB->pui32Script[2]	=	line number
	psScriptCB->pui32Script[3]	=	read offset address
	psScriptCB->pui32Script[4]	=	write offset value
	psScriptCB->pui32Script[5]	=	required packet size
	psScriptCB->pui32Script[6]	=	circular buffer size
	*/

	/* Is this the first time we execute this CBP command? */
	if (!psScriptCB->bPollPending)
	{
		psScriptCB->bPollPending = IMG_TRUE;
		psScriptCB->ui32LoopCount = 0;
		psScriptCB->ui32Delay = 10;

		VERBOSE_OUTPUT(CBP_MEM, psScriptCB->pui32Script);
	}

	while (bContinue)
	{
		ReadMem(ui32RoffAddr, &ui32RoffValue);

		if (ui32RoffValue > ui32WoffValue)
			ui32FreeSpace = ui32RoffValue - ui32WoffValue - 1;
		else
			ui32FreeSpace = (ui32RoffValue - ui32WoffValue) + (ui32CircularBufferSize - 1);
		
		if (ui32FreeSpace >= ui32RequiredPacketSize)
		{
			bCBPCompleted = IMG_TRUE;
			bContinue = IMG_FALSE;
		}
		else if (gui32NumScripts > 1)
		{
			bCBPCompleted = IMG_FALSE;
			bContinue = IMG_FALSE;
		}
	}
	
	if (!bCBPCompleted)
	{
		/* Reset the time count to 0 */
		psScriptCB->ui32TimeCount = 0;
	}
	else
	{
		/* Ready to move on */
		psScriptCB->bPollPending = IMG_FALSE;

		/* Advance script pointer and exit */
		psScriptCB->pui32Script += 7;
	}
}

IMG_VOID PDL_RegCircularBufferPoll(PDL_psScriptCB psScriptCB)
{
	IMG_UINT32 ui32RoffAddr			  = psScriptCB->pui32Script[3];
	IMG_UINT32 ui32WoffValue		  = psScriptCB->pui32Script[4];
	IMG_UINT32 ui32RequiredPacketSize = psScriptCB->pui32Script[5];
	IMG_UINT32 ui32CircularBufferSize = psScriptCB->pui32Script[6];
    IMG_UINT32 ui32RoffValue;
	IMG_UINT32 ui32FreeSpace;
	IMG_BOOL   bContinue			  = IMG_TRUE;
	IMG_BOOL   bCBPCompleted		  = IMG_FALSE;
    
	/*
	psScriptCB->pui32Script[0]	=	"circular buffer poll" (0x0000000B)
	psScriptCB->pui32Script[1]	=	file id
	psScriptCB->pui32Script[2]	=	line number
	psScriptCB->pui32Script[3]	=	read offset address
	psScriptCB->pui32Script[4]	=	write offset value
	psScriptCB->pui32Script[5]	=	required packet size
	psScriptCB->pui32Script[6]	=	circular buffer size
	*/

	/* Is this the first time we execute this CBP command? */
	if (!psScriptCB->bPollPending)
	{
		psScriptCB->bPollPending = IMG_TRUE;
		psScriptCB->ui32LoopCount = 0;
		psScriptCB->ui32Delay = 10;

		VERBOSE_OUTPUT(CBP_REG, psScriptCB->pui32Script);
	}

	while (bContinue)
	{
		ReadReg(ui32RoffAddr, &ui32RoffValue);

		if (ui32RoffValue > ui32WoffValue)
			ui32FreeSpace = ui32RoffValue - ui32WoffValue - 1;
		else
			ui32FreeSpace = (ui32RoffValue - ui32WoffValue) + (ui32CircularBufferSize - 1);

		if (ui32FreeSpace >= ui32RequiredPacketSize)
		{
			bCBPCompleted = IMG_TRUE;
			bContinue = IMG_FALSE;
		}
		else if (gui32NumScripts > 1)
		{
			bCBPCompleted = IMG_FALSE;
			bContinue = IMG_FALSE;
		}
	}

	if (!bCBPCompleted)
	{
		/* Reset the time count to 0 */
		psScriptCB->ui32TimeCount = 0;
	}
	else
	{
		/* Ready to move on */
		psScriptCB->bPollPending = IMG_FALSE;

		/* Advance script pointer and exit */
		psScriptCB->pui32Script += 7;
	}
}

/******************************************************************************/
/*                                                                            */
/*		Synchronisation Commands                                              */
/*																			  */
/******************************************************************************/
IMG_VOID PDL_Sync(PDL_psScriptCB psScriptCB)
{
	IMG_UINT32     ui32SyncId = psScriptCB->pui32Script[3];
	PDL_psTestCB   psTestCB = &asTestCB[psScriptCB->ui32TestId - 1];
	PDL_psScriptCB psScriptItrCB;
	IMG_UINT32     ui32SysSyncId;
	IMG_BOOL       bEnableSyncs = IMG_TRUE;
	
	/*
	psScriptCB->pui32Script[0]	=	"sync" (0x00000025)
	psScriptCB->pui32Script[1]	=	file id
	psScriptCB->pui32Script[2]	=	line number
	psScriptCB->pui32Script[3]	=	sync id
	*/

	VERBOSE_OUTPUT(SYNC, psScriptCB->pui32Script);

	/*Check for a valid Sync Id */
	if (ui32SyncId >= NO_SYSSYNC_IDS)
	{
		PDL_ASSERT(psScriptCB->pui32Script);
	}

	if (ui32SyncId > 31)
	{
		ui32SysSyncId = psTestCB->aui32SystemSyncId[ui32SyncId];
		
		/* If the inter sync does not already have a system sync Id it is not active */
		if (ui32SysSyncId >= MAX_SYNC_IDS)
		{
			IMG_UINT32 ui32TestIdIndex;

			/* Test to see if all inter-syncs are waiting */
			for(ui32TestIdIndex = 0; ui32TestIdIndex < gui32NumTests; ui32TestIdIndex++)
			{	
				PDL_psTestCB psTestItrCB = &asTestCB[ui32TestIdIndex];

				/* Ignore the current test */
				if ( psTestItrCB != psTestCB )
				{
					IMG_UINT32 i;

					for (i = 32; i < NO_SYSSYNC_IDS; i++)
					{
						/* Look for a matching System Sync Id */
						if (psTestItrCB->aui32SystemSyncId[i] == ui32SysSyncId)
						{
							IMG_UINT32 ui32ScriptIdIndex;

							for (ui32ScriptIdIndex = 0; ui32ScriptIdIndex < gui32NumScripts; ui32ScriptIdIndex++)
							{
								psScriptItrCB = &asScriptCB[ui32ScriptIdIndex];

								/* If one of the files from this test is waiting on this sync */
								if (psScriptItrCB->bWaiting &&
                                    (psScriptItrCB->ui32TestId == (ui32TestIdIndex + 1)) &&
                                    (psScriptItrCB->ui32SyncWaiting == ui32SysSyncId))
								{
									/* It should not be possible for these to be the same file */
									if ( psScriptCB == psScriptItrCB )
										PDL_ASSERT( psScriptCB->pui32Script );
									break;
								}
							}
							/* If the test above did not find an active sync then we must still wait for that sync */
							if (ui32ScriptIdIndex >= gui32NumScripts)
							{
								bEnableSyncs = IMG_FALSE;
								break;
							}
						}
					}
				}
				/* If we can't enable the syncs we don't need to keep checking */
				if (!bEnableSyncs)
					break;
			}
		}
	}
	else /* Check for intra-syncs */
	{
		IMG_UINT32 ui32ScriptIdIndex;

		ui32SysSyncId = GetSysSyncId( psScriptCB, ui32SyncId );

		for (ui32ScriptIdIndex = 0; ui32ScriptIdIndex < gui32NumScripts; ui32ScriptIdIndex++)
		{
			psScriptItrCB = &asScriptCB [ui32ScriptIdIndex];

			/* If it is one of the files from this test and this sync is enabled */
			if ((psScriptItrCB->ui32TestId == psScriptCB->ui32TestId) &&
                ((psScriptItrCB->ui32DisabledSyncs & (1 << ui32SyncId)) == 0) &&
                (psScriptItrCB != psScriptCB) )
			{
				/* If this script is not waiting on the same sync then we can't enable the syncs */
				if (psScriptItrCB->bWaiting == IMG_FALSE ||
                    (psScriptItrCB->ui32SyncWaiting != ui32SysSyncId ) )
				{
					bEnableSyncs = IMG_FALSE;
					break;
				}
			}
		}
	}	

	/* If all the syncs have called they can all be enabled */
	if (bEnableSyncs)
	{
		IMG_UINT32 ui32ScriptIdIndex = 0;

		for (ui32ScriptIdIndex = 0; (ui32ScriptIdIndex < gui32NumScripts) && (ui32SysSyncId >= MAX_SYNC_IDS); ui32ScriptIdIndex++)
		{
			psScriptItrCB = &asScriptCB[ui32ScriptIdIndex];

			if (psScriptItrCB->ui32SyncWaiting == ui32SysSyncId)
			{
				/* This sync must be waiting */
				if (psScriptItrCB->bWaiting != IMG_TRUE)
					PDL_ASSERT(psScriptCB->pui32Script);
				
				/* Enable this file */
				psScriptItrCB->bWaiting = IMG_FALSE;
				psScriptItrCB->ui32SyncWaiting = 0;
			}
		}
	}
	else
	{
		psScriptCB->ui32SyncWaiting = ui32SysSyncId;
		psScriptCB->bWaiting = IMG_TRUE;
	}

	psScriptCB->pui32Script += 4;
}

IMG_VOID PDL_Lock(PDL_psScriptCB psScriptCB)
{
	PDL_psTestCB psTestCB = &asTestCB[psScriptCB->ui32TestId - 1];
	IMG_UINT32 ui32SemaId = psScriptCB->pui32Script[3];

	/*
	psScriptCB->pui32Script[0]	=	"lock" (0x00000026)
	psScriptCB->pui32Script[1]	=	file id
	psScriptCB->pui32Script[2]	=	line number
	psScriptCB->pui32Script[3]	=	semaphore id
	*/

	VERBOSE_OUTPUT(LOCK, psScriptCB->pui32Script);
	
	if (ui32SemaId >= MAX_SEMAPHORES)
	{
		PDL_ASSERT(psScriptCB->pui32Script);
		return;
	}
		
	if (psTestCB->ai32Semaphores[ui32SemaId] <= 0)
	{
		/* Wait for Unlock */
		psScriptCB->bWaiting = IMG_TRUE;
		psScriptCB->ui32SemaWaiting = ui32SemaId;
	}

	psTestCB->ai32Semaphores[ui32SemaId]--;

	psScriptCB->pui32Script += 4;
}


IMG_VOID PDL_Unlock(PDL_psScriptCB psScriptCB)
{
	PDL_psTestCB psTestCB = &asTestCB[psScriptCB->ui32TestId - 1];
	IMG_UINT32 ui32SemaId = psScriptCB->pui32Script[3];

	/*
	psScriptCB->pui32Script[0]	=	"unlock" (0x00000027)
	psScriptCB->pui32Script[1]	=	file id
	psScriptCB->pui32Script[2]	=	line number
	psScriptCB->pui32Script[3]	=	semaphore id
	*/

	VERBOSE_OUTPUT(UNLOCK, psScriptCB->pui32Script);

	if (psTestCB->ai32Semaphores[ui32SemaId] < 0)
	{
		IMG_UINT32	ui32Index;
		
		/* unlock one file */
		for (ui32Index = 0; ui32Index < gui32NumScripts; ui32Index++)
		{
			PDL_psScriptCB psScriptItrCB = &asScriptCB[ui32Index];

			if ((psScriptItrCB->ui32TestId == psScriptCB->ui32TestId) && psScriptItrCB->bWaiting && (psScriptItrCB->ui32SemaWaiting == ui32SemaId))
			{
				psScriptItrCB->ui32SemaWaiting = 0;
				psScriptItrCB->bWaiting = IMG_FALSE;
				break;
			}
		}
	}
	
	psTestCB->ai32Semaphores[ui32SemaId]++;

	psScriptCB->pui32Script += 4;
}

// Padding command, this command does nothing
IMG_VOID PDL_Padding(PDL_psScriptCB psScriptCB)
{
    psScriptCB->pui32Script++;
}

// SAB command, by default this command does nothing
IMG_VOID PDL_SaveBytesFromMemory(PDL_psScriptCB psScriptCB)
{	
        //printf("PDL_SaveBytesFromMemory addr=%x size=%d\n",psScriptCB->pui32Script[3],psScriptCB->pui32Script[4]);
	/*
	psScriptCB->pui32Script[0]	=	"Save Bytes" (0x00000031)
	psScriptCB->pui32Script[1]	=	file id
	psScriptCB->pui32Script[2]	=	line number
	psScriptCB->pui32Script[3]	=	address
	psScriptCB->pui32Script[4]	=	size
	*/
	VERBOSE_OUTPUT(SAB_MEM, psScriptCB->pui32Script);

	// This block of code generates an area of memory which contains all the SAB and SII dumps
	// This area of memory can be dumped to a binary file which the PdumpExtractImage tool can interpret
	if (pui8SABOutput)
	{
		// if this is a new SAB line in the original pdump,
		// add a header of the 0x31 SAB id, file id, line number and size to the save mem area
		if (psScriptCB->ui32SabFileID != psScriptCB->pui32Script[1] ||
            psScriptCB->ui32SabLineNum != psScriptCB->pui32Script[2])
        {
			#if defined(CONFIG_RTD287X_QC) || defined(CONFIG_RTD287XP_QC) || defined(CONFIG_RTD287X_23x23_QC)
			if ((IMG_UINTPTR)pui8SABOutput & 0x3)
            {
                IMG_UINT32 skipbytes = 4 - ((IMG_UINTPTR)pui8SABOutput & 0x3);
                *pui32SABOrigin += skipbytes;
                pui8SABOutput += skipbytes; // skip to 4 byte alignment
            }
			#else
			pui8SABOutput = (IMG_PUINT8)(((IMG_UINTPTR)pui8SABOutput + 3) & ~0x3); // skip to 4 byte alignment
			#endif
#ifdef EMU_TARGET
            EmuSaveMemFlush();
#endif
            *(IMG_PUINT32)pui8SABOutput = psScriptCB->pui32Script[0];
            pui8SABOutput += sizeof(IMG_UINT32);
            *(IMG_PUINT32)pui8SABOutput = psScriptCB->pui32Script[1];
            pui8SABOutput += sizeof(IMG_UINT32);
            *(IMG_PUINT32)pui8SABOutput = psScriptCB->pui32Script[2];
            pui8SABOutput += sizeof(IMG_UINT32);
            psScriptCB->ui32SabFileID = psScriptCB->pui32Script[1];
            psScriptCB->ui32SabLineNum = psScriptCB->pui32Script[2];
            
            // Create a size variable as the fourth header number
            psScriptCB->pui32SabSize = (IMG_PUINT32)pui8SABOutput;
            psScriptCB->ui32SabSize = 0;
            *psScriptCB->pui32SabSize = psScriptCB->ui32SabSize;
            pui8SABOutput += sizeof(IMG_UINT32);
			*pui32SABOrigin += 4 * sizeof(IMG_UINT32);
        }
        
        // Copy the SAB data into the save mem area
        //printf("PDL_SaveBytesFromMemory pui8SABOutput=%x \n",pui8SABOutput);

        SaveMem(pui8SABOutput, psScriptCB->pui32Script[3], psScriptCB->pui32Script[4]);
        pui8SABOutput += psScriptCB->pui32Script[4];
		*pui32SABOrigin += psScriptCB->pui32Script[4];
        psScriptCB->ui32SabSize += psScriptCB->pui32Script[4];
        *psScriptCB->pui32SabSize = psScriptCB->ui32SabSize;

	}
    
    psScriptCB->pui32Script += 5;
}

#ifdef _MSC_VER
#define inline __inline
#endif

/******************************************************************************/
/*                                                                            */
/*		64bit Address Commands                                                */
/*																			  */
/******************************************************************************/
static inline IMG_BOOL pdl_CanRun64BitCommands(IMG_UINT64 ui64Address)
{
// Ignore Visual Studio warning C4127: conditional expression is constant
#ifdef _MSC_VER
#pragma warning(push)
#pragma warning(disable:4127)
#endif

#ifndef IGNORE_CHECKS

  if (sizeof(void *) == 8)
  {
    return IMG_TRUE;
  }
  else
  {
    return (ui64Address < ( 0x1ULL << 32 ));
  }

#endif

#ifdef _MSC_VER
#pragma warning(pop)
#endif
}

IMG_VOID PDL_WriteRegister64(PDL_psScriptCB psScriptCB)
{
	/*
	psScriptCB->pui32Script[0]	=	"write register" (0x00000000)
	psScriptCB->pui32Script[1]	=	file id
	psScriptCB->pui32Script[2]	=	line number
	psScriptCB->pui32Script[3]	=	address(lower32)
	psScriptCB->pui32Script[4]	=	address(upper32)
	psScriptCB->pui32Script[5]	=	value
	*/
	
	// Check we have 64bit compatibility
	if (!pdl_CanRun64BitCommands(ADDR64(psScriptCB->pui32Script[3])))
	{
		ERROR_OUTPUT("64bit commands cannot run on a 32bit system\n");
		PDL_ASSERT(psScriptCB->pui32Script);
	}

	VERBOSE_OUTPUT(WRW_REG64, psScriptCB->pui32Script);

	WriteReg(ADDR64(psScriptCB->pui32Script[3]), psScriptCB->pui32Script[5]);
	
	/* Advance script pointer and exit */
	psScriptCB->pui32Script += 6;
}

IMG_VOID PDL_WriteMemory64(PDL_psScriptCB psScriptCB)
{	
	/*
	psScriptCB->pui32Script[0]	=	"write memory" (0x00000001)
	psScriptCB->pui32Script[1]	=	file id
	psScriptCB->pui32Script[2]	=	line number
	psScriptCB->pui32Script[3]	=	address(lower32)
	psScriptCB->pui32Script[4]	=	address(upper32)
	psScriptCB->pui32Script[5]	=	value
	*/

	// Check we have 64bit compatibility
	if (!pdl_CanRun64BitCommands(ADDR64(psScriptCB->pui32Script[3])))
	{
		ERROR_OUTPUT("64bit commands cannot run on a 32bit system\n");
		PDL_ASSERT(psScriptCB->pui32Script);
	}

	VERBOSE_OUTPUT(WRW_MEM64, psScriptCB->pui32Script);

	WriteMem(ADDR64(psScriptCB->pui32Script[3]), psScriptCB->pui32Script[5]);
	
	/* Advance script pointer and exit */
	psScriptCB->pui32Script += 6;

}

IMG_VOID PDL_ReadRegister64(PDL_psScriptCB psScriptCB)
{
	IMG_UINT32 ui32Temp;

	/*
	psScriptCB->pui32Script[0]	=	"read register" (0x00000003)
	psScriptCB->pui32Script[1]	=	file id
	psScriptCB->pui32Script[2]	=	line number
	psScriptCB->pui32Script[3]	=	address(lower32)
	psScriptCB->pui32Script[4]	=	address(upper32)
	*/

	// Check we have 64bit compatibility
	if (!pdl_CanRun64BitCommands(ADDR64(psScriptCB->pui32Script[3])))
	{
		ERROR_OUTPUT("64bit commands cannot run on a 32bit system\n");
		PDL_ASSERT( psScriptCB->pui32Script );
	}
	
	VERBOSE_OUTPUT(RDW_REG64, psScriptCB->pui32Script);

	ReadReg(ADDR64(psScriptCB->pui32Script[3]), &ui32Temp);
	
	/* Advance script pointer and exit */
	psScriptCB->pui32Script += 5;
}	

IMG_VOID PDL_ReadMemory64 (PDL_psScriptCB psScriptCB)
{
	IMG_UINT32 ui32Temp;

	/*
	psScriptCB->pui32Script[0]	=	"read memory" (0x00000004)
	psScriptCB->pui32Script[1]	=	file id
	psScriptCB->pui32Script[2]	=	line number
	psScriptCB->pui32Script[3]	=	address(lower32)
	psScriptCB->pui32Script[4]	=	address(upper32)
	*/

	// Check we have 64bit compatibility
	if (!pdl_CanRun64BitCommands(ADDR64(psScriptCB->pui32Script[3])))
	{
		ERROR_OUTPUT("64bit commands cannot run on a 32bit system\n");
		PDL_ASSERT(psScriptCB->pui32Script);
	}

	VERBOSE_OUTPUT(RDW_MEM64, psScriptCB->pui32Script);

	ReadMem(ADDR64(psScriptCB->pui32Script[3]), &ui32Temp);
	
	/* Advance script pointer and exit */
	psScriptCB->pui32Script += 5;
}

IMG_VOID PDL_PollRegister64(PDL_psScriptCB psScriptCB)
{
	// Check we have 64bit compatibility
	if (!pdl_CanRun64BitCommands(ADDR64(psScriptCB->pui32Script[3])))
	{
		ERROR_OUTPUT("64bit commands cannot run on a 32bit system\n");
		PDL_ASSERT(psScriptCB->pui32Script);
	}

	if (!psScriptCB->bPollPending)
		VERBOSE_OUTPUT(POL_REG64, psScriptCB->pui32Script);
	
	PDL_Poll(psScriptCB, PDL_POLL_REG64);
}

IMG_VOID PDL_PollMemory64(PDL_psScriptCB psScriptCB)
{
	// Check we have 64bit compatibility
	if (!pdl_CanRun64BitCommands(ADDR64(psScriptCB->pui32Script[3])))
	{
		ERROR_OUTPUT("64bit commands cannot run on a 32bit system\n");
		PDL_ASSERT(psScriptCB->pui32Script);
	}

	if (!psScriptCB->bPollPending)
		VERBOSE_OUTPUT(POL_MEM64, psScriptCB->pui32Script);
	
	PDL_Poll(psScriptCB, PDL_POLL_MEM64);
}

IMG_VOID PDL_LoadBytesToMemory64(PDL_psScriptCB psScriptCB)
{
	IMG_UINT32 ui32DataSize = psScriptCB->pui32Script[5];

	/*
	psScriptCB->pui32Script[0]	=	"load bytes to memory" (0x00000007)
	psScriptCB->pui32Script[1]	=	file id
	psScriptCB->pui32Script[2]	=	line number
	psScriptCB->pui32Script[3]	=	address(lower32)
	psScriptCB->pui32Script[4]	=	address(upper32)
	psScriptCB->pui32Script[5]	=	size (in bytes)
	psScriptCB->pui32Script[6]	=	data[1], data[2], data[3], data[4],
	psScriptCB->pui32Script[7]	=	data[5], data[6], data[7], data[8],
	...
	...
	*/

	// Check we have 64bit compatibility
	if (!pdl_CanRun64BitCommands(ADDR64(psScriptCB->pui32Script[3])))
	{
		ERROR_OUTPUT("64bit commands cannot run on a 32bit system\n");
		PDL_ASSERT(psScriptCB->pui32Script);
	}

	VERBOSE_OUTPUT(LDB_MEM64, psScriptCB->pui32Script);
	
	CopyMem(ADDR64(psScriptCB->pui32Script[3]), &psScriptCB->pui32Script[6], ui32DataSize);

	/* Advance script pointer and exit (round byte count up and convert to word count)  */
	ui32DataSize += 3;
	ui32DataSize >>= 2;
	psScriptCB->pui32Script += (6 + ui32DataSize);
}
#if defined(CONFIG_RTD287X_QC) || defined(CONFIG_RTD287XP_QC) || defined(CONFIG_RTD287X_23x23_QC)
IMG_VOID PDL_FillMem64(PDL_psScriptCB psScriptCB)
{
	/*
	psScriptCB->pui32Script[0]	=	"fill memory" (0x00000043)
	psScriptCB->pui32Script[1]	=	file id
	psScriptCB->pui32Script[2]	=	line number
	psScriptCB->pui32Script[3]	=	address(lower32)
	psScriptCB->pui32Script[4]	=	address(upper32)
	psScriptCB->pui32Script[5]	=	byte
    psScriptCB->pui32Script[6]	=	size (in bytes)
	*/

	// Check we have 64bit compatibility
	if (!pdl_CanRun64BitCommands(ADDR64(psScriptCB->pui32Script[3])))
	{
        ERROR_OUTPUT("64bit commands cannot run on a 32bit system\n");
        PDL_ASSERT(psScriptCB->pui32Script);
    }
    
    VERBOSE_OUTPUT(FILL_MEM64, psScriptCB->pui32Script);
	
	FillMem(ADDR64(psScriptCB->pui32Script[3]),
			(IMG_UINT8)psScriptCB->pui32Script[5], psScriptCB->pui32Script[6]);
    
	/* Advance script pointer and exit */
	psScriptCB->pui32Script += 7;
}
#endif

IMG_VOID PDL_MemCircularBufferPoll64(PDL_psScriptCB psScriptCB)
{
	IMG_UINT64 ui64RoffAddr			  = ADDR64(psScriptCB->pui32Script[3]);
	IMG_UINT32 ui32WoffValue		  = psScriptCB->pui32Script[5];
	IMG_UINT32 ui32RequiredPacketSize = psScriptCB->pui32Script[6];
	IMG_UINT32 ui32CircularBufferSize = psScriptCB->pui32Script[7];
    IMG_UINT32 ui32RoffValue;
	IMG_UINT32 ui32FreeSpace;
	IMG_BOOL   bContinue			  = IMG_TRUE;
	IMG_BOOL   bCBPCompleted		  = IMG_FALSE;

	/*
	psScriptCB->pui32Script[0]	=	"circular buffer poll" (0x0000000B)
	psScriptCB->pui32Script[1]	=	file id
	psScriptCB->pui32Script[2]	=	line number
	psScriptCB->pui32Script[3]	=	address(lower32)
	psScriptCB->pui32Script[4]	=	address(upper32)
	psScriptCB->pui32Script[6]	=	write offset value
	psScriptCB->pui32Script[7]	=	required packet size
	psScriptCB->pui32Script[8]	=	circular buffer size
	*/
	
	// Check we have 64bit compatibility
	if (!pdl_CanRun64BitCommands(ADDR64(psScriptCB->pui32Script[3])))
	{
		ERROR_OUTPUT("64bit commands cannot run on a 32bit system\n");
		PDL_ASSERT(psScriptCB->pui32Script);
	}

	/* Is this the first time we execute this CBP command? */
	if (!psScriptCB->bPollPending)
	{
		psScriptCB->bPollPending = IMG_TRUE;
		psScriptCB->ui32LoopCount = 0;
		psScriptCB->ui32Delay = 10;

		VERBOSE_OUTPUT(CBP_MEM64, psScriptCB->pui32Script);
	}

	while (bContinue)
	{
		ReadMem(ui64RoffAddr, &ui32RoffValue);

		if (ui32RoffValue > ui32WoffValue)
			ui32FreeSpace = ui32RoffValue - ui32WoffValue - 1;
		else
			ui32FreeSpace = (ui32RoffValue - ui32WoffValue) + (ui32CircularBufferSize - 1);
		
		if (ui32FreeSpace >= ui32RequiredPacketSize)
		{
			bCBPCompleted = IMG_TRUE;
			bContinue = IMG_FALSE;
		}
		else if (gui32NumScripts > 1)
		{
			bCBPCompleted = IMG_FALSE;
			bContinue = IMG_FALSE;
		}
	}
	
	if (!bCBPCompleted)
	{
		/* Reset the time count to 0 */
		psScriptCB->ui32TimeCount = 0;
	}
	else
	{
		/* Ready to move on */
		psScriptCB->bPollPending = IMG_FALSE;

		/* Advance script pointer and exit */
		psScriptCB->pui32Script += 8;
	}
}

IMG_VOID PDL_WriteIntRegToRegister64(PDL_psScriptCB psScriptCB)
{

	/*
	psScriptCB->pui32Script[0]	=	"write intreg to register64" (0x00000035)
	psScriptCB->pui32Script[1]	=	file id
	psScriptCB->pui32Script[2]	=	line number
	psScriptCB->pui32Script[3]	=	address(lower32)
	psScriptCB->pui32Script[4]	=	address(upper32)
	psScriptCB->pui32Script[5]	=	internal register ID
	*/

	VERBOSE_OUTPUT(INTREG_WRW_REG64, psScriptCB->pui32Script);

	if (psScriptCB->pui32Script[5] < NUMBER_OF_INTERNAL_REGS)
	{
		WriteReg(ADDR64(psScriptCB->pui32Script[3]), (IMG_UINT32)aui64InternalRegisters[PDL_SCRIPT_NO][psScriptCB->pui32Script[5]]);
	}
	else
	{
		ERROR_OUTPUT("Register Number out of scope\n");
		PDL_ASSERT(psScriptCB->pui32Script);
	}
	
	/* Advance script pointer and exit */
	psScriptCB->pui32Script += 6;
}

IMG_VOID PDL_WriteIntRegToMemory64(PDL_psScriptCB psScriptCB)
{
	/*
	psScriptCB->pui32Script[0]	=	"write intreg to memory 64" (0x0000002D)
	psScriptCB->pui32Script[1]	=	file id
	psScriptCB->pui32Script[2]	=	line number
	psScriptCB->pui32Script[3]	=	address(lower32)
	psScriptCB->pui32Script[4]	=	address(upper32)
	psScriptCB->pui32Script[5]	=	internal register ID
	*/

	VERBOSE_OUTPUT(INTREG_WRW_MEM64, psScriptCB->pui32Script);

	if (psScriptCB->pui32Script[5] < NUMBER_OF_INTERNAL_REGS)
	{
		WriteMem(ADDR64(psScriptCB->pui32Script[3]), (IMG_UINT32)aui64InternalRegisters[PDL_SCRIPT_NO][psScriptCB->pui32Script[5]]);
	}
	else
	{
		ERROR_OUTPUT("Register Number out of scope\n");
		PDL_ASSERT(psScriptCB->pui32Script);
	}
	
	/* Advance script pointer and exit */
	psScriptCB->pui32Script += 6;
}

IMG_VOID PDL_ReadMemoryToIntReg64(PDL_psScriptCB psScriptCB)
{
	/*
	psScriptCB->pui32Script[0]	=	"read memory to intreg" (0x0000000F)
	psScriptCB->pui32Script[1]	=	file id
	psScriptCB->pui32Script[2]	=	line number
	psScriptCB->pui32Script[3]	=	address(lower32)
	psScriptCB->pui32Script[4]	=	address(upper32)
	psScriptCB->pui32Script[5]	=	internal register ID
	*/

	VERBOSE_OUTPUT(INTREG_RDW_MEM64, psScriptCB->pui32Script);

	if (psScriptCB->pui32Script[5] < NUMBER_OF_INTERNAL_REGS)
	{
#if defined(CONFIG_RTD287X_QC) || defined(CONFIG_RTD287XP_QC) || defined(CONFIG_RTD287X_23x23_QC)		
        aui64InternalRegisters[PDL_SCRIPT_NO][psScriptCB->pui32Script[5]] = 0;
#endif
		ReadMem(ADDR64(psScriptCB->pui32Script[3]), &aui64InternalRegisters[PDL_SCRIPT_NO][psScriptCB->pui32Script[5]]);
	}
	else
	{
		ERROR_OUTPUT("Register Number out of scope\n");
		PDL_ASSERT(psScriptCB->pui32Script);
	}
	
	/* Advance script pointer and exit */
	psScriptCB->pui32Script += 6;
}

IMG_VOID PDL_ReadRegister64ToIntReg(PDL_psScriptCB psScriptCB)
{
	/*
	psScriptCB->pui32Script[0]	=	"read register64 to intreg" (0x0000000F)
	psScriptCB->pui32Script[1]	=	file id
	psScriptCB->pui32Script[2]	=	line number
	psScriptCB->pui32Script[3]	=	address(lower32)
	psScriptCB->pui32Script[4]	=	address(upper32)
	psScriptCB->pui32Script[5]	=	internal register ID
	*/

	VERBOSE_OUTPUT(INTREG_RDW_REG64, psScriptCB->pui32Script);

	if (psScriptCB->pui32Script[5] < NUMBER_OF_INTERNAL_REGS)
	{
#if defined(CONFIG_RTD287X_QC) || defined(CONFIG_RTD287XP_QC) || defined(CONFIG_RTD287X_23x23_QC)
		aui64InternalRegisters[PDL_SCRIPT_NO][psScriptCB->pui32Script[5]] = 0;
#endif
		ReadReg(ADDR64(psScriptCB->pui32Script[3]), &aui64InternalRegisters[PDL_SCRIPT_NO][psScriptCB->pui32Script[5]]);
	}
	else
	{
		ERROR_OUTPUT("Internal Variable Number out of scope\n");
		PDL_ASSERT(psScriptCB->pui32Script);
	}
	
	/* Advance script pointer and exit */
	psScriptCB->pui32Script += 6;
}

// SAB command, by default this command does nothing
IMG_VOID PDL_SaveBytesFromMemory64(PDL_psScriptCB psScriptCB)
{	
	/*
	psScriptCB->pui32Script[0]	=	"Save Bytes 64" (0x00000032)
	psScriptCB->pui32Script[1]	=	file id
	psScriptCB->pui32Script[2]	=	line number
	psScriptCB->pui32Script[3]	=	address(lower32)
	psScriptCB->pui32Script[4]	=	address(upper32)
	psScriptCB->pui32Script[5]	=	size
	*/
	VERBOSE_OUTPUT(SAB_MEM64, psScriptCB->pui32Script);
    
	// This block of code generates an area of memory which contains all the SAB and SII dumps
	// This area of memory can be dumped to a binary file which the PdumpExtractImage tool can interpret
    if (pui8SABOutput)
	{
		// if this is a new SAB line in the original pdump,
		// add a header of the 0x31 SAB id, file id, line number and size to the save mem area
		if (psScriptCB->ui32SabFileID != psScriptCB->pui32Script[1] ||
            psScriptCB->ui32SabLineNum != psScriptCB->pui32Script[2])
        {
#if defined(CONFIG_RTD287X_QC) || defined(CONFIG_RTD287XP_QC) || defined(CONFIG_RTD287X_23x23_QC)
            if ((IMG_UINTPTR)pui8SABOutput & 0x3)
            {
                IMG_UINT32 skipbytes = 4 - ((IMG_UINTPTR)pui8SABOutput & 0x3);
                *pui32SABOrigin += skipbytes;
                pui8SABOutput += skipbytes; // skip to 4 byte alignment
            }
#else			
			pui8SABOutput = (IMG_PUINT8)(((IMG_UINTPTR)pui8SABOutput + 3) & ~0x3); // skip to 4 byte alignment
#endif
#ifdef EMU_TARGET
            EmuSaveMemFlush();
#endif
            *(IMG_PUINT32)pui8SABOutput = psScriptCB->pui32Script[0];
            pui8SABOutput += sizeof(IMG_UINT32);
            *(IMG_PUINT32)pui8SABOutput = psScriptCB->pui32Script[1];
            pui8SABOutput += sizeof(IMG_UINT32);
            *(IMG_PUINT32)pui8SABOutput = psScriptCB->pui32Script[2];
            pui8SABOutput += sizeof(IMG_UINT32);
            psScriptCB->ui32SabFileID = psScriptCB->pui32Script[1];
            psScriptCB->ui32SabLineNum = psScriptCB->pui32Script[2];
            
            // Create a size variable as the fourth header number
            psScriptCB->pui32SabSize = (IMG_PUINT32)pui8SABOutput;
            psScriptCB->ui32SabSize = 0;
            *psScriptCB->pui32SabSize = psScriptCB->ui32SabSize;
            pui8SABOutput += sizeof(IMG_UINT32);
#if defined(CONFIG_RTD287X_QC) || defined(CONFIG_RTD287XP_QC) || defined(CONFIG_RTD287X_23x23_QC)
			*pui32SABOrigin += 4 * sizeof(IMG_UINT32);
#endif
        }
        
        // Copy the SAB data into the save mem area
        SaveMem(pui8SABOutput, ADDR64(psScriptCB->pui32Script[3]), psScriptCB->pui32Script[5]);
#if defined(CONFIG_RTD287X_QC) || defined(CONFIG_RTD287XP_QC) || defined(CONFIG_RTD287X_23x23_QC)
        pui8SABOutput += psScriptCB->pui32Script[5];
        *pui32SABOrigin += psScriptCB->pui32Script[5];
#else
        pui8SABOutput += psScriptCB->pui32Script[4];
#endif
        psScriptCB->ui32SabSize += psScriptCB->pui32Script[5];
        *psScriptCB->pui32SabSize = psScriptCB->ui32SabSize;
	}
    
    psScriptCB->pui32Script += 6;
}

/******************************************************************************/
/*                                                                            */
/*		64bit Address and 64bit Data Commands                                 */
/*																			  */
/******************************************************************************/
IMG_VOID PDL_Write64Register64(PDL_psScriptCB psScriptCB)
{
	/*
	psScriptCB->pui32Script[0]	=	"write register" (0x00000000)
	psScriptCB->pui32Script[1]	=	file id
	psScriptCB->pui32Script[2]	=	line number
	psScriptCB->pui32Script[3]	=	address(lower32)
	psScriptCB->pui32Script[4]	=	address(upper32)
	psScriptCB->pui32Script[5]	=	value(lower32)
	psScriptCB->pui32Script[6]	=	value(upper32)
	*/
	
	// Check we have 64bit compatibility
	if (!pdl_CanRun64BitCommands(ADDR64(psScriptCB->pui32Script[3])))
	{
		ERROR_OUTPUT("64bit commands cannot run on a 32bit system\n");
		PDL_ASSERT(psScriptCB->pui32Script);
	}

	VERBOSE_OUTPUT(WRW64_REG64, psScriptCB->pui32Script);

	WriteReg64(ADDR64(psScriptCB->pui32Script[3]), DATA64(psScriptCB->pui32Script[5]));
	
	/* Advance script pointer and exit */
	psScriptCB->pui32Script += 7;
}	

IMG_VOID PDL_Write64Memory64(PDL_psScriptCB psScriptCB)
{	
	/*
	psScriptCB->pui32Script[0]	=	"write memory" (0x00000001)
	psScriptCB->pui32Script[1]	=	file id
	psScriptCB->pui32Script[2]	=	line number
	psScriptCB->pui32Script[3]	=	address(lower32)
	psScriptCB->pui32Script[4]	=	address(upper32)
	psScriptCB->pui32Script[5]	=	value(lower32)
	psScriptCB->pui32Script[6]	=	value(upper32)
	*/

	// Check we have 64bit compatibility
	if (!pdl_CanRun64BitCommands(ADDR64(psScriptCB->pui32Script[3])))
	{
		ERROR_OUTPUT("64bit commands cannot run on a 32bit system\n");
		PDL_ASSERT(psScriptCB->pui32Script);
	}

	VERBOSE_OUTPUT(WRW64_MEM64, psScriptCB->pui32Script);

	WriteMem64(ADDR64(psScriptCB->pui32Script[3]), DATA64(psScriptCB->pui32Script[5]));
	
	/* Advance script pointer and exit */
	psScriptCB->pui32Script += 7;
}

IMG_VOID PDL_Read64Register64(PDL_psScriptCB psScriptCB)
{
	IMG_UINT64 ui64Temp;

	/*
	psScriptCB->pui32Script[0]	=	"read register" (0x00000003)
	psScriptCB->pui32Script[1]	=	file id
	psScriptCB->pui32Script[2]	=	line number
	psScriptCB->pui32Script[3]	=	address(lower32)
	psScriptCB->pui32Script[4]	=	address(upper32)
	*/

	// Check we have 64bit compatibility
	if (!pdl_CanRun64BitCommands(ADDR64(psScriptCB->pui32Script[3])))
	{
		ERROR_OUTPUT("64bit commands cannot run on a 32bit system\n");
		PDL_ASSERT(psScriptCB->pui32Script);
	}
	
	VERBOSE_OUTPUT(RDW64_REG64, psScriptCB->pui32Script);

	ReadReg64(ADDR64(psScriptCB->pui32Script[3]), &ui64Temp);
	
	/* Advance script pointer and exit */
	psScriptCB->pui32Script += 5;
}	

IMG_VOID PDL_Read64Memory64(PDL_psScriptCB psScriptCB)
{
	IMG_UINT64 ui64Temp;

	/*
	psScriptCB->pui32Script[0]	=	"read memory" (0x00000004)
	psScriptCB->pui32Script[1]	=	file id
	psScriptCB->pui32Script[2]	=	line number
	psScriptCB->pui32Script[3]	=	address(lower32)
	psScriptCB->pui32Script[4]	=	address(upper32)
	*/

	// Check we have 64bit compatibility
	if (!pdl_CanRun64BitCommands(ADDR64(psScriptCB->pui32Script[3])))
	{
		ERROR_OUTPUT("64bit commands cannot run on a 32bit system\n");
		PDL_ASSERT(psScriptCB->pui32Script);
	}

	VERBOSE_OUTPUT(RDW64_MEM64, psScriptCB->pui32Script);

	ReadMem64(ADDR64(psScriptCB->pui32Script[3]), &ui64Temp);
	
	/* Advance script pointer and exit */
	psScriptCB->pui32Script += 5;
}

IMG_VOID PDL_Poll64Register64(PDL_psScriptCB psScriptCB)
{
	// Check we have 64bit compatibility
	if (!pdl_CanRun64BitCommands(ADDR64(psScriptCB->pui32Script[3])))
	{
		ERROR_OUTPUT("64bit commands cannot run on a 32bit system\n");
		PDL_ASSERT(psScriptCB->pui32Script);
	}

	if (!psScriptCB->bPollPending)
		VERBOSE_OUTPUT(POL64_REG64, psScriptCB->pui32Script);
	
	PDL_Poll(psScriptCB, PDL_POLL64_REG64);
}

IMG_VOID PDL_Poll64Memory64(PDL_psScriptCB psScriptCB)
{
	// Check we have 64bit compatibility
	if (!pdl_CanRun64BitCommands(ADDR64(psScriptCB->pui32Script[3])))
	{
		ERROR_OUTPUT("64bit commands cannot run on a 32bit system\n");
		PDL_ASSERT(psScriptCB->pui32Script);
	}

	if (!psScriptCB->bPollPending)
		VERBOSE_OUTPUT(POL64_MEM64, psScriptCB->pui32Script);
	
	PDL_Poll(psScriptCB, PDL_POLL64_MEM64);
}

void PDL_Write64IntRegToRegister64(PDL_psScriptCB psScriptCB)
{
	/*
	psScriptCB->pui32Script[0]	=	"write intreg to register64" (0x00000035)
	psScriptCB->pui32Script[1]	=	file id
	psScriptCB->pui32Script[2]	=	line number
	psScriptCB->pui32Script[3]	=	address(lower32)
	psScriptCB->pui32Script[4]	=	address(upper32)
	psScriptCB->pui32Script[5]	=	internal register ID
	*/

	VERBOSE_OUTPUT(INTREG_WRW64_REG64, psScriptCB->pui32Script);

	if (psScriptCB->pui32Script[5] < NUMBER_OF_INTERNAL_REGS)
	{
		WriteReg64(ADDR64(psScriptCB->pui32Script[3]), aui64InternalRegisters[PDL_SCRIPT_NO][psScriptCB->pui32Script[5]]);
	}
	else
	{
		ERROR_OUTPUT("Register Number out of scope\n");
		PDL_ASSERT(psScriptCB->pui32Script);
	}
	
	/* Advance script pointer and exit */
	psScriptCB->pui32Script += 6;
}

IMG_VOID PDL_Write64IntRegToMemory64(PDL_psScriptCB psScriptCB)
{
	/*
	psScriptCB->pui32Script[0]	=	"write intreg to memory 64" (0x0000002D)
	psScriptCB->pui32Script[1]	=	file id
	psScriptCB->pui32Script[2]	=	line number
	psScriptCB->pui32Script[3]	=	address(lower32)
	psScriptCB->pui32Script[4]	=	address(upper32)
	psScriptCB->pui32Script[5]	=	internal register ID
	*/

	VERBOSE_OUTPUT(INTREG_WRW64_MEM64, psScriptCB->pui32Script);

	if (psScriptCB->pui32Script[5] < NUMBER_OF_INTERNAL_REGS)
	{
		WriteMem64(ADDR64(psScriptCB->pui32Script[3]), aui64InternalRegisters[PDL_SCRIPT_NO][psScriptCB->pui32Script[5]]);
	}
	else
	{
		ERROR_OUTPUT("Register Number out of scope\n");
		PDL_ASSERT(psScriptCB->pui32Script);
	}
	
	/* Advance script pointer and exit */
	psScriptCB->pui32Script += 6;
}

IMG_VOID PDL_Read64Memory64ToIntReg(PDL_psScriptCB psScriptCB)
{
	/*
	psScriptCB->pui32Script[0]	=	"read memory to intreg" (0x0000000F)
	psScriptCB->pui32Script[1]	=	file id
	psScriptCB->pui32Script[2]	=	line number
	psScriptCB->pui32Script[3]	=	address(lower32)
	psScriptCB->pui32Script[4]	=	address(upper32)
	psScriptCB->pui32Script[5]	=	internal register ID
	*/

	VERBOSE_OUTPUT(INTREG_RDW64_MEM64, psScriptCB->pui32Script);

	if (psScriptCB->pui32Script[5] < NUMBER_OF_INTERNAL_REGS)
	{
#if defined(CONFIG_RTD287X_QC) || defined(CONFIG_RTD287XP_QC) || defined(CONFIG_RTD287X_23x23_QC)
        aui64InternalRegisters[PDL_SCRIPT_NO][psScriptCB->pui32Script[5]] = 0;	
#endif
		ReadMem64(ADDR64(psScriptCB->pui32Script[3]), &aui64InternalRegisters[PDL_SCRIPT_NO][psScriptCB->pui32Script[5]]);
	}
	else
	{
		ERROR_OUTPUT("Register Number out of scope\n");
		PDL_ASSERT(psScriptCB->pui32Script);
	}
	
	/* Advance script pointer and exit */
	psScriptCB->pui32Script += 6;
}

IMG_VOID PDL_Read64Register64ToIntReg(PDL_psScriptCB psScriptCB)
{
	/*
	psScriptCB->pui32Script[0]	=	"read register64 to intreg" (0x0000000F)
	psScriptCB->pui32Script[1]	=	file id
	psScriptCB->pui32Script[2]	=	line number
	psScriptCB->pui32Script[3]	=	address(lower32)
	psScriptCB->pui32Script[4]	=	address(upper32)
	psScriptCB->pui32Script[5]	=	internal register ID
	*/

	VERBOSE_OUTPUT(INTREG_RDW64_REG64, psScriptCB->pui32Script);

	if (psScriptCB->pui32Script[5] < NUMBER_OF_INTERNAL_REGS)
	{
#if defined(CONFIG_RTD287X_QC) || defined(CONFIG_RTD287XP_QC) || defined(CONFIG_RTD287X_23x23_QC)
        aui64InternalRegisters[PDL_SCRIPT_NO][psScriptCB->pui32Script[5]] = 0;
#endif
		ReadReg64(ADDR64(psScriptCB->pui32Script[3]), &aui64InternalRegisters[PDL_SCRIPT_NO][psScriptCB->pui32Script[5]]);
	}
	else
	{
		ERROR_OUTPUT("Internal Variable Number out of scope\n");
		PDL_ASSERT(psScriptCB->pui32Script);
	}
	
	/* Advance script pointer and exit */
	psScriptCB->pui32Script += 6;
}

/******************************************************************************/
/*                                                                            */
/*		Internal Register commands                                            */
/*																			  */
/******************************************************************************/
#if defined(CONFIG_RTD287X_QC) || defined(CONFIG_RTD287XP_QC) || defined(CONFIG_RTD287X_23x23_QC)
IMG_VOID PDL_IntRegThreeOperandCmd(PDL_psScriptCB psScriptCB,
                                   PDL_pfnIntRegOpFunction pfnIntRegOpFunction, IMG_BOOL intRegOperand)
{
	/*
	psScriptCB->pui32Script[0]	=	"intreg command" (0x00000010 - 0x0000001D)
	psScriptCB->pui32Script[1]	=	file id
	psScriptCB->pui32Script[2]	=	line number
	psScriptCB->pui32Script[3]	=	dest intreg ID
	psScriptCB->pui32Script[4]	=	op intreg ID
	psScriptCB->pui32Script[5]	=	last operand (lower32) / op2 intreg id
    psScriptCB->pui32Script[6]	=	last operand (upper32) / NA
	*/
	
	if (intRegOperand)	/* If the last operand is a register */
	{
		if ((psScriptCB->pui32Script[3] < NUMBER_OF_INTERNAL_REGS) && 
				(psScriptCB->pui32Script[4] < NUMBER_OF_INTERNAL_REGS) &&
				(psScriptCB->pui32Script[5] < NUMBER_OF_INTERNAL_REGS))
		{
			aui64InternalRegisters[PDL_SCRIPT_NO][psScriptCB->pui32Script[3]] = 
				pfnIntRegOpFunction(aui64InternalRegisters[PDL_SCRIPT_NO][psScriptCB->pui32Script[4]], 
									aui64InternalRegisters[PDL_SCRIPT_NO][psScriptCB->pui32Script[5]]);
		}
		else
		{
			ERROR_OUTPUT("Incorrect Command\n");
			PDL_ASSERT(psScriptCB->pui32Script);
		}
	}
	else /* Last operand is an immediate data value */
	{
		if ((psScriptCB->pui32Script[3] < NUMBER_OF_INTERNAL_REGS) && 
				(psScriptCB->pui32Script[4] < NUMBER_OF_INTERNAL_REGS))
		{
			aui64InternalRegisters[PDL_SCRIPT_NO][psScriptCB->pui32Script[3]] 
			= pfnIntRegOpFunction(aui64InternalRegisters[PDL_SCRIPT_NO][psScriptCB->pui32Script[4]], DATA64(psScriptCB->pui32Script[5]));
		}
		else
		{
			ERROR_OUTPUT("Incorrect Command\n");
			PDL_ASSERT(psScriptCB->pui32Script);
		}
        psScriptCB->pui32Script ++;
	}

	/* Advance script pointer and exit */
	psScriptCB->pui32Script += 6;
}
#else
IMG_VOID PDL_IntRegThreeOperandCmd(PDL_psScriptCB psScriptCB,
                                   PDL_pfnIntRegOpFunction pfnIntRegOpFunction)
{
	/*
	psScriptCB->pui32Script[0]	=	"intreg command" (0x00000010 - 0x0000001D)
	psScriptCB->pui32Script[1]	=	file id
	psScriptCB->pui32Script[2]	=	line number
	psScriptCB->pui32Script[3]	=	bIsRegLastOperand
	psScriptCB->pui32Script[4]	=	dest intreg ID
	psScriptCB->pui32Script[5]	=	op intreg ID
	psScriptCB->pui32Script[6]	=	last operand
	*/
	
	if (psScriptCB->pui32Script[3])	/* If the last operand is a register */
	{
		if ((psScriptCB->pui32Script[4] < NUMBER_OF_INTERNAL_REGS) && 
            (psScriptCB->pui32Script[5] < NUMBER_OF_INTERNAL_REGS) &&
            (psScriptCB->pui32Script[6] < NUMBER_OF_INTERNAL_REGS))
		{
			aui64InternalRegisters[PDL_SCRIPT_NO][psScriptCB->pui32Script[4]] = 
				pfnIntRegOpFunction(aui64InternalRegisters[PDL_SCRIPT_NO][psScriptCB->pui32Script[5]], 
				aui64InternalRegisters[PDL_SCRIPT_NO][psScriptCB->pui32Script[6]]);
		}
		else
		{
			ERROR_OUTPUT("Incorrect Command\n");
			PDL_ASSERT(psScriptCB->pui32Script);
		}
	}
	else /* Last operand is an immediate data value */
	{
		if ((psScriptCB->pui32Script[4] < NUMBER_OF_INTERNAL_REGS) && 
			(psScriptCB->pui32Script[5] < NUMBER_OF_INTERNAL_REGS))
		{
			aui64InternalRegisters[PDL_SCRIPT_NO][psScriptCB->pui32Script[4]] = pfnIntRegOpFunction(aui64InternalRegisters[PDL_SCRIPT_NO][psScriptCB->pui32Script[5]], psScriptCB->pui32Script[6]);
		}
		else
		{
			ERROR_OUTPUT("Incorrect Command\n");
			PDL_ASSERT(psScriptCB->pui32Script);
		}
	}

	/* Advance script pointer and exit */
	psScriptCB->pui32Script += 7;
}
#endif
IMG_VOID PDL_WriteIntRegToRegister(PDL_psScriptCB psScriptCB)
{
	/*
	psScriptCB->pui32Script[0]	=	"write intreg to register" (0x0000000C)
	psScriptCB->pui32Script[1]	=	file id
	psScriptCB->pui32Script[2]	=	line number
	psScriptCB->pui32Script[3]	=	address
	psScriptCB->pui32Script[4]	=	internal register ID
	*/

	VERBOSE_OUTPUT(INTREG_WRW_REG, psScriptCB->pui32Script);

	if (psScriptCB->pui32Script[4] < NUMBER_OF_INTERNAL_REGS)
	{
		WriteReg(psScriptCB->pui32Script[3], (IMG_UINT32)aui64InternalRegisters[PDL_SCRIPT_NO][psScriptCB->pui32Script[4]]);
	}
	else
	{
		ERROR_OUTPUT("Register Number out of scope\n");
		PDL_ASSERT(psScriptCB->pui32Script);
	}
	
	/* Advance script pointer and exit */
	psScriptCB->pui32Script += 5;
}

IMG_VOID PDL_WriteIntRegToMemory(PDL_psScriptCB psScriptCB)
{
	/*
	psScriptCB->pui32Script[0]	=	"write intreg to register" (0x0000000D)
	psScriptCB->pui32Script[1]	=	file id
	psScriptCB->pui32Script[2]	=	line number
	psScriptCB->pui32Script[3]	=	address
	psScriptCB->pui32Script[4]	=	internal register ID
	*/

	VERBOSE_OUTPUT(INTREG_WRW_MEM, psScriptCB->pui32Script);

	if (psScriptCB->pui32Script[4] < NUMBER_OF_INTERNAL_REGS)
	{
		WriteMem(psScriptCB->pui32Script[3], (IMG_UINT32)aui64InternalRegisters[PDL_SCRIPT_NO][psScriptCB->pui32Script[4]]);
	}
	else
	{
		ERROR_OUTPUT("Register Number out of scope\n");
		PDL_ASSERT(psScriptCB->pui32Script);
	}
	
	/* Advance script pointer and exit */
	psScriptCB->pui32Script += 5;
}

IMG_VOID PDL_ReadRegisterToIntReg(PDL_psScriptCB psScriptCB)
{
	/*
	psScriptCB->pui32Script[0]	=	"read register to intreg" (0x0000000E)
	psScriptCB->pui32Script[1]	=	file id
	psScriptCB->pui32Script[2]	=	line number
	psScriptCB->pui32Script[3]	=	address
	psScriptCB->pui32Script[4]	=	internal register ID
	*/

	VERBOSE_OUTPUT(INTREG_RDW_REG, psScriptCB->pui32Script);

	if (psScriptCB->pui32Script[4] < NUMBER_OF_INTERNAL_REGS)
	{
#if defined(CONFIG_RTD287X_QC) || defined(CONFIG_RTD287XP_QC) || defined(CONFIG_RTD287X_23x23_QC)
        aui64InternalRegisters[PDL_SCRIPT_NO][psScriptCB->pui32Script[4]] = 0;
#endif
		ReadReg(psScriptCB->pui32Script[3], &aui64InternalRegisters[PDL_SCRIPT_NO][psScriptCB->pui32Script[4]]);
	}
	else
	{
		ERROR_OUTPUT("Register Number out of scope\n");
		PDL_ASSERT(psScriptCB->pui32Script);
	}
	
	/* Advance script pointer and exit */
	psScriptCB->pui32Script += 5;
}

IMG_VOID PDL_ReadMemoryToIntReg(PDL_psScriptCB psScriptCB)
{
	/*
	psScriptCB->pui32Script[0]	=	"read memory to intreg" (0x0000000F)
	psScriptCB->pui32Script[1]	=	file id
	psScriptCB->pui32Script[2]	=	line number
	psScriptCB->pui32Script[3]	=	address
	psScriptCB->pui32Script[4]	=	internal register ID
	*/

	VERBOSE_OUTPUT(INTREG_RDW_MEM, psScriptCB->pui32Script);

	if (psScriptCB->pui32Script[4] < NUMBER_OF_INTERNAL_REGS)
	{
#if defined(CONFIG_RTD287X_QC) || defined(CONFIG_RTD287XP_QC) || defined(CONFIG_RTD287X_23x23_QC)
		aui64InternalRegisters[PDL_SCRIPT_NO][psScriptCB->pui32Script[4]] = 0;
#endif
		ReadMem(psScriptCB->pui32Script[3], &aui64InternalRegisters[PDL_SCRIPT_NO][psScriptCB->pui32Script[4]]);
	}
	else
	{
		ERROR_OUTPUT("Register Number out of scope\n");
		PDL_ASSERT(psScriptCB->pui32Script);
	}
	
	/* Advance script pointer and exit */
	psScriptCB->pui32Script += 5;
}
#if defined(CONFIG_RTD287X_QC) || defined(CONFIG_RTD287XP_QC) || defined(CONFIG_RTD287X_23x23_QC)
IMG_VOID PDL_IntRegMOV(PDL_psScriptCB psScriptCB)
{
	/*
	psScriptCB->pui32Script[0]	=	"intreg move" (0x00000010)
	psScriptCB->pui32Script[1]	=	file id
	psScriptCB->pui32Script[2]	=	line number
	psScriptCB->pui32Script[3]	=	dest intreg ID
	psScriptCB->pui32Script[4]	=	data (lower32)
    psScriptCB->pui32Script[5]	=	data (upper32)
	*/

	VERBOSE_OUTPUT(INTREG_MOV, psScriptCB->pui32Script);


	if (psScriptCB->pui32Script[3] < NUMBER_OF_INTERNAL_REGS)
	{
		aui64InternalRegisters[PDL_SCRIPT_NO][psScriptCB->pui32Script[3]] = DATA64(psScriptCB->pui32Script[4]);
	}
	else
	{
		ERROR_OUTPUT("Register Number out of scope\n");
		PDL_ASSERT(psScriptCB->pui32Script);
	}

	/* Advance script pointer and exit */
	psScriptCB->pui32Script += 6;
}
#else
IMG_VOID PDL_IntRegMOV(PDL_psScriptCB psScriptCB)
{
	/*
	psScriptCB->pui32Script[0]	=	"intreg move" (0x00000010)
	psScriptCB->pui32Script[1]	=	file id
	psScriptCB->pui32Script[2]	=	line number
	psScriptCB->pui32Script[3]	=	bIsRegLastOperand
	psScriptCB->pui32Script[4]	=	dest intreg ID
	psScriptCB->pui32Script[5]	=	last operand
	*/

	VERBOSE_OUTPUT(INTREG_MOV, psScriptCB->pui32Script);

	if (psScriptCB->pui32Script[3])	/* If the last operand is a register */
	{
		if ((psScriptCB->pui32Script[4] < NUMBER_OF_INTERNAL_REGS) && 
			(psScriptCB->pui32Script[5] < NUMBER_OF_INTERNAL_REGS))
		{
			aui64InternalRegisters[PDL_SCRIPT_NO][psScriptCB->pui32Script[4]] = aui64InternalRegisters[PDL_SCRIPT_NO][psScriptCB->pui32Script[5]];
		}
		else
		{
			ERROR_OUTPUT("Register Number out of scope\n");
			PDL_ASSERT(psScriptCB->pui32Script);
		}

	}
	else /* Last operand is an immediate data value */
	{
		if (psScriptCB->pui32Script[4] < NUMBER_OF_INTERNAL_REGS)
		{
			aui64InternalRegisters[PDL_SCRIPT_NO][psScriptCB->pui32Script[4]] = psScriptCB->pui32Script[5];
		}
		else
		{
			ERROR_OUTPUT("Register Number out of scope\n");
			PDL_ASSERT(psScriptCB->pui32Script);
		}
	}

	/* Advance script pointer and exit */
	psScriptCB->pui32Script += 6;
}
#endif
#if defined(CONFIG_RTD287X_QC) || defined(CONFIG_RTD287XP_QC) || defined(CONFIG_RTD287X_23x23_QC)
IMG_VOID PDL_IntRegMOV_IntReg(PDL_psScriptCB psScriptCB)
{
	/*
	psScriptCB->pui32Script[0]	=	"intreg move" (0x00000010)
	psScriptCB->pui32Script[1]	=	file id
	psScriptCB->pui32Script[2]	=	line number
	psScriptCB->pui32Script[3]	=	dest intreg ID
	psScriptCB->pui32Script[4]	=	src intreg ID
	*/

	VERBOSE_OUTPUT(INTREG_MOV_INTREG, psScriptCB->pui32Script);

	if ((psScriptCB->pui32Script[3] < NUMBER_OF_INTERNAL_REGS) && 
			(psScriptCB->pui32Script[4] < NUMBER_OF_INTERNAL_REGS))
	{
		aui64InternalRegisters[PDL_SCRIPT_NO][psScriptCB->pui32Script[3]] = aui64InternalRegisters[PDL_SCRIPT_NO][psScriptCB->pui32Script[4]];
	}
	else
	{
		ERROR_OUTPUT("Register Number out of scope\n");
		PDL_ASSERT(psScriptCB->pui32Script);
	}

	/* Advance script pointer and exit */
	psScriptCB->pui32Script += 5;
}
#endif
#ifndef CONFIG_RTD287X_QC
IMG_VOID PDL_IntRegMOV64(PDL_psScriptCB psScriptCB)
{
	/*
	psScriptCB->pui32Script[0]	=	"intreg move" (0x00000010)
	psScriptCB->pui32Script[1]	=	file id
	psScriptCB->pui32Script[2]	=	line number
	psScriptCB->pui32Script[3]	=	dest intreg ID
	psScriptCB->pui32Script[4]	=	upper 32bits of word
	psScriptCB->pui32Script[5]	=	lower 32bits of word
	*/

	// Check we have 64bit compatibility
	if (!pdl_CanRun64BitCommands(ADDR64(psScriptCB->pui32Script[4])))
	{
		ERROR_OUTPUT("64bit commands cannot run on a 32bit system\n");
		PDL_ASSERT( psScriptCB->pui32Script );
	}

	VERBOSE_OUTPUT(INTREG_MOV64, psScriptCB->pui32Script);

	if (psScriptCB->pui32Script[3] < NUMBER_OF_INTERNAL_REGS)
	{
		aui64InternalRegisters[PDL_SCRIPT_NO][psScriptCB->pui32Script[3]] = ADDR64(psScriptCB->pui32Script[4]);
	}
    else
	{
		ERROR_OUTPUT("Register Number out of scope\n");
		PDL_ASSERT(psScriptCB->pui32Script);
	}

	/* Advance script pointer and exit */
	psScriptCB->pui32Script += 6;
}
#endif
IMG_VOID PDL_IntRegAND(PDL_psScriptCB psScriptCB)
{
	VERBOSE_OUTPUT(INTREG_AND, psScriptCB->pui32Script);
#if defined(CONFIG_RTD287X_QC) || defined(CONFIG_RTD287XP_QC) || defined(CONFIG_RTD287X_23x23_QC)
	PDL_IntRegThreeOperandCmd(psScriptCB, &PDL_IntRegOpAND, IMG_FALSE);
#else	
	PDL_IntRegThreeOperandCmd(psScriptCB, &PDL_IntRegOpAND);
#endif
}

IMG_VOID PDL_IntRegOR(PDL_psScriptCB psScriptCB)
{
	VERBOSE_OUTPUT(INTREG_OR, psScriptCB->pui32Script);
#if defined(CONFIG_RTD287X_QC) || defined(CONFIG_RTD287XP_QC) || defined(CONFIG_RTD287X_23x23_QC)
	PDL_IntRegThreeOperandCmd(psScriptCB, &PDL_IntRegOpOR, IMG_FALSE);
#else
	PDL_IntRegThreeOperandCmd(psScriptCB, &PDL_IntRegOpOR);
#endif
}

IMG_VOID PDL_IntRegXOR(PDL_psScriptCB psScriptCB)
{
	VERBOSE_OUTPUT(INTREG_XOR, psScriptCB->pui32Script);
#if defined(CONFIG_RTD287X_QC) || defined(CONFIG_RTD287XP_QC) || defined(CONFIG_RTD287X_23x23_QC)	
	PDL_IntRegThreeOperandCmd(psScriptCB, &PDL_IntRegOpXOR, IMG_FALSE);
#else
	PDL_IntRegThreeOperandCmd(psScriptCB, &PDL_IntRegOpXOR);
#endif
}

IMG_VOID PDL_IntRegNOT(PDL_psScriptCB psScriptCB)
{
	/*
	psScriptCB->pui32Script[0]	=	"intreg NOT" (0x00000014)
	psScriptCB->pui32Script[1]	=	file id
	psScriptCB->pui32Script[2]	=	line number
	psScriptCB->pui32Script[3]	=	dest intreg ID
	psScriptCB->pui32Script[4]	=	op intreg ID
	*/
	
	VERBOSE_OUTPUT(INTREG_NOT, psScriptCB->pui32Script);

	if ((psScriptCB->pui32Script[3] < NUMBER_OF_INTERNAL_REGS) && 
		(psScriptCB->pui32Script[4] < NUMBER_OF_INTERNAL_REGS))
	{
		aui64InternalRegisters[PDL_SCRIPT_NO][psScriptCB->pui32Script[3]] = ~ aui64InternalRegisters[PDL_SCRIPT_NO][psScriptCB->pui32Script[4]];
	}
	else
	{
		ERROR_OUTPUT("Register Number out of scope\n");
		PDL_ASSERT(psScriptCB->pui32Script);
	}

	/* Advance script pointer and exit */
	psScriptCB->pui32Script += 5;
}

IMG_VOID PDL_IntRegSHR(PDL_psScriptCB psScriptCB)
{
	VERBOSE_OUTPUT(INTREG_SHR, psScriptCB->pui32Script);
#if defined(CONFIG_RTD287X_QC) || defined(CONFIG_RTD287XP_QC) || defined(CONFIG_RTD287X_23x23_QC)
	PDL_IntRegThreeOperandCmd(psScriptCB, &PDL_IntRegOpSHR, IMG_FALSE);
#else	
	PDL_IntRegThreeOperandCmd(psScriptCB, &PDL_IntRegOpSHR);
#endif
}

IMG_VOID PDL_IntRegSHL(PDL_psScriptCB psScriptCB)
{
	VERBOSE_OUTPUT(INTREG_SHL, psScriptCB->pui32Script);
#if defined(CONFIG_RTD287X_QC) || defined(CONFIG_RTD287XP_QC) || defined(CONFIG_RTD287X_23x23_QC)
	PDL_IntRegThreeOperandCmd(psScriptCB, &PDL_IntRegOpSHL, IMG_FALSE);
#else	
	PDL_IntRegThreeOperandCmd(psScriptCB, &PDL_IntRegOpSHL);
#endif
}

IMG_VOID PDL_IntRegADD(PDL_psScriptCB psScriptCB)
{
	VERBOSE_OUTPUT(INTREG_ADD, psScriptCB->pui32Script);
#if defined(CONFIG_RTD287X_QC) || defined(CONFIG_RTD287XP_QC)|| defined(CONFIG_RTD287X_23x23_QC)	
	PDL_IntRegThreeOperandCmd(psScriptCB, &PDL_IntRegOpADD, IMG_FALSE);
#else	
	PDL_IntRegThreeOperandCmd(psScriptCB, &PDL_IntRegOpADD);
#endif
}

IMG_VOID PDL_IntRegSUB(PDL_psScriptCB psScriptCB)
{
	VERBOSE_OUTPUT(INTREG_SUB, psScriptCB->pui32Script);
#if defined(CONFIG_RTD287X_QC) || defined(CONFIG_RTD287XP_QC)|| defined(CONFIG_RTD287X_23x23_QC)	
	PDL_IntRegThreeOperandCmd(psScriptCB, &PDL_IntRegOpSUB, IMG_FALSE);
#else	
	PDL_IntRegThreeOperandCmd(psScriptCB, &PDL_IntRegOpSUB);
#endif
}

IMG_VOID PDL_IntRegMUL(PDL_psScriptCB psScriptCB)
{
	VERBOSE_OUTPUT(INTREG_MUL, psScriptCB->pui32Script);
#if defined(CONFIG_RTD287X_QC) || defined(CONFIG_RTD287XP_QC)|| defined(CONFIG_RTD287X_23x23_QC)	
	PDL_IntRegThreeOperandCmd(psScriptCB, &PDL_IntRegOpMUL, IMG_FALSE);
#else	
	PDL_IntRegThreeOperandCmd(psScriptCB, &PDL_IntRegOpMUL);
#endif
}

IMG_VOID PDL_IntRegIMUL(PDL_psScriptCB psScriptCB)
{
	VERBOSE_OUTPUT(INTREG_IMUL, psScriptCB->pui32Script);
#if defined(CONFIG_RTD287X_QC) || defined(CONFIG_RTD287XP_QC)|| defined(CONFIG_RTD287X_23x23_QC)	
	PDL_IntRegThreeOperandCmd(psScriptCB, &PDL_IntRegOpIMUL, IMG_FALSE);
#else	
	PDL_IntRegThreeOperandCmd(psScriptCB, &PDL_IntRegOpIMUL);
#endif
}

IMG_VOID PDL_IntRegDIV(PDL_psScriptCB psScriptCB)
{
	VERBOSE_OUTPUT(INTREG_DIV, psScriptCB->pui32Script);
#if defined(CONFIG_RTD287X_QC) || defined(CONFIG_RTD287XP_QC)|| defined(CONFIG_RTD287X_23x23_QC)	
	PDL_IntRegThreeOperandCmd(psScriptCB, &PDL_IntRegOpDIV, IMG_FALSE);
#else	
	PDL_IntRegThreeOperandCmd(psScriptCB, &PDL_IntRegOpDIV);
#endif
}

IMG_VOID PDL_IntRegIDIV(PDL_psScriptCB psScriptCB)
{
	VERBOSE_OUTPUT(INTREG_IDIV, psScriptCB->pui32Script);
#if defined(CONFIG_RTD287X_QC) || defined(CONFIG_RTD287XP_QC)|| defined(CONFIG_RTD287X_23x23_QC)	
	PDL_IntRegThreeOperandCmd(psScriptCB, &PDL_IntRegOpIDIV, IMG_FALSE);
#else	
	PDL_IntRegThreeOperandCmd(psScriptCB, &PDL_IntRegOpIDIV);
#endif
}

IMG_VOID PDL_IntRegMOD(PDL_psScriptCB psScriptCB)
{
	VERBOSE_OUTPUT(INTREG_MOD, psScriptCB->pui32Script);
#if defined(CONFIG_RTD287X_QC) || defined(CONFIG_RTD287XP_QC)|| defined(CONFIG_RTD287X_23x23_QC)	
	PDL_IntRegThreeOperandCmd(psScriptCB, &PDL_IntRegOpMOD, IMG_FALSE);
#else	
	PDL_IntRegThreeOperandCmd(psScriptCB, &PDL_IntRegOpMOD);
#endif
}

IMG_VOID PDL_IntRegEQU(PDL_psScriptCB psScriptCB)
{
	VERBOSE_OUTPUT(INTREG_EQU, psScriptCB->pui32Script);
#if defined(CONFIG_RTD287X_QC) || defined(CONFIG_RTD287XP_QC)|| defined(CONFIG_RTD287X_23x23_QC)	
	PDL_IntRegThreeOperandCmd(psScriptCB, &PDL_IntRegOpEQU, IMG_FALSE);
#else	
	PDL_IntRegThreeOperandCmd(psScriptCB, &PDL_IntRegOpEQU);
#endif
}

IMG_VOID PDL_IntRegGT(PDL_psScriptCB psScriptCB)
{
	VERBOSE_OUTPUT(INTREG_GT, psScriptCB->pui32Script);
#if defined(CONFIG_RTD287X_QC) || defined(CONFIG_RTD287XP_QC)|| defined(CONFIG_RTD287X_23x23_QC)
	PDL_IntRegThreeOperandCmd(psScriptCB, &PDL_IntRegOpGT, IMG_FALSE);
#else	
	PDL_IntRegThreeOperandCmd(psScriptCB, &PDL_IntRegOpGT);
#endif
}

IMG_VOID PDL_IntRegGTE(PDL_psScriptCB psScriptCB)
{
	VERBOSE_OUTPUT(INTREG_GTE, psScriptCB->pui32Script);
#if defined(CONFIG_RTD287X_QC) || defined(CONFIG_RTD287XP_QC)|| defined(CONFIG_RTD287X_23x23_QC)
	PDL_IntRegThreeOperandCmd(psScriptCB, &PDL_IntRegOpGTE, IMG_FALSE);
#else	
	PDL_IntRegThreeOperandCmd(psScriptCB, &PDL_IntRegOpGTE);
#endif
}

IMG_VOID PDL_IntRegLT(PDL_psScriptCB psScriptCB)
{
	VERBOSE_OUTPUT(INTREG_LT, psScriptCB->pui32Script);
#if defined(CONFIG_RTD287X_QC) || defined(CONFIG_RTD287XP_QC)|| defined(CONFIG_RTD287X_23x23_QC)	
	PDL_IntRegThreeOperandCmd(psScriptCB, &PDL_IntRegOpLT, IMG_FALSE);
#else	
	PDL_IntRegThreeOperandCmd(psScriptCB, &PDL_IntRegOpLT);
#endif
}

IMG_VOID PDL_IntRegLTE(PDL_psScriptCB psScriptCB)
{
	VERBOSE_OUTPUT(INTREG_LTE, psScriptCB->pui32Script);
#if defined(CONFIG_RTD287X_QC) || defined(CONFIG_RTD287XP_QC)|| defined(CONFIG_RTD287X_23x23_QC)	
	PDL_IntRegThreeOperandCmd(psScriptCB, &PDL_IntRegOpLTE, IMG_FALSE);
#else	
	PDL_IntRegThreeOperandCmd(psScriptCB, &PDL_IntRegOpLTE);
#endif
}

IMG_VOID PDL_IntRegNEQ(PDL_psScriptCB psScriptCB)
{
	VERBOSE_OUTPUT(INTREG_NEQ, psScriptCB->pui32Script);
#if defined(CONFIG_RTD287X_QC) || defined(CONFIG_RTD287XP_QC)|| defined(CONFIG_RTD287X_23x23_QC)	
	PDL_IntRegThreeOperandCmd(psScriptCB, &PDL_IntRegOpNEQ, IMG_FALSE);
#else	
	PDL_IntRegThreeOperandCmd(psScriptCB, &PDL_IntRegOpNEQ);
#endif
}

#if defined(CONFIG_RTD287X_QC) || defined(CONFIG_RTD287XP_QC) || defined(CONFIG_RTD287X_23x23_QC)
// Int Var operators with int var last parameter

IMG_VOID PDL_IntRegAND_IntReg(PDL_psScriptCB psScriptCB)
{
	VERBOSE_OUTPUT(INTREG_AND_INTREG, psScriptCB->pui32Script);

	PDL_IntRegThreeOperandCmd(psScriptCB, &PDL_IntRegOpAND, IMG_TRUE);
}

IMG_VOID PDL_IntRegOR_IntReg(PDL_psScriptCB psScriptCB)
{
	VERBOSE_OUTPUT(INTREG_OR_INTREG, psScriptCB->pui32Script);

	PDL_IntRegThreeOperandCmd(psScriptCB, &PDL_IntRegOpOR, IMG_TRUE);
}

IMG_VOID PDL_IntRegXOR_IntReg(PDL_psScriptCB psScriptCB)
{
	VERBOSE_OUTPUT(INTREG_XOR_INTREG, psScriptCB->pui32Script);

	PDL_IntRegThreeOperandCmd(psScriptCB, &PDL_IntRegOpXOR, IMG_TRUE);
}

IMG_VOID PDL_IntRegSHR_IntReg(PDL_psScriptCB psScriptCB)
{
	VERBOSE_OUTPUT(INTREG_SHR_INTREG, psScriptCB->pui32Script);

	PDL_IntRegThreeOperandCmd(psScriptCB, &PDL_IntRegOpSHR, IMG_TRUE);
}

IMG_VOID PDL_IntRegSHL_IntReg(PDL_psScriptCB psScriptCB)
{
	VERBOSE_OUTPUT(INTREG_SHL_INTREG, psScriptCB->pui32Script);

	PDL_IntRegThreeOperandCmd(psScriptCB, &PDL_IntRegOpSHL, IMG_TRUE);
}

IMG_VOID PDL_IntRegADD_IntReg(PDL_psScriptCB psScriptCB)
{
	VERBOSE_OUTPUT(INTREG_ADD_INTREG, psScriptCB->pui32Script);

	PDL_IntRegThreeOperandCmd(psScriptCB, &PDL_IntRegOpADD, IMG_TRUE);
}

IMG_VOID PDL_IntRegSUB_IntReg(PDL_psScriptCB psScriptCB)
{
	VERBOSE_OUTPUT(INTREG_SUB_INTREG, psScriptCB->pui32Script);

	PDL_IntRegThreeOperandCmd(psScriptCB, &PDL_IntRegOpSUB, IMG_TRUE);
}

IMG_VOID PDL_IntRegMUL_IntReg(PDL_psScriptCB psScriptCB)
{
	VERBOSE_OUTPUT(INTREG_MUL_INTREG, psScriptCB->pui32Script);

	PDL_IntRegThreeOperandCmd(psScriptCB, &PDL_IntRegOpMUL, IMG_TRUE);
}

IMG_VOID PDL_IntRegIMUL_IntReg(PDL_psScriptCB psScriptCB)
{
	VERBOSE_OUTPUT(INTREG_IMUL_INTREG, psScriptCB->pui32Script);

	PDL_IntRegThreeOperandCmd(psScriptCB, &PDL_IntRegOpIMUL, IMG_TRUE);
}

IMG_VOID PDL_IntRegDIV_IntReg(PDL_psScriptCB psScriptCB)
{
	VERBOSE_OUTPUT(INTREG_DIV_INTREG, psScriptCB->pui32Script);

	PDL_IntRegThreeOperandCmd(psScriptCB, &PDL_IntRegOpDIV, IMG_TRUE);
}

IMG_VOID PDL_IntRegIDIV_IntReg(PDL_psScriptCB psScriptCB)
{
	VERBOSE_OUTPUT(INTREG_IDIV_INTREG, psScriptCB->pui32Script);

	PDL_IntRegThreeOperandCmd(psScriptCB, &PDL_IntRegOpIDIV, IMG_TRUE);
}

IMG_VOID PDL_IntRegMOD_IntReg(PDL_psScriptCB psScriptCB)
{
	VERBOSE_OUTPUT(INTREG_MOD_INTREG, psScriptCB->pui32Script);

	PDL_IntRegThreeOperandCmd(psScriptCB, &PDL_IntRegOpMOD, IMG_TRUE);
}

IMG_VOID PDL_IntRegEQU_IntReg(PDL_psScriptCB psScriptCB)
{
	VERBOSE_OUTPUT(INTREG_EQU_INTREG, psScriptCB->pui32Script);

	PDL_IntRegThreeOperandCmd(psScriptCB, &PDL_IntRegOpEQU, IMG_TRUE);
}

IMG_VOID PDL_IntRegGT_IntReg(PDL_psScriptCB psScriptCB)
{
	VERBOSE_OUTPUT(INTREG_GT_INTREG, psScriptCB->pui32Script);

	PDL_IntRegThreeOperandCmd(psScriptCB, &PDL_IntRegOpGT, IMG_TRUE);
}

IMG_VOID PDL_IntRegGTE_IntReg(PDL_psScriptCB psScriptCB)
{
	VERBOSE_OUTPUT(INTREG_GTE_INTREG, psScriptCB->pui32Script);

	PDL_IntRegThreeOperandCmd(psScriptCB, &PDL_IntRegOpGTE, IMG_TRUE);
}

IMG_VOID PDL_IntRegLT_IntReg(PDL_psScriptCB psScriptCB)
{
	VERBOSE_OUTPUT(INTREG_LT_INTREG, psScriptCB->pui32Script);

	PDL_IntRegThreeOperandCmd(psScriptCB, &PDL_IntRegOpLT, IMG_TRUE);
}

IMG_VOID PDL_IntRegLTE_IntReg(PDL_psScriptCB psScriptCB)
{
	VERBOSE_OUTPUT(INTREG_LTE_INTREG, psScriptCB->pui32Script);

	PDL_IntRegThreeOperandCmd(psScriptCB, &PDL_IntRegOpLTE, IMG_TRUE);
}

IMG_VOID PDL_IntRegNEQ_IntReg(PDL_psScriptCB psScriptCB)
{
	VERBOSE_OUTPUT(INTREG_NEQ_INTREG, psScriptCB->pui32Script);

	PDL_IntRegThreeOperandCmd(psScriptCB, &PDL_IntRegOpNEQ, IMG_TRUE);
}
#endif
/******************************************************************************/
/*                                                                            */
/*		Startup and script processing loop functions                          */
/*																			  */
/******************************************************************************/
IMG_VOID CheckSignature(IMG_PUINT32 pui32SigAddr, IMG_UINT32 ui32Sig)
{
	if ((((IMG_UINTPTR)pui32SigAddr) & 0x00000003) != 0x00000000)
	{
		/* Not 32 bit aligned */
		ERROR_OUTPUT("Not 32-bit Aligned\n");
        PDL_ASSERT(IMG_FALSE);
	}
	else if ((*pui32SigAddr & PDL_SIGNATURE_MASK) != ui32Sig)
    {
        /* Not the expected signature */
        ERROR_OUTPUT("Not the expected Signature \n");
	printf("PDL_SIGNATURE_MASK=%x *pui32SigAddr=%x",PDL_SIGNATURE_MASK,*pui32SigAddr);
        PDL_ASSERT(IMG_FALSE);
    }
}

/******************************************************************************/

IMG_VOID CheckValidScript(IMG_PUINT32 pui32ScriptPointer)
{
	IMG_PUINT32 pui32;
	
	pui32 = pui32ScriptPointer;

	/* Possible to check for valid pointer? */
	//if ( 0 /* Check pui32 for validity ? */ )
	//{
	//	/* Placeholder for address validity check failure */
	//	ERROR_OUTPUT("Placeholder for address validity check failure\n");
    //    PDL_ASSERT(IMG_FALSE);
	//}
	//else
	{
		/* Check 1st signature valid */
		CheckSignature(pui32, PDL_SIGNATURE1);

		/* 1st signature valid. Move to where the 2nd signature should be and check. */
		pui32 += pui32[1];
		pui32 += 2;
		CheckSignature(pui32, PDL_SIGNATURE2);
	}
}

/******************************************************************************/

/*!
********************************************************************************

 @Function				ProcessScripts

*******************************************************************************/
IMG_BOOL ProcessScripts(IMG_VOID)
{
	IMG_UINT32 i, ui32ScriptFnIndex, ui32MinWait = PDL_POLLCOUNT_INFINITE;
	IMG_BOOL bAllWaiting, bAllAtEOF = IMG_FALSE, bAllWaitOrPoll = IMG_FALSE;

	//printf("func=%s line=%d gui32NumScripts=%d...... \n",__FUNCTION__,__LINE__,gui32NumScripts);	
	while (!bAllAtEOF)
	{
		if (bAllWaitOrPoll)
			ui32MinWait = PDL_POLLCOUNT_INFINITE;
	    //printf("func=%s line=%d ..... \n",__FUNCTION__,__LINE__);	
		/* Process next command from PDUMP files...*/
		for (i = 0; i < gui32NumScripts; i++)
		{
			if (!asScriptCB[i].bEOF && !asScriptCB[i].bWaiting)
			{
				if (asScriptCB[i].pui32Script == asScriptCB[i].pui32ScriptBase)
				{
					CheckValidScript(asScriptCB[i].pui32Script);
					asScriptCB[i].pui32Script += 2;
				}
				/* If all are waiting on polls or syncs find the shortest waiting time */
				if (bAllWaitOrPoll)
				{
					IMG_UINT32 ui32WaitTime = 0;
					
					if (asScriptCB[i].ui32TimeCount < asScriptCB[i].ui32Delay)
						ui32WaitTime = asScriptCB[i].ui32Delay - asScriptCB[i].ui32TimeCount;

					if (ui32WaitTime < ui32MinWait)
						ui32MinWait = ui32WaitTime;
				}

				if (!bAllWaitOrPoll || ui32MinWait == 0)
				{
					if ((*asScriptCB[i].pui32Script & PDL_SIGNATURE_MASK) != PDL_SIGNATURE2)
					{
						ui32ScriptFnIndex = (*asScriptCB[i].pui32Script) & ~TAL_PDUMPL_NO_OPTIMISE;
						if (ui32ScriptFnIndex <= ui32MaxScriptFunction)
						{
							if (asScriptCB[i].bPollPending)
							{
								asScriptCB[i].ui32TimeCount ++;
						         //printf("func=%s line=%d ..... ui32ScriptFnIndex=%d\n",__FUNCTION__,__LINE__,ui32ScriptFnIndex);
								if (asScriptCB[i].ui32TimeCount >= asScriptCB[i].ui32Delay){
							        (pfnScriptFunction[ui32ScriptFnIndex])(&asScriptCB[i]);
								}
								if(g_ret == IMG_FALSE)
									return IMG_FALSE;
						         //printf("func=%s line=%d ..... ui32ScriptFnIndex=%d\n",__FUNCTION__,__LINE__,ui32ScriptFnIndex);
							}
							else
							{
								/* Save file id and line number in case of failure */
								asScriptCB[i].ui32FileID	= asScriptCB[i].pui32Script[1];
								asScriptCB[i].ui32LineNum	= asScriptCB[i].pui32Script[2];
						         //printf("func=%s line=%d ..... ui32ScriptFnIndex=%d\n",__FUNCTION__,__LINE__,ui32ScriptFnIndex);
								(pfnScriptFunction[ui32ScriptFnIndex])(&asScriptCB[i]);
								if(g_ret == IMG_FALSE)
									return IMG_FALSE;
						         //printf("func=%s line=%d ..... ui32ScriptFnIndex=%d\n",__FUNCTION__,__LINE__,ui32ScriptFnIndex);
							}
							if(g_ret == IMG_FALSE)
							    return IMG_FALSE;
						}
						else
						{
							PDL_ASSERT(asScriptCB[i].pui32Script);
						}
					    //printf("func=%s line=%d ..... \n",__FUNCTION__,__LINE__);
					}
					else
					{
						asScriptCB[i].bEOF = IMG_TRUE;
					}
				}
			}
		}
	    //printf("func=%s line=%d ..... \n",__FUNCTION__,__LINE__);
		/* If they are all waiting then wait till next crucial time point */
		if ((bAllWaitOrPoll == IMG_TRUE) && (ui32MinWait != 0))
		{
			for (i = 0; i < gui32NumScripts; i++)
			{
				/* If this script is not at EOF and not waiting for sync...*/
				if (!asScriptCB[i].bEOF && !asScriptCB[i].bWaiting)
				{
					if (!asScriptCB[i].bPollPending)
						PDL_ASSERT(asScriptCB[i].pui32Script);

					asScriptCB[i].ui32TimeCount += ui32MinWait;
				}
			}
            
			/* Wait appropriate time */
			Delay(ui32MinWait);
		}
		/* Check if all files are at EOF or are waiting for a SYNC ...*/
		bAllAtEOF = IMG_TRUE;
		bAllWaiting = IMG_TRUE;
		bAllWaitOrPoll = IMG_TRUE;
		for (i = 0; i < gui32NumScripts; i++)
		{
			bAllAtEOF = bAllAtEOF && asScriptCB[i].bEOF;
			bAllWaiting = bAllWaiting && (asScriptCB[i].bWaiting);
			bAllWaitOrPoll = bAllWaitOrPoll && ( asScriptCB[i].bEOF || asScriptCB[i].bWaiting || asScriptCB[i].bPollPending );
		}
	    //printf("func=%s line=%d ..... \n",__FUNCTION__,__LINE__);
		/* If we have found a condition of all the scripts being stuck */
		if (bAllWaiting)
			PDL_ASSERT(asScriptCB[i].pui32Script);
	    //printf("func=%s line=%d ..... \n",__FUNCTION__,__LINE__);
	}
    
	PDL_SUCCESS();
	if(g_ret == IMG_FALSE)
		return IMG_FALSE;
	return IMG_TRUE;
}

/*!
********************************************************************************

 @Function				GetSystemSyncId

*******************************************************************************/
static IMG_UINT32 GetSystemSyncId ( )
{
	return _ui32SysSyncId++;
}

/*!
********************************************************************************

 @Function				GetScript

*******************************************************************************/
static PDL_psScriptCB GetScript(IMG_UINT32 ui32ScriptId, IMG_UINT32	ui32TestId)
{
	PDL_psScriptCB psScriptCB = IMG_NULL;
	IMG_UINT32 i = 1;
	
	/* Count through to the correct script Number */
	for (i = 0; i < gui32NumScripts; i++)
	{
		psScriptCB	= &asScriptCB[i];

		if ((ui32ScriptId == psScriptCB->ui32ScriptId) &&
            (ui32TestId == psScriptCB->ui32TestId))
		{
			break;
		}
	}

	if (i >= gui32NumScripts)
	{		
		PDL_ASSERT(psScriptCB->pui32Script);
		return IMG_NULL;
	}
	return psScriptCB;
}

/*!
********************************************************************************

 @Function				DisableSync

*******************************************************************************/
static IMG_VOID DisableSync(IMG_UINT32 ui32SyncId, IMG_UINT32	ui32TestId)
{	
	IMG_UINT32 i;

	for (i = 0; i < gui32NumScripts; i++)
	{
		PDL_psScriptCB psScriptCB = &asScriptCB[i];

		if (psScriptCB->ui32TestId == ui32TestId)
			psScriptCB->ui32DisabledSyncs |= (1 << ui32SyncId);
	}
}

/*!
********************************************************************************

 @Function				GetSysSyncId
 
*******************************************************************************/
IMG_UINT32 GetSysSyncId(PDL_psScriptCB psScriptCB, IMG_UINT32 ui32SyncId)
{
	PDL_psTestCB psTestCB = &asTestCB[psScriptCB->ui32TestId - 1];
	IMG_UINT32 ui32SysSyncId;

	/*Check for a valid Sync Id  */
	if (ui32SyncId >= MAX_SYNC_IDS)
		PDL_ASSERT(psScriptCB->pui32Script);	
	
	/* Check to see if this sync is disabled */
	if (psScriptCB->ui32DisabledSyncs & (1 << ui32SyncId) )
		return 0;

	/* Find the system sync Id or get a new one */
	ui32SysSyncId = psTestCB->aui32SystemSyncId[ui32SyncId];
	if (ui32SysSyncId == 0)
	{
		ui32SysSyncId = GetSystemSyncId();
		psTestCB->aui32SystemSyncId[ui32SyncId] = ui32SysSyncId;
	}
	return ui32SysSyncId;
}

/*!
******************************************************************************

 @Function				IntraSync

******************************************************************************/
IMG_VOID IntraSync(IMG_UINT32 ui32TestId, IMG_UINT32 ui32SyncId,
                   IMG_UINT32 ui32ScriptId)
{
	PDL_psScriptCB psScriptCB = IMG_NULL;
	PDL_psTestCB psTestCB;

	/* Check the sync id is valid */
	if (ui32SyncId >= 32)
		PDL_ASSERT(psScriptCB->pui32Script);

	/* Locate the test */
	psTestCB = &asTestCB [ui32TestId - 1];

	/* Check that this sync Id has not already been used */
    if (psTestCB->aui32SystemSyncId[ui32SyncId] == 0)
	{
		/* Set a system sync Id */
		psTestCB->aui32SystemSyncId[ui32SyncId] = GetSystemSyncId();

		/* Disable Syncs */
		DisableSync(ui32SyncId, ui32TestId);
	}

	/* Find Defined Script */
	psScriptCB = GetScript(ui32ScriptId, ui32TestId);


	/* Enable this script */
	psScriptCB->ui32DisabledSyncs = psScriptCB->ui32DisabledSyncs & (~(1 << ui32SyncId));
}

/*!
******************************************************************************

 @Function				InterSync

******************************************************************************/
IMG_VOID InterSync(IMG_UINT32 ui32TestId1, IMG_UINT32 ui32Sync1,
                   IMG_UINT32 ui32TestId2, IMG_UINT32 ui32Sync2)
{
	PDL_psTestCB psTestCB1, psTestCB2;
	IMG_UINT32 ui32SysSync;

	/* Check the sync ids are valid */
	if ((ui32Sync1 >= NO_SYSSYNC_IDS) || (ui32Sync1 < MAX_SYNC_IDS)	||
        (ui32Sync2 >= NO_SYSSYNC_IDS) || (ui32Sync2 < MAX_SYNC_IDS))
	{
		PDL_ASSERT(IMG_FALSE);
	}

	/* Locate the tests */
	psTestCB1 = &asTestCB[ui32TestId1 - 1];
	psTestCB2 = &asTestCB[ui32TestId2 - 1];

	/* Check to see if one of the tests already has a Sync Id defined */
	if (psTestCB1->aui32SystemSyncId[ui32Sync1] != 0)
	{
		/* If one of the Ids is already set the other shouldn't be */
		if (psTestCB2->aui32SystemSyncId[ui32Sync2] != 0)
			PDL_ASSERT(IMG_FALSE);

		ui32SysSync = psTestCB1->aui32SystemSyncId[ui32Sync1];
	}
	else if (psTestCB2->aui32SystemSyncId[ui32Sync2] != 0)
	{
		/* If one of the Ids is already set the other shouldn't be */
		if (psTestCB1->aui32SystemSyncId[ui32Sync1] != 0)
		{
			ERROR_OUTPUT("Script Function No out of range\n");
			PDL_ASSERT(IMG_FALSE);
		}

		ui32SysSync = psTestCB2->aui32SystemSyncId[ui32Sync2];
	}
	else
	{
		/* Neither is defined so get a new one */
		ui32SysSync = GetSystemSyncId();
	}

	/* Set the system Sync Ids to the same value */
	psTestCB1->aui32SystemSyncId[ui32Sync1] = ui32SysSync;
	psTestCB2->aui32SystemSyncId[ui32Sync2] = ui32SysSync;
}

/*!
******************************************************************************

 @Function				InitialiseScript

******************************************************************************/
IMG_VOID InitialiseScript(PDL_psScriptCB psScriptCB, IMG_UINT32 ui32TestId,
                          IMG_UINT32 ui32ScriptId,
                          IMG_PUINT32 pui32StartLocation)
{
	psScriptCB->ui32ScriptId = ui32ScriptId;
	psScriptCB->ui32TestId = ui32TestId;

	psScriptCB->pui32ScriptBase = pui32StartLocation;
	psScriptCB->pui32Script = pui32StartLocation;
	psScriptCB->bEOF = IMG_FALSE;

	psScriptCB->ui32FileID = 0xFFFFFFFF;
	psScriptCB->ui32LineNum = 0;
	
	psScriptCB->ui32DisabledSyncs = 0;
	psScriptCB->bWaiting = IMG_FALSE;
	psScriptCB->ui32SyncWaiting = 0;
	psScriptCB->ui32SemaWaiting = 0;

	psScriptCB->bPollPending = IMG_FALSE;
	psScriptCB->ui32LoopCount = 0;
	psScriptCB->ui32TimeCount = 0;

	psScriptCB->ui32SabFileID = 0xFFFFFFFF;
	psScriptCB->ui32SabLineNum = 0;

	psScriptCB->pvInfo = IMG_NULL;
}

/*!
******************************************************************************

 @Function				PreprocessScripts

******************************************************************************/
IMG_BOOL PreprocessScripts(IMG_VOID)
{
	IMG_UINT32 *pui32ScriptBase = (IMG_PUINT32)pvScriptPointer;
	IMG_UINT32 *pui32ScriptPointer = pui32ScriptBase;
	printf("PreprocessScripts ...... \n");	
       // printf("func=%s line=%d *pui32ScriptPointer=%x, size=%x, numtest=%x ..... \n",__FUNCTION__,__LINE__,*pui32ScriptPointer,pui32ScriptPointer[1], pui32ScriptPointer[2]);
	/* Single script */
	if ((*pui32ScriptPointer & PDL_SIGNATURE_MASK) == PDL_SIGNATURE1)
	{
		InitialiseScript(&asScriptCB[0], 1, 1, pui32ScriptBase);
		gui32NumScripts = 1;
	}
	/* PdumpL header present */
	else if (*pui32ScriptPointer == PDL_SIGNATURE_COMPSCRIPT_HSTART)
	{
		IMG_UINT32 ui32TestId, ui32HSize, ui32NumSyncs, ui32SyncIndex;

		ui32HSize = pui32ScriptPointer[1];
		gui32NumTests = pui32ScriptPointer[2];

		if (gui32NumTests > MAX_PDUMPLTESTS)
		{
			PDL_ASSERT(IMG_FALSE);
			return IMG_FALSE;
		}

		/* Firstly check that the HEND signature is located where it is expected */
		if (pui32ScriptBase[ui32HSize-1] != PDL_SIGNATURE_COMPSCRIPT_HEND)
		{
			PDL_ASSERT(IMG_FALSE);
			return IMG_FALSE;
		}

		pui32ScriptPointer+=3;
	    
		//printf("func=%s line=%d ...... gui32NumTests=%d \n",__FUNCTION__,__LINE__,gui32NumTests);	
		/* For each one of the tests */
		for (ui32TestId = 1; ui32TestId <= gui32NumTests; ui32TestId++)
		{
			IMG_UINT32	ui32Index;
			IMG_UINT32	ui32ScriptId;
			IMG_UINT32	ui32NumScripts = pui32ScriptPointer[0];
			pui32ScriptPointer++;

			/* Initialise the test CB for this test */
			asTestCB[ui32TestId-1].ui32NumScripts = ui32NumScripts;
			for (ui32Index = 0; ui32Index < MAX_SEMAPHORES; ui32Index++)
				asTestCB[ui32TestId-1].ai32Semaphores[ui32Index] = 0;
            
			for (ui32Index = 0; ui32Index < NO_SYSSYNC_IDS; ui32Index++)
				asTestCB[ui32TestId-1].aui32SystemSyncId[ui32Index] = 0;

			/* Parse information for each one of the scripts in the test */
			for (ui32ScriptId = 1; ui32ScriptId <= ui32NumScripts; ui32ScriptId++)
			{
				IMG_PUINT32 pui32ScriptStart = pui32ScriptBase + (ui32HSize + pui32ScriptPointer[0]);
				pui32ScriptPointer++;

				InitialiseScript(&asScriptCB[gui32NumScripts], ui32TestId, ui32ScriptId, pui32ScriptStart);
				gui32NumScripts++;
				
				if (gui32NumScripts > MAX_PDUMPLSCRIPTS)
				{
					/* We may want to increase the number of available scripts */
					PDL_ASSERT(IMG_FALSE);
					return IMG_FALSE;
				}
			}
		}
		//printf("func=%s line=%d ...... gui32NumTests=%d \n",__FUNCTION__,__LINE__,gui32NumTests);
		/* Next we read in the sync information */
		ui32NumSyncs = pui32ScriptPointer[0];
		pui32ScriptPointer++;

		for (ui32SyncIndex = 0; ui32SyncIndex < ui32NumSyncs; ui32SyncIndex++)
		{
			IMG_UINT32 ui32TestNum = pui32ScriptPointer[0];
			IMG_UINT32 ui32SyncId = pui32ScriptPointer[1];
			IMG_UINT32 ui32ElemCount = pui32ScriptPointer[2];
			IMG_UINT32 ui32ElemIndex;
	
			pui32ScriptPointer+=3;

			if (ui32ElemCount == 0)
			{
				/* This is a disable Sync Command */
				DisableSync(ui32SyncId, ui32TestNum);
			}
			else
			{
				for (ui32ElemIndex = 0; ui32ElemIndex < ui32ElemCount; ui32ElemIndex++)
				{
					if (ui32SyncId <= 31)
					{
						IMG_UINT32	ui32ScriptId = pui32ScriptPointer[0];
						
						pui32ScriptPointer++;

						IntraSync(ui32TestNum, ui32SyncId, ui32ScriptId);
					}
					else
					{
						IMG_UINT32 ui32TestNum2 = pui32ScriptPointer[0];
						IMG_UINT32 ui32SyncId2 = pui32ScriptPointer[1];
						
						pui32ScriptPointer+=2;

						InterSync(ui32TestNum, ui32SyncId, ui32TestNum2, ui32SyncId2);
					}
				}
			}
		}

		/* End of header */
		if  (pui32ScriptPointer[0] != PDL_SIGNATURE_COMPSCRIPT_HEND)
		{
			PDL_ASSERT(IMG_FALSE);
			return IMG_FALSE;
		}

		pui32ScriptPointer++;
	}
	else
	{
		/* This case cannot be handled */
		PDL_ASSERT(IMG_FALSE);
		return IMG_FALSE;
	}
	//printf("func=%s line=%d ...... \n",__FUNCTION__,__LINE__);		
	return IMG_TRUE;
}

/******************************************************************************/
/******************************************************************************/
IMG_VOID DoSystemValidationChecks(IMG_VOID)
{
	IMG_PUINT8 pui8;

    /* Check for little-endian, etc */
	pui8 = (IMG_PUINT8)&ui32CheckLittleEndian;
	if (*pui8 != 0x04)
	{
		/* Not little endian */
		ERROR_OUTPUT("Not little endian\n");
        PDL_ASSERT(IMG_FALSE);
	}

	/* Check for ** what else ** ? */
}
/******************************************************************************/

int QC_Verifier_GPU_PATTERN()
{
#ifdef CONFIG_RTD287X_QC_NON_DCACHE   
	int dcache_status_ret=1;
#endif
	int ret=0;
	int max_test=100;
       int icnt =0;
	/* Save args details */
	//gbl_argc = argc;
	//gbl_argv = argv;
        for(icnt =0; icnt < LOOP_CNT; icnt++) 
        {
             //dcache_status_ret=1;
	       ret=0;
              max_test=100;
///////////////////////
            pattern_ptr=0;
            pattern_golden_ptr=0;

             g_ret=IMG_TRUE;
             BIF_count = 0;
            
             pvScriptPointer	= (volatile IMG_PVOID)(IMG_UINTPTR)(GPU_PATTERN_ADDR);        
	       pui8SABOutput     = (IMG_PUINT8)(IMG_UINTPTR)(GPU_PATTERN_OUT_ADDR);
	       golden_ptr          = (IMG_PUINT8)(IMG_UINTPTR)(GPU_PATTERN_GOLDEN_ADDR);
		outptr                 = (IMG_PUINT8)(IMG_UINTPTR)(GPU_PATTERN_OUT_ADDR);  
               ui32CheckLittleEndian = 0x01020304;
			//int				gbl_argc;
			//char **			gbl_argv;
		  gui32BinLitePlayerFlags = 0;
		  //	IMG_UINT64		aui64InternalRegisters[MAX_PDUMPLSCRIPTS][NUMBER_OF_INTERNAL_REGS];
		  //PDL_sScriptCB   asScriptCB[MAX_PDUMPLSCRIPTS];
		  gui32NumScripts = 0;			
		  //	PDL_sTestCB		asTestCB[MAX_PDUMPLTESTS];
		  gui32NumTests = 0;
   		  _ui32SysSyncId = 32;
		  pui32SABOrigin  =0;
///////////////////////
              printf("\n\n [LOOP COUNT=%d]...... \n\n",icnt);
#ifdef CONFIG_RTD287X_QC_NON_DCACHE      
        	dcache_status_ret = dcache_status();
        	
        	if(dcache_status_ret)
        	    dcache_disable();
#endif       	
        	QC_Copy_Pattern_data(GPU_PATTERN_ADDR,GPU_PATTERN_GOLDEN_ADDR);

        	//printf("do_bin_lit ...... \n");
        	//pvScriptPointer = &outlite_5[0];
        	/* Target-specific initialisation */
        	PDL_INIT();
        	printf("do_bin_lit ...... PDL_INIT done \n");

                if (pui8SABOutput)
                {
                    pui32SABOrigin = (IMG_PUINT32)pui8SABOutput;
                    pui8SABOutput += 4;
                    *pui32SABOrigin = 4; // Allow 4 bytes for this variable
                }     

                //printf("run script[%x]\n",(IMG_UINTPTR)(pvScriptPointer));    
            
                /* Verify that the user has set the base pointer and proceed accordingly */
                switch ((IMG_UINTPTR)(pvScriptPointer))
                {
                    case -1:
                        /* Not set! */
                        ERROR_OUTPUT("Base pointer not set\n");
                        PDL_ASSERT(IMG_FALSE);
            			ret = -1;
                        break;			/* Shouldn't actually get here */
                    case 0:
                        /* Set, but just for system validation checks */
                        DoSystemValidationChecks();
            			ret = -1;
            			break;
                    default:
                        /* Gather information about the script(s) */

            	    //printf("func=%s line=%d ..... \n",__FUNCTION__,__LINE__);	
                        if (PreprocessScripts())
                        {
                            // Process the script(s)
                                        ret = ProcessScripts();
                                        g_ret = IMG_TRUE;
                                        BIF_count = 0;
                                        if(ret == IMG_FALSE)
                                        {
                                        	return FAILED;//FAILED
                                        }
                            
                                        printf("max_test=%d \n",max_test);
#ifdef CONFIG_RTD287X_QC_NON_DCACHE
                                        if(dcache_status_ret)
                                        {
                                        dcache_enable();	
                                        }
#endif
                                        if(ret == IMG_TRUE)
                                    	        continue; ////return SUCCESS;//FAILED
                                        else
                                             return FAILED; 

                         }
                        else
                        {
            		        return FAILED;
            		    }

                        break;
                 }

                if(ret == IMG_TRUE)
                    continue; ////return SUCCESS;//FAILED
                else
                    return FAILED;
        }

        return SUCCESS;
    
}

