#include "config.h"
#include "../tb_util.h"
#if MP_M470_MP_F049_DLB_APB

static const char* pattern_0 ="\
TRUE\n\
TRUE\n\
TRUE\n\
TRUE\n\
TRUE\n\
TRUE\n";


static test_vector mp_m470_mp_F049_DLB_APB_vector = {
	.vector_name = "mp_m470_mp_F049_DLB_APB",
	.cmd_string = "\
# This test just writes and reads from a few registers in the REGISTERDMA, \n\
# BROADCAST and LOAD BALANCER units.\n\
# --------------------------------------------------------\n\
reset\n\
# --------------------------------------------------------\n\
# Load balancer setup\n\
# DLB CONFIG: 0x80014000 - 0x80014FFF\n\
# --------------------------------------------------------\n\
writereg 80014000 00050001 # Master tile list physical base address and axi router enable\n\
writereg 80014004 00050000 # Master tile list virtual base address\n\
writereg 80014008 00047000 # Tile list virtual base address writereg 8001400C 000F000F\n\ 
# Framebuffer dimension\n\
writereg 80014010 00010001 # Tile list configuration\n\
writereg 80014014 0F0F0000 # Start tile positions\n\
writereg 80014018 000000FF # PP enable mask\n\
# ---------------------------------------------------------\n\
# Load balancer setup\n\
# DLB CONFIG: 0x80014000 - 0x80014FFF\n\
# ---------------------------------------------------------\n\
check_reg 80014000 = 00050001 > 0  # Master tile list physical base address and axi router enable\n\
check_reg 80014004 = 00050000 >> 0 # Master tile list virtual base address\n\
check_reg 80014008 = 00047000 >> 0 # Tile list virtual base address writereg 8001400C 000F000F\n\
# Framebuffer dimension\n\
check_reg 80014010 = 00010001 >> 0 # Tile list configuration\n\
check_reg 80014014 = 0F0F0000 >> 0 # Start tile positions\n\
check_reg 80014018 = 000000FF >> 0 # PP enable mask\n",
};

mali_error_code mp_m470_mp_F049_DLB_APB(void){
	mali_error_code err = MALI_ERROR_NO_ERROR;
	mp_m470_mp_F049_DLB_APB_vector.pattern_num = 1;
	mp_m470_mp_F049_DLB_APB_vector.pattern[0] = pattern_0;
	mp_m470_mp_F049_DLB_APB_vector.pattern_offset[0] = 0;
	IPRINTF("\n\n\n\n>>>>>enter function mp_m470_mp_F049_DLB_APB <<<<<\n");
	err = cmd_read_configtxt(&mp_m470_mp_F049_DLB_APB_vector);
	return err;

}

#endif

