


void CRT_CLK_OnOff(enum CRT_MODULE module_ip, enum CRT_CLK clken, void *private_data)
{
    switch (module_ip)
    {
        case DTVExtAtsc3:
            if (DTV_ExtAtsc3Demod_CriticalRegister(clken) == CRT_FAIL)
                pr_warn("DTVExtAtsc3 CRT setting fail\n");
            break;
        case TVFRONTEND:
            if (TV_Frontend_CriticalRegister(clken) == CRT_FAIL)
			    pr_warn("TVFRONTEND CRT setting fail\n");
		    break;
        case TVALL:
            if (TV_All_CriticalRegister(clken) == CRT_FAIL)
			    pr_warn("TVALL CRT setting fail\n");
		    break;



    }    
    
}

int DTV_ExtAtsc3Demod_CriticalRegister(enum CRT_CLK clken)
{
	
	if (clken == CLK_ON) {
        rtd_outl(SYS_REG_SYS_SRST4_reg, SYS_REG_SYS_SRST4_rstn_atsc_demod(1)|SYS_REG_SYS_SRST4_write_data(0));
		rtd_outl(SYS_REG_SYS_SRST4_reg, SYS_REG_SYS_SRST4_rstn_atsc_demod(1)|SYS_REG_SYS_SRST4_write_data(1));
		udelay(10);
	} else {
		rtd_outl(SYS_REG_SYS_SRST4_reg, SYS_REG_SYS_SRST4_rstn_atsc_demod(1)|SYS_REG_SYS_SRST4_write_data(0));
	}
	return CRT_SUCCESS;
}

int TV_Frontend_CriticalRegister(enum CRT_CLK clken)
{
	/* 
	//from script
	//IFADC, frontend CLK / RESET flow
	//rtd_outl(0xb8000110, 0x00480001);				//<bit22>Clken_dtv_demod_mb, <bit19>CLKEN_dtv_frontend,  set to 1
	//rtd_outl(0xb8000110, 0x00480000);				//<bit22>Clken_dtv_demod_mb, <bit19>CLKEN_dtv_frontend, set to 0
	rtd_outl(0xb8000100, 0x00080001);				//<bit19>RSTN_dtv_frontend,  set to 1(release)
	rtd_outl(0xb8000104, 0x00000003);				//<bit1>RSTN_dtv_demod_mb,  set to 1(release)
	rtd_outl(0xb8000110, 0x00480001);				//<bit22>Clken_dtv_demod_mb, <bit19>CLKEN_dtv_frontend,  set to 1
	ScalerTimer_DelayXms(10);
	*/
	if (clken == CLK_ON) {
		//rtd_outl(SYS_REG_SYS_CLKEN0_reg, SYS_REG_SYS_CLKEN0_clken_dtv_demod_mb(1) |SYS_REG_SYS_CLKEN0_clken_dtv_frontend(1) |SYS_REG_SYS_CLKEN0_write_data(1));	
		//rtd_outl(SYS_REG_SYS_CLKEN0_reg, SYS_REG_SYS_CLKEN0_clken_dtv_demod_mb(1) |SYS_REG_SYS_CLKEN0_clken_dtv_frontend(1) |SYS_REG_SYS_CLKEN0_write_data(0));
		rtd_outl(SYS_REG_SYS_SRST0_reg, SYS_REG_SYS_SRST0_rstn_dtv_frontend(1) |SYS_REG_SYS_SRST0_write_data(1));
		rtd_outl(SYS_REG_SYS_SRST1_reg, SYS_REG_SYS_SRST1_rstn_dtv_demod_mb(1) |SYS_REG_SYS_SRST1_write_data(1));
		rtd_outl(SYS_REG_SYS_CLKEN0_reg, SYS_REG_SYS_CLKEN0_clken_dtv_demod_mb(1) |SYS_REG_SYS_CLKEN0_clken_dtv_frontend(1) |SYS_REG_SYS_CLKEN0_write_data(1));

		udelay(10);
	} else {
		// no need...
	}
	return CRT_SUCCESS;
}

int TV_All_CriticalRegister(enum CRT_CLK clken)
{
	/* 
	//from script   Demod(A+D) CLK / Reast set to 0
    //ATV turn off	
    rtd_outl(0xb8000104, 0x00800000);							//RSTN_IF_DEMOD<bit23> set to 0(active low)
    rtd_outl(0xb8000108, 0x00400800);							//RSTN_IF_DEMOD_logic<bit22> set to 0(active low)
    rtd_outl(0xb8000114, 0x00800000);							//CLKEN_IF_DEMOD<bit23> set to 0(CLK off)
    ScalerTimer_DelayXms(1);									//driver delay 1mS

    //DTV Demod IP reset
    rtd_outl(0xb8000100, 0x01182000);							//Demod IP Reset<bit24, bit20, bit19, bit13> set to 0(active low)
    rtd_outl(0xb8000108, 0x00000800);							//Demod IP Reset<bit11> set to 0(active low)
    ScalerTimer_DelayXms(1);									//driver delay 1mS

    //DTV Demod Wrapper reset
    rtd_outl(0xb8000100, 0x80e00000);							//Demod IP Reset<bit31, bit23, bit22, bit21> set to 0(active low)
    rtd_outl(0xb8000104, 0x00000002);							//RSTN_dtv_demod_mb<bit2> set to 0(active low)
    ScalerTimer_DelayXms(1);									//driver delay 1mS

    //DTV Demod turn off
    rtd_outl(0xb8000110, 0x81d82000);							//Demod CLK<bit31, bit24, bit23, bit22, bit20, bit19, bit13> set to 0
    rtd_outl(0xb8000118, 0x00000800);							//CLKEN_DTV_DEMOD<bit11> set to 0
    ScalerTimer_DelayXms(1);	
	*/
	
	       //DTV Demod turn off(CLK/RESET), Demod IP off frist then wrapper 
    if (clken == CLK_OFF) {
        //ATV_IFD RESET and CLK OFF
        rtd_outl(SYS_REG_SYS_SRST1_reg, SYS_REG_SYS_SRST1_rstn_if_demod(1)|SYS_REG_SYS_SRST1_write_data(0));
        rtd_outl(SYS_REG_SYS_SRST2_reg, SYS_REG_SYS_SRST2_rstn_if_demod_logic(1)|SYS_REG_SYS_SRST1_write_data(0));
        rtd_outl(SYS_REG_SYS_CLKEN1_reg, SYS_REG_SYS_CLKEN1_clken_if_demod(1)|SYS_REG_SYS_CLKEN1_write_data(0));

        //DTV_IP reset
        rtd_outl(SYS_REG_SYS_SRST0_reg, SYS_REG_SYS_SRST0_rstn_atb_demod(1)|SYS_REG_SYS_SRST0_rstn_hdic(1)|SYS_REG_SYS_SRST0_rstn_dtv_frontend(1)|SYS_REG_SYS_SRST0_rstn_rtk_demod(1)|SYS_REG_SYS_SRST0_write_data(0));
        rtd_outl(SYS_REG_SYS_SRST2_reg, SYS_REG_SYS_SRST2_rstn_dtv_demod(1)|SYS_REG_SYS_SRST2_write_data(0));
        mdelay(1);
        //DTV_warpper reset
        rtd_outl(SYS_REG_SYS_SRST0_reg, SYS_REG_SYS_SRST0_rstn_diseqc(1)|SYS_REG_SYS_SRST0_rstn_atb_demod_wrap(1)|SYS_REG_SYS_SRST0_rstn_hdic_apb(1)|SYS_REG_SYS_SRST0_rstn_hdic_axi(1)|SYS_REG_SYS_SRST0_write_data(0));
        rtd_outl(SYS_REG_SYS_SRST1_reg, SYS_REG_SYS_SRST1_rstn_dtv_demod_mb(1)|SYS_REG_SYS_SRST1_write_data(0));
        mdelay(1);
        //turn off clk
		rtd_outl(SYS_REG_SYS_CLKEN0_reg, SYS_REG_SYS_CLKEN0_clken_diseqc(1)|SYS_REG_SYS_CLKEN0_clken_atb_demod(1)|SYS_REG_SYS_CLKEN0_clken_atb_demod_wrap(1)|SYS_REG_SYS_CLKEN0_clken_dtv_demod_mb(1)|SYS_REG_SYS_CLKEN0_clken_hdic(1)|SYS_REG_SYS_CLKEN0_clken_dtv_frontend(1)|SYS_REG_SYS_CLKEN0_clken_rtk_demod(1)|SYS_REG_SYS_CLKEN0_write_data(0));
		rtd_outl(SYS_REG_SYS_CLKEN2_reg, SYS_REG_SYS_CLKEN2_clken_dtv_demod(1)|SYS_REG_SYS_CLKEN2_write_data(0));
		udelay(10);
	} else {
		//please turn on by tv standard...
	}
	return CRT_SUCCESS;
}