#include <qc_verify_common.h>
#include <hdmi_qc.h>
#include "mhl_cbus.h"
#include "MHL3.h"
#include "MHL_CDF.h"

typedef struct {
	unsigned int Info;   //[0] : cbus transmit ready or not
	                          //[1] : reconnect  or not
	                          //[2] : 1 sec rotine command  ,write ready command per 1 sec
	                          //[3] : MHL or not
	UINT16 MHL_TIMER1;  // For release  SET_MHL_READY_TO_TRANSMIT
	UINT16 MHL_TIMER2;  // For  RECONNECT_1K
	UINT16 MHL_TIMER3;  // For CONNECT_DCAP_RDY command  1 sec send 1 times
	UINT8   MHL_CBUS_CMD_ST;
	UINT8   bBuf[16];
} MHL_PARAM_T;
MHL_PARAM_T MHL_CTRL;

UINT8 _bMhl_clk_mode;


void CBUS_InitialPHYSettings(void)
{
#if defined(CONFIG_RTD299O_QC)
	hdmiport_mask(CBUS_PMM_CBUS_PHY_0_reg,
		~(CBUS_PMM_CBUS_PHY_0_cbus_control_mask|CBUS_PMM_CBUS_PHY_0_en_bias_txrx_mask|CBUS_PMM_CBUS_PHY_0_ldo_vsel_txrx_mask|CBUS_PMM_CBUS_PHY_0_en_ldo_txrx_mask),
		(CBUS_PMM_CBUS_PHY_0_cbus_control(0x8)|CBUS_PMM_CBUS_PHY_0_en_bias_txrx_mask|CBUS_PMM_CBUS_PHY_0_ldo_vsel_txrx(0x01)|CBUS_PMM_CBUS_PHY_0_en_ldo_txrx_mask));
#else
	hdmiport_mask(CBUS_PMM_CBUS_PHY_0_reg,~(CBUS_PMM_CBUS_PHY_0_en_bias_txrx_mask|CBUS_PMM_CBUS_PHY_0_en_ldo_txrx_mask),(CBUS_PMM_CBUS_PHY_0_en_bias_txrx_mask|CBUS_PMM_CBUS_PHY_0_en_ldo_txrx_mask));
#endif
	hdmiport_mask(CBUS_PMM_CBUS_PHY_4_reg, ~(CBUS_PMM_CBUS_PHY_4_adjr_100k_rx_mask), CBUS_PMM_CBUS_PHY_4_adjr_100k_rx(0xa));
	hdmiport_mask(CBUS_PMM_CBUS_PHY_4_reg, ~(CBUS_PMM_CBUS_PHY_4_auto_k_100k_rx_mask), 0);
	hdmiport_mask(CBUS_PMM_CBUS_PHY_4_reg, ~(CBUS_PMM_CBUS_PHY_4_auto_k_100k_rx_mask), (CBUS_PMM_CBUS_PHY_4_auto_k_100k_rx_mask));

	hdmiport_mask(CBUS_PMM_CBUS_PHY_4_reg, ~CBUS_PMM_CBUS_PHY_4_en_res_cal_cbus_rx_mask, 0);
	hdmiport_mask(CBUS_PMM_CBUS_PHY_4_reg, ~CBUS_PMM_CBUS_PHY_4_en_res_cal_cbus_rx_mask, CBUS_PMM_CBUS_PHY_4_en_res_cal_cbus_rx_mask);

	hdmiport_mask(CBUS_PMM_CBUS_PHY_4_reg, ~(CBUS_PMM_CBUS_PHY_4_sel_input_high_rx_mask|CBUS_PMM_CBUS_PHY_4_sel_input_low_rx_mask), (CBUS_PMM_CBUS_PHY_4_sel_input_high_rx(0)|CBUS_PMM_CBUS_PHY_4_sel_input_low_rx(1)));
	MHL_Z100k_Switch(MHL_CHANNEL, 0);
}

/***************************************************************************************/
//Function :   void MHLInitialMACSettings(void)
//Description:  Cbus setting
//
//return: S
/**************************************************************************************/
void MHLInitialMACSettings(void)
{
	// Write clear wake pulse & discovery pulse
	hdmiport_mask(CBUS_PMM_CBUS_STANDBY_00_reg, ~(CBUS_PMM_CBUS_STANDBY_00_wake_pulse_det_mask|CBUS_PMM_CBUS_STANDBY_00_dis_pulse_det_mask),(CBUS_PMM_CBUS_STANDBY_00_wake_pulse_det_mask|CBUS_PMM_CBUS_STANDBY_00_dis_pulse_det_mask));

	// Set MHL 1MHz Clk Divider  27M clock
	hdmiport_mask(CBUS_PMM_CBUS_STANDBY_01_reg, ~(CBUS_PMM_CBUS_STANDBY_01_clk_1m_div_mask), CBUS_PMM_CBUS_STANDBY_01_clk_1m_div(13));

	//cloud fix for HTC issue
	hdmiport_mask(CBUS_PMM_CBUS_STANDBY_01_reg, ~(CBUS_PMM_CBUS_STANDBY_01_clk_1k_div_mask), CBUS_PMM_CBUS_STANDBY_01_clk_1k_div(519));  //519* 1.25
	//initial wake up pulse width
	//2013 0621 for HTC wake up timing  16.25msec ~33.75msec
	hdmiport_mask(CBUS_PMM_CBUS_STANDBY_04_reg,~(CBUS_PMM_CBUS_STANDBY_04_wake_offset_low_mask|CBUS_PMM_CBUS_STANDBY_04_wake_offset_low2_mask|CBUS_PMM_CBUS_STANDBY_04_cbus_disconn_mask|CBUS_PMM_CBUS_STANDBY_04_wake_cnt_mask),(CBUS_PMM_CBUS_STANDBY_04_wake_offset(7)|CBUS_PMM_CBUS_STANDBY_04_wake_offset_low(7)|CBUS_PMM_CBUS_STANDBY_04_wake_offset_low2(7)));//20msec +-7msec

	//Set Cbus discuss  Low Time to 150us
	hdmiport_mask(CBUS_PMM_CBUS_STANDBY_02_reg, ~(CBUS_PMM_CBUS_STANDBY_02_disconn_mask), CBUS_PMM_CBUS_STANDBY_02_disconn(1)); //cloud test for 4.3.20

	// Set Discovery Upper/Lower Bound  60 micro second ~ 140 micro sec
	hdmiport_mask(CBUS_PMM_CBUS_STANDBY_05_reg, ~(CBUS_PMM_CBUS_STANDBY_05_dis_upper_mask|CBUS_PMM_CBUS_STANDBY_05_dis_lower_mask), (CBUS_PMM_CBUS_STANDBY_05_dis_upper(5)|CBUS_PMM_CBUS_STANDBY_05_dis_lower(5)));

	hdmiport_mask(CBUS_DUMMY0_reg, ~(CBUS_CBUS_DUMMY0_ddc_idle_no_tx_abort_gated_mask), CBUS_CBUS_DUMMY0_ddc_idle_no_tx_abort_gated_mask); /* 4.3.17.2 */
}

void CDF_Cability_Setting(void)
{
	hdmiport_mask(MSC_REG_01_reg, ~MSC_REG_01_mhl_ver_mask, (CDF_CR_MHL_VER_MAJOR<<4)|CDF_CR_MHL_VER_MINOR);  //MHL 2.0
	hdmiport_mask(MSC_REG_02_reg, ~(MSC_REG_02_plim_mask|MSC_REG_02_pow_mask|MSC_REG_02_dev_type_mask), MSC_REG_02_plim(CDF_CR_POW_PLIM)|MSC_REG_02_pow(CDF_CR_POW)|MSC_REG_02_dev_type(CDF_CR_DEV_TYPE));  //MHL 2.0
	//adopter_H
	hdmi_out (MSC_REG_03_reg,CDF_CR_ADOPTER_ID_H);
	// adopter_L
	hdmi_out (MSC_REG_04_reg,CDF_CR_ADOPTER_ID_L);


	hdmiport_mask(MSC_REG_05_reg, ~(MSC_REG_05_vid_link_md_mask|MSC_REG_05_supp_vga_mask|MSC_REG_05_supp_islands_mask|MSC_REG_05_supp_ppixel_mask|MSC_REG_05_supp_yuv422_mask|MSC_REG_05_supp_yuv444_mask|MSC_REG_05_supp_rgb444_mask),
		(MSC_REG_05_vid_link_md(CDF_CR_SUPP_16BPP)|MSC_REG_05_supp_vga(CDF_CR_SUPP_VGA))|MSC_REG_05_supp_islands(CDF_CR_SUPP_ISLANDS)|MSC_REG_05_supp_ppixel(CDF_CR_SUPP_PPIXEL)|MSC_REG_05_supp_yuv422(CDF_CR_SUPP_YCBCR422)|MSC_REG_05_supp_yuv444(CDF_CR_SUPP_YCBCR444)|MSC_REG_05_supp_rgb444(CDF_CR_SUPP_YCBCR444));// not support PP mode

	hdmiport_mask(MSC_REG_06_reg, ~(MSC_REG_06_aud_hbr_mask|MSC_REG_06_aud_8ch_mask|MSC_REG_06_aud_2ch_mask), MSC_REG_06_aud_hbr(CDF_CR_HBR)|MSC_REG_06_aud_8ch(CDF_CR_AUD_8CH)|MSC_REG_06_aud_2ch(CDF_CR_AUD_2CH));// not support PP mode

	hdmiport_mask(MSC_REG_07_reg, ~(MSC_REG_07_video_type_mask|MSC_REG_07_vt_game_mask|MSC_REG_07_vt_cinema_mask|MSC_REG_07_vt_photo_mask|MSC_REG_07_vt_graphics_mask),MSC_REG_07_vt_game(CDF_CR_VT_GAME)|MSC_REG_07_vt_cinema(CDF_CR_VT_CINEMA)|MSC_REG_07_vt_photo(CDF_CR_VT_PHOTO)|MSC_REG_07_vt_graphics(CDF_CR_VT_GRAPHICS));

	hdmiport_mask(MSC_REG_08_reg, ~(MSC_REG_08_ld_gui_mask|MSC_REG_08_ld_speaker_mask|MSC_REG_08_ld_record_mask|MSC_REG_08_ld_tuner_mask|MSC_REG_08_ld_media_mask|MSC_REG_08_ld_audio_mask|MSC_REG_08_ld_video_mask|MSC_REG_08_ld_display_mask),MSC_REG_08_ld_gui(CDF_CR_LD_GUI)|MSC_REG_08_ld_speaker(CDF_CR_LD_SPEAKER)|MSC_REG_08_ld_record(CDF_CR_LD_RECORD)|MSC_REG_08_ld_tuner(CDF_CR_LD_TUNER)|MSC_REG_08_ld_media(CDF_CR_LD_MEDIA)|MSC_REG_08_ld_audio(CDF_CR_LD_AUDIO)|MSC_REG_08_ld_video(CDF_CR_LD_VIDEO)|MSC_REG_08_ld_display(CDF_CR_LD_DISPLAY));//

	hdmiport_mask(MSC_REG_09_reg, ~MSC_REG_09_bandwid_mask,MSC_REG_09_bandwid(CDF_CR_BANDWIDTH));// not support PP mode

	hdmiport_mask(MSC_REG_0A_reg, ~(MSC_REG_0A_rbp_supp_mask|MSC_REG_0A_ucp_recv_supp_mask|MSC_REG_0A_ucp_send_supp_mask|MSC_REG_0A_sp_supp_mask|MSC_REG_0A_rap_supp_mask|MSC_REG_0A_rcp_supp_mask), MSC_REG_0A_rbp_supp(CDF_CR_RBP_SUPPORT)|MSC_REG_0A_ucp_recv_supp(CDF_CR_UCP_RECV_SUPPORT)|MSC_REG_0A_ucp_send_supp(CDF_CR_UCP_SEND_SUPPORT)|MSC_REG_0A_sp_supp(CDF_CR_SP_SUPPORT)|MSC_REG_0A_rap_supp(CDF_CR_RAP_SUPPORT)|MSC_REG_0A_rcp_supp(CDF_CR_RCP_SUPPORT));// not support RAP   RCP  UCP send

	hdmiport_mask(MSC_REG_0B_reg, ~MSC_REG_0B_device_id_h_mask,CDF_CR_DEVICE_ID_H);// not support PP mode

	hdmiport_mask(MSC_REG_0C_reg, ~MSC_REG_0C_device_id_l_mask,CDF_CR_DEVICE_ID_L);// not support PP mode

	hdmiport_mask(MSC_REG_0D_reg, ~MSC_REG_0D_scr_size_mask,MSC_REG_0D_scr_size(CDF_CR_SCRATCHPAD_SIZE));// not support PP mode

	hdmiport_mask(MSC_REG_0E_reg, ~(MSC_REG_0E_stat_size_mask|MSC_REG_0E_int_size_mask),MSC_REG_0E_stat_size(CDF_CR_INT_SIZE)|MSC_REG_0E_int_size(CDF_CR_STAT_SIZE));// not support PP mode


#if MHL3_ENABLE
	hdmi_out(CBUS_MSC_REG_80_reg,
		CBUS_MSC_REG_80_ecbus_s_075(CDF_ECBUS_S_75)|
		CBUS_MSC_REG_80_ecbus_s_8b(CDF_ECBUS_S_8BIT)|
		CBUS_MSC_REG_80_ecbus_s_12b(CDF_ECBUS_S_12BIT)|
		CBUS_MSC_REG_80_ecbus_d_150(CDF_ECBUS_D_150)|
		CBUS_MSC_REG_80_ecbus_d_8b(CDF_ECBUS_D_8BIT));		// eCBUS-S 8-bit Mode support only
	hdmi_out(CBUS_MSC_REG_81_reg,
		CBUS_MSC_REG_81_tmds_150(CDF_TMDS_150)|
		CBUS_MSC_REG_81_tmds_300(CDF_TMDS_300)|
		CBUS_MSC_REG_81_tmds_600(CDF_TMDS_600));		// TMDS Support 6Gbps
	hdmi_out(CBUS_MSC_REG_82_reg,
		CBUS_MSC_REG_82_dev_host(CDF_DEV_HOST)|
		CBUS_MSC_REG_82_dev_device(CDF_DEV_DEVICE)|
		CBUS_MSC_REG_82_dev_charger(CDF_DEV_CHARGER)|
		CBUS_MSC_REG_82_hid_host(CDF_HID_HOST)|
		CBUS_MSC_REG_82_hid_dev(CDF_HID_DEVICE));		// HID Device, Charger, USB Device
	hdmi_out(CBUS_MSC_REG_83_reg,
		CBUS_MSC_REG_83_ld_phone(CDF_LD_PHONE));		// Not Support Phone function
	hdmi_out(CBUS_MSC_REG_84_reg,
		(CDF_ACRFS_DIV_8)|
		(CDF_ACRFS_DIV_16<<1)|
		(CDF_ACRFS_DIV_32<<2));		// ACRFD_DIV_SUPPORT
#endif

}

/***************************************************************************************/
//Function :  MHLTmdsInitial(void)
//Description: MHL Tmds Setting
//
//return: SEND MSG RCP key To follower
/**************************************************************************************/
void MHLTmdsInitial(void)
{
	//pn no swap
	hdmiport_mask(MHL_DAL_STATUS_reg, ~(MHL_DAL_STATUS_pn_swap_mask),0);

	//MHL
	hdmiport_mask(MHL_DAL_STATUS_reg,~MHL_DAL_STATUS_mhl_ver_1_2_mask,MHL_DAL_STATUS_mhl_ver_1_2(1));

	hdmiport_mask(MHL_CH_CR_reg, ~(MHL_CH_CR_mhl_ch1_cr_afifo_en_mask|MHL_CH_CR_mhl_ch0_cr_afifo_en_mask), (MHL_CH_CR_mhl_ch1_cr_afifo_en_mask|MHL_CH_CR_mhl_ch0_cr_afifo_en_mask)); // follow script, Mac3 default=1


#if MHL3_ENABLE
	mhl3_init_phy_mac();
#endif
	CDF_Cability_Setting();
#if 0
	rtd_maskl(CRT_SYS_CLKSEL_reg, ~CRT_SYS_CLKSEL_cbus_clksel_mask, CRT_SYS_CLKSEL_cbus_clksel(1));  /*1=audio clk*/
	CBUS_LinkerSetting(196);
#endif
}

void CBUS_LinkerSetting(float fSystemClk)
{
	float  One_clk_period ,fTemp1,fTemp2 ;
	u_int8_t bTemp1,bTemp2;

	// Upper Bound of SYNC Pulse Low Time Period  & Lower Bound
	//ScalerSetByte(P28_AF_CBUS0_CTRL_0F, 0xEA);
	//upper bound of sync pulse
	One_clk_period = 1000/(fSystemClk/2) ; //unit  n -sec
	fTemp1 = 1.6*T_BIT_CBUS_MAX/One_clk_period;
	bTemp1 = (u_int8_t)fTemp1 ;  //0xc2 if clock is 202Mhz
	fTemp2 = 1.4*T_BIT_CBUS_MIN/One_clk_period;
	bTemp2 = (u_int8_t)fTemp2 ;  //0x71 if clock is 202Mhz
	HDMI_PRINTF("[CBUS_LOG] Sync pulse low Time Upper bound  = %x (0xc2)Lower bound = %x (0x71) \n",bTemp1 ,bTemp2);
	hdmiport_mask(CBUS_LINK_00_reg, ~(CBUS_LINK_00_sync0_hb_mask|CBUS_LINK_00_sync0_lb_mask), (CBUS_LINK_00_sync0_hb(bTemp1)|CBUS_LINK_00_sync0_lb(bTemp2)));

	// Upper Bound of SYNC Pulse High Time Period & Lower Bound of SYNC Pulse High Time Period
	//ScalerSetByte(P28_B1_CBUS0_CTRL_11, 0x58);
	fTemp1 = 0.6*T_BIT_CBUS_MAX/One_clk_period;
	bTemp1 = (u_int8_t)fTemp1 ;  //0x48 if clock is 202Mhz
	fTemp2 = 0.4*T_BIT_CBUS_MIN/One_clk_period;
	bTemp2 = (u_int8_t)fTemp2 ;  //0x21 if clock is 202Mhz
	HDMI_PRINTF("[CBUS_LOG] Sync pulse High Time Upper bound  = %x (0x48) Lower bound = %x (0x21) \n",bTemp1 ,bTemp2);
	hdmiport_mask(CBUS_LINK_01_reg, ~(CBUS_LINK_01_sync1_hb_mask|CBUS_LINK_01_sync1_lb_mask), (CBUS_LINK_01_sync1_hb(bTemp1)|CBUS_LINK_01_sync1_lb(bTemp2)));

	// Absolute Threshold Time
	//ScalerSetByte(P28_B4_CBUS0_CTRL_14, 0x5D);// not set bit 8 enable
	fTemp1 = 0.76*T_BIT_CBUS_AVE/One_clk_period; ;
	bTemp1 = (u_int8_t)fTemp1 ;  //0x48 if clock is 202Mhz
	HDMI_PRINTF("[CBUS_LOG] Absolute Threshold Time = %x (0x4d) \n",bTemp1 );
	hdmiport_mask(CBUS_LINK_03_reg, ~(CBUS_LINK_03_abs_threshold_mask), (CBUS_LINK_03_abs_threshold(bTemp1)));

	// Parity Bit Time
	//ScalerSetByte(P28_B5_CBUS0_CTRL_15, 0x79);
	fTemp1 = T_BIT_CBUS_AVE/One_clk_period; ;
	bTemp1 = (u_int8_t)fTemp1 ;  //0x65 if clock is 202Mhz
	HDMI_PRINTF("[CBUS_LOG] Parity Bit Time = %x (0x65) \n",bTemp1 );
	hdmiport_mask(CBUS_LINK_04_reg, ~(CBUS_LINK_04_parity_time_mask), (CBUS_LINK_04_parity_time(bTemp1)));

	// Parity Error Limit
	//ScalerSetBit(P28_B6_CBUS0_CTRL_16, ~(_BIT7 | _BIT4 | _BIT3 | _BIT2 | _BIT1 | _BIT0), 0x0F);

	hdmiport_mask(CBUS_LINK_05_reg, ~(CBUS_LINK_05_parity_limit_mask|CBUS_LINK_05_parity_fail_mask), (CBUS_LINK_05_parity_limit(0x12)|CBUS_LINK_05_parity_fail_mask));

	// Ack Bit Initial Falling Edge
	//ScalerSetBit(P28_B7_CBUS0_CTRL_17, ~(_BIT6 | _BIT5 | _BIT4 | _BIT3 | _BIT2 | _BIT1 | _BIT0), 0x0F);
	//fTemp1 =0.75* 128/One_clk_period;//cloud test
	fTemp1 = 128/One_clk_period;//cloud test
	bTemp1 = (u_int8_t)fTemp1 ;  // if clock is 202Mhz       ????????????
	HDMI_PRINTF("[CBUS_LOG] Ack Bit Initial Falling Edge = %x (0x0d) \n",bTemp1 );
	hdmiport_mask(CBUS_LINK_06_reg, ~(CBUS_LINK_06_ack_fall_mask), (CBUS_LINK_06_ack_fall(bTemp1)));

	// Ack Bit Drive Low Time
	//ScalerSetBit(P28_B8_CBUS0_CTRL_18, ~(_BIT6 | _BIT5 | _BIT4 | _BIT3 | _BIT2 | _BIT1 | _BIT0), 0x3C);
	// 400nsec ~600nsec
	// fTemp1 = 0.96*T_CBUS_ACK_0/One_clk_period;
	fTemp1 = T_CBUS_ACK_0/One_clk_period;
	bTemp1 = (u_int8_t)fTemp1 ;  //0x32  if clock is 202Mhz
	HDMI_PRINTF("[CBUS_LOG] Ack Bit Drive Low Time = %x (0x32) \n",bTemp1 );
	hdmiport_mask(CBUS_LINK_07_reg, ~(CBUS_LINK_07_ack_0_mask), (CBUS_LINK_07_ack_0(bTemp1)));

	// Requester Bit Time
	//ScalerSetByte(P28_BA_CBUS0_CTRL_1A, 0x80);
	// fTemp1 = 1.04*T_TX_bit_time/One_clk_period;
	fTemp1 = T_TX_bit_time/One_clk_period;
	bTemp1 = (u_int8_t)fTemp1 ;  //0x32  if clock is 202Mhz
	HDMI_PRINTF("[CBUS_LOG] Ack Bit Drive Low Time = %x (0x65) \n",bTemp1 );
	hdmiport_mask(CBUS_LINK_08_reg, ~(CBUS_LINK_08_tx_bit_time_mask), (CBUS_LINK_08_tx_bit_time(bTemp1)));

	// Check Received Ack Bit's Falling Edge
	//ScalerSetBit(P28_BC_CBUS0_CTRL_1C, ~(_BIT6 | _BIT5 | _BIT4 | _BIT3 | _BIT2 | _BIT1 | _BIT0), 0x7F);
	fTemp1 = (float)T_TX_bit_time*0.88/One_clk_period;
	//fTemp1 = T_TX_bit_time/One_clk_period;
	bTemp1 = (u_int8_t)fTemp1 ;  //0x32  if clock is 202Mhz
	//cloud change for cts test
	//bTemp1 = 0x59;
	HDMI_PRINTF("[CBUS_LOG] Check Received Ack Bit's Falling Edge = %x (0x46) \n",bTemp1 );
	hdmiport_mask(CBUS_LINK_0A_reg, ~(CBUS_LINK_0A_tx_ack_fal_mask), (CBUS_LINK_0A_tx_ack_fal(bTemp1)));

	// Check Received Ack Bit's Driving Low Period Upper Bound
	//ScalerSetBit(P28_BD_CBUS0_CTRL_1D, ~(_BIT6 | _BIT5 | _BIT4 | _BIT3 | _BIT2 | _BIT1 | _BIT0), 0x4F);
	fTemp1 = (float)T_CBUS_ACK_0_max*1.2/One_clk_period;
	bTemp1 = (u_int8_t)fTemp1 ;  //0x32  if clock is 202Mhz
	//bTemp1 = 0x45;
	//bTemp1 = 0x49;//2013 0815 for cbus cts 4.3.
	HDMI_PRINTF("[CBUS_LOG] Check Received Ack Bit's Driving Low Period Upper Bound = %x (0x3E) \n",bTemp1 );
	hdmiport_mask(CBUS_LINK_0B_reg, ~(CBUS_LINK_0B_tx_ack_low_hb_mask), (CBUS_LINK_0B_tx_ack_low_hb(bTemp1)));

	// Check Received Ack Bit's Driving Low Period Lower Bound
	//ScalerSetBit(P28_BE_CBUS0_CTRL_1E, ~(_BIT6 | _BIT5 | _BIT4 | _BIT3 | _BIT2 | _BIT1 | _BIT0), 0x25);
	fTemp1 = (float)T_CBUS_ACK_0_min*0.8/One_clk_period;
	bTemp1 = (u_int8_t)fTemp1 ;  //0x32  if clock is 202Mhz
	//cloud change for cts test
	//bTemp1 = 0x20;
	HDMI_PRINTF("[CBUS_LOG] Check Received Ack Bit's Driving Low Period lower Bound = %x (0x27) \n",bTemp1 );
	hdmiport_mask(CBUS_LINK_0C_reg, ~(CBUS_LINK_0C_tx_ack_low_lb_mask), (CBUS_LINK_0C_tx_ack_low_lb(bTemp1)));

	// Actively Driving High Time for CBUS
	//ScalerSetBit(P28_C0_CBUS0_CTRL_20, ~(_BIT5 | _BIT4 | _BIT3 | _BIT2 | _BIT1 | _BIT0), 0x19);
	fTemp1 = T_drive_H_AVE/One_clk_period;
	bTemp1 = (u_int8_t)fTemp1 ;  //0x32  if clock is 202Mhz
	HDMI_PRINTF("[CBUS_LOG] Actively Driving High Time for CBUS = %x (0x19) \n",bTemp1 );
	hdmiport_mask(CBUS_LINK_0E_reg, ~(CBUS_LINK_0E_drv_hi_cbus_mask), (CBUS_LINK_0E_drv_hi_cbus(bTemp1)));

	// CBUS Requester Transmit Opportunity after Arbitration
	//ScalerSetByte(P28_C2_CBUS0_CTRL_22, 0x79);
	fTemp1 = (float)T_TX_bit_time/One_clk_period;
	bTemp1 = (u_int8_t)fTemp1 ;  //0x32  if clock is 202Mhz
	HDMI_PRINTF("[CBUS_LOG] CBUS Requester Transmit Opportunity after Arbitration = %x (0x65) \n",bTemp1 );
	hdmiport_mask(CBUS_LINK_10_reg, ~(CBUS_LINK_10_req_opp_flt_mask), (CBUS_LINK_10_req_opp_flt(bTemp1)));

	// CBUS Requester Continue After Ack
	//ScalerSetByte(P28_C3_CBUS0_CTRL_23, 0x3C);
	fTemp1 = T_TX_bit_time*0.5/(One_clk_period);
	bTemp1 = (u_int8_t)fTemp1 ;  //0x32  if clock is 202Mhz
	HDMI_PRINTF("[CBUS_LOG] CBUS Requester Continue After Ack = %x (0x32) \n",bTemp1 );
	hdmiport_mask(CBUS_LINK_11_reg, ~(CBUS_LINK_11_req_cont_mask), (CBUS_LINK_11_req_cont(bTemp1)));

	// Link Layer Timeout
	//ScalerSetBit(P28_C5_CBUS0_CTRL_25, ~(_BIT5 | _BIT4 | _BIT3 | _BIT2 | _BIT1), (_BIT4 | _BIT3 | _BIT2));
	fTemp1 = (((T_link_timeout/One_clk_period)-15)+16)/16; /*rounding*/
	bTemp1 = (u_int8_t)fTemp1 ;  //0x32  if clock is 202Mhz
	HDMI_PRINTF("[CBUS_LOG] CBUS Requester Continue After Ack = %x (0x0c) \n",bTemp1 );
	hdmiport_mask(CBUS_LINK_13_reg, ~(CBUS_LINK_13_link_time_mask), (CBUS_LINK_13_link_time(bTemp1)));

}

void mhl_disconnect(void)
{
#if MHL3_ENABLE
	mhl3_disconnect();
	mhl3_reset();
#endif
	MHL_Z100k_Switch(MHL_CHANNEL, 0);
	hdmiport_mask(CBUS_PMM_CBUS_STANDBY_04_reg, ~(CBUS_PMM_CBUS_STANDBY_04_disconn_irq_en_mask|CBUS_PMM_CBUS_STANDBY_04_cbus_disconn_mask), (CBUS_PMM_CBUS_STANDBY_04_cbus_disconn_mask));
	hdmiport_mask(CBUS_PMM_CBUS_STANDBY_02_reg, ~(CBUS_PMM_CBUS_STANDBY_02_dis_deb_lv_mask), CBUS_PMM_CBUS_STANDBY_02_dis_deb_lv(4));
	hdmiport_mask(CBUS_PMM_CBUS_STANDBY_08_reg, ~(CBUS_PMM_CBUS_STANDBY_08_goto_sink1_mask), (CBUS_PMM_CBUS_STANDBY_08_goto_sink1_mask));
	hdmiport_mask(CBUS_PMM_CBUS_STANDBY_00_reg, ~(CBUS_PMM_CBUS_STANDBY_00_wake_pulse_det_mask|CBUS_PMM_CBUS_STANDBY_00_dis_pulse_det_mask), (CBUS_PMM_CBUS_STANDBY_00_wake_pulse_det_mask|CBUS_PMM_CBUS_STANDBY_00_dis_pulse_det_mask));
}

u_int8_t MHLMscFIFOSendCommand( u_int8_t enumMSCCommand, u_int8_t enumMSCOffset, u_int8_t enumMSCValue, u_int8_t ucDataLength, u_int8_t *pucData)
{
	UINT8 ucTimeOut = 100;
	UINT8 ucSendType = 0;
	UINT8 ucWaitType = 0;
	UINT8 ucI = 0;
	//  HDMI_PRINTF("[CBUS_LOG] cloud MHLMscFIFOSendCommand = %x ,  offset = %x ,  enumMSCValue = %x \n" ,enumMSCCommand,enumMSCOffset,enumMSCValue);
	switch(enumMSCCommand)
	{
	case MHL_MSC_CMD_CODE_SET_INT:   //MHL_MSC_CMD_CODE_WRT_STAT
	case MHL_MSC_CMD_CODE_MSC_MSG:
		ucSendType = MHL_TX_CASE_COM_OFF_DAT;
		ucWaitType = MHL_TX_WAIT_CASE_CMD_ONLY;
		break;

	case MHL_MSC_CMD_CODE_SET_HPD:
		ucSendType = MHL_TX_CASE_COMMAND;
		ucWaitType = MHL_TX_WAIT_CASE_CMD_ONLY;
		break;

	case MHL_MSC_CMD_CODE_GET_STATE:
	case MHL_MSC_CMD_CODE_GET_VENDOR_ID:
	case MHL_MSC_CMD_CODE_GET_MSC_ERR:
		ucSendType = MHL_TX_CASE_COMMAND;
		ucWaitType = MHL_TX_WAIT_CASE_DATA_ONLY;
		break;

	case MHL_MSC_CMD_CODE_ABORT:
		ucSendType = MHL_TX_CASE_COMMAND;
		ucWaitType = MHL_TX_WAIT_CASE_CMD_NO_WAIT;
		break;

	case MHL_MSC_CMD_CODE_WRT_BURST:
		ucSendType = MHL_TX_CASE_COM_OFF_DAT_COM;
		ucWaitType = MHL_TX_WAIT_CASE_CMD_ONLY;
		break;

	default:
		break;
	}


	// Check If Source Has Sent An ABORT Packet
	if(CBUS_MSC_06_get_abort_req_irq(rtd_inl(CBUS_MSC_06_reg)) == TRUE)
	{
		//clear Abort flag
		rtd_maskl(CBUS_MSC_06_reg,~(CBUS_MSC_06_abort_req_irq_mask),CBUS_MSC_06_abort_req_irq_mask);
		return _MHL_ABORT_FAIL;
	}

	FW0Requester_set_tx_case(ucSendType);
	rtd_maskl(FW0_REQ_00_reg,~(FW0_REQ_00_fw0_fifo_clr_mask),FW0_REQ_00_fw0_fifo_clr_mask);
	// Set MSC Command
	FW0Requester_set_cmd1(enumMSCCommand);
	// Set MSC Offset
	FW0Requester_set_offset(enumMSCOffset);
	if(enumMSCCommand == MHL_MSC_CMD_CODE_WRT_BURST)
	{
		HDMI_PRINTF("[CBUS] MHLMscFIFOSendCommand -> MHL_MSC_CMD_CODE_WRT_BURST \n");
		// Set MSC Last Command
		FW0Requester_set_cmd2(MHL_MSC_CMD_CODE_EOF);
		// Set MSC Data
		for(ucI = 0; ucI < ucDataLength; ucI++)
		{
			FW0Requester_set_data(pucData[ucI]);
		}
	}
	else
	{
		// Set MSC Value
		FW0Requester_set_data(enumMSCValue);
	}

	// MSC Packet and Wait Type
	FW0Requester_set_head(MHL_HEADER_MSC_CMD);
	FW0Requester_set_wait_case(ucWaitType);
	// Send Request
	FW0Requester_set_req_en(1);

	// Check if Process is finished
	while(--ucTimeOut != 0)
	{
		//  HDMI_PRINTF("[CBUS_LOG]HW REQ finish  = %d  , Error flag = %d  \n",FW0Requester_get_finish_flag() ,FW0Requester_get_error_flag());
		if(CBUS_MSC_06_get_abort_req_irq(rtd_inl(CBUS_MSC_06_reg)) == TRUE)  //abort occur
		{
			//clear Abort flag
			rtd_maskl(CBUS_MSC_06_reg,~(CBUS_MSC_06_abort_req_irq_mask),CBUS_MSC_06_abort_req_irq_mask);
			HDMI_PRINTF("[CBUS] SEND CMD return Abort \n");
			return _MHL_ABORT_FAIL;
		}
		else if((FW0Requester_get_finish_flag() == TRUE) && (FW0Requester_get_error_flag() == 0x00))
		{
			// Transmit success
			// Clear Flag

			FW0Requester_set_finish_flag(1);

			if(ucWaitType == MHL_TX_WAIT_CASE_CMD_NO_WAIT)
			{
				//   HDMI_PRINTF("[CBUS_LOG]Transmit finish !!_MHL_SUCCESS!!!!!!\n");
				return _MHL_SUCCESS;
			}
			else
			{
				// Check ACK Packet
				// HDMI_PRINTF("[CBUS_LOG]Transmit finish !!!!!!\n");
				if(FW0Requester_get_cmd()== MHL_MSC_CMD_CODE_ACK)
				{
					//    HDMI_PRINTF("[CBUS_LOG]SEND CMD return _MHL_SUCCESS \n");
					return _MHL_SUCCESS;
				}
				else
				{
					HDMI_PRINTF("[CBUS] SEND CMD return _MHL_FAIL \n");
					return _MHL_FAIL;
				}
			}
		}
		else if((FW0Requester_get_error_flag() == TRUE)  && (FW0Requester_get_error_code() == _MHL_ERR_CODE_PRO_ER))
		{
			// Clear Flags
			FW0Requester_set_finish_flag(1);
			FW0Requester_set_error_flag(1);
			FW0Requester_CLR_error_code() ;
			HDMI_PRINTF("[CBUS] SEND CMD return _MHL_ABORT_REPLY \n");
			return _MHL_ABORT_REPLY;
		}

		udelay(10000);
		//  ScalerTimerDelayXms(1);
	}

	// Clear Flags
	FW0Requester_set_finish_flag(1);
	FW0Requester_set_error_flag(1);
	FW0Requester_CLR_error_code() ;
	HDMI_PRINTF("[CBUS] not finish ucTimeOut = %d !! _MHL_FAIL !!!!!! \n",ucTimeOut);
	return _MHL_FAIL;
}


u_int8_t MHLMscSendCommand( u_int8_t enumMSCCommand, u_int8_t enumMSCOffset, u_int8_t enumMSCValue)
{
    UINT8 ucResultPacket = 0;

    ucResultPacket = MHLMscFIFOSendCommand( enumMSCCommand, enumMSCOffset, enumMSCValue, 0, _NULL_POINTER);

    return ucResultPacket;

}

void OCbus_Power(char enable)
{
	if (enable) {
		hdmiport_mask(CBUS_PMM_CBUS_PHY_4_reg,
			~(CBUS_PMM_CBUS_PHY_4_en_cbus_rx_mask|CBUS_PMM_CBUS_PHY_4_mhl_bmos_en_rx_mask|CBUS_PMM_CBUS_PHY_4_en_cmp_rx_mask|CBUS_PMM_CBUS_PHY_4_en_driver_rx_mask),
			(CBUS_PMM_CBUS_PHY_4_en_cbus_rx_mask|CBUS_PMM_CBUS_PHY_4_mhl_bmos_en_rx_mask|CBUS_PMM_CBUS_PHY_4_en_cmp_rx_mask|CBUS_PMM_CBUS_PHY_4_en_driver_rx_mask));
		hdmiport_mask(CBUS_PMM_CBUS_PHY_4_reg, ~CBUS_PMM_CBUS_PHY_4_sel_cbusb_gpio_rx_mask, 0);
		hdmiport_mask(HDMI_HDMI_VCR_reg, ~(HDMI_HDMI_VCR_cbus_ddc_chsel_mask), HDMI_HDMI_VCR_cbus_ddc_chsel_mask);
	} else {
		hdmiport_mask(CBUS_PMM_CBUS_PHY_4_reg,
			~(CBUS_PMM_CBUS_PHY_4_en_cbus_rx_mask|CBUS_PMM_CBUS_PHY_4_mhl_bmos_en_rx_mask|CBUS_PMM_CBUS_PHY_4_en_cmp_rx_mask|CBUS_PMM_CBUS_PHY_4_en_driver_rx_mask),
			0);
		hdmiport_mask(CBUS_PMM_CBUS_PHY_4_reg, ~CBUS_PMM_CBUS_PHY_4_sel_cbusb_gpio_rx_mask, CBUS_PMM_CBUS_PHY_4_sel_cbusb_gpio_rx_mask);
		hdmiport_mask(HDMI_HDMI_VCR_reg, ~(HDMI_HDMI_VCR_cbus_ddc_chsel_mask), 0);
	}
}

//--------------------------------------------------
// Description  : Power Process for CBUS Phy
// Input Value  : bEn --> _ON/_OFF
// Output Value : None
//--------------------------------------------------
void CBUSSwitch(unsigned char benable)
{

	if (benable) {
		hdmi_mhl_z300_sel(GET_HDMI_CHANNEL(), 1, 0);
		OCbus_Power(1);

		hdmiport_mask(CBUS_PMM_CBUS_STANDBY_00_reg, ~(CBUS_PMM_CBUS_STANDBY_00_dis_irq_en_mask|CBUS_PMM_CBUS_STANDBY_00_wake_irq_en_mask), 0);
		hdmiport_mask(CBUS_PMM_CBUS_STANDBY_08_reg, ~(CBUS_PMM_CBUS_STANDBY_08_cable_det_mask), CBUS_PMM_CBUS_STANDBY_08_cable_det_mask);
	} else {
		OCbus_Power(0);

		hdmiport_mask(CBUS_PMM_CBUS_STANDBY_00_reg, ~(CBUS_PMM_CBUS_STANDBY_00_dis_irq_en_mask|CBUS_PMM_CBUS_STANDBY_00_wake_irq_en_mask), 0);
		hdmiport_mask(CBUS_PMM_CBUS_STANDBY_08_reg, ~(CBUS_PMM_CBUS_STANDBY_08_cable_det_mask), 0);
	}

	MHL_Z100k_Switch(GET_HDMI_CHANNEL(), 0);
}


//--------------------------------------------------
// Description  :Cbus power on or poer off setting
// Input Value  : none
// Output Value : no
//
//--------------------------------------------------
void Cbus_Power(char enable)
{
	if (enable) {
		OCbus_Power(1);
	} else {
		if (MHLMscSendCommand(MHL_MSC_CMD_CODE_CLR_HPD, MHL_MSC_CMD_CODE_NULL, MHL_MSC_CMD_CODE_NULL) == _MHL_OK) {
			HDMI_PRINTF("[CBUS_LOG] _MHL_CLR_HPD!!!!!\n");
		} else {
			HDMI_PRINTF("[CBUS_LOG]  _MHL_CLR_HPD FAIL!!!!\n");
		}
		if (DETECT_MHL2_IN) {
			hdmiport_mask(CBUS_PMM_CBUS_PHY_3_reg, ~(CBUS_PMM_CBUS_PHY_3_cbus_e_rx_mask), 0);
		}

		OCbus_Power(0);
		hdmiport_mask(CBUS_PMM_CBUS_STANDBY_08_reg, ~(CBUS_PMM_CBUS_STANDBY_08_goto_sink1_mask), (CBUS_PMM_CBUS_STANDBY_08_goto_sink1_mask));
	}
}

void MHL_Z100k_Switch(unsigned char port, unsigned char benable)
{
	if (benable) {
		hdmiport_mask(DFE_HDMI_RX_PHY_Z0POW_reg, ~(DFE_HDMI_RX_PHY_Z0POW_reg_z0_z100_en(1<<port)), DFE_HDMI_RX_PHY_Z0POW_reg_z0_z100_en(1<<port));
	} else {
		hdmiport_mask(DFE_HDMI_RX_PHY_Z0POW_reg, ~(DFE_HDMI_RX_PHY_Z0POW_reg_z0_z100_en(1<<port)), 0);
	}
}

void hdmi_mhl_z300_sel(unsigned char port, bool is_mhl, bool is_mhl3)
{
	if (is_mhl && !is_mhl3) {
		rtd_maskl(DFE_HDMI_RX_PHY_Z0POW_reg, ~(DFE_HDMI_RX_PHY_Z0POW_reg_z0_z300_sel((1<<port))), 0);
	} else {
		rtd_maskl(DFE_HDMI_RX_PHY_Z0POW_reg, ~(DFE_HDMI_RX_PHY_Z0POW_reg_z0_z300_sel((1<<port))), DFE_HDMI_RX_PHY_Z0POW_reg_z0_z300_sel((1<<port)));
	}
	hdmiport_mask(DFE_HDMI_RX_PHY_Z0POW_reg, ~(DFE_HDMI_RX_PHY_Z0POW_reg_z0_z300pow_mask), (DFE_HDMI_RX_PHY_Z0POW_reg_z0_z300pow_mask));
}

void mhl_clk_switch(unsigned char bchannel, unsigned char benable)
{
	unsigned int mhl_pow_bit[3] = {	DFE_HDMI_RX_PHY_MHL_reg_p0_mhl_pow_mask,
					DFE_HDMI_RX_PHY_MHL_reg_p1_mhl_pow_mask,
					DFE_HDMI_RX_PHY_MHL_reg_p2_mhl_pow_mask
				};
	unsigned int datasel_bit[3] = {	DFE_HDMI_RX_PHY_MHL_reg_p0_mhl_hdmi_datasel_mask,
					DFE_HDMI_RX_PHY_MHL_reg_p1_mhl_hdmi_datasel_mask,
					DFE_HDMI_RX_PHY_MHL_reg_p2_mhl_hdmi_datasel_mask
				};
	unsigned int cksel_bit[3] = {	DFE_HDMI_RX_PHY_MHL_reg_p0_mhl_hdmi_cksel_mask,
					DFE_HDMI_RX_PHY_MHL_reg_p1_mhl_hdmi_cksel_mask,
					DFE_HDMI_RX_PHY_MHL_reg_p2_mhl_hdmi_cksel_mask
				};
	if (benable) {
		if (mhl_is_ver3x()) {
			hdmiport_mask(DFE_HDMI_RX_PHY_MHL_reg, ~(cksel_bit[bchannel]|datasel_bit[bchannel]|mhl_pow_bit[bchannel]),
			              (cksel_bit[bchannel]|datasel_bit[bchannel]));
			HDMI_PRINTF("[MHL] CLK as MHL3\n");
		} else {
			hdmiport_mask(DFE_HDMI_RX_PHY_MHL_reg, ~(cksel_bit[bchannel]|datasel_bit[bchannel]|mhl_pow_bit[bchannel]),
			              (mhl_pow_bit[bchannel]));
			HDMI_PRINTF("[MHL] CLK as MHL2\n");
		}
	} else {
		hdmiport_mask(DFE_HDMI_RX_PHY_MHL_reg, ~(cksel_bit[bchannel]|datasel_bit[bchannel]|mhl_pow_bit[bchannel]),
		              (cksel_bit[bchannel]|datasel_bit[bchannel]));
		/*HDMI_PRINTF("CLK as HDMI\n");*/
	}

	hdmi_ck_md_ref_sel(bchannel, mhl_is_ver3x());
	hdmi_mhl_z300_sel(bchannel, benable, mhl_is_ver3x()); /* remove it? */

}

//--------------------------------------------------
// Description  : Power Process for CBUS Phy
// Input Value  : bEn --> _ON/_OFF
// Output Value : None
//--------------------------------------------------
void MHLSwitch(unsigned char bchannel, unsigned char benable)
{
	if (benable) {
		if (_bMhl_clk_mode) {
			hdmiport_mask(MHL_DEMUX_CTRL_reg, ~(MHL_DEMUX_CTRL_mhl_en_mask|MHL_DEMUX_CTRL_mhl_pp_en_mask), MHL_DEMUX_CTRL_mhl_en_mask|MHL_DEMUX_CTRL_mhl_pp_en_mask);
			hdmiport_mask(HDMI_MHL_HDMI_MAC_CTRL_reg, ~(HDMI_MHL_HDMI_MAC_CTRL_ch_dec_pp_mode_en_mask|HDMI_MHL_HDMI_MAC_CTRL_pp_mode_output_mask|HDMI_MHL_HDMI_MAC_CTRL_packet_mhl_en_mask), (HDMI_MHL_HDMI_MAC_CTRL_ch_dec_pp_mode_en_mask|HDMI_MHL_HDMI_MAC_CTRL_pp_mode_output_mask|HDMI_MHL_HDMI_MAC_CTRL_packet_mhl_en_mask));
			hdmiport_mask(HDMI_MHL_HDMI_MAC_CTRL_reg, ~(HDMI_MHL_HDMI_MAC_CTRL_xor_pixel_sel_mask), HDMI_MHL_HDMI_MAC_CTRL_xor_pixel_sel(3));

			HDMI_PRINTF("[MHL_LOG] MHLswitch ppmode=1\n");
		} else {
			hdmiport_mask(MHL_DEMUX_CTRL_reg, ~(MHL_DEMUX_CTRL_mhl_en_mask|MHL_DEMUX_CTRL_mhl_pp_en_mask), MHL_DEMUX_CTRL_mhl_en_mask);
			hdmiport_mask(HDMI_MHL_HDMI_MAC_CTRL_reg, ~(HDMI_MHL_HDMI_MAC_CTRL_ch_dec_pp_mode_en_mask|HDMI_MHL_HDMI_MAC_CTRL_pp_mode_output_mask|HDMI_MHL_HDMI_MAC_CTRL_packet_mhl_en_mask), 0);
			hdmiport_mask(HDMI_MHL_HDMI_MAC_CTRL_reg, ~(HDMI_MHL_HDMI_MAC_CTRL_xor_pixel_sel_mask), HDMI_MHL_HDMI_MAC_CTRL_xor_pixel_sel(0));

			HDMI_PRINTF("[MHL_LOG] MHLswitch ppmode=0\n");
		}

#if MHL3_ENABLE
		if (mhl_is_ver3x()) {
			hdmiport_mask (HDMI_TMDS_ERRC_reg, ~HDMI_TMDS_ERRC_nl_mask, HDMI_TMDS_ERRC_nl(0));
		} else {
			hdmiport_mask (HDMI_TMDS_ERRC_reg, ~HDMI_TMDS_ERRC_nl_mask, HDMI_TMDS_ERRC_nl(3));
		}

#endif

		hdmiport_mask(MHL_MHL3_CTRL_reg, ~MHL_MHL3_CTRL_mhl_ver3_en_mask, MHL_MHL3_CTRL_mhl_ver3_en(mhl_is_ver3x()));
	} else {                          // MHL plug out  HDMI MODE
		_bMhl_clk_mode = 0;

		hdmiport_mask(MHL_DEMUX_CTRL_reg, ~(MHL_DEMUX_CTRL_mhl_en_mask|MHL_DEMUX_CTRL_mhl_pp_en_mask), 0);
		hdmiport_mask(HDMI_MHL_HDMI_MAC_CTRL_reg, ~(HDMI_MHL_HDMI_MAC_CTRL_ch_dec_pp_mode_en_mask|HDMI_MHL_HDMI_MAC_CTRL_pp_mode_output_mask|HDMI_MHL_HDMI_MAC_CTRL_packet_mhl_en_mask), 0);
		hdmiport_mask(HDMI_MHL_HDMI_MAC_CTRL_reg, ~(HDMI_MHL_HDMI_MAC_CTRL_xor_pixel_sel_mask), HDMI_MHL_HDMI_MAC_CTRL_xor_pixel_sel(0));
		hdmiport_mask(MHL_MHL3_CTRL_reg, ~MHL_MHL3_CTRL_mhl_ver3_en_mask, 0);
		hdmiport_mask (HDMI_TMDS_ERRC_reg, ~HDMI_TMDS_ERRC_nl_mask, HDMI_TMDS_ERRC_nl(3));
	}

	hdmi_mhl_z300_sel(bchannel, benable, mhl_is_ver3x());

}

void mhl3_set_24_16bit(void)
{
	if (mhl_is_ver3x() && (mhl3_get_bits_per_pixel() == BPP_16)) {
		HDMI_PRINTF("[MHL] MHL3 - 16bit\n");
		hdmiport_mask(MHL_MHL3_CTRL_reg, ~MHL_MHL3_CTRL_mhl_ver3_24_16_bit_sel_mask, MHL_MHL3_CTRL_mhl_ver3_24_16_bit_sel(1));
	} else {
		hdmiport_mask(MHL_MHL3_CTRL_reg, ~MHL_MHL3_CTRL_mhl_ver3_24_16_bit_sel_mask, MHL_MHL3_CTRL_mhl_ver3_24_16_bit_sel(0));
	}
}

void mhl3_set_detectmode(void)
{
#if MHL3_ENABLE
	if (GET_ISMHL() && mhl_is_ver3x()) {
		hdmiport_mask(HDMI_HDMI_SCR_reg, ~(HDMI_HDMI_SCR_dvi_reset_ds_cm_en_mask), 0);
		hdmiport_mask(HDMI_HDMI_SCR_reg, ~(HDMI_HDMI_SCR_mode_mask|HDMI_HDMI_SCR_msmode_mask), (HDMI_HDMI_SCR_mode_mask|HDMI_HDMI_SCR_msmode_mask));
	} else {
		hdmiport_mask(HDMI_HDMI_SCR_reg, ~(HDMI_HDMI_SCR_dvi_reset_ds_cm_en_mask), HDMI_HDMI_SCR_dvi_reset_ds_cm_en_mask);
		hdmiport_mask(HDMI_HDMI_SCR_reg, ~(HDMI_HDMI_SCR_mode_mask|HDMI_HDMI_SCR_msmode_mask), 0);
	}
#endif
}

void mhl_fill_burst_chksum(unsigned char *buf) /*buf[2]=chksum for across all 16 bytes*/
{
	unsigned char i, cksum;
	cksum = 0;
	for (i = 0; i < 16; i++) {
		cksum += buf[i];
	}
	buf[2] = 0xff-cksum+1;
}

//--------------------------------------------------
// Description  : Send Write Burst Operation
// Input Value  : ucInputPort --> D0 or D1
//                ucDataLength --> Data Length
//                pucData --> Data
//                ucMode --> Write Burst Mode
// Output Value : Success or Different Fail Situations
//--------------------------------------------------

u_int8_t MHLMscSendWriteBurst( u_int8_t ucOffset, u_int8_t ucDataLength, u_int8_t *pucData, EnumMHLWriteBurstMode enumMode)
{
	u_int8_t ucResultPacket = 0 , bTimecnt =100;

	if(enumMode == _MHL_WRITE_BURST_WITH_REQ) {

		// Clear Grant To Write Flag
		hdmiport_mask(MSC_REG_20_reg,~MSC_REG_20_grt_wrt_mask,MSC_REG_20_grt_wrt_mask);
		// Send Request to Write
		MHLMscSendCommand( MHL_MSC_CMD_CODE_SET_INT, _MHL_REG_RCHANGE_INT, REQ_WRT);

		//  this area is different with monitor
		// Disable Access Port Auto Increase
		//    ScalerSetBit(P28_AB_CBUS0_CTRL_0B, ~_BIT0, 0x00);
		// Polling Grant to Write
		//    ScalerSetByte(P28_AC_CBUS0_CTRL_0C, _MSC_RCHANGE_INT);
		//    ScalerTimerPollingFlagProc(100, P28_AD_CBUS0_CTRL_0D, _MSC_GRT_WRT, _TRUE);
		// Enable Access Port Auto Increase
		//    ScalerSetBit(P28_AB_CBUS0_CTRL_0B, ~_BIT0, _BIT0);

		do {
			HDMI_DELAYMS(10);
			bTimecnt --;
			if(MSC_REG_20_get_grt_wrt(hdmi_in(MSC_REG_20_reg)))   break ;
		} while ((!MSC_REG_20_get_grt_wrt(hdmi_in(MSC_REG_20_reg)))&&(bTimecnt) );

		if(bTimecnt ==0)    HDMI_PRINTF("[CBUS_LOG]  MHLMscSendWriteBurst  wait Timeout!!! \n" );

	}

//	if(GET_MHL_READY_TO_TRANSMIT() == TRUE) {
		ucResultPacket = MHLMscFIFOSendCommand(MHL_MSC_CMD_CODE_WRT_BURST, ucOffset, 0x00, ucDataLength, pucData);

		switch(ucResultPacket) {
			case _MHL_SUCCESS: // Source reply ACK Packet

				// Send Device Scratchpad Change
				MHLMscSendCommand( MHL_MSC_CMD_CODE_SET_INT, _MHL_REG_RCHANGE_INT, DSCR_CHG);

				return _MHL_OK;

				break;

			case _MHL_ABORT_FAIL: // Source reply ABORT Packet

//				SET_MHL_READY_TO_TRANSMIT(0);

//				SET_MHL_TIMER1_SEC(250); // 250 * 10 msec  =2.5 sec



				return _MHL_NG;

				break;

			case _MHL_ABORT_REPLY: // Source Reply Data Packet Instead of Control Packet

				MHLMscFIFOSendCommand( MHL_MSC_CMD_CODE_ABORT, MHL_MSC_CMD_CODE_NULL, MHL_MSC_CMD_CODE_NULL, 0, _NULL_POINTER);

				return _MHL_NG;

				break;

			default: // Source Reply No Packet(Timeout) or NACK

				return _MHL_NG;

				break;
		}
//	} else {
//		return _MHL_NG;
//	}
}

bool MHL_GetScratchpad(unsigned char len, unsigned char *scr)
{
	unsigned char i;
	/*if ( MSC_REG_20_get_dscr_chg(hdmi_in(MSC_REG_20_reg)) ) {*/
		for (i=0; i<len; i++) {
			if ( i > 31 ) {
				HDMI_PRINTF("[MHL] The max length of Get Scratchpad is 32.\n");
				return FALSE;
			}
			scr[i] = MSC_REG_40_get_scratch_40(hdmi_in(MSC_REG_40_reg+(i*4)));
		}
		/*hdmi_out(MSC_REG_20_reg, MSC_REG_20_dscr_chg_mask);*/
		return TRUE;
	/*}
	return FALSE;*/
}


bool mhl_get_msc_write_burst(void)
{
	if (CBUS_MSC_06_get_wr_burst_irq(hdmi_in(CBUS_MSC_06_reg))) {
		hdmi_out(CBUS_MSC_06_reg, CBUS_MSC_06_wr_burst_irq_mask);
		/*hdmi_out(CBUS_MSC_06_reg, CBUS_MSC_06_wr_stat_irq_mask);*/
		hdmi_out(CBUS_oCBUS_CTRL_10_reg, CBUS_oCBUS_CTRL_10_wr_xstat_irq_mask);
		return TRUE;
	}
	return FALSE;
}

void mhl_write_burst_handler(void)
{
unsigned char wburst_buff[16];

	if (!mhl_get_msc_write_burst()) {
		return;
	}

	MHL_GetScratchpad(16, wburst_buff);

#if MHL3_ENABLE
	if ((wburst_buff[0] == BIST_SETUP_H) && (wburst_buff[1] == BIST_SETUP_L)) {
		MHLMscSendCommand(MHL_MSC_CMD_CODE_MSC_MSG, MHL_MSG_READY, (BIST_ECBUS_READY|BIST_AVLINK_READY|BIST_TERM_READY));
		mhl3_bist_ecbus_set(wburst_buff[3], wburst_buff[4], (wburst_buff[5]<<8)|wburst_buff[6]);
		mhl3_bist_avlink_set(wburst_buff[0x0b], wburst_buff[0x09], (wburst_buff[0x0c]<<8)|wburst_buff[0x0d], wburst_buff[0x0e]);
	} else if ((wburst_buff[0] == VC_ASSIGN_H) && (wburst_buff[1] == VC_ASSIGN_L)) {
		mhl3_virtual_channel_handler(wburst_buff);
	} else if ((wburst_buff[0] == BIST_RETURN_STAT_H) && (wburst_buff[1] == BIST_RETURN_STAT_L)) {
		HDMI_PRINTF("[MHL3] GET BIST, NEED TO DO SOMETHING?\n");
	} else if ((wburst_buff[0] == BIST_DISCARD_H) && (wburst_buff[1] == BIST_DISCARD_L)) {
		HDMI_PRINTF("[MHL3] GET BIST, NEED TO DO SOMETHING?\n");
	} else if ((wburst_buff[0] == BIST_ECHO_REQUEST_H) && (wburst_buff[1] == BIST_ECHO_REQUEST_L)) {
		HDMI_PRINTF("[MHL3] GET BIST, NEED TO DO SOMETHING?\n");
	} else if ((wburst_buff[0] == BIST_ECHO_RESPONSE_H) && (wburst_buff[1] == BIST_ECHO_RESPONSE_L)) {
		HDMI_PRINTF("[MHL3] GET BIST, NEED TO DO SOMETHING?\n");
	} else if ((wburst_buff[0] == EMSC_SUPPORT_H) && (wburst_buff[1] == EMSC_SUPPORT_L)) {
		HDMI_PRINTF("[MHL3] Receive WB-EMSC_SUPPORT (tot=%d,num=%d,%02x,%02x)\n", wburst_buff[3], wburst_buff[5], wburst_buff[6], wburst_buff[7]);
	} else if ((wburst_buff[0] == BITS_PER_PIXEL_FMT_H) && (wburst_buff[1] == BITS_PER_PIXEL_FMT_L)) {
		HDMI_PRINTF("[MHL3] GET BITS_PER_PIXEL_FMT=%d %d %d\n", wburst_buff[6], wburst_buff[7], wburst_buff[8]);
	} else {
		HDMI_PRINTF("[MHL3] GET MSC_WRITE_BURST(0x%02x%02x), NEED TO DO SOMETHING?\n", wburst_buff[0], wburst_buff[1]);
	}
#else
	HDMI_PRINTF("[MHL] GET MSC_WRITE_BURST(0x%02x%02x), NEED TO DO SOMETHING?\n", wburst_buff[0], wburst_buff[1]);
#endif
}

bool mhl_get_bist_trigger(void)
{
	if (CBUS_oCBUS_CTRL_13_get_btrig_irq(hdmi_in(CBUS_oCBUS_CTRL_13_reg))) {
		hdmi_out(CBUS_oCBUS_CTRL_13_reg, CBUS_oCBUS_CTRL_13_btrig_irq_mask);
		return TRUE;
	}
	return FALSE;
}

bool mhl_get_bist_request_stat(void)
{
	if (CBUS_oCBUS_CTRL_13_get_breq_irq(hdmi_in(CBUS_oCBUS_CTRL_13_reg))) {
		hdmi_out(CBUS_oCBUS_CTRL_13_reg, CBUS_oCBUS_CTRL_13_breq_irq_mask);
		return TRUE;
	}
	return FALSE;
}

bool mhl_get_bist_ready(void)
{
	if (CBUS_oCBUS_CTRL_13_get_brdy_irq(hdmi_in(CBUS_oCBUS_CTRL_13_reg))) {
		hdmi_out(CBUS_oCBUS_CTRL_13_reg, CBUS_oCBUS_CTRL_13_brdy_irq_mask);
		return TRUE;
	}
	return FALSE;
}

bool mhl_get_bist_stop(void)
{
	if (CBUS_oCBUS_CTRL_13_get_bstop_irq(hdmi_in(CBUS_oCBUS_CTRL_13_reg))) {
		hdmi_out(CBUS_oCBUS_CTRL_13_reg, CBUS_oCBUS_CTRL_13_bstop_irq_mask);
		return TRUE;
	}
	return FALSE;
}

u_int8_t MHLMscRBPGetCommand(u_int8_t *pucKeyCode)
{
	if (CBUS_oCBUS_CTRL_12_get_rbp_irq(rtd_inl(CBUS_oCBUS_CTRL_12_reg))) {
		hdmi_out(CBUS_oCBUS_CTRL_12_reg, CBUS_oCBUS_CTRL_12_rbp_irq_mask);
		pucKeyCode[0] = CBUS_oCBUS_CTRL_16_get_rbp_rcv(hdmi_in(CBUS_oCBUS_CTRL_16_reg));

		return TRUE;
	}
	return FALSE;
}

bool mhl_check_rbp_valid(const unsigned char rbp_code)
{
	if (rbp_code!=0x35) {
		return TRUE;
	}
	return FALSE;
}
void  MHLMscRBPHandler(void)
{
	unsigned char rbp_code;
	if (MHLMscRBPGetCommand(&rbp_code)) {
		//HDMI_PRINTF("[MHL] GOT RBP=%x\n", rbp_code);
		if (mhl_check_rbp_valid(rbp_code)) {
			MHLMscSendCommand(MHL_MSC_CMD_CODE_MSC_MSG, MHL_MSG_RBPK, rbp_code);
		} else {
			MHLMscSendCommand(MHL_MSC_CMD_CODE_MSC_MSG, MHL_MSG_RBPE, 1);
//			HDMI_DELAYMS(50);
			MHLMscSendCommand(MHL_MSC_CMD_CODE_MSC_MSG, MHL_MSG_RBPK, rbp_code);
		}
	}
}

bool  MHLMscCheckDeviceINT(void)
{
#if MHL3_ENABLE
unsigned int i;
#endif

	if (CBUS_MSC_06_get_wr_stat_irq(hdmi_in(CBUS_MSC_06_reg)) == TRUE) {
		hdmi_out(CBUS_MSC_06_reg, CBUS_MSC_06_wr_stat_irq_mask);
		HDMI_PRINTF("[CBUS] Receive MSC_WR_ST cmd=%x offset=%x data=%x len =%x\n", hdmi_in(CBUS_MSC_01_reg), hdmi_in(CBUS_MSC_02_reg), hdmi_in(CBUS_MSC_04_reg), CBUS_MSC_03_get_na_rx_len(hdmi_in(CBUS_MSC_03_reg)));
		/*if (hdmi_in(CBUS_MSC_02_reg) == _MHL_REG_LINK_MODE) {
			mhl_link_mode_updated = 1;
			HDMI_PRINTF("[CBUS] clk_mode=%d\n", MSC_REG_31_get_clk_mode(hdmi_in(MSC_REG_31_reg)));
		}*/

		if (MSC_REG_20_get_req_wrt(hdmi_in(MSC_REG_20_reg)) == TRUE) {
			hdmi_out(MSC_REG_20_reg, MSC_REG_20_req_wrt_mask);
			HDMI_PRINTF("[CBUS_LOG] READ TX REQUEST WRT, SRC WILL SEND WRITE_BURST(6C)\n");
			if (MHLMscSendCommand(MHL_MSC_CMD_CODE_SET_INT, _MHL_REG_RCHANGE_INT, GRT_WRT) == _MHL_OK) {

			}
		}

#if MHL3_ENABLE
		if (MSC_REG_20_get_rchg_int_6(hdmi_in(MSC_REG_20_reg)) == TRUE) { /*FEAT_COMPLETE*/
			hdmi_out(MSC_REG_20_reg, MSC_REG_20_rchg_int_6_mask);
			HDMI_PRINTF("[CBUS_LOG] FEAT_COMPLETE\n");
		}

		if (MSC_REG_20_get_rchg_int_5(hdmi_in(MSC_REG_20_reg)) == TRUE) { /*FEAT_REQ*/
			hdmi_out(MSC_REG_20_reg, MSC_REG_20_rchg_int_5_mask);
			mhl3_send_hev_vic();
			mhl3_send_emsc_support();
			if (MHLMscSendCommand(MHL_MSC_CMD_CODE_SET_INT, _MHL_REG_RCHANGE_INT, FEAT_COMPLETE) == _MHL_OK) {
				HDMI_PRINTF("[CBUS] FEAT_REQ & FEAT_COMPLETE\n");
			}
		}

		if (MSC_REG_20_get_dcap_chg(hdmi_in(MSC_REG_20_reg))) {
			hdmi_out(MSC_REG_20_reg, MSC_REG_20_dcap_chg_mask);
			if (mhl3_get_src_ver() >= 0x30) {
				for (i = 0x80; i < 0x81; i++) {
					if (!mhl3_read_xdevcap(i)) { /*CTS6.4.3.4, 6.4.16.2*/
						break;
            }
				}
				WRITE_XSTAT(0x90, 0x04); /*6.4.3.4, follow MNT*/
			}
			/*if (MHLMscSendCommand(MHL_MSC_CMD_CODE_SET_INT, _MHL_REG_RCHANGE_INT, FEAT_REQ) == _MHL_OK) {
				HDMI_PRINTF("[CBUS_LOG] FEAT_REQ OK\n");
			} else {
				HDMI_PRINTF("[CBUS_LOG] FEAT_REQ FAIL\n");
			}*/
		}
#endif

		if (MSC_REG_20_get_dscr_chg(hdmi_in(MSC_REG_20_reg))) {
			hdmi_out(MSC_REG_20_reg, MSC_REG_20_dscr_chg_mask);
			HDMI_PRINTF("[CBUS_LOG] SCRATCHPAD CHG\n");
        }

        // Check 3D Request and Reply No Support For All Timings
		if (MSC_REG_20_get_cbus_3d_req(hdmi_in(MSC_REG_20_reg)) == TRUE) {
            // 3D_VIC Header
            MHL_CTRL.bBuf[0] = _MHL_3D_VIC_HB;   //ADOPTER ID HIGH
            MHL_CTRL.bBuf[1] = _MHL_3D_VIC_LB;   //ADOPTER ID LOW

            // Total Entries -> 0
            MHL_CTRL.bBuf[3] = 0x00;

            // Checksum -> pData[0] ^ pData[1] ^ pData[3]
            MHL_CTRL.bBuf[2] = 0x10;

            // 3D_DTD Header
            MHL_CTRL.bBuf[4] = _MHL_3D_DTD_HB;
            MHL_CTRL.bBuf[5] = _MHL_3D_DTD_LB;

            // Total Entries -> 0
            MHL_CTRL.bBuf[7] = 0x00;

            // Checksum -> pData[0] ^ pData[1] ^ pData[3]
            MHL_CTRL.bBuf[6] = 0x11;

            if((MHLMscSendWriteBurst( _MHL_REG_SCRATCH_START, 4, MHL_CTRL.bBuf, _MHL_WRITE_BURST_WITH_REQ) == _MHL_OK) &&
			    (MHLMscSendWriteBurst(_MHL_REG_SCRATCH_START, 4, &MHL_CTRL.bBuf[4], _MHL_WRITE_BURST_WITH_REQ)) == _MHL_OK) {
                //ScalerSetDataPortByte(P28_AC_CBUS0_CTRL_0C, _MSC_RCHANGE_INT, _BIT4);
				hdmi_out(MSC_REG_20_reg, MSC_REG_20_cbus_3d_req_mask);
				HDMI_PRINTF("[CBUS_LOG] 3D REQ DONE\n");
            }
        }

	  return TRUE;
    }

	/* msc_msg handler */
#if MHL3_ENABLE
	if (mhl3_get_src_ver() >= 0x30) {
		if (CBUS_MSC_06_get_msg_sub_irq(hdmi_in(CBUS_MSC_06_reg))) { /*6.3.11.23*/
			hdmi_out(CBUS_MSC_06_reg, CBUS_MSC_06_msg_sub_irq_mask);
			MHLMscSendCommand(MHL_MSC_CMD_CODE_MSC_MSG, MHL_MSG_MSGE, _MSC_INEFFECTIVE_CODE);
		}
	}

	mhl3_xstat_handler();
	mhl3_bist_handler();
	mhl3_block_handler();
#endif

	mhl_write_burst_handler();
	MHLMscRBPHandler();

	return FALSE;

}



UINT8 MHL_IsPPMode(void)
{
	return _bMhl_clk_mode;
}

bool mhl_is_ver3x(void)
{
#if MHL3_ENABLE
	return (mhl3_get_version() >= 0x30);
#else
	return 0;
#endif
}


void QC_CBUS(UINT8 channel)
{
	UINT32 timer1 = 0, discovery_time_pt = 0, msc_time_pt = 0, break_time_pt = 0, t1_send_1st_cmd = 0;
	UINT16 cbus_st = CBUS_INIT;
	_bMhl_clk_mode = 0;

	MHL2_IN_PIN();
	HDMI2_MHL2_SEL_MHL_OUT();

	hdmi_z0_set(GET_HDMI_CHANNEL(), LN_B, 0);
	CBUSSwitch(1);
	Cbus_Power(1);

	rtd_maskl(CBUS_PMM_CBUS_STANDBY_04_reg, ~(CBUS_PMM_CBUS_STANDBY_04_disconn_irq_en_mask|CBUS_PMM_CBUS_STANDBY_04_cbus_disconn_mask), (CBUS_PMM_CBUS_STANDBY_04_cbus_disconn_mask)); // qc only
	HDMI_PRINTF("[CBUS] Please connecting MHL source, waiting.....%s\n", (CTS_TEST)?"(CTS Mode, press ""x"" to quit)":"");
	break_time_pt = timer1;

	while(1)	{
		if ((rtd_inl(CBUS_PMM_CBUS_STANDBY_04_reg)&(CBUS_PMM_CBUS_STANDBY_04_cbus_disconn_mask)) == (CBUS_PMM_CBUS_STANDBY_04_cbus_disconn_mask)) {
			mhl_disconnect();
			cbus_st = CBUS_INIT;
			break_time_pt = timer1;
			HDMI_PRINTF("[CBUS] disconnected!\n");
		}

		//wait wake up pulse
		if (cbus_st == CBUS_INIT) {
			if((rtd_inl(CBUS_PMM_CBUS_STANDBY_00_reg)&(CBUS_PMM_CBUS_STANDBY_00_wake_pulse_det_mask)) == ( CBUS_PMM_CBUS_STANDBY_00_wake_pulse_det_mask)) { // wake up  occurs
		        		rtd_outl(CBUS_PMM_CBUS_STANDBY_00_reg, CBUS_PMM_CBUS_STANDBY_00_wake_pulse_det_mask); //Sirius
		        		cbus_st = CBUS_WAKE;
				break_time_pt = timer1;
		        		HDMI_PRINTF("[CBUS] wake up pulse!\n");
	    		}
		}

		//wait discovery pulse
		if (cbus_st == CBUS_WAKE)	{
			if((rtd_inl(CBUS_PMM_CBUS_STANDBY_00_reg)&(CBUS_PMM_CBUS_STANDBY_00_dis_pulse_det_mask)) == (CBUS_PMM_CBUS_STANDBY_00_dis_pulse_det_mask )) {   // discovery occurs
				hdmi_z0_set(GET_HDMI_CHANNEL(), LN_B, 1);
				MHL_Z100k_Switch(MHL_CHANNEL, 1);
#if MHL3_ENABLE
				t1_send_1st_cmd = 10; /* 4.3.15.1; 2 */
				while (--t1_send_1st_cmd) {
					udelay(1000);
					if (rtd_inl(CBUS_PMM_CBUS_STANDBY_04_reg)&(CBUS_PMM_CBUS_STANDBY_04_cbus_disconn_mask)) {
						rtd_maskl(CBUS_PMM_CBUS_STANDBY_00_reg, ~(CBUS_PMM_CBUS_STANDBY_00_dis_pulse_det_mask|CBUS_PMM_CBUS_STANDBY_00_wake_pulse_det_mask), (CBUS_PMM_CBUS_STANDBY_00_dis_pulse_det_mask|CBUS_PMM_CBUS_STANDBY_00_wake_pulse_det_mask));
						rtd_maskl(CBUS_PMM_CBUS_STANDBY_04_reg, ~(CBUS_PMM_CBUS_STANDBY_04_disconn_irq_en_mask|CBUS_PMM_CBUS_STANDBY_04_cbus_disconn_mask), (CBUS_PMM_CBUS_STANDBY_04_disconn_irq_en_mask|CBUS_PMM_CBUS_STANDBY_04_cbus_disconn_mask));

						rtd_maskl(CBUS_PMM_CBUS_STANDBY_02_reg, ~(CBUS_PMM_CBUS_STANDBY_02_dis_deb_lv_mask), 0);
						continue;
					}
				}

				mhl3_init_state();
				if (mhl3_ocbus_send_cmd()) {
					mhl3_ecbus_discovery();
				}
#endif
				rtd_maskl(CBUS_PMM_CBUS_STANDBY_00_reg, ~(CBUS_PMM_CBUS_STANDBY_00_dis_pulse_det_mask|CBUS_PMM_CBUS_STANDBY_00_wake_pulse_det_mask), (CBUS_PMM_CBUS_STANDBY_00_dis_pulse_det_mask|CBUS_PMM_CBUS_STANDBY_00_wake_pulse_det_mask));
				rtd_maskl(CBUS_PMM_CBUS_STANDBY_04_reg, ~(CBUS_PMM_CBUS_STANDBY_04_disconn_irq_en_mask|CBUS_PMM_CBUS_STANDBY_04_cbus_disconn_mask), (CBUS_PMM_CBUS_STANDBY_04_disconn_irq_en_mask|CBUS_PMM_CBUS_STANDBY_04_cbus_disconn_mask));

				rtd_maskl(CBUS_PMM_CBUS_STANDBY_02_reg, ~(CBUS_PMM_CBUS_STANDBY_02_dis_deb_lv_mask), 0);

				cbus_st = CBUS_DISCOVERY;
		  		HDMI_PRINTF("[CBUS] discovery done\n");
				//udelay(10000);
				break_time_pt = timer1;
				discovery_time_pt  = timer1;
	    		}
		}

#if MHL3_ENABLE

		if ((mhl_is_ver3x()) && cbus_st > CBUS_WAKE) {
			if (!mhl3_ecbus_discovery()) {
				cbus_st = CBUS_INIT;
				CBUSSwitch(1);
				HDMI_PRINTF("re-connect\n");
			}
		}

		if (cbus_st == CBUS_DISCOVERY) {
			if (mhl_is_ver3x()) {
				if (mhl3_get_state() == MHL3_READY) {
					cbus_st = CBUS_READY;
				}
				break_time_pt = timer1;
			} else {
				udelay(100000); /* 4.3.6.2*/
				if (MHLMscSendCommand(MHL_MSC_CMD_CODE_SET_HPD, MHL_MSC_CMD_CODE_NULL, MHL_MSC_CMD_CODE_NULL) == _MHL_OK) {
		    			cbus_st = CBUS_SETHPD;
					break_time_pt = timer1;
					HDMI_PRINTF("[CBUS] sent set_hpd\n");
		    		} else {
					HDMI_PRINTF("[CBUS] MHL_SET_HPD FAIL!!!!!  \n");
		    		}
				udelay(10000);
			}


		}

#else
		if (cbus_st == CBUS_DISCOVERY && (abs(timer1-discovery_time_pt)>300)) {
			if (MHLMscSendCommand(MHL_MSC_CMD_CODE_SET_HPD, MHL_MSC_CMD_CODE_NULL, MHL_MSC_CMD_CODE_NULL) == _MHL_OK) {
	    			cbus_st = CBUS_SETHPD;
				break_time_pt = timer1;
				HDMI_PRINTF("[CBUS] sent set_hpd\n");
	    		} else {
				HDMI_PRINTF("[CBUS] MHL_SET_HPD FAIL!!!!!  \n");
	    		}
			udelay(10000);
			discovery_time_pt  = timer1;
		}
#endif

		//SEND path enable command
		if (cbus_st == CBUS_SETHPD) {
			if (MHLMscSendCommand(MHL_MSC_CMD_CODE_WRT_STAT, _MHL_REG_LINK_MODE, LINK_MODE_PATH_EN) == _MHL_OK) {
				cbus_st = CBUS_PATHEN;
				break_time_pt = timer1;
				HDMI_PRINTF("[CBUS] sent path_en, MHL is connected successfully\n");
			} else {
				HDMI_PRINTF("[CBUS]  PATH_EN FAIL!!!!!  \n");
			}
			udelay(10000);
	    	}

		if (cbus_st == CBUS_PATHEN) {
			if (MHLMscSendCommand(MHL_MSC_CMD_CODE_WRT_STAT, _MHL_REG_CONNECTED_RDY, CONNECT_DCAP_RDY) == _MHL_OK) {
				MHL_Z100k_Switch(MHL_CHANNEL, 0);
				cbus_st = CBUS_READY;
				break_time_pt = timer1;
				HDMI_PRINTF("[CBUS] sent dcap, ver=%x\n", rtd_inl(MSC_REG_01_reg));
			} else {
				HDMI_PRINTF("[CBUS] MHL DEV CAP RDY FAIL!!!!!  \n");
			}
			udelay(10000);
		}

		if (CBUS_MSC_06_get_clk_mode_chg(rtd_inl(CBUS_MSC_06_reg))) {
			_bMhl_clk_mode = (MSC_REG_31_get_clk_mode(rtd_inl(MSC_REG_31_reg)) == 0x02)?1:0;
			HDMI_PRINTF("[CBUS] PP mode = %d\n", _bMhl_clk_mode);
			rtd_outl(CBUS_MSC_06_reg, CBUS_MSC_06_clk_mode_chg_mask);
		}

		if (cbus_st == CBUS_READY || cbus_st == CBUS_PATHEN) {
			if (abs(timer1-msc_time_pt) > 100) {
				if (MHLMscCheckDeviceINT()) {
					break_time_pt = timer1;
				}
				msc_time_pt = timer1;
			}
		}

		if ( GETCHAR_x ) {
			break;
		}

		if (!CTS_TEST) {
			if (abs(timer1-break_time_pt) > LOOP_TIMEOUT) {
				break; //quit if no command in timeout
			}
		}

		udelay(1000); //loop takes at least 1ms
		timer1++;

	}

}

#if AUDIO_DETECT_EN
void Audio_Scrpit_test_48k(void)
{

rtd_outl(0xb80004e4, 0x00000009);




//-------- Module Clock & Reset Enable ---------------------------------
rtd_outl(0xb8000110,0xFFFFFFFF);
rtd_outl(0xb8000114,0xFFFFFFFF);
rtd_outl(0xb8000118,0xFFFFFFFF);
rtd_outl(0xb800011c,0xFFFFFFFF);
/*
rtd_outl(0xb8000110,0x00241001);
rtd_outl(0xb8000114,0x010001C2);
rtd_outl(0xb8000118,0x00e015a4);
rtd_outl(0xb800011c,0x00000000);
*/
rtd_outl(0xb8000100,0xFFFFFFFF);
rtd_outl(0xb8000104,0xFFFFFFFF);
rtd_outl(0xb8000108,0xFFFFFFFF);
rtd_outl(0xb800010c,0xFFFFFFFF);

rtd_outl(0xb8000110,0xFFFFFFFF);
rtd_outl(0xb8000114,0xFFFFFFFF);
rtd_outl(0xb8000118,0xFFFFFFFF);
rtd_outl(0xb800011c,0xFFFFFFFF);

//-------- bandgap & bias power---------
//[25]HDMI bandgap power 1:on 0:off(default on)
// IFD MBIAS power on(default on)
//-------- bandgap & bias power---------
//[25]HDMI bandgap power 1:on 0:off(default on)
// IFD MBIAS power on(default on)
//==========================================================================================================
//AUDIO clock
HDMI_PRINTF("Audio_Scrpit_test44444444444444444444444---------------111111111111111111\n");
rtd_outl(0xb8006004, 0xF0102222);//PLL audio, turn on ADC/DAC SDRAM

//rtd_maskl(0xb8033004,0xffefffff,0x00100000)// video DAC bias power on
//rtd_outl(0xb8033000,0x11100000);
HDMI_PRINTF("Audio_Scrpit_test44444444444444444444444\n");

rtd_outl(0xb8006b44, 0x00003FFF);//power ON
rtd_outl(0xb8006b5c, 0x000000BF);//enable output normal mode

rtd_outl(0xb8006554, 0x00007651);//DS FIFO ADC1
rtd_outl(0xb8006b10, 0x000C0003);//DAC_0_1 setting PB(modify)

rtd_outl(0xb8006b30, 0x01FB01FB);//analog_frontend1_ADC1_AIN1
rtd_outl(0xb8006b34, 0x01FF01FF);//analog_frontend2_ADC2_mute

rtd_outl(0xb8006b38, 0x81FBFF7F);//DAC0_HPO DAC1_AIO2 unmute L channel
rtd_outl(0xb8006b3c, 0x01FBFF7F);//DAC0_HPO DAC1_AIO2 unmute R channel
rtd_outl(0xb8006b6c, 0xC1800000);//AIO1 AIO2 floating
rtd_outl(0xb8006b50, 0x50000CCE);//VREF 0.5VDD
HDMI_PRINTF("Audio_Scrpit_test5555555555555555555555555\n");


rtd_outl(0xb806022c,0x00000001);//SPDIF_IN / SPDIF_in_sel bit0,1
rtd_outl(0xb8060210,0xF0F060F0);//SPDIF_IN / ST_GPIO_18 out for 176pin
rtd_outl(0xb8006554,0x00000002);//DSFIFO from SPDIF


rtd_outl(0xb8006130,0x40000000);//SPDIF in select internal HDMI

#if 0

//176.4k
rtd_outl(0xb80004F0, 0x0000001c);//psaud_psen=1, psaud_en=1
rtd_outl(0xb80004F4, 0x00000001);//coef C=(1+2)*2,PSAUD_DIV

rtd_outl(0xb8006010, 0x01306C15);//digital tracking,PARA_E,D,B,A
rtd_outl(0xb8006004, 0xF0111111);//clock source spdif
rtd_outl(0xb8006008, 0xa5000000);//ADC tcon0
rtd_outl(0xb800600c, 0xa5000000);//DAC0 tcon1
rtd_outl(0xb8006028, 0xa5000000);//DAC1 tcon2

rtd_outl(0xb800600c, 0x05000000);//DAC0 tcon1 For high speed
rtd_outl(0xb8006550, 0x44440007);//For high speed
#endif
//96k
#if 0
rtd_outl(0xb80004F0, 0x0000000c);//psaud_psen=1, psaud_en=1
rtd_outl(0xb80004F4, 0x00000004);//coef C=(4+2)*2,PSAUD_DIV

rtd_outl(0xb8006010, 0x01300c00);//digital tracking
rtd_outl(0xb8006004, 0xF0111111);//clock source spdif
rtd_outl(0xb8006008, 0x15000000);//ADC tcon0
rtd_outl(0xb800600c, 0x15000000);//DAC0 tcon1
rtd_outl(0xb8006028, 0x15000000);//DAC1 tcon2
#endif

 //48k
#if 1
rtd_outl(0xb80004F0, 0x0000000c);//psaud_psen=1, psaud_en=1
rtd_outl(0xb80004F4, 0x00000004);//coef C=(4+2)*2,PSAUD_DIV

rtd_outl(0xb8006010, 0x02300c00);//digital tracking
rtd_outl(0xb8006004, 0xF0111111);//clock source spdif
rtd_outl(0xb8006008, 0x05000000);//ADC tcon0
rtd_outl(0xb800600c, 0x05000000);//DAC0 tcon1
rtd_outl(0xb8006028, 0x05000000);//DAC1 tcon2

rtd_outl(0xb8000874,0xCC009C00);//SPDIF_OUT / bb_aio1l_apad out for 176pin
#endif
#if 0

//192k
rtd_outl(0xb80004F0, 0x0000000c);//psaud_psen=1, psaud_en=1
rtd_outl(0xb80004F4, 0x00000001);//coef C=(1+2)*2,PSAUD_DIV

rtd_outl(0xb8006010, 0x01300c00);//digital tracking
rtd_outl(0xb8006004, 0xF0111111);//clock source spdif
rtd_outl(0xb8006008, 0x25000000);//ADC tcon0
//rtd_outl(0xb800600c, 0x25000000);//DAC0 tcon1
rtd_outl(0xb8006028, 0x25000000);//DAC1 tcon2
//
rtd_outl(0xb800600c, 0x05000000);//DAC0 tcon1 For high speed
rtd_outl(0xb8006550, 0x44440007);//For high speed
#endif
HDMI_PRINTF("Audio_Scrpit_test66666666666666666666666666\n");
HDMI_PRINTF("Audio_Scrpit_test\n");

}
#endif

void MHL_Debug(void)
{
#if 0 // BCH ERR
	hdmiport_mask(0xb800d028, ~(_BIT9|_BIT8|_BIT7|_BIT6|_BIT5|_BIT4), 0x04<<4);
	hdmiport_mask(0xb800d1ac, ~(_BIT7|_BIT6|_BIT5|_BIT4), 0x01<<4);
	hdmiport_mask(0xb80008b8, ~(_BIT29|_BIT28|_BIT27|_BIT26|_BIT25|_BIT24|_BIT23|_BIT22), 0x06<<22);
	hdmiport_mask(0xb800d700, ~(_BIT12|_BIT11|_BIT10), 0x05<<10);
//	hdmiport_mask(0xb8000820, ~(_BIT31|_BIT30|_BIT29|_BIT28), 0xe<<28);
	hdmiport_mask(0xb8000810, ~(_BIT7|_BIT6|_BIT5|_BIT4), 0xe<<4);
	hdmiport_mask(0xb8000814, ~(_BIT31|_BIT30|_BIT29|_BIT28|_BIT23|_BIT22|_BIT21|_BIT20|_BIT15|_BIT14|_BIT13|_BIT12|_BIT7|_BIT6|_BIT5|_BIT4),
		(0xe<<28)|(0xe<<20)|(0xe<<12)|(0xe<<4));
	hdmiport_mask(0xb8000818, ~(_BIT31|_BIT30|_BIT29|_BIT28|_BIT23|_BIT22|_BIT21|_BIT20|_BIT15|_BIT14|_BIT13|_BIT12|_BIT7|_BIT6|_BIT5|_BIT4),
		(0xe<<28)|(0xe<<20)|(0xe<<12)|(0xe<<4));
#endif
#if 1 // RR
	hdmiport_mask(0xb800d700, ~(_BIT12|_BIT11|_BIT10), 0x01<<10);
	hdmiport_mask(0xb800d1ac, ~(_BIT7|_BIT6|_BIT5|_BIT4), 0x09<<4);
	hdmiport_mask(0xb80008b8, ~(_BIT29|_BIT28|_BIT27|_BIT26|_BIT25|_BIT24|_BIT23|_BIT22), 0x06<<22);
	hdmiport_mask(0xb8000828, ~(_BIT23|_BIT22|_BIT21|_BIT20),
		(0xe<<20)); //RR
//	hdmiport_mask(0xb8000820, ~(_BIT31|_BIT30|_BIT29|_BIT28), 0xe<<28);
#endif
}


bool QC_MHL_Main(UINT8 channel)
{
	bool crc_result = FALSE;
	UINT32 b;
	unsigned char i;

	HDMI_PRINTF("[HDMI] ================ START OF TEST (PORT=%d) ======================\n", channel);

	//drvif_Hdmi_Init();

	drvif_Hdmi_InitSrc(channel);
//	MHL_Debug();

	if (CBUS_EN) {
		QC_CBUS(channel);
	} else {
		//drvif_mhl3_cbus_switch(1);
		_bMhl_clk_mode = (ForcePacketPixelMode)?1:0;
	}

	mhl_clk_switch(channel, 1);

	MHLSwitch(channel, 1);
	mhl3_set_detectmode();

	b = HdmiMeasureVedioClock();
	if (b > 100) {
		SimpleMHLTMDSPhy(b, 1);
		mdelay(10);
		Hdmi_DetectMode(b);

#if AUDIO_DETECT_EN
		Hdmi_AudioModeDetect();
		Audio_Scrpit_test_48k();
#endif

#if DISPLAY_EN
		#include "case3_ipg1080p_frc_fhd/case3_hdmi1080p_frc_fhd.tbl"
#endif

		crc_result = QC_CRCCheck();
	}

	printk("[HDMI] Port%d TMDS clock = %03dMHz, CRC checked: %s\n", channel, (b*27+128)>>8, crc_result?"PASS":"FAIL!");

	HDMI_PRINTF("[HDMI] ================ END OF TEST (PORT=%d) ======================\n\n", channel);

	return crc_result;
}

bool IsMHLPortEnable(UINT8 pt)
{
	if (pt == 0) {
		return MHL1_CHECK_CRC; //(MPort0!=0);
	} else if (pt == 1) {
		return MHL2_CHECK_CRC; //(MPort1!=0);
	} else {
		return MHL3_CHECK_CRC; //(MPort2!=0);
	}
}

int QC_Verifier_MHL(void)
{
	int Result = SUCCESS;
	bool test_flag = TRUE;
	UINT16  i=0,j=0;

	printk("Mag2/Merlin MHL Rx QC Test\n");

//-------------------------------------
//  Reset Value Test
//-------------------------------------
//
//	return DefaultValueTest();
//
//-------------------------------------

	drvif_Hdmi_Init();

    for ( i=0; i<MHL_QCloop; i++ )
    {
        printk("[HDMI] LOOP=#%d\n", i+1);
        for ( j=0; j<3; j++ )
        {
            if ( IsMHLPortEnable(j) )
            {
		test_flag &= QC_MHL_Main(j);
            }
        }
#if LOOP_ERROR_BREAK
        if ( !test_flag )
        {
            break;
        }
#endif
    }

    if ( !test_flag )
    {
        Result = FAILED;
    }

	return Result;
}

