#include <qc_verify_common.h>
#include <common.h>
#include <command.h>
#include <coproc.h>


/* test case 
unsigned int cop_mtest_base = 0x10000000;
unsigned int cop_mtest_size = 0x00200000;
unsigned int cop_mtest_pattern = 0x5a5a55aa;
unsigned int cop_mtest_iteration = 0x1000;
*/
#if CONFIG_QC_MULTI_CORE_TEST
extern int mem_test(vu_long *start, vu_long *end, int iteration_limit, vu_long pattern);
#ifdef CONFIG_USE_IRQ
typedef unsigned int InterruptNum;
extern void ipi_send_target(unsigned int cpu_id, InterruptNum ipi_num);
#endif
#endif
int QC_Verifier_Multi_Core(void)
{

#if CONFIG_QC_MULTI_CORE_TEST

	unsigned int cpu_id = 0;
        unsigned int regBase = 0;
        unsigned int regValue = 0;
	unsigned int coproc_bitmap = 0;
        int ret = 0;
	int i = 0;
	
	/* Set Memory Parameter */
	cop_mtest_size = 0x00002000;
	//cop_mtest_corebits = 0xf;
       printf("Start MTEST_________CPU %d _________\n", cpu_id);

	printf("Core %d do mtest %x %x %x %x\n", cpu_id,
                                cop_mtest_base + (cpu_id) * cop_mtest_size,
                                cop_mtest_base + (cpu_id + 1) * cop_mtest_size,
                                cop_mtest_pattern,
                                cop_mtest_iteration);

        coproc_putc(0x27 + cpu_id);  // print ['] to debug
        ret = mem_test((vu_long *)(cop_mtest_base + cpu_id * cop_mtest_size),
        		(vu_long *)(cop_mtest_base + (cpu_id + 1) * cop_mtest_size),
                	cop_mtest_iteration,
                	cop_mtest_pattern);	
	if ( ret != 0 )
	{
		rtd_maskl(0xb801bd20,0xffBfffff,0x00400000);//GPIO86[22] set high, SCPU fail
		return FAILED;
	}
	else
		printf("Core %d OK~~~~~~\n", cpu_id);

	printf("\n");

	for (i = 1; i < NR_CPUS; i++)
	{
		printf("Start MTEST_________");

		if (i == 1)
		{
			coproc_bitmap = 2;
			cpu_id = 1;
			if ((coproc_bitmap & _BIT1) != _BIT1)
				continue;
			else {
				regBase = MAGIC_TAG_CORE1_reg;
				printf("CPU %d _________\n", cpu_id);
			}
		}
		else if (i == 2)
		{
			coproc_bitmap = 4;
			cpu_id = 2;
			if ((coproc_bitmap & _BIT2) != _BIT2)
				continue;
			else {
				regBase = MAGIC_TAG_CORE2_reg;
				printf("CPU %d _________\n", cpu_id);
			}
		}
		else if (i == 3)
		{
			coproc_bitmap = 8;
			cpu_id = 3;
			if ((coproc_bitmap & _BIT3) != _BIT3)
				continue;
			else {
				regBase = MAGIC_TAG_CORE3_reg;
				printf("CPU %d _________\n", cpu_id);
			}
		}
		else if (i == 4)
		{
			coproc_bitmap = 16;
			cpu_id = 4;
			if ((coproc_bitmap & _BIT4) != _BIT4)
				continue;
			else {
				regBase = MAGIC_TAG_CORE4_reg;
				printf("CPU %d _________\n", cpu_id);
			}
		}
		invalidate_dcache_range(MAGIC_TAG_CORE0_reg, MAGIC_TAG_CORE0_reg + (4 * (NR_CPUS + 1)));
		regValue = rtd_inl(regBase);
		if(regValue == MAGIC_COPROC_NOT_SUPPORT)
		{
			printf("CPU %d NOT SUPPORT skip memory test\n", cpu_id);
			continue;
		}
		// Start MTEST
		printf("Core %d do mtest %x %x %x %x\n", i,
                                cop_mtest_base + i * cop_mtest_size,
                                cop_mtest_base + (i + 1) * cop_mtest_size,
                                cop_mtest_pattern,
                                cop_mtest_iteration);

		rtd_outl(regBase, MAGIC_COPROC_OP_MEM_TEST);
		flush_dcache_range(MAGIC_TAG_CORE0_reg, MAGIC_TAG_CORE0_reg + (4 * (NR_CPUS + 1)));
		#ifdef CONFIG_USE_IRQ
              ipi_send_target(cpu_id,2);
		#else
		dsb();
		asm volatile("SEV");
		#endif
		//mdelay(100);
		while(1) {
			invalidate_dcache_range(MAGIC_TAG_CORE0_reg, MAGIC_TAG_CORE0_reg + (4 * (NR_CPUS + 1)));
			regValue = rtd_inl(regBase);
                        if (regValue == MAGIC_COPROC_MEM_TEST_OK) {
                                printf("Core %d OK~~~~~~\n", i);
                                break;
                        }
                        else if (regValue == MAGIC_COPROC_MEM_TEST_FAIL) {
                                printf("Core %d FAILED!!!!!!\n", i);
                                ret = 1;
                                break;
                        }
                }
                flush_dcache_range(MAGIC_TAG_CORE0_reg, MAGIC_TAG_CORE0_reg + (4 * (NR_CPUS + 1)));
                rtd_outl(regBase, MAGIC_COPROC_MEM_TEST_DONE);

		/* alternative */
		//ret = do_coprocessor_mem_test(coproc_bitmap);

		/* alternative */
		//coproc_putc(0x27 + cpu_id); // print [()*] to debug
            	//ret = mem_test((vu_long *)(cop_mtest_base + cpu_id * cop_mtest_size),
                //                               (vu_long *)(cop_mtest_base + (cpu_id + 1) * cop_mtest_size),
                //                                cop_mtest_iteration,
                //                                cop_mtest_pattern);

		printf("\n");		
	
		if ( ret != 0 )
		{
			//rtd_maskl(0xb801bd20,0xffBfffff,0x00400000);//GPIO86[22] set high, SCPU fail
			return FAILED;	
		}
		if (cpu_id == 4)
		{
			//rtd_maskl(0xb801bd20,0xffBfffff,0x00000000);//GPIO86[22] set low, SCPU pass
			return SUCCESS; 
		}
	}
        return SUCCESS; 
#else
	printf("Please define config file - CONFIG_QC_MULTI_CORE_TEST\n");
	return FAILED;
#endif

} 
