#include <qc_verify_common.h>
#include "../../common/cmd_burn_otp.h"
#include <I_Domain_qc.h>

#define _OTP_FAIL   				(-1)
#define OTP_DEBUG_LOG     	0 //0:Off 1:On

#define OTP_SOURCE_YPP		0
#define OTP_SOURCE_SCART	1
#define OTP_ECC_ENABLE 0
/*************For modify area*********************/

const UINT8   OTP_UpdateThres=3;
const UINT8   OTP_AlignPoint=4;
const UINT8   OTP_GAIN_SLICE=3;
const UINT8   OTP_CODE_SLICE=9;
const UINT8   OTP_OFFSET_SLICE=1;
UINT16 OTP_SAWB_GetTARGET[2][3]={{489,512,508},   //YPP target
	                                              {300,298,315}}; //SCART target
//signed short OTP_AWB_ADC_Gain_Slice[6]={	0x40,0x80,0xc0,0x120,0x1a0} ;     //  5 slice gain at  64,128,192,284,416 point
UINT16 OTP_AWB_ADC_Gain_Slice[2][9]={{0x1,0x20,0x40,0x80,0xC0,0x100,0x160,0x1C0,0x1ff},//  YPP 9 slice gain at  0,16,32,96,144,224,320,400,496 point
									    {0x1,0x20,0x40,0x80,0xC0,0x100,0x160,0x1C0,0x1ff}  //  SCART 9 slice gain at  0,16,32,96,144,224,320,400,496 point
								  };

/*************Static Area  ***********************/

UINT16 OTP_CURRENT_DIFF[3]={0,0,0};
signed short OTP_FINAL_GAIN[3]={0,0,0};
#if 1
UINT16 OTP_ADC_Calib[3][9] = {
	{0,0,0,0,0,0,0,0,0},  //R
	{0,0,0,0,0,0,0,0,0},  //G
	{0,0,0,0,0,0,0,0,0}   //B
	};
#else
UINT16 OTP_ADC_Calib[3][9] = {
	{640,603,570,512,466,427,377,339,318},  //R
	{626,590,556,501,455,417,369,333,311},  //G
	{633,599,564,509,464,424,377,340,319}   //B
	};
#endif

/////////////OTP          ///////////////////////////
#define OTP_STATUS_Empty		0
#define OTP_STATUS_GainDone	1
#define OTP_STATUS_OffsetDone	2
#define OTP_STATUS_FINISH		3 
#define OTP_YPP_Status_Offset 	30
#define OTP_YPP_Status_Size		2
#define OTP_YPP_Data_Offset 	  	10
#define OTP_YPP_Data_Size 	  	10
#define OTP_YPP_DWord_Offset 	32	 
#define OTP_YPP_DWord_Size 	 	32

//Merlin3
#define OTP_YPP_START_ADDR_BASE1   1664   // 15456//512 for VGA//10848_512 bit for VGA/YPP , 13*32 bit
#define OTP_YPP_START_ADDR_BASE2   2080   // 15456//512 for VGA//10848_512 bit for VGA/YPP , 13*32 bit
//Merlin2
//#define OTP_YPP_START_ADDR_BASE1   2336   // 15456//512 for VGA//10848_512 bit for VGA/YPP , 13*32 bit
//#define OTP_YPP_START_ADDR_BASE2   2752    //15968//416 for scart//11360_512 bit for SCART ,   10*32 bit
//Merlin1
//#define OTP_YPP_START_ADDR_BASE1   15648   // 15456//512 for VGA//10848_512 bit for VGA/YPP
//#define OTP_YPP_START_ADDR_BASE2   16064    //15968//416 for scart//11360_512 bit for SCART

UINT16  OTP_YPP_START_ADDR[2]={OTP_YPP_START_ADDR_BASE1,OTP_YPP_START_ADDR_BASE2};  
UINT16  OTP_LENGTH[2]={13,10};//{(OTP_GAIN_SLICE+OTP_CODE_SLICE+OTP_OFFSET_SLICE),(OTP_CODE_SLICE+OTP_OFFSET_SLICE)};  
signed short ADC_OTP_STATUS[4]={	OTP_STATUS_Empty,OTP_STATUS_GainDone,OTP_STATUS_OffsetDone,OTP_STATUS_FINISH}; // empty/shift/done/finish
//512 BIT  =32*16   =>   1 DWORD=32 bit =10 Bit_RADC+10BitGADC+10BitBADC+2bitSTATUS , Status=0 :empty, 1=shift to Next,2=Done,3=Success
//Start addr=10848>>5 then <<2 (align 32)
//Addr Map
//   DWORD   bit 30~31 	bit20~29   	bit10~19   	bit 0~9 
//        0   	0/1/2/(3)	Gain2		Gain1      	Gain0   
//        1   	0/1/2     		Gain5		Gain4      	Gain3   
//        2   	0/1/2     		Gain8		Gain7      	Gain6   
//        3   	0/1/2     		G0_RCode   	G0_GCode   	G0_BCode
//        4   	0/1/2     		G1_RCode   	G1_GCode   	G1_BCode
//        5   	0/1/2     		G2_RCode   	G2_GCode   	G2_BCode
//        6   	0/1/2     		G3_RCode   	G3_GCode   	G3_BCode
//        7   	0/1/2     		G4_RCode   	G4_GCode   	G4_BCode
//        8   	0/1/2     		G5_RCode   	G5_GCode   	G5_BCode
//        9   	0/1/2     		G6_RCode   	G6_GCode   	G6_BCode
//       10    	0/1/2     		G7_RCode   	G7_GCode   	G7_BCode
//       11   	0/1/2     		G8_RCode   	G8_GCode   	G8_BCode
//       12   	0/1/2     		Reserved        Reserved       Reserved
//       13   	0/1/2     		Reserved        Reserved       Reserved
//       14   	0/1/2     		Reserved        Reserved       Reserved
//       15   	0/1/2     		Reserved        Reserved       Reserved

#if 0
#define ADC_OTP_REG_BASE    			(0x18038000)
#define ADC_OTP_EF_CTRL         			(ADC_OTP_REG_BASE + 0x800)
#define ADC_EF_CTRL_WRITE_EN4          	(1 << 20)
#define ADC_EF_CTRL_EN_WAKEUP	  	(1 << 19)
#define ADC_EF_CTRL_WRITE_EN3          	(1 << 18)
#define ADC_EF_CTRL_EN_INIT_PROC      	(1 << 17)
#define ADC_EF_CTRL_WRITE_EN2           	(1 << 16)
#define ADC_EF_CTRL_EN_PROG_OTP       	(1 << 15)
#define ADC_EF_CTRL_WRITE_EN1           	(1 << 14)
#define ADC_OTP_EF_CTRL_STS      		(ADC_OTP_REG_BASE + 0x830)
#define ADC_EF_CTRL_PROG_STS			(1<<17)
#define ADC_EF_CTRL_PROG_ACT			(1<<16)
#endif

extern int EnHammingCode1024(char* orig_data, unsigned int* ecc_data);

int QCADC_burn_otp_read(unsigned int bit_offset,unsigned int data_size)
{
	__attribute__ ((unused)) unsigned int byte_offset;
	unsigned int world_offset;
	__attribute__ ((unused)) unsigned int mask;
	unsigned int mask_size=0;
	UINT8 i;
	volatile unsigned int otp_data;	
	if(OTP_DEBUG_LOG)
    			printk("OTP read data_size=%x,(bit_offset&0x1F)= %x\n", data_size,(bit_offset&0x1F));
	if((data_size+(bit_offset&0x1F))>32)
		{
			printk("OTP read error data_size=%x,(bit_offset&0x1F)= %x\n", data_size,(bit_offset&0x1F));
			return _FAIL;
		}
	byte_offset  =  bit_offset >> 3;
	world_offset =  bit_offset >> 5;
	
	for (i=0;i<data_size;i++)
		mask_size=mask_size|(1<<i);
	
	mask =  mask_size << (bit_offset&0x1F);
	
	//otp_data = rtd_inl(ADC_OTP_REG_BASE+(world_offset<<2));
	otp_data = rtd_inl(0xb8038000+(world_offset<<2));
	
	if(OTP_DEBUG_LOG)
	printk("OTP addr=%x is 0x %x\n", (ADC_OTP_REG_BASE+(world_offset<<2)), otp_data);



	
	otp_data=otp_data>> (bit_offset&0x1F);
/*	if( otp_data & mask ) {
		printk("OTP bit %d is 1\n", bit_offset);
	}
	else {
		printk("OTP bit %d is 0\n", bit_offset);
	}
*/	
	return otp_data;
}


int QCADC_start_DWord_program(UINT32 addr,UINT32 data)
{
int Waiting_Count=100;
UINT32 status1=0;
BOOL Done=0;
if(OTP_DEBUG_LOG)
printk("data:%x, prog_addr:0x%08x\n", data, addr);

#if 1    //enable
    rtd_outl(addr,data); //assign addr/data
    // enable program otp
    rtd_outl(ADC_OTP_EN_PRO_EFUSE,0x0000dead); // trigger program enable 
    while(Waiting_Count>0)
    	{
    	status1=rtd_inl(ADC_OTP_EF_PROGRAM_STATUS1);
	Done=(status1&ADC_OTP_EF_PROGRAM_STATUS1_DONE)>0?TRUE:FALSE;
	if (Done)
		break;//Write done
	else 
	Waiting_Count=Waiting_Count-1;//not finish yet!
        // check status	
    udelay(50);	
    	}
    // check status
    	status1=rtd_inl(ADC_OTP_EF_PROGRAM_STATUS1);
    	if((( status1&ADC_OTP_EF_PROGRAM_STATUS1_SUCCESS ) >0) &&
			( (status1 &ADC_OTP_EF_PROGRAM_STATUS1_FAIL) == 0)){
			if(OTP_DEBUG_LOG)	
		    	printk("program DB  OK\n");
			   return _SUCCESS;
    	}
	else {
			if(OTP_DEBUG_LOG)		
		    	printk("program DB FAILED,ADC_EF_PROGRAM_STATUS1=%x \n",status1);	
		       return _FAIL;
	}
#endif
 return _SUCCESS;	
}



int QCADC_burn_otp_write_data(unsigned int bit_offset, UINT16 *data, unsigned int data_combined,unsigned int type)
{
	//unsigned int i,j;
	UINT32 temp,addr;
	unsigned int world_offset;
	//volatile unsigned int otp_data;
	
    if( bit_offset > 3072 ) {
    	return _FAIL;
    }

	world_offset =  bit_offset >> 5;	
	addr = 0xb8038000+(world_offset<<2);
	
if(OTP_DEBUG_LOG)
    			printk("OTP write addr =%x,bit_offset=%d,data= %x\n", addr,bit_offset,data[0]);



	if(0==type) //write gain slice
		{


					temp=0;
					temp=temp|( data[0]&0x03ff);
					temp=temp|( data[1]&0x03ff)<<10;
					temp=temp|( data[2]&0x03ff)<<20;
					if(OTP_DEBUG_LOG)
				    	printk("ADC_OTP_WRITE_DATA bit_offset %d,data=%d,temp=%x,data_combined=%d,type=%d\n",bit_offset, data[0],temp,data_combined,type);											
					QCADC_start_DWord_program(addr,temp);


		}
	else if(1==type) //write code slice
		{

					temp=0;
					temp=temp|( data[OTP_CODE_SLICE*2]&0x03ff);
					temp=temp|( data[OTP_CODE_SLICE]&0x03ff)<<10;
					temp=temp|( data[0]&0x03ff)<<20;
					if(OTP_DEBUG_LOG)					
				    	printk("ADC_OTP_WRITE_DATA bit_offset %d,data=%d,temp=%x,data_combined=%d,type=%d\n",bit_offset, data[0],temp,data_combined,type);						
					QCADC_start_DWord_program(addr,temp);


		}
	else // write status
		{
					temp=0;
					temp=(data[0]&0x0000003)<<30;
					if(OTP_DEBUG_LOG)					
				    	printk("ADC_OTP_WRITE_DATA bit_offset %d,data=%d,temp=%x,data_combined=%d,type=%d\n",bit_offset, data[0],temp,data_combined,type);												

					QCADC_start_DWord_program(addr,temp);
		
		}
	
	return _SUCCESS;
}

#if 0
signed short QCADC_burn_otp_write_flow(UINT8 aCalibrationSource)
{
int oStatus,oStartIndex;
int oData_Combin=3;
signed short i,ii,CurrentIndex=0,FirstIn=1;
UINT32 Ideal_Read,Real_Read;
	//Step1. Check status empty
	//Step2: Write Gain slice & status 
	//Step3: Write Code  & status 
	for(i=0;i<(OTP_GAIN_SLICE+OTP_CODE_SLICE);i++)
	{
		oStatus=QCADC_burn_otp_read(OTP_YPP_START_ADDR[aCalibrationSource]+OTP_YPP_Status_Offset+CurrentIndex*OTP_YPP_DWord_Size,OTP_YPP_Status_Size);
		Ideal_Read=0;Real_Read=0;
		#if 1
		if(ADC_OTP_STATUS[0]!=oStatus)  //if status != empty then auto shift to next DWORD Address
			{

				if ((OTP_LENGTH[aCalibrationSource]-OTP_GAIN_SLICE-OTP_CODE_SLICE)>CurrentIndex)
					{
					if(OTP_DEBUG_LOG)
				       printk("ADC_OTP_WRITE_FLOW read 'Gain slice' checking status Not empty go SHIFT, status=%d,CurrentIndex=%d,i_index=%d\n", oStatus,CurrentIndex,i);
   					CurrentIndex=CurrentIndex+1;
					i=i-1;
					continue;
					}
				else{
				       printk("ADC_OTP_WRITE_FLOW read 'Gain slice' checking status Not empty go FAIL, status=%d,CurrentIndex=%d\n", oStatus,CurrentIndex);
					return _FAIL;						   
					}				  		
			}
		#endif
		if(i<OTP_GAIN_SLICE){// wirter Gain slice
		QCADC_burn_otp_write_data(OTP_YPP_START_ADDR[aCalibrationSource]+CurrentIndex*OTP_YPP_DWord_Size,&OTP_AWB_ADC_Gain_Slice[aCalibrationSource][i*oData_Combin],oData_Combin,0);
		for(ii=0;ii<oData_Combin;ii++)//Confirm writing
		Ideal_Read=Ideal_Read|((OTP_AWB_ADC_Gain_Slice[aCalibrationSource][0+i*oData_Combin+ii]<<ii*OTP_YPP_Data_Size));
			}
		else{// writer Code slice
		QCADC_burn_otp_write_data(OTP_YPP_START_ADDR[aCalibrationSource]+CurrentIndex*OTP_YPP_DWord_Size,&OTP_ADC_Calib[0][i-OTP_GAIN_SLICE],oData_Combin,1);
		for(ii=0;ii<oData_Combin;ii++) //confirm writing
		Ideal_Read=Ideal_Read|(OTP_ADC_Calib[oData_Combin-ii-1][i-OTP_GAIN_SLICE]<<(ii*OTP_YPP_Data_Size));
		}
		Real_Read=QCADC_burn_otp_read(OTP_YPP_START_ADDR[aCalibrationSource]+CurrentIndex*OTP_YPP_DWord_Size,OTP_YPP_Status_Offset);

		#if 1  // Confirm writed and  status update
		if(Ideal_Read==Real_Read)
			{
			if(OTP_DEBUG_LOG)
		       printk("ADC_OTP_WRITE_FLOW  OKOKOKOK 'Confirm Gain&CodeSlice=%d' CurrentIndex=%d, Ideal_Read=%x,Real_Read=%x,\n", i,CurrentIndex,Ideal_Read,Real_Read);
			QCADC_burn_otp_write_data(OTP_YPP_START_ADDR[aCalibrationSource]+OTP_YPP_Status_Offset+CurrentIndex*OTP_YPP_DWord_Size,&ADC_OTP_STATUS[2],oData_Combin,2);//Status write Done
				if(1==FirstIn){			
				oStartIndex=CurrentIndex;
				FirstIn=0;
				}
				if ((OTP_GAIN_SLICE+OTP_CODE_SLICE-1)==i){
				QCADC_burn_otp_write_data(OTP_YPP_START_ADDR[aCalibrationSource]+OTP_YPP_Status_Offset+oStartIndex*OTP_YPP_DWord_Size,&ADC_OTP_STATUS[3],oData_Combin,2);//Status write finish		
				return _SUCCESS;
				}				
			}
		else	{	            
			if(OTP_DEBUG_LOG)			
		       printk("ADC_OTP_WRITE_FLOW  NGNGNGNG 'Confirm Gain&CodeSlice=%d' CurrentIndex=%d, Ideal_Read=%x,Real_Read=%x,\n", i,CurrentIndex,Ideal_Read,Real_Read);			
			QCADC_burn_otp_write_data(OTP_YPP_START_ADDR[aCalibrationSource]+OTP_YPP_Status_Offset+CurrentIndex*OTP_YPP_DWord_Size,&ADC_OTP_STATUS[1],oData_Combin,2);//Status write Shift
			i=i-1;
			}		
		#endif
		if (15>CurrentIndex)
		CurrentIndex=CurrentIndex+1;					
		else
		return _FAIL;		
	}		
		return _SUCCESS;
}
#else
signed short QCADC_burn_otp_write_flow(UINT8 aCalibrationSource)
{
int oStatus; //,oStartIndex;
int oData_Combin=3;
signed short i,ii,CurrentIndex=0; // ,FirstIn=1;
UINT32 Ideal_Read,Real_Read,Margin_Read;
BOOL oSuccess=0;
	//Step1. Check status empty
	//Step2: Write Gain slice & status 
	//Step3: Write Code  & status 

switch (aCalibrationSource)	
{
case 0:  // YPP table start: Gain slice(3) + Code slice(9) + Offset slice(1)=13
	for(i=0;i<OTP_GAIN_SLICE;i++)// wirter Gain slice(3)
	{
		oStatus=QCADC_burn_otp_read(OTP_YPP_START_ADDR[aCalibrationSource]+OTP_YPP_Status_Offset+CurrentIndex*OTP_YPP_DWord_Size,OTP_YPP_Status_Size);
		Ideal_Read=0;Real_Read=0;
	
		if(OTP_STATUS_FINISH==oStatus) //already finish ,return success
			{
				       printk("ADC_OTP_WRITE_FLOW read 'Gain slice' checking status = finish, status=%d,CurrentIndex=%d\n", oStatus,CurrentIndex);
					return _SUCCESS;						   			  		
			}
          	else if(OTP_STATUS_Empty!=oStatus)  //if status != empty then auto shift to next DWORD Address
			{ 
				       printk("ADC_OTP_WRITE_FLOW read 'Gain slice' checking status Not empty go FAIL, status=%d,CurrentIndex=%d\n", oStatus,CurrentIndex);
					return _FAIL;						   			  		
			}


		QCADC_burn_otp_write_data(OTP_YPP_START_ADDR[aCalibrationSource]+CurrentIndex*OTP_YPP_DWord_Size,&OTP_AWB_ADC_Gain_Slice[aCalibrationSource][i*oData_Combin],oData_Combin,0);
		for(ii=0;ii<oData_Combin;ii++)//Confirm writing
		Ideal_Read=Ideal_Read|((OTP_AWB_ADC_Gain_Slice[aCalibrationSource][0+i*oData_Combin+ii]<<ii*OTP_YPP_Data_Size));



	       rtd_maskl(ADC_OTP_EF_CTRL,0xffffffcf,0x0);  //0X18038814=0X00000000 NORMAL real              
		Real_Read=QCADC_burn_otp_read(OTP_YPP_START_ADDR[aCalibrationSource]+CurrentIndex*OTP_YPP_DWord_Size,OTP_YPP_Status_Offset);
	       rtd_maskl(ADC_OTP_EF_CTRL,0xffffffcf,0x10);  //0X18038814=0X0000000C initial margin real				
		Margin_Read=QCADC_burn_otp_read(OTP_YPP_START_ADDR[aCalibrationSource]+CurrentIndex*OTP_YPP_DWord_Size,OTP_YPP_Status_Offset);
		if((Ideal_Read!=Real_Read)||(Ideal_Read!=Margin_Read))		
						
//		if(0)
			{
				//if(OTP_DEBUG_LOG)			
			       printk("ADC_OTP_WRITE_FLOW  Gain slice NGNGNGNG 'Confirm Gain&CodeSlice=%d' CurrentIndex=%d, Ideal_Read=%x,Real_Read=%x,\n", i,CurrentIndex,Ideal_Read,Real_Read);						
				return _OTP_FAIL;
			}
		QCADC_burn_otp_write_data(OTP_YPP_START_ADDR[aCalibrationSource]+OTP_YPP_Status_Offset+CurrentIndex*OTP_YPP_DWord_Size,(UINT16 *)(&ADC_OTP_STATUS[1]),oData_Combin,2);//Status write GainDone
		CurrentIndex=CurrentIndex+1;
	}

case 1: //SCART table start:  Code slice (9) + Offset slice(1)=10
	for(i=0;i<OTP_CODE_SLICE;i++)//  Code slice  (9)
	{
		oStatus=QCADC_burn_otp_read(OTP_YPP_START_ADDR[aCalibrationSource]+OTP_YPP_Status_Offset+CurrentIndex*OTP_YPP_DWord_Size,OTP_YPP_Status_Size);
		Ideal_Read=0;Real_Read=0;

//		if(OTP_STATUS_FINISH==oStatus) //already finish ,return success

		if(OTP_STATUS_FINISH==oStatus) //already finish ,return success, in order  compatible to old version scart status=2 after finish  
	
			{
				    printk("ADC_OTP_WRITE_FLOW read 'Gain slice'  checking status = finish, status=%d,CurrentIndex=%d\n", oStatus,CurrentIndex);
					return _SUCCESS;						   									  		
			}

		if(OTP_STATUS_Empty!=oStatus)  //if status != empty then auto shift to next DWORD Address
			{
				    printk("ADC_OTP_WRITE_FLOW read 'Gain slice' checking status Not empty go FAIL, status=%d,CurrentIndex=%d\n", oStatus,CurrentIndex);
					return _FAIL;							   									  		
			}
		QCADC_burn_otp_write_data(OTP_YPP_START_ADDR[aCalibrationSource]+CurrentIndex*OTP_YPP_DWord_Size,&OTP_ADC_Calib[0][i],oData_Combin,1);
		for(ii=0;ii<oData_Combin;ii++) //confirm writing
		Ideal_Read=Ideal_Read|(OTP_ADC_Calib[oData_Combin-ii-1][i]<<(ii*OTP_YPP_Data_Size));
	
	       rtd_maskl(ADC_OTP_EF_CTRL,0xffffffcf,0x0);  //0X18038814=0X00000000 NORMAL real    	
		Real_Read=QCADC_burn_otp_read(OTP_YPP_START_ADDR[aCalibrationSource]+CurrentIndex*OTP_YPP_DWord_Size,OTP_YPP_Status_Offset);
		rtd_maskl(ADC_OTP_EF_CTRL,0xffffffcf,0x10);  //0X18038814=0X0000000C initial margin real		
		Margin_Read=QCADC_burn_otp_read(OTP_YPP_START_ADDR[aCalibrationSource]+CurrentIndex*OTP_YPP_DWord_Size,OTP_YPP_Status_Offset);
		if((Ideal_Read!=Real_Read)||(Ideal_Read!=Margin_Read))				
			
//               if(0)			
		{

//			if(OTP_DEBUG_LOG)			
		       printk("ADC_OTP_WRITE_FLOW Code slice NGNGNGNG 'Confirm Gain&CodeSlice=%d' CurrentIndex=%d, Ideal_Read=%x,Real_Read=%x,\n", i,CurrentIndex,Ideal_Read,Real_Read);									
			return _OTP_FAIL;
			}
		//QCADC_burn_otp_write_data(OTP_YPP_START_ADDR[aCalibrationSource]+OTP_YPP_Status_Offset+CurrentIndex*OTP_YPP_DWord_Size,&ADC_OTP_STATUS[aCalibrationSource+1],oData_Combin,2);//Status GainDone		
		QCADC_burn_otp_write_data(OTP_YPP_START_ADDR[aCalibrationSource]+OTP_YPP_Status_Offset+CurrentIndex*OTP_YPP_DWord_Size,(UINT16 *)(&ADC_OTP_STATUS[1]),oData_Combin,2);//Status GainDone		
		CurrentIndex=CurrentIndex+1;
	}
		
case 2: //Offset gain slice (1)		
		for(i=0;i<OTP_OFFSET_SLICE;i++)//  Code slice  (9)
		{
		//offset not save...
		#if 0
			oStatus=QCADC_burn_otp_read(OTP_YPP_START_ADDR[aCalibrationSource]+OTP_YPP_Status_Offset+CurrentIndex*OTP_YPP_DWord_Size,OTP_YPP_Status_Size);
			Ideal_Read=0;Real_Read=0;
			#if 1
			if(ADC_OTP_STATUS[0]!=oStatus)  //if status != empty then auto shift to next DWORD Address
				{
					       printk("ADC_OTP_WRITE_FLOW read 'Gain slice' checking status Not empty go FAIL, status=%d,CurrentIndex=%d\n", oStatus,CurrentIndex);
						return _FAIL;						   
						}				  		
				}
			#endif

			QCADC_burn_otp_write_data(OTP_YPP_START_ADDR[aCalibrationSource]+CurrentIndex*OTP_YPP_DWord_Size,&OTP_AWB_ADC_Gain_Slice[aCalibrationSource][i*oData_Combin],oData_Combin,0);
			for(ii=0;ii<oData_Combin;ii++)//Confirm writing
			Ideal_Read=Ideal_Read|((OTP_AWB_ADC_Gain_Slice[aCalibrationSource][0+i*oData_Combin+ii]<<ii*OTP_YPP_Data_Size));
			Real_Read=QCADC_burn_otp_read(OTP_YPP_START_ADDR[aCalibrationSource]+CurrentIndex*OTP_YPP_DWord_Size,OTP_YPP_Status_Offset);
			if(Ideal_Read!=Real_Read)		
				{
				if(OTP_DEBUG_LOG)			
			       printk("ADC_OTP_WRITE_FLOW Code slice NGNGNGNG 'Confirm Gain&CodeSlice=%d' CurrentIndex=%d, Ideal_Read=%x,Real_Read=%x,\n", i,CurrentIndex,Ideal_Read,Real_Read);									
			oSuccess=oSuccess|_OTP_FAIL;
				break;
				}
			QCADC_burn_otp_write_data(OTP_YPP_START_ADDR[aCalibrationSource]+OTP_YPP_Status_Offset+CurrentIndex*OTP_YPP_DWord_Size,&ADC_OTP_STATUS[2],oData_Combin,2);//Status OffsetDone					
			CurrentIndex=CurrentIndex+1;
		#endif
		}		
	break;
default:
	break;
}

if(_SUCCESS==oSuccess)
{
	if(OTP_SOURCE_YPP==aCalibrationSource)
		// because OTP can't over writer the same bit, so the finish bit sould combin using ADC_OTP_STATUS[1]+ADC_OTP_STATUS[2]=ADC_OTP_STATUS[3]
		//QCADC_burn_otp_write_data(OTP_YPP_START_ADDR[aCalibrationSource]+OTP_YPP_Status_Offset,&ADC_OTP_STATUS[3],oData_Combin,2);//Status GainDone			
		QCADC_burn_otp_write_data(OTP_YPP_START_ADDR[aCalibrationSource]+OTP_YPP_Status_Offset,(UINT16 *)(&ADC_OTP_STATUS[2]),oData_Combin,2);//Status GainDone			
	if(OTP_SOURCE_SCART==aCalibrationSource)
		// because OTP can't over writer the same bit, so the finish bit sould combin using ADC_OTP_STATUS[1]+ADC_OTP_STATUS[2]=ADC_OTP_STATUS[3]
		//QCADC_burn_otp_write_data(OTP_YPP_START_ADDR[aCalibrationSource]+OTP_YPP_Status_Offset,&ADC_OTP_STATUS[3],oData_Combin,2);//Status GainDone				
		QCADC_burn_otp_write_data(OTP_YPP_START_ADDR[aCalibrationSource]+OTP_YPP_Status_Offset,(UINT16 *)(&ADC_OTP_STATUS[2]),oData_Combin,2);//Status GainDone
	return _SUCCESS;
}
else
	return _OTP_FAIL;
}
#endif
// DAC level: 000:0.25V 001:0.4V 010:0.55V 011:0.7V 100:0.85V 101:1.0V 110:1.15V 111:1.3V
void QCADC_Get_CodeDiff(UINT8 DacLevel1,UINT8 DacLevel2,UINT16 GainValueR,UINT16 GainValueG,UINT16 GainValueB,UINT8 gCalibrationSource)
{
int ii;
UINT8 Avg_count=8;
UINT32 ADC_CODE_A,ADC_CODE_B;
UINT16 temp[6],new_temp[6],old_temp[6];

//printk("Get_CodeDiff\n");
if(0==gCalibrationSource)
	rtd_maskl(REG_ADC_VBIAS,0xffe00fff,_BIT23|_BIT21|_BIT20|_BIT15|_BIT14); //Enable Calib mode,SH gain=1.7
else
	rtd_maskl(REG_ADC_VBIAS,0xffe00fff,_BIT23|_BIT21|_BIT20|_BIT14); //Enable Calib mode,SH gain=1.0
	
	temp[0]=0;temp[1]=0;temp[2]=0;temp[3]=0;temp[4]=0;temp[5]=0;
	old_temp[0]=0;old_temp[1]=0;old_temp[2]=0;old_temp[3]=0;old_temp[4]=0;old_temp[5]=0;
	new_temp[0]=0;new_temp[1]=0;new_temp[2]=0;new_temp[3]=0;new_temp[4]=0;new_temp[5]=0;
	rtd_maskl(REG_ADC_VBIAS,0xfff8ffff,(DacLevel1&0x7)<<16); //Enable Calib mode DAC=0.55V
	rtd_outl(REG_ADC_GAIN0,(GainValueG<<16)|GainValueR); //set RG gain
	rtd_outl(REG_ADC_GAIN1,GainValueB); //set B gain
	udelay(50);
	
		for(ii=0;ii<Avg_count+1;ii++)
			{
			ADC_CODE_A=0;ADC_CODE_B=0;
			ADC_CODE_A=rtd_inl(REG_ADC_RGB_DATA);
			ADC_CODE_B=rtd_inl(REG_ADC_RGB_DATA2);
			new_temp[0]=(ADC_CODE_A>>18);
			new_temp[1]=((ADC_CODE_A&0xfff)>>2);
			new_temp[2]=(ADC_CODE_B>>18);			

			if (0!=ii)
				{
				if((20<(YPP_abs(new_temp[0],old_temp[0])))||(20<(YPP_abs(new_temp[1],old_temp[1])))||(20<(YPP_abs(new_temp[2],old_temp[2]))))
					{
					ii=ii-1;
					if(OTP_DEBUG_LOG)
					printk("Get_CodeDiff error new_temp[0]=%d,old_temp[0]=%d,new_temp[1]=%d,old_temp[1]=%d,new_temp[2]=%d,old_temp[2]=%d \n",new_temp[0],old_temp[0],new_temp[1],old_temp[1],new_temp[2],old_temp[2]);							
					}
				else
					{
					temp[0]=new_temp[0]+temp[0];
					temp[1]=new_temp[1]+temp[1];
					temp[2]=new_temp[2]+temp[2];
					}
				}
			old_temp[0]=new_temp[0];
			old_temp[1]=new_temp[1];
			old_temp[2]=new_temp[2];
					
			udelay(5);
//			printk("Get_CodeDiff error new_temp[0]=%d,old_temp[0]=%d,new_temp[1]=%d,old_temp[1]=%d,new_temp[2]=%d,old_temp[2]=%d \n",new_temp[0],old_temp[0],new_temp[1],old_temp[1],new_temp[2],old_temp[2]);										
			}
		temp[0]	=		temp[0]	>>3;
		temp[1]	=		temp[1]	>>3;
		temp[2]	=		temp[2]	>>3;
	
	rtd_maskl(REG_ADC_VBIAS,0xfff8ffff,(DacLevel2&0x7)<<16); //Enable Calib mode DAC=0.55V
		udelay(50);
			for(ii=0;ii<Avg_count+1;ii++)
			{
			ADC_CODE_A=0;ADC_CODE_B=0;
			ADC_CODE_A=rtd_inl(REG_ADC_RGB_DATA);
			ADC_CODE_B=rtd_inl(REG_ADC_RGB_DATA2);

			new_temp[3]=(ADC_CODE_A>>18);
			new_temp[4]=((ADC_CODE_A&0xfff)>>2);
			new_temp[5]=(ADC_CODE_B>>18);	
			if (0!=ii)
				{
				if((20<(YPP_abs(new_temp[3],old_temp[3])))|(20<(YPP_abs(new_temp[4],old_temp[4])))|(20<(YPP_abs(new_temp[5],old_temp[5]))))
					{
					ii=ii-1;
					if(OTP_DEBUG_LOG)					
					printk("Get_CodeDiff error new_temp[3]=%d,old_temp[3]=%d,new_temp[4]=%d,old_temp[4]=%d,new_temp[5]=%d,old_temp[5]=%d \n",new_temp[3],old_temp[3],new_temp[4],old_temp[4],new_temp[5],old_temp[5]);							
					}
				else
					{
					temp[3]=new_temp[3]+temp[3];
					temp[4]=new_temp[4]+temp[4];
					temp[5]=new_temp[5]+temp[5];
					}
				}	
			old_temp[3]=new_temp[3];
			old_temp[4]=new_temp[4];
			old_temp[5]=new_temp[5];
			udelay(5);		

			}
		temp[3]	=		temp[3]	>>3;
		temp[4]	=		temp[4]	>>3;
		temp[5]	=		temp[5]	>>3;	
				
		for(ii=0;ii<3;ii++)
	       OTP_CURRENT_DIFF[ii]=temp[3+ii]>temp[0+ii]?(temp[3+ii]-temp[0+ii]):(temp[0+ii]-temp[3+ii]);
if(OTP_DEBUG_LOG)		
//if (1)
printk("Currently,  Gain=%d,%d,%d, code=%d,%d,%d\n",GainValueR,GainValueG,GainValueB,OTP_CURRENT_DIFF[0],OTP_CURRENT_DIFF[1],OTP_CURRENT_DIFF[2]);

}
void QCADC_Interpolate_GainValue(UINT16 iCode,UINT8 iADCSelect,signed short  *iNewGain,UINT8 iCalibrationSource )	
{
UINT8 interpolate_zone,i1,i2;
UINT16 temp1,temp2;
UINT16 ratio_tempR,ratio_tempG,ratio_tempB;
UINT32 ratio_temp1;

	ratio_tempR=OTP_ADC_Calib[0][OTP_AlignPoint];
	ratio_tempG=OTP_ADC_Calib[1][OTP_AlignPoint];
	ratio_tempB=OTP_ADC_Calib[2][OTP_AlignPoint];
	ratio_temp1=OTP_CURRENT_DIFF[0]+(OTP_CURRENT_DIFF[1]<<1)+OTP_CURRENT_DIFF[2];
//	ratio=(( CURRENT_DIFF[0]/ratio_tempR)+2*( CURRENT_DIFF[1]/ratio_tempG)+( CURRENT_DIFF[2]/ratio_tempB))/4
	printk("Interpolate_GainValue ratio=%d \n",ratio_temp1);

	for(i1=0;i1<OTP_GAIN_SLICE;i1++)
		for (i2=0;i2<OTP_CODE_SLICE;i2++){
			OTP_ADC_Calib[i1][i2]=(OTP_ADC_Calib[i1][i2]*ratio_temp1)/(ratio_tempR+(ratio_tempG<<1)+ratio_tempB);

//			printk("Interpolate_GainValue new ADC_Calib[%d][%d]=%d \n",i1,i2,ADC_Calib[i1][i2]);
			}
			
	interpolate_zone=iCode>OTP_ADC_Calib[iADCSelect][0]?0:(iCode>OTP_ADC_Calib[iADCSelect][1]?1:(iCode>OTP_ADC_Calib[iADCSelect][2]?2:(iCode>OTP_ADC_Calib[iADCSelect][3]?3:(iCode>OTP_ADC_Calib[iADCSelect][4]?
		                             4:(iCode>OTP_ADC_Calib[iADCSelect][5]?5:(iCode>OTP_ADC_Calib[iADCSelect][6]?6:(iCode>OTP_ADC_Calib[iADCSelect][7]?7:(iCode>OTP_ADC_Calib[iADCSelect][8]?8:9))))))));	
	switch (interpolate_zone)
		{
		case 0:
			temp1=OTP_ADC_Calib[iADCSelect][interpolate_zone]-OTP_ADC_Calib[iADCSelect][interpolate_zone+1];
			temp2=YPP_abs(OTP_AWB_ADC_Gain_Slice[iCalibrationSource][interpolate_zone],OTP_AWB_ADC_Gain_Slice[iCalibrationSource][interpolate_zone+1]);
			*iNewGain=OTP_AWB_ADC_Gain_Slice[iCalibrationSource][interpolate_zone]-(iCode-OTP_ADC_Calib[iADCSelect][interpolate_zone])*temp2/temp1;			
			break;
		case 9:
			temp1=OTP_ADC_Calib[iADCSelect][interpolate_zone-2]-OTP_ADC_Calib[iADCSelect][interpolate_zone-1];
			temp2=YPP_abs(OTP_AWB_ADC_Gain_Slice[iCalibrationSource][interpolate_zone-2],OTP_AWB_ADC_Gain_Slice[iCalibrationSource][interpolate_zone-1]);
			*iNewGain=OTP_AWB_ADC_Gain_Slice[iCalibrationSource][interpolate_zone-1]+(OTP_ADC_Calib[iADCSelect][interpolate_zone-1]-iCode)*temp2/temp1;			
			break;
		default:
			temp1=OTP_ADC_Calib[iADCSelect][interpolate_zone-1]-OTP_ADC_Calib[iADCSelect][interpolate_zone];
			temp2=YPP_abs(OTP_AWB_ADC_Gain_Slice[iCalibrationSource][interpolate_zone-1],OTP_AWB_ADC_Gain_Slice[iCalibrationSource][interpolate_zone]);
			*iNewGain=OTP_AWB_ADC_Gain_Slice[iCalibrationSource][interpolate_zone]-(iCode-OTP_ADC_Calib[iADCSelect][interpolate_zone])*temp2/temp1;
			break;
		}
	printk("Interpolate_GainValue interpolate_zone=%d,iNewGain=%d\n",interpolate_zone,*iNewGain);
}
void QCADC_Calculate_GainDrift(signed short  *cGainAdjust,UINT8 cCalibrationSource)
{
printk("Calculate_GainDrift\n");
UINT16 CurrentValue,TableValue;
signed short CodeDrift,GainDrift[3];
UINT8  i;

CurrentValue=OTP_CURRENT_DIFF[0]+OTP_CURRENT_DIFF[1]+OTP_CURRENT_DIFF[1]+OTP_CURRENT_DIFF[2];// G channel weighting *2
TableValue=OTP_ADC_Calib[0][OTP_AlignPoint]+OTP_ADC_Calib[1][OTP_AlignPoint]+OTP_ADC_Calib[1][OTP_AlignPoint]+OTP_ADC_Calib[2][OTP_AlignPoint];// G channel weighting *2

CodeDrift=(YPP_abs(TableValue,CurrentValue))>>2;

if (CodeDrift>OTP_UpdateThres)
{
	for(i=0;i<3;i++)
	{
	CurrentValue>TableValue?QCADC_Interpolate_GainValue(OTP_ADC_Calib[i][OTP_AlignPoint]+CodeDrift,i,&GainDrift[i],cCalibrationSource):QCADC_Interpolate_GainValue(OTP_ADC_Calib[i][OTP_AlignPoint]-CodeDrift,i,&GainDrift[i],cCalibrationSource);
//	Interpolate_GainValue(OTP_SAWB_GetTARGET[i],i,&NewGain[i]);
//	printk("Calculate_GainDrift CodeDrift=%d,GainDrift[%d]=%d,TableNewGain[%d]=%d\n",CodeDrift,i,GainDrift[i],i,NewGain[i]);
//	NewGain[i]=NewGain[i]+GainDrift[i]-OTP_AWB_ADC_Gain_Slice[1];
	*(cGainAdjust+i)=GainDrift[i]-OTP_AWB_ADC_Gain_Slice[cCalibrationSource][OTP_AlignPoint];
	}
//	printk("Calculate_GainDrift FinalNewGain[0]=%d,FinalNewGain[1]=%d,FinalNewGain[2]=%d,\n",NewGain[0],NewGain[1],NewGain[2]);
}
else{
*cGainAdjust=0;*(cGainAdjust+1)=0;*(cGainAdjust+2)=0;}
printk("Calculate_GainDrift CodeDrift=%d cGainAdjust=%d,%d,%d\n",CodeDrift,*cGainAdjust,*(cGainAdjust+1),*(cGainAdjust+2));
}

void QCADC_SAWB_GainCalculate(UINT8 sCalibrationSource)
{
// get current 0.55~0.85V code diff at gain =OTP_AWB_ADC_Gain_Slice[2]
// DAC level: 000:0.25V 001:0.4V 010:0.55V 011:0.7V 100:0.85V 101:1.0V 110:1.15V 111:1.3V
//Step1. Get the Codediff  at currently align point.
//Step2. Caculate Gain drift at align point. a. Caculate the which gain will have the same codediff on org-table b. code drift = a.-align point
//Step3. Caculate the Gain for GetTagertValue and the final Gain=              

//signed short  sGainCompensate[3];
int i;
printk("SAWB_GainCalculate source=%d\n",sCalibrationSource);

QCADC_Get_CodeDiff(2,4,OTP_AWB_ADC_Gain_Slice[sCalibrationSource][OTP_AlignPoint],OTP_AWB_ADC_Gain_Slice[sCalibrationSource][OTP_AlignPoint],OTP_AWB_ADC_Gain_Slice[sCalibrationSource][OTP_AlignPoint],sCalibrationSource);
//QCADC_Calculate_GainDrift(sGainCompensate,sCalibrationSource);
	for (i=0;i<3;i++)
	{
	QCADC_Interpolate_GainValue(OTP_SAWB_GetTARGET[sCalibrationSource][i],i,&OTP_FINAL_GAIN[i],sCalibrationSource);
//	OTP_FINAL_GAIN[i]=OTP_FINAL_GAIN[i]-sGainCompensate[i];
	if (OTP_FINAL_GAIN[i]>511)
		OTP_FINAL_GAIN[i]=511;
	else if (OTP_FINAL_GAIN[i]<0)
	OTP_FINAL_GAIN[i]=0;
	}
printk("SAWB_GainCalculate OTP_FINAL_GAIN=%d,%d,%d\n",OTP_FINAL_GAIN[0],OTP_FINAL_GAIN[1],OTP_FINAL_GAIN[2]);
printk("SAWB_GainCalculate Source=%d, GetTargetValue=%d,%d,%d\n",sCalibrationSource,OTP_SAWB_GetTARGET[sCalibrationSource][0],OTP_SAWB_GetTARGET[sCalibrationSource][1],OTP_SAWB_GetTARGET[sCalibrationSource][2]);
// confirm final gain and GetTarget
QCADC_Get_CodeDiff(2,4,OTP_FINAL_GAIN[0],OTP_FINAL_GAIN[1],OTP_FINAL_GAIN[2],sCalibrationSource);
printk("Currently,  Gain=%d,%d,%d, code=%d,%d,%d\n",OTP_FINAL_GAIN[0],OTP_FINAL_GAIN[1],OTP_FINAL_GAIN[2],OTP_CURRENT_DIFF[0],OTP_CURRENT_DIFF[1],OTP_CURRENT_DIFF[2]);
}
void QCADC_Build_Self_AWB_ADC_Curve(UINT8 bCalibrationSource)
{
int count,i,ii;
//UINT8 Avg_count=16;
//UINT32 ADC_CODE_A,ADC_CODE_B;
//UINT16 temp[6],new_temp[6],old_temp[6],ADC_R,ADC_G,ADC_B;

	printk("Build_Self_AWB_ADC_Curve source=%d\n",bCalibrationSource);


	if(0==bCalibrationSource)
	rtd_maskl(REG_ADC_VBIAS,0xffe00fff,_BIT23|_BIT21|_BIT20|_BIT15); //Enable Calib mode,SH gain=1.7
	else
	rtd_maskl(REG_ADC_VBIAS,0xffe00fff,_BIT23|_BIT21|_BIT20); //Enable Calib mode,SH gain=1.0		

	 

	 
	count=OTP_CODE_SLICE;
	//printk("Build_Self_AWB_ADC_Curve count=%d\n",count);
	for(i=0;i<count;i++)
		{
		QCADC_Get_CodeDiff(2,4,OTP_AWB_ADC_Gain_Slice[bCalibrationSource][i],OTP_AWB_ADC_Gain_Slice[bCalibrationSource][i],OTP_AWB_ADC_Gain_Slice[bCalibrationSource][i],bCalibrationSource);
		for(ii=0;ii<3;ii++)
				{
				OTP_ADC_Calib[ii][i]=0;
			       OTP_ADC_Calib[ii][i]=OTP_CURRENT_DIFF[ii];
				}
		}
		if(OTP_DEBUG_LOG)
//		if(1)			
			{
	printk("OTP_ADC_Calib source=%d, Gain Slice=%d,%d,%d,%d,%d,%d,%d,%d,%d\n",bCalibrationSource,OTP_AWB_ADC_Gain_Slice[bCalibrationSource][0],OTP_AWB_ADC_Gain_Slice[bCalibrationSource][1],OTP_AWB_ADC_Gain_Slice[bCalibrationSource][2],
	OTP_AWB_ADC_Gain_Slice[bCalibrationSource][3],OTP_AWB_ADC_Gain_Slice[bCalibrationSource][4],OTP_AWB_ADC_Gain_Slice[bCalibrationSource][5],OTP_AWB_ADC_Gain_Slice[bCalibrationSource][6],OTP_AWB_ADC_Gain_Slice[bCalibrationSource][7]
	,OTP_AWB_ADC_Gain_Slice[bCalibrationSource][8]);
	printk("OTP_ADC_Calib R diff=%d,%d,%d,%d,%d,%d,%d,%d,%d\n",OTP_ADC_Calib[0][0],OTP_ADC_Calib[0][1],OTP_ADC_Calib[0][2],OTP_ADC_Calib[0][3],OTP_ADC_Calib[0][4],OTP_ADC_Calib[0][5]
															,OTP_ADC_Calib[0][6],OTP_ADC_Calib[0][7],OTP_ADC_Calib[0][8]);
	printk("OTP_ADC_Calib G diff=%d,%d,%d,%d,%d,%d,%d,%d,%d\n",OTP_ADC_Calib[1][0],OTP_ADC_Calib[1][1],OTP_ADC_Calib[1][2],OTP_ADC_Calib[1][3],OTP_ADC_Calib[1][4],OTP_ADC_Calib[1][5]
															,OTP_ADC_Calib[1][6],OTP_ADC_Calib[1][7],OTP_ADC_Calib[1][8]);
	printk("OTP_ADC_Calib B diff=%d,%d,%d,%d,%d,%d,%d,%d,%d\n",OTP_ADC_Calib[2][0],OTP_ADC_Calib[2][1],OTP_ADC_Calib[2][2],OTP_ADC_Calib[2][3],OTP_ADC_Calib[2][4],OTP_ADC_Calib[2][5]
															,OTP_ADC_Calib[2][6],OTP_ADC_Calib[2][7],OTP_ADC_Calib[2][8]);
			}

}




int QC_Verifier_OTP(void)
{
 UINT32 	result = SUCCESS;
	UINT8 test_flag = 1;
if(test_flag)
{
// sync from I_domain.c	
rtd_outl(0xb8000114, 0x60002803);// enable TVSB1~3,APLL_ADC,I/M/D domain clock 
rtd_outl(0xb8000114, 0x60002802);// disable TVSB1~3,APLL_ADC,I/M/D domain clock	
rtd_outl(0xb8000104, 0xE0002806);// hold TVSB1~3,APLL_ADC,I/M/D domain reset	
rtd_outl(0xb8000104, 0xE0002807);// release TVSB1~3,APLL_ADC,I/M/D domain reset	
	udelay(100000); 	
rtd_outl(0xb8000114, 0x60002803);// enable TVSB1~3,APLL_ADC,I/M/D domain clock
rtd_outl(0xb8000108,  0x03000000);// RESET TVSB1~3,APLL_ADC,I/M/D domain clock	
rtd_outl(0xb8000108,  0x03000001);// disable TVSB1~3,APLL_ADC,I/M/D domain clock
rtd_outl(0xb8000118,  0x03000001);// disable TVSB1~3,APLL_ADC,I/M/D domain clock
rtd_outl(0xb8029000,	0x00000000);// disable PTG
////PLL27x Clock : 108M
rtd_maskl(0xb80004D0,0xFFFFFFE0,0x0000000E);//432MHzPLL27X_M[6:0] = 0x0E
rtd_maskl(0xb80004D4,0xFFFFFFFF,0x00000000);// do nothing
rtd_maskl(0xb80004DC,0xFDFC0FFF,0x0201F000);//[25]PLL_L2H_CML_POW [17:16]PLL27X_CK108M_DIV = 0x1, divide by 4 (use when VCO=432MHz) [15:14]PLL27X_YPPADC_CKO_SEL = 0x3,YPPADC clock outpu 11:108M [13]PLL27X_YPPADC_CKO_EN[12]PLL27X_YPPADC_CK54M_EN
rtd_maskl(0xb80004D8,0x00000000,0x00000000);//Power off and rst PLL27x
rtd_maskl(0xb80004D8,0x00000000,0x00000017);//Power on PLL27x [4]PLL27X_PS_EN[3]PLL27X_PS_DIV2 = 0x0 use VCO = 540,324,432M[2]PLL27X_VCORSTB[1]PLL27X_RSTB[0]PLL27X_POW

	rtd_maskl(REG_PLL_CTRL,0xfff8DffE,_BIT18|_BIT16|_BIT13|_BIT0);	 //enable APLL LDO 1.1V power, 0xb8020104[18:16]=101(05), 0xb8020104[0]=1, power down , 0xb8020104[13]=1, RSTN_OFFMS for MAC3
		 udelay(45000);
#include "../I_Domain/ypp_adc_480i.tbl"
		udelay(50500);
#include "../I_Domain/apll_ypp480i.tbl"                        // APLL for YPbPr480i source
	rtd_outl(REG_ADC_CTL_RGB123, 0x03550195);
		udelay(125000);
	rtd_maskl(REG_PLL_CTRL,0xfff8DffE,(_BIT18|_BIT16|_BIT13)&(~_BIT0));	// enable APLL & dual clk,	0xb8020104[0]=0, Normal run, V16 setting: 1.68V(default), LDO reference voltage setting:1.1V (default), LDO power on, 0xb8020104[13]=1, RSTN_OFFMS for MAC3
		udelay(125000);
	rtd_maskl(REG_ADC_CLOCK,0xfffffbff,_BIT10); //clk from Pll27x
	rtd_maskl(REG_ADC_DCRESTORE_CTRL,0xffd0fe00,_BIT21); //Enable Calib mode OFFPAD,LPF=10M
	rtd_maskl(REG_ADC_CLAMP_CTRL1,0xfffffe00,_BIT8|_BIT6|_BIT5|_BIT3|_BIT2|_BIT0); //VClamping postive Enable
	rtd_maskl(REG_ADC_CLAMP_CTRL0,0xf000fe00,_BIT27|_BIT25|_BIT24|_BIT22|_BIT21|_BIT19|_BIT7|_BIT6|_BIT4|_BIT3|_BIT1|_BIT0); //VClamping postive Enable
	rtd_outl(0xb801A004, 0x32);
	rtd_outl(0xb801A004, 0x22);
	rtd_outl(0xb801A004, 0x23);
	


    	QCADC_Build_Self_AWB_ADC_Curve(OTP_SOURCE_YPP);
//	QCADC_SAWB_GainCalculate(OTP_SOURCE_YPP);  		
	result=result|QCADC_burn_otp_write_flow(OTP_SOURCE_YPP);
    	QCADC_Build_Self_AWB_ADC_Curve(OTP_SOURCE_SCART); 
//	QCADC_SAWB_GainCalculate(OTP_SOURCE_SCART);  		
	result=result|QCADC_burn_otp_write_flow(OTP_SOURCE_SCART);		
	printk("result=%x \n",result);




if(OTP_ECC_ENABLE)
{
int i=0,ii=0;
UINT32 temp;
char ADC_Data[128];//8*128
int ECC_Data=0;
for(i=0;i<23;i++)
	{
	temp=ADC_OTP_REG_BASE+((OTP_YPP_START_ADDR_BASE1>>5)<<2)+i*4;
	
	for(ii=0;ii<4;ii++)
	ADC_Data[i*4+ii]=(rtd_inl(temp)>>(8*ii))&0xff;
	}
       for(ii=91;i<128;i++)
	ADC_Data[i]=0;
	//if(OTP_DEBUG_LOG)
	printk("ADC ECC reg=0x%x,data=%x \n",temp,(unsigned int)ADC_Data);

	EnHammingCode1024(ADC_Data,(unsigned int *)(&ECC_Data));
	printk("ADC_ecc_data=0x%x \n",ECC_Data);	
}

//rtd_part_outl(0xb8000844,31,28,0xf); //pinshare gpio71 to GPIO
//rtd_part_outl(0xb801bd08,7,7,0x1); //set to GPO
//rtd_part_outl(0xb801bd20,7,7,0x1); //GPO to high, efuse power on

}	
	if(result!=_SUCCESS)
	return FAILED;
	else
	return SUCCESS;


} 

