#include <qc_verify_common.h>
#include <rbusVDTopReg.h>
#include <rbusVDIFDinReg.h>
#include <rbusAdcReg.h>
#include <rbusTV_SB1_ANAReg.h>
#include <rbusVDPQReg.h>
//#include "VDC_Top_qc.h"
#include "VDC_verification_code.h"

VDC_VERIFY_ENTRY_T  vdc_verify_run_list[] = {
	{"print_all_list",vdc_print_all_test_case},
	{"case3_1",vdc_test_case_3_1},
	{"case3_2",vdc_test_case_3_2},
	{"case_3_3_contrast",vdc_test_case_3_3_contrast},
	{"case_3_3_brightness",vdc_test_case_3_3_brightness},
	{"case_3_3_saturation",vdc_test_case_3_3_saturation},
	{"case_3_3_hue",vdc_test_case_3_3_hue},
	{"case3_4",vdc_test_case_3_4},
	{"case3_7",vdc_test_case_3_7},
	{"case5_1",vdc_test_case_5_1},
	//{"case5_2",vdc_test_case_5_2},
	{"case_mac3_12_2",vdc_test_case_mac3_12_2},
	{"case_mac3_12_3",vdc_test_case_mac3_12_3},
	{"case_mac3_12_4",vdc_test_case_mac3_12_4},
	{"case_mac3_12_5",vdc_test_case_mac3_12_5},
	{"case_mac3_12_6",vdc_test_case_mac3_12_6},
	{"case_mac3_12_7",vdc_test_case_mac3_12_7},
	{"case_mac3_12_8",vdc_test_case_mac3_12_8},
	{"case_mac3_12_9",vdc_test_case_mac3_12_9},
	{"restore2default",vdc_restore2default},
	{ "", NULL}
};

/*
example:
int vdc_test_case(void)
{
	unsigned int ret;

	ret = vsuccess;
	
	return ret;
}
*/

/*
Comment:
1. case3_5 test in the qc code
2. 3_6 don't add temporarily
*/

int vdc_print_all_test_case(void)
{
	int total;
	unsigned int ret;

	ret = vsuccess;
	total = 0;
		
	printk(" == VDC CODE TEST LIST ==\n");
	while(vdc_verify_run_list[total].entry_function != 0)
	{
		printk("  %d).%s\n",total,vdc_verify_run_list[total].entry_name);
		total++;
	}
	printk("  %d).ALL (not support now)\n",total);
	total++;
	//printk("  %d).ALL LOOPS [Shift+A to break loops]\n",total);
	printk("  %d).ALL LOOPS (not support now)\n",total);
	total++;
	printk("  %d).ESC\n",total);
	printk("\r\n");

	return ret;

}

int vdc_test_case_3_1(void)
{
	unsigned int ret;
	vdtop_video_status_reg1_RBUS vdtop_video_status_reg1_reg;

	trace("%s()\n",__FUNCTION__);

	ret = vsuccess;
	
	vdtop_video_status_reg1_reg.regValue= rtd_inl(VDTOP_VIDEO_STATUS_REG1_VADDR);

	if((vdtop_video_status_reg1_reg.regValue&0xE)==0xE)
	{
		trace("0x%x,value:0x%x\n",VDTOP_VIDEO_STATUS_REG1_VADDR,(rtd_inl(VDTOP_VIDEO_STATUS_REG1_VADDR)&0xf));
		trace("pass\n");
	}
	else
	{
		trace("no_signal:0x%x\n",(vdtop_video_status_reg1_reg.regValue&0xf));
		ret = vfail;
	}

	return ret;
}

int vdc_test_case_3_2(void)
{
	unsigned int ret,tmp,i,j;
	vdtop_output_control_RBUS vdtop_output_control_reg;

	trace("%s()\n",__FUNCTION__);

	trace("start yc delay\n");

	ret = vsuccess;

	tmp = rtd_inl(VDTOP_OUTPUT_CONTROL_VADDR);

	for(i=0;i<16;i++)
	{
		vdtop_output_control_reg.regValue = rtd_inl(VDTOP_OUTPUT_CONTROL_VADDR);
		vdtop_output_control_reg.yc_delay = i;
		rtd_outl(VDTOP_OUTPUT_CONTROL_VADDR,vdtop_output_control_reg.regValue);
		for(j=0;j<5;j++)
		{
			udelay(1000000);
		}
	}
	
	//restore the value
	rtd_outl(VDTOP_OUTPUT_CONTROL_VADDR,tmp);

	return ret;
}

int vdc_test_case_3_3_contrast(void)
{
	unsigned int ret,tmp,i,j;
	vdtop_luma_contrast_adj_RBUS vdtop_luma_contrast_adj_reg;
	vdtop_luma_brightness_adj_RBUS vdtop_luma_brightness_adj_reg;
	vdtop_chroma_saturation_adj_RBUS vdtop_chroma_saturation_adj_reg;

	trace("%s()\n",__FUNCTION__);

	ret = vsuccess;

	tmp = rtd_inl(VDTOP_LUMA_CONTRAST_ADJ_VADDR);
	
	for(i=0;i<0x100;i++)
	{
		vdtop_luma_contrast_adj_reg.regValue = rtd_inl(VDTOP_LUMA_CONTRAST_ADJ_VADDR);
		vdtop_luma_contrast_adj_reg.contrast = i;
		rtd_outl(VDTOP_LUMA_CONTRAST_ADJ_VADDR,vdtop_luma_contrast_adj_reg.regValue);
		udelay(1000000);
	}

	//restore the value
	rtd_outl(VDTOP_LUMA_CONTRAST_ADJ_VADDR,tmp);

	return ret;
}

int vdc_test_case_3_3_brightness(void)
{
	unsigned int ret,tmp,i,j;
	vdtop_luma_contrast_adj_RBUS vdtop_luma_contrast_adj_reg;
	vdtop_luma_brightness_adj_RBUS vdtop_luma_brightness_adj_reg;
	vdtop_chroma_saturation_adj_RBUS vdtop_chroma_saturation_adj_reg;

	trace("%s()\n",__FUNCTION__);

	ret = vsuccess;

	tmp = rtd_inl(VDTOP_LUMA_BRIGHTNESS_ADJ_VADDR);

	for(i=0;i<0x100;i++)
	{	
		vdtop_luma_brightness_adj_reg.regValue = rtd_inl(VDTOP_LUMA_BRIGHTNESS_ADJ_VADDR);
		vdtop_luma_brightness_adj_reg.brightness = i;
		rtd_outl(VDTOP_LUMA_BRIGHTNESS_ADJ_VADDR,vdtop_luma_brightness_adj_reg.regValue);
		udelay(1000000);
	}

	//restore the value
	rtd_outl(VDTOP_LUMA_BRIGHTNESS_ADJ_VADDR,tmp);	

	return ret;
}

int vdc_test_case_3_3_saturation(void)
{
	unsigned int ret,tmp,i,j;
	vdtop_luma_contrast_adj_RBUS vdtop_luma_contrast_adj_reg;
	vdtop_luma_brightness_adj_RBUS vdtop_luma_brightness_adj_reg;
	vdtop_chroma_saturation_adj_RBUS vdtop_chroma_saturation_adj_reg;

	trace("%s()\n",__FUNCTION__);

	ret = vsuccess;
	
	tmp = rtd_inl(VDTOP_CHROMA_SATURATION_ADJ_VADDR);
	
	for(i=0;i<0x100;i++)
	{
		vdtop_chroma_saturation_adj_reg.regValue = rtd_inl(VDTOP_CHROMA_SATURATION_ADJ_VADDR);
		vdtop_chroma_saturation_adj_reg.saturation = i;
		rtd_outl(VDTOP_CHROMA_SATURATION_ADJ_VADDR,vdtop_chroma_saturation_adj_reg.regValue);
		udelay(1000000);
	}

	//restore the value
	rtd_outl(VDTOP_CHROMA_SATURATION_ADJ_VADDR,tmp);
	
	udelay(1000000);	

	return ret;
}

int vdc_test_case_3_3_hue(void)
{
	unsigned int ret,tmp,i,j;
	vdtop_chroma_hue_phase_adj_RBUS vdtop_chroma_hue_phase_adj_reg;

	trace("%s()\n",__FUNCTION__);

	ret = vsuccess;

	tmp = rtd_inl(VDTOP_CHROMA_HUE_PHASE_ADJ_VADDR);
	
	for(i=0;i<0x100;i++)
	{
		vdtop_chroma_hue_phase_adj_reg.regValue = rtd_inl(VDTOP_CHROMA_HUE_PHASE_ADJ_VADDR);
		vdtop_chroma_hue_phase_adj_reg.hue = i;
		rtd_outl(VDTOP_CHROMA_HUE_PHASE_ADJ_VADDR,vdtop_chroma_hue_phase_adj_reg.regValue);
		udelay(1000000);
	}

	//restore the value
	rtd_outl(VDTOP_CHROMA_HUE_PHASE_ADJ_VADDR,tmp);

	return ret;
}


int vdc_test_case_3_4(void)
{
	unsigned int ret,tmp,tmp1,tmp2,tmp3,tmp4,i,j;
	vdtop_pattern_control_RBUS vdtop_pattern_control_reg;
	vdtop_ad_sw_ctrl0_RBUS vdtop_ad_sw_ctrl0_reg;
	vdtop_video_control1_RBUS vdtop_video_control1_reg;
	vdtop_fsw_ctrl2_RBUS vdtop_fsw_ctrl2_reg;
	
	trace("%s()\n",__FUNCTION__);

	ret = vsuccess;

	vdtop_pattern_control_reg.regValue = rtd_inl(VDTOP_PATTERN_CONTROL_VADDR);
	vdtop_ad_sw_ctrl0_reg.regValue = rtd_inl(VDTOP_AD_SW_CTRL0_VADDR);

	//backup the setting
	tmp = rtd_inl(VDTOP_PATTERN_CONTROL_VADDR);
	tmp1 = rtd_inl(VDTOP_AD_SW_CTRL0_VADDR);
	tmp2 = rtd_inl(VDTOP_VIDEO_CONTROL1_VADDR);
	tmp3 = rtd_inl(VDTOP_FSW_CTRL2_VADDR);
	tmp4 = rtd_inl(VDTOP_CB_SAT_ADJ_VADDR);

	//clear the path and pattern
	rtd_outl(VDTOP_AD_SW_CTRL0_VADDR,0x0);
	rtd_outl(VDTOP_PATTERN_CONTROL_VADDR,0x0);

	//enable the ntsc internal pattern gen.
	vdtop_pattern_control_reg.regValue = rtd_inl(VDTOP_PATTERN_CONTROL_VADDR);
	vdtop_pattern_control_reg.pattern_gen_cvbs_mode = 0x0;
	vdtop_pattern_control_reg.pattern_generator_enable = 0x1;
	rtd_outl(VDTOP_PATTERN_CONTROL_VADDR,vdtop_pattern_control_reg.regValue);

	trace("ntsc pattern gen\n");
	for(j = 0; j< 100; j++)
		udelay(1000000);

	
	//clear the path and pattern
	rtd_outl(VDTOP_AD_SW_CTRL0_VADDR,0x0);
	rtd_outl(VDTOP_PATTERN_CONTROL_VADDR,0x0);

	//enable the pal internal pattern gen.
	vdtop_pattern_control_reg.regValue = rtd_inl(VDTOP_PATTERN_CONTROL_VADDR);
	vdtop_pattern_control_reg.pattern_gen_cvbs_mode = 0x1;
	vdtop_pattern_control_reg.pattern_generator_enable = 0x1;
	rtd_outl(VDTOP_PATTERN_CONTROL_VADDR,vdtop_pattern_control_reg.regValue);

	trace("pal pattern gen\n");
	for(j = 0; j< 100; j++)
		udelay(1000000);

	//clear the path and pattern
	rtd_outl(VDTOP_AD_SW_CTRL0_VADDR,0x0);
	rtd_outl(VDTOP_PATTERN_CONTROL_VADDR,0x0);

	//enable the ntsc sv pattern gen.
	vdtop_video_control1_reg.regValue = rtd_inl(VDTOP_VIDEO_CONTROL1_VADDR);
	vdtop_video_control1_reg.yc_src = 0x1;
	rtd_outl(VDTOP_VIDEO_CONTROL1_VADDR,vdtop_video_control1_reg.regValue);
	vdtop_pattern_control_reg.regValue = rtd_inl(VDTOP_PATTERN_CONTROL_VADDR);
	vdtop_pattern_control_reg.pattern_generator_enable = 0x1;
	rtd_outl(VDTOP_PATTERN_CONTROL_VADDR,vdtop_pattern_control_reg.regValue);

	trace("ntsc sv pattern gen\n");
	for(j = 0; j< 100; j++)
		udelay(1000000);

	//clear the path and pattern
	rtd_outl(VDTOP_PATTERN_CONTROL_VADDR,tmp);
	rtd_outl(VDTOP_AD_SW_CTRL0_VADDR,tmp1);
	rtd_outl(VDTOP_VIDEO_CONTROL1_VADDR,tmp2);
	rtd_outl(VDTOP_FSW_CTRL2_VADDR,tmp3);
	rtd_outl(VDTOP_CB_SAT_ADJ_VADDR,tmp4);


	//enable scart pattern gen.
	rtd_outl(VDTOP_AD_SW_CTRL0_VADDR,0x1E);
	
	vdtop_fsw_ctrl2_reg.regValue = rtd_inl(VDTOP_FSW_CTRL2_VADDR);
	vdtop_fsw_ctrl2_reg.fb_en = 0x1;
	vdtop_fsw_ctrl2_reg.fb_sw = 0x1;
	vdtop_fsw_ctrl2_reg.scart_en = 0x1;
	rtd_outl(VDTOP_FSW_CTRL2_VADDR,vdtop_fsw_ctrl2_reg.regValue);
	
	rtd_outl(VDTOP_CB_SAT_ADJ_VADDR,0x80);
	
	vdtop_pattern_control_reg.regValue = rtd_inl(VDTOP_PATTERN_CONTROL_VADDR);
	vdtop_pattern_control_reg.pattern_gen_scart_en = 0x1;
	vdtop_pattern_control_reg.pattern_generator_enable = 0x1;
	rtd_outl(VDTOP_PATTERN_CONTROL_VADDR,vdtop_pattern_control_reg.regValue);	
	trace("scart pattern gen\n");
	for(j = 0; j< 100; j++)
		udelay(1000000);

	//restore the value
	rtd_outl(VDTOP_PATTERN_CONTROL_VADDR,tmp);
	rtd_outl(VDTOP_AD_SW_CTRL0_VADDR,tmp1);
	rtd_outl(VDTOP_VIDEO_CONTROL1_VADDR,tmp2);
	rtd_outl(VDTOP_FSW_CTRL2_VADDR,tmp3);
	rtd_outl(VDTOP_CB_SAT_ADJ_VADDR,tmp4);
	
	return ret;
}

int vdc_test_case_3_7(void)
{
	unsigned int ret,tmp,tmp1,tmp2,tmp3,j;

	vdtop_output_control_RBUS vdtop_output_control_reg;
	vdtop_blue_screen_y_RBUS vdtop_blue_screen_y_reg;
	vdtop_blue_screen_cb_RBUS vdtop_blue_screen_cb_reg;
	vdtop_blue_screen_cr_RBUS vdtop_blue_screen_cr_reg;

	trace("%s()\n",__FUNCTION__);

	tmp = rtd_inl(VDTOP_OUTPUT_CONTROL_VADDR);
	tmp1 = rtd_inl(VDTOP_BLUE_SCREEN_Y_VADDR);
	tmp2 = rtd_inl(VDTOP_BLUE_SCREEN_CB_VADDR);
	tmp3 = rtd_inl(VDTOP_BLUE_SCREEN_CR_VADDR);

	vdtop_output_control_reg.regValue = rtd_inl(VDTOP_OUTPUT_CONTROL_VADDR);
	vdtop_output_control_reg.blue_mode = 0x1;
	rtd_outl(VDTOP_OUTPUT_CONTROL_VADDR,vdtop_output_control_reg.regValue);

	vdtop_blue_screen_y_reg.regValue = rtd_inl(VDTOP_BLUE_SCREEN_Y_VADDR);
	vdtop_blue_screen_y_reg.blue_screen_y = 0x30;
	rtd_outl(VDTOP_BLUE_SCREEN_Y_VADDR,vdtop_blue_screen_y_reg.regValue);

	trace("blue_screen_y\n");
	
	for(j = 0; j< 100; j++)
		udelay(1000000);

	//restore the value
	rtd_outl(VDTOP_BLUE_SCREEN_Y_VADDR,tmp1);
	
	vdtop_blue_screen_cb_reg.regValue = rtd_inl(VDTOP_BLUE_SCREEN_CB_VADDR);
	vdtop_blue_screen_cb_reg.blue_screen_cb = 0x30;
	rtd_outl(VDTOP_BLUE_SCREEN_CB_VADDR,vdtop_blue_screen_cb_reg.regValue);

	trace("blue_screen_cb\n");

	for(j = 0; j< 100; j++)
		udelay(1000000);	

	//restore the value
	rtd_outl(VDTOP_BLUE_SCREEN_CB_VADDR,tmp2);


	vdtop_blue_screen_cr_reg.regValue = rtd_inl(VDTOP_BLUE_SCREEN_CR_VADDR);
	vdtop_blue_screen_cr_reg.blue_screen_cr = 0x20;
	rtd_outl(VDTOP_BLUE_SCREEN_CR_VADDR,vdtop_blue_screen_cr_reg.regValue);

	trace("blue_screen_cr\n");

	for(j = 0; j< 100; j++)
		udelay(1000000);


	//restore the value
	rtd_outl(VDTOP_BLUE_SCREEN_CR_VADDR,tmp3);
	rtd_outl(VDTOP_OUTPUT_CONTROL_VADDR,tmp);

	ret = vsuccess;
	
	return ret;
}

int vdc_test_case_5_1(void)
{
	unsigned int ret,tmp,i;

	vdtop_mode_detection_status_RBUS vdtop_mode_detection_status_reg;
	vdtop_automode_443358pk_ctrl_RBUS vdtop_automode_443358pk_ctrl_reg;

	trace("%s()\n",__FUNCTION__);

	tmp = rtd_inl(VDTOP_AUTOMODE_443358PK_CTRL_VADDR);

	
	vdtop_automode_443358pk_ctrl_reg.regValue = rtd_inl(VDTOP_AUTOMODE_443358PK_CTRL_VADDR);
	vdtop_automode_443358pk_ctrl_reg.mode_443358pk_sel = 0x0;
	vdtop_automode_443358pk_ctrl_reg.mode_secam2_sel = 0x0;
	vdtop_automode_443358pk_ctrl_reg.pk_foraudio = 0x0;
	rtd_outl(VDTOP_AUTOMODE_443358PK_CTRL_VADDR,vdtop_automode_443358pk_ctrl_reg.regValue);

	for(i=0;i<5;i++)
		udelay(1000000);

	vdtop_mode_detection_status_reg.regValue = rtd_inl(VDTOP_MODE_DETECTION_STATUS_VADDR);
	trace("addr:0x%x,value:0x%x\n",VDTOP_AUTOMODE_443358PK_CTRL_VADDR,rtd_inl(VDTOP_AUTOMODE_443358PK_CTRL_VADDR));
	trace("\t\t94A4[4:6]:\t\t94A4[2:0]:\n");
	trace("value:\t\t0x%x\t\t\t0x%x\n",vdtop_mode_detection_status_reg.set_mode_status,vdtop_mode_detection_status_reg.decision_mode_status);

	for(i=0;i<5;i++)
		udelay(1000000);
	
	//restore the setting
	rtd_outl(VDTOP_AUTOMODE_443358PK_CTRL_VADDR,tmp);
	
	ret = vsuccess;
	
	return ret;
}

int vdc_test_case_5_2(void)
{
	unsigned int ret,tmp,i;

	vdtop_mode_detection_status_RBUS vdtop_mode_detection_status_reg;
	vdtop_automode_443358pk_ctrl_RBUS vdtop_automode_443358pk_ctrl_reg;

	trace("%s()\n",__FUNCTION__);

	tmp = rtd_inl(VDTOP_AUTOMODE_443358PK_CTRL_VADDR);

	
	vdtop_automode_443358pk_ctrl_reg.regValue = rtd_inl(VDTOP_AUTOMODE_443358PK_CTRL_VADDR);
	vdtop_automode_443358pk_ctrl_reg.mode_443358pk_sel = 0x1;
	vdtop_automode_443358pk_ctrl_reg.mode_secam2_sel = 0x1;
	vdtop_automode_443358pk_ctrl_reg.pk_foraudio = 0x0;
	rtd_outl(VDTOP_AUTOMODE_443358PK_CTRL_VADDR,vdtop_automode_443358pk_ctrl_reg.regValue);

	for(i=0;i<5;i++)
		udelay(1000000);
	
	vdtop_mode_detection_status_reg.regValue = rtd_inl(VDTOP_MODE_DETECTION_STATUS_VADDR);
	trace("addr:0x%x,value:0x%x\n",VDTOP_AUTOMODE_443358PK_CTRL_VADDR,rtd_inl(VDTOP_AUTOMODE_443358PK_CTRL_VADDR));
	trace("\t\t94A4[4:6]:\t\t94A4[2:0]:\n");
	trace("value:\t\t0x%x\t\t\t0x%x\n",vdtop_mode_detection_status_reg.set_mode_status,vdtop_mode_detection_status_reg.decision_mode_status);



	for(i=0;i<5;i++)
		udelay(1000000);

	//restore the setting
	rtd_outl(VDTOP_AUTOMODE_443358PK_CTRL_VADDR,tmp);
	
	ret = vsuccess;
	
	return ret;
}

int vdc_test_case_5_3_auto_pos_ctrl(void)
{
	unsigned int ret,i,tmp1;
	vdtop_auto_pos_ctrl_RBUS vdtop_auto_pos_ctrl_reg,tmp;

	trace("%s()\n",__FUNCTION__);

	tmp.regValue = rtd_inl(VDTOP_AUTO_POS_CTRL_VADDR);
	
	vdtop_auto_pos_ctrl_reg.regValue = rtd_inl(VDTOP_AUTO_POS_CTRL_VADDR);
	vdtop_auto_pos_ctrl_reg.new_y1delay_en = 0x1;
	vdtop_auto_pos_ctrl_reg.new_cb1delay_en = 0x1;
	vdtop_auto_pos_ctrl_reg.new_cr1delay_en = 0x1;
	vdtop_auto_pos_ctrl_reg.y1delayreg_en = 0x1;
	vdtop_auto_pos_ctrl_reg.cb1delayreg_en = 0x1;
	vdtop_auto_pos_ctrl_reg.cr1delayreg_en = 0x1;
	rtd_outl(VDTOP_AUTO_POS_CTRL_VADDR,vdtop_auto_pos_ctrl_reg.regValue);

	udelay(1000000);

	for(i=0;i<64;i++)
	{
		vdtop_auto_pos_ctrl_reg.regValue = rtd_inl(VDTOP_AUTO_POS_CTRL_VADDR);
		vdtop_auto_pos_ctrl_reg.y1delay = i;
		rtd_outl(VDTOP_AUTO_POS_CTRL_VADDR,vdtop_auto_pos_ctrl_reg.regValue);
		udelay(1000000);
	}

	//restore the y1delay
	vdtop_auto_pos_ctrl_reg.regValue = rtd_inl(VDTOP_AUTO_POS_CTRL_VADDR);
	vdtop_auto_pos_ctrl_reg.y1delay = tmp.y1delay;
	rtd_outl(VDTOP_AUTO_POS_CTRL_VADDR,vdtop_auto_pos_ctrl_reg.regValue);	

	udelay(1000000);

	for(i=0;i<64;i++)
	{
		vdtop_auto_pos_ctrl_reg.regValue = rtd_inl(VDTOP_AUTO_POS_CTRL_VADDR);
		vdtop_auto_pos_ctrl_reg.cb1delay = i;
		rtd_outl(VDTOP_AUTO_POS_CTRL_VADDR,vdtop_auto_pos_ctrl_reg.regValue);
		udelay(1000000);
	}

	//restore the cb1delay
	vdtop_auto_pos_ctrl_reg.regValue = rtd_inl(VDTOP_AUTO_POS_CTRL_VADDR);
	vdtop_auto_pos_ctrl_reg.cb1delay = tmp.cb1delay;
	rtd_outl(VDTOP_AUTO_POS_CTRL_VADDR,vdtop_auto_pos_ctrl_reg.regValue);

	udelay(1000000);

	for(i=0;i<64;i++)
	{
		vdtop_auto_pos_ctrl_reg.regValue = rtd_inl(VDTOP_AUTO_POS_CTRL_VADDR);
		vdtop_auto_pos_ctrl_reg.cr1delay = i;
		rtd_outl(VDTOP_AUTO_POS_CTRL_VADDR,vdtop_auto_pos_ctrl_reg.regValue);
		udelay(1000000);
	}

	//restore the value
	rtd_outl(VDTOP_AUTO_POS_CTRL_VADDR,tmp.regValue);

	ret = vsuccess;
	
	return ret;
}

int vdc_test_case_5_3_auto_pos_ctrl2(void)
{
	unsigned int ret,tmp,tmp1;
	vdtop_auto_pos_ctrl_2_RBUS vdtop_auto_pos_ctrl_2_reg;
	vdtop_chroma_kill_RBUS vdtop_chroma_kill_reg;

	trace("%s()\n",__FUNCTION__);
	
	tmp = rtd_inl(VDTOP_CHROMA_KILL_VADDR);
	tmp1 = rtd_inl(VDTOP_AUTO_POS_CTRL_2_VADDR);

	vdtop_auto_pos_ctrl_2_reg.regValue = rtd_inl(VDTOP_AUTO_POS_CTRL_2_VADDR);
	vdtop_chroma_kill_reg.regValue = rtd_inl(VDTOP_CHROMA_KILL_VADDR);

	vdtop_auto_pos_ctrl_2_reg.ckill_y1delayreg_en = 0x1;
	vdtop_auto_pos_ctrl_2_reg.ckill_cb1delayreg_en = 0x1;
	vdtop_auto_pos_ctrl_2_reg.ckill_cr1delayreg_en = 0x1;
	
	vdtop_chroma_kill_reg.user_ckill_mode = 0x1;

	rtd_outl(VDTOP_AUTO_POS_CTRL_2_VADDR,vdtop_auto_pos_ctrl_2_reg.regValue);
	rtd_outl(VDTOP_CHROMA_KILL_VADDR,vdtop_chroma_kill_reg.regValue);

	dbug("addr:0x%x,value:0x%x",VDTOP_AUTO_POS_CTRL_2_VADDR,rtd_inl(VDTOP_AUTO_POS_CTRL_2_VADDR));
	dbug("addr:0x%x,value:0x%x",VDTOP_CHROMA_KILL_VADDR,rtd_inl(VDTOP_CHROMA_KILL_VADDR));

	//restore the value
	rtd_outl(VDTOP_AUTO_POS_CTRL_2_VADDR,vdtop_auto_pos_ctrl_2_reg.regValue);
	rtd_outl(VDTOP_CHROMA_KILL_VADDR,vdtop_chroma_kill_reg.regValue);


	ret = vsuccess;
	
	return ret;
}

#if 0
int vdc_test_case_mac3_12_1(void)
{
	unsigned int ret;

	trace("%s()\n",__FUNCTION__);
	
	vdtop_chroma_reduce_cntl1_RBUS vdtop_chroma_reduce_cntl1_reg;
	vdtop_chroma_reduce_cntl2_RBUS vdtop_chroma_reduce_cntl2_reg;
	
	vdtop_chroma_reduce_cntl1_reg.regValue = rtd_inl(VDTOP_CHROMA_REDUCE_CNTL1_VADDR);
	vdtop_chroma_reduce_cntl2_reg.regValue = rtd_inl(VDTOP_CHROMA_REDUCE_CNTL2_VADDR);

	trace("SV reduce...\n");
	

	ret = vsuccess;
	
	return ret;
}
#endif


int vdc_test_case_mac3_12_2(void)
{
	unsigned int ret,tmp;
	vdtop_adc_over_under_flag_RBUS vdtop_adc_over_under_flag_reg;
	
	tmp = rtd_inl(VDTOP_ADC_OVER_UNDER_FLAG_VADDR);

	vdtop_adc_over_under_flag_reg.regValue = rtd_inl(VDTOP_ADC_OVER_UNDER_FLAG_VADDR);
	vdtop_adc_over_under_flag_reg.adc_value_max_thr = 0x0;
	rtd_outl(VDTOP_ADC_OVER_UNDER_FLAG_VADDR,vdtop_adc_over_under_flag_reg.regValue);

	udelay(1000000);

	//clear
	rtd_outl(VDTOP_ADC_OVER_UNDER_FLAG_VADDR,(rtd_inl(VDTOP_ADC_OVER_UNDER_FLAG_VADDR)|0xff));

	udelay(1000000);

	vdtop_adc_over_under_flag_reg.regValue = rtd_inl(VDTOP_ADC_OVER_UNDER_FLAG_VADDR);
	trace("95bc[0]\t95bc[2]\t95bc[4]\t95bc[6]\t\n");
	trace("0x%x\t0x%x\t0x%x\t0x%x\n",vdtop_adc_over_under_flag_reg.ad4_value_big,vdtop_adc_over_under_flag_reg.ad3_value_big,vdtop_adc_over_under_flag_reg.ad2_value_big,vdtop_adc_over_under_flag_reg.ad1_value_big);


	udelay(1000000);

	vdtop_adc_over_under_flag_reg.regValue = rtd_inl(VDTOP_ADC_OVER_UNDER_FLAG_VADDR);
	vdtop_adc_over_under_flag_reg.adc_value_max_thr = 0x3ff;
	rtd_outl(VDTOP_ADC_OVER_UNDER_FLAG_VADDR,vdtop_adc_over_under_flag_reg.regValue);

	udelay(1000000);

	//clear
	rtd_outl(VDTOP_ADC_OVER_UNDER_FLAG_VADDR,(rtd_inl(VDTOP_ADC_OVER_UNDER_FLAG_VADDR)|0xff));

	udelay(1000000);


	vdtop_adc_over_under_flag_reg.regValue = rtd_inl(VDTOP_ADC_OVER_UNDER_FLAG_VADDR);
	trace("95bc[0]\t95bc[2]\t95bc[4]\t95bc[6]\n");
	trace("0x%x\t0x%x\t0x%x\t0x%x\n",vdtop_adc_over_under_flag_reg.ad4_value_big,vdtop_adc_over_under_flag_reg.ad3_value_big,vdtop_adc_over_under_flag_reg.ad2_value_big,vdtop_adc_over_under_flag_reg.ad1_value_big);


	udelay(1000000);

	vdtop_adc_over_under_flag_reg.regValue = rtd_inl(VDTOP_ADC_OVER_UNDER_FLAG_VADDR);
	vdtop_adc_over_under_flag_reg.adc_value_min_thr = 0x3ff;
	rtd_outl(VDTOP_ADC_OVER_UNDER_FLAG_VADDR,vdtop_adc_over_under_flag_reg.regValue);

	udelay(1000000);

	//clear
	rtd_outl(VDTOP_ADC_OVER_UNDER_FLAG_VADDR,(rtd_inl(VDTOP_ADC_OVER_UNDER_FLAG_VADDR)|0xff));

	udelay(1000000);


	vdtop_adc_over_under_flag_reg.regValue = rtd_inl(VDTOP_ADC_OVER_UNDER_FLAG_VADDR);
	trace("95bc[1]\t95bc[3]\t95bc[5]\t95bc[7]\t\n");
	trace("0x%x\t0x%x\t0x%x\t0x%x\n",vdtop_adc_over_under_flag_reg.ad4_value_small,vdtop_adc_over_under_flag_reg.ad3_value_small,vdtop_adc_over_under_flag_reg.ad2_value_small,vdtop_adc_over_under_flag_reg.ad1_value_small);

	udelay(1000000);

	vdtop_adc_over_under_flag_reg.regValue = rtd_inl(VDTOP_ADC_OVER_UNDER_FLAG_VADDR);
	vdtop_adc_over_under_flag_reg.adc_value_min_thr = 0x00;
	rtd_outl(VDTOP_ADC_OVER_UNDER_FLAG_VADDR,vdtop_adc_over_under_flag_reg.regValue);

	//clear
	rtd_outl(VDTOP_ADC_OVER_UNDER_FLAG_VADDR,(rtd_inl(VDTOP_ADC_OVER_UNDER_FLAG_VADDR)|0xff));

	udelay(1000000);


	vdtop_adc_over_under_flag_reg.regValue = rtd_inl(VDTOP_ADC_OVER_UNDER_FLAG_VADDR);
	trace("95bc[1]\t95bc[3]\t95bc[5]\t95bc[7]\t\n");
	trace("0x%x\t0x%x\t0x%x\t0x%x\n",vdtop_adc_over_under_flag_reg.ad4_value_small,vdtop_adc_over_under_flag_reg.ad3_value_small,vdtop_adc_over_under_flag_reg.ad2_value_small,vdtop_adc_over_under_flag_reg.ad1_value_small);

	//restore the value	
	rtd_outl(VDTOP_ADC_OVER_UNDER_FLAG_VADDR,tmp);


	ret = vsuccess;
	
	return ret;
}

int vdc_test_case_mac3_12_3(void)
{
	unsigned int ret,tmp;
	vdtop_dgain_out_over_under_flag_RBUS vdtop_dgain_out_over_under_flag_reg;
	vdtop_dgain_out_over_under_cntl_RBUS vdtop_dgain_out_over_under_cntl_reg;

	vdtop_dgain_out_over_under_cntl_reg.regValue = rtd_inl(VDTOP_DGAIN_OUT_OVER_UNDER_CNTL_VADDR);
	//vdtop_dgain_out_over_under_flag_reg.regValue = rtd_inl(VDTOP_DGAIN_OUT_OVER_UNDER_FLAG_VADDR);


	vdtop_dgain_out_over_under_cntl_reg.regValue = rtd_inl(VDTOP_DGAIN_OUT_OVER_UNDER_CNTL_VADDR);
	vdtop_dgain_out_over_under_cntl_reg.dgain_out_data_min_thr = 0xfff;
	rtd_outl(VDTOP_DGAIN_OUT_OVER_UNDER_CNTL_VADDR,vdtop_dgain_out_over_under_cntl_reg.regValue);
	
	//clear status reg.
	rtd_outl(VDTOP_DGAIN_OUT_OVER_UNDER_FLAG_VADDR,0x3ff);

	trace("95c0[9]:0x%x\n",((rtd_inl(VDTOP_DGAIN_OUT_OVER_UNDER_FLAG_VADDR)>>9)&0x1));

	vdtop_dgain_out_over_under_cntl_reg.regValue = rtd_inl(VDTOP_DGAIN_OUT_OVER_UNDER_CNTL_VADDR);
	vdtop_dgain_out_over_under_cntl_reg.dgain_out_data_min_thr = 0x0;
	rtd_outl(VDTOP_DGAIN_OUT_OVER_UNDER_CNTL_VADDR,vdtop_dgain_out_over_under_cntl_reg.regValue);
	
	//clear status reg.
	rtd_outl(VDTOP_DGAIN_OUT_OVER_UNDER_FLAG_VADDR,0x3ff);

	trace("95c0[9]:0x%x\n",((rtd_inl(VDTOP_DGAIN_OUT_OVER_UNDER_FLAG_VADDR)>>9)&0x1));


	vdtop_dgain_out_over_under_cntl_reg.regValue = rtd_inl(VDTOP_DGAIN_OUT_OVER_UNDER_CNTL_VADDR);
	vdtop_dgain_out_over_under_cntl_reg.dgain_out_data_max_thr = 0x0;
	rtd_outl(VDTOP_DGAIN_OUT_OVER_UNDER_CNTL_VADDR,vdtop_dgain_out_over_under_cntl_reg.regValue);
	
	//clear status reg.
	rtd_outl(VDTOP_DGAIN_OUT_OVER_UNDER_FLAG_VADDR,0x3ff);

	trace("95c0[0]:\t95c0[2]:\t95c0[4]:\t95c0[6]:\t95c0[8]:\n");
	trace("0x%x\t0x%x\t0x%x\t0x%x\t0x%x\n",((rtd_inl(VDTOP_DGAIN_OUT_OVER_UNDER_FLAG_VADDR)>>0)&0x1),((rtd_inl(VDTOP_DGAIN_OUT_OVER_UNDER_FLAG_VADDR)>>2)&0x1),((rtd_inl(VDTOP_DGAIN_OUT_OVER_UNDER_FLAG_VADDR)>>4)&0x1),((rtd_inl(VDTOP_DGAIN_OUT_OVER_UNDER_FLAG_VADDR)>>6)&0x1),((rtd_inl(VDTOP_DGAIN_OUT_OVER_UNDER_FLAG_VADDR)>>8)&0x1));


	vdtop_dgain_out_over_under_cntl_reg.regValue = rtd_inl(VDTOP_DGAIN_OUT_OVER_UNDER_CNTL_VADDR);
	vdtop_dgain_out_over_under_cntl_reg.dgain_out_data_max_thr = 0xfff;
	rtd_outl(VDTOP_DGAIN_OUT_OVER_UNDER_CNTL_VADDR,vdtop_dgain_out_over_under_cntl_reg.regValue);
	
	//clear status reg.
	rtd_outl(VDTOP_DGAIN_OUT_OVER_UNDER_FLAG_VADDR,0x3ff);

	trace("95c0[0]:\t95c0[2]:\t95c0[4]:\t95c0[6]:\t95c0[8]:\n");
	trace("0x%x\t0x%x\t0x%x\t0x%x\t0x%x\n",((rtd_inl(VDTOP_DGAIN_OUT_OVER_UNDER_FLAG_VADDR)>>0)&0x1),((rtd_inl(VDTOP_DGAIN_OUT_OVER_UNDER_FLAG_VADDR)>>2)&0x1),((rtd_inl(VDTOP_DGAIN_OUT_OVER_UNDER_FLAG_VADDR)>>4)&0x1),((rtd_inl(VDTOP_DGAIN_OUT_OVER_UNDER_FLAG_VADDR)>>6)&0x1),((rtd_inl(VDTOP_DGAIN_OUT_OVER_UNDER_FLAG_VADDR)>>8)&0x1));



	ret = vsuccess;
	
	return ret;
}



int vdc_test_case_mac3_12_4(void)
{
	unsigned int ret;
	vdtop_agc_gate_th_swap_RBUS vdtop_agc_gate_th_swap_reg;

	vdtop_agc_gate_th_swap_reg.regValue = rtd_inl(VDTOP_AGC_GATE_TH_SWAP_VADDR);
	vdtop_agc_gate_th_swap_reg.cvbs_clamp_length_limit_en = 0x1;
	rtd_outl(VDTOP_AGC_GATE_TH_SWAP_VADDR,vdtop_agc_gate_th_swap_reg.regValue);

	trace("Please plug out the source and plug it again\n");

	ret = vsuccess;
	
	return ret;
}


int vdc_test_case_mac3_12_5(void)
{
	unsigned int ret,i;
	vdtop_clampagc_compluma_new_threshold1_RBUS vdtop_clampagc_compluma_new_threshold1_reg;
	
	trace("%s()\n",__FUNCTION__);	

	vdtop_clampagc_compluma_new_threshold1_reg.regValue = rtd_inl(VDTOP_CLAMPAGC_COMPLUMA_NEW_THRESHOLD1_VADDR);

	if(vdtop_clampagc_compluma_new_threshold1_reg.ypeak_wide_iir_en)
	{
		trace("the bit has already set\n");
	}
	else
	{
		vdtop_clampagc_compluma_new_threshold1_reg.ypeak_wide_iir_en = 0x1;
		rtd_outl(VDTOP_CLAMPAGC_COMPLUMA_NEW_THRESHOLD1_VADDR,vdtop_clampagc_compluma_new_threshold1_reg.regValue);
		trace("addr:0x%x,value:0x%x\n",VDTOP_CLAMPAGC_COMPLUMA_NEW_THRESHOLD1_VADDR,((rtd_inl(VDTOP_CLAMPAGC_COMPLUMA_NEW_THRESHOLD1_VADDR)>>13)&0x1));
		trace("the bit has already set\n");
	}

	

	ret = vsuccess;
	
	return ret;
}


int vdc_test_case_mac3_12_6(void)
{
	unsigned int ret,i,j,value_array[10];
	vdtop_sync_midpt_v2_RBUS vdtop_sync_midpt_v2_reg;

	trace("%s()\n",__FUNCTION__);

	ret = vsuccess;

	for(i = 0;i < 10;i++)
	{
		vdtop_sync_midpt_v2_reg.regValue = rtd_inl(VDTOP_SYNC_MIDPT_V2_VADDR);
		trace("0x%x\n",vdtop_sync_midpt_v2_reg.new_vdetect_feature_max_core);
		udelay(100000);
	}
	
	return ret;
}

int vdc_test_case_mac3_12_7(void)
{
	#define cmd_buffer_size 32

	unsigned int ret,i;
	UINT8 cmd_buffer[cmd_buffer_size];
	UINT8 key[] = "c";
	INT32 argc;
	vdtop_hdetect_vphase_status_RBUS vdtop_hdetect_vphase_status_reg;

	
	argc = 0x0;

	vdtop_hdetect_vphase_status_reg.regValue = rtd_inl(VDTOP_HDETECT_VPHASE_STATUS_VADDR);

	if(0x0 == vdtop_hdetect_vphase_status_reg.vphase_status)
	{
		trace("vphase_status:0x%x\n",(rtd_inl(VDTOP_HDETECT_VPHASE_STATUS_VADDR)&0xff));
		trace("please unplug the source and push c key\n");
		
		memset(cmd_buffer, 0, cmd_buffer_size);
		GetLine(cmd_buffer,cmd_buffer_size,0x1);
		trace("\n");
		
		if(strcmp(key,cmd_buffer)==0x0)
		{
			for(i=0;i<20;i++)
			{
				trace("0x%x\n",(rtd_inl(VDTOP_HDETECT_VPHASE_STATUS_VADDR)&0xff));
				udelay(10000);
			}
		}
	}
	else
	{
		trace("fail. vphase_status != 0\n");
	}
	

	ret = vsuccess;

	
	
	return ret;
}



int vdc_test_case_mac3_12_8(void)
{
	unsigned int ret;
	vdtop_new_vdetect_ctrl_RBUS vdtop_new_vdetect_ctrl_reg;

	vdtop_new_vdetect_ctrl_reg.regValue = rtd_inl(VDTOP_NEW_VDETECT_CTRL_VADDR);
	if(vdtop_new_vdetect_ctrl_reg.new_vdetect_maxmin_data_rc_en)
	{
		trace("addr:0x%x,value:0x%x\n",VDTOP_NEW_VDETECT_CTRL_VADDR,vdtop_new_vdetect_ctrl_reg.new_vdetect_maxmin_data_rc_en);
		trace("pass\n");
	}
	else
	{
		trace("fail\n");
	}

	ret = vsuccess;
	
	return ret;
}

int vdc_test_case_mac3_12_9(void)
{
	unsigned int ret;
	vdtop_video_status_reg2_RBUS vdtop_video_status_reg2_reg;
	vdtop_video_status_reg2_reg.regValue = rtd_inl(VDTOP_VIDEO_STATUS_REG2_VADDR);

	trace("old v : 0x%x\n",((rtd_inl(VDTOP_VIDEO_STATUS_REG2_VADDR)>>10)&0x1));
	
	if(vdtop_video_status_reg2_reg.old_vdetect_stable)
	{
		trace("old v stable\n");
		ret = vsuccess;
	}
	else
	{
		trace("old v nonstable\n");
	}
		ret = vfail;
	return ret;
}


int vdc_test_case_mac3_12_14(void)
{
	unsigned int ret;
	vdtop_cstate_status_RBUS vdtop_cstate_status_reg;

	ret = vsuccess;

	udelay(1000000);
	
	vdtop_cstate_status_reg.regValue = rtd_inl(VDTOP_CSTATE_STATUS_VADDR);
	vdtop_cstate_status_reg.cpll_use_fine_or_final_hlock = 0x0;
	rtd_outl(VDTOP_CSTATE_STATUS_VADDR,vdtop_cstate_status_reg.regValue);
	
	udelay(1000000);	

	vdtop_cstate_status_reg.regValue = rtd_inl(VDTOP_CSTATE_STATUS_VADDR);
	vdtop_cstate_status_reg.cpll_use_fine_or_final_hlock = 0x1;
	rtd_outl(VDTOP_CSTATE_STATUS_VADDR,vdtop_cstate_status_reg.regValue);


	udelay(1000000);	

	vdtop_cstate_status_reg.regValue = rtd_inl(VDTOP_CSTATE_STATUS_VADDR);
	vdtop_cstate_status_reg.cpll_use_fine_or_final_hlock = 0x0;
	rtd_outl(VDTOP_CSTATE_STATUS_VADDR,vdtop_cstate_status_reg.regValue);


	return ret;
}


int vdc_test_case_megellan2_13_1(void)
{
	unsigned int ret,i;
	vdtop_chroma_loopfilter_state_RBUS vdtop_chroma_loopfilter_state_reg;
	

	trace("%s()\n",__FUNCTION__);

	ret = vsuccess;

	trace("temporarily disable the func...\n");
	//reduce the NG in t
	vdtop_chroma_loopfilter_state_reg.regValue = rtd_inl(VDTOP_CHROMA_LOOPFILTER_STATE_VADDR);
	vdtop_chroma_loopfilter_state_reg.cresample_signed_en = 0x0;
	rtd_outl(VDTOP_CHROMA_LOOPFILTER_STATE_VADDR,vdtop_chroma_loopfilter_state_reg.regValue);

	trace("Please use the tg35 and reduce the hsync level to 10%\n");
	for(i = 0; i<10;i++)
		udelay(1000000);


	//reduce the NG in t
	trace("Enable the func...\n");
	vdtop_chroma_loopfilter_state_reg.regValue = rtd_inl(VDTOP_CHROMA_LOOPFILTER_STATE_VADDR);
	vdtop_chroma_loopfilter_state_reg.cresample_signed_en = 0x1;
	rtd_outl(VDTOP_CHROMA_LOOPFILTER_STATE_VADDR,vdtop_chroma_loopfilter_state_reg.regValue);
	trace("test finish...\n");

	return ret;
}


int vdc_test_case_megellan2_13_2(void)
{
	unsigned int ret,i;
	vdtop_agc_dgain_status_RBUS vdtop_agc_dgain_status_reg;
	vdtop_agc_gate_width_RBUS vdtop_agc_gate_width_reg,tmp_reg;

	trace("%s()\n",__FUNCTION__);

	ret = vsuccess;

	trace("Please use the tg35 and reduce the hsync level to 10%");
	for(i = 0; i<10;i++)
		udelay(1000000);

	vdtop_agc_dgain_status_reg.regValue = rtd_inl(VDTOP_AGC_DGAIN_STATUS_VADDR);
	trace("dgain status: 0x%x\n",vdtop_agc_dgain_status_reg.agc_dgain);

	tmp_reg.regValue = rtd_inl(VDTOP_AGC_GATE_WIDTH_VADDR); //backup the setting

	vdtop_agc_gate_width_reg.regValue = rtd_inl(VDTOP_AGC_GATE_WIDTH_VADDR);
	vdtop_agc_gate_width_reg.data_path_dgain_limit_up = 0x900;
	rtd_outl(VDTOP_AGC_GATE_WIDTH_VADDR,vdtop_agc_gate_width_reg.regValue);

	vdtop_agc_dgain_status_reg.regValue = rtd_inl(VDTOP_AGC_DGAIN_STATUS_VADDR);
	trace("dgain status: 0x%x\n",vdtop_agc_dgain_status_reg.agc_dgain);

	//restore the setting
	rtd_outl(VDTOP_AGC_GATE_WIDTH_VADDR,tmp_reg.regValue);

	trace("Please use the tg35 and increase the hsync level to 200%");

	for(i = 0; i<10;i++)
		udelay(1000000);

	vdtop_agc_dgain_status_reg.regValue = rtd_inl(VDTOP_AGC_DGAIN_STATUS_VADDR);
	trace("dgain status: 0x%x\n",vdtop_agc_dgain_status_reg.agc_dgain);

	vdtop_agc_gate_width_reg.regValue = rtd_inl(VDTOP_AGC_GATE_WIDTH_VADDR);
	vdtop_agc_gate_width_reg.data_path_dgain_limit_low = 0x300;
	rtd_outl(VDTOP_AGC_GATE_WIDTH_VADDR,vdtop_agc_gate_width_reg.regValue);

	vdtop_agc_dgain_status_reg.regValue = rtd_inl(VDTOP_AGC_DGAIN_STATUS_VADDR);
	trace("dgain status: 0x%x\n",vdtop_agc_dgain_status_reg.agc_dgain);

	return ret;
}

int vdc_test_case_megellan2_13_3(void)
{
	unsigned int ret,i;
	vdtop_ycbcr_moniter_ctrl_RBUS vdtop_ycbcr_moniter_ctrl_reg;
	vdtop_adc_updn_ctrl_RBUS vdtop_adc_updn_ctrl_reg;
	vdtop_ycbcr_moniter_value_y_RBUS vdtop_ycbcr_moniter_value_y_reg;
	vdtop_ycbcr_moniter_value_cbcr_RBUS vdtop_ycbcr_moniter_value_cbcr_reg;

	trace("%s()\n",__FUNCTION__);

	ret = vsuccess;

	//enable the monitor
	vdtop_ycbcr_moniter_ctrl_reg.regValue = rtd_inl(VDTOP_YCBCR_MONITER_CTRL_VADDR);
	vdtop_ycbcr_moniter_ctrl_reg.ycbcr_moniter_en = 0x1;
	rtd_outl(VDTOP_YCBCR_MONITER_CTRL_VADDR,vdtop_ycbcr_moniter_ctrl_reg.regValue);

	//scale up the measurement block 
	vdtop_ycbcr_moniter_ctrl_reg.regValue = rtd_inl(VDTOP_YCBCR_MONITER_CTRL_VADDR);

	trace("scale up the block\n");

	for(i = 0; i < 16; i++)
	{
		vdtop_ycbcr_moniter_ctrl_reg.moniter_size = i;
		rtd_outl(VDTOP_YCBCR_MONITER_CTRL_VADDR,vdtop_ycbcr_moniter_ctrl_reg.regValue);	
		udelay(1000000);
	}

	//tune the color
	vdtop_adc_updn_ctrl_reg.regValue = rtd_inl(VDTOP_ADC_UPDN_CTRL_VADDR);

	trace("set the y\n");

	for(i = 0; i < 256; i++)
	{
		vdtop_adc_updn_ctrl_reg.moniter_y_value = i;
		rtd_outl(VDTOP_ADC_UPDN_CTRL_VADDR,vdtop_adc_updn_ctrl_reg.regValue);
		udelay(1000000);
	}

	trace("set the cb\n");

	vdtop_adc_updn_ctrl_reg.regValue = rtd_inl(VDTOP_ADC_UPDN_CTRL_VADDR);

	for(i = 0; i < 256; i++)
	{
		vdtop_adc_updn_ctrl_reg.moniter_cb_value = i;
		rtd_outl(VDTOP_ADC_UPDN_CTRL_VADDR,vdtop_adc_updn_ctrl_reg.regValue);
		udelay(1000000);
	}	

	trace("set the cr\n");

	vdtop_adc_updn_ctrl_reg.regValue = rtd_inl(VDTOP_ADC_UPDN_CTRL_VADDR);

	for(i = 0; i < 256; i++)
	{
		vdtop_adc_updn_ctrl_reg.moniter_cr_value = i;
		rtd_outl(VDTOP_ADC_UPDN_CTRL_VADDR,vdtop_adc_updn_ctrl_reg.regValue);
		udelay(1000000);
	}	

	vdtop_ycbcr_moniter_value_y_reg.regValue = rtd_inl(VDTOP_YCBCR_MONITER_VALUE_Y_VADDR);
	trace("y:0x%x\n",vdtop_ycbcr_moniter_value_y_reg.vd_yout_moniter);
	
	vdtop_ycbcr_moniter_value_cbcr_reg.regValue = rtd_inl(VDTOP_YCBCR_MONITER_VALUE_CBCR_VADDR);
	trace("cb:0x%x\n",vdtop_ycbcr_moniter_value_cbcr_reg.vd_cbout_moniter);
	trace("cb:0x%x\n",vdtop_ycbcr_moniter_value_cbcr_reg.vd_crout_moniter);

	return ret;
}


int vdc_restore2default(void)
{
	unsigned int ret;

	#include "adc_backup.tbl"
	#include "ifd_backup.tbl"
	#include "vdc_backup.tbl"

	drvif_module_vdc_SoftReset();

	ret = vsuccess;
	
	return ret;
}




void vdc_verify(void)
{
	#define	CONSOLE_MODE_QC_PROMPT	"EnterNumber :"
	#define	QCINFO_CMD_BUFFER_SIZE	128

	INT32	argc = 0;
  	INT8	**argv = NULL;
	int	total, fail, pass,i;
	int	tNum;
	char tResl[64];
	unsigned int	rst=0;
	unsigned int	totcnt = 0;
	UINT8	abyCommandBuffer[QCINFO_CMD_BUFFER_SIZE];
	UINT32	loops;
	UINT32	item;
	UINT32	tMs;
	UINT32	FailCnt = 0;
	UINT32  option;

	total = 0;
	fail   = 0;
	pass = 0;
	loops = 0;
	option = 0;

	printk(" == VDC CODE TEST LIST ==\n");//vdc_verify_run_list
	while(vdc_verify_run_list[total].entry_function != 0)
	{
		printk("  %d).%s\n",total,vdc_verify_run_list[total].entry_name);
		total++;
	}
	printk("  %d).ALL (not support now)\n",total);
	total++;
	//printk("  %d).ALL LOOPS [Shift+A to break loops]\n",total);
	printk("  %d).ALL LOOPS (not support now)\n",total);
	total++;
	printk("  %d).ESC\n",total);
	printk("\r\n");

	item = total -2;
	while(TRUE)
	{
		if(option==2)
		{
			tNum = (total-2);	//for once auto run
		}
		else
		{
			printk("%s", CONSOLE_MODE_QC_PROMPT);
			memset(abyCommandBuffer, 0, QCINFO_CMD_BUFFER_SIZE);
			GetLine(abyCommandBuffer, QCINFO_CMD_BUFFER_SIZE, 1);
	      	printk("\n");

			//Parse Argument Count by Input Data
  			argc = GetArgc((const INT8 *) abyCommandBuffer);
	      	//Parse Argument String by Input Data
  			argv = (INT8 **) GetArgv((const INT8 *) abyCommandBuffer);
	      	if(argc < 1)
	      	{
	      	  	continue;
	      	}

	      	//Convert Argument String to Upper Case
	      	StrUpr(argv[0]);
			tNum = strtoul((const INT8 *) (argv[0]), (INT8 **) NULL, 10);
		}

		if (tNum==total)
		{	//ESC
			break;
		}
		else if (tNum==(total-2))
		{
			for (i=0;i<(item);i++)
			{
				if(GETCHAR_ESC)
					break;

				if (vdc_verify_run_list[i].entry_function())
				{
					fail++;
					tResl[i] = 'F';
					FailCnt++;
				}
				else
				{
					pass++;
					tResl[i] = 'S';
				}
				printk("========== tot err count ======================>> %d \n",FailCnt);
			}

			//Fail IP
			printk("\r\n *** FAIL IP ***\n");
			for (i=0;i<(item);i++)
			{
				if (FailCnt==0)
				{
					printk("\r\n");
					printk("\n+++++++++++++++++\n");
					printk("+++ No Fail IP ++");
					printk("\n+++++++++++++++++\n");
					printk("\r\n");
					printk("\r\n");
					break;
				}

				if (tResl[i]=='F')
					printk("  %d).%s\n\n",i ,vdc_verify_run_list[i].entry_name);
			}

			#if CONFIG_QC_ONCE_ALL
				break;
			#endif
		}
		else if (tNum==(total-1))
		{	//ALL LOOPS
			//printk("ALL LOOPS =>%d\n",tNum);
			loops = 0;
			fail = 0;
			while(TRUE)
			{
				if (GETCHAR_ESC)
				break;

				for (i=0;i<(item);i++)
				{
					//local_uart1_disable();
					if (vdc_verify_run_list[i].entry_function())
					{
						//local_uart1_enable();
						fail++;
						tResl[i] = 'F';
					}
					else
					{
						//local_uart1_enable();
						pass++;
						tResl[i] = 'S';
					}
				}

				loops++;
				printk("\r\n =========== QC VERIFY LOOPS [%d] ============ \n",loops);
				//Succ IP
				printk("\r\n *** SUCCESS IP ***\n");
				for (i=0;i<(item);i++)
				{
					if (tResl[i]=='S')
						printk("  %d).%s\n",i, vdc_verify_run_list[i].entry_name);
				}

				//Fail IP
				printk("\r\n *** FAIL IP ***\n");
				for (i=0;i<(item);i++)
				{
					if (tResl[i]=='F')
						printk("  %d).%s\n",i ,vdc_verify_run_list[i].entry_name);
				}

				if (fail>0)
				break;
			}
		}
		else
		{
			printk("\r\n *** RESULT ***\n");

			if (vdc_verify_run_list[tNum].entry_function())
			{
				printk("  %d).%s IP test Fail\n\n", tNum,vdc_verify_run_list[tNum].entry_name);
			}
			else
			{
				printk("  %d).%s IP test Pass\n\n",tNum,vdc_verify_run_list[tNum].entry_name);
			}
		}
	}
}

