#ifndef _VDE_QC_BIN
#define _VDE_QC_BIN

struct hex_data
{
    unsigned int addr;
    unsigned int data;
};

#define VDE1_DIR0_HEXFILE_NAME "pattern_vde10.h"
#define VDE1_DIR1_HEXFILE_NAME "pattern_vde11.h"
#define VDE2_DIR0_HEXFILE_NAME "pattern_vde20.h"
#define VDE2_DIR1_HEXFILE_NAME "pattern_vde21.h"

#define CONFIG_QC_VDE1
//#define CONFIG_QC_VDE2

#include VDE1_DIR0_HEXFILE_NAME 
#include VDE1_DIR1_HEXFILE_NAME 
#include VDE2_DIR0_HEXFILE_NAME 
#include VDE2_DIR1_HEXFILE_NAME 

#define MIPS_V_ENTRY_CODE_ADDR			(0x00000200)

#define SB2_HD_SEM_reg      0xB801A000

// clock and reset
#define CRT_SYS_CLKEN0_reg  0xB8000110
#define CRT_SYS_CLKEN1_reg 0xB8000114
#define CRT_SYS_SRST0_reg  0xB8000100
#define CRT_SYS_SRST1_reg  0xB8000104

// Mips kseq base address
#define MIPS_KSEG0BASE		0x80000000
#define MIPS_KSEG1BASE		0xa0000000
#define MIPS_KSEG_MSK		0xe0000000



#define VCPU_JUMP_ADDR_reg		(0xb801a61c)
#define VCPU2_JUMP_ADDR_reg		(0xb801a618)

// test pass/fail flag
#define VDE1_TEST_FLAG_ADDR    0x00002104
#define VDE2_TEST_FLAG_ADDR    0x00002404

// vcpu-only test mode
#define VDE1_TEST_MODE_ADDR    0x00002120
#define VDE2_TEST_MODE_ADDR    0x00002420

// share addr scpu and vcpu
#define MIPS_VDE1_ENTRY_QC_CODE_ADDR_PTR (0x0000210c)
#define MIPS_VDE2_ENTRY_QC_CODE_ADDR_PTR (0x0000240c)


// v_entry_qc addr
#define MIPS_V_ENTRY_QC_CODE_ADDR             (0x00000200)


// VE1 cmd:run and stop
#define VDE1_CMD_ADDR   (0x00002100)
#define VDE1_CMD_START  (0x01000000)
#define VDE1_CMD_STOP   (0x00000000)

// VE2 cmd:run and stop
#define VDE2_CMD_ADDR   (0x00002400)
#define VDE2_CMD_START  (0x01000000)
#define VDE2_CMD_STOP   (0x00000000)

#ifndef SUCCESS
#define SUCCESS 				0
#endif

#ifndef FAILED
#define FAILED 					-1
#endif

#ifndef _ZERO
#define _ZERO   						0x00000000
#endif
#ifndef _BIT0
#define _BIT0   						0x00000001
#endif
#ifndef _BIT1
#define _BIT1   						0x00000002
#endif
#ifndef _BIT2
#define _BIT2   						0x00000004
#endif
#ifndef _BIT3
#define _BIT3   						0x00000008
#endif
#ifndef _BIT4
#define _BIT4   						0x00000010
#endif
#ifndef _BIT5
#define _BIT5   						0x00000020
#endif
#ifndef _BIT6
#define _BIT6   						0x00000040
#endif
#ifndef _BIT7
#define _BIT7   						0x00000080
#endif
#ifndef _BIT8
#define _BIT8   						0x00000100
#endif
#ifndef _BIT9
#define _BIT9   						0x00000200
#endif
#ifndef _BIT10
#define _BIT10  						0x00000400
#endif
#ifndef _BIT11
#define _BIT11  						0x00000800
#endif
#ifndef _BIT12
#define _BIT12  						0x00001000
#endif
#ifndef _BIT13
#define _BIT13  						0x00002000
#endif
#ifndef _BIT14
#define _BIT14  						0x00004000
#endif
#ifndef _BIT15
#define _BIT15  						0x00008000
#endif
#ifndef _BIT16
#define _BIT16   						0x00010000
#endif
#ifndef _BIT17
#define _BIT17  						0x00020000
#endif
#ifndef _BIT18
#define _BIT18   						0x00040000
#endif
#ifndef _BIT19
#define _BIT19   						0x00080000
#endif
#ifndef _BIT20
#define _BIT20   						0x00100000
#endif
#ifndef _BIT21
#define _BIT21   						0x00200000
#endif
#ifndef _BIT22
#define _BIT22   						0x00400000
#endif
#ifndef _BIT23
#define _BIT23   						0x00800000
#endif
#ifndef _BIT24
#define _BIT24   						0x01000000
#endif
#ifndef _BIT25
#define _BIT25   						0x02000000
#endif
#ifndef _BIT26
#define _BIT26  						0x04000000
#endif
#ifndef _BIT27
#define _BIT27  						0x08000000
#endif
#ifndef _BIT28
#define _BIT28  						0x10000000
#endif
#ifndef _BIT29
#define _BIT29  						0x20000000
#endif
#ifndef _BIT30
#define _BIT30  						0x40000000
#endif
#ifndef _BIT31
#define _BIT31  						0x80000000
#endif

#endif // _VDE_QC_BIN
