#include <sys/ioctl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <stdio.h>
#include <unistd.h>
#include <string.h>
#define install_debug printf
#define install_fail printf
typedef enum{
	TYPE_VE,
	TYPE_VDE,
	TYPE_VE_ENCODE,
	TYPE_MAX,
}TYPE_E;

static int hexfile2headerfile(const char *pfilename,const char *pheadname,const char *array_name)
{
        FILE *fp_r ,*fp_w;
        char filename_output[128] = {0}, newline[512] = {0}, write_string[128] = {0}, write_tmp[128] = {0};
        unsigned int num, addr ,data_0,data_4, data_8,data_c;
        unsigned int count = 0;
        snprintf(filename_output, sizeof(filename_output), pheadname);
        if ((fp_r = fopen(pfilename, "r")) ==NULL) {
                install_fail("cannot open file:%s\r\n",pfilename);
                return -1;
        }
        if ((fp_w = fopen(filename_output, "w")) == NULL) {
        	install_fail("cannot open file:%s\r\n", filename_output);
        	fclose(fp_r);
        	return -1;
        }
        printf("start\r\n");

        snprintf(write_string, sizeof(write_string), "%s", array_name);

        fwrite(write_string,1, strlen(write_string), fp_w);
        while(NULL!= fgets(newline, sizeof(newline),fp_r))
        {

                sscanf(newline,"%d %x %x %x%x %x", &num, &addr , &data_0, &data_4, &data_8, &data_c);
                count++;
                if (num ==1)
                {
                        snprintf(write_string, sizeof(write_string), "\t{0x%08x, 0x%08x},\r\n", addr , data_0);
                }
                else if (num ==4)
                {
                        snprintf(write_string, sizeof(write_string), "\t{0x%08x, 0x%08x},\r\n", addr+0x0, data_0);
                        snprintf(write_tmp, sizeof(write_tmp), "\t{0x%08x, 0x%08x},\r\n", addr+0x4, data_4);
                        strcat(write_string, write_tmp);
                        snprintf(write_tmp, sizeof(write_tmp), "\t{0x%08x, 0x%08x},\r\n", addr+0x8, data_8);
                        strcat(write_string, write_tmp);
                        snprintf(write_tmp, sizeof(write_tmp), "\t{0x%08x, 0x%08x},\r\n", addr+0xc,data_c);
                        strcat(write_string, write_tmp);
                }
                else
                {
                        printf("error num = %d\r\n", num);
                }
                fwrite(write_string, 1, strlen(write_string), fp_w);
        }
        snprintf(write_string, sizeof(write_string), "};");
        fwrite(write_string,1, strlen(write_string), fp_w);
        printf("total count =%d\r\n", count);
        printf("done\r\n");
        fclose(fp_r);
        fclose(fp_w);
        return 0;
}

int main(int argc, char* argv[])
{

        char filename[128] = {0};
        char headname[128] = {0};
        char array_name[64] = {0};
        char vcpu_id[2] = {0};
        char part_num[2] = {0};
        char type[16] =  {0};
        TYPE_E type_e = TYPE_MAX;

        if (argc < 4)
        {
        	printf("Usage: ./hex2header [-type] [hex_name] [vcpu_id]\r\n");
        	return -1;
        }

        snprintf(filename, sizeof(filename),"%s",argv[2]);
        printf("filename : %s\n",filename);

        snprintf(vcpu_id, sizeof(vcpu_id),"%s",argv[3]);
        printf("vcpu_id : %s, argv[3]:%s\n",vcpu_id, argv[3]);
        
        if((vcpu_id[0] != '1') && (vcpu_id[0] != '2'))
        {
                printf("get vcpu_id error, the vcpu_id should be 1 or 2\n");
                return -1;
        }
        snprintf(type, sizeof(type),"%s",argv[1]);

        if(strncmp(type, "-vee", 4) == 0)
        {
                type_e = TYPE_VE_ENCODE;
                snprintf(headname, sizeof(headname),"pattern_ve_encode%s.h", vcpu_id);
                printf("headname : %s\n",headname);
                snprintf(array_name, sizeof(array_name),"struct hex_data pattern_ve_encode%s[] =\r\n{\r\n", vcpu_id);
                printf("array_name : %s\n", array_name);    
        }
        else if(strncmp(type, "-ve", 3) == 0)
        {
                type_e = TYPE_VE;
                snprintf(headname, sizeof(headname),"pattern_ve%s.h", vcpu_id);
                printf("headname : %s\n",headname);
                snprintf(array_name, sizeof(array_name),"struct hex_data pattern_ve%s[] =\r\n{\r\n", vcpu_id);
                printf("array_name : %s\n", array_name);     
        }
        else if(strncmp(type, "-vde", 4) == 0)
        {
                type_e = TYPE_VDE;
                snprintf(part_num, sizeof(part_num),"%s",argv[4]);
                printf("part_num : %s, argv[4]:%s\n",vcpu_id, argv[4]);
                snprintf(headname, sizeof(headname),"pattern_vde%s%s.h", vcpu_id, part_num);
                printf("headname : %s\n",headname);
                snprintf(array_name, sizeof(array_name),"struct hex_data pattern_vde%s%s[] =\r\n{\r\n", vcpu_id, part_num);
                printf("array_name : %s\n", array_name);  
        }
        else
                type_e = TYPE_MAX;

        if(type_e >= TYPE_MAX)
        {
        	printf("get type error, the first parameter need use -ve or -vee or -vde\n");
        	return -1;
        }

        hexfile2headerfile(filename,headname,array_name);
        return 0;
}


