#ifndef __VP9_COMMON_H__
#define __VP9_COMMON_H__

#define SUCCESS		0
#define FAILED		(-1)

struct hex_data
{
    unsigned int addr;
    unsigned int data;
};

//------------------------------------------
// Definitions of Bits
//------------------------------------------
#define _ZERO                                                   0x00
#define _BIT0                                                   0x01
#define _BIT1                                                   0x02
#define _BIT2                                                   0x04
#define _BIT3                                                   0x08
#define _BIT4                                                   0x10
#define _BIT5                                                   0x20
#define _BIT6                                                   0x40
#define _BIT7                                                   0x80
#define _BIT8                                                   0x0100
#define _BIT9                                                   0x0200
#define _BIT10                                                  0x0400
#define _BIT11                                                  0x0800
#define _BIT12                                                  0x1000
#define _BIT13                                                  0x2000
#define _BIT14                                                  0x4000
#define _BIT15                                                  0x8000
#define _BIT16                                                  0x00010000
#define _BIT17                                                  0x00020000
#define _BIT18                                                  0x00040000
#define _BIT19                                                  0x00080000
#define _BIT20                                                  0x00100000
#define _BIT21                                                  0x00200000
#define _BIT22                                                  0x00400000
#define _BIT23                                                  0x00800000
#define _BIT24                                                  0x01000000
#define _BIT25                                                  0x02000000
#define _BIT26                                                  0x04000000
#define _BIT27                                                  0x08000000
#define _BIT28                                                  0x10000000
#define _BIT29                                                  0x20000000
#define _BIT30                                                  0x40000000
#define _BIT31                                                  0x80000000

typedef unsigned char		UINT8;
typedef signed char			INT8;
typedef unsigned short		UINT16;
typedef signed short		INT16;
typedef unsigned int		UINT32;
typedef signed int			INT32;
typedef unsigned long long	UINT64;
typedef signed long long	INT64;
typedef UINT8				bool;

typedef UINT32              uint32_t;
typedef UINT64              uint64_t;
typedef UINT64              u_int64_t;
typedef INT64               int64_t;

#define REG8( addr )		  (*(volatile UINT8 *) (addr))
#define REG16( addr )		  (*(volatile UINT16 *)(addr))
#define REG32( addr )		  (*(volatile UINT32 *)(addr))
#define REG64( addr )		  (*(volatile UINT64 *)(addr))

#define BYTE(d,n)		  (((d) >> ((n) << 3)) & 0xFF)
#define BIT(x)               (1 <<x)

//#define SWAP(DATA) (((DATA>>24)&0xff)|((DATA>>8)&0xff00)|((DATA<<8)&0x00ff0000)|((DATA<<24)&0xff000000))
#define SWAPEND32(d)    ((BYTE(d,0) << 24) |\
		         (BYTE(d,1) << 16) |\
		         (BYTE(d,2) << 8)  |\
		         (BYTE(d,3) << 0))


//void enable_clock(unsigned int reg_reset, unsigned int mask_reset, unsigned int reg_clock, unsigned int mask_clock);
//void disable_clock(unsigned int reg_reset, unsigned int mask_reset, unsigned int reg_clock, unsigned int mask_clock);
//int memcpy(void *destination, void *source, UINT32 size);

#endif //__VP9_COMMON_H__
