/**
* @file Mac7p-DesignSpec-D-Domain_DCTI_DLTI
* RBus systemc program.
*
* @author RS_MM2_SD
* @email jason9.ccc@realtek.com
 * @date 2019/11/22
* @ingroup model_rbus
 * @version { 1.0 }
 **
 */

#ifndef _RBUS_COLOR_REG_H_
#define _RBUS_COLOR_REG_H_

#include "rbusTypes.h"



//  COLOR Register Address



#define  COLOR_D_VC_GLOBAL_CTRL_VADDR                       	(0xb802a000)
#define  COLOR_D_VC_GLOBAL_CTRL_0_VADDR                     	(0xb802a014)
#define  COLOR_D_VC_GLOBAL_CTRL_DB_VADDR                    	(0xb802a004)



#ifndef LITTLE_ENDIAN //apply BIG_ENDIAN

//======COLOR register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:1;
        RBus_UInt32  dummy1802a000_30_27:4;
        RBus_UInt32  write_enable_11:1;
        RBus_UInt32  ms_vc_en:1;
        RBus_UInt32  write_enable_10:1;
        RBus_UInt32  highlightwin_inv:1;
        RBus_UInt32  res2:2;
        RBus_UInt32  write_enable_9:1;
        RBus_UInt32  icm_dcc_swap:1;
        RBus_UInt32  write_enable_8:1;
        RBus_UInt32  hlw_shpnr_enhance_en:1;
        RBus_UInt32  hlw_shpnr_enhance_mode:3;
        RBus_UInt32  write_enable_7:1;
        RBus_UInt32  hlw_shpnr_out_sel:1;
        RBus_UInt32  write_enable_6:1;
        RBus_UInt32  reg_bypass_pq:1;
        RBus_UInt32  res3:6;
        RBus_UInt32  write_enable_2:1;
        RBus_UInt32  m_dcti_en:1;
        RBus_UInt32  res4:2;
    };
}color_d_vc_global_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  write_enable_4:1;
        RBus_UInt32  ms_ctrl_sharp:3;
        RBus_UInt32  write_enable_20:1;
        RBus_UInt32  ms_ctrl_uvcoring:3;
        RBus_UInt32  write_enable_1:1;
        RBus_UInt32  ms_ctrl_dcc:3;
        RBus_UInt32  res2:2;
        RBus_UInt32  write_enable_12:1;
        RBus_UInt32  m_lc_comp_en:1;
        RBus_UInt32  write_enable_3:1;
        RBus_UInt32  ms_ctrl_icm:3;
    };
}color_d_vc_global_ctrl_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:29;
        RBus_UInt32  db_read:1;
        RBus_UInt32  db_en:1;
        RBus_UInt32  db_load:1;
    };
}color_d_vc_global_ctrl_db_RBUS;

#else //apply LITTLE_ENDIAN

//======COLOR register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  m_dcti_en:1;
        RBus_UInt32  write_enable_2:1;
        RBus_UInt32  res2:6;
        RBus_UInt32  reg_bypass_pq:1;
        RBus_UInt32  write_enable_6:1;
        RBus_UInt32  hlw_shpnr_out_sel:1;
        RBus_UInt32  write_enable_7:1;
        RBus_UInt32  hlw_shpnr_enhance_mode:3;
        RBus_UInt32  hlw_shpnr_enhance_en:1;
        RBus_UInt32  write_enable_8:1;
        RBus_UInt32  icm_dcc_swap:1;
        RBus_UInt32  write_enable_9:1;
        RBus_UInt32  res3:2;
        RBus_UInt32  highlightwin_inv:1;
        RBus_UInt32  write_enable_10:1;
        RBus_UInt32  ms_vc_en:1;
        RBus_UInt32  write_enable_11:1;
        RBus_UInt32  dummy1802a000_30_27:4;
        RBus_UInt32  res4:1;
    };
}color_d_vc_global_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ms_ctrl_icm:3;
        RBus_UInt32  write_enable_3:1;
        RBus_UInt32  m_lc_comp_en:1;
        RBus_UInt32  write_enable_12:1;
        RBus_UInt32  res1:2;
        RBus_UInt32  ms_ctrl_dcc:3;
        RBus_UInt32  write_enable_1:1;
        RBus_UInt32  ms_ctrl_uvcoring:3;
        RBus_UInt32  write_enable_20:1;
        RBus_UInt32  ms_ctrl_sharp:3;
        RBus_UInt32  write_enable_4:1;
        RBus_UInt32  res2:12;
    };
}color_d_vc_global_ctrl_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  db_load:1;
        RBus_UInt32  db_en:1;
        RBus_UInt32  db_read:1;
        RBus_UInt32  res1:29;
    };
}color_d_vc_global_ctrl_db_RBUS;




#endif 


#endif 
