/**
* @file Mac7p-DesignSpec-I-Domain_HDMI_3D_DMA_CAP
* RBus systemc program.
*
* @author RS_MM2_SD
* @email jason9.ccc@realtek.com
 * @date 2019/11/22
* @ingroup model_rbus
 * @version { 1.0 }
 **
 */

#ifndef _RBUS_H3DDMA_REG_H_
#define _RBUS_H3DDMA_REG_H_

#include "rbusTypes.h"



//  H3DDMA Register Address



#define  H3DDMA_LR_SEPARATE_CTRL1_VADDR                     	(0xb8025800)
#define  H3DDMA_LR_SEPARATE_CTRL2_VADDR                     	(0xb8025804)
#define  H3DDMA_LR_SEPARATE_INSERT_VS_START_VADDR           	(0xb8025808)
#define  H3DDMA_LR_SEPARATE_INSERT_VS_END_VADDR             	(0xb802580c)
#define  H3DDMA_I3DDMA_ENABLE_VADDR                         	(0xb8025810)
#define  H3DDMA_I3DDMA_CTRL_0_VADDR                         	(0xb8025814)
#define  H3DDMA_LR_SEPARATE_CTRL3_VADDR                     	(0xb8025818)
#define  H3DDMA_TG_V1_END_VADDR                             	(0xb8025820)
#define  H3DDMA_TG_SF_HTOTAL_VADDR                          	(0xb8025824)
#define  H3DDMA_TG_STATUS_VADDR                             	(0xb8025828)
#define  H3DDMA_I3DDMA_BIST_FAIL_VADDR                      	(0xb802582c)
#define  H3DDMA_I3DDMA_BIST_DRF_FAIL_VADDR                  	(0xb8025830)
#define  H3DDMA_I3DDMA_BIST_RM_0_VADDR                      	(0xb8025834)
#define  H3DDMA_I3DDMA_BIST_RM_1_VADDR                      	(0xb8025838)
#define  H3DDMA_I3DDMA_LS_RME_VADDR                         	(0xb802583c)
#define  H3DDMA_I3DDMA_MDP_CR_VADDR                         	(0xb8025840)
#define  H3DDMA_LR_CRC_CTRL_VADDR                           	(0xb8025844)
#define  H3DDMA_CRC_L_RESULT_VADDR                          	(0xb8025848)
#define  H3DDMA_CRC_R_RESULT_VADDR                          	(0xb802584c)
#define  H3DDMA_INTERRUPT_ENABLE_VADDR                      	(0xb8025850)
#define  H3DDMA_H3DDMA_PQ_CMP_VADDR                         	(0xb8025860)
#define  H3DDMA_H3DDMA_PQ_CMP_PAIR_VADDR                    	(0xb8025864)
#define  H3DDMA_H3DDMA_PQ_CMP_BIT_VADDR                     	(0xb8025868)
#define  H3DDMA_H3DDMA_PQ_CMP_ENABLE_VADDR                  	(0xb802586c)
#define  H3DDMA_H3DDMA_PQ_CMP_SMOOTH_VADDR                  	(0xb8025870)
#define  H3DDMA_H3DDMA_PQ_CMP_ALLOCATE_VADDR                	(0xb8025874)
#define  H3DDMA_H3DDMA_PQ_CMP_POOR_VADDR                    	(0xb8025878)
#define  H3DDMA_H3DDMA_PQ_CMP_GUARANTEE_VADDR               	(0xb802587c)
#define  H3DDMA_H3DDMA_PQ_CMP_BALANCE_VADDR                 	(0xb8025880)
#define  H3DDMA_H3DDMA_PQ_CMP_IRQ_EN_VADDR                  	(0xb8025884)
#define  H3DDMA_H3DDMA_PQ_CMP_IRQ_ST_VADDR                  	(0xb8025888)
#define  H3DDMA_H3DDMA_PQ_CMP_ST_VADDR                      	(0xb802588c)
#define  H3DDMA_H3DDMA_PQ_CMP_QP_ST_VADDR                   	(0xb8025890)
#define  H3DDMA_H3DDMA_PQ_CMP_FIFO_ST1_VADDR                	(0xb8025894)
#define  H3DDMA_H3DDMA_PQ_CMP_LEFT_ST_VADDR                 	(0xb802589c)
#define  H3DDMA_H3DDMA_PQ_CMP_PACKAGE_ST_VADDR              	(0xb80258a0)
#define  H3DDMA_H3DDMA_PQ_CMP_CRC_EVEN_G_VADDR              	(0xb80258a4)
#define  H3DDMA_H3DDMA_PQ_CMP_CRC_EVEN_R_VADDR              	(0xb80258a8)
#define  H3DDMA_H3DDMA_PQ_CMP_CRC_EVEN_B_VADDR              	(0xb80258ac)
#define  H3DDMA_H3DDMA_PQ_CMP_BLK0_ADD0_VADDR               	(0xb80258b0)
#define  H3DDMA_H3DDMA_PQ_CMP_BLK0_ADD1_VADDR               	(0xb80258b4)
#define  H3DDMA_H3DDMA_PQ_CMP_DOUBLE_BUFFER_CTRL_VADDR      	(0xb80258b8)
#define  H3DDMA_H3DDMA_PQ_CMP_DEN_EXTEND_RATE_VADDR         	(0xb80258bc)
#define  H3DDMA_CAP0_CAP_CTL0_VADDR                         	(0xb8025b00)
#define  H3DDMA_CAP0_CTI_DMA_WR_RULE_CHECK_UP_VADDR         	(0xb8025b04)
#define  H3DDMA_CAP0_CTI_DMA_WR_RULE_CHECK_LOW_VADDR        	(0xb8025b08)
#define  H3DDMA_CAP0_CTI_DMA_WR_RULE_CHECK_UP_1_VADDR       	(0xb80258d0)
#define  H3DDMA_CAP0_CTI_DMA_WR_RULE_CHECK_LOW_1_VADDR      	(0xb80258d4)
#define  H3DDMA_CAP0_CTI_DMA_WR_RULE_CHECK_UP_2_VADDR       	(0xb80258d8)
#define  H3DDMA_CAP0_CTI_DMA_WR_RULE_CHECK_LOW_2_VADDR      	(0xb80258dc)
#define  H3DDMA_CAP0_CTI_DMA_WR_RULE_CHECK_UP_3_VADDR       	(0xb80258e0)
#define  H3DDMA_CAP0_CTI_DMA_WR_RULE_CHECK_LOW_3_VADDR      	(0xb80258e4)
#define  H3DDMA_CAP0_CTI_DMA_WR_CTRL_VADDR                  	(0xb8025b0c)
#define  H3DDMA_CAP0_CTI_DMA_WR_STATUS_VADDR                	(0xb8025b10)
#define  H3DDMA_CAP0_CTI_DMA_WR_STATUS1_VADDR               	(0xb8025b14)
#define  H3DDMA_CAP0_CTI_DMA_WR_STATUS2_VADDR               	(0xb8025b18)
#define  H3DDMA_CAP0_CTI_DMA_WR_WATER_MONITOR_VADDR         	(0xb8025b1c)
#define  H3DDMA_CAP0_WR_DMA_NUM_BL_WRAP_ADDR_0_VADDR        	(0xb8025b20)
#define  H3DDMA_CAP0_WR_DMA_NUM_BL_WRAP_ADDR_1_VADDR        	(0xb8025b24)
#define  H3DDMA_CAP0_WR_DMA_NUM_BL_WRAP_ADDR_2_VADDR        	(0xb8025b28)
#define  H3DDMA_CAP0_WR_DMA_NUM_BL_WRAP_ADDR_3_VADDR        	(0xb8025b2c)
#define  H3DDMA_CAP0_WR_DMA_NUM_BL_WRAP_ADDR_R0_VADDR       	(0xb8025b30)
#define  H3DDMA_CAP0_WR_DMA_NUM_BL_WRAP_ADDR_R1_VADDR       	(0xb8025b34)
#define  H3DDMA_CAP0_WR_DMA_NUM_BL_WRAP_ADDR_R2_VADDR       	(0xb8025b38)
#define  H3DDMA_CAP0_WR_DMA_NUM_BL_WRAP_ADDR_R3_VADDR       	(0xb8025b3c)
#define  H3DDMA_CAP0_WR_DMA_NUM_BL_WRAP_LINE_STEP_VADDR     	(0xb8025b40)
#define  H3DDMA_CAP0_WR_DMA_NUM_BL_WRAP_CTL_VADDR           	(0xb8025b44)
#define  H3DDMA_CAP0_WR_DMA_NUM_BL_WRAP_ROLLING_VADDR       	(0xb8025b48)
#define  H3DDMA_CAP0_WR_DMA_NUM_BL_WRAP_WORD_VADDR          	(0xb8025b4c)
#define  H3DDMA_CAP0_WR_DMA_NUM_BL_WRAP_ST1_VADDR           	(0xb8025b50)
#define  H3DDMA_CAP0_WR_DMA_NUM_BL_WRAP_ST2_VADDR           	(0xb8025b54)
#define  H3DDMA_CAP0_WR_DMA_PXLTOBUS_VADDR                  	(0xb8025b58)
#define  H3DDMA_CAP0_CAP_L_START_DB_VADDR                   	(0xb8025b60)
#define  H3DDMA_CAP0_CAP_R_START_DB_VADDR                   	(0xb8025b64)
#define  H3DDMA_CAP0_CAP_STATUS_VADDR                       	(0xb8025b68)
#define  H3DDMA_CAP1_CAP_CTL0_VADDR                         	(0xb8025b80)
#define  H3DDMA_CAP1_CTI_DMA_WR_RULE_CHECK_UP_VADDR         	(0xb8025b84)
#define  H3DDMA_CAP1_CTI_DMA_WR_RULE_CHECK_LOW_VADDR        	(0xb8025b88)
#define  H3DDMA_CAP1_CTI_DMA_WR_CTRL_VADDR                  	(0xb8025b8c)
#define  H3DDMA_CAP1_CTI_DMA_WR_STATUS_VADDR                	(0xb8025b90)
#define  H3DDMA_CAP1_CTI_DMA_WR_STATUS1_VADDR               	(0xb8025b94)
#define  H3DDMA_CAP1_CTI_DMA_WR_STATUS2_VADDR               	(0xb8025b98)
#define  H3DDMA_CAP1_CTI_DMA_WR_WATER_MONITOR_VADDR         	(0xb8025b9c)
#define  H3DDMA_CAP1_WR_DMA_NUM_BL_WRAP_ADDR_0_VADDR        	(0xb8025ba0)
#define  H3DDMA_CAP1_WR_DMA_NUM_BL_WRAP_ADDR_1_VADDR        	(0xb8025ba4)
#define  H3DDMA_CAP1_WR_DMA_NUM_BL_WRAP_ADDR_2_VADDR        	(0xb8025ba8)
#define  H3DDMA_CAP1_WR_DMA_NUM_BL_WRAP_ADDR_3_VADDR        	(0xb8025bac)
#define  H3DDMA_CAP1_WR_DMA_NUM_BL_WRAP_ADDR_R0_VADDR       	(0xb8025bb0)
#define  H3DDMA_CAP1_WR_DMA_NUM_BL_WRAP_ADDR_R1_VADDR       	(0xb8025bb4)
#define  H3DDMA_CAP1_WR_DMA_NUM_BL_WRAP_ADDR_R2_VADDR       	(0xb8025bb8)
#define  H3DDMA_CAP1_WR_DMA_NUM_BL_WRAP_ADDR_R3_VADDR       	(0xb8025bbc)
#define  H3DDMA_CAP1_WR_DMA_NUM_BL_WRAP_LINE_STEP_VADDR     	(0xb8025bc0)
#define  H3DDMA_CAP1_WR_DMA_NUM_BL_WRAP_CTL_VADDR           	(0xb8025bc4)
#define  H3DDMA_CAP1_WR_DMA_NUM_BL_WRAP_ROLLING_VADDR       	(0xb8025bc8)
#define  H3DDMA_CAP1_WR_DMA_NUM_BL_WRAP_WORD_VADDR          	(0xb8025bcc)
#define  H3DDMA_CAP1_WR_DMA_NUM_BL_WRAP_ST1_VADDR           	(0xb8025bd0)
#define  H3DDMA_CAP1_WR_DMA_NUM_BL_WRAP_ST2_VADDR           	(0xb8025bd4)
#define  H3DDMA_CAP1_WR_DMA_PXLTOBUS_VADDR                  	(0xb8025bd8)
#define  H3DDMA_CAP1_CAP_L_START_DB_VADDR                   	(0xb8025be0)
#define  H3DDMA_CAP1_CAP_R_START_DB_VADDR                   	(0xb8025be4)
#define  H3DDMA_CAP1_CAP_STATUS_VADDR                       	(0xb8025be8)
#define  H3DDMA_CAP2_CAP_CTL0_VADDR                         	(0xb8025d00)
#define  H3DDMA_CAP2_CTI_DMA_WR_RULE_CHECK_UP_VADDR         	(0xb8025d04)
#define  H3DDMA_CAP2_CTI_DMA_WR_RULE_CHECK_LOW_VADDR        	(0xb8025d08)
#define  H3DDMA_CAP2_CTI_DMA_WR_CTRL_VADDR                  	(0xb8025d0c)
#define  H3DDMA_CAP2_CTI_DMA_WR_STATUS_VADDR                	(0xb8025d10)
#define  H3DDMA_CAP2_CTI_DMA_WR_STATUS1_VADDR               	(0xb8025d14)
#define  H3DDMA_CAP2_CTI_DMA_WR_STATUS2_VADDR               	(0xb8025d18)
#define  H3DDMA_CAP2_CTI_DMA_WR_WATER_MONITOR_VADDR         	(0xb8025d1c)
#define  H3DDMA_CAP2_WR_DMA_NUM_BL_WRAP_ADDR_0_VADDR        	(0xb8025d20)
#define  H3DDMA_CAP2_WR_DMA_NUM_BL_WRAP_ADDR_1_VADDR        	(0xb8025d24)
#define  H3DDMA_CAP2_WR_DMA_NUM_BL_WRAP_ADDR_2_VADDR        	(0xb8025d28)
#define  H3DDMA_CAP2_WR_DMA_NUM_BL_WRAP_ADDR_3_VADDR        	(0xb8025d2c)
#define  H3DDMA_CAP2_WR_DMA_NUM_BL_WRAP_ADDR_R0_VADDR       	(0xb8025d30)
#define  H3DDMA_CAP2_WR_DMA_NUM_BL_WRAP_ADDR_R1_VADDR       	(0xb8025d34)
#define  H3DDMA_CAP2_WR_DMA_NUM_BL_WRAP_ADDR_R2_VADDR       	(0xb8025d38)
#define  H3DDMA_CAP2_WR_DMA_NUM_BL_WRAP_ADDR_R3_VADDR       	(0xb8025d3c)
#define  H3DDMA_CAP2_WR_DMA_NUM_BL_WRAP_LINE_STEP_VADDR     	(0xb8025d40)
#define  H3DDMA_CAP2_WR_DMA_NUM_BL_WRAP_CTL_VADDR           	(0xb8025d44)
#define  H3DDMA_CAP2_WR_DMA_NUM_BL_WRAP_ROLLING_VADDR       	(0xb8025d48)
#define  H3DDMA_CAP2_WR_DMA_NUM_BL_WRAP_WORD_VADDR          	(0xb8025d4c)
#define  H3DDMA_CAP2_WR_DMA_NUM_BL_WRAP_ST1_VADDR           	(0xb8025d50)
#define  H3DDMA_CAP2_WR_DMA_NUM_BL_WRAP_ST2_VADDR           	(0xb8025d54)
#define  H3DDMA_CAP2_WR_DMA_PXLTOBUS_VADDR                  	(0xb8025d58)
#define  H3DDMA_CAP2_CAP_L_START_DB_VADDR                   	(0xb8025d60)
#define  H3DDMA_CAP2_CAP_R_START_DB_VADDR                   	(0xb8025d64)
#define  H3DDMA_CAP2_CAP_STATUS_VADDR                       	(0xb8025d68)
#define  H3DDMA_CAP3_CAP_CTL0_VADDR                         	(0xb8025d80)
#define  H3DDMA_CAP3_CTI_DMA_WR_RULE_CHECK_UP_VADDR         	(0xb8025d84)
#define  H3DDMA_CAP3_CTI_DMA_WR_RULE_CHECK_LOW_VADDR        	(0xb8025d88)
#define  H3DDMA_CAP3_CTI_DMA_WR_CTRL_VADDR                  	(0xb8025d8c)
#define  H3DDMA_CAP3_CTI_DMA_WR_STATUS_VADDR                	(0xb8025d90)
#define  H3DDMA_CAP3_CTI_DMA_WR_STATUS1_VADDR               	(0xb8025d94)
#define  H3DDMA_CAP3_CTI_DMA_WR_STATUS2_VADDR               	(0xb8025d98)
#define  H3DDMA_CAP3_CTI_DMA_WR_WATER_MONITOR_VADDR         	(0xb8025d9c)
#define  H3DDMA_CAP3_WR_DMA_NUM_BL_WRAP_ADDR_0_VADDR        	(0xb8025da0)
#define  H3DDMA_CAP3_WR_DMA_NUM_BL_WRAP_ADDR_1_VADDR        	(0xb8025da4)
#define  H3DDMA_CAP3_WR_DMA_NUM_BL_WRAP_ADDR_2_VADDR        	(0xb8025da8)
#define  H3DDMA_CAP3_WR_DMA_NUM_BL_WRAP_ADDR_3_VADDR        	(0xb8025dac)
#define  H3DDMA_CAP3_WR_DMA_NUM_BL_WRAP_ADDR_R0_VADDR       	(0xb8025db0)
#define  H3DDMA_CAP3_WR_DMA_NUM_BL_WRAP_ADDR_R1_VADDR       	(0xb8025db4)
#define  H3DDMA_CAP3_WR_DMA_NUM_BL_WRAP_ADDR_R2_VADDR       	(0xb8025db8)
#define  H3DDMA_CAP3_WR_DMA_NUM_BL_WRAP_ADDR_R3_VADDR       	(0xb8025dbc)
#define  H3DDMA_CAP3_WR_DMA_NUM_BL_WRAP_LINE_STEP_VADDR     	(0xb8025dc0)
#define  H3DDMA_CAP3_WR_DMA_NUM_BL_WRAP_CTL_VADDR           	(0xb8025dc4)
#define  H3DDMA_CAP3_WR_DMA_NUM_BL_WRAP_ROLLING_VADDR       	(0xb8025dc8)
#define  H3DDMA_CAP3_WR_DMA_NUM_BL_WRAP_WORD_VADDR          	(0xb8025dcc)
#define  H3DDMA_CAP3_WR_DMA_NUM_BL_WRAP_ST1_VADDR           	(0xb8025dd0)
#define  H3DDMA_CAP3_WR_DMA_NUM_BL_WRAP_ST2_VADDR           	(0xb8025dd4)
#define  H3DDMA_CAP3_WR_DMA_PXLTOBUS_VADDR                  	(0xb8025dd8)
#define  H3DDMA_CAP3_CAP_L_START_DB_VADDR                   	(0xb8025de0)
#define  H3DDMA_CAP3_CAP_R_START_DB_VADDR                   	(0xb8025de4)
#define  H3DDMA_CAP3_CAP_STATUS_VADDR                       	(0xb8025de8)



#ifndef LITTLE_ENDIAN //apply BIG_ENDIAN

//======H3DDMA register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy_lr_ctrl1:5;
        RBus_UInt32  hdmi420_en:1;
        RBus_UInt32  res1:2;
        RBus_UInt32  vs_inv:1;
        RBus_UInt32  hs_inv:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  progressive:1;
        RBus_UInt32  hdmi_3d_structure:4;
        RBus_UInt32  fp_vact_space1:8;
        RBus_UInt32  fp_vact_space2:8;
    };
}h3ddma_lr_separate_ctrl1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  vact:16;
        RBus_UInt32  res1:1;
        RBus_UInt32  hact:15;
    };
}h3ddma_lr_separate_ctrl2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:11;
        RBus_UInt32  hstart:13;
        RBus_UInt32  vstart:8;
    };
}h3ddma_lr_separate_insert_vs_start_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:11;
        RBus_UInt32  hend:13;
        RBus_UInt32  vend:8;
    };
}h3ddma_lr_separate_insert_vs_end_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  cap3_seq_blk_sel:1;
        RBus_UInt32  cap2_seq_blk_sel:1;
        RBus_UInt32  cap1_seq_blk_sel:1;
        RBus_UInt32  cap0_seq_blk_sel:1;
        RBus_UInt32  reorder:1;
        RBus_UInt32  uzd_mux_sel:1;
        RBus_UInt32  block_sel_to_flag_fifo_option:1;
        RBus_UInt32  frc_style:1;
        RBus_UInt32  frc_en:1;
        RBus_UInt32  tg_en:1;
        RBus_UInt32  lr_separate_en:1;
        RBus_UInt32  res2:1;
    };
}h3ddma_i3ddma_enable_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  cap3_channel_swap:3;
        RBus_UInt32  cap2_channel_swap:3;
        RBus_UInt32  cap1_channel_swap:3;
        RBus_UInt32  cap0_channel_swap:3;
    };
}h3ddma_i3ddma_ctrl_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  vact2:16;
        RBus_UInt32  res1:1;
        RBus_UInt32  hact2:15;
    };
}h3ddma_lr_separate_ctrl3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:6;
        RBus_UInt32  pullup_en:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  res3:3;
        RBus_UInt32  tg_hend1:13;
        RBus_UInt32  tg_vend1:8;
    };
}h3ddma_tg_v1_end_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  tg_slf_htotal_en:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  tg_slf_htotal:14;
    };
}h3ddma_tg_sf_htotal_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:23;
        RBus_UInt32  vs_rising_occur:1;
        RBus_UInt32  res2:6;
        RBus_UInt32  tg_l_flag:1;
        RBus_UInt32  tg_field:1;
    };
}h3ddma_tg_status_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:15;
        RBus_UInt32  i3ddma_bist_cap3_fail:1;
        RBus_UInt32  i3ddma_bist_cap1_fail:1;
        RBus_UInt32  i3ddma_pqc2_bist_fail_12:1;
        RBus_UInt32  i3ddma_pqc2_bist_fail_11:1;
        RBus_UInt32  i3ddma_pqc2_bist_fail_10:1;
        RBus_UInt32  i3ddma_pqc2_bist_fail_9:1;
        RBus_UInt32  i3ddma_pqc2_bist_fail_8:1;
        RBus_UInt32  i3ddma_pqc2_bist_fail_7:1;
        RBus_UInt32  i3ddma_pqc2_bist_fail_6:1;
        RBus_UInt32  i3ddma_pqc2_bist_fail_5:1;
        RBus_UInt32  i3ddma_pqc2_bist_fail_4:1;
        RBus_UInt32  i3ddma_pqc2_bist_fail_3:1;
        RBus_UInt32  i3ddma_pqc2_bist_fail_2:1;
        RBus_UInt32  i3ddma_pqc2_bist_fail_1:1;
        RBus_UInt32  i3ddma_pqc2_bist_fail_0:1;
        RBus_UInt32  i3ddma_bist_cap2_fail:1;
        RBus_UInt32  i3ddma_bist_cap0_fail:1;
    };
}h3ddma_i3ddma_bist_fail_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:15;
        RBus_UInt32  i3ddma_cap3_drf_fail:1;
        RBus_UInt32  i3ddma_cap1_drf_fail:1;
        RBus_UInt32  i3ddma_pqc2_drf_fail_12:1;
        RBus_UInt32  i3ddma_pqc2_drf_fail_11:1;
        RBus_UInt32  i3ddma_pqc2_drf_fail_10:1;
        RBus_UInt32  i3ddma_pqc2_drf_fail_9:1;
        RBus_UInt32  i3ddma_pqc2_drf_fail_8:1;
        RBus_UInt32  i3ddma_pqc2_drf_fail_7:1;
        RBus_UInt32  i3ddma_pqc2_drf_fail_6:1;
        RBus_UInt32  i3ddma_pqc2_drf_fail_5:1;
        RBus_UInt32  i3ddma_pqc2_drf_fail_4:1;
        RBus_UInt32  i3ddma_pqc2_drf_fail_3:1;
        RBus_UInt32  i3ddma_pqc2_drf_fail_2:1;
        RBus_UInt32  i3ddma_pqc2_drf_fail_1:1;
        RBus_UInt32  i3ddma_pqc2_drf_fail_0:1;
        RBus_UInt32  i3ddma_cap2_drf_fail:1;
        RBus_UInt32  i3ddma_cap0_drf_fail:1;
    };
}h3ddma_i3ddma_bist_drf_fail_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap1_rmb:4;
        RBus_UInt32  cap1_rma:4;
        RBus_UInt32  i3ddma_pqc2_rm_1:4;
        RBus_UInt32  i3ddma_pqc2_rm_0:4;
        RBus_UInt32  cap2_rmb:4;
        RBus_UInt32  cap2_rma:4;
        RBus_UInt32  cap0_rmb:4;
        RBus_UInt32  cap0_rma:4;
    };
}h3ddma_i3ddma_bist_rm_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cap3_rmb:4;
        RBus_UInt32  cap3_rma:4;
    };
}h3ddma_i3ddma_bist_rm_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:6;
        RBus_UInt32  cap3_rmeb:1;
        RBus_UInt32  cap3_rmea:1;
        RBus_UInt32  cap1_rmeb:1;
        RBus_UInt32  cap1_rmea:1;
        RBus_UInt32  i3ddma_pqc2_rme_1:1;
        RBus_UInt32  i3ddma_pqc2_rme_0:1;
        RBus_UInt32  cap2_rmeb:1;
        RBus_UInt32  cap2_rmea:1;
        RBus_UInt32  cap0_rmeb:1;
        RBus_UInt32  cap0_rmea:1;
        RBus_UInt32  res2:10;
        RBus_UInt32  cap3_ls:1;
        RBus_UInt32  cap1_ls:1;
        RBus_UInt32  i3ddma_pqc2_ls_1:1;
        RBus_UInt32  i3ddma_pqc2_ls_0:1;
        RBus_UInt32  cap2_ls:1;
        RBus_UInt32  cap0_ls:1;
    };
}h3ddma_i3ddma_ls_rme_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:7;
        RBus_UInt32  mdp_max_packet_num:9;
        RBus_UInt32  res2:13;
        RBus_UInt32  mdp_mode:2;
        RBus_UInt32  mdp_en:1;
    };
}h3ddma_i3ddma_mdp_cr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  r_crc_res_sel:4;
        RBus_UInt32  res2:2;
        RBus_UInt32  r_crc_conti:1;
        RBus_UInt32  r_crc_start:1;
        RBus_UInt32  l_crc_res_sel:4;
        RBus_UInt32  res3:2;
        RBus_UInt32  l_crc_conti:1;
        RBus_UInt32  l_crc_start:1;
    };
}h3ddma_lr_crc_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  crc_l_result:32;
    };
}h3ddma_crc_l_result_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  crc_r_result:32;
    };
}h3ddma_crc_r_result_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cap3_last_wr_ie:1;
        RBus_UInt32  cap2_last_wr_ie:1;
        RBus_UInt32  cap1_last_wr_ie:1;
        RBus_UInt32  cap0_last_wr_ie:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  mem_err_ie:1;
        RBus_UInt32  fifo_err_ie:1;
        RBus_UInt32  vs_rising_ie:1;
    };
}h3ddma_interrupt_enable_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmp_en:1;
        RBus_UInt32  res1:6;
        RBus_UInt32  cmp_width_div32:9;
        RBus_UInt32  res2:2;
        RBus_UInt32  cmp_height:14;
    };
}h3ddma_h3ddma_pq_cmp_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmp_line_sum_bit:16;
        RBus_UInt32  cmp_400_old_mode_en:1;
        RBus_UInt32  dummy18025864_14_11:4;
        RBus_UInt32  cmp_jump4_en:1;
        RBus_UInt32  cmp_qp_mode:2;
        RBus_UInt32  cmp_dic_mode_en:1;
        RBus_UInt32  two_line_prediction_en:1;
        RBus_UInt32  cmp_line_mode:1;
        RBus_UInt32  cmp_data_color:1;
        RBus_UInt32  cmp_data_bit_width:2;
        RBus_UInt32  cmp_data_format:2;
    };
}h3ddma_h3ddma_pq_cmp_pair_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  first_line_more_bit:6;
        RBus_UInt32  res2:2;
        RBus_UInt32  block_limit_bit:6;
        RBus_UInt32  res3:2;
        RBus_UInt32  line_limit_bit:6;
        RBus_UInt32  res4:2;
        RBus_UInt32  frame_limit_bit:6;
    };
}h3ddma_h3ddma_pq_cmp_bit_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  input_fifo_pause_cycle:4;
        RBus_UInt32  tail_dummy_throughput:1;
        RBus_UInt32  first_predict_nc_mode:1;
        RBus_UInt32  res1:5;
        RBus_UInt32  g_ratio:5;
        RBus_UInt32  add_last2blk_over_curve_bit:1;
        RBus_UInt32  variation_maxmin_en:1;
        RBus_UInt32  dynamic_sum_line_rst:1;
        RBus_UInt32  blk0_add_en:1;
        RBus_UInt32  guarantee_max_qp_en:1;
        RBus_UInt32  dynamic_allocate_ratio_en:1;
        RBus_UInt32  poor_limit_min_qp_en:1;
        RBus_UInt32  balance_en:1;
        RBus_UInt32  fisrt_line_more_en:1;
        RBus_UInt32  blk0_add_half_en:1;
        RBus_UInt32  do_422_mode:2;
        RBus_UInt32  first_predict_nc_en:1;
        RBus_UInt32  not_enough_bit_do_422_en:1;
        RBus_UInt32  not_rich_do_422_en:1;
        RBus_UInt32  rb_lossy_do_422_en:1;
    };
}h3ddma_h3ddma_pq_cmp_enable_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dic_mode_option:4;
        RBus_UInt32  res1:1;
        RBus_UInt32  not_enough_bit_do_422_qp:3;
        RBus_UInt32  not_rich_do_422_th:4;
        RBus_UInt32  res2:1;
        RBus_UInt32  rb_lossy_do_422_qp_level:3;
        RBus_UInt32  dic_mode_entry_th:4;
        RBus_UInt32  variation_value_th:4;
        RBus_UInt32  res3:1;
        RBus_UInt32  variation_num_th:3;
        RBus_UInt32  res4:1;
        RBus_UInt32  variation_near_num_th:3;
    };
}h3ddma_h3ddma_pq_cmp_smooth_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  dynamic_allocate_ratio_max:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  dynamic_allocate_ratio_min:5;
        RBus_UInt32  res3:5;
        RBus_UInt32  dynamic_allocate_line:3;
        RBus_UInt32  dynamic_allocate_more:4;
        RBus_UInt32  dynamic_allocate_less:4;
    };
}h3ddma_h3ddma_pq_cmp_allocate_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  poor_limit_th_qp4:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  poor_limit_th_qp3:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  poor_limit_th_qp2:5;
        RBus_UInt32  res4:3;
        RBus_UInt32  poor_limit_th_qp1:5;
    };
}h3ddma_h3ddma_pq_cmp_poor_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  cmp_crc_ro_line_sel:14;
        RBus_UInt32  dic_mode_qp_th_rb:4;
        RBus_UInt32  dic_mode_qp_th_g:4;
        RBus_UInt32  guarantee_max_rb_qp:4;
        RBus_UInt32  guarantee_max_g_qp:4;
    };
}h3ddma_h3ddma_pq_cmp_guarantee_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  variation_maxmin_th2:8;
        RBus_UInt32  variation_maxmin_th:8;
        RBus_UInt32  res1:2;
        RBus_UInt32  balance_rb_ov_th:2;
        RBus_UInt32  balance_rb_ud_th:2;
        RBus_UInt32  balance_rb_give:2;
        RBus_UInt32  res2:2;
        RBus_UInt32  balance_g_ov_th:2;
        RBus_UInt32  balance_g_ud_th:2;
        RBus_UInt32  balance_g_give:2;
    };
}h3ddma_h3ddma_pq_cmp_balance_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:13;
        RBus_UInt32  prs_over_line_sum_bit_irq_en:1;
        RBus_UInt32  tail_fifo_overflow_irq_en:1;
        RBus_UInt32  input_fifo_overflow_irq_en:1;
        RBus_UInt32  block_fifo_overflow_irq_en:1;
        RBus_UInt32  input_size_more_irq_en:1;
        RBus_UInt32  input_size_less_irq_en:1;
        RBus_UInt32  over_flb_irq_en:1;
        RBus_UInt32  res2:2;
        RBus_UInt32  request_fifo_even_overflow_irq_en:1;
        RBus_UInt32  res3:1;
        RBus_UInt32  res4:1;
        RBus_UInt32  g_fifo_even_overflow_irq_en:1;
        RBus_UInt32  r_fifo_even_overflow_irq_en:1;
        RBus_UInt32  b_fifo_even_overflow_irq_en:1;
        RBus_UInt32  res5:1;
        RBus_UInt32  res6:1;
        RBus_UInt32  res7:1;
        RBus_UInt32  res8:1;
    };
}h3ddma_h3ddma_pq_cmp_irq_en_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pqc_irq:1;
        RBus_UInt32  res1:12;
        RBus_UInt32  prs_over_line_sum_bit_st:1;
        RBus_UInt32  tail_fifo_overflow_st:1;
        RBus_UInt32  input_fifo_overflow_st:1;
        RBus_UInt32  block_fifo_overflow_st:1;
        RBus_UInt32  input_size_more_st:1;
        RBus_UInt32  input_size_less_st:1;
        RBus_UInt32  over_flb_st:1;
        RBus_UInt32  res2:2;
        RBus_UInt32  request_fifo_even_overflow_st:1;
        RBus_UInt32  res3:1;
        RBus_UInt32  res4:1;
        RBus_UInt32  g_fifo_even_overflow_st:1;
        RBus_UInt32  r_fifo_even_overflow_st:1;
        RBus_UInt32  b_fifo_even_overflow_st:1;
        RBus_UInt32  res5:1;
        RBus_UInt32  res6:1;
        RBus_UInt32  res7:1;
        RBus_UInt32  res8:1;
    };
}h3ddma_h3ddma_pq_cmp_irq_st_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:1;
        RBus_UInt32  res2:2;
        RBus_UInt32  g_ratio_max:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  g_ratio_min:5;
        RBus_UInt32  res4:2;
        RBus_UInt32  cmp_package_height_cnt:14;
    };
}h3ddma_h3ddma_pq_cmp_st_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  long_term_qp_measure_en:1;
        RBus_UInt32  res1:7;
        RBus_UInt32  long_term_g_qp_max:4;
        RBus_UInt32  long_term_rb_qp_max:4;
        RBus_UInt32  res2:8;
        RBus_UInt32  short_term_g_qp_max:4;
        RBus_UInt32  short_term_rb_qp_max:4;
    };
}h3ddma_h3ddma_pq_cmp_qp_st_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fifo_water_measure_en:1;
        RBus_UInt32  res1:7;
        RBus_UInt32  fifo_water_even_g:8;
        RBus_UInt32  fifo_water_even_r:8;
        RBus_UInt32  fifo_water_even_b:8;
    };
}h3ddma_h3ddma_pq_cmp_fifo_st1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  g_frame_left:16;
        RBus_UInt32  rb_frame_left:16;
    };
}h3ddma_h3ddma_pq_cmp_left_st_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  total_package_long_term:1;
        RBus_UInt32  res1:7;
        RBus_UInt32  total_package_even:24;
    };
}h3ddma_h3ddma_pq_cmp_package_st_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmp_crc_even_g:32;
    };
}h3ddma_h3ddma_pq_cmp_crc_even_g_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmp_crc_even_r:32;
    };
}h3ddma_h3ddma_pq_cmp_crc_even_r_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmp_crc_even_b:32;
    };
}h3ddma_h3ddma_pq_cmp_crc_even_b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  blk0_add_value0:6;
        RBus_UInt32  dic_mode_tolerance:8;
        RBus_UInt32  res2:2;
        RBus_UInt32  blk0_add_value32:6;
        RBus_UInt32  res3:2;
        RBus_UInt32  blk0_add_value16:6;
    };
}h3ddma_h3ddma_pq_cmp_blk0_add0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  blk0_add_value8:6;
        RBus_UInt32  res2:2;
        RBus_UInt32  blk0_add_value4:6;
        RBus_UInt32  res3:2;
        RBus_UInt32  blk0_add_value2:6;
        RBus_UInt32  res4:2;
        RBus_UInt32  blk0_add_value1:6;
    };
}h3ddma_h3ddma_pq_cmp_blk0_add1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:29;
        RBus_UInt32  db_read_sel:1;
        RBus_UInt32  db_apply:1;
        RBus_UInt32  db_en:1;
    };
}h3ddma_h3ddma_pq_cmp_double_buffer_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  pqc_den_extend_rate:4;
    };
}h3ddma_h3ddma_pq_cmp_den_extend_rate_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap0_triple_buf_en:1;
        RBus_UInt32  cap0_cap_block_fw:2;
        RBus_UInt32  cap0_set_block_sel:1;
        RBus_UInt32  cap0_quad_buf_en:1;
        RBus_UInt32  res1:2;
        RBus_UInt32  cap0_freeze_en:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  cap0_auto_block_sel_en:1;
        RBus_UInt32  cap0_half_wr_en:1;
        RBus_UInt32  cap0_half_wr_sel:1;
        RBus_UInt32  res3:19;
        RBus_UInt32  cap0_frame_access_mode:1;
    };
}h3ddma_cap0_cap_ctl0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap0_dma_up_limit:28;
        RBus_UInt32  res1:4;
    };
}h3ddma_cap0_cti_dma_wr_rule_check_up_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap0_dma_low_limit:28;
        RBus_UInt32  res1:4;
    };
}h3ddma_cap0_cti_dma_wr_rule_check_low_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap0_dma_up_limit_1:28;
        RBus_UInt32  res1:4;
    };
}h3ddma_cap0_cti_dma_wr_rule_check_up_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap0_dma_low_limit_1:28;
        RBus_UInt32  res1:4;
    };
}h3ddma_cap0_cti_dma_wr_rule_check_low_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap0_dma_up_limit_2:28;
        RBus_UInt32  res1:4;
    };
}h3ddma_cap0_cti_dma_wr_rule_check_up_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap0_dma_low_limit_2:28;
        RBus_UInt32  res1:4;
    };
}h3ddma_cap0_cti_dma_wr_rule_check_low_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap0_dma_up_limit_3:28;
        RBus_UInt32  res1:4;
    };
}h3ddma_cap0_cti_dma_wr_rule_check_up_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap0_dma_low_limit_3:28;
        RBus_UInt32  res1:4;
    };
}h3ddma_cap0_cti_dma_wr_rule_check_low_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:18;
        RBus_UInt32  cap0_dma_8byte_swap:1;
        RBus_UInt32  cap0_dma_4byte_swap:1;
        RBus_UInt32  cap0_dma_2byte_swap:1;
        RBus_UInt32  cap0_dma_1byte_swap:1;
        RBus_UInt32  cap0_max_outstanding:2;
        RBus_UInt32  res2:6;
        RBus_UInt32  cap0_force_all_rst:1;
        RBus_UInt32  cap0_dma_enable:1;
    };
}h3ddma_cap0_cti_dma_wr_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:1;
        RBus_UInt32  cap0_dma_cmd_water:3;
        RBus_UInt32  res2:2;
        RBus_UInt32  cap0_dma_data_water:10;
        RBus_UInt32  res3:5;
        RBus_UInt32  cap0_cur_outstanding:3;
        RBus_UInt32  res4:3;
        RBus_UInt32  cap0_soft_rst_before_cmd_finish:1;
        RBus_UInt32  cap0_soft_rst_with_data_left:1;
        RBus_UInt32  cap0_data_fifo_underflow_err:1;
        RBus_UInt32  cap0_exceed_range_err:1;
        RBus_UInt32  cap0_zero_length_err:1;
    };
}h3ddma_cap0_cti_dma_wr_status_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap0_ack_num_error:1;
        RBus_UInt32  cap0_last_no_ack_error:1;
        RBus_UInt32  res1:7;
        RBus_UInt32  cap0_target_ack_num:7;
        RBus_UInt32  res2:1;
        RBus_UInt32  cap0_last_ack_num:7;
        RBus_UInt32  res3:2;
        RBus_UInt32  cap0_selected_bl:6;
    };
}h3ddma_cap0_cti_dma_wr_status1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap0_selected_addr:27;
        RBus_UInt32  res1:3;
        RBus_UInt32  cap0_addr_bl_sel:2;
    };
}h3ddma_cap0_cti_dma_wr_status2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap0_monitor_en:1;
        RBus_UInt32  cap0_monitor_conti:1;
        RBus_UInt32  res1:5;
        RBus_UInt32  cap0_reach_thd:1;
        RBus_UInt32  cap0_monitor_thd:10;
        RBus_UInt32  res2:4;
        RBus_UInt32  cap0_highest_water_level:10;
    };
}h3ddma_cap0_cti_dma_wr_water_monitor_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap0_sta_addr_0:28;
        RBus_UInt32  res1:4;
    };
}h3ddma_cap0_wr_dma_num_bl_wrap_addr_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap0_sta_addr_1:28;
        RBus_UInt32  res1:4;
    };
}h3ddma_cap0_wr_dma_num_bl_wrap_addr_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap0_sta_addr_2:28;
        RBus_UInt32  res1:4;
    };
}h3ddma_cap0_wr_dma_num_bl_wrap_addr_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap0_sta_addr_3:28;
        RBus_UInt32  res1:4;
    };
}h3ddma_cap0_wr_dma_num_bl_wrap_addr_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap0_sta_addr_r0:28;
        RBus_UInt32  res1:4;
    };
}h3ddma_cap0_wr_dma_num_bl_wrap_addr_r0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap0_sta_addr_r1:28;
        RBus_UInt32  res1:4;
    };
}h3ddma_cap0_wr_dma_num_bl_wrap_addr_r1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap0_sta_addr_r2:28;
        RBus_UInt32  res1:4;
    };
}h3ddma_cap0_wr_dma_num_bl_wrap_addr_r2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap0_sta_addr_r3:28;
        RBus_UInt32  res1:4;
    };
}h3ddma_cap0_wr_dma_num_bl_wrap_addr_r3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap0_line_step:28;
        RBus_UInt32  res1:4;
    };
}h3ddma_cap0_wr_dma_num_bl_wrap_line_step_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  cap0_line_num:12;
        RBus_UInt32  res2:5;
        RBus_UInt32  cap0_burst_len:7;
        RBus_UInt32  res3:4;
    };
}h3ddma_cap0_wr_dma_num_bl_wrap_ctl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap0_rolling_enable:1;
        RBus_UInt32  res1:3;
        RBus_UInt32  cap0_rolling_space:12;
        RBus_UInt32  res2:4;
        RBus_UInt32  cap0_rolling_num:12;
    };
}h3ddma_cap0_wr_dma_num_bl_wrap_rolling_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  cap0_addr_toggle_mode:2;
        RBus_UInt32  res2:5;
        RBus_UInt32  cap0_line_burst_num:23;
    };
}h3ddma_cap0_wr_dma_num_bl_wrap_word_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap0_remain_setting:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  cap0_finish_status:2;
        RBus_UInt32  res2:5;
        RBus_UInt32  cap0_remain_burst_num:23;
    };
}h3ddma_cap0_wr_dma_num_bl_wrap_st1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap0_soft_rst_before_finish:1;
        RBus_UInt32  res1:3;
        RBus_UInt32  cap0_remain_line_num:12;
        RBus_UInt32  res2:16;
    };
}h3ddma_cap0_wr_dma_num_bl_wrap_st2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  cap0_bit_sel:2;
        RBus_UInt32  cap0_pixel_encoding:2;
    };
}h3ddma_cap0_wr_dma_pxltobus_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap0_sta_addr_db:29;
        RBus_UInt32  res1:3;
    };
}h3ddma_cap0_cap_l_start_db_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap0_sta_addr_r_db:29;
        RBus_UInt32  res1:3;
    };
}h3ddma_cap0_cap_r_start_db_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:23;
        RBus_UInt32  cap0_freeze_ok:1;
        RBus_UInt32  res2:2;
        RBus_UInt32  cap0_cap_block_sel:2;
        RBus_UInt32  cap0_cap_last_wr_flag:1;
        RBus_UInt32  cap0_cap_over_size:1;
        RBus_UInt32  cap0_cap_under_size:1;
        RBus_UInt32  cap0_cap_fifo_overflow:1;
    };
}h3ddma_cap0_cap_status_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap1_triple_buf_en:1;
        RBus_UInt32  cap1_cap_block_fw:2;
        RBus_UInt32  cap1_set_block_sel:1;
        RBus_UInt32  cap1_quad_buf_en:1;
        RBus_UInt32  res1:2;
        RBus_UInt32  cap1_freeze_en:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  cap1_auto_block_sel_en:1;
        RBus_UInt32  res3:21;
        RBus_UInt32  cap1_frame_access_mode:1;
    };
}h3ddma_cap1_cap_ctl0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap1_dma_up_limit:28;
        RBus_UInt32  res1:4;
    };
}h3ddma_cap1_cti_dma_wr_rule_check_up_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap1_dma_low_limit:28;
        RBus_UInt32  res1:4;
    };
}h3ddma_cap1_cti_dma_wr_rule_check_low_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:18;
        RBus_UInt32  cap1_dma_8byte_swap:1;
        RBus_UInt32  cap1_dma_4byte_swap:1;
        RBus_UInt32  cap1_dma_2byte_swap:1;
        RBus_UInt32  cap1_dma_1byte_swap:1;
        RBus_UInt32  cap1_max_outstanding:2;
        RBus_UInt32  res2:6;
        RBus_UInt32  cap1_force_all_rst:1;
        RBus_UInt32  cap1_dma_enable:1;
    };
}h3ddma_cap1_cti_dma_wr_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:1;
        RBus_UInt32  cap1_dma_cmd_water:3;
        RBus_UInt32  res2:4;
        RBus_UInt32  cap1_dma_data_water:8;
        RBus_UInt32  res3:5;
        RBus_UInt32  cap1_cur_outstanding:3;
        RBus_UInt32  res4:3;
        RBus_UInt32  cap1_soft_rst_before_cmd_finish:1;
        RBus_UInt32  cap1_soft_rst_with_data_left:1;
        RBus_UInt32  cap1_data_fifo_underflow_err:1;
        RBus_UInt32  cap1_exceed_range_err:1;
        RBus_UInt32  cap1_zero_length_err:1;
    };
}h3ddma_cap1_cti_dma_wr_status_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap1_ack_num_error:1;
        RBus_UInt32  cap1_last_no_ack_error:1;
        RBus_UInt32  res1:7;
        RBus_UInt32  cap1_target_ack_num:7;
        RBus_UInt32  res2:1;
        RBus_UInt32  cap1_last_ack_num:7;
        RBus_UInt32  res3:2;
        RBus_UInt32  cap1_selected_bl:6;
    };
}h3ddma_cap1_cti_dma_wr_status1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap1_selected_addr:27;
        RBus_UInt32  res1:3;
        RBus_UInt32  cap1_addr_bl_sel:2;
    };
}h3ddma_cap1_cti_dma_wr_status2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap1_monitor_en:1;
        RBus_UInt32  cap1_monitor_conti:1;
        RBus_UInt32  res1:5;
        RBus_UInt32  cap1_reach_thd:1;
        RBus_UInt32  cap1_monitor_thd:8;
        RBus_UInt32  res2:8;
        RBus_UInt32  cap1_highest_water_level:8;
    };
}h3ddma_cap1_cti_dma_wr_water_monitor_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap1_sta_addr_0:28;
        RBus_UInt32  res1:4;
    };
}h3ddma_cap1_wr_dma_num_bl_wrap_addr_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap1_sta_addr_1:28;
        RBus_UInt32  res1:4;
    };
}h3ddma_cap1_wr_dma_num_bl_wrap_addr_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap1_sta_addr_2:28;
        RBus_UInt32  res1:4;
    };
}h3ddma_cap1_wr_dma_num_bl_wrap_addr_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap1_sta_addr_3:28;
        RBus_UInt32  res1:4;
    };
}h3ddma_cap1_wr_dma_num_bl_wrap_addr_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap1_sta_addr_r0:28;
        RBus_UInt32  res1:4;
    };
}h3ddma_cap1_wr_dma_num_bl_wrap_addr_r0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap1_sta_addr_r1:28;
        RBus_UInt32  res1:4;
    };
}h3ddma_cap1_wr_dma_num_bl_wrap_addr_r1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap1_sta_addr_r2:28;
        RBus_UInt32  res1:4;
    };
}h3ddma_cap1_wr_dma_num_bl_wrap_addr_r2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap1_sta_addr_r3:28;
        RBus_UInt32  res1:4;
    };
}h3ddma_cap1_wr_dma_num_bl_wrap_addr_r3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap1_line_step:28;
        RBus_UInt32  res1:4;
    };
}h3ddma_cap1_wr_dma_num_bl_wrap_line_step_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  cap1_line_num:12;
        RBus_UInt32  res2:5;
        RBus_UInt32  cap1_burst_len:7;
        RBus_UInt32  res3:4;
    };
}h3ddma_cap1_wr_dma_num_bl_wrap_ctl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap1_rolling_enable:1;
        RBus_UInt32  res1:3;
        RBus_UInt32  cap1_rolling_space:12;
        RBus_UInt32  res2:4;
        RBus_UInt32  cap1_rolling_num:12;
    };
}h3ddma_cap1_wr_dma_num_bl_wrap_rolling_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  cap1_addr_toggle_mode:2;
        RBus_UInt32  res2:5;
        RBus_UInt32  cap1_line_burst_num:23;
    };
}h3ddma_cap1_wr_dma_num_bl_wrap_word_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap1_remain_setting:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  cap1_finish_status:2;
        RBus_UInt32  res2:5;
        RBus_UInt32  cap1_remain_burst_num:23;
    };
}h3ddma_cap1_wr_dma_num_bl_wrap_st1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap1_soft_rst_before_finish:1;
        RBus_UInt32  res1:3;
        RBus_UInt32  cap1_remain_line_num:12;
        RBus_UInt32  res2:16;
    };
}h3ddma_cap1_wr_dma_num_bl_wrap_st2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  cap1_bit_sel:2;
        RBus_UInt32  cap1_pixel_encoding:2;
    };
}h3ddma_cap1_wr_dma_pxltobus_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap1_sta_addr_db:29;
        RBus_UInt32  res1:3;
    };
}h3ddma_cap1_cap_l_start_db_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap1_sta_addr_r_db:29;
        RBus_UInt32  res1:3;
    };
}h3ddma_cap1_cap_r_start_db_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:23;
        RBus_UInt32  cap1_freeze_ok:1;
        RBus_UInt32  res2:2;
        RBus_UInt32  cap1_cap_block_sel:2;
        RBus_UInt32  cap1_cap_last_wr_flag:1;
        RBus_UInt32  cap1_cap_over_size:1;
        RBus_UInt32  cap1_cap_under_size:1;
        RBus_UInt32  cap1_cap_fifo_overflow:1;
    };
}h3ddma_cap1_cap_status_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap2_triple_buf_en:1;
        RBus_UInt32  cap2_cap_block_fw:2;
        RBus_UInt32  cap2_set_block_sel:1;
        RBus_UInt32  cap2_quad_buf_en:1;
        RBus_UInt32  res1:2;
        RBus_UInt32  cap2_freeze_en:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  cap2_auto_block_sel_en:1;
        RBus_UInt32  res3:21;
        RBus_UInt32  cap2_frame_access_mode:1;
    };
}h3ddma_cap2_cap_ctl0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap2_dma_up_limit:28;
        RBus_UInt32  res1:4;
    };
}h3ddma_cap2_cti_dma_wr_rule_check_up_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap2_dma_low_limit:28;
        RBus_UInt32  res1:4;
    };
}h3ddma_cap2_cti_dma_wr_rule_check_low_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:18;
        RBus_UInt32  cap2_dma_8byte_swap:1;
        RBus_UInt32  cap2_dma_4byte_swap:1;
        RBus_UInt32  cap2_dma_2byte_swap:1;
        RBus_UInt32  cap2_dma_1byte_swap:1;
        RBus_UInt32  cap2_max_outstanding:2;
        RBus_UInt32  res2:6;
        RBus_UInt32  cap2_force_all_rst:1;
        RBus_UInt32  cap2_dma_enable:1;
    };
}h3ddma_cap2_cti_dma_wr_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:1;
        RBus_UInt32  cap2_dma_cmd_water:3;
        RBus_UInt32  res2:3;
        RBus_UInt32  cap2_dma_data_water:9;
        RBus_UInt32  res3:5;
        RBus_UInt32  cap2_cur_outstanding:3;
        RBus_UInt32  res4:3;
        RBus_UInt32  cap2_soft_rst_before_cmd_finish:1;
        RBus_UInt32  cap2_soft_rst_with_data_left:1;
        RBus_UInt32  cap2_data_fifo_underflow_err:1;
        RBus_UInt32  cap2_exceed_range_err:1;
        RBus_UInt32  cap2_zero_length_err:1;
    };
}h3ddma_cap2_cti_dma_wr_status_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap2_ack_num_error:1;
        RBus_UInt32  cap2_last_no_ack_error:1;
        RBus_UInt32  res1:7;
        RBus_UInt32  cap2_target_ack_num:7;
        RBus_UInt32  res2:1;
        RBus_UInt32  cap2_last_ack_num:7;
        RBus_UInt32  res3:2;
        RBus_UInt32  cap2_selected_bl:6;
    };
}h3ddma_cap2_cti_dma_wr_status1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap2_selected_addr:27;
        RBus_UInt32  res1:3;
        RBus_UInt32  cap2_addr_bl_sel:2;
    };
}h3ddma_cap2_cti_dma_wr_status2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap2_monitor_en:1;
        RBus_UInt32  cap2_monitor_conti:1;
        RBus_UInt32  res1:5;
        RBus_UInt32  cap2_reach_thd:1;
        RBus_UInt32  cap2_monitor_thd:9;
        RBus_UInt32  res2:6;
        RBus_UInt32  cap2_highest_water_level:9;
    };
}h3ddma_cap2_cti_dma_wr_water_monitor_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap2_sta_addr_0:28;
        RBus_UInt32  res1:4;
    };
}h3ddma_cap2_wr_dma_num_bl_wrap_addr_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap2_sta_addr_1:28;
        RBus_UInt32  res1:4;
    };
}h3ddma_cap2_wr_dma_num_bl_wrap_addr_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap2_sta_addr_2:28;
        RBus_UInt32  res1:4;
    };
}h3ddma_cap2_wr_dma_num_bl_wrap_addr_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap2_sta_addr_3:28;
        RBus_UInt32  res1:4;
    };
}h3ddma_cap2_wr_dma_num_bl_wrap_addr_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap2_sta_addr_r0:28;
        RBus_UInt32  res1:4;
    };
}h3ddma_cap2_wr_dma_num_bl_wrap_addr_r0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap2_sta_addr_r1:28;
        RBus_UInt32  res1:4;
    };
}h3ddma_cap2_wr_dma_num_bl_wrap_addr_r1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap2_sta_addr_r2:28;
        RBus_UInt32  res1:4;
    };
}h3ddma_cap2_wr_dma_num_bl_wrap_addr_r2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap2_sta_addr_r3:28;
        RBus_UInt32  res1:4;
    };
}h3ddma_cap2_wr_dma_num_bl_wrap_addr_r3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap2_line_step:28;
        RBus_UInt32  res1:4;
    };
}h3ddma_cap2_wr_dma_num_bl_wrap_line_step_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  cap2_line_num:12;
        RBus_UInt32  res2:5;
        RBus_UInt32  cap2_burst_len:7;
        RBus_UInt32  res3:4;
    };
}h3ddma_cap2_wr_dma_num_bl_wrap_ctl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap2_rolling_enable:1;
        RBus_UInt32  res1:3;
        RBus_UInt32  cap2_rolling_space:12;
        RBus_UInt32  res2:4;
        RBus_UInt32  cap2_rolling_num:12;
    };
}h3ddma_cap2_wr_dma_num_bl_wrap_rolling_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  cap2_addr_toggle_mode:2;
        RBus_UInt32  res2:5;
        RBus_UInt32  cap2_line_burst_num:23;
    };
}h3ddma_cap2_wr_dma_num_bl_wrap_word_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap2_remain_setting:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  cap2_finish_status:2;
        RBus_UInt32  res2:5;
        RBus_UInt32  cap2_remain_burst_num:23;
    };
}h3ddma_cap2_wr_dma_num_bl_wrap_st1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap2_soft_rst_before_finish:1;
        RBus_UInt32  res1:3;
        RBus_UInt32  cap2_remain_line_num:12;
        RBus_UInt32  res2:16;
    };
}h3ddma_cap2_wr_dma_num_bl_wrap_st2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  cap2_bit_sel:2;
        RBus_UInt32  cap2_pixel_encoding:2;
    };
}h3ddma_cap2_wr_dma_pxltobus_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap2_sta_addr_db:29;
        RBus_UInt32  res1:3;
    };
}h3ddma_cap2_cap_l_start_db_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap2_sta_addr_r_db:29;
        RBus_UInt32  res1:3;
    };
}h3ddma_cap2_cap_r_start_db_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:23;
        RBus_UInt32  cap2_freeze_ok:1;
        RBus_UInt32  res2:2;
        RBus_UInt32  cap2_cap_block_sel:2;
        RBus_UInt32  cap2_cap_last_wr_flag:1;
        RBus_UInt32  cap2_cap_over_size:1;
        RBus_UInt32  cap2_cap_under_size:1;
        RBus_UInt32  cap2_cap_fifo_overflow:1;
    };
}h3ddma_cap2_cap_status_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap3_triple_buf_en:1;
        RBus_UInt32  cap3_cap_block_fw:2;
        RBus_UInt32  cap3_set_block_sel:1;
        RBus_UInt32  cap3_quad_buf_en:1;
        RBus_UInt32  res1:2;
        RBus_UInt32  cap3_freeze_en:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  cap3_auto_block_sel_en:1;
        RBus_UInt32  res3:21;
        RBus_UInt32  cap3_frame_access_mode:1;
    };
}h3ddma_cap3_cap_ctl0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap3_dma_up_limit:28;
        RBus_UInt32  res1:4;
    };
}h3ddma_cap3_cti_dma_wr_rule_check_up_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap3_dma_low_limit:28;
        RBus_UInt32  res1:4;
    };
}h3ddma_cap3_cti_dma_wr_rule_check_low_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:18;
        RBus_UInt32  cap3_dma_8byte_swap:1;
        RBus_UInt32  cap3_dma_4byte_swap:1;
        RBus_UInt32  cap3_dma_2byte_swap:1;
        RBus_UInt32  cap3_dma_1byte_swap:1;
        RBus_UInt32  cap3_max_outstanding:2;
        RBus_UInt32  res2:6;
        RBus_UInt32  cap3_force_all_rst:1;
        RBus_UInt32  cap3_dma_enable:1;
    };
}h3ddma_cap3_cti_dma_wr_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:1;
        RBus_UInt32  cap3_dma_cmd_water:3;
        RBus_UInt32  res2:6;
        RBus_UInt32  cap3_dma_data_water:6;
        RBus_UInt32  res3:5;
        RBus_UInt32  cap3_cur_outstanding:3;
        RBus_UInt32  res4:3;
        RBus_UInt32  cap3_soft_rst_before_cmd_finish:1;
        RBus_UInt32  cap3_soft_rst_with_data_left:1;
        RBus_UInt32  cap3_data_fifo_underflow_err:1;
        RBus_UInt32  cap3_exceed_range_err:1;
        RBus_UInt32  cap3_zero_length_err:1;
    };
}h3ddma_cap3_cti_dma_wr_status_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap3_ack_num_error:1;
        RBus_UInt32  cap3_last_no_ack_error:1;
        RBus_UInt32  res1:7;
        RBus_UInt32  cap3_target_ack_num:7;
        RBus_UInt32  res2:1;
        RBus_UInt32  cap3_last_ack_num:7;
        RBus_UInt32  res3:2;
        RBus_UInt32  cap3_selected_bl:6;
    };
}h3ddma_cap3_cti_dma_wr_status1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap3_selected_addr:27;
        RBus_UInt32  res1:3;
        RBus_UInt32  cap3_addr_bl_sel:2;
    };
}h3ddma_cap3_cti_dma_wr_status2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap3_monitor_en:1;
        RBus_UInt32  cap3_monitor_conti:1;
        RBus_UInt32  res1:5;
        RBus_UInt32  cap3_reach_thd:1;
        RBus_UInt32  cap3_monitor_thd:6;
        RBus_UInt32  res2:12;
        RBus_UInt32  cap3_highest_water_level:6;
    };
}h3ddma_cap3_cti_dma_wr_water_monitor_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap3_sta_addr_0:28;
        RBus_UInt32  res1:4;
    };
}h3ddma_cap3_wr_dma_num_bl_wrap_addr_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap3_sta_addr_1:28;
        RBus_UInt32  res1:4;
    };
}h3ddma_cap3_wr_dma_num_bl_wrap_addr_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap3_sta_addr_2:28;
        RBus_UInt32  res1:4;
    };
}h3ddma_cap3_wr_dma_num_bl_wrap_addr_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap3_sta_addr_3:28;
        RBus_UInt32  res1:4;
    };
}h3ddma_cap3_wr_dma_num_bl_wrap_addr_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap3_sta_addr_r0:28;
        RBus_UInt32  res1:4;
    };
}h3ddma_cap3_wr_dma_num_bl_wrap_addr_r0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap3_sta_addr_r1:28;
        RBus_UInt32  res1:4;
    };
}h3ddma_cap3_wr_dma_num_bl_wrap_addr_r1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap3_sta_addr_r2:28;
        RBus_UInt32  res1:4;
    };
}h3ddma_cap3_wr_dma_num_bl_wrap_addr_r2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap3_sta_addr_r3:28;
        RBus_UInt32  res1:4;
    };
}h3ddma_cap3_wr_dma_num_bl_wrap_addr_r3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap3_line_step:28;
        RBus_UInt32  res1:4;
    };
}h3ddma_cap3_wr_dma_num_bl_wrap_line_step_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  cap3_line_num:12;
        RBus_UInt32  res2:5;
        RBus_UInt32  cap3_burst_len:7;
        RBus_UInt32  res3:4;
    };
}h3ddma_cap3_wr_dma_num_bl_wrap_ctl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap3_rolling_enable:1;
        RBus_UInt32  res1:3;
        RBus_UInt32  cap3_rolling_space:12;
        RBus_UInt32  res2:4;
        RBus_UInt32  cap3_rolling_num:12;
    };
}h3ddma_cap3_wr_dma_num_bl_wrap_rolling_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  cap3_addr_toggle_mode:2;
        RBus_UInt32  res2:5;
        RBus_UInt32  cap3_line_burst_num:23;
    };
}h3ddma_cap3_wr_dma_num_bl_wrap_word_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap3_remain_setting:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  cap3_finish_status:2;
        RBus_UInt32  res2:5;
        RBus_UInt32  cap3_remain_burst_num:23;
    };
}h3ddma_cap3_wr_dma_num_bl_wrap_st1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap3_soft_rst_before_finish:1;
        RBus_UInt32  res1:3;
        RBus_UInt32  cap3_remain_line_num:12;
        RBus_UInt32  res2:16;
    };
}h3ddma_cap3_wr_dma_num_bl_wrap_st2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  cap3_bit_sel:2;
        RBus_UInt32  cap3_pixel_encoding:2;
    };
}h3ddma_cap3_wr_dma_pxltobus_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap3_sta_addr_db:29;
        RBus_UInt32  res1:3;
    };
}h3ddma_cap3_cap_l_start_db_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap3_sta_addr_r_db:29;
        RBus_UInt32  res1:3;
    };
}h3ddma_cap3_cap_r_start_db_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:23;
        RBus_UInt32  cap3_freeze_ok:1;
        RBus_UInt32  res2:2;
        RBus_UInt32  cap3_cap_block_sel:2;
        RBus_UInt32  cap3_cap_last_wr_flag:1;
        RBus_UInt32  cap3_cap_over_size:1;
        RBus_UInt32  cap3_cap_under_size:1;
        RBus_UInt32  cap3_cap_fifo_overflow:1;
    };
}h3ddma_cap3_cap_status_RBUS;

#else //apply LITTLE_ENDIAN

//======H3DDMA register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fp_vact_space2:8;
        RBus_UInt32  fp_vact_space1:8;
        RBus_UInt32  hdmi_3d_structure:4;
        RBus_UInt32  progressive:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  hs_inv:1;
        RBus_UInt32  vs_inv:1;
        RBus_UInt32  res2:2;
        RBus_UInt32  hdmi420_en:1;
        RBus_UInt32  dummy_lr_ctrl1:5;
    };
}h3ddma_lr_separate_ctrl1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hact:15;
        RBus_UInt32  res1:1;
        RBus_UInt32  vact:16;
    };
}h3ddma_lr_separate_ctrl2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  vstart:8;
        RBus_UInt32  hstart:13;
        RBus_UInt32  res1:11;
    };
}h3ddma_lr_separate_insert_vs_start_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  vend:8;
        RBus_UInt32  hend:13;
        RBus_UInt32  res1:11;
    };
}h3ddma_lr_separate_insert_vs_end_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:1;
        RBus_UInt32  lr_separate_en:1;
        RBus_UInt32  tg_en:1;
        RBus_UInt32  frc_en:1;
        RBus_UInt32  frc_style:1;
        RBus_UInt32  block_sel_to_flag_fifo_option:1;
        RBus_UInt32  uzd_mux_sel:1;
        RBus_UInt32  reorder:1;
        RBus_UInt32  cap0_seq_blk_sel:1;
        RBus_UInt32  cap1_seq_blk_sel:1;
        RBus_UInt32  cap2_seq_blk_sel:1;
        RBus_UInt32  cap3_seq_blk_sel:1;
        RBus_UInt32  res2:20;
    };
}h3ddma_i3ddma_enable_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap0_channel_swap:3;
        RBus_UInt32  cap1_channel_swap:3;
        RBus_UInt32  cap2_channel_swap:3;
        RBus_UInt32  cap3_channel_swap:3;
        RBus_UInt32  res1:20;
    };
}h3ddma_i3ddma_ctrl_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hact2:15;
        RBus_UInt32  res1:1;
        RBus_UInt32  vact2:16;
    };
}h3ddma_lr_separate_ctrl3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  tg_vend1:8;
        RBus_UInt32  tg_hend1:13;
        RBus_UInt32  res1:3;
        RBus_UInt32  res2:1;
        RBus_UInt32  pullup_en:1;
        RBus_UInt32  res3:6;
    };
}h3ddma_tg_v1_end_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  tg_slf_htotal:14;
        RBus_UInt32  res1:1;
        RBus_UInt32  tg_slf_htotal_en:1;
        RBus_UInt32  res2:16;
    };
}h3ddma_tg_sf_htotal_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  tg_field:1;
        RBus_UInt32  tg_l_flag:1;
        RBus_UInt32  res1:6;
        RBus_UInt32  vs_rising_occur:1;
        RBus_UInt32  res2:23;
    };
}h3ddma_tg_status_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  i3ddma_bist_cap0_fail:1;
        RBus_UInt32  i3ddma_bist_cap2_fail:1;
        RBus_UInt32  i3ddma_pqc2_bist_fail_0:1;
        RBus_UInt32  i3ddma_pqc2_bist_fail_1:1;
        RBus_UInt32  i3ddma_pqc2_bist_fail_2:1;
        RBus_UInt32  i3ddma_pqc2_bist_fail_3:1;
        RBus_UInt32  i3ddma_pqc2_bist_fail_4:1;
        RBus_UInt32  i3ddma_pqc2_bist_fail_5:1;
        RBus_UInt32  i3ddma_pqc2_bist_fail_6:1;
        RBus_UInt32  i3ddma_pqc2_bist_fail_7:1;
        RBus_UInt32  i3ddma_pqc2_bist_fail_8:1;
        RBus_UInt32  i3ddma_pqc2_bist_fail_9:1;
        RBus_UInt32  i3ddma_pqc2_bist_fail_10:1;
        RBus_UInt32  i3ddma_pqc2_bist_fail_11:1;
        RBus_UInt32  i3ddma_pqc2_bist_fail_12:1;
        RBus_UInt32  i3ddma_bist_cap1_fail:1;
        RBus_UInt32  i3ddma_bist_cap3_fail:1;
        RBus_UInt32  res1:15;
    };
}h3ddma_i3ddma_bist_fail_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  i3ddma_cap0_drf_fail:1;
        RBus_UInt32  i3ddma_cap2_drf_fail:1;
        RBus_UInt32  i3ddma_pqc2_drf_fail_0:1;
        RBus_UInt32  i3ddma_pqc2_drf_fail_1:1;
        RBus_UInt32  i3ddma_pqc2_drf_fail_2:1;
        RBus_UInt32  i3ddma_pqc2_drf_fail_3:1;
        RBus_UInt32  i3ddma_pqc2_drf_fail_4:1;
        RBus_UInt32  i3ddma_pqc2_drf_fail_5:1;
        RBus_UInt32  i3ddma_pqc2_drf_fail_6:1;
        RBus_UInt32  i3ddma_pqc2_drf_fail_7:1;
        RBus_UInt32  i3ddma_pqc2_drf_fail_8:1;
        RBus_UInt32  i3ddma_pqc2_drf_fail_9:1;
        RBus_UInt32  i3ddma_pqc2_drf_fail_10:1;
        RBus_UInt32  i3ddma_pqc2_drf_fail_11:1;
        RBus_UInt32  i3ddma_pqc2_drf_fail_12:1;
        RBus_UInt32  i3ddma_cap1_drf_fail:1;
        RBus_UInt32  i3ddma_cap3_drf_fail:1;
        RBus_UInt32  res1:15;
    };
}h3ddma_i3ddma_bist_drf_fail_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap0_rma:4;
        RBus_UInt32  cap0_rmb:4;
        RBus_UInt32  cap2_rma:4;
        RBus_UInt32  cap2_rmb:4;
        RBus_UInt32  i3ddma_pqc2_rm_0:4;
        RBus_UInt32  i3ddma_pqc2_rm_1:4;
        RBus_UInt32  cap1_rma:4;
        RBus_UInt32  cap1_rmb:4;
    };
}h3ddma_i3ddma_bist_rm_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap3_rma:4;
        RBus_UInt32  cap3_rmb:4;
        RBus_UInt32  res1:24;
    };
}h3ddma_i3ddma_bist_rm_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap0_ls:1;
        RBus_UInt32  cap2_ls:1;
        RBus_UInt32  i3ddma_pqc2_ls_0:1;
        RBus_UInt32  i3ddma_pqc2_ls_1:1;
        RBus_UInt32  cap1_ls:1;
        RBus_UInt32  cap3_ls:1;
        RBus_UInt32  res1:10;
        RBus_UInt32  cap0_rmea:1;
        RBus_UInt32  cap0_rmeb:1;
        RBus_UInt32  cap2_rmea:1;
        RBus_UInt32  cap2_rmeb:1;
        RBus_UInt32  i3ddma_pqc2_rme_0:1;
        RBus_UInt32  i3ddma_pqc2_rme_1:1;
        RBus_UInt32  cap1_rmea:1;
        RBus_UInt32  cap1_rmeb:1;
        RBus_UInt32  cap3_rmea:1;
        RBus_UInt32  cap3_rmeb:1;
        RBus_UInt32  res2:6;
    };
}h3ddma_i3ddma_ls_rme_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mdp_en:1;
        RBus_UInt32  mdp_mode:2;
        RBus_UInt32  res1:13;
        RBus_UInt32  mdp_max_packet_num:9;
        RBus_UInt32  res2:7;
    };
}h3ddma_i3ddma_mdp_cr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  l_crc_start:1;
        RBus_UInt32  l_crc_conti:1;
        RBus_UInt32  res1:2;
        RBus_UInt32  l_crc_res_sel:4;
        RBus_UInt32  r_crc_start:1;
        RBus_UInt32  r_crc_conti:1;
        RBus_UInt32  res2:2;
        RBus_UInt32  r_crc_res_sel:4;
        RBus_UInt32  res3:16;
    };
}h3ddma_lr_crc_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  crc_l_result:32;
    };
}h3ddma_crc_l_result_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  crc_r_result:32;
    };
}h3ddma_crc_r_result_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  vs_rising_ie:1;
        RBus_UInt32  fifo_err_ie:1;
        RBus_UInt32  mem_err_ie:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  cap0_last_wr_ie:1;
        RBus_UInt32  cap1_last_wr_ie:1;
        RBus_UInt32  cap2_last_wr_ie:1;
        RBus_UInt32  cap3_last_wr_ie:1;
        RBus_UInt32  res2:24;
    };
}h3ddma_interrupt_enable_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmp_height:14;
        RBus_UInt32  res1:2;
        RBus_UInt32  cmp_width_div32:9;
        RBus_UInt32  res2:6;
        RBus_UInt32  cmp_en:1;
    };
}h3ddma_h3ddma_pq_cmp_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmp_data_format:2;
        RBus_UInt32  cmp_data_bit_width:2;
        RBus_UInt32  cmp_data_color:1;
        RBus_UInt32  cmp_line_mode:1;
        RBus_UInt32  two_line_prediction_en:1;
        RBus_UInt32  cmp_dic_mode_en:1;
        RBus_UInt32  cmp_qp_mode:2;
        RBus_UInt32  cmp_jump4_en:1;
        RBus_UInt32  dummy18025864_14_11:4;
        RBus_UInt32  cmp_400_old_mode_en:1;
        RBus_UInt32  cmp_line_sum_bit:16;
    };
}h3ddma_h3ddma_pq_cmp_pair_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  frame_limit_bit:6;
        RBus_UInt32  res1:2;
        RBus_UInt32  line_limit_bit:6;
        RBus_UInt32  res2:2;
        RBus_UInt32  block_limit_bit:6;
        RBus_UInt32  res3:2;
        RBus_UInt32  first_line_more_bit:6;
        RBus_UInt32  res4:2;
    };
}h3ddma_h3ddma_pq_cmp_bit_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  rb_lossy_do_422_en:1;
        RBus_UInt32  not_rich_do_422_en:1;
        RBus_UInt32  not_enough_bit_do_422_en:1;
        RBus_UInt32  first_predict_nc_en:1;
        RBus_UInt32  do_422_mode:2;
        RBus_UInt32  blk0_add_half_en:1;
        RBus_UInt32  fisrt_line_more_en:1;
        RBus_UInt32  balance_en:1;
        RBus_UInt32  poor_limit_min_qp_en:1;
        RBus_UInt32  dynamic_allocate_ratio_en:1;
        RBus_UInt32  guarantee_max_qp_en:1;
        RBus_UInt32  blk0_add_en:1;
        RBus_UInt32  dynamic_sum_line_rst:1;
        RBus_UInt32  variation_maxmin_en:1;
        RBus_UInt32  add_last2blk_over_curve_bit:1;
        RBus_UInt32  g_ratio:5;
        RBus_UInt32  res1:5;
        RBus_UInt32  first_predict_nc_mode:1;
        RBus_UInt32  tail_dummy_throughput:1;
        RBus_UInt32  input_fifo_pause_cycle:4;
    };
}h3ddma_h3ddma_pq_cmp_enable_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  variation_near_num_th:3;
        RBus_UInt32  res1:1;
        RBus_UInt32  variation_num_th:3;
        RBus_UInt32  res2:1;
        RBus_UInt32  variation_value_th:4;
        RBus_UInt32  dic_mode_entry_th:4;
        RBus_UInt32  rb_lossy_do_422_qp_level:3;
        RBus_UInt32  res3:1;
        RBus_UInt32  not_rich_do_422_th:4;
        RBus_UInt32  not_enough_bit_do_422_qp:3;
        RBus_UInt32  res4:1;
        RBus_UInt32  dic_mode_option:4;
    };
}h3ddma_h3ddma_pq_cmp_smooth_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dynamic_allocate_less:4;
        RBus_UInt32  dynamic_allocate_more:4;
        RBus_UInt32  dynamic_allocate_line:3;
        RBus_UInt32  res1:5;
        RBus_UInt32  dynamic_allocate_ratio_min:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  dynamic_allocate_ratio_max:5;
        RBus_UInt32  res3:3;
    };
}h3ddma_h3ddma_pq_cmp_allocate_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  poor_limit_th_qp1:5;
        RBus_UInt32  res1:3;
        RBus_UInt32  poor_limit_th_qp2:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  poor_limit_th_qp3:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  poor_limit_th_qp4:5;
        RBus_UInt32  res4:3;
    };
}h3ddma_h3ddma_pq_cmp_poor_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  guarantee_max_g_qp:4;
        RBus_UInt32  guarantee_max_rb_qp:4;
        RBus_UInt32  dic_mode_qp_th_g:4;
        RBus_UInt32  dic_mode_qp_th_rb:4;
        RBus_UInt32  cmp_crc_ro_line_sel:14;
        RBus_UInt32  res1:2;
    };
}h3ddma_h3ddma_pq_cmp_guarantee_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  balance_g_give:2;
        RBus_UInt32  balance_g_ud_th:2;
        RBus_UInt32  balance_g_ov_th:2;
        RBus_UInt32  res1:2;
        RBus_UInt32  balance_rb_give:2;
        RBus_UInt32  balance_rb_ud_th:2;
        RBus_UInt32  balance_rb_ov_th:2;
        RBus_UInt32  res2:2;
        RBus_UInt32  variation_maxmin_th:8;
        RBus_UInt32  variation_maxmin_th2:8;
    };
}h3ddma_h3ddma_pq_cmp_balance_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  res3:1;
        RBus_UInt32  res4:1;
        RBus_UInt32  b_fifo_even_overflow_irq_en:1;
        RBus_UInt32  r_fifo_even_overflow_irq_en:1;
        RBus_UInt32  g_fifo_even_overflow_irq_en:1;
        RBus_UInt32  res5:1;
        RBus_UInt32  res6:1;
        RBus_UInt32  request_fifo_even_overflow_irq_en:1;
        RBus_UInt32  res7:2;
        RBus_UInt32  over_flb_irq_en:1;
        RBus_UInt32  input_size_less_irq_en:1;
        RBus_UInt32  input_size_more_irq_en:1;
        RBus_UInt32  block_fifo_overflow_irq_en:1;
        RBus_UInt32  input_fifo_overflow_irq_en:1;
        RBus_UInt32  tail_fifo_overflow_irq_en:1;
        RBus_UInt32  prs_over_line_sum_bit_irq_en:1;
        RBus_UInt32  res8:13;
    };
}h3ddma_h3ddma_pq_cmp_irq_en_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  res3:1;
        RBus_UInt32  res4:1;
        RBus_UInt32  b_fifo_even_overflow_st:1;
        RBus_UInt32  r_fifo_even_overflow_st:1;
        RBus_UInt32  g_fifo_even_overflow_st:1;
        RBus_UInt32  res5:1;
        RBus_UInt32  res6:1;
        RBus_UInt32  request_fifo_even_overflow_st:1;
        RBus_UInt32  res7:2;
        RBus_UInt32  over_flb_st:1;
        RBus_UInt32  input_size_less_st:1;
        RBus_UInt32  input_size_more_st:1;
        RBus_UInt32  block_fifo_overflow_st:1;
        RBus_UInt32  input_fifo_overflow_st:1;
        RBus_UInt32  tail_fifo_overflow_st:1;
        RBus_UInt32  prs_over_line_sum_bit_st:1;
        RBus_UInt32  res8:12;
        RBus_UInt32  pqc_irq:1;
    };
}h3ddma_h3ddma_pq_cmp_irq_st_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmp_package_height_cnt:14;
        RBus_UInt32  res1:2;
        RBus_UInt32  g_ratio_min:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  g_ratio_max:5;
        RBus_UInt32  res3:2;
        RBus_UInt32  res4:1;
    };
}h3ddma_h3ddma_pq_cmp_st_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  short_term_rb_qp_max:4;
        RBus_UInt32  short_term_g_qp_max:4;
        RBus_UInt32  res1:8;
        RBus_UInt32  long_term_rb_qp_max:4;
        RBus_UInt32  long_term_g_qp_max:4;
        RBus_UInt32  res2:7;
        RBus_UInt32  long_term_qp_measure_en:1;
    };
}h3ddma_h3ddma_pq_cmp_qp_st_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fifo_water_even_b:8;
        RBus_UInt32  fifo_water_even_r:8;
        RBus_UInt32  fifo_water_even_g:8;
        RBus_UInt32  res1:7;
        RBus_UInt32  fifo_water_measure_en:1;
    };
}h3ddma_h3ddma_pq_cmp_fifo_st1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  rb_frame_left:16;
        RBus_UInt32  g_frame_left:16;
    };
}h3ddma_h3ddma_pq_cmp_left_st_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  total_package_even:24;
        RBus_UInt32  res1:7;
        RBus_UInt32  total_package_long_term:1;
    };
}h3ddma_h3ddma_pq_cmp_package_st_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmp_crc_even_g:32;
    };
}h3ddma_h3ddma_pq_cmp_crc_even_g_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmp_crc_even_r:32;
    };
}h3ddma_h3ddma_pq_cmp_crc_even_r_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmp_crc_even_b:32;
    };
}h3ddma_h3ddma_pq_cmp_crc_even_b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  blk0_add_value16:6;
        RBus_UInt32  res1:2;
        RBus_UInt32  blk0_add_value32:6;
        RBus_UInt32  res2:2;
        RBus_UInt32  dic_mode_tolerance:8;
        RBus_UInt32  blk0_add_value0:6;
        RBus_UInt32  res3:2;
    };
}h3ddma_h3ddma_pq_cmp_blk0_add0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  blk0_add_value1:6;
        RBus_UInt32  res1:2;
        RBus_UInt32  blk0_add_value2:6;
        RBus_UInt32  res2:2;
        RBus_UInt32  blk0_add_value4:6;
        RBus_UInt32  res3:2;
        RBus_UInt32  blk0_add_value8:6;
        RBus_UInt32  res4:2;
    };
}h3ddma_h3ddma_pq_cmp_blk0_add1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  db_en:1;
        RBus_UInt32  db_apply:1;
        RBus_UInt32  db_read_sel:1;
        RBus_UInt32  res1:29;
    };
}h3ddma_h3ddma_pq_cmp_double_buffer_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pqc_den_extend_rate:4;
        RBus_UInt32  res1:28;
    };
}h3ddma_h3ddma_pq_cmp_den_extend_rate_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap0_frame_access_mode:1;
        RBus_UInt32  res1:19;
        RBus_UInt32  cap0_half_wr_sel:1;
        RBus_UInt32  cap0_half_wr_en:1;
        RBus_UInt32  cap0_auto_block_sel_en:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  cap0_freeze_en:1;
        RBus_UInt32  res3:2;
        RBus_UInt32  cap0_quad_buf_en:1;
        RBus_UInt32  cap0_set_block_sel:1;
        RBus_UInt32  cap0_cap_block_fw:2;
        RBus_UInt32  cap0_triple_buf_en:1;
    };
}h3ddma_cap0_cap_ctl0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  cap0_dma_up_limit:28;
    };
}h3ddma_cap0_cti_dma_wr_rule_check_up_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  cap0_dma_low_limit:28;
    };
}h3ddma_cap0_cti_dma_wr_rule_check_low_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  cap0_dma_up_limit_1:28;
    };
}h3ddma_cap0_cti_dma_wr_rule_check_up_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  cap0_dma_low_limit_1:28;
    };
}h3ddma_cap0_cti_dma_wr_rule_check_low_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  cap0_dma_up_limit_2:28;
    };
}h3ddma_cap0_cti_dma_wr_rule_check_up_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  cap0_dma_low_limit_2:28;
    };
}h3ddma_cap0_cti_dma_wr_rule_check_low_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  cap0_dma_up_limit_3:28;
    };
}h3ddma_cap0_cti_dma_wr_rule_check_up_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  cap0_dma_low_limit_3:28;
    };
}h3ddma_cap0_cti_dma_wr_rule_check_low_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap0_dma_enable:1;
        RBus_UInt32  cap0_force_all_rst:1;
        RBus_UInt32  res1:6;
        RBus_UInt32  cap0_max_outstanding:2;
        RBus_UInt32  cap0_dma_1byte_swap:1;
        RBus_UInt32  cap0_dma_2byte_swap:1;
        RBus_UInt32  cap0_dma_4byte_swap:1;
        RBus_UInt32  cap0_dma_8byte_swap:1;
        RBus_UInt32  res2:18;
    };
}h3ddma_cap0_cti_dma_wr_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap0_zero_length_err:1;
        RBus_UInt32  cap0_exceed_range_err:1;
        RBus_UInt32  cap0_data_fifo_underflow_err:1;
        RBus_UInt32  cap0_soft_rst_with_data_left:1;
        RBus_UInt32  cap0_soft_rst_before_cmd_finish:1;
        RBus_UInt32  res1:3;
        RBus_UInt32  cap0_cur_outstanding:3;
        RBus_UInt32  res2:5;
        RBus_UInt32  cap0_dma_data_water:10;
        RBus_UInt32  res3:2;
        RBus_UInt32  cap0_dma_cmd_water:3;
        RBus_UInt32  res4:1;
    };
}h3ddma_cap0_cti_dma_wr_status_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap0_selected_bl:6;
        RBus_UInt32  res1:2;
        RBus_UInt32  cap0_last_ack_num:7;
        RBus_UInt32  res2:1;
        RBus_UInt32  cap0_target_ack_num:7;
        RBus_UInt32  res3:7;
        RBus_UInt32  cap0_last_no_ack_error:1;
        RBus_UInt32  cap0_ack_num_error:1;
    };
}h3ddma_cap0_cti_dma_wr_status1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap0_addr_bl_sel:2;
        RBus_UInt32  res1:3;
        RBus_UInt32  cap0_selected_addr:27;
    };
}h3ddma_cap0_cti_dma_wr_status2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap0_highest_water_level:10;
        RBus_UInt32  res1:4;
        RBus_UInt32  cap0_monitor_thd:10;
        RBus_UInt32  cap0_reach_thd:1;
        RBus_UInt32  res2:5;
        RBus_UInt32  cap0_monitor_conti:1;
        RBus_UInt32  cap0_monitor_en:1;
    };
}h3ddma_cap0_cti_dma_wr_water_monitor_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  cap0_sta_addr_0:28;
    };
}h3ddma_cap0_wr_dma_num_bl_wrap_addr_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  cap0_sta_addr_1:28;
    };
}h3ddma_cap0_wr_dma_num_bl_wrap_addr_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  cap0_sta_addr_2:28;
    };
}h3ddma_cap0_wr_dma_num_bl_wrap_addr_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  cap0_sta_addr_3:28;
    };
}h3ddma_cap0_wr_dma_num_bl_wrap_addr_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  cap0_sta_addr_r0:28;
    };
}h3ddma_cap0_wr_dma_num_bl_wrap_addr_r0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  cap0_sta_addr_r1:28;
    };
}h3ddma_cap0_wr_dma_num_bl_wrap_addr_r1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  cap0_sta_addr_r2:28;
    };
}h3ddma_cap0_wr_dma_num_bl_wrap_addr_r2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  cap0_sta_addr_r3:28;
    };
}h3ddma_cap0_wr_dma_num_bl_wrap_addr_r3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  cap0_line_step:28;
    };
}h3ddma_cap0_wr_dma_num_bl_wrap_line_step_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  cap0_burst_len:7;
        RBus_UInt32  res2:5;
        RBus_UInt32  cap0_line_num:12;
        RBus_UInt32  res3:4;
    };
}h3ddma_cap0_wr_dma_num_bl_wrap_ctl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap0_rolling_num:12;
        RBus_UInt32  res1:4;
        RBus_UInt32  cap0_rolling_space:12;
        RBus_UInt32  res2:3;
        RBus_UInt32  cap0_rolling_enable:1;
    };
}h3ddma_cap0_wr_dma_num_bl_wrap_rolling_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap0_line_burst_num:23;
        RBus_UInt32  res1:5;
        RBus_UInt32  cap0_addr_toggle_mode:2;
        RBus_UInt32  res2:2;
    };
}h3ddma_cap0_wr_dma_num_bl_wrap_word_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap0_remain_burst_num:23;
        RBus_UInt32  res1:5;
        RBus_UInt32  cap0_finish_status:2;
        RBus_UInt32  res2:1;
        RBus_UInt32  cap0_remain_setting:1;
    };
}h3ddma_cap0_wr_dma_num_bl_wrap_st1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  cap0_remain_line_num:12;
        RBus_UInt32  res2:3;
        RBus_UInt32  cap0_soft_rst_before_finish:1;
    };
}h3ddma_cap0_wr_dma_num_bl_wrap_st2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap0_pixel_encoding:2;
        RBus_UInt32  cap0_bit_sel:2;
        RBus_UInt32  res1:28;
    };
}h3ddma_cap0_wr_dma_pxltobus_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  cap0_sta_addr_db:29;
    };
}h3ddma_cap0_cap_l_start_db_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  cap0_sta_addr_r_db:29;
    };
}h3ddma_cap0_cap_r_start_db_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap0_cap_fifo_overflow:1;
        RBus_UInt32  cap0_cap_under_size:1;
        RBus_UInt32  cap0_cap_over_size:1;
        RBus_UInt32  cap0_cap_last_wr_flag:1;
        RBus_UInt32  cap0_cap_block_sel:2;
        RBus_UInt32  res1:2;
        RBus_UInt32  cap0_freeze_ok:1;
        RBus_UInt32  res2:23;
    };
}h3ddma_cap0_cap_status_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap1_frame_access_mode:1;
        RBus_UInt32  res1:21;
        RBus_UInt32  cap1_auto_block_sel_en:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  cap1_freeze_en:1;
        RBus_UInt32  res3:2;
        RBus_UInt32  cap1_quad_buf_en:1;
        RBus_UInt32  cap1_set_block_sel:1;
        RBus_UInt32  cap1_cap_block_fw:2;
        RBus_UInt32  cap1_triple_buf_en:1;
    };
}h3ddma_cap1_cap_ctl0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  cap1_dma_up_limit:28;
    };
}h3ddma_cap1_cti_dma_wr_rule_check_up_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  cap1_dma_low_limit:28;
    };
}h3ddma_cap1_cti_dma_wr_rule_check_low_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap1_dma_enable:1;
        RBus_UInt32  cap1_force_all_rst:1;
        RBus_UInt32  res1:6;
        RBus_UInt32  cap1_max_outstanding:2;
        RBus_UInt32  cap1_dma_1byte_swap:1;
        RBus_UInt32  cap1_dma_2byte_swap:1;
        RBus_UInt32  cap1_dma_4byte_swap:1;
        RBus_UInt32  cap1_dma_8byte_swap:1;
        RBus_UInt32  res2:18;
    };
}h3ddma_cap1_cti_dma_wr_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap1_zero_length_err:1;
        RBus_UInt32  cap1_exceed_range_err:1;
        RBus_UInt32  cap1_data_fifo_underflow_err:1;
        RBus_UInt32  cap1_soft_rst_with_data_left:1;
        RBus_UInt32  cap1_soft_rst_before_cmd_finish:1;
        RBus_UInt32  res1:3;
        RBus_UInt32  cap1_cur_outstanding:3;
        RBus_UInt32  res2:5;
        RBus_UInt32  cap1_dma_data_water:8;
        RBus_UInt32  res3:4;
        RBus_UInt32  cap1_dma_cmd_water:3;
        RBus_UInt32  res4:1;
    };
}h3ddma_cap1_cti_dma_wr_status_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap1_selected_bl:6;
        RBus_UInt32  res1:2;
        RBus_UInt32  cap1_last_ack_num:7;
        RBus_UInt32  res2:1;
        RBus_UInt32  cap1_target_ack_num:7;
        RBus_UInt32  res3:7;
        RBus_UInt32  cap1_last_no_ack_error:1;
        RBus_UInt32  cap1_ack_num_error:1;
    };
}h3ddma_cap1_cti_dma_wr_status1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap1_addr_bl_sel:2;
        RBus_UInt32  res1:3;
        RBus_UInt32  cap1_selected_addr:27;
    };
}h3ddma_cap1_cti_dma_wr_status2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap1_highest_water_level:8;
        RBus_UInt32  res1:8;
        RBus_UInt32  cap1_monitor_thd:8;
        RBus_UInt32  cap1_reach_thd:1;
        RBus_UInt32  res2:5;
        RBus_UInt32  cap1_monitor_conti:1;
        RBus_UInt32  cap1_monitor_en:1;
    };
}h3ddma_cap1_cti_dma_wr_water_monitor_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  cap1_sta_addr_0:28;
    };
}h3ddma_cap1_wr_dma_num_bl_wrap_addr_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  cap1_sta_addr_1:28;
    };
}h3ddma_cap1_wr_dma_num_bl_wrap_addr_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  cap1_sta_addr_2:28;
    };
}h3ddma_cap1_wr_dma_num_bl_wrap_addr_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  cap1_sta_addr_3:28;
    };
}h3ddma_cap1_wr_dma_num_bl_wrap_addr_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  cap1_sta_addr_r0:28;
    };
}h3ddma_cap1_wr_dma_num_bl_wrap_addr_r0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  cap1_sta_addr_r1:28;
    };
}h3ddma_cap1_wr_dma_num_bl_wrap_addr_r1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  cap1_sta_addr_r2:28;
    };
}h3ddma_cap1_wr_dma_num_bl_wrap_addr_r2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  cap1_sta_addr_r3:28;
    };
}h3ddma_cap1_wr_dma_num_bl_wrap_addr_r3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  cap1_line_step:28;
    };
}h3ddma_cap1_wr_dma_num_bl_wrap_line_step_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  cap1_burst_len:7;
        RBus_UInt32  res2:5;
        RBus_UInt32  cap1_line_num:12;
        RBus_UInt32  res3:4;
    };
}h3ddma_cap1_wr_dma_num_bl_wrap_ctl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap1_rolling_num:12;
        RBus_UInt32  res1:4;
        RBus_UInt32  cap1_rolling_space:12;
        RBus_UInt32  res2:3;
        RBus_UInt32  cap1_rolling_enable:1;
    };
}h3ddma_cap1_wr_dma_num_bl_wrap_rolling_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap1_line_burst_num:23;
        RBus_UInt32  res1:5;
        RBus_UInt32  cap1_addr_toggle_mode:2;
        RBus_UInt32  res2:2;
    };
}h3ddma_cap1_wr_dma_num_bl_wrap_word_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap1_remain_burst_num:23;
        RBus_UInt32  res1:5;
        RBus_UInt32  cap1_finish_status:2;
        RBus_UInt32  res2:1;
        RBus_UInt32  cap1_remain_setting:1;
    };
}h3ddma_cap1_wr_dma_num_bl_wrap_st1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  cap1_remain_line_num:12;
        RBus_UInt32  res2:3;
        RBus_UInt32  cap1_soft_rst_before_finish:1;
    };
}h3ddma_cap1_wr_dma_num_bl_wrap_st2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap1_pixel_encoding:2;
        RBus_UInt32  cap1_bit_sel:2;
        RBus_UInt32  res1:28;
    };
}h3ddma_cap1_wr_dma_pxltobus_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  cap1_sta_addr_db:29;
    };
}h3ddma_cap1_cap_l_start_db_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  cap1_sta_addr_r_db:29;
    };
}h3ddma_cap1_cap_r_start_db_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap1_cap_fifo_overflow:1;
        RBus_UInt32  cap1_cap_under_size:1;
        RBus_UInt32  cap1_cap_over_size:1;
        RBus_UInt32  cap1_cap_last_wr_flag:1;
        RBus_UInt32  cap1_cap_block_sel:2;
        RBus_UInt32  res1:2;
        RBus_UInt32  cap1_freeze_ok:1;
        RBus_UInt32  res2:23;
    };
}h3ddma_cap1_cap_status_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap2_frame_access_mode:1;
        RBus_UInt32  res1:21;
        RBus_UInt32  cap2_auto_block_sel_en:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  cap2_freeze_en:1;
        RBus_UInt32  res3:2;
        RBus_UInt32  cap2_quad_buf_en:1;
        RBus_UInt32  cap2_set_block_sel:1;
        RBus_UInt32  cap2_cap_block_fw:2;
        RBus_UInt32  cap2_triple_buf_en:1;
    };
}h3ddma_cap2_cap_ctl0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  cap2_dma_up_limit:28;
    };
}h3ddma_cap2_cti_dma_wr_rule_check_up_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  cap2_dma_low_limit:28;
    };
}h3ddma_cap2_cti_dma_wr_rule_check_low_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap2_dma_enable:1;
        RBus_UInt32  cap2_force_all_rst:1;
        RBus_UInt32  res1:6;
        RBus_UInt32  cap2_max_outstanding:2;
        RBus_UInt32  cap2_dma_1byte_swap:1;
        RBus_UInt32  cap2_dma_2byte_swap:1;
        RBus_UInt32  cap2_dma_4byte_swap:1;
        RBus_UInt32  cap2_dma_8byte_swap:1;
        RBus_UInt32  res2:18;
    };
}h3ddma_cap2_cti_dma_wr_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap2_zero_length_err:1;
        RBus_UInt32  cap2_exceed_range_err:1;
        RBus_UInt32  cap2_data_fifo_underflow_err:1;
        RBus_UInt32  cap2_soft_rst_with_data_left:1;
        RBus_UInt32  cap2_soft_rst_before_cmd_finish:1;
        RBus_UInt32  res1:3;
        RBus_UInt32  cap2_cur_outstanding:3;
        RBus_UInt32  res2:5;
        RBus_UInt32  cap2_dma_data_water:9;
        RBus_UInt32  res3:3;
        RBus_UInt32  cap2_dma_cmd_water:3;
        RBus_UInt32  res4:1;
    };
}h3ddma_cap2_cti_dma_wr_status_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap2_selected_bl:6;
        RBus_UInt32  res1:2;
        RBus_UInt32  cap2_last_ack_num:7;
        RBus_UInt32  res2:1;
        RBus_UInt32  cap2_target_ack_num:7;
        RBus_UInt32  res3:7;
        RBus_UInt32  cap2_last_no_ack_error:1;
        RBus_UInt32  cap2_ack_num_error:1;
    };
}h3ddma_cap2_cti_dma_wr_status1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap2_addr_bl_sel:2;
        RBus_UInt32  res1:3;
        RBus_UInt32  cap2_selected_addr:27;
    };
}h3ddma_cap2_cti_dma_wr_status2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap2_highest_water_level:9;
        RBus_UInt32  res1:6;
        RBus_UInt32  cap2_monitor_thd:9;
        RBus_UInt32  cap2_reach_thd:1;
        RBus_UInt32  res2:5;
        RBus_UInt32  cap2_monitor_conti:1;
        RBus_UInt32  cap2_monitor_en:1;
    };
}h3ddma_cap2_cti_dma_wr_water_monitor_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  cap2_sta_addr_0:28;
    };
}h3ddma_cap2_wr_dma_num_bl_wrap_addr_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  cap2_sta_addr_1:28;
    };
}h3ddma_cap2_wr_dma_num_bl_wrap_addr_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  cap2_sta_addr_2:28;
    };
}h3ddma_cap2_wr_dma_num_bl_wrap_addr_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  cap2_sta_addr_3:28;
    };
}h3ddma_cap2_wr_dma_num_bl_wrap_addr_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  cap2_sta_addr_r0:28;
    };
}h3ddma_cap2_wr_dma_num_bl_wrap_addr_r0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  cap2_sta_addr_r1:28;
    };
}h3ddma_cap2_wr_dma_num_bl_wrap_addr_r1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  cap2_sta_addr_r2:28;
    };
}h3ddma_cap2_wr_dma_num_bl_wrap_addr_r2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  cap2_sta_addr_r3:28;
    };
}h3ddma_cap2_wr_dma_num_bl_wrap_addr_r3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  cap2_line_step:28;
    };
}h3ddma_cap2_wr_dma_num_bl_wrap_line_step_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  cap2_burst_len:7;
        RBus_UInt32  res2:5;
        RBus_UInt32  cap2_line_num:12;
        RBus_UInt32  res3:4;
    };
}h3ddma_cap2_wr_dma_num_bl_wrap_ctl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap2_rolling_num:12;
        RBus_UInt32  res1:4;
        RBus_UInt32  cap2_rolling_space:12;
        RBus_UInt32  res2:3;
        RBus_UInt32  cap2_rolling_enable:1;
    };
}h3ddma_cap2_wr_dma_num_bl_wrap_rolling_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap2_line_burst_num:23;
        RBus_UInt32  res1:5;
        RBus_UInt32  cap2_addr_toggle_mode:2;
        RBus_UInt32  res2:2;
    };
}h3ddma_cap2_wr_dma_num_bl_wrap_word_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap2_remain_burst_num:23;
        RBus_UInt32  res1:5;
        RBus_UInt32  cap2_finish_status:2;
        RBus_UInt32  res2:1;
        RBus_UInt32  cap2_remain_setting:1;
    };
}h3ddma_cap2_wr_dma_num_bl_wrap_st1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  cap2_remain_line_num:12;
        RBus_UInt32  res2:3;
        RBus_UInt32  cap2_soft_rst_before_finish:1;
    };
}h3ddma_cap2_wr_dma_num_bl_wrap_st2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap2_pixel_encoding:2;
        RBus_UInt32  cap2_bit_sel:2;
        RBus_UInt32  res1:28;
    };
}h3ddma_cap2_wr_dma_pxltobus_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  cap2_sta_addr_db:29;
    };
}h3ddma_cap2_cap_l_start_db_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  cap2_sta_addr_r_db:29;
    };
}h3ddma_cap2_cap_r_start_db_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap2_cap_fifo_overflow:1;
        RBus_UInt32  cap2_cap_under_size:1;
        RBus_UInt32  cap2_cap_over_size:1;
        RBus_UInt32  cap2_cap_last_wr_flag:1;
        RBus_UInt32  cap2_cap_block_sel:2;
        RBus_UInt32  res1:2;
        RBus_UInt32  cap2_freeze_ok:1;
        RBus_UInt32  res2:23;
    };
}h3ddma_cap2_cap_status_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap3_frame_access_mode:1;
        RBus_UInt32  res1:21;
        RBus_UInt32  cap3_auto_block_sel_en:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  cap3_freeze_en:1;
        RBus_UInt32  res3:2;
        RBus_UInt32  cap3_quad_buf_en:1;
        RBus_UInt32  cap3_set_block_sel:1;
        RBus_UInt32  cap3_cap_block_fw:2;
        RBus_UInt32  cap3_triple_buf_en:1;
    };
}h3ddma_cap3_cap_ctl0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  cap3_dma_up_limit:28;
    };
}h3ddma_cap3_cti_dma_wr_rule_check_up_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  cap3_dma_low_limit:28;
    };
}h3ddma_cap3_cti_dma_wr_rule_check_low_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap3_dma_enable:1;
        RBus_UInt32  cap3_force_all_rst:1;
        RBus_UInt32  res1:6;
        RBus_UInt32  cap3_max_outstanding:2;
        RBus_UInt32  cap3_dma_1byte_swap:1;
        RBus_UInt32  cap3_dma_2byte_swap:1;
        RBus_UInt32  cap3_dma_4byte_swap:1;
        RBus_UInt32  cap3_dma_8byte_swap:1;
        RBus_UInt32  res2:18;
    };
}h3ddma_cap3_cti_dma_wr_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap3_zero_length_err:1;
        RBus_UInt32  cap3_exceed_range_err:1;
        RBus_UInt32  cap3_data_fifo_underflow_err:1;
        RBus_UInt32  cap3_soft_rst_with_data_left:1;
        RBus_UInt32  cap3_soft_rst_before_cmd_finish:1;
        RBus_UInt32  res1:3;
        RBus_UInt32  cap3_cur_outstanding:3;
        RBus_UInt32  res2:5;
        RBus_UInt32  cap3_dma_data_water:6;
        RBus_UInt32  res3:6;
        RBus_UInt32  cap3_dma_cmd_water:3;
        RBus_UInt32  res4:1;
    };
}h3ddma_cap3_cti_dma_wr_status_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap3_selected_bl:6;
        RBus_UInt32  res1:2;
        RBus_UInt32  cap3_last_ack_num:7;
        RBus_UInt32  res2:1;
        RBus_UInt32  cap3_target_ack_num:7;
        RBus_UInt32  res3:7;
        RBus_UInt32  cap3_last_no_ack_error:1;
        RBus_UInt32  cap3_ack_num_error:1;
    };
}h3ddma_cap3_cti_dma_wr_status1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap3_addr_bl_sel:2;
        RBus_UInt32  res1:3;
        RBus_UInt32  cap3_selected_addr:27;
    };
}h3ddma_cap3_cti_dma_wr_status2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap3_highest_water_level:6;
        RBus_UInt32  res1:12;
        RBus_UInt32  cap3_monitor_thd:6;
        RBus_UInt32  cap3_reach_thd:1;
        RBus_UInt32  res2:5;
        RBus_UInt32  cap3_monitor_conti:1;
        RBus_UInt32  cap3_monitor_en:1;
    };
}h3ddma_cap3_cti_dma_wr_water_monitor_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  cap3_sta_addr_0:28;
    };
}h3ddma_cap3_wr_dma_num_bl_wrap_addr_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  cap3_sta_addr_1:28;
    };
}h3ddma_cap3_wr_dma_num_bl_wrap_addr_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  cap3_sta_addr_2:28;
    };
}h3ddma_cap3_wr_dma_num_bl_wrap_addr_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  cap3_sta_addr_3:28;
    };
}h3ddma_cap3_wr_dma_num_bl_wrap_addr_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  cap3_sta_addr_r0:28;
    };
}h3ddma_cap3_wr_dma_num_bl_wrap_addr_r0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  cap3_sta_addr_r1:28;
    };
}h3ddma_cap3_wr_dma_num_bl_wrap_addr_r1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  cap3_sta_addr_r2:28;
    };
}h3ddma_cap3_wr_dma_num_bl_wrap_addr_r2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  cap3_sta_addr_r3:28;
    };
}h3ddma_cap3_wr_dma_num_bl_wrap_addr_r3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  cap3_line_step:28;
    };
}h3ddma_cap3_wr_dma_num_bl_wrap_line_step_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  cap3_burst_len:7;
        RBus_UInt32  res2:5;
        RBus_UInt32  cap3_line_num:12;
        RBus_UInt32  res3:4;
    };
}h3ddma_cap3_wr_dma_num_bl_wrap_ctl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap3_rolling_num:12;
        RBus_UInt32  res1:4;
        RBus_UInt32  cap3_rolling_space:12;
        RBus_UInt32  res2:3;
        RBus_UInt32  cap3_rolling_enable:1;
    };
}h3ddma_cap3_wr_dma_num_bl_wrap_rolling_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap3_line_burst_num:23;
        RBus_UInt32  res1:5;
        RBus_UInt32  cap3_addr_toggle_mode:2;
        RBus_UInt32  res2:2;
    };
}h3ddma_cap3_wr_dma_num_bl_wrap_word_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap3_remain_burst_num:23;
        RBus_UInt32  res1:5;
        RBus_UInt32  cap3_finish_status:2;
        RBus_UInt32  res2:1;
        RBus_UInt32  cap3_remain_setting:1;
    };
}h3ddma_cap3_wr_dma_num_bl_wrap_st1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  cap3_remain_line_num:12;
        RBus_UInt32  res2:3;
        RBus_UInt32  cap3_soft_rst_before_finish:1;
    };
}h3ddma_cap3_wr_dma_num_bl_wrap_st2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap3_pixel_encoding:2;
        RBus_UInt32  cap3_bit_sel:2;
        RBus_UInt32  res1:28;
    };
}h3ddma_cap3_wr_dma_pxltobus_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  cap3_sta_addr_db:29;
    };
}h3ddma_cap3_cap_l_start_db_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  cap3_sta_addr_r_db:29;
    };
}h3ddma_cap3_cap_r_start_db_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap3_cap_fifo_overflow:1;
        RBus_UInt32  cap3_cap_under_size:1;
        RBus_UInt32  cap3_cap_over_size:1;
        RBus_UInt32  cap3_cap_last_wr_flag:1;
        RBus_UInt32  cap3_cap_block_sel:2;
        RBus_UInt32  res1:2;
        RBus_UInt32  cap3_freeze_ok:1;
        RBus_UInt32  res2:23;
    };
}h3ddma_cap3_cap_status_RBUS;




#endif 


#endif 
