/**
* @file Mac7p-DesignSpec-I-Domain_BIST_BISR_control
* RBus systemc program.
*
* @author RS_MM2_SD
* @email jason9.ccc@realtek.com
 * @date 2019/11/22
* @ingroup model_rbus
 * @version { 1.0 }
 **
 */

#ifndef _RBUS_I_BIST_BISR_REG_H_
#define _RBUS_I_BIST_BISR_REG_H_

#include "rbusTypes.h"



//  I_BIST_BISR Register Address



#define  I_BIST_BISR_DISPI_BIST_MODE_VADDR                  	(0xb8025f00)
#define  I_BIST_BISR_DISPI_BIST_DONE_VADDR                  	(0xb8025f04)
#define  I_BIST_BISR_DISPI_BIST_FAIL_GROUP_VADDR            	(0xb8025f08)
#define  I_BIST_BISR_DISPI_DRF_MODE_VADDR                   	(0xb8025f0c)
#define  I_BIST_BISR_DISPI_DRF_RESUME_VADDR                 	(0xb8025f10)
#define  I_BIST_BISR_DISPI_DRF_DONE_VADDR                   	(0xb8025f14)
#define  I_BIST_BISR_DISPI_DRF_PAUSE_VADDR                  	(0xb8025f18)
#define  I_BIST_BISR_DISPI_DRF_FAIL_GROUP_VADDR             	(0xb8025f1c)
#define  I_BIST_BISR_DISPI_BISR_SECOND_RUN_EN_VADDR         	(0xb8025f20)
#define  I_BIST_BISR_DISPI_BISR_FAIL_GROUP_VADDR            	(0xb8025f24)
#define  I_BIST_BISR_DISPI_BISR_DRF_MODE_VADDR              	(0xb8025f28)
#define  I_BIST_BISR_DISPI_BISR_DRF_RESUME_VADDR            	(0xb8025f2c)
#define  I_BIST_BISR_DISPI_BISR_DRF_DONE_VADDR              	(0xb8025f30)
#define  I_BIST_BISR_DISPI_BISR_DRF_PAUSE_VADDR             	(0xb8025f34)
#define  I_BIST_BISR_DISPI_BISR_DRF_FAIL_GROUP_VADDR        	(0xb8025f38)
#define  I_BIST_BISR_DISPI_BIST_MODE_1_VADDR                	(0xb8025f40)
#define  I_BIST_BISR_DISPI_BIST_DONE_1_VADDR                	(0xb8025f44)
#define  I_BIST_BISR_DISPI_BIST_FAIL_GROUP_1_VADDR          	(0xb8025f48)
#define  I_BIST_BISR_DISPI_DRF_MODE_1_VADDR                 	(0xb8025f4c)
#define  I_BIST_BISR_DISPI_DRF_RESUME_1_VADDR               	(0xb8025f50)
#define  I_BIST_BISR_DISPI_DRF_DONE_1_VADDR                 	(0xb8025f54)
#define  I_BIST_BISR_DISPI_DRF_PAUSE_1_VADDR                	(0xb8025f58)
#define  I_BIST_BISR_DISPI_DRF_FAIL_GROUP_1_VADDR           	(0xb8025f5c)



#ifndef LITTLE_ENDIAN //apply BIG_ENDIAN

//======I_BIST_BISR register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  isnr_dma_wdat_bist_mode:1;
        RBus_UInt32  res1:2;
        RBus_UInt32  ch1_mbist_hist_1p_bist_mode:1;
        RBus_UInt32  ch1_mbist_hist_2p_bist_mode:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  res3:1;
        RBus_UInt32  di_li4_bist_mode:1;
        RBus_UInt32  di_hmc_bist_mode:1;
        RBus_UInt32  pqdc1_bist_mode:1;
        RBus_UInt32  pqdc2_bist_mode:1;
        RBus_UInt32  pqc1_bist_mode:1;
        RBus_UInt32  pqc2_bist_mode:1;
        RBus_UInt32  res4:4;
        RBus_UInt32  i3ddma_cap3_bist_mode:1;
        RBus_UInt32  i3ddma_cap2_bist_mode:1;
        RBus_UInt32  i3ddma_cap1_bist_mode:1;
        RBus_UInt32  i3ddma_cap0_bist_mode:1;
        RBus_UInt32  sdnr_ch1_bist_mode:1;
        RBus_UInt32  sdnr_ch2_bist_mode:1;
        RBus_UInt32  di_tr2to1_bist_mode:1;
        RBus_UInt32  i3ddma_pqc2_bist_mode:1;
        RBus_UInt32  di_dma_wdat_bist_mode:1;
        RBus_UInt32  di_dma_rdat_bist_mode:1;
        RBus_UInt32  di_li1_bist_mode:1;
        RBus_UInt32  di_li2_bist_mode:1;
        RBus_UInt32  di_li3_bist_mode:1;
        RBus_UInt32  i3ddma_uzd_bist_mode:1;
        RBus_UInt32  res5:1;
    };
}i_bist_bisr_dispi_bist_mode_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  isnr_dma_wdat_bist_done:1;
        RBus_UInt32  res1:2;
        RBus_UInt32  ch1_mbist_hist_1p_bist_done:1;
        RBus_UInt32  ch1_mbist_hist_2p_bist_done:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  res3:1;
        RBus_UInt32  di_li4_bist_done:1;
        RBus_UInt32  di_hmc_bist_done:1;
        RBus_UInt32  pqdc1_bist_done:1;
        RBus_UInt32  pqdc2_bist_done:1;
        RBus_UInt32  pqc1_bist_done:1;
        RBus_UInt32  pqc2_bist_done:1;
        RBus_UInt32  res4:4;
        RBus_UInt32  i3ddma_cap3_bist_done:1;
        RBus_UInt32  i3ddma_cap2_bist_done:1;
        RBus_UInt32  i3ddma_cap1_bist_done:1;
        RBus_UInt32  i3ddma_cap0_bist_done:1;
        RBus_UInt32  sdnr_ch1_bist_done:1;
        RBus_UInt32  sdnr_ch2_bist_done:1;
        RBus_UInt32  di_tr2to1_bist_done:1;
        RBus_UInt32  i3ddma_pqc2_bist_done:1;
        RBus_UInt32  di_dma_wdat_bist_done:1;
        RBus_UInt32  di_dma_rdat_bist_done:1;
        RBus_UInt32  di_li1_bist_done:1;
        RBus_UInt32  di_li2_bist_done:1;
        RBus_UInt32  di_li3_bist_done:1;
        RBus_UInt32  i3ddma_uzd_bist_done:1;
        RBus_UInt32  res5:1;
    };
}i_bist_bisr_dispi_bist_done_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  isnr_dma_wdat_bist_fail_group:1;
        RBus_UInt32  res1:2;
        RBus_UInt32  ch1_mbist_hist_1p_fail_group:1;
        RBus_UInt32  ch1_mbist_hist_2p_fail_group:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  res3:1;
        RBus_UInt32  di_li4_bist_fail_group:1;
        RBus_UInt32  di_hmc_bist_fail_group:1;
        RBus_UInt32  pqdc1_bist_fail_group:1;
        RBus_UInt32  pqdc2_bist_fail_group:1;
        RBus_UInt32  pqc1_bist_fail_group:1;
        RBus_UInt32  pqc2_bist_fail_group:1;
        RBus_UInt32  res4:4;
        RBus_UInt32  i3ddma_cap3_bist_fail_group:1;
        RBus_UInt32  i3ddma_cap2_bist_fail_group:1;
        RBus_UInt32  i3ddma_cap1_bist_fail_group:1;
        RBus_UInt32  i3ddma_cap0_bist_fail_group:1;
        RBus_UInt32  sdnr_ch1_bist_fail_group:1;
        RBus_UInt32  sdnr_ch2_bist_fail_group:1;
        RBus_UInt32  di_tr2to1_bist_fail_group:1;
        RBus_UInt32  i3ddma_pqc2_bist_fail_group:1;
        RBus_UInt32  di_dma_wdat_bist_fail_group:1;
        RBus_UInt32  di_dma_rdat_bist_fail_group:1;
        RBus_UInt32  di_li1_bist_fail_group:1;
        RBus_UInt32  di_li2_bist_fail_group:1;
        RBus_UInt32  di_li3_bist_fail_group:1;
        RBus_UInt32  i3ddma_uzd_bist_fail_group:1;
        RBus_UInt32  res5:1;
    };
}i_bist_bisr_dispi_bist_fail_group_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  isnr_dma_wdat_drf_mode:1;
        RBus_UInt32  res1:2;
        RBus_UInt32  ch1_mbist_hist_1p_drf_mode:1;
        RBus_UInt32  ch1_mbist_hist_2p_drf_mode:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  res3:1;
        RBus_UInt32  di_li4_drf_mode:1;
        RBus_UInt32  di_hmc_drf_mode:1;
        RBus_UInt32  pqdc1_drf_mode:1;
        RBus_UInt32  pqdc2_drf_mode:1;
        RBus_UInt32  pqc1_drf_mode:1;
        RBus_UInt32  pqc2_drf_mode:1;
        RBus_UInt32  res4:4;
        RBus_UInt32  i3ddma_cap3_drf_mode:1;
        RBus_UInt32  i3ddma_cap2_drf_mode:1;
        RBus_UInt32  i3ddma_cap1_drf_mode:1;
        RBus_UInt32  i3ddma_cap0_drf_mode:1;
        RBus_UInt32  sdnr_ch1_drf_mode:1;
        RBus_UInt32  sdnr_ch2_drf_mode:1;
        RBus_UInt32  di_tr2to1_drf_mode:1;
        RBus_UInt32  i3ddma_pqc2_drf_mode:1;
        RBus_UInt32  di_dma_wdat_drf_mode:1;
        RBus_UInt32  di_dma_rdat_drf_mode:1;
        RBus_UInt32  di_li1_drf_mode:1;
        RBus_UInt32  di_li2_drf_mode:1;
        RBus_UInt32  di_li3_drf_mode:1;
        RBus_UInt32  i3ddma_uzd_drf_mode:1;
        RBus_UInt32  res5:1;
    };
}i_bist_bisr_dispi_drf_mode_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  isnr_dma_wdat_drf_resume:1;
        RBus_UInt32  res1:2;
        RBus_UInt32  ch1_mbist_hist_1p_drf_resume:1;
        RBus_UInt32  ch1_mbist_hist_2p_drf_resume:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  res3:1;
        RBus_UInt32  di_li4_drf_resume:1;
        RBus_UInt32  di_hmc_drf_resume:1;
        RBus_UInt32  pqdc1_drf_resume:1;
        RBus_UInt32  pqdc2_drf_resume:1;
        RBus_UInt32  pqc1_drf_resume:1;
        RBus_UInt32  pqc2_drf_resume:1;
        RBus_UInt32  res4:4;
        RBus_UInt32  i3ddma_cap3_drf_resume:1;
        RBus_UInt32  i3ddma_cap2_drf_resume:1;
        RBus_UInt32  i3ddma_cap1_drf_resume:1;
        RBus_UInt32  i3ddma_cap0_drf_resume:1;
        RBus_UInt32  sdnr_ch1_drf_resume:1;
        RBus_UInt32  sdnr_ch2_drf_resume:1;
        RBus_UInt32  di_tr2to1_drf_resume:1;
        RBus_UInt32  i3ddma_pqc2_drf_resume:1;
        RBus_UInt32  di_dma_wdat_drf_resume:1;
        RBus_UInt32  di_dma_rdat_drf_resume:1;
        RBus_UInt32  di_li1_drf_resume:1;
        RBus_UInt32  di_li2_drf_resume:1;
        RBus_UInt32  di_li3_drf_resume:1;
        RBus_UInt32  i3ddma_uzd_drf_resume:1;
        RBus_UInt32  res5:1;
    };
}i_bist_bisr_dispi_drf_resume_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  isnr_dma_wdat_drf_done:1;
        RBus_UInt32  res1:2;
        RBus_UInt32  ch1_mbist_hist_1p_drf_done:1;
        RBus_UInt32  ch1_mbist_hist_2p_drf_done:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  res3:1;
        RBus_UInt32  di_li4_drf_done:1;
        RBus_UInt32  di_hmc_drf_done:1;
        RBus_UInt32  pqdc1_drf_done:1;
        RBus_UInt32  pqdc2_drf_done:1;
        RBus_UInt32  pqc1_drf_done:1;
        RBus_UInt32  pqc2_drf_done:1;
        RBus_UInt32  res4:4;
        RBus_UInt32  i3ddma_cap3_drf_done:1;
        RBus_UInt32  i3ddma_cap2_drf_done:1;
        RBus_UInt32  i3ddma_cap1_drf_done:1;
        RBus_UInt32  i3ddma_cap0_drf_done:1;
        RBus_UInt32  sdnr_ch1_drf_done:1;
        RBus_UInt32  sdnr_ch2_drf_done:1;
        RBus_UInt32  di_tr2to1_drf_done:1;
        RBus_UInt32  i3ddma_pqc2_drf_done:1;
        RBus_UInt32  di_dma_wdat_drf_done:1;
        RBus_UInt32  di_dma_rdat_drf_done:1;
        RBus_UInt32  di_li1_drf_done:1;
        RBus_UInt32  di_li2_drf_done:1;
        RBus_UInt32  di_li3_drf_done:1;
        RBus_UInt32  i3ddma_uzd_drf_done:1;
        RBus_UInt32  res5:1;
    };
}i_bist_bisr_dispi_drf_done_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  isnr_dma_wdat_drf_pause:1;
        RBus_UInt32  res1:2;
        RBus_UInt32  ch1_mbist_hist_1p_drf_pause:1;
        RBus_UInt32  ch1_mbist_hist_2p_drf_pause:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  res3:1;
        RBus_UInt32  di_li4_drf_pause:1;
        RBus_UInt32  di_hmc_drf_pause:1;
        RBus_UInt32  pqdc1_drf_pause:1;
        RBus_UInt32  pqdc2_drf_pause:1;
        RBus_UInt32  pqc1_drf_pause:1;
        RBus_UInt32  pqc2_drf_pause:1;
        RBus_UInt32  res4:4;
        RBus_UInt32  i3ddma_cap3_drf_pause:1;
        RBus_UInt32  i3ddma_cap2_drf_pause:1;
        RBus_UInt32  i3ddma_cap1_drf_pause:1;
        RBus_UInt32  i3ddma_cap0_drf_pause:1;
        RBus_UInt32  sdnr_ch1_drf_pause:1;
        RBus_UInt32  sdnr_ch2_drf_pause:1;
        RBus_UInt32  di_tr2to1_drf_pause:1;
        RBus_UInt32  i3ddma_pqc2_drf_pause:1;
        RBus_UInt32  di_dma_wdat_drf_pause:1;
        RBus_UInt32  di_dma_rdat_drf_pause:1;
        RBus_UInt32  di_li1_drf_pause:1;
        RBus_UInt32  di_li2_drf_pause:1;
        RBus_UInt32  di_li3_drf_pause:1;
        RBus_UInt32  i3ddma_uzd_drf_pause:1;
        RBus_UInt32  res5:1;
    };
}i_bist_bisr_dispi_drf_pause_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  isnr_dma_wdat_drf_fail_group:1;
        RBus_UInt32  res1:2;
        RBus_UInt32  ch1_mbist_hist_1p_drf_fail_group:1;
        RBus_UInt32  ch1_mbist_hist_2p_drf_fail_group:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  res3:1;
        RBus_UInt32  di_li4_drf_fail_group:1;
        RBus_UInt32  di_hmc_drf_fail_group:1;
        RBus_UInt32  pqdc1_drf_fail_group:1;
        RBus_UInt32  pqdc2_drf_fail_group:1;
        RBus_UInt32  pqc1_drf_fail_group:1;
        RBus_UInt32  pqc2_drf_fail_group:1;
        RBus_UInt32  res4:4;
        RBus_UInt32  i3ddma_cap3_drf_fail_group:1;
        RBus_UInt32  i3ddma_cap2_drf_fail_group:1;
        RBus_UInt32  i3ddma_cap1_drf_fail_group:1;
        RBus_UInt32  i3ddma_cap0_drf_fail_group:1;
        RBus_UInt32  sdnr_ch1_drf_fail_group:1;
        RBus_UInt32  sdnr_ch2_drf_fail_group:1;
        RBus_UInt32  di_tr2to1_drf_fail_group:1;
        RBus_UInt32  i3ddma_pqc2_drf_fail_group:1;
        RBus_UInt32  di_dma_wdat_drf_fail_group:1;
        RBus_UInt32  di_dma_rdat_drf_fail_group:1;
        RBus_UInt32  di_li1_drf_fail_group:1;
        RBus_UInt32  di_li2_drf_fail_group:1;
        RBus_UInt32  di_li3_drf_fail_group:1;
        RBus_UInt32  i3ddma_uzd_drf_fail_group:1;
        RBus_UInt32  res5:1;
    };
}i_bist_bisr_dispi_drf_fail_group_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:31;
        RBus_UInt32  spnr_bisr_second_run_en:1;
    };
}i_bist_bisr_dispi_bisr_second_run_en_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:31;
        RBus_UInt32  spnr_bisr_fail_group:1;
    };
}i_bist_bisr_dispi_bisr_fail_group_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:31;
        RBus_UInt32  spnr_bisr_drf_mode:1;
    };
}i_bist_bisr_dispi_bisr_drf_mode_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:31;
        RBus_UInt32  spnr_bisr_drf_resume:1;
    };
}i_bist_bisr_dispi_bisr_drf_resume_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:31;
        RBus_UInt32  spnr_bisr_drf_done:1;
    };
}i_bist_bisr_dispi_bisr_drf_done_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:31;
        RBus_UInt32  spnr_bisr_drf_pause:1;
    };
}i_bist_bisr_dispi_bisr_drf_pause_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:31;
        RBus_UInt32  spnr_bisr_drf_fail_group:1;
    };
}i_bist_bisr_dispi_bisr_drf_fail_group_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:29;
        RBus_UInt32  mvf_rinfo_bist_mode:1;
        RBus_UInt32  mvf_rdat_bist_mode:1;
        RBus_UInt32  mpegnr_vdeblk_bist_mode:1;
    };
}i_bist_bisr_dispi_bist_mode_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:29;
        RBus_UInt32  mvf_rinfo_bist_done:1;
        RBus_UInt32  mvf_rdat_bist_done:1;
        RBus_UInt32  mpegnr_vdeblk_bist_done:1;
    };
}i_bist_bisr_dispi_bist_done_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:29;
        RBus_UInt32  mvf_rinfo_bist_fail_group:1;
        RBus_UInt32  mvf_rdat_bist_fail_group:1;
        RBus_UInt32  mpegnr_vdeblk_bist_fail_group:1;
    };
}i_bist_bisr_dispi_bist_fail_group_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:29;
        RBus_UInt32  mvf_rinfo_drf_mode:1;
        RBus_UInt32  mvf_rdat_drf_mode:1;
        RBus_UInt32  mpegnr_vdeblk_drf_mode:1;
    };
}i_bist_bisr_dispi_drf_mode_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:29;
        RBus_UInt32  mvf_rinfo_drf_resume:1;
        RBus_UInt32  mvf_rdat_drf_resume:1;
        RBus_UInt32  mpegnr_vdeblk_drf_resume:1;
    };
}i_bist_bisr_dispi_drf_resume_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:29;
        RBus_UInt32  mvf_rinfo_drf_done:1;
        RBus_UInt32  mvf_rdat_drf_done:1;
        RBus_UInt32  mpegnr_vdeblk_drf_done:1;
    };
}i_bist_bisr_dispi_drf_done_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:29;
        RBus_UInt32  mvf_rinfo_drf_pause:1;
        RBus_UInt32  mvf_rdat_drf_pause:1;
        RBus_UInt32  mpegnr_vdeblk_drf_pause:1;
    };
}i_bist_bisr_dispi_drf_pause_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:29;
        RBus_UInt32  mvf_rinfo_drf_fail_group:1;
        RBus_UInt32  mvf_rdat_drf_fail_group:1;
        RBus_UInt32  mpegnr_vdeblk_drf_fail_group:1;
    };
}i_bist_bisr_dispi_drf_fail_group_1_RBUS;

#else //apply LITTLE_ENDIAN

//======I_BIST_BISR register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:1;
        RBus_UInt32  i3ddma_uzd_bist_mode:1;
        RBus_UInt32  di_li3_bist_mode:1;
        RBus_UInt32  di_li2_bist_mode:1;
        RBus_UInt32  di_li1_bist_mode:1;
        RBus_UInt32  di_dma_rdat_bist_mode:1;
        RBus_UInt32  di_dma_wdat_bist_mode:1;
        RBus_UInt32  i3ddma_pqc2_bist_mode:1;
        RBus_UInt32  di_tr2to1_bist_mode:1;
        RBus_UInt32  sdnr_ch2_bist_mode:1;
        RBus_UInt32  sdnr_ch1_bist_mode:1;
        RBus_UInt32  i3ddma_cap0_bist_mode:1;
        RBus_UInt32  i3ddma_cap1_bist_mode:1;
        RBus_UInt32  i3ddma_cap2_bist_mode:1;
        RBus_UInt32  i3ddma_cap3_bist_mode:1;
        RBus_UInt32  res2:4;
        RBus_UInt32  pqc2_bist_mode:1;
        RBus_UInt32  pqc1_bist_mode:1;
        RBus_UInt32  pqdc2_bist_mode:1;
        RBus_UInt32  pqdc1_bist_mode:1;
        RBus_UInt32  di_hmc_bist_mode:1;
        RBus_UInt32  di_li4_bist_mode:1;
        RBus_UInt32  res3:1;
        RBus_UInt32  res4:1;
        RBus_UInt32  ch1_mbist_hist_2p_bist_mode:1;
        RBus_UInt32  ch1_mbist_hist_1p_bist_mode:1;
        RBus_UInt32  res5:2;
        RBus_UInt32  isnr_dma_wdat_bist_mode:1;
    };
}i_bist_bisr_dispi_bist_mode_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:1;
        RBus_UInt32  i3ddma_uzd_bist_done:1;
        RBus_UInt32  di_li3_bist_done:1;
        RBus_UInt32  di_li2_bist_done:1;
        RBus_UInt32  di_li1_bist_done:1;
        RBus_UInt32  di_dma_rdat_bist_done:1;
        RBus_UInt32  di_dma_wdat_bist_done:1;
        RBus_UInt32  i3ddma_pqc2_bist_done:1;
        RBus_UInt32  di_tr2to1_bist_done:1;
        RBus_UInt32  sdnr_ch2_bist_done:1;
        RBus_UInt32  sdnr_ch1_bist_done:1;
        RBus_UInt32  i3ddma_cap0_bist_done:1;
        RBus_UInt32  i3ddma_cap1_bist_done:1;
        RBus_UInt32  i3ddma_cap2_bist_done:1;
        RBus_UInt32  i3ddma_cap3_bist_done:1;
        RBus_UInt32  res2:4;
        RBus_UInt32  pqc2_bist_done:1;
        RBus_UInt32  pqc1_bist_done:1;
        RBus_UInt32  pqdc2_bist_done:1;
        RBus_UInt32  pqdc1_bist_done:1;
        RBus_UInt32  di_hmc_bist_done:1;
        RBus_UInt32  di_li4_bist_done:1;
        RBus_UInt32  res3:1;
        RBus_UInt32  res4:1;
        RBus_UInt32  ch1_mbist_hist_2p_bist_done:1;
        RBus_UInt32  ch1_mbist_hist_1p_bist_done:1;
        RBus_UInt32  res5:2;
        RBus_UInt32  isnr_dma_wdat_bist_done:1;
    };
}i_bist_bisr_dispi_bist_done_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:1;
        RBus_UInt32  i3ddma_uzd_bist_fail_group:1;
        RBus_UInt32  di_li3_bist_fail_group:1;
        RBus_UInt32  di_li2_bist_fail_group:1;
        RBus_UInt32  di_li1_bist_fail_group:1;
        RBus_UInt32  di_dma_rdat_bist_fail_group:1;
        RBus_UInt32  di_dma_wdat_bist_fail_group:1;
        RBus_UInt32  i3ddma_pqc2_bist_fail_group:1;
        RBus_UInt32  di_tr2to1_bist_fail_group:1;
        RBus_UInt32  sdnr_ch2_bist_fail_group:1;
        RBus_UInt32  sdnr_ch1_bist_fail_group:1;
        RBus_UInt32  i3ddma_cap0_bist_fail_group:1;
        RBus_UInt32  i3ddma_cap1_bist_fail_group:1;
        RBus_UInt32  i3ddma_cap2_bist_fail_group:1;
        RBus_UInt32  i3ddma_cap3_bist_fail_group:1;
        RBus_UInt32  res2:4;
        RBus_UInt32  pqc2_bist_fail_group:1;
        RBus_UInt32  pqc1_bist_fail_group:1;
        RBus_UInt32  pqdc2_bist_fail_group:1;
        RBus_UInt32  pqdc1_bist_fail_group:1;
        RBus_UInt32  di_hmc_bist_fail_group:1;
        RBus_UInt32  di_li4_bist_fail_group:1;
        RBus_UInt32  res3:1;
        RBus_UInt32  res4:1;
        RBus_UInt32  ch1_mbist_hist_2p_fail_group:1;
        RBus_UInt32  ch1_mbist_hist_1p_fail_group:1;
        RBus_UInt32  res5:2;
        RBus_UInt32  isnr_dma_wdat_bist_fail_group:1;
    };
}i_bist_bisr_dispi_bist_fail_group_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:1;
        RBus_UInt32  i3ddma_uzd_drf_mode:1;
        RBus_UInt32  di_li3_drf_mode:1;
        RBus_UInt32  di_li2_drf_mode:1;
        RBus_UInt32  di_li1_drf_mode:1;
        RBus_UInt32  di_dma_rdat_drf_mode:1;
        RBus_UInt32  di_dma_wdat_drf_mode:1;
        RBus_UInt32  i3ddma_pqc2_drf_mode:1;
        RBus_UInt32  di_tr2to1_drf_mode:1;
        RBus_UInt32  sdnr_ch2_drf_mode:1;
        RBus_UInt32  sdnr_ch1_drf_mode:1;
        RBus_UInt32  i3ddma_cap0_drf_mode:1;
        RBus_UInt32  i3ddma_cap1_drf_mode:1;
        RBus_UInt32  i3ddma_cap2_drf_mode:1;
        RBus_UInt32  i3ddma_cap3_drf_mode:1;
        RBus_UInt32  res2:4;
        RBus_UInt32  pqc2_drf_mode:1;
        RBus_UInt32  pqc1_drf_mode:1;
        RBus_UInt32  pqdc2_drf_mode:1;
        RBus_UInt32  pqdc1_drf_mode:1;
        RBus_UInt32  di_hmc_drf_mode:1;
        RBus_UInt32  di_li4_drf_mode:1;
        RBus_UInt32  res3:1;
        RBus_UInt32  res4:1;
        RBus_UInt32  ch1_mbist_hist_2p_drf_mode:1;
        RBus_UInt32  ch1_mbist_hist_1p_drf_mode:1;
        RBus_UInt32  res5:2;
        RBus_UInt32  isnr_dma_wdat_drf_mode:1;
    };
}i_bist_bisr_dispi_drf_mode_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:1;
        RBus_UInt32  i3ddma_uzd_drf_resume:1;
        RBus_UInt32  di_li3_drf_resume:1;
        RBus_UInt32  di_li2_drf_resume:1;
        RBus_UInt32  di_li1_drf_resume:1;
        RBus_UInt32  di_dma_rdat_drf_resume:1;
        RBus_UInt32  di_dma_wdat_drf_resume:1;
        RBus_UInt32  i3ddma_pqc2_drf_resume:1;
        RBus_UInt32  di_tr2to1_drf_resume:1;
        RBus_UInt32  sdnr_ch2_drf_resume:1;
        RBus_UInt32  sdnr_ch1_drf_resume:1;
        RBus_UInt32  i3ddma_cap0_drf_resume:1;
        RBus_UInt32  i3ddma_cap1_drf_resume:1;
        RBus_UInt32  i3ddma_cap2_drf_resume:1;
        RBus_UInt32  i3ddma_cap3_drf_resume:1;
        RBus_UInt32  res2:4;
        RBus_UInt32  pqc2_drf_resume:1;
        RBus_UInt32  pqc1_drf_resume:1;
        RBus_UInt32  pqdc2_drf_resume:1;
        RBus_UInt32  pqdc1_drf_resume:1;
        RBus_UInt32  di_hmc_drf_resume:1;
        RBus_UInt32  di_li4_drf_resume:1;
        RBus_UInt32  res3:1;
        RBus_UInt32  res4:1;
        RBus_UInt32  ch1_mbist_hist_2p_drf_resume:1;
        RBus_UInt32  ch1_mbist_hist_1p_drf_resume:1;
        RBus_UInt32  res5:2;
        RBus_UInt32  isnr_dma_wdat_drf_resume:1;
    };
}i_bist_bisr_dispi_drf_resume_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:1;
        RBus_UInt32  i3ddma_uzd_drf_done:1;
        RBus_UInt32  di_li3_drf_done:1;
        RBus_UInt32  di_li2_drf_done:1;
        RBus_UInt32  di_li1_drf_done:1;
        RBus_UInt32  di_dma_rdat_drf_done:1;
        RBus_UInt32  di_dma_wdat_drf_done:1;
        RBus_UInt32  i3ddma_pqc2_drf_done:1;
        RBus_UInt32  di_tr2to1_drf_done:1;
        RBus_UInt32  sdnr_ch2_drf_done:1;
        RBus_UInt32  sdnr_ch1_drf_done:1;
        RBus_UInt32  i3ddma_cap0_drf_done:1;
        RBus_UInt32  i3ddma_cap1_drf_done:1;
        RBus_UInt32  i3ddma_cap2_drf_done:1;
        RBus_UInt32  i3ddma_cap3_drf_done:1;
        RBus_UInt32  res2:4;
        RBus_UInt32  pqc2_drf_done:1;
        RBus_UInt32  pqc1_drf_done:1;
        RBus_UInt32  pqdc2_drf_done:1;
        RBus_UInt32  pqdc1_drf_done:1;
        RBus_UInt32  di_hmc_drf_done:1;
        RBus_UInt32  di_li4_drf_done:1;
        RBus_UInt32  res3:1;
        RBus_UInt32  res4:1;
        RBus_UInt32  ch1_mbist_hist_2p_drf_done:1;
        RBus_UInt32  ch1_mbist_hist_1p_drf_done:1;
        RBus_UInt32  res5:2;
        RBus_UInt32  isnr_dma_wdat_drf_done:1;
    };
}i_bist_bisr_dispi_drf_done_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:1;
        RBus_UInt32  i3ddma_uzd_drf_pause:1;
        RBus_UInt32  di_li3_drf_pause:1;
        RBus_UInt32  di_li2_drf_pause:1;
        RBus_UInt32  di_li1_drf_pause:1;
        RBus_UInt32  di_dma_rdat_drf_pause:1;
        RBus_UInt32  di_dma_wdat_drf_pause:1;
        RBus_UInt32  i3ddma_pqc2_drf_pause:1;
        RBus_UInt32  di_tr2to1_drf_pause:1;
        RBus_UInt32  sdnr_ch2_drf_pause:1;
        RBus_UInt32  sdnr_ch1_drf_pause:1;
        RBus_UInt32  i3ddma_cap0_drf_pause:1;
        RBus_UInt32  i3ddma_cap1_drf_pause:1;
        RBus_UInt32  i3ddma_cap2_drf_pause:1;
        RBus_UInt32  i3ddma_cap3_drf_pause:1;
        RBus_UInt32  res2:4;
        RBus_UInt32  pqc2_drf_pause:1;
        RBus_UInt32  pqc1_drf_pause:1;
        RBus_UInt32  pqdc2_drf_pause:1;
        RBus_UInt32  pqdc1_drf_pause:1;
        RBus_UInt32  di_hmc_drf_pause:1;
        RBus_UInt32  di_li4_drf_pause:1;
        RBus_UInt32  res3:1;
        RBus_UInt32  res4:1;
        RBus_UInt32  ch1_mbist_hist_2p_drf_pause:1;
        RBus_UInt32  ch1_mbist_hist_1p_drf_pause:1;
        RBus_UInt32  res5:2;
        RBus_UInt32  isnr_dma_wdat_drf_pause:1;
    };
}i_bist_bisr_dispi_drf_pause_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:1;
        RBus_UInt32  i3ddma_uzd_drf_fail_group:1;
        RBus_UInt32  di_li3_drf_fail_group:1;
        RBus_UInt32  di_li2_drf_fail_group:1;
        RBus_UInt32  di_li1_drf_fail_group:1;
        RBus_UInt32  di_dma_rdat_drf_fail_group:1;
        RBus_UInt32  di_dma_wdat_drf_fail_group:1;
        RBus_UInt32  i3ddma_pqc2_drf_fail_group:1;
        RBus_UInt32  di_tr2to1_drf_fail_group:1;
        RBus_UInt32  sdnr_ch2_drf_fail_group:1;
        RBus_UInt32  sdnr_ch1_drf_fail_group:1;
        RBus_UInt32  i3ddma_cap0_drf_fail_group:1;
        RBus_UInt32  i3ddma_cap1_drf_fail_group:1;
        RBus_UInt32  i3ddma_cap2_drf_fail_group:1;
        RBus_UInt32  i3ddma_cap3_drf_fail_group:1;
        RBus_UInt32  res2:4;
        RBus_UInt32  pqc2_drf_fail_group:1;
        RBus_UInt32  pqc1_drf_fail_group:1;
        RBus_UInt32  pqdc2_drf_fail_group:1;
        RBus_UInt32  pqdc1_drf_fail_group:1;
        RBus_UInt32  di_hmc_drf_fail_group:1;
        RBus_UInt32  di_li4_drf_fail_group:1;
        RBus_UInt32  res3:1;
        RBus_UInt32  res4:1;
        RBus_UInt32  ch1_mbist_hist_2p_drf_fail_group:1;
        RBus_UInt32  ch1_mbist_hist_1p_drf_fail_group:1;
        RBus_UInt32  res5:2;
        RBus_UInt32  isnr_dma_wdat_drf_fail_group:1;
    };
}i_bist_bisr_dispi_drf_fail_group_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  spnr_bisr_second_run_en:1;
        RBus_UInt32  res1:31;
    };
}i_bist_bisr_dispi_bisr_second_run_en_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  spnr_bisr_fail_group:1;
        RBus_UInt32  res1:31;
    };
}i_bist_bisr_dispi_bisr_fail_group_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  spnr_bisr_drf_mode:1;
        RBus_UInt32  res1:31;
    };
}i_bist_bisr_dispi_bisr_drf_mode_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  spnr_bisr_drf_resume:1;
        RBus_UInt32  res1:31;
    };
}i_bist_bisr_dispi_bisr_drf_resume_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  spnr_bisr_drf_done:1;
        RBus_UInt32  res1:31;
    };
}i_bist_bisr_dispi_bisr_drf_done_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  spnr_bisr_drf_pause:1;
        RBus_UInt32  res1:31;
    };
}i_bist_bisr_dispi_bisr_drf_pause_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  spnr_bisr_drf_fail_group:1;
        RBus_UInt32  res1:31;
    };
}i_bist_bisr_dispi_bisr_drf_fail_group_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mpegnr_vdeblk_bist_mode:1;
        RBus_UInt32  mvf_rdat_bist_mode:1;
        RBus_UInt32  mvf_rinfo_bist_mode:1;
        RBus_UInt32  res1:29;
    };
}i_bist_bisr_dispi_bist_mode_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mpegnr_vdeblk_bist_done:1;
        RBus_UInt32  mvf_rdat_bist_done:1;
        RBus_UInt32  mvf_rinfo_bist_done:1;
        RBus_UInt32  res1:29;
    };
}i_bist_bisr_dispi_bist_done_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mpegnr_vdeblk_bist_fail_group:1;
        RBus_UInt32  mvf_rdat_bist_fail_group:1;
        RBus_UInt32  mvf_rinfo_bist_fail_group:1;
        RBus_UInt32  res1:29;
    };
}i_bist_bisr_dispi_bist_fail_group_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mpegnr_vdeblk_drf_mode:1;
        RBus_UInt32  mvf_rdat_drf_mode:1;
        RBus_UInt32  mvf_rinfo_drf_mode:1;
        RBus_UInt32  res1:29;
    };
}i_bist_bisr_dispi_drf_mode_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mpegnr_vdeblk_drf_resume:1;
        RBus_UInt32  mvf_rdat_drf_resume:1;
        RBus_UInt32  mvf_rinfo_drf_resume:1;
        RBus_UInt32  res1:29;
    };
}i_bist_bisr_dispi_drf_resume_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mpegnr_vdeblk_drf_done:1;
        RBus_UInt32  mvf_rdat_drf_done:1;
        RBus_UInt32  mvf_rinfo_drf_done:1;
        RBus_UInt32  res1:29;
    };
}i_bist_bisr_dispi_drf_done_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mpegnr_vdeblk_drf_pause:1;
        RBus_UInt32  mvf_rdat_drf_pause:1;
        RBus_UInt32  mvf_rinfo_drf_pause:1;
        RBus_UInt32  res1:29;
    };
}i_bist_bisr_dispi_drf_pause_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mpegnr_vdeblk_drf_fail_group:1;
        RBus_UInt32  mvf_rdat_drf_fail_group:1;
        RBus_UInt32  mvf_rinfo_drf_fail_group:1;
        RBus_UInt32  res1:29;
    };
}i_bist_bisr_dispi_drf_fail_group_1_RBUS;




#endif 


#endif 
