/**
* @file Mac7p-DesignSpec-I-Domain-Decontour
* RBus systemc program.
*
* @author RS_MM2_SD
* @email jason9.ccc@realtek.com
 * @date 2019/11/22
* @ingroup model_rbus
 * @version { 1.0 }
 **
 */

#ifndef _RBUS_IPQ_DECONTOUR_REG_H_
#define _RBUS_IPQ_DECONTOUR_REG_H_

#include "rbusTypes.h"



//  IPQ_DECONTOUR Register Address



#define  IPQ_DECONTOUR_DE_CONTOUR_CTRL_VADDR                	(0xb8025700)
#define  IPQ_DECONTOUR_DE_CONTOUR_CONTRAST_Y_VADDR          	(0xb8025704)
#define  IPQ_DECONTOUR_DE_CONTOUR_CONTRAST_C_VADDR          	(0xb8025708)
#define  IPQ_DECONTOUR_DE_CONTOUR_CONTRAST_VADDR            	(0xb802570c)
#define  IPQ_DECONTOUR_DE_CONTOUR_NEIGHBOR_DIFF_VADDR       	(0xb8025710)
#define  IPQ_DECONTOUR_DE_CONTOUR_THRESHOLD_VADDR           	(0xb8025714)
#define  IPQ_DECONTOUR_DE_CONTOUR_DIFF_TH_VADDR             	(0xb8025718)
#define  IPQ_DECONTOUR_DE_CONTOUR_COUNTER_VADDR             	(0xb802571c)
#define  IPQ_DECONTOUR_DE_CONTOUR_AVFILTER_COUNTER_VADDR    	(0xb8025720)
#define  IPQ_DECONTOUR_DE_CONTOUR_HIST_CTRL_VADDR           	(0xb8025724)
#define  IPQ_DECONTOUR_DE_CONTOUR_HIST_DATA_VADDR           	(0xb8025728)
#define  IPQ_DECONTOUR_DE_CONTOUR_YDIFF_HIST_VADDR          	(0xb802572c)
#define  IPQ_DECONTOUR_DE_CONTOUR_CDIFF_HIST_VADDR          	(0xb8025730)
#define  IPQ_DECONTOUR_DE_CONTOUR_DB_REG_CTL_VADDR          	(0xb8025734)
#define  IPQ_DECONTOUR_DE_CONTOUR_BOTTLENECK_VADDR          	(0xb8025738)
#define  IPQ_DECONTOUR_DE_CONTOUR_DIFF_CLAMP_VADDR          	(0xb802573c)
#define  IPQ_DECONTOUR_DE_CONTOUR_CONTRAST2_VADDR           	(0xb8025740)
#define  IPQ_DECONTOUR_DE_CONTOUR_CONTRAST3_VADDR           	(0xb8025744)
#define  IPQ_DECONTOUR_DE_CONTOUR_DARK_VADDR                	(0xb8025748)
#define  IPQ_DECONTOUR_DE_CONTOUR_GRADATION_VADDR           	(0xb802574c)
#define  IPQ_DECONTOUR_DE_CONTOUR_MINMAX_VADDR              	(0xb8025750)
#define  IPQ_DECONTOUR_DE_CONTOUR_LEVEL_VADDR               	(0xb8025754)



#ifndef LITTLE_ENDIAN //apply BIG_ENDIAN

//======IPQ_DECONTOUR register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decont_en:1;
        RBus_UInt32  decont_neighbor_far:1;
        RBus_UInt32  decont_debug_en:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  decont_debug_mode:2;
        RBus_UInt32  res2:1;
        RBus_UInt32  decont_yc_mode:2;
        RBus_UInt32  res3:1;
        RBus_UInt32  decont_bottleneck_en:1;
        RBus_UInt32  decont_blend_weight_lpf_en:1;
        RBus_UInt32  res4:1;
        RBus_UInt32  res5:3;
        RBus_UInt32  decont_blend_lowbd:8;
        RBus_UInt32  res6:2;
        RBus_UInt32  decont_blend_step:2;
        RBus_UInt32  res7:2;
        RBus_UInt32  decont_snr_blend_mode:2;
    };
}ipq_decontour_de_contour_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  decont_contrast_th_y_info:9;
        RBus_UInt32  decont_neighbor_diff_th_y_info:6;
        RBus_UInt32  decont_gradation_th_y_info:5;
        RBus_UInt32  decont_maxmindiff_th_y_info:8;
    };
}ipq_decontour_de_contour_contrast_y_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  decont_contrast_th_c_info:11;
        RBus_UInt32  decont_neighbor_diff_th_c_info:6;
        RBus_UInt32  decont_gradation_th_c_info:5;
        RBus_UInt32  decont_maxmindiff_th_c_info:8;
    };
}ipq_decontour_de_contour_contrast_c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:6;
        RBus_UInt32  decont_contrast_th_y:10;
        RBus_UInt32  res2:6;
        RBus_UInt32  decont_contrast_th_c:10;
    };
}ipq_decontour_de_contour_contrast_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  decont_neighbor_diff_th2_y:6;
        RBus_UInt32  res2:2;
        RBus_UInt32  decont_neighbor_diff_th_y:6;
        RBus_UInt32  res3:2;
        RBus_UInt32  decont_neighbor_diff_th2_c:6;
        RBus_UInt32  res4:2;
        RBus_UInt32  decont_neighbor_diff_th_c:6;
    };
}ipq_decontour_de_contour_neighbor_diff_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:1;
        RBus_UInt32  decont_gradation_th_y:5;
        RBus_UInt32  decont_dark_th:10;
        RBus_UInt32  res2:1;
        RBus_UInt32  decont_gradation_th_c:5;
        RBus_UInt32  decont_dark_contrast_th:10;
    };
}ipq_decontour_de_contour_threshold_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  decont_maxmindiff_th_c:8;
        RBus_UInt32  decont_maxmindiff_th_y:8;
    };
}ipq_decontour_de_contour_diff_th_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  decont_contour_cnt:24;
    };
}ipq_decontour_de_contour_counter_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  decont_avfilter_cnt:24;
    };
}ipq_decontour_de_contour_avfilter_counter_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decont_filter_range_hist_rden:1;
        RBus_UInt32  decont_filter_range_hist_read_mode:1;
        RBus_UInt32  decont_filter_range_hist_locken:1;
        RBus_UInt32  decont_filter_range_hist_raddr:4;
        RBus_UInt32  res1:25;
    };
}ipq_decontour_de_contour_hist_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  decont_filter_range_hist:24;
    };
}ipq_decontour_de_contour_hist_data_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decont_info_ydiff_hist_rden:1;
        RBus_UInt32  decont_info_ydiff_hist_read_mode:1;
        RBus_UInt32  decont_info_ydiff_hist_locken:1;
        RBus_UInt32  decont_info_ydiff_hist_raddr:3;
        RBus_UInt32  res1:2;
        RBus_UInt32  decont_info_ydiff_hist:24;
    };
}ipq_decontour_de_contour_ydiff_hist_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decont_info_cdiff_hist_rden:1;
        RBus_UInt32  decont_info_cdiff_hist_read_mode:1;
        RBus_UInt32  decont_info_cdiff_hist_locken:1;
        RBus_UInt32  decont_info_cdiff_hist_raddr:3;
        RBus_UInt32  res1:2;
        RBus_UInt32  decont_info_cdiff_hist:24;
    };
}ipq_decontour_de_contour_cdiff_hist_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:29;
        RBus_UInt32  db_read:1;
        RBus_UInt32  db_en:1;
        RBus_UInt32  db_apply:1;
    };
}ipq_decontour_de_contour_db_reg_ctl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  decont_bottleneck_range3:4;
        RBus_UInt32  decont_bottleneck_range2:4;
        RBus_UInt32  decont_bottleneck_range1:4;
        RBus_UInt32  decont_bottleneck_range0:4;
    };
}ipq_decontour_de_contour_bottleneck_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  decont_diff_clamp_c:10;
        RBus_UInt32  decont_diff_clamp_y:10;
    };
}ipq_decontour_de_contour_diff_clamp_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:6;
        RBus_UInt32  decont_contrast_th3_y:10;
        RBus_UInt32  res2:6;
        RBus_UInt32  decont_contrast_th2_y:10;
    };
}ipq_decontour_de_contour_contrast2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:6;
        RBus_UInt32  decont_contrast_th3_c:10;
        RBus_UInt32  res2:6;
        RBus_UInt32  decont_contrast_th2_c:10;
    };
}ipq_decontour_de_contour_contrast3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:6;
        RBus_UInt32  decont_dark_contrast_th3:10;
        RBus_UInt32  res2:6;
        RBus_UInt32  decont_dark_contrast_th2:10;
    };
}ipq_decontour_de_contour_dark_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  decont_gradation_th2_c:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  decont_gradation_th2_y:5;
    };
}ipq_decontour_de_contour_gradation_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  decont_maxmin_lv3:2;
        RBus_UInt32  decont_maxmin_lv2:2;
        RBus_UInt32  decont_maxmin_lv1:2;
        RBus_UInt32  decont_maxmin_lv0:2;
        RBus_UInt32  decont_maxmindiff_th3_y:8;
        RBus_UInt32  decont_maxmindiff_th2_y:8;
    };
}ipq_decontour_de_contour_minmax_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:13;
        RBus_UInt32  decont_blend_gain_md:3;
        RBus_UInt32  res2:1;
        RBus_UInt32  decont_blend_gain_lo:3;
        RBus_UInt32  decont_level_range_hi:4;
        RBus_UInt32  decont_level_range_md:4;
        RBus_UInt32  decont_level_range_lo:4;
    };
}ipq_decontour_de_contour_level_RBUS;

#else //apply LITTLE_ENDIAN

//======IPQ_DECONTOUR register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decont_snr_blend_mode:2;
        RBus_UInt32  res1:2;
        RBus_UInt32  decont_blend_step:2;
        RBus_UInt32  res2:2;
        RBus_UInt32  decont_blend_lowbd:8;
        RBus_UInt32  res3:3;
        RBus_UInt32  res4:1;
        RBus_UInt32  decont_blend_weight_lpf_en:1;
        RBus_UInt32  decont_bottleneck_en:1;
        RBus_UInt32  res5:1;
        RBus_UInt32  decont_yc_mode:2;
        RBus_UInt32  res6:1;
        RBus_UInt32  decont_debug_mode:2;
        RBus_UInt32  res7:1;
        RBus_UInt32  decont_debug_en:1;
        RBus_UInt32  decont_neighbor_far:1;
        RBus_UInt32  decont_en:1;
    };
}ipq_decontour_de_contour_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decont_maxmindiff_th_y_info:8;
        RBus_UInt32  decont_gradation_th_y_info:5;
        RBus_UInt32  decont_neighbor_diff_th_y_info:6;
        RBus_UInt32  decont_contrast_th_y_info:9;
        RBus_UInt32  res1:4;
    };
}ipq_decontour_de_contour_contrast_y_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decont_maxmindiff_th_c_info:8;
        RBus_UInt32  decont_gradation_th_c_info:5;
        RBus_UInt32  decont_neighbor_diff_th_c_info:6;
        RBus_UInt32  decont_contrast_th_c_info:11;
        RBus_UInt32  res1:2;
    };
}ipq_decontour_de_contour_contrast_c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decont_contrast_th_c:10;
        RBus_UInt32  res1:6;
        RBus_UInt32  decont_contrast_th_y:10;
        RBus_UInt32  res2:6;
    };
}ipq_decontour_de_contour_contrast_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decont_neighbor_diff_th_c:6;
        RBus_UInt32  res1:2;
        RBus_UInt32  decont_neighbor_diff_th2_c:6;
        RBus_UInt32  res2:2;
        RBus_UInt32  decont_neighbor_diff_th_y:6;
        RBus_UInt32  res3:2;
        RBus_UInt32  decont_neighbor_diff_th2_y:6;
        RBus_UInt32  res4:2;
    };
}ipq_decontour_de_contour_neighbor_diff_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decont_dark_contrast_th:10;
        RBus_UInt32  decont_gradation_th_c:5;
        RBus_UInt32  res1:1;
        RBus_UInt32  decont_dark_th:10;
        RBus_UInt32  decont_gradation_th_y:5;
        RBus_UInt32  res2:1;
    };
}ipq_decontour_de_contour_threshold_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decont_maxmindiff_th_y:8;
        RBus_UInt32  decont_maxmindiff_th_c:8;
        RBus_UInt32  res1:16;
    };
}ipq_decontour_de_contour_diff_th_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decont_contour_cnt:24;
        RBus_UInt32  res1:8;
    };
}ipq_decontour_de_contour_counter_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decont_avfilter_cnt:24;
        RBus_UInt32  res1:8;
    };
}ipq_decontour_de_contour_avfilter_counter_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:25;
        RBus_UInt32  decont_filter_range_hist_raddr:4;
        RBus_UInt32  decont_filter_range_hist_locken:1;
        RBus_UInt32  decont_filter_range_hist_read_mode:1;
        RBus_UInt32  decont_filter_range_hist_rden:1;
    };
}ipq_decontour_de_contour_hist_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decont_filter_range_hist:24;
        RBus_UInt32  res1:8;
    };
}ipq_decontour_de_contour_hist_data_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decont_info_ydiff_hist:24;
        RBus_UInt32  res1:2;
        RBus_UInt32  decont_info_ydiff_hist_raddr:3;
        RBus_UInt32  decont_info_ydiff_hist_locken:1;
        RBus_UInt32  decont_info_ydiff_hist_read_mode:1;
        RBus_UInt32  decont_info_ydiff_hist_rden:1;
    };
}ipq_decontour_de_contour_ydiff_hist_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decont_info_cdiff_hist:24;
        RBus_UInt32  res1:2;
        RBus_UInt32  decont_info_cdiff_hist_raddr:3;
        RBus_UInt32  decont_info_cdiff_hist_locken:1;
        RBus_UInt32  decont_info_cdiff_hist_read_mode:1;
        RBus_UInt32  decont_info_cdiff_hist_rden:1;
    };
}ipq_decontour_de_contour_cdiff_hist_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  db_apply:1;
        RBus_UInt32  db_en:1;
        RBus_UInt32  db_read:1;
        RBus_UInt32  res1:29;
    };
}ipq_decontour_de_contour_db_reg_ctl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decont_bottleneck_range0:4;
        RBus_UInt32  decont_bottleneck_range1:4;
        RBus_UInt32  decont_bottleneck_range2:4;
        RBus_UInt32  decont_bottleneck_range3:4;
        RBus_UInt32  res1:16;
    };
}ipq_decontour_de_contour_bottleneck_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decont_diff_clamp_y:10;
        RBus_UInt32  decont_diff_clamp_c:10;
        RBus_UInt32  res1:12;
    };
}ipq_decontour_de_contour_diff_clamp_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decont_contrast_th2_y:10;
        RBus_UInt32  res1:6;
        RBus_UInt32  decont_contrast_th3_y:10;
        RBus_UInt32  res2:6;
    };
}ipq_decontour_de_contour_contrast2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decont_contrast_th2_c:10;
        RBus_UInt32  res1:6;
        RBus_UInt32  decont_contrast_th3_c:10;
        RBus_UInt32  res2:6;
    };
}ipq_decontour_de_contour_contrast3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decont_dark_contrast_th2:10;
        RBus_UInt32  res1:6;
        RBus_UInt32  decont_dark_contrast_th3:10;
        RBus_UInt32  res2:6;
    };
}ipq_decontour_de_contour_dark_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decont_gradation_th2_y:5;
        RBus_UInt32  res1:3;
        RBus_UInt32  decont_gradation_th2_c:5;
        RBus_UInt32  res2:19;
    };
}ipq_decontour_de_contour_gradation_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decont_maxmindiff_th2_y:8;
        RBus_UInt32  decont_maxmindiff_th3_y:8;
        RBus_UInt32  decont_maxmin_lv0:2;
        RBus_UInt32  decont_maxmin_lv1:2;
        RBus_UInt32  decont_maxmin_lv2:2;
        RBus_UInt32  decont_maxmin_lv3:2;
        RBus_UInt32  res1:8;
    };
}ipq_decontour_de_contour_minmax_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decont_level_range_lo:4;
        RBus_UInt32  decont_level_range_md:4;
        RBus_UInt32  decont_level_range_hi:4;
        RBus_UInt32  decont_blend_gain_lo:3;
        RBus_UInt32  res1:1;
        RBus_UInt32  decont_blend_gain_md:3;
        RBus_UInt32  res2:13;
    };
}ipq_decontour_de_contour_level_RBUS;




#endif 


#endif 
