/**
* @file Mac7p-DesignSpec-D-Domain_Panel_Compensation_OverDrive
* RBus systemc program.
*
* @author RS_MM2_SD
* @email jason9.ccc@realtek.com
 * @date 2019/11/22
* @ingroup model_rbus
 * @version { 1.0 }
 **
 */

#ifndef _RBUS_OD_REG_H_
#define _RBUS_OD_REG_H_

#include "rbusTypes.h"



//  OD Register Address



#define  OD_OD_CTRL_VADDR                                   	(0xb802ca00)
#define  OD_OD_CTRL1_VADDR                                  	(0xb802ca04)
#define  OD_OD_CTRL2_VADDR                                  	(0xb802ca08)
#define  OD_OD_LUT_ADDR_VADDR                               	(0xb802ca0c)
#define  OD_OD_LUT_DATA_VADDR                               	(0xb802ca10)
#define  OD_OD_NOISE_REDUCTION_CTRL_VADDR                   	(0xb802ca30)
#define  OD_OD_NOISE_REDUCTION_CTRL_W_VADDR                 	(0xb802ca34)
#define  OD_D_CRC_CTRL1_VADDR                               	(0xb802cb44)
#define  OD_CRC_RESULT1_VADDR                               	(0xb802cb48)
#define  OD_ACCESSDATA_CTRL_PC_VADDR                        	(0xb802cb54)
#define  OD_ACCESSDATA_POSCTRL_PC_VADDR                     	(0xb802cb58)
#define  OD_WRITEDATA_DATA_PC_VADDR                         	(0xb802cb5c)
#define  OD_WRITEDATA_DATA_1_PC_VADDR                       	(0xb802cb60)
#define  OD_WRITEDATA_DATA_2_PC_VADDR                       	(0xb802cb64)
#define  OD_WRITEDATA_DATA_3_PC_VADDR                       	(0xb802cb68)
#define  OD_WRITEDATA_DATA_4_PC_VADDR                       	(0xb802cb6c)
#define  OD_WRITEDATA_DATA_5_PC_VADDR                       	(0xb802cb70)
#define  OD_WRITEDATA_DATA_6_PC_VADDR                       	(0xb802cb74)
#define  OD_WRITEDATA_DATA_7_PC_VADDR                       	(0xb802cb78)
#define  OD_READDATA_DATA_CHANNEL1_1_PC_VADDR               	(0xb802cb94)
#define  OD_READDATA_DATA_CHANNEL1_2_PC_VADDR               	(0xb802cb98)
#define  OD_READDATA_DATA_CHANNEL2_1_PC_VADDR               	(0xb802cb9c)
#define  OD_READDATA_DATA_CHANNEL2_2_PC_VADDR               	(0xb802cba0)
#define  OD_READDATA_DATA_CHANNEL3_1_PC_VADDR               	(0xb802cba4)
#define  OD_READDATA_DATA_CHANNEL3_2_PC_VADDR               	(0xb802cba8)
#define  OD_OD_BIST_VADDR                                   	(0xb802cbb0)
#define  OD_OD_BIST_1_VADDR                                 	(0xb802cbb4)
#define  OD_OD_BIST_2_VADDR                                 	(0xb802cbb8)
#define  OD_OD_BIST_3_VADDR                                 	(0xb802cbbc)
#define  OD_YMODE_CTRL_VADDR                                	(0xb802cbc0)
#define  OD_YMODE_SAT_VADDR                                 	(0xb802cbc4)
#define  OD_YMODE_SAT_TH_VADDR                              	(0xb802cbc8)
#define  OD_YMODE_SAT_OFFSET_GAIN_VADDR                     	(0xb802cbcc)
#define  OD_YMODE_SAT_Y_VADDR                               	(0xb802cbd0)
#define  OD_YMODE_SAT_Y_COLOR2GRAY_VADDR                    	(0xb802cbd4)
#define  OD_YMODE_SAT_Y_SLOPE_VADDR                         	(0xb802cbd8)
#define  OD_YMODE_LPF_VADDR                                 	(0xb802cbdc)
#define  OD_OD_RGBW_CTRL_VADDR                              	(0xb802cbf0)
#define  OD_OD_RGBW2Y_CTRL_VADDR                            	(0xb802cbf4)
#define  OD_OD_HHF_VADDR                                    	(0xb802cbf8)
#define  OD_OD_HHF_STAT_VADDR                               	(0xb802cbfc)



#ifndef LITTLE_ENDIAN //apply BIG_ENDIAN

//======OD register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy1802ca00_31_7:25;
        RBus_UInt32  od_scaling_filter:3;
        RBus_UInt32  res1:2;
        RBus_UInt32  od_scaling_en:1;
        RBus_UInt32  od_en:1;
    };
}od_od_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:5;
        RBus_UInt32  db_apply:1;
        RBus_UInt32  db_read_level:1;
        RBus_UInt32  od_en_dbf_en:1;
        RBus_UInt32  res2:3;
        RBus_UInt32  force_pre_out:1;
        RBus_UInt32  od_pre_422_en:1;
        RBus_UInt32  od_cur_422_en:1;
        RBus_UInt32  res3:1;
        RBus_UInt32  rounding_en:1;
        RBus_UInt32  res4:10;
        RBus_UInt32  od_disp_res:2;
        RBus_UInt32  res5:3;
        RBus_UInt32  od_pdest_en:1;
    };
}od_od_ctrl1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:1;
        RBus_UInt32  od_delta_gain_w:7;
        RBus_UInt32  res2:1;
        RBus_UInt32  od_delta_gain_b:7;
        RBus_UInt32  res3:1;
        RBus_UInt32  od_delta_gain_g:7;
        RBus_UInt32  res4:1;
        RBus_UInt32  od_delta_gain_r:7;
    };
}od_od_ctrl2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:13;
        RBus_UInt32  table_type:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  od_lut_ax_en:1;
        RBus_UInt32  od_lut_ax_mode:1;
        RBus_UInt32  od_lut_adr_mode:1;
        RBus_UInt32  od_lut_sel:3;
        RBus_UInt32  od_lut_row_addr:5;
        RBus_UInt32  res3:1;
        RBus_UInt32  od_lut_column_addr:5;
    };
}od_od_lut_addr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  od_lut_data:16;
    };
}od_od_lut_data_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  od_nr_mode:1;
        RBus_UInt32  od_b_nr_en:1;
        RBus_UInt32  od_g_nr_en:1;
        RBus_UInt32  od_r_nr_en:1;
        RBus_UInt32  res2:2;
        RBus_UInt32  od_b_nr_thd:6;
        RBus_UInt32  res3:2;
        RBus_UInt32  od_g_nr_thd:6;
        RBus_UInt32  res4:2;
        RBus_UInt32  od_r_nr_thd:6;
    };
}od_od_noise_reduction_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  od_w_nr_en:1;
        RBus_UInt32  res1:25;
        RBus_UInt32  od_w_nr_thd:6;
    };
}od_od_noise_reduction_ctrl_w_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:30;
        RBus_UInt32  crc_1_conti:1;
        RBus_UInt32  crc_1_start:1;
    };
}od_d_crc_ctrl1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  crc_1_result:32;
    };
}od_crc_result1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cross_bar_en:1;
        RBus_UInt32  access_read_rgbw:1;
        RBus_UInt32  res1:21;
        RBus_UInt32  l_flag_enable:1;
        RBus_UInt32  w_en_ctrl:4;
        RBus_UInt32  res2:1;
        RBus_UInt32  access_write_en:1;
        RBus_UInt32  res3:1;
        RBus_UInt32  access_read_en:1;
    };
}od_accessdata_ctrl_pc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  access_starty:12;
        RBus_UInt32  res2:4;
        RBus_UInt32  access_startx:12;
    };
}od_accessdata_posctrl_pc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  access_v_wdat:10;
        RBus_UInt32  access_u_wdat:10;
        RBus_UInt32  access_y_wdat:10;
    };
}od_writedata_data_pc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  access_v1_wdat:10;
        RBus_UInt32  access_u1_wdat:10;
        RBus_UInt32  access_y1_wdat:10;
    };
}od_writedata_data_1_pc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  access_v2_wdat:10;
        RBus_UInt32  access_u2_wdat:10;
        RBus_UInt32  access_y2_wdat:10;
    };
}od_writedata_data_2_pc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  access_v3_wdat:10;
        RBus_UInt32  access_u3_wdat:10;
        RBus_UInt32  access_y3_wdat:10;
    };
}od_writedata_data_3_pc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  access_v4_wdat:10;
        RBus_UInt32  access_u4_wdat:10;
        RBus_UInt32  access_y4_wdat:10;
    };
}od_writedata_data_4_pc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  access_v5_wdat:10;
        RBus_UInt32  access_u5_wdat:10;
        RBus_UInt32  access_y5_wdat:10;
    };
}od_writedata_data_5_pc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  access_v6_wdat:10;
        RBus_UInt32  access_u6_wdat:10;
        RBus_UInt32  access_y6_wdat:10;
    };
}od_writedata_data_6_pc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  access_v7_wdat:10;
        RBus_UInt32  access_u7_wdat:10;
        RBus_UInt32  access_y7_wdat:10;
    };
}od_writedata_data_7_pc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  access_y01_color:2;
        RBus_UInt32  access_y01:12;
        RBus_UInt32  res2:2;
        RBus_UInt32  access_y00_color:2;
        RBus_UInt32  access_y00:12;
    };
}od_readdata_data_channel1_1_pc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  access_y11_color:2;
        RBus_UInt32  access_y11:12;
        RBus_UInt32  res2:2;
        RBus_UInt32  access_y10_color:2;
        RBus_UInt32  access_y10:12;
    };
}od_readdata_data_channel1_2_pc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  access_u01_color:2;
        RBus_UInt32  access_u01:12;
        RBus_UInt32  res2:2;
        RBus_UInt32  access_u00_color:2;
        RBus_UInt32  access_u00:12;
    };
}od_readdata_data_channel2_1_pc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  access_u11_color:2;
        RBus_UInt32  access_u11:12;
        RBus_UInt32  res2:2;
        RBus_UInt32  access_u10_color:2;
        RBus_UInt32  access_u10:12;
    };
}od_readdata_data_channel2_2_pc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  access_v01_color:2;
        RBus_UInt32  access_v01:12;
        RBus_UInt32  res2:2;
        RBus_UInt32  access_v00_color:2;
        RBus_UInt32  access_v00:12;
    };
}od_readdata_data_channel3_1_pc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  access_v11_color:2;
        RBus_UInt32  access_v11:12;
        RBus_UInt32  res2:2;
        RBus_UInt32  access_v10_color:2;
        RBus_UInt32  access_v10:12;
    };
}od_readdata_data_channel3_2_pc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  od_test1_0:1;
        RBus_UInt32  res1:7;
        RBus_UInt32  rm_3:4;
        RBus_UInt32  rm_2:4;
        RBus_UInt32  rm_1:4;
        RBus_UInt32  rm_0:4;
        RBus_UInt32  rme_3:1;
        RBus_UInt32  rme_2:1;
        RBus_UInt32  rme_1:1;
        RBus_UInt32  rme_0:1;
        RBus_UInt32  ls_3:1;
        RBus_UInt32  ls_2:1;
        RBus_UInt32  ls_1:1;
        RBus_UInt32  ls_0:1;
    };
}od_od_bist_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:6;
        RBus_UInt32  od_mplus_shifter_drf_fail:1;
        RBus_UInt32  res2:2;
        RBus_UInt32  od_line_buf_drf_fail_1:1;
        RBus_UInt32  od_line_buf_drf_fail_0:1;
        RBus_UInt32  od_mplus_shifter_bist_fail:1;
        RBus_UInt32  res3:2;
        RBus_UInt32  od_line_buf_bist_fail_1:1;
        RBus_UInt32  od_line_buf_bist_fail_0:1;
        RBus_UInt32  od_drf_fail_7:1;
        RBus_UInt32  od_bist_fail_7:1;
        RBus_UInt32  od_drf_fail_6:1;
        RBus_UInt32  od_bist_fail_6:1;
        RBus_UInt32  od_drf_fail_5:1;
        RBus_UInt32  od_bist_fail_5:1;
        RBus_UInt32  od_drf_fail_4:1;
        RBus_UInt32  od_bist_fail_4:1;
        RBus_UInt32  od_drf_fail_3:1;
        RBus_UInt32  od_bist_fail_3:1;
        RBus_UInt32  od_drf_fail_2:1;
        RBus_UInt32  od_bist_fail_2:1;
        RBus_UInt32  od_drf_fail_1:1;
        RBus_UInt32  od_bist_fail_1:1;
        RBus_UInt32  od_drf_fail_0:1;
        RBus_UInt32  od_bist_fail_0:1;
    };
}od_od_bist_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  od_mplus_shifter_rm:4;
        RBus_UInt32  res2:7;
        RBus_UInt32  od_line_buf_test1_0:1;
        RBus_UInt32  od_line_buf_rm_1:4;
        RBus_UInt32  od_line_buf_rm_0:4;
        RBus_UInt32  od_mplus_shifter_rme:1;
        RBus_UInt32  res3:2;
        RBus_UInt32  od_line_buf_rme_1:1;
        RBus_UInt32  od_line_buf_rme_0:1;
        RBus_UInt32  od_mplus_shifter_ls:1;
        RBus_UInt32  res4:2;
        RBus_UInt32  od_line_buf_ls_1:1;
        RBus_UInt32  od_line_buf_ls_0:1;
    };
}od_od_bist_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  rm_7:4;
        RBus_UInt32  rm_6:4;
        RBus_UInt32  rm_5:4;
        RBus_UInt32  rm_4:4;
        RBus_UInt32  rme_7:1;
        RBus_UInt32  rme_6:1;
        RBus_UInt32  rme_5:1;
        RBus_UInt32  rme_4:1;
        RBus_UInt32  ls_7:1;
        RBus_UInt32  ls_6:1;
        RBus_UInt32  ls_5:1;
        RBus_UInt32  ls_4:1;
    };
}od_od_bist_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  b_coeff:8;
        RBus_UInt32  g_coeff:8;
        RBus_UInt32  r_coeff:8;
        RBus_UInt32  od_ymode_debug_en:2;
        RBus_UInt32  od_ymode_sat_en:1;
        RBus_UInt32  od_ymode_en:1;
    };
}od_ymode_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sat_b_diff_th:4;
        RBus_UInt32  sat_g_diff_th:4;
        RBus_UInt32  sat_r_diff_th:4;
        RBus_UInt32  dummy1802cbc4_19_12:8;
        RBus_UInt32  sat_offset_clamp_en:1;
        RBus_UInt32  sat_y_en:1;
        RBus_UInt32  sat_m_en:1;
        RBus_UInt32  sat_c_en:1;
        RBus_UInt32  sat_b_en:1;
        RBus_UInt32  sat_g_en:1;
        RBus_UInt32  sat_r_en:1;
        RBus_UInt32  sat_y_diff_neg_en:1;
        RBus_UInt32  sat_y_diff_pos_en:1;
        RBus_UInt32  sat_color2gray_en:1;
        RBus_UInt32  sat_gray2cmy_en:1;
        RBus_UInt32  sat_gray2rgb_en:1;
    };
}od_ymode_sat_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  sat_color2gray_th:6;
        RBus_UInt32  res2:3;
        RBus_UInt32  sat_diff_th_factor:3;
        RBus_UInt32  sat_br_diff_th:6;
        RBus_UInt32  sat_gb_diff_th:6;
        RBus_UInt32  sat_rg_diff_th:6;
    };
}od_ymode_sat_th_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:5;
        RBus_UInt32  sat_color2gray_offset_gain:3;
        RBus_UInt32  res2:1;
        RBus_UInt32  sat_gray2y_offset_gain:3;
        RBus_UInt32  res3:1;
        RBus_UInt32  sat_gray2m_offset_gain:3;
        RBus_UInt32  res4:1;
        RBus_UInt32  sat_gray2c_offset_gain:3;
        RBus_UInt32  res5:1;
        RBus_UInt32  sat_gray2b_offset_gain:3;
        RBus_UInt32  res6:1;
        RBus_UInt32  sat_gray2g_offset_gain:3;
        RBus_UInt32  res7:1;
        RBus_UInt32  sat_gray2r_offset_gain:3;
    };
}od_ymode_sat_offset_gain_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  offset_hi_th:6;
        RBus_UInt32  res2:2;
        RBus_UInt32  offset_lo_th:6;
        RBus_UInt32  y_diff_hi_th:8;
        RBus_UInt32  y_diff_lo_th:8;
    };
}od_ymode_sat_y_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  offset_hi_th_color2gray:6;
        RBus_UInt32  res2:2;
        RBus_UInt32  offset_lo_th_color2gray:6;
        RBus_UInt32  y_diff_hi_th_color2gray:8;
        RBus_UInt32  y_diff_lo_th_color2gray:8;
    };
}od_ymode_sat_y_color2gray_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  offset_slope_color2gray:14;
        RBus_UInt32  res2:2;
        RBus_UInt32  offset_slope:14;
    };
}od_ymode_sat_y_slope_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy1802cbdc_31_7:25;
        RBus_UInt32  rgb2y_lpf_c1:3;
        RBus_UInt32  rgb2y_lpf_c0:4;
    };
}od_ymode_lpf_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:15;
        RBus_UInt32  od_input_format:1;
        RBus_UInt32  even_ch_w:2;
        RBus_UInt32  even_ch_b:2;
        RBus_UInt32  even_ch_g:2;
        RBus_UInt32  even_ch_r:2;
        RBus_UInt32  odd_ch_w:2;
        RBus_UInt32  odd_ch_b:2;
        RBus_UInt32  odd_ch_g:2;
        RBus_UInt32  odd_ch_r:2;
    };
}od_od_rgbw_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:1;
        RBus_UInt32  rgbw_c4:3;
        RBus_UInt32  res2:1;
        RBus_UInt32  rgbw_c3:3;
        RBus_UInt32  res3:1;
        RBus_UInt32  rgbw_c2:3;
        RBus_UInt32  rgbw_c1:4;
        RBus_UInt32  rgbw_c0:4;
        RBus_UInt32  w_coeff:8;
        RBus_UInt32  res4:2;
        RBus_UInt32  od_ymode_sat_rgbw2rgb_en:1;
        RBus_UInt32  od_ymode_rgbw_en:1;
    };
}od_od_rgbw2y_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  od_hhf_w2:5;
        RBus_UInt32  od_hhf_w1:5;
        RBus_UInt32  res1:1;
        RBus_UInt32  od_hhf_max:3;
        RBus_UInt32  od_hhf_th2:3;
        RBus_UInt32  od_hhf_th1:3;
        RBus_UInt32  res2:2;
        RBus_UInt32  od_hhf_gain:6;
        RBus_UInt32  res3:3;
        RBus_UInt32  od_hhf_en:1;
    };
}od_od_hhf_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  od_hhf_statistic:32;
    };
}od_od_hhf_stat_RBUS;

#else //apply LITTLE_ENDIAN

//======OD register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  od_en:1;
        RBus_UInt32  od_scaling_en:1;
        RBus_UInt32  res1:2;
        RBus_UInt32  od_scaling_filter:3;
        RBus_UInt32  dummy1802ca00_31_7:25;
    };
}od_od_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  od_pdest_en:1;
        RBus_UInt32  res1:3;
        RBus_UInt32  od_disp_res:2;
        RBus_UInt32  res2:10;
        RBus_UInt32  rounding_en:1;
        RBus_UInt32  res3:1;
        RBus_UInt32  od_cur_422_en:1;
        RBus_UInt32  od_pre_422_en:1;
        RBus_UInt32  force_pre_out:1;
        RBus_UInt32  res4:3;
        RBus_UInt32  od_en_dbf_en:1;
        RBus_UInt32  db_read_level:1;
        RBus_UInt32  db_apply:1;
        RBus_UInt32  res5:5;
    };
}od_od_ctrl1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  od_delta_gain_r:7;
        RBus_UInt32  res1:1;
        RBus_UInt32  od_delta_gain_g:7;
        RBus_UInt32  res2:1;
        RBus_UInt32  od_delta_gain_b:7;
        RBus_UInt32  res3:1;
        RBus_UInt32  od_delta_gain_w:7;
        RBus_UInt32  res4:1;
    };
}od_od_ctrl2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  od_lut_column_addr:5;
        RBus_UInt32  res1:1;
        RBus_UInt32  od_lut_row_addr:5;
        RBus_UInt32  od_lut_sel:3;
        RBus_UInt32  od_lut_adr_mode:1;
        RBus_UInt32  od_lut_ax_mode:1;
        RBus_UInt32  od_lut_ax_en:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  table_type:1;
        RBus_UInt32  res3:13;
    };
}od_od_lut_addr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  od_lut_data:16;
        RBus_UInt32  res1:16;
    };
}od_od_lut_data_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  od_r_nr_thd:6;
        RBus_UInt32  res1:2;
        RBus_UInt32  od_g_nr_thd:6;
        RBus_UInt32  res2:2;
        RBus_UInt32  od_b_nr_thd:6;
        RBus_UInt32  res3:2;
        RBus_UInt32  od_r_nr_en:1;
        RBus_UInt32  od_g_nr_en:1;
        RBus_UInt32  od_b_nr_en:1;
        RBus_UInt32  od_nr_mode:1;
        RBus_UInt32  res4:4;
    };
}od_od_noise_reduction_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  od_w_nr_thd:6;
        RBus_UInt32  res1:25;
        RBus_UInt32  od_w_nr_en:1;
    };
}od_od_noise_reduction_ctrl_w_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  crc_1_start:1;
        RBus_UInt32  crc_1_conti:1;
        RBus_UInt32  res1:30;
    };
}od_d_crc_ctrl1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  crc_1_result:32;
    };
}od_crc_result1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  access_read_en:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  access_write_en:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  w_en_ctrl:4;
        RBus_UInt32  l_flag_enable:1;
        RBus_UInt32  res3:21;
        RBus_UInt32  access_read_rgbw:1;
        RBus_UInt32  cross_bar_en:1;
    };
}od_accessdata_ctrl_pc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  access_startx:12;
        RBus_UInt32  res1:4;
        RBus_UInt32  access_starty:12;
        RBus_UInt32  res2:4;
    };
}od_accessdata_posctrl_pc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  access_y_wdat:10;
        RBus_UInt32  access_u_wdat:10;
        RBus_UInt32  access_v_wdat:10;
        RBus_UInt32  res1:2;
    };
}od_writedata_data_pc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  access_y1_wdat:10;
        RBus_UInt32  access_u1_wdat:10;
        RBus_UInt32  access_v1_wdat:10;
        RBus_UInt32  res1:2;
    };
}od_writedata_data_1_pc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  access_y2_wdat:10;
        RBus_UInt32  access_u2_wdat:10;
        RBus_UInt32  access_v2_wdat:10;
        RBus_UInt32  res1:2;
    };
}od_writedata_data_2_pc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  access_y3_wdat:10;
        RBus_UInt32  access_u3_wdat:10;
        RBus_UInt32  access_v3_wdat:10;
        RBus_UInt32  res1:2;
    };
}od_writedata_data_3_pc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  access_y4_wdat:10;
        RBus_UInt32  access_u4_wdat:10;
        RBus_UInt32  access_v4_wdat:10;
        RBus_UInt32  res1:2;
    };
}od_writedata_data_4_pc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  access_y5_wdat:10;
        RBus_UInt32  access_u5_wdat:10;
        RBus_UInt32  access_v5_wdat:10;
        RBus_UInt32  res1:2;
    };
}od_writedata_data_5_pc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  access_y6_wdat:10;
        RBus_UInt32  access_u6_wdat:10;
        RBus_UInt32  access_v6_wdat:10;
        RBus_UInt32  res1:2;
    };
}od_writedata_data_6_pc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  access_y7_wdat:10;
        RBus_UInt32  access_u7_wdat:10;
        RBus_UInt32  access_v7_wdat:10;
        RBus_UInt32  res1:2;
    };
}od_writedata_data_7_pc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  access_y00:12;
        RBus_UInt32  access_y00_color:2;
        RBus_UInt32  res1:2;
        RBus_UInt32  access_y01:12;
        RBus_UInt32  access_y01_color:2;
        RBus_UInt32  res2:2;
    };
}od_readdata_data_channel1_1_pc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  access_y10:12;
        RBus_UInt32  access_y10_color:2;
        RBus_UInt32  res1:2;
        RBus_UInt32  access_y11:12;
        RBus_UInt32  access_y11_color:2;
        RBus_UInt32  res2:2;
    };
}od_readdata_data_channel1_2_pc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  access_u00:12;
        RBus_UInt32  access_u00_color:2;
        RBus_UInt32  res1:2;
        RBus_UInt32  access_u01:12;
        RBus_UInt32  access_u01_color:2;
        RBus_UInt32  res2:2;
    };
}od_readdata_data_channel2_1_pc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  access_u10:12;
        RBus_UInt32  access_u10_color:2;
        RBus_UInt32  res1:2;
        RBus_UInt32  access_u11:12;
        RBus_UInt32  access_u11_color:2;
        RBus_UInt32  res2:2;
    };
}od_readdata_data_channel2_2_pc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  access_v00:12;
        RBus_UInt32  access_v00_color:2;
        RBus_UInt32  res1:2;
        RBus_UInt32  access_v01:12;
        RBus_UInt32  access_v01_color:2;
        RBus_UInt32  res2:2;
    };
}od_readdata_data_channel3_1_pc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  access_v10:12;
        RBus_UInt32  access_v10_color:2;
        RBus_UInt32  res1:2;
        RBus_UInt32  access_v11:12;
        RBus_UInt32  access_v11_color:2;
        RBus_UInt32  res2:2;
    };
}od_readdata_data_channel3_2_pc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ls_0:1;
        RBus_UInt32  ls_1:1;
        RBus_UInt32  ls_2:1;
        RBus_UInt32  ls_3:1;
        RBus_UInt32  rme_0:1;
        RBus_UInt32  rme_1:1;
        RBus_UInt32  rme_2:1;
        RBus_UInt32  rme_3:1;
        RBus_UInt32  rm_0:4;
        RBus_UInt32  rm_1:4;
        RBus_UInt32  rm_2:4;
        RBus_UInt32  rm_3:4;
        RBus_UInt32  res1:7;
        RBus_UInt32  od_test1_0:1;
    };
}od_od_bist_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  od_bist_fail_0:1;
        RBus_UInt32  od_drf_fail_0:1;
        RBus_UInt32  od_bist_fail_1:1;
        RBus_UInt32  od_drf_fail_1:1;
        RBus_UInt32  od_bist_fail_2:1;
        RBus_UInt32  od_drf_fail_2:1;
        RBus_UInt32  od_bist_fail_3:1;
        RBus_UInt32  od_drf_fail_3:1;
        RBus_UInt32  od_bist_fail_4:1;
        RBus_UInt32  od_drf_fail_4:1;
        RBus_UInt32  od_bist_fail_5:1;
        RBus_UInt32  od_drf_fail_5:1;
        RBus_UInt32  od_bist_fail_6:1;
        RBus_UInt32  od_drf_fail_6:1;
        RBus_UInt32  od_bist_fail_7:1;
        RBus_UInt32  od_drf_fail_7:1;
        RBus_UInt32  od_line_buf_bist_fail_0:1;
        RBus_UInt32  od_line_buf_bist_fail_1:1;
        RBus_UInt32  res1:2;
        RBus_UInt32  od_mplus_shifter_bist_fail:1;
        RBus_UInt32  od_line_buf_drf_fail_0:1;
        RBus_UInt32  od_line_buf_drf_fail_1:1;
        RBus_UInt32  res2:2;
        RBus_UInt32  od_mplus_shifter_drf_fail:1;
        RBus_UInt32  res3:6;
    };
}od_od_bist_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  od_line_buf_ls_0:1;
        RBus_UInt32  od_line_buf_ls_1:1;
        RBus_UInt32  res1:2;
        RBus_UInt32  od_mplus_shifter_ls:1;
        RBus_UInt32  od_line_buf_rme_0:1;
        RBus_UInt32  od_line_buf_rme_1:1;
        RBus_UInt32  res2:2;
        RBus_UInt32  od_mplus_shifter_rme:1;
        RBus_UInt32  od_line_buf_rm_0:4;
        RBus_UInt32  od_line_buf_rm_1:4;
        RBus_UInt32  od_line_buf_test1_0:1;
        RBus_UInt32  res3:7;
        RBus_UInt32  od_mplus_shifter_rm:4;
        RBus_UInt32  res4:2;
    };
}od_od_bist_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ls_4:1;
        RBus_UInt32  ls_5:1;
        RBus_UInt32  ls_6:1;
        RBus_UInt32  ls_7:1;
        RBus_UInt32  rme_4:1;
        RBus_UInt32  rme_5:1;
        RBus_UInt32  rme_6:1;
        RBus_UInt32  rme_7:1;
        RBus_UInt32  rm_4:4;
        RBus_UInt32  rm_5:4;
        RBus_UInt32  rm_6:4;
        RBus_UInt32  rm_7:4;
        RBus_UInt32  res1:8;
    };
}od_od_bist_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  od_ymode_en:1;
        RBus_UInt32  od_ymode_sat_en:1;
        RBus_UInt32  od_ymode_debug_en:2;
        RBus_UInt32  r_coeff:8;
        RBus_UInt32  g_coeff:8;
        RBus_UInt32  b_coeff:8;
        RBus_UInt32  res1:4;
    };
}od_ymode_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sat_gray2rgb_en:1;
        RBus_UInt32  sat_gray2cmy_en:1;
        RBus_UInt32  sat_color2gray_en:1;
        RBus_UInt32  sat_y_diff_pos_en:1;
        RBus_UInt32  sat_y_diff_neg_en:1;
        RBus_UInt32  sat_r_en:1;
        RBus_UInt32  sat_g_en:1;
        RBus_UInt32  sat_b_en:1;
        RBus_UInt32  sat_c_en:1;
        RBus_UInt32  sat_m_en:1;
        RBus_UInt32  sat_y_en:1;
        RBus_UInt32  sat_offset_clamp_en:1;
        RBus_UInt32  dummy1802cbc4_19_12:8;
        RBus_UInt32  sat_r_diff_th:4;
        RBus_UInt32  sat_g_diff_th:4;
        RBus_UInt32  sat_b_diff_th:4;
    };
}od_ymode_sat_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sat_rg_diff_th:6;
        RBus_UInt32  sat_gb_diff_th:6;
        RBus_UInt32  sat_br_diff_th:6;
        RBus_UInt32  sat_diff_th_factor:3;
        RBus_UInt32  res1:3;
        RBus_UInt32  sat_color2gray_th:6;
        RBus_UInt32  res2:2;
    };
}od_ymode_sat_th_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sat_gray2r_offset_gain:3;
        RBus_UInt32  res1:1;
        RBus_UInt32  sat_gray2g_offset_gain:3;
        RBus_UInt32  res2:1;
        RBus_UInt32  sat_gray2b_offset_gain:3;
        RBus_UInt32  res3:1;
        RBus_UInt32  sat_gray2c_offset_gain:3;
        RBus_UInt32  res4:1;
        RBus_UInt32  sat_gray2m_offset_gain:3;
        RBus_UInt32  res5:1;
        RBus_UInt32  sat_gray2y_offset_gain:3;
        RBus_UInt32  res6:1;
        RBus_UInt32  sat_color2gray_offset_gain:3;
        RBus_UInt32  res7:5;
    };
}od_ymode_sat_offset_gain_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  y_diff_lo_th:8;
        RBus_UInt32  y_diff_hi_th:8;
        RBus_UInt32  offset_lo_th:6;
        RBus_UInt32  res1:2;
        RBus_UInt32  offset_hi_th:6;
        RBus_UInt32  res2:2;
    };
}od_ymode_sat_y_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  y_diff_lo_th_color2gray:8;
        RBus_UInt32  y_diff_hi_th_color2gray:8;
        RBus_UInt32  offset_lo_th_color2gray:6;
        RBus_UInt32  res1:2;
        RBus_UInt32  offset_hi_th_color2gray:6;
        RBus_UInt32  res2:2;
    };
}od_ymode_sat_y_color2gray_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  offset_slope:14;
        RBus_UInt32  res1:2;
        RBus_UInt32  offset_slope_color2gray:14;
        RBus_UInt32  res2:2;
    };
}od_ymode_sat_y_slope_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  rgb2y_lpf_c0:4;
        RBus_UInt32  rgb2y_lpf_c1:3;
        RBus_UInt32  dummy1802cbdc_31_7:25;
    };
}od_ymode_lpf_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  odd_ch_r:2;
        RBus_UInt32  odd_ch_g:2;
        RBus_UInt32  odd_ch_b:2;
        RBus_UInt32  odd_ch_w:2;
        RBus_UInt32  even_ch_r:2;
        RBus_UInt32  even_ch_g:2;
        RBus_UInt32  even_ch_b:2;
        RBus_UInt32  even_ch_w:2;
        RBus_UInt32  od_input_format:1;
        RBus_UInt32  res1:15;
    };
}od_od_rgbw_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  od_ymode_rgbw_en:1;
        RBus_UInt32  od_ymode_sat_rgbw2rgb_en:1;
        RBus_UInt32  res1:2;
        RBus_UInt32  w_coeff:8;
        RBus_UInt32  rgbw_c0:4;
        RBus_UInt32  rgbw_c1:4;
        RBus_UInt32  rgbw_c2:3;
        RBus_UInt32  res2:1;
        RBus_UInt32  rgbw_c3:3;
        RBus_UInt32  res3:1;
        RBus_UInt32  rgbw_c4:3;
        RBus_UInt32  res4:1;
    };
}od_od_rgbw2y_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  od_hhf_en:1;
        RBus_UInt32  res1:3;
        RBus_UInt32  od_hhf_gain:6;
        RBus_UInt32  res2:2;
        RBus_UInt32  od_hhf_th1:3;
        RBus_UInt32  od_hhf_th2:3;
        RBus_UInt32  od_hhf_max:3;
        RBus_UInt32  res3:1;
        RBus_UInt32  od_hhf_w1:5;
        RBus_UInt32  od_hhf_w2:5;
    };
}od_od_hhf_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  od_hhf_statistic:32;
    };
}od_od_hhf_stat_RBUS;




#endif 


#endif 
