/**
* @file Mac7p-DesignSpec-D-Domain_Panel_Compensation_OverDrive
* RBus systemc program.
*
* @author RS_MM2_SD
* @email jason9.ccc@realtek.com
 * @date 2019/11/22
* @ingroup model_rbus
 * @version { 1.0 }
 **
 */

#ifndef _RBUS_OD_DMA_REG_H_
#define _RBUS_OD_DMA_REG_H_

#include "rbusTypes.h"



//  OD_DMA Register Address



#define  OD_DMA_ODDMA_PQ_CMP_VADDR                          	(0xb802cd00)
#define  OD_DMA_ODDMA_PQ_CMP_PAIR_VADDR                     	(0xb802cd04)
#define  OD_DMA_ODDMA_PQ_CMP_BIT_VADDR                      	(0xb802cd08)
#define  OD_DMA_ODDMA_PQ_CMP_ENABLE_VADDR                   	(0xb802cd0c)
#define  OD_DMA_ODDMA_PQ_CMP_SMOOTH_VADDR                   	(0xb802cd10)
#define  OD_DMA_ODDMA_PQ_CMP_ALLOCATE_VADDR                 	(0xb802cd14)
#define  OD_DMA_ODDMA_PQ_CMP_POOR_VADDR                     	(0xb802cd18)
#define  OD_DMA_ODDMA_PQ_CMP_GUARANTEE_VADDR                	(0xb802cd1c)
#define  OD_DMA_ODDMA_PQ_CMP_BALANCE_VADDR                  	(0xb802cd20)
#define  OD_DMA_ODDMA_PQ_CMP_IRQ_EN_VADDR                   	(0xb802cd24)
#define  OD_DMA_ODDMA_PQ_CMP_IRQ_ST_VADDR                   	(0xb802cd28)
#define  OD_DMA_ODDMA_PQ_CMP_ST_VADDR                       	(0xb802cd2c)
#define  OD_DMA_ODDMA_PQ_CMP_QP_ST_VADDR                    	(0xb802cd30)
#define  OD_DMA_ODDMA_PQ_CMP_FIFO_ST1_VADDR                 	(0xb802cd34)
#define  OD_DMA_ODDMA_PQ_CMP_LEFT_ST_VADDR                  	(0xb802cd3c)
#define  OD_DMA_ODDMA_PQ_CMP_PACKAGE_ST_VADDR               	(0xb802cd40)
#define  OD_DMA_ODDMA_PQ_CMP_CRC_EVEN_G_VADDR               	(0xb802cd44)
#define  OD_DMA_ODDMA_PQ_CMP_CRC_EVEN_R_VADDR               	(0xb802cd48)
#define  OD_DMA_ODDMA_PQ_CMP_CRC_EVEN_B_VADDR               	(0xb802cd4c)
#define  OD_DMA_ODDMA_PQ_CMP_BLK0_ADD0_VADDR                	(0xb802cd60)
#define  OD_DMA_ODDMA_PQ_CMP_BLK0_ADD1_VADDR                	(0xb802cd64)
#define  OD_DMA_ODDMA_PQ_DECMP_VADDR                        	(0xb802cd80)
#define  OD_DMA_ODDMA_PQ_DECMP_PAIR_VADDR                   	(0xb802cd84)
#define  OD_DMA_ODDMA_PQ_DECMP_SAT_EN_VADDR                 	(0xb802cd88)
#define  OD_DMA_ODDMA_PQ_DECMP_IRQ_EN_VADDR                 	(0xb802cd8c)
#define  OD_DMA_ODDMA_PQ_DECMP_IRQ_ST_VADDR                 	(0xb802cd90)
#define  OD_DMA_ODDMA_PQ_DECMP_MARK_EN_VADDR                	(0xb802cd94)
#define  OD_DMA_ODDMA_PQ_DECMP_MARK_COLOR_01_VADDR          	(0xb802cd98)
#define  OD_DMA_ODDMA_PQ_DECMP_MARK_COLOR_23_VADDR          	(0xb802cd9c)
#define  OD_DMA_ODDMA_PQ_DECMP_MARK_COLOR_45_VADDR          	(0xb802cda0)
#define  OD_DMA_ODDMA_PQ_DECMP_MARK_COLOR_67_VADDR          	(0xb802cda4)
#define  OD_DMA_ODDMA_PQ_DECMP_MARK_COLOR_422_VADDR         	(0xb802cda8)
#define  OD_DMA_ODDMA_PQ_DECMP_ST_VADDR                     	(0xb802cdac)
#define  OD_DMA_ODDMA_PQ_DECMP_CRC_EVEN_G_VADDR             	(0xb802cdb0)
#define  OD_DMA_ODDMA_PQ_DECMP_CRC_EVEN_R_VADDR             	(0xb802cdb4)
#define  OD_DMA_ODDMA_PQ_DECMP_CRC_EVEN_B_VADDR             	(0xb802cdb8)
#define  OD_DMA_ODDMA_PQ_DECMP_PAUSE_CYCLE_VADDR            	(0xb802cdd0)
#define  OD_DMA_ODDMA_PQC_PQDC_COMPENSATION_VADDR           	(0xb802cdd4)
#define  OD_DMA_OD_DMA_DB_EN_VADDR                          	(0xb802cde0)
#define  OD_DMA_OD_DMA_CTRL_VADDR                           	(0xb802cde4)
#define  OD_DMA_OD_DMA_CTRL_2_VADDR                         	(0xb802cde8)
#define  OD_DMA_OD_DMA_STATUS_VADDR                         	(0xb802cdec)
#define  OD_DMA_ODDMA_WR_RULE_CHECK_UP_VADDR                	(0xb802ce00)
#define  OD_DMA_ODDMA_WR_RULE_CHECK_LOW_VADDR               	(0xb802ce04)
#define  OD_DMA_ODDMA_WR_CTRL_VADDR                         	(0xb802ce08)
#define  OD_DMA_ODDMA_WR_STATUS_VADDR                       	(0xb802ce0c)
#define  OD_DMA_ODDMA_WR_STATUS1_VADDR                      	(0xb802ce10)
#define  OD_DMA_ODDMA_WR_STATUS2_VADDR                      	(0xb802ce14)
#define  OD_DMA_ODDMA_WR_WATER_MONITOR_VADDR                	(0xb802ce18)
#define  OD_DMA_ODDMA_WR_NUM_BL_WRAP_ADDR_0_VADDR           	(0xb802ce30)
#define  OD_DMA_ODDMA_WR_NUM_BL_WRAP_ADDR_1_VADDR           	(0xb802ce34)
#define  OD_DMA_ODDMA_WR_NUM_BL_WRAP_LINE_STEP_VADDR        	(0xb802ce38)
#define  OD_DMA_ODDMA_WR_NUM_BL_WRAP_CTL_VADDR              	(0xb802ce3c)
#define  OD_DMA_ODDMA_WR_NUM_BL_WRAP_ROLLING_VADDR          	(0xb802ce40)
#define  OD_DMA_ODDMA_WR_NUM_BL_WRAP_WORD_VADDR             	(0xb802ce44)
#define  OD_DMA_ODDMA_WR_NUM_BL_WRAP_ST1_VADDR              	(0xb802ce48)
#define  OD_DMA_ODDMA_WR_NUM_BL_WRAP_ST2_VADDR              	(0xb802ce4c)
#define  OD_DMA_ODDMA_RD_RULE_CHECK_UP_VADDR                	(0xb802ce80)
#define  OD_DMA_ODDMA_RD_RULE_CHECK_LOW_VADDR               	(0xb802ce84)
#define  OD_DMA_ODDMA_RD_CTRL_VADDR                         	(0xb802ce88)
#define  OD_DMA_ODDMA_RD_STATUS_VADDR                       	(0xb802ce8c)
#define  OD_DMA_ODDMA_RD_STATUS1_VADDR                      	(0xb802ce90)
#define  OD_DMA_ODDMA_RD_STATUS2_VADDR                      	(0xb802ce94)
#define  OD_DMA_ODDMA_RD_WATER_MONITOR_VADDR                	(0xb802ce98)
#define  OD_DMA_ODDMA_RD_NUM_BL_WRAP_ADDR_0_VADDR           	(0xb802ceb0)
#define  OD_DMA_ODDMA_RD_NUM_BL_WRAP_ADDR_1_VADDR           	(0xb802ceb4)
#define  OD_DMA_ODDMA_RD_NUM_BL_WRAP_LINE_STEP_VADDR        	(0xb802ceb8)
#define  OD_DMA_ODDMA_RD_NUM_BL_WRAP_CTL_VADDR              	(0xb802cebc)
#define  OD_DMA_ODDMA_RD_NUM_BL_WRAP_ROLLING_VADDR          	(0xb802cec0)
#define  OD_DMA_ODDMA_RD_NUM_BL_WRAP_WORD_VADDR             	(0xb802cec4)
#define  OD_DMA_ODDMA_RD_NUM_BL_WRAP_ST1_VADDR              	(0xb802cec8)
#define  OD_DMA_ODDMA_RD_NUM_BL_WRAP_ST2_VADDR              	(0xb802cecc)
#define  OD_DMA_ODDMA_CRC_CTRL_VADDR                        	(0xb802cf00)
#define  OD_DMA_ODDMA_CRC_MASK_VADDR                        	(0xb802cf04)
#define  OD_DMA_ODDMA_CAP_L_CRC_RESULT_VADDR                	(0xb802cf08)
#define  OD_DMA_ODDMA_DISP_L_CRC_RESULT_VADDR               	(0xb802cf0c)
#define  OD_DMA_ODDMA_CAP_RM_VADDR                          	(0xb802cf20)
#define  OD_DMA_ODDMA_CAP_RME_VADDR                         	(0xb802cf24)
#define  OD_DMA_ODDMA_CAP_LS_VADDR                          	(0xb802cf28)
#define  OD_DMA_ODDMA_CAP_FAIL_VADDR                        	(0xb802cf2c)
#define  OD_DMA_ODDMA_CAP_DRF_FAIL_VADDR                    	(0xb802cf30)
#define  OD_DMA_ODDMA_DISP_RM_VADDR                         	(0xb802cf40)
#define  OD_DMA_ODDMA_DISP_RME_VADDR                        	(0xb802cf44)
#define  OD_DMA_ODDMA_DISP_LS_VADDR                         	(0xb802cf48)
#define  OD_DMA_ODDMA_DISP_BIST_FAIL_VADDR                  	(0xb802cf4c)
#define  OD_DMA_ODDMA_DISP_DRF_FAIL_VADDR                   	(0xb802cf50)



#ifndef LITTLE_ENDIAN //apply BIG_ENDIAN

//======OD_DMA register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmp_en:1;
        RBus_UInt32  res1:6;
        RBus_UInt32  cmp_width_div32:9;
        RBus_UInt32  res2:2;
        RBus_UInt32  cmp_height:14;
    };
}od_dma_oddma_pq_cmp_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmp_line_sum_bit:16;
        RBus_UInt32  cmp_400_old_mode_en:1;
        RBus_UInt32  dummy1802cd04_14_11:4;
        RBus_UInt32  cmp_jump4_en:1;
        RBus_UInt32  cmp_qp_mode:2;
        RBus_UInt32  dummy1802cd04_7:1;
        RBus_UInt32  two_line_prediction_en:1;
        RBus_UInt32  cmp_line_mode:1;
        RBus_UInt32  cmp_data_color:1;
        RBus_UInt32  cmp_data_bit_width:2;
        RBus_UInt32  cmp_data_format:2;
    };
}od_dma_oddma_pq_cmp_pair_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  first_line_more_bit:6;
        RBus_UInt32  res2:2;
        RBus_UInt32  block_limit_bit:6;
        RBus_UInt32  res3:2;
        RBus_UInt32  line_limit_bit:6;
        RBus_UInt32  res4:2;
        RBus_UInt32  frame_limit_bit:6;
    };
}od_dma_oddma_pq_cmp_bit_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  input_fifo_pause_cycle:4;
        RBus_UInt32  tail_dummy_throughput:1;
        RBus_UInt32  first_predict_nc_mode:1;
        RBus_UInt32  res1:5;
        RBus_UInt32  g_ratio:5;
        RBus_UInt32  add_last2blk_over_curve_bit:1;
        RBus_UInt32  variation_maxmin_en:1;
        RBus_UInt32  dynamic_sum_line_rst:1;
        RBus_UInt32  blk0_add_en:1;
        RBus_UInt32  guarantee_max_qp_en:1;
        RBus_UInt32  dynamic_allocate_ratio_en:1;
        RBus_UInt32  poor_limit_min_qp_en:1;
        RBus_UInt32  balance_en:1;
        RBus_UInt32  fisrt_line_more_en:1;
        RBus_UInt32  blk0_add_half_en:1;
        RBus_UInt32  do_422_mode:2;
        RBus_UInt32  first_predict_nc_en:1;
        RBus_UInt32  not_enough_bit_do_422_en:1;
        RBus_UInt32  not_rich_do_422_en:1;
        RBus_UInt32  rb_lossy_do_422_en:1;
    };
}od_dma_oddma_pq_cmp_enable_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dic_mode_option:4;
        RBus_UInt32  res1:1;
        RBus_UInt32  not_enough_bit_do_422_qp:3;
        RBus_UInt32  not_rich_do_422_th:4;
        RBus_UInt32  res2:1;
        RBus_UInt32  rb_lossy_do_422_qp_level:3;
        RBus_UInt32  dic_mode_entry_th:4;
        RBus_UInt32  variation_value_th:4;
        RBus_UInt32  res3:1;
        RBus_UInt32  variation_num_th:3;
        RBus_UInt32  res4:1;
        RBus_UInt32  variation_near_num_th:3;
    };
}od_dma_oddma_pq_cmp_smooth_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  dynamic_allocate_ratio_max:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  dynamic_allocate_ratio_min:5;
        RBus_UInt32  res3:5;
        RBus_UInt32  dynamic_allocate_line:3;
        RBus_UInt32  dynamic_allocate_more:4;
        RBus_UInt32  dynamic_allocate_less:4;
    };
}od_dma_oddma_pq_cmp_allocate_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  poor_limit_th_qp4:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  poor_limit_th_qp3:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  poor_limit_th_qp2:5;
        RBus_UInt32  res4:3;
        RBus_UInt32  poor_limit_th_qp1:5;
    };
}od_dma_oddma_pq_cmp_poor_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  cmp_crc_ro_line_sel:14;
        RBus_UInt32  dic_mode_qp_th_rb:4;
        RBus_UInt32  dic_mode_qp_th_g:4;
        RBus_UInt32  guarantee_max_rb_qp:4;
        RBus_UInt32  guarantee_max_g_qp:4;
    };
}od_dma_oddma_pq_cmp_guarantee_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  variation_maxmin_th2:8;
        RBus_UInt32  variation_maxmin_th:8;
        RBus_UInt32  res1:2;
        RBus_UInt32  balance_rb_ov_th:2;
        RBus_UInt32  balance_rb_ud_th:2;
        RBus_UInt32  balance_rb_give:2;
        RBus_UInt32  res2:2;
        RBus_UInt32  balance_g_ov_th:2;
        RBus_UInt32  balance_g_ud_th:2;
        RBus_UInt32  balance_g_give:2;
    };
}od_dma_oddma_pq_cmp_balance_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:13;
        RBus_UInt32  prs_over_line_sum_bit_irq_en:1;
        RBus_UInt32  tail_fifo_overflow_irq_en:1;
        RBus_UInt32  input_fifo_overflow_irq_en:1;
        RBus_UInt32  block_fifo_overflow_irq_en:1;
        RBus_UInt32  input_size_more_irq_en:1;
        RBus_UInt32  input_size_less_irq_en:1;
        RBus_UInt32  over_flb_irq_en:1;
        RBus_UInt32  res2:2;
        RBus_UInt32  request_fifo_even_overflow_irq_en:1;
        RBus_UInt32  res3:2;
        RBus_UInt32  g_fifo_even_overflow_irq_en:1;
        RBus_UInt32  r_fifo_even_overflow_irq_en:1;
        RBus_UInt32  b_fifo_even_overflow_irq_en:1;
        RBus_UInt32  res4:4;
    };
}od_dma_oddma_pq_cmp_irq_en_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pqc_irq:1;
        RBus_UInt32  res1:12;
        RBus_UInt32  prs_over_line_sum_bit_st:1;
        RBus_UInt32  tail_fifo_overflow_st:1;
        RBus_UInt32  input_fifo_overflow_st:1;
        RBus_UInt32  block_fifo_overflow_st:1;
        RBus_UInt32  input_size_more_st:1;
        RBus_UInt32  input_size_less_st:1;
        RBus_UInt32  over_flb_st:1;
        RBus_UInt32  res2:2;
        RBus_UInt32  request_fifo_even_overflow_st:1;
        RBus_UInt32  res3:2;
        RBus_UInt32  g_fifo_even_overflow_st:1;
        RBus_UInt32  r_fifo_even_overflow_st:1;
        RBus_UInt32  b_fifo_even_overflow_st:1;
        RBus_UInt32  res4:4;
    };
}od_dma_oddma_pq_cmp_irq_st_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  g_ratio_max:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  g_ratio_min:5;
        RBus_UInt32  res3:2;
        RBus_UInt32  cmp_package_height_cnt:14;
    };
}od_dma_oddma_pq_cmp_st_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  long_term_qp_measure_en:1;
        RBus_UInt32  res1:7;
        RBus_UInt32  long_term_g_qp_max:4;
        RBus_UInt32  long_term_rb_qp_max:4;
        RBus_UInt32  res2:8;
        RBus_UInt32  short_term_g_qp_max:4;
        RBus_UInt32  short_term_rb_qp_max:4;
    };
}od_dma_oddma_pq_cmp_qp_st_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fifo_water_measure_en:1;
        RBus_UInt32  res1:7;
        RBus_UInt32  fifo_water_even_g:8;
        RBus_UInt32  fifo_water_even_r:8;
        RBus_UInt32  fifo_water_even_b:8;
    };
}od_dma_oddma_pq_cmp_fifo_st1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  g_frame_left:16;
        RBus_UInt32  rb_frame_left:16;
    };
}od_dma_oddma_pq_cmp_left_st_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  total_package_long_term:1;
        RBus_UInt32  res1:7;
        RBus_UInt32  total_package_even:24;
    };
}od_dma_oddma_pq_cmp_package_st_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmp_crc_even_g:32;
    };
}od_dma_oddma_pq_cmp_crc_even_g_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmp_crc_even_r:32;
    };
}od_dma_oddma_pq_cmp_crc_even_r_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmp_crc_even_b:32;
    };
}od_dma_oddma_pq_cmp_crc_even_b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  blk0_add_value0:6;
        RBus_UInt32  dic_mode_tolerance:8;
        RBus_UInt32  res2:2;
        RBus_UInt32  blk0_add_value32:6;
        RBus_UInt32  res3:2;
        RBus_UInt32  blk0_add_value16:6;
    };
}od_dma_oddma_pq_cmp_blk0_add0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  blk0_add_value8:6;
        RBus_UInt32  res2:2;
        RBus_UInt32  blk0_add_value4:6;
        RBus_UInt32  res3:2;
        RBus_UInt32  blk0_add_value2:6;
        RBus_UInt32  res4:2;
        RBus_UInt32  blk0_add_value1:6;
    };
}od_dma_oddma_pq_cmp_blk0_add1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decmp_en:1;
        RBus_UInt32  res1:6;
        RBus_UInt32  decmp_width_div32:9;
        RBus_UInt32  res2:2;
        RBus_UInt32  decmp_height:14;
    };
}od_dma_oddma_pq_decmp_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decmp_line_sum_bit:16;
        RBus_UInt32  decmp_400_old_mode_en:1;
        RBus_UInt32  dummy1802cd84_14_11:4;
        RBus_UInt32  decmp_jump4_en:1;
        RBus_UInt32  decmp_qp_mode:2;
        RBus_UInt32  dummy1802cd84_7:1;
        RBus_UInt32  decmp_two_line_prediction_en:1;
        RBus_UInt32  decmp_line_mode:1;
        RBus_UInt32  decmp_data_color:1;
        RBus_UInt32  decmp_data_bit_width:2;
        RBus_UInt32  decmp_data_format:2;
    };
}od_dma_oddma_pq_decmp_pair_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  decmp_crc_ro_line_sel:14;
        RBus_UInt32  res2:13;
        RBus_UInt32  saturation_type_delta:1;
        RBus_UInt32  saturation_type:1;
        RBus_UInt32  saturation_en:1;
    };
}od_dma_oddma_pq_decmp_sat_en_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:10;
        RBus_UInt32  not_finish_irq_even_en:1;
        RBus_UInt32  underflow_irq_even_en:1;
        RBus_UInt32  dic_error_even_en:1;
        RBus_UInt32  crc_r_error_even_en:1;
        RBus_UInt32  crc_g_error_even_en:1;
        RBus_UInt32  crc_b_error_even_en:1;
        RBus_UInt32  res2:16;
    };
}od_dma_oddma_pq_decmp_irq_en_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pqdc_irq:1;
        RBus_UInt32  res1:3;
        RBus_UInt32  in_fifo_overflow_even_st:1;
        RBus_UInt32  ring_r_overflow_even_st:1;
        RBus_UInt32  ring_g_overflow_even_st:1;
        RBus_UInt32  ring_b_overflow_even_st:1;
        RBus_UInt32  res2:2;
        RBus_UInt32  not_finish_irq_even_st:1;
        RBus_UInt32  underflow_irq_even_st:1;
        RBus_UInt32  dic_error_even_st:1;
        RBus_UInt32  crc_r_error_even_st:1;
        RBus_UInt32  crc_g_error_even_st:1;
        RBus_UInt32  crc_b_error_even_st:1;
        RBus_UInt32  res3:16;
    };
}od_dma_oddma_pq_decmp_irq_st_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mark_en_do_422:1;
        RBus_UInt32  res1:13;
        RBus_UInt32  mark_en_dic:1;
        RBus_UInt32  mark_en_qp_sel:1;
        RBus_UInt32  res2:8;
        RBus_UInt32  mark_en_qp7:1;
        RBus_UInt32  mark_en_qp6:1;
        RBus_UInt32  mark_en_qp5:1;
        RBus_UInt32  mark_en_qp4:1;
        RBus_UInt32  mark_en_qp3:1;
        RBus_UInt32  mark_en_qp2:1;
        RBus_UInt32  mark_en_qp1:1;
        RBus_UInt32  mark_en_qp0:1;
    };
}od_dma_oddma_pq_decmp_mark_en_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mark_color_0:16;
        RBus_UInt32  mark_color_1:16;
    };
}od_dma_oddma_pq_decmp_mark_color_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mark_color_2:16;
        RBus_UInt32  mark_color_3:16;
    };
}od_dma_oddma_pq_decmp_mark_color_23_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mark_color_4:16;
        RBus_UInt32  mark_color_5:16;
    };
}od_dma_oddma_pq_decmp_mark_color_45_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mark_color_6:16;
        RBus_UInt32  mark_color_7:16;
    };
}od_dma_oddma_pq_decmp_mark_color_67_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mark_color_dic:16;
        RBus_UInt32  mark_color_422:16;
    };
}od_dma_oddma_pq_decmp_mark_color_422_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  decmp_crc_error_line:14;
        RBus_UInt32  res2:2;
        RBus_UInt32  decmp_package_height_cnt:14;
    };
}od_dma_oddma_pq_decmp_st_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decmp_crc_even_g:32;
    };
}od_dma_oddma_pq_decmp_crc_even_g_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decmp_crc_even_r:32;
    };
}od_dma_oddma_pq_decmp_crc_even_r_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decmp_crc_even_b:32;
    };
}od_dma_oddma_pq_decmp_crc_even_b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decmp_pause_cycle_measure_en:1;
        RBus_UInt32  decmp_pause_cycle_long_term:1;
        RBus_UInt32  res1:22;
        RBus_UInt32  decmp_pause_cycle:8;
    };
}od_dma_oddma_pq_decmp_pause_cycle_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy1802cdd4_31_2:30;
        RBus_UInt32  tr_en:1;
        RBus_UInt32  comp_de_comp_bypass:1;
    };
}od_dma_oddma_pqc_pqdc_compensation_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:23;
        RBus_UInt32  smooth_tog_en:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  disp_db_apply:1;
        RBus_UInt32  disp_db_rd_sel:1;
        RBus_UInt32  disp_db_en:1;
        RBus_UInt32  res3:1;
        RBus_UInt32  cap_db_apply:1;
        RBus_UInt32  cap_db_rd_sel:1;
        RBus_UInt32  cap_db_en:1;
    };
}od_dma_od_dma_db_en_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:9;
        RBus_UInt32  bit_sel:2;
        RBus_UInt32  pixel_encoding:1;
        RBus_UInt32  cap_block_fw:1;
        RBus_UInt32  set_block_sel:1;
        RBus_UInt32  auto_block_sel_en:1;
        RBus_UInt32  oddma_mode_sel:1;
        RBus_UInt32  res2:16;
    };
}od_dma_od_dma_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  vact:16;
        RBus_UInt32  res1:1;
        RBus_UInt32  hact:15;
    };
}od_dma_od_dma_ctrl_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy1802cdec_31_14:18;
        RBus_UInt32  disp_underflow:1;
        RBus_UInt32  cap_overflow:1;
        RBus_UInt32  cap_over_size:1;
        RBus_UInt32  cap_under_size:1;
        RBus_UInt32  freeze_ok:1;
        RBus_UInt32  vs_rising_occur:1;
        RBus_UInt32  cap_block:1;
        RBus_UInt32  res1:4;
        RBus_UInt32  disp_fifo_err_ie:1;
        RBus_UInt32  cap_fifo_err_ie:1;
        RBus_UInt32  vs_rising_ie:1;
    };
}od_dma_od_dma_status_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap_up_limit:28;
        RBus_UInt32  res1:4;
    };
}od_dma_oddma_wr_rule_check_up_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap_low_limit:28;
        RBus_UInt32  res1:4;
    };
}od_dma_oddma_wr_rule_check_low_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  cap_max_outstanding:2;
        RBus_UInt32  res2:6;
        RBus_UInt32  cap_force_all_rst:1;
        RBus_UInt32  cap_en:1;
    };
}od_dma_oddma_wr_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:1;
        RBus_UInt32  cap_cmd_water:3;
        RBus_UInt32  res2:3;
        RBus_UInt32  cap_data_water:9;
        RBus_UInt32  res3:5;
        RBus_UInt32  cap_cur_outstanding:3;
        RBus_UInt32  res4:3;
        RBus_UInt32  cap_soft_rst_before_cmd_finish:1;
        RBus_UInt32  cap_soft_rst_with_data_left:1;
        RBus_UInt32  cap_data_fifo_underflow_err:1;
        RBus_UInt32  cap_exceed_range_err:1;
        RBus_UInt32  cap_zero_length_err:1;
    };
}od_dma_oddma_wr_status_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap_ack_num_error:1;
        RBus_UInt32  cap_last_no_ack_error:1;
        RBus_UInt32  res1:7;
        RBus_UInt32  cap_target_ack_num:7;
        RBus_UInt32  res2:1;
        RBus_UInt32  cap_last_ack_num:7;
        RBus_UInt32  res3:1;
        RBus_UInt32  cap_selected_bl:7;
    };
}od_dma_oddma_wr_status1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap_selected_addr:28;
        RBus_UInt32  res1:2;
        RBus_UInt32  cap_addr_bl_sel:2;
    };
}od_dma_oddma_wr_status2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap_monitor_en:1;
        RBus_UInt32  cap_monitor_conti:1;
        RBus_UInt32  res1:4;
        RBus_UInt32  cap_reach_thd:1;
        RBus_UInt32  cap_monitor_thd:9;
        RBus_UInt32  res2:7;
        RBus_UInt32  cap_highest_water_level:9;
    };
}od_dma_oddma_wr_water_monitor_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap_sta_addr_0:28;
        RBus_UInt32  res1:4;
    };
}od_dma_oddma_wr_num_bl_wrap_addr_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap_sta_addr_1:28;
        RBus_UInt32  res1:4;
    };
}od_dma_oddma_wr_num_bl_wrap_addr_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap_line_step:28;
        RBus_UInt32  res1:4;
    };
}od_dma_oddma_wr_num_bl_wrap_line_step_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  cap_line_num:12;
        RBus_UInt32  res2:5;
        RBus_UInt32  cap_burst_len:7;
        RBus_UInt32  res3:4;
    };
}od_dma_oddma_wr_num_bl_wrap_ctl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap_rolling_enable:1;
        RBus_UInt32  res1:3;
        RBus_UInt32  cap_rolling_space:12;
        RBus_UInt32  res2:16;
    };
}od_dma_oddma_wr_num_bl_wrap_rolling_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:5;
        RBus_UInt32  cap_line_128_num:23;
        RBus_UInt32  res2:4;
    };
}od_dma_oddma_wr_num_bl_wrap_word_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:5;
        RBus_UInt32  cap_remain_128_num:23;
        RBus_UInt32  res2:2;
        RBus_UInt32  cap_finish_status:2;
    };
}od_dma_oddma_wr_num_bl_wrap_st1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap_soft_rst_before_finish:1;
        RBus_UInt32  res1:3;
        RBus_UInt32  cap_remain_line_num:12;
        RBus_UInt32  res2:16;
    };
}od_dma_oddma_wr_num_bl_wrap_st2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  disp_up_limit:28;
        RBus_UInt32  res1:4;
    };
}od_dma_oddma_rd_rule_check_up_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  disp_low_limit:28;
        RBus_UInt32  res1:4;
    };
}od_dma_oddma_rd_rule_check_low_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  disp_max_outstanding:2;
        RBus_UInt32  res2:6;
        RBus_UInt32  disp_force_all_rst:1;
        RBus_UInt32  disp_en:1;
    };
}od_dma_oddma_rd_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:1;
        RBus_UInt32  disp_cmd_water:3;
        RBus_UInt32  res2:3;
        RBus_UInt32  disp_data_water:9;
        RBus_UInt32  res3:5;
        RBus_UInt32  disp_cur_outstanding:3;
        RBus_UInt32  res4:3;
        RBus_UInt32  disp_soft_rst_before_cmd_finish:1;
        RBus_UInt32  disp_soft_rst_with_data_left:1;
        RBus_UInt32  disp_data_fifo_overflow_err:1;
        RBus_UInt32  disp_exceed_range_err:1;
        RBus_UInt32  disp_zero_length_err:1;
    };
}od_dma_oddma_rd_status_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  disp_ack_num_error:1;
        RBus_UInt32  disp_last_no_ack_error:1;
        RBus_UInt32  res1:7;
        RBus_UInt32  disp_target_ack_num:7;
        RBus_UInt32  res2:1;
        RBus_UInt32  disp_last_ack_num:7;
        RBus_UInt32  res3:1;
        RBus_UInt32  disp_selected_bl:7;
    };
}od_dma_oddma_rd_status1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  disp_selected_addr:28;
        RBus_UInt32  res1:2;
        RBus_UInt32  disp_addr_bl_sel:2;
    };
}od_dma_oddma_rd_status2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  disp_monitor_en:1;
        RBus_UInt32  disp_monitor_conti:1;
        RBus_UInt32  res1:4;
        RBus_UInt32  disp_reach_thd:1;
        RBus_UInt32  disp_monitor_thd:9;
        RBus_UInt32  res2:7;
        RBus_UInt32  disp_lowest_water_level:9;
    };
}od_dma_oddma_rd_water_monitor_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  disp_sta_addr_0:28;
        RBus_UInt32  res1:4;
    };
}od_dma_oddma_rd_num_bl_wrap_addr_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  disp_sta_addr_1:28;
        RBus_UInt32  res1:4;
    };
}od_dma_oddma_rd_num_bl_wrap_addr_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  disp_line_step:28;
        RBus_UInt32  res1:4;
    };
}od_dma_oddma_rd_num_bl_wrap_line_step_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  disp_line_num:12;
        RBus_UInt32  res2:5;
        RBus_UInt32  disp_burst_len:7;
        RBus_UInt32  res3:4;
    };
}od_dma_oddma_rd_num_bl_wrap_ctl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  disp_rolling_enable:1;
        RBus_UInt32  res1:3;
        RBus_UInt32  disp_rolling_space:12;
        RBus_UInt32  res2:16;
    };
}od_dma_oddma_rd_num_bl_wrap_rolling_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:5;
        RBus_UInt32  disp_line_128_num:23;
        RBus_UInt32  res2:4;
    };
}od_dma_oddma_rd_num_bl_wrap_word_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:5;
        RBus_UInt32  disp_remain_128_num:23;
        RBus_UInt32  res2:2;
        RBus_UInt32  disp_finish_status:2;
    };
}od_dma_oddma_rd_num_bl_wrap_st1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  disp_soft_rst_before_finish:1;
        RBus_UInt32  res1:3;
        RBus_UInt32  disp_remain_line_num:12;
        RBus_UInt32  res2:16;
    };
}od_dma_oddma_rd_num_bl_wrap_st2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  match_buffer:2;
        RBus_UInt32  crc_comp_error_int:1;
        RBus_UInt32  dynamic_crc_cmp_en:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  crc_comp_error_flag:1;
        RBus_UInt32  crc_bit_sel:3;
        RBus_UInt32  crc_pixel_encoding:1;
        RBus_UInt32  res3:14;
        RBus_UInt32  disp_crc_conti:1;
        RBus_UInt32  disp_crc_start:1;
        RBus_UInt32  res4:2;
        RBus_UInt32  cap_crc_conti:1;
        RBus_UInt32  cap_crc_start:1;
    };
}od_dma_oddma_crc_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  crc_mask:30;
    };
}od_dma_oddma_crc_mask_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap_l_crc_result:32;
    };
}od_dma_oddma_cap_l_crc_result_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  disp_l_crc_result:32;
    };
}od_dma_oddma_disp_l_crc_result_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  pqc2_rm_1:4;
        RBus_UInt32  pqc2_rm_0:4;
        RBus_UInt32  pqc1_rm_0:4;
        RBus_UInt32  res2:12;
        RBus_UInt32  cap_rm:4;
    };
}od_dma_oddma_cap_rm_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pqc_test_rwm:1;
        RBus_UInt32  res1:12;
        RBus_UInt32  pqc2_rme_1:1;
        RBus_UInt32  pqc2_rme_0:1;
        RBus_UInt32  pqc1_rme_0:1;
        RBus_UInt32  res2:14;
        RBus_UInt32  cap_test:1;
        RBus_UInt32  cap_rme:1;
    };
}od_dma_oddma_cap_rme_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:13;
        RBus_UInt32  pqc2_ls_1:1;
        RBus_UInt32  pqc2_ls_0:1;
        RBus_UInt32  pqc1_ls_0:1;
        RBus_UInt32  res2:15;
        RBus_UInt32  cap_ls:1;
    };
}od_dma_oddma_cap_ls_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  pqc2_bist_fail_12:1;
        RBus_UInt32  pqc2_bist_fail_11:1;
        RBus_UInt32  pqc2_bist_fail_10:1;
        RBus_UInt32  pqc2_bist_fail_9:1;
        RBus_UInt32  pqc2_bist_fail_8:1;
        RBus_UInt32  pqc2_bist_fail_7:1;
        RBus_UInt32  pqc2_bist_fail_6:1;
        RBus_UInt32  pqc2_bist_fail_5:1;
        RBus_UInt32  pqc2_bist_fail_4:1;
        RBus_UInt32  pqc2_bist_fail_3:1;
        RBus_UInt32  pqc2_bist_fail_2:1;
        RBus_UInt32  pqc2_bist_fail_1:1;
        RBus_UInt32  pqc2_bist_fail_0:1;
        RBus_UInt32  pqc1_bist_fail_0:1;
        RBus_UInt32  res2:15;
        RBus_UInt32  cap_bist_fail:1;
    };
}od_dma_oddma_cap_fail_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  pqc2_drf_fail_12:1;
        RBus_UInt32  pqc2_drf_fail_11:1;
        RBus_UInt32  pqc2_drf_fail_10:1;
        RBus_UInt32  pqc2_drf_fail_9:1;
        RBus_UInt32  pqc2_drf_fail_8:1;
        RBus_UInt32  pqc2_drf_fail_7:1;
        RBus_UInt32  pqc2_drf_fail_6:1;
        RBus_UInt32  pqc2_drf_fail_5:1;
        RBus_UInt32  pqc2_drf_fail_4:1;
        RBus_UInt32  pqc2_drf_fail_3:1;
        RBus_UInt32  pqc2_drf_fail_2:1;
        RBus_UInt32  pqc2_drf_fail_1:1;
        RBus_UInt32  pqc2_drf_fail_0:1;
        RBus_UInt32  pqc1_drf_fail_0:1;
        RBus_UInt32  res2:15;
        RBus_UInt32  cap_drf_fail:1;
    };
}od_dma_oddma_cap_drf_fail_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  pqdc2_rm_0:4;
        RBus_UInt32  pqdc1_rm_0:4;
        RBus_UInt32  res2:12;
        RBus_UInt32  disp_rm:4;
    };
}od_dma_oddma_disp_rm_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pqdc_test_rwm:1;
        RBus_UInt32  res1:13;
        RBus_UInt32  pqdc2_rme_0:1;
        RBus_UInt32  pqdc1_rme_0:1;
        RBus_UInt32  res2:14;
        RBus_UInt32  disp_test:1;
        RBus_UInt32  disp_rme:1;
    };
}od_dma_oddma_disp_rme_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:14;
        RBus_UInt32  pqdc2_ls_0:1;
        RBus_UInt32  pqdc1_ls_0:1;
        RBus_UInt32  res2:15;
        RBus_UInt32  disp_ls:1;
    };
}od_dma_oddma_disp_ls_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:13;
        RBus_UInt32  pqdc2_bist_fail_1:1;
        RBus_UInt32  pqdc2_bist_fail_0:1;
        RBus_UInt32  pqdc1_bist_fail_0:1;
        RBus_UInt32  res2:15;
        RBus_UInt32  disp_bist_fail:1;
    };
}od_dma_oddma_disp_bist_fail_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:13;
        RBus_UInt32  pqdc2_drf_fail_1:1;
        RBus_UInt32  pqdc2_drf_fail_0:1;
        RBus_UInt32  pqdc1_drf_fail_0:1;
        RBus_UInt32  res2:15;
        RBus_UInt32  disp_drf_fail:1;
    };
}od_dma_oddma_disp_drf_fail_RBUS;

#else //apply LITTLE_ENDIAN

//======OD_DMA register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmp_height:14;
        RBus_UInt32  res1:2;
        RBus_UInt32  cmp_width_div32:9;
        RBus_UInt32  res2:6;
        RBus_UInt32  cmp_en:1;
    };
}od_dma_oddma_pq_cmp_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmp_data_format:2;
        RBus_UInt32  cmp_data_bit_width:2;
        RBus_UInt32  cmp_data_color:1;
        RBus_UInt32  cmp_line_mode:1;
        RBus_UInt32  two_line_prediction_en:1;
        RBus_UInt32  dummy1802cd04_7:1;
        RBus_UInt32  cmp_qp_mode:2;
        RBus_UInt32  cmp_jump4_en:1;
        RBus_UInt32  dummy1802cd04_14_11:4;
        RBus_UInt32  cmp_400_old_mode_en:1;
        RBus_UInt32  cmp_line_sum_bit:16;
    };
}od_dma_oddma_pq_cmp_pair_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  frame_limit_bit:6;
        RBus_UInt32  res1:2;
        RBus_UInt32  line_limit_bit:6;
        RBus_UInt32  res2:2;
        RBus_UInt32  block_limit_bit:6;
        RBus_UInt32  res3:2;
        RBus_UInt32  first_line_more_bit:6;
        RBus_UInt32  res4:2;
    };
}od_dma_oddma_pq_cmp_bit_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  rb_lossy_do_422_en:1;
        RBus_UInt32  not_rich_do_422_en:1;
        RBus_UInt32  not_enough_bit_do_422_en:1;
        RBus_UInt32  first_predict_nc_en:1;
        RBus_UInt32  do_422_mode:2;
        RBus_UInt32  blk0_add_half_en:1;
        RBus_UInt32  fisrt_line_more_en:1;
        RBus_UInt32  balance_en:1;
        RBus_UInt32  poor_limit_min_qp_en:1;
        RBus_UInt32  dynamic_allocate_ratio_en:1;
        RBus_UInt32  guarantee_max_qp_en:1;
        RBus_UInt32  blk0_add_en:1;
        RBus_UInt32  dynamic_sum_line_rst:1;
        RBus_UInt32  variation_maxmin_en:1;
        RBus_UInt32  add_last2blk_over_curve_bit:1;
        RBus_UInt32  g_ratio:5;
        RBus_UInt32  res1:5;
        RBus_UInt32  first_predict_nc_mode:1;
        RBus_UInt32  tail_dummy_throughput:1;
        RBus_UInt32  input_fifo_pause_cycle:4;
    };
}od_dma_oddma_pq_cmp_enable_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  variation_near_num_th:3;
        RBus_UInt32  res1:1;
        RBus_UInt32  variation_num_th:3;
        RBus_UInt32  res2:1;
        RBus_UInt32  variation_value_th:4;
        RBus_UInt32  dic_mode_entry_th:4;
        RBus_UInt32  rb_lossy_do_422_qp_level:3;
        RBus_UInt32  res3:1;
        RBus_UInt32  not_rich_do_422_th:4;
        RBus_UInt32  not_enough_bit_do_422_qp:3;
        RBus_UInt32  res4:1;
        RBus_UInt32  dic_mode_option:4;
    };
}od_dma_oddma_pq_cmp_smooth_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dynamic_allocate_less:4;
        RBus_UInt32  dynamic_allocate_more:4;
        RBus_UInt32  dynamic_allocate_line:3;
        RBus_UInt32  res1:5;
        RBus_UInt32  dynamic_allocate_ratio_min:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  dynamic_allocate_ratio_max:5;
        RBus_UInt32  res3:3;
    };
}od_dma_oddma_pq_cmp_allocate_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  poor_limit_th_qp1:5;
        RBus_UInt32  res1:3;
        RBus_UInt32  poor_limit_th_qp2:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  poor_limit_th_qp3:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  poor_limit_th_qp4:5;
        RBus_UInt32  res4:3;
    };
}od_dma_oddma_pq_cmp_poor_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  guarantee_max_g_qp:4;
        RBus_UInt32  guarantee_max_rb_qp:4;
        RBus_UInt32  dic_mode_qp_th_g:4;
        RBus_UInt32  dic_mode_qp_th_rb:4;
        RBus_UInt32  cmp_crc_ro_line_sel:14;
        RBus_UInt32  res1:2;
    };
}od_dma_oddma_pq_cmp_guarantee_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  balance_g_give:2;
        RBus_UInt32  balance_g_ud_th:2;
        RBus_UInt32  balance_g_ov_th:2;
        RBus_UInt32  res1:2;
        RBus_UInt32  balance_rb_give:2;
        RBus_UInt32  balance_rb_ud_th:2;
        RBus_UInt32  balance_rb_ov_th:2;
        RBus_UInt32  res2:2;
        RBus_UInt32  variation_maxmin_th:8;
        RBus_UInt32  variation_maxmin_th2:8;
    };
}od_dma_oddma_pq_cmp_balance_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  b_fifo_even_overflow_irq_en:1;
        RBus_UInt32  r_fifo_even_overflow_irq_en:1;
        RBus_UInt32  g_fifo_even_overflow_irq_en:1;
        RBus_UInt32  res2:2;
        RBus_UInt32  request_fifo_even_overflow_irq_en:1;
        RBus_UInt32  res3:2;
        RBus_UInt32  over_flb_irq_en:1;
        RBus_UInt32  input_size_less_irq_en:1;
        RBus_UInt32  input_size_more_irq_en:1;
        RBus_UInt32  block_fifo_overflow_irq_en:1;
        RBus_UInt32  input_fifo_overflow_irq_en:1;
        RBus_UInt32  tail_fifo_overflow_irq_en:1;
        RBus_UInt32  prs_over_line_sum_bit_irq_en:1;
        RBus_UInt32  res4:13;
    };
}od_dma_oddma_pq_cmp_irq_en_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  b_fifo_even_overflow_st:1;
        RBus_UInt32  r_fifo_even_overflow_st:1;
        RBus_UInt32  g_fifo_even_overflow_st:1;
        RBus_UInt32  res2:2;
        RBus_UInt32  request_fifo_even_overflow_st:1;
        RBus_UInt32  res3:2;
        RBus_UInt32  over_flb_st:1;
        RBus_UInt32  input_size_less_st:1;
        RBus_UInt32  input_size_more_st:1;
        RBus_UInt32  block_fifo_overflow_st:1;
        RBus_UInt32  input_fifo_overflow_st:1;
        RBus_UInt32  tail_fifo_overflow_st:1;
        RBus_UInt32  prs_over_line_sum_bit_st:1;
        RBus_UInt32  res4:12;
        RBus_UInt32  pqc_irq:1;
    };
}od_dma_oddma_pq_cmp_irq_st_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmp_package_height_cnt:14;
        RBus_UInt32  res1:2;
        RBus_UInt32  g_ratio_min:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  g_ratio_max:5;
        RBus_UInt32  res3:3;
    };
}od_dma_oddma_pq_cmp_st_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  short_term_rb_qp_max:4;
        RBus_UInt32  short_term_g_qp_max:4;
        RBus_UInt32  res1:8;
        RBus_UInt32  long_term_rb_qp_max:4;
        RBus_UInt32  long_term_g_qp_max:4;
        RBus_UInt32  res2:7;
        RBus_UInt32  long_term_qp_measure_en:1;
    };
}od_dma_oddma_pq_cmp_qp_st_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fifo_water_even_b:8;
        RBus_UInt32  fifo_water_even_r:8;
        RBus_UInt32  fifo_water_even_g:8;
        RBus_UInt32  res1:7;
        RBus_UInt32  fifo_water_measure_en:1;
    };
}od_dma_oddma_pq_cmp_fifo_st1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  rb_frame_left:16;
        RBus_UInt32  g_frame_left:16;
    };
}od_dma_oddma_pq_cmp_left_st_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  total_package_even:24;
        RBus_UInt32  res1:7;
        RBus_UInt32  total_package_long_term:1;
    };
}od_dma_oddma_pq_cmp_package_st_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmp_crc_even_g:32;
    };
}od_dma_oddma_pq_cmp_crc_even_g_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmp_crc_even_r:32;
    };
}od_dma_oddma_pq_cmp_crc_even_r_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmp_crc_even_b:32;
    };
}od_dma_oddma_pq_cmp_crc_even_b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  blk0_add_value16:6;
        RBus_UInt32  res1:2;
        RBus_UInt32  blk0_add_value32:6;
        RBus_UInt32  res2:2;
        RBus_UInt32  dic_mode_tolerance:8;
        RBus_UInt32  blk0_add_value0:6;
        RBus_UInt32  res3:2;
    };
}od_dma_oddma_pq_cmp_blk0_add0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  blk0_add_value1:6;
        RBus_UInt32  res1:2;
        RBus_UInt32  blk0_add_value2:6;
        RBus_UInt32  res2:2;
        RBus_UInt32  blk0_add_value4:6;
        RBus_UInt32  res3:2;
        RBus_UInt32  blk0_add_value8:6;
        RBus_UInt32  res4:2;
    };
}od_dma_oddma_pq_cmp_blk0_add1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decmp_height:14;
        RBus_UInt32  res1:2;
        RBus_UInt32  decmp_width_div32:9;
        RBus_UInt32  res2:6;
        RBus_UInt32  decmp_en:1;
    };
}od_dma_oddma_pq_decmp_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decmp_data_format:2;
        RBus_UInt32  decmp_data_bit_width:2;
        RBus_UInt32  decmp_data_color:1;
        RBus_UInt32  decmp_line_mode:1;
        RBus_UInt32  decmp_two_line_prediction_en:1;
        RBus_UInt32  dummy1802cd84_7:1;
        RBus_UInt32  decmp_qp_mode:2;
        RBus_UInt32  decmp_jump4_en:1;
        RBus_UInt32  dummy1802cd84_14_11:4;
        RBus_UInt32  decmp_400_old_mode_en:1;
        RBus_UInt32  decmp_line_sum_bit:16;
    };
}od_dma_oddma_pq_decmp_pair_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  saturation_en:1;
        RBus_UInt32  saturation_type:1;
        RBus_UInt32  saturation_type_delta:1;
        RBus_UInt32  res1:13;
        RBus_UInt32  decmp_crc_ro_line_sel:14;
        RBus_UInt32  res2:2;
    };
}od_dma_oddma_pq_decmp_sat_en_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  crc_b_error_even_en:1;
        RBus_UInt32  crc_g_error_even_en:1;
        RBus_UInt32  crc_r_error_even_en:1;
        RBus_UInt32  dic_error_even_en:1;
        RBus_UInt32  underflow_irq_even_en:1;
        RBus_UInt32  not_finish_irq_even_en:1;
        RBus_UInt32  res2:10;
    };
}od_dma_oddma_pq_decmp_irq_en_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  crc_b_error_even_st:1;
        RBus_UInt32  crc_g_error_even_st:1;
        RBus_UInt32  crc_r_error_even_st:1;
        RBus_UInt32  dic_error_even_st:1;
        RBus_UInt32  underflow_irq_even_st:1;
        RBus_UInt32  not_finish_irq_even_st:1;
        RBus_UInt32  res2:2;
        RBus_UInt32  ring_b_overflow_even_st:1;
        RBus_UInt32  ring_g_overflow_even_st:1;
        RBus_UInt32  ring_r_overflow_even_st:1;
        RBus_UInt32  in_fifo_overflow_even_st:1;
        RBus_UInt32  res3:3;
        RBus_UInt32  pqdc_irq:1;
    };
}od_dma_oddma_pq_decmp_irq_st_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mark_en_qp0:1;
        RBus_UInt32  mark_en_qp1:1;
        RBus_UInt32  mark_en_qp2:1;
        RBus_UInt32  mark_en_qp3:1;
        RBus_UInt32  mark_en_qp4:1;
        RBus_UInt32  mark_en_qp5:1;
        RBus_UInt32  mark_en_qp6:1;
        RBus_UInt32  mark_en_qp7:1;
        RBus_UInt32  res1:8;
        RBus_UInt32  mark_en_qp_sel:1;
        RBus_UInt32  mark_en_dic:1;
        RBus_UInt32  res2:13;
        RBus_UInt32  mark_en_do_422:1;
    };
}od_dma_oddma_pq_decmp_mark_en_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mark_color_1:16;
        RBus_UInt32  mark_color_0:16;
    };
}od_dma_oddma_pq_decmp_mark_color_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mark_color_3:16;
        RBus_UInt32  mark_color_2:16;
    };
}od_dma_oddma_pq_decmp_mark_color_23_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mark_color_5:16;
        RBus_UInt32  mark_color_4:16;
    };
}od_dma_oddma_pq_decmp_mark_color_45_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mark_color_7:16;
        RBus_UInt32  mark_color_6:16;
    };
}od_dma_oddma_pq_decmp_mark_color_67_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mark_color_422:16;
        RBus_UInt32  mark_color_dic:16;
    };
}od_dma_oddma_pq_decmp_mark_color_422_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decmp_package_height_cnt:14;
        RBus_UInt32  res1:2;
        RBus_UInt32  decmp_crc_error_line:14;
        RBus_UInt32  res2:2;
    };
}od_dma_oddma_pq_decmp_st_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decmp_crc_even_g:32;
    };
}od_dma_oddma_pq_decmp_crc_even_g_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decmp_crc_even_r:32;
    };
}od_dma_oddma_pq_decmp_crc_even_r_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decmp_crc_even_b:32;
    };
}od_dma_oddma_pq_decmp_crc_even_b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decmp_pause_cycle:8;
        RBus_UInt32  res1:22;
        RBus_UInt32  decmp_pause_cycle_long_term:1;
        RBus_UInt32  decmp_pause_cycle_measure_en:1;
    };
}od_dma_oddma_pq_decmp_pause_cycle_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  comp_de_comp_bypass:1;
        RBus_UInt32  tr_en:1;
        RBus_UInt32  dummy1802cdd4_31_2:30;
    };
}od_dma_oddma_pqc_pqdc_compensation_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap_db_en:1;
        RBus_UInt32  cap_db_rd_sel:1;
        RBus_UInt32  cap_db_apply:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  disp_db_en:1;
        RBus_UInt32  disp_db_rd_sel:1;
        RBus_UInt32  disp_db_apply:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  smooth_tog_en:1;
        RBus_UInt32  res3:23;
    };
}od_dma_od_dma_db_en_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  oddma_mode_sel:1;
        RBus_UInt32  auto_block_sel_en:1;
        RBus_UInt32  set_block_sel:1;
        RBus_UInt32  cap_block_fw:1;
        RBus_UInt32  pixel_encoding:1;
        RBus_UInt32  bit_sel:2;
        RBus_UInt32  res2:9;
    };
}od_dma_od_dma_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hact:15;
        RBus_UInt32  res1:1;
        RBus_UInt32  vact:16;
    };
}od_dma_od_dma_ctrl_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  vs_rising_ie:1;
        RBus_UInt32  cap_fifo_err_ie:1;
        RBus_UInt32  disp_fifo_err_ie:1;
        RBus_UInt32  res1:4;
        RBus_UInt32  cap_block:1;
        RBus_UInt32  vs_rising_occur:1;
        RBus_UInt32  freeze_ok:1;
        RBus_UInt32  cap_under_size:1;
        RBus_UInt32  cap_over_size:1;
        RBus_UInt32  cap_overflow:1;
        RBus_UInt32  disp_underflow:1;
        RBus_UInt32  dummy1802cdec_31_14:18;
    };
}od_dma_od_dma_status_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  cap_up_limit:28;
    };
}od_dma_oddma_wr_rule_check_up_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  cap_low_limit:28;
    };
}od_dma_oddma_wr_rule_check_low_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap_en:1;
        RBus_UInt32  cap_force_all_rst:1;
        RBus_UInt32  res1:6;
        RBus_UInt32  cap_max_outstanding:2;
        RBus_UInt32  res2:22;
    };
}od_dma_oddma_wr_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap_zero_length_err:1;
        RBus_UInt32  cap_exceed_range_err:1;
        RBus_UInt32  cap_data_fifo_underflow_err:1;
        RBus_UInt32  cap_soft_rst_with_data_left:1;
        RBus_UInt32  cap_soft_rst_before_cmd_finish:1;
        RBus_UInt32  res1:3;
        RBus_UInt32  cap_cur_outstanding:3;
        RBus_UInt32  res2:5;
        RBus_UInt32  cap_data_water:9;
        RBus_UInt32  res3:3;
        RBus_UInt32  cap_cmd_water:3;
        RBus_UInt32  res4:1;
    };
}od_dma_oddma_wr_status_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap_selected_bl:7;
        RBus_UInt32  res1:1;
        RBus_UInt32  cap_last_ack_num:7;
        RBus_UInt32  res2:1;
        RBus_UInt32  cap_target_ack_num:7;
        RBus_UInt32  res3:7;
        RBus_UInt32  cap_last_no_ack_error:1;
        RBus_UInt32  cap_ack_num_error:1;
    };
}od_dma_oddma_wr_status1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap_addr_bl_sel:2;
        RBus_UInt32  res1:2;
        RBus_UInt32  cap_selected_addr:28;
    };
}od_dma_oddma_wr_status2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap_highest_water_level:9;
        RBus_UInt32  res1:7;
        RBus_UInt32  cap_monitor_thd:9;
        RBus_UInt32  cap_reach_thd:1;
        RBus_UInt32  res2:4;
        RBus_UInt32  cap_monitor_conti:1;
        RBus_UInt32  cap_monitor_en:1;
    };
}od_dma_oddma_wr_water_monitor_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  cap_sta_addr_0:28;
    };
}od_dma_oddma_wr_num_bl_wrap_addr_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  cap_sta_addr_1:28;
    };
}od_dma_oddma_wr_num_bl_wrap_addr_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  cap_line_step:28;
    };
}od_dma_oddma_wr_num_bl_wrap_line_step_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  cap_burst_len:7;
        RBus_UInt32  res2:5;
        RBus_UInt32  cap_line_num:12;
        RBus_UInt32  res3:4;
    };
}od_dma_oddma_wr_num_bl_wrap_ctl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  cap_rolling_space:12;
        RBus_UInt32  res2:3;
        RBus_UInt32  cap_rolling_enable:1;
    };
}od_dma_oddma_wr_num_bl_wrap_rolling_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  cap_line_128_num:23;
        RBus_UInt32  res2:5;
    };
}od_dma_oddma_wr_num_bl_wrap_word_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap_finish_status:2;
        RBus_UInt32  res1:2;
        RBus_UInt32  cap_remain_128_num:23;
        RBus_UInt32  res2:5;
    };
}od_dma_oddma_wr_num_bl_wrap_st1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  cap_remain_line_num:12;
        RBus_UInt32  res2:3;
        RBus_UInt32  cap_soft_rst_before_finish:1;
    };
}od_dma_oddma_wr_num_bl_wrap_st2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  disp_up_limit:28;
    };
}od_dma_oddma_rd_rule_check_up_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  disp_low_limit:28;
    };
}od_dma_oddma_rd_rule_check_low_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  disp_en:1;
        RBus_UInt32  disp_force_all_rst:1;
        RBus_UInt32  res1:6;
        RBus_UInt32  disp_max_outstanding:2;
        RBus_UInt32  res2:22;
    };
}od_dma_oddma_rd_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  disp_zero_length_err:1;
        RBus_UInt32  disp_exceed_range_err:1;
        RBus_UInt32  disp_data_fifo_overflow_err:1;
        RBus_UInt32  disp_soft_rst_with_data_left:1;
        RBus_UInt32  disp_soft_rst_before_cmd_finish:1;
        RBus_UInt32  res1:3;
        RBus_UInt32  disp_cur_outstanding:3;
        RBus_UInt32  res2:5;
        RBus_UInt32  disp_data_water:9;
        RBus_UInt32  res3:3;
        RBus_UInt32  disp_cmd_water:3;
        RBus_UInt32  res4:1;
    };
}od_dma_oddma_rd_status_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  disp_selected_bl:7;
        RBus_UInt32  res1:1;
        RBus_UInt32  disp_last_ack_num:7;
        RBus_UInt32  res2:1;
        RBus_UInt32  disp_target_ack_num:7;
        RBus_UInt32  res3:7;
        RBus_UInt32  disp_last_no_ack_error:1;
        RBus_UInt32  disp_ack_num_error:1;
    };
}od_dma_oddma_rd_status1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  disp_addr_bl_sel:2;
        RBus_UInt32  res1:2;
        RBus_UInt32  disp_selected_addr:28;
    };
}od_dma_oddma_rd_status2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  disp_lowest_water_level:9;
        RBus_UInt32  res1:7;
        RBus_UInt32  disp_monitor_thd:9;
        RBus_UInt32  disp_reach_thd:1;
        RBus_UInt32  res2:4;
        RBus_UInt32  disp_monitor_conti:1;
        RBus_UInt32  disp_monitor_en:1;
    };
}od_dma_oddma_rd_water_monitor_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  disp_sta_addr_0:28;
    };
}od_dma_oddma_rd_num_bl_wrap_addr_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  disp_sta_addr_1:28;
    };
}od_dma_oddma_rd_num_bl_wrap_addr_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  disp_line_step:28;
    };
}od_dma_oddma_rd_num_bl_wrap_line_step_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  disp_burst_len:7;
        RBus_UInt32  res2:5;
        RBus_UInt32  disp_line_num:12;
        RBus_UInt32  res3:4;
    };
}od_dma_oddma_rd_num_bl_wrap_ctl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  disp_rolling_space:12;
        RBus_UInt32  res2:3;
        RBus_UInt32  disp_rolling_enable:1;
    };
}od_dma_oddma_rd_num_bl_wrap_rolling_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  disp_line_128_num:23;
        RBus_UInt32  res2:5;
    };
}od_dma_oddma_rd_num_bl_wrap_word_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  disp_finish_status:2;
        RBus_UInt32  res1:2;
        RBus_UInt32  disp_remain_128_num:23;
        RBus_UInt32  res2:5;
    };
}od_dma_oddma_rd_num_bl_wrap_st1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  disp_remain_line_num:12;
        RBus_UInt32  res2:3;
        RBus_UInt32  disp_soft_rst_before_finish:1;
    };
}od_dma_oddma_rd_num_bl_wrap_st2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap_crc_start:1;
        RBus_UInt32  cap_crc_conti:1;
        RBus_UInt32  res1:2;
        RBus_UInt32  disp_crc_start:1;
        RBus_UInt32  disp_crc_conti:1;
        RBus_UInt32  res2:14;
        RBus_UInt32  crc_pixel_encoding:1;
        RBus_UInt32  crc_bit_sel:3;
        RBus_UInt32  crc_comp_error_flag:1;
        RBus_UInt32  res3:1;
        RBus_UInt32  dynamic_crc_cmp_en:1;
        RBus_UInt32  crc_comp_error_int:1;
        RBus_UInt32  match_buffer:2;
        RBus_UInt32  res4:2;
    };
}od_dma_oddma_crc_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  crc_mask:30;
        RBus_UInt32  res1:2;
    };
}od_dma_oddma_crc_mask_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap_l_crc_result:32;
    };
}od_dma_oddma_cap_l_crc_result_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  disp_l_crc_result:32;
    };
}od_dma_oddma_disp_l_crc_result_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap_rm:4;
        RBus_UInt32  res1:12;
        RBus_UInt32  pqc1_rm_0:4;
        RBus_UInt32  pqc2_rm_0:4;
        RBus_UInt32  pqc2_rm_1:4;
        RBus_UInt32  res2:4;
    };
}od_dma_oddma_cap_rm_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap_rme:1;
        RBus_UInt32  cap_test:1;
        RBus_UInt32  res1:14;
        RBus_UInt32  pqc1_rme_0:1;
        RBus_UInt32  pqc2_rme_0:1;
        RBus_UInt32  pqc2_rme_1:1;
        RBus_UInt32  res2:12;
        RBus_UInt32  pqc_test_rwm:1;
    };
}od_dma_oddma_cap_rme_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap_ls:1;
        RBus_UInt32  res1:15;
        RBus_UInt32  pqc1_ls_0:1;
        RBus_UInt32  pqc2_ls_0:1;
        RBus_UInt32  pqc2_ls_1:1;
        RBus_UInt32  res2:13;
    };
}od_dma_oddma_cap_ls_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap_bist_fail:1;
        RBus_UInt32  res1:15;
        RBus_UInt32  pqc1_bist_fail_0:1;
        RBus_UInt32  pqc2_bist_fail_0:1;
        RBus_UInt32  pqc2_bist_fail_1:1;
        RBus_UInt32  pqc2_bist_fail_2:1;
        RBus_UInt32  pqc2_bist_fail_3:1;
        RBus_UInt32  pqc2_bist_fail_4:1;
        RBus_UInt32  pqc2_bist_fail_5:1;
        RBus_UInt32  pqc2_bist_fail_6:1;
        RBus_UInt32  pqc2_bist_fail_7:1;
        RBus_UInt32  pqc2_bist_fail_8:1;
        RBus_UInt32  pqc2_bist_fail_9:1;
        RBus_UInt32  pqc2_bist_fail_10:1;
        RBus_UInt32  pqc2_bist_fail_11:1;
        RBus_UInt32  pqc2_bist_fail_12:1;
        RBus_UInt32  res2:2;
    };
}od_dma_oddma_cap_fail_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap_drf_fail:1;
        RBus_UInt32  res1:15;
        RBus_UInt32  pqc1_drf_fail_0:1;
        RBus_UInt32  pqc2_drf_fail_0:1;
        RBus_UInt32  pqc2_drf_fail_1:1;
        RBus_UInt32  pqc2_drf_fail_2:1;
        RBus_UInt32  pqc2_drf_fail_3:1;
        RBus_UInt32  pqc2_drf_fail_4:1;
        RBus_UInt32  pqc2_drf_fail_5:1;
        RBus_UInt32  pqc2_drf_fail_6:1;
        RBus_UInt32  pqc2_drf_fail_7:1;
        RBus_UInt32  pqc2_drf_fail_8:1;
        RBus_UInt32  pqc2_drf_fail_9:1;
        RBus_UInt32  pqc2_drf_fail_10:1;
        RBus_UInt32  pqc2_drf_fail_11:1;
        RBus_UInt32  pqc2_drf_fail_12:1;
        RBus_UInt32  res2:2;
    };
}od_dma_oddma_cap_drf_fail_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  disp_rm:4;
        RBus_UInt32  res1:12;
        RBus_UInt32  pqdc1_rm_0:4;
        RBus_UInt32  pqdc2_rm_0:4;
        RBus_UInt32  res2:8;
    };
}od_dma_oddma_disp_rm_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  disp_rme:1;
        RBus_UInt32  disp_test:1;
        RBus_UInt32  res1:14;
        RBus_UInt32  pqdc1_rme_0:1;
        RBus_UInt32  pqdc2_rme_0:1;
        RBus_UInt32  res2:13;
        RBus_UInt32  pqdc_test_rwm:1;
    };
}od_dma_oddma_disp_rme_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  disp_ls:1;
        RBus_UInt32  res1:15;
        RBus_UInt32  pqdc1_ls_0:1;
        RBus_UInt32  pqdc2_ls_0:1;
        RBus_UInt32  res2:14;
    };
}od_dma_oddma_disp_ls_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  disp_bist_fail:1;
        RBus_UInt32  res1:15;
        RBus_UInt32  pqdc1_bist_fail_0:1;
        RBus_UInt32  pqdc2_bist_fail_0:1;
        RBus_UInt32  pqdc2_bist_fail_1:1;
        RBus_UInt32  res2:13;
    };
}od_dma_oddma_disp_bist_fail_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  disp_drf_fail:1;
        RBus_UInt32  res1:15;
        RBus_UInt32  pqdc1_drf_fail_0:1;
        RBus_UInt32  pqdc2_drf_fail_0:1;
        RBus_UInt32  pqdc2_drf_fail_1:1;
        RBus_UInt32  res2:13;
    };
}od_dma_oddma_disp_drf_fail_RBUS;




#endif 


#endif 
