/**
* @file Mac7p-DesignSpec-I-Domain_VGIP
* RBus systemc program.
*
* @author RS_MM2_SD
* @email jason9.ccc@realtek.com
 * @date 2019/11/22
* @ingroup model_rbus
 * @version { 1.0 }
 **
 */

#ifndef _RBUS_SUB_VGIP_PTG_REG_H_
#define _RBUS_SUB_VGIP_PTG_REG_H_

#include "rbusTypes.h"



//  SUB_VGIP_PTG Register Address



#define  SUB_VGIP_PTG_CH2_PTG_CTRL_VADDR                    	(0xb80227c0)
#define  SUB_VGIP_PTG_CH2_PTG_C0Y_CB_CR_VADDR               	(0xb80227c4)
#define  SUB_VGIP_PTG_CH2_PTG_C1Y_CB_CR_VADDR               	(0xb80227c8)
#define  SUB_VGIP_PTG_CH2_PTG_C2Y_CB_CR_VADDR               	(0xb80227cc)
#define  SUB_VGIP_PTG_CH2_PTG_C3Y_CB_CR_VADDR               	(0xb80227d0)
#define  SUB_VGIP_PTG_CH2_PTG_C4Y_CB_CR_VADDR               	(0xb80227d4)
#define  SUB_VGIP_PTG_CH2_PTG_C5Y_CR_CB_VADDR               	(0xb80227d8)
#define  SUB_VGIP_PTG_CH2_PTG_C6Y_CB_CR_VADDR               	(0xb80227dc)
#define  SUB_VGIP_PTG_CH2_PTG_C7Y_CB_CR_VADDR               	(0xb80227e0)
#define  SUB_VGIP_PTG_PTG_CHN2_ACT_HSTA_WIDTH_VADDR         	(0xb80227e8)
#define  SUB_VGIP_PTG_PTG_CHN2_ACT_VSTA_WIDTH_VADDR         	(0xb80227ec)



#ifndef LITTLE_ENDIAN //apply BIG_ENDIAN

//======SUB_VGIP_PTG register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:9;
        RBus_UInt32  ch2_color_bar_mode_en:1;
        RBus_UInt32  ch2_shift_size_mode:1;
        RBus_UInt32  res2:13;
        RBus_UInt32  ch2_ptg_den_sel:1;
        RBus_UInt32  ch2_mask_one_eye_en:1;
        RBus_UInt32  ch2_mask_one_eye_left:1;
        RBus_UInt32  ch2_color_bar_vertical_mode:1;
        RBus_UInt32  ch2_color_bar_interlaced_mode:1;
        RBus_UInt32  ch2_color_bar_3d_mode:1;
        RBus_UInt32  ch2_color_num:2;
    };
}sub_vgip_ptg_ch2_ptg_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  ch2_i_c0y_92b:8;
        RBus_UInt32  ch2_i_c0cr_92b:8;
        RBus_UInt32  ch2_i_c0cb_92b:8;
    };
}sub_vgip_ptg_ch2_ptg_c0y_cb_cr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  ch2_i_c1y_92b:8;
        RBus_UInt32  ch2_i_c1cr_92b:8;
        RBus_UInt32  ch2_i_c1cb_92b:8;
    };
}sub_vgip_ptg_ch2_ptg_c1y_cb_cr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  ch2_i_c2y_92b:8;
        RBus_UInt32  ch2_i_c2cr_92b:8;
        RBus_UInt32  ch2_i_c2cb_92b:8;
    };
}sub_vgip_ptg_ch2_ptg_c2y_cb_cr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  ch2_i_c3y_92b:8;
        RBus_UInt32  ch2_i_c3cr_92b:8;
        RBus_UInt32  ch2_i_c3cb_92b:8;
    };
}sub_vgip_ptg_ch2_ptg_c3y_cb_cr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  ch2_i_c4y_92b:8;
        RBus_UInt32  ch2_i_c4cr_92b:8;
        RBus_UInt32  ch2_i_c4cb_92b:8;
    };
}sub_vgip_ptg_ch2_ptg_c4y_cb_cr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  ch2_i_c5y_92b:8;
        RBus_UInt32  ch2_i_c5cr_92b:8;
        RBus_UInt32  ch2_i_c5cb_92b:8;
    };
}sub_vgip_ptg_ch2_ptg_c5y_cr_cb_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  ch2_i_c6y_92b:8;
        RBus_UInt32  ch2_i_c6cr_92b:8;
        RBus_UInt32  ch2_i_c6cb_92b:8;
    };
}sub_vgip_ptg_ch2_ptg_c6y_cb_cr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  ch2_i_c7y_92b:8;
        RBus_UInt32  ch2_i_c7cr_92b:8;
        RBus_UInt32  ch2_i_c7cb_92b:8;
    };
}sub_vgip_ptg_ch2_ptg_c7y_cb_cr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  ptg_ch2_ih_act_sta:14;
        RBus_UInt32  res2:2;
        RBus_UInt32  ptg_ch2_ih_act_wid:14;
    };
}sub_vgip_ptg_ptg_chn2_act_hsta_width_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  ptg_ch2_iv_act_sta:14;
        RBus_UInt32  res2:2;
        RBus_UInt32  ptg_ch2_iv_act_len:14;
    };
}sub_vgip_ptg_ptg_chn2_act_vsta_width_RBUS;

#else //apply LITTLE_ENDIAN

//======SUB_VGIP_PTG register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ch2_color_num:2;
        RBus_UInt32  ch2_color_bar_3d_mode:1;
        RBus_UInt32  ch2_color_bar_interlaced_mode:1;
        RBus_UInt32  ch2_color_bar_vertical_mode:1;
        RBus_UInt32  ch2_mask_one_eye_left:1;
        RBus_UInt32  ch2_mask_one_eye_en:1;
        RBus_UInt32  ch2_ptg_den_sel:1;
        RBus_UInt32  res1:13;
        RBus_UInt32  ch2_shift_size_mode:1;
        RBus_UInt32  ch2_color_bar_mode_en:1;
        RBus_UInt32  res2:9;
    };
}sub_vgip_ptg_ch2_ptg_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ch2_i_c0cb_92b:8;
        RBus_UInt32  ch2_i_c0cr_92b:8;
        RBus_UInt32  ch2_i_c0y_92b:8;
        RBus_UInt32  res1:8;
    };
}sub_vgip_ptg_ch2_ptg_c0y_cb_cr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ch2_i_c1cb_92b:8;
        RBus_UInt32  ch2_i_c1cr_92b:8;
        RBus_UInt32  ch2_i_c1y_92b:8;
        RBus_UInt32  res1:8;
    };
}sub_vgip_ptg_ch2_ptg_c1y_cb_cr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ch2_i_c2cb_92b:8;
        RBus_UInt32  ch2_i_c2cr_92b:8;
        RBus_UInt32  ch2_i_c2y_92b:8;
        RBus_UInt32  res1:8;
    };
}sub_vgip_ptg_ch2_ptg_c2y_cb_cr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ch2_i_c3cb_92b:8;
        RBus_UInt32  ch2_i_c3cr_92b:8;
        RBus_UInt32  ch2_i_c3y_92b:8;
        RBus_UInt32  res1:8;
    };
}sub_vgip_ptg_ch2_ptg_c3y_cb_cr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ch2_i_c4cb_92b:8;
        RBus_UInt32  ch2_i_c4cr_92b:8;
        RBus_UInt32  ch2_i_c4y_92b:8;
        RBus_UInt32  res1:8;
    };
}sub_vgip_ptg_ch2_ptg_c4y_cb_cr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ch2_i_c5cb_92b:8;
        RBus_UInt32  ch2_i_c5cr_92b:8;
        RBus_UInt32  ch2_i_c5y_92b:8;
        RBus_UInt32  res1:8;
    };
}sub_vgip_ptg_ch2_ptg_c5y_cr_cb_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ch2_i_c6cb_92b:8;
        RBus_UInt32  ch2_i_c6cr_92b:8;
        RBus_UInt32  ch2_i_c6y_92b:8;
        RBus_UInt32  res1:8;
    };
}sub_vgip_ptg_ch2_ptg_c6y_cb_cr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ch2_i_c7cb_92b:8;
        RBus_UInt32  ch2_i_c7cr_92b:8;
        RBus_UInt32  ch2_i_c7y_92b:8;
        RBus_UInt32  res1:8;
    };
}sub_vgip_ptg_ch2_ptg_c7y_cb_cr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ptg_ch2_ih_act_wid:14;
        RBus_UInt32  res1:2;
        RBus_UInt32  ptg_ch2_ih_act_sta:14;
        RBus_UInt32  res2:2;
    };
}sub_vgip_ptg_ptg_chn2_act_hsta_width_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ptg_ch2_iv_act_len:14;
        RBus_UInt32  res1:2;
        RBus_UInt32  ptg_ch2_iv_act_sta:14;
        RBus_UInt32  res2:2;
    };
}sub_vgip_ptg_ptg_chn2_act_vsta_width_RBUS;




#endif 


#endif 
