/**
* @file rbusIpq_decontourReg.h
* RBus systemc program.
*
* @author RS_MM2_SD
* @email jason9.ccc@realtek.com
 * @date 2016/6/3
* @ingroup model_rbus
 * @version { 1.0 }
 **
 */

#ifndef _RBUS_IPQ_DECONTOUR_REG_H_
#define _RBUS_IPQ_DECONTOUR_REG_H_

#include "rbusTypes.h"



//  IPQ_DECONTOUR Register Address



#define  IPQ_DECONTOUR_DE_CONTOUR_CTRL_VADDR                	(0xb8025700)
#define  IPQ_DECONTOUR_DE_CONTOUR_CONTRAST_VADDR            	(0xb8025704)
#define  IPQ_DECONTOUR_DE_CONTOUR_NEIGHBOR_DIFF_VADDR       	(0xb8025708)
#define  IPQ_DECONTOUR_DE_CONTOUR_THRESHOLD_VADDR           	(0xb802570c)
#define  IPQ_DECONTOUR_DE_CONTOUR_COUNTER_VADDR             	(0xb8025714)
#define  IPQ_DECONTOUR_DE_CONTOUR_AVFILTER_COUNTER_VADDR    	(0xb8025718)
#define  IPQ_DECONTOUR_DE_CONTOUR_HIST0_VADDR               	(0xb802571c)
#define  IPQ_DECONTOUR_DE_CONTOUR_HIST1_VADDR               	(0xb8025720)
#define  IPQ_DECONTOUR_DE_CONTOUR_HIST2_VADDR               	(0xb8025724)
#define  IPQ_DECONTOUR_DE_CONTOUR_HIST3_VADDR               	(0xb8025728)
#define  IPQ_DECONTOUR_DE_CONTOUR_HIST4_VADDR               	(0xb802572c)
#define  IPQ_DECONTOUR_DE_CONTOUR_HIST5_VADDR               	(0xb8025730)
#define  IPQ_DECONTOUR_DE_CONTOUR_HIST6_VADDR               	(0xb8025734)
#define  IPQ_DECONTOUR_DE_CONTOUR_HIST7_VADDR               	(0xb8025738)
#define  IPQ_DECONTOUR_DE_CONTOUR_HIST8_VADDR               	(0xb802573c)
#define  IPQ_DECONTOUR_DE_CONTOUR_HIST9_VADDR               	(0xb8025740)
#define  IPQ_DECONTOUR_DE_CONTOUR_HIST10_VADDR              	(0xb8025744)
#define  IPQ_DECONTOUR_DE_CONTOUR_HIST11_VADDR              	(0xb8025748)
#define  IPQ_DECONTOUR_DE_CONTOUR_HIST12_VADDR              	(0xb802574c)
#define  IPQ_DECONTOUR_DE_CONTOUR_HIST13_VADDR              	(0xb8025750)
#define  IPQ_DECONTOUR_DE_CONTOUR_HIST14_VADDR              	(0xb8025754)
#define  IPQ_DECONTOUR_DE_CONTOUR_HIST15_VADDR              	(0xb8025758)
#define  IPQ_DECONTOUR_DE_CONTOUR_DB_REG_CTL_VADDR          	(0xb802575c)



#ifndef LITTLE_ENDIAN //apply BIG_ENDIAN

//======IPQ_DECONTOUR register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decont_en:1;
        RBus_UInt32  decont_neighbor_far:1;
        RBus_UInt32  decont_debug_en:1;
        RBus_UInt32  decont_debug_mode:1;
        RBus_UInt32  decont_filter_mode:1;
        RBus_UInt32  res1:11;
        RBus_UInt32  decont_blend_lowbd:8;
        RBus_UInt32  res2:2;
        RBus_UInt32  decont_blend_step:2;
        RBus_UInt32  res3:2;
        RBus_UInt32  decont_snr_blend_mode:2;
    };
}ipq_decontour_de_contour_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  decont_contrast_th_y:8;
        RBus_UInt32  res2:7;
        RBus_UInt32  decont_contrast_th_c:9;
    };
}ipq_decontour_de_contour_contrast_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:10;
        RBus_UInt32  decont_neighbor_diff_th_y:6;
        RBus_UInt32  res2:10;
        RBus_UInt32  decont_neighbor_diff_th_c:6;
    };
}ipq_decontour_de_contour_neighbor_diff_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:1;
        RBus_UInt32  decont_gradation_th:5;
        RBus_UInt32  decont_dark_th:10;
        RBus_UInt32  res2:8;
        RBus_UInt32  decont_dark_contrast_th:8;
    };
}ipq_decontour_de_contour_threshold_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:11;
        RBus_UInt32  decont_contour_cnt:21;
    };
}ipq_decontour_de_contour_counter_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:11;
        RBus_UInt32  decont_avfilter_cnt:21;
    };
}ipq_decontour_de_contour_avfilter_counter_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:11;
        RBus_UInt32  decont_filter_range_hist0:21;
    };
}ipq_decontour_de_contour_hist0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:11;
        RBus_UInt32  decont_filter_range_hist1:21;
    };
}ipq_decontour_de_contour_hist1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:11;
        RBus_UInt32  decont_filter_range_hist2:21;
    };
}ipq_decontour_de_contour_hist2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:11;
        RBus_UInt32  decont_filter_range_hist3:21;
    };
}ipq_decontour_de_contour_hist3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:11;
        RBus_UInt32  decont_filter_range_hist4:21;
    };
}ipq_decontour_de_contour_hist4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:11;
        RBus_UInt32  decont_filter_range_hist5:21;
    };
}ipq_decontour_de_contour_hist5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:11;
        RBus_UInt32  decont_filter_range_hist6:21;
    };
}ipq_decontour_de_contour_hist6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:11;
        RBus_UInt32  decont_filter_range_hist7:21;
    };
}ipq_decontour_de_contour_hist7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:11;
        RBus_UInt32  decont_filter_range_hist8:21;
    };
}ipq_decontour_de_contour_hist8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:11;
        RBus_UInt32  decont_filter_range_hist9:21;
    };
}ipq_decontour_de_contour_hist9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:11;
        RBus_UInt32  decont_filter_range_hist10:21;
    };
}ipq_decontour_de_contour_hist10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:11;
        RBus_UInt32  decont_filter_range_hist11:21;
    };
}ipq_decontour_de_contour_hist11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:11;
        RBus_UInt32  decont_filter_range_hist12:21;
    };
}ipq_decontour_de_contour_hist12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:11;
        RBus_UInt32  decont_filter_range_hist13:21;
    };
}ipq_decontour_de_contour_hist13_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:11;
        RBus_UInt32  decont_filter_range_hist14:21;
    };
}ipq_decontour_de_contour_hist14_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:11;
        RBus_UInt32  decont_filter_range_hist15:21;
    };
}ipq_decontour_de_contour_hist15_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:29;
        RBus_UInt32  db_read:1;
        RBus_UInt32  db_en:1;
        RBus_UInt32  db_apply:1;
    };
}ipq_decontour_de_contour_db_reg_ctl_RBUS;

#else //apply LITTLE_ENDIAN

//======IPQ_DECONTOUR register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decont_snr_blend_mode:2;
        RBus_UInt32  res1:2;
        RBus_UInt32  decont_blend_step:2;
        RBus_UInt32  res2:2;
        RBus_UInt32  decont_blend_lowbd:8;
        RBus_UInt32  res3:11;
        RBus_UInt32  decont_filter_mode:1;
        RBus_UInt32  decont_debug_mode:1;
        RBus_UInt32  decont_debug_en:1;
        RBus_UInt32  decont_neighbor_far:1;
        RBus_UInt32  decont_en:1;
    };
}ipq_decontour_de_contour_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decont_contrast_th_c:9;
        RBus_UInt32  res1:7;
        RBus_UInt32  decont_contrast_th_y:8;
        RBus_UInt32  res2:8;
    };
}ipq_decontour_de_contour_contrast_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decont_neighbor_diff_th_c:6;
        RBus_UInt32  res1:10;
        RBus_UInt32  decont_neighbor_diff_th_y:6;
        RBus_UInt32  res2:10;
    };
}ipq_decontour_de_contour_neighbor_diff_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decont_dark_contrast_th:8;
        RBus_UInt32  res1:8;
        RBus_UInt32  decont_dark_th:10;
        RBus_UInt32  decont_gradation_th:5;
        RBus_UInt32  res2:1;
    };
}ipq_decontour_de_contour_threshold_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decont_contour_cnt:21;
        RBus_UInt32  res1:11;
    };
}ipq_decontour_de_contour_counter_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decont_avfilter_cnt:21;
        RBus_UInt32  res1:11;
    };
}ipq_decontour_de_contour_avfilter_counter_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decont_filter_range_hist0:21;
        RBus_UInt32  res1:11;
    };
}ipq_decontour_de_contour_hist0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decont_filter_range_hist1:21;
        RBus_UInt32  res1:11;
    };
}ipq_decontour_de_contour_hist1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decont_filter_range_hist2:21;
        RBus_UInt32  res1:11;
    };
}ipq_decontour_de_contour_hist2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decont_filter_range_hist3:21;
        RBus_UInt32  res1:11;
    };
}ipq_decontour_de_contour_hist3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decont_filter_range_hist4:21;
        RBus_UInt32  res1:11;
    };
}ipq_decontour_de_contour_hist4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decont_filter_range_hist5:21;
        RBus_UInt32  res1:11;
    };
}ipq_decontour_de_contour_hist5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decont_filter_range_hist6:21;
        RBus_UInt32  res1:11;
    };
}ipq_decontour_de_contour_hist6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decont_filter_range_hist7:21;
        RBus_UInt32  res1:11;
    };
}ipq_decontour_de_contour_hist7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decont_filter_range_hist8:21;
        RBus_UInt32  res1:11;
    };
}ipq_decontour_de_contour_hist8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decont_filter_range_hist9:21;
        RBus_UInt32  res1:11;
    };
}ipq_decontour_de_contour_hist9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decont_filter_range_hist10:21;
        RBus_UInt32  res1:11;
    };
}ipq_decontour_de_contour_hist10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decont_filter_range_hist11:21;
        RBus_UInt32  res1:11;
    };
}ipq_decontour_de_contour_hist11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decont_filter_range_hist12:21;
        RBus_UInt32  res1:11;
    };
}ipq_decontour_de_contour_hist12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decont_filter_range_hist13:21;
        RBus_UInt32  res1:11;
    };
}ipq_decontour_de_contour_hist13_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decont_filter_range_hist14:21;
        RBus_UInt32  res1:11;
    };
}ipq_decontour_de_contour_hist14_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decont_filter_range_hist15:21;
        RBus_UInt32  res1:11;
    };
}ipq_decontour_de_contour_hist15_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  db_apply:1;
        RBus_UInt32  db_en:1;
        RBus_UInt32  db_read:1;
        RBus_UInt32  res1:29;
    };
}ipq_decontour_de_contour_db_reg_ctl_RBUS;




#endif 


#endif 
