/**
* @file Merlin3-DesignSpec-D-Domain_Demura
* RBus systemc program.
*
* @author RS_MM2_SD
* @email jason9.ccc@realtek.com
 * @date 2017/6/9
* @ingroup model_rbus
 * @version { 1.0 }
 **
 */

#ifndef _RBUS_DEMURA_REG_H_
#define _RBUS_DEMURA_REG_H_

#include "rbusTypes.h"



//  DEMURA Register Address



#define  DEMURA_DEMURA_CONTROL_VADDR                        	(0xb802eb00)
#define  DEMURA_DEMURA_R_PLANE_1_CONTROL_VADDR              	(0xb802eb04)
#define  DEMURA_DEMURA_R_PLANE_2_CONTROL_VADDR              	(0xb802eb08)
#define  DEMURA_DEMURA_R_PLANE_3_CONTROL_VADDR              	(0xb802eb0c)
#define  DEMURA_DEMURA_R_PLANE_4_CONTROL_VADDR              	(0xb802eb10)
#define  DEMURA_DEMURA_R_PLANE_5_CONTROL_VADDR              	(0xb802eb14)
#define  DEMURA_DEMURA_G_PLANE_1_CONTROL_VADDR              	(0xb802eb20)
#define  DEMURA_DEMURA_G_PLANE_2_CONTROL_VADDR              	(0xb802eb24)
#define  DEMURA_DEMURA_G_PLANE_3_CONTROL_VADDR              	(0xb802eb28)
#define  DEMURA_DEMURA_G_PLANE_4_CONTROL_VADDR              	(0xb802eb2c)
#define  DEMURA_DEMURA_G_PLANE_5_CONTROL_VADDR              	(0xb802eb30)
#define  DEMURA_DEMURA_B_PLANE_1_CONTROL_VADDR              	(0xb802eb40)
#define  DEMURA_DEMURA_B_PLANE_2_CONTROL_VADDR              	(0xb802eb44)
#define  DEMURA_DEMURA_B_PLANE_3_CONTROL_VADDR              	(0xb802eb48)
#define  DEMURA_DEMURA_B_PLANE_4_CONTROL_VADDR              	(0xb802eb4c)
#define  DEMURA_DEMURA_B_PLANE_5_CONTROL_VADDR              	(0xb802eb50)
#define  DEMURA_DEMURA_DMA_CTRL_1_VADDR                     	(0xb802eb60)
#define  DEMURA_DEMURA_DMA_WRAP_ADDR_VADDR                  	(0xb802eb64)
#define  DEMURA_DEMURA_DMA_WRAP_LINE_STEP_VADDR             	(0xb802eb68)
#define  DEMURA_DEMURA_DMA_WRAP_LEN_VADDR                   	(0xb802eb6c)
#define  DEMURA_DEMURA_DMA_WRAP_WORD_VADDR                  	(0xb802eb70)
#define  DEMURA_DEMURA_DMA_RULE_CHECK_UP_VADDR              	(0xb802eb74)
#define  DEMURA_DEMURA_DMA_RULE_CHECK_LOW_VADDR             	(0xb802eb78)
#define  DEMURA_DEMURA_DMA_CTRL_VADDR                       	(0xb802eb7c)
#define  DEMURA_DEMURA_DMA_WRAP_ST1_VADDR                   	(0xb802eb80)
#define  DEMURA_DEMURA_DMA_WRAP_ST2_VADDR                   	(0xb802eb84)
#define  DEMURA_DEMURA_DMA_ST1_VADDR                        	(0xb802eb88)
#define  DEMURA_DEMURA_DMA_ST2_VADDR                        	(0xb802eb8c)
#define  DEMURA_DEMURA_DMA_ST3_VADDR                        	(0xb802eb90)
#define  DEMURA_DEMURA_DMA_WATER_MONITOR_VADDR              	(0xb802eb94)
#define  DEMURA_DEMURA_DMA_BIST_1_VADDR                     	(0xb802eba0)
#define  DEMURA_DEMURA_DMA_BIST_2_VADDR                     	(0xb802eba4)



#ifndef LITTLE_ENDIAN //apply BIG_ENDIAN

//======DEMURA register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy1802eb00_31_6:26;
        RBus_UInt32  demura_table_scale:2;
        RBus_UInt32  demura_block_size:2;
        RBus_UInt32  demura_rgb_table_seperate:1;
        RBus_UInt32  demura_en:1;
    };
}demura_demura_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:6;
        RBus_UInt32  demura_r_upper_cutoff:10;
        RBus_UInt32  res2:6;
        RBus_UInt32  demura_r_lower_cutoff:10;
    };
}demura_demura_r_plane_1_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:6;
        RBus_UInt32  demura_r_m_level:10;
        RBus_UInt32  res2:6;
        RBus_UInt32  demura_r_l_level:10;
    };
}demura_demura_r_plane_2_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  demura_r_h_level:10;
    };
}demura_demura_r_plane_3_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  r_div_factor_l_m:16;
        RBus_UInt32  r_div_factor_l:16;
    };
}demura_demura_r_plane_4_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  r_div_factor_h:16;
        RBus_UInt32  r_div_factor_m_h:16;
    };
}demura_demura_r_plane_5_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:6;
        RBus_UInt32  demura_g_upper_cutoff:10;
        RBus_UInt32  res2:6;
        RBus_UInt32  demura_g_lower_cutoff:10;
    };
}demura_demura_g_plane_1_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:6;
        RBus_UInt32  demura_g_m_level:10;
        RBus_UInt32  res2:6;
        RBus_UInt32  demura_g_l_level:10;
    };
}demura_demura_g_plane_2_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  demura_g_h_level:10;
    };
}demura_demura_g_plane_3_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  g_div_factor_l_m:16;
        RBus_UInt32  g_div_factor_l:16;
    };
}demura_demura_g_plane_4_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  g_div_factor_h:16;
        RBus_UInt32  g_div_factor_m_h:16;
    };
}demura_demura_g_plane_5_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:6;
        RBus_UInt32  demura_b_upper_cutoff:10;
        RBus_UInt32  res2:6;
        RBus_UInt32  demura_b_lower_cutoff:10;
    };
}demura_demura_b_plane_1_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:6;
        RBus_UInt32  demura_b_m_level:10;
        RBus_UInt32  res2:6;
        RBus_UInt32  demura_b_l_level:10;
    };
}demura_demura_b_plane_2_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  demura_b_h_level:10;
    };
}demura_demura_b_plane_3_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  b_div_factor_l_m:16;
        RBus_UInt32  b_div_factor_l:16;
    };
}demura_demura_b_plane_4_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  b_div_factor_h:16;
        RBus_UInt32  b_div_factor_m_h:16;
    };
}demura_demura_b_plane_5_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:7;
        RBus_UInt32  table_width:9;
        RBus_UInt32  res2:7;
        RBus_UInt32  table_height:9;
    };
}demura_demura_dma_ctrl_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sta_addr:28;
        RBus_UInt32  res1:4;
    };
}demura_demura_dma_wrap_addr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  line_step:28;
        RBus_UInt32  res1:4;
    };
}demura_demura_dma_wrap_line_step_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  burst_len:7;
        RBus_UInt32  res2:4;
    };
}demura_demura_dma_wrap_len_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:5;
        RBus_UInt32  line_128_num:23;
        RBus_UInt32  res2:4;
    };
}demura_demura_dma_wrap_word_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dma_up_limit:28;
        RBus_UInt32  res1:4;
    };
}demura_demura_dma_rule_check_up_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dma_low_limit:28;
        RBus_UInt32  res1:4;
    };
}demura_demura_dma_rule_check_low_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:18;
        RBus_UInt32  dma_8byte_swap:1;
        RBus_UInt32  dma_4byte_swap:1;
        RBus_UInt32  dma_2byte_swap:1;
        RBus_UInt32  dma_1byte_swap:1;
        RBus_UInt32  max_outstanding:2;
        RBus_UInt32  res2:6;
        RBus_UInt32  force_all_rst:1;
        RBus_UInt32  res3:1;
    };
}demura_demura_dma_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  soft_rst_before_finish:1;
        RBus_UInt32  res1:3;
        RBus_UInt32  remain_line_num:12;
        RBus_UInt32  res2:16;
    };
}demura_demura_dma_wrap_st1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:5;
        RBus_UInt32  remain_128_num:23;
        RBus_UInt32  res2:2;
        RBus_UInt32  finish_status:2;
    };
}demura_demura_dma_wrap_st2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:1;
        RBus_UInt32  dma_cmd_water:3;
        RBus_UInt32  res2:5;
        RBus_UInt32  dma_data_water:7;
        RBus_UInt32  res3:5;
        RBus_UInt32  cur_outstanding:3;
        RBus_UInt32  res4:2;
        RBus_UInt32  fifo_underflow:1;
        RBus_UInt32  soft_rst_before_cmd_finish:1;
        RBus_UInt32  soft_rst_with_data_left:1;
        RBus_UInt32  data_fifo_overflow_err:1;
        RBus_UInt32  exceed_range_err:1;
        RBus_UInt32  zero_length_err:1;
    };
}demura_demura_dma_st1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ack_num_error:1;
        RBus_UInt32  last_no_ack_error:1;
        RBus_UInt32  res1:7;
        RBus_UInt32  target_ack_num:7;
        RBus_UInt32  res2:1;
        RBus_UInt32  last_ack_num:7;
        RBus_UInt32  res3:1;
        RBus_UInt32  selected_bl:7;
    };
}demura_demura_dma_st2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  selected_addr:28;
        RBus_UInt32  res1:2;
        RBus_UInt32  addr_bl_sel:2;
    };
}demura_demura_dma_st3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  monitor_en:1;
        RBus_UInt32  monitor_conti:1;
        RBus_UInt32  res1:7;
        RBus_UInt32  monitor_thd:7;
        RBus_UInt32  res2:7;
        RBus_UInt32  reach_thd:1;
        RBus_UInt32  res3:1;
        RBus_UInt32  lowest_water_level:7;
    };
}demura_demura_dma_water_monitor_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:9;
        RBus_UInt32  ls_dma_fifo:1;
        RBus_UInt32  ls_r1:1;
        RBus_UInt32  ls_g1:1;
        RBus_UInt32  ls_b1:1;
        RBus_UInt32  ls_r0:1;
        RBus_UInt32  ls_g0:1;
        RBus_UInt32  ls_b0:1;
        RBus_UInt32  res2:11;
        RBus_UInt32  rme:1;
        RBus_UInt32  rm:4;
    };
}demura_demura_dma_bist_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:9;
        RBus_UInt32  demura_dma_fifo_drf_bist_fail:1;
        RBus_UInt32  demura_r1_drf_bist_fail:1;
        RBus_UInt32  demura_g1_drf_bist_fail:1;
        RBus_UInt32  demura_b1_drf_bist_fail:1;
        RBus_UInt32  demura_r0_drf_bist_fail:1;
        RBus_UInt32  demura_g0_drf_bist_fail:1;
        RBus_UInt32  demura_b0_drf_bist_fail:1;
        RBus_UInt32  res2:9;
        RBus_UInt32  demura_dma_fifo_bist_fail:1;
        RBus_UInt32  demura_r1_bist_fail:1;
        RBus_UInt32  demura_g1_bist_fail:1;
        RBus_UInt32  demura_b1_bist_fail:1;
        RBus_UInt32  demura_r0_bist_fail:1;
        RBus_UInt32  demura_g0_bist_fail:1;
        RBus_UInt32  demura_b0_bist_fail:1;
    };
}demura_demura_dma_bist_2_RBUS;

#else //apply LITTLE_ENDIAN

//======DEMURA register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  demura_en:1;
        RBus_UInt32  demura_rgb_table_seperate:1;
        RBus_UInt32  demura_block_size:2;
        RBus_UInt32  demura_table_scale:2;
        RBus_UInt32  dummy1802eb00_31_6:26;
    };
}demura_demura_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  demura_r_lower_cutoff:10;
        RBus_UInt32  res1:6;
        RBus_UInt32  demura_r_upper_cutoff:10;
        RBus_UInt32  res2:6;
    };
}demura_demura_r_plane_1_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  demura_r_l_level:10;
        RBus_UInt32  res1:6;
        RBus_UInt32  demura_r_m_level:10;
        RBus_UInt32  res2:6;
    };
}demura_demura_r_plane_2_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  demura_r_h_level:10;
        RBus_UInt32  res1:22;
    };
}demura_demura_r_plane_3_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  r_div_factor_l:16;
        RBus_UInt32  r_div_factor_l_m:16;
    };
}demura_demura_r_plane_4_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  r_div_factor_m_h:16;
        RBus_UInt32  r_div_factor_h:16;
    };
}demura_demura_r_plane_5_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  demura_g_lower_cutoff:10;
        RBus_UInt32  res1:6;
        RBus_UInt32  demura_g_upper_cutoff:10;
        RBus_UInt32  res2:6;
    };
}demura_demura_g_plane_1_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  demura_g_l_level:10;
        RBus_UInt32  res1:6;
        RBus_UInt32  demura_g_m_level:10;
        RBus_UInt32  res2:6;
    };
}demura_demura_g_plane_2_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  demura_g_h_level:10;
        RBus_UInt32  res1:22;
    };
}demura_demura_g_plane_3_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  g_div_factor_l:16;
        RBus_UInt32  g_div_factor_l_m:16;
    };
}demura_demura_g_plane_4_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  g_div_factor_m_h:16;
        RBus_UInt32  g_div_factor_h:16;
    };
}demura_demura_g_plane_5_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  demura_b_lower_cutoff:10;
        RBus_UInt32  res1:6;
        RBus_UInt32  demura_b_upper_cutoff:10;
        RBus_UInt32  res2:6;
    };
}demura_demura_b_plane_1_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  demura_b_l_level:10;
        RBus_UInt32  res1:6;
        RBus_UInt32  demura_b_m_level:10;
        RBus_UInt32  res2:6;
    };
}demura_demura_b_plane_2_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  demura_b_h_level:10;
        RBus_UInt32  res1:22;
    };
}demura_demura_b_plane_3_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  b_div_factor_l:16;
        RBus_UInt32  b_div_factor_l_m:16;
    };
}demura_demura_b_plane_4_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  b_div_factor_m_h:16;
        RBus_UInt32  b_div_factor_h:16;
    };
}demura_demura_b_plane_5_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  table_height:9;
        RBus_UInt32  res1:7;
        RBus_UInt32  table_width:9;
        RBus_UInt32  res2:7;
    };
}demura_demura_dma_ctrl_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  sta_addr:28;
    };
}demura_demura_dma_wrap_addr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  line_step:28;
    };
}demura_demura_dma_wrap_line_step_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  burst_len:7;
        RBus_UInt32  res2:21;
    };
}demura_demura_dma_wrap_len_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  line_128_num:23;
        RBus_UInt32  res2:5;
    };
}demura_demura_dma_wrap_word_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  dma_up_limit:28;
    };
}demura_demura_dma_rule_check_up_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  dma_low_limit:28;
    };
}demura_demura_dma_rule_check_low_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:1;
        RBus_UInt32  force_all_rst:1;
        RBus_UInt32  res2:6;
        RBus_UInt32  max_outstanding:2;
        RBus_UInt32  dma_1byte_swap:1;
        RBus_UInt32  dma_2byte_swap:1;
        RBus_UInt32  dma_4byte_swap:1;
        RBus_UInt32  dma_8byte_swap:1;
        RBus_UInt32  res3:18;
    };
}demura_demura_dma_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  remain_line_num:12;
        RBus_UInt32  res2:3;
        RBus_UInt32  soft_rst_before_finish:1;
    };
}demura_demura_dma_wrap_st1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  finish_status:2;
        RBus_UInt32  res1:2;
        RBus_UInt32  remain_128_num:23;
        RBus_UInt32  res2:5;
    };
}demura_demura_dma_wrap_st2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  zero_length_err:1;
        RBus_UInt32  exceed_range_err:1;
        RBus_UInt32  data_fifo_overflow_err:1;
        RBus_UInt32  soft_rst_with_data_left:1;
        RBus_UInt32  soft_rst_before_cmd_finish:1;
        RBus_UInt32  fifo_underflow:1;
        RBus_UInt32  res1:2;
        RBus_UInt32  cur_outstanding:3;
        RBus_UInt32  res2:5;
        RBus_UInt32  dma_data_water:7;
        RBus_UInt32  res3:5;
        RBus_UInt32  dma_cmd_water:3;
        RBus_UInt32  res4:1;
    };
}demura_demura_dma_st1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  selected_bl:7;
        RBus_UInt32  res1:1;
        RBus_UInt32  last_ack_num:7;
        RBus_UInt32  res2:1;
        RBus_UInt32  target_ack_num:7;
        RBus_UInt32  res3:7;
        RBus_UInt32  last_no_ack_error:1;
        RBus_UInt32  ack_num_error:1;
    };
}demura_demura_dma_st2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  addr_bl_sel:2;
        RBus_UInt32  res1:2;
        RBus_UInt32  selected_addr:28;
    };
}demura_demura_dma_st3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lowest_water_level:7;
        RBus_UInt32  res1:1;
        RBus_UInt32  reach_thd:1;
        RBus_UInt32  res2:7;
        RBus_UInt32  monitor_thd:7;
        RBus_UInt32  res3:7;
        RBus_UInt32  monitor_conti:1;
        RBus_UInt32  monitor_en:1;
    };
}demura_demura_dma_water_monitor_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  rm:4;
        RBus_UInt32  rme:1;
        RBus_UInt32  res1:11;
        RBus_UInt32  ls_b0:1;
        RBus_UInt32  ls_g0:1;
        RBus_UInt32  ls_r0:1;
        RBus_UInt32  ls_b1:1;
        RBus_UInt32  ls_g1:1;
        RBus_UInt32  ls_r1:1;
        RBus_UInt32  ls_dma_fifo:1;
        RBus_UInt32  res2:9;
    };
}demura_demura_dma_bist_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  demura_b0_bist_fail:1;
        RBus_UInt32  demura_g0_bist_fail:1;
        RBus_UInt32  demura_r0_bist_fail:1;
        RBus_UInt32  demura_b1_bist_fail:1;
        RBus_UInt32  demura_g1_bist_fail:1;
        RBus_UInt32  demura_r1_bist_fail:1;
        RBus_UInt32  demura_dma_fifo_bist_fail:1;
        RBus_UInt32  res1:9;
        RBus_UInt32  demura_b0_drf_bist_fail:1;
        RBus_UInt32  demura_g0_drf_bist_fail:1;
        RBus_UInt32  demura_r0_drf_bist_fail:1;
        RBus_UInt32  demura_b1_drf_bist_fail:1;
        RBus_UInt32  demura_g1_drf_bist_fail:1;
        RBus_UInt32  demura_r1_drf_bist_fail:1;
        RBus_UInt32  demura_dma_fifo_drf_bist_fail:1;
        RBus_UInt32  res2:9;
    };
}demura_demura_dma_bist_2_RBUS;




#endif 


#endif 
