/**
* @file Merlin3-DesignSpec-I-Domain_IDMA_HDMI_3D_DMA
* RBus systemc program.
*
* @author RS_MM2_SD
* @email jason9.ccc@realtek.com
 * @date 2017/6/9
* @ingroup model_rbus
 * @version { 1.0 }
 **
 */

#ifndef _RBUS_H3DDMA_REG_H_
#define _RBUS_H3DDMA_REG_H_

#include "rbusTypes.h"



//  H3DDMA Register Address



#define  H3DDMA_LR_SEPARATE_CTRL1_VADDR                     	(0xb8025800)
#define  H3DDMA_LR_SEPARATE_CTRL2_VADDR                     	(0xb8025804)
#define  H3DDMA_LR_SEPARATE_INSERT_VS_START_VADDR           	(0xb8025808)
#define  H3DDMA_LR_SEPARATE_INSERT_VS_END_VADDR             	(0xb802580c)
#define  H3DDMA_CAP_CTL0_VADDR                              	(0xb8025810)
#define  H3DDMA_CAP_CTL1_VADDR                              	(0xb8025814)
#define  H3DDMA_CAP_BOUNDARYADDR1_VADDR                     	(0xb8025818)
#define  H3DDMA_CAP_BOUNDARYADDR2_VADDR                     	(0xb802581c)
#define  H3DDMA_CAP2_BOUNDARYADDR1_VADDR                    	(0xb80258b0)
#define  H3DDMA_CAP2_BOUNDARYADDR2_VADDR                    	(0xb80258b4)
#define  H3DDMA_CAP_L1_START_VADDR                          	(0xb8025820)
#define  H3DDMA_CAP_L2_START_VADDR                          	(0xb8025824)
#define  H3DDMA_CAP_R1_START_VADDR                          	(0xb8025828)
#define  H3DDMA_CAP_R2_START_VADDR                          	(0xb802582c)
#define  H3DDMA_CAP_L1_START_DB_VADDR                       	(0xb8025830)
#define  H3DDMA_CAP_R1_START_DB_VADDR                       	(0xb8025834)
#define  H3DDMA_CAP_STATUS_VADDR                            	(0xb8025838)
#define  H3DDMA_TG_V1_END_VADDR                             	(0xb802583c)
#define  H3DDMA_TG_V2_START_VADDR                           	(0xb8025840)
#define  H3DDMA_TG_V2_END_VADDR                             	(0xb8025844)
#define  H3DDMA_TG_V3_START_VADDR                           	(0xb8025848)
#define  H3DDMA_TG_V3_END_VADDR                             	(0xb802584c)
#define  H3DDMA_TG_V4_START_VADDR                           	(0xb8025850)
#define  H3DDMA_TG_V4_END_VADDR                             	(0xb8025854)
#define  H3DDMA_CTS_FIFO_CTRL_VADDR                         	(0xb802585c)
#define  H3DDMA_LR_CRC_CTRL_VADDR                           	(0xb8025860)
#define  H3DDMA_CRC_L_RESULT_VADDR                          	(0xb8025864)
#define  H3DDMA_CRC_R_RESULT_VADDR                          	(0xb8025868)
#define  H3DDMA_INTERRUPT_ENABLE_VADDR                      	(0xb802586c)
#define  H3DDMA_I3DDMA_ENABLE_VADDR                         	(0xb8025870)
#define  H3DDMA_I3DDMA_BYTE_CHANNEL_SWAP_VADDR              	(0xb8025874)
#define  H3DDMA_CAP_L1_START_DB_2_VADDR                     	(0xb8025878)
#define  H3DDMA_CAP_R1_START_DB_2_VADDR                     	(0xb802587c)
#define  H3DDMA_CAP_STATUS_2_VADDR                          	(0xb8025880)
#define  H3DDMA_CAP_L3_START_VADDR                          	(0xb8025884)
#define  H3DDMA_CAP_R3_START_VADDR                          	(0xb8025888)
#define  H3DDMA_CAP_L4_START_VADDR                          	(0xb802588c)
#define  H3DDMA_CAP_R4_START_VADDR                          	(0xb8025890)
#define  H3DDMA_CAP_CTL2_VADDR                              	(0xb8025894)
#define  H3DDMA_MD_M1_START_VADDR                           	(0xb8025898)
#define  H3DDMA_MD_M2_START_VADDR                           	(0xb802589c)
#define  H3DDMA_MD_M3_START_VADDR                           	(0xb80258a0)
#define  H3DDMA_MD_M4_START_VADDR                           	(0xb80258a4)
#define  H3DDMA_I3DDMA_MDP_CR_VADDR                         	(0xb80258a8)
#define  H3DDMA_CAP2_BYTE_SWAP_VADDR                        	(0xb80258ac)
#define  H3DDMA_I3DDMA_BIST_CAP_FAIL_VADDR                  	(0xb80258d8)
#define  H3DDMA_I3DDMA_DRF_CAP_FAIL_VADDR                   	(0xb80258ec)
#define  H3DDMA_I3DDMA_DVS_VADDR                            	(0xb80258f0)
#define  H3DDMA_I3DDMA_DVSE_VADDR                           	(0xb80258f4)
#define  H3DDMA_I3DDMA_LS_VADDR                             	(0xb80258f8)
#define  H3DDMA_H3DDMA_PQ_CMP_VADDR                         	(0xb8025d00)
#define  H3DDMA_H3DDMA_PQ_CMP_PAIR_VADDR                    	(0xb8025d04)
#define  H3DDMA_H3DDMA_PQ_CMP_BIT_VADDR                     	(0xb8025d08)
#define  H3DDMA_H3DDMA_PQ_CMP_ENABLE_VADDR                  	(0xb8025d0c)
#define  H3DDMA_H3DDMA_PQ_CMP_SMOOTH_VADDR                  	(0xb8025d10)
#define  H3DDMA_H3DDMA_PQ_CMP_ALLOCATE_VADDR                	(0xb8025d14)
#define  H3DDMA_H3DDMA_PQ_CMP_POOR_VADDR                    	(0xb8025d18)
#define  H3DDMA_H3DDMA_PQ_CMP_GUARANTEE_VADDR               	(0xb8025d1c)
#define  H3DDMA_H3DDMA_PQ_CMP_BALANCE_VADDR                 	(0xb8025d20)
#define  H3DDMA_H3DDMA_PQ_CMP_IRQ_EN_VADDR                  	(0xb8025d24)
#define  H3DDMA_H3DDMA_PQ_CMP_IRQ_ST_VADDR                  	(0xb8025d28)
#define  H3DDMA_H3DDMA_PQ_CMP_ST_VADDR                      	(0xb8025d2c)
#define  H3DDMA_H3DDMA_PQ_CMP_QP_ST_VADDR                   	(0xb8025d30)
#define  H3DDMA_H3DDMA_PQ_CMP_FIFO_ST1_VADDR                	(0xb8025d34)
#define  H3DDMA_H3DDMA_PQ_CMP_LEFT_ST_VADDR                 	(0xb8025d3c)
#define  H3DDMA_H3DDMA_PQ_CMP_PACKAGE_ST_VADDR              	(0xb8025d40)
#define  H3DDMA_H3DDMA_PQ_CMP_CRC_EVEN_G_VADDR              	(0xb8025d44)
#define  H3DDMA_H3DDMA_PQ_CMP_CRC_EVEN_R_VADDR              	(0xb8025d48)
#define  H3DDMA_H3DDMA_PQ_CMP_CRC_EVEN_B_VADDR              	(0xb8025d4c)
#define  H3DDMA_H3DDMA_PQ_CMP_BLK0_ADD0_VADDR               	(0xb8025d60)
#define  H3DDMA_H3DDMA_PQ_CMP_BLK0_ADD1_VADDR               	(0xb8025d64)
#define  H3DDMA_H3DDMA_PQ_CMP_DOUBLE_BUFFER_CTRL_VADDR      	(0xb8025d68)
#define  H3DDMA_H3DDMA_PQ_CMP_DEN_EXTEND_RATE_VADDR         	(0xb8025d6c)



#ifndef LITTLE_ENDIAN //apply BIG_ENDIAN

//======H3DDMA register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy_lr_ctrl1:5;
        RBus_UInt32  hdmi420_en:1;
        RBus_UInt32  chess_board_format:1;
        RBus_UInt32  hdmi_3d_sel:1;
        RBus_UInt32  vs_inv:1;
        RBus_UInt32  hs_inv:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  progressive:1;
        RBus_UInt32  hdmi_3d_structure:4;
        RBus_UInt32  fp_vact_space1:8;
        RBus_UInt32  fp_vact_space2:8;
    };
}h3ddma_lr_separate_ctrl1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  vact:16;
        RBus_UInt32  res1:1;
        RBus_UInt32  hact:15;
    };
}h3ddma_lr_separate_ctrl2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:11;
        RBus_UInt32  hstart:13;
        RBus_UInt32  vstart:8;
    };
}h3ddma_lr_separate_insert_vs_start_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:11;
        RBus_UInt32  hend:13;
        RBus_UInt32  vend:8;
    };
}h3ddma_lr_separate_insert_vs_end_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  triple_buf_en:1;
        RBus_UInt32  cap_block_fw:2;
        RBus_UInt32  set_block_sel:1;
        RBus_UInt32  quad_buf_en:1;
        RBus_UInt32  res1:2;
        RBus_UInt32  freeze_en:1;
        RBus_UInt32  vs_fall_rst_en:1;
        RBus_UInt32  auto_block_sel_en:1;
        RBus_UInt32  half_wr_en:1;
        RBus_UInt32  half_wr_sel:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  bit_sel:1;
        RBus_UInt32  pixel_encoding:2;
        RBus_UInt32  res3:1;
        RBus_UInt32  cap_write_len:7;
        RBus_UInt32  res4:1;
        RBus_UInt32  cap_write_rem:7;
    };
}h3ddma_cap_ctl0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy_cap_ctl1:17;
        RBus_UInt32  cap_water_lv:7;
        RBus_UInt32  cap_write_num:8;
    };
}h3ddma_cap_ctl1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap_mem_up_limit:29;
        RBus_UInt32  res1:3;
    };
}h3ddma_cap_boundaryaddr1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap_mem_low_limit:29;
        RBus_UInt32  res1:3;
    };
}h3ddma_cap_boundaryaddr2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap2_mem_up_limit:29;
        RBus_UInt32  res1:3;
    };
}h3ddma_cap2_boundaryaddr1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap2_mem_low_limit:29;
        RBus_UInt32  res1:3;
    };
}h3ddma_cap2_boundaryaddr2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap_l1_start:29;
        RBus_UInt32  res1:3;
    };
}h3ddma_cap_l1_start_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap_l2_start:29;
        RBus_UInt32  res1:3;
    };
}h3ddma_cap_l2_start_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap_r1_start:29;
        RBus_UInt32  res1:3;
    };
}h3ddma_cap_r1_start_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap_r2_start:29;
        RBus_UInt32  res1:3;
    };
}h3ddma_cap_r2_start_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap_l1_start_db:29;
        RBus_UInt32  res1:3;
    };
}h3ddma_cap_l1_start_db_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap_r1_start_db:29;
        RBus_UInt32  res1:3;
    };
}h3ddma_cap_r1_start_db_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:10;
        RBus_UInt32  cap2_block_sel:2;
        RBus_UInt32  cap_block_sel:2;
        RBus_UInt32  cap2_last_wr_flag:1;
        RBus_UInt32  cap_last_wr_flag:1;
        RBus_UInt32  res2:2;
        RBus_UInt32  cap_block_2:2;
        RBus_UInt32  cap_over_size:1;
        RBus_UInt32  cap_under_size:1;
        RBus_UInt32  freeze_ok:1;
        RBus_UInt32  vs_rising_occur:1;
        RBus_UInt32  tg_l_flag:1;
        RBus_UInt32  res3:1;
        RBus_UInt32  cap_field:1;
        RBus_UInt32  cap_fifo_full:1;
        RBus_UInt32  cap_fifo_empty:1;
        RBus_UInt32  cap_fifo_overflow:1;
        RBus_UInt32  cap_fifo_underflow:1;
        RBus_UInt32  cap_ddr_over_range:1;
    };
}h3ddma_cap_status_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:6;
        RBus_UInt32  pullup_en:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  res3:3;
        RBus_UInt32  tg_hend1:13;
        RBus_UInt32  tg_vend1:8;
    };
}h3ddma_tg_v1_end_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  tg_hstart2:13;
        RBus_UInt32  res2:3;
        RBus_UInt32  tg_vstart2:13;
    };
}h3ddma_tg_v2_start_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  tg_hend2:13;
        RBus_UInt32  res2:3;
        RBus_UInt32  tg_vend2:13;
    };
}h3ddma_tg_v2_end_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  tg_hstart3:13;
        RBus_UInt32  res2:3;
        RBus_UInt32  tg_vstart3:13;
    };
}h3ddma_tg_v3_start_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  tg_hend3:13;
        RBus_UInt32  res2:3;
        RBus_UInt32  tg_vend3:13;
    };
}h3ddma_tg_v3_end_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  tg_hstart4:13;
        RBus_UInt32  res2:3;
        RBus_UInt32  tg_vstart4:13;
    };
}h3ddma_tg_v4_start_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  tg_hend4:13;
        RBus_UInt32  res2:3;
        RBus_UInt32  tg_vend4:13;
    };
}h3ddma_tg_v4_end_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy_cts_fifo:24;
        RBus_UInt32  res1:5;
        RBus_UInt32  force_ctsfifo_rstn:1;
        RBus_UInt32  en_ctsfifo_vsrst:1;
        RBus_UInt32  en_ctsfifo_bypass:1;
    };
}h3ddma_cts_fifo_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  r_crc_conti:1;
        RBus_UInt32  r_crc_start:1;
        RBus_UInt32  res2:6;
        RBus_UInt32  l_crc_conti:1;
        RBus_UInt32  l_crc_start:1;
    };
}h3ddma_lr_crc_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  crc_l_result:32;
    };
}h3ddma_crc_l_result_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  crc_r_result:32;
    };
}h3ddma_crc_r_result_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:27;
        RBus_UInt32  cap2_last_wrt_ie:1;
        RBus_UInt32  cap_last_wrt_ie:1;
        RBus_UInt32  mem_err_ie:1;
        RBus_UInt32  fifo_err_ie:1;
        RBus_UInt32  vs_rising_ie:1;
    };
}h3ddma_interrupt_enable_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:26;
        RBus_UInt32  block_sel_to_flag_fifo_option:1;
        RBus_UInt32  frc_style:1;
        RBus_UInt32  frc_en:1;
        RBus_UInt32  tg_en:1;
        RBus_UInt32  lr_separate_en:1;
        RBus_UInt32  cap_en:1;
    };
}h3ddma_i3ddma_enable_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:25;
        RBus_UInt32  dma_channel_swap:3;
        RBus_UInt32  dma_8byte_swap:1;
        RBus_UInt32  dma_4byte_swap:1;
        RBus_UInt32  dma_2byte_swap:1;
        RBus_UInt32  dma_1byte_swap:1;
    };
}h3ddma_i3ddma_byte_channel_swap_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap2_l1_start_db:29;
        RBus_UInt32  res1:3;
    };
}h3ddma_cap_l1_start_db_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap2_r1_start_db:29;
        RBus_UInt32  res1:3;
    };
}h3ddma_cap_r1_start_db_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:25;
        RBus_UInt32  cap2_block:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  cap2_fifo_full:1;
        RBus_UInt32  cap2_fifo_empty:1;
        RBus_UInt32  cap2_fifo_overflow:1;
        RBus_UInt32  cap2_fifo_underflow:1;
        RBus_UInt32  cap2_ddr_over_range:1;
    };
}h3ddma_cap_status_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap_l3_start:29;
        RBus_UInt32  res1:3;
    };
}h3ddma_cap_l3_start_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap_r3_start:29;
        RBus_UInt32  res1:3;
    };
}h3ddma_cap_r3_start_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap_l4_start:29;
        RBus_UInt32  res1:3;
    };
}h3ddma_cap_l4_start_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap_r4_start:29;
        RBus_UInt32  res1:3;
    };
}h3ddma_cap_r4_start_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  md_parser_en:1;
        RBus_UInt32  cap2_write_len:7;
        RBus_UInt32  res1:1;
        RBus_UInt32  cap2_write_rem:7;
        RBus_UInt32  cap2_dcu_sel:1;
        RBus_UInt32  cap2_water_lv:7;
        RBus_UInt32  cap2_write_num:8;
    };
}h3ddma_cap_ctl2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  md_m1_start:29;
        RBus_UInt32  res1:3;
    };
}h3ddma_md_m1_start_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  md_m2_start:29;
        RBus_UInt32  res1:3;
    };
}h3ddma_md_m2_start_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  md_m3_start:29;
        RBus_UInt32  res1:3;
    };
}h3ddma_md_m3_start_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  md_m4_start:29;
        RBus_UInt32  res1:3;
    };
}h3ddma_md_m4_start_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:7;
        RBus_UInt32  max_packet_num:9;
        RBus_UInt32  dummy180258a8_15:1;
        RBus_UInt32  dummy180258a8_14:1;
        RBus_UInt32  dummy180258a8_13:1;
        RBus_UInt32  dummy180258a8_12:1;
        RBus_UInt32  dummy180258a8_11:1;
        RBus_UInt32  dummy180258a8_10_8:3;
        RBus_UInt32  dummy180258a8_7:1;
        RBus_UInt32  dummy180258a8_6_4:3;
        RBus_UInt32  dummy180258a8_3:1;
        RBus_UInt32  mode:2;
        RBus_UInt32  en:1;
    };
}h3ddma_i3ddma_mdp_cr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  cap2_8byte_swap:1;
        RBus_UInt32  cap2_4byte_swap:1;
        RBus_UInt32  cap2_2byte_swap:1;
        RBus_UInt32  cap2_1byte_swap:1;
    };
}h3ddma_cap2_byte_swap_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:17;
        RBus_UInt32  i3ddma_pqc2_bist_fail_12:1;
        RBus_UInt32  i3ddma_pqc2_bist_fail_11:1;
        RBus_UInt32  i3ddma_pqc2_bist_fail_10:1;
        RBus_UInt32  i3ddma_pqc2_bist_fail_9:1;
        RBus_UInt32  i3ddma_pqc2_bist_fail_8:1;
        RBus_UInt32  i3ddma_pqc2_bist_fail_7:1;
        RBus_UInt32  i3ddma_pqc2_bist_fail_6:1;
        RBus_UInt32  i3ddma_pqc2_bist_fail_5:1;
        RBus_UInt32  i3ddma_pqc2_bist_fail_4:1;
        RBus_UInt32  i3ddma_pqc2_bist_fail_3:1;
        RBus_UInt32  i3ddma_pqc2_bist_fail_2:1;
        RBus_UInt32  i3ddma_pqc2_bist_fail_1:1;
        RBus_UInt32  i3ddma_pqc2_bist_fail_0:1;
        RBus_UInt32  i3ddma_bist_cap2_fail:1;
        RBus_UInt32  i3ddma_bist_cap_fail:1;
    };
}h3ddma_i3ddma_bist_cap_fail_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:17;
        RBus_UInt32  i3ddma_pqc2_drf_fail_12:1;
        RBus_UInt32  i3ddma_pqc2_drf_fail_11:1;
        RBus_UInt32  i3ddma_pqc2_drf_fail_10:1;
        RBus_UInt32  i3ddma_pqc2_drf_fail_9:1;
        RBus_UInt32  i3ddma_pqc2_drf_fail_8:1;
        RBus_UInt32  i3ddma_pqc2_drf_fail_7:1;
        RBus_UInt32  i3ddma_pqc2_drf_fail_6:1;
        RBus_UInt32  i3ddma_pqc2_drf_fail_5:1;
        RBus_UInt32  i3ddma_pqc2_drf_fail_4:1;
        RBus_UInt32  i3ddma_pqc2_drf_fail_3:1;
        RBus_UInt32  i3ddma_pqc2_drf_fail_2:1;
        RBus_UInt32  i3ddma_pqc2_drf_fail_1:1;
        RBus_UInt32  i3ddma_pqc2_drf_fail_0:1;
        RBus_UInt32  i3ddma_drf_cap2_fail:1;
        RBus_UInt32  i3ddma_drf_cap_fail:1;
    };
}h3ddma_i3ddma_drf_cap_fail_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  i3ddma_pqc2_rm_1:4;
        RBus_UInt32  i3ddma_pqc2_rm_0:4;
        RBus_UInt32  cap2_dvsb:4;
        RBus_UInt32  cap2_dvsa:4;
        RBus_UInt32  cap_dvsb:4;
        RBus_UInt32  cap_dvsa:4;
    };
}h3ddma_i3ddma_dvs_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:26;
        RBus_UInt32  i3ddma_pqc2_rme_1:1;
        RBus_UInt32  i3ddma_pqc2_rme_0:1;
        RBus_UInt32  cap2_dvseb:1;
        RBus_UInt32  cap2_dvsea:1;
        RBus_UInt32  cap_dvseb:1;
        RBus_UInt32  cap_dvsea:1;
    };
}h3ddma_i3ddma_dvse_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  i3ddma_pqc2_ls_1:1;
        RBus_UInt32  i3ddma_pqc2_ls_0:1;
        RBus_UInt32  cap2_ls:1;
        RBus_UInt32  cap_ls:1;
    };
}h3ddma_i3ddma_ls_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmp_en:1;
        RBus_UInt32  res1:6;
        RBus_UInt32  cmp_width_div32:9;
        RBus_UInt32  res2:2;
        RBus_UInt32  cmp_height:14;
    };
}h3ddma_h3ddma_pq_cmp_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmp_line_sum_bit:16;
        RBus_UInt32  cmp_400_old_mode_en:1;
        RBus_UInt32  dummy18025d04_14_7:8;
        RBus_UInt32  two_line_prediction_en:1;
        RBus_UInt32  cmp_line_mode:1;
        RBus_UInt32  cmp_data_color:1;
        RBus_UInt32  cmp_data_bit_width:2;
        RBus_UInt32  cmp_data_format:2;
    };
}h3ddma_h3ddma_pq_cmp_pair_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  first_line_more_bit:6;
        RBus_UInt32  res2:2;
        RBus_UInt32  block_limit_bit:6;
        RBus_UInt32  res3:2;
        RBus_UInt32  line_limit_bit:6;
        RBus_UInt32  res4:2;
        RBus_UInt32  frame_limit_bit:6;
    };
}h3ddma_h3ddma_pq_cmp_bit_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  input_fifo_pause_cycle:4;
        RBus_UInt32  tail_dummy_throughput:1;
        RBus_UInt32  res1:6;
        RBus_UInt32  g_ratio:5;
        RBus_UInt32  add_last2blk_over_curve_bit:1;
        RBus_UInt32  force_last2blk_pe_mode0:1;
        RBus_UInt32  dynamic_sum_line_rst:1;
        RBus_UInt32  blk0_add_en:1;
        RBus_UInt32  guarantee_max_qp_en:1;
        RBus_UInt32  dynamic_allocate_ratio_en:1;
        RBus_UInt32  poor_limit_min_qp_en:1;
        RBus_UInt32  balance_en:1;
        RBus_UInt32  fisrt_line_more_en:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  do_422_mode:2;
        RBus_UInt32  res3:1;
        RBus_UInt32  not_enough_bit_do_422_en:1;
        RBus_UInt32  not_rich_do_422_en:1;
        RBus_UInt32  rb_lossy_do_422_en:1;
    };
}h3ddma_h3ddma_pq_cmp_enable_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:5;
        RBus_UInt32  not_enough_bit_do_422_qp:3;
        RBus_UInt32  not_rich_do_422_th:4;
        RBus_UInt32  res2:1;
        RBus_UInt32  rb_lossy_do_422_qp_level:3;
        RBus_UInt32  res3:4;
        RBus_UInt32  variation_value_th:4;
        RBus_UInt32  res4:1;
        RBus_UInt32  variation_num_th:3;
        RBus_UInt32  res5:1;
        RBus_UInt32  variation_near_num_th:3;
    };
}h3ddma_h3ddma_pq_cmp_smooth_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  dynamic_allocate_ratio_max:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  dynamic_allocate_ratio_min:5;
        RBus_UInt32  res3:5;
        RBus_UInt32  dynamic_allocate_line:3;
        RBus_UInt32  dynamic_allocate_more:4;
        RBus_UInt32  dynamic_allocate_less:4;
    };
}h3ddma_h3ddma_pq_cmp_allocate_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  poor_limit_th_qp4:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  poor_limit_th_qp3:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  poor_limit_th_qp2:5;
        RBus_UInt32  res4:3;
        RBus_UInt32  poor_limit_th_qp1:5;
    };
}h3ddma_h3ddma_pq_cmp_poor_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  cmp_crc_ro_line_sel:14;
        RBus_UInt32  res2:8;
        RBus_UInt32  guarantee_max_rb_qp:4;
        RBus_UInt32  guarantee_max_g_qp:4;
    };
}h3ddma_h3ddma_pq_cmp_guarantee_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:18;
        RBus_UInt32  balance_rb_ov_th:2;
        RBus_UInt32  balance_rb_ud_th:2;
        RBus_UInt32  balance_rb_give:2;
        RBus_UInt32  res2:2;
        RBus_UInt32  balance_g_ov_th:2;
        RBus_UInt32  balance_g_ud_th:2;
        RBus_UInt32  balance_g_give:2;
    };
}h3ddma_h3ddma_pq_cmp_balance_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:13;
        RBus_UInt32  prs_over_line_sum_bit_irq_en:1;
        RBus_UInt32  tail_fifo_overflow_irq_en:1;
        RBus_UInt32  input_fifo_overflow_irq_en:1;
        RBus_UInt32  block_fifo_overflow_irq_en:1;
        RBus_UInt32  input_size_more_irq_en:1;
        RBus_UInt32  input_size_less_irq_en:1;
        RBus_UInt32  over_flb_irq_en:1;
        RBus_UInt32  res2:2;
        RBus_UInt32  request_fifo_even_overflow_irq_en:1;
        RBus_UInt32  res3:1;
        RBus_UInt32  res4:1;
        RBus_UInt32  g_fifo_even_overflow_irq_en:1;
        RBus_UInt32  r_fifo_even_overflow_irq_en:1;
        RBus_UInt32  b_fifo_even_overflow_irq_en:1;
        RBus_UInt32  res5:1;
        RBus_UInt32  res6:1;
        RBus_UInt32  res7:1;
        RBus_UInt32  res8:1;
    };
}h3ddma_h3ddma_pq_cmp_irq_en_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pqc_irq:1;
        RBus_UInt32  res1:12;
        RBus_UInt32  prs_over_line_sum_bit_st:1;
        RBus_UInt32  tail_fifo_overflow_st:1;
        RBus_UInt32  input_fifo_overflow_st:1;
        RBus_UInt32  block_fifo_overflow_st:1;
        RBus_UInt32  input_size_more_st:1;
        RBus_UInt32  input_size_less_st:1;
        RBus_UInt32  over_flb_st:1;
        RBus_UInt32  res2:2;
        RBus_UInt32  request_fifo_even_overflow_st:1;
        RBus_UInt32  res3:1;
        RBus_UInt32  res4:1;
        RBus_UInt32  g_fifo_even_overflow_st:1;
        RBus_UInt32  r_fifo_even_overflow_st:1;
        RBus_UInt32  b_fifo_even_overflow_st:1;
        RBus_UInt32  res5:1;
        RBus_UInt32  res6:1;
        RBus_UInt32  res7:1;
        RBus_UInt32  res8:1;
    };
}h3ddma_h3ddma_pq_cmp_irq_st_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  g_ratio_max:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  g_ratio_min:5;
        RBus_UInt32  res3:2;
        RBus_UInt32  cmp_package_height_cnt:14;
    };
}h3ddma_h3ddma_pq_cmp_st_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  long_term_qp_measure_en:1;
        RBus_UInt32  res1:7;
        RBus_UInt32  long_term_g_qp_max:4;
        RBus_UInt32  long_term_rb_qp_max:4;
        RBus_UInt32  res2:8;
        RBus_UInt32  short_term_g_qp_max:4;
        RBus_UInt32  short_term_rb_qp_max:4;
    };
}h3ddma_h3ddma_pq_cmp_qp_st_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fifo_water_measure_en:1;
        RBus_UInt32  res1:7;
        RBus_UInt32  fifo_water_even_g:8;
        RBus_UInt32  fifo_water_even_r:8;
        RBus_UInt32  fifo_water_even_b:8;
    };
}h3ddma_h3ddma_pq_cmp_fifo_st1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  g_frame_left:16;
        RBus_UInt32  rb_frame_left:16;
    };
}h3ddma_h3ddma_pq_cmp_left_st_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  total_package_long_term:1;
        RBus_UInt32  res1:7;
        RBus_UInt32  total_package_even:24;
    };
}h3ddma_h3ddma_pq_cmp_package_st_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmp_crc_even_g:32;
    };
}h3ddma_h3ddma_pq_cmp_crc_even_g_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmp_crc_even_r:32;
    };
}h3ddma_h3ddma_pq_cmp_crc_even_r_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmp_crc_even_b:32;
    };
}h3ddma_h3ddma_pq_cmp_crc_even_b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:18;
        RBus_UInt32  blk0_add_value32:6;
        RBus_UInt32  res2:2;
        RBus_UInt32  blk0_add_value16:6;
    };
}h3ddma_h3ddma_pq_cmp_blk0_add0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  blk0_add_value8:6;
        RBus_UInt32  res2:2;
        RBus_UInt32  blk0_add_value4:6;
        RBus_UInt32  res3:2;
        RBus_UInt32  blk0_add_value2:6;
        RBus_UInt32  res4:2;
        RBus_UInt32  blk0_add_value1:6;
    };
}h3ddma_h3ddma_pq_cmp_blk0_add1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:29;
        RBus_UInt32  db_read_sel:1;
        RBus_UInt32  db_apply:1;
        RBus_UInt32  db_en:1;
    };
}h3ddma_h3ddma_pq_cmp_double_buffer_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  pqc_den_extend_rate:4;
    };
}h3ddma_h3ddma_pq_cmp_den_extend_rate_RBUS;

#else //apply LITTLE_ENDIAN

//======H3DDMA register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fp_vact_space2:8;
        RBus_UInt32  fp_vact_space1:8;
        RBus_UInt32  hdmi_3d_structure:4;
        RBus_UInt32  progressive:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  hs_inv:1;
        RBus_UInt32  vs_inv:1;
        RBus_UInt32  hdmi_3d_sel:1;
        RBus_UInt32  chess_board_format:1;
        RBus_UInt32  hdmi420_en:1;
        RBus_UInt32  dummy_lr_ctrl1:5;
    };
}h3ddma_lr_separate_ctrl1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hact:15;
        RBus_UInt32  res1:1;
        RBus_UInt32  vact:16;
    };
}h3ddma_lr_separate_ctrl2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  vstart:8;
        RBus_UInt32  hstart:13;
        RBus_UInt32  res1:11;
    };
}h3ddma_lr_separate_insert_vs_start_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  vend:8;
        RBus_UInt32  hend:13;
        RBus_UInt32  res1:11;
    };
}h3ddma_lr_separate_insert_vs_end_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap_write_rem:7;
        RBus_UInt32  res1:1;
        RBus_UInt32  cap_write_len:7;
        RBus_UInt32  res2:1;
        RBus_UInt32  pixel_encoding:2;
        RBus_UInt32  bit_sel:1;
        RBus_UInt32  res3:1;
        RBus_UInt32  half_wr_sel:1;
        RBus_UInt32  half_wr_en:1;
        RBus_UInt32  auto_block_sel_en:1;
        RBus_UInt32  vs_fall_rst_en:1;
        RBus_UInt32  freeze_en:1;
        RBus_UInt32  res4:2;
        RBus_UInt32  quad_buf_en:1;
        RBus_UInt32  set_block_sel:1;
        RBus_UInt32  cap_block_fw:2;
        RBus_UInt32  triple_buf_en:1;
    };
}h3ddma_cap_ctl0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap_write_num:8;
        RBus_UInt32  cap_water_lv:7;
        RBus_UInt32  dummy_cap_ctl1:17;
    };
}h3ddma_cap_ctl1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  cap_mem_up_limit:29;
    };
}h3ddma_cap_boundaryaddr1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  cap_mem_low_limit:29;
    };
}h3ddma_cap_boundaryaddr2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  cap2_mem_up_limit:29;
    };
}h3ddma_cap2_boundaryaddr1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  cap2_mem_low_limit:29;
    };
}h3ddma_cap2_boundaryaddr2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  cap_l1_start:29;
    };
}h3ddma_cap_l1_start_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  cap_l2_start:29;
    };
}h3ddma_cap_l2_start_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  cap_r1_start:29;
    };
}h3ddma_cap_r1_start_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  cap_r2_start:29;
    };
}h3ddma_cap_r2_start_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  cap_l1_start_db:29;
    };
}h3ddma_cap_l1_start_db_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  cap_r1_start_db:29;
    };
}h3ddma_cap_r1_start_db_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap_ddr_over_range:1;
        RBus_UInt32  cap_fifo_underflow:1;
        RBus_UInt32  cap_fifo_overflow:1;
        RBus_UInt32  cap_fifo_empty:1;
        RBus_UInt32  cap_fifo_full:1;
        RBus_UInt32  cap_field:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  tg_l_flag:1;
        RBus_UInt32  vs_rising_occur:1;
        RBus_UInt32  freeze_ok:1;
        RBus_UInt32  cap_under_size:1;
        RBus_UInt32  cap_over_size:1;
        RBus_UInt32  cap_block_2:2;
        RBus_UInt32  res2:2;
        RBus_UInt32  cap_last_wr_flag:1;
        RBus_UInt32  cap2_last_wr_flag:1;
        RBus_UInt32  cap_block_sel:2;
        RBus_UInt32  cap2_block_sel:2;
        RBus_UInt32  res3:10;
    };
}h3ddma_cap_status_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  tg_vend1:8;
        RBus_UInt32  tg_hend1:13;
        RBus_UInt32  res1:3;
        RBus_UInt32  res2:1;
        RBus_UInt32  pullup_en:1;
        RBus_UInt32  res3:6;
    };
}h3ddma_tg_v1_end_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  tg_vstart2:13;
        RBus_UInt32  res1:3;
        RBus_UInt32  tg_hstart2:13;
        RBus_UInt32  res2:3;
    };
}h3ddma_tg_v2_start_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  tg_vend2:13;
        RBus_UInt32  res1:3;
        RBus_UInt32  tg_hend2:13;
        RBus_UInt32  res2:3;
    };
}h3ddma_tg_v2_end_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  tg_vstart3:13;
        RBus_UInt32  res1:3;
        RBus_UInt32  tg_hstart3:13;
        RBus_UInt32  res2:3;
    };
}h3ddma_tg_v3_start_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  tg_vend3:13;
        RBus_UInt32  res1:3;
        RBus_UInt32  tg_hend3:13;
        RBus_UInt32  res2:3;
    };
}h3ddma_tg_v3_end_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  tg_vstart4:13;
        RBus_UInt32  res1:3;
        RBus_UInt32  tg_hstart4:13;
        RBus_UInt32  res2:3;
    };
}h3ddma_tg_v4_start_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  tg_vend4:13;
        RBus_UInt32  res1:3;
        RBus_UInt32  tg_hend4:13;
        RBus_UInt32  res2:3;
    };
}h3ddma_tg_v4_end_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  en_ctsfifo_bypass:1;
        RBus_UInt32  en_ctsfifo_vsrst:1;
        RBus_UInt32  force_ctsfifo_rstn:1;
        RBus_UInt32  res1:5;
        RBus_UInt32  dummy_cts_fifo:24;
    };
}h3ddma_cts_fifo_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  l_crc_start:1;
        RBus_UInt32  l_crc_conti:1;
        RBus_UInt32  res1:6;
        RBus_UInt32  r_crc_start:1;
        RBus_UInt32  r_crc_conti:1;
        RBus_UInt32  res2:22;
    };
}h3ddma_lr_crc_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  crc_l_result:32;
    };
}h3ddma_crc_l_result_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  crc_r_result:32;
    };
}h3ddma_crc_r_result_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  vs_rising_ie:1;
        RBus_UInt32  fifo_err_ie:1;
        RBus_UInt32  mem_err_ie:1;
        RBus_UInt32  cap_last_wrt_ie:1;
        RBus_UInt32  cap2_last_wrt_ie:1;
        RBus_UInt32  res1:27;
    };
}h3ddma_interrupt_enable_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap_en:1;
        RBus_UInt32  lr_separate_en:1;
        RBus_UInt32  tg_en:1;
        RBus_UInt32  frc_en:1;
        RBus_UInt32  frc_style:1;
        RBus_UInt32  block_sel_to_flag_fifo_option:1;
        RBus_UInt32  res1:26;
    };
}h3ddma_i3ddma_enable_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dma_1byte_swap:1;
        RBus_UInt32  dma_2byte_swap:1;
        RBus_UInt32  dma_4byte_swap:1;
        RBus_UInt32  dma_8byte_swap:1;
        RBus_UInt32  dma_channel_swap:3;
        RBus_UInt32  res1:25;
    };
}h3ddma_i3ddma_byte_channel_swap_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  cap2_l1_start_db:29;
    };
}h3ddma_cap_l1_start_db_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  cap2_r1_start_db:29;
    };
}h3ddma_cap_r1_start_db_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap2_ddr_over_range:1;
        RBus_UInt32  cap2_fifo_underflow:1;
        RBus_UInt32  cap2_fifo_overflow:1;
        RBus_UInt32  cap2_fifo_empty:1;
        RBus_UInt32  cap2_fifo_full:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  cap2_block:1;
        RBus_UInt32  res2:25;
    };
}h3ddma_cap_status_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  cap_l3_start:29;
    };
}h3ddma_cap_l3_start_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  cap_r3_start:29;
    };
}h3ddma_cap_r3_start_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  cap_l4_start:29;
    };
}h3ddma_cap_l4_start_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  cap_r4_start:29;
    };
}h3ddma_cap_r4_start_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap2_write_num:8;
        RBus_UInt32  cap2_water_lv:7;
        RBus_UInt32  cap2_dcu_sel:1;
        RBus_UInt32  cap2_write_rem:7;
        RBus_UInt32  res1:1;
        RBus_UInt32  cap2_write_len:7;
        RBus_UInt32  md_parser_en:1;
    };
}h3ddma_cap_ctl2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  md_m1_start:29;
    };
}h3ddma_md_m1_start_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  md_m2_start:29;
    };
}h3ddma_md_m2_start_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  md_m3_start:29;
    };
}h3ddma_md_m3_start_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  md_m4_start:29;
    };
}h3ddma_md_m4_start_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  en:1;
        RBus_UInt32  mode:2;
        RBus_UInt32  dummy180258a8_3:1;
        RBus_UInt32  dummy180258a8_6_4:3;
        RBus_UInt32  dummy180258a8_7:1;
        RBus_UInt32  dummy180258a8_10_8:3;
        RBus_UInt32  dummy180258a8_11:1;
        RBus_UInt32  dummy180258a8_12:1;
        RBus_UInt32  dummy180258a8_13:1;
        RBus_UInt32  dummy180258a8_14:1;
        RBus_UInt32  dummy180258a8_15:1;
        RBus_UInt32  max_packet_num:9;
        RBus_UInt32  res1:7;
    };
}h3ddma_i3ddma_mdp_cr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap2_1byte_swap:1;
        RBus_UInt32  cap2_2byte_swap:1;
        RBus_UInt32  cap2_4byte_swap:1;
        RBus_UInt32  cap2_8byte_swap:1;
        RBus_UInt32  res1:28;
    };
}h3ddma_cap2_byte_swap_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  i3ddma_bist_cap_fail:1;
        RBus_UInt32  i3ddma_bist_cap2_fail:1;
        RBus_UInt32  i3ddma_pqc2_bist_fail_0:1;
        RBus_UInt32  i3ddma_pqc2_bist_fail_1:1;
        RBus_UInt32  i3ddma_pqc2_bist_fail_2:1;
        RBus_UInt32  i3ddma_pqc2_bist_fail_3:1;
        RBus_UInt32  i3ddma_pqc2_bist_fail_4:1;
        RBus_UInt32  i3ddma_pqc2_bist_fail_5:1;
        RBus_UInt32  i3ddma_pqc2_bist_fail_6:1;
        RBus_UInt32  i3ddma_pqc2_bist_fail_7:1;
        RBus_UInt32  i3ddma_pqc2_bist_fail_8:1;
        RBus_UInt32  i3ddma_pqc2_bist_fail_9:1;
        RBus_UInt32  i3ddma_pqc2_bist_fail_10:1;
        RBus_UInt32  i3ddma_pqc2_bist_fail_11:1;
        RBus_UInt32  i3ddma_pqc2_bist_fail_12:1;
        RBus_UInt32  res1:17;
    };
}h3ddma_i3ddma_bist_cap_fail_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  i3ddma_drf_cap_fail:1;
        RBus_UInt32  i3ddma_drf_cap2_fail:1;
        RBus_UInt32  i3ddma_pqc2_drf_fail_0:1;
        RBus_UInt32  i3ddma_pqc2_drf_fail_1:1;
        RBus_UInt32  i3ddma_pqc2_drf_fail_2:1;
        RBus_UInt32  i3ddma_pqc2_drf_fail_3:1;
        RBus_UInt32  i3ddma_pqc2_drf_fail_4:1;
        RBus_UInt32  i3ddma_pqc2_drf_fail_5:1;
        RBus_UInt32  i3ddma_pqc2_drf_fail_6:1;
        RBus_UInt32  i3ddma_pqc2_drf_fail_7:1;
        RBus_UInt32  i3ddma_pqc2_drf_fail_8:1;
        RBus_UInt32  i3ddma_pqc2_drf_fail_9:1;
        RBus_UInt32  i3ddma_pqc2_drf_fail_10:1;
        RBus_UInt32  i3ddma_pqc2_drf_fail_11:1;
        RBus_UInt32  i3ddma_pqc2_drf_fail_12:1;
        RBus_UInt32  res1:17;
    };
}h3ddma_i3ddma_drf_cap_fail_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap_dvsa:4;
        RBus_UInt32  cap_dvsb:4;
        RBus_UInt32  cap2_dvsa:4;
        RBus_UInt32  cap2_dvsb:4;
        RBus_UInt32  i3ddma_pqc2_rm_0:4;
        RBus_UInt32  i3ddma_pqc2_rm_1:4;
        RBus_UInt32  res1:8;
    };
}h3ddma_i3ddma_dvs_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap_dvsea:1;
        RBus_UInt32  cap_dvseb:1;
        RBus_UInt32  cap2_dvsea:1;
        RBus_UInt32  cap2_dvseb:1;
        RBus_UInt32  i3ddma_pqc2_rme_0:1;
        RBus_UInt32  i3ddma_pqc2_rme_1:1;
        RBus_UInt32  res1:26;
    };
}h3ddma_i3ddma_dvse_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cap_ls:1;
        RBus_UInt32  cap2_ls:1;
        RBus_UInt32  i3ddma_pqc2_ls_0:1;
        RBus_UInt32  i3ddma_pqc2_ls_1:1;
        RBus_UInt32  res1:28;
    };
}h3ddma_i3ddma_ls_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmp_height:14;
        RBus_UInt32  res1:2;
        RBus_UInt32  cmp_width_div32:9;
        RBus_UInt32  res2:6;
        RBus_UInt32  cmp_en:1;
    };
}h3ddma_h3ddma_pq_cmp_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmp_data_format:2;
        RBus_UInt32  cmp_data_bit_width:2;
        RBus_UInt32  cmp_data_color:1;
        RBus_UInt32  cmp_line_mode:1;
        RBus_UInt32  two_line_prediction_en:1;
        RBus_UInt32  dummy18025d04_14_7:8;
        RBus_UInt32  cmp_400_old_mode_en:1;
        RBus_UInt32  cmp_line_sum_bit:16;
    };
}h3ddma_h3ddma_pq_cmp_pair_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  frame_limit_bit:6;
        RBus_UInt32  res1:2;
        RBus_UInt32  line_limit_bit:6;
        RBus_UInt32  res2:2;
        RBus_UInt32  block_limit_bit:6;
        RBus_UInt32  res3:2;
        RBus_UInt32  first_line_more_bit:6;
        RBus_UInt32  res4:2;
    };
}h3ddma_h3ddma_pq_cmp_bit_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  rb_lossy_do_422_en:1;
        RBus_UInt32  not_rich_do_422_en:1;
        RBus_UInt32  not_enough_bit_do_422_en:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  do_422_mode:2;
        RBus_UInt32  res2:1;
        RBus_UInt32  fisrt_line_more_en:1;
        RBus_UInt32  balance_en:1;
        RBus_UInt32  poor_limit_min_qp_en:1;
        RBus_UInt32  dynamic_allocate_ratio_en:1;
        RBus_UInt32  guarantee_max_qp_en:1;
        RBus_UInt32  blk0_add_en:1;
        RBus_UInt32  dynamic_sum_line_rst:1;
        RBus_UInt32  force_last2blk_pe_mode0:1;
        RBus_UInt32  add_last2blk_over_curve_bit:1;
        RBus_UInt32  g_ratio:5;
        RBus_UInt32  res3:6;
        RBus_UInt32  tail_dummy_throughput:1;
        RBus_UInt32  input_fifo_pause_cycle:4;
    };
}h3ddma_h3ddma_pq_cmp_enable_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  variation_near_num_th:3;
        RBus_UInt32  res1:1;
        RBus_UInt32  variation_num_th:3;
        RBus_UInt32  res2:1;
        RBus_UInt32  variation_value_th:4;
        RBus_UInt32  res3:4;
        RBus_UInt32  rb_lossy_do_422_qp_level:3;
        RBus_UInt32  res4:1;
        RBus_UInt32  not_rich_do_422_th:4;
        RBus_UInt32  not_enough_bit_do_422_qp:3;
        RBus_UInt32  res5:5;
    };
}h3ddma_h3ddma_pq_cmp_smooth_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dynamic_allocate_less:4;
        RBus_UInt32  dynamic_allocate_more:4;
        RBus_UInt32  dynamic_allocate_line:3;
        RBus_UInt32  res1:5;
        RBus_UInt32  dynamic_allocate_ratio_min:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  dynamic_allocate_ratio_max:5;
        RBus_UInt32  res3:3;
    };
}h3ddma_h3ddma_pq_cmp_allocate_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  poor_limit_th_qp1:5;
        RBus_UInt32  res1:3;
        RBus_UInt32  poor_limit_th_qp2:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  poor_limit_th_qp3:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  poor_limit_th_qp4:5;
        RBus_UInt32  res4:3;
    };
}h3ddma_h3ddma_pq_cmp_poor_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  guarantee_max_g_qp:4;
        RBus_UInt32  guarantee_max_rb_qp:4;
        RBus_UInt32  res1:8;
        RBus_UInt32  cmp_crc_ro_line_sel:14;
        RBus_UInt32  res2:2;
    };
}h3ddma_h3ddma_pq_cmp_guarantee_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  balance_g_give:2;
        RBus_UInt32  balance_g_ud_th:2;
        RBus_UInt32  balance_g_ov_th:2;
        RBus_UInt32  res1:2;
        RBus_UInt32  balance_rb_give:2;
        RBus_UInt32  balance_rb_ud_th:2;
        RBus_UInt32  balance_rb_ov_th:2;
        RBus_UInt32  res2:18;
    };
}h3ddma_h3ddma_pq_cmp_balance_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  res3:1;
        RBus_UInt32  res4:1;
        RBus_UInt32  b_fifo_even_overflow_irq_en:1;
        RBus_UInt32  r_fifo_even_overflow_irq_en:1;
        RBus_UInt32  g_fifo_even_overflow_irq_en:1;
        RBus_UInt32  res5:1;
        RBus_UInt32  res6:1;
        RBus_UInt32  request_fifo_even_overflow_irq_en:1;
        RBus_UInt32  res7:2;
        RBus_UInt32  over_flb_irq_en:1;
        RBus_UInt32  input_size_less_irq_en:1;
        RBus_UInt32  input_size_more_irq_en:1;
        RBus_UInt32  block_fifo_overflow_irq_en:1;
        RBus_UInt32  input_fifo_overflow_irq_en:1;
        RBus_UInt32  tail_fifo_overflow_irq_en:1;
        RBus_UInt32  prs_over_line_sum_bit_irq_en:1;
        RBus_UInt32  res8:13;
    };
}h3ddma_h3ddma_pq_cmp_irq_en_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  res3:1;
        RBus_UInt32  res4:1;
        RBus_UInt32  b_fifo_even_overflow_st:1;
        RBus_UInt32  r_fifo_even_overflow_st:1;
        RBus_UInt32  g_fifo_even_overflow_st:1;
        RBus_UInt32  res5:1;
        RBus_UInt32  res6:1;
        RBus_UInt32  request_fifo_even_overflow_st:1;
        RBus_UInt32  res7:2;
        RBus_UInt32  over_flb_st:1;
        RBus_UInt32  input_size_less_st:1;
        RBus_UInt32  input_size_more_st:1;
        RBus_UInt32  block_fifo_overflow_st:1;
        RBus_UInt32  input_fifo_overflow_st:1;
        RBus_UInt32  tail_fifo_overflow_st:1;
        RBus_UInt32  prs_over_line_sum_bit_st:1;
        RBus_UInt32  res8:12;
        RBus_UInt32  pqc_irq:1;
    };
}h3ddma_h3ddma_pq_cmp_irq_st_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmp_package_height_cnt:14;
        RBus_UInt32  res1:2;
        RBus_UInt32  g_ratio_min:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  g_ratio_max:5;
        RBus_UInt32  res3:3;
    };
}h3ddma_h3ddma_pq_cmp_st_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  short_term_rb_qp_max:4;
        RBus_UInt32  short_term_g_qp_max:4;
        RBus_UInt32  res1:8;
        RBus_UInt32  long_term_rb_qp_max:4;
        RBus_UInt32  long_term_g_qp_max:4;
        RBus_UInt32  res2:7;
        RBus_UInt32  long_term_qp_measure_en:1;
    };
}h3ddma_h3ddma_pq_cmp_qp_st_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fifo_water_even_b:8;
        RBus_UInt32  fifo_water_even_r:8;
        RBus_UInt32  fifo_water_even_g:8;
        RBus_UInt32  res1:7;
        RBus_UInt32  fifo_water_measure_en:1;
    };
}h3ddma_h3ddma_pq_cmp_fifo_st1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  rb_frame_left:16;
        RBus_UInt32  g_frame_left:16;
    };
}h3ddma_h3ddma_pq_cmp_left_st_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  total_package_even:24;
        RBus_UInt32  res1:7;
        RBus_UInt32  total_package_long_term:1;
    };
}h3ddma_h3ddma_pq_cmp_package_st_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmp_crc_even_g:32;
    };
}h3ddma_h3ddma_pq_cmp_crc_even_g_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmp_crc_even_r:32;
    };
}h3ddma_h3ddma_pq_cmp_crc_even_r_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmp_crc_even_b:32;
    };
}h3ddma_h3ddma_pq_cmp_crc_even_b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  blk0_add_value16:6;
        RBus_UInt32  res1:2;
        RBus_UInt32  blk0_add_value32:6;
        RBus_UInt32  res2:18;
    };
}h3ddma_h3ddma_pq_cmp_blk0_add0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  blk0_add_value1:6;
        RBus_UInt32  res1:2;
        RBus_UInt32  blk0_add_value2:6;
        RBus_UInt32  res2:2;
        RBus_UInt32  blk0_add_value4:6;
        RBus_UInt32  res3:2;
        RBus_UInt32  blk0_add_value8:6;
        RBus_UInt32  res4:2;
    };
}h3ddma_h3ddma_pq_cmp_blk0_add1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  db_en:1;
        RBus_UInt32  db_apply:1;
        RBus_UInt32  db_read_sel:1;
        RBus_UInt32  res1:29;
    };
}h3ddma_h3ddma_pq_cmp_double_buffer_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pqc_den_extend_rate:4;
        RBus_UInt32  res1:28;
    };
}h3ddma_h3ddma_pq_cmp_den_extend_rate_RBUS;




#endif 


#endif 
