#ifndef __HDMI_HDCP_H__
#define __HDMI_HDCP_H__

#define	HDCP_10_DVI 	0x91
#define	HDCP_11_HDMI 	0x93


extern void lib_hdmi_hdcp_init(unsigned char nport);
extern void lib_hdmi_write_hdcpkey(unsigned char nport, unsigned char *bksv, unsigned char *hdcp_key);
extern void lib_hdmi_read_hdcpkey(unsigned char nport, unsigned char *bksv, unsigned char *hdcp_key);

// for HDCP1.4
extern void lib_hdmi_hdcp14_enable(unsigned char port, unsigned char on);
extern unsigned char lib_hdmi_hdcp14_is_onoff(unsigned char nport);
extern unsigned char lib_hdcp14_check_aksv_reg(unsigned char port);
extern void lib_hdcp14_clear_aksv_reg(unsigned char port);
extern unsigned char lib_hdcp14_check_bksv_reg(unsigned char nport);
extern void lib_hdcp14_clear_bksv_reg(unsigned char nport);
extern void lib_hdmi_hdcp_port_write_conti(unsigned char port, unsigned char addr, const unsigned char* value, unsigned char num);
extern void lib_hdmi_hdcp_port_write(unsigned char port, unsigned char addr ,unsigned char value);
extern unsigned char lib_hdmi_hdcp_port_read(unsigned char port, unsigned char addr);
extern void lib_hdmi_hdcp_toggle_dkapde(unsigned char nport);

#if HDCP2_2 // HDCP2_2
extern void lib_hdmi_hdcp22_enable(unsigned char port, unsigned char enable);
extern unsigned char lib_hdmi_hdcp22_is_onoff(unsigned char nport);
extern unsigned char lib_hdmi_hdcp22_get_auth_done(unsigned char nport);
extern void lib_hdmi_hdcp22_init(unsigned char port);
#endif

#endif //__HDMI_HDCP_H__
