#ifndef __USB_PV_H__
#define __USB_PV_H__

#include "rtd_type.h"

extern int usb_pv_IP_start(int argc, char *argv[]);
extern int usb_pv_storgae_RW_test(int argc, char *argv[]);
extern int usb_pv_usb2serial_test(int argc, char *argv[]);
extern int usb_pv_help(int argc, char *argv[]);

SUB_FUNC usb_verify_func_list[] =
{
    {"usb_pv_IP_start", "Verify IP works or not.",
        usb_pv_IP_start},
    {"usb_pv_storage_RW_test", "Verify USB storage Read/Write.",
        usb_pv_storgae_RW_test},
    {"usb_pv_usb2serial_test", "Verify USB2Serial device (pl2303).",
        usb_pv_usb2serial_test},

    /* Always keep help func at last. It's going to be skip at auto testing mode */
    {"usb_pv_help",	"Read me for more information.",
    	usb_pv_help},

};

#define USB_PV_FUNC_COUNT    (sizeof(usb_verify_func_list)/sizeof(SUB_FUNC))

#define KNRM  "\x1B[0m"
#define KRED  "\x1B[31m"
#define KGRN  "\x1B[32m"
#define KYEL  "\x1B[33m"
#define KBLU  "\x1B[34m"
#define KMAG  "\x1B[35m"
#define KCYN  "\x1B[36m"
#define KWHT  "\x1B[37m"

#define USB_PV_PRINT(fmt, args...) \
    printf("%s(%d) " fmt, __func__, __LINE__, ## args)

#define USB_PV_SHOW_RESULT(ret) \
    printf("####################### %s%s%s ###################### \n", \
            ret ? KRED : KGRN, \
            ret ? " fail  " : "success", KNRM)

#endif
