#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include "otp_bitmap.h"
#include "otp_info.h"
#include "util.h"

int get_2state_OTP(unsigned int value)
{
	switch (value) {
		case TWO_STATE_VIRGIN:
		case TWO_STATE_DEFAULT:
			return 0;
		case TWO_STATE_SECURE:
			return 1;
		default:
			return -1;
	}
}

int get_3state_OTP_progressive(unsigned int value)
{
	switch (value) {
		case THREE_STATE_VIRGIN:
		case THREE_STATE_DEFAULT:
			return 0;
		case THREE_STATE_PROTECTED:
			return 1;
		case THREE_STATE_SECURE:
			return 2;
		default:
			return -1;
	}
}

int get_3state_OTP_split(unsigned int value)
{
	switch (value) {
		case THREE_STATE_VIRGIN:
		case THREE_STATE_DEFAULT:
			return 0;
		case THREE_STATE_SECURE1:
			return 1;
		case THREE_STATE_SECURE2:
			return 2;
		default:
			return -1;
	}
}

int get_4state_OTP_split(unsigned int value)
{
	switch (value) {
		case FOUR_STATE_VIRGIN:
		case FOUR_STATE_DEFAULT:
			return 0;
		case FOUR_STATE_SECURE1:
			return 1;
		case FOUR_STATE_SECURE2:
			return 2;
		case FOUR_STATE_SECURE3:
			return 3;
		default:
			return -1;
	}
}

unsigned int encode_2state_OTP(int value)
{
	switch (value) {
		case 0:
			return TWO_STATE_DEFAULT;
		case 1:
			return TWO_STATE_SECURE;
		default:
			return TWO_STATE_VIRGIN;
	}
}

unsigned int encode_3state_OTP_progressive(int value)
{
	switch (value) {
		case 0:
			return THREE_STATE_DEFAULT;
		case 1:
			return THREE_STATE_PROTECTED;
		case 2:
			return THREE_STATE_SECURE;
		default:
			return THREE_STATE_VIRGIN;
	}
}

unsigned int encode_3state_OTP_split(int value)
{
	switch (value) {
		case 0:
			return THREE_STATE_DEFAULT;
		case 1:
			return THREE_STATE_SECURE1;
		case 2:
			return THREE_STATE_SECURE2;
		default:
			return THREE_STATE_VIRGIN;
	}
}

unsigned int encode_4state_OTP_split(int value)
{
	switch (value) {
		case 0:
			return FOUR_STATE_DEFAULT;
		case 1:
			return FOUR_STATE_SECURE1;
		case 2:
			return FOUR_STATE_SECURE2;
		case 3:
			return FOUR_STATE_SECURE3;
		default:
			return FOUR_STATE_VIRGIN;
	}
}

