/**************************************************************
// Spec Version                  : 1.4
// Parser Version                : DVR_Parser_6.11(120105)
// CModelGen Version             : 5.1 2012.01.05
// Naming Rule                   :  Register_Name
// Naming Rule                   : Module_Register_Name_reg
// Parse Option                  : Only Parse _op1
// Parse Address Region          : All Address Region
// Decode bit number             : 12 bits
// Firmware Header Generate Date : 2013/11/13 14:18:21
***************************************************************/


#ifndef __RTK_MD_REG_H__
#define __RTK_MD_REG_H__

#include <rbus/md_reg.h>

#define BIT(x)                      (1 << (x))
#define MD_CMD_BUF          (4096 * sizeof(uint32_t))
#define MD_ONE_CMD_LEN  (4 * sizeof(uint32_t))


#define MD_SMQ_CNTL_reg                    MD_MD_SMQ_CNTL_reg
#define MD_SMQ_INT_STATUS_reg              MD_MD_SMQ_INT_STATUS_reg
#define MD_SMQ_INT_ENABLE_reg              MD_MD_SMQ_INT_ENABLE_reg
#define MD_SMQBASE_reg                     MD_MD_SMQBase_reg
#define MD_SMQLIMIT_reg                    MD_MD_SMQLimit_reg
#define MD_SMQRDPTR_reg                    MD_MD_SMQRdptr_reg
#define MD_SMQWRPTR_reg                    MD_MD_SMQWrptr_reg
#define MD_SMQFIFOSTATE_reg                MD_MD_SMQFifoState_reg
#define MD_SMQ_INSTCNT_reg                 MD_MD_SMQ_INSTCNT_reg
#define MD_DBG_reg                         MD_MD_DBG_reg
#define MD_POWER_reg                       MD_MD_POWER_reg
#define MD_DUMMY1_reg                      MD_MD_DUMMY1_reg
#define MD_DUMMY2_reg                      MD_MD_DUMMY2_reg
#define MD_REG_MODE_reg                    MD_MD_REG_MODE_reg
#define MD_REG_CTRL_reg                    MD_MD_REG_CTRL_reg
#define MD_REG_CMD1_reg                    MD_MD_REG_CMD1_reg
#define MD_REG_CMD2_reg                    MD_MD_REG_CMD2_reg
#define MD_REG_CMD3_reg                    MD_MD_REG_CMD3_reg
#define MD_REG_CMD4_reg                    MD_MD_REG_CMD4_reg
#define MD_W_CRC_CTRL_reg                  MD_MD_W_CRC_CTRL_reg
#define MD_W_CRC_MASK1_reg                 MD_MD_W_CRC_MASK1_reg
#define MD_W_CRC_MASK2_reg                 MD_MD_W_CRC_MASK2_reg
#define MD_W_CRC_RESULT_reg                MD_MD_W_CRC_RESULT_reg
#define MD_R_CRC_CTRL_reg                  MD_MD_R_CRC_CTRL_reg
#define MD_R_CRC_MASK1_reg                 MD_MD_R_CRC_MASK1_reg
#define MD_R_CRC_MASK2_reg                 MD_MD_R_CRC_MASK2_reg
#define MD_DES_CRC_reg                     MD_MD_DES_CRC_reg
#define MD_R_CRC_RESULT_reg                MD_MD_R_CRC_RESULT_reg
#define MD_CRC_STATUS_reg                  MD_MD_CRC_STATUS_reg
#define MD_REG_CMD5_reg                    MD_MD_REG_CMD5_reg
#define MD_MULTI_REQ_reg                   MD_MD_MULTI_REQ_reg
#define MD_BSTLEN_reg                      MD_MD_BSTLEN_reg

#define GET_MD_SMQ_CNTL()                                                  rtd_inl(MD_SMQ_CNTL_reg)
#define GET_MD_SMQ_INT_STATUS()                                       rtd_inl(MD_SMQ_INT_STATUS_reg)
#define GET_MD_SMQ_INT_ENABLE()                                       rtd_inl(MD_SMQ_INT_ENABLE_reg)
#define GET_MD_SMQBASE()                                                    rtd_inl(MD_SMQBASE_reg)
#define GET_MD_SMQLIMIT()                                                   rtd_inl(MD_SMQLIMIT_reg)
#define GET_MD_SMQRDPTR()                                                 rtd_inl(MD_SMQRDPTR_reg)
#define GET_MD_SMQWRPTR()                                                 rtd_inl(MD_SMQWRPTR_reg)
#define GET_MD_SMQFIFOSTATE()                                           rtd_inl(MD_SMQFIFOSTATE_reg)
#define GET_MD_SMQ_INSTCNT()                                            rtd_inl(MD_SMQ_INSTCNT_reg)
#define GET_MD_DUMMY1()                                                     rtd_inl(MD_DUMMY1_reg)
#define GET_MD_MULTI_REQ()                                                 rtd_inl(MD_MULTI_REQ_reg)
#define GET_MD_REG_MODE()                                                  rtd_inl(MD_REG_MODE_reg)
#define GET_MD_REG_CTRL()                                                   rtd_inl(MD_REG_CTRL_reg)
#define GET_MD_REG_CMD1()                                                  rtd_inl(MD_REG_CMD1_reg)
#define GET_MD_REG_CMD2()                                                  rtd_inl(MD_REG_CMD2_reg)
#define GET_MD_REG_CMD3()                                                  rtd_inl(MD_REG_CMD3_reg)
#define GET_MD_REG_CMD4()                                                  rtd_inl(MD_REG_CMD4_reg)
#define GET_MD_W_CRC_CTRL()                                              rtd_inl(MD_W_CRC_CTRL_reg)
#define GET_MD_W_CRC_MASK1()                                            rtd_inl(MD_W_CRC_MASK1_reg)
#define GET_MD_W_CRC_MASK2()                                            rtd_inl(MD_W_CRC_MASK2_reg)
#define GET_MD_W_CRC_RESULT()                                          rtd_inl(MD_W_CRC_RESULT_reg)
#define GET_MD_R_CRC_CTRL()                                               rtd_inl(MD_R_CRC_CTRL_reg)
#define GET_MD_R_CRC_MASK1()                                             rtd_inl(MD_R_CRC_MASK1_reg)
#define GET_MD_R_CRC_MASK2()                                             rtd_inl(MD_R_CRC_MASK2_reg)
#define GET_MD_DES_CRC()                                                     rtd_inl(MD_DES_CRC_reg)
#define GET_MD_R_CRC_RESULT()                                            rtd_inl(MD_R_CRC_RESULT_reg)
#define GET_MD_W_CRC_RESULT()                                            rtd_inl(MD_W_CRC_RESULT_reg)





#define SET_MD_SMQ_CNTL(val)                                               rtd_outl(MD_SMQ_CNTL_reg, val)
#define SET_MD_SMQ_INT_STATUS(val)                                    rtd_outl(MD_SMQ_INT_STATUS_reg, val)
#define SET_MD_SMQ_INT_ENABLE(val)                                    rtd_outl(MD_SMQ_INT_ENABLE_reg, val)
#define SET_MD_SMQBASE(val)                                                  rtd_outl(MD_SMQBASE_reg, val)
#define SET_MD_SMQLIMIT(val)                                                 rtd_outl(MD_SMQLIMIT_reg, val)
#define SET_MD_SMQRDPTR(val)                                               rtd_outl(MD_SMQRDPTR_reg, val)
#define SET_MD_SMQWRPTR(val)                                               rtd_outl(MD_SMQWRPTR_reg, val)
#define SET_MD_SMQFIFOSTATE(val)                                         rtd_outl(MD_SMQFIFOSTATE_reg, val)
#define SET_MD_SMQ_INSTCNT(val)                                          rtd_outl(MD_SMQ_INSTCNT_reg, val)
#define SET_MD_DUMMY1(val)                                                   rtd_outl(MD_DUMMY1_reg, val)
#define SET_MD_MULTI_REQ(val)                                               rtd_outl(MD_MULTI_REQ_reg, val)
#define SET_MD_REG_MODE(val)                                                rtd_outl(MD_REG_MODE_reg, val)
#define SET_MD_REG_CTRL(val)                                                   rtd_outl(MD_REG_CTRL_reg, val)
#define SET_MD_REG_CMD1(val)                                                  rtd_outl(MD_REG_CMD1_reg, val)
#define SET_MD_REG_CMD2(val)                                                  rtd_outl(MD_REG_CMD2_reg, val)
#define SET_MD_REG_CMD3(val)                                                  rtd_outl(MD_REG_CMD3_reg, val)
#define SET_MD_REG_CMD4(val)                                                  rtd_outl(MD_REG_CMD4_reg, val)
#define SET_MD_REG_CMD5(val)                                                  rtd_outl(MD_REG_CMD5_reg, val)
#define SET_MD_W_CRC_CTRL(val)                                              rtd_outl(MD_W_CRC_CTRL_reg, val)
#define SET_MD_W_CRC_MASK1(val)                                            rtd_outl(MD_W_CRC_MASK1_reg, val)
#define SET_MD_W_CRC_MASK2(val)                                            rtd_outl(MD_W_CRC_MASK2_reg, val)
#define SET_MD_W_CRC_RESULT(val)                                          rtd_outl(MD_W_CRC_RESULT_reg, val)
#define SET_MD_R_CRC_CTRL(val)                                               rtd_outl(MD_R_CRC_CTRL_reg, val)
#define SET_MD_R_CRC_MASK1(val)                                             rtd_outl(MD_R_CRC_MASK1_reg, val)
#define SET_MD_R_CRC_MASK2(val)                                             rtd_outl(MD_R_CRC_MASK2_reg, val)
#define SET_MD_DES_CRC(val)                                                          rtd_outl(MD_DES_CRC_reg, val)
#define SET_MD_R_CRC_RESULT(val)                                                rtd_outl(MD_R_CRC_RESULT_reg, val)


#define MD_SMQ_IDLE_MASK                                                  0x00000008
#define MD_SMQ_IDLE_SHIFT                                                  3
#define GET_MD_SMQ_IDLE()                                                   ((GET_MD_SMQ_CNTL() & MD_SMQ_IDLE_MASK) >> MD_SMQ_IDLE_SHIFT)

#define MD_SMQ_INST_CNT_MASK                                           (0x0000FFFF)
#define MD_SMQ_INST_CNT_SHIFT                                           (0)
#define GET_MD_SMQ_INST_CNT()                                           ((GET_MD_SMQ_INSTCNT() & MD_SMQ_INST_CNT_MASK) >> MD_SMQ_INST_CNT_SHIFT)

#define MD_MULTI_REQ_EN_MASK                                           0x00000001
#define MD_MULTI_REQ_EN_SHIFT                                           0
#define GET_MD_MULTI_REQ_EN()                                           ((GET_MD_MULTI_REQ() & MD_MULTI_REQ_EN_MASK) >> MD_MULTI_REQ_EN_SHIFT)
#define MD_MULTI_REQ_EN(x)                                                 (((x) << MD_MULTI_REQ_EN_SHIFT) & MD_MULTI_REQ_EN_MASK)

#define MD_REG_POLL_MASK                                                   0x00010000
#define MD_REG_POLL_SHIFT                                                   16
#define GET_MD_REG_POLL()                                                   ((GET_MD_REG_CTRL() & MD_REG_POLL_MASK) >> MD_REG_POLL_SHIFT)
#define MD_REG_POLL(x)                                                         (((x) << MD_REG_POLL_SHIFT) & MD_REG_POLL_MASK)

#define MD_REG_LOOP_MASK                                                   0x0000FFFF
#define MD_REG_LOOP_SHIFT                                                   0
#define GET_MD_REG_LOOP()                                                   ((GET_MD_REG_CTRL() & MD_REG_LOOP_MASK) >> MD_REG_LOOP_SHIFT)
#define MD_REG_LOOP(x)                                                         (((x) << MD_REG_LOOP_SHIFT) & MD_REG_LOOP_MASK)

#define MD_REG_MODE_MASK                                                   0x00000001
#define MD_REG_MODE_SHIFT                                                   0
#define GET_MD_REG_MODE_MODE()                                           ((GET_MD_REG_MODE() & MD_REG_MODE_MASK) >> MD_REG_MODE_SHIFT)
#define MD_REG_MODE(x)                                                         (((x) << MD_REG_MODE_SHIFT) & MD_REG_MODE_MASK)

#define MD_R_CRC_START_MASK                                             0x00000002
#define MD_R_CRC_START_SHIFT                                             1
#define GET_MD_R_CRC_START()                                           ((GET_MD_R_CRC_CTRL() & MD_R_CRC_START_MASK) >> MD_R_CRC_START_SHIFT)
#define MD_R_CRC_START(x)                                                  (((x) << MD_R_CRC_START_SHIFT) & MD_R_CRC_START_MASK)

#define MD_R_CRC_READ_ONLY(x)                                          ((x & 1) << 3) 
#define MD_W_CRC_START(x)                                              ((x & 1) << 1)

typedef enum {
    MdWriteData = BIT(0),
    MdGo        = BIT(1),
    MdEndianSwap    = BIT(2),
    MdIdle      = BIT(3)
} MD_CTRL_REG;

/*interrupt status and control bits */
typedef enum {
    MD_INT_STS_MQ_INST_ERR = BIT(1),
    MD_INT_STS_MQ_EMPTY  = BIT(3),
    MD_INT_STS_FDMA_DONE   = BIT(4),
    MD_INT_STS_MQ_MODE_2B4BERR  = BIT(5),
    MD_INT_STS_FDMA_GO_BUSY =  BIT(10),
} MD_INT_STATUS_REG;

typedef enum {
    MD_INT_MQ_INST_ERR_EN = BIT(1),
    MD_INT_MQ_EMPTY_EN  = BIT(3),
    MD_INT_FDMA_DONE_EN   = BIT(4),
    MD_INT_MQ_MODE_2B4BERR_EN  = BIT(5),
    MD_INT_SCPU_INT_EN=  BIT(10),
}  MD_INT_CTRL_REG;



/*********The defines releated to MD COMMAND DESCRIPTOR*************/
#define MD_SEQ_LEN_LIMIT        (0x80000000)
#define MD_SEQ_LEN_LIMIT_MASK   (0x7fffffff)

/*********************seq to seq******************************/
#define MOVE_FORWARD        0
#define MOVE_BACKWARD       BIT(7)

#define MD_CONST            BIT(6)
#define MD_VECTOR           (0)

/*Word 1 bit[3:0] : opcode */
#define MD_1B               (0x05)
#define MD_2B               (0x07)
#define MD_4B               (0x0D)

/*Word 1 bit[5:4] : move mode */
#define MD_SS               (0x00) /*seq -> seq */
#define MD_SB               (0x10) /*seq -> blk */
#define MD_BS               (0x20) /*blk -> seq */
#define MD_SS_PITCH         (0x30) /*seq -> seq (pitch) */

#define MD_2B_SS            (MD_SS|MD_2B)
#define MD_2B_SS_PITCH          (MD_SS_PITCH|MD_2B)

#define MD_4B_SS            (MD_SS|MD_4B)
#define MD_4B_SS_PITCH          (MD_SS_PITCH|MD_4B)


/**************************seq->seq with pitch***********************/
#define MD_SRC_PITCH(x)         ((x & 0x1FFF)<<19)
#define MD_MAX_SRC_PITCH        (0x2000)
#define MD_DST_PITCH(x)         ((x & 0x1FFF)<<6)
#define MD_MAX_DST_PITCH        (0x2000)
#define MD_HEIGHT_BLK(x)        ((x & 0x7FF)<<21)
#define MD_MAX_HEIGHT_BLOCK     (0x800)
#define MD_WIDTH_BLK(x)         ((x & 0x3FFF)<<7)
#define MD_MAX_WIDTH_BLOCK      (0x4000)

#endif
