/**
* @file Merlin6_MEMC_MC3
* RBus systemc program.
*
* @author RS_MM2_SD
* @email mm_mm2_rd_sw_kernel@realtek.com
* @ingroup model_rbus
 * @version { 1.0 }
 **
 */

#ifndef _RBUS_MC3_REG_H_
#define _RBUS_MC3_REG_H_

#include "rbus_types.h"



//  MC3 Register Address
#define  MC3_MC_HF_LPF_0                                                        0x18099C00
#define  MC3_MC_HF_LPF_0_reg_addr                                                "0xB8099C00"
#define  MC3_MC_HF_LPF_0_reg                                                     0xB8099C00
#define  MC3_MC_HF_LPF_0_inst_addr                                               "0x0000"
#define  set_MC3_MC_HF_LPF_0_reg(data)                                           (*((volatile unsigned int*)MC3_MC_HF_LPF_0_reg)=data)
#define  get_MC3_MC_HF_LPF_0_reg                                                 (*((volatile unsigned int*)MC3_MC_HF_LPF_0_reg))
#define  MC3_MC_HF_LPF_0_mc_hf_lpf_diff_range_shift                              (31)
#define  MC3_MC_HF_LPF_0_mc_hf_lpf_filter4_weight_shift                          (26)
#define  MC3_MC_HF_LPF_0_mc_hf_lpf_filter3_weight_shift                          (21)
#define  MC3_MC_HF_LPF_0_mc_hf_lpf_filter2_weight_shift                          (16)
#define  MC3_MC_HF_LPF_0_mc_hf_lpf_filter1_weight_shift                          (11)
#define  MC3_MC_HF_LPF_0_mc_hf_lpf_force_value_shift                             (4)
#define  MC3_MC_HF_LPF_0_mc_hf_lpf_max_min_weight_en_shift                       (3)
#define  MC3_MC_HF_LPF_0_mc_hf_lpf_max_weight_en_shift                           (2)
#define  MC3_MC_HF_LPF_0_mc_hf_lpf_force_value_en_shift                          (1)
#define  MC3_MC_HF_LPF_0_mc_hf_lpf_en_shift                                      (0)
#define  MC3_MC_HF_LPF_0_mc_hf_lpf_diff_range_mask                               (0x80000000)
#define  MC3_MC_HF_LPF_0_mc_hf_lpf_filter4_weight_mask                           (0x7C000000)
#define  MC3_MC_HF_LPF_0_mc_hf_lpf_filter3_weight_mask                           (0x03E00000)
#define  MC3_MC_HF_LPF_0_mc_hf_lpf_filter2_weight_mask                           (0x001F0000)
#define  MC3_MC_HF_LPF_0_mc_hf_lpf_filter1_weight_mask                           (0x0000F800)
#define  MC3_MC_HF_LPF_0_mc_hf_lpf_force_value_mask                              (0x000007F0)
#define  MC3_MC_HF_LPF_0_mc_hf_lpf_max_min_weight_en_mask                        (0x00000008)
#define  MC3_MC_HF_LPF_0_mc_hf_lpf_max_weight_en_mask                            (0x00000004)
#define  MC3_MC_HF_LPF_0_mc_hf_lpf_force_value_en_mask                           (0x00000002)
#define  MC3_MC_HF_LPF_0_mc_hf_lpf_en_mask                                       (0x00000001)
#define  MC3_MC_HF_LPF_0_mc_hf_lpf_diff_range(data)                              (0x80000000&((data)<<31))
#define  MC3_MC_HF_LPF_0_mc_hf_lpf_filter4_weight(data)                          (0x7C000000&((data)<<26))
#define  MC3_MC_HF_LPF_0_mc_hf_lpf_filter3_weight(data)                          (0x03E00000&((data)<<21))
#define  MC3_MC_HF_LPF_0_mc_hf_lpf_filter2_weight(data)                          (0x001F0000&((data)<<16))
#define  MC3_MC_HF_LPF_0_mc_hf_lpf_filter1_weight(data)                          (0x0000F800&((data)<<11))
#define  MC3_MC_HF_LPF_0_mc_hf_lpf_force_value(data)                             (0x000007F0&((data)<<4))
#define  MC3_MC_HF_LPF_0_mc_hf_lpf_max_min_weight_en(data)                       (0x00000008&((data)<<3))
#define  MC3_MC_HF_LPF_0_mc_hf_lpf_max_weight_en(data)                           (0x00000004&((data)<<2))
#define  MC3_MC_HF_LPF_0_mc_hf_lpf_force_value_en(data)                          (0x00000002&((data)<<1))
#define  MC3_MC_HF_LPF_0_mc_hf_lpf_en(data)                                      (0x00000001&(data))
#define  MC3_MC_HF_LPF_0_get_mc_hf_lpf_diff_range(data)                          ((0x80000000&(data))>>31)
#define  MC3_MC_HF_LPF_0_get_mc_hf_lpf_filter4_weight(data)                      ((0x7C000000&(data))>>26)
#define  MC3_MC_HF_LPF_0_get_mc_hf_lpf_filter3_weight(data)                      ((0x03E00000&(data))>>21)
#define  MC3_MC_HF_LPF_0_get_mc_hf_lpf_filter2_weight(data)                      ((0x001F0000&(data))>>16)
#define  MC3_MC_HF_LPF_0_get_mc_hf_lpf_filter1_weight(data)                      ((0x0000F800&(data))>>11)
#define  MC3_MC_HF_LPF_0_get_mc_hf_lpf_force_value(data)                         ((0x000007F0&(data))>>4)
#define  MC3_MC_HF_LPF_0_get_mc_hf_lpf_max_min_weight_en(data)                   ((0x00000008&(data))>>3)
#define  MC3_MC_HF_LPF_0_get_mc_hf_lpf_max_weight_en(data)                       ((0x00000004&(data))>>2)
#define  MC3_MC_HF_LPF_0_get_mc_hf_lpf_force_value_en(data)                      ((0x00000002&(data))>>1)
#define  MC3_MC_HF_LPF_0_get_mc_hf_lpf_en(data)                                  (0x00000001&(data))

#define  MC3_MC_HF_LPF_1                                                        0x18099C04
#define  MC3_MC_HF_LPF_1_reg_addr                                                "0xB8099C04"
#define  MC3_MC_HF_LPF_1_reg                                                     0xB8099C04
#define  MC3_MC_HF_LPF_1_inst_addr                                               "0x0001"
#define  set_MC3_MC_HF_LPF_1_reg(data)                                           (*((volatile unsigned int*)MC3_MC_HF_LPF_1_reg)=data)
#define  get_MC3_MC_HF_LPF_1_reg                                                 (*((volatile unsigned int*)MC3_MC_HF_LPF_1_reg))
#define  MC3_MC_HF_LPF_1_mc_hf_lpf_max_offset_shift                              (19)
#define  MC3_MC_HF_LPF_1_mc_hf_lpf_max_alpha_shift                               (15)
#define  MC3_MC_HF_LPF_1_mc_hf_lpf_filter7_weight_shift                          (10)
#define  MC3_MC_HF_LPF_1_mc_hf_lpf_filter6_weight_shift                          (5)
#define  MC3_MC_HF_LPF_1_mc_hf_lpf_filter5_weight_shift                          (0)
#define  MC3_MC_HF_LPF_1_mc_hf_lpf_max_offset_mask                               (0x03F80000)
#define  MC3_MC_HF_LPF_1_mc_hf_lpf_max_alpha_mask                                (0x00078000)
#define  MC3_MC_HF_LPF_1_mc_hf_lpf_filter7_weight_mask                           (0x00007C00)
#define  MC3_MC_HF_LPF_1_mc_hf_lpf_filter6_weight_mask                           (0x000003E0)
#define  MC3_MC_HF_LPF_1_mc_hf_lpf_filter5_weight_mask                           (0x0000001F)
#define  MC3_MC_HF_LPF_1_mc_hf_lpf_max_offset(data)                              (0x03F80000&((data)<<19))
#define  MC3_MC_HF_LPF_1_mc_hf_lpf_max_alpha(data)                               (0x00078000&((data)<<15))
#define  MC3_MC_HF_LPF_1_mc_hf_lpf_filter7_weight(data)                          (0x00007C00&((data)<<10))
#define  MC3_MC_HF_LPF_1_mc_hf_lpf_filter6_weight(data)                          (0x000003E0&((data)<<5))
#define  MC3_MC_HF_LPF_1_mc_hf_lpf_filter5_weight(data)                          (0x0000001F&(data))
#define  MC3_MC_HF_LPF_1_get_mc_hf_lpf_max_offset(data)                          ((0x03F80000&(data))>>19)
#define  MC3_MC_HF_LPF_1_get_mc_hf_lpf_max_alpha(data)                           ((0x00078000&(data))>>15)
#define  MC3_MC_HF_LPF_1_get_mc_hf_lpf_filter7_weight(data)                      ((0x00007C00&(data))>>10)
#define  MC3_MC_HF_LPF_1_get_mc_hf_lpf_filter6_weight(data)                      ((0x000003E0&(data))>>5)
#define  MC3_MC_HF_LPF_1_get_mc_hf_lpf_filter5_weight(data)                      (0x0000001F&(data))

#define  MC3_MC_HF_LPF_2                                                        0x18099C08
#define  MC3_MC_HF_LPF_2_reg_addr                                                "0xB8099C08"
#define  MC3_MC_HF_LPF_2_reg                                                     0xB8099C08
#define  MC3_MC_HF_LPF_2_inst_addr                                               "0x0002"
#define  set_MC3_MC_HF_LPF_2_reg(data)                                           (*((volatile unsigned int*)MC3_MC_HF_LPF_2_reg)=data)
#define  get_MC3_MC_HF_LPF_2_reg                                                 (*((volatile unsigned int*)MC3_MC_HF_LPF_2_reg))
#define  MC3_MC_HF_LPF_2_mc_hf_lpf_mv_limit_slp_shift                            (20)
#define  MC3_MC_HF_LPF_2_mc_hf_lpf_mv_limit_th_shift                             (15)
#define  MC3_MC_HF_LPF_2_mc_hf_lpf_diff_offset_shift                             (8)
#define  MC3_MC_HF_LPF_2_mc_hf_lpf_max_min_weight_limit_slp_shift                (3)
#define  MC3_MC_HF_LPF_2_mc_hf_lpf_max_min_weight_limit_th_shift                 (0)
#define  MC3_MC_HF_LPF_2_mc_hf_lpf_mv_limit_slp_mask                             (0x01F00000)
#define  MC3_MC_HF_LPF_2_mc_hf_lpf_mv_limit_th_mask                              (0x000F8000)
#define  MC3_MC_HF_LPF_2_mc_hf_lpf_diff_offset_mask                              (0x00007F00)
#define  MC3_MC_HF_LPF_2_mc_hf_lpf_max_min_weight_limit_slp_mask                 (0x000000F8)
#define  MC3_MC_HF_LPF_2_mc_hf_lpf_max_min_weight_limit_th_mask                  (0x00000007)
#define  MC3_MC_HF_LPF_2_mc_hf_lpf_mv_limit_slp(data)                            (0x01F00000&((data)<<20))
#define  MC3_MC_HF_LPF_2_mc_hf_lpf_mv_limit_th(data)                             (0x000F8000&((data)<<15))
#define  MC3_MC_HF_LPF_2_mc_hf_lpf_diff_offset(data)                             (0x00007F00&((data)<<8))
#define  MC3_MC_HF_LPF_2_mc_hf_lpf_max_min_weight_limit_slp(data)                (0x000000F8&((data)<<3))
#define  MC3_MC_HF_LPF_2_mc_hf_lpf_max_min_weight_limit_th(data)                 (0x00000007&(data))
#define  MC3_MC_HF_LPF_2_get_mc_hf_lpf_mv_limit_slp(data)                        ((0x01F00000&(data))>>20)
#define  MC3_MC_HF_LPF_2_get_mc_hf_lpf_mv_limit_th(data)                         ((0x000F8000&(data))>>15)
#define  MC3_MC_HF_LPF_2_get_mc_hf_lpf_diff_offset(data)                         ((0x00007F00&(data))>>8)
#define  MC3_MC_HF_LPF_2_get_mc_hf_lpf_max_min_weight_limit_slp(data)            ((0x000000F8&(data))>>3)
#define  MC3_MC_HF_LPF_2_get_mc_hf_lpf_max_min_weight_limit_th(data)             (0x00000007&(data))

#define  MC3_MC_HF_LPF_3                                                        0x18099C0C
#define  MC3_MC_HF_LPF_3_reg_addr                                                "0xB8099C0C"
#define  MC3_MC_HF_LPF_3_reg                                                     0xB8099C0C
#define  MC3_MC_HF_LPF_3_inst_addr                                               "0x0003"
#define  set_MC3_MC_HF_LPF_3_reg(data)                                           (*((volatile unsigned int*)MC3_MC_HF_LPF_3_reg)=data)
#define  get_MC3_MC_HF_LPF_3_reg                                                 (*((volatile unsigned int*)MC3_MC_HF_LPF_3_reg))
#define  MC3_MC_HF_LPF_3_mc_frame_filter1_cnt_shift                              (0)
#define  MC3_MC_HF_LPF_3_mc_frame_filter1_cnt_mask                               (0xFFFFFFFF)
#define  MC3_MC_HF_LPF_3_mc_frame_filter1_cnt(data)                              (0xFFFFFFFF&(data))
#define  MC3_MC_HF_LPF_3_get_mc_frame_filter1_cnt(data)                          (0xFFFFFFFF&(data))

#define  MC3_MC_HF_LPF_4                                                        0x18099C10
#define  MC3_MC_HF_LPF_4_reg_addr                                                "0xB8099C10"
#define  MC3_MC_HF_LPF_4_reg                                                     0xB8099C10
#define  MC3_MC_HF_LPF_4_inst_addr                                               "0x0004"
#define  set_MC3_MC_HF_LPF_4_reg(data)                                           (*((volatile unsigned int*)MC3_MC_HF_LPF_4_reg)=data)
#define  get_MC3_MC_HF_LPF_4_reg                                                 (*((volatile unsigned int*)MC3_MC_HF_LPF_4_reg))
#define  MC3_MC_HF_LPF_4_mc_frame_filter2_cnt_shift                              (0)
#define  MC3_MC_HF_LPF_4_mc_frame_filter2_cnt_mask                               (0xFFFFFFFF)
#define  MC3_MC_HF_LPF_4_mc_frame_filter2_cnt(data)                              (0xFFFFFFFF&(data))
#define  MC3_MC_HF_LPF_4_get_mc_frame_filter2_cnt(data)                          (0xFFFFFFFF&(data))

#define  MC3_MC_HF_LPF_5                                                        0x18099C14
#define  MC3_MC_HF_LPF_5_reg_addr                                                "0xB8099C14"
#define  MC3_MC_HF_LPF_5_reg                                                     0xB8099C14
#define  MC3_MC_HF_LPF_5_inst_addr                                               "0x0005"
#define  set_MC3_MC_HF_LPF_5_reg(data)                                           (*((volatile unsigned int*)MC3_MC_HF_LPF_5_reg)=data)
#define  get_MC3_MC_HF_LPF_5_reg                                                 (*((volatile unsigned int*)MC3_MC_HF_LPF_5_reg))
#define  MC3_MC_HF_LPF_5_mc_frame_filter3_cnt_shift                              (0)
#define  MC3_MC_HF_LPF_5_mc_frame_filter3_cnt_mask                               (0xFFFFFFFF)
#define  MC3_MC_HF_LPF_5_mc_frame_filter3_cnt(data)                              (0xFFFFFFFF&(data))
#define  MC3_MC_HF_LPF_5_get_mc_frame_filter3_cnt(data)                          (0xFFFFFFFF&(data))

#define  MC3_MC_HF_LPF_6                                                        0x18099C18
#define  MC3_MC_HF_LPF_6_reg_addr                                                "0xB8099C18"
#define  MC3_MC_HF_LPF_6_reg                                                     0xB8099C18
#define  MC3_MC_HF_LPF_6_inst_addr                                               "0x0006"
#define  set_MC3_MC_HF_LPF_6_reg(data)                                           (*((volatile unsigned int*)MC3_MC_HF_LPF_6_reg)=data)
#define  get_MC3_MC_HF_LPF_6_reg                                                 (*((volatile unsigned int*)MC3_MC_HF_LPF_6_reg))
#define  MC3_MC_HF_LPF_6_mc_frame_filter4_cnt_shift                              (0)
#define  MC3_MC_HF_LPF_6_mc_frame_filter4_cnt_mask                               (0xFFFFFFFF)
#define  MC3_MC_HF_LPF_6_mc_frame_filter4_cnt(data)                              (0xFFFFFFFF&(data))
#define  MC3_MC_HF_LPF_6_get_mc_frame_filter4_cnt(data)                          (0xFFFFFFFF&(data))

#define  MC3_MC_HF_LPF_7                                                        0x18099C1C
#define  MC3_MC_HF_LPF_7_reg_addr                                                "0xB8099C1C"
#define  MC3_MC_HF_LPF_7_reg                                                     0xB8099C1C
#define  MC3_MC_HF_LPF_7_inst_addr                                               "0x0007"
#define  set_MC3_MC_HF_LPF_7_reg(data)                                           (*((volatile unsigned int*)MC3_MC_HF_LPF_7_reg)=data)
#define  get_MC3_MC_HF_LPF_7_reg                                                 (*((volatile unsigned int*)MC3_MC_HF_LPF_7_reg))
#define  MC3_MC_HF_LPF_7_mc_frame_filter5_cnt_shift                              (0)
#define  MC3_MC_HF_LPF_7_mc_frame_filter5_cnt_mask                               (0xFFFFFFFF)
#define  MC3_MC_HF_LPF_7_mc_frame_filter5_cnt(data)                              (0xFFFFFFFF&(data))
#define  MC3_MC_HF_LPF_7_get_mc_frame_filter5_cnt(data)                          (0xFFFFFFFF&(data))

#define  MC3_MC_HF_LPF_8                                                        0x18099C20
#define  MC3_MC_HF_LPF_8_reg_addr                                                "0xB8099C20"
#define  MC3_MC_HF_LPF_8_reg                                                     0xB8099C20
#define  MC3_MC_HF_LPF_8_inst_addr                                               "0x0008"
#define  set_MC3_MC_HF_LPF_8_reg(data)                                           (*((volatile unsigned int*)MC3_MC_HF_LPF_8_reg)=data)
#define  get_MC3_MC_HF_LPF_8_reg                                                 (*((volatile unsigned int*)MC3_MC_HF_LPF_8_reg))
#define  MC3_MC_HF_LPF_8_mc_frame_filter6_cnt_shift                              (0)
#define  MC3_MC_HF_LPF_8_mc_frame_filter6_cnt_mask                               (0xFFFFFFFF)
#define  MC3_MC_HF_LPF_8_mc_frame_filter6_cnt(data)                              (0xFFFFFFFF&(data))
#define  MC3_MC_HF_LPF_8_get_mc_frame_filter6_cnt(data)                          (0xFFFFFFFF&(data))

#define  MC3_MC_HF_LPF_9                                                        0x18099C24
#define  MC3_MC_HF_LPF_9_reg_addr                                                "0xB8099C24"
#define  MC3_MC_HF_LPF_9_reg                                                     0xB8099C24
#define  MC3_MC_HF_LPF_9_inst_addr                                               "0x0009"
#define  set_MC3_MC_HF_LPF_9_reg(data)                                           (*((volatile unsigned int*)MC3_MC_HF_LPF_9_reg)=data)
#define  get_MC3_MC_HF_LPF_9_reg                                                 (*((volatile unsigned int*)MC3_MC_HF_LPF_9_reg))
#define  MC3_MC_HF_LPF_9_mc_frame_filter7_cnt_shift                              (0)
#define  MC3_MC_HF_LPF_9_mc_frame_filter7_cnt_mask                               (0xFFFFFFFF)
#define  MC3_MC_HF_LPF_9_mc_frame_filter7_cnt(data)                              (0xFFFFFFFF&(data))
#define  MC3_MC_HF_LPF_9_get_mc_frame_filter7_cnt(data)                          (0xFFFFFFFF&(data))

#define  MC3_MC_NREA_RIM_BLEND                                                  0x18099C28
#define  MC3_MC_NREA_RIM_BLEND_reg_addr                                          "0xB8099C28"
#define  MC3_MC_NREA_RIM_BLEND_reg                                               0xB8099C28
#define  MC3_MC_NREA_RIM_BLEND_inst_addr                                         "0x000A"
#define  set_MC3_MC_NREA_RIM_BLEND_reg(data)                                     (*((volatile unsigned int*)MC3_MC_NREA_RIM_BLEND_reg)=data)
#define  get_MC3_MC_NREA_RIM_BLEND_reg                                           (*((volatile unsigned int*)MC3_MC_NREA_RIM_BLEND_reg))
#define  MC3_MC_NREA_RIM_BLEND_mc_near_rim_blending_gain_shift                   (2)
#define  MC3_MC_NREA_RIM_BLEND_mc_near_rim_blending_mode_shift                   (1)
#define  MC3_MC_NREA_RIM_BLEND_mc_near_rim_blending_en_shift                     (0)
#define  MC3_MC_NREA_RIM_BLEND_mc_near_rim_blending_gain_mask                    (0x0000000C)
#define  MC3_MC_NREA_RIM_BLEND_mc_near_rim_blending_mode_mask                    (0x00000002)
#define  MC3_MC_NREA_RIM_BLEND_mc_near_rim_blending_en_mask                      (0x00000001)
#define  MC3_MC_NREA_RIM_BLEND_mc_near_rim_blending_gain(data)                   (0x0000000C&((data)<<2))
#define  MC3_MC_NREA_RIM_BLEND_mc_near_rim_blending_mode(data)                   (0x00000002&((data)<<1))
#define  MC3_MC_NREA_RIM_BLEND_mc_near_rim_blending_en(data)                     (0x00000001&(data))
#define  MC3_MC_NREA_RIM_BLEND_get_mc_near_rim_blending_gain(data)               ((0x0000000C&(data))>>2)
#define  MC3_MC_NREA_RIM_BLEND_get_mc_near_rim_blending_mode(data)               ((0x00000002&(data))>>1)
#define  MC3_MC_NREA_RIM_BLEND_get_mc_near_rim_blending_en(data)                 (0x00000001&(data))

#ifndef LITTLE_ENDIAN //apply BIG_ENDIAN

//======MC3 register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mc_hf_lpf_diff_range:1;
        RBus_UInt32  mc_hf_lpf_filter4_weight:5;
        RBus_UInt32  mc_hf_lpf_filter3_weight:5;
        RBus_UInt32  mc_hf_lpf_filter2_weight:5;
        RBus_UInt32  mc_hf_lpf_filter1_weight:5;
        RBus_UInt32  mc_hf_lpf_force_value:7;
        RBus_UInt32  mc_hf_lpf_max_min_weight_en:1;
        RBus_UInt32  mc_hf_lpf_max_weight_en:1;
        RBus_UInt32  mc_hf_lpf_force_value_en:1;
        RBus_UInt32  mc_hf_lpf_en:1;
    };
}mc3_mc_hf_lpf_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:6;
        RBus_UInt32  mc_hf_lpf_max_offset:7;
        RBus_UInt32  mc_hf_lpf_max_alpha:4;
        RBus_UInt32  mc_hf_lpf_filter7_weight:5;
        RBus_UInt32  mc_hf_lpf_filter6_weight:5;
        RBus_UInt32  mc_hf_lpf_filter5_weight:5;
    };
}mc3_mc_hf_lpf_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:7;
        RBus_UInt32  mc_hf_lpf_mv_limit_slp:5;
        RBus_UInt32  mc_hf_lpf_mv_limit_th:5;
        RBus_UInt32  mc_hf_lpf_diff_offset:7;
        RBus_UInt32  mc_hf_lpf_max_min_weight_limit_slp:5;
        RBus_UInt32  mc_hf_lpf_max_min_weight_limit_th:3;
    };
}mc3_mc_hf_lpf_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mc_frame_filter1_cnt:32;
    };
}mc3_mc_hf_lpf_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mc_frame_filter2_cnt:32;
    };
}mc3_mc_hf_lpf_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mc_frame_filter3_cnt:32;
    };
}mc3_mc_hf_lpf_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mc_frame_filter4_cnt:32;
    };
}mc3_mc_hf_lpf_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mc_frame_filter5_cnt:32;
    };
}mc3_mc_hf_lpf_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mc_frame_filter6_cnt:32;
    };
}mc3_mc_hf_lpf_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mc_frame_filter7_cnt:32;
    };
}mc3_mc_hf_lpf_9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  mc_near_rim_blending_gain:2;
        RBus_UInt32  mc_near_rim_blending_mode:1;
        RBus_UInt32  mc_near_rim_blending_en:1;
    };
}mc3_mc_nrea_rim_blend_RBUS;

#else //apply LITTLE_ENDIAN

//======MC3 register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mc_hf_lpf_en:1;
        RBus_UInt32  mc_hf_lpf_force_value_en:1;
        RBus_UInt32  mc_hf_lpf_max_weight_en:1;
        RBus_UInt32  mc_hf_lpf_max_min_weight_en:1;
        RBus_UInt32  mc_hf_lpf_force_value:7;
        RBus_UInt32  mc_hf_lpf_filter1_weight:5;
        RBus_UInt32  mc_hf_lpf_filter2_weight:5;
        RBus_UInt32  mc_hf_lpf_filter3_weight:5;
        RBus_UInt32  mc_hf_lpf_filter4_weight:5;
        RBus_UInt32  mc_hf_lpf_diff_range:1;
    };
}mc3_mc_hf_lpf_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mc_hf_lpf_filter5_weight:5;
        RBus_UInt32  mc_hf_lpf_filter6_weight:5;
        RBus_UInt32  mc_hf_lpf_filter7_weight:5;
        RBus_UInt32  mc_hf_lpf_max_alpha:4;
        RBus_UInt32  mc_hf_lpf_max_offset:7;
        RBus_UInt32  res1:6;
    };
}mc3_mc_hf_lpf_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mc_hf_lpf_max_min_weight_limit_th:3;
        RBus_UInt32  mc_hf_lpf_max_min_weight_limit_slp:5;
        RBus_UInt32  mc_hf_lpf_diff_offset:7;
        RBus_UInt32  mc_hf_lpf_mv_limit_th:5;
        RBus_UInt32  mc_hf_lpf_mv_limit_slp:5;
        RBus_UInt32  res1:7;
    };
}mc3_mc_hf_lpf_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mc_frame_filter1_cnt:32;
    };
}mc3_mc_hf_lpf_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mc_frame_filter2_cnt:32;
    };
}mc3_mc_hf_lpf_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mc_frame_filter3_cnt:32;
    };
}mc3_mc_hf_lpf_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mc_frame_filter4_cnt:32;
    };
}mc3_mc_hf_lpf_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mc_frame_filter5_cnt:32;
    };
}mc3_mc_hf_lpf_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mc_frame_filter6_cnt:32;
    };
}mc3_mc_hf_lpf_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mc_frame_filter7_cnt:32;
    };
}mc3_mc_hf_lpf_9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mc_near_rim_blending_en:1;
        RBus_UInt32  mc_near_rim_blending_mode:1;
        RBus_UInt32  mc_near_rim_blending_gain:2;
        RBus_UInt32  res1:28;
    };
}mc3_mc_nrea_rim_blend_RBUS;




#endif 


#endif 
