#include <common.h>
#include <panel_config_parameter.h>
#include <ppoverlay_reg.h>
#include <sys_reg_reg.h>
#include <pll_reg_reg.h>
#include <pll27x_reg_reg.h>
#include <rbus/two_step_uzu_reg.h>
#include <rbus/od_reg.h>

//#include <pinmux_main_reg.h>
//#include <rbusCRTReg.h>
//#include <rbusPpOverlayReg.h>
#include <pif_reg.h>
#include <sfg_reg.h>
#include <vby1_reg.h>
#include "../../../../../qc_verify/include/VIP/Merlin2/rbus_file/rbusEPIReg.h"
#include <pinmux_lvdsphy_reg.h>
#include <platform_lib/board/pcb_mgr.h>
#ifndef IS_FPGA
#include <platform_lib/board/pcb.h>
#endif
#include <asm/io.h>
#include <bootparam.h>
#include <asm/arch/factorylib.h>
#include <panel.h>
//#include <asm/arch/rbus/rbusLD_InterfaceReg.h>
#include <asm/arch/ld_interface.h>
#include <drivers/i2c/rtk_g2c_lib.h>
#include <drivers/i2c/rtk_i2c_lib.h>
#include <asm/arch/fw_info.h>
#include <panel_api.h>
#include <watchdog.h>
#include <system.h>
#ifdef CONFIG_FSW
#include <factorylib_ro.h>
#include <malloc.h>
#include <parse_h.h>
#endif

#if 0 // remove by weihao because not existed in rbus, fixed me
#include <rtk_gdma_driver.h>
#endif

#ifdef CONFIG_PANEL_SHARP_60_MEMC
#include <tcon/frdlcdapi.h>
#include <drivers/i2c/rtk_i2c_lib.h>
#endif //#ifdef CONFIG_PANEL_SHARP_60_MEMC
#include <rtk_gdma_export.h>
#include <gdma_reg.h>
#ifdef CONFIG_TCON_LESS
#include <asm/arch/takeoverlib_ext4.h>
#endif

extern bool Eeprom_SetMacAddressToKernel_Read(void);
extern bool Eeprom_SetMacAddressToKernel_Apply(void);
extern uchar boot_ac_on;
extern int boot_power_on_mode;
extern BOOT_MODE boot_mode;
extern uchar boot_panel_type;
#if defined(Config_Vulcan3_PCB_TRUE)
extern int EnableFHD;
#endif

extern bool QHB_Boot;
#if defined(CONFIG_EPI_CONVERT_VBY1_TEST) && defined(Config_Board_TV010_PANEL)
extern uchar vby1_aphy16_23_output;
#endif

#define CONFIG_MEMC_BYPASS 1
//#define CONFIG_HW_SUPPORT_MEMC 1

//#define BOARD_RTD286X_PATCH 1

#define DISABLE_SOME_PRINTF
#ifdef DISABLE_SOME_PRINTF
	#define DEBUG_PRINT(fmt,args...)
#else
	#define DEBUG_PRINT(fmt,args...)	 printf(fmt,## args);
#endif

#define PANEL_I2C				3
// wrapper of  register access API
#define rtd_outl(addr, val) _rtd_outl( addr, val)
#define rtd_inl(addr) _rtd_inl(addr)
extern void rtd_part_outl(unsigned int addr, unsigned int B, unsigned int C, unsigned int D);

void panel_enable_turn_on(void);
void panel_enable_turn_off(void);
void panel_customized_setting(void);
void panel_i2c_init(void);

#if 1  // lockn fw mode
void rtk_disp_vby1_init_flow(void);
#endif

#ifdef OPEN_CELL_PANEL
void Panel_Tcon_Init(void);
#endif
#ifdef CONFIG_PANEL_SHARP_60_MEMC
void panel_sharp_memc_init(unsigned char stage);
#endif //#ifdef CONFIG_PANEL_SHARP_60_MEMC

#ifdef CONFIG_PANEL_APPLY_TCON_SETTING
#define PANEL_TCON_SETTING_HEADER_MAGNO_BIN	"BIN"
#define PANEL_TCON_SETTING_HEADER_MAGNO_TXT	"TXT"
#define PANEL_TCON_SETTING_FILE_NAME	FACTORY_HEADER_FILE_NAME"TCON.bin"
#define PANEL_ODC_SETTING_FILE_NAME		FACTORY_HEADER_FILE_NAME"ODC.bin"

extern void panel_apply_tcon_setting(char *filename);
#endif

void panel_misc(void);
void panel_pwm_invert_custom_setting(void);
extern struct _PANEL_CONFIG_PARAMETER  default_panel_parameter;
extern _BOARD_VERSION board_version;

//extern INT32 boot_backlight_value;

#define CONFIG_CPU_XTAL_FREQ 27000000

//UINT32 panel_wait_us_first = 0;
//unsigned char panel_wait_is_wrap = 0;
static unsigned char  panel_init_1st_is_done = 0;
static unsigned char  panel_init_2nd_is_done = 0;

extern UINT16 romcode_boe_rgbw_table_160720[16128];
extern UINT16 romcode_boe_rgbw_table_vivi_160815[16128];
extern UINT16 romcode_boe_rgbw_table_cinema_160815[16128];

extern void panel_set_BOE_RGBW(UINT16 *ptr_tab);
extern void panel_set_MPLUS_RGBW(void);

#ifdef CONFIG_CUSTOM_SN_PANEL
extern int IsID_Match(void);
//extern void setID_Dismatch(int en);
#endif

extern int rtk_plat_run_rescue_from_eMMC(unsigned int blk_no);
#ifdef CONFIG_FSW
extern bool fsw_emmc_bootup;
extern bool fsw_spi_bootup;
#endif
extern int fsw_2k_panel_id;

#define BOOTLOGO_WIDTH 1920
#define BOOTLOGO_HEIGHT 1080
#define BOOTLOGO_HD_WIDTH 1280
#define BOOTLOGO_HD_HEIGHT 720
#define BOOTLOGO_BYTE_PER_PIXEL 3

unsigned char Get_PANEL_TYPE_IS_MILLET3_4K2K_SERIES(void)
{
	if((default_panel_parameter.iCONFIG_PANEL_CUSTOM_INDEX >=  DYNAMIC_OUTPUT_PANEL_SERIES_BEGIN) &&
		   (default_panel_parameter.iCONFIG_PANEL_CUSTOM_INDEX < DYNAMIC_OUTPUT_PANEL_SERIES_MAX))
		   return 1;
	else
		return 0;
}

unsigned char Get_PANEL_TYPE_IS_IWATT_LOCAL_DIMMING(void)
{
	if((default_panel_parameter.iCONFIG_PANEL_TYPE == P_LVDS_2K1K) &&
		((default_panel_parameter.iCONFIG_PANEL_CUSTOM_INDEX == P_IWATT7018_LG_42_SFK1)||
		(default_panel_parameter.iCONFIG_PANEL_CUSTOM_INDEX == P_IWATT7018_LG_47_SFK1)))
		   return 1;
	else
		return 0;
}



/**
 * drvif_clock_set_pll
 * Set PLL register.
 *
 * @param <M_Code> { M code}
 * @param <N_Code> { N code}
 * @param <CPC> { charge pump current}
 * @return { none }
 *
 */
void drvif_clock_set_pll(UINT8 M_Code, UINT8 N_Code, UINT8 div, UINT8 CPC)
{
	pll27x_reg_sys_pll_disp1_RBUS pll_disp1_reg;
	pll27x_reg_sys_pll_disp2_RBUS pll_disp2_reg;
	pll27x_reg_sys_pll_disp3_RBUS pll_disp3_reg;
	//crt_sys_dclkss_RBUS dclkss_reg;
	//unsigned int offset;
	//Modify by tyan
	if(div == 1)
		div = 0;
	else if(div == 2)
		div = 1;
	else if(div == 4)
		div = 2;
	else if(div == 8)
		div = 3;
#if 0
	dclkss_reg.regValue = rtd_inl(CRT_SYS_DCLKSS_reg);
	offset = dclkss_reg.dclk_offset_11_0;
	dclkss_reg.dclk_offset_11_0 = 0;
	dclkss_reg.dclk_ss_en = 0;
	dclkss_reg.dclk_ss_load = 1;
	rtd_outl(CRT_SYS_DCLKSS_reg, dclkss_reg.regValue);
#endif
	//rtd_maskl(PLL27X_REG_SYS_PLL_DISP2_reg, ~(_BIT17) , _BIT17);

	pll_disp2_reg.regValue = rtd_inl(PLL27X_REG_SYS_PLL_DISP2_reg);
	pll_disp2_reg.dpll_x_bpsin = 0;
	pll_disp2_reg.dpll_x_bpspi= 0;
	rtd_outl(PLL27X_REG_SYS_PLL_DISP2_reg, pll_disp2_reg.regValue);

	mdelay(1);

	pll_disp3_reg.regValue =  rtd_inl(PLL27X_REG_SYS_PLL_DISP3_reg);
	pll_disp1_reg.regValue = 0;
	pll_disp1_reg.dpll_m = M_Code - 3;
	pll_disp3_reg.dpll_o = div;
	pll_disp1_reg.dpll_n= N_Code - 2;
#if 0	//fix it later
	pll_disp1_reg.dpll_ip= CPC;
#else
	pll_disp1_reg.dpll_ip = 5;
	//pll_disp1_reg.dpll_cs = 2;
	pll_disp1_reg.dpll_cp = 0;
	pll_disp1_reg.dpll_rs = 6;
	//pll_disp1_reg.dpll_ssc_inv = 1;
	pll_disp1_reg.dpll_ssc_inv = 0;
#endif
	rtd_outl(PLL27X_REG_SYS_PLL_DISP1_reg, pll_disp1_reg.regValue);
	rtd_outl(PLL27X_REG_SYS_PLL_DISP3_reg, pll_disp3_reg.regValue);
	mdelay(1);

	pll_disp3_reg.regValue = rtd_inl(PLL27X_REG_SYS_PLL_DISP3_reg);
//	pll_disp3_reg.pif_dpll_src_sel = 1;
	//pll_disp3_reg.dpll_ldosel = 1;
	pll_disp3_reg.dpll_reser = 1;
	pll_disp3_reg.dpll_dummy = 1;
	//pll_disp3_reg.dpll_prescaler = 1;
	pll_disp3_reg.dpll_rstb = 1;
	pll_disp3_reg.dpll_freeze = 0;
	//pll_disp3_reg.dpll_vcorstb = 1;
	pll_disp3_reg.dpll_pow= 1;
	rtd_outl(PLL27X_REG_SYS_PLL_DISP3_reg, pll_disp3_reg.regValue);

	//rtd_maskl(SYSTEM_SYS_DCLKSS_VADDR, 0xff, _BIT31 | _BIT2|_BIT0);
}

unsigned char drvif_clock_cal_cpc(unsigned int M_Code,unsigned int N_Code) // CPC : charge pump current
{
	unsigned int ucTemp1;
	unsigned int  ucTemp2 = 0;
	//sys_pll_disp2_RBUS pll_disp1_reg;

	//Modify by tyan start 20070701  but not test yet
	if( N_Code <= 5){
		//LPF_Mode = 0, suppose  iM / Ich = 1.673
		ucTemp1 = ((unsigned int) M_Code  *10000/ 1673);
	/*	pll_disp1_reg.regValue = IoReg_Read32(SYSTEM_SYS_PLL_DISP2_VADDR);
		pll_disp1_reg.dplllpfmode = 0;
		IoReg_Write32(SYSTEM_SYS_PLL_DISP2_VADDR, pll_disp1_reg.regValue);*/
	}
	else{
		//16>=N_Code>5
		//LPF_Mode = 1, suppose iM / Ich =17.6
		ucTemp1 = ( (unsigned int)M_Code *10000 / 17600);
		/*pll_disp1_reg.regValue = IoReg_Read32(SYSTEM_SYS_PLL_DISP2_VADDR);
		pll_disp1_reg.dplllpfmode = 1;
		IoReg_Write32(SYSTEM_SYS_PLL_DISP2_VADDR, pll_disp1_reg.regValue);*/
	}

	//ROSPrintf("\n Ich *10= %x",ucTemp1);

	//DPLL_CRNT[4:0] = DPLLSI[4:0]
	//I=(2.5uA+2.5uA*bit[0]+5uA*bit[1]+10uA*bit[2]+20uA*bit[3]+30uA*bit[4]) ,
	//Ip=I*[(bit[5]+1) / 2]Keep Icp/DPM constant

	ucTemp1=ucTemp1-25;

	if (ucTemp1 > 300) {
		ucTemp1 -= 300;
		ucTemp2 += 16;
	}

	if (ucTemp1 > 200) {
		ucTemp1 -= 200;
		ucTemp2 += 8;
	}

	if (ucTemp1 > 100) {
		ucTemp1 -= 100;
		ucTemp2 |= 4;
	}

	if (ucTemp1 > 50) {
		ucTemp1 -= 50;
		ucTemp2 += 2;
	}

	if (ucTemp1 > 25) {
		ucTemp1 -= 25;
		ucTemp2 += 1;
	}

	ucTemp2 += 32;

	return ucTemp2;
}


void drvif_clock_offset(unsigned short usDclkOffset)
{
	pll27x_reg_pll_ssc0_RBUS pll_ssc0_reg;

	pll_ssc0_reg.regValue = rtd_inl(PLL27X_REG_PLL_SSC0_reg);
	pll_ssc0_reg.fcode_t_ssc= usDclkOffset;
	rtd_outl(PLL27X_REG_PLL_SSC0_reg, pll_ssc0_reg.regValue);
}





/*============================================================================*/
/**
 * drvif_clock_set_dclk
 * This function is used to set display clock.
 *
 * @param	<niHFreq>		{ IHFreq }
 * @param	<niVActLen>		{ input length (IVActLen for normal case; IVTotal for FRC ATV and JPEG RPTG) }
 * @param	<default_freq>	{ default frequency (Its priority is highest. Set 0 to calculate dclk.) }
 * @return					{ 0) FRC, 1) framesync }
 */
unsigned char drvif_clock_set_dclk(unsigned int ulFreq)
{
	unsigned char  cpc,div=1, ret=0;
	//unsigned char cnt=0;
	unsigned short nMCode,nNCode, f_code;
	unsigned int nDPLL=0,temp=0;  // V1 clockworks warning - fix ID 724]
	//unsigned int nStep;
	UINT32 dclk_Temp;
	pll27x_reg_pll_ssc0_RBUS crt_pll_ssc0_reg;
	//pll27x_reg_pll_ssc5_RBUS crt_pll_ssc5_reg;

	printf("##### drvif_clock_set_dclk : %d ###########\n", ulFreq);



	if((ulFreq>=400*1000000) && (ulFreq <= 700*1000000)){
		div = 1;
	}else if((ulFreq>=200*1000000) && (ulFreq <= 350*1000000)){
		div = 2;
		ulFreq = ulFreq*2;
	}else if((ulFreq>=100*1000000) && (ulFreq <= 175*1000000)){
		div = 4;
		ulFreq = ulFreq*4;
	}else if((ulFreq>=60*1000000) && (ulFreq <= 80*1000000)){
		div = 8;
		ulFreq = ulFreq*8;
	}else{
		printf("\n Error Dclk Range!\n");
	}

	printf("\n After Mapping (ulFreq:%d) (div:%d)======\n", ulFreq, div);

	nNCode = 3;
	dclk_Temp = ((ulFreq*nNCode) /(27*100));
	printf("dclk_Temp:%d\n", dclk_Temp);
	nMCode = dclk_Temp/10000;
	f_code = ((dclk_Temp % 10000)*2048)/10000;  // offset
	printf("nMCode:%d, f_code:%d\n", nMCode, f_code);
	cpc = drvif_clock_cal_cpc(nMCode,nNCode);

	crt_pll_ssc0_reg.regValue= rtd_inl(PLL27X_REG_PLL_SSC0_reg);
	crt_pll_ssc0_reg.oc_en = 0;
	crt_pll_ssc0_reg.fcode_t_ssc = 0;
	crt_pll_ssc0_reg.oc_step_set = 0x200;
	rtd_outl(PLL27X_REG_PLL_SSC0_reg, crt_pll_ssc0_reg.regValue);

	drvif_clock_set_pll(nMCode, nNCode, div, cpc);

	//Enable DDS spread spectrum output function
	drvif_clock_offset(f_code);

	crt_pll_ssc0_reg.regValue= rtd_inl(PLL27X_REG_PLL_SSC0_reg);
	crt_pll_ssc0_reg.oc_en = 1;
	rtd_outl(PLL27X_REG_PLL_SSC0_reg, crt_pll_ssc0_reg.regValue);

/*
	cnt=100;
	do{
		mdelay(1);
		crt_pll_ssc5_reg.regValue = rtd_inl(PLL27X_REG_PLL_SSC5_reg);
	}while((crt_pll_ssc5_reg.oc_done != 1) && (cnt--));
*/
	mdelay(1);
	crt_pll_ssc0_reg.oc_en = 0;
	rtd_outl(PLL27X_REG_PLL_SSC0_reg, crt_pll_ssc0_reg.regValue);

	printf("Panel: ulFreq:%d, nDPLL:%d, Mcode:%d, Ncode:%d, offset:%x\n", ulFreq, nDPLL, nMCode, nNCode, temp);

	return ret;
}

unsigned char drvif_clock_set_dtg_uzu_div(void)
{
	sys_reg_sys_dispclksel_RBUS sys_dispclksel_reg;
	UINT32 dclk_fract_a, dclk_fract_b;

	dclk_fract_a = 0;
	dclk_fract_b = 0;
	sys_dispclksel_reg.regValue = rtd_inl(SYS_REG_SYS_DISPCLKSEL_reg);
	sys_dispclksel_reg.dclk_fract_a = dclk_fract_a;
	sys_dispclksel_reg.dclk_fract_b = (dclk_fract_b&0x1f);
//	sys_dispclksel_reg.dclk_fract_b_eco = (dclk_fract_b&_BIT5)?1:0; fix compile error for 289x
	rtd_outl(SYS_REG_SYS_DISPCLKSEL_reg, sys_dispclksel_reg.regValue);

	printf("\n #### 0xb8000208[%x]\n", sys_dispclksel_reg.regValue);
	printf("\n #### [%s]\n", __FUNCTION__);
	return 0;
}


unsigned char drvif_clock_set_dtg_memc_div(void)
{
	sys_reg_sys_dispclksel_RBUS sys_dispclksel_reg;
	sys_dispclksel_reg.regValue = rtd_inl(SYS_REG_SYS_DISPCLKSEL_reg);
	#if 0
	sys_dispclksel_reg.memc_me_div = 1;

	if(default_panel_parameter.iCONFIG_DISPLAY_REFRESH_RATE == 120)
		sys_dispclksel_reg.dispd_memc_out_sel = 1;
	else
		sys_dispclksel_reg.dispd_memc_out_sel = 0;
	#endif

	rtd_outl(SYS_REG_SYS_DISPCLKSEL_reg, sys_dispclksel_reg.regValue);
	printf("\n #### 0xb8000208[%x]\n", sys_dispclksel_reg.regValue);
	printf("\n #### [%s]\n", __FUNCTION__);
	return 0;
}


void panel_sfg_config(struct _PANEL_CONFIG_PARAMETER *panel)
{
	if((panel->iCONFIG_PANEL_TYPE == P_EPI_TYPE)/*||(panel->iCONFIG_PANEL_TYPE == P_MINI_LVDS)*/){
		printf("EPI/MLVDS panel doesn't set SFG\n");
		return;
	}

	  //---------- SFG ------------------------------------------------------------------
	sfg_sfg_zz_shift_dbg_ctrl_RBUS sfg_zz_shift_dbg_ctrl_reg;
	sfg_sfg_swap_ctrl0_RBUS sfg_swap_ctrl0_reg;
/*
	sfg_sfg_swap_ctrl1_RBUS sfg_swap_ctrl1_reg;
	sfg_sfg_swap_ctrl2_RBUS sfg_swap_ctrl2_reg;
	sfg_sfg_swap_ctrl3_RBUS sfg_swap_ctrl3_reg;
	sfg_sfg_swap_ctrl4_RBUS sfg_swap_ctrl4_reg;
*/
	int i=0;

//	sfg_swap_ctrl2_reg.regValue = 0;

	sfg_zz_shift_dbg_ctrl_reg.regValue = rtd_inl(SFG_SFG_ZZ_shift_dbg_CTRL_reg);
	sfg_zz_shift_dbg_ctrl_reg.lclk_inv_sel = 1;
	if((panel->iCONFIG_PANEL_TYPE == P_VBY1_4K2K) ||
		(panel->iCONFIG_PANEL_TYPE == P_VBY1_TO_LVDS) ||
		(panel->iCONFIG_PANEL_TYPE == P_VBY1_TO_HDMI) ||
		(panel->iCONFIG_PANEL_TYPE == P_VBY1_TO_LVDS_TO_HDMI) ||
		(panel->iCONFIG_PANEL_TYPE == P_VBY1_TO_LVDS_2K)){
		sfg_zz_shift_dbg_ctrl_reg.pif_clk_sel = 1;
	}
	sfg_zz_shift_dbg_ctrl_reg.dout_mode = panel->iCONFIG_DISPLAY_COLOR_BITS;
	sfg_zz_shift_dbg_ctrl_reg.sfg_dout_en  = 1;
	sfg_zz_shift_dbg_ctrl_reg.dvs_inv = (panel->iCONFIG_DISPLAY_VERTICAL_SYNC_NORMAL? 0:1);
	sfg_zz_shift_dbg_ctrl_reg.dhs_inv = (panel->iCONFIG_DISPLAY_VERTICAL_SYNC_NORMAL? 0:1);
	sfg_zz_shift_dbg_ctrl_reg.dden_inv = 0;
	if(panel->iCONFIG_PANEL_TYPE == P_MINI_LVDS)
		sfg_zz_shift_dbg_ctrl_reg.daclk_inv = 0;
	else
		sfg_zz_shift_dbg_ctrl_reg.daclk_inv = 1;
	sfg_zz_shift_dbg_ctrl_reg.daclk_en = 1;
	sfg_zz_shift_dbg_ctrl_reg.dout_rb_swap = panel->iCONFIG_DISPLAY_RED_BLUE_SWAP;
	sfg_zz_shift_dbg_ctrl_reg.dout_bit_swap =  panel->iCONFIG_DISPLAY_MSB_LSB_SWAP;
	sfg_zz_shift_dbg_ctrl_reg.dout_data_inv = panel->iCONFIG_DISPLAY_OUTPUT_INVERSE;
	sfg_zz_shift_dbg_ctrl_reg.dclk_dly_sel = panel->iCONFIG_DISP_DCLK_DELAY;
	rtd_outl(SFG_SFG_ZZ_shift_dbg_CTRL_reg, sfg_zz_shift_dbg_ctrl_reg.regValue);
	sfg_swap_ctrl0_reg.regValue = rtd_inl(SFG_SFG_SWAP_CTRL0_reg);
	sfg_swap_ctrl0_reg.dclk_mode_switch = panel->iCONFIG_DISPLAY_PORT;
	//Force to background enable
	sfg_swap_ctrl0_reg.force_bg_dif_aport = 1;
	sfg_swap_ctrl0_reg.force_bg_dif_bport = 1;
	sfg_swap_ctrl0_reg.force_bg_dif_cport = 1;
	sfg_swap_ctrl0_reg.force_bg_dif_dport = 1;
	sfg_swap_ctrl0_reg.force_bg_dif_eport = 1;
	sfg_swap_ctrl0_reg.force_bg_dif_fport = 1;
	sfg_swap_ctrl0_reg.force_bg_dif_gport = 1;
	sfg_swap_ctrl0_reg.force_bg_dif_hport = 1;
	sfg_swap_ctrl0_reg.force_bg_dif_iport = 1;
	sfg_swap_ctrl0_reg.force_bg_dif_jport = 1;
	sfg_swap_ctrl0_reg.force_bg_dif_kport = 1;
	sfg_swap_ctrl0_reg.force_bg_dif_lport = 1;
//	sfg_swap_ctrl0_reg.force_bg_dif_mport = 1;
//	sfg_swap_ctrl0_reg.force_bg_dif_nport = 1;
//	sfg_swap_ctrl0_reg.force_bg_dif_oport = 1;
//	sfg_swap_ctrl0_reg.force_bg_dif_pport = 1;
	rtd_outl(SFG_SFG_SWAP_CTRL0_reg, sfg_swap_ctrl0_reg.regValue);

	sfg_sfg_ctrl_0_RBUS    sfg_ctrl_0_reg;
	sfg_sfg_ctrl_9_RBUS    sfg_ctrl_9_reg;
	sfg_sfg_ctrl_8_RBUS    sfg_ctrl_8_reg;
	sfg_sfg_ctrl_7_RBUS    sfg_ctrl_7_reg;
	sfg_sfg_ctrl_6_RBUS    sfg_ctrl_6_reg;
	sfg_sfg_ctrl_5_RBUS	   sfg_ctrl_5_reg;
	sfg_sfg_ctrl_1_RBUS    sfg_ctrl_1_reg;
	sfg_sfg_ctrl_a_RBUS    sfg_ctrl_a_reg;
	sfg_sfg_ctrl_b_RBUS	   sfg_ctrl_b_reg;
	sfg_sfg_ctrl_c_RBUS    sfg_ctrl_c_reg;

	unsigned int m_seg_width = 0;
	unsigned char temp = 0;

	sfg_ctrl_0_reg.regValue = rtd_inl(SFG_SFG_CTRL_0_reg);

	//if(panel->iCONFIG_PANEL_TYPE == P_VBY1_4K2K){
	if(panel->iCONFIG_SFG_SEG_NUM != 0){

		m_seg_width = (panel->iCONFIG_DISP_ACT_END_HPOS-panel->iCONFIG_DISP_ACT_STA_HPOS)/(panel->iCONFIG_SFG_SEG_NUM);

		if(panel->iCONFIG_SFG_SEG_NUM == 1){
			sfg_ctrl_1_reg.regValue = 0;
		}
		else{
			sfg_ctrl_1_reg.seg0_start = 0;
			sfg_ctrl_1_reg.seg1_start = m_seg_width;
		}
		rtd_outl(SFG_SFG_CTRL_1_reg, sfg_ctrl_1_reg.regValue);

		for(i=1; i<(panel->iCONFIG_SFG_SEG_NUM)/2; i++){

			sfg_ctrl_1_reg.seg0_start = sfg_ctrl_1_reg.seg1_start + m_seg_width;
			sfg_ctrl_1_reg.seg1_start = sfg_ctrl_1_reg.seg0_start + m_seg_width;

			rtd_outl(SFG_SFG_CTRL_1_reg+4*i, sfg_ctrl_1_reg.regValue);
		}

		for(i=(panel->iCONFIG_SFG_SEG_NUM)/2 ; i<8; i++){
			rtd_outl(SFG_SFG_CTRL_1_reg+4*i, 0);
		}

		sfg_ctrl_0_reg.seg_num = panel->iCONFIG_SFG_SEG_NUM-1;

		if(panel->iCONFIG_SFG_PORT_NUM != 0)
			sfg_ctrl_0_reg.port_num = panel->iCONFIG_SFG_PORT_NUM-1;
		else{
			if(panel->iCONFIG_DISPLAY_PORT == 2){	// port 4
				sfg_ctrl_0_reg.port_num = 3;
			}else{ //port 1,2
				sfg_ctrl_0_reg.port_num = panel->iCONFIG_DISPLAY_PORT;
			}
		}

	}
	else{	//traditional lvds panel setting
		if(panel->iCONFIG_DISPLAY_PORT == 2){	// port 4
			sfg_ctrl_0_reg.port_num = 3;
		}else{ //port 1,2
			sfg_ctrl_0_reg.port_num = panel->iCONFIG_DISPLAY_PORT;
		}
		sfg_ctrl_0_reg.seg_num = 0;
		rtd_outl(SFG_SFG_CTRL_1_reg, 0);
		rtd_outl(SFG_SFG_CTRL_2_reg, 0);
		rtd_outl(SFG_SFG_CTRL_3_reg, 0);
		rtd_outl(SFG_SFG_CTRL_4_reg, 0);
	}

	if(panel->iCONFIG_PANEL_TYPE == P_VBY1_TO_LVDS)
		sfg_ctrl_0_reg.data_shift_en = 1;
	else
		sfg_ctrl_0_reg.data_shift_en = 0;

	rtd_outl(SFG_SFG_CTRL_0_reg, sfg_ctrl_0_reg.regValue);

	printf("###### SFG_SFG_CTRL_0_reg : %x ########\n", sfg_ctrl_0_reg.regValue);

	sfg_ctrl_6_reg.regValue = 0;
	if((panel->iCONFIG_PANEL_TYPE == P_VBY1_TO_LVDS) ||
		(default_panel_parameter.iCONFIG_PANEL_TYPE == P_VBY1_TO_LVDS_TO_HDMI)){
		sfg_ctrl_6_reg.downsample_v=1; //vertical down sample( 4K2K=>4K1K) , data hold period*2
	}
	sfg_ctrl_6_reg.tg_auto_cfg = 1;
	rtd_outl(SFG_SFG_CTRL_6_reg, sfg_ctrl_6_reg.regValue);//Disable ByPass Mode

	sfg_ctrl_7_reg.regValue = rtd_inl(SFG_SFG_CTRL_7_reg);
	sfg_ctrl_7_reg.hsync_width = panel->iCONFIG_DISP_HSYNC_WIDTH;//HS_Width = 16 dclk = 16*Pixel_Mode*n DH_Width (����4����, n������?
	sfg_ctrl_7_reg.hsync_delay = panel->iCONFIG_DISP_HORIZONTAL_TOTAL -13;
	rtd_outl(SFG_SFG_CTRL_7_reg, sfg_ctrl_7_reg.regValue);


	sfg_ctrl_8_reg.regValue = rtd_inl(SFG_SFG_CTRL_8_reg);
	sfg_ctrl_8_reg.vsync_start = 0;
	sfg_ctrl_8_reg.vsync_end = panel->iCONFIG_DISP_VSYNC_LENGTH;
	rtd_outl(SFG_SFG_CTRL_8_reg, sfg_ctrl_8_reg.regValue);

	sfg_ctrl_9_reg.regValue = rtd_inl(SFG_SFG_CTRL_9_reg);
	sfg_ctrl_9_reg.sfg_dh_den_sta = panel->iCONFIG_DISP_DEN_STA_HPOS;
	sfg_ctrl_9_reg.req_start = panel->iCONFIG_DISP_DEN_STA_HPOS-6;
	rtd_outl(SFG_SFG_CTRL_9_reg, sfg_ctrl_9_reg.regValue);

	sfg_ctrl_5_reg.regValue = rtd_inl(SFG_SFG_CTRL_5_reg);
//	sfg_ctrl_5_reg.hs_distance = 0;
	sfg_ctrl_5_reg.seg0_flip= 0;
	rtd_outl(SFG_SFG_CTRL_5_reg, sfg_ctrl_5_reg.regValue);

	sfg_ctrl_a_reg.regValue = rtd_inl(SFG_SFG_CTRL_A_reg);
	sfg_ctrl_a_reg.final_line_length = (panel->iCONFIG_DISP_ACT_END_HPOS-panel->iCONFIG_DISP_ACT_STA_HPOS);
	if ((panel->iCONFIG_PANEL_TYPE == P_VBY1_TO_LVDS)  ||
		(default_panel_parameter.iCONFIG_PANEL_TYPE == P_VBY1_TO_LVDS_TO_HDMI)) {
		sfg_ctrl_a_reg.final_line_length *= 2; //vertical down sample( 4K2K=>4K1K) , data hold period*2
	}else{
		sfg_ctrl_a_reg.final_line_length /=  (panel->iCONFIG_SR_PIXEL_MODE+1);
	}
	rtd_outl(SFG_SFG_CTRL_A_reg, sfg_ctrl_a_reg.regValue);

	sfg_ctrl_b_reg.regValue = 0;
	sfg_ctrl_b_reg.final_addr_split_mode = ((panel->iCONFIG_DISP_ACT_END_HPOS-panel->iCONFIG_DISP_ACT_STA_HPOS)/3)*3-1;
	temp = (panel->iCONFIG_DISP_ACT_END_HPOS-panel->iCONFIG_DISP_ACT_STA_HPOS)%3;
	sfg_ctrl_b_reg.residue_pix_split_mode = (temp == 0)?2:(temp-1);
	rtd_outl(SFG_SFG_CTRL_B_reg, sfg_ctrl_b_reg.regValue);

	if(panel->iCONFIG_PANEL_TYPE == P_EPI_TYPE){
		sfg_ctrl_c_reg.hs_den_io_dist = sfg_ctrl_9_reg.req_start + 6;
		sfg_ctrl_c_reg.hs_io_dist = sfg_ctrl_7_reg.hsync_delay + 6;
	}else{
		sfg_ctrl_c_reg.regValue = 0;
	}
	rtd_outl(SFG_SFG_CTRL_C_reg, sfg_ctrl_c_reg.regValue);

	//sfg_sfg_dummy_RBUS sfg_sfg_dummy_reg;
	//vby1_video_format_RBUS vby1_video_format_reg;

#if 0 //move to SFG
	//analog/digital interface control sequence.
	if( (panel->iCONFIG_PANEL_TYPE == P_VBY1_4K2K)    ||
		(panel->iCONFIG_PANEL_TYPE == P_VBY1_TO_HDMI) ||
		(panel->iCONFIG_PANEL_TYPE == P_VBY1_TO_HDMI_MEMC_FREERUN) ||
		(panel->iCONFIG_PANEL_TYPE == P_EPI_TYPE))
	{
		vby1_video_format_reg.regValue = rtd_inl(VBY1_VIDEO_FORMAT_reg);
		vby1_video_format_reg.lclk_inv_sel = 1;
		rtd_outl(VBY1_VIDEO_FORMAT_reg, vby1_video_format_reg.regValue);
	}
	printf("###### 0xB802D700 : %x ########\n", rtd_inl(VBY1_VIDEO_FORMAT_reg));
#endif

#if 0 //move to power on init flow
	sfg_sfg_dummy_reg.regValue = rtd_inl(SFG_SFG_DUMMY_reg);
	if((panel->iCONFIG_PANEL_TYPE == P_VBY1_4K2K) ||
		(panel->iCONFIG_PANEL_TYPE == P_VBY1_TO_HDMI_MEMC_FREERUN) ||
		(panel->iCONFIG_PANEL_TYPE == P_VBY1_TO_HDMI)){
		//sfg_sfg_dummy_reg.dummy_2= 0x1000;	// clken for vby1
		sfg_sfg_dummy_reg.clken_vby1= 1;	// clken for vby1 clk gating
	}else if(panel->iCONFIG_PANEL_TYPE == P_EPI_TYPE){
		sfg_sfg_dummy_reg.clken_epi = 1;	// clken for epi
	}else{
		sfg_sfg_dummy_reg.clken_lvds= 1; // clken for lvds
	}
	rtd_outl(SFG_SFG_DUMMY_reg, sfg_sfg_dummy_reg.regValue);
	printf("###### 1. 0xB802D9B8 : %x ########\n", sfg_ctrl_0_reg.regValue);
#endif
	rtd_outl(SFG_SFG_MID_DUMMY_0_reg, 0);
	rtd_outl(SFG_SFG_MID_DUMMY_1_reg, 0);
	rtd_outl(SFG_SFG_MID_DUMMY_2_reg, 0);
	rtd_outl(SFG_SFG_MID_DUMMY_3_reg, 0);

//	sfg_sfg_data_after_den_RBUS sfg_sfg_data_after_den_reg;
//	sfg_sfg_data_after_den_reg.regValue = rtd_inl(SFG_SFG_data_after_den_reg);
//	sfg_sfg_data_after_den_reg.active_pixel_rgb = (panel->iCONFIG_DISP_ACT_END_HPOS-panel->iCONFIG_DISP_ACT_STA_HPOS);
//	rtd_outl(SFG_SFG_data_after_den_reg, sfg_sfg_data_after_den_reg.regValue);

}

unsigned int Get_DISPLAY_PANEL_MPLUS_RGBW(void)
{
	if((default_panel_parameter.iCONFIG_PANEL_TYPE == P_EPI_TYPE) ||
		(default_panel_parameter.iCONFIG_PANEL_TYPE == P_CEDS) ||
		(default_panel_parameter.iCONFIG_PANEL_TYPE == P_CHPI)) {
		if((default_panel_parameter.iCONFIG_PANEL_CUSTOM_INDEX >= P_EPI_LG_MPLUS_RGBW_PANEL_BEGIN) &&
			(default_panel_parameter.iCONFIG_PANEL_CUSTOM_INDEX <= P_EPI_LG_MPLUS_RGBW_PANEL_MAX) ){
			return true;
		}else if((default_panel_parameter.iCONFIG_PANEL_CUSTOM_INDEX >= P_CEDS_PANEL_BEGIN) &&
				(default_panel_parameter.iCONFIG_PANEL_CUSTOM_INDEX <= P_CEDS_PANEL_MAX) ){
			return true;
		} else if ((default_panel_parameter.iCONFIG_PANEL_CUSTOM_INDEX >= P_CHPI_BEGIN) &&
				(default_panel_parameter.iCONFIG_PANEL_CUSTOM_INDEX <= P_CHPI_PANEL_MAX)) {
			return true;
		} else {
			return false;
		}
	} else
		return false;
}

unsigned int Get_DISPLAY_PANEL_BOW_RGBW(void)
{
	if(default_panel_parameter.iCONFIG_PANEL_TYPE == P_EPI_TYPE){
		if((default_panel_parameter.iCONFIG_PANEL_CUSTOM_INDEX >= P_CEDS_LG_BOE_RGBW_PANEL_BEGIN) &&
			(default_panel_parameter.iCONFIG_PANEL_CUSTOM_INDEX <= P_CEDS_LG_BOE_RGBW_PANEL_MAX) ){
			return true;
	} else {
			return false;
		}
	} else
		return false;
}

void panel_rgbw_setting(void)
{
	if((default_panel_parameter.iCONFIG_PANEL_TYPE != P_EPI_TYPE)&&
		(default_panel_parameter.iCONFIG_PANEL_TYPE != P_CEDS) &&
		(default_panel_parameter.iCONFIG_PANEL_TYPE != P_CHPI))
		return;

	if(Get_DISPLAY_PANEL_BOW_RGBW() == true){
		printf("panel_set_BOE_RGBW\n");
// FIX ME - panel_rgbw.c not define romcode_boe_rgbw_table_vivi_160815
//		panel_set_BOE_RGBW(romcode_boe_rgbw_table_vivi_160815);
	}else if(Get_DISPLAY_PANEL_MPLUS_RGBW() == true){
		printf("panel_set_MPLUS_RGBW\n");
		panel_set_MPLUS_RGBW();
	}
	else{
		printf("not rgbw panel. \n");
	}

}

void panel_interface_pinmux_setting(void)
{
// FIX ME
#if 0
	gpio_cfg_1_RBUS pinmux_main_gpio_cfg_1_reg;
	gpio_cfg_4_RBUS pinmux_main_gpio_cfg_4_reg;
	pin_mux_ctrl2_RBUS pin_mux_ctrl2_reg;
	pin_mux_tpsel_RBUS pin_mux_tpsel_reg;

	pinmux_main_gpio_cfg_1_reg.regValue = rtd_inl(PINMUX_MAIN_GPIO_CFG_1_reg);
	pinmux_main_gpio_cfg_4_reg.regValue = rtd_inl(PINMUX_MAIN_GPIO_CFG_4_reg);
	pin_mux_ctrl2_reg.regValue = rtd_inl(PINMUX_MAIN_Pin_Mux_Ctrl2_reg);
	pin_mux_tpsel_reg.regValue = rtd_inl(PINMUX_MAIN_Pin_Mux_TPSEL_reg);

	if(default_panel_parameter.iCONFIG_PANEL_TYPE == P_EPI_TYPE){
		pinmux_main_gpio_cfg_1_reg.gpio_4_ps = 0x7;
		pinmux_main_gpio_cfg_1_reg.gpio_5_ps = 0x5;
		pinmux_main_gpio_cfg_1_reg.gpio_6_ps = 0x4;
		pinmux_main_gpio_cfg_1_reg.gpio_7_ps = 0x6; //6: EPI_LOCK_src0,<I>

		pinmux_main_gpio_cfg_4_reg.gpio_16_ps = 1;

		pin_mux_ctrl2_reg.phif_enable = 1;
	}else if((default_panel_parameter.iCONFIG_PANEL_TYPE == P_VBY1_4K2K)||
				(default_panel_parameter.iCONFIG_PANEL_TYPE == P_VBY1_TO_HDMI)){

		//pinmux_main_gpio_cfg_1_reg.gpio_4_ps = 0xf;
		//pinmux_main_gpio_cfg_1_reg.gpio_5_ps = 0xf;
		pinmux_main_gpio_cfg_1_reg.gpio_6_ps = 0x3;
		pinmux_main_gpio_cfg_1_reg.gpio_7_ps = 0x3;

		pinmux_main_gpio_cfg_4_reg.gpio_16_ps = 0;
		pinmux_main_gpio_cfg_4_reg.gpio_17_ps = 0;

		pin_mux_tpsel_reg.tp2_mux_selection = 4;
		pin_mux_tpsel_reg.tp3_mux_selection = 0;

	}
	rtd_outl(PINMUX_MAIN_GPIO_CFG_1_reg, pinmux_main_gpio_cfg_1_reg.regValue);
	rtd_outl(PINMUX_MAIN_GPIO_CFG_4_reg, pinmux_main_gpio_cfg_4_reg.regValue);
	rtd_outl(PINMUX_MAIN_Pin_Mux_Ctrl2_reg, pin_mux_ctrl2_reg.regValue);
	rtd_outl(PINMUX_MAIN_Pin_Mux_TPSEL_reg, pin_mux_tpsel_reg.regValue);
#endif
}

void panel_enable_turn_on(void)
{
	rtd_setbits(0xb801BD00,_BIT3);
	rtd_setbits(0xb801BD18,_BIT3);
}

void panel_enable_turn_off(void)
{
	rtd_clearbits(0xb801BD00,_BIT3);
	rtd_clearbits(0xb801BD18,_BIT3);
}

#if 1
unsigned int p0_lane_power_value;
unsigned int p1_lane_power_value;
unsigned int p2_lane_power_value;
unsigned int p3_lane_power_value;
// FIX ME - PINMUX_LVDSPHY_VBY1EPI_90_reg not defined
void vbe_disp_lane_power_off(void)
{
	pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_1_RBUS  pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_1_reg;
	pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_5_RBUS  pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_5_reg;
	pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_9_RBUS  pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_9_reg;
	pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_13_RBUS pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_13_reg;
	pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_17_RBUS pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_17_reg;
	pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_21_RBUS pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_21_reg;
	pinmux_lvdsphy_lvdsepivby1_phy_ctrl_0_25_RBUS pinmux_lvdsphy_lvdsepivby1_phy_ctrl_0_25_reg;
	pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_29_RBUS pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_29_reg;
	pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_33_RBUS pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_33_reg;
	pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_37_RBUS pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_37_reg;
	pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_41_RBUS pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_41_reg;
	pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_45_RBUS pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_45_reg;
	//pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_49_RBUS pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_49_reg;
//	pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_53_RBUS pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_53_reg;

	pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_1_reg.regValue  = rtd_inl(PINMUX_LVDSPHY_LVDSEPIVBY1_PHY_CTRL_1_1_reg);
	pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_5_reg.regValue  = rtd_inl(PINMUX_LVDSPHY_LVDSEPIVBY1_PHY_CTRL_1_5_reg);
	pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_9_reg.regValue  = rtd_inl(PINMUX_LVDSPHY_LVDSEPIVBY1_PHY_CTRL_1_9_reg);
	pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_13_reg.regValue = rtd_inl(PINMUX_LVDSPHY_LVDSEPIVBY1_PHY_CTRL_1_13_reg);
	pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_17_reg.regValue = rtd_inl(PINMUX_LVDSPHY_LVDSEPIVBY1_PHY_CTRL_1_17_reg);
	pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_21_reg.regValue = rtd_inl(PINMUX_LVDSPHY_LVDSEPIVBY1_PHY_CTRL_1_21_reg);
	pinmux_lvdsphy_lvdsepivby1_phy_ctrl_0_25_reg.regValue = rtd_inl(PINMUX_LVDSPHY_LVDSEPIVBY1_PHY_CTRL_0_25_reg);
	pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_29_reg.regValue = rtd_inl(PINMUX_LVDSPHY_LVDSEPIVBY1_PHY_CTRL_1_29_reg);
	pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_33_reg.regValue = rtd_inl(PINMUX_LVDSPHY_LVDSEPIVBY1_PHY_CTRL_1_33_reg);
	pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_37_reg.regValue = rtd_inl(PINMUX_LVDSPHY_LVDSEPIVBY1_PHY_CTRL_1_37_reg);
	pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_41_reg.regValue = rtd_inl(PINMUX_LVDSPHY_LVDSEPIVBY1_PHY_CTRL_1_41_reg);
	pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_45_reg.regValue = rtd_inl(PINMUX_LVDSPHY_LVDSEPIVBY1_PHY_CTRL_1_45_reg);
	//pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_49_reg.regValue = rtd_inl(PINMUX_LVDSPHY_LVDSEPIVBY1_PHY_CTRL_1_49_reg);
	//pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_53_reg.regValue = rtd_inl(PINMUX_LVDSPHY_LVDSEPIVBY1_PHY_CTRL_1_53_reg);
#if 0
	pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_1_reg.pif_tx0_pow = 0;
	pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_5_reg.pif_tx1_pow= 0;
	pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_9_reg.pif_tx2_pow= 0;
	pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_13_reg.pif_tx3_pow= 0;
	pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_17_reg.pif_tx4_pow= 0;
	pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_21_reg.pif_tx5_pow= 0;
	pinmux_lvdsphy_lvdsepivby1_phy_ctrl_0_25_reg.pif_tx6_pow= 0;
	pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_29_reg.pif_tx7_pow= 0;
	pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_33_reg.pif_tx8_pow= 0;
	pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_37_reg.pif_tx9_pow= 0;
	pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_41_reg.pif_tx10_pow= 0;
	pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_45_reg.pif_tx11_pow= 0;
	pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_49_reg.pif_tx12_pow= 0;
	pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_53_reg.pif_tx13_pow= 0;
#endif
	rtd_outl(PINMUX_LVDSPHY_LVDSEPIVBY1_PHY_CTRL_1_1_reg,pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_1_reg.regValue);
	rtd_outl(PINMUX_LVDSPHY_LVDSEPIVBY1_PHY_CTRL_1_5_reg,pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_5_reg.regValue);
	rtd_outl(PINMUX_LVDSPHY_LVDSEPIVBY1_PHY_CTRL_1_9_reg,pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_9_reg.regValue);
	rtd_outl(PINMUX_LVDSPHY_LVDSEPIVBY1_PHY_CTRL_1_13_reg,pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_13_reg.regValue);
	rtd_outl(PINMUX_LVDSPHY_LVDSEPIVBY1_PHY_CTRL_1_17_reg,pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_17_reg.regValue);
	rtd_outl(PINMUX_LVDSPHY_LVDSEPIVBY1_PHY_CTRL_1_21_reg,pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_21_reg.regValue);
	rtd_outl(PINMUX_LVDSPHY_LVDSEPIVBY1_PHY_CTRL_0_25_reg,pinmux_lvdsphy_lvdsepivby1_phy_ctrl_0_25_reg.regValue);
	rtd_outl(PINMUX_LVDSPHY_LVDSEPIVBY1_PHY_CTRL_1_29_reg,pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_29_reg.regValue);
	rtd_outl(PINMUX_LVDSPHY_LVDSEPIVBY1_PHY_CTRL_1_33_reg,pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_33_reg.regValue);
	rtd_outl(PINMUX_LVDSPHY_LVDSEPIVBY1_PHY_CTRL_1_37_reg,pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_37_reg.regValue);
	rtd_outl(PINMUX_LVDSPHY_LVDSEPIVBY1_PHY_CTRL_1_41_reg,pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_41_reg.regValue);
	rtd_outl(PINMUX_LVDSPHY_LVDSEPIVBY1_PHY_CTRL_1_45_reg,pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_45_reg.regValue);
	//rtd_outl(PINMUX_LVDSPHY_LVDSEPIVBY1_PHY_CTRL_1_49_reg,pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_49_reg.regValue);
	//rtd_outl(PINMUX_LVDSPHY_LVDSEPIVBY1_PHY_CTRL_1_53_reg,pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_53_reg.regValue);

	printf("[vbe_disp_lane_power_off] turn off disp lane Power\n");
}


void vbe_disp_lane_power_on(void)
{
	pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_1_RBUS  pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_1_reg;
	pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_5_RBUS  pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_5_reg;
	pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_9_RBUS  pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_9_reg;
	pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_13_RBUS pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_13_reg;
	pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_17_RBUS pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_17_reg;
	pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_21_RBUS pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_21_reg;
	pinmux_lvdsphy_lvdsepivby1_phy_ctrl_0_25_RBUS pinmux_lvdsphy_lvdsepivby1_phy_ctrl_0_25_reg;
	pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_29_RBUS pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_29_reg;
	pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_33_RBUS pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_33_reg;
	pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_37_RBUS pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_37_reg;
	pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_41_RBUS pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_41_reg;
	pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_45_RBUS pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_45_reg;
//	pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_49_RBUS pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_49_reg;
//	pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_53_RBUS pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_53_reg;

	pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_1_reg.regValue  = rtd_inl(PINMUX_LVDSPHY_LVDSEPIVBY1_PHY_CTRL_1_1_reg);
	pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_5_reg.regValue  = rtd_inl(PINMUX_LVDSPHY_LVDSEPIVBY1_PHY_CTRL_1_5_reg);
	pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_9_reg.regValue  = rtd_inl(PINMUX_LVDSPHY_LVDSEPIVBY1_PHY_CTRL_1_9_reg);
	pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_13_reg.regValue = rtd_inl(PINMUX_LVDSPHY_LVDSEPIVBY1_PHY_CTRL_1_13_reg);
	pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_17_reg.regValue = rtd_inl(PINMUX_LVDSPHY_LVDSEPIVBY1_PHY_CTRL_1_17_reg);
	pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_21_reg.regValue = rtd_inl(PINMUX_LVDSPHY_LVDSEPIVBY1_PHY_CTRL_1_21_reg);
	pinmux_lvdsphy_lvdsepivby1_phy_ctrl_0_25_reg.regValue = rtd_inl(PINMUX_LVDSPHY_LVDSEPIVBY1_PHY_CTRL_0_25_reg);
	pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_29_reg.regValue = rtd_inl(PINMUX_LVDSPHY_LVDSEPIVBY1_PHY_CTRL_1_29_reg);
	pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_33_reg.regValue = rtd_inl(PINMUX_LVDSPHY_LVDSEPIVBY1_PHY_CTRL_1_33_reg);
	pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_37_reg.regValue = rtd_inl(PINMUX_LVDSPHY_LVDSEPIVBY1_PHY_CTRL_1_37_reg);
	pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_41_reg.regValue = rtd_inl(PINMUX_LVDSPHY_LVDSEPIVBY1_PHY_CTRL_1_41_reg);
	pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_45_reg.regValue = rtd_inl(PINMUX_LVDSPHY_LVDSEPIVBY1_PHY_CTRL_1_45_reg);
//	pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_49_reg.regValue = rtd_inl(PINMUX_LVDSPHY_LVDSEPIVBY1_PHY_CTRL_1_49_reg);
//	pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_53_reg.regValue = rtd_inl(PINMUX_LVDSPHY_LVDSEPIVBY1_PHY_CTRL_1_53_reg);
#if 0
	pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_1_reg.pif_tx0_pow = 1;
	pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_5_reg.pif_tx1_pow= 1;
	pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_9_reg.pif_tx2_pow= 1;
	pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_13_reg.pif_tx3_pow= 1;
	pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_17_reg.pif_tx4_pow= 1;
	pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_21_reg.pif_tx5_pow= 1;
	pinmux_lvdsphy_lvdsepivby1_phy_ctrl_0_25_reg.pif_tx6_pow= 1;
	pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_29_reg.pif_tx7_pow= 1;
	pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_33_reg.pif_tx8_pow= 1;
	pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_37_reg.pif_tx9_pow= 1;
	pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_41_reg.pif_tx10_pow= 1;
	pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_45_reg.pif_tx11_pow= 1;
	pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_49_reg.pif_tx12_pow= 1;
	pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_53_reg.pif_tx13_pow= 1;
#endif
	rtd_outl(PINMUX_LVDSPHY_LVDSEPIVBY1_PHY_CTRL_1_1_reg,pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_1_reg.regValue);
	rtd_outl(PINMUX_LVDSPHY_LVDSEPIVBY1_PHY_CTRL_1_5_reg,pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_5_reg.regValue);
	rtd_outl(PINMUX_LVDSPHY_LVDSEPIVBY1_PHY_CTRL_1_9_reg,pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_9_reg.regValue);
	rtd_outl(PINMUX_LVDSPHY_LVDSEPIVBY1_PHY_CTRL_1_13_reg,pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_13_reg.regValue);
	rtd_outl(PINMUX_LVDSPHY_LVDSEPIVBY1_PHY_CTRL_1_17_reg,pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_17_reg.regValue);
	rtd_outl(PINMUX_LVDSPHY_LVDSEPIVBY1_PHY_CTRL_1_21_reg,pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_21_reg.regValue);
	rtd_outl(PINMUX_LVDSPHY_LVDSEPIVBY1_PHY_CTRL_0_25_reg,pinmux_lvdsphy_lvdsepivby1_phy_ctrl_0_25_reg.regValue);
	rtd_outl(PINMUX_LVDSPHY_LVDSEPIVBY1_PHY_CTRL_1_29_reg,pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_29_reg.regValue);
	rtd_outl(PINMUX_LVDSPHY_LVDSEPIVBY1_PHY_CTRL_1_33_reg,pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_33_reg.regValue);
	rtd_outl(PINMUX_LVDSPHY_LVDSEPIVBY1_PHY_CTRL_1_37_reg,pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_37_reg.regValue);
	rtd_outl(PINMUX_LVDSPHY_LVDSEPIVBY1_PHY_CTRL_1_41_reg,pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_41_reg.regValue);
	rtd_outl(PINMUX_LVDSPHY_LVDSEPIVBY1_PHY_CTRL_1_45_reg,pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_45_reg.regValue);
//	rtd_outl(PINMUX_LVDSPHY_LVDSEPIVBY1_PHY_CTRL_1_49_reg,pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_49_reg.regValue);
//	rtd_outl(PINMUX_LVDSPHY_LVDSEPIVBY1_PHY_CTRL_1_53_reg,pinmux_lvdsphy_lvdsepivby1_phy_ctrl_1_53_reg.regValue);

	printf("[vbe_disp_lane_power_on] turn off disp lane Power\n");
}


void lane_power_reset(void)
{
	vbe_disp_lane_power_off();
	mdelay(5);
#if 1
	rtd_outl(VBY1_VBY1_STATUS_FW_CTRL_reg,0xF0000000);
	rtd_outl(VBY1_VBY1_STATUS_FW_CTRL_reg,0xD0000000);
	unsigned char tmp = 0;
	unsigned char timeout = 100;
	do{
		vby1_vby1_status_fw_ctrl_RBUS vby1_status_fw_ctrl_reg;
		vby1_status_fw_ctrl_reg.regValue = rtd_inl(VBY1_VBY1_STATUS_FW_CTRL_reg);
		if((vby1_status_fw_ctrl_reg.hw_lockn==1)&&(vby1_status_fw_ctrl_reg.hw_htpdn==0)) {
			tmp++;
		} else {
			mdelay(2);
		}
	}while((tmp<3)&&(--timeout));
	rtd_outl(VBY1_VBY1_STATUS_FW_CTRL_reg,0x80000000);
#endif
	vbe_disp_lane_power_on();
}

unsigned char vbe_disp_vby1_lockn_check(void)
{
#if 1  // lockn fw mode
	unsigned char tmp = 0;
	unsigned char timeout = 3;

	if(default_panel_parameter.iCONFIG_PANEL_CUSTOM_INDEX == VBY_ONE_PANEL_innolux_4K2K_600M_1S_8L){
		//INX panel use hw lock mode, skip check
		return 1;
	}

	do{
		vby1_vby1_status_fw_ctrl_RBUS vby1_status_fw_ctrl_reg;
		vby1_status_fw_ctrl_reg.regValue = rtd_inl(VBY1_VBY1_STATUS_FW_CTRL_reg);
		if((vby1_status_fw_ctrl_reg.hw_lockn!=0)||(vby1_status_fw_ctrl_reg.hw_htpdn!=0)){
			tmp++;
		}
		else{
			tmp=0;
		}
		__udelay(1);
	}while(--timeout);


	printf("vbe_disp_vby1_lockn_check(%d)\n", tmp);

	if(tmp >= 3) {
		return 0;
	} else {
		return 1;
	}
#else

	unsigned char tmp = 0;
	unsigned char timeout = 100;
	do{
		vby1_vby1_status_fw_ctrl_RBUS vby1_status_fw_ctrl_reg;
		vby1_status_fw_ctrl_reg.regValue = rtd_inl(VBY1_VBY1_STATUS_FW_CTRL_reg);
		if((vby1_status_fw_ctrl_reg.hw_lockn==0)&&(vby1_status_fw_ctrl_reg.hw_htpdn==0))
			break;
		mdelay(1);
	}while(--timeout);
	if(timeout == 0) {
		return 0;
	} else {
		mdelay(100);
		return 1;
	}
#endif
}
char vbe_disp_tcon_readStatus(void)
{
	//unsigned char data[3]={0,0,0};
	//int ret = 0;
	//int i=0;
	//unsigned char command=0;
	int checkStatus=0;
	//unsigned char read_data[2]={0,0};
#if 1  // lockn fw mode
	if(default_panel_parameter.iCONFIG_DISPLAY_REFRESH_RATE == 60)
		return 0; //reset condition
#endif
	//t-con checking

#if 0 // wait for I2C function enable
	for(i=0; i<16; i++){
		data[0]=0x2;
		data[1]=0x97;
		data[2]=(unsigned char)(((0xff00)&(1 << i))>>8);
		ret =  I2C_Write_EX(PANEL_I2C,0x38,3,&data[0]);
		if(ret<0) {
			printf("I2C_Write_EX(0x297) return fail,break\n");
			checkStatus =1392;
			break;
		}
		data[0]=0x2;
		data[1]=0x96;
		data[2]=(unsigned char)((0x00ff)&(1 << i));
		ret =  I2C_Write_EX(PANEL_I2C,0x38,3,&data[0]);
		if(ret<0) {
			printf("I2C_Write_EX(0x297) return fail,break\n");
			checkStatus =1392;
			break;
		}
		read_data[0]=0xA;
		read_data[1]=0xA9;
		ret = I2C_Read_EX(PANEL_I2C, 0x38, 2, &read_data[0], 1, &command);
		if(ret<0) {
			printf("I2C_Read_EX(0x297) return fail,break\n");
			checkStatus =1392;
			break;
		}
		checkStatus += command;
		printf("tcon status[%d]=%x,%x\n",i,command,checkStatus);
		command=0;
	}
#endif
	if(checkStatus != 1392)
		return 1; //reset condition
	else
		return 0; //normal ok
}
unsigned char rtk_disp_tcon_lock_self_check(void)
{
#if 1  // lockn fw mode
	unsigned char result=1;
	unsigned char panel_type=0;

#ifdef PIN_MODEL_OPT_4
	panel_type = (unsigned char)IO_Get(PIN_MODEL_OPT_4); //0:led, 1:oled
#endif
	//printf("rtk_disp_tcon_lock_self_check panel_type=%d\n",panel_type);
	if (panel_type==0) {
		if((default_panel_parameter.iCONFIG_PANEL_TYPE == P_VBY1_4K2K)||(default_panel_parameter.iCONFIG_PANEL_TYPE == P_VBY1_2K1K) )

		{
			unsigned char tcon_fail_count=0;
			unsigned char lockn_result=0;
			while(tcon_fail_count<2) {
				lockn_result=vbe_disp_vby1_lockn_check();
				if(lockn_result==1)//lockn ok
				{ //0: lock N = high 1: lock N = low
					if(vbe_disp_tcon_readStatus() != 0)
					{// reset condition 1: reset 0: not
						//reset by soc lane power down and up
						tcon_fail_count++;
						printf("tcon check fail=%d\n",tcon_fail_count);
						//lane_power_reset();
						vbe_disp_lane_power_off();
						rtk_disp_vby1_init_flow();
						result=0;//fail
					} else {
						printf("tcon check ok\n");
						result=1;//ok
						break;
					}
				}
				else  //lockn high timeout
				{
					result=0; //fail
					tcon_fail_count++;
					printf("lockn always high,fail=%d\n",tcon_fail_count);
					//lane_power_reset();
					vbe_disp_lane_power_off();
					rtk_disp_vby1_init_flow();
				}
			}
		}
	}else{
		/*baker GPIO patch for K2L*/
		/*change pinmux to GPIO mode for HDMI*/
		rtd_outl(0xb8060204, rtd_inl(0xb8060204)|0xf0000000);
	}
	return result;
#else

	unsigned char result=1;
	unsigned char panel_type=0;

#ifdef PIN_MODEL_OTP_4
	panel_type = (unsigned char)IO_Get(PIN_MODEL_OPT_4); //0:led, 1:oled
#endif
	//printf("rtk_disp_tcon_lock_self_check panel_type=%d\n",panel_type);
	if (panel_type==0) {
		if(default_panel_parameter.iCONFIG_DISPLAY_REFRESH_RATE == 120)
		{
			unsigned char tcon_fail_count=0;
			unsigned char lockn_result=0;
			while(tcon_fail_count<2) {
				lockn_result=vbe_disp_vby1_lockn_check();
				if(lockn_result==1)//lockn ok
				{ //0: lock N = high 1: lock N = low
					if(vbe_disp_tcon_readStatus() != 0)
					{// reset condition 1: reset 0: not
						//reset by soc lane power down and up
						tcon_fail_count++;
						printf("tcon check fail=%d\n",tcon_fail_count);
						lane_power_reset();
						result=0;//fail
					} else {
						printf("tcon check ok\n");
						result=1;//ok
						break;
					}
				}
				else  //lockn high timeout
				{
					result=0; //fail
					tcon_fail_count++;
					printf("lockn always high,fail=%d\n",tcon_fail_count);
					lane_power_reset();
				}
			}
		}
		else
		{
			result=1; //ok
			printf("**********not 120 panel don't do lockn & tcon check********\n");
		}
	}else{
		/*baker GPIO patch for K2L*/
		/*change pinmux to GPIO mode for HDMI*/
		rtd_outl(0xb8060204, rtd_inl(0xb8060204)|0xf0000000);
	}
	return result;
#endif
}
#endif

void rtk_disp_vby1_init_flow(void)
{
#if 0
	unsigned char tmp = 0, count=0;
	//unsigned int timeout = 0x25000;
	UINT32 dvs_count = 0;
	//vby1_vby1_status_fw_ctrl_RBUS vby1_status_fw_ctrl_reg;

	//wait 3 stable d domain vsync
	for(count=0; ((count<10)&&(tmp<3)); count++){
		dvs_count = rtd_inl(PPOVERLAY_DVS_cnt_reg);
		if(default_panel_parameter.iCONFIG_DISPLAY_REFRESH_RATE == 120){
			if((dvs_count<=0x371D8)&&(dvs_count>=0x36000))
				tmp++;
		}else{
			if((dvs_count<=0x6E3B1)&&(dvs_count>=0x6D7F8))
				tmp++;
		}
		mdelay(20);
	}
	printf("[VBY1] wait d domain vsync [%d]\n", count);

	rtd_outl(VBY1_VBY1_STATUS_FW_CTRL_reg,0xA0000000);
	rtd_outl(VBY1_VBY1_STATUS_FW_CTRL_reg,0x80000000);
	vbe_disp_lane_power_on();
	printf("[VBY1]rtk_disp_vby1_init_flow OK \n");
	printf("########## 0xB802D754(%x)\n", rtd_inl(0xB802D754));
#endif
}

/**
*
* @}
*/
//dtg master to golden vsync delay line & pixel, depends on memc internel delay
#define DTGM_2_GOLDEN_VSYNC_DELAY_LINE 0x86
#define DTGM_2_GOLDEN_VSYNC_DELAY_PIXEL 0x98

#define DTGM_2_KIWIPRE_VSYNC_DELAY_LINE 0x5
#define DTGM_2_KIWIPRE_VSYNC_DELAY_PIXEL 0x4

	//2nd uzu on/off ip delay line & pixel
#define TWO_STEP_UZU_ON_OFF_DELAY_LINE 0x7
#define TWO_STEP_UZU_ON_OFF_DELAY_PIXEL 0x49
	//memc bypass, stage1 & stage2 Fifo margin (fifo length/2)
#define STAGE1_STAGE2_FIFO_MARGIN 1
#define DTG_MEMC_FREERUN_DEN_OFFSET -14


//#undef	rtd_inl
//#define  rtd_inl(x) __rtd_inl(x)
extern void GDMA_Clk_Select(void);
void setPanelDataSetting(struct _PANEL_CONFIG_PARAMETER *panel)
{
	unsigned int DHTotal;
	unsigned int den_h_start, den_h_end;
	unsigned char pixelmode_div = 1;
	ppoverlay_display_timing_ctrl1_RBUS display_timing_ctrl1_reg;
	ppoverlay_display_timing_ctrl2_RBUS display_timing_ctrl2_reg;
	ppoverlay_dh_width_RBUS dh_width_reg;
	ppoverlay_dh_total_last_line_length_RBUS dh_total_last_line_length_reg;
	ppoverlay_dv_length_RBUS dv_length_reg;
	ppoverlay_dv_total_RBUS dv_total_reg;
	//unsigned char count=0, tmp=0;
	//unsigned int dvs_count=0;

	ppoverlay_uzudtg_countrol_RBUS uzudtg_countrol_reg;
	ppoverlay_uzudtg_dv_total_RBUS uzudtg_dv_total_reg;
	ppoverlay_uzudtg_dh_total_RBUS uzudtg_dh_total_reg;
	ppoverlay_dh_den_start_end_RBUS dh_den_start_end_reg;
	ppoverlay_dv_den_start_end_RBUS dv_den_start_end_reg;
	ppoverlay_memcdtg_control_RBUS memcdtg_control_reg;
	ppoverlay_memcdtg_dv_total_RBUS memcdtg_dv_total_reg;
	ppoverlay_memcdtg_dh_total_RBUS memcdtg_dh_total_reg;
	ppoverlay_memcdtg_dv_den_start_end_RBUS memcdtg_dv_den_start_end_reg;
	ppoverlay_memcdtg_dh_den_start_end_RBUS memcdtg_dh_den_start_end_reg;
	ppoverlay_memc_mux_ctrl_RBUS memc_mux_ctrl_reg;
	ppoverlay_display_background_color_RBUS display_background_color_reg;
	ppoverlay_display_background_color_2_RBUS display_background_color_2_reg;
	ppoverlay_main_display_control_rsv_RBUS main_display_control_rsv_reg;
	ppoverlay_main_den_h_start_end_RBUS main_den_h_start_end_reg;
	ppoverlay_main_border_highlight_border_color1_RBUS main_border_highlight_border_color1_reg;
	ppoverlay_main_border_highlight_border_color2_RBUS main_border_highlight_border_color2_reg;
	ppoverlay_main_border_highlight_border_color3_RBUS main_border_highlight_border_color3_reg;
	ppoverlay_main_den_v_start_end_RBUS main_den_v_start_end_reg;
	ppoverlay_main_background_h_start_end_RBUS main_background_h_start_end_reg;
	ppoverlay_main_active_h_start_end_RBUS main_active_h_start_end_reg;
	ppoverlay_main_background_v_start_end_RBUS main_background_v_start_end_reg;
	ppoverlay_main_active_v_start_end_RBUS main_active_v_start_end_reg;
	ppoverlay_uzudtg_control1_RBUS ppoverlay_uzudtg_control1_reg;
	ppoverlay_memcdtg_control3_RBUS ppoverlay_memcdtg_control3_reg;
	ppoverlay_uzudtg_control2_RBUS ppoverlay_uzudtg_control2_reg;
	ppoverlay_memcdtg_control2_RBUS ppoverlay_memcdtg_control2_reg;

	ppoverlay_double_buffer_ctrl_RBUS double_buffer_ctrl_reg;
	sys_reg_sys_dispclksel_RBUS crt_sys_dispclksel_reg;

	printf("[2k trace code] %s, %s, %d\n", __FILE__, __FUNCTION__, __LINE__);
    if(boot_panel_type==P_LVDS_2K1K){
        rtd_maskl(SYS_REG_SYS_SRST3_reg, 0xffffbffe, 0x4001);  //Reset bit of lg pod
        rtd_maskl(SYS_REG_SYS_CLKEN3_reg, 0xffffbffe, 0x4001);  //Clock enable bit of lg pod
    }

	crt_sys_dispclksel_reg.regValue = rtd_inl(SYS_REG_SYS_DISPCLKSEL_reg);
	crt_sys_dispclksel_reg.clken_disp_memc = 1;
	crt_sys_dispclksel_reg.clken_disp_stage1 = 1; // fix compile error for rtd289x
	rtd_outl(SYS_REG_SYS_DISPCLKSEL_reg, crt_sys_dispclksel_reg.regValue);

	sys_reg_sys_dclk_gate_sel0_RBUS sys_reg_sys_dclk_gate_sel0_reg;
	sys_reg_sys_dclk_gate_sel1_RBUS sys_reg_sys_dclk_gate_sel1_reg;
	sys_reg_sys_dclk_gate_sel0_reg.regValue = rtd_inl(SYS_REG_SYS_DCLK_GATE_SEL0_reg);
	sys_reg_sys_dclk_gate_sel1_reg.regValue = rtd_inl(SYS_REG_SYS_DCLK_GATE_SEL1_reg);

	if(default_panel_parameter.iCONFIG_DISPLAY_REFRESH_RATE == 120){
		sys_reg_sys_dclk_gate_sel0_reg.dclk_s1_f1p_gate_sel = 0;
		sys_reg_sys_dclk_gate_sel0_reg.dclk_s1_f2p_gate_sel = 0;
		sys_reg_sys_dclk_gate_sel0_reg.dclk_s2_f1p_gate_sel = 0;
		sys_reg_sys_dclk_gate_sel0_reg.dclk_s2_f2p_gate_sel = 0;
		sys_reg_sys_dclk_gate_sel0_reg.dclk_osd_f1p_gate_sel = 1;
		sys_reg_sys_dclk_gate_sel0_reg.dclk_osd_f2p_gate_sel = 2;
		sys_reg_sys_dclk_gate_sel1_reg.dclk_memc_in_if_gate_sel = 1;
		sys_reg_sys_dclk_gate_sel1_reg.dclk_memc_out_if_gate_sel = 1;
		sys_reg_sys_dclk_gate_sel1_reg.dclk_mc_ippre_gate_sel = 1;
		sys_reg_sys_dclk_gate_sel1_reg.dclk_mc_ippre2x_gate_sel = 0;
		sys_reg_sys_dclk_gate_sel1_reg.dclk_mc_gate_sel = 0;
#ifdef NEED_FIX_IN_BRINGUP
		sys_reg_sys_dclk_gate_sel1_reg.dclk_s2_f2p_div2_gate_sel = 1;
#endif
	}else{
		sys_reg_sys_dclk_gate_sel0_reg.dclk_s1_f1p_gate_sel = 0;
		sys_reg_sys_dclk_gate_sel0_reg.dclk_s1_f2p_gate_sel = 1;
		sys_reg_sys_dclk_gate_sel0_reg.dclk_s2_f1p_gate_sel = 0;
		sys_reg_sys_dclk_gate_sel0_reg.dclk_s2_f2p_gate_sel = 1;
		sys_reg_sys_dclk_gate_sel0_reg.dclk_osd_f1p_gate_sel = 1;
		sys_reg_sys_dclk_gate_sel0_reg.dclk_osd_f2p_gate_sel = 2;
		sys_reg_sys_dclk_gate_sel1_reg.dclk_memc_in_if_gate_sel = 1;
		sys_reg_sys_dclk_gate_sel1_reg.dclk_memc_out_if_gate_sel = 1;
		sys_reg_sys_dclk_gate_sel1_reg.dclk_mc_ippre_gate_sel = 1;
		sys_reg_sys_dclk_gate_sel1_reg.dclk_mc_ippre2x_gate_sel = 0;
		sys_reg_sys_dclk_gate_sel1_reg.dclk_mc_gate_sel = 0;
#ifdef NEED_FIX_IN_BRINGUP
		sys_reg_sys_dclk_gate_sel1_reg.dclk_s2_f2p_div2_gate_sel = 1;
#endif
	}
	rtd_outl(SYS_REG_SYS_DCLK_GATE_SEL0_reg, sys_reg_sys_dclk_gate_sel0_reg.regValue);
	rtd_outl(SYS_REG_SYS_DCLK_GATE_SEL1_reg, sys_reg_sys_dclk_gate_sel1_reg.regValue);

	ppoverlay_dispd_smooth_toggle1_RBUS ppoverlay_dispd_smooth_toggle1_reg;
	ppoverlay_dispd_smooth_toggle1_reg.regValue = 0;
	ppoverlay_dispd_smooth_toggle1_reg.dispd_stage1_smooth_toggle_apply = 1;
	rtd_outl(PPOVERLAY_dispd_smooth_toggle1_reg, ppoverlay_dispd_smooth_toggle1_reg.regValue);

	//disable double buffer register
	double_buffer_ctrl_reg.regValue = rtd_inl(PPOVERLAY_Double_Buffer_CTRL_reg);
	double_buffer_ctrl_reg.dreg_dbuf_en = 0;
	rtd_outl(PPOVERLAY_Double_Buffer_CTRL_reg, double_buffer_ctrl_reg.regValue);

	pixelmode_div = (panel->iCONFIG_SR_PIXEL_MODE+1);
	//printf("pixelmode_div = %d\n", pixelmode_div);

	//DTG Master setting
	display_timing_ctrl1_reg.regValue = rtd_inl(PPOVERLAY_Display_Timing_CTRL1_reg);
	display_timing_ctrl1_reg.disp_frc_on_fsync = 0;
	display_timing_ctrl1_reg.disp_line_4x = panel->iFIX_LAST_LINE_4X_ENABLE;
	display_timing_ctrl1_reg.disp_fsync_en = 0;
#if 0
	if((panel->iCONFIG_PANEL_TYPE == P_VBY1_4K2K)||
		(panel->iCONFIG_PANEL_TYPE == P_VBY1_2K1K) ||
		(panel->iCONFIG_PANEL_TYPE == P_VBY1_TO_HDMI)||
		(panel->iCONFIG_PANEL_TYPE == P_VBY1_TO_HDMI_MEMC_FREERUN) ||
		(panel->iCONFIG_PANEL_TYPE == P_EPI_TYPE))
		display_timing_ctrl1_reg.disp_en = 0;	// enable dtg out wait for vby one phy and sfg ready for sync timing
	else
#endif
	display_timing_ctrl1_reg.disp_en = 1;
	display_timing_ctrl1_reg.wde_to_free_run = 0;
	display_timing_ctrl1_reg.dout_force_bg = 0;
	//display_timing_ctrl1_reg.disp_fix_last_line = 0;
	rtd_outl(PPOVERLAY_Display_Timing_CTRL1_reg, display_timing_ctrl1_reg.regValue);
	display_timing_ctrl2_reg.regValue = rtd_inl(PPOVERLAY_Display_Timing_CTRL2_reg);
	/*decide the sharpness processing how many lines,
	0: 5 line mode (den max width is 1920)
	1: Reserved
	2: 3 line mode (den max width is 3840)
	3: 1 line mode (den max width is 3840)
	*/
	//display_timing_ctrl2_reg.shpnr_line_mode = 1;
	//display_timing_ctrl2_reg.pod2_enable = 0;
	rtd_outl(PPOVERLAY_Display_Timing_CTRL2_reg, display_timing_ctrl2_reg.regValue);
	dh_width_reg.dh_width = panel->iCONFIG_DISP_HSYNC_WIDTH;
	rtd_outl(PPOVERLAY_DH_Width_reg, dh_width_reg.regValue);

	DHTotal = panel->iCONFIG_DISP_HORIZONTAL_TOTAL-1;
	if((DHTotal|0x3) > (panel->iCONFIG_DISP_HORIZONTAL_TOTAL-1)){
		DHTotal = (DHTotal&0xfffc)-1;
	}else{
		DHTotal = DHTotal|0x3;
	}	// DHtotal 4x alignment
	printf("Disp HTotal=%d, Htotal 4x alignment=%d\n", panel->iCONFIG_DISP_HORIZONTAL_TOTAL-1,
		DHTotal);
	// cklai@101223 make sure the DHTotal lastline value is odd.
	//DHTotal = panel->iCONFIG_DISP_HSYNC_LASTLINE;
	//if (DHTotal & _BIT0) // if odd
	//	DHTotal += 1; // set even

	den_h_start = panel->iCONFIG_DISP_DEN_STA_HPOS;
	printf("[2k trace code] %s, %s, %d\n", __FILE__, __FUNCTION__, __LINE__);
    if(boot_panel_type!=P_LVDS_2K1K){
	den_h_start = den_h_start & 0xfffc;  // 4x alignment
    }
	den_h_end = den_h_start + (panel->iCONFIG_DISP_ACT_END_HPOS - panel->iCONFIG_DISP_ACT_STA_HPOS);
	printf("[2k trace code] %s, %s, %d\n", __FILE__, __FUNCTION__, __LINE__);
    if(boot_panel_type!=P_LVDS_2K1K){
	den_h_end = den_h_end & 0xfffc;   // 4x alignment
    }

    printf("den_h_start=%d, den_h_end=%d\n", den_h_start, den_h_end);
    printf("den_v_start=%d, den_v_end=%d\n", panel->iCONFIG_DISP_DEN_STA_VPOS, panel->iCONFIG_DISP_DEN_END_VPOS);

	dh_total_last_line_length_reg.regValue = 0;
	dh_total_last_line_length_reg.dh_total = DHTotal;
	dh_total_last_line_length_reg.dh_total_last_line = DHTotal;
	rtd_outl(PPOVERLAY_DH_Total_Last_Line_Length_reg, dh_total_last_line_length_reg.regValue);
	dv_length_reg.regValue = 0;
	dv_length_reg.dv_length = panel->iCONFIG_DISP_VSYNC_LENGTH;
	rtd_outl(PPOVERLAY_DV_Length_reg, dv_length_reg.regValue);
	dv_total_reg.regValue = 0;
	dv_total_reg.dv_total = panel->iCONFIG_DISP_VERTICAL_TOTAL - 1;
	rtd_outl(PPOVERLAY_DV_total_reg, dv_total_reg.regValue);


	//UZU DTG setting
	uzudtg_dv_total_reg.regValue = rtd_inl(PPOVERLAY_uzudtg_DV_TOTAL_reg);
	uzudtg_dv_total_reg.uzudtg_dv_total = panel->iCONFIG_DISP_VERTICAL_TOTAL-1;
	rtd_outl(PPOVERLAY_uzudtg_DV_TOTAL_reg, uzudtg_dv_total_reg.regValue);
	uzudtg_dh_total_reg.regValue = rtd_inl(PPOVERLAY_uzudtg_DH_TOTAL_reg);
	uzudtg_dh_total_reg.uzudtg_dh_total = DHTotal/pixelmode_div;
	uzudtg_dh_total_reg.uzudtg_dh_total_last_line = DHTotal/pixelmode_div;
	rtd_outl(PPOVERLAY_uzudtg_DH_TOTAL_reg, uzudtg_dh_total_reg.regValue);
	dh_den_start_end_reg.regValue = rtd_inl(PPOVERLAY_DH_DEN_Start_End_reg);
	dh_den_start_end_reg.dh_den_sta = den_h_start/pixelmode_div;
	dh_den_start_end_reg.dh_den_end = den_h_end/pixelmode_div;
	rtd_outl(PPOVERLAY_DH_DEN_Start_End_reg, dh_den_start_end_reg.regValue);
	dv_den_start_end_reg.regValue = rtd_inl(PPOVERLAY_DV_DEN_Start_End_reg);
	dv_den_start_end_reg.dv_den_sta = panel->iCONFIG_DISP_DEN_STA_VPOS;
	dv_den_start_end_reg.dv_den_end = panel->iCONFIG_DISP_DEN_END_VPOS;
	rtd_outl(PPOVERLAY_DV_DEN_Start_End_reg, dv_den_start_end_reg.regValue);
	uzudtg_countrol_reg.regValue = rtd_inl(PPOVERLAY_UZUDTG_COUNTROL_reg);
	uzudtg_countrol_reg.uzudtg_en = 1;
	uzudtg_countrol_reg.uzudtg_fsync_en = 1;
	rtd_outl(PPOVERLAY_UZUDTG_COUNTROL_reg, uzudtg_countrol_reg.regValue);
	printf("[uzu] dvtotal(%x = %x)\n", PPOVERLAY_uzudtg_DV_TOTAL_reg, uzudtg_dv_total_reg.regValue);
	printf("[uzu] dhtotal(%x = %x)\n", PPOVERLAY_uzudtg_DH_TOTAL_reg, uzudtg_dh_total_reg.regValue);
	printf("[uzu] dh den start(%x = %x)\n", PPOVERLAY_DH_DEN_Start_End_reg, dh_den_start_end_reg.regValue);
	printf("[uzu] dv den start(%x = %x)\n", PPOVERLAY_DV_DEN_Start_End_reg, dv_den_start_end_reg.regValue);
	printf("[uzu] uzudtg control (%x = %x)\n", PPOVERLAY_UZUDTG_COUNTROL_reg, uzudtg_countrol_reg.regValue);

	ppoverlay_uzudtg_fractional_fsync_RBUS uzudtg_fractional_fsync_reg;
	uzudtg_fractional_fsync_reg.regValue = rtd_inl(PPOVERLAY_uzudtg_fractional_fsync_reg);
	uzudtg_fractional_fsync_reg.uzudtg_remove_half_ivs = 1; // enable;
	uzudtg_fractional_fsync_reg.uzudtg_remove_half_ivs_alignmode = 1; // align to ivs
	if(default_panel_parameter.iCONFIG_DISPLAY_REFRESH_RATE == 120){
#ifdef CONFIG_MEMC_BYPASS	// bringup memc bypass mode
		uzudtg_fractional_fsync_reg.uzudtg_remove_half_ivs_mode = 0;
#else
		uzudtg_fractional_fsync_reg.uzudtg_remove_half_ivs_mode = 1;
#endif
	}else{
		uzudtg_fractional_fsync_reg.uzudtg_remove_half_ivs_mode = 0;
	}
	uzudtg_fractional_fsync_reg.uzudtg_multiple_vsync = 0;
	rtd_outl(PPOVERLAY_uzudtg_fractional_fsync_reg, uzudtg_fractional_fsync_reg.regValue);


	//MEMC DTG setting
	memcdtg_dv_total_reg.regValue = rtd_inl(PPOVERLAY_memcdtg_DV_TOTAL_reg);
	memcdtg_dv_total_reg.memcdtg_dv_total = panel->iCONFIG_DISP_VERTICAL_TOTAL-1;
	rtd_outl(PPOVERLAY_memcdtg_DV_TOTAL_reg, memcdtg_dv_total_reg.memcdtg_dv_total);

	memcdtg_dh_total_reg.regValue = rtd_inl(PPOVERLAY_memcdtg_DH_TOTAL_reg);
	memcdtg_dh_total_reg.memcdtg_dh_total = DHTotal;
	memcdtg_dh_total_reg.memcdtg_dh_total_last_line = DHTotal;
	rtd_outl(PPOVERLAY_memcdtg_DH_TOTAL_reg, memcdtg_dh_total_reg.regValue);
	memcdtg_dh_den_start_end_reg.regValue = rtd_inl(PPOVERLAY_memcdtg_DH_DEN_Start_End_reg);
	if(default_panel_parameter.iCONFIG_PANEL_TYPE == P_VBY1_TO_HDMI_MEMC_FREERUN){
		memcdtg_dh_den_start_end_reg.memcdtg_dh_den_sta = den_h_start+DTG_MEMC_FREERUN_DEN_OFFSET;
		memcdtg_dh_den_start_end_reg.memcdtg_dh_den_end = den_h_end+DTG_MEMC_FREERUN_DEN_OFFSET;
	}else{
		memcdtg_dh_den_start_end_reg.memcdtg_dh_den_sta = den_h_start;
		memcdtg_dh_den_start_end_reg.memcdtg_dh_den_end = den_h_end;
	}
	rtd_outl(PPOVERLAY_memcdtg_DH_DEN_Start_End_reg, memcdtg_dh_den_start_end_reg.regValue);
	memcdtg_dv_den_start_end_reg.regValue = rtd_inl(PPOVERLAY_memcdtg_DV_DEN_Start_End_reg);
	memcdtg_dv_den_start_end_reg.memcdtg_dv_den_sta = panel->iCONFIG_DISP_DEN_STA_VPOS;
	memcdtg_dv_den_start_end_reg.memcdtg_dv_den_end = panel->iCONFIG_DISP_DEN_END_VPOS;
	rtd_outl(PPOVERLAY_memcdtg_DV_DEN_Start_End_reg, memcdtg_dv_den_start_end_reg.regValue);
	memcdtg_control_reg.regValue = rtd_inl(PPOVERLAY_MEMCDTG_CONTROL_reg);
	memcdtg_control_reg.memcdtg_en = 1;
	memcdtg_control_reg.memcdtg_fsync_en =1;
	rtd_outl(PPOVERLAY_MEMCDTG_CONTROL_reg, memcdtg_control_reg.regValue);
	memc_mux_ctrl_reg.regValue = rtd_inl(PPOVERLAY_MEMC_MUX_CTRL_reg);

#ifdef CONFIG_MEMC_BYPASS	// bringup memc bypass mode
	memc_mux_ctrl_reg.rtk_bypass_vs_delay=0x5;
	memc_mux_ctrl_reg.memc_outmux_sel = 0; //from MEMC
	memc_mux_ctrl_reg.memcdtg_golden_vs =1; // use golden post vs
	memc_mux_ctrl_reg.memc_out_bg_en = 0;//enable MEMC output bg
#else  //for bring up
	memc_mux_ctrl_reg.rtk_bypass_vs_delay=0;
	memc_mux_ctrl_reg.memc_outmux_sel = 1; //from MEMC
	memc_mux_ctrl_reg.memcdtg_golden_vs =1; // use golden post vs
	memc_mux_ctrl_reg.memc_out_bg_en = 1;//enable MEMC output bg
#endif
	if(default_panel_parameter.iCONFIG_PANEL_TYPE == P_VBY1_TO_HDMI_MEMC_FREERUN)
	{
		printf("[memc]VBY1_TO_HDMI_MEMC_FREERUN, goldenvsync=0\n");
		memc_mux_ctrl_reg.memcdtg_golden_vs =0; // use memc vs
	}

	rtd_outl(PPOVERLAY_MEMC_MUX_CTRL_reg, memc_mux_ctrl_reg.regValue);
	printf("[memc] dvtotal(%x = %x)\n", PPOVERLAY_memcdtg_DV_TOTAL_reg, memcdtg_dv_total_reg.regValue);
	printf("[memc] dhtotal(%x = %x)\n", PPOVERLAY_memcdtg_DH_TOTAL_reg, memcdtg_dh_total_reg.regValue);
	printf("[memc] dh den start(%x = %x)\n", PPOVERLAY_memcdtg_DH_DEN_Start_End_reg, memcdtg_dh_den_start_end_reg.regValue);
	printf("[memc] dv den start(%x = %x)\n", PPOVERLAY_memcdtg_DV_DEN_Start_End_reg, memcdtg_dv_den_start_end_reg.regValue);
	printf("[memc] uzudtg control (%x = %x)\n", PPOVERLAY_MEMC_MUX_CTRL_reg, memc_mux_ctrl_reg.regValue);

#ifdef CONFIG_CUSTOM_SN_PANEL
	int rtk_pn = 0;
	const char *rtk_pnStr = getenv("rtk_pn");
	rtk_pn = simple_strtoul(rtk_pnStr, NULL, 10);

	if(rtk_pn){
		//demo borad def value
		//DTGM_2_GOLDEN_VSYNC_DELAY_LINE=0x41;
		//DTGM_2_GOLDEN_VSYNC_DELAY_PIXEL=0x6c3;
	}
#endif
#ifndef CONFIG_MEMC_BYPASS
	//MEMC golden VS delay
	if(default_panel_parameter.iCONFIG_DISPLAY_REFRESH_RATE == 120){
		rtd_outl(PPOVERLAY_MEMCDTG_CONTROL3_reg, 0x009b040b);
	}
	else{
		ppoverlay_uzudtg_control1_reg.regValue = rtd_inl(PPOVERLAY_uzudtg_control1_reg);
		ppoverlay_uzudtg_control1_reg.dtgm2uzuvs_line = DTGM_2_GOLDEN_VSYNC_DELAY_LINE;
		ppoverlay_uzudtg_control1_reg.dtgm2uzuvs_pixel = DTGM_2_GOLDEN_VSYNC_DELAY_PIXEL-STAGE1_STAGE2_FIFO_MARGIN;
		rtd_outl(PPOVERLAY_uzudtg_control1_reg, ppoverlay_uzudtg_control1_reg.regValue);
		ppoverlay_memcdtg_control3_reg.regValue = rtd_inl(PPOVERLAY_MEMCDTG_CONTROL3_reg);
		ppoverlay_memcdtg_control3_reg.dtgm2goldenpostvs_line = DTGM_2_GOLDEN_VSYNC_DELAY_LINE;
		ppoverlay_memcdtg_control3_reg.dtgm2goldenpostvs_pixel = DTGM_2_GOLDEN_VSYNC_DELAY_PIXEL;
		rtd_outl(PPOVERLAY_MEMCDTG_CONTROL3_reg, ppoverlay_memcdtg_control3_reg.regValue);
	}
#else
	//default use golden vsync
	ppoverlay_memcdtg_control3_reg.regValue = rtd_inl(PPOVERLAY_MEMCDTG_CONTROL3_reg);
	ppoverlay_memcdtg_control3_reg.dtgm2goldenpostvs_line = DTGM_2_GOLDEN_VSYNC_DELAY_LINE;
	ppoverlay_memcdtg_control3_reg.dtgm2goldenpostvs_pixel = DTGM_2_GOLDEN_VSYNC_DELAY_PIXEL;
	rtd_outl(PPOVERLAY_MEMCDTG_CONTROL3_reg, ppoverlay_memcdtg_control3_reg.regValue);
#endif

	/* two step uzu dtg2master delay line setting */
	ppoverlay_uzudtg_control1_reg.regValue = rtd_inl(PPOVERLAY_uzudtg_control1_reg);
	ppoverlay_uzudtg_control1_reg.dtgm2uzuvs_line = DTGM_2_GOLDEN_VSYNC_DELAY_LINE;
	ppoverlay_uzudtg_control1_reg.dtgm2uzuvs_pixel = DTGM_2_GOLDEN_VSYNC_DELAY_PIXEL-STAGE1_STAGE2_FIFO_MARGIN;
#ifdef CONFIG_MEMC_BYPASS	// 4k2k120 use 2nd uzu
	if((default_panel_parameter.iCONFIG_DISPLAY_REFRESH_RATE == 120)&&
		((default_panel_parameter.iCONFIG_DISP_ACT_END_HPOS - default_panel_parameter.iCONFIG_DISP_ACT_STA_HPOS) == 3840) &&
		((default_panel_parameter.iCONFIG_DISP_ACT_END_VPOS - default_panel_parameter.iCONFIG_DISP_ACT_STA_VPOS) == 2160))
	{
		od_od_ctrl_RBUS od_od_ctrl_reg;
		// OD_4K120 mode
		od_od_ctrl_reg.regValue = rtd_inl(OD_OD_CTRL_reg);
		od_od_ctrl_reg.od_4k120_mode = 1;
		rtd_outl(OD_OD_CTRL_reg, od_od_ctrl_reg.regValue);

		ppoverlay_uzudtg_control1_reg.two_step_uzu_en = 1;
		ppoverlay_uzudtg_control1_reg.uzu_4k_120_mode = 1;
	}
#endif
	rtd_outl(PPOVERLAY_uzudtg_control1_reg, ppoverlay_uzudtg_control1_reg.regValue);
	ppoverlay_uzudtg_control2_reg.regValue = rtd_inl(PPOVERLAY_uzudtg_control2_reg);
#ifdef CONFIG_MEMC_BYPASS	// 4k2k120 use 2nd uzu
#if 0
	if((default_panel_parameter.iCONFIG_DISPLAY_REFRESH_RATE == 120)&&
		((default_panel_parameter.iCONFIG_DISP_ACT_END_HPOS - default_panel_parameter.iCONFIG_DISP_ACT_STA_HPOS) == 3840) &&
		((default_panel_parameter.iCONFIG_DISP_ACT_END_VPOS - default_panel_parameter.iCONFIG_DISP_ACT_STA_VPOS) == 2160))
	{
		ppoverlay_uzudtg_control2_reg.dtgm2uzu_s1_vs_line = DTGM_2_GOLDEN_VSYNC_DELAY_LINE-TWO_STEP_UZU_ON_OFF_DELAY_LINE;
		ppoverlay_uzudtg_control2_reg.dtgm2uzu_s1_vs_pixel = DTGM_2_GOLDEN_VSYNC_DELAY_PIXEL-STAGE1_STAGE2_FIFO_MARGIN-TWO_STEP_UZU_ON_OFF_DELAY_PIXEL;
	}else{
#endif
	ppoverlay_uzudtg_control2_reg.dtgm2uzu_s1_vs_line = DTGM_2_GOLDEN_VSYNC_DELAY_LINE-TWO_STEP_UZU_ON_OFF_DELAY_LINE;
	ppoverlay_uzudtg_control2_reg.dtgm2uzu_s1_vs_pixel = DTGM_2_GOLDEN_VSYNC_DELAY_PIXEL-STAGE1_STAGE2_FIFO_MARGIN-TWO_STEP_UZU_ON_OFF_DELAY_PIXEL;
#if 0
	}
#endif
#else
	ppoverlay_uzudtg_control2_reg.dtgm2uzu_s1_vs_line = DTGM_2_GOLDEN_VSYNC_DELAY_LINE-TWO_STEP_UZU_ON_OFF_DELAY_LINE;
	ppoverlay_uzudtg_control2_reg.dtgm2uzu_s1_vs_pixel = DTGM_2_GOLDEN_VSYNC_DELAY_PIXEL-STAGE1_STAGE2_FIFO_MARGIN-TWO_STEP_UZU_ON_OFF_DELAY_PIXEL;
#endif

	rtd_outl(PPOVERLAY_uzudtg_control2_reg, ppoverlay_uzudtg_control2_reg.regValue);

	//set MEMC kiwiprevs delay
	ppoverlay_memcdtg_control2_reg.regValue = rtd_inl(PPOVERLAY_MEMCDTG_CONTROL2_reg);
	ppoverlay_memcdtg_control2_reg.dtgm2kiwiprevs_line = DTGM_2_KIWIPRE_VSYNC_DELAY_LINE;
	ppoverlay_memcdtg_control2_reg.dtgm2kiwiprevs_pixel = DTGM_2_KIWIPRE_VSYNC_DELAY_PIXEL;
	rtd_outl(PPOVERLAY_MEMCDTG_CONTROL2_reg, ppoverlay_memcdtg_control2_reg.regValue);
	//MEMC in/out clock enable
	sys_reg_sys_dispclksel_RBUS sys_dispclksel_reg;
	sys_dispclksel_reg.regValue = rtd_inl(SYS_REG_SYS_DISPCLKSEL_reg);
	sys_dispclksel_reg.clken_disp_memc = 1;
	rtd_outl(SYS_REG_SYS_DISPCLKSEL_reg, sys_dispclksel_reg.regValue);
	rtd_outl(0xb802e800, 0x00000001);//memc mux function


	display_background_color_reg.regValue = 0;
	display_background_color_reg.d_bg_b= 0;
	display_background_color_reg.d_bg_g = 0;
	display_background_color_2_reg.regValue = 0;
	display_background_color_2_reg.d_bg_r = 0;
	rtd_outl(PPOVERLAY_Display_Background_Color_reg, display_background_color_reg.regValue);
	rtd_outl(PPOVERLAY_Display_Background_Color_2_reg, display_background_color_2_reg.regValue);

#ifndef CONFIG_MEMC_BYPASS	// bringup memc bypass mode
	//qiangzhou add:memc open, so should change to 4k2k uzu dtg for balance test
	pixelmode_div = 1;
	uzudtg_dh_total_reg.regValue = rtd_inl(PPOVERLAY_uzudtg_DH_TOTAL_reg);
	uzudtg_dh_total_reg.uzudtg_dh_total = DHTotal/pixelmode_div;
	uzudtg_dh_total_reg.uzudtg_dh_total_last_line = DHTotal/pixelmode_div;
	rtd_outl(PPOVERLAY_uzudtg_DH_TOTAL_reg, uzudtg_dh_total_reg.regValue);
	dh_den_start_end_reg.regValue = rtd_inl(PPOVERLAY_DH_DEN_Start_End_reg);
	dh_den_start_end_reg.dh_den_sta = den_h_start/pixelmode_div;
	dh_den_start_end_reg.dh_den_end = den_h_end/pixelmode_div;
	rtd_outl(PPOVERLAY_DH_DEN_Start_End_reg, dh_den_start_end_reg.regValue);
#endif


	//MTG setting
	//USER:LewisLee DATE:2012/05/31
	//to prevent disable display data enable interrupt
	//let D domain ISR work error
	main_display_control_rsv_reg.regValue = rtd_inl(PPOVERLAY_Main_Display_Control_RSV_reg);
	main_display_control_rsv_reg.main_wd_to_background = 0;
	main_display_control_rsv_reg.m_hbd_en = 0;
	main_display_control_rsv_reg.m_bd_trans = 0;
	main_display_control_rsv_reg.m_force_bg = 1;
	main_display_control_rsv_reg.m_disp_en = 1;
	rtd_outl(PPOVERLAY_Main_Display_Control_RSV_reg, main_display_control_rsv_reg.regValue);
	main_border_highlight_border_color1_reg.regValue = 0;
	main_border_highlight_border_color2_reg.regValue = 0;
	main_border_highlight_border_color3_reg.regValue = 0;
	main_border_highlight_border_color1_reg.m_hbd_b = 0;
	main_border_highlight_border_color1_reg.m_hbd_g = 0;
	main_border_highlight_border_color2_reg.m_hbd_r = 0;
	main_border_highlight_border_color2_reg.m_bd_b= 0;
	main_border_highlight_border_color3_reg.m_bd_g = 0;
	main_border_highlight_border_color3_reg.m_bd_r = 0;
	rtd_outl(PPOVERLAY_Main_Border_Highlight_Border_Color1_reg, main_border_highlight_border_color1_reg.regValue);
	rtd_outl(PPOVERLAY_Main_Border_Highlight_Border_Color2_reg, main_border_highlight_border_color2_reg.regValue);
	rtd_outl(PPOVERLAY_Main_Border_Highlight_Border_Color3_reg, main_border_highlight_border_color3_reg.regValue);
	//Display window H Enable setting // 0x437
	main_den_h_start_end_reg.regValue = 0;
	main_den_h_start_end_reg.mh_den_sta = (panel->iCONFIG_DISP_ACT_STA_HPOS)/pixelmode_div;
	main_den_h_start_end_reg.mh_den_end = (panel->iCONFIG_DISP_ACT_END_HPOS)/pixelmode_div;
	rtd_outl(PPOVERLAY_MAIN_DEN_H_Start_End_reg, main_den_h_start_end_reg.regValue);
	//Display window V Enable setting // 0x43a
	main_den_v_start_end_reg.regValue = 0;
	main_den_v_start_end_reg.mv_den_sta = panel->iCONFIG_DISP_ACT_STA_VPOS;
	main_den_v_start_end_reg.mv_den_end = panel->iCONFIG_DISP_ACT_END_VPOS;
	rtd_outl(PPOVERLAY_MAIN_DEN_V_Start_End_reg, main_den_v_start_end_reg.regValue);
	//Background window H setting // 0x43d
	main_background_h_start_end_reg.regValue = 0;
	main_background_h_start_end_reg.mh_bg_sta = (panel->iCONFIG_DISP_ACT_STA_HPOS)/pixelmode_div;
	main_background_h_start_end_reg.mh_bg_end = (panel->iCONFIG_DISP_ACT_END_HPOS)/pixelmode_div;
	rtd_outl(PPOVERLAY_MAIN_Background_H_Start_End_reg, main_background_h_start_end_reg.regValue);
	//Background window V setting // 0x440
	main_background_v_start_end_reg.regValue = 0;
	main_background_v_start_end_reg.mv_bg_sta = panel->iCONFIG_DISP_ACT_STA_VPOS;
	main_background_v_start_end_reg.mv_bg_end = panel->iCONFIG_DISP_ACT_END_VPOS;
	rtd_outl(PPOVERLAY_MAIN_Background_V_Start_End_reg, main_background_v_start_end_reg.regValue);
	//Active window H setting // 0x443
	main_active_h_start_end_reg.regValue = 0;
	main_active_h_start_end_reg.mh_act_sta = (panel->iCONFIG_DISP_ACT_STA_HPOS)/pixelmode_div;
	main_active_h_start_end_reg.mh_act_end = (panel->iCONFIG_DISP_ACT_END_HPOS)/pixelmode_div;
	rtd_outl(PPOVERLAY_MAIN_Active_H_Start_End_reg, main_active_h_start_end_reg.regValue);
	//Active window V setting // 0x446
	main_active_v_start_end_reg.regValue = 0;
	main_active_v_start_end_reg.mv_act_sta = panel->iCONFIG_DISP_ACT_STA_VPOS;
	main_active_v_start_end_reg.mv_act_end = panel->iCONFIG_DISP_ACT_END_VPOS;
	rtd_outl(PPOVERLAY_MAIN_Active_V_Start_End_reg, main_active_v_start_end_reg.regValue);

	panel_sfg_config(panel);


	drvif_clock_set_dclk(panel->iCONFIG_DISPLAY_CLOCK_TYPICAL);
	drvif_clock_set_dtg_uzu_div();
	drvif_clock_set_dtg_memc_div();


	DEBUG_PRINT("panel_init  panel->iCONFIG_DISPLAY_PORT = %x\n",panel->iCONFIG_DISPLAY_PORT);

#if defined (Config_PIFType_Mini_LVDS)
	//rtd_outl(0xb8000208, 0x00004074); 	// D-Domain, SFG, MEMC_IN/OUT Clock Enable
	//rtd_outl(0xb8028100, 0x00050000); 	// Bypass MEMC
	rtd_maskl(0xb80006C8, 0x7FFFFFFF, 0x00000000);	// DPLL use LS APHY
#if defined (Config_TPV_mLVDS_TRUE)
	//color b8028004=> 01C60008
	rtd_outl(0xb8028004, 0x01C60008);

	//���u
	//0xb80269F0 =>102E10F0
	//0xb8026830 =>102E10F0
	rtd_outl(0xb80269f0, 0x102E10F0);
	rtd_outl(0xb8026830, 0x102E10F0);

	//�׽u
	//b802db00: 01000302
	//b802db04: 05040706
	rtd_outl(0xb802db00, 0x01000302);
	rtd_outl(0xb802db04, 0x05040706);
#endif
#endif

	panel_interface_common();
#if 0
	if((panel->iCONFIG_PANEL_TYPE == P_VBY1_4K2K) ||
	   (panel->iCONFIG_PANEL_TYPE == P_VBY1_2K1K) ||
	   (panel->iCONFIG_PANEL_TYPE == P_VBY1_TO_HDMI)||
	   (panel->iCONFIG_PANEL_TYPE == P_VBY1_TO_HDMI_MEMC_FREERUN) ||
	   (panel->iCONFIG_PANEL_TYPE == P_EPI_TYPE))
	{
		double_buffer_ctrl_reg.regValue = rtd_inl(PPOVERLAY_Double_Buffer_CTRL_reg);
		double_buffer_ctrl_reg.dreg_dbuf_en = 0;
		rtd_outl(PPOVERLAY_Double_Buffer_CTRL_reg, double_buffer_ctrl_reg.regValue);
		display_timing_ctrl1_reg.regValue = rtd_inl(PPOVERLAY_Display_Timing_CTRL1_reg);
		display_timing_ctrl1_reg.disp_frc_on_fsync = 0;
		display_timing_ctrl1_reg.disp_fsync_en = 0;
#if defined(Config_Board_TV010_PANEL)
		display_timing_ctrl1_reg.disp_en = 0;
#else
		display_timing_ctrl1_reg.disp_en = 1;				// enable dtg out for sync vby_one timing
#endif
		rtd_outl(PPOVERLAY_Display_Timing_CTRL1_reg, display_timing_ctrl1_reg.regValue);

		//if((panel->iCONFIG_PANEL_TYPE == P_VBY1_4K2K) || (panel->iCONFIG_PANEL_TYPE == P_VBY1_2K1K) || (panel->iCONFIG_PANEL_TYPE == P_VBY1_TO_HDMI))
			//rtk_disp_vby1_init_flow();
	}
#endif

#if defined(Config_Board_TV010_PANEL)
	//DTG Master setting
	display_timing_ctrl1_reg.regValue = rtd_inl(PPOVERLAY_Display_Timing_CTRL1_reg);
	display_timing_ctrl1_reg.dout_force_bg = 1;
	display_timing_ctrl1_reg.disp_en = 1;
	rtd_outl(PPOVERLAY_Display_Timing_CTRL1_reg, display_timing_ctrl1_reg.regValue);
#endif

#ifdef CONFIG_RTK_GDMA_SUPPORT
	// GDMA initialization
	GDMA_Clk_Select();
	//GDMA_init_module(0);
#endif

	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
}


void panel_epi_initial_flow(void)
{
	printf("panel_epi_initial_flow\n");

	//---------------------------------------------------------------------------------------------------------------------------------
	//Initial Flow
	//--------------------------------------------------------------------------------------------------------------------------------
	// (1) DPLL Power Enable  (As above Script)
	//
	// (2) Wait DPLL stable at least 150us (SW Control)
	//
	// (3) Release DCLK Gating (SW Control)
	//
	// (4) TXPLL power up TXPLL during reset state (As above Script)
	//
	// (5) TXPLL reset release (Below Setting)
	rtd_part_outl(0xb8000C20, 10, 10, 0x1);
	//
	// (6) Wait TXPLL stable at least 150us (SW Control)
	//
	// (7) EPI Clock Enable (Below Setting)
	rtd_outl(0xb802D9B8, 0x40000000);
	//
	// (8) EPI MAC Enable (Below Setting)
	rtd_part_outl(0xb802606C, 16, 16, 0x1);
	//
	// (9) Enable Async FIFO,
	rtd_outl(0xb802D038, 0x00000001);
	//
	// (10) APHY Lane Power Enable (Below Setting)
	rtd_outl(0xb8000CC0, 0x000003FC);
	//
	// (11) Panel Power Enable (SW Control),
}

#if defined(Config_Vulcan3_PCB_TRUE)
void panel_lvds_fhd_tx(void)
{
    printf("\033[1;33m panel_lvds_fhd_tx \033[m\n");

	//---------------------------------------------------------------------------------------------------------------------------------
	//SFG: DH_ST_END = 0x008C080C, DTG_HS_Width = 16, DTG_VS_Width = 6
	//---------------------------------------------------------------------------------------------------------------------------------

	// ----------------------- Insert Dummy Line Function & Auto Config SFG Timing Gen -----------------------
	rtd_outl(0xb802D988, 0x40000000);	// bypass SFG disable[31], auto config sfg timing gen [30], insert dummy line[22:20]/[18:16]/[14:12]/[10:8], downsample v disable [0]

	// ----------------------- SFG Timing -----------------------
	rtd_outl(0xb802D900, 0x01101040);	// tcon_clk=dclk [27], sfg_clk=dclk [26], SFG_OSD path disable[25], SFG path enable [24],
	//fixed DTG last line hsync period [22], any to any subpixel disable [21], PIF clk selection epi/lvds [18],
	//pre rb swap disable[17], display 24bit RGB mode[13:12], dclk/aclk enable [6], post rb swap disable[5],
	rtd_outl(0xb802D9B8, 0x00000000);	// PIF clock enable / disable control (LVDS/LVDS[31], EPI[30], Vby1[29], Vby1 OSD[28], P2P[15], iSP[14], USIT[13]), Data inverse disable [16],
	rtd_outl(0xb802D950, 0x044C0014);	// Dv_den_end[29:16] = 1100, Dv_den_sta[13:0] = 20
	rtd_outl(0xb802D954, 0x08140094);	// Dh_den_end[29:16] = 2068, Dh_den_sta[13:0] = 148
	rtd_outl(0xb802D958, 0x04200897);	// Dv_width[31:24] = 4, Dh_width[23:16] = 32, Dh_total[12:0] = 2199
	rtd_outl(0xb802D99C, 0x07800000);	// Final Line Length[28:16] = 1920
	rtd_outl(0xb802D9A0, 0x00000000);	// Residue_pix_split_mode[18:16], Final_addr_split_mode[12:0],
	rtd_outl(0xb802D9A4, 0x008C0890);	// hs_den_io_dist (auto config)[28:16], hs_io_dist (auto config)[12:0]
	rtd_outl(0xb802D98C, 0x00000000);	// hsync_width(auto config)[23:16], hsync_delay(auto config)[15:0]
	rtd_outl(0xb802D990, 0x00000300);	// Hs_distance (for DRD&RGB Split mode) [29:16], vsync_end(auto config)[15:8], vsync_start(auto config)[7:0]
	rtd_outl(0xb802D994, 0x00000000);	// sfg_dh_den_sta (auto config)[31:16], req_start (auto config)[15:0]

	// ------------------------ Force SFG Data as background color -------------------------
	rtd_outl(0xb802D928, 0x00000000);	// bypass sfg data[31], dif background R [29:30], G[19:10], B[9:0]
	rtd_outl(0xb802D904, 0x01FFF000);	// PIF_Clock = Dclk / (1+1) [27:24], Force A~P port to background enable [23][22]...[8]

	// ------------------------ SFG Control -------------------------
	rtd_outl(0xb802D964, 0x00000001);	// SFG normal mode[29:28], 1 pixel mode[17:16], 0+1 Segment[12:8], H-Flip disable[7], 1+1 Port[4:0]
	rtd_outl(0xb802D910, 0x00000003);	// CRC normal mode[31], CRC continuous mode [1], CRC control start[0]

	// -------------------------- Segment Setting ---------------------------
	rtd_outl(0xb802D968, 0x00000000);	// Seg 0 Start [28:16] = 0, Seg 1 Start [12:0] = 0
	rtd_outl(0xb802D998, 0x00000000);	// Segment 15~0 Flip [15][14]K[0]
	rtd_outl(0xb802DA94, 0x00000000);	// Line 0 last segment start [28:16] = 0, Line 1 last segment start [12:0] = 0
	rtd_outl(0xb802DA98, 0x00000000);	// Line 2 last segment start [28:16] = 0, Line 3 last segment start [12:0] = 0
	rtd_outl(0xb802DBE0, 0x00000000);	// Line 4 last segment start [28:16] = 0, Line 5 last segment start [12:0] = 0
	rtd_outl(0xb802DBE4, 0x00000000);	// Line 6 last segment start [28:16] = 0, Line 7 last segment start [12:0] = 0

	// -------------------------- Zig-Zag Mode ---------------------------
	rtd_outl(0xb802D92C, 0x00000000);	// 8n+0~8n+3 line ZZ mode control
	rtd_outl(0xb802DBA8, 0x00000000);	// 8n+4~8n+7 line ZZ mode control

	// -------------------------- Add Segment dummy front / back pixels or mid subpixel ---------------------------
	rtd_outl(0xb802D930, 0x00000000);	// Seg 0 / Seg 1 Line 0~3 front/back dummy pixel number
	rtd_outl(0xb802D9E8, 0x00000000);	// Seg 0 / Seg 1 place and number of middle dummy subpixel
	rtd_outl(0xb802DA1C, 0x00000000);	// front/back/middle dummy content [28], double buffer[20]

	// -------------------------- SFG_Pattern Generate ---------------------------
	rtd_outl(0xb802DBF0,0x0EF08700);	// width[28:20] = 239+1, height[16:8] = 135+1, [5] pattern reset by hs, [3] rgb mode, [2:1] v color bar, [0] SFG ptn gen disable
	rtd_outl(0xb802DBF4,0x00FFFFFF);	// color bar 0 content W[31:24], R[23:16], G[15:8], B[7:0]
	rtd_outl(0xb802DBF8,0x00FFFF00);	// color bar 1 content W[31:24], R[23:16], G[15:8], B[7:0]
	rtd_outl(0xb802DBFC,0x0000FFFF);	// color bar 2 content W[31:24], R[23:16], G[15:8], B[7:0]
	rtd_outl(0xb802DC00,0x0000FF00);	// color bar 3 content W[31:24], R[23:16], G[15:8], B[7:0]
	rtd_outl(0xb802DC04,0x00FF00FF);	// color bar 4 content W[31:24], R[23:16], G[15:8], B[7:0]
	rtd_outl(0xb802DC08,0x00FF0000);	// color bar 5 content W[31:24], R[23:16], G[15:8], B[7:0]
	rtd_outl(0xb802DC0C,0x000000FF);	// color bar 6 content W[31:24], R[23:16], G[15:8], B[7:0]
	rtd_outl(0xb802DC10,0x00000000);	// color bar 7 content W[31:24], R[23:16], G[15:8], B[7:0]

	// -------------------------- PIF FIFO Control ---------------------------
	rtd_outl(0xb802DC94,0x00000000);	// PIF_FIFO disable[31], TX PHY LVDS/mLVDS mode[30:28]
	rtd_outl(0xb802DC98,0x9C00FFFF);	// PIF_FIFO auto reset enable [31] ,Lane 15~0 [15:0] enable / disable control
	//iCONFIG_DISPLAY_PORTAB_SWAP
	rtd_outl(0xb802DC9C,0xB12345FF);	// Lane 7~0 pair assign
	rtd_outl(0xb802DCA0,0xFFFF789A);	// Lane 15~8 pair assign
	//rtd_outl(0xb802DC9C,0x5789aBFF);	// Lane 7~0 pair assign
	//rtd_outl(0xb802DCA0,0xFFFF1234);	// Lane 15~8 pair assign

	rtd_outl(0xb802DCC8,0x00003FFC);	// 16 lane video[30:28], phy lane15~0 enable / disable control [15:0]
	rtd_outl(0xb802DCD0,0x00000000);	// Lane 15~0  [15:0] PN swap disable / enable control

	rtd_part_outl(0xb802D900, 11, 11, 0x1); // SFG out enable
	//---------------------------------------------------------------------------------------------------------------------------------
	//DISP_IF
	//---------------------------------------------------------------------------------------------------------------------------------
	rtd_outl(0xb802D008, 0x00005000);	// LVDS A/B Port Disable, LSB First, LVDS format use Table1,

	//---------------------------------------------------------------------------------------------------------------------------------
	//VBy1 APHY  4K60 package must using PP mode for lane0~lane11, 4K120 package using LVDS mode for Lane2~Lane13
	//---------------------------------------------------------------------------------------------------------------------------------
	rtd_outl(0xb8000CC0, 0x00000000);	// Lane Power disable,
	rtd_outl(0xb8000C74, 0x80000000);	// GLOBAL_POW_EN(1),
	rtd_outl(0xb8000C00, 0x30030020);	// PI_A1(Phase16), PI_A2(Phase16), VBG,
	rtd_outl(0xb8000C04, 0x30030020);	// PI_B1(Phase16), PI_B2(Phase16),
	rtd_outl(0xb8000C08, 0x03080100);	// PI_AB(Phase0), LDO_1V = 0.988V, DIVB(1),
	rtd_outl(0xb8000C0C, 0x0005E3B0);	// Small KVCO, Bypass PI, CKREF_INV(0), PLL_ICP<2:0>, PLL_SC1, PLL_SC2, PLL_SR,
	rtd_outl(0xb8000C10, 0x0A001000);	// CK1X_INV(0), CK20X_INV(0), MACPLL_CKO_INV(0), PRESCALERDIV_LS(2), EPI_DIVM(7),
	rtd_outl(0xb8000C14, 0x00000000);	// Normal VCO, PLL Test PAD select, PLL_ICP<3>,
	rtd_outl(0xb8000C18, 0x00000002);	// TXPLL use LVDS/mLVDS feedback path,
	rtd_outl(0xb8000C20, 0x00000200);	// TXPLL_EN(1), TXPLL_RSTN(0),
	rtd_outl(0xb8000C50, 0x01D08000);	// IBN Current, VCM Level, LDO1V_EN(1), VCM_SHIFT_DOWN(0),
	rtd_outl(0xb8000C78, 0x00000000);	// CKIN_DIVN(2),

	//rtd_outl(0xb8000D00, 0x33002314); // Lane0 : LS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(17)
	//rtd_outl(0xb8000D10, 0x33002314); // Lane1 : LS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(17)
	rtd_outl(0xb8000D20, 0x33002314);	// Lane2 : LS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(17)
	rtd_outl(0xb8000D30, 0x33002314);	// Lane3 : LS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(17)
	rtd_outl(0xb8000D40, 0x33002314);	// Lane4 : LS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(17)
	rtd_outl(0xb8000D50, 0x33002314);	// Lane5 : LS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(17)
	rtd_outl(0xb8000D60, 0x33002314);	// Lane6 : LS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(17)
	rtd_outl(0xb8000D70, 0x33002314);	// Lane7 : LS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(17)
	rtd_outl(0xb8000D80, 0x33002314);	// Lane8 : LS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(17)
	rtd_outl(0xb8000D90, 0x33002314);	// Lane9 : LS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(17)
	rtd_outl(0xb8000DA0, 0x33002314);	// Lane10: LS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(17)
	rtd_outl(0xb8000DB0, 0x33002314);	// Lane11: LS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(17)
	rtd_outl(0xb8000DC0, 0x33002314);	// Lane12: LS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(17)
	rtd_outl(0xb8000DD0, 0x33002314);	// Lane13: LS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(17)
	//rtd_outl(0xb8000DE0, 0x33002314); // Lane14: LS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(17)
	//rtd_outl(0xb8000DF0, 0x33002314); // Lane15: LS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(17)
	//
	//
	//rtd_outl(0xb8000D04, 0x44000006); // Lane0 : CKMX_INV(0), IEM_EN(1), RT_EN(1), RP_EN(0), IEM_SEL,
	//rtd_outl(0xb8000D14, 0x44000006); // Lane1 : CKMX_INV(0), IEM_EN(1), RT_EN(1), RP_EN(0), IEM_SEL,
	rtd_outl(0xb8000D24, 0x44000006);	// Lane2 : CKMX_INV(0), IEM_EN(1), RT_EN(1), RP_EN(0), IEM_SEL,
	rtd_outl(0xb8000D34, 0x44000006);	// Lane3 : CKMX_INV(0), IEM_EN(1), RT_EN(1), RP_EN(0), IEM_SEL,
	rtd_outl(0xb8000D44, 0x44000006);	// Lane4 : CKMX_INV(0), IEM_EN(1), RT_EN(1), RP_EN(0), IEM_SEL,
	rtd_outl(0xb8000D54, 0x44000006);	// Lane5 : CKMX_INV(0), IEM_EN(1), RT_EN(1), RP_EN(0), IEM_SEL,
	rtd_outl(0xb8000D64, 0x44000006);	// Lane6 : CKMX_INV(0), IEM_EN(1), RT_EN(1), RP_EN(0), IEM_SEL,
	rtd_outl(0xb8000D74, 0x44000006);	// Lane7 : CKMX_INV(0), IEM_EN(1), RT_EN(1), RP_EN(0), IEM_SEL,
	rtd_outl(0xb8000D84, 0x44000006);	// Lane8 : CKMX_INV(0), IEM_EN(1), RT_EN(1), RP_EN(0), IEM_SEL,
	rtd_outl(0xb8000D94, 0x44000006);	// Lane9 : CKMX_INV(0), IEM_EN(1), RT_EN(1), RP_EN(0), IEM_SEL,
	rtd_outl(0xb8000DA4, 0x44000006);	// Lane10: CKMX_INV(0), IEM_EN(1), RT_EN(1), RP_EN(0), IEM_SEL,
	rtd_outl(0xb8000DB4, 0x44000006);	// Lane11: CKMX_INV(0), IEM_EN(1), RT_EN(1), RP_EN(0), IEM_SEL,
	rtd_outl(0xb8000DC4, 0x44000006);	// Lane12: CKMX_INV(0), IEM_EN(1), RT_EN(1), RP_EN(0), IEM_SEL,
	rtd_outl(0xb8000DD4, 0x44000006);	// Lane13: CKMX_INV(0), IEM_EN(1), RT_EN(1), RP_EN(0), IEM_SEL,
	//rtd_outl(0xb8000DE4, 0x44000006); // Lane14: CKMX_INV(0), IEM_EN(1), RT_EN(1), RP_EN(0), IEM_SEL,
	//rtd_outl(0xb8000DF4, 0x44000006); // Lane15: CKMX_INV(0), IEM_EN(1), RT_EN(1), RP_EN(0), IEM_SEL,

	//
	//rtd_outl(0xb8000D08, 0x0000000A); // Lane0 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(1), DRV_MODE_SEL(PP_MODE),
	//rtd_outl(0xb8000D18, 0x0000000A); // Lane1 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(1), DRV_MODE_SEL(PP_MODE),
	rtd_outl(0xb8000D28, 0x0000000A);	// Lane2 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(1), DRV_MODE_SEL(PP_MODE),
	rtd_outl(0xb8000D38, 0x0000000A);	// Lane3 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(1), DRV_MODE_SEL(PP_MODE),
	rtd_outl(0xb8000D48, 0x0000000A);	// Lane4 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(1), DRV_MODE_SEL(PP_MODE),
	rtd_outl(0xb8000D58, 0x0000000A);	// Lane5 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(1), DRV_MODE_SEL(PP_MODE),
	rtd_outl(0xb8000D68, 0x0000000A);	// Lane6 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(1), DRV_MODE_SEL(PP_MODE),
	rtd_outl(0xb8000D78, 0x0000000A);	// Lane7 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(1), DRV_MODE_SEL(PP_MODE),
	rtd_outl(0xb8000D88, 0x0000000A);	// Lane8 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(1), DRV_MODE_SEL(PP_MODE),
	rtd_outl(0xb8000D98, 0x0000000A);	// Lane9 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(1), DRV_MODE_SEL(PP_MODE),
	rtd_outl(0xb8000DA8, 0x0000000A);	// Lane10: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(1), DRV_MODE_SEL(PP_MODE),
	rtd_outl(0xb8000DB8, 0x0000000A);	// Lane11: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(1), DRV_MODE_SEL(PP_MODE),
	rtd_outl(0xb8000DC8, 0x0000000A);	// Lane12: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(1), DRV_MODE_SEL(PP_MODE),
	rtd_outl(0xb8000DD8, 0x0000000A);	// Lane13: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(1), DRV_MODE_SEL(PP_MODE),
	//rtd_outl(0xb8000DE8, 0x0000000A); // Lane14: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(1), DRV_MODE_SEL(PP_MODE),
	//rtd_outl(0xb8000DF8, 0x0000000A); // Lane15: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(1), DRV_MODE_SEL(PP_MODE),

	//---------------------------------------------------------------------------------------------------------------------------------
	//Initial Flow
	//--------------------------------------------------------------------------------------------------------------------------------
	// (1) DPLL Power Enable  (As above Script)
	//
	// (2) Wait DPLL stable at least 150us (SW Control)
	//
	// (3) Release DCLK Gating (SW Control)
	//
	// (4) TXPLL power up TXPLL during reset state (As above Script)
	//
	// (5) TXPLL reset release (Below Setting)
	rtd_part_outl(0xb8000C20, 10, 10, 0x1);
	//
	// (6) Wait TXPLL stable at least 150us (SW Control)
	//
	// (7) LVDS/mLVDS Clock Enable (Below Setting)
	rtd_outl(0xb802D9B8, 0x80000000);
	//
	// (8) LVDS MAC Enable (Below Setting)
	rtd_part_outl(0xb802D008, 7, 4, 0xC);
	//
	// (9) Enable Async FIFO,
	rtd_part_outl(0xb802DC94, 31, 31, 0x1);
	//
	// (10) APHY Lane Power Enable (Below Setting)
	if(QHB_Boot == false)
		rtd_outl(0xb8000CC0, 0x00003FFC);
	else{
		rtd_outl(0xb8000CC0, 0x0);
	}
	//
	// (11) Panel Power Enable (SW Control),

}
#endif
static void panel_lvds_tx(void)
{
    printf("\033[1;33m panel_lvds_tx \033[m\n");

    //---------------------------------------------------------------------------------------------------------------------------------
    //SFG: DH_ST_END = 0x008C080C, DTG_HS_Width = 16, DTG_VS_Width = 6
    //---------------------------------------------------------------------------------------------------------------------------------

    // ----------------------- Insert Dummy Line Function & Auto Config SFG Timing Gen -----------------------
    rtd_outl(0xb802D988, 0x40000000);	// bypass SFG disable[31], auto config sfg timing gen [30], insert dummy line[22:20]/[18:16]/[14:12]/[10:8], downsample v disable [0]

    // ----------------------- SFG Timing -----------------------
    rtd_outl(0xb802D900, 0x01101840);	// tcon_clk=dclk [27], sfg_clk=dclk [26], SFG_OSD path disable[25], SFG path enable [24],
    //fixed DTG last line hsync period [22], any to any subpixel disable [21], PIF clk selection epi/lvds [18],
    //pre rb swap disable[17], display 24bit RGB mode[13:12], dclk/aclk enable [6], post rb swap disable[5],
    rtd_outl(0xb802D9B8, 0x00000000);	// PIF clock enable / disable control (LVDS/LVDS[31], EPI[30], Vby1[29], Vby1 OSD[28], P2P[15], iSP[14], USIT[13]), Data inverse disable [16],
    rtd_outl(0xb802D950, 0x03170017);   //SN spec Dv_den_sta[13:0] = 23 Dv_den_end[29:16] = 768+23 //0x030A000A	// Dv_den_end[29:16] = 778, Dv_den_sta[13:0] = 10
    rtd_outl(0xb802D954, 0x05C60070);	// Dh_den_end[29:16] = 1478, Dh_den_sta[13:0] = 112
    rtd_outl(0xb802D958, 0x050F0C2F);	// Dv_width[31:24] = 5, Dh_width[23:16] = 15, Dh_total[12:0] = 3119
    rtd_outl(0xb802D99C, 0x0AAC0000);	// Final Line Length[28:16] = 2732
    rtd_outl(0xb802D9A0, 0x00000000);	// Residue_pix_split_mode[18:16], Final_addr_split_mode[12:0],
    rtd_outl(0xb802D9A4, 0x00700C28);	// hs_den_io_dist (auto config)[28:16], hs_io_dist (auto config)[12:0]
    rtd_outl(0xb802D98C, 0x00000000);	// hsync_width(auto config)[23:16], hsync_delay(auto config)[15:0]
    rtd_outl(0xb802D990, 0x00000300);	// Hs_distance (for DRD&RGB Split mode) [29:16], vsync_end(auto config)[15:8], vsync_start(auto config)[7:0]
    rtd_outl(0xb802D994, 0x00000000);	// sfg_dh_den_sta (auto config)[31:16], req_start (auto config)[15:0]

    // ------------------------ Force SFG Data as background color -------------------------
    rtd_outl(0xb802D928, 0x00000000);	// bypass sfg data[31], dif background R [29:30], G[19:10], B[9:0]
    rtd_outl(0xb802D904, 0x01FFF000);	// PIF_Clock = Dclk / (1+1) [27:24], Force A~P port to background enable [23][22]...[8]

    // ------------------------ SFG Control -------------------------
    rtd_outl(0xb802D964, 0x00000101);	// SFG normal mode[29:28], 1 pixel mode[17:16], 1+1 Segment[12:8], H-Flip disable[7], 1+1 Port[4:0]
    rtd_outl(0xb802D910, 0x00000003);	// CRC normal mode[31], CRC continuous mode [1], CRC control start[0]

    // -------------------------- Segment Setting ---------------------------
    rtd_outl(0xb802D968, 0x00000000);	// Seg 0 Start [28:16] = 0, Seg 1 Start [12:0] = 0
    rtd_outl(0xb802D998, 0x00000000);	// Segment 15~0 Flip [15][14]K[0]
    rtd_outl(0xb802DA94, 0x00000000);	// Line 0 last segment start [28:16] = 0, Line 1 last segment start [12:0] = 0
    rtd_outl(0xb802DA98, 0x00000000);	// Line 2 last segment start [28:16] = 0, Line 3 last segment start [12:0] = 0
    rtd_outl(0xb802DBE0, 0x00000000);	// Line 4 last segment start [28:16] = 0, Line 5 last segment start [12:0] = 0
    rtd_outl(0xb802DBE4, 0x00000000);	// Line 6 last segment start [28:16] = 0, Line 7 last segment start [12:0] = 0

    // -------------------------- Zig-Zag Mode ---------------------------
    rtd_outl(0xb802D92C, 0x00000000);	// 8n+0~8n+3 line ZZ mode control
    rtd_outl(0xb802DBA8, 0x00000000);	// 8n+4~8n+7 line ZZ mode control

    // -------------------------- Add Segment dummy front / back pixels or mid subpixel ---------------------------
    rtd_outl(0xb802D930, 0x00000000);	// Seg 0 / Seg 1 Line 0~3 front/back dummy pixel number
    rtd_outl(0xb802D9E8, 0x00000000);	// Seg 0 / Seg 1 place and number of middle dummy subpixel
    rtd_outl(0xb802DA1C, 0x00000000);	// front/back/middle dummy content [28], double buffer[20]

    // -------------------------- SFG_Pattern Generate ---------------------------
    rtd_outl(0xb802DBF0,0x0AA05F00);	// width[28:20] = 169+1, height[16:8] = 95+1, [5] pattern reset by hs, [3] rgb mode, [2:1] v color bar, [0] SFG ptn gen disable
    rtd_outl(0xb802DBF4,0x00FFFFFF);	// color bar 0 content W[31:24], R[23:16], G[15:8], B[7:0]
    rtd_outl(0xb802DBF8,0x00FFFF00);	// color bar 1 content W[31:24], R[23:16], G[15:8], B[7:0]
    rtd_outl(0xb802DBFC,0x0000FFFF);	// color bar 2 content W[31:24], R[23:16], G[15:8], B[7:0]
    rtd_outl(0xb802DC00,0x0000FF00);	// color bar 3 content W[31:24], R[23:16], G[15:8], B[7:0]
    rtd_outl(0xb802DC04,0x00FF00FF);	// color bar 4 content W[31:24], R[23:16], G[15:8], B[7:0]
    rtd_outl(0xb802DC08,0x00FF0000);	// color bar 5 content W[31:24], R[23:16], G[15:8], B[7:0]
    rtd_outl(0xb802DC0C,0x000000FF);	// color bar 6 content W[31:24], R[23:16], G[15:8], B[7:0]
    rtd_outl(0xb802DC10,0x00000000);	// color bar 7 content W[31:24], R[23:16], G[15:8], B[7:0]

    // -------------------------- PIF FIFO Control ---------------------------
    rtd_outl(0xb802DC94,0x00000000);	// PIF_FIFO disable[31], TX PHY LVDS/mLVDS mode[30:28]
    rtd_outl(0xb802DC98,0x9C00FFFF);	// PIF_FIFO auto reset enable [31] ,Lane 15~0 [15:0] enable / disable control
    rtd_outl(0xb802DC9C,0x654321FF);	// Lane 7~0 pair assign
    rtd_outl(0xb802DCA0,0xFFFFFFFF);	// Lane 15~8 pair assign
    rtd_outl(0xb802DCC8,0x00003FFC);	// 16 lane video[30:28], phy lane15~0 enable / disable control [15:0]
    rtd_outl(0xb802DCD0,0x000000FC);	// Lane 15~0  [15:0] PN swap disable / enable control

    rtd_part_outl(0xb802D900, 11, 11, 0x1);	// SFG out enable

    //---------------------------------------------------------------------------------------------------------------------------------
    //DISP_IF
    //---------------------------------------------------------------------------------------------------------------------------------
    rtd_outl(0xb802D008, 0x00005000);	// LVDS A/B Port Disable, LSB First, LVDS format use Table1,

    //---------------------------------------------------------------------------------------------------------------------------------
    //VBy1 APHY  4K60 package must using PP mode for lane0~lane11, 4K120 package using LVDS mode for Lane2~Lane13
    //---------------------------------------------------------------------------------------------------------------------------------
    rtd_outl(0xb8000CC0, 0x00000000);	// Lane Power disable,
    rtd_outl(0xb8000C74, 0x80000000);	// GLOBAL_POW_EN(1),
    rtd_outl(0xb8000C00, 0x30030020);	// PI_A1(Phase16), PI_A2(Phase16), VBG,
    rtd_outl(0xb8000C04, 0x30030020);	// PI_B1(Phase16), PI_B2(Phase16),
    rtd_outl(0xb8000C08, 0x03080100);	// PI_AB(Phase0), LDO_1V = 0.988V, DIVB(1),
    rtd_outl(0xb8000C0C, 0x0005E3B0);	// Small KVCO, Bypass PI, CKREF_INV(0), PLL_ICP<2:0>, PLL_SC1, PLL_SC2, PLL_SR,
    rtd_outl(0xb8000C10, 0x0A001000);	// CK1X_INV(0), CK20X_INV(0), MACPLL_CKO_INV(0), PRESCALERDIV_LS(2), EPI_DIVM(7),
    rtd_outl(0xb8000C14, 0x00000000);	// Normal VCO, PLL Test PAD select, PLL_ICP<3>,
    rtd_outl(0xb8000C18, 0x00000002);	// TXPLL use LVDS/mLVDS feedback path,
    rtd_outl(0xb8000C20, 0x00000200);	// TXPLL_EN(1), TXPLL_RSTN(0),
    rtd_outl(0xb8000C50, 0x01F48000);	// IBN Current, VCM Level, LDO1V_EN(1), VCM_SHIFT_DOWN(0),
    rtd_outl(0xb8000C78, 0x00000000);	// CKIN_DIVN(2),

    //rtd_outl(0xb8000D00, 0x33002314);	// Lane0 : LS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(17)
    //rtd_outl(0xb8000D10, 0x33002314);	// Lane1 : LS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(17)
    rtd_outl(0xb8000D20, 0x33002708);	// Lane2 : LS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(17)
    rtd_outl(0xb8000D30, 0x33002708);	// Lane3 : LS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(17)
    rtd_outl(0xb8000D40, 0x33002708);	// Lane4 : LS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(17)
    rtd_outl(0xb8000D50, 0x33002708);	// Lane5 : LS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(17)
    rtd_outl(0xb8000D60, 0x33002708);	// Lane6 : LS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(17)
    //rtd_outl(0xb8000D70, 0x33002314);	// Lane7 : LS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(17)
    //rtd_outl(0xb8000D80, 0x33002314);	// Lane8 : LS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(17)
    //rtd_outl(0xb8000D90, 0x33002314);	// Lane9 : LS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(17)
    //rtd_outl(0xb8000DA0, 0x33002314);	// Lane10: LS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(17)
    //rtd_outl(0xb8000DB0, 0x33002314);	// Lane11: LS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(17)
    //rtd_outl(0xb8000DC0, 0x33002314);	// Lane12: LS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(17)
    //rtd_outl(0xb8000DD0, 0x33002314);	// Lane13: LS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(17)
    //rtd_outl(0xb8000DE0, 0x33002314);	// Lane14: LS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(17)
    //rtd_outl(0xb8000DF0, 0x33002314);	// Lane15: LS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(17)
    //
    //
    //rtd_outl(0xb8000D04, 0x44000006);	// Lane0 : CKMX_INV(0), IEM_EN(1), RT_EN(1), RP_EN(0), IEM_SEL,
    //rtd_outl(0xb8000D14, 0x44000006);	// Lane1 : CKMX_INV(0), IEM_EN(1), RT_EN(1), RP_EN(0), IEM_SEL,
    rtd_outl(0xb8000D24, 0x44000003);	// Lane2 : CKMX_INV(0), IEM_EN(1), RT_EN(1), RP_EN(0), IEM_SEL,
    rtd_outl(0xb8000D34, 0x44000003);	// Lane3 : CKMX_INV(0), IEM_EN(1), RT_EN(1), RP_EN(0), IEM_SEL,
    rtd_outl(0xb8000D44, 0x44000003);	// Lane4 : CKMX_INV(0), IEM_EN(1), RT_EN(1), RP_EN(0), IEM_SEL,
    rtd_outl(0xb8000D54, 0x44000003);	// Lane5 : CKMX_INV(0), IEM_EN(1), RT_EN(1), RP_EN(0), IEM_SEL,
    rtd_outl(0xb8000D64, 0x44000003);	// Lane6 : CKMX_INV(0), IEM_EN(1), RT_EN(1), RP_EN(0), IEM_SEL,
    //rtd_outl(0xb8000D74, 0x44000006);	// Lane7 : CKMX_INV(0), IEM_EN(1), RT_EN(1), RP_EN(0), IEM_SEL,
    //rtd_outl(0xb8000D84, 0x44000006);	// Lane8 : CKMX_INV(0), IEM_EN(1), RT_EN(1), RP_EN(0), IEM_SEL,
    //rtd_outl(0xb8000D94, 0x44000006);	// Lane9 : CKMX_INV(0), IEM_EN(1), RT_EN(1), RP_EN(0), IEM_SEL,
    //rtd_outl(0xb8000DA4, 0x44000006);	// Lane10: CKMX_INV(0), IEM_EN(1), RT_EN(1), RP_EN(0), IEM_SEL,
    //rtd_outl(0xb8000DB4, 0x44000006);	// Lane11: CKMX_INV(0), IEM_EN(1), RT_EN(1), RP_EN(0), IEM_SEL,
    //rtd_outl(0xb8000DC4, 0x44000006);	// Lane12: CKMX_INV(0), IEM_EN(1), RT_EN(1), RP_EN(0), IEM_SEL,
    //rtd_outl(0xb8000DD4, 0x44000006);	// Lane13: CKMX_INV(0), IEM_EN(1), RT_EN(1), RP_EN(0), IEM_SEL,
    //rtd_outl(0xb8000DE4, 0x44000006);	// Lane14: CKMX_INV(0), IEM_EN(1), RT_EN(1), RP_EN(0), IEM_SEL,
    //rtd_outl(0xb8000DF4, 0x44000006);	// Lane15: CKMX_INV(0), IEM_EN(1), RT_EN(1), RP_EN(0), IEM_SEL,

    //
    //rtd_outl(0xb8000D08, 0x0000000A);	// Lane0 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(1), DRV_MODE_SEL(PP_MODE),
    //rtd_outl(0xb8000D18, 0x0000000A);	// Lane1 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(1), DRV_MODE_SEL(PP_MODE),
    rtd_outl(0xb8000D28, 0x0000000A);	// Lane2 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(1), DRV_MODE_SEL(PP_MODE),
    rtd_outl(0xb8000D38, 0x0000000A);	// Lane3 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(1), DRV_MODE_SEL(PP_MODE),
    rtd_outl(0xb8000D48, 0x0000000A);	// Lane4 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(1), DRV_MODE_SEL(PP_MODE),
    rtd_outl(0xb8000D58, 0x0000000A);	// Lane5 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(1), DRV_MODE_SEL(PP_MODE),
    rtd_outl(0xb8000D68, 0x0000000A);	// Lane6 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(1), DRV_MODE_SEL(PP_MODE),
    rtd_outl(0xb8000D78, 0x0000000A);	// Lane7 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(1), DRV_MODE_SEL(PP_MODE),
    rtd_outl(0xb8000D88, 0x0000000A);	// Lane8 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(1), DRV_MODE_SEL(PP_MODE),
    rtd_outl(0xb8000D98, 0x0000000A);	// Lane9 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(1), DRV_MODE_SEL(PP_MODE),
    rtd_outl(0xb8000DA8, 0x0000000A);	// Lane10: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(1), DRV_MODE_SEL(PP_MODE),
    rtd_outl(0xb8000DB8, 0x0000000A);	// Lane11: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(1), DRV_MODE_SEL(PP_MODE),
    rtd_outl(0xb8000DC8, 0x0000000A);	// Lane12: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(1), DRV_MODE_SEL(PP_MODE),
    rtd_outl(0xb8000DD8, 0x0000000A);	// Lane13: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(1), DRV_MODE_SEL(PP_MODE),
    //rtd_outl(0xb8000DE8, 0x0000000A);	// Lane14: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(1), DRV_MODE_SEL(PP_MODE),
    //rtd_outl(0xb8000DF8, 0x0000000A);	// Lane15: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(1), DRV_MODE_SEL(PP_MODE),

    //---------------------------------------------------------------------------------------------------------------------------------
    //Initial Flow
    //--------------------------------------------------------------------------------------------------------------------------------
    // (1) DPLL Power Enable  (As above Script)
    //
    // (2) Wait DPLL stable at least 150us (SW Control)
    //
    // (3) Release DCLK Gating (SW Control)
    //
    // (4) TXPLL power up TXPLL during reset state (As above Script)
    //
    // (5) TXPLL reset release (Below Setting)
    rtd_part_outl(0xb8000C20, 10, 10, 0x1);
    //
    // (6) Wait TXPLL stable at least 150us (SW Control)
    //
    // (7) LVDS/mLVDS Clock Enable (Below Setting)
    rtd_outl(0xb802D9B8, 0x80000000);
    //
    // (8) LVDS MAC Enable (Below Setting)
    rtd_part_outl(0xb802D008, 7, 4, 0xC);
    //
    // (9) Enable Async FIFO,
    rtd_part_outl(0xb802DC94, 31, 31, 0x1);
    //
    // (10) APHY Lane Power Enable (Below Setting)
	if(QHB_Boot == false)
		rtd_outl(0xb8000CC0, 0x00003FFC);
	else{
		rtd_outl(0xb8000CC0, 0x0);
	}
    //
    // (11) Panel Power Enable (SW Control),

}

static void panel_mLVDS_tx(void)
{
#if 0
	if(default_panel_parameter.iCONFIG_PANEL_CUSTOM_INDEX==P_MINI_LVDS_CSOT_PANEL){
		printf("Panel Custom Index : P_MINI_LVDS_CSOT_PANEL\n");
		panel_mLVDS_CSOT_tcon_setting();
	}else if(default_panel_parameter.iCONFIG_PANEL_CUSTOM_INDEX==P_MINI_LVDS_BOE_PANEL){
		printf("Panel Custom Index : P_MINI_LVDS_BOE_PANEL\n");
		panel_mLVDS_BOE_tcon_setting();
	}else
#endif
	if(default_panel_parameter.iCONFIG_PANEL_CUSTOM_INDEX==P_MINI_LVDS_SHARP_70_PANEL){
		printf("Panel Custom Index : P_MINI_LVDS_SHARP_70_PANEL\n");
		panel_mLVDS_Sharp_70_Inch_tcon_setting();
	}
	else if(default_panel_parameter.iCONFIG_PANEL_CUSTOM_INDEX==P_MINI_LVDS_CSOT_PANEL){
		printf("Panel Custom Index : P_MINI_LVDS_CSOT_PANEL\n");
		panel_mLVDS_CSOT_GOA_tcon_setting();
	}else{
		printf("Panel Custom Index : unknow\n");
		panel_mLVDS_BOE_default_tcon_tx();
	}
}

static void panel_epi_tx(void)
{
#if 0
	if(default_panel_parameter.iCONFIG_PANEL_CUSTOM_INDEX==P_EPI_LG_LC430DGG_UHD60_12LANE){
		printf("Panel Custom Index : P_EPI_LG_LC430DGG_UHD60_12LANE\n");
		panel_epi_lc430dgg_uhd60_12lane_tcon_setting();
	}else if(default_panel_parameter.iCONFIG_PANEL_CUSTOM_INDEX==P_EPI_LG_LC550DGG_UHD60_12LANE){
		printf("Panel Custom Index : P_EPI_LG_LC550EGG_UHD60_12LANE\n");
		panel_epi_lc550dgg_uhd60_12lane_tcon_setting();
	}else if(default_panel_parameter.iCONFIG_PANEL_CUSTOM_INDEX==P_EPI_LG_LC430EGG_UHD60_6LANE){
		printf("Panel Custom Index : P_EPI_LG_LC430EGG_UHD60_6LANE\n");
		panel_epi_lc430egg_uhd60_6lane_tcon_setting();
	}else
#endif
	if(default_panel_parameter.iCONFIG_PANEL_CUSTOM_INDEX==P_EPI_LG_LC550EGG_UHD60_6LANE){
		printf("Panel Custom Index : P_EPI_LG_LC550EGG_UHD60_6LANE\n");
		panel_epi_lc550egg_uhd60_6lane_tcon_setting();
	} else if(default_panel_parameter.iCONFIG_PANEL_CUSTOM_INDEX==P_EPI_LG_LC490EGG_UHD60_6LANE){
		printf("Panel Custom Index : P_EPI_LG_LC490EGG_UHD60_6LANE\n");
		panel_epi_lc490egg_uhd60_6lane_tcon_setting();
	} else if(default_panel_parameter.iCONFIG_PANEL_CUSTOM_INDEX == P_EPI_LG_V18_65INCH_UHD60_8LANE){
		printf("Panel Custom Index : P_EPI_LG_V18_65INCH_UHD60_8LANE\n");
		panel_epi_v18_65inch_uhd60_8lane_tcon_setting();
	} else if(default_panel_parameter.iCONFIG_PANEL_CUSTOM_INDEX == P_EPI_LG_V20_49INCH_UHD60_6LANE){
		printf("Panel Custom Index : P_EPI_LG_V20_49INCH_UHD60_6LANE\n");
		panel_epi_v20_49inch_uhd60_6lane_tcon_setting();
	}
#if 0
	else{
		printf("Panel Custom Index : unknow\n");
		panel_epi_lc430dgg_uhd60_12lane_tcon_setting();
	}
#endif
}

static void panel_vby1_to_lvds_tx(void)
{
       printf("\033[1;33m panel_vby1_to_lvds_tx \033[m\n");
	//---------------------------------------------------------------------------------------------------------------------------------
	//SFG: DH_ST_END = 0x01181018, DTG_HS_Width = 32, DTG_VS_Width = 12
	//------------------------------------------------------------------------------------------------------------------------------
	rtd_outl(0xb802D900, 0x01140040);	// [27]=0:TCON_clk_div=1,[26]=SFG_clk_div=1, path enable, Common fifo use vby1_clk, 30-bit Mode, SFG out disable,
					        // Remove last too short dhs, any to any sub-pixel assign disable,
	rtd_outl(0xb802D904, 0x00FFF000);	// PIF_Clock = Dclk, Force to background enable,
	rtd_outl(0xb802D910, 0x00000003);	// CRC Enable,
	rtd_outl(0xb802D928, 0x00000000);	// PIF Forcre to BG disable,
	rtd_outl(0xb802D92C, 0x00000000);	// Line 8n+0/8n+1/8n+2/8n+3 not sub-pixel shift,
	rtd_outl(0xb802DBA8, 0x00000000);	// Line 8n+4/8n+5/8n+6/8n+7 not sub-pixel shift,
	rtd_outl(0xb802D930, 0x00000000);	// SEG0/SEG1 No front/back dummy pixel,
	//rtd_outl(0xb802D934, 0x00000000);	// SEG2/SEG3 No front/back dummy pixel,
	//rtd_outl(0xb802D938, 0x00000000);	// SEG4/SEG5 No front/back dummy pixel,
	//rtd_outl(0xb802D940, 0x00000000);	// SEG6/SEG7 No front/back dummy pixel,
	//rtd_outl(0xb802D944, 0x00000000);	// SEG8/SEG9 No front/back dummy pixel,
	//rtd_outl(0xb802D948, 0x00000000);	// SEG10/SEG11 No front/back dummy pixel,
	//rtd_outl(0xb802DB08, 0x00000000);	// SEG12/SEG13 No front/back dummy pixel,
	//rtd_outl(0xb802DB0C, 0x00000000);	// SEG14/SEG15 No front/back dummy pixel,
	rtd_outl(0xb802D950, 0x089D002D);	// DV_Den_end,DV_Den_sta, (follow DTG timing)
	rtd_outl(0xb802D954, 0x10180118);	// DH_Den_end,DH_Den_sta, (follow DTG timing)
	rtd_outl(0xb802D958, 0x057F112F);	// DV_width,Dh_width,Dh_total (follow DTG timing)
if(default_panel_parameter.iCONFIG_PANEL_CUSTOM_INDEX == VBY_ONE_PANEL_4K2K_TO_HDMI_2K1K)
	rtd_outl(0xb802D964, 0x00000003);	// SFG Normal Mode, 1.5 packet mode disable, H-Flip disable, 1-SEG, 4-Port, data shift enable
else
	rtd_outl(0xb802D964, 0x80000003);	// SFG Normal Mode, 1.5 packet mode disable, H-Flip disable, 1-SEG, 4-Port, data shift enable
	rtd_outl(0xb802D968, 0x00000000);	// SEG0/SEG1 Start Address,
	//rtd_outl(0xb802D96C, 0x00000000);	// SEG2/SEG3 Start Address,
	//rtd_outl(0xb802D970, 0x00000000);	// SEG4/SEG5 Start Address,
	//rtd_outl(0xb802D974, 0x00000000);	// SEG6/SEG7 Start Address,
	//rtd_outl(0xb802D978, 0x00000000);	// SEG8/SEG9 Start Address,
	//rtd_outl(0xb802D97C, 0x00000000);	// SEG10/SEG11 Start Address,
	//rtd_outl(0xb802DB00, 0x00000000);	// SEG12/SEG13 Start Address,
	//rtd_outl(0xb802DB04, 0x00000000);	// SEG14/SEG15 Start Address,
	//rtd_outl(0xb802D980, 0x00000000);	// Front dummy line(4N+0) data0,
	//rtd_outl(0xb802D984, 0x00000000);	// Front dummy line(4N+1) data1,
	//rtd_outl(0xb802D94C, 0x00000000);	// Front dummy line(4N+2) data2,
	//rtd_outl(0xb802DA28, 0x00000000);	// Front dummy line(4N+3) data3,
	//rtd_outl(0xb802DA24, 0x00000000);	// dummuy line data select,
	rtd_outl(0xb802D988, 0x40000001);	// Bypass SFG disable, Auto config enable, downsample enable, dummy ine disable,
	rtd_outl(0xb802D990, 0x00000300);	// Hs_distance, Vsync Start/End,
	rtd_outl(0xb802D998, 0x00000000);	// Segement-flip Disable,
	rtd_outl(0xb802D99C, 0x1E000000);	// Final line length,
	rtd_outl(0xb802D9A0, 0x00000000);	// Residue_pix_split_mode, Final_addr_split_mode,
	rtd_outl(0xb802D9A4, 0x01181128);	// hs_den_io_dist, hs_io_dist,
	rtd_outl(0xb802D9B8, 0x00000000);	// All PIF Clock disable, Data inverse disable,[31]lvds, [30]epi/cmpi, [29]vby1, [28]vby1OSD, [15]p2p, [14]isp
	rtd_outl(0xb802D9E8, 0x00000000);	// SEG0/SEG1 No middle dummy sub-pixel,
	//rtd_outl(0xb802D9EC, 0x00000000);	// SEG2/SEG3 No middle dummy sub-pixel,
	//rtd_outl(0xb802D9F0, 0x00000000);	// SEG4/SEG5 No middle dummy sub-pixel,
	//rtd_outl(0xb802D9F4, 0x00000000);	// SEG6/SEG7 No middle dummy sub-pixel,
	//rtd_outl(0xb802D9F8, 0x00000000);	// SEG8/SEG9 No middle dummy sub-pixel,
	//rtd_outl(0xb802D9FC, 0x00000000);	// SEG10/SEG11 No middle dummy sub-pixel,
	//rtd_outl(0xb802DB10, 0x00000000);	// SEG12/SEG13 No middle dummy sub-pixel,
	//rtd_outl(0xb802DB14, 0x00000000);	// SEG14/SEG15 No middle dummy sub-pixel,
	rtd_outl(0xb802DA08, 0x81000000);	// Active_pixel_RGB, ext_num use fw mode, unit is sub-pixel,
	//rtd_outl(0xb802DA0C, 0x00000000);	// G-dummy sub-pixel for line 8n+0, G-dummy data select from SFG input,
	//rtd_outl(0xb802DA10, 0x00000000);	// G-dummy sub-pixel for line 8n+1,
	//rtd_outl(0xb802DA14, 0x00000000);	// G-dummy sub-pixel for line 8n+2,
	//rtd_outl(0xb802DA18, 0x00000000);	// G-dummy sub-pixel for line 8n+3,
	//rtd_outl(0xb802DBAC, 0x00000000);	// G-dummy sub-pixel for line 8n+4,
	//rtd_outl(0xb802DBB0, 0x00000000);	// G-dummy sub-pixel for line 8n+5,
	//rtd_outl(0xb802DBB4, 0x00000000);	// G-dummy sub-pixel for line 8n+6,
	//rtd_outl(0xb802DBB8, 0x00000000);	// G-dummy sub-pixel for line 8n+7,
	rtd_outl(0xb802DA1C, 0x00000000);	// dummy_pixel_data is black,
	rtd_outl(0xb802DA94, 0x00000000);	// Last_seg_start, last_seg_start_res for line 4n+0/1,
	rtd_outl(0xb802DA98, 0x00000000);	// Last_seg_start, last_seg_start_res for line 4n+2/3,
	rtd_outl(0xb802DBE0, 0x00000000);	// Last_seg_start, last_seg_start_res for line 4n+4/5,
	rtd_outl(0xb802DBE4, 0x00000000);	// Last_seg_start, last_seg_start_res for line 4n+6/7,
	//rtd_outl(0xb802DAA0, 0x02020202);	// DRD Data Mapping,
	//rtd_outl(0xb802DAA4, 0x04040404);	// DRD Data Mapping,
	//rtd_outl(0xb802DAA8, 0x00000000);	// DRD Data Mapping,
	//rtd_outl(0xb802DAAC, 0x08080808);	// DRD Data Mapping,
	//rtd_outl(0xb802DAB0, 0x06060606);	// DRD Data Mapping,
	//rtd_outl(0xb802DAB4, 0x0E0E0E0E);	// DRD Data Mapping,
	//rtd_outl(0xb802DAB8, 0x0A0A0A0A);	// DRD Data Mapping,
	//rtd_outl(0xb802DABC, 0x0C0C0C0C);	// DRD Data Mapping,
	//rtd_outl(0xb802DAC0, 0x10101010);	// DRD Data Mapping,
	//rtd_outl(0xb802DAC4, 0x12121212);	// DRD Data Mapping,
	//rtd_outl(0xb802DAC8, 0x14141414);	// DRD Data Mapping,
	//rtd_outl(0xb802DACC, 0x16161616);	// DRD Data Mapping,
	//rtd_outl(0xb802DAD0, 0x01010101);	// DRD Data Mapping,
	//rtd_outl(0xb802DAD4, 0x03030303);	// DRD Data Mapping,
	//rtd_outl(0xb802DAD8, 0x05050505);	// DRD Data Mapping,
	//rtd_outl(0xb802DADC, 0x07070707);	// DRD Data Mapping,
	//rtd_outl(0xb802DAE0, 0x0B0B0B0B);	// DRD Data Mapping,
	//rtd_outl(0xb802DAE4, 0x0D0D0D0D);	// DRD Data Mapping,
	//rtd_outl(0xb802DAE8, 0x09090909);	// DRD Data Mapping,
	//rtd_outl(0xb802DAEC, 0x11111111);	// DRD Data Mapping,
	//rtd_outl(0xb802DAF0, 0x0F0F0F0F);	// DRD Data Mapping,
	//rtd_outl(0xb802DAF4, 0x17171717);	// DRD Data Mapping,
	//rtd_outl(0xb802DAF8, 0x13131313);	// DRD Data Mapping,
	//rtd_outl(0xb802DAFC, 0x15151515);	// DRD Data Mapping,
	//rtd_outl(0xb802DB68, 0x00000000);	// ext_num setting for case_a line7~0,
	//rtd_outl(0xb802DB6C, 0x00000000);	// ext_num setting for case_b line7~0,
	//rtd_outl(0xb802DB78, 0x00000000);	// Virtual data_0/1 for G-dummy line 8n+0,
	//rtd_outl(0xb802DB7C, 0x00000000);	// Virtual data_0/1 for G-dummy line 8n+1,
	//rtd_outl(0xb802DB80, 0x00000000);	// Virtual data_0/1 for G-dummy line 8n+2,
	//rtd_outl(0xb802DB84, 0x00000000);	// Virtual data_0/1 for G-dummy line 8n+3,
	//rtd_outl(0xb802DB88, 0x00000000);	// Virtual data_0/1 for G-dummy line 8n+4,
	//rtd_outl(0xb802DB8C, 0x00000000);	// Virtual data_0/1 for G-dummy line 8n+5,
	//rtd_outl(0xb802DB90, 0x00000000);	// Virtual data_0/1 for G-dummy line 8n+6,
	//rtd_outl(0xb802DB94, 0x00000000);	// Virtual data_0/1 for G-dummy line 8n+7,
	rtd_outl(0xb802DBF0, 0x1DF10E00);	// SFG Pattern Gen. Disable, RGB Mode, Width = 480, Hight = 270, pattern reset by hs,
	rtd_outl(0xb802DBF4, 0x00FFFFFF);	// SFG Pattern Gen. R/G/B/W Color for Bar0,
	rtd_outl(0xb802DBF8, 0x00FFFF00);	// SFG Pattern Gen. R/G/B/W Color for Bar1,
	rtd_outl(0xb802DBFC, 0x0000FFFF);	// SFG Pattern Gen. R/G/B/W Color for Bar2,
	rtd_outl(0xb802DC00, 0x0000FF00);	// SFG Pattern Gen. R/G/B/W Color for Bar3,
	rtd_outl(0xb802DC04, 0x00FF00FF);	// SFG Pattern Gen. R/G/B/W Color for Bar4,
	rtd_outl(0xb802DC08, 0x00FF0000);	// SFG Pattern Gen. R/G/B/W Color for Bar5,
	rtd_outl(0xb802DC0C, 0x000000FF);	// SFG Pattern Gen. R/G/B/W Color for Bar6,
	rtd_outl(0xb802DC10, 0x00000000);	// SFG Pattern Gen. R/G/B/W Color for Bar7,
	//rtd_outl(0xb802DC14, 0x00000000);	// SFG Pattern Gen. gray_data0 and gray_data1 for manmal pattern,
	//rtd_outl(0xb802DC18, 0x00000000);	// SFG Pattern Gen. manmal pattern sub-pixel data select for line 4n+0,
	//rtd_outl(0xb802DC1C, 0x00000000);	// SFG Pattern Gen. manmal pattern sub-pixel data select for line 4n+1,
	//rtd_outl(0xb802DC20, 0x00000000);	// SFG Pattern Gen. manmal pattern sub-pixel data select for line 4n+2,
	//rtd_outl(0xb802DC24, 0x00000000);	// SFG Pattern Gen. manmal pattern sub-pixel data select for line 4n+3,
	rtd_outl(0xb802DC94, 0x10000000);	// Aysnc FIFO disble, Async FIFO use Vby1 Mode,
	rtd_outl(0xb802DC98, 0x9C0000FF);	// 15~0 Lane_en
#if defined (Config_Package_type_BGA_27x27) || defined(CONFIG_VBY1LANE_FROM_0_TO_7)
	rtd_outl(0xb802DC9C, 0x76541320);	// Lane 7~0 pair assign,  2K using lane2~lane14 for LSphy
	rtd_outl(0xb802DCA0, 0xFFFFFFFF);	// Lane 15~8 pair assign,  2K using lane2~lane14 for LSphy
	rtd_outl(0xb802DCC8, 0x000000FF);	// VIDEO_OSD_SEL 16lane video, phy lane7~lane0 enable
#else
	rtd_outl(0xb802DC9C, 0x1320FFFF);	// Lane 7~0 pair assign,  2K using lane2~lane14 for LSphy
	rtd_outl(0xb802DCA0, 0xFFFF1320);	// Lane 15~8 pair assign,  2K using lane2~lane14 for LSphy
	rtd_outl(0xb802DCC8, 0x00000FF0);	// VIDEO_OSD_SEL 16lane video, phy lane14~lane2 enable
#endif
	rtd_outl(0xb802DCD0, 0x00000000);	// P/N Swap enable ,
	rtd_part_outl(0xb802D900, 11, 11, 0x1);	// SFG out enable,

	//---------------------------------------------------------------------------------------------------------------------------------
	//LOCKN, HPTDN Pin share
	//---------------------------------------------------------------------------------------------------------------------------------
	rtd_maskl(0xb8000818, 0xFFFF0FFF, 0x00002000);	// GPIO_26 pinshare to vby1_htpd_src0,
	rtd_maskl(0xb800081C, 0x0FFFFFFF, 0x10000000);	// GPIO_28 pinshare to vby1_lock_src0,
	rtd_maskl(0xb8000CBC, 0xFFFFFFC3, 0x00000000);	// VBy1_HPTDN/VBy1_LOCKN use vby1_htpd_src0/vby1_lock_src0,
	rtd_maskl(0xb8000824, 0xE7FFFFFF, 0x00000000);	// GPIO_28/GPIO_26 use 3.3V GPI,

	//---------------------------------------------------------------------------------------------------------------------------------
	//VBy1 MAC
	//---------------------------------------------------------------------------------------------------------------------------------
	rtd_outl(0xb802D700, 0x00300000); 	// VBy1_MAC_CLK = dclk/8,
	rtd_outl(0xb802D704, 0x00000004); 	// VBy1 4-Byte Mode,
	rtd_outl(0xb802D708, 0x00000000); 	// 24-bit ctrl_bit,
	rtd_outl(0xb802D70C, 0x6AC00000); 	// VBy1 disable, PLL for lclk is stable, debounce count for HTPDN/LOCKN is 16-xtal,
						// Send BE before ALN, don't send BS after ALN finish,
	rtd_outl(0xb802D714, 0x00000000); 	// 3D Flag Disable,
	rtd_outl(0xb802D718, 0x00FF0003); 	// CRC Continuous Mode Enable for All lane,
	rtd_outl(0xb802D730, 0x00000000); 	// HTPDN/LOCKN use HW Mode, DE Only Mode Disable,
	rtd_outl(0xb802D758, 0xC001FFFF);	  // 8B10B and Scrambler Enable, set 8B10/scrambler initial state,

	rtd_outl(0xb802D774, 0x0000005);  //disable,meta_sta;
	rtd_outl(0xb802D778, 0x1000009);  //start by HVsync, meta_end;
	//rtd_outl(0xb802D78C, 0x0000000);  // meta_data1
	//rtd_outl(0xb802D790, 0x0000000);  // meta_data2
	//rtd_outl(0xb802D794, 0x0000000);  // meta_data3
	//rtd_outl(0xb802D798, 0x0000000);  // meta_data4
	//rtd_outl(0xb802D79C, 0x0000000);  // meta_data5
	//rtd_outl(0xb802D7A0, 0x0000000);  // meta_data6
	//rtd_outl(0xb802D7A4, 0x0000000);  // meta_data7
	//rtd_outl(0xb802D7A8, 0x0000000);  // meta_data8
	//rtd_outl(0xb802D7AC, 0x0000000);  // meta_data9
	//rtd_outl(0xb802D7B0, 0x0000000);  // meta_data10
	//rtd_outl(0xb802D7B4, 0x0000000);  // meta_data11
	//rtd_outl(0xb802D7B8, 0x0000000);  // meta_data12
	//rtd_outl(0xb802D7BC, 0x0000000);  // meta_data13
	//rtd_outl(0xb802D7C0, 0x0000000);  // meta_data14
	//rtd_outl(0xb802D7C4, 0x0000000);  // meta_data15
	//rtd_outl(0xb802D7C8, 0x0000000);  // meta_data16
	//rtd_outl(0xb802D7CC, 0x0000000);  // meta_data17
	//rtd_outl(0xb802D7D0, 0x0000000);  // meta_data18
	//rtd_outl(0xb802D7D4, 0x0000000);  // meta_data19
	//rtd_outl(0xb802D7D8, 0x0000000);  // meta_data20
	//rtd_outl(0xb802D7DC, 0x0000000);  // meta_data21
	//rtd_outl(0xb802D7E0, 0x0000000);  // meta_data22
	//rtd_outl(0xb802D7E4, 0x0000000);  // meta_data23
	//rtd_outl(0xb802D7E8, 0x0000000);  // meta_data24
	//rtd_outl(0xb802D7EC, 0x0000000);  // meta_data25
	//rtd_outl(0xb802D7F0, 0x0000000);  // meta_data26
	//rtd_outl(0xb802D7F4, 0x0000000);  // meta_data27
	//rtd_outl(0xb802D7F8, 0x0000000);  // meta_data28
	//rtd_outl(0xb802D7FC, 0x0000000);  // meta_data29

	//---------------------------------------------------------------------------------------------------------------------------------
	//DISP_IF
	//---------------------------------------------------------------------------------------------------------------------------------
	//rtd_outl(0xb802D02C, 0x00000001);	// Async FIFO use VBy1 Mode,
	//rtd_outl(0xb802D030, 0x00000000);	// P/N Swap disable,
	//rtd_outl(0xb802D038, 0x00000000);	// Async FIFO disable,
	//rtd_outl(0xb802D03C, 0x00030010);	// Async FIFO reset enable, adaptive reset, apply after 16-clock,
	//rtd_outl(0xb802D060, 0x00010203);	// Lane 0~3 pair assign,
	//rtd_outl(0xb802D064, 0x04050607);	// Lane 4~7 pair assign,
	//rtd_outl(0xb802D068, 0xFFFFFFFF);	// Lane 8~11 pair assign,

	//---------------------------------------------------------------------------------------------------------------------------------
	//PIF_APHY
	//---------------------------------------------------------------------------------------------------------------------------------
	rtd_outl(0xb8000CC0, 0x00000000);	// Lane Power disable,
	rtd_outl(0xb8000C74, 0x80000000);	// GLOBAL_POW_EN(1),
	rtd_outl(0xb8000C00, 0x30030020);	// PI_A1(Phase16), PI_A2(Phase16), VBG,
	rtd_outl(0xb8000C04, 0x30030020);	// PI_B1(Phase16), PI_B2(Phase16),
	rtd_outl(0xb8000C08, 0x03080100);	// PI_AB(Phase0), LDO_1V = 0.988V, DIVB(1),
	rtd_outl(0xb8000C0C, 0x8000E4B0);	// Big KVCO, Bypass PI, CKREF_INV(0), PLL_ICP<2:0>, PLL_SC1, PLL_SC2, PLL_SR,
	rtd_outl(0xb8000C10, 0x00000000);	// CK1X_INV(0), CK20X_INV(0), MACPLL_CKO_INV(0), PRESCALERDIV_HS(1),
	rtd_outl(0xb8000C14, 0x00000001);	// Normal VCO, PLL Test PAD select, PLL_ICP<3>,
	rtd_outl(0xb8000C18, 0x00000020);	// TXPLL use VBy1 feedback path, MACPLL_DIVM(4),
	rtd_outl(0xb8000C20, 0x00000200);	// TXPLL_EN(1), TXPLL_RSTN(0),
	rtd_outl(0xb8000C50, 0x01F48000);	// IBN Current, VCM Level, LDO1V_EN(1), VCM_SHIFT_DOWN(0),
	rtd_outl(0xb8000C78, 0x00000E00);	// CKIN_DIVN(16),
	//
	//
#if defined (Config_Package_type_BGA_27x27) || defined(CONFIG_VBY1LANE_FROM_0_TO_7)
	rtd_outl(0xb8000D00, 0x66002815);	// Lane0 : HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	rtd_outl(0xb8000D10, 0x66002815);	// Lane1 : HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	rtd_outl(0xb8000D20, 0x66002815);	// Lane2 : HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	rtd_outl(0xb8000D30, 0x66002815);	// Lane3 : HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
#else
	rtd_outl(0xb8000D00, 0x77002815);	// Lane0 : Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	rtd_outl(0xb8000D10, 0x77002815);	// Lane1 : Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	rtd_outl(0xb8000D20, 0x77002815);	// Lane2 : Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	rtd_outl(0xb8000D30, 0x77002815);	// Lane3 : Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
#endif
	rtd_outl(0xb8000D40, 0x66002815);	// Lane4 : HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	rtd_outl(0xb8000D50, 0x66002815);	// Lane5 : HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	rtd_outl(0xb8000D60, 0x66002815);	// Lane6 : HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	rtd_outl(0xb8000D70, 0x66002815);	// Lane7 : HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
#if defined (Config_Package_type_BGA_27x27) || defined(CONFIG_VBY1LANE_FROM_0_TO_7)
	rtd_outl(0xb8000D80, 0x77002815);	// Lane8 : Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	rtd_outl(0xb8000D90, 0x77002815);	// Lane9 : Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	rtd_outl(0xb8000DA0, 0x77002815);	// Lane10: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	rtd_outl(0xb8000DB0, 0x77002815);	// Lane11: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
#else
	rtd_outl(0xb8000D80, 0x66002815);	// Lane8 : HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	rtd_outl(0xb8000D90, 0x66002815);	// Lane9 : HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	rtd_outl(0xb8000DA0, 0x66002815);	// Lane10: HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	rtd_outl(0xb8000DB0, 0x66002815);	// Lane11: HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
#endif
	rtd_outl(0xb8000DC0, 0x77002815);	// Lane12: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	rtd_outl(0xb8000DD0, 0x77002815);	// Lane13: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	rtd_outl(0xb8000DE0, 0x77002815);	// Lane14: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	rtd_outl(0xb8000DF0, 0x77002815);	// Lane15: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	//
	rtd_outl(0xb8000D04, 0x44003006);	// Lane0 : CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000D14, 0x44003006);	// Lane1 : CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000D24, 0x44003006);	// Lane2 : CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000D34, 0x44003006);	// Lane3 : CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000D44, 0x44003006);	// Lane4 : CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000D54, 0x44003006);	// Lane5 : CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000D64, 0x44003006);	// Lane6 : CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000D74, 0x44003006);	// Lane7 : CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000D84, 0x44003006);	// Lane8 : CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000D94, 0x44003006);	// Lane9 : CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000DA4, 0x44003006);	// Lane10: CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000DB4, 0x44003006);	// Lane11: CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000DC4, 0x44003006);	// Lane12: CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000DD4, 0x44003006);	// Lane13: CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000DE4, 0x44003006);	// Lane14: CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000DF4, 0x44003006);	// Lane15: CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
#if defined (Config_Package_type_BGA_27x27) || defined(CONFIG_VBY1LANE_FROM_0_TO_7)
	rtd_outl(0xb8000D08, 0x00000009);	// Lane0 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000D18, 0x00000009);	// Lane1 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000D28, 0x00000009);	// Lane2 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000D38, 0x00000009);	// Lane3 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
#else
	//
	//rtd_outl(0xb8000D08, 0x00000009);	// Lane0 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	//rtd_outl(0xb8000D18, 0x00000009);	// Lane1 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	//rtd_outl(0xb8000D28, 0x00000009);	// Lane2 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	//rtd_outl(0xb8000D38, 0x00000009);	// Lane3 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
#endif
	rtd_outl(0xb8000D48, 0x00000009);	// Lane4 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000D58, 0x00000009);	// Lane5 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000D68, 0x00000009);	// Lane6 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000D78, 0x00000009);	// Lane7 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
#if defined (Config_Package_type_BGA_27x27) || defined(CONFIG_VBY1LANE_FROM_0_TO_7)
	//rtd_outl(0xb8000D88, 0x00000009);	// Lane8 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	//rtd_outl(0xb8000D98, 0x00000009);	// Lane9 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	//rtd_outl(0xb8000DA8, 0x00000009);	// Lane10: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	//rtd_outl(0xb8000DB8, 0x00000009);	// Lane11: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
#else
	rtd_outl(0xb8000D88, 0x00000009);	// Lane8 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000D98, 0x00000009);	// Lane9 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000DA8, 0x00000009);	// Lane10: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000DB8, 0x00000009);	// Lane11: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
#endif
	//rtd_outl(0xb8000DC8, 0x00000009);	// Lane12: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	//rtd_outl(0xb8000DD8, 0x00000009);	// Lane13: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	//rtd_outl(0xb8000DE8, 0x00000009);	// Lane14: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	//rtd_outl(0xb8000DF8, 0x00000009);	// Lane15: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),


	//---------------------------------------------------------------------------------------------------------------------------------
	//Initial Flow
	//--------------------------------------------------------------------------------------------------------------------------------
	// (1) DPLL Power Enable  (As above Script)
	//
	// (2) Wait DPLL stable at least 150us (SW Control)
	//
	// (3) Release DCLK Gating (SW Control)
	//
	// (4) TXPLL power up TXPLL during reset state (As above Script)
	//
	// (5) TXPLL reset release (Below Setting)
	rtd_part_outl(0xb8000C20, 10, 10, 0x1);
	//
	// (6) Wait TXPLL stable at least 150us (SW Control)
	//
	// (7) VBy1 Clock Enable (Below Setting)
	rtd_outl(0xb802D9B8, 0x20000000); //[31]lvds, [30]epi/cmpi, [29]vby1, [28]vby1OSD, [15]p2p, [14]isp
	//
	// (8) VBy1 MAC Enable (Below Setting)
	rtd_part_outl(0xb802D70C, 31, 31, 0x1);
	//
	// (9) Enable Async FIFO,
	rtd_part_outl(0xb802DC94, 31, 31, 0x1);
	//rtd_outl(0xb802D038, 0x00000001);
	//
	// (10) APHY Lane Power Enable (Below Setting)
#if defined (Config_Package_type_BGA_27x27) || defined(CONFIG_VBY1LANE_FROM_0_TO_7)
	rtd_outl(0xb8000CC0, 0x000000FF);
#else
	rtd_outl(0xb8000CC0, 0x00000FF0);
#endif
	//
	// (11) Panel Power Enable (SW Control)
}

static void panel_vby1_tx(void)
{
    printf("\033[1;33m panel_vby1_tx \033[m\n");

	//---------------------------------------------------------------------------------------------------------------------------------
	//SFG: DH_ST_END = 0x01181018, DTG_HS_Width = 32, DTG_VS_Width = 12
	//---------------------------------------------------------------------------------------------------------------------------------
	rtd_outl(0xb802D900, 0x01140040);	// [27]=0:TCON_clk_div=1,[26]=SFG_clk_div=1, path enable, Common fifo use vby1_clk, 30-bit Mode, SFG out disable,
						// Remove last too short dhs, any to any sub-pixel assign disable,
	rtd_outl(0xb802D904, 0x00FFF000);	// PIF_Clock = Dclk, Force to background enable,
	rtd_outl(0xb802D910, 0x00000003);	// CRC Enable,
	rtd_outl(0xb802D928, 0x00000000);	// PIF Forcre to BG disable,
	rtd_outl(0xb802D92C, 0x00000000);	// Line 8n+0/8n+1/8n+2/8n+3 not sub-pixel shift,
	rtd_outl(0xb802DBA8, 0x00000000);	// Line 8n+4/8n+5/8n+6/8n+7 not sub-pixel shift,
	rtd_outl(0xb802D930, 0x00000000);	// SEG0/SEG1 No front/back dummy pixel,
	//rtd_outl(0xb802D934, 0x00000000); // SEG2/SEG3 No front/back dummy pixel,
	//rtd_outl(0xb802D938, 0x00000000); // SEG4/SEG5 No front/back dummy pixel,
	//rtd_outl(0xb802D940, 0x00000000); // SEG6/SEG7 No front/back dummy pixel,
	//rtd_outl(0xb802D944, 0x00000000); // SEG8/SEG9 No front/back dummy pixel,
	//rtd_outl(0xb802D948, 0x00000000); // SEG10/SEG11 No front/back dummy pixel,
	//rtd_outl(0xb802DB08, 0x00000000); // SEG12/SEG13 No front/back dummy pixel,
	//rtd_outl(0xb802DB0C, 0x00000000); // SEG14/SEG15 No front/back dummy pixel,
	rtd_outl(0xb802D950, 0x089D002D);	// DV_Den_end,DV_Den_sta, (follow DTG timing)
	rtd_outl(0xb802D954, 0x10180118);	// DH_Den_end,DH_Den_sta, (follow DTG timing)
	rtd_outl(0xb802D958, 0x057F112F);	// DV_width,Dh_width,Dh_total (follow DTG timing)
	rtd_outl(0xb802D964, 0x00000007);	// SFG Normal Mode, 1.5 packet mode disable,1 pixel mode, H-Flip disable, 1-SEG, 8-Port,
	rtd_outl(0xb802D968, 0x00000000);	// SEG0/SEG1 Start Address,
	//rtd_outl(0xb802D96C, 0x00000000); // SEG2/SEG3 Start Address,
	//rtd_outl(0xb802D970, 0x00000000); // SEG4/SEG5 Start Address,
	//rtd_outl(0xb802D974, 0x00000000); // SEG6/SEG7 Start Address,
	//rtd_outl(0xb802D978, 0x00000000); // SEG8/SEG9 Start Address,
	//rtd_outl(0xb802D97C, 0x00000000); // SEG10/SEG11 Start Address,
	//rtd_outl(0xb802DB00, 0x00000000); // SEG12/SEG13 Start Address,
	//rtd_outl(0xb802DB04, 0x00000000); // SEG14/SEG15 Start Address,
	//rtd_outl(0xb802D980, 0x00000000); // Front dummy line(4N+0) data0,
	//rtd_outl(0xb802D984, 0x00000000); // Front dummy line(4N+1) data1,
	//rtd_outl(0xb802D94C, 0x00000000); // Front dummy line(4N+2) data2,
	//rtd_outl(0xb802DA28, 0x00000000); // Front dummy line(4N+3) data3,
	//rtd_outl(0xb802DA24, 0x00000000); // dummuy line data select,
	rtd_outl(0xb802D988, 0x40000000);	// Bypass SFG disable, Auto config enable, downsample disable, dummy ine disable,
	rtd_outl(0xb802D990, 0x00000300);	// Hs_distance, Vsync Start/End,
	rtd_outl(0xb802D998, 0x00000000);	// Segement-flip Disable,
	rtd_outl(0xb802D99C, 0x0F000000);	// Final line length,
	rtd_outl(0xb802D9A0, 0x00000000);	// Residue_pix_split_mode, Final_addr_split_mode,
	rtd_outl(0xb802D9A4, 0x01181128);	// hs_den_io_dist, hs_io_dist,
	rtd_outl(0xb802D9B8, 0x00000000);	// All PIF Clock disable, Data inverse disable,[31]lvds, [30]epi/cmpi, [29]vby1, [28]vby1OSD, [15]p2p, [14]isp
	rtd_outl(0xb802D9E8, 0x00000000);	// SEG0/SEG1 No middle dummy sub-pixel,
	//rtd_outl(0xb802D9EC, 0x00000000); // SEG2/SEG3 No middle dummy sub-pixel,
	//rtd_outl(0xb802D9F0, 0x00000000); // SEG4/SEG5 No middle dummy sub-pixel,
	//rtd_outl(0xb802D9F4, 0x00000000); // SEG6/SEG7 No middle dummy sub-pixel,
	//rtd_outl(0xb802D9F8, 0x00000000); // SEG8/SEG9 No middle dummy sub-pixel,
	//rtd_outl(0xb802D9FC, 0x00000000); // SEG10/SEG11 No middle dummy sub-pixel,
	//rtd_outl(0xb802DB10, 0x00000000); // SEG12/SEG13 No middle dummy sub-pixel,
	//rtd_outl(0xb802DB14, 0x00000000); // SEG14/SEG15 No middle dummy sub-pixel,
	rtd_outl(0xb802DA08, 0x81000000);	// Active_pixel_RGB, ext_num use fw mode, unit is sub-pixel,
	//rtd_outl(0xb802DA0C, 0x00000000); // G-dummy sub-pixel for line 8n+0, G-dummy data select from SFG input,
	//rtd_outl(0xb802DA10, 0x00000000); // G-dummy sub-pixel for line 8n+1,
	//rtd_outl(0xb802DA14, 0x00000000); // G-dummy sub-pixel for line 8n+2,
	//rtd_outl(0xb802DA18, 0x00000000); // G-dummy sub-pixel for line 8n+3,
	//rtd_outl(0xb802DBAC, 0x00000000); // G-dummy sub-pixel for line 8n+4,
	//rtd_outl(0xb802DBB0, 0x00000000); // G-dummy sub-pixel for line 8n+5,
	//rtd_outl(0xb802DBB4, 0x00000000); // G-dummy sub-pixel for line 8n+6,
	//rtd_outl(0xb802DBB8, 0x00000000); // G-dummy sub-pixel for line 8n+7,
	rtd_outl(0xb802DA1C, 0x00000000);	// dummy_pixel_data is black,
	rtd_outl(0xb802DA94, 0x00000000);	// Last_seg_start, last_seg_start_res for line 4n+0/1,
	rtd_outl(0xb802DA98, 0x00000000);	// Last_seg_start, last_seg_start_res for line 4n+2/3,
	rtd_outl(0xb802DBE0, 0x00000000);	// Last_seg_start, last_seg_start_res for line 4n+4/5,
	rtd_outl(0xb802DBE4, 0x00000000);	// Last_seg_start, last_seg_start_res for line 4n+6/7,
	//rtd_outl(0xb802DAA0, 0x02020202); // DRD Data Mapping,
	//rtd_outl(0xb802DAA4, 0x04040404); // DRD Data Mapping,
	//rtd_outl(0xb802DAA8, 0x00000000); // DRD Data Mapping,
	//rtd_outl(0xb802DAAC, 0x08080808); // DRD Data Mapping,
	//rtd_outl(0xb802DAB0, 0x06060606); // DRD Data Mapping,
	//rtd_outl(0xb802DAB4, 0x0E0E0E0E); // DRD Data Mapping,
	//rtd_outl(0xb802DAB8, 0x0A0A0A0A); // DRD Data Mapping,
	//rtd_outl(0xb802DABC, 0x0C0C0C0C); // DRD Data Mapping,
	//rtd_outl(0xb802DAC0, 0x10101010); // DRD Data Mapping,
	//rtd_outl(0xb802DAC4, 0x12121212); // DRD Data Mapping,
	//rtd_outl(0xb802DAC8, 0x14141414); // DRD Data Mapping,
	//rtd_outl(0xb802DACC, 0x16161616); // DRD Data Mapping,
	//rtd_outl(0xb802DAD0, 0x01010101); // DRD Data Mapping,
	//rtd_outl(0xb802DAD4, 0x03030303); // DRD Data Mapping,
	//rtd_outl(0xb802DAD8, 0x05050505); // DRD Data Mapping,
	//rtd_outl(0xb802DADC, 0x07070707); // DRD Data Mapping,
	//rtd_outl(0xb802DAE0, 0x0B0B0B0B); // DRD Data Mapping,
	//rtd_outl(0xb802DAE4, 0x0D0D0D0D); // DRD Data Mapping,
	//rtd_outl(0xb802DAE8, 0x09090909); // DRD Data Mapping,
	//rtd_outl(0xb802DAEC, 0x11111111); // DRD Data Mapping,
	//rtd_outl(0xb802DAF0, 0x0F0F0F0F); // DRD Data Mapping,
	//rtd_outl(0xb802DAF4, 0x17171717); // DRD Data Mapping,
	//rtd_outl(0xb802DAF8, 0x13131313); // DRD Data Mapping,
	//rtd_outl(0xb802DAFC, 0x15151515); // DRD Data Mapping,
	//rtd_outl(0xb802DB68, 0x00000000); // ext_num setting for case_a line7~0,
	//rtd_outl(0xb802DB6C, 0x00000000); // ext_num setting for case_b line7~0,
	//rtd_outl(0xb802DB78, 0x00000000); // Virtual data_0/1 for G-dummy line 8n+0,
	//rtd_outl(0xb802DB7C, 0x00000000); // Virtual data_0/1 for G-dummy line 8n+1,
	//rtd_outl(0xb802DB80, 0x00000000); // Virtual data_0/1 for G-dummy line 8n+2,
	//rtd_outl(0xb802DB84, 0x00000000); // Virtual data_0/1 for G-dummy line 8n+3,
	//rtd_outl(0xb802DB88, 0x00000000); // Virtual data_0/1 for G-dummy line 8n+4,
	//rtd_outl(0xb802DB8C, 0x00000000); // Virtual data_0/1 for G-dummy line 8n+5,
	//rtd_outl(0xb802DB90, 0x00000000); // Virtual data_0/1 for G-dummy line 8n+6,
	//rtd_outl(0xb802DB94, 0x00000000); // Virtual data_0/1 for G-dummy line 8n+7,
	rtd_outl(0xb802DBF0, 0x1DF10E00);	// SFG Pattern Gen. Disable, RGB Mode, Width = 480, Hight = 270, pattern reset by hs,
	rtd_outl(0xb802DBF4, 0x00FFFFFF);	// SFG Pattern Gen. R/G/B/W Color for Bar0,
	rtd_outl(0xb802DBF8, 0x00FFFF00);	// SFG Pattern Gen. R/G/B/W Color for Bar1,
	rtd_outl(0xb802DBFC, 0x0000FFFF);	// SFG Pattern Gen. R/G/B/W Color for Bar2,
	rtd_outl(0xb802DC00, 0x0000FF00);	// SFG Pattern Gen. R/G/B/W Color for Bar3,
	rtd_outl(0xb802DC04, 0x00FF00FF);	// SFG Pattern Gen. R/G/B/W Color for Bar4,
	rtd_outl(0xb802DC08, 0x00FF0000);	// SFG Pattern Gen. R/G/B/W Color for Bar5,
	rtd_outl(0xb802DC0C, 0x000000FF);	// SFG Pattern Gen. R/G/B/W Color for Bar6,
	rtd_outl(0xb802DC10, 0x00000000);	// SFG Pattern Gen. R/G/B/W Color for Bar7,
	//rtd_outl(0xb802DC14, 0x00000000); // SFG Pattern Gen. gray_data0 and gray_data1 for manmal pattern,
	//rtd_outl(0xb802DC18, 0x00000000); // SFG Pattern Gen. manmal pattern sub-pixel data select for line 4n+0,
	//rtd_outl(0xb802DC1C, 0x00000000); // SFG Pattern Gen. manmal pattern sub-pixel data select for line 4n+1,
	//rtd_outl(0xb802DC20, 0x00000000); // SFG Pattern Gen. manmal pattern sub-pixel data select for line 4n+2,
	//rtd_outl(0xb802DC24, 0x00000000); // SFG Pattern Gen. manmal pattern sub-pixel data select for line 4n+3,
	rtd_outl(0xb802DC94, 0x10000000);	// Aysnc FIFO disble, Async FIFO use Vby1 Mode,
	rtd_outl(0xb802DC98, 0x9C0000FF);	// 15~0 Lane_en
#if defined (Config_Package_type_BGA_27x27) || defined(CONFIG_VBY1LANE_FROM_0_TO_7)
	rtd_outl(0xb802DC9C, 0x76543210);	// Lane 7~0 pair assign,  2K using lane2~lane14 for LSphy
	rtd_outl(0xb802DCA0, 0xFFFFFFFF);	// Lane 15~8 pair assign,  2K using lane2~lane14 for LSphy
	rtd_outl(0xb802DCC8, 0x000000FF);	// VIDEO_OSD_SEL 16lane video, phy lane7~lane0 enable
#else
	rtd_outl(0xb802DC9C, 0x3210FFFF);	// Lane 7~0 pair assign,  2K using lane2~lane14 for LSphy
	rtd_outl(0xb802DCA0, 0xFFFF7654);	// Lane 15~8 pair assign,  2K using lane2~lane14 for LSphy
	rtd_outl(0xb802DCC8, 0x00000FF0);	// VIDEO_OSD_SEL 16lane video, phy lane14~lane2 enable
#endif
	rtd_outl(0xb802DCD0, 0x00000000);	// P/N Swap enable ,
	rtd_part_outl(0xb802D900, 11, 11, 0x1); // SFG out enable,

	//---------------------------------------------------------------------------------------------------------------------------------
	//LOCKN, HPTDN Pin share
	//---------------------------------------------------------------------------------------------------------------------------------
	rtd_maskl(0xb8000818, 0xFFFF0FFF, 0x00002000);	// GPIO_26 pinshare to vby1_htpd_src0,
	rtd_maskl(0xb800081C, 0x0FFFFFFF, 0x10000000);	// GPIO_28 pinshare to vby1_lock_src0,
	rtd_maskl(0xb8000CBC, 0xFFFFFFC3, 0x00000000);	// VBy1_HPTDN/VBy1_LOCKN use vby1_htpd_src0/vby1_lock_src0,
	rtd_maskl(0xb8000824, 0xE7FFFFFF, 0x00000000);	// GPIO_28/GPIO_26 use 3.3V GPI,

	//---------------------------------------------------------------------------------------------------------------------------------
	//VBy1 MAC
	//---------------------------------------------------------------------------------------------------------------------------------
	rtd_outl(0xb802D700, 0x00300000);	// VBy1_MAC_CLK = dclk/8,
	rtd_outl(0xb802D704, 0x00000004);	// VBy1 4-Byte Mode,
	rtd_outl(0xb802D708, 0x00000000);	// 24-bit ctrl_bit,
	rtd_outl(0xb802D70C, 0x6AC00000);	// VBy1 disable, PLL for lclk is stable, debounce count for HTPDN/LOCKN is 16-xtal,
						// Send BE before ALN, don't send BS after ALN finish,
	rtd_outl(0xb802D714, 0x00000000);	// 3D Flag Disable,
	rtd_outl(0xb802D718, 0x00FF0003);	// CRC Continuous Mode Enable for All lane,
	rtd_outl(0xb802D730, 0x00000000);	// HTPDN/LOCKN use HW Mode, DE Only Mode Disable,
	rtd_outl(0xb802D758, 0xC001FFFF);	  // 8B10B and Scrambler Enable, set 8B10/scrambler initial state,

	rtd_outl(0xb802D774, 0x0000005);  //disable,meta_sta;
	rtd_outl(0xb802D778, 0x1000009);  //start by HVsync, meta_end;
	//rtd_outl(0xb802D78C, 0x0000000);	// meta_data1
	//rtd_outl(0xb802D790, 0x0000000);	// meta_data2
	//rtd_outl(0xb802D794, 0x0000000);	// meta_data3
	//rtd_outl(0xb802D798, 0x0000000);	// meta_data4
	//rtd_outl(0xb802D79C, 0x0000000);	// meta_data5
	//rtd_outl(0xb802D7A0, 0x0000000);	// meta_data6
	//rtd_outl(0xb802D7A4, 0x0000000);	// meta_data7
	//rtd_outl(0xb802D7A8, 0x0000000);	// meta_data8
	//rtd_outl(0xb802D7AC, 0x0000000);	// meta_data9
	//rtd_outl(0xb802D7B0, 0x0000000);	// meta_data10
	//rtd_outl(0xb802D7B4, 0x0000000);	// meta_data11
	//rtd_outl(0xb802D7B8, 0x0000000);	// meta_data12
	//rtd_outl(0xb802D7BC, 0x0000000);	// meta_data13
	//rtd_outl(0xb802D7C0, 0x0000000);	// meta_data14
	//rtd_outl(0xb802D7C4, 0x0000000);	// meta_data15
	//rtd_outl(0xb802D7C8, 0x0000000);	// meta_data16
	//rtd_outl(0xb802D7CC, 0x0000000);	// meta_data17
	//rtd_outl(0xb802D7D0, 0x0000000);	// meta_data18
	//rtd_outl(0xb802D7D4, 0x0000000);	// meta_data19
	//rtd_outl(0xb802D7D8, 0x0000000);	// meta_data20
	//rtd_outl(0xb802D7DC, 0x0000000);	// meta_data21
	//rtd_outl(0xb802D7E0, 0x0000000);	// meta_data22
	//rtd_outl(0xb802D7E4, 0x0000000);	// meta_data23
	//rtd_outl(0xb802D7E8, 0x0000000);	// meta_data24
	//rtd_outl(0xb802D7EC, 0x0000000);	// meta_data25
	//rtd_outl(0xb802D7F0, 0x0000000);	// meta_data26
	//rtd_outl(0xb802D7F4, 0x0000000);	// meta_data27
	//rtd_outl(0xb802D7F8, 0x0000000);	// meta_data28
	//rtd_outl(0xb802D7FC, 0x0000000);	// meta_data29

	//---------------------------------------------------------------------------------------------------------------------------------
	//DISP_IF
	//---------------------------------------------------------------------------------------------------------------------------------
	//rtd_outl(0xb802D02C, 0x00000001); // Async FIFO use VBy1 Mode,
	//rtd_outl(0xb802D030, 0x00000000); // P/N Swap disable,
	//rtd_outl(0xb802D038, 0x00000000); // Async FIFO disable,
	//rtd_outl(0xb802D03C, 0x00030010); // Async FIFO reset enable, adaptive reset, apply after 16-clock,
	//rtd_outl(0xb802D060, 0x00010203); // Lane 0~3 pair assign,
	//rtd_outl(0xb802D064, 0x04050607); // Lane 4~7 pair assign,
	//rtd_outl(0xb802D068, 0xFFFFFFFF); // Lane 8~11 pair assign,

	//---------------------------------------------------------------------------------------------------------------------------------
	//PIF_APHY
	//---------------------------------------------------------------------------------------------------------------------------------
	rtd_outl(0xb8000CC0, 0x00000000);	// Lane Power disable,
	rtd_outl(0xb8000C74, 0x80000000);	// GLOBAL_POW_EN(1),
	rtd_outl(0xb8000C00, 0x30030020);	// PI_A1(Phase16), PI_A2(Phase16), VBG,
	rtd_outl(0xb8000C04, 0x30030020);	// PI_B1(Phase16), PI_B2(Phase16),
	rtd_outl(0xb8000C08, 0x03080100);	// PI_AB(Phase0), LDO_1V = 0.988V, DIVB(1),
	rtd_outl(0xb8000C0C, 0x8000E4B0);	// Big KVCO, Bypass PI, CKREF_INV(0), PLL_ICP<2:0>, PLL_SC1, PLL_SC2, PLL_SR,
	rtd_outl(0xb8000C10, 0x00000000);	// CK1X_INV(0), CK20X_INV(0), MACPLL_CKO_INV(0), PRESCALERDIV_HS(1),
	rtd_outl(0xb8000C14, 0x00000001);	// Normal VCO, PLL Test PAD select, PLL_ICP<3>,
	rtd_outl(0xb8000C18, 0x00000020);	// TXPLL use VBy1 feedback path, MACPLL_DIVM(4),
	rtd_outl(0xb8000C20, 0x00000200);	// TXPLL_EN(1), TXPLL_RSTN(0),
	rtd_outl(0xb8000C50, 0x01F48000);	// IBN Current, VCM Level, LDO1V_EN(1), VCM_SHIFT_DOWN(0),
	rtd_outl(0xb8000C78, 0x00000E00);	// CKIN_DIVN(16),
	//
#if defined (Config_Package_type_BGA_27x27) || defined(CONFIG_VBY1LANE_FROM_0_TO_7)
	rtd_outl(0xb8000D00, 0x66002815);	// Lane0 : HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	rtd_outl(0xb8000D10, 0x66002815);	// Lane1 : HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	rtd_outl(0xb8000D20, 0x66002815);	// Lane2 : HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	rtd_outl(0xb8000D30, 0x66002815);	// Lane3 : HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
#else
	rtd_outl(0xb8000D00, 0x77002815);	// Lane0 : Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	rtd_outl(0xb8000D10, 0x77002815);	// Lane1 : Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	rtd_outl(0xb8000D20, 0x77002815);	// Lane2 : Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	rtd_outl(0xb8000D30, 0x77002815);	// Lane3 : Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
#endif
	rtd_outl(0xb8000D40, 0x66002815);	// Lane4 : HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	rtd_outl(0xb8000D50, 0x66002815);	// Lane5 : HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	rtd_outl(0xb8000D60, 0x66002815);	// Lane6 : HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	rtd_outl(0xb8000D70, 0x66002815);	// Lane7 : HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
#if defined (Config_Package_type_BGA_27x27) || defined(CONFIG_VBY1LANE_FROM_0_TO_7)
	rtd_outl(0xb8000D80, 0x77002815);	// Lane8 : Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	rtd_outl(0xb8000D90, 0x77002815);	// Lane9 : Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	rtd_outl(0xb8000DA0, 0x77002815);	// Lane10: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	rtd_outl(0xb8000DB0, 0x77002815);	// Lane11: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
#else
	rtd_outl(0xb8000D80, 0x66002815);	// Lane8 : HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	rtd_outl(0xb8000D90, 0x66002815);	// Lane9 : HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	rtd_outl(0xb8000DA0, 0x66002815);	// Lane10: HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	rtd_outl(0xb8000DB0, 0x66002815);	// Lane11: HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
#endif
	rtd_outl(0xb8000DC0, 0x77002815);	// Lane12: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	rtd_outl(0xb8000DD0, 0x77002815);	// Lane13: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	rtd_outl(0xb8000DE0, 0x77002815);	// Lane14: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	rtd_outl(0xb8000DF0, 0x77002815);	// Lane15: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	//
	rtd_outl(0xb8000D04, 0x44003006);	// Lane0 : CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000D14, 0x44003006);	// Lane1 : CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000D24, 0x44003006);	// Lane2 : CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000D34, 0x44003006);	// Lane3 : CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000D44, 0x44003006);	// Lane4 : CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000D54, 0x44003006);	// Lane5 : CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000D64, 0x44003006);	// Lane6 : CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000D74, 0x44003006);	// Lane7 : CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000D84, 0x44003006);	// Lane8 : CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000D94, 0x44003006);	// Lane9 : CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000DA4, 0x44003006);	// Lane10: CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000DB4, 0x44003006);	// Lane11: CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000DC4, 0x44003006);	// Lane12: CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000DD4, 0x44003006);	// Lane13: CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000DE4, 0x44003006);	// Lane14: CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000DF4, 0x44003006);	// Lane15: CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	//
#if defined (Config_Package_type_BGA_27x27) || defined(CONFIG_VBY1LANE_FROM_0_TO_7)
	rtd_outl(0xb8000D08, 0x00000009);	// Lane0 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000D18, 0x00000009);	// Lane1 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000D28, 0x00000009);	// Lane2 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000D38, 0x00000009);	// Lane3 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
#else
	//
	//rtd_outl(0xb8000D08, 0x00000009); // Lane0 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	//rtd_outl(0xb8000D18, 0x00000009); // Lane1 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	//rtd_outl(0xb8000D28, 0x00000009); // Lane2 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	//rtd_outl(0xb8000D38, 0x00000009); // Lane3 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
#endif
	rtd_outl(0xb8000D48, 0x00000009);	// Lane4 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000D58, 0x00000009);	// Lane5 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000D68, 0x00000009);	// Lane6 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000D78, 0x00000009);	// Lane7 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
#if defined (Config_Package_type_BGA_27x27) || defined(CONFIG_VBY1LANE_FROM_0_TO_7)
	//rtd_outl(0xb8000D88, 0x00000009); // Lane8 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	//rtd_outl(0xb8000D98, 0x00000009); // Lane9 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	//rtd_outl(0xb8000DA8, 0x00000009); // Lane10: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	//rtd_outl(0xb8000DB8, 0x00000009); // Lane11: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
#else
	rtd_outl(0xb8000D88, 0x00000009);	// Lane8 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000D98, 0x00000009);	// Lane9 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000DA8, 0x00000009);	// Lane10: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000DB8, 0x00000009);	// Lane11: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
#endif
	//rtd_outl(0xb8000DC8, 0x00000009); // Lane12: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	//rtd_outl(0xb8000DD8, 0x00000009); // Lane13: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	//rtd_outl(0xb8000DE8, 0x00000009); // Lane14: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	//rtd_outl(0xb8000DF8, 0x00000009); // Lane15: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),

	//---------------------------------------------------------------------------------------------------------------------------------
	//Initial Flow
	//--------------------------------------------------------------------------------------------------------------------------------
	// (1) DPLL Power Enable  (As above Script)
	//
	// (2) Wait DPLL stable at least 150us (SW Control)
	//
	// (3) Release DCLK Gating (SW Control)
	//
	// (4) TXPLL power up TXPLL during reset state (As above Script)
	//
	// (5) TXPLL reset release (Below Setting)
	rtd_part_outl(0xb8000C20, 10, 10, 0x1);
	//
	// (6) Wait TXPLL stable at least 150us (SW Control)
	//
	// (7) VBy1 Clock Enable (Below Setting)
	rtd_outl(0xb802D9B8, 0x20000000); //[31]lvds, [30]epi/cmpi, [29]vby1, [28]vby1OSD, [15]p2p, [14]isp
	//
	// (8) VBy1 MAC Enable (Below Setting)
	rtd_part_outl(0xb802D70C, 31, 31, 0x1);
	//
	// (9) Enable Async FIFO,
	rtd_part_outl(0xb802DC94, 31, 31, 0x1);
	//rtd_outl(0xb802D038, 0x00000001);
	//
	// (10) APHY Lane Power Enable (Below Setting)
#if defined (Config_Package_type_BGA_27x27) || defined(CONFIG_VBY1LANE_FROM_0_TO_7)
	if(QHB_Boot == false)
		rtd_outl(0xb8000CC0, 0x000000FF);
	else{
		rtd_outl(0xb8000CC0, 0x0);
		printf("=Bypass lane power Enable under QHB_Boot case=\n");
	}
#else
	if(QHB_Boot == false)
		rtd_outl(0xb8000CC0, 0x00000FF0);
	else{
		rtd_outl(0xb8000CC0, 0x0);
		printf("=Bypass lane power Enable under QHB_Boot case=\n");
	}

#endif
	//
	// (11) Panel Power Enable (SW Control)

}

static void panel_vby1_4k120_tx(void)
{
	printf("=== panel_vby1_4k120_tx ===\n");

	//---------------------------------------------------------------------------------------------------------------------------------
	//SFG: DH_ST_END = 0x01181018, DTG_HS_Width = 32, DTG_VS_Width = 12
	//---------------------------------------------------------------------------------------------------------------------------------
	rtd_outl(0xb802D900, 0x01140040);	// SFG path enable, Common fifo use vby1_clk, 30-bit Mode, SFG out disable,
						// Remove last too short dhs, any to any sub-pixel assign disable,
	rtd_outl(0xb802D904, 0x00FFFF00);	// PIF_Clock = Dclk, Force to background enable,
	rtd_outl(0xb802D910, 0x00000003);	// CRC Enable,
	rtd_outl(0xb802D928, 0x00000000);	// PIF Forcre to BG disable,
	rtd_outl(0xb802D92C, 0x00000000);	// Line 8n+0/8n+1/8n+2/8n+3 not sub-pixel shift,
	rtd_outl(0xb802DBA8, 0x00000000);	// Line 8n+4/8n+5/8n+6/8n+7 not sub-pixel shift,
	rtd_outl(0xb802D930, 0x00000000);	// SEG0/SEG1 No front/back dummy pixel,
	//rtd_outl(0xb802D934, 0x00000000); // SEG2/SEG3 No front/back dummy pixel,
	//rtd_outl(0xb802D938, 0x00000000); // SEG4/SEG5 No front/back dummy pixel,
	//rtd_outl(0xb802D940, 0x00000000); // SEG6/SEG7 No front/back dummy pixel,
	//rtd_outl(0xb802D944, 0x00000000); // SEG8/SEG9 No front/back dummy pixel,
	//rtd_outl(0xb802D948, 0x00000000); // SEG10/SEG11 No front/back dummy pixel,
	//rtd_outl(0xb802DB08, 0x00000000); // SEG12/SEG13 No front/back dummy pixel,
	//rtd_outl(0xb802DB0C, 0x00000000); // SEG14/SEG15 No front/back dummy pixel,
	rtd_outl(0xb802D950, 0x089D002D);	// DV_Den_end,DV_Den_sta, (follow DTG timing)
	rtd_outl(0xb802D954, 0x080C008C);	// DH_Den_end,DH_Den_sta, (follow DTG timing)
	rtd_outl(0xb802D958, 0x053F0897);	// DV_width,Dh_width,Dh_total (follow DTG timing)
	if(default_panel_parameter.iCONFIG_SFG_SEG_NUM == 1){
		rtd_outl(0xb802D964, 0x0001000f);	// SFG Normal Mode, 1.5 packet mode disable, 2 pixel mode, H-Flip disable, 1-SEG, 16-Port,
		rtd_outl(0xb802D968, 0x00000000);	// SEG0/SEG1 Start Address,
	}else if(default_panel_parameter.iCONFIG_SFG_SEG_NUM == 2){
		rtd_outl(0xb802D964, 0x0001010f);	// SFG Normal Mode, 1.5 packet mode disable, 2 pixel mode, H-Flip disable, 1-SEG, 16-Port,
		rtd_outl(0xb802D968, 0x00000780);	// SEG0/SEG1 Start Address,
	}else{
		rtd_outl(0xb802D964, 0x0001010f);	// SFG Normal Mode, 1.5 packet mode disable, 2 pixel mode, H-Flip disable, 1-SEG, 16-Port,
		rtd_outl(0xb802D968, 0x00000780);	// SEG0/SEG1 Start Address,
	}
	//rtd_outl(0xb802D96C, 0x00000000); // SEG2/SEG3 Start Address,
	//rtd_outl(0xb802D970, 0x00000000); // SEG4/SEG5 Start Address,
	//rtd_outl(0xb802D974, 0x00000000); // SEG6/SEG7 Start Address,
	//rtd_outl(0xb802D978, 0x00000000); // SEG8/SEG9 Start Address,
	//rtd_outl(0xb802D97C, 0x00000000); // SEG10/SEG11 Start Address,
	//rtd_outl(0xb802DB00, 0x00000000); // SEG12/SEG13 Start Address,
	//rtd_outl(0xb802DB04, 0x00000000); // SEG14/SEG15 Start Address,
	//rtd_outl(0xb802D980, 0x00000000); // Front dummy line(4N+0) data0,
	//rtd_outl(0xb802D984, 0x00000000); // Front dummy line(4N+1) data1,
	//rtd_outl(0xb802D94C, 0x00000000); // Front dummy line(4N+2) data2,
	//rtd_outl(0xb802DA28, 0x00000000); // Front dummy line(4N+3) data3,
	//rtd_outl(0xb802DA24, 0x00000000); // dummuy line data select,
	rtd_outl(0xb802D988, 0x40000000);	// Bypass SFG disable, Auto config enable, downsample disable, dummy ine disable,
	rtd_outl(0xb802D990, 0x00000300);	// Hs_distance, Vsync Start/End,
	rtd_outl(0xb802D998, 0x00000000);	// Segement-flip Disable,
	rtd_outl(0xb802D99C, 0x07800000);	// Final line length,
	rtd_outl(0xb802D9A0, 0x00000000);	// Residue_pix_split_mode, Final_addr_split_mode,
	rtd_outl(0xb802D9A4, 0x008C0894);	// hs_den_io_dist, hs_io_dist,
	rtd_outl(0xb802D9B8, 0x00000000);	// All PIF Clock disable, Data inverse disable,[31]lvds, [30]epi/cmpi, [29]vby1, [28]vby1OSD, [15]p2p, [14]isp
	rtd_outl(0xb802D9E8, 0x00000000);	// SEG0/SEG1 No middle dummy sub-pixel,
	//rtd_outl(0xb802D9EC, 0x00000000); // SEG2/SEG3 No middle dummy sub-pixel,
	//rtd_outl(0xb802D9F0, 0x00000000); // SEG4/SEG5 No middle dummy sub-pixel,
	//rtd_outl(0xb802D9F4, 0x00000000); // SEG6/SEG7 No middle dummy sub-pixel,
	//rtd_outl(0xb802D9F8, 0x00000000); // SEG8/SEG9 No middle dummy sub-pixel,
	//rtd_outl(0xb802D9FC, 0x00000000); // SEG10/SEG11 No middle dummy sub-pixel,
	//rtd_outl(0xb802DB10, 0x00000000); // SEG12/SEG13 No middle dummy sub-pixel,
	//rtd_outl(0xb802DB14, 0x00000000); // SEG14/SEG15 No middle dummy sub-pixel,
	rtd_outl(0xb802DA08, 0x81000000);	// Active_pixel_RGB, ext_num use fw mode, unit is sub-pixel,
	//rtd_outl(0xb802DA0C, 0x00000000); // G-dummy sub-pixel for line 8n+0, G-dummy data select from SFG input,
	//rtd_outl(0xb802DA10, 0x00000000); // G-dummy sub-pixel for line 8n+1,
	//rtd_outl(0xb802DA14, 0x00000000); // G-dummy sub-pixel for line 8n+2,
	//rtd_outl(0xb802DA18, 0x00000000); // G-dummy sub-pixel for line 8n+3,
	//rtd_outl(0xb802DBAC, 0x00000000); // G-dummy sub-pixel for line 8n+4,
	//rtd_outl(0xb802DBB0, 0x00000000); // G-dummy sub-pixel for line 8n+5,
	//rtd_outl(0xb802DBB4, 0x00000000); // G-dummy sub-pixel for line 8n+6,
	//rtd_outl(0xb802DBB8, 0x00000000); // G-dummy sub-pixel for line 8n+7,
	rtd_outl(0xb802DA1C, 0x00000000);	// dummy_pixel_data is black,
	rtd_outl(0xb802DA94, 0x00000000);	// Last_seg_start, last_seg_start_res for line 4n+0/1,
	rtd_outl(0xb802DA98, 0x00000000);	// Last_seg_start, last_seg_start_res for line 4n+2/3,
	rtd_outl(0xb802DBE0, 0x00000000);	// Last_seg_start, last_seg_start_res for line 4n+4/5,
	rtd_outl(0xb802DBE4, 0x00000000);	// Last_seg_start, last_seg_start_res for line 4n+6/7,
	//rtd_outl(0xb802DAA0, 0x02020202); // DRD Data Mapping,
	//rtd_outl(0xb802DAA4, 0x04040404); // DRD Data Mapping,
	//rtd_outl(0xb802DAA8, 0x00000000); // DRD Data Mapping,
	//rtd_outl(0xb802DAAC, 0x08080808); // DRD Data Mapping,
	//rtd_outl(0xb802DAB0, 0x06060606); // DRD Data Mapping,
	//rtd_outl(0xb802DAB4, 0x0E0E0E0E); // DRD Data Mapping,
	//rtd_outl(0xb802DAB8, 0x0A0A0A0A); // DRD Data Mapping,
	//rtd_outl(0xb802DABC, 0x0C0C0C0C); // DRD Data Mapping,
	//rtd_outl(0xb802DAC0, 0x10101010); // DRD Data Mapping,
	//rtd_outl(0xb802DAC4, 0x12121212); // DRD Data Mapping,
	//rtd_outl(0xb802DAC8, 0x14141414); // DRD Data Mapping,
	//rtd_outl(0xb802DACC, 0x16161616); // DRD Data Mapping,
	//rtd_outl(0xb802DAD0, 0x01010101); // DRD Data Mapping,
	//rtd_outl(0xb802DAD4, 0x03030303); // DRD Data Mapping,
	//rtd_outl(0xb802DAD8, 0x05050505); // DRD Data Mapping,
	//rtd_outl(0xb802DADC, 0x07070707); // DRD Data Mapping,
	//rtd_outl(0xb802DAE0, 0x0B0B0B0B); // DRD Data Mapping,
	//rtd_outl(0xb802DAE4, 0x0D0D0D0D); // DRD Data Mapping,
	//rtd_outl(0xb802DAE8, 0x09090909); // DRD Data Mapping,
	//rtd_outl(0xb802DAEC, 0x11111111); // DRD Data Mapping,
	//rtd_outl(0xb802DAF0, 0x0F0F0F0F); // DRD Data Mapping,
	//rtd_outl(0xb802DAF4, 0x17171717); // DRD Data Mapping,
	//rtd_outl(0xb802DAF8, 0x13131313); // DRD Data Mapping,
	//rtd_outl(0xb802DAFC, 0x15151515); // DRD Data Mapping,
	//rtd_outl(0xb802DB68, 0x00000000); // ext_num setting for case_a line7~0,
	//rtd_outl(0xb802DB6C, 0x00000000); // ext_num setting for case_b line7~0,
	//rtd_outl(0xb802DB78, 0x00000000); // Virtual data_0/1 for G-dummy line 8n+0,
	//rtd_outl(0xb802DB7C, 0x00000000); // Virtual data_0/1 for G-dummy line 8n+1,
	//rtd_outl(0xb802DB80, 0x00000000); // Virtual data_0/1 for G-dummy line 8n+2,
	//rtd_outl(0xb802DB84, 0x00000000); // Virtual data_0/1 for G-dummy line 8n+3,
	//rtd_outl(0xb802DB88, 0x00000000); // Virtual data_0/1 for G-dummy line 8n+4,
	//rtd_outl(0xb802DB8C, 0x00000000); // Virtual data_0/1 for G-dummy line 8n+5,
	//rtd_outl(0xb802DB90, 0x00000000); // Virtual data_0/1 for G-dummy line 8n+6,
	//rtd_outl(0xb802DB94, 0x00000000); // Virtual data_0/1 for G-dummy line 8n+7,
	rtd_outl(0xb802DBF0, 0x0F010E00);	// SFG Pattern Gen. Disable, RGB Mode, Width = 240, Hight = 270, pattern reset by hs,
	rtd_outl(0xb802DBF4, 0x00FFFFFF);	// SFG Pattern Gen. R/G/B/W Color for Bar0,
	rtd_outl(0xb802DBF8, 0x00FFFF00);	// SFG Pattern Gen. R/G/B/W Color for Bar1,
	rtd_outl(0xb802DBFC, 0x0000FFFF);	// SFG Pattern Gen. R/G/B/W Color for Bar2,
	rtd_outl(0xb802DC00, 0x0000FF00);	// SFG Pattern Gen. R/G/B/W Color for Bar3,
	rtd_outl(0xb802DC04, 0x00FF00FF);	// SFG Pattern Gen. R/G/B/W Color for Bar4,
	rtd_outl(0xb802DC08, 0x00FF0000);	// SFG Pattern Gen. R/G/B/W Color for Bar5,
	rtd_outl(0xb802DC0C, 0x000000FF);	// SFG Pattern Gen. R/G/B/W Color for Bar6,
	rtd_outl(0xb802DC10, 0x00000000);	// SFG Pattern Gen. R/G/B/W Color for Bar7,
	//rtd_outl(0xb802DC14, 0x00000000); // SFG Pattern Gen. gray_data0 and gray_data1 for manmal pattern,
	//rtd_outl(0xb802DC18, 0x00000000); // SFG Pattern Gen. manmal pattern sub-pixel data select for line 4n+0,
	//rtd_outl(0xb802DC1C, 0x00000000); // SFG Pattern Gen. manmal pattern sub-pixel data select for line 4n+1,
	//rtd_outl(0xb802DC20, 0x00000000); // SFG Pattern Gen. manmal pattern sub-pixel data select for line 4n+2,
	//rtd_outl(0xb802DC24, 0x00000000); // SFG Pattern Gen. manmal pattern sub-pixel data select for line 4n+3,
	rtd_outl(0xb802DC94, 0x10000000);	// Aysnc FIFO disble, Async FIFO use Vby1 Mode,
	rtd_outl(0xb802DC98, 0x9C00FFFF);	// 15~0 Lane_en
	rtd_outl(0xb802DC9C, 0x76543210);	// Lane 7~0 pair assign,  (2K using lane2~lane14 for LSphy)
	rtd_outl(0xb802DCA0, 0xFEDCBA98);	// Lane 15~8 pair assign, (2K using lane2~lane14 for LSphy)
	rtd_outl(0xb802DCC8, 0x0000FFFF);	// VIDEO_OSD_SEL 16lane video, phy lane15~lane0 enable
	rtd_outl(0xb802DCD0, 0x00000000);	// P/N Swap enable ,
	rtd_part_outl(0xb802D900, 11, 11, 0x1); // SFG out enable,

	//---------------------------------------------------------------------------------------------------------------------------------
	//LOCKN, HPTDN Pin share
	//---------------------------------------------------------------------------------------------------------------------------------
	rtd_maskl(0xb8000818, 0xFFFF0FFF, 0x00002000);	// GPIO_26 pinshare to vby1_htpd_src0,
	rtd_maskl(0xb800081C, 0x0FFFFFFF, 0x10000000);	// GPIO_28 pinshare to vby1_lock_src0,
	rtd_maskl(0xb8000CBC, 0xFFFFFFC3, 0x00000000);	// VBy1_HPTDN/VBy1_LOCKN use vby1_htpd_src0/vby1_lock_src0,
	rtd_maskl(0xb8000824, 0xE7FFFFFF, 0x00000000);	// GPIO_28/GPIO_26 use 3.3V GPI,

	//---------------------------------------------------------------------------------------------------------------------------------
	//VBy1 MAC
	//---------------------------------------------------------------------------------------------------------------------------------
	rtd_outl(0xb802D700, 0x00300000);	// VBy1_MAC_CLK = dclk/8,
	rtd_outl(0xb802D704, 0x00000004);	// VBy1 4-Byte Mode,
	rtd_outl(0xb802D708, 0x00000000);	// 24-bit ctrl_bit,
	rtd_outl(0xb802D70C, 0x6AC00000);	// VBy1 disable, PLL for lclk is stable, debounce count for HTPDN/LOCKN is 16-xtal,
						// Send BE before ALN, don't send BS after ALN finish,
	rtd_outl(0xb802D714, 0x00000000);	// 3D Flag Disable,
	rtd_outl(0xb802D718, 0x00FF0003);	// CRC Continuous Mode Enable for All lane,
	rtd_outl(0xb802D730, 0x00000000);	// HTPDN/LOCKN use HW Mode, DE Only Mode Disable,
	rtd_outl(0xb802D758, 0xC001FFFF);	  // 8B10B and Scrambler Enable, set 8B10/scrambler initial state,

	rtd_outl(0xb802D774, 0x0000005);  //disable,meta_sta;
	rtd_outl(0xb802D778, 0x1000009);  //start by HVsync, meta_end;
	//rtd_outl(0xb802D78C, 0x0000000);	// meta_data1
	//rtd_outl(0xb802D790, 0x0000000);	// meta_data2
	//rtd_outl(0xb802D794, 0x0000000);	// meta_data3
	//rtd_outl(0xb802D798, 0x0000000);	// meta_data4
	//rtd_outl(0xb802D79C, 0x0000000);	// meta_data5
	//rtd_outl(0xb802D7A0, 0x0000000);	// meta_data6
	//rtd_outl(0xb802D7A4, 0x0000000);	// meta_data7
	//rtd_outl(0xb802D7A8, 0x0000000);	// meta_data8
	//rtd_outl(0xb802D7AC, 0x0000000);	// meta_data9
	//rtd_outl(0xb802D7B0, 0x0000000);	// meta_data10
	//rtd_outl(0xb802D7B4, 0x0000000);	// meta_data11
	//rtd_outl(0xb802D7B8, 0x0000000);	// meta_data12
	//rtd_outl(0xb802D7BC, 0x0000000);	// meta_data13
	//rtd_outl(0xb802D7C0, 0x0000000);	// meta_data14
	//rtd_outl(0xb802D7C4, 0x0000000);	// meta_data15
	//rtd_outl(0xb802D7C8, 0x0000000);	// meta_data16
	//rtd_outl(0xb802D7CC, 0x0000000);	// meta_data17
	//rtd_outl(0xb802D7D0, 0x0000000);	// meta_data18
	//rtd_outl(0xb802D7D4, 0x0000000);	// meta_data19
	//rtd_outl(0xb802D7D8, 0x0000000);	// meta_data20
	//rtd_outl(0xb802D7DC, 0x0000000);	// meta_data21
	//rtd_outl(0xb802D7E0, 0x0000000);	// meta_data22
	//rtd_outl(0xb802D7E4, 0x0000000);	// meta_data23
	//rtd_outl(0xb802D7E8, 0x0000000);	// meta_data24
	//rtd_outl(0xb802D7EC, 0x0000000);	// meta_data25
	//rtd_outl(0xb802D7F0, 0x0000000);	// meta_data26
	//rtd_outl(0xb802D7F4, 0x0000000);	// meta_data27
	//rtd_outl(0xb802D7F8, 0x0000000);	// meta_data28
	//rtd_outl(0xb802D7FC, 0x0000000);	// meta_data29

	//---------------------------------------------------------------------------------------------------------------------------------
	//DISP_IF
	//---------------------------------------------------------------------------------------------------------------------------------
	//rtd_outl(0xb802D02C, 0x00000001); // Async FIFO use VBy1 Mode,
	//rtd_outl(0xb802D030, 0x00000000); // P/N Swap disable,
	//rtd_outl(0xb802D038, 0x00000000); // Async FIFO disable,
	//rtd_outl(0xb802D03C, 0x00030010); // Async FIFO reset enable, adaptive reset, apply after 16-clock,
	//rtd_outl(0xb802D060, 0x00010203); // Lane 0~3 pair assign,
	//rtd_outl(0xb802D064, 0x04050607); // Lane 4~7 pair assign,
	//rtd_outl(0xb802D068, 0xFFFFFFFF); // Lane 8~11 pair assign,

	//---------------------------------------------------------------------------------------------------------------------------------
	//PIF_APHY
	//---------------------------------------------------------------------------------------------------------------------------------
	rtd_outl(0xb8000CC0, 0x00000000);	// Lane Power disable,
	rtd_outl(0xb8000C74, 0x80000000);	// GLOBAL_POW_EN(1),
	rtd_outl(0xb8000C00, 0x30030020);	// PI_A1(Phase16), PI_A2(Phase16), VBG,
	rtd_outl(0xb8000C04, 0x30030020);	// PI_B1(Phase16), PI_B2(Phase16),
	rtd_outl(0xb8000C08, 0x03080100);	// PI_AB(Phase0), LDO_1V = 0.988V, DIVB(1),
	rtd_outl(0xb8000C0C, 0x8000E4B0);	// Big KVCO, Bypass PI, CKREF_INV(0), PLL_ICP<2:0>, PLL_SC1, PLL_SC2, PLL_SR,
	rtd_outl(0xb8000C10, 0x00000000);	// CK1X_INV(0), CK20X_INV(0), MACPLL_CKO_INV(0), PRESCALERDIV_HS(1),
	rtd_outl(0xb8000C14, 0x00000001);	// Normal VCO, PLL Test PAD select, PLL_ICP<3>,
	rtd_outl(0xb8000C18, 0x00000020);	// TXPLL use VBy1 feedback path, MACPLL_DIVM(4),
	rtd_outl(0xb8000C20, 0x00000200);	// TXPLL_EN(1), TXPLL_RSTN(0),
	rtd_outl(0xb8000C50, 0x01F48000);	// IBN Current, VCM Level, LDO1V_EN(1), VCM_SHIFT_DOWN(0),
	rtd_outl(0xb8000C78, 0x00000E00);	// CKIN_DIVN(16),
	//
	rtd_outl(0xb8000D00, 0x66002815);	// Lane0 : HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	rtd_outl(0xb8000D10, 0x66002815);	// Lane1 : HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	rtd_outl(0xb8000D20, 0x66002815);	// Lane2 : HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	rtd_outl(0xb8000D30, 0x66002815);	// Lane3 : HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	rtd_outl(0xb8000D40, 0x66002815);	// Lane4 : HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	rtd_outl(0xb8000D50, 0x66002815);	// Lane5 : HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	rtd_outl(0xb8000D60, 0x66002815);	// Lane6 : HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	rtd_outl(0xb8000D70, 0x66002815);	// Lane7 : HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	rtd_outl(0xb8000D80, 0x66002815);	// Lane8 : HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	rtd_outl(0xb8000D90, 0x66002815);	// Lane9 : HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	rtd_outl(0xb8000DA0, 0x66002815);	// Lane10: HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	rtd_outl(0xb8000DB0, 0x66002815);	// Lane11: HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	rtd_outl(0xb8000DC0, 0x66002815);	// Lane12: HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	rtd_outl(0xb8000DD0, 0x66002815);	// Lane13: HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	rtd_outl(0xb8000DE0, 0x66002815);	// Lane14: HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	rtd_outl(0xb8000DF0, 0x66002815);	// Lane15: HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	//
	rtd_outl(0xb8000D04, 0x44003006);	// Lane0 : CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000D14, 0x44003006);	// Lane1 : CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000D24, 0x44003006);	// Lane2 : CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000D34, 0x44003006);	// Lane3 : CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000D44, 0x44003006);	// Lane4 : CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000D54, 0x44003006);	// Lane5 : CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000D64, 0x44003006);	// Lane6 : CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000D74, 0x44003006);	// Lane7 : CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000D84, 0x44003006);	// Lane8 : CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000D94, 0x44003006);	// Lane9 : CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000DA4, 0x44003006);	// Lane10: CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000DB4, 0x44003006);	// Lane11: CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000DC4, 0x44003006);	// Lane12: CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000DD4, 0x44003006);	// Lane13: CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000DE4, 0x44003006);	// Lane14: CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000DF4, 0x44003006);	// Lane15: CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	//
	rtd_outl(0xb8000D08, 0x00000009);	// Lane0 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000D18, 0x00000009);	// Lane1 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000D28, 0x00000009);	// Lane2 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000D38, 0x00000009);	// Lane3 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000D48, 0x00000009);	// Lane4 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000D58, 0x00000009);	// Lane5 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000D68, 0x00000009);	// Lane6 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000D78, 0x00000009);	// Lane7 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000D88, 0x00000009);	// Lane8 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000D98, 0x00000009);	// Lane9 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000DA8, 0x00000009);	// Lane10: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000DB8, 0x00000009);	// Lane11: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000DC8, 0x00000009);	// Lane12: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000DD8, 0x00000009);	// Lane13: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000DE8, 0x00000009);	// Lane14: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000DF8, 0x00000009);	// Lane15: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),

	//---------------------------------------------------------------------------------------------------------------------------------
	//Initial Flow
	//--------------------------------------------------------------------------------------------------------------------------------
	// (1) DPLL Power Enable  (As above Script)
	//
	// (2) Wait DPLL stable at least 150us (SW Control)
	//
	// (3) Release DCLK Gating (SW Control)
	//
	// (4) TXPLL power up TXPLL during reset state (As above Script)
	//
	// (5) TXPLL reset release (Below Setting)
	rtd_part_outl(0xb8000C20, 10, 10, 0x1);
	//
	// (6) Wait TXPLL stable at least 150us (SW Control)
	//
	// (7) VBy1 Clock Enable (Below Setting)
	rtd_outl(0xb802D9B8, 0x20000000); //[31]lvds, [30]epi/cmpi, [29]vby1, [28]vby1OSD, [15]p2p, [14]isp
	//
	// (8) VBy1 MAC Enable (Below Setting)
	rtd_part_outl(0xb802D70C, 31, 31, 0x1);
	//
	// (9) Enable Async FIFO,
	rtd_part_outl(0xb802DC94, 31, 31, 0x1);
	//rtd_outl(0xb802D038, 0x00000001);
	//
	// (10) APHY Lane Power Enable (Below Setting)
	rtd_outl(0xb8000CC0, 0x0000FFFF);
	//
	// (11) Panel Power Enable (SW Control)

}

static void panel_tcon_ceds_setting(void)
{
        printf("=== panel_tcon_ceds_setting  ===\n");

        // Tcon Pinshare Setting,
        rtd_part_outl(0xb8000804, 31, 28, 0x5);		// gpio_4 for STV1, use Tcon10, 0x4/5/6/7/8_TCON_9/10/11/12/17
        rtd_part_outl(0xb8000814, 23, 20, 0x4);		// gpio_21 for ON_CLK, use Tcon21, 0x4/5/6/7/8_TCON_21/22/23/24
        rtd_part_outl(0xb800080C, 15, 12, 0x5);		// gpio_14 for OFF_CLK, use Tcon0, 0x4/5/6/7_TCON_20/0/1/2
        rtd_part_outl(0xb8000808, 31, 28, 0x4);		// gpio_08 for LC, use Tcon17, 0x4/5/6/7/8_TCON_17/18/19/20

        rtd_outl(0xb802D208, 0x00000000);		// Global Tcon disable,

        ////////////////////////////////////////////////////////////////////////////
        // STV1, GPIO_4, Tcon10,
        rtd_outl(0xb802D350, 0x06D606D6);		// H_start/H_end,
        rtd_outl(0xb802D354, 0x0053005A);		// V_start/V_end,
        rtd_outl(0xb802D358, 0x00000180);		// Control,
        ////////////////////////////////////////////////////////////////////////////

        ////////////////////////////////////////////////////////////////////////////
        // ON_CLK, GPIO_21, Tcon21,
        rtd_outl(0xb802D4B0, 0x06A400F2);		// H_start/H_end,
        rtd_outl(0xb802D4B4, 0x00571137);		// V_start/V_end,
        rtd_outl(0xb802D4B8, 0x00000280);		// Control,
        ////////////////////////////////////////////////////////////////////////////

        ////////////////////////////////////////////////////////////////////////////
        // OFF_CLK, GPIO_14, Tcon0,
        rtd_outl(0xb802D210, 0x06A400F2);		// H_start/H_end,
        rtd_outl(0xb802D214, 0x005b113b);		// V_start/V_end,
        rtd_outl(0xb802D218, 0x00000280);		// Control,

        ////////////////////////////////////////////////////////////////////////////

        // LC, GPIO_04 Tcon9,
        // TCON14,
        //rtd_outl(0xb802D3D0, 0x0A2C0A2C);		// H_start/H_end,
        //rtd_outl(0xb802D3D4, 0x08AF08AF);		// V_start/V_end,
        //rtd_outl(0xb802D3D8, 0x00000480);		// Control,
        //rtd_outl(0xb802D3E0, 0x000000B3);		// Across Frame Period,
        // Tcon17, GPIO_08
        rtd_outl(0xb802D430, 0x07f007f0);		// H_start/H_end,
        rtd_outl(0xb802D434, 0x00130013);		// V_start/V_end,
        rtd_outl(0xb802D438, 0x00000480);		// Control,
        rtd_outl(0xb802D440, 0x00fa00fa);		// Across Frame Period,

        ////////////////////////////////////////////////////////////////////////////
        // POL, TCON19/Tcon20,
        // Tcon18,
        rtd_outl(0xb802D450, 0x00500100);		// H_start/H_end,
        rtd_outl(0xb802D454, 0x00000001);		// V_start/V_end,
        rtd_outl(0xb802D458, 0x00000180);		// Control,
        // Tcon19 (POL2),
        rtd_outl(0xb802D470, 0x044C044C);		// H_start/H_end,
        rtd_outl(0xb802D474, 0x00010001);		// V_start/V_end,
        rtd_outl(0xb802D478, 0x00000480);		// Control,
        rtd_outl(0xb802D480, 0x00000000);		// Across Frame Period,
        // Tcon20 (POL1),
        rtd_outl(0xb802D490, 0x044C044C);		// H_start/H_end,
        rtd_outl(0xb802D494, 0x00010001);		// V_start/V_end,
        rtd_outl(0xb802D498, 0x00000480);		// Control,
        //rtd_outl(0xb802D494, 0x00011180);		// V_start/V_end,
        //rtd_outl(0xb802D498, 0x00000183);		// Control,
        ////////////////////////////////////////////////////////////////////////////

        // CS0, Tcon24,
        // Tcon24,
        rtd_outl(0xb802D510, 0x00500100);		// H_start/H_end,
        rtd_outl(0xb802D514, 0x00000001);		// V_start/V_end,
        rtd_outl(0xb802D518, 0x00000180);		// Control,
        ////////////////////////////////////////////////////////////////////////////
        // GSP, Tcon25,
        // Tcon25,
        rtd_outl(0xb802D530, 0x044C044C);		// H_start/H_end,
        rtd_outl(0xb802D534, 0x00570058);		// V_start/V_end,
        rtd_outl(0xb802D538, 0x00000180);		// Control,
        ////////////////////////////////////////////////////////////////////////////
        // DE (Tcon8, TCLK), for debug,
        //rtd_outl(0xb802D310, 0x008C080C);		// H_start/H_end,
        //rtd_outl(0xb802D314, 0x005A113A);		// V_start/V_end,
        //rtd_outl(0xb802D318, 0x00000180);		// Control,
        ////////////////////////////////////////////////////////////////////////////

        rtd_part_outl(0xb802D208, 1, 1, 0x1);		// Across frame and Across line 3 enable,
        rtd_part_outl(0xb802D208, 0, 0, 0x1);		// Global Tcon enable,

}

static void panel_ceds_tx(void)
{
	printf("\033[1;33m panel_ceds_tx \033[m\n");
#ifdef CONFIG_TCONLESS_BOE_CEDS
	panel_ceds_BOE_43UHD60HZ_12lane_8b_DualGate_tcon_setting();
#endif
}

void panel_tcon_chpi_setting(void)
{
	// Tcon Pinshare Setting,
	rtd_part_outl(0xb8000CA0, 31, 28, 0xB);		// TX27P for ON_CLK, use Tcon12,
	rtd_part_outl(0xb8000CA0, 19, 16, 0xA);		// TX26N for TCLK, use Tcon17,
	//
	// B16_QA
	//rtd_part_outl(0xb8000804, 23, 20, 0x8);	// gpio_05 for SCLK, use Tcon3,
	//rtd_part_outl(0xb8000804, 7, 4, 0x8);		// gpio_07 for OFF_CLK, use Tcon7,
	//
	// B16_DEMO (S1AL1A)
	rtd_part_outl(0xb8000800, 15, 12, 0x8);		// gpio_02 for SCLK, use Tcon3,
	rtd_part_outl(0xb8000804, 15, 12, 0xA);		// gpio_06 for OFF_CLK, use Tcon7,
	//
	rtd_outl(0xb802D208, 0x00000000);		// Global Tcon disable,

	////////////////////////////////////////////////////////////////////////////
	// SCLK, gpio_05, Tcon3,
	// Tcon3 (Frame Start Pulse),
	rtd_outl(0xb802D270, 0x000107FC);		// H_start/H_end,
	rtd_outl(0xb802D274, 0x00510057);		// V_start/V_end,
	rtd_outl(0xb802D278, 0x00000180);		// Control,
	////////////////////////////////////////////////////////////////////////////
	// OFF_CLK, gpio_07, Tcon7,
	// Tocn6 (ODD Line),
	rtd_outl(0xb802D2D0, 0x027206E8);		// H_start/H_end,
	rtd_outl(0xb802D2D4, 0x005c1144);		// V_start/V_end,
	rtd_outl(0xb802D2D8, 0x00000380);		// Control,
	rtd_outl(0xb802D2DC, 0x00020000);		// Across Line3 RP/HP,
	// Tcon7 (EVEN Line),
	rtd_outl(0xb802D2F0, 0x027206E8);		// H_start/H_end,
	rtd_outl(0xb802D2F4, 0x005B1143);		// V_start/V_end,
	rtd_outl(0xb802D2F8, 0x00000382);		// Control,
	rtd_outl(0xb802D2FC, 0x00020000);		// Across Line3 RP/HP,
	////////////////////////////////////////////////////////////////////////////
	// ON_CLK, TX27P, Tcon12,
	// Tcon11 (ODD Line),
	rtd_outl(0xb802D370, 0x05c00856);		// H_start/H_end,
	rtd_outl(0xb802D374, 0x0058113E);		// V_start/V_end,
	rtd_outl(0xb802D378, 0x00000380);		// Control,
	rtd_outl(0xb802D37C, 0x00020000);		// Across Line3 RP/HP,
	// Tcon12 (EVEN Line),
	rtd_outl(0xb802D390, 0x05C00856);		// H_start/H_end,
	rtd_outl(0xb802D394, 0x0057113D);		// V_start/V_end,
	rtd_outl(0xb802D398, 0x00000382);		// Control,
	rtd_outl(0xb802D39C, 0x00020000);		// Across Line3 RP/HP,
	////////////////////////////////////////////////////////////////////////////
	// TCLK, TX26N, Tcon17,
	// TCON16,
	rtd_outl(0xb802D410, 0x00F800F8);		// H_start/H_end,
	rtd_outl(0xb802D414, 0x00010001);		// V_start/V_end,
	rtd_outl(0xb802D418, 0x00000480);		// Control,
	rtd_outl(0xb802D420, 0x0000007E);		// Across Frame Period,
	// Tcon17,
	rtd_outl(0xb802D430, 0x01A801A8);		// H_start/H_end,
	rtd_outl(0xb802D434, 0x00010001);		// V_start/V_end,
	rtd_outl(0xb802D438, 0x00000483);		// Control,
	rtd_outl(0xb802D440, 0x0000007E);		// Across Frame Period,
	////////////////////////////////////////////////////////////////////////////
	// POL, TCON19/Tcon20,
	// Tcon19 (POL2),
	rtd_outl(0xb802D470, 0x044C044C);		// H_start/H_end,
	rtd_outl(0xb802D474, 0x00010001);		// V_start/V_end,
	rtd_outl(0xb802D478, 0x00000480);		// Control,
	rtd_outl(0xb802D480, 0x00000000);		// Across Frame Period,
	// Tcon20 (POL1),
	rtd_outl(0xb802D490, 0x044C044C);		// H_start/H_end,
	rtd_outl(0xb802D494, 0x00011180);		// V_start/V_end,
	rtd_outl(0xb802D498, 0x00000183);		// Control,
	////////////////////////////////////////////////////////////////////////////
	// FSYNC, Tcon25,
	// Tcon25,
	rtd_outl(0xb802D530, 0x044C044C);		// H_start/H_end,
	rtd_outl(0xb802D534, 0x00570058);		// V_start/V_end,
	rtd_outl(0xb802D538, 0x00000180);		// Control,
	////////////////////////////////////////////////////////////////////////////
	// DE (Tcon17, EO), for debug,
	//rtd_outl(0xb802D430, 0x00B40836);		// H_start/H_end,
	//rtd_outl(0xb802D434, 0x005A1139);		// V_start/V_end,
	//rtd_outl(0xb802D438, 0x00000180);		// Control,
	////////////////////////////////////////////////////////////////////////////
	// DE (Tcon17, EO), for debug,
	//rtd_outl(0xb802D430, 0x00B40836);		// H_start/H_end,
	//rtd_outl(0xb802D434, 0x005A005A);		// V_start/V_end,
	//rtd_outl(0xb802D438, 0x00000180);		// Control,
	////////////////////////////////////////////////////////////////////////////
	rtd_part_outl(0xb802D208, 1, 1, 0x1);		// Across frame and Across line 3 enable,
	rtd_part_outl(0xb802D208, 0, 0, 0x1);		// Global Tcon enable,
}

static void panel_chpi_tx(void)
{
	if (default_panel_parameter.iCONFIG_PANEL_CUSTOM_INDEX == P_CHPI_55INCH_UHD60_6LANE_HIMAX) {
		printf("Panel Custom Index : P_CHPI_55INCH_UHD60_6LANE_HIMAX\n");
		panel_chpi_55inch_uhd60_6lane_himax();
	} else if (default_panel_parameter.iCONFIG_PANEL_CUSTOM_INDEX == P_CHPI_55INCH_UHD60_6LANE_ILITEK) {
		printf("Panel Custom Index : P_CHPI_55INCH_UHD60_6LANE_ILITEK\n");
		panel_chpi_55inch_uhd60_6lane_ilitek();
	} else if (default_panel_parameter.iCONFIG_PANEL_CUSTOM_INDEX == P_CHPI_55INCH_UHD60_6LANE_RAYDIUM) {
		printf("Panel Custom Index : P_CHPI_55INCH_UHD60_6LANE_RAYDIUM\n");
		panel_chpi_55inch_uhd60_6lane_raydium();
	} else if (default_panel_parameter.iCONFIG_PANEL_CUSTOM_INDEX == P_CHPI_BC_TRIGGER) {
		printf("Panel Custom Index : P_CHPI_BC_TRIGGER\n");
		panel_chpi_bc_trigger();
	} else {
		printf("Panel Custom Index : unknow\n");
	}
}

static void panel_isp_tx(void)
{
	if (default_panel_parameter.iCONFIG_PANEL_CUSTOM_INDEX == P_ISP_50INCH_UHD60_12LANE) {
		printf("Panel Custom Index : P_ISP_50INCH_UHD60_12LANE\n");
		panel_isp_50inch_uhd60_12lane();
	} else if (default_panel_parameter.iCONFIG_PANEL_CUSTOM_INDEX == P_ISP_43INCH_UHD60_12LANE) {
		printf("Panel Custom Index : P_ISP_43INCH_UHD60_12LANE\n");
		panel_isp_43inch_uhd60_12lane();
	} else {
		printf("Panel Custom Index : unknow\n");
	}
}

static void panel_usit_tx(void)
{
	if (default_panel_parameter.iCONFIG_PANEL_CUSTOM_INDEX == P_USIT_50INCH_UHD60_12LANE) {
		printf("Panel Custom Index : P_USIT_50INCH_UHD60_12LANE\n");
		panel_usit_50inch_uhd60_12lane();
	} else {
		printf("Panel Custom Index : unknow\n");
	}
}



void panel_interface_common(void)
{
	//pif_lvds_ctrl0_RBUS lvds_ctrl0_reg;
	//pif_lvds_ctrl3_RBUS  lvds_ctrl3_reg;

	//lvds_ctrl0_reg.regValue = rtd_inl(PIF_LVDS_CTRL0_reg);
	//lvds_ctrl3_reg.regValue = rtd_inl(PIF_LVDS_CTRL3_reg);

	printf("=== Panel Type : %d ===\n", default_panel_parameter.iCONFIG_PANEL_TYPE);
	//panel_interface_pinmux_setting();
	printf("=== iCONFIG_PANEL_CUSTOM_INDEX : %d ===\n", default_panel_parameter.iCONFIG_PANEL_CUSTOM_INDEX);

	if(CusApi_panel_interface_common()){
		printf("\n\033[1;33m<<<Normal mode & TCONx3 fail bypass vby1 driver>>>\033[m\n");
		printf("\n\033[1;33m<<<Normal mode & TCONx3 fail bypass vby1 driver>>>\033[m\n");
		printf("\n\033[1;33m<<<Normal mode & TCONx3 fail bypass vby1 driver>>>\033[m\n");
	} else if((default_panel_parameter.iCONFIG_PANEL_TYPE == P_VBY1_4K2K) ||
		(default_panel_parameter.iCONFIG_PANEL_TYPE == P_VBY1_2K1K) ||
		(default_panel_parameter.iCONFIG_PANEL_TYPE == P_VBY1_TO_HDMI_MEMC_FREERUN) ||
		(default_panel_parameter.iCONFIG_PANEL_TYPE == P_VBY1_TO_HDMI)){
		if((default_panel_parameter.iCONFIG_PANEL_CUSTOM_INDEX == VBY_ONE_PANEL_LG_4K2K_120HZ_1S_16L)||
			(default_panel_parameter.iCONFIG_PANEL_CUSTOM_INDEX == VBY_ONE_PANEL_LG_4K2K_120HZ_2S_16L))
			panel_vby1_4k120_tx();
		else if(default_panel_parameter.iCONFIG_PANEL_CUSTOM_INDEX == VBY_ONE_PANEL_4K2K_TO_HDMI_2K1K)
			panel_vby1_to_lvds_tx();
		else
			panel_vby1_tx();
	} else if(default_panel_parameter.iCONFIG_PANEL_TYPE == P_EPI_TYPE){
		panel_epi_tx();
		//panel_rgbw_setting();
	} else if(default_panel_parameter.iCONFIG_PANEL_TYPE == P_MINI_LVDS){
		panel_mLVDS_tx();
	} else if(default_panel_parameter.iCONFIG_PANEL_TYPE == P_VBY1_TO_LVDS ||
		(default_panel_parameter.iCONFIG_PANEL_TYPE == P_VBY1_TO_LVDS_TO_HDMI)){
		panel_vby1_to_lvds_tx();
	} else if (default_panel_parameter.iCONFIG_PANEL_TYPE == P_CEDS){
		//panel_rgbw_setting();
#ifdef CONFIG_TCONLESS_BOE_CEDS
		// ------------------------ MEMC DTG ------------------------
		rtd_outl(0xB8028604, 0x000008C9);	// memc_dtg dv_total
		rtd_outl(0xB8028608, 0x112F112F);	// memc_dtg dh_total
		rtd_outl(0xB8028618, 0x002D089D);	// memc_dtg dv_den_sta_end
		rtd_outl(0xB802861C, 0x01181018);	// memc_dtg dh_den_sta_end
		//rtd_outl(0xb8028000, 0x01000000);	// FRC Mode
#endif
		panel_tcon_ceds_setting();
		panel_ceds_tx();
	} else if (default_panel_parameter.iCONFIG_PANEL_TYPE == P_CHPI) {
		//panel_rgbw_setting();
		panel_tcon_chpi_setting();
		panel_chpi_tx();
	} else if (default_panel_parameter.iCONFIG_PANEL_TYPE == P_ISP) {
		panel_isp_tx();
	} else if ((default_panel_parameter.iCONFIG_PANEL_TYPE == P_LVDS_2K1K)||
		(default_panel_parameter.iCONFIG_PANEL_TYPE == P_LVDS_TO_HDMI)){
#if defined(Config_Vulcan3_PCB_TRUE)
		if(EnableFHD)
			panel_lvds_fhd_tx();
		else
#endif
			panel_lvds_tx();
	} else if (default_panel_parameter.iCONFIG_PANEL_TYPE == P_USIT) {
		panel_usit_tx();
	}



//	rtd_outl(PIF_LVDS_CTRL0_reg, lvds_ctrl0_reg.regValue);
//	rtd_outl(PIF_LVDS_CTRL3_reg, lvds_ctrl3_reg.regValue);

}

void vby1_fhd_dtg(void)
{
	printf("=== vby1_fhd_dtg ====");
	rtd_maskl(0xb8000190,0xF00F888F,0x02101450);	// DPLL M, N, Icp = 2.5uA, Rs = 6KOhms.
	rtd_maskl(0xb8000194,0xFFCFCFFE,0x00300001);	// DPLL DIV_A/1
	rtd_maskl(0xb8028294,0xFFFFFFFC,0x00000000);	// DPLL DIV_D/1
	rtd_maskl(0xb8000300,0xF000FFFA,0x07500001);	// DPLL OFFSET
	rtd_maskl(0xb8000300,0xF000FFFA,0x07500005);	// DPLL OFFSET Load in

	rtd_outl(0xb8028000, 0x01000000);	// Free Run Mode
	rtd_outl(0xb8028008, 0x0000000F);	// Hsync width
	rtd_outl(0xb802800C, 0x08970897);	// DH_total
	rtd_outl(0xb8028010, 0x00000005);	// DV_sync width
	rtd_outl(0xb8028014, 0x00000464);	// DV_total
	rtd_outl(0xb8028018, 0x008C080C);	// DH_den_sta, DH_den_end
	rtd_outl(0xb802801C, 0x0016044E);	// DV_den_sta, DV_den_end
	rtd_outl(0xb8028024, 0x000000FF);	// Display Background Color
	rtd_outl(0xb8028028, 0x00000002);	// Disable Buffer

	rtd_outl(0xb8028100, 0x00000001);	// Main Display enable
	rtd_outl(0xb8028108, 0x0CD40000);	// Main Border Color
	rtd_outl(0xb802810C, 0x00000000);	// Main Background Color
	rtd_outl(0xb8028110, 0x00000780);	// Main DEN_H_str,Main DEN_H_end
	rtd_outl(0xb8028114, 0x00000438);	// Main DEN_V_str,Main DEN_V_end
	rtd_outl(0xb8028118, 0x00000780);	// Main Background_H_str,Main Background_H_end
	rtd_outl(0xb802811C, 0x00000438);	// Main Background_V_str,Main Background_V_end
	rtd_outl(0xb8028120, 0x00000780);	// Main Active_H_str,Main Active_H_end
	rtd_outl(0xb8028124, 0x00000438);	// Main Active_V_str,Main Active_V_end

}

void panel_vby1_to_lvds_vip_table(void)
{
	//---------------------------------------------------------------------------------------------------------------------------------
	// Data Shift 2-LSB By Gamma
	//---------------------------------------------------------------------------------------------------------------------------------
	rtd_outl(0xb802c804,0x00000100);//--> gamma bypass, write R channel
	rtd_outl(0xb802c800,0x00000404);
	rtd_outl(0xb802c800,0x00080404);
	rtd_outl(0xb802c800,0x00100404);
	rtd_outl(0xb802c800,0x00180404);
	rtd_outl(0xb802c800,0x00200404);
	rtd_outl(0xb802c800,0x00280404);
	rtd_outl(0xb802c800,0x00300404);
	rtd_outl(0xb802c800,0x00380404);
	rtd_outl(0xb802c800,0x00400404);
	rtd_outl(0xb802c800,0x00480404);
	rtd_outl(0xb802c800,0x00500404);
	rtd_outl(0xb802c800,0x00580404);
	rtd_outl(0xb802c800,0x00600404);
	rtd_outl(0xb802c800,0x00680404);
	rtd_outl(0xb802c800,0x00700404);
	rtd_outl(0xb802c800,0x00780404);
	rtd_outl(0xb802c800,0x00800404);
	rtd_outl(0xb802c800,0x00880404);
	rtd_outl(0xb802c800,0x00900404);
	rtd_outl(0xb802c800,0x00980404);
	rtd_outl(0xb802c800,0x00a00404);
	rtd_outl(0xb802c800,0x00a80404);
	rtd_outl(0xb802c800,0x00b00404);
	rtd_outl(0xb802c800,0x00b80404);
	rtd_outl(0xb802c800,0x00c00404);
	rtd_outl(0xb802c800,0x00c80404);
	rtd_outl(0xb802c800,0x00d00404);
	rtd_outl(0xb802c800,0x00d80404);
	rtd_outl(0xb802c800,0x00e00404);
	rtd_outl(0xb802c800,0x00e80404);
	rtd_outl(0xb802c800,0x00f00404);
	rtd_outl(0xb802c800,0x00f80404);
	rtd_outl(0xb802c800,0x01000404);
	rtd_outl(0xb802c800,0x01080404);
	rtd_outl(0xb802c800,0x01100404);
	rtd_outl(0xb802c800,0x01180404);
	rtd_outl(0xb802c800,0x01200404);
	rtd_outl(0xb802c800,0x01280404);
	rtd_outl(0xb802c800,0x01300404);
	rtd_outl(0xb802c800,0x01380404);
	rtd_outl(0xb802c800,0x01400404);
	rtd_outl(0xb802c800,0x01480404);
	rtd_outl(0xb802c800,0x01500404);
	rtd_outl(0xb802c800,0x01580404);
	rtd_outl(0xb802c800,0x01600404);
	rtd_outl(0xb802c800,0x01680404);
	rtd_outl(0xb802c800,0x01700404);
	rtd_outl(0xb802c800,0x01780404);
	rtd_outl(0xb802c800,0x01800404);
	rtd_outl(0xb802c800,0x01880404);
	rtd_outl(0xb802c800,0x01900404);
	rtd_outl(0xb802c800,0x01980404);
	rtd_outl(0xb802c800,0x01a00404);
	rtd_outl(0xb802c800,0x01a80404);
	rtd_outl(0xb802c800,0x01b00404);
	rtd_outl(0xb802c800,0x01b80404);
	rtd_outl(0xb802c800,0x01c00404);
	rtd_outl(0xb802c800,0x01c80404);
	rtd_outl(0xb802c800,0x01d00404);
	rtd_outl(0xb802c800,0x01d80404);
	rtd_outl(0xb802c800,0x01e00404);
	rtd_outl(0xb802c800,0x01e80404);
	rtd_outl(0xb802c800,0x01f00404);
	rtd_outl(0xb802c800,0x01f80404);
	rtd_outl(0xb802c800,0x02000404);
	rtd_outl(0xb802c800,0x02080404);
	rtd_outl(0xb802c800,0x02100404);
	rtd_outl(0xb802c800,0x02180404);
	rtd_outl(0xb802c800,0x02200404);
	rtd_outl(0xb802c800,0x02280404);
	rtd_outl(0xb802c800,0x02300404);
	rtd_outl(0xb802c800,0x02380404);
	rtd_outl(0xb802c800,0x02400404);
	rtd_outl(0xb802c800,0x02480404);
	rtd_outl(0xb802c800,0x02500404);
	rtd_outl(0xb802c800,0x02580404);
	rtd_outl(0xb802c800,0x02600404);
	rtd_outl(0xb802c800,0x02680404);
	rtd_outl(0xb802c800,0x02700404);
	rtd_outl(0xb802c800,0x02780404);
	rtd_outl(0xb802c800,0x02800404);
	rtd_outl(0xb802c800,0x02880404);
	rtd_outl(0xb802c800,0x02900404);
	rtd_outl(0xb802c800,0x02980404);
	rtd_outl(0xb802c800,0x02a00404);
	rtd_outl(0xb802c800,0x02a80404);
	rtd_outl(0xb802c800,0x02b00404);
	rtd_outl(0xb802c800,0x02b80404);
	rtd_outl(0xb802c800,0x02c00404);
	rtd_outl(0xb802c800,0x02c80404);
	rtd_outl(0xb802c800,0x02d00404);
	rtd_outl(0xb802c800,0x02d80404);
	rtd_outl(0xb802c800,0x02e00404);
	rtd_outl(0xb802c800,0x02e80404);
	rtd_outl(0xb802c800,0x02f00404);
	rtd_outl(0xb802c800,0x02f80404);
	rtd_outl(0xb802c800,0x03000404);
	rtd_outl(0xb802c800,0x03080404);
	rtd_outl(0xb802c800,0x03100404);
	rtd_outl(0xb802c800,0x03180404);
	rtd_outl(0xb802c800,0x03200404);
	rtd_outl(0xb802c800,0x03280404);
	rtd_outl(0xb802c800,0x03300404);
	rtd_outl(0xb802c800,0x03380404);
	rtd_outl(0xb802c800,0x03400404);
	rtd_outl(0xb802c800,0x03480404);
	rtd_outl(0xb802c800,0x03500404);
	rtd_outl(0xb802c800,0x03580404);
	rtd_outl(0xb802c800,0x03600404);
	rtd_outl(0xb802c800,0x03680404);
	rtd_outl(0xb802c800,0x03700404);
	rtd_outl(0xb802c800,0x03780404);
	rtd_outl(0xb802c800,0x03800404);
	rtd_outl(0xb802c800,0x03880404);
	rtd_outl(0xb802c800,0x03900404);
	rtd_outl(0xb802c800,0x03980404);
	rtd_outl(0xb802c800,0x03a00404);
	rtd_outl(0xb802c800,0x03a80404);
	rtd_outl(0xb802c800,0x03b00404);
	rtd_outl(0xb802c800,0x03b80404);
	rtd_outl(0xb802c800,0x03c00404);
	rtd_outl(0xb802c800,0x03c80404);
	rtd_outl(0xb802c800,0x03d00404);
	rtd_outl(0xb802c800,0x03d80404);
	rtd_outl(0xb802c800,0x03e00404);
	rtd_outl(0xb802c800,0x03e80404);
	rtd_outl(0xb802c800,0x03f00404);
	rtd_outl(0xb802c800,0x03f80404);
	rtd_outl(0xb802c804,0x00000120);//--> G channel, ax table1
	rtd_outl(0xb802c800,0x00000404);
	rtd_outl(0xb802c800,0x00080404);
	rtd_outl(0xb802c800,0x00100404);
	rtd_outl(0xb802c800,0x00180404);
	rtd_outl(0xb802c800,0x00200404);
	rtd_outl(0xb802c800,0x00280404);
	rtd_outl(0xb802c800,0x00300404);
	rtd_outl(0xb802c800,0x00380404);
	rtd_outl(0xb802c800,0x00400404);
	rtd_outl(0xb802c800,0x00480404);
	rtd_outl(0xb802c800,0x00500404);
	rtd_outl(0xb802c800,0x00580404);
	rtd_outl(0xb802c800,0x00600404);
	rtd_outl(0xb802c800,0x00680404);
	rtd_outl(0xb802c800,0x00700404);
	rtd_outl(0xb802c800,0x00780404);
	rtd_outl(0xb802c800,0x00800404);
	rtd_outl(0xb802c800,0x00880404);
	rtd_outl(0xb802c800,0x00900404);
	rtd_outl(0xb802c800,0x00980404);
	rtd_outl(0xb802c800,0x00a00404);
	rtd_outl(0xb802c800,0x00a80404);
	rtd_outl(0xb802c800,0x00b00404);
	rtd_outl(0xb802c800,0x00b80404);
	rtd_outl(0xb802c800,0x00c00404);
	rtd_outl(0xb802c800,0x00c80404);
	rtd_outl(0xb802c800,0x00d00404);
	rtd_outl(0xb802c800,0x00d80404);
	rtd_outl(0xb802c800,0x00e00404);
	rtd_outl(0xb802c800,0x00e80404);
	rtd_outl(0xb802c800,0x00f00404);
	rtd_outl(0xb802c800,0x00f80404);
	rtd_outl(0xb802c800,0x01000404);
	rtd_outl(0xb802c800,0x01080404);
	rtd_outl(0xb802c800,0x01100404);
	rtd_outl(0xb802c800,0x01180404);
	rtd_outl(0xb802c800,0x01200404);
	rtd_outl(0xb802c800,0x01280404);
	rtd_outl(0xb802c800,0x01300404);
	rtd_outl(0xb802c800,0x01380404);
	rtd_outl(0xb802c800,0x01400404);
	rtd_outl(0xb802c800,0x01480404);
	rtd_outl(0xb802c800,0x01500404);
	rtd_outl(0xb802c800,0x01580404);
	rtd_outl(0xb802c800,0x01600404);
	rtd_outl(0xb802c800,0x01680404);
	rtd_outl(0xb802c800,0x01700404);
	rtd_outl(0xb802c800,0x01780404);
	rtd_outl(0xb802c800,0x01800404);
	rtd_outl(0xb802c800,0x01880404);
	rtd_outl(0xb802c800,0x01900404);
	rtd_outl(0xb802c800,0x01980404);
	rtd_outl(0xb802c800,0x01a00404);
	rtd_outl(0xb802c800,0x01a80404);
	rtd_outl(0xb802c800,0x01b00404);
	rtd_outl(0xb802c800,0x01b80404);
	rtd_outl(0xb802c800,0x01c00404);
	rtd_outl(0xb802c800,0x01c80404);
	rtd_outl(0xb802c800,0x01d00404);
	rtd_outl(0xb802c800,0x01d80404);
	rtd_outl(0xb802c800,0x01e00404);
	rtd_outl(0xb802c800,0x01e80404);
	rtd_outl(0xb802c800,0x01f00404);
	rtd_outl(0xb802c800,0x01f80404);
	rtd_outl(0xb802c800,0x02000404);
	rtd_outl(0xb802c800,0x02080404);
	rtd_outl(0xb802c800,0x02100404);
	rtd_outl(0xb802c800,0x02180404);
	rtd_outl(0xb802c800,0x02200404);
	rtd_outl(0xb802c800,0x02280404);
	rtd_outl(0xb802c800,0x02300404);
	rtd_outl(0xb802c800,0x02380404);
	rtd_outl(0xb802c800,0x02400404);
	rtd_outl(0xb802c800,0x02480404);
	rtd_outl(0xb802c800,0x02500404);
	rtd_outl(0xb802c800,0x02580404);
	rtd_outl(0xb802c800,0x02600404);
	rtd_outl(0xb802c800,0x02680404);
	rtd_outl(0xb802c800,0x02700404);
	rtd_outl(0xb802c800,0x02780404);
	rtd_outl(0xb802c800,0x02800404);
	rtd_outl(0xb802c800,0x02880404);
	rtd_outl(0xb802c800,0x02900404);
	rtd_outl(0xb802c800,0x02980404);
	rtd_outl(0xb802c800,0x02a00404);
	rtd_outl(0xb802c800,0x02a80404);
	rtd_outl(0xb802c800,0x02b00404);
	rtd_outl(0xb802c800,0x02b80404);
	rtd_outl(0xb802c800,0x02c00404);
	rtd_outl(0xb802c800,0x02c80404);
	rtd_outl(0xb802c800,0x02d00404);
	rtd_outl(0xb802c800,0x02d80404);
	rtd_outl(0xb802c800,0x02e00404);
	rtd_outl(0xb802c800,0x02e80404);
	rtd_outl(0xb802c800,0x02f00404);
	rtd_outl(0xb802c800,0x02f80404);
	rtd_outl(0xb802c800,0x03000404);
	rtd_outl(0xb802c800,0x03080404);
	rtd_outl(0xb802c800,0x03100404);
	rtd_outl(0xb802c800,0x03180404);
	rtd_outl(0xb802c800,0x03200404);
	rtd_outl(0xb802c800,0x03280404);
	rtd_outl(0xb802c800,0x03300404);
	rtd_outl(0xb802c800,0x03380404);
	rtd_outl(0xb802c800,0x03400404);
	rtd_outl(0xb802c800,0x03480404);
	rtd_outl(0xb802c800,0x03500404);
	rtd_outl(0xb802c800,0x03580404);
	rtd_outl(0xb802c800,0x03600404);
	rtd_outl(0xb802c800,0x03680404);
	rtd_outl(0xb802c800,0x03700404);
	rtd_outl(0xb802c800,0x03780404);
	rtd_outl(0xb802c800,0x03800404);
	rtd_outl(0xb802c800,0x03880404);
	rtd_outl(0xb802c800,0x03900404);
	rtd_outl(0xb802c800,0x03980404);
	rtd_outl(0xb802c800,0x03a00404);
	rtd_outl(0xb802c800,0x03a80404);
	rtd_outl(0xb802c800,0x03b00404);
	rtd_outl(0xb802c800,0x03b80404);
	rtd_outl(0xb802c800,0x03c00404);
	rtd_outl(0xb802c800,0x03c80404);
	rtd_outl(0xb802c800,0x03d00404);
	rtd_outl(0xb802c800,0x03d80404);
	rtd_outl(0xb802c800,0x03e00404);
	rtd_outl(0xb802c800,0x03e80404);
	rtd_outl(0xb802c800,0x03f00404);
	rtd_outl(0xb802c800,0x03f80404);
	rtd_outl(0xb802c804,0x00000140);//--> B channel, ax table1
	rtd_outl(0xb802c800,0x00000404);
	rtd_outl(0xb802c800,0x00080404);
	rtd_outl(0xb802c800,0x00100404);
	rtd_outl(0xb802c800,0x00180404);
	rtd_outl(0xb802c800,0x00200404);
	rtd_outl(0xb802c800,0x00280404);
	rtd_outl(0xb802c800,0x00300404);
	rtd_outl(0xb802c800,0x00380404);
	rtd_outl(0xb802c800,0x00400404);
	rtd_outl(0xb802c800,0x00480404);
	rtd_outl(0xb802c800,0x00500404);
	rtd_outl(0xb802c800,0x00580404);
	rtd_outl(0xb802c800,0x00600404);
	rtd_outl(0xb802c800,0x00680404);
	rtd_outl(0xb802c800,0x00700404);
	rtd_outl(0xb802c800,0x00780404);
	rtd_outl(0xb802c800,0x00800404);
	rtd_outl(0xb802c800,0x00880404);
	rtd_outl(0xb802c800,0x00900404);
	rtd_outl(0xb802c800,0x00980404);
	rtd_outl(0xb802c800,0x00a00404);
	rtd_outl(0xb802c800,0x00a80404);
	rtd_outl(0xb802c800,0x00b00404);
	rtd_outl(0xb802c800,0x00b80404);
	rtd_outl(0xb802c800,0x00c00404);
	rtd_outl(0xb802c800,0x00c80404);
	rtd_outl(0xb802c800,0x00d00404);
	rtd_outl(0xb802c800,0x00d80404);
	rtd_outl(0xb802c800,0x00e00404);
	rtd_outl(0xb802c800,0x00e80404);
	rtd_outl(0xb802c800,0x00f00404);
	rtd_outl(0xb802c800,0x00f80404);
	rtd_outl(0xb802c800,0x01000404);
	rtd_outl(0xb802c800,0x01080404);
	rtd_outl(0xb802c800,0x01100404);
	rtd_outl(0xb802c800,0x01180404);
	rtd_outl(0xb802c800,0x01200404);
	rtd_outl(0xb802c800,0x01280404);
	rtd_outl(0xb802c800,0x01300404);
	rtd_outl(0xb802c800,0x01380404);
	rtd_outl(0xb802c800,0x01400404);
	rtd_outl(0xb802c800,0x01480404);
	rtd_outl(0xb802c800,0x01500404);
	rtd_outl(0xb802c800,0x01580404);
	rtd_outl(0xb802c800,0x01600404);
	rtd_outl(0xb802c800,0x01680404);
	rtd_outl(0xb802c800,0x01700404);
	rtd_outl(0xb802c800,0x01780404);
	rtd_outl(0xb802c800,0x01800404);
	rtd_outl(0xb802c800,0x01880404);
	rtd_outl(0xb802c800,0x01900404);
	rtd_outl(0xb802c800,0x01980404);
	rtd_outl(0xb802c800,0x01a00404);
	rtd_outl(0xb802c800,0x01a80404);
	rtd_outl(0xb802c800,0x01b00404);
	rtd_outl(0xb802c800,0x01b80404);
	rtd_outl(0xb802c800,0x01c00404);
	rtd_outl(0xb802c800,0x01c80404);
	rtd_outl(0xb802c800,0x01d00404);
	rtd_outl(0xb802c800,0x01d80404);
	rtd_outl(0xb802c800,0x01e00404);
	rtd_outl(0xb802c800,0x01e80404);
	rtd_outl(0xb802c800,0x01f00404);
	rtd_outl(0xb802c800,0x01f80404);
	rtd_outl(0xb802c800,0x02000404);
	rtd_outl(0xb802c800,0x02080404);
	rtd_outl(0xb802c800,0x02100404);
	rtd_outl(0xb802c800,0x02180404);
	rtd_outl(0xb802c800,0x02200404);
	rtd_outl(0xb802c800,0x02280404);
	rtd_outl(0xb802c800,0x02300404);
	rtd_outl(0xb802c800,0x02380404);
	rtd_outl(0xb802c800,0x02400404);
	rtd_outl(0xb802c800,0x02480404);
	rtd_outl(0xb802c800,0x02500404);
	rtd_outl(0xb802c800,0x02580404);
	rtd_outl(0xb802c800,0x02600404);
	rtd_outl(0xb802c800,0x02680404);
	rtd_outl(0xb802c800,0x02700404);
	rtd_outl(0xb802c800,0x02780404);
	rtd_outl(0xb802c800,0x02800404);
	rtd_outl(0xb802c800,0x02880404);
	rtd_outl(0xb802c800,0x02900404);
	rtd_outl(0xb802c800,0x02980404);
	rtd_outl(0xb802c800,0x02a00404);
	rtd_outl(0xb802c800,0x02a80404);
	rtd_outl(0xb802c800,0x02b00404);
	rtd_outl(0xb802c800,0x02b80404);
	rtd_outl(0xb802c800,0x02c00404);
	rtd_outl(0xb802c800,0x02c80404);
	rtd_outl(0xb802c800,0x02d00404);
	rtd_outl(0xb802c800,0x02d80404);
	rtd_outl(0xb802c800,0x02e00404);
	rtd_outl(0xb802c800,0x02e80404);
	rtd_outl(0xb802c800,0x02f00404);
	rtd_outl(0xb802c800,0x02f80404);
	rtd_outl(0xb802c800,0x03000404);
	rtd_outl(0xb802c800,0x03080404);
	rtd_outl(0xb802c800,0x03100404);
	rtd_outl(0xb802c800,0x03180404);
	rtd_outl(0xb802c800,0x03200404);
	rtd_outl(0xb802c800,0x03280404);
	rtd_outl(0xb802c800,0x03300404);
	rtd_outl(0xb802c800,0x03380404);
	rtd_outl(0xb802c800,0x03400404);
	rtd_outl(0xb802c800,0x03480404);
	rtd_outl(0xb802c800,0x03500404);
	rtd_outl(0xb802c800,0x03580404);
	rtd_outl(0xb802c800,0x03600404);
	rtd_outl(0xb802c800,0x03680404);
	rtd_outl(0xb802c800,0x03700404);
	rtd_outl(0xb802c800,0x03780404);
	rtd_outl(0xb802c800,0x03800404);
	rtd_outl(0xb802c800,0x03880404);
	rtd_outl(0xb802c800,0x03900404);
	rtd_outl(0xb802c800,0x03980404);
	rtd_outl(0xb802c800,0x03a00404);
	rtd_outl(0xb802c800,0x03a80404);
	rtd_outl(0xb802c800,0x03b00404);
	rtd_outl(0xb802c800,0x03b80404);
	rtd_outl(0xb802c800,0x03c00404);
	rtd_outl(0xb802c800,0x03c80404);
	rtd_outl(0xb802c800,0x03d00404);
	rtd_outl(0xb802c800,0x03d80404);
	rtd_outl(0xb802c800,0x03e00404);
	rtd_outl(0xb802c800,0x03e80404);
	rtd_outl(0xb802c800,0x03f00404);
	rtd_outl(0xb802c800,0x03f80404);
	rtd_outl(0xb802c804,0x00000041);// disable access, enable gamma
	rtd_maskl(0xb802c814,0xffffffff,0x00010000);//set outgamma position is back

	rtd_outl(0xb802c500,0x00000000);// Dither Disabe

}






void panel_dpg_enable(void) // uzu color bar
{
	UINT32 width;
	UINT32 height;

	rtd_outl(0xb8029000, 0x00000031);	// DPG Color Bar

	width = (default_panel_parameter.iCONFIG_DISP_ACT_END_HPOS - default_panel_parameter.iCONFIG_DISP_ACT_STA_HPOS)
		/(default_panel_parameter.iCONFIG_SR_PIXEL_MODE+1);
	height = (default_panel_parameter.iCONFIG_DISP_ACT_END_VPOS - default_panel_parameter.iCONFIG_DISP_ACT_STA_VPOS);

	rtd_outl(0xb8029074, (width/8)-1);	// DPG Color Width
	rtd_outl(0xb8029028, (((width&0xffff)<<16)|(height&0xffff)));	// Input Size

#ifdef CONFIG_MEMC_BYPASS	// 4k2k120 use 2nd uzu
	if((default_panel_parameter.iCONFIG_DISPLAY_REFRESH_RATE == 120)&&
		(width == 3840) && (height == 2160))
	{
		rtd_outl(TWO_STEP_UZU_DM_TWO_STEP_SR_Input_Size_reg, 0x0F000870);		// Input Size (3840x2160)
		rtd_outl(TWO_STEP_UZU_DM_TWO_STEP_SR_Ctrl_reg, 0x802a8000); 	// Input Size (3840x2160)
	}
#endif

	// clear dtg & mtg force bg
	rtd_clearbits(PPOVERLAY_Display_Timing_CTRL1_reg, _BIT18);
	rtd_clearbits(PPOVERLAY_Main_Display_Control_RSV_reg, _BIT1);

}


#if 0 //ben mark unused code
void lvds_2k1k_120_4ports_script(void)
{
//#if defined(LVDS_PANEL_MILLET3_2K1K_120)
	//dpll
	rtd_outl(0xb8000190, 0x0210142A);	// M = 35, N = 3
	rtd_outl(0xb8000194, 0x01720042);	// DIV = 1 , DPLL power on
	rtd_outl(0xb8000300, 0x07500001);	// OFFSET = 1872, DPLL_CLK = 297MHz
	rtd_outl(0xb8000300, 0x07500005);	// Load in
	//dtg
	rtd_outl(0xb8028000, 0x11040000);	// free run mode, force to bg
	rtd_outl(0xb8028004, 0xC0000000);	// SR Bypass
	rtd_outl(0xb8028008, 0x0000000F);	// Hsync width
	rtd_outl(0xb802800C, 0x08970897);	// DHtotal=2200
	rtd_outl(0xb8028010, 0x00000003);	// Vsync width
	rtd_outl(0xb8028014, 0x00000464);	// DVtotal=1125
	rtd_outl(0xb8028018, 0x008c080c);	// DH_den_sta,DH_den_end
	rtd_outl(0xb802801C, 0x0016044E);	// DV_den_sta,DV_den_end
	rtd_outl(0xb8028028, 0x00000004);	// Double Buffer Control
	rtd_outl(0xb8028294, 0x00000000);	// dclk = dpll / 1 = 297MHz
	//mtg
	rtd_outl(0xb8028100, 0x00000001);	// Main Display enable
	rtd_outl(0xb8028108, 0x0CD40000);	// Main Border Color
	rtd_outl(0xb802810C, 0x00000000);	// Main Background Color
	rtd_outl(0xb8028110, 0x00000780);	// Main DEN_H_str,Main DEN_H_end
	rtd_outl(0xb8028114, 0x00000438);	// Main DEN_V_str,Main DEN_V_end
	rtd_outl(0xb8028118, 0x00000780);	// Main Background_H_str,Main Background_H_end
	rtd_outl(0xb802811C, 0x00000438);	// Main Background_V_str,Main Background_V_end
	rtd_outl(0xb8028120, 0x00000780);	// Main Active_H_str,Main Active_H_end
	rtd_outl(0xb8028124, 0x00000438);	// Main Active_V_str,Main Active_V_end
	//color bar
#ifndef CONFIG_SYS_PANEL_DISABLE_PATTERN_GEN
	rtd_outl(0xb8029000, 0x00EF0031);		// D-domain Pattern Gen Setting
#endif
	rtd_outl(0xb8029028, 0x07800438);		//Input Size (1920x1080)

	//lvds
	//------------------------------------------------------------------------------------------------------------
	//DCLK DIV
	//------------------------------------------------------------------------------------------------------------
	rtd_outl(0xb8028294, 0x00000000);	//DCLK = DPLL_Clk / 1

	//------------------------------------------------------------------------------------------------------------
	//SFG, 1 Pixel Mode, DH_ST_END = 0x008C080C, DTG_HS_Width = 16, DTG_VS_Width = 4
	//------------------------------------------------------------------------------------------------------------
	rtd_outl(0xb802D100, 0x000008c0);	//10-bit Mode, Dout Enable
	rtd_outl(0xb802D104, 0x8000FFFF);	//PIF_Clock = Dclk/4, Force to background enable
//	rtd_outl(0xb802D108, 0x23010000);	//Port A~H mapping
//	rtd_outl(0xb802D10C, 0x00000000);	//Port I~P mapping
	rtd_outl(0xb802D130, 0x00000000);	//SEG 0/1/2/3, Front/End, Odd/Even Line, no dummy pixel
	rtd_outl(0xb802D134, 0x00000000);	//SEG 4/5/6/7, Front/End, Odd/Even Line, no dummy pixel
	rtd_outl(0xb802D138, 0x00000000);	//SEG 8/9/10/11, Front/End, Odd/Even Line, no dummy pixel
	rtd_outl(0xb802D13C, 0x00000000);	//SEG 12/13/14/15, Front/End, Odd/Even Line, no dummy pixel
	rtd_outl(0xb802D140, 0x00000003);	//1-SEG, 4-Port, No H-Flip
	rtd_outl(0xb802D144, 0x00000000);	//SEG 0/1 Start
	rtd_outl(0xb802D148, 0x00000000);	//SEG 2/3 Start
	rtd_outl(0xb802D14C, 0x00000000);	//SEG 4/5 Start
	rtd_outl(0xb802D150, 0x00000000);	//SEG 6/7 Start
	rtd_outl(0xb802D154, 0x00000000);	//SEG 8/9 Start
	rtd_outl(0xb802D158, 0x00000000);	//SEG 10/11 Start
	rtd_outl(0xb802D15C, 0x00000000);	//SEG 12/13 Start
	rtd_outl(0xb802D160, 0x00000000);	//SEG 14/15 Start
	rtd_outl(0xb802D164, 0x00000000);	//Disable ByPass Mode
	rtd_outl(0xb802D168, 0x000F0798);	//HS_Width = 16 dclk = 16*Pixel_Mode*n DH_Width (����4����, n������?
						//hsync_delay = 1944 = data_length/Pixel_Mode +24
	rtd_outl(0xb802D16C, 0x00030000);	//VSYNC_ST = 0, V_SYNC = DV_Width
	rtd_outl(0xb802D170, 0x008C0086);	//sfg_dh_den_sta = DH_ST = 140
						//req_start = DH_ST - 6 = 140 - 6 = 134
	rtd_outl(0xb802D174, 0x3C000000);	//final_line_length = 1920, hsync_threshold = 0
	//------------------------------------------------------------------------------------------------------------
	//PIF
	//------------------------------------------------------------------------------------------------------------
	rtd_outl(0xb802D000, 0x00000000);	//Select LVDS(Mini-LVDS) clock & data
	rtd_outl(0xb802D010, 0x000002F0);	//PN not Swap, LVDS not Mirror, LVDS Mapping Table1, LVDS Port Enable
	//------------------------------------------------------------------------------------------------------------
	//LVDS Pin Share
	//------------------------------------------------------------------------------------------------------------
	rtd_outl(0xb8000890, 0x00000000);	//A-Port LVDS pin share
	rtd_outl(0xb8000894, 0x00000000);	//A-Port LVDS pin share
	rtd_outl(0xb8000898, 0x00000000);	//B-Port LVDS pin share
	rtd_outl(0xb80008A0, 0x00000000);	//C-Port LVDS pin share
	rtd_outl(0xb80008A4, 0x00000000);	//C-Port LVDS pin share
	rtd_outl(0xb80008A8, 0x00000000);	//D-Port LVDS pin share
	//------------------------------------------------------------------------------------------------------------
	//LVDS/mini-LVDS TX PHY
	//------------------------------------------------------------------------------------------------------------
	rtd_outl(0xb8000C00, 0xEC8DAED9);	//Current_source_0 power on, PLL_0 power ON, LDO_0 pow signal power on
						//EPI_CM_0 => Select LVDS Mode
						//VCOM_SELL_0 = 3'b100
						//IBHN_0 = 40uA, IBHX_0 = 40uA, IBTX_0 = 80uA, CML_Pre_Driver_0 = 60uA
						//PLL_CP_0 = 3pF, PLL_CS_0 = 63pF, PLL_IP_0 = 10uA
						//EPI_VSELL_0 = 2.08V
						//VCOM_0 = 40u*24/8*10.04k = 1.2048V
	rtd_outl(0xb8000C04, 0x119FE7E1);	//PLL_RS_0 = 6Kohm, PLL_PI_IP_0 = 180uA, PI_Phase_0 = ??????, PI_0 Disable
	rtd_outl(0xb8000C08, 0x00080580);	//PLL_M_0 = 7, PLL_N_0 = 1, PLL_DIV_0 = 1
						//SWAPL_0 = 0 (7bit LVDS MSB First)
						//PLL_PI_RL_0 = 2.6kohm, PLL_LDO_0 = 1.76V
						//PLL_BW_0 = 10u/(2*pi)*6k*63/(63+3)*3G/7 = 3.9MHz
	rtd_outl(0xb8000C0C, 0x0FFF0FFF);	//Data/Clock_Selection_0 (LVDS Mode, All Pair PI Bypass)
	rtd_outl(0xb8000C10, 0x00000000);	//Pre-emphasis_enable_0 = 0, LAG_0 Disable
	rtd_outl(0xb8000C14, 0x00000000);	//segmented_transition_enable_0 = 0; EPI_Mode_0 disable
	rtd_outl(0xb8000C18, 0x00000FFF);	//Parallel_Resistor_0 Disable (double driving disable), TX_differential_0 enable
	rtd_outl(0xb8000C1C, 0x00AAAAAA);	//Parallel_Resistor_0 = 100ohm
	rtd_outl(0xb8000C20, 0x00000000);	//segmented_transition_timing_0 = (2'b00 => T0=slow, T1=slow)
	rtd_outl(0xb8000C2C, 0x00000000);	//Pre-emphasis_0 = X4 (the weakest)
	rtd_outl(0xb8000C30, 0x00000000);	//Pre-emphasis_0 = X4 (the weakest)
	rtd_outl(0xb8000C34, 0x0000000F);	//NMOS segmented_transition_current_0 = (the stongest)
	rtd_outl(0xb8000C38, 0xFFFFFFFF);	//NMOS segmented_transition_current_0 = (the stongest)
	rtd_outl(0xb8000C3C, 0x0000000F);	//PMOS segmented_transition_current_0 = (the stongest)
	rtd_outl(0xb8000C40, 0xFFFFFFFF);	//PMOS segmented_transition_current_0 = (the stongest)
	rtd_outl(0xb8000C44, 0x0E739CE7);	//SL_0 = 5'b11100 (3*13=x39)
	rtd_outl(0xb8000C48, 0x39CE739C);	//SL_0 = 5'b11100 (2*13=x39)
						//Iout_0 = 40u*8/4*39=3.12mA
	rtd_outl(0xb8000C50, 0xEC8DAED9);	//Current_source_1 power on, PLL_1 power ON, LDO_1 pow signal power on
						//EPI_CM_1 => Select LVDS Mode
						//VCOM_SELL_1 = 3'b100
						//IBHN_1 = 40uA, IBHX_1 = 40uA, IBTX_1 = 80uA, CML_Pre_Driver_1 = 60uA
						//PLL_CP_1 = 3pF, PLL_CS_1 = 63pF, PLL_IP_1 = 10uA
						//EPI_VSELL_1 = 2.08V
						//VCOM_1 = 40u*24/8*10.04k = 1.2048V
	rtd_outl(0xb8000C54, 0x219FE7E1);	//PLL_RS_1 = 6Kohm, PLL_PI_IP_1 = 180uA, PI_Phase_1 = ??????, PI_1 Disable
	rtd_outl(0xb8000C58, 0x00080580);	//PLL_M_1 = 7, PLL_N_1 = 1, PLL_DIV_1 = 1
						//SWAPL_1 = 0 (7bit LVDS MSB First)
						//PLL_PI_RL_1 = 2.6kohm, PLL_LDO_1 = 1.76V
						//PLL_BW_1 = 10u/(2*pi)*6k*63/(63+3)*3G/7 = 3.9MHz
	rtd_outl(0xb8000C5C, 0x0FFF0FFF);	//Data/Clock_Selection_1 (LVDS Mode, All Pair PI Bypass)
	rtd_outl(0xb8000C60, 0x00000000);	//Pre-emphasis_enable_1 = 0, LAG_1 Disable
	rtd_outl(0xb8000C64, 0x00000000);	//segmented_transition_enable_1 = 0; EPI_Mode_1 disable
	rtd_outl(0xb8000C68, 0x00000FFF);	//Parallel_Resistor_1 Disable (double driving disable), TX_differential_1 enable
	rtd_outl(0xb8000C6C, 0x00AAAAAA);	//Parallel_Resistor_1 = 100ohm
	rtd_outl(0xb8000C70, 0x00000000);	//segmented_transition_timing_1 = 2'b00 => (T0=slow, T1=slow)
	rtd_outl(0xb8000C7C, 0x00000000);	//Pre-emphasis_1 = X4 (the weakest)
	rtd_outl(0xb8000C80, 0x00000000);	//Pre-emphasis_1 = X4 (the weakest)
	rtd_outl(0xb8000C84, 0x0000000F);	//NMOS segmented_transition_current_1 = (the stongest)
	rtd_outl(0xb8000C88, 0xFFFFFFFF);	//NMOS segmented_transition_current_1 = (the stongest)
	rtd_outl(0xb8000C8C, 0x0000000F);	//PMOS segmented_transition_current_1 = (the stongest)
	rtd_outl(0xb8000C90, 0xFFFFFFFF);	//PMOS segmented_transition_current_1 = (the stongest)
	rtd_outl(0xb8000C94, 0x0E739CE7);	//SL_1 = 5'b01110 (3*13=x39)
	rtd_outl(0xb8000C98, 0x39CE739C);	//SL_1 = 5'b01110 (3*13=x39)
						//Iout_1 = 40u*8/4*39=3.12mA
	//rtd_outl(0xb800DA40, 0x03000202);	// HDMI Power Enable
	printf("========= lvds_2k1k_120_4ports_script : LVDS/mini-LVDS TX PHY ==========\n");

//#endif
}
#endif

#if 0 // cklai@mark unused code
void lvds_4k2k_30_4ports_script(void)
{
//#if defined(LVDS_PANEL_MILLET3_4K2K_30)
	//set dpll
	rtd_outl(0xb8000490, 0x0210142A);	// M = 35, N = 3
	rtd_outl(0xb8000494, 0x01720042);	// DIV = 1 , DPLL power on
	rtd_outl(0xb8000640, 0x07500001);	// OFFSET = 1872, DPLL_CLK = 297MHz
	rtd_outl(0xb8000640, 0x07500005);	// Load in
	//dtg 4k2k
	rtd_outl(0xb8028000, 0x11000000);	// free run mode
	rtd_outl(0xb8028004, 0xC5000000);	// SR Bypass
	rtd_outl(0xb8028008, 0x0000000F);	// Hsync width
	rtd_outl(0xb802800C, 0x112F112F);	// DHtotal=4400
	rtd_outl(0xb8028010, 0x00000005);	// Vsync widths
	rtd_outl(0xb8028014, 0x000008C9);	// DVtotal=2250
	rtd_outl(0xb8028018, 0x01181018);	// DH_den_sta,DH_den_end
	rtd_outl(0xb802801C, 0x002d089d);	// DV_den_sta,DV_den_end
	rtd_outl(0xb8028028, 0x00000004);	// Double Buffer Control
	rtd_outl(0xb8028294, 0x00000000);	// dclk = dpll / 1 = 297MHz
	//mtg 4k2k
	rtd_outl(0xb8028100, 0x00008C01);	// Main Display enable
	rtd_outl(0xb8028108, 0x0CD40000);	// Main Border Color
	rtd_outl(0xb802810C, 0x00000000);	// Main Background Color
	rtd_outl(0xb8028110, 0x00000F00);	// Main DEN_H_str,Main DEN_H_end
	rtd_outl(0xb8028114, 0x00000870);	// Main DEN_V_str,Main DEN_V_end
	rtd_outl(0xb8028118, 0x00000F00);	// Main Background_H_str,Main Background_H_end
	rtd_outl(0xb802811C, 0x00000870);	// Main Background_V_str,Main Background_V_end
	rtd_outl(0xb8028120, 0x00000F00);	// Main Active_H_str,Main Active_H_end
	rtd_outl(0xb8028124, 0x00000870);	// Main Active_V_str,Main Active_V_end
	//color bar
	rtd_outl(0xb8029000, 0x01DF0031);		// D-domain Pattern Gen Setting
	rtd_outl(0xb8029028, 0x0F000870);		//Input Size
	// lvds 4k2k 4port 1pixel 1seg
	//------------------------------------------------------------------------------------------------------------
	//SFG, 1 Pixel Mode, DTG_DH_ST_END = 0x01181018, DTG_HS_Width = 64, DTG_VS_Width = 8
	//------------------------------------------------------------------------------------------------------------
	rtd_outl(0xb802D100, 0x00000840);	//10-bit Mode, Dout Enable
	rtd_outl(0xb802D104, 0x8000FFFF);	//PIF_Clock = Dclk/4, Force to background enable
//	rtd_outl(0xb802D108, 0x23010000);	//Port A~H mapping
//	rtd_outl(0xb802D10C, 0x89ABCDEF);	//Port I~P mapping
	rtd_outl(0xb802D130, 0x00000000);	//SEG 0/1/2/3, Front/End, Odd/Even Line, no dummy pixel
	rtd_outl(0xb802D134, 0x00000000);	//SEG 4/5/6/7, Front/End, Odd/Even Line, no dummy pixel
	rtd_outl(0xb802D138, 0x00000000);	//SEG 8/9/10/11, Front/End, Odd/Even Line, no dummy pixel
	rtd_outl(0xb802D13C, 0x00000000);	//SEG 12/13/14/15, Front/End, Odd/Even Line, no dummy pixel
	rtd_outl(0xb802D140, 0x00000003);	//1-SEG, 4-Port, No H-Flip
	rtd_outl(0xb802D144, 0x00000000);	//SEG 0/1 Start
	rtd_outl(0xb802D148, 0x00000000);	//SEG 2/3 Start
	rtd_outl(0xb802D14C, 0x00000000);	//SEG 4/5 Start
	rtd_outl(0xb802D150, 0x00000000);	//SEG 6/7 Start
	rtd_outl(0xb802D154, 0x00000000);	//SEG 8/9 Start
	rtd_outl(0xb802D158, 0x00000000);	//SEG 10/11 Start
	rtd_outl(0xb802D15C, 0x00000000);	//SEG 12/13 Start
	rtd_outl(0xb802D160, 0x00000000);	//SEG 14/15 Start
	rtd_outl(0xb802D164, 0x00000000);	//Disable ByPass Mode
	rtd_outl(0xb802D168, 0x00400F18);	//HS_Width = 64 dclk (����4����, n������?
										//hsync_delay = 984 = data_length/Pixel_Mode +24
	rtd_outl(0xb802D16C, 0x00070000);	//VSYNC_ST = 0, V_SYNC = DV_Width
	rtd_outl(0xb802D170, 0x01180112);	//sfg_dh_den_sta = DH_ST / pixel_mode = 280/4, req_start = DH_ST / pixel_mode - 6 = 280 - 6 = 274
	rtd_outl(0xb802D174, 0x78000000);	//final_line_length = 3840, hsync_threshold = 0

	//------------------------------------------------------------------------------------------------------------
	//PIF
	//------------------------------------------------------------------------------------------------------------
	rtd_outl(0xb802D000, 0x00000000);	//Select LVDS(Mini-LVDS) clock & data
	rtd_outl(0xb802D010, 0x000002F0);	//PN not Swap, LVDS not Mirror, LVDS Mapping Table1, LVDS Port Enable

	//------------------------------------------------------------------------------------------------------------
	//LVDS Pin Share
	//------------------------------------------------------------------------------------------------------------
	rtd_outl(0xb8000890, 0x00000000);	//A-Port LVDS pin share
	rtd_outl(0xb8000894, 0x00000000);	//A-Port LVDS pin share
	rtd_outl(0xb8000898, 0x00000000);	//B-Port LVDS pin share
	rtd_outl(0xb80008A0, 0x00000000);	//C-Port LVDS pin share
	rtd_outl(0xb80008A4, 0x00000000);	//C-Port LVDS pin share
	rtd_outl(0xb80008A8, 0x00000000);	//D-Port LVDS pin share

	//------------------------------------------------------------------------------------------------------------
	//LVDS/mini-LVDS TX PHY
	//------------------------------------------------------------------------------------------------------------
	rtd_outl(0xb8000C00, 0xEC8DAED9);	//Current_source_0 power on, PLL_0 power ON, LDO_0 pow signal power on
						//EPI_CM_0 => Select LVDS Mode
						//VCOM_SELL_0 = 3'b100
						//IBHN_0 = 40uA, IBHX_0 = 40uA, IBTX_0 = 80uA, CML_Pre_Driver_0 = 60uA
						//PLL_CP_0 = 3pF, PLL_CS_0 = 63pF, PLL_IP_0 = 10uA
						//EPI_VSELL_0 = 2.08V
						//VCOM_0 = 40u*24/8*10.04k = 1.2048V
	rtd_outl(0xb8000C04, 0x119FE7E1);	//PLL_RS_0 = 6Kohm, PLL_PI_IP_0 = 180uA, PI_Phase_0 = ??????, PI_0 Disable
	rtd_outl(0xb8000C08, 0x00080580);	//PLL_M_0 = 7, PLL_N_0 = 1, PLL_DIV_0 = 1
						//SWAPL_0 = 0 (7bit LVDS MSB First)
						//PLL_PI_RL_0 = 2.6kohm, PLL_LDO_0 = 1.76V
						//PLL_BW_0 = 10u/(2*pi)*6k*63/(63+3)*3G/7 = 3.9MHz
	rtd_outl(0xb8000C0C, 0x0FFF0FFF);	//Data/Clock_Selection_0 (LVDS Mode, All Pair PI Bypass)
	rtd_outl(0xb8000C10, 0x00000000);	//Pre-emphasis_enable_0 = 0, LAG_0 Disable
	rtd_outl(0xb8000C14, 0x00000000);	//segmented_transition_enable_0 = 0; EPI_Mode_0 disable
	rtd_outl(0xb8000C18, 0x00000FFF);	//Parallel_Resistor_0 Disable (double driving disable), TX_differential_0 enable
	rtd_outl(0xb8000C1C, 0x00AAAAAA);	//Parallel_Resistor_0 = 100ohm
	rtd_outl(0xb8000C20, 0x00000000);	//segmented_transition_timing_0 = (2'b00 => T0=slow, T1=slow)
	rtd_outl(0xb8000C2C, 0x00000000);	//Pre-emphasis_0 = X4 (the weakest)
	rtd_outl(0xb8000C30, 0x00000000);	//Pre-emphasis_0 = X4 (the weakest)
	rtd_outl(0xb8000C34, 0x0000000F);	//NMOS segmented_transition_current_0 = (the stongest)
	rtd_outl(0xb8000C38, 0xFFFFFFFF);	//NMOS segmented_transition_current_0 = (the stongest)
	rtd_outl(0xb8000C3C, 0x0000000F);	//PMOS segmented_transition_current_0 = (the stongest)
	rtd_outl(0xb8000C40, 0xFFFFFFFF);	//PMOS segmented_transition_current_0 = (the stongest)
	rtd_outl(0xb8000C44, 0x0E739CE7);	//SL_0 = 5'b11100 (3*13=x39)
	rtd_outl(0xb8000C48, 0x39CE739C);	//SL_0 = 5'b11100 (2*13=x39)
						//Iout_0 = 40u*8/4*39=3.12mA
	rtd_outl(0xb8000C50, 0xEC8DAED9);	//Current_source_1 power on, PLL_1 power ON, LDO_1 pow signal power on
						//EPI_CM_1 => Select LVDS Mode
						//VCOM_SELL_1 = 3'b100
						//IBHN_1 = 40uA, IBHX_1 = 40uA, IBTX_1 = 80uA, CML_Pre_Driver_1 = 60uA
						//PLL_CP_1 = 3pF, PLL_CS_1 = 63pF, PLL_IP_1 = 10uA
						//EPI_VSELL_1 = 2.08V
						//VCOM_1 = 40u*24/8*10.04k = 1.2048V
	rtd_outl(0xb8000C54, 0x219FE7E1);	//PLL_RS_1 = 6Kohm, PLL_PI_IP_1 = 180uA, PI_Phase_1 = ??????, PI_1 Disable
	rtd_outl(0xb8000C58, 0x00080580);	//PLL_M_1 = 7, PLL_N_1 = 1, PLL_DIV_1 = 1
						//SWAPL_1 = 0 (7bit LVDS MSB First)
						//PLL_PI_RL_1 = 2.6kohm, PLL_LDO_1 = 1.76V
						//PLL_BW_1 = 10u/(2*pi)*6k*63/(63+3)*3G/7 = 3.9MHz
	rtd_outl(0xb8000C5C, 0x0FFF0FFF);	//Data/Clock_Selection_1 (LVDS Mode, All Pair PI Bypass)
	rtd_outl(0xb8000C60, 0x00000000);	//Pre-emphasis_enable_1 = 0, LAG_1 Disable
	rtd_outl(0xb8000C64, 0x00000000);	//segmented_transition_enable_1 = 0; EPI_Mode_1 disable
	rtd_outl(0xb8000C68, 0x00000FFF);	//Parallel_Resistor_1 Disable (double driving disable), TX_differential_1 enable
	rtd_outl(0xb8000C6C, 0x00AAAAAA);	//Parallel_Resistor_1 = 100ohm
	rtd_outl(0xb8000C70, 0x00000000);	//segmented_transition_timing_1 = 2'b00 => (T0=slow, T1=slow)
	rtd_outl(0xb8000C7C, 0x00000000);	//Pre-emphasis_1 = X4 (the weakest)
	rtd_outl(0xb8000C80, 0x00000000);	//Pre-emphasis_1 = X4 (the weakest)
	rtd_outl(0xb8000C84, 0x0000000F);	//NMOS segmented_transition_current_1 = (the stongest)
	rtd_outl(0xb8000C88, 0xFFFFFFFF);	//NMOS segmented_transition_current_1 = (the stongest)
	rtd_outl(0xb8000C8C, 0x0000000F);	//PMOS segmented_transition_current_1 = (the stongest)
	rtd_outl(0xb8000C90, 0xFFFFFFFF);	//PMOS segmented_transition_current_1 = (the stongest)
	rtd_outl(0xb8000C94, 0x0E739CE7);	//SL_1 = 5'b01110 (3*13=x39)
	rtd_outl(0xb8000C98, 0x39CE739C);	//SL_1 = 5'b01110 (3*13=x39)
						//Iout_1 = 40u*8/4*39=3.12mA
	rtd_outl(0xb800DA40, 0x03000202);	// HDMI Power Enable
	//rtd_outl(0xb8020000, 0x000001FF);	// HDMI Power Enable


//#endif
}
#endif

#if 0 //ben marked unused code
void EPI_FHD_60HZ_Script(void)
{
	// Case for LGD demo
	// TM120,FHD,60HZ,32" Panel
	//

	// Bypass 12V panel power to EPI connector
	rtd_outl(0xb8061100, 0x00000010);		// bit4=1
	rtd_outl(0xb8061108, 0x00000010);		// bit4=1

	//set dpll
	rtd_outl(0xb8000490, 0x0210412A);	// M = 35, N = 6 for 148.5Mhz, IB=2u
	rtd_outl(0xb8000494, 0x01720042);	// DIV = 1 , DPLL power on
	rtd_outl(0xb8000640, 0x07500001);	// OFFSET = 1872, DPLL_CLK = 297MHz
	rtd_outl(0xb8000640, 0x07500005);	// Load in

	//set dtg
	rtd_outl(0xb8028000, 0x11000000);	// free run mode
	rtd_outl(0xb8028004, 0xC0000000);	// SR Bypass
	rtd_outl(0xb8028008, 0x0000000F);	// Hsync width
	rtd_outl(0xb802800C, 0x08970897);	// DHtotal=2200
	rtd_outl(0xb8028010, 0x00000003);	// Vsync width
	rtd_outl(0xb8028014, 0x00000464);	// DVtotal=1125
	rtd_outl(0xb8028018, 0x008c080c);	// DH_den_sta,DH_den_end
	rtd_outl(0xb802801C, 0x0016044E);	// DV_den_sta,DV_den_end
	rtd_outl(0xb8028028, 0x00000004);	// Double Buffer Control
	rtd_outl(0xb8028294, 0x00000000);	// dclk = dpll / 1 = 297MHz

	//set mtg
	rtd_outl(0xb8028100, 0x00000001);	// Main Display enable
	rtd_outl(0xb8028108, 0x0CD40000);	// Main Border Color
	rtd_outl(0xb802810C, 0x00000000);	// Main Background Color
	rtd_outl(0xb8028110, 0x00000780);	// Main DEN_H_str,Main DEN_H_end
	rtd_outl(0xb8028114, 0x00000438);	// Main DEN_V_str,Main DEN_V_end
	rtd_outl(0xb8028118, 0x00000780);	// Main Background_H_str,Main Background_H_end
	rtd_outl(0xb802811C, 0x00000438);	// Main Background_V_str,Main Background_V_end
	rtd_outl(0xb8028120, 0x00000780);	// Main Active_H_str,Main Active_H_end
	rtd_outl(0xb8028124, 0x00000438);	// Main Active_V_str,Main Active_V_end

	//D pattern gen
	rtd_outl(0xb8029000, 0x00EF0031);		// D-domain Pattern Gen Setting
	rtd_outl(0xb8029028, 0x07800438);		//Input Size (1920x1080)


	// EPI/LVDS pin share.
	// Select EPI mode
	rtd_outl(0xB802D000,0x00000001); // Select EPI mode.
	rtd_outl(0xb802D010,0x00000000); // Disable LVDS port

	rtd_outl(0xb8000890,0x00000000); //A-Port LVDS pin share
	rtd_outl(0xb8000894,0x00000000); //A-Port LVDS pin share
	rtd_outl(0xb8000898,0x00000000); //B-Port LVDS pin share
	rtd_outl(0xb80008A0,0x00000000); //C-Port LVDS pin share
	rtd_outl(0xb80008A4,0x00000000); //C-Port LVDS pin share
	rtd_outl(0xb80008A8,0x00000000); //D-Port LVDS pin share

	//------------------------------------------------------------------------------------------------------------
	//SFG, 1 Pixel Mode, DH_ST_END = 0x008C080C, DTG_HS_Width = 16, DTG_VS_Width = 4
	//------------------------------------------------------------------------------------------------------------
	rtd_outl(0xb802D100,0x00101860); //8-bit Mode, Dout Enable, 2nd line shift 1 sub-pixel, Post R/B Swap
	rtd_outl(0xb802D104,0x0000FFFF); //Force to background enable
	rtd_outl(0xb802D108,0x54321000); //Port A~H mapping 6port. (*)
	rtd_outl(0xb802D10C,0x89abcdef); //Port I~P mapping
	rtd_outl(0xb802D130,0x00000000); //SEG 0/1/2/3, Front/End, Odd/Even Line, no dummy pixel
	rtd_outl(0xb802D134,0x00000000); //SEG 4/5/6/7, Front/End, Odd/Even Line, no dummy pixel
	rtd_outl(0xb802D138,0x00000000); //SEG 8/9/10/11, Front/End, Odd/Even Line, no dummy pixel
	rtd_outl(0xb802D13C,0x00000000); //SEG 12/13/14/15, Front/End, Odd/Even Line, no dummy pixel
	rtd_outl(0xb802D140,0x00001055); //6-SEG, 6-Port, No H-Flip (*), bit12=1=Req_from_epi.
	rtd_outl(0xb802D144,0x00000140); //SEG 0/1 Start (*)
	rtd_outl(0xb802D148,0x028003C0); //SEG 2/3 Start (*)
	rtd_outl(0xb802D14C,0x05000640); //SEG 4/5 Start (*)
	rtd_outl(0xb802D150,0x00000000); //SEG 6/7 Start
	rtd_outl(0xb802D154,0x00000000); //SEG 8/9 Start
	rtd_outl(0xb802D158,0x00000000); //SEG 10/11 Start
	rtd_outl(0xb802D15C,0x00000000); //SEG 12/13 Start
	rtd_outl(0xb802D160,0x00000000); //SEG 14/15 Start
	rtd_outl(0xb802D164,0x40000000); //Disable ByPass Mode, bit30=1=auto_config_sfg_timing_gen
	rtd_outl(0xb802D168,0x000F0798); //HS_Width = 16 dclk = 16*Pixel_Mode*n DH_Width (multiple for 4, n is constant)
	                                 //hsync_delay = 1944 = data_length/Pixel_Mode +24
	rtd_outl(0xb802D16C,0x00030000); //VSYNC_ST = 0, V_SYNC = DV_Width
	rtd_outl(0xb802D170,0x008C0086); //sfg_dh_den_sta = DH_ST = 140
	                                 //req_start = DH_ST - 6 = 140 - 6 = 134
	rtd_outl(0xb802D174,0x3C000000); //final_line_length = 1920, hsync_threshold = 0

	//#include "epi_mac.tbl"
	// EPI MAC-layer configuration

	rtd_outl(0xB802D500,0x00000015); // CTR_Start=0x15,CTR_Start_dummy=0x0,P/N no swap.
	rtd_outl(0xB802D504,0x00000020); // SOE for FSM use, depends on PORCH num. (ex:2200-1920=280)
	                                 // soe_sta_num = Phase1_preamble_length
	                                 //     Value="set"+4
	                                 //     Set Phase1_len = Porch-Phase2_len =280/6-4=36 => Set 32.
	                                 // soe_width_num = Phase2_preamble_length
	                                 //     Value="set"+0
	                                 //     Set "0" = Phase2_len = 4+0=4  => Set 0
	rtd_outl(0xB802D508,0x00011506); // SOE for LGD use.
	                                 // V13:soe_sta_pkt=soe_end(8b)="Last data to falling"
	                                 //     RTK wr style => value="set"+0
	                                 //     LGD rd style => Value="set"+4, Timing min.=10 => v13 needs 10, So we set "6"
	                                 // V13:soe_width_pkt=soe_Start(10b)="First data to rising"
	                                 //     RTK wr style => value="set"+0
	                                 //     LGD rd style => vlaue="set"+3, Timing min.=3 => v13 needs 280, So we set "277"
	rtd_outl(0xB802D50C,0x00000090); // CTR2:Register value for CTR2.(LTD2,LBR=1, others:0)
	rtd_outl(0xB802D510,0xFFFFFFF1); // CTR2:Select CTR2(c0 ~c5 ) source. From Tcon or Register(all "1"). (c0 from tcon17)
	rtd_outl(0xB802D514,0xFFF9FFFF); // CTR2:Select CTR2(c6 ~c11) source. From Tcon or Register(all "1"). (c9 from tcon19)
	rtd_outl(0xB802D518,0xFFFFFFFF); // CTR2:Select CTR2(c12~c17) source. From Tcon or Register(all "1").
	rtd_outl(0xB802D51C,0xFFFFFFFF); // CTR2:Select CTR2(c18~c23) source. From Tcon or Register(all "1").
	rtd_outl(0xB802D520,0xFFFFFFFF); // CTR2:Select CTR2(c24~c29) source. From Tcon or Register(all "1").
	rtd_outl(0xB802D524,0x00000000); // CTR3: reserved for future. bit30=0 to disable.
	rtd_outl(0xB802D528,0x0000002A); // Data_Start=0x2A,Data_Start_dummy=0x0.
	rtd_outl(0xB802D52C,0x08000000); // Bit31=0=No_data_in.(Bit30=1 to reset), Bit29=0=PRBS7_OFF, 8bit

	rtd_outl(0xB802D530,0xC0000000); // EPI mode setting, bit[1]=1=lock_source_from_hw.

	//#include "epi_phy.tbl"
	// EPI mode configuration
	// FHD 60hz input, 6lane, 8bit mode
	// Data_rate=148.5M*14/3=693Mbps

	//===== DCLK DIV =====
	rtd_outl(0xb8028294,0x00000000); // bit[1:0]=00(DCLK=DPLL_Clk/1),(00:/1, 01:/2, 10:/4)

	//===== PHY layer, Phy0 for port A,B =====
	rtd_outl(0xB8000C00,0xEECDFED8); // bit25=1=EPI_mode, bit[23:21]=110=0.9V.
	rtd_outl(0xB8000C04,0x119FE7E1); //
	rtd_outl(0xB8000C08,0x00380C80); // bit[21:20]=2'b11=EPI_LSB, bit[14:8]=M_code=12(Value=12+2=14).
	rtd_outl(0xB8000C0C,0x0FFF0FFF); // Select=1 for data, P2S not reset
	rtd_outl(0xB8000C10,0x00000000); // pre-emphasis=disable, p2s phase don't select.
	rtd_outl(0xB8000C14,0x00000FFF); // TXEPIENL=slew_control_bypass, 1:bypass(EPI), 0:not bypass
	rtd_outl(0xB8000C18,0x0FFF0FFF); // Differential mode=enable, Int.Z=ON
	rtd_outl(0xB8000C1C,0x00AAAAAA); // Z=10=100ohm (00:140ohm,01:120ohm,10:100ohm,11:80ohm)
	rtd_outl(0xB8000C20,0x00000000); // Tx SR selection 0:SR_on, 1:SR_off
	rtd_outl(0xB8000C24,0x00000000); // TTLI mode=not select
	rtd_outl(0xB8000C28,0x00000000); // TTLO mode=not select
	rtd_outl(0xB8000C2C,0x00000000); // Pre-emphasis swing selection=not select
	rtd_outl(0xB8000C30,0x00000000); // Pre-emphasis swing selection=not select
	rtd_outl(0xB8000C34,0x0000000F); // NMOS switch selection=not select (Sharp=on)
	rtd_outl(0xB8000C38,0xFFFFFFFF); // NMOS switch selection=not select (Sharp=on)
	rtd_outl(0xB8000C3C,0x0000000F); // PMOS switch selection=not select (Sharp=on)
	rtd_outl(0xB8000C40,0xFFFFFFFF); // PMOS switch selection=not select (Sharp=on)
	rtd_outl(0xB8000C44,0x0E739CE7); // Swing select=default=11100
	rtd_outl(0xB8000C48,0x39CE739C); // Swing select=default=11100

	//================================= Mux Setting ===================================
	rtd_outl(0xb800DA40,0x03000202); // HDMI Power Enable (PHY power supply)

	//#include "tcon_noSSCG.tbl"
	//Tcon Setting
	rtd_outl(0xb802D208, 0x00000000);	// Disable across frame and across line 3 Function
	rtd_outl(0xb802D464, 0x00000001);	// Enable Timing Controller Function

	// GST, TCON10 + TCON11, LVDS_C_DN, 14
	rtd_outl(0xb802D2D8, 0x08140824);	// TCON10 H_ST_END
	rtd_outl(0xb802D2DC, 0x04520454);	// TCON10 V_ST_END
	rtd_outl(0xb802D2E0, 0x00400080);	// TCON10 Ctrl, Normal Mode, noSSCG
	rtd_outl(0xb802D420, 0x00001680);	// TCON10 noSSCG ST_END
	rtd_outl(0xb802D2F0, 0x00940094);	// TCON11 H_ST_END
	rtd_outl(0xb802D2F4, 0x00100013);	// TCON11 V_ST_END
	rtd_outl(0xb802D2F8, 0x00420180);	// TCON11 Ctrl
	rtd_outl(0xb802D424, 0x000017C0);	// TCON11 noSSCG ST_END

	// MCLK, TCON9, LVDS_C_DP, 13
	rtd_outl(0xb802D2C0, 0x009400A4);	// TCON9 H_ST_END
	rtd_outl(0xb802D2C4, 0x00140452);	// TCON9 V_ST_END
	rtd_outl(0xb802D2C8, 0x00400080);	// TCON9 Ctrl, Normal Mode, noSSCG
	rtd_outl(0xb802D41C, 0x04E00640);	// TCON9 noSSCG ST_END

	// GCLK, TCON4 + TCON5 + TCON6 + TCON7, LVDS_C_EN, 12
	rtd_outl(0xb802D25C, 0x00940094);	// TCON4 H_ST_END
	rtd_outl(0xb802D260, 0x0011021F);	// TCON4 V_ST_END
	rtd_outl(0xb802D264, 0x00400380);	// TCON4 Ctrl, Across_Line_1
	rtd_outl(0xb802D268, 0x00020001);	// TCON4 Across_Line_3, RP = 2, HP = 1
	rtd_outl(0xb802D408, 0x098C10F8);	// TCON4 noSSCG ST_END
	rtd_outl(0xb802D270, 0x00940094);	// TCON5 H_ST_END
	rtd_outl(0xb802D274, 0x0010021F);	// TCON5 V_ST_END
	rtd_outl(0xb802D278, 0x00420380);	// TCON5 Ctrl, Across_Line_1, TCON5_noSSCG or TCON4_noSSCG
	rtd_outl(0xb802D27C, 0x00020001);	// TCON5 Across_Line_3, RP = 2, HP = 1
	rtd_outl(0xb802D40C, 0x098C10F8);	// TCON5 noSSCG ST_END
	rtd_outl(0xb802D284, 0x00940094);	// TCON6 H_ST_END
	rtd_outl(0xb802D288, 0x00100013);	// TCON6 V_ST_END
	rtd_outl(0xb802D28C, 0x00610180);	// TCON6 Ctrl, Across_Line_1 Mode, TCON inverse, TCON6_noSSCG and TCON5_noSSCG
	rtd_outl(0xb802D410, 0x000017C0);	// TCON6 noSSCG ST_END
	rtd_outl(0xb802D298, 0x08140824);	// TCON7 H_ST_END
	rtd_outl(0xb802D29C, 0x044E0454);	// TCON7 V_ST_END (V_END - 1)
	rtd_outl(0xb802D2A0, 0x00420080);	// TCON7 Ctrl, Normal Mode, TCON7_noSSCG or TCON6_noSSCG
	rtd_outl(0xb802D414, 0x00001680);	// TCON7 noSSCG ST_END

	// EO, TCON12 + TCON13, LVDS_C_CP, 15
	rtd_outl(0xb802D304, 0x08140814);	// TCON12 H_ST_END
	rtd_outl(0xb802D308, 0x04560456);	// TCON12 V_ST_END
	rtd_outl(0xb802D30C, 0x00000480);	// TCON12 Ctrl
	rtd_outl(0xb802D314, 0x0000007D);	// TCON12 Across Frame Period
	rtd_outl(0xb802D31C, 0x08740874);	// TCON13 H_ST_END
	rtd_outl(0xb802D320, 0x04560456);	// TCON13 V_ST_END
	rtd_outl(0xb802D324, 0x00000483);	// TCON13 Ctrl
	rtd_outl(0xb802D32C, 0x0000007D);	// TCON13 Across Frame Period

	// POL, TCON16 + TCON17, for EPI, 17
	rtd_outl(0xb802D358, 0x00020002);	// TCON16 H_ST_END
	rtd_outl(0xb802D35C, 0x00000000);	// TCON16 V_ST_END
	rtd_outl(0xb802D360, 0x00000480);	// TCON16 Ctrl
	rtd_outl(0xb802D368, 0x00000000);	// TCON16 Across Frame Period
	rtd_outl(0xb802D36C, 0x00020002);	// TCON17 H_ST_END
	rtd_outl(0xb802D370, 0x00000119);	// TCON17 V_ST_END
	rtd_outl(0xb802D374, 0x00000383);	// TCON17 Ctrl
	rtd_outl(0xb802D378, 0x00040003);	// TCON17 Across Line 3 HP/RP

	// GSP, TCON19, for EPI, LVDS_D_FN, 30
	rtd_outl(0xb802D394, 0x03C003C0);	// TCON19 H_ST_END
	rtd_outl(0xb802D398, 0x00150017);	// TCON19 V_ST_END
	rtd_outl(0xb802D39C, 0x00000180);	// TCON19 Ctrl

	// TEST, TCON15, for LVDS_C_CN, 16
	rtd_outl(0xb802D344, 0x00940814);
	rtd_outl(0xb802D348, 0x0016044E);
	rtd_outl(0xb802D34C, 0x00000180);

	rtd_outl(0xb802D208, 0x00000002);	// Enable across frame and across line 3 Function
	rtd_outl(0xb80004E4, 0x00000008);	// audio clock enable

	// must put here...??
	rtd_outl(0xb8022294, 0x0000001F);		// TTL out

	// Pin_mux setting

	// Tcon output
	rtd_outl(0xb80008A0, 0xFFF33333);	// LVDS C Port Pin Share to Tcon
	rtd_outl(0xb80008A4, 0x33000000);	// LVDS C Port Pin Share to Tcon
	rtd_outl(0xb80008A8, 0x33FF0000);	// LVDS D Port Pin Share to Tcon
	rtd_outl(0xb8000C68, 0x00000000);	// Disable differential mode
	rtd_outl(0xb8000C78, 0x00FFFFFF);	// TXPHY TTLI Enable

	// GPO setting
	rtd_outl(0xb801BC0C, 0x000000E0);	// GPIO_101=VCOMDYN=GPO=1, GPIO_102=WP=GPO=1, GPIO_103=REVERSE=GPO=1
	rtd_outl(0xb801BC24, 0x000000E0);	// GPIO_101=VCOMDYN=GPO=1, GPIO_102=WP=GPO=1, GPIO_103=REVERSE=GPO=1
}
#endif


#if 0 // cklai@mark unused code
void
panel_sys_set_wait_us(
    UINT32 us )	/* Interval in microseconds			*/
{
    UINT32 last;
    panel_wait_us_first = rtd_inl(0xb801b638);
    last  = panel_wait_us_first + 27*us;

    DEBUG_PRINT("set wait us=%d, current=%d\n", us, panel_wait_us_first);

    if (last >= panel_wait_us_first)
		panel_wait_is_wrap = 0;
    else
		panel_wait_is_wrap = 1;

}
#endif

#if defined(Config_Board_TV010_PANEL)
void panel_ld_18R_spi_init(void)
{

	//AS Mode SPI0 SRC1
	rtd_part_outl(0xb80008b8,29,28,0x1);    //ld_spi0_p2_sck_src0/src1
	rtd_part_outl(0xb80008b8,25,24,0x1);    //ld_spi0_p3_sdo_src0/src1
	rtd_part_outl(0xb80008b8,21,20,0x1);    //ld_spi0_p4_sdi_src0/src1

	rtd_part_outl(0xb8000800,31,28,0x7);    //7 D8: ld_spi0_p1_cs1,<O>           gpio_0
	rtd_part_outl(0xb8000800,23,20,0x7);    //7 E8: ld_spi0_p2_sck_src1,<I/O>    gpio_1
	rtd_part_outl(0xb8000800,15,12,0x7);    //7 E7: ld_spi0_p3_sdo_SRC1,<I/O>    gpio_2
	rtd_part_outl(0xb8000c80,31,28,0x7);    //7 E5: ld_spi0_p4_sdi_SRC1,<I>      gpio_7  lvds_p0_txgp
	rtd_part_outl(0xb8000c80,27,24,0x7);    //7: ld_spi0_p5_v_sync,<O>        gpio_8  lvds_p0_txgn
	rtd_part_outl(0xb8000c80,23,20,0x7);    //7: ld_spi0_p6_h_sync,<O>        gpio_9  lvds_p0_txfp



	rtd_part_outl(0xb802C268,9,9,0x0);		//LD disable

	//-------------------------
	//	LD InterFace Init
	//-------------------------
	rtd_part_outl(0xb802C900,31,30,0x1);	//LGD mode(default)
	rtd_part_outl(0xb802C900,28,28,0x1);	//LD SPI Start(only Merlin use this bit)
	rtd_part_outl(0xb802C900,4,4,0x1);		//LD_SPI1
	rtd_part_outl(0xb802C900,3,3,0x0);		//one SPI local dimming block
	rtd_part_outl(0xb802C900,0,0,0x0);		//Ld_spi disable

	rtd_part_outl(0xb802C904,31,31,0x1);	//First received bit or transmitted bit is in the MSB of SRAM or register
	rtd_part_outl(0xb802C904,13,4,0x13);	//Output Unit:20 unit(= set+1)     Output Unit:18 + 2 unit(= set+1)
	rtd_part_outl(0xb802C904,1,0,0x0);		//Output_Data_format:8 bit

	rtd_part_outl(0xb802C908,23,16,0x4f);	//SCK_H
	rtd_part_outl(0xb802C908,7,0,0x4f);	//SCK_L
	rtd_part_outl(0xb802C90c,31,8,0xea60);	//Data_send_Delay
	rtd_part_outl(0xb802C910,31,8,0xd4c);	//Each_unit_delay
	rtd_part_outl(0xb802C914,31,24,0x32);	//Vsync_d
	rtd_part_outl(0xb802C918,24,16,0x4f);	//Data_hold_time, must to set equal SCK_H!!!


	//------------------------------
	//	LD Output Index SRAM
	//------------------------------
	rtd_outl(0xb802C91c,0x00);		//Output data index RW_port pointer set

	rtd_outl(0xb802C920,0x24);		//Start_ID
	rtd_outl(0xb802C920,0x25);		//command

	rtd_outl(0xb802C920,0x00);		//1
	rtd_outl(0xb802C920,0x02);		//2
	rtd_outl(0xb802C920,0x04);		//3
	rtd_outl(0xb802C920,0x06);		//4
	rtd_outl(0xb802C920,0x08);		//5
	rtd_outl(0xb802C920,0x0a);		//6
	rtd_outl(0xb802C920,0x0c);		//7
	rtd_outl(0xb802C920,0x0e);		//8
	rtd_outl(0xb802C920,0x10);		//9
	rtd_outl(0xb802C920,0x12);		//10
	rtd_outl(0xb802C920,0x14);		//11
	rtd_outl(0xb802C920,0x16);		//12
	rtd_outl(0xb802C920,0x18);		//13
	rtd_outl(0xb802C920,0x1a);		//14
	rtd_outl(0xb802C920,0x1c);		//15
	rtd_outl(0xb802C920,0x1e);		//16
	rtd_outl(0xb802C920,0x20);		//17
	rtd_outl(0xb802C920,0x22);		//18




	//------------------------------
	//	LD Data SRAM
	//------------------------------

	rtd_outl(0xb802C924,0x00); 		//Data RW_port pointer set

	rtd_outl(0xb802C928,0x7F);		//1
	rtd_outl(0xb802C928,0x7F);		//2
	rtd_outl(0xb802C928,0x7F);		//3
	rtd_outl(0xb802C928,0x7F);		//4
	rtd_outl(0xb802C928,0x7F);		//5
	rtd_outl(0xb802C928,0x7F);		//6
	rtd_outl(0xb802C928,0x7F);		//7
	rtd_outl(0xb802C928,0x7F);		//8
	rtd_outl(0xb802C928,0x7F);      		//9
	rtd_outl(0xb802C928,0x7F);		//10
	rtd_outl(0xb802C928,0x7F);		//11
	rtd_outl(0xb802C928,0x7F);		//12
	rtd_outl(0xb802C928,0x7F);		//13
	rtd_outl(0xb802C928,0x7F);		//14
	rtd_outl(0xb802C928,0x7F);      		//15
	rtd_outl(0xb802C928,0x7F);		//16
	rtd_outl(0xb802C928,0x7F);		//17
	rtd_outl(0xb802C928,0x7F);		//18

	rtd_outl(0xb802C928,0x7F);		//1
	rtd_outl(0xb802C928,0x7F);		//2
	rtd_outl(0xb802C928,0x7F);		//3
	rtd_outl(0xb802C928,0x7F);		//4
	rtd_outl(0xb802C928,0x7F);		//5
	rtd_outl(0xb802C928,0x7F);		//6
	rtd_outl(0xb802C928,0x7F);		//7
	rtd_outl(0xb802C928,0x7F);		//8
	rtd_outl(0xb802C928,0x7F);      		//9
	rtd_outl(0xb802C928,0x7F);		//10
	rtd_outl(0xb802C928,0x7F);		//11
	rtd_outl(0xb802C928,0x7F);		//12
	rtd_outl(0xb802C928,0x7F);		//13
	rtd_outl(0xb802C928,0x7F);		//14
	rtd_outl(0xb802C928,0x7F);      		//15
	rtd_outl(0xb802C928,0x7F);		//16
	rtd_outl(0xb802C928,0x7F);		//17
	rtd_outl(0xb802C928,0x7F);		//18

	rtd_outl(0xb802C928,0xaa);		//Start ID = 0xaa
	rtd_outl(0xb802C928,0x01);		//CMD = 0x01

	//checksum :
	rtd_part_outl(0xb802C900,2,2,0x1); //Send_follow_Vsync
	rtd_part_outl(0xb802C900,0,0,0x1); //Ld_spi enable

}

void panel_ld_12R_spi_init(void)
{

	//lvds pad power enable
	//rtd_part_outl(0xb8000c74,31,31,0x1);
	//rtd_part_outl(0xb8000d74,31,31,0x1);

	//AS Mode SPI0 SRC1
	rtd_part_outl(0xb80008b8,29,28,0x1);	//ld_spi0_p2_sck_src0/src1
	rtd_part_outl(0xb80008b8,25,24,0x1);	//ld_spi0_p3_sdo_src0/src1
	rtd_part_outl(0xb80008b8,21,20,0x1);	//ld_spi0_p4_sdi_src0/src1

	rtd_part_outl(0xb8000800,31,28,0x7);	//7 D8: ld_spi0_p1_cs1,<O>			 gpio_0
	rtd_part_outl(0xb8000800,23,20,0x7);	//7 E8: ld_spi0_p2_sck_src1,<I/O>	 gpio_1
	rtd_part_outl(0xb8000800,15,12,0x7);	//7 E7: ld_spi0_p3_sdo_SRC1,<I/O>	 gpio_2
	rtd_part_outl(0xb8000c80,31,28,0x7);	//7 E5: ld_spi0_p4_sdi_SRC1,<I> 	 gpio_7  lvds_p0_txgp
	rtd_part_outl(0xb8000c80,27,24,0x7);	//7: ld_spi0_p5_v_sync,<O>		  gpio_8  lvds_p0_txgn
//	rtd_part_outl(0xb8000c80,23,20,0x7);	//7: ld_spi0_p6_h_sync,<O>		  gpio_9  lvds_p0_txfp



	rtd_part_outl(0xb802C268,9,9,0x0);		//LD disable

	//-------------------------
	//	LD InterFace Init
	//-------------------------
	rtd_part_outl(0xb802C900,31,30,0x1);	//LGD mode(default)
	rtd_part_outl(0xb802C900,28,28,0x1);	//LD SPI Start(only Merlin use this bit)
	rtd_part_outl(0xb802C900,4,4,0x1);		//LD_SPI1
	rtd_part_outl(0xb802C900,3,3,0x0);		//one SPI local dimming block
	rtd_part_outl(0xb802C900,0,0,0x0);		//Ld_spi disable

	rtd_part_outl(0xb802C904,31,31,0x1);	//First received bit or transmitted bit is in the MSB of SRAM or register
	rtd_part_outl(0xb802C904,13,4,0x0d);	//Output Unit:14 unit(= set+1)	   Output Unit:12 + 2 unit(= set+1)
	rtd_part_outl(0xb802C904,1,0,0x0);		//Output_Data_format:8 bit

	rtd_part_outl(0xb802C908,23,16,0x4f);	//SCK_H
	rtd_part_outl(0xb802C908,7,0,0x4f); 	//SCK_L
	rtd_part_outl(0xb802C90c,31,8,0xea60);	//Data_send_Delay
	rtd_part_outl(0xb802C910,31,8,0xd4c);	//Each_unit_delay
	rtd_part_outl(0xb802C914,31,24,0x32);	//Vsync_d
	rtd_part_outl(0xb802C918,24,16,0x4f);	//Data_hold_time, must to set equal SCK_H!!!


	//------------------------------
	//	LD Output Index SRAM
	//------------------------------
	rtd_outl(0xb802C91c,0x00);		//Output data index RW_port pointer set

	rtd_outl(0xb802C920,0x18);		//Start_ID
	rtd_outl(0xb802C920,0x19);		//command

	rtd_outl(0xb802C920,0x00);		//1
	rtd_outl(0xb802C920,0x02);		//2
	rtd_outl(0xb802C920,0x04);		//3
	rtd_outl(0xb802C920,0x06);		//4
	rtd_outl(0xb802C920,0x08);		//5
	rtd_outl(0xb802C920,0x0a);		//6
	rtd_outl(0xb802C920,0x0c);		//7
	rtd_outl(0xb802C920,0x0e);		//8
	rtd_outl(0xb802C920,0x10);		//9
	rtd_outl(0xb802C920,0x12);		//10
	rtd_outl(0xb802C920,0x14);		//11
	rtd_outl(0xb802C920,0x16);		//12




	//------------------------------
	//	LD Data SRAM
	//------------------------------

	rtd_outl(0xb802C924,0x00);		//Data RW_port pointer set

	rtd_outl(0xb802C928,0xFF);		//1
	rtd_outl(0xb802C928,0xFF);		//2
	rtd_outl(0xb802C928,0xFF);		//3
	rtd_outl(0xb802C928,0xFF);		//4
	rtd_outl(0xb802C928,0xFF);		//5
	rtd_outl(0xb802C928,0xFF);		//6
	rtd_outl(0xb802C928,0xFF);		//7
	rtd_outl(0xb802C928,0xFF);		//8
	rtd_outl(0xb802C928,0xFF);		//9
	rtd_outl(0xb802C928,0xFF);		//10
	rtd_outl(0xb802C928,0xFF);		//11
	rtd_outl(0xb802C928,0xFF);		//12

	rtd_outl(0xb802C928,0xFF);		//1
	rtd_outl(0xb802C928,0xFF);		//2
	rtd_outl(0xb802C928,0xFF);		//3
	rtd_outl(0xb802C928,0xFF);		//4
	rtd_outl(0xb802C928,0xFF);		//5
	rtd_outl(0xb802C928,0xFF);		//6
	rtd_outl(0xb802C928,0xFF);		//7
	rtd_outl(0xb802C928,0xFF);		//8
	rtd_outl(0xb802C928,0xFF);		//9
	rtd_outl(0xb802C928,0xFF);		//10
	rtd_outl(0xb802C928,0xFF);		//11
	rtd_outl(0xb802C928,0xFF);		//12

	rtd_outl(0xb802C928,0xaa);		//Start ID = 0xaa
	rtd_outl(0xb802C928,0x01);		//CMD = 0x01

	//checksum :

	rtd_part_outl(0xb802C900,2,2,0x1); //Send_follow_Vsync
	rtd_part_outl(0xb802C268,9,9,0x1);		//LD enable
	rtd_part_outl(0xb802C900,0,0,0x1); //Ld_spi enable

}


char panel_spi_read_byte(unsigned int reg_addr,char fisrt_flg)
{
	unsigned int read_status = 0;
	unsigned int readdata = 0;
	char data = 0;
	char rt_done_cnt = 0;
       printf("\n reg_addrr=%x\n",reg_addr);

	rtd_part_outl(0xb802C900,0,0,0x0); //Ld_spi disable
	rtd_part_outl(0xb802C904,13,4,0x4); //Output Unit = set+1
	rtd_part_outl(0xb802C904,1,0,0x0);   //Output_Data_format:8 bit

	rtd_part_outl(0xb802C91c,25,16,0x0); //SRAM index
	rtd_part_outl(0xb802C920,9,0,0x00);
	rtd_part_outl(0xb802C920,9,0,0x01);
	rtd_part_outl(0xb802C920,9,0,0x02);
	rtd_part_outl(0xb802C920,9,0,0x03);
	rtd_part_outl(0xb802C920,9,0,0x04);

	rtd_part_outl(0xb802C924,25,16,0x0); //Data index
	rtd_part_outl(0xb802C928,15,0,0x41); //01 + Device Address
	rtd_part_outl(0xb802C928,15,0,reg_addr); //Start Regesiter Address
	rtd_part_outl(0xb802C928,15,0,0x00); //Start Regesiter Address
	rtd_part_outl(0xb802C928,15,0,0x00); //Start Regesiter Address
	rtd_part_outl(0xb802C928,15,0,0x00); //Start Regesiter Address

	rtd_part_outl(0xb802C92c, 8, 8,0x1);			//doesn't look at command bit
	rtd_part_outl(0xb802C92c, 7, 7,0x1);			//write cmd RX
	//rtd_part_outl(0xb802C92c, 6, 6,0x0);
	//rtd_part_outl(0xb802C92c, 5, 5,0x0);
	//rtd_part_outl(0xb802C92c, 4, 4,0x0);
	//rtd_part_outl(0xb802C92c, 3, 0,0x1);

	rtd_part_outl(0xb802C930, 8, 4,0x2); //input Unit = set+1

	rtd_part_outl(0xb801bd18,0,0,0x0);    //7 D8: cs gpo low
	rtd_part_outl(0xb802C900,27,27,0x1); // As led reset=1
	rtd_part_outl(0xb802C900,0,0,0x1); //Ld_spi start enable
	rtd_part_outl(0xb802C900,1,1,0x1); //Send_trigger
	//mdelay(5);
	udelay(100);
	rtd_part_outl(0xb801bd18,0,0,0x1);    //7 D8: cs gpo high

	rtd_part_outl(0xb802C900,27,27,0x0); // As led reset=0

	read_status = rtd_inl(0xb802C960);
	printf("\n read_status = %x\n",read_status);
	while((!(read_status & _BIT31))&&(rt_done_cnt < 5))
	{
		printf("\n read_status%d = %x\n",rt_done_cnt,read_status);
		rt_done_cnt ++;
		mdelay(20);
		read_status = rtd_inl(0xb802C960);
	}

	readdata = rtd_inl(0xb802C934);
	printf("\n read_data = %x",readdata);
	if(fisrt_flg == 1)
	{
		//read_status = (read_data & 0x007F8000) >> 15;
		read_status = (readdata & 0x0001Fe00) >> 9;
       	data = (char)(read_status & 0x00ff);
		printf("  first read data = %x\n",data);
	}
	else
	{
		read_status = (readdata & 0x000001FE) >> 1;
       	data = (char)(read_status & 0x00ff);
		printf("  stable read data = %x\n",data);
	}


	rtd_part_outl(0xb802C92c, 8, 8,0x1);			//doesn't look at command bit
	rtd_part_outl(0xb802C92c, 7, 7,0x0);			//write cmd back to TX

	return data;

}

//char data[29];
#endif

void panel_reconfig_fhd_param(void)
{
	default_panel_parameter.iCONFIG_DISP_VERTICAL_TOTAL = 1125;
	default_panel_parameter.iCONFIG_DISP_HORIZONTAL_TOTAL = 2200;
	default_panel_parameter.iCONFIG_DISP_DEN_STA_HPOS= 140;
	default_panel_parameter.iCONFIG_DISP_DEN_END_HPOS = 2060;
	default_panel_parameter.iCONFIG_DISP_DEN_STA_VPOS= 16;
	default_panel_parameter.iCONFIG_DISP_DEN_END_VPOS = 1096;
	default_panel_parameter.iCONFIG_DISP_ACT_STA_HPOS= 0;
	default_panel_parameter.iCONFIG_DISP_ACT_END_HPOS= 1920;
	default_panel_parameter.iCONFIG_DISP_ACT_STA_VPOS= 0;
	default_panel_parameter.iCONFIG_DISP_ACT_END_VPOS= 1080;
	default_panel_parameter.iCONFIG_DISP_HSYNC_LASTLINE= 2200;
}



void LD_Set_Last_BackLight(unsigned char UserValue)
{
	UINT8 i;
	UINT32 temp = 0;
	UINT32 sp_index, sp_tab0, sp_tab1;
	UINT32 ld_spatialremaptab[65];

	/*ld_spatialremaptab[0] = 0;
	for(i = 1 ; i <= 64 ; i++ )
	{
		ld_spatialremaptab[i] = (i * UserValue) >> 4;
		//printf("---lhh--- table[%d]=%x\n", i,ld_spatialremaptab[i]);
	}*/
	unsigned short MinValue = 384;

	MinValue = MinValue*UserValue/255;

	ld_spatialremaptab[0] = MinValue;
	for(i = 1 ; i <= 64 ; i++ )
	{
		ld_spatialremaptab[i] = (i * UserValue) >> 4;

		if(ld_spatialremaptab[i] < MinValue)
		{
			ld_spatialremaptab[i] = MinValue;
		}
		//printf("---lhh--- table[%d]=%d, MinValue=%d\n", i,ld_spatialremaptab[i],MinValue);
	}
	rtd_outl(0xb802c254, 0x00000001);
	rtd_part_outl(0xb802c2e8,9,0,0x00000000);

	for(i = 0 ; i < 32 ; i++)
	{
		sp_index = i;
		sp_tab0 = ld_spatialremaptab[i * 2 + 1];
		sp_tab1 = ld_spatialremaptab[i * 2 + 2];
		temp = (sp_index << 24) | (sp_tab1 << 12) | sp_tab0 ;
		rtd_outl(0xb802c258, temp);
		//printf("---SRMP = %x ---\n", temp);
	}

}


#if (defined(Config_Board_TV043_RENO_V001) || defined(Config_Board_TV043_RENO_V002))
void panel_ld_96area_bright_spi_init(void)
{
	// This script is for tcl 96 regions backlight test

	//---Script Start---

	//-------------------------
	//	LD SPI Pin Share
	//-------------------------

	// Roku Board
	//SPI1
	//Ball AA8, spi1_ld_hsync
	rtd_part_outl(0xb800084c,31,28,0x4);

	//Ball E6, spi1_ld_sdo_src4
	rtd_part_outl(0xb8000814,15,12,0x3);//3
	rtd_part_outl(0xb80008dc,10,8,0x4);

	//Ball E7, spi1_ld_sdi_src4,
	rtd_part_outl(0xb8000810,7,4,0x3);//3
	rtd_part_outl(0xb80008dc,6,4,0x4);//] = 0x4

	//Ball F6, spi1_ld_vsync
	rtd_part_outl(0xb8000814,7,4,0x3);//3

	//Ball F7, ld_spi1_p1_cs1
	rtd_part_outl(0xb8000814,31,28,0x3);//3

	//Ball G7,  ld_spi1_p2_sck_src4
	rtd_part_outl(0xb8000814,23,20,0x3);//3
	rtd_part_outl(0xb80008dc,14,12,0x4);

	//-------------------------
	//	LD InterFace Init
	//-------------------------
	rtd_part_outl(0xb802C900,31,30,0x1);	//LGD mode(default)
	rtd_part_outl(0xb802C900,28,28,0x1);	//LD SPI Start(only Merlin use this bit)
	rtd_part_outl(0xb802C900,10,10,0x1);	//TX_CLK_INV
	rtd_part_outl(0xb802C900,4,4,0x1);		//LD_SPI1
	rtd_part_outl(0xb802C900,3,3,0x0);		//one SPI local dimming block
	//rtd_part_outl(0xb802C900,0,0,0x0);	//Ld_spi disable

	rtd_part_outl(0xb802C904,31,31,0x1);	//First received bit or transmitted bit is in the MSB of SRAM or register
	rtd_part_outl(0xb802C904,13,4,0xc6);	//Output Unit:8 unit(= set+1)     Output Unit:(2+2+96*2+3)-1=198=0xc6(= set+1)
	rtd_part_outl(0xb802C904,1,0,0x0);		//Output_Data_format:8 bit
	rtd_part_outl(0xb802C984,8,8,0x1);		//Rata SRAM Byte Select Mode enable
	rtd_part_outl(0xb802C984,4,0,0x0);		//Rata SRAM Byte Select Mode enable

	rtd_part_outl(0xb802C908,23,16,0x4f);	//SCK_H
	rtd_part_outl(0xb802C908,7,0,0x4f);		//SCK_L
	rtd_part_outl(0xb802C90c,31,8,0xea60);	//Data_send_Delay
	rtd_part_outl(0xb802C910,31,8,0xd4c);	//Each_unit_delay
	rtd_part_outl(0xb802C914,31,24,0x32);	//Vsync_d
	//rtd_part_outl(0xb802C918,24,16,0x4f);	//Data_hold_time, sample data at falling edge
	rtd_part_outl(0xb802C988,31,8,0x0);		//Sck hold time:
	rtd_part_outl(0xb802C958,31,8,0x0);		//Cs hold time

	//rtd_part_outl(0xb802C968,31,19,0x112f);	// ld_spi_h_total = 4400 = 0x112f 120hz
	//rtd_part_outl(0xb802C96c,31,19,0x465);	// ld_spi_v_total = 1125 = 0x465
	//rtd_part_outl(0xb802C970,2,0,0x1);		// dv_reproduce_mode = 1: 1 vs in. 2 vs out


	//------------------------------
	//	LD Data Output Index SRAM
	//------------------------------
	rtd_outl(0xb802C91c,0x00);		//Output data index RW_port pointer set

	rtd_outl(0xb802C920,0x0200);		//Indicator start code 1st = 0x55
	rtd_outl(0xb802C920,0x0201);		//Indicator start code 2nd = 0xaa
	rtd_outl(0xb802C920,0x0202);		//Command 1st = 0x00
	rtd_outl(0xb802C920,0x0203);		//Command 2nd = 0x04

	//row 0
	rtd_outl(0xb802C920,0x0800);		//0 h
	rtd_outl(0xb802C920,0x0000);		//0 l
	rtd_outl(0xb802C920,0x0801);		//3
	rtd_outl(0xb802C920,0x0001);		//4
	rtd_outl(0xb802C920,0x0802);		//5
	rtd_outl(0xb802C920,0x0002);		//6
	rtd_outl(0xb802C920,0x0803);		//7
	rtd_outl(0xb802C920,0x0003);		//8
	rtd_outl(0xb802C920,0x0804);		//9
	rtd_outl(0xb802C920,0x0004);		//2
	rtd_outl(0xb802C920,0x0805);		//1
	rtd_outl(0xb802C920,0x0005);		//2
	rtd_outl(0xb802C920,0x0806);		//1
	rtd_outl(0xb802C920,0x0006);		//2
	rtd_outl(0xb802C920,0x0807);		//1
	rtd_outl(0xb802C920,0x0007);		//2
	rtd_outl(0xb802C920,0x0808);		//1
	rtd_outl(0xb802C920,0x0008);		//2
	rtd_outl(0xb802C920,0x0809);		//1
	rtd_outl(0xb802C920,0x0009);		//2
	rtd_outl(0xb802C920,0x080a);		//1
	rtd_outl(0xb802C920,0x000a);		//2
	rtd_outl(0xb802C920,0x080b);		//1
	rtd_outl(0xb802C920,0x000b);		//2
	rtd_outl(0xb802C920,0x080c);		//1
	rtd_outl(0xb802C920,0x000c);		//2
	rtd_outl(0xb802C920,0x080d);		//1
	rtd_outl(0xb802C920,0x000d);		//2
	rtd_outl(0xb802C920,0x080e);		//1
	rtd_outl(0xb802C920,0x000e);		//2
	rtd_outl(0xb802C920,0x080f);		//1
	rtd_outl(0xb802C920,0x000f);		//2

	//row 1
	rtd_outl(0xb802C920,0x0810);		//0 h
	rtd_outl(0xb802C920,0x0010);		//0 l
	rtd_outl(0xb802C920,0x0811);		//3
	rtd_outl(0xb802C920,0x0011);		//4
	rtd_outl(0xb802C920,0x0812);		//5
	rtd_outl(0xb802C920,0x0012);		//6
	rtd_outl(0xb802C920,0x0813);		//7
	rtd_outl(0xb802C920,0x0013);		//8
	rtd_outl(0xb802C920,0x0814);		//9
	rtd_outl(0xb802C920,0x0014);		//2
	rtd_outl(0xb802C920,0x0815);		//1
	rtd_outl(0xb802C920,0x0015);		//2
	rtd_outl(0xb802C920,0x0816);		//1
	rtd_outl(0xb802C920,0x0016);		//2
	rtd_outl(0xb802C920,0x0817);		//1
	rtd_outl(0xb802C920,0x0017);		//2
	rtd_outl(0xb802C920,0x0818);		//1
	rtd_outl(0xb802C920,0x0018);		//2
	rtd_outl(0xb802C920,0x0819);		//1
	rtd_outl(0xb802C920,0x0019);		//2
	rtd_outl(0xb802C920,0x081a);		//1
	rtd_outl(0xb802C920,0x001a);		//2
	rtd_outl(0xb802C920,0x081b);		//1
	rtd_outl(0xb802C920,0x001b);		//2
	rtd_outl(0xb802C920,0x081c);		//1
	rtd_outl(0xb802C920,0x001c);		//2
	rtd_outl(0xb802C920,0x081d);		//1
	rtd_outl(0xb802C920,0x001d);		//2
	rtd_outl(0xb802C920,0x081e);		//1
	rtd_outl(0xb802C920,0x001e);		//2
	rtd_outl(0xb802C920,0x081f);		//1
	rtd_outl(0xb802C920,0x001f);		//2

	//row 2
	rtd_outl(0xb802C920,0x0820);		//0 h
	rtd_outl(0xb802C920,0x0020);		//0 l
	rtd_outl(0xb802C920,0x0821);		//3
	rtd_outl(0xb802C920,0x0021);		//4
	rtd_outl(0xb802C920,0x0822);		//5
	rtd_outl(0xb802C920,0x0022);		//6
	rtd_outl(0xb802C920,0x0823);		//7
	rtd_outl(0xb802C920,0x0023);		//8
	rtd_outl(0xb802C920,0x0824);		//9
	rtd_outl(0xb802C920,0x0024);		//2
	rtd_outl(0xb802C920,0x0825);		//1
	rtd_outl(0xb802C920,0x0025);		//2
	rtd_outl(0xb802C920,0x0826);		//1
	rtd_outl(0xb802C920,0x0026);		//2
	rtd_outl(0xb802C920,0x0827);		//1
	rtd_outl(0xb802C920,0x0027);		//2
	rtd_outl(0xb802C920,0x0828);		//1
	rtd_outl(0xb802C920,0x0028);		//2
	rtd_outl(0xb802C920,0x0829);		//1
	rtd_outl(0xb802C920,0x0029);		//2
	rtd_outl(0xb802C920,0x082a);		//1
	rtd_outl(0xb802C920,0x002a);		//2
	rtd_outl(0xb802C920,0x082b);		//1
	rtd_outl(0xb802C920,0x002b);		//2
	rtd_outl(0xb802C920,0x082c);		//1
	rtd_outl(0xb802C920,0x002c);		//2
	rtd_outl(0xb802C920,0x082d);		//1
	rtd_outl(0xb802C920,0x002d);		//2
	rtd_outl(0xb802C920,0x082e);		//1
	rtd_outl(0xb802C920,0x002e);		//2
	rtd_outl(0xb802C920,0x082f);		//1
	rtd_outl(0xb802C920,0x002f);		//2

	//row 3
	rtd_outl(0xb802C920,0x0830);		//0 h
	rtd_outl(0xb802C920,0x0030);		//0 l
	rtd_outl(0xb802C920,0x0831);		//3
	rtd_outl(0xb802C920,0x0031);		//4
	rtd_outl(0xb802C920,0x0832);		//5
	rtd_outl(0xb802C920,0x0032);		//6
	rtd_outl(0xb802C920,0x0833);		//7
	rtd_outl(0xb802C920,0x0033);		//8
	rtd_outl(0xb802C920,0x0834);		//9
	rtd_outl(0xb802C920,0x0034);		//2
	rtd_outl(0xb802C920,0x0835);		//1
	rtd_outl(0xb802C920,0x0035);		//2
	rtd_outl(0xb802C920,0x0836);		//1
	rtd_outl(0xb802C920,0x0036);		//2
	rtd_outl(0xb802C920,0x0837);		//1
	rtd_outl(0xb802C920,0x0037);		//2
	rtd_outl(0xb802C920,0x0838);		//1
	rtd_outl(0xb802C920,0x0038);		//2
	rtd_outl(0xb802C920,0x0839);		//1
	rtd_outl(0xb802C920,0x0039);		//2
	rtd_outl(0xb802C920,0x083a);		//1
	rtd_outl(0xb802C920,0x003a);		//2
	rtd_outl(0xb802C920,0x083b);		//1
	rtd_outl(0xb802C920,0x003b);		//2
	rtd_outl(0xb802C920,0x083c);		//1
	rtd_outl(0xb802C920,0x003c);		//2
	rtd_outl(0xb802C920,0x083d);		//1
	rtd_outl(0xb802C920,0x003d);		//2
	rtd_outl(0xb802C920,0x083e);		//1
	rtd_outl(0xb802C920,0x003e);		//2
	rtd_outl(0xb802C920,0x083f);		//1
	rtd_outl(0xb802C920,0x003f);		//2

	//row 4
	rtd_outl(0xb802C920,0x0840);		//0 h
	rtd_outl(0xb802C920,0x0040);		//0 l
	rtd_outl(0xb802C920,0x0841);		//3
	rtd_outl(0xb802C920,0x0041);		//4
	rtd_outl(0xb802C920,0x0842);		//5
	rtd_outl(0xb802C920,0x0042);		//6
	rtd_outl(0xb802C920,0x0843);		//7
	rtd_outl(0xb802C920,0x0043);		//8
	rtd_outl(0xb802C920,0x0844);		//9
	rtd_outl(0xb802C920,0x0044);		//2
	rtd_outl(0xb802C920,0x0845);		//1
	rtd_outl(0xb802C920,0x0045);		//2
	rtd_outl(0xb802C920,0x0846);		//1
	rtd_outl(0xb802C920,0x0046);		//2
	rtd_outl(0xb802C920,0x0847);		//1
	rtd_outl(0xb802C920,0x0047);		//2
	rtd_outl(0xb802C920,0x0848);		//1
	rtd_outl(0xb802C920,0x0048);		//2
	rtd_outl(0xb802C920,0x0849);		//1
	rtd_outl(0xb802C920,0x0049);		//2
	rtd_outl(0xb802C920,0x084a);		//1
	rtd_outl(0xb802C920,0x004a);		//2
	rtd_outl(0xb802C920,0x084b);		//1
	rtd_outl(0xb802C920,0x004b);		//2
	rtd_outl(0xb802C920,0x084c);		//1
	rtd_outl(0xb802C920,0x004c);		//2
	rtd_outl(0xb802C920,0x084d);		//1
	rtd_outl(0xb802C920,0x004d);		//2
	rtd_outl(0xb802C920,0x084e);		//1
	rtd_outl(0xb802C920,0x004e);		//2
	rtd_outl(0xb802C920,0x084f);		//1
	rtd_outl(0xb802C920,0x004f);		//2

	//row 5
	rtd_outl(0xb802C920,0x0850);		//0 h
	rtd_outl(0xb802C920,0x0050);		//0 l
	rtd_outl(0xb802C920,0x0851);		//3
	rtd_outl(0xb802C920,0x0051);		//4
	rtd_outl(0xb802C920,0x0852);		//5
	rtd_outl(0xb802C920,0x0052);		//6
	rtd_outl(0xb802C920,0x0853);		//7
	rtd_outl(0xb802C920,0x0053);		//8
	rtd_outl(0xb802C920,0x0854);		//9
	rtd_outl(0xb802C920,0x0054);		//2
	rtd_outl(0xb802C920,0x0855);		//1
	rtd_outl(0xb802C920,0x0055);		//2
	rtd_outl(0xb802C920,0x0856);		//1
	rtd_outl(0xb802C920,0x0056);		//2
	rtd_outl(0xb802C920,0x0857);		//1
	rtd_outl(0xb802C920,0x0057);		//2
	rtd_outl(0xb802C920,0x0858);		//1
	rtd_outl(0xb802C920,0x0058);		//2
	rtd_outl(0xb802C920,0x0859);		//1
	rtd_outl(0xb802C920,0x0059);		//2
	rtd_outl(0xb802C920,0x085a);		//1
	rtd_outl(0xb802C920,0x005a);		//2
	rtd_outl(0xb802C920,0x085b);		//1
	rtd_outl(0xb802C920,0x005b);		//2
	rtd_outl(0xb802C920,0x085c);		//1
	rtd_outl(0xb802C920,0x005c);		//2
	rtd_outl(0xb802C920,0x085d);		//1
	rtd_outl(0xb802C920,0x005d);		//2
	rtd_outl(0xb802C920,0x085e);		//1
	rtd_outl(0xb802C920,0x005e);		//2
	rtd_outl(0xb802C920,0x085f);		//1
	rtd_outl(0xb802C920,0x005f);		//2

	// data 3*8bit
	rtd_outl(0xb802C920,0x00204);		//data1 pwm
	rtd_outl(0xb802C920,0x00205);		//data2 current
	rtd_outl(0xb802C920,0x00206);		//data3 apl



	// checksum

	//------------------------------
	//	LD Data SRAM
	//------------------------------


	rtd_outl(0xb802C924,0x00);	//Data RW_port pointer set

	//row 0
	rtd_outl(0xb802C928,0x0fff);		//0x00
	rtd_outl(0xb802C928,0x0fff);		//0x01
	rtd_outl(0xb802C928,0x0fff);		//0x08
	rtd_outl(0xb802C928,0x0fff);		//0x03
	rtd_outl(0xb802C928,0x0fff);		//0x04
	rtd_outl(0xb802C928,0x0fff);		//0x05
	rtd_outl(0xb802C928,0x0fff);		//0x06
	rtd_outl(0xb802C928,0x0fff);		//0x07
	rtd_outl(0xb802C928,0x0fff);		//0x08
	rtd_outl(0xb802C928,0x0fff);		//0x09
	rtd_outl(0xb802C928,0x0fff);		//0x0a
	rtd_outl(0xb802C928,0x0fff);		//0x0b
	rtd_outl(0xb802C928,0x0fff);		//0x0c
	rtd_outl(0xb802C928,0x0fff);		//0x0d
	rtd_outl(0xb802C928,0x0fff);		//0x0e
	rtd_outl(0xb802C928,0x0fff);		//0x0f

	//row 1
	rtd_outl(0xb802C928,0x0fff);		//0x10
	rtd_outl(0xb802C928,0x0fff);		//0x11
	rtd_outl(0xb802C928,0x0fff);		//0x12
	rtd_outl(0xb802C928,0x0fff);		//0x13
	rtd_outl(0xb802C928,0x0fff);		//0x14
	rtd_outl(0xb802C928,0x0fff);		//0x15
	rtd_outl(0xb802C928,0x0fff);		//0x16
	rtd_outl(0xb802C928,0x0fff);		//0x17
	rtd_outl(0xb802C928,0x0fff);		//0x18
	rtd_outl(0xb802C928,0x0fff);		//0x19
	rtd_outl(0xb802C928,0x0fff);		//0x1a
	rtd_outl(0xb802C928,0x0fff);		//0x1b
	rtd_outl(0xb802C928,0x0fff);		//0x1c
	rtd_outl(0xb802C928,0x0fff);		//0x1d
	rtd_outl(0xb802C928,0x0fff);		//0x1e
	rtd_outl(0xb802C928,0x0fff);		//0x1f

	//row 2
	rtd_outl(0xb802C928,0x0fff);		//0x20
	rtd_outl(0xb802C928,0x0fff);		//0x21
	rtd_outl(0xb802C928,0x0fff);		//0x22
	rtd_outl(0xb802C928,0x0fff);		//0x23
	rtd_outl(0xb802C928,0x0fff);		//0x24
	rtd_outl(0xb802C928,0x0fff);		//0x25
	rtd_outl(0xb802C928,0x0fff);		//0x26
	rtd_outl(0xb802C928,0x0fff);		//0x27
	rtd_outl(0xb802C928,0x0fff);		//0x28
	rtd_outl(0xb802C928,0x0fff);		//0x29
	rtd_outl(0xb802C928,0x0fff);		//0x2a
	rtd_outl(0xb802C928,0x0fff);		//0x2b
	rtd_outl(0xb802C928,0x0fff);		//0x2c
	rtd_outl(0xb802C928,0x0fff);		//0x2d
	rtd_outl(0xb802C928,0x0fff);		//0x2e
	rtd_outl(0xb802C928,0x0fff);		//0x2f

	//row 3
	rtd_outl(0xb802C928,0x0fff);		//0x30
	rtd_outl(0xb802C928,0x0fff);		//0x31
	rtd_outl(0xb802C928,0x0fff);		//0x32
	rtd_outl(0xb802C928,0x0fff);		//0x33
	rtd_outl(0xb802C928,0x0fff);		//0x34
	rtd_outl(0xb802C928,0x0fff);		//0x35
	rtd_outl(0xb802C928,0x0fff);		//0x36
	rtd_outl(0xb802C928,0x0fff);		//0x37
	rtd_outl(0xb802C928,0x0fff);		//0x38
	rtd_outl(0xb802C928,0x0fff);		//0x39
	rtd_outl(0xb802C928,0x0fff);		//0x3a
	rtd_outl(0xb802C928,0x0fff);		//0x3b
	rtd_outl(0xb802C928,0x0fff);		//0x3c
	rtd_outl(0xb802C928,0x0fff);		//0x3d
	rtd_outl(0xb802C928,0x0fff);		//0x3e
	rtd_outl(0xb802C928,0x0fff);		//0x3f

	//row 4
	rtd_outl(0xb802C928,0x0fff);		//0x40
	rtd_outl(0xb802C928,0x0fff);		//0x41
	rtd_outl(0xb802C928,0x0fff);		//0x42
	rtd_outl(0xb802C928,0x0fff);		//0x43
	rtd_outl(0xb802C928,0x0fff);		//0x44
	rtd_outl(0xb802C928,0x0fff);		//0x45
	rtd_outl(0xb802C928,0x0fff);		//0x46
	rtd_outl(0xb802C928,0x0fff);		//0x47
	rtd_outl(0xb802C928,0x0fff);		//0x48
	rtd_outl(0xb802C928,0x0fff);		//0x49
	rtd_outl(0xb802C928,0x0fff);		//0x4a
	rtd_outl(0xb802C928,0x0fff);		//0x4b
	rtd_outl(0xb802C928,0x0fff);		//0x4c
	rtd_outl(0xb802C928,0x0fff);		//0x4d
	rtd_outl(0xb802C928,0x0fff);		//0x4e
	rtd_outl(0xb802C928,0x0fff);		//0x4f

	//row 5
	rtd_outl(0xb802C928,0x0fff);		//0x50
	rtd_outl(0xb802C928,0x0fff);		//0x51
	rtd_outl(0xb802C928,0x0fff);		//0x52
	rtd_outl(0xb802C928,0x0fff);		//0x53
	rtd_outl(0xb802C928,0x0fff);		//0x54
	rtd_outl(0xb802C928,0x0fff);		//0x55
	rtd_outl(0xb802C928,0x0fff);		//0x56
	rtd_outl(0xb802C928,0x0fff);		//0x57
	rtd_outl(0xb802C928,0x0fff);		//0x58
	rtd_outl(0xb802C928,0x0fff);		//0x59
	rtd_outl(0xb802C928,0x0fff);		//0x5a
	rtd_outl(0xb802C928,0x0fff);		//0x5b
	rtd_outl(0xb802C928,0x0fff);		//0x5c
	rtd_outl(0xb802C928,0x0fff);		//0x5d
	rtd_outl(0xb802C928,0x0fff);		//0x5e
	rtd_outl(0xb802C928,0x0fff);		//0x5f

	rtd_outl(0xb802C924,0x02000000);	//Data RW_port pointer set
	// id cmd
	rtd_outl(0xb802C928,0x55);			//0x60 Indicator start code 1st
	rtd_outl(0xb802C928,0xaa);			//0x61 Indicator start code 2nd
	rtd_outl(0xb802C928,0x00);			//0x62 Command 1st
	rtd_outl(0xb802C928,0x3c);			//0x63 Command 2nd

	//data 3 * 8bit
	rtd_outl(0xb802C928,0xff);			//0x64 data1 pwm
	rtd_outl(0xb802C928,0xff);			//0x65 data2 current
	rtd_outl(0xb802C928,0xff);			//0x66 data3 apl

	//checksum
	rtd_outl(0xb802C928,0xfe);			//data : for fix bl=254

	//checksum
	rtd_part_outl(0xb802C900,2,2,0x1);	//Send_follow_Vsync
	rtd_part_outl(0xb802C900,0,0,0x1);	//Ld_spi enable
}
#endif



void panel_LD_init_16(int ibacklight)
{
	    //-------------------------
		//	LD SPI Pin Share
		//-------------------------

		/*rtd_part_outl(0xb8000884,31,28,0x5);	//ld_spi0_p1_cs1,<O>				   (Ball_ AM36)
		rtd_part_outl(0xb8000884,15,12,0x5);  //ld_spi0_p5_v_sync,<O>			   (Ball_ AL37)
		rtd_part_outl(0xb8000884,27,24,0x5);  // ld_spi0_p2_sck_SRC1,<I/O>		   (Ball_AM38)
		rtd_part_outl(0xb8000888,23,20,0x5);  //ld_spi0_p3_sdo_SRC1,<I/O>		   (Ball_AM37)
		rtd_part_outl(0xb8000884,19,16,0x5);  // ld_spi0_p4_sdi_SRC1,<I>		   (Ball_AL36)*/

		rtd_part_outl(0xb8000800,31,28,0x7);  //ld_spi0_p1_cs1,<O>				   (Ball_A24)
		//rtd_part_outl(0xb800082c,31,28,0x8);  //ld_spi0_p5_v_sync,<O>			   (Ball_P4)
		rtd_part_outl(0xb8000c80,27,24,0x7);//ld_spi0_p5_v_sync,<O>                         (Ball_D15)
		rtd_part_outl(0xb8000800,23,20,0x7);  // ld_spi0_p2_sck_SRC1,<I/O>		   (Ball_A23)
		rtd_part_outl(0xb8000800,15,12,0x7);  //ld_spi0_p3_sdo_SRC1,<I/O>		   (Ball_B23)
		rtd_part_outl(0xb8000c80,31,28,0x7);  // ld_spi0_p4_sdi_SRC1,<I>		          (Ball_C15)


		//-------------------------
		//	LD InterFace Init
		//-------------------------
		rtd_part_outl(0xb802C900,31,30,0x1);	//LGD mode(default)
		rtd_part_outl(0xb802C900,28,28,0x1);	//LD SPI Start(only Merlin use this bit)
		rtd_part_outl(0xb802C900,4,4,0x1);		//LD_SPI1
		rtd_part_outl(0xb802C900,3,3,0x0);		//one SPI local dimming block
		rtd_part_outl(0xb802C900,0,0,0x0);		//Ld_spi disable
		rtd_part_outl(0xb802C904,31,31,0x1);	//First received bit or transmitted bit is in the MSB of SRAM or register
		rtd_part_outl(0xb802C904,13,4,0x11);	//Output Unit:18 unit(= set+1)	   Output Unit:16 + 2 unit(= set+1)
		rtd_part_outl(0xb802C904,1,0,0x0);		//Output_Data_format:8 bit
		rtd_part_outl(0xb802C908,23,16,0x4f);	//SCK_H
		rtd_part_outl(0xb802C908,7,0,0x4f); 	//SCK_L
		rtd_part_outl(0xb802C90c,31,8,0xea60);	//Data_send_Delay
		rtd_part_outl(0xb802C910,31,8,0xd4c);	//Each_unit_delay
		rtd_part_outl(0xb802C914,31,24,0x32);	//Vsync_d
		rtd_part_outl(0xb802C918,24,16,0x4f);	//Data_hold_time, must to set equal SCK_H!!!

		//------------------------------
		//	LD Output Index SRAM
		//------------------------------
		rtd_outl(0xb802C91c,0x00);		//Output data index RW_port pointer set
		rtd_outl(0xb802C920,0x20);		//Start_ID
		rtd_outl(0xb802C920,0x21);		//command
		rtd_outl(0xb802C920,0x00);		//1
		rtd_outl(0xb802C920,0x02);		//2
		rtd_outl(0xb802C920,0x04);		//3
		rtd_outl(0xb802C920,0x06);		//4
		rtd_outl(0xb802C920,0x08);		//5
		rtd_outl(0xb802C920,0x0a);		//6
		rtd_outl(0xb802C920,0x0c);		//7
		rtd_outl(0xb802C920,0x0e);		//8
		rtd_outl(0xb802C920,0x10);		//9
		rtd_outl(0xb802C920,0x12);		//10
		rtd_outl(0xb802C920,0x14);		//11
		rtd_outl(0xb802C920,0x16);		//12
		rtd_outl(0xb802C920,0x18);		//13
		rtd_outl(0xb802C920,0x1a);		//14
		rtd_outl(0xb802C920,0x1c);		//15
		rtd_outl(0xb802C920,0x1e);		//16

		//------------------------------
		//	LD Data SRAM
		//------------------------------
		rtd_outl(0xb802C924,0x00);		//Data RW_port pointer set
		rtd_outl(0xb802C928,0x15);		//1
		rtd_outl(0xb802C928,0x76);				// no use
		rtd_outl(0xb802C928,0x76);		//2
		rtd_outl(0xb802C928,0x76);				// no use
		rtd_outl(0xb802C928,0x76);		//3
		rtd_outl(0xb802C928,0x76);				// no use
		rtd_outl(0xb802C928,0x76);		//4
		rtd_outl(0xb802C928,0x76);				// no use
		rtd_outl(0xb802C928,0x76);		//5
		rtd_outl(0xb802C928,0x76);				// no use
		rtd_outl(0xb802C928,0x76);		//6
		rtd_outl(0xb802C928,0x76);				// no use
		rtd_outl(0xb802C928,0x76);		//7
		rtd_outl(0xb802C928,0x76);				// no use
		rtd_outl(0xb802C928,0x76);		//8
		rtd_outl(0xb802C928,0x76);				// no use
		rtd_outl(0xb802C928,0x76);		//9
		rtd_outl(0xb802C928,0x76);				// no use
		rtd_outl(0xb802C928,0x76);		//10
		rtd_outl(0xb802C928,0x76);				// no use
		rtd_outl(0xb802C928,0x76);		//11
		rtd_outl(0xb802C928,0x76);				// no use
		rtd_outl(0xb802C928,0x76);		//12
		rtd_outl(0xb802C928,0x76);				// no use
		rtd_outl(0xb802C928,0x76);		//13
		rtd_outl(0xb802C928,0x76);				// no use
		rtd_outl(0xb802C928,0x76);		//14
		rtd_outl(0xb802C928,0x76);				// no use
		rtd_outl(0xb802C928,0x76);		//15
		rtd_outl(0xb802C928,0x76);				// no use
		rtd_outl(0xb802C928,0x76);		//16
		rtd_outl(0xb802C928,0x76);				// no use
		rtd_outl(0xb802C928,0xaa);		//Start ID = 0xaa
		rtd_outl(0xb802C928,0x01);		//CMD = 0x01


		// LD algo setting
		rtd_part_outl(0xb802C268,31,25,0x3);	// BLU WR NUM = 3
		rtd_part_outl(0xb802C268,24,16,0x1f);	// SPI total = 32 - 1
		rtd_part_outl(0xb802C268,7,0,0x10); 	// BLU gain = 16
		rtd_part_outl(0xb802C208,0,0,0x1);	// LD valid
		rtd_part_outl(0xb802C268,9,9,0x1);	// SPI enable
		rtd_part_outl(0xb802C294,1,1,0x0);	// SW off
		rtd_part_outl(0xb802c200,31,31,0x0);	// Comp off
		rtd_part_outl(0xb802c208,1,1,0x1);	// LD_T_Enable
		rtd_part_outl(0xb802c208,5,4,0x1);	// edge top-buttom type
		rtd_part_outl(0xb802c204,31,31,0x0);	// db off
		rtd_part_outl(0xb802c208,28,24,0xf);	// Hunm
		rtd_part_outl(0xb802c208,20,16,0x0);	// Vunm
		rtd_part_outl(0xb802c208,3,2,0x2);	// LD_Hist_Mode?????????????????????????
		rtd_part_outl(0xb802c20c,28,16,0xf0);	// Hsize 3840/12 = 320
		rtd_part_outl(0xb802c20c,11,0,0x870);	// Vsize 2160/1 = 2160

		// backlight decision
		rtd_outl(0xb802c23c, 0x061a0005);
		rtd_outl(0xb802c240, 0x00000000);
		rtd_outl(0xb802c244, 0x00000000);

		// temporal filter
		rtd_outl(0xb802c25c, 0x08300418);
		rtd_outl(0xb802c260, 0x08300210);
		rtd_outl(0xb802c264, 0x00400400);

		// spatial filter
		rtd_outl(0xb802c250, 0x00770220);
		rtd_outl(0xb802c254, 0x00000001);

		LD_Set_Last_BackLight(ibacklight);

		rtd_part_outl(0xb802C900,2,2,0x1); //Send_follow_Vsync
		rtd_part_outl(0xb802C900,0,0,0x1); //Ld_spi enable
		//---Script Start---

}

void panel_LD_init_288(int ibacklight)
{
	//-------------------------
	//	LD SPI Pin Share
	//-------------------------

	/*rtd_part_outl(0xb8000884,31,28,0x5);	//ld_spi0_p1_cs1,<O>				 (Ball_ AM36)
	rtd_part_outl(0xb8000884,15,12,0x5);  //ld_spi0_p5_v_sync,<O>			   (Ball_ AL37)
	rtd_part_outl(0xb8000884,27,24,0x5);  // ld_spi0_p2_sck_SRC1,<I/O>		   (Ball_AM38)
	rtd_part_outl(0xb8000888,23,20,0x5);  //ld_spi0_p3_sdo_SRC1,<I/O>		   (Ball_AM37)
	rtd_part_outl(0xb8000884,19,16,0x5);  // ld_spi0_p4_sdi_SRC1,<I>		   (Ball_AL36)*/


	//-------------------------
	//	LD InterFace Init
	//-------------------------
	rtd_part_outl(0xb802C900,31,30,0x1);	//LGD mode(default)
	rtd_part_outl(0xb802C900,28,28,0x1);	//LD SPI Start(only Merlin use this bit)
	rtd_part_outl(0xb802C900,4,4,0x1);		//LD_SPI1
	rtd_part_outl(0xb802C900,3,3,0x0);		//one SPI local dimming block
	rtd_part_outl(0xb802C900,0,0,0x0);		//Ld_spi disable

	rtd_part_outl(0xb802C904,31,31,0x1);	//First received bit or transmitted bit is in the MSB of SRAM or register
	rtd_part_outl(0xb802C904,13,4,0x121);	//Output Unit:290 unit(= set+1) 	Output Unit:288 + 2 unit(= set+1)
	rtd_part_outl(0xb802C904,1,0,0x0);		//Output_Data_format:8 bit

	rtd_part_outl(0xb802C908,23,16,0x4f);	//SCK_H
	rtd_part_outl(0xb802C908,7,0,0x4f); 	//SCK_L
	rtd_part_outl(0xb802C90c,31,8,0xea60);	//Data_send_Delay
	rtd_part_outl(0xb802C910,31,8,0x24c);	//Each_unit_delay
	rtd_part_outl(0xb802C914,31,24,0x32);	//Vsync_d
	rtd_part_outl(0xb802C918,24,16,0x4f);	//Data_hold_time, must to set equal SCK_H!!!


	//------------------------------
	//	LD Output Index SRAM
	//------------------------------
	rtd_outl(0xb802C91c,0x00);		//Output data index RW_port pointer set

	rtd_outl(0xb802C920,0x120); 	//Start_ID
	rtd_outl(0xb802C920,0x121); 	//command

	rtd_outl(0xb802C920,0x000); 	//00-00
	rtd_outl(0xb802C920,0x001); 	//00-01
	rtd_outl(0xb802C920,0x002); 	//00-02
	rtd_outl(0xb802C920,0x003); 	//00-03
	rtd_outl(0xb802C920,0x004); 	//00-04
	rtd_outl(0xb802C920,0x005); 	//00-05
	rtd_outl(0xb802C920,0x006); 	//00-06
	rtd_outl(0xb802C920,0x007); 	//00-07
	rtd_outl(0xb802C920,0x008); 	//00-08
	rtd_outl(0xb802C920,0x009); 	//00-09
	rtd_outl(0xb802C920,0x00a); 	//00-10
	rtd_outl(0xb802C920,0x00b); 	//00-11
	rtd_outl(0xb802C920,0x00c); 	//00-12
	rtd_outl(0xb802C920,0x00d); 	//00-13
	rtd_outl(0xb802C920,0x00e); 	//00-14
	rtd_outl(0xb802C920,0x00f); 	//00-15

	rtd_outl(0xb802C920,0x010); 	//01-00
	rtd_outl(0xb802C920,0x011); 	//01-01
	rtd_outl(0xb802C920,0x012); 	//01-02
	rtd_outl(0xb802C920,0x013); 	//01-03
	rtd_outl(0xb802C920,0x014); 	//01-04
	rtd_outl(0xb802C920,0x015); 	//01-05
	rtd_outl(0xb802C920,0x016); 	//01-06
	rtd_outl(0xb802C920,0x017); 	//01-07
	rtd_outl(0xb802C920,0x018); 	//01-08
	rtd_outl(0xb802C920,0x019); 	//01-09
	rtd_outl(0xb802C920,0x01a); 	//01-10
	rtd_outl(0xb802C920,0x01b); 	//01-11
	rtd_outl(0xb802C920,0x01c); 	//01-12
	rtd_outl(0xb802C920,0x01d); 	//01-13
	rtd_outl(0xb802C920,0x01e); 	//01-14
	rtd_outl(0xb802C920,0x01f); 	//01-15

	rtd_outl(0xb802C920,0x020); 	//02-00
	rtd_outl(0xb802C920,0x021); 	//02-01
	rtd_outl(0xb802C920,0x022); 	//02-02
	rtd_outl(0xb802C920,0x023); 	//02-03
	rtd_outl(0xb802C920,0x024); 	//02-04
	rtd_outl(0xb802C920,0x025); 	//02-05
	rtd_outl(0xb802C920,0x026); 	//02-06
	rtd_outl(0xb802C920,0x027); 	//02-07
	rtd_outl(0xb802C920,0x028); 	//02-08
	rtd_outl(0xb802C920,0x029); 	//02-09
	rtd_outl(0xb802C920,0x02a); 	//02-10
	rtd_outl(0xb802C920,0x02b); 	//02-11
	rtd_outl(0xb802C920,0x02c); 	//02-12
	rtd_outl(0xb802C920,0x02d); 	//02-13
	rtd_outl(0xb802C920,0x02e); 	//02-14
	rtd_outl(0xb802C920,0x02f); 	//02-15

	rtd_outl(0xb802C920,0x030); 	//03-00
	rtd_outl(0xb802C920,0x031); 	//03-01
	rtd_outl(0xb802C920,0x032); 	//03-02
	rtd_outl(0xb802C920,0x033); 	//03-03
	rtd_outl(0xb802C920,0x034); 	//03-04
	rtd_outl(0xb802C920,0x035); 	//03-05
	rtd_outl(0xb802C920,0x036); 	//03-06
	rtd_outl(0xb802C920,0x037); 	//03-07
	rtd_outl(0xb802C920,0x038); 	//03-08
	rtd_outl(0xb802C920,0x039); 	//03-09
	rtd_outl(0xb802C920,0x03a); 	//03-10
	rtd_outl(0xb802C920,0x03b); 	//03-11
	rtd_outl(0xb802C920,0x03c); 	//03-12
	rtd_outl(0xb802C920,0x03d); 	//03-13
	rtd_outl(0xb802C920,0x03e); 	//03-14
	rtd_outl(0xb802C920,0x03f); 	//03-15

	rtd_outl(0xb802C920,0x040); 	//04-00
	rtd_outl(0xb802C920,0x041); 	//04-01
	rtd_outl(0xb802C920,0x042); 	//04-02
	rtd_outl(0xb802C920,0x043); 	//04-03
	rtd_outl(0xb802C920,0x044); 	//04-04
	rtd_outl(0xb802C920,0x045); 	//04-05
	rtd_outl(0xb802C920,0x046); 	//04-06
	rtd_outl(0xb802C920,0x047); 	//04-07
	rtd_outl(0xb802C920,0x048); 	//04-08
	rtd_outl(0xb802C920,0x049); 	//04-09
	rtd_outl(0xb802C920,0x04a); 	//04-10
	rtd_outl(0xb802C920,0x04b); 	//04-11
	rtd_outl(0xb802C920,0x04c); 	//04-12
	rtd_outl(0xb802C920,0x04d); 	//04-13
	rtd_outl(0xb802C920,0x04e); 	//04-14
	rtd_outl(0xb802C920,0x04f); 	//04-15

	rtd_outl(0xb802C920,0x050); 	//05-00
	rtd_outl(0xb802C920,0x051); 	//05-01
	rtd_outl(0xb802C920,0x052); 	//05-02
	rtd_outl(0xb802C920,0x053); 	//05-03
	rtd_outl(0xb802C920,0x054); 	//05-04
	rtd_outl(0xb802C920,0x055); 	//05-05
	rtd_outl(0xb802C920,0x056); 	//05-06
	rtd_outl(0xb802C920,0x057); 	//05-07
	rtd_outl(0xb802C920,0x058); 	//05-08
	rtd_outl(0xb802C920,0x059); 	//05-09
	rtd_outl(0xb802C920,0x05a); 	//05-10
	rtd_outl(0xb802C920,0x05b); 	//05-11
	rtd_outl(0xb802C920,0x05c); 	//05-12
	rtd_outl(0xb802C920,0x05d); 	//05-13
	rtd_outl(0xb802C920,0x05e); 	//05-14
	rtd_outl(0xb802C920,0x05f); 	//05-15

	rtd_outl(0xb802C920,0x060); 	//06-00
	rtd_outl(0xb802C920,0x061); 	//06-01
	rtd_outl(0xb802C920,0x062); 	//06-02
	rtd_outl(0xb802C920,0x063); 	//06-03
	rtd_outl(0xb802C920,0x064); 	//06-04
	rtd_outl(0xb802C920,0x065); 	//06-05
	rtd_outl(0xb802C920,0x066); 	//06-06
	rtd_outl(0xb802C920,0x067); 	//06-07
	rtd_outl(0xb802C920,0x068); 	//06-08
	rtd_outl(0xb802C920,0x069); 	//06-09
	rtd_outl(0xb802C920,0x06a); 	//06-10
	rtd_outl(0xb802C920,0x06b); 	//06-11
	rtd_outl(0xb802C920,0x06c); 	//06-12
	rtd_outl(0xb802C920,0x06d); 	//06-13
	rtd_outl(0xb802C920,0x06e); 	//06-14
	rtd_outl(0xb802C920,0x06f); 	//06-15

	rtd_outl(0xb802C920,0x070); 	//07-00
	rtd_outl(0xb802C920,0x071); 	//07-01
	rtd_outl(0xb802C920,0x072); 	//07-02
	rtd_outl(0xb802C920,0x073); 	//07-03
	rtd_outl(0xb802C920,0x074); 	//07-04
	rtd_outl(0xb802C920,0x075); 	//07-05
	rtd_outl(0xb802C920,0x076); 	//07-06
	rtd_outl(0xb802C920,0x077); 	//07-07
	rtd_outl(0xb802C920,0x078); 	//07-08
	rtd_outl(0xb802C920,0x079); 	//07-09
	rtd_outl(0xb802C920,0x07a); 	//07-10
	rtd_outl(0xb802C920,0x07b); 	//07-11
	rtd_outl(0xb802C920,0x07c); 	//07-12
	rtd_outl(0xb802C920,0x07d); 	//07-13
	rtd_outl(0xb802C920,0x07e); 	//07-14
	rtd_outl(0xb802C920,0x07f); 	//07-15

	rtd_outl(0xb802C920,0x080); 	//08-00
	rtd_outl(0xb802C920,0x081); 	//08-01
	rtd_outl(0xb802C920,0x082); 	//08-02
	rtd_outl(0xb802C920,0x083); 	//08-03
	rtd_outl(0xb802C920,0x084); 	//08-04
	rtd_outl(0xb802C920,0x085); 	//08-05
	rtd_outl(0xb802C920,0x086); 	//08-06
	rtd_outl(0xb802C920,0x087); 	//08-07
	rtd_outl(0xb802C920,0x088); 	//08-08
	rtd_outl(0xb802C920,0x089); 	//08-09
	rtd_outl(0xb802C920,0x08a); 	//08-10
	rtd_outl(0xb802C920,0x08b); 	//08-11
	rtd_outl(0xb802C920,0x08c); 	//08-12
	rtd_outl(0xb802C920,0x08d); 	//08-13
	rtd_outl(0xb802C920,0x08e); 	//08-14
	rtd_outl(0xb802C920,0x08f); 	//08-15

	rtd_outl(0xb802C920,0x090); 	//09-00
	rtd_outl(0xb802C920,0x091); 	//09-01
	rtd_outl(0xb802C920,0x092); 	//09-02
	rtd_outl(0xb802C920,0x093); 	//09-03
	rtd_outl(0xb802C920,0x094); 	//09-04
	rtd_outl(0xb802C920,0x095); 	//09-05
	rtd_outl(0xb802C920,0x096); 	//09-06
	rtd_outl(0xb802C920,0x097); 	//09-07
	rtd_outl(0xb802C920,0x098); 	//09-08
	rtd_outl(0xb802C920,0x099); 	//09-09
	rtd_outl(0xb802C920,0x09a); 	//09-10
	rtd_outl(0xb802C920,0x09b); 	//09-11
	rtd_outl(0xb802C920,0x09c); 	//09-12
	rtd_outl(0xb802C920,0x09d); 	//09-13
	rtd_outl(0xb802C920,0x09e); 	//09-14
	rtd_outl(0xb802C920,0x09f); 	//09-15

	rtd_outl(0xb802C920,0x0a0); 	//0a-00
	rtd_outl(0xb802C920,0x0a1); 	//0a-01
	rtd_outl(0xb802C920,0x0a2); 	//0a-02
	rtd_outl(0xb802C920,0x0a3); 	//0a-03
	rtd_outl(0xb802C920,0x0a4); 	//0a-04
	rtd_outl(0xb802C920,0x0a5); 	//0a-05
	rtd_outl(0xb802C920,0x0a6); 	//0a-06
	rtd_outl(0xb802C920,0x0a7); 	//0a-07
	rtd_outl(0xb802C920,0x0a8); 	//0a-08
	rtd_outl(0xb802C920,0x0a9); 	//0a-09
	rtd_outl(0xb802C920,0x0aa); 	//0a-10
	rtd_outl(0xb802C920,0x0ab); 	//0a-11
	rtd_outl(0xb802C920,0x0ac); 	//0a-12
	rtd_outl(0xb802C920,0x0ad); 	//0a-13
	rtd_outl(0xb802C920,0x0ae); 	//0a-14
	rtd_outl(0xb802C920,0x0af); 	//0a-15

	rtd_outl(0xb802C920,0x0b0); 	//0b-00
	rtd_outl(0xb802C920,0x0b1); 	//0b-01
	rtd_outl(0xb802C920,0x0b2); 	//0b-02
	rtd_outl(0xb802C920,0x0b3); 	//0b-03
	rtd_outl(0xb802C920,0x0b4); 	//0b-04
	rtd_outl(0xb802C920,0x0b5); 	//0b-05
	rtd_outl(0xb802C920,0x0b6); 	//0b-06
	rtd_outl(0xb802C920,0x0b7); 	//0b-07
	rtd_outl(0xb802C920,0x0b8); 	//0b-08
	rtd_outl(0xb802C920,0x0b9); 	//0b-09
	rtd_outl(0xb802C920,0x0ba); 	//0b-10
	rtd_outl(0xb802C920,0x0bb); 	//0b-11
	rtd_outl(0xb802C920,0x0bc); 	//0b-12
	rtd_outl(0xb802C920,0x0bd); 	//0b-13
	rtd_outl(0xb802C920,0x0be); 	//0b-14
	rtd_outl(0xb802C920,0x0bf); 	//0b-15

	rtd_outl(0xb802C920,0x0c0); 	//0c-00
	rtd_outl(0xb802C920,0x0c1); 	//0c-01
	rtd_outl(0xb802C920,0x0c2); 	//0c-02
	rtd_outl(0xb802C920,0x0c3); 	//0c-03
	rtd_outl(0xb802C920,0x0c4); 	//0c-04
	rtd_outl(0xb802C920,0x0c5); 	//0c-05
	rtd_outl(0xb802C920,0x0c6); 	//0c-06
	rtd_outl(0xb802C920,0x0c7); 	//0c-07
	rtd_outl(0xb802C920,0x0c8); 	//0c-08
	rtd_outl(0xb802C920,0x0c9); 	//0c-09
	rtd_outl(0xb802C920,0x0ca); 	//0c-10
	rtd_outl(0xb802C920,0x0cb); 	//0c-11
	rtd_outl(0xb802C920,0x0cc); 	//0c-12
	rtd_outl(0xb802C920,0x0cd); 	//0c-13
	rtd_outl(0xb802C920,0x0ce); 	//0c-14
	rtd_outl(0xb802C920,0x0cf); 	//0c-15

	rtd_outl(0xb802C920,0x0d0); 	//0d-00
	rtd_outl(0xb802C920,0x0d1); 	//0d-01
	rtd_outl(0xb802C920,0x0d2); 	//0d-02
	rtd_outl(0xb802C920,0x0d3); 	//0d-03
	rtd_outl(0xb802C920,0x0d4); 	//0d-04
	rtd_outl(0xb802C920,0x0d5); 	//0d-05
	rtd_outl(0xb802C920,0x0d6); 	//0d-06
	rtd_outl(0xb802C920,0x0d7); 	//0d-07
	rtd_outl(0xb802C920,0x0d8); 	//0d-08
	rtd_outl(0xb802C920,0x0d9); 	//0d-09
	rtd_outl(0xb802C920,0x0da); 	//0d-10
	rtd_outl(0xb802C920,0x0db); 	//0d-11
	rtd_outl(0xb802C920,0x0dc); 	//0d-12
	rtd_outl(0xb802C920,0x0dd); 	//0d-13
	rtd_outl(0xb802C920,0x0de); 	//0d-14
	rtd_outl(0xb802C920,0x0df); 	//0d-15

	rtd_outl(0xb802C920,0x0e0); 	//0e-00
	rtd_outl(0xb802C920,0x0e1); 	//0e-01
	rtd_outl(0xb802C920,0x0e2); 	//0e-02
	rtd_outl(0xb802C920,0x0e3); 	//0e-03
	rtd_outl(0xb802C920,0x0e4); 	//0e-04
	rtd_outl(0xb802C920,0x0e5); 	//0e-05
	rtd_outl(0xb802C920,0x0e6); 	//0e-06
	rtd_outl(0xb802C920,0x0e7); 	//0e-07
	rtd_outl(0xb802C920,0x0e8); 	//0e-08
	rtd_outl(0xb802C920,0x0e9); 	//0e-09
	rtd_outl(0xb802C920,0x0ea); 	//0e-10
	rtd_outl(0xb802C920,0x0eb); 	//0e-11
	rtd_outl(0xb802C920,0x0ec); 	//0e-12
	rtd_outl(0xb802C920,0x0ed); 	//0e-13
	rtd_outl(0xb802C920,0x0ee); 	//0e-14
	rtd_outl(0xb802C920,0x0ef); 	//0e-15

	rtd_outl(0xb802C920,0x0f0); 	//0f-00
	rtd_outl(0xb802C920,0x0f1); 	//0f-01
	rtd_outl(0xb802C920,0x0f2); 	//0f-02
	rtd_outl(0xb802C920,0x0f3); 	//0f-03
	rtd_outl(0xb802C920,0x0f4); 	//0f-04
	rtd_outl(0xb802C920,0x0f5); 	//0f-05
	rtd_outl(0xb802C920,0x0f6); 	//0f-06
	rtd_outl(0xb802C920,0x0f7); 	//0f-07
	rtd_outl(0xb802C920,0x0f8); 	//0f-08
	rtd_outl(0xb802C920,0x0f9); 	//0f-09
	rtd_outl(0xb802C920,0x0fa); 	//0f-10
	rtd_outl(0xb802C920,0x0fb); 	//0f-11
	rtd_outl(0xb802C920,0x0fc); 	//0f-12
	rtd_outl(0xb802C920,0x0fd); 	//0f-13
	rtd_outl(0xb802C920,0x0fe); 	//0f-14
	rtd_outl(0xb802C920,0x0ff); 	//0f-15

	rtd_outl(0xb802C920,0x100); 	//10-00
	rtd_outl(0xb802C920,0x101); 	//10-01
	rtd_outl(0xb802C920,0x102); 	//10-02
	rtd_outl(0xb802C920,0x103); 	//10-03
	rtd_outl(0xb802C920,0x104); 	//10-04
	rtd_outl(0xb802C920,0x105); 	//10-05
	rtd_outl(0xb802C920,0x106); 	//10-06
	rtd_outl(0xb802C920,0x107); 	//10-07
	rtd_outl(0xb802C920,0x108); 	//10-08
	rtd_outl(0xb802C920,0x109); 	//10-09
	rtd_outl(0xb802C920,0x10a); 	//10-10
	rtd_outl(0xb802C920,0x10b); 	//10-11
	rtd_outl(0xb802C920,0x10c); 	//10-12
	rtd_outl(0xb802C920,0x10d); 	//10-13
	rtd_outl(0xb802C920,0x10e); 	//10-14
	rtd_outl(0xb802C920,0x10f); 	//10-15

	rtd_outl(0xb802C920,0x110); 	//11-00
	rtd_outl(0xb802C920,0x111); 	//11-01
	rtd_outl(0xb802C920,0x112); 	//11-02
	rtd_outl(0xb802C920,0x113); 	//11-03
	rtd_outl(0xb802C920,0x114); 	//11-04
	rtd_outl(0xb802C920,0x115); 	//11-05
	rtd_outl(0xb802C920,0x116); 	//11-06
	rtd_outl(0xb802C920,0x117); 	//11-07
	rtd_outl(0xb802C920,0x118); 	//11-08
	rtd_outl(0xb802C920,0x119); 	//11-09
	rtd_outl(0xb802C920,0x11a); 	//11-10
	rtd_outl(0xb802C920,0x11b); 	//11-11
	rtd_outl(0xb802C920,0x11c); 	//11-12
	rtd_outl(0xb802C920,0x11d); 	//11-13
	rtd_outl(0xb802C920,0x11e); 	//11-14
	rtd_outl(0xb802C920,0x11f); 	//11-15


	//------------------------------
	//	LD Data SRAM
	//------------------------------

	rtd_outl(0xb802C924,0x00);		//Data RW_port pointer set

	rtd_outl(0xb802C928,0xf0);		//1 	row1
	rtd_outl(0xb802C928,0xf0);		//2
	rtd_outl(0xb802C928,0xf0);		//3
	rtd_outl(0xb802C928,0xf0);		//4
	rtd_outl(0xb802C928,0xf0);		//5
	rtd_outl(0xb802C928,0xf0);		//6
	rtd_outl(0xb802C928,0xf0);		//7
	rtd_outl(0xb802C928,0xf0);		//8
	rtd_outl(0xb802C928,0xf0);		//9
	rtd_outl(0xb802C928,0xf0);		//10
	rtd_outl(0xb802C928,0xf0);		//11
	rtd_outl(0xb802C928,0xf0);		//12
	rtd_outl(0xb802C928,0xf0);		//13
	rtd_outl(0xb802C928,0xf0);		//14
	rtd_outl(0xb802C928,0xf0);		//15
	rtd_outl(0xb802C928,0xf0);		//16

	rtd_outl(0xb802C928,0xf0);		//1 	row2
	rtd_outl(0xb802C928,0xf0);		//2
	rtd_outl(0xb802C928,0xf0);		//3
	rtd_outl(0xb802C928,0xf0);		//4
	rtd_outl(0xb802C928,0xf0);		//5
	rtd_outl(0xb802C928,0xf0);		//6
	rtd_outl(0xb802C928,0xf0);		//7
	rtd_outl(0xb802C928,0xf0);		//8
	rtd_outl(0xb802C928,0xf0);		//9
	rtd_outl(0xb802C928,0xf0);		//10
	rtd_outl(0xb802C928,0xf0);		//11
	rtd_outl(0xb802C928,0xf0);		//12
	rtd_outl(0xb802C928,0xf0);		//13
	rtd_outl(0xb802C928,0xf0);		//14
	rtd_outl(0xb802C928,0xf0);		//15
	rtd_outl(0xb802C928,0xf0);		//16

	rtd_outl(0xb802C928,0xf0);		//1 	row3
	rtd_outl(0xb802C928,0xf0);		//2
	rtd_outl(0xb802C928,0xf0);		//3
	rtd_outl(0xb802C928,0xf0);		//4
	rtd_outl(0xb802C928,0xf0);		//5
	rtd_outl(0xb802C928,0xf0);		//6
	rtd_outl(0xb802C928,0xf0);		//7
	rtd_outl(0xb802C928,0xf0);		//8
	rtd_outl(0xb802C928,0xf0);		//9
	rtd_outl(0xb802C928,0xf0);		//10
	rtd_outl(0xb802C928,0xf0);		//11
	rtd_outl(0xb802C928,0xf0);		//12
	rtd_outl(0xb802C928,0xf0);		//13
	rtd_outl(0xb802C928,0xf0);		//14
	rtd_outl(0xb802C928,0xf0);		//15
	rtd_outl(0xb802C928,0xf0);		//16

	rtd_outl(0xb802C928,0xf0);		//1 	row4
	rtd_outl(0xb802C928,0xf0);		//2
	rtd_outl(0xb802C928,0xf0);		//3
	rtd_outl(0xb802C928,0xf0);		//4
	rtd_outl(0xb802C928,0xf0);		//5
	rtd_outl(0xb802C928,0xf0);		//6
	rtd_outl(0xb802C928,0xf0);		//7
	rtd_outl(0xb802C928,0xf0);		//8
	rtd_outl(0xb802C928,0xf0);		//9
	rtd_outl(0xb802C928,0xf0);		//10
	rtd_outl(0xb802C928,0xf0);		//11
	rtd_outl(0xb802C928,0xf0);		//12
	rtd_outl(0xb802C928,0xf0);		//13
	rtd_outl(0xb802C928,0xf0);		//14
	rtd_outl(0xb802C928,0xf0);		//15
	rtd_outl(0xb802C928,0xf0);		//16

	rtd_outl(0xb802C928,0xf0);		//1 	row5
	rtd_outl(0xb802C928,0xf0);		//2
	rtd_outl(0xb802C928,0xf0);		//3
	rtd_outl(0xb802C928,0xf0);		//4
	rtd_outl(0xb802C928,0xf0);		//5
	rtd_outl(0xb802C928,0xf0);		//6
	rtd_outl(0xb802C928,0xf0);		//7
	rtd_outl(0xb802C928,0xf0);		//8
	rtd_outl(0xb802C928,0xf0);		//9
	rtd_outl(0xb802C928,0xf0);		//10
	rtd_outl(0xb802C928,0xf0);		//11
	rtd_outl(0xb802C928,0xf0);		//12
	rtd_outl(0xb802C928,0xf0);		//13
	rtd_outl(0xb802C928,0xf0);		//14
	rtd_outl(0xb802C928,0xf0);		//15
	rtd_outl(0xb802C928,0xf0);		//16

	rtd_outl(0xb802C928,0xf0);		//1 	row6
	rtd_outl(0xb802C928,0xf0);		//2
	rtd_outl(0xb802C928,0xf0);		//3
	rtd_outl(0xb802C928,0xf0);		//4
	rtd_outl(0xb802C928,0xf0);		//5
	rtd_outl(0xb802C928,0xf0);		//6
	rtd_outl(0xb802C928,0xf0);		//7
	rtd_outl(0xb802C928,0xf0);		//8
	rtd_outl(0xb802C928,0xf0);		//9
	rtd_outl(0xb802C928,0xf0);		//10
	rtd_outl(0xb802C928,0xf0);		//11
	rtd_outl(0xb802C928,0xf0);		//12
	rtd_outl(0xb802C928,0xf0);		//13
	rtd_outl(0xb802C928,0xf0);		//14
	rtd_outl(0xb802C928,0xf0);		//15
	rtd_outl(0xb802C928,0xf0);		//16

	rtd_outl(0xb802C928,0xf0);		//1 	row7
	rtd_outl(0xb802C928,0xf0);		//2
	rtd_outl(0xb802C928,0xf0);		//3
	rtd_outl(0xb802C928,0xf0);		//4
	rtd_outl(0xb802C928,0xf0);		//5
	rtd_outl(0xb802C928,0xf0);		//6
	rtd_outl(0xb802C928,0xf0);		//7
	rtd_outl(0xb802C928,0xf0);		//8
	rtd_outl(0xb802C928,0xf0);		//9
	rtd_outl(0xb802C928,0xf0);		//10
	rtd_outl(0xb802C928,0xf0);		//11
	rtd_outl(0xb802C928,0xf0);		//12
	rtd_outl(0xb802C928,0xf0);		//13
	rtd_outl(0xb802C928,0xf0);		//14
	rtd_outl(0xb802C928,0xf0);		//15
	rtd_outl(0xb802C928,0xf0);		//16

	rtd_outl(0xb802C928,0xf0);		//1 	row8
	rtd_outl(0xb802C928,0xf0);		//2
	rtd_outl(0xb802C928,0xf0);		//3
	rtd_outl(0xb802C928,0xf0);		//4
	rtd_outl(0xb802C928,0xf0);		//5
	rtd_outl(0xb802C928,0xf0);		//6
	rtd_outl(0xb802C928,0xf0);		//7
	rtd_outl(0xb802C928,0xf0);		//8
	rtd_outl(0xb802C928,0xf0);		//9
	rtd_outl(0xb802C928,0xf0);		//10
	rtd_outl(0xb802C928,0xf0);		//11
	rtd_outl(0xb802C928,0xf0);		//12
	rtd_outl(0xb802C928,0xf0);		//13
	rtd_outl(0xb802C928,0xf0);		//14
	rtd_outl(0xb802C928,0xf0);		//15
	rtd_outl(0xb802C928,0xf0);		//16

	rtd_outl(0xb802C928,0xf0);		//1 	row9
	rtd_outl(0xb802C928,0xf0);		//2
	rtd_outl(0xb802C928,0xf0);		//3
	rtd_outl(0xb802C928,0xf0);		//4
	rtd_outl(0xb802C928,0xf0);		//5
	rtd_outl(0xb802C928,0xf0);		//6
	rtd_outl(0xb802C928,0xf0);		//7
	rtd_outl(0xb802C928,0xf0);		//8
	rtd_outl(0xb802C928,0xf0);		//9
	rtd_outl(0xb802C928,0xf0);		//10
	rtd_outl(0xb802C928,0xf0);		//11
	rtd_outl(0xb802C928,0xf0);		//12
	rtd_outl(0xb802C928,0xf0);		//13
	rtd_outl(0xb802C928,0xf0);		//14
	rtd_outl(0xb802C928,0xf0);		//15
	rtd_outl(0xb802C928,0xf0);		//16

	rtd_outl(0xb802C928,0xf0);		//1 	row10
	rtd_outl(0xb802C928,0xf0);		//2
	rtd_outl(0xb802C928,0xf0);		//3
	rtd_outl(0xb802C928,0xf0);		//4
	rtd_outl(0xb802C928,0xf0);		//5
	rtd_outl(0xb802C928,0xf0);		//6
	rtd_outl(0xb802C928,0xf0);		//7
	rtd_outl(0xb802C928,0xf0);		//8
	rtd_outl(0xb802C928,0xf0);		//9
	rtd_outl(0xb802C928,0xf0);		//10
	rtd_outl(0xb802C928,0xf0);		//11
	rtd_outl(0xb802C928,0xf0);		//12
	rtd_outl(0xb802C928,0xf0);		//13
	rtd_outl(0xb802C928,0xf0);		//14
	rtd_outl(0xb802C928,0xf0);		//15
	rtd_outl(0xb802C928,0xf0);		//16

	rtd_outl(0xb802C928,0xf0);		//1 	row11
	rtd_outl(0xb802C928,0xf0);		//2
	rtd_outl(0xb802C928,0xf0);		//3
	rtd_outl(0xb802C928,0xf0);		//4
	rtd_outl(0xb802C928,0xf0);		//5
	rtd_outl(0xb802C928,0xf0);		//6
	rtd_outl(0xb802C928,0xf0);		//7
	rtd_outl(0xb802C928,0xf0);		//8
	rtd_outl(0xb802C928,0xf0);		//9
	rtd_outl(0xb802C928,0xf0);		//10
	rtd_outl(0xb802C928,0xf0);		//11
	rtd_outl(0xb802C928,0xf0);		//12
	rtd_outl(0xb802C928,0xf0);		//13
	rtd_outl(0xb802C928,0xf0);		//14
	rtd_outl(0xb802C928,0xf0);		//15
	rtd_outl(0xb802C928,0xf0);		//16

	rtd_outl(0xb802C928,0xf0);		//1 	row12
	rtd_outl(0xb802C928,0xf0);		//2
	rtd_outl(0xb802C928,0xf0);		//3
	rtd_outl(0xb802C928,0xf0);		//4
	rtd_outl(0xb802C928,0xf0);		//5
	rtd_outl(0xb802C928,0xf0);		//6
	rtd_outl(0xb802C928,0xf0);		//7
	rtd_outl(0xb802C928,0xf0);		//8
	rtd_outl(0xb802C928,0xf0);		//9
	rtd_outl(0xb802C928,0xf0);		//10
	rtd_outl(0xb802C928,0xf0);		//11
	rtd_outl(0xb802C928,0xf0);		//12
	rtd_outl(0xb802C928,0xf0);		//13
	rtd_outl(0xb802C928,0xf0);		//14
	rtd_outl(0xb802C928,0xf0);		//15
	rtd_outl(0xb802C928,0xf0);		//16

	rtd_outl(0xb802C928,0xf0);		//1 	row13
	rtd_outl(0xb802C928,0xf0);		//2
	rtd_outl(0xb802C928,0xf0);		//3
	rtd_outl(0xb802C928,0xf0);		//4
	rtd_outl(0xb802C928,0xf0);		//5
	rtd_outl(0xb802C928,0xf0);		//6
	rtd_outl(0xb802C928,0xf0);		//7
	rtd_outl(0xb802C928,0xf0);		//8
	rtd_outl(0xb802C928,0xf0);		//9
	rtd_outl(0xb802C928,0xf0);		//10
	rtd_outl(0xb802C928,0xf0);		//11
	rtd_outl(0xb802C928,0xf0);		//12
	rtd_outl(0xb802C928,0xf0);		//13
	rtd_outl(0xb802C928,0xf0);		//14
	rtd_outl(0xb802C928,0xf0);		//15
	rtd_outl(0xb802C928,0xf0);		//16

	rtd_outl(0xb802C928,0xf0);		//1 	row14
	rtd_outl(0xb802C928,0xf0);		//2
	rtd_outl(0xb802C928,0xf0);		//3
	rtd_outl(0xb802C928,0xf0);		//4
	rtd_outl(0xb802C928,0xf0);		//5
	rtd_outl(0xb802C928,0xf0);		//6
	rtd_outl(0xb802C928,0xf0);		//7
	rtd_outl(0xb802C928,0xf0);		//8
	rtd_outl(0xb802C928,0xf0);		//9
	rtd_outl(0xb802C928,0xf0);		//10
	rtd_outl(0xb802C928,0xf0);		//11
	rtd_outl(0xb802C928,0xf0);		//12
	rtd_outl(0xb802C928,0xf0);		//13
	rtd_outl(0xb802C928,0xf0);		//14
	rtd_outl(0xb802C928,0xf0);		//15
	rtd_outl(0xb802C928,0xf0);		//16

	rtd_outl(0xb802C928,0xf0);		//1 	row15
	rtd_outl(0xb802C928,0xf0);		//2
	rtd_outl(0xb802C928,0xf0);		//3
	rtd_outl(0xb802C928,0xf0);		//4
	rtd_outl(0xb802C928,0xf0);		//5
	rtd_outl(0xb802C928,0xf0);		//6
	rtd_outl(0xb802C928,0xf0);		//7
	rtd_outl(0xb802C928,0xf0);		//8
	rtd_outl(0xb802C928,0xf0);		//9
	rtd_outl(0xb802C928,0xf0);		//10
	rtd_outl(0xb802C928,0xf0);		//11
	rtd_outl(0xb802C928,0xf0);		//12
	rtd_outl(0xb802C928,0xf0);		//13
	rtd_outl(0xb802C928,0xf0);		//14
	rtd_outl(0xb802C928,0xf0);		//15
	rtd_outl(0xb802C928,0xf0);		//16

	rtd_outl(0xb802C928,0xf0);		//1 	row16
	rtd_outl(0xb802C928,0xf0);		//2
	rtd_outl(0xb802C928,0xf0);		//3
	rtd_outl(0xb802C928,0xf0);		//4
	rtd_outl(0xb802C928,0xf0);		//5
	rtd_outl(0xb802C928,0xf0);		//6
	rtd_outl(0xb802C928,0xf0);		//7
	rtd_outl(0xb802C928,0xf0);		//8
	rtd_outl(0xb802C928,0xf0);		//9
	rtd_outl(0xb802C928,0xf0);		//10
	rtd_outl(0xb802C928,0xf0);		//11
	rtd_outl(0xb802C928,0xf0);		//12
	rtd_outl(0xb802C928,0xf0);		//13
	rtd_outl(0xb802C928,0xf0);		//14
	rtd_outl(0xb802C928,0xf0);		//15
	rtd_outl(0xb802C928,0xf0);		//16

	rtd_outl(0xb802C928,0xf0);		//1 	row17
	rtd_outl(0xb802C928,0xf0);		//2
	rtd_outl(0xb802C928,0xf0);		//3
	rtd_outl(0xb802C928,0xf0);		//4
	rtd_outl(0xb802C928,0xf0);		//5
	rtd_outl(0xb802C928,0xf0);		//6
	rtd_outl(0xb802C928,0xf0);		//7
	rtd_outl(0xb802C928,0xf0);		//8
	rtd_outl(0xb802C928,0xf0);		//9
	rtd_outl(0xb802C928,0xf0);		//10
	rtd_outl(0xb802C928,0xf0);		//11
	rtd_outl(0xb802C928,0xf0);		//12
	rtd_outl(0xb802C928,0xf0);		//13
	rtd_outl(0xb802C928,0xf0);		//14
	rtd_outl(0xb802C928,0xf0);		//15
	rtd_outl(0xb802C928,0xf0);		//16

	rtd_outl(0xb802C928,0xf0);		//1 	row18
	rtd_outl(0xb802C928,0xf0);		//2
	rtd_outl(0xb802C928,0xf0);		//3
	rtd_outl(0xb802C928,0xf0);		//4
	rtd_outl(0xb802C928,0xf0);		//5
	rtd_outl(0xb802C928,0xf0);		//6
	rtd_outl(0xb802C928,0xf0);		//7
	rtd_outl(0xb802C928,0xf0);		//8
	rtd_outl(0xb802C928,0xf0);		//9
	rtd_outl(0xb802C928,0xf0);		//10
	rtd_outl(0xb802C928,0xf0);		//11
	rtd_outl(0xb802C928,0xf0);		//12
	rtd_outl(0xb802C928,0xf0);		//13
	rtd_outl(0xb802C928,0xf0);		//14
	rtd_outl(0xb802C928,0xf0);		//15
	rtd_outl(0xb802C928,0xf0);		//16


	rtd_outl(0xb802C928,0xaa);		//Start ID = 0xaa
	rtd_outl(0xb802C928,0x01);		//CMD = 0x01

	//checksum :

	rtd_part_outl(0xb802C900,2,2,0x1); //Send_follow_Vsync
	rtd_part_outl(0xb802C900,0,0,0x1); //Ld_spi enable

}


#if defined(Config_Board_TV002_V001)
#if defined(CONFIG_CUSTOM_Vulcan_PowerSequence)
//BE Control I2C
typedef struct
{
	unsigned char bSize;
	unsigned char bAddr;
	unsigned char bArray[18];
}BE_CTRL_REG;

static BE_CTRL_REG BE_CTRL_InitTbl_0[] =
{
	{ 0x6,0x68, {0x30, 0x7c, 0x00, 0x00, 0x00, 0xc0} },
	{ 0x12,0x58,{0x00, 0x20, 0x59, 0x44, 0x38, 0x57, 0x30, 0x30, 0x37, 0x48, 0x4E, 0x47, 0x30, 0x31, 0x30, 0x31, 0x00, 0x00} },
	{ 0x6,0x58, {0x00, 0x00, 0x00, 0x00, 0x00, 0x00} },
	{ 0x6,0x68, {0x30, 0x24, 0x00, 0x00, 0x00, 0x01} },
};
#define SIZEOF_BE_CTRL_INITTBL_0 (sizeof(BE_CTRL_InitTbl_0)/sizeof(BE_CTRL_InitTbl_0[0]))

static BE_CTRL_REG BE_CTRL_InitTbl_1[] =
{
	{ 0x6,0x68,{ 0x30, 0x7c, 0x00, 0x00, 0x00, 0x80} },
	{ 0x6,0x58,{ 0x15, 0x00, 0x08, 0xc0, 0x0a, 0x00} },
	{ 0x6,0x58,{ 0x30, 0x00, 0x00, 0x00, 0x02, 0x10} },
	{ 0x6,0x58,{ 0x30, 0x10, 0x00, 0x00, 0x00, 0x00} },
	{ 0x6,0x58,{ 0x30, 0x20, 0x00, 0x00, 0x00, 0x00} },
	{ 0x6,0x58,{ 0x31, 0x00, 0x00, 0x00, 0x8c, 0xa1} },
	{ 0x6,0x58,{ 0x31, 0x10, 0x00, 0x00, 0x00, 0x01} },
	{ 0x6,0x58,{ 0x31, 0xb0, 0x10, 0x00, 0x00, 0x00} },
	{ 0x6,0x58,{ 0x50, 0x30, 0x00, 0x00, 0x00, 0x01} },
	{ 0x6,0x58,{ 0x50, 0x34, 0x00, 0x00, 0x00, 0x00} },
	{ 0x6,0x58,{ 0x50, 0x38, 0x00, 0x00, 0x00, 0x00} },
	{ 0x6,0x58,{ 0x50, 0x3c, 0x04, 0x08, 0x00, 0xc9} },
	{ 0x6,0x58,{ 0x50, 0x40, 0x00, 0x00, 0x02, 0x0e} },
	{ 0x6,0x58,{ 0x50, 0x44, 0x1d, 0xad, 0x03, 0x83} },
	{ 0x6,0x58,{ 0x50, 0x48, 0x00, 0x00, 0x1e, 0xd0} },
	{ 0x6,0x58,{ 0x50, 0x4c, 0x1d, 0x0e, 0x1f, 0x6e} },
	{ 0x6,0x58,{ 0x50, 0x50, 0x00, 0x00, 0x03, 0x83} },
	{ 0x6,0x58,{ 0x50, 0x58, 0x00, 0x40, 0x00, 0x00} },
	{ 0x6,0x58,{ 0x50, 0x5c, 0x00, 0x00, 0x00, 0x00} },
};
#define SIZEOF_BE_CTRL_INITTBL_1 (sizeof(BE_CTRL_InitTbl_1)/sizeof(BE_CTRL_InitTbl_1[0]))

BE_CTRL_REG BE_CTRL_InitTbl_2[] ={

	{ 0x6,0x68,{0x30, 0x7c, 0x00, 0x00, 0x00, 0x85} },
	{ 0x6,0x58,{0x03, 0x20, 0x00, 0x00, 0x00, 0x01} },
	{ 0x6,0x58,{0x05, 0x10, 0x00, 0x00, 0x00, 0x01} },
	{ 0x6,0x68,{0x30, 0x7c, 0x00, 0x00, 0x00, 0x80} },

	// 4
	{ 0x6,0x58,{0x31, 0x20, 0xff, 0xff, 0xff, 0xff} },//x1
	{ 0x6,0x58,{0x31, 0x30, 0xff, 0xff, 0xff, 0xff} },//x2
	{ 0x6,0x58,{0x31, 0x38, 0xff, 0xff, 0xff, 0xff} },//x3
	{ 0x6,0x58,{0x31, 0x40, 0xff, 0xff, 0xff, 0xff} },//x4
	{ 0x6,0x58,{0x31, 0x50, 0xff, 0xff, 0xff, 0xff} },//x5
	{ 0x6,0x58,{0x31, 0x60, 0xff, 0xff, 0xff, 0xff} },//x6
	{ 0x6,0x58,{0x31, 0x70, 0xff, 0xff, 0xff, 0xff} },//x7
	{ 0x6,0x58,{0x31, 0x80, 0xff, 0xff, 0xff, 0xff} },//x8
	{ 0x6,0x58,{0x31, 0x90, 0xff, 0xff, 0xff, 0xff} },//12 x17
	{ 0x6,0x58,{0x31, 0x94, 0xff, 0xff, 0xff, 0xff} },//x9

	// 14
	{ 0x6,0x68,{0x30, 0x7c, 0x00, 0x00, 0x00, 0x84} },

	// 15
	{ 0x6,0x58,{0x11, 0x64, 0xff, 0xff, 0xff, 0xff} },// x10
	{ 0x6,0x58,{0x11, 0x68, 0xff, 0xff, 0xff, 0xff} },// x11
	{ 0x6,0x58,{0x11, 0x6c, 0xff, 0xff, 0xff, 0xff} },// x12
	{ 0x6,0x58,{0x11, 0x70, 0xff, 0xff, 0xff, 0xff} },// x13
	{ 0x6,0x58,{0x11, 0x74, 0xff, 0xff, 0xff, 0xff} },// x14
	{ 0x6,0x58,{0x11, 0x50, 0xff, 0xff, 0xff, 0xff} },// x15
	{ 0x6,0x58,{0x11, 0x00, 0xff, 0xff, 0xff, 0xff} },// x16

	// 22
	{ 0x6,0x68,{0x30, 0x7c, 0x00, 0x00, 0x00, 0x8f} },

#if 1
	// 23
	{ 0x6,0x58,{0x12, 0x48, 0x00, 0x00, 0x00, 0x00} },// X29
	{ 0x6,0x58,{0x12, 0x54, 0x00, 0x00, 0x00, 0x00} },// X30
	{ 0x6,0x58,{0x12, 0x60, 0x00, 0x00, 0x00, 0x00} },
	{ 0x6,0x58,{0x12, 0x6c, 0x00, 0x00, 0x00, 0x00} },
	{ 0x6,0x58,{0x12, 0x78, 0x00, 0x00, 0x00, 0x00} },
	{ 0x6,0x58,{0x12, 0x84, 0x00, 0x00, 0x00, 0x00} },
	{ 0x6,0x58,{0x12, 0x90, 0x00, 0x00, 0x00, 0x00} },
	{ 0x6,0x58,{0x12, 0x9c, 0x00, 0x00, 0x00, 0x00} },

    //31
	{ 0x6,0x58,{0x11, 0xc4, 0x00, 0x00, 0x00, 0x07} },//X37
	{ 0x6,0x58,{0x11, 0xcc, 0x00, 0x00, 0x00, 0x00} },
	{ 0x6,0x58,{0x11, 0xd0, 0x00, 0x00, 0x00, 0x00} },
	{ 0x6,0x58,{0x11, 0xd4, 0x00, 0x00, 0x00, 0x00} },
	{ 0x6,0x58,{0x11, 0xd8, 0x00, 0x00, 0x00, 0x00} },
	{ 0x6,0x58,{0x11, 0xdc, 0x00, 0x00, 0x00, 0x00} },
	{ 0x6,0x58,{0x11, 0xe0, 0x00, 0x00, 0x00, 0x00} },
	{ 0x6,0x58,{0x11, 0xe4, 0x00, 0x00, 0x00, 0x00} },
	{ 0x6,0x58,{0x12, 0x08, 0x00, 0x00, 0x00, 0x00} },
	{ 0x6,0x58,{0x12, 0x14, 0x00, 0x00, 0x00, 0x00} },

	// 40
	{ 0x6,0x68,{0x30, 0x7c, 0x00, 0x00, 0x00, 0x85} },
	{ 0x6,0x58,{0x03, 0x10, 0x00, 0x00, 0x00, 0x01} },
	{ 0x6,0x58,{0x05, 0x00, 0x00, 0x00, 0x00, 0x01} },
};
#define SIZEOF_BE_CTRL_INITTBL_2 (sizeof(BE_CTRL_InitTbl_2)/sizeof(BE_CTRL_InitTbl_2[0]))

static BE_CTRL_REG BE_CTRL_InitTbl_3[] =
{
	{ 0x6,0x68,{0x30, 0x7c, 0x00, 0x00, 0x00, 0x8f} },
	{ 0x6,0x58,{0x13, 0x48, 0x00, 0x00, 0x00, 0xff} },
	{ 0x6,0x68,{0x30, 0x7c, 0x00, 0x00, 0x00, 0xc0} },
	{ 0x6,0x58,{0x00, 0x34, 0x00, 0x00, 0x00, 0x01} },
	{ 0x6,0x68,{0x30, 0x24, 0x00, 0x00, 0x00, 0x02} },
};
#define SIZEOF_BE_CTRL_INITTBL_3 (sizeof(BE_CTRL_InitTbl_3)/sizeof(BE_CTRL_InitTbl_3[0]))

#endif

static void debug_log_be_i2c_access(unsigned char slave, unsigned char length, unsigned char* data)
{
    unsigned char i = 0;

    printf("BEI2C: %02x", slave);
    for(i = 0; i < length; i++) {
        printf(" %02x", data[i]);
    }
    printf("\n");
}

static void bectrl_send_data_table(BE_CTRL_REG* initTable, unsigned char tableSize)
{
    unsigned char index = 0, addr = 0, size = 0;
    unsigned char* p_data = NULL;

	for(index = 0; index < tableSize; index++)
    {
        addr   = initTable[index].bAddr;
        size   = initTable[index].bSize;
        p_data = initTable[index].bArray;

        debug_log_be_i2c_access(addr, size, p_data);
        if (I2C_Write_EX(BE_I2C, (addr>>1), size, p_data) < 0) //addr>>1 is I2C API spec.
            printf("program BE Control failed_short\n");
    }
}

#define BECTRL_BOOT_CHECK_CNT       40
#define BECTRL_BOOT_CHECK_DELEY     5   //ms
static void bectrl_wait_boot_done(void)
{
    unsigned char i;
    unsigned char regAddr[2] = {0x02, 0x00};
    unsigned char data[16] = {0};
    BE_CTRL_REG checkState[]={
        { 0x6,0x68, {0x30, 0x7C, 0x00, 0x00, 0x00, 0xC0} },
    };


    //BE Check BOOTUP_NOTE
    for(i = 0; i < BECTRL_BOOT_CHECK_CNT ; i++){
        if(IO_Get(PIN_BOOTUP_NOTE)){
            //printf("PIN_BOOTUP_NOTE High cnt=%d\n",i);
            break;
        }
        else
            mdelay(BECTRL_BOOT_CHECK_DELEY);
    }
    if(i >= BECTRL_BOOT_CHECK_CNT)
        printf("[BEIC]:PIN_BOOTUP_NOTE error.\n");


    //BE Check BOOT STATUS
    for(i = 0; i < BECTRL_BOOT_CHECK_CNT; i++){

        debug_log_be_i2c_access(checkState[0].bAddr, checkState[0].bSize, checkState[0].bArray);
        I2C_Write_EX(BE_I2C, (checkState[0].bAddr>>1),  checkState[0].bSize, checkState[0].bArray );
        I2C_Read_EX(BE_I2C, (0x58>>1) , 2, regAddr, 4, data);
        if(data[0] == 1){
            //printf("--[BEIC]:Boot state stable cnt =%d--\n",i);
            break;
        }
        else
            mdelay(BECTRL_BOOT_CHECK_DELEY);
    }

    if(i >= BECTRL_BOOT_CHECK_CNT){
        printf("[BEIC]:Boot state error.\n");
        printf("%d %d %d %d \n",data[0],data[1],data[2],data[3]);
    }
}

static void bectrl_load_InitTbl_2(void)
{
    BE_CTRL_InitTbl_2[4].bArray[2] =default_panel_parameter.snInfo.External_device_control_1_X1_31_24;
	BE_CTRL_InitTbl_2[4].bArray[3] =default_panel_parameter.snInfo.External_device_control_1_X1_23_16;
	BE_CTRL_InitTbl_2[4].bArray[4] =default_panel_parameter.snInfo.External_device_control_1_X1_15_8;
	BE_CTRL_InitTbl_2[4].bArray[5] =default_panel_parameter.snInfo.External_device_control_1_X1_7_0;

	BE_CTRL_InitTbl_2[5].bArray[2] =default_panel_parameter.snInfo.External_device_control_1_X2_31_24;
	BE_CTRL_InitTbl_2[5].bArray[3] =default_panel_parameter.snInfo.External_device_control_1_X2_23_16;
	BE_CTRL_InitTbl_2[5].bArray[4] =default_panel_parameter.snInfo.External_device_control_1_X2_15_8;
	BE_CTRL_InitTbl_2[5].bArray[5] =default_panel_parameter.snInfo.External_device_control_1_X2_7_0;

	BE_CTRL_InitTbl_2[6].bArray[2] =default_panel_parameter.snInfo.External_device_control_1_X3_31_24;
	BE_CTRL_InitTbl_2[6].bArray[3] =default_panel_parameter.snInfo.External_device_control_1_X3_23_16;
	BE_CTRL_InitTbl_2[6].bArray[4] =default_panel_parameter.snInfo.External_device_control_1_X3_15_8;
	BE_CTRL_InitTbl_2[6].bArray[5] =default_panel_parameter.snInfo.External_device_control_1_X3_7_0;

	BE_CTRL_InitTbl_2[7].bArray[2] =default_panel_parameter.snInfo.External_device_control_1_X4_31_24;
	BE_CTRL_InitTbl_2[7].bArray[3] =default_panel_parameter.snInfo.External_device_control_1_X4_23_16;
	BE_CTRL_InitTbl_2[7].bArray[4] =default_panel_parameter.snInfo.External_device_control_1_X4_15_8;
	BE_CTRL_InitTbl_2[7].bArray[5] =default_panel_parameter.snInfo.External_device_control_1_X4_7_0;

	BE_CTRL_InitTbl_2[8].bArray[2] =default_panel_parameter.snInfo.External_device_control_1_X5_31_24;
	BE_CTRL_InitTbl_2[8].bArray[3] =default_panel_parameter.snInfo.External_device_control_1_X5_23_16;
	BE_CTRL_InitTbl_2[8].bArray[4] =default_panel_parameter.snInfo.External_device_control_1_X5_15_8;
	BE_CTRL_InitTbl_2[8].bArray[5] =default_panel_parameter.snInfo.External_device_control_1_X5_7_0;

	BE_CTRL_InitTbl_2[9].bArray[2] =default_panel_parameter.snInfo.External_device_control_1_X6_31_24;
	BE_CTRL_InitTbl_2[9].bArray[3] =default_panel_parameter.snInfo.External_device_control_1_X6_23_16;
	BE_CTRL_InitTbl_2[9].bArray[4] =default_panel_parameter.snInfo.External_device_control_1_X6_15_8;
	BE_CTRL_InitTbl_2[9].bArray[5] =default_panel_parameter.snInfo.External_device_control_1_X6_7_0;

	BE_CTRL_InitTbl_2[10].bArray[2] =default_panel_parameter.snInfo.External_device_control_1_X7_31_24;
	BE_CTRL_InitTbl_2[10].bArray[3] =default_panel_parameter.snInfo.External_device_control_1_X7_23_16;
	BE_CTRL_InitTbl_2[10].bArray[4] =default_panel_parameter.snInfo.External_device_control_1_X7_15_8;
	BE_CTRL_InitTbl_2[10].bArray[5] =default_panel_parameter.snInfo.External_device_control_1_X7_7_0;

	BE_CTRL_InitTbl_2[11].bArray[2] =default_panel_parameter.snInfo.External_device_control_1_X8_31_24;
	BE_CTRL_InitTbl_2[11].bArray[3] =default_panel_parameter.snInfo.External_device_control_1_X8_23_16;
	BE_CTRL_InitTbl_2[11].bArray[4] =default_panel_parameter.snInfo.External_device_control_1_X8_15_8;
	BE_CTRL_InitTbl_2[11].bArray[5] =default_panel_parameter.snInfo.External_device_control_1_X8_7_0;

	BE_CTRL_InitTbl_2[12].bArray[2] =default_panel_parameter.snInfo.External_device_control_1_X17_31_24;
	BE_CTRL_InitTbl_2[12].bArray[3] =default_panel_parameter.snInfo.External_device_control_1_X17_23_16;
	BE_CTRL_InitTbl_2[12].bArray[4] =default_panel_parameter.snInfo.External_device_control_1_X17_15_8;
	BE_CTRL_InitTbl_2[12].bArray[5] =default_panel_parameter.snInfo.External_device_control_1_X17_7_0;

	BE_CTRL_InitTbl_2[13].bArray[2] =default_panel_parameter.snInfo.External_device_control_1_X9_31_24;
	BE_CTRL_InitTbl_2[13].bArray[3] =default_panel_parameter.snInfo.External_device_control_1_X9_23_16;
	BE_CTRL_InitTbl_2[13].bArray[4] =default_panel_parameter.snInfo.External_device_control_1_X9_15_8;
	BE_CTRL_InitTbl_2[13].bArray[5] =default_panel_parameter.snInfo.External_device_control_1_X9_7_0;

	BE_CTRL_InitTbl_2[15].bArray[2] =default_panel_parameter.snInfo.External_device_control_1_X10_31_24;
	BE_CTRL_InitTbl_2[15].bArray[3] =default_panel_parameter.snInfo.External_device_control_1_X10_23_16;
	BE_CTRL_InitTbl_2[15].bArray[4] =default_panel_parameter.snInfo.External_device_control_1_X10_15_8;
	BE_CTRL_InitTbl_2[15].bArray[5] =default_panel_parameter.snInfo.External_device_control_1_X10_7_0;

	BE_CTRL_InitTbl_2[16].bArray[2] =default_panel_parameter.snInfo.External_device_control_1_X11_31_24;
	BE_CTRL_InitTbl_2[16].bArray[3] =default_panel_parameter.snInfo.External_device_control_1_X11_23_16;
	BE_CTRL_InitTbl_2[16].bArray[4] =default_panel_parameter.snInfo.External_device_control_1_X11_15_8;
	BE_CTRL_InitTbl_2[16].bArray[5] =default_panel_parameter.snInfo.External_device_control_1_X11_7_0;

	BE_CTRL_InitTbl_2[17].bArray[2] =default_panel_parameter.snInfo.External_device_control_1_X12_31_24;
	BE_CTRL_InitTbl_2[17].bArray[3] =default_panel_parameter.snInfo.External_device_control_1_X12_23_16;
	BE_CTRL_InitTbl_2[17].bArray[4] =default_panel_parameter.snInfo.External_device_control_1_X12_15_8;
	BE_CTRL_InitTbl_2[17].bArray[5] =default_panel_parameter.snInfo.External_device_control_1_X12_7_0;

	BE_CTRL_InitTbl_2[18].bArray[2] =default_panel_parameter.snInfo.External_device_control_1_X13_31_24;
	BE_CTRL_InitTbl_2[18].bArray[3] =default_panel_parameter.snInfo.External_device_control_1_X13_23_16;
	BE_CTRL_InitTbl_2[18].bArray[4] =default_panel_parameter.snInfo.External_device_control_1_X13_15_8;
	BE_CTRL_InitTbl_2[18].bArray[5] =default_panel_parameter.snInfo.External_device_control_1_X13_7_0;

	BE_CTRL_InitTbl_2[19].bArray[2] =default_panel_parameter.snInfo.External_device_control_1_X14_31_24;
	BE_CTRL_InitTbl_2[19].bArray[3] =default_panel_parameter.snInfo.External_device_control_1_X14_23_16;
	BE_CTRL_InitTbl_2[19].bArray[4] =default_panel_parameter.snInfo.External_device_control_1_X14_15_8;
	BE_CTRL_InitTbl_2[19].bArray[5] =default_panel_parameter.snInfo.External_device_control_1_X14_7_0;

	BE_CTRL_InitTbl_2[20].bArray[2] =default_panel_parameter.snInfo.External_device_control_1_X15_31_24;
	BE_CTRL_InitTbl_2[20].bArray[3] =default_panel_parameter.snInfo.External_device_control_1_X15_23_16;
	BE_CTRL_InitTbl_2[20].bArray[4] =default_panel_parameter.snInfo.External_device_control_1_X15_15_8;
	BE_CTRL_InitTbl_2[20].bArray[5] =default_panel_parameter.snInfo.External_device_control_1_X15_7_0;

	BE_CTRL_InitTbl_2[21].bArray[2] =default_panel_parameter.snInfo.External_device_control_1_X16_31_24;
	BE_CTRL_InitTbl_2[21].bArray[3] =default_panel_parameter.snInfo.External_device_control_1_X16_23_16;
	BE_CTRL_InitTbl_2[21].bArray[4] =default_panel_parameter.snInfo.External_device_control_1_X16_15_8;
	BE_CTRL_InitTbl_2[21].bArray[5] =default_panel_parameter.snInfo.External_device_control_1_X16_7_0;


    BE_CTRL_InitTbl_2[23].bArray[2] =default_panel_parameter.snInfo.VTOD_De_emphasis_set[0];
    BE_CTRL_InitTbl_2[23].bArray[3] =default_panel_parameter.snInfo.VTOD_De_emphasis_set[1];
    BE_CTRL_InitTbl_2[23].bArray[4] =default_panel_parameter.snInfo.VTOD_De_emphasis_set[2];
    BE_CTRL_InitTbl_2[23].bArray[5] =default_panel_parameter.snInfo.VTOD_De_emphasis_set[3];

    BE_CTRL_InitTbl_2[24].bArray[2] =default_panel_parameter.snInfo.VTOD_De_emphasis_set[4];
    BE_CTRL_InitTbl_2[24].bArray[3] =default_panel_parameter.snInfo.VTOD_De_emphasis_set[5];
    BE_CTRL_InitTbl_2[24].bArray[4] =default_panel_parameter.snInfo.VTOD_De_emphasis_set[6];
    BE_CTRL_InitTbl_2[24].bArray[5] =default_panel_parameter.snInfo.VTOD_De_emphasis_set[7];

    BE_CTRL_InitTbl_2[25].bArray[2] =default_panel_parameter.snInfo.VTOD_De_emphasis_set[8];
    BE_CTRL_InitTbl_2[25].bArray[3] =default_panel_parameter.snInfo.VTOD_De_emphasis_set[9];
    BE_CTRL_InitTbl_2[25].bArray[4] =default_panel_parameter.snInfo.VTOD_De_emphasis_set[10];
    BE_CTRL_InitTbl_2[25].bArray[5] =default_panel_parameter.snInfo.VTOD_De_emphasis_set[11];

    BE_CTRL_InitTbl_2[26].bArray[2] =default_panel_parameter.snInfo.VTOD_De_emphasis_set[12];
    BE_CTRL_InitTbl_2[26].bArray[3] =default_panel_parameter.snInfo.VTOD_De_emphasis_set[13];
    BE_CTRL_InitTbl_2[26].bArray[4] =default_panel_parameter.snInfo.VTOD_De_emphasis_set[14];
    BE_CTRL_InitTbl_2[26].bArray[5] =default_panel_parameter.snInfo.VTOD_De_emphasis_set[15];

    BE_CTRL_InitTbl_2[27].bArray[2] =default_panel_parameter.snInfo.VTOD_De_emphasis_set[16];
    BE_CTRL_InitTbl_2[27].bArray[3] =default_panel_parameter.snInfo.VTOD_De_emphasis_set[17];
    BE_CTRL_InitTbl_2[27].bArray[4] =default_panel_parameter.snInfo.VTOD_De_emphasis_set[18];
    BE_CTRL_InitTbl_2[27].bArray[5] =default_panel_parameter.snInfo.VTOD_De_emphasis_set[19];

    BE_CTRL_InitTbl_2[28].bArray[2] =default_panel_parameter.snInfo.VTOD_De_emphasis_set[20];
    BE_CTRL_InitTbl_2[28].bArray[3] =default_panel_parameter.snInfo.VTOD_De_emphasis_set[21];
    BE_CTRL_InitTbl_2[28].bArray[4] =default_panel_parameter.snInfo.VTOD_De_emphasis_set[22];
    BE_CTRL_InitTbl_2[28].bArray[5] =default_panel_parameter.snInfo.VTOD_De_emphasis_set[23];

    BE_CTRL_InitTbl_2[29].bArray[2] =default_panel_parameter.snInfo.VTOD_De_emphasis_set[24];
    BE_CTRL_InitTbl_2[29].bArray[3] =default_panel_parameter.snInfo.VTOD_De_emphasis_set[25];
    BE_CTRL_InitTbl_2[29].bArray[4] =default_panel_parameter.snInfo.VTOD_De_emphasis_set[26];
    BE_CTRL_InitTbl_2[29].bArray[5] =default_panel_parameter.snInfo.VTOD_De_emphasis_set[27];

    BE_CTRL_InitTbl_2[30].bArray[2] =default_panel_parameter.snInfo.VTOD_De_emphasis_set[28];
    BE_CTRL_InitTbl_2[30].bArray[3] =default_panel_parameter.snInfo.VTOD_De_emphasis_set[29];
    BE_CTRL_InitTbl_2[30].bArray[4] =default_panel_parameter.snInfo.VTOD_De_emphasis_set[30];
    BE_CTRL_InitTbl_2[30].bArray[5] =default_panel_parameter.snInfo.VTOD_De_emphasis_set[31];//X36

    //X37
    BE_CTRL_InitTbl_2[31].bArray[2] =default_panel_parameter.snInfo.Common_control[0];
    BE_CTRL_InitTbl_2[31].bArray[3] =default_panel_parameter.snInfo.Common_control[1];
    BE_CTRL_InitTbl_2[31].bArray[4] =default_panel_parameter.snInfo.Common_control[2];
    BE_CTRL_InitTbl_2[31].bArray[5] =default_panel_parameter.snInfo.Common_control[3];

	BE_CTRL_InitTbl_2[32].bArray[2] =default_panel_parameter.snInfo.Common_control[4];
	BE_CTRL_InitTbl_2[32].bArray[3] =default_panel_parameter.snInfo.Common_control[5];
	BE_CTRL_InitTbl_2[32].bArray[4] =default_panel_parameter.snInfo.Common_control[6];
	BE_CTRL_InitTbl_2[32].bArray[5] =default_panel_parameter.snInfo.Common_control[7];

	BE_CTRL_InitTbl_2[33].bArray[2] =default_panel_parameter.snInfo.Common_control[8];
	BE_CTRL_InitTbl_2[33].bArray[3] =default_panel_parameter.snInfo.Common_control[9];
	BE_CTRL_InitTbl_2[33].bArray[4] =default_panel_parameter.snInfo.Common_control[10];
	BE_CTRL_InitTbl_2[33].bArray[5] =default_panel_parameter.snInfo.Common_control[11];

	BE_CTRL_InitTbl_2[34].bArray[2] =default_panel_parameter.snInfo.Common_control[12];
	BE_CTRL_InitTbl_2[34].bArray[3] =default_panel_parameter.snInfo.Common_control[13];
	BE_CTRL_InitTbl_2[34].bArray[4] =default_panel_parameter.snInfo.Common_control[14];
	BE_CTRL_InitTbl_2[34].bArray[5] =default_panel_parameter.snInfo.Common_control[15];

	BE_CTRL_InitTbl_2[35].bArray[2] =default_panel_parameter.snInfo.Common_control[16];
	BE_CTRL_InitTbl_2[35].bArray[3] =default_panel_parameter.snInfo.Common_control[17];
	BE_CTRL_InitTbl_2[35].bArray[4] =default_panel_parameter.snInfo.Common_control[18];
	BE_CTRL_InitTbl_2[35].bArray[5] =default_panel_parameter.snInfo.Common_control[19];

	BE_CTRL_InitTbl_2[36].bArray[2] =default_panel_parameter.snInfo.Common_control[20];
	BE_CTRL_InitTbl_2[36].bArray[3] =default_panel_parameter.snInfo.Common_control[21];
	BE_CTRL_InitTbl_2[36].bArray[4] =default_panel_parameter.snInfo.Common_control[22];
	BE_CTRL_InitTbl_2[36].bArray[5] =default_panel_parameter.snInfo.Common_control[23];

	BE_CTRL_InitTbl_2[37].bArray[2] =default_panel_parameter.snInfo.Common_control[24];
	BE_CTRL_InitTbl_2[37].bArray[3] =default_panel_parameter.snInfo.Common_control[25];
	BE_CTRL_InitTbl_2[37].bArray[4] =default_panel_parameter.snInfo.Common_control[26];
	BE_CTRL_InitTbl_2[37].bArray[5] =default_panel_parameter.snInfo.Common_control[27];

	BE_CTRL_InitTbl_2[38].bArray[2] =default_panel_parameter.snInfo.Common_control[28];
	BE_CTRL_InitTbl_2[38].bArray[3] =default_panel_parameter.snInfo.Common_control[29];
	BE_CTRL_InitTbl_2[38].bArray[4] =default_panel_parameter.snInfo.Common_control[30];
	BE_CTRL_InitTbl_2[38].bArray[5] =default_panel_parameter.snInfo.Common_control[31];

	BE_CTRL_InitTbl_2[39].bArray[2] =default_panel_parameter.snInfo.Common_control[32];
	BE_CTRL_InitTbl_2[39].bArray[3] =default_panel_parameter.snInfo.Common_control[33];
	BE_CTRL_InitTbl_2[39].bArray[4] =default_panel_parameter.snInfo.Common_control[34];
	BE_CTRL_InitTbl_2[39].bArray[5] =default_panel_parameter.snInfo.Common_control[35];

	BE_CTRL_InitTbl_2[40].bArray[2] =default_panel_parameter.snInfo.Common_control[36];
	BE_CTRL_InitTbl_2[40].bArray[3] =default_panel_parameter.snInfo.Common_control[37];
	BE_CTRL_InitTbl_2[40].bArray[4] =default_panel_parameter.snInfo.Common_control[38];
	BE_CTRL_InitTbl_2[40].bArray[5] =default_panel_parameter.snInfo.Common_control[39];
}

#elif defined(CONFIG_CUSTOM_Warrior_PowerSequence)
#ifdef CONFIG_TCON_LESS
bool panel_set_pmic_lsic(void)
{
	char tmpPath[100] = {0};
	UINT8 tconIndex = 0;
	char *r_file_buf = NULL;
	char w_file_buf[600] = {'\0'};
    int file_length = 0;
	char buf[32] = {'\0'};
	int charcount = 0, linecount = 0, buffercount = 0, w_count = 0;
	char tmp_byte = 0;
	unsigned char dataCount = 0; 	// 0:cmd_type, 1:slave_add/time, 2:sub_add, 3:length, 4:data
	unsigned char cmdType = 0;		// 0:none 1:write, 2:delay, 3:read,
	unsigned int msec = 0;

	unsigned char slave_add = 0, sub_add = 0, length = 0;
	unsigned char p_data[20] ={0};

	printf("[trace code] %s, %s, %d\n", __FILE__, __FUNCTION__, __LINE__);
	tconIndex = default_panel_parameter.snInfo.Tcon_Index;
	printf("[trace code] tconIndex = %d\n", tconIndex);

	sprintf(tmpPath, "%s%03d.csv", "tmp/factory_ro/tcon/pmic_",tconIndex);
	printf("[trace code] tmpPath = %s\n", tmpPath);

	printf("n=%x r=%x ,=%x \n",'\n', '\r', ',');
	//<cmd_type> <Slave Add> <Sub Add> <Length> <Data>
	if (factory_ro_read(tmpPath, &r_file_buf, &file_length)) {
		printf("can't find file:%s !\n", tmpPath);
		return false;
	}
	if(file_length > 0)
	{
		printf("[trace code] %s, %s, %d\n", __FILE__, __FUNCTION__, __LINE__);
		for (charcount=0; charcount<file_length; charcount++)
		{
			tmp_byte = r_file_buf[charcount];
			w_file_buf[w_count] = tmp_byte;
			w_count++;
			if((tmp_byte !=  '\n')&&(tmp_byte != '\r')&&(charcount==file_length-1))
			{
				printf("file end! 001\n");
			}
			else if((tmp_byte ==  '\n')||(tmp_byte == '\r'))
			{
				if(tmp_byte == '\r')
					continue;
				if(dataCount > 2 && buffercount > 0)
				{
					p_data[dataCount-2] = simple_strtoul(buf, NULL, 16);
					//printf("p_data[%d] = %s, \t", dataType-2, buf);
					//printf("p_data[%d] = 0x%02x, \n", dataType-2, p_data[dataType-2]);
				}

				if (cmdType==2)
				{
					printf("line[%d] %s, %d\n",linecount, "delay", msec);
					mdelay(msec);
				}
				else if (cmdType==1)
				{
					printf("line[%d] 0x%02x\t0x%02x\t0x%02x\t",linecount, slave_add, sub_add, length);
					//printf("line[%d] 0x%02x\t0x%02x\t0x%02x\t",linecount, (0x68>>1), sub_add, length);
					for(int i=1;i<length+1;i++)
						printf("0x%02x\t", p_data[i]);
					printf("\n");

					printf("[tcon code] %s, %s, %d\n", __FILE__, __FUNCTION__, __LINE__);
					printf("[tcon code] addr = 0x%02x\n", (slave_add>>1));
					if (I2C_Write_EX(TCON_I2C, (slave_add>>1), length+1, p_data) < 0) //addr>>1 is I2C API spec.
						printf("pmic Control failed_short\n");
				}
				else if (cmdType==3)
				{
					printf("I2C_Read_EX() \n");
				}

				cmdType = 0;
				msec = 0;
				tmp_byte = 0;
				memset(buf,'\0',sizeof(buf));
				buffercount = 0;
				dataCount = 0;
                linecount++;

			}
			else if((tmp_byte ==  ','))
            {
            	//printf("buf = %s\n", buf);
            	if(buffercount == 0)
            	{
					//printf("no data \n");
            	}
				else
				{
					if(dataCount == 0)
					{
						if (strcmp(buf, "delay")==0)
						{
							printf("buf is mdelay\n");
							cmdType = 2;
						}
						else if (strcmp(buf, "write")==0)
						{
							printf("buf is write\n");
							cmdType = 1;
						}
						else if (strcmp(buf, "read")==0)
						{
							printf("buf is read\n");
							cmdType = 3;
						}
					}
	            	else if(dataCount == 1)
	            	{
	            		if(cmdType == 2)
	            		{
	            			// delay
							msec = simple_strtoul(buf, NULL, 10);
	            		}
						else
						{
		            		slave_add = simple_strtoul(buf, NULL, 16);
		            		//printf("Slave Add = %s, \t",buf);
							//printf("slave_add = 0x%02x, \n",slave_add);
						}
	            	}
					else if(dataCount == 2)
	            	{
	            		//printf("buf = %s\n", buf);

		            	sub_add = simple_strtoul(buf, NULL, 16);
						p_data[0] = simple_strtoul(buf, NULL, 16);
	            		//printf("Sub Add = %s, \t",buf);
						//printf("sub_add = 0x%02x, \n",sub_add);
	            	}
					else if(dataCount == 3)
	            	{
	            		length = simple_strtoul(buf, NULL, 16);
	            		//printf("length = %s, \t",buf);
						//printf("length = 0x%02x, \n",length);
	            	}
					else
					{
						p_data[dataCount-2] = simple_strtoul(buf, NULL, 16);
						//printf("p_data[%d] = %s, \t", dataType-2, buf);
						//printf("p_data[%d] = 0x%02x, \n", dataCount-2, p_data[dataCount-2]);
					}
				}
				memset(buf,'\0',sizeof(buf));
                dataCount++;
                buffercount = 0;
            }
			else
            {
                buf[buffercount] = tmp_byte;
                buffercount++;
            }
		}
		if(w_count > 0)
		{
			printf("[trace code] %s, %s, %d\n", __FILE__, __FUNCTION__, __LINE__);
			factory_write("tmp/factory/pmic.bin", w_file_buf, w_count+1);
			factory_save();
		}
	}
	return true;
}

bool panel_set_vcom(void)
{
	//UINT8 tconIndex = 0;
	char *r_file_buf = NULL;
    int file_length = 0;
	char buf[32] = {'\0'};
	int charcount = 0, linecount = 0, buffercount = 0;
	char tmp_byte = 0;
	unsigned char dataCount = 0; 	// 0:cmd_type, 1:slave_add/time, 2:sub_add, 3:length, 4:data
	unsigned char cmdType = 0;		// 0:none 1:write, 2:delay, 3:read,
	unsigned int msec = 0;

	unsigned char slave_add = 0, sub_add = 0, length = 0;
	unsigned char p_data[20] ={0};

	printf("[trace code] %s, %s, %d\n", __FILE__, __FUNCTION__, __LINE__);
	//tconIndex = default_panel_parameter.snInfo[0].Tcon_Index;
	//printf("[trace code] tconIndex = %d\n", tconIndex);

	//sprintf(tmpPath, "%s%03d.bin", "tmp/factory_ro/tcon/pmic_",tconIndex);
	//printf("[trace code] tmpPath = %s\n", tmpPath);

	printf("n=%x r=%x ,=%x \n",'\n', '\r', ',');
	//<cmd_type> <Slave Add> <Sub Add> <Length> <Data>
	if (factory_read("tmp/factory/tcon/vcom.csv", &r_file_buf, &file_length)) {
		printf("can't find file:tmp/factory/tcon/vcom.csv !\n");
		if (takeover_read("takeover/vcom.bin", &r_file_buf, &file_length)) {
			printf("can't find file:takeover/vcom.bin !\n");
			return false;
		}
	}
	if(file_length > 0)
	{
		printf("[trace code] %s, %s, %d\n", __FILE__, __FUNCTION__, __LINE__);
		for (charcount=0; charcount<file_length; charcount++)
		{
			tmp_byte = r_file_buf[charcount];
			if((tmp_byte !=  '\n')&&(tmp_byte != '\r')&&(charcount==file_length-1))
			{
				printf("file end! 001\n");
			}
			else if((tmp_byte ==  '\n')||(tmp_byte == '\r'))
			{
				if(tmp_byte == '\r')
					continue;
				if(dataCount > 2 && buffercount > 0)
				{
					p_data[dataCount-2] = simple_strtoul(buf, NULL, 16);
					//printf("p_data[%d] = %s, \t", dataType-2, buf);
					//printf("p_data[%d] = 0x%02x, \n", dataType-2, p_data[dataType-2]);
				}

				if (cmdType==2)
				{
					printf("line[%d] %s, %d\n",linecount, "delay", msec);
					mdelay(msec);
				}
				else if (cmdType==1)
				{
					printf("line[%d] 0x%02x\t0x%02x\t0x%02x\t",linecount, slave_add, sub_add, length);
					//printf("line[%d] 0x%02x\t0x%02x\t0x%02x\t",linecount, (0x68>>1), sub_add, length);
					for(int i=1;i<length+1;i++)
						printf("0x%02x\t", p_data[i]);
					printf("\n");

					printf("[tcon code] %s, %s, %d\n", __FILE__, __FUNCTION__, __LINE__);
					printf("[tcon code] addr = 0x%02x\n", (slave_add>>1));
					if (I2C_Write_EX(TCON_I2C, (slave_add>>1), length+1, p_data) < 0) //addr>>1 is I2C API spec.
						printf("pmic Control failed_short\n");
				}
				else if (cmdType==3)
				{
					printf("I2C_Read_EX() \n");
				}

				cmdType = 0;
				msec = 0;
				tmp_byte = 0;
				memset(buf,'\0',sizeof(buf));
				buffercount = 0;
				dataCount = 0;
                linecount++;

			}
			else if((tmp_byte ==  ','))
            {
            	//printf("buf = %s\n", buf);
            	if(buffercount == 0)
            	{
					//printf("no data \n");
            	}
				else
				{
					if(dataCount == 0)
					{
						if (strcmp(buf, "delay")==0)
						{
							printf("buf is mdelay\n");
							cmdType = 2;
						}
						else if (strcmp(buf, "write")==0)
						{
							printf("buf is write\n");
							cmdType = 1;
						}
						else if (strcmp(buf, "read")==0)
						{
							printf("buf is read\n");
							cmdType = 3;
						}
					}
	            	else if(dataCount == 1)
	            	{
	            		if(cmdType == 2)
	            		{
	            			// delay
							msec = simple_strtoul(buf, NULL, 10);
	            		}
						else
						{
		            		slave_add = simple_strtoul(buf, NULL, 16);
		            		//printf("Slave Add = %s, \t",buf);
							//printf("slave_add = 0x%02x, \n",slave_add);
						}
	            	}
					else if(dataCount == 2)
	            	{
	            		//printf("buf = %s\n", buf);

		            	sub_add = simple_strtoul(buf, NULL, 16);
						p_data[0] = simple_strtoul(buf, NULL, 16);
	            		//printf("Sub Add = %s, \t",buf);
						//printf("sub_add = 0x%02x, \n",sub_add);
	            	}
					else if(dataCount == 3)
	            	{
	            		length = simple_strtoul(buf, NULL, 16);
	            		//printf("length = %s, \t",buf);
						//printf("length = 0x%02x, \n",length);
	            	}
					else
					{
						p_data[dataCount-2] = simple_strtoul(buf, NULL, 16);
						//printf("p_data[%d] = %s, \t", dataType-2, buf);
						//printf("p_data[%d] = 0x%02x, \n", dataCount-2, p_data[dataCount-2]);
					}
				}
				memset(buf,'\0',sizeof(buf));
                dataCount++;
                buffercount = 0;
            }
			else
            {
                buf[buffercount] = tmp_byte;
                buffercount++;
            }
		}
	}
	return true;
}

bool panel_set_tcon_timing(void)
{
	char tmpPath[100] = {0};
	UINT8 tconIndex = 0;
	char *raw_ptr = NULL;
	int file_len = 0;

	#define HEADER_SIZE 16
	UINT32 iSize = 0;	// bin total size
	UINT32 iTableArraySize;  //table total size
	char iTableType;

	UINT8 byte0 = 0;
	UINT8 byte1 = 0;
	UINT8 byte2 = 0;
	UINT8 byte3 = 0;

	UINT32 cmdType = 0;
	UINT32 addr = 0;
	UINT32 value_1 = 0;
	UINT32 value_2 = 0;
#if 1
	char w_file_buf[1024] = {'\0'};
	char addr_buffer[16] = {'\0'};
	int file_length = 0;
	int charcount = 0;
#endif

	printf("[trace code] %s, %s, %d\n", __FILE__, __FUNCTION__, __LINE__);

	tconIndex = default_panel_parameter.snInfo.Tcon_Index;
	printf("[trace code] tconIndex = %d\n", tconIndex);

	sprintf(tmpPath, "%s%03d.bin", "tmp/factory_ro/tcon/tcon_timing_",tconIndex);
	printf("[trace code] tmpPath = %s\n", tmpPath);

	if ((factory_ro_read((char *)tmpPath, &raw_ptr, &file_len) == 0)) {
		printf("%s size =%d byte.--\n", tmpPath, file_len);
		// get HEADER
		memcpy(&iSize,raw_ptr, sizeof(UINT32));
		memcpy(&iTableArraySize,raw_ptr+4, sizeof(UINT32));
		memcpy(&iTableType,raw_ptr+12, sizeof(char));
		printf("iSize =%d, 0x%x--\n",iSize, iSize);
		printf("iTableArraySize =%d, 0x%x--\n",iTableArraySize, iTableArraySize);
		printf("iTableType =%d, 0x%x--\n",iTableType, iTableType);

		// get table
		for (int i=0; i<iTableArraySize/16; i++)
		{
#if 0
			memcpy(&cmdType,raw_ptr+HEADER_SIZE+(16*i)+0, sizeof(UINT32));
			memcpy(&addr,raw_ptr+HEADER_SIZE+(16*i)+4, sizeof(UINT32));
			memcpy(&value_1,raw_ptr+HEADER_SIZE+(16*i)+8, sizeof(UINT32));
			memcpy(&value_2,raw_ptr+HEADER_SIZE+(16*i)+12, sizeof(UINT32));
#else
			// cmdType
			memcpy(&byte0,raw_ptr+HEADER_SIZE+(16*i)+0, sizeof(UINT8));
			memcpy(&byte1,raw_ptr+HEADER_SIZE+(16*i)+1, sizeof(UINT8));
			memcpy(&byte2,raw_ptr+HEADER_SIZE+(16*i)+2, sizeof(UINT8));
			memcpy(&byte3,raw_ptr+HEADER_SIZE+(16*i)+3, sizeof(UINT8));
			cmdType = (byte0<<24)+(byte1<<16)+(byte2<<8)+byte3;

			// addr
			memcpy(&byte0,raw_ptr+HEADER_SIZE+(16*i)+4+0, sizeof(UINT8));
			memcpy(&byte1,raw_ptr+HEADER_SIZE+(16*i)+4+1, sizeof(UINT8));
			memcpy(&byte2,raw_ptr+HEADER_SIZE+(16*i)+4+2, sizeof(UINT8));
			memcpy(&byte3,raw_ptr+HEADER_SIZE+(16*i)+4+3, sizeof(UINT8));
			addr = (byte0<<24)+(byte1<<16)+(byte2<<8)+byte3;
#if 1
			//sprintf(addr_buffer, "0x%02x%02x%02x%02x%c", (byte0<<24), (byte1<<16), (byte2<<8), byte3, ',');
			sprintf(addr_buffer, "0x%08x,", addr);
			strcat(w_file_buf, addr_buffer);
			printf("register addr = %s\n", addr_buffer);
			memset(addr_buffer,'\0',sizeof(addr_buffer));
#endif

			// value_1
			memcpy(&byte0,raw_ptr+HEADER_SIZE+(16*i)+8+0, sizeof(UINT8));
			memcpy(&byte1,raw_ptr+HEADER_SIZE+(16*i)+8+1, sizeof(UINT8));
			memcpy(&byte2,raw_ptr+HEADER_SIZE+(16*i)+8+2, sizeof(UINT8));
			memcpy(&byte3,raw_ptr+HEADER_SIZE+(16*i)+8+3, sizeof(UINT8));
			value_1 = (byte0<<24)+(byte1<<16)+(byte2<<8)+byte3;

			// value_2
			memcpy(&byte0,raw_ptr+HEADER_SIZE+(16*i)+12+0, sizeof(UINT8));
			memcpy(&byte1,raw_ptr+HEADER_SIZE+(16*i)+12+1, sizeof(UINT8));
			memcpy(&byte2,raw_ptr+HEADER_SIZE+(16*i)+12+2, sizeof(UINT8));
			memcpy(&byte3,raw_ptr+HEADER_SIZE+(16*i)+12+3, sizeof(UINT8));
			value_2 = (byte0<<24)+(byte1<<16)+(byte2<<8)+byte3;
#endif
			//printf("[%08xh] %d, 0x%08x, 0x%08x, 0x%08x\n", HEADER_SIZE+(i*16), cmdType, addr, value_1, value_2);

			switch(cmdType)
			{
				case 0:
					rtd_outl(addr, value_1);
					printf("rtd_outl 0x%08x, 0x%08x\n", addr, value_1);
					break;
				case 1:
					rtd_maskl(addr, value_1, value_2);
					printf("rtd_maskl 0x%08x, 0x%08x, 0x%08x\n", addr, value_1, value_2);
					break;
				case 4:
					rtd_part_outl(addr, value_1>>16, value_1&0xFFFF, value_2);
					printf("rtd_part_outl 0x%08x, 0x%08x, 0x%08x, 0x%08x\n", addr, (value_1>>16), (value_1&0xFFFF), value_2);
					break;
				default:
					break;
			}
		}
#if 1
		sprintf(addr_buffer, "%c%c", '\r', '\n');
		strcat(w_file_buf, addr_buffer);
		file_length = sizeof(w_file_buf);
		printf("[trace code] w_file_length = %d\n", sizeof(w_file_buf));
		for(charcount=0; charcount<file_length; charcount++)
		{
			if(w_file_buf[charcount]=='\0')
				break;
		}
		printf("[trace code] charcount = %d\n", charcount);
		if(charcount > 0)
		{
			factory_delete("tmp/factory/tcon/tcon_timing_addr.txt");
			factory_write("tmp/factory/tcon/tcon_timing_addr.txt", w_file_buf, charcount);
			factory_save();
		}
#endif
	}
	else
	{
		printf("can't find file:%s !\n", tmpPath);
		return false;
	}
	return true;
}

bool panel_set_tcon_order(void)
{
	char tmpPath[100] = {0};
	UINT8 tconIndex = 0;
	UINT8 tconOrder = 0;
	char *raw_ptr = NULL;
	int file_len = 0;

	printf("[trace code] %s, %s, %d\n", __FILE__, __FUNCTION__, __LINE__);
	tconIndex = default_panel_parameter.snInfo.Tcon_Index;
	printf("[trace code] tconIndex = %d\n", tconIndex);

	sprintf(tmpPath, "%s%03d.bin", "tmp/factory_ro/tcon/tcon_data_",tconIndex);
	printf("[trace code] tmpPath = %s\n", tmpPath);

	if ((factory_ro_read((char *)tmpPath, &raw_ptr, &file_len) == 0)) {
		printf("%s size =%d byte.--\n", tmpPath, file_len);
		// get tconOrder
		memcpy(&tconOrder, raw_ptr, sizeof(UINT8));
		printf("[trace code] tconOrder = %d\n", tconOrder);
	}
	else
	{
		printf("can't find file:%s !\n", tmpPath);
		return false;
	}

	switch(tconOrder)
	{
		case 0: // de-mura -> de-mura -> output gamma -> VALC -> OD -> line OD -> panel
			rtd_maskl(0xB802EB00, ~_BIT6, 0);		// B802EB00[6]= 0
			rtd_maskl(0xB802C804, ~_BIT1, 0);		// B802C804[1]= 0
			rtd_maskl(0xB802ee00, ~_BIT16, 0);		// B802ee00[16]= 0
			rtd_maskl(0xb8028004, ~_BIT31, 0);		// b8028004[31]= 0
			rtd_maskl(0xb8028004, ~_BIT29, _BIT29);	// b8028004[29]= 1
			break;

		case 1: // de-mura -> de-mura -> output gamma -> OD -> VALC -> line OD -> panel
			rtd_maskl(0xB802EB00, ~_BIT6, 0);		// B802EB00[6]= 0
			rtd_maskl(0xB802C804, ~_BIT1, 0);		// B802C804[1]= 0
			rtd_maskl(0xB802ee00, ~_BIT16, _BIT16);	// B802ee00[16]= 1
			rtd_maskl(0xb8028004, ~_BIT31, 0);		// b8028004[31]= 0
			rtd_maskl(0xb8028004, ~_BIT29, _BIT29);	// b8028004[29]= 1
			break;

		case 2: // de-mura -> de-mura -> VALC -> OD -> line OD -> output gamma -> panel
			rtd_maskl(0xB802EB00, ~_BIT6, 0);		// B802EB00[6]= 0
			rtd_maskl(0xB802C804, ~_BIT1, _BIT1);	// B802C804[1]= 1
			rtd_maskl(0xB802ee00, ~_BIT16, 0);		// B802ee00[16]= 0
			rtd_maskl(0xb8028004, ~_BIT31, _BIT31);	// b8028004[31]= 1
			rtd_maskl(0xb8028004, ~_BIT29, 0);		// b8028004[29]= 0
			break;

		case 3: // de-mura -> de-mura -> VALC -> OD -> output gamma -> line OD -> panel
			rtd_maskl(0xB802EB00, ~_BIT6, 0);		// B802EB00[6]= 0
			rtd_maskl(0xB802C804, ~_BIT1, _BIT1);	// B802C804[1]= 1
			rtd_maskl(0xB802ee00, ~_BIT16, 0);		// B802ee00[16]= 0
			rtd_maskl(0xb8028004, ~_BIT31, 0);		// b8028004[31]= 0
			rtd_maskl(0xb8028004, ~_BIT29, _BIT29);	// b8028004[29]= 1
			break;

		case 4: // de-mura -> de-mura -> OD -> VALC -> line OD -> output gamma -> panel
			rtd_maskl(0xB802EB00, ~_BIT6, 0);		// B802EB00[6]= 0
			rtd_maskl(0xB802C804, ~_BIT1, _BIT1);	// B802C804[1]= 1
			rtd_maskl(0xB802ee00, ~_BIT16, _BIT16);	// B802ee00[16]= 1
			rtd_maskl(0xb8028004, ~_BIT31, _BIT31);	// b8028004[31]= 1
			rtd_maskl(0xb8028004, ~_BIT29, 0);		// b8028004[29]= 0
			break;

		case 5: // de-mura -> de-mura -> OD -> VALC -> output gamma -> line OD -> panel
			rtd_maskl(0xB802EB00, ~_BIT6, 0);		// B802EB00[6]= 0
			rtd_maskl(0xB802C804, ~_BIT1, _BIT1);	// B802C804[1]= 1
			rtd_maskl(0xB802ee00, ~_BIT16, _BIT16);	// B802ee00[16]= 1
			rtd_maskl(0xb8028004, ~_BIT31, 0);		// b8028004[31]= 0
			rtd_maskl(0xb8028004, ~_BIT29, _BIT29);	// b8028004[29]= 1
			break;

		case 6: // de-mura -> output gamma -> VALC -> OD -> line OD -> de-mura -> panel
			rtd_maskl(0xB802EB00, ~_BIT6, _BIT6);	// B802EB00[6]= 1
			rtd_maskl(0xB802C804, ~_BIT1, 0);		// B802C804[1]= 0
			rtd_maskl(0xB802ee00, ~_BIT16, 0);		// B802ee00[16]= 0
			rtd_maskl(0xb8028004, ~_BIT31, 0);		// b8028004[31]= 0
			rtd_maskl(0xb8028004, ~_BIT29, _BIT29);	// b8028004[29]= 1
			break;

		case 7: // de-mura -> output gamma -> VALC -> OD -> de-mura -> line OD -> panel
			rtd_maskl(0xB802EB00, ~_BIT6, _BIT6);	// B802EB00[6]= 1
			rtd_maskl(0xB802C804, ~_BIT1, 0);		// B802C804[1]= 0
			rtd_maskl(0xB802ee00, ~_BIT16, 0);		// B802ee00[16]= 0
			rtd_maskl(0xb8028004, ~_BIT31, 0);		// b8028004[31]= 0
			rtd_maskl(0xb8028004, ~_BIT29, _BIT29);	// b8028004[29]= 1
			break;

		case 8: // de-mura -> output gamma -> OD -> VALC -> line OD -> de-mura -> panel
			rtd_maskl(0xB802EB00, ~_BIT6, _BIT6);	// B802EB00[6]= 1
			rtd_maskl(0xB802C804, ~_BIT1, 0);		// B802C804[1]= 0
			rtd_maskl(0xB802ee00, ~_BIT16, _BIT16);	// B802ee00[16]= 1
			rtd_maskl(0xb8028004, ~_BIT31, 0);		// b8028004[31]= 0
			rtd_maskl(0xb8028004, ~_BIT29, _BIT29);	// b8028004[29]= 1
			break;

		case 9: // de-mura -> output gamma -> OD -> VALC -> de-mura -> line OD -> panel
			rtd_maskl(0xB802EB00, ~_BIT6, _BIT6);	// B802EB00[6]= 1
			rtd_maskl(0xB802C804, ~_BIT1, 0);		// B802C804[1]= 0
			rtd_maskl(0xB802ee00, ~_BIT16, _BIT16);	// B802ee00[16]= 1
			rtd_maskl(0xb8028004, ~_BIT31, 0);		// b8028004[31]= 0
			rtd_maskl(0xb8028004, ~_BIT29, _BIT29);	// b8028004[29]= 1
			break;

		case 10: // de-mura -> VALC -> OD -> line OD -> de-mura -> output gamma -> panel
			rtd_maskl(0xB802EB00, ~_BIT6, _BIT6);	// B802EB00[6]= 1
			rtd_maskl(0xB802C804, ~_BIT1, _BIT1);	// B802C804[1]= 1
			rtd_maskl(0xB802ee00, ~_BIT16, 0);		// B802ee00[16]= 0
			rtd_maskl(0xb8028004, ~_BIT31, _BIT31);	// b8028004[31]= 1
			rtd_maskl(0xb8028004, ~_BIT29, 0);		// b8028004[29]= 0
			break;

		case 11: // de-mura -> VALC -> OD -> de-mura -> output gamma -> line OD -> panel
			rtd_maskl(0xB802EB00, ~_BIT6, _BIT6);	// B802EB00[6]= 1
			rtd_maskl(0xB802C804, ~_BIT1, _BIT1);	// B802C804[1]= 1
			rtd_maskl(0xB802ee00, ~_BIT16, 0);		// B802ee00[16]= 0
			rtd_maskl(0xb8028004, ~_BIT31, 0);		// b8028004[31]= 0
			rtd_maskl(0xb8028004, ~_BIT29, _BIT29);	// b8028004[29]= 1
			break;

		case 12: // de-mura -> OD -> VALC -> line OD -> de-mura -> output gamma -> panel
			rtd_maskl(0xB802EB00, ~_BIT6, _BIT6);	// B802EB00[6]= 1
			rtd_maskl(0xB802C804, ~_BIT1, _BIT1);	// B802C804[1]= 1
			rtd_maskl(0xB802ee00, ~_BIT16, _BIT16);	// B802ee00[16]= 1
			rtd_maskl(0xb8028004, ~_BIT31, _BIT31);	// b8028004[31]= 1
			rtd_maskl(0xb8028004, ~_BIT29, 0);		// b8028004[29]= 0
			break;

		case 13: // de-mura -> OD -> VALC -> de-mura -> output gamma -> line OD -> panel
			rtd_maskl(0xB802EB00, ~_BIT6, _BIT6);	// B802EB00[6]= 1
			rtd_maskl(0xB802C804, ~_BIT1, _BIT1);	// B802C804[1]= 1
			rtd_maskl(0xB802ee00, ~_BIT16, _BIT16);	// B802ee00[16]= 1
			rtd_maskl(0xb8028004, ~_BIT31, 0);		// b8028004[31]= 0
			rtd_maskl(0xb8028004, ~_BIT29, _BIT29);	// b8028004[29]= 1
			break;
	}
	return true;
}

bool panel_set_tcc(void)
{
	char tmpPath[100] = {0};
	UINT8 tconIndex = 0;
	UINT8 tcc_flow[30];
	char *raw_ptr = NULL;
	int file_len = 0;

	printf("[trace code] %s, %s, %d\n", __FILE__, __FUNCTION__, __LINE__);
	tconIndex = default_panel_parameter.snInfo.Tcon_Index;
	printf("[trace code] tconIndex = %d\n", tconIndex);

	sprintf(tmpPath, "%s%03d.bin", "tmp/factory_ro/tcon/tcon_data_",tconIndex);
	printf("[trace code] tmpPath = %s\n", tmpPath);

	if ((factory_ro_read((char *)tmpPath, &raw_ptr, &file_len) == 0)) {
		printf("%s size =%d byte.--\n", tmpPath, file_len);
		// get tcc_flow
		memcpy(&tcc_flow, raw_ptr+1, sizeof(UINT8)*30);
#if 1
		printf("[trace code] %s, %s, %d\n", __FILE__, __FUNCTION__, __LINE__);
		for(int i=0; i<30; i++)
		{
			printf("tcc_flow[%d]=%d, ", i, tcc_flow[i]);
		}
		printf("\n");
#endif
	}
	else
	{
		printf("can't find file:%s !\n", tmpPath);
		return false;
	}
	// tcc flow

	return true;
}
#endif
#endif
#endif

void panel_init_1st(void)
{

        if (boot_mode == BOOT_CONSOLE_MODE) {
            printf("skip panel_init_1st, mode=%d\n", boot_mode);
            return;
        }

	if (panel_init_1st_is_done)
		return;
	panel_init_1st_is_done = 1;

#if 0 // it's the wrong crt setting
	//Clock enable for Display Domain VIDEO Path
	rtd_setbits(CRT_SYS_CLKEN1_reg, _BIT4 | _BIT9);
#endif

	printf("panel_init_1st 0529_1022\n");

	if(default_panel_parameter.iCONFIG_PANEL_CUSTOM_INDEX == P_M4_Default_2k1k)
	{
		printf("reconfig dtg as fhd\n");
		panel_reconfig_fhd_param();
	}
#if defined(Config_Board_TV002_V001)
		//sn power seq spec
    if ((boot_power_on_mode == POWER_OFF) && (boot_mode != BOOT_RESCUE_MODE)){//vby1 don't need ouput follow sequence
        printf("Tv will goto suspend, skip panel_init_1st\n");
        return;
    }

#if defined(CONFIG_CUSTOM_Vulcan_PowerSequence)
		if(boot_power_on_mode==POWER_OFF){
			IO_Set(PIN_X_PQ_RST, 0);
		}
		else{
			//BE control sequence, by arthur
			//1. pull high X_PQ_RST
			printf("[arthur] release the BE_PQ reset.\n");
			IO_Set(PIN_X_PQ_RST, 1);	//pull high
			mdelay(500);

			printf("[Eric] BE_PQ I2C Cmd request.\n");

			//I2C4 src1 need to setting the InputMux 0xb80008d8 G12[17:16]=1 E11[21:20]=1
			rtd_outl(0xb80008d8, (rtd_inl(0xb80008d8) | 0x00110000));

	        //BE Sequence #0
	        bectrl_send_data_table(BE_CTRL_InitTbl_0, SIZEOF_BE_CTRL_INITTBL_0);

	        //BE Wait Bootup
	        bectrl_wait_boot_done();

	        //BE Sequence #1
	        printf("--------------#1----------\n");
	        bectrl_send_data_table(BE_CTRL_InitTbl_1, SIZEOF_BE_CTRL_INITTBL_1);

	        //BE Sequence #2
	        bectrl_load_InitTbl_2();
	        //TBD. Commented out due to spec issue.
	        printf("--------------#2----------\n");
	        //bectrl_send_data_table(BE_CTRL_InitTbl_2, SIZEOF_BE_CTRL_INITTBL_2);

	        //BE Sequence #3
	        printf("--------------#3----------\n");
	        bectrl_send_data_table(BE_CTRL_InitTbl_3, SIZEOF_BE_CTRL_INITTBL_3);

			//panel sequence
			printf("[arthur] Panel sequence : I2C request.\n");
			//1. Panel_I2C
			//2. Video Output (VXO) pull up
		}

#elif defined(CONFIG_CUSTOM_Warrior_PowerSequence)
        if(boot_power_on_mode != POWER_OFF){
            printf("==Strat Warrior PowerSequence==\n");
#ifdef CONFIG_TCON_LESS
#ifndef CONFIG_RTKPCB
            int pin_panel_less = IO_Get(PIN_PANEL_LESS);
            int pin_fbffc_top = IO_Get(PIN_FBFFC_TOP);
            int pin_fbffc_bottom = IO_Get(PIN_FBFFC_BOTTOM);
            int pin_tconless_sel = IO_Get(PIN_TCONLESS_SEL);
#else
            int pin_panel_less = 0;
            int pin_fbffc_top = 0;
            int pin_fbffc_bottom = 0;
            int pin_tconless_sel = 0;
#endif
            unsigned long long value = 0;
            if (pcb_mgr_get_enum_info_byname("PIN_WIFI_HOST_RESET", &value) == 0)
                IO_Set(value, 1);

            printf("[trace code] %s, %s, %d\n", __FILE__, __FUNCTION__, __LINE__);
            printf("[trace code] pin_panel_less=%d, pin_tconless_sel=%d\n", pin_panel_less, pin_tconless_sel);
            printf("[trace code] pin_fbffc_top=%d, pin_fbffc_bottom=%d\n", pin_fbffc_top, pin_fbffc_bottom);
		if(IsID_Match())
		{
			if (pin_fbffc_top==1 && pin_fbffc_bottom==0)
			{
				// Cross FFC
				printf("[trace code] Cross FFC !!!\n");
			}
			else if(pin_panel_less == 0)
			{
				// tcon/tcon_less
				if(pin_fbffc_top==0 && pin_fbffc_bottom==1)
				{
					// tcon_less
					printf("[trace code] Panel & Tcon-less !!!\n");
					panel_set_tcon_timing();
					panel_set_pmic_lsic();
					panel_set_vcom();
					panel_set_tcc();
					panel_set_tcon_order();
				}
				else
				{
					// tcon
					printf("[trace code] Panel & Tcon !!!\n");
					panel_set_tcon_timing();
					panel_set_tcc();
					panel_set_tcon_order();
				}
			}
			else
			{
				// panel_less, tcon/tcon_less
				if(pin_tconless_sel==0)
				{
					// tcon_less
					printf("[trace code] Panel-less & Tcon-less !!!\n");
					panel_set_tcon_timing();
					panel_set_pmic_lsic();
					panel_set_vcom();
					panel_set_tcc();
					panel_set_tcon_order();
				}
				else
				{
					// tcon
					printf("[trace code] Panel-less & Tcon !!!\n");
					panel_set_tcon_timing();
					panel_set_tcc();
					panel_set_tcon_order();
				}
			}
		}
		else
		{
			printf("[trace code] %s, %s, %d\n", __FILE__, __FUNCTION__, __LINE__);
			return;
		}
#endif
	}
#endif
#endif


	//printf("iCONFIG_BACKLIGHT_PWM_FREQ=%d\n", (&default_panel_parameter)->iCONFIG_BACKLIGHT_PWM_FREQ);
	//printf("iCONFIG_BACKLIGHT_PWM_DUTY=%d\n", (&default_panel_parameter)->iCONFIG_BACKLIGHT_PWM_DUTY);
	//printf("iPANEL_TO_LVDS_ON_ms=%d\n", (&default_panel_parameter)->iPANEL_TO_LVDS_ON_ms);
	//printf("iLVDS_TO_LIGHT_ON_ms=%d\n", (&default_panel_parameter)->iLVDS_TO_LIGHT_ON_ms);

#if defined(USE_PANEL_CONFIG_PARAM_EXTEND_FOR_TV035)
	if ( default_c_panel_param_extend.iCONFIG_CUSTOMER_LD != 0 )
	{
		printf("Local Dimming panel no use pwm \n");
		panel_LD_init_16(254);
	}
#endif

#if (defined(Config_Board_TV043_RENO_V001) || defined(Config_Board_TV043_RENO_V002))
	printf("iCONFIG_PANEL_CUSTOM_INDEX = [%d] \n", default_panel_parameter.iCONFIG_PANEL_CUSTOM_INDEX);
	if ( default_panel_parameter.iCONFIG_PANEL_CUSTOM_INDEX == VBY_ONE_PANEL_CHINASTAR_4K2K_600M_2S_8L )
	{
		printf("TV043 RENO Local Dimming panel\n");
		panel_ld_96area_bright_spi_init();
	}
#endif

	if(Get_PANEL_TYPE_IS_IWATT_LOCAL_DIMMING()){
		printf("\n $$$$$$$$ This is Local Dimming Panel !!! \n");
#ifdef CONFIG_REALTEK_LOCAL_DIMMING_INTERFACE
		ld_Init();
#endif
	}

#if defined(Config_Board_TV010_PANEL)
	 // FOR OLED Power on flow T6
	 if(default_panel_parameter.iCONFIG_PANEL_CUSTOM_INDEX== VBY_ONE_PANEL_LG_OLED_2K1K_120HZ_1S_4L)
	{
		//IO_Set(PIN_EVDD_ON, 0);
		//IO_Set(PIN_3D_EN, 0);
//		rtd_maskl(0xb801bd18,0xFFFBBFFF,0x00040000);  // // EVDD ON 3D OFF
		if(((&default_panel_parameter)->iPANEL_OFF_TO_ON_ms) > 500)
		{
			char times,remainder,i;
			times = ((&default_panel_parameter)->iPANEL_OFF_TO_ON_ms) /500;
			remainder = ((&default_panel_parameter)->iPANEL_OFF_TO_ON_ms) % 500;
			//printf("\n PANEL_TO_LVDS_ON_ms=%d\n",((&default_panel_parameter)->iPANEL_TO_LVDS_ON_ms));
			printf("\n T6 deley times=%d  remainder=%d\n", times , remainder);
			for(i=0;i<times;i++)
			{
				mdelay(500);
				WATCHDOG_KICK();
			}
			if(remainder)
				mdelay(remainder);
		}
		else
			mdelay((&default_panel_parameter)->iPANEL_OFF_TO_ON_ms);
	}
#endif

#ifndef IS_FPGA
#if 1
	if((default_panel_parameter.iCONFIG_PANEL_TYPE ==P_MINI_LVDS)
		&& (default_panel_parameter.iCONFIG_PANEL_CUSTOM_INDEX==P_MINI_LVDS_CSOT_PANEL))
	{
		printf("xxxxxx P_MINI_LVDS_CSOT_PANEL dont set panel_en here. xxxxxxxxxxx \n");
		// it needs customize power on sequence
	}
	else
	{

		if (boot_power_on_mode != POWER_OFF){
			#ifdef CONFIG_CUSTOM_SN_PANEL
			if((IsID_Match()==1) && (QHB_Boot == false))
				IO_Set(PIN_LVDS_ON_OFF, 1);
			#else
				IO_Set(PIN_LVDS_ON_OFF, 1);
			#endif
		}
	}
#endif
#endif


#if (defined CONFIG_PANEL_CMI_V390HJ1_PEL_OPENCELL)
	IO_Set(PIN_PANEL_OE1_ON_OFF, 1);
	IO_Set(PIN_PANEL_OE2_ON_OFF, 1);
	IO_Set(PIN_PANEL_VFLK_ON_OFF, 1);
#endif

#ifdef CONFIG_PANEL_SHARP_60_MEMC
	panel_sharp_memc_init(0);
#else //#ifdef CONFIG_PANEL_SHARP_60_MEMC
#ifdef CONFIG_BOARD_298X_TV035_QFP176_V3_EMMC
#else
	//if((default_panel_parameter.iCONFIG_PANEL_TYPE != P_VBY1_4K2K) &&
	//	(default_panel_parameter.iCONFIG_PANEL_TYPE != P_VBY1_2K1K) &&
	//  (default_panel_parameter.iCONFIG_PANEL_TYPE != P_VBY1_TO_HDMI_MEMC_FREERUN) &&
	//	(default_panel_parameter.iCONFIG_PANEL_TYPE != P_VBY1_TO_HDMI)){
	mdelay(((&default_panel_parameter)->iPANEL_TO_LVDS_ON_ms));
	//}
#endif
#endif //#ifdef CONFIG_PANEL_SHARP_60_MEMC

#if 0 //!(CONFIG_FT)

	if((default_panel_parameter.iCONFIG_PANEL_TYPE == P_VBY1_4K2K) ||
		(default_panel_parameter.iCONFIG_PANEL_TYPE == P_VBY1_TO_HDMI)){

		//check HW HTPDN done
		unsigned int cnt=100;
		vby1_vby1_status_fw_ctrl_RBUS vby1_vby1_status_fw_ctrl_reg;
		vby1_vby1_status_fw_ctrl_reg.regValue = rtd_inl(VBY1_VBY1_STATUS_FW_CTRL_reg);

		if(vby1_vby1_status_fw_ctrl_reg.htpdn_mode_ctrl == 0){
			while((vby1_vby1_status_fw_ctrl_reg.hw_htpdn==1)&&(cnt--)){
				mdelay(20);
				vby1_vby1_status_fw_ctrl_reg.regValue = rtd_inl(VBY1_VBY1_STATUS_FW_CTRL_reg);
			}
		}

		if(cnt)
			printf("------------- TCON HTPDN Pull Low [%d] \n", cnt);
		else
			printf("------------- TCON HTPDN Pull Low TimeOUT !!!\n");

		printf("------------- TCON HTPDN Pull Low status [%x] \n", rtd_inl(VBY1_VBY1_STATUS_FW_CTRL_reg));

	}
#endif
#if defined(CONFIG_FSW)
	if(fsw_emmc_bootup || fsw_spi_bootup)
	{
		printf("[trace code] %s, %s, %d\n", __FILE__, __FUNCTION__, __LINE__);
		// 0x20000000: // 512M
		// 0x40000000: // 1G
		// 0x60000000: // 1.5G
		// 0x80000000: // 2G
		printf("[trace code] get_ddr_size = 0x%x\n", get_ddr_size());
		if(get_ddr_size() == 0x60000000)
		{
			if (fsw_2k_panel_id == 1)
			{
				printf("update APA32W default_panel_parameter \n");
				default_panel_parameter.snInfo.PanelIndex = 13;
				memcpy(default_panel_parameter.snInfo.PanelIDString ,"IS6S320CNO0101" ,sizeof(char)*14);
				default_panel_parameter.snInfo.InchSize = 32;

				default_panel_parameter.snInfo.Chassis_Index = 0;
				default_panel_parameter.snInfo.Panel_Width = 1366;
				default_panel_parameter.snInfo.Panel_Height = 768;
				default_panel_parameter.snInfo.PixelClk60Hz = 79704000;
				default_panel_parameter.snInfo.HTotalMax = 2000;
				default_panel_parameter.snInfo.HTotal60Hz = 1640;
				default_panel_parameter.snInfo.HTotalMin = 1450;
				default_panel_parameter.snInfo.VTotalMax = 1200;
				default_panel_parameter.snInfo.VTotal60Hz = 811;
				default_panel_parameter.snInfo.VTotalMin = 778;
				default_panel_parameter.snInfo.VClkMax = 63;
				default_panel_parameter.snInfo.VClkMin = 47;
				default_panel_parameter.snInfo.HSyncWidth_60Hz = 32;
				default_panel_parameter.snInfo.VSyncWidth_60Hz = 4;
				default_panel_parameter.snInfo.HFrontPorch_60Hz = 192;
				default_panel_parameter.snInfo.HbackPorch_60Hz = 50;
				default_panel_parameter.snInfo.VFrontPorch_60Hz = 20;
				default_panel_parameter.snInfo.VbackPorch_60Hz = 19;
				default_panel_parameter.snInfo.HSyncPolarity = 1;
				default_panel_parameter.snInfo.VSyncPolarity = 1;
				default_panel_parameter.snInfo.PixelClk50Hz = 79704000;
				default_panel_parameter.snInfo.HTotal50Hz = 1640;
				default_panel_parameter.snInfo.VCOM_Pattern = 8;
				default_panel_parameter.snInfo.VCOM_Type = 1;	//6;
				default_panel_parameter.snInfo.Drive_strength = 14;	//7;
				default_panel_parameter.snInfo.Pre_emphasis_On_Off= 1;
				default_panel_parameter.snInfo.Pre_emphasis_level = 7;
				default_panel_parameter.snInfo.Spread_spectrum_On_Off = 1;
				default_panel_parameter.snInfo.SpreadPermillage = 4;
				default_panel_parameter.snInfo.SpreadFreq = 30000;
				default_panel_parameter.snInfo.Video_I_F_format = 7;
				default_panel_parameter.snInfo.VTotal50Hz = 972;
				default_panel_parameter.snInfo.HSyncWidth_50Hz = 32;
				default_panel_parameter.snInfo.VSyncWidth_50Hz = 4;
				default_panel_parameter.snInfo.HFrontPorch_50Hz = 192;
				default_panel_parameter.snInfo.HbackPorch_50Hz = 50;
				default_panel_parameter.snInfo.VFrontPorch_50Hz = 181;
				default_panel_parameter.snInfo.VbackPorch_50Hz = 19;
				default_panel_parameter.snInfo.Mura_CUC_ID = 0;
#ifdef CONFIG_TCON_LESS
				default_panel_parameter.snInfo.Tcon_Index = 0;
#else
				default_panel_parameter.snInfo.Reserved_15 = 0;
#endif
				default_panel_parameter.snInfo.CURRENT_MAX = 492;
				default_panel_parameter.snInfo.CURRENT_MIN = 147;
				default_panel_parameter.snInfo.BL_PWM_MAX = 1024;
				default_panel_parameter.snInfo.BL_PWM_MIN = 51;
				default_panel_parameter.snInfo.BL_CUR_FREQ = 77;
				default_panel_parameter.snInfo.BL_PWM_FREQ = 116;
				default_panel_parameter.snInfo.BL_WAIT_LOGO = 120;
				default_panel_parameter.snInfo.BL_PSL_DIFF = 0;
				default_panel_parameter.snInfo.PixelClk48Hz = 79704000;
				default_panel_parameter.snInfo.HTotal48Hz = 1064;
				default_panel_parameter.snInfo.VTotal48Hz= 1013;
				default_panel_parameter.snInfo.HSyncWidth_48Hz = 32;
				default_panel_parameter.snInfo.VSyncWidth_48Hz = 4;
				default_panel_parameter.snInfo.HFrontPorch_48Hz = 192;
				default_panel_parameter.snInfo.HbackPorch_48Hz = 50;
				default_panel_parameter.snInfo.VFrontPorch_48Hz = 222;
				default_panel_parameter.snInfo.VbackPorch_48Hz = 19;
				default_panel_parameter.snInfo.Reserved_16 = 0;
				default_panel_parameter.snInfo.Reserved_17 = 0;
				default_panel_parameter.snInfo.Reserved_18 = 0;
				default_panel_parameter.snInfo.Reserved_19 = 0;
				default_panel_parameter.snInfo.Reserved_20 = 0;
				default_panel_parameter.snInfo.Reserved_21 = 0;
				default_panel_parameter.snInfo.Reserved_22 = 0;
				default_panel_parameter.snInfo.Reserved_23 = 0;
				default_panel_parameter.snInfo.Reserved_24 = 0;
				default_panel_parameter.snInfo.Reserved_25 = 0;
				default_panel_parameter.snInfo.Reserved_26 = 0;
				default_panel_parameter.snInfo.Reserved_27 = 0;
				default_panel_parameter.snInfo.Reserved_28 = 0;
#if defined(Config_Vulcan3_PCB_TRUE)
				default_panel_parameter.snInfo.LVDS_Format = 0;
				default_panel_parameter.snInfo.LVDS_clock_level_even = 0;
				default_panel_parameter.snInfo.LVDS_clock_level_odd = 0;	//14;
#else
				default_panel_parameter.snInfo.Reserved_29 = 0;
				default_panel_parameter.snInfo.Reserved_30 = 0;
				default_panel_parameter.snInfo.LVDS_clock_level = 0;	//14;
#endif
				default_panel_parameter.snInfo.Mura_CUC_data_transfer = 0;		 //Reserved_32
				default_panel_parameter.snInfo._12V_WAIT = 0;
				default_panel_parameter.snInfo.EDID_WAIT = 4;
				default_panel_parameter.snInfo.VBO_WAIT = 1;

				// update default_panel_parameter
				default_panel_parameter.iCONFIG_DISPLAY_PORT = 1;
				default_panel_parameter.iCONFIG_DISPLAY_COLOR_BITS = 0;
				default_panel_parameter.iCONFIG_DISPLAY_EVEN_RSV1_BIT = 0;
				default_panel_parameter.iCONFIG_DISPLAY_ODD_RSV1_BIT = 0;
				default_panel_parameter.iCONFIG_DISPLAY_BITMAPPING_TABLE = 1;
				default_panel_parameter.iCONFIG_DISPLAY_PORTAB_SWAP = 1;
				default_panel_parameter.iCONFIG_DISPLAY_RED_BLUE_SWAP = 0;
				default_panel_parameter.iCONFIG_DISPLAY_MSB_LSB_SWAP = 0;
				default_panel_parameter.iCONFIG_DISPLAY_SKEW_DATA_OUTPUT = 0;
				default_panel_parameter.iCONFIG_DISPLAY_OUTPUT_INVERSE = 0;
				default_panel_parameter.iCONFIG_DISPLAY_VERTICAL_SYNC_NORMAL = 1;
				default_panel_parameter.iCONFIG_DISPLAY_HORIZONTAL_SYNC_NORMAL = 1;
				default_panel_parameter.iCONFIG_DISPLAY_RATIO_4X3 = 0;
				default_panel_parameter.iCONFIG_DISPLAY_CLOCK_MAX = 63;
				default_panel_parameter.iCONFIG_DISPLAY_CLOCK_MIN = 47;
				default_panel_parameter.iCONFIG_DISPLAY_REFRESH_RATE = 60;
				default_panel_parameter.iCONFIG_DISPLAY_CLOCK_TYPICAL = 159408000;
				default_panel_parameter.iCONFIG_DISP_HORIZONTAL_TOTAL = 3280;
				default_panel_parameter.iCONFIG_DISP_VERTICAL_TOTAL = 811;
				default_panel_parameter.iCONFIG_DISP_HSYNC_WIDTH = 64;
				default_panel_parameter.iCONFIG_DISP_VSYNC_LENGTH = 3;
				default_panel_parameter.iCONFIG_DISP_DEN_STA_HPOS = 164;
				default_panel_parameter.iCONFIG_DISP_DEN_END_HPOS = 1530;
				default_panel_parameter.iCONFIG_DISP_DEN_STA_VPOS = 23;
				default_panel_parameter.iCONFIG_DISP_DEN_END_VPOS = 791;
				default_panel_parameter.iCONFIG_DISP_ACT_STA_HPOS = 0;
				default_panel_parameter.iCONFIG_DISP_ACT_END_HPOS = 1366;
				default_panel_parameter.iCONFIG_DISP_ACT_STA_VPOS = 0;
				default_panel_parameter.iCONFIG_DISP_ACT_END_VPOS = 768;
				default_panel_parameter.iCONFIG_DISP_HSYNC_LASTLINE = 4400;
				default_panel_parameter.iCONFIG_DISP_DCLK_DELAY = 0;
				default_panel_parameter._iCONFIG_DISP_ACT_STA_BIOS = 0;
				default_panel_parameter.iCONFIG_DEFAULT_DPLL_M_DIVIDER = 178;
				default_panel_parameter.iCONFIG_DEFAULT_DPLL_N_DIVIDER = 24;
				default_panel_parameter.iPANEL_TO_LVDS_ON_ms = 50;
				default_panel_parameter.iLVDS_TO_LIGHT_ON_ms = 500;
				default_panel_parameter.iLIGHT_TO_LDVS_OFF_ms = 200;
				default_panel_parameter.iLVDS_TO_PANEL_OFF_ms = 40;
				default_panel_parameter.iPANEL_OFF_TO_ON_ms = 1200;
				default_panel_parameter.iCONFIG_BACKLIGHT_PWM_FREQ = 116;
				default_panel_parameter.iCONFIG_BACKLIGHT_PWM_DUTY = 255;
				default_panel_parameter.iFIX_LAST_LINE_ENABLE = 0;
				default_panel_parameter.iFIX_LAST_LINE_4X_ENABLE = 0;
				default_panel_parameter.iVFLIP = 0;
				default_panel_parameter.iPICASSO_CONTROL_ON = 0;
				default_panel_parameter.i3D_DISPLAY_SUPPORT = 0;
				default_panel_parameter.i3D_LINE_ALTERNATIVE_SUPPORT = 0;
				default_panel_parameter.i3D_PR_OUTPUT_LR_SWAP = 0;
				default_panel_parameter.i3D_SG_OUTPUT_120HZ_ON = 0;
				default_panel_parameter.i3D_SG_24HZ_OUTPUT_FHD_ON = 0;
				default_panel_parameter.iSCALER_2D_3D_CVT_HWSHIFT_ENABLE = 0;
				default_panel_parameter.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MIN = 2647;
				default_panel_parameter.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MAX = 2812;
				default_panel_parameter.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN = 778;
				default_panel_parameter.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX = 1200;
				default_panel_parameter.iCONFIG_LVDS_4_PORTS_INDEX = 0;
				default_panel_parameter.iCONFIG_LVDS_PN_SWAP = 0;
				default_panel_parameter.iCONFIG_LVDS_MIRROR = 0;
				default_panel_parameter.iCONFIG_DISPLAY_PORT_CONFIG1 = 19088743;
				default_panel_parameter.iCONFIG_DISPLAY_PORT_CONFIG2 = 19088743;
				default_panel_parameter.iCONFIG_SR_MODE = 0;
				default_panel_parameter.iCONFIG_SR_PIXEL_MODE = 0;
				default_panel_parameter.iCONFIG_SFG_SEG_NUM = 1;
				default_panel_parameter.iCONFIG_SFG_PORT_NUM = 8;
				default_panel_parameter.iCONFIG_PANEL_TYPE = P_LVDS_2K1K;
				default_panel_parameter.iCONFIG_PANEL_CUSTOM_INDEX = 1;
				default_panel_parameter.i3D_DISPLAY_TIMING = 0;
				default_panel_parameter.iCONFIG_CUSTOMER_PANEL_ID = 13;
				default_panel_parameter.iCONFIG_DISP_RESVER05 = 0;
				default_panel_parameter.iCONFIG_DISP_RESVER06 = 0;
				default_panel_parameter.iPANEL_WIDTH_MM = 941;
				default_panel_parameter.iPANEL_HEIGHT_MM = 529;
				default_panel_parameter.iBACKLIGHT_PWM_48HZ_FREQ = 0;
				default_panel_parameter.iBACKLIGHT_PWM_50HZ_FREQ = 0;
				default_panel_parameter.iBACKLIGHT_PWM_60HZ_FREQ = 0;

				default_panel_parameter.iPixelClk60Hz = 159408000;
				default_panel_parameter.iHTotal60Hz = 3280;
				default_panel_parameter.iVTotal60Hz = 811;
				default_panel_parameter.iHSyncWidth_60Hz = 64;
				default_panel_parameter.iVSyncWidth_60Hz = 4;
				default_panel_parameter.iHFrontPorch_60Hz = 384;
				default_panel_parameter.iHbackPorch_60Hz = 100;
				default_panel_parameter.iVFrontPorch_60Hz = 20;
				default_panel_parameter.iVbackPorch_60Hz = 19;

				default_panel_parameter.iPixelClk50Hz = 159408000;
				default_panel_parameter.iHTotal50Hz = 3280;
				default_panel_parameter.iVTotal50Hz = 972;
				default_panel_parameter.iHSyncWidth_50Hz = 64;
				default_panel_parameter.iVSyncWidth_50Hz = 4;
				default_panel_parameter.iHFrontPorch_50Hz = 384;
				default_panel_parameter.iHbackPorch_50Hz = 100;
				default_panel_parameter.iVFrontPorch_50Hz = 181;
				default_panel_parameter.iVbackPorch_50Hz = 19;

				default_panel_parameter.iPixelClk48Hz = 159408000;
				default_panel_parameter.iHTotal48Hz = 3280;
				default_panel_parameter.iVTotal48Hz = 1013;
				default_panel_parameter.iHSyncWidth_48Hz = 64;
				default_panel_parameter.iVSyncWidth_48Hz = 4;
				default_panel_parameter.iHFrontPorch_48Hz = 384;
				default_panel_parameter.iHbackPorch_48Hz = 100;
				default_panel_parameter.iVFrontPorch_48Hz = 222;
				default_panel_parameter.iVbackPorch_48Hz = 19;

				strncpy(default_panel_parameter.sPanelName, "APA_32W", sizeof(default_panel_parameter.sPanelName));
			}
			else
			{
				printf("update APA43 default_panel_parameter \n");
				default_panel_parameter.snInfo.PanelIndex = 26;
				memcpy(default_panel_parameter.snInfo.PanelIDString ,"NS8S003CNO0101" ,sizeof(char)*14);
				default_panel_parameter.snInfo.InchSize = 43;
			
				default_panel_parameter.snInfo.Chassis_Index = 0;
				default_panel_parameter.snInfo.Panel_Width = 1920;
				default_panel_parameter.snInfo.Panel_Height = 1080;
				default_panel_parameter.snInfo.PixelClk60Hz = 148500000;
				default_panel_parameter.snInfo.HTotalMax = 2350;
				default_panel_parameter.snInfo.HTotal60Hz = 2200;
				default_panel_parameter.snInfo.HTotalMin = 2145;
				default_panel_parameter.snInfo.VTotalMax = 1480;
				default_panel_parameter.snInfo.VTotal60Hz = 1126;
				default_panel_parameter.snInfo.VTotalMin = 1100;
				default_panel_parameter.snInfo.VClkMax = 62;
				default_panel_parameter.snInfo.VClkMin = 47;
				default_panel_parameter.snInfo.HSyncWidth_60Hz = 32;
				default_panel_parameter.snInfo.VSyncWidth_60Hz = 4;
				default_panel_parameter.snInfo.HFrontPorch_60Hz = 32;
				default_panel_parameter.snInfo.HbackPorch_60Hz = 4;
				default_panel_parameter.snInfo.VFrontPorch_60Hz = 25;
				default_panel_parameter.snInfo.VbackPorch_60Hz = 16;
				default_panel_parameter.snInfo.HSyncPolarity = 1;
				default_panel_parameter.snInfo.VSyncPolarity = 1;
				default_panel_parameter.snInfo.PixelClk50Hz = 148500000;
				default_panel_parameter.snInfo.HTotal50Hz = 2200;
				default_panel_parameter.snInfo.VCOM_Pattern = 1;
				default_panel_parameter.snInfo.VCOM_Type = 3;	//6;
				default_panel_parameter.snInfo.Drive_strength = 7; //7;
				default_panel_parameter.snInfo.Pre_emphasis_On_Off= 1;
				default_panel_parameter.snInfo.Pre_emphasis_level = 7;
				default_panel_parameter.snInfo.Spread_spectrum_On_Off = 1;
				default_panel_parameter.snInfo.SpreadPermillage = 30;
				default_panel_parameter.snInfo.SpreadFreq = 45000;
				default_panel_parameter.snInfo.Video_I_F_format = 6;
				default_panel_parameter.snInfo.VTotal50Hz = 1350;
				default_panel_parameter.snInfo.HSyncWidth_50Hz = 32;
				default_panel_parameter.snInfo.VSyncWidth_50Hz = 4;
				default_panel_parameter.snInfo.HFrontPorch_50Hz = 32;
				default_panel_parameter.snInfo.HbackPorch_50Hz = 216;
				default_panel_parameter.snInfo.VFrontPorch_50Hz = 250;
				default_panel_parameter.snInfo.VbackPorch_50Hz = 16;
				default_panel_parameter.snInfo.Mura_CUC_ID = 5;
#ifdef CONFIG_TCON_LESS
				default_panel_parameter.snInfo.Tcon_Index = 0;
#else
				default_panel_parameter.snInfo.Reserved_15 = 0;
#endif
				default_panel_parameter.snInfo.CURRENT_MAX = 573;
				default_panel_parameter.snInfo.CURRENT_MIN = 172;
				default_panel_parameter.snInfo.BL_PWM_MAX = 1024;
				default_panel_parameter.snInfo.BL_PWM_MIN = 51;
				default_panel_parameter.snInfo.BL_CUR_FREQ = 77;
				default_panel_parameter.snInfo.BL_PWM_FREQ = 116;
				default_panel_parameter.snInfo.BL_WAIT_LOGO = 120;
				default_panel_parameter.snInfo.BL_PSL_DIFF = 0;
				default_panel_parameter.snInfo.PixelClk48Hz = 148500000;
				default_panel_parameter.snInfo.HTotal48Hz = 2200;
				default_panel_parameter.snInfo.VTotal48Hz= 1406;
				default_panel_parameter.snInfo.HSyncWidth_48Hz = 32;
				default_panel_parameter.snInfo.VSyncWidth_48Hz = 4;
				default_panel_parameter.snInfo.HFrontPorch_48Hz = 32;
				default_panel_parameter.snInfo.HbackPorch_48Hz = 216;
				default_panel_parameter.snInfo.VFrontPorch_48Hz = 306;
				default_panel_parameter.snInfo.VbackPorch_48Hz = 16;
				default_panel_parameter.snInfo.Reserved_16 = 0;
				default_panel_parameter.snInfo.Reserved_17 = 0;
				default_panel_parameter.snInfo.Reserved_18 = 0;
				default_panel_parameter.snInfo.Reserved_19 = 0;
				default_panel_parameter.snInfo.Reserved_20 = 0;
				default_panel_parameter.snInfo.Reserved_21 = 0;
				default_panel_parameter.snInfo.Reserved_22 = 0;
				default_panel_parameter.snInfo.Reserved_23 = 0;
				default_panel_parameter.snInfo.Reserved_24 = 0;
				default_panel_parameter.snInfo.Reserved_25 = 0;
				default_panel_parameter.snInfo.Reserved_26 = 0;
				default_panel_parameter.snInfo.Reserved_27 = 0;
				default_panel_parameter.snInfo.Reserved_28 = 0;
#if defined(Config_Vulcan3_PCB_TRUE)
				default_panel_parameter.snInfo.LVDS_Format = 2;
				default_panel_parameter.snInfo.LVDS_clock_level_even = 14;
				default_panel_parameter.snInfo.LVDS_clock_level_odd = 14;	//14;
#else
				default_panel_parameter.snInfo.Reserved_29 = 0;
				default_panel_parameter.snInfo.Reserved_30 = 0;
				default_panel_parameter.snInfo.LVDS_clock_level = 0;	//14;
#endif
				default_panel_parameter.snInfo.Mura_CUC_data_transfer = 0;		 //Reserved_32
				default_panel_parameter.snInfo._12V_WAIT = 0;
				default_panel_parameter.snInfo.EDID_WAIT = 4;
				default_panel_parameter.snInfo.VBO_WAIT = 2;
			
				// update default_panel_parameter
				default_panel_parameter.iCONFIG_DISPLAY_PORT = 1;
				default_panel_parameter.iCONFIG_DISPLAY_COLOR_BITS = 0;
				default_panel_parameter.iCONFIG_DISPLAY_EVEN_RSV1_BIT = 0;
				default_panel_parameter.iCONFIG_DISPLAY_ODD_RSV1_BIT = 0;
				default_panel_parameter.iCONFIG_DISPLAY_BITMAPPING_TABLE = 1;
				default_panel_parameter.iCONFIG_DISPLAY_PORTAB_SWAP = 1;
				default_panel_parameter.iCONFIG_DISPLAY_RED_BLUE_SWAP = 0;
				default_panel_parameter.iCONFIG_DISPLAY_MSB_LSB_SWAP = 0;
				default_panel_parameter.iCONFIG_DISPLAY_SKEW_DATA_OUTPUT = 0;
				default_panel_parameter.iCONFIG_DISPLAY_OUTPUT_INVERSE = 0;
				default_panel_parameter.iCONFIG_DISPLAY_VERTICAL_SYNC_NORMAL = 1;
				default_panel_parameter.iCONFIG_DISPLAY_HORIZONTAL_SYNC_NORMAL = 1;
				default_panel_parameter.iCONFIG_DISPLAY_RATIO_4X3 = 0;
				default_panel_parameter.iCONFIG_DISPLAY_CLOCK_MAX = 63;
				default_panel_parameter.iCONFIG_DISPLAY_CLOCK_MIN = 47;
				default_panel_parameter.iCONFIG_DISPLAY_REFRESH_RATE = 60;
				default_panel_parameter.iCONFIG_DISPLAY_CLOCK_TYPICAL = 148500000;
				default_panel_parameter.iCONFIG_DISP_HORIZONTAL_TOTAL = 2200;
				default_panel_parameter.iCONFIG_DISP_VERTICAL_TOTAL = 1126;
				default_panel_parameter.iCONFIG_DISP_HSYNC_WIDTH = 32;
				default_panel_parameter.iCONFIG_DISP_VSYNC_LENGTH = 3;
				default_panel_parameter.iCONFIG_DISP_DEN_STA_HPOS = 248;
				default_panel_parameter.iCONFIG_DISP_DEN_END_HPOS = 2168;
				default_panel_parameter.iCONFIG_DISP_DEN_STA_VPOS = 20;
				default_panel_parameter.iCONFIG_DISP_DEN_END_VPOS = 1100;
				default_panel_parameter.iCONFIG_DISP_ACT_STA_HPOS = 0;
				default_panel_parameter.iCONFIG_DISP_ACT_END_HPOS = 1920;
				default_panel_parameter.iCONFIG_DISP_ACT_STA_VPOS = 0;
				default_panel_parameter.iCONFIG_DISP_ACT_END_VPOS = 1080;
				default_panel_parameter.iCONFIG_DISP_HSYNC_LASTLINE = 4400;
				default_panel_parameter.iCONFIG_DISP_DCLK_DELAY = 0;
				default_panel_parameter._iCONFIG_DISP_ACT_STA_BIOS = 0;
				default_panel_parameter.iCONFIG_DEFAULT_DPLL_M_DIVIDER = 178;
				default_panel_parameter.iCONFIG_DEFAULT_DPLL_N_DIVIDER = 24;
				default_panel_parameter.iPANEL_TO_LVDS_ON_ms = 50;
				default_panel_parameter.iLVDS_TO_LIGHT_ON_ms = 500;
				default_panel_parameter.iLIGHT_TO_LDVS_OFF_ms = 200;
				default_panel_parameter.iLVDS_TO_PANEL_OFF_ms = 40;
				default_panel_parameter.iPANEL_OFF_TO_ON_ms = 1200;
				default_panel_parameter.iCONFIG_BACKLIGHT_PWM_FREQ = 116;
				default_panel_parameter.iCONFIG_BACKLIGHT_PWM_DUTY = 255;
				default_panel_parameter.iFIX_LAST_LINE_ENABLE = 0;
				default_panel_parameter.iFIX_LAST_LINE_4X_ENABLE = 0;
				default_panel_parameter.iVFLIP = 0;
				default_panel_parameter.iPICASSO_CONTROL_ON = 0;
				default_panel_parameter.i3D_DISPLAY_SUPPORT = 0;
				default_panel_parameter.i3D_LINE_ALTERNATIVE_SUPPORT = 0;
				default_panel_parameter.i3D_PR_OUTPUT_LR_SWAP = 0;
				default_panel_parameter.i3D_SG_OUTPUT_120HZ_ON = 0;
				default_panel_parameter.i3D_SG_24HZ_OUTPUT_FHD_ON = 0;
				default_panel_parameter.iSCALER_2D_3D_CVT_HWSHIFT_ENABLE = 0;
				default_panel_parameter.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MIN = 2647;
				default_panel_parameter.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MAX = 2812;
				default_panel_parameter.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN = 778;
				default_panel_parameter.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX = 1200;
				default_panel_parameter.iCONFIG_LVDS_4_PORTS_INDEX = 0;
				default_panel_parameter.iCONFIG_LVDS_PN_SWAP = 0;
				default_panel_parameter.iCONFIG_LVDS_MIRROR = 0;
				default_panel_parameter.iCONFIG_DISPLAY_PORT_CONFIG1 = 19088743;
				default_panel_parameter.iCONFIG_DISPLAY_PORT_CONFIG2 = 19088743;
				default_panel_parameter.iCONFIG_SR_MODE = 0;
				default_panel_parameter.iCONFIG_SR_PIXEL_MODE = 0;
				default_panel_parameter.iCONFIG_SFG_SEG_NUM = 1;
				default_panel_parameter.iCONFIG_SFG_PORT_NUM = 8;
				default_panel_parameter.iCONFIG_PANEL_TYPE = P_LVDS_2K1K;
				default_panel_parameter.iCONFIG_PANEL_CUSTOM_INDEX = 1;
				default_panel_parameter.i3D_DISPLAY_TIMING = 0;
				default_panel_parameter.iCONFIG_CUSTOMER_PANEL_ID = 13;
				default_panel_parameter.iCONFIG_DISP_RESVER05 = 0;
				default_panel_parameter.iCONFIG_DISP_RESVER06 = 0;
				default_panel_parameter.iPANEL_WIDTH_MM = 941;
				default_panel_parameter.iPANEL_HEIGHT_MM = 529;
				default_panel_parameter.iBACKLIGHT_PWM_48HZ_FREQ = 0;
				default_panel_parameter.iBACKLIGHT_PWM_50HZ_FREQ = 0;
				default_panel_parameter.iBACKLIGHT_PWM_60HZ_FREQ = 0;
			
				default_panel_parameter.iPixelClk60Hz = 148500000;
				default_panel_parameter.iHTotal60Hz = 2350;
				default_panel_parameter.iVTotal60Hz = 2200;
				default_panel_parameter.iHSyncWidth_60Hz = 32;
				default_panel_parameter.iVSyncWidth_60Hz = 4;
				default_panel_parameter.iHFrontPorch_60Hz = 32;
				default_panel_parameter.iHbackPorch_60Hz = 216;
				default_panel_parameter.iVFrontPorch_60Hz = 25;
				default_panel_parameter.iVbackPorch_60Hz = 16;
			
				default_panel_parameter.iPixelClk50Hz = 148500000;
				default_panel_parameter.iHTotal50Hz = 2200;
				default_panel_parameter.iVTotal50Hz = 1350;
				default_panel_parameter.iHSyncWidth_50Hz = 32;
				default_panel_parameter.iVSyncWidth_50Hz = 4;
				default_panel_parameter.iHFrontPorch_50Hz = 32;
				default_panel_parameter.iHbackPorch_50Hz = 216;
				default_panel_parameter.iVFrontPorch_50Hz = 250;
				default_panel_parameter.iVbackPorch_50Hz = 16;
			
				default_panel_parameter.iPixelClk48Hz = 148500000;
				default_panel_parameter.iHTotal48Hz = 2200;
				default_panel_parameter.iVTotal48Hz = 1406;
				default_panel_parameter.iHSyncWidth_48Hz = 32;
				default_panel_parameter.iVSyncWidth_48Hz = 4;
				default_panel_parameter.iHFrontPorch_48Hz = 32;
				default_panel_parameter.iHbackPorch_48Hz = 216;
				default_panel_parameter.iVFrontPorch_48Hz = 306;
				default_panel_parameter.iVbackPorch_48Hz = 16;
			
				strncpy(default_panel_parameter.sPanelName, "APA_43", sizeof(default_panel_parameter.sPanelName));
			}
		}
		printf("[trace code] boot_panel_type = %d\n", boot_panel_type);
	}
#endif
#if 0	// debug
	printf("[trace code] %s, %s, %d\n", __FILE__, __FUNCTION__, __LINE__);
	printf(" snInfo.PanelIndex=%d \n",default_panel_parameter.snInfo.PanelIndex);
	printf(" snInfo.PanelIDString=%s \n",default_panel_parameter.snInfo.PanelIDString);
	printf(" snInfo.InchSize=%d \n",default_panel_parameter.snInfo.InchSize);
	printf(" snInfo.Chassis_Index=%d \n",default_panel_parameter.snInfo.Chassis_Index);
	printf(" snInfo.Panel_Width=%d \n",default_panel_parameter.snInfo.Panel_Width);
	printf(" snInfo.Panel_Height=%d \n",default_panel_parameter.snInfo.Panel_Height);
	printf(" snInfo.PixelClk60Hz=%d \n",default_panel_parameter.snInfo.PixelClk60Hz);
	printf(" snInfo.HTotalMax=%d \n",default_panel_parameter.snInfo.HTotalMax);
	printf(" snInfo.HTotal60Hz=%d \n",default_panel_parameter.snInfo.HTotal60Hz);
	printf(" snInfo.HTotalMin=%d \n",default_panel_parameter.snInfo.HTotalMin);
	printf(" snInfo.VTotalMax=%d \n",default_panel_parameter.snInfo.VTotalMax);
	printf(" snInfo.VTotal60Hz=%d \n",default_panel_parameter.snInfo.VTotal60Hz);
	printf(" snInfo.VTotalMin=%d \n",default_panel_parameter.snInfo.VTotalMin);
	printf(" snInfo.VClkMax=%d \n",default_panel_parameter.snInfo.VClkMax);
	printf(" snInfo.VClkMin=%d \n",default_panel_parameter.snInfo.VClkMin);
	printf(" snInfo.HSyncWidth_60Hz=%d \n",default_panel_parameter.snInfo.HSyncWidth_60Hz);
	printf(" snInfo.VSyncWidth_60Hz=%d \n",default_panel_parameter.snInfo.VSyncWidth_60Hz);
	printf(" snInfo.HFrontPorch_60Hz=%d \n",default_panel_parameter.snInfo.HFrontPorch_60Hz);
	printf(" snInfo.HbackPorch_60Hz=%d \n",default_panel_parameter.snInfo.HbackPorch_60Hz);
	printf(" snInfo.VFrontPorch_60Hz=%d \n",default_panel_parameter.snInfo.VFrontPorch_60Hz);
	printf(" snInfo.VbackPorch_60Hz=%d \n",default_panel_parameter.snInfo.VbackPorch_60Hz);
	printf(" snInfo.HSyncPolarity=%d \n",default_panel_parameter.snInfo.HSyncPolarity);
	printf(" snInfo.VSyncPolarity=%d \n",default_panel_parameter.snInfo.VSyncPolarity);
	printf(" snInfo.PixelClk50Hz=%d \n",default_panel_parameter.snInfo.PixelClk50Hz);
	printf(" snInfo.HTotal50Hz=%d \n",default_panel_parameter.snInfo.HTotal50Hz);
	printf(" snInfo.VCOM_Pattern=%d \n",default_panel_parameter.snInfo.VCOM_Pattern);
	printf(" snInfo.VCOM_Type=%d \n",default_panel_parameter.snInfo.VCOM_Type);
	printf(" snInfo.Drive_strength=%d \n",default_panel_parameter.snInfo.Drive_strength);
	printf(" snInfo.Pre_emphasis_On_Off=%d \n",default_panel_parameter.snInfo.Pre_emphasis_On_Off);
	printf(" snInfo.Pre_emphasis_level=%d \n",default_panel_parameter.snInfo.Pre_emphasis_level);
	printf(" snInfo.Spread_spectrum_On_Off=%d \n",default_panel_parameter.snInfo.Spread_spectrum_On_Off);
	printf(" snInfo.SpreadPermillage=%d \n",default_panel_parameter.snInfo.SpreadPermillage);
	printf(" snInfo.SpreadFreq=%d \n",default_panel_parameter.snInfo.SpreadFreq);
	printf(" snInfo.Video_I_F_format=%d \n",default_panel_parameter.snInfo.Video_I_F_format);
	printf(" snInfo.VTotal50Hz=%d \n",default_panel_parameter.snInfo.VTotal50Hz);
	printf(" snInfo.HSyncWidth_50Hz=%d \n",default_panel_parameter.snInfo.HSyncWidth_50Hz);
	printf(" snInfo.VSyncWidth_50Hz=%d \n",default_panel_parameter.snInfo.VSyncWidth_50Hz);
	printf(" snInfo.HFrontPorch_50Hz=%d \n",default_panel_parameter.snInfo.HFrontPorch_50Hz);
	printf(" snInfo.HbackPorch_50Hz=%d \n",default_panel_parameter.snInfo.HbackPorch_50Hz);
	printf(" snInfo.VFrontPorch_50Hz=%d \n",default_panel_parameter.snInfo.VFrontPorch_50Hz);
	printf(" snInfo.VbackPorch_50Hz=%d \n",default_panel_parameter.snInfo.VbackPorch_50Hz);
	printf(" snInfo.Mura_CUC_ID=%d \n",default_panel_parameter.snInfo.Mura_CUC_ID);
	printf(" snInfo.Reserved_15=%d \n",default_panel_parameter.snInfo.Reserved_15);
	printf(" snInfo.CURRENT_MAX=%d \n",default_panel_parameter.snInfo.CURRENT_MAX);
	printf(" snInfo.CURRENT_MIN=%d \n",default_panel_parameter.snInfo.CURRENT_MIN);
	printf(" snInfo.BL_PWM_MAX=%d \n",default_panel_parameter.snInfo.BL_PWM_MAX);
	printf(" snInfo.BL_PWM_MIN=%d \n",default_panel_parameter.snInfo.BL_PWM_MIN);
	printf(" snInfo.BL_CUR_FREQ=%d \n",default_panel_parameter.snInfo.BL_CUR_FREQ);
	printf(" snInfo.BL_PWM_FREQ=%d \n",default_panel_parameter.snInfo.BL_PWM_FREQ);
	printf(" snInfo.BL_WAIT_LOGO=%d \n",default_panel_parameter.snInfo.BL_WAIT_LOGO);
	printf(" snInfo.BL_PSL_DIFF=%d \n",default_panel_parameter.snInfo.BL_PSL_DIFF);
	printf(" snInfo.PixelClk48Hz=%d \n",default_panel_parameter.snInfo.PixelClk48Hz);
	printf(" snInfo.HTotal48Hz=%d \n",default_panel_parameter.snInfo.HTotal48Hz);
	printf(" snInfo.VTotal48Hz=%d \n",default_panel_parameter.snInfo.VTotal48Hz);
	printf(" snInfo.HSyncWidth_48Hz=%d \n",default_panel_parameter.snInfo.HSyncWidth_48Hz);
	printf(" snInfo.VSyncWidth_48Hz=%d \n",default_panel_parameter.snInfo.VSyncWidth_48Hz);
	printf(" snInfo.HFrontPorch_48Hz=%d \n",default_panel_parameter.snInfo.HFrontPorch_48Hz);
	printf(" snInfo.HbackPorch_48Hz=%d \n",default_panel_parameter.snInfo.HbackPorch_48Hz);
	printf(" snInfo.VFrontPorch_48Hz=%d \n",default_panel_parameter.snInfo.VFrontPorch_48Hz);
	printf(" snInfo.VbackPorch_48Hz=%d \n",default_panel_parameter.snInfo.VbackPorch_48Hz);

	printf(" snInfo.LVDS_clock_level=%d \n",default_panel_parameter.snInfo.LVDS_clock_level);
	printf(" snInfo.Mura_CUC_data_transfer=%d \n",default_panel_parameter.snInfo.Mura_CUC_data_transfer);
	printf(" snInfo._12V_WAIT=%d \n",default_panel_parameter.snInfo._12V_WAIT);
	printf(" snInfo.EDID_WAIT=%d \n",default_panel_parameter.snInfo.EDID_WAIT);
	printf(" snInfo.VBO_WAIT=%d \n",default_panel_parameter.snInfo.VBO_WAIT);

#endif

#if 0	// debug
	printf("[trace code] %s, %s, %d\n", __FILE__, __FUNCTION__, __LINE__);
	printf(" iCONFIG_DISPLAY_PORT=%d \n",default_panel_parameter.iCONFIG_DISPLAY_PORT);
	printf(" iCONFIG_DISPLAY_COLOR_BITS=%d \n",default_panel_parameter.iCONFIG_DISPLAY_COLOR_BITS);
	printf(" iCONFIG_DISPLAY_EVEN_RSV1_BIT=%d \n",default_panel_parameter.iCONFIG_DISPLAY_EVEN_RSV1_BIT);
	printf(" iCONFIG_DISPLAY_ODD_RSV1_BIT=%d \n",default_panel_parameter.iCONFIG_DISPLAY_ODD_RSV1_BIT);
	printf(" iCONFIG_DISPLAY_BITMAPPING_TABLE=%d \n",default_panel_parameter.iCONFIG_DISPLAY_BITMAPPING_TABLE);
	printf(" iCONFIG_DISPLAY_PORTAB_SWAP=%d \n",default_panel_parameter.iCONFIG_DISPLAY_PORTAB_SWAP);
	printf(" iCONFIG_DISPLAY_RED_BLUE_SWAP=%d \n",default_panel_parameter.iCONFIG_DISPLAY_RED_BLUE_SWAP);
	printf(" iCONFIG_DISPLAY_MSB_LSB_SWAP=%d \n",default_panel_parameter.iCONFIG_DISPLAY_MSB_LSB_SWAP);
	printf(" iCONFIG_DISPLAY_SKEW_DATA_OUTPUT=%d \n",default_panel_parameter.iCONFIG_DISPLAY_SKEW_DATA_OUTPUT);
	printf(" iCONFIG_DISPLAY_OUTPUT_INVERSE=%d \n",default_panel_parameter.iCONFIG_DISPLAY_OUTPUT_INVERSE);
	printf(" iCONFIG_DISPLAY_VERTICAL_SYNC_NORMAL=%d \n",default_panel_parameter.iCONFIG_DISPLAY_VERTICAL_SYNC_NORMAL);
	printf(" iCONFIG_DISPLAY_HORIZONTAL_SYNC_NORMAL=%d \n",default_panel_parameter.iCONFIG_DISPLAY_HORIZONTAL_SYNC_NORMAL);
	printf(" iCONFIG_DISPLAY_RATIO_4X3=%d \n",default_panel_parameter.iCONFIG_DISPLAY_RATIO_4X3);
	printf(" iCONFIG_DISPLAY_CLOCK_MAX=%d \n",default_panel_parameter.iCONFIG_DISPLAY_CLOCK_MAX);
	printf(" iCONFIG_DISPLAY_CLOCK_MIN=%d \n",default_panel_parameter.iCONFIG_DISPLAY_CLOCK_MIN);
	printf(" iCONFIG_DISPLAY_REFRESH_RATE=%d \n",default_panel_parameter.iCONFIG_DISPLAY_REFRESH_RATE);
	printf(" iCONFIG_DISPLAY_CLOCK_TYPICAL=%d \n",default_panel_parameter.iCONFIG_DISPLAY_CLOCK_TYPICAL);
	printf(" iCONFIG_DISP_HORIZONTAL_TOTAL=%d \n",default_panel_parameter.iCONFIG_DISP_HORIZONTAL_TOTAL);
	printf(" iCONFIG_DISP_VERTICAL_TOTAL=%d \n",default_panel_parameter.iCONFIG_DISP_VERTICAL_TOTAL);
	printf(" iCONFIG_DISP_HSYNC_WIDTH=%d \n",default_panel_parameter.iCONFIG_DISP_HSYNC_WIDTH);
	printf(" iCONFIG_DISP_VSYNC_LENGTH=%d \n",default_panel_parameter.iCONFIG_DISP_VSYNC_LENGTH);
	printf(" iCONFIG_DISP_DEN_STA_HPOS=%d \n",default_panel_parameter.iCONFIG_DISP_DEN_STA_HPOS);
	printf(" iCONFIG_DISP_DEN_END_HPOS=%d \n",default_panel_parameter.iCONFIG_DISP_DEN_END_HPOS);
	printf(" iCONFIG_DISP_DEN_STA_VPOS=%d \n",default_panel_parameter.iCONFIG_DISP_DEN_STA_VPOS);
	printf(" iCONFIG_DISP_DEN_END_VPOS=%d \n",default_panel_parameter.iCONFIG_DISP_DEN_END_VPOS);
	printf(" iCONFIG_DISP_ACT_STA_HPOS=%d \n",default_panel_parameter.iCONFIG_DISP_ACT_STA_HPOS);
	printf(" iCONFIG_DISP_ACT_END_HPOS=%d \n",default_panel_parameter.iCONFIG_DISP_ACT_END_HPOS);
	printf(" iCONFIG_DISP_ACT_STA_VPOS=%d \n",default_panel_parameter.iCONFIG_DISP_ACT_STA_VPOS);
	printf(" iCONFIG_DISP_ACT_END_VPOS=%d \n",default_panel_parameter.iCONFIG_DISP_ACT_END_VPOS);
	printf(" iCONFIG_DISP_HSYNC_LASTLINE=%d \n",default_panel_parameter.iCONFIG_DISP_HSYNC_LASTLINE);
	printf(" iCONFIG_DISP_DCLK_DELAY=%d \n",default_panel_parameter.iCONFIG_DISP_DCLK_DELAY);
	printf(" _iCONFIG_DISP_ACT_STA_BIOS=%d \n",default_panel_parameter._iCONFIG_DISP_ACT_STA_BIOS);
	printf(" iCONFIG_DEFAULT_DPLL_M_DIVIDER=%d \n",default_panel_parameter.iCONFIG_DEFAULT_DPLL_M_DIVIDER);
	printf(" iCONFIG_DEFAULT_DPLL_N_DIVIDER=%d \n",default_panel_parameter.iCONFIG_DEFAULT_DPLL_N_DIVIDER);
	printf(" iPANEL_TO_LVDS_ON_ms=%d \n",default_panel_parameter.iPANEL_TO_LVDS_ON_ms);
	printf(" iLVDS_TO_LIGHT_ON_ms=%d \n",default_panel_parameter.iLVDS_TO_LIGHT_ON_ms);
	printf(" iLIGHT_TO_LDVS_OFF_ms=%d \n",default_panel_parameter.iLIGHT_TO_LDVS_OFF_ms);
	printf(" iLVDS_TO_PANEL_OFF_ms=%d \n",default_panel_parameter.iLVDS_TO_PANEL_OFF_ms);
	printf(" iPANEL_OFF_TO_ON_ms=%d \n",default_panel_parameter.iPANEL_OFF_TO_ON_ms);
	printf(" iCONFIG_BACKLIGHT_PWM_FREQ=%d \n",default_panel_parameter.iCONFIG_BACKLIGHT_PWM_FREQ);
	printf(" iCONFIG_BACKLIGHT_PWM_DUTY=%d \n",default_panel_parameter.iCONFIG_BACKLIGHT_PWM_DUTY);
	printf(" iFIX_LAST_LINE_ENABLE=%d \n",default_panel_parameter.iFIX_LAST_LINE_ENABLE);
	printf(" iFIX_LAST_LINE_4X_ENABLE=%d \n",default_panel_parameter.iFIX_LAST_LINE_4X_ENABLE);
	printf(" iVFLIP=%d \n",default_panel_parameter.iVFLIP);
	printf(" iPICASSO_CONTROL_ON=%d \n",default_panel_parameter.iPICASSO_CONTROL_ON);
	printf(" i3D_DISPLAY_SUPPORT=%d \n",default_panel_parameter.i3D_DISPLAY_SUPPORT);
	printf(" i3D_LINE_ALTERNATIVE_SUPPORT=%d \n",default_panel_parameter.i3D_LINE_ALTERNATIVE_SUPPORT);
	printf(" i3D_PR_OUTPUT_LR_SWAP=%d \n",default_panel_parameter.i3D_PR_OUTPUT_LR_SWAP);
	printf(" i3D_SG_OUTPUT_120HZ_ON=%d \n",default_panel_parameter.i3D_SG_OUTPUT_120HZ_ON);
	printf(" i3D_SG_24HZ_OUTPUT_FHD_ON=%d \n",default_panel_parameter.i3D_SG_24HZ_OUTPUT_FHD_ON);
	printf(" iSCALER_2D_3D_CVT_HWSHIFT_ENABLE=%d \n",default_panel_parameter.iSCALER_2D_3D_CVT_HWSHIFT_ENABLE);
	printf(" iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MIN=%d \n",default_panel_parameter.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MIN);
	printf(" iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MAX=%d \n",default_panel_parameter.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MAX);
	printf(" iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN=%d \n",default_panel_parameter.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN);
	printf(" iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX=%d \n",default_panel_parameter.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX);
	printf(" iCONFIG_LVDS_4_PORTS_INDEX=%d \n",default_panel_parameter.iCONFIG_LVDS_4_PORTS_INDEX);
	printf(" iCONFIG_LVDS_PN_SWAP=%d \n",default_panel_parameter.iCONFIG_LVDS_PN_SWAP);
	printf(" iCONFIG_LVDS_MIRROR=%d \n",default_panel_parameter.iCONFIG_LVDS_MIRROR);
	printf(" iCONFIG_DISPLAY_PORT_CONFIG1=%d \n",default_panel_parameter.iCONFIG_DISPLAY_PORT_CONFIG1);
	printf(" iCONFIG_DISPLAY_PORT_CONFIG2=%d \n",default_panel_parameter.iCONFIG_DISPLAY_PORT_CONFIG2);
	printf(" iCONFIG_SR_MODE=%d \n",default_panel_parameter.iCONFIG_SR_MODE);
	printf(" iCONFIG_SR_PIXEL_MODE=%d \n",default_panel_parameter.iCONFIG_SR_PIXEL_MODE);
	printf(" iCONFIG_SFG_SEG_NUM=%d \n",default_panel_parameter.iCONFIG_SFG_SEG_NUM);
	printf(" iCONFIG_SFG_PORT_NUM=%d \n",default_panel_parameter.iCONFIG_SFG_PORT_NUM);
	printf(" iCONFIG_PANEL_TYPE=%d \n",default_panel_parameter.iCONFIG_PANEL_TYPE);
	printf(" iCONFIG_PANEL_CUSTOM_INDEX=%d \n",default_panel_parameter.iCONFIG_PANEL_CUSTOM_INDEX);
	printf(" i3D_DISPLAY_TIMING=%d \n",default_panel_parameter.i3D_DISPLAY_TIMING);
	printf(" iCONFIG_CUSTOMER_PANEL_ID=%d \n",default_panel_parameter.iCONFIG_CUSTOMER_PANEL_ID);
	printf(" iCONFIG_DISP_RESVER05=%d \n",default_panel_parameter.iCONFIG_DISP_RESVER05);
	printf(" iCONFIG_DISP_RESVER06=%d \n",default_panel_parameter.iCONFIG_DISP_RESVER06);
	printf(" iPANEL_WIDTH_MM=%d \n",default_panel_parameter.iPANEL_WIDTH_MM);
	printf(" iPANEL_HEIGHT_MM=%d \n",default_panel_parameter.iPANEL_HEIGHT_MM);
	printf(" iBACKLIGHT_PWM_48HZ_FREQ=%d \n",default_panel_parameter.iBACKLIGHT_PWM_48HZ_FREQ);
	printf(" iBACKLIGHT_PWM_50HZ_FREQ=%d \n",default_panel_parameter.iBACKLIGHT_PWM_50HZ_FREQ);
	printf(" iBACKLIGHT_PWM_60HZ_FREQ=%d \n",default_panel_parameter.iBACKLIGHT_PWM_60HZ_FREQ);
#ifdef CONFIG_CUSTOM_SN_PANEL
	printf(" iPixelClk60Hz=%d \n",default_panel_parameter.iPixelClk60Hz);
	printf(" iHTotal60Hz=%d \n",default_panel_parameter.iHTotal60Hz);
	printf(" iVTotal60Hz=%d \n",default_panel_parameter.iVTotal60Hz);
	printf(" iHSyncWidth_60Hz=%d \n",default_panel_parameter.iHSyncWidth_60Hz);
	printf(" iVSyncWidth_60Hz=%d \n",default_panel_parameter.iVSyncWidth_60Hz);
	printf(" iHFrontPorch_60Hz=%d \n",default_panel_parameter.iHFrontPorch_60Hz);
	printf(" iHbackPorch_60Hz=%d \n",default_panel_parameter.iHbackPorch_60Hz);
	printf(" iVFrontPorch_60Hz=%d \n",default_panel_parameter.iVFrontPorch_60Hz);
	printf(" iVbackPorch_60Hz=%d \n",default_panel_parameter.iVbackPorch_60Hz);

	printf(" iPixelClk50Hz=%d \n",default_panel_parameter.iPixelClk50Hz);
	printf(" iHTotal50Hz=%d \n",default_panel_parameter.iHTotal50Hz);
	printf(" iVTotal50Hz=%d \n",default_panel_parameter.iVTotal50Hz);
	printf(" iHSyncWidth_50Hz=%d \n",default_panel_parameter.iHSyncWidth_50Hz);
	printf(" iVSyncWidth_50Hz=%d \n",default_panel_parameter.iVSyncWidth_50Hz);
	printf(" iHFrontPorch_50Hz=%d \n",default_panel_parameter.iHFrontPorch_50Hz);
	printf(" iHbackPorch_50Hz=%d \n",default_panel_parameter.iHbackPorch_50Hz);
	printf(" iVFrontPorch_50Hz=%d \n",default_panel_parameter.iVFrontPorch_50Hz);
	printf(" iVbackPorch_50Hz=%d \n",default_panel_parameter.iVbackPorch_50Hz);

	printf(" iPixelClk48Hz=%d \n",default_panel_parameter.iPixelClk48Hz);
	printf(" iHTotal48Hz=%d \n",default_panel_parameter.iHTotal48Hz);
	printf(" iVTotal48Hz=%d \n",default_panel_parameter.iVTotal48Hz);
	printf(" iHSyncWidth_48Hz=%d \n",default_panel_parameter.iHSyncWidth_48Hz);
	printf(" iVSyncWidth_48Hz=%d \n",default_panel_parameter.iVSyncWidth_48Hz);
	printf(" iHFrontPorch_48Hz=%d \n",default_panel_parameter.iHFrontPorch_48Hz);
	printf(" iHbackPorch_48Hz=%d \n",default_panel_parameter.iHbackPorch_48Hz);
	printf(" iVFrontPorch_48Hz=%d \n",default_panel_parameter.iVFrontPorch_48Hz);
	printf(" iVbackPorch_48Hz=%d \n",default_panel_parameter.iVbackPorch_48Hz);
#endif
	printf(" sPanelName=%s \n",default_panel_parameter.sPanelName);
#endif
	// set Panel Display Timing Gen
	setPanelDataSetting(&default_panel_parameter);

	panel_i2c_init();

#ifdef CONFIG_PANEL_SHARP_60_MEMC
	//panel_sharp_memc_init(1);
#endif //#ifdef CONFIG_PANEL_SHARP_60_MEMC

	panel_customized_setting();

#ifndef CONFIG_SYS_PANEL_DISABLE_PATTERN_GEN
	panel_dpg_enable();
#endif

	#if defined(LVDS_PN_SWAP)
	rtd_maskl(0xb802d000, 0xfffffbff, 0x00000000);  //LVDS PN Swap disable bit10=0
	printf("Do LVDS PN Swap\n");
	#endif //#if defined(LVDS_PN_SWAP)

	#if 1	//yuan
	GetOutputGamma_BinFileParameters();
	GetVALC_BinFileParameters();
	GetMemaddr_demur_od();
	GetDemura_BinFileParameters();
	GetOD_BinFileParameters();
	#endif

	//dump_register();
}

void pwm_pinshare_power_enable(void)
{
	//clken:1
	//rtd_part_outl(0xb800000c,0,0,1);//clken_misc[0]
	//rtd_part_outl(0xb800000c,6,6,1);//clk_en_iso_misc[6]
//		rtd_part_outl(0xb8000010,25,25,1);//clken_pwm[25]:1
//		rtd_part_outl(0xb8000014,12,12,1);//clken_padmux[12]
//		rtd_part_outl(0xb8000014,29,29,1);//clken_tvsb3[29]//mantis:55208
	rtd_maskl(0xb8000010, (~_BIT25), _BIT25);
	rtd_maskl(0xb8000014, (~_BIT12), _BIT12);
	rtd_maskl(0xb8000014, (~_BIT29), _BIT29);
	//rtd_part_outl(0xb8060040,3,3,1);//clken_iso_pwm[3]:1
	//rtd_part_outl(0xb8060040,2,2,1);//clken_iso_padmux[2]
	////rtd_part_outl(0xb8060040,1,1,1);//clken_iso_misc_off[1]
	//rtd_part_outl(0xb8060040,0,0,1);//clken_iso_misc[0]

	//clken:0
	//rtd_part_outl(0xb800000c,0,0,0);//clken_misc[0]
	//rtd_part_outl(0xb800000c,6,6,0);//clk_en_iso_misc[6]
//		rtd_part_outl(0xb8000010,25,25,0);//clken_pwm[25]:1
//		rtd_part_outl(0xb8000014,12,12,0);//clken_padmux[12]
//		rtd_part_outl(0xb8000014,29,29,0);//clken_tvsb3[29]//mantis:55208
	rtd_maskl(0xb8000010, (~_BIT25), 0);
	rtd_maskl(0xb8000014, (~_BIT12), 0);
	rtd_maskl(0xb8000014, (~_BIT29), 0);
	//rtd_part_outl(0xb8060040,3,3,0);//clken_iso_pwm[3]:1
	//rtd_part_outl(0xb8060040,2,2,0);//clken_iso_padmux[2]
	////rtd_part_outl(0xb8060040,1,1,0);//clken_iso_misc_off[1]
	//rtd_part_outl(0xb8060040,0,0,0);//clken_iso_misc[0]

	//RSTN:0
	//rtd_part_outl(0xb8000000,0,0,0); //rstn_misc[0]
//		rtd_part_outl(0xb8000008,14,14,0); //rstn_tvsb3[14]
	rtd_maskl(0xb8000008, (~_BIT14), 0);
	//mdelay(10);
	//rtd_part_outl(0xb8060030,3,3,0); //rstn_iso_pwm[3]
	////rtd_part_outl(0xb8060030,2,2,0);//rstn_iso_padmux[2]
	////rtd_part_outl(0xb8060030,1,1,0);//iso_misc_off[1]
	//rtd_part_outl(0xb8060030,0,0,0);//rstn_iso_misc[0]
	//!!halt!! rtd_part_outl(0xb8000004,13,13,0);//rstn_padmux[13]
	//!!halt!! rtd_part_outl(0xb8000004,7,7,0);//rstn_pwm[7]

	//RSTN:1
	//rtd_part_outl(0xb8000000,0,0,1); //rstn_misc[0]
//		rtd_part_outl(0xb8000008,14,14,1); //rstn_tvsb3[14]
	rtd_maskl(0xb8000008, (~_BIT14), _BIT14);
	//rtd_part_outl(0xb8060030,3,3,1); //rstn_iso_pwm[3]
	////rtd_part_outl(0xb8060030,2,2,1);//rstn_iso_padmux[2]
	////rtd_part_outl(0xb8060030,1,1,1);//iso_misc_off[1]
	//rtd_part_outl(0xb8060030,0,0,1);//rstn_iso_misc[0]
//		rtd_part_outl(0xb8000004,13,13,1);//rstn_padmux[13]
//		rtd_part_outl(0xb8000004,7,7,1);//rstn_pwm[7]
	rtd_maskl(0xb8000004, (~_BIT13), _BIT13);
	rtd_maskl(0xb8000004, (~_BIT7), _BIT7);

	//clken:1
	//rtd_part_outl(0xb800000c,0,0,1);//clken_misc[0]
	//rtd_part_outl(0xb800000c,6,6,1);//clk_en_iso_misc[6]
//		rtd_part_outl(0xb8000010,25,25,1);//clken_pwm[25]:1
//		rtd_part_outl(0xb8000014,12,12,1);//clken_padmux[12]
//		rtd_part_outl(0xb8000014,29,29,1);//clken_tvsb3[29]//mantis:55208
	rtd_maskl(0xb8000010, (~_BIT25), _BIT25);
	rtd_maskl(0xb8000014, (~_BIT12), _BIT12);
	rtd_maskl(0xb8000014, (~_BIT29), _BIT29);
	//rtd_part_outl(0xb8060040,3,3,1);//clken_iso_pwm[3]:1
	//rtd_part_outl(0xb8060040,2,2,1);//clken_iso_padmux[2]
	////rtd_part_outl(0xb8060040,1,1,1);//clken_iso_misc_off[1]
	//rtd_part_outl(0xb8060040,0,0,1);//clken_iso_misc[0]

	//pin share
	//!!!no need!!! rtd_part_outl(0xb80008b8,31,27,d);//pin share "0x0D"
//		rtd_part_outl(0xb8000c2c,31,29,2);//pin share "0x2"

	if((default_panel_parameter.iCONFIG_PANEL_TYPE != P_VBY1_4K2K) &&
		(default_panel_parameter.iCONFIG_PANEL_TYPE != P_VBY1_2K1K) &&
		(default_panel_parameter.iCONFIG_PANEL_TYPE != P_VBY1_TO_HDMI) &&
		(default_panel_parameter.iCONFIG_PANEL_TYPE != P_EPI_TYPE))
	{
		rtd_maskl(0xb8000c2c, (~(_BIT31|_BIT30|_BIT29)), _BIT30);
		rtd_outl(0xb8000c78,0xffff0000);//pin share "0xffff0000"
	}
}

void panel_current_adjust(void)
{			//panel			 id		frequence
//	int valuefre=0;
//	int valuefre1=0;
#ifdef PANEL_CONFIG_FROM_FACTORY_PANEL_BIN
#ifdef PIN_I_PWM
	int IPWM_Freq=0;
	int IPWM_Duty=0;

	IPWM_Freq=(&default_panel_parameter)->iCONFIG_IPWMFeq;
	IPWM_Duty=(&default_panel_parameter)->iCONFIG_IPWMDuty;

	printf("panel current IPWM_Freq = 0x%x,IPWM_Duty = 0x%x,sizeof(PANEL_CONFIG_PARAMETER)=%d\n",IPWM_Freq,IPWM_Duty,sizeof(PANEL_CONFIG_PARAMETER));
	printf("iCONFIG_VPWMFeq=%d,iCONFIG_VPWMDuty=%d",(&default_panel_parameter)->iCONFIG_VPWMFeq,(&default_panel_parameter)->iCONFIG_VPWMDuty);

	IO_PWM_SetFreq(PIN_I_PWM, IPWM_Freq*1000);	//set Freq 15k
	IO_PWM_SetDuty(PIN_I_PWM, IPWM_Duty);

	IO_PWM_SetFreq(PIN_V_PWM,(&default_panel_parameter)->iCONFIG_VPWMFeq * 1000);	//set freq 15K
	IO_PWM_SetDuty(PIN_V_PWM,(&default_panel_parameter)->iCONFIG_VPWMDuty); //pwm_set
#endif
#else
#ifdef PIN_PANEL_CURRENT_ADJ
	int valueduty=0;
	int valueduty1=0;

	printf("panel current value = 0x%x\n",(&default_panel_parameter)->iCONFIG_DISP_RESVER05);
	valueduty=((&default_panel_parameter)->iCONFIG_DISP_RESVER05)>>8;
	valueduty1=((&default_panel_parameter)->iCONFIG_DISP_RESVER05) & 0xFF;
	IO_PWM_SetFreq(PIN_PANEL_CURRENT_ADJ,15000);	//set Freq 15k
	IO_PWM_SetDuty(PIN_PANEL_CURRENT_ADJ, valueduty);
	IO_PWM_SetFreq(PIN_PANEL_CURRENT_ADJ1,15000);	//set freq 15K
	IO_PWM_SetDuty(PIN_PANEL_CURRENT_ADJ1,valueduty1); //pwm_set
#endif
#endif
}

void panel_set_spread_spectrum(UINT8  bEnable, UINT16 u16Percent, UINT32 ss_freq)
{
	//UINT16 dclk_ss_reg_table[16]={0, 5, 10, 15, 20, 25, 30, 35, 40, 45, 50, 55, 60, 65, 70, 75};
	UINT16 dclk_sscg_range = 0;
	//UINT8 tableidx = 0;
	pll27x_reg_sys_dclkss_RBUS dclkss_reg;
	pll27x_reg_sys_pll_disp1_RBUS pll_disp1_reg;
	pll27x_reg_pll_ssc0_RBUS pll_ssc0_reg;
	pll27x_reg_pll_ssc3_RBUS pll_ssc3_reg;
	pll27x_reg_pll_ssc4_RBUS pll_ssc4_reg;
	pll27x_reg_pll_ssc5_RBUS pll_ssc5_reg;
	pll27x_reg_sys_pll_disp3_RBUS pll27x_reg_sys_pll_disp3_reg;
	UINT32 m_code, f_code, n_code, n_code_ssc, f_code_ssc;
	UINT32 temp, temp_ssc/*, tmp_val*/;
	UINT32 dot_gran=4, gran_est;
	UINT32 dpll_clk, dpll_clk_ssc, ssc_clk, step;
//	UINT32 ss_freq = 30*1000; //30K
//	unsigned long long gran_est_temp=0;
	UINT32 cnt=0;
//	unsigned char panel_type=0;
	UINT32 dclk_Temp;
	UINT32 ulFreq=0;
	UINT32 div=0;
/*
	if(bEnable == 0 || u16Percent ==0)
		tableidx = 0;
	else{
		if(u16Percent % 5 ==0)
			tableidx = ( u16Percent / 5 ) ;
		else
			tableidx = ( u16Percent / 5 )+1 ;
	}

	printf("\n dclk_ss_reg_table[%d] = %d \n", tableidx, dclk_ss_reg_table[tableidx]);
	dclk_sscg_range = dclk_ss_reg_table[tableidx];
*/
	dclk_sscg_range = u16Percent;

	printf("\n dclk_sscg_range = %d \n", dclk_sscg_range);

	ulFreq = default_panel_parameter.iCONFIG_DISPLAY_CLOCK_TYPICAL;

	if((ulFreq>=400*1000000) && (ulFreq <= 700*1000000)){
		div = 1;
	}else if((ulFreq>=200*1000000) && (ulFreq <= 350*1000000)){
		div = 2;
		ulFreq = ulFreq*2;
	}else if((ulFreq>=100*1000000) && (ulFreq <= 175*1000000)){
		div = 4;
		ulFreq = ulFreq*4;
	}else if((ulFreq>=60*1000000) && (ulFreq <= 80*1000000)){
		div = 8;
		ulFreq = ulFreq*8;
	}else{
		printf("\n Error Dclk Range!\n");
	}
	n_code = 1;
	dclk_Temp = ((ulFreq*(n_code+2)) /(27*100));
	//printf("dclk_Temp:%d\n", dclk_Temp);
	m_code = (dclk_Temp/10000)-3;
	f_code = ((dclk_Temp % 10000)*2048)/10000;	// offset
	pll_disp1_reg.regValue = rtd_inl(PLL27X_REG_SYS_PLL_DISP1_reg);
	pll_ssc0_reg.regValue = rtd_inl(PLL27X_REG_PLL_SSC0_reg);
	pll_ssc3_reg.regValue = rtd_inl(PLL27X_REG_PLL_SSC3_reg);
	pll_ssc4_reg.regValue = rtd_inl(PLL27X_REG_PLL_SSC4_reg);
	//if(tableidx == 0){
	if(bEnable == 0 || u16Percent ==0){
		//set default dclk freq.
		   pll_disp1_reg.dpll_m = m_code;
		pll_disp1_reg.dpll_n = n_code;
		pll_ssc0_reg.fcode_t_ssc = f_code;
		pll_ssc0_reg.oc_en = 0;
		pll_ssc0_reg.oc_step_set = 0x200;
		rtd_outl(PLL27X_REG_SYS_PLL_DISP1_reg, pll_disp1_reg.regValue);
		rtd_outl(PLL27X_REG_PLL_SSC0_reg, pll_ssc0_reg.regValue);
		pll_ssc0_reg.oc_en = 1;
		rtd_outl(PLL27X_REG_PLL_SSC0_reg, pll_ssc0_reg.regValue);
		cnt=10;
		do{
			pll_ssc5_reg.regValue = rtd_inl(PLL27X_REG_PLL_SSC5_reg);
			mdelay(1);
		}while((pll_ssc5_reg.oc_done != 1) && (cnt--));
		pll_ssc0_reg.oc_en = 0;
		rtd_outl(PLL27X_REG_PLL_SSC0_reg, pll_ssc0_reg.regValue);
		//disable sscg
		pll_ssc4_reg.en_ssc = 0;
		rtd_outl(PLL27X_REG_PLL_SSC4_reg, pll_ssc4_reg.regValue);
		return;
	}

	temp = ((m_code+3)*10000+ ((f_code*10000)/2048));
	//printf("\n temp1:%d \n", temp);
	temp = temp+ (temp*(dclk_sscg_range*10)/2)/10000;
	m_code = temp/10000-3;
	f_code = ((temp%10000)*2048)/10000;
	temp_ssc = (temp*(1000-dclk_sscg_range))/1000;
	n_code_ssc = temp_ssc/10000-3;
	f_code_ssc = ((temp_ssc%10000)*2048)/10000;

	pll_disp1_reg.dpll_m = m_code;
	pll_disp1_reg.dpll_n = n_code;
	pll_ssc0_reg.fcode_t_ssc = f_code;

	pll_ssc3_reg.ncode_ssc = n_code_ssc;
	pll_ssc3_reg.fcode_ssc = f_code_ssc;
	pll_ssc0_reg.oc_en = 0;
	pll_ssc0_reg.oc_step_set = 0x200;
	rtd_outl(PLL27X_REG_SYS_PLL_DISP1_reg, pll_disp1_reg.regValue);
	rtd_outl(PLL27X_REG_PLL_SSC0_reg, pll_ssc0_reg.regValue);
	rtd_outl(PLL27X_REG_PLL_SSC3_reg, pll_ssc3_reg.regValue);

	pll27x_reg_sys_pll_disp3_reg.regValue = rtd_inl(PLL27X_REG_SYS_PLL_DISP3_reg);
	if(div == 1)
		pll27x_reg_sys_pll_disp3_reg.dpll_o = 0;
	else if(div == 2)
		pll27x_reg_sys_pll_disp3_reg.dpll_o = 1;
	else if(div == 4)
		pll27x_reg_sys_pll_disp3_reg.dpll_o = 2;
	else if(div == 8)
		pll27x_reg_sys_pll_disp3_reg.dpll_o = 3;
	else
		pll27x_reg_sys_pll_disp3_reg.dpll_o = 0;
	rtd_outl(PLL27X_REG_SYS_PLL_DISP3_reg, pll27x_reg_sys_pll_disp3_reg.regValue);

	//printf("\n temp:%d, temp_ssc:%d, n_code_ssc:%d, f_code_ssc:%d\n", temp, temp_ssc, n_code_ssc, f_code_ssc);

	temp= 0;
	dpll_clk = (((m_code+3)*1000000 + (f_code*1000000)/2048)*27) / (n_code+2);
	dpll_clk_ssc = (dpll_clk/1000*(1000 - dclk_sscg_range));
	printf( "\n dpll_clk:%d, dpll_clk_ssc:%d, div:%d\n", dpll_clk, dpll_clk_ssc, div);
	temp = (10000*((m_code-n_code_ssc)*2048+f_code-f_code_ssc)/2/2048 + (n_code_ssc+3)*10000);
	//printf( "\n div div div div div:%d \n", div);
	if((temp != 0) && (div != 0))
		ssc_clk = (dpll_clk_ssc)/temp;
	else
	{
		if(temp == 0)
		printf("\n [Error]temp should not be zero!!!! \n");

		if(div == 0)
		printf("\n [Error]div should not be zero!!!! \n");

		return;

	}
	//printf("\n temp:%d, ssc_clk:%d \n", temp, dpll_clk_ssc/temp);

	if(ss_freq != 0)
		step =	ssc_clk*10000 / ss_freq;
	else {
		printf("\n [Error]ss_freq should not be zero!!!! \n");
		return;
	}

	if(f_code>=f_code_ssc)
		gran_est = (((m_code-n_code_ssc)*2048+f_code-f_code_ssc)*2*(1<<(15-dot_gran))) /step;
	else
		gran_est = (((m_code-1-n_code_ssc)*2048+ (2048+f_code)-f_code_ssc)*2*(1<<(15-dot_gran))) /step;


	//printf( "m_code:%d, n_code:%d, f_code:%d, n_code_ssc:%d, f_code_ssc:%d\n", m_code , n_code, f_code, n_code_ssc, f_code_ssc);
	//printf( "\n step:%d, gran_est:%d\n", step , gran_est);

	pll_ssc4_reg.dot_gran = dot_gran;
	pll_ssc4_reg.gran_auto_rst = 1;
	pll_ssc4_reg.gran_est = gran_est;
	rtd_outl(PLL27X_REG_PLL_SSC4_reg, pll_ssc4_reg.regValue);

	pll_ssc0_reg.oc_en = 1;
	rtd_outl(PLL27X_REG_PLL_SSC0_reg, pll_ssc0_reg.regValue);

	cnt=100;
	do{
		mdelay(1);
		pll_ssc5_reg.regValue = rtd_inl(PLL27X_REG_PLL_SSC5_reg);
	}while((pll_ssc5_reg.oc_done != 1) && (cnt--));

	pll_ssc0_reg.oc_en = 0;
	rtd_outl(PLL27X_REG_PLL_SSC0_reg, pll_ssc0_reg.regValue);
	pll_ssc4_reg.en_ssc = 1;
	rtd_outl(PLL27X_REG_PLL_SSC4_reg, pll_ssc4_reg.regValue);


	dclkss_reg.regValue = rtd_inl(PLL27X_REG_SYS_DCLKSS_reg);
	dclkss_reg.dclk_ss_load = 1;
	dclkss_reg.dclk_ss_en = 1;
	rtd_outl(PLL27X_REG_SYS_DCLKSS_reg, dclkss_reg.regValue);

}

#if defined(Config_Board_TV010_PANEL)
extern void init_network_driver(void);
#endif

extern bootparam_t bootparam;	//for sscg

void panel_init_2nd(void)
{
	if (panel_init_2nd_is_done)
		return;
	panel_init_2nd_is_done = 1;

	if (boot_mode == BOOT_CONSOLE_MODE) {
		printf("skip panel_init_2nd, mode=%d\n", boot_mode);
		return;
	}

	if ((boot_power_on_mode == POWER_OFF) && (boot_mode != BOOT_RESCUE_MODE))
		return;
	panel_init_2nd_is_done = 1;

	panel_init_1st();

#ifdef CONFIG_CMD_MISC
	display_boottime_log("test"); printf("%s %d:\n", __FUNCTION__, __LINE__);
#endif

#ifdef CONFIG_PANEL_APPLY_TCON_SETTING
	panel_apply_tcon_setting(PANEL_TCON_SETTING_FILE_NAME);
	panel_apply_tcon_setting(PANEL_ODC_SETTING_FILE_NAME);
#endif

	printf("panel_init_2nd\n");
	// set up back light pwm freq/duty
#if 0
	panel_current_adjust();
#endif

#if 0 // FIXME for 294x bringup
#if defined(CONFIG_BOARD_298X_TV003_QFP176_V2_NAND)
    IO_PWM_SetFreq(PIN_DIMMER,(&default_panel_parameter)->iCONFIG_BACKLIGHT_PWM_FREQ);  //pwm_init
    IO_PWM_SetDuty(PIN_DIMMER, (&default_panel_parameter)->iCONFIG_BACKLIGHT_PWM_DUTY); //pwm_set
#elif defined(CONFIG_BOARD_298X_TV035_QFP176_V3_EMMC) || defined(CONFIG_BOARD_298X_TV035_BGA459_EMMC)
	IO_PWM_SetFreq(PIN_BL_ADJ,(&default_panel_parameter)->iCONFIG_BACKLIGHT_PWM_FREQ);	//pwm_init
	if ( bootparam.backlight_value > 254 )
	{
		bootparam.backlight_value = 254;
	}
	else if ( bootparam.backlight_value < 10 )
	{
		bootparam.backlight_value = 10;
	}
	IO_PWM_SetDuty(PIN_BL_ADJ, bootparam.backlight_value); //pwm_set
#elif defined(CONFIG_BOARD_298X_TV015_QFP176_V3_EMMC_VER1)
	if(default_panel_parameter.iCONFIG_BACKLIGHT_PWM_DUTY > 254)
		default_panel_parameter.iCONFIG_BACKLIGHT_PWM_DUTY = 254;
	if(default_panel_parameter.iCONFIG_BACKLIGHT_PWM_DUTY < 2)
		default_panel_parameter.iCONFIG_BACKLIGHT_PWM_DUTY = 2;
	IO_PWM_SetFreq(PIN_BL_ADJ,(&default_panel_parameter)->iCONFIG_BACKLIGHT_PWM_FREQ);	//pwm_init
	IO_PWM_SetDuty(PIN_BL_ADJ, (&default_panel_parameter)->iCONFIG_BACKLIGHT_PWM_DUTY); 	//pwm_set
#else
	IO_PWM_SetFreq(PIN_BL_ADJ,(&default_panel_parameter)->iCONFIG_BACKLIGHT_PWM_FREQ);	//pwm_init
	IO_PWM_SetDuty(PIN_BL_ADJ, (&default_panel_parameter)->iCONFIG_BACKLIGHT_PWM_DUTY); 	//pwm_set
#endif
#endif
#if 0
	pwm_pinshare_power_enable();
#endif
#if 0
	printf("panel_init_2nd,%d iLVDS_TO_LIGHT_ON_ms=%d \n",__LINE__, (&default_panel_parameter)->iLVDS_TO_LIGHT_ON_ms);
	printf("panel_init_2nd,%d iPANEL_TO_LVDS_ON_ms=%d \n",__LINE__, (&default_panel_parameter)->iPANEL_TO_LVDS_ON_ms);
	printf("panel_init_2nd,%d iLIGHT_TO_LDVS_OFF_ms=%d \n",__LINE__, (&default_panel_parameter)->iLIGHT_TO_LDVS_OFF_ms);
	printf("panel_init_2nd,%d iLVDS_TO_PANEL_OFF_ms=%d \n",__LINE__, (&default_panel_parameter)->iLVDS_TO_PANEL_OFF_ms);
#endif

#if 0 //defined(CONFIG_REALTEK_AMP_TAS5711)
	printf("%d\n",__LINE__);
	extern void AudioAmp_InitAudioOut2I2S_2nd(void);
	AudioAmp_InitAudioOut2I2S_2nd();
	(&default_panel_parameter)->iLVDS_TO_LIGHT_ON_ms -= 150;
#endif

	//if((default_panel_parameter.iCONFIG_PANEL_TYPE != P_VBY1_4K2K) &&
	//   (default_panel_parameter.iCONFIG_PANEL_TYPE != P_VBY1_2K1K) &&
	//   (default_panel_parameter.iCONFIG_PANEL_TYPE != P_VBY1_TO_HDMI_MEMC_FREERUN) &&
	//	(default_panel_parameter.iCONFIG_PANEL_TYPE != P_VBY1_TO_HDMI)){
	mdelay((&default_panel_parameter)->iLVDS_TO_LIGHT_ON_ms);
	//}
#if defined(Config_Board_TV010_PANEL)
	//tv010 need this delay, no matter if VBY_4K2K or others
	// FOR OLED Power on flow T3
	else if(default_panel_parameter.iCONFIG_PANEL_CUSTOM_INDEX== VBY_ONE_PANEL_LG_OLED_2K1K_120HZ_1S_4L)	{
		if(((&default_panel_parameter)->iLVDS_TO_LIGHT_ON_ms) > 500)
		{
			char times,remainder,i;
			times = ((&default_panel_parameter)->iLVDS_TO_LIGHT_ON_ms) /500;
			remainder = ((&default_panel_parameter)->iLVDS_TO_LIGHT_ON_ms) % 500;
			printf("\n T3 deley times =%d  remainder=%d\n", times , remainder);
			for(i=0;i<times;i++)
			{
				mdelay(500);
				WATCHDOG_KICK();
			}
			if(remainder)
				mdelay(remainder);
		}
		else
		{
			mdelay((&default_panel_parameter)->iLVDS_TO_LIGHT_ON_ms);
		}
		//IO_Set(PIN_EVDD_ON, 1);
//		rtd_maskl(0xb801bd18,0xFFFBBFFF,0x00000000);  // // EVDD ON
	}
#endif

#ifndef IS_FPGA
#ifdef CONFIG_FSW
	if(fsw_emmc_bootup)
		boot_power_on_mode = BACKLIGHT_OFF;
#endif
	if (boot_power_on_mode != BACKLIGHT_OFF)
	{
			#ifdef CONFIG_CUSTOM_SN_PANEL
			if(IsID_Match()){
#ifndef CONFIG_RTKPCB
				#define PWM_DCLK 594000000
				int Pwm_Duty=(default_panel_parameter.snInfo.CURRENT_MAX/4);
				int Pwm_freq =(((((PWM_DCLK/4))/2)/(31+1))/default_panel_parameter.snInfo.BL_CUR_FREQ);

				//sn power seq spec
				if (boot_power_on_mode != POWER_OFF){//power off not to set pwm,power seq spec
					printf("BL_CUR_FREQ =%d\n",default_panel_parameter.snInfo.BL_CUR_FREQ);
					printf("CURRENT_MAX =%d\n",default_panel_parameter.snInfo.CURRENT_MAX);
					printf("Pwm_Duty =%d \n",Pwm_Duty);
					printf("Pwm_freq =%d \n",Pwm_freq);

					if(QHB_Boot == false){
						//GPIO 13
						IO_PWM_SetFreq(PIN_DC_DIMMER_IP_REF, Pwm_freq);
						IO_PWM_SetDuty(PIN_DC_DIMMER_IP_REF, Pwm_Duty);

						//GPIO10 100% =255
						IO_PWM_SetFreq(PIN_PWM0_DIMMER, Pwm_freq);
						IO_PWM_SetDuty(PIN_PWM0_DIMMER, 255);

						Pwm_freq =(((((PWM_DCLK/4))/2)/(31+1))/default_panel_parameter.snInfo.BL_PWM_FREQ);

						//GPIO 11
						Pwm_Duty =255/4;//25%
						IO_PWM_SetFreq(PIN_BL_ADJ, Pwm_freq);
						IO_PWM_SetDuty(PIN_BL_ADJ, Pwm_Duty);

						//GPIO12
						Pwm_Duty =255/4;//25%
						IO_PWM_SetFreq(PIN_PWM2_DIMMER, Pwm_freq);
						IO_PWM_SetDuty(PIN_PWM2_DIMMER, Pwm_Duty);

					}else{
						//GPIO 13
						IO_PWM_SetFreq(PIN_DC_DIMMER_IP_REF, Pwm_freq);
						IO_PWM_SetDuty(PIN_DC_DIMMER_IP_REF, 0);

						//GPIO10 100% =255
						IO_PWM_SetFreq(PIN_PWM0_DIMMER, Pwm_freq);
						IO_PWM_SetDuty(PIN_PWM0_DIMMER, 0);

						Pwm_freq =(((((PWM_DCLK/4))/2)/(31+1))/default_panel_parameter.snInfo.BL_PWM_FREQ);

						//GPIO 11
						IO_PWM_SetFreq(PIN_BL_ADJ, Pwm_freq);
						IO_PWM_SetDuty(PIN_BL_ADJ, 0);

						//GPIO12
						IO_PWM_SetFreq(PIN_PWM2_DIMMER, Pwm_freq);
						IO_PWM_SetDuty(PIN_PWM2_DIMMER, 0);
						IO_Set(PIN_LVDS_ON_OFF, 0);
}
					}
#endif
			}
            #endif

	}
#endif

// set LD pinshare
//mdelay(100);
//rtd_maskl(0xB8000888, 0x000F0FFF, 0x55505000);

	if(Get_PANEL_TYPE_IS_IWATT_LOCAL_DIMMING()){
#ifdef CONFIG_REALTEK_LOCAL_DIMMING_INTERFACE
	unsigned int  data0[5] = {0x00001280,0x000d5cd,0x00001b1b,0x000025b5,0x00004039}; // Write A0~A3 regiser value, 0x2500(A0) = (0xA0*4)+0x1000(Write mode)
	unsigned int  data1[22] = {	// Write 0x50~0x64 register value
							0x00001140,0x00000000,0x00000010,0x00000000,0x00000000,0x0000008f,
						    	0x00000677,0x00000677,0x0000047f,0x0000047f,0x00000287,0x00000287,
							0x0000008f,0x0000008f,0x00000677,0x00000677,0x0000047f,0x0000047f,
							0x00000287,0x00000287,0x0000008f,0x0000008f
						   };
	unsigned int  data2[18] = {	// Write 0x00~0x10 register value
							0x00001000,0x00000007,0x00000fff,0x00000fff,0x00000fff,0x00000fff,
						    	0x00000fff,0x00000fff,0x00000fff,0x00000fff,0x00000fff,0x00000fff,
							0x00000fff,0x00000fff,0x00000fff,0x00000fff,0x00000fff,0x00000fff
						   };
	unsigned int  data3[2] = {	0x00001280,0x000055cd  };// Write 0xA0 register value
	unsigned int  data4[2] = {	0x00001144,0x00000330  };// Write 0x51 register value
	unsigned int  data5[2] = {	0x00001284,0x00001717  };// Write 0xA1 register value
	unsigned int  data6[2] = {	0x00001148,0x000001ea  };// Write 0x52 register value
	unsigned int  data7[2] = {	0x00001148,0x000000ea  };// Write 0x52 register value
	unsigned int  data8[2] = {	0x00001000,0x00000007  };// Write 0x00 register value
	unsigned int  data9[17] = {	// Write 0x01~0x10 register value
							0x00001004,0x00000fff,0x00000fff,0x00000fff,0x00000fff,0x00000fff,
							0x00000fff,0x00000fff,0x00000fff,0x00000fff,0x00000fff,0x00000fff,
							0x00000fff,0x00000fff,0x00000fff,0x00000fff,0x00000fff
							};

 	ld_Write(data0, 5 , LD_WRITE_MODE_NOT_FOLLOW_VSYNC);
	ld_Write(data1, 22 , LD_WRITE_MODE_NOT_FOLLOW_VSYNC);
	ld_Write(data2, 18 , LD_WRITE_MODE_NOT_FOLLOW_VSYNC);
	ld_Write(data3, 2 , LD_WRITE_MODE_NOT_FOLLOW_VSYNC);
	ld_Write(data4, 2 , LD_WRITE_MODE_NOT_FOLLOW_VSYNC);
	ld_Write(data5, 2 , LD_WRITE_MODE_NOT_FOLLOW_VSYNC);
	ld_Write(data6, 2 , LD_WRITE_MODE_NOT_FOLLOW_VSYNC);
	ld_Write(data7, 2 , LD_WRITE_MODE_NOT_FOLLOW_VSYNC);
	ld_Write(data8, 2 , LD_WRITE_MODE_NOT_FOLLOW_VSYNC);
	ld_Write(data9, 17 , LD_WRITE_MODE_FOLLOW_VSYNC);	// For Backlight Scan
#endif

       //printf("\n $$$$$$$$ Read 0xA0 = %x \n", ld_Read(0x280));// Read 0xA0 register value



	printf("\n $$$$$$$$ local diming setting complete ....... \n");
        }

#if defined(Config_Board_TV010_PANEL)
#ifdef PANEL_CONFIG_FROM_FACTORY_PANEL_BIN
	printf("\n iCONFIG_LD_Enable=%d\n",default_panel_parameter.iCONFIG_LD_Enable);
	if(default_panel_parameter.iCONFIG_LD_Enable == 1)
	{
#if 0
		switch(default_panel_parameter.iCONFIG_LD_Partition_Amount)
		{
			case 12:
			default:
				panel_ld_12R_algo_init();

				if(default_panel_parameter.iCONFIG_LD_SPIDecoderMcuInPower_Enable == 0)
				{
					panel_ld_12R_nomcu_spi_init();
				}
				else
				{
					panel_ld_12R_spi_init();
				}

				break;

			case 18:
				panel_ld_18R_algo_init();
				panel_ld_18R_spi_init();
				break;

		}
		printf("\n &&&&&&&&&& local diming setting complete ....... \n");
#else
		switch(default_panel_parameter.iCONFIG_LD_Partition_Amount)
		{
			case 240:
			{
				printf("\n $$$$$$$$ LD_algo_comp_on_240R  local diming setting begin ....... \n");
				#include <panel_script/Merlin3_LD_algo_comp_on_240R_20170726_Sky3.tbl>
				printf("\n $$$$$$$$ LD_algo_comp_on_240R  local diming setting complete ....... \n");
			    break;
			}

			case 12:
			{
				printf("\n $$$$$$$$ LD_algo_comp_on_12R  local diming setting begin ....... \n");
				#include <panel_script/Merlin3_LD_algo_comp_on_12R_20170728_Sky3_v2.tbl>
				printf("\n $$$$$$$$ LD_algo_comp_on_12R  local diming setting complete ....... \n");
			    break;
			}

			default:
			{
				printf("\n &&&&&&&&&& no support LD_Partition_Amount, local diming setting fail !!!!!!!! ....... \n");
				break;
			}
		}
#endif
	}
#endif
#endif

/*For local dimming demo*/
#ifdef Config_Panel_TV010_LocalDiming_is_240R
	printf("\n $$$$$$$$ LD_algo_comp_on_240R  local diming setting begin ....... \n");
	#include <panel_script/Merlin3_LD_algo_comp_on_240R_20170726_Sky3.tbl>
	printf("\n $$$$$$$$ LD_algo_comp_on_240R  local diming setting complete ....... \n");
#elif defined(Config_Panel_TV010_LocalDiming_is_12R)
	printf("\n $$$$$$$$ LD_algo_comp_on_12R  local diming setting begin ....... \n");
	#include <panel_script/Merlin3_LD_algo_comp_on_12R_20170728_Sky3_v2.tbl>
	printf("\n $$$$$$$$ LD_algo_comp_on_12R  local diming setting complete ....... \n");
#endif

#if 0 // 240R
#include <Merlin_LD_algo_comp_240R_20150812_all_on.tbl>
#include <Merlin_LD_algo_init_240R_20150818_HDR_ON.TBL>
#include <Merlin_local_dimming_LGD for skyworth_240_20150805_FULL.TBL>
#elif 0 // 180R
#include <Merlin_LD_algo_comp_180R_20150812_all_on.tbl>
#include <Merlin_LD_algo_init_180R_20150818_HDR_ON.tbl>
#include <Merlin_local_dimming_LGD for skyworth_180_20150805_FULL.tbl>
#elif 0 // 108R
#include <Merlin_LD_algo_comp_108R_20150818_all_on.tbl>
#include <Merlin_LD_algo_init_108R_20150818_HDR_ON.tbl>
#include <Merlin_local_dimming_LGD for skyworth_108_20150805_FULL.tbl>
#endif

	// bus high clock set to 459MHz
	/* local dimming used, compiler it if define local dimming above.
	rtd_outl(0xb8000434, 0x00000e03);
	rtd_maskl(0xb8000438, (~_BIT0), _BIT0);
	*/

#if defined(CONFIG_BOARD_298X_TV035_QFP176_V3_EMMC) || defined(CONFIG_BOARD_298X_TV035_BGA459_EMMC)
	//add by xiangping_chen start
   	//for LVDS Spread Spectrum FMDIV
    rtd_maskl(0xb8000318, 0xFFFF80FF,0x9<<8);
	//add by xiangping_chen end
#endif

	if(bootparam.panel_ssc_enable != BOOTPARAM_PANEL_SSC_UNKNOWN){
		printf("bootparam : (%d.%d.%d) \n", bootparam.panel_ssc_enable, bootparam.panel_ssc_step, bootparam.panel_ssc_span);
		//Set SSCG by tmp/factory/bin_panel/000BootParam.h
		panel_set_spread_spectrum(bootparam.panel_ssc_enable, bootparam.panel_ssc_step, bootparam.panel_ssc_span);
	}else{
		printf("bootparam is NULL. run default sscg.\n");
		//default SSCG Flow
		if(((&default_panel_parameter)->iCONFIG_PANEL_TYPE == P_VBY1_TO_HDMI) ||
			((&default_panel_parameter)->iCONFIG_PANEL_TYPE == P_VBY1_TO_HDMI_MEMC_FREERUN)){
			// Don't turn on SSCG
		}else{
			//panel_set_spread_spectrum(true, 5); //0.5%
		}
	}

#ifdef IS_BOX
	hdmi_tx_init();
#endif

#if 1//set z0 default value is low (HDMI)
	//Provided by HDMI driver owner
	rtd_outl(0xB8000104, 0x00000400 | 0x01);
	rtd_outl(0xB8000114, 0x00000400 | 0x01);
	rtd_outl(0xB800DAFC, 0x00000000);
#endif

#ifdef BOARD_RTD286X_PATCH
	//control panel_en power due to no pcb rtd286x define
	if(default_panel_parameter.iCONFIG_PANEL_TYPE == P_MINI_LVDS){
		if((default_panel_parameter.iCONFIG_PANEL_CUSTOM_INDEX==P_MINI_LVDS_CSOT_PANEL) ||
		(default_panel_parameter.iCONFIG_PANEL_CUSTOM_INDEX==P_MINI_LVDS_BOE_PANEL)){
			rtd_clearbits(0xb801bd20, _BIT7); 	// GPIO_71 Output H,
			mdelay(2000);
			rtd_setbits(0xb801bd20, _BIT7); 	// GPIO_71 Output H,
		}
	}
#endif

        // IMPORTANT! must be called
        panel_misc();

	if(!strcmp(default_panel_parameter.sPanelName, "RTK_4K2K_VBY1_1Seg8Port_new.h")) {
            panel_pwm_invert_custom_setting();
        }

}

void panel_misc(void)
{
#if defined(CONFIG_REALTEK_AMP_ALC1311)
	#if 0 //Fix me:mark for compile
	extern void AudioAmp_InitAudioOut2I2S_1st(void);
	  AudioAmp_InitAudioOut2I2S_1st();
	#endif
#endif
#if defined(CONFIG_REALTEK_AMP_TAS5711) || defined(CONFIG_REALTEK_AMP_TAS5707) || defined(CONFIG_REALTEK_AMP_ACL1310)
    printf("ampinit at panel flow, %d\n",__LINE__);
	#if 0 //Fix me:mark for compile
    extern void AudioAmp_InitAudioOut2I2S_2nd(void);
    AudioAmp_InitAudioOut2I2S_2nd();
	#endif
#endif

#if defined(CONFIG_REALTEK_EERPOM_TV010_A)
    if(boot_power_on_mode != POWER_OFF)
    {
        Eeprom_SetMacAddressToKernel_Read();
        Eeprom_SetMacAddressToKernel_Apply();
    }
#endif

#ifdef CONFIG_USB_CHECK_CUSTOMER_COMMAND
    if (boot_ac_on && (boot_mode == BOOT_NORMAL_MODE))
    {
        // usb start
        char cmd[128];
        int ret=0;
        memset(cmd, 0, sizeof(cmd));
        sprintf(cmd, "usb start");
        WATCHDOG_KICK();
        ret = run_command(cmd, 0);
        if(ret != 0)
        {
            /* Usb start error */
            WATCHDOG_KICK();
            printf("[INFO] %s:usb start failed. (No USB plug-in)\n", __FUNCTION__);
        }
        else {
            char* pUsbFirstFileName = NULL;
            pUsbFirstFileName = fat_ls_first("usb", "0:1");
            WATCHDOG_KICK();
            if (pUsbFirstFileName) {
                printf("pUsbFirstFileName = %s\n", pUsbFirstFileName);
                if (strncmp(pUsbFirstFileName, "skyworth_test_", strlen("skyworth_test_")) == 0) {  //speedup
                    if (strncmp(pUsbFirstFileName, "skyworth_test_enter_install", strlen("skyworth_test_enter_install")) == 0) {
                        printf("\033[1;31m Usb fast install is detected!! \033[m\n");
                        /* fill 0x2379aacc to enter rescure kernel */
#if defined(CONFIG_CUSTOMER_TV010)
                        rtd_outl(REG_AC_DC_ON_reg, rtd_inl(REG_AC_DC_ON_reg) & 0xc0000000 | 0x2379aacc);
#else
                        rtd_outl(REG_AC_DC_ON_reg, 0x2379aacc);
#endif

                        // trigger WD
                        rtd_outl(MIS_TCWTR, _BIT0);
                        rtd_outl(MIS_TCWOV_reg, 0x0); //reboot immediately
                        rtd_clearbits(MIS_TCWCR_reg, 0xff);
                    }

                    if (strncmp(pUsbFirstFileName, "skyworth_test_panelid_", strlen("skyworth_test_panelid_")) == 0) {
                        printf("[DEBUG]%s:%d\n",__FUNCTION__,__LINE__);
                        char panelID_str[3] ={ 0x00, 0x00, 0x00};
                        int panelID;
                        int final_num = strlen("skyworth_test_panelid_");
                        panelID_str[0] = pUsbFirstFileName[final_num];
                        panelID_str[1] = pUsbFirstFileName[final_num+1];
                        panelID = (unsigned int) strtoul (panelID_str, (char **) 0, 10);
                        printf("\033[1;31m panelID_str = %s, panelID = %d\033[m\n", panelID_str, panelID);
                        printf("\033[1;31m panelID_str = %s, panelID = %d\033[m\n", panelID_str, panelID);
                        printf("\033[1;31m panelID_str = %s, panelID = %d\033[m\n", panelID_str, panelID);
                        printf("\033[1;31m panelID_str = %s, panelID = %d\033[m\n", panelID_str, panelID);
                        printf("\033[1;31m panelID_str = %s, panelID = %d\033[m\n", panelID_str, panelID);
                        //eep command
                        memset(cmd, 0, sizeof(cmd));
                        sprintf(cmd, "eep e 0x%02x\n", panelID);
                        printf("\033[1;31m cmd: %s \033[m\n", cmd);
                        WATCHDOG_KICK();
                        run_command(cmd, 0);
                    }
                }
            }
            else
                printf("pUsbFirstFileName = NULL\n");
        }
        // usb stop
        memset(cmd, 0, sizeof(cmd));
        sprintf(cmd, "usb stop");
        ret = run_command(cmd, 0);
        if (ret != 0)
        {
            /* Usb stop error */
            printf("[INFO] %s:usb stop failed.\n", __FUNCTION__);
        }
    }
#endif

#if defined(Config_Board_TV006_QFP256_2H_EMMC)
// PWM1 & 4  Enable PWM1 reset by DVS
	rtd_setbits(0xB801BC90,_BIT28);
	rtd_setbits(0xB801BCB4,_BIT28);
#endif

}

void panel_pwm_invert_custom_setting(void)
{
    extern unsigned int env_setup_env_pcb(void);
    unsigned long long value = 0;
    pcb_mgr_get_enum_info_byname("PIN_BL_ADJ",&value);
    #define CLEAR_PWM_INVERT(x)                  (x & (~(1<<23)));

    value = CLEAR_PWM_INVERT(value);                            //clear invert bit[23]

    pcb_mgr_set_enum_info_byname("PIN_BL_ADJ", value);
    env_setup_env_pcb();
}

#if 0 // cklai@mark unused code
#define rtd_setbits(offset, Mask) rtd_outl(offset, (rtd_inl(offset) | Mask))
#define rtd_clearbits(offset, Mask) rtd_outl(offset, ((rtd_inl(offset) & ~(Mask))))
void scaler_wait_for_event(unsigned int addr, unsigned int event)
{
	unsigned int timeoutcnt = 0x032500;

	rtd_setbits(addr, event);
	rtd_clearbits(addr, event);


	do {
		if(rtd_inl(addr) & event) {
			return;
		}
	} while(timeoutcnt-- != 0);

	return;

}

void disable_force_bg(void)
{
	printf("disable_force_bg\n");
	ppoverlay_display_timing_ctrl1_RBUS display_timing_ctrl1_reg;
	scaler_wait_for_event(PPOVERLAY_DTG_PENDING_STATUS_VADDR, _BIT0);//wait data anable end
	display_timing_ctrl1_reg.regValue = rtd_inl(PPOVERLAY_Display_Timing_CTRL1_reg);
	display_timing_ctrl1_reg.dout_force_bg = 0;
	rtd_outl(PPOVERLAY_Display_Timing_CTRL1_reg, display_timing_ctrl1_reg.regValue);
}
#endif
static void  panel_vby1_custom_setting(void)
{
	if(default_panel_parameter.iCONFIG_PANEL_CUSTOM_INDEX == VBY_ONE_PANEL_4K2K_to_H5X){
		rtd_part_outl(0xb802D030, 11, 0, 0xFFF);   //Lane0~11 PN SWAP
	}
}

static void  panel_epi_custom_setting(void)
{
	if(default_panel_parameter.iCONFIG_PANEL_CUSTOM_INDEX == P_EPI_LG_47_ART5){
		sfg_sfg_ctrl_0_RBUS    sfg_ctrl_0_reg;
		// enable h flip
		sfg_ctrl_0_reg.regValue = rtd_inl(SFG_SFG_CTRL_0_reg);
		sfg_ctrl_0_reg.h_flip_en = 1;
		rtd_outl(SFG_SFG_CTRL_0_reg, sfg_ctrl_0_reg.regValue);
	}
}

static void  panel_lvds_custom_setting(void)
{

}

static void  panel_mlvds_custom_setting(void)
{

	}

void panel_customized_setting(void)
{
	printf("=== Panel Index : %x ===\n", default_panel_parameter.iCONFIG_PANEL_CUSTOM_INDEX);

	if((default_panel_parameter.iCONFIG_PANEL_TYPE == P_VBY1_4K2K) ||
		(default_panel_parameter.iCONFIG_PANEL_TYPE == P_VBY1_2K1K) ||
		(default_panel_parameter.iCONFIG_PANEL_TYPE == P_VBY1_TO_HDMI)){
		panel_vby1_custom_setting();
	}
	else if(default_panel_parameter.iCONFIG_PANEL_TYPE == P_EPI_TYPE){
		panel_epi_custom_setting();
	}
	else if(default_panel_parameter.iCONFIG_PANEL_TYPE == P_MINI_LVDS){
		panel_mlvds_custom_setting();
	}
	else{
		panel_lvds_custom_setting();
	}
	CusApi_panel_customized_setting();
}

void panel_i2c_init(void)
{

#if 0
	// PA168 init via I2C command
	if(panel_Tcon_PA168_Enable()){
		mdelay(500);  // wait TCON ready //500ms
		PA168_i2c_cmd(); // PA168 init via I2C command
	}else if(Get_PANEL_TYPE_IS_MILLET3_4K2K_SERIES()){
		mdelay(500);  // wait TCON ready //500ms
		if(default_panel_parameter.iCONFIG_PANEL_CUSTOM_INDEX == VBY_ONE_PANEL_INX8903_4K2K_VBY1){
		}
		else{
			Millet4_i2c_cmd();
		}
	}
#endif

#if defined(Config_Board_TV010_PANEL)
	if(default_panel_parameter.iCONFIG_PANEL_TYPE == P_EPI_TYPE){
		 panel_epi_gamma_i2c_control();
	}
	else
#endif
		panel_tcon_i2c_control();

	CusApi_panel_i2c_init();

	return;
}

#ifdef IS_BOX
//For BOX ONLY by Andy Teng 2014/02/19
void hdmi_tx_init(void)
{
	printf("%s FIXME (need crt setting of hdmi)\n", __FUNCTION__);

	//HDMI TX
	rtd_maskl(SYS_REG_SYS_SRST1_reg, ~_BIT9, _BIT9);	  //HDMI TX rstn
	rtd_maskl(SYS_REG_SYS_CLKEN1_reg, ~_BIT9, _BIT9); //HDMI TX clk en
	//HDMI RX
	rtd_maskl(SYS_REG_SYS_SRST1_reg, ~_BIT10, _BIT10);   //HDMI RX rstn
	rtd_maskl(SYS_REG_SYS_CLKEN1_reg, ~_BIT10, _BIT10);   //HDMI RX clk en
#if 0
	rtd_maskl(0xb8007B40, 0xFDFFFFFF,0x02000000); //HDMI bandgap power 1:on 0:off
	//HDMI AIO
	rtd_maskl(0xb8000000, 0xffff7fff, 0x8000);	  //AIO rstn
	rtd_maskl(0xb800000c, 0xfffffbff, 0x400); //AIO clk en
	//APLL ADC
	rtd_maskl(0xb8000008, 0xffffffef, 0x10);  //APLL ADC rstn
	rtd_maskl(0xb8000014, 0xfeffffff, 0x1000000); //APLL ADC clk en
	//TVE
	rtd_maskl(0xb8000000, 0xfff7ffff, 0x80000);   //TVE rstn
	rtd_maskl(0xb8000004, 0xfff7ffff, 0x80000);   //TVE clkgen reset
	rtd_maskl(0xb800000c, 0xffffbfff, 0x4000);	  //TVE clk en
	//Display2Tve
	rtd_maskl(0xb8000008, 0xfffffffd, 0x2);   // DISP rstn
	rtd_maskl(0xb8000014, 0xfffffff7, 0x8);   //DISP clk en
	rtd_maskl(0xb8000014, 0xffbfffff, 0x400000);  //Display2TVE clk en

	rtd_outl(0xb8020104,0x00050009);  // APLL_ADC LDO power, for PLL27X
#endif

	return;
}
#endif

int panel_init(void)
{

//	rtk_stamp_set_bit(UBOOT_STAMP_PANEL_INIT_START);

	printf("panel initialize....\n");
	panel_init_1st();
#ifndef CONFIG_PANEL_INIT_2ND_AFTER_LOGO
	panel_init_2nd();
#endif
        // don't add any code at below
	return 0;
}

#ifdef CONFIG_PANEL_SHARP_60_MEMC

int ms_wait(int ms)
{
	udelay(1000*ms);
	return 0;
}

/*======================================================================
 * Func : panel_I2C_Write_EX
 *
 * Desc : Panel I2C Write Function (Extended Version)
 *
 * Parm : Id        : i2c id
 *    nAddr     : bytes number of address
 *        Addr      : target address (7bits)
 *        nData     : number of bytes to write
 *        pData     : data to write
 *
 * Retn : S_OK / S_FALSE
 *======================================================================*/
int panel_I2C_Write_EX(
    unsigned short  Addr,
    unsigned char       nSubAddr,
    unsigned char*  pSubAddr,
    unsigned short  nData,
    unsigned char*  pData
)
{
//  printf("I2C_Write_EX2\r\n");
    unsigned short devAddr = Addr >> 1;

    unsigned char cmd[64];
    unsigned short cmd_len = nData + nSubAddr;

    if (cmd_len > 64)
        return S_FALSE;

    memcpy(cmd, pSubAddr, nSubAddr);
    memcpy(cmd + nSubAddr, pData, nData);

    printf("panel_I2C_Write_EX, devAddr=%x\r\n", devAddr);

    return I2C_StartXfer(PANEL_I2C_MASTER, devAddr, cmd_len, cmd, 0, NULL);
}

/*======================================================================
 * Func : panel_I2C_Read_EX
 *
 * Desc : Panel I2C Read Function
 *
 * Parm : id           : i2c id
 *        Addr         : Target Address (7bits)
 *        nSubAddr     : number of bytes of sub address
 *        pSubAddr     : sub address
 *        nData        : numver of bytes to read
 *        pData        : data to read
 *
 * Retn : S_OK / S_FALSE
 *======================================================================*/
int panel_I2C_Read_EX(
    unsigned short  Addr,
    unsigned char       nSubAddr,
    unsigned char*  pSubAddr,
    unsigned short  nData,
    unsigned char*  pData
)
{
//  printf("I2C_Read_EX2\r\n");
//  printf("I2C_Read_EX2, Addr=%x\r\n",Addr);
//  printf("I2C_Read_EX2, nSubAddr=%x\r\n",nSubAddr);
//  printf("I2C_Read_EX2, pSubAddr[0]=%x\r\n",pSubAddr[0]);
//  printf("I2C_Read_EX2, pSubAddr[1]=%x\r\n",pSubAddr[1]);
//  printf("I2C_Read_EX2, nData=%x\r\n",nData);
//  printf("I2C_Read_EX2, *pData=%x\r\n",*pData);

    unsigned short devAddr = Addr >> 1;

    printf("panel_I2C_Read_EX, devAddr=%x\r\n", devAddr);

    return I2C_StartXfer(PANEL_I2C_MASTER, devAddr, nSubAddr, pSubAddr, nData, pData);
}

void panel_sharp_memc_init(unsigned char stage)
{
	if(0 == stage)
	{
		udelay(40000);  // 40 ms
		IO_Set(PIN_PANEL_ENABLE, 0);
//		IO_Set(PIN_DET_POW, 1);
		udelay(40000);  // 40 ms
	}
	else if(1 == stage)
	{
		unsigned long long value = 0;
		if (pcb_mgr_get_enum_info_byname("PIN_BL_ON_OFF", &value) == 0)
		{
			IO_Set(value, 1);
		}
		udelay(100000);  // 100 ms
		dFrdLcdControler_e dFrdLcdControler = FRDLCD_UNKNOWN;
		// Register TV003 I2C callback function
		//printf("Sharp:ifrdSetDriver\n");
		dResult_e dReseult = S_SPEC_ERROR;
		unsigned short Vcomdata;
		unsigned char version[50];

		ifrdSetDriver(panel_I2C_Read_EX,panel_I2C_Write_EX,ms_wait);

		// 4-1 Start sequence
		udelay(100000);  // 100 ms
		printf("SHARP 60 MEMC\n");
		// Set inch size of the factory mode.
		//printf("Sharp:eFrdLcdSetSize\n");
		dReseult = eFrdLcdSetSize(FRDLCD_PNL_60);
		//printf("eFrdLcdSetSize = %d\r\n",dReseult);
		//printf("Sharp:eFrdLcdGetLsiInfo\n");
		dFrdLcdControler = eFrdLcdGetLsiInfo();
		//printf("eFrdLcdGetLsiInfo = %d\r\n",dFrdLcdControler);

		dReseult = eFrdLcdChkEepLoadEnd();
		//printf("eFrdLcdChkEepLoadEnd = %d\r\n",dReseult);

		dReseult = eFrdLcdChkEepLoadEnd();
		//printf("eFrdLcdChkEepLoadEnd = %d\r\n",dReseult);

		dReseult = eFrdLcdGetRevInfo(version);
		//printf("eFrdLcdGetRevInfo = %d\r\n",dReseult);

		dReseult = eFrdLcdGetLibVer(version);
		//printf("eFrdLcdGetLibVer = %d\r\n",dReseult);
		//printf("eFrdLcdGetLibVer = %s\r\n",version);
/*
		dReseult = eFrdLcdGetDac(1,&Vcomdata);
		{
			if(Vcomdata > 127)
				Vcomdata = 0;
			dReseult = eFrdLcdSetDac(0,(unsigned char)Vcomdata);
		}
*/
		//printf("Sharp:eFrdSetMute\n");
		eFrdSetMute(1);
		//printf("Sharp:eFrdLcdInit\n");
		dReseult = eFrdLcdInit(1);
		//printf("eFrdLcdInit = %d\r\n",dReseult);

		// Set to FRD_INPUT_FREQ_60HZ
		//printf("Sharp:eFrdInit(1,FRD_INPUT_FREQ_60HZ)\n");
		dReseult = eFrdInit(1,FRD_INPUT_FREQ_50HZ);
		//printf("eFrdInit = %d\r\n ",dReseult);

		// Set to FRDLCD_TRN_OVR_NORMAL
		//printf("eFrdLcdSetTrnOvr(FRDLCD_TRN_OVR_NORMAL)\n");
		dReseult = eFrdLcdSetTrnOvr(FRDLCD_TRN_OVR_NORMAL);
		//printf("eFrdLcdSetTrnOvr = %d\r\n ",dReseult);

		// 4-3 Quick shoot
		// INV_POW must be high, but where is INV_POW??
		if(1) // To Do:  Obtain the setting from MENU->Picture->Advanced->Quick shoot
		{
			//printf("Quick shoot is ON\r\n");
			eFrdSetMode(1);
		}
		else
		{
			//printf("Quick shoot is OFF\r\n");
			eFrdSetMode(0);
		}

		// 4-4 Frequency control
		// INV_POW must be high, but where is INV_POW??
		//printf("Frequency control enable\r\n");
		eFrdSetMute(1);
		udelay(64000);  // 64 ms
		eFrdSetFreeRun(1);

		// Set to FRD_INPUT_FREQ_60HZ
		eFrdSetOutFreq(FRD_INPUT_FREQ_60HZ);
		eFrdLcdSetQsFreq(FRD_INPUT_FREQ_60HZ);
		udelay(50000);  // 50 ms
		eFrdSetFreeRun(0);
		udelay(50000);  // 50 ms
		eFrdSetMute(0);
		udelay(64000);  // 64 ms

		// 4-5 Temperature change
		// INV_POW must be high, but where is INV_POW??

		/*__________________________________________________
		|(*1) Temperature table	|			  |
		|	temperature	|	Temperature table |
		|	Temp<99		|		0	  |
		|	99<=Temp<8C	|		1	  |
		|	8C<=Temp<80	|		2 	  |
		|	80<=Temp<74	|		3	  |
		|	74<=Temp<69	|		4	  |
		|	69<=Temp<5E	|		5	  |
		|	5E<=Temp<4E	|		6	  |
		|	4E<=Temp	|		7	  |
		|_______________________|_________________________|
		*/
		//eFrdLcdSetLvl();

		// INV_POW must be low, but where is INV_POW??
		//printf("eFrdLcdSetQsEnable(1,1)\n");
		eFrdLcdSetQsEnable(1,1);
		//printf("eFrdSetMute(0)\n");
		eFrdSetMute(0);
		udelay(42000);  // 42 ms
		//printf("eFrdLcdSetOutput(1)\n");
		eFrdLcdSetOutput(1);
	}
}
#endif //#ifdef CONFIG_PANEL_SHARP_60_MEMC

extern int GDMA_init_module(unsigned int cmdbaddr);
int gdma_showlogo(uint logo_ddr_address)
{
       printf("\033[1;33m gdma_showlogo (logo_ddr_address=0x%x)\033[m\n", logo_ddr_address);
       unsigned int BootLogo_Width = BOOTLOGO_WIDTH;
       unsigned int BootLogo_Hegth = BOOTLOGO_HEIGHT;

#ifdef CONFIG_TCONLESS_BOE_CEDS
	I2C_Init();
	I2C_SetSpeed( TCON_I2C , 300);

	unsigned char data[2]={0,0};
	unsigned char slave_addr=(0x66>>1);

	printf("\033[1;33m TCON_I2C PM_IC reg(0x64)=0x80 \033[m\n");
	data[0]=0x64;    //Mode control
	data[1]=0x80;    //bit7 Mode 0: Normal mode. CRC is enabled  1: Test mode. CRC is disabled

	I2C_Write_EX(TCON_I2C, slave_addr, 2, &data[0]);
	udelay(700);  // 700 us

	printf("\033[1;33m TCON_I2C PM_IC reg(0x04~0x0F) \033[m\n");
	data[0]=0x04;
	data[1]=0x20;
	I2C_Write_EX(TCON_I2C, slave_addr, 2, &data[0]);
	data[0]=0x05;
	data[1]=0x20;
	I2C_Write_EX(TCON_I2C, slave_addr, 2, &data[0]);
	data[0]=0x06;
	data[1]=0xFC;
	I2C_Write_EX(TCON_I2C, slave_addr, 2, &data[0]);
	data[0]=0x07;
	data[1]=0x66;
	I2C_Write_EX(TCON_I2C, slave_addr, 2, &data[0]);
	data[0]=0x08;
	data[1]=0xFB;
	I2C_Write_EX(TCON_I2C, slave_addr, 2, &data[0]);
	data[0]=0x09;
	data[1]=0x34;
	I2C_Write_EX(TCON_I2C, slave_addr, 2, &data[0]);
	data[0]=0x0A;
	data[1]=0x34;
	I2C_Write_EX(TCON_I2C, slave_addr, 2, &data[0]);
	data[0]=0x0B;
	data[1]=0x00;
	I2C_Write_EX(TCON_I2C, slave_addr, 2, &data[0]);
	data[0]=0x0C;
	data[1]=0x20;
	I2C_Write_EX(TCON_I2C, slave_addr, 2, &data[0]);
	data[0]=0x0D;
	data[1]=0x20;
	I2C_Write_EX(TCON_I2C, slave_addr, 2, &data[0]);
	data[0]=0x0E;
	data[1]=0x00;
	I2C_Write_EX(TCON_I2C, slave_addr, 2, &data[0]);
	data[0]=0x0F;
	data[1]=0x00;
	I2C_Write_EX(TCON_I2C, slave_addr, 2, &data[0]);

	printf("\033[1;33m TCON_I2C PM_IC reg(0x10~0x1F) \033[m\n");
	data[0]=0x10;
	data[1]=0x3B;
	I2C_Write_EX(TCON_I2C, slave_addr, 2, &data[0]);
	data[0]=0x11;
	data[1]=0x50;
	I2C_Write_EX(TCON_I2C, slave_addr, 2, &data[0]);
	data[0]=0x12;
	data[1]=0x00;
	I2C_Write_EX(TCON_I2C, slave_addr, 2, &data[0]);
	data[0]=0x13;
	data[1]=0x30;
	I2C_Write_EX(TCON_I2C, slave_addr, 2, &data[0]);
	data[0]=0x14;
	data[1]=0x52;
	I2C_Write_EX(TCON_I2C, slave_addr, 2, &data[0]);
	data[0]=0x15;
	data[1]=0xCF;
	I2C_Write_EX(TCON_I2C, slave_addr, 2, &data[0]);
	data[0]=0x16;
	data[1]=0x29;
	I2C_Write_EX(TCON_I2C, slave_addr, 2, &data[0]);
	data[0]=0x17;
	data[1]=0x00;
	I2C_Write_EX(TCON_I2C, slave_addr, 2, &data[0]);
	data[0]=0x18;
	data[1]=0x00;
	I2C_Write_EX(TCON_I2C, slave_addr, 2, &data[0]);
	data[0]=0x19;
	data[1]=0x20;
	I2C_Write_EX(TCON_I2C, slave_addr, 2, &data[0]);
	data[0]=0x1A;
	data[1]=0x11;
	I2C_Write_EX(TCON_I2C, slave_addr, 2, &data[0]);
	data[0]=0x1B;
	data[1]=0xC7;
	I2C_Write_EX(TCON_I2C, slave_addr, 2, &data[0]);
	data[0]=0x1C;
	data[1]=0x00;
	I2C_Write_EX(TCON_I2C, slave_addr, 2, &data[0]);
	data[0]=0x1D;
	data[1]=0x01;
	I2C_Write_EX(TCON_I2C, slave_addr, 2, &data[0]);
	data[0]=0x1E;
	data[1]=0x2B;
	I2C_Write_EX(TCON_I2C, slave_addr, 2, &data[0]);
	data[0]=0x1F;
	data[1]=0x0F;
	I2C_Write_EX(TCON_I2C, slave_addr, 2, &data[0]);

	printf("\033[1;33m TCON_I2C PM_IC reg(0x20~0x27) \033[m\n");
	data[0]=0x20;
	data[1]=0x70;
	I2C_Write_EX(TCON_I2C, slave_addr, 2, &data[0]);
	data[0]=0x21;
	data[1]=0xC0;
	I2C_Write_EX(TCON_I2C, slave_addr, 2, &data[0]);
	data[0]=0x22;
	data[1]=0x00;
	I2C_Write_EX(TCON_I2C, slave_addr, 2, &data[0]);
	data[0]=0x23;
	data[1]=0x00;
	I2C_Write_EX(TCON_I2C, slave_addr, 2, &data[0]);
	data[0]=0x24;
	data[1]=0x14;
	I2C_Write_EX(TCON_I2C, slave_addr, 2, &data[0]);
	data[0]=0x25;
	data[1]=0x1A;
	I2C_Write_EX(TCON_I2C, slave_addr, 2, &data[0]);
	data[0]=0x26;
	data[1]=0x11;
	I2C_Write_EX(TCON_I2C, slave_addr, 2, &data[0]);
	data[0]=0x27;
	data[1]=0xA1;
	I2C_Write_EX(TCON_I2C, slave_addr, 2, &data[0]);
#endif

#ifdef CONFIG_SYS_GDMA_SUPPORT
	GDMA_PICTURE_OBJECT *picObj;
	PICTURE_LAYERS_OBJECT pic_layer;
	VO_OSD_COLOR_FORMAT format =  VO_OSD_COLOR_FORMAT_RGB888_LITTLE;

	static unsigned int daddr=0;

	if(logo_ddr_address != 0)
		daddr = logo_ddr_address;
	if(!(rtd_inl(SYS_REG_SYS_DISPCLKSEL_reg) & SYS_REG_SYS_DISPCLKSEL_clken_disp_gdma(1))) {
		printf("[GDMA] %s wait dclk..display later.\n", __func__);
		return -1;
	}
	if(rtd_inl(GDMA_OSD1_WI_reg)) {
		printf("[GDMA] %s display twice , skip.\n", __func__);
		return -1;
	}
	if(daddr == 0) {
		printf("[GDMA] %s display addr=0 , skip.\n", __func__);
		return -1;
	}
#if 0
	while(1){
		if(rtd_inl(SYS_REG_SYS_DISPCLKSEL_reg) & SYS_REG_SYS_DISPCLKSEL_clken_disp_gdma(1)) {
			printf("[GDMA] %s , delay %d ms\n", __func__, 10*cnt);
			break;
		}
		mdelay(10);
		cnt++;
		if(cnt >500) {
			printf("[GDMA] %s FAIL!!, delay %d ms\n", __func__, 10*500);
			return 0;
		}
	}
#endif
		printf("[2k trace code] %s, %s, %d\n", __FILE__, __FUNCTION__, __LINE__);
       if(boot_panel_type == P_LVDS_2K1K){
           BootLogo_Width = BOOTLOGO_HD_WIDTH;
           BootLogo_Hegth = BOOTLOGO_HD_HEIGHT;
       }
       printf("\033[1;33m BootLogo_Width=%d,BootLogo_Hegth=%d\033[m\n", BootLogo_Width, BootLogo_Hegth);
	GDMA_init_module(daddr + BootLogo_Width*BootLogo_Hegth*BOOTLOGO_BYTE_PER_PIXEL);
	memset(&pic_layer, 0, sizeof(PICTURE_LAYERS_OBJECT));
	picObj = &pic_layer.layer[0].normal[0];
	pic_layer.layer_num = 1;
	pic_layer.layer[0].normal_num = 1;
	pic_layer.layer[0].onlineOrder = C0;
	picObj->src_type = SRC_NORMAL;
	picObj->format = format;
	picObj->context = 0;
	picObj->key_en = 0;
	picObj->colorkey = -1;
	picObj->alpha = 0;
	picObj->x = 0;
	picObj->y = 0;
	picObj->width = BootLogo_Width;
	picObj->height = BootLogo_Hegth;
	picObj->address = daddr;//logo_ddr_address;
	picObj->pitch = BootLogo_Width * BOOTLOGO_BYTE_PER_PIXEL;
	picObj->compressed = 0;
	picObj->plane = VO_GRAPHIC_OSD1;
	picObj->dst_x = 0;
	picObj->dst_y = 0;
	picObj->dst_width = 0;
 	picObj->dst_height = 0;
	picObj->layer_used = 1;
	picObj->plane_ar.plane_alpha_a = 0xff;
	picObj->plane_ar.plane_alpha_r = 0xff;
	picObj->plane_gb.plane_alpha_g = 0xff;
	picObj->plane_gb.plane_alpha_b = 0xff;
	picObj->clear_x.value = 0;
	picObj->clear_y.value = 0;
	picObj->show = 1;
	picObj->rgb_order = VO_OSD_COLOR_RGB;
	picObj->syncInfo.syncstamp = 0;
	picObj->scale_factor = 1;
	GDMA_ReceivePicture(&pic_layer);
#endif
	return 0;
}

