#include <qc_verify_common.h>
#include <I_Domain_qc.h>
#include "../../common/cmd_burn_otp.h"


#define YPP_480I  0
#define YPP_1080I 1
#define YPP_1080P 2
#define Thremal_testing 2   //0:480I   1:1080I  2:1080P		//Clayton 5/23: Choose 1080p for critical test

#define YPP_480I_SET  1		// 0:disable, 1:enable 
#define YPP_1080P_SET  0  // 0:disable, 1:enable



/////////////// AWB           ////////////////////////

/*************For modify area*********************/

UINT8   UpdateThres=3;
UINT8   AlignPoint=4;
UINT8   GAIN_SLICE=3;
UINT8   CODE_SLICE=9;
UINT16 SAWB_GetTARGET[2][3]={{325,320,330},   //YPP target
	                                              {300,298,315}}; //SCART target
//signed short AWB_ADC_Gain_Slice[6]={	0x40,0x80,0xc0,0x120,0x1a0} ;     
UINT16 AWB_ADC_Gain_Slice[2][9]={{0x1,0x20,0x40,0x80,0xC0,0x100,0x160,0x1C0,0x1ff},//  YPP 9 slice gain at  1,32,64,128,196,256,352,448,511 point
								  {0x1,0x20,0x40,0x80,0xC0,0x100,0x160,0x1C0,0x1ff}  //  SCART 9 slice gain at  1,32,64,128,196,256,352,448,511 point
								  };
extern unsigned int rtd_part_inl(unsigned int addr, unsigned int B, unsigned int C);
extern void rtd_part_outl(unsigned int addr, unsigned int B, unsigned int C, unsigned int D);
/*************Static Area  ***********************/

UINT16 CURRENT_DIFF[3]={0,0,0};
signed short FINAL_GAIN[3]={0,0,0};
#if 1
UINT16 ADC_Calib[3][9] = {
	{0,0,0,0,0,0,0,0,0},  //R
	{0,0,0,0,0,0,0,0,0},  //G
	{0,0,0,0,0,0,0,0,0}   //B
	};
#else //IC5 3.3V table
UINT16 ADC_Calib[3][9] = {
	{640,603,570,512,466,427,377,339,318},  //R
	{626,590,556,501,455,417,369,333,311},  //G
	{633,599,564,509,464,424,377,340,319}   //B
	};
#endif
/*
signed short AWB_ADC_Gain_Slice[5]={	0x60,0xa0,0xe0,0x140,0x1a0} ;     //  5 slice gain at  96,160,224,320,416 point
UINT16 ADC_Calib[3][5] = {
	{500, 453, 414, 367, 328},  //R
	{519, 469,428,377,337},  //G
	{533,482,439,387,348}   //B
	};
*/	









/////////////////////////////////////////////////
///////                 For NIKE TX Test             ///////////
/////////////////////////////////////////////////

BOOL YPP_RX_CheckStable(UINT8 SourceType)
{

	UINT32 On_Vsync_total;
	UINT32 Off_Vsync_total;
	UINT32 Off_Vsync;
	int i;
	int imd_error=0;


	printk("YPP_RX_CheckStable source type=%x \n",SourceType);	
	switch(SourceType)
		{
		case YPP_480I:
		#include "adc_ypp480i.tbl"
			udelay(200000);
		#include "apll_ypp480i.tbl"                        // APLL for YPbPr480i source
			udelay(200000);
		#include "sp_480i.tbl" 
			udelay(200000);
		#include "vgip_ch1_ipg_480i.tbl"
			// Enable Online measure
		break;
		case YPP_1080P:
		case YPP_1080I:
			break;
		default:
			break;
		}
		rtd_outl(0xb8021100, 0x00050600);	// Enable Offline measure			
		rtd_outl(0xb8021200, 0x00000600);	// Enable Online measure


	#if 1
////////////////Off line measure/////////////////

	for(i=0;i<3;i++)
	{
	rtd_outl(0xb8021100, 0x00050600);	// Status read of Offline measure		
	udelay(5000);	
	rtd_outl(0xb8021100, 0x00051600);	// Status read of Offline measure

	Off_Vsync_total = rtd_inl(0xb8021104);
	printk("Offline Measure Result :0x%x \n", Off_Vsync_total);

	Off_Vsync = (Off_Vsync_total&0x7ffc0000)>>18;

	switch(SourceType)
		{
		case YPP_480I:
			if((Off_Vsync>=0x104)&&(Off_Vsync<=0x107))
				{		
				printk("Offline Measure Vsync Count total = %x \n",Off_Vsync);
				printk("Timing = 480i \n");
				imd_error |=0;
				}
			else if(i==2)
				{
				printk("Offline Measure Vsync Count total fail resoult=0x%x \n",Off_Vsync);
				imd_error |= 1;
				return 1;
				}
			break;
		case YPP_1080I:
		case YPP_1080P:
			break;
			default:
				break;
		}
	}

	udelay(200000);	
////////////////On line measure/////////////////
	for(i=0;i<3;i++){
	rtd_outl(0xb8021200, 0x00000600);	// Status read of Online measure			
	udelay(5000);	
	rtd_outl(0xb8021200, 0x00001600);	// Status read of Online measure	
	On_Vsync_total = rtd_inl(0xb8021204);
	printk("Online Measure Result :0x%x \n", On_Vsync_total);

	On_Vsync_total = (On_Vsync_total&0x7ffC0000)>>18;
	switch(SourceType)
		{
		case YPP_480I:
			if((Off_Vsync>=0x104)&&(Off_Vsync<=0x107))
				{		
				printk("Offline Measure Vsync Count total = %x \n",Off_Vsync);
				printk("Timing = 480i \n");
				imd_error |=0;
				}
			else if(i==2)
				{		
				printk("Offline Measure Vsync Count total fail resoult=0x%x \n",Off_Vsync);
				imd_error |= 1;
				return 1;
				}
			break;
		case YPP_1080I:
		case YPP_1080P:
			break;
			default:
				break;
		}
	}
	#endif
	
	if(imd_error==0)
	return 0;
else 
	return 1;
}

// Mac5p QC test
BOOL IMD_Tst(VOID)			        
{
	UINT32 updn_r_result;
	UINT32 updn_g_result;
	UINT32 updn_b_result;	
	UINT32 sync_type=0;
	UINT32 On_Vsync_total;
	UINT32 Off_Vsync_total;
	UINT32 Off_Vsync;
	UINT32 Off_HSPeriod;	// Clayton for debug use
	UINT32 pe_measure;	// Clayton for debug use
	
	int i;
	int imd_error=0;


 printk("IMD process 4 VGA path & data \n");


#include "./Merlin6/adc_VGA.tbl"


udelay(20000);


#include "./Merlin6/sp_VGA.tbl" 


#include "./Merlin6/apll_800600.tbl"                        // VGA 800*600


udelay(20000);


	rtd_outl(0xb8021070,0x3);
	udelay(100000);
	printk("0xb8000804= 0x%x \n",rtd_inl(0xb8000804));
	if((rtd_inl(0xb8021070)&0x3)==0x3)  //true: ready, false: not ready
	{
		printk("HS VS pad is  OK \n");
		
		while((rtd_inl(0xb8021004)&0x80000000)!=0x80000000)   //SP1_AutoRst
				{
				for (i=0; i<255; i++)	// for delay
					i = i;
				}
		sync_type = rtd_inl(0xb8021004)&0x00000070;
		sync_type = sync_type>>4;

		if (sync_type == 6)
		{
			printk("sync type is separate\n");
			//return 1;
		}
		else
		{
			printk("sync type is fail\n");
			return 1;
		}


	}
	else
	{
	printk("0xb8021070= 0x%x \n",rtd_inl(0xb8021070));
		printk("VS pad is fail \n");
	return 1;
	}


printk("IMD process 6  YPP\n");


//Turn off Panel_VCC for 2K VBY1toHDMI BD 
rtd_outl(0x18061104, 0x08000001); 	// ST_GPIO_57 panel power control
rtd_outl(0x1806110c, 0x08000000); 	// ST_GPIO_57 panel power control

 
///*  MASK wait for script file finish
#if YPP_480I_SET
#include "./Merlin6/adc_ypp480i.tbl"
#endif

#if YPP_1080P_SET
//#include "DDR_Setting_B31CN_432.tbl" //20150415 For MAG2
#include "./Merlin6/ypp_adc_1080p.tbl"	
#endif

udelay(2500);
#if YPP_480I_SET
#include "./Merlin6/apll_ypp480i.tbl"                                // APLL for YPbPr480i source
#endif

#if YPP_1080P_SET
#include "./Merlin6/apll_ypp1080p.tbl"	
#endif



///*  MASK wait for script file finish
#if YPP_480I_SET			
#include "./Merlin6/sp_updn_ypp480i.tbl" 	
#endif

#if YPP_1080P_SET
#include "./Merlin6/sp_updn_ypp1080p.tbl"
#endif






udelay(20000);	


// Enable Offline measure
rtd_outl(0xb8021100, 0x00050600);	// Enable Offline measure

udelay(100000);
udelay(100000);


rtd_outl(0xb8021100, 0x00051600);	// pop Offline measure

udelay(100000);
udelay(100000);



printk("0xb8021100= 0x%x \n",rtd_inl(0xb8021100));

udelay(100000);
udelay(100000);

printk("0xb8021104= 0x%x \n",rtd_inl(0xb8021104));

	// debug use
	
	// [start]
	Off_HSPeriod = rtd_inl(0xb8021108);
	printk("Test Off_HSPeriod :0x%x \n", Off_HSPeriod);

	


rtd_outl(0xb8020018, 0x009f0000);	// ADC DC Restore off

udelay(100000);
udelay(100000);

rtd_outl(0xb8020134, 0x00008000);	// enable max phase error measure

udelay(100000);
udelay(100000);

	pe_measure = rtd_inl(0xb8020134);	// measure Max PE
	printk("Test pe_measure :0x%x \n", pe_measure);

	
                          
#include "./Merlin6/vgip_ch1_ypp_480i.tbl"          /             

rtd_outl(0xb8000208, 0x00000074);		// D-Domain, SFG Clock Enable
rtd_outl(0xb8000230, 0x00211010);		// [22:20]:osd_f2p/4, [18:16]:osd_f1p/2, [14:12]:s2_f2p=/2, [10:8]:s2_f1p, [6:4]:s1_f2p=/2, [2:0]:s1_f1p
rtd_outl(0xb8000234, 0x00100111);		// [22:20]:s2_f2p_div2(mPlus)/2, [18:16]:mc/1, [14:12]:mc_ippre2x/1, [10:8]:mc_ippre/2, [6:4]:memc_out/2, [2:0]:memc_in/2
rtd_outl(0xb802811C, 0x00000001);	 // gating apply

#include "./Merlin6/dpll_594MHz.tbl"    			
#include "./Merlin6/dpg_uhd.tbl"                                               
#include "./Merlin6/dtg_uhd_frc.tbl"				
#include "./Merlin6/vby1_uhd_60hz_8lane_8b_to_LVDS.tbl"	
#include "./Merlin6/Merlin6_B22_QA.tbl"	

rtd_outl(0x18061100, 0x00000021); 	// ST_GPIO_04 LG panel_ctl
rtd_outl(0x18061108, 0x00000021); 	// ST_GPIO_04 LG panel_ctl     


rtd_outl(0x1802d964, 0x00000003); 	// no pixel shift   

//Turn on RP 30 ohm for OLT test 
rtd_outl(0xb8000D04, 0x44001006);	// Lane0 : CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.5V, IEM_SEL(6),
rtd_outl(0xb8000D14, 0x44001006);	// Lane1 : CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.5V, IEM_SEL(6),
rtd_outl(0xb8000D24, 0x44001006);	// Lane2 : CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.5V, IEM_SEL(6),
rtd_outl(0xb8000D34, 0x44001006);	// Lane3 : CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.5V, IEM_SEL(6),
rtd_outl(0xb8000D44, 0x44001006);	// Lane4 : CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.5V, IEM_SEL(6),
rtd_outl(0xb8000D54, 0x44001006);	// Lane5 : CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.5V, IEM_SEL(6),
rtd_outl(0xb8000D64, 0x44001006);	// Lane6 : CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.5V, IEM_SEL(6),
rtd_outl(0xb8000D74, 0x44001006);	// Lane7 : CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.5V, IEM_SEL(6),
rtd_outl(0xb8000D84, 0x44001006);	// Lane8 : CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.5V, IEM_SEL(6),
rtd_outl(0xb8000D94, 0x44001006);	// Lane9 : CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.5V, IEM_SEL(6),
rtd_outl(0xb8000DA4, 0x44001006);	// Lane10: CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.5V, IEM_SEL(6),
rtd_outl(0xb8000DB4, 0x44001006);	// Lane11: CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.5V, IEM_SEL(6),
rtd_outl(0xb8000DC4, 0x44001006);	// Lane12: CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.5V, IEM_SEL(6),
rtd_outl(0xb8000DD4, 0x44001006);	// Lane13: CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.5V, IEM_SEL(6),
rtd_outl(0xb8000DE4, 0x44001006);	// Lane14: CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.5V, IEM_SEL(6),
rtd_outl(0xb8000DF4, 0x44001006);	// Lane15: CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.5V, IEM_SEL(6),
//

//Turn on all PIF lane  for OLT test 

rtd_outl(0xb802DC9C, 0x13200000);	// Lane 7~0 pair assign,  2K using lane2~lane14 for LSphy
rtd_outl(0xb802DCA0, 0x00001320);	// Lane 15~8 pair assign,  2K using lane2~lane14 for LSphy

rtd_outl(0xb8000D00, 0x66002815);	// Lane0 : Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
rtd_outl(0xb8000D10, 0x66002815);	// Lane1 : Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
rtd_outl(0xb8000D20, 0x66002815);	// Lane2 : Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
rtd_outl(0xb8000D30, 0x66002815);	// Lane3 : Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
rtd_outl(0xb8000D40, 0x66002815);	// Lane4 : HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
rtd_outl(0xb8000D50, 0x66002815);	// Lane5 : HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
rtd_outl(0xb8000D60, 0x66002815);	// Lane6 : HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
rtd_outl(0xb8000D70, 0x66002815);	// Lane7 : HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
rtd_outl(0xb8000D80, 0x66002815);	// Lane8 : HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
rtd_outl(0xb8000D90, 0x66002815);	// Lane9 : HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
rtd_outl(0xb8000DA0, 0x66002815);	// Lane10: HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
rtd_outl(0xb8000DB0, 0x66002815);	// Lane11: HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
rtd_outl(0xb8000DC0, 0x66002815);	// Lane12: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
rtd_outl(0xb8000DD0, 0x66002815);	// Lane13: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
rtd_outl(0xb8000DE0, 0x66002815);	// Lane14: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
rtd_outl(0xb8000DF0, 0x66002815);	// Lane15: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),



	
/*
	// ABL status read
	udelay(10000);
	abl_result = rtd_inl(0xb8020208);
	for (i=15000; i>0; i--)
	{   
		if (abl_result == 0x80000007)   // Sirius ABL as same as 55 , 0xb8020208[31] Measure Error Flag Reset: 1, 0xb8020208[2:0] R/Pr & G/Y & B/Pb Channel ABL Result is equal: 1
		{ 
			printk("ABL adjust Pass, count= %d\n", 15000-i);
			i = 0;			//i=0, for loop end
			imd_error = 0;
		} 
		else
		{
		abl_result = rtd_inl(0xb8020208);
		}
		udelay(1000);
	}
	
	if (abl_result != 0x80000007)	// Sirius ABL as same as 55
	{
		printk("ABL adjust Fail abl_result=0x%x \n",abl_result);
		imd_error = 1;
		return 1;
	}
*/




// UpDn status read
	udelay(10000);
	updn_r_result = rtd_inl(0xb8021090);
	updn_g_result = rtd_inl(0xb80210A0);
	updn_b_result = rtd_inl(0xb80210B0);

	printk("Rch UpDn Clamp Result :0x%x \n", updn_r_result);
	printk("Gch UpDn Clamp Result :0x%x \n", updn_g_result);
	printk("Bch UpDn Clamp Result :0x%x \n", updn_b_result);
	
/*
	for (i=5000; i>0; i--)
	{   
		if (((updn_r_result&0x80000) == 0x80000) && ((updn_g_result&0x80000) == 0x80000) && ((updn_b_result&0x80000) == 0x80000) )     
		{ 
			printk("UpDn Clamp adjust Pass, count= %d\n", 15000-i);
			i = 0;			//i=0, for loop end
			imd_error = 0;
		} 
		else
		{
		
	            updn_r_result = rtd_inl(0xb8021090);
	            updn_g_result = rtd_inl(0xb80210A0);
	            updn_b_result = rtd_inl(0xb80210B0);

		}
		udelay(1000);
	}
	
	
	if (((updn_r_result&0x80000) != 0x80000) || ((updn_g_result&0x80000) != 0x80000) || ((updn_b_result&0x80000) != 0x80000) )    
	{
		printk("UpDn Clamp  adjust Fail \n");
		imd_error = 1;
		return 1;
	}

 */



#if YPP_480I_SET

printk("Finish APLL & SP setting\n");
// Measure read
udelay(100000);
////////////////Off line measure/////////////////

	for(i=0;i<3;i++)	//debug: loop 10 times / Normal: loop 3 times
	{
	//printk("0xb8000104= 0x%x \n",rtd_inl(0xb8000104));
	//printk("0xb8000114= 0x%x \n",rtd_inl(0xb8000114));
	udelay(1000);	
	//printk("Clayton1 Check APLL setting; 0xb8020100= 0x%x \n",rtd_inl(0xb8020100));
	//printk("Clayton Check Icode=0x%x ; Pcode=0x%x; \n",rtd_inl(0xb8020128),rtd_inl(0xb802012c));
	rtd_outl(0xb8021100, 0x00210600);	// Normal: 0x00010600 ; Debug: 0x00050600
	//printk("Clayton:use input clock; 0xb8021100= 0x%x \n",rtd_inl(0xb8021100));
	udelay(50000);	//after enable offline measure, it needs 1~2 frames to check lines
	rtd_outl(0xb8021100, 0x00211600);	// popup, Normal: 0x00011600 ; Debug: 0x00051600
	//printk(" Clayton:use input clock; 0xb8021100= 0x%x \n",rtd_inl(0xb8021100));
	udelay(1000);
	Off_Vsync_total = rtd_inl(0xb8021104);	//0xb8021104[30:18]: Input VSYNC Period Measurement Result
	printk("Offline Measure Result :0x%x \n", Off_Vsync_total);

	// debug use
	// [start]
	/*
	Off_HSPeriod = rtd_inl(0xb8021108);
	printk("Off_HSPeriod :0x%x \n", Off_HSPeriod);

	
	rtd_outl(0xb8020138, 0x00008000);	// enable max phase error measure
	udelay(100);
	rtd_outl(0xb8020138, 0x0000C000);	// enable max phase error measure
	udelay(100);
	max_pe_measure = rtd_inl(0xb8020138);	// measure Max PE
	printk("max_pe_measure :0x%x \n", max_pe_measure);
	*/
	// [end]
	//
	
	//Off_Vsync = (Off_Vsync_total&0x7ffc0000)>>18; //0xb8021104[30:18]: Input VSYNC Period Measurement Result
	Off_Vsync = Off_Vsync_total&0x00001fff; //0xb8021104[12:0]: Input VSYNC Period Measurement Result , For MAG2

	if (Off_Vsync == 0x105)
	{
		printk("Offline Measure Vsync Count total = 261 \n");
		printk("Timing = 480i \n");
		imd_error |=0;
		break;
	}
	else if (Off_Vsync == 0x106)
	{
		printk("Offline Measure Vsync Count total = 262 \n");
		printk("Timing = 480i \n");
		imd_error |=0;
				break;
	}
	else if (Off_Vsync == 0x104)
	{
		printk("Offline Measure Vsync Count total = 260 \n");
		printk("Timing = 480i \n");
		imd_error |=0;
				break;
	}
	else if (Off_Vsync == 0x107)
	{
		printk("Offline Measure Vsync Count total = 263 \n");
		printk("Timing = 480i \n");
		imd_error |=0;
				break;
	}
	else if(i==2)
		{	
			printk("Offline Measure Vsync Count total fail resoult=0x%x \n",Off_Vsync);
			imd_error |= 1;
			return 1;
				}


		}


udelay(25000);	


rtd_outl(0xb8022210, 0x90050001); //VGIP select ADC, 0xb8022210[30:28]=001:ADC/VGA (including Pattern Generator)(12bit)



////////////////On line measure/////////////////
	for(i=0;i<3;i++){

	udelay(40000);	
	//rtd_outl(0xb8021200, 0x00000000);
	rtd_outl(0xb8021200, 0x00000000);
	udelay(40000);
	rtd_outl(0xb8021200, 0x00000003);	// Status read of Online measure	
	udelay(50000);	
	rtd_outl(0xb8021200, 0x00000007);	// Status read of Online measure , enable Popup Measure Result
	udelay(15000);
	On_Vsync_total = rtd_inl(0xb8021230);		//0xb8021230[13:0]: Input VSYNC Period Measurement Result
	printk("Online Measure Result :0x%x \n", On_Vsync_total);

	On_Vsync_total = On_Vsync_total&0x00003fff;		// for MAC3 


	if (On_Vsync_total == 0x105)
	{
		printk("Online Measure Vsync Count total = 261 \n");
		printk("Timing = 480i \n");
		imd_error |=0;
		break;
	}
	else	if (On_Vsync_total == 0x104)
	{
		printk("Online Measure Vsync Count total = 260 \n");
		printk("Timing = 480i \n");
		imd_error |=0;
		break;		
	}
		else	if (On_Vsync_total == 0x106)
	{
		printk("Online Measure Vsync Count total = 262 \n");
		printk("Timing = 480i \n");
		imd_error |=0;
		break;		
	}
		else	if (On_Vsync_total == 0x107)
	{
		printk("Online Measure Vsync Count total = 263 \n");
		printk("Timing = 480i \n");
		imd_error |=0;
		break;
	}
	else if(i==2)
		{
		
			printk("Online Measure Vsync Count total fail resoult=0x%x \n",On_Vsync_total);
			imd_error |= 1;
			return 1;
	}
		
		}

#endif		//YPP_480I_SET END

#if YPP_1080P_SET   //Clayton, no modify for Mac5p. Just use 480i to test


// Measure read
udelay(15000);
////////////////Off line measure/////////////////

	for(i=0;i<3;i++)
	{
	//printk("0xb8000104= 0x%x \n",rtd_inl(0xb8000104));
	//printk("0xb8000114= 0x%x \n",rtd_inl(0xb8000114));
	udelay(30000);	
	rtd_outl(0xb8021100, 0x00010600);	// Status read of Offline measure for MAC3
	printk("0xb8021100= 0x%x \n",rtd_inl(0xb8021100));
	udelay(30000);	
	rtd_outl(0xb8021100, 0x00011600);	// popup, Status read of Offline measure for MAC3
	printk("0xb8021100= 0x%x \n",rtd_inl(0xb8021100));
	udelay(250000);
	Off_Vsync_total = rtd_inl(0xb8021104);	//0xb8021104[30:18]: Input VSYNC Period Measurement Result
	printk("Offline Measure Result :0x%x \n", Off_Vsync_total);

	//Off_Vsync = (Off_Vsync_total&0x7ffc0000)>>18; //0xb8021104[30:18]: Input VSYNC Period Measurement Result
	Off_Vsync = Off_Vsync_total&0x00001fff; //0xb8021104[12:0]: Input VSYNC Period Measurement Result , For MAG2

	if (Off_Vsync == 0x465)
	{
		printk("Offline Measure Vsync Count total = 1125 \n");
		printk("Timing = 1080p \n");
		imd_error |=0;
		break;
	}
	else if (Off_Vsync == 0x466)
	{
		printk("Offline Measure Vsync Count total = 1126 \n");
		printk("Timing = 1080p \n");
		imd_error |=0;
				break;
	}
	else if (Off_Vsync == 0x464)
	{
		printk("Offline Measure Vsync Count total = 1124 \n");
		printk("Timing = 1080p \n");
		imd_error |=0;
				break;
	}
	else if (Off_Vsync == 0x467)
	{
		printk("Offline Measure Vsync Count total = 1127 \n");
		printk("Timing = 1080p \n");
		imd_error |=0;
				break;
	}
	else if(i==2)
		{	
			printk("Offline Measure Vsync Count total fail resoult=0x%x \n",Off_Vsync);
			imd_error |= 1;
			return 1;
				}


		}


udelay(25000);	


rtd_outl(0xb8022210, 0x90050001); //VGIP select ADC, 0xb8022210[30:28]=001:ADC/VGA (including Pattern Generator)(12bit)



////////////////On line measure/////////////////
	for(i=0;i<3;i++){

	udelay(40000);	
	//rtd_outl(0xb8021200, 0x00000000);
	rtd_outl(0xb8021200, 0x00000000);	// for MAG2
	udelay(40000);
	rtd_outl(0xb8021200, 0x00000003);	// Status read of Online measure, for MAG2		
	udelay(50000);	
	rtd_outl(0xb8021200, 0x00000007);	// Status read of Online measure , enable Popup Measure Result	, for MAG2
	udelay(15000);
	On_Vsync_total = rtd_inl(0xb8021230);		//0xb8021230[13:0]: Input VSYNC Period Measurement Result for MAG2
	printk("Online Measure Result :0x%x \n", On_Vsync_total);

	On_Vsync_total = On_Vsync_total&0x00003fff;		// for MAC3 

//	printk("%s():line:%d\n",__FUNCTION__,__LINE__);

	if (On_Vsync_total == 0x465)
	{
		printk("Online Measure Vsync Count total = 1125 \n");
		printk("Timing = 1080p \n");
		imd_error |=0;
		break;
	}
	else	if (On_Vsync_total == 0x464)
	{
		printk("Online Measure Vsync Count total = 1124 \n");
		printk("Timing = 1080p \n");
		imd_error |=0;
		break;		
	}
		else	if (On_Vsync_total == 0x466)
	{
		printk("Online Measure Vsync Count total = 1126 \n");
		printk("Timing = 1080p \n");
		imd_error |=0;
		break;		
	}
		else	if (On_Vsync_total == 0x467)
	{
		printk("Online Measure Vsync Count total = 1127 \n");
		printk("Timing = 1080p \n");
		imd_error |=0;
		break;
	}
	else if(i==2)
		{
		
			printk("Online Measure Vsync Count total fail resoult=0x%x \n",On_Vsync_total);
			imd_error |= 1;
			return 1;
	}
		
		}

#endif		//YPP_1080P_SET END











	

//printk("%s():line:%d\n",__FUNCTION__,__LINE__);  debug use

if(imd_error==0)
	return 0;
else 
	return 1;

}




void IPTG_480I(void)
{

//Mac5p portion, Mark for Merlin3, 
/*
// For MAC3  2014.09.02
//...	#include "case8_ipg480i_fs_fhd.tbl"....START
//#include "mag2_crt.tbl"
//printk("Load 480I IPTG 1 \n");
#include "apll_ipg480i.tbl"
printk("Load 480I IPTG 2 \n");
#include "ipg_480i.tbl"
printk("Load 480I IPTG 3 \n");
#include "sp_ipg.tbl"
printk("Load 480I IPTG 4 \n");
#include "vgip_ch1_ipg_480i.tbl"
printk("Load 480I IPTG 5 \n");
#include "bypass_di_uzd_ch1_444_10b.tbl"
printk("Load 480I IPTG 6 \n");
#include "m_ch1_frc_to_fs.tbl"		//LVDS panel
printk("Load 480I IPTG 7 \n");
#include "uzu_main_444_480i_to_fhd.tbl"
printk("Load 480I IPTG 8 \n");
#include "dtg_fhd.tbl"
printk("Load 480I IPTG 9 \n");
#include "mtg_fhd.tbl"
printk("Load 480I IPTG 10 \n");
#include "dpll_fhd.tbl"
printk("Load 480I IPTG 11 \n");
#include "LVDS_FHD_1Pixel_1Seg_2Port.tbl"
printk("Load 480I IPTG 12 \n");
*/

//Clayton 6/15: Use case15_ipg480i_frc_fhd============
#include "apll_ipg480i.tbl"
printk("Load 480I IPTG 2 \n");
#include "ipg_480i.tbl"
printk("Load 480I IPTG 3 \n");
#include "sp_ipg_480i.tbl"
printk("Load 480I IPTG 4 \n");
#include "vgip_ch1_ipg_480i.tbl"
printk("Load 480I IPTG 5 \n");
#include "uzd_bypass_di_480i.tbl"
printk("Load 480I IPTG 6 \n");
#include "m_ch1_frc_480i10b444.tbl"
printk("Load 480I IPTG 7 \n");
rtd_outl(0xb8000208, 0x00004074);		// D-Domain, SFG, MEMC_IN/OUT Clock Enable
rtd_outl(0xb8028100, 0x00050000);		// Bypass MEMC
#include "dpll_594MHz.tbl"
printk("Load 480I IPTG 8 \n");
rtd_maskl(0xb80006C8, 0x7FFFFFFF, 0x80000000);	// DPLL use HS APHY
#include "uzu_main_444_480i_to_uhd.tbl"
printk("Load 480I IPTG 9 \n");
#include "dtg_uhd_frc.tbl"
printk("Load 480I IPTG 10 \n");
#include "vby1_uhd_60hz_8lane_10b.tbl"
printk("Load 480I IPTG 11 \n");
//#include "./d_domain/pif/vby1_uhd_60hz_8lane_10b_to_LVDS.tbl"
#include "Merlin3_B27_QA.tbl"
printk("Load 480I IPTG 12 \n");
//============

//...	#include "case8_ipg480i_fs_fhd.tbl"....END
	
//#include "ddr_init.tbl"

//--

/*-------------------------------------------------------------------------------Sirius Mark Script
#include "case8_ypbpr480i_fs_fhd/apll_ipg480i.tbl"
		udelay(50);
#include "case8_ypbpr480i_fs_fhd/ipg_480i_QC.tbl"
		udelay(50);
#include "case8_ypbpr480i_fs_fhd/sp_ipg.tbl"
		udelay(50);
#include "case8_ypbpr480i_fs_fhd/vgip_ch1_ipg_480i.tbl"
		udelay(50);
#include "case8_ypbpr480i_fs_fhd/m_ch1_frc_1080i10b444.tbl"	//????
		udelay(50);
#include "case8_ypbpr480i_fs_fhd/uzu_main_444_bypass480i.tbl"
		udelay(50);
#include "case8_ypbpr480i_fs_fhd/DPLL_297MHz.tbl"
		udelay(50);
#include "case8_ypbpr480i_fs_fhd/dtg_fhd_fs.tbl"
		udelay(50);
#include "case8_ypbpr480i_fs_fhd/mtg_fhd.tbl"
		udelay(50);
#include "case8_ypbpr480i_fs_fhd/ivs2dvs_480i_fhd.tbl"		// ivs2dvs delay for ipg1080p to FHD
		udelay(50);
#include "case8_ypbpr480i_fs_fhd/m_ch1_frc_to_fs.tbl"		// mdomain change to fs mode
		udelay(50);
#include "case8_ypbpr480i_fs_fhd/LVDS_FHD_1Seg_2Port.tbl"	// SFG, PIF, TX_PHY
*/  //------------------------------------------------------------------------------------------Sirius Mark Script


//rtd_outl(0xb800DB40, 0x02800202);	//HDMI Bandgap Enable
rtd_outl(0xb802a700, 0x00000040);	//YUV2RGB conversion Disable

}


BOOL IP_ABL_Verify(void)
{

UINT16  Hsync_Delay=3;	//default=3
UINT16  Hact_start=0;
//UINT16  Vstart=0,Vact_start=0;
UINT8    reg_conut=0,TestCase=10;

UINT16 R_code,G_code,B_code;	
UINT32 ABL_Hstart,temp,temp1=0,temp2,i;
//UINT32 j;	//Clayton, debug use.
bool     Fl_pass=1;
printk("IP_ABL_Verify \n");

              //Hstart=rtd_inl(REG_PTG_H_STA_WID)>>16;   // Horizontal active start = 16, active width = 842
			  //printk("REG_PTG_H_STA_WID= 0x%x \n",rtd_inl(REG_PTG_H_STA_WID));
              Hact_start=rtd_inl(REG_PTG_HSTA_WID)>>16;   // Pattern Gen display Hstart & Hactive =704 eݯd16 piexels ΨӧP_porch 
              printk("REG_PTG_HSTA_WID= 0x%x \n",rtd_inl(REG_PTG_HSTA_WID));
              //Vstart=rtd_inl(REG_PTG_V_STA_LEN)>>16;   // Horizontal active start = 16, active width = 842
              //printk("REG_PTG_V_STA_LEN= 0x%x \n",rtd_inl(REG_PTG_V_STA_LEN));
              //Vact_start=rtd_inl(REG_PTG_VSTA_LEN)>>16;   // Pattern Gen display Hstart & Hactive =704 eݯd16 piexels ΨӧP_porch 
              //printk("REG_PTG_VSTA_LEN= 0x%x \n",rtd_inl(REG_PTG_VSTA_LEN));

	// abl setup (abl.tbl)
	  	ABL_Hstart=Hact_start-Hsync_Delay-4; // init H window width=4, Hact_start = 128 (default)
	  	  printk("ABL_Hstart=0x%x ; Hsync_Delay=%d\n",ABL_Hstart, Hsync_Delay);	


for (reg_conut=0;reg_conut<TestCase;reg_conut++)	  	
{
		rtd_outl(REG_PTG_TG, 0x40000003);   // Enable timing generator, select Seperate CS
		rtd_outl(REG_PTG_TOTALHV, 0x035a0106);   // Total pixel = 858*262
		rtd_outl(REG_PTG_H_STA_WID, 0x0010034a);   // Horizontal active start = 16, active width = 842
		rtd_outl(REG_PTG_V_STA_LEN, 0x00050101);   // Vertical active start = 5, active width = 257
		rtd_outl(REG_PTG_HSTA_WID, 0x009102c0);   // Pattern Gen display Hstart & Hactive =704 eݯd16 piexels ΨӧP_porch 
		rtd_outl(REG_PTG_VSTA_LEN, 0x001000f0);   // Pattern Gen display Vstart & Vactive
		rtd_outl(REG_PTG_CTRL, 0x00000003);   // PTG control, select pattern = Vertical Color Bar 
		rtd_outl(REG_PTG_BARW, 0x00000059);   // Color bar width  =59
		rtd_outl(REG_PTG_C0Y, 0x00ffffff);   // active region color 
		//printk("REG_PTG_C1Y= 0x%x \n",rtd_inl(REG_PTG_C1Y));
		rtd_outl(REG_PTG_C2Y, 0x00010101);   // porch region color 101=5           10 bit color=5
		rtd_outl(REG_PTG_MAX_COLOR_CTRL, 0x00000fff);   // color set (copy from defualt value) 1 coloe
		rtd_outl(REG_PTG_TG, 0x40000003);   // Enable timing generator, ?? 0x4000003 miss a zero, it should be 0x40000003.
		udelay(10000);
		rtd_outl(REG_ABL_WINDOW, (0x07818300|(ABL_Hstart/3)));  // 1/3 porch, REG_ABL_WINDOW=0x0781832A
		//printk("1.REG_ABL_WINDOW= 0x%x \n",rtd_inl(REG_ABL_WINDOW));
		rtd_outl(REG_ABL_STATUS, 0x80000000);
		printk("REG_ABL_STATUS= 0x%x \n",rtd_inl(REG_ABL_STATUS));  // check reset ? 2014.09.03
		//rtd_outl(REG_ABL_CTRL, 0x808a0100);
		rtd_outl(REG_ABL_CTRL, 0x008a0100);		// disable abl before switch online/offline mode , For MAC3 2014.09.02
		rtd_outl(REG_ABL_CTRL, 0x808a0100);		// enable abl , For MAC3 2014.09.02
		rtd_outl(REG_ABL_MGN_RG, 0x00440044);	// For red, equal Margin =0, large error Margin=4 , lock Margin = 4 ,
												// Fo green, equal Margin =0, large error Margin=4 , lock Margin = 4 ,
		rtd_outl(REG_ABL_MGN_B, 0x00000044);	// Fo blue, equal Margin =0, large error Margin=4 , lock Margin = 4 ,

		udelay(10000);
		
	switch(reg_conut)		
	{
		case 0://  min/avg  measure meathod 
				rtd_outl(REG_ABL_WINDOW, (0x07818300|(ABL_Hstart+2)));  // window cross porch & active, REG_ABL_WINDOW=0x07818382
				//printk("2.REG_ABL_WINDOW = 0x%x \n",rtd_inl(REG_ABL_WINDOW));
				udelay(100000);
				R_code=rtd_inl(REG_ABL_RSLT0)>>16;
				G_code=rtd_inl(REG_ABL_RSLT0)&(0x0000ffff);
				B_code=rtd_inl(REG_ABL_RSLT1)&(0x0000ffff);
				//printk("R_code = 0x%x \n",R_code);
				//printk("G_code = 0x%x \n",G_code);
				//printk("B_code = 0x%x \n",B_code);
		              if( (R_code==0x202)&&(G_code==0x202) &&(B_code==0x202) ) //measure  AVG,  
		              	{
							rtd_outl(REG_ABL_CTRL, rtd_inl(REG_ABL_CTRL)|_BIT25);	//set Measure Pixels Method:Minimum value
							//printk("0xb8020200= 0x%x \n",rtd_inl(0xb8020200));
							udelay(10000);
							R_code=rtd_inl(REG_ABL_RSLT0)>>16;
							G_code=rtd_inl(REG_ABL_RSLT0)&(0x0000ffff);
							B_code=rtd_inl(REG_ABL_RSLT1)&(0x0000ffff);


							//printk("R_code = 0x%x \n",R_code);
							//printk("G_code = 0x%x \n",G_code);
							//printk("B_code = 0x%x \n",B_code);
							
					              if( (R_code==0x5)&&(G_code==0x5)&&(B_code==0x5) )  //measure  min					
		            				printk("IP_ABL,avg/min  measure PASS!! \n");	
								  else
									{
									printk("IP_ABL,avg measure fail 1 R=0x%x,G=0x%x,B=0x%x! \n",R_code,G_code,B_code);		
									Fl_pass=FALSE;
									}
		              	}
						else	  
						{
						printk("IP_ABL,min measure fail 2 R=0x%x,G=0x%x,B=0x%x! \n",R_code,G_code,B_code);	
						Fl_pass=FALSE;
						}
		break;		
		case 1://diff
				R_code=rtd_inl(REG_ABL_NOISE_VAL0)>>16; //diff
				G_code=rtd_inl(REG_ABL_NOISE_VAL0)&(0x0000ffff);//diff
				B_code=rtd_inl(REG_ABL_NOISE_VAL1)&(0x0000ffff);//diff

				if(((R_code+(rtd_inl(REG_ABL_RSLT0)>>16))==8)&&
				    ((G_code+(rtd_inl(REG_ABL_RSLT0)&0x0000ffff))==8)&&
				    ((B_code+(rtd_inl(REG_ABL_RSLT1)&0x0000ffff))==8))
          			printk("IP_ABL,diff  measure PASS!! \n");	
				else
					{
					printk("IP_ABL,diff R=0x%x,G=0x%x,B=0x%x! \n",R_code,G_code,B_code);
					Fl_pass=FALSE;
					}
				
				
		break;
		case 2://target
				rtd_outl(REG_ABL_CTRL, rtd_inl(REG_ABL_CTRL)&(0xfffff000&(0<<8)));
				udelay(20000);	
				R_code=rtd_inl(REG_ABL_RSLT0)>>16;
				G_code=rtd_inl(REG_ABL_RSLT0)&(0x0000ffff);
				B_code=rtd_inl(REG_ABL_RSLT1)&(0x0000ffff);

				for(i=0;i<16;i++)
					{
					rtd_outl(REG_ABL_CTRL, (rtd_inl(REG_ABL_CTRL)&(0xfffff000&(i<<8))));
					udelay(10000);	
				
					if(!(((rtd_inl(REG_ABL_NOISE_VAL0)>>16)==YPP_abs(R_code,4*i))&&
						((rtd_inl(REG_ABL_NOISE_VAL0)&0x0000ffff)==YPP_abs(G_code,4*i))&&
						((rtd_inl(REG_ABL_NOISE_VAL1)&(0x0000ffff))==YPP_abs(B_code,4*i))))
						{
         		 			printk("IP_ABL,target value i=%d fail!! \n",i);	
						Fl_pass=FALSE;
						break;
						}				         		 	
					}
					printk("IP_ABL,target value Pass!! \n");
				
		break;
		
		case 3://vga/ypp mode Pos_Neg pin select
				temp=rtd_inl(REG_ABL_STATUS)&0x00000007;
				if(temp==7)
					{

					rtd_outl(REG_ABL_CTRL, rtd_inl(REG_ABL_CTRL)|(_BIT24));   // set ABL Enable in YPbPr format
					udelay(10000);	
								temp=rtd_inl(REG_ABL_STATUS)&0x00000007; 
								if(temp==2)
									printk("IP_ABL,YPP/VGA mode & Pos_Neg pin select Pass!! \n");
								else
									{
									printk("IP_ABL,YPP/VGA mode & Pos_Neg pin select Fail!! \n");	
									Fl_pass=FALSE;
									}
					}
				else
					{
					printk("IP_ABL,YPP/VGA mode Fail 2!! \n");	
					Fl_pass=FALSE;
					}				
		break;
		case 4://offline & frame	 ABL_EN	, for MAC3 modify by Brandon
				rtd_outl(REG_PTG_C0Y, 0x00101010);   // active region color 
				rtd_outl(REG_ABL_WINDOW, (0x07818300|(ABL_Hstart+1)));  // window cross porch & active
				    for(i=0;i<4;i++)
					{

					rtd_outl(REG_ABL_CTRL, (0x70000100|(i<<20))); //Auto Black Level Enable: disable, off line mode, frame=4
					//printk("1.REG_ABL_CTRL = 0x%x \n",rtd_inl(REG_ABL_CTRL));
					udelay(10000);	
					
					rtd_outl(REG_ADC_OFFSET0, 0x02000200);   //offset to default				
					rtd_outl(REG_ADC_OFFSET1, 0x00000200);   //offset to default	
	
			
					
					udelay(10000);
					rtd_outl(REG_ABL_CTRL, (0xf0000100|(i<<20))); //Auto Black Level Enable: Enable, off line mode, frame=4
					//printk("2.REG_ABL_CTRL = 0x%x \n",rtd_inl(REG_ABL_CTRL));
					udelay(300000);	
					//printk("REG_ADC_OFFSET0 = 0x%x \n",rtd_inl(REG_ADC_OFFSET0));
					//printk("REG_ADC_OFFSET1 = 0x%x \n",rtd_inl(REG_ADC_OFFSET1));
					temp=(rtd_inl(REG_ADC_OFFSET0)&0x0000ffff)-0x200;		//??
					//printk("case 4 temp = 0x%x \n",temp);
					if(!((temp)==((i+4)*(rtd_inl(REG_ABL_NOISE_VAL0)&0x000ffff))))		//??frameq4]7, Ѧ18020200[21:20], 
						{
                        printk("IP_ABL,Offline&frame mode &ABL_EN Fail  i =%d!! \n",i);	
						printk("temp=%d !! \n",temp);	
						printk("result=%d !! \n",(rtd_inl(REG_ABL_NOISE_VAL0)&0x0000ffff));												
						Fl_pass=FALSE;
						break;
						}
					}
				if(Fl_pass!=FALSE)
					printk("IP_ABL,offline&framemode & ABL_EN  PASS !! \n");	
				break;	
									
			
		case 5://Online mode
					
					rtd_outl(REG_ADC_OFFSET0, 0x00800080);   //set offset, Y]wӤj, վdelayɶNV[	// For MAC3		
					rtd_outl(REG_ADC_OFFSET1, 0x00000080);   //set offset, Y]wӤj, վdelayɶNV[	// For MAC3
					//rtd_outl(REG_ABL_CTRL, 0x70800100); //on line mode, frame=4
					//udelay(100000);	
					rtd_outl(REG_ABL_CTRL, 0xf0800100); //on line mode, frame=4
					udelay(10000000);							// Yadc offsettZӦh, hdelay timeɶn[, ثeadc offset set 80Oӱoέp⧹ 
					printk("Case5.REG_ADC_OFFSET0 = 0x%x \n",rtd_inl(REG_ADC_OFFSET0));
					printk("Case5.REG_ADC_OFFSET1 = 0x%x \n",rtd_inl(REG_ADC_OFFSET1));

					R_code=(rtd_inl(REG_ADC_OFFSET0)&0x0000ffff);	
					G_code=(rtd_inl(REG_ADC_OFFSET0)>>16)&0x0000ffff;	
					B_code=rtd_inl(REG_ADC_OFFSET1)&0x0000ffff;	
				
					if((R_code!=0x0)||(G_code!=0x0)||(B_code!=0x0))			// For MAC3  
						{
						printk("IP_ABL,Online mode Fail  !! \n");	
						printk("R_code=%d,G_code=%d,B_code=%d, !! \n",R_code,G_code,B_code);	
						Fl_pass=FALSE;						
						break;
						}
									
					printk("IP_ABL,online mode PASS !! \n");									
			break;
			
		case 6:// Hs leading/trailing
				rtd_outl(REG_ABL_WINDOW, (0x07818300|(ABL_Hstart)));  // window cross porch & active, REG_ABL_WINDOW=0x07818380
				udelay(20000);
				R_code=rtd_inl(REG_ABL_RSLT0)>>16;
				G_code=rtd_inl(REG_ABL_RSLT0)&(0x0000ffff);
				B_code=rtd_inl(REG_ABL_RSLT1)&(0x0000ffff);
		              if( (R_code==5)&&(G_code==5) &&(B_code==5) ) //leading edge
		              	{
							rtd_outl(REG_ABL_CTRL, rtd_inl(REG_ABL_CTRL)|(_BIT16));		//REG_ABL_CTRL[16], H_start Reference Select:1, Trailing edge
							udelay(20000);
					  		R_code=rtd_inl(REG_ABL_RSLT0)>>16;
							G_code=rtd_inl(REG_ABL_RSLT0)&(0x0000ffff);
							B_code=rtd_inl(REG_ABL_RSLT1)&(0x0000ffff);
							udelay(20000);
					              if( (R_code==0x3FF)&&(G_code==0x3FF) &&(B_code==0x3FF) )  //Trailing edge
             		            		printk("IP_ABL, Hsync leading/trailing edge  PASS!! \n");	
							else	
								{
								printk("IP_ABL, Hsync leading/trailing edge  Fail!! R=%d,G=%d,B=%d \n",R_code,G_code,B_code);	
								Fl_pass=FALSE;
								}
		              	}
				  break;
		case 7: //H window	//[Clayton][Fix me] Fail ==>5/9 Fixed and test pass
				rtd_outl(REG_PTG_CTRL, 0x00000004);   // H gradient
				rtd_outl(REG_PTG_C3Y, 0x28282800);   //  neg adj 24
				rtd_outl(REG_PTG_C4Y, 0x0F000000);   // every 8 pixel
				udelay(2000);
				temp=1023;
				for (i=0;i<3;i++)
					{
				rtd_outl(REG_ABL_WINDOW,( (0x07818000|(ABL_Hstart+4))|(i<<8)));  // 4 pixel in front of data, RGE_ABL_WINDOW= 0x07818084~0x07818384, 
																				  //Width of ABL region in each line: 16/32/64/4 pixel
				udelay(20000);
				R_code=rtd_inl(REG_ABL_RSLT0)>>16;
				G_code=rtd_inl(REG_ABL_RSLT0)&(0x0000ffff);
				B_code=rtd_inl(REG_ABL_RSLT1)&(0x0000ffff);	
				
				temp=temp-12*i;
		              if( !((R_code==temp)&&(G_code==temp) &&(B_code==temp) ))
		              	{
					printk("IP_ABL, H window  Fail!! R=%d,G=%d,B=%d \n",R_code,G_code,B_code);
					Fl_pass=FALSE;
					  break;

		              	}
					  
				}
					
				/* MAC2 only, MAC3 doesn't verify !,Mag2 add back */
				temp=0x3ff;
				for (i=0;i<3;i++)
					{
				// [Clayton] Mac5p fine tune: ABL address from ((ABL_Hstart+7)/2) -> (((ABL_Hstart+7)/2)+1)
				// Choose i=0 active area ; i=1~2 Pattern area => because if all is pattern area, it will over range for multiple of start_pos
				rtd_outl(REG_ABL_WINDOW,( (0x07818300|(((ABL_Hstart+7)/2)+1))|(i<<30)));  // 4 pixel in front of data, RGE_ABL_WINDOW= 0x07818043/0x4718043/0x8718043/0xc718043,
																						// 00: start_pos = abl_start_pos X 1
																						// 01: start_pos = abl_start_pos X 2
																						// 10: start_pos = abl_start_pos X 4
																						// 11: start_pos = abl_start_pos X 8
				udelay(20000);
				if(i==0)
				temp2=1;
				else if(i==1)
				temp2=2;
				else if(i==2)
				temp2=4;
				else
				temp2=8;				
				
				temp1=(rtd_inl(REG_ABL_WINDOW)&0xff)*temp2;
				if((temp1+4)<(Hact_start+4))			//between active~PTG = Background color => C2Y	//Clayton: It should compare with (IPTG pattern area)Hact_start?, Old: ABL_Hstart
					{
				temp=((rtd_inl(REG_PTG_C2Y)&0xff)<<2)|(rtd_inl(REG_PTG_C2Y)&0x3);// 10 bit data lsb 2 bit repeat
				printk("[Clayton]new test1, temp1=0x%x temp=0x%x  Hact_start=0x%x  ABL_Hstart=0x%x\n",temp1,temp,Hact_start,ABL_Hstart);
					}
				else
					{
				temp=0x3ff-((temp1-(ABL_Hstart+4))/16)*24;	//PTG area, use IPTG H-Gradient
				printk("[Clayton]new test2, temp1=0x%x temp=0x%x  Hact_start=0x%x  ABL_Hstart=0x%x\n",temp1,temp,Hact_start,ABL_Hstart);
					}
				R_code=rtd_inl(REG_ABL_RSLT0)>>16;
				G_code=rtd_inl(REG_ABL_RSLT0)&(0x0000ffff);
				B_code=rtd_inl(REG_ABL_RSLT1)&(0x0000ffff);			
		              if( !((R_code==temp)&&(G_code==temp) &&(B_code==temp) ))
		              	{
					printk("IP_ABL, H window  pos_mul Fail!! R=%d,G=%d,B=%d,ABL_Hstart=%x,temp=%x,temp1=%x i=%d\n",R_code,G_code,B_code,ABL_Hstart,temp,temp1,i);
					// Clayton, debug use
					// [start]
					//for(j=0;j<10;j++)
						//{
						//IP_ABL_Verify_debug(j);
						//}
					// [end]
					Fl_pass=FALSE;
					  break;

		              	}
				printk("[Clayton]IP_ABL, H window  pos_mul PASS R=%d,G=%d,B=%d,ABL_Hstart=%x,temp=%x,temp1=%x i=%d\n",R_code,G_code,B_code,ABL_Hstart,temp,temp1,i);
				}
				
				if(Fl_pass==TRUE)
				printk("IP_ABL, H window & pos_mul Pass \n");	
				printk("IP_ABL, H window  Pass!! \n");
				break;
				
			
		case 8: //V window
			//Clayton 5/10 new ABL_Hstart from real IPTG Pat_Hstart
			// Because this case target is Pattern area ABL data instead of Active area
              		Hact_start=rtd_inl(REG_PTG_HSTA_WID)>>16;   // Pattern Gen display Hstart & Hactive =704 eݯd16 piexels ΨӧP_porch 
	  			ABL_Hstart=Hact_start-Hsync_Delay-4; // init H window width=4, Hact_start = 128 (default)
              		printk("New REG_PTG_HSTA_WID= 0x%x \n",rtd_inl(REG_PTG_HSTA_WID));
	  	  		printk("New ABL_Hstart=0x%x ; Hsync_Delay=%d\n",ABL_Hstart, Hsync_Delay);	

				rtd_outl(REG_PTG_TG, 0x40000002);   // Disable timing generator, bit0=0
				rtd_outl(REG_PTG_VSTA_LEN, 0x001900f0);   // V datastart move to line 25
				rtd_outl(REG_PTG_TG, 0x40000003);   // Enable timing generator, bit0=1				
				udelay(20000);
				rtd_outl(REG_ABL_CTRL, 0x008a0100);
				// Clayton 5/10
				//rtd_outl(REG_ABL_WINDOW,( (0x07818300|(((ABL_Hstart+7))+1))|(i<<30)));	//debug use
				rtd_outl(REG_ABL_WINDOW, (0x01818300|(ABL_Hstart+4)));  // at  the edge of H,V data, H width =4, REG_ABL_WINDOW=0x01818384	; Clayton: 0x01818300->0x07818300
																// Vstart=24, end=48 & measure=8 lines, interval=16 lines
				printk("[Clayton]IP_ABL, V window1, Change abl_start_pos_mul!!REG_ABL_WINDOW=0x%x \n", rtd_inl(REG_ABL_WINDOW));
				rtd_outl(REG_ABL_CTRL, 0x808a0100);															     
				udelay(20000);
				
				R_code=rtd_inl(REG_ABL_RSLT0)>>16;
				if (R_code==0x3ff)
					{
					rtd_outl(REG_ABL_WINDOW, (0x00f16300|(ABL_Hstart+4)));  // move V start=22 ,end=46 ; Old: 0x00f16300 -> 0x01816300
																			// Clayton 5/9
																			// old= (0x00f16300|(ABL_Hstart+4))
																			// New= (0x40f16300|(ABL_Hstart+4))
					printk("[Clayton]IP_ABL, V window2, Change abl_start_pos_mul!!REG_ABL_WINDOW=0x%x \n", rtd_inl(REG_ABL_WINDOW));
					udelay(20000);
					R_code=rtd_inl(REG_ABL_RSLT0)>>16;
					if((R_code==0x301)|(R_code==0x300)) //(1023*6*4+5*2*4)/8*4      average value
				       printk("IP_ABL, V start/end  Pass \n");		
					else						
						{
						printk("IP_ABL, V start/end  fail1 R_code=0x%x\n",R_code);	
						Fl_pass=FALSE;
						break;
						}
					}
				else
					{
						printk("IP_ABL, V start/end  fail2 R_code=0x%x \n",R_code);	
						Fl_pass=FALSE;						
						break;	
					}
				temp=8;
				for(i=1;i<4;i++) //avg line count
					{
					temp=temp*2;
					rtd_outl(REG_ABL_WINDOW,(((rtd_inl(REG_ABL_WINDOW)&0xfffff3ff)|(i<<10))&0xc00fffff)|(((temp+22+16)/2)<<20));  // move V start=22 ,end=54
																								// Clayton 5/9: Keep 0x18020204[31:30]=0x1, start_pos = abl_start_pos X 2
																								// &0x000fffff --> &0xc00fffff
					printk("[Clayton]IP_ABL, V window3--avg line, Change abl_start_pos_mul!!REG_ABL_WINDOW=0x%x ;for count=%d\n", rtd_inl(REG_ABL_WINDOW),i);
					rtd_outl(REG_ABL_CTRL,(rtd_inl(REG_ABL_CTRL)&~_BIT31));  //" &~ " ??
					udelay(100);
					rtd_outl(REG_ABL_CTRL,(rtd_inl(REG_ABL_CTRL)|_BIT31));
					udelay(60000);
//					printk("IP_ABL, 0x%x \n", rtd_inl(REG_ABL_WINDOW));			
					R_code=rtd_inl(REG_ABL_RSLT0)>>16;	
					G_code=(40+(temp-2)*4*1023)/(temp*4);
					temp1=YPP_abs(R_code,G_code);
					if(temp1>3)
						{
						printk("IP_ABL, V avg line fail  i=%d, Result=0x%x,Target=0x%x \n",YPP_abs(R_code,G_code),R_code,G_code);	
						Fl_pass=FALSE;						
						break;
						}
					
					}
				printk("IP_ABL, V avg line pass ! \n");
				break;
		case 9:  //test MGN  in VGA mode
				rtd_outl(REG_PTG_C0Y, 0x00101010);   // active region color 
				rtd_outl(REG_ABL_WINDOW, (0x07818300|(ABL_Hstart)));  // window cross porch & active
				rtd_outl(REG_ABL_MGN_RG, 0x10841084);  // MGN
				rtd_outl(REG_ABL_MGN_B, 0x00001084);  // MGN

				for(i=0;i<3;i++)  // for R, G, B 3 color 
					{
					rtd_outl(REG_ABL_MGN_RG, 0x10841084);  // MGN
					rtd_outl(REG_ABL_MGN_B, 0x00001084);  // MGN
					rtd_outl(REG_ABL_CTRL, 0x80800100); 
					udelay(20000);	
					rtd_outl(REG_ADC_OFFSET0, 0x00000000);   //offset to default				
					rtd_outl(REG_ADC_OFFSET1, 0x00000000);   //offset to default	
					udelay(100000);	
					//rtd_outl(REG_ABL_CTRL, 0x80800100|(1<<(30-i))); //on line mode, frame=4
					// For MAC3
					//rtd_outl(REG_ABL_CTRL, 0x00000100|(1<<(30-i))); //off line mode, frame=4
					//udelay(100000); 
					rtd_outl(REG_ABL_CTRL, 0x80000100|(1<<(30-i))); //off line mode, frame=4
					udelay(500000);
					
					if(i==0)
					temp=(rtd_inl(REG_ADC_OFFSET0)&0x0000ffff)-0x000;	
					else if(i==1)
					temp=((rtd_inl(REG_ADC_OFFSET0)&0xffff0000)>>16)-0x000;	
					else
					temp=(rtd_inl(REG_ADC_OFFSET1)&0x0000ffff)-0x000;	
					//printk("01 REG_ADC_OFFSET0 = 0x%x \n",rtd_inl(REG_ADC_OFFSET0));
					//printk("2 REG_ADC_OFFSET1 = 0x%x \n",rtd_inl(REG_ADC_OFFSET1));
					
					if(temp==0)	//EQ_MGN,adjust 1step=1
						{
						rtd_outl(REG_ABL_MGN_RG, 0x00840084);  // window cross porch & active
						rtd_outl(REG_ABL_MGN_B, 0x00000084);  // window cross porch & active					
						udelay(10000);	

						// For MAC3
						rtd_outl(REG_ADC_OFFSET0, 0x00100010);   //set offset  	// For MAC3			
						rtd_outl(REG_ADC_OFFSET1, 0x00000010);   //set offset	// For MAC3
						udelay(100000);	

						if(i==0)
						temp1=rtd_inl(REG_ADC_OFFSET0)&0x0000ffff;
						else if(i==1)
						temp1=(rtd_inl(REG_ADC_OFFSET0)&0xffff0000)>>16;
						else
						temp1=rtd_inl(REG_ADC_OFFSET1)&0x0000ffff;	
						
						//printk("101 REG_ADC_OFFSET0 = 0x%x \n",rtd_inl(REG_ADC_OFFSET0));
						//printk("12 REG_ADC_OFFSET1 = 0x%x \n",rtd_inl(REG_ADC_OFFSET1));
						
				       //if(temp1>0x400) // [10]=sign bit:neg value direction
				       if(temp1>0x0) // [10]=sign bit:neg value direction ,for MAC3
						printk("IP_ABL, color(R=0,G=1,B=2)=%d EQ_MGN Pass temp1=0x%x! \n",i,temp1);					
						else
							{
							printk("IP_ABL, color(R=0,G=1,B=2)=%d EQ_ERROR_MGN fail1 result=0x%x! \n",i,temp1);
							Fl_pass=FALSE;							
							break;
							}
						}
					else
						{
						printk("IP_ABL,color(R=0,G=1,B=2)=%d EQ_ERROR_MGN fail2 result=0x%x! \n",i,temp1);	
						Fl_pass=FALSE;						
						break;
						}


					//Large_error_MGN,  adjust 1step=LG_error_MGN
					rtd_outl(REG_ABL_CTRL, 0x80800100); //off line mode, frame=4
					rtd_outl(REG_ADC_OFFSET0, 0x00000000);   //offset to default				
					rtd_outl(REG_ADC_OFFSET1, 0x00000000);   //offset to default	
					udelay(100000);	
					rtd_outl(REG_ABL_MGN_RG, 0x00440044);  // window cross porch & active
					rtd_outl(REG_ABL_MGN_B, 0x00000044);  // window cross porch & active	
					rtd_outl(REG_ABL_CTRL, 0x80800100|(1<<(30-i))); //off line mode, frame=4
					udelay(10000);	
					
					if(i==0)
					temp=rtd_inl(REG_ADC_OFFSET0)&0x0000ffff;
					else if(i==1)
					temp=(rtd_inl(REG_ADC_OFFSET0)&0xffff0000)>>16;						
					else
					temp=rtd_inl(REG_ADC_OFFSET1)&0x0000ffff;	

					//printk("201 REG_ADC_OFFSET0 = 0x%x \n",rtd_inl(REG_ADC_OFFSET0));
					//printk("212 REG_ADC_OFFSET1 = 0x%x \n",rtd_inl(REG_ADC_OFFSET1));
					
				       //if(temp1>0x400) // [10]=sign bit:neg value direction
				       if(temp1>0x0) // neg value direction , For MAC3
						printk("IP_ABL,color(R=0,G=1,B=2) =%d LG_MGN Pass result=0x%x,temp1=0x%x ! \n",i,temp,temp1);										
					else
						{
						printk("IP_ABL,colo(R=0,G=1,B=2) r=%d LG_MGN fail result=0x%x,temp1=0x%x   ! \n",i,temp,temp1);	
						Fl_pass=FALSE;						
						break;
						}
					}
		default:
			break;									
		}
	if (Fl_pass==FALSE)
		break;
	}
if (Fl_pass==FALSE)
	return 0;
else
	return 1;
}

BOOL IP_SF_Verify(void)
{
UINT8    test_count=0,test_case=6;

UINT32  temp;
//UINT32  temp1,i;
bool     Fl_pass=1;

printk("IP_SF_Verify  \n");
//IPTG  Total pixel = 858*262, H start 145 ,width 704, V start 16 active 240

rtd_outl(REG_PTG_TG,rtd_inl(REG_PTG_TG)&(~_BIT0));	 
udelay(100000);	
rtd_outl(REG_PTG_TG,rtd_inl(REG_PTG_TG)|_BIT0);	 
for(test_count=0;test_count<test_case;test_count++)
{
rtd_outl(0xb8022210, 0x90000001);	 //VGIP enable 
rtd_outl(REG_PTG_C0Y, 0x00ffffff);//R=0x1ff,G=0x3ff B=0x2ff
rtd_outl(REG_AUTO_H_BOUNDARY, 0x00500359);//set H  boudary , start 80 end 858
rtd_outl(REG_AUTO_V_BOUNDARY, 0x00020106);//set V  boudary , start 2 end 262
rtd_outl(REG_AUTO_RGB_MARGIN, 0x04040400);//R/G/B Noise MGN 01
rtd_outl(REG_AUTO_ADJ, 0);//reset adj
rtd_outl(REG_AUTO_FIELD, 0);//reset field
rtd_outl(0xb8023500, 0x0);//Disable dither
rtd_outl(0xb8023504, 0x0);//diable Dither
	switch(test_count)
		{
			case 0:// test H V boundary & Result HV start/end & VGIP src sel 
				rtd_outl(REG_AUTO_RGB_MARGIN, 0);		//R/G/B Noise MGN	0
				rtd_outl(REG_AUTO_ADJ, _BIT0);			//Start Auto-Function Tracking Function
				udelay(100000);	
				temp=YPP_abs(rtd_inl(REG_AUTO_V_BOUNDARY),rtd_inl(REG_AUTO_RESULT_V)); //interlace  1 line diff between even/odd
				if((rtd_inl(REG_AUTO_H_BOUNDARY)==rtd_inl(REG_AUTO_RESULT_H))&&
					(temp<=1))
					
					printk("IP_SF_Verify, HV boundary & Result Pass , H boundary=0x%x,Set_HBound=0x%x\n",rtd_inl(REG_AUTO_RESULT_H),rtd_inl(REG_AUTO_H_BOUNDARY));
				else
					{
					printk("IP_SF_Verify, HV boundary & Result fail H boundary=0x%x,V_boundary=0x%x\n",rtd_inl(REG_AUTO_RESULT_H),rtd_inl(REG_AUTO_RESULT_V));
					Fl_pass=FALSE;	
					break;
					}
				rtd_outl(REG_AUTO_RGB_MARGIN, 0x04040400);	//R/G/B Noise MGN 01
				rtd_outl(REG_AUTO_ADJ, _BIT0);				//Start Auto-Function Tracking Function
				udelay(100000);	
				if(((rtd_inl(REG_PTG_HSTA_WID)>>16)==((rtd_inl(REG_AUTO_RESULT_H)>>16)+1))&&   //IPTG H active start
				    ((rtd_inl(REG_PTG_HSTA_WID)&0x0000ffff)==(rtd_inl(REG_AUTO_RESULT_H)&0x0000fff)-(rtd_inl(REG_AUTO_RESULT_H)>>16)+1)) //IPGT H width
					{
					printk("IP_SF_Verify, RGB MGN PASS \n");

					      rtd_outl( VGIP_CHN1_MISC,    rtd_inl(VGIP_CHN1_MISC)|_BIT6); //delay 32 pixel
      					      rtd_outl(REG_AUTO_FIELD, rtd_inl(REG_AUTO_FIELD)|_BIT31); //measure after VGIP 
      					      udelay(100000);	
					      rtd_outl(REG_AUTO_ADJ, _BIT0); //measure before VGIP 
					      udelay(100000);	
					  if((rtd_inl(REG_PTG_HSTA_WID)>>16)==((rtd_inl(REG_AUTO_RESULT_H)>>16)))
					  	{
		      				      rtd_outl(REG_AUTO_FIELD, rtd_inl(REG_AUTO_FIELD)&(~_BIT31)); //measure after VGIP 	      					
						      rtd_outl(REG_AUTO_ADJ, _BIT0); //measure after VGIP 
					      	      udelay(100000);
						      if((rtd_inl(REG_PTG_HSTA_WID)>>16)==((rtd_inl(REG_AUTO_RESULT_H)>>16)+1+0x20))
	  						printk("IP_SF_Verify, VGIP src  Pass \n" );
						      else
						      	{
							printk("IP_SF_Verify, VGIP src (after ) Fail source  REG_PTG_HSTA_WID=%x,REG_AUTO_RESULT_H=%x\n",rtd_inl(REG_PTG_HSTA_WID),rtd_inl(REG_AUTO_RESULT_H) );							  	
							Fl_pass=FALSE;
							break;
						      	}
					  	}
					  else
					  	{
					  	printk("IP_SF_Verify, VGIP src (before ) Fail  \n" );	
						Fl_pass=FALSE;
						break;
					  	}
					  	printk("IP_SF_Verify, VGIP src (before ) Pass \n" );	
					      rtd_outl( VGIP_CHN1_MISC,    rtd_inl(VGIP_CHN1_MISC)&(~_BIT6)); //delay 0 pixel
					}
				else
					{
					printk("IP_SF_Verify, RGB MGN fail =0x%x\n",rtd_inl(REG_AUTO_RESULT_H) );
					Fl_pass=FALSE;						
					break;
					}	
	
				break;
			case 1: //Odd sel en
			// Clayton 5/16: No need to test case1~ case6 due to moving to ADC-SmartFit
			// [Start]
			/*
				rtd_outl(0xb8022210, 0x90000101);	 //VGIP enable  safe-mode->Odd off
				rtd_outl(REG_AUTO_FIELD, (_BIT7|_BIT6));	 //mesaure odd
				udelay(100000);	
				rtd_outl(REG_AUTO_ADJ, _BIT0);	 //Enable measue		
				udelay(100000);	
				if(rtd_inl(REG_AUTO_ADJ)==0)
					{
						printk("IP_SF_Verify, odd sel fail1 0x%x\n",rtd_inl(REG_AUTO_ADJ));							
						Fl_pass=FALSE;
						break;						
					}
				else
				rtd_outl(REG_AUTO_FIELD, _BIT7);	 //VGIP enable  safe-mode->Odd off
					udelay(10000);	
				rtd_outl(REG_AUTO_ADJ, _BIT0);	 //Enable measue		
				udelay(100000);	
				if(rtd_inl(REG_AUTO_ADJ)!=0)
					{
						printk("IP_SF_Verify, odd sel fail2 %x\n",rtd_inl(REG_AUTO_ADJ));							
						Fl_pass=FALSE;
						break;						
					}
				printk("IP_SF_Verify, odd sel PASS \n");							

				// pulse_det_en & phase/balance mode
			       rtd_outl(REG_AUTO_H_BOUNDARY, 0x00900091);//set H  boudary , measure only two vertical line  color black->white
				rtd_outl(REG_AUTO_V_BOUNDARY, rtd_inl(REG_AUTO_RESULT_V));
				rtd_outl(REG_AUTO_ADJ,_BIT6| _BIT5|_BIT4|_BIT1);	 //difference&MAX&Acc&Phase		
				udelay(10000);	
				rtd_outl(REG_AUTO_ADJ,rtd_inl(REG_AUTO_ADJ)|_BIT0);	 //Enable measue						
				udelay(100000);	
				temp=rtd_inl(REG_AUTO_RESULT_PASHE_L);  //V active* (1023-5)  sum of difference

				rtd_outl(REG_AUTO_ADJ,_BIT6|_BIT5|_BIT4|_BIT3|_BIT1);	    ////difference&MAX&Acc&Phase  + pulse_det_en, the result will be double
				udelay(10000);	
				rtd_outl(REG_AUTO_ADJ,rtd_inl(REG_AUTO_ADJ)|_BIT0);	 //Enable measue						
				udelay(100000);	
				temp1=rtd_inl(REG_AUTO_RESULT_PASHE_L);				
				if (temp*2==temp1)
				printk("IP_SF_Verify, pulse_det_en PASS \n");												
				else
				{
				printk("IP_SF_Verify, pulse_det_en fail 0x%x\n", temp1);				
				Fl_pass=FALSE;
				}
				*/
				// [end]
				break;
				
			case 2://RGB_in_one_en & square_en
			        //Measure R
			 // Clayton 5/16: No need to test case1~ case6 due to moving to ADC-SmartFit
			// [Start]    
			/*
				rtd_outl(REG_AUTO_RGB_MARGIN, 0x00000000);//Noise MGN 0
				rtd_outl(REG_AUTO_ADJ, _BIT4|_BIT6);	 //differ & accu
				udelay(10000);	
				rtd_outl(REG_AUTO_ADJ,rtd_inl(REG_AUTO_ADJ)| _BIT0);	 //Enable measue		
				udelay(100000);	
				temp=rtd_inl(REG_AUTO_RESULT_PASHE_L);
			        //Measure G
				rtd_outl(REG_AUTO_RGB_MARGIN, 0x00000100);//Noise MGN 0
				rtd_outl(REG_AUTO_ADJ, _BIT4|_BIT6);	 //differ & accu
				udelay(10000);	
				rtd_outl(REG_AUTO_ADJ,rtd_inl(REG_AUTO_ADJ)| _BIT0);	 //Enable measue		
				udelay(100000);	
				temp=temp+rtd_inl(REG_AUTO_RESULT_PASHE_L);
			        //Measure B
				rtd_outl(REG_AUTO_RGB_MARGIN, 0x00000200);//Noise MGN 0
				rtd_outl(REG_AUTO_ADJ, _BIT4|_BIT6);	 //differ & accu
				udelay(10000);	
				rtd_outl(REG_AUTO_ADJ,rtd_inl(REG_AUTO_ADJ)| _BIT0);	 //Enable measue		
				udelay(100000);	
				temp=temp+rtd_inl(REG_AUTO_RESULT_PASHE_L);


				rtd_outl(REG_AUTO_FIELD,_BIT4);	 //RGB together
				udelay(10000);	
				rtd_outl(REG_AUTO_ADJ,rtd_inl(REG_AUTO_ADJ)| _BIT0);	 //Enable measue		
				udelay(100000);	
				temp1=rtd_inl(REG_AUTO_RESULT_PASHE_L);
				
				if(YPP_abs(temp,temp1)<0x0000100)
				printk("IP_SF_Verify, RGB_in_one_en  PASS,SumRGB=%x,in_one=%x _BIT4|_BIT6 \n",temp,temp1);
				else
					{
					printk("IP_SF_Verify, RGB_in_one_en  fail ,temp=0x%x,temp1=0x%x\n",temp,temp1);
					printk("fail ,b8022010=0x%x,b8022000=0x%x\n",rtd_inl(REG_AUTO_ADJ),rtd_inl(REG_AUTO_FIELD));
					//printk("fail ,temp=0x%x,temp1=0x%x\n",temp,temp1);
					Fl_pass=FALSE;
					break;
					}
				rtd_outl(REG_AUTO_FIELD,_BIT4|_BIT3);	 //RGB together/square_en
				udelay(10000);	
				rtd_outl(REG_AUTO_ADJ,rtd_inl(REG_AUTO_ADJ)| _BIT0);	 //Enable measue		
				udelay(100000);	
				temp1=rtd_inl(REG_AUTO_RESULT_PASHE_L);			// RGB togeter value= diff, temp1= (diff/16) * (diff/16)
				rtd_outl(REG_AUTO_RGB_MARGIN, 0x04040400);//R/G/B pixel noise margin  04
				
				if(temp>temp1)					
					printk("IP_SF_Verify, square_en  PASS \n");
				else
					{
					
					printk("IP_SF_Verify, square_en  fail temp=%x ; temp1=%x\n",temp,temp1);
					Fl_pass=FALSE;
					break;
					}
				*/
				// [end]				
				break;
			case 3: //sum of pixel  &  even/odd pixel
			// Clayton 5/16: No need to test case1~ case6 due to moving to ADC-SmartFit
			// [Start]
			/*
			       // sum of pixel
			       rtd_outl(REG_AUTO_H_BOUNDARY, 0x00900091);//set H  boudary , measure only two vertical line
   				rtd_outl(REG_AUTO_FIELD, _BIT2);	 //pixel number mode
 				rtd_outl(REG_AUTO_ADJ, _BIT6|_BIT4);	 //pixel number mode
				udelay(10000);	
				rtd_outl(REG_AUTO_ADJ,rtd_inl(REG_AUTO_ADJ)| _BIT0);	 //Enable measue		
				udelay(100000);	
				temp=rtd_inl(REG_AUTO_RESULT_PASHE_L);
				temp1=YPP_abs(temp,(((rtd_inl(REG_AUTO_H_BOUNDARY)&0x0000ffff)-(rtd_inl(REG_AUTO_H_BOUNDARY)>>16)+1)* 
						  ((rtd_inl(REG_AUTO_V_BOUNDARY)&0x0000ffff)-(rtd_inl(REG_AUTO_V_BOUNDARY)>>16)+1))); //| temp - (H start - H end +1)*(V start - V end +1) |
				if(temp1<=2)
					printk("IP_SF_Verify, sum_pixel_num  PASS \n");
				else
					{
					printk("IP_SF_Verify, sum_pixel_num fail \n");
					Fl_pass=FALSE;
					break;
					}			
				// even/odd pixel
				rtd_outl(REG_AUTO_RGB_MARGIN, 0x07040400);//R/G/B pixel noise margin  04, enable odd pixel measure 
				udelay(10000);
				rtd_outl(REG_AUTO_ADJ,rtd_inl(REG_AUTO_ADJ)| _BIT0);	 //Enable measue		
				udelay(100000);	
				if(((temp/2)+2)>rtd_inl(REG_AUTO_RESULT_PASHE_L))
					printk("IP_SF_Verify, even/odd pixel select  PASS \n");
				else
					{
					printk("IP_SF_Verify, even/odd pixel select  fail 0x%x\n",rtd_inl(REG_AUTO_RESULT_PASHE_L));
					Fl_pass=FALSE;
					}
				*/
				// [end]				
				break;
				
			case 4: // compare mode / color select  & MAX/MIN /RGB balance
			// Clayton 5/16: No need to test case1~ case6 due to moving to ADC-SmartFit
			// [Start]	
			/*
				rtd_outl(REG_PTG_C0Y, 0x00ff7fbf);//IPTG R=0x1ff,G=0x3ff B=0x2ff
				rtd_outl(REG_AUTO_H_BOUNDARY, 0x009300B0);	
				rtd_outl(REG_AUTO_ADJ, _BIT6|_BIT5);//compare mode & max color
				for(i=0;i<3;i++)
					{
					rtd_outl(REG_AUTO_RGB_MARGIN, 0x04040400|(i<<8));//IPTG R=0x1ff,G=0x3ff B=0x2ff
					udelay(10000);
					rtd_outl(REG_AUTO_ADJ,rtd_inl(REG_AUTO_ADJ)| _BIT0);	 //Enable measue		
					udelay(100000);	
					if((rtd_inl(REG_AUTO_RESULT_PASHE_L)>>8)!=(i+1))
						{
						printk("IP_SF_Verify, color select MAX fail i (R=0,B=1,G=2)=%d,0x%x\n",i,rtd_inl(REG_AUTO_RESULT_PASHE_L));						
						Fl_pass=FALSE;
						break;
						}
					}
						printk("IP_SF_Verify, color select & compare mode MAX  PASS\n");						
   					rtd_outl(REG_AUTO_FIELD, rtd_inl(REG_AUTO_FIELD)|_BIT30); //AutoBalance 3 chs 
					rtd_outl(REG_AUTO_RGB_MARGIN, 0x04040400|(2<<8));//IPTG R=0x1ff,G=0x3ff B=0x2ff
					udelay(10000);
					rtd_outl(REG_AUTO_ADJ,rtd_inl(REG_AUTO_ADJ)| _BIT0);	 //Enable measue		
					udelay(100000);	
					if	((((rtd_inl(REG_AUTO_RESULT_PASHE_M)&0x3ff)>>2)==((rtd_inl(REG_PTG_C0Y)&0xff00)>>8))&&
						(((rtd_inl(REG_AUTO_RESULT_PASHE_L)&0x3ff0000)>>18)==((rtd_inl(REG_PTG_C0Y)&0xff)))&&
						(((rtd_inl(REG_AUTO_RESULT_PASHE_L)&0x3ff)>>2)==((rtd_inl(REG_PTG_C0Y)&0xff0000)>>16)))
							printk("IP_SF_Verify, AutoBalance 3 chs & compare mode MAX  PASS\n");	
					else
						{
							printk("IP_SF_Verify, AutoBalance 3 chs & compare mode MAX  fail\n");	
							Fl_pass=FALSE;
  							break;
						}
   					rtd_outl(REG_AUTO_FIELD, rtd_inl(REG_AUTO_FIELD)&(~_BIT30)); //AutoBalance 3 chs disable					
				// MIN		
				rtd_outl(REG_AUTO_ADJ, _BIT6);//compare mode & min color						

				rtd_outl(REG_AUTO_V_BOUNDARY, 0x00040104);//set V  boudary , start 2 end 262
				udelay(10000);					
				rtd_outl(REG_AUTO_ADJ,rtd_inl(REG_AUTO_ADJ)| _BIT0);	 //Enable measue		
				udelay(100000);	
				temp=(~(rtd_inl(REG_AUTO_RESULT_PASHE_L)))&0x000003ff;
				if( temp==5)
						printk("IP_SF_Verify, color select & compare mode MIN  PASS\n");
				else
					{
						printk("IP_SF_Verify, color select & compare mode MIN  fail 0x%x \n",temp);
						Fl_pass=FALSE;
					}
				*/
				// [end]				
				break;
			case 5:
			// Clayton 5/16: No need to test case1~ case6 due to moving to ADC-SmartFit
			// [Start]	
			/*
				// diff_pixel_sel->value
				rtd_outl(REG_AUTO_ADJ,rtd_inl(REG_AUTO_ADJ)| _BIT0);	 //Enable measue		
				udelay(100000);
			       rtd_outl(REG_AUTO_H_BOUNDARY, 0x00910091);//set H  boudary , measure only one vertical line				
			       rtd_outl(REG_AUTO_V_BOUNDARY, rtd_inl(REG_AUTO_RESULT_V));//set H  boudary to active size ,and  measure only one vertical line							       
 				rtd_outl(REG_AUTO_ADJ, _BIT4);	 //select pixel value & acc mode
				udelay(10000);	
				rtd_outl(REG_AUTO_ADJ,rtd_inl(REG_AUTO_ADJ)| _BIT0);	 //Enable measue		
				udelay(100000);	
				temp=rtd_inl(REG_AUTO_RESULT_PASHE_L);
				temp1=(0x3ff*((rtd_inl(REG_AUTO_RESULT_V)&0x0000ffff)-(rtd_inl(REG_AUTO_RESULT_V)>>16)+1) );
				if(temp== temp1)
					printk("IP_SF_Verify, diff_pixel_sel  PASS \n");				
				else
				{
					printk("IP_SF_Verify, diff_pixel_sel  fail 0x%x target=0x%x \n",temp,temp1);				
					Fl_pass=FALSE;
					break;
				}		
				*/
				// [end]				
				break;
			case 6://auto phase				
				break;
			default:			
				break;
		}
		// [Clayton][Fix me] by pass first
		// [start]
		//if (Fl_pass==FALSE)
		//break;
		// [end]
}
if (Fl_pass==FALSE)
	return 0;
else
	return 1;

}

//Clayton 5/11 new modify for ADC Smart-Fit
BOOL IP_ADCSF_Verify(void)
{
UINT8    test_count=0,test_case=6;

UINT32  temp,temp1,i, delay_pixel=1;	//For ADC-SF, it would delay 1 pixel vs. SF
bool     Fl_pass=1;

printk("IP_ADCSF_Verify  \n");
//IPTG  Total pixel = 858*262, H start 145 ,width 704, V start 16 active 240

rtd_outl(REG_PTG_TG,rtd_inl(REG_PTG_TG)&(~_BIT0));	 
udelay(100000);	
rtd_outl(REG_PTG_TG,rtd_inl(REG_PTG_TG)|_BIT0);	 
for(test_count=0;test_count<test_case;test_count++)
{
rtd_outl(0xb8022210, 0x90000001);	 //VGIP enable 
rtd_outl(REG_PTG_C0Y, 0x00ffffff);//R=0x1ff,G=0x3ff B=0x2ff
rtd_outl(REG_ADC_AUTO_H_BOUNDARY, 0x00500359);//set H  boudary , start 80 end 858
//rtd_outl(REG_ADC_AUTO_H_BOUNDARY, 0x00050370);//set H  boudary , start 80 end 858		//debug
	// IPTG active Hstart: 0x10, Hend: 0x359
	// So, ADC-SF needs to set range larger than measured area
	// ADC-SF, set Hstar: 0x5, Hend: 0x370

rtd_outl(REG_ADC_AUTO_V_BOUNDARY, 0x00020106);//set V  boudary , start 2 end 262
rtd_outl(REG_ADC_AUTO_RGB_MARGIN, 0x04040400);//R/G/B Noise MGN 01
rtd_outl(REG_ADC_AUTO_ADJ, 0);//reset adj	
rtd_outl(REG_ADC_AUTO_FIELD, 0x80000000);//reset field	//Clayton: something different between SF & ADC-SF
										// auto_balance_rgb set as 0x2 = only 1 channel use color_sel 0x1802_040c[9:8] to choose
										// as Smart-Fit
rtd_outl(0xb8023500, 0x0);//Disable dither
rtd_outl(0xb8023504, 0x0);//diable Dither
	udelay(100000);
	switch(test_count)
		{
			case 0:// test H V boundary & Result HV start/end & VGIP src sel 
				rtd_outl(REG_ADC_AUTO_RGB_MARGIN, 0);		//R/G/B Noise MGN	0
				rtd_outl(REG_ADC_AUTO_ADJ, _BIT0);			//Start Auto-Function Tracking Function
				udelay(100000);	
				temp=YPP_abs(rtd_inl(REG_ADC_AUTO_V_BOUNDARY),rtd_inl(REG_ADC_AUTO_RESULT_V)); //interlace  1 line diff between even/odd
				if((rtd_inl(REG_ADC_AUTO_H_BOUNDARY)==rtd_inl(REG_ADC_AUTO_RESULT_H)+delay_pixel)&&
					(temp<=1))
					
					printk("IP_ADCSF_Verify, HV boundary & Result Pass \n");
				else
					{
					printk("IP_ADCSF_Verify, HV boundary & Result fail H boundary=0x%x,V_boundary=0x%x, Set_HBound=0x%x, Set_VBound=0x%x, temp=0x%x\n",rtd_inl(REG_ADC_AUTO_RESULT_H),rtd_inl(REG_ADC_AUTO_RESULT_V),rtd_inl(REG_ADC_AUTO_H_BOUNDARY),rtd_inl(REG_ADC_AUTO_V_BOUNDARY),temp);
					Fl_pass=FALSE;	
					break;
					}
				rtd_outl(REG_ADC_AUTO_RGB_MARGIN, 0x04040400);	//R/G/B Noise MGN 01
				rtd_outl(REG_ADC_AUTO_ADJ, _BIT0);				//Start Auto-Function Tracking Function
				udelay(100000);	
				if(((rtd_inl(REG_PTG_HSTA_WID)>>16)==((rtd_inl(REG_ADC_AUTO_RESULT_H)>>16)+1))&&   //IPTG H active start
				    ((rtd_inl(REG_PTG_HSTA_WID)&0x0000ffff)==(rtd_inl(REG_ADC_AUTO_RESULT_H)&0x0000fff)-(rtd_inl(REG_ADC_AUTO_RESULT_H)>>16)+1)) //IPGT H width
					{
					printk("IP_ADCSF_Verify, RGB MGN PASS \n");

					// [Clayton] 5/11: No need in ADC-SmartFit
					// [Start]
					/*
					      rtd_outl( VGIP_CHN1_MISC,    rtd_inl(VGIP_CHN1_MISC)|_BIT6); //delay 32 pixel
						// Clayton 5/11: No need in ADC-SF
						//rtd_outl(REG_ADC_AUTO_FIELD, rtd_inl(REG_ADC_AUTO_FIELD)|_BIT31); //measure after VGIP 
      					      udelay(100000);	
					      rtd_outl(REG_ADC_AUTO_ADJ, _BIT0); //measure before VGIP 
					      udelay(100000);	
						  
					  if((rtd_inl(REG_PTG_HSTA_WID)>>16)==((rtd_inl(REG_ADC_AUTO_RESULT_H)>>16)))
					  	{
		      				      rtd_outl(REG_ADC_AUTO_FIELD, rtd_inl(REG_ADC_AUTO_FIELD)&(~_BIT31)); //measure after VGIP 	      					
						      rtd_outl(REG_ADC_AUTO_ADJ, _BIT0); //measure after VGIP 
					      	      udelay(100000);
						      if((rtd_inl(REG_PTG_HSTA_WID)>>16)==((rtd_inl(REG_ADC_AUTO_RESULT_H)>>16)+1+0x20))
	  						printk("IP_SF_Verify, VGIP src  Pass \n" );
						      else
						      	{
							printk("IP_SF_Verify, VGIP src (after ) Fail source  REG_PTG_HSTA_WID=%x,REG_AUTO_RESULT_H=%x\n",rtd_inl(REG_PTG_HSTA_WID),rtd_inl(REG_AUTO_RESULT_H) );							  	
							Fl_pass=FALSE;
							break;
						      	}
					  	}
					  else
					  	{
					  	printk("IP_SF_Verify, VGIP src (before ) Fail  \n" );	
						Fl_pass=FALSE;
						break;
					  	}
					  	printk("IP_SF_Verify, VGIP src (before ) Pass \n" );	
					*/
					// [end]
						printk("IP_ADCSF_Verify, No need to check after VGIP in ADC-SmartFit \n");
					      rtd_outl( VGIP_CHN1_MISC,    rtd_inl(VGIP_CHN1_MISC)&(~_BIT6)); //delay 0 pixel
					}
				else
					{
					printk("IP_ADCSF_Verify, RGB MGN fail =0x%x\n",rtd_inl(REG_ADC_AUTO_RESULT_H) );
					Fl_pass=FALSE;						
					break;
					}	
	
				break;
			case 1: //Odd sel en
				rtd_outl(0xb8022210, 0x90000101);	 //VGIP enable  safe-mode->Odd off
				rtd_outl(REG_ADC_AUTO_FIELD, (_BIT31|_BIT7|_BIT6));	 //mesaure odd, Clayton: set bit31 for default setting
				udelay(100000);	
				rtd_outl(REG_ADC_AUTO_ADJ, _BIT0);	 //Enable measue		
				udelay(100000);	
				if(rtd_inl(REG_ADC_AUTO_ADJ)==0)
					{
						printk("IP_ADCSF_Verify, odd sel fail1 0x%x\n",rtd_inl(REG_ADC_AUTO_ADJ));							
						Fl_pass=FALSE;
						break;						
					}
				else
				rtd_outl(REG_ADC_AUTO_FIELD, _BIT31|_BIT7);	 //VGIP enable  safe-mode->Odd off, Clayton: set bit31 for default setting
					udelay(10000);	
				rtd_outl(REG_ADC_AUTO_ADJ, _BIT0);	 //Enable measue		
				udelay(100000);	
				if(rtd_inl(REG_ADC_AUTO_ADJ)!=0)
					{
						printk("IP_ADCSF_Verify, odd sel fail2 %x\n",rtd_inl(REG_ADC_AUTO_ADJ));							
						Fl_pass=FALSE;
						break;						
					}
				printk("IP_ADCSF_Verify, odd sel PASS \n");							

				// pulse_det_en & phase/balance mode
			       rtd_outl(REG_ADC_AUTO_H_BOUNDARY, 0x00900091);//set H  boudary , measure only two vertical line  color black->white
				rtd_outl(REG_ADC_AUTO_V_BOUNDARY, rtd_inl(REG_ADC_AUTO_RESULT_V));
				rtd_outl(REG_ADC_AUTO_ADJ,_BIT6| _BIT5|_BIT4|_BIT1);	 //difference&MAX&Acc&Phase		
				udelay(10000);	
				rtd_outl(REG_ADC_AUTO_ADJ,rtd_inl(REG_ADC_AUTO_ADJ)|_BIT0);	 //Enable measue						
				udelay(100000);	
				temp=rtd_inl(REG_ADC_AUTO_RESULT_PASHE_L);  //V active* (1023-5)  sum of difference

				rtd_outl(REG_ADC_AUTO_ADJ,_BIT6|_BIT5|_BIT4|_BIT3|_BIT1);	    ////difference&MAX&Acc&Phase  + pulse_det_en, the result will be double
				udelay(10000);	
				rtd_outl(REG_ADC_AUTO_ADJ,rtd_inl(REG_ADC_AUTO_ADJ)|_BIT0);	 //Enable measue						
				udelay(100000);	
				temp1=rtd_inl(REG_ADC_AUTO_RESULT_PASHE_L);				
				if (temp*2==temp1)
				printk("IP_ADCSF_Verify, pulse_det_en PASS \n");												
				else
				{
				printk("IP_ADCSF_Verify, pulse_det_en fail 0x%x\n", temp1);				
				Fl_pass=FALSE;
				}
				break;
				
			case 2://RGB_in_one_en & square_en
			        //Measure R
				rtd_outl(REG_ADC_AUTO_RGB_MARGIN, 0x00000000);//Noise MGN 0
				rtd_outl(REG_ADC_AUTO_ADJ, _BIT4|_BIT6);	 //differ & accu
				udelay(10000);	
				rtd_outl(REG_ADC_AUTO_ADJ,rtd_inl(REG_ADC_AUTO_ADJ)| _BIT0);	 //Enable measue		
				udelay(100000);	
				temp=rtd_inl(REG_ADC_AUTO_RESULT_PASHE_L);
			        //Measure G
				rtd_outl(REG_ADC_AUTO_RGB_MARGIN, 0x00000100);//Noise MGN 0
				rtd_outl(REG_ADC_AUTO_ADJ, _BIT4|_BIT6);	 //differ & accu
				udelay(10000);	
				rtd_outl(REG_ADC_AUTO_ADJ,rtd_inl(REG_ADC_AUTO_ADJ)| _BIT0);	 //Enable measue		
				udelay(100000);	
				temp=temp+rtd_inl(REG_ADC_AUTO_RESULT_PASHE_L);
			        //Measure B
				rtd_outl(REG_ADC_AUTO_RGB_MARGIN, 0x00000200);//Noise MGN 0
				rtd_outl(REG_ADC_AUTO_ADJ, _BIT4|_BIT6);	 //differ & accu
				udelay(10000);	
				rtd_outl(REG_ADC_AUTO_ADJ,rtd_inl(REG_ADC_AUTO_ADJ)| _BIT0);	 //Enable measue		
				udelay(100000);	
				temp=temp+rtd_inl(REG_ADC_AUTO_RESULT_PASHE_L);


				rtd_outl(REG_ADC_AUTO_FIELD,_BIT31|_BIT4);	 //RGB together,Clayton: set bit31 for default setting
				udelay(10000);	
				rtd_outl(REG_ADC_AUTO_ADJ,rtd_inl(REG_ADC_AUTO_ADJ)| _BIT0);	 //Enable measue		
				udelay(100000);	
				temp1=rtd_inl(REG_ADC_AUTO_RESULT_PASHE_L);
				
				if(YPP_abs(temp,temp1)<0x0000100)
				printk("IP_ADCSF_Verify, RGB_in_one_en  PASS,SumRGB=%x,in_one=%x _BIT4|_BIT6 \n",temp,temp1);
				else
					{
					printk("IP_ADCSF_Verify, RGB_in_one_en  fail ,temp=0x%x,temp1=0x%x\n",temp,temp1);
					printk("fail ,b8022010=0x%x,b8022000=0x%x\n",rtd_inl(REG_ADC_AUTO_ADJ),rtd_inl(REG_ADC_AUTO_FIELD));
					//printk("fail ,temp=0x%x,temp1=0x%x\n",temp,temp1);
					Fl_pass=FALSE;
					break;
					}
				rtd_outl(REG_ADC_AUTO_FIELD,_BIT31|_BIT4|_BIT3);	 //RGB together/square_en, Clayton: set bit31 for default setting
				udelay(10000);	
				rtd_outl(REG_ADC_AUTO_ADJ,rtd_inl(REG_ADC_AUTO_ADJ)| _BIT0);	 //Enable measue		
				udelay(100000);	
				temp1=rtd_inl(REG_ADC_AUTO_RESULT_PASHE_L);			// RGB togeter value= diff, temp1= (diff/16) * (diff/16)
				rtd_outl(REG_ADC_AUTO_RGB_MARGIN, 0x04040400);//R/G/B pixel noise margin  04
				
				if(temp>temp1)					
					printk("IP_ADCSF_Verify, square_en  PASS \n");
				else
					{
					
					printk("IP_ADCSF_Verify, square_en  fail temp=%x ; temp1=%x\n",temp,temp1);
					Fl_pass=FALSE;
					break;
					}
				break;
			case 3: //sum of pixel  &  even/odd pixel

			       // sum of pixel
			       rtd_outl(REG_ADC_AUTO_H_BOUNDARY, 0x00900091);//set H  boudary , measure only two vertical line
   				rtd_outl(REG_ADC_AUTO_FIELD,_BIT31| _BIT2);	 //pixel number mode, Clayton: set bit31 for default setting
 				rtd_outl(REG_ADC_AUTO_ADJ, _BIT6|_BIT4);	 //pixel number mode
				udelay(10000);	
				rtd_outl(REG_ADC_AUTO_ADJ,rtd_inl(REG_ADC_AUTO_ADJ)| _BIT0);	 //Enable measue		
				udelay(100000);	
				temp=rtd_inl(REG_ADC_AUTO_RESULT_PASHE_L);
				temp1=YPP_abs(temp,(((rtd_inl(REG_ADC_AUTO_H_BOUNDARY)&0x0000ffff)-(rtd_inl(REG_ADC_AUTO_H_BOUNDARY)>>16)+1)* 
						  ((rtd_inl(REG_ADC_AUTO_V_BOUNDARY)&0x0000ffff)-(rtd_inl(REG_ADC_AUTO_V_BOUNDARY)>>16)+1))); //| temp - (H start - H end +1)*(V start - V end +1) |
				if(temp1<=2)
					printk("IP_ADCSF_Verify, sum_pixel_num  PASS \n");
				else
					{
					printk("IP_ADCSF_Verify, sum_pixel_num fail \n");
					Fl_pass=FALSE;
					break;
					}			
				// even/odd pixel
				rtd_outl(REG_ADC_AUTO_RGB_MARGIN, 0x07040400);//R/G/B pixel noise margin  04, enable odd pixel measure 
				udelay(10000);
				rtd_outl(REG_ADC_AUTO_ADJ,rtd_inl(REG_ADC_AUTO_ADJ)| _BIT0);	 //Enable measue		
				udelay(100000);	
				if(((temp/2)+2)>rtd_inl(REG_ADC_AUTO_RESULT_PASHE_L))
					printk("IP_ADCSF_Verify, even/odd pixel select  PASS \n");
				else
					{
					printk("IP_ADCSF_Verify, even/odd pixel select  fail 0x%x\n",rtd_inl(REG_ADC_AUTO_RESULT_PASHE_L));
					Fl_pass=FALSE;
					}
				break;
				
			case 4: // compare mode / color select  & MAX/MIN /RGB balance
				rtd_outl(REG_PTG_C0Y, 0x00ff7fbf);//0x00ff7fbf: IPTG R=0x1ff,G=0x3ff B=0x2ff ; debug: 00BF7FBF--IPTG R=0x1ff,G=0x2ff B=0x2ff 
				rtd_outl(REG_ADC_AUTO_H_BOUNDARY, 0x009300B0);	
				rtd_outl(REG_ADC_AUTO_ADJ, _BIT6|_BIT5);//compare mode & max color
				for(i=0;i<3;i++)
					{
					rtd_outl(REG_ADC_AUTO_RGB_MARGIN, 0x04040400|(i<<8));//IPTG R=0x1ff,G=0x3ff B=0x2ff
					udelay(10000);
					rtd_outl(REG_ADC_AUTO_ADJ,rtd_inl(REG_ADC_AUTO_ADJ)| _BIT0);	 //Enable measue		
					udelay(100000);	
					if((rtd_inl(REG_ADC_AUTO_RESULT_PASHE_L)>>8)!=(i+1))
						{
						printk("IP_ADCSF_Verify, color select MAX fail i (R=0,B=1,G=2)=%d,0x%x\n",i,rtd_inl(REG_ADC_AUTO_RESULT_PASHE_L));						
						Fl_pass=FALSE;
						break;
						}
					}
						printk("IP_ADCSF_Verify, color select & compare mode MAX  PASS\n");						
   					rtd_outl(REG_ADC_AUTO_FIELD, rtd_inl(REG_ADC_AUTO_FIELD)|_BIT30); //AutoBalance 3 chs 
					rtd_outl(REG_ADC_AUTO_RGB_MARGIN, 0x04040400|(2<<8));//IPTG R=0x1ff,G=0x3ff B=0x2ff
					udelay(10000);
					rtd_outl(REG_ADC_AUTO_ADJ,rtd_inl(REG_ADC_AUTO_ADJ)| _BIT0);	 //Enable measue		
					udelay(100000);	
					if	((((rtd_inl(REG_ADC_AUTO_RESULT_PASHE_M)&0x3ff)>>2)==((rtd_inl(REG_PTG_C0Y)&0xff00)>>8))&&
						(((rtd_inl(REG_ADC_AUTO_RESULT_PASHE_L)&0x3ff0000)>>18)==((rtd_inl(REG_PTG_C0Y)&0xff)))&&
						(((rtd_inl(REG_ADC_AUTO_RESULT_PASHE_L)&0x3ff)>>2)==((rtd_inl(REG_PTG_C0Y)&0xff0000)>>16)))
							printk("IP_ADCSF_Verify, AutoBalance 3 chs & compare mode MAX  PASS\n");	
					else
						{
							printk("IP_ADCSF_Verify, AutoBalance 3 chs & compare mode MAX  fail\n");	
							Fl_pass=FALSE;
  							break;
						}
   					rtd_outl(REG_ADC_AUTO_FIELD, rtd_inl(REG_ADC_AUTO_FIELD)&(~_BIT30)); //AutoBalance 3 chs disable					
				// MIN		
				rtd_outl(REG_ADC_AUTO_ADJ, _BIT6);//compare mode & min color						

				rtd_outl(REG_ADC_AUTO_V_BOUNDARY, 0x00060100);//set V  boudary , start 2 end 262
				// Clayton 5/12: It seems strange of V-range
				// Old: 0x00040104 ; debug: 0x00060100
				
				udelay(10000);					
				rtd_outl(REG_ADC_AUTO_ADJ,rtd_inl(REG_ADC_AUTO_ADJ)| _BIT0);	 //Enable measue		
				udelay(100000);	
				temp=(~(rtd_inl(REG_ADC_AUTO_RESULT_PASHE_L)))&0x000003ff;
				if( temp==5)
						printk("IP_ADCSF_Verify, color select & compare mode MIN  PASS\n");
				else
					{
						printk("IP_ADCSF_Verify, color select & compare mode MIN  fail 0x%x ; 0x%x\n",temp,(rtd_inl(REG_ADC_AUTO_RESULT_PASHE_L)));
						Fl_pass=FALSE;
					}
				break;
			case 5:	// Pattern area
				// diff_pixel_sel->value
				rtd_outl(REG_ADC_AUTO_ADJ,rtd_inl(REG_ADC_AUTO_ADJ)| _BIT0);	 //Enable measue		
				udelay(100000);
			       rtd_outl(REG_ADC_AUTO_H_BOUNDARY, 0x00920092);//set H  boudary , measure only one vertical line		
			       											    //Clayton 5/15: old--0x00910091, new--0x00920092, H need to right shift 1pixel due to before VGIP
			       rtd_outl(REG_ADC_AUTO_V_BOUNDARY, rtd_inl(REG_ADC_AUTO_RESULT_V));//set H  boudary to active size ,and  measure only one vertical line							       
 				rtd_outl(REG_ADC_AUTO_ADJ, _BIT4);	 //select pixel value & acc mode
				udelay(10000);	
				rtd_outl(REG_ADC_AUTO_ADJ,rtd_inl(REG_ADC_AUTO_ADJ)| _BIT0);	 //Enable measue		
				udelay(100000);	
				temp=rtd_inl(REG_ADC_AUTO_RESULT_PASHE_L);
				temp1=(0x3ff*((rtd_inl(REG_ADC_AUTO_RESULT_V)&0x0000ffff)-(rtd_inl(REG_ADC_AUTO_RESULT_V)>>16)+1) );
				if(temp== temp1)
					printk("IP_ADCSF_Verify, diff_pixel_sel  PASS \n");				
				else
				{
					printk("IP_ADCSF_Verify, diff_pixel_sel  fail 0x%x target=0x%x ; Set_V=0x%x, Result_V=0x%x\n",temp,temp1,rtd_inl(REG_ADC_AUTO_V_BOUNDARY), rtd_inl(REG_ADC_AUTO_RESULT_V));				
					Fl_pass=FALSE;
					break;
				}				
				break;
			case 6://auto phase				
				break;
			default:			
				break;
		}
		// [Clayton][Fix me] by pass first
		// [start]
		//if (Fl_pass==FALSE)
		//break;
		// [end]
}
if (Fl_pass==FALSE)
	return 0;
else
	return 1;

}


BOOL IP_ADCSF_Verify_old(void)
{
UINT8    test_count=0,test_case=6;

UINT32  temp,temp1,i;
bool     Fl_pass=1;

printk("IP_SF_Verify  \n");
//IPTG  Total pixel = 858*262, H start 145 ,width 704, V start 16 active 240

rtd_outl(REG_PTG_TG,rtd_inl(REG_PTG_TG)&(~_BIT0));	 
udelay(100000);	
rtd_outl(REG_PTG_TG,rtd_inl(REG_PTG_TG)|_BIT0);	 
for(test_count=0;test_count<test_case;test_count++)
{
rtd_outl(0xb8022210, 0x90000001);	 //VGIP enable 
rtd_outl(REG_PTG_C0Y, 0x00ffffff);//R=0x1ff,G=0x3ff B=0x2ff
rtd_outl(REG_ADC_AUTO_H_BOUNDARY, 0x00500359);//set H  boudary , start 80 end 858
rtd_outl(REG_ADC_AUTO_V_BOUNDARY, 0x00020106);//set V  boudary , start 2 end 262
rtd_outl(REG_ADC_AUTO_RGB_MARGIN, 0x04040400);//R/G/B Noise MGN 01
rtd_outl(REG_ADC_AUTO_ADJ, 0);//reset adj
rtd_outl(REG_ADC_AUTO_FIELD, 0);//reset field
rtd_outl(0xb8023500, 0x0);//Disable dither
rtd_outl(0xb8023504, 0x0);//diable Dither
	switch(test_count)
		{
			case 0:// test H V boundary & Result HV start/end & VGIP src sel 
				rtd_outl(REG_ADC_AUTO_RGB_MARGIN, 0);		//R/G/B Noise MGN	0
				rtd_outl(REG_ADC_AUTO_ADJ, _BIT0);			//Start Auto-Function Tracking Function
				udelay(100000);	
				temp=YPP_abs(rtd_inl(REG_ADC_AUTO_V_BOUNDARY),rtd_inl(REG_ADC_AUTO_RESULT_V)); //interlace  1 line diff between even/odd
				if((rtd_inl(REG_ADC_AUTO_H_BOUNDARY)==rtd_inl(REG_ADC_AUTO_RESULT_H))&&
					(temp<=1))
					
					printk("IP_ADC_SF_Verify, HV boundary & Result Pass \n");
				else
					{
					printk("IP_ADC_SF_Verify, HV boundary & Result fail H boundary=0x%x,V_boundary=0x%x\n",rtd_inl(REG_ADC_AUTO_RESULT_H),rtd_inl(REG_ADC_AUTO_RESULT_V));
					Fl_pass=FALSE;	
					break;
					}
				rtd_outl(REG_ADC_AUTO_RGB_MARGIN, 0x04040400);	//R/G/B Noise MGN 01
				rtd_outl(REG_ADC_AUTO_ADJ, _BIT0);				//Start Auto-Function Tracking Function
				udelay(100000);	
				if(((rtd_inl(REG_PTG_HSTA_WID)>>16)==((rtd_inl(REG_ADC_AUTO_RESULT_H)>>16)+1))&&   //IPTG H active start
				    ((rtd_inl(REG_PTG_HSTA_WID)&0x0000ffff)==(rtd_inl(REG_ADC_AUTO_RESULT_H)&0x0000fff)-(rtd_inl(REG_ADC_AUTO_RESULT_H)>>16)+1)) //IPGT H width
					{
					printk("IP_ADC_SF_Verify, RGB MGN PASS \n");

					      rtd_outl( VGIP_CHN1_MISC,    rtd_inl(VGIP_CHN1_MISC)|_BIT6); //delay 32 pixel
      					      rtd_outl(REG_ADC_AUTO_FIELD, rtd_inl(VGIP_CHN1_MISC)|_BIT31); //measure after VGIP 
      					      udelay(100000);	
					      rtd_outl(REG_ADC_AUTO_ADJ, _BIT0); //measure before VGIP 
					      udelay(100000);	
					  if((rtd_inl(REG_PTG_HSTA_WID)>>16)==((rtd_inl(REG_ADC_AUTO_RESULT_H)>>16)))
					  	{
		      				      rtd_outl(REG_ADC_AUTO_FIELD, rtd_inl(VGIP_CHN1_MISC)&(~_BIT31)); //measure after VGIP 	      					
						      rtd_outl(REG_ADC_AUTO_ADJ, _BIT0); //measure after VGIP 
					      	      udelay(100000);
						      if((rtd_inl(REG_PTG_HSTA_WID)>>16)==((rtd_inl(REG_ADC_AUTO_RESULT_H)>>16)+1+0x20))
	  						printk("IP_SF_Verify, VGIP src  Pass \n" );
						      else
						      	{
							printk("IP_ADC_SF_Verify, VGIP src (after ) Fail source  REG_PTG_HSTA_WID=%x,REG_ADC_AUTO_RESULT_H=%x\n",rtd_inl(REG_PTG_HSTA_WID),rtd_inl(REG_ADC_AUTO_RESULT_H) );							  	
							Fl_pass=FALSE;
							break;
						      	}
					  	}
					  else
					  	{
					  	printk("IP_ADC_SF_Verify, VGIP src (before ) Fail  \n" );	
						Fl_pass=FALSE;
						break;
					  	}
					  	printk("IP_ADC_SF_Verify, VGIP src (before ) Pass \n" );	
					      rtd_outl( VGIP_CHN1_MISC,    rtd_inl(VGIP_CHN1_MISC)&(~_BIT6)); //delay 0 pixel
					}
				else
					{
					printk("IP_ADC_SF_Verify, RGB MGN fail =0x%x\n",rtd_inl(REG_ADC_AUTO_RESULT_H) );
					Fl_pass=FALSE;						
					break;
					}	
	
				break;
			case 1: //Odd sel en
				rtd_outl(0xb8022210, 0x90000101);	 //VGIP enable  safe-mode->Odd off
				rtd_outl(REG_ADC_AUTO_FIELD, (_BIT7|_BIT6));	 //mesaure odd
				udelay(100000);	
				rtd_outl(REG_ADC_AUTO_ADJ, _BIT0);	 //Enable measue		
				udelay(100000);	
				if(rtd_inl(REG_ADC_AUTO_ADJ)==0)
					{
						printk("IP_ADC_SF_Verify, odd sel fail1 0x%x\n",rtd_inl(REG_ADC_AUTO_ADJ));							
						Fl_pass=FALSE;
						break;						
					}
				else
				rtd_outl(REG_ADC_AUTO_FIELD, _BIT7);	 //VGIP enable  safe-mode->Odd off
					udelay(10000);	
				rtd_outl(REG_ADC_AUTO_ADJ, _BIT0);	 //Enable measue		
				udelay(100000);	
				if(rtd_inl(REG_AUTO_ADJ)!=0)
					{
						printk("IP_ADC_SF_Verify, odd sel fail2 %x\n",rtd_inl(REG_ADC_AUTO_ADJ));							
						Fl_pass=FALSE;
						break;						
					}
				printk("IP_ADC_SF_Verify, odd sel PASS \n");							

				// pulse_det_en & phase/balance mode
			       rtd_outl(REG_ADC_AUTO_H_BOUNDARY, 0x00900091);//set H  boudary , measure only two vertical line  color black->white
				rtd_outl(REG_ADC_AUTO_V_BOUNDARY, rtd_inl(REG_ADC_AUTO_RESULT_V));
				rtd_outl(REG_ADC_AUTO_ADJ,_BIT6| _BIT5|_BIT4|_BIT1);	 //difference&MAX&Acc&Phase		
				udelay(10000);	
				rtd_outl(REG_ADC_AUTO_ADJ,rtd_inl(REG_ADC_AUTO_ADJ)|_BIT0);	 //Enable measue						
				udelay(100000);	
				temp=rtd_inl(REG_ADC_AUTO_RESULT_PASHE_L);  //V active* (1023-5)  sum of difference

				rtd_outl(REG_ADC_AUTO_ADJ,_BIT6|_BIT5|_BIT4|_BIT3|_BIT1);	    ////difference&MAX&Acc&Phase  + pulse_det_en, the result will be double
				udelay(10000);	
				rtd_outl(REG_ADC_AUTO_ADJ,rtd_inl(REG_ADC_AUTO_ADJ)|_BIT0);	 //Enable measue						
				udelay(100000);	
				temp1=rtd_inl(REG_ADC_AUTO_RESULT_PASHE_L);				
				if (temp*2==temp1)
				printk("IP_ADC_SF_Verify, pulse_det_en PASS \n");												
				else
				{
				printk("IP_ADC_SF_Verify, pulse_det_en fail 0x%x\n", temp1);				
				Fl_pass=FALSE;
				}
				break;
				
			case 2://RGB_in_one_en & square_en
			        //Measure R
				rtd_outl(REG_ADC_AUTO_RGB_MARGIN, 0x00000000);//Noise MGN 0
				rtd_outl(REG_ADC_AUTO_ADJ, _BIT4|_BIT6);	 //differ & accu
				udelay(10000);	
				rtd_outl(REG_ADC_AUTO_ADJ,rtd_inl(REG_ADC_AUTO_ADJ)| _BIT0);	 //Enable measue		
				udelay(100000);	
				temp=rtd_inl(REG_ADC_AUTO_RESULT_PASHE_L);
			        //Measure G
				rtd_outl(REG_ADC_AUTO_RGB_MARGIN, 0x00000100);//Noise MGN 0
				rtd_outl(REG_ADC_AUTO_ADJ, _BIT4|_BIT6);	 //differ & accu
				udelay(10000);	
				rtd_outl(REG_ADC_AUTO_ADJ,rtd_inl(REG_ADC_AUTO_ADJ)| _BIT0);	 //Enable measue		
				udelay(100000);	
				temp=temp+rtd_inl(REG_ADC_AUTO_RESULT_PASHE_L);
			        //Measure B
				rtd_outl(REG_ADC_AUTO_RGB_MARGIN, 0x00000200);//Noise MGN 0
				rtd_outl(REG_ADC_AUTO_ADJ, _BIT4|_BIT6);	 //differ & accu
				udelay(10000);	
				rtd_outl(REG_ADC_AUTO_ADJ,rtd_inl(REG_ADC_AUTO_ADJ)| _BIT0);	 //Enable measue		
				udelay(100000);	
				temp=temp+rtd_inl(REG_ADC_AUTO_RESULT_PASHE_L);


				rtd_outl(REG_ADC_AUTO_FIELD,_BIT4);	 //RGB together
				udelay(10000);	
				rtd_outl(REG_ADC_AUTO_ADJ,rtd_inl(REG_ADC_AUTO_ADJ)| _BIT0);	 //Enable measue		
				udelay(100000);	
				temp1=rtd_inl(REG_ADC_AUTO_RESULT_PASHE_L);
				
				if(YPP_abs(temp,temp1)<0x0000100)
				printk("IP_ADC_SF_Verify, RGB_in_one_en  PASS,SumRGB=%x,in_one=%x _BIT4|_BIT6 \n",temp,temp1);
				else
					{
					printk("IP_ADC_SF_Verify, RGB_in_one_en  fail ,temp=0x%x,temp1=0x%x\n",temp,temp1);
					printk("fail ,b8020410=0x%x,b8020400=0x%x\n",rtd_inl(REG_ADC_AUTO_ADJ),rtd_inl(REG_ADC_AUTO_FIELD));
					//printk("fail ,temp=0x%x,temp1=0x%x\n",temp,temp1);
					Fl_pass=FALSE;
					break;
					}
				rtd_outl(REG_ADC_AUTO_FIELD,_BIT4|_BIT3);	 //RGB together/square_en
				udelay(10000);	
				rtd_outl(REG_ADC_AUTO_ADJ,rtd_inl(REG_ADC_AUTO_ADJ)| _BIT0);	 //Enable measue		
				udelay(100000);	
				temp1=rtd_inl(REG_ADC_AUTO_RESULT_PASHE_L);			// RGB togeter value= diff, temp1= (diff/16) * (diff/16)
				rtd_outl(REG_ADC_AUTO_RGB_MARGIN, 0x04040400);//R/G/B pixel noise margin  04
				
				if(temp>temp1)					
					printk("IP_ADC_SF_Verify, square_en  PASS \n");
				else
					{
					
					printk("IP_ADC_SF_Verify, square_en  fail temp1=%x\n",temp1);
					Fl_pass=FALSE;
					break;
					}
				break;
			case 3: //sum of pixel  &  even/odd pixel

			       // sum of pixel
			       rtd_outl(REG_ADC_AUTO_H_BOUNDARY, 0x00900091);//set H  boudary , measure only two vertical line
   				rtd_outl(REG_ADC_AUTO_FIELD, _BIT2);	 //pixel number mode
 				rtd_outl(REG_ADC_AUTO_ADJ, _BIT6|_BIT4);	 //pixel number mode
				udelay(10000);	
				rtd_outl(REG_ADC_AUTO_ADJ,rtd_inl(REG_ADC_AUTO_ADJ)| _BIT0);	 //Enable measue		
				udelay(100000);	
				temp=rtd_inl(REG_ADC_AUTO_RESULT_PASHE_L);
				temp1=YPP_abs(temp,(((rtd_inl(REG_ADC_AUTO_H_BOUNDARY)&0x0000ffff)-(rtd_inl(REG_ADC_AUTO_H_BOUNDARY)>>16)+1)* 
						  ((rtd_inl(REG_ADC_AUTO_V_BOUNDARY)&0x0000ffff)-(rtd_inl(REG_ADC_AUTO_V_BOUNDARY)>>16)+1))); //| temp - (H start - H end +1)*(V start - V end +1) |
				if(temp1<=2)
					printk("IP_ADC_SF_Verify, sum_pixel_num  PASS \n");
				else
					{
					printk("IP_ADC_SF_Verify, sum_pixel_num fail \n");
					Fl_pass=FALSE;
					break;
					}			
				// even/odd pixel
				rtd_outl(REG_ADC_AUTO_RGB_MARGIN, 0x07040400);//R/G/B pixel noise margin  04, enable odd pixel measure 
				udelay(10000);
				rtd_outl(REG_ADC_AUTO_ADJ,rtd_inl(REG_ADC_AUTO_ADJ)| _BIT0);	 //Enable measue		
				udelay(100000);	
				if(((temp/2)+2)>rtd_inl(REG_ADC_AUTO_RESULT_PASHE_L))
					printk("IP_ADC_SF_Verify, even/odd pixel select  PASS \n");
				else
					{
					printk("IP_ADC_SF_Verify, even/odd pixel select  fail 0x%x\n",rtd_inl(REG_ADC_AUTO_RESULT_PASHE_L));
					Fl_pass=FALSE;
					}
				break;
				
			case 4: // compare mode / color select  & MAX/MIN /RGB balance
				rtd_outl(REG_PTG_C0Y, 0x00ff7fbf);//IPTG R=0x1ff,G=0x3ff B=0x2ff
				rtd_outl(REG_ADC_AUTO_H_BOUNDARY, 0x009300B0);	
				rtd_outl(REG_ADC_AUTO_ADJ, _BIT6|_BIT5);//compare mode & max color
				for(i=0;i<3;i++)
					{
					rtd_outl(REG_ADC_AUTO_RGB_MARGIN, 0x04040400|(i<<8));//IPTG R=0x1ff,G=0x3ff B=0x2ff
					udelay(10000);
					rtd_outl(REG_ADC_AUTO_ADJ,rtd_inl(REG_ADC_AUTO_ADJ)| _BIT0);	 //Enable measue		
					udelay(100000);	
					if((rtd_inl(REG_ADC_AUTO_RESULT_PASHE_L)>>8)!=(i+1))
						{
						printk("IP_ADC_SF_Verify, color select MAX fail i (R=0,B=1,G=2)=%d,0x%x\n",i,rtd_inl(REG_ADC_AUTO_RESULT_PASHE_L));						
						Fl_pass=FALSE;
						break;
						}
					}
						printk("IP_ADC_SF_Verify, color select & compare mode MAX  PASS\n");						
   					rtd_outl(REG_ADC_AUTO_FIELD, rtd_inl(VGIP_CHN1_MISC)|_BIT30); //AutoBalance 3 chs 
					rtd_outl(REG_ADC_AUTO_RGB_MARGIN, 0x04040400|(2<<8));//IPTG R=0x1ff,G=0x3ff B=0x2ff
					udelay(10000);
					rtd_outl(REG_ADC_AUTO_ADJ,rtd_inl(REG_ADC_AUTO_ADJ)| _BIT0);	 //Enable measue		
					udelay(100000);	
					if	((((rtd_inl(REG_ADC_AUTO_RESULT_PASHE_M)&0x3ff)>>2)==((rtd_inl(REG_PTG_C0Y)&0xff00)>>8))&&
						(((rtd_inl(REG_ADC_AUTO_RESULT_PASHE_L)&0x3ff0000)>>18)==((rtd_inl(REG_PTG_C0Y)&0xff)))&&
						(((rtd_inl(REG_ADC_AUTO_RESULT_PASHE_L)&0x3ff)>>2)==((rtd_inl(REG_PTG_C0Y)&0xff0000)>>16)))
							printk("IP_ADC_SF_Verify, AutoBalance 3 chs & compare mode MAX  PASS\n");	
					else
						{
							printk("IP_ADC_SF_Verify, AutoBalance 3 chs & compare mode MAX  fail\n");	
							Fl_pass=FALSE;
  							break;
						}
   					rtd_outl(REG_ADC_AUTO_FIELD, rtd_inl(VGIP_CHN1_MISC)&(~_BIT30)); //AutoBalance 3 chs disable					
				// MIN		
				rtd_outl(REG_ADC_AUTO_ADJ, _BIT6);//compare mode & min color						

				rtd_outl(REG_ADC_AUTO_V_BOUNDARY, 0x00040104);//set V  boudary , start 2 end 262
				udelay(10000);					
				rtd_outl(REG_ADC_AUTO_ADJ,rtd_inl(REG_ADC_AUTO_ADJ)| _BIT0);	 //Enable measue		
				udelay(100000);	
				temp=(~(rtd_inl(REG_ADC_AUTO_RESULT_PASHE_L)))&0x000003ff;
				if( temp==5)
						printk("IP_ADC_SF_Verify, color select & compare mode MIN  PASS\n");
				else
					{
						printk("IP_ADC_SF_Verify, color select & compare mode MIN  fail 0x%x \n",temp);
						Fl_pass=FALSE;
					}
				break;
			case 5:
				// diff_pixel_sel->value
				rtd_outl(REG_ADC_AUTO_ADJ,rtd_inl(REG_ADC_AUTO_ADJ)| _BIT0);	 //Enable measue		
				udelay(100000);
			       rtd_outl(REG_ADC_AUTO_H_BOUNDARY, 0x00910091);//set H  boudary , measure only one vertical line				
			       rtd_outl(REG_ADC_AUTO_V_BOUNDARY, rtd_inl(REG_ADC_AUTO_RESULT_V));//set H  boudary to active size ,and  measure only one vertical line							       
 				rtd_outl(REG_ADC_AUTO_ADJ, _BIT4);	 //select pixel value & acc mode
				udelay(10000);	
				rtd_outl(REG_ADC_AUTO_ADJ,rtd_inl(REG_ADC_AUTO_ADJ)| _BIT0);	 //Enable measue		
				udelay(100000);	
				temp=rtd_inl(REG_ADC_AUTO_RESULT_PASHE_L);
				temp1=(0x3ff*((rtd_inl(REG_ADC_AUTO_RESULT_V)&0x0000ffff)-(rtd_inl(REG_ADC_AUTO_RESULT_V)>>16)+1) );
				if(temp== temp1)
					printk("IP_ADC_SF_Verify, diff_pixel_sel  PASS \n");				
				else
				{
					printk("IP_ADC_SF_Verify, diff_pixel_sel  fail 0x%x target=0x%x \n",temp,temp1);				
					Fl_pass=FALSE;
					break;
				}				
				break;
			case 6://auto phase				
				break;
			default:			
				break;
		}
		if (Fl_pass==FALSE)
		break;
}
if (Fl_pass==FALSE)
	return 0;
else
	return 1;

}
BOOL IP_RingingFilter_Verify(void)
{
#if 0
UINT8    test_count=0,test_case=6;

UINT32  temp,temp1,i;
bool     Fl_pass=1;


if (Fl_pass==FALSE)
	return 1;
else
#endif	
	return 0;

}

BOOL IP_SP_Verify(void)
{
UINT8    test_count=0,test_case=7,i;   // test_case can modify to 5
UINT32  temp;
bool     Fl_pass=1;

printk("IP_SP_Verify  \n");



//IPTG  Total pixel = 858*262, H start 145 ,width 704, V start 16 active 240
for(test_count=0;test_count<test_case;test_count++)
{
		rtd_outl(REG_SP1_CTRL,0);// source select PTG ,decomp disable (de_hs=hs_raw,de_vs=vs_raw)
		rtd_outl(REG_PTG_TG,(rtd_inl(REG_PTG_TG)&0xfffffffd));   // Set progressive	,  0xb802210c[1]=0: disable, frame format						
		switch(test_count)
			{
			case 0: //offline measure
				rtd_outl(REG_SP1_CTRL,0);// source select PTG ,decomp disable (de_hs=hs_raw,de_vs=vs_raw)
				udelay(1000);	
				rtd_outl(REG_SP_MS3CTRL ,_BIT9|_BIT10);//auto mode , enable
				udelay(100000);		
				rtd_outl(REG_SP_MS3CTRL ,_BIT9|_BIT10|_BIT12);//pop up
				udelay(200000);	
				temp=rtd_inl(REG_SP_MS3CTRL);

/*
				#if defined(CONFIG_BGA21_QC) || defined(CONFIG_BGA23_QC) || defined(CONFIG_QFP156_QC)	//Clayton: Fix me, check why?
                            #else
				if(temp&0x00200000)
					printk("IP_SP_Offline_Verify, off_ms_now  PASS \n");				
				else{
					printk("IP_SP_Offline_Verify, off_ms_now  Fail,temp=0x%x \n",temp);					
					Fl_pass=FALSE;
					break;
					}
				#endif
*/

				udelay(200000);		
				temp=rtd_inl(REG_SP_MS3RST0);
				temp=YPP_abs(((temp&0x00000fff)),(rtd_inl(REG_PTG_TOTALHV)&0x00000fff)); 	// | REG_SP_MS3RST0[30:18] - PTG input[12:0]  | <= 1 , Pass
				//printk("REG_PTG_TOTALHV0x%x\n",rtd_inl(REG_PTG_TOTALHV)); 

				if(temp<=1)
					printk("IP_SP_Offline_Verify, V period  PASS \n");						
				else{
					printk("IP_SP_Offline_Verify, V period  fail , temp=0x%x\n",temp);									
					Fl_pass=FALSE;
					break;
					}

			
				temp=rtd_inl(REG_SP_MS3RST1);
				temp=YPP_abs(((temp&0x0000fff0)>>4),2*((rtd_inl(REG_PTG_TOTALHV)&0x0fff0000)>>16));	// | REG_SP_MS3RST0[17:4] - 2 * PTG input[28:16]  | <= 3 , Pass
				if(temp<=3)
					printk("IP_SP_Offline_Verify, H period  PASS \n");						
				else{
					printk("IP_SP_Offline_Verify, H period  fail , temp=0x%x,measure=0x%x,IPTG=0x%x\n",temp,rtd_inl(REG_SP_MS3RST0),rtd_inl(REG_PTG_TOTALHV));									
					Fl_pass=FALSE;
					break;
					}


				temp=rtd_inl(REG_SP_MS3Stus);
				temp=YPP_abs((temp&0x00003fff),2*16*(((rtd_inl(REG_PTG_TG)&0x00000300)>>8)+1));	// | REG_SP_MS3RST1[13:0] - 2 * 16 * (REG_PTG_TG[9:8]+1)  | <= 3 , Pass
				if(temp<=3)
					printk("IP_SP_Offline_Verify, H high period  PASS \n");						
				else{
					printk("IP_SP_Offline_Verify, H high period  fail , temp=0x%x\n",temp);									
					Fl_pass=FALSE;
					break;
					}

				temp=rtd_inl(REG_SP_MS3Stus);
				temp=YPP_abs(((temp&0x1fff0000)>>16),4);	// | REG_SP_MS3RST1[28:16] - 4  | <= 3 , Pass
				if(temp<=3)
					printk("IP_SP_Offline_Verify, V high period  PASS \n");						
				else{
					printk("IP_SP_Offline_Verify, V high period  fail , temp=0x%x\n",temp);									
					Fl_pass=FALSE;
					break;					
					}		
				break;

			case 2: //Off line measure source
				rtd_outl(REG_SP1_CTRL,0x400);// SP1 source select PTG ,decomp enable (de_hs!=hs_raw,de_vs!=vs_raw)				
//				rtd_outl(0xb8021000,0x400);// SP1 source select PTG ,decomp enable (de_hs!=hs_raw,de_vs!=vs_raw)				

				
				udelay(3000);				
				for(i=0;i<8;i++)
					{
					rtd_outl(REG_SP_MS3CTRL ,(i<<16)|_BIT9|_BIT10);//auto mode , enable
					udelay(60000);		//add delay ; old: 30ms ->New: 60ms
					rtd_outl(REG_SP_MS3CTRL ,(i<<16)|_BIT9|_BIT10|_BIT12);//pop up
					udelay(60000);
					temp=rtd_inl(REG_SP_MS3RST0);
					if((i!=2)&&(i!=3)&&(i!=6)&&(i!=7))//no sp2, i=0,1,4,5
												    // i=0: Off_meas_source=0x0 , PatternGen/JPEG
												    // i=1: Off_meas_source=0x1 , adc_hs/adc_vs
												    // i=4: Off_meas_source=0x4 , hs_raw1/vs_raw1
												    // i=5: Off_meas_source=0x5 , de_hs1/de_hs1
						{
							temp=YPP_abs((temp&0x00000fff),(rtd_inl(REG_PTG_TOTALHV)&0x00000fff));
							//printk("IP_SP_Offline_Verify, source select check , temp=0x%x, Totalv_line=0x%x, i=%d\n",temp,(rtd_inl(REG_PTG_TOTALHV)&0x00000fff),i);
							if(temp>1)
							{
								printk("IP_SP_Offline_Verify, source select fail , temp=0x%x, Totalv_line=0x%x, i=%d\n",temp,(rtd_inl(REG_PTG_TOTALHV)&0x00000fff),i);									
								Fl_pass=FALSE;
								break;
							}				
						}
					}
				if(Fl_pass==TRUE)
								printk("IP_SP_Offline_Verify, source select Pass \n");														
				break;
				
			case 3: //online measure1
				rtd_outl(REG_SP1_CTRL,0);// source select PTG ,decomp disable (de_hs=hs_raw,de_vs=vs_raw)
				udelay(1000);	
				rtd_outl(REG_SP_MS1CTRL ,_BIT0|_BIT1);//auto mode , enable , measure VS or HS or DEN by crystal clock , Measure Source from VGIP Input
				udelay(100000);		
				rtd_outl(REG_SP_MS1CTRL ,_BIT0|_BIT1|_BIT2);//pop up
				udelay(2000);	
//				temp=rtd_inl(REG_SP_MS1CTRL);

//				if(temp&0x00200000)
//					printk("IP_SP_Online_Verify, off_ms_now  PASS \n");				
//				else{
//					printk("IP_SP_Online_Verify, off_ms_now  Fail,temp=0x%x \n",temp);					
//					Fl_pass=FALSE;
//					}

				udelay(2000);		
				temp=rtd_inl(REG_onms1_vs_period);
				temp=YPP_abs((temp&0x00003fff),(rtd_inl(REG_PTG_TOTALHV)&0x00000fff));
				if(temp<=1)
					printk("IP_SP_Online1_Verify, V period  PASS \n");						
				else{
					printk("IP_SP_Online1_Verify, V period  fail , temp=0x%x\n",temp);									
					Fl_pass=FALSE;
					}

			
				temp=rtd_inl(REG_onms1_hs_period);
				temp=YPP_abs(((temp&0x0000fff0)>>4),2*((rtd_inl(REG_PTG_TOTALHV)&0x0fff0000)>>16));	
				if(temp<=3)
					printk("IP_SP_Online1_Verify, H period  PASS \n");						
				else{
					printk("IP_SP_Online1_Verify, H period  fail , temp=0x%x\n",temp);									
					Fl_pass=FALSE;
					}


				temp=rtd_inl(REG_onms1_vshs_high_period);
				temp=YPP_abs((temp&0x00003fff),2*16*(((rtd_inl(REG_PTG_TG)&0x00000300)>>8)+1));	
				if(temp<=3)
					printk("IP_SP_Online1_Verify, H high period  PASS \n");						
				else{
					printk("IP_SP_Online1_Verify, H high period  fail , temp=0x%x\n",temp);									
					Fl_pass=FALSE;
					}

				temp=rtd_inl(REG_onms1_vshs_high_period);
				temp=YPP_abs(((temp&0x1fff0000)>>16),4);	
				if(temp<=3)
					printk("IP_SP_Online1_Verify, V high period  PASS \n");						
				else{
					printk("IP_SP_Online1_Verify, V high period  fail , temp=0x%x\n",temp);									
					Fl_pass=FALSE;
					}		
				break;

			case 4: //online measure1
				rtd_outl(REG_SP1_CTRL,0);// source select PTG ,decomp disable (de_hs=hs_raw,de_vs=vs_raw)
				udelay(1000);	
				rtd_outl(REG_SP_MS1CTRL ,_BIT0|_BIT1|_BIT5);//auto mode , enable, APLL clock
				udelay(100000);		
				rtd_outl(REG_SP_MS1CTRL ,_BIT0|_BIT1|_BIT2|_BIT5);//pop up
				udelay(2000);	
				temp=rtd_inl(REG_onms1_hs_period);
				
				temp=YPP_abs(((temp&0x0003fff0)>>4),((rtd_inl(REG_PTG_TOTALHV)&0x1fff0000)>>16));	
				
				if(temp<=3)
					printk("IP_SP_Online1_Verify, measure by APLL clock  PASS \n");						
				else{
					printk("IP_SP_Online1_Verify, measure by APLL clock  fail , temp=0x%x\n",temp);									
					Fl_pass=FALSE;
					}

				
				break;
#if 0   // MacArthur has no sub channel
			case 5: //online measure2
					rtd_outl(0xb8021000,0);// source select PTG ,decomp disable (de_hs=hs_raw,de_vs=vs_raw)
					rtd_outl(0xb8022244,0x90000001);				//Enable VGIP2 
					udelay(100000);	
					rtd_outl(REG_SP_MS2CTRL ,_BIT9|_BIT10);//auto mode , enable
					udelay(100000);		
					rtd_outl(REG_SP_MS2CTRL ,_BIT9|_BIT10|_BIT12);//pop up
					udelay(200000);	
	//				temp=rtd_inl(REG_SP_MS1CTRL);

	//				if(temp&0x00200000)
	//					printk("IP_SP_Online_Verify, off_ms_now  PASS \n");				
	//				else{
	//					printk("IP_SP_Online_Verify, off_ms_now  Fail,temp=0x%x \n",temp);					
	//					Fl_pass=FALSE;
	//					}

					udelay(200000);		
					temp=rtd_inl(REG_SP_MS2RST0);
					temp=YPP_abs(((temp&0x0fff0000)>>16),(rtd_inl(REG_PTG_TOTALHV)&0x00000fff));
					if(temp<=1)
						printk("IP_SP_Online2_Verify, V period  PASS \n");						
					else{
						printk("IP_SP_Online2_Verify, V period  fail , temp=0x%x\n",temp);									
						Fl_pass=FALSE;
						}

				
					temp=rtd_inl(REG_SP_MS2RST0);
					temp=YPP_abs(((temp&0x0000fff0)>>4),2*((rtd_inl(REG_PTG_TOTALHV)&0x0fff0000)>>16));	
					if(temp<=3)
						printk("IP_SP_Online2_Verify, H period  PASS \n");						
					else{
						printk("IP_SP_Online2_Verify, H period  fail , temp=0x%x\n",temp);									
						Fl_pass=FALSE;
						}


					temp=rtd_inl(REG_SP_MS2RST1);
					temp=YPP_abs((temp&0x0000ffff),2*16*(((rtd_inl(REG_PTG_TG)&0x00000300)>>8)+1));	
					if(temp<=3)
						printk("IP_SP_Online2_Verify, H high period  PASS \n");						
					else{
						printk("IP_SP_Online2_Verify, H high period  fail , temp=0x%x\n",temp);									
						Fl_pass=FALSE;
						}

					temp=rtd_inl(REG_SP_MS2RST1);
					temp=YPP_abs(((temp&0x0fff0000)>>16),4);	
					if(temp<=3)
						printk("IP_SP_Online2_Verify, V high period  PASS \n");						
					else{
						printk("IP_SP_Online2_Verify, V high period  fail , temp=0x%x\n",temp);									
						Fl_pass=FALSE;
						}		
					break;

				case 6: //online measure2
					rtd_outl(0xb8021000,0);// source select PTG ,decomp disable (de_hs=hs_raw,de_vs=vs_raw)
					udelay(1000);	
					rtd_outl(REG_SP_MS2CTRL ,_BIT9|_BIT10|_BIT16);//auto mode , enable, APLL clock
					udelay(100000);		
					rtd_outl(REG_SP_MS2CTRL ,_BIT9|_BIT10|_BIT12|_BIT16);//pop up
					udelay(200000);	
					temp=rtd_inl(REG_SP_MS2RST0);
					temp=YPP_abs(((temp&0x0000fff0)>>4),((rtd_inl(REG_PTG_TOTALHV)&0x0fff0000)>>16));	
					if(temp<=3)
						printk("IP_SP_Online2_Verify, measure by APLL clock  PASS \n");						
					else{
						printk("IP_SP_Online2_Verify, measure by APLL clock  fail , temp=0x%x\n",temp);									
						Fl_pass=FALSE;
						}					
					break;				
#endif				
			default:
				break;
			}
		if (Fl_pass==FALSE)
		break;
}
if (Fl_pass==FALSE)
	return 0;
else
	return 1;

}
//#if 1           //20130822
BOOL IP_3D_ONMS_Verify(void)
{
UINT8    test_count=0,test_case=15;
//IPTG  Total pixel = 858*262, H start 145 ,width 704, V start 16 active 240

	//UINT32	FL_case=0xFFFFFFFF;	
	bool	Fl_pass=1;
	UINT32	rgb2yuv=0;
	UINT32 cnt_n=0;
	
	UINT32	active_space_1=0,active_space_2=0,active_space_3=0;
	UINT32	Vtotalde=0,Vtotal=0,Vs_high_period=0,Hs_high_period=0;
	UINT32	Hact=0,htotal=0,Vblank_len=0,Vact_start=0;
	
	UINT32	onms_vact_space1_max_info=0;
	UINT32	onms_vact_space2_max_info=0;
	UINT32	onms_vact_space3_max_info=0;
	UINT32	onms_vact_space1_min_info=0;
	UINT32	onms_vact_space2_min_info=0;
	UINT32	onms_vact_space3_min_info=0;

	UINT32	Get_r_value=0,Get_g_value=0,Get_b_value=0;
	UINT32	L_blank_line_end=0,R_blank_line_start=0;

	printk(" === IP_3D_ONMS_Verify === \n");

//=================================//
//=== set hdmi 1080p to display ===//
//=================================//
#if 0
#include "apll_ipg1080p.tbl"				// apll setting
#include "sp_ipg.tbl"						// sync processor to select hs/vs from ipg
#include "vgip_ch1_ipg_1080p.tbl"			// vgip ch1 for ipg
#include "rgb2yuvch1_dis.tbl"                   // rgb2yuv disable
#include "uzd_ch1_444_10b_bypass1080p.tbl"	// UZD 444 10b bypass , UZD disable
#include "di_bypass_ch1.tbl"				// bypass de-interlace
#include "ivs2dvs_1080p_fhd.tbl"			// ivs2dvs delay
#include "m_ch1_frc_1080p10b444.tbl"		// M-domain setting
#include "dpll_fhd_1080p_dibypass.tbl"		// DPLL setting for fhd
#include "dtg_fhd.tbl"						// DTG for full hd setting
#include "mtg_fhd.tbl"						// MTG for 1920x1080 setting
#include "uzu_main_444_bypass1080p.tbl"		// UZU for 444 bypass, UZU enable
#include "yuv2rgb_main_en.tbl"				// yuv 2 rgb main enable
#include "LVDS_Pin_Share.tbl"				// LVDS Control setting
#else

//#include "case4_ipg1080p_3d_297Mhz/apll_ipg1080p.tbl"            //Sirius Mark Script ------------------------2014.01.06

//=================test IPTG 3D and 3d onms=================================================

//=== HDMI 3D PTG Setting ===//  HDMI Mac setting and clock 297Mhz



//rtd_outl(0xb8000910,0x00000006); //select hdmi debug output?
rtd_outl(0xb800da40,0x03000000); //enable bandgap
rtd_outl(0xb800d048,0x00000180); //deep color clock output = enable,Enable HDMI deep color mode = enable
rtd_outl(0xb800d098,0x00000008); //video enable
rtd_outl(0xb800d018,0x00000220); //auto output enable, output clk enable
rtd_outl(0xb800d400,0x07e0005b); //M = 31+2;N = 1+2,output clk div1
rtd_outl(0xb800d404,0x00070289); //power down
rtd_outl(0xb800d410,0x00000010); //input clk = X'tal, output clk = PLL, double buffer M,N,O code
rtd_outl(0xb800d414,0x00000000); //div oclk by 1
rtd_outl(0xb800d404,0x00070288); //power up
//delay(1ms);
rtd_outl(0xb800d404,0x00070a88); //cmp enable = 1 after power up
//delay(100us);
rtd_outl(0xb800d404,0x00071a88); //latch cal after power up
//============================================================================================

												  		//Sirius Mark Script ------------------------2014.01.06
//#include "case4_ipg1080p_3d_297Mhz/ipg_1080p.tbl"     //add adc setting select hdmi 297Mhz clock for IPTG 

//#include "case4_ipg1080p_3d_297Mhz/sp_ipg.tbl"         //Sirius Mark Script ------------------------2014.01.06
//#include "case4_ipg1080p_3d_297Mhz/vgip_ch1_ipg_1080p.tbl"//Sirius Mark Script ------------------------2014.01.06



#endif
	

	rgb2yuv=(rtd_inl(0xb800d0bc)>>18)&0x3;		//read color space mode
	if (rgb2yuv == 0x0)
		{
		rtd_maskl(0xb8023000,~(_BIT1|_BIT0),0x0);	//rgb2yuv disable
		rtd_maskl(0xb802a700,~_BIT0,0x0);			//yuv2rgb disable
		}
	else
		{
		rtd_maskl(0xb802a700,~_BIT0,_BIT0); 		//yuv2rgb enable
		}

	//rtd_maskl(0xb8023000,0x00000020);			//rgb2yuv disable
	//rtd_maskl(0xb802a700,0x00000002);			//yuv2rgb disable


								

//===========================//
//=== HDMI 3D PTG Setting ===//
//===========================//
	//#include "hdmi_3D_PTG_1080P.tbl"		// 3D PTG
//	rtd_outl(0xb800d580,0x0000000e); //HDMI Output Source = PTG , bypass fifo = diable

	//////HDMI MAC Setting//////
//	rtd_outl(0xb8000910,0x00000006); //select hdmi debug output
//	rtd_outl(0xb800da40,0x02000000); //enable bandgap
//	rtd_outl(0xb800d028,0x000001d0); //debug output select = dbg_out_29 , test pin[0]= dpclk_buf
//	rtd_outl(0xb800d048,0x00000180); //deep color clock output = enable,Enable HDMI deep color mode = enable
//	rtd_outl(0xb800d098,0x00000008); //video enable
//	rtd_outl(0xb800d018,0x00000220); //auto output enable, output clk enable
//	rtd_outl(0xb800d400,0x07e0005b); //M = 31+2;N = 1+2,output clk div1
//	rtd_outl(0xb800d404,0x00070289); //power down
//	rtd_outl(0xb800d410,0x00000010); //input clk = X'tal, output clk = PLL, double buffer M,N,O code
//	rtd_outl(0xb800d414,0x00000000); //div oclk by 1
//	rtd_outl(0xb800d404,0x00070288); //power up
	//delay(1ms);
//	rtd_outl(0xb800d404,0x00070a88); //cmp enable = 1 after power up
	//delay(100us);
//	rtd_outl(0xb800d404,0x00071a88); //latch cal after power up

#if 0
	//////HDMI 3D PTG Setting///////
	rtd_outl(0xb800d50c,0x00000006); //PTG disable
	rtd_outl(0xb800d500,0x08980465); //Input horizontal total pixel = 2200,when 3D mode, vertical total lines =1125*2
	//rtd_outl(0xb800d504,0x00c00780); //Hstart = 192 , Active Video Width = 1920
	//rtd_outl(0xb800d508,0x00290438); //Vstart = 41 , Active Video Length = 1080
	rtd_outl(0xb800d504,0x008c0780); //Hstart = 140 , Active Video Width = 1920
	rtd_outl(0xb800d508,0x00160438); //Vstart = 22 , Active Video Length = 1080

	rtd_outl(0xb800d514,0x008c0780); //pattern Hstart = 202 , pattern width = 1920
	rtd_outl(0xb800d518,0x00160438); //pattern Vstart = 21 , pattern length = 1080

	rtd_outl(0xb800d520,0x00000003); //L PTG mode = Veritical color bar
	rtd_outl(0xb800d524,0x000000f0); //L single bar width =
	//rtd_outl(0xb800d528,0x00d1f05a); //L Color0 = Red(0x0051f05a) //for DE Xdebug pin(Y bit8 =1)
	rtd_outl(0xb800d528,0x0051f05a); //L Color0 = Red
	rtd_outl(0xb800d52c,0x00296ef0); //L Color1 = Blue
	rtd_outl(0xb800d530,0x00913622); //L Color2 = Green
	rtd_outl(0xb800d548,0x00000fff); //L Max color count = 1

	rtd_outl(0xb800d550,0x00000003); //R PTG mode = Veritical color bar
	rtd_outl(0xb800d554,0x000000f0); //R single bar width =
	rtd_outl(0xb800d558,0x00296ef0); //R Color0 = Blue
	rtd_outl(0xb800d55c,0x0051f05a); //R Color1 = Red
	rtd_outl(0xb800d560,0x00913622); //R Color2 = Green
	rtd_outl(0xb800d578,0x00000fff); //R Max color count = 1

	rtd_outl(0xb800d50c,0x00000005); //fix L flag disable,mode = 3D mode , PTG enable
	rtd_outl(0xb800d580,0x0000000e); //HDMI Output Source = PTG , bypass fifo = diable
	//rtd_outl(0xb800d580,0x0000001d); //HDMI Output Source = PTG , bypass fifo = enable
#else
	rtd_outl(REG_PTG_TG,0x00000006); //PTG disable
	rtd_outl(REG_PTG_TOTALHV,0x08980465); //Input horizontal total pixel = 2200,when 3D mode, vertical total lines =1125*2 
	rtd_outl(REG_PTG_H_STA_WID,0x008c0780); //Hstart = 140 , Active Video Width = 1920
	rtd_outl(REG_PTG_V_STA_LEN,0x00160438); //Vstart = 22 , Active Video Length = 1080

	rtd_outl(REG_PTG_HSTA_WID,0x008c0780); //pattern Hstart = 202 , pattern width = 1920
	rtd_outl(REG_PTG_VSTA_LEN,0x00160438); //pattern Vstart = 21 , pattern length = 1080
	rtd_outl(REG_R_PTG_HSTA_WID,0x008c0780); //pattern Hstart = 202 , pattern width = 1920
	rtd_outl(REG_R_PTG_VSTA_LEN,0x00160438); //pattern Vstart = 21 , pattern length = 1080

	rtd_outl(REG_PTG_CTRL,0x00000003); //L PTG mode = Veritical color bar
	rtd_outl(REG_PTG_BARW,0x000000f0); //L single bar width =
	//rtd_outl(0xb800d528,0x00d1f05a); //L Color0 = Red(0x0051f05a) //for DE Xdebug pin(Y bit8 =1)
	rtd_outl(REG_PTG_C0Y,0x0051f05a); //L Color0 = Red
	rtd_outl(REG_PTG_C1Y,0x00296ef0); //L Color1 = Blue
	rtd_outl(REG_PTG_C2Y,0x00913622); //L Color2 = Green
	rtd_outl(REG_PTG_C7Y,0x10808000); //color bar =1
	rtd_outl(REG_PTG_MAX_COLOR_CTRL,0x00000fff); //L Max color count = 1
 
	rtd_outl(REG_R_PTG_CTRL,0x00000003); //R PTG mode = Veritical color bar
	rtd_outl(REG_R_PTG_BARW,0x000000f0); //R single bar width =
	rtd_outl(REG_R_PTG_C0Y,0x00296ef0); //R Color0 = Blue
	rtd_outl(REG_R_PTG_C1Y,0x0051f05a); //R Color1 = Red
	rtd_outl(REG_R_PTG_C2Y,0x00913622); //R Color2 = Green
	rtd_outl(REG_R_PTG_C7Y,0x10808000); //color bar =1
	rtd_outl(REG_R_PTG_MAX_COLOR_CTRL,0x00000fff); //R Max color count = 1

	rtd_outl(REG_PTG_TG,0x00000005); //fix L flag disable,mode = 3D mode , PTG enable
#endif



	udelay(100);										

for(test_count=0;test_count<test_case;test_count++)
{

	switch(test_count)
			{
			case 0:
//===============================//
//=== 3D ONMS START for 1080P ===//
//===============================//
					printk("(0)Check progressive mode\n");

					// step 0 : measure active space in progressive mode
					rtd_outl(0xb8021300,0x091100a0); 	// set progressive mode
					rtd_outl(0xb8021314,0x042E0433); 	// set active_video2 length = 0x42e = 1070, active_video1 length = 0x433 = 1075
					rtd_outl(0xb802131c,0x0370DC37); 	// set active_space 1,2,3 = 0x37 = 45 (std of 1080), 30(std of 720)
					udelay(1000);

					for(cnt_n=0;cnt_n<100;cnt_n++)
					{
						rtd_maskl(0xb8021300,~_BIT0,_BIT0);	// start measure
						udelay(100000);
						rtd_maskl(0xb8021300,~_BIT2,_BIT2);	// pop-up measure result
						udelay(1000);
						rtd_inl(0xb8021300);				// read for ready
						udelay(1000);
						//printk(".");
						if((rtd_inl(0xb8021324)!=0)&((rtd_inl(0xb8021300)&0x1)==0))  //b8021324=0, 
							break;                                                                                 
					}
					
					active_space_1 = rtd_inl(0xb8021324);
					if(active_space_1 != 0x00330006)
					{
						printk("(0)progressive mode fail!! active_space_1 = 0x%x	\n",active_space_1);	
						Fl_pass=FALSE;
					}
					else
							printk("case 0==>PASS!!\n");
	
			break;

			case 1:
	
						// step 1 : check HV info.
						printk("1)Check HV info.\n");
						Vtotalde 		= (rtd_inl(0xb8021330)>>16)&0x0fff;
						Vtotal 			= (rtd_inl(0xb8021330)&0x3fff);
						Vs_high_period 	= (rtd_inl(0xb8021334)>>14)&0x0fff;
						Hs_high_period 	= (rtd_inl(0xb8021334)&0x3fff);
						Hact 			= (rtd_inl(0xb8021338)>>18)&0x3fff;
						htotal	 		= (rtd_inl(0xb8021338)>>2)&0x3fff;
						Vblank_len 		= (rtd_inl(0xb802133c)>>16)&0x00ff;
						Vact_start 		= (rtd_inl(0xb802133c)&0x0fff);

						if(Vtotalde != 0x89E)					//Vtotalde = 2206
						{
							printk("(1)Vtotalde fail,%x\n",Vtotalde);
							Fl_pass=FALSE;
							break;
						}
						else if (Vtotal !=0x8CB)				//Vtotal = 2251
						{
							printk("(1)Vtotal fail\n");
							Fl_pass=FALSE;
							break;							
						}
						else if (Vs_high_period !=0x4)			//Vs_high_period = 4
						{
							printk("(1)Vs_high_period fail\n");
							Fl_pass=FALSE;
							break;							
						}
						else if (Hs_high_period !=0x11)			//Hs_high_period = 17
						{
							printk("(1)Hs_high_period fail\n");
							Fl_pass=FALSE;
							break;														
						}
						else if (Hact !=0x780)					//H_active = 1920
						{
							printk("(1)Hact fail,Hact = %x\n",Hact);
							Fl_pass=FALSE;
							break;														
						}
						else if (htotal !=0x898)				//H_total = 2200
						{
							printk("(1)htotal fail\n");
							Fl_pass=FALSE;
							break;														
						}
						else if (Vblank_len !=0x16)				//Vblank_len = 22
						{
							printk("(1)Vblank_len fail\n");
							Fl_pass=FALSE;
							break;														
						}
						else if (Vact_start !=0x17)				//Vact_start = 23
						{
							printk("(1)Vact_start fail\n");
							Fl_pass=FALSE;
							break;														
						}
						else
							printk("case 1==>PASS!!\n");
			break;
			case 2:


						printk("(2)Check interlace mode.\n");
						rtd_outl(0xb8021300,0x081100a0);	// set interlace mode
						rtd_outl(REG_PTG_TG,0x00000007);	// set hdmi PTG as interlaced mode.						
//						rtd_outl(0xb800d50c,0x00000007);	// set hdmi PTG as interlaced mode.
						rtd_outl(0xb8021314,0x042E0433);	// set active_video2 = 0x42e = 1070, active_video1 = 0x433 = 1075
						rtd_outl(0xb8021318,0x0433042E);	// set active_video4 = 0x433 = 1075, active_video3 = 0x42e = 1070
						udelay(1000);
						
						for(cnt_n=0;cnt_n<100;cnt_n++)
						{
							rtd_maskl(0xb8021300,~_BIT0,_BIT0);	// start measure
							udelay(100000);
							rtd_maskl(0xb8021300,~_BIT2,_BIT2);	// pop-up measure result
							udelay(1000);
							rtd_inl(0xb8021300);				// read for ready
							udelay(1000);
							//printk(".");
							if((rtd_inl(0xb8021328)!=0)&((rtd_inl(0xb8021300)&0x1)==0))
								break;
						}
						active_space_1 = rtd_inl(0xb8021324);
						active_space_2 = rtd_inl(0xb8021328);
						active_space_3 = rtd_inl(0xb802132c);
						
						if((active_space_1!=0x00330006)|(active_space_2!=0x00330007)|(active_space_3!=0x00340007))
						{
							printk("(2)Interlace mode fail!! active_space_1 = 0x%x,active_space_2 = 0x%x,active_space_3 = 0x%x,	\n",active_space_1,active_space_2,active_space_3);	
							Fl_pass=FALSE;
							break;														
						}

						else
							printk("case 2==>PASS!!\n");
						
				break;
				case 3:
						printk("(3)Check Max/Min info.\n");
						onms_vact_space1_max_info = rtd_inl(0xb8021344);
						onms_vact_space2_max_info = rtd_inl(0xb8021348);
						onms_vact_space3_max_info = rtd_inl(0xb802134c);
						onms_vact_space1_min_info = rtd_inl(0xb8021350);
						onms_vact_space2_min_info = rtd_inl(0xb8021354);
						onms_vact_space3_min_info = rtd_inl(0xb8021358);

						if(onms_vact_space1_max_info != 0x0330182D)
						{
							printk("(3)onms_vact_space1_max_info fail %x\n",onms_vact_space1_max_info);
							Fl_pass=FALSE;
							break;														
						}
						else if (onms_vact_space2_max_info !=0x03301C2C)
						{
							printk("(3)onms_vact_space2_max_info fail\n");
							Fl_pass=FALSE;
							break;														
						}
						else if (onms_vact_space3_max_info !=0x03401C2D)
						{
							printk("(3)onms_vact_space3_max_info fail\n");
							Fl_pass=FALSE;
							break;														
						}
						else if (onms_vact_space1_min_info !=0x0330182D)
						{
							printk("(3)onms_vact_space1_min_info fail\n");
							Fl_pass=FALSE;
							break;														
						}
						else if (onms_vact_space2_min_info !=0x03301C2C)
						{
							printk("(3)onms_vact_space2_min_info fail\n");
							Fl_pass=FALSE;
							break;														
						}
						else if (onms_vact_space3_min_info !=0x03401C2D)
						{
							printk("(3)onms_vact_space3_min_info fail\n");
							Fl_pass=FALSE;
							break;														
						}
						else											
							printk("case 3==>PASS!!\n");

					break;

					case 4:

						printk("(4)Check pixel value\n");

						// check Pixel_get_en,Pixel_ok
						if(rtd_inl(0xb8021304) != 0x01000000)
						{
							printk("(4)Pixel_ok fail\n");
							Fl_pass=FALSE;
							break;
						}

						//get rgb value
						rtd_outl(REG_PTG_C0Y,0x00010101);	// set L region to black gray level = 1(of 8bit)						
//						rtd_outl(0xb800d528,0x00010101);	// set L region to black gray level = 1(of 8bit)
															//(ptg will repeat to 10 bit, 1 will be 101)
						rtd_outl(0xb8021314,0x042E0400);	// set measure area to L region
						udelay(100000);

						for(cnt_n=0;cnt_n<100;cnt_n++)
						{
							rtd_maskl(0xb8021300,~_BIT0,_BIT0);	// start measure
							udelay(100000);
							rtd_maskl(0xb8021300,~_BIT2,_BIT2);	// pop-up measure result
							udelay(1000);
							rtd_inl(0xb8021300);				// read for ready
							udelay(1000);
							//printk(".");
							if((rtd_inl(0xb8021328)==0x001B0000)&((rtd_inl(0xb8021300)&0x1)==0))
								break;
						}
							
						Get_r_value = (rtd_inl(0xb8021304)>>12)&0xfff;	//r value of L region = 0x14 = b10100
						Get_g_value = rtd_inl(0xb8021304)&0xfff;		//g value of L region = 0x14 = b10100
						Get_b_value = rtd_inl(0xb8021308)&0xfff;		//b value of L region = 0x14 = b10100

						if((Get_r_value!=0x14)|(Get_g_value!=0x14)|(Get_b_value!=0x14)) //the same with ptg
						{
							printk("(4)Pixel get value fail%x %x %x\n",Get_r_value,Get_g_value,Get_b_value);
							Fl_pass=FALSE;
							break;
						}

						//set active value equal to the getting value
						rtd_outl(0xb802130c,0x00014014);
						rtd_outl(0xb8021310,0x00000014);

						for(cnt_n=0;cnt_n<100;cnt_n++)
						{
							rtd_maskl(0xb8021300,~_BIT0,_BIT0);	// start measure
							udelay(100000);
							rtd_maskl(0xb8021300,~_BIT2,_BIT2);	// pop-up measure result
							udelay(1000);
							rtd_inl(0xb8021300);				// read for ready
							udelay(1000);
							//printk(".");
							if((rtd_inl(0xb8021324)==0x00370000)&((rtd_inl(0xb8021300)&0x1)==0))
								break;
						}
						//if the difference pixel number < th, HW will assume it's active space
						active_space_1 = rtd_inl(0xb8021324);
						if(active_space_1 != 0x00370000)
						{
							printk("(4)Pixel set active value fail\n");
							Fl_pass=FALSE;
							break;
						}
						
						rtd_outl(0xb8021300,0x0a1100a0);	// select active space 2 to get value
						for(cnt_n=0;cnt_n<100;cnt_n++)
						{
							rtd_maskl(0xb8021300,~_BIT0,_BIT0);	// start measure
							udelay(100000);
							rtd_maskl(0xb8021300,~_BIT2,_BIT2);	// pop-up measure result
							udelay(1000);
							rtd_inl(0xb8021300);				// read for ready
							udelay(1000);
							//printk(".");
							if((rtd_inl(0xb8021328)==0x001B0000)&((rtd_inl(0xb8021300)&0x1)==0))
								break;
						}


						Get_r_value = (rtd_inl(0xb8021304)>>12)&0xfff;	//r value of R region = 0x6E8
						Get_g_value = rtd_inl(0xb8021304)&0xfff;		//g value of R region = 0x294
						Get_b_value = rtd_inl(0xb8021308)&0xfff;		//b value of R region = 0xF00

						if((Get_r_value!=0x6E8)|(Get_g_value!=0x294)|(Get_b_value!=0xF00)) //the same with ptg
						{
							printk("(4)Select active space 2 fail\n");
							Fl_pass=FALSE;
							break;
						}

						if(Fl_pass!=FALSE)
							printk("case 4==>PASS!!\n");
					break;
					
					case 5:
						// step 5 : check blank line
						printk("(5)Check blank line\n");
						rtd_outl(REG_PTG_TG,0x00000005);	// set progressive
						rtd_outl(REG_PTG_C0Y,0x00000000);	// set L region to black gray level = 0(of 8bit)						
//						rtd_outl(0xb800d50c,0x00000005);	// set progressive
//						rtd_outl(0xb800d528,0x00000000);	// set L region to black gray level = 0(of 8bit)
						rtd_outl(0xb8021314,0x042E0470);	// set region conver the blank line
						rtd_outl(0xb802130c,0x00000000);	// reset active r/g/b value to 0
						rtd_outl(0xb8021310,0x00000000);	// reset active r/g/b value to 0
						rtd_outl(0xb8021300,0x091100a0);
						
						for(cnt_n=0;cnt_n<100;cnt_n++)
						{
							rtd_maskl(0xb8021300,~_BIT0,_BIT0);	// start measure
							udelay(100000);
							rtd_maskl(0xb8021300,~_BIT2,_BIT2);	// pop-up measure result
							udelay(1000);
							rtd_inl(0xb8021300);				// read for ready
							udelay(1000);
							//printk(".");
							if(((rtd_inl(0xb8021320)&0xfff)==0x467)&((rtd_inl(0xb8021300)&0x1)==0))
								break;
						}

						L_blank_line_end = (rtd_inl(0xb8021320)&0x7ff);	
						if(L_blank_line_end != 0x467)
						{
							printk("(5)L_blank_line_end fail \n");
							Fl_pass=FALSE;
							break;
						}
							
						rtd_outl(REG_PTG_C0Y,0x0051f05a);	// set L region to black gray level = 0(of 8bit)						
						rtd_outl(REG_R_PTG_C0Y,0x00000000);	// set L region to black gray level = 0(of 8bit)	
//						rtd_outl(0xb800d528,0x0051f05a);	// reset L region
//						rtd_outl(0xb800d558,0x00000000);	// set R region to black gray level = 0(of 8bit)
						rtd_outl(0xb8021314,0x042E0300);	// set region conver the blank line

						for(cnt_n=0;cnt_n<100;cnt_n++)
						{
							rtd_maskl(0xb8021300,~_BIT0,_BIT0);	// start measure
							udelay(100000);
							rtd_maskl(0xb8021300,~_BIT2,_BIT2);	// pop-up measure result
							udelay(1000);
							rtd_inl(0xb8021300);				// read for ready
							udelay(1000);
							//printk(".");
							if((rtd_inl(0xb8021328)==0x01020001)&((rtd_inl(0xb8021300)&0x1)==0))
								break;
						}

						R_blank_line_start = ((rtd_inl(0xb8021320)>>16)&0x7df);
						if(R_blank_line_start != 0x102)
						{
							printk("(5)R_blank_line_start fail %x\n",rtd_inl(0xb8021320));
							Fl_pass=FALSE;
							break;
						}
						rtd_outl(0xb8021314,0x042E0433);	// reset region
						if(Fl_pass!=FALSE)
							printk("case 5==>PASS!!\n");
					break;
					case 6:
	// step 6 : check flag of status
						printk("(6)Check flag of status\n");
						
						//set continuous mode, flag will NOT be correct in one time mode
						rtd_maskl(0xb8021300,~_BIT1,_BIT1);
						udelay(10000);

						//set min > (end-start)
						//b802135c[2]=1,[1]=1,[0]=1
						rtd_outl(0xb8021340,0x04010040);  // Vact_space1_min=64, Vact_space2_min=64, Vact_space3_min=64
						udelay(100000);

						for(cnt_n=0;cnt_n<100;cnt_n++)
						{
							rtd_maskl(0xb8021300,~_BIT0,_BIT0); // start measure
							udelay(100000);
							rtd_maskl(0xb8021300,~_BIT2,_BIT2);	// pop-up measure result
							udelay(1000);
							rtd_inl(0xb8021300);				// read for ready
							udelay(1000);
							//printk(".");
							if((rtd_inl(0xb802135c)==0x00070007)&((rtd_inl(0xb8021300)&0x1)==0))
								break;
						}
						if((rtd_inl(0xb802135c)&0x7)!=0x7)
						{
							printk("(6)Vact_space_under_min fail %x\n",rtd_inl(0xb802135c));	
							Fl_pass=FALSE;
							break;
						}
						else
							printk("case 6==>PASS!!\n");

				break;						
				case 7:		
						printk("(7)Hsync inversion check\n");					
						rtd_outl(0xb8021360,_BIT0);
						udelay(1000);
						rtd_maskl(0xb8021360,~_BIT0,0x0);
						udelay(1000);
						rtd_outl(0xb8021360,_BIT1);
						udelay(1000);
						rtd_maskl(0xb8021360,~_BIT1,0x0);
						udelay(1000);
						rtd_outl(0xb8021360,_BIT2);
						udelay(1000);
						rtd_maskl(0xb8021360,~_BIT2,0x0);
						
						//reset
						rtd_outl(0xb8021340,0x0);
						for(cnt_n=0;cnt_n<10;cnt_n++)
						{
							rtd_outl(0xb802135c,0xfffff);//wclr_out
							rtd_maskl(0xb8021300,~_BIT0,_BIT0); // start measure
							udelay(100000);
							rtd_maskl(0xb8021300,~_BIT2,_BIT2); // pop-up measure result
							udelay(1000);
							rtd_inl(0xb8021300);				// read for ready
							if(rtd_inl(0xb802135c)==0x00070000)
								break;
						}
						if(rtd_inl(0xb802135c)!=0x00070000)
						{
							printk("(7)Hsync inversion fail 1 %x\n",rtd_inl(0xb802135c));
							Fl_pass=FALSE;
							break;
						}
					
						//invert hsync
						//b802135c[16]=0,[8]=1,[6]=1,[3]=1
						rtd_maskl(0xb8021300,~_BIT3,_BIT3); 	//invert hsync
						for(cnt_n=0;cnt_n<10;cnt_n++)
						{
							rtd_maskl(0xb8021300,~_BIT0,_BIT0); // start measure
							udelay(100000);
							rtd_maskl(0xb8021300,~_BIT2,_BIT2);	// pop-up measure result
							udelay(1000);
							rtd_inl(0xb8021300);				// read for ready
							udelay(1000);
							//printk(".");
							if((rtd_inl(0xb802135c)==0x00060148)&((rtd_inl(0xb8021300)&0x1)==0))
								break;
						}
						if(rtd_inl(0xb802135c)!=0x00060148)
						{
							printk("(7)Hsync inversion fail 2  %x\n",rtd_inl(0xb802135c));
							Fl_pass=FALSE;
							break;
						}
						else
							printk("case 7==>PASS!!\n");
					break;
				case 8:	
						rtd_outl(0xb8021360,_BIT3);
						udelay(1000);
						rtd_maskl(0xb8021360,~_BIT3,0x0);
						udelay(1000);
						rtd_outl(0xb8021360,_BIT6);
						udelay(1000);
						rtd_maskl(0xb8021360,~_BIT6,0x0);
						udelay(1000);
						rtd_outl(0xb8021360,_BIT8);
						udelay(1000);
						rtd_maskl(0xb8021360,~_BIT8,0x0);
						//reset
						rtd_maskl(0xb8021300,~_BIT3,0x0); //invert hsync back to initial
						for(cnt_n=0;cnt_n<10;cnt_n++)
						{
							rtd_outl(0xb802135c,0xfffff);//wclr_out
							rtd_maskl(0xb8021300,~_BIT0,_BIT0); // start measure
							udelay(100000);
							rtd_maskl(0xb8021300,~_BIT2,_BIT2); // pop-up measure result
							udelay(1000);
							rtd_inl(0xb8021300);				// read for ready
							if(rtd_inl(0xb802135c)==0x00070000)
								break;
						}
						if(rtd_inl(0xb802135c)!=0x00070000)
							{
								printk("(8)Vsync inversion fail 1%x\n",rtd_inl(0xb802135c));
							Fl_pass=FALSE;
							break;
							}

							//invert vsync
							//b802135c[17]=0,[15]=1,[12]=1,[9]=1,[7]=1,[6]=1
							rtd_maskl(0xb8021300,~_BIT4,_BIT4); 	//invert hsync(X) => invert vsyc 
							for(cnt_n=0;cnt_n<10;cnt_n++)
							{
								rtd_maskl(0xb8021300,~_BIT0,_BIT0); // start measure
								udelay(100000);
								rtd_maskl(0xb8021300,~_BIT2,_BIT2);	// pop-up measure result
								udelay(1000);
								rtd_inl(0xb8021300);				// read for ready
								udelay(1000);
								//printk(".");
								if((rtd_inl(0xb802135c)==0x000592C0)&((rtd_inl(0xb8021300)&0x1)==0))
									break;
							}
							if(rtd_inl(0xb802135c)!=0x000592C0)
							{
								printk("(8)Vsync inversion fail 2%x\n",rtd_inl(0xb802135c));
							Fl_pass=FALSE;
							break;
							}
							else
							printk("case 8==>PASS!!\n");								

						break;

					case 9:
							rtd_outl(0xb8021360,_BIT6);
							udelay(1000);
							rtd_maskl(0xb8021360,~_BIT6,0x0);
							udelay(1000);
							rtd_outl(0xb8021360,_BIT7);
							udelay(1000);
							rtd_maskl(0xb8021360,~_BIT7,0x0);
							udelay(1000);
							rtd_outl(0xb8021360,_BIT9);
							udelay(1000);
							rtd_maskl(0xb8021360,~_BIT9,0x0);
							udelay(1000);
							rtd_outl(0xb8021360,_BIT12);
							udelay(1000);
							rtd_maskl(0xb8021360,~_BIT12,0x0);
							udelay(1000);
							rtd_outl(0xb8021360,_BIT15);
							udelay(1000);
							rtd_maskl(0xb8021360,~_BIT15,0x0);
							//reset
							rtd_maskl(0xb8021300,~_BIT4,0x0); //invert hsync back to initial
							for(cnt_n=0;cnt_n<10;cnt_n++)
							{
								rtd_outl(0xb802135c,0xfffff);//wclr_out
								rtd_maskl(0xb8021300,~_BIT0,_BIT0); // start measure
								udelay(100000);
								rtd_maskl(0xb8021300,~_BIT2,_BIT2); // pop-up measure result
								udelay(1000);
								rtd_inl(0xb8021300);				// read for ready
								if(rtd_inl(0xb802135c)==0x00070000)
									break;
							}
							if(rtd_inl(0xb802135c)!=0x00070000)
							{
								printk("(9)Hact & Htotal detect fail 1%x\n",rtd_inl(0xb802135c));
								Fl_pass=FALSE;
								break;
							}							
					
							//change htotal & hact
							//b802135c[14]=1,[4]=1(change htatoal),[5]=1,[3]=1(change hact)
							rtd_outl(REG_PTG_TOTALHV,0x08b80465);	//change htotal
							rtd_outl(REG_PTG_H_STA_WID,0x008c0788);	//change hact							
//							rtd_outl(0xb800d500,0x08b80465);	//change htotal
//							rtd_outl(0xb800d504,0x008c0788);	//change hact
							for(cnt_n=0;cnt_n<10;cnt_n++)
							{
								rtd_maskl(0xb8021300,~_BIT0,_BIT0); // start measure
								udelay(100000);
								rtd_maskl(0xb8021300,~_BIT2,_BIT2);	// pop-up measure result
								udelay(1000);
								rtd_inl(0xb8021300);				// read for ready
								udelay(1000);
								//printk(".");
								if((rtd_inl(0xb802135c)==0x00074038)&((rtd_inl(0xb8021300)&0x1)==0))
									break;
							}
							if(rtd_inl(0xb802135c)!=0x00074038)
							{
								printk("(9)Hact & Htotal detect fail 2%x\n",rtd_inl(0xb802135c));
								Fl_pass=FALSE;
								break;
							}
							else
							printk("case 9==>PASS!!\n");	
					break;
				case 10:
							rtd_outl(0xb8021360,_BIT3);
							udelay(1000);
							rtd_maskl(0xb8021360,~_BIT3,0x0);
							udelay(1000);
							rtd_outl(0xb8021360,_BIT4);
							udelay(1000);
							rtd_maskl(0xb8021360,~_BIT4,0x0);
							udelay(1000);
							rtd_outl(0xb8021360,_BIT5);
							udelay(1000);
							rtd_maskl(0xb8021360,~_BIT5,0x0);
							udelay(1000);
							rtd_outl(0xb8021360,_BIT14);
							udelay(1000);
							rtd_maskl(0xb8021360,~_BIT14,0x0);
							//reset	
							rtd_outl(REG_PTG_TOTALHV,0x08980465);	//change htotal
							rtd_outl(REG_PTG_H_STA_WID,0x008c0780);	//change hact								
//							rtd_outl(0xb800d500,0x08980465);	//set htotal back
//							rtd_outl(0xb800d504,0x008c0780);	//set hact back
							for(cnt_n=0;cnt_n<10;cnt_n++)
							{
								rtd_outl(0xb802135c,0xfffff);//wclr_out
								rtd_maskl(0xb8021300,~_BIT0,_BIT0); // start measure
								udelay(100000);
								rtd_maskl(0xb8021300,~_BIT2,_BIT2); // pop-up measure result
								udelay(1000);
								rtd_inl(0xb8021300);				// read for ready
								if(rtd_inl(0xb802135c)==0x00070000)
									break;
							}
							if(rtd_inl(0xb802135c)!=0x00070000)
							{
								printk("(10)Vact & Vtotal detect fail 1%x\n",rtd_inl(0xb802135c));
								Fl_pass=FALSE;
								break;
							}							

							//change vtotal & vact
							//b802135c[15]=1,[7]=1,[6]=1(change vtatoal),[7]=1(change vact)
							rtd_outl(REG_PTG_TOTALHV,0x0898046d);	//change htotal
							rtd_outl(REG_PTG_V_STA_LEN,0x00160478);	//change hact								
//					rtd_outl(0xb800d500,0x0898046d);	//change vtotal
//					rtd_outl(0xb800d508,0x00160478);	//change vact
							for(cnt_n=0;cnt_n<10;cnt_n++)
							{
								rtd_maskl(0xb8021300,~_BIT0,_BIT0); // start measure
								udelay(100000);
								rtd_maskl(0xb8021300,~_BIT2,_BIT2);	// pop-up measure result
								udelay(1000);
								rtd_inl(0xb8021300);				// read for ready
								udelay(1000);
								//printk(".");
								if((rtd_inl(0xb802135c)==0x000780C0)&((rtd_inl(0xb8021300)&0x1)==0))
									break;
							}
							if(rtd_inl(0xb802135c)!=0x000780C0)
							{
								printk("(10)Vact & Vtotal detect fail 1%x\n",rtd_inl(0xb802135c));
								Fl_pass=FALSE;
								break;
							}
							else
							printk("case 10==>PASS!!\n");	
					break;		
				case 11:
							rtd_outl(0xb8021360,_BIT6);
							udelay(1000);
							rtd_maskl(0xb8021360,~_BIT6,0x0);
							udelay(1000);
							rtd_outl(0xb8021360,_BIT7);
							udelay(1000);
							rtd_maskl(0xb8021360,~_BIT7,0x0);
							udelay(1000);
							rtd_outl(0xb8021360,_BIT15);
							udelay(1000);
							rtd_maskl(0xb8021360,~_BIT15,0x0);
							//reset
							rtd_outl(REG_PTG_TOTALHV,0x08980465);	//change htotal
							rtd_outl(REG_PTG_V_STA_LEN,0x00160438);	//change hact								
//					rtd_outl(0xb800d500,0x08980465);	//set vtotal back
//					rtd_outl(0xb800d508,0x00160438);	//set vact back
//						rtd_outl(0xb8021300,(rtd_inl(0xb8021300)&~_BIT1));
							for(cnt_n=0;cnt_n<10;cnt_n++)
							{
								rtd_outl(0xb802135c,0xfffff);//wclr_out
								rtd_maskl(0xb8021300,~_BIT0,_BIT0); // start measure
								udelay(100000);
								rtd_maskl(0xb8021300,~_BIT2,_BIT2); // pop-up measure result
								udelay(1000);
								rtd_inl(0xb8021300);				// read for ready
								if(rtd_inl(0xb802135c)==0x00070000)
									break;
							}
								if(rtd_inl(0xb802135c)!=0x00070000)
								{
									printk("(11)vtotal time-out detect fail 1%x\n",rtd_inl(0xb802135c));
									Fl_pass=FALSE;
								break;
							}							
								//change vtotal to make vsync time-out
								//b802135c[13]=1,
							rtd_outl(REG_PTG_TOTALHV,0x08980c65);	//change htotal								
//						rtd_outl(0xb800d500,0x08980c65);	//change vtotal & htotal
								for(cnt_n=0;cnt_n<100;cnt_n++)
								{
									rtd_outl(0xb802135c,0xfffff);//wclr_out
									rtd_maskl(0xb8021300,~_BIT0,_BIT0); // start measure
									udelay(100000);
									rtd_maskl(0xb8021300,~_BIT2,_BIT2);	// pop-up measure result
									udelay(1000);
									rtd_inl(0xb8021300);				// read for ready
									udelay(1000);
									//printk(".");
									if((rtd_inl(0xb802135c)==0x00070007)&((rtd_inl(0xb8021300)&0x1)==0))
										break;
								}
						udelay(100000);								
								if((rtd_inl(0xb802135c)&_BIT13)==0)
								{
									printk("(11)vtotal time-out detect fail 2%x\n",rtd_inl(0xb802135c));
									Fl_pass=FALSE;
								break;
							}
							else
							printk("case 11==>PASS!!\n");	
					break;		
				case 12:
								rtd_outl(0xb8021360,_BIT13);
								udelay(1000);
								rtd_maskl(0xb8021360,~_BIT13,0x0);
								//reset
								rtd_maskl(0xb8021300,~_BIT6,_BIT6); //set time-out to 76ms
								rtd_maskl(0xb8021300,~_BIT0,_BIT0); //start measure
								for(cnt_n=0;cnt_n<100;cnt_n++)
								{
									rtd_maskl(0xb8021300,~_BIT0,_BIT0); // start measure
									udelay(100000);
									rtd_maskl(0xb8021300,~_BIT2,_BIT2);	// pop-up measure result
									udelay(1000);
									rtd_inl(0xb8021300);				// read for ready
									udelay(1000);
									//printk(".");
									if((rtd_inl(0xb802135c)==0x00070007)&((rtd_inl(0xb8021300)&0x1)==0))
										break;
								}
								if(rtd_inl(0xb802135c)!=0x00070000)
								{
									printk("(12)vtotal time-out threshold fail 1%x\n",rtd_inl(0xb802135c));
									Fl_pass=FALSE;
								break;
							}
							else
							printk("case 12==>PASS!!\n");	
					break;	
				case 13:
							rtd_outl(REG_PTG_TOTALHV,0x08980465);	//change htotal					
//						rtd_outl(0xb800d500,0x08980465);	//set htotal,vtotal back
								for(cnt_n=0;cnt_n<10;cnt_n++)
								{
									rtd_outl(0xb802135c,0xfffff);//wclr_out
									rtd_maskl(0xb8021300,~_BIT0,_BIT0); // start measure
									udelay(100000);
									rtd_maskl(0xb8021300,~_BIT2,_BIT2); // pop-up measure result
									udelay(1000);
									rtd_inl(0xb8021300);				// read for ready
									if(rtd_inl(0xb802135c)==0x00070000)
										break;
								}
								if(rtd_inl(0xb802135c)!=0x00070000)
									{
										printk("(13)htotal over-flow detect fail 1%x\n",rtd_inl(0xb802135c));
									Fl_pass=FALSE;
								break;
								}								
									//disable ptg to make hsync & vsync over-flow
									//b802135c[10]=1
							rtd_outl(REG_PTG_TG,0x0);	//change htotal														
//							rtd_outl(0xb800d50c,0x0);	//disable ptg
									for(cnt_n=0;cnt_n<10;cnt_n++)
									{
										rtd_maskl(0xb8021300,~_BIT0,_BIT0); // start measure
										udelay(100000);
										rtd_maskl(0xb8021300,~_BIT2,_BIT2);	// pop-up measure result
										udelay(1000);
										rtd_inl(0xb8021300);				// read for ready
										udelay(1000);
										//printk(".");
										if((((rtd_inl(0xb802135c)&_BIT10)>>10)==1)&((rtd_inl(0xb8021300)&0x1)==0))
											break;
									}
									if(((rtd_inl(0xb802135c)&_BIT10)>>10)!=1)
									{
										printk("(13)htotal over-flow detect fail 2%x\n",rtd_inl(0xb802135c));
									Fl_pass=FALSE;
								break;
							}
							else
							printk("case 13==>PASS!!\n");	
							break;
						case 14:							
									rtd_outl(0xb8021360,_BIT10);
									udelay(1000);
									rtd_maskl(0xb8021360,~_BIT10,0x0);
									//reset
							rtd_outl(REG_PTG_TG,0x5);//change htotal										
//							rtd_outl(0xb800d50c,0x5);	//enable ptg
									for(cnt_n=0;cnt_n<10;cnt_n++)
									{
										rtd_outl(0xb802135c,0xfffff);//wclr_out
										rtd_maskl(0xb8021300,~_BIT0,_BIT0); // start measure
										udelay(100000);
										rtd_maskl(0xb8021300,~_BIT2,_BIT2); // pop-up measure result
										udelay(1000);
										rtd_inl(0xb8021300);				// read for ready
										if(rtd_inl(0xb802135c)==0x00070000)
											break;
									}
								if(rtd_inl(0xb802135c)!=0x00070000)
								{
									printk("(14)vtotal overflow detect fail 1%x\n",rtd_inl(0xb802135c));
									Fl_pass=FALSE;
								break;
							}
								//change vtotal to make vsync over-flow
								//b802135c[11]=1
							rtd_outl(REG_PTG_TG,0x7);//change htotal	
						rtd_outl(REG_PTG_TOTALHV,0x00981fff);	//change vtotal							
//						rtd_outl(0xb800d50c,0x7);			//set interlace mode, Vtotal will be double.
//						rtd_outl(0xb800d500,0x00981fff);	//change vtotal
								for(cnt_n=0;cnt_n<10;cnt_n++)
								{
									rtd_maskl(0xb8021300,~_BIT24,0x0);//set interlace mode.
									rtd_maskl(0xb8021300,~_BIT0,_BIT0); // start measure
									udelay(100000);
									rtd_maskl(0xb8021300,~_BIT2,_BIT2);	// pop-up measure result
									udelay(1000);
									rtd_inl(0xb8021300);				// read for ready
									udelay(1000);
									//printk(".");
									if((((rtd_inl(0xb802135c)&_BIT11)>>11)==1)&((rtd_inl(0xb8021300)&0x1)==0))
										break;
								}
								if(((rtd_inl(0xb802135c)&_BIT11)>>11)!=1)
								{
									printk("(14)vtotal overflow detect fail 2%x\n",rtd_inl(0xb802135c));
									Fl_pass=FALSE;
								break;
							}
							else
							printk("case 14==>PASS!!\n");	
							break;		
						case 15:
							      rtd_outl(0xb8021360,_BIT11);
								udelay(1000);
								rtd_maskl(0xb8021360,~_BIT11,0x0);
								//reset
							rtd_outl(REG_PTG_TG,0x08980465);//change htotal	
//						rtd_outl(0xb800d500,0x08980465);	//set htotal back
								for(cnt_n=0;cnt_n<10;cnt_n++)
								{
									rtd_outl(0xb802135c,0xfffff);//wclr_out
									rtd_maskl(0xb8021300,~_BIT0,_BIT0); // start measure
									udelay(100000);
									rtd_maskl(0xb8021300,~_BIT2,_BIT2); // pop-up measure result
									udelay(1000);
									rtd_inl(0xb8021300);				// read for ready
									if(rtd_inl(0xb802135c)==0x000a0000)
										break;
								}
							break;
				default:
							break;

				}
			// [Clayton][Fix me] by pass first
		// [start]
			printk("(Fl_pass flag=%x\n",Fl_pass);
			//if (Fl_pass==FALSE)
		//break;
			// [end]
}

		
	if (Fl_pass==FALSE)
		return 0;
	else
		return 1;


}
//#endif      //20130821
// Clayton 2017/5/18
// Modify the mapping register from Magellan SyncProcess(for onms) to Mac5p ONMS
BOOL IP_IPTG_Verify(void)
{
UINT8    test_count=0,test_case=7,i;	//Clayton: Original--test_case=16 ; Mac5p set test_case=7, skip IPTG CRC check first
UINT16  Width,Length;
UINT32   temp,temp1,temp2;
bool     Fl_pass=1;

printk("IP_IPTG_Verify  \n");

		rtd_outl(0xb8020000 , 0x000001ff);  // global power on



//IPTG  Total pixel = 858*262, H start 145 ,width 704, V start 16 active 240

for(test_count=0;test_count<test_case;test_count++)
{
		rtd_outl(REG_PTG_TOTALHV, 0x035a0106);   // Total pixel = 858*262
		rtd_outl(REG_PTG_H_STA_WID, 0x0010034a);   // Horizontal active start = 16, active width = 842
		rtd_outl(REG_PTG_V_STA_LEN, 0x00050101);   // Vertical active start = 5, active width = 257


		rtd_outl(REG_PTG_HSTA_WID, 0x009102c0);   // Pattern Gen display Hstart=145 & Hactive =704 eݯd16 piexels ΨӧP_porch 
		rtd_outl(REG_PTG_VSTA_LEN, 0x001000f0);   // Pattern Gen display Vstart=16 & Vactive =240
		rtd_outl(REG_PTG_CTRL, 0x00000003);   // PTG control, select pattern = Color Bar 
		rtd_outl(REG_PTG_BARW, 0x00000059);   // Color bar width  =59
		rtd_outl(REG_PTG_C0Y, 0x00ffffff);   // active region color 
		rtd_outl(REG_PTG_C2Y, 0x00070707);   // porch region color 101=5           10 bit color=5
		rtd_outl(REG_PTG_MAX_COLOR_CTRL, 0x00000fff);   // color set (copy from defualt value) 1 color
		rtd_outl(REG_PTG_TG, 0x40000002);   // Diable timing generator, interlace,seperate
		udelay(20000);
		rtd_outl(REG_PTG_TG, 0x40000003);   // Enable timing generator, interlace,seperate
		
switch(test_count)
	{
	case 0:  //IPTG HV total use online measure 
		rtd_outl(REG_onms1_ctrl, _BIT0|_BIT5|_BIT7);		//online measure, Clayton: on1_sycms_clk / on1_vact_space_meas_en / on1_start_ms
		udelay(200000);			
		rtd_outl(REG_onms1_ctrl, _BIT0|_BIT5|_BIT7|_BIT2);		//online measure,Clayton: Popup, on1_sycms_clk / on1_vact_space_meas_en / on1_start_ms / on1_popup_meas
		udelay(200000);	
		temp1=rtd_inl(REG_onms1_hs_period);		//online measure		
		Width=(temp1&0x0000fff0)>>4;
		temp2=rtd_inl(REG_onms1_vs_period);
		Length=(temp2&0x00000fff);		
		temp=YPP_abs((Length+1),(rtd_inl(REG_PTG_TOTALHV)&0x00000fff));
			if((Width==((rtd_inl(REG_PTG_TOTALHV)&0x0fff0000)>>16)) && (temp<=1))	// Clayton: Width+1 == IPTG Htotal => Width == IPTG Htotal, why needs to +1 before ?
				printk("New IP_IPTG_Verify HVtotal Pass\n");						  			    
			else
			{
				printk("New IP_IPTG_Verify fail Htotal=%d VTotal=%d temp=%d, REG_PTG_TOTALHV=0x%x\n",Width,Length,temp, rtd_inl(REG_PTG_TOTALHV));		
				Fl_pass=FALSE;	
				break;
			}	
	
		break;
	case 1: //IPTG HV start& width& len
		rtd_outl(0xb8022210, 0x90000001);	 //VGIP enable 
		rtd_outl(REG_AUTO_H_BOUNDARY, 0x0005035A);//set H  boudary , start 80 end 858
		rtd_outl(REG_AUTO_V_BOUNDARY, 0x00020106);//set V  boudary , start 2 end 262
		rtd_outl(REG_AUTO_RGB_MARGIN, 0x04040400);//Noise MGN 0
		rtd_outl(REG_AUTO_ADJ, 0);//reset adj
		rtd_outl(REG_AUTO_FIELD, 0);//reset field		
	
				rtd_outl(REG_AUTO_ADJ, _BIT0);
				udelay(100000);	
				Length=((rtd_inl(REG_AUTO_RESULT_V)&0x0fff0000)>>16);
				Width=((rtd_inl(REG_AUTO_RESULT_H)&0x0fff0000)>>16);

				if(((Length+1)==(rtd_inl(REG_PTG_V_STA_LEN)&0x0fff0000)>>16)&&
					((Width+1)==(rtd_inl(REG_PTG_H_STA_WID)&0x0fff0000)>>16))       
					printk("IP_IPTG_Verify HV start Pass\n");		
				else
					{
					printk("IP_IPTG_Verify Hstart=%d Vstart=%d\n",Width,Length);		
					Fl_pass=FALSE;	
					break;								
					}
				
				Length=(rtd_inl(REG_AUTO_RESULT_V)&0x00000fff)-Length+1;		// V, active  region end - active  region start = V active  region
				Width=(rtd_inl(REG_AUTO_RESULT_H)&0x00000fff)-Width+1;			// H, active  region end - active  region start = H active  region
				if((Length==(rtd_inl(REG_PTG_V_STA_LEN)&0x00000fff))&&
					(Width==(rtd_inl(REG_PTG_H_STA_WID)&0x00000fff)))
					printk("IP_IPTG_Verify HV WID&LEN Pass\n");		
				else
					{
					printk("IP_IPTG_Verify H_WID=%d V_LEN=%d\n",Width,Length);		
					Fl_pass=FALSE;	
					}
				break;				
	case 2://IPTG PTG HV start& width& len
				rtd_outl(REG_AUTO_RGB_MARGIN, 0x80808000);//Noise MGN 0
				rtd_outl(REG_AUTO_ADJ, _BIT0);
				udelay(100000);	

				Length=((rtd_inl(REG_AUTO_RESULT_V)&0x0fff0000)>>16);
				Width=((rtd_inl(REG_AUTO_RESULT_H)&0x0fff0000)>>16);

				if(((Length+1)==(rtd_inl(REG_PTG_VSTA_LEN)&0x0fff0000)>>16)&&
					((Width+1)==(rtd_inl(REG_PTG_HSTA_WID)&0x0fff000)>>16))
					printk("IP_IPTG_Verify PTG HV start Pass\n");		
				else
					{
					printk("IP_IPTG_Verify fail PTG Hstart=%d Vstart=%d\n",Width,Length);		
					Fl_pass=FALSE;	
					break;								
					}
				
				Length=(rtd_inl(REG_AUTO_RESULT_V)&0x00000fff)-Length+1;
				Width=(rtd_inl(REG_AUTO_RESULT_H)&0x00000fff)-Width+1;
				if((Length==(rtd_inl(REG_PTG_VSTA_LEN)&0x00000fff))&&
					(Width==(rtd_inl(REG_PTG_HSTA_WID)&0x00000fff)))
					printk("IP_IPTG_Verify PTG HV WID&LEN Pass\n");		
				else
					{
					printk("IP_IPTG_Verify PTG H_WID=%d V_LEN=%d\n",Width,Length);		
					Fl_pass=FALSE;	
					}								
				break;
	case 3: //IPTG H_HighPulseWid                   TEST: on line measure
				for (i=0;i<4;i++)
					{
						rtd_outl(REG_PTG_TG,(rtd_inl(REG_PTG_TG)&0xfffffcff)|(i<<8));   // Set H_HighPulseWid ,00/01 /10 /11 (16/32/48/64 pixel)
						udelay(20000);							
						rtd_outl(REG_onms1_ctrl, _BIT0|_BIT5|_BIT7);		//online measure
						udelay(20000);			
						rtd_outl(REG_onms1_ctrl, _BIT0|_BIT5|_BIT7|_BIT2);		//Pop up
						udelay(200000);	
						Width=rtd_inl(REG_onms1_vshs_high_period)&0x00000fff;
						if(Width!=((i+1)*0x10))
							{
							printk("New IP_IPTG_Verify H_HighPulseWid=%d result=%d\n",i,Width);									
							Fl_pass=FALSE;	
							break;
							}
						if(i==3)
							printk("New IP_IPTG_Verify H_HighPulseWid  Pass\n");									
					}
				break;	
	case 4: //IPTG CS type              TEST: SP auto run result
				for (i=0;i<5;i++)
					{
						rtd_outl(REG_PTG_TG,(rtd_inl(REG_PTG_TG)&0x0fffffff)|(i<<28));   // Set CS
						udelay(20000);							
						rtd_outl(REG_SP1_CTRL, 0x00000000);		//Clayton: SP1 AUTO detect
						udelay(20000);			
						rtd_outl(REG_SP1_CTRL, 0x00000400);		//Clayton: SP1 AUTO detect						
						udelay(200000);							//Clayton: add delay 200ms ->1000ms	

						// Clayton: Add checking auto result is ready then check sync type
						int count=0;
						while(((rtd_inl(REG_SP1_AutoRst)&_BIT31)>>31)==0)
							{
								udelay(100000);
								count++;
								printk("New IP_IPTG_Verify, case4 : wait for auto_result is ready, count=%d\n",count);
							}
						
						temp=(rtd_inl(REG_SP1_AutoRst)&0x00000070)>>4;  //get sync type
						switch(i)
							{
							case 0://IPTG cs= OR
							case 1://IPTG cs= XOR
								if(temp!=5)  //sp detect XOR/OR without EQ
									temp=FALSE;
								else
									temp=TRUE;
							break;
							case 2://IPTG cs= all 0
							case 3://IPTG cs= all 1 	
								if(temp!=0)  //sp detect No signal 
									temp=FALSE;
								else
									temp=TRUE;	
							break;
							case 4://IPTG cs= separete 	
								if(temp!=6)  //sp detect Separaet 
									temp=FALSE;
								else
									temp=TRUE;	
							break;

							default:
									temp=FALSE;	
								break;	

							}
						if(temp==FALSE)
							{
							printk("New IP_IPTG_Verify CS=%d result=%d ; reg=0x%x\n",i,(rtd_inl(REG_SP1_AutoRst)&0x00000070)>>4,rtd_inl(REG_SP1_AutoRst));									
							Fl_pass=FALSE;	
							break;
							}
							//printk("IP_IPTG_Verify CS=%d result=%d\n",i,(rtd_inl(REG_SP1_AutoRst)&0x00000070)>>4);	
						if(i==4)
							printk("New IP_IPTG_Verify CS  Pass\n");									
					}
				break;		
		case 5:	//Enable                  TEST: Auto run result
					rtd_outl(REG_PTG_TG,(rtd_inl(REG_PTG_TG)&0x0fffffff));   // Set CS=OR,Enable

					rtd_outl(REG_SP1_CTRL, 0x00000000);		//SP1 Hysnc Type AUTO detect disable
					udelay(20000);			
					rtd_outl(REG_SP1_CTRL, 0x00000400);		//SP1 Hysnc Type AUTO detect enable						
					udelay(200000);									
						// Clayton: Add checking auto result is ready then check sync type
						int count=0;
						while(((rtd_inl(REG_SP1_AutoRst)&_BIT31)>>31)==0)
							{
								udelay(100000);
								count++;
								printk("New IP_IPTG_Verify, case5 : wait for auto_result is ready, count=%d\n",count);
							}
					
					temp=(rtd_inl(REG_SP1_AutoRst)&0x00000070)>>4;  //get sync type
					if(temp==5)	//sp detect XOR/OR without EQ
						{
						rtd_outl(REG_PTG_TG,(rtd_inl(REG_PTG_TG)&0x0ffffffe));   // Set CS=OR, Timing generator Disable
						rtd_outl(REG_SP1_CTRL, 0x00000000);		//SP1 Hysnc Type AUTO detect disable
						udelay(20000);			
						rtd_outl(REG_SP1_CTRL, 0x00000400);		//SP1 Hysnc Type AUTO detect enable						
						udelay(200000);									
						temp=(rtd_inl(REG_SP1_AutoRst)&0x00000070)>>4;  //get sync type						
						if(temp==0) //sp detect No signal
							{
							printk("New IP_IPTG_Verify EN Pass\n");									
		
							}
						else
							{
							printk("New IP_IPTG_Verify EN fail2\n");									
							Fl_pass=FALSE;	
							break;
							}																									
						}
					else
						{
						printk("New IP_IPTG_Verify EN fail1\n");									
						Fl_pass=FALSE;	
						break;
							}		
					break;
		case 6:	//Interlace/progressive mode   TEST: VGIP FIELD TOG
					rtd_outl(0xb8022214,0x000000ff);// clear VGIP field tog flag
					udelay(200000);								
					temp=rtd_inl(0xb8022214);
					if(temp&0x00000040) //interlace
						{
						printk("IP_IPTG_Verify interlace\n");									
						rtd_outl(REG_PTG_TG,(rtd_inl(REG_PTG_TG)&0xfffffffd));   // Set progressive					
						udelay(200000);								
						rtd_outl(0xb8022214,0x000000ff);// clear VGIP field tog flag
						udelay(200000);								
							if(!(rtd_inl(0xb8022214)&0x00000040))
	//					printk("IP_IPTG_Verify progressive\n");																
							printk("IP_IPTG_Verify interlace/progressive Pass\n");			
							else
							{
								printk("1. IP_IPTG_Verify interlace/progressive fail flag=0x%x\n",rtd_inl(0xb8022214));		
								Fl_pass=FALSE;	
								break;
							}									
						}
					else
						{
						printk("2. IP_IPTG_Verify interlace/progressive fail flag=0x%x\n",rtd_inl(0xb8022214));		
						Fl_pass=FALSE;	
						break;
							}		
		break;

		case 7: //random   TEST:CRC
			rtd_outl(REG_PTG_TG,rtd_inl(REG_PTG_TG)&0xfffffffd); //progressive 
			rtd_outl(REG_PTG_CTRL,(rtd_inl(REG_PTG_CTRL)|0x00000100)&0xfffffff8); //enable random , disable PTG (All image is random)
			udelay(200000);											
			
			rtd_outl(0xb8025220,0x00000003); //Enable  uzd CRC
			udelay(200000);											
			temp= rtd_inl(0xb8025224); //CRC result

			if((temp==0x3847466F)||(temp==0x14ED1808))
		   		printk("IP_IPTG_Verify Random Background Pass\n");		
			else
				{
				printk("IP_IPTG_Verify Random Background Fail CRC=0x%x\n",temp);		
				Fl_pass=FALSE;	
				}

			udelay(1000000);			// hold pattern on screen for tester see								
 		break;

		case 8: // V color bar    TEST CRC
			rtd_outl(REG_PTG_TG,rtd_inl(REG_PTG_TG)&0xfffffffd); //progressive 
			rtd_outl(REG_PTG_CTRL,(rtd_inl(REG_PTG_CTRL)&0xfffffff8)|0x0000003); //V color bar
			rtd_outl(REG_PTG_C0Y,0x00ffffff); // color  bar 1 =white
			rtd_outl(REG_PTG_C1Y,0x0000ff00); // color  bar 2 =red
			rtd_outl(REG_PTG_C2Y,0x00ff0000); // color  bar 3 =green
			rtd_outl(REG_PTG_C3Y,0x0000ff00); // color  bar 4 =blue
			rtd_outl(REG_PTG_C4Y,0xffff0000); // color  bar 5 =yellow
			rtd_outl(REG_PTG_C5Y,0xff00ff00); // color  bar 6 =cyan
			rtd_outl(REG_PTG_C6Y,0x00ffff00); // color  bar 7 =maginta
			rtd_outl(REG_PTG_C7Y,0x00000000); // color  bar 8 =Black
			rtd_outl(REG_PTG_C7Y,(rtd_inl(REG_PTG_C7Y)|0x00000007)); //7 color bar
			
			udelay(20000);											
			rtd_outl(0xb8025220,0x00000003); //Enable  CRC
			udelay(20000);											
			temp= rtd_inl(0xb8025224);  //CRC result

			if((temp==0x8AC023E9)||(temp==0x79752773))
		   		printk("IP_IPTG_Verify V color bar & 8 colors Pass\n");		
			else{
				printk("IP_IPTG_Verify V color bar & 8 colors fail CRC=0x%x\n",temp);		
				Fl_pass=FALSE;	
				}

			udelay(1000000);			// hold pattern on screen for tester see								
			break;

		case 9: // H color bar    TEST CRC
			rtd_outl(REG_PTG_TG,rtd_inl(REG_PTG_TG)&0xfffffffd); //progressive 
			rtd_outl(REG_PTG_CTRL,(rtd_inl(REG_PTG_CTRL)&0xfffffff8)|0x0000002); //H color bar		
			rtd_outl(REG_PTG_BARW,((rtd_inl(REG_PTG_BARW)&0xfffffc00)|(rtd_inl(REG_PTG_VSTA_LEN)&0x00000fff)/8)); //7 color bar

			rtd_outl(REG_PTG_C0Y,0x00ffffff); // color  bar 1 =white
			rtd_outl(REG_PTG_C1Y,0x0000ff00); // color  bar 2 =red
			rtd_outl(REG_PTG_C2Y,0x00ff0000); // color  bar 3 =green
			rtd_outl(REG_PTG_C3Y,0x0000ff00); // color  bar 4 =blue
			rtd_outl(REG_PTG_C4Y,0xffff0000); // color  bar 5 =yellow
			rtd_outl(REG_PTG_C5Y,0xff00ff00); // color  bar 6 =cyan
			rtd_outl(REG_PTG_C6Y,0x00ffff00); // color  bar 7 =maginta
			rtd_outl(REG_PTG_C7Y,0x00000000); // color  bar 8 =Black
			rtd_outl(REG_PTG_C7Y,(rtd_inl(REG_PTG_C7Y)|0x00000007)); //7 color bar

			
			udelay(20000);											
			rtd_outl(0xb8025220,0x00000003); //Enable  CRC
			udelay(20000);											
			temp= rtd_inl(0xb8025224);  //CRC result

			if((temp==0x29169BD3)||(temp==0xF05A1C02))
		   		printk("IP_IPTG_Verify H color bar & BARW Pass\n");		
			else{
				printk("IP_IPTG_Verify H color bar & BARW fail CRC=0x%x\n",temp);		
				Fl_pass=FALSE;	
				}

			udelay(1000000);			// hold pattern on screen for tester see								
			break;
			
     
      
            case 10: // H gradient    TEST CRC
			rtd_outl(REG_PTG_TG,rtd_inl(REG_PTG_TG)&0xfffffffd); //progressive 
			rtd_outl(REG_PTG_CTRL,(rtd_inl(REG_PTG_CTRL)&0xfffffff8)|0x0000004); // H  gradient ?
//			rtd_outl(REG_PTG_MAX_COLOR_CTRL,(rtd_inl(REG_PTG_MAX_COLOR_CTRL)|0x07000000)); //7 color bar
//			rtd_outl(REG_PTG_BARW,((rtd_inl(REG_PTG_BARW)&0xfffffc00)|(rtd_inl(REG_PTG_VSTA_LEN)&0x00000fff)/8)); //7 color bar

			rtd_outl(REG_PTG_C0Y,0x00000000); // black  background
			rtd_outl(REG_PTG_C3Y,0x04040400); // adjust
			rtd_outl(REG_PTG_C4Y,0x01000000); // step   
			
			udelay(20000);											
			rtd_outl(0xb8025220,0x00000003); //Enable  CRC
			udelay(20000);											
			temp= rtd_inl(0xb8025224);  //CRC result

			if((temp==0x894C4BBC)||(temp==0xFA59F937))
		   		printk("IP_IPTG_Verify H gradient & step & adjust Pass\n");		
			else{
				printk("IP_IPTG_Verify H gradient & step & adjust fail CRC=0x%x\n",temp);		
				Fl_pass=FALSE;	
				}

			udelay(1000000);			// hold pattern on screen for tester see								
			break;	
			
            case 11: // V gradient    TEST CRC
			rtd_outl(REG_PTG_TG,rtd_inl(REG_PTG_TG)&0xfffffffd); //progressive 
			rtd_outl(REG_PTG_CTRL,(rtd_inl(REG_PTG_CTRL)&0xfffffff8)|0x0000005); //V  gradient ?
//			rtd_outl(REG_PTG_MAX_COLOR_CTRL,(rtd_inl(REG_PTG_MAX_COLOR_CTRL)|0x07000000)); //7 color bar
//			rtd_outl(REG_PTG_BARW,((rtd_inl(REG_PTG_BARW)&0xfffffc00)|(rtd_inl(REG_PTG_VSTA_LEN)&0x00000fff)/8)); //7 color bar

			rtd_outl(REG_PTG_C0Y,0x00000000); // black  background
			rtd_outl(REG_PTG_C3Y,0x05050500); // adjust
			rtd_outl(REG_PTG_C4Y,0x00000000); // step   
			
			udelay(20000);											
			rtd_outl(0xb8025220,0x00000003); //Enable  CRC
			udelay(20000);											
			temp= rtd_inl(0xb8025224);  //CRC result

			if((temp==0x042A3DE5)||(temp==0x558D4924))
		   		printk("IP_IPTG_Verify V gradient & step & adjust  Pass\n");		
			else{
				printk("IP_IPTG_Verify V gradient & step & adjust fail CRC=0x%x\n",temp);		
				Fl_pass=FALSE;	
				}

			udelay(1000000);			// hold pattern on screen for tester see								
			break;			

          case 12: // HV gradient    TEST CRC
			rtd_outl(REG_PTG_TG,rtd_inl(REG_PTG_TG)&0xfffffffd); //progressive 
			rtd_outl(REG_PTG_CTRL,(rtd_inl(REG_PTG_CTRL)&0xfffffff8)|0x0000006); //H and V  gradient ?
//			rtd_outl(REG_PTG_MAX_COLOR_CTRL,(rtd_inl(REG_PTG_MAX_COLOR_CTRL)|0x07000000)); //7 color bar
//			rtd_outl(REG_PTG_BARW,((rtd_inl(REG_PTG_BARW)&0xfffffc00)|(rtd_inl(REG_PTG_VSTA_LEN)&0x00000fff)/8)); //7 color bar

			rtd_outl(REG_PTG_C0Y,0x00000000); // black  background
			rtd_outl(REG_PTG_C3Y,0x02020200); // adjust
			rtd_outl(REG_PTG_C4Y,0x00000000); // step   
			
			udelay(20000);											
			rtd_outl(0xb8025220,0x00000003); //Enable  CRC
			udelay(20000);											
			temp= rtd_inl(0xb8025224);  //CRC result

			if((temp==0x57A2C69F)||(temp==0x6EB9B006))
		   		printk("IP_IPTG_Verify HV gradient & step & adjust  Pass\n");		
			else{
				printk("IP_IPTG_Verify HV gradient & step & adjust fail CRC=0x%x\n",temp);		
				Fl_pass=FALSE;	
				}

			udelay(1000000);			// hold pattern on screen for tester see								
			break;	
          case 13: // Bitmap    TEST CRC
			rtd_outl(REG_PTG_TG,rtd_inl(REG_PTG_TG)&0xfffffffd); //progressive 
			rtd_outl(REG_PTG_CTRL,(rtd_inl(REG_PTG_CTRL)&0xfffffff8)|0x0000007); //bitmap pattern
//			rtd_outl(REG_PTG_MAX_COLOR_CTRL,(rtd_inl(REG_PTG_MAX_COLOR_CTRL)|0x07000000)); //7 color bar
//			rtd_outl(REG_PTG_BARW,((rtd_inl(REG_PTG_BARW)&0xfffffc00)|(rtd_inl(REG_PTG_VSTA_LEN)&0x00000fff)/8)); //7 color bar

			rtd_outl(REG_PTG_C0Y,0x00000000); // black  background
			rtd_outl(REG_PTG_C1Y,0x00ffffff); // white  frontground			
			rtd_outl(REG_PTG_C4Y,0x00007700); // Bitmap 8x8   
			rtd_outl(REG_PTG_C5Y,0xFF0f0f00); // Bitmap 8x8   
			rtd_outl(REG_PTG_C6Y,0x0f0ff000); // Bitmap 8x8   
			rtd_outl(REG_PTG_C7Y,0xf0f0f000); // Bitmap 8x8   
			
			udelay(20000);											
			rtd_outl(0xb8025220,0x00000003); //Enable  CRC
			udelay(20000);											
			temp= rtd_inl(0xb8025224);  //CRC result

			if((temp==0xBAE4E8C3)||(temp==0x6CEB125E)||(temp==0x7CC0715E))
		   		printk("IP_IPTG_Verify Bitmap Pass\n");		
			else{
				printk("IP_IPTG_Verify Bitmap CRC=0x%x\n",temp);		
				Fl_pass=FALSE;	
				}

			udelay(1000000);			// hold pattern on screen for tester see								
			break;	

          case 14: // MV  H/Mp_adj mode    TEST: tester see
			rtd_outl(REG_PTG_TG,rtd_inl(REG_PTG_TG)&0xfffffffd); //progressive 
			rtd_outl(REG_PTG_CTRL,(rtd_inl(REG_PTG_CTRL)&0xfffffff8)|0x0000007); //bitmap pattern
//			rtd_outl(REG_PTG_MAX_COLOR_CTRL,(rtd_inl(REG_PTG_MAX_COLOR_CTRL)|0x07000000)); //7 color bar
//			rtd_outl(REG_PTG_BARW,((rtd_inl(REG_PTG_BARW)&0xfffffc00)|(rtd_inl(REG_PTG_VSTA_LEN)&0x00000fff)/8)); //7 color bar

			rtd_outl(REG_PTG_C0Y,0x00000000); // black  background
			rtd_outl(REG_PTG_C1Y,0x00ffffff); // white  frontground			
			rtd_outl(REG_PTG_C4Y,0x00007700); // Bitmap 8x8   
			rtd_outl(REG_PTG_C5Y,0xFF0f0f00); // Bitmap 8x8   
			rtd_outl(REG_PTG_C6Y,0x0f0ff000); // Bitmap 8x8   
			rtd_outl(REG_PTG_C7Y,0xf0f0f000); // Bitmap 8x8   

			rtd_outl(REG_PTG_MAX_COLOR_CTRL,0x04000f00); // Bitmap 8x8  ,Mv_H_l(Pixel count)= 40 ,Mp_adj_num_l = 00
			rtd_outl(REG_PTG_MAX_COLOR_CTRL,0x04000f80); // Bitmap 8x8   ,Mp_adj_num_l = 80
			
		   		printk("IP_IPTG_Verify Motion H direct  MP_ADJ \n");		

			udelay(10000000);			// hold pattern on screen for tester see
			break;				

          case 15: // MV  V/Mp_adj mode    TEST: tester see
			rtd_outl(REG_PTG_TG,rtd_inl(REG_PTG_TG)&0xfffffffd); //progressive 
			rtd_outl(REG_PTG_CTRL,(rtd_inl(REG_PTG_CTRL)&0xfffffff8)|0x0000007); //Bitmap
//			rtd_outl(REG_PTG_MAX_COLOR_CTRL,(rtd_inl(REG_PTG_MAX_COLOR_CTRL)|0x07000000)); //7 color bar
//			rtd_outl(REG_PTG_BARW,((rtd_inl(REG_PTG_BARW)&0xfffffc00)|(rtd_inl(REG_PTG_VSTA_LEN)&0x00000fff)/8)); //7 color bar

			rtd_outl(REG_PTG_C0Y,0x00000000); // black  background
			rtd_outl(REG_PTG_C1Y,0x00ffffff); // white  frontground			
			rtd_outl(REG_PTG_C4Y,0x00007700); // Bitmap 8x8   
			rtd_outl(REG_PTG_C5Y,0xFF0f0f00); // Bitmap 8x8   
			rtd_outl(REG_PTG_C6Y,0x0f0ff000); // Bitmap 8x8   
			rtd_outl(REG_PTG_C7Y,0xf0f0f000); // Bitmap 8x8   

			rtd_outl(REG_PTG_MAX_COLOR_CTRL,0x00040f00); // Bitmap 8x8   ,Mv_V_l(Line count)= 40 ,Mp_adj_num_l = 00
			rtd_outl(REG_PTG_MAX_COLOR_CTRL,0x00040f80); // Bitmap 8x8   ,Mp_adj_num_l = 80
			
		   		printk("IP_IPTG_Verify Motion V direct  MP_vs_num \n");		

			udelay(3000000);			// hold pattern on screen for tester see
			break;				

	default:
		break;
	}
		// [Clayton][Fix me] by pass first
		// [start]
		
	//if (Fl_pass==FALSE)
		//break;
	// [end]
}
if (Fl_pass==FALSE)
	return 0;
else
	return 1;

}




BOOL	APLL_Thermal_test(void)
{
#if 1
	UINT8	w;
    //UINT8  i;
 	UINT8	num;
	UINT32 	y;
	UINT32	x = 0;
	UINT32	z = 0;
	UINT32	dummy_delay = 0;
	//UINT32 	abl_result=0;
#endif

//20190605
//rtd_outl(0xb80004dc,0x00003000); //open PLL27x clock        00003000
//rtd_maskl(REG_AUTO_FIELD,0xfffffdff,00000200); //APLL DDS autphase depends on i_SmartFit ; Clayton: it should be removed ?!
//rtd_maskl(REG_ADC_AUTO_FIELD,0xfffffdff,00000000); //Clayton: APLL DDS autphase depends on ADC_SmartFit 
//20190605	
	
#if Thremal_testing==0

rtd_outl(0xb800db40, 0x02800202);       //HDMI bandgap power
rtd_outl(0xb800db44, 0x00030800);       //HDMI bandgap power  
rtd_outl(0xb802005c, 0x00130003);	      //LDO power on 

udelay(100000);

printk("480i\n");


udelay(100000);


rtd_outl(0xb802010c, 0x00700000);	//set longt path




 rtd_outl(0xb8020104, 0x00050609);	 //enable APLL LDO 1.1V power, 0xb8020104[18:16]=101(05), 0xb8020104[0]=1, power down , 0xb8020104[13]=1, RSTN_OFFMS for MAC3
 udelay(20000); 
 
///*  MASK wait for script file finish
#include "adc_ypp480i.tbl"
udelay(2500);

//*/

rtd_outl(0xb8020104, 0x00050608);	// enable APLL & dual clk,  0xb8020104[0]=0, Normal run, V16 setting: 1.68V(default), LDO reference voltage setting:1.1V (default), LDO power on, 0xb8020104[13]=1, RSTN_OFFMS for MAC3

udelay(20000);	

///*  MASK wait for script file finish
#include "sp_480i.tbl"
udelay(20000000);	
#include "apll_ypp480i.tbl"                        // APLL for YPbPr480i source
udelay(2100);
udelay(250000);
//*/
//#include "vgip_ch1_ipg_480i.tbl"   //20130324

//#include "vgipch1_480i.tbl"                     // VGIP(ch1) for 480i setting
udelay(20000);	 

///*  MASK wait for script file finish
#include "vgip_ch1_ypp_480i.tbl"               // vgip ch1 for ipg 480i    20130324
udelay(20000);	 
printk("Loading...7!\n");

///*  MASK wait for script file finish

#include "bypass_di_uzd_ch1_444_10b.tbl"	//For MAC3
#include "uzd_bypass_di_480i.tbl"	//For Merlin3, Clayton 6/15
//#include "m_ch1_frc_to_fs.tbl"	//LVDS panel
#include "m_ch1_frc_480i10b444.tbl"	//Clayton 6/15: Update for Vby1 panel
//*/
udelay(20000);	 
printk("Loading...10!\n");

///*  MASK wait for script file finish

udelay(20000);	 
//#include "dpll_fhd.tbl"		// For MAC3
//rtd_outl(0xb8000208, 0x00004014);		//For MAG2
rtd_outl(0xb8000208, 0x00004074);		// D-Domain, SFG, MEMC_IN/OUT Clock Enable, Clayton 6/15
rtd_outl(0xb8028100, 0x00050000);		// Bypass MEMC, Clayton 6/15

#include "dpll_594MHz.tbl"		// For Merlin3: Clayton 6/15
rtd_maskl(0xb80006C8, 0x7FFFFFFF, 0x80000000);	// DPLL use HS APHY
//#include "uzu_main_444_480i_to_fhd.tbl"
#include "uzu_main_444_480i_to_uhd.tbl"


udelay(20000);	 
//#include "dtg_fhd_fs.tbl"		//for sirius
//#include "dtg_fhd.tbl"   //for MAC3
#include "dtg_uhd_frc.tbl"   //for Merlin3, Clayton 6/15
//#include "mtg_fhd.tbl"
//*/
printk("Loading...13!\n");

//*  MASK wait for script file finish

//#include "LVDS_FHD_1Pixel_1Seg_2Port.tbl"		// For MAC3
#include "vby1_uhd_60hz_8lane_10b.tbl"		// For Merlin3, Clayton 6/15
#include "Merlin3_B27_QA.tbl"

#include "ABL_YPP.tbl"
/*
abl_result = rtd_inl(0xb8020208);
	while(abl_result!=0x80000007)
	{   

 
		abl_result = rtd_inl(0xb8020208);
		udelay(1000);
	}

			printk("ABL adjust Pass \n");



 UINT8 BestPhase=0;
 UINT32 BestSOD=0;	 
 udelay(100000);
 printk("Long path\n");


 for (dummy_delay=2; dummy_delay<4; dummy_delay++)
	 {
        x = rtd_inl(0xb8020108)&0x0000ffff;	// set dummy_delay, <1:0> phase0 thermal delay control
		rtd_outl(0xb8020108, x | dummy_delay<<16);  

	   
        printk("Long path dummy_delay = %d\n",dummy_delay);     
        printk("0xb8020108= 0x%x \n",rtd_inl(0xb8020108));

		for (y=0; y<16; y++)
			{

				
			rtd_outl(0xb8020124, y);	// delay_cp_mode, mode0~mode15
			printk("Long path dummy_delay = %d,delay_cp_mode = %d\n",dummy_delay,y);
			printk("0xb8020108= 0x%x \n",rtd_inl(0xb8020108));

			//Smart Fit setting
			//rtd_outl(0xb8022000, 0x00000010);	
			rtd_outl(0xb8022000, 0x000000C0); // only measure odd
			rtd_outl(0xb8022004, 0x02000600);	
			rtd_outl(0xb8022008, 0x00500300);	
			rtd_outl(0xb802200c, 0x40404200);	
			rtd_outl(0xb8022010, 0x0000007a);
			rtd_outl(0xb8022024, 0x00000000);

			z = 0;
			for (num=0; num<128; num++)
				{
				x = rtd_inl(0xb802010c)&0xffffff80;	// set phase
				rtd_outl(0xb802010c, x | z);   //set  0xb802010c = 0xffffff80~0xffffffff
				
				//printk("phase = %x\n",z);
				z = z+1;
				
				for (w=0; w<255; w++)	// for delay
					w = w;
			
				rtd_outl(0xb8022010, 0x0000007b);  //SF ,  AUTO_ADJ
				while((rtd_inl(0xb8022010)&0x00000001)==1)
					{
					for (w=0; w<255; w++)
						w = w;	
					}
			
				x = rtd_inl(0xb8022020);	// AUTO_RESULT_PHASE_L
				//printk("sum = %x\n",x);
				printk("%d\n",x);	
				//printk("SF phase=%d,SOD=%d\n",z,x);
				if(y==15)  // long path    mode 3
					{
					if(x>BestSOD)
						{
						BestPhase=z-1;
						BestSOD=x;
						}
					}
				
				}
			}
     }


   
printk("Software Mode LONG PATH + mode 1 BestPhase=%d, BestSOD=%x \n",BestPhase,BestSOD);
*/



/*
BestPhase=0;
BestSOD=0; 
// Smart Fit auto phase

rtd_outl(0xb8022024, 0x800000ff);
rtd_outl(0xb8022010, 0x00000053);
udelay(10000);	
for (w=0; w<255; w++)
				w = w;	

for(z=0;z<128;z++)
{
	while((rtd_inl(0xb8022024)&0x00000080)==0)		
		{
		//printk("0xb8022024=%x \n",rtd_inl(0xb8022024));
		}
//	printk("0xb8022024=%x \n",rtd_inl(0xb8022024));	
rtd_outl(0xb8022024,rtd_inl(0xb8022024)|0x00000080);
//udelay(10000);	
x = rtd_inl(0xb8022020);
	if(x>BestSOD)
			{
			BestPhase=z;
			BestSOD=x;
			} 
printk("HW Phase=%d SOD=%d \n",z,x);

}
printk("Hardware Mode LONG PATH + mode 1 BestPhase=%d, BestSOD=%x \n",BestPhase,BestSOD);
*/
#endif




#if Thremal_testing==1

rtd_outl(0xb800db40, 0x02800202);       //HDMI bandgap power
rtd_outl(0xb800db44, 0x00030800);       //HDMI bandgap power  
rtd_outl(0xb802005c, 0x00130003);	    //LDO power on 

udelay(100000);

printk("1080i\n");


//              Sirius Mark Script
/*

#include "APLL_ypp_adc_1080i.tbl"


udelay(100000);


rtd_outl(0xb802010c, 0x00700000);//set longt path

#include "APLL_apll_ypp1080i.tbl"

udelay(1000);


#include "APLL_sp_1080i.tbl"
printk("0xb8021004= 0x%x \n",rtd_inl(0xb8021004));

#include "APLL_vgip_ch1_ypp_1080i.tbl"
//#include "LVDS_FHD_1Pixel_1Seg_2Port.tbl"
udelay(1000);


#include "APLL_di_en_ch1_1080i_2d.tbl"
udelay(1000);

#include "APLL_m_ch1_frc_1080i10b444.tbl"
#include "APLL_uzu_main_444_bypass1080i.tbl"
udelay(1000);

//--
#include "APLL_DPLL_297MHz_1080i.tbl"
udelay(1000);

#include "APLL_dtg_fhd_fs_1080i.tbl"
udelay(1000);

#include "APLL_mtg_fhd_1080i.tbl"
#include "APLL_ivs2dvs_1080i_fhd.tbl"		// ivs2dvs delay for ipg1080p to FHD
//#include "m_ch1_frc_to_fs.tbl"			// mdomain change to fs mode
#include "APLL_LVDS_FHD_1Seg_2Port_1080i.tbl"

*/

//				Sirius Mark Script


UINT8 BestPhase=0;
UINT32 BestSOD=0;	

rtd_outl(0xb802010c, 0x00700000);	//set longt path
printk("Long path\n");


udelay(100000);


 for (dummy_delay=2; dummy_delay<4; dummy_delay++)
	 {
        x = rtd_inl(0xb8020108)&0x0000ffff;	// set dummy_delay
		rtd_outl(0xb8020108, x | dummy_delay<<16);  

	   
        printk("Long path dummy_delay = %d\n",dummy_delay);     
        printk("0xb8020108= 0x%x \n",rtd_inl(0xb8020108));

		for (y=0; y<16; y++)
			{

				
			rtd_outl(0xb8020124, y);	// delay_cp_mode
			printk("Long path dummy_delay = %d,delay_cp_mode = %d\n",dummy_delay,y);
			printk("0xb8020108= 0x%x \n",rtd_inl(0xb8020108));

			//Smart Fit setting
			//rtd_outl(0xb8022000, 0x00000010);	
			rtd_outl(0xb8022000, 0x000000C0); // only measure odd
			rtd_outl(0xb8022004, 0x02000600);	
			rtd_outl(0xb8022008, 0x00500300);	
			rtd_outl(0xb802200c, 0x40404200);	
			rtd_outl(0xb8022010, 0x0000007a);
			rtd_outl(0xb8022024, 0x00000000);

			z = 0;
			for (num=0; num<128; num++)
				{
				x = rtd_inl(0xb802010c)&0xffffff80;	// set phase
				rtd_outl(0xb802010c, x | z); 
				
				//printk("phase = %x\n",z);
				z = z+1;
				
				for (w=0; w<255; w++)	// for delay
					w = w;
			
				rtd_outl(0xb8022010, 0x0000007b);
				while((rtd_inl(0xb8022010)&0x00000001)==1)
					{
					for (w=0; w<255; w++)
						w = w;	
					}
			
				x = rtd_inl(0xb8022020);
				//printk("sum = %x\n",x);
				printk("%d\n",x);	
				//printk("SF phase=%d,SOD=%d\n",z,x);
				if(y==15)  // long path    mode 3
					{
					if(x>BestSOD)
						{
						BestPhase=z-1;
						BestSOD=x;
						}
					}
				
				}
			}
     }


   
//printk("Software Mode LONG PATH + mode 1 BestPhase=%d, BestSOD=%x \n",BestPhase,BestSOD);




/*
BestPhase=0;
BestSOD=0; 
// Smart Fit auto phase

rtd_outl(0xb8022024, 0x800000ff);
rtd_outl(0xb8022010, 0x00000053);
udelay(10000);	
for (w=0; w<255; w++)
				w = w;	

for(z=0;z<128;z++)
{
	while((rtd_inl(0xb8022024)&0x00000080)==0)		
		{
		//printk("0xb8022024=%x \n",rtd_inl(0xb8022024));
		}
//	printk("0xb8022024=%x \n",rtd_inl(0xb8022024));	
rtd_outl(0xb8022024,rtd_inl(0xb8022024)|0x00000080);
//udelay(10000);	
x = rtd_inl(0xb8022020);
	if(x>BestSOD)
			{
			BestPhase=z;
			BestSOD=x;
			} 
printk("HW Phase=%d SOD=%d \n",z,x);

}
printk("Hardware Mode LONG PATH + mode 1 BestPhase=%d, BestSOD=%x \n",BestPhase,BestSOD);
*/
#endif

 


	

#if Thremal_testing==2

//20190605
//rtd_outl(0xb800db40, 0x02800202);       //HDMI bandgap power
//rtd_outl(0xb800db44, 0x00030800);       //HDMI bandgap power  
//rtd_outl(0xb802005c, 0x00130003);	    //LDO power on 
//20190605

udelay(100000);

printk("1080P\n");


#include "./Merlin6/adc_ypp1080p.tbl"
#include "./Merlin6/apll_ypp1080p.tbl"
#include "./Merlin6/sp_updn_ypp1080p.tbl"
//#include "./Merlin6/vgip_ch1_ypp_1080p.tbl"
//#include "./Merlin6/uzd_bypass_di_1080p.tbl"
//#include "./Merlin6/m_ch1_frc_1080p10b444.tbl"

rtd_outl(0xb8000208, 0x00000074);		// D-Domain, SFG Clock Enable
rtd_outl(0xb8000230, 0x00211010);		// [22:20]:osd_f2p/4, [18:16]:osd_f1p/2, [14:12]:s2_f2p=/2, [10:8]:s2_f1p, [6:4]:s1_f2p=/2, [2:0]:s1_f1p
rtd_outl(0xb8000234, 0x00100111);		// [22:20]:s2_f2p_div2(mPlus)/2, [18:16]:mc/1, [14:12]:mc_ippre2x/1, [10:8]:mc_ippre/2, [6:4]:memc_out/2, [2:0]:memc_in/2
rtd_outl(0xb802811C, 0x00000001);	       // gating apply

//#include "./Merlin6/dpll_594MHz.tbl"
//#include "./Merlin6/uzu_main_444_1080p_to_uhd.tbl"
//#include "./Merlin6/dtg_uhd_frc.tbl"
//#include "./Merlin6/vby1_uhd_60hz_8lane_8b_to_LVDS.tbl"
//#include "./Merlin6/Merlin5_B22_QA.tbl"

rtd_outl(0x18061100, 0x00000021); 	// ST_GPIO_04 LG panel_ctl
rtd_outl(0x18061108, 0x00000021); 	// ST_GPIO_04 LG panel_ctl


UINT8 BestPhase=0;
UINT32 BestSOD=0;	
/*
rtd_outl(0xb802010c, 0x00400000);	//set Short path   Phase select:Look up table   Intinal phase:phase0 ,PLL2D2 set 0:ADC CLK=1/2 VCO CLK
printk("Short path\n");

    
   for (dummy_delay=0; dummy_delay<4; dummy_delay++)
	   {
          x = rtd_inl(0xb8020108)&0x0000ffff;	// set dummy_delay
		  rtd_outl(0xb8020108, x | dummy_delay<<16);  

	   
          printk("Short path dummy_delay = %d\n",dummy_delay);     
          printk("0xb8020108= 0x%x \n",rtd_inl(0xb8020108));
	   
		for (y=0; y<16; y++)
			{
				
			rtd_outl(0xb8020124, y);	// delay_cp_mode
			printk("Short path dummy_delay = %d ,delay_cp_mode = %d\n",dummy_delay,y);
            printk("0xb8020124= 0x%x \n",rtd_inl(0xb8020124));
			//Smart Fit setting
			//rtd_outl(0xb8022000, 0x00000010);	
			rtd_outl(0xb8022000, 0x000000C0);  // only measure odd
			rtd_outl(0xb8022004, 0x02000600);	
			rtd_outl(0xb8022008, 0x00500300);	
			rtd_outl(0xb802200c, 0x40404200);	
			rtd_outl(0xb8022010, 0x0000007a);
			rtd_outl(0xb8022024, 0x00000000);
			z = 0;
			for (num=0; num<128; num++)
				{
				x = rtd_inl(0xb802010c)&0xffffff80;	// set phase
				rtd_outl(0xb802010c, x | z); 
				
				//printk("phase = %x\n",z);
				//printk("0xb802010c= 0x%x \n",rtd_inl(0xb802010c));
				z = z+1;
			
				for (w=0; w<255; w++)	// for delay
					w = w;
			
				rtd_outl(0xb8022010, 0x0000007b);
				while((rtd_inl(0xb8022010)&0x00000001)==1)
					{
					for (w=0; w<255; w++)	// for delay
						w = w;	
					}
			
				x = rtd_inl(0xb8022020);
				//printk("sum = %x\n",x);
				//printk("\n");
				printk("%d\n",x);	
				}
			}
       }
       */

udelay(100000);

rtd_outl(REG_PLLPHASE_CTRL, _BIT21);	//set longt path ; Clayton: long path--0xb802010c[21]=1
rtd_outl(REG_ADC_PLLPHASE_CTRL, _BIT22);	//Clayton: Set APLL phase select from lookup table--0x0xb8020428[22]=1

printk("Long path\n");

 for (dummy_delay=0; dummy_delay<4; dummy_delay++)
	 {
        x = rtd_inl(REG_PLLDIV)&0x0000ffff;	// set dummy_delay
		rtd_outl(REG_PLLDIV, x | dummy_delay<<16);  	// Clayton: [17:16] phase0 thermal delay control

	   
        printk("Long path dummy_delay = %d\n",dummy_delay);     
        printk("0xb8020108= 0x%x \n",rtd_inl(REG_PLLDIV));

		for (y=0; y<16; y++)
			{

				
			rtd_outl(REG_PLL_DIV_CTRL, y);	// 0xb8020124[3:0] delay_cp_mode
			printk("Long path dummy_delay = %d,delay_cp_mode = %d\n",dummy_delay,y);
			printk("0xb8020124= 0x%x \n",rtd_inl(REG_PLL_DIV_CTRL));

			//Smart Fit setting ->Clayton: Change to ADC-SmartFit
			//rtd_outl(0xb8022000, 0x00000010);	
			rtd_outl(REG_ADC_AUTO_FIELD, 0x80000000); // only measure odd; Clayton: ADC-SmartFit 0x18020400[31:30] need to set 0x2 or 0x3 & odd_sel_en=0 disable for 1080P
			rtd_outl(REG_ADC_AUTO_H_BOUNDARY, 0x02000600);	
			rtd_outl(REG_ADC_AUTO_V_BOUNDARY, 0x00500300);	
			rtd_outl(REG_ADC_AUTO_RGB_MARGIN, 0x40404200);	
			rtd_outl(REG_ADC_AUTO_ADJ, 0x0000007a);
			rtd_outl(REG_ADC_AUTO_PASHE_CTRL0, 0x00000000);

			z = 0;
			for (num=0; num<128; num++)
				{
				x = rtd_inl(REG_ADC_PLLPHASE_CTRL)&0xffffff80;	// set phase
				rtd_outl(REG_ADC_PLLPHASE_CTRL, x | z); 
				
				//printk("phase = %x\n",z);
				z = z+1;
				
				for (w=0; w<255; w++)	// for delay
					w = w;
			
				rtd_outl(REG_ADC_AUTO_ADJ, 0x0000007b);
				// Clayton [fixed me]: temporally mark it, replaced by udelay(100000);
				// [Start]
				
				int test_count=0;
				while((rtd_inl(REG_ADC_AUTO_ADJ)&0x00000001)==1)
					{
					test_count++;
					//printk("APLL_Thermal_test, Check now_af ready or not, test_count=%d\n",test_count);
					for (w=0; w<255; w++)
						w = w;	
					}
				// [End]
				
				//udelay(100000);
				x = rtd_inl(REG_ADC_AUTO_RESULT_PASHE_L);
				//printk("sum = %x\n",x);
				printk("%d\n",x);	
				//printk("SF phase=%d,SOD=%d\n",z,x);
				if(y==15)  // long path    mode 3
					{
					if(x>BestSOD)
						{
						BestPhase=z-1;
						BestSOD=x;
						}
					}
				
				}
			}
     }
printk("Software Mode LONG PATH + mode 1 BestPhase=%d, BestSOD=%x \n",BestPhase,BestSOD);
/*
BestPhase=0;
BestSOD=0; 
// Smart Fit auto phase

rtd_outl(0xb8022024, 0x800000ff);
rtd_outl(0xb8022010, 0x00000053);
udelay(10000);	
for (w=0; w<255; w++)
				w = w;	

for(z=0;z<128;z++)
{
	while((rtd_inl(0xb8022024)&0x00000080)==0)		
		{
		//printk("0xb8022024=%x \n",rtd_inl(0xb8022024));
		}
//	printk("0xb8022024=%x \n",rtd_inl(0xb8022024));	
rtd_outl(0xb8022024,rtd_inl(0xb8022024)|0x00000080);
//udelay(10000);	
x = rtd_inl(0xb8022020);
	if(x>BestSOD)
			{
			BestPhase=z;
			BestSOD=x;
			} 
printk("HW Phase=%d SOD=%d \n",z,x);

}
printk("Hardware Mode LONG PATH + mode 1 BestPhase=%d, BestSOD=%x \n",BestPhase,BestSOD);
*/
#endif

return SUCCESS;

}
// DAC level: 000:0.25V 001:0.4V 010:0.55V 011:0.7V 100:0.85V 101:1.0V 110:1.15V 111:1.3V
void Get_CodeDiff(UINT8 DacLevel1,UINT8 DacLevel2,UINT16 GainValueR,UINT16 GainValueG,UINT16 GainValueB,UINT8 gCalibrationSource)
{
int ii;
UINT8 Avg_count=16;
UINT32 ADC_CODE_A,ADC_CODE_B;
UINT16 temp[6],new_temp[6],old_temp[6];

//printk("Get_CodeDiff\n");

if(0==gCalibrationSource)
	rtd_maskl(REG_ADC_VBIAS,0xffe00fff,_BIT23|_BIT21|_BIT20|_BIT15|_BIT14); //Enable Calib mode,SH gain=1.7
else
	rtd_maskl(REG_ADC_VBIAS,0xffe00fff,_BIT23|_BIT21|_BIT20|_BIT14); //Enable Calib mode,SH gain=1.0	

	temp[0]=0;temp[1]=0;temp[2]=0;temp[3]=0;temp[4]=0;temp[5]=0;
	old_temp[0]=0;old_temp[1]=0;old_temp[2]=0;old_temp[3]=0;old_temp[4]=0;old_temp[5]=0;
	new_temp[0]=0;new_temp[1]=0;new_temp[2]=0;new_temp[3]=0;new_temp[4]=0;new_temp[5]=0;
	rtd_maskl(REG_ADC_VBIAS,0xfff8ffff,(DacLevel1&0x7)<<16); //Enable Calib mode DAC=0.55V
	rtd_outl(REG_ADC_GAIN0,(GainValueG<<16)|GainValueR); //set RG gain
	rtd_outl(REG_ADC_GAIN1,GainValueB); //set B gain
	udelay(50);
	
		for(ii=0;ii<Avg_count+1;ii++)
			{
			ADC_CODE_A=0;ADC_CODE_B=0;
			ADC_CODE_A=rtd_inl(REG_ADC_RGB_DATA);
			ADC_CODE_B=rtd_inl(REG_ADC_RGB_DATA2);
			new_temp[0]=(ADC_CODE_A>>18);
			new_temp[1]=((ADC_CODE_A&0xfff)>>2);
			new_temp[2]=(ADC_CODE_B>>18);			

			if (0!=ii)
				{
				if((20<(YPP_abs(new_temp[0],old_temp[0])))||(20<(YPP_abs(new_temp[1],old_temp[1])))||(20<(YPP_abs(new_temp[2],old_temp[2]))))
					{
					ii=ii-1;
//					printk("Get_CodeDiff error YPP_abs(new_temp[0],old_temp[0])=%d,YPP_abs(new_temp[1],old_temp[1])=%d,YPP_abs(new_temp[2],old_temp[2])=%d,%d\n",(20<(YPP_abs(new_temp[0],old_temp[0]))),(20<(YPP_abs(new_temp[1],old_temp[1]))),(20<(YPP_abs(new_temp[2],old_temp[2]))),
//						(20<YPP_abs(new_temp[0],old_temp[0]))||(20<YPP_abs(new_temp[1],old_temp[1]))||(20<YPP_abs(new_temp[2],old_temp[2])));							
					printk("Get_CodeDiff error new_temp[0]=%d,old_temp[0]=%d,new_temp[1]=%d,old_temp[1]=%d,new_temp[2]=%d,old_temp[2]=%d \n",new_temp[0],old_temp[0],new_temp[1],old_temp[1],new_temp[2],old_temp[2]);							
					}
				else
					{
					temp[0]=new_temp[0]+temp[0];
					temp[1]=new_temp[1]+temp[1];
					temp[2]=new_temp[2]+temp[2];
					}
				}
			old_temp[0]=new_temp[0];
			old_temp[1]=new_temp[1];
			old_temp[2]=new_temp[2];
					
			udelay(10);
			}
		temp[0]	=		temp[0]	>>4;
		temp[1]	=		temp[1]	>>4;
		temp[2]	=		temp[2]	>>4;
	
	rtd_maskl(REG_ADC_VBIAS,0xfff8ffff,(DacLevel2&0x7)<<16); //Enable Calib mode DAC=0.55V
		udelay(50);
			for(ii=0;ii<Avg_count+1;ii++)
			{
			ADC_CODE_A=0;ADC_CODE_B=0;
			ADC_CODE_A=rtd_inl(REG_ADC_RGB_DATA);
			ADC_CODE_B=rtd_inl(REG_ADC_RGB_DATA2);

			new_temp[3]=(ADC_CODE_A>>18);
			new_temp[4]=((ADC_CODE_A&0xfff)>>2);
			new_temp[5]=(ADC_CODE_B>>18);	
			if (0!=ii)
				{
				if((20<(YPP_abs(new_temp[3],old_temp[3])))|(20<(YPP_abs(new_temp[4],old_temp[4])))|(20<(YPP_abs(new_temp[5],old_temp[5]))))
					{
					ii=ii-1;
					printk("Get_CodeDiff error new_temp[3]=%d,old_temp[3]=%d,new_temp[4]=%d,old_temp[4]=%d,new_temp[5]=%d,old_temp[5]=%d \n",new_temp[3],old_temp[3],new_temp[4],old_temp[4],new_temp[5],old_temp[5]);							
					}
				else
					{
					temp[3]=new_temp[3]+temp[3];
					temp[4]=new_temp[4]+temp[4];
					temp[5]=new_temp[5]+temp[5];
					}
				}	
			old_temp[3]=new_temp[3];
			old_temp[4]=new_temp[4];
			old_temp[5]=new_temp[5];
			udelay(10);		

			}
		temp[3]	=		temp[3]	>>4;
		temp[4]	=		temp[4]	>>4;
		temp[5]	=		temp[5]	>>4;	
		
		for(ii=0;ii<3;ii++)
	       CURRENT_DIFF[ii]=temp[3+ii]>temp[0+ii]?(temp[3+ii]-temp[0+ii]):(temp[0+ii]-temp[3+ii]);
		
printk("Currently,  Gain=%d,%d,%d, code=%d,%d,%d,%d,%d,%d,%d,%d,%d\n",GainValueR,GainValueG,GainValueB,temp[0]	,temp[1]	,temp[2]	,temp[3]	,temp[4]	,temp[5],	CURRENT_DIFF[0],CURRENT_DIFF[1],CURRENT_DIFF[2]);

}
void Interpolate_GainValue(UINT16 iCode,UINT8 iADCSelect,signed short  *iNewGain,UINT8 iCalibrationSource )	
{
UINT8 interpolate_zone,i1,i2;
UINT16 temp1,temp2;
//UINT16  ratio;
UINT16 ratio_tempR,ratio_tempG,ratio_tempB;
UINT32 ratio_temp1;
//UINT32 ratio_temp2;
//volatile float ratio;

	ratio_tempR=ADC_Calib[0][AlignPoint];
	ratio_tempG=ADC_Calib[1][AlignPoint];
	ratio_tempB=ADC_Calib[2][AlignPoint];
	ratio_temp1=CURRENT_DIFF[0]+(CURRENT_DIFF[1]<<1)+CURRENT_DIFF[2];
//	ratio=(( CURRENT_DIFF[0]/ratio_tempR)+2*( CURRENT_DIFF[1]/ratio_tempG)+( CURRENT_DIFF[2]/ratio_tempB))/4
	printk("Interpolate_GainValue ratio=%d \n",ratio_temp1);

	for(i1=0;i1<GAIN_SLICE;i1++)
		for (i2=0;i2<CODE_SLICE;i2++){
			ADC_Calib[i1][i2]=(ADC_Calib[i1][i2]*ratio_temp1)/(ratio_tempR+(ratio_tempG<<1)+ratio_tempB);

//			printk("Interpolate_GainValue new ADC_Calib[%d][%d]=%d \n",i1,i2,ADC_Calib[i1][i2]);
			}
			
	interpolate_zone=iCode>ADC_Calib[iADCSelect][0]?0:(iCode>ADC_Calib[iADCSelect][1]?1:(iCode>ADC_Calib[iADCSelect][2]?2:(iCode>ADC_Calib[iADCSelect][3]?3:(iCode>ADC_Calib[iADCSelect][4]?
		                             4:(iCode>ADC_Calib[iADCSelect][5]?5:(iCode>ADC_Calib[iADCSelect][6]?6:(iCode>ADC_Calib[iADCSelect][7]?7:(iCode>ADC_Calib[iADCSelect][8]?8:9))))))));	
	switch (interpolate_zone)
		{
		case 0:
			temp1=ADC_Calib[iADCSelect][interpolate_zone]-ADC_Calib[iADCSelect][interpolate_zone+1];
			temp2=YPP_abs(AWB_ADC_Gain_Slice[iCalibrationSource][interpolate_zone],AWB_ADC_Gain_Slice[iCalibrationSource][interpolate_zone+1]);
			*iNewGain=AWB_ADC_Gain_Slice[iCalibrationSource][interpolate_zone]-(iCode-ADC_Calib[iADCSelect][interpolate_zone])*temp2/temp1;			
			break;
		case 9:
			temp1=ADC_Calib[iADCSelect][interpolate_zone-2]-ADC_Calib[iADCSelect][interpolate_zone-1];
			temp2=YPP_abs(AWB_ADC_Gain_Slice[iCalibrationSource][interpolate_zone-2],AWB_ADC_Gain_Slice[iCalibrationSource][interpolate_zone-1]);
			*iNewGain=AWB_ADC_Gain_Slice[iCalibrationSource][interpolate_zone-1]+(ADC_Calib[iADCSelect][interpolate_zone-1]-iCode)*temp2/temp1;			
			break;
		default:
			temp1=ADC_Calib[iADCSelect][interpolate_zone-1]-ADC_Calib[iADCSelect][interpolate_zone];
			temp2=YPP_abs(AWB_ADC_Gain_Slice[iCalibrationSource][interpolate_zone-1],AWB_ADC_Gain_Slice[iCalibrationSource][interpolate_zone]);
			*iNewGain=AWB_ADC_Gain_Slice[iCalibrationSource][interpolate_zone]-(iCode-ADC_Calib[iADCSelect][interpolate_zone])*temp2/temp1;
			break;
		}
	printk("Interpolate_GainValue interpolate_zone=%d,iNewGain=%d\n",interpolate_zone,*iNewGain);
}
void	Get_ADC_Curve(UINT8 gCalibrationSource)
{
UINT16 ADC_index=0;

rtd_maskl(REG_PLL_CTRL,0xfff8DffE,_BIT18|_BIT16|_BIT13|_BIT0);	 //enable APLL LDO 1.1V power, 0xb8020104[18:16]=101(05), 0xb8020104[0]=1, power down , 0xb8020104[13]=1, RSTN_OFFMS for MAC3
	 udelay(45000);
#include "adc_ypp480i.tbl"
	udelay(50500);
#include "apll_ypp480i.tbl"                        // APLL for YPbPr480i source
rtd_outl(REG_ADC_CTL_RGB123, 0x03550195);
	udelay(25000);
rtd_maskl(REG_PLL_CTRL,0xfff8DffE,(_BIT18|_BIT16|_BIT13)&(~_BIT0));	// enable APLL & dual clk,	0xb8020104[0]=0, Normal run, V16 setting: 1.68V(default), LDO reference voltage setting:1.1V (default), LDO power on, 0xb8020104[13]=1, RSTN_OFFMS for MAC3
	udelay(25000);
rtd_maskl(REG_ADC_CLOCK,0xfffffbff,_BIT10); //clk from Pll27x
rtd_maskl(REG_ADC_DCRESTORE_CTRL,0xffd0fe00,_BIT21); //Enable Calib mode OFFPAD,LPF=10M
rtd_maskl(REG_ADC_CLAMP_CTRL1,0xfffffe00,_BIT8|_BIT6|_BIT5|_BIT3|_BIT2|_BIT0); //VClamping postive Enable
rtd_maskl(REG_ADC_CLAMP_CTRL0,0xf000fe00,_BIT27|_BIT25|_BIT24|_BIT22|_BIT21|_BIT19|_BIT7|_BIT6|_BIT4|_BIT3|_BIT1|_BIT0); //VClamping postive Enable,Up/Dn Nclamping off


printk("Get_CodeDiff\n");
for (ADC_index=0;ADC_index<512;ADC_index++)
Get_CodeDiff(2,4,ADC_index,ADC_index,ADC_index,gCalibrationSource);

}


void	Test_Get_ADC_Curve(UINT8 gCalibrationSource)
{
UINT16 ADC_index=0;

rtd_maskl(REG_PLL_CTRL,0xfff8DffE,_BIT18|_BIT16|_BIT13|_BIT0);	 //enable APLL LDO 1.1V power, 0xb8020104[18:16]=101(05), 0xb8020104[0]=1, power down , 0xb8020104[13]=1, RSTN_OFFMS for MAC3
	 udelay(45000);
#include "adc_ypp480i.tbl"
	udelay(50500);
#include "apll_ypp480i.tbl"                        // APLL for YPbPr480i source
rtd_outl(REG_ADC_CTL_RGB123, 0x03550195);
	udelay(25000);
rtd_maskl(REG_PLL_CTRL,0xfff8DffE,(_BIT18|_BIT16|_BIT13)&(~_BIT0));	// enable APLL & dual clk,	0xb8020104[0]=0, Normal run, V16 setting: 1.68V(default), LDO reference voltage setting:1.1V (default), LDO power on, 0xb8020104[13]=1, RSTN_OFFMS for MAC3
	udelay(25000);
rtd_maskl(REG_ADC_CLOCK,0xfffffbff,_BIT10); //clk from Pll27x
rtd_maskl(REG_ADC_DCRESTORE_CTRL,0xffd0fe00,_BIT21); //Enable Calib mode OFFPAD,LPF=10M
rtd_maskl(REG_ADC_CLAMP_CTRL1,0xfffffe00,_BIT8|_BIT6|_BIT5|_BIT3|_BIT2|_BIT0); //VClamping postive Enable
rtd_maskl(REG_ADC_CLAMP_CTRL0,0xf000fe00,_BIT27|_BIT25|_BIT24|_BIT22|_BIT21|_BIT19|_BIT7|_BIT6|_BIT4|_BIT3|_BIT1|_BIT0); //VClamping postive Enable,Up/Dn Nclamping off


printk("Get_CodeDiff\n");
for (ADC_index=0;ADC_index<512;ADC_index++)
Get_CodeDiff(2,4,30,30,30,gCalibrationSource);

}
void SAWB_GainCalculate(UINT8 sCalibrationSource)
{
// get current 0.55~0.85V code diff at gain =AWB_ADC_Gain_Slice[2]
// DAC level: 000:0.25V 001:0.4V 010:0.55V 011:0.7V 100:0.85V 101:1.0V 110:1.15V 111:1.3V
//Step1. Get the Codediff  at currently align point.
//Step2. Caculate Gain drift at align point. a. Caculate the which gain will have the same codediff on org-table b. code drift = a.-align point
//Step3. Caculate the Gain for GetTagertValue and the final Gain=              

//signed short  sGainCompensate[3];
int i;
printk("SAWB_GainCalculate source=%d\n",sCalibrationSource);

rtd_maskl(REG_PLL_CTRL,0xfff8DffE,_BIT18|_BIT16|_BIT13|_BIT0);	 //enable APLL LDO 1.1V power, 0xb8020104[18:16]=101(05), 0xb8020104[0]=1, power down , 0xb8020104[13]=1, RSTN_OFFMS for MAC3
	 udelay(45000);
#include "adc_ypp480i.tbl"
	udelay(50500);
#include "apll_ypp480i.tbl"                        // APLL for YPbPr480i source
rtd_outl(REG_ADC_CTL_RGB123, 0x03550195);
	udelay(25000);
rtd_maskl(REG_PLL_CTRL,0xfff8DffE,(_BIT18|_BIT16|_BIT13)&(~_BIT0));	// enable APLL & dual clk,	0xb8020104[0]=0, Normal run, V16 setting: 1.68V(default), LDO reference voltage setting:1.1V (default), LDO power on, 0xb8020104[13]=1, RSTN_OFFMS for MAC3
	udelay(25000);
rtd_maskl(REG_ADC_CLOCK,0xfffffbff,_BIT10); //clk from Pll27x
rtd_maskl(REG_ADC_DCRESTORE_CTRL,0xffd0fe00,_BIT21); //Enable Calib mode OFFPAD,LPF=10M
rtd_maskl(REG_ADC_CLAMP_CTRL1,0xfffffe00,_BIT8|_BIT6|_BIT5|_BIT3|_BIT2|_BIT0); //VClamping postive Enable
rtd_maskl(REG_ADC_CLAMP_CTRL0,0xf000fe00,_BIT27|_BIT25|_BIT24|_BIT22|_BIT21|_BIT19|_BIT7|_BIT6|_BIT4|_BIT3|_BIT1|_BIT0); //VClamping postive Enable,Up/Dn Nclamping off



Get_CodeDiff(2,4,AWB_ADC_Gain_Slice[sCalibrationSource][AlignPoint],AWB_ADC_Gain_Slice[sCalibrationSource][AlignPoint],AWB_ADC_Gain_Slice[sCalibrationSource][AlignPoint],sCalibrationSource);
//Calculate_GainDrift(sGainCompensate,sCalibrationSource);
	for (i=0;i<3;i++)
	{
	Interpolate_GainValue(SAWB_GetTARGET[sCalibrationSource][i],i,&FINAL_GAIN[i],sCalibrationSource);
//	FINAL_GAIN[i]=FINAL_GAIN[i]-sGainCompensate[i];
	if (FINAL_GAIN[i]>511)
		FINAL_GAIN[i]=511;
	else if (FINAL_GAIN[i]<0)
	FINAL_GAIN[i]=0;
	}
printk("SAWB_GainCalculate FINAL_GAIN=%d,%d,%d\n",FINAL_GAIN[0],FINAL_GAIN[1],FINAL_GAIN[2]);
printk("SAWB_GainCalculate Source=%d, GetTargetValue=%d,%d,%d\n",sCalibrationSource,SAWB_GetTARGET[sCalibrationSource][0],SAWB_GetTARGET[sCalibrationSource][1],SAWB_GetTARGET[sCalibrationSource][2]);
// confirm final gain and GetTarget
Get_CodeDiff(2,4,FINAL_GAIN[0],FINAL_GAIN[1],FINAL_GAIN[2],sCalibrationSource);
}
void Build_Self_AWB_ADC_Curve(UINT8 bCalibrationSource)
{
int count,i,ii;
//UINT8 Avg_count=16;
//UINT32 ADC_CODE_A,ADC_CODE_B;
//UINT16 temp[6],new_temp[6],old_temp[6],ADC_R,ADC_G,ADC_B;

	printk("Build_Self_AWB_ADC_Curve source=%d\n",bCalibrationSource);
	rtd_maskl(REG_PLL_CTRL,0xfff8DffE,_BIT18|_BIT16|_BIT13|_BIT0);	 //enable APLL LDO 1.1V power, 0xb8020104[18:16]=101(05), 0xb8020104[0]=1, power down , 0xb8020104[13]=1, RSTN_OFFMS for MAC3
		 udelay(45000);
#include "adc_ypp480i.tbl"
		udelay(50500);
#include "apll_ypp480i.tbl"                        // APLL for YPbPr480i source
	rtd_outl(REG_ADC_CTL_RGB123, 0x03550195);
		udelay(125000);
	rtd_maskl(REG_PLL_CTRL,0xfff8DffE,(_BIT18|_BIT16|_BIT13)&(~_BIT0));	// enable APLL & dual clk,	0xb8020104[0]=0, Normal run, V16 setting: 1.68V(default), LDO reference voltage setting:1.1V (default), LDO power on, 0xb8020104[13]=1, RSTN_OFFMS for MAC3
		udelay(125000);
	rtd_maskl(REG_ADC_CLOCK,0xfffffbff,_BIT10); //clk from Pll27x
	if(0==bCalibrationSource)
	rtd_maskl(REG_ADC_VBIAS,0xffe00fff,_BIT23|_BIT21|_BIT20|_BIT15); //Enable Calib mode,SH gain=1.7
	else
	rtd_maskl(REG_ADC_VBIAS,0xffe00fff,_BIT23|_BIT21|_BIT20); //Enable Calib mode,SH gain=1.0		

	rtd_maskl(REG_ADC_DCRESTORE_CTRL,0xffd0fe00,_BIT21); //Enable Calib mode OFFPAD,LPF=10M
	rtd_maskl(REG_ADC_CLAMP_CTRL1,0xfffffe00,_BIT8|_BIT6|_BIT5|_BIT3|_BIT2|_BIT0); //VClamping postive Enable
	rtd_maskl(REG_ADC_CLAMP_CTRL0,0xf000fe00,_BIT27|_BIT25|_BIT24|_BIT22|_BIT21|_BIT19|_BIT7|_BIT6|_BIT4|_BIT3|_BIT1|_BIT0); //VClamping postive Enable
	 

	 
	count=CODE_SLICE;
	//printk("Build_Self_AWB_ADC_Curve count=%d\n",count);
	for(i=0;i<count;i++)
		{
		
		Get_CodeDiff(2,4,AWB_ADC_Gain_Slice[bCalibrationSource][i],AWB_ADC_Gain_Slice[bCalibrationSource][i],AWB_ADC_Gain_Slice[bCalibrationSource][i],bCalibrationSource);
		for(ii=0;ii<3;ii++)
				{
				ADC_Calib[ii][i]=0;
			       ADC_Calib[ii][i]=CURRENT_DIFF[ii];
				}
		}
	printk("ADC_Calib source=%d, Gain Slice=%d,%d,%d,%d,%d,%d,%d,%d,%d\n",bCalibrationSource,AWB_ADC_Gain_Slice[bCalibrationSource][0],AWB_ADC_Gain_Slice[bCalibrationSource][1],AWB_ADC_Gain_Slice[bCalibrationSource][2],
	AWB_ADC_Gain_Slice[bCalibrationSource][3],AWB_ADC_Gain_Slice[bCalibrationSource][4],AWB_ADC_Gain_Slice[bCalibrationSource][5],AWB_ADC_Gain_Slice[bCalibrationSource][6],
	AWB_ADC_Gain_Slice[bCalibrationSource][7],AWB_ADC_Gain_Slice[bCalibrationSource][8]);
	printk("ADC_Calib R diff=%d,%d,%d,%d,%d,%d,%d,%d,%d\n",ADC_Calib[0][0],ADC_Calib[0][1],ADC_Calib[0][2],ADC_Calib[0][3],ADC_Calib[0][4],ADC_Calib[0][5]
														 ,ADC_Calib[0][6],ADC_Calib[0][7],ADC_Calib[0][8]);
	printk("ADC_Calib G diff=%d,%d,%d,%d,%d,%d,%d,%d,%d\n",ADC_Calib[1][0],ADC_Calib[1][1],ADC_Calib[1][2],ADC_Calib[1][3],ADC_Calib[1][4],ADC_Calib[1][5]
 														 ,ADC_Calib[1][6],ADC_Calib[1][7],ADC_Calib[1][8]);
	printk("ADC_Calib B diff=%d,%d,%d,%d,%d,%d,%d,%d,%d\n",ADC_Calib[2][0],ADC_Calib[2][1],ADC_Calib[2][2],ADC_Calib[2][3],ADC_Calib[2][4],ADC_Calib[2][5]
														 ,ADC_Calib[2][6],ADC_Calib[2][7],ADC_Calib[2][8]);
}







BOOL I_domain_IP_Verify(void)
{
bool success=TRUE;
printk("I_domain_IP_Verify, Load 480I IPTG \n");
IPTG_480I(); //RGB color space direct related to IPTG
printk("I_domain_IP_Verify, finish 480I IPTG \n");
//Clayton 5/16 : Temp for Auto phase test
//[Start]
/*
printk("I_domain_IP_Verify, Test APLL_Thermal_test \n");
success=success&APLL_Thermal_test();
return success;
*/
//[End]
success=success&IP_ABL_Verify();
success=success&IP_SP_Verify();		//MAG2 blake_chen verify, 2015.04.07

//	For MAC3 2014.09.02
//if(success==TRUE) //[Clayton][Fix me] by pass temporally
success=success&IP_SF_Verify();		// Clayton: I-SmartFit only needs to test case0
//if(success==TRUE)
success=success&IP_ADCSF_Verify();	// From Mac5p, only needs to test ADC-SmartFit
									// Old SmartFit only keeps Boundary check & data enable

//if(success==TRUE) //[Clayton][Fix me] by pass temporally
success=success&IP_IPTG_Verify();

//Clayton 5/16: Low priority to test
// Due to 3D PTG moving to HDMI part, it didn't bring up till now.
// And 3D ONMS is not used till now.
printk("I_domain_IP_Verify, Skip IP_3D_ONMS_Verify first \n");
//success=success&IP_3D_ONMS_Verify();

//if(success==TRUE)
//success=success&APLL_Thermal_test();



return success;
}


int QC_Verifier_I_Domain(void)
{
	//example

    UINT32 	result = 0;	


	
printk("IMDVerifier\n");


//-------- Module Clock & Reset Enable ---------------------------------
/*
rtd_outl(0x18000110,0xFFFBA3F1);//turn on all except CPUS
rtd_outl(0x18000114,0xFFFFFFFF); 
rtd_outl(0x18000118,0xFFFFFFFF); 
rtd_outl(0x1800011c,0xFFFFFFFF); 

rtd_outl(0x18000110,0xFFFBFFF8);
rtd_outl(0x18000114,0xFCFFFE3C);
rtd_outl(0x18000118,0xFF17EA5A); 
rtd_outl(0x1800011c,0xFFFFDFFE); 

rtd_outl(0x18000100,0xFFFBA775);//except ALL CPUS
rtd_outl(0x18000104,0xFFFFFFFF);
rtd_outl(0x18000108,0xFFFFFFFF); 
rtd_outl(0x1800010c,0xFFFFFFFF); 

rtd_outl(0x18000110,0xFFFBA7F1);//except ALL CPUS
//rtd_outl(0x18000110,0xFFFFFFFF);
rtd_outl(0x18000114,0xFFFFFFFF); 
rtd_outl(0x18000118,0xFFFFFFFF); 
rtd_outl(0x1800011c,0xFFFFFFFF);
*/

/*
       rtd_outl(0xb800010c, 0x00002001);
	rtd_outl(0xb8000114, 0x60002803);// enable TVSB1~3,APLL_ADC,I/M/D domain clock 
	rtd_outl(0xb8000114, 0x60002802);// disable TVSB1~3,APLL_ADC,I/M/D domain clock	
	rtd_outl(0xb8000104, 0xE0002806);// hold TVSB1~3,APLL_ADC,I/M/D domain reset	
	rtd_outl(0xb8000104, 0xE0002807);// release TVSB1~3,APLL_ADC,I/M/D domain reset	
	rtd_outl(0xb800010c, 0x00002001);// release D3 reset
	udelay(100000); 	
	rtd_outl(0xb8000114, 0x60002803);// enable TVSB1~3,APLL_ADC,I/M/D domain clock
	rtd_outl(0xb8000108,  0x03000000);// RESET TVSB1~3,APLL_ADC,I/M/D domain clock	
	rtd_outl(0xb8000108,  0x03000001);// disable TVSB1~3,APLL_ADC,I/M/D domain clock
	rtd_outl(0xb8000118,  0x03000001);// disable TVSB1~3,APLL_ADC,I/M/D domain clock
	rtd_outl(0xb8029000,	0x00000000);// disable PTG
*/


//-------- Module Clock & Reset Enable ---------------------------------
rtd_outl(0x18000114,0x00002a00);//enable TVSB1~5,I/D domain,OFFMS,APLL_ADC clk
rtd_outl(0x18000114,0x00002a01);//disable TVSB1~5,I/D domain,OFFMS,APLL_ADC clk
rtd_outl(0x18000104,0x00002a00);//release TVSB1~5,I/D domain,OFFMS,APLL_ADC rst
rtd_outl(0x18000104,0x00002a01);//enable TVSB1~5,I/D domain,OFFMS,APLL_ADC clk


rtd_outl(0xb8000108,  0x03000000);// RESET TVSB1~3,APLL_ADC,I/M/D domain clock	
rtd_outl(0xb8000108,  0x03000001);// disable TVSB1~3,APLL_ADC,I/M/D domain clock
rtd_outl(0xb8000118,  0x03000000);// disable TVSB1~3,APLL_ADC,I/M/D domain clock
rtd_outl(0xb8000118,  0x03000001);// disable TVSB1~3,APLL_ADC,I/M/D domain clock

rtd_outl(0xb8029000,  0x00000000);// disable PTG


rtd_outl(0xb8000830, 0xCCCCCC00);	 // Vsync Hsync pinmux select

#if 1// 1 run QC code, 0 run IDomain IP test  2014.09.02


printk("IMD process 3 IMD_Tst \n");
    result = result + IMD_Tst();	//IMD_Tst, return 1 fail, return 0 success 

    if (result)
		return FAILED;
    else
		return SUCCESS;

#else //

//IDomain IP Test 
/*
    printk("IDomain IP test \n");
	  result=I_domain_IP_Verify();			
    
    if (result)
		return FAILED;
    else
		return SUCCESS;
*/

//APLL Thermal Test
 
    printk("APLL Thermal test \n");
	  result=APLL_Thermal_test();			
    
    if (result)
		return SUCCESS;
    else
		return FAILED;


#if 0 
//initialize clk 27x domain for VD
////PLL27x Clock : 108M
rtd_maskl(0xb80004D0,0xFFFFFFE0,0x0000000E);//432MHzPLL27X_M[6:0] = 0x0E
rtd_maskl(0xb80004D4,0xFFFFFFFF,0x00000000);// do nothing
rtd_maskl(0xb80004DC,0xFDFC0FFF,0x0201F000);//[25]PLL_L2H_CML_POW [17:16]PLL27X_CK108M_DIV = 0x1, divide by 4 (use when VCO=432MHz) [15:14]PLL27X_YPPADC_CKO_SEL = 0x3,YPPADC clock outpu 11:108M [13]PLL27X_YPPADC_CKO_EN[12]PLL27X_YPPADC_CK54M_EN
rtd_maskl(0xb80004D8,0x00000000,0x00000000);//Power off and rst PLL27x
rtd_maskl(0xb80004D8,0x00000000,0x00000017);//Power on PLL27x [4]PLL27X_PS_EN[3]PLL27X_PS_DIV2 = 0x0 use VCO = 540,324,432M[2]PLL27X_VCORSTB[1]PLL27X_RSTB[0]PLL27X_POW
//	Get_ADC_Curve(SOURCE_YPP);
   	Build_Self_AWB_ADC_Curve(SOURCE_YPP);
	SAWB_GainCalculate(SOURCE_YPP);  		
//	Get_ADC_Curve(SOURCE_SCART);
    Build_Self_AWB_ADC_Curve(SOURCE_SCART); 
	SAWB_GainCalculate(SOURCE_SCART);  		

//		Test_Get_ADC_Curve(SOURCE_YPP);
#endif
	printk("result=%x \n",result);	
   

#endif
	
	printk("\n");	

	return SUCCESS;	
}

