/**
* @file rbusHDMIReg.h
* RBus systemc program.
*
* @author RS_MM2_SD
* @email jason9.ccc@realtek.com
 * @date 2014/7/24
* @ingroup model_rbus
 * @version { 1.0 }
 **
 */

#ifndef _RBUS_HDMI_REG_H_
#define _RBUS_HDMI_REG_H_

#include "rbusTypes.h"



//  HDMI_CLKDET Register Address



#define  HDMI_CLKDET_CLKDETCR_VADDR                         	(0xb8061f00)
#define  HDMI_CLKDET_CLKDETSR_VADDR                         	(0xb8061f04)
#define  HDMI_CLKDET_GDI_TMDSCLK_SETTING_00_VADDR           	(0xb8061f08)
#define  HDMI_CLKDET_GDI_TMDSCLK_SETTING_01_VADDR           	(0xb8061f0c)
#define  HDMI_CLKDET_GDI_TMDSCLK_SETTING_02_VADDR           	(0xb8061f10)



#ifndef LITTLE_ENDIAN //apply BIG_ENDIAN

//======HDMI_CLKDET register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:31;
        RBus_UInt32  clock_det_en:1;
    };
}hdmi_clkdet_clkdetcr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:26;
        RBus_UInt32  en_tmds_chg_irq:1;
        RBus_UInt32  tmds_chg_irq:1;
        RBus_UInt32  dummy18061f04_3_2:2;
        RBus_UInt32  clk_in_target_irq_en:1;
        RBus_UInt32  clk_in_target:1;
    };
}hdmi_clkdet_clkdetsr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  dclk_cnt_start:12;
        RBus_UInt32  res2:4;
        RBus_UInt32  dclk_cnt_end:12;
    };
}hdmi_clkdet_gdi_tmdsclk_setting_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  target_for_maximum_clk_counter:12;
        RBus_UInt32  res2:4;
        RBus_UInt32  target_for_minimum_clk_counter:12;
    };
}hdmi_clkdet_gdi_tmdsclk_setting_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  clk_counter_err_threshold:4;
        RBus_UInt32  clk_counter_debounce:8;
    };
}hdmi_clkdet_gdi_tmdsclk_setting_02_RBUS;

#else //apply LITTLE_ENDIAN

//======HDMI_CLKDET register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  clock_det_en:1;
        RBus_UInt32  res1:31;
    };
}hdmi_clkdet_clkdetcr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  clk_in_target:1;
        RBus_UInt32  clk_in_target_irq_en:1;
        RBus_UInt32  dummy18061f04_3:2;
        RBus_UInt32  tmds_chg_irq:1;
        RBus_UInt32  en_tmds_chg_irq:1;
        RBus_UInt32  res1:26;
    };
}hdmi_clkdet_clkdetsr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dclk_cnt_end:12;
        RBus_UInt32  res1:4;
        RBus_UInt32  dclk_cnt_start:12;
        RBus_UInt32  res2:4;
    };
}hdmi_clkdet_gdi_tmdsclk_setting_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  target_for_minimum_clk_counter:12;
        RBus_UInt32  res1:4;
        RBus_UInt32  target_for_maximum_clk_counter:12;
        RBus_UInt32  res2:4;
    };
}hdmi_clkdet_gdi_tmdsclk_setting_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  clk_counter_debounce:8;
        RBus_UInt32  clk_counter_err_threshold:4;
        RBus_UInt32  res1:20;
    };
}hdmi_clkdet_gdi_tmdsclk_setting_02_RBUS;




#endif

//  HDMI Register Address

/*

#define  HDMI_TMDS_MSR0_VADDR                               	(0xb800d000)
#define  HDMI_TMDS_MSR1_VADDR                               	(0xb800d004)
#define  HDMI_TMDS_CRCC_VADDR                               	(0xb800d008)
#define  HDMI_TMDS_CRCO0_VADDR                              	(0xb800d00c)
#define  HDMI_TMDS_CRCO1_VADDR                              	(0xb800d010)
#define  HDMI_TMDS_CTRL_VADDR                               	(0xb800d014)
#define  HDMI_TMDS_OUTCTL_VADDR                             	(0xb800d018)
#define  HDMI_TMDS_PWDCTL_VADDR                             	(0xb800d01c)
#define  HDMI_TMDS_Z0CC_VADDR                               	(0xb800d020)
#define  HDMI_TMDS_CPS_VADDR                                	(0xb800d024)
#define  HDMI_TMDS_UDC_VADDR                                	(0xb800d028)
#define  HDMI_TMDS_ERRC_VADDR                               	(0xb800d02c)
#define  HDMI_TMDS_OUT_CTRL_VADDR                           	(0xb800d030)
#define  HDMI_TMDS_ROUT_VADDR                               	(0xb800d034)
#define  HDMI_TMDS_GOUT_VADDR                               	(0xb800d038)
#define  HDMI_TMDS_BOUT_VADDR                               	(0xb800d03c)
#define  HDMI_TMDS_DPC0_VADDR                               	(0xb800d040)
#define  HDMI_TMDS_DPC1_VADDR                               	(0xb800d044)
#define  HDMI_TMDS_DPC_SET0_VADDR                           	(0xb800d048)
#define  HDMI_TMDS_DPC_SET1_VADDR                           	(0xb800d04c)
#define  HDMI_TMDS_DPC_SET2_VADDR                           	(0xb800d050)
#define  HDMI_TMDS_DPC_SET3_VADDR                           	(0xb800d054)
#define  HDMI_TMDS_DET_CTL_VADDR                            	(0xb800d058)
#define  HDMI_TMDS_DET_STS_VADDR                            	(0xb800d05c)
#define  HDMI_VIDEO_BIT_ERR_DET_VADDR                       	(0xb800d060)
#define  HDMI_VIDEO_BIT_ERR_STATUS_VADDR                    	(0xb800d064)
#define  HDMI_CH_CR_VADDR                                   	(0xb800d068)
#define  HDMI_CH_SR_VADDR                                   	(0xb800d06c)
#define  HDMI_HDMI_SR_VADDR                                 	(0xb800d080)
#define  HDMI_HDMI_GPVS_VADDR                               	(0xb800d084)
#define  HDMI_HDMI_PSAP_VADDR                               	(0xb800d088)
#define  HDMI_HDMI_PSDP_VADDR                               	(0xb800d08c)
#define  HDMI_HDMI_SCR_VADDR                                	(0xb800d090)
#define  HDMI_HDMI_BCHCR_VADDR                              	(0xb800d094)
#define  HDMI_HDMI_AVMCR_VADDR                              	(0xb800d098)
#define  HDMI_HDMI_WDCR0_VADDR                              	(0xb800d09c)
#define  HDMI_HDMI_DBCR_VADDR                               	(0xb800d0a0)
#define  HDMI_HDMI_AWDSR_VADDR                              	(0xb800d0a4)
#define  HDMI_HDMI_VWDSR_VADDR                              	(0xb800d0a8)
#define  HDMI_HDMI_PAMICR_VADDR                             	(0xb800d0ac)
#define  HDMI_HDMI_PTRSV1_VADDR                             	(0xb800d0b0)
#define  HDMI_HDMI_PVGCR0_VADDR                             	(0xb800d0b4)
#define  HDMI_HDMI_PVSR0_VADDR                              	(0xb800d0b8)
#define  HDMI_HDMI_VCR_VADDR                                	(0xb800d0bc)
#define  HDMI_HDMI_ACRCR_VADDR                              	(0xb800d0c0)
#define  HDMI_HDMI_ACRSR0_VADDR                             	(0xb800d0c4)
#define  HDMI_HDMI_ACRSR1_VADDR                             	(0xb800d0c8)
#define  HDMI_HDMI_ACS0_VADDR                               	(0xb800d0cc)
#define  HDMI_HDMI_ACS1_VADDR                               	(0xb800d0d0)
#define  HDMI_HDMI_INTCR_VADDR                              	(0xb800d0d4)
#define  HDMI_HDMI_ALCR_VADDR                               	(0xb800d0d8)
#define  HDMI_HDMI_AOCR_VADDR                               	(0xb800d0dc)
#define  HDMI_HDMI_BCSR_VADDR                               	(0xb800d0e0)
#define  HDMI_HDMI_ASR0_VADDR                               	(0xb800d0e4)
#define  HDMI_HDMI_ASR1_VADDR                               	(0xb800d0e8)
#define  HDMI_HDMI_VIDEO_FORMAT_VADDR                       	(0xb800d0ec)
#define  HDMI_HDMI_3D_FORMAT_VADDR                          	(0xb800d0f0)
#define  HDMI_AUDIO_SAMPLE_RATE_CHANGE_IRQ_VADDR            	(0xb800d100)
#define  HDMI_HIGH_BIT_RATE_AUDIO_PACKET_VADDR              	(0xb800d104)
#define  HDMI_HDMI_AFCR_VADDR                               	(0xb800d108)
#define  HDMI_HDMI_AFSR_VADDR                               	(0xb800d10c)
#define  HDMI_HDMI_MAGCR0_VADDR                             	(0xb800d110)
#define  HDMI_HDMI_MAG_M_FINAL_VADDR                        	(0xb800d114)
#define  HDMI_ZCD_CTRL_VADDR                                	(0xb800d118)
#define  HDMI_AUDIO_FREQDET_VADDR                           	(0xb800d11c)
#define  HDMI_RANGE0_1_VADDR                                	(0xb800d120)
#define  HDMI_RANGE2_3_VADDR                                	(0xb800d124)
#define  HDMI_RANGE4_5_VADDR                                	(0xb800d128)
#define  HDMI_PRESET_S_CODE0_VADDR                          	(0xb800d12c)
#define  HDMI_PRESET_S_CODE1_VADDR                          	(0xb800d130)
#define  HDMI_PRBS7_R_CTRL_VADDR                            	(0xb800d134)
#define  HDMI_PRBS7_G_CTRL_VADDR                            	(0xb800d138)
#define  HDMI_PRBS7_B_CTRL_VADDR                            	(0xb800d13c)
#define  HDMI_HDMI_LEADING_GB_CMP_CTRL_VADDR                	(0xb800d140)
#define  HDMI_HDMI_LEADING_GB_CMP_TIMES_VADDR               	(0xb800d144)
#define  HDMI_HDMI_LEADING_GB_CMP_CNT_VADDR                 	(0xb800d148)
#define  HDMI_AUDIO_CTS_UP_BOUND_VADDR                      	(0xb800d14c)
#define  HDMI_AUDIO_CTS_LOW_BOUND_VADDR                     	(0xb800d150)
#define  HDMI_AUDIO_N_UP_BOUND_VADDR                        	(0xb800d154)
#define  HDMI_AUDIO_N_LOW_BOUND_VADDR                       	(0xb800d158)
#define  HDMI_MHL_HDMI_MAC_CTRL_VADDR                       	(0xb800d15c)
#define  HDMI_MHL_3D_FORMAT_VADDR                           	(0xb800d160)
#define  HDMI_LIGHT_SLEEP_VADDR                             	(0xb800d170)
#define  HDMI_DEEP_SLEEP_VADDR                              	(0xb800d174)
#define  HDMI_SHOT_DOWN_VADDR                               	(0xb800d178)
#define  HDMI_READ_MARGIN_ENABLE_VADDR                      	(0xb800d17c)
#define  HDMI_READ_MARGIN_VADDR                             	(0xb800d180)
#define  HDMI_BIST_MODE_VADDR                               	(0xb800d184)
#define  HDMI_BIST_DONE_VADDR                               	(0xb800d188)
#define  HDMI_BIST_FAIL_VADDR                               	(0xb800d18c)
#define  HDMI_DRF_MODE_VADDR                                	(0xb800d190)
#define  HDMI_DRF_RESUME_VADDR                              	(0xb800d194)
#define  HDMI_DRF_DONE_VADDR                                	(0xb800d198)
#define  HDMI_DRF_PAUSE_VADDR                               	(0xb800d19c)
#define  HDMI_DRF_FAIL_VADDR                                	(0xb800d1a0)
#define  HDMI_DVS_VADDR                                     	(0xb800d1a4)
#define  HDMI_DVSE_VADDR                                    	(0xb800d1a8)
#define  HDMI_CTS_FIFO_CTL_VADDR                            	(0xb800d1ac)
#define  HDMI_CBUS_CLK_CTL_VADDR                            	(0xb800d1b0)
#define  HDMI_HDCP_BIST_VADDR                               	(0xb800d200)
#define  HDMI_HDCP_CR_VADDR                                 	(0xb800d204)
#define  HDMI_HDCP_DKAP_VADDR                               	(0xb800d208)
#define  HDMI_HDCP_PCR_VADDR                                	(0xb800d20c)
#define  HDMI_HDCP_FLAG1_VADDR                              	(0xb800d210)
#define  HDMI_HDCP_FLAG2_VADDR                              	(0xb800d214)
#define  HDMI_HDCP_AP_VADDR                                 	(0xb800d218)
#define  HDMI_HDCP_DP_VADDR                                 	(0xb800d21c)
#define  HDMI_HDCP_2P2_CR_VADDR                             	(0xb800d220)
#define  HDMI_HDCP_2P2_KS0_VADDR                            	(0xb800d224)
#define  HDMI_HDCP_2P2_KS1_VADDR                            	(0xb800d228)
#define  HDMI_HDCP_2P2_KS2_VADDR                            	(0xb800d22c)
#define  HDMI_HDCP_2P2_KS3_VADDR                            	(0xb800d230)
#define  HDMI_HDCP_2P2_LC0_VADDR                            	(0xb800d234)
#define  HDMI_HDCP_2P2_LC1_VADDR                            	(0xb800d238)
#define  HDMI_HDCP_2P2_LC2_VADDR                            	(0xb800d23c)
#define  HDMI_HDCP_2P2_LC3_VADDR                            	(0xb800d240)
#define  HDMI_HDCP_2P2_RIV0_VADDR                           	(0xb800d244)
#define  HDMI_HDCP_2P2_RIV1_VADDR                           	(0xb800d248)
#define  HDMI_HDCP_2P2_SR0_VADDR                            	(0xb800d24c)
#define  HDMI_HDCP_2P2_SR1_VADDR                            	(0xb800d250)
#define  HDMI_HDCP_MSAP_VADDR                               	(0xb800d254)
#define  HDMI_HDCP_MSDP_VADDR                               	(0xb800d258)
#define  HDMI_HDMI_CMCR_VADDR                               	(0xb800d300)
#define  HDMI_HDMI_MCAPR_VADDR                              	(0xb800d304)
#define  HDMI_HDMI_SCAPR_VADDR                              	(0xb800d308)
#define  HDMI_HDMI_DCAPR0_VADDR                             	(0xb800d30c)
#define  HDMI_HDMI_PSCR_VADDR                               	(0xb800d310)
#define  HDMI_HDMI_AFDD_VADDR                               	(0xb800d31c)
#define  HDMI_HDMI_FTR_VADDR                                	(0xb800d320)
#define  HDMI_HDMI_FBR_VADDR                                	(0xb800d324)
#define  HDMI_HDMI_ICPSNCR0_VADDR                           	(0xb800d328)
#define  HDMI_HDMI_PCPSNCR0_VADDR                           	(0xb800d32c)
#define  HDMI_HDMI_ICTPSR0_VADDR                            	(0xb800d330)
#define  HDMI_HDMI_PCTPSR0_VADDR                            	(0xb800d334)
#define  HDMI_HDMI_ICBPSR0_VADDR                            	(0xb800d338)
#define  HDMI_HDMI_PCBPSR0_VADDR                            	(0xb800d33c)
#define  HDMI_HDMI_NTX1024TR0_VADDR                         	(0xb800d340)
#define  HDMI_HDMI_STBPR_VADDR                              	(0xb800d344)
#define  HDMI_HDMI_NCPER_VADDR                              	(0xb800d348)
#define  HDMI_HDMI_PETR_VADDR                               	(0xb800d34c)
#define  HDMI_HDMI_AAPNR_VADDR                              	(0xb800d350)
#define  HDMI_HDMI_APDMCR_VADDR                             	(0xb800d354)
#define  HDMI_HDMI_APTMCR0_VADDR                            	(0xb800d358)
#define  HDMI_HDMI_APTMCR1_VADDR                            	(0xb800d35c)
#define  HDMI_HDMI_NPECR_VADDR                              	(0xb800d360)
#define  HDMI_HDMI_NROR_VADDR                               	(0xb800d364)
#define  HDMI_HDMI_NTX1024TR0_THRESHOLD_VADDR               	(0xb800d368)
#define  HDMI_HDMI_APLLCR0_VADDR                            	(0xb800d380)
#define  HDMI_HDMI_APLLCR1_VADDR                            	(0xb800d384)
#define  HDMI_HDMI_APLLCR2_VADDR                            	(0xb800d388)
#define  HDMI_HDMI_APLLCR3_VADDR                            	(0xb800d38c)
#define  HDMI_HDMI_APLL_TESTM_VADDR                         	(0xb800d390)
#define  HDMI_HDMI_VPLLCR0_VADDR                            	(0xb800d400)
#define  HDMI_HDMI_VPLLCR1_VADDR                            	(0xb800d404)
#define  HDMI_HDMI_VPLLCR2_VADDR                            	(0xb800d408)
#define  HDMI_MN_SCLKG_CTRL_VADDR                           	(0xb800d410)
#define  HDMI_MN_SCLKG_DIVS_VADDR                           	(0xb800d414)

*/
// For IFD USE
#define  HDMI_HDMI_APLLCR1_VADDR                            	(0xb800d384)
#define  HDMI_HDMI_VPLLCR1_VADDR                            	(0xb800d404)


#ifndef LITTLE_ENDIAN //apply BIG_ENDIAN

//======HDMI register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  tmm:1;
        RBus_UInt32  mt:3;
        RBus_UInt32  ncp:4;
    };
}hdmi_tmds_msr0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  tms:1;
        RBus_UInt32  mrs:2;
        RBus_UInt32  ms:2;
        RBus_UInt32  ctc:1;
        RBus_UInt32  vmr:7;
    };
}hdmi_tmds_msr1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:27;
        RBus_UInt32  crc_done:1;
        RBus_UInt32  crc_nonstable:1;
        RBus_UInt32  crcts:2;
        RBus_UInt32  crcc:1;
    };
}hdmi_tmds_crcc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  crcob2_3:8;
        RBus_UInt32  crcob2_2:8;
        RBus_UInt32  crcob2_1:8;
    };
}hdmi_tmds_crco0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  crcob2_6:8;
        RBus_UInt32  crcob2_5:8;
        RBus_UInt32  crcob2_4:8;
    };
}hdmi_tmds_crco1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  bcd:1;
        RBus_UInt32  gcd:1;
        RBus_UInt32  rcd:1;
        RBus_UInt32  ho:1;
        RBus_UInt32  yo:1;
        RBus_UInt32  dummy1800d014_2_0:3;
    };
}hdmi_tmds_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:18;
        RBus_UInt32  trcoe_r:1;
        RBus_UInt32  tgcoe_r:1;
        RBus_UInt32  tbcoe_r:1;
        RBus_UInt32  ocke_r:1;
        RBus_UInt32  aoe:1;
        RBus_UInt32  trcoe:1;
        RBus_UInt32  tgcoe:1;
        RBus_UInt32  tbcoe:1;
        RBus_UInt32  ocke:1;
        RBus_UInt32  ockie:1;
        RBus_UInt32  dummy1800d018_3:1;
        RBus_UInt32  dummy1800d018_2:1;
        RBus_UInt32  dummy1800d018_1:1;
        RBus_UInt32  dummy1800d018_0:1;
    };
}hdmi_tmds_outctl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ecc_r:1;
        RBus_UInt32  erip_r:1;
        RBus_UInt32  egip_r:1;
        RBus_UInt32  ebip_r:1;
        RBus_UInt32  dummy1800d01c_27_10:18;
        RBus_UInt32  video_preamble_off_en:1;
        RBus_UInt32  hs_width_sel:1;
        RBus_UInt32  deo:1;
        RBus_UInt32  brcw:1;
        RBus_UInt32  pnsw:1;
        RBus_UInt32  iccaf:1;
        RBus_UInt32  ecc:1;
        RBus_UInt32  erip:1;
        RBus_UInt32  egip:1;
        RBus_UInt32  ebip:1;
    };
}hdmi_tmds_pwdctl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:31;
        RBus_UInt32  hde:1;
    };
}hdmi_tmds_z0cc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  pll_div2_en:1;
        RBus_UInt32  no_clk_in:1;
        RBus_UInt32  clkv_meas_sel:2;
        RBus_UInt32  de_inv_disable:1;
        RBus_UInt32  de_err_pulse_en:1;
        RBus_UInt32  clr_infoframe_dvi:1;
        RBus_UInt32  auto_dvi2hdmi:1;
        RBus_UInt32  dummy1800d024_1_0:2;
    };
}hdmi_tmds_cps_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  debug_sel:6;
        RBus_UInt32  dummy1800d028_3:1;
        RBus_UInt32  cptest:1;
        RBus_UInt32  hmtm:2;
    };
}hdmi_tmds_udc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:29;
        RBus_UInt32  nl:3;
    };
}hdmi_tmds_errc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  tmds_bypass:1;
        RBus_UInt32  dummy1800d030_6_0:7;
    };
}hdmi_tmds_out_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  tmds_rout_h:8;
        RBus_UInt32  tmds_rout_l:8;
    };
}hdmi_tmds_rout_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  tmds_gout_h:8;
        RBus_UInt32  tmds_gout_l:8;
    };
}hdmi_tmds_gout_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  tmds_bout_h:8;
        RBus_UInt32  tmds_bout_l:8;
    };
}hdmi_tmds_bout_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  dpc_pp_valid:1;
        RBus_UInt32  dpc_default_ph:1;
        RBus_UInt32  dpc_pp:4;
        RBus_UInt32  dpc_cd:4;
    };
}hdmi_tmds_dpc0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:13;
        RBus_UInt32  dpc_cd_chg_flag:1;
        RBus_UInt32  dpc_cd_chg_wd_en:1;
        RBus_UInt32  dpc_cd_chg_int_en:1;
        RBus_UInt32  dummy1800d044_15_11:5;
        RBus_UInt32  dpc_auto:1;
        RBus_UInt32  dpc_pp_valid_fw:1;
        RBus_UInt32  dpc_default_ph_fw:1;
        RBus_UInt32  dpc_pp_fw:4;
        RBus_UInt32  dpc_cd_fw:4;
    };
}hdmi_tmds_dpc1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:23;
        RBus_UInt32  dpc_bypass_dis:1;
        RBus_UInt32  dpc_en:1;
        RBus_UInt32  phase_errcnt_in:3;
        RBus_UInt32  phase_clrcnt_in:3;
        RBus_UInt32  phase_clr_sel:1;
    };
}hdmi_tmds_dpc_set0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  set_full_noti:4;
        RBus_UInt32  set_empty_noti:4;
    };
}hdmi_tmds_dpc_set1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fifo_errcnt_in:3;
        RBus_UInt32  clr_phase_flag:1;
        RBus_UInt32  clr_fifo_flag:1;
        RBus_UInt32  dpc_phase_ok:1;
        RBus_UInt32  dpc_phase_err_flag:1;
        RBus_UInt32  dpc_fifo_err_flag:1;
    };
}hdmi_tmds_dpc_set2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  dpc_fifo_over_flag:1;
        RBus_UInt32  dpc_fifo_under_flag:1;
        RBus_UInt32  dpc_fifo_over_xflag:1;
        RBus_UInt32  dpc_fifo_under_xflag:1;
        RBus_UInt32  res2:4;
    };
}hdmi_tmds_dpc_set3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  de_sel:1;
        RBus_UInt32  tran_err_thrd:4;
        RBus_UInt32  neg_de_err_thrd:4;
        RBus_UInt32  pos_de_err_thrd:4;
        RBus_UInt32  dummy1800d058_15:1;
        RBus_UInt32  neg_de_lowbd:7;
        RBus_UInt32  dummy1800d058_7_6:2;
        RBus_UInt32  pos_de_lowbd:6;
    };
}hdmi_tmds_det_ctl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:23;
        RBus_UInt32  red_tran_err_flag:1;
        RBus_UInt32  grn_tran_err_flag:1;
        RBus_UInt32  blu_tran_err_flag:1;
        RBus_UInt32  red_pos_de_err_flag:1;
        RBus_UInt32  grn_pos_de_err_flag:1;
        RBus_UInt32  blu_pos_de_err_flag:1;
        RBus_UInt32  red_neg_de_err_flag:1;
        RBus_UInt32  grn_neg_de_err_flag:1;
        RBus_UInt32  blu_neg_de_err_flag:1;
    };
}hdmi_tmds_det_sts_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  thd:16;
        RBus_UInt32  res1:4;
        RBus_UInt32  irq_en:1;
        RBus_UInt32  reset:1;
        RBus_UInt32  period:6;
        RBus_UInt32  ch_sel:2;
        RBus_UInt32  mode:1;
        RBus_UInt32  en:1;
    };
}hdmi_video_bit_err_det_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  ad_max:5;
        RBus_UInt32  ad_min:5;
        RBus_UInt32  no_dis_reset:1;
        RBus_UInt32  bit_err_thd:1;
        RBus_UInt32  bit_err:1;
        RBus_UInt32  bit_err_cnt_of:1;
        RBus_UInt32  bit_err_cnt:16;
    };
}hdmi_video_bit_err_status_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:7;
        RBus_UInt32  r_ch_afifo_en:1;
        RBus_UInt32  g_ch_afifo_en:1;
        RBus_UInt32  b_ch_afifo_en:1;
        RBus_UInt32  ch_sync_sel:2;
        RBus_UInt32  dummy1800d068_19_17:3;
        RBus_UInt32  rden_thr:5;
        RBus_UInt32  dummy1800d068_11_9:3;
        RBus_UInt32  udwater_thr:5;
        RBus_UInt32  dummy1800d068_3_2:2;
        RBus_UInt32  flush:1;
        RBus_UInt32  ch_afifo_irq_en:1;
    };
}hdmi_ch_cr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:1;
        RBus_UInt32  rgb_de_align_flag:1;
        RBus_UInt32  r_rwclk_det_timeout_flag:1;
        RBus_UInt32  r_wrclk_det_timeout_flag:1;
        RBus_UInt32  g_rwclk_det_timeout_flag:1;
        RBus_UInt32  g_wrclk_det_timeout_flag:1;
        RBus_UInt32  b_rwclk_det_timeout_flag:1;
        RBus_UInt32  b_wrclk_det_timeout_flag:1;
        RBus_UInt32  r_rudflow_flag:1;
        RBus_UInt32  r_wovflow_flag:1;
        RBus_UInt32  r_rflush_flag:1;
        RBus_UInt32  r_rw_water_lv:5;
        RBus_UInt32  g_rudflow_flag:1;
        RBus_UInt32  g_wovflow_flag:1;
        RBus_UInt32  g_rflush_flag:1;
        RBus_UInt32  g_rw_water_lv:5;
        RBus_UInt32  b_rudflow_flag:1;
        RBus_UInt32  b_wovflow_flag:1;
        RBus_UInt32  b_rflush_flag:1;
        RBus_UInt32  b_rw_water_lv:5;
    };
}hdmi_ch_sr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  avmute_bg:1;
        RBus_UInt32  avmute:1;
        RBus_UInt32  vic:1;
        RBus_UInt32  spdiftype:1;
        RBus_UInt32  pllsts:1;
        RBus_UInt32  afifoof:1;
        RBus_UInt32  afifouf:1;
        RBus_UInt32  mode:1;
    };
}hdmi_hdmi_sr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:18;
        RBus_UInt32  gmps_v:1;
        RBus_UInt32  vsps_v:1;
        RBus_UInt32  gmps:1;
        RBus_UInt32  vsps:1;
        RBus_UInt32  nps:1;
        RBus_UInt32  dummy1800d084_8:1;
        RBus_UInt32  dummy1800d084_7:1;
        RBus_UInt32  pis_6:1;
        RBus_UInt32  pis_5:1;
        RBus_UInt32  pvs_4:1;
        RBus_UInt32  pvs_3:1;
        RBus_UInt32  pvs_2:1;
        RBus_UInt32  pvs_1:1;
        RBus_UInt32  pvs_0:1;
    };
}hdmi_hdmi_gpvs_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  apss:8;
    };
}hdmi_hdmi_psap_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  dpss:8;
    };
}hdmi_hdmi_psdp_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  nval:8;
        RBus_UInt32  res2:1;
        RBus_UInt32  no_vs_det_en:1;
        RBus_UInt32  dvi_reset_ds_cm_en:1;
        RBus_UInt32  packet_ignore:1;
        RBus_UInt32  mode:1;
        RBus_UInt32  msmode:1;
        RBus_UInt32  cabs:1;
        RBus_UInt32  fcddip:1;
    };
}hdmi_hdmi_scr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  res2:2;
        RBus_UInt32  spcss:1;
        RBus_UInt32  enrwe:1;
        RBus_UInt32  bche:1;
        RBus_UInt32  bches:1;
        RBus_UInt32  bches2:1;
        RBus_UInt32  pe:1;
    };
}hdmi_hdmi_bchcr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  wd_ptg_en:1;
        RBus_UInt32  wd_vclk_en:1;
        RBus_UInt32  avmute_flag:1;
        RBus_UInt32  avmute_win_en:1;
        RBus_UInt32  aoc:1;
        RBus_UInt32  aomc:1;
        RBus_UInt32  awd:1;
        RBus_UInt32  ve:1;
        RBus_UInt32  ampic:1;
        RBus_UInt32  vdpic:1;
        RBus_UInt32  nfpss:1;
    };
}hdmi_hdmi_avmcr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:6;
        RBus_UInt32  awdch:1;
        RBus_UInt32  vwdch:1;
        RBus_UInt32  vwdap:1;
        RBus_UInt32  vwdlf:1;
        RBus_UInt32  vwdafo:1;
        RBus_UInt32  vwdafu:1;
        RBus_UInt32  yv:4;
        RBus_UInt32  awdck:1;
        RBus_UInt32  awdlf:1;
        RBus_UInt32  ch_st_sel:1;
        RBus_UInt32  vwdact:1;
        RBus_UInt32  xv:4;
        RBus_UInt32  asmfe:1;
        RBus_UInt32  load_d:1;
        RBus_UInt32  bt_track_en:1;
        RBus_UInt32  awdct:1;
        RBus_UInt32  awdap:1;
        RBus_UInt32  awdfo:1;
        RBus_UInt32  awdfu:1;
        RBus_UInt32  ct:1;
    };
}hdmi_hdmi_wdcr0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  aldbfv:1;
        RBus_UInt32  aldbfo:1;
        RBus_UInt32  aldbfu:1;
        RBus_UInt32  aldbpn:1;
    };
}hdmi_hdmi_dbcr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:25;
        RBus_UInt32  awdpvsb:7;
    };
}hdmi_hdmi_awdsr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:25;
        RBus_UInt32  vwdpvsb:7;
    };
}hdmi_hdmi_vwdsr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:25;
        RBus_UInt32  icpvsb:7;
    };
}hdmi_hdmi_pamicr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy1800d0b0_31_24:8;
        RBus_UInt32  dummy1800d0b0_23_16:8;
        RBus_UInt32  pt2:8;
        RBus_UInt32  pt1:8;
    };
}hdmi_hdmi_ptrsv1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pvsef:32;
    };
}hdmi_hdmi_pvgcr0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pvs:32;
    };
}hdmi_hdmi_pvsr0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  cbus_ddc_chsel:1;
        RBus_UInt32  hdmi_field:1;
        RBus_UInt32  int_pro_chg_flag:1;
        RBus_UInt32  int_pro_chg_wd_en:1;
        RBus_UInt32  int_pro_chg_int_en:1;
        RBus_UInt32  hdcp_ddc_chsel:2;
        RBus_UInt32  iclk_sel:2;
        RBus_UInt32  csc_r:2;
        RBus_UInt32  hdirq:1;
        RBus_UInt32  csam:1;
        RBus_UInt32  csc:2;
        RBus_UInt32  field_decide_sel:1;
        RBus_UInt32  prdsam:1;
        RBus_UInt32  dsc_r:4;
        RBus_UInt32  eoi:1;
        RBus_UInt32  eot:1;
        RBus_UInt32  se:1;
        RBus_UInt32  rs:1;
        RBus_UInt32  dsc:4;
    };
}hdmi_hdmi_vcr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:30;
        RBus_UInt32  pucnr:1;
        RBus_UInt32  pucsr:1;
    };
}hdmi_hdmi_acrcr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  cts:20;
    };
}hdmi_hdmi_acrsr0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  n:20;
    };
}hdmi_hdmi_acrsr1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  cs:16;
    };
}hdmi_hdmi_acs0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  cs:24;
    };
}hdmi_hdmi_acs1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  pending:1;
        RBus_UInt32  avmute:1;
        RBus_UInt32  fifod:1;
        RBus_UInt32  act:1;
        RBus_UInt32  apll:1;
        RBus_UInt32  afifoo:1;
        RBus_UInt32  afifou:1;
        RBus_UInt32  vc:1;
    };
}hdmi_hdmi_intcr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  lo1:2;
        RBus_UInt32  lo2:2;
        RBus_UInt32  lo3:2;
        RBus_UInt32  lo4:2;
    };
}hdmi_hdmi_alcr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:23;
        RBus_UInt32  i2s_clk_en_dvi:1;
        RBus_UInt32  spdifo1:1;
        RBus_UInt32  spdifo2:1;
        RBus_UInt32  spdifo3:1;
        RBus_UInt32  spdifo4:1;
        RBus_UInt32  i2so1:1;
        RBus_UInt32  i2so2:1;
        RBus_UInt32  i2so3:1;
        RBus_UInt32  i2so4:1;
    };
}hdmi_hdmi_aocr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:26;
        RBus_UInt32  nvlgb:1;
        RBus_UInt32  nalgb:1;
        RBus_UInt32  natgb:1;
        RBus_UInt32  ngb:1;
        RBus_UInt32  pe:1;
        RBus_UInt32  gcp:1;
    };
}hdmi_hdmi_bcsr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:29;
        RBus_UInt32  fsre:1;
        RBus_UInt32  fsif:1;
        RBus_UInt32  fscs:1;
    };
}hdmi_hdmi_asr0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:25;
        RBus_UInt32  fbif:3;
        RBus_UInt32  fbcs:4;
    };
}hdmi_hdmi_asr1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  hvf:3;
        RBus_UInt32  hdmi_vic:8;
    };
}hdmi_hdmi_video_format_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  hdmi_3d_ext_data:4;
        RBus_UInt32  hdmi_3d_metadata_type:3;
        RBus_UInt32  res2:1;
        RBus_UInt32  hdmi_3d_structure:4;
        RBus_UInt32  hdmi_3d_meta_present:1;
        RBus_UInt32  res3:3;
    };
}hdmi_hdmi_3d_format_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  en_ncts_chg_irq:1;
        RBus_UInt32  ncts_chg_irq:1;
        RBus_UInt32  en_ch_status_chg_irq:1;
        RBus_UInt32  ch_status_chg_irq:1;
    };
}hdmi_audio_sample_rate_change_irq_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:29;
        RBus_UInt32  hbr_audio_mode_manual:1;
        RBus_UInt32  hbr_audio_mode_fw:1;
        RBus_UInt32  hbr_audio_mode:1;
    };
}hdmi_high_bit_rate_audio_packet_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy1800d108_31_14:18;
        RBus_UInt32  gain_bypass_en:1;
        RBus_UInt32  afifof:1;
        RBus_UInt32  afifoe:1;
        RBus_UInt32  afifowe_r:1;
        RBus_UInt32  afifore_r:2;
        RBus_UInt32  tst_i2s_sw:1;
        RBus_UInt32  aoem:1;
        RBus_UInt32  aoc:1;
        RBus_UInt32  audio_test_enable:1;
        RBus_UInt32  mgc:1;
        RBus_UInt32  afifowe:1;
        RBus_UInt32  afifore:2;
    };
}hdmi_hdmi_afcr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:31;
        RBus_UInt32  audio_bist_clksel:1;
    };
}hdmi_hdmi_afsr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  agi:3;
        RBus_UInt32  agd:5;
        RBus_UInt32  mg:8;
    };
}hdmi_hdmi_magcr0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:1;
        RBus_UInt32  ldp_time:10;
        RBus_UInt32  ldp_time_mode:1;
        RBus_UInt32  fg_r:8;
        RBus_UInt32  fg_l:8;
        RBus_UInt32  auto_dly_mod:1;
        RBus_UInt32  fg_en:1;
        RBus_UInt32  ffg_l:1;
        RBus_UInt32  ffg_r:1;
    };
}hdmi_hdmi_mag_m_final_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  zcd_ch7_done:1;
        RBus_UInt32  zcd_ch6_done:1;
        RBus_UInt32  zcd_ch5_done:1;
        RBus_UInt32  zcd_ch4_done:1;
        RBus_UInt32  zcd_ch3_done:1;
        RBus_UInt32  zcd_ch2_done:1;
        RBus_UInt32  zcd_ch1_done:1;
        RBus_UInt32  zcd_ch0_done:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  zcd_timeout:7;
        RBus_UInt32  zcd_en:1;
        RBus_UInt32  zcd_sep_8ch:1;
        RBus_UInt32  zcd_sep_st:1;
        RBus_UInt32  dummy1800d118_4_0:5;
    };
}hdmi_zcd_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  xtal_div:8;
        RBus_UInt32  afreq_meas_result:12;
        RBus_UInt32  afreq_meas_range:3;
        RBus_UInt32  popup_afreq_meas_result:1;
        RBus_UInt32  audio_freq_detect:1;
        RBus_UInt32  auto_load_scode:1;
        RBus_UInt32  awd_by_freqchange:1;
        RBus_UInt32  awd_by_noaudio:1;
        RBus_UInt32  irq_by_freqchange:1;
        RBus_UInt32  irq_by_noaudio:1;
        RBus_UInt32  freqchange:1;
        RBus_UInt32  noaudio:1;
    };
}hdmi_audio_freqdet_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  range0_th:12;
        RBus_UInt32  range1_th:12;
    };
}hdmi_range0_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  range2_th:12;
        RBus_UInt32  range3_th:12;
    };
}hdmi_range2_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  range4_th:12;
        RBus_UInt32  range5_th:12;
    };
}hdmi_range4_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pre_set_s1_code3:1;
        RBus_UInt32  pre_set_s_code3:7;
        RBus_UInt32  pre_set_s1_code2:1;
        RBus_UInt32  pre_set_s_code2:7;
        RBus_UInt32  pre_set_s1_code1:1;
        RBus_UInt32  pre_set_s_code1:7;
        RBus_UInt32  pre_set_s1_code0:1;
        RBus_UInt32  pre_set_s_code0:7;
    };
}hdmi_preset_s_code0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  dp_abuf_wr_mod_en:1;
        RBus_UInt32  auto_stop_trk_en:1;
        RBus_UInt32  trk_mod_en:1;
        RBus_UInt32  afsm_mod_en:1;
        RBus_UInt32  res2:4;
        RBus_UInt32  pre_set_sm_code0:1;
        RBus_UInt32  pre_set_sm_code1:1;
        RBus_UInt32  pre_set_sm_code2:1;
        RBus_UInt32  pre_set_sm_code3:1;
        RBus_UInt32  pre_set_sm_code4:1;
        RBus_UInt32  res3:3;
        RBus_UInt32  pre_set_s1_code4:1;
        RBus_UInt32  pre_set_s_code4:7;
    };
}hdmi_preset_s_code1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  prbs7_rxbist_err_cnt:8;
        RBus_UInt32  prbs7_err_cnt:4;
        RBus_UInt32  res2:2;
        RBus_UInt32  prbs7_bit_err:10;
        RBus_UInt32  prbs7_lock:1;
        RBus_UInt32  prbs7_err_cnt_clr:1;
        RBus_UInt32  prbs7_reverse:1;
        RBus_UInt32  prbs7_rxen:1;
    };
}hdmi_prbs7_r_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  prbs7_rxbist_err_cnt:8;
        RBus_UInt32  prbs7_err_cnt:4;
        RBus_UInt32  res2:2;
        RBus_UInt32  prbs7_bit_err:10;
        RBus_UInt32  prbs7_lock:1;
        RBus_UInt32  prbs7_err_cnt_clr:1;
        RBus_UInt32  prbs7_reverse:1;
        RBus_UInt32  prbs7_rxen:1;
    };
}hdmi_prbs7_g_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  prbs7_rxbist_err_cnt:8;
        RBus_UInt32  prbs7_err_cnt:4;
        RBus_UInt32  res2:2;
        RBus_UInt32  prbs7_bit_err:10;
        RBus_UInt32  prbs7_lock:1;
        RBus_UInt32  prbs7_err_cnt_clr:1;
        RBus_UInt32  prbs7_reverse:1;
        RBus_UInt32  prbs7_rxen:1;
    };
}hdmi_prbs7_b_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:1;
        RBus_UInt32  cmp_err_flag:1;
        RBus_UInt32  cmp_err_wd_en:1;
        RBus_UInt32  cmp_err_int_en:1;
        RBus_UInt32  preamble:4;
        RBus_UInt32  res2:6;
        RBus_UInt32  cmp_value:10;
        RBus_UInt32  res3:3;
        RBus_UInt32  dvi_mode_sel:1;
        RBus_UInt32  channel_sel:2;
        RBus_UInt32  lgb_cal_conti:1;
        RBus_UInt32  lgb_cal_en:1;
    };
}hdmi_hdmi_leading_gb_cmp_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmp_err_cnt:16;
        RBus_UInt32  cmp_times:16;
    };
}hdmi_hdmi_leading_gb_cmp_times_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  preamble_cmp_cnt:16;
        RBus_UInt32  preamble_cmp_cnt_by_frame:16;
    };
}hdmi_hdmi_leading_gb_cmp_cnt_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cts_over_flag:1;
        RBus_UInt32  res1:10;
        RBus_UInt32  cts_clip_en:1;
        RBus_UInt32  cts_up_bound:20;
    };
}hdmi_audio_cts_up_bound_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cts_under_flag:1;
        RBus_UInt32  res1:11;
        RBus_UInt32  cts_low_bound:20;
    };
}hdmi_audio_cts_low_bound_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  n_over_flag:1;
        RBus_UInt32  res1:10;
        RBus_UInt32  n_clip_en:1;
        RBus_UInt32  n_up_bound:20;
    };
}hdmi_audio_n_up_bound_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  n_under_flag:1;
        RBus_UInt32  res1:11;
        RBus_UInt32  n_low_bound:20;
    };
}hdmi_audio_n_low_bound_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  pp_mode_output:1;
        RBus_UInt32  res2:3;
        RBus_UInt32  packet_mhl_en:1;
        RBus_UInt32  xor_pixel_sel:3;
        RBus_UInt32  cal_pixel_sel:1;
        RBus_UInt32  res3:3;
        RBus_UInt32  ch_dec_pp_mode_en:1;
    };
}hdmi_mhl_hdmi_mac_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  mhl_3d_fmt:4;
        RBus_UInt32  mhl_vid:2;
        RBus_UInt32  oui:24;
    };
}hdmi_mhl_3d_format_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:27;
        RBus_UInt32  hdcp_2p2_ls1:1;
        RBus_UInt32  hdcp_2p2_ls0:1;
        RBus_UInt32  hdcp_ksvfifo_ls:1;
        RBus_UInt32  hdcp_ls:1;
        RBus_UInt32  audio_ls:1;
    };
}hdmi_light_sleep_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:30;
        RBus_UInt32  hdcp_ds:1;
        RBus_UInt32  audio_ds:1;
    };
}hdmi_deep_sleep_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:30;
        RBus_UInt32  hdcp_sd:1;
        RBus_UInt32  audio_sd:1;
    };
}hdmi_shot_down_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:27;
        RBus_UInt32  hdcp_2p2_rme1:1;
        RBus_UInt32  hdcp_2p2_rme0:1;
        RBus_UInt32  hdcp_ksvfifo_rme:1;
        RBus_UInt32  hdcp_rme:1;
        RBus_UInt32  audio_rme:1;
    };
}hdmi_read_margin_enable_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  hdcp_2p2_rm1:4;
        RBus_UInt32  hdcp_2p2_rm0:4;
        RBus_UInt32  hdcp_ksvfifo_rm:4;
        RBus_UInt32  hdcp_rm:4;
        RBus_UInt32  audio_rm:4;
    };
}hdmi_read_margin_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  hdcp_2p2_bist_en:1;
        RBus_UInt32  hdcp_ksvfifo_bist_en:1;
        RBus_UInt32  hdcp_bist_en:1;
        RBus_UInt32  audio_bist_en:1;
    };
}hdmi_bist_mode_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  hdcp_2p2_bist_done:1;
        RBus_UInt32  hdcp_ksvfifo_bist_done:1;
        RBus_UInt32  hdcp_bist_done:1;
        RBus_UInt32  audio_bist_done:1;
    };
}hdmi_bist_done_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  hdcp_2p2_bist_fail:1;
        RBus_UInt32  hdcp_ksvfifo_bist_fail:1;
        RBus_UInt32  hdcp_bist_fail:1;
        RBus_UInt32  audio_bist_fail:1;
    };
}hdmi_bist_fail_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  hdcp_2p2_drf_mode:1;
        RBus_UInt32  hdcp_ksvfifo_drf_mode:1;
        RBus_UInt32  hdcp_drf_mode:1;
        RBus_UInt32  audio_drf_mode:1;
    };
}hdmi_drf_mode_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  hdcp_2p2_drf_resume:1;
        RBus_UInt32  hdcp_ksvfifo_drf_resume:1;
        RBus_UInt32  hdcp_drf_resume:1;
        RBus_UInt32  audio_drf_resume:1;
    };
}hdmi_drf_resume_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  hdcp_2p2_drf_done:1;
        RBus_UInt32  hdcp_ksvfifo_drf_done:1;
        RBus_UInt32  hdcp_drf_done:1;
        RBus_UInt32  audio_drf_done:1;
    };
}hdmi_drf_done_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  hdcp_2p2_drf_pause:1;
        RBus_UInt32  hdcp_ksvfifo_drf_pause:1;
        RBus_UInt32  hdcp_drf_pause:1;
        RBus_UInt32  audio_drf_pause:1;
    };
}hdmi_drf_pause_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  hdcp_2p2_drf_fail:1;
        RBus_UInt32  hdcp_ksvfifo_drf_fail:1;
        RBus_UInt32  hdcp_drf_fail:1;
        RBus_UInt32  audio_drf_fail:1;
    };
}hdmi_drf_fail_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  hdcp_dvs:4;
        RBus_UInt32  audio_dvs:4;
    };
}hdmi_dvs_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:30;
        RBus_UInt32  hdcp_dvse:1;
        RBus_UInt32  audio_dvse:1;
    };
}hdmi_dvse_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  hdmi_2x_out_sel:2;
        RBus_UInt32  hdmi_test_sel:4;
        RBus_UInt32  hdmi_out_sel:1;
        RBus_UInt32  force_ctsfifo_rstn_hdmi:1;
        RBus_UInt32  en_ctsfifo_vsrst_hdmi:1;
        RBus_UInt32  en_ctsfifo_bypass_hdmi:1;
    };
}hdmi_cts_fifo_ctl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:25;
        RBus_UInt32  sys_clk_div:3;
        RBus_UInt32  res2:2;
        RBus_UInt32  cbus_core_pwdn:1;
        RBus_UInt32  sys_clk_en:1;
    };
}hdmi_cbus_clk_ctl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:32;
    };
}hdmi_hdcp_bist_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  namfe:1;
        RBus_UInt32  rpt:1;
        RBus_UInt32  ivsp:1;
        RBus_UInt32  invvs:1;
        RBus_UInt32  ivspm:1;
        RBus_UInt32  maddf:1;
        RBus_UInt32  dkapde:1;
        RBus_UInt32  hdcp_en:1;
    };
}hdmi_hdcp_cr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  dkap:8;
    };
}hdmi_hdcp_dkap_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  i2c_scl_dly_sel:4;
        RBus_UInt32  i2c_sda_dly_sel:4;
        RBus_UInt32  res2:2;
        RBus_UInt32  tune_up_down:1;
        RBus_UInt32  tune_range:7;
        RBus_UInt32  ddcdbnc:1;
        RBus_UInt32  km_clk_sel_eco:1;
        RBus_UInt32  dbnc_level_sel:1;
        RBus_UInt32  km_clk_sel:1;
        RBus_UInt32  hdcp_vs_sel:1;
        RBus_UInt32  enc_tog:1;
        RBus_UInt32  avmute_dis:1;
        RBus_UInt32  dummy1800d20c_2:1;
        RBus_UInt32  apai_type:1;
        RBus_UInt32  apai:1;
    };
}hdmi_hdcp_pcr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:27;
        RBus_UInt32  wr_aksv_flag:1;
        RBus_UInt32  rd_ri_flag:1;
        RBus_UInt32  rd_bksv_flag:1;
        RBus_UInt32  dummy1800d210_1_0:2;
    };
}hdmi_hdcp_flag1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:27;
        RBus_UInt32  irq_aksv_en:1;
        RBus_UInt32  irq_ri_en:1;
        RBus_UInt32  irq_bksv_en:1;
        RBus_UInt32  dummy1800d214_1_0:2;
    };
}hdmi_hdcp_flag2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:13;
        RBus_UInt32  ksvfifo_status:1;
        RBus_UInt32  dp_ksvfifo_ptr:10;
        RBus_UInt32  ap1:8;
    };
}hdmi_hdcp_ap_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  dp1:8;
    };
}hdmi_hdcp_dp_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy1800d220_31_25:7;
        RBus_UInt32  ks_encoded:1;
        RBus_UInt32  switch_state:12;
        RBus_UInt32  rpt_thr_unauth:1;
        RBus_UInt32  fw_mode_riv:1;
        RBus_UInt32  apply_state:1;
        RBus_UInt32  mspai:1;
        RBus_UInt32  new_auth_device:1;
        RBus_UInt32  verify_id_pass:1;
        RBus_UInt32  verify_id_done:1;
        RBus_UInt32  assemble_id_fail:1;
        RBus_UInt32  downstream_done:1;
        RBus_UInt32  ks_done:1;
        RBus_UInt32  switch_unauth:1;
        RBus_UInt32  hdcp_2p2_en:1;
    };
}hdmi_hdcp_2p2_cr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ks:32;
    };
}hdmi_hdcp_2p2_ks0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ks:32;
    };
}hdmi_hdcp_2p2_ks1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ks:32;
    };
}hdmi_hdcp_2p2_ks2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ks:32;
    };
}hdmi_hdcp_2p2_ks3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lc:32;
    };
}hdmi_hdcp_2p2_lc0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lc:32;
    };
}hdmi_hdcp_2p2_lc1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lc:32;
    };
}hdmi_hdcp_2p2_lc2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lc:32;
    };
}hdmi_hdcp_2p2_lc3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  riv:32;
    };
}hdmi_hdcp_2p2_riv0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  riv:32;
    };
}hdmi_hdcp_2p2_riv1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:15;
        RBus_UInt32  irq_msg_overwrite:1;
        RBus_UInt32  irq_unauth_chg:1;
        RBus_UInt32  irq_state_chg:1;
        RBus_UInt32  irq_rd_msg_done:1;
        RBus_UInt32  irq_wr_msg_done:1;
        RBus_UInt32  state:12;
    };
}hdmi_hdcp_2p2_sr0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:27;
        RBus_UInt32  irq_msg_overwrite_en:1;
        RBus_UInt32  irq_unauth_chg_en:1;
        RBus_UInt32  irq_state_chg_en:1;
        RBus_UInt32  irq_rd_msg_done_en:1;
        RBus_UInt32  irq_wr_msg_done_en:1;
    };
}hdmi_hdcp_2p2_sr1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  ap1:10;
    };
}hdmi_hdcp_msap_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  dp1:8;
    };
}hdmi_hdcp_msdp_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  icmux:1;
        RBus_UInt32  ocs:2;
        RBus_UInt32  dbdcb:1;
        RBus_UInt32  dummy1800d300_3_0:4;
    };
}hdmi_hdmi_cmcr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  dummy1800d304_7_0:8;
    };
}hdmi_hdmi_mcapr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:14;
        RBus_UInt32  s1_code_msb_r:1;
        RBus_UInt32  slc_r:1;
        RBus_UInt32  sc_r:7;
        RBus_UInt32  s1_code_msb:1;
        RBus_UInt32  slc:1;
        RBus_UInt32  sc:7;
    };
}hdmi_hdmi_scapr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  dcaprh:8;
        RBus_UInt32  dcaprl:8;
    };
}hdmi_hdmi_dcapr0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fdint:3;
        RBus_UInt32  etcn:1;
        RBus_UInt32  etfd:1;
        RBus_UInt32  etfbc:1;
        RBus_UInt32  pecs:2;
    };
}hdmi_hdmi_pscr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mfddf:8;
        RBus_UInt32  mfddr:8;
        RBus_UInt32  fddf:8;
        RBus_UInt32  fddr:8;
    };
}hdmi_hdmi_afdd_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  tl2der:2;
        RBus_UInt32  tl2def:2;
        RBus_UInt32  tt:4;
    };
}hdmi_hdmi_ftr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  tfd:5;
        RBus_UInt32  bad:3;
    };
}hdmi_hdmi_fbr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  ich:8;
        RBus_UInt32  icl:8;
    };
}hdmi_hdmi_icpsncr0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  pch:8;
        RBus_UInt32  pcl:8;
    };
}hdmi_hdmi_pcpsncr0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  icth:8;
        RBus_UInt32  ictl:8;
    };
}hdmi_hdmi_ictpsr0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  pcth:8;
        RBus_UInt32  pctl:8;
    };
}hdmi_hdmi_pctpsr0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  icbh:8;
        RBus_UInt32  icbl:8;
    };
}hdmi_hdmi_icbpsr0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  pcbh:8;
        RBus_UInt32  pcbl:8;
    };
}hdmi_hdmi_pcbpsr0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  rm:1;
        RBus_UInt32  nt:12;
    };
}hdmi_hdmi_ntx1024tr0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ftb:8;
    };
}hdmi_hdmi_stbpr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ncper:8;
    };
}hdmi_hdmi_ncper_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  petr:8;
    };
}hdmi_hdmi_petr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cmvtc:1;
        RBus_UInt32  cmvbc:1;
        RBus_UInt32  ssdmou:1;
        RBus_UInt32  tef:1;
        RBus_UInt32  w1c5:1;
        RBus_UInt32  pem:1;
        RBus_UInt32  esdm:1;
        RBus_UInt32  dummy1800d350_0:1;
    };
}hdmi_hdmi_aapnr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  dummy1800d354_7:1;
        RBus_UInt32  dummy1800d354_6:1;
        RBus_UInt32  edm:1;
        RBus_UInt32  pst:1;
        RBus_UInt32  psc:4;
    };
}hdmi_hdmi_apdmcr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fps:4;
        RBus_UInt32  sps:4;
    };
}hdmi_hdmi_aptmcr0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:25;
        RBus_UInt32  plltm:1;
        RBus_UInt32  fpsd:1;
        RBus_UInt32  spsd:1;
        RBus_UInt32  nfpss:4;
    };
}hdmi_hdmi_aptmcr1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ncts_disable_pe_check_en:1;
        RBus_UInt32  ncts_re_enable_off_en:1;
        RBus_UInt32  ncts_disable_pe_check_status:1;
        RBus_UInt32  ncts_disable_pe_check_irq_en:1;
        RBus_UInt32  dummy1800d360_27_20:8;
        RBus_UInt32  ncts_disable_pe_check_cnt:20;
    };
}hdmi_hdmi_npecr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ncts_re_enable_off_start:16;
        RBus_UInt32  ncts_re_enable_off_end:16;
    };
}hdmi_hdmi_nror_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  over_threshold:1;
        RBus_UInt32  under_threshold:1;
        RBus_UInt32  wd_by_tmds_clk:1;
        RBus_UInt32  irq_by_tmds_clk:1;
        RBus_UInt32  nt_up_threshold:12;
        RBus_UInt32  res1:4;
        RBus_UInt32  nt_low_threshold:12;
    };
}hdmi_hdmi_ntx1024tr0_threshold_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dpll_reg:2;
        RBus_UInt32  dpll_m:8;
        RBus_UInt32  res1:1;
        RBus_UInt32  dpll_reser:4;
        RBus_UInt32  dpll_bpn:1;
        RBus_UInt32  dpll_o:2;
        RBus_UInt32  res2:5;
        RBus_UInt32  dpll_n:3;
        RBus_UInt32  dpll_rs:3;
        RBus_UInt32  dpll_ip:3;
    };
}hdmi_hdmi_apllcr0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:9;
        RBus_UInt32  dpll_cp:2;
        RBus_UInt32  dpll_seltst:2;
        RBus_UInt32  dpll_cs:2;
        RBus_UInt32  res2:2;
        RBus_UInt32  res3:1;
        RBus_UInt32  res4:1;
        RBus_UInt32  res5:1;
        RBus_UInt32  res6:1;
        RBus_UInt32  res7:1;
        RBus_UInt32  dpll_reserve:1;
        RBus_UInt32  dpll_bpphs:1;
        RBus_UInt32  dpll_wdo:1;
        RBus_UInt32  dpll_wdrst:1;
        RBus_UInt32  dpll_wdset:1;
        RBus_UInt32  dummy1800d384_4:1;
        RBus_UInt32  dpll_stop:1;
        RBus_UInt32  dpll_freeze:1;
        RBus_UInt32  dpll_vcorstb:1;
        RBus_UInt32  dpll_pwdn:1;
    };
}hdmi_hdmi_apllcr1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:27;
        RBus_UInt32  res2:1;
        RBus_UInt32  res3:1;
        RBus_UInt32  res4:2;
        RBus_UInt32  dpll_rloadm:1;
    };
}hdmi_hdmi_apllcr2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  sum_c_samp:16;
    };
}hdmi_hdmi_apllcr3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  dpll_m_test:8;
        RBus_UInt32  res2:20;
        RBus_UInt32  dpll_m_db:1;
        RBus_UInt32  dpll_m_sel:1;
    };
}hdmi_hdmi_apll_testm_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dpll_reg:2;
        RBus_UInt32  dpll_m:8;
        RBus_UInt32  res1:1;
        RBus_UInt32  dpll_reser:4;
        RBus_UInt32  dpll_bpn:1;
        RBus_UInt32  dpll_o:2;
        RBus_UInt32  res2:5;
        RBus_UInt32  dpll_n:3;
        RBus_UInt32  dpll_rs:3;
        RBus_UInt32  dpll_ip:3;
    };
}hdmi_hdmi_vpllcr0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:9;
        RBus_UInt32  dpll_cp:2;
        RBus_UInt32  dpll_seltst:2;
        RBus_UInt32  dpll_cs:2;
        RBus_UInt32  res2:2;
        RBus_UInt32  res3:1;
        RBus_UInt32  res4:1;
        RBus_UInt32  res5:1;
        RBus_UInt32  res6:1;
        RBus_UInt32  res7:1;
        RBus_UInt32  dpll_reserve:1;
        RBus_UInt32  dpll_bpphs:1;
        RBus_UInt32  dpll_wdo:1;
        RBus_UInt32  dpll_wdrst:1;
        RBus_UInt32  dpll_wdset:1;
        RBus_UInt32  dummy1800d404_4:1;
        RBus_UInt32  dpll_stop:1;
        RBus_UInt32  dpll_freeze:1;
        RBus_UInt32  dpll_vcorstb:1;
        RBus_UInt32  dpll_pwdn:1;
    };
}hdmi_hdmi_vpllcr1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:27;
        RBus_UInt32  res2:1;
        RBus_UInt32  res3:1;
        RBus_UInt32  res4:2;
        RBus_UInt32  dpll_rloadm:1;
    };
}hdmi_hdmi_vpllcr2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  sclkg_pll_in_sel:1;
        RBus_UInt32  sclkg_oclk_sel:2;
        RBus_UInt32  sclkg_dbuf:1;
        RBus_UInt32  dummy1800d410_3_0:4;
    };
}hdmi_mn_sclkg_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  sclkg_pll_div2_en:1;
        RBus_UInt32  sclkg_pll_divs:7;
    };
}hdmi_mn_sclkg_divs_RBUS;

#else //apply LITTLE_ENDIAN

//======HDMI register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ncp:4;
        RBus_UInt32  mt:3;
        RBus_UInt32  tmm:1;
        RBus_UInt32  res1:24;
    };
}hdmi_tmds_msr0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  vmr:7;
        RBus_UInt32  ctc:1;
        RBus_UInt32  ms:2;
        RBus_UInt32  mrs:2;
        RBus_UInt32  tms:1;
        RBus_UInt32  res1:19;
    };
}hdmi_tmds_msr1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  crcc:1;
        RBus_UInt32  crcts:2;
        RBus_UInt32  crc_nonstable:1;
        RBus_UInt32  crc_done:1;
        RBus_UInt32  res1:27;
    };
}hdmi_tmds_crcc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  crcob2_1:8;
        RBus_UInt32  crcob2_2:8;
        RBus_UInt32  crcob2_3:8;
        RBus_UInt32  res1:8;
    };
}hdmi_tmds_crco0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  crcob2_4:8;
        RBus_UInt32  crcob2_5:8;
        RBus_UInt32  crcob2_6:8;
        RBus_UInt32  res1:8;
    };
}hdmi_tmds_crco1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy1800d014_2_0:3;
        RBus_UInt32  yo:1;
        RBus_UInt32  ho:1;
        RBus_UInt32  rcd:1;
        RBus_UInt32  gcd:1;
        RBus_UInt32  bcd:1;
        RBus_UInt32  res1:24;
    };
}hdmi_tmds_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy1800d018_0:1;
        RBus_UInt32  dummy1800d018_1:1;
        RBus_UInt32  dummy1800d018_2:1;
        RBus_UInt32  dummy1800d018_3:1;
        RBus_UInt32  ockie:1;
        RBus_UInt32  ocke:1;
        RBus_UInt32  tbcoe:1;
        RBus_UInt32  tgcoe:1;
        RBus_UInt32  trcoe:1;
        RBus_UInt32  aoe:1;
        RBus_UInt32  ocke_r:1;
        RBus_UInt32  tbcoe_r:1;
        RBus_UInt32  tgcoe_r:1;
        RBus_UInt32  trcoe_r:1;
        RBus_UInt32  res1:18;
    };
}hdmi_tmds_outctl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ebip:1;
        RBus_UInt32  egip:1;
        RBus_UInt32  erip:1;
        RBus_UInt32  ecc:1;
        RBus_UInt32  iccaf:1;
        RBus_UInt32  pnsw:1;
        RBus_UInt32  brcw:1;
        RBus_UInt32  deo:1;
        RBus_UInt32  hs_width_sel:1;
        RBus_UInt32  video_preamble_off_en:1;
        RBus_UInt32  dummy1800d01c_27:18;
        RBus_UInt32  ebip_r:1;
        RBus_UInt32  egip_r:1;
        RBus_UInt32  erip_r:1;
        RBus_UInt32  ecc_r:1;
    };
}hdmi_tmds_pwdctl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hde:1;
        RBus_UInt32  res1:31;
    };
}hdmi_tmds_z0cc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy1800d024_1_0:2;
        RBus_UInt32  auto_dvi2hdmi:1;
        RBus_UInt32  clr_infoframe_dvi:1;
        RBus_UInt32  de_err_pulse_en:1;
        RBus_UInt32  de_inv_disable:1;
        RBus_UInt32  clkv_meas_sel:2;
        RBus_UInt32  no_clk_in:1;
        RBus_UInt32  pll_div2_en:1;
        RBus_UInt32  res1:22;
    };
}hdmi_tmds_cps_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hmtm:2;
        RBus_UInt32  cptest:1;
        RBus_UInt32  dummy1800d028_3_3:1;
        RBus_UInt32  debug_sel:6;
        RBus_UInt32  res1:22;
    };
}hdmi_tmds_udc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  nl:3;
        RBus_UInt32  res1:29;
    };
}hdmi_tmds_errc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy1800d030_6_0:7;
        RBus_UInt32  tmds_bypass:1;
        RBus_UInt32  res1:24;
    };
}hdmi_tmds_out_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  tmds_rout_l:8;
        RBus_UInt32  tmds_rout_h:8;
        RBus_UInt32  res1:16;
    };
}hdmi_tmds_rout_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  tmds_gout_l:8;
        RBus_UInt32  tmds_gout_h:8;
        RBus_UInt32  res1:16;
    };
}hdmi_tmds_gout_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  tmds_bout_l:8;
        RBus_UInt32  tmds_bout_h:8;
        RBus_UInt32  res1:16;
    };
}hdmi_tmds_bout_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dpc_cd:4;
        RBus_UInt32  dpc_pp:4;
        RBus_UInt32  dpc_default_ph:1;
        RBus_UInt32  dpc_pp_valid:1;
        RBus_UInt32  res1:22;
    };
}hdmi_tmds_dpc0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dpc_cd_fw:4;
        RBus_UInt32  dpc_pp_fw:4;
        RBus_UInt32  dpc_default_ph_fw:1;
        RBus_UInt32  dpc_pp_valid_fw:1;
        RBus_UInt32  dpc_auto:1;
        RBus_UInt32  dummy1800d044_15_11:5;
        RBus_UInt32  dpc_cd_chg_int_en:1;
        RBus_UInt32  dpc_cd_chg_wd_en:1;
        RBus_UInt32  dpc_cd_chg_flag:1;
        RBus_UInt32  res1:13;
    };
}hdmi_tmds_dpc1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  phase_clr_sel:1;
        RBus_UInt32  phase_clrcnt_in:3;
        RBus_UInt32  phase_errcnt_in:3;
        RBus_UInt32  dpc_en:1;
        RBus_UInt32  dpc_bypass_dis:1;
        RBus_UInt32  res1:23;
    };
}hdmi_tmds_dpc_set0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  set_empty_noti:4;
        RBus_UInt32  set_full_noti:4;
        RBus_UInt32  res1:24;
    };
}hdmi_tmds_dpc_set1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dpc_fifo_err_flag:1;
        RBus_UInt32  dpc_phase_err_flag:1;
        RBus_UInt32  dpc_phase_ok:1;
        RBus_UInt32  clr_fifo_flag:1;
        RBus_UInt32  clr_phase_flag:1;
        RBus_UInt32  fifo_errcnt_in:3;
        RBus_UInt32  res1:24;
    };
}hdmi_tmds_dpc_set2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  dpc_fifo_under_xflag:1;
        RBus_UInt32  dpc_fifo_over_xflag:1;
        RBus_UInt32  dpc_fifo_under_flag:1;
        RBus_UInt32  dpc_fifo_over_flag:1;
        RBus_UInt32  res2:24;
    };
}hdmi_tmds_dpc_set3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pos_de_lowbd:6;
        RBus_UInt32  dummy1800d058_7_6:2;
        RBus_UInt32  neg_de_lowbd:7;
        RBus_UInt32  dummy1800d058_15_15:1;
        RBus_UInt32  pos_de_err_thrd:4;
        RBus_UInt32  neg_de_err_thrd:4;
        RBus_UInt32  tran_err_thrd:4;
        RBus_UInt32  de_sel:1;
        RBus_UInt32  res1:3;
    };
}hdmi_tmds_det_ctl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  blu_neg_de_err_flag:1;
        RBus_UInt32  grn_neg_de_err_flag:1;
        RBus_UInt32  red_neg_de_err_flag:1;
        RBus_UInt32  blu_pos_de_err_flag:1;
        RBus_UInt32  grn_pos_de_err_flag:1;
        RBus_UInt32  red_pos_de_err_flag:1;
        RBus_UInt32  blu_tran_err_flag:1;
        RBus_UInt32  grn_tran_err_flag:1;
        RBus_UInt32  red_tran_err_flag:1;
        RBus_UInt32  res1:23;
    };
}hdmi_tmds_det_sts_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  en:1;
        RBus_UInt32  mode:1;
        RBus_UInt32  ch_sel:2;
        RBus_UInt32  period:6;
        RBus_UInt32  reset:1;
        RBus_UInt32  irq_en:1;
        RBus_UInt32  res1:4;
        RBus_UInt32  thd:16;
    };
}hdmi_video_bit_err_det_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  bit_err_cnt:16;
        RBus_UInt32  bit_err_cnt_of:1;
        RBus_UInt32  bit_err:1;
        RBus_UInt32  bit_err_thd:1;
        RBus_UInt32  no_dis_reset:1;
        RBus_UInt32  ad_min:5;
        RBus_UInt32  ad_max:5;
        RBus_UInt32  res1:2;
    };
}hdmi_video_bit_err_status_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ch_afifo_irq_en:1;
        RBus_UInt32  flush:1;
        RBus_UInt32  dummy1800d068_3:2;
        RBus_UInt32  udwater_thr:5;
        RBus_UInt32  dummy1800d068_11:3;
        RBus_UInt32  rden_thr:5;
        RBus_UInt32  dummy1800d068_19:3;
        RBus_UInt32  ch_sync_sel:2;
        RBus_UInt32  b_ch_afifo_en:1;
        RBus_UInt32  g_ch_afifo_en:1;
        RBus_UInt32  r_ch_afifo_en:1;
        RBus_UInt32  res1:7;
    };
}hdmi_ch_cr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  b_rw_water_lv:5;
        RBus_UInt32  b_rflush_flag:1;
        RBus_UInt32  b_wovflow_flag:1;
        RBus_UInt32  b_rudflow_flag:1;
        RBus_UInt32  g_rw_water_lv:5;
        RBus_UInt32  g_rflush_flag:1;
        RBus_UInt32  g_wovflow_flag:1;
        RBus_UInt32  g_rudflow_flag:1;
        RBus_UInt32  r_rw_water_lv:5;
        RBus_UInt32  r_rflush_flag:1;
        RBus_UInt32  r_wovflow_flag:1;
        RBus_UInt32  r_rudflow_flag:1;
        RBus_UInt32  b_wrclk_det_timeout_flag:1;
        RBus_UInt32  b_rwclk_det_timeout_flag:1;
        RBus_UInt32  g_wrclk_det_timeout_flag:1;
        RBus_UInt32  g_rwclk_det_timeout_flag:1;
        RBus_UInt32  r_wrclk_det_timeout_flag:1;
        RBus_UInt32  r_rwclk_det_timeout_flag:1;
        RBus_UInt32  rgb_de_align_flag:1;
        RBus_UInt32  res1:1;
    };
}hdmi_ch_sr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mode:1;
        RBus_UInt32  afifouf:1;
        RBus_UInt32  afifoof:1;
        RBus_UInt32  pllsts:1;
        RBus_UInt32  spdiftype:1;
        RBus_UInt32  vic:1;
        RBus_UInt32  avmute:1;
        RBus_UInt32  avmute_bg:1;
        RBus_UInt32  res1:24;
    };
}hdmi_hdmi_sr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pvs_0:1;
        RBus_UInt32  pvs_1:1;
        RBus_UInt32  pvs_2:1;
        RBus_UInt32  pvs_3:1;
        RBus_UInt32  pvs_4:1;
        RBus_UInt32  pis_5:1;
        RBus_UInt32  pis_6:1;
        RBus_UInt32  dummy1800d084_7:1;
        RBus_UInt32  dummy1800d084_8:1;
        RBus_UInt32  nps:1;
        RBus_UInt32  vsps:1;
        RBus_UInt32  gmps:1;
        RBus_UInt32  vsps_v:1;
        RBus_UInt32  gmps_v:1;
        RBus_UInt32  res1:18;
    };
}hdmi_hdmi_gpvs_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  apss:8;
        RBus_UInt32  res1:24;
    };
}hdmi_hdmi_psap_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dpss:8;
        RBus_UInt32  res1:24;
    };
}hdmi_hdmi_psdp_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fcddip:1;
        RBus_UInt32  cabs:1;
        RBus_UInt32  msmode:1;
        RBus_UInt32  mode:1;
        RBus_UInt32  packet_ignore:1;
        RBus_UInt32  dvi_reset_ds_cm_en:1;
        RBus_UInt32  no_vs_det_en:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  nval:8;
        RBus_UInt32  res2:16;
    };
}hdmi_hdmi_scr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pe:1;
        RBus_UInt32  bches2:1;
        RBus_UInt32  bches:1;
        RBus_UInt32  bche:1;
        RBus_UInt32  enrwe:1;
        RBus_UInt32  spcss:1;
        RBus_UInt32  res1:2;
        RBus_UInt32  res2:24;
    };
}hdmi_hdmi_bchcr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  nfpss:1;
        RBus_UInt32  vdpic:1;
        RBus_UInt32  ampic:1;
        RBus_UInt32  ve:1;
        RBus_UInt32  awd:1;
        RBus_UInt32  aomc:1;
        RBus_UInt32  aoc:1;
        RBus_UInt32  avmute_win_en:1;
        RBus_UInt32  avmute_flag:1;
        RBus_UInt32  wd_vclk_en:1;
        RBus_UInt32  wd_ptg_en:1;
        RBus_UInt32  res1:21;
    };
}hdmi_hdmi_avmcr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ct:1;
        RBus_UInt32  awdfu:1;
        RBus_UInt32  awdfo:1;
        RBus_UInt32  awdap:1;
        RBus_UInt32  awdct:1;
        RBus_UInt32  bt_track_en:1;
        RBus_UInt32  load_d:1;
        RBus_UInt32  asmfe:1;
        RBus_UInt32  xv:4;
        RBus_UInt32  vwdact:1;
        RBus_UInt32  ch_st_sel:1;
        RBus_UInt32  awdlf:1;
        RBus_UInt32  awdck:1;
        RBus_UInt32  yv:4;
        RBus_UInt32  vwdafu:1;
        RBus_UInt32  vwdafo:1;
        RBus_UInt32  vwdlf:1;
        RBus_UInt32  vwdap:1;
        RBus_UInt32  vwdch:1;
        RBus_UInt32  awdch:1;
        RBus_UInt32  res1:6;
    };
}hdmi_hdmi_wdcr0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  aldbpn:1;
        RBus_UInt32  aldbfu:1;
        RBus_UInt32  aldbfo:1;
        RBus_UInt32  aldbfv:1;
        RBus_UInt32  res1:28;
    };
}hdmi_hdmi_dbcr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  awdpvsb:7;
        RBus_UInt32  res1:25;
    };
}hdmi_hdmi_awdsr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  vwdpvsb:7;
        RBus_UInt32  res1:25;
    };
}hdmi_hdmi_vwdsr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  icpvsb:7;
        RBus_UInt32  res1:25;
    };
}hdmi_hdmi_pamicr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pt1:8;
        RBus_UInt32  pt2:8;
        RBus_UInt32  dummy1800d0b0_23_16:8;
        RBus_UInt32  dummy1800d0b0_31_24:8;
    };
}hdmi_hdmi_ptrsv1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pvsef:32;
    };
}hdmi_hdmi_pvgcr0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pvs:32;
    };
}hdmi_hdmi_pvsr0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dsc:4;
        RBus_UInt32  rs:1;
        RBus_UInt32  se:1;
        RBus_UInt32  eot:1;
        RBus_UInt32  eoi:1;
        RBus_UInt32  dsc_r:4;
        RBus_UInt32  prdsam:1;
        RBus_UInt32  field_decide_sel:1;
        RBus_UInt32  csc:2;
        RBus_UInt32  csam:1;
        RBus_UInt32  hdirq:1;
        RBus_UInt32  csc_r:2;
        RBus_UInt32  iclk_sel:2;
        RBus_UInt32  hdcp_ddc_chsel:2;
        RBus_UInt32  int_pro_chg_int_en:1;
        RBus_UInt32  int_pro_chg_wd_en:1;
        RBus_UInt32  int_pro_chg_flag:1;
        RBus_UInt32  hdmi_field:1;
        RBus_UInt32  cbus_ddc_chsel:1;
        RBus_UInt32  res1:3;
    };
}hdmi_hdmi_vcr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pucsr:1;
        RBus_UInt32  pucnr:1;
        RBus_UInt32  res1:30;
    };
}hdmi_hdmi_acrcr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cts:20;
        RBus_UInt32  res1:12;
    };
}hdmi_hdmi_acrsr0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  n:20;
        RBus_UInt32  res1:12;
    };
}hdmi_hdmi_acrsr1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cs:16;
        RBus_UInt32  res1:16;
    };
}hdmi_hdmi_acs0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cs:24;
        RBus_UInt32  res1:8;
    };
}hdmi_hdmi_acs1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  vc:1;
        RBus_UInt32  afifou:1;
        RBus_UInt32  afifoo:1;
        RBus_UInt32  apll:1;
        RBus_UInt32  act:1;
        RBus_UInt32  fifod:1;
        RBus_UInt32  avmute:1;
        RBus_UInt32  pending:1;
        RBus_UInt32  res1:24;
    };
}hdmi_hdmi_intcr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lo4:2;
        RBus_UInt32  lo3:2;
        RBus_UInt32  lo2:2;
        RBus_UInt32  lo1:2;
        RBus_UInt32  res1:24;
    };
}hdmi_hdmi_alcr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  i2so4:1;
        RBus_UInt32  i2so3:1;
        RBus_UInt32  i2so2:1;
        RBus_UInt32  i2so1:1;
        RBus_UInt32  spdifo4:1;
        RBus_UInt32  spdifo3:1;
        RBus_UInt32  spdifo2:1;
        RBus_UInt32  spdifo1:1;
        RBus_UInt32  i2s_clk_en_dvi:1;
        RBus_UInt32  res1:23;
    };
}hdmi_hdmi_aocr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  gcp:1;
        RBus_UInt32  pe:1;
        RBus_UInt32  ngb:1;
        RBus_UInt32  natgb:1;
        RBus_UInt32  nalgb:1;
        RBus_UInt32  nvlgb:1;
        RBus_UInt32  res1:26;
    };
}hdmi_hdmi_bcsr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fscs:1;
        RBus_UInt32  fsif:1;
        RBus_UInt32  fsre:1;
        RBus_UInt32  res1:29;
    };
}hdmi_hdmi_asr0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fbcs:4;
        RBus_UInt32  fbif:3;
        RBus_UInt32  res1:25;
    };
}hdmi_hdmi_asr1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hdmi_vic:8;
        RBus_UInt32  hvf:3;
        RBus_UInt32  res1:21;
    };
}hdmi_hdmi_video_format_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  hdmi_3d_meta_present:1;
        RBus_UInt32  hdmi_3d_structure:4;
        RBus_UInt32  res2:1;
        RBus_UInt32  hdmi_3d_metadata_type:3;
        RBus_UInt32  hdmi_3d_ext_data:4;
        RBus_UInt32  res3:16;
    };
}hdmi_hdmi_3d_format_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ch_status_chg_irq:1;
        RBus_UInt32  en_ch_status_chg_irq:1;
        RBus_UInt32  ncts_chg_irq:1;
        RBus_UInt32  en_ncts_chg_irq:1;
        RBus_UInt32  res1:28;
    };
}hdmi_audio_sample_rate_change_irq_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hbr_audio_mode:1;
        RBus_UInt32  hbr_audio_mode_fw:1;
        RBus_UInt32  hbr_audio_mode_manual:1;
        RBus_UInt32  res1:29;
    };
}hdmi_high_bit_rate_audio_packet_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  afifore:2;
        RBus_UInt32  afifowe:1;
        RBus_UInt32  mgc:1;
        RBus_UInt32  audio_test_enable:1;
        RBus_UInt32  aoc:1;
        RBus_UInt32  aoem:1;
        RBus_UInt32  tst_i2s_sw:1;
        RBus_UInt32  afifore_r:2;
        RBus_UInt32  afifowe_r:1;
        RBus_UInt32  afifoe:1;
        RBus_UInt32  afifof:1;
        RBus_UInt32  gain_bypass_en:1;
        RBus_UInt32  dummy1800d108_31_14:18;
    };
}hdmi_hdmi_afcr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  audio_bist_clksel:1;
        RBus_UInt32  res1:31;
    };
}hdmi_hdmi_afsr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mg:8;
        RBus_UInt32  agd:5;
        RBus_UInt32  agi:3;
        RBus_UInt32  res1:16;
    };
}hdmi_hdmi_magcr0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffg_r:1;
        RBus_UInt32  ffg_l:1;
        RBus_UInt32  fg_en:1;
        RBus_UInt32  auto_dly_mod:1;
        RBus_UInt32  fg_l:8;
        RBus_UInt32  fg_r:8;
        RBus_UInt32  ldp_time_mode:1;
        RBus_UInt32  ldp_time:10;
        RBus_UInt32  res1:1;
    };
}hdmi_hdmi_mag_m_final_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy1800d118_4_0:5;
        RBus_UInt32  zcd_sep_st:1;
        RBus_UInt32  zcd_sep_8ch:1;
        RBus_UInt32  zcd_en:1;
        RBus_UInt32  zcd_timeout:7;
        RBus_UInt32  res1:1;
        RBus_UInt32  zcd_ch0_done:1;
        RBus_UInt32  zcd_ch1_done:1;
        RBus_UInt32  zcd_ch2_done:1;
        RBus_UInt32  zcd_ch3_done:1;
        RBus_UInt32  zcd_ch4_done:1;
        RBus_UInt32  zcd_ch5_done:1;
        RBus_UInt32  zcd_ch6_done:1;
        RBus_UInt32  zcd_ch7_done:1;
        RBus_UInt32  res2:8;
    };
}hdmi_zcd_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  noaudio:1;
        RBus_UInt32  freqchange:1;
        RBus_UInt32  irq_by_noaudio:1;
        RBus_UInt32  irq_by_freqchange:1;
        RBus_UInt32  awd_by_noaudio:1;
        RBus_UInt32  awd_by_freqchange:1;
        RBus_UInt32  auto_load_scode:1;
        RBus_UInt32  audio_freq_detect:1;
        RBus_UInt32  popup_afreq_meas_result:1;
        RBus_UInt32  afreq_meas_range:3;
        RBus_UInt32  afreq_meas_result:12;
        RBus_UInt32  xtal_div:8;
    };
}hdmi_audio_freqdet_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  range1_th:12;
        RBus_UInt32  range0_th:12;
        RBus_UInt32  res1:8;
    };
}hdmi_range0_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  range3_th:12;
        RBus_UInt32  range2_th:12;
        RBus_UInt32  res1:8;
    };
}hdmi_range2_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  range5_th:12;
        RBus_UInt32  range4_th:12;
        RBus_UInt32  res1:8;
    };
}hdmi_range4_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pre_set_s_code0:7;
        RBus_UInt32  pre_set_s1_code0:1;
        RBus_UInt32  pre_set_s_code1:7;
        RBus_UInt32  pre_set_s1_code1:1;
        RBus_UInt32  pre_set_s_code2:7;
        RBus_UInt32  pre_set_s1_code2:1;
        RBus_UInt32  pre_set_s_code3:7;
        RBus_UInt32  pre_set_s1_code3:1;
    };
}hdmi_preset_s_code0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pre_set_s_code4:7;
        RBus_UInt32  pre_set_s1_code4:1;
        RBus_UInt32  res1:3;
        RBus_UInt32  pre_set_sm_code4:1;
        RBus_UInt32  pre_set_sm_code3:1;
        RBus_UInt32  pre_set_sm_code2:1;
        RBus_UInt32  pre_set_sm_code1:1;
        RBus_UInt32  pre_set_sm_code0:1;
        RBus_UInt32  res2:4;
        RBus_UInt32  afsm_mod_en:1;
        RBus_UInt32  trk_mod_en:1;
        RBus_UInt32  auto_stop_trk_en:1;
        RBus_UInt32  dp_abuf_wr_mod_en:1;
        RBus_UInt32  res3:8;
    };
}hdmi_preset_s_code1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  prbs7_rxen:1;
        RBus_UInt32  prbs7_reverse:1;
        RBus_UInt32  prbs7_err_cnt_clr:1;
        RBus_UInt32  prbs7_lock:1;
        RBus_UInt32  prbs7_bit_err:10;
        RBus_UInt32  res1:2;
        RBus_UInt32  prbs7_err_cnt:4;
        RBus_UInt32  prbs7_rxbist_err_cnt:8;
        RBus_UInt32  res2:4;
    };
}hdmi_prbs7_r_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  prbs7_rxen:1;
        RBus_UInt32  prbs7_reverse:1;
        RBus_UInt32  prbs7_err_cnt_clr:1;
        RBus_UInt32  prbs7_lock:1;
        RBus_UInt32  prbs7_bit_err:10;
        RBus_UInt32  res1:2;
        RBus_UInt32  prbs7_err_cnt:4;
        RBus_UInt32  prbs7_rxbist_err_cnt:8;
        RBus_UInt32  res2:4;
    };
}hdmi_prbs7_g_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  prbs7_rxen:1;
        RBus_UInt32  prbs7_reverse:1;
        RBus_UInt32  prbs7_err_cnt_clr:1;
        RBus_UInt32  prbs7_lock:1;
        RBus_UInt32  prbs7_bit_err:10;
        RBus_UInt32  res1:2;
        RBus_UInt32  prbs7_err_cnt:4;
        RBus_UInt32  prbs7_rxbist_err_cnt:8;
        RBus_UInt32  res2:4;
    };
}hdmi_prbs7_b_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lgb_cal_en:1;
        RBus_UInt32  lgb_cal_conti:1;
        RBus_UInt32  channel_sel:2;
        RBus_UInt32  dvi_mode_sel:1;
        RBus_UInt32  res1:3;
        RBus_UInt32  cmp_value:10;
        RBus_UInt32  res2:6;
        RBus_UInt32  preamble:4;
        RBus_UInt32  cmp_err_int_en:1;
        RBus_UInt32  cmp_err_wd_en:1;
        RBus_UInt32  cmp_err_flag:1;
        RBus_UInt32  res3:1;
    };
}hdmi_hdmi_leading_gb_cmp_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmp_times:16;
        RBus_UInt32  cmp_err_cnt:16;
    };
}hdmi_hdmi_leading_gb_cmp_times_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  preamble_cmp_cnt_by_frame:16;
        RBus_UInt32  preamble_cmp_cnt:16;
    };
}hdmi_hdmi_leading_gb_cmp_cnt_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cts_up_bound:20;
        RBus_UInt32  cts_clip_en:1;
        RBus_UInt32  res1:10;
        RBus_UInt32  cts_over_flag:1;
    };
}hdmi_audio_cts_up_bound_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cts_low_bound:20;
        RBus_UInt32  res1:11;
        RBus_UInt32  cts_under_flag:1;
    };
}hdmi_audio_cts_low_bound_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  n_up_bound:20;
        RBus_UInt32  n_clip_en:1;
        RBus_UInt32  res1:10;
        RBus_UInt32  n_over_flag:1;
    };
}hdmi_audio_n_up_bound_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  n_low_bound:20;
        RBus_UInt32  res1:11;
        RBus_UInt32  n_under_flag:1;
    };
}hdmi_audio_n_low_bound_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ch_dec_pp_mode_en:1;
        RBus_UInt32  res1:3;
        RBus_UInt32  cal_pixel_sel:1;
        RBus_UInt32  xor_pixel_sel:3;
        RBus_UInt32  packet_mhl_en:1;
        RBus_UInt32  res2:3;
        RBus_UInt32  pp_mode_output:1;
        RBus_UInt32  res3:19;
    };
}hdmi_mhl_hdmi_mac_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  oui:24;
        RBus_UInt32  mhl_vid:2;
        RBus_UInt32  mhl_3d_fmt:4;
        RBus_UInt32  res1:2;
    };
}hdmi_mhl_3d_format_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  audio_ls:1;
        RBus_UInt32  hdcp_ls:1;
        RBus_UInt32  hdcp_ksvfifo_ls:1;
        RBus_UInt32  hdcp_2p2_ls0:1;
        RBus_UInt32  hdcp_2p2_ls1:1;
        RBus_UInt32  res1:27;
    };
}hdmi_light_sleep_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  audio_ds:1;
        RBus_UInt32  hdcp_ds:1;
        RBus_UInt32  res1:30;
    };
}hdmi_deep_sleep_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  audio_sd:1;
        RBus_UInt32  hdcp_sd:1;
        RBus_UInt32  res1:30;
    };
}hdmi_shot_down_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  audio_rme:1;
        RBus_UInt32  hdcp_rme:1;
        RBus_UInt32  hdcp_ksvfifo_rme:1;
        RBus_UInt32  hdcp_2p2_rme0:1;
        RBus_UInt32  hdcp_2p2_rme1:1;
        RBus_UInt32  res1:27;
    };
}hdmi_read_margin_enable_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  audio_rm:4;
        RBus_UInt32  hdcp_rm:4;
        RBus_UInt32  hdcp_ksvfifo_rm:4;
        RBus_UInt32  hdcp_2p2_rm0:4;
        RBus_UInt32  hdcp_2p2_rm1:4;
        RBus_UInt32  res1:12;
    };
}hdmi_read_margin_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  audio_bist_en:1;
        RBus_UInt32  hdcp_bist_en:1;
        RBus_UInt32  hdcp_ksvfifo_bist_en:1;
        RBus_UInt32  hdcp_2p2_bist_en:1;
        RBus_UInt32  res1:28;
    };
}hdmi_bist_mode_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  audio_bist_done:1;
        RBus_UInt32  hdcp_bist_done:1;
        RBus_UInt32  hdcp_ksvfifo_bist_done:1;
        RBus_UInt32  hdcp_2p2_bist_done:1;
        RBus_UInt32  res1:28;
    };
}hdmi_bist_done_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  audio_bist_fail:1;
        RBus_UInt32  hdcp_bist_fail:1;
        RBus_UInt32  hdcp_ksvfifo_bist_fail:1;
        RBus_UInt32  hdcp_2p2_bist_fail:1;
        RBus_UInt32  res1:28;
    };
}hdmi_bist_fail_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  audio_drf_mode:1;
        RBus_UInt32  hdcp_drf_mode:1;
        RBus_UInt32  hdcp_ksvfifo_drf_mode:1;
        RBus_UInt32  hdcp_2p2_drf_mode:1;
        RBus_UInt32  res1:28;
    };
}hdmi_drf_mode_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  audio_drf_resume:1;
        RBus_UInt32  hdcp_drf_resume:1;
        RBus_UInt32  hdcp_ksvfifo_drf_resume:1;
        RBus_UInt32  hdcp_2p2_drf_resume:1;
        RBus_UInt32  res1:28;
    };
}hdmi_drf_resume_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  audio_drf_done:1;
        RBus_UInt32  hdcp_drf_done:1;
        RBus_UInt32  hdcp_ksvfifo_drf_done:1;
        RBus_UInt32  hdcp_2p2_drf_done:1;
        RBus_UInt32  res1:28;
    };
}hdmi_drf_done_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  audio_drf_pause:1;
        RBus_UInt32  hdcp_drf_pause:1;
        RBus_UInt32  hdcp_ksvfifo_drf_pause:1;
        RBus_UInt32  hdcp_2p2_drf_pause:1;
        RBus_UInt32  res1:28;
    };
}hdmi_drf_pause_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  audio_drf_fail:1;
        RBus_UInt32  hdcp_drf_fail:1;
        RBus_UInt32  hdcp_ksvfifo_drf_fail:1;
        RBus_UInt32  hdcp_2p2_drf_fail:1;
        RBus_UInt32  res1:28;
    };
}hdmi_drf_fail_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  audio_dvs:4;
        RBus_UInt32  hdcp_dvs:4;
        RBus_UInt32  res1:24;
    };
}hdmi_dvs_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  audio_dvse:1;
        RBus_UInt32  hdcp_dvse:1;
        RBus_UInt32  res1:30;
    };
}hdmi_dvse_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  en_ctsfifo_bypass_hdmi:1;
        RBus_UInt32  en_ctsfifo_vsrst_hdmi:1;
        RBus_UInt32  force_ctsfifo_rstn_hdmi:1;
        RBus_UInt32  hdmi_out_sel:1;
        RBus_UInt32  hdmi_test_sel:4;
        RBus_UInt32  hdmi_2x_out_sel:2;
        RBus_UInt32  res1:22;
    };
}hdmi_cts_fifo_ctl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sys_clk_en:1;
        RBus_UInt32  cbus_core_pwdn:1;
        RBus_UInt32  res1:2;
        RBus_UInt32  sys_clk_div:3;
        RBus_UInt32  res2:25;
    };
}hdmi_cbus_clk_ctl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:32;
    };
}hdmi_hdcp_bist_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hdcp_en:1;
        RBus_UInt32  dkapde:1;
        RBus_UInt32  maddf:1;
        RBus_UInt32  ivspm:1;
        RBus_UInt32  invvs:1;
        RBus_UInt32  ivsp:1;
        RBus_UInt32  rpt:1;
        RBus_UInt32  namfe:1;
        RBus_UInt32  res1:24;
    };
}hdmi_hdcp_cr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dkap:8;
        RBus_UInt32  res1:24;
    };
}hdmi_hdcp_dkap_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  apai:1;
        RBus_UInt32  apai_type:1;
        RBus_UInt32  dummy1800d20c_2:1;
        RBus_UInt32  avmute_dis:1;
        RBus_UInt32  enc_tog:1;
        RBus_UInt32  hdcp_vs_sel:1;
        RBus_UInt32  km_clk_sel:1;
        RBus_UInt32  dbnc_level_sel:1;
        RBus_UInt32  km_clk_sel_eco:1;
        RBus_UInt32  ddcdbnc:1;
        RBus_UInt32  tune_range:7;
        RBus_UInt32  tune_up_down:1;
        RBus_UInt32  res1:2;
        RBus_UInt32  i2c_sda_dly_sel:4;
        RBus_UInt32  i2c_scl_dly_sel:4;
        RBus_UInt32  res2:4;
    };
}hdmi_hdcp_pcr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy1800d210_1_0:2;
        RBus_UInt32  rd_bksv_flag:1;
        RBus_UInt32  rd_ri_flag:1;
        RBus_UInt32  wr_aksv_flag:1;
        RBus_UInt32  res1:27;
    };
}hdmi_hdcp_flag1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy1800d214_1_0:2;
        RBus_UInt32  irq_bksv_en:1;
        RBus_UInt32  irq_ri_en:1;
        RBus_UInt32  irq_aksv_en:1;
        RBus_UInt32  res1:27;
    };
}hdmi_hdcp_flag2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ap1:8;
        RBus_UInt32  dp_ksvfifo_ptr:10;
        RBus_UInt32  ksvfifo_status:1;
        RBus_UInt32  res1:13;
    };
}hdmi_hdcp_ap_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dp1:8;
        RBus_UInt32  res1:24;
    };
}hdmi_hdcp_dp_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hdcp_2p2_en:1;
        RBus_UInt32  switch_unauth:1;
        RBus_UInt32  ks_done:1;
        RBus_UInt32  downstream_done:1;
        RBus_UInt32  assemble_id_fail:1;
        RBus_UInt32  verify_id_done:1;
        RBus_UInt32  verify_id_pass:1;
        RBus_UInt32  new_auth_device:1;
        RBus_UInt32  mspai:1;
        RBus_UInt32  apply_state:1;
        RBus_UInt32  fw_mode_riv:1;
        RBus_UInt32  rpt_thr_unauth:1;
        RBus_UInt32  switch_state:12;
        RBus_UInt32  ks_encoded:1;
        RBus_UInt32  dummy1800d220_31:7;
    };
}hdmi_hdcp_2p2_cr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ks:32;
    };
}hdmi_hdcp_2p2_ks0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ks:32;
    };
}hdmi_hdcp_2p2_ks1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ks:32;
    };
}hdmi_hdcp_2p2_ks2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ks:32;
    };
}hdmi_hdcp_2p2_ks3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lc:32;
    };
}hdmi_hdcp_2p2_lc0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lc:32;
    };
}hdmi_hdcp_2p2_lc1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lc:32;
    };
}hdmi_hdcp_2p2_lc2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lc:32;
    };
}hdmi_hdcp_2p2_lc3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  riv:32;
    };
}hdmi_hdcp_2p2_riv0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  riv:32;
    };
}hdmi_hdcp_2p2_riv1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  state:12;
        RBus_UInt32  irq_wr_msg_done:1;
        RBus_UInt32  irq_rd_msg_done:1;
        RBus_UInt32  irq_state_chg:1;
        RBus_UInt32  irq_unauth_chg:1;
        RBus_UInt32  irq_msg_overwrite:1;
        RBus_UInt32  res1:15;
    };
}hdmi_hdcp_2p2_sr0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  irq_wr_msg_done_en:1;
        RBus_UInt32  irq_rd_msg_done_en:1;
        RBus_UInt32  irq_state_chg_en:1;
        RBus_UInt32  irq_unauth_chg_en:1;
        RBus_UInt32  irq_msg_overwrite_en:1;
        RBus_UInt32  res1:27;
    };
}hdmi_hdcp_2p2_sr1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ap1:10;
        RBus_UInt32  res1:22;
    };
}hdmi_hdcp_msap_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dp1:8;
        RBus_UInt32  res1:24;
    };
}hdmi_hdcp_msdp_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy1800d300_3_0:4;
        RBus_UInt32  dbdcb:1;
        RBus_UInt32  ocs:2;
        RBus_UInt32  icmux:1;
        RBus_UInt32  res1:24;
    };
}hdmi_hdmi_cmcr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy1800d304_7_0:8;
        RBus_UInt32  res1:24;
    };
}hdmi_hdmi_mcapr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sc:7;
        RBus_UInt32  slc:1;
        RBus_UInt32  s1_code_msb:1;
        RBus_UInt32  sc_r:7;
        RBus_UInt32  slc_r:1;
        RBus_UInt32  s1_code_msb_r:1;
        RBus_UInt32  res1:14;
    };
}hdmi_hdmi_scapr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dcaprl:8;
        RBus_UInt32  dcaprh:8;
        RBus_UInt32  res1:16;
    };
}hdmi_hdmi_dcapr0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pecs:2;
        RBus_UInt32  etfbc:1;
        RBus_UInt32  etfd:1;
        RBus_UInt32  etcn:1;
        RBus_UInt32  fdint:3;
        RBus_UInt32  res1:24;
    };
}hdmi_hdmi_pscr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fddr:8;
        RBus_UInt32  fddf:8;
        RBus_UInt32  mfddr:8;
        RBus_UInt32  mfddf:8;
    };
}hdmi_hdmi_afdd_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  tt:4;
        RBus_UInt32  tl2def:2;
        RBus_UInt32  tl2der:2;
        RBus_UInt32  res1:24;
    };
}hdmi_hdmi_ftr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  bad:3;
        RBus_UInt32  tfd:5;
        RBus_UInt32  res1:24;
    };
}hdmi_hdmi_fbr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  icl:8;
        RBus_UInt32  ich:8;
        RBus_UInt32  res1:16;
    };
}hdmi_hdmi_icpsncr0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pcl:8;
        RBus_UInt32  pch:8;
        RBus_UInt32  res1:16;
    };
}hdmi_hdmi_pcpsncr0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ictl:8;
        RBus_UInt32  icth:8;
        RBus_UInt32  res1:16;
    };
}hdmi_hdmi_ictpsr0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pctl:8;
        RBus_UInt32  pcth:8;
        RBus_UInt32  res1:16;
    };
}hdmi_hdmi_pctpsr0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  icbl:8;
        RBus_UInt32  icbh:8;
        RBus_UInt32  res1:16;
    };
}hdmi_hdmi_icbpsr0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pcbl:8;
        RBus_UInt32  pcbh:8;
        RBus_UInt32  res1:16;
    };
}hdmi_hdmi_pcbpsr0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  nt:12;
        RBus_UInt32  rm:1;
        RBus_UInt32  res1:19;
    };
}hdmi_hdmi_ntx1024tr0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ftb:8;
        RBus_UInt32  res1:24;
    };
}hdmi_hdmi_stbpr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ncper:8;
        RBus_UInt32  res1:24;
    };
}hdmi_hdmi_ncper_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  petr:8;
        RBus_UInt32  res1:24;
    };
}hdmi_hdmi_petr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy1800d350_0:1;
        RBus_UInt32  esdm:1;
        RBus_UInt32  pem:1;
        RBus_UInt32  w1c5:1;
        RBus_UInt32  tef:1;
        RBus_UInt32  ssdmou:1;
        RBus_UInt32  cmvbc:1;
        RBus_UInt32  cmvtc:1;
        RBus_UInt32  res1:24;
    };
}hdmi_hdmi_aapnr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  psc:4;
        RBus_UInt32  pst:1;
        RBus_UInt32  edm:1;
        RBus_UInt32  dummy1800d354_6_6:1;
        RBus_UInt32  dummy1800d354_7_7:1;
        RBus_UInt32  res1:24;
    };
}hdmi_hdmi_apdmcr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sps:4;
        RBus_UInt32  fps:4;
        RBus_UInt32  res1:24;
    };
}hdmi_hdmi_aptmcr0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  nfpss:4;
        RBus_UInt32  spsd:1;
        RBus_UInt32  fpsd:1;
        RBus_UInt32  plltm:1;
        RBus_UInt32  res1:25;
    };
}hdmi_hdmi_aptmcr1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ncts_disable_pe_check_cnt:20;
        RBus_UInt32  dummy1800d360_27_20:8;
        RBus_UInt32  ncts_disable_pe_check_irq_en:1;
        RBus_UInt32  ncts_disable_pe_check_status:1;
        RBus_UInt32  ncts_re_enable_off_en:1;
        RBus_UInt32  ncts_disable_pe_check_en:1;
    };
}hdmi_hdmi_npecr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ncts_re_enable_off_end:16;
        RBus_UInt32  ncts_re_enable_off_start:16;
    };
}hdmi_hdmi_nror_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  nt_low_threshold:12;
        RBus_UInt32  res1:4;
        RBus_UInt32  nt_up_threshold:12;
        RBus_UInt32  irq_by_tmds_clk:1;
        RBus_UInt32  wd_by_tmds_clk:1;
        RBus_UInt32  under_threshold:1;
        RBus_UInt32  over_threshold:1;
    };
}hdmi_hdmi_ntx1024tr0_threshold_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dpll_ip:3;
        RBus_UInt32  dpll_rs:3;
        RBus_UInt32  dpll_n:3;
        RBus_UInt32  res1:5;
        RBus_UInt32  dpll_o:2;
        RBus_UInt32  dpll_bpn:1;
        RBus_UInt32  dpll_reser:4;
        RBus_UInt32  res2:1;
        RBus_UInt32  dpll_m:8;
        RBus_UInt32  dpll_reg:2;
    };
}hdmi_hdmi_apllcr0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dpll_pwdn:1;
        RBus_UInt32  dpll_vcorstb:1;
        RBus_UInt32  dpll_freeze:1;
        RBus_UInt32  dpll_stop:1;
        RBus_UInt32  dummy1800d384_4:1;
        RBus_UInt32  dpll_wdset:1;
        RBus_UInt32  dpll_wdrst:1;
        RBus_UInt32  dpll_wdo:1;
        RBus_UInt32  dpll_bpphs:1;
        RBus_UInt32  dpll_reserve:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  res3:1;
        RBus_UInt32  res4:1;
        RBus_UInt32  res5:1;
        RBus_UInt32  res6:2;
        RBus_UInt32  dpll_cs:2;
        RBus_UInt32  dpll_seltst:2;
        RBus_UInt32  dpll_cp:2;
        RBus_UInt32  res7:9;
    };
}hdmi_hdmi_apllcr1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dpll_rloadm:1;
        RBus_UInt32  res1:2;
        RBus_UInt32  res2:1;
        RBus_UInt32  res3:1;
        RBus_UInt32  res4:27;
    };
}hdmi_hdmi_apllcr2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sum_c_samp:16;
        RBus_UInt32  res1:16;
    };
}hdmi_hdmi_apllcr3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dpll_m_sel:1;
        RBus_UInt32  dpll_m_db:1;
        RBus_UInt32  res1:20;
        RBus_UInt32  dpll_m_test:8;
        RBus_UInt32  res2:2;
    };
}hdmi_hdmi_apll_testm_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dpll_ip:3;
        RBus_UInt32  dpll_rs:3;
        RBus_UInt32  dpll_n:3;
        RBus_UInt32  res1:5;
        RBus_UInt32  dpll_o:2;
        RBus_UInt32  dpll_bpn:1;
        RBus_UInt32  dpll_reser:4;
        RBus_UInt32  res2:1;
        RBus_UInt32  dpll_m:8;
        RBus_UInt32  dpll_reg:2;
    };
}hdmi_hdmi_vpllcr0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dpll_pwdn:1;
        RBus_UInt32  dpll_vcorstb:1;
        RBus_UInt32  dpll_freeze:1;
        RBus_UInt32  dpll_stop:1;
        RBus_UInt32  dummy1800d404_4:1;
        RBus_UInt32  dpll_wdset:1;
        RBus_UInt32  dpll_wdrst:1;
        RBus_UInt32  dpll_wdo:1;
        RBus_UInt32  dpll_bpphs:1;
        RBus_UInt32  dpll_reserve:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  res3:1;
        RBus_UInt32  res4:1;
        RBus_UInt32  res5:1;
        RBus_UInt32  res6:2;
        RBus_UInt32  dpll_cs:2;
        RBus_UInt32  dpll_seltst:2;
        RBus_UInt32  dpll_cp:2;
        RBus_UInt32  res7:9;
    };
}hdmi_hdmi_vpllcr1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dpll_rloadm:1;
        RBus_UInt32  res1:2;
        RBus_UInt32  res2:1;
        RBus_UInt32  res3:1;
        RBus_UInt32  res4:27;
    };
}hdmi_hdmi_vpllcr2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy1800d410_3_0:4;
        RBus_UInt32  sclkg_dbuf:1;
        RBus_UInt32  sclkg_oclk_sel:2;
        RBus_UInt32  sclkg_pll_in_sel:1;
        RBus_UInt32  res1:24;
    };
}hdmi_mn_sclkg_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sclkg_pll_divs:7;
        RBus_UInt32  sclkg_pll_div2_en:1;
        RBus_UInt32  res1:24;
    };
}hdmi_mn_sclkg_divs_RBUS;




#endif

//  HDMIPHY Register Address



#define  HDMIPHY_REG_CK_1_4_VADDR                           	(0xb800db00)
#define  HDMIPHY_REG_CK_5_8_VADDR                           	(0xb800db04)
#define  HDMIPHY_REG_CK_9_12_VADDR                          	(0xb800db08)
#define  HDMIPHY_REG_CK_RESULT_VADDR                        	(0xb800db0c)
#define  HDMIPHY_REG_R_1_4_VADDR                            	(0xb800db10)
#define  HDMIPHY_REG_R_5_8_VADDR                            	(0xb800db14)
#define  HDMIPHY_REG_R_9_12_VADDR                           	(0xb800db18)
#define  HDMIPHY_REG_R_RESULT_VADDR                         	(0xb800db1c)
#define  HDMIPHY_REG_G_1_4_VADDR                            	(0xb800db20)
#define  HDMIPHY_REG_G_5_8_VADDR                            	(0xb800db24)
#define  HDMIPHY_REG_G_9_12_VADDR                           	(0xb800db28)
#define  HDMIPHY_REG_G_RESULT_VADDR                         	(0xb800db2c)
#define  HDMIPHY_REG_B_1_4_VADDR                            	(0xb800db30)
#define  HDMIPHY_REG_B_5_8_VADDR                            	(0xb800db34)
#define  HDMIPHY_REG_B_9_12_VADDR                           	(0xb800db38)
#define  HDMIPHY_REG_B_RESULT_VADDR                         	(0xb800db3c)
#define  HDMIPHY_REG_BANDGAP_Z0_VADDR                       	(0xb800db40)
#define  HDMIPHY_REG_PHY_CTL_VADDR                          	(0xb800db44)
#define  HDMIPHY_REG_RGB_KOFF_SEL_VADDR                     	(0xb800db48)
#define  HDMIPHY_REG_BANDGAP_Z0_CTRL_VADDR                  	(0xb800db4c)
#define  HDMIPHY_REG_BANDGAP_Z0_CTRL_2_VADDR                	(0xb800db50)
#define  HDMIPHY_REG_B_13_VADDR                             	(0xb800db54)
#define  HDMIPHY_REG_B_14_15_VADDR                          	(0xb800db58)
#define  HDMIPHY_REG_G_13_VADDR                             	(0xb800db5c)
#define  HDMIPHY_REG_G_14_15_VADDR                          	(0xb800db60)
#define  HDMIPHY_REG_R_13_VADDR                             	(0xb800db64)
#define  HDMIPHY_REG_R_14_15_VADDR                          	(0xb800db68)
#define  HDMIPHY_DPLL_CTRL_VADDR                            	(0xb800db6c)
#define  HDMIPHY_TEST_CTRL_VADDR                            	(0xb800db70)
#define  HDMIPHY_ANALOG_CDR_CTRL1_VADDR                     	(0xb800db74)
#define  HDMIPHY_ANALOG_CDR_CTRL2_VADDR                     	(0xb800db78)
#define  HDMIPHY_ANALOG_CDR_CTRL3_VADDR                     	(0xb800db7c)
#define  HDMIPHY_ANALOG_CDR_CTRL4_VADDR                     	(0xb800db80)
#define  HDMIPHY_ANALOG_CDR_CTRL5_VADDR                     	(0xb800db84)
#define  HDMIPHY_ANALOG_CDR_STATUS_VADDR                    	(0xb800db88)
#define  HDMIPHY_REG_CK_MD_VADDR                            	(0xb800dbdc)
#define  HDMIPHY_REG_MHL_CTRL_VADDR                         	(0xb800dbe0)
#define  HDMIPHY_REG_DIG_PHY_CTRL_NEW_1_VADDR               	(0xb800dbe4)
#define  HDMIPHY_REG_DIG_PHY_CTRL_NEW_2_VADDR               	(0xb800dbe8)
#define  HDMIPHY_REG_DIG_PHY_CTRL_NEW_3_VADDR               	(0xb800dbec)
#define  HDMIPHY_TIMER_VADDR                                	(0xb800dbf0)
#define  HDMIPHY_R_CDR_ER_COUNT_VADDR                       	(0xb800dbf4)
#define  HDMIPHY_G_CDR_ER_COUNT_VADDR                       	(0xb800dbf8)
#define  HDMIPHY_B_CDR_ER_COUNT_VADDR                       	(0xb800dbfc)



#ifndef LITTLE_ENDIAN //apply BIG_ENDIAN

//======HDMIPHY register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  reg_ck_4:8;
        RBus_UInt32  reg_ck_3:8;
        RBus_UInt32  reg_ck_2:8;
        RBus_UInt32  reg_ck_1:8;
    };
}hdmiphy_reg_ck_1_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  reg_ck_8:8;
        RBus_UInt32  reg_ck_7:8;
        RBus_UInt32  reg_ck_6:8;
        RBus_UInt32  reg_ck_5:8;
    };
}hdmiphy_reg_ck_5_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  reg_ck_12:8;
        RBus_UInt32  reg_ck_11:8;
        RBus_UInt32  reg_ck_10:8;
        RBus_UInt32  reg_ck_9:8;
    };
}hdmiphy_reg_ck_9_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ck_md_count:13;
        RBus_UInt32  dummy1800db0c_18:1;
        RBus_UInt32  dummy1800db0c_17:1;
        RBus_UInt32  ck_md_unstable_count:5;
        RBus_UInt32  dummy1800db0c_11_9:3;
        RBus_UInt32  ck_rate:4;
        RBus_UInt32  dummy1800db0c_4_3:2;
        RBus_UInt32  ck_md_unstable_flag:1;
        RBus_UInt32  ck_wdo:1;
        RBus_UInt32  ck_md_ok:1;
    };
}hdmiphy_reg_ck_result_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  reg_r_4:8;
        RBus_UInt32  reg_r_3:8;
        RBus_UInt32  reg_r_2:8;
        RBus_UInt32  reg_r_1:8;
    };
}hdmiphy_reg_r_1_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  reg_r_8:8;
        RBus_UInt32  reg_r_7:8;
        RBus_UInt32  reg_r_6:8;
        RBus_UInt32  reg_r_5:8;
    };
}hdmiphy_reg_r_5_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  reg_r_12:8;
        RBus_UInt32  reg_r_11:8;
        RBus_UInt32  reg_r_10:8;
        RBus_UInt32  reg_r_9:8;
    };
}hdmiphy_reg_r_9_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  r_koffok:1;
        RBus_UInt32  r_koff_bound:1;
        RBus_UInt32  r_msb:8;
        RBus_UInt32  r_lsb:8;
        RBus_UInt32  r_koff_tst:6;
        RBus_UInt32  res2:5;
    };
}hdmiphy_reg_r_result_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  reg_g_4:8;
        RBus_UInt32  reg_g_3:8;
        RBus_UInt32  reg_g_2:8;
        RBus_UInt32  reg_g_1:8;
    };
}hdmiphy_reg_g_1_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  reg_g_8:8;
        RBus_UInt32  reg_g_7:8;
        RBus_UInt32  reg_g_6:8;
        RBus_UInt32  reg_g_5:8;
    };
}hdmiphy_reg_g_5_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  reg_g_12:8;
        RBus_UInt32  reg_g_11:8;
        RBus_UInt32  reg_g_10:8;
        RBus_UInt32  reg_g_9:8;
    };
}hdmiphy_reg_g_9_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  g_koffok:1;
        RBus_UInt32  g_koff_bound:1;
        RBus_UInt32  g_msb:8;
        RBus_UInt32  g_lsb:8;
        RBus_UInt32  g_koff_tst:6;
        RBus_UInt32  res2:5;
    };
}hdmiphy_reg_g_result_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  reg_b_4:8;
        RBus_UInt32  reg_b_3:8;
        RBus_UInt32  reg_b_2:8;
        RBus_UInt32  reg_b_1:8;
    };
}hdmiphy_reg_b_1_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  reg_b_8:8;
        RBus_UInt32  reg_b_7:8;
        RBus_UInt32  reg_b_6:8;
        RBus_UInt32  reg_b_5:8;
    };
}hdmiphy_reg_b_5_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  reg_b_12:8;
        RBus_UInt32  reg_b_11:8;
        RBus_UInt32  reg_b_10:8;
        RBus_UInt32  reg_b_9:8;
    };
}hdmiphy_reg_b_9_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  b_koffok:1;
        RBus_UInt32  b_koff_bound:1;
        RBus_UInt32  b_msb:8;
        RBus_UInt32  b_lsb:8;
        RBus_UInt32  b_koff_tst:6;
        RBus_UInt32  res2:5;
    };
}hdmiphy_reg_b_result_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  reg_bg_envbgup:1;
        RBus_UInt32  reg_bg_rbgloop2:3;
        RBus_UInt32  reg_bg_rbg2:2;
        RBus_UInt32  bgpow:1;
        RBus_UInt32  sbg:2;
        RBus_UInt32  z0pow:1;
        RBus_UInt32  reg_bg_rbg:3;
        RBus_UInt32  entst_z0:1;
        RBus_UInt32  z0tune:1;
        RBus_UInt32  spad:1;
        RBus_UInt32  stst:4;
        RBus_UInt32  hspow:1;
        RBus_UInt32  z0_res:5;
        RBus_UInt32  z0tst:4;
        RBus_UInt32  z0_ok:1;
        RBus_UInt32  z0_bound:1;
    };
}hdmiphy_reg_bandgap_z0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy1800db44_31:1;
        RBus_UInt32  dfe_rstn_n:1;
        RBus_UInt32  b_dig_cdr_rstb:1;
        RBus_UInt32  b_dig_rstb:1;
        RBus_UInt32  g_dig_cdr_rstb:1;
        RBus_UInt32  g_dig_rstb:1;
        RBus_UInt32  r_dig_cdr_rstb:1;
        RBus_UInt32  r_dig_rstb:1;
        RBus_UInt32  ck_dig_rstb:1;
        RBus_UInt32  ck_vcorstb:1;
        RBus_UInt32  ck_pllrstb:1;
        RBus_UInt32  ck_md_rstb:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  ldo_ref:3;
        RBus_UInt32  reg_top_in:8;
        RBus_UInt32  dummy1800db44_7_6:2;
        RBus_UInt32  reg_ckcmp:1;
        RBus_UInt32  reg_ckdet:3;
        RBus_UInt32  reg_cklatch:1;
        RBus_UInt32  debug_select:1;
    };
}hdmiphy_reg_phy_ctl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  reg_top_out:8;
        RBus_UInt32  res1:3;
        RBus_UInt32  r_koff_sel:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  g_koff_sel:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  b_koff_sel:5;
    };
}hdmiphy_reg_rgb_koff_sel_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:11;
        RBus_UInt32  adjr_0:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  adjr_1:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  adjr_2:5;
    };
}hdmiphy_reg_bandgap_z0_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:10;
        RBus_UInt32  reg_z0_ibxadj:2;
        RBus_UInt32  res2:1;
        RBus_UInt32  reg_ck_z0pow:3;
        RBus_UInt32  res3:1;
        RBus_UInt32  reg_b_z0pow:3;
        RBus_UInt32  res4:1;
        RBus_UInt32  reg_g_z0pow:3;
        RBus_UInt32  res5:1;
        RBus_UInt32  reg_r_z0pow:3;
        RBus_UInt32  res6:1;
        RBus_UInt32  z0pow_0:1;
        RBus_UInt32  z0pow_1:1;
        RBus_UInt32  z0pow_2:1;
    };
}hdmiphy_reg_bandgap_z0_ctrl_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  reg_b_13:8;
    };
}hdmiphy_reg_b_13_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  reg_b_15:8;
        RBus_UInt32  reg_b_14:8;
    };
}hdmiphy_reg_b_14_15_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  reg_g_13:8;
    };
}hdmiphy_reg_g_13_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  reg_g_15:8;
        RBus_UInt32  reg_g_14:8;
    };
}hdmiphy_reg_g_14_15_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  reg_r_13:8;
    };
}hdmiphy_reg_r_13_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  reg_r_15:8;
        RBus_UInt32  reg_r_14:8;
    };
}hdmiphy_reg_r_14_15_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  reg_dpll_pow:1;
        RBus_UInt32  reg_dpll_ldosel:2;
        RBus_UInt32  pow_ldo:1;
    };
}hdmiphy_dpll_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:30;
        RBus_UInt32  reg_testout_sel:2;
    };
}hdmiphy_test_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  reg_gdi_1:32;
    };
}hdmiphy_analog_cdr_ctrl1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  reg_gdi_2:32;
    };
}hdmiphy_analog_cdr_ctrl2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  reg_gdi_3:32;
    };
}hdmiphy_analog_cdr_ctrl3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  reg_gdi_4:32;
    };
}hdmiphy_analog_cdr_ctrl4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  reg_gdi_5:32;
    };
}hdmiphy_analog_cdr_ctrl5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:23;
        RBus_UInt32  gdi_fld_calibok:1;
        RBus_UInt32  res2:3;
        RBus_UInt32  gdi_koff_sel:5;
    };
}hdmiphy_analog_cdr_status_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ck_md_error_limit:5;
        RBus_UInt32  ck_md_reserved:4;
        RBus_UInt32  ck_md_pop_plus:1;
        RBus_UInt32  ck_md_threshold:6;
        RBus_UInt32  dummy1800dbdc_15:1;
        RBus_UInt32  ck_md_debounce:7;
        RBus_UInt32  dummy1800dbdc_7_6:2;
        RBus_UInt32  ck_md_err:1;
        RBus_UInt32  ck_md_adj:4;
        RBus_UInt32  ck_md_auto:1;
    };
}hdmiphy_reg_ck_md_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  reg_z300pow:3;
        RBus_UInt32  res2:1;
        RBus_UInt32  reg_z300_sel_2:1;
        RBus_UInt32  reg_z300_sel_1:1;
        RBus_UInt32  reg_z300_sel_0:1;
        RBus_UInt32  reg_enddc:1;
        RBus_UInt32  reg_mhlpow:1;
        RBus_UInt32  reg_mhl_hdmisel:1;
        RBus_UInt32  reg_z100k_enb:1;
    };
}hdmiphy_reg_mhl_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  ck_md_sel:2;
        RBus_UInt32  reg_ldo_sel:2;
        RBus_UInt32  reg_cdr_rate_sel:3;
        RBus_UInt32  reg_infifo_cnt:3;
        RBus_UInt32  reg_pi_m_mode:1;
        RBus_UInt32  reg_kd:1;
        RBus_UInt32  reg_ercnt_en:1;
        RBus_UInt32  reg_edge_out:1;
        RBus_UInt32  reg_data_order:1;
        RBus_UInt32  reg_cdr_ckinv:1;
        RBus_UInt32  reg_bypass_sdm_int:1;
        RBus_UInt32  reg_acc2_manual:1;
        RBus_UInt32  reg_acc2_period:10;
    };
}hdmiphy_reg_dig_phy_ctrl_new_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  reg_squ_tri:1;
        RBus_UInt32  res2:3;
        RBus_UInt32  reg_st_m_value:5;
        RBus_UInt32  res3:1;
        RBus_UInt32  reg_ki:3;
        RBus_UInt32  reg_kp:8;
        RBus_UInt32  reg_en_m_value:8;
    };
}hdmiphy_reg_dig_phy_ctrl_new_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:18;
        RBus_UInt32  reg_int_init:14;
    };
}hdmiphy_reg_dig_phy_ctrl_new_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:11;
        RBus_UInt32  reg_timer_ber:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  reg_timer_eq:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  reg_timer_lpf:5;
    };
}hdmiphy_timer_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  r_cdr_ber_notify:1;
        RBus_UInt32  res2:2;
        RBus_UInt32  r_cdr_er_count:10;
    };
}hdmiphy_r_cdr_er_count_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  g_cdr_ber_notify:1;
        RBus_UInt32  res2:2;
        RBus_UInt32  g_cdr_er_count:10;
    };
}hdmiphy_g_cdr_er_count_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  b_cdr_ber_notify:1;
        RBus_UInt32  res2:2;
        RBus_UInt32  b_cdr_er_count:10;
    };
}hdmiphy_b_cdr_er_count_RBUS;

#else //apply LITTLE_ENDIAN

//======HDMIPHY register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  reg_ck_1:8;
        RBus_UInt32  reg_ck_2:8;
        RBus_UInt32  reg_ck_3:8;
        RBus_UInt32  reg_ck_4:8;
    };
}hdmiphy_reg_ck_1_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  reg_ck_5:8;
        RBus_UInt32  reg_ck_6:8;
        RBus_UInt32  reg_ck_7:8;
        RBus_UInt32  reg_ck_8:8;
    };
}hdmiphy_reg_ck_5_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  reg_ck_9:8;
        RBus_UInt32  reg_ck_10:8;
        RBus_UInt32  reg_ck_11:8;
        RBus_UInt32  reg_ck_12:8;
    };
}hdmiphy_reg_ck_9_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ck_md_ok:1;
        RBus_UInt32  ck_wdo:1;
        RBus_UInt32  ck_md_unstable_flag:1;
        RBus_UInt32  dummy1800db0c_4:2;
        RBus_UInt32  ck_rate:4;
        RBus_UInt32  dummy1800db0c_11:3;
        RBus_UInt32  ck_md_unstable_count:5;
        RBus_UInt32  dummy1800db0c_17:1;
        RBus_UInt32  dummy1800db0c_18:1;
        RBus_UInt32  ck_md_count:13;
    };
}hdmiphy_reg_ck_result_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  reg_r_1:8;
        RBus_UInt32  reg_r_2:8;
        RBus_UInt32  reg_r_3:8;
        RBus_UInt32  reg_r_4:8;
    };
}hdmiphy_reg_r_1_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  reg_r_5:8;
        RBus_UInt32  reg_r_6:8;
        RBus_UInt32  reg_r_7:8;
        RBus_UInt32  reg_r_8:8;
    };
}hdmiphy_reg_r_5_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  reg_r_9:8;
        RBus_UInt32  reg_r_10:8;
        RBus_UInt32  reg_r_11:8;
        RBus_UInt32  reg_r_12:8;
    };
}hdmiphy_reg_r_9_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:5;
        RBus_UInt32  r_koff_tst:6;
        RBus_UInt32  r_lsb:8;
        RBus_UInt32  r_msb:8;
        RBus_UInt32  r_koff_bound:1;
        RBus_UInt32  r_koffok:1;
        RBus_UInt32  res2:3;
    };
}hdmiphy_reg_r_result_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  reg_g_1:8;
        RBus_UInt32  reg_g_2:8;
        RBus_UInt32  reg_g_3:8;
        RBus_UInt32  reg_g_4:8;
    };
}hdmiphy_reg_g_1_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  reg_g_5:8;
        RBus_UInt32  reg_g_6:8;
        RBus_UInt32  reg_g_7:8;
        RBus_UInt32  reg_g_8:8;
    };
}hdmiphy_reg_g_5_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  reg_g_9:8;
        RBus_UInt32  reg_g_10:8;
        RBus_UInt32  reg_g_11:8;
        RBus_UInt32  reg_g_12:8;
    };
}hdmiphy_reg_g_9_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:5;
        RBus_UInt32  g_koff_tst:6;
        RBus_UInt32  g_lsb:8;
        RBus_UInt32  g_msb:8;
        RBus_UInt32  g_koff_bound:1;
        RBus_UInt32  g_koffok:1;
        RBus_UInt32  res2:3;
    };
}hdmiphy_reg_g_result_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  reg_b_1:8;
        RBus_UInt32  reg_b_2:8;
        RBus_UInt32  reg_b_3:8;
        RBus_UInt32  reg_b_4:8;
    };
}hdmiphy_reg_b_1_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  reg_b_5:8;
        RBus_UInt32  reg_b_6:8;
        RBus_UInt32  reg_b_7:8;
        RBus_UInt32  reg_b_8:8;
    };
}hdmiphy_reg_b_5_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  reg_b_9:8;
        RBus_UInt32  reg_b_10:8;
        RBus_UInt32  reg_b_11:8;
        RBus_UInt32  reg_b_12:8;
    };
}hdmiphy_reg_b_9_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:5;
        RBus_UInt32  b_koff_tst:6;
        RBus_UInt32  b_lsb:8;
        RBus_UInt32  b_msb:8;
        RBus_UInt32  b_koff_bound:1;
        RBus_UInt32  b_koffok:1;
        RBus_UInt32  res2:3;
    };
}hdmiphy_reg_b_result_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  z0_bound:1;
        RBus_UInt32  z0_ok:1;
        RBus_UInt32  z0tst:4;
        RBus_UInt32  z0_res:5;
        RBus_UInt32  hspow:1;
        RBus_UInt32  stst:4;
        RBus_UInt32  spad:1;
        RBus_UInt32  z0tune:1;
        RBus_UInt32  entst_z0:1;
        RBus_UInt32  reg_bg_rbg:3;
        RBus_UInt32  z0pow:1;
        RBus_UInt32  sbg:2;
        RBus_UInt32  bgpow:1;
        RBus_UInt32  reg_bg_rbg2:2;
        RBus_UInt32  reg_bg_rbgloop2:3;
        RBus_UInt32  reg_bg_envbgup:1;
    };
}hdmiphy_reg_bandgap_z0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  debug_select:1;
        RBus_UInt32  reg_cklatch:1;
        RBus_UInt32  reg_ckdet:3;
        RBus_UInt32  reg_ckcmp:1;
        RBus_UInt32  dummy1800db44_7:2;
        RBus_UInt32  reg_top_in:8;
        RBus_UInt32  ldo_ref:3;
        RBus_UInt32  res1:1;
        RBus_UInt32  ck_md_rstb:1;
        RBus_UInt32  ck_pllrstb:1;
        RBus_UInt32  ck_vcorstb:1;
        RBus_UInt32  ck_dig_rstb:1;
        RBus_UInt32  r_dig_rstb:1;
        RBus_UInt32  r_dig_cdr_rstb:1;
        RBus_UInt32  g_dig_rstb:1;
        RBus_UInt32  g_dig_cdr_rstb:1;
        RBus_UInt32  b_dig_rstb:1;
        RBus_UInt32  b_dig_cdr_rstb:1;
        RBus_UInt32  dfe_rstn_n:1;
        RBus_UInt32  dummy1800db44_31:1;
    };
}hdmiphy_reg_phy_ctl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  b_koff_sel:5;
        RBus_UInt32  res1:3;
        RBus_UInt32  g_koff_sel:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  r_koff_sel:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  reg_top_out:8;
    };
}hdmiphy_reg_rgb_koff_sel_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  adjr_2:5;
        RBus_UInt32  res1:3;
        RBus_UInt32  adjr_1:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  adjr_0:5;
        RBus_UInt32  res3:11;
    };
}hdmiphy_reg_bandgap_z0_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  z0pow_2:1;
        RBus_UInt32  z0pow_1:1;
        RBus_UInt32  z0pow_0:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  reg_r_z0pow:3;
        RBus_UInt32  res2:1;
        RBus_UInt32  reg_g_z0pow:3;
        RBus_UInt32  res3:1;
        RBus_UInt32  reg_b_z0pow:3;
        RBus_UInt32  res4:1;
        RBus_UInt32  reg_ck_z0pow:3;
        RBus_UInt32  res5:1;
        RBus_UInt32  reg_z0_ibxadj:2;
        RBus_UInt32  res6:10;
    };
}hdmiphy_reg_bandgap_z0_ctrl_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  reg_b_13:8;
        RBus_UInt32  res1:24;
    };
}hdmiphy_reg_b_13_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  reg_b_14:8;
        RBus_UInt32  reg_b_15:8;
        RBus_UInt32  res1:16;
    };
}hdmiphy_reg_b_14_15_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  reg_g_13:8;
        RBus_UInt32  res1:24;
    };
}hdmiphy_reg_g_13_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  reg_g_14:8;
        RBus_UInt32  reg_g_15:8;
        RBus_UInt32  res1:16;
    };
}hdmiphy_reg_g_14_15_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  reg_r_13:8;
        RBus_UInt32  res1:24;
    };
}hdmiphy_reg_r_13_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  reg_r_14:8;
        RBus_UInt32  reg_r_15:8;
        RBus_UInt32  res1:16;
    };
}hdmiphy_reg_r_14_15_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pow_ldo:1;
        RBus_UInt32  reg_dpll_ldosel:2;
        RBus_UInt32  reg_dpll_pow:1;
        RBus_UInt32  res1:28;
    };
}hdmiphy_dpll_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  reg_testout_sel:2;
        RBus_UInt32  res1:30;
    };
}hdmiphy_test_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  reg_gdi_1:32;
    };
}hdmiphy_analog_cdr_ctrl1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  reg_gdi_2:32;
    };
}hdmiphy_analog_cdr_ctrl2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  reg_gdi_3:32;
    };
}hdmiphy_analog_cdr_ctrl3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  reg_gdi_4:32;
    };
}hdmiphy_analog_cdr_ctrl4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  reg_gdi_5:32;
    };
}hdmiphy_analog_cdr_ctrl5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  gdi_koff_sel:5;
        RBus_UInt32  res1:3;
        RBus_UInt32  gdi_fld_calibok:1;
        RBus_UInt32  res2:23;
    };
}hdmiphy_analog_cdr_status_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ck_md_auto:1;
        RBus_UInt32  ck_md_adj:4;
        RBus_UInt32  ck_md_err:1;
        RBus_UInt32  dummy1800dbdc_7:2;
        RBus_UInt32  ck_md_debounce:7;
        RBus_UInt32  dummy1800dbdc_15:1;
        RBus_UInt32  ck_md_threshold:6;
        RBus_UInt32  ck_md_pop_plus:1;
        RBus_UInt32  ck_md_reserved:4;
        RBus_UInt32  ck_md_error_limit:5;
    };
}hdmiphy_reg_ck_md_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  reg_z100k_enb:1;
        RBus_UInt32  reg_mhl_hdmisel:1;
        RBus_UInt32  reg_mhlpow:1;
        RBus_UInt32  reg_enddc:1;
        RBus_UInt32  reg_z300_sel_0:1;
        RBus_UInt32  reg_z300_sel_1:1;
        RBus_UInt32  reg_z300_sel_2:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  reg_z300pow:3;
        RBus_UInt32  res2:21;
    };
}hdmiphy_reg_mhl_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  reg_acc2_period:10;
        RBus_UInt32  reg_acc2_manual:1;
        RBus_UInt32  reg_bypass_sdm_int:1;
        RBus_UInt32  reg_cdr_ckinv:1;
        RBus_UInt32  reg_data_order:1;
        RBus_UInt32  reg_edge_out:1;
        RBus_UInt32  reg_ercnt_en:1;
        RBus_UInt32  reg_kd:1;
        RBus_UInt32  reg_pi_m_mode:1;
        RBus_UInt32  reg_infifo_cnt:3;
        RBus_UInt32  reg_cdr_rate_sel:3;
        RBus_UInt32  reg_ldo_sel:2;
        RBus_UInt32  ck_md_sel:2;
        RBus_UInt32  res1:4;
    };
}hdmiphy_reg_dig_phy_ctrl_new_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  reg_en_m_value:8;
        RBus_UInt32  reg_kp:8;
        RBus_UInt32  reg_ki:3;
        RBus_UInt32  res1:1;
        RBus_UInt32  reg_st_m_value:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  reg_squ_tri:1;
        RBus_UInt32  res3:3;
    };
}hdmiphy_reg_dig_phy_ctrl_new_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  reg_int_init:14;
        RBus_UInt32  res1:18;
    };
}hdmiphy_reg_dig_phy_ctrl_new_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  reg_timer_lpf:5;
        RBus_UInt32  res1:3;
        RBus_UInt32  reg_timer_eq:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  reg_timer_ber:5;
        RBus_UInt32  res3:11;
    };
}hdmiphy_timer_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  r_cdr_er_count:10;
        RBus_UInt32  res1:2;
        RBus_UInt32  r_cdr_ber_notify:1;
        RBus_UInt32  res2:19;
    };
}hdmiphy_r_cdr_er_count_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  g_cdr_er_count:10;
        RBus_UInt32  res1:2;
        RBus_UInt32  g_cdr_ber_notify:1;
        RBus_UInt32  res2:19;
    };
}hdmiphy_g_cdr_er_count_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  b_cdr_er_count:10;
        RBus_UInt32  res1:2;
        RBus_UInt32  b_cdr_ber_notify:1;
        RBus_UInt32  res2:19;
    };
}hdmiphy_b_cdr_er_count_RBUS;




#endif

// clock detection 2015 0305

#if 0

#endif

//cloud modify mag2 reg 20150306

#define  HDMI_CLKDET_CLKDETCR                                                    0x18061F00
#define  HDMI_CLKDET_CLKDETCR_reg_addr                                           "0xB8061F00"
#define  HDMI_CLKDET_CLKDETCR_reg                                                0xB8061F00
#define  HDMI_CLKDET_CLKDETCR_inst_addr                                          "0x0000"
#define  set_HDMI_CLKDET_CLKDETCR_reg(data)                                      (*((volatile unsigned int*)HDMI_CLKDET_CLKDETCR_reg)=data)
#define  get_HDMI_CLKDET_CLKDETCR_reg                                            (*((volatile unsigned int*)HDMI_CLKDET_CLKDETCR_reg))
#define  HDMI_CLKDET_CLKDETCR_clock_det_en_shift                                 (0)
#define  HDMI_CLKDET_CLKDETCR_clock_det_en_mask                                  (0x00000001)
#define  HDMI_CLKDET_CLKDETCR_clock_det_en(data)                                 (0x00000001&(data))
#define  HDMI_CLKDET_CLKDETCR_get_clock_det_en(data)                             (0x00000001&(data))

#define  HDMI_CLKDET_CLKDETSR                                                    0x18061F04
#define  HDMI_CLKDET_CLKDETSR_reg_addr                                           "0xB8061F04"
#define  HDMI_CLKDET_CLKDETSR_reg                                                0xB8061F04
#define  HDMI_CLKDET_CLKDETSR_inst_addr                                          "0x0001"
#define  set_HDMI_CLKDET_CLKDETSR_reg(data)                                      (*((volatile unsigned int*)HDMI_CLKDET_CLKDETSR_reg)=data)
#define  get_HDMI_CLKDET_CLKDETSR_reg                                            (*((volatile unsigned int*)HDMI_CLKDET_CLKDETSR_reg))
#define  HDMI_CLKDET_CLKDETSR_en_tmds_chg_irq_shift                              (5)
#define  HDMI_CLKDET_CLKDETSR_tmds_chg_irq_shift                                 (4)
#define  HDMI_CLKDET_CLKDETSR_dummy_shift                                        (2)
#define  HDMI_CLKDET_CLKDETSR_clk_in_target_irq_en_shift                         (1)
#define  HDMI_CLKDET_CLKDETSR_clk_in_target_shift                                (0)
#define  HDMI_CLKDET_CLKDETSR_en_tmds_chg_irq_mask                               (0x00000020)
#define  HDMI_CLKDET_CLKDETSR_tmds_chg_irq_mask                                  (0x00000010)
#define  HDMI_CLKDET_CLKDETSR_dummy_mask                                         (0x0000000C)
#define  HDMI_CLKDET_CLKDETSR_clk_in_target_irq_en_mask                          (0x00000002)
#define  HDMI_CLKDET_CLKDETSR_clk_in_target_mask                                 (0x00000001)
#define  HDMI_CLKDET_CLKDETSR_en_tmds_chg_irq(data)                              (0x00000020&((data)<<5))
#define  HDMI_CLKDET_CLKDETSR_tmds_chg_irq(data)                                 (0x00000010&((data)<<4))
#define  HDMI_CLKDET_CLKDETSR_dummy(data)                                        (0x0000000C&((data)<<2))
#define  HDMI_CLKDET_CLKDETSR_clk_in_target_irq_en(data)                         (0x00000002&((data)<<1))
#define  HDMI_CLKDET_CLKDETSR_clk_in_target(data)                                (0x00000001&(data))
#define  HDMI_CLKDET_CLKDETSR_get_en_tmds_chg_irq(data)                          ((0x00000020&(data))>>5)
#define  HDMI_CLKDET_CLKDETSR_get_tmds_chg_irq(data)                             ((0x00000010&(data))>>4)
#define  HDMI_CLKDET_CLKDETSR_get_dummy(data)                                    ((0x0000000C&(data))>>2)
#define  HDMI_CLKDET_CLKDETSR_get_clk_in_target_irq_en(data)                     ((0x00000002&(data))>>1)
#define  HDMI_CLKDET_CLKDETSR_get_clk_in_target(data)                            (0x00000001&(data))

#define  HDMI_CLKDET_GDI_TMDSCLK_SETTING_00                                      0x18061F08
#define  HDMI_CLKDET_GDI_TMDSCLK_SETTING_00_reg_addr                             "0xB8061F08"
#define  HDMI_CLKDET_GDI_TMDSCLK_SETTING_00_reg                                  0xB8061F08
#define  HDMI_CLKDET_GDI_TMDSCLK_SETTING_00_inst_addr                            "0x0002"
#define  set_HDMI_CLKDET_GDI_TMDSCLK_SETTING_00_reg(data)                        (*((volatile unsigned int*)HDMI_CLKDET_GDI_TMDSCLK_SETTING_00_reg)=data)
#define  get_HDMI_CLKDET_GDI_TMDSCLK_SETTING_00_reg                              (*((volatile unsigned int*)HDMI_CLKDET_GDI_TMDSCLK_SETTING_00_reg))
#define  HDMI_CLKDET_GDI_TMDSCLK_SETTING_00_dclk_cnt_start_shift                 (16)
#define  HDMI_CLKDET_GDI_TMDSCLK_SETTING_00_dclk_cnt_end_shift                   (0)
#define  HDMI_CLKDET_GDI_TMDSCLK_SETTING_00_dclk_cnt_start_mask                  (0x0FFF0000)
#define  HDMI_CLKDET_GDI_TMDSCLK_SETTING_00_dclk_cnt_end_mask                    (0x00000FFF)
#define  HDMI_CLKDET_GDI_TMDSCLK_SETTING_00_dclk_cnt_start(data)                 (0x0FFF0000&((data)<<16))
#define  HDMI_CLKDET_GDI_TMDSCLK_SETTING_00_dclk_cnt_end(data)                   (0x00000FFF&(data))
#define  HDMI_CLKDET_GDI_TMDSCLK_SETTING_00_get_dclk_cnt_start(data)             ((0x0FFF0000&(data))>>16)
#define  HDMI_CLKDET_GDI_TMDSCLK_SETTING_00_get_dclk_cnt_end(data)               (0x00000FFF&(data))

#define  HDMI_CLKDET_GDI_TMDSCLK_SETTING_01                                      0x18061F0C
#define  HDMI_CLKDET_GDI_TMDSCLK_SETTING_01_reg_addr                             "0xB8061F0C"
#define  HDMI_CLKDET_GDI_TMDSCLK_SETTING_01_reg                                  0xB8061F0C
#define  HDMI_CLKDET_GDI_TMDSCLK_SETTING_01_inst_addr                            "0x0003"
#define  set_HDMI_CLKDET_GDI_TMDSCLK_SETTING_01_reg(data)                        (*((volatile unsigned int*)HDMI_CLKDET_GDI_TMDSCLK_SETTING_01_reg)=data)
#define  get_HDMI_CLKDET_GDI_TMDSCLK_SETTING_01_reg                              (*((volatile unsigned int*)HDMI_CLKDET_GDI_TMDSCLK_SETTING_01_reg))
#define  HDMI_CLKDET_GDI_TMDSCLK_SETTING_01_target_for_maximum_clk_counter_shift (16)
#define  HDMI_CLKDET_GDI_TMDSCLK_SETTING_01_target_for_minimum_clk_counter_shift (0)
#define  HDMI_CLKDET_GDI_TMDSCLK_SETTING_01_target_for_maximum_clk_counter_mask  (0x0FFF0000)
#define  HDMI_CLKDET_GDI_TMDSCLK_SETTING_01_target_for_minimum_clk_counter_mask  (0x00000FFF)
#define  HDMI_CLKDET_GDI_TMDSCLK_SETTING_01_target_for_maximum_clk_counter(data) (0x0FFF0000&((data)<<16))
#define  HDMI_CLKDET_GDI_TMDSCLK_SETTING_01_target_for_minimum_clk_counter(data) (0x00000FFF&(data))
#define  HDMI_CLKDET_GDI_TMDSCLK_SETTING_01_get_target_for_maximum_clk_counter(data) ((0x0FFF0000&(data))>>16)
#define  HDMI_CLKDET_GDI_TMDSCLK_SETTING_01_get_target_for_minimum_clk_counter(data) (0x00000FFF&(data))

#define  HDMI_CLKDET_GDI_TMDSCLK_SETTING_02                                      0x18061F10
#define  HDMI_CLKDET_GDI_TMDSCLK_SETTING_02_reg_addr                             "0xB8061F10"
#define  HDMI_CLKDET_GDI_TMDSCLK_SETTING_02_reg                                  0xB8061F10
#define  HDMI_CLKDET_GDI_TMDSCLK_SETTING_02_inst_addr                            "0x0004"
#define  set_HDMI_CLKDET_GDI_TMDSCLK_SETTING_02_reg(data)                        (*((volatile unsigned int*)HDMI_CLKDET_GDI_TMDSCLK_SETTING_02_reg)=data)
#define  get_HDMI_CLKDET_GDI_TMDSCLK_SETTING_02_reg                              (*((volatile unsigned int*)HDMI_CLKDET_GDI_TMDSCLK_SETTING_02_reg))
#define  HDMI_CLKDET_GDI_TMDSCLK_SETTING_02_clk_counter_err_threshold_shift      (8)
#define  HDMI_CLKDET_GDI_TMDSCLK_SETTING_02_clk_counter_debounce_shift           (0)
#define  HDMI_CLKDET_GDI_TMDSCLK_SETTING_02_clk_counter_err_threshold_mask       (0x00000F00)
#define  HDMI_CLKDET_GDI_TMDSCLK_SETTING_02_clk_counter_debounce_mask            (0x000000FF)
#define  HDMI_CLKDET_GDI_TMDSCLK_SETTING_02_clk_counter_err_threshold(data)      (0x00000F00&((data)<<8))
#define  HDMI_CLKDET_GDI_TMDSCLK_SETTING_02_clk_counter_debounce(data)           (0x000000FF&(data))
#define  HDMI_CLKDET_GDI_TMDSCLK_SETTING_02_get_clk_counter_err_threshold(data)  ((0x00000F00&(data))>>8)
#define  HDMI_CLKDET_GDI_TMDSCLK_SETTING_02_get_clk_counter_debounce(data)       (0x000000FF&(data))

// MAG2  Digital Spec 20150304


#if 0


#else

#define  HDMI_TMDS_MSR0                                                          0x1800D000
#define  HDMI_TMDS_MSR0_reg_addr                                                 "0xB800D000"
#define  HDMI_TMDS_MSR0_reg                                                      0xB800D000
#define  HDMI_TMDS_MSR0_inst_addr                                                "0x0000"
#define  set_HDMI_TMDS_MSR0_reg(data)                                            (*((volatile unsigned int*)HDMI_TMDS_MSR0_reg)=data)
#define  get_HDMI_TMDS_MSR0_reg                                                  (*((volatile unsigned int*)HDMI_TMDS_MSR0_reg))
#define  HDMI_TMDS_MSR0_tmm_shift                                                (7)
#define  HDMI_TMDS_MSR0_mt_shift                                                 (4)
#define  HDMI_TMDS_MSR0_ncp_shift                                                (0)
#define  HDMI_TMDS_MSR0_tmm_mask                                                 (0x00000080)
#define  HDMI_TMDS_MSR0_mt_mask                                                  (0x00000070)
#define  HDMI_TMDS_MSR0_ncp_mask                                                 (0x0000000F)
#define  HDMI_TMDS_MSR0_tmm(data)                                                (0x00000080&((data)<<7))
#define  HDMI_TMDS_MSR0_mt(data)                                                 (0x00000070&((data)<<4))
#define  HDMI_TMDS_MSR0_ncp(data)                                                (0x0000000F&(data))
#define  HDMI_TMDS_MSR0_get_tmm(data)                                            ((0x00000080&(data))>>7)
#define  HDMI_TMDS_MSR0_get_mt(data)                                             ((0x00000070&(data))>>4)
#define  HDMI_TMDS_MSR0_get_ncp(data)                                            (0x0000000F&(data))

#define  HDMI_TMDS_MSR1                                                          0x1800D004
#define  HDMI_TMDS_MSR1_reg_addr                                                 "0xB800D004"
#define  HDMI_TMDS_MSR1_reg                                                      0xB800D004
#define  HDMI_TMDS_MSR1_inst_addr                                                "0x0001"
#define  set_HDMI_TMDS_MSR1_reg(data)                                            (*((volatile unsigned int*)HDMI_TMDS_MSR1_reg)=data)
#define  get_HDMI_TMDS_MSR1_reg                                                  (*((volatile unsigned int*)HDMI_TMDS_MSR1_reg))
#define  HDMI_TMDS_MSR1_tms_shift                                                (12)
#define  HDMI_TMDS_MSR1_mrs_shift                                                (10)
#define  HDMI_TMDS_MSR1_ms_shift                                                 (8)
#define  HDMI_TMDS_MSR1_ctc_shift                                                (7)
#define  HDMI_TMDS_MSR1_vmr_shift                                                (0)
#define  HDMI_TMDS_MSR1_tms_mask                                                 (0x00001000)
#define  HDMI_TMDS_MSR1_mrs_mask                                                 (0x00000C00)
#define  HDMI_TMDS_MSR1_ms_mask                                                  (0x00000300)
#define  HDMI_TMDS_MSR1_ctc_mask                                                 (0x00000080)
#define  HDMI_TMDS_MSR1_vmr_mask                                                 (0x0000007F)
#define  HDMI_TMDS_MSR1_tms(data)                                                (0x00001000&((data)<<12))
#define  HDMI_TMDS_MSR1_mrs(data)                                                (0x00000C00&((data)<<10))
#define  HDMI_TMDS_MSR1_ms(data)                                                 (0x00000300&((data)<<8))
#define  HDMI_TMDS_MSR1_ctc(data)                                                (0x00000080&((data)<<7))
#define  HDMI_TMDS_MSR1_vmr(data)                                                (0x0000007F&(data))
#define  HDMI_TMDS_MSR1_get_tms(data)                                            ((0x00001000&(data))>>12)
#define  HDMI_TMDS_MSR1_get_mrs(data)                                            ((0x00000C00&(data))>>10)
#define  HDMI_TMDS_MSR1_get_ms(data)                                             ((0x00000300&(data))>>8)
#define  HDMI_TMDS_MSR1_get_ctc(data)                                            ((0x00000080&(data))>>7)
#define  HDMI_TMDS_MSR1_get_vmr(data)                                            (0x0000007F&(data))

#define  HDMI_TMDS_CRCC                                                          0x1800D008
#define  HDMI_TMDS_CRCC_reg_addr                                                 "0xB800D008"
#define  HDMI_TMDS_CRCC_reg                                                      0xB800D008
#define  HDMI_TMDS_CRCC_inst_addr                                                "0x0002"
#define  set_HDMI_TMDS_CRCC_reg(data)                                            (*((volatile unsigned int*)HDMI_TMDS_CRCC_reg)=data)
#define  get_HDMI_TMDS_CRCC_reg                                                  (*((volatile unsigned int*)HDMI_TMDS_CRCC_reg))
#define  HDMI_TMDS_CRCC_crc_r_en_shift                                           (7)
#define  HDMI_TMDS_CRCC_crc_g_en_shift                                           (6)
#define  HDMI_TMDS_CRCC_crc_b_en_shift                                           (5)
#define  HDMI_TMDS_CRCC_crc_done_shift                                           (4)
#define  HDMI_TMDS_CRCC_crc_nonstable_shift                                      (3)
#define  HDMI_TMDS_CRCC_crcts_shift                                              (1)
#define  HDMI_TMDS_CRCC_crcc_shift                                               (0)
#define  HDMI_TMDS_CRCC_crc_r_en_mask                                            (0x00000080)
#define  HDMI_TMDS_CRCC_crc_g_en_mask                                            (0x00000040)
#define  HDMI_TMDS_CRCC_crc_b_en_mask                                            (0x00000020)
#define  HDMI_TMDS_CRCC_crc_done_mask                                            (0x00000010)
#define  HDMI_TMDS_CRCC_crc_nonstable_mask                                       (0x00000008)
#define  HDMI_TMDS_CRCC_crcts_mask                                               (0x00000006)
#define  HDMI_TMDS_CRCC_crcc_mask                                                (0x00000001)
#define  HDMI_TMDS_CRCC_crc_r_en(data)                                           (0x00000080&((data)<<7))
#define  HDMI_TMDS_CRCC_crc_g_en(data)                                           (0x00000040&((data)<<6))
#define  HDMI_TMDS_CRCC_crc_b_en(data)                                           (0x00000020&((data)<<5))
#define  HDMI_TMDS_CRCC_crc_done(data)                                           (0x00000010&((data)<<4))
#define  HDMI_TMDS_CRCC_crc_nonstable(data)                                      (0x00000008&((data)<<3))
#define  HDMI_TMDS_CRCC_crcts(data)                                              (0x00000006&((data)<<1))
#define  HDMI_TMDS_CRCC_crcc(data)                                               (0x00000001&(data))
#define  HDMI_TMDS_CRCC_get_crc_r_en(data)                                       ((0x00000080&(data))>>7)
#define  HDMI_TMDS_CRCC_get_crc_g_en(data)                                       ((0x00000040&(data))>>6)
#define  HDMI_TMDS_CRCC_get_crc_b_en(data)                                       ((0x00000020&(data))>>5)
#define  HDMI_TMDS_CRCC_get_crc_done(data)                                       ((0x00000010&(data))>>4)
#define  HDMI_TMDS_CRCC_get_crc_nonstable(data)                                  ((0x00000008&(data))>>3)
#define  HDMI_TMDS_CRCC_get_crcts(data)                                          ((0x00000006&(data))>>1)
#define  HDMI_TMDS_CRCC_get_crcc(data)                                           (0x00000001&(data))

#define  HDMI_TMDS_CRCO0                                                         0x1800D00C
#define  HDMI_TMDS_CRCO0_reg_addr                                                "0xB800D00C"
#define  HDMI_TMDS_CRCO0_reg                                                     0xB800D00C
#define  HDMI_TMDS_CRCO0_inst_addr                                               "0x0003"
#define  set_HDMI_TMDS_CRCO0_reg(data)                                           (*((volatile unsigned int*)HDMI_TMDS_CRCO0_reg)=data)
#define  get_HDMI_TMDS_CRCO0_reg                                                 (*((volatile unsigned int*)HDMI_TMDS_CRCO0_reg))
#define  HDMI_TMDS_CRCO0_crcob2_3_shift                                          (16)
#define  HDMI_TMDS_CRCO0_crcob2_2_shift                                          (8)
#define  HDMI_TMDS_CRCO0_crcob2_1_shift                                          (0)
#define  HDMI_TMDS_CRCO0_crcob2_3_mask                                           (0x00FF0000)
#define  HDMI_TMDS_CRCO0_crcob2_2_mask                                           (0x0000FF00)
#define  HDMI_TMDS_CRCO0_crcob2_1_mask                                           (0x000000FF)
#define  HDMI_TMDS_CRCO0_crcob2_3(data)                                          (0x00FF0000&((data)<<16))
#define  HDMI_TMDS_CRCO0_crcob2_2(data)                                          (0x0000FF00&((data)<<8))
#define  HDMI_TMDS_CRCO0_crcob2_1(data)                                          (0x000000FF&(data))
#define  HDMI_TMDS_CRCO0_get_crcob2_3(data)                                      ((0x00FF0000&(data))>>16)
#define  HDMI_TMDS_CRCO0_get_crcob2_2(data)                                      ((0x0000FF00&(data))>>8)
#define  HDMI_TMDS_CRCO0_get_crcob2_1(data)                                      (0x000000FF&(data))

#define  HDMI_TMDS_CRCO1                                                         0x1800D010
#define  HDMI_TMDS_CRCO1_reg_addr                                                "0xB800D010"
#define  HDMI_TMDS_CRCO1_reg                                                     0xB800D010
#define  HDMI_TMDS_CRCO1_inst_addr                                               "0x0004"
#define  set_HDMI_TMDS_CRCO1_reg(data)                                           (*((volatile unsigned int*)HDMI_TMDS_CRCO1_reg)=data)
#define  get_HDMI_TMDS_CRCO1_reg                                                 (*((volatile unsigned int*)HDMI_TMDS_CRCO1_reg))
#define  HDMI_TMDS_CRCO1_crcob2_6_shift                                          (16)
#define  HDMI_TMDS_CRCO1_crcob2_5_shift                                          (8)
#define  HDMI_TMDS_CRCO1_crcob2_4_shift                                          (0)
#define  HDMI_TMDS_CRCO1_crcob2_6_mask                                           (0x00FF0000)
#define  HDMI_TMDS_CRCO1_crcob2_5_mask                                           (0x0000FF00)
#define  HDMI_TMDS_CRCO1_crcob2_4_mask                                           (0x000000FF)
#define  HDMI_TMDS_CRCO1_crcob2_6(data)                                          (0x00FF0000&((data)<<16))
#define  HDMI_TMDS_CRCO1_crcob2_5(data)                                          (0x0000FF00&((data)<<8))
#define  HDMI_TMDS_CRCO1_crcob2_4(data)                                          (0x000000FF&(data))
#define  HDMI_TMDS_CRCO1_get_crcob2_6(data)                                      ((0x00FF0000&(data))>>16)
#define  HDMI_TMDS_CRCO1_get_crcob2_5(data)                                      ((0x0000FF00&(data))>>8)
#define  HDMI_TMDS_CRCO1_get_crcob2_4(data)                                      (0x000000FF&(data))

#define  HDMI_TMDS_CTRL                                                          0x1800D014
#define  HDMI_TMDS_CTRL_reg_addr                                                 "0xB800D014"
#define  HDMI_TMDS_CTRL_reg                                                      0xB800D014
#define  HDMI_TMDS_CTRL_inst_addr                                                "0x0005"
#define  set_HDMI_TMDS_CTRL_reg(data)                                            (*((volatile unsigned int*)HDMI_TMDS_CTRL_reg)=data)
#define  get_HDMI_TMDS_CTRL_reg                                                  (*((volatile unsigned int*)HDMI_TMDS_CTRL_reg))
#define  HDMI_TMDS_CTRL_bcd_shift                                                (7)
#define  HDMI_TMDS_CTRL_gcd_shift                                                (6)
#define  HDMI_TMDS_CTRL_rcd_shift                                                (5)
#define  HDMI_TMDS_CTRL_ho_shift                                                 (4)
#define  HDMI_TMDS_CTRL_yo_shift                                                 (3)
#define  HDMI_TMDS_CTRL_dummy_shift                                              (0)
#define  HDMI_TMDS_CTRL_bcd_mask                                                 (0x00000080)
#define  HDMI_TMDS_CTRL_gcd_mask                                                 (0x00000040)
#define  HDMI_TMDS_CTRL_rcd_mask                                                 (0x00000020)
#define  HDMI_TMDS_CTRL_ho_mask                                                  (0x00000010)
#define  HDMI_TMDS_CTRL_yo_mask                                                  (0x00000008)
#define  HDMI_TMDS_CTRL_dummy_mask                                               (0x00000007)
#define  HDMI_TMDS_CTRL_bcd(data)                                                (0x00000080&((data)<<7))
#define  HDMI_TMDS_CTRL_gcd(data)                                                (0x00000040&((data)<<6))
#define  HDMI_TMDS_CTRL_rcd(data)                                                (0x00000020&((data)<<5))
#define  HDMI_TMDS_CTRL_ho(data)                                                 (0x00000010&((data)<<4))
#define  HDMI_TMDS_CTRL_yo(data)                                                 (0x00000008&((data)<<3))
#define  HDMI_TMDS_CTRL_dummy(data)                                              (0x00000007&(data))
#define  HDMI_TMDS_CTRL_get_bcd(data)                                            ((0x00000080&(data))>>7)
#define  HDMI_TMDS_CTRL_get_gcd(data)                                            ((0x00000040&(data))>>6)
#define  HDMI_TMDS_CTRL_get_rcd(data)                                            ((0x00000020&(data))>>5)
#define  HDMI_TMDS_CTRL_get_ho(data)                                             ((0x00000010&(data))>>4)
#define  HDMI_TMDS_CTRL_get_yo(data)                                             ((0x00000008&(data))>>3)
#define  HDMI_TMDS_CTRL_get_dummy(data)                                          (0x00000007&(data))

#define  HDMI_TMDS_OUTCTL                                                        0x1800D018
#define  HDMI_TMDS_OUTCTL_reg_addr                                               "0xB800D018"
#define  HDMI_TMDS_OUTCTL_reg                                                    0xB800D018
#define  HDMI_TMDS_OUTCTL_inst_addr                                              "0x0006"
#define  set_HDMI_TMDS_OUTCTL_reg(data)                                          (*((volatile unsigned int*)HDMI_TMDS_OUTCTL_reg)=data)
#define  get_HDMI_TMDS_OUTCTL_reg                                                (*((volatile unsigned int*)HDMI_TMDS_OUTCTL_reg))
#define  HDMI_TMDS_OUTCTL_trcoe_r_shift                                          (13)
#define  HDMI_TMDS_OUTCTL_tgcoe_r_shift                                          (12)
#define  HDMI_TMDS_OUTCTL_tbcoe_r_shift                                          (11)
#define  HDMI_TMDS_OUTCTL_ocke_r_shift                                           (10)
#define  HDMI_TMDS_OUTCTL_aoe_shift                                              (9)
#define  HDMI_TMDS_OUTCTL_trcoe_shift                                            (8)
#define  HDMI_TMDS_OUTCTL_tgcoe_shift                                            (7)
#define  HDMI_TMDS_OUTCTL_tbcoe_shift                                            (6)
#define  HDMI_TMDS_OUTCTL_ocke_shift                                             (5)
#define  HDMI_TMDS_OUTCTL_ockie_shift                                            (4)
/*
#define  HDMI_TMDS_OUTCTL_dummy_shift                                            (3)
#define  HDMI_TMDS_OUTCTL_dummy_shift                                            (2)
#define  HDMI_TMDS_OUTCTL_dummy_shift                                            (1)
#define  HDMI_TMDS_OUTCTL_dummy_shift                                            (0)
*/
#define  HDMI_TMDS_OUTCTL_trcoe_r_mask                                           (0x00002000)
#define  HDMI_TMDS_OUTCTL_tgcoe_r_mask                                           (0x00001000)
#define  HDMI_TMDS_OUTCTL_tbcoe_r_mask                                           (0x00000800)
#define  HDMI_TMDS_OUTCTL_ocke_r_mask                                            (0x00000400)
#define  HDMI_TMDS_OUTCTL_aoe_mask                                               (0x00000200)
#define  HDMI_TMDS_OUTCTL_trcoe_mask                                             (0x00000100)
#define  HDMI_TMDS_OUTCTL_tgcoe_mask                                             (0x00000080)
#define  HDMI_TMDS_OUTCTL_tbcoe_mask                                             (0x00000040)
#define  HDMI_TMDS_OUTCTL_ocke_mask                                              (0x00000020)
#define  HDMI_TMDS_OUTCTL_ockie_mask                                             (0x00000010)
/*
#define  HDMI_TMDS_OUTCTL_dummy_mask                                             (0x00000008)
#define  HDMI_TMDS_OUTCTL_dummy_mask                                             (0x00000004)
#define  HDMI_TMDS_OUTCTL_dummy_mask                                             (0x00000002)
#define  HDMI_TMDS_OUTCTL_dummy_mask                                             (0x00000001)
*/
#define  HDMI_TMDS_OUTCTL_trcoe_r(data)                                          (0x00002000&((data)<<13))
#define  HDMI_TMDS_OUTCTL_tgcoe_r(data)                                          (0x00001000&((data)<<12))
#define  HDMI_TMDS_OUTCTL_tbcoe_r(data)                                          (0x00000800&((data)<<11))
#define  HDMI_TMDS_OUTCTL_ocke_r(data)                                           (0x00000400&((data)<<10))
#define  HDMI_TMDS_OUTCTL_aoe(data)                                              (0x00000200&((data)<<9))
#define  HDMI_TMDS_OUTCTL_trcoe(data)                                            (0x00000100&((data)<<8))
#define  HDMI_TMDS_OUTCTL_tgcoe(data)                                            (0x00000080&((data)<<7))
#define  HDMI_TMDS_OUTCTL_tbcoe(data)                                            (0x00000040&((data)<<6))
#define  HDMI_TMDS_OUTCTL_ocke(data)                                             (0x00000020&((data)<<5))
#define  HDMI_TMDS_OUTCTL_ockie(data)                                            (0x00000010&((data)<<4))
/*
#define  HDMI_TMDS_OUTCTL_dummy(data)                                            (0x00000008&((data)<<3))
#define  HDMI_TMDS_OUTCTL_dummy(data)                                            (0x00000004&((data)<<2))
#define  HDMI_TMDS_OUTCTL_dummy(data)                                            (0x00000002&((data)<<1))
#define  HDMI_TMDS_OUTCTL_dummy(data)                                            (0x00000001&(data))
*/
#define  HDMI_TMDS_OUTCTL_get_trcoe_r(data)                                      ((0x00002000&(data))>>13)
#define  HDMI_TMDS_OUTCTL_get_tgcoe_r(data)                                      ((0x00001000&(data))>>12)
#define  HDMI_TMDS_OUTCTL_get_tbcoe_r(data)                                      ((0x00000800&(data))>>11)
#define  HDMI_TMDS_OUTCTL_get_ocke_r(data)                                       ((0x00000400&(data))>>10)
#define  HDMI_TMDS_OUTCTL_get_aoe(data)                                          ((0x00000200&(data))>>9)
#define  HDMI_TMDS_OUTCTL_get_trcoe(data)                                        ((0x00000100&(data))>>8)
#define  HDMI_TMDS_OUTCTL_get_tgcoe(data)                                        ((0x00000080&(data))>>7)
#define  HDMI_TMDS_OUTCTL_get_tbcoe(data)                                        ((0x00000040&(data))>>6)
#define  HDMI_TMDS_OUTCTL_get_ocke(data)                                         ((0x00000020&(data))>>5)
#define  HDMI_TMDS_OUTCTL_get_ockie(data)                                        ((0x00000010&(data))>>4)
/*
#define  HDMI_TMDS_OUTCTL_get_dummy(data)                                        ((0x00000008&(data))>>3)
#define  HDMI_TMDS_OUTCTL_get_dummy(data)                                        ((0x00000004&(data))>>2)
#define  HDMI_TMDS_OUTCTL_get_dummy(data)                                        ((0x00000002&(data))>>1)
#define  HDMI_TMDS_OUTCTL_get_dummy(data)                                        (0x00000001&(data))
*/

#define  HDMI_TMDS_PWDCTL                                                        0x1800D01C
#define  HDMI_TMDS_PWDCTL_reg_addr                                               "0xB800D01C"
#define  HDMI_TMDS_PWDCTL_reg                                                    0xB800D01C
#define  HDMI_TMDS_PWDCTL_inst_addr                                              "0x0007"
#define  set_HDMI_TMDS_PWDCTL_reg(data)                                          (*((volatile unsigned int*)HDMI_TMDS_PWDCTL_reg)=data)
#define  get_HDMI_TMDS_PWDCTL_reg                                                (*((volatile unsigned int*)HDMI_TMDS_PWDCTL_reg))
#define  HDMI_TMDS_PWDCTL_ecc_r_shift                                            (31)
#define  HDMI_TMDS_PWDCTL_erip_r_shift                                           (30)
#define  HDMI_TMDS_PWDCTL_egip_r_shift                                           (29)
#define  HDMI_TMDS_PWDCTL_ebip_r_shift                                           (28)
#define  HDMI_TMDS_PWDCTL_dummy_shift                                            (10)
#define  HDMI_TMDS_PWDCTL_video_preamble_off_en_shift                            (9)
#define  HDMI_TMDS_PWDCTL_hs_width_sel_shift                                     (8)
#define  HDMI_TMDS_PWDCTL_deo_shift                                              (7)
#define  HDMI_TMDS_PWDCTL_brcw_shift                                             (6)
#define  HDMI_TMDS_PWDCTL_pnsw_shift                                             (5)
#define  HDMI_TMDS_PWDCTL_iccaf_shift                                            (4)
#define  HDMI_TMDS_PWDCTL_ecc_shift                                              (3)
#define  HDMI_TMDS_PWDCTL_erip_shift                                             (2)
#define  HDMI_TMDS_PWDCTL_egip_shift                                             (1)
#define  HDMI_TMDS_PWDCTL_ebip_shift                                             (0)
#define  HDMI_TMDS_PWDCTL_ecc_r_mask                                             (0x80000000)
#define  HDMI_TMDS_PWDCTL_erip_r_mask                                            (0x40000000)
#define  HDMI_TMDS_PWDCTL_egip_r_mask                                            (0x20000000)
#define  HDMI_TMDS_PWDCTL_ebip_r_mask                                            (0x10000000)
#define  HDMI_TMDS_PWDCTL_dummy_mask                                             (0x0FFFFC00)
#define  HDMI_TMDS_PWDCTL_video_preamble_off_en_mask                             (0x00000200)
#define  HDMI_TMDS_PWDCTL_hs_width_sel_mask                                      (0x00000100)
#define  HDMI_TMDS_PWDCTL_deo_mask                                               (0x00000080)
#define  HDMI_TMDS_PWDCTL_brcw_mask                                              (0x00000040)
#define  HDMI_TMDS_PWDCTL_pnsw_mask                                              (0x00000020)
#define  HDMI_TMDS_PWDCTL_iccaf_mask                                             (0x00000010)
#define  HDMI_TMDS_PWDCTL_ecc_mask                                               (0x00000008)
#define  HDMI_TMDS_PWDCTL_erip_mask                                              (0x00000004)
#define  HDMI_TMDS_PWDCTL_egip_mask                                              (0x00000002)
#define  HDMI_TMDS_PWDCTL_ebip_mask                                              (0x00000001)
#define  HDMI_TMDS_PWDCTL_ecc_r(data)                                            (0x80000000&((data)<<31))
#define  HDMI_TMDS_PWDCTL_erip_r(data)                                           (0x40000000&((data)<<30))
#define  HDMI_TMDS_PWDCTL_egip_r(data)                                           (0x20000000&((data)<<29))
#define  HDMI_TMDS_PWDCTL_ebip_r(data)                                           (0x10000000&((data)<<28))
#define  HDMI_TMDS_PWDCTL_dummy(data)                                            (0x0FFFFC00&((data)<<10))
#define  HDMI_TMDS_PWDCTL_video_preamble_off_en(data)                            (0x00000200&((data)<<9))
#define  HDMI_TMDS_PWDCTL_hs_width_sel(data)                                     (0x00000100&((data)<<8))
#define  HDMI_TMDS_PWDCTL_deo(data)                                              (0x00000080&((data)<<7))
#define  HDMI_TMDS_PWDCTL_brcw(data)                                             (0x00000040&((data)<<6))
#define  HDMI_TMDS_PWDCTL_pnsw(data)                                             (0x00000020&((data)<<5))
#define  HDMI_TMDS_PWDCTL_iccaf(data)                                            (0x00000010&((data)<<4))
#define  HDMI_TMDS_PWDCTL_ecc(data)                                              (0x00000008&((data)<<3))
#define  HDMI_TMDS_PWDCTL_erip(data)                                             (0x00000004&((data)<<2))
#define  HDMI_TMDS_PWDCTL_egip(data)                                             (0x00000002&((data)<<1))
#define  HDMI_TMDS_PWDCTL_ebip(data)                                             (0x00000001&(data))
#define  HDMI_TMDS_PWDCTL_get_ecc_r(data)                                        ((0x80000000&(data))>>31)
#define  HDMI_TMDS_PWDCTL_get_erip_r(data)                                       ((0x40000000&(data))>>30)
#define  HDMI_TMDS_PWDCTL_get_egip_r(data)                                       ((0x20000000&(data))>>29)
#define  HDMI_TMDS_PWDCTL_get_ebip_r(data)                                       ((0x10000000&(data))>>28)
#define  HDMI_TMDS_PWDCTL_get_dummy(data)                                        ((0x0FFFFC00&(data))>>10)
#define  HDMI_TMDS_PWDCTL_get_video_preamble_off_en(data)                        ((0x00000200&(data))>>9)
#define  HDMI_TMDS_PWDCTL_get_hs_width_sel(data)                                 ((0x00000100&(data))>>8)
#define  HDMI_TMDS_PWDCTL_get_deo(data)                                          ((0x00000080&(data))>>7)
#define  HDMI_TMDS_PWDCTL_get_brcw(data)                                         ((0x00000040&(data))>>6)
#define  HDMI_TMDS_PWDCTL_get_pnsw(data)                                         ((0x00000020&(data))>>5)
#define  HDMI_TMDS_PWDCTL_get_iccaf(data)                                        ((0x00000010&(data))>>4)
#define  HDMI_TMDS_PWDCTL_get_ecc(data)                                          ((0x00000008&(data))>>3)
#define  HDMI_TMDS_PWDCTL_get_erip(data)                                         ((0x00000004&(data))>>2)
#define  HDMI_TMDS_PWDCTL_get_egip(data)                                         ((0x00000002&(data))>>1)
#define  HDMI_TMDS_PWDCTL_get_ebip(data)                                         (0x00000001&(data))

#define  HDMI_TMDS_Z0CC                                                          0x1800D020
#define  HDMI_TMDS_Z0CC_reg_addr                                                 "0xB800D020"
#define  HDMI_TMDS_Z0CC_reg                                                      0xB800D020
#define  HDMI_TMDS_Z0CC_inst_addr                                                "0x0008"
#define  set_HDMI_TMDS_Z0CC_reg(data)                                            (*((volatile unsigned int*)HDMI_TMDS_Z0CC_reg)=data)
#define  get_HDMI_TMDS_Z0CC_reg                                                  (*((volatile unsigned int*)HDMI_TMDS_Z0CC_reg))
#define  HDMI_TMDS_Z0CC_hde_shift                                                (0)
#define  HDMI_TMDS_Z0CC_hde_mask                                                 (0x00000001)
#define  HDMI_TMDS_Z0CC_hde(data)                                                (0x00000001&(data))
#define  HDMI_TMDS_Z0CC_get_hde(data)                                            (0x00000001&(data))

#define  HDMI_TMDS_CPS                                                           0x1800D024
#define  HDMI_TMDS_CPS_reg_addr                                                  "0xB800D024"
#define  HDMI_TMDS_CPS_reg                                                       0xB800D024
#define  HDMI_TMDS_CPS_inst_addr                                                 "0x0009"
#define  set_HDMI_TMDS_CPS_reg(data)                                             (*((volatile unsigned int*)HDMI_TMDS_CPS_reg)=data)
#define  get_HDMI_TMDS_CPS_reg                                                   (*((volatile unsigned int*)HDMI_TMDS_CPS_reg))
#define  HDMI_TMDS_CPS_pll_div2_en_shift                                         (9)
#define  HDMI_TMDS_CPS_no_clk_in_shift                                           (8)
#define  HDMI_TMDS_CPS_clkv_meas_sel_shift                                       (6)
#define  HDMI_TMDS_CPS_de_inv_disable_shift                                      (5)
#define  HDMI_TMDS_CPS_de_err_pulse_en_shift                                     (4)
#define  HDMI_TMDS_CPS_clr_infoframe_dvi_shift                                   (3)
#define  HDMI_TMDS_CPS_auto_dvi2hdmi_shift                                       (2)
#define  HDMI_TMDS_CPS_dummy_shift                                               (0)
#define  HDMI_TMDS_CPS_pll_div2_en_mask                                          (0x00000200)
#define  HDMI_TMDS_CPS_no_clk_in_mask                                            (0x00000100)
#define  HDMI_TMDS_CPS_clkv_meas_sel_mask                                        (0x000000C0)
#define  HDMI_TMDS_CPS_de_inv_disable_mask                                       (0x00000020)
#define  HDMI_TMDS_CPS_de_err_pulse_en_mask                                      (0x00000010)
#define  HDMI_TMDS_CPS_clr_infoframe_dvi_mask                                    (0x00000008)
#define  HDMI_TMDS_CPS_auto_dvi2hdmi_mask                                        (0x00000004)
#define  HDMI_TMDS_CPS_dummy_mask                                                (0x00000003)
#define  HDMI_TMDS_CPS_pll_div2_en(data)                                         (0x00000200&((data)<<9))
#define  HDMI_TMDS_CPS_no_clk_in(data)                                           (0x00000100&((data)<<8))
#define  HDMI_TMDS_CPS_clkv_meas_sel(data)                                       (0x000000C0&((data)<<6))
#define  HDMI_TMDS_CPS_de_inv_disable(data)                                      (0x00000020&((data)<<5))
#define  HDMI_TMDS_CPS_de_err_pulse_en(data)                                     (0x00000010&((data)<<4))
#define  HDMI_TMDS_CPS_clr_infoframe_dvi(data)                                   (0x00000008&((data)<<3))
#define  HDMI_TMDS_CPS_auto_dvi2hdmi(data)                                       (0x00000004&((data)<<2))
#define  HDMI_TMDS_CPS_dummy(data)                                               (0x00000003&(data))
#define  HDMI_TMDS_CPS_get_pll_div2_en(data)                                     ((0x00000200&(data))>>9)
#define  HDMI_TMDS_CPS_get_no_clk_in(data)                                       ((0x00000100&(data))>>8)
#define  HDMI_TMDS_CPS_get_clkv_meas_sel(data)                                   ((0x000000C0&(data))>>6)
#define  HDMI_TMDS_CPS_get_de_inv_disable(data)                                  ((0x00000020&(data))>>5)
#define  HDMI_TMDS_CPS_get_de_err_pulse_en(data)                                 ((0x00000010&(data))>>4)
#define  HDMI_TMDS_CPS_get_clr_infoframe_dvi(data)                               ((0x00000008&(data))>>3)
#define  HDMI_TMDS_CPS_get_auto_dvi2hdmi(data)                                   ((0x00000004&(data))>>2)
#define  HDMI_TMDS_CPS_get_dummy(data)                                           (0x00000003&(data))

#define  HDMI_TMDS_UDC                                                           0x1800D028
#define  HDMI_TMDS_UDC_reg_addr                                                  "0xB800D028"
#define  HDMI_TMDS_UDC_reg                                                       0xB800D028
#define  HDMI_TMDS_UDC_inst_addr                                                 "0x000A"
#define  set_HDMI_TMDS_UDC_reg(data)                                             (*((volatile unsigned int*)HDMI_TMDS_UDC_reg)=data)
#define  get_HDMI_TMDS_UDC_reg                                                   (*((volatile unsigned int*)HDMI_TMDS_UDC_reg))
#define  HDMI_TMDS_UDC_debug_sel_shift                                           (4)
#define  HDMI_TMDS_UDC_dummy_shift                                               (3)
#define  HDMI_TMDS_UDC_cptest_shift                                              (2)
#define  HDMI_TMDS_UDC_hmtm_shift                                                (0)
#define  HDMI_TMDS_UDC_debug_sel_mask                                            (0x000003F0)
#define  HDMI_TMDS_UDC_dummy_mask                                                (0x00000008)
#define  HDMI_TMDS_UDC_cptest_mask                                               (0x00000004)
#define  HDMI_TMDS_UDC_hmtm_mask                                                 (0x00000003)
#define  HDMI_TMDS_UDC_debug_sel(data)                                           (0x000003F0&((data)<<4))
#define  HDMI_TMDS_UDC_dummy(data)                                               (0x00000008&((data)<<3))
#define  HDMI_TMDS_UDC_cptest(data)                                              (0x00000004&((data)<<2))
#define  HDMI_TMDS_UDC_hmtm(data)                                                (0x00000003&(data))
#define  HDMI_TMDS_UDC_get_debug_sel(data)                                       ((0x000003F0&(data))>>4)
#define  HDMI_TMDS_UDC_get_dummy(data)                                           ((0x00000008&(data))>>3)
#define  HDMI_TMDS_UDC_get_cptest(data)                                          ((0x00000004&(data))>>2)
#define  HDMI_TMDS_UDC_get_hmtm(data)                                            (0x00000003&(data))

#define  HDMI_TMDS_ERRC                                                          0x1800D02C
#define  HDMI_TMDS_ERRC_reg_addr                                                 "0xB800D02C"
#define  HDMI_TMDS_ERRC_reg                                                      0xB800D02C
#define  HDMI_TMDS_ERRC_inst_addr                                                "0x000B"
#define  set_HDMI_TMDS_ERRC_reg(data)                                            (*((volatile unsigned int*)HDMI_TMDS_ERRC_reg)=data)
#define  get_HDMI_TMDS_ERRC_reg                                                  (*((volatile unsigned int*)HDMI_TMDS_ERRC_reg))
#define  HDMI_TMDS_ERRC_nl_shift                                                 (0)
#define  HDMI_TMDS_ERRC_nl_mask                                                  (0x00000007)
#define  HDMI_TMDS_ERRC_nl(data)                                                 (0x00000007&(data))
#define  HDMI_TMDS_ERRC_get_nl(data)                                             (0x00000007&(data))

#define  HDMI_TMDS_OUT_CTRL                                                      0x1800D030
#define  HDMI_TMDS_OUT_CTRL_reg_addr                                             "0xB800D030"
#define  HDMI_TMDS_OUT_CTRL_reg                                                  0xB800D030
#define  HDMI_TMDS_OUT_CTRL_inst_addr                                            "0x000C"
#define  set_HDMI_TMDS_OUT_CTRL_reg(data)                                        (*((volatile unsigned int*)HDMI_TMDS_OUT_CTRL_reg)=data)
#define  get_HDMI_TMDS_OUT_CTRL_reg                                              (*((volatile unsigned int*)HDMI_TMDS_OUT_CTRL_reg))
#define  HDMI_TMDS_OUT_CTRL_tmds_bypass_shift                                    (7)
#define  HDMI_TMDS_OUT_CTRL_dummy_shift                                          (0)
#define  HDMI_TMDS_OUT_CTRL_tmds_bypass_mask                                     (0x00000080)
#define  HDMI_TMDS_OUT_CTRL_dummy_mask                                           (0x0000007F)
#define  HDMI_TMDS_OUT_CTRL_tmds_bypass(data)                                    (0x00000080&((data)<<7))
#define  HDMI_TMDS_OUT_CTRL_dummy(data)                                          (0x0000007F&(data))
#define  HDMI_TMDS_OUT_CTRL_get_tmds_bypass(data)                                ((0x00000080&(data))>>7)
#define  HDMI_TMDS_OUT_CTRL_get_dummy(data)                                      (0x0000007F&(data))

#define  HDMI_TMDS_ROUT                                                          0x1800D034
#define  HDMI_TMDS_ROUT_reg_addr                                                 "0xB800D034"
#define  HDMI_TMDS_ROUT_reg                                                      0xB800D034
#define  HDMI_TMDS_ROUT_inst_addr                                                "0x000D"
#define  set_HDMI_TMDS_ROUT_reg(data)                                            (*((volatile unsigned int*)HDMI_TMDS_ROUT_reg)=data)
#define  get_HDMI_TMDS_ROUT_reg                                                  (*((volatile unsigned int*)HDMI_TMDS_ROUT_reg))
#define  HDMI_TMDS_ROUT_tmds_rout_h_shift                                        (8)
#define  HDMI_TMDS_ROUT_tmds_rout_l_shift                                        (0)
#define  HDMI_TMDS_ROUT_tmds_rout_h_mask                                         (0x0000FF00)
#define  HDMI_TMDS_ROUT_tmds_rout_l_mask                                         (0x000000FF)
#define  HDMI_TMDS_ROUT_tmds_rout_h(data)                                        (0x0000FF00&((data)<<8))
#define  HDMI_TMDS_ROUT_tmds_rout_l(data)                                        (0x000000FF&(data))
#define  HDMI_TMDS_ROUT_get_tmds_rout_h(data)                                    ((0x0000FF00&(data))>>8)
#define  HDMI_TMDS_ROUT_get_tmds_rout_l(data)                                    (0x000000FF&(data))

#define  HDMI_TMDS_GOUT                                                          0x1800D038
#define  HDMI_TMDS_GOUT_reg_addr                                                 "0xB800D038"
#define  HDMI_TMDS_GOUT_reg                                                      0xB800D038
#define  HDMI_TMDS_GOUT_inst_addr                                                "0x000E"
#define  set_HDMI_TMDS_GOUT_reg(data)                                            (*((volatile unsigned int*)HDMI_TMDS_GOUT_reg)=data)
#define  get_HDMI_TMDS_GOUT_reg                                                  (*((volatile unsigned int*)HDMI_TMDS_GOUT_reg))
#define  HDMI_TMDS_GOUT_tmds_gout_h_shift                                        (8)
#define  HDMI_TMDS_GOUT_tmds_gout_l_shift                                        (0)
#define  HDMI_TMDS_GOUT_tmds_gout_h_mask                                         (0x0000FF00)
#define  HDMI_TMDS_GOUT_tmds_gout_l_mask                                         (0x000000FF)
#define  HDMI_TMDS_GOUT_tmds_gout_h(data)                                        (0x0000FF00&((data)<<8))
#define  HDMI_TMDS_GOUT_tmds_gout_l(data)                                        (0x000000FF&(data))
#define  HDMI_TMDS_GOUT_get_tmds_gout_h(data)                                    ((0x0000FF00&(data))>>8)
#define  HDMI_TMDS_GOUT_get_tmds_gout_l(data)                                    (0x000000FF&(data))

#define  HDMI_TMDS_BOUT                                                          0x1800D03C
#define  HDMI_TMDS_BOUT_reg_addr                                                 "0xB800D03C"
#define  HDMI_TMDS_BOUT_reg                                                      0xB800D03C
#define  HDMI_TMDS_BOUT_inst_addr                                                "0x000F"
#define  set_HDMI_TMDS_BOUT_reg(data)                                            (*((volatile unsigned int*)HDMI_TMDS_BOUT_reg)=data)
#define  get_HDMI_TMDS_BOUT_reg                                                  (*((volatile unsigned int*)HDMI_TMDS_BOUT_reg))
#define  HDMI_TMDS_BOUT_tmds_bout_h_shift                                        (8)
#define  HDMI_TMDS_BOUT_tmds_bout_l_shift                                        (0)
#define  HDMI_TMDS_BOUT_tmds_bout_h_mask                                         (0x0000FF00)
#define  HDMI_TMDS_BOUT_tmds_bout_l_mask                                         (0x000000FF)
#define  HDMI_TMDS_BOUT_tmds_bout_h(data)                                        (0x0000FF00&((data)<<8))
#define  HDMI_TMDS_BOUT_tmds_bout_l(data)                                        (0x000000FF&(data))
#define  HDMI_TMDS_BOUT_get_tmds_bout_h(data)                                    ((0x0000FF00&(data))>>8)
#define  HDMI_TMDS_BOUT_get_tmds_bout_l(data)                                    (0x000000FF&(data))

#define  HDMI_TMDS_DPC0                                                          0x1800D040
#define  HDMI_TMDS_DPC0_reg_addr                                                 "0xB800D040"
#define  HDMI_TMDS_DPC0_reg                                                      0xB800D040
#define  HDMI_TMDS_DPC0_inst_addr                                                "0x0010"
#define  set_HDMI_TMDS_DPC0_reg(data)                                            (*((volatile unsigned int*)HDMI_TMDS_DPC0_reg)=data)
#define  get_HDMI_TMDS_DPC0_reg                                                  (*((volatile unsigned int*)HDMI_TMDS_DPC0_reg))
#define  HDMI_TMDS_DPC0_dpc_pp_valid_shift                                       (9)
#define  HDMI_TMDS_DPC0_dpc_default_ph_shift                                     (8)
#define  HDMI_TMDS_DPC0_dpc_pp_shift                                             (4)
#define  HDMI_TMDS_DPC0_dpc_cd_shift                                             (0)
#define  HDMI_TMDS_DPC0_dpc_pp_valid_mask                                        (0x00000200)
#define  HDMI_TMDS_DPC0_dpc_default_ph_mask                                      (0x00000100)
#define  HDMI_TMDS_DPC0_dpc_pp_mask                                              (0x000000F0)
#define  HDMI_TMDS_DPC0_dpc_cd_mask                                              (0x0000000F)
#define  HDMI_TMDS_DPC0_dpc_pp_valid(data)                                       (0x00000200&((data)<<9))
#define  HDMI_TMDS_DPC0_dpc_default_ph(data)                                     (0x00000100&((data)<<8))
#define  HDMI_TMDS_DPC0_dpc_pp(data)                                             (0x000000F0&((data)<<4))
#define  HDMI_TMDS_DPC0_dpc_cd(data)                                             (0x0000000F&(data))
#define  HDMI_TMDS_DPC0_get_dpc_pp_valid(data)                                   ((0x00000200&(data))>>9)
#define  HDMI_TMDS_DPC0_get_dpc_default_ph(data)                                 ((0x00000100&(data))>>8)
#define  HDMI_TMDS_DPC0_get_dpc_pp(data)                                         ((0x000000F0&(data))>>4)
#define  HDMI_TMDS_DPC0_get_dpc_cd(data)                                         (0x0000000F&(data))

#define  HDMI_TMDS_DPC1                                                          0x1800D044
#define  HDMI_TMDS_DPC1_reg_addr                                                 "0xB800D044"
#define  HDMI_TMDS_DPC1_reg                                                      0xB800D044
#define  HDMI_TMDS_DPC1_inst_addr                                                "0x0011"
#define  set_HDMI_TMDS_DPC1_reg(data)                                            (*((volatile unsigned int*)HDMI_TMDS_DPC1_reg)=data)
#define  get_HDMI_TMDS_DPC1_reg                                                  (*((volatile unsigned int*)HDMI_TMDS_DPC1_reg))
#define  HDMI_TMDS_DPC1_dpc_cd_chg_flag_shift                                    (18)
#define  HDMI_TMDS_DPC1_dpc_cd_chg_wd_en_shift                                   (17)
#define  HDMI_TMDS_DPC1_dpc_cd_chg_int_en_shift                                  (16)
#define  HDMI_TMDS_DPC1_dummy_shift                                              (11)
#define  HDMI_TMDS_DPC1_dpc_auto_shift                                           (10)
#define  HDMI_TMDS_DPC1_dpc_pp_valid_fw_shift                                    (9)
#define  HDMI_TMDS_DPC1_dpc_default_ph_fw_shift                                  (8)
#define  HDMI_TMDS_DPC1_dpc_pp_fw_shift                                          (4)
#define  HDMI_TMDS_DPC1_dpc_cd_fw_shift                                          (0)
#define  HDMI_TMDS_DPC1_dpc_cd_chg_flag_mask                                     (0x00040000)
#define  HDMI_TMDS_DPC1_dpc_cd_chg_wd_en_mask                                    (0x00020000)
#define  HDMI_TMDS_DPC1_dpc_cd_chg_int_en_mask                                   (0x00010000)
#define  HDMI_TMDS_DPC1_dummy_mask                                               (0x0000F800)
#define  HDMI_TMDS_DPC1_dpc_auto_mask                                            (0x00000400)
#define  HDMI_TMDS_DPC1_dpc_pp_valid_fw_mask                                     (0x00000200)
#define  HDMI_TMDS_DPC1_dpc_default_ph_fw_mask                                   (0x00000100)
#define  HDMI_TMDS_DPC1_dpc_pp_fw_mask                                           (0x000000F0)
#define  HDMI_TMDS_DPC1_dpc_cd_fw_mask                                           (0x0000000F)
#define  HDMI_TMDS_DPC1_dpc_cd_chg_flag(data)                                    (0x00040000&((data)<<18))
#define  HDMI_TMDS_DPC1_dpc_cd_chg_wd_en(data)                                   (0x00020000&((data)<<17))
#define  HDMI_TMDS_DPC1_dpc_cd_chg_int_en(data)                                  (0x00010000&((data)<<16))
#define  HDMI_TMDS_DPC1_dummy(data)                                              (0x0000F800&((data)<<11))
#define  HDMI_TMDS_DPC1_dpc_auto(data)                                           (0x00000400&((data)<<10))
#define  HDMI_TMDS_DPC1_dpc_pp_valid_fw(data)                                    (0x00000200&((data)<<9))
#define  HDMI_TMDS_DPC1_dpc_default_ph_fw(data)                                  (0x00000100&((data)<<8))
#define  HDMI_TMDS_DPC1_dpc_pp_fw(data)                                          (0x000000F0&((data)<<4))
#define  HDMI_TMDS_DPC1_dpc_cd_fw(data)                                          (0x0000000F&(data))
#define  HDMI_TMDS_DPC1_get_dpc_cd_chg_flag(data)                                ((0x00040000&(data))>>18)
#define  HDMI_TMDS_DPC1_get_dpc_cd_chg_wd_en(data)                               ((0x00020000&(data))>>17)
#define  HDMI_TMDS_DPC1_get_dpc_cd_chg_int_en(data)                              ((0x00010000&(data))>>16)
#define  HDMI_TMDS_DPC1_get_dummy(data)                                          ((0x0000F800&(data))>>11)
#define  HDMI_TMDS_DPC1_get_dpc_auto(data)                                       ((0x00000400&(data))>>10)
#define  HDMI_TMDS_DPC1_get_dpc_pp_valid_fw(data)                                ((0x00000200&(data))>>9)
#define  HDMI_TMDS_DPC1_get_dpc_default_ph_fw(data)                              ((0x00000100&(data))>>8)
#define  HDMI_TMDS_DPC1_get_dpc_pp_fw(data)                                      ((0x000000F0&(data))>>4)
#define  HDMI_TMDS_DPC1_get_dpc_cd_fw(data)                                      (0x0000000F&(data))

#define  HDMI_TMDS_DPC_SET0                                                      0x1800D048
#define  HDMI_TMDS_DPC_SET0_reg_addr                                             "0xB800D048"
#define  HDMI_TMDS_DPC_SET0_reg                                                  0xB800D048
#define  HDMI_TMDS_DPC_SET0_inst_addr                                            "0x0012"
#define  set_HDMI_TMDS_DPC_SET0_reg(data)                                        (*((volatile unsigned int*)HDMI_TMDS_DPC_SET0_reg)=data)
#define  get_HDMI_TMDS_DPC_SET0_reg                                              (*((volatile unsigned int*)HDMI_TMDS_DPC_SET0_reg))
#define  HDMI_TMDS_DPC_SET0_dpc_bypass_dis_shift                                 (8)
#define  HDMI_TMDS_DPC_SET0_dpc_en_shift                                         (7)
#define  HDMI_TMDS_DPC_SET0_phase_errcnt_in_shift                                (4)
#define  HDMI_TMDS_DPC_SET0_phase_clrcnt_in_shift                                (1)
#define  HDMI_TMDS_DPC_SET0_phase_clr_sel_shift                                  (0)
#define  HDMI_TMDS_DPC_SET0_dpc_bypass_dis_mask                                  (0x00000100)
#define  HDMI_TMDS_DPC_SET0_dpc_en_mask                                          (0x00000080)
#define  HDMI_TMDS_DPC_SET0_phase_errcnt_in_mask                                 (0x00000070)
#define  HDMI_TMDS_DPC_SET0_phase_clrcnt_in_mask                                 (0x0000000E)
#define  HDMI_TMDS_DPC_SET0_phase_clr_sel_mask                                   (0x00000001)
#define  HDMI_TMDS_DPC_SET0_dpc_bypass_dis(data)                                 (0x00000100&((data)<<8))
#define  HDMI_TMDS_DPC_SET0_dpc_en(data)                                         (0x00000080&((data)<<7))
#define  HDMI_TMDS_DPC_SET0_phase_errcnt_in(data)                                (0x00000070&((data)<<4))
#define  HDMI_TMDS_DPC_SET0_phase_clrcnt_in(data)                                (0x0000000E&((data)<<1))
#define  HDMI_TMDS_DPC_SET0_phase_clr_sel(data)                                  (0x00000001&(data))
#define  HDMI_TMDS_DPC_SET0_get_dpc_bypass_dis(data)                             ((0x00000100&(data))>>8)
#define  HDMI_TMDS_DPC_SET0_get_dpc_en(data)                                     ((0x00000080&(data))>>7)
#define  HDMI_TMDS_DPC_SET0_get_phase_errcnt_in(data)                            ((0x00000070&(data))>>4)
#define  HDMI_TMDS_DPC_SET0_get_phase_clrcnt_in(data)                            ((0x0000000E&(data))>>1)
#define  HDMI_TMDS_DPC_SET0_get_phase_clr_sel(data)                              (0x00000001&(data))

#define  HDMI_TMDS_DPC_SET1                                                      0x1800D04C
#define  HDMI_TMDS_DPC_SET1_reg_addr                                             "0xB800D04C"
#define  HDMI_TMDS_DPC_SET1_reg                                                  0xB800D04C
#define  HDMI_TMDS_DPC_SET1_inst_addr                                            "0x0013"
#define  set_HDMI_TMDS_DPC_SET1_reg(data)                                        (*((volatile unsigned int*)HDMI_TMDS_DPC_SET1_reg)=data)
#define  get_HDMI_TMDS_DPC_SET1_reg                                              (*((volatile unsigned int*)HDMI_TMDS_DPC_SET1_reg))
#define  HDMI_TMDS_DPC_SET1_set_full_noti_shift                                  (4)
#define  HDMI_TMDS_DPC_SET1_set_empty_noti_shift                                 (0)
#define  HDMI_TMDS_DPC_SET1_set_full_noti_mask                                   (0x000000F0)
#define  HDMI_TMDS_DPC_SET1_set_empty_noti_mask                                  (0x0000000F)
#define  HDMI_TMDS_DPC_SET1_set_full_noti(data)                                  (0x000000F0&((data)<<4))
#define  HDMI_TMDS_DPC_SET1_set_empty_noti(data)                                 (0x0000000F&(data))
#define  HDMI_TMDS_DPC_SET1_get_set_full_noti(data)                              ((0x000000F0&(data))>>4)
#define  HDMI_TMDS_DPC_SET1_get_set_empty_noti(data)                             (0x0000000F&(data))

#define  HDMI_TMDS_DPC_SET2                                                      0x1800D050
#define  HDMI_TMDS_DPC_SET2_reg_addr                                             "0xB800D050"
#define  HDMI_TMDS_DPC_SET2_reg                                                  0xB800D050
#define  HDMI_TMDS_DPC_SET2_inst_addr                                            "0x0014"
#define  set_HDMI_TMDS_DPC_SET2_reg(data)                                        (*((volatile unsigned int*)HDMI_TMDS_DPC_SET2_reg)=data)
#define  get_HDMI_TMDS_DPC_SET2_reg                                              (*((volatile unsigned int*)HDMI_TMDS_DPC_SET2_reg))
#define  HDMI_TMDS_DPC_SET2_fifo_errcnt_in_shift                                 (5)
#define  HDMI_TMDS_DPC_SET2_clr_phase_flag_shift                                 (4)
#define  HDMI_TMDS_DPC_SET2_clr_fifo_flag_shift                                  (3)
#define  HDMI_TMDS_DPC_SET2_dpc_phase_ok_shift                                   (2)
#define  HDMI_TMDS_DPC_SET2_dpc_phase_err_flag_shift                             (1)
#define  HDMI_TMDS_DPC_SET2_dpc_fifo_err_flag_shift                              (0)
#define  HDMI_TMDS_DPC_SET2_fifo_errcnt_in_mask                                  (0x000000E0)
#define  HDMI_TMDS_DPC_SET2_clr_phase_flag_mask                                  (0x00000010)
#define  HDMI_TMDS_DPC_SET2_clr_fifo_flag_mask                                   (0x00000008)
#define  HDMI_TMDS_DPC_SET2_dpc_phase_ok_mask                                    (0x00000004)
#define  HDMI_TMDS_DPC_SET2_dpc_phase_err_flag_mask                              (0x00000002)
#define  HDMI_TMDS_DPC_SET2_dpc_fifo_err_flag_mask                               (0x00000001)
#define  HDMI_TMDS_DPC_SET2_fifo_errcnt_in(data)                                 (0x000000E0&((data)<<5))
#define  HDMI_TMDS_DPC_SET2_clr_phase_flag(data)                                 (0x00000010&((data)<<4))
#define  HDMI_TMDS_DPC_SET2_clr_fifo_flag(data)                                  (0x00000008&((data)<<3))
#define  HDMI_TMDS_DPC_SET2_dpc_phase_ok(data)                                   (0x00000004&((data)<<2))
#define  HDMI_TMDS_DPC_SET2_dpc_phase_err_flag(data)                             (0x00000002&((data)<<1))
#define  HDMI_TMDS_DPC_SET2_dpc_fifo_err_flag(data)                              (0x00000001&(data))
#define  HDMI_TMDS_DPC_SET2_get_fifo_errcnt_in(data)                             ((0x000000E0&(data))>>5)
#define  HDMI_TMDS_DPC_SET2_get_clr_phase_flag(data)                             ((0x00000010&(data))>>4)
#define  HDMI_TMDS_DPC_SET2_get_clr_fifo_flag(data)                              ((0x00000008&(data))>>3)
#define  HDMI_TMDS_DPC_SET2_get_dpc_phase_ok(data)                               ((0x00000004&(data))>>2)
#define  HDMI_TMDS_DPC_SET2_get_dpc_phase_err_flag(data)                         ((0x00000002&(data))>>1)
#define  HDMI_TMDS_DPC_SET2_get_dpc_fifo_err_flag(data)                          (0x00000001&(data))

#define  HDMI_TMDS_DPC_SET3                                                      0x1800D054
#define  HDMI_TMDS_DPC_SET3_reg_addr                                             "0xB800D054"
#define  HDMI_TMDS_DPC_SET3_reg                                                  0xB800D054
#define  HDMI_TMDS_DPC_SET3_inst_addr                                            "0x0015"
#define  set_HDMI_TMDS_DPC_SET3_reg(data)                                        (*((volatile unsigned int*)HDMI_TMDS_DPC_SET3_reg)=data)
#define  get_HDMI_TMDS_DPC_SET3_reg                                              (*((volatile unsigned int*)HDMI_TMDS_DPC_SET3_reg))
#define  HDMI_TMDS_DPC_SET3_dpc_fifo_over_flag_shift                             (7)
#define  HDMI_TMDS_DPC_SET3_dpc_fifo_under_flag_shift                            (6)
#define  HDMI_TMDS_DPC_SET3_dpc_fifo_over_xflag_shift                            (5)
#define  HDMI_TMDS_DPC_SET3_dpc_fifo_under_xflag_shift                           (4)
#define  HDMI_TMDS_DPC_SET3_dpc_fifo_over_flag_mask                              (0x00000080)
#define  HDMI_TMDS_DPC_SET3_dpc_fifo_under_flag_mask                             (0x00000040)
#define  HDMI_TMDS_DPC_SET3_dpc_fifo_over_xflag_mask                             (0x00000020)
#define  HDMI_TMDS_DPC_SET3_dpc_fifo_under_xflag_mask                            (0x00000010)
#define  HDMI_TMDS_DPC_SET3_dpc_fifo_over_flag(data)                             (0x00000080&((data)<<7))
#define  HDMI_TMDS_DPC_SET3_dpc_fifo_under_flag(data)                            (0x00000040&((data)<<6))
#define  HDMI_TMDS_DPC_SET3_dpc_fifo_over_xflag(data)                            (0x00000020&((data)<<5))
#define  HDMI_TMDS_DPC_SET3_dpc_fifo_under_xflag(data)                           (0x00000010&((data)<<4))
#define  HDMI_TMDS_DPC_SET3_get_dpc_fifo_over_flag(data)                         ((0x00000080&(data))>>7)
#define  HDMI_TMDS_DPC_SET3_get_dpc_fifo_under_flag(data)                        ((0x00000040&(data))>>6)
#define  HDMI_TMDS_DPC_SET3_get_dpc_fifo_over_xflag(data)                        ((0x00000020&(data))>>5)
#define  HDMI_TMDS_DPC_SET3_get_dpc_fifo_under_xflag(data)                       ((0x00000010&(data))>>4)

#define  HDMI_TMDS_DET_CTL                                                       0x1800D058
#define  HDMI_TMDS_DET_CTL_reg_addr                                              "0xB800D058"
#define  HDMI_TMDS_DET_CTL_reg                                                   0xB800D058
#define  HDMI_TMDS_DET_CTL_inst_addr                                             "0x0016"
#define  set_HDMI_TMDS_DET_CTL_reg(data)                                         (*((volatile unsigned int*)HDMI_TMDS_DET_CTL_reg)=data)
#define  get_HDMI_TMDS_DET_CTL_reg                                               (*((volatile unsigned int*)HDMI_TMDS_DET_CTL_reg))
#define  HDMI_TMDS_DET_CTL_de_sel_shift                                          (28)
#define  HDMI_TMDS_DET_CTL_tran_err_thrd_shift                                   (24)
#define  HDMI_TMDS_DET_CTL_neg_de_err_thrd_shift                                 (20)
#define  HDMI_TMDS_DET_CTL_pos_de_err_thrd_shift                                 (16)
//#define  HDMI_TMDS_DET_CTL_dummy_shift                                           (15)
#define  HDMI_TMDS_DET_CTL_neg_de_lowbd_shift                                    (8)
//#define  HDMI_TMDS_DET_CTL_dummy_shift                                           (6)
#define  HDMI_TMDS_DET_CTL_pos_de_lowbd_shift                                    (0)
#define  HDMI_TMDS_DET_CTL_de_sel_mask                                           (0x10000000)
#define  HDMI_TMDS_DET_CTL_tran_err_thrd_mask                                    (0x0F000000)
#define  HDMI_TMDS_DET_CTL_neg_de_err_thrd_mask                                  (0x00F00000)
#define  HDMI_TMDS_DET_CTL_pos_de_err_thrd_mask                                  (0x000F0000)
//#define  HDMI_TMDS_DET_CTL_dummy_mask                                            (0x00008000)
#define  HDMI_TMDS_DET_CTL_neg_de_lowbd_mask                                     (0x00007F00)
//#define  HDMI_TMDS_DET_CTL_dummy_mask                                            (0x000000C0)
#define  HDMI_TMDS_DET_CTL_pos_de_lowbd_mask                                     (0x0000003F)
#define  HDMI_TMDS_DET_CTL_de_sel(data)                                          (0x10000000&((data)<<28))
#define  HDMI_TMDS_DET_CTL_tran_err_thrd(data)                                   (0x0F000000&((data)<<24))
#define  HDMI_TMDS_DET_CTL_neg_de_err_thrd(data)                                 (0x00F00000&((data)<<20))
#define  HDMI_TMDS_DET_CTL_pos_de_err_thrd(data)                                 (0x000F0000&((data)<<16))
//#define  HDMI_TMDS_DET_CTL_dummy(data)                                           (0x00008000&((data)<<15))
#define  HDMI_TMDS_DET_CTL_neg_de_lowbd(data)                                    (0x00007F00&((data)<<8))
//#define  HDMI_TMDS_DET_CTL_dummy(data)                                           (0x000000C0&((data)<<6))
#define  HDMI_TMDS_DET_CTL_pos_de_lowbd(data)                                    (0x0000003F&(data))
#define  HDMI_TMDS_DET_CTL_get_de_sel(data)                                      ((0x10000000&(data))>>28)
#define  HDMI_TMDS_DET_CTL_get_tran_err_thrd(data)                               ((0x0F000000&(data))>>24)
#define  HDMI_TMDS_DET_CTL_get_neg_de_err_thrd(data)                             ((0x00F00000&(data))>>20)
#define  HDMI_TMDS_DET_CTL_get_pos_de_err_thrd(data)                             ((0x000F0000&(data))>>16)
//#define  HDMI_TMDS_DET_CTL_get_dummy(data)                                       ((0x00008000&(data))>>15)
#define  HDMI_TMDS_DET_CTL_get_neg_de_lowbd(data)                                ((0x00007F00&(data))>>8)
//#define  HDMI_TMDS_DET_CTL_get_dummy(data)                                       ((0x000000C0&(data))>>6)
#define  HDMI_TMDS_DET_CTL_get_pos_de_lowbd(data)                                (0x0000003F&(data))

#define  HDMI_TMDS_DET_STS                                                       0x1800D05C
#define  HDMI_TMDS_DET_STS_reg_addr                                              "0xB800D05C"
#define  HDMI_TMDS_DET_STS_reg                                                   0xB800D05C
#define  HDMI_TMDS_DET_STS_inst_addr                                             "0x0017"
#define  set_HDMI_TMDS_DET_STS_reg(data)                                         (*((volatile unsigned int*)HDMI_TMDS_DET_STS_reg)=data)
#define  get_HDMI_TMDS_DET_STS_reg                                               (*((volatile unsigned int*)HDMI_TMDS_DET_STS_reg))
#define  HDMI_TMDS_DET_STS_red_tran_err_flag_shift                               (8)
#define  HDMI_TMDS_DET_STS_grn_tran_err_flag_shift                               (7)
#define  HDMI_TMDS_DET_STS_blu_tran_err_flag_shift                               (6)
#define  HDMI_TMDS_DET_STS_red_pos_de_err_flag_shift                             (5)
#define  HDMI_TMDS_DET_STS_grn_pos_de_err_flag_shift                             (4)
#define  HDMI_TMDS_DET_STS_blu_pos_de_err_flag_shift                             (3)
#define  HDMI_TMDS_DET_STS_red_neg_de_err_flag_shift                             (2)
#define  HDMI_TMDS_DET_STS_grn_neg_de_err_flag_shift                             (1)
#define  HDMI_TMDS_DET_STS_blu_neg_de_err_flag_shift                             (0)
#define  HDMI_TMDS_DET_STS_red_tran_err_flag_mask                                (0x00000100)
#define  HDMI_TMDS_DET_STS_grn_tran_err_flag_mask                                (0x00000080)
#define  HDMI_TMDS_DET_STS_blu_tran_err_flag_mask                                (0x00000040)
#define  HDMI_TMDS_DET_STS_red_pos_de_err_flag_mask                              (0x00000020)
#define  HDMI_TMDS_DET_STS_grn_pos_de_err_flag_mask                              (0x00000010)
#define  HDMI_TMDS_DET_STS_blu_pos_de_err_flag_mask                              (0x00000008)
#define  HDMI_TMDS_DET_STS_red_neg_de_err_flag_mask                              (0x00000004)
#define  HDMI_TMDS_DET_STS_grn_neg_de_err_flag_mask                              (0x00000002)
#define  HDMI_TMDS_DET_STS_blu_neg_de_err_flag_mask                              (0x00000001)
#define  HDMI_TMDS_DET_STS_red_tran_err_flag(data)                               (0x00000100&((data)<<8))
#define  HDMI_TMDS_DET_STS_grn_tran_err_flag(data)                               (0x00000080&((data)<<7))
#define  HDMI_TMDS_DET_STS_blu_tran_err_flag(data)                               (0x00000040&((data)<<6))
#define  HDMI_TMDS_DET_STS_red_pos_de_err_flag(data)                             (0x00000020&((data)<<5))
#define  HDMI_TMDS_DET_STS_grn_pos_de_err_flag(data)                             (0x00000010&((data)<<4))
#define  HDMI_TMDS_DET_STS_blu_pos_de_err_flag(data)                             (0x00000008&((data)<<3))
#define  HDMI_TMDS_DET_STS_red_neg_de_err_flag(data)                             (0x00000004&((data)<<2))
#define  HDMI_TMDS_DET_STS_grn_neg_de_err_flag(data)                             (0x00000002&((data)<<1))
#define  HDMI_TMDS_DET_STS_blu_neg_de_err_flag(data)                             (0x00000001&(data))
#define  HDMI_TMDS_DET_STS_get_red_tran_err_flag(data)                           ((0x00000100&(data))>>8)
#define  HDMI_TMDS_DET_STS_get_grn_tran_err_flag(data)                           ((0x00000080&(data))>>7)
#define  HDMI_TMDS_DET_STS_get_blu_tran_err_flag(data)                           ((0x00000040&(data))>>6)
#define  HDMI_TMDS_DET_STS_get_red_pos_de_err_flag(data)                         ((0x00000020&(data))>>5)
#define  HDMI_TMDS_DET_STS_get_grn_pos_de_err_flag(data)                         ((0x00000010&(data))>>4)
#define  HDMI_TMDS_DET_STS_get_blu_pos_de_err_flag(data)                         ((0x00000008&(data))>>3)
#define  HDMI_TMDS_DET_STS_get_red_neg_de_err_flag(data)                         ((0x00000004&(data))>>2)
#define  HDMI_TMDS_DET_STS_get_grn_neg_de_err_flag(data)                         ((0x00000002&(data))>>1)
#define  HDMI_TMDS_DET_STS_get_blu_neg_de_err_flag(data)                         (0x00000001&(data))

#define  HDMI_VIDEO_BIT_ERR_DET                                                  0x1800D060
#define  HDMI_VIDEO_BIT_ERR_DET_reg_addr                                         "0xB800D060"
#define  HDMI_VIDEO_BIT_ERR_DET_reg                                              0xB800D060
#define  HDMI_VIDEO_BIT_ERR_DET_inst_addr                                        "0x0018"
#define  set_HDMI_VIDEO_BIT_ERR_DET_reg(data)                                    (*((volatile unsigned int*)HDMI_VIDEO_BIT_ERR_DET_reg)=data)
#define  get_HDMI_VIDEO_BIT_ERR_DET_reg                                          (*((volatile unsigned int*)HDMI_VIDEO_BIT_ERR_DET_reg))
#define  HDMI_VIDEO_BIT_ERR_DET_thd_shift                                        (16)
#define  HDMI_VIDEO_BIT_ERR_DET_disparity_reset_mode_shift                       (12)
#define  HDMI_VIDEO_BIT_ERR_DET_irq_en_shift                                     (11)
#define  HDMI_VIDEO_BIT_ERR_DET_reset_shift                                      (10)
#define  HDMI_VIDEO_BIT_ERR_DET_period_shift                                     (4)
#define  HDMI_VIDEO_BIT_ERR_DET_ch_sel_shift                                     (2)
#define  HDMI_VIDEO_BIT_ERR_DET_mode_shift                                       (1)
#define  HDMI_VIDEO_BIT_ERR_DET_en_shift                                         (0)
#define  HDMI_VIDEO_BIT_ERR_DET_thd_mask                                         (0xFFFF0000)
#define  HDMI_VIDEO_BIT_ERR_DET_disparity_reset_mode_mask                        (0x00001000)
#define  HDMI_VIDEO_BIT_ERR_DET_irq_en_mask                                      (0x00000800)
#define  HDMI_VIDEO_BIT_ERR_DET_reset_mask                                       (0x00000400)
#define  HDMI_VIDEO_BIT_ERR_DET_period_mask                                      (0x000003F0)
#define  HDMI_VIDEO_BIT_ERR_DET_ch_sel_mask                                      (0x0000000C)
#define  HDMI_VIDEO_BIT_ERR_DET_mode_mask                                        (0x00000002)
#define  HDMI_VIDEO_BIT_ERR_DET_en_mask                                          (0x00000001)
#define  HDMI_VIDEO_BIT_ERR_DET_thd(data)                                        (0xFFFF0000&((data)<<16))
#define  HDMI_VIDEO_BIT_ERR_DET_disparity_reset_mode(data)                       (0x00001000&((data)<<12))
#define  HDMI_VIDEO_BIT_ERR_DET_irq_en(data)                                     (0x00000800&((data)<<11))
#define  HDMI_VIDEO_BIT_ERR_DET_reset(data)                                      (0x00000400&((data)<<10))
#define  HDMI_VIDEO_BIT_ERR_DET_period(data)                                     (0x000003F0&((data)<<4))
#define  HDMI_VIDEO_BIT_ERR_DET_ch_sel(data)                                     (0x0000000C&((data)<<2))
#define  HDMI_VIDEO_BIT_ERR_DET_mode(data)                                       (0x00000002&((data)<<1))
#define  HDMI_VIDEO_BIT_ERR_DET_en(data)                                         (0x00000001&(data))
#define  HDMI_VIDEO_BIT_ERR_DET_get_thd(data)                                    ((0xFFFF0000&(data))>>16)
#define  HDMI_VIDEO_BIT_ERR_DET_get_disparity_reset_mode(data)                   ((0x00001000&(data))>>12)
#define  HDMI_VIDEO_BIT_ERR_DET_get_irq_en(data)                                 ((0x00000800&(data))>>11)
#define  HDMI_VIDEO_BIT_ERR_DET_get_reset(data)                                  ((0x00000400&(data))>>10)
#define  HDMI_VIDEO_BIT_ERR_DET_get_period(data)                                 ((0x000003F0&(data))>>4)
#define  HDMI_VIDEO_BIT_ERR_DET_get_ch_sel(data)                                 ((0x0000000C&(data))>>2)
#define  HDMI_VIDEO_BIT_ERR_DET_get_mode(data)                                   ((0x00000002&(data))>>1)
#define  HDMI_VIDEO_BIT_ERR_DET_get_en(data)                                     (0x00000001&(data))

#define  HDMI_VIDEO_BIT_ERR_STATUS_B                                             0x1800D064
#define  HDMI_VIDEO_BIT_ERR_STATUS_B_reg_addr                                    "0xB800D064"
#define  HDMI_VIDEO_BIT_ERR_STATUS_B_reg                                         0xB800D064
#define  HDMI_VIDEO_BIT_ERR_STATUS_B_inst_addr                                   "0x0019"
#define  set_HDMI_VIDEO_BIT_ERR_STATUS_B_reg(data)                               (*((volatile unsigned int*)HDMI_VIDEO_BIT_ERR_STATUS_B_reg)=data)
#define  get_HDMI_VIDEO_BIT_ERR_STATUS_B_reg                                     (*((volatile unsigned int*)HDMI_VIDEO_BIT_ERR_STATUS_B_reg))
#define  HDMI_VIDEO_BIT_ERR_STATUS_B_ad_max_b_shift                              (26)
#define  HDMI_VIDEO_BIT_ERR_STATUS_B_ad_min_b_shift                              (20)
#define  HDMI_VIDEO_BIT_ERR_STATUS_B_no_dis_reset_b_shift                        (19)
#define  HDMI_VIDEO_BIT_ERR_STATUS_B_bit_err_thd_b_shift                         (18)
#define  HDMI_VIDEO_BIT_ERR_STATUS_B_bit_err_b_shift                             (17)
#define  HDMI_VIDEO_BIT_ERR_STATUS_B_bit_err_cnt_of_b_shift                      (16)
#define  HDMI_VIDEO_BIT_ERR_STATUS_B_bit_err_cnt_b_shift                         (0)
#define  HDMI_VIDEO_BIT_ERR_STATUS_B_ad_max_b_mask                               (0xFC000000)
#define  HDMI_VIDEO_BIT_ERR_STATUS_B_ad_min_b_mask                               (0x03F00000)
#define  HDMI_VIDEO_BIT_ERR_STATUS_B_no_dis_reset_b_mask                         (0x00080000)
#define  HDMI_VIDEO_BIT_ERR_STATUS_B_bit_err_thd_b_mask                          (0x00040000)
#define  HDMI_VIDEO_BIT_ERR_STATUS_B_bit_err_b_mask                              (0x00020000)
#define  HDMI_VIDEO_BIT_ERR_STATUS_B_bit_err_cnt_of_b_mask                       (0x00010000)
#define  HDMI_VIDEO_BIT_ERR_STATUS_B_bit_err_cnt_b_mask                          (0x0000FFFF)
#define  HDMI_VIDEO_BIT_ERR_STATUS_B_ad_max_b(data)                              (0xFC000000&((data)<<26))
#define  HDMI_VIDEO_BIT_ERR_STATUS_B_ad_min_b(data)                              (0x03F00000&((data)<<20))
#define  HDMI_VIDEO_BIT_ERR_STATUS_B_no_dis_reset_b(data)                        (0x00080000&((data)<<19))
#define  HDMI_VIDEO_BIT_ERR_STATUS_B_bit_err_thd_b(data)                         (0x00040000&((data)<<18))
#define  HDMI_VIDEO_BIT_ERR_STATUS_B_bit_err_b(data)                             (0x00020000&((data)<<17))
#define  HDMI_VIDEO_BIT_ERR_STATUS_B_bit_err_cnt_of_b(data)                      (0x00010000&((data)<<16))
#define  HDMI_VIDEO_BIT_ERR_STATUS_B_bit_err_cnt_b(data)                         (0x0000FFFF&(data))
#define  HDMI_VIDEO_BIT_ERR_STATUS_B_get_ad_max_b(data)                          ((0xFC000000&(data))>>26)
#define  HDMI_VIDEO_BIT_ERR_STATUS_B_get_ad_min_b(data)                          ((0x03F00000&(data))>>20)
#define  HDMI_VIDEO_BIT_ERR_STATUS_B_get_no_dis_reset_b(data)                    ((0x00080000&(data))>>19)
#define  HDMI_VIDEO_BIT_ERR_STATUS_B_get_bit_err_thd_b(data)                     ((0x00040000&(data))>>18)
#define  HDMI_VIDEO_BIT_ERR_STATUS_B_get_bit_err_b(data)                         ((0x00020000&(data))>>17)
#define  HDMI_VIDEO_BIT_ERR_STATUS_B_get_bit_err_cnt_of_b(data)                  ((0x00010000&(data))>>16)
#define  HDMI_VIDEO_BIT_ERR_STATUS_B_get_bit_err_cnt_b(data)                     (0x0000FFFF&(data))

#define  HDMI_VIDEO_BIT_ERR_STATUS_G                                             0x1800D068
#define  HDMI_VIDEO_BIT_ERR_STATUS_G_reg_addr                                    "0xB800D068"
#define  HDMI_VIDEO_BIT_ERR_STATUS_G_reg                                         0xB800D068
#define  HDMI_VIDEO_BIT_ERR_STATUS_G_inst_addr                                   "0x001A"
#define  set_HDMI_VIDEO_BIT_ERR_STATUS_G_reg(data)                               (*((volatile unsigned int*)HDMI_VIDEO_BIT_ERR_STATUS_G_reg)=data)
#define  get_HDMI_VIDEO_BIT_ERR_STATUS_G_reg                                     (*((volatile unsigned int*)HDMI_VIDEO_BIT_ERR_STATUS_G_reg))
#define  HDMI_VIDEO_BIT_ERR_STATUS_G_ad_max_g_shift                              (26)
#define  HDMI_VIDEO_BIT_ERR_STATUS_G_ad_min_g_shift                              (20)
#define  HDMI_VIDEO_BIT_ERR_STATUS_G_no_dis_reset_g_shift                        (19)
#define  HDMI_VIDEO_BIT_ERR_STATUS_G_bit_err_thd_g_shift                         (18)
#define  HDMI_VIDEO_BIT_ERR_STATUS_G_bit_err_g_shift                             (17)
#define  HDMI_VIDEO_BIT_ERR_STATUS_G_bit_err_cnt_of_g_shift                      (16)
#define  HDMI_VIDEO_BIT_ERR_STATUS_G_bit_err_cnt_g_shift                         (0)
#define  HDMI_VIDEO_BIT_ERR_STATUS_G_ad_max_g_mask                               (0xFC000000)
#define  HDMI_VIDEO_BIT_ERR_STATUS_G_ad_min_g_mask                               (0x03F00000)
#define  HDMI_VIDEO_BIT_ERR_STATUS_G_no_dis_reset_g_mask                         (0x00080000)
#define  HDMI_VIDEO_BIT_ERR_STATUS_G_bit_err_thd_g_mask                          (0x00040000)
#define  HDMI_VIDEO_BIT_ERR_STATUS_G_bit_err_g_mask                              (0x00020000)
#define  HDMI_VIDEO_BIT_ERR_STATUS_G_bit_err_cnt_of_g_mask                       (0x00010000)
#define  HDMI_VIDEO_BIT_ERR_STATUS_G_bit_err_cnt_g_mask                          (0x0000FFFF)
#define  HDMI_VIDEO_BIT_ERR_STATUS_G_ad_max_g(data)                              (0xFC000000&((data)<<26))
#define  HDMI_VIDEO_BIT_ERR_STATUS_G_ad_min_g(data)                              (0x03F00000&((data)<<20))
#define  HDMI_VIDEO_BIT_ERR_STATUS_G_no_dis_reset_g(data)                        (0x00080000&((data)<<19))
#define  HDMI_VIDEO_BIT_ERR_STATUS_G_bit_err_thd_g(data)                         (0x00040000&((data)<<18))
#define  HDMI_VIDEO_BIT_ERR_STATUS_G_bit_err_g(data)                             (0x00020000&((data)<<17))
#define  HDMI_VIDEO_BIT_ERR_STATUS_G_bit_err_cnt_of_g(data)                      (0x00010000&((data)<<16))
#define  HDMI_VIDEO_BIT_ERR_STATUS_G_bit_err_cnt_g(data)                         (0x0000FFFF&(data))
#define  HDMI_VIDEO_BIT_ERR_STATUS_G_get_ad_max_g(data)                          ((0xFC000000&(data))>>26)
#define  HDMI_VIDEO_BIT_ERR_STATUS_G_get_ad_min_g(data)                          ((0x03F00000&(data))>>20)
#define  HDMI_VIDEO_BIT_ERR_STATUS_G_get_no_dis_reset_g(data)                    ((0x00080000&(data))>>19)
#define  HDMI_VIDEO_BIT_ERR_STATUS_G_get_bit_err_thd_g(data)                     ((0x00040000&(data))>>18)
#define  HDMI_VIDEO_BIT_ERR_STATUS_G_get_bit_err_g(data)                         ((0x00020000&(data))>>17)
#define  HDMI_VIDEO_BIT_ERR_STATUS_G_get_bit_err_cnt_of_g(data)                  ((0x00010000&(data))>>16)
#define  HDMI_VIDEO_BIT_ERR_STATUS_G_get_bit_err_cnt_g(data)                     (0x0000FFFF&(data))

#define  HDMI_VIDEO_BIT_ERR_STATUS_R                                             0x1800D06C
#define  HDMI_VIDEO_BIT_ERR_STATUS_R_reg_addr                                    "0xB800D06C"
#define  HDMI_VIDEO_BIT_ERR_STATUS_R_reg                                         0xB800D06C
#define  HDMI_VIDEO_BIT_ERR_STATUS_R_inst_addr                                   "0x001B"
#define  set_HDMI_VIDEO_BIT_ERR_STATUS_R_reg(data)                               (*((volatile unsigned int*)HDMI_VIDEO_BIT_ERR_STATUS_R_reg)=data)
#define  get_HDMI_VIDEO_BIT_ERR_STATUS_R_reg                                     (*((volatile unsigned int*)HDMI_VIDEO_BIT_ERR_STATUS_R_reg))
#define  HDMI_VIDEO_BIT_ERR_STATUS_R_ad_max_r_shift                              (26)
#define  HDMI_VIDEO_BIT_ERR_STATUS_R_ad_min_r_shift                              (20)
#define  HDMI_VIDEO_BIT_ERR_STATUS_R_no_dis_reset_r_shift                        (19)
#define  HDMI_VIDEO_BIT_ERR_STATUS_R_bit_err_thd_r_shift                         (18)
#define  HDMI_VIDEO_BIT_ERR_STATUS_R_bit_err_r_shift                             (17)
#define  HDMI_VIDEO_BIT_ERR_STATUS_R_bit_err_cnt_of_r_shift                      (16)
#define  HDMI_VIDEO_BIT_ERR_STATUS_R_bit_err_cnt_r_shift                         (0)
#define  HDMI_VIDEO_BIT_ERR_STATUS_R_ad_max_r_mask                               (0xFC000000)
#define  HDMI_VIDEO_BIT_ERR_STATUS_R_ad_min_r_mask                               (0x03F00000)
#define  HDMI_VIDEO_BIT_ERR_STATUS_R_no_dis_reset_r_mask                         (0x00080000)
#define  HDMI_VIDEO_BIT_ERR_STATUS_R_bit_err_thd_r_mask                          (0x00040000)
#define  HDMI_VIDEO_BIT_ERR_STATUS_R_bit_err_r_mask                              (0x00020000)
#define  HDMI_VIDEO_BIT_ERR_STATUS_R_bit_err_cnt_of_r_mask                       (0x00010000)
#define  HDMI_VIDEO_BIT_ERR_STATUS_R_bit_err_cnt_r_mask                          (0x0000FFFF)
#define  HDMI_VIDEO_BIT_ERR_STATUS_R_ad_max_r(data)                              (0xFC000000&((data)<<26))
#define  HDMI_VIDEO_BIT_ERR_STATUS_R_ad_min_r(data)                              (0x03F00000&((data)<<20))
#define  HDMI_VIDEO_BIT_ERR_STATUS_R_no_dis_reset_r(data)                        (0x00080000&((data)<<19))
#define  HDMI_VIDEO_BIT_ERR_STATUS_R_bit_err_thd_r(data)                         (0x00040000&((data)<<18))
#define  HDMI_VIDEO_BIT_ERR_STATUS_R_bit_err_r(data)                             (0x00020000&((data)<<17))
#define  HDMI_VIDEO_BIT_ERR_STATUS_R_bit_err_cnt_of_r(data)                      (0x00010000&((data)<<16))
#define  HDMI_VIDEO_BIT_ERR_STATUS_R_bit_err_cnt_r(data)                         (0x0000FFFF&(data))
#define  HDMI_VIDEO_BIT_ERR_STATUS_R_get_ad_max_r(data)                          ((0xFC000000&(data))>>26)
#define  HDMI_VIDEO_BIT_ERR_STATUS_R_get_ad_min_r(data)                          ((0x03F00000&(data))>>20)
#define  HDMI_VIDEO_BIT_ERR_STATUS_R_get_no_dis_reset_r(data)                    ((0x00080000&(data))>>19)
#define  HDMI_VIDEO_BIT_ERR_STATUS_R_get_bit_err_thd_r(data)                     ((0x00040000&(data))>>18)
#define  HDMI_VIDEO_BIT_ERR_STATUS_R_get_bit_err_r(data)                         ((0x00020000&(data))>>17)
#define  HDMI_VIDEO_BIT_ERR_STATUS_R_get_bit_err_cnt_of_r(data)                  ((0x00010000&(data))>>16)
#define  HDMI_VIDEO_BIT_ERR_STATUS_R_get_bit_err_cnt_r(data)                     (0x0000FFFF&(data))

#define  HDMI_TERC4_ERR_DET                                                      0x1800D070
#define  HDMI_TERC4_ERR_DET_reg_addr                                             "0xB800D070"
#define  HDMI_TERC4_ERR_DET_reg                                                  0xB800D070
#define  HDMI_TERC4_ERR_DET_inst_addr                                            "0x001C"
#define  set_HDMI_TERC4_ERR_DET_reg(data)                                        (*((volatile unsigned int*)HDMI_TERC4_ERR_DET_reg)=data)
#define  get_HDMI_TERC4_ERR_DET_reg                                              (*((volatile unsigned int*)HDMI_TERC4_ERR_DET_reg))
#define  HDMI_TERC4_ERR_DET_terc4_thd_shift                                      (0)
#define  HDMI_TERC4_ERR_DET_terc4_thd_mask                                       (0x0000FFFF)
#define  HDMI_TERC4_ERR_DET_terc4_thd(data)                                      (0x0000FFFF&(data))
#define  HDMI_TERC4_ERR_DET_get_terc4_thd(data)                                  (0x0000FFFF&(data))

#define  HDMI_TERC4_ERR_STATUS_B                                                 0x1800D074
#define  HDMI_TERC4_ERR_STATUS_B_reg_addr                                        "0xB800D074"
#define  HDMI_TERC4_ERR_STATUS_B_reg                                             0xB800D074
#define  HDMI_TERC4_ERR_STATUS_B_inst_addr                                       "0x001D"
#define  set_HDMI_TERC4_ERR_STATUS_B_reg(data)                                   (*((volatile unsigned int*)HDMI_TERC4_ERR_STATUS_B_reg)=data)
#define  get_HDMI_TERC4_ERR_STATUS_B_reg                                         (*((volatile unsigned int*)HDMI_TERC4_ERR_STATUS_B_reg))
#define  HDMI_TERC4_ERR_STATUS_B_terc4_err_thd_b_shift                           (18)
#define  HDMI_TERC4_ERR_STATUS_B_terc4_err_b_shift                               (17)
#define  HDMI_TERC4_ERR_STATUS_B_terc4_err_cnt_of_b_shift                        (16)
#define  HDMI_TERC4_ERR_STATUS_B_terc4_err_cnt_b_shift                           (0)
#define  HDMI_TERC4_ERR_STATUS_B_terc4_err_thd_b_mask                            (0x00040000)
#define  HDMI_TERC4_ERR_STATUS_B_terc4_err_b_mask                                (0x00020000)
#define  HDMI_TERC4_ERR_STATUS_B_terc4_err_cnt_of_b_mask                         (0x00010000)
#define  HDMI_TERC4_ERR_STATUS_B_terc4_err_cnt_b_mask                            (0x0000FFFF)
#define  HDMI_TERC4_ERR_STATUS_B_terc4_err_thd_b(data)                           (0x00040000&((data)<<18))
#define  HDMI_TERC4_ERR_STATUS_B_terc4_err_b(data)                               (0x00020000&((data)<<17))
#define  HDMI_TERC4_ERR_STATUS_B_terc4_err_cnt_of_b(data)                        (0x00010000&((data)<<16))
#define  HDMI_TERC4_ERR_STATUS_B_terc4_err_cnt_b(data)                           (0x0000FFFF&(data))
#define  HDMI_TERC4_ERR_STATUS_B_get_terc4_err_thd_b(data)                       ((0x00040000&(data))>>18)
#define  HDMI_TERC4_ERR_STATUS_B_get_terc4_err_b(data)                           ((0x00020000&(data))>>17)
#define  HDMI_TERC4_ERR_STATUS_B_get_terc4_err_cnt_of_b(data)                    ((0x00010000&(data))>>16)
#define  HDMI_TERC4_ERR_STATUS_B_get_terc4_err_cnt_b(data)                       (0x0000FFFF&(data))

#define  HDMI_TERC4_ERR_STATUS_G                                                 0x1800D078
#define  HDMI_TERC4_ERR_STATUS_G_reg_addr                                        "0xB800D078"
#define  HDMI_TERC4_ERR_STATUS_G_reg                                             0xB800D078
#define  HDMI_TERC4_ERR_STATUS_G_inst_addr                                       "0x001E"
#define  set_HDMI_TERC4_ERR_STATUS_G_reg(data)                                   (*((volatile unsigned int*)HDMI_TERC4_ERR_STATUS_G_reg)=data)
#define  get_HDMI_TERC4_ERR_STATUS_G_reg                                         (*((volatile unsigned int*)HDMI_TERC4_ERR_STATUS_G_reg))
#define  HDMI_TERC4_ERR_STATUS_G_terc4_err_thd_g_shift                           (18)
#define  HDMI_TERC4_ERR_STATUS_G_terc4_err_g_shift                               (17)
#define  HDMI_TERC4_ERR_STATUS_G_terc4_err_cnt_of_g_shift                        (16)
#define  HDMI_TERC4_ERR_STATUS_G_terc4_err_cnt_g_shift                           (0)
#define  HDMI_TERC4_ERR_STATUS_G_terc4_err_thd_g_mask                            (0x00040000)
#define  HDMI_TERC4_ERR_STATUS_G_terc4_err_g_mask                                (0x00020000)
#define  HDMI_TERC4_ERR_STATUS_G_terc4_err_cnt_of_g_mask                         (0x00010000)
#define  HDMI_TERC4_ERR_STATUS_G_terc4_err_cnt_g_mask                            (0x0000FFFF)
#define  HDMI_TERC4_ERR_STATUS_G_terc4_err_thd_g(data)                           (0x00040000&((data)<<18))
#define  HDMI_TERC4_ERR_STATUS_G_terc4_err_g(data)                               (0x00020000&((data)<<17))
#define  HDMI_TERC4_ERR_STATUS_G_terc4_err_cnt_of_g(data)                        (0x00010000&((data)<<16))
#define  HDMI_TERC4_ERR_STATUS_G_terc4_err_cnt_g(data)                           (0x0000FFFF&(data))
#define  HDMI_TERC4_ERR_STATUS_G_get_terc4_err_thd_g(data)                       ((0x00040000&(data))>>18)
#define  HDMI_TERC4_ERR_STATUS_G_get_terc4_err_g(data)                           ((0x00020000&(data))>>17)
#define  HDMI_TERC4_ERR_STATUS_G_get_terc4_err_cnt_of_g(data)                    ((0x00010000&(data))>>16)
#define  HDMI_TERC4_ERR_STATUS_G_get_terc4_err_cnt_g(data)                       (0x0000FFFF&(data))

#define  HDMI_TERC4_ERR_STATUS_R                                                 0x1800D07C
#define  HDMI_TERC4_ERR_STATUS_R_reg_addr                                        "0xB800D07C"
#define  HDMI_TERC4_ERR_STATUS_R_reg                                             0xB800D07C
#define  HDMI_TERC4_ERR_STATUS_R_inst_addr                                       "0x001F"
#define  set_HDMI_TERC4_ERR_STATUS_R_reg(data)                                   (*((volatile unsigned int*)HDMI_TERC4_ERR_STATUS_R_reg)=data)
#define  get_HDMI_TERC4_ERR_STATUS_R_reg                                         (*((volatile unsigned int*)HDMI_TERC4_ERR_STATUS_R_reg))
#define  HDMI_TERC4_ERR_STATUS_R_terc4_err_thd_r_shift                           (18)
#define  HDMI_TERC4_ERR_STATUS_R_terc4_err_r_shift                               (17)
#define  HDMI_TERC4_ERR_STATUS_R_terc4_err_cnt_of_r_shift                        (16)
#define  HDMI_TERC4_ERR_STATUS_R_terc4_err_cnt_r_shift                           (0)
#define  HDMI_TERC4_ERR_STATUS_R_terc4_err_thd_r_mask                            (0x00040000)
#define  HDMI_TERC4_ERR_STATUS_R_terc4_err_r_mask                                (0x00020000)
#define  HDMI_TERC4_ERR_STATUS_R_terc4_err_cnt_of_r_mask                         (0x00010000)
#define  HDMI_TERC4_ERR_STATUS_R_terc4_err_cnt_r_mask                            (0x0000FFFF)
#define  HDMI_TERC4_ERR_STATUS_R_terc4_err_thd_r(data)                           (0x00040000&((data)<<18))
#define  HDMI_TERC4_ERR_STATUS_R_terc4_err_r(data)                               (0x00020000&((data)<<17))
#define  HDMI_TERC4_ERR_STATUS_R_terc4_err_cnt_of_r(data)                        (0x00010000&((data)<<16))
#define  HDMI_TERC4_ERR_STATUS_R_terc4_err_cnt_r(data)                           (0x0000FFFF&(data))
#define  HDMI_TERC4_ERR_STATUS_R_get_terc4_err_thd_r(data)                       ((0x00040000&(data))>>18)
#define  HDMI_TERC4_ERR_STATUS_R_get_terc4_err_r(data)                           ((0x00020000&(data))>>17)
#define  HDMI_TERC4_ERR_STATUS_R_get_terc4_err_cnt_of_r(data)                    ((0x00010000&(data))>>16)
#define  HDMI_TERC4_ERR_STATUS_R_get_terc4_err_cnt_r(data)                       (0x0000FFFF&(data))

#define  HDMI_HDMI_SR                                                            0x1800D080
#define  HDMI_HDMI_SR_reg_addr                                                   "0xB800D080"
#define  HDMI_HDMI_SR_reg                                                        0xB800D080
#define  HDMI_HDMI_SR_inst_addr                                                  "0x0020"
#define  set_HDMI_HDMI_SR_reg(data)                                              (*((volatile unsigned int*)HDMI_HDMI_SR_reg)=data)
#define  get_HDMI_HDMI_SR_reg                                                    (*((volatile unsigned int*)HDMI_HDMI_SR_reg))
#define  HDMI_HDMI_SR_avmute_bg_shift                                            (7)
#define  HDMI_HDMI_SR_avmute_shift                                               (6)
#define  HDMI_HDMI_SR_vic_shift                                                  (5)
#define  HDMI_HDMI_SR_spdiftype_shift                                            (4)
#define  HDMI_HDMI_SR_pllsts_shift                                               (3)
#define  HDMI_HDMI_SR_afifoof_shift                                              (2)
#define  HDMI_HDMI_SR_afifouf_shift                                              (1)
#define  HDMI_HDMI_SR_mode_shift                                                 (0)
#define  HDMI_HDMI_SR_avmute_bg_mask                                             (0x00000080)
#define  HDMI_HDMI_SR_avmute_mask                                                (0x00000040)
#define  HDMI_HDMI_SR_vic_mask                                                   (0x00000020)
#define  HDMI_HDMI_SR_spdiftype_mask                                             (0x00000010)
#define  HDMI_HDMI_SR_pllsts_mask                                                (0x00000008)
#define  HDMI_HDMI_SR_afifoof_mask                                               (0x00000004)
#define  HDMI_HDMI_SR_afifouf_mask                                               (0x00000002)
#define  HDMI_HDMI_SR_mode_mask                                                  (0x00000001)
#define  HDMI_HDMI_SR_avmute_bg(data)                                            (0x00000080&((data)<<7))
#define  HDMI_HDMI_SR_avmute(data)                                               (0x00000040&((data)<<6))
#define  HDMI_HDMI_SR_vic(data)                                                  (0x00000020&((data)<<5))
#define  HDMI_HDMI_SR_spdiftype(data)                                            (0x00000010&((data)<<4))
#define  HDMI_HDMI_SR_pllsts(data)                                               (0x00000008&((data)<<3))
#define  HDMI_HDMI_SR_afifoof(data)                                              (0x00000004&((data)<<2))
#define  HDMI_HDMI_SR_afifouf(data)                                              (0x00000002&((data)<<1))
#define  HDMI_HDMI_SR_mode(data)                                                 (0x00000001&(data))
#define  HDMI_HDMI_SR_get_avmute_bg(data)                                        ((0x00000080&(data))>>7)
#define  HDMI_HDMI_SR_get_avmute(data)                                           ((0x00000040&(data))>>6)
#define  HDMI_HDMI_SR_get_vic(data)                                              ((0x00000020&(data))>>5)
#define  HDMI_HDMI_SR_get_spdiftype(data)                                        ((0x00000010&(data))>>4)
#define  HDMI_HDMI_SR_get_pllsts(data)                                           ((0x00000008&(data))>>3)
#define  HDMI_HDMI_SR_get_afifoof(data)                                          ((0x00000004&(data))>>2)
#define  HDMI_HDMI_SR_get_afifouf(data)                                          ((0x00000002&(data))>>1)
#define  HDMI_HDMI_SR_get_mode(data)                                             (0x00000001&(data))

#define  HDMI_HDMI_GPVS                                                          0x1800D084
#define  HDMI_HDMI_GPVS_reg_addr                                                 "0xB800D084"
#define  HDMI_HDMI_GPVS_reg                                                      0xB800D084
#define  HDMI_HDMI_GPVS_inst_addr                                                "0x0021"
#define  set_HDMI_HDMI_GPVS_reg(data)                                            (*((volatile unsigned int*)HDMI_HDMI_GPVS_reg)=data)
#define  get_HDMI_HDMI_GPVS_reg                                                  (*((volatile unsigned int*)HDMI_HDMI_GPVS_reg))
#define  HDMI_HDMI_GPVS_fvsps_shift                                              (14)
#define  HDMI_HDMI_GPVS_gmps_v_shift                                             (13)
#define  HDMI_HDMI_GPVS_vsps_v_shift                                             (12)
#define  HDMI_HDMI_GPVS_gmps_shift                                               (11)
#define  HDMI_HDMI_GPVS_vsps_shift                                               (10)
#define  HDMI_HDMI_GPVS_nps_shift                                                (9)
//#define  HDMI_HDMI_GPVS_dummy_shift                                              (8)
//#define  HDMI_HDMI_GPVS_dummy_shift                                              (7)
#define  HDMI_HDMI_GPVS_pis_6_shift                                              (6)
#define  HDMI_HDMI_GPVS_pis_5_shift                                              (5)
#define  HDMI_HDMI_GPVS_pvs_4_shift                                              (4)
#define  HDMI_HDMI_GPVS_pvs_3_shift                                              (3)
#define  HDMI_HDMI_GPVS_pvs_2_shift                                              (2)
#define  HDMI_HDMI_GPVS_pvs_1_shift                                              (1)
#define  HDMI_HDMI_GPVS_pvs_0_shift                                              (0)
#define  HDMI_HDMI_GPVS_fvsps_mask                                               (0x00004000)
#define  HDMI_HDMI_GPVS_gmps_v_mask                                              (0x00002000)
#define  HDMI_HDMI_GPVS_vsps_v_mask                                              (0x00001000)
#define  HDMI_HDMI_GPVS_gmps_mask                                                (0x00000800)
#define  HDMI_HDMI_GPVS_vsps_mask                                                (0x00000400)
#define  HDMI_HDMI_GPVS_nps_mask                                                 (0x00000200)
//#define  HDMI_HDMI_GPVS_dummy_mask                                               (0x00000100)
//#define  HDMI_HDMI_GPVS_dummy_mask                                               (0x00000080)
#define  HDMI_HDMI_GPVS_pis_6_mask                                               (0x00000040)
#define  HDMI_HDMI_GPVS_pis_5_mask                                               (0x00000020)
#define  HDMI_HDMI_GPVS_pvs_4_mask                                               (0x00000010)
#define  HDMI_HDMI_GPVS_pvs_3_mask                                               (0x00000008)
#define  HDMI_HDMI_GPVS_pvs_2_mask                                               (0x00000004)
#define  HDMI_HDMI_GPVS_pvs_1_mask                                               (0x00000002)
#define  HDMI_HDMI_GPVS_pvs_0_mask                                               (0x00000001)
#define  HDMI_HDMI_GPVS_fvsps(data)                                              (0x00004000&((data)<<14))
#define  HDMI_HDMI_GPVS_gmps_v(data)                                             (0x00002000&((data)<<13))
#define  HDMI_HDMI_GPVS_vsps_v(data)                                             (0x00001000&((data)<<12))
#define  HDMI_HDMI_GPVS_gmps(data)                                               (0x00000800&((data)<<11))
#define  HDMI_HDMI_GPVS_vsps(data)                                               (0x00000400&((data)<<10))
#define  HDMI_HDMI_GPVS_nps(data)                                                (0x00000200&((data)<<9))
//#define  HDMI_HDMI_GPVS_dummy(data)                                              (0x00000100&((data)<<8))
//#define  HDMI_HDMI_GPVS_dummy(data)                                              (0x00000080&((data)<<7))
#define  HDMI_HDMI_GPVS_pis_6(data)                                              (0x00000040&((data)<<6))
#define  HDMI_HDMI_GPVS_pis_5(data)                                              (0x00000020&((data)<<5))
#define  HDMI_HDMI_GPVS_pvs_4(data)                                              (0x00000010&((data)<<4))
#define  HDMI_HDMI_GPVS_pvs_3(data)                                              (0x00000008&((data)<<3))
#define  HDMI_HDMI_GPVS_pvs_2(data)                                              (0x00000004&((data)<<2))
#define  HDMI_HDMI_GPVS_pvs_1(data)                                              (0x00000002&((data)<<1))
#define  HDMI_HDMI_GPVS_pvs_0(data)                                              (0x00000001&(data))
#define  HDMI_HDMI_GPVS_get_fvsps(data)                                          ((0x00004000&(data))>>14)
#define  HDMI_HDMI_GPVS_get_gmps_v(data)                                         ((0x00002000&(data))>>13)
#define  HDMI_HDMI_GPVS_get_vsps_v(data)                                         ((0x00001000&(data))>>12)
#define  HDMI_HDMI_GPVS_get_gmps(data)                                           ((0x00000800&(data))>>11)
#define  HDMI_HDMI_GPVS_get_vsps(data)                                           ((0x00000400&(data))>>10)
#define  HDMI_HDMI_GPVS_get_nps(data)                                            ((0x00000200&(data))>>9)
//#define  HDMI_HDMI_GPVS_get_dummy(data)                                          ((0x00000100&(data))>>8)
//#define  HDMI_HDMI_GPVS_get_dummy(data)                                          ((0x00000080&(data))>>7)
#define  HDMI_HDMI_GPVS_get_pis_6(data)                                          ((0x00000040&(data))>>6)
#define  HDMI_HDMI_GPVS_get_pis_5(data)                                          ((0x00000020&(data))>>5)
#define  HDMI_HDMI_GPVS_get_pvs_4(data)                                          ((0x00000010&(data))>>4)
#define  HDMI_HDMI_GPVS_get_pvs_3(data)                                          ((0x00000008&(data))>>3)
#define  HDMI_HDMI_GPVS_get_pvs_2(data)                                          ((0x00000004&(data))>>2)
#define  HDMI_HDMI_GPVS_get_pvs_1(data)                                          ((0x00000002&(data))>>1)
#define  HDMI_HDMI_GPVS_get_pvs_0(data)                                          (0x00000001&(data))

#define  HDMI_HDMI_PSAP                                                          0x1800D088
#define  HDMI_HDMI_PSAP_reg_addr                                                 "0xB800D088"
#define  HDMI_HDMI_PSAP_reg                                                      0xB800D088
#define  HDMI_HDMI_PSAP_inst_addr                                                "0x0022"
#define  set_HDMI_HDMI_PSAP_reg(data)                                            (*((volatile unsigned int*)HDMI_HDMI_PSAP_reg)=data)
#define  get_HDMI_HDMI_PSAP_reg                                                  (*((volatile unsigned int*)HDMI_HDMI_PSAP_reg))
#define  HDMI_HDMI_PSAP_apss_shift                                               (0)
#define  HDMI_HDMI_PSAP_apss_mask                                                (0x000001FF)
#define  HDMI_HDMI_PSAP_apss(data)                                               (0x000001FF&(data))
#define  HDMI_HDMI_PSAP_get_apss(data)                                           (0x000001FF&(data))

#define  HDMI_HDMI_PSDP                                                          0x1800D08C
#define  HDMI_HDMI_PSDP_reg_addr                                                 "0xB800D08C"
#define  HDMI_HDMI_PSDP_reg                                                      0xB800D08C
#define  HDMI_HDMI_PSDP_inst_addr                                                "0x0023"
#define  set_HDMI_HDMI_PSDP_reg(data)                                            (*((volatile unsigned int*)HDMI_HDMI_PSDP_reg)=data)
#define  get_HDMI_HDMI_PSDP_reg                                                  (*((volatile unsigned int*)HDMI_HDMI_PSDP_reg))
#define  HDMI_HDMI_PSDP_dpss_shift                                               (0)
#define  HDMI_HDMI_PSDP_dpss_mask                                                (0x000000FF)
#define  HDMI_HDMI_PSDP_dpss(data)                                               (0x000000FF&(data))
#define  HDMI_HDMI_PSDP_get_dpss(data)                                           (0x000000FF&(data))

#define  HDMI_HDMI_SCR                                                           0x1800D090
#define  HDMI_HDMI_SCR_reg_addr                                                  "0xB800D090"
#define  HDMI_HDMI_SCR_reg                                                       0xB800D090
#define  HDMI_HDMI_SCR_inst_addr                                                 "0x0024"
#define  set_HDMI_HDMI_SCR_reg(data)                                             (*((volatile unsigned int*)HDMI_HDMI_SCR_reg)=data)
#define  get_HDMI_HDMI_SCR_reg                                                   (*((volatile unsigned int*)HDMI_HDMI_SCR_reg))
#define  HDMI_HDMI_SCR_nval_shift                                                (8)
#define  HDMI_HDMI_SCR_no_vs_det_en_shift                                        (6)
#define  HDMI_HDMI_SCR_dvi_reset_ds_cm_en_shift                                  (5)
#define  HDMI_HDMI_SCR_packet_ignore_shift                                       (4)
#define  HDMI_HDMI_SCR_mode_shift                                                (3)
#define  HDMI_HDMI_SCR_msmode_shift                                              (2)
#define  HDMI_HDMI_SCR_cabs_shift                                                (1)
#define  HDMI_HDMI_SCR_fcddip_shift                                              (0)
#define  HDMI_HDMI_SCR_nval_mask                                                 (0x0000FF00)
#define  HDMI_HDMI_SCR_no_vs_det_en_mask                                         (0x00000040)
#define  HDMI_HDMI_SCR_dvi_reset_ds_cm_en_mask                                   (0x00000020)
#define  HDMI_HDMI_SCR_packet_ignore_mask                                        (0x00000010)
#define  HDMI_HDMI_SCR_mode_mask                                                 (0x00000008)
#define  HDMI_HDMI_SCR_msmode_mask                                               (0x00000004)
#define  HDMI_HDMI_SCR_cabs_mask                                                 (0x00000002)
#define  HDMI_HDMI_SCR_fcddip_mask                                               (0x00000001)
#define  HDMI_HDMI_SCR_nval(data)                                                (0x0000FF00&((data)<<8))
#define  HDMI_HDMI_SCR_no_vs_det_en(data)                                        (0x00000040&((data)<<6))
#define  HDMI_HDMI_SCR_dvi_reset_ds_cm_en(data)                                  (0x00000020&((data)<<5))
#define  HDMI_HDMI_SCR_packet_ignore(data)                                       (0x00000010&((data)<<4))
#define  HDMI_HDMI_SCR_mode(data)                                                (0x00000008&((data)<<3))
#define  HDMI_HDMI_SCR_msmode(data)                                              (0x00000004&((data)<<2))
#define  HDMI_HDMI_SCR_cabs(data)                                                (0x00000002&((data)<<1))
#define  HDMI_HDMI_SCR_fcddip(data)                                              (0x00000001&(data))
#define  HDMI_HDMI_SCR_get_nval(data)                                            ((0x0000FF00&(data))>>8)
#define  HDMI_HDMI_SCR_get_no_vs_det_en(data)                                    ((0x00000040&(data))>>6)
#define  HDMI_HDMI_SCR_get_dvi_reset_ds_cm_en(data)                              ((0x00000020&(data))>>5)
#define  HDMI_HDMI_SCR_get_packet_ignore(data)                                   ((0x00000010&(data))>>4)
#define  HDMI_HDMI_SCR_get_mode(data)                                            ((0x00000008&(data))>>3)
#define  HDMI_HDMI_SCR_get_msmode(data)                                          ((0x00000004&(data))>>2)
#define  HDMI_HDMI_SCR_get_cabs(data)                                            ((0x00000002&(data))>>1)
#define  HDMI_HDMI_SCR_get_fcddip(data)                                          (0x00000001&(data))

#define  HDMI_HDMI_BCHCR                                                         0x1800D094
#define  HDMI_HDMI_BCHCR_reg_addr                                                "0xB800D094"
#define  HDMI_HDMI_BCHCR_reg                                                     0xB800D094
#define  HDMI_HDMI_BCHCR_inst_addr                                               "0x0025"
#define  set_HDMI_HDMI_BCHCR_reg(data)                                           (*((volatile unsigned int*)HDMI_HDMI_BCHCR_reg)=data)
#define  get_HDMI_HDMI_BCHCR_reg                                                 (*((volatile unsigned int*)HDMI_HDMI_BCHCR_reg))
#define  HDMI_HDMI_BCHCR_spcss_shift                                             (5)
#define  HDMI_HDMI_BCHCR_enrwe_shift                                             (4)
#define  HDMI_HDMI_BCHCR_bche_shift                                              (3)
#define  HDMI_HDMI_BCHCR_bches_shift                                             (2)
#define  HDMI_HDMI_BCHCR_bches2_shift                                            (1)
#define  HDMI_HDMI_BCHCR_pe_shift                                                (0)
#define  HDMI_HDMI_BCHCR_spcss_mask                                              (0x00000020)
#define  HDMI_HDMI_BCHCR_enrwe_mask                                              (0x00000010)
#define  HDMI_HDMI_BCHCR_bche_mask                                               (0x00000008)
#define  HDMI_HDMI_BCHCR_bches_mask                                              (0x00000004)
#define  HDMI_HDMI_BCHCR_bches2_mask                                             (0x00000002)
#define  HDMI_HDMI_BCHCR_pe_mask                                                 (0x00000001)
#define  HDMI_HDMI_BCHCR_spcss(data)                                             (0x00000020&((data)<<5))
#define  HDMI_HDMI_BCHCR_enrwe(data)                                             (0x00000010&((data)<<4))
#define  HDMI_HDMI_BCHCR_bche(data)                                              (0x00000008&((data)<<3))
#define  HDMI_HDMI_BCHCR_bches(data)                                             (0x00000004&((data)<<2))
#define  HDMI_HDMI_BCHCR_bches2(data)                                            (0x00000002&((data)<<1))
#define  HDMI_HDMI_BCHCR_pe(data)                                                (0x00000001&(data))
#define  HDMI_HDMI_BCHCR_get_spcss(data)                                         ((0x00000020&(data))>>5)
#define  HDMI_HDMI_BCHCR_get_enrwe(data)                                         ((0x00000010&(data))>>4)
#define  HDMI_HDMI_BCHCR_get_bche(data)                                          ((0x00000008&(data))>>3)
#define  HDMI_HDMI_BCHCR_get_bches(data)                                         ((0x00000004&(data))>>2)
#define  HDMI_HDMI_BCHCR_get_bches2(data)                                        ((0x00000002&(data))>>1)
#define  HDMI_HDMI_BCHCR_get_pe(data)                                            (0x00000001&(data))

#define  HDMI_HDMI_AVMCR                                                         0x1800D098
#define  HDMI_HDMI_AVMCR_reg_addr                                                "0xB800D098"
#define  HDMI_HDMI_AVMCR_reg                                                     0xB800D098
#define  HDMI_HDMI_AVMCR_inst_addr                                               "0x0026"
#define  set_HDMI_HDMI_AVMCR_reg(data)                                           (*((volatile unsigned int*)HDMI_HDMI_AVMCR_reg)=data)
#define  get_HDMI_HDMI_AVMCR_reg                                                 (*((volatile unsigned int*)HDMI_HDMI_AVMCR_reg))
#define  HDMI_HDMI_AVMCR_wd_ptg_en_shift                                         (10)
#define  HDMI_HDMI_AVMCR_wd_vclk_en_shift                                        (9)
#define  HDMI_HDMI_AVMCR_avmute_flag_shift                                       (8)
#define  HDMI_HDMI_AVMCR_avmute_win_en_shift                                     (7)
#define  HDMI_HDMI_AVMCR_aoc_shift                                               (6)
#define  HDMI_HDMI_AVMCR_aomc_shift                                              (5)
#define  HDMI_HDMI_AVMCR_awd_shift                                               (4)
#define  HDMI_HDMI_AVMCR_ve_shift                                                (3)
#define  HDMI_HDMI_AVMCR_ampic_shift                                             (2)
#define  HDMI_HDMI_AVMCR_vdpic_shift                                             (1)
#define  HDMI_HDMI_AVMCR_nfpss_shift                                             (0)
#define  HDMI_HDMI_AVMCR_wd_ptg_en_mask                                          (0x00000400)
#define  HDMI_HDMI_AVMCR_wd_vclk_en_mask                                         (0x00000200)
#define  HDMI_HDMI_AVMCR_avmute_flag_mask                                        (0x00000100)
#define  HDMI_HDMI_AVMCR_avmute_win_en_mask                                      (0x00000080)
#define  HDMI_HDMI_AVMCR_aoc_mask                                                (0x00000040)
#define  HDMI_HDMI_AVMCR_aomc_mask                                               (0x00000020)
#define  HDMI_HDMI_AVMCR_awd_mask                                                (0x00000010)
#define  HDMI_HDMI_AVMCR_ve_mask                                                 (0x00000008)
#define  HDMI_HDMI_AVMCR_ampic_mask                                              (0x00000004)
#define  HDMI_HDMI_AVMCR_vdpic_mask                                              (0x00000002)
#define  HDMI_HDMI_AVMCR_nfpss_mask                                              (0x00000001)
#define  HDMI_HDMI_AVMCR_wd_ptg_en(data)                                         (0x00000400&((data)<<10))
#define  HDMI_HDMI_AVMCR_wd_vclk_en(data)                                        (0x00000200&((data)<<9))
#define  HDMI_HDMI_AVMCR_avmute_flag(data)                                       (0x00000100&((data)<<8))
#define  HDMI_HDMI_AVMCR_avmute_win_en(data)                                     (0x00000080&((data)<<7))
#define  HDMI_HDMI_AVMCR_aoc(data)                                               (0x00000040&((data)<<6))
#define  HDMI_HDMI_AVMCR_aomc(data)                                              (0x00000020&((data)<<5))
#define  HDMI_HDMI_AVMCR_awd(data)                                               (0x00000010&((data)<<4))
#define  HDMI_HDMI_AVMCR_ve(data)                                                (0x00000008&((data)<<3))
#define  HDMI_HDMI_AVMCR_ampic(data)                                             (0x00000004&((data)<<2))
#define  HDMI_HDMI_AVMCR_vdpic(data)                                             (0x00000002&((data)<<1))
#define  HDMI_HDMI_AVMCR_nfpss(data)                                             (0x00000001&(data))
#define  HDMI_HDMI_AVMCR_get_wd_ptg_en(data)                                     ((0x00000400&(data))>>10)
#define  HDMI_HDMI_AVMCR_get_wd_vclk_en(data)                                    ((0x00000200&(data))>>9)
#define  HDMI_HDMI_AVMCR_get_avmute_flag(data)                                   ((0x00000100&(data))>>8)
#define  HDMI_HDMI_AVMCR_get_avmute_win_en(data)                                 ((0x00000080&(data))>>7)
#define  HDMI_HDMI_AVMCR_get_aoc(data)                                           ((0x00000040&(data))>>6)
#define  HDMI_HDMI_AVMCR_get_aomc(data)                                          ((0x00000020&(data))>>5)
#define  HDMI_HDMI_AVMCR_get_awd(data)                                           ((0x00000010&(data))>>4)
#define  HDMI_HDMI_AVMCR_get_ve(data)                                            ((0x00000008&(data))>>3)
#define  HDMI_HDMI_AVMCR_get_ampic(data)                                         ((0x00000004&(data))>>2)
#define  HDMI_HDMI_AVMCR_get_vdpic(data)                                         ((0x00000002&(data))>>1)
#define  HDMI_HDMI_AVMCR_get_nfpss(data)                                         (0x00000001&(data))

#define  HDMI_HDMI_WDCR0                                                         0x1800D09C
#define  HDMI_HDMI_WDCR0_reg_addr                                                "0xB800D09C"
#define  HDMI_HDMI_WDCR0_reg                                                     0xB800D09C
#define  HDMI_HDMI_WDCR0_inst_addr                                               "0x0027"
#define  set_HDMI_HDMI_WDCR0_reg(data)                                           (*((volatile unsigned int*)HDMI_HDMI_WDCR0_reg)=data)
#define  get_HDMI_HDMI_WDCR0_reg                                                 (*((volatile unsigned int*)HDMI_HDMI_WDCR0_reg))
#define  HDMI_HDMI_WDCR0_wdm_shift                                               (27)
#define  HDMI_HDMI_WDCR0_wds_shift                                               (26)
#define  HDMI_HDMI_WDCR0_awdch_shift                                             (25)
#define  HDMI_HDMI_WDCR0_vwdch_shift                                             (24)
#define  HDMI_HDMI_WDCR0_vwdap_shift                                             (23)
#define  HDMI_HDMI_WDCR0_vwdlf_shift                                             (22)
#define  HDMI_HDMI_WDCR0_vwdafo_shift                                            (21)
#define  HDMI_HDMI_WDCR0_vwdafu_shift                                            (20)
#define  HDMI_HDMI_WDCR0_yv_shift                                                (16)
#define  HDMI_HDMI_WDCR0_awdck_shift                                             (15)
#define  HDMI_HDMI_WDCR0_awdlf_shift                                             (14)
#define  HDMI_HDMI_WDCR0_ch_st_sel_shift                                         (13)
#define  HDMI_HDMI_WDCR0_vwdact_shift                                            (12)
#define  HDMI_HDMI_WDCR0_xv_shift                                                (8)
#define  HDMI_HDMI_WDCR0_asmfe_shift                                             (7)
#define  HDMI_HDMI_WDCR0_load_d_shift                                            (6)
#define  HDMI_HDMI_WDCR0_bt_track_en_shift                                       (5)
#define  HDMI_HDMI_WDCR0_awdct_shift                                             (4)
#define  HDMI_HDMI_WDCR0_awdap_shift                                             (3)
#define  HDMI_HDMI_WDCR0_awdfo_shift                                             (2)
#define  HDMI_HDMI_WDCR0_awdfu_shift                                             (1)
#define  HDMI_HDMI_WDCR0_ct_shift                                                (0)
#define  HDMI_HDMI_WDCR0_wdm_mask                                                (0x08000000)
#define  HDMI_HDMI_WDCR0_wds_mask                                                (0x04000000)
#define  HDMI_HDMI_WDCR0_awdch_mask                                              (0x02000000)
#define  HDMI_HDMI_WDCR0_vwdch_mask                                              (0x01000000)
#define  HDMI_HDMI_WDCR0_vwdap_mask                                              (0x00800000)
#define  HDMI_HDMI_WDCR0_vwdlf_mask                                              (0x00400000)
#define  HDMI_HDMI_WDCR0_vwdafo_mask                                             (0x00200000)
#define  HDMI_HDMI_WDCR0_vwdafu_mask                                             (0x00100000)
#define  HDMI_HDMI_WDCR0_yv_mask                                                 (0x000F0000)
#define  HDMI_HDMI_WDCR0_awdck_mask                                              (0x00008000)
#define  HDMI_HDMI_WDCR0_awdlf_mask                                              (0x00004000)
#define  HDMI_HDMI_WDCR0_ch_st_sel_mask                                          (0x00002000)
#define  HDMI_HDMI_WDCR0_vwdact_mask                                             (0x00001000)
#define  HDMI_HDMI_WDCR0_xv_mask                                                 (0x00000F00)
#define  HDMI_HDMI_WDCR0_asmfe_mask                                              (0x00000080)
#define  HDMI_HDMI_WDCR0_load_d_mask                                             (0x00000040)
#define  HDMI_HDMI_WDCR0_bt_track_en_mask                                        (0x00000020)
#define  HDMI_HDMI_WDCR0_awdct_mask                                              (0x00000010)
#define  HDMI_HDMI_WDCR0_awdap_mask                                              (0x00000008)
#define  HDMI_HDMI_WDCR0_awdfo_mask                                              (0x00000004)
#define  HDMI_HDMI_WDCR0_awdfu_mask                                              (0x00000002)
#define  HDMI_HDMI_WDCR0_ct_mask                                                 (0x00000001)
#define  HDMI_HDMI_WDCR0_wdm(data)                                               (0x08000000&((data)<<27))
#define  HDMI_HDMI_WDCR0_wds(data)                                               (0x04000000&((data)<<26))
#define  HDMI_HDMI_WDCR0_awdch(data)                                             (0x02000000&((data)<<25))
#define  HDMI_HDMI_WDCR0_vwdch(data)                                             (0x01000000&((data)<<24))
#define  HDMI_HDMI_WDCR0_vwdap(data)                                             (0x00800000&((data)<<23))
#define  HDMI_HDMI_WDCR0_vwdlf(data)                                             (0x00400000&((data)<<22))
#define  HDMI_HDMI_WDCR0_vwdafo(data)                                            (0x00200000&((data)<<21))
#define  HDMI_HDMI_WDCR0_vwdafu(data)                                            (0x00100000&((data)<<20))
#define  HDMI_HDMI_WDCR0_yv(data)                                                (0x000F0000&((data)<<16))
#define  HDMI_HDMI_WDCR0_awdck(data)                                             (0x00008000&((data)<<15))
#define  HDMI_HDMI_WDCR0_awdlf(data)                                             (0x00004000&((data)<<14))
#define  HDMI_HDMI_WDCR0_ch_st_sel(data)                                         (0x00002000&((data)<<13))
#define  HDMI_HDMI_WDCR0_vwdact(data)                                            (0x00001000&((data)<<12))
#define  HDMI_HDMI_WDCR0_xv(data)                                                (0x00000F00&((data)<<8))
#define  HDMI_HDMI_WDCR0_asmfe(data)                                             (0x00000080&((data)<<7))
#define  HDMI_HDMI_WDCR0_load_d(data)                                            (0x00000040&((data)<<6))
#define  HDMI_HDMI_WDCR0_bt_track_en(data)                                       (0x00000020&((data)<<5))
#define  HDMI_HDMI_WDCR0_awdct(data)                                             (0x00000010&((data)<<4))
#define  HDMI_HDMI_WDCR0_awdap(data)                                             (0x00000008&((data)<<3))
#define  HDMI_HDMI_WDCR0_awdfo(data)                                             (0x00000004&((data)<<2))
#define  HDMI_HDMI_WDCR0_awdfu(data)                                             (0x00000002&((data)<<1))
#define  HDMI_HDMI_WDCR0_ct(data)                                                (0x00000001&(data))
#define  HDMI_HDMI_WDCR0_get_wdm(data)                                           ((0x08000000&(data))>>27)
#define  HDMI_HDMI_WDCR0_get_wds(data)                                           ((0x04000000&(data))>>26)
#define  HDMI_HDMI_WDCR0_get_awdch(data)                                         ((0x02000000&(data))>>25)
#define  HDMI_HDMI_WDCR0_get_vwdch(data)                                         ((0x01000000&(data))>>24)
#define  HDMI_HDMI_WDCR0_get_vwdap(data)                                         ((0x00800000&(data))>>23)
#define  HDMI_HDMI_WDCR0_get_vwdlf(data)                                         ((0x00400000&(data))>>22)
#define  HDMI_HDMI_WDCR0_get_vwdafo(data)                                        ((0x00200000&(data))>>21)
#define  HDMI_HDMI_WDCR0_get_vwdafu(data)                                        ((0x00100000&(data))>>20)
#define  HDMI_HDMI_WDCR0_get_yv(data)                                            ((0x000F0000&(data))>>16)
#define  HDMI_HDMI_WDCR0_get_awdck(data)                                         ((0x00008000&(data))>>15)
#define  HDMI_HDMI_WDCR0_get_awdlf(data)                                         ((0x00004000&(data))>>14)
#define  HDMI_HDMI_WDCR0_get_ch_st_sel(data)                                     ((0x00002000&(data))>>13)
#define  HDMI_HDMI_WDCR0_get_vwdact(data)                                        ((0x00001000&(data))>>12)
#define  HDMI_HDMI_WDCR0_get_xv(data)                                            ((0x00000F00&(data))>>8)
#define  HDMI_HDMI_WDCR0_get_asmfe(data)                                         ((0x00000080&(data))>>7)
#define  HDMI_HDMI_WDCR0_get_load_d(data)                                        ((0x00000040&(data))>>6)
#define  HDMI_HDMI_WDCR0_get_bt_track_en(data)                                   ((0x00000020&(data))>>5)
#define  HDMI_HDMI_WDCR0_get_awdct(data)                                         ((0x00000010&(data))>>4)
#define  HDMI_HDMI_WDCR0_get_awdap(data)                                         ((0x00000008&(data))>>3)
#define  HDMI_HDMI_WDCR0_get_awdfo(data)                                         ((0x00000004&(data))>>2)
#define  HDMI_HDMI_WDCR0_get_awdfu(data)                                         ((0x00000002&(data))>>1)
#define  HDMI_HDMI_WDCR0_get_ct(data)                                            (0x00000001&(data))

#define  HDMI_HDMI_DBCR                                                          0x1800D0A0
#define  HDMI_HDMI_DBCR_reg_addr                                                 "0xB800D0A0"
#define  HDMI_HDMI_DBCR_reg                                                      0xB800D0A0
#define  HDMI_HDMI_DBCR_inst_addr                                                "0x0028"
#define  set_HDMI_HDMI_DBCR_reg(data)                                            (*((volatile unsigned int*)HDMI_HDMI_DBCR_reg)=data)
#define  get_HDMI_HDMI_DBCR_reg                                                  (*((volatile unsigned int*)HDMI_HDMI_DBCR_reg))
#define  HDMI_HDMI_DBCR_aldbfv_shift                                             (3)
#define  HDMI_HDMI_DBCR_aldbfo_shift                                             (2)
#define  HDMI_HDMI_DBCR_aldbfu_shift                                             (1)
#define  HDMI_HDMI_DBCR_aldbpn_shift                                             (0)
#define  HDMI_HDMI_DBCR_aldbfv_mask                                              (0x00000008)
#define  HDMI_HDMI_DBCR_aldbfo_mask                                              (0x00000004)
#define  HDMI_HDMI_DBCR_aldbfu_mask                                              (0x00000002)
#define  HDMI_HDMI_DBCR_aldbpn_mask                                              (0x00000001)
#define  HDMI_HDMI_DBCR_aldbfv(data)                                             (0x00000008&((data)<<3))
#define  HDMI_HDMI_DBCR_aldbfo(data)                                             (0x00000004&((data)<<2))
#define  HDMI_HDMI_DBCR_aldbfu(data)                                             (0x00000002&((data)<<1))
#define  HDMI_HDMI_DBCR_aldbpn(data)                                             (0x00000001&(data))
#define  HDMI_HDMI_DBCR_get_aldbfv(data)                                         ((0x00000008&(data))>>3)
#define  HDMI_HDMI_DBCR_get_aldbfo(data)                                         ((0x00000004&(data))>>2)
#define  HDMI_HDMI_DBCR_get_aldbfu(data)                                         ((0x00000002&(data))>>1)
#define  HDMI_HDMI_DBCR_get_aldbpn(data)                                         (0x00000001&(data))

#define  HDMI_HDMI_AWDSR                                                         0x1800D0A4
#define  HDMI_HDMI_AWDSR_reg_addr                                                "0xB800D0A4"
#define  HDMI_HDMI_AWDSR_reg                                                     0xB800D0A4
#define  HDMI_HDMI_AWDSR_inst_addr                                               "0x0029"
#define  set_HDMI_HDMI_AWDSR_reg(data)                                           (*((volatile unsigned int*)HDMI_HDMI_AWDSR_reg)=data)
#define  get_HDMI_HDMI_AWDSR_reg                                                 (*((volatile unsigned int*)HDMI_HDMI_AWDSR_reg))
#define  HDMI_HDMI_AWDSR_awdpvsb_shift                                           (0)
#define  HDMI_HDMI_AWDSR_awdpvsb_mask                                            (0x0000007F)
#define  HDMI_HDMI_AWDSR_awdpvsb(data)                                           (0x0000007F&(data))
#define  HDMI_HDMI_AWDSR_get_awdpvsb(data)                                       (0x0000007F&(data))

#define  HDMI_HDMI_VWDSR                                                         0x1800D0A8
#define  HDMI_HDMI_VWDSR_reg_addr                                                "0xB800D0A8"
#define  HDMI_HDMI_VWDSR_reg                                                     0xB800D0A8
#define  HDMI_HDMI_VWDSR_inst_addr                                               "0x002A"
#define  set_HDMI_HDMI_VWDSR_reg(data)                                           (*((volatile unsigned int*)HDMI_HDMI_VWDSR_reg)=data)
#define  get_HDMI_HDMI_VWDSR_reg                                                 (*((volatile unsigned int*)HDMI_HDMI_VWDSR_reg))
#define  HDMI_HDMI_VWDSR_vwdpvsb_shift                                           (0)
#define  HDMI_HDMI_VWDSR_vwdpvsb_mask                                            (0x0000007F)
#define  HDMI_HDMI_VWDSR_vwdpvsb(data)                                           (0x0000007F&(data))
#define  HDMI_HDMI_VWDSR_get_vwdpvsb(data)                                       (0x0000007F&(data))

#define  HDMI_HDMI_PAMICR                                                        0x1800D0AC
#define  HDMI_HDMI_PAMICR_reg_addr                                               "0xB800D0AC"
#define  HDMI_HDMI_PAMICR_reg                                                    0xB800D0AC
#define  HDMI_HDMI_PAMICR_inst_addr                                              "0x002B"
#define  set_HDMI_HDMI_PAMICR_reg(data)                                          (*((volatile unsigned int*)HDMI_HDMI_PAMICR_reg)=data)
#define  get_HDMI_HDMI_PAMICR_reg                                                (*((volatile unsigned int*)HDMI_HDMI_PAMICR_reg))
#define  HDMI_HDMI_PAMICR_icpvsb_shift                                           (0)
#define  HDMI_HDMI_PAMICR_icpvsb_mask                                            (0x0000007F)
#define  HDMI_HDMI_PAMICR_icpvsb(data)                                           (0x0000007F&(data))
#define  HDMI_HDMI_PAMICR_get_icpvsb(data)                                       (0x0000007F&(data))

#define  HDMI_HDMI_PTRSV1                                                        0x1800D0B0
#define  HDMI_HDMI_PTRSV1_reg_addr                                               "0xB800D0B0"
#define  HDMI_HDMI_PTRSV1_reg                                                    0xB800D0B0
#define  HDMI_HDMI_PTRSV1_inst_addr                                              "0x002C"
#define  set_HDMI_HDMI_PTRSV1_reg(data)                                          (*((volatile unsigned int*)HDMI_HDMI_PTRSV1_reg)=data)
#define  get_HDMI_HDMI_PTRSV1_reg                                                (*((volatile unsigned int*)HDMI_HDMI_PTRSV1_reg))
//#define  HDMI_HDMI_PTRSV1_dummy_shift                                            (24)
//#define  HDMI_HDMI_PTRSV1_dummy_shift                                            (16)
#define  HDMI_HDMI_PTRSV1_pt2_shift                                              (8)
#define  HDMI_HDMI_PTRSV1_pt1_shift                                              (0)
//#define  HDMI_HDMI_PTRSV1_dummy_mask                                             (0xFF000000)
//#define  HDMI_HDMI_PTRSV1_dummy_mask                                             (0x00FF0000)
#define  HDMI_HDMI_PTRSV1_pt2_mask                                               (0x0000FF00)
#define  HDMI_HDMI_PTRSV1_pt1_mask                                               (0x000000FF)
//#define  HDMI_HDMI_PTRSV1_dummy(data)                                            (0xFF000000&((data)<<24))
//#define  HDMI_HDMI_PTRSV1_dummy(data)                                            (0x00FF0000&((data)<<16))
#define  HDMI_HDMI_PTRSV1_pt2(data)                                              (0x0000FF00&((data)<<8))
#define  HDMI_HDMI_PTRSV1_pt1(data)                                              (0x000000FF&(data))
//#define  HDMI_HDMI_PTRSV1_get_dummy(data)                                        ((0xFF000000&(data))>>24)
//#define  HDMI_HDMI_PTRSV1_get_dummy(data)                                        ((0x00FF0000&(data))>>16)
#define  HDMI_HDMI_PTRSV1_get_pt2(data)                                          ((0x0000FF00&(data))>>8)
#define  HDMI_HDMI_PTRSV1_get_pt1(data)                                          (0x000000FF&(data))

#define  HDMI_HDMI_PVGCR0                                                        0x1800D0B4
#define  HDMI_HDMI_PVGCR0_reg_addr                                               "0xB800D0B4"
#define  HDMI_HDMI_PVGCR0_reg                                                    0xB800D0B4
#define  HDMI_HDMI_PVGCR0_inst_addr                                              "0x002D"
#define  set_HDMI_HDMI_PVGCR0_reg(data)                                          (*((volatile unsigned int*)HDMI_HDMI_PVGCR0_reg)=data)
#define  get_HDMI_HDMI_PVGCR0_reg                                                (*((volatile unsigned int*)HDMI_HDMI_PVGCR0_reg))
#define  HDMI_HDMI_PVGCR0_pvsef_shift                                            (0)
#define  HDMI_HDMI_PVGCR0_pvsef_mask                                             (0xFFFFFFFF)
#define  HDMI_HDMI_PVGCR0_pvsef(data)                                            (0xFFFFFFFF&(data))
#define  HDMI_HDMI_PVGCR0_get_pvsef(data)                                        (0xFFFFFFFF&(data))

#define  HDMI_HDMI_PVSR0                                                         0x1800D0B8
#define  HDMI_HDMI_PVSR0_reg_addr                                                "0xB800D0B8"
#define  HDMI_HDMI_PVSR0_reg                                                     0xB800D0B8
#define  HDMI_HDMI_PVSR0_inst_addr                                               "0x002E"
#define  set_HDMI_HDMI_PVSR0_reg(data)                                           (*((volatile unsigned int*)HDMI_HDMI_PVSR0_reg)=data)
#define  get_HDMI_HDMI_PVSR0_reg                                                 (*((volatile unsigned int*)HDMI_HDMI_PVSR0_reg))
#define  HDMI_HDMI_PVSR0_pvs_shift                                               (0)
#define  HDMI_HDMI_PVSR0_pvs_mask                                                (0xFFFFFFFF)
#define  HDMI_HDMI_PVSR0_pvs(data)                                               (0xFFFFFFFF&(data))
#define  HDMI_HDMI_PVSR0_get_pvs(data)                                           (0xFFFFFFFF&(data))

#define  HDMI_HDMI_VCR                                                           0x1800D0BC
#define  HDMI_HDMI_VCR_reg_addr                                                  "0xB800D0BC"
#define  HDMI_HDMI_VCR_reg                                                       0xB800D0BC
#define  HDMI_HDMI_VCR_inst_addr                                                 "0x002F"
#define  set_HDMI_HDMI_VCR_reg(data)                                             (*((volatile unsigned int*)HDMI_HDMI_VCR_reg)=data)
#define  get_HDMI_HDMI_VCR_reg                                                   (*((volatile unsigned int*)HDMI_HDMI_VCR_reg))
#define  HDMI_HDMI_VCR_cbus_ddc_chsel_shift                                      (28)
#define  HDMI_HDMI_VCR_hdmi_field_shift                                          (27)
#define  HDMI_HDMI_VCR_int_pro_chg_flag_shift                                    (26)
#define  HDMI_HDMI_VCR_int_pro_chg_wd_en_shift                                   (25)
#define  HDMI_HDMI_VCR_int_pro_chg_int_en_shift                                  (24)
#define  HDMI_HDMI_VCR_hdcp_ddc_chsel_shift                                      (22)
#define  HDMI_HDMI_VCR_iclk_sel_shift                                            (20)
#define  HDMI_HDMI_VCR_csc_r_shift                                               (18)
#define  HDMI_HDMI_VCR_hdirq_shift                                               (17)
#define  HDMI_HDMI_VCR_csam_shift                                                (16)
#define  HDMI_HDMI_VCR_csc_shift                                                 (14)
#define  HDMI_HDMI_VCR_field_decide_sel_shift                                    (13)
#define  HDMI_HDMI_VCR_prdsam_shift                                              (12)
#define  HDMI_HDMI_VCR_dsc_r_shift                                               (8)
#define  HDMI_HDMI_VCR_eoi_shift                                                 (7)
#define  HDMI_HDMI_VCR_eot_shift                                                 (6)
#define  HDMI_HDMI_VCR_se_shift                                                  (5)
#define  HDMI_HDMI_VCR_rs_shift                                                  (4)
#define  HDMI_HDMI_VCR_dsc_shift                                                 (0)
#define  HDMI_HDMI_VCR_cbus_ddc_chsel_mask                                       (0x10000000)
#define  HDMI_HDMI_VCR_hdmi_field_mask                                           (0x08000000)
#define  HDMI_HDMI_VCR_int_pro_chg_flag_mask                                     (0x04000000)
#define  HDMI_HDMI_VCR_int_pro_chg_wd_en_mask                                    (0x02000000)
#define  HDMI_HDMI_VCR_int_pro_chg_int_en_mask                                   (0x01000000)
#define  HDMI_HDMI_VCR_hdcp_ddc_chsel_mask                                       (0x00C00000)
#define  HDMI_HDMI_VCR_iclk_sel_mask                                             (0x00300000)
#define  HDMI_HDMI_VCR_csc_r_mask                                                (0x000C0000)
#define  HDMI_HDMI_VCR_hdirq_mask                                                (0x00020000)
#define  HDMI_HDMI_VCR_csam_mask                                                 (0x00010000)
#define  HDMI_HDMI_VCR_csc_mask                                                  (0x0000C000)
#define  HDMI_HDMI_VCR_field_decide_sel_mask                                     (0x00002000)
#define  HDMI_HDMI_VCR_prdsam_mask                                               (0x00001000)
#define  HDMI_HDMI_VCR_dsc_r_mask                                                (0x00000F00)
#define  HDMI_HDMI_VCR_eoi_mask                                                  (0x00000080)
#define  HDMI_HDMI_VCR_eot_mask                                                  (0x00000040)
#define  HDMI_HDMI_VCR_se_mask                                                   (0x00000020)
#define  HDMI_HDMI_VCR_rs_mask                                                   (0x00000010)
#define  HDMI_HDMI_VCR_dsc_mask                                                  (0x0000000F)
#define  HDMI_HDMI_VCR_cbus_ddc_chsel(data)                                      (0x10000000&((data)<<28))
#define  HDMI_HDMI_VCR_hdmi_field(data)                                          (0x08000000&((data)<<27))
#define  HDMI_HDMI_VCR_int_pro_chg_flag(data)                                    (0x04000000&((data)<<26))
#define  HDMI_HDMI_VCR_int_pro_chg_wd_en(data)                                   (0x02000000&((data)<<25))
#define  HDMI_HDMI_VCR_int_pro_chg_int_en(data)                                  (0x01000000&((data)<<24))
#define  HDMI_HDMI_VCR_hdcp_ddc_chsel(data)                                      (0x00C00000&((data)<<22))
#define  HDMI_HDMI_VCR_iclk_sel(data)                                            (0x00300000&((data)<<20))
#define  HDMI_HDMI_VCR_csc_r(data)                                               (0x000C0000&((data)<<18))
#define  HDMI_HDMI_VCR_hdirq(data)                                               (0x00020000&((data)<<17))
#define  HDMI_HDMI_VCR_csam(data)                                                (0x00010000&((data)<<16))
#define  HDMI_HDMI_VCR_csc(data)                                                 (0x0000C000&((data)<<14))
#define  HDMI_HDMI_VCR_field_decide_sel(data)                                    (0x00002000&((data)<<13))
#define  HDMI_HDMI_VCR_prdsam(data)                                              (0x00001000&((data)<<12))
#define  HDMI_HDMI_VCR_dsc_r(data)                                               (0x00000F00&((data)<<8))
#define  HDMI_HDMI_VCR_eoi(data)                                                 (0x00000080&((data)<<7))
#define  HDMI_HDMI_VCR_eot(data)                                                 (0x00000040&((data)<<6))
#define  HDMI_HDMI_VCR_se(data)                                                  (0x00000020&((data)<<5))
#define  HDMI_HDMI_VCR_rs(data)                                                  (0x00000010&((data)<<4))
#define  HDMI_HDMI_VCR_dsc(data)                                                 (0x0000000F&(data))
#define  HDMI_HDMI_VCR_get_cbus_ddc_chsel(data)                                  ((0x10000000&(data))>>28)
#define  HDMI_HDMI_VCR_get_hdmi_field(data)                                      ((0x08000000&(data))>>27)
#define  HDMI_HDMI_VCR_get_int_pro_chg_flag(data)                                ((0x04000000&(data))>>26)
#define  HDMI_HDMI_VCR_get_int_pro_chg_wd_en(data)                               ((0x02000000&(data))>>25)
#define  HDMI_HDMI_VCR_get_int_pro_chg_int_en(data)                              ((0x01000000&(data))>>24)
#define  HDMI_HDMI_VCR_get_hdcp_ddc_chsel(data)                                  ((0x00C00000&(data))>>22)
#define  HDMI_HDMI_VCR_get_iclk_sel(data)                                        ((0x00300000&(data))>>20)
#define  HDMI_HDMI_VCR_get_csc_r(data)                                           ((0x000C0000&(data))>>18)
#define  HDMI_HDMI_VCR_get_hdirq(data)                                           ((0x00020000&(data))>>17)
#define  HDMI_HDMI_VCR_get_csam(data)                                            ((0x00010000&(data))>>16)
#define  HDMI_HDMI_VCR_get_csc(data)                                             ((0x0000C000&(data))>>14)
#define  HDMI_HDMI_VCR_get_field_decide_sel(data)                                ((0x00002000&(data))>>13)
#define  HDMI_HDMI_VCR_get_prdsam(data)                                          ((0x00001000&(data))>>12)
#define  HDMI_HDMI_VCR_get_dsc_r(data)                                           ((0x00000F00&(data))>>8)
#define  HDMI_HDMI_VCR_get_eoi(data)                                             ((0x00000080&(data))>>7)
#define  HDMI_HDMI_VCR_get_eot(data)                                             ((0x00000040&(data))>>6)
#define  HDMI_HDMI_VCR_get_se(data)                                              ((0x00000020&(data))>>5)
#define  HDMI_HDMI_VCR_get_rs(data)                                              ((0x00000010&(data))>>4)
#define  HDMI_HDMI_VCR_get_dsc(data)                                             (0x0000000F&(data))

#define  HDMI_HDMI_ACRCR                                                         0x1800D0C0
#define  HDMI_HDMI_ACRCR_reg_addr                                                "0xB800D0C0"
#define  HDMI_HDMI_ACRCR_reg                                                     0xB800D0C0
#define  HDMI_HDMI_ACRCR_inst_addr                                               "0x0030"
#define  set_HDMI_HDMI_ACRCR_reg(data)                                           (*((volatile unsigned int*)HDMI_HDMI_ACRCR_reg)=data)
#define  get_HDMI_HDMI_ACRCR_reg                                                 (*((volatile unsigned int*)HDMI_HDMI_ACRCR_reg))
#define  HDMI_HDMI_ACRCR_pucnr_shift                                             (1)
#define  HDMI_HDMI_ACRCR_pucsr_shift                                             (0)
#define  HDMI_HDMI_ACRCR_pucnr_mask                                              (0x00000002)
#define  HDMI_HDMI_ACRCR_pucsr_mask                                              (0x00000001)
#define  HDMI_HDMI_ACRCR_pucnr(data)                                             (0x00000002&((data)<<1))
#define  HDMI_HDMI_ACRCR_pucsr(data)                                             (0x00000001&(data))
#define  HDMI_HDMI_ACRCR_get_pucnr(data)                                         ((0x00000002&(data))>>1)
#define  HDMI_HDMI_ACRCR_get_pucsr(data)                                         (0x00000001&(data))

#define  HDMI_HDMI_ACRSR0                                                        0x1800D0C4
#define  HDMI_HDMI_ACRSR0_reg_addr                                               "0xB800D0C4"
#define  HDMI_HDMI_ACRSR0_reg                                                    0xB800D0C4
#define  HDMI_HDMI_ACRSR0_inst_addr                                              "0x0031"
#define  set_HDMI_HDMI_ACRSR0_reg(data)                                          (*((volatile unsigned int*)HDMI_HDMI_ACRSR0_reg)=data)
#define  get_HDMI_HDMI_ACRSR0_reg                                                (*((volatile unsigned int*)HDMI_HDMI_ACRSR0_reg))
#define  HDMI_HDMI_ACRSR0_cts_shift                                              (0)
#define  HDMI_HDMI_ACRSR0_cts_mask                                               (0x000FFFFF)
#define  HDMI_HDMI_ACRSR0_cts(data)                                              (0x000FFFFF&(data))
#define  HDMI_HDMI_ACRSR0_get_cts(data)                                          (0x000FFFFF&(data))

#define  HDMI_HDMI_ACRSR1                                                        0x1800D0C8
#define  HDMI_HDMI_ACRSR1_reg_addr                                               "0xB800D0C8"
#define  HDMI_HDMI_ACRSR1_reg                                                    0xB800D0C8
#define  HDMI_HDMI_ACRSR1_inst_addr                                              "0x0032"
#define  set_HDMI_HDMI_ACRSR1_reg(data)                                          (*((volatile unsigned int*)HDMI_HDMI_ACRSR1_reg)=data)
#define  get_HDMI_HDMI_ACRSR1_reg                                                (*((volatile unsigned int*)HDMI_HDMI_ACRSR1_reg))
#define  HDMI_HDMI_ACRSR1_n_shift                                                (0)
#define  HDMI_HDMI_ACRSR1_n_mask                                                 (0x000FFFFF)
#define  HDMI_HDMI_ACRSR1_n(data)                                                (0x000FFFFF&(data))
#define  HDMI_HDMI_ACRSR1_get_n(data)                                            (0x000FFFFF&(data))

#define  HDMI_HDMI_ACS0                                                          0x1800D0CC
#define  HDMI_HDMI_ACS0_reg_addr                                                 "0xB800D0CC"
#define  HDMI_HDMI_ACS0_reg                                                      0xB800D0CC
#define  HDMI_HDMI_ACS0_inst_addr                                                "0x0033"
#define  set_HDMI_HDMI_ACS0_reg(data)                                            (*((volatile unsigned int*)HDMI_HDMI_ACS0_reg)=data)
#define  get_HDMI_HDMI_ACS0_reg                                                  (*((volatile unsigned int*)HDMI_HDMI_ACS0_reg))
#define  HDMI_HDMI_ACS0_cs_shift                                                 (0)
#define  HDMI_HDMI_ACS0_cs_mask                                                  (0x0000FFFF)
#define  HDMI_HDMI_ACS0_cs(data)                                                 (0x0000FFFF&(data))
#define  HDMI_HDMI_ACS0_get_cs(data)                                             (0x0000FFFF&(data))

#define  HDMI_HDMI_ACS1                                                          0x1800D0D0
#define  HDMI_HDMI_ACS1_reg_addr                                                 "0xB800D0D0"
#define  HDMI_HDMI_ACS1_reg                                                      0xB800D0D0
#define  HDMI_HDMI_ACS1_inst_addr                                                "0x0034"
#define  set_HDMI_HDMI_ACS1_reg(data)                                            (*((volatile unsigned int*)HDMI_HDMI_ACS1_reg)=data)
#define  get_HDMI_HDMI_ACS1_reg                                                  (*((volatile unsigned int*)HDMI_HDMI_ACS1_reg))
#define  HDMI_HDMI_ACS1_cs_shift                                                 (0)
#define  HDMI_HDMI_ACS1_cs_mask                                                  (0x00FFFFFF)
#define  HDMI_HDMI_ACS1_cs(data)                                                 (0x00FFFFFF&(data))
#define  HDMI_HDMI_ACS1_get_cs(data)                                             (0x00FFFFFF&(data))

#define  HDMI_HDMI_INTCR                                                         0x1800D0D4
#define  HDMI_HDMI_INTCR_reg_addr                                                "0xB800D0D4"
#define  HDMI_HDMI_INTCR_reg                                                     0xB800D0D4
#define  HDMI_HDMI_INTCR_inst_addr                                               "0x0035"
#define  set_HDMI_HDMI_INTCR_reg(data)                                           (*((volatile unsigned int*)HDMI_HDMI_INTCR_reg)=data)
#define  get_HDMI_HDMI_INTCR_reg                                                 (*((volatile unsigned int*)HDMI_HDMI_INTCR_reg))
#define  HDMI_HDMI_INTCR_pending_shift                                           (7)
#define  HDMI_HDMI_INTCR_avmute_shift                                            (6)
#define  HDMI_HDMI_INTCR_fifod_shift                                             (5)
#define  HDMI_HDMI_INTCR_act_shift                                               (4)
#define  HDMI_HDMI_INTCR_apll_shift                                              (3)
#define  HDMI_HDMI_INTCR_afifoo_shift                                            (2)
#define  HDMI_HDMI_INTCR_afifou_shift                                            (1)
#define  HDMI_HDMI_INTCR_vc_shift                                                (0)
#define  HDMI_HDMI_INTCR_pending_mask                                            (0x00000080)
#define  HDMI_HDMI_INTCR_avmute_mask                                             (0x00000040)
#define  HDMI_HDMI_INTCR_fifod_mask                                              (0x00000020)
#define  HDMI_HDMI_INTCR_act_mask                                                (0x00000010)
#define  HDMI_HDMI_INTCR_apll_mask                                               (0x00000008)
#define  HDMI_HDMI_INTCR_afifoo_mask                                             (0x00000004)
#define  HDMI_HDMI_INTCR_afifou_mask                                             (0x00000002)
#define  HDMI_HDMI_INTCR_vc_mask                                                 (0x00000001)
#define  HDMI_HDMI_INTCR_pending(data)                                           (0x00000080&((data)<<7))
#define  HDMI_HDMI_INTCR_avmute(data)                                            (0x00000040&((data)<<6))
#define  HDMI_HDMI_INTCR_fifod(data)                                             (0x00000020&((data)<<5))
#define  HDMI_HDMI_INTCR_act(data)                                               (0x00000010&((data)<<4))
#define  HDMI_HDMI_INTCR_apll(data)                                              (0x00000008&((data)<<3))
#define  HDMI_HDMI_INTCR_afifoo(data)                                            (0x00000004&((data)<<2))
#define  HDMI_HDMI_INTCR_afifou(data)                                            (0x00000002&((data)<<1))
#define  HDMI_HDMI_INTCR_vc(data)                                                (0x00000001&(data))
#define  HDMI_HDMI_INTCR_get_pending(data)                                       ((0x00000080&(data))>>7)
#define  HDMI_HDMI_INTCR_get_avmute(data)                                        ((0x00000040&(data))>>6)
#define  HDMI_HDMI_INTCR_get_fifod(data)                                         ((0x00000020&(data))>>5)
#define  HDMI_HDMI_INTCR_get_act(data)                                           ((0x00000010&(data))>>4)
#define  HDMI_HDMI_INTCR_get_apll(data)                                          ((0x00000008&(data))>>3)
#define  HDMI_HDMI_INTCR_get_afifoo(data)                                        ((0x00000004&(data))>>2)
#define  HDMI_HDMI_INTCR_get_afifou(data)                                        ((0x00000002&(data))>>1)
#define  HDMI_HDMI_INTCR_get_vc(data)                                            (0x00000001&(data))

#define  HDMI_HDMI_ALCR                                                          0x1800D0D8
#define  HDMI_HDMI_ALCR_reg_addr                                                 "0xB800D0D8"
#define  HDMI_HDMI_ALCR_reg                                                      0xB800D0D8
#define  HDMI_HDMI_ALCR_inst_addr                                                "0x0036"
#define  set_HDMI_HDMI_ALCR_reg(data)                                            (*((volatile unsigned int*)HDMI_HDMI_ALCR_reg)=data)
#define  get_HDMI_HDMI_ALCR_reg                                                  (*((volatile unsigned int*)HDMI_HDMI_ALCR_reg))
#define  HDMI_HDMI_ALCR_lo1_shift                                                (6)
#define  HDMI_HDMI_ALCR_lo2_shift                                                (4)
#define  HDMI_HDMI_ALCR_lo3_shift                                                (2)
#define  HDMI_HDMI_ALCR_lo4_shift                                                (0)
#define  HDMI_HDMI_ALCR_lo1_mask                                                 (0x000000C0)
#define  HDMI_HDMI_ALCR_lo2_mask                                                 (0x00000030)
#define  HDMI_HDMI_ALCR_lo3_mask                                                 (0x0000000C)
#define  HDMI_HDMI_ALCR_lo4_mask                                                 (0x00000003)
#define  HDMI_HDMI_ALCR_lo1(data)                                                (0x000000C0&((data)<<6))
#define  HDMI_HDMI_ALCR_lo2(data)                                                (0x00000030&((data)<<4))
#define  HDMI_HDMI_ALCR_lo3(data)                                                (0x0000000C&((data)<<2))
#define  HDMI_HDMI_ALCR_lo4(data)                                                (0x00000003&(data))
#define  HDMI_HDMI_ALCR_get_lo1(data)                                            ((0x000000C0&(data))>>6)
#define  HDMI_HDMI_ALCR_get_lo2(data)                                            ((0x00000030&(data))>>4)
#define  HDMI_HDMI_ALCR_get_lo3(data)                                            ((0x0000000C&(data))>>2)
#define  HDMI_HDMI_ALCR_get_lo4(data)                                            (0x00000003&(data))

#define  HDMI_HDMI_AOCR                                                          0x1800D0DC
#define  HDMI_HDMI_AOCR_reg_addr                                                 "0xB800D0DC"
#define  HDMI_HDMI_AOCR_reg                                                      0xB800D0DC
#define  HDMI_HDMI_AOCR_inst_addr                                                "0x0037"
#define  set_HDMI_HDMI_AOCR_reg(data)                                            (*((volatile unsigned int*)HDMI_HDMI_AOCR_reg)=data)
#define  get_HDMI_HDMI_AOCR_reg                                                  (*((volatile unsigned int*)HDMI_HDMI_AOCR_reg))
#define  HDMI_HDMI_AOCR_i2s_clk_en_dvi_shift                                     (8)
#define  HDMI_HDMI_AOCR_spdifo1_shift                                            (7)
#define  HDMI_HDMI_AOCR_spdifo2_shift                                            (6)
#define  HDMI_HDMI_AOCR_spdifo3_shift                                            (5)
#define  HDMI_HDMI_AOCR_spdifo4_shift                                            (4)
#define  HDMI_HDMI_AOCR_i2so1_shift                                              (3)
#define  HDMI_HDMI_AOCR_i2so2_shift                                              (2)
#define  HDMI_HDMI_AOCR_i2so3_shift                                              (1)
#define  HDMI_HDMI_AOCR_i2so4_shift                                              (0)
#define  HDMI_HDMI_AOCR_i2s_clk_en_dvi_mask                                      (0x00000100)
#define  HDMI_HDMI_AOCR_spdifo1_mask                                             (0x00000080)
#define  HDMI_HDMI_AOCR_spdifo2_mask                                             (0x00000040)
#define  HDMI_HDMI_AOCR_spdifo3_mask                                             (0x00000020)
#define  HDMI_HDMI_AOCR_spdifo4_mask                                             (0x00000010)
#define  HDMI_HDMI_AOCR_i2so1_mask                                               (0x00000008)
#define  HDMI_HDMI_AOCR_i2so2_mask                                               (0x00000004)
#define  HDMI_HDMI_AOCR_i2so3_mask                                               (0x00000002)
#define  HDMI_HDMI_AOCR_i2so4_mask                                               (0x00000001)
#define  HDMI_HDMI_AOCR_i2s_clk_en_dvi(data)                                     (0x00000100&((data)<<8))
#define  HDMI_HDMI_AOCR_spdifo1(data)                                            (0x00000080&((data)<<7))
#define  HDMI_HDMI_AOCR_spdifo2(data)                                            (0x00000040&((data)<<6))
#define  HDMI_HDMI_AOCR_spdifo3(data)                                            (0x00000020&((data)<<5))
#define  HDMI_HDMI_AOCR_spdifo4(data)                                            (0x00000010&((data)<<4))
#define  HDMI_HDMI_AOCR_i2so1(data)                                              (0x00000008&((data)<<3))
#define  HDMI_HDMI_AOCR_i2so2(data)                                              (0x00000004&((data)<<2))
#define  HDMI_HDMI_AOCR_i2so3(data)                                              (0x00000002&((data)<<1))
#define  HDMI_HDMI_AOCR_i2so4(data)                                              (0x00000001&(data))
#define  HDMI_HDMI_AOCR_get_i2s_clk_en_dvi(data)                                 ((0x00000100&(data))>>8)
#define  HDMI_HDMI_AOCR_get_spdifo1(data)                                        ((0x00000080&(data))>>7)
#define  HDMI_HDMI_AOCR_get_spdifo2(data)                                        ((0x00000040&(data))>>6)
#define  HDMI_HDMI_AOCR_get_spdifo3(data)                                        ((0x00000020&(data))>>5)
#define  HDMI_HDMI_AOCR_get_spdifo4(data)                                        ((0x00000010&(data))>>4)
#define  HDMI_HDMI_AOCR_get_i2so1(data)                                          ((0x00000008&(data))>>3)
#define  HDMI_HDMI_AOCR_get_i2so2(data)                                          ((0x00000004&(data))>>2)
#define  HDMI_HDMI_AOCR_get_i2so3(data)                                          ((0x00000002&(data))>>1)
#define  HDMI_HDMI_AOCR_get_i2so4(data)                                          (0x00000001&(data))

#define  HDMI_HDMI_BCSR                                                          0x1800D0E0
#define  HDMI_HDMI_BCSR_reg_addr                                                 "0xB800D0E0"
#define  HDMI_HDMI_BCSR_reg                                                      0xB800D0E0
#define  HDMI_HDMI_BCSR_inst_addr                                                "0x0038"
#define  set_HDMI_HDMI_BCSR_reg(data)                                            (*((volatile unsigned int*)HDMI_HDMI_BCSR_reg)=data)
#define  get_HDMI_HDMI_BCSR_reg                                                  (*((volatile unsigned int*)HDMI_HDMI_BCSR_reg))
#define  HDMI_HDMI_BCSR_nvlgb_shift                                              (5)
#define  HDMI_HDMI_BCSR_nalgb_shift                                              (4)
#define  HDMI_HDMI_BCSR_natgb_shift                                              (3)
#define  HDMI_HDMI_BCSR_ngb_shift                                                (2)
#define  HDMI_HDMI_BCSR_pe_shift                                                 (1)
#define  HDMI_HDMI_BCSR_gcp_shift                                                (0)
#define  HDMI_HDMI_BCSR_nvlgb_mask                                               (0x00000020)
#define  HDMI_HDMI_BCSR_nalgb_mask                                               (0x00000010)
#define  HDMI_HDMI_BCSR_natgb_mask                                               (0x00000008)
#define  HDMI_HDMI_BCSR_ngb_mask                                                 (0x00000004)
#define  HDMI_HDMI_BCSR_pe_mask                                                  (0x00000002)
#define  HDMI_HDMI_BCSR_gcp_mask                                                 (0x00000001)
#define  HDMI_HDMI_BCSR_nvlgb(data)                                              (0x00000020&((data)<<5))
#define  HDMI_HDMI_BCSR_nalgb(data)                                              (0x00000010&((data)<<4))
#define  HDMI_HDMI_BCSR_natgb(data)                                              (0x00000008&((data)<<3))
#define  HDMI_HDMI_BCSR_ngb(data)                                                (0x00000004&((data)<<2))
#define  HDMI_HDMI_BCSR_pe(data)                                                 (0x00000002&((data)<<1))
#define  HDMI_HDMI_BCSR_gcp(data)                                                (0x00000001&(data))
#define  HDMI_HDMI_BCSR_get_nvlgb(data)                                          ((0x00000020&(data))>>5)
#define  HDMI_HDMI_BCSR_get_nalgb(data)                                          ((0x00000010&(data))>>4)
#define  HDMI_HDMI_BCSR_get_natgb(data)                                          ((0x00000008&(data))>>3)
#define  HDMI_HDMI_BCSR_get_ngb(data)                                            ((0x00000004&(data))>>2)
#define  HDMI_HDMI_BCSR_get_pe(data)                                             ((0x00000002&(data))>>1)
#define  HDMI_HDMI_BCSR_get_gcp(data)                                            (0x00000001&(data))

#define  HDMI_HDMI_ASR0                                                          0x1800D0E4
#define  HDMI_HDMI_ASR0_reg_addr                                                 "0xB800D0E4"
#define  HDMI_HDMI_ASR0_reg                                                      0xB800D0E4
#define  HDMI_HDMI_ASR0_inst_addr                                                "0x0039"
#define  set_HDMI_HDMI_ASR0_reg(data)                                            (*((volatile unsigned int*)HDMI_HDMI_ASR0_reg)=data)
#define  get_HDMI_HDMI_ASR0_reg                                                  (*((volatile unsigned int*)HDMI_HDMI_ASR0_reg))
#define  HDMI_HDMI_ASR0_fsre_shift                                               (2)
#define  HDMI_HDMI_ASR0_fsif_shift                                               (1)
#define  HDMI_HDMI_ASR0_fscs_shift                                               (0)
#define  HDMI_HDMI_ASR0_fsre_mask                                                (0x00000004)
#define  HDMI_HDMI_ASR0_fsif_mask                                                (0x00000002)
#define  HDMI_HDMI_ASR0_fscs_mask                                                (0x00000001)
#define  HDMI_HDMI_ASR0_fsre(data)                                               (0x00000004&((data)<<2))
#define  HDMI_HDMI_ASR0_fsif(data)                                               (0x00000002&((data)<<1))
#define  HDMI_HDMI_ASR0_fscs(data)                                               (0x00000001&(data))
#define  HDMI_HDMI_ASR0_get_fsre(data)                                           ((0x00000004&(data))>>2)
#define  HDMI_HDMI_ASR0_get_fsif(data)                                           ((0x00000002&(data))>>1)
#define  HDMI_HDMI_ASR0_get_fscs(data)                                           (0x00000001&(data))

#define  HDMI_HDMI_ASR1                                                          0x1800D0E8
#define  HDMI_HDMI_ASR1_reg_addr                                                 "0xB800D0E8"
#define  HDMI_HDMI_ASR1_reg                                                      0xB800D0E8
#define  HDMI_HDMI_ASR1_inst_addr                                                "0x003A"
#define  set_HDMI_HDMI_ASR1_reg(data)                                            (*((volatile unsigned int*)HDMI_HDMI_ASR1_reg)=data)
#define  get_HDMI_HDMI_ASR1_reg                                                  (*((volatile unsigned int*)HDMI_HDMI_ASR1_reg))
#define  HDMI_HDMI_ASR1_fbif_shift                                               (4)
#define  HDMI_HDMI_ASR1_fbcs_shift                                               (0)
#define  HDMI_HDMI_ASR1_fbif_mask                                                (0x00000070)
#define  HDMI_HDMI_ASR1_fbcs_mask                                                (0x0000000F)
#define  HDMI_HDMI_ASR1_fbif(data)                                               (0x00000070&((data)<<4))
#define  HDMI_HDMI_ASR1_fbcs(data)                                               (0x0000000F&(data))
#define  HDMI_HDMI_ASR1_get_fbif(data)                                           ((0x00000070&(data))>>4)
#define  HDMI_HDMI_ASR1_get_fbcs(data)                                           (0x0000000F&(data))

#define  HDMI_HDMI_VIDEO_FORMAT                                                  0x1800D0EC
#define  HDMI_HDMI_VIDEO_FORMAT_reg_addr                                         "0xB800D0EC"
#define  HDMI_HDMI_VIDEO_FORMAT_reg                                              0xB800D0EC
#define  HDMI_HDMI_VIDEO_FORMAT_inst_addr                                        "0x003B"
#define  set_HDMI_HDMI_VIDEO_FORMAT_reg(data)                                    (*((volatile unsigned int*)HDMI_HDMI_VIDEO_FORMAT_reg)=data)
#define  get_HDMI_HDMI_VIDEO_FORMAT_reg                                          (*((volatile unsigned int*)HDMI_HDMI_VIDEO_FORMAT_reg))
#define  HDMI_HDMI_VIDEO_FORMAT_hvf_shift                                        (8)
#define  HDMI_HDMI_VIDEO_FORMAT_hdmi_vic_shift                                   (0)
#define  HDMI_HDMI_VIDEO_FORMAT_hvf_mask                                         (0x00000700)
#define  HDMI_HDMI_VIDEO_FORMAT_hdmi_vic_mask                                    (0x000000FF)
#define  HDMI_HDMI_VIDEO_FORMAT_hvf(data)                                        (0x00000700&((data)<<8))
#define  HDMI_HDMI_VIDEO_FORMAT_hdmi_vic(data)                                   (0x000000FF&(data))
#define  HDMI_HDMI_VIDEO_FORMAT_get_hvf(data)                                    ((0x00000700&(data))>>8)
#define  HDMI_HDMI_VIDEO_FORMAT_get_hdmi_vic(data)                               (0x000000FF&(data))

#define  HDMI_HDMI_3D_FORMAT                                                     0x1800D0F0
#define  HDMI_HDMI_3D_FORMAT_reg_addr                                            "0xB800D0F0"
#define  HDMI_HDMI_3D_FORMAT_reg                                                 0xB800D0F0
#define  HDMI_HDMI_3D_FORMAT_inst_addr                                           "0x003C"
#define  set_HDMI_HDMI_3D_FORMAT_reg(data)                                       (*((volatile unsigned int*)HDMI_HDMI_3D_FORMAT_reg)=data)
#define  get_HDMI_HDMI_3D_FORMAT_reg                                             (*((volatile unsigned int*)HDMI_HDMI_3D_FORMAT_reg))
#define  HDMI_HDMI_3D_FORMAT_hdmi_3d_ext_data_shift                              (12)
#define  HDMI_HDMI_3D_FORMAT_hdmi_3d_metadata_type_shift                         (9)
#define  HDMI_HDMI_3D_FORMAT_hdmi_3d_structure_shift                             (4)
#define  HDMI_HDMI_3D_FORMAT_hdmi_3d_meta_present_shift                          (3)
#define  HDMI_HDMI_3D_FORMAT_hdmi_3d_ext_data_mask                               (0x0000F000)
#define  HDMI_HDMI_3D_FORMAT_hdmi_3d_metadata_type_mask                          (0x00000E00)
#define  HDMI_HDMI_3D_FORMAT_hdmi_3d_structure_mask                              (0x000000F0)
#define  HDMI_HDMI_3D_FORMAT_hdmi_3d_meta_present_mask                           (0x00000008)
#define  HDMI_HDMI_3D_FORMAT_hdmi_3d_ext_data(data)                              (0x0000F000&((data)<<12))
#define  HDMI_HDMI_3D_FORMAT_hdmi_3d_metadata_type(data)                         (0x00000E00&((data)<<9))
#define  HDMI_HDMI_3D_FORMAT_hdmi_3d_structure(data)                             (0x000000F0&((data)<<4))
#define  HDMI_HDMI_3D_FORMAT_hdmi_3d_meta_present(data)                          (0x00000008&((data)<<3))
#define  HDMI_HDMI_3D_FORMAT_get_hdmi_3d_ext_data(data)                          ((0x0000F000&(data))>>12)
#define  HDMI_HDMI_3D_FORMAT_get_hdmi_3d_metadata_type(data)                     ((0x00000E00&(data))>>9)
#define  HDMI_HDMI_3D_FORMAT_get_hdmi_3d_structure(data)                         ((0x000000F0&(data))>>4)
#define  HDMI_HDMI_3D_FORMAT_get_hdmi_3d_meta_present(data)                      ((0x00000008&(data))>>3)

#define  HDMI_HDMI_FVSI                                                          0x1800D0F4
#define  HDMI_HDMI_FVSI_reg_addr                                                 "0xB800D0F4"
#define  HDMI_HDMI_FVSI_reg                                                      0xB800D0F4
#define  HDMI_HDMI_FVSI_inst_addr                                                "0x003D"
#define  set_HDMI_HDMI_FVSI_reg(data)                                            (*((volatile unsigned int*)HDMI_HDMI_FVSI_reg)=data)
#define  get_HDMI_HDMI_FVSI_reg                                                  (*((volatile unsigned int*)HDMI_HDMI_FVSI_reg))
#define  HDMI_HDMI_FVSI_info_3d_preferred2dview_shift                            (13)
#define  HDMI_HDMI_FVSI_info_3d_viewdependency_shift                             (11)
#define  HDMI_HDMI_FVSI_info_3d_dualview_shift                                   (10)
#define  HDMI_HDMI_FVSI_info_3d_additionalinfo_present_shift                     (9)
#define  HDMI_HDMI_FVSI_info_3d_f_ext_data_shift                                 (5)
#define  HDMI_HDMI_FVSI_info_3d_f_structure_shift                                (1)
#define  HDMI_HDMI_FVSI_info_3d_valid_shift                                      (0)
#define  HDMI_HDMI_FVSI_info_3d_preferred2dview_mask                             (0x00006000)
#define  HDMI_HDMI_FVSI_info_3d_viewdependency_mask                              (0x00001800)
#define  HDMI_HDMI_FVSI_info_3d_dualview_mask                                    (0x00000400)
#define  HDMI_HDMI_FVSI_info_3d_additionalinfo_present_mask                      (0x00000200)
#define  HDMI_HDMI_FVSI_info_3d_f_ext_data_mask                                  (0x000001E0)
#define  HDMI_HDMI_FVSI_info_3d_f_structure_mask                                 (0x0000001E)
#define  HDMI_HDMI_FVSI_info_3d_valid_mask                                       (0x00000001)
#define  HDMI_HDMI_FVSI_info_3d_preferred2dview(data)                            (0x00006000&((data)<<13))
#define  HDMI_HDMI_FVSI_info_3d_viewdependency(data)                             (0x00001800&((data)<<11))
#define  HDMI_HDMI_FVSI_info_3d_dualview(data)                                   (0x00000400&((data)<<10))
#define  HDMI_HDMI_FVSI_info_3d_additionalinfo_present(data)                     (0x00000200&((data)<<9))
#define  HDMI_HDMI_FVSI_info_3d_f_ext_data(data)                                 (0x000001E0&((data)<<5))
#define  HDMI_HDMI_FVSI_info_3d_f_structure(data)                                (0x0000001E&((data)<<1))
#define  HDMI_HDMI_FVSI_info_3d_valid(data)                                      (0x00000001&(data))
#define  HDMI_HDMI_FVSI_get_info_3d_preferred2dview(data)                        ((0x00006000&(data))>>13)
#define  HDMI_HDMI_FVSI_get_info_3d_viewdependency(data)                         ((0x00001800&(data))>>11)
#define  HDMI_HDMI_FVSI_get_info_3d_dualview(data)                               ((0x00000400&(data))>>10)
#define  HDMI_HDMI_FVSI_get_info_3d_additionalinfo_present(data)                 ((0x00000200&(data))>>9)
#define  HDMI_HDMI_FVSI_get_info_3d_f_ext_data(data)                             ((0x000001E0&(data))>>5)
#define  HDMI_HDMI_FVSI_get_info_3d_f_structure(data)                            ((0x0000001E&(data))>>1)
#define  HDMI_HDMI_FVSI_get_info_3d_valid(data)                                  (0x00000001&(data))

#define  HDMI_CH_CR                                                              0x1800D0F8
#define  HDMI_CH_CR_reg_addr                                                     "0xB800D0F8"
#define  HDMI_CH_CR_reg                                                          0xB800D0F8
#define  HDMI_CH_CR_inst_addr                                                    "0x003E"
#define  set_HDMI_CH_CR_reg(data)                                                (*((volatile unsigned int*)HDMI_CH_CR_reg)=data)
#define  get_HDMI_CH_CR_reg                                                      (*((volatile unsigned int*)HDMI_CH_CR_reg))
#define  HDMI_CH_CR_r_ch_afifo_en_shift                                          (24)
#define  HDMI_CH_CR_g_ch_afifo_en_shift                                          (23)
#define  HDMI_CH_CR_b_ch_afifo_en_shift                                          (22)
#define  HDMI_CH_CR_ch_sync_sel_shift                                            (20)
//#define  HDMI_CH_CR_dummy_shift                                                  (17)
#define  HDMI_CH_CR_rden_thr_shift                                               (12)
//#define  HDMI_CH_CR_dummy_shift                                                  (9)
#define  HDMI_CH_CR_udwater_thr_shift                                            (4)
//#define  HDMI_CH_CR_dummy_shift                                                  (2)
#define  HDMI_CH_CR_flush_shift                                                  (1)
#define  HDMI_CH_CR_ch_afifo_irq_en_shift                                        (0)
#define  HDMI_CH_CR_r_ch_afifo_en_mask                                           (0x01000000)
#define  HDMI_CH_CR_g_ch_afifo_en_mask                                           (0x00800000)
#define  HDMI_CH_CR_b_ch_afifo_en_mask                                           (0x00400000)
#define  HDMI_CH_CR_ch_sync_sel_mask                                             (0x00300000)
//#define  HDMI_CH_CR_dummy_mask                                                   (0x000E0000)
#define  HDMI_CH_CR_rden_thr_mask                                                (0x0001F000)
#define  HDMI_CH_CR_dummy_mask                                                   (0x00000E00)
#define  HDMI_CH_CR_udwater_thr_mask                                             (0x000001F0)
//#define  HDMI_CH_CR_dummy_mask                                                   (0x0000000C)
#define  HDMI_CH_CR_flush_mask                                                   (0x00000002)
#define  HDMI_CH_CR_ch_afifo_irq_en_mask                                         (0x00000001)
#define  HDMI_CH_CR_r_ch_afifo_en(data)                                          (0x01000000&((data)<<24))
#define  HDMI_CH_CR_g_ch_afifo_en(data)                                          (0x00800000&((data)<<23))
#define  HDMI_CH_CR_b_ch_afifo_en(data)                                          (0x00400000&((data)<<22))
#define  HDMI_CH_CR_ch_sync_sel(data)                                            (0x00300000&((data)<<20))
//#define  HDMI_CH_CR_dummy(data)                                                  (0x000E0000&((data)<<17))
#define  HDMI_CH_CR_rden_thr(data)                                               (0x0001F000&((data)<<12))
//#define  HDMI_CH_CR_dummy(data)                                                  (0x00000E00&((data)<<9))
#define  HDMI_CH_CR_udwater_thr(data)                                            (0x000001F0&((data)<<4))
//#define  HDMI_CH_CR_dummy(data)                                                  (0x0000000C&((data)<<2))
#define  HDMI_CH_CR_flush(data)                                                  (0x00000002&((data)<<1))
#define  HDMI_CH_CR_ch_afifo_irq_en(data)                                        (0x00000001&(data))
#define  HDMI_CH_CR_get_r_ch_afifo_en(data)                                      ((0x01000000&(data))>>24)
#define  HDMI_CH_CR_get_g_ch_afifo_en(data)                                      ((0x00800000&(data))>>23)
#define  HDMI_CH_CR_get_b_ch_afifo_en(data)                                      ((0x00400000&(data))>>22)
#define  HDMI_CH_CR_get_ch_sync_sel(data)                                        ((0x00300000&(data))>>20)
//#define  HDMI_CH_CR_get_dummy(data)                                              ((0x000E0000&(data))>>17)
#define  HDMI_CH_CR_get_rden_thr(data)                                           ((0x0001F000&(data))>>12)
//#define  HDMI_CH_CR_get_dummy(data)                                              ((0x00000E00&(data))>>9)
#define  HDMI_CH_CR_get_udwater_thr(data)                                        ((0x000001F0&(data))>>4)
//#define  HDMI_CH_CR_get_dummy(data)                                              ((0x0000000C&(data))>>2)
#define  HDMI_CH_CR_get_flush(data)                                              ((0x00000002&(data))>>1)
#define  HDMI_CH_CR_get_ch_afifo_irq_en(data)                                    (0x00000001&(data))

#define  HDMI_CH_SR                                                              0x1800D0FC
#define  HDMI_CH_SR_reg_addr                                                     "0xB800D0FC"
#define  HDMI_CH_SR_reg                                                          0xB800D0FC
#define  HDMI_CH_SR_inst_addr                                                    "0x003F"
#define  set_HDMI_CH_SR_reg(data)                                                (*((volatile unsigned int*)HDMI_CH_SR_reg)=data)
#define  get_HDMI_CH_SR_reg                                                      (*((volatile unsigned int*)HDMI_CH_SR_reg))
#define  HDMI_CH_SR_rgb_de_align_flag_shift                                      (30)
#define  HDMI_CH_SR_r_rwclk_det_timeout_flag_shift                               (29)
#define  HDMI_CH_SR_r_wrclk_det_timeout_flag_shift                               (28)
#define  HDMI_CH_SR_g_rwclk_det_timeout_flag_shift                               (27)
#define  HDMI_CH_SR_g_wrclk_det_timeout_flag_shift                               (26)
#define  HDMI_CH_SR_b_rwclk_det_timeout_flag_shift                               (25)
#define  HDMI_CH_SR_b_wrclk_det_timeout_flag_shift                               (24)
#define  HDMI_CH_SR_r_rudflow_flag_shift                                         (23)
#define  HDMI_CH_SR_r_wovflow_flag_shift                                         (22)
#define  HDMI_CH_SR_r_rflush_flag_shift                                          (21)
#define  HDMI_CH_SR_r_rw_water_lv_shift                                          (16)
#define  HDMI_CH_SR_g_rudflow_flag_shift                                         (15)
#define  HDMI_CH_SR_g_wovflow_flag_shift                                         (14)
#define  HDMI_CH_SR_g_rflush_flag_shift                                          (13)
#define  HDMI_CH_SR_g_rw_water_lv_shift                                          (8)
#define  HDMI_CH_SR_b_rudflow_flag_shift                                         (7)
#define  HDMI_CH_SR_b_wovflow_flag_shift                                         (6)
#define  HDMI_CH_SR_b_rflush_flag_shift                                          (5)
#define  HDMI_CH_SR_b_rw_water_lv_shift                                          (0)
#define  HDMI_CH_SR_rgb_de_align_flag_mask                                       (0x40000000)
#define  HDMI_CH_SR_r_rwclk_det_timeout_flag_mask                                (0x20000000)
#define  HDMI_CH_SR_r_wrclk_det_timeout_flag_mask                                (0x10000000)
#define  HDMI_CH_SR_g_rwclk_det_timeout_flag_mask                                (0x08000000)
#define  HDMI_CH_SR_g_wrclk_det_timeout_flag_mask                                (0x04000000)
#define  HDMI_CH_SR_b_rwclk_det_timeout_flag_mask                                (0x02000000)
#define  HDMI_CH_SR_b_wrclk_det_timeout_flag_mask                                (0x01000000)
#define  HDMI_CH_SR_r_rudflow_flag_mask                                          (0x00800000)
#define  HDMI_CH_SR_r_wovflow_flag_mask                                          (0x00400000)
#define  HDMI_CH_SR_r_rflush_flag_mask                                           (0x00200000)
#define  HDMI_CH_SR_r_rw_water_lv_mask                                           (0x001F0000)
#define  HDMI_CH_SR_g_rudflow_flag_mask                                          (0x00008000)
#define  HDMI_CH_SR_g_wovflow_flag_mask                                          (0x00004000)
#define  HDMI_CH_SR_g_rflush_flag_mask                                           (0x00002000)
#define  HDMI_CH_SR_g_rw_water_lv_mask                                           (0x00001F00)
#define  HDMI_CH_SR_b_rudflow_flag_mask                                          (0x00000080)
#define  HDMI_CH_SR_b_wovflow_flag_mask                                          (0x00000040)
#define  HDMI_CH_SR_b_rflush_flag_mask                                           (0x00000020)
#define  HDMI_CH_SR_b_rw_water_lv_mask                                           (0x0000001F)
#define  HDMI_CH_SR_rgb_de_align_flag(data)                                      (0x40000000&((data)<<30))
#define  HDMI_CH_SR_r_rwclk_det_timeout_flag(data)                               (0x20000000&((data)<<29))
#define  HDMI_CH_SR_r_wrclk_det_timeout_flag(data)                               (0x10000000&((data)<<28))
#define  HDMI_CH_SR_g_rwclk_det_timeout_flag(data)                               (0x08000000&((data)<<27))
#define  HDMI_CH_SR_g_wrclk_det_timeout_flag(data)                               (0x04000000&((data)<<26))
#define  HDMI_CH_SR_b_rwclk_det_timeout_flag(data)                               (0x02000000&((data)<<25))
#define  HDMI_CH_SR_b_wrclk_det_timeout_flag(data)                               (0x01000000&((data)<<24))
#define  HDMI_CH_SR_r_rudflow_flag(data)                                         (0x00800000&((data)<<23))
#define  HDMI_CH_SR_r_wovflow_flag(data)                                         (0x00400000&((data)<<22))
#define  HDMI_CH_SR_r_rflush_flag(data)                                          (0x00200000&((data)<<21))
#define  HDMI_CH_SR_r_rw_water_lv(data)                                          (0x001F0000&((data)<<16))
#define  HDMI_CH_SR_g_rudflow_flag(data)                                         (0x00008000&((data)<<15))
#define  HDMI_CH_SR_g_wovflow_flag(data)                                         (0x00004000&((data)<<14))
#define  HDMI_CH_SR_g_rflush_flag(data)                                          (0x00002000&((data)<<13))
#define  HDMI_CH_SR_g_rw_water_lv(data)                                          (0x00001F00&((data)<<8))
#define  HDMI_CH_SR_b_rudflow_flag(data)                                         (0x00000080&((data)<<7))
#define  HDMI_CH_SR_b_wovflow_flag(data)                                         (0x00000040&((data)<<6))
#define  HDMI_CH_SR_b_rflush_flag(data)                                          (0x00000020&((data)<<5))
#define  HDMI_CH_SR_b_rw_water_lv(data)                                          (0x0000001F&(data))
#define  HDMI_CH_SR_get_rgb_de_align_flag(data)                                  ((0x40000000&(data))>>30)
#define  HDMI_CH_SR_get_r_rwclk_det_timeout_flag(data)                           ((0x20000000&(data))>>29)
#define  HDMI_CH_SR_get_r_wrclk_det_timeout_flag(data)                           ((0x10000000&(data))>>28)
#define  HDMI_CH_SR_get_g_rwclk_det_timeout_flag(data)                           ((0x08000000&(data))>>27)
#define  HDMI_CH_SR_get_g_wrclk_det_timeout_flag(data)                           ((0x04000000&(data))>>26)
#define  HDMI_CH_SR_get_b_rwclk_det_timeout_flag(data)                           ((0x02000000&(data))>>25)
#define  HDMI_CH_SR_get_b_wrclk_det_timeout_flag(data)                           ((0x01000000&(data))>>24)
#define  HDMI_CH_SR_get_r_rudflow_flag(data)                                     ((0x00800000&(data))>>23)
#define  HDMI_CH_SR_get_r_wovflow_flag(data)                                     ((0x00400000&(data))>>22)
#define  HDMI_CH_SR_get_r_rflush_flag(data)                                      ((0x00200000&(data))>>21)
#define  HDMI_CH_SR_get_r_rw_water_lv(data)                                      ((0x001F0000&(data))>>16)
#define  HDMI_CH_SR_get_g_rudflow_flag(data)                                     ((0x00008000&(data))>>15)
#define  HDMI_CH_SR_get_g_wovflow_flag(data)                                     ((0x00004000&(data))>>14)
#define  HDMI_CH_SR_get_g_rflush_flag(data)                                      ((0x00002000&(data))>>13)
#define  HDMI_CH_SR_get_g_rw_water_lv(data)                                      ((0x00001F00&(data))>>8)
#define  HDMI_CH_SR_get_b_rudflow_flag(data)                                     ((0x00000080&(data))>>7)
#define  HDMI_CH_SR_get_b_wovflow_flag(data)                                     ((0x00000040&(data))>>6)
#define  HDMI_CH_SR_get_b_rflush_flag(data)                                      ((0x00000020&(data))>>5)
#define  HDMI_CH_SR_get_b_rw_water_lv(data)                                      (0x0000001F&(data))

#define  HDMI_Audio_Sample_Rate_Change_IRQ                                       0x1800D100
#define  HDMI_Audio_Sample_Rate_Change_IRQ_reg_addr                              "0xB800D100"
#define  HDMI_Audio_Sample_Rate_Change_IRQ_reg                                   0xB800D100
#define  HDMI_Audio_Sample_Rate_Change_IRQ_inst_addr                             "0x0040"
#define  set_HDMI_Audio_Sample_Rate_Change_IRQ_reg(data)                         (*((volatile unsigned int*)HDMI_Audio_Sample_Rate_Change_IRQ_reg)=data)
#define  get_HDMI_Audio_Sample_Rate_Change_IRQ_reg                               (*((volatile unsigned int*)HDMI_Audio_Sample_Rate_Change_IRQ_reg))
#define  HDMI_Audio_Sample_Rate_Change_IRQ_en_ncts_chg_irq_shift                 (3)
#define  HDMI_Audio_Sample_Rate_Change_IRQ_ncts_chg_irq_shift                    (2)
#define  HDMI_Audio_Sample_Rate_Change_IRQ_en_ch_status_chg_irq_shift            (1)
#define  HDMI_Audio_Sample_Rate_Change_IRQ_ch_status_chg_irq_shift               (0)
#define  HDMI_Audio_Sample_Rate_Change_IRQ_en_ncts_chg_irq_mask                  (0x00000008)
#define  HDMI_Audio_Sample_Rate_Change_IRQ_ncts_chg_irq_mask                     (0x00000004)
#define  HDMI_Audio_Sample_Rate_Change_IRQ_en_ch_status_chg_irq_mask             (0x00000002)
#define  HDMI_Audio_Sample_Rate_Change_IRQ_ch_status_chg_irq_mask                (0x00000001)
#define  HDMI_Audio_Sample_Rate_Change_IRQ_en_ncts_chg_irq(data)                 (0x00000008&((data)<<3))
#define  HDMI_Audio_Sample_Rate_Change_IRQ_ncts_chg_irq(data)                    (0x00000004&((data)<<2))
#define  HDMI_Audio_Sample_Rate_Change_IRQ_en_ch_status_chg_irq(data)            (0x00000002&((data)<<1))
#define  HDMI_Audio_Sample_Rate_Change_IRQ_ch_status_chg_irq(data)               (0x00000001&(data))
#define  HDMI_Audio_Sample_Rate_Change_IRQ_get_en_ncts_chg_irq(data)             ((0x00000008&(data))>>3)
#define  HDMI_Audio_Sample_Rate_Change_IRQ_get_ncts_chg_irq(data)                ((0x00000004&(data))>>2)
#define  HDMI_Audio_Sample_Rate_Change_IRQ_get_en_ch_status_chg_irq(data)        ((0x00000002&(data))>>1)
#define  HDMI_Audio_Sample_Rate_Change_IRQ_get_ch_status_chg_irq(data)           (0x00000001&(data))

#define  HDMI_High_Bit_Rate_Audio_Packet                                         0x1800D104
#define  HDMI_High_Bit_Rate_Audio_Packet_reg_addr                                "0xB800D104"
#define  HDMI_High_Bit_Rate_Audio_Packet_reg                                     0xB800D104
#define  HDMI_High_Bit_Rate_Audio_Packet_inst_addr                               "0x0041"
#define  set_HDMI_High_Bit_Rate_Audio_Packet_reg(data)                           (*((volatile unsigned int*)HDMI_High_Bit_Rate_Audio_Packet_reg)=data)
#define  get_HDMI_High_Bit_Rate_Audio_Packet_reg                                 (*((volatile unsigned int*)HDMI_High_Bit_Rate_Audio_Packet_reg))
#define  HDMI_High_Bit_Rate_Audio_Packet_hbr_audio_mode_manual_shift             (2)
#define  HDMI_High_Bit_Rate_Audio_Packet_hbr_audio_mode_fw_shift                 (1)
#define  HDMI_High_Bit_Rate_Audio_Packet_hbr_audio_mode_shift                    (0)
#define  HDMI_High_Bit_Rate_Audio_Packet_hbr_audio_mode_manual_mask              (0x00000004)
#define  HDMI_High_Bit_Rate_Audio_Packet_hbr_audio_mode_fw_mask                  (0x00000002)
#define  HDMI_High_Bit_Rate_Audio_Packet_hbr_audio_mode_mask                     (0x00000001)
#define  HDMI_High_Bit_Rate_Audio_Packet_hbr_audio_mode_manual(data)             (0x00000004&((data)<<2))
#define  HDMI_High_Bit_Rate_Audio_Packet_hbr_audio_mode_fw(data)                 (0x00000002&((data)<<1))
#define  HDMI_High_Bit_Rate_Audio_Packet_hbr_audio_mode(data)                    (0x00000001&(data))
#define  HDMI_High_Bit_Rate_Audio_Packet_get_hbr_audio_mode_manual(data)         ((0x00000004&(data))>>2)
#define  HDMI_High_Bit_Rate_Audio_Packet_get_hbr_audio_mode_fw(data)             ((0x00000002&(data))>>1)
#define  HDMI_High_Bit_Rate_Audio_Packet_get_hbr_audio_mode(data)                (0x00000001&(data))

#define  HDMI_HDMI_AFCR                                                          0x1800D108
#define  HDMI_HDMI_AFCR_reg_addr                                                 "0xB800D108"
#define  HDMI_HDMI_AFCR_reg                                                      0xB800D108
#define  HDMI_HDMI_AFCR_inst_addr                                                "0x0042"
#define  set_HDMI_HDMI_AFCR_reg(data)                                            (*((volatile unsigned int*)HDMI_HDMI_AFCR_reg)=data)
#define  get_HDMI_HDMI_AFCR_reg                                                  (*((volatile unsigned int*)HDMI_HDMI_AFCR_reg))
#define  HDMI_HDMI_AFCR_dummy_shift                                              (14)
#define  HDMI_HDMI_AFCR_gain_bypass_en_shift                                     (13)
#define  HDMI_HDMI_AFCR_afifof_shift                                             (12)
#define  HDMI_HDMI_AFCR_afifoe_shift                                             (11)
#define  HDMI_HDMI_AFCR_afifowe_r_shift                                          (10)
#define  HDMI_HDMI_AFCR_afifore_r_shift                                          (8)
#define  HDMI_HDMI_AFCR_tst_i2s_sw_shift                                         (7)
#define  HDMI_HDMI_AFCR_aoem_shift                                               (6)
#define  HDMI_HDMI_AFCR_aoc_shift                                                (5)
#define  HDMI_HDMI_AFCR_audio_test_enable_shift                                  (4)
#define  HDMI_HDMI_AFCR_mgc_shift                                                (3)
#define  HDMI_HDMI_AFCR_afifowe_shift                                            (2)
#define  HDMI_HDMI_AFCR_afifore_shift                                            (0)
#define  HDMI_HDMI_AFCR_dummy_mask                                               (0xFFFFC000)
#define  HDMI_HDMI_AFCR_gain_bypass_en_mask                                      (0x00002000)
#define  HDMI_HDMI_AFCR_afifof_mask                                              (0x00001000)
#define  HDMI_HDMI_AFCR_afifoe_mask                                              (0x00000800)
#define  HDMI_HDMI_AFCR_afifowe_r_mask                                           (0x00000400)
#define  HDMI_HDMI_AFCR_afifore_r_mask                                           (0x00000300)
#define  HDMI_HDMI_AFCR_tst_i2s_sw_mask                                          (0x00000080)
#define  HDMI_HDMI_AFCR_aoem_mask                                                (0x00000040)
#define  HDMI_HDMI_AFCR_aoc_mask                                                 (0x00000020)
#define  HDMI_HDMI_AFCR_audio_test_enable_mask                                   (0x00000010)
#define  HDMI_HDMI_AFCR_mgc_mask                                                 (0x00000008)
#define  HDMI_HDMI_AFCR_afifowe_mask                                             (0x00000004)
#define  HDMI_HDMI_AFCR_afifore_mask                                             (0x00000003)
#define  HDMI_HDMI_AFCR_dummy(data)                                              (0xFFFFC000&((data)<<14))
#define  HDMI_HDMI_AFCR_gain_bypass_en(data)                                     (0x00002000&((data)<<13))
#define  HDMI_HDMI_AFCR_afifof(data)                                             (0x00001000&((data)<<12))
#define  HDMI_HDMI_AFCR_afifoe(data)                                             (0x00000800&((data)<<11))
#define  HDMI_HDMI_AFCR_afifowe_r(data)                                          (0x00000400&((data)<<10))
#define  HDMI_HDMI_AFCR_afifore_r(data)                                          (0x00000300&((data)<<8))
#define  HDMI_HDMI_AFCR_tst_i2s_sw(data)                                         (0x00000080&((data)<<7))
#define  HDMI_HDMI_AFCR_aoem(data)                                               (0x00000040&((data)<<6))
#define  HDMI_HDMI_AFCR_aoc(data)                                                (0x00000020&((data)<<5))
#define  HDMI_HDMI_AFCR_audio_test_enable(data)                                  (0x00000010&((data)<<4))
#define  HDMI_HDMI_AFCR_mgc(data)                                                (0x00000008&((data)<<3))
#define  HDMI_HDMI_AFCR_afifowe(data)                                            (0x00000004&((data)<<2))
#define  HDMI_HDMI_AFCR_afifore(data)                                            (0x00000003&(data))
#define  HDMI_HDMI_AFCR_get_dummy(data)                                          ((0xFFFFC000&(data))>>14)
#define  HDMI_HDMI_AFCR_get_gain_bypass_en(data)                                 ((0x00002000&(data))>>13)
#define  HDMI_HDMI_AFCR_get_afifof(data)                                         ((0x00001000&(data))>>12)
#define  HDMI_HDMI_AFCR_get_afifoe(data)                                         ((0x00000800&(data))>>11)
#define  HDMI_HDMI_AFCR_get_afifowe_r(data)                                      ((0x00000400&(data))>>10)
#define  HDMI_HDMI_AFCR_get_afifore_r(data)                                      ((0x00000300&(data))>>8)
#define  HDMI_HDMI_AFCR_get_tst_i2s_sw(data)                                     ((0x00000080&(data))>>7)
#define  HDMI_HDMI_AFCR_get_aoem(data)                                           ((0x00000040&(data))>>6)
#define  HDMI_HDMI_AFCR_get_aoc(data)                                            ((0x00000020&(data))>>5)
#define  HDMI_HDMI_AFCR_get_audio_test_enable(data)                              ((0x00000010&(data))>>4)
#define  HDMI_HDMI_AFCR_get_mgc(data)                                            ((0x00000008&(data))>>3)
#define  HDMI_HDMI_AFCR_get_afifowe(data)                                        ((0x00000004&(data))>>2)
#define  HDMI_HDMI_AFCR_get_afifore(data)                                        (0x00000003&(data))
//For SW function
#define MHL_CTS_TEST_ON                                                    _BIT31
#define MHL_CTS_TEST_PP_MODE                                           _BIT30
#define MHL_HDMI_SETPHY_BYPASS                                       _BIT29
#define MHL_HDMI_PHY_BYPASS                                            _BIT28
#define MHL_HDMI_Bit_Error_check                                        _BIT27
#define MHL3_RUN_6G 					(_BIT26)
#define MHL3_RUN_3G 					(_BIT25)
#define MHL3_RUN_1p5G 					(_BIT25|_BIT26)
#define MHL3_RUN_16bit					(_BIT24)  /*_BIT24=1: 16bit; _BIT24=0: 24bit */
#define MHL3_BYPASS_CBUS_CLK				(_BIT23)
#define HDMI_6G_TEST      				(_BIT22)
#define HDMI_Force_3G      				(_BIT21)

#define  HDMI_HDMI_AFSR                                                          0x1800D10C
#define  HDMI_HDMI_AFSR_reg_addr                                                 "0xB800D10C"
#define  HDMI_HDMI_AFSR_reg                                                      0xB800D10C
#define  HDMI_HDMI_AFSR_inst_addr                                                "0x0043"
#define  set_HDMI_HDMI_AFSR_reg(data)                                            (*((volatile unsigned int*)HDMI_HDMI_AFSR_reg)=data)
#define  get_HDMI_HDMI_AFSR_reg                                                  (*((volatile unsigned int*)HDMI_HDMI_AFSR_reg))
#define  HDMI_HDMI_AFSR_audio_bist_clksel_shift                                  (0)
#define  HDMI_HDMI_AFSR_audio_bist_clksel_mask                                   (0x00000001)
#define  HDMI_HDMI_AFSR_audio_bist_clksel(data)                                  (0x00000001&(data))
#define  HDMI_HDMI_AFSR_get_audio_bist_clksel(data)                              (0x00000001&(data))

#define  HDMI_HDMI_MAGCR0                                                        0x1800D110
#define  HDMI_HDMI_MAGCR0_reg_addr                                               "0xB800D110"
#define  HDMI_HDMI_MAGCR0_reg                                                    0xB800D110
#define  HDMI_HDMI_MAGCR0_inst_addr                                              "0x0044"
#define  set_HDMI_HDMI_MAGCR0_reg(data)                                          (*((volatile unsigned int*)HDMI_HDMI_MAGCR0_reg)=data)
#define  get_HDMI_HDMI_MAGCR0_reg                                                (*((volatile unsigned int*)HDMI_HDMI_MAGCR0_reg))
#define  HDMI_HDMI_MAGCR0_agi_shift                                              (13)
#define  HDMI_HDMI_MAGCR0_agd_shift                                              (8)
#define  HDMI_HDMI_MAGCR0_mg_shift                                               (0)
#define  HDMI_HDMI_MAGCR0_agi_mask                                               (0x0000E000)
#define  HDMI_HDMI_MAGCR0_agd_mask                                               (0x00001F00)
#define  HDMI_HDMI_MAGCR0_mg_mask                                                (0x000000FF)
#define  HDMI_HDMI_MAGCR0_agi(data)                                              (0x0000E000&((data)<<13))
#define  HDMI_HDMI_MAGCR0_agd(data)                                              (0x00001F00&((data)<<8))
#define  HDMI_HDMI_MAGCR0_mg(data)                                               (0x000000FF&(data))
#define  HDMI_HDMI_MAGCR0_get_agi(data)                                          ((0x0000E000&(data))>>13)
#define  HDMI_HDMI_MAGCR0_get_agd(data)                                          ((0x00001F00&(data))>>8)
#define  HDMI_HDMI_MAGCR0_get_mg(data)                                           (0x000000FF&(data))

#define  HDMI_HDMI_MAG_M_FINAL                                                   0x1800D114
#define  HDMI_HDMI_MAG_M_FINAL_reg_addr                                          "0xB800D114"
#define  HDMI_HDMI_MAG_M_FINAL_reg                                               0xB800D114
#define  HDMI_HDMI_MAG_M_FINAL_inst_addr                                         "0x0045"
#define  set_HDMI_HDMI_MAG_M_FINAL_reg(data)                                     (*((volatile unsigned int*)HDMI_HDMI_MAG_M_FINAL_reg)=data)
#define  get_HDMI_HDMI_MAG_M_FINAL_reg                                           (*((volatile unsigned int*)HDMI_HDMI_MAG_M_FINAL_reg))
#define  HDMI_HDMI_MAG_M_FINAL_ldp_time_shift                                    (21)
#define  HDMI_HDMI_MAG_M_FINAL_ldp_time_mode_shift                               (20)
#define  HDMI_HDMI_MAG_M_FINAL_fg_r_shift                                        (12)
#define  HDMI_HDMI_MAG_M_FINAL_fg_l_shift                                        (4)
#define  HDMI_HDMI_MAG_M_FINAL_auto_dly_mod_shift                                (3)
#define  HDMI_HDMI_MAG_M_FINAL_fg_en_shift                                       (2)
#define  HDMI_HDMI_MAG_M_FINAL_ffg_l_shift                                       (1)
#define  HDMI_HDMI_MAG_M_FINAL_ffg_r_shift                                       (0)
#define  HDMI_HDMI_MAG_M_FINAL_ldp_time_mask                                     (0x7FE00000)
#define  HDMI_HDMI_MAG_M_FINAL_ldp_time_mode_mask                                (0x00100000)
#define  HDMI_HDMI_MAG_M_FINAL_fg_r_mask                                         (0x000FF000)
#define  HDMI_HDMI_MAG_M_FINAL_fg_l_mask                                         (0x00000FF0)
#define  HDMI_HDMI_MAG_M_FINAL_auto_dly_mod_mask                                 (0x00000008)
#define  HDMI_HDMI_MAG_M_FINAL_fg_en_mask                                        (0x00000004)
#define  HDMI_HDMI_MAG_M_FINAL_ffg_l_mask                                        (0x00000002)
#define  HDMI_HDMI_MAG_M_FINAL_ffg_r_mask                                        (0x00000001)
#define  HDMI_HDMI_MAG_M_FINAL_ldp_time(data)                                    (0x7FE00000&((data)<<21))
#define  HDMI_HDMI_MAG_M_FINAL_ldp_time_mode(data)                               (0x00100000&((data)<<20))
#define  HDMI_HDMI_MAG_M_FINAL_fg_r(data)                                        (0x000FF000&((data)<<12))
#define  HDMI_HDMI_MAG_M_FINAL_fg_l(data)                                        (0x00000FF0&((data)<<4))
#define  HDMI_HDMI_MAG_M_FINAL_auto_dly_mod(data)                                (0x00000008&((data)<<3))
#define  HDMI_HDMI_MAG_M_FINAL_fg_en(data)                                       (0x00000004&((data)<<2))
#define  HDMI_HDMI_MAG_M_FINAL_ffg_l(data)                                       (0x00000002&((data)<<1))
#define  HDMI_HDMI_MAG_M_FINAL_ffg_r(data)                                       (0x00000001&(data))
#define  HDMI_HDMI_MAG_M_FINAL_get_ldp_time(data)                                ((0x7FE00000&(data))>>21)
#define  HDMI_HDMI_MAG_M_FINAL_get_ldp_time_mode(data)                           ((0x00100000&(data))>>20)
#define  HDMI_HDMI_MAG_M_FINAL_get_fg_r(data)                                    ((0x000FF000&(data))>>12)
#define  HDMI_HDMI_MAG_M_FINAL_get_fg_l(data)                                    ((0x00000FF0&(data))>>4)
#define  HDMI_HDMI_MAG_M_FINAL_get_auto_dly_mod(data)                            ((0x00000008&(data))>>3)
#define  HDMI_HDMI_MAG_M_FINAL_get_fg_en(data)                                   ((0x00000004&(data))>>2)
#define  HDMI_HDMI_MAG_M_FINAL_get_ffg_l(data)                                   ((0x00000002&(data))>>1)
#define  HDMI_HDMI_MAG_M_FINAL_get_ffg_r(data)                                   (0x00000001&(data))

#define  HDMI_ZCD_CTRL                                                           0x1800D118
#define  HDMI_ZCD_CTRL_reg_addr                                                  "0xB800D118"
#define  HDMI_ZCD_CTRL_reg                                                       0xB800D118
#define  HDMI_ZCD_CTRL_inst_addr                                                 "0x0046"
#define  set_HDMI_ZCD_CTRL_reg(data)                                             (*((volatile unsigned int*)HDMI_ZCD_CTRL_reg)=data)
#define  get_HDMI_ZCD_CTRL_reg                                                   (*((volatile unsigned int*)HDMI_ZCD_CTRL_reg))
#define  HDMI_ZCD_CTRL_zcd_ch7_done_shift                                        (23)
#define  HDMI_ZCD_CTRL_zcd_ch6_done_shift                                        (22)
#define  HDMI_ZCD_CTRL_zcd_ch5_done_shift                                        (21)
#define  HDMI_ZCD_CTRL_zcd_ch4_done_shift                                        (20)
#define  HDMI_ZCD_CTRL_zcd_ch3_done_shift                                        (19)
#define  HDMI_ZCD_CTRL_zcd_ch2_done_shift                                        (18)
#define  HDMI_ZCD_CTRL_zcd_ch1_done_shift                                        (17)
#define  HDMI_ZCD_CTRL_zcd_ch0_done_shift                                        (16)
#define  HDMI_ZCD_CTRL_zcd_timeout_shift                                         (8)
#define  HDMI_ZCD_CTRL_zcd_en_shift                                              (7)
#define  HDMI_ZCD_CTRL_zcd_sep_8ch_shift                                         (6)
#define  HDMI_ZCD_CTRL_zcd_sep_st_shift                                          (5)
#define  HDMI_ZCD_CTRL_dummy_shift                                               (0)
#define  HDMI_ZCD_CTRL_zcd_ch7_done_mask                                         (0x00800000)
#define  HDMI_ZCD_CTRL_zcd_ch6_done_mask                                         (0x00400000)
#define  HDMI_ZCD_CTRL_zcd_ch5_done_mask                                         (0x00200000)
#define  HDMI_ZCD_CTRL_zcd_ch4_done_mask                                         (0x00100000)
#define  HDMI_ZCD_CTRL_zcd_ch3_done_mask                                         (0x00080000)
#define  HDMI_ZCD_CTRL_zcd_ch2_done_mask                                         (0x00040000)
#define  HDMI_ZCD_CTRL_zcd_ch1_done_mask                                         (0x00020000)
#define  HDMI_ZCD_CTRL_zcd_ch0_done_mask                                         (0x00010000)
#define  HDMI_ZCD_CTRL_zcd_timeout_mask                                          (0x00007F00)
#define  HDMI_ZCD_CTRL_zcd_en_mask                                               (0x00000080)
#define  HDMI_ZCD_CTRL_zcd_sep_8ch_mask                                          (0x00000040)
#define  HDMI_ZCD_CTRL_zcd_sep_st_mask                                           (0x00000020)
#define  HDMI_ZCD_CTRL_dummy_mask                                                (0x0000001F)
#define  HDMI_ZCD_CTRL_zcd_ch7_done(data)                                        (0x00800000&((data)<<23))
#define  HDMI_ZCD_CTRL_zcd_ch6_done(data)                                        (0x00400000&((data)<<22))
#define  HDMI_ZCD_CTRL_zcd_ch5_done(data)                                        (0x00200000&((data)<<21))
#define  HDMI_ZCD_CTRL_zcd_ch4_done(data)                                        (0x00100000&((data)<<20))
#define  HDMI_ZCD_CTRL_zcd_ch3_done(data)                                        (0x00080000&((data)<<19))
#define  HDMI_ZCD_CTRL_zcd_ch2_done(data)                                        (0x00040000&((data)<<18))
#define  HDMI_ZCD_CTRL_zcd_ch1_done(data)                                        (0x00020000&((data)<<17))
#define  HDMI_ZCD_CTRL_zcd_ch0_done(data)                                        (0x00010000&((data)<<16))
#define  HDMI_ZCD_CTRL_zcd_timeout(data)                                         (0x00007F00&((data)<<8))
#define  HDMI_ZCD_CTRL_zcd_en(data)                                              (0x00000080&((data)<<7))
#define  HDMI_ZCD_CTRL_zcd_sep_8ch(data)                                         (0x00000040&((data)<<6))
#define  HDMI_ZCD_CTRL_zcd_sep_st(data)                                          (0x00000020&((data)<<5))
#define  HDMI_ZCD_CTRL_dummy(data)                                               (0x0000001F&(data))
#define  HDMI_ZCD_CTRL_get_zcd_ch7_done(data)                                    ((0x00800000&(data))>>23)
#define  HDMI_ZCD_CTRL_get_zcd_ch6_done(data)                                    ((0x00400000&(data))>>22)
#define  HDMI_ZCD_CTRL_get_zcd_ch5_done(data)                                    ((0x00200000&(data))>>21)
#define  HDMI_ZCD_CTRL_get_zcd_ch4_done(data)                                    ((0x00100000&(data))>>20)
#define  HDMI_ZCD_CTRL_get_zcd_ch3_done(data)                                    ((0x00080000&(data))>>19)
#define  HDMI_ZCD_CTRL_get_zcd_ch2_done(data)                                    ((0x00040000&(data))>>18)
#define  HDMI_ZCD_CTRL_get_zcd_ch1_done(data)                                    ((0x00020000&(data))>>17)
#define  HDMI_ZCD_CTRL_get_zcd_ch0_done(data)                                    ((0x00010000&(data))>>16)
#define  HDMI_ZCD_CTRL_get_zcd_timeout(data)                                     ((0x00007F00&(data))>>8)
#define  HDMI_ZCD_CTRL_get_zcd_en(data)                                          ((0x00000080&(data))>>7)
#define  HDMI_ZCD_CTRL_get_zcd_sep_8ch(data)                                     ((0x00000040&(data))>>6)
#define  HDMI_ZCD_CTRL_get_zcd_sep_st(data)                                      ((0x00000020&(data))>>5)
#define  HDMI_ZCD_CTRL_get_dummy(data)                                           (0x0000001F&(data))

#define  HDMI_AUDIO_FREQDET                                                      0x1800D11C
#define  HDMI_AUDIO_FREQDET_reg_addr                                             "0xB800D11C"
#define  HDMI_AUDIO_FREQDET_reg                                                  0xB800D11C
#define  HDMI_AUDIO_FREQDET_inst_addr                                            "0x0047"
#define  set_HDMI_AUDIO_FREQDET_reg(data)                                        (*((volatile unsigned int*)HDMI_AUDIO_FREQDET_reg)=data)
#define  get_HDMI_AUDIO_FREQDET_reg                                              (*((volatile unsigned int*)HDMI_AUDIO_FREQDET_reg))
#define  HDMI_AUDIO_FREQDET_xtal_div_shift                                       (24)
#define  HDMI_AUDIO_FREQDET_afreq_meas_result_shift                              (12)
#define  HDMI_AUDIO_FREQDET_afreq_meas_range_shift                               (9)
#define  HDMI_AUDIO_FREQDET_popup_afreq_meas_result_shift                        (8)
#define  HDMI_AUDIO_FREQDET_audio_freq_detect_shift                              (7)
#define  HDMI_AUDIO_FREQDET_auto_load_scode_shift                                (6)
#define  HDMI_AUDIO_FREQDET_awd_by_freqchange_shift                              (5)
#define  HDMI_AUDIO_FREQDET_awd_by_noaudio_shift                                 (4)
#define  HDMI_AUDIO_FREQDET_irq_by_freqchange_shift                              (3)
#define  HDMI_AUDIO_FREQDET_irq_by_noaudio_shift                                 (2)
#define  HDMI_AUDIO_FREQDET_freqchange_shift                                     (1)
#define  HDMI_AUDIO_FREQDET_noaudio_shift                                        (0)
#define  HDMI_AUDIO_FREQDET_xtal_div_mask                                        (0xFF000000)
#define  HDMI_AUDIO_FREQDET_afreq_meas_result_mask                               (0x00FFF000)
#define  HDMI_AUDIO_FREQDET_afreq_meas_range_mask                                (0x00000E00)
#define  HDMI_AUDIO_FREQDET_popup_afreq_meas_result_mask                         (0x00000100)
#define  HDMI_AUDIO_FREQDET_audio_freq_detect_mask                               (0x00000080)
#define  HDMI_AUDIO_FREQDET_auto_load_scode_mask                                 (0x00000040)
#define  HDMI_AUDIO_FREQDET_awd_by_freqchange_mask                               (0x00000020)
#define  HDMI_AUDIO_FREQDET_awd_by_noaudio_mask                                  (0x00000010)
#define  HDMI_AUDIO_FREQDET_irq_by_freqchange_mask                               (0x00000008)
#define  HDMI_AUDIO_FREQDET_irq_by_noaudio_mask                                  (0x00000004)
#define  HDMI_AUDIO_FREQDET_freqchange_mask                                      (0x00000002)
#define  HDMI_AUDIO_FREQDET_noaudio_mask                                         (0x00000001)
#define  HDMI_AUDIO_FREQDET_xtal_div(data)                                       (0xFF000000&((data)<<24))
#define  HDMI_AUDIO_FREQDET_afreq_meas_result(data)                              (0x00FFF000&((data)<<12))
#define  HDMI_AUDIO_FREQDET_afreq_meas_range(data)                               (0x00000E00&((data)<<9))
#define  HDMI_AUDIO_FREQDET_popup_afreq_meas_result(data)                        (0x00000100&((data)<<8))
#define  HDMI_AUDIO_FREQDET_audio_freq_detect(data)                              (0x00000080&((data)<<7))
#define  HDMI_AUDIO_FREQDET_auto_load_scode(data)                                (0x00000040&((data)<<6))
#define  HDMI_AUDIO_FREQDET_awd_by_freqchange(data)                              (0x00000020&((data)<<5))
#define  HDMI_AUDIO_FREQDET_awd_by_noaudio(data)                                 (0x00000010&((data)<<4))
#define  HDMI_AUDIO_FREQDET_irq_by_freqchange(data)                              (0x00000008&((data)<<3))
#define  HDMI_AUDIO_FREQDET_irq_by_noaudio(data)                                 (0x00000004&((data)<<2))
#define  HDMI_AUDIO_FREQDET_freqchange(data)                                     (0x00000002&((data)<<1))
#define  HDMI_AUDIO_FREQDET_noaudio(data)                                        (0x00000001&(data))
#define  HDMI_AUDIO_FREQDET_get_xtal_div(data)                                   ((0xFF000000&(data))>>24)
#define  HDMI_AUDIO_FREQDET_get_afreq_meas_result(data)                          ((0x00FFF000&(data))>>12)
#define  HDMI_AUDIO_FREQDET_get_afreq_meas_range(data)                           ((0x00000E00&(data))>>9)
#define  HDMI_AUDIO_FREQDET_get_popup_afreq_meas_result(data)                    ((0x00000100&(data))>>8)
#define  HDMI_AUDIO_FREQDET_get_audio_freq_detect(data)                          ((0x00000080&(data))>>7)
#define  HDMI_AUDIO_FREQDET_get_auto_load_scode(data)                            ((0x00000040&(data))>>6)
#define  HDMI_AUDIO_FREQDET_get_awd_by_freqchange(data)                          ((0x00000020&(data))>>5)
#define  HDMI_AUDIO_FREQDET_get_awd_by_noaudio(data)                             ((0x00000010&(data))>>4)
#define  HDMI_AUDIO_FREQDET_get_irq_by_freqchange(data)                          ((0x00000008&(data))>>3)
#define  HDMI_AUDIO_FREQDET_get_irq_by_noaudio(data)                             ((0x00000004&(data))>>2)
#define  HDMI_AUDIO_FREQDET_get_freqchange(data)                                 ((0x00000002&(data))>>1)
#define  HDMI_AUDIO_FREQDET_get_noaudio(data)                                    (0x00000001&(data))

#define  HDMI_RANGE0_1                                                           0x1800D120
#define  HDMI_RANGE0_1_reg_addr                                                  "0xB800D120"
#define  HDMI_RANGE0_1_reg                                                       0xB800D120
#define  HDMI_RANGE0_1_inst_addr                                                 "0x0048"
#define  set_HDMI_RANGE0_1_reg(data)                                             (*((volatile unsigned int*)HDMI_RANGE0_1_reg)=data)
#define  get_HDMI_RANGE0_1_reg                                                   (*((volatile unsigned int*)HDMI_RANGE0_1_reg))
#define  HDMI_RANGE0_1_range0_th_shift                                           (12)
#define  HDMI_RANGE0_1_range1_th_shift                                           (0)
#define  HDMI_RANGE0_1_range0_th_mask                                            (0x00FFF000)
#define  HDMI_RANGE0_1_range1_th_mask                                            (0x00000FFF)
#define  HDMI_RANGE0_1_range0_th(data)                                           (0x00FFF000&((data)<<12))
#define  HDMI_RANGE0_1_range1_th(data)                                           (0x00000FFF&(data))
#define  HDMI_RANGE0_1_get_range0_th(data)                                       ((0x00FFF000&(data))>>12)
#define  HDMI_RANGE0_1_get_range1_th(data)                                       (0x00000FFF&(data))

#define  HDMI_RANGE2_3                                                           0x1800D124
#define  HDMI_RANGE2_3_reg_addr                                                  "0xB800D124"
#define  HDMI_RANGE2_3_reg                                                       0xB800D124
#define  HDMI_RANGE2_3_inst_addr                                                 "0x0049"
#define  set_HDMI_RANGE2_3_reg(data)                                             (*((volatile unsigned int*)HDMI_RANGE2_3_reg)=data)
#define  get_HDMI_RANGE2_3_reg                                                   (*((volatile unsigned int*)HDMI_RANGE2_3_reg))
#define  HDMI_RANGE2_3_range2_th_shift                                           (12)
#define  HDMI_RANGE2_3_range3_th_shift                                           (0)
#define  HDMI_RANGE2_3_range2_th_mask                                            (0x00FFF000)
#define  HDMI_RANGE2_3_range3_th_mask                                            (0x00000FFF)
#define  HDMI_RANGE2_3_range2_th(data)                                           (0x00FFF000&((data)<<12))
#define  HDMI_RANGE2_3_range3_th(data)                                           (0x00000FFF&(data))
#define  HDMI_RANGE2_3_get_range2_th(data)                                       ((0x00FFF000&(data))>>12)
#define  HDMI_RANGE2_3_get_range3_th(data)                                       (0x00000FFF&(data))

#define  HDMI_RANGE4_5                                                           0x1800D128
#define  HDMI_RANGE4_5_reg_addr                                                  "0xB800D128"
#define  HDMI_RANGE4_5_reg                                                       0xB800D128
#define  HDMI_RANGE4_5_inst_addr                                                 "0x004A"
#define  set_HDMI_RANGE4_5_reg(data)                                             (*((volatile unsigned int*)HDMI_RANGE4_5_reg)=data)
#define  get_HDMI_RANGE4_5_reg                                                   (*((volatile unsigned int*)HDMI_RANGE4_5_reg))
#define  HDMI_RANGE4_5_range4_th_shift                                           (12)
#define  HDMI_RANGE4_5_range5_th_shift                                           (0)
#define  HDMI_RANGE4_5_range4_th_mask                                            (0x00FFF000)
#define  HDMI_RANGE4_5_range5_th_mask                                            (0x00000FFF)
#define  HDMI_RANGE4_5_range4_th(data)                                           (0x00FFF000&((data)<<12))
#define  HDMI_RANGE4_5_range5_th(data)                                           (0x00000FFF&(data))
#define  HDMI_RANGE4_5_get_range4_th(data)                                       ((0x00FFF000&(data))>>12)
#define  HDMI_RANGE4_5_get_range5_th(data)                                       (0x00000FFF&(data))

#define  HDMI_PRESET_S_CODE0                                                     0x1800D12C
#define  HDMI_PRESET_S_CODE0_reg_addr                                            "0xB800D12C"
#define  HDMI_PRESET_S_CODE0_reg                                                 0xB800D12C
#define  HDMI_PRESET_S_CODE0_inst_addr                                           "0x004B"
#define  set_HDMI_PRESET_S_CODE0_reg(data)                                       (*((volatile unsigned int*)HDMI_PRESET_S_CODE0_reg)=data)
#define  get_HDMI_PRESET_S_CODE0_reg                                             (*((volatile unsigned int*)HDMI_PRESET_S_CODE0_reg))
#define  HDMI_PRESET_S_CODE0_pre_set_s1_code3_shift                              (31)
#define  HDMI_PRESET_S_CODE0_pre_set_s_code3_shift                               (24)
#define  HDMI_PRESET_S_CODE0_pre_set_s1_code2_shift                              (23)
#define  HDMI_PRESET_S_CODE0_pre_set_s_code2_shift                               (16)
#define  HDMI_PRESET_S_CODE0_pre_set_s1_code1_shift                              (15)
#define  HDMI_PRESET_S_CODE0_pre_set_s_code1_shift                               (8)
#define  HDMI_PRESET_S_CODE0_pre_set_s1_code0_shift                              (7)
#define  HDMI_PRESET_S_CODE0_pre_set_s_code0_shift                               (0)
#define  HDMI_PRESET_S_CODE0_pre_set_s1_code3_mask                               (0x80000000)
#define  HDMI_PRESET_S_CODE0_pre_set_s_code3_mask                                (0x7F000000)
#define  HDMI_PRESET_S_CODE0_pre_set_s1_code2_mask                               (0x00800000)
#define  HDMI_PRESET_S_CODE0_pre_set_s_code2_mask                                (0x007F0000)
#define  HDMI_PRESET_S_CODE0_pre_set_s1_code1_mask                               (0x00008000)
#define  HDMI_PRESET_S_CODE0_pre_set_s_code1_mask                                (0x00007F00)
#define  HDMI_PRESET_S_CODE0_pre_set_s1_code0_mask                               (0x00000080)
#define  HDMI_PRESET_S_CODE0_pre_set_s_code0_mask                                (0x0000007F)
#define  HDMI_PRESET_S_CODE0_pre_set_s1_code3(data)                              (0x80000000&((data)<<31))
#define  HDMI_PRESET_S_CODE0_pre_set_s_code3(data)                               (0x7F000000&((data)<<24))
#define  HDMI_PRESET_S_CODE0_pre_set_s1_code2(data)                              (0x00800000&((data)<<23))
#define  HDMI_PRESET_S_CODE0_pre_set_s_code2(data)                               (0x007F0000&((data)<<16))
#define  HDMI_PRESET_S_CODE0_pre_set_s1_code1(data)                              (0x00008000&((data)<<15))
#define  HDMI_PRESET_S_CODE0_pre_set_s_code1(data)                               (0x00007F00&((data)<<8))
#define  HDMI_PRESET_S_CODE0_pre_set_s1_code0(data)                              (0x00000080&((data)<<7))
#define  HDMI_PRESET_S_CODE0_pre_set_s_code0(data)                               (0x0000007F&(data))
#define  HDMI_PRESET_S_CODE0_get_pre_set_s1_code3(data)                          ((0x80000000&(data))>>31)
#define  HDMI_PRESET_S_CODE0_get_pre_set_s_code3(data)                           ((0x7F000000&(data))>>24)
#define  HDMI_PRESET_S_CODE0_get_pre_set_s1_code2(data)                          ((0x00800000&(data))>>23)
#define  HDMI_PRESET_S_CODE0_get_pre_set_s_code2(data)                           ((0x007F0000&(data))>>16)
#define  HDMI_PRESET_S_CODE0_get_pre_set_s1_code1(data)                          ((0x00008000&(data))>>15)
#define  HDMI_PRESET_S_CODE0_get_pre_set_s_code1(data)                           ((0x00007F00&(data))>>8)
#define  HDMI_PRESET_S_CODE0_get_pre_set_s1_code0(data)                          ((0x00000080&(data))>>7)
#define  HDMI_PRESET_S_CODE0_get_pre_set_s_code0(data)                           (0x0000007F&(data))

#define  HDMI_PRESET_S_CODE1                                                     0x1800D130
#define  HDMI_PRESET_S_CODE1_reg_addr                                            "0xB800D130"
#define  HDMI_PRESET_S_CODE1_reg                                                 0xB800D130
#define  HDMI_PRESET_S_CODE1_inst_addr                                           "0x004C"
#define  set_HDMI_PRESET_S_CODE1_reg(data)                                       (*((volatile unsigned int*)HDMI_PRESET_S_CODE1_reg)=data)
#define  get_HDMI_PRESET_S_CODE1_reg                                             (*((volatile unsigned int*)HDMI_PRESET_S_CODE1_reg))
#define  HDMI_PRESET_S_CODE1_dp_abuf_wr_mod_en_shift                             (23)
#define  HDMI_PRESET_S_CODE1_auto_stop_trk_en_shift                              (22)
#define  HDMI_PRESET_S_CODE1_trk_mod_en_shift                                    (21)
#define  HDMI_PRESET_S_CODE1_afsm_mod_en_shift                                   (20)
#define  HDMI_PRESET_S_CODE1_pre_set_sm_code0_shift                              (15)
#define  HDMI_PRESET_S_CODE1_pre_set_sm_code1_shift                              (14)
#define  HDMI_PRESET_S_CODE1_pre_set_sm_code2_shift                              (13)
#define  HDMI_PRESET_S_CODE1_pre_set_sm_code3_shift                              (12)
#define  HDMI_PRESET_S_CODE1_pre_set_sm_code4_shift                              (11)
#define  HDMI_PRESET_S_CODE1_pre_set_s1_code4_shift                              (7)
#define  HDMI_PRESET_S_CODE1_pre_set_s_code4_shift                               (0)
#define  HDMI_PRESET_S_CODE1_dp_abuf_wr_mod_en_mask                              (0x00800000)
#define  HDMI_PRESET_S_CODE1_auto_stop_trk_en_mask                               (0x00400000)
#define  HDMI_PRESET_S_CODE1_trk_mod_en_mask                                     (0x00200000)
#define  HDMI_PRESET_S_CODE1_afsm_mod_en_mask                                    (0x00100000)
#define  HDMI_PRESET_S_CODE1_pre_set_sm_code0_mask                               (0x00008000)
#define  HDMI_PRESET_S_CODE1_pre_set_sm_code1_mask                               (0x00004000)
#define  HDMI_PRESET_S_CODE1_pre_set_sm_code2_mask                               (0x00002000)
#define  HDMI_PRESET_S_CODE1_pre_set_sm_code3_mask                               (0x00001000)
#define  HDMI_PRESET_S_CODE1_pre_set_sm_code4_mask                               (0x00000800)
#define  HDMI_PRESET_S_CODE1_pre_set_s1_code4_mask                               (0x00000080)
#define  HDMI_PRESET_S_CODE1_pre_set_s_code4_mask                                (0x0000007F)
#define  HDMI_PRESET_S_CODE1_dp_abuf_wr_mod_en(data)                             (0x00800000&((data)<<23))
#define  HDMI_PRESET_S_CODE1_auto_stop_trk_en(data)                              (0x00400000&((data)<<22))
#define  HDMI_PRESET_S_CODE1_trk_mod_en(data)                                    (0x00200000&((data)<<21))
#define  HDMI_PRESET_S_CODE1_afsm_mod_en(data)                                   (0x00100000&((data)<<20))
#define  HDMI_PRESET_S_CODE1_pre_set_sm_code0(data)                              (0x00008000&((data)<<15))
#define  HDMI_PRESET_S_CODE1_pre_set_sm_code1(data)                              (0x00004000&((data)<<14))
#define  HDMI_PRESET_S_CODE1_pre_set_sm_code2(data)                              (0x00002000&((data)<<13))
#define  HDMI_PRESET_S_CODE1_pre_set_sm_code3(data)                              (0x00001000&((data)<<12))
#define  HDMI_PRESET_S_CODE1_pre_set_sm_code4(data)                              (0x00000800&((data)<<11))
#define  HDMI_PRESET_S_CODE1_pre_set_s1_code4(data)                              (0x00000080&((data)<<7))
#define  HDMI_PRESET_S_CODE1_pre_set_s_code4(data)                               (0x0000007F&(data))
#define  HDMI_PRESET_S_CODE1_get_dp_abuf_wr_mod_en(data)                         ((0x00800000&(data))>>23)
#define  HDMI_PRESET_S_CODE1_get_auto_stop_trk_en(data)                          ((0x00400000&(data))>>22)
#define  HDMI_PRESET_S_CODE1_get_trk_mod_en(data)                                ((0x00200000&(data))>>21)
#define  HDMI_PRESET_S_CODE1_get_afsm_mod_en(data)                               ((0x00100000&(data))>>20)
#define  HDMI_PRESET_S_CODE1_get_pre_set_sm_code0(data)                          ((0x00008000&(data))>>15)
#define  HDMI_PRESET_S_CODE1_get_pre_set_sm_code1(data)                          ((0x00004000&(data))>>14)
#define  HDMI_PRESET_S_CODE1_get_pre_set_sm_code2(data)                          ((0x00002000&(data))>>13)
#define  HDMI_PRESET_S_CODE1_get_pre_set_sm_code3(data)                          ((0x00001000&(data))>>12)
#define  HDMI_PRESET_S_CODE1_get_pre_set_sm_code4(data)                          ((0x00000800&(data))>>11)
#define  HDMI_PRESET_S_CODE1_get_pre_set_s1_code4(data)                          ((0x00000080&(data))>>7)
#define  HDMI_PRESET_S_CODE1_get_pre_set_s_code4(data)                           (0x0000007F&(data))

#define  HDMI_PRBS_R_CTRL                                                        0x1800D134
#define  HDMI_PRBS_R_CTRL_reg_addr                                               "0xB800D134"
#define  HDMI_PRBS_R_CTRL_reg                                                    0xB800D134
#define  HDMI_PRBS_R_CTRL_inst_addr                                              "0x004D"
#define  set_HDMI_PRBS_R_CTRL_reg(data)                                          (*((volatile unsigned int*)HDMI_PRBS_R_CTRL_reg)=data)
#define  get_HDMI_PRBS_R_CTRL_reg                                                (*((volatile unsigned int*)HDMI_PRBS_R_CTRL_reg))
#define  HDMI_PRBS_R_CTRL_prbs23_rxen_shift                                      (28)
#define  HDMI_PRBS_R_CTRL_prbs_rxbist_err_cnt_shift                              (20)
#define  HDMI_PRBS_R_CTRL_prbs_err_cnt_shift                                     (16)
#define  HDMI_PRBS_R_CTRL_prbs_bit_err_shift                                     (4)
#define  HDMI_PRBS_R_CTRL_prbs_lock_shift                                        (3)
#define  HDMI_PRBS_R_CTRL_prbs_err_cnt_clr_shift                                 (2)
#define  HDMI_PRBS_R_CTRL_prbs_reverse_shift                                     (1)
#define  HDMI_PRBS_R_CTRL_prbs7_rxen_shift                                       (0)
#define  HDMI_PRBS_R_CTRL_prbs23_rxen_mask                                       (0x10000000)
#define  HDMI_PRBS_R_CTRL_prbs_rxbist_err_cnt_mask                               (0x0FF00000)
#define  HDMI_PRBS_R_CTRL_prbs_err_cnt_mask                                      (0x000F0000)
#define  HDMI_PRBS_R_CTRL_prbs_bit_err_mask                                      (0x00003FF0)
#define  HDMI_PRBS_R_CTRL_prbs_lock_mask                                         (0x00000008)
#define  HDMI_PRBS_R_CTRL_prbs_err_cnt_clr_mask                                  (0x00000004)
#define  HDMI_PRBS_R_CTRL_prbs_reverse_mask                                      (0x00000002)
#define  HDMI_PRBS_R_CTRL_prbs7_rxen_mask                                        (0x00000001)
#define  HDMI_PRBS_R_CTRL_prbs23_rxen(data)                                      (0x10000000&((data)<<28))
#define  HDMI_PRBS_R_CTRL_prbs_rxbist_err_cnt(data)                              (0x0FF00000&((data)<<20))
#define  HDMI_PRBS_R_CTRL_prbs_err_cnt(data)                                     (0x000F0000&((data)<<16))
#define  HDMI_PRBS_R_CTRL_prbs_bit_err(data)                                     (0x00003FF0&((data)<<4))
#define  HDMI_PRBS_R_CTRL_prbs_lock(data)                                        (0x00000008&((data)<<3))
#define  HDMI_PRBS_R_CTRL_prbs_err_cnt_clr(data)                                 (0x00000004&((data)<<2))
#define  HDMI_PRBS_R_CTRL_prbs_reverse(data)                                     (0x00000002&((data)<<1))
#define  HDMI_PRBS_R_CTRL_prbs7_rxen(data)                                       (0x00000001&(data))
#define  HDMI_PRBS_R_CTRL_get_prbs23_rxen(data)                                  ((0x10000000&(data))>>28)
#define  HDMI_PRBS_R_CTRL_get_prbs_rxbist_err_cnt(data)                          ((0x0FF00000&(data))>>20)
#define  HDMI_PRBS_R_CTRL_get_prbs_err_cnt(data)                                 ((0x000F0000&(data))>>16)
#define  HDMI_PRBS_R_CTRL_get_prbs_bit_err(data)                                 ((0x00003FF0&(data))>>4)
#define  HDMI_PRBS_R_CTRL_get_prbs_lock(data)                                    ((0x00000008&(data))>>3)
#define  HDMI_PRBS_R_CTRL_get_prbs_err_cnt_clr(data)                             ((0x00000004&(data))>>2)
#define  HDMI_PRBS_R_CTRL_get_prbs_reverse(data)                                 ((0x00000002&(data))>>1)
#define  HDMI_PRBS_R_CTRL_get_prbs7_rxen(data)                                   (0x00000001&(data))

#define  HDMI_PRBS_G_CTRL                                                        0x1800D138
#define  HDMI_PRBS_G_CTRL_reg_addr                                               "0xB800D138"
#define  HDMI_PRBS_G_CTRL_reg                                                    0xB800D138
#define  HDMI_PRBS_G_CTRL_inst_addr                                              "0x004E"
#define  set_HDMI_PRBS_G_CTRL_reg(data)                                          (*((volatile unsigned int*)HDMI_PRBS_G_CTRL_reg)=data)
#define  get_HDMI_PRBS_G_CTRL_reg                                                (*((volatile unsigned int*)HDMI_PRBS_G_CTRL_reg))
#define  HDMI_PRBS_G_CTRL_prbs23_rxen_shift                                      (28)
#define  HDMI_PRBS_G_CTRL_prbs_rxbist_err_cnt_shift                              (20)
#define  HDMI_PRBS_G_CTRL_prbs_err_cnt_shift                                     (16)
#define  HDMI_PRBS_G_CTRL_prbs_bit_err_shift                                     (4)
#define  HDMI_PRBS_G_CTRL_prbs_lock_shift                                        (3)
#define  HDMI_PRBS_G_CTRL_prbs_err_cnt_clr_shift                                 (2)
#define  HDMI_PRBS_G_CTRL_prbs_reverse_shift                                     (1)
#define  HDMI_PRBS_G_CTRL_prbs7_rxen_shift                                       (0)
#define  HDMI_PRBS_G_CTRL_prbs23_rxen_mask                                       (0x10000000)
#define  HDMI_PRBS_G_CTRL_prbs_rxbist_err_cnt_mask                               (0x0FF00000)
#define  HDMI_PRBS_G_CTRL_prbs_err_cnt_mask                                      (0x000F0000)
#define  HDMI_PRBS_G_CTRL_prbs_bit_err_mask                                      (0x00003FF0)
#define  HDMI_PRBS_G_CTRL_prbs_lock_mask                                         (0x00000008)
#define  HDMI_PRBS_G_CTRL_prbs_err_cnt_clr_mask                                  (0x00000004)
#define  HDMI_PRBS_G_CTRL_prbs_reverse_mask                                      (0x00000002)
#define  HDMI_PRBS_G_CTRL_prbs7_rxen_mask                                        (0x00000001)
#define  HDMI_PRBS_G_CTRL_prbs23_rxen(data)                                      (0x10000000&((data)<<28))
#define  HDMI_PRBS_G_CTRL_prbs_rxbist_err_cnt(data)                              (0x0FF00000&((data)<<20))
#define  HDMI_PRBS_G_CTRL_prbs_err_cnt(data)                                     (0x000F0000&((data)<<16))
#define  HDMI_PRBS_G_CTRL_prbs_bit_err(data)                                     (0x00003FF0&((data)<<4))
#define  HDMI_PRBS_G_CTRL_prbs_lock(data)                                        (0x00000008&((data)<<3))
#define  HDMI_PRBS_G_CTRL_prbs_err_cnt_clr(data)                                 (0x00000004&((data)<<2))
#define  HDMI_PRBS_G_CTRL_prbs_reverse(data)                                     (0x00000002&((data)<<1))
#define  HDMI_PRBS_G_CTRL_prbs7_rxen(data)                                       (0x00000001&(data))
#define  HDMI_PRBS_G_CTRL_get_prbs23_rxen(data)                                  ((0x10000000&(data))>>28)
#define  HDMI_PRBS_G_CTRL_get_prbs_rxbist_err_cnt(data)                          ((0x0FF00000&(data))>>20)
#define  HDMI_PRBS_G_CTRL_get_prbs_err_cnt(data)                                 ((0x000F0000&(data))>>16)
#define  HDMI_PRBS_G_CTRL_get_prbs_bit_err(data)                                 ((0x00003FF0&(data))>>4)
#define  HDMI_PRBS_G_CTRL_get_prbs_lock(data)                                    ((0x00000008&(data))>>3)
#define  HDMI_PRBS_G_CTRL_get_prbs_err_cnt_clr(data)                             ((0x00000004&(data))>>2)
#define  HDMI_PRBS_G_CTRL_get_prbs_reverse(data)                                 ((0x00000002&(data))>>1)
#define  HDMI_PRBS_G_CTRL_get_prbs7_rxen(data)                                   (0x00000001&(data))

#define  HDMI_PRBS_B_CTRL                                                        0x1800D13C
#define  HDMI_PRBS_B_CTRL_reg_addr                                               "0xB800D13C"
#define  HDMI_PRBS_B_CTRL_reg                                                    0xB800D13C
#define  HDMI_PRBS_B_CTRL_inst_addr                                              "0x004F"
#define  set_HDMI_PRBS_B_CTRL_reg(data)                                          (*((volatile unsigned int*)HDMI_PRBS_B_CTRL_reg)=data)
#define  get_HDMI_PRBS_B_CTRL_reg                                                (*((volatile unsigned int*)HDMI_PRBS_B_CTRL_reg))
#define  HDMI_PRBS_B_CTRL_prbs23_rxen_shift                                      (28)
#define  HDMI_PRBS_B_CTRL_prbs_rxbist_err_cnt_shift                              (20)
#define  HDMI_PRBS_B_CTRL_prbs_err_cnt_shift                                     (16)
#define  HDMI_PRBS_B_CTRL_prbs_bit_err_shift                                     (4)
#define  HDMI_PRBS_B_CTRL_prbs_lock_shift                                        (3)
#define  HDMI_PRBS_B_CTRL_prbs_err_cnt_clr_shift                                 (2)
#define  HDMI_PRBS_B_CTRL_prbs_reverse_shift                                     (1)
#define  HDMI_PRBS_B_CTRL_prbs7_rxen_shift                                       (0)
#define  HDMI_PRBS_B_CTRL_prbs23_rxen_mask                                       (0x10000000)
#define  HDMI_PRBS_B_CTRL_prbs_rxbist_err_cnt_mask                               (0x0FF00000)
#define  HDMI_PRBS_B_CTRL_prbs_err_cnt_mask                                      (0x000F0000)
#define  HDMI_PRBS_B_CTRL_prbs_bit_err_mask                                      (0x00003FF0)
#define  HDMI_PRBS_B_CTRL_prbs_lock_mask                                         (0x00000008)
#define  HDMI_PRBS_B_CTRL_prbs_err_cnt_clr_mask                                  (0x00000004)
#define  HDMI_PRBS_B_CTRL_prbs_reverse_mask                                      (0x00000002)
#define  HDMI_PRBS_B_CTRL_prbs7_rxen_mask                                        (0x00000001)
#define  HDMI_PRBS_B_CTRL_prbs23_rxen(data)                                      (0x10000000&((data)<<28))
#define  HDMI_PRBS_B_CTRL_prbs_rxbist_err_cnt(data)                              (0x0FF00000&((data)<<20))
#define  HDMI_PRBS_B_CTRL_prbs_err_cnt(data)                                     (0x000F0000&((data)<<16))
#define  HDMI_PRBS_B_CTRL_prbs_bit_err(data)                                     (0x00003FF0&((data)<<4))
#define  HDMI_PRBS_B_CTRL_prbs_lock(data)                                        (0x00000008&((data)<<3))
#define  HDMI_PRBS_B_CTRL_prbs_err_cnt_clr(data)                                 (0x00000004&((data)<<2))
#define  HDMI_PRBS_B_CTRL_prbs_reverse(data)                                     (0x00000002&((data)<<1))
#define  HDMI_PRBS_B_CTRL_prbs7_rxen(data)                                       (0x00000001&(data))
#define  HDMI_PRBS_B_CTRL_get_prbs23_rxen(data)                                  ((0x10000000&(data))>>28)
#define  HDMI_PRBS_B_CTRL_get_prbs_rxbist_err_cnt(data)                          ((0x0FF00000&(data))>>20)
#define  HDMI_PRBS_B_CTRL_get_prbs_err_cnt(data)                                 ((0x000F0000&(data))>>16)
#define  HDMI_PRBS_B_CTRL_get_prbs_bit_err(data)                                 ((0x00003FF0&(data))>>4)
#define  HDMI_PRBS_B_CTRL_get_prbs_lock(data)                                    ((0x00000008&(data))>>3)
#define  HDMI_PRBS_B_CTRL_get_prbs_err_cnt_clr(data)                             ((0x00000004&(data))>>2)
#define  HDMI_PRBS_B_CTRL_get_prbs_reverse(data)                                 ((0x00000002&(data))>>1)
#define  HDMI_PRBS_B_CTRL_get_prbs7_rxen(data)                                   (0x00000001&(data))

#define  HDMI_HDMI_leading_GB_cmp_ctrl                                           0x1800D140
#define  HDMI_HDMI_leading_GB_cmp_ctrl_reg_addr                                  "0xB800D140"
#define  HDMI_HDMI_leading_GB_cmp_ctrl_reg                                       0xB800D140
#define  HDMI_HDMI_leading_GB_cmp_ctrl_inst_addr                                 "0x0050"
#define  set_HDMI_HDMI_leading_GB_cmp_ctrl_reg(data)                             (*((volatile unsigned int*)HDMI_HDMI_leading_GB_cmp_ctrl_reg)=data)
#define  get_HDMI_HDMI_leading_GB_cmp_ctrl_reg                                   (*((volatile unsigned int*)HDMI_HDMI_leading_GB_cmp_ctrl_reg))
#define  HDMI_HDMI_leading_GB_cmp_ctrl_cmp_err_flag_shift                        (30)
#define  HDMI_HDMI_leading_GB_cmp_ctrl_cmp_err_wd_en_shift                       (29)
#define  HDMI_HDMI_leading_GB_cmp_ctrl_cmp_err_int_en_shift                      (28)
#define  HDMI_HDMI_leading_GB_cmp_ctrl_preamble_shift                            (24)
#define  HDMI_HDMI_leading_GB_cmp_ctrl_cmp_value_shift                           (8)
#define  HDMI_HDMI_leading_GB_cmp_ctrl_dvi_mode_sel_shift                        (4)
#define  HDMI_HDMI_leading_GB_cmp_ctrl_channel_sel_shift                         (2)
#define  HDMI_HDMI_leading_GB_cmp_ctrl_lgb_cal_conti_shift                       (1)
#define  HDMI_HDMI_leading_GB_cmp_ctrl_lgb_cal_en_shift                          (0)
#define  HDMI_HDMI_leading_GB_cmp_ctrl_cmp_err_flag_mask                         (0x40000000)
#define  HDMI_HDMI_leading_GB_cmp_ctrl_cmp_err_wd_en_mask                        (0x20000000)
#define  HDMI_HDMI_leading_GB_cmp_ctrl_cmp_err_int_en_mask                       (0x10000000)
#define  HDMI_HDMI_leading_GB_cmp_ctrl_preamble_mask                             (0x0F000000)
#define  HDMI_HDMI_leading_GB_cmp_ctrl_cmp_value_mask                            (0x0003FF00)
#define  HDMI_HDMI_leading_GB_cmp_ctrl_dvi_mode_sel_mask                         (0x00000010)
#define  HDMI_HDMI_leading_GB_cmp_ctrl_channel_sel_mask                          (0x0000000C)
#define  HDMI_HDMI_leading_GB_cmp_ctrl_lgb_cal_conti_mask                        (0x00000002)
#define  HDMI_HDMI_leading_GB_cmp_ctrl_lgb_cal_en_mask                           (0x00000001)
#define  HDMI_HDMI_leading_GB_cmp_ctrl_cmp_err_flag(data)                        (0x40000000&((data)<<30))
#define  HDMI_HDMI_leading_GB_cmp_ctrl_cmp_err_wd_en(data)                       (0x20000000&((data)<<29))
#define  HDMI_HDMI_leading_GB_cmp_ctrl_cmp_err_int_en(data)                      (0x10000000&((data)<<28))
#define  HDMI_HDMI_leading_GB_cmp_ctrl_preamble(data)                            (0x0F000000&((data)<<24))
#define  HDMI_HDMI_leading_GB_cmp_ctrl_cmp_value(data)                           (0x0003FF00&((data)<<8))
#define  HDMI_HDMI_leading_GB_cmp_ctrl_dvi_mode_sel(data)                        (0x00000010&((data)<<4))
#define  HDMI_HDMI_leading_GB_cmp_ctrl_channel_sel(data)                         (0x0000000C&((data)<<2))
#define  HDMI_HDMI_leading_GB_cmp_ctrl_lgb_cal_conti(data)                       (0x00000002&((data)<<1))
#define  HDMI_HDMI_leading_GB_cmp_ctrl_lgb_cal_en(data)                          (0x00000001&(data))
#define  HDMI_HDMI_leading_GB_cmp_ctrl_get_cmp_err_flag(data)                    ((0x40000000&(data))>>30)
#define  HDMI_HDMI_leading_GB_cmp_ctrl_get_cmp_err_wd_en(data)                   ((0x20000000&(data))>>29)
#define  HDMI_HDMI_leading_GB_cmp_ctrl_get_cmp_err_int_en(data)                  ((0x10000000&(data))>>28)
#define  HDMI_HDMI_leading_GB_cmp_ctrl_get_preamble(data)                        ((0x0F000000&(data))>>24)
#define  HDMI_HDMI_leading_GB_cmp_ctrl_get_cmp_value(data)                       ((0x0003FF00&(data))>>8)
#define  HDMI_HDMI_leading_GB_cmp_ctrl_get_dvi_mode_sel(data)                    ((0x00000010&(data))>>4)
#define  HDMI_HDMI_leading_GB_cmp_ctrl_get_channel_sel(data)                     ((0x0000000C&(data))>>2)
#define  HDMI_HDMI_leading_GB_cmp_ctrl_get_lgb_cal_conti(data)                   ((0x00000002&(data))>>1)
#define  HDMI_HDMI_leading_GB_cmp_ctrl_get_lgb_cal_en(data)                      (0x00000001&(data))

#define  HDMI_HDMI_leading_GB_cmp_times                                          0x1800D144
#define  HDMI_HDMI_leading_GB_cmp_times_reg_addr                                 "0xB800D144"
#define  HDMI_HDMI_leading_GB_cmp_times_reg                                      0xB800D144
#define  HDMI_HDMI_leading_GB_cmp_times_inst_addr                                "0x0051"
#define  set_HDMI_HDMI_leading_GB_cmp_times_reg(data)                            (*((volatile unsigned int*)HDMI_HDMI_leading_GB_cmp_times_reg)=data)
#define  get_HDMI_HDMI_leading_GB_cmp_times_reg                                  (*((volatile unsigned int*)HDMI_HDMI_leading_GB_cmp_times_reg))
#define  HDMI_HDMI_leading_GB_cmp_times_cmp_err_cnt_shift                        (16)
#define  HDMI_HDMI_leading_GB_cmp_times_cmp_times_shift                          (0)
#define  HDMI_HDMI_leading_GB_cmp_times_cmp_err_cnt_mask                         (0xFFFF0000)
#define  HDMI_HDMI_leading_GB_cmp_times_cmp_times_mask                           (0x0000FFFF)
#define  HDMI_HDMI_leading_GB_cmp_times_cmp_err_cnt(data)                        (0xFFFF0000&((data)<<16))
#define  HDMI_HDMI_leading_GB_cmp_times_cmp_times(data)                          (0x0000FFFF&(data))
#define  HDMI_HDMI_leading_GB_cmp_times_get_cmp_err_cnt(data)                    ((0xFFFF0000&(data))>>16)
#define  HDMI_HDMI_leading_GB_cmp_times_get_cmp_times(data)                      (0x0000FFFF&(data))

#define  HDMI_HDMI_leading_GB_cmp_cnt                                            0x1800D148
#define  HDMI_HDMI_leading_GB_cmp_cnt_reg_addr                                   "0xB800D148"
#define  HDMI_HDMI_leading_GB_cmp_cnt_reg                                        0xB800D148
#define  HDMI_HDMI_leading_GB_cmp_cnt_inst_addr                                  "0x0052"
#define  set_HDMI_HDMI_leading_GB_cmp_cnt_reg(data)                              (*((volatile unsigned int*)HDMI_HDMI_leading_GB_cmp_cnt_reg)=data)
#define  get_HDMI_HDMI_leading_GB_cmp_cnt_reg                                    (*((volatile unsigned int*)HDMI_HDMI_leading_GB_cmp_cnt_reg))
#define  HDMI_HDMI_leading_GB_cmp_cnt_preamble_cmp_cnt_shift                     (16)
#define  HDMI_HDMI_leading_GB_cmp_cnt_preamble_cmp_cnt_by_frame_shift            (0)
#define  HDMI_HDMI_leading_GB_cmp_cnt_preamble_cmp_cnt_mask                      (0xFFFF0000)
#define  HDMI_HDMI_leading_GB_cmp_cnt_preamble_cmp_cnt_by_frame_mask             (0x0000FFFF)
#define  HDMI_HDMI_leading_GB_cmp_cnt_preamble_cmp_cnt(data)                     (0xFFFF0000&((data)<<16))
#define  HDMI_HDMI_leading_GB_cmp_cnt_preamble_cmp_cnt_by_frame(data)            (0x0000FFFF&(data))
#define  HDMI_HDMI_leading_GB_cmp_cnt_get_preamble_cmp_cnt(data)                 ((0xFFFF0000&(data))>>16)
#define  HDMI_HDMI_leading_GB_cmp_cnt_get_preamble_cmp_cnt_by_frame(data)        (0x0000FFFF&(data))

#define  HDMI_AUDIO_CTS_UP_BOUND                                                 0x1800D14C
#define  HDMI_AUDIO_CTS_UP_BOUND_reg_addr                                        "0xB800D14C"
#define  HDMI_AUDIO_CTS_UP_BOUND_reg                                             0xB800D14C
#define  HDMI_AUDIO_CTS_UP_BOUND_inst_addr                                       "0x0053"
#define  set_HDMI_AUDIO_CTS_UP_BOUND_reg(data)                                   (*((volatile unsigned int*)HDMI_AUDIO_CTS_UP_BOUND_reg)=data)
#define  get_HDMI_AUDIO_CTS_UP_BOUND_reg                                         (*((volatile unsigned int*)HDMI_AUDIO_CTS_UP_BOUND_reg))
#define  HDMI_AUDIO_CTS_UP_BOUND_cts_over_flag_shift                             (31)
#define  HDMI_AUDIO_CTS_UP_BOUND_cts_clip_en_shift                               (20)
#define  HDMI_AUDIO_CTS_UP_BOUND_cts_up_bound_shift                              (0)
#define  HDMI_AUDIO_CTS_UP_BOUND_cts_over_flag_mask                              (0x80000000)
#define  HDMI_AUDIO_CTS_UP_BOUND_cts_clip_en_mask                                (0x00100000)
#define  HDMI_AUDIO_CTS_UP_BOUND_cts_up_bound_mask                               (0x000FFFFF)
#define  HDMI_AUDIO_CTS_UP_BOUND_cts_over_flag(data)                             (0x80000000&((data)<<31))
#define  HDMI_AUDIO_CTS_UP_BOUND_cts_clip_en(data)                               (0x00100000&((data)<<20))
#define  HDMI_AUDIO_CTS_UP_BOUND_cts_up_bound(data)                              (0x000FFFFF&(data))
#define  HDMI_AUDIO_CTS_UP_BOUND_get_cts_over_flag(data)                         ((0x80000000&(data))>>31)
#define  HDMI_AUDIO_CTS_UP_BOUND_get_cts_clip_en(data)                           ((0x00100000&(data))>>20)
#define  HDMI_AUDIO_CTS_UP_BOUND_get_cts_up_bound(data)                          (0x000FFFFF&(data))

#define  HDMI_AUDIO_CTS_LOW_BOUND                                                0x1800D150
#define  HDMI_AUDIO_CTS_LOW_BOUND_reg_addr                                       "0xB800D150"
#define  HDMI_AUDIO_CTS_LOW_BOUND_reg                                            0xB800D150
#define  HDMI_AUDIO_CTS_LOW_BOUND_inst_addr                                      "0x0054"
#define  set_HDMI_AUDIO_CTS_LOW_BOUND_reg(data)                                  (*((volatile unsigned int*)HDMI_AUDIO_CTS_LOW_BOUND_reg)=data)
#define  get_HDMI_AUDIO_CTS_LOW_BOUND_reg                                        (*((volatile unsigned int*)HDMI_AUDIO_CTS_LOW_BOUND_reg))
#define  HDMI_AUDIO_CTS_LOW_BOUND_cts_under_flag_shift                           (31)
#define  HDMI_AUDIO_CTS_LOW_BOUND_cts_low_bound_shift                            (0)
#define  HDMI_AUDIO_CTS_LOW_BOUND_cts_under_flag_mask                            (0x80000000)
#define  HDMI_AUDIO_CTS_LOW_BOUND_cts_low_bound_mask                             (0x000FFFFF)
#define  HDMI_AUDIO_CTS_LOW_BOUND_cts_under_flag(data)                           (0x80000000&((data)<<31))
#define  HDMI_AUDIO_CTS_LOW_BOUND_cts_low_bound(data)                            (0x000FFFFF&(data))
#define  HDMI_AUDIO_CTS_LOW_BOUND_get_cts_under_flag(data)                       ((0x80000000&(data))>>31)
#define  HDMI_AUDIO_CTS_LOW_BOUND_get_cts_low_bound(data)                        (0x000FFFFF&(data))

#define  HDMI_AUDIO_N_UP_BOUND                                                   0x1800D154
#define  HDMI_AUDIO_N_UP_BOUND_reg_addr                                          "0xB800D154"
#define  HDMI_AUDIO_N_UP_BOUND_reg                                               0xB800D154
#define  HDMI_AUDIO_N_UP_BOUND_inst_addr                                         "0x0055"
#define  set_HDMI_AUDIO_N_UP_BOUND_reg(data)                                     (*((volatile unsigned int*)HDMI_AUDIO_N_UP_BOUND_reg)=data)
#define  get_HDMI_AUDIO_N_UP_BOUND_reg                                           (*((volatile unsigned int*)HDMI_AUDIO_N_UP_BOUND_reg))
#define  HDMI_AUDIO_N_UP_BOUND_n_over_flag_shift                                 (31)
#define  HDMI_AUDIO_N_UP_BOUND_n_clip_en_shift                                   (20)
#define  HDMI_AUDIO_N_UP_BOUND_n_up_bound_shift                                  (0)
#define  HDMI_AUDIO_N_UP_BOUND_n_over_flag_mask                                  (0x80000000)
#define  HDMI_AUDIO_N_UP_BOUND_n_clip_en_mask                                    (0x00100000)
#define  HDMI_AUDIO_N_UP_BOUND_n_up_bound_mask                                   (0x000FFFFF)
#define  HDMI_AUDIO_N_UP_BOUND_n_over_flag(data)                                 (0x80000000&((data)<<31))
#define  HDMI_AUDIO_N_UP_BOUND_n_clip_en(data)                                   (0x00100000&((data)<<20))
#define  HDMI_AUDIO_N_UP_BOUND_n_up_bound(data)                                  (0x000FFFFF&(data))
#define  HDMI_AUDIO_N_UP_BOUND_get_n_over_flag(data)                             ((0x80000000&(data))>>31)
#define  HDMI_AUDIO_N_UP_BOUND_get_n_clip_en(data)                               ((0x00100000&(data))>>20)
#define  HDMI_AUDIO_N_UP_BOUND_get_n_up_bound(data)                              (0x000FFFFF&(data))

#define  HDMI_AUDIO_N_LOW_BOUND                                                  0x1800D158
#define  HDMI_AUDIO_N_LOW_BOUND_reg_addr                                         "0xB800D158"
#define  HDMI_AUDIO_N_LOW_BOUND_reg                                              0xB800D158
#define  HDMI_AUDIO_N_LOW_BOUND_inst_addr                                        "0x0056"
#define  set_HDMI_AUDIO_N_LOW_BOUND_reg(data)                                    (*((volatile unsigned int*)HDMI_AUDIO_N_LOW_BOUND_reg)=data)
#define  get_HDMI_AUDIO_N_LOW_BOUND_reg                                          (*((volatile unsigned int*)HDMI_AUDIO_N_LOW_BOUND_reg))
#define  HDMI_AUDIO_N_LOW_BOUND_n_under_flag_shift                               (31)
#define  HDMI_AUDIO_N_LOW_BOUND_n_low_bound_shift                                (0)
#define  HDMI_AUDIO_N_LOW_BOUND_n_under_flag_mask                                (0x80000000)
#define  HDMI_AUDIO_N_LOW_BOUND_n_low_bound_mask                                 (0x000FFFFF)
#define  HDMI_AUDIO_N_LOW_BOUND_n_under_flag(data)                               (0x80000000&((data)<<31))
#define  HDMI_AUDIO_N_LOW_BOUND_n_low_bound(data)                                (0x000FFFFF&(data))
#define  HDMI_AUDIO_N_LOW_BOUND_get_n_under_flag(data)                           ((0x80000000&(data))>>31)
#define  HDMI_AUDIO_N_LOW_BOUND_get_n_low_bound(data)                            (0x000FFFFF&(data))

#define  HDMI_MHL_HDMI_MAC_CTRL                                                  0x1800D15C
#define  HDMI_MHL_HDMI_MAC_CTRL_reg_addr                                         "0xB800D15C"
#define  HDMI_MHL_HDMI_MAC_CTRL_reg                                              0xB800D15C
#define  HDMI_MHL_HDMI_MAC_CTRL_inst_addr                                        "0x0057"
#define  set_HDMI_MHL_HDMI_MAC_CTRL_reg(data)                                    (*((volatile unsigned int*)HDMI_MHL_HDMI_MAC_CTRL_reg)=data)
#define  get_HDMI_MHL_HDMI_MAC_CTRL_reg                                          (*((volatile unsigned int*)HDMI_MHL_HDMI_MAC_CTRL_reg))
#define  HDMI_MHL_HDMI_MAC_CTRL_hporch_offset_shift                              (16)
#define  HDMI_MHL_HDMI_MAC_CTRL_dummy_shift                                      (14)
#define  HDMI_MHL_HDMI_MAC_CTRL_en_packet_retiming_vsrst_shift                   (13)
#define  HDMI_MHL_HDMI_MAC_CTRL_pp_mode_output_shift                             (12)
#define  HDMI_MHL_HDMI_MAC_CTRL_packet_mhl_en_shift                              (8)
#define  HDMI_MHL_HDMI_MAC_CTRL_xor_pixel_sel_shift                              (5)
#define  HDMI_MHL_HDMI_MAC_CTRL_cal_pixel_sel_shift                              (4)
#define  HDMI_MHL_HDMI_MAC_CTRL_ch_dec_pp_mode_en_shift                          (0)
#define  HDMI_MHL_HDMI_MAC_CTRL_hporch_offset_mask                               (0x03FF0000)
#define  HDMI_MHL_HDMI_MAC_CTRL_dummy_mask                                       (0x0000C000)
#define  HDMI_MHL_HDMI_MAC_CTRL_en_packet_retiming_vsrst_mask                    (0x00002000)
#define  HDMI_MHL_HDMI_MAC_CTRL_pp_mode_output_mask                              (0x00001000)
#define  HDMI_MHL_HDMI_MAC_CTRL_packet_mhl_en_mask                               (0x00000100)
#define  HDMI_MHL_HDMI_MAC_CTRL_xor_pixel_sel_mask                               (0x000000E0)
#define  HDMI_MHL_HDMI_MAC_CTRL_cal_pixel_sel_mask                               (0x00000010)
#define  HDMI_MHL_HDMI_MAC_CTRL_ch_dec_pp_mode_en_mask                           (0x00000001)
#define  HDMI_MHL_HDMI_MAC_CTRL_hporch_offset(data)                              (0x03FF0000&((data)<<16))
#define  HDMI_MHL_HDMI_MAC_CTRL_dummy(data)                                      (0x0000C000&((data)<<14))
#define  HDMI_MHL_HDMI_MAC_CTRL_en_packet_retiming_vsrst(data)                   (0x00002000&((data)<<13))
#define  HDMI_MHL_HDMI_MAC_CTRL_pp_mode_output(data)                             (0x00001000&((data)<<12))
#define  HDMI_MHL_HDMI_MAC_CTRL_packet_mhl_en(data)                              (0x00000100&((data)<<8))
#define  HDMI_MHL_HDMI_MAC_CTRL_xor_pixel_sel(data)                              (0x000000E0&((data)<<5))
#define  HDMI_MHL_HDMI_MAC_CTRL_cal_pixel_sel(data)                              (0x00000010&((data)<<4))
#define  HDMI_MHL_HDMI_MAC_CTRL_ch_dec_pp_mode_en(data)                          (0x00000001&(data))
#define  HDMI_MHL_HDMI_MAC_CTRL_get_hporch_offset(data)                          ((0x03FF0000&(data))>>16)
#define  HDMI_MHL_HDMI_MAC_CTRL_get_dummy(data)                                  ((0x0000C000&(data))>>14)
#define  HDMI_MHL_HDMI_MAC_CTRL_get_en_packet_retiming_vsrst(data)               ((0x00002000&(data))>>13)
#define  HDMI_MHL_HDMI_MAC_CTRL_get_pp_mode_output(data)                         ((0x00001000&(data))>>12)
#define  HDMI_MHL_HDMI_MAC_CTRL_get_packet_mhl_en(data)                          ((0x00000100&(data))>>8)
#define  HDMI_MHL_HDMI_MAC_CTRL_get_xor_pixel_sel(data)                          ((0x000000E0&(data))>>5)
#define  HDMI_MHL_HDMI_MAC_CTRL_get_cal_pixel_sel(data)                          ((0x00000010&(data))>>4)
#define  HDMI_MHL_HDMI_MAC_CTRL_get_ch_dec_pp_mode_en(data)                      (0x00000001&(data))

#define  HDMI_MHL_3D_FORMAT                                                      0x1800D160
#define  HDMI_MHL_3D_FORMAT_reg_addr                                             "0xB800D160"
#define  HDMI_MHL_3D_FORMAT_reg                                                  0xB800D160
#define  HDMI_MHL_3D_FORMAT_inst_addr                                            "0x0058"
#define  set_HDMI_MHL_3D_FORMAT_reg(data)                                        (*((volatile unsigned int*)HDMI_MHL_3D_FORMAT_reg)=data)
#define  get_HDMI_MHL_3D_FORMAT_reg                                              (*((volatile unsigned int*)HDMI_MHL_3D_FORMAT_reg))
#define  HDMI_MHL_3D_FORMAT_mhl_3d_fmt_shift                                     (26)
#define  HDMI_MHL_3D_FORMAT_mhl_vid_shift                                        (24)
#define  HDMI_MHL_3D_FORMAT_oui_shift                                            (0)
#define  HDMI_MHL_3D_FORMAT_mhl_3d_fmt_mask                                      (0x3C000000)
#define  HDMI_MHL_3D_FORMAT_mhl_vid_mask                                         (0x03000000)
#define  HDMI_MHL_3D_FORMAT_oui_mask                                             (0x00FFFFFF)
#define  HDMI_MHL_3D_FORMAT_mhl_3d_fmt(data)                                     (0x3C000000&((data)<<26))
#define  HDMI_MHL_3D_FORMAT_mhl_vid(data)                                        (0x03000000&((data)<<24))
#define  HDMI_MHL_3D_FORMAT_oui(data)                                            (0x00FFFFFF&(data))
#define  HDMI_MHL_3D_FORMAT_get_mhl_3d_fmt(data)                                 ((0x3C000000&(data))>>26)
#define  HDMI_MHL_3D_FORMAT_get_mhl_vid(data)                                    ((0x03000000&(data))>>24)
#define  HDMI_MHL_3D_FORMAT_get_oui(data)                                        (0x00FFFFFF&(data))

#define  HDMI_MHL_3p0_FORMAT0                                                    0x1800D164
#define  HDMI_MHL_3p0_FORMAT0_reg_addr                                           "0xB800D164"
#define  HDMI_MHL_3p0_FORMAT0_reg                                                0xB800D164
#define  HDMI_MHL_3p0_FORMAT0_inst_addr                                          "0x0059"
#define  set_HDMI_MHL_3p0_FORMAT0_reg(data)                                      (*((volatile unsigned int*)HDMI_MHL_3p0_FORMAT0_reg)=data)
#define  get_HDMI_MHL_3p0_FORMAT0_reg                                            (*((volatile unsigned int*)HDMI_MHL_3p0_FORMAT0_reg))
#define  HDMI_MHL_3p0_FORMAT0_mhl_hev_fmt_shift                                  (17)
#define  HDMI_MHL_3p0_FORMAT0_sep_aud_shift                                      (16)
#define  HDMI_MHL_3p0_FORMAT0_mhl_hev_fmt_type_shift                             (0)
#define  HDMI_MHL_3p0_FORMAT0_mhl_hev_fmt_mask                                   (0x00060000)
#define  HDMI_MHL_3p0_FORMAT0_sep_aud_mask                                       (0x00010000)
#define  HDMI_MHL_3p0_FORMAT0_mhl_hev_fmt_type_mask                              (0x0000FFFF)
#define  HDMI_MHL_3p0_FORMAT0_mhl_hev_fmt(data)                                  (0x00060000&((data)<<17))
#define  HDMI_MHL_3p0_FORMAT0_sep_aud(data)                                      (0x00010000&((data)<<16))
#define  HDMI_MHL_3p0_FORMAT0_mhl_hev_fmt_type(data)                             (0x0000FFFF&(data))
#define  HDMI_MHL_3p0_FORMAT0_get_mhl_hev_fmt(data)                              ((0x00060000&(data))>>17)
#define  HDMI_MHL_3p0_FORMAT0_get_sep_aud(data)                                  ((0x00010000&(data))>>16)
#define  HDMI_MHL_3p0_FORMAT0_get_mhl_hev_fmt_type(data)                         (0x0000FFFF&(data))

#define  HDMI_MHL_3p0_FORMAT1                                                    0x1800D168
#define  HDMI_MHL_3p0_FORMAT1_reg_addr                                           "0xB800D168"
#define  HDMI_MHL_3p0_FORMAT1_reg                                                0xB800D168
#define  HDMI_MHL_3p0_FORMAT1_inst_addr                                          "0x005A"
#define  set_HDMI_MHL_3p0_FORMAT1_reg(data)                                      (*((volatile unsigned int*)HDMI_MHL_3p0_FORMAT1_reg)=data)
#define  get_HDMI_MHL_3p0_FORMAT1_reg                                            (*((volatile unsigned int*)HDMI_MHL_3p0_FORMAT1_reg))
#define  HDMI_MHL_3p0_FORMAT1_acrfs_div_shift                                    (21)
#define  HDMI_MHL_3p0_FORMAT1_av_delay_dir_shift                                 (20)
#define  HDMI_MHL_3p0_FORMAT1_av_delay_sync_shift                                (0)
#define  HDMI_MHL_3p0_FORMAT1_acrfs_div_mask                                     (0x00E00000)
#define  HDMI_MHL_3p0_FORMAT1_av_delay_dir_mask                                  (0x00100000)
#define  HDMI_MHL_3p0_FORMAT1_av_delay_sync_mask                                 (0x000FFFFF)
#define  HDMI_MHL_3p0_FORMAT1_acrfs_div(data)                                    (0x00E00000&((data)<<21))
#define  HDMI_MHL_3p0_FORMAT1_av_delay_dir(data)                                 (0x00100000&((data)<<20))
#define  HDMI_MHL_3p0_FORMAT1_av_delay_sync(data)                                (0x000FFFFF&(data))
#define  HDMI_MHL_3p0_FORMAT1_get_acrfs_div(data)                                ((0x00E00000&(data))>>21)
#define  HDMI_MHL_3p0_FORMAT1_get_av_delay_dir(data)                             ((0x00100000&(data))>>20)
#define  HDMI_MHL_3p0_FORMAT1_get_av_delay_sync(data)                            (0x000FFFFF&(data))

#define  HDMI_LIGHT_SLEEP                                                        0x1800D170
#define  HDMI_LIGHT_SLEEP_reg_addr                                               "0xB800D170"
#define  HDMI_LIGHT_SLEEP_reg                                                    0xB800D170
#define  HDMI_LIGHT_SLEEP_inst_addr                                              "0x005B"
#define  set_HDMI_LIGHT_SLEEP_reg(data)                                          (*((volatile unsigned int*)HDMI_LIGHT_SLEEP_reg)=data)
#define  get_HDMI_LIGHT_SLEEP_reg                                                (*((volatile unsigned int*)HDMI_LIGHT_SLEEP_reg))
#define  HDMI_LIGHT_SLEEP_yuv420_ls3_shift                                       (8)
#define  HDMI_LIGHT_SLEEP_yuv420_ls2_shift                                       (7)
#define  HDMI_LIGHT_SLEEP_yuv420_ls1_shift                                       (6)
#define  HDMI_LIGHT_SLEEP_yuv420_ls0_shift                                       (5)
#define  HDMI_LIGHT_SLEEP_hdcp_2p2_ls1_shift                                     (4)
#define  HDMI_LIGHT_SLEEP_hdcp_2p2_ls0_shift                                     (3)
#define  HDMI_LIGHT_SLEEP_hdcp_ksvfifo_ls_shift                                  (2)
#define  HDMI_LIGHT_SLEEP_hdcp_ls_shift                                          (1)
#define  HDMI_LIGHT_SLEEP_audio_ls_shift                                         (0)
#define  HDMI_LIGHT_SLEEP_yuv420_ls3_mask                                        (0x00000100)
#define  HDMI_LIGHT_SLEEP_yuv420_ls2_mask                                        (0x00000080)
#define  HDMI_LIGHT_SLEEP_yuv420_ls1_mask                                        (0x00000040)
#define  HDMI_LIGHT_SLEEP_yuv420_ls0_mask                                        (0x00000020)
#define  HDMI_LIGHT_SLEEP_hdcp_2p2_ls1_mask                                      (0x00000010)
#define  HDMI_LIGHT_SLEEP_hdcp_2p2_ls0_mask                                      (0x00000008)
#define  HDMI_LIGHT_SLEEP_hdcp_ksvfifo_ls_mask                                   (0x00000004)
#define  HDMI_LIGHT_SLEEP_hdcp_ls_mask                                           (0x00000002)
#define  HDMI_LIGHT_SLEEP_audio_ls_mask                                          (0x00000001)
#define  HDMI_LIGHT_SLEEP_yuv420_ls3(data)                                       (0x00000100&((data)<<8))
#define  HDMI_LIGHT_SLEEP_yuv420_ls2(data)                                       (0x00000080&((data)<<7))
#define  HDMI_LIGHT_SLEEP_yuv420_ls1(data)                                       (0x00000040&((data)<<6))
#define  HDMI_LIGHT_SLEEP_yuv420_ls0(data)                                       (0x00000020&((data)<<5))
#define  HDMI_LIGHT_SLEEP_hdcp_2p2_ls1(data)                                     (0x00000010&((data)<<4))
#define  HDMI_LIGHT_SLEEP_hdcp_2p2_ls0(data)                                     (0x00000008&((data)<<3))
#define  HDMI_LIGHT_SLEEP_hdcp_ksvfifo_ls(data)                                  (0x00000004&((data)<<2))
#define  HDMI_LIGHT_SLEEP_hdcp_ls(data)                                          (0x00000002&((data)<<1))
#define  HDMI_LIGHT_SLEEP_audio_ls(data)                                         (0x00000001&(data))
#define  HDMI_LIGHT_SLEEP_get_yuv420_ls3(data)                                   ((0x00000100&(data))>>8)
#define  HDMI_LIGHT_SLEEP_get_yuv420_ls2(data)                                   ((0x00000080&(data))>>7)
#define  HDMI_LIGHT_SLEEP_get_yuv420_ls1(data)                                   ((0x00000040&(data))>>6)
#define  HDMI_LIGHT_SLEEP_get_yuv420_ls0(data)                                   ((0x00000020&(data))>>5)
#define  HDMI_LIGHT_SLEEP_get_hdcp_2p2_ls1(data)                                 ((0x00000010&(data))>>4)
#define  HDMI_LIGHT_SLEEP_get_hdcp_2p2_ls0(data)                                 ((0x00000008&(data))>>3)
#define  HDMI_LIGHT_SLEEP_get_hdcp_ksvfifo_ls(data)                              ((0x00000004&(data))>>2)
#define  HDMI_LIGHT_SLEEP_get_hdcp_ls(data)                                      ((0x00000002&(data))>>1)
#define  HDMI_LIGHT_SLEEP_get_audio_ls(data)                                     (0x00000001&(data))

#define  HDMI_READ_MARGIN2                                                       0x1800D174
#define  HDMI_READ_MARGIN2_reg_addr                                              "0xB800D174"
#define  HDMI_READ_MARGIN2_reg                                                   0xB800D174
#define  HDMI_READ_MARGIN2_inst_addr                                             "0x005C"
#define  set_HDMI_READ_MARGIN2_reg(data)                                         (*((volatile unsigned int*)HDMI_READ_MARGIN2_reg)=data)
#define  get_HDMI_READ_MARGIN2_reg                                               (*((volatile unsigned int*)HDMI_READ_MARGIN2_reg))
#define  HDMI_READ_MARGIN2_yuv420_rm3_shift                                      (12)
#define  HDMI_READ_MARGIN2_yuv420_rm2_shift                                      (8)
#define  HDMI_READ_MARGIN2_yuv420_rm1_shift                                      (4)
#define  HDMI_READ_MARGIN2_yuv420_rm0_shift                                      (0)
#define  HDMI_READ_MARGIN2_yuv420_rm3_mask                                       (0x0000F000)
#define  HDMI_READ_MARGIN2_yuv420_rm2_mask                                       (0x00000F00)
#define  HDMI_READ_MARGIN2_yuv420_rm1_mask                                       (0x000000F0)
#define  HDMI_READ_MARGIN2_yuv420_rm0_mask                                       (0x0000000F)
#define  HDMI_READ_MARGIN2_yuv420_rm3(data)                                      (0x0000F000&((data)<<12))
#define  HDMI_READ_MARGIN2_yuv420_rm2(data)                                      (0x00000F00&((data)<<8))
#define  HDMI_READ_MARGIN2_yuv420_rm1(data)                                      (0x000000F0&((data)<<4))
#define  HDMI_READ_MARGIN2_yuv420_rm0(data)                                      (0x0000000F&(data))
#define  HDMI_READ_MARGIN2_get_yuv420_rm3(data)                                  ((0x0000F000&(data))>>12)
#define  HDMI_READ_MARGIN2_get_yuv420_rm2(data)                                  ((0x00000F00&(data))>>8)
#define  HDMI_READ_MARGIN2_get_yuv420_rm1(data)                                  ((0x000000F0&(data))>>4)
#define  HDMI_READ_MARGIN2_get_yuv420_rm0(data)                                  (0x0000000F&(data))

#define  HDMI_READ_MARGIN_ENABLE                                                 0x1800D178
#define  HDMI_READ_MARGIN_ENABLE_reg_addr                                        "0xB800D178"
#define  HDMI_READ_MARGIN_ENABLE_reg                                             0xB800D178
#define  HDMI_READ_MARGIN_ENABLE_inst_addr                                       "0x005D"
#define  set_HDMI_READ_MARGIN_ENABLE_reg(data)                                   (*((volatile unsigned int*)HDMI_READ_MARGIN_ENABLE_reg)=data)
#define  get_HDMI_READ_MARGIN_ENABLE_reg                                         (*((volatile unsigned int*)HDMI_READ_MARGIN_ENABLE_reg))
#define  HDMI_READ_MARGIN_ENABLE_yuv420_rme3_shift                               (8)
#define  HDMI_READ_MARGIN_ENABLE_yuv420_rme2_shift                               (7)
#define  HDMI_READ_MARGIN_ENABLE_yuv420_rme1_shift                               (6)
#define  HDMI_READ_MARGIN_ENABLE_yuv420_rme0_shift                               (5)
#define  HDMI_READ_MARGIN_ENABLE_hdcp_2p2_rme1_shift                             (4)
#define  HDMI_READ_MARGIN_ENABLE_hdcp_2p2_rme0_shift                             (3)
#define  HDMI_READ_MARGIN_ENABLE_hdcp_ksvfifo_rme_shift                          (2)
#define  HDMI_READ_MARGIN_ENABLE_hdcp_rme_shift                                  (1)
#define  HDMI_READ_MARGIN_ENABLE_audio_rme_shift                                 (0)
#define  HDMI_READ_MARGIN_ENABLE_yuv420_rme3_mask                                (0x00000100)
#define  HDMI_READ_MARGIN_ENABLE_yuv420_rme2_mask                                (0x00000080)
#define  HDMI_READ_MARGIN_ENABLE_yuv420_rme1_mask                                (0x00000040)
#define  HDMI_READ_MARGIN_ENABLE_yuv420_rme0_mask                                (0x00000020)
#define  HDMI_READ_MARGIN_ENABLE_hdcp_2p2_rme1_mask                              (0x00000010)
#define  HDMI_READ_MARGIN_ENABLE_hdcp_2p2_rme0_mask                              (0x00000008)
#define  HDMI_READ_MARGIN_ENABLE_hdcp_ksvfifo_rme_mask                           (0x00000004)
#define  HDMI_READ_MARGIN_ENABLE_hdcp_rme_mask                                   (0x00000002)
#define  HDMI_READ_MARGIN_ENABLE_audio_rme_mask                                  (0x00000001)
#define  HDMI_READ_MARGIN_ENABLE_yuv420_rme3(data)                               (0x00000100&((data)<<8))
#define  HDMI_READ_MARGIN_ENABLE_yuv420_rme2(data)                               (0x00000080&((data)<<7))
#define  HDMI_READ_MARGIN_ENABLE_yuv420_rme1(data)                               (0x00000040&((data)<<6))
#define  HDMI_READ_MARGIN_ENABLE_yuv420_rme0(data)                               (0x00000020&((data)<<5))
#define  HDMI_READ_MARGIN_ENABLE_hdcp_2p2_rme1(data)                             (0x00000010&((data)<<4))
#define  HDMI_READ_MARGIN_ENABLE_hdcp_2p2_rme0(data)                             (0x00000008&((data)<<3))
#define  HDMI_READ_MARGIN_ENABLE_hdcp_ksvfifo_rme(data)                          (0x00000004&((data)<<2))
#define  HDMI_READ_MARGIN_ENABLE_hdcp_rme(data)                                  (0x00000002&((data)<<1))
#define  HDMI_READ_MARGIN_ENABLE_audio_rme(data)                                 (0x00000001&(data))
#define  HDMI_READ_MARGIN_ENABLE_get_yuv420_rme3(data)                           ((0x00000100&(data))>>8)
#define  HDMI_READ_MARGIN_ENABLE_get_yuv420_rme2(data)                           ((0x00000080&(data))>>7)
#define  HDMI_READ_MARGIN_ENABLE_get_yuv420_rme1(data)                           ((0x00000040&(data))>>6)
#define  HDMI_READ_MARGIN_ENABLE_get_yuv420_rme0(data)                           ((0x00000020&(data))>>5)
#define  HDMI_READ_MARGIN_ENABLE_get_hdcp_2p2_rme1(data)                         ((0x00000010&(data))>>4)
#define  HDMI_READ_MARGIN_ENABLE_get_hdcp_2p2_rme0(data)                         ((0x00000008&(data))>>3)
#define  HDMI_READ_MARGIN_ENABLE_get_hdcp_ksvfifo_rme(data)                      ((0x00000004&(data))>>2)
#define  HDMI_READ_MARGIN_ENABLE_get_hdcp_rme(data)                              ((0x00000002&(data))>>1)
#define  HDMI_READ_MARGIN_ENABLE_get_audio_rme(data)                             (0x00000001&(data))

#define  HDMI_READ_MARGIN                                                        0x1800D17C
#define  HDMI_READ_MARGIN_reg_addr                                               "0xB800D17C"
#define  HDMI_READ_MARGIN_reg                                                    0xB800D17C
#define  HDMI_READ_MARGIN_inst_addr                                              "0x005E"
#define  set_HDMI_READ_MARGIN_reg(data)                                          (*((volatile unsigned int*)HDMI_READ_MARGIN_reg)=data)
#define  get_HDMI_READ_MARGIN_reg                                                (*((volatile unsigned int*)HDMI_READ_MARGIN_reg))
#define  HDMI_READ_MARGIN_hdcp_2p2_rm1_shift                                     (16)
#define  HDMI_READ_MARGIN_hdcp_2p2_rm0_shift                                     (12)
#define  HDMI_READ_MARGIN_hdcp_ksvfifo_rm_shift                                  (8)
#define  HDMI_READ_MARGIN_hdcp_rm_shift                                          (4)
#define  HDMI_READ_MARGIN_audio_rm_shift                                         (0)
#define  HDMI_READ_MARGIN_hdcp_2p2_rm1_mask                                      (0x000F0000)
#define  HDMI_READ_MARGIN_hdcp_2p2_rm0_mask                                      (0x0000F000)
#define  HDMI_READ_MARGIN_hdcp_ksvfifo_rm_mask                                   (0x00000F00)
#define  HDMI_READ_MARGIN_hdcp_rm_mask                                           (0x000000F0)
#define  HDMI_READ_MARGIN_audio_rm_mask                                          (0x0000000F)
#define  HDMI_READ_MARGIN_hdcp_2p2_rm1(data)                                     (0x000F0000&((data)<<16))
#define  HDMI_READ_MARGIN_hdcp_2p2_rm0(data)                                     (0x0000F000&((data)<<12))
#define  HDMI_READ_MARGIN_hdcp_ksvfifo_rm(data)                                  (0x00000F00&((data)<<8))
#define  HDMI_READ_MARGIN_hdcp_rm(data)                                          (0x000000F0&((data)<<4))
#define  HDMI_READ_MARGIN_audio_rm(data)                                         (0x0000000F&(data))
#define  HDMI_READ_MARGIN_get_hdcp_2p2_rm1(data)                                 ((0x000F0000&(data))>>16)
#define  HDMI_READ_MARGIN_get_hdcp_2p2_rm0(data)                                 ((0x0000F000&(data))>>12)
#define  HDMI_READ_MARGIN_get_hdcp_ksvfifo_rm(data)                              ((0x00000F00&(data))>>8)
#define  HDMI_READ_MARGIN_get_hdcp_rm(data)                                      ((0x000000F0&(data))>>4)
#define  HDMI_READ_MARGIN_get_audio_rm(data)                                     (0x0000000F&(data))

#define  HDMI_BIST_MODE                                                          0x1800D180
#define  HDMI_BIST_MODE_reg_addr                                                 "0xB800D180"
#define  HDMI_BIST_MODE_reg                                                      0xB800D180
#define  HDMI_BIST_MODE_inst_addr                                                "0x005F"
#define  set_HDMI_BIST_MODE_reg(data)                                            (*((volatile unsigned int*)HDMI_BIST_MODE_reg)=data)
#define  get_HDMI_BIST_MODE_reg                                                  (*((volatile unsigned int*)HDMI_BIST_MODE_reg))
#define  HDMI_BIST_MODE_yuv420_bist_en_shift                                     (4)
#define  HDMI_BIST_MODE_hdcp_2p2_bist_en_shift                                   (3)
#define  HDMI_BIST_MODE_hdcp_ksvfifo_bist_en_shift                               (2)
#define  HDMI_BIST_MODE_hdcp_bist_en_shift                                       (1)
#define  HDMI_BIST_MODE_audio_bist_en_shift                                      (0)
#define  HDMI_BIST_MODE_yuv420_bist_en_mask                                      (0x00000010)
#define  HDMI_BIST_MODE_hdcp_2p2_bist_en_mask                                    (0x00000008)
#define  HDMI_BIST_MODE_hdcp_ksvfifo_bist_en_mask                                (0x00000004)
#define  HDMI_BIST_MODE_hdcp_bist_en_mask                                        (0x00000002)
#define  HDMI_BIST_MODE_audio_bist_en_mask                                       (0x00000001)
#define  HDMI_BIST_MODE_yuv420_bist_en(data)                                     (0x00000010&((data)<<4))
#define  HDMI_BIST_MODE_hdcp_2p2_bist_en(data)                                   (0x00000008&((data)<<3))
#define  HDMI_BIST_MODE_hdcp_ksvfifo_bist_en(data)                               (0x00000004&((data)<<2))
#define  HDMI_BIST_MODE_hdcp_bist_en(data)                                       (0x00000002&((data)<<1))
#define  HDMI_BIST_MODE_audio_bist_en(data)                                      (0x00000001&(data))
#define  HDMI_BIST_MODE_get_yuv420_bist_en(data)                                 ((0x00000010&(data))>>4)
#define  HDMI_BIST_MODE_get_hdcp_2p2_bist_en(data)                               ((0x00000008&(data))>>3)
#define  HDMI_BIST_MODE_get_hdcp_ksvfifo_bist_en(data)                           ((0x00000004&(data))>>2)
#define  HDMI_BIST_MODE_get_hdcp_bist_en(data)                                   ((0x00000002&(data))>>1)
#define  HDMI_BIST_MODE_get_audio_bist_en(data)                                  (0x00000001&(data))

#define  HDMI_BIST_DONE                                                          0x1800D184
#define  HDMI_BIST_DONE_reg_addr                                                 "0xB800D184"
#define  HDMI_BIST_DONE_reg                                                      0xB800D184
#define  HDMI_BIST_DONE_inst_addr                                                "0x0060"
#define  set_HDMI_BIST_DONE_reg(data)                                            (*((volatile unsigned int*)HDMI_BIST_DONE_reg)=data)
#define  get_HDMI_BIST_DONE_reg                                                  (*((volatile unsigned int*)HDMI_BIST_DONE_reg))
#define  HDMI_BIST_DONE_yuv420_bist_done_shift                                   (4)
#define  HDMI_BIST_DONE_hdcp_2p2_bist_done_shift                                 (3)
#define  HDMI_BIST_DONE_hdcp_ksvfifo_bist_done_shift                             (2)
#define  HDMI_BIST_DONE_hdcp_bist_done_shift                                     (1)
#define  HDMI_BIST_DONE_audio_bist_done_shift                                    (0)
#define  HDMI_BIST_DONE_yuv420_bist_done_mask                                    (0x00000010)
#define  HDMI_BIST_DONE_hdcp_2p2_bist_done_mask                                  (0x00000008)
#define  HDMI_BIST_DONE_hdcp_ksvfifo_bist_done_mask                              (0x00000004)
#define  HDMI_BIST_DONE_hdcp_bist_done_mask                                      (0x00000002)
#define  HDMI_BIST_DONE_audio_bist_done_mask                                     (0x00000001)
#define  HDMI_BIST_DONE_yuv420_bist_done(data)                                   (0x00000010&((data)<<4))
#define  HDMI_BIST_DONE_hdcp_2p2_bist_done(data)                                 (0x00000008&((data)<<3))
#define  HDMI_BIST_DONE_hdcp_ksvfifo_bist_done(data)                             (0x00000004&((data)<<2))
#define  HDMI_BIST_DONE_hdcp_bist_done(data)                                     (0x00000002&((data)<<1))
#define  HDMI_BIST_DONE_audio_bist_done(data)                                    (0x00000001&(data))
#define  HDMI_BIST_DONE_get_yuv420_bist_done(data)                               ((0x00000010&(data))>>4)
#define  HDMI_BIST_DONE_get_hdcp_2p2_bist_done(data)                             ((0x00000008&(data))>>3)
#define  HDMI_BIST_DONE_get_hdcp_ksvfifo_bist_done(data)                         ((0x00000004&(data))>>2)
#define  HDMI_BIST_DONE_get_hdcp_bist_done(data)                                 ((0x00000002&(data))>>1)
#define  HDMI_BIST_DONE_get_audio_bist_done(data)                                (0x00000001&(data))

#define  HDMI_BIST_FAIL                                                          0x1800D188
#define  HDMI_BIST_FAIL_reg_addr                                                 "0xB800D188"
#define  HDMI_BIST_FAIL_reg                                                      0xB800D188
#define  HDMI_BIST_FAIL_inst_addr                                                "0x0061"
#define  set_HDMI_BIST_FAIL_reg(data)                                            (*((volatile unsigned int*)HDMI_BIST_FAIL_reg)=data)
#define  get_HDMI_BIST_FAIL_reg                                                  (*((volatile unsigned int*)HDMI_BIST_FAIL_reg))
#define  HDMI_BIST_FAIL_yuv420_bist_fail_shift                                   (4)
#define  HDMI_BIST_FAIL_hdcp_2p2_bist_fail_shift                                 (3)
#define  HDMI_BIST_FAIL_hdcp_ksvfifo_bist_fail_shift                             (2)
#define  HDMI_BIST_FAIL_hdcp_bist_fail_shift                                     (1)
#define  HDMI_BIST_FAIL_audio_bist_fail_shift                                    (0)
#define  HDMI_BIST_FAIL_yuv420_bist_fail_mask                                    (0x00000010)
#define  HDMI_BIST_FAIL_hdcp_2p2_bist_fail_mask                                  (0x00000008)
#define  HDMI_BIST_FAIL_hdcp_ksvfifo_bist_fail_mask                              (0x00000004)
#define  HDMI_BIST_FAIL_hdcp_bist_fail_mask                                      (0x00000002)
#define  HDMI_BIST_FAIL_audio_bist_fail_mask                                     (0x00000001)
#define  HDMI_BIST_FAIL_yuv420_bist_fail(data)                                   (0x00000010&((data)<<4))
#define  HDMI_BIST_FAIL_hdcp_2p2_bist_fail(data)                                 (0x00000008&((data)<<3))
#define  HDMI_BIST_FAIL_hdcp_ksvfifo_bist_fail(data)                             (0x00000004&((data)<<2))
#define  HDMI_BIST_FAIL_hdcp_bist_fail(data)                                     (0x00000002&((data)<<1))
#define  HDMI_BIST_FAIL_audio_bist_fail(data)                                    (0x00000001&(data))
#define  HDMI_BIST_FAIL_get_yuv420_bist_fail(data)                               ((0x00000010&(data))>>4)
#define  HDMI_BIST_FAIL_get_hdcp_2p2_bist_fail(data)                             ((0x00000008&(data))>>3)
#define  HDMI_BIST_FAIL_get_hdcp_ksvfifo_bist_fail(data)                         ((0x00000004&(data))>>2)
#define  HDMI_BIST_FAIL_get_hdcp_bist_fail(data)                                 ((0x00000002&(data))>>1)
#define  HDMI_BIST_FAIL_get_audio_bist_fail(data)                                (0x00000001&(data))

#define  HDMI_DRF_MODE                                                           0x1800D18C
#define  HDMI_DRF_MODE_reg_addr                                                  "0xB800D18C"
#define  HDMI_DRF_MODE_reg                                                       0xB800D18C
#define  HDMI_DRF_MODE_inst_addr                                                 "0x0062"
#define  set_HDMI_DRF_MODE_reg(data)                                             (*((volatile unsigned int*)HDMI_DRF_MODE_reg)=data)
#define  get_HDMI_DRF_MODE_reg                                                   (*((volatile unsigned int*)HDMI_DRF_MODE_reg))
#define  HDMI_DRF_MODE_yuv420_drf_mode_shift                                     (4)
#define  HDMI_DRF_MODE_hdcp_2p2_drf_mode_shift                                   (3)
#define  HDMI_DRF_MODE_hdcp_ksvfifo_drf_mode_shift                               (2)
#define  HDMI_DRF_MODE_hdcp_drf_mode_shift                                       (1)
#define  HDMI_DRF_MODE_audio_drf_mode_shift                                      (0)
#define  HDMI_DRF_MODE_yuv420_drf_mode_mask                                      (0x00000010)
#define  HDMI_DRF_MODE_hdcp_2p2_drf_mode_mask                                    (0x00000008)
#define  HDMI_DRF_MODE_hdcp_ksvfifo_drf_mode_mask                                (0x00000004)
#define  HDMI_DRF_MODE_hdcp_drf_mode_mask                                        (0x00000002)
#define  HDMI_DRF_MODE_audio_drf_mode_mask                                       (0x00000001)
#define  HDMI_DRF_MODE_yuv420_drf_mode(data)                                     (0x00000010&((data)<<4))
#define  HDMI_DRF_MODE_hdcp_2p2_drf_mode(data)                                   (0x00000008&((data)<<3))
#define  HDMI_DRF_MODE_hdcp_ksvfifo_drf_mode(data)                               (0x00000004&((data)<<2))
#define  HDMI_DRF_MODE_hdcp_drf_mode(data)                                       (0x00000002&((data)<<1))
#define  HDMI_DRF_MODE_audio_drf_mode(data)                                      (0x00000001&(data))
#define  HDMI_DRF_MODE_get_yuv420_drf_mode(data)                                 ((0x00000010&(data))>>4)
#define  HDMI_DRF_MODE_get_hdcp_2p2_drf_mode(data)                               ((0x00000008&(data))>>3)
#define  HDMI_DRF_MODE_get_hdcp_ksvfifo_drf_mode(data)                           ((0x00000004&(data))>>2)
#define  HDMI_DRF_MODE_get_hdcp_drf_mode(data)                                   ((0x00000002&(data))>>1)
#define  HDMI_DRF_MODE_get_audio_drf_mode(data)                                  (0x00000001&(data))

#define  HDMI_DRF_RESUME                                                         0x1800D190
#define  HDMI_DRF_RESUME_reg_addr                                                "0xB800D190"
#define  HDMI_DRF_RESUME_reg                                                     0xB800D190
#define  HDMI_DRF_RESUME_inst_addr                                               "0x0063"
#define  set_HDMI_DRF_RESUME_reg(data)                                           (*((volatile unsigned int*)HDMI_DRF_RESUME_reg)=data)
#define  get_HDMI_DRF_RESUME_reg                                                 (*((volatile unsigned int*)HDMI_DRF_RESUME_reg))
#define  HDMI_DRF_RESUME_yuv420_drf_resume_shift                                 (4)
#define  HDMI_DRF_RESUME_hdcp_2p2_drf_resume_shift                               (3)
#define  HDMI_DRF_RESUME_hdcp_ksvfifo_drf_resume_shift                           (2)
#define  HDMI_DRF_RESUME_hdcp_drf_resume_shift                                   (1)
#define  HDMI_DRF_RESUME_audio_drf_resume_shift                                  (0)
#define  HDMI_DRF_RESUME_yuv420_drf_resume_mask                                  (0x00000010)
#define  HDMI_DRF_RESUME_hdcp_2p2_drf_resume_mask                                (0x00000008)
#define  HDMI_DRF_RESUME_hdcp_ksvfifo_drf_resume_mask                            (0x00000004)
#define  HDMI_DRF_RESUME_hdcp_drf_resume_mask                                    (0x00000002)
#define  HDMI_DRF_RESUME_audio_drf_resume_mask                                   (0x00000001)
#define  HDMI_DRF_RESUME_yuv420_drf_resume(data)                                 (0x00000010&((data)<<4))
#define  HDMI_DRF_RESUME_hdcp_2p2_drf_resume(data)                               (0x00000008&((data)<<3))
#define  HDMI_DRF_RESUME_hdcp_ksvfifo_drf_resume(data)                           (0x00000004&((data)<<2))
#define  HDMI_DRF_RESUME_hdcp_drf_resume(data)                                   (0x00000002&((data)<<1))
#define  HDMI_DRF_RESUME_audio_drf_resume(data)                                  (0x00000001&(data))
#define  HDMI_DRF_RESUME_get_yuv420_drf_resume(data)                             ((0x00000010&(data))>>4)
#define  HDMI_DRF_RESUME_get_hdcp_2p2_drf_resume(data)                           ((0x00000008&(data))>>3)
#define  HDMI_DRF_RESUME_get_hdcp_ksvfifo_drf_resume(data)                       ((0x00000004&(data))>>2)
#define  HDMI_DRF_RESUME_get_hdcp_drf_resume(data)                               ((0x00000002&(data))>>1)
#define  HDMI_DRF_RESUME_get_audio_drf_resume(data)                              (0x00000001&(data))

#define  HDMI_DRF_DONE                                                           0x1800D194
#define  HDMI_DRF_DONE_reg_addr                                                  "0xB800D194"
#define  HDMI_DRF_DONE_reg                                                       0xB800D194
#define  HDMI_DRF_DONE_inst_addr                                                 "0x0064"
#define  set_HDMI_DRF_DONE_reg(data)                                             (*((volatile unsigned int*)HDMI_DRF_DONE_reg)=data)
#define  get_HDMI_DRF_DONE_reg                                                   (*((volatile unsigned int*)HDMI_DRF_DONE_reg))
#define  HDMI_DRF_DONE_yuv420_drf_done_shift                                     (4)
#define  HDMI_DRF_DONE_hdcp_2p2_drf_done_shift                                   (3)
#define  HDMI_DRF_DONE_hdcp_ksvfifo_drf_done_shift                               (2)
#define  HDMI_DRF_DONE_hdcp_drf_done_shift                                       (1)
#define  HDMI_DRF_DONE_audio_drf_done_shift                                      (0)
#define  HDMI_DRF_DONE_yuv420_drf_done_mask                                      (0x00000010)
#define  HDMI_DRF_DONE_hdcp_2p2_drf_done_mask                                    (0x00000008)
#define  HDMI_DRF_DONE_hdcp_ksvfifo_drf_done_mask                                (0x00000004)
#define  HDMI_DRF_DONE_hdcp_drf_done_mask                                        (0x00000002)
#define  HDMI_DRF_DONE_audio_drf_done_mask                                       (0x00000001)
#define  HDMI_DRF_DONE_yuv420_drf_done(data)                                     (0x00000010&((data)<<4))
#define  HDMI_DRF_DONE_hdcp_2p2_drf_done(data)                                   (0x00000008&((data)<<3))
#define  HDMI_DRF_DONE_hdcp_ksvfifo_drf_done(data)                               (0x00000004&((data)<<2))
#define  HDMI_DRF_DONE_hdcp_drf_done(data)                                       (0x00000002&((data)<<1))
#define  HDMI_DRF_DONE_audio_drf_done(data)                                      (0x00000001&(data))
#define  HDMI_DRF_DONE_get_yuv420_drf_done(data)                                 ((0x00000010&(data))>>4)
#define  HDMI_DRF_DONE_get_hdcp_2p2_drf_done(data)                               ((0x00000008&(data))>>3)
#define  HDMI_DRF_DONE_get_hdcp_ksvfifo_drf_done(data)                           ((0x00000004&(data))>>2)
#define  HDMI_DRF_DONE_get_hdcp_drf_done(data)                                   ((0x00000002&(data))>>1)
#define  HDMI_DRF_DONE_get_audio_drf_done(data)                                  (0x00000001&(data))

#define  HDMI_DRF_PAUSE                                                          0x1800D198
#define  HDMI_DRF_PAUSE_reg_addr                                                 "0xB800D198"
#define  HDMI_DRF_PAUSE_reg                                                      0xB800D198
#define  HDMI_DRF_PAUSE_inst_addr                                                "0x0065"
#define  set_HDMI_DRF_PAUSE_reg(data)                                            (*((volatile unsigned int*)HDMI_DRF_PAUSE_reg)=data)
#define  get_HDMI_DRF_PAUSE_reg                                                  (*((volatile unsigned int*)HDMI_DRF_PAUSE_reg))
#define  HDMI_DRF_PAUSE_yuv420_drf_pause_shift                                   (4)
#define  HDMI_DRF_PAUSE_hdcp_2p2_drf_pause_shift                                 (3)
#define  HDMI_DRF_PAUSE_hdcp_ksvfifo_drf_pause_shift                             (2)
#define  HDMI_DRF_PAUSE_hdcp_drf_pause_shift                                     (1)
#define  HDMI_DRF_PAUSE_audio_drf_pause_shift                                    (0)
#define  HDMI_DRF_PAUSE_yuv420_drf_pause_mask                                    (0x00000010)
#define  HDMI_DRF_PAUSE_hdcp_2p2_drf_pause_mask                                  (0x00000008)
#define  HDMI_DRF_PAUSE_hdcp_ksvfifo_drf_pause_mask                              (0x00000004)
#define  HDMI_DRF_PAUSE_hdcp_drf_pause_mask                                      (0x00000002)
#define  HDMI_DRF_PAUSE_audio_drf_pause_mask                                     (0x00000001)
#define  HDMI_DRF_PAUSE_yuv420_drf_pause(data)                                   (0x00000010&((data)<<4))
#define  HDMI_DRF_PAUSE_hdcp_2p2_drf_pause(data)                                 (0x00000008&((data)<<3))
#define  HDMI_DRF_PAUSE_hdcp_ksvfifo_drf_pause(data)                             (0x00000004&((data)<<2))
#define  HDMI_DRF_PAUSE_hdcp_drf_pause(data)                                     (0x00000002&((data)<<1))
#define  HDMI_DRF_PAUSE_audio_drf_pause(data)                                    (0x00000001&(data))
#define  HDMI_DRF_PAUSE_get_yuv420_drf_pause(data)                               ((0x00000010&(data))>>4)
#define  HDMI_DRF_PAUSE_get_hdcp_2p2_drf_pause(data)                             ((0x00000008&(data))>>3)
#define  HDMI_DRF_PAUSE_get_hdcp_ksvfifo_drf_pause(data)                         ((0x00000004&(data))>>2)
#define  HDMI_DRF_PAUSE_get_hdcp_drf_pause(data)                                 ((0x00000002&(data))>>1)
#define  HDMI_DRF_PAUSE_get_audio_drf_pause(data)                                (0x00000001&(data))

#define  HDMI_DRF_FAIL                                                           0x1800D19C
#define  HDMI_DRF_FAIL_reg_addr                                                  "0xB800D19C"
#define  HDMI_DRF_FAIL_reg                                                       0xB800D19C
#define  HDMI_DRF_FAIL_inst_addr                                                 "0x0066"
#define  set_HDMI_DRF_FAIL_reg(data)                                             (*((volatile unsigned int*)HDMI_DRF_FAIL_reg)=data)
#define  get_HDMI_DRF_FAIL_reg                                                   (*((volatile unsigned int*)HDMI_DRF_FAIL_reg))
#define  HDMI_DRF_FAIL_yuv420_drf_fail_shift                                     (4)
#define  HDMI_DRF_FAIL_hdcp_2p2_drf_fail_shift                                   (3)
#define  HDMI_DRF_FAIL_hdcp_ksvfifo_drf_fail_shift                               (2)
#define  HDMI_DRF_FAIL_hdcp_drf_fail_shift                                       (1)
#define  HDMI_DRF_FAIL_audio_drf_fail_shift                                      (0)
#define  HDMI_DRF_FAIL_yuv420_drf_fail_mask                                      (0x00000010)
#define  HDMI_DRF_FAIL_hdcp_2p2_drf_fail_mask                                    (0x00000008)
#define  HDMI_DRF_FAIL_hdcp_ksvfifo_drf_fail_mask                                (0x00000004)
#define  HDMI_DRF_FAIL_hdcp_drf_fail_mask                                        (0x00000002)
#define  HDMI_DRF_FAIL_audio_drf_fail_mask                                       (0x00000001)
#define  HDMI_DRF_FAIL_yuv420_drf_fail(data)                                     (0x00000010&((data)<<4))
#define  HDMI_DRF_FAIL_hdcp_2p2_drf_fail(data)                                   (0x00000008&((data)<<3))
#define  HDMI_DRF_FAIL_hdcp_ksvfifo_drf_fail(data)                               (0x00000004&((data)<<2))
#define  HDMI_DRF_FAIL_hdcp_drf_fail(data)                                       (0x00000002&((data)<<1))
#define  HDMI_DRF_FAIL_audio_drf_fail(data)                                      (0x00000001&(data))
#define  HDMI_DRF_FAIL_get_yuv420_drf_fail(data)                                 ((0x00000010&(data))>>4)
#define  HDMI_DRF_FAIL_get_hdcp_2p2_drf_fail(data)                               ((0x00000008&(data))>>3)
#define  HDMI_DRF_FAIL_get_hdcp_ksvfifo_drf_fail(data)                           ((0x00000004&(data))>>2)
#define  HDMI_DRF_FAIL_get_hdcp_drf_fail(data)                                   ((0x00000002&(data))>>1)
#define  HDMI_DRF_FAIL_get_audio_drf_fail(data)                                  (0x00000001&(data))

#define  HDMI_PHY_FIFO_CR                                                        0x1800D1A0
#define  HDMI_PHY_FIFO_CR_reg_addr                                               "0xB800D1A0"
#define  HDMI_PHY_FIFO_CR_reg                                                    0xB800D1A0
#define  HDMI_PHY_FIFO_CR_inst_addr                                              "0x0067"
#define  set_HDMI_PHY_FIFO_CR_reg(data)                                          (*((volatile unsigned int*)HDMI_PHY_FIFO_CR_reg)=data)
#define  get_HDMI_PHY_FIFO_CR_reg                                                (*((volatile unsigned int*)HDMI_PHY_FIFO_CR_reg))
#define  HDMI_PHY_FIFO_CR_port2_rclk_inv_shift                                   (30)
#define  HDMI_PHY_FIFO_CR_port2_gclk_inv_shift                                   (29)
#define  HDMI_PHY_FIFO_CR_port2_bclk_inv_shift                                   (28)
#define  HDMI_PHY_FIFO_CR_port1_rclk_inv_shift                                   (27)
#define  HDMI_PHY_FIFO_CR_port1_gclk_inv_shift                                   (26)
#define  HDMI_PHY_FIFO_CR_port1_bclk_inv_shift                                   (25)
#define  HDMI_PHY_FIFO_CR_port0_rclk_inv_shift                                   (24)
#define  HDMI_PHY_FIFO_CR_port0_gclk_inv_shift                                   (23)
#define  HDMI_PHY_FIFO_CR_port0_bclk_inv_shift                                   (22)
#define  HDMI_PHY_FIFO_CR_port_sel_shift                                         (20)
#define  HDMI_PHY_FIFO_CR_port2_r_flush_shift                                    (19)
#define  HDMI_PHY_FIFO_CR_port2_r_afifo_en_shift                                 (18)
#define  HDMI_PHY_FIFO_CR_port2_g_flush_shift                                    (17)
#define  HDMI_PHY_FIFO_CR_port2_g_afifo_en_shift                                 (16)
#define  HDMI_PHY_FIFO_CR_port2_b_flush_shift                                    (15)
#define  HDMI_PHY_FIFO_CR_port2_b_afifo_en_shift                                 (14)
//#define  HDMI_PHY_FIFO_CR_dummy_shift                                            (13)
#define  HDMI_PHY_FIFO_CR_port1_r_flush_shift                                    (12)
#define  HDMI_PHY_FIFO_CR_port1_r_afifo_en_shift                                 (11)
#define  HDMI_PHY_FIFO_CR_port1_g_flush_shift                                    (10)
#define  HDMI_PHY_FIFO_CR_port1_g_afifo_en_shift                                 (9)
#define  HDMI_PHY_FIFO_CR_port1_b_flush_shift                                    (8)
#define  HDMI_PHY_FIFO_CR_port1_b_afifo_en_shift                                 (7)
//#define  HDMI_PHY_FIFO_CR_dummy_shift                                            (6)
#define  HDMI_PHY_FIFO_CR_port0_r_flush_shift                                    (5)
#define  HDMI_PHY_FIFO_CR_port0_r_afifo_en_shift                                 (4)
#define  HDMI_PHY_FIFO_CR_port0_g_flush_shift                                    (3)
#define  HDMI_PHY_FIFO_CR_port0_g_afifo_en_shift                                 (2)
#define  HDMI_PHY_FIFO_CR_port0_b_flush_shift                                    (1)
#define  HDMI_PHY_FIFO_CR_port0_b_afifo_en_shift                                 (0)
#define  HDMI_PHY_FIFO_CR_port2_rclk_inv_mask                                    (0x40000000)
#define  HDMI_PHY_FIFO_CR_port2_gclk_inv_mask                                    (0x20000000)
#define  HDMI_PHY_FIFO_CR_port2_bclk_inv_mask                                    (0x10000000)
#define  HDMI_PHY_FIFO_CR_port1_rclk_inv_mask                                    (0x08000000)
#define  HDMI_PHY_FIFO_CR_port1_gclk_inv_mask                                    (0x04000000)
#define  HDMI_PHY_FIFO_CR_port1_bclk_inv_mask                                    (0x02000000)
#define  HDMI_PHY_FIFO_CR_port0_rclk_inv_mask                                    (0x01000000)
#define  HDMI_PHY_FIFO_CR_port0_gclk_inv_mask                                    (0x00800000)
#define  HDMI_PHY_FIFO_CR_port0_bclk_inv_mask                                    (0x00400000)
#define  HDMI_PHY_FIFO_CR_port_sel_mask                                          (0x00300000)
#define  HDMI_PHY_FIFO_CR_port2_r_flush_mask                                     (0x00080000)
#define  HDMI_PHY_FIFO_CR_port2_r_afifo_en_mask                                  (0x00040000)
#define  HDMI_PHY_FIFO_CR_port2_g_flush_mask                                     (0x00020000)
#define  HDMI_PHY_FIFO_CR_port2_g_afifo_en_mask                                  (0x00010000)
#define  HDMI_PHY_FIFO_CR_port2_b_flush_mask                                     (0x00008000)
#define  HDMI_PHY_FIFO_CR_port2_b_afifo_en_mask                                  (0x00004000)
//#define  HDMI_PHY_FIFO_CR_dummy_mask                                             (0x00002000)
#define  HDMI_PHY_FIFO_CR_port1_r_flush_mask                                     (0x00001000)
#define  HDMI_PHY_FIFO_CR_port1_r_afifo_en_mask                                  (0x00000800)
#define  HDMI_PHY_FIFO_CR_port1_g_flush_mask                                     (0x00000400)
#define  HDMI_PHY_FIFO_CR_port1_g_afifo_en_mask                                  (0x00000200)
#define  HDMI_PHY_FIFO_CR_port1_b_flush_mask                                     (0x00000100)
#define  HDMI_PHY_FIFO_CR_port1_b_afifo_en_mask                                  (0x00000080)
//#define  HDMI_PHY_FIFO_CR_dummy_mask                                             (0x00000040)
#define  HDMI_PHY_FIFO_CR_port0_r_flush_mask                                     (0x00000020)
#define  HDMI_PHY_FIFO_CR_port0_r_afifo_en_mask                                  (0x00000010)
#define  HDMI_PHY_FIFO_CR_port0_g_flush_mask                                     (0x00000008)
#define  HDMI_PHY_FIFO_CR_port0_g_afifo_en_mask                                  (0x00000004)
#define  HDMI_PHY_FIFO_CR_port0_b_flush_mask                                     (0x00000002)
#define  HDMI_PHY_FIFO_CR_port0_b_afifo_en_mask                                  (0x00000001)
#define  HDMI_PHY_FIFO_CR_port2_rclk_inv(data)                                   (0x40000000&((data)<<30))
#define  HDMI_PHY_FIFO_CR_port2_gclk_inv(data)                                   (0x20000000&((data)<<29))
#define  HDMI_PHY_FIFO_CR_port2_bclk_inv(data)                                   (0x10000000&((data)<<28))
#define  HDMI_PHY_FIFO_CR_port1_rclk_inv(data)                                   (0x08000000&((data)<<27))
#define  HDMI_PHY_FIFO_CR_port1_gclk_inv(data)                                   (0x04000000&((data)<<26))
#define  HDMI_PHY_FIFO_CR_port1_bclk_inv(data)                                   (0x02000000&((data)<<25))
#define  HDMI_PHY_FIFO_CR_port0_rclk_inv(data)                                   (0x01000000&((data)<<24))
#define  HDMI_PHY_FIFO_CR_port0_gclk_inv(data)                                   (0x00800000&((data)<<23))
#define  HDMI_PHY_FIFO_CR_port0_bclk_inv(data)                                   (0x00400000&((data)<<22))
#define  HDMI_PHY_FIFO_CR_port_sel(data)                                         (0x00300000&((data)<<20))
#define  HDMI_PHY_FIFO_CR_port2_r_flush(data)                                    (0x00080000&((data)<<19))
#define  HDMI_PHY_FIFO_CR_port2_r_afifo_en(data)                                 (0x00040000&((data)<<18))
#define  HDMI_PHY_FIFO_CR_port2_g_flush(data)                                    (0x00020000&((data)<<17))
#define  HDMI_PHY_FIFO_CR_port2_g_afifo_en(data)                                 (0x00010000&((data)<<16))
#define  HDMI_PHY_FIFO_CR_port2_b_flush(data)                                    (0x00008000&((data)<<15))
#define  HDMI_PHY_FIFO_CR_port2_b_afifo_en(data)                                 (0x00004000&((data)<<14))
//#define  HDMI_PHY_FIFO_CR_dummy(data)                                            (0x00002000&((data)<<13))
#define  HDMI_PHY_FIFO_CR_port1_r_flush(data)                                    (0x00001000&((data)<<12))
#define  HDMI_PHY_FIFO_CR_port1_r_afifo_en(data)                                 (0x00000800&((data)<<11))
#define  HDMI_PHY_FIFO_CR_port1_g_flush(data)                                    (0x00000400&((data)<<10))
#define  HDMI_PHY_FIFO_CR_port1_g_afifo_en(data)                                 (0x00000200&((data)<<9))
#define  HDMI_PHY_FIFO_CR_port1_b_flush(data)                                    (0x00000100&((data)<<8))
#define  HDMI_PHY_FIFO_CR_port1_b_afifo_en(data)                                 (0x00000080&((data)<<7))
//#define  HDMI_PHY_FIFO_CR_dummy(data)                                            (0x00000040&((data)<<6))
#define  HDMI_PHY_FIFO_CR_port0_r_flush(data)                                    (0x00000020&((data)<<5))
#define  HDMI_PHY_FIFO_CR_port0_r_afifo_en(data)                                 (0x00000010&((data)<<4))
#define  HDMI_PHY_FIFO_CR_port0_g_flush(data)                                    (0x00000008&((data)<<3))
#define  HDMI_PHY_FIFO_CR_port0_g_afifo_en(data)                                 (0x00000004&((data)<<2))
#define  HDMI_PHY_FIFO_CR_port0_b_flush(data)                                    (0x00000002&((data)<<1))
#define  HDMI_PHY_FIFO_CR_port0_b_afifo_en(data)                                 (0x00000001&(data))
#define  HDMI_PHY_FIFO_CR_get_port2_rclk_inv(data)                               ((0x40000000&(data))>>30)
#define  HDMI_PHY_FIFO_CR_get_port2_gclk_inv(data)                               ((0x20000000&(data))>>29)
#define  HDMI_PHY_FIFO_CR_get_port2_bclk_inv(data)                               ((0x10000000&(data))>>28)
#define  HDMI_PHY_FIFO_CR_get_port1_rclk_inv(data)                               ((0x08000000&(data))>>27)
#define  HDMI_PHY_FIFO_CR_get_port1_gclk_inv(data)                               ((0x04000000&(data))>>26)
#define  HDMI_PHY_FIFO_CR_get_port1_bclk_inv(data)                               ((0x02000000&(data))>>25)
#define  HDMI_PHY_FIFO_CR_get_port0_rclk_inv(data)                               ((0x01000000&(data))>>24)
#define  HDMI_PHY_FIFO_CR_get_port0_gclk_inv(data)                               ((0x00800000&(data))>>23)
#define  HDMI_PHY_FIFO_CR_get_port0_bclk_inv(data)                               ((0x00400000&(data))>>22)
#define  HDMI_PHY_FIFO_CR_get_port_sel(data)                                     ((0x00300000&(data))>>20)
#define  HDMI_PHY_FIFO_CR_get_port2_r_flush(data)                                ((0x00080000&(data))>>19)
#define  HDMI_PHY_FIFO_CR_get_port2_r_afifo_en(data)                             ((0x00040000&(data))>>18)
#define  HDMI_PHY_FIFO_CR_get_port2_g_flush(data)                                ((0x00020000&(data))>>17)
#define  HDMI_PHY_FIFO_CR_get_port2_g_afifo_en(data)                             ((0x00010000&(data))>>16)
#define  HDMI_PHY_FIFO_CR_get_port2_b_flush(data)                                ((0x00008000&(data))>>15)
#define  HDMI_PHY_FIFO_CR_get_port2_b_afifo_en(data)                             ((0x00004000&(data))>>14)
//#define  HDMI_PHY_FIFO_CR_get_dummy(data)                                        ((0x00002000&(data))>>13)
#define  HDMI_PHY_FIFO_CR_get_port1_r_flush(data)                                ((0x00001000&(data))>>12)
#define  HDMI_PHY_FIFO_CR_get_port1_r_afifo_en(data)                             ((0x00000800&(data))>>11)
#define  HDMI_PHY_FIFO_CR_get_port1_g_flush(data)                                ((0x00000400&(data))>>10)
#define  HDMI_PHY_FIFO_CR_get_port1_g_afifo_en(data)                             ((0x00000200&(data))>>9)
#define  HDMI_PHY_FIFO_CR_get_port1_b_flush(data)                                ((0x00000100&(data))>>8)
#define  HDMI_PHY_FIFO_CR_get_port1_b_afifo_en(data)                             ((0x00000080&(data))>>7)
//#define  HDMI_PHY_FIFO_CR_get_dummy(data)                                        ((0x00000040&(data))>>6)
#define  HDMI_PHY_FIFO_CR_get_port0_r_flush(data)                                ((0x00000020&(data))>>5)
#define  HDMI_PHY_FIFO_CR_get_port0_r_afifo_en(data)                             ((0x00000010&(data))>>4)
#define  HDMI_PHY_FIFO_CR_get_port0_g_flush(data)                                ((0x00000008&(data))>>3)
#define  HDMI_PHY_FIFO_CR_get_port0_g_afifo_en(data)                             ((0x00000004&(data))>>2)
#define  HDMI_PHY_FIFO_CR_get_port0_b_flush(data)                                ((0x00000002&(data))>>1)
#define  HDMI_PHY_FIFO_CR_get_port0_b_afifo_en(data)                             (0x00000001&(data))

#define  HDMI_PHY_FIFO_SR0                                                       0x1800D1A4
#define  HDMI_PHY_FIFO_SR0_reg_addr                                              "0xB800D1A4"
#define  HDMI_PHY_FIFO_SR0_reg                                                   0xB800D1A4
#define  HDMI_PHY_FIFO_SR0_inst_addr                                             "0x0068"
#define  set_HDMI_PHY_FIFO_SR0_reg(data)                                         (*((volatile unsigned int*)HDMI_PHY_FIFO_SR0_reg)=data)
#define  get_HDMI_PHY_FIFO_SR0_reg                                               (*((volatile unsigned int*)HDMI_PHY_FIFO_SR0_reg))
#define  HDMI_PHY_FIFO_SR0_port1_r_wrclk_det_timeout_flag_shift                  (29)
#define  HDMI_PHY_FIFO_SR0_port1_r_rwclk_det_timeout_flag_shift                  (28)
#define  HDMI_PHY_FIFO_SR0_port1_r_wovflow_flag_shift                            (27)
#define  HDMI_PHY_FIFO_SR0_port1_r_rudflow_flag_shift                            (26)
#define  HDMI_PHY_FIFO_SR0_port1_r_rflush_flag_shift                             (25)
#define  HDMI_PHY_FIFO_SR0_port1_g_wrclk_det_timeout_flag_shift                  (24)
#define  HDMI_PHY_FIFO_SR0_port1_g_rwclk_det_timeout_flag_shift                  (23)
#define  HDMI_PHY_FIFO_SR0_port1_g_wovflow_flag_shift                            (22)
#define  HDMI_PHY_FIFO_SR0_port1_g_rudflow_flag_shift                            (21)
#define  HDMI_PHY_FIFO_SR0_port1_g_rflush_flag_shift                             (20)
#define  HDMI_PHY_FIFO_SR0_port1_b_wrclk_det_timeout_flag_shift                  (19)
#define  HDMI_PHY_FIFO_SR0_port1_b_rwclk_det_timeout_flag_shift                  (18)
#define  HDMI_PHY_FIFO_SR0_port1_b_wovflow_flag_shift                            (17)
#define  HDMI_PHY_FIFO_SR0_port1_b_rudflow_flag_shift                            (16)
#define  HDMI_PHY_FIFO_SR0_port1_b_rflush_flag_shift                             (15)
#define  HDMI_PHY_FIFO_SR0_port0_r_wrclk_det_timeout_flag_shift                  (14)
#define  HDMI_PHY_FIFO_SR0_port0_r_rwclk_det_timeout_flag_shift                  (13)
#define  HDMI_PHY_FIFO_SR0_port0_r_wovflow_flag_shift                            (12)
#define  HDMI_PHY_FIFO_SR0_port0_r_rudflow_flag_shift                            (11)
#define  HDMI_PHY_FIFO_SR0_port0_r_rflush_flag_shift                             (10)
#define  HDMI_PHY_FIFO_SR0_port0_g_wrclk_det_timeout_flag_shift                  (9)
#define  HDMI_PHY_FIFO_SR0_port0_g_rwclk_det_timeout_flag_shift                  (8)
#define  HDMI_PHY_FIFO_SR0_port0_g_wovflow_flag_shift                            (7)
#define  HDMI_PHY_FIFO_SR0_port0_g_rudflow_flag_shift                            (6)
#define  HDMI_PHY_FIFO_SR0_port0_g_rflush_flag_shift                             (5)
#define  HDMI_PHY_FIFO_SR0_port0_b_wrclk_det_timeout_flag_shift                  (4)
#define  HDMI_PHY_FIFO_SR0_port0_b_rwclk_det_timeout_flag_shift                  (3)
#define  HDMI_PHY_FIFO_SR0_port0_b_wovflow_flag_shift                            (2)
#define  HDMI_PHY_FIFO_SR0_port0_b_rudflow_flag_shift                            (1)
#define  HDMI_PHY_FIFO_SR0_port0_b_rflush_flag_shift                             (0)
#define  HDMI_PHY_FIFO_SR0_port1_r_wrclk_det_timeout_flag_mask                   (0x20000000)
#define  HDMI_PHY_FIFO_SR0_port1_r_rwclk_det_timeout_flag_mask                   (0x10000000)
#define  HDMI_PHY_FIFO_SR0_port1_r_wovflow_flag_mask                             (0x08000000)
#define  HDMI_PHY_FIFO_SR0_port1_r_rudflow_flag_mask                             (0x04000000)
#define  HDMI_PHY_FIFO_SR0_port1_r_rflush_flag_mask                              (0x02000000)
#define  HDMI_PHY_FIFO_SR0_port1_g_wrclk_det_timeout_flag_mask                   (0x01000000)
#define  HDMI_PHY_FIFO_SR0_port1_g_rwclk_det_timeout_flag_mask                   (0x00800000)
#define  HDMI_PHY_FIFO_SR0_port1_g_wovflow_flag_mask                             (0x00400000)
#define  HDMI_PHY_FIFO_SR0_port1_g_rudflow_flag_mask                             (0x00200000)
#define  HDMI_PHY_FIFO_SR0_port1_g_rflush_flag_mask                              (0x00100000)
#define  HDMI_PHY_FIFO_SR0_port1_b_wrclk_det_timeout_flag_mask                   (0x00080000)
#define  HDMI_PHY_FIFO_SR0_port1_b_rwclk_det_timeout_flag_mask                   (0x00040000)
#define  HDMI_PHY_FIFO_SR0_port1_b_wovflow_flag_mask                             (0x00020000)
#define  HDMI_PHY_FIFO_SR0_port1_b_rudflow_flag_mask                             (0x00010000)
#define  HDMI_PHY_FIFO_SR0_port1_b_rflush_flag_mask                              (0x00008000)
#define  HDMI_PHY_FIFO_SR0_port0_r_wrclk_det_timeout_flag_mask                   (0x00004000)
#define  HDMI_PHY_FIFO_SR0_port0_r_rwclk_det_timeout_flag_mask                   (0x00002000)
#define  HDMI_PHY_FIFO_SR0_port0_r_wovflow_flag_mask                             (0x00001000)
#define  HDMI_PHY_FIFO_SR0_port0_r_rudflow_flag_mask                             (0x00000800)
#define  HDMI_PHY_FIFO_SR0_port0_r_rflush_flag_mask                              (0x00000400)
#define  HDMI_PHY_FIFO_SR0_port0_g_wrclk_det_timeout_flag_mask                   (0x00000200)
#define  HDMI_PHY_FIFO_SR0_port0_g_rwclk_det_timeout_flag_mask                   (0x00000100)
#define  HDMI_PHY_FIFO_SR0_port0_g_wovflow_flag_mask                             (0x00000080)
#define  HDMI_PHY_FIFO_SR0_port0_g_rudflow_flag_mask                             (0x00000040)
#define  HDMI_PHY_FIFO_SR0_port0_g_rflush_flag_mask                              (0x00000020)
#define  HDMI_PHY_FIFO_SR0_port0_b_wrclk_det_timeout_flag_mask                   (0x00000010)
#define  HDMI_PHY_FIFO_SR0_port0_b_rwclk_det_timeout_flag_mask                   (0x00000008)
#define  HDMI_PHY_FIFO_SR0_port0_b_wovflow_flag_mask                             (0x00000004)
#define  HDMI_PHY_FIFO_SR0_port0_b_rudflow_flag_mask                             (0x00000002)
#define  HDMI_PHY_FIFO_SR0_port0_b_rflush_flag_mask                              (0x00000001)
#define  HDMI_PHY_FIFO_SR0_port1_r_wrclk_det_timeout_flag(data)                  (0x20000000&((data)<<29))
#define  HDMI_PHY_FIFO_SR0_port1_r_rwclk_det_timeout_flag(data)                  (0x10000000&((data)<<28))
#define  HDMI_PHY_FIFO_SR0_port1_r_wovflow_flag(data)                            (0x08000000&((data)<<27))
#define  HDMI_PHY_FIFO_SR0_port1_r_rudflow_flag(data)                            (0x04000000&((data)<<26))
#define  HDMI_PHY_FIFO_SR0_port1_r_rflush_flag(data)                             (0x02000000&((data)<<25))
#define  HDMI_PHY_FIFO_SR0_port1_g_wrclk_det_timeout_flag(data)                  (0x01000000&((data)<<24))
#define  HDMI_PHY_FIFO_SR0_port1_g_rwclk_det_timeout_flag(data)                  (0x00800000&((data)<<23))
#define  HDMI_PHY_FIFO_SR0_port1_g_wovflow_flag(data)                            (0x00400000&((data)<<22))
#define  HDMI_PHY_FIFO_SR0_port1_g_rudflow_flag(data)                            (0x00200000&((data)<<21))
#define  HDMI_PHY_FIFO_SR0_port1_g_rflush_flag(data)                             (0x00100000&((data)<<20))
#define  HDMI_PHY_FIFO_SR0_port1_b_wrclk_det_timeout_flag(data)                  (0x00080000&((data)<<19))
#define  HDMI_PHY_FIFO_SR0_port1_b_rwclk_det_timeout_flag(data)                  (0x00040000&((data)<<18))
#define  HDMI_PHY_FIFO_SR0_port1_b_wovflow_flag(data)                            (0x00020000&((data)<<17))
#define  HDMI_PHY_FIFO_SR0_port1_b_rudflow_flag(data)                            (0x00010000&((data)<<16))
#define  HDMI_PHY_FIFO_SR0_port1_b_rflush_flag(data)                             (0x00008000&((data)<<15))
#define  HDMI_PHY_FIFO_SR0_port0_r_wrclk_det_timeout_flag(data)                  (0x00004000&((data)<<14))
#define  HDMI_PHY_FIFO_SR0_port0_r_rwclk_det_timeout_flag(data)                  (0x00002000&((data)<<13))
#define  HDMI_PHY_FIFO_SR0_port0_r_wovflow_flag(data)                            (0x00001000&((data)<<12))
#define  HDMI_PHY_FIFO_SR0_port0_r_rudflow_flag(data)                            (0x00000800&((data)<<11))
#define  HDMI_PHY_FIFO_SR0_port0_r_rflush_flag(data)                             (0x00000400&((data)<<10))
#define  HDMI_PHY_FIFO_SR0_port0_g_wrclk_det_timeout_flag(data)                  (0x00000200&((data)<<9))
#define  HDMI_PHY_FIFO_SR0_port0_g_rwclk_det_timeout_flag(data)                  (0x00000100&((data)<<8))
#define  HDMI_PHY_FIFO_SR0_port0_g_wovflow_flag(data)                            (0x00000080&((data)<<7))
#define  HDMI_PHY_FIFO_SR0_port0_g_rudflow_flag(data)                            (0x00000040&((data)<<6))
#define  HDMI_PHY_FIFO_SR0_port0_g_rflush_flag(data)                             (0x00000020&((data)<<5))
#define  HDMI_PHY_FIFO_SR0_port0_b_wrclk_det_timeout_flag(data)                  (0x00000010&((data)<<4))
#define  HDMI_PHY_FIFO_SR0_port0_b_rwclk_det_timeout_flag(data)                  (0x00000008&((data)<<3))
#define  HDMI_PHY_FIFO_SR0_port0_b_wovflow_flag(data)                            (0x00000004&((data)<<2))
#define  HDMI_PHY_FIFO_SR0_port0_b_rudflow_flag(data)                            (0x00000002&((data)<<1))
#define  HDMI_PHY_FIFO_SR0_port0_b_rflush_flag(data)                             (0x00000001&(data))
#define  HDMI_PHY_FIFO_SR0_get_port1_r_wrclk_det_timeout_flag(data)              ((0x20000000&(data))>>29)
#define  HDMI_PHY_FIFO_SR0_get_port1_r_rwclk_det_timeout_flag(data)              ((0x10000000&(data))>>28)
#define  HDMI_PHY_FIFO_SR0_get_port1_r_wovflow_flag(data)                        ((0x08000000&(data))>>27)
#define  HDMI_PHY_FIFO_SR0_get_port1_r_rudflow_flag(data)                        ((0x04000000&(data))>>26)
#define  HDMI_PHY_FIFO_SR0_get_port1_r_rflush_flag(data)                         ((0x02000000&(data))>>25)
#define  HDMI_PHY_FIFO_SR0_get_port1_g_wrclk_det_timeout_flag(data)              ((0x01000000&(data))>>24)
#define  HDMI_PHY_FIFO_SR0_get_port1_g_rwclk_det_timeout_flag(data)              ((0x00800000&(data))>>23)
#define  HDMI_PHY_FIFO_SR0_get_port1_g_wovflow_flag(data)                        ((0x00400000&(data))>>22)
#define  HDMI_PHY_FIFO_SR0_get_port1_g_rudflow_flag(data)                        ((0x00200000&(data))>>21)
#define  HDMI_PHY_FIFO_SR0_get_port1_g_rflush_flag(data)                         ((0x00100000&(data))>>20)
#define  HDMI_PHY_FIFO_SR0_get_port1_b_wrclk_det_timeout_flag(data)              ((0x00080000&(data))>>19)
#define  HDMI_PHY_FIFO_SR0_get_port1_b_rwclk_det_timeout_flag(data)              ((0x00040000&(data))>>18)
#define  HDMI_PHY_FIFO_SR0_get_port1_b_wovflow_flag(data)                        ((0x00020000&(data))>>17)
#define  HDMI_PHY_FIFO_SR0_get_port1_b_rudflow_flag(data)                        ((0x00010000&(data))>>16)
#define  HDMI_PHY_FIFO_SR0_get_port1_b_rflush_flag(data)                         ((0x00008000&(data))>>15)
#define  HDMI_PHY_FIFO_SR0_get_port0_r_wrclk_det_timeout_flag(data)              ((0x00004000&(data))>>14)
#define  HDMI_PHY_FIFO_SR0_get_port0_r_rwclk_det_timeout_flag(data)              ((0x00002000&(data))>>13)
#define  HDMI_PHY_FIFO_SR0_get_port0_r_wovflow_flag(data)                        ((0x00001000&(data))>>12)
#define  HDMI_PHY_FIFO_SR0_get_port0_r_rudflow_flag(data)                        ((0x00000800&(data))>>11)
#define  HDMI_PHY_FIFO_SR0_get_port0_r_rflush_flag(data)                         ((0x00000400&(data))>>10)
#define  HDMI_PHY_FIFO_SR0_get_port0_g_wrclk_det_timeout_flag(data)              ((0x00000200&(data))>>9)
#define  HDMI_PHY_FIFO_SR0_get_port0_g_rwclk_det_timeout_flag(data)              ((0x00000100&(data))>>8)
#define  HDMI_PHY_FIFO_SR0_get_port0_g_wovflow_flag(data)                        ((0x00000080&(data))>>7)
#define  HDMI_PHY_FIFO_SR0_get_port0_g_rudflow_flag(data)                        ((0x00000040&(data))>>6)
#define  HDMI_PHY_FIFO_SR0_get_port0_g_rflush_flag(data)                         ((0x00000020&(data))>>5)
#define  HDMI_PHY_FIFO_SR0_get_port0_b_wrclk_det_timeout_flag(data)              ((0x00000010&(data))>>4)
#define  HDMI_PHY_FIFO_SR0_get_port0_b_rwclk_det_timeout_flag(data)              ((0x00000008&(data))>>3)
#define  HDMI_PHY_FIFO_SR0_get_port0_b_wovflow_flag(data)                        ((0x00000004&(data))>>2)
#define  HDMI_PHY_FIFO_SR0_get_port0_b_rudflow_flag(data)                        ((0x00000002&(data))>>1)
#define  HDMI_PHY_FIFO_SR0_get_port0_b_rflush_flag(data)                         (0x00000001&(data))

#define  HDMI_PHY_FIFO_SR1                                                       0x1800D1A8
#define  HDMI_PHY_FIFO_SR1_reg_addr                                              "0xB800D1A8"
#define  HDMI_PHY_FIFO_SR1_reg                                                   0xB800D1A8
#define  HDMI_PHY_FIFO_SR1_inst_addr                                             "0x0069"
#define  set_HDMI_PHY_FIFO_SR1_reg(data)                                         (*((volatile unsigned int*)HDMI_PHY_FIFO_SR1_reg)=data)
#define  get_HDMI_PHY_FIFO_SR1_reg                                               (*((volatile unsigned int*)HDMI_PHY_FIFO_SR1_reg))
#define  HDMI_PHY_FIFO_SR1_port2_r_wrclk_det_timeout_flag_shift                  (14)
#define  HDMI_PHY_FIFO_SR1_port2_r_rwclk_det_timeout_flag_shift                  (13)
#define  HDMI_PHY_FIFO_SR1_port2_r_wovflow_flag_shift                            (12)
#define  HDMI_PHY_FIFO_SR1_port2_r_rudflow_flag_shift                            (11)
#define  HDMI_PHY_FIFO_SR1_port2_r_rflush_flag_shift                             (10)
#define  HDMI_PHY_FIFO_SR1_port2_g_wrclk_det_timeout_flag_shift                  (9)
#define  HDMI_PHY_FIFO_SR1_port2_g_rwclk_det_timeout_flag_shift                  (8)
#define  HDMI_PHY_FIFO_SR1_port2_g_wovflow_flag_shift                            (7)
#define  HDMI_PHY_FIFO_SR1_port2_g_rudflow_flag_shift                            (6)
#define  HDMI_PHY_FIFO_SR1_port2_g_rflush_flag_shift                             (5)
#define  HDMI_PHY_FIFO_SR1_port2_b_wrclk_det_timeout_flag_shift                  (4)
#define  HDMI_PHY_FIFO_SR1_port2_b_rwclk_det_timeout_flag_shift                  (3)
#define  HDMI_PHY_FIFO_SR1_port2_b_wovflow_flag_shift                            (2)
#define  HDMI_PHY_FIFO_SR1_port2_b_rudflow_flag_shift                            (1)
#define  HDMI_PHY_FIFO_SR1_port2_b_rflush_flag_shift                             (0)
#define  HDMI_PHY_FIFO_SR1_port2_r_wrclk_det_timeout_flag_mask                   (0x00004000)
#define  HDMI_PHY_FIFO_SR1_port2_r_rwclk_det_timeout_flag_mask                   (0x00002000)
#define  HDMI_PHY_FIFO_SR1_port2_r_wovflow_flag_mask                             (0x00001000)
#define  HDMI_PHY_FIFO_SR1_port2_r_rudflow_flag_mask                             (0x00000800)
#define  HDMI_PHY_FIFO_SR1_port2_r_rflush_flag_mask                              (0x00000400)
#define  HDMI_PHY_FIFO_SR1_port2_g_wrclk_det_timeout_flag_mask                   (0x00000200)
#define  HDMI_PHY_FIFO_SR1_port2_g_rwclk_det_timeout_flag_mask                   (0x00000100)
#define  HDMI_PHY_FIFO_SR1_port2_g_wovflow_flag_mask                             (0x00000080)
#define  HDMI_PHY_FIFO_SR1_port2_g_rudflow_flag_mask                             (0x00000040)
#define  HDMI_PHY_FIFO_SR1_port2_g_rflush_flag_mask                              (0x00000020)
#define  HDMI_PHY_FIFO_SR1_port2_b_wrclk_det_timeout_flag_mask                   (0x00000010)
#define  HDMI_PHY_FIFO_SR1_port2_b_rwclk_det_timeout_flag_mask                   (0x00000008)
#define  HDMI_PHY_FIFO_SR1_port2_b_wovflow_flag_mask                             (0x00000004)
#define  HDMI_PHY_FIFO_SR1_port2_b_rudflow_flag_mask                             (0x00000002)
#define  HDMI_PHY_FIFO_SR1_port2_b_rflush_flag_mask                              (0x00000001)
#define  HDMI_PHY_FIFO_SR1_port2_r_wrclk_det_timeout_flag(data)                  (0x00004000&((data)<<14))
#define  HDMI_PHY_FIFO_SR1_port2_r_rwclk_det_timeout_flag(data)                  (0x00002000&((data)<<13))
#define  HDMI_PHY_FIFO_SR1_port2_r_wovflow_flag(data)                            (0x00001000&((data)<<12))
#define  HDMI_PHY_FIFO_SR1_port2_r_rudflow_flag(data)                            (0x00000800&((data)<<11))
#define  HDMI_PHY_FIFO_SR1_port2_r_rflush_flag(data)                             (0x00000400&((data)<<10))
#define  HDMI_PHY_FIFO_SR1_port2_g_wrclk_det_timeout_flag(data)                  (0x00000200&((data)<<9))
#define  HDMI_PHY_FIFO_SR1_port2_g_rwclk_det_timeout_flag(data)                  (0x00000100&((data)<<8))
#define  HDMI_PHY_FIFO_SR1_port2_g_wovflow_flag(data)                            (0x00000080&((data)<<7))
#define  HDMI_PHY_FIFO_SR1_port2_g_rudflow_flag(data)                            (0x00000040&((data)<<6))
#define  HDMI_PHY_FIFO_SR1_port2_g_rflush_flag(data)                             (0x00000020&((data)<<5))
#define  HDMI_PHY_FIFO_SR1_port2_b_wrclk_det_timeout_flag(data)                  (0x00000010&((data)<<4))
#define  HDMI_PHY_FIFO_SR1_port2_b_rwclk_det_timeout_flag(data)                  (0x00000008&((data)<<3))
#define  HDMI_PHY_FIFO_SR1_port2_b_wovflow_flag(data)                            (0x00000004&((data)<<2))
#define  HDMI_PHY_FIFO_SR1_port2_b_rudflow_flag(data)                            (0x00000002&((data)<<1))
#define  HDMI_PHY_FIFO_SR1_port2_b_rflush_flag(data)                             (0x00000001&(data))
#define  HDMI_PHY_FIFO_SR1_get_port2_r_wrclk_det_timeout_flag(data)              ((0x00004000&(data))>>14)
#define  HDMI_PHY_FIFO_SR1_get_port2_r_rwclk_det_timeout_flag(data)              ((0x00002000&(data))>>13)
#define  HDMI_PHY_FIFO_SR1_get_port2_r_wovflow_flag(data)                        ((0x00001000&(data))>>12)
#define  HDMI_PHY_FIFO_SR1_get_port2_r_rudflow_flag(data)                        ((0x00000800&(data))>>11)
#define  HDMI_PHY_FIFO_SR1_get_port2_r_rflush_flag(data)                         ((0x00000400&(data))>>10)
#define  HDMI_PHY_FIFO_SR1_get_port2_g_wrclk_det_timeout_flag(data)              ((0x00000200&(data))>>9)
#define  HDMI_PHY_FIFO_SR1_get_port2_g_rwclk_det_timeout_flag(data)              ((0x00000100&(data))>>8)
#define  HDMI_PHY_FIFO_SR1_get_port2_g_wovflow_flag(data)                        ((0x00000080&(data))>>7)
#define  HDMI_PHY_FIFO_SR1_get_port2_g_rudflow_flag(data)                        ((0x00000040&(data))>>6)
#define  HDMI_PHY_FIFO_SR1_get_port2_g_rflush_flag(data)                         ((0x00000020&(data))>>5)
#define  HDMI_PHY_FIFO_SR1_get_port2_b_wrclk_det_timeout_flag(data)              ((0x00000010&(data))>>4)
#define  HDMI_PHY_FIFO_SR1_get_port2_b_rwclk_det_timeout_flag(data)              ((0x00000008&(data))>>3)
#define  HDMI_PHY_FIFO_SR1_get_port2_b_wovflow_flag(data)                        ((0x00000004&(data))>>2)
#define  HDMI_PHY_FIFO_SR1_get_port2_b_rudflow_flag(data)                        ((0x00000002&(data))>>1)
#define  HDMI_PHY_FIFO_SR1_get_port2_b_rflush_flag(data)                         (0x00000001&(data))

#define  HDMI_HDMI_CTS_FIFO_CTL                                                  0x1800D1AC
#define  HDMI_HDMI_CTS_FIFO_CTL_reg_addr                                         "0xB800D1AC"
#define  HDMI_HDMI_CTS_FIFO_CTL_reg                                              0xB800D1AC
#define  HDMI_HDMI_CTS_FIFO_CTL_inst_addr                                        "0x006A"
#define  set_HDMI_HDMI_CTS_FIFO_CTL_reg(data)                                    (*((volatile unsigned int*)HDMI_HDMI_CTS_FIFO_CTL_reg)=data)
#define  get_HDMI_HDMI_CTS_FIFO_CTL_reg                                          (*((volatile unsigned int*)HDMI_HDMI_CTS_FIFO_CTL_reg))
#define  HDMI_HDMI_CTS_FIFO_CTL_force_ctsfifo_rstn_phy_dbgout_r_shift            (17)
#define  HDMI_HDMI_CTS_FIFO_CTL_en_ctsfifo_bypass_phy_dbgout_r_shift             (16)
#define  HDMI_HDMI_CTS_FIFO_CTL_force_ctsfifo_rstn_phy_dbgout_g_shift            (15)
#define  HDMI_HDMI_CTS_FIFO_CTL_en_ctsfifo_bypass_phy_dbgout_g_shift             (14)
#define  HDMI_HDMI_CTS_FIFO_CTL_force_ctsfifo_rstn_phy_dbgout_b_shift            (13)
#define  HDMI_HDMI_CTS_FIFO_CTL_en_ctsfifo_bypass_phy_dbgout_b_shift             (12)
#define  HDMI_HDMI_CTS_FIFO_CTL_dummy_shift                                      (11)
#define  HDMI_HDMI_CTS_FIFO_CTL_debug_select_shift                               (10)
#define  HDMI_HDMI_CTS_FIFO_CTL_hdmi_2x_out_sel_shift                            (8)
#define  HDMI_HDMI_CTS_FIFO_CTL_hdmi_test_sel_shift                              (4)
#define  HDMI_HDMI_CTS_FIFO_CTL_hdmi_out_sel_shift                               (3)
#define  HDMI_HDMI_CTS_FIFO_CTL_force_ctsfifo_rstn_hdmi_shift                    (2)
#define  HDMI_HDMI_CTS_FIFO_CTL_en_ctsfifo_vsrst_hdmi_shift                      (1)
#define  HDMI_HDMI_CTS_FIFO_CTL_en_ctsfifo_bypass_hdmi_shift                     (0)
#define  HDMI_HDMI_CTS_FIFO_CTL_force_ctsfifo_rstn_phy_dbgout_r_mask             (0x00020000)
#define  HDMI_HDMI_CTS_FIFO_CTL_en_ctsfifo_bypass_phy_dbgout_r_mask              (0x00010000)
#define  HDMI_HDMI_CTS_FIFO_CTL_force_ctsfifo_rstn_phy_dbgout_g_mask             (0x00008000)
#define  HDMI_HDMI_CTS_FIFO_CTL_en_ctsfifo_bypass_phy_dbgout_g_mask              (0x00004000)
#define  HDMI_HDMI_CTS_FIFO_CTL_force_ctsfifo_rstn_phy_dbgout_b_mask             (0x00002000)
#define  HDMI_HDMI_CTS_FIFO_CTL_en_ctsfifo_bypass_phy_dbgout_b_mask              (0x00001000)
#define  HDMI_HDMI_CTS_FIFO_CTL_dummy_mask                                       (0x00000800)
#define  HDMI_HDMI_CTS_FIFO_CTL_debug_select_mask                                (0x00000400)
#define  HDMI_HDMI_CTS_FIFO_CTL_hdmi_2x_out_sel_mask                             (0x00000300)
#define  HDMI_HDMI_CTS_FIFO_CTL_hdmi_test_sel_mask                               (0x000000F0)
#define  HDMI_HDMI_CTS_FIFO_CTL_hdmi_out_sel_mask                                (0x00000008)
#define  HDMI_HDMI_CTS_FIFO_CTL_force_ctsfifo_rstn_hdmi_mask                     (0x00000004)
#define  HDMI_HDMI_CTS_FIFO_CTL_en_ctsfifo_vsrst_hdmi_mask                       (0x00000002)
#define  HDMI_HDMI_CTS_FIFO_CTL_en_ctsfifo_bypass_hdmi_mask                      (0x00000001)
#define  HDMI_HDMI_CTS_FIFO_CTL_force_ctsfifo_rstn_phy_dbgout_r(data)            (0x00020000&((data)<<17))
#define  HDMI_HDMI_CTS_FIFO_CTL_en_ctsfifo_bypass_phy_dbgout_r(data)             (0x00010000&((data)<<16))
#define  HDMI_HDMI_CTS_FIFO_CTL_force_ctsfifo_rstn_phy_dbgout_g(data)            (0x00008000&((data)<<15))
#define  HDMI_HDMI_CTS_FIFO_CTL_en_ctsfifo_bypass_phy_dbgout_g(data)             (0x00004000&((data)<<14))
#define  HDMI_HDMI_CTS_FIFO_CTL_force_ctsfifo_rstn_phy_dbgout_b(data)            (0x00002000&((data)<<13))
#define  HDMI_HDMI_CTS_FIFO_CTL_en_ctsfifo_bypass_phy_dbgout_b(data)             (0x00001000&((data)<<12))
#define  HDMI_HDMI_CTS_FIFO_CTL_dummy(data)                                      (0x00000800&((data)<<11))
#define  HDMI_HDMI_CTS_FIFO_CTL_debug_select(data)                               (0x00000400&((data)<<10))
#define  HDMI_HDMI_CTS_FIFO_CTL_hdmi_2x_out_sel(data)                            (0x00000300&((data)<<8))
#define  HDMI_HDMI_CTS_FIFO_CTL_hdmi_test_sel(data)                              (0x000000F0&((data)<<4))
#define  HDMI_HDMI_CTS_FIFO_CTL_hdmi_out_sel(data)                               (0x00000008&((data)<<3))
#define  HDMI_HDMI_CTS_FIFO_CTL_force_ctsfifo_rstn_hdmi(data)                    (0x00000004&((data)<<2))
#define  HDMI_HDMI_CTS_FIFO_CTL_en_ctsfifo_vsrst_hdmi(data)                      (0x00000002&((data)<<1))
#define  HDMI_HDMI_CTS_FIFO_CTL_en_ctsfifo_bypass_hdmi(data)                     (0x00000001&(data))
#define  HDMI_HDMI_CTS_FIFO_CTL_get_force_ctsfifo_rstn_phy_dbgout_r(data)        ((0x00020000&(data))>>17)
#define  HDMI_HDMI_CTS_FIFO_CTL_get_en_ctsfifo_bypass_phy_dbgout_r(data)         ((0x00010000&(data))>>16)
#define  HDMI_HDMI_CTS_FIFO_CTL_get_force_ctsfifo_rstn_phy_dbgout_g(data)        ((0x00008000&(data))>>15)
#define  HDMI_HDMI_CTS_FIFO_CTL_get_en_ctsfifo_bypass_phy_dbgout_g(data)         ((0x00004000&(data))>>14)
#define  HDMI_HDMI_CTS_FIFO_CTL_get_force_ctsfifo_rstn_phy_dbgout_b(data)        ((0x00002000&(data))>>13)
#define  HDMI_HDMI_CTS_FIFO_CTL_get_en_ctsfifo_bypass_phy_dbgout_b(data)         ((0x00001000&(data))>>12)
#define  HDMI_HDMI_CTS_FIFO_CTL_get_dummy(data)                                  ((0x00000800&(data))>>11)
#define  HDMI_HDMI_CTS_FIFO_CTL_get_debug_select(data)                           ((0x00000400&(data))>>10)
#define  HDMI_HDMI_CTS_FIFO_CTL_get_hdmi_2x_out_sel(data)                        ((0x00000300&(data))>>8)
#define  HDMI_HDMI_CTS_FIFO_CTL_get_hdmi_test_sel(data)                          ((0x000000F0&(data))>>4)
#define  HDMI_HDMI_CTS_FIFO_CTL_get_hdmi_out_sel(data)                           ((0x00000008&(data))>>3)
#define  HDMI_HDMI_CTS_FIFO_CTL_get_force_ctsfifo_rstn_hdmi(data)                ((0x00000004&(data))>>2)
#define  HDMI_HDMI_CTS_FIFO_CTL_get_en_ctsfifo_vsrst_hdmi(data)                  ((0x00000002&(data))>>1)
#define  HDMI_HDMI_CTS_FIFO_CTL_get_en_ctsfifo_bypass_hdmi(data)                 (0x00000001&(data))

#define  HDMI_CBUS_CLK_CTL                                                       0x1800D1B0
#define  HDMI_CBUS_CLK_CTL_reg_addr                                              "0xB800D1B0"
#define  HDMI_CBUS_CLK_CTL_reg                                                   0xB800D1B0
#define  HDMI_CBUS_CLK_CTL_inst_addr                                             "0x006B"
#define  set_HDMI_CBUS_CLK_CTL_reg(data)                                         (*((volatile unsigned int*)HDMI_CBUS_CLK_CTL_reg)=data)
#define  get_HDMI_CBUS_CLK_CTL_reg                                               (*((volatile unsigned int*)HDMI_CBUS_CLK_CTL_reg))
//#define  HDMI_CBUS_CLK_CTL_dummy_shift                                           (4)
//#define  HDMI_CBUS_CLK_CTL_dummy_shift                                           (1)
//#define  HDMI_CBUS_CLK_CTL_dummy_shift                                           (0)
//#define  HDMI_CBUS_CLK_CTL_dummy_mask                                            (0x00000070)
//#define  HDMI_CBUS_CLK_CTL_dummy_mask                                            (0x00000002)
//#define  HDMI_CBUS_CLK_CTL_dummy_mask                                            (0x00000001)
//#define  HDMI_CBUS_CLK_CTL_dummy(data)                                           (0x00000070&((data)<<4))
//#define  HDMI_CBUS_CLK_CTL_dummy(data)                                           (0x00000002&((data)<<1))
//#define  HDMI_CBUS_CLK_CTL_dummy(data)                                           (0x00000001&(data))
//#define  HDMI_CBUS_CLK_CTL_get_dummy(data)                                       ((0x00000070&(data))>>4)
//#define  HDMI_CBUS_CLK_CTL_get_dummy(data)                                       ((0x00000002&(data))>>1)
//#define  HDMI_CBUS_CLK_CTL_get_dummy(data)                                       (0x00000001&(data))

#define  HDMI_HDMI_2p0_CR                                                        0x1800D1B4
#define  HDMI_HDMI_2p0_CR_reg_addr                                               "0xB800D1B4"
#define  HDMI_HDMI_2p0_CR_reg                                                    0xB800D1B4
#define  HDMI_HDMI_2p0_CR_inst_addr                                              "0x006C"
#define  set_HDMI_HDMI_2p0_CR_reg(data)                                          (*((volatile unsigned int*)HDMI_HDMI_2p0_CR_reg)=data)
#define  get_HDMI_HDMI_2p0_CR_reg                                                (*((volatile unsigned int*)HDMI_HDMI_2p0_CR_reg))
#define  HDMI_HDMI_2p0_CR_gating_en_shift                                        (8)
#define  HDMI_HDMI_2p0_CR_ctr_char_num_shift                                     (1)
#define  HDMI_HDMI_2p0_CR_hdmi_2p0_en_shift                                      (0)
#define  HDMI_HDMI_2p0_CR_gating_en_mask                                         (0x00000100)
#define  HDMI_HDMI_2p0_CR_ctr_char_num_mask                                      (0x000000FE)
#define  HDMI_HDMI_2p0_CR_hdmi_2p0_en_mask                                       (0x00000001)
#define  HDMI_HDMI_2p0_CR_gating_en(data)                                        (0x00000100&((data)<<8))
#define  HDMI_HDMI_2p0_CR_ctr_char_num(data)                                     (0x000000FE&((data)<<1))
#define  HDMI_HDMI_2p0_CR_hdmi_2p0_en(data)                                      (0x00000001&(data))
#define  HDMI_HDMI_2p0_CR_get_gating_en(data)                                    ((0x00000100&(data))>>8)
#define  HDMI_HDMI_2p0_CR_get_ctr_char_num(data)                                 ((0x000000FE&(data))>>1)
#define  HDMI_HDMI_2p0_CR_get_hdmi_2p0_en(data)                                  (0x00000001&(data))

#define  HDMI_SCR_CR                                                             0x1800D1B8
#define  HDMI_SCR_CR_reg_addr                                                    "0xB800D1B8"
#define  HDMI_SCR_CR_reg                                                         0xB800D1B8
#define  HDMI_SCR_CR_inst_addr                                                   "0x006D"
#define  set_HDMI_SCR_CR_reg(data)                                               (*((volatile unsigned int*)HDMI_SCR_CR_reg)=data)
#define  get_HDMI_SCR_CR_reg                                                     (*((volatile unsigned int*)HDMI_SCR_CR_reg))
#define  HDMI_SCR_CR_char_lock_shift                                             (17)
#define  HDMI_SCR_CR_uscr_fall_bound_err_r_shift                                 (16)
#define  HDMI_SCR_CR_uscr_fall_bound_err_g_shift                                 (15)
#define  HDMI_SCR_CR_uscr_fall_bound_err_b_shift                                 (14)
#define  HDMI_SCR_CR_uscr_per_glitch_r_shift                                     (13)
#define  HDMI_SCR_CR_uscr_per_glitch_g_shift                                     (12)
#define  HDMI_SCR_CR_uscr_per_glitch_b_shift                                     (11)
#define  HDMI_SCR_CR_uscr_char_flag_r_shift                                      (10)
#define  HDMI_SCR_CR_uscr_char_flag_g_shift                                      (9)
#define  HDMI_SCR_CR_uscr_char_flag_b_shift                                      (8)
#define  HDMI_SCR_CR_uscr_num_shift                                              (4)
#define  HDMI_SCR_CR_dummy_shift                                                 (2)
#define  HDMI_SCR_CR_scr_en_fw_shift                                             (1)
#define  HDMI_SCR_CR_scr_auto_shift                                              (0)
#define  HDMI_SCR_CR_char_lock_mask                                              (0x00020000)
#define  HDMI_SCR_CR_uscr_fall_bound_err_r_mask                                  (0x00010000)
#define  HDMI_SCR_CR_uscr_fall_bound_err_g_mask                                  (0x00008000)
#define  HDMI_SCR_CR_uscr_fall_bound_err_b_mask                                  (0x00004000)
#define  HDMI_SCR_CR_uscr_per_glitch_r_mask                                      (0x00002000)
#define  HDMI_SCR_CR_uscr_per_glitch_g_mask                                      (0x00001000)
#define  HDMI_SCR_CR_uscr_per_glitch_b_mask                                      (0x00000800)
#define  HDMI_SCR_CR_uscr_char_flag_r_mask                                       (0x00000400)
#define  HDMI_SCR_CR_uscr_char_flag_g_mask                                       (0x00000200)
#define  HDMI_SCR_CR_uscr_char_flag_b_mask                                       (0x00000100)
#define  HDMI_SCR_CR_uscr_num_mask                                               (0x000000F0)
#define  HDMI_SCR_CR_dummy_mask                                                  (0x0000000C)
#define  HDMI_SCR_CR_scr_en_fw_mask                                              (0x00000002)
#define  HDMI_SCR_CR_scr_auto_mask                                               (0x00000001)
#define  HDMI_SCR_CR_char_lock(data)                                             (0x00020000&((data)<<17))
#define  HDMI_SCR_CR_uscr_fall_bound_err_r(data)                                 (0x00010000&((data)<<16))
#define  HDMI_SCR_CR_uscr_fall_bound_err_g(data)                                 (0x00008000&((data)<<15))
#define  HDMI_SCR_CR_uscr_fall_bound_err_b(data)                                 (0x00004000&((data)<<14))
#define  HDMI_SCR_CR_uscr_per_glitch_r(data)                                     (0x00002000&((data)<<13))
#define  HDMI_SCR_CR_uscr_per_glitch_g(data)                                     (0x00001000&((data)<<12))
#define  HDMI_SCR_CR_uscr_per_glitch_b(data)                                     (0x00000800&((data)<<11))
#define  HDMI_SCR_CR_uscr_char_flag_r(data)                                      (0x00000400&((data)<<10))
#define  HDMI_SCR_CR_uscr_char_flag_g(data)                                      (0x00000200&((data)<<9))
#define  HDMI_SCR_CR_uscr_char_flag_b(data)                                      (0x00000100&((data)<<8))
#define  HDMI_SCR_CR_uscr_num(data)                                              (0x000000F0&((data)<<4))
#define  HDMI_SCR_CR_dummy(data)                                                 (0x0000000C&((data)<<2))
#define  HDMI_SCR_CR_scr_en_fw(data)                                             (0x00000002&((data)<<1))
#define  HDMI_SCR_CR_scr_auto(data)                                              (0x00000001&(data))
#define  HDMI_SCR_CR_get_char_lock(data)                                         ((0x00020000&(data))>>17)
#define  HDMI_SCR_CR_get_uscr_fall_bound_err_r(data)                             ((0x00010000&(data))>>16)
#define  HDMI_SCR_CR_get_uscr_fall_bound_err_g(data)                             ((0x00008000&(data))>>15)
#define  HDMI_SCR_CR_get_uscr_fall_bound_err_b(data)                             ((0x00004000&(data))>>14)
#define  HDMI_SCR_CR_get_uscr_per_glitch_r(data)                                 ((0x00002000&(data))>>13)
#define  HDMI_SCR_CR_get_uscr_per_glitch_g(data)                                 ((0x00001000&(data))>>12)
#define  HDMI_SCR_CR_get_uscr_per_glitch_b(data)                                 ((0x00000800&(data))>>11)
#define  HDMI_SCR_CR_get_uscr_char_flag_r(data)                                  ((0x00000400&(data))>>10)
#define  HDMI_SCR_CR_get_uscr_char_flag_g(data)                                  ((0x00000200&(data))>>9)
#define  HDMI_SCR_CR_get_uscr_char_flag_b(data)                                  ((0x00000100&(data))>>8)
#define  HDMI_SCR_CR_get_uscr_num(data)                                          ((0x000000F0&(data))>>4)
#define  HDMI_SCR_CR_get_dummy(data)                                             ((0x0000000C&(data))>>2)
#define  HDMI_SCR_CR_get_scr_en_fw(data)                                         ((0x00000002&(data))>>1)
#define  HDMI_SCR_CR_get_scr_auto(data)                                          (0x00000001&(data))

#define  HDMI_CERCR                                                              0x1800D1BC
#define  HDMI_CERCR_reg_addr                                                     "0xB800D1BC"
#define  HDMI_CERCR_reg                                                          0xB800D1BC
#define  HDMI_CERCR_inst_addr                                                    "0x006E"
#define  set_HDMI_CERCR_reg(data)                                                (*((volatile unsigned int*)HDMI_CERCR_reg)=data)
#define  get_HDMI_CERCR_reg                                                      (*((volatile unsigned int*)HDMI_CERCR_reg))
#define  HDMI_CERCR_ch_locked_reset_shift                                        (28)
#define  HDMI_CERCR_ch2_over_max_err_num_shift                                   (27)
#define  HDMI_CERCR_ch1_over_max_err_num_shift                                   (26)
#define  HDMI_CERCR_ch0_over_max_err_num_shift                                   (25)
#define  HDMI_CERCR_max_err_num_shift                                            (15)
#define  HDMI_CERCR_valid_reset_shift                                            (14)
#define  HDMI_CERCR_reset_err_det_shift                                          (13)
#define  HDMI_CERCR_keep_err_det_shift                                           (12)
#define  HDMI_CERCR_refer_implem_shift                                           (11)
#define  HDMI_CERCR_reset_shift                                                  (10)
#define  HDMI_CERCR_period_shift                                                 (4)
#define  HDMI_CERCR_dummy_shift                                                  (2)
#define  HDMI_CERCR_mode_shift                                                   (1)
#define  HDMI_CERCR_en_shift                                                     (0)
#define  HDMI_CERCR_ch_locked_reset_mask                                         (0x10000000)
#define  HDMI_CERCR_ch2_over_max_err_num_mask                                    (0x08000000)
#define  HDMI_CERCR_ch1_over_max_err_num_mask                                    (0x04000000)
#define  HDMI_CERCR_ch0_over_max_err_num_mask                                    (0x02000000)
#define  HDMI_CERCR_max_err_num_mask                                             (0x01FF8000)
#define  HDMI_CERCR_valid_reset_mask                                             (0x00004000)
#define  HDMI_CERCR_reset_err_det_mask                                           (0x00002000)
#define  HDMI_CERCR_keep_err_det_mask                                            (0x00001000)
#define  HDMI_CERCR_refer_implem_mask                                            (0x00000800)
#define  HDMI_CERCR_reset_mask                                                   (0x00000400)
#define  HDMI_CERCR_period_mask                                                  (0x000003F0)
#define  HDMI_CERCR_dummy_mask                                                   (0x0000000C)
#define  HDMI_CERCR_mode_mask                                                    (0x00000002)
#define  HDMI_CERCR_en_mask                                                      (0x00000001)
#define  HDMI_CERCR_ch_locked_reset(data)                                        (0x10000000&((data)<<28))
#define  HDMI_CERCR_ch2_over_max_err_num(data)                                   (0x08000000&((data)<<27))
#define  HDMI_CERCR_ch1_over_max_err_num(data)                                   (0x04000000&((data)<<26))
#define  HDMI_CERCR_ch0_over_max_err_num(data)                                   (0x02000000&((data)<<25))
#define  HDMI_CERCR_max_err_num(data)                                            (0x01FF8000&((data)<<15))
#define  HDMI_CERCR_valid_reset(data)                                            (0x00004000&((data)<<14))
#define  HDMI_CERCR_reset_err_det(data)                                          (0x00002000&((data)<<13))
#define  HDMI_CERCR_keep_err_det(data)                                           (0x00001000&((data)<<12))
#define  HDMI_CERCR_refer_implem(data)                                           (0x00000800&((data)<<11))
#define  HDMI_CERCR_reset(data)                                                  (0x00000400&((data)<<10))
#define  HDMI_CERCR_period(data)                                                 (0x000003F0&((data)<<4))
#define  HDMI_CERCR_dummy(data)                                                  (0x0000000C&((data)<<2))
#define  HDMI_CERCR_mode(data)                                                   (0x00000002&((data)<<1))
#define  HDMI_CERCR_en(data)                                                     (0x00000001&(data))
#define  HDMI_CERCR_get_ch_locked_reset(data)                                    ((0x10000000&(data))>>28)
#define  HDMI_CERCR_get_ch2_over_max_err_num(data)                               ((0x08000000&(data))>>27)
#define  HDMI_CERCR_get_ch1_over_max_err_num(data)                               ((0x04000000&(data))>>26)
#define  HDMI_CERCR_get_ch0_over_max_err_num(data)                               ((0x02000000&(data))>>25)
#define  HDMI_CERCR_get_max_err_num(data)                                        ((0x01FF8000&(data))>>15)
#define  HDMI_CERCR_get_valid_reset(data)                                        ((0x00004000&(data))>>14)
#define  HDMI_CERCR_get_reset_err_det(data)                                      ((0x00002000&(data))>>13)
#define  HDMI_CERCR_get_keep_err_det(data)                                       ((0x00001000&(data))>>12)
#define  HDMI_CERCR_get_refer_implem(data)                                       ((0x00000800&(data))>>11)
#define  HDMI_CERCR_get_reset(data)                                              ((0x00000400&(data))>>10)
#define  HDMI_CERCR_get_period(data)                                             ((0x000003F0&(data))>>4)
#define  HDMI_CERCR_get_dummy(data)                                              ((0x0000000C&(data))>>2)
#define  HDMI_CERCR_get_mode(data)                                               ((0x00000002&(data))>>1)
#define  HDMI_CERCR_get_en(data)                                                 (0x00000001&(data))

#define  HDMI_CERSR0                                                             0x1800D1C0
#define  HDMI_CERSR0_reg_addr                                                    "0xB800D1C0"
#define  HDMI_CERSR0_reg                                                         0xB800D1C0
#define  HDMI_CERSR0_inst_addr                                                   "0x006F"
#define  set_HDMI_CERSR0_reg(data)                                               (*((volatile unsigned int*)HDMI_CERSR0_reg)=data)
#define  get_HDMI_CERSR0_reg                                                     (*((volatile unsigned int*)HDMI_CERSR0_reg))
#define  HDMI_CERSR0_err_cnt1_video_shift                                        (16)
#define  HDMI_CERSR0_err_cnt0_video_shift                                        (0)
#define  HDMI_CERSR0_err_cnt1_video_mask                                         (0x7FFF0000)
#define  HDMI_CERSR0_err_cnt0_video_mask                                         (0x00007FFF)
#define  HDMI_CERSR0_err_cnt1_video(data)                                        (0x7FFF0000&((data)<<16))
#define  HDMI_CERSR0_err_cnt0_video(data)                                        (0x00007FFF&(data))
#define  HDMI_CERSR0_get_err_cnt1_video(data)                                    ((0x7FFF0000&(data))>>16)
#define  HDMI_CERSR0_get_err_cnt0_video(data)                                    (0x00007FFF&(data))

#define  HDMI_CERSR1                                                             0x1800D1C4
#define  HDMI_CERSR1_reg_addr                                                    "0xB800D1C4"
#define  HDMI_CERSR1_reg                                                         0xB800D1C4
#define  HDMI_CERSR1_inst_addr                                                   "0x0070"
#define  set_HDMI_CERSR1_reg(data)                                               (*((volatile unsigned int*)HDMI_CERSR1_reg)=data)
#define  get_HDMI_CERSR1_reg                                                     (*((volatile unsigned int*)HDMI_CERSR1_reg))
#define  HDMI_CERSR1_err_cnt0_pkt_shift                                          (16)
#define  HDMI_CERSR1_err_cnt2_video_shift                                        (0)
#define  HDMI_CERSR1_err_cnt0_pkt_mask                                           (0x7FFF0000)
#define  HDMI_CERSR1_err_cnt2_video_mask                                         (0x00007FFF)
#define  HDMI_CERSR1_err_cnt0_pkt(data)                                          (0x7FFF0000&((data)<<16))
#define  HDMI_CERSR1_err_cnt2_video(data)                                        (0x00007FFF&(data))
#define  HDMI_CERSR1_get_err_cnt0_pkt(data)                                      ((0x7FFF0000&(data))>>16)
#define  HDMI_CERSR1_get_err_cnt2_video(data)                                    (0x00007FFF&(data))

#define  HDMI_CERSR2                                                             0x1800D1C8
#define  HDMI_CERSR2_reg_addr                                                    "0xB800D1C8"
#define  HDMI_CERSR2_reg                                                         0xB800D1C8
#define  HDMI_CERSR2_inst_addr                                                   "0x0071"
#define  set_HDMI_CERSR2_reg(data)                                               (*((volatile unsigned int*)HDMI_CERSR2_reg)=data)
#define  get_HDMI_CERSR2_reg                                                     (*((volatile unsigned int*)HDMI_CERSR2_reg))
#define  HDMI_CERSR2_err_cnt2_pkt_shift                                          (16)
#define  HDMI_CERSR2_err_cnt1_pkt_shift                                          (0)
#define  HDMI_CERSR2_err_cnt2_pkt_mask                                           (0x7FFF0000)
#define  HDMI_CERSR2_err_cnt1_pkt_mask                                           (0x00007FFF)
#define  HDMI_CERSR2_err_cnt2_pkt(data)                                          (0x7FFF0000&((data)<<16))
#define  HDMI_CERSR2_err_cnt1_pkt(data)                                          (0x00007FFF&(data))
#define  HDMI_CERSR2_get_err_cnt2_pkt(data)                                      ((0x7FFF0000&(data))>>16)
#define  HDMI_CERSR2_get_err_cnt1_pkt(data)                                      (0x00007FFF&(data))

#define  HDMI_CERSR3                                                             0x1800D1CC
#define  HDMI_CERSR3_reg_addr                                                    "0xB800D1CC"
#define  HDMI_CERSR3_reg                                                         0xB800D1CC
#define  HDMI_CERSR3_inst_addr                                                   "0x0072"
#define  set_HDMI_CERSR3_reg(data)                                               (*((volatile unsigned int*)HDMI_CERSR3_reg)=data)
#define  get_HDMI_CERSR3_reg                                                     (*((volatile unsigned int*)HDMI_CERSR3_reg))
#define  HDMI_CERSR3_err_cnt1_ctr_shift                                          (16)
#define  HDMI_CERSR3_err_cnt0_ctr_shift                                          (0)
#define  HDMI_CERSR3_err_cnt1_ctr_mask                                           (0x7FFF0000)
#define  HDMI_CERSR3_err_cnt0_ctr_mask                                           (0x00007FFF)
#define  HDMI_CERSR3_err_cnt1_ctr(data)                                          (0x7FFF0000&((data)<<16))
#define  HDMI_CERSR3_err_cnt0_ctr(data)                                          (0x00007FFF&(data))
#define  HDMI_CERSR3_get_err_cnt1_ctr(data)                                      ((0x7FFF0000&(data))>>16)
#define  HDMI_CERSR3_get_err_cnt0_ctr(data)                                      (0x00007FFF&(data))

#define  HDMI_CERSR4                                                             0x1800D1D0
#define  HDMI_CERSR4_reg_addr                                                    "0xB800D1D0"
#define  HDMI_CERSR4_reg                                                         0xB800D1D0
#define  HDMI_CERSR4_inst_addr                                                   "0x0073"
#define  set_HDMI_CERSR4_reg(data)                                               (*((volatile unsigned int*)HDMI_CERSR4_reg)=data)
#define  get_HDMI_CERSR4_reg                                                     (*((volatile unsigned int*)HDMI_CERSR4_reg))
#define  HDMI_CERSR4_err_cnt2_ctr_shift                                          (0)
#define  HDMI_CERSR4_err_cnt2_ctr_mask                                           (0x00007FFF)
#define  HDMI_CERSR4_err_cnt2_ctr(data)                                          (0x00007FFF&(data))
#define  HDMI_CERSR4_get_err_cnt2_ctr(data)                                      (0x00007FFF&(data))

#define  HDMI_YUV420_CR                                                          0x1800D1D4
#define  HDMI_YUV420_CR_reg_addr                                                 "0xB800D1D4"
#define  HDMI_YUV420_CR_reg                                                      0xB800D1D4
#define  HDMI_YUV420_CR_inst_addr                                                "0x0074"
#define  set_HDMI_YUV420_CR_reg(data)                                            (*((volatile unsigned int*)HDMI_YUV420_CR_reg)=data)
#define  get_HDMI_YUV420_CR_reg                                                  (*((volatile unsigned int*)HDMI_YUV420_CR_reg))
#define  HDMI_YUV420_CR_fifo_over_flag_shift                                     (2)
#define  HDMI_YUV420_CR_fifo_under_flag_shift                                    (1)
#define  HDMI_YUV420_CR_en_shift                                                 (0)
#define  HDMI_YUV420_CR_fifo_over_flag_mask                                      (0x00000004)
#define  HDMI_YUV420_CR_fifo_under_flag_mask                                     (0x00000002)
#define  HDMI_YUV420_CR_en_mask                                                  (0x00000001)
#define  HDMI_YUV420_CR_fifo_over_flag(data)                                     (0x00000004&((data)<<2))
#define  HDMI_YUV420_CR_fifo_under_flag(data)                                    (0x00000002&((data)<<1))
#define  HDMI_YUV420_CR_en(data)                                                 (0x00000001&(data))
#define  HDMI_YUV420_CR_get_fifo_over_flag(data)                                 ((0x00000004&(data))>>2)
#define  HDMI_YUV420_CR_get_fifo_under_flag(data)                                ((0x00000002&(data))>>1)
#define  HDMI_YUV420_CR_get_en(data)                                             (0x00000001&(data))

#define  HDMI_SCDC_CR                                                            0x1800D1D8
#define  HDMI_SCDC_CR_reg_addr                                                   "0xB800D1D8"
#define  HDMI_SCDC_CR_reg                                                        0xB800D1D8
#define  HDMI_SCDC_CR_inst_addr                                                  "0x0075"
#define  set_HDMI_SCDC_CR_reg(data)                                              (*((volatile unsigned int*)HDMI_SCDC_CR_reg)=data)
#define  get_HDMI_SCDC_CR_reg                                                    (*((volatile unsigned int*)HDMI_SCDC_CR_reg))
#define  HDMI_SCDC_CR_scdc_reset_shift                                           (5)
#define  HDMI_SCDC_CR_dummy_shift                                                (2)
#define  HDMI_SCDC_CR_maddf_shift                                                (1)
#define  HDMI_SCDC_CR_scdc_en_shift                                              (0)
#define  HDMI_SCDC_CR_scdc_reset_mask                                            (0x00000020)
#define  HDMI_SCDC_CR_dummy_mask                                                 (0x0000001C)
#define  HDMI_SCDC_CR_maddf_mask                                                 (0x00000002)
#define  HDMI_SCDC_CR_scdc_en_mask                                               (0x00000001)
#define  HDMI_SCDC_CR_scdc_reset(data)                                           (0x00000020&((data)<<5))
#define  HDMI_SCDC_CR_dummy(data)                                                (0x0000001C&((data)<<2))
#define  HDMI_SCDC_CR_maddf(data)                                                (0x00000002&((data)<<1))
#define  HDMI_SCDC_CR_scdc_en(data)                                              (0x00000001&(data))
#define  HDMI_SCDC_CR_get_scdc_reset(data)                                       ((0x00000020&(data))>>5)
#define  HDMI_SCDC_CR_get_dummy(data)                                            ((0x0000001C&(data))>>2)
#define  HDMI_SCDC_CR_get_maddf(data)                                            ((0x00000002&(data))>>1)
#define  HDMI_SCDC_CR_get_scdc_en(data)                                          (0x00000001&(data))

#define  HDMI_SCDC_PCR                                                           0x1800D1DC
#define  HDMI_SCDC_PCR_reg_addr                                                  "0xB800D1DC"
#define  HDMI_SCDC_PCR_reg                                                       0xB800D1DC
#define  HDMI_SCDC_PCR_inst_addr                                                 "0x0076"
#define  set_HDMI_SCDC_PCR_reg(data)                                             (*((volatile unsigned int*)HDMI_SCDC_PCR_reg)=data)
#define  get_HDMI_SCDC_PCR_reg                                                   (*((volatile unsigned int*)HDMI_SCDC_PCR_reg))
#define  HDMI_SCDC_PCR_timeout_flag_shift                                        (31)
#define  HDMI_SCDC_PCR_timeout_sel_shift                                         (29)
#define  HDMI_SCDC_PCR_status_flag_shift                                         (28)
#define  HDMI_SCDC_PCR_config_flag_shift                                         (27)
#define  HDMI_SCDC_PCR_scrambler_status_flag_shift                               (26)
#define  HDMI_SCDC_PCR_tmds_config_flag_shift                                    (25)
#define  HDMI_SCDC_PCR_i2c_scl_dly_sel_shift                                     (21)
#define  HDMI_SCDC_PCR_i2c_sda_dly_sel_shift                                     (17)
#define  HDMI_SCDC_PCR_i2c_free_num_shift                                        (10)
#define  HDMI_SCDC_PCR_rr_retry_sel_shift                                        (8)
#define  HDMI_SCDC_PCR_dbnc_level_sel_shift                                      (7)
#define  HDMI_SCDC_PCR_dummy_shift                                               (1)
#define  HDMI_SCDC_PCR_apai_shift                                                (0)
#define  HDMI_SCDC_PCR_timeout_flag_mask                                         (0x80000000)
#define  HDMI_SCDC_PCR_timeout_sel_mask                                          (0x60000000)
#define  HDMI_SCDC_PCR_status_flag_mask                                          (0x10000000)
#define  HDMI_SCDC_PCR_config_flag_mask                                          (0x08000000)
#define  HDMI_SCDC_PCR_scrambler_status_flag_mask                                (0x04000000)
#define  HDMI_SCDC_PCR_tmds_config_flag_mask                                     (0x02000000)
#define  HDMI_SCDC_PCR_i2c_scl_dly_sel_mask                                      (0x01E00000)
#define  HDMI_SCDC_PCR_i2c_sda_dly_sel_mask                                      (0x001E0000)
#define  HDMI_SCDC_PCR_i2c_free_num_mask                                         (0x0001FC00)
#define  HDMI_SCDC_PCR_rr_retry_sel_mask                                         (0x00000300)
#define  HDMI_SCDC_PCR_dbnc_level_sel_mask                                       (0x00000080)
#define  HDMI_SCDC_PCR_dummy_mask                                                (0x0000007E)
#define  HDMI_SCDC_PCR_apai_mask                                                 (0x00000001)
#define  HDMI_SCDC_PCR_timeout_flag(data)                                        (0x80000000&((data)<<31))
#define  HDMI_SCDC_PCR_timeout_sel(data)                                         (0x60000000&((data)<<29))
#define  HDMI_SCDC_PCR_status_flag(data)                                         (0x10000000&((data)<<28))
#define  HDMI_SCDC_PCR_config_flag(data)                                         (0x08000000&((data)<<27))
#define  HDMI_SCDC_PCR_scrambler_status_flag(data)                               (0x04000000&((data)<<26))
#define  HDMI_SCDC_PCR_tmds_config_flag(data)                                    (0x02000000&((data)<<25))
#define  HDMI_SCDC_PCR_i2c_scl_dly_sel(data)                                     (0x01E00000&((data)<<21))
#define  HDMI_SCDC_PCR_i2c_sda_dly_sel(data)                                     (0x001E0000&((data)<<17))
#define  HDMI_SCDC_PCR_i2c_free_num(data)                                        (0x0001FC00&((data)<<10))
#define  HDMI_SCDC_PCR_rr_retry_sel(data)                                        (0x00000300&((data)<<8))
#define  HDMI_SCDC_PCR_dbnc_level_sel(data)                                      (0x00000080&((data)<<7))
#define  HDMI_SCDC_PCR_dummy(data)                                               (0x0000007E&((data)<<1))
#define  HDMI_SCDC_PCR_apai(data)                                                (0x00000001&(data))
#define  HDMI_SCDC_PCR_get_timeout_flag(data)                                    ((0x80000000&(data))>>31)
#define  HDMI_SCDC_PCR_get_timeout_sel(data)                                     ((0x60000000&(data))>>29)
#define  HDMI_SCDC_PCR_get_status_flag(data)                                     ((0x10000000&(data))>>28)
#define  HDMI_SCDC_PCR_get_config_flag(data)                                     ((0x08000000&(data))>>27)
#define  HDMI_SCDC_PCR_get_scrambler_status_flag(data)                           ((0x04000000&(data))>>26)
#define  HDMI_SCDC_PCR_get_tmds_config_flag(data)                                ((0x02000000&(data))>>25)
#define  HDMI_SCDC_PCR_get_i2c_scl_dly_sel(data)                                 ((0x01E00000&(data))>>21)
#define  HDMI_SCDC_PCR_get_i2c_sda_dly_sel(data)                                 ((0x001E0000&(data))>>17)
#define  HDMI_SCDC_PCR_get_i2c_free_num(data)                                    ((0x0001FC00&(data))>>10)
#define  HDMI_SCDC_PCR_get_rr_retry_sel(data)                                    ((0x00000300&(data))>>8)
#define  HDMI_SCDC_PCR_get_dbnc_level_sel(data)                                  ((0x00000080&(data))>>7)
#define  HDMI_SCDC_PCR_get_dummy(data)                                           ((0x0000007E&(data))>>1)
#define  HDMI_SCDC_PCR_get_apai(data)                                            (0x00000001&(data))

#define  HDMI_SCDC_AP                                                            0x1800D1E0
#define  HDMI_SCDC_AP_reg_addr                                                   "0xB800D1E0"
#define  HDMI_SCDC_AP_reg                                                        0xB800D1E0
#define  HDMI_SCDC_AP_inst_addr                                                  "0x0077"
#define  set_HDMI_SCDC_AP_reg(data)                                              (*((volatile unsigned int*)HDMI_SCDC_AP_reg)=data)
#define  get_HDMI_SCDC_AP_reg                                                    (*((volatile unsigned int*)HDMI_SCDC_AP_reg))
#define  HDMI_SCDC_AP_ap1_shift                                                  (0)
#define  HDMI_SCDC_AP_ap1_mask                                                   (0x000000FF)
#define  HDMI_SCDC_AP_ap1(data)                                                  (0x000000FF&(data))
#define  HDMI_SCDC_AP_get_ap1(data)                                              (0x000000FF&(data))

#define  HDMI_SCDC_DP                                                            0x1800D1E4
#define  HDMI_SCDC_DP_reg_addr                                                   "0xB800D1E4"
#define  HDMI_SCDC_DP_reg                                                        0xB800D1E4
#define  HDMI_SCDC_DP_inst_addr                                                  "0x0078"
#define  set_HDMI_SCDC_DP_reg(data)                                              (*((volatile unsigned int*)HDMI_SCDC_DP_reg)=data)
#define  get_HDMI_SCDC_DP_reg                                                    (*((volatile unsigned int*)HDMI_SCDC_DP_reg))
#define  HDMI_SCDC_DP_dp1_shift                                                  (0)
#define  HDMI_SCDC_DP_dp1_mask                                                   (0x000000FF)
#define  HDMI_SCDC_DP_dp1(data)                                                  (0x000000FF&(data))
#define  HDMI_SCDC_DP_get_dp1(data)                                              (0x000000FF&(data))

#define  HDMI_CLKDETCR_D                                                           0x1800D1E8
#define  HDMI_CLKDETCR_D_reg_addr                                                  "0xB800D1E8"
#define  HDMI_CLKDETCR_D_reg                                                       0xB800D1E8
#define  HDMI_CLKDETCR_D_inst_addr                                                 "0x0079"
#define  set_HDMI_CLKDETCR_D_reg(data)                                             (*((volatile unsigned int*)HDMI_CLKDETCR_reg)=data)
#define  get_HDMI_CLKDETCR_D_reg                                                   (*((volatile unsigned int*)HDMI_CLKDETCR_reg))
#define  HDMI_CLKDETCR_D_clock_det_en_shift                                        (0)
#define  HDMI_CLKDETCR_D_clock_det_en_mask                                         (0x00000001)
#define  HDMI_CLKDETCR_D_clock_det_en(data)                                        (0x00000001&(data))
#define  HDMI_CLKDETCR_D_get_clock_det_en(data)                                    (0x00000001&(data))

#define  HDMI_CLKDETSR_D                                                           0x1800D1EC
#define  HDMI_CLKDETSR_D_reg_addr                                                  "0xB800D1EC"
#define  HDMI_CLKDETSR_D_reg                                                       0xB800D1EC
#define  HDMI_CLKDETSR_D_inst_addr                                                 "0x007A"
#define  set_HDMI_CLKDETSR_D_reg(data)                                             (*((volatile unsigned int*)HDMI_CLKDETSR_reg)=data)
#define  get_HDMI_CLKDETSR_D_reg                                                   (*((volatile unsigned int*)HDMI_CLKDETSR_reg))
#define  HDMI_CLKDETSR_D_en_tmds_chg_irq_shift                                     (5)
#define  HDMI_CLKDETSR_D_tmds_chg_irq_shift                                        (4)
#define  HDMI_CLKDETSR_D_dummy_shift                                               (2)
#define  HDMI_CLKDETSR_D_clk_not_in_target_irq_en_shift                            (1)
#define  HDMI_CLKDETSR_D_clk_not_in_target_shift                                   (0)
#define  HDMI_CLKDETSR_D_en_tmds_chg_irq_mask                                      (0x00000020)
#define  HDMI_CLKDETSR_D_tmds_chg_irq_mask                                         (0x00000010)
#define  HDMI_CLKDETSR_D_dummy_mask                                                (0x0000000C)
#define  HDMI_CLKDETSR_D_clk_not_in_target_irq_en_mask                             (0x00000002)
#define  HDMI_CLKDETSR_D_clk_not_in_target_mask                                    (0x00000001)
#define  HDMI_CLKDETSR_D_en_tmds_chg_irq(data)                                     (0x00000020&((data)<<5))
#define  HDMI_CLKDETSR_D_tmds_chg_irq(data)                                        (0x00000010&((data)<<4))
#define  HDMI_CLKDETSR_D_dummy(data)                                               (0x0000000C&((data)<<2))
#define  HDMI_CLKDETSR_D_clk_not_in_target_irq_en(data)                            (0x00000002&((data)<<1))
#define  HDMI_CLKDETSR_D_clk_not_in_target(data)                                   (0x00000001&(data))
#define  HDMI_CLKDETSR_D_get_en_tmds_chg_irq(data)                                 ((0x00000020&(data))>>5)
#define  HDMI_CLKDETSR_D_get_tmds_chg_irq(data)                                    ((0x00000010&(data))>>4)
#define  HDMI_CLKDETSR_D_get_dummy(data)                                           ((0x0000000C&(data))>>2)
#define  HDMI_CLKDETSR_D_get_clk_not_in_target_irq_en(data)                        ((0x00000002&(data))>>1)
#define  HDMI_CLKDETSR_D_get_clk_not_in_target(data)                               (0x00000001&(data))

#define  HDMI_GDI_TMDSCLK_SETTING_D_00                                             0x1800D1F0
#define  HDMI_GDI_TMDSCLK_SETTING_D_00_reg_addr                                    "0xB800D1F0"
#define  HDMI_GDI_TMDSCLK_SETTING_D_00_reg                                         0xB800D1F0
#define  HDMI_GDI_TMDSCLK_SETTING_D_00_inst_addr                                   "0x007B"
#define  set_HDMI_GDI_TMDSCLK_SETTING_D_00_reg(data)                               (*((volatile unsigned int*)HDMI_GDI_TMDSCLK_SETTING_00_reg)=data)
#define  get_HDMI_GDI_TMDSCLK_SETTING_D_00_reg                                     (*((volatile unsigned int*)HDMI_GDI_TMDSCLK_SETTING_00_reg))
#define  HDMI_GDI_TMDSCLK_SETTING_D_00_dclk_cnt_start_shift                        (16)
#define  HDMI_GDI_TMDSCLK_SETTING_D_00_dclk_cnt_end_shift                          (0)
#define  HDMI_GDI_TMDSCLK_SETTING_D_00_dclk_cnt_start_mask                         (0x0FFF0000)
#define  HDMI_GDI_TMDSCLK_SETTING_D_00_dclk_cnt_end_mask                           (0x00000FFF)
#define  HDMI_GDI_TMDSCLK_SETTING_D_00_dclk_cnt_start(data)                        (0x0FFF0000&((data)<<16))
#define  HDMI_GDI_TMDSCLK_SETTING_D_00_dclk_cnt_end(data)                          (0x00000FFF&(data))
#define  HDMI_GDI_TMDSCLK_SETTING_D_00_get_dclk_cnt_start(data)                    ((0x0FFF0000&(data))>>16)
#define  HDMI_GDI_TMDSCLK_SETTING_D_00_get_dclk_cnt_end(data)                      (0x00000FFF&(data))

#define  HDMI_GDI_TMDSCLK_SETTING_D_01                                             0x1800D1F4
#define  HDMI_GDI_TMDSCLK_SETTING_D_01_reg_addr                                    "0xB800D1F4"
#define  HDMI_GDI_TMDSCLK_SETTING_D_01_reg                                         0xB800D1F4
#define  HDMI_GDI_TMDSCLK_SETTING_D_01_inst_addr                                   "0x007C"
#define  set_HDMI_GDI_TMDSCLK_SETTING_D_01_reg(data)                               (*((volatile unsigned int*)HDMI_GDI_TMDSCLK_SETTING_01_reg)=data)
#define  get_HDMI_GDI_TMDSCLK_SETTING_01_reg                                     (*((volatile unsigned int*)HDMI_GDI_TMDSCLK_SETTING_01_reg))
#define  HDMI_GDI_TMDSCLK_SETTING_D_01_target_for_maximum_clk_counter_shift        (16)
#define  HDMI_GDI_TMDSCLK_SETTING_D_01_target_for_minimum_clk_counter_shift        (0)
#define  HDMI_GDI_TMDSCLK_SETTING_D_01_target_for_maximum_clk_counter_mask         (0x0FFF0000)
#define  HDMI_GDI_TMDSCLK_SETTING_D_01_target_for_minimum_clk_counter_mask         (0x00000FFF)
#define  HDMI_GDI_TMDSCLK_SETTING_D_01_target_for_maximum_clk_counter(data)        (0x0FFF0000&((data)<<16))
#define  HDMI_GDI_TMDSCLK_SETTING_D_01_target_for_minimum_clk_counter(data)        (0x00000FFF&(data))
#define  HDMI_GDI_TMDSCLK_SETTING_D_01_get_target_for_maximum_clk_counter(data)    ((0x0FFF0000&(data))>>16)
#define  HDMI_GDI_TMDSCLK_SETTING_D_01_get_target_for_minimum_clk_counter(data)    (0x00000FFF&(data))

#define  HDMI_GDI_TMDSCLK_SETTING_D_02                                             0x1800D1F8
#define  HDMI_GDI_TMDSCLK_SETTING_D_02_reg_addr                                    "0xB800D1F8"
#define  HDMI_GDI_TMDSCLK_SETTING_D_02_reg                                         0xB800D1F8
#define  HDMI_GDI_TMDSCLK_SETTING_D_02_inst_addr                                   "0x007D"
#define  set_HDMI_GDI_TMDSCLK_SETTING_D_02_reg(data)                               (*((volatile unsigned int*)HDMI_GDI_TMDSCLK_SETTING_02_reg)=data)
#define  get_HDMI_GDI_TMDSCLK_SETTING_D_02_reg                                     (*((volatile unsigned int*)HDMI_GDI_TMDSCLK_SETTING_02_reg))
#define  HDMI_GDI_TMDSCLK_SETTING_D_02_clk_counter_err_threshold_shift             (8)
#define  HDMI_GDI_TMDSCLK_SETTING_D_02_clk_counter_debounce_shift                  (0)
#define  HDMI_GDI_TMDSCLK_SETTING_D_02_clk_counter_err_threshold_mask              (0x00000F00)
#define  HDMI_GDI_TMDSCLK_SETTING_D_02_clk_counter_debounce_mask                   (0x000000FF)
#define  HDMI_GDI_TMDSCLK_SETTING_D_02_clk_counter_err_threshold(data)             (0x00000F00&((data)<<8))
#define  HDMI_GDI_TMDSCLK_SETTING_D_02_clk_counter_debounce(data)                  (0x000000FF&(data))
#define  HDMI_GDI_TMDSCLK_SETTING_D_02_get_clk_counter_err_threshold(data)         ((0x00000F00&(data))>>8)
#define  HDMI_GDI_TMDSCLK_SETTING_D_02_get_clk_counter_debounce(data)              (0x000000FF&(data))

#define  HDMI_HDCP_CR                                                            0x1800D204
#define  HDMI_HDCP_CR_reg_addr                                                   "0xB800D204"
#define  HDMI_HDCP_CR_reg                                                        0xB800D204
#define  HDMI_HDCP_CR_inst_addr                                                  "0x007E"
#define  set_HDMI_HDCP_CR_reg(data)                                              (*((volatile unsigned int*)HDMI_HDCP_CR_reg)=data)
#define  get_HDMI_HDCP_CR_reg                                                    (*((volatile unsigned int*)HDMI_HDCP_CR_reg))
#define  HDMI_HDCP_CR_namfe_shift                                                (7)
#define  HDMI_HDCP_CR_rpt_shift                                                  (6)
#define  HDMI_HDCP_CR_ivsp_shift                                                 (5)
#define  HDMI_HDCP_CR_invvs_shift                                                (4)
#define  HDMI_HDCP_CR_ivspm_shift                                                (3)
#define  HDMI_HDCP_CR_maddf_shift                                                (2)
#define  HDMI_HDCP_CR_dkapde_shift                                               (1)
#define  HDMI_HDCP_CR_hdcp_en_shift                                              (0)
#define  HDMI_HDCP_CR_namfe_mask                                                 (0x00000080)
#define  HDMI_HDCP_CR_rpt_mask                                                   (0x00000040)
#define  HDMI_HDCP_CR_ivsp_mask                                                  (0x00000020)
#define  HDMI_HDCP_CR_invvs_mask                                                 (0x00000010)
#define  HDMI_HDCP_CR_ivspm_mask                                                 (0x00000008)
#define  HDMI_HDCP_CR_maddf_mask                                                 (0x00000004)
#define  HDMI_HDCP_CR_dkapde_mask                                                (0x00000002)
#define  HDMI_HDCP_CR_hdcp_en_mask                                               (0x00000001)
#define  HDMI_HDCP_CR_namfe(data)                                                (0x00000080&((data)<<7))
#define  HDMI_HDCP_CR_rpt(data)                                                  (0x00000040&((data)<<6))
#define  HDMI_HDCP_CR_ivsp(data)                                                 (0x00000020&((data)<<5))
#define  HDMI_HDCP_CR_invvs(data)                                                (0x00000010&((data)<<4))
#define  HDMI_HDCP_CR_ivspm(data)                                                (0x00000008&((data)<<3))
#define  HDMI_HDCP_CR_maddf(data)                                                (0x00000004&((data)<<2))
#define  HDMI_HDCP_CR_dkapde(data)                                               (0x00000002&((data)<<1))
#define  HDMI_HDCP_CR_hdcp_en(data)                                              (0x00000001&(data))
#define  HDMI_HDCP_CR_get_namfe(data)                                            ((0x00000080&(data))>>7)
#define  HDMI_HDCP_CR_get_rpt(data)                                              ((0x00000040&(data))>>6)
#define  HDMI_HDCP_CR_get_ivsp(data)                                             ((0x00000020&(data))>>5)
#define  HDMI_HDCP_CR_get_invvs(data)                                            ((0x00000010&(data))>>4)
#define  HDMI_HDCP_CR_get_ivspm(data)                                            ((0x00000008&(data))>>3)
#define  HDMI_HDCP_CR_get_maddf(data)                                            ((0x00000004&(data))>>2)
#define  HDMI_HDCP_CR_get_dkapde(data)                                           ((0x00000002&(data))>>1)
#define  HDMI_HDCP_CR_get_hdcp_en(data)                                          (0x00000001&(data))

#define  HDMI_HDCP_DKAP                                                          0x1800D208
#define  HDMI_HDCP_DKAP_reg_addr                                                 "0xB800D208"
#define  HDMI_HDCP_DKAP_reg                                                      0xB800D208
#define  HDMI_HDCP_DKAP_inst_addr                                                "0x007F"
#define  set_HDMI_HDCP_DKAP_reg(data)                                            (*((volatile unsigned int*)HDMI_HDCP_DKAP_reg)=data)
#define  get_HDMI_HDCP_DKAP_reg                                                  (*((volatile unsigned int*)HDMI_HDCP_DKAP_reg))
#define  HDMI_HDCP_DKAP_dkap_shift                                               (0)
#define  HDMI_HDCP_DKAP_dkap_mask                                                (0x000000FF)
#define  HDMI_HDCP_DKAP_dkap(data)                                               (0x000000FF&(data))
#define  HDMI_HDCP_DKAP_get_dkap(data)                                           (0x000000FF&(data))

#define  HDMI_HDCP_PCR                                                           0x1800D20C
#define  HDMI_HDCP_PCR_reg_addr                                                  "0xB800D20C"
#define  HDMI_HDCP_PCR_reg                                                       0xB800D20C
#define  HDMI_HDCP_PCR_inst_addr                                                 "0x0080"
#define  set_HDMI_HDCP_PCR_reg(data)                                             (*((volatile unsigned int*)HDMI_HDCP_PCR_reg)=data)
#define  get_HDMI_HDCP_PCR_reg                                                   (*((volatile unsigned int*)HDMI_HDCP_PCR_reg))
#define  HDMI_HDCP_PCR_i2c_scl_dly_sel_shift                                     (24)
#define  HDMI_HDCP_PCR_i2c_sda_dly_sel_shift                                     (20)
#define  HDMI_HDCP_PCR_tune_up_down_shift                                        (17)
#define  HDMI_HDCP_PCR_tune_range_shift                                          (10)
#define  HDMI_HDCP_PCR_ddcdbnc_shift                                             (9)
#define  HDMI_HDCP_PCR_km_clk_sel_eco_shift                                      (8)
#define  HDMI_HDCP_PCR_dbnc_level_sel_shift                                      (7)
#define  HDMI_HDCP_PCR_km_clk_sel_shift                                          (6)
#define  HDMI_HDCP_PCR_hdcp_vs_sel_shift                                         (5)
#define  HDMI_HDCP_PCR_enc_tog_shift                                             (4)
#define  HDMI_HDCP_PCR_avmute_dis_shift                                          (3)
#define  HDMI_HDCP_PCR_dummy_shift                                               (2)
#define  HDMI_HDCP_PCR_apai_type_shift                                           (1)
#define  HDMI_HDCP_PCR_apai_shift                                                (0)
#define  HDMI_HDCP_PCR_i2c_scl_dly_sel_mask                                      (0x0F000000)
#define  HDMI_HDCP_PCR_i2c_sda_dly_sel_mask                                      (0x00F00000)
#define  HDMI_HDCP_PCR_tune_up_down_mask                                         (0x00020000)
#define  HDMI_HDCP_PCR_tune_range_mask                                           (0x0001FC00)
#define  HDMI_HDCP_PCR_ddcdbnc_mask                                              (0x00000200)
#define  HDMI_HDCP_PCR_km_clk_sel_eco_mask                                       (0x00000100)
#define  HDMI_HDCP_PCR_dbnc_level_sel_mask                                       (0x00000080)
#define  HDMI_HDCP_PCR_km_clk_sel_mask                                           (0x00000040)
#define  HDMI_HDCP_PCR_hdcp_vs_sel_mask                                          (0x00000020)
#define  HDMI_HDCP_PCR_enc_tog_mask                                              (0x00000010)
#define  HDMI_HDCP_PCR_avmute_dis_mask                                           (0x00000008)
#define  HDMI_HDCP_PCR_dummy_mask                                                (0x00000004)
#define  HDMI_HDCP_PCR_apai_type_mask                                            (0x00000002)
#define  HDMI_HDCP_PCR_apai_mask                                                 (0x00000001)
#define  HDMI_HDCP_PCR_i2c_scl_dly_sel(data)                                     (0x0F000000&((data)<<24))
#define  HDMI_HDCP_PCR_i2c_sda_dly_sel(data)                                     (0x00F00000&((data)<<20))
#define  HDMI_HDCP_PCR_tune_up_down(data)                                        (0x00020000&((data)<<17))
#define  HDMI_HDCP_PCR_tune_range(data)                                          (0x0001FC00&((data)<<10))
#define  HDMI_HDCP_PCR_ddcdbnc(data)                                             (0x00000200&((data)<<9))
#define  HDMI_HDCP_PCR_km_clk_sel_eco(data)                                      (0x00000100&((data)<<8))
#define  HDMI_HDCP_PCR_dbnc_level_sel(data)                                      (0x00000080&((data)<<7))
#define  HDMI_HDCP_PCR_km_clk_sel(data)                                          (0x00000040&((data)<<6))
#define  HDMI_HDCP_PCR_hdcp_vs_sel(data)                                         (0x00000020&((data)<<5))
#define  HDMI_HDCP_PCR_enc_tog(data)                                             (0x00000010&((data)<<4))
#define  HDMI_HDCP_PCR_avmute_dis(data)                                          (0x00000008&((data)<<3))
#define  HDMI_HDCP_PCR_dummy(data)                                               (0x00000004&((data)<<2))
#define  HDMI_HDCP_PCR_apai_type(data)                                           (0x00000002&((data)<<1))
#define  HDMI_HDCP_PCR_apai(data)                                                (0x00000001&(data))
#define  HDMI_HDCP_PCR_get_i2c_scl_dly_sel(data)                                 ((0x0F000000&(data))>>24)
#define  HDMI_HDCP_PCR_get_i2c_sda_dly_sel(data)                                 ((0x00F00000&(data))>>20)
#define  HDMI_HDCP_PCR_get_tune_up_down(data)                                    ((0x00020000&(data))>>17)
#define  HDMI_HDCP_PCR_get_tune_range(data)                                      ((0x0001FC00&(data))>>10)
#define  HDMI_HDCP_PCR_get_ddcdbnc(data)                                         ((0x00000200&(data))>>9)
#define  HDMI_HDCP_PCR_get_km_clk_sel_eco(data)                                  ((0x00000100&(data))>>8)
#define  HDMI_HDCP_PCR_get_dbnc_level_sel(data)                                  ((0x00000080&(data))>>7)
#define  HDMI_HDCP_PCR_get_km_clk_sel(data)                                      ((0x00000040&(data))>>6)
#define  HDMI_HDCP_PCR_get_hdcp_vs_sel(data)                                     ((0x00000020&(data))>>5)
#define  HDMI_HDCP_PCR_get_enc_tog(data)                                         ((0x00000010&(data))>>4)
#define  HDMI_HDCP_PCR_get_avmute_dis(data)                                      ((0x00000008&(data))>>3)
#define  HDMI_HDCP_PCR_get_dummy(data)                                           ((0x00000004&(data))>>2)
#define  HDMI_HDCP_PCR_get_apai_type(data)                                       ((0x00000002&(data))>>1)
#define  HDMI_HDCP_PCR_get_apai(data)                                            (0x00000001&(data))

#define  HDMI_HDCP_FLAG1                                                         0x1800D210
#define  HDMI_HDCP_FLAG1_reg_addr                                                "0xB800D210"
#define  HDMI_HDCP_FLAG1_reg                                                     0xB800D210
#define  HDMI_HDCP_FLAG1_inst_addr                                               "0x0081"
#define  set_HDMI_HDCP_FLAG1_reg(data)                                           (*((volatile unsigned int*)HDMI_HDCP_FLAG1_reg)=data)
#define  get_HDMI_HDCP_FLAG1_reg                                                 (*((volatile unsigned int*)HDMI_HDCP_FLAG1_reg))
#define  HDMI_HDCP_FLAG1_wr_aksv_flag_shift                                      (4)
#define  HDMI_HDCP_FLAG1_rd_ri_flag_shift                                        (3)
#define  HDMI_HDCP_FLAG1_rd_bksv_flag_shift                                      (2)
#define  HDMI_HDCP_FLAG1_dummy_shift                                             (0)
#define  HDMI_HDCP_FLAG1_wr_aksv_flag_mask                                       (0x00000010)
#define  HDMI_HDCP_FLAG1_rd_ri_flag_mask                                         (0x00000008)
#define  HDMI_HDCP_FLAG1_rd_bksv_flag_mask                                       (0x00000004)
#define  HDMI_HDCP_FLAG1_dummy_mask                                              (0x00000003)
#define  HDMI_HDCP_FLAG1_wr_aksv_flag(data)                                      (0x00000010&((data)<<4))
#define  HDMI_HDCP_FLAG1_rd_ri_flag(data)                                        (0x00000008&((data)<<3))
#define  HDMI_HDCP_FLAG1_rd_bksv_flag(data)                                      (0x00000004&((data)<<2))
#define  HDMI_HDCP_FLAG1_dummy(data)                                             (0x00000003&(data))
#define  HDMI_HDCP_FLAG1_get_wr_aksv_flag(data)                                  ((0x00000010&(data))>>4)
#define  HDMI_HDCP_FLAG1_get_rd_ri_flag(data)                                    ((0x00000008&(data))>>3)
#define  HDMI_HDCP_FLAG1_get_rd_bksv_flag(data)                                  ((0x00000004&(data))>>2)
#define  HDMI_HDCP_FLAG1_get_dummy(data)                                         (0x00000003&(data))

#define  HDMI_HDCP_FLAG2                                                         0x1800D214
#define  HDMI_HDCP_FLAG2_reg_addr                                                "0xB800D214"
#define  HDMI_HDCP_FLAG2_reg                                                     0xB800D214
#define  HDMI_HDCP_FLAG2_inst_addr                                               "0x0082"
#define  set_HDMI_HDCP_FLAG2_reg(data)                                           (*((volatile unsigned int*)HDMI_HDCP_FLAG2_reg)=data)
#define  get_HDMI_HDCP_FLAG2_reg                                                 (*((volatile unsigned int*)HDMI_HDCP_FLAG2_reg))
#define  HDMI_HDCP_FLAG2_irq_aksv_en_shift                                       (4)
#define  HDMI_HDCP_FLAG2_irq_ri_en_shift                                         (3)
#define  HDMI_HDCP_FLAG2_irq_bksv_en_shift                                       (2)
#define  HDMI_HDCP_FLAG2_dummy_shift                                             (0)
#define  HDMI_HDCP_FLAG2_irq_aksv_en_mask                                        (0x00000010)
#define  HDMI_HDCP_FLAG2_irq_ri_en_mask                                          (0x00000008)
#define  HDMI_HDCP_FLAG2_irq_bksv_en_mask                                        (0x00000004)
#define  HDMI_HDCP_FLAG2_dummy_mask                                              (0x00000003)
#define  HDMI_HDCP_FLAG2_irq_aksv_en(data)                                       (0x00000010&((data)<<4))
#define  HDMI_HDCP_FLAG2_irq_ri_en(data)                                         (0x00000008&((data)<<3))
#define  HDMI_HDCP_FLAG2_irq_bksv_en(data)                                       (0x00000004&((data)<<2))
#define  HDMI_HDCP_FLAG2_dummy(data)                                             (0x00000003&(data))
#define  HDMI_HDCP_FLAG2_get_irq_aksv_en(data)                                   ((0x00000010&(data))>>4)
#define  HDMI_HDCP_FLAG2_get_irq_ri_en(data)                                     ((0x00000008&(data))>>3)
#define  HDMI_HDCP_FLAG2_get_irq_bksv_en(data)                                   ((0x00000004&(data))>>2)
#define  HDMI_HDCP_FLAG2_get_dummy(data)                                         (0x00000003&(data))

#define  HDMI_HDCP_AP                                                            0x1800D218
#define  HDMI_HDCP_AP_reg_addr                                                   "0xB800D218"
#define  HDMI_HDCP_AP_reg                                                        0xB800D218
#define  HDMI_HDCP_AP_inst_addr                                                  "0x0083"
#define  set_HDMI_HDCP_AP_reg(data)                                              (*((volatile unsigned int*)HDMI_HDCP_AP_reg)=data)
#define  get_HDMI_HDCP_AP_reg                                                    (*((volatile unsigned int*)HDMI_HDCP_AP_reg))
#define  HDMI_HDCP_AP_ksvfifo_status_shift                                       (18)
#define  HDMI_HDCP_AP_dp_ksvfifo_ptr_shift                                       (8)
#define  HDMI_HDCP_AP_ap1_shift                                                  (0)
#define  HDMI_HDCP_AP_ksvfifo_status_mask                                        (0x00040000)
#define  HDMI_HDCP_AP_dp_ksvfifo_ptr_mask                                        (0x0003FF00)
#define  HDMI_HDCP_AP_ap1_mask                                                   (0x000000FF)
#define  HDMI_HDCP_AP_ksvfifo_status(data)                                       (0x00040000&((data)<<18))
#define  HDMI_HDCP_AP_dp_ksvfifo_ptr(data)                                       (0x0003FF00&((data)<<8))
#define  HDMI_HDCP_AP_ap1(data)                                                  (0x000000FF&(data))
#define  HDMI_HDCP_AP_get_ksvfifo_status(data)                                   ((0x00040000&(data))>>18)
#define  HDMI_HDCP_AP_get_dp_ksvfifo_ptr(data)                                   ((0x0003FF00&(data))>>8)
#define  HDMI_HDCP_AP_get_ap1(data)                                              (0x000000FF&(data))

#define  HDMI_HDCP_DP                                                            0x1800D21C
#define  HDMI_HDCP_DP_reg_addr                                                   "0xB800D21C"
#define  HDMI_HDCP_DP_reg                                                        0xB800D21C
#define  HDMI_HDCP_DP_inst_addr                                                  "0x0084"
#define  set_HDMI_HDCP_DP_reg(data)                                              (*((volatile unsigned int*)HDMI_HDCP_DP_reg)=data)
#define  get_HDMI_HDCP_DP_reg                                                    (*((volatile unsigned int*)HDMI_HDCP_DP_reg))
#define  HDMI_HDCP_DP_dp1_shift                                                  (0)
#define  HDMI_HDCP_DP_dp1_mask                                                   (0x000000FF)
#define  HDMI_HDCP_DP_dp1(data)                                                  (0x000000FF&(data))
#define  HDMI_HDCP_DP_get_dp1(data)                                              (0x000000FF&(data))

#define  HDMI_HDCP_2p2_CR                                                        0x1800D220
#define  HDMI_HDCP_2p2_CR_reg_addr                                               "0xB800D220"
#define  HDMI_HDCP_2p2_CR_reg                                                    0xB800D220
#define  HDMI_HDCP_2p2_CR_inst_addr                                              "0x0085"
#define  set_HDMI_HDCP_2p2_CR_reg(data)                                          (*((volatile unsigned int*)HDMI_HDCP_2p2_CR_reg)=data)
#define  get_HDMI_HDCP_2p2_CR_reg                                                (*((volatile unsigned int*)HDMI_HDCP_2p2_CR_reg))
#define  HDMI_HDCP_2p2_CR_dummy_shift                                            (27)
#define  HDMI_HDCP_2p2_CR_fn_auto_inc_shift                                      (26)
#define  HDMI_HDCP_2p2_CR_apply_cp_fn_shift                                      (25)
#define  HDMI_HDCP_2p2_CR_ks_encoded_shift                                       (24)
#define  HDMI_HDCP_2p2_CR_switch_state_shift                                     (12)
#define  HDMI_HDCP_2p2_CR_rpt_thr_unauth_shift                                   (11)
#define  HDMI_HDCP_2p2_CR_fw_mode_riv_shift                                      (10)
#define  HDMI_HDCP_2p2_CR_apply_state_shift                                      (9)
#define  HDMI_HDCP_2p2_CR_mspai_shift                                            (8)
#define  HDMI_HDCP_2p2_CR_new_auth_device_shift                                  (7)
#define  HDMI_HDCP_2p2_CR_verify_id_pass_shift                                   (6)
#define  HDMI_HDCP_2p2_CR_verify_id_done_shift                                   (5)
#define  HDMI_HDCP_2p2_CR_assemble_id_fail_shift                                 (4)
#define  HDMI_HDCP_2p2_CR_downstream_done_shift                                  (3)
#define  HDMI_HDCP_2p2_CR_ks_done_shift                                          (2)
#define  HDMI_HDCP_2p2_CR_switch_unauth_shift                                    (1)
#define  HDMI_HDCP_2p2_CR_hdcp_2p2_en_shift                                      (0)
#define  HDMI_HDCP_2p2_CR_dummy_mask                                             (0xF8000000)
#define  HDMI_HDCP_2p2_CR_fn_auto_inc_mask                                       (0x04000000)
#define  HDMI_HDCP_2p2_CR_apply_cp_fn_mask                                       (0x02000000)
#define  HDMI_HDCP_2p2_CR_ks_encoded_mask                                        (0x01000000)
#define  HDMI_HDCP_2p2_CR_switch_state_mask                                      (0x00FFF000)
#define  HDMI_HDCP_2p2_CR_rpt_thr_unauth_mask                                    (0x00000800)
#define  HDMI_HDCP_2p2_CR_fw_mode_riv_mask                                       (0x00000400)
#define  HDMI_HDCP_2p2_CR_apply_state_mask                                       (0x00000200)
#define  HDMI_HDCP_2p2_CR_mspai_mask                                             (0x00000100)
#define  HDMI_HDCP_2p2_CR_new_auth_device_mask                                   (0x00000080)
#define  HDMI_HDCP_2p2_CR_verify_id_pass_mask                                    (0x00000040)
#define  HDMI_HDCP_2p2_CR_verify_id_done_mask                                    (0x00000020)
#define  HDMI_HDCP_2p2_CR_assemble_id_fail_mask                                  (0x00000010)
#define  HDMI_HDCP_2p2_CR_downstream_done_mask                                   (0x00000008)
#define  HDMI_HDCP_2p2_CR_ks_done_mask                                           (0x00000004)
#define  HDMI_HDCP_2p2_CR_switch_unauth_mask                                     (0x00000002)
#define  HDMI_HDCP_2p2_CR_hdcp_2p2_en_mask                                       (0x00000001)
#define  HDMI_HDCP_2p2_CR_dummy(data)                                            (0xF8000000&((data)<<27))
#define  HDMI_HDCP_2p2_CR_fn_auto_inc(data)                                      (0x04000000&((data)<<26))
#define  HDMI_HDCP_2p2_CR_apply_cp_fn(data)                                      (0x02000000&((data)<<25))
#define  HDMI_HDCP_2p2_CR_ks_encoded(data)                                       (0x01000000&((data)<<24))
#define  HDMI_HDCP_2p2_CR_switch_state(data)                                     (0x00FFF000&((data)<<12))
#define  HDMI_HDCP_2p2_CR_rpt_thr_unauth(data)                                   (0x00000800&((data)<<11))
#define  HDMI_HDCP_2p2_CR_fw_mode_riv(data)                                      (0x00000400&((data)<<10))
#define  HDMI_HDCP_2p2_CR_apply_state(data)                                      (0x00000200&((data)<<9))
#define  HDMI_HDCP_2p2_CR_mspai(data)                                            (0x00000100&((data)<<8))
#define  HDMI_HDCP_2p2_CR_new_auth_device(data)                                  (0x00000080&((data)<<7))
#define  HDMI_HDCP_2p2_CR_verify_id_pass(data)                                   (0x00000040&((data)<<6))
#define  HDMI_HDCP_2p2_CR_verify_id_done(data)                                   (0x00000020&((data)<<5))
#define  HDMI_HDCP_2p2_CR_assemble_id_fail(data)                                 (0x00000010&((data)<<4))
#define  HDMI_HDCP_2p2_CR_downstream_done(data)                                  (0x00000008&((data)<<3))
#define  HDMI_HDCP_2p2_CR_ks_done(data)                                          (0x00000004&((data)<<2))
#define  HDMI_HDCP_2p2_CR_switch_unauth(data)                                    (0x00000002&((data)<<1))
#define  HDMI_HDCP_2p2_CR_hdcp_2p2_en(data)                                      (0x00000001&(data))
#define  HDMI_HDCP_2p2_CR_get_dummy(data)                                        ((0xF8000000&(data))>>27)
#define  HDMI_HDCP_2p2_CR_get_fn_auto_inc(data)                                  ((0x04000000&(data))>>26)
#define  HDMI_HDCP_2p2_CR_get_apply_cp_fn(data)                                  ((0x02000000&(data))>>25)
#define  HDMI_HDCP_2p2_CR_get_ks_encoded(data)                                   ((0x01000000&(data))>>24)
#define  HDMI_HDCP_2p2_CR_get_switch_state(data)                                 ((0x00FFF000&(data))>>12)
#define  HDMI_HDCP_2p2_CR_get_rpt_thr_unauth(data)                               ((0x00000800&(data))>>11)
#define  HDMI_HDCP_2p2_CR_get_fw_mode_riv(data)                                  ((0x00000400&(data))>>10)
#define  HDMI_HDCP_2p2_CR_get_apply_state(data)                                  ((0x00000200&(data))>>9)
#define  HDMI_HDCP_2p2_CR_get_mspai(data)                                        ((0x00000100&(data))>>8)
#define  HDMI_HDCP_2p2_CR_get_new_auth_device(data)                              ((0x00000080&(data))>>7)
#define  HDMI_HDCP_2p2_CR_get_verify_id_pass(data)                               ((0x00000040&(data))>>6)
#define  HDMI_HDCP_2p2_CR_get_verify_id_done(data)                               ((0x00000020&(data))>>5)
#define  HDMI_HDCP_2p2_CR_get_assemble_id_fail(data)                             ((0x00000010&(data))>>4)
#define  HDMI_HDCP_2p2_CR_get_downstream_done(data)                              ((0x00000008&(data))>>3)
#define  HDMI_HDCP_2p2_CR_get_ks_done(data)                                      ((0x00000004&(data))>>2)
#define  HDMI_HDCP_2p2_CR_get_switch_unauth(data)                                ((0x00000002&(data))>>1)
#define  HDMI_HDCP_2p2_CR_get_hdcp_2p2_en(data)                                  (0x00000001&(data))

#define  HDMI_HDCP_2p2_ks0                                                       0x1800D224
#define  HDMI_HDCP_2p2_ks0_reg_addr                                              "0xB800D224"
#define  HDMI_HDCP_2p2_ks0_reg                                                   0xB800D224
#define  HDMI_HDCP_2p2_ks0_inst_addr                                             "0x0086"
#define  set_HDMI_HDCP_2p2_ks0_reg(data)                                         (*((volatile unsigned int*)HDMI_HDCP_2p2_ks0_reg)=data)
#define  get_HDMI_HDCP_2p2_ks0_reg                                               (*((volatile unsigned int*)HDMI_HDCP_2p2_ks0_reg))
#define  HDMI_HDCP_2p2_ks0_ks_shift                                              (0)
#define  HDMI_HDCP_2p2_ks0_ks_mask                                               (0xFFFFFFFF)
#define  HDMI_HDCP_2p2_ks0_ks(data)                                              (0xFFFFFFFF&(data))
#define  HDMI_HDCP_2p2_ks0_get_ks(data)                                          (0xFFFFFFFF&(data))

#define  HDMI_HDCP_2p2_ks1                                                       0x1800D228
#define  HDMI_HDCP_2p2_ks1_reg_addr                                              "0xB800D228"
#define  HDMI_HDCP_2p2_ks1_reg                                                   0xB800D228
#define  HDMI_HDCP_2p2_ks1_inst_addr                                             "0x0087"
#define  set_HDMI_HDCP_2p2_ks1_reg(data)                                         (*((volatile unsigned int*)HDMI_HDCP_2p2_ks1_reg)=data)
#define  get_HDMI_HDCP_2p2_ks1_reg                                               (*((volatile unsigned int*)HDMI_HDCP_2p2_ks1_reg))
#define  HDMI_HDCP_2p2_ks1_ks_shift                                              (0)
#define  HDMI_HDCP_2p2_ks1_ks_mask                                               (0xFFFFFFFF)
#define  HDMI_HDCP_2p2_ks1_ks(data)                                              (0xFFFFFFFF&(data))
#define  HDMI_HDCP_2p2_ks1_get_ks(data)                                          (0xFFFFFFFF&(data))

#define  HDMI_HDCP_2p2_ks2                                                       0x1800D22C
#define  HDMI_HDCP_2p2_ks2_reg_addr                                              "0xB800D22C"
#define  HDMI_HDCP_2p2_ks2_reg                                                   0xB800D22C
#define  HDMI_HDCP_2p2_ks2_inst_addr                                             "0x0088"
#define  set_HDMI_HDCP_2p2_ks2_reg(data)                                         (*((volatile unsigned int*)HDMI_HDCP_2p2_ks2_reg)=data)
#define  get_HDMI_HDCP_2p2_ks2_reg                                               (*((volatile unsigned int*)HDMI_HDCP_2p2_ks2_reg))
#define  HDMI_HDCP_2p2_ks2_ks_shift                                              (0)
#define  HDMI_HDCP_2p2_ks2_ks_mask                                               (0xFFFFFFFF)
#define  HDMI_HDCP_2p2_ks2_ks(data)                                              (0xFFFFFFFF&(data))
#define  HDMI_HDCP_2p2_ks2_get_ks(data)                                          (0xFFFFFFFF&(data))

#define  HDMI_HDCP_2p2_ks3                                                       0x1800D230
#define  HDMI_HDCP_2p2_ks3_reg_addr                                              "0xB800D230"
#define  HDMI_HDCP_2p2_ks3_reg                                                   0xB800D230
#define  HDMI_HDCP_2p2_ks3_inst_addr                                             "0x0089"
#define  set_HDMI_HDCP_2p2_ks3_reg(data)                                         (*((volatile unsigned int*)HDMI_HDCP_2p2_ks3_reg)=data)
#define  get_HDMI_HDCP_2p2_ks3_reg                                               (*((volatile unsigned int*)HDMI_HDCP_2p2_ks3_reg))
#define  HDMI_HDCP_2p2_ks3_ks_shift                                              (0)
#define  HDMI_HDCP_2p2_ks3_ks_mask                                               (0xFFFFFFFF)
#define  HDMI_HDCP_2p2_ks3_ks(data)                                              (0xFFFFFFFF&(data))
#define  HDMI_HDCP_2p2_ks3_get_ks(data)                                          (0xFFFFFFFF&(data))

#define  HDMI_HDCP_2p2_lc0                                                       0x1800D234
#define  HDMI_HDCP_2p2_lc0_reg_addr                                              "0xB800D234"
#define  HDMI_HDCP_2p2_lc0_reg                                                   0xB800D234
#define  HDMI_HDCP_2p2_lc0_inst_addr                                             "0x008A"
#define  set_HDMI_HDCP_2p2_lc0_reg(data)                                         (*((volatile unsigned int*)HDMI_HDCP_2p2_lc0_reg)=data)
#define  get_HDMI_HDCP_2p2_lc0_reg                                               (*((volatile unsigned int*)HDMI_HDCP_2p2_lc0_reg))
#define  HDMI_HDCP_2p2_lc0_lc_shift                                              (0)
#define  HDMI_HDCP_2p2_lc0_lc_mask                                               (0xFFFFFFFF)
#define  HDMI_HDCP_2p2_lc0_lc(data)                                              (0xFFFFFFFF&(data))
#define  HDMI_HDCP_2p2_lc0_get_lc(data)                                          (0xFFFFFFFF&(data))

#define  HDMI_HDCP_2p2_lc1                                                       0x1800D238
#define  HDMI_HDCP_2p2_lc1_reg_addr                                              "0xB800D238"
#define  HDMI_HDCP_2p2_lc1_reg                                                   0xB800D238
#define  HDMI_HDCP_2p2_lc1_inst_addr                                             "0x008B"
#define  set_HDMI_HDCP_2p2_lc1_reg(data)                                         (*((volatile unsigned int*)HDMI_HDCP_2p2_lc1_reg)=data)
#define  get_HDMI_HDCP_2p2_lc1_reg                                               (*((volatile unsigned int*)HDMI_HDCP_2p2_lc1_reg))
#define  HDMI_HDCP_2p2_lc1_lc_shift                                              (0)
#define  HDMI_HDCP_2p2_lc1_lc_mask                                               (0xFFFFFFFF)
#define  HDMI_HDCP_2p2_lc1_lc(data)                                              (0xFFFFFFFF&(data))
#define  HDMI_HDCP_2p2_lc1_get_lc(data)                                          (0xFFFFFFFF&(data))

#define  HDMI_HDCP_2p2_lc2                                                       0x1800D23C
#define  HDMI_HDCP_2p2_lc2_reg_addr                                              "0xB800D23C"
#define  HDMI_HDCP_2p2_lc2_reg                                                   0xB800D23C
#define  HDMI_HDCP_2p2_lc2_inst_addr                                             "0x008C"
#define  set_HDMI_HDCP_2p2_lc2_reg(data)                                         (*((volatile unsigned int*)HDMI_HDCP_2p2_lc2_reg)=data)
#define  get_HDMI_HDCP_2p2_lc2_reg                                               (*((volatile unsigned int*)HDMI_HDCP_2p2_lc2_reg))
#define  HDMI_HDCP_2p2_lc2_lc_shift                                              (0)
#define  HDMI_HDCP_2p2_lc2_lc_mask                                               (0xFFFFFFFF)
#define  HDMI_HDCP_2p2_lc2_lc(data)                                              (0xFFFFFFFF&(data))
#define  HDMI_HDCP_2p2_lc2_get_lc(data)                                          (0xFFFFFFFF&(data))

#define  HDMI_HDCP_2p2_lc3                                                       0x1800D240
#define  HDMI_HDCP_2p2_lc3_reg_addr                                              "0xB800D240"
#define  HDMI_HDCP_2p2_lc3_reg                                                   0xB800D240
#define  HDMI_HDCP_2p2_lc3_inst_addr                                             "0x008D"
#define  set_HDMI_HDCP_2p2_lc3_reg(data)                                         (*((volatile unsigned int*)HDMI_HDCP_2p2_lc3_reg)=data)
#define  get_HDMI_HDCP_2p2_lc3_reg                                               (*((volatile unsigned int*)HDMI_HDCP_2p2_lc3_reg))
#define  HDMI_HDCP_2p2_lc3_lc_shift                                              (0)
#define  HDMI_HDCP_2p2_lc3_lc_mask                                               (0xFFFFFFFF)
#define  HDMI_HDCP_2p2_lc3_lc(data)                                              (0xFFFFFFFF&(data))
#define  HDMI_HDCP_2p2_lc3_get_lc(data)                                          (0xFFFFFFFF&(data))

#define  HDMI_HDCP_2p2_riv0                                                      0x1800D244
#define  HDMI_HDCP_2p2_riv0_reg_addr                                             "0xB800D244"
#define  HDMI_HDCP_2p2_riv0_reg                                                  0xB800D244
#define  HDMI_HDCP_2p2_riv0_inst_addr                                            "0x008E"
#define  set_HDMI_HDCP_2p2_riv0_reg(data)                                        (*((volatile unsigned int*)HDMI_HDCP_2p2_riv0_reg)=data)
#define  get_HDMI_HDCP_2p2_riv0_reg                                              (*((volatile unsigned int*)HDMI_HDCP_2p2_riv0_reg))
#define  HDMI_HDCP_2p2_riv0_riv_shift                                            (0)
#define  HDMI_HDCP_2p2_riv0_riv_mask                                             (0xFFFFFFFF)
#define  HDMI_HDCP_2p2_riv0_riv(data)                                            (0xFFFFFFFF&(data))
#define  HDMI_HDCP_2p2_riv0_get_riv(data)                                        (0xFFFFFFFF&(data))

#define  HDMI_HDCP_2p2_riv1                                                      0x1800D248
#define  HDMI_HDCP_2p2_riv1_reg_addr                                             "0xB800D248"
#define  HDMI_HDCP_2p2_riv1_reg                                                  0xB800D248
#define  HDMI_HDCP_2p2_riv1_inst_addr                                            "0x008F"
#define  set_HDMI_HDCP_2p2_riv1_reg(data)                                        (*((volatile unsigned int*)HDMI_HDCP_2p2_riv1_reg)=data)
#define  get_HDMI_HDCP_2p2_riv1_reg                                              (*((volatile unsigned int*)HDMI_HDCP_2p2_riv1_reg))
#define  HDMI_HDCP_2p2_riv1_riv_shift                                            (0)
#define  HDMI_HDCP_2p2_riv1_riv_mask                                             (0xFFFFFFFF)
#define  HDMI_HDCP_2p2_riv1_riv(data)                                            (0xFFFFFFFF&(data))
#define  HDMI_HDCP_2p2_riv1_get_riv(data)                                        (0xFFFFFFFF&(data))

#define  HDMI_HDCP_2p2_SR0                                                       0x1800D24C
#define  HDMI_HDCP_2p2_SR0_reg_addr                                              "0xB800D24C"
#define  HDMI_HDCP_2p2_SR0_reg                                                   0xB800D24C
#define  HDMI_HDCP_2p2_SR0_inst_addr                                             "0x0090"
#define  set_HDMI_HDCP_2p2_SR0_reg(data)                                         (*((volatile unsigned int*)HDMI_HDCP_2p2_SR0_reg)=data)
#define  get_HDMI_HDCP_2p2_SR0_reg                                               (*((volatile unsigned int*)HDMI_HDCP_2p2_SR0_reg))
#define  HDMI_HDCP_2p2_SR0_frame_number_shift                                    (20)
#define  HDMI_HDCP_2p2_SR0_irq_fn_compare_fail_shift                             (19)
#define  HDMI_HDCP_2p2_SR0_irq_crc_fail_shift                                    (18)
#define  HDMI_HDCP_2p2_SR0_irq_no_cp_packet_shift                                (17)
#define  HDMI_HDCP_2p2_SR0_irq_msg_overwrite_shift                               (16)
#define  HDMI_HDCP_2p2_SR0_irq_unauth_chg_shift                                  (15)
#define  HDMI_HDCP_2p2_SR0_irq_state_chg_shift                                   (14)
#define  HDMI_HDCP_2p2_SR0_irq_rd_msg_done_shift                                 (13)
#define  HDMI_HDCP_2p2_SR0_irq_wr_msg_done_shift                                 (12)
#define  HDMI_HDCP_2p2_SR0_state_shift                                           (0)
#define  HDMI_HDCP_2p2_SR0_frame_number_mask                                     (0x0FF00000)
#define  HDMI_HDCP_2p2_SR0_irq_fn_compare_fail_mask                              (0x00080000)
#define  HDMI_HDCP_2p2_SR0_irq_crc_fail_mask                                     (0x00040000)
#define  HDMI_HDCP_2p2_SR0_irq_no_cp_packet_mask                                 (0x00020000)
#define  HDMI_HDCP_2p2_SR0_irq_msg_overwrite_mask                                (0x00010000)
#define  HDMI_HDCP_2p2_SR0_irq_unauth_chg_mask                                   (0x00008000)
#define  HDMI_HDCP_2p2_SR0_irq_state_chg_mask                                    (0x00004000)
#define  HDMI_HDCP_2p2_SR0_irq_rd_msg_done_mask                                  (0x00002000)
#define  HDMI_HDCP_2p2_SR0_irq_wr_msg_done_mask                                  (0x00001000)
#define  HDMI_HDCP_2p2_SR0_state_mask                                            (0x00000FFF)
#define  HDMI_HDCP_2p2_SR0_frame_number(data)                                    (0x0FF00000&((data)<<20))
#define  HDMI_HDCP_2p2_SR0_irq_fn_compare_fail(data)                             (0x00080000&((data)<<19))
#define  HDMI_HDCP_2p2_SR0_irq_crc_fail(data)                                    (0x00040000&((data)<<18))
#define  HDMI_HDCP_2p2_SR0_irq_no_cp_packet(data)                                (0x00020000&((data)<<17))
#define  HDMI_HDCP_2p2_SR0_irq_msg_overwrite(data)                               (0x00010000&((data)<<16))
#define  HDMI_HDCP_2p2_SR0_irq_unauth_chg(data)                                  (0x00008000&((data)<<15))
#define  HDMI_HDCP_2p2_SR0_irq_state_chg(data)                                   (0x00004000&((data)<<14))
#define  HDMI_HDCP_2p2_SR0_irq_rd_msg_done(data)                                 (0x00002000&((data)<<13))
#define  HDMI_HDCP_2p2_SR0_irq_wr_msg_done(data)                                 (0x00001000&((data)<<12))
#define  HDMI_HDCP_2p2_SR0_state(data)                                           (0x00000FFF&(data))
#define  HDMI_HDCP_2p2_SR0_get_frame_number(data)                                ((0x0FF00000&(data))>>20)
#define  HDMI_HDCP_2p2_SR0_get_irq_fn_compare_fail(data)                         ((0x00080000&(data))>>19)
#define  HDMI_HDCP_2p2_SR0_get_irq_crc_fail(data)                                ((0x00040000&(data))>>18)
#define  HDMI_HDCP_2p2_SR0_get_irq_no_cp_packet(data)                            ((0x00020000&(data))>>17)
#define  HDMI_HDCP_2p2_SR0_get_irq_msg_overwrite(data)                           ((0x00010000&(data))>>16)
#define  HDMI_HDCP_2p2_SR0_get_irq_unauth_chg(data)                              ((0x00008000&(data))>>15)
#define  HDMI_HDCP_2p2_SR0_get_irq_state_chg(data)                               ((0x00004000&(data))>>14)
#define  HDMI_HDCP_2p2_SR0_get_irq_rd_msg_done(data)                             ((0x00002000&(data))>>13)
#define  HDMI_HDCP_2p2_SR0_get_irq_wr_msg_done(data)                             ((0x00001000&(data))>>12)
#define  HDMI_HDCP_2p2_SR0_get_state(data)                                       (0x00000FFF&(data))

#define  HDMI_HDCP_2p2_SR1                                                       0x1800D250
#define  HDMI_HDCP_2p2_SR1_reg_addr                                              "0xB800D250"
#define  HDMI_HDCP_2p2_SR1_reg                                                   0xB800D250
#define  HDMI_HDCP_2p2_SR1_inst_addr                                             "0x0091"
#define  set_HDMI_HDCP_2p2_SR1_reg(data)                                         (*((volatile unsigned int*)HDMI_HDCP_2p2_SR1_reg)=data)
#define  get_HDMI_HDCP_2p2_SR1_reg                                               (*((volatile unsigned int*)HDMI_HDCP_2p2_SR1_reg))
#define  HDMI_HDCP_2p2_SR1_crc_fail_wd_en_shift                                  (9)
#define  HDMI_HDCP_2p2_SR1_no_cp_packet_wd_en_shift                              (8)
#define  HDMI_HDCP_2p2_SR1_irq_fn_compare_fail_en_shift                          (7)
#define  HDMI_HDCP_2p2_SR1_irq_crc_fail_en_shift                                 (6)
#define  HDMI_HDCP_2p2_SR1_irq_no_cp_packet_en_shift                             (5)
#define  HDMI_HDCP_2p2_SR1_irq_msg_overwrite_en_shift                            (4)
#define  HDMI_HDCP_2p2_SR1_irq_unauth_chg_en_shift                               (3)
#define  HDMI_HDCP_2p2_SR1_irq_state_chg_en_shift                                (2)
#define  HDMI_HDCP_2p2_SR1_irq_rd_msg_done_en_shift                              (1)
#define  HDMI_HDCP_2p2_SR1_irq_wr_msg_done_en_shift                              (0)
#define  HDMI_HDCP_2p2_SR1_crc_fail_wd_en_mask                                   (0x00000200)
#define  HDMI_HDCP_2p2_SR1_no_cp_packet_wd_en_mask                               (0x00000100)
#define  HDMI_HDCP_2p2_SR1_irq_fn_compare_fail_en_mask                           (0x00000080)
#define  HDMI_HDCP_2p2_SR1_irq_crc_fail_en_mask                                  (0x00000040)
#define  HDMI_HDCP_2p2_SR1_irq_no_cp_packet_en_mask                              (0x00000020)
#define  HDMI_HDCP_2p2_SR1_irq_msg_overwrite_en_mask                             (0x00000010)
#define  HDMI_HDCP_2p2_SR1_irq_unauth_chg_en_mask                                (0x00000008)
#define  HDMI_HDCP_2p2_SR1_irq_state_chg_en_mask                                 (0x00000004)
#define  HDMI_HDCP_2p2_SR1_irq_rd_msg_done_en_mask                               (0x00000002)
#define  HDMI_HDCP_2p2_SR1_irq_wr_msg_done_en_mask                               (0x00000001)
#define  HDMI_HDCP_2p2_SR1_crc_fail_wd_en(data)                                  (0x00000200&((data)<<9))
#define  HDMI_HDCP_2p2_SR1_no_cp_packet_wd_en(data)                              (0x00000100&((data)<<8))
#define  HDMI_HDCP_2p2_SR1_irq_fn_compare_fail_en(data)                          (0x00000080&((data)<<7))
#define  HDMI_HDCP_2p2_SR1_irq_crc_fail_en(data)                                 (0x00000040&((data)<<6))
#define  HDMI_HDCP_2p2_SR1_irq_no_cp_packet_en(data)                             (0x00000020&((data)<<5))
#define  HDMI_HDCP_2p2_SR1_irq_msg_overwrite_en(data)                            (0x00000010&((data)<<4))
#define  HDMI_HDCP_2p2_SR1_irq_unauth_chg_en(data)                               (0x00000008&((data)<<3))
#define  HDMI_HDCP_2p2_SR1_irq_state_chg_en(data)                                (0x00000004&((data)<<2))
#define  HDMI_HDCP_2p2_SR1_irq_rd_msg_done_en(data)                              (0x00000002&((data)<<1))
#define  HDMI_HDCP_2p2_SR1_irq_wr_msg_done_en(data)                              (0x00000001&(data))
#define  HDMI_HDCP_2p2_SR1_get_crc_fail_wd_en(data)                              ((0x00000200&(data))>>9)
#define  HDMI_HDCP_2p2_SR1_get_no_cp_packet_wd_en(data)                          ((0x00000100&(data))>>8)
#define  HDMI_HDCP_2p2_SR1_get_irq_fn_compare_fail_en(data)                      ((0x00000080&(data))>>7)
#define  HDMI_HDCP_2p2_SR1_get_irq_crc_fail_en(data)                             ((0x00000040&(data))>>6)
#define  HDMI_HDCP_2p2_SR1_get_irq_no_cp_packet_en(data)                         ((0x00000020&(data))>>5)
#define  HDMI_HDCP_2p2_SR1_get_irq_msg_overwrite_en(data)                        ((0x00000010&(data))>>4)
#define  HDMI_HDCP_2p2_SR1_get_irq_unauth_chg_en(data)                           ((0x00000008&(data))>>3)
#define  HDMI_HDCP_2p2_SR1_get_irq_state_chg_en(data)                            ((0x00000004&(data))>>2)
#define  HDMI_HDCP_2p2_SR1_get_irq_rd_msg_done_en(data)                          ((0x00000002&(data))>>1)
#define  HDMI_HDCP_2p2_SR1_get_irq_wr_msg_done_en(data)                          (0x00000001&(data))

#define  HDMI_HDCP_MSAP                                                          0x1800D254
#define  HDMI_HDCP_MSAP_reg_addr                                                 "0xB800D254"
#define  HDMI_HDCP_MSAP_reg                                                      0xB800D254
#define  HDMI_HDCP_MSAP_inst_addr                                                "0x0092"
#define  set_HDMI_HDCP_MSAP_reg(data)                                            (*((volatile unsigned int*)HDMI_HDCP_MSAP_reg)=data)
#define  get_HDMI_HDCP_MSAP_reg                                                  (*((volatile unsigned int*)HDMI_HDCP_MSAP_reg))
#define  HDMI_HDCP_MSAP_ap1_shift                                                (0)
#define  HDMI_HDCP_MSAP_ap1_mask                                                 (0x000003FF)
#define  HDMI_HDCP_MSAP_ap1(data)                                                (0x000003FF&(data))
#define  HDMI_HDCP_MSAP_get_ap1(data)                                            (0x000003FF&(data))

#define  HDMI_HDCP_MSDP                                                          0x1800D258
#define  HDMI_HDCP_MSDP_reg_addr                                                 "0xB800D258"
#define  HDMI_HDCP_MSDP_reg                                                      0xB800D258
#define  HDMI_HDCP_MSDP_inst_addr                                                "0x0093"
#define  set_HDMI_HDCP_MSDP_reg(data)                                            (*((volatile unsigned int*)HDMI_HDCP_MSDP_reg)=data)
#define  get_HDMI_HDCP_MSDP_reg                                                  (*((volatile unsigned int*)HDMI_HDCP_MSDP_reg))
#define  HDMI_HDCP_MSDP_dp1_shift                                                (0)
#define  HDMI_HDCP_MSDP_dp1_mask                                                 (0x000000FF)
#define  HDMI_HDCP_MSDP_dp1(data)                                                (0x000000FF&(data))
#define  HDMI_HDCP_MSDP_get_dp1(data)                                            (0x000000FF&(data))

#define  HDMI_HDMI_CMCR                                                          0x1800D300
#define  HDMI_HDMI_CMCR_reg_addr                                                 "0xB800D300"
#define  HDMI_HDMI_CMCR_reg                                                      0xB800D300
#define  HDMI_HDMI_CMCR_inst_addr                                                "0x0094"
#define  set_HDMI_HDMI_CMCR_reg(data)                                            (*((volatile unsigned int*)HDMI_HDMI_CMCR_reg)=data)
#define  get_HDMI_HDMI_CMCR_reg                                                  (*((volatile unsigned int*)HDMI_HDMI_CMCR_reg))
#define  HDMI_HDMI_CMCR_icmux_shift                                              (7)
#define  HDMI_HDMI_CMCR_ocs_shift                                                (5)
#define  HDMI_HDMI_CMCR_dbdcb_shift                                              (4)
#define  HDMI_HDMI_CMCR_dummy_shift                                              (0)
#define  HDMI_HDMI_CMCR_icmux_mask                                               (0x00000080)
#define  HDMI_HDMI_CMCR_ocs_mask                                                 (0x00000060)
#define  HDMI_HDMI_CMCR_dbdcb_mask                                               (0x00000010)
#define  HDMI_HDMI_CMCR_dummy_mask                                               (0x0000000F)
#define  HDMI_HDMI_CMCR_icmux(data)                                              (0x00000080&((data)<<7))
#define  HDMI_HDMI_CMCR_ocs(data)                                                (0x00000060&((data)<<5))
#define  HDMI_HDMI_CMCR_dbdcb(data)                                              (0x00000010&((data)<<4))
#define  HDMI_HDMI_CMCR_dummy(data)                                              (0x0000000F&(data))
#define  HDMI_HDMI_CMCR_get_icmux(data)                                          ((0x00000080&(data))>>7)
#define  HDMI_HDMI_CMCR_get_ocs(data)                                            ((0x00000060&(data))>>5)
#define  HDMI_HDMI_CMCR_get_dbdcb(data)                                          ((0x00000010&(data))>>4)
#define  HDMI_HDMI_CMCR_get_dummy(data)                                          (0x0000000F&(data))

#define  HDMI_HDMI_MCAPR                                                         0x1800D304
#define  HDMI_HDMI_MCAPR_reg_addr                                                "0xB800D304"
#define  HDMI_HDMI_MCAPR_reg                                                     0xB800D304
#define  HDMI_HDMI_MCAPR_inst_addr                                               "0x0095"
#define  set_HDMI_HDMI_MCAPR_reg(data)                                           (*((volatile unsigned int*)HDMI_HDMI_MCAPR_reg)=data)
#define  get_HDMI_HDMI_MCAPR_reg                                                 (*((volatile unsigned int*)HDMI_HDMI_MCAPR_reg))
#define  HDMI_HDMI_MCAPR_dummy_shift                                             (0)
#define  HDMI_HDMI_MCAPR_dummy_mask                                              (0x000000FF)
#define  HDMI_HDMI_MCAPR_dummy(data)                                             (0x000000FF&(data))
#define  HDMI_HDMI_MCAPR_get_dummy(data)                                         (0x000000FF&(data))

#define  HDMI_HDMI_SCAPR                                                         0x1800D308
#define  HDMI_HDMI_SCAPR_reg_addr                                                "0xB800D308"
#define  HDMI_HDMI_SCAPR_reg                                                     0xB800D308
#define  HDMI_HDMI_SCAPR_inst_addr                                               "0x0096"
#define  set_HDMI_HDMI_SCAPR_reg(data)                                           (*((volatile unsigned int*)HDMI_HDMI_SCAPR_reg)=data)
#define  get_HDMI_HDMI_SCAPR_reg                                                 (*((volatile unsigned int*)HDMI_HDMI_SCAPR_reg))
#define  HDMI_HDMI_SCAPR_s1_code_msb_r_shift                                     (17)
#define  HDMI_HDMI_SCAPR_slc_r_shift                                             (16)
#define  HDMI_HDMI_SCAPR_sc_r_shift                                              (9)
#define  HDMI_HDMI_SCAPR_s1_code_msb_shift                                       (8)
#define  HDMI_HDMI_SCAPR_slc_shift                                               (7)
#define  HDMI_HDMI_SCAPR_sc_shift                                                (0)
#define  HDMI_HDMI_SCAPR_s1_code_msb_r_mask                                      (0x00020000)
#define  HDMI_HDMI_SCAPR_slc_r_mask                                              (0x00010000)
#define  HDMI_HDMI_SCAPR_sc_r_mask                                               (0x0000FE00)
#define  HDMI_HDMI_SCAPR_s1_code_msb_mask                                        (0x00000100)
#define  HDMI_HDMI_SCAPR_slc_mask                                                (0x00000080)
#define  HDMI_HDMI_SCAPR_sc_mask                                                 (0x0000007F)
#define  HDMI_HDMI_SCAPR_s1_code_msb_r(data)                                     (0x00020000&((data)<<17))
#define  HDMI_HDMI_SCAPR_slc_r(data)                                             (0x00010000&((data)<<16))
#define  HDMI_HDMI_SCAPR_sc_r(data)                                              (0x0000FE00&((data)<<9))
#define  HDMI_HDMI_SCAPR_s1_code_msb(data)                                       (0x00000100&((data)<<8))
#define  HDMI_HDMI_SCAPR_slc(data)                                               (0x00000080&((data)<<7))
#define  HDMI_HDMI_SCAPR_sc(data)                                                (0x0000007F&(data))
#define  HDMI_HDMI_SCAPR_get_s1_code_msb_r(data)                                 ((0x00020000&(data))>>17)
#define  HDMI_HDMI_SCAPR_get_slc_r(data)                                         ((0x00010000&(data))>>16)
#define  HDMI_HDMI_SCAPR_get_sc_r(data)                                          ((0x0000FE00&(data))>>9)
#define  HDMI_HDMI_SCAPR_get_s1_code_msb(data)                                   ((0x00000100&(data))>>8)
#define  HDMI_HDMI_SCAPR_get_slc(data)                                           ((0x00000080&(data))>>7)
#define  HDMI_HDMI_SCAPR_get_sc(data)                                            (0x0000007F&(data))

#define  HDMI_HDMI_DCAPR0                                                        0x1800D30C
#define  HDMI_HDMI_DCAPR0_reg_addr                                               "0xB800D30C"
#define  HDMI_HDMI_DCAPR0_reg                                                    0xB800D30C
#define  HDMI_HDMI_DCAPR0_inst_addr                                              "0x0097"
#define  set_HDMI_HDMI_DCAPR0_reg(data)                                          (*((volatile unsigned int*)HDMI_HDMI_DCAPR0_reg)=data)
#define  get_HDMI_HDMI_DCAPR0_reg                                                (*((volatile unsigned int*)HDMI_HDMI_DCAPR0_reg))
#define  HDMI_HDMI_DCAPR0_dcaprh_shift                                           (8)
#define  HDMI_HDMI_DCAPR0_dcaprl_shift                                           (0)
#define  HDMI_HDMI_DCAPR0_dcaprh_mask                                            (0x0000FF00)
#define  HDMI_HDMI_DCAPR0_dcaprl_mask                                            (0x000000FF)
#define  HDMI_HDMI_DCAPR0_dcaprh(data)                                           (0x0000FF00&((data)<<8))
#define  HDMI_HDMI_DCAPR0_dcaprl(data)                                           (0x000000FF&(data))
#define  HDMI_HDMI_DCAPR0_get_dcaprh(data)                                       ((0x0000FF00&(data))>>8)
#define  HDMI_HDMI_DCAPR0_get_dcaprl(data)                                       (0x000000FF&(data))

#define  HDMI_HDMI_PSCR                                                          0x1800D310
#define  HDMI_HDMI_PSCR_reg_addr                                                 "0xB800D310"
#define  HDMI_HDMI_PSCR_reg                                                      0xB800D310
#define  HDMI_HDMI_PSCR_inst_addr                                                "0x0098"
#define  set_HDMI_HDMI_PSCR_reg(data)                                            (*((volatile unsigned int*)HDMI_HDMI_PSCR_reg)=data)
#define  get_HDMI_HDMI_PSCR_reg                                                  (*((volatile unsigned int*)HDMI_HDMI_PSCR_reg))
#define  HDMI_HDMI_PSCR_fdint_shift                                              (5)
#define  HDMI_HDMI_PSCR_etcn_shift                                               (4)
#define  HDMI_HDMI_PSCR_etfd_shift                                               (3)
#define  HDMI_HDMI_PSCR_etfbc_shift                                              (2)
#define  HDMI_HDMI_PSCR_pecs_shift                                               (0)
#define  HDMI_HDMI_PSCR_fdint_mask                                               (0x000000E0)
#define  HDMI_HDMI_PSCR_etcn_mask                                                (0x00000010)
#define  HDMI_HDMI_PSCR_etfd_mask                                                (0x00000008)
#define  HDMI_HDMI_PSCR_etfbc_mask                                               (0x00000004)
#define  HDMI_HDMI_PSCR_pecs_mask                                                (0x00000003)
#define  HDMI_HDMI_PSCR_fdint(data)                                              (0x000000E0&((data)<<5))
#define  HDMI_HDMI_PSCR_etcn(data)                                               (0x00000010&((data)<<4))
#define  HDMI_HDMI_PSCR_etfd(data)                                               (0x00000008&((data)<<3))
#define  HDMI_HDMI_PSCR_etfbc(data)                                              (0x00000004&((data)<<2))
#define  HDMI_HDMI_PSCR_pecs(data)                                               (0x00000003&(data))
#define  HDMI_HDMI_PSCR_get_fdint(data)                                          ((0x000000E0&(data))>>5)
#define  HDMI_HDMI_PSCR_get_etcn(data)                                           ((0x00000010&(data))>>4)
#define  HDMI_HDMI_PSCR_get_etfd(data)                                           ((0x00000008&(data))>>3)
#define  HDMI_HDMI_PSCR_get_etfbc(data)                                          ((0x00000004&(data))>>2)
#define  HDMI_HDMI_PSCR_get_pecs(data)                                           (0x00000003&(data))

#define  HDMI_HDMI_AFDD                                                          0x1800D31C
#define  HDMI_HDMI_AFDD_reg_addr                                                 "0xB800D31C"
#define  HDMI_HDMI_AFDD_reg                                                      0xB800D31C
#define  HDMI_HDMI_AFDD_inst_addr                                                "0x0099"
#define  set_HDMI_HDMI_AFDD_reg(data)                                            (*((volatile unsigned int*)HDMI_HDMI_AFDD_reg)=data)
#define  get_HDMI_HDMI_AFDD_reg                                                  (*((volatile unsigned int*)HDMI_HDMI_AFDD_reg))
#define  HDMI_HDMI_AFDD_mfddf_shift                                              (24)
#define  HDMI_HDMI_AFDD_mfddr_shift                                              (16)
#define  HDMI_HDMI_AFDD_fddf_shift                                               (8)
#define  HDMI_HDMI_AFDD_fddr_shift                                               (0)
#define  HDMI_HDMI_AFDD_mfddf_mask                                               (0xFF000000)
#define  HDMI_HDMI_AFDD_mfddr_mask                                               (0x00FF0000)
#define  HDMI_HDMI_AFDD_fddf_mask                                                (0x0000FF00)
#define  HDMI_HDMI_AFDD_fddr_mask                                                (0x000000FF)
#define  HDMI_HDMI_AFDD_mfddf(data)                                              (0xFF000000&((data)<<24))
#define  HDMI_HDMI_AFDD_mfddr(data)                                              (0x00FF0000&((data)<<16))
#define  HDMI_HDMI_AFDD_fddf(data)                                               (0x0000FF00&((data)<<8))
#define  HDMI_HDMI_AFDD_fddr(data)                                               (0x000000FF&(data))
#define  HDMI_HDMI_AFDD_get_mfddf(data)                                          ((0xFF000000&(data))>>24)
#define  HDMI_HDMI_AFDD_get_mfddr(data)                                          ((0x00FF0000&(data))>>16)
#define  HDMI_HDMI_AFDD_get_fddf(data)                                           ((0x0000FF00&(data))>>8)
#define  HDMI_HDMI_AFDD_get_fddr(data)                                           (0x000000FF&(data))

#define  HDMI_HDMI_FTR                                                           0x1800D320
#define  HDMI_HDMI_FTR_reg_addr                                                  "0xB800D320"
#define  HDMI_HDMI_FTR_reg                                                       0xB800D320
#define  HDMI_HDMI_FTR_inst_addr                                                 "0x009A"
#define  set_HDMI_HDMI_FTR_reg(data)                                             (*((volatile unsigned int*)HDMI_HDMI_FTR_reg)=data)
#define  get_HDMI_HDMI_FTR_reg                                                   (*((volatile unsigned int*)HDMI_HDMI_FTR_reg))
#define  HDMI_HDMI_FTR_tl2der_shift                                              (6)
#define  HDMI_HDMI_FTR_tl2def_shift                                              (4)
#define  HDMI_HDMI_FTR_tt_shift                                                  (0)
#define  HDMI_HDMI_FTR_tl2der_mask                                               (0x000000C0)
#define  HDMI_HDMI_FTR_tl2def_mask                                               (0x00000030)
#define  HDMI_HDMI_FTR_tt_mask                                                   (0x0000000F)
#define  HDMI_HDMI_FTR_tl2der(data)                                              (0x000000C0&((data)<<6))
#define  HDMI_HDMI_FTR_tl2def(data)                                              (0x00000030&((data)<<4))
#define  HDMI_HDMI_FTR_tt(data)                                                  (0x0000000F&(data))
#define  HDMI_HDMI_FTR_get_tl2der(data)                                          ((0x000000C0&(data))>>6)
#define  HDMI_HDMI_FTR_get_tl2def(data)                                          ((0x00000030&(data))>>4)
#define  HDMI_HDMI_FTR_get_tt(data)                                              (0x0000000F&(data))

#define  HDMI_HDMI_FBR                                                           0x1800D324
#define  HDMI_HDMI_FBR_reg_addr                                                  "0xB800D324"
#define  HDMI_HDMI_FBR_reg                                                       0xB800D324
#define  HDMI_HDMI_FBR_inst_addr                                                 "0x009B"
#define  set_HDMI_HDMI_FBR_reg(data)                                             (*((volatile unsigned int*)HDMI_HDMI_FBR_reg)=data)
#define  get_HDMI_HDMI_FBR_reg                                                   (*((volatile unsigned int*)HDMI_HDMI_FBR_reg))
#define  HDMI_HDMI_FBR_tfd_shift                                                 (3)
#define  HDMI_HDMI_FBR_bad_shift                                                 (0)
#define  HDMI_HDMI_FBR_tfd_mask                                                  (0x000000F8)
#define  HDMI_HDMI_FBR_bad_mask                                                  (0x00000007)
#define  HDMI_HDMI_FBR_tfd(data)                                                 (0x000000F8&((data)<<3))
#define  HDMI_HDMI_FBR_bad(data)                                                 (0x00000007&(data))
#define  HDMI_HDMI_FBR_get_tfd(data)                                             ((0x000000F8&(data))>>3)
#define  HDMI_HDMI_FBR_get_bad(data)                                             (0x00000007&(data))

#define  HDMI_HDMI_ICPSNCR0                                                      0x1800D328
#define  HDMI_HDMI_ICPSNCR0_reg_addr                                             "0xB800D328"
#define  HDMI_HDMI_ICPSNCR0_reg                                                  0xB800D328
#define  HDMI_HDMI_ICPSNCR0_inst_addr                                            "0x009C"
#define  set_HDMI_HDMI_ICPSNCR0_reg(data)                                        (*((volatile unsigned int*)HDMI_HDMI_ICPSNCR0_reg)=data)
#define  get_HDMI_HDMI_ICPSNCR0_reg                                              (*((volatile unsigned int*)HDMI_HDMI_ICPSNCR0_reg))
#define  HDMI_HDMI_ICPSNCR0_ich_shift                                            (8)
#define  HDMI_HDMI_ICPSNCR0_icl_shift                                            (0)
#define  HDMI_HDMI_ICPSNCR0_ich_mask                                             (0x0000FF00)
#define  HDMI_HDMI_ICPSNCR0_icl_mask                                             (0x000000FF)
#define  HDMI_HDMI_ICPSNCR0_ich(data)                                            (0x0000FF00&((data)<<8))
#define  HDMI_HDMI_ICPSNCR0_icl(data)                                            (0x000000FF&(data))
#define  HDMI_HDMI_ICPSNCR0_get_ich(data)                                        ((0x0000FF00&(data))>>8)
#define  HDMI_HDMI_ICPSNCR0_get_icl(data)                                        (0x000000FF&(data))

#define  HDMI_HDMI_PCPSNCR0                                                      0x1800D32C
#define  HDMI_HDMI_PCPSNCR0_reg_addr                                             "0xB800D32C"
#define  HDMI_HDMI_PCPSNCR0_reg                                                  0xB800D32C
#define  HDMI_HDMI_PCPSNCR0_inst_addr                                            "0x009D"
#define  set_HDMI_HDMI_PCPSNCR0_reg(data)                                        (*((volatile unsigned int*)HDMI_HDMI_PCPSNCR0_reg)=data)
#define  get_HDMI_HDMI_PCPSNCR0_reg                                              (*((volatile unsigned int*)HDMI_HDMI_PCPSNCR0_reg))
#define  HDMI_HDMI_PCPSNCR0_pch_shift                                            (8)
#define  HDMI_HDMI_PCPSNCR0_pcl_shift                                            (0)
#define  HDMI_HDMI_PCPSNCR0_pch_mask                                             (0x0000FF00)
#define  HDMI_HDMI_PCPSNCR0_pcl_mask                                             (0x000000FF)
#define  HDMI_HDMI_PCPSNCR0_pch(data)                                            (0x0000FF00&((data)<<8))
#define  HDMI_HDMI_PCPSNCR0_pcl(data)                                            (0x000000FF&(data))
#define  HDMI_HDMI_PCPSNCR0_get_pch(data)                                        ((0x0000FF00&(data))>>8)
#define  HDMI_HDMI_PCPSNCR0_get_pcl(data)                                        (0x000000FF&(data))

#define  HDMI_HDMI_ICTPSR0                                                       0x1800D330
#define  HDMI_HDMI_ICTPSR0_reg_addr                                              "0xB800D330"
#define  HDMI_HDMI_ICTPSR0_reg                                                   0xB800D330
#define  HDMI_HDMI_ICTPSR0_inst_addr                                             "0x009E"
#define  set_HDMI_HDMI_ICTPSR0_reg(data)                                         (*((volatile unsigned int*)HDMI_HDMI_ICTPSR0_reg)=data)
#define  get_HDMI_HDMI_ICTPSR0_reg                                               (*((volatile unsigned int*)HDMI_HDMI_ICTPSR0_reg))
#define  HDMI_HDMI_ICTPSR0_icth_shift                                            (8)
#define  HDMI_HDMI_ICTPSR0_ictl_shift                                            (0)
#define  HDMI_HDMI_ICTPSR0_icth_mask                                             (0x0000FF00)
#define  HDMI_HDMI_ICTPSR0_ictl_mask                                             (0x000000FF)
#define  HDMI_HDMI_ICTPSR0_icth(data)                                            (0x0000FF00&((data)<<8))
#define  HDMI_HDMI_ICTPSR0_ictl(data)                                            (0x000000FF&(data))
#define  HDMI_HDMI_ICTPSR0_get_icth(data)                                        ((0x0000FF00&(data))>>8)
#define  HDMI_HDMI_ICTPSR0_get_ictl(data)                                        (0x000000FF&(data))

#define  HDMI_HDMI_PCTPSR0                                                       0x1800D334
#define  HDMI_HDMI_PCTPSR0_reg_addr                                              "0xB800D334"
#define  HDMI_HDMI_PCTPSR0_reg                                                   0xB800D334
#define  HDMI_HDMI_PCTPSR0_inst_addr                                             "0x009F"
#define  set_HDMI_HDMI_PCTPSR0_reg(data)                                         (*((volatile unsigned int*)HDMI_HDMI_PCTPSR0_reg)=data)
#define  get_HDMI_HDMI_PCTPSR0_reg                                               (*((volatile unsigned int*)HDMI_HDMI_PCTPSR0_reg))
#define  HDMI_HDMI_PCTPSR0_pcth_shift                                            (8)
#define  HDMI_HDMI_PCTPSR0_pctl_shift                                            (0)
#define  HDMI_HDMI_PCTPSR0_pcth_mask                                             (0x0000FF00)
#define  HDMI_HDMI_PCTPSR0_pctl_mask                                             (0x000000FF)
#define  HDMI_HDMI_PCTPSR0_pcth(data)                                            (0x0000FF00&((data)<<8))
#define  HDMI_HDMI_PCTPSR0_pctl(data)                                            (0x000000FF&(data))
#define  HDMI_HDMI_PCTPSR0_get_pcth(data)                                        ((0x0000FF00&(data))>>8)
#define  HDMI_HDMI_PCTPSR0_get_pctl(data)                                        (0x000000FF&(data))

#define  HDMI_HDMI_ICBPSR0                                                       0x1800D338
#define  HDMI_HDMI_ICBPSR0_reg_addr                                              "0xB800D338"
#define  HDMI_HDMI_ICBPSR0_reg                                                   0xB800D338
#define  HDMI_HDMI_ICBPSR0_inst_addr                                             "0x00A0"
#define  set_HDMI_HDMI_ICBPSR0_reg(data)                                         (*((volatile unsigned int*)HDMI_HDMI_ICBPSR0_reg)=data)
#define  get_HDMI_HDMI_ICBPSR0_reg                                               (*((volatile unsigned int*)HDMI_HDMI_ICBPSR0_reg))
#define  HDMI_HDMI_ICBPSR0_icbh_shift                                            (8)
#define  HDMI_HDMI_ICBPSR0_icbl_shift                                            (0)
#define  HDMI_HDMI_ICBPSR0_icbh_mask                                             (0x0000FF00)
#define  HDMI_HDMI_ICBPSR0_icbl_mask                                             (0x000000FF)
#define  HDMI_HDMI_ICBPSR0_icbh(data)                                            (0x0000FF00&((data)<<8))
#define  HDMI_HDMI_ICBPSR0_icbl(data)                                            (0x000000FF&(data))
#define  HDMI_HDMI_ICBPSR0_get_icbh(data)                                        ((0x0000FF00&(data))>>8)
#define  HDMI_HDMI_ICBPSR0_get_icbl(data)                                        (0x000000FF&(data))

#define  HDMI_HDMI_PCBPSR0                                                       0x1800D33C
#define  HDMI_HDMI_PCBPSR0_reg_addr                                              "0xB800D33C"
#define  HDMI_HDMI_PCBPSR0_reg                                                   0xB800D33C
#define  HDMI_HDMI_PCBPSR0_inst_addr                                             "0x00A1"
#define  set_HDMI_HDMI_PCBPSR0_reg(data)                                         (*((volatile unsigned int*)HDMI_HDMI_PCBPSR0_reg)=data)
#define  get_HDMI_HDMI_PCBPSR0_reg                                               (*((volatile unsigned int*)HDMI_HDMI_PCBPSR0_reg))
#define  HDMI_HDMI_PCBPSR0_pcbh_shift                                            (8)
#define  HDMI_HDMI_PCBPSR0_pcbl_shift                                            (0)
#define  HDMI_HDMI_PCBPSR0_pcbh_mask                                             (0x0000FF00)
#define  HDMI_HDMI_PCBPSR0_pcbl_mask                                             (0x000000FF)
#define  HDMI_HDMI_PCBPSR0_pcbh(data)                                            (0x0000FF00&((data)<<8))
#define  HDMI_HDMI_PCBPSR0_pcbl(data)                                            (0x000000FF&(data))
#define  HDMI_HDMI_PCBPSR0_get_pcbh(data)                                        ((0x0000FF00&(data))>>8)
#define  HDMI_HDMI_PCBPSR0_get_pcbl(data)                                        (0x000000FF&(data))

#define  HDMI_HDMI_NTx1024TR0                                                    0x1800D340
#define  HDMI_HDMI_NTx1024TR0_reg_addr                                           "0xB800D340"
#define  HDMI_HDMI_NTx1024TR0_reg                                                0xB800D340
#define  HDMI_HDMI_NTx1024TR0_inst_addr                                          "0x00A2"
#define  set_HDMI_HDMI_NTx1024TR0_reg(data)                                      (*((volatile unsigned int*)HDMI_HDMI_NTx1024TR0_reg)=data)
#define  get_HDMI_HDMI_NTx1024TR0_reg                                            (*((volatile unsigned int*)HDMI_HDMI_NTx1024TR0_reg))
#define  HDMI_HDMI_NTx1024TR0_rm_shift                                           (12)
#define  HDMI_HDMI_NTx1024TR0_nt_shift                                           (0)
#define  HDMI_HDMI_NTx1024TR0_rm_mask                                            (0x00001000)
#define  HDMI_HDMI_NTx1024TR0_nt_mask                                            (0x00000FFF)
#define  HDMI_HDMI_NTx1024TR0_rm(data)                                           (0x00001000&((data)<<12))
#define  HDMI_HDMI_NTx1024TR0_nt(data)                                           (0x00000FFF&(data))
#define  HDMI_HDMI_NTx1024TR0_get_rm(data)                                       ((0x00001000&(data))>>12)
#define  HDMI_HDMI_NTx1024TR0_get_nt(data)                                       (0x00000FFF&(data))

#define  HDMI_HDMI_STBPR                                                         0x1800D344
#define  HDMI_HDMI_STBPR_reg_addr                                                "0xB800D344"
#define  HDMI_HDMI_STBPR_reg                                                     0xB800D344
#define  HDMI_HDMI_STBPR_inst_addr                                               "0x00A3"
#define  set_HDMI_HDMI_STBPR_reg(data)                                           (*((volatile unsigned int*)HDMI_HDMI_STBPR_reg)=data)
#define  get_HDMI_HDMI_STBPR_reg                                                 (*((volatile unsigned int*)HDMI_HDMI_STBPR_reg))
#define  HDMI_HDMI_STBPR_ftb_shift                                               (0)
#define  HDMI_HDMI_STBPR_ftb_mask                                                (0x000000FF)
#define  HDMI_HDMI_STBPR_ftb(data)                                               (0x000000FF&(data))
#define  HDMI_HDMI_STBPR_get_ftb(data)                                           (0x000000FF&(data))

#define  HDMI_HDMI_NCPER                                                         0x1800D348
#define  HDMI_HDMI_NCPER_reg_addr                                                "0xB800D348"
#define  HDMI_HDMI_NCPER_reg                                                     0xB800D348
#define  HDMI_HDMI_NCPER_inst_addr                                               "0x00A4"
#define  set_HDMI_HDMI_NCPER_reg(data)                                           (*((volatile unsigned int*)HDMI_HDMI_NCPER_reg)=data)
#define  get_HDMI_HDMI_NCPER_reg                                                 (*((volatile unsigned int*)HDMI_HDMI_NCPER_reg))
#define  HDMI_HDMI_NCPER_ncper_shift                                             (0)
#define  HDMI_HDMI_NCPER_ncper_mask                                              (0x000000FF)
#define  HDMI_HDMI_NCPER_ncper(data)                                             (0x000000FF&(data))
#define  HDMI_HDMI_NCPER_get_ncper(data)                                         (0x000000FF&(data))

#define  HDMI_HDMI_PETR                                                          0x1800D34C
#define  HDMI_HDMI_PETR_reg_addr                                                 "0xB800D34C"
#define  HDMI_HDMI_PETR_reg                                                      0xB800D34C
#define  HDMI_HDMI_PETR_inst_addr                                                "0x00A5"
#define  set_HDMI_HDMI_PETR_reg(data)                                            (*((volatile unsigned int*)HDMI_HDMI_PETR_reg)=data)
#define  get_HDMI_HDMI_PETR_reg                                                  (*((volatile unsigned int*)HDMI_HDMI_PETR_reg))
#define  HDMI_HDMI_PETR_petr_shift                                               (0)
#define  HDMI_HDMI_PETR_petr_mask                                                (0x000000FF)
#define  HDMI_HDMI_PETR_petr(data)                                               (0x000000FF&(data))
#define  HDMI_HDMI_PETR_get_petr(data)                                           (0x000000FF&(data))

#define  HDMI_HDMI_AAPNR                                                         0x1800D350
#define  HDMI_HDMI_AAPNR_reg_addr                                                "0xB800D350"
#define  HDMI_HDMI_AAPNR_reg                                                     0xB800D350
#define  HDMI_HDMI_AAPNR_inst_addr                                               "0x00A6"
#define  set_HDMI_HDMI_AAPNR_reg(data)                                           (*((volatile unsigned int*)HDMI_HDMI_AAPNR_reg)=data)
#define  get_HDMI_HDMI_AAPNR_reg                                                 (*((volatile unsigned int*)HDMI_HDMI_AAPNR_reg))
#define  HDMI_HDMI_AAPNR_cmvtc_shift                                             (7)
#define  HDMI_HDMI_AAPNR_cmvbc_shift                                             (6)
#define  HDMI_HDMI_AAPNR_ssdmou_shift                                            (5)
#define  HDMI_HDMI_AAPNR_tef_shift                                               (4)
#define  HDMI_HDMI_AAPNR_w1c5_shift                                              (3)
#define  HDMI_HDMI_AAPNR_pem_shift                                               (2)
#define  HDMI_HDMI_AAPNR_esdm_shift                                              (1)
#define  HDMI_HDMI_AAPNR_dummy_shift                                             (0)
#define  HDMI_HDMI_AAPNR_cmvtc_mask                                              (0x00000080)
#define  HDMI_HDMI_AAPNR_cmvbc_mask                                              (0x00000040)
#define  HDMI_HDMI_AAPNR_ssdmou_mask                                             (0x00000020)
#define  HDMI_HDMI_AAPNR_tef_mask                                                (0x00000010)
#define  HDMI_HDMI_AAPNR_w1c5_mask                                               (0x00000008)
#define  HDMI_HDMI_AAPNR_pem_mask                                                (0x00000004)
#define  HDMI_HDMI_AAPNR_esdm_mask                                               (0x00000002)
#define  HDMI_HDMI_AAPNR_dummy_mask                                              (0x00000001)
#define  HDMI_HDMI_AAPNR_cmvtc(data)                                             (0x00000080&((data)<<7))
#define  HDMI_HDMI_AAPNR_cmvbc(data)                                             (0x00000040&((data)<<6))
#define  HDMI_HDMI_AAPNR_ssdmou(data)                                            (0x00000020&((data)<<5))
#define  HDMI_HDMI_AAPNR_tef(data)                                               (0x00000010&((data)<<4))
#define  HDMI_HDMI_AAPNR_w1c5(data)                                              (0x00000008&((data)<<3))
#define  HDMI_HDMI_AAPNR_pem(data)                                               (0x00000004&((data)<<2))
#define  HDMI_HDMI_AAPNR_esdm(data)                                              (0x00000002&((data)<<1))
#define  HDMI_HDMI_AAPNR_dummy(data)                                             (0x00000001&(data))
#define  HDMI_HDMI_AAPNR_get_cmvtc(data)                                         ((0x00000080&(data))>>7)
#define  HDMI_HDMI_AAPNR_get_cmvbc(data)                                         ((0x00000040&(data))>>6)
#define  HDMI_HDMI_AAPNR_get_ssdmou(data)                                        ((0x00000020&(data))>>5)
#define  HDMI_HDMI_AAPNR_get_tef(data)                                           ((0x00000010&(data))>>4)
#define  HDMI_HDMI_AAPNR_get_w1c5(data)                                          ((0x00000008&(data))>>3)
#define  HDMI_HDMI_AAPNR_get_pem(data)                                           ((0x00000004&(data))>>2)
#define  HDMI_HDMI_AAPNR_get_esdm(data)                                          ((0x00000002&(data))>>1)
#define  HDMI_HDMI_AAPNR_get_dummy(data)                                         (0x00000001&(data))

#define  HDMI_HDMI_APDMCR                                                        0x1800D354
#define  HDMI_HDMI_APDMCR_reg_addr                                               "0xB800D354"
#define  HDMI_HDMI_APDMCR_reg                                                    0xB800D354
#define  HDMI_HDMI_APDMCR_inst_addr                                              "0x00A7"
#define  set_HDMI_HDMI_APDMCR_reg(data)                                          (*((volatile unsigned int*)HDMI_HDMI_APDMCR_reg)=data)
#define  get_HDMI_HDMI_APDMCR_reg                                                (*((volatile unsigned int*)HDMI_HDMI_APDMCR_reg))
//#define  HDMI_HDMI_APDMCR_dummy_shift                                            (7)
//#define  HDMI_HDMI_APDMCR_dummy_shift                                            (6)
#define  HDMI_HDMI_APDMCR_edm_shift                                              (5)
#define  HDMI_HDMI_APDMCR_pst_shift                                              (4)
#define  HDMI_HDMI_APDMCR_psc_shift                                              (0)
//#define  HDMI_HDMI_APDMCR_dummy_mask                                             (0x00000080)
//#define  HDMI_HDMI_APDMCR_dummy_mask                                             (0x00000040)
#define  HDMI_HDMI_APDMCR_edm_mask                                               (0x00000020)
#define  HDMI_HDMI_APDMCR_pst_mask                                               (0x00000010)
#define  HDMI_HDMI_APDMCR_psc_mask                                               (0x0000000F)
//#define  HDMI_HDMI_APDMCR_dummy(data)                                            (0x00000080&((data)<<7))
//#define  HDMI_HDMI_APDMCR_dummy(data)                                            (0x00000040&((data)<<6))
#define  HDMI_HDMI_APDMCR_edm(data)                                              (0x00000020&((data)<<5))
#define  HDMI_HDMI_APDMCR_pst(data)                                              (0x00000010&((data)<<4))
#define  HDMI_HDMI_APDMCR_psc(data)                                              (0x0000000F&(data))
//#define  HDMI_HDMI_APDMCR_get_dummy(data)                                        ((0x00000080&(data))>>7)
//#define  HDMI_HDMI_APDMCR_get_dummy(data)                                        ((0x00000040&(data))>>6)
#define  HDMI_HDMI_APDMCR_get_edm(data)                                          ((0x00000020&(data))>>5)
#define  HDMI_HDMI_APDMCR_get_pst(data)                                          ((0x00000010&(data))>>4)
#define  HDMI_HDMI_APDMCR_get_psc(data)                                          (0x0000000F&(data))

#define  HDMI_HDMI_APTMCR0                                                       0x1800D358
#define  HDMI_HDMI_APTMCR0_reg_addr                                              "0xB800D358"
#define  HDMI_HDMI_APTMCR0_reg                                                   0xB800D358
#define  HDMI_HDMI_APTMCR0_inst_addr                                             "0x00A8"
#define  set_HDMI_HDMI_APTMCR0_reg(data)                                         (*((volatile unsigned int*)HDMI_HDMI_APTMCR0_reg)=data)
#define  get_HDMI_HDMI_APTMCR0_reg                                               (*((volatile unsigned int*)HDMI_HDMI_APTMCR0_reg))
#define  HDMI_HDMI_APTMCR0_fps_shift                                             (4)
#define  HDMI_HDMI_APTMCR0_sps_shift                                             (0)
#define  HDMI_HDMI_APTMCR0_fps_mask                                              (0x000000F0)
#define  HDMI_HDMI_APTMCR0_sps_mask                                              (0x0000000F)
#define  HDMI_HDMI_APTMCR0_fps(data)                                             (0x000000F0&((data)<<4))
#define  HDMI_HDMI_APTMCR0_sps(data)                                             (0x0000000F&(data))
#define  HDMI_HDMI_APTMCR0_get_fps(data)                                         ((0x000000F0&(data))>>4)
#define  HDMI_HDMI_APTMCR0_get_sps(data)                                         (0x0000000F&(data))

#define  HDMI_HDMI_APTMCR1                                                       0x1800D35C
#define  HDMI_HDMI_APTMCR1_reg_addr                                              "0xB800D35C"
#define  HDMI_HDMI_APTMCR1_reg                                                   0xB800D35C
#define  HDMI_HDMI_APTMCR1_inst_addr                                             "0x00A9"
#define  set_HDMI_HDMI_APTMCR1_reg(data)                                         (*((volatile unsigned int*)HDMI_HDMI_APTMCR1_reg)=data)
#define  get_HDMI_HDMI_APTMCR1_reg                                               (*((volatile unsigned int*)HDMI_HDMI_APTMCR1_reg))
#define  HDMI_HDMI_APTMCR1_plltm_shift                                           (6)
#define  HDMI_HDMI_APTMCR1_fpsd_shift                                            (5)
#define  HDMI_HDMI_APTMCR1_spsd_shift                                            (4)
#define  HDMI_HDMI_APTMCR1_nfpss_shift                                           (0)
#define  HDMI_HDMI_APTMCR1_plltm_mask                                            (0x00000040)
#define  HDMI_HDMI_APTMCR1_fpsd_mask                                             (0x00000020)
#define  HDMI_HDMI_APTMCR1_spsd_mask                                             (0x00000010)
#define  HDMI_HDMI_APTMCR1_nfpss_mask                                            (0x0000000F)
#define  HDMI_HDMI_APTMCR1_plltm(data)                                           (0x00000040&((data)<<6))
#define  HDMI_HDMI_APTMCR1_fpsd(data)                                            (0x00000020&((data)<<5))
#define  HDMI_HDMI_APTMCR1_spsd(data)                                            (0x00000010&((data)<<4))
#define  HDMI_HDMI_APTMCR1_nfpss(data)                                           (0x0000000F&(data))
#define  HDMI_HDMI_APTMCR1_get_plltm(data)                                       ((0x00000040&(data))>>6)
#define  HDMI_HDMI_APTMCR1_get_fpsd(data)                                        ((0x00000020&(data))>>5)
#define  HDMI_HDMI_APTMCR1_get_spsd(data)                                        ((0x00000010&(data))>>4)
#define  HDMI_HDMI_APTMCR1_get_nfpss(data)                                       (0x0000000F&(data))

#define  HDMI_HDMI_NPECR                                                         0x1800D360
#define  HDMI_HDMI_NPECR_reg_addr                                                "0xB800D360"
#define  HDMI_HDMI_NPECR_reg                                                     0xB800D360
#define  HDMI_HDMI_NPECR_inst_addr                                               "0x00AA"
#define  set_HDMI_HDMI_NPECR_reg(data)                                           (*((volatile unsigned int*)HDMI_HDMI_NPECR_reg)=data)
#define  get_HDMI_HDMI_NPECR_reg                                                 (*((volatile unsigned int*)HDMI_HDMI_NPECR_reg))
#define  HDMI_HDMI_NPECR_ncts_disable_pe_check_en_shift                          (31)
#define  HDMI_HDMI_NPECR_ncts_re_enable_off_en_shift                             (30)
#define  HDMI_HDMI_NPECR_ncts_disable_pe_check_status_shift                      (29)
#define  HDMI_HDMI_NPECR_ncts_disable_pe_check_irq_en_shift                      (28)
#define  HDMI_HDMI_NPECR_dummy_shift                                             (20)
#define  HDMI_HDMI_NPECR_ncts_disable_pe_check_cnt_shift                         (0)
#define  HDMI_HDMI_NPECR_ncts_disable_pe_check_en_mask                           (0x80000000)
#define  HDMI_HDMI_NPECR_ncts_re_enable_off_en_mask                              (0x40000000)
#define  HDMI_HDMI_NPECR_ncts_disable_pe_check_status_mask                       (0x20000000)
#define  HDMI_HDMI_NPECR_ncts_disable_pe_check_irq_en_mask                       (0x10000000)
#define  HDMI_HDMI_NPECR_dummy_mask                                              (0x0FF00000)
#define  HDMI_HDMI_NPECR_ncts_disable_pe_check_cnt_mask                          (0x000FFFFF)
#define  HDMI_HDMI_NPECR_ncts_disable_pe_check_en(data)                          (0x80000000&((data)<<31))
#define  HDMI_HDMI_NPECR_ncts_re_enable_off_en(data)                             (0x40000000&((data)<<30))
#define  HDMI_HDMI_NPECR_ncts_disable_pe_check_status(data)                      (0x20000000&((data)<<29))
#define  HDMI_HDMI_NPECR_ncts_disable_pe_check_irq_en(data)                      (0x10000000&((data)<<28))
#define  HDMI_HDMI_NPECR_dummy(data)                                             (0x0FF00000&((data)<<20))
#define  HDMI_HDMI_NPECR_ncts_disable_pe_check_cnt(data)                         (0x000FFFFF&(data))
#define  HDMI_HDMI_NPECR_get_ncts_disable_pe_check_en(data)                      ((0x80000000&(data))>>31)
#define  HDMI_HDMI_NPECR_get_ncts_re_enable_off_en(data)                         ((0x40000000&(data))>>30)
#define  HDMI_HDMI_NPECR_get_ncts_disable_pe_check_status(data)                  ((0x20000000&(data))>>29)
#define  HDMI_HDMI_NPECR_get_ncts_disable_pe_check_irq_en(data)                  ((0x10000000&(data))>>28)
#define  HDMI_HDMI_NPECR_get_dummy(data)                                         ((0x0FF00000&(data))>>20)
#define  HDMI_HDMI_NPECR_get_ncts_disable_pe_check_cnt(data)                     (0x000FFFFF&(data))

#define  HDMI_HDMI_NROR                                                          0x1800D364
#define  HDMI_HDMI_NROR_reg_addr                                                 "0xB800D364"
#define  HDMI_HDMI_NROR_reg                                                      0xB800D364
#define  HDMI_HDMI_NROR_inst_addr                                                "0x00AB"
#define  set_HDMI_HDMI_NROR_reg(data)                                            (*((volatile unsigned int*)HDMI_HDMI_NROR_reg)=data)
#define  get_HDMI_HDMI_NROR_reg                                                  (*((volatile unsigned int*)HDMI_HDMI_NROR_reg))
#define  HDMI_HDMI_NROR_ncts_re_enable_off_start_shift                           (16)
#define  HDMI_HDMI_NROR_ncts_re_enable_off_end_shift                             (0)
#define  HDMI_HDMI_NROR_ncts_re_enable_off_start_mask                            (0xFFFF0000)
#define  HDMI_HDMI_NROR_ncts_re_enable_off_end_mask                              (0x0000FFFF)
#define  HDMI_HDMI_NROR_ncts_re_enable_off_start(data)                           (0xFFFF0000&((data)<<16))
#define  HDMI_HDMI_NROR_ncts_re_enable_off_end(data)                             (0x0000FFFF&(data))
#define  HDMI_HDMI_NROR_get_ncts_re_enable_off_start(data)                       ((0xFFFF0000&(data))>>16)
#define  HDMI_HDMI_NROR_get_ncts_re_enable_off_end(data)                         (0x0000FFFF&(data))

#define  HDMI_HDMI_NTx1024TR0_Threshold                                          0x1800D368
#define  HDMI_HDMI_NTx1024TR0_Threshold_reg_addr                                 "0xB800D368"
#define  HDMI_HDMI_NTx1024TR0_Threshold_reg                                      0xB800D368
#define  HDMI_HDMI_NTx1024TR0_Threshold_inst_addr                                "0x00AC"
#define  set_HDMI_HDMI_NTx1024TR0_Threshold_reg(data)                            (*((volatile unsigned int*)HDMI_HDMI_NTx1024TR0_Threshold_reg)=data)
#define  get_HDMI_HDMI_NTx1024TR0_Threshold_reg                                  (*((volatile unsigned int*)HDMI_HDMI_NTx1024TR0_Threshold_reg))
#define  HDMI_HDMI_NTx1024TR0_Threshold_over_threshold_shift                     (31)
#define  HDMI_HDMI_NTx1024TR0_Threshold_under_threshold_shift                    (30)
#define  HDMI_HDMI_NTx1024TR0_Threshold_wd_by_tmds_clk_shift                     (29)
#define  HDMI_HDMI_NTx1024TR0_Threshold_irq_by_tmds_clk_shift                    (28)
#define  HDMI_HDMI_NTx1024TR0_Threshold_nt_up_threshold_shift                    (16)
#define  HDMI_HDMI_NTx1024TR0_Threshold_nt_low_threshold_shift                   (0)
#define  HDMI_HDMI_NTx1024TR0_Threshold_over_threshold_mask                      (0x80000000)
#define  HDMI_HDMI_NTx1024TR0_Threshold_under_threshold_mask                     (0x40000000)
#define  HDMI_HDMI_NTx1024TR0_Threshold_wd_by_tmds_clk_mask                      (0x20000000)
#define  HDMI_HDMI_NTx1024TR0_Threshold_irq_by_tmds_clk_mask                     (0x10000000)
#define  HDMI_HDMI_NTx1024TR0_Threshold_nt_up_threshold_mask                     (0x0FFF0000)
#define  HDMI_HDMI_NTx1024TR0_Threshold_nt_low_threshold_mask                    (0x00000FFF)
#define  HDMI_HDMI_NTx1024TR0_Threshold_over_threshold(data)                     (0x80000000&((data)<<31))
#define  HDMI_HDMI_NTx1024TR0_Threshold_under_threshold(data)                    (0x40000000&((data)<<30))
#define  HDMI_HDMI_NTx1024TR0_Threshold_wd_by_tmds_clk(data)                     (0x20000000&((data)<<29))
#define  HDMI_HDMI_NTx1024TR0_Threshold_irq_by_tmds_clk(data)                    (0x10000000&((data)<<28))
#define  HDMI_HDMI_NTx1024TR0_Threshold_nt_up_threshold(data)                    (0x0FFF0000&((data)<<16))
#define  HDMI_HDMI_NTx1024TR0_Threshold_nt_low_threshold(data)                   (0x00000FFF&(data))
#define  HDMI_HDMI_NTx1024TR0_Threshold_get_over_threshold(data)                 ((0x80000000&(data))>>31)
#define  HDMI_HDMI_NTx1024TR0_Threshold_get_under_threshold(data)                ((0x40000000&(data))>>30)
#define  HDMI_HDMI_NTx1024TR0_Threshold_get_wd_by_tmds_clk(data)                 ((0x20000000&(data))>>29)
#define  HDMI_HDMI_NTx1024TR0_Threshold_get_irq_by_tmds_clk(data)                ((0x10000000&(data))>>28)
#define  HDMI_HDMI_NTx1024TR0_Threshold_get_nt_up_threshold(data)                ((0x0FFF0000&(data))>>16)
#define  HDMI_HDMI_NTx1024TR0_Threshold_get_nt_low_threshold(data)               (0x00000FFF&(data))

#define  HDMI_HDMI_APLLCR0                                                       0x1800D380
#define  HDMI_HDMI_APLLCR0_reg_addr                                              "0xB800D380"
#define  HDMI_HDMI_APLLCR0_reg                                                   0xB800D380
#define  HDMI_HDMI_APLLCR0_inst_addr                                             "0x00AD"
#define  set_HDMI_HDMI_APLLCR0_reg(data)                                         (*((volatile unsigned int*)HDMI_HDMI_APLLCR0_reg)=data)
#define  get_HDMI_HDMI_APLLCR0_reg                                               (*((volatile unsigned int*)HDMI_HDMI_APLLCR0_reg))
#define  HDMI_HDMI_APLLCR0_dpll_reg_shift                                        (30)
#define  HDMI_HDMI_APLLCR0_dpll_m_shift                                          (22)
#define  HDMI_HDMI_APLLCR0_dpll_reser_shift                                      (17)
#define  HDMI_HDMI_APLLCR0_dpll_bpsin_shift                                      (16)
#define  HDMI_HDMI_APLLCR0_dpll_o_shift                                          (14)
#define  HDMI_HDMI_APLLCR0_dpll_n_shift                                          (6)
#define  HDMI_HDMI_APLLCR0_dpll_rs_shift                                         (3)
#define  HDMI_HDMI_APLLCR0_dpll_ip_shift                                         (0)
#define  HDMI_HDMI_APLLCR0_dpll_reg_mask                                         (0xC0000000)
#define  HDMI_HDMI_APLLCR0_dpll_m_mask                                           (0x3FC00000)
#define  HDMI_HDMI_APLLCR0_dpll_reser_mask                                       (0x001E0000)
#define  HDMI_HDMI_APLLCR0_dpll_bpsin_mask                                       (0x00010000)
#define  HDMI_HDMI_APLLCR0_dpll_o_mask                                           (0x0000C000)
#define  HDMI_HDMI_APLLCR0_dpll_n_mask                                           (0x000001C0)
#define  HDMI_HDMI_APLLCR0_dpll_rs_mask                                          (0x00000038)
#define  HDMI_HDMI_APLLCR0_dpll_ip_mask                                          (0x00000007)
#define  HDMI_HDMI_APLLCR0_dpll_reg(data)                                        (0xC0000000&((data)<<30))
#define  HDMI_HDMI_APLLCR0_dpll_m(data)                                          (0x3FC00000&((data)<<22))
#define  HDMI_HDMI_APLLCR0_dpll_reser(data)                                      (0x001E0000&((data)<<17))
#define  HDMI_HDMI_APLLCR0_dpll_bpsin(data)                                      (0x00010000&((data)<<16))
#define  HDMI_HDMI_APLLCR0_dpll_o(data)                                          (0x0000C000&((data)<<14))
#define  HDMI_HDMI_APLLCR0_dpll_n(data)                                          (0x000001C0&((data)<<6))
#define  HDMI_HDMI_APLLCR0_dpll_rs(data)                                         (0x00000038&((data)<<3))
#define  HDMI_HDMI_APLLCR0_dpll_ip(data)                                         (0x00000007&(data))
#define  HDMI_HDMI_APLLCR0_get_dpll_reg(data)                                    ((0xC0000000&(data))>>30)
#define  HDMI_HDMI_APLLCR0_get_dpll_m(data)                                      ((0x3FC00000&(data))>>22)
#define  HDMI_HDMI_APLLCR0_get_dpll_reser(data)                                  ((0x001E0000&(data))>>17)
#define  HDMI_HDMI_APLLCR0_get_dpll_bpsin(data)                                  ((0x00010000&(data))>>16)
#define  HDMI_HDMI_APLLCR0_get_dpll_o(data)                                      ((0x0000C000&(data))>>14)
#define  HDMI_HDMI_APLLCR0_get_dpll_n(data)                                      ((0x000001C0&(data))>>6)
#define  HDMI_HDMI_APLLCR0_get_dpll_rs(data)                                     ((0x00000038&(data))>>3)
#define  HDMI_HDMI_APLLCR0_get_dpll_ip(data)                                     (0x00000007&(data))

#define  HDMI_HDMI_APLLCR1                                                       0x1800D384
#define  HDMI_HDMI_APLLCR1_reg_addr                                              "0xB800D384"
#define  HDMI_HDMI_APLLCR1_reg                                                   0xB800D384
#define  HDMI_HDMI_APLLCR1_inst_addr                                             "0x00AE"
#define  set_HDMI_HDMI_APLLCR1_reg(data)                                         (*((volatile unsigned int*)HDMI_HDMI_APLLCR1_reg)=data)
#define  get_HDMI_HDMI_APLLCR1_reg                                               (*((volatile unsigned int*)HDMI_HDMI_APLLCR1_reg))
#define  HDMI_HDMI_APLLCR1_dpll_cp_shift                                         (21)
#define  HDMI_HDMI_APLLCR1_dpll_seltst_shift                                     (19)
#define  HDMI_HDMI_APLLCR1_dpll_cs_shift                                         (17)
#define  HDMI_HDMI_APLLCR1_dpll_reserve_shift                                    (9)
#define  HDMI_HDMI_APLLCR1_dpll_bpspsw_shift                                     (8)
#define  HDMI_HDMI_APLLCR1_dpll_wdo_shift                                        (7)
#define  HDMI_HDMI_APLLCR1_dpll_wdrst_shift                                      (6)
#define  HDMI_HDMI_APLLCR1_dpll_wdset_shift                                      (5)
#define  HDMI_HDMI_APLLCR1_dummy_shift                                           (4)
#define  HDMI_HDMI_APLLCR1_dpll_stoppsw_shift                                    (3)
#define  HDMI_HDMI_APLLCR1_dpll_freeze_shift                                     (2)
#define  HDMI_HDMI_APLLCR1_dpll_vcorstb_shift                                    (1)
#define  HDMI_HDMI_APLLCR1_dpll_pow_shift                                        (0)
#define  HDMI_HDMI_APLLCR1_dpll_cp_mask                                          (0x00600000)
#define  HDMI_HDMI_APLLCR1_dpll_seltst_mask                                      (0x00180000)
#define  HDMI_HDMI_APLLCR1_dpll_cs_mask                                          (0x00060000)
#define  HDMI_HDMI_APLLCR1_dpll_reserve_mask                                     (0x00000200)
#define  HDMI_HDMI_APLLCR1_dpll_bpspsw_mask                                      (0x00000100)
#define  HDMI_HDMI_APLLCR1_dpll_wdo_mask                                         (0x00000080)
#define  HDMI_HDMI_APLLCR1_dpll_wdrst_mask                                       (0x00000040)
#define  HDMI_HDMI_APLLCR1_dpll_wdset_mask                                       (0x00000020)
#define  HDMI_HDMI_APLLCR1_dummy_mask                                            (0x00000010)
#define  HDMI_HDMI_APLLCR1_dpll_stoppsw_mask                                     (0x00000008)
#define  HDMI_HDMI_APLLCR1_dpll_freeze_mask                                      (0x00000004)
#define  HDMI_HDMI_APLLCR1_dpll_vcorstb_mask                                     (0x00000002)
#define  HDMI_HDMI_APLLCR1_dpll_pow_mask                                         (0x00000001)
#define  HDMI_HDMI_APLLCR1_dpll_cp(data)                                         (0x00600000&((data)<<21))
#define  HDMI_HDMI_APLLCR1_dpll_seltst(data)                                     (0x00180000&((data)<<19))
#define  HDMI_HDMI_APLLCR1_dpll_cs(data)                                         (0x00060000&((data)<<17))
#define  HDMI_HDMI_APLLCR1_dpll_reserve(data)                                    (0x00000200&((data)<<9))
#define  HDMI_HDMI_APLLCR1_dpll_bpspsw(data)                                     (0x00000100&((data)<<8))
#define  HDMI_HDMI_APLLCR1_dpll_wdo(data)                                        (0x00000080&((data)<<7))
#define  HDMI_HDMI_APLLCR1_dpll_wdrst(data)                                      (0x00000040&((data)<<6))
#define  HDMI_HDMI_APLLCR1_dpll_wdset(data)                                      (0x00000020&((data)<<5))
#define  HDMI_HDMI_APLLCR1_dummy(data)                                           (0x00000010&((data)<<4))
#define  HDMI_HDMI_APLLCR1_dpll_stoppsw(data)                                    (0x00000008&((data)<<3))
#define  HDMI_HDMI_APLLCR1_dpll_freeze(data)                                     (0x00000004&((data)<<2))
#define  HDMI_HDMI_APLLCR1_dpll_vcorstb(data)                                    (0x00000002&((data)<<1))
#define  HDMI_HDMI_APLLCR1_dpll_pow(data)                                        (0x00000001&(data))
#define  HDMI_HDMI_APLLCR1_get_dpll_cp(data)                                     ((0x00600000&(data))>>21)
#define  HDMI_HDMI_APLLCR1_get_dpll_seltst(data)                                 ((0x00180000&(data))>>19)
#define  HDMI_HDMI_APLLCR1_get_dpll_cs(data)                                     ((0x00060000&(data))>>17)
#define  HDMI_HDMI_APLLCR1_get_dpll_reserve(data)                                ((0x00000200&(data))>>9)
#define  HDMI_HDMI_APLLCR1_get_dpll_bpspsw(data)                                 ((0x00000100&(data))>>8)
#define  HDMI_HDMI_APLLCR1_get_dpll_wdo(data)                                    ((0x00000080&(data))>>7)
#define  HDMI_HDMI_APLLCR1_get_dpll_wdrst(data)                                  ((0x00000040&(data))>>6)
#define  HDMI_HDMI_APLLCR1_get_dpll_wdset(data)                                  ((0x00000020&(data))>>5)
#define  HDMI_HDMI_APLLCR1_get_dummy(data)                                       ((0x00000010&(data))>>4)
#define  HDMI_HDMI_APLLCR1_get_dpll_stoppsw(data)                                ((0x00000008&(data))>>3)
#define  HDMI_HDMI_APLLCR1_get_dpll_freeze(data)                                 ((0x00000004&(data))>>2)
#define  HDMI_HDMI_APLLCR1_get_dpll_vcorstb(data)                                ((0x00000002&(data))>>1)
#define  HDMI_HDMI_APLLCR1_get_dpll_pow(data)                                    (0x00000001&(data))
#define HDMI_APLLCR1_dpll_CS_MASK                                        ((1<<18)|(1<<17))
#define HDMI_APLLCR1_dpll_CS_20P                                          (0)
#define HDMI_APLLCR1_dpll_CS_25P                                          (1<<17)
#define HDMI_APLLCR1_dpll_CS_30P                                          (2<<17)
#define HDMI_APLLCR1_dpll_CS_35P                                          (3<<17)



#define  HDMI_HDMI_APLLCR2                                                       0x1800D388
#define  HDMI_HDMI_APLLCR2_reg_addr                                              "0xB800D388"
#define  HDMI_HDMI_APLLCR2_reg                                                   0xB800D388
#define  HDMI_HDMI_APLLCR2_inst_addr                                             "0x00AF"
#define  set_HDMI_HDMI_APLLCR2_reg(data)                                         (*((volatile unsigned int*)HDMI_HDMI_APLLCR2_reg)=data)
#define  get_HDMI_HDMI_APLLCR2_reg                                               (*((volatile unsigned int*)HDMI_HDMI_APLLCR2_reg))
#define  HDMI_HDMI_APLLCR2_dpll_reloadm_shift                                    (0)
#define  HDMI_HDMI_APLLCR2_dpll_reloadm_mask                                     (0x00000001)
#define  HDMI_HDMI_APLLCR2_dpll_reloadm(data)                                    (0x00000001&(data))
#define  HDMI_HDMI_APLLCR2_get_dpll_reloadm(data)                                (0x00000001&(data))

#define  HDMI_HDMI_APLLCR3                                                       0x1800D38C
#define  HDMI_HDMI_APLLCR3_reg_addr                                              "0xB800D38C"
#define  HDMI_HDMI_APLLCR3_reg                                                   0xB800D38C
#define  HDMI_HDMI_APLLCR3_inst_addr                                             "0x00B0"
#define  set_HDMI_HDMI_APLLCR3_reg(data)                                         (*((volatile unsigned int*)HDMI_HDMI_APLLCR3_reg)=data)
#define  get_HDMI_HDMI_APLLCR3_reg                                               (*((volatile unsigned int*)HDMI_HDMI_APLLCR3_reg))
#define  HDMI_HDMI_APLLCR3_sum_c_samp_shift                                      (0)
#define  HDMI_HDMI_APLLCR3_sum_c_samp_mask                                       (0x0000FFFF)
#define  HDMI_HDMI_APLLCR3_sum_c_samp(data)                                      (0x0000FFFF&(data))
#define  HDMI_HDMI_APLLCR3_get_sum_c_samp(data)                                  (0x0000FFFF&(data))

#define  HDMI_HDMI_APLL_TESTM                                                    0x1800D390
#define  HDMI_HDMI_APLL_TESTM_reg_addr                                           "0xB800D390"
#define  HDMI_HDMI_APLL_TESTM_reg                                                0xB800D390
#define  HDMI_HDMI_APLL_TESTM_inst_addr                                          "0x00B1"
#define  set_HDMI_HDMI_APLL_TESTM_reg(data)                                      (*((volatile unsigned int*)HDMI_HDMI_APLL_TESTM_reg)=data)
#define  get_HDMI_HDMI_APLL_TESTM_reg                                            (*((volatile unsigned int*)HDMI_HDMI_APLL_TESTM_reg))
#define  HDMI_HDMI_APLL_TESTM_dpll_m_test_shift                                  (22)
#define  HDMI_HDMI_APLL_TESTM_dpll_m_db_shift                                    (1)
#define  HDMI_HDMI_APLL_TESTM_dpll_m_sel_shift                                   (0)
#define  HDMI_HDMI_APLL_TESTM_dpll_m_test_mask                                   (0x3FC00000)
#define  HDMI_HDMI_APLL_TESTM_dpll_m_db_mask                                     (0x00000002)
#define  HDMI_HDMI_APLL_TESTM_dpll_m_sel_mask                                    (0x00000001)
#define  HDMI_HDMI_APLL_TESTM_dpll_m_test(data)                                  (0x3FC00000&((data)<<22))
#define  HDMI_HDMI_APLL_TESTM_dpll_m_db(data)                                    (0x00000002&((data)<<1))
#define  HDMI_HDMI_APLL_TESTM_dpll_m_sel(data)                                   (0x00000001&(data))
#define  HDMI_HDMI_APLL_TESTM_get_dpll_m_test(data)                              ((0x3FC00000&(data))>>22)
#define  HDMI_HDMI_APLL_TESTM_get_dpll_m_db(data)                                ((0x00000002&(data))>>1)
#define  HDMI_HDMI_APLL_TESTM_get_dpll_m_sel(data)                               (0x00000001&(data))

#define  HDMI_HDMI_VPLLCR0                                                       0x1800D400
#define  HDMI_HDMI_VPLLCR0_reg_addr                                              "0xB800D400"
#define  HDMI_HDMI_VPLLCR0_reg                                                   0xB800D400
#define  HDMI_HDMI_VPLLCR0_inst_addr                                             "0x00B2"
#define  set_HDMI_HDMI_VPLLCR0_reg(data)                                         (*((volatile unsigned int*)HDMI_HDMI_VPLLCR0_reg)=data)
#define  get_HDMI_HDMI_VPLLCR0_reg                                               (*((volatile unsigned int*)HDMI_HDMI_VPLLCR0_reg))
#define  HDMI_HDMI_VPLLCR0_dpll_reg_shift                                        (30)
#define  HDMI_HDMI_VPLLCR0_dpll_m_shift                                          (22)
#define  HDMI_HDMI_VPLLCR0_dpll_reser_shift                                      (17)
#define  HDMI_HDMI_VPLLCR0_dpll_bpsin_shift                                      (16)
#define  HDMI_HDMI_VPLLCR0_dpll_o_shift                                          (14)
#define  HDMI_HDMI_VPLLCR0_dpll_n_shift                                          (6)
#define  HDMI_HDMI_VPLLCR0_dpll_rs_shift                                         (3)
#define  HDMI_HDMI_VPLLCR0_dpll_ip_shift                                         (0)
#define  HDMI_HDMI_VPLLCR0_dpll_reg_mask                                         (0xC0000000)
#define  HDMI_HDMI_VPLLCR0_dpll_m_mask                                           (0x3FC00000)
#define  HDMI_HDMI_VPLLCR0_dpll_reser_mask                                       (0x001E0000)
#define  HDMI_HDMI_VPLLCR0_dpll_bpsin_mask                                       (0x00010000)
#define  HDMI_HDMI_VPLLCR0_dpll_o_mask                                           (0x0000C000)
#define  HDMI_HDMI_VPLLCR0_dpll_n_mask                                           (0x000001C0)
#define  HDMI_HDMI_VPLLCR0_dpll_rs_mask                                          (0x00000038)
#define  HDMI_HDMI_VPLLCR0_dpll_ip_mask                                          (0x00000007)
#define  HDMI_HDMI_VPLLCR0_dpll_reg(data)                                        (0xC0000000&((data)<<30))
#define  HDMI_HDMI_VPLLCR0_dpll_m(data)                                          (0x3FC00000&((data)<<22))
#define  HDMI_HDMI_VPLLCR0_dpll_reser(data)                                      (0x001E0000&((data)<<17))
#define  HDMI_HDMI_VPLLCR0_dpll_bpsin(data)                                      (0x00010000&((data)<<16))
#define  HDMI_HDMI_VPLLCR0_dpll_o(data)                                          (0x0000C000&((data)<<14))
#define  HDMI_HDMI_VPLLCR0_dpll_n(data)                                          (0x000001C0&((data)<<6))
#define  HDMI_HDMI_VPLLCR0_dpll_rs(data)                                         (0x00000038&((data)<<3))
#define  HDMI_HDMI_VPLLCR0_dpll_ip(data)                                         (0x00000007&(data))
#define  HDMI_HDMI_VPLLCR0_get_dpll_reg(data)                                    ((0xC0000000&(data))>>30)
#define  HDMI_HDMI_VPLLCR0_get_dpll_m(data)                                      ((0x3FC00000&(data))>>22)
#define  HDMI_HDMI_VPLLCR0_get_dpll_reser(data)                                  ((0x001E0000&(data))>>17)
#define  HDMI_HDMI_VPLLCR0_get_dpll_bpsin(data)                                  ((0x00010000&(data))>>16)
#define  HDMI_HDMI_VPLLCR0_get_dpll_o(data)                                      ((0x0000C000&(data))>>14)
#define  HDMI_HDMI_VPLLCR0_get_dpll_n(data)                                      ((0x000001C0&(data))>>6)
#define  HDMI_HDMI_VPLLCR0_get_dpll_rs(data)                                     ((0x00000038&(data))>>3)
#define  HDMI_HDMI_VPLLCR0_get_dpll_ip(data)                                     (0x00000007&(data))

#define  HDMI_HDMI_VPLLCR1                                                       0x1800D404
#define  HDMI_HDMI_VPLLCR1_reg_addr                                              "0xB800D404"
#define  HDMI_HDMI_VPLLCR1_reg                                                   0xB800D404
#define  HDMI_HDMI_VPLLCR1_inst_addr                                             "0x00B3"
#define  set_HDMI_HDMI_VPLLCR1_reg(data)                                         (*((volatile unsigned int*)HDMI_HDMI_VPLLCR1_reg)=data)
#define  get_HDMI_HDMI_VPLLCR1_reg                                               (*((volatile unsigned int*)HDMI_HDMI_VPLLCR1_reg))
#define  HDMI_HDMI_VPLLCR1_dpll_cp_shift                                         (21)
#define  HDMI_HDMI_VPLLCR1_dpll_seltst_shift                                     (19)
#define  HDMI_HDMI_VPLLCR1_dpll_cs_shift                                         (17)
#define  HDMI_HDMI_VPLLCR1_dpll_ldo_pow_shift                                    (12)
#define  HDMI_HDMI_VPLLCR1_dpll_ldo_sel_shift                                    (10)
#define  HDMI_HDMI_VPLLCR1_dpll_reserve_shift                                    (9)
#define  HDMI_HDMI_VPLLCR1_dpll_bpspsw_shift                                     (8)
#define  HDMI_HDMI_VPLLCR1_dpll_wdo_shift                                        (7)
#define  HDMI_HDMI_VPLLCR1_dpll_wdrst_shift                                      (6)
#define  HDMI_HDMI_VPLLCR1_dpll_wdset_shift                                      (5)
#define  HDMI_HDMI_VPLLCR1_dummy_shift                                           (4)
#define  HDMI_HDMI_VPLLCR1_dpll_stoppsw_shift                                    (3)
#define  HDMI_HDMI_VPLLCR1_dpll_freeze_shift                                     (2)
#define  HDMI_HDMI_VPLLCR1_dpll_vcorstb_shift                                    (1)
#define  HDMI_HDMI_VPLLCR1_dpll_pow_shift                                        (0)
#define  HDMI_HDMI_VPLLCR1_dpll_cp_mask                                          (0x00600000)
#define  HDMI_HDMI_VPLLCR1_dpll_seltst_mask                                      (0x00180000)
#define  HDMI_HDMI_VPLLCR1_dpll_cs_mask                                          (0x00060000)
#define  HDMI_HDMI_VPLLCR1_dpll_ldo_pow_mask                                     (0x00001000)
#define  HDMI_HDMI_VPLLCR1_dpll_ldo_sel_mask                                     (0x00000C00)
#define  HDMI_HDMI_VPLLCR1_dpll_reserve_mask                                     (0x00000200)
#define  HDMI_HDMI_VPLLCR1_dpll_bpspsw_mask                                      (0x00000100)
#define  HDMI_HDMI_VPLLCR1_dpll_wdo_mask                                         (0x00000080)
#define  HDMI_HDMI_VPLLCR1_dpll_wdrst_mask                                       (0x00000040)
#define  HDMI_HDMI_VPLLCR1_dpll_wdset_mask                                       (0x00000020)
#define  HDMI_HDMI_VPLLCR1_dummy_mask                                            (0x00000010)
#define  HDMI_HDMI_VPLLCR1_dpll_stoppsw_mask                                     (0x00000008)
#define  HDMI_HDMI_VPLLCR1_dpll_freeze_mask                                      (0x00000004)
#define  HDMI_HDMI_VPLLCR1_dpll_vcorstb_mask                                     (0x00000002)
#define  HDMI_HDMI_VPLLCR1_dpll_pow_mask                                         (0x00000001)
#define  HDMI_HDMI_VPLLCR1_dpll_cp(data)                                         (0x00600000&((data)<<21))
#define  HDMI_HDMI_VPLLCR1_dpll_seltst(data)                                     (0x00180000&((data)<<19))
#define  HDMI_HDMI_VPLLCR1_dpll_cs(data)                                         (0x00060000&((data)<<17))
#define  HDMI_HDMI_VPLLCR1_dpll_ldo_pow(data)                                    (0x00001000&((data)<<12))
#define  HDMI_HDMI_VPLLCR1_dpll_ldo_sel(data)                                    (0x00000C00&((data)<<10))
#define  HDMI_HDMI_VPLLCR1_dpll_reserve(data)                                    (0x00000200&((data)<<9))
#define  HDMI_HDMI_VPLLCR1_dpll_bpspsw(data)                                     (0x00000100&((data)<<8))
#define  HDMI_HDMI_VPLLCR1_dpll_wdo(data)                                        (0x00000080&((data)<<7))
#define  HDMI_HDMI_VPLLCR1_dpll_wdrst(data)                                      (0x00000040&((data)<<6))
#define  HDMI_HDMI_VPLLCR1_dpll_wdset(data)                                      (0x00000020&((data)<<5))
#define  HDMI_HDMI_VPLLCR1_dummy(data)                                           (0x00000010&((data)<<4))
#define  HDMI_HDMI_VPLLCR1_dpll_stoppsw(data)                                    (0x00000008&((data)<<3))
#define  HDMI_HDMI_VPLLCR1_dpll_freeze(data)                                     (0x00000004&((data)<<2))
#define  HDMI_HDMI_VPLLCR1_dpll_vcorstb(data)                                    (0x00000002&((data)<<1))
#define  HDMI_HDMI_VPLLCR1_dpll_pow(data)                                        (0x00000001&(data))
#define  HDMI_HDMI_VPLLCR1_get_dpll_cp(data)                                     ((0x00600000&(data))>>21)
#define  HDMI_HDMI_VPLLCR1_get_dpll_seltst(data)                                 ((0x00180000&(data))>>19)
#define  HDMI_HDMI_VPLLCR1_get_dpll_cs(data)                                     ((0x00060000&(data))>>17)
#define  HDMI_HDMI_VPLLCR1_get_dpll_ldo_pow(data)                                ((0x00001000&(data))>>12)
#define  HDMI_HDMI_VPLLCR1_get_dpll_ldo_sel(data)                                ((0x00000C00&(data))>>10)
#define  HDMI_HDMI_VPLLCR1_get_dpll_reserve(data)                                ((0x00000200&(data))>>9)
#define  HDMI_HDMI_VPLLCR1_get_dpll_bpspsw(data)                                 ((0x00000100&(data))>>8)
#define  HDMI_HDMI_VPLLCR1_get_dpll_wdo(data)                                    ((0x00000080&(data))>>7)
#define  HDMI_HDMI_VPLLCR1_get_dpll_wdrst(data)                                  ((0x00000040&(data))>>6)
#define  HDMI_HDMI_VPLLCR1_get_dpll_wdset(data)                                  ((0x00000020&(data))>>5)
#define  HDMI_HDMI_VPLLCR1_get_dummy(data)                                       ((0x00000010&(data))>>4)
#define  HDMI_HDMI_VPLLCR1_get_dpll_stoppsw(data)                                ((0x00000008&(data))>>3)
#define  HDMI_HDMI_VPLLCR1_get_dpll_freeze(data)                                 ((0x00000004&(data))>>2)
#define  HDMI_HDMI_VPLLCR1_get_dpll_vcorstb(data)                                ((0x00000002&(data))>>1)
#define  HDMI_HDMI_VPLLCR1_get_dpll_pow(data)                                    (0x00000001&(data))

#define  HDMI_HDMI_VPLLCR2                                                       0x1800D408
#define  HDMI_HDMI_VPLLCR2_reg_addr                                              "0xB800D408"
#define  HDMI_HDMI_VPLLCR2_reg                                                   0xB800D408
#define  HDMI_HDMI_VPLLCR2_inst_addr                                             "0x00B4"
#define  set_HDMI_HDMI_VPLLCR2_reg(data)                                         (*((volatile unsigned int*)HDMI_HDMI_VPLLCR2_reg)=data)
#define  get_HDMI_HDMI_VPLLCR2_reg                                               (*((volatile unsigned int*)HDMI_HDMI_VPLLCR2_reg))
#define  HDMI_HDMI_VPLLCR2_dpll_reloadm_shift                                    (0)
#define  HDMI_HDMI_VPLLCR2_dpll_reloadm_mask                                     (0x00000001)
#define  HDMI_HDMI_VPLLCR2_dpll_reloadm(data)                                    (0x00000001&(data))
#define  HDMI_HDMI_VPLLCR2_get_dpll_reloadm(data)                                (0x00000001&(data))

#define  HDMI_MN_SCLKG_CTRL                                                      0x1800D410
#define  HDMI_MN_SCLKG_CTRL_reg_addr                                             "0xB800D410"
#define  HDMI_MN_SCLKG_CTRL_reg                                                  0xB800D410
#define  HDMI_MN_SCLKG_CTRL_inst_addr                                            "0x00B5"
#define  set_HDMI_MN_SCLKG_CTRL_reg(data)                                        (*((volatile unsigned int*)HDMI_MN_SCLKG_CTRL_reg)=data)
#define  get_HDMI_MN_SCLKG_CTRL_reg                                              (*((volatile unsigned int*)HDMI_MN_SCLKG_CTRL_reg))
#define  HDMI_MN_SCLKG_CTRL_sclkg_pll_in_sel_shift                               (7)
#define  HDMI_MN_SCLKG_CTRL_sclkg_oclk_sel_shift                                 (5)
#define  HDMI_MN_SCLKG_CTRL_sclkg_dbuf_shift                                     (4)
#define  HDMI_MN_SCLKG_CTRL_dummy_shift                                          (0)
#define  HDMI_MN_SCLKG_CTRL_sclkg_pll_in_sel_mask                                (0x00000080)
#define  HDMI_MN_SCLKG_CTRL_sclkg_oclk_sel_mask                                  (0x00000060)
#define  HDMI_MN_SCLKG_CTRL_sclkg_dbuf_mask                                      (0x00000010)
#define  HDMI_MN_SCLKG_CTRL_dummy_mask                                           (0x0000000F)
#define  HDMI_MN_SCLKG_CTRL_sclkg_pll_in_sel(data)                               (0x00000080&((data)<<7))
#define  HDMI_MN_SCLKG_CTRL_sclkg_oclk_sel(data)                                 (0x00000060&((data)<<5))
#define  HDMI_MN_SCLKG_CTRL_sclkg_dbuf(data)                                     (0x00000010&((data)<<4))
#define  HDMI_MN_SCLKG_CTRL_dummy(data)                                          (0x0000000F&(data))
#define  HDMI_MN_SCLKG_CTRL_get_sclkg_pll_in_sel(data)                           ((0x00000080&(data))>>7)
#define  HDMI_MN_SCLKG_CTRL_get_sclkg_oclk_sel(data)                             ((0x00000060&(data))>>5)
#define  HDMI_MN_SCLKG_CTRL_get_sclkg_dbuf(data)                                 ((0x00000010&(data))>>4)
#define  HDMI_MN_SCLKG_CTRL_get_dummy(data)                                      (0x0000000F&(data))

#define  HDMI_MN_SCLKG_DIVS                                                      0x1800D414
#define  HDMI_MN_SCLKG_DIVS_reg_addr                                             "0xB800D414"
#define  HDMI_MN_SCLKG_DIVS_reg                                                  0xB800D414
#define  HDMI_MN_SCLKG_DIVS_inst_addr                                            "0x00B6"
#define  set_HDMI_MN_SCLKG_DIVS_reg(data)                                        (*((volatile unsigned int*)HDMI_MN_SCLKG_DIVS_reg)=data)
#define  get_HDMI_MN_SCLKG_DIVS_reg                                              (*((volatile unsigned int*)HDMI_MN_SCLKG_DIVS_reg))
#define  HDMI_MN_SCLKG_DIVS_sclkg_pll_div2_en_shift                              (7)
#define  HDMI_MN_SCLKG_DIVS_sclkg_pll_divs_shift                                 (0)
#define  HDMI_MN_SCLKG_DIVS_sclkg_pll_div2_en_mask                               (0x00000080)
#define  HDMI_MN_SCLKG_DIVS_sclkg_pll_divs_mask                                  (0x0000007F)
#define  HDMI_MN_SCLKG_DIVS_sclkg_pll_div2_en(data)                              (0x00000080&((data)<<7))
#define  HDMI_MN_SCLKG_DIVS_sclkg_pll_divs(data)                                 (0x0000007F&(data))
#define  HDMI_MN_SCLKG_DIVS_get_sclkg_pll_div2_en(data)                          ((0x00000080&(data))>>7)
#define  HDMI_MN_SCLKG_DIVS_get_sclkg_pll_divs(data)                             (0x0000007F&(data))




#endif

//end of MAG2 Digital Spec 20150304






// HDMI PHY
//HDMI PHY MAC3
#if 1


//  DFE_HDMI_RX_PHY Register Address
#define  DFE_HDMI_RX_PHY_BG                                                      0x1800DA00
#define  DFE_HDMI_RX_PHY_BG_reg_addr                                             "0xB800DA00"
#define  DFE_HDMI_RX_PHY_BG_reg                                                  0xB800DA00
#define  DFE_HDMI_RX_PHY_BG_inst_addr                                            "0x0000"
#define  set_DFE_HDMI_RX_PHY_BG_reg(data)                                        (*((volatile unsigned int*)DFE_HDMI_RX_PHY_BG_reg)=data)
#define  get_DFE_HDMI_RX_PHY_BG_reg                                              (*((volatile unsigned int*)DFE_HDMI_RX_PHY_BG_reg))
#define  DFE_HDMI_RX_PHY_BG_reg_bg_rbgloop2_shift                                (7)
#define  DFE_HDMI_RX_PHY_BG_reg_bg_rbg_shift                                     (4)
#define  DFE_HDMI_RX_PHY_BG_reg_bg_rbg2_shift                                    (2)
#define  DFE_HDMI_RX_PHY_BG_reg_bg_pow_shift                                     (1)
#define  DFE_HDMI_RX_PHY_BG_reg_bg_envbgup_shift                                 (0)
#define  DFE_HDMI_RX_PHY_BG_reg_bg_rbgloop2_mask                                 (0x00000380)
#define  DFE_HDMI_RX_PHY_BG_reg_bg_rbg_mask                                      (0x00000070)
#define  DFE_HDMI_RX_PHY_BG_reg_bg_rbg2_mask                                     (0x0000000C)
#define  DFE_HDMI_RX_PHY_BG_reg_bg_pow_mask                                      (0x00000002)
#define  DFE_HDMI_RX_PHY_BG_reg_bg_envbgup_mask                                  (0x00000001)
#define  DFE_HDMI_RX_PHY_BG_reg_bg_rbgloop2(data)                                (0x00000380&((data)<<7))
#define  DFE_HDMI_RX_PHY_BG_reg_bg_rbg(data)                                     (0x00000070&((data)<<4))
#define  DFE_HDMI_RX_PHY_BG_reg_bg_rbg2(data)                                    (0x0000000C&((data)<<2))
#define  DFE_HDMI_RX_PHY_BG_reg_bg_pow(data)                                     (0x00000002&((data)<<1))
#define  DFE_HDMI_RX_PHY_BG_reg_bg_envbgup(data)                                 (0x00000001&(data))
#define  DFE_HDMI_RX_PHY_BG_get_reg_bg_rbgloop2(data)                            ((0x00000380&(data))>>7)
#define  DFE_HDMI_RX_PHY_BG_get_reg_bg_rbg(data)                                 ((0x00000070&(data))>>4)
#define  DFE_HDMI_RX_PHY_BG_get_reg_bg_rbg2(data)                                ((0x0000000C&(data))>>2)
#define  DFE_HDMI_RX_PHY_BG_get_reg_bg_pow(data)                                 ((0x00000002&(data))>>1)
#define  DFE_HDMI_RX_PHY_BG_get_reg_bg_envbgup(data)                             (0x00000001&(data))

#define  DFE_HDMI_RX_PHY_MD                                                      0x1800DA04
#define  DFE_HDMI_RX_PHY_MD_reg_addr                                             "0xB800DA04"
#define  DFE_HDMI_RX_PHY_MD_reg                                                  0xB800DA04
#define  DFE_HDMI_RX_PHY_MD_inst_addr                                            "0x0001"
#define  set_DFE_HDMI_RX_PHY_MD_reg(data)                                        (*((volatile unsigned int*)DFE_HDMI_RX_PHY_MD_reg)=data)
#define  get_DFE_HDMI_RX_PHY_MD_reg                                              (*((volatile unsigned int*)DFE_HDMI_RX_PHY_MD_reg))
#define  DFE_HDMI_RX_PHY_MD_reg_ck_latch_shift                                   (4)
#define  DFE_HDMI_RX_PHY_MD_reg_ck_cmp_shift                                     (3)
#define  DFE_HDMI_RX_PHY_MD_reg_ck_ckdet_shift                                   (0)
#define  DFE_HDMI_RX_PHY_MD_reg_ck_latch_mask                                    (0x00000010)
#define  DFE_HDMI_RX_PHY_MD_reg_ck_cmp_mask                                      (0x00000008)
#define  DFE_HDMI_RX_PHY_MD_reg_ck_ckdet_mask                                    (0x00000007)
#define  DFE_HDMI_RX_PHY_MD_reg_ck_latch(data)                                   (0x00000010&((data)<<4))
#define  DFE_HDMI_RX_PHY_MD_reg_ck_cmp(data)                                     (0x00000008&((data)<<3))
#define  DFE_HDMI_RX_PHY_MD_reg_ck_ckdet(data)                                   (0x00000007&(data))
#define  DFE_HDMI_RX_PHY_MD_get_reg_ck_latch(data)                               ((0x00000010&(data))>>4)
#define  DFE_HDMI_RX_PHY_MD_get_reg_ck_cmp(data)                                 ((0x00000008&(data))>>3)
#define  DFE_HDMI_RX_PHY_MD_get_reg_ck_ckdet(data)                               (0x00000007&(data))

#define  DFE_HDMI_RX_PHY_LDO                                                     0x1800DA08
#define  DFE_HDMI_RX_PHY_LDO_reg_addr                                            "0xB800DA08"
#define  DFE_HDMI_RX_PHY_LDO_reg                                                 0xB800DA08
#define  DFE_HDMI_RX_PHY_LDO_inst_addr                                           "0x0002"
#define  set_DFE_HDMI_RX_PHY_LDO_reg(data)                                       (*((volatile unsigned int*)DFE_HDMI_RX_PHY_LDO_reg)=data)
#define  get_DFE_HDMI_RX_PHY_LDO_reg                                             (*((volatile unsigned int*)DFE_HDMI_RX_PHY_LDO_reg))
#define  DFE_HDMI_RX_PHY_LDO_reg_p2_ldo_sel_shift                                (7)
#define  DFE_HDMI_RX_PHY_LDO_reg_p1_ldo_sel_shift                                (5)
#define  DFE_HDMI_RX_PHY_LDO_reg_p0_ldo_sel_shift                                (3)
#define  DFE_HDMI_RX_PHY_LDO_reg_p2_ldo_pow_shift                                (2)
#define  DFE_HDMI_RX_PHY_LDO_reg_p1_ldo_pow_shift                                (1)
#define  DFE_HDMI_RX_PHY_LDO_reg_p0_ldo_pow_shift                                (0)
#define  DFE_HDMI_RX_PHY_LDO_reg_p2_ldo_sel_mask                                 (0x00000180)
#define  DFE_HDMI_RX_PHY_LDO_reg_p1_ldo_sel_mask                                 (0x00000060)
#define  DFE_HDMI_RX_PHY_LDO_reg_p0_ldo_sel_mask                                 (0x00000018)
#define  DFE_HDMI_RX_PHY_LDO_reg_p2_ldo_pow_mask                                 (0x00000004)
#define  DFE_HDMI_RX_PHY_LDO_reg_p1_ldo_pow_mask                                 (0x00000002)
#define  DFE_HDMI_RX_PHY_LDO_reg_p0_ldo_pow_mask                                 (0x00000001)
#define  DFE_HDMI_RX_PHY_LDO_reg_p2_ldo_sel(data)                                (0x00000180&((data)<<7))
#define  DFE_HDMI_RX_PHY_LDO_reg_p1_ldo_sel(data)                                (0x00000060&((data)<<5))
#define  DFE_HDMI_RX_PHY_LDO_reg_p0_ldo_sel(data)                                (0x00000018&((data)<<3))
#define  DFE_HDMI_RX_PHY_LDO_reg_p2_ldo_pow(data)                                (0x00000004&((data)<<2))
#define  DFE_HDMI_RX_PHY_LDO_reg_p1_ldo_pow(data)                                (0x00000002&((data)<<1))
#define  DFE_HDMI_RX_PHY_LDO_reg_p0_ldo_pow(data)                                (0x00000001&(data))
#define  DFE_HDMI_RX_PHY_LDO_get_reg_p2_ldo_sel(data)                            ((0x00000180&(data))>>7)
#define  DFE_HDMI_RX_PHY_LDO_get_reg_p1_ldo_sel(data)                            ((0x00000060&(data))>>5)
#define  DFE_HDMI_RX_PHY_LDO_get_reg_p0_ldo_sel(data)                            ((0x00000018&(data))>>3)
#define  DFE_HDMI_RX_PHY_LDO_get_reg_p2_ldo_pow(data)                            ((0x00000004&(data))>>2)
#define  DFE_HDMI_RX_PHY_LDO_get_reg_p1_ldo_pow(data)                            ((0x00000002&(data))>>1)
#define  DFE_HDMI_RX_PHY_LDO_get_reg_p0_ldo_pow(data)                            (0x00000001&(data))

#define  DFE_HDMI_RX_PHY_MHL                                                     0x1800DA0C
#define  DFE_HDMI_RX_PHY_MHL_reg_addr                                            "0xB800DA0C"
#define  DFE_HDMI_RX_PHY_MHL_reg                                                 0xB800DA0C
#define  DFE_HDMI_RX_PHY_MHL_inst_addr                                           "0x0003"
#define  set_DFE_HDMI_RX_PHY_MHL_reg(data)                                       (*((volatile unsigned int*)DFE_HDMI_RX_PHY_MHL_reg)=data)
#define  get_DFE_HDMI_RX_PHY_MHL_reg                                             (*((volatile unsigned int*)DFE_HDMI_RX_PHY_MHL_reg))
#define  DFE_HDMI_RX_PHY_MHL_reg_p2_mhl_hdmi_datasel_shift                       (9)
#define  DFE_HDMI_RX_PHY_MHL_reg_p2_mhl_hdmi_cksel_shift                         (8)
#define  DFE_HDMI_RX_PHY_MHL_reg_p2_mhl_pow_shift                                (7)
#define  DFE_HDMI_RX_PHY_MHL_reg_p1_mhl_hdmi_datasel_shift                       (6)
#define  DFE_HDMI_RX_PHY_MHL_reg_p1_mhl_hdmi_cksel_shift                         (5)
#define  DFE_HDMI_RX_PHY_MHL_reg_p1_mhl_pow_shift                                (4)
#define  DFE_HDMI_RX_PHY_MHL_reg_p0_mhl_hdmi_cksel_shift                         (3)
#define  DFE_HDMI_RX_PHY_MHL_reg_p0_mhl_hdmi_datasel_shift                       (2)
#define  DFE_HDMI_RX_PHY_MHL_reg_p0_mhl_pow_shift                                (1)
#define  DFE_HDMI_RX_PHY_MHL_reg_mhl_hdmisel_shift                               (0)
#define  DFE_HDMI_RX_PHY_MHL_reg_p2_mhl_hdmi_datasel_mask                        (0x00000200)
#define  DFE_HDMI_RX_PHY_MHL_reg_p2_mhl_hdmi_cksel_mask                          (0x00000100)
#define  DFE_HDMI_RX_PHY_MHL_reg_p2_mhl_pow_mask                                 (0x00000080)
#define  DFE_HDMI_RX_PHY_MHL_reg_p1_mhl_hdmi_datasel_mask                        (0x00000040)
#define  DFE_HDMI_RX_PHY_MHL_reg_p1_mhl_hdmi_cksel_mask                          (0x00000020)
#define  DFE_HDMI_RX_PHY_MHL_reg_p1_mhl_pow_mask                                 (0x00000010)
#define  DFE_HDMI_RX_PHY_MHL_reg_p0_mhl_hdmi_cksel_mask                          (0x00000008)
#define  DFE_HDMI_RX_PHY_MHL_reg_p0_mhl_hdmi_datasel_mask                        (0x00000004)
#define  DFE_HDMI_RX_PHY_MHL_reg_p0_mhl_pow_mask                                 (0x00000002)
#define  DFE_HDMI_RX_PHY_MHL_reg_mhl_hdmisel_mask                                (0x00000001)
#define  DFE_HDMI_RX_PHY_MHL_reg_p2_mhl_hdmi_datasel(data)                       (0x00000200&((data)<<9))
#define  DFE_HDMI_RX_PHY_MHL_reg_p2_mhl_hdmi_cksel(data)                         (0x00000100&((data)<<8))
#define  DFE_HDMI_RX_PHY_MHL_reg_p2_mhl_pow(data)                                (0x00000080&((data)<<7))
#define  DFE_HDMI_RX_PHY_MHL_reg_p1_mhl_hdmi_datasel(data)                       (0x00000040&((data)<<6))
#define  DFE_HDMI_RX_PHY_MHL_reg_p1_mhl_hdmi_cksel(data)                         (0x00000020&((data)<<5))
#define  DFE_HDMI_RX_PHY_MHL_reg_p1_mhl_pow(data)                                (0x00000010&((data)<<4))
#define  DFE_HDMI_RX_PHY_MHL_reg_p0_mhl_hdmi_cksel(data)                         (0x00000008&((data)<<3))
#define  DFE_HDMI_RX_PHY_MHL_reg_p0_mhl_hdmi_datasel(data)                       (0x00000004&((data)<<2))
#define  DFE_HDMI_RX_PHY_MHL_reg_p0_mhl_pow(data)                                (0x00000002&((data)<<1))
#define  DFE_HDMI_RX_PHY_MHL_reg_mhl_hdmisel(data)                               (0x00000001&(data))
#define  DFE_HDMI_RX_PHY_MHL_get_reg_p2_mhl_hdmi_datasel(data)                   ((0x00000200&(data))>>9)
#define  DFE_HDMI_RX_PHY_MHL_get_reg_p2_mhl_hdmi_cksel(data)                     ((0x00000100&(data))>>8)
#define  DFE_HDMI_RX_PHY_MHL_get_reg_p2_mhl_pow(data)                            ((0x00000080&(data))>>7)
#define  DFE_HDMI_RX_PHY_MHL_get_reg_p1_mhl_hdmi_datasel(data)                   ((0x00000040&(data))>>6)
#define  DFE_HDMI_RX_PHY_MHL_get_reg_p1_mhl_hdmi_cksel(data)                     ((0x00000020&(data))>>5)
#define  DFE_HDMI_RX_PHY_MHL_get_reg_p1_mhl_pow(data)                            ((0x00000010&(data))>>4)
#define  DFE_HDMI_RX_PHY_MHL_get_reg_p0_mhl_hdmi_cksel(data)                     ((0x00000008&(data))>>3)
#define  DFE_HDMI_RX_PHY_MHL_get_reg_p0_mhl_hdmi_datasel(data)                   ((0x00000004&(data))>>2)
#define  DFE_HDMI_RX_PHY_MHL_get_reg_p0_mhl_pow(data)                            ((0x00000002&(data))>>1)
#define  DFE_HDMI_RX_PHY_MHL_get_reg_mhl_hdmisel(data)                           (0x00000001&(data))

#define  DFE_HDMI_RX_PHY_P0_ACDR1                                                0x1800DA10
#define  DFE_HDMI_RX_PHY_P0_ACDR1_reg_addr                                       "0xB800DA10"
#define  DFE_HDMI_RX_PHY_P0_ACDR1_reg                                            0xB800DA10
#define  DFE_HDMI_RX_PHY_P0_ACDR1_inst_addr                                      "0x0004"
#define  set_DFE_HDMI_RX_PHY_P0_ACDR1_reg(data)                                  (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P0_ACDR1_reg)=data)
#define  get_DFE_HDMI_RX_PHY_P0_ACDR1_reg                                        (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P0_ACDR1_reg))
#define  DFE_HDMI_RX_PHY_P0_ACDR1_reg_p0_acdr_4_shift                            (24)
#define  DFE_HDMI_RX_PHY_P0_ACDR1_reg_p0_acdr_3_shift                            (16)
#define  DFE_HDMI_RX_PHY_P0_ACDR1_reg_p0_acdr_2_shift                            (8)
#define  DFE_HDMI_RX_PHY_P0_ACDR1_reg_p0_acdr_1_shift                            (0)
#define  DFE_HDMI_RX_PHY_P0_ACDR1_reg_p0_acdr_4_mask                             (0xFF000000)
#define  DFE_HDMI_RX_PHY_P0_ACDR1_reg_p0_acdr_3_mask                             (0x00FF0000)
#define  DFE_HDMI_RX_PHY_P0_ACDR1_reg_p0_acdr_2_mask                             (0x0000FF00)
#define  DFE_HDMI_RX_PHY_P0_ACDR1_reg_p0_acdr_1_mask                             (0x000000FF)
#define  DFE_HDMI_RX_PHY_P0_ACDR1_reg_p0_acdr_4(data)                            (0xFF000000&((data)<<24))
#define  DFE_HDMI_RX_PHY_P0_ACDR1_reg_p0_acdr_3(data)                            (0x00FF0000&((data)<<16))
#define  DFE_HDMI_RX_PHY_P0_ACDR1_reg_p0_acdr_2(data)                            (0x0000FF00&((data)<<8))
#define  DFE_HDMI_RX_PHY_P0_ACDR1_reg_p0_acdr_1(data)                            (0x000000FF&(data))
#define  DFE_HDMI_RX_PHY_P0_ACDR1_get_reg_p0_acdr_4(data)                        ((0xFF000000&(data))>>24)
#define  DFE_HDMI_RX_PHY_P0_ACDR1_get_reg_p0_acdr_3(data)                        ((0x00FF0000&(data))>>16)
#define  DFE_HDMI_RX_PHY_P0_ACDR1_get_reg_p0_acdr_2(data)                        ((0x0000FF00&(data))>>8)
#define  DFE_HDMI_RX_PHY_P0_ACDR1_get_reg_p0_acdr_1(data)                        (0x000000FF&(data))
#define  p0_REG_ACDR_CPCVM_EN                     (_BIT26)
#define  p0_REG_ACDR_VCOGAIN                       (_BIT21|_BIT20)
#define  p0_REG_ACDR_LFRS_SEL                      (_BIT15|_BIT14|_BIT13)
#define  p0_REG_ACDR_CKFLD_EN                     (_BIT5)
#define  p0_REG_ACDR_EN                                 (_BIT1)
#define  p0_REG_ACDR_TOP_EN                         (_BIT0)

#define  DFE_HDMI_RX_PHY_P0_ACDR2                                                0x1800DA14
#define  DFE_HDMI_RX_PHY_P0_ACDR2_reg_addr                                       "0xB800DA14"
#define  DFE_HDMI_RX_PHY_P0_ACDR2_reg                                            0xB800DA14
#define  DFE_HDMI_RX_PHY_P0_ACDR2_inst_addr                                      "0x0005"
#define  set_DFE_HDMI_RX_PHY_P0_ACDR2_reg(data)                                  (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P0_ACDR2_reg)=data)
#define  get_DFE_HDMI_RX_PHY_P0_ACDR2_reg                                        (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P0_ACDR2_reg))
#define  DFE_HDMI_RX_PHY_P0_ACDR2_reg_p0_acdr_8_shift                            (24)
#define  DFE_HDMI_RX_PHY_P0_ACDR2_reg_p0_acdr_7_shift                            (16)
#define  DFE_HDMI_RX_PHY_P0_ACDR2_reg_p0_acdr_6_shift                            (8)
#define  DFE_HDMI_RX_PHY_P0_ACDR2_reg_p0_acdr_5_shift                            (0)
#define  DFE_HDMI_RX_PHY_P0_ACDR2_reg_p0_acdr_8_mask                             (0xFF000000)
#define  DFE_HDMI_RX_PHY_P0_ACDR2_reg_p0_acdr_7_mask                             (0x00FF0000)
#define  DFE_HDMI_RX_PHY_P0_ACDR2_reg_p0_acdr_6_mask                             (0x0000FF00)
#define  DFE_HDMI_RX_PHY_P0_ACDR2_reg_p0_acdr_5_mask                             (0x000000FF)
#define  DFE_HDMI_RX_PHY_P0_ACDR2_reg_p0_acdr_8(data)                            (0xFF000000&((data)<<24))
#define  DFE_HDMI_RX_PHY_P0_ACDR2_reg_p0_acdr_7(data)                            (0x00FF0000&((data)<<16))
#define  DFE_HDMI_RX_PHY_P0_ACDR2_reg_p0_acdr_6(data)                            (0x0000FF00&((data)<<8))
#define  DFE_HDMI_RX_PHY_P0_ACDR2_reg_p0_acdr_5(data)                            (0x000000FF&(data))
#define  DFE_HDMI_RX_PHY_P0_ACDR2_get_reg_p0_acdr_8(data)                        ((0xFF000000&(data))>>24)
#define  DFE_HDMI_RX_PHY_P0_ACDR2_get_reg_p0_acdr_7(data)                        ((0x00FF0000&(data))>>16)
#define  DFE_HDMI_RX_PHY_P0_ACDR2_get_reg_p0_acdr_6(data)                        ((0x0000FF00&(data))>>8)
#define  DFE_HDMI_RX_PHY_P0_ACDR2_get_reg_p0_acdr_5(data)                        (0x000000FF&(data))

#define  DFE_HDMI_RX_PHY_P0_B1                                                   0x1800DA18
#define  DFE_HDMI_RX_PHY_P0_B1_reg_addr                                          "0xB800DA18"
#define  DFE_HDMI_RX_PHY_P0_B1_reg                                               0xB800DA18
#define  DFE_HDMI_RX_PHY_P0_B1_inst_addr                                         "0x0006"
#define  set_DFE_HDMI_RX_PHY_P0_B1_reg(data)                                     (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P0_B1_reg)=data)
#define  get_DFE_HDMI_RX_PHY_P0_B1_reg                                           (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P0_B1_reg))
#define  DFE_HDMI_RX_PHY_P0_B1_reg_p0_b_4_shift                                  (24)
#define  DFE_HDMI_RX_PHY_P0_B1_reg_p0_b_3_shift                                  (16)
#define  DFE_HDMI_RX_PHY_P0_B1_reg_p0_b_2_shift                                  (8)
#define  DFE_HDMI_RX_PHY_P0_B1_reg_p0_b_1_shift                                  (0)
#define  DFE_HDMI_RX_PHY_P0_B1_reg_p0_b_4_mask                                   (0xFF000000)
#define  DFE_HDMI_RX_PHY_P0_B1_reg_p0_b_3_mask                                   (0x00FF0000)
#define  DFE_HDMI_RX_PHY_P0_B1_reg_p0_b_2_mask                                   (0x0000FF00)
#define  DFE_HDMI_RX_PHY_P0_B1_reg_p0_b_1_mask                                   (0x000000FF)
#define  DFE_HDMI_RX_PHY_P0_B1_reg_p0_b_4(data)                                  (0xFF000000&((data)<<24))
#define  DFE_HDMI_RX_PHY_P0_B1_reg_p0_b_3(data)                                  (0x00FF0000&((data)<<16))
#define  DFE_HDMI_RX_PHY_P0_B1_reg_p0_b_2(data)                                  (0x0000FF00&((data)<<8))
#define  DFE_HDMI_RX_PHY_P0_B1_reg_p0_b_1(data)                                  (0x000000FF&(data))
#define  DFE_HDMI_RX_PHY_P0_B1_get_reg_p0_b_4(data)                              ((0xFF000000&(data))>>24)
#define  DFE_HDMI_RX_PHY_P0_B1_get_reg_p0_b_3(data)                              ((0x00FF0000&(data))>>16)
#define  DFE_HDMI_RX_PHY_P0_B1_get_reg_p0_b_2(data)                              ((0x0000FF00&(data))>>8)
#define  DFE_HDMI_RX_PHY_P0_B1_get_reg_p0_b_1(data)                              (0x000000FF&(data))
#define  P0_b_1_inputoff                                                                      		(_BIT0)
#define  P0_b_1_FORE_KOFF_RANGE                                                                    (_BIT22|_BIT21)
#define  P0_b_4_FORE_KOFF_AUTOK                                                                    (_BIT28)
#define  P0_b_CLK_PIX2_RATE_SEL						(_BIT26)
#define  P0_b_DEMUX_BBPD_RSTB                                                                       (_BIT25)
#define  P0_b_4_FORE_POW_FORE_KOFF                                                                  (_BIT24)
#define  P0_b_3_FORE_EN_FORE_KOFF                                                                    (_BIT23)


#define  DFE_HDMI_RX_PHY_P0_B2                                                   0x1800DA1C
#define  DFE_HDMI_RX_PHY_P0_B2_reg_addr                                          "0xB800DA1C"
#define  DFE_HDMI_RX_PHY_P0_B2_reg                                               0xB800DA1C
#define  DFE_HDMI_RX_PHY_P0_B2_inst_addr                                         "0x0007"
#define  set_DFE_HDMI_RX_PHY_P0_B2_reg(data)                                     (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P0_B2_reg)=data)
#define  get_DFE_HDMI_RX_PHY_P0_B2_reg                                           (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P0_B2_reg))
#define  DFE_HDMI_RX_PHY_P0_B2_reg_p0_b_8_shift                                  (24)
#define  DFE_HDMI_RX_PHY_P0_B2_reg_p0_b_7_shift                                  (16)
#define  DFE_HDMI_RX_PHY_P0_B2_reg_p0_b_6_shift                                  (8)
#define  DFE_HDMI_RX_PHY_P0_B2_reg_p0_b_5_shift                                  (0)
#define  DFE_HDMI_RX_PHY_P0_B2_reg_p0_b_8_mask                                   (0xFF000000)
#define  DFE_HDMI_RX_PHY_P0_B2_reg_p0_b_7_mask                                   (0x00FF0000)
#define  DFE_HDMI_RX_PHY_P0_B2_reg_p0_b_6_mask                                   (0x0000FF00)
#define  DFE_HDMI_RX_PHY_P0_B2_reg_p0_b_5_mask                                   (0x000000FF)
#define  DFE_HDMI_RX_PHY_P0_B2_reg_p0_b_8(data)                                  (0xFF000000&((data)<<24))
#define  DFE_HDMI_RX_PHY_P0_B2_reg_p0_b_7(data)                                  (0x00FF0000&((data)<<16))
#define  DFE_HDMI_RX_PHY_P0_B2_reg_p0_b_6(data)                                  (0x0000FF00&((data)<<8))
#define  DFE_HDMI_RX_PHY_P0_B2_reg_p0_b_5(data)                                  (0x000000FF&(data))
#define  DFE_HDMI_RX_PHY_P0_B2_get_reg_p0_b_8(data)                              ((0xFF000000&(data))>>24)
#define  DFE_HDMI_RX_PHY_P0_B2_get_reg_p0_b_7(data)                              ((0x00FF0000&(data))>>16)
#define  DFE_HDMI_RX_PHY_P0_B2_get_reg_p0_b_6(data)                              ((0x0000FF00&(data))>>8)
#define  DFE_HDMI_RX_PHY_P0_B2_get_reg_p0_b_5(data)                              (0x000000FF&(data))

#define  DFE_HDMI_RX_PHY_P0_B2_reg_p0_b_8_PR_RATE_SEL_shift             (26)
#define  DFE_HDMI_RX_PHY_P0_B2_reg_p0_b_8_DEMUX_shift             (29)
#define  DFE_HDMI_RX_PHY_P0_B2_reg_p0_b_7_TAP0_ISEL_shift                 (21)
#define  P0_b_8_DEMUX                                                                                             (_BIT29|_BIT30|_BIT31)
#define  P0_b_8_PR_RATE_SEL                                                                                    (_BIT26|_BIT27|_BIT28)
#define  P0_b_8_POW_PR                                                                                            _BIT25
#define  P0_b_7_TAP0_ISEL                                                                                         (_BIT21|_BIT22|_BIT23)
#define  P0_b_7_TAP0_ISEL_400uA                                                                              (_BIT22|_BIT23)
#define  P0_b_7_LEQ_ISEL                                                                                           (_BIT18|_BIT19|_BIT20)
#define  P0_b_7_LEQ_ISEL_400uA                                                                                (_BIT19|_BIT20)
#define  P0_b_7_LEQ_ISEL_200uA                                                                                (_BIT20)
#define  P0_b_7_PI_ISEL                                                                                              (_BIT16|_BIT17)
#define  P0_b_6_LEQ_BIT_RATE                                                                                    (_BIT14|_BIT15)
#define  P0_b_6_LEQ_BIT_RATE_HBR                                                                            (_BIT15)
#define  P0_b_6_LEQ_BIT_RATE_MBR                                                                            (_BIT14)
#define  P0_b_6_TAP0_HBR                                                                              	        (_BIT13)
#define  P0_b_6_LEQ_PASSIVE_CORNER                                                                      (_BIT12|_BIT11)
#define  P0_b_5_LEQ_CURRENT_ADJ                                                                            (_BIT3|_BIT4)
#define  P0_b_5_LEQ_CURRENT_ADJ_1X                                                                            (_BIT3)
#define  P0_b_5_LEQ_CURRENT_ADJ_1p25X                                                                       (_BIT4)
#define  P0_b_5_EQ_POW                                                                                             _BIT0




#define  DFE_HDMI_RX_PHY_P0_B3                                                   0x1800DA20
#define  DFE_HDMI_RX_PHY_P0_B3_reg_addr                                          "0xB800DA20"
#define  DFE_HDMI_RX_PHY_P0_B3_reg                                               0xB800DA20
#define  DFE_HDMI_RX_PHY_P0_B3_inst_addr                                         "0x0008"
#define  set_DFE_HDMI_RX_PHY_P0_B3_reg(data)                                     (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P0_B3_reg)=data)
#define  get_DFE_HDMI_RX_PHY_P0_B3_reg                                           (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P0_B3_reg))
#define  DFE_HDMI_RX_PHY_P0_B3_reg_p0_b_12_shift                                 (24)
#define  DFE_HDMI_RX_PHY_P0_B3_reg_p0_b_12_PR_shift                            (24)
#define  DFE_HDMI_RX_PHY_P0_B3_reg_p0_b_11_shift                                 (16)
#define  DFE_HDMI_RX_PHY_P0_B3_reg_p0_b_10_shift                                 (8)
#define  DFE_HDMI_RX_PHY_P0_B3_reg_p0_b_9_shift                                  (0)
#define  DFE_HDMI_RX_PHY_P0_B3_reg_p0_b_12_mask                                  (0xFF000000)
#define  DFE_HDMI_RX_PHY_P0_B3_reg_p0_b_11_mask                                  (0x00FF0000)
#define  DFE_HDMI_RX_PHY_P0_B3_reg_p0_b_10_mask                                  (0x0000FF00)
#define  DFE_HDMI_RX_PHY_P0_B3_reg_p0_b_9_mask                                   (0x000000FF)
#define  DFE_HDMI_RX_PHY_P0_B3_reg_p0_b_12(data)                                 (0xFF000000&((data)<<24))
#define  DFE_HDMI_RX_PHY_P0_B3_reg_p0_b_11(data)                                 (0x00FF0000&((data)<<16))
#define  DFE_HDMI_RX_PHY_P0_B3_reg_p0_b_10(data)                                 (0x0000FF00&((data)<<8))
#define  DFE_HDMI_RX_PHY_P0_B3_reg_p0_b_9(data)                                  (0x000000FF&(data))
#define  DFE_HDMI_RX_PHY_P0_B3_get_reg_p0_b_12(data)                             ((0xFF000000&(data))>>24)
#define  DFE_HDMI_RX_PHY_P0_B3_get_reg_p0_b_11(data)                             ((0x00FF0000&(data))>>16)
#define  DFE_HDMI_RX_PHY_P0_B3_get_reg_p0_b_10(data)                             ((0x0000FF00&(data))>>8)
#define  DFE_HDMI_RX_PHY_P0_B3_get_reg_p0_b_9(data)                              (0x000000FF&(data))
#define P0_B_DFE_TAPEN4321                                                                              (_BIT6|_BIT5|_BIT4|_BIT3)
#define P0_b_12_PR 														 (_BIT24|_BIT25)
#define P0_b_9_DFE_ADAPTION_POW_EN 								              (_BIT7)
#define P0_b_9_DFE_TAP_EN 								                           (_BIT3|_BIT4|_BIT5|_BIT6)
#define P0_b_9_DFE_TAP1_EN 								                           (_BIT3)
#define  DFE_HDMI_RX_PHY_P0_b_tap_en(data)                                                           (0x00000078&((data)<<3))
#define P0_b_11_ACDR_RATE_SEL_HALF_RATE 								 (_BIT16)
#define P0_b_10_DFE_SUMAMP_LP_MANUALOFF								 (_BIT15)
#define P0_b_10_DFE_SUMAMP_ISEL_mask 								              (_BIT11|_BIT12|_BIT13)
#define P0_b_10_DFE_SUMAMP_ISEL_400uA 								              (_BIT13)
#define P0_b_10_DFE_PREAMP_ISEL_mask 								                    (_BIT8|_BIT9|_BIT10)
#define P0_b_10_DFE_PREAMP_ISEL_400uA 								                    (_BIT10)



#define  DFE_HDMI_RX_PHY_P0_B4                                                   0x1800DA24
#define  DFE_HDMI_RX_PHY_P0_B4_reg_addr                                          "0xB800DA24"
#define  DFE_HDMI_RX_PHY_P0_B4_reg                                               0xB800DA24
#define  DFE_HDMI_RX_PHY_P0_B4_inst_addr                                         "0x0009"
#define  set_DFE_HDMI_RX_PHY_P0_B4_reg(data)                                     (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P0_B4_reg)=data)
#define  get_DFE_HDMI_RX_PHY_P0_B4_reg                                           (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P0_B4_reg))
#define  DFE_HDMI_RX_PHY_P0_B4_reg_p0_b_koff_sel_shift                           (10)
#define  DFE_HDMI_RX_PHY_P0_B4_reg_p0_b_koff_bound_shift                         (9)
#define  DFE_HDMI_RX_PHY_P0_B4_reg_p0_b_koffok_shift                             (8)
#define  DFE_HDMI_RX_PHY_P0_B4_reg_p0_b_13_shift                                 (0)
#define  DFE_HDMI_RX_PHY_P0_B4_reg_p0_b_koff_sel_mask                            (0x00007C00)
#define  DFE_HDMI_RX_PHY_P0_B4_reg_p0_b_koff_bound_mask                          (0x00000200)
#define  DFE_HDMI_RX_PHY_P0_B4_reg_p0_b_koffok_mask                              (0x00000100)
#define  DFE_HDMI_RX_PHY_P0_B4_reg_p0_b_13_mask                                  (0x000000FF)
#define  DFE_HDMI_RX_PHY_P0_B4_reg_p0_b_koff_sel(data)                           (0x00007C00&((data)<<10))
#define  DFE_HDMI_RX_PHY_P0_B4_reg_p0_b_koff_bound(data)                         (0x00000200&((data)<<9))
#define  DFE_HDMI_RX_PHY_P0_B4_reg_p0_b_koffok(data)                             (0x00000100&((data)<<8))
#define  DFE_HDMI_RX_PHY_P0_B4_reg_p0_b_13(data)                                 (0x000000FF&(data))
#define  DFE_HDMI_RX_PHY_P0_B4_get_reg_p0_b_koff_sel(data)                       ((0x00007C00&(data))>>10)
#define  DFE_HDMI_RX_PHY_P0_B4_get_reg_p0_b_koff_bound(data)                     ((0x00000200&(data))>>9)
#define  DFE_HDMI_RX_PHY_P0_B4_get_reg_p0_b_koffok(data)                         ((0x00000100&(data))>>8)
#define  DFE_HDMI_RX_PHY_P0_B4_get_reg_p0_b_13(data)                             (0x000000FF&(data))

#define  DFE_HDMI_RX_PHY_P0_CK1                                                  0x1800DA28
#define  DFE_HDMI_RX_PHY_P0_CK1_reg_addr                                         "0xB800DA28"
#define  DFE_HDMI_RX_PHY_P0_CK1_reg                                              0xB800DA28
#define  DFE_HDMI_RX_PHY_P0_CK1_inst_addr                                        "0x000A"
#define  set_DFE_HDMI_RX_PHY_P0_CK1_reg(data)                                    (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P0_CK1_reg)=data)
#define  get_DFE_HDMI_RX_PHY_P0_CK1_reg                                          (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P0_CK1_reg))
#define  DFE_HDMI_RX_PHY_P0_CK1_reg_p0_ck_4_shift                                (24)
#define  DFE_HDMI_RX_PHY_P0_CK1_reg_p0_ck_3_shift                                (16)
#define  DFE_HDMI_RX_PHY_P0_CK1_reg_p0_ck_2_shift                                (8)
#define  DFE_HDMI_RX_PHY_P0_CK1_reg_p0_ck_1_shift                                (0)
#define  DFE_HDMI_RX_PHY_P0_CK1_reg_p0_ck_3_CMU_N_code_shift            (18)
#define  DFE_HDMI_RX_PHY_P0_CK1_reg_p0_ck_4_mask                                 (0xFF000000)
#define  DFE_HDMI_RX_PHY_P0_CK1_reg_p0_ck_3_mask                                 (0x00FF0000)
#define  DFE_HDMI_RX_PHY_P0_CK1_reg_p0_ck_2_mask                                 (0x0000FF00)
#define  DFE_HDMI_RX_PHY_P0_CK1_reg_p0_ck_1_mask                                 (0x000000FF)
#define  DFE_HDMI_RX_PHY_P0_CK1_reg_p0_ck_4(data)                                (0xFF000000&((data)<<24))
#define  DFE_HDMI_RX_PHY_P0_CK1_reg_p0_ck_3(data)                                (0x00FF0000&((data)<<16))
#define  DFE_HDMI_RX_PHY_P0_CK1_reg_p0_ck_2(data)                                (0x0000FF00&((data)<<8))
#define  DFE_HDMI_RX_PHY_P0_CK1_reg_p0_ck_1(data)                                (0x000000FF&(data))
#define  DFE_HDMI_RX_PHY_P0_CK1_get_reg_p0_ck_4(data)                            ((0xFF000000&(data))>>24)
#define  DFE_HDMI_RX_PHY_P0_CK1_get_reg_p0_ck_3(data)                            ((0x00FF0000&(data))>>16)
#define  DFE_HDMI_RX_PHY_P0_CK1_get_reg_p0_ck_2(data)                            ((0x0000FF00&(data))>>8)
#define  DFE_HDMI_RX_PHY_P0_CK1_get_reg_p0_ck_1(data)                            (0x000000FF&(data))
#define  p0_ck_3_CMU_PREDIVN                                                                          (_BIT20|_BIT21|_BIT22|_BIT23)
#define  p0_ck_3_CMU_N_code                                                                          (_BIT18|_BIT19)
#define  p0_ck_2_CMU_CKIN_SEL                                                                   (_BIT12|_BIT13|_BIT14|_BIT15)
#define  p0_CMU_CKOUT_SEL                                                                             (_BIT11)
#define  p0_ck_2_CK_MD_REF_SEL                                                                   _BIT9
#define  p0_ck_1_port_bias                                                                              _BIT2
#define  p0_ck_1_CKAFE_POW                                                                          _BIT1


#define  DFE_HDMI_RX_PHY_P0_CK2                                                  0x1800DA2C
#define  DFE_HDMI_RX_PHY_P0_CK2_reg_addr                                         "0xB800DA2C"
#define  DFE_HDMI_RX_PHY_P0_CK2_reg                                              0xB800DA2C
#define  DFE_HDMI_RX_PHY_P0_CK2_inst_addr                                        "0x000B"
#define  set_DFE_HDMI_RX_PHY_P0_CK2_reg(data)                                    (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P0_CK2_reg)=data)
#define  get_DFE_HDMI_RX_PHY_P0_CK2_reg                                          (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P0_CK2_reg))
#define  DFE_HDMI_RX_PHY_P0_CK2_reg_p0_ck_8_shift                                (24)
#define  DFE_HDMI_RX_PHY_P0_CK2_reg_p0_ck_7_shift                                (16)
#define  DFE_HDMI_RX_PHY_P0_CK2_reg_p0_ck_6_shift                                (8)
#define  DFE_HDMI_RX_PHY_P0_CK2_reg_p0_ck_5_shift                                (0)
#define  DFE_HDMI_RX_PHY_P0_CK2_reg_p0_ck_8_mask                                 (0xFF000000)
#define  DFE_HDMI_RX_PHY_P0_CK2_reg_p0_ck_7_mask                                 (0x00FF0000)
#define  DFE_HDMI_RX_PHY_P0_CK2_reg_p0_ck_6_mask                                 (0x0000FF00)
#define  DFE_HDMI_RX_PHY_P0_CK2_reg_p0_ck_5_mask                                 (0x000000FF)
#define  DFE_HDMI_RX_PHY_P0_CK2_reg_p0_ck_8(data)                                (0xFF000000&((data)<<24))
#define  DFE_HDMI_RX_PHY_P0_CK2_reg_p0_ck_7(data)                                (0x00FF0000&((data)<<16))
#define  DFE_HDMI_RX_PHY_P0_CK2_reg_p0_ck_6(data)                                (0x0000FF00&((data)<<8))
#define  DFE_HDMI_RX_PHY_P0_CK2_reg_p0_ck_5(data)                                (0x000000FF&(data))
#define  DFE_HDMI_RX_PHY_P0_CK2_get_reg_p0_ck_8(data)                            ((0xFF000000&(data))>>24)
#define  DFE_HDMI_RX_PHY_P0_CK2_get_reg_p0_ck_7(data)                            ((0x00FF0000&(data))>>16)
#define  DFE_HDMI_RX_PHY_P0_CK2_get_reg_p0_ck_6(data)                            ((0x0000FF00&(data))>>8)
#define  DFE_HDMI_RX_PHY_P0_CK2_get_reg_p0_ck_5(data)                            (0x000000FF&(data))
#define P0_ck_8_LDO_EN                                                                                  _BIT25
#define  P0_ck_8_VSEL_LDO_A_mask                                                                   (_BIT29|_BIT30|_BIT31)
#define  P0_ck_8_VSEL_LDO_D_mask                                                                   (_BIT26|_BIT27|_BIT28)
#define  P0_ck_8_LDO_EN_mask                                                                          (_BIT25)
#define  P0_ck_8_CMU_BPPSR_mask                                                                          (_BIT24)
#define  P0_ck_7_CMU_BYPASS_PI_mask                                                              (_BIT19)
#define  P0_ck_7_CMU_PI_I_SEL_mask                                                                 (_BIT16|_BIT17|_BIT18)
#define  P0_ck_6_CMU_BIG_KVCO_mask                                                                 (_BIT13)
#define  P0_ck_6_CMU_EN_CAP_mask                                                                     (_BIT12)
#define  P0_ck_6_CMU_SEL_CS_mask                                                                     (_BIT8|_BIT9|_BIT10)
#define  P0_ck_5_CMU_SEL_PUMP_I_mask                                                               (_BIT4|_BIT5|_BIT6|_BIT7)
#define  P0_ck_5_CMU_SEL_R1_mask                                                                       (_BIT0|_BIT1|_BIT2)
#define  DFE_HDMI_RX_PHY_P0_VSEL_LDO_D(data)                            (0x1C000000&((data)<<26))
#define  DFE_HDMI_RX_PHY_P0_CMU_BPPSR(data)                            (0x01000000&((data)<<24))
#define  DFE_HDMI_RX_PHY_P0_CMU_SEL_CS(data)                            (0x00000700&((data)<<8))
#define  DFE_HDMI_RX_PHY_P0_CMU_SEL_PUMP_I(data)                            (0x000000F0&((data)<<4))
#define  DFE_HDMI_RX_PHY_P0_CMU_SEL_R1(data)                            (0x00000007&((data)<<0))

#define  DFE_HDMI_RX_PHY_P0_CK3                                                  0x1800DA30
#define  DFE_HDMI_RX_PHY_P0_CK3_reg_addr                                         "0xB800DA30"
#define  DFE_HDMI_RX_PHY_P0_CK3_reg                                              0xB800DA30
#define  DFE_HDMI_RX_PHY_P0_CK3_inst_addr                                        "0x000C"
#define  set_DFE_HDMI_RX_PHY_P0_CK3_reg(data)                                    (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P0_CK3_reg)=data)
#define  get_DFE_HDMI_RX_PHY_P0_CK3_reg                                          (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P0_CK3_reg))
#define  DFE_HDMI_RX_PHY_P0_CK3_reg_p0_ck_12_shift                               (24)
#define  DFE_HDMI_RX_PHY_P0_CK3_reg_p0_ck_11_shift                               (16)
#define  DFE_HDMI_RX_PHY_P0_CK3_reg_p0_ck_10_shift                               (8)
#define  DFE_HDMI_RX_PHY_P0_CK3_reg_p0_ck_9_shift                                (0)
#define  DFE_HDMI_RX_PHY_P0_CK3_reg_p0_ck_12_mask                                (0xFF000000)
#define  DFE_HDMI_RX_PHY_P0_CK3_reg_p0_ck_11_mask                                (0x00FF0000)
#define  DFE_HDMI_RX_PHY_P0_CK3_reg_p0_ck_10_mask                                (0x0000FF00)
#define  DFE_HDMI_RX_PHY_P0_CK3_reg_p0_ck_9_mask                                 (0x000000FF)
#define  DFE_HDMI_RX_PHY_P0_CK3_reg_p0_ck_12(data)                               (0xFF000000&((data)<<24))
#define  DFE_HDMI_RX_PHY_P0_CK3_reg_p0_ck_11(data)                               (0x00FF0000&((data)<<16))
#define  DFE_HDMI_RX_PHY_P0_CK3_reg_p0_ck_10(data)                               (0x0000FF00&((data)<<8))
#define  DFE_HDMI_RX_PHY_P0_CK3_reg_p0_ck_9(data)                                (0x000000FF&(data))
#define  DFE_HDMI_RX_PHY_P0_CK3_get_reg_p0_ck_12(data)                           ((0xFF000000&(data))>>24)
#define  DFE_HDMI_RX_PHY_P0_CK3_get_reg_p0_ck_11(data)                           ((0x00FF0000&(data))>>16)
#define  DFE_HDMI_RX_PHY_P0_CK3_get_reg_p0_ck_10(data)                           ((0x0000FF00&(data))>>8)
#define  DFE_HDMI_RX_PHY_P0_CK3_get_reg_p0_ck_9(data)                            (0x000000FF&(data))
#define  P0_ck_9_CMU_PFD_RSTB                                                                          (_BIT5)
#define  P0_ck_9_CMU_WDRST                                                                          (_BIT2)

#define  DFE_HDMI_RX_PHY_P0_CK4                                                  0x1800DA34
#define  DFE_HDMI_RX_PHY_P0_CK4_reg_addr                                         "0xB800DA34"
#define  DFE_HDMI_RX_PHY_P0_CK4_reg                                              0xB800DA34
#define  DFE_HDMI_RX_PHY_P0_CK4_inst_addr                                        "0x000D"
#define  set_DFE_HDMI_RX_PHY_P0_CK4_reg(data)                                    (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P0_CK4_reg)=data)
#define  get_DFE_HDMI_RX_PHY_P0_CK4_reg                                          (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P0_CK4_reg))
#define  DFE_HDMI_RX_PHY_P0_CK4_reg_p0_ck_13_shift                               (0)
#define  DFE_HDMI_RX_PHY_P0_CK4_reg_p0_ck_13_mask                                (0x000000FF)
#define  DFE_HDMI_RX_PHY_P0_CK4_reg_p0_ck_13(data)                               (0x000000FF&(data))
#define  DFE_HDMI_RX_PHY_P0_CK4_get_reg_p0_ck_13(data)                           (0x000000FF&(data))

#define  DFE_HDMI_RX_PHY_ENABLE                                                  0x1800DA38
#define  DFE_HDMI_RX_PHY_ENABLE_reg_addr                                         "0xB800DA38"
#define  DFE_HDMI_RX_PHY_ENABLE_reg                                              0xB800DA38
#define  DFE_HDMI_RX_PHY_ENABLE_inst_addr                                        "0x000E"
#define  set_DFE_HDMI_RX_PHY_ENABLE_reg(data)                                    (*((volatile unsigned int*)DFE_HDMI_RX_PHY_ENABLE_reg)=data)
#define  get_DFE_HDMI_RX_PHY_ENABLE_reg                                          (*((volatile unsigned int*)DFE_HDMI_RX_PHY_ENABLE_reg))
#define  DFE_HDMI_RX_PHY_ENABLE_reg_p2_en_rx_shift                               (18)
#define  DFE_HDMI_RX_PHY_ENABLE_reg_p2_en_cmu_shift                              (17)
#define  DFE_HDMI_RX_PHY_ENABLE_reg_p2_en_cdr_shift                              (14)
#define  DFE_HDMI_RX_PHY_ENABLE_reg_p1_en_rx_shift                               (11)
#define  DFE_HDMI_RX_PHY_ENABLE_reg_p1_en_cmu_shift                              (10)
#define  DFE_HDMI_RX_PHY_ENABLE_reg_p1_en_cdr_shift                              (7)
#define  DFE_HDMI_RX_PHY_ENABLE_reg_p0_en_rx_shift                               (4)
#define  DFE_HDMI_RX_PHY_ENABLE_reg_p0_en_cmu_shift                              (3)
#define  DFE_HDMI_RX_PHY_ENABLE_reg_p0_en_cdr_shift                              (0)
#define  DFE_HDMI_RX_PHY_ENABLE_reg_p2_en_rx_mask                                (0x001C0000)
#define  DFE_HDMI_RX_PHY_ENABLE_reg_p2_en_cmu_mask                               (0x00020000)
#define  DFE_HDMI_RX_PHY_ENABLE_reg_p2_en_cdr_mask                               (0x0001C000)
#define  DFE_HDMI_RX_PHY_ENABLE_reg_p1_en_rx_mask                                (0x00003800)
#define  DFE_HDMI_RX_PHY_ENABLE_reg_p1_en_cmu_mask                               (0x00000400)
#define  DFE_HDMI_RX_PHY_ENABLE_reg_p1_en_cdr_mask                               (0x00000380)
#define  DFE_HDMI_RX_PHY_ENABLE_reg_p0_en_rx_mask                                (0x00000070)
#define  DFE_HDMI_RX_PHY_ENABLE_reg_p0_en_cmu_mask                               (0x00000008)
#define  DFE_HDMI_RX_PHY_ENABLE_reg_p0_en_cdr_mask                               (0x00000007)
#define  DFE_HDMI_RX_PHY_ENABLE_reg_p2_en_rx(data)                               (0x001C0000&((data)<<18))
#define  DFE_HDMI_RX_PHY_ENABLE_reg_p2_en_cmu(data)                              (0x00020000&((data)<<17))
#define  DFE_HDMI_RX_PHY_ENABLE_reg_p2_en_cdr(data)                              (0x0001C000&((data)<<14))
#define  DFE_HDMI_RX_PHY_ENABLE_reg_p1_en_rx(data)                               (0x00003800&((data)<<11))
#define  DFE_HDMI_RX_PHY_ENABLE_reg_p1_en_cmu(data)                              (0x00000400&((data)<<10))
#define  DFE_HDMI_RX_PHY_ENABLE_reg_p1_en_cdr(data)                              (0x00000380&((data)<<7))
#define  DFE_HDMI_RX_PHY_ENABLE_reg_p0_en_rx(data)                               (0x00000070&((data)<<4))
#define  DFE_HDMI_RX_PHY_ENABLE_reg_p0_en_cmu(data)                              (0x00000008&((data)<<3))
#define  DFE_HDMI_RX_PHY_ENABLE_reg_p0_en_cdr(data)                              (0x00000007&(data))
#define  DFE_HDMI_RX_PHY_ENABLE_get_reg_p2_en_rx(data)                           ((0x001C0000&(data))>>18)
#define  DFE_HDMI_RX_PHY_ENABLE_get_reg_p2_en_cmu(data)                          ((0x00020000&(data))>>17)
#define  DFE_HDMI_RX_PHY_ENABLE_get_reg_p2_en_cdr(data)                          ((0x0001C000&(data))>>14)
#define  DFE_HDMI_RX_PHY_ENABLE_get_reg_p1_en_rx(data)                           ((0x00003800&(data))>>11)
#define  DFE_HDMI_RX_PHY_ENABLE_get_reg_p1_en_cmu(data)                          ((0x00000400&(data))>>10)
#define  DFE_HDMI_RX_PHY_ENABLE_get_reg_p1_en_cdr(data)                          ((0x00000380&(data))>>7)
#define  DFE_HDMI_RX_PHY_ENABLE_get_reg_p0_en_rx(data)                           ((0x00000070&(data))>>4)
#define  DFE_HDMI_RX_PHY_ENABLE_get_reg_p0_en_cmu(data)                          ((0x00000008&(data))>>3)
#define  DFE_HDMI_RX_PHY_ENABLE_get_reg_p0_en_cdr(data)                          (0x00000007&(data))

#define  DFE_HDMI_RX_PHY_P0_G1                                                   0x1800DA3C
#define  DFE_HDMI_RX_PHY_P0_G1_reg_addr                                          "0xB800DA3C"
#define  DFE_HDMI_RX_PHY_P0_G1_reg                                               0xB800DA3C
#define  DFE_HDMI_RX_PHY_P0_G1_inst_addr                                         "0x000F"
#define  set_DFE_HDMI_RX_PHY_P0_G1_reg(data)                                     (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P0_G1_reg)=data)
#define  get_DFE_HDMI_RX_PHY_P0_G1_reg                                           (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P0_G1_reg))
#define  DFE_HDMI_RX_PHY_P0_G1_reg_p0_g_4_shift                                  (24)
#define  DFE_HDMI_RX_PHY_P0_G1_reg_p0_g_3_shift                                  (16)
#define  DFE_HDMI_RX_PHY_P0_G1_reg_p0_g_2_shift                                  (8)
#define  DFE_HDMI_RX_PHY_P0_G1_reg_p0_g_1_shift                                  (0)
#define  DFE_HDMI_RX_PHY_P0_G1_reg_p0_g_4_mask                                   (0xFF000000)
#define  DFE_HDMI_RX_PHY_P0_G1_reg_p0_g_3_mask                                   (0x00FF0000)
#define  DFE_HDMI_RX_PHY_P0_G1_reg_p0_g_2_mask                                   (0x0000FF00)
#define  DFE_HDMI_RX_PHY_P0_G1_reg_p0_g_1_mask                                   (0x000000FF)
#define  DFE_HDMI_RX_PHY_P0_G1_reg_p0_g_4(data)                                  (0xFF000000&((data)<<24))
#define  DFE_HDMI_RX_PHY_P0_G1_reg_p0_g_3(data)                                  (0x00FF0000&((data)<<16))
#define  DFE_HDMI_RX_PHY_P0_G1_reg_p0_g_2(data)                                  (0x0000FF00&((data)<<8))
#define  DFE_HDMI_RX_PHY_P0_G1_reg_p0_g_1(data)                                  (0x000000FF&(data))
#define  DFE_HDMI_RX_PHY_P0_G1_get_reg_p0_g_4(data)                              ((0xFF000000&(data))>>24)
#define  DFE_HDMI_RX_PHY_P0_G1_get_reg_p0_g_3(data)                              ((0x00FF0000&(data))>>16)
#define  DFE_HDMI_RX_PHY_P0_G1_get_reg_p0_g_2(data)                              ((0x0000FF00&(data))>>8)
#define  DFE_HDMI_RX_PHY_P0_G1_get_reg_p0_g_1(data)                              (0x000000FF&(data))

#define  P0_g_1_inputoff                                                                      		(_BIT0)
#define  P0_g_1_FORE_KOFF_RANGE                                                                    	(_BIT22|_BIT21)
#define  P0_g_4_FORE_KOFF_AUTOK                                                                    (_BIT28)
#define  P0_g_CLK_PIX2_RATE_SEL						(_BIT26)
#define  P0_g_DEMUX_BBPD_RSTB                                                                       (_BIT25)
#define  P0_g_4_FORE_POW_FORE_KOFF                                                                  (_BIT24)
#define  P0_g_3_FORE_EN_FORE_KOFF                                                                    (_BIT23)
#define  DFE_HDMI_RX_PHY_P0_G2                                                   0x1800DA40
#define  DFE_HDMI_RX_PHY_P0_G2_reg_addr                                          "0xB800DA40"
#define  DFE_HDMI_RX_PHY_P0_G2_reg                                               0xB800DA40
#define  DFE_HDMI_RX_PHY_P0_G2_inst_addr                                         "0x0010"
#define  set_DFE_HDMI_RX_PHY_P0_G2_reg(data)                                     (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P0_G2_reg)=data)
#define  get_DFE_HDMI_RX_PHY_P0_G2_reg                                           (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P0_G2_reg))
#define  DFE_HDMI_RX_PHY_P0_G2_reg_p0_g_8_shift                                  (24)
#define  DFE_HDMI_RX_PHY_P0_G2_reg_p0_g_7_shift                                  (16)
#define  DFE_HDMI_RX_PHY_P0_G2_reg_p0_g_6_shift                                  (8)
#define  DFE_HDMI_RX_PHY_P0_G2_reg_p0_g_5_shift                                  (0)
#define  DFE_HDMI_RX_PHY_P0_G2_reg_p0_g_8_mask                                   (0xFF000000)
#define  DFE_HDMI_RX_PHY_P0_G2_reg_p0_g_7_mask                                   (0x00FF0000)
#define  DFE_HDMI_RX_PHY_P0_G2_reg_p0_g_6_mask                                   (0x0000FF00)
#define  DFE_HDMI_RX_PHY_P0_G2_reg_p0_g_5_mask                                   (0x000000FF)
#define  DFE_HDMI_RX_PHY_P0_G2_reg_p0_g_8(data)                                  (0xFF000000&((data)<<24))
#define  DFE_HDMI_RX_PHY_P0_G2_reg_p0_g_7(data)                                  (0x00FF0000&((data)<<16))
#define  DFE_HDMI_RX_PHY_P0_G2_reg_p0_g_6(data)                                  (0x0000FF00&((data)<<8))
#define  DFE_HDMI_RX_PHY_P0_G2_reg_p0_g_5(data)                                  (0x000000FF&(data))
#define  DFE_HDMI_RX_PHY_P0_G2_get_reg_p0_g_8(data)                              ((0xFF000000&(data))>>24)
#define  DFE_HDMI_RX_PHY_P0_G2_get_reg_p0_g_7(data)                              ((0x00FF0000&(data))>>16)
#define  DFE_HDMI_RX_PHY_P0_G2_get_reg_p0_g_6(data)                              ((0x0000FF00&(data))>>8)
#define  DFE_HDMI_RX_PHY_P0_G2_get_reg_p0_g_5(data)                              (0x000000FF&(data))
#define  P0_g_8_POW_PR                                                                                   _BIT25
#define  P0_g_8_EQ_POW                                                                                   _BIT0


#define  DFE_HDMI_RX_PHY_P0_G2_reg_p0_g_8_PR_RATE_SEL_shift             (26)
#define  DFE_HDMI_RX_PHY_P0_G2_reg_p0_g_8_DEMUX_shift             (29)
#define  DFE_HDMI_RX_PHY_P0_G2_reg_p0_g_7_TAP0_ISEL_shift                 (21)
#define  P0_g_8_DEMUX                                                                                             (_BIT29|_BIT30|_BIT31)
#define  P0_g_8_PR_RATE_SEL                                                                                    (_BIT26|_BIT27|_BIT28)
#define  P0_g_8_POW_PR                                                                                            _BIT25
#define  P0_g_7_TAP0_ISEL                                                                                         (_BIT21|_BIT22|_BIT23)
#define  P0_g_7_TAP0_ISEL_400uA                                                                              (_BIT22|_BIT23)
#define  P0_g_7_LEQ_ISEL                                                                                           (_BIT18|_BIT19|_BIT20)
#define  P0_g_7_LEQ_ISEL_400uA                                                                                (_BIT19|_BIT20)
#define  P0_g_7_LEQ_ISEL_200uA                                                                                (_BIT20)
#define  P0_g_7_PI_ISEL                                                                                              (_BIT16|_BIT17)
#define  P0_g_6_LEQ_BIT_RATE                                                                                    (_BIT14|_BIT15)
#define  P0_g_6_LEQ_BIT_RATE_HBR                                                                            (_BIT15)
#define  P0_g_6_LEQ_BIT_RATE_MBR                                                                            (_BIT14)
#define  P0_g_6_TAP0_HBR                                                                              	        (_BIT13)
#define  P0_g_6_LEQ_PASSIVE_CORNER                                                                      (_BIT12|_BIT11)
#define  P0_g_5_LEQ_CURRENT_ADJ                                                                            (_BIT3|_BIT4)
#define  P0_g_5_LEQ_CURRENT_ADJ_1X                                                                            (_BIT3)
#define  P0_g_5_LEQ_CURRENT_ADJ_1p25X                                                                       (_BIT4)
#define  P0_g_5_EQ_POW                                                                                             _BIT0


#define  DFE_HDMI_RX_PHY_P0_G3                                                   0x1800DA44
#define  DFE_HDMI_RX_PHY_P0_G3_reg_addr                                          "0xB800DA44"
#define  DFE_HDMI_RX_PHY_P0_G3_reg                                               0xB800DA44
#define  DFE_HDMI_RX_PHY_P0_G3_inst_addr                                         "0x0011"
#define  set_DFE_HDMI_RX_PHY_P0_G3_reg(data)                                     (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P0_G3_reg)=data)
#define  get_DFE_HDMI_RX_PHY_P0_G3_reg                                           (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P0_G3_reg))
#define  DFE_HDMI_RX_PHY_P0_G3_reg_p0_g_12_shift                                 (24)
#define  DFE_HDMI_RX_PHY_P0_G3_reg_p0_g_11_shift                                 (16)
#define  DFE_HDMI_RX_PHY_P0_G3_reg_p0_g_10_shift                                 (8)
#define  DFE_HDMI_RX_PHY_P0_G3_reg_p0_g_9_shift                                  (0)
#define  DFE_HDMI_RX_PHY_P0_G3_reg_p0_g_12_mask                                  (0xFF000000)
#define  DFE_HDMI_RX_PHY_P0_G3_reg_p0_g_11_mask                                  (0x00FF0000)
#define  DFE_HDMI_RX_PHY_P0_G3_reg_p0_g_10_mask                                  (0x0000FF00)
#define  DFE_HDMI_RX_PHY_P0_G3_reg_p0_g_9_mask                                   (0x000000FF)
#define  DFE_HDMI_RX_PHY_P0_G3_reg_p0_g_12(data)                                 (0xFF000000&((data)<<24))
#define  DFE_HDMI_RX_PHY_P0_G3_reg_p0_g_11(data)                                 (0x00FF0000&((data)<<16))
#define  DFE_HDMI_RX_PHY_P0_G3_reg_p0_g_10(data)                                 (0x0000FF00&((data)<<8))
#define  DFE_HDMI_RX_PHY_P0_G3_reg_p0_g_9(data)                                  (0x000000FF&(data))
#define  DFE_HDMI_RX_PHY_P0_G3_get_reg_p0_g_12(data)                             ((0xFF000000&(data))>>24)
#define  DFE_HDMI_RX_PHY_P0_G3_get_reg_p0_g_11(data)                             ((0x00FF0000&(data))>>16)
#define  DFE_HDMI_RX_PHY_P0_G3_get_reg_p0_g_10(data)                             ((0x0000FF00&(data))>>8)
#define  DFE_HDMI_RX_PHY_P0_G3_get_reg_p0_g_9(data)                              (0x000000FF&(data))
#define P0_G_DFE_TAPEN4321 													(_BIT6|_BIT5|_BIT4|_BIT3)
#define P0_g_12_PR 														 (_BIT24|_BIT25)
#define P0_g_9_DFE_ADAPTION_POW_EN 						              (_BIT7)
#define P0_g_9_DFE_TAP_EN 						                           (_BIT3|_BIT4|_BIT5|_BIT6)
#define P0_g_9_DFE_TAP1_EN 						                           (_BIT3)
#define  DFE_HDMI_RX_PHY_P0_g_tap_en(data)                                                           (0x00000078&((data)<<3))

#define P0_g_11_ACDR_RATE_SEL_HALF_RATE 								 (_BIT16)
#define P0_g_10_DFE_SUMAMP_LP_MANUALOFF								 (_BIT15)
#define P0_g_10_DFE_SUMAMP_ISEL_mask 								              (_BIT11|_BIT12|_BIT13)
#define P0_g_10_DFE_SUMAMP_ISEL_400uA 								              (_BIT13)
#define P0_g_10_DFE_PREAMP_ISEL_mask 								                    (_BIT8|_BIT9|_BIT10)
#define P0_g_10_DFE_PREAMP_ISEL_400uA 								                    (_BIT10)

#define  DFE_HDMI_RX_PHY_P0_G4                                                   0x1800DA48
#define  DFE_HDMI_RX_PHY_P0_G4_reg_addr                                          "0xB800DA48"
#define  DFE_HDMI_RX_PHY_P0_G4_reg                                               0xB800DA48
#define  DFE_HDMI_RX_PHY_P0_G4_inst_addr                                         "0x0012"
#define  set_DFE_HDMI_RX_PHY_P0_G4_reg(data)                                     (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P0_G4_reg)=data)
#define  get_DFE_HDMI_RX_PHY_P0_G4_reg                                           (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P0_G4_reg))
#define  DFE_HDMI_RX_PHY_P0_G4_reg_p0_g_koff_sel_shift                           (10)
#define  DFE_HDMI_RX_PHY_P0_G4_reg_p0_g_koff_bound_shift                         (9)
#define  DFE_HDMI_RX_PHY_P0_G4_reg_p0_g_koffok_shift                             (8)
#define  DFE_HDMI_RX_PHY_P0_G4_reg_p0_g_13_shift                                 (0)
#define  DFE_HDMI_RX_PHY_P0_G4_reg_p0_g_koff_sel_mask                            (0x00007C00)
#define  DFE_HDMI_RX_PHY_P0_G4_reg_p0_g_koff_bound_mask                          (0x00000200)
#define  DFE_HDMI_RX_PHY_P0_G4_reg_p0_g_koffok_mask                              (0x00000100)
#define  DFE_HDMI_RX_PHY_P0_G4_reg_p0_g_13_mask                                  (0x000000FF)
#define  DFE_HDMI_RX_PHY_P0_G4_reg_p0_g_koff_sel(data)                           (0x00007C00&((data)<<10))
#define  DFE_HDMI_RX_PHY_P0_G4_reg_p0_g_koff_bound(data)                         (0x00000200&((data)<<9))
#define  DFE_HDMI_RX_PHY_P0_G4_reg_p0_g_koffok(data)                             (0x00000100&((data)<<8))
#define  DFE_HDMI_RX_PHY_P0_G4_reg_p0_g_13(data)                                 (0x000000FF&(data))
#define  DFE_HDMI_RX_PHY_P0_G4_get_reg_p0_g_koff_sel(data)                       ((0x00007C00&(data))>>10)
#define  DFE_HDMI_RX_PHY_P0_G4_get_reg_p0_g_koff_bound(data)                     ((0x00000200&(data))>>9)
#define  DFE_HDMI_RX_PHY_P0_G4_get_reg_p0_g_koffok(data)                         ((0x00000100&(data))>>8)
#define  DFE_HDMI_RX_PHY_P0_G4_get_reg_p0_g_13(data)                             (0x000000FF&(data))

#define  DFE_HDMI_RX_PHY_P0_R1                                                   0x1800DA4C
#define  DFE_HDMI_RX_PHY_P0_R1_reg_addr                                          "0xB800DA4C"
#define  DFE_HDMI_RX_PHY_P0_R1_reg                                               0xB800DA4C
#define  DFE_HDMI_RX_PHY_P0_R1_inst_addr                                         "0x0013"
#define  set_DFE_HDMI_RX_PHY_P0_R1_reg(data)                                     (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P0_R1_reg)=data)
#define  get_DFE_HDMI_RX_PHY_P0_R1_reg                                           (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P0_R1_reg))
#define  DFE_HDMI_RX_PHY_P0_R1_reg_p0_r_4_shift                                  (24)
#define  DFE_HDMI_RX_PHY_P0_R1_reg_p0_r_3_shift                                  (16)
#define  DFE_HDMI_RX_PHY_P0_R1_reg_p0_r_2_shift                                  (8)
#define  DFE_HDMI_RX_PHY_P0_R1_reg_p0_r_1_shift                                  (0)
#define  DFE_HDMI_RX_PHY_P0_R1_reg_p0_r_4_mask                                   (0xFF000000)
#define  DFE_HDMI_RX_PHY_P0_R1_reg_p0_r_3_mask                                   (0x00FF0000)
#define  DFE_HDMI_RX_PHY_P0_R1_reg_p0_r_2_mask                                   (0x0000FF00)
#define  DFE_HDMI_RX_PHY_P0_R1_reg_p0_r_1_mask                                   (0x000000FF)
#define  DFE_HDMI_RX_PHY_P0_R1_reg_p0_r_4(data)                                  (0xFF000000&((data)<<24))
#define  DFE_HDMI_RX_PHY_P0_R1_reg_p0_r_3(data)                                  (0x00FF0000&((data)<<16))
#define  DFE_HDMI_RX_PHY_P0_R1_reg_p0_r_2(data)                                  (0x0000FF00&((data)<<8))
#define  DFE_HDMI_RX_PHY_P0_R1_reg_p0_r_1(data)                                  (0x000000FF&(data))
#define  DFE_HDMI_RX_PHY_P0_R1_get_reg_p0_r_4(data)                              ((0xFF000000&(data))>>24)
#define  DFE_HDMI_RX_PHY_P0_R1_get_reg_p0_r_3(data)                              ((0x00FF0000&(data))>>16)
#define  DFE_HDMI_RX_PHY_P0_R1_get_reg_p0_r_2(data)                              ((0x0000FF00&(data))>>8)
#define  DFE_HDMI_RX_PHY_P0_R1_get_reg_p0_r_1(data)                              (0x000000FF&(data))
#define  P0_r_4_FORE_KOFF_AUTOK                                                                    (_BIT28)
#define  P0_r_CLK_PIX2_RATE_SEL						(_BIT26)
#define  P0_r_1_FORE_KOFF_RANGE                                                                    (_BIT22|_BIT21)
#define  P0_r_1_inputoff                                                                      (_BIT0)
#define  P0_r_DEMUX_BBPD_RSTB                                                                       (_BIT25)
#define  P0_r_4_FORE_POW_FORE_KOFF                                                                  (_BIT24)
#define  P0_r_3_FORE_EN_FORE_KOFF                                                                    (_BIT23)

#define  DFE_HDMI_RX_PHY_P0_R2                                                   0x1800DA50
#define  DFE_HDMI_RX_PHY_P0_R2_reg_addr                                          "0xB800DA50"
#define  DFE_HDMI_RX_PHY_P0_R2_reg                                               0xB800DA50
#define  DFE_HDMI_RX_PHY_P0_R2_inst_addr                                         "0x0014"
#define  set_DFE_HDMI_RX_PHY_P0_R2_reg(data)                                     (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P0_R2_reg)=data)
#define  get_DFE_HDMI_RX_PHY_P0_R2_reg                                           (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P0_R2_reg))
#define  DFE_HDMI_RX_PHY_P0_R2_reg_p0_r_8_shift                                  (24)
#define  DFE_HDMI_RX_PHY_P0_R2_reg_p0_r_7_shift                                  (16)
#define  DFE_HDMI_RX_PHY_P0_R2_reg_p0_r_6_shift                                  (8)
#define  DFE_HDMI_RX_PHY_P0_R2_reg_p0_r_5_shift                                  (0)
#define  DFE_HDMI_RX_PHY_P0_R2_reg_p0_r_8_mask                                   (0xFF000000)
#define  DFE_HDMI_RX_PHY_P0_R2_reg_p0_r_7_mask                                   (0x00FF0000)
#define  DFE_HDMI_RX_PHY_P0_R2_reg_p0_r_6_mask                                   (0x0000FF00)
#define  DFE_HDMI_RX_PHY_P0_R2_reg_p0_r_5_mask                                   (0x000000FF)
#define  DFE_HDMI_RX_PHY_P0_R2_reg_p0_r_8(data)                                  (0xFF000000&((data)<<24))
#define  DFE_HDMI_RX_PHY_P0_R2_reg_p0_r_7(data)                                  (0x00FF0000&((data)<<16))
#define  DFE_HDMI_RX_PHY_P0_R2_reg_p0_r_6(data)                                  (0x0000FF00&((data)<<8))
#define  DFE_HDMI_RX_PHY_P0_R2_reg_p0_r_5(data)                                  (0x000000FF&(data))
#define  DFE_HDMI_RX_PHY_P0_R2_get_reg_p0_r_8(data)                              ((0xFF000000&(data))>>24)
#define  DFE_HDMI_RX_PHY_P0_R2_get_reg_p0_r_7(data)                              ((0x00FF0000&(data))>>16)
#define  DFE_HDMI_RX_PHY_P0_R2_get_reg_p0_r_6(data)                              ((0x0000FF00&(data))>>8)
#define  DFE_HDMI_RX_PHY_P0_R2_get_reg_p0_r_5(data)                              (0x000000FF&(data))

#define  DFE_HDMI_RX_PHY_P0_R2_reg_p0_r_8_PR_RATE_SEL_shift             (26)
#define  DFE_HDMI_RX_PHY_P0_R2_reg_p0_r_8_DEMUX_shift             (29)
#define  DFE_HDMI_RX_PHY_P0_R2_reg_p0_r_7_TAP0_ISEL_shift                 (21)
#define  P0_r_8_DEMUX                                                                                             (_BIT29|_BIT30|_BIT31)
#define  P0_r_8_PR_RATE_SEL                                                                                    (_BIT26|_BIT27|_BIT28)
#define  P0_r_8_POW_PR                                                                                            _BIT25
#define  P0_r_7_TAP0_ISEL                                                                                         (_BIT21|_BIT22|_BIT23)
#define  P0_r_7_TAP0_ISEL_400uA                                                                              (_BIT22|_BIT23)
#define  P0_r_7_LEQ_ISEL                                                                                           (_BIT18|_BIT19|_BIT20)
#define  P0_r_7_LEQ_ISEL_400uA                                                                                (_BIT19|_BIT20)
#define  P0_r_7_LEQ_ISEL_200uA                                                                                (_BIT20)
#define  P0_r_7_PI_ISEL                                                                                              (_BIT16|_BIT17)
#define  P0_r_6_LEQ_BIT_RATE                                                                                    (_BIT14|_BIT15)
#define  P0_r_6_LEQ_BIT_RATE_HBR                                                                            (_BIT15)
#define  P0_r_6_LEQ_BIT_RATE_MBR                                                                            (_BIT14)
#define  P0_r_6_TAP0_HBR                                                                              	        (_BIT13)
#define  P0_r_6_LEQ_PASSIVE_CORNER                                                                      (_BIT12|_BIT11)
#define  P0_r_5_LEQ_CURRENT_ADJ                                                                            (_BIT3|_BIT4)
#define  P0_r_5_LEQ_CURRENT_ADJ_1X                                                                            (_BIT3)
#define  P0_r_5_LEQ_CURRENT_ADJ_1p25X                                                                       (_BIT4)
#define  P0_r_5_EQ_POW                                                                                             _BIT0

#define  DFE_HDMI_RX_PHY_P0_R3                                                   0x1800DA54
#define  DFE_HDMI_RX_PHY_P0_R3_reg_addr                                          "0xB800DA54"
#define  DFE_HDMI_RX_PHY_P0_R3_reg                                               0xB800DA54
#define  DFE_HDMI_RX_PHY_P0_R3_inst_addr                                         "0x0015"
#define  set_DFE_HDMI_RX_PHY_P0_R3_reg(data)                                     (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P0_R3_reg)=data)
#define  get_DFE_HDMI_RX_PHY_P0_R3_reg                                           (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P0_R3_reg))
#define  DFE_HDMI_RX_PHY_P0_R3_reg_p0_r_12_shift                                 (24)
#define  DFE_HDMI_RX_PHY_P0_R3_reg_p0_r_11_shift                                 (16)
#define  DFE_HDMI_RX_PHY_P0_R3_reg_p0_r_10_shift                                 (8)
#define  DFE_HDMI_RX_PHY_P0_R3_reg_p0_r_9_shift                                  (0)
#define  DFE_HDMI_RX_PHY_P0_R3_reg_p0_r_12_mask                                  (0xFF000000)
#define  DFE_HDMI_RX_PHY_P0_R3_reg_p0_r_11_mask                                  (0x00FF0000)
#define  DFE_HDMI_RX_PHY_P0_R3_reg_p0_r_10_mask                                  (0x0000FF00)
#define  DFE_HDMI_RX_PHY_P0_R3_reg_p0_r_9_mask                                   (0x000000FF)
#define  DFE_HDMI_RX_PHY_P0_R3_reg_p0_r_12(data)                                 (0xFF000000&((data)<<24))
#define  DFE_HDMI_RX_PHY_P0_R3_reg_p0_r_11(data)                                 (0x00FF0000&((data)<<16))
#define  DFE_HDMI_RX_PHY_P0_R3_reg_p0_r_10(data)                                 (0x0000FF00&((data)<<8))
#define  DFE_HDMI_RX_PHY_P0_R3_reg_p0_r_9(data)                                  (0x000000FF&(data))
#define  DFE_HDMI_RX_PHY_P0_R3_get_reg_p0_r_12(data)                             ((0xFF000000&(data))>>24)
#define  DFE_HDMI_RX_PHY_P0_R3_get_reg_p0_r_11(data)                             ((0x00FF0000&(data))>>16)
#define  DFE_HDMI_RX_PHY_P0_R3_get_reg_p0_r_10(data)                             ((0x0000FF00&(data))>>8)
#define  DFE_HDMI_RX_PHY_P0_R3_get_reg_p0_r_9(data)                              (0x000000FF&(data))
#define  P0_R_DFE_TAPEN4321                                                                             (_BIT6|_BIT5|_BIT4|_BIT3)
#define  P0_r_12_PR 														      (_BIT24|_BIT25)
#define P0_r_9_DFE_ADAPTION_POW_EN 								              (_BIT7)
#define P0_r_9_DFE_TAP_EN 								                           (_BIT3|_BIT4|_BIT5|_BIT6)
#define P0_r_9_DFE_TAP1_EN 								                           (_BIT3)
#define  DFE_HDMI_RX_PHY_P0_r_tap_en(data)                                                           (0x00000078&((data)<<3))
#define  P0_r_11_ACDR_RATE_SEL 												(_BIT24|_BIT25)
#define P0_r_11_ACDR_RATE_SEL_HALF_RATE 								             (_BIT16)
#define P0_r_10_DFE_SUMAMP_LP_MANUALOFF								 (_BIT15)
#define P0_r_10_DFE_SUMAMP_ISEL_mask 								              (_BIT11|_BIT12|_BIT13)
#define P0_r_10_DFE_SUMAMP_ISEL_400uA 								              (_BIT13)
#define P0_r_10_DFE_PREAMP_ISEL_mask 								                    (_BIT8|_BIT9|_BIT10)
#define P0_r_10_DFE_PREAMP_ISEL_400uA 								                    (_BIT10)

#define  DFE_HDMI_RX_PHY_P0_R4                                                   0x1800DA58
#define  DFE_HDMI_RX_PHY_P0_R4_reg_addr                                          "0xB800DA58"
#define  DFE_HDMI_RX_PHY_P0_R4_reg                                               0xB800DA58
#define  DFE_HDMI_RX_PHY_P0_R4_inst_addr                                         "0x0016"
#define  set_DFE_HDMI_RX_PHY_P0_R4_reg(data)                                     (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P0_R4_reg)=data)
#define  get_DFE_HDMI_RX_PHY_P0_R4_reg                                           (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P0_R4_reg))
#define  DFE_HDMI_RX_PHY_P0_R4_reg_p0_r_koff_sel_shift                           (10)
#define  DFE_HDMI_RX_PHY_P0_R4_reg_p0_r_koff_bound_shift                         (9)
#define  DFE_HDMI_RX_PHY_P0_R4_reg_p0_r_koffok_shift                             (8)
#define  DFE_HDMI_RX_PHY_P0_R4_reg_p0_r_13_shift                                 (0)
#define  DFE_HDMI_RX_PHY_P0_R4_reg_p0_r_koff_sel_mask                            (0x00007C00)
#define  DFE_HDMI_RX_PHY_P0_R4_reg_p0_r_koff_bound_mask                          (0x00000200)
#define  DFE_HDMI_RX_PHY_P0_R4_reg_p0_r_koffok_mask                              (0x00000100)
#define  DFE_HDMI_RX_PHY_P0_R4_reg_p0_r_13_mask                                  (0x000000FF)
#define  DFE_HDMI_RX_PHY_P0_R4_reg_p0_r_koff_sel(data)                           (0x00007C00&((data)<<10))
#define  DFE_HDMI_RX_PHY_P0_R4_reg_p0_r_koff_bound(data)                         (0x00000200&((data)<<9))
#define  DFE_HDMI_RX_PHY_P0_R4_reg_p0_r_koffok(data)                             (0x00000100&((data)<<8))
#define  DFE_HDMI_RX_PHY_P0_R4_reg_p0_r_13(data)                                 (0x000000FF&(data))
#define  DFE_HDMI_RX_PHY_P0_R4_get_reg_p0_r_koff_sel(data)                       ((0x00007C00&(data))>>10)
#define  DFE_HDMI_RX_PHY_P0_R4_get_reg_p0_r_koff_bound(data)                     ((0x00000200&(data))>>9)
#define  DFE_HDMI_RX_PHY_P0_R4_get_reg_p0_r_koffok(data)                         ((0x00000100&(data))>>8)
#define  DFE_HDMI_RX_PHY_P0_R4_get_reg_p0_r_13(data)                             (0x000000FF&(data))

#define  DFE_HDMI_RX_PHY_P1_ACDR1                                                0x1800DA5C
#define  DFE_HDMI_RX_PHY_P1_ACDR1_reg_addr                                       "0xB800DA5C"
#define  DFE_HDMI_RX_PHY_P1_ACDR1_reg                                            0xB800DA5C
#define  DFE_HDMI_RX_PHY_P1_ACDR1_inst_addr                                      "0x0017"
#define  set_DFE_HDMI_RX_PHY_P1_ACDR1_reg(data)                                  (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P1_ACDR1_reg)=data)
#define  get_DFE_HDMI_RX_PHY_P1_ACDR1_reg                                        (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P1_ACDR1_reg))
#define  DFE_HDMI_RX_PHY_P1_ACDR1_reg_p1_acdr_4_shift                            (24)
#define  DFE_HDMI_RX_PHY_P1_ACDR1_reg_p1_acdr_3_shift                            (16)
#define  DFE_HDMI_RX_PHY_P1_ACDR1_reg_p1_acdr_2_shift                            (8)
#define  DFE_HDMI_RX_PHY_P1_ACDR1_reg_p1_acdr_1_shift                            (0)
#define  DFE_HDMI_RX_PHY_P1_ACDR1_reg_p1_acdr_4_mask                             (0xFF000000)
#define  DFE_HDMI_RX_PHY_P1_ACDR1_reg_p1_acdr_3_mask                             (0x00FF0000)
#define  DFE_HDMI_RX_PHY_P1_ACDR1_reg_p1_acdr_2_mask                             (0x0000FF00)
#define  DFE_HDMI_RX_PHY_P1_ACDR1_reg_p1_acdr_1_mask                             (0x000000FF)
#define  DFE_HDMI_RX_PHY_P1_ACDR1_reg_p1_acdr_4(data)                            (0xFF000000&((data)<<24))
#define  DFE_HDMI_RX_PHY_P1_ACDR1_reg_p1_acdr_3(data)                            (0x00FF0000&((data)<<16))
#define  DFE_HDMI_RX_PHY_P1_ACDR1_reg_p1_acdr_2(data)                            (0x0000FF00&((data)<<8))
#define  DFE_HDMI_RX_PHY_P1_ACDR1_reg_p1_acdr_1(data)                            (0x000000FF&(data))
#define  DFE_HDMI_RX_PHY_P1_ACDR1_get_reg_p1_acdr_4(data)                        ((0xFF000000&(data))>>24)
#define  DFE_HDMI_RX_PHY_P1_ACDR1_get_reg_p1_acdr_3(data)                        ((0x00FF0000&(data))>>16)
#define  DFE_HDMI_RX_PHY_P1_ACDR1_get_reg_p1_acdr_2(data)                        ((0x0000FF00&(data))>>8)
#define  DFE_HDMI_RX_PHY_P1_ACDR1_get_reg_p1_acdr_1(data)                        (0x000000FF&(data))
#define  p1_REG_ACDR_CPCVM_EN                     (_BIT26)
#define  p1_REG_ACDR_VCOGAIN                       (_BIT21|_BIT20)
#define  p1_REG_ACDR_LFRS_SEL                      (_BIT15|_BIT14|_BIT13)
#define  p1_REG_ACDR_CKFLD_EN                     (_BIT5)
#define  p1_REG_ACDR_EN                                 (_BIT1)
#define  p1_REG_ACDR_TOP_EN                         (_BIT0)

#define  DFE_HDMI_RX_PHY_P1_ACDR2                                                0x1800DA60
#define  DFE_HDMI_RX_PHY_P1_ACDR2_reg_addr                                       "0xB800DA60"
#define  DFE_HDMI_RX_PHY_P1_ACDR2_reg                                            0xB800DA60
#define  DFE_HDMI_RX_PHY_P1_ACDR2_inst_addr                                      "0x0018"
#define  set_DFE_HDMI_RX_PHY_P1_ACDR2_reg(data)                                  (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P1_ACDR2_reg)=data)
#define  get_DFE_HDMI_RX_PHY_P1_ACDR2_reg                                        (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P1_ACDR2_reg))
#define  DFE_HDMI_RX_PHY_P1_ACDR2_reg_p1_acdr_8_shift                            (24)
#define  DFE_HDMI_RX_PHY_P1_ACDR2_reg_p1_acdr_7_shift                            (16)
#define  DFE_HDMI_RX_PHY_P1_ACDR2_reg_p1_acdr_6_shift                            (8)
#define  DFE_HDMI_RX_PHY_P1_ACDR2_reg_p1_acdr_5_shift                            (0)
#define  DFE_HDMI_RX_PHY_P1_ACDR2_reg_p1_acdr_8_mask                             (0xFF000000)
#define  DFE_HDMI_RX_PHY_P1_ACDR2_reg_p1_acdr_7_mask                             (0x00FF0000)
#define  DFE_HDMI_RX_PHY_P1_ACDR2_reg_p1_acdr_6_mask                             (0x0000FF00)
#define  DFE_HDMI_RX_PHY_P1_ACDR2_reg_p1_acdr_5_mask                             (0x000000FF)
#define  DFE_HDMI_RX_PHY_P1_ACDR2_reg_p1_acdr_8(data)                            (0xFF000000&((data)<<24))
#define  DFE_HDMI_RX_PHY_P1_ACDR2_reg_p1_acdr_7(data)                            (0x00FF0000&((data)<<16))
#define  DFE_HDMI_RX_PHY_P1_ACDR2_reg_p1_acdr_6(data)                            (0x0000FF00&((data)<<8))
#define  DFE_HDMI_RX_PHY_P1_ACDR2_reg_p1_acdr_5(data)                            (0x000000FF&(data))
#define  DFE_HDMI_RX_PHY_P1_ACDR2_get_reg_p1_acdr_8(data)                        ((0xFF000000&(data))>>24)
#define  DFE_HDMI_RX_PHY_P1_ACDR2_get_reg_p1_acdr_7(data)                        ((0x00FF0000&(data))>>16)
#define  DFE_HDMI_RX_PHY_P1_ACDR2_get_reg_p1_acdr_6(data)                        ((0x0000FF00&(data))>>8)
#define  DFE_HDMI_RX_PHY_P1_ACDR2_get_reg_p1_acdr_5(data)                        (0x000000FF&(data))

#define  DFE_HDMI_RX_PHY_P1_B1                                                   0x1800DA64
#define  DFE_HDMI_RX_PHY_P1_B1_reg_addr                                          "0xB800DA64"
#define  DFE_HDMI_RX_PHY_P1_B1_reg                                               0xB800DA64
#define  DFE_HDMI_RX_PHY_P1_B1_inst_addr                                         "0x0019"
#define  set_DFE_HDMI_RX_PHY_P1_B1_reg(data)                                     (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P1_B1_reg)=data)
#define  get_DFE_HDMI_RX_PHY_P1_B1_reg                                           (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P1_B1_reg))
#define  DFE_HDMI_RX_PHY_P1_B1_reg_p1_b_4_shift                                  (24)
#define  DFE_HDMI_RX_PHY_P1_B1_reg_p1_b_3_shift                                  (16)
#define  DFE_HDMI_RX_PHY_P1_B1_reg_p1_b_2_shift                                  (8)
#define  DFE_HDMI_RX_PHY_P1_B1_reg_p1_b_1_shift                                  (0)
#define  DFE_HDMI_RX_PHY_P1_B1_reg_p1_b_4_mask                                   (0xFF000000)
#define  DFE_HDMI_RX_PHY_P1_B1_reg_p1_b_3_mask                                   (0x00FF0000)
#define  DFE_HDMI_RX_PHY_P1_B1_reg_p1_b_2_mask                                   (0x0000FF00)
#define  DFE_HDMI_RX_PHY_P1_B1_reg_p1_b_1_mask                                   (0x000000FF)
#define  DFE_HDMI_RX_PHY_P1_B1_reg_p1_b_4(data)                                  (0xFF000000&((data)<<24))
#define  DFE_HDMI_RX_PHY_P1_B1_reg_p1_b_3(data)                                  (0x00FF0000&((data)<<16))
#define  DFE_HDMI_RX_PHY_P1_B1_reg_p1_b_2(data)                                  (0x0000FF00&((data)<<8))
#define  DFE_HDMI_RX_PHY_P1_B1_reg_p1_b_1(data)                                  (0x000000FF&(data))
#define  DFE_HDMI_RX_PHY_P1_B1_get_reg_p1_b_4(data)                              ((0xFF000000&(data))>>24)
#define  DFE_HDMI_RX_PHY_P1_B1_get_reg_p1_b_3(data)                              ((0x00FF0000&(data))>>16)
#define  DFE_HDMI_RX_PHY_P1_B1_get_reg_p1_b_2(data)                              ((0x0000FF00&(data))>>8)
#define  DFE_HDMI_RX_PHY_P1_B1_get_reg_p1_b_1(data)                              (0x000000FF&(data))
#define  P1_b_1_B_LANE_INPUT_OFF                                                 (_BIT0)
#define  P1_b_3_B_FORE_KOFF_RANGE                                                 (_BIT22|_BIT21)
#define  P1_b_1_FORE_KOFF_ADJR                                                    (_BIT16|_BIT17|_BIT18|_BIT19|_BIT20)
#define  P1_b_2_LEQ_BIT_RATE_mask                                                                             (_BIT8|_BIT9)
#define  P1_b_2_LEQ_BIT_RATE_MBR                                                                             (_BIT8)
#define  P1_b_2_LEQ_BIT_RATE_HBR                                                                                  (_BIT9)

#define  DFE_HDMI_RX_PHY_P1_B2                                                   0x1800DA68
#define  DFE_HDMI_RX_PHY_P1_B2_reg_addr                                          "0xB800DA68"
#define  DFE_HDMI_RX_PHY_P1_B2_reg                                               0xB800DA68
#define  DFE_HDMI_RX_PHY_P1_B2_inst_addr                                         "0x001A"
#define  set_DFE_HDMI_RX_PHY_P1_B2_reg(data)                                     (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P1_B2_reg)=data)
#define  get_DFE_HDMI_RX_PHY_P1_B2_reg                                           (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P1_B2_reg))
#define  DFE_HDMI_RX_PHY_P1_B2_reg_p1_b_8_shift                                  (24)
#define  DFE_HDMI_RX_PHY_P1_B2_reg_p1_b_7_shift                                  (16)
#define  DFE_HDMI_RX_PHY_P1_B2_reg_p1_b_6_shift                                  (8)
#define  DFE_HDMI_RX_PHY_P1_B2_reg_p1_b_5_shift                                  (0)
#define  DFE_HDMI_RX_PHY_P1_B2_reg_p1_b_8_mask                                   (0xFF000000)
#define  DFE_HDMI_RX_PHY_P1_B2_reg_p1_b_7_mask                                   (0x00FF0000)
#define  DFE_HDMI_RX_PHY_P1_B2_reg_p1_b_6_mask                                   (0x0000FF00)
#define  DFE_HDMI_RX_PHY_P1_B2_reg_p1_b_5_mask                                   (0x000000FF)
#define  DFE_HDMI_RX_PHY_P1_B2_reg_p1_b_8(data)                                  (0xFF000000&((data)<<24))
#define  DFE_HDMI_RX_PHY_P1_B2_reg_p1_b_7(data)                                  (0x00FF0000&((data)<<16))
#define  DFE_HDMI_RX_PHY_P1_B2_reg_p1_b_6(data)                                  (0x0000FF00&((data)<<8))
#define  DFE_HDMI_RX_PHY_P1_B2_reg_p1_b_5(data)                                  (0x000000FF&(data))
#define  DFE_HDMI_RX_PHY_P1_B2_get_reg_p1_b_8(data)                              ((0xFF000000&(data))>>24)
#define  DFE_HDMI_RX_PHY_P1_B2_get_reg_p1_b_7(data)                              ((0x00FF0000&(data))>>16)
#define  DFE_HDMI_RX_PHY_P1_B2_get_reg_p1_b_6(data)                              ((0x0000FF00&(data))>>8)
#define  DFE_HDMI_RX_PHY_P1_B2_get_reg_p1_b_5(data)                              (0x000000FF&(data))
#define  DFE_HDMI_RX_PHY_P1_B2_reg_p1_b_8_PR_RATE_SEL_shift             (26)
#define  DFE_HDMI_RX_PHY_P1_B2_reg_p1_b_8_DEMUX_shift             (29)
#define  DFE_HDMI_RX_PHY_P1_B2_reg_p1_b_7_TAP0_ISEL_shift                 (21)
#define  P1_b_8_DEMUX                                                                                             (_BIT29|_BIT30|_BIT31)
#define  P1_b_8_PR_RATE_SEL                                                                                    (_BIT26|_BIT27|_BIT28)
#define  P1_b_8_POW_PR                                                                                            _BIT25
#define  P1_b_8_BY_PASS_PR                                                                                      _BIT24
#define  P1_b_7_TAP0_ISEL                                                                                         (_BIT21|_BIT22|_BIT23)
#define  P1_b_7_TAP0_ISEL_400uA                                                                              (_BIT22|_BIT23)
#define  P1_b_7_LEQ_ISEL                                                                                           (_BIT18|_BIT19|_BIT20)
#define  P1_b_7_LEQ_ISEL_400uA                                                                                (_BIT19|_BIT20)
#define  P1_b_7_LEQ_ISEL_200uA                                                                                (_BIT20)
#define  P1_b_7_PI_ISEL                                                                                              (_BIT16|_BIT17)
#define  P1_b_6_LEQ_BIT_RATE                                                                                    (_BIT14|_BIT15)
#define  P1_b_6_LEQ_BIT_RATE_HBR                                                                            (_BIT15)
#define  P1_b_6_LEQ_BIT_RATE_MBR                                                                            (_BIT14)
#define  P1_b_6_TAP0_HBR                                                                              	        (_BIT13)
#define  P1_b_6_LEQ_PASSIVE_CORNER                                                                       ( _BIT11|_BIT12)

#define  P1_b_5_TAP0_CURRENT_ADJ                                                                            (_BIT3|_BIT4)
#define  P1_b_5_TAP0_CURRENT_ADJ_1X                                                                            (_BIT3)
#define  P1_b_5_TAP0_CURRENT_ADJ_1p25X                                                                       (_BIT4)
#define  P1_b_5_EQ_POW                                                                                             _BIT0




#define  DFE_HDMI_RX_PHY_P1_B3                                                   0x1800DA6C
#define  DFE_HDMI_RX_PHY_P1_B3_reg_addr                                          "0xB800DA6C"
#define  DFE_HDMI_RX_PHY_P1_B3_reg                                               0xB800DA6C
#define  DFE_HDMI_RX_PHY_P1_B3_inst_addr                                         "0x001B"
#define  set_DFE_HDMI_RX_PHY_P1_B3_reg(data)                                     (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P1_B3_reg)=data)
#define  get_DFE_HDMI_RX_PHY_P1_B3_reg                                           (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P1_B3_reg))
#define  DFE_HDMI_RX_PHY_P1_B3_reg_p1_b_12_shift                                 (24)
#define  DFE_HDMI_RX_PHY_P1_B3_reg_p1_b_11_shift                                 (16)
#define  DFE_HDMI_RX_PHY_P1_B3_reg_p1_b_10_shift                                 (8)
#define  DFE_HDMI_RX_PHY_P1_B3_reg_p1_b_9_shift                                  (0)
#define  DFE_HDMI_RX_PHY_P1_B3_reg_p1_b_12_mask                                  (0xFF000000)
#define  DFE_HDMI_RX_PHY_P1_B3_reg_p1_b_11_mask                                  (0x00FF0000)
#define  DFE_HDMI_RX_PHY_P1_B3_reg_p1_b_10_mask                                  (0x0000FF00)
#define  DFE_HDMI_RX_PHY_P1_B3_reg_p1_b_9_mask                                   (0x000000FF)
#define  DFE_HDMI_RX_PHY_P1_B3_reg_p1_b_12(data)                                 (0xFF000000&((data)<<24))
#define  DFE_HDMI_RX_PHY_P1_B3_reg_p1_b_11(data)                                 (0x00FF0000&((data)<<16))
#define  DFE_HDMI_RX_PHY_P1_B3_reg_p1_b_10(data)                                 (0x0000FF00&((data)<<8))
#define  DFE_HDMI_RX_PHY_P1_B3_reg_p1_b_9(data)                                  (0x000000FF&(data))
#define  DFE_HDMI_RX_PHY_P1_B3_get_reg_p1_b_12(data)                             ((0xFF000000&(data))>>24)
#define  DFE_HDMI_RX_PHY_P1_B3_get_reg_p1_b_11(data)                             ((0x00FF0000&(data))>>16)
#define  DFE_HDMI_RX_PHY_P1_B3_get_reg_p1_b_10(data)                             ((0x0000FF00&(data))>>8)
#define  DFE_HDMI_RX_PHY_P1_B3_get_reg_p1_b_9(data)                              (0x000000FF&(data))
#define P1_B_DFE_TAPEN4321                                                                              (_BIT6|_BIT5|_BIT4|_BIT3)
#define P1_b_12_PR 														 (_BIT24|_BIT25)
#define P1_b_11_ACDR_RATE_SEL_HALF_RATE 								 (_BIT16)
#define P1_b_9_DFE_ADAPTION_POW_EN 								              (_BIT7)
#define P1_b_9_DFE_TAP_EN 								                           (_BIT3|_BIT4|_BIT5|_BIT6)
#define P1_b_9_DFE_TAP1_EN 								                           (_BIT3)
#define  DFE_HDMI_RX_PHY_P1_b_tap_en(data)                                                           (0x00000078&((data)<<3))
#define P1_b_11_ACDR_RATE_SEL_HALF_RATE 								 (_BIT16)
#define P1_b_9_DFE_ADAPTION_POW_EN 								              (_BIT7)


#define  DFE_HDMI_RX_PHY_P1_B4                                                   0x1800DA70
#define  DFE_HDMI_RX_PHY_P1_B4_reg_addr                                          "0xB800DA70"
#define  DFE_HDMI_RX_PHY_P1_B4_reg                                               0xB800DA70
#define  DFE_HDMI_RX_PHY_P1_B4_inst_addr                                         "0x001C"
#define  set_DFE_HDMI_RX_PHY_P1_B4_reg(data)                                     (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P1_B4_reg)=data)
#define  get_DFE_HDMI_RX_PHY_P1_B4_reg                                           (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P1_B4_reg))
#define  DFE_HDMI_RX_PHY_P1_B4_reg_p1_b_koff_sel_shift                           (10)
#define  DFE_HDMI_RX_PHY_P1_B4_reg_p1_b_koff_bound_shift                         (9)
#define  DFE_HDMI_RX_PHY_P1_B4_reg_p1_b_koffok_shift                             (8)
#define  DFE_HDMI_RX_PHY_P1_B4_reg_p1_b_13_shift                                 (0)
#define  DFE_HDMI_RX_PHY_P1_B4_reg_p1_b_koff_sel_mask                            (0x00007C00)
#define  DFE_HDMI_RX_PHY_P1_B4_reg_p1_b_koff_bound_mask                          (0x00000200)
#define  DFE_HDMI_RX_PHY_P1_B4_reg_p1_b_koffok_mask                              (0x00000100)
#define  DFE_HDMI_RX_PHY_P1_B4_reg_p1_b_13_mask                                  (0x000000FF)
#define  DFE_HDMI_RX_PHY_P1_B4_reg_p1_b_koff_sel(data)                           (0x00007C00&((data)<<10))
#define  DFE_HDMI_RX_PHY_P1_B4_reg_p1_b_koff_bound(data)                         (0x00000200&((data)<<9))
#define  DFE_HDMI_RX_PHY_P1_B4_reg_p1_b_koffok(data)                             (0x00000100&((data)<<8))
#define  DFE_HDMI_RX_PHY_P1_B4_reg_p1_b_13(data)                                 (0x000000FF&(data))
#define  DFE_HDMI_RX_PHY_P1_B4_get_reg_p1_b_koff_sel(data)                       ((0x00007C00&(data))>>10)
#define  DFE_HDMI_RX_PHY_P1_B4_get_reg_p1_b_koff_bound(data)                     ((0x00000200&(data))>>9)
#define  DFE_HDMI_RX_PHY_P1_B4_get_reg_p1_b_koffok(data)                         ((0x00000100&(data))>>8)
#define  DFE_HDMI_RX_PHY_P1_B4_get_reg_p1_b_13(data)                             (0x000000FF&(data))

#define  DFE_HDMI_RX_PHY_P1_CK1                                                  0x1800DA74
#define  DFE_HDMI_RX_PHY_P1_CK1_reg_addr                                         "0xB800DA74"
#define  DFE_HDMI_RX_PHY_P1_CK1_reg                                              0xB800DA74
#define  DFE_HDMI_RX_PHY_P1_CK1_inst_addr                                        "0x001D"
#define  set_DFE_HDMI_RX_PHY_P1_CK1_reg(data)                                    (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P1_CK1_reg)=data)
#define  get_DFE_HDMI_RX_PHY_P1_CK1_reg                                          (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P1_CK1_reg))
#define  DFE_HDMI_RX_PHY_P1_CK1_reg_p1_ck_4_shift                                (24)
#define  DFE_HDMI_RX_PHY_P1_CK1_reg_p1_ck_3_shift                                (16)
#define  DFE_HDMI_RX_PHY_P1_CK1_reg_p1_ck_2_shift                                (8)
#define  DFE_HDMI_RX_PHY_P1_CK1_reg_p1_ck_1_shift                                (0)
#define  DFE_HDMI_RX_PHY_P1_CK1_reg_p1_ck_4_mask                                 (0xFF000000)
#define  DFE_HDMI_RX_PHY_P1_CK1_reg_p1_ck_3_mask                                 (0x00FF0000)
#define  DFE_HDMI_RX_PHY_P1_CK1_reg_p1_ck_2_mask                                 (0x0000FF00)
#define  DFE_HDMI_RX_PHY_P1_CK1_reg_p1_ck_1_mask                                 (0x000000FF)
#define  DFE_HDMI_RX_PHY_P1_CK1_reg_p1_ck_4(data)                                (0xFF000000&((data)<<24))
#define  DFE_HDMI_RX_PHY_P1_CK1_reg_p1_ck_3(data)                                (0x00FF0000&((data)<<16))
#define  DFE_HDMI_RX_PHY_P1_CK1_reg_p1_ck_2(data)                                (0x0000FF00&((data)<<8))
#define  DFE_HDMI_RX_PHY_P1_CK1_reg_p1_ck_1(data)                                (0x000000FF&(data))
#define  DFE_HDMI_RX_PHY_P1_CK1_get_reg_p1_ck_4(data)                            ((0xFF000000&(data))>>24)
#define  DFE_HDMI_RX_PHY_P1_CK1_get_reg_p1_ck_3(data)                            ((0x00FF0000&(data))>>16)
#define  DFE_HDMI_RX_PHY_P1_CK1_get_reg_p1_ck_2(data)                            ((0x0000FF00&(data))>>8)
#define  DFE_HDMI_RX_PHY_P1_CK1_get_reg_p1_ck_1(data)                            (0x000000FF&(data))
#define  p1_ck_3_CMU_PREDIVN                                                                          (_BIT20|_BIT21|_BIT22|_BIT23)
#define  p1_ck_3_CMU_N_code                                                                          (_BIT18|_BIT19)
#define  p1_ck_2_CMU_CKIN_SEL                                                                   (_BIT12|_BIT13|_BIT14|_BIT15)
#define  p1_CMU_CKOUT_SEL                                                                             (_BIT11)
#define  p1_ck_2_CK_MD_REF_SEL                                                                   _BIT9
#define  p1_ck_1_port_bias                                                                              _BIT2
#define  p1_ck_1_CKAFE_POW                                                                          _BIT1



#define  DFE_HDMI_RX_PHY_P1_CK2                                                  0x1800DA78
#define  DFE_HDMI_RX_PHY_P1_CK2_reg_addr                                         "0xB800DA78"
#define  DFE_HDMI_RX_PHY_P1_CK2_reg                                              0xB800DA78
#define  DFE_HDMI_RX_PHY_P1_CK2_inst_addr                                        "0x001E"
#define  set_DFE_HDMI_RX_PHY_P1_CK2_reg(data)                                    (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P1_CK2_reg)=data)
#define  get_DFE_HDMI_RX_PHY_P1_CK2_reg                                          (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P1_CK2_reg))
#define  DFE_HDMI_RX_PHY_P1_CK2_reg_p1_ck_8_shift                                (24)
#define  DFE_HDMI_RX_PHY_P1_CK2_reg_p1_ck_7_shift                                (16)
#define  DFE_HDMI_RX_PHY_P1_CK2_reg_p1_ck_6_shift                                (8)
#define  DFE_HDMI_RX_PHY_P1_CK2_reg_p1_ck_5_shift                                (0)
#define  DFE_HDMI_RX_PHY_P1_CK2_reg_p1_ck_8_mask                                 (0xFF000000)
#define  DFE_HDMI_RX_PHY_P1_CK2_reg_p1_ck_7_mask                                 (0x00FF0000)
#define  DFE_HDMI_RX_PHY_P1_CK2_reg_p1_ck_6_mask                                 (0x0000FF00)
#define  DFE_HDMI_RX_PHY_P1_CK2_reg_p1_ck_5_mask                                 (0x000000FF)
#define  DFE_HDMI_RX_PHY_P1_CK2_reg_p1_ck_8(data)                                (0xFF000000&((data)<<24))
#define  DFE_HDMI_RX_PHY_P1_CK2_reg_p1_ck_7(data)                                (0x00FF0000&((data)<<16))
#define  DFE_HDMI_RX_PHY_P1_CK2_reg_p1_ck_6(data)                                (0x0000FF00&((data)<<8))
#define  DFE_HDMI_RX_PHY_P1_CK2_reg_p1_ck_5(data)                                (0x000000FF&(data))
#define  DFE_HDMI_RX_PHY_P1_CK2_get_reg_p1_ck_8(data)                            ((0xFF000000&(data))>>24)
#define  DFE_HDMI_RX_PHY_P1_CK2_get_reg_p1_ck_7(data)                            ((0x00FF0000&(data))>>16)
#define  DFE_HDMI_RX_PHY_P1_CK2_get_reg_p1_ck_6(data)                            ((0x0000FF00&(data))>>8)
#define  DFE_HDMI_RX_PHY_P1_CK2_get_reg_p1_ck_5(data)                            (0x000000FF&(data))
#define  P1_ck_8_VSEL_LDO_A_mask                                                                   (_BIT29|_BIT30|_BIT31)
#define  P1_ck_8_VSEL_LDO_D_mask                                                                   (_BIT26|_BIT27|_BIT28)
#define  P1_ck_8_LDO_EN_mask                                                                          (_BIT25)
#define  P1_ck_8_CMU_BPPSR_mask                                                                          (_BIT24)
#define  P1_ck_7_CMU_BYPASS_PI_mask                                                              (_BIT19)
#define  P1_ck_7_CMU_PI_I_SEL_mask                                                                 (_BIT16|_BIT17|_BIT18)
#define  P1_ck_6_CMU_BIG_KVCO_mask                                                                 (_BIT13)
#define  P1_ck_6_CMU_EN_CAP_mask                                                                     (_BIT12)
#define  P1_ck_6_CMU_SEL_CS_mask                                                                     (_BIT8|_BIT9|_BIT10)
#define  P1_ck_5_CMU_SEL_PUMP_I_mask                                                               (_BIT4|_BIT5|_BIT6|_BIT7)
#define  P1_ck_5_CMU_SEL_R1_mask                                                                       (_BIT0|_BIT1|_BIT2)
#define  DFE_HDMI_RX_PHY_P1_VSEL_LDO_D(data)                            (0x1C000000&((data)<<26))
#define  DFE_HDMI_RX_PHY_P1_CMU_BPPSR(data)                            (0x01000000&((data)<<24))
#define  DFE_HDMI_RX_PHY_P1_CMU_SEL_CS(data)                            (0x00000700&((data)<<8))
#define  DFE_HDMI_RX_PHY_P1_CMU_SEL_PUMP_I(data)                            (0x000000F0&((data)<<4))
#define  DFE_HDMI_RX_PHY_P1_CMU_SEL_R1(data)                            (0x00000007&((data)<<0))

#define  DFE_HDMI_RX_PHY_P1_CK3                                                  0x1800DA7C
#define  DFE_HDMI_RX_PHY_P1_CK3_reg_addr                                         "0xB800DA7C"
#define  DFE_HDMI_RX_PHY_P1_CK3_reg                                              0xB800DA7C
#define  DFE_HDMI_RX_PHY_P1_CK3_inst_addr                                        "0x001F"
#define  set_DFE_HDMI_RX_PHY_P1_CK3_reg(data)                                    (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P1_CK3_reg)=data)
#define  get_DFE_HDMI_RX_PHY_P1_CK3_reg                                          (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P1_CK3_reg))
#define  DFE_HDMI_RX_PHY_P1_CK3_reg_p1_ck_12_shift                               (24)
#define  DFE_HDMI_RX_PHY_P1_CK3_reg_p1_ck_11_shift                               (16)
#define  DFE_HDMI_RX_PHY_P1_CK3_reg_p1_ck_10_shift                               (8)
#define  DFE_HDMI_RX_PHY_P1_CK3_reg_p1_ck_9_shift                                (0)
#define  DFE_HDMI_RX_PHY_P1_CK3_reg_p1_ck_12_mask                                (0xFF000000)
#define  DFE_HDMI_RX_PHY_P1_CK3_reg_p1_ck_11_mask                                (0x00FF0000)
#define  DFE_HDMI_RX_PHY_P1_CK3_reg_p1_ck_10_mask                                (0x0000FF00)
#define  DFE_HDMI_RX_PHY_P1_CK3_reg_p1_ck_9_mask                                 (0x000000FF)
#define  DFE_HDMI_RX_PHY_P1_CK3_reg_p1_ck_12(data)                               (0xFF000000&((data)<<24))
#define  DFE_HDMI_RX_PHY_P1_CK3_reg_p1_ck_11(data)                               (0x00FF0000&((data)<<16))
#define  DFE_HDMI_RX_PHY_P1_CK3_reg_p1_ck_10(data)                               (0x0000FF00&((data)<<8))
#define  DFE_HDMI_RX_PHY_P1_CK3_reg_p1_ck_9(data)                                (0x000000FF&(data))
#define  DFE_HDMI_RX_PHY_P1_CK3_get_reg_p1_ck_12(data)                           ((0xFF000000&(data))>>24)
#define  DFE_HDMI_RX_PHY_P1_CK3_get_reg_p1_ck_11(data)                           ((0x00FF0000&(data))>>16)
#define  DFE_HDMI_RX_PHY_P1_CK3_get_reg_p1_ck_10(data)                           ((0x0000FF00&(data))>>8)
#define  DFE_HDMI_RX_PHY_P1_CK3_get_reg_p1_ck_9(data)                            (0x000000FF&(data))
#define  P1_ck_9_CMU_PFD_RSTB                                                                          (_BIT5)
#define  P1_ck_9_CMU_WDRST                                                                          (_BIT2)




#define  DFE_HDMI_RX_PHY_P1_CK4                                                  0x1800DA80
#define  DFE_HDMI_RX_PHY_P1_CK4_reg_addr                                         "0xB800DA80"
#define  DFE_HDMI_RX_PHY_P1_CK4_reg                                              0xB800DA80
#define  DFE_HDMI_RX_PHY_P1_CK4_inst_addr                                        "0x0020"
#define  set_DFE_HDMI_RX_PHY_P1_CK4_reg(data)                                    (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P1_CK4_reg)=data)
#define  get_DFE_HDMI_RX_PHY_P1_CK4_reg                                          (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P1_CK4_reg))
#define  DFE_HDMI_RX_PHY_P1_CK4_reg_p1_ck_13_shift                               (0)
#define  DFE_HDMI_RX_PHY_P1_CK4_reg_p1_ck_13_mask                                (0x000000FF)
#define  DFE_HDMI_RX_PHY_P1_CK4_reg_p1_ck_13(data)                               (0x000000FF&(data))
#define  DFE_HDMI_RX_PHY_P1_CK4_get_reg_p1_ck_13(data)                           (0x000000FF&(data))

#define  DFE_HDMI_RX_PHY_P1_G1                                                   0x1800DA84
#define  DFE_HDMI_RX_PHY_P1_G1_reg_addr                                          "0xB800DA84"
#define  DFE_HDMI_RX_PHY_P1_G1_reg                                               0xB800DA84
#define  DFE_HDMI_RX_PHY_P1_G1_inst_addr                                         "0x0021"
#define  set_DFE_HDMI_RX_PHY_P1_G1_reg(data)                                     (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P1_G1_reg)=data)
#define  get_DFE_HDMI_RX_PHY_P1_G1_reg                                           (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P1_G1_reg))
#define  DFE_HDMI_RX_PHY_P1_G1_reg_p1_g_4_shift                                  (24)
#define  DFE_HDMI_RX_PHY_P1_G1_reg_p1_g_3_shift                                  (16)
#define  DFE_HDMI_RX_PHY_P1_G1_reg_p1_g_2_shift                                  (8)
#define  DFE_HDMI_RX_PHY_P1_G1_reg_p1_g_1_shift                                  (0)
#define  DFE_HDMI_RX_PHY_P1_G1_reg_p1_g_4_mask                                   (0xFF000000)
#define  DFE_HDMI_RX_PHY_P1_G1_reg_p1_g_3_mask                                   (0x00FF0000)
#define  DFE_HDMI_RX_PHY_P1_G1_reg_p1_g_2_mask                                   (0x0000FF00)
#define  DFE_HDMI_RX_PHY_P1_G1_reg_p1_g_1_mask                                   (0x000000FF)
#define  DFE_HDMI_RX_PHY_P1_G1_reg_p1_g_4(data)                                  (0xFF000000&((data)<<24))
#define  DFE_HDMI_RX_PHY_P1_G1_reg_p1_g_3(data)                                  (0x00FF0000&((data)<<16))
#define  DFE_HDMI_RX_PHY_P1_G1_reg_p1_g_2(data)                                  (0x0000FF00&((data)<<8))
#define  DFE_HDMI_RX_PHY_P1_G1_reg_p1_g_1(data)                                  (0x000000FF&(data))
#define  DFE_HDMI_RX_PHY_P1_G1_get_reg_p1_g_4(data)                              ((0xFF000000&(data))>>24)
#define  DFE_HDMI_RX_PHY_P1_G1_get_reg_p1_g_3(data)                              ((0x00FF0000&(data))>>16)
#define  DFE_HDMI_RX_PHY_P1_G1_get_reg_p1_g_2(data)                              ((0x0000FF00&(data))>>8)
#define  DFE_HDMI_RX_PHY_P1_G1_get_reg_p1_g_1(data)                              (0x000000FF&(data))
#define  P1_g_1_G_LANE_INPUT_OFF                                                 (_BIT0)
#define  P1_g_2_LEQ_BIT_RATE_mask                                                                             (_BIT8|_BIT9)
#define  P1_g_2_LEQ_BIT_RATE_MBR                                                                             (_BIT8)
#define  P1_g_2_LEQ_BIT_RATE_HBR                                                                                  (_BIT9)

#define  DFE_HDMI_RX_PHY_P1_G2                                                   0x1800DA88
#define  DFE_HDMI_RX_PHY_P1_G2_reg_addr                                          "0xB800DA88"
#define  DFE_HDMI_RX_PHY_P1_G2_reg                                               0xB800DA88
#define  DFE_HDMI_RX_PHY_P1_G2_inst_addr                                         "0x0022"
#define  set_DFE_HDMI_RX_PHY_P1_G2_reg(data)                                     (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P1_G2_reg)=data)
#define  get_DFE_HDMI_RX_PHY_P1_G2_reg                                           (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P1_G2_reg))
#define  DFE_HDMI_RX_PHY_P1_G2_reg_p1_g_8_shift                                  (24)
#define  DFE_HDMI_RX_PHY_P1_G2_reg_p1_g_7_shift                                  (16)
#define  DFE_HDMI_RX_PHY_P1_G2_reg_p1_g_6_shift                                  (8)
#define  DFE_HDMI_RX_PHY_P1_G2_reg_p1_g_5_shift                                  (0)
#define  DFE_HDMI_RX_PHY_P1_G2_reg_p1_g_8_mask                                   (0xFF000000)
#define  DFE_HDMI_RX_PHY_P1_G2_reg_p1_g_7_mask                                   (0x00FF0000)
#define  DFE_HDMI_RX_PHY_P1_G2_reg_p1_g_6_mask                                   (0x0000FF00)
#define  DFE_HDMI_RX_PHY_P1_G2_reg_p1_g_5_mask                                   (0x000000FF)
#define  DFE_HDMI_RX_PHY_P1_G2_reg_p1_g_8(data)                                  (0xFF000000&((data)<<24))
#define  DFE_HDMI_RX_PHY_P1_G2_reg_p1_g_7(data)                                  (0x00FF0000&((data)<<16))
#define  DFE_HDMI_RX_PHY_P1_G2_reg_p1_g_6(data)                                  (0x0000FF00&((data)<<8))
#define  DFE_HDMI_RX_PHY_P1_G2_reg_p1_g_5(data)                                  (0x000000FF&(data))
#define  DFE_HDMI_RX_PHY_P1_G2_get_reg_p1_g_8(data)                              ((0xFF000000&(data))>>24)
#define  DFE_HDMI_RX_PHY_P1_G2_get_reg_p1_g_7(data)                              ((0x00FF0000&(data))>>16)
#define  DFE_HDMI_RX_PHY_P1_G2_get_reg_p1_g_6(data)                              ((0x0000FF00&(data))>>8)
#define  DFE_HDMI_RX_PHY_P1_G2_get_reg_p1_g_5(data)                              (0x000000FF&(data))

#define  DFE_HDMI_RX_PHY_P1_G2_reg_p1_g_8_PR_RATE_SEL_shift             (26)
#define  DFE_HDMI_RX_PHY_P1_G2_reg_p1_g_8_DEMUX_shift             (29)
#define  DFE_HDMI_RX_PHY_P1_G2_reg_p1_g_7_TAP0_ISEL_shift                 (21)
#define  P1_g_8_DEMUX                                                                                             (_BIT29|_BIT30|_BIT31)
#define  P1_g_8_PR_RATE_SEL                                                                                    (_BIT26|_BIT27|_BIT28)
#define  P1_g_8_POW_PR                                                                                            _BIT25
#define  P1_g_8_BY_PASS_PR                                                                                      _BIT24
#define  P1_g_7_TAP0_ISEL                                                                                         (_BIT21|_BIT22|_BIT23)
#define  P1_g_7_TAP0_ISEL_400uA                                                                              (_BIT22|_BIT23)
#define  P1_g_7_LEQ_ISEL                                                                                           (_BIT18|_BIT19|_BIT20)
#define  P1_g_7_LEQ_ISEL_400uA                                                                                (_BIT19|_BIT20)
#define  P1_g_7_PI_ISEL                                                                                              (_BIT16|_BIT17)
#define  P1_g_6_LEQ_BIT_RATE                                                                                    (_BIT14|_BIT15)
#define  P1_g_6_LEQ_BIT_RATE_HBR                                                                            (_BIT15)
#define  P1_g_6_LEQ_BIT_RATE_MBR                                                                            (_BIT14)
#define  P1_g_6_TAP0_HBR                                                                              	        (_BIT13)
#define  P1_g_6_LEQ_PASSIVE_CORNER                                                                       ( _BIT11|_BIT12)
#define  P1_g_5_TAP0_CURRENT_ADJ                                                                            (_BIT3|_BIT4)
#define  P1_g_5_TAP0_CURRENT_ADJ_1X                                                                            (_BIT3)
#define  P1_g_5_TAP0_CURRENT_ADJ_1p25X                                                                       (_BIT4)
#define  P1_g_5_EQ_POW                                                                                             _BIT0


#define  DFE_HDMI_RX_PHY_P1_G3                                                   0x1800DA8C
#define  DFE_HDMI_RX_PHY_P1_G3_reg_addr                                          "0xB800DA8C"
#define  DFE_HDMI_RX_PHY_P1_G3_reg                                               0xB800DA8C
#define  DFE_HDMI_RX_PHY_P1_G3_inst_addr                                         "0x0023"
#define  set_DFE_HDMI_RX_PHY_P1_G3_reg(data)                                     (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P1_G3_reg)=data)
#define  get_DFE_HDMI_RX_PHY_P1_G3_reg                                           (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P1_G3_reg))
#define  DFE_HDMI_RX_PHY_P1_G3_reg_p1_g_12_shift                                 (24)
#define  DFE_HDMI_RX_PHY_P1_G3_reg_p1_g_11_shift                                 (16)
#define  DFE_HDMI_RX_PHY_P1_G3_reg_p1_g_10_shift                                 (8)
#define  DFE_HDMI_RX_PHY_P1_G3_reg_p1_g_9_shift                                  (0)
#define  DFE_HDMI_RX_PHY_P1_G3_reg_p1_g_12_mask                                  (0xFF000000)
#define  DFE_HDMI_RX_PHY_P1_G3_reg_p1_g_11_mask                                  (0x00FF0000)
#define  DFE_HDMI_RX_PHY_P1_G3_reg_p1_g_10_mask                                  (0x0000FF00)
#define  DFE_HDMI_RX_PHY_P1_G3_reg_p1_g_9_mask                                   (0x000000FF)
#define  DFE_HDMI_RX_PHY_P1_G3_reg_p1_g_12(data)                                 (0xFF000000&((data)<<24))
#define  DFE_HDMI_RX_PHY_P1_G3_reg_p1_g_11(data)                                 (0x00FF0000&((data)<<16))
#define  DFE_HDMI_RX_PHY_P1_G3_reg_p1_g_10(data)                                 (0x0000FF00&((data)<<8))
#define  DFE_HDMI_RX_PHY_P1_G3_reg_p1_g_9(data)                                  (0x000000FF&(data))
#define  DFE_HDMI_RX_PHY_P1_G3_get_reg_p1_g_12(data)                             ((0xFF000000&(data))>>24)
#define  DFE_HDMI_RX_PHY_P1_G3_get_reg_p1_g_11(data)                             ((0x00FF0000&(data))>>16)
#define  DFE_HDMI_RX_PHY_P1_G3_get_reg_p1_g_10(data)                             ((0x0000FF00&(data))>>8)
#define  DFE_HDMI_RX_PHY_P1_G3_get_reg_p1_g_9(data)                              (0x000000FF&(data))
#define P1_G_DFE_TAPEN4321                                                                              (_BIT6|_BIT5|_BIT4|_BIT3)
#define P1_g_12_PR 														 (_BIT24|_BIT25)
#define P1_g_9_DFE_ADAPTION_POW_EN 								              (_BIT7)
#define P1_g_9_DFE_TAP_EN 								                           (_BIT3|_BIT4|_BIT5|_BIT6)
#define P1_g_9_DFE_TAP1_EN 								                           (_BIT3)
#define  DFE_HDMI_RX_PHY_P1_g_tap_en(data)                                                           (0x00000078&((data)<<3))


#define  DFE_HDMI_RX_PHY_P1_G4                                                   0x1800DA90
#define  DFE_HDMI_RX_PHY_P1_G4_reg_addr                                          "0xB800DA90"
#define  DFE_HDMI_RX_PHY_P1_G4_reg                                               0xB800DA90
#define  DFE_HDMI_RX_PHY_P1_G4_inst_addr                                         "0x0024"
#define  set_DFE_HDMI_RX_PHY_P1_G4_reg(data)                                     (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P1_G4_reg)=data)
#define  get_DFE_HDMI_RX_PHY_P1_G4_reg                                           (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P1_G4_reg))
#define  DFE_HDMI_RX_PHY_P1_G4_reg_p1_g_koff_sel_shift                           (10)
#define  DFE_HDMI_RX_PHY_P1_G4_reg_p1_g_koff_bound_shift                         (9)
#define  DFE_HDMI_RX_PHY_P1_G4_reg_p1_g_koffok_shift                             (8)
#define  DFE_HDMI_RX_PHY_P1_G4_reg_p1_g_13_shift                                 (0)
#define  DFE_HDMI_RX_PHY_P1_G4_reg_p1_g_koff_sel_mask                            (0x00007C00)
#define  DFE_HDMI_RX_PHY_P1_G4_reg_p1_g_koff_bound_mask                          (0x00000200)
#define  DFE_HDMI_RX_PHY_P1_G4_reg_p1_g_koffok_mask                              (0x00000100)
#define  DFE_HDMI_RX_PHY_P1_G4_reg_p1_g_13_mask                                  (0x000000FF)
#define  DFE_HDMI_RX_PHY_P1_G4_reg_p1_g_koff_sel(data)                           (0x00007C00&((data)<<10))
#define  DFE_HDMI_RX_PHY_P1_G4_reg_p1_g_koff_bound(data)                         (0x00000200&((data)<<9))
#define  DFE_HDMI_RX_PHY_P1_G4_reg_p1_g_koffok(data)                             (0x00000100&((data)<<8))
#define  DFE_HDMI_RX_PHY_P1_G4_reg_p1_g_13(data)                                 (0x000000FF&(data))
#define  DFE_HDMI_RX_PHY_P1_G4_get_reg_p1_g_koff_sel(data)                       ((0x00007C00&(data))>>10)
#define  DFE_HDMI_RX_PHY_P1_G4_get_reg_p1_g_koff_bound(data)                     ((0x00000200&(data))>>9)
#define  DFE_HDMI_RX_PHY_P1_G4_get_reg_p1_g_koffok(data)                         ((0x00000100&(data))>>8)
#define  DFE_HDMI_RX_PHY_P1_G4_get_reg_p1_g_13(data)                             (0x000000FF&(data))

#define  DFE_HDMI_RX_PHY_P1_R1                                                   0x1800DA94
#define  DFE_HDMI_RX_PHY_P1_R1_reg_addr                                          "0xB800DA94"
#define  DFE_HDMI_RX_PHY_P1_R1_reg                                               0xB800DA94
#define  DFE_HDMI_RX_PHY_P1_R1_inst_addr                                         "0x0025"
#define  set_DFE_HDMI_RX_PHY_P1_R1_reg(data)                                     (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P1_R1_reg)=data)
#define  get_DFE_HDMI_RX_PHY_P1_R1_reg                                           (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P1_R1_reg))
#define  DFE_HDMI_RX_PHY_P1_R1_reg_p1_r_4_shift                                  (24)
#define  DFE_HDMI_RX_PHY_P1_R1_reg_p1_r_3_shift                                  (16)
#define  DFE_HDMI_RX_PHY_P1_R1_reg_p1_r_2_shift                                  (8)
#define  DFE_HDMI_RX_PHY_P1_R1_reg_p1_r_1_shift                                  (0)
#define  DFE_HDMI_RX_PHY_P1_R1_reg_p1_r_4_mask                                   (0xFF000000)
#define  DFE_HDMI_RX_PHY_P1_R1_reg_p1_r_3_mask                                   (0x00FF0000)
#define  DFE_HDMI_RX_PHY_P1_R1_reg_p1_r_2_mask                                   (0x0000FF00)
#define  DFE_HDMI_RX_PHY_P1_R1_reg_p1_r_1_mask                                   (0x000000FF)
#define  DFE_HDMI_RX_PHY_P1_R1_reg_p1_r_4(data)                                  (0xFF000000&((data)<<24))
#define  DFE_HDMI_RX_PHY_P1_R1_reg_p1_r_3(data)                                  (0x00FF0000&((data)<<16))
#define  DFE_HDMI_RX_PHY_P1_R1_reg_p1_r_2(data)                                  (0x0000FF00&((data)<<8))
#define  DFE_HDMI_RX_PHY_P1_R1_reg_p1_r_1(data)                                  (0x000000FF&(data))
#define  DFE_HDMI_RX_PHY_P1_R1_get_reg_p1_r_4(data)                              ((0xFF000000&(data))>>24)
#define  DFE_HDMI_RX_PHY_P1_R1_get_reg_p1_r_3(data)                              ((0x00FF0000&(data))>>16)
#define  DFE_HDMI_RX_PHY_P1_R1_get_reg_p1_r_2(data)                              ((0x0000FF00&(data))>>8)
#define  DFE_HDMI_RX_PHY_P1_R1_get_reg_p1_r_1(data)                              (0x000000FF&(data))
#define  P1_r_1_R_LANE_INPUT_OFF                                                 (_BIT0)
#define  P1_r_2_LEQ_BIT_RATE_mask                                                                             (_BIT8|_BIT9)
#define  P1_r_2_LEQ_BIT_RATE_MBR                                                                             (_BIT8)
#define  P1_r_2_LEQ_BIT_RATE_HBR                                                                                  (_BIT9)

#define  DFE_HDMI_RX_PHY_P1_R2                                                   0x1800DA98
#define  DFE_HDMI_RX_PHY_P1_R2_reg_addr                                          "0xB800DA98"
#define  DFE_HDMI_RX_PHY_P1_R2_reg                                               0xB800DA98
#define  DFE_HDMI_RX_PHY_P1_R2_inst_addr                                         "0x0026"
#define  set_DFE_HDMI_RX_PHY_P1_R2_reg(data)                                     (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P1_R2_reg)=data)
#define  get_DFE_HDMI_RX_PHY_P1_R2_reg                                           (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P1_R2_reg))
#define  DFE_HDMI_RX_PHY_P1_R2_reg_p1_r_8_shift                                  (24)
#define  DFE_HDMI_RX_PHY_P1_R2_reg_p1_r_7_shift                                  (16)
#define  DFE_HDMI_RX_PHY_P1_R2_reg_p1_r_6_shift                                  (8)
#define  DFE_HDMI_RX_PHY_P1_R2_reg_p1_r_5_shift                                  (0)
#define  DFE_HDMI_RX_PHY_P1_R2_reg_p1_r_8_mask                                   (0xFF000000)
#define  DFE_HDMI_RX_PHY_P1_R2_reg_p1_r_7_mask                                   (0x00FF0000)
#define  DFE_HDMI_RX_PHY_P1_R2_reg_p1_r_6_mask                                   (0x0000FF00)
#define  DFE_HDMI_RX_PHY_P1_R2_reg_p1_r_5_mask                                   (0x000000FF)
#define  DFE_HDMI_RX_PHY_P1_R2_reg_p1_r_8(data)                                  (0xFF000000&((data)<<24))
#define  DFE_HDMI_RX_PHY_P1_R2_reg_p1_r_7(data)                                  (0x00FF0000&((data)<<16))
#define  DFE_HDMI_RX_PHY_P1_R2_reg_p1_r_6(data)                                  (0x0000FF00&((data)<<8))
#define  DFE_HDMI_RX_PHY_P1_R2_reg_p1_r_5(data)                                  (0x000000FF&(data))
#define  DFE_HDMI_RX_PHY_P1_R2_get_reg_p1_r_8(data)                              ((0xFF000000&(data))>>24)
#define  DFE_HDMI_RX_PHY_P1_R2_get_reg_p1_r_7(data)                              ((0x00FF0000&(data))>>16)
#define  DFE_HDMI_RX_PHY_P1_R2_get_reg_p1_r_6(data)                              ((0x0000FF00&(data))>>8)
#define  DFE_HDMI_RX_PHY_P1_R2_get_reg_p1_r_5(data)                              (0x000000FF&(data))
#define  DFE_HDMI_RX_PHY_P1_R2_reg_p0_r_8_PR_RATE_SEL_shift             (26)
#define  DFE_HDMI_RX_PHY_P1_R2_reg_p0_r_8_DEMUX_shift             (29)
#define  DFE_HDMI_RX_PHY_P1_R2_reg_p0_r_7_TAP0_ISEL_shift                 (21)
#define  P1_r_8_DEMUX                                                                                             (_BIT29|_BIT30|_BIT31)
#define  P1_r_8_PR_RATE_SEL                                                                                    (_BIT26|_BIT27|_BIT28)
#define  P1_r_8_POW_PR                                                                                            _BIT25
#define  P1_r_8_BY_PASS_PR                                                                                      _BIT24
#define  P1_r_7_TAP0_ISEL                                                                                         (_BIT21|_BIT22|_BIT23)
#define  P1_r_7_TAP0_ISEL_400uA                                                                              (_BIT22|_BIT23)
#define  P1_r_7_LEQ_ISEL                                                                                           (_BIT18|_BIT19|_BIT20)
#define  P1_r_7_LEQ_ISEL_400uA                                                                                (_BIT19|_BIT20)
#define  P1_r_7_PI_ISEL                                                                                              (_BIT16|_BIT17)
#define  P1_r_6_LEQ_BIT_RATE                                                                                    (_BIT14|_BIT15)
#define  P1_r_6_LEQ_BIT_RATE_HBR                                                                            (_BIT15)
#define  P1_r_6_LEQ_BIT_RATE_MBR                                                                            (_BIT14)
#define  P1_r_6_TAP0_HBR                                                                              	        (_BIT13)
#define  P1_r_6_LEQ_PASSIVE_CORNER                                                                      (_BIT12|_BIT11)
#define  P1_r_5_TAP0_CURRENT_ADJ                                                                            (_BIT3|_BIT4)
#define  P1_r_5_TAP0_CURRENT_ADJ_1X                                                                            (_BIT3)
#define  P1_r_5_TAP0_CURRENT_ADJ_1p25X                                                                       (_BIT4)
#define  P1_r_5_EQ_POW                                                                                             _BIT0


#define  DFE_HDMI_RX_PHY_P1_R3                                                   0x1800DA9C
#define  DFE_HDMI_RX_PHY_P1_R3_reg_addr                                          "0xB800DA9C"
#define  DFE_HDMI_RX_PHY_P1_R3_reg                                               0xB800DA9C
#define  DFE_HDMI_RX_PHY_P1_R3_inst_addr                                         "0x0027"
#define  set_DFE_HDMI_RX_PHY_P1_R3_reg(data)                                     (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P1_R3_reg)=data)
#define  get_DFE_HDMI_RX_PHY_P1_R3_reg                                           (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P1_R3_reg))
#define  DFE_HDMI_RX_PHY_P1_R3_reg_p1_r_12_shift                                 (24)
#define  DFE_HDMI_RX_PHY_P1_R3_reg_p1_r_11_shift                                 (16)
#define  DFE_HDMI_RX_PHY_P1_R3_reg_p1_r_10_shift                                 (8)
#define  DFE_HDMI_RX_PHY_P1_R3_reg_p1_r_9_shift                                  (0)
#define  DFE_HDMI_RX_PHY_P1_R3_reg_p1_r_12_mask                                  (0xFF000000)
#define  DFE_HDMI_RX_PHY_P1_R3_reg_p1_r_11_mask                                  (0x00FF0000)
#define  DFE_HDMI_RX_PHY_P1_R3_reg_p1_r_10_mask                                  (0x0000FF00)
#define  DFE_HDMI_RX_PHY_P1_R3_reg_p1_r_9_mask                                   (0x000000FF)
#define  DFE_HDMI_RX_PHY_P1_R3_reg_p1_r_12(data)                                 (0xFF000000&((data)<<24))
#define  DFE_HDMI_RX_PHY_P1_R3_reg_p1_r_11(data)                                 (0x00FF0000&((data)<<16))
#define  DFE_HDMI_RX_PHY_P1_R3_reg_p1_r_10(data)                                 (0x0000FF00&((data)<<8))
#define  DFE_HDMI_RX_PHY_P1_R3_reg_p1_r_9(data)                                  (0x000000FF&(data))
#define  DFE_HDMI_RX_PHY_P1_R3_get_reg_p1_r_12(data)                             ((0xFF000000&(data))>>24)
#define  DFE_HDMI_RX_PHY_P1_R3_get_reg_p1_r_11(data)                             ((0x00FF0000&(data))>>16)
#define  DFE_HDMI_RX_PHY_P1_R3_get_reg_p1_r_10(data)                             ((0x0000FF00&(data))>>8)
#define  DFE_HDMI_RX_PHY_P1_R3_get_reg_p1_r_9(data)                              (0x000000FF&(data))
#define P1_R_DFE_TAPEN4321                                                                              (_BIT6|_BIT5|_BIT4|_BIT3)
#define P1_r_12_PR 														 (_BIT24|_BIT25)
#define P1_r_9_DFE_ADAPTION_POW_EN 								              (_BIT7)
#define P1_r_9_DFE_TAP_EN 								                           (_BIT3|_BIT4|_BIT5|_BIT6)
#define P1_r_9_DFE_TAP1_EN 								                           (_BIT3)
#define  DFE_HDMI_RX_PHY_P1_r_tap_en(data)                                                           (0x00000078&((data)<<3))


#define  DFE_HDMI_RX_PHY_P1_R4                                                   0x1800DAA0
#define  DFE_HDMI_RX_PHY_P1_R4_reg_addr                                          "0xB800DAA0"
#define  DFE_HDMI_RX_PHY_P1_R4_reg                                               0xB800DAA0
#define  DFE_HDMI_RX_PHY_P1_R4_inst_addr                                         "0x0028"
#define  set_DFE_HDMI_RX_PHY_P1_R4_reg(data)                                     (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P1_R4_reg)=data)
#define  get_DFE_HDMI_RX_PHY_P1_R4_reg                                           (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P1_R4_reg))
#define  DFE_HDMI_RX_PHY_P1_R4_reg_p1_r_koff_sel_shift                           (10)
#define  DFE_HDMI_RX_PHY_P1_R4_reg_p1_r_koff_bound_shift                         (9)
#define  DFE_HDMI_RX_PHY_P1_R4_reg_p1_r_koffok_shift                             (8)
#define  DFE_HDMI_RX_PHY_P1_R4_reg_p1_r_13_shift                                 (0)
#define  DFE_HDMI_RX_PHY_P1_R4_reg_p1_r_koff_sel_mask                            (0x00007C00)
#define  DFE_HDMI_RX_PHY_P1_R4_reg_p1_r_koff_bound_mask                          (0x00000200)
#define  DFE_HDMI_RX_PHY_P1_R4_reg_p1_r_koffok_mask                              (0x00000100)
#define  DFE_HDMI_RX_PHY_P1_R4_reg_p1_r_13_mask                                  (0x000000FF)
#define  DFE_HDMI_RX_PHY_P1_R4_reg_p1_r_koff_sel(data)                           (0x00007C00&((data)<<10))
#define  DFE_HDMI_RX_PHY_P1_R4_reg_p1_r_koff_bound(data)                         (0x00000200&((data)<<9))
#define  DFE_HDMI_RX_PHY_P1_R4_reg_p1_r_koffok(data)                             (0x00000100&((data)<<8))
#define  DFE_HDMI_RX_PHY_P1_R4_reg_p1_r_13(data)                                 (0x000000FF&(data))
#define  DFE_HDMI_RX_PHY_P1_R4_get_reg_p1_r_koff_sel(data)                       ((0x00007C00&(data))>>10)
#define  DFE_HDMI_RX_PHY_P1_R4_get_reg_p1_r_koff_bound(data)                     ((0x00000200&(data))>>9)
#define  DFE_HDMI_RX_PHY_P1_R4_get_reg_p1_r_koffok(data)                         ((0x00000100&(data))>>8)
#define  DFE_HDMI_RX_PHY_P1_R4_get_reg_p1_r_13(data)                             (0x000000FF&(data))

#define  DFE_HDMI_RX_PHY_P2_ACDR1                                                0x1800DAA4
#define  DFE_HDMI_RX_PHY_P2_ACDR1_reg_addr                                       "0xB800DAA4"
#define  DFE_HDMI_RX_PHY_P2_ACDR1_reg                                            0xB800DAA4
#define  DFE_HDMI_RX_PHY_P2_ACDR1_inst_addr                                      "0x0029"
#define  set_DFE_HDMI_RX_PHY_P2_ACDR1_reg(data)                                  (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P2_ACDR1_reg)=data)
#define  get_DFE_HDMI_RX_PHY_P2_ACDR1_reg                                        (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P2_ACDR1_reg))
#define  DFE_HDMI_RX_PHY_P2_ACDR1_reg_p2_acdr_4_shift                            (24)
#define  DFE_HDMI_RX_PHY_P2_ACDR1_reg_p2_acdr_3_shift                            (16)
#define  DFE_HDMI_RX_PHY_P2_ACDR1_reg_p2_acdr_2_shift                            (8)
#define  DFE_HDMI_RX_PHY_P2_ACDR1_reg_p2_acdr_1_shift                            (0)
#define  DFE_HDMI_RX_PHY_P2_ACDR1_reg_p2_acdr_4_mask                             (0xFF000000)
#define  DFE_HDMI_RX_PHY_P2_ACDR1_reg_p2_acdr_3_mask                             (0x00FF0000)
#define  DFE_HDMI_RX_PHY_P2_ACDR1_reg_p2_acdr_2_mask                             (0x0000FF00)
#define  DFE_HDMI_RX_PHY_P2_ACDR1_reg_p2_acdr_1_mask                             (0x000000FF)
#define  DFE_HDMI_RX_PHY_P2_ACDR1_reg_p2_acdr_4(data)                            (0xFF000000&((data)<<24))
#define  DFE_HDMI_RX_PHY_P2_ACDR1_reg_p2_acdr_3(data)                            (0x00FF0000&((data)<<16))
#define  DFE_HDMI_RX_PHY_P2_ACDR1_reg_p2_acdr_2(data)                            (0x0000FF00&((data)<<8))
#define  DFE_HDMI_RX_PHY_P2_ACDR1_reg_p2_acdr_1(data)                            (0x000000FF&(data))
#define  DFE_HDMI_RX_PHY_P2_ACDR1_get_reg_p2_acdr_4(data)                        ((0xFF000000&(data))>>24)
#define  DFE_HDMI_RX_PHY_P2_ACDR1_get_reg_p2_acdr_3(data)                        ((0x00FF0000&(data))>>16)
#define  DFE_HDMI_RX_PHY_P2_ACDR1_get_reg_p2_acdr_2(data)                        ((0x0000FF00&(data))>>8)
#define  DFE_HDMI_RX_PHY_P2_ACDR1_get_reg_p2_acdr_1(data)                        (0x000000FF&(data))
#define  p2_REG_ACDR_CPCVM_EN                     (_BIT26)
#define  p2_REG_ACDR_VCOGAIN                       (_BIT21|_BIT20)
#define  p2_REG_ACDR_LFRS_SEL                      (_BIT15|_BIT14|_BIT13)
#define  p2_REG_ACDR_CKFLD_EN                     (_BIT5)
#define  p2_REG_ACDR_EN                                 (_BIT1)
#define  p2_REG_ACDR_TOP_EN                         (_BIT0)

#define  DFE_HDMI_RX_PHY_P2_ACDR2                                                0x1800DAA8
#define  DFE_HDMI_RX_PHY_P2_ACDR2_reg_addr                                       "0xB800DAA8"
#define  DFE_HDMI_RX_PHY_P2_ACDR2_reg                                            0xB800DAA8
#define  DFE_HDMI_RX_PHY_P2_ACDR2_inst_addr                                      "0x002A"
#define  set_DFE_HDMI_RX_PHY_P2_ACDR2_reg(data)                                  (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P2_ACDR2_reg)=data)
#define  get_DFE_HDMI_RX_PHY_P2_ACDR2_reg                                        (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P2_ACDR2_reg))
#define  DFE_HDMI_RX_PHY_P2_ACDR2_reg_p2_acdr_8_shift                            (24)
#define  DFE_HDMI_RX_PHY_P2_ACDR2_reg_p2_acdr_7_shift                            (16)
#define  DFE_HDMI_RX_PHY_P2_ACDR2_reg_p2_acdr_6_shift                            (8)
#define  DFE_HDMI_RX_PHY_P2_ACDR2_reg_p2_acdr_5_shift                            (0)
#define  DFE_HDMI_RX_PHY_P2_ACDR2_reg_p2_acdr_8_mask                             (0xFF000000)
#define  DFE_HDMI_RX_PHY_P2_ACDR2_reg_p2_acdr_7_mask                             (0x00FF0000)
#define  DFE_HDMI_RX_PHY_P2_ACDR2_reg_p2_acdr_6_mask                             (0x0000FF00)
#define  DFE_HDMI_RX_PHY_P2_ACDR2_reg_p2_acdr_5_mask                             (0x000000FF)
#define  DFE_HDMI_RX_PHY_P2_ACDR2_reg_p2_acdr_8(data)                            (0xFF000000&((data)<<24))
#define  DFE_HDMI_RX_PHY_P2_ACDR2_reg_p2_acdr_7(data)                            (0x00FF0000&((data)<<16))
#define  DFE_HDMI_RX_PHY_P2_ACDR2_reg_p2_acdr_6(data)                            (0x0000FF00&((data)<<8))
#define  DFE_HDMI_RX_PHY_P2_ACDR2_reg_p2_acdr_5(data)                            (0x000000FF&(data))
#define  DFE_HDMI_RX_PHY_P2_ACDR2_get_reg_p2_acdr_8(data)                        ((0xFF000000&(data))>>24)
#define  DFE_HDMI_RX_PHY_P2_ACDR2_get_reg_p2_acdr_7(data)                        ((0x00FF0000&(data))>>16)
#define  DFE_HDMI_RX_PHY_P2_ACDR2_get_reg_p2_acdr_6(data)                        ((0x0000FF00&(data))>>8)
#define  DFE_HDMI_RX_PHY_P2_ACDR2_get_reg_p2_acdr_5(data)                        (0x000000FF&(data))

#define  DFE_HDMI_RX_PHY_P2_B1                                                   0x1800DAAC
#define  DFE_HDMI_RX_PHY_P2_B1_reg_addr                                          "0xB800DAAC"
#define  DFE_HDMI_RX_PHY_P2_B1_reg                                               0xB800DAAC
#define  DFE_HDMI_RX_PHY_P2_B1_inst_addr                                         "0x002B"
#define  set_DFE_HDMI_RX_PHY_P2_B1_reg(data)                                     (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P2_B1_reg)=data)
#define  get_DFE_HDMI_RX_PHY_P2_B1_reg                                           (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P2_B1_reg))
#define  DFE_HDMI_RX_PHY_P2_B1_reg_p2_b_4_shift                                  (24)
#define  DFE_HDMI_RX_PHY_P2_B1_reg_p2_b_3_shift                                  (16)
#define  DFE_HDMI_RX_PHY_P2_B1_reg_p2_b_2_shift                                  (8)
#define  DFE_HDMI_RX_PHY_P2_B1_reg_p2_b_1_shift                                  (0)
#define  DFE_HDMI_RX_PHY_P2_B1_reg_p2_b_4_mask                                   (0xFF000000)
#define  DFE_HDMI_RX_PHY_P2_B1_reg_p2_b_3_mask                                   (0x00FF0000)
#define  DFE_HDMI_RX_PHY_P2_B1_reg_p2_b_2_mask                                   (0x0000FF00)
#define  DFE_HDMI_RX_PHY_P2_B1_reg_p2_b_1_mask                                   (0x000000FF)
#define  DFE_HDMI_RX_PHY_P2_B1_reg_p2_b_4(data)                                  (0xFF000000&((data)<<24))
#define  DFE_HDMI_RX_PHY_P2_B1_reg_p2_b_3(data)                                  (0x00FF0000&((data)<<16))
#define  DFE_HDMI_RX_PHY_P2_B1_reg_p2_b_2(data)                                  (0x0000FF00&((data)<<8))
#define  DFE_HDMI_RX_PHY_P2_B1_reg_p2_b_1(data)                                  (0x000000FF&(data))
#define  DFE_HDMI_RX_PHY_P2_B1_get_reg_p2_b_4(data)                              ((0xFF000000&(data))>>24)
#define  DFE_HDMI_RX_PHY_P2_B1_get_reg_p2_b_3(data)                              ((0x00FF0000&(data))>>16)
#define  DFE_HDMI_RX_PHY_P2_B1_get_reg_p2_b_2(data)                              ((0x0000FF00&(data))>>8)
#define  DFE_HDMI_RX_PHY_P2_B1_get_reg_p2_b_1(data)                              (0x000000FF&(data))

#define  DFE_HDMI_RX_PHY_P2_B2                                                   0x1800DAB0
#define  DFE_HDMI_RX_PHY_P2_B2_reg_addr                                          "0xB800DAB0"
#define  DFE_HDMI_RX_PHY_P2_B2_reg                                               0xB800DAB0
#define  DFE_HDMI_RX_PHY_P2_B2_inst_addr                                         "0x002C"
#define  set_DFE_HDMI_RX_PHY_P2_B2_reg(data)                                     (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P2_B2_reg)=data)
#define  get_DFE_HDMI_RX_PHY_P2_B2_reg                                           (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P2_B2_reg))
#define  DFE_HDMI_RX_PHY_P2_B2_reg_p2_b_8_shift                                  (24)
#define  DFE_HDMI_RX_PHY_P2_B2_reg_p2_b_7_shift                                  (16)
#define  DFE_HDMI_RX_PHY_P2_B2_reg_p2_b_6_shift                                  (8)
#define  DFE_HDMI_RX_PHY_P2_B2_reg_p2_b_5_shift                                  (0)
#define  DFE_HDMI_RX_PHY_P2_B2_reg_p2_b_8_mask                                   (0xFF000000)
#define  DFE_HDMI_RX_PHY_P2_B2_reg_p2_b_7_mask                                   (0x00FF0000)
#define  DFE_HDMI_RX_PHY_P2_B2_reg_p2_b_6_mask                                   (0x0000FF00)
#define  DFE_HDMI_RX_PHY_P2_B2_reg_p2_b_5_mask                                   (0x000000FF)
#define  DFE_HDMI_RX_PHY_P2_B2_reg_p2_b_8(data)                                  (0xFF000000&((data)<<24))
#define  DFE_HDMI_RX_PHY_P2_B2_reg_p2_b_7(data)                                  (0x00FF0000&((data)<<16))
#define  DFE_HDMI_RX_PHY_P2_B2_reg_p2_b_6(data)                                  (0x0000FF00&((data)<<8))
#define  DFE_HDMI_RX_PHY_P2_B2_reg_p2_b_5(data)                                  (0x000000FF&(data))
#define  DFE_HDMI_RX_PHY_P2_B2_get_reg_p2_b_8(data)                              ((0xFF000000&(data))>>24)
#define  DFE_HDMI_RX_PHY_P2_B2_get_reg_p2_b_7(data)                              ((0x00FF0000&(data))>>16)
#define  DFE_HDMI_RX_PHY_P2_B2_get_reg_p2_b_6(data)                              ((0x0000FF00&(data))>>8)
#define  DFE_HDMI_RX_PHY_P2_B2_get_reg_p2_b_5(data)                              (0x000000FF&(data))

#define  DFE_HDMI_RX_PHY_P2_B2_reg_p2_b_8_PR_RATE_SEL_shift             (26)
#define  DFE_HDMI_RX_PHY_P2_B2_reg_p2_b_8_DEMUX_shift             (29)
#define  DFE_HDMI_RX_PHY_P2_B2_reg_p2_b_7_TAP0_ISEL_shift                 (21)
#define  P2_b_8_DEMUX                                                                                             (_BIT29|_BIT30|_BIT31)
#define  P2_b_8_PR_RATE_SEL                                                                                    (_BIT26|_BIT27|_BIT28)
#define  P2_b_8_POW_PR                                                                                            _BIT25
#define  P2_b_7_TAP0_ISEL                                                                                         (_BIT21|_BIT22|_BIT23)
#define  P2_b_7_TAP0_ISEL_400uA                                                                              (_BIT22|_BIT23)
#define  P2_b_7_LEQ_ISEL                                                                                           (_BIT18|_BIT19|_BIT20)
#define  P2_b_7_LEQ_ISEL_400uA                                                                                (_BIT19|_BIT20)
#define  P2_b_7_PI_ISEL                                                                                              (_BIT16|_BIT17)
#define  P2_b_6_LEQ_BIT_RATE                                                                                    (_BIT14|_BIT15)
#define  P2_b_6_LEQ_BIT_RATE_HBR                                                                            (_BIT15)
#define  P2_b_6_LEQ_BIT_RATE_MBR                                                                            (_BIT14)
#define  P2_b_6_TAP0_HBR                                                                              	        (_BIT13)
#define  P2_b_6_LEQ_PASSIVE_CORNER                                                                      (_BIT12|_BIT11)
#define  P2_b_5_EQ_POW                                                                                             _BIT0


#define  DFE_HDMI_RX_PHY_P2_B3                                                   0x1800DAB4
#define  DFE_HDMI_RX_PHY_P2_B3_reg_addr                                          "0xB800DAB4"
#define  DFE_HDMI_RX_PHY_P2_B3_reg                                               0xB800DAB4
#define  DFE_HDMI_RX_PHY_P2_B3_inst_addr                                         "0x002D"
#define  set_DFE_HDMI_RX_PHY_P2_B3_reg(data)                                     (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P2_B3_reg)=data)
#define  get_DFE_HDMI_RX_PHY_P2_B3_reg                                           (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P2_B3_reg))
#define  DFE_HDMI_RX_PHY_P2_B3_reg_p2_b_12_shift                                 (24)
#define  DFE_HDMI_RX_PHY_P2_B3_reg_p2_b_11_shift                                 (16)
#define  DFE_HDMI_RX_PHY_P2_B3_reg_p2_b_10_shift                                 (8)
#define  DFE_HDMI_RX_PHY_P2_B3_reg_p2_b_9_shift                                  (0)
#define  DFE_HDMI_RX_PHY_P2_B3_reg_p2_b_12_mask                                  (0xFF000000)
#define  DFE_HDMI_RX_PHY_P2_B3_reg_p2_b_11_mask                                  (0x00FF0000)
#define  DFE_HDMI_RX_PHY_P2_B3_reg_p2_b_10_mask                                  (0x0000FF00)
#define  DFE_HDMI_RX_PHY_P2_B3_reg_p2_b_9_mask                                   (0x000000FF)
#define  DFE_HDMI_RX_PHY_P2_B3_reg_p2_b_12(data)                                 (0xFF000000&((data)<<24))
#define  DFE_HDMI_RX_PHY_P2_B3_reg_p2_b_11(data)                                 (0x00FF0000&((data)<<16))
#define  DFE_HDMI_RX_PHY_P2_B3_reg_p2_b_10(data)                                 (0x0000FF00&((data)<<8))
#define  DFE_HDMI_RX_PHY_P2_B3_reg_p2_b_9(data)                                  (0x000000FF&(data))
#define  DFE_HDMI_RX_PHY_P2_B3_get_reg_p2_b_12(data)                             ((0xFF000000&(data))>>24)
#define  DFE_HDMI_RX_PHY_P2_B3_get_reg_p2_b_11(data)                             ((0x00FF0000&(data))>>16)
#define  DFE_HDMI_RX_PHY_P2_B3_get_reg_p2_b_10(data)                             ((0x0000FF00&(data))>>8)
#define  DFE_HDMI_RX_PHY_P2_B3_get_reg_p2_b_9(data)                              (0x000000FF&(data))
#define P2_B_DFE_TAPEN4321                                                                              (_BIT6|_BIT5|_BIT4|_BIT3)
#define P2_b_12_PR 							 (_BIT24|_BIT25)
#define P2_b_11_ACDR_RATE_SEL_HALF_RATE 					 (_BIT16)
#define P2_b_9_DFE_ADAPTION_POW_EN 				              (_BIT7)
#define P2_b_9_DFE_TAP_EN 					              (_BIT3|_BIT4|_BIT5|_BIT6)
#define P2_b_9_DFE_TAP1_EN 					                (_BIT3)
#define  DFE_HDMI_RX_PHY_P2_b_tap_en(data)                                                           (0x00000078&((data)<<3))


#define  DFE_HDMI_RX_PHY_P2_B4                                                   0x1800DAB8
#define  DFE_HDMI_RX_PHY_P2_B4_reg_addr                                          "0xB800DAB8"
#define  DFE_HDMI_RX_PHY_P2_B4_reg                                               0xB800DAB8
#define  DFE_HDMI_RX_PHY_P2_B4_inst_addr                                         "0x002E"
#define  set_DFE_HDMI_RX_PHY_P2_B4_reg(data)                                     (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P2_B4_reg)=data)
#define  get_DFE_HDMI_RX_PHY_P2_B4_reg                                           (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P2_B4_reg))
#define  DFE_HDMI_RX_PHY_P2_B4_reg_p2_b_koff_sel_shift                           (10)
#define  DFE_HDMI_RX_PHY_P2_B4_reg_p2_b_koff_bound_shift                         (9)
#define  DFE_HDMI_RX_PHY_P2_B4_reg_p2_b_koffok_shift                             (8)
#define  DFE_HDMI_RX_PHY_P2_B4_reg_p2_b_13_shift                                 (0)
#define  DFE_HDMI_RX_PHY_P2_B4_reg_p2_b_koff_sel_mask                            (0x00007C00)
#define  DFE_HDMI_RX_PHY_P2_B4_reg_p2_b_koff_bound_mask                          (0x00000200)
#define  DFE_HDMI_RX_PHY_P2_B4_reg_p2_b_koffok_mask                              (0x00000100)
#define  DFE_HDMI_RX_PHY_P2_B4_reg_p2_b_13_mask                                  (0x000000FF)
#define  DFE_HDMI_RX_PHY_P2_B4_reg_p2_b_koff_sel(data)                           (0x00007C00&((data)<<10))
#define  DFE_HDMI_RX_PHY_P2_B4_reg_p2_b_koff_bound(data)                         (0x00000200&((data)<<9))
#define  DFE_HDMI_RX_PHY_P2_B4_reg_p2_b_koffok(data)                             (0x00000100&((data)<<8))
#define  DFE_HDMI_RX_PHY_P2_B4_reg_p2_b_13(data)                                 (0x000000FF&(data))
#define  DFE_HDMI_RX_PHY_P2_B4_get_reg_p2_b_koff_sel(data)                       ((0x00007C00&(data))>>10)
#define  DFE_HDMI_RX_PHY_P2_B4_get_reg_p2_b_koff_bound(data)                     ((0x00000200&(data))>>9)
#define  DFE_HDMI_RX_PHY_P2_B4_get_reg_p2_b_koffok(data)                         ((0x00000100&(data))>>8)
#define  DFE_HDMI_RX_PHY_P2_B4_get_reg_p2_b_13(data)                             (0x000000FF&(data))

#define  DFE_HDMI_RX_PHY_P2_CK1                                                  0x1800DABC
#define  DFE_HDMI_RX_PHY_P2_CK1_reg_addr                                         "0xB800DABC"
#define  DFE_HDMI_RX_PHY_P2_CK1_reg                                              0xB800DABC
#define  DFE_HDMI_RX_PHY_P2_CK1_inst_addr                                        "0x002F"
#define  set_DFE_HDMI_RX_PHY_P2_CK1_reg(data)                                    (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P2_CK1_reg)=data)
#define  get_DFE_HDMI_RX_PHY_P2_CK1_reg                                          (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P2_CK1_reg))
#define  DFE_HDMI_RX_PHY_P2_CK1_reg_p2_ck_4_shift                                (24)
#define  DFE_HDMI_RX_PHY_P2_CK1_reg_p2_ck_3_shift                                (16)
#define  DFE_HDMI_RX_PHY_P2_CK1_reg_p2_ck_2_shift                                (8)
#define  DFE_HDMI_RX_PHY_P2_CK1_reg_p2_ck_1_shift                                (0)
#define  DFE_HDMI_RX_PHY_P2_CK1_reg_p2_ck_4_mask                                 (0xFF000000)
#define  DFE_HDMI_RX_PHY_P2_CK1_reg_p2_ck_3_mask                                 (0x00FF0000)
#define  DFE_HDMI_RX_PHY_P2_CK1_reg_p2_ck_2_mask                                 (0x0000FF00)
#define  DFE_HDMI_RX_PHY_P2_CK1_reg_p2_ck_1_mask                                 (0x000000FF)
#define  DFE_HDMI_RX_PHY_P2_CK1_reg_p2_ck_4(data)                                (0xFF000000&((data)<<24))
#define  DFE_HDMI_RX_PHY_P2_CK1_reg_p2_ck_3(data)                                (0x00FF0000&((data)<<16))
#define  DFE_HDMI_RX_PHY_P2_CK1_reg_p2_ck_2(data)                                (0x0000FF00&((data)<<8))
#define  DFE_HDMI_RX_PHY_P2_CK1_reg_p2_ck_1(data)                                (0x000000FF&(data))
#define  DFE_HDMI_RX_PHY_P2_CK1_get_reg_p2_ck_4(data)                            ((0xFF000000&(data))>>24)
#define  DFE_HDMI_RX_PHY_P2_CK1_get_reg_p2_ck_3(data)                            ((0x00FF0000&(data))>>16)
#define  DFE_HDMI_RX_PHY_P2_CK1_get_reg_p2_ck_2(data)                            ((0x0000FF00&(data))>>8)
#define  DFE_HDMI_RX_PHY_P2_CK1_get_reg_p2_ck_1(data)                            (0x000000FF&(data))
#define  p2_ck_3_CMU_N_code                                                                          (_BIT18|_BIT19)
#define  p2_ck_2_CMU_CKIN_SEL                                                                   (_BIT12|_BIT13|_BIT14|_BIT15)
#define  p2_CMU_CKOUT_SEL                                                                             (_BIT11)
#define  p2_ck_2_CK_MD_REF_SEL                                                                   _BIT9
#define  p2_ck_1_port_bias                                                                              _BIT2
#define  p2_ck_1_CKAFE_POW                                                                          _BIT1


#define  DFE_HDMI_RX_PHY_P2_CK2                                                  0x1800DAC0
#define  DFE_HDMI_RX_PHY_P2_CK2_reg_addr                                         "0xB800DAC0"
#define  DFE_HDMI_RX_PHY_P2_CK2_reg                                              0xB800DAC0
#define  DFE_HDMI_RX_PHY_P2_CK2_inst_addr                                        "0x0030"
#define  set_DFE_HDMI_RX_PHY_P2_CK2_reg(data)                                    (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P2_CK2_reg)=data)
#define  get_DFE_HDMI_RX_PHY_P2_CK2_reg                                          (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P2_CK2_reg))
#define  DFE_HDMI_RX_PHY_P2_CK2_reg_p2_ck_8_shift                                (24)
#define  DFE_HDMI_RX_PHY_P2_CK2_reg_p2_ck_7_shift                                (16)
#define  DFE_HDMI_RX_PHY_P2_CK2_reg_p2_ck_6_shift                                (8)
#define  DFE_HDMI_RX_PHY_P2_CK2_reg_p2_ck_5_shift                                (0)
#define  DFE_HDMI_RX_PHY_P2_CK2_reg_p2_ck_8_mask                                 (0xFF000000)
#define  DFE_HDMI_RX_PHY_P2_CK2_reg_p2_ck_7_mask                                 (0x00FF0000)
#define  DFE_HDMI_RX_PHY_P2_CK2_reg_p2_ck_6_mask                                 (0x0000FF00)
#define  DFE_HDMI_RX_PHY_P2_CK2_reg_p2_ck_5_mask                                 (0x000000FF)
#define  DFE_HDMI_RX_PHY_P2_CK2_reg_p2_ck_8(data)                                (0xFF000000&((data)<<24))
#define  DFE_HDMI_RX_PHY_P2_CK2_reg_p2_ck_7(data)                                (0x00FF0000&((data)<<16))
#define  DFE_HDMI_RX_PHY_P2_CK2_reg_p2_ck_6(data)                                (0x0000FF00&((data)<<8))
#define  DFE_HDMI_RX_PHY_P2_CK2_reg_p2_ck_5(data)                                (0x000000FF&(data))
#define  DFE_HDMI_RX_PHY_P2_CK2_get_reg_p2_ck_8(data)                            ((0xFF000000&(data))>>24)
#define  DFE_HDMI_RX_PHY_P2_CK2_get_reg_p2_ck_7(data)                            ((0x00FF0000&(data))>>16)
#define  DFE_HDMI_RX_PHY_P2_CK2_get_reg_p2_ck_6(data)                            ((0x0000FF00&(data))>>8)
#define  DFE_HDMI_RX_PHY_P2_CK2_get_reg_p2_ck_5(data)                            (0x000000FF&(data))
#define  p2_ck_8_LDO_EN                                                                                  _BIT25
#define  P2_ck_8_VSEL_LDO_A_mask                                                                   (_BIT29|_BIT30|_BIT31)
#define  P2_ck_8_VSEL_LDO_D_mask                                                                   (_BIT26|_BIT27|_BIT28)
#define  P2_ck_8_LDO_EN_mask                                                                          (_BIT25)
#define  P2_ck_8_CMU_BPPSR_mask                                                                          (_BIT24)
#define  P2_ck_7_CMU_BYPASS_PI_mask                                                              (_BIT19)
#define  P2_ck_7_CMU_PI_I_SEL_mask                                                                 (_BIT16|_BIT17|_BIT18)
#define  P2_ck_6_CMU_BIG_KVCO_mask                                                                 (_BIT13)
#define  P2_ck_6_CMU_EN_CAP_mask                                                                     (_BIT12)
#define  P2_ck_6_CMU_SEL_CS_mask                                                                     (_BIT8|_BIT9|_BIT10)
#define  P2_ck_5_CMU_SEL_PUMP_I_mask                                                               (_BIT4|_BIT5|_BIT6|_BIT7)
#define  P2_ck_5_CMU_SEL_R1_mask                                                                       (_BIT0|_BIT1|_BIT2)
#define  DFE_HDMI_RX_PHY_P2_VSEL_LDO_D(data)                            (0x1C000000&((data)<<26))
#define  DFE_HDMI_RX_PHY_P2_CMU_BPPSR(data)                            (0x01000000&((data)<<24))
#define  DFE_HDMI_RX_PHY_P2_CMU_SEL_CS(data)                            (0x00000700&((data)<<8))
#define  DFE_HDMI_RX_PHY_P2_CMU_SEL_PUMP_I(data)                            (0x000000F0&((data)<<4))
#define  DFE_HDMI_RX_PHY_P2_CMU_SEL_R1(data)                            (0x00000007&((data)<<0))

#define  DFE_HDMI_RX_PHY_P2_CK3                                                  0x1800DAC4
#define  DFE_HDMI_RX_PHY_P2_CK3_reg_addr                                         "0xB800DAC4"
#define  DFE_HDMI_RX_PHY_P2_CK3_reg                                              0xB800DAC4
#define  DFE_HDMI_RX_PHY_P2_CK3_inst_addr                                        "0x0031"
#define  set_DFE_HDMI_RX_PHY_P2_CK3_reg(data)                                    (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P2_CK3_reg)=data)
#define  get_DFE_HDMI_RX_PHY_P2_CK3_reg                                          (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P2_CK3_reg))
#define  DFE_HDMI_RX_PHY_P2_CK3_reg_p2_ck_12_shift                               (24)
#define  DFE_HDMI_RX_PHY_P2_CK3_reg_p2_ck_11_shift                               (16)
#define  DFE_HDMI_RX_PHY_P2_CK3_reg_p2_ck_10_shift                               (8)
#define  DFE_HDMI_RX_PHY_P2_CK3_reg_p2_ck_9_shift                                (0)
#define  DFE_HDMI_RX_PHY_P2_CK3_reg_p2_ck_12_mask                                (0xFF000000)
#define  DFE_HDMI_RX_PHY_P2_CK3_reg_p2_ck_11_mask                                (0x00FF0000)
#define  DFE_HDMI_RX_PHY_P2_CK3_reg_p2_ck_10_mask                                (0x0000FF00)
#define  DFE_HDMI_RX_PHY_P2_CK3_reg_p2_ck_9_mask                                 (0x000000FF)
#define  DFE_HDMI_RX_PHY_P2_CK3_reg_p2_ck_12(data)                               (0xFF000000&((data)<<24))
#define  DFE_HDMI_RX_PHY_P2_CK3_reg_p2_ck_11(data)                               (0x00FF0000&((data)<<16))
#define  DFE_HDMI_RX_PHY_P2_CK3_reg_p2_ck_10(data)                               (0x0000FF00&((data)<<8))
#define  DFE_HDMI_RX_PHY_P2_CK3_reg_p2_ck_9(data)                                (0x000000FF&(data))
#define  DFE_HDMI_RX_PHY_P2_CK3_get_reg_p2_ck_12(data)                           ((0xFF000000&(data))>>24)
#define  DFE_HDMI_RX_PHY_P2_CK3_get_reg_p2_ck_11(data)                           ((0x00FF0000&(data))>>16)
#define  DFE_HDMI_RX_PHY_P2_CK3_get_reg_p2_ck_10(data)                           ((0x0000FF00&(data))>>8)
#define  DFE_HDMI_RX_PHY_P2_CK3_get_reg_p2_ck_9(data)                            (0x000000FF&(data))
#define  P2_ck_9_CMU_PFD_RSTB                                                                          (_BIT5)
#define  P2_ck_9_CMU_WDRST                                                                          (_BIT2)

#define  DFE_HDMI_RX_PHY_P2_CK4                                                  0x1800DAC8
#define  DFE_HDMI_RX_PHY_P2_CK4_reg_addr                                         "0xB800DAC8"
#define  DFE_HDMI_RX_PHY_P2_CK4_reg                                              0xB800DAC8
#define  DFE_HDMI_RX_PHY_P2_CK4_inst_addr                                        "0x0032"
#define  set_DFE_HDMI_RX_PHY_P2_CK4_reg(data)                                    (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P2_CK4_reg)=data)
#define  get_DFE_HDMI_RX_PHY_P2_CK4_reg                                          (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P2_CK4_reg))
#define  DFE_HDMI_RX_PHY_P2_CK4_reg_p2_ck_13_shift                               (0)
#define  DFE_HDMI_RX_PHY_P2_CK4_reg_p2_ck_13_mask                                (0x000000FF)
#define  DFE_HDMI_RX_PHY_P2_CK4_reg_p2_ck_13(data)                               (0x000000FF&(data))
#define  DFE_HDMI_RX_PHY_P2_CK4_get_reg_p2_ck_13(data)                           (0x000000FF&(data))

#define  DFE_HDMI_RX_PHY_P2_G1                                                   0x1800DACC
#define  DFE_HDMI_RX_PHY_P2_G1_reg_addr                                          "0xB800DACC"
#define  DFE_HDMI_RX_PHY_P2_G1_reg                                               0xB800DACC
#define  DFE_HDMI_RX_PHY_P2_G1_inst_addr                                         "0x0033"
#define  set_DFE_HDMI_RX_PHY_P2_G1_reg(data)                                     (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P2_G1_reg)=data)
#define  get_DFE_HDMI_RX_PHY_P2_G1_reg                                           (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P2_G1_reg))
#define  DFE_HDMI_RX_PHY_P2_G1_reg_p2_g_4_shift                                  (24)
#define  DFE_HDMI_RX_PHY_P2_G1_reg_p2_g_3_shift                                  (16)
#define  DFE_HDMI_RX_PHY_P2_G1_reg_p2_g_2_shift                                  (8)
#define  DFE_HDMI_RX_PHY_P2_G1_reg_p2_g_1_shift                                  (0)
#define  DFE_HDMI_RX_PHY_P2_G1_reg_p2_g_4_mask                                   (0xFF000000)
#define  DFE_HDMI_RX_PHY_P2_G1_reg_p2_g_3_mask                                   (0x00FF0000)
#define  DFE_HDMI_RX_PHY_P2_G1_reg_p2_g_2_mask                                   (0x0000FF00)
#define  DFE_HDMI_RX_PHY_P2_G1_reg_p2_g_1_mask                                   (0x000000FF)
#define  DFE_HDMI_RX_PHY_P2_G1_reg_p2_g_4(data)                                  (0xFF000000&((data)<<24))
#define  DFE_HDMI_RX_PHY_P2_G1_reg_p2_g_3(data)                                  (0x00FF0000&((data)<<16))
#define  DFE_HDMI_RX_PHY_P2_G1_reg_p2_g_2(data)                                  (0x0000FF00&((data)<<8))
#define  DFE_HDMI_RX_PHY_P2_G1_reg_p2_g_1(data)                                  (0x000000FF&(data))
#define  DFE_HDMI_RX_PHY_P2_G1_get_reg_p2_g_4(data)                              ((0xFF000000&(data))>>24)
#define  DFE_HDMI_RX_PHY_P2_G1_get_reg_p2_g_3(data)                              ((0x00FF0000&(data))>>16)
#define  DFE_HDMI_RX_PHY_P2_G1_get_reg_p2_g_2(data)                              ((0x0000FF00&(data))>>8)
#define  DFE_HDMI_RX_PHY_P2_G1_get_reg_p2_g_1(data)                              (0x000000FF&(data))

#define  DFE_HDMI_RX_PHY_P2_G2                                                   0x1800DAD0
#define  DFE_HDMI_RX_PHY_P2_G2_reg_addr                                          "0xB800DAD0"
#define  DFE_HDMI_RX_PHY_P2_G2_reg                                               0xB800DAD0
#define  DFE_HDMI_RX_PHY_P2_G2_inst_addr                                         "0x0034"
#define  set_DFE_HDMI_RX_PHY_P2_G2_reg(data)                                     (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P2_G2_reg)=data)
#define  get_DFE_HDMI_RX_PHY_P2_G2_reg                                           (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P2_G2_reg))
#define  DFE_HDMI_RX_PHY_P2_G2_reg_p2_g_8_shift                                  (24)
#define  DFE_HDMI_RX_PHY_P2_G2_reg_p2_g_7_shift                                  (16)
#define  DFE_HDMI_RX_PHY_P2_G2_reg_p2_g_6_shift                                  (8)
#define  DFE_HDMI_RX_PHY_P2_G2_reg_p2_g_5_shift                                  (0)
#define  DFE_HDMI_RX_PHY_P2_G2_reg_p2_g_8_mask                                   (0xFF000000)
#define  DFE_HDMI_RX_PHY_P2_G2_reg_p2_g_7_mask                                   (0x00FF0000)
#define  DFE_HDMI_RX_PHY_P2_G2_reg_p2_g_6_mask                                   (0x0000FF00)
#define  DFE_HDMI_RX_PHY_P2_G2_reg_p2_g_5_mask                                   (0x000000FF)
#define  DFE_HDMI_RX_PHY_P2_G2_reg_p2_g_8(data)                                  (0xFF000000&((data)<<24))
#define  DFE_HDMI_RX_PHY_P2_G2_reg_p2_g_7(data)                                  (0x00FF0000&((data)<<16))
#define  DFE_HDMI_RX_PHY_P2_G2_reg_p2_g_6(data)                                  (0x0000FF00&((data)<<8))
#define  DFE_HDMI_RX_PHY_P2_G2_reg_p2_g_5(data)                                  (0x000000FF&(data))
#define  DFE_HDMI_RX_PHY_P2_G2_get_reg_p2_g_8(data)                              ((0xFF000000&(data))>>24)
#define  DFE_HDMI_RX_PHY_P2_G2_get_reg_p2_g_7(data)                              ((0x00FF0000&(data))>>16)
#define  DFE_HDMI_RX_PHY_P2_G2_get_reg_p2_g_6(data)                              ((0x0000FF00&(data))>>8)
#define  DFE_HDMI_RX_PHY_P2_G2_get_reg_p2_g_5(data)                              (0x000000FF&(data))
#define  DFE_HDMI_RX_PHY_P2_G2_reg_p2_g_8_PR_RATE_SEL_shift             (26)
#define  DFE_HDMI_RX_PHY_P2_G2_reg_p2_g_8_DEMUX_shift             (29)
#define  DFE_HDMI_RX_PHY_P2_G2_reg_p2_g_7_TAP0_ISEL_shift                 (21)
#define  P2_g_8_DEMUX                                                                                             (_BIT29|_BIT30|_BIT31)
#define  P2_g_8_PR_RATE_SEL                                                                                    (_BIT26|_BIT27|_BIT28)
#define  P2_g_8_POW_PR                                                                                            _BIT25
#define  P2_g_7_TAP0_ISEL                                                                                         (_BIT21|_BIT22|_BIT23)
#define  P2_g_7_TAP0_ISEL_400uA                                                                              (_BIT22|_BIT23)
#define  P2_g_7_LEQ_ISEL                                                                                           (_BIT18|_BIT19|_BIT20)
#define  P2_g_7_LEQ_ISEL_400uA                                                                                (_BIT19|_BIT20)
#define  P2_g_7_PI_ISEL                                                                                              (_BIT16|_BIT17)
#define  P2_g_6_LEQ_BIT_RATE                                                                                    (_BIT14|_BIT15)
#define  P2_g_6_LEQ_BIT_RATE_HBR                                                                            (_BIT15)
#define  P2_g_6_LEQ_BIT_RATE_MBR                                                                            (_BIT14)
#define  P2_g_6_TAP0_HBR                                                                              	        (_BIT13)
#define  P2_g_6_LEQ_PASSIVE_CORNER                                                                      (_BIT12|_BIT11)
#define  P2_g_5_EQ_POW                                                                                             _BIT0


#define  DFE_HDMI_RX_PHY_P2_G3                                                   0x1800DAD4
#define  DFE_HDMI_RX_PHY_P2_G3_reg_addr                                          "0xB800DAD4"
#define  DFE_HDMI_RX_PHY_P2_G3_reg                                               0xB800DAD4
#define  DFE_HDMI_RX_PHY_P2_G3_inst_addr                                         "0x0035"
#define  set_DFE_HDMI_RX_PHY_P2_G3_reg(data)                                     (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P2_G3_reg)=data)
#define  get_DFE_HDMI_RX_PHY_P2_G3_reg                                           (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P2_G3_reg))
#define  DFE_HDMI_RX_PHY_P2_G3_reg_p2_g_12_shift                                 (24)
#define  DFE_HDMI_RX_PHY_P2_G3_reg_p2_g_11_shift                                 (16)
#define  DFE_HDMI_RX_PHY_P2_G3_reg_p2_g_10_shift                                 (8)
#define  DFE_HDMI_RX_PHY_P2_G3_reg_p2_g_9_shift                                  (0)
#define  DFE_HDMI_RX_PHY_P2_G3_reg_p2_g_12_mask                                  (0xFF000000)
#define  DFE_HDMI_RX_PHY_P2_G3_reg_p2_g_11_mask                                  (0x00FF0000)
#define  DFE_HDMI_RX_PHY_P2_G3_reg_p2_g_10_mask                                  (0x0000FF00)
#define  DFE_HDMI_RX_PHY_P2_G3_reg_p2_g_9_mask                                   (0x000000FF)
#define  DFE_HDMI_RX_PHY_P2_G3_reg_p2_g_12(data)                                 (0xFF000000&((data)<<24))
#define  DFE_HDMI_RX_PHY_P2_G3_reg_p2_g_11(data)                                 (0x00FF0000&((data)<<16))
#define  DFE_HDMI_RX_PHY_P2_G3_reg_p2_g_10(data)                                 (0x0000FF00&((data)<<8))
#define  DFE_HDMI_RX_PHY_P2_G3_reg_p2_g_9(data)                                  (0x000000FF&(data))
#define  DFE_HDMI_RX_PHY_P2_G3_get_reg_p2_g_12(data)                             ((0xFF000000&(data))>>24)
#define  DFE_HDMI_RX_PHY_P2_G3_get_reg_p2_g_11(data)                             ((0x00FF0000&(data))>>16)
#define  DFE_HDMI_RX_PHY_P2_G3_get_reg_p2_g_10(data)                             ((0x0000FF00&(data))>>8)
#define  DFE_HDMI_RX_PHY_P2_G3_get_reg_p2_g_9(data)                              (0x000000FF&(data))
#define P2_G_DFE_TAPEN4321                                                                              (_BIT6|_BIT5|_BIT4|_BIT3)
#define P2_g_12_PR 														 (_BIT24|_BIT25)
#define P2_g_9_DFE_ADAPTION_POW_EN 								              (_BIT7)
#define P2_g_9_DFE_TAP_EN 								                           (_BIT3|_BIT4|_BIT5|_BIT6)
#define P2_g_9_DFE_TAP1_EN 								                           (_BIT3)
#define  DFE_HDMI_RX_PHY_P2_g_tap_en(data)                                                           (0x00000078&((data)<<3))


#define  DFE_HDMI_RX_PHY_P2_G4                                                   0x1800DAD8
#define  DFE_HDMI_RX_PHY_P2_G4_reg_addr                                          "0xB800DAD8"
#define  DFE_HDMI_RX_PHY_P2_G4_reg                                               0xB800DAD8
#define  DFE_HDMI_RX_PHY_P2_G4_inst_addr                                         "0x0036"
#define  set_DFE_HDMI_RX_PHY_P2_G4_reg(data)                                     (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P2_G4_reg)=data)
#define  get_DFE_HDMI_RX_PHY_P2_G4_reg                                           (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P2_G4_reg))
#define  DFE_HDMI_RX_PHY_P2_G4_reg_p2_g_koff_sel_shift                           (10)
#define  DFE_HDMI_RX_PHY_P2_G4_reg_p2_g_koff_bound_shift                         (9)
#define  DFE_HDMI_RX_PHY_P2_G4_reg_p2_g_koffok_shift                             (8)
#define  DFE_HDMI_RX_PHY_P2_G4_reg_p2_g_13_shift                                 (0)
#define  DFE_HDMI_RX_PHY_P2_G4_reg_p2_g_koff_sel_mask                            (0x00007C00)
#define  DFE_HDMI_RX_PHY_P2_G4_reg_p2_g_koff_bound_mask                          (0x00000200)
#define  DFE_HDMI_RX_PHY_P2_G4_reg_p2_g_koffok_mask                              (0x00000100)
#define  DFE_HDMI_RX_PHY_P2_G4_reg_p2_g_13_mask                                  (0x000000FF)
#define  DFE_HDMI_RX_PHY_P2_G4_reg_p2_g_koff_sel(data)                           (0x00007C00&((data)<<10))
#define  DFE_HDMI_RX_PHY_P2_G4_reg_p2_g_koff_bound(data)                         (0x00000200&((data)<<9))
#define  DFE_HDMI_RX_PHY_P2_G4_reg_p2_g_koffok(data)                             (0x00000100&((data)<<8))
#define  DFE_HDMI_RX_PHY_P2_G4_reg_p2_g_13(data)                                 (0x000000FF&(data))
#define  DFE_HDMI_RX_PHY_P2_G4_get_reg_p2_g_koff_sel(data)                       ((0x00007C00&(data))>>10)
#define  DFE_HDMI_RX_PHY_P2_G4_get_reg_p2_g_koff_bound(data)                     ((0x00000200&(data))>>9)
#define  DFE_HDMI_RX_PHY_P2_G4_get_reg_p2_g_koffok(data)                         ((0x00000100&(data))>>8)
#define  DFE_HDMI_RX_PHY_P2_G4_get_reg_p2_g_13(data)                             (0x000000FF&(data))

#define  DFE_HDMI_RX_PHY_P2_R1                                                   0x1800DADC
#define  DFE_HDMI_RX_PHY_P2_R1_reg_addr                                          "0xB800DADC"
#define  DFE_HDMI_RX_PHY_P2_R1_reg                                               0xB800DADC
#define  DFE_HDMI_RX_PHY_P2_R1_inst_addr                                         "0x0037"
#define  set_DFE_HDMI_RX_PHY_P2_R1_reg(data)                                     (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P2_R1_reg)=data)
#define  get_DFE_HDMI_RX_PHY_P2_R1_reg                                           (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P2_R1_reg))
#define  DFE_HDMI_RX_PHY_P2_R1_reg_p2_r_4_shift                                  (24)
#define  DFE_HDMI_RX_PHY_P2_R1_reg_p2_r_3_shift                                  (16)
#define  DFE_HDMI_RX_PHY_P2_R1_reg_p2_r_2_shift                                  (8)
#define  DFE_HDMI_RX_PHY_P2_R1_reg_p2_r_1_shift                                  (0)
#define  DFE_HDMI_RX_PHY_P2_R1_reg_p2_r_4_mask                                   (0xFF000000)
#define  DFE_HDMI_RX_PHY_P2_R1_reg_p2_r_3_mask                                   (0x00FF0000)
#define  DFE_HDMI_RX_PHY_P2_R1_reg_p2_r_2_mask                                   (0x0000FF00)
#define  DFE_HDMI_RX_PHY_P2_R1_reg_p2_r_1_mask                                   (0x000000FF)
#define  DFE_HDMI_RX_PHY_P2_R1_reg_p2_r_4(data)                                  (0xFF000000&((data)<<24))
#define  DFE_HDMI_RX_PHY_P2_R1_reg_p2_r_3(data)                                  (0x00FF0000&((data)<<16))
#define  DFE_HDMI_RX_PHY_P2_R1_reg_p2_r_2(data)                                  (0x0000FF00&((data)<<8))
#define  DFE_HDMI_RX_PHY_P2_R1_reg_p2_r_1(data)                                  (0x000000FF&(data))
#define  DFE_HDMI_RX_PHY_P2_R1_get_reg_p2_r_4(data)                              ((0xFF000000&(data))>>24)
#define  DFE_HDMI_RX_PHY_P2_R1_get_reg_p2_r_3(data)                              ((0x00FF0000&(data))>>16)
#define  DFE_HDMI_RX_PHY_P2_R1_get_reg_p2_r_2(data)                              ((0x0000FF00&(data))>>8)
#define  DFE_HDMI_RX_PHY_P2_R1_get_reg_p2_r_1(data)                              (0x000000FF&(data))

#define  DFE_HDMI_RX_PHY_P2_R2                                                   0x1800DAE0
#define  DFE_HDMI_RX_PHY_P2_R2_reg_addr                                          "0xB800DAE0"
#define  DFE_HDMI_RX_PHY_P2_R2_reg                                               0xB800DAE0
#define  DFE_HDMI_RX_PHY_P2_R2_inst_addr                                         "0x0038"
#define  set_DFE_HDMI_RX_PHY_P2_R2_reg(data)                                     (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P2_R2_reg)=data)
#define  get_DFE_HDMI_RX_PHY_P2_R2_reg                                           (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P2_R2_reg))
#define  DFE_HDMI_RX_PHY_P2_R2_reg_p2_r_8_shift                                  (24)
#define  DFE_HDMI_RX_PHY_P2_R2_reg_p2_r_7_shift                                  (16)
#define  DFE_HDMI_RX_PHY_P2_R2_reg_p2_r_6_shift                                  (8)
#define  DFE_HDMI_RX_PHY_P2_R2_reg_p2_r_5_shift                                  (0)
#define  DFE_HDMI_RX_PHY_P2_R2_reg_p2_r_8_mask                                   (0xFF000000)
#define  DFE_HDMI_RX_PHY_P2_R2_reg_p2_r_7_mask                                   (0x00FF0000)
#define  DFE_HDMI_RX_PHY_P2_R2_reg_p2_r_6_mask                                   (0x0000FF00)
#define  DFE_HDMI_RX_PHY_P2_R2_reg_p2_r_5_mask                                   (0x000000FF)
#define  DFE_HDMI_RX_PHY_P2_R2_reg_p2_r_8(data)                                  (0xFF000000&((data)<<24))
#define  DFE_HDMI_RX_PHY_P2_R2_reg_p2_r_7(data)                                  (0x00FF0000&((data)<<16))
#define  DFE_HDMI_RX_PHY_P2_R2_reg_p2_r_6(data)                                  (0x0000FF00&((data)<<8))
#define  DFE_HDMI_RX_PHY_P2_R2_reg_p2_r_5(data)                                  (0x000000FF&(data))
#define  DFE_HDMI_RX_PHY_P2_R2_get_reg_p2_r_8(data)                              ((0xFF000000&(data))>>24)
#define  DFE_HDMI_RX_PHY_P2_R2_get_reg_p2_r_7(data)                              ((0x00FF0000&(data))>>16)
#define  DFE_HDMI_RX_PHY_P2_R2_get_reg_p2_r_6(data)                              ((0x0000FF00&(data))>>8)
#define  DFE_HDMI_RX_PHY_P2_R2_get_reg_p2_r_5(data)                              (0x000000FF&(data))
#define  DFE_HDMI_RX_PHY_P2_R2_reg_p2_r_8_PR_RATE_SEL_shift             (26)
#define  DFE_HDMI_RX_PHY_P2_R2_reg_p2_r_8_DEMUX_shift             (29)
#define  DFE_HDMI_RX_PHY_P2_R2_reg_p2_r_7_TAP0_ISEL_shift                 (21)
#define  P2_r_8_DEMUX                                                                                             (_BIT29|_BIT30|_BIT31)
#define  P2_r_8_PR_RATE_SEL                                                                                    (_BIT26|_BIT27|_BIT28)
#define  P2_r_8_POW_PR                                                                                            _BIT25
#define  P2_r_7_TAP0_ISEL                                                                                         (_BIT21|_BIT22|_BIT23)
#define  P2_r_7_TAP0_ISEL_400uA                                                                              (_BIT22|_BIT23)
#define  P2_r_7_LEQ_ISEL                                                                                           (_BIT18|_BIT19|_BIT20)
#define  P2_r_7_LEQ_ISEL_400uA                                                                                (_BIT19|_BIT20)
#define  P2_r_7_PI_ISEL                                                                                              (_BIT16|_BIT17)
#define  P2_r_6_LEQ_BIT_RATE                                                                                    (_BIT14|_BIT15)
#define  P2_r_6_LEQ_BIT_RATE_HBR                                                                            (_BIT15)
#define  P2_r_6_LEQ_BIT_RATE_MBR                                                                            (_BIT14)
#define  P2_r_6_TAP0_HBR                                                                              	        (_BIT13)
#define  P2_r_6_LEQ_PASSIVE_CORNER                                                                      (_BIT12|_BIT11)
#define  P2_r_5_EQ_POW                                                                                             _BIT0



#define  DFE_HDMI_RX_PHY_P2_R3                                                   0x1800DAE4
#define  DFE_HDMI_RX_PHY_P2_R3_reg_addr                                          "0xB800DAE4"
#define  DFE_HDMI_RX_PHY_P2_R3_reg                                               0xB800DAE4
#define  DFE_HDMI_RX_PHY_P2_R3_inst_addr                                         "0x0039"
#define  set_DFE_HDMI_RX_PHY_P2_R3_reg(data)                                     (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P2_R3_reg)=data)
#define  get_DFE_HDMI_RX_PHY_P2_R3_reg                                           (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P2_R3_reg))
#define  DFE_HDMI_RX_PHY_P2_R3_reg_p2_r_12_shift                                 (24)
#define  DFE_HDMI_RX_PHY_P2_R3_reg_p2_r_11_shift                                 (16)
#define  DFE_HDMI_RX_PHY_P2_R3_reg_p2_r_10_shift                                 (8)
#define  DFE_HDMI_RX_PHY_P2_R3_reg_p2_r_9_shift                                  (0)
#define  DFE_HDMI_RX_PHY_P2_R3_reg_p2_r_12_mask                                  (0xFF000000)
#define  DFE_HDMI_RX_PHY_P2_R3_reg_p2_r_11_mask                                  (0x00FF0000)
#define  DFE_HDMI_RX_PHY_P2_R3_reg_p2_r_10_mask                                  (0x0000FF00)
#define  DFE_HDMI_RX_PHY_P2_R3_reg_p2_r_9_mask                                   (0x000000FF)
#define  DFE_HDMI_RX_PHY_P2_R3_reg_p2_r_12(data)                                 (0xFF000000&((data)<<24))
#define  DFE_HDMI_RX_PHY_P2_R3_reg_p2_r_11(data)                                 (0x00FF0000&((data)<<16))
#define  DFE_HDMI_RX_PHY_P2_R3_reg_p2_r_10(data)                                 (0x0000FF00&((data)<<8))
#define  DFE_HDMI_RX_PHY_P2_R3_reg_p2_r_9(data)                                  (0x000000FF&(data))
#define  DFE_HDMI_RX_PHY_P2_R3_get_reg_p2_r_12(data)                             ((0xFF000000&(data))>>24)
#define  DFE_HDMI_RX_PHY_P2_R3_get_reg_p2_r_11(data)                             ((0x00FF0000&(data))>>16)
#define  DFE_HDMI_RX_PHY_P2_R3_get_reg_p2_r_10(data)                             ((0x0000FF00&(data))>>8)
#define  DFE_HDMI_RX_PHY_P2_R3_get_reg_p2_r_9(data)                              (0x000000FF&(data))
#define P2_R_DFE_TAPEN4321                                                                              (_BIT6|_BIT5|_BIT4|_BIT3)
#define P2_r_12_PR 														 (_BIT24|_BIT25)
#define P2_r_9_DFE_ADAPTION_POW_EN 								              (_BIT7)
#define P2_r_9_DFE_TAP_EN 								                           (_BIT3|_BIT4|_BIT5|_BIT6)
#define P2_r_9_DFE_TAP1_EN 								                           (_BIT3)
#define  DFE_HDMI_RX_PHY_P2_r_tap_en(data)                                                           (0x00000078&((data)<<3))


#define  DFE_HDMI_RX_PHY_P2_R4                                                   0x1800DAE8
#define  DFE_HDMI_RX_PHY_P2_R4_reg_addr                                          "0xB800DAE8"
#define  DFE_HDMI_RX_PHY_P2_R4_reg                                               0xB800DAE8
#define  DFE_HDMI_RX_PHY_P2_R4_inst_addr                                         "0x003A"
#define  set_DFE_HDMI_RX_PHY_P2_R4_reg(data)                                     (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P2_R4_reg)=data)
#define  get_DFE_HDMI_RX_PHY_P2_R4_reg                                           (*((volatile unsigned int*)DFE_HDMI_RX_PHY_P2_R4_reg))
#define  DFE_HDMI_RX_PHY_P2_R4_reg_p2_r_koff_sel_shift                           (10)
#define  DFE_HDMI_RX_PHY_P2_R4_reg_p2_r_koff_bound_shift                         (9)
#define  DFE_HDMI_RX_PHY_P2_R4_reg_p2_r_koffok_shift                             (8)
#define  DFE_HDMI_RX_PHY_P2_R4_reg_p2_r_13_shift                                 (0)
#define  DFE_HDMI_RX_PHY_P2_R4_reg_p2_r_koff_sel_mask                            (0x00007C00)
#define  DFE_HDMI_RX_PHY_P2_R4_reg_p2_r_koff_bound_mask                          (0x00000200)
#define  DFE_HDMI_RX_PHY_P2_R4_reg_p2_r_koffok_mask                              (0x00000100)
#define  DFE_HDMI_RX_PHY_P2_R4_reg_p2_r_13_mask                                  (0x000000FF)
#define  DFE_HDMI_RX_PHY_P2_R4_reg_p2_r_koff_sel(data)                           (0x00007C00&((data)<<10))
#define  DFE_HDMI_RX_PHY_P2_R4_reg_p2_r_koff_bound(data)                         (0x00000200&((data)<<9))
#define  DFE_HDMI_RX_PHY_P2_R4_reg_p2_r_koffok(data)                             (0x00000100&((data)<<8))
#define  DFE_HDMI_RX_PHY_P2_R4_reg_p2_r_13(data)                                 (0x000000FF&(data))
#define  DFE_HDMI_RX_PHY_P2_R4_get_reg_p2_r_koff_sel(data)                       ((0x00007C00&(data))>>10)
#define  DFE_HDMI_RX_PHY_P2_R4_get_reg_p2_r_koff_bound(data)                     ((0x00000200&(data))>>9)
#define  DFE_HDMI_RX_PHY_P2_R4_get_reg_p2_r_koffok(data)                         ((0x00000100&(data))>>8)
#define  DFE_HDMI_RX_PHY_P2_R4_get_reg_p2_r_13(data)                             (0x000000FF&(data))

#define  DFE_HDMI_RX_PHY_TEST                                                    0x1800DAEC
#define  DFE_HDMI_RX_PHY_TEST_reg_addr                                           "0xB800DAEC"
#define  DFE_HDMI_RX_PHY_TEST_reg                                                0xB800DAEC
#define  DFE_HDMI_RX_PHY_TEST_inst_addr                                          "0x003B"
#define  set_DFE_HDMI_RX_PHY_TEST_reg(data)                                      (*((volatile unsigned int*)DFE_HDMI_RX_PHY_TEST_reg)=data)
#define  get_DFE_HDMI_RX_PHY_TEST_reg                                            (*((volatile unsigned int*)DFE_HDMI_RX_PHY_TEST_reg))
#define  DFE_HDMI_RX_PHY_TEST_reg_tst_spad_shift                                 (4)
#define  DFE_HDMI_RX_PHY_TEST_reg_stst_shift                                     (0)
#define  DFE_HDMI_RX_PHY_TEST_reg_tst_spad_mask                                  (0x00000010)
#define  DFE_HDMI_RX_PHY_TEST_reg_stst_mask                                      (0x0000000F)
#define  DFE_HDMI_RX_PHY_TEST_reg_tst_spad(data)                                 (0x00000010&((data)<<4))
#define  DFE_HDMI_RX_PHY_TEST_reg_stst(data)                                     (0x0000000F&(data))
#define  DFE_HDMI_RX_PHY_TEST_get_reg_tst_spad(data)                             ((0x00000010&(data))>>4)
#define  DFE_HDMI_RX_PHY_TEST_get_reg_stst(data)                                 (0x0000000F&(data))

#define  DFE_HDMI_RX_PHY_TOP_IN                                                  0x1800DAF0
#define  DFE_HDMI_RX_PHY_TOP_IN_reg_addr                                         "0xB800DAF0"
#define  DFE_HDMI_RX_PHY_TOP_IN_reg                                              0xB800DAF0
#define  DFE_HDMI_RX_PHY_TOP_IN_inst_addr                                        "0x003C"
#define  set_DFE_HDMI_RX_PHY_TOP_IN_reg(data)                                    (*((volatile unsigned int*)DFE_HDMI_RX_PHY_TOP_IN_reg)=data)
#define  get_DFE_HDMI_RX_PHY_TOP_IN_reg                                          (*((volatile unsigned int*)DFE_HDMI_RX_PHY_TOP_IN_reg))
#define  DFE_HDMI_RX_PHY_TOP_IN_reg_top_in_4_shift                               (24)
#define  DFE_HDMI_RX_PHY_TOP_IN_reg_top_in_3_shift                               (16)
#define  DFE_HDMI_RX_PHY_TOP_IN_reg_top_in_2_shift                               (8)
#define  DFE_HDMI_RX_PHY_TOP_IN_reg_top_in_1_shift                               (0)
#define  DFE_HDMI_RX_PHY_TOP_IN_reg_top_in_4_mask                                (0xFF000000)
#define  DFE_HDMI_RX_PHY_TOP_IN_reg_top_in_3_mask                                (0x00FF0000)
#define  DFE_HDMI_RX_PHY_TOP_IN_reg_top_in_2_mask                                (0x0000FF00)
#define  DFE_HDMI_RX_PHY_TOP_IN_reg_top_in_1_mask                                (0x000000FF)
#define  DFE_HDMI_RX_PHY_TOP_IN_reg_top_in_4(data)                               (0xFF000000&((data)<<24))
#define  DFE_HDMI_RX_PHY_TOP_IN_reg_top_in_3(data)                               (0x00FF0000&((data)<<16))
#define  DFE_HDMI_RX_PHY_TOP_IN_reg_top_in_2(data)                               (0x0000FF00&((data)<<8))
#define  DFE_HDMI_RX_PHY_TOP_IN_reg_top_in_1(data)                               (0x000000FF&(data))
#define  DFE_HDMI_RX_PHY_TOP_IN_get_reg_top_in_4(data)                           ((0xFF000000&(data))>>24)
#define  DFE_HDMI_RX_PHY_TOP_IN_get_reg_top_in_3(data)                           ((0x00FF0000&(data))>>16)
#define  DFE_HDMI_RX_PHY_TOP_IN_get_reg_top_in_2(data)                           ((0x0000FF00&(data))>>8)
#define  DFE_HDMI_RX_PHY_TOP_IN_get_reg_top_in_1(data)                           (0x000000FF&(data))

#define  DFE_HDMI_RX_PHY_TOP_OUT                                                 0x1800DAF4
#define  DFE_HDMI_RX_PHY_TOP_OUT_reg_addr                                        "0xB800DAF4"
#define  DFE_HDMI_RX_PHY_TOP_OUT_reg                                             0xB800DAF4
#define  DFE_HDMI_RX_PHY_TOP_OUT_inst_addr                                       "0x003D"
#define  set_DFE_HDMI_RX_PHY_TOP_OUT_reg(data)                                   (*((volatile unsigned int*)DFE_HDMI_RX_PHY_TOP_OUT_reg)=data)
#define  get_DFE_HDMI_RX_PHY_TOP_OUT_reg                                         (*((volatile unsigned int*)DFE_HDMI_RX_PHY_TOP_OUT_reg))
#define  DFE_HDMI_RX_PHY_TOP_OUT_reg_top_out_4_shift                             (24)
#define  DFE_HDMI_RX_PHY_TOP_OUT_reg_top_out_3_shift                             (16)
#define  DFE_HDMI_RX_PHY_TOP_OUT_reg_top_out_2_shift                             (8)
#define  DFE_HDMI_RX_PHY_TOP_OUT_reg_top_out_1_shift                             (0)
#define  DFE_HDMI_RX_PHY_TOP_OUT_reg_top_out_4_mask                              (0xFF000000)
#define  DFE_HDMI_RX_PHY_TOP_OUT_reg_top_out_3_mask                              (0x00FF0000)
#define  DFE_HDMI_RX_PHY_TOP_OUT_reg_top_out_2_mask                              (0x0000FF00)
#define  DFE_HDMI_RX_PHY_TOP_OUT_reg_top_out_1_mask                              (0x000000FF)
#define  DFE_HDMI_RX_PHY_TOP_OUT_reg_top_out_4(data)                             (0xFF000000&((data)<<24))
#define  DFE_HDMI_RX_PHY_TOP_OUT_reg_top_out_3(data)                             (0x00FF0000&((data)<<16))
#define  DFE_HDMI_RX_PHY_TOP_OUT_reg_top_out_2(data)                             (0x0000FF00&((data)<<8))
#define  DFE_HDMI_RX_PHY_TOP_OUT_reg_top_out_1(data)                             (0x000000FF&(data))
#define  DFE_HDMI_RX_PHY_TOP_OUT_get_reg_top_out_4(data)                         ((0xFF000000&(data))>>24)
#define  DFE_HDMI_RX_PHY_TOP_OUT_get_reg_top_out_3(data)                         ((0x00FF0000&(data))>>16)
#define  DFE_HDMI_RX_PHY_TOP_OUT_get_reg_top_out_2(data)                         ((0x0000FF00&(data))>>8)
#define  DFE_HDMI_RX_PHY_TOP_OUT_get_reg_top_out_1(data)                         (0x000000FF&(data))

#define  DFE_HDMI_RX_PHY_Z0K                                                     0x1800DAF8
#define  DFE_HDMI_RX_PHY_Z0K_reg_addr                                            "0xB800DAF8"
#define  DFE_HDMI_RX_PHY_Z0K_reg                                                 0xB800DAF8
#define  DFE_HDMI_RX_PHY_Z0K_inst_addr                                           "0x003E"
#define  set_DFE_HDMI_RX_PHY_Z0K_reg(data)                                       (*((volatile unsigned int*)DFE_HDMI_RX_PHY_Z0K_reg)=data)
#define  get_DFE_HDMI_RX_PHY_Z0K_reg                                             (*((volatile unsigned int*)DFE_HDMI_RX_PHY_Z0K_reg))
#define  DFE_HDMI_RX_PHY_Z0K_reg_z0_z0pow_shift                                  (28)
#define  DFE_HDMI_RX_PHY_Z0K_reg_z0_stune_shift                                  (27)
#define  DFE_HDMI_RX_PHY_Z0K_reg_z0_res_shift                                    (22)
#define  DFE_HDMI_RX_PHY_Z0K_reg_z0_ok_shift                                     (21)
#define  DFE_HDMI_RX_PHY_Z0K_reg_z0_entst_shift                                  (20)
#define  DFE_HDMI_RX_PHY_Z0K_reg_z0_bound_shift                                  (19)
#define  DFE_HDMI_RX_PHY_Z0K_reg_z0_adjr_2_shift                                 (14)
#define  DFE_HDMI_RX_PHY_Z0K_reg_z0_adjr_1_shift                                 (9)
#define  DFE_HDMI_RX_PHY_Z0K_reg_z0_adjr_0_shift                                 (4)
#define  DFE_HDMI_RX_PHY_Z0K_reg_z0tst_shift                                     (0)
#define  DFE_HDMI_RX_PHY_Z0K_reg_z0_z0pow_mask                                   (0x10000000)
#define  DFE_HDMI_RX_PHY_Z0K_reg_z0_stune_mask                                   (0x08000000)
#define  DFE_HDMI_RX_PHY_Z0K_reg_z0_res_mask                                     (0x07C00000)
#define  DFE_HDMI_RX_PHY_Z0K_reg_z0_ok_mask                                      (0x00200000)
#define  DFE_HDMI_RX_PHY_Z0K_reg_z0_entst_mask                                   (0x00100000)
#define  DFE_HDMI_RX_PHY_Z0K_reg_z0_bound_mask                                   (0x00080000)
#define  DFE_HDMI_RX_PHY_Z0K_reg_z0_adjr_2_mask                                  (0x0007C000)
#define  DFE_HDMI_RX_PHY_Z0K_reg_z0_adjr_1_mask                                  (0x00003E00)
#define  DFE_HDMI_RX_PHY_Z0K_reg_z0_adjr_0_mask                                  (0x000001F0)
#define  DFE_HDMI_RX_PHY_Z0K_reg_z0tst_mask                                      (0x0000000F)
#define  DFE_HDMI_RX_PHY_Z0K_reg_z0_z0pow(data)                                  (0x10000000&((data)<<28))
#define  DFE_HDMI_RX_PHY_Z0K_reg_z0_stune(data)                                  (0x08000000&((data)<<27))
#define  DFE_HDMI_RX_PHY_Z0K_reg_z0_res(data)                                    (0x07C00000&((data)<<22))
#define  DFE_HDMI_RX_PHY_Z0K_reg_z0_ok(data)                                     (0x00200000&((data)<<21))
#define  DFE_HDMI_RX_PHY_Z0K_reg_z0_entst(data)                                  (0x00100000&((data)<<20))
#define  DFE_HDMI_RX_PHY_Z0K_reg_z0_bound(data)                                  (0x00080000&((data)<<19))
#define  DFE_HDMI_RX_PHY_Z0K_reg_z0_adjr_2(data)                                 (0x0007C000&((data)<<14))
#define  DFE_HDMI_RX_PHY_Z0K_reg_z0_adjr_1(data)                                 (0x00003E00&((data)<<9))
#define  DFE_HDMI_RX_PHY_Z0K_reg_z0_adjr_0(data)                                 (0x000001F0&((data)<<4))
#define  DFE_HDMI_RX_PHY_Z0K_reg_z0tst(data)                                     (0x0000000F&(data))
#define  DFE_HDMI_RX_PHY_Z0K_get_reg_z0_z0pow(data)                              ((0x10000000&(data))>>28)
#define  DFE_HDMI_RX_PHY_Z0K_get_reg_z0_stune(data)                              ((0x08000000&(data))>>27)
#define  DFE_HDMI_RX_PHY_Z0K_get_reg_z0_res(data)                                ((0x07C00000&(data))>>22)
#define  DFE_HDMI_RX_PHY_Z0K_get_reg_z0_ok(data)                                 ((0x00200000&(data))>>21)
#define  DFE_HDMI_RX_PHY_Z0K_get_reg_z0_entst(data)                              ((0x00100000&(data))>>20)
#define  DFE_HDMI_RX_PHY_Z0K_get_reg_z0_bound(data)                              ((0x00080000&(data))>>19)
#define  DFE_HDMI_RX_PHY_Z0K_get_reg_z0_adjr_2(data)                             ((0x0007C000&(data))>>14)
#define  DFE_HDMI_RX_PHY_Z0K_get_reg_z0_adjr_1(data)                             ((0x00003E00&(data))>>9)
#define  DFE_HDMI_RX_PHY_Z0K_get_reg_z0_adjr_0(data)                             ((0x000001F0&(data))>>4)
#define  DFE_HDMI_RX_PHY_Z0K_get_reg_z0tst(data)                                 (0x0000000F&(data))

#define  DFE_HDMI_RX_PHY_Z0POW                                                   0x1800DAFC
#define  DFE_HDMI_RX_PHY_Z0POW_reg_addr                                          "0xB800DAFC"
#define  DFE_HDMI_RX_PHY_Z0POW_reg                                               0xB800DAFC
#define  DFE_HDMI_RX_PHY_Z0POW_inst_addr                                         "0x003F"
#define  set_DFE_HDMI_RX_PHY_Z0POW_reg(data)                                     (*((volatile unsigned int*)DFE_HDMI_RX_PHY_Z0POW_reg)=data)
#define  get_DFE_HDMI_RX_PHY_Z0POW_reg                                           (*((volatile unsigned int*)DFE_HDMI_RX_PHY_Z0POW_reg))
#define  DFE_HDMI_RX_PHY_Z0POW_reg_z0_z300_sel_shift                             (18)
#define  DFE_HDMI_RX_PHY_Z0POW_reg_z0_z300pow_shift                              (15)
#define  DFE_HDMI_RX_PHY_Z0POW_reg_z0_z100_en_shift                              (12)
#define  DFE_HDMI_RX_PHY_Z0POW_reg_z0_z0pow_r_shift                              (9)
#define  DFE_HDMI_RX_PHY_Z0POW_reg_z0_z0pow_g_shift                              (6)
#define  DFE_HDMI_RX_PHY_Z0POW_reg_z0_z0pow_ck_shift                             (3)
#define  DFE_HDMI_RX_PHY_Z0POW_reg_z0_z0pow_b_shift                              (0)
#define  DFE_HDMI_RX_PHY_Z0POW_reg_z0_z300_sel_mask                              (0x001C0000)
#define  DFE_HDMI_RX_PHY_Z0POW_reg_z0_z300pow_mask                               (0x00038000)
#define  DFE_HDMI_RX_PHY_Z0POW_reg_z0_z100_en_mask                               (0x00007000)
#define  DFE_HDMI_RX_PHY_Z0POW_reg_z0_z0pow_r_mask                               (0x00000E00)
#define  DFE_HDMI_RX_PHY_Z0POW_reg_z0_z0pow_g_mask                               (0x000001C0)
#define  DFE_HDMI_RX_PHY_Z0POW_reg_z0_z0pow_ck_mask                              (0x00000038)
#define  DFE_HDMI_RX_PHY_Z0POW_reg_z0_z0pow_b_mask                               (0x00000007)
#define  DFE_HDMI_RX_PHY_Z0POW_reg_z0_z300_sel(data)                             (0x001C0000&((data)<<18))
#define  DFE_HDMI_RX_PHY_Z0POW_reg_z0_z300pow(data)                              (0x00038000&((data)<<15))
#define  DFE_HDMI_RX_PHY_Z0POW_reg_z0_z100_en(data)                              (0x00007000&((data)<<12))
#define  DFE_HDMI_RX_PHY_Z0POW_reg_z0_z0pow_r(data)                              (0x00000E00&((data)<<9))
#define  DFE_HDMI_RX_PHY_Z0POW_reg_z0_z0pow_g(data)                              (0x000001C0&((data)<<6))
#define  DFE_HDMI_RX_PHY_Z0POW_reg_z0_z0pow_ck(data)                             (0x00000038&((data)<<3))
#define  DFE_HDMI_RX_PHY_Z0POW_reg_z0_z0pow_b(data)                              (0x00000007&(data))
#define  DFE_HDMI_RX_PHY_Z0POW_get_reg_z0_z300_sel(data)                         ((0x001C0000&(data))>>18)
#define  DFE_HDMI_RX_PHY_Z0POW_get_reg_z0_z300pow(data)                          ((0x00038000&(data))>>15)
#define  DFE_HDMI_RX_PHY_Z0POW_get_reg_z0_z100_en(data)                          ((0x00007000&(data))>>12)
#define  DFE_HDMI_RX_PHY_Z0POW_get_reg_z0_z0pow_r(data)                          ((0x00000E00&(data))>>9)
#define  DFE_HDMI_RX_PHY_Z0POW_get_reg_z0_z0pow_g(data)                          ((0x000001C0&(data))>>6)
#define  DFE_HDMI_RX_PHY_Z0POW_get_reg_z0_z0pow_ck(data)                         ((0x00000038&(data))>>3)
#define  DFE_HDMI_RX_PHY_Z0POW_get_reg_z0_z0pow_b(data)                          (0x00000007&(data))

#define  DFE_HDMI_RX_PHY_BYPASS                                                  0x1800DB00
#define  DFE_HDMI_RX_PHY_BYPASS_reg_addr                                         "0xB800DB00"
#define  DFE_HDMI_RX_PHY_BYPASS_reg                                              0xB800DB00
#define  DFE_HDMI_RX_PHY_BYPASS_inst_addr                                        "0x0040"
#define  set_DFE_HDMI_RX_PHY_BYPASS_reg(data)                                    (*((volatile unsigned int*)DFE_HDMI_RX_PHY_BYPASS_reg)=data)
#define  get_DFE_HDMI_RX_PHY_BYPASS_reg                                          (*((volatile unsigned int*)DFE_HDMI_RX_PHY_BYPASS_reg))
#define  DFE_HDMI_RX_PHY_BYPASS_p2_bypass_ok_shift                               (2)
#define  DFE_HDMI_RX_PHY_BYPASS_p1_bypass_ok_shift                               (1)
#define  DFE_HDMI_RX_PHY_BYPASS_p0_bypass_ok_shift                               (0)
#define  DFE_HDMI_RX_PHY_BYPASS_p2_bypass_ok_mask                                (0x00000004)
#define  DFE_HDMI_RX_PHY_BYPASS_p1_bypass_ok_mask                                (0x00000002)
#define  DFE_HDMI_RX_PHY_BYPASS_p0_bypass_ok_mask                                (0x00000001)
#define  DFE_HDMI_RX_PHY_BYPASS_p2_bypass_ok(data)                               (0x00000004&((data)<<2))
#define  DFE_HDMI_RX_PHY_BYPASS_p1_bypass_ok(data)                               (0x00000002&((data)<<1))
#define  DFE_HDMI_RX_PHY_BYPASS_p0_bypass_ok(data)                               (0x00000001&(data))
#define  DFE_HDMI_RX_PHY_BYPASS_get_p2_bypass_ok(data)                           ((0x00000004&(data))>>2)
#define  DFE_HDMI_RX_PHY_BYPASS_get_p1_bypass_ok(data)                           ((0x00000002&(data))>>1)
#define  DFE_HDMI_RX_PHY_BYPASS_get_p0_bypass_ok(data)                           (0x00000001&(data))

#define  DFE_HDMI_RX_PHY_RST                                                     0x1800DB04
#define  DFE_HDMI_RX_PHY_RST_reg_addr                                            "0xB800DB04"
#define  DFE_HDMI_RX_PHY_RST_reg                                                 0xB800DB04
#define  DFE_HDMI_RX_PHY_RST_inst_addr                                           "0x0041"
#define  set_DFE_HDMI_RX_PHY_RST_reg(data)                                       (*((volatile unsigned int*)DFE_HDMI_RX_PHY_RST_reg)=data)
#define  get_DFE_HDMI_RX_PHY_RST_reg                                             (*((volatile unsigned int*)DFE_HDMI_RX_PHY_RST_reg))
#define  DFE_HDMI_RX_PHY_RST_dfe_rstn_n_shift                                    (18)
#define  DFE_HDMI_RX_PHY_RST_reg_p2_acdr_rstb_fsm_shift                          (17)
#define  DFE_HDMI_RX_PHY_RST_reg_p1_acdr_rstb_fsm_shift                          (16)
#define  DFE_HDMI_RX_PHY_RST_reg_p0_acdr_rstb_fsm_shift                          (15)
#define  DFE_HDMI_RX_PHY_RST_p2_ck_vcorstb_shift                                 (14)
#define  DFE_HDMI_RX_PHY_RST_p1_ck_vcorstb_shift                                 (13)
#define  DFE_HDMI_RX_PHY_RST_p0_ck_vcorstb_shift                                 (12)
#define  DFE_HDMI_RX_PHY_RST_p2_ck_pllrstb_shift                                 (11)
#define  DFE_HDMI_RX_PHY_RST_p1_ck_pllrstb_shift                                 (10)
#define  DFE_HDMI_RX_PHY_RST_p0_ck_pllrstb_shift                                 (9)
#define  DFE_HDMI_RX_PHY_RST_p2_r_demux_rstb_shift                               (8)
#define  DFE_HDMI_RX_PHY_RST_p2_g_demux_rstb_shift                               (7)
#define  DFE_HDMI_RX_PHY_RST_p2_b_demux_rstb_shift                               (6)
#define  DFE_HDMI_RX_PHY_RST_p1_r_demux_rstb_shift                               (5)
#define  DFE_HDMI_RX_PHY_RST_p1_g_demux_rstb_shift                               (4)
#define  DFE_HDMI_RX_PHY_RST_p1_b_demux_rstb_shift                               (3)
#define  DFE_HDMI_RX_PHY_RST_p0_r_demux_rstb_shift                               (2)
#define  DFE_HDMI_RX_PHY_RST_p0_g_demux_rstb_shift                               (1)
#define  DFE_HDMI_RX_PHY_RST_p0_b_demux_rstb_shift                               (0)
#define  DFE_HDMI_RX_PHY_RST_dfe_rstn_n_mask                                     (0x00040000)
#define  DFE_HDMI_RX_PHY_RST_reg_p2_acdr_rstb_fsm_mask                           (0x00020000)
#define  DFE_HDMI_RX_PHY_RST_reg_p1_acdr_rstb_fsm_mask                           (0x00010000)
#define  DFE_HDMI_RX_PHY_RST_reg_p0_acdr_rstb_fsm_mask                           (0x00008000)
#define  DFE_HDMI_RX_PHY_RST_p2_ck_vcorstb_mask                                  (0x00004000)
#define  DFE_HDMI_RX_PHY_RST_p1_ck_vcorstb_mask                                  (0x00002000)
#define  DFE_HDMI_RX_PHY_RST_p0_ck_vcorstb_mask                                  (0x00001000)
#define  DFE_HDMI_RX_PHY_RST_p2_ck_pllrstb_mask                                  (0x00000800)
#define  DFE_HDMI_RX_PHY_RST_p1_ck_pllrstb_mask                                  (0x00000400)
#define  DFE_HDMI_RX_PHY_RST_p0_ck_pllrstb_mask                                  (0x00000200)
#define  DFE_HDMI_RX_PHY_RST_p2_r_demux_rstb_mask                                (0x00000100)
#define  DFE_HDMI_RX_PHY_RST_p2_g_demux_rstb_mask                                (0x00000080)
#define  DFE_HDMI_RX_PHY_RST_p2_b_demux_rstb_mask                                (0x00000040)
#define  DFE_HDMI_RX_PHY_RST_p1_r_demux_rstb_mask                                (0x00000020)
#define  DFE_HDMI_RX_PHY_RST_p1_g_demux_rstb_mask                                (0x00000010)
#define  DFE_HDMI_RX_PHY_RST_p1_b_demux_rstb_mask                                (0x00000008)
#define  DFE_HDMI_RX_PHY_RST_p0_r_demux_rstb_mask                                (0x00000004)
#define  DFE_HDMI_RX_PHY_RST_p0_g_demux_rstb_mask                                (0x00000002)
#define  DFE_HDMI_RX_PHY_RST_p0_b_demux_rstb_mask                                (0x00000001)
#define  DFE_HDMI_RX_PHY_RST_dfe_rstn_n(data)                                    (0x00040000&((data)<<18))
#define  DFE_HDMI_RX_PHY_RST_reg_p2_acdr_rstb_fsm(data)                          (0x00020000&((data)<<17))
#define  DFE_HDMI_RX_PHY_RST_reg_p1_acdr_rstb_fsm(data)                          (0x00010000&((data)<<16))
#define  DFE_HDMI_RX_PHY_RST_reg_p0_acdr_rstb_fsm(data)                          (0x00008000&((data)<<15))
#define  DFE_HDMI_RX_PHY_RST_p2_ck_vcorstb(data)                                 (0x00004000&((data)<<14))
#define  DFE_HDMI_RX_PHY_RST_p1_ck_vcorstb(data)                                 (0x00002000&((data)<<13))
#define  DFE_HDMI_RX_PHY_RST_p0_ck_vcorstb(data)                                 (0x00001000&((data)<<12))
#define  DFE_HDMI_RX_PHY_RST_p2_ck_pllrstb(data)                                 (0x00000800&((data)<<11))
#define  DFE_HDMI_RX_PHY_RST_p1_ck_pllrstb(data)                                 (0x00000400&((data)<<10))
#define  DFE_HDMI_RX_PHY_RST_p0_ck_pllrstb(data)                                 (0x00000200&((data)<<9))
#define  DFE_HDMI_RX_PHY_RST_p2_r_demux_rstb(data)                               (0x00000100&((data)<<8))
#define  DFE_HDMI_RX_PHY_RST_p2_g_demux_rstb(data)                               (0x00000080&((data)<<7))
#define  DFE_HDMI_RX_PHY_RST_p2_b_demux_rstb(data)                               (0x00000040&((data)<<6))
#define  DFE_HDMI_RX_PHY_RST_p1_r_demux_rstb(data)                               (0x00000020&((data)<<5))
#define  DFE_HDMI_RX_PHY_RST_p1_g_demux_rstb(data)                               (0x00000010&((data)<<4))
#define  DFE_HDMI_RX_PHY_RST_p1_b_demux_rstb(data)                               (0x00000008&((data)<<3))
#define  DFE_HDMI_RX_PHY_RST_p0_r_demux_rstb(data)                               (0x00000004&((data)<<2))
#define  DFE_HDMI_RX_PHY_RST_p0_g_demux_rstb(data)                               (0x00000002&((data)<<1))
#define  DFE_HDMI_RX_PHY_RST_p0_b_demux_rstb(data)                               (0x00000001&(data))
#define  DFE_HDMI_RX_PHY_RST_get_dfe_rstn_n(data)                                ((0x00040000&(data))>>18)
#define  DFE_HDMI_RX_PHY_RST_get_reg_p2_acdr_rstb_fsm(data)                      ((0x00020000&(data))>>17)
#define  DFE_HDMI_RX_PHY_RST_get_reg_p1_acdr_rstb_fsm(data)                      ((0x00010000&(data))>>16)
#define  DFE_HDMI_RX_PHY_RST_get_reg_p0_acdr_rstb_fsm(data)                      ((0x00008000&(data))>>15)
#define  DFE_HDMI_RX_PHY_RST_get_p2_ck_vcorstb(data)                             ((0x00004000&(data))>>14)
#define  DFE_HDMI_RX_PHY_RST_get_p1_ck_vcorstb(data)                             ((0x00002000&(data))>>13)
#define  DFE_HDMI_RX_PHY_RST_get_p0_ck_vcorstb(data)                             ((0x00001000&(data))>>12)
#define  DFE_HDMI_RX_PHY_RST_get_p2_ck_pllrstb(data)                             ((0x00000800&(data))>>11)
#define  DFE_HDMI_RX_PHY_RST_get_p1_ck_pllrstb(data)                             ((0x00000400&(data))>>10)
#define  DFE_HDMI_RX_PHY_RST_get_p0_ck_pllrstb(data)                             ((0x00000200&(data))>>9)
#define  DFE_HDMI_RX_PHY_RST_get_p2_r_demux_rstb(data)                           ((0x00000100&(data))>>8)
#define  DFE_HDMI_RX_PHY_RST_get_p2_g_demux_rstb(data)                           ((0x00000080&(data))>>7)
#define  DFE_HDMI_RX_PHY_RST_get_p2_b_demux_rstb(data)                           ((0x00000040&(data))>>6)
#define  DFE_HDMI_RX_PHY_RST_get_p1_r_demux_rstb(data)                           ((0x00000020&(data))>>5)
#define  DFE_HDMI_RX_PHY_RST_get_p1_g_demux_rstb(data)                           ((0x00000010&(data))>>4)
#define  DFE_HDMI_RX_PHY_RST_get_p1_b_demux_rstb(data)                           ((0x00000008&(data))>>3)
#define  DFE_HDMI_RX_PHY_RST_get_p0_r_demux_rstb(data)                           ((0x00000004&(data))>>2)
#define  DFE_HDMI_RX_PHY_RST_get_p0_g_demux_rstb(data)                           ((0x00000002&(data))>>1)
#define  DFE_HDMI_RX_PHY_RST_get_p0_b_demux_rstb(data)                           (0x00000001&(data))

#define  DFE_HDMI_RX_PHY_REGD0                                                   0x1800DB1C
#define  DFE_HDMI_RX_PHY_REGD0_reg_addr                                          "0xB800DB1C"
#define  DFE_HDMI_RX_PHY_REGD0_reg                                               0xB800DB1C
#define  DFE_HDMI_RX_PHY_REGD0_inst_addr                                         "0x0042"
#define  set_DFE_HDMI_RX_PHY_REGD0_reg(data)                                     (*((volatile unsigned int*)DFE_HDMI_RX_PHY_REGD0_reg)=data)
#define  get_DFE_HDMI_RX_PHY_REGD0_reg                                           (*((volatile unsigned int*)DFE_HDMI_RX_PHY_REGD0_reg))
#define  DFE_HDMI_RX_PHY_REGD0_p0_r_dig_rst_n_shift                              (31)
#define  DFE_HDMI_RX_PHY_REGD0_p0_g_dig_rst_n_shift                              (30)
#define  DFE_HDMI_RX_PHY_REGD0_p0_b_dig_rst_n_shift                              (29)
#define  DFE_HDMI_RX_PHY_REGD0_p0_r_cdr_rst_n_shift                              (28)
#define  DFE_HDMI_RX_PHY_REGD0_p0_g_cdr_rst_n_shift                              (27)
#define  DFE_HDMI_RX_PHY_REGD0_p0_b_cdr_rst_n_shift                              (26)
#define  DFE_HDMI_RX_PHY_REGD0_reg_p0_cdr_ckinv_r_shift                          (25)
#define  DFE_HDMI_RX_PHY_REGD0_reg_p0_cdr_ckinv_g_shift                          (24)
#define  DFE_HDMI_RX_PHY_REGD0_reg_p0_cdr_ckinv_b_shift                          (23)
#define  DFE_HDMI_RX_PHY_REGD0_reg_p0_shift_inv_r_shift                          (22)
#define  DFE_HDMI_RX_PHY_REGD0_reg_p0_shift_inv_g_shift                          (21)
#define  DFE_HDMI_RX_PHY_REGD0_reg_p0_shift_inv_b_shift                          (20)
#define  DFE_HDMI_RX_PHY_REGD0_reg_p0_rate_sel_shift                             (17)
#define  DFE_HDMI_RX_PHY_REGD0_reg_p0_kd_shift                                   (16)
#define  DFE_HDMI_RX_PHY_REGD0_reg_p0_kp_shift                                   (8)
#define  DFE_HDMI_RX_PHY_REGD0_reg_p0_ki_shift                                   (5)
#define  DFE_HDMI_RX_PHY_REGD0_reg_p0_bypass_sdm_int_shift                       (4)
#define  DFE_HDMI_RX_PHY_REGD0_reg_p0_data_order_shift                           (3)
#define  DFE_HDMI_RX_PHY_REGD0_reg_p0_infifo_cnt_shift                           (0)
#define  DFE_HDMI_RX_PHY_REGD0_p0_r_dig_rst_n_mask                               (0x80000000)
#define  DFE_HDMI_RX_PHY_REGD0_p0_g_dig_rst_n_mask                               (0x40000000)
#define  DFE_HDMI_RX_PHY_REGD0_p0_b_dig_rst_n_mask                               (0x20000000)
#define  DFE_HDMI_RX_PHY_REGD0_p0_r_cdr_rst_n_mask                               (0x10000000)
#define  DFE_HDMI_RX_PHY_REGD0_p0_g_cdr_rst_n_mask                               (0x08000000)
#define  DFE_HDMI_RX_PHY_REGD0_p0_b_cdr_rst_n_mask                               (0x04000000)
#define  DFE_HDMI_RX_PHY_REGD0_reg_p0_cdr_ckinv_r_mask                           (0x02000000)
#define  DFE_HDMI_RX_PHY_REGD0_reg_p0_cdr_ckinv_g_mask                           (0x01000000)
#define  DFE_HDMI_RX_PHY_REGD0_reg_p0_cdr_ckinv_b_mask                           (0x00800000)
#define  DFE_HDMI_RX_PHY_REGD0_reg_p0_shift_inv_r_mask                           (0x00400000)
#define  DFE_HDMI_RX_PHY_REGD0_reg_p0_shift_inv_g_mask                           (0x00200000)
#define  DFE_HDMI_RX_PHY_REGD0_reg_p0_shift_inv_b_mask                           (0x00100000)
#define  DFE_HDMI_RX_PHY_REGD0_reg_p0_rate_sel_mask                              (0x000E0000)
#define  DFE_HDMI_RX_PHY_REGD0_reg_p0_kd_mask                                    (0x00010000)
#define  DFE_HDMI_RX_PHY_REGD0_reg_p0_kp_mask                                    (0x0000FF00)
#define  DFE_HDMI_RX_PHY_REGD0_reg_p0_ki_mask                                    (0x000000E0)
#define  DFE_HDMI_RX_PHY_REGD0_reg_p0_bypass_sdm_int_mask                        (0x00000010)
#define  DFE_HDMI_RX_PHY_REGD0_reg_p0_data_order_mask                            (0x00000008)
#define  DFE_HDMI_RX_PHY_REGD0_reg_p0_infifo_cnt_mask                            (0x00000007)
#define  DFE_HDMI_RX_PHY_REGD0_p0_r_dig_rst_n(data)                              (0x80000000&((data)<<31))
#define  DFE_HDMI_RX_PHY_REGD0_p0_g_dig_rst_n(data)                              (0x40000000&((data)<<30))
#define  DFE_HDMI_RX_PHY_REGD0_p0_b_dig_rst_n(data)                              (0x20000000&((data)<<29))
#define  DFE_HDMI_RX_PHY_REGD0_p0_r_cdr_rst_n(data)                              (0x10000000&((data)<<28))
#define  DFE_HDMI_RX_PHY_REGD0_p0_g_cdr_rst_n(data)                              (0x08000000&((data)<<27))
#define  DFE_HDMI_RX_PHY_REGD0_p0_b_cdr_rst_n(data)                              (0x04000000&((data)<<26))
#define  DFE_HDMI_RX_PHY_REGD0_reg_p0_cdr_ckinv_r(data)                          (0x02000000&((data)<<25))
#define  DFE_HDMI_RX_PHY_REGD0_reg_p0_cdr_ckinv_g(data)                          (0x01000000&((data)<<24))
#define  DFE_HDMI_RX_PHY_REGD0_reg_p0_cdr_ckinv_b(data)                          (0x00800000&((data)<<23))
#define  DFE_HDMI_RX_PHY_REGD0_reg_p0_shift_inv_r(data)                          (0x00400000&((data)<<22))
#define  DFE_HDMI_RX_PHY_REGD0_reg_p0_shift_inv_g(data)                          (0x00200000&((data)<<21))
#define  DFE_HDMI_RX_PHY_REGD0_reg_p0_shift_inv_b(data)                          (0x00100000&((data)<<20))
#define  DFE_HDMI_RX_PHY_REGD0_reg_p0_rate_sel(data)                             (0x000E0000&((data)<<17))
#define  DFE_HDMI_RX_PHY_REGD0_reg_p0_kd(data)                                   (0x00010000&((data)<<16))
#define  DFE_HDMI_RX_PHY_REGD0_reg_p0_kp(data)                                   (0x0000FF00&((data)<<8))
#define  DFE_HDMI_RX_PHY_REGD0_reg_p0_ki(data)                                   (0x000000E0&((data)<<5))
#define  DFE_HDMI_RX_PHY_REGD0_reg_p0_bypass_sdm_int(data)                       (0x00000010&((data)<<4))
#define  DFE_HDMI_RX_PHY_REGD0_reg_p0_data_order(data)                           (0x00000008&((data)<<3))
#define  DFE_HDMI_RX_PHY_REGD0_reg_p0_infifo_cnt(data)                           (0x00000007&(data))
#define  DFE_HDMI_RX_PHY_REGD0_get_p0_r_dig_rst_n(data)                          ((0x80000000&(data))>>31)
#define  DFE_HDMI_RX_PHY_REGD0_get_p0_g_dig_rst_n(data)                          ((0x40000000&(data))>>30)
#define  DFE_HDMI_RX_PHY_REGD0_get_p0_b_dig_rst_n(data)                          ((0x20000000&(data))>>29)
#define  DFE_HDMI_RX_PHY_REGD0_get_p0_r_cdr_rst_n(data)                          ((0x10000000&(data))>>28)
#define  DFE_HDMI_RX_PHY_REGD0_get_p0_g_cdr_rst_n(data)                          ((0x08000000&(data))>>27)
#define  DFE_HDMI_RX_PHY_REGD0_get_p0_b_cdr_rst_n(data)                          ((0x04000000&(data))>>26)
#define  DFE_HDMI_RX_PHY_REGD0_get_reg_p0_cdr_ckinv_r(data)                      ((0x02000000&(data))>>25)
#define  DFE_HDMI_RX_PHY_REGD0_get_reg_p0_cdr_ckinv_g(data)                      ((0x01000000&(data))>>24)
#define  DFE_HDMI_RX_PHY_REGD0_get_reg_p0_cdr_ckinv_b(data)                      ((0x00800000&(data))>>23)
#define  DFE_HDMI_RX_PHY_REGD0_get_reg_p0_shift_inv_r(data)                      ((0x00400000&(data))>>22)
#define  DFE_HDMI_RX_PHY_REGD0_get_reg_p0_shift_inv_g(data)                      ((0x00200000&(data))>>21)
#define  DFE_HDMI_RX_PHY_REGD0_get_reg_p0_shift_inv_b(data)                      ((0x00100000&(data))>>20)
#define  DFE_HDMI_RX_PHY_REGD0_get_reg_p0_rate_sel(data)                         ((0x000E0000&(data))>>17)
#define  DFE_HDMI_RX_PHY_REGD0_get_reg_p0_kd(data)                               ((0x00010000&(data))>>16)
#define  DFE_HDMI_RX_PHY_REGD0_get_reg_p0_kp(data)                               ((0x0000FF00&(data))>>8)
#define  DFE_HDMI_RX_PHY_REGD0_get_reg_p0_ki(data)                               ((0x000000E0&(data))>>5)
#define  DFE_HDMI_RX_PHY_REGD0_get_reg_p0_bypass_sdm_int(data)                   ((0x00000010&(data))>>4)
#define  DFE_HDMI_RX_PHY_REGD0_get_reg_p0_data_order(data)                       ((0x00000008&(data))>>3)
#define  DFE_HDMI_RX_PHY_REGD0_get_reg_p0_infifo_cnt(data)                       (0x00000007&(data))

#define  DFE_HDMI_RX_PHY_REGD1                                                   0x1800DB20
#define  DFE_HDMI_RX_PHY_REGD1_reg_addr                                          "0xB800DB20"
#define  DFE_HDMI_RX_PHY_REGD1_reg                                               0xB800DB20
#define  DFE_HDMI_RX_PHY_REGD1_inst_addr                                         "0x0043"
#define  set_DFE_HDMI_RX_PHY_REGD1_reg(data)                                     (*((volatile unsigned int*)DFE_HDMI_RX_PHY_REGD1_reg)=data)
#define  get_DFE_HDMI_RX_PHY_REGD1_reg                                           (*((volatile unsigned int*)DFE_HDMI_RX_PHY_REGD1_reg))
#define  DFE_HDMI_RX_PHY_REGD1_reg_p0_int_init_shift                             (18)
#define  DFE_HDMI_RX_PHY_REGD1_reg_p0_acc2_period_shift                          (8)
#define  DFE_HDMI_RX_PHY_REGD1_reg_p0_squ_tri_shift                              (7)
#define  DFE_HDMI_RX_PHY_REGD1_reg_p0_acc2_manual_shift                          (6)
#define  DFE_HDMI_RX_PHY_REGD1_reg_p0_testout_sel_shift                          (4)
#define  DFE_HDMI_RX_PHY_REGD1_reg_p0_ercnt_en_shift                             (3)
#define  DFE_HDMI_RX_PHY_REGD1_reg_p0_edge_out_shift                             (2)
#define  DFE_HDMI_RX_PHY_REGD1_reg_p0_pi_m_mode_shift                            (1)
#define  DFE_HDMI_RX_PHY_REGD1_reg_p0_dyn_kp_en_shift                            (0)
#define  DFE_HDMI_RX_PHY_REGD1_reg_p0_int_init_mask                              (0xFFFC0000)
#define  DFE_HDMI_RX_PHY_REGD1_reg_p0_acc2_period_mask                           (0x0003FF00)
#define  DFE_HDMI_RX_PHY_REGD1_reg_p0_squ_tri_mask                               (0x00000080)
#define  DFE_HDMI_RX_PHY_REGD1_reg_p0_acc2_manual_mask                           (0x00000040)
#define  DFE_HDMI_RX_PHY_REGD1_reg_p0_testout_sel_mask                           (0x00000030)
#define  DFE_HDMI_RX_PHY_REGD1_reg_p0_ercnt_en_mask                              (0x00000008)
#define  DFE_HDMI_RX_PHY_REGD1_reg_p0_edge_out_mask                              (0x00000004)
#define  DFE_HDMI_RX_PHY_REGD1_reg_p0_pi_m_mode_mask                             (0x00000002)
#define  DFE_HDMI_RX_PHY_REGD1_reg_p0_dyn_kp_en_mask                             (0x00000001)
#define  DFE_HDMI_RX_PHY_REGD1_reg_p0_int_init(data)                             (0xFFFC0000&((data)<<18))
#define  DFE_HDMI_RX_PHY_REGD1_reg_p0_acc2_period(data)                          (0x0003FF00&((data)<<8))
#define  DFE_HDMI_RX_PHY_REGD1_reg_p0_squ_tri(data)                              (0x00000080&((data)<<7))
#define  DFE_HDMI_RX_PHY_REGD1_reg_p0_acc2_manual(data)                          (0x00000040&((data)<<6))
#define  DFE_HDMI_RX_PHY_REGD1_reg_p0_testout_sel(data)                          (0x00000030&((data)<<4))
#define  DFE_HDMI_RX_PHY_REGD1_reg_p0_ercnt_en(data)                             (0x00000008&((data)<<3))
#define  DFE_HDMI_RX_PHY_REGD1_reg_p0_edge_out(data)                             (0x00000004&((data)<<2))
#define  DFE_HDMI_RX_PHY_REGD1_reg_p0_pi_m_mode(data)                            (0x00000002&((data)<<1))
#define  DFE_HDMI_RX_PHY_REGD1_reg_p0_dyn_kp_en(data)                            (0x00000001&(data))
#define  DFE_HDMI_RX_PHY_REGD1_get_reg_p0_int_init(data)                         ((0xFFFC0000&(data))>>18)
#define  DFE_HDMI_RX_PHY_REGD1_get_reg_p0_acc2_period(data)                      ((0x0003FF00&(data))>>8)
#define  DFE_HDMI_RX_PHY_REGD1_get_reg_p0_squ_tri(data)                          ((0x00000080&(data))>>7)
#define  DFE_HDMI_RX_PHY_REGD1_get_reg_p0_acc2_manual(data)                      ((0x00000040&(data))>>6)
#define  DFE_HDMI_RX_PHY_REGD1_get_reg_p0_testout_sel(data)                      ((0x00000030&(data))>>4)
#define  DFE_HDMI_RX_PHY_REGD1_get_reg_p0_ercnt_en(data)                         ((0x00000008&(data))>>3)
#define  DFE_HDMI_RX_PHY_REGD1_get_reg_p0_edge_out(data)                         ((0x00000004&(data))>>2)
#define  DFE_HDMI_RX_PHY_REGD1_get_reg_p0_pi_m_mode(data)                        ((0x00000002&(data))>>1)
#define  DFE_HDMI_RX_PHY_REGD1_get_reg_p0_dyn_kp_en(data)                        (0x00000001&(data))

#define  DFE_HDMI_RX_PHY_REGD2                                                   0x1800DB24
#define  DFE_HDMI_RX_PHY_REGD2_reg_addr                                          "0xB800DB24"
#define  DFE_HDMI_RX_PHY_REGD2_reg                                               0xB800DB24
#define  DFE_HDMI_RX_PHY_REGD2_inst_addr                                         "0x0044"
#define  set_DFE_HDMI_RX_PHY_REGD2_reg(data)                                     (*((volatile unsigned int*)DFE_HDMI_RX_PHY_REGD2_reg)=data)
#define  get_DFE_HDMI_RX_PHY_REGD2_reg                                           (*((volatile unsigned int*)DFE_HDMI_RX_PHY_REGD2_reg))
#define  DFE_HDMI_RX_PHY_REGD2_reg_p0_en_m_value_shift                           (28)
#define  DFE_HDMI_RX_PHY_REGD2_reg_p0_st_m_value_shift                           (23)
#define  DFE_HDMI_RX_PHY_REGD2_reg_p0_timer_lpf_shift                            (18)
#define  DFE_HDMI_RX_PHY_REGD2_reg_p0_timer_eq_shift                             (13)
#define  DFE_HDMI_RX_PHY_REGD2_reg_p0_timer_ber_shift                            (8)
#define  DFE_HDMI_RX_PHY_REGD2_reg_p0_en_m_value_mask                            (0xF0000000)
#define  DFE_HDMI_RX_PHY_REGD2_reg_p0_st_m_value_mask                            (0x0F800000)
#define  DFE_HDMI_RX_PHY_REGD2_reg_p0_timer_lpf_mask                             (0x007C0000)
#define  DFE_HDMI_RX_PHY_REGD2_reg_p0_timer_eq_mask                              (0x0003E000)
#define  DFE_HDMI_RX_PHY_REGD2_reg_p0_timer_ber_mask                             (0x00001F00)
#define  DFE_HDMI_RX_PHY_REGD2_reg_p0_en_m_value(data)                           (0xF0000000&((data)<<28))
#define  DFE_HDMI_RX_PHY_REGD2_reg_p0_st_m_value(data)                           (0x0F800000&((data)<<23))
#define  DFE_HDMI_RX_PHY_REGD2_reg_p0_timer_lpf(data)                            (0x007C0000&((data)<<18))
#define  DFE_HDMI_RX_PHY_REGD2_reg_p0_timer_eq(data)                             (0x0003E000&((data)<<13))
#define  DFE_HDMI_RX_PHY_REGD2_reg_p0_timer_ber(data)                            (0x00001F00&((data)<<8))
#define  DFE_HDMI_RX_PHY_REGD2_get_reg_p0_en_m_value(data)                       ((0xF0000000&(data))>>28)
#define  DFE_HDMI_RX_PHY_REGD2_get_reg_p0_st_m_value(data)                       ((0x0F800000&(data))>>23)
#define  DFE_HDMI_RX_PHY_REGD2_get_reg_p0_timer_lpf(data)                        ((0x007C0000&(data))>>18)
#define  DFE_HDMI_RX_PHY_REGD2_get_reg_p0_timer_eq(data)                         ((0x0003E000&(data))>>13)
#define  DFE_HDMI_RX_PHY_REGD2_get_reg_p0_timer_ber(data)                        ((0x00001F00&(data))>>8)

#define  DFE_HDMI_RX_PHY_REGD3                                                   0x1800DB28
#define  DFE_HDMI_RX_PHY_REGD3_reg_addr                                          "0xB800DB28"
#define  DFE_HDMI_RX_PHY_REGD3_reg                                               0xB800DB28
#define  DFE_HDMI_RX_PHY_REGD3_inst_addr                                         "0x0045"
#define  set_DFE_HDMI_RX_PHY_REGD3_reg(data)                                     (*((volatile unsigned int*)DFE_HDMI_RX_PHY_REGD3_reg)=data)
#define  get_DFE_HDMI_RX_PHY_REGD3_reg                                           (*((volatile unsigned int*)DFE_HDMI_RX_PHY_REGD3_reg))
#define  DFE_HDMI_RX_PHY_REGD3_p0_st_ro_r_shift                                  (24)
#define  DFE_HDMI_RX_PHY_REGD3_p0_en_ro_r_shift                                  (20)
#define  DFE_HDMI_RX_PHY_REGD3_p0_st_ro_g_shift                                  (14)
#define  DFE_HDMI_RX_PHY_REGD3_p0_en_ro_g_shift                                  (10)
#define  DFE_HDMI_RX_PHY_REGD3_p0_st_ro_b_shift                                  (4)
#define  DFE_HDMI_RX_PHY_REGD3_p0_en_ro_b_shift                                  (0)
#define  DFE_HDMI_RX_PHY_REGD3_p0_st_ro_r_mask                                   (0x1F000000)
#define  DFE_HDMI_RX_PHY_REGD3_p0_en_ro_r_mask                                   (0x00F00000)
#define  DFE_HDMI_RX_PHY_REGD3_p0_st_ro_g_mask                                   (0x0007C000)
#define  DFE_HDMI_RX_PHY_REGD3_p0_en_ro_g_mask                                   (0x00003C00)
#define  DFE_HDMI_RX_PHY_REGD3_p0_st_ro_b_mask                                   (0x000001F0)
#define  DFE_HDMI_RX_PHY_REGD3_p0_en_ro_b_mask                                   (0x0000000F)
#define  DFE_HDMI_RX_PHY_REGD3_p0_st_ro_r(data)                                  (0x1F000000&((data)<<24))
#define  DFE_HDMI_RX_PHY_REGD3_p0_en_ro_r(data)                                  (0x00F00000&((data)<<20))
#define  DFE_HDMI_RX_PHY_REGD3_p0_st_ro_g(data)                                  (0x0007C000&((data)<<14))
#define  DFE_HDMI_RX_PHY_REGD3_p0_en_ro_g(data)                                  (0x00003C00&((data)<<10))
#define  DFE_HDMI_RX_PHY_REGD3_p0_st_ro_b(data)                                  (0x000001F0&((data)<<4))
#define  DFE_HDMI_RX_PHY_REGD3_p0_en_ro_b(data)                                  (0x0000000F&(data))
#define  DFE_HDMI_RX_PHY_REGD3_get_p0_st_ro_r(data)                              ((0x1F000000&(data))>>24)
#define  DFE_HDMI_RX_PHY_REGD3_get_p0_en_ro_r(data)                              ((0x00F00000&(data))>>20)
#define  DFE_HDMI_RX_PHY_REGD3_get_p0_st_ro_g(data)                              ((0x0007C000&(data))>>14)
#define  DFE_HDMI_RX_PHY_REGD3_get_p0_en_ro_g(data)                              ((0x00003C00&(data))>>10)
#define  DFE_HDMI_RX_PHY_REGD3_get_p0_st_ro_b(data)                              ((0x000001F0&(data))>>4)
#define  DFE_HDMI_RX_PHY_REGD3_get_p0_en_ro_b(data)                              (0x0000000F&(data))

#define  DFE_HDMI_RX_PHY_REGD4                                                   0x1800DB2C
#define  DFE_HDMI_RX_PHY_REGD4_reg_addr                                          "0xB800DB2C"
#define  DFE_HDMI_RX_PHY_REGD4_reg                                               0xB800DB2C
#define  DFE_HDMI_RX_PHY_REGD4_inst_addr                                         "0x0046"
#define  set_DFE_HDMI_RX_PHY_REGD4_reg(data)                                     (*((volatile unsigned int*)DFE_HDMI_RX_PHY_REGD4_reg)=data)
#define  get_DFE_HDMI_RX_PHY_REGD4_reg                                           (*((volatile unsigned int*)DFE_HDMI_RX_PHY_REGD4_reg))
#define  DFE_HDMI_RX_PHY_REGD4_p0_er_count_r_shift                               (20)
#define  DFE_HDMI_RX_PHY_REGD4_p0_er_count_g_shift                               (10)
#define  DFE_HDMI_RX_PHY_REGD4_p0_er_count_b_shift                               (0)
#define  DFE_HDMI_RX_PHY_REGD4_p0_er_count_r_mask                                (0x3FF00000)
#define  DFE_HDMI_RX_PHY_REGD4_p0_er_count_g_mask                                (0x000FFC00)
#define  DFE_HDMI_RX_PHY_REGD4_p0_er_count_b_mask                                (0x000003FF)
#define  DFE_HDMI_RX_PHY_REGD4_p0_er_count_r(data)                               (0x3FF00000&((data)<<20))
#define  DFE_HDMI_RX_PHY_REGD4_p0_er_count_g(data)                               (0x000FFC00&((data)<<10))
#define  DFE_HDMI_RX_PHY_REGD4_p0_er_count_b(data)                               (0x000003FF&(data))
#define  DFE_HDMI_RX_PHY_REGD4_get_p0_er_count_r(data)                           ((0x3FF00000&(data))>>20)
#define  DFE_HDMI_RX_PHY_REGD4_get_p0_er_count_g(data)                           ((0x000FFC00&(data))>>10)
#define  DFE_HDMI_RX_PHY_REGD4_get_p0_er_count_b(data)                           (0x000003FF&(data))

#define  DFE_HDMI_RX_PHY_REGD5                                                   0x1800DB30
#define  DFE_HDMI_RX_PHY_REGD5_reg_addr                                          "0xB800DB30"
#define  DFE_HDMI_RX_PHY_REGD5_reg                                               0xB800DB30
#define  DFE_HDMI_RX_PHY_REGD5_inst_addr                                         "0x0047"
#define  set_DFE_HDMI_RX_PHY_REGD5_reg(data)                                     (*((volatile unsigned int*)DFE_HDMI_RX_PHY_REGD5_reg)=data)
#define  get_DFE_HDMI_RX_PHY_REGD5_reg                                           (*((volatile unsigned int*)DFE_HDMI_RX_PHY_REGD5_reg))
#define  DFE_HDMI_RX_PHY_REGD5_p1_r_dig_rst_n_shift                              (31)
#define  DFE_HDMI_RX_PHY_REGD5_p1_g_dig_rst_n_shift                              (30)
#define  DFE_HDMI_RX_PHY_REGD5_p1_b_dig_rst_n_shift                              (29)
#define  DFE_HDMI_RX_PHY_REGD5_p1_r_cdr_rst_n_shift                              (28)
#define  DFE_HDMI_RX_PHY_REGD5_p1_g_cdr_rst_n_shift                              (27)
#define  DFE_HDMI_RX_PHY_REGD5_p1_b_cdr_rst_n_shift                              (26)
#define  DFE_HDMI_RX_PHY_REGD5_reg_p1_cdr_ckinv_r_shift                          (25)
#define  DFE_HDMI_RX_PHY_REGD5_reg_p1_cdr_ckinv_g_shift                          (24)
#define  DFE_HDMI_RX_PHY_REGD5_reg_p1_cdr_ckinv_b_shift                          (23)
#define  DFE_HDMI_RX_PHY_REGD5_reg_p1_shift_inv_r_shift                          (22)
#define  DFE_HDMI_RX_PHY_REGD5_reg_p1_shift_inv_g_shift                          (21)
#define  DFE_HDMI_RX_PHY_REGD5_reg_p1_shift_inv_b_shift                          (20)
#define  DFE_HDMI_RX_PHY_REGD5_reg_p1_rate_sel_shift                             (17)
#define  DFE_HDMI_RX_PHY_REGD5_reg_p1_kd_shift                                   (16)
#define  DFE_HDMI_RX_PHY_REGD5_reg_p1_kp_shift                                   (8)
#define  DFE_HDMI_RX_PHY_REGD5_reg_p1_ki_shift                                   (5)
#define  DFE_HDMI_RX_PHY_REGD5_reg_p1_bypass_sdm_int_shift                       (4)
#define  DFE_HDMI_RX_PHY_REGD5_reg_p1_data_order_shift                           (3)
#define  DFE_HDMI_RX_PHY_REGD5_reg_p1_infifo_cnt_shift                           (0)
#define  DFE_HDMI_RX_PHY_REGD5_p1_r_dig_rst_n_mask                               (0x80000000)
#define  DFE_HDMI_RX_PHY_REGD5_p1_g_dig_rst_n_mask                               (0x40000000)
#define  DFE_HDMI_RX_PHY_REGD5_p1_b_dig_rst_n_mask                               (0x20000000)
#define  DFE_HDMI_RX_PHY_REGD5_p1_r_cdr_rst_n_mask                               (0x10000000)
#define  DFE_HDMI_RX_PHY_REGD5_p1_g_cdr_rst_n_mask                               (0x08000000)
#define  DFE_HDMI_RX_PHY_REGD5_p1_b_cdr_rst_n_mask                               (0x04000000)
#define  DFE_HDMI_RX_PHY_REGD5_reg_p1_cdr_ckinv_r_mask                           (0x02000000)
#define  DFE_HDMI_RX_PHY_REGD5_reg_p1_cdr_ckinv_g_mask                           (0x01000000)
#define  DFE_HDMI_RX_PHY_REGD5_reg_p1_cdr_ckinv_b_mask                           (0x00800000)
#define  DFE_HDMI_RX_PHY_REGD5_reg_p1_shift_inv_r_mask                           (0x00400000)
#define  DFE_HDMI_RX_PHY_REGD5_reg_p1_shift_inv_g_mask                           (0x00200000)
#define  DFE_HDMI_RX_PHY_REGD5_reg_p1_shift_inv_b_mask                           (0x00100000)
#define  DFE_HDMI_RX_PHY_REGD5_reg_p1_rate_sel_mask                              (0x000E0000)
#define  DFE_HDMI_RX_PHY_REGD5_reg_p1_kd_mask                                    (0x00010000)
#define  DFE_HDMI_RX_PHY_REGD5_reg_p1_kp_mask                                    (0x0000FF00)
#define  DFE_HDMI_RX_PHY_REGD5_reg_p1_ki_mask                                    (0x000000E0)
#define  DFE_HDMI_RX_PHY_REGD5_reg_p1_bypass_sdm_int_mask                        (0x00000010)
#define  DFE_HDMI_RX_PHY_REGD5_reg_p1_data_order_mask                            (0x00000008)
#define  DFE_HDMI_RX_PHY_REGD5_reg_p1_infifo_cnt_mask                            (0x00000007)
#define  DFE_HDMI_RX_PHY_REGD5_p1_r_dig_rst_n(data)                              (0x80000000&((data)<<31))
#define  DFE_HDMI_RX_PHY_REGD5_p1_g_dig_rst_n(data)                              (0x40000000&((data)<<30))
#define  DFE_HDMI_RX_PHY_REGD5_p1_b_dig_rst_n(data)                              (0x20000000&((data)<<29))
#define  DFE_HDMI_RX_PHY_REGD5_p1_r_cdr_rst_n(data)                              (0x10000000&((data)<<28))
#define  DFE_HDMI_RX_PHY_REGD5_p1_g_cdr_rst_n(data)                              (0x08000000&((data)<<27))
#define  DFE_HDMI_RX_PHY_REGD5_p1_b_cdr_rst_n(data)                              (0x04000000&((data)<<26))
#define  DFE_HDMI_RX_PHY_REGD5_reg_p1_cdr_ckinv_r(data)                          (0x02000000&((data)<<25))
#define  DFE_HDMI_RX_PHY_REGD5_reg_p1_cdr_ckinv_g(data)                          (0x01000000&((data)<<24))
#define  DFE_HDMI_RX_PHY_REGD5_reg_p1_cdr_ckinv_b(data)                          (0x00800000&((data)<<23))
#define  DFE_HDMI_RX_PHY_REGD5_reg_p1_shift_inv_r(data)                          (0x00400000&((data)<<22))
#define  DFE_HDMI_RX_PHY_REGD5_reg_p1_shift_inv_g(data)                          (0x00200000&((data)<<21))
#define  DFE_HDMI_RX_PHY_REGD5_reg_p1_shift_inv_b(data)                          (0x00100000&((data)<<20))
#define  DFE_HDMI_RX_PHY_REGD5_reg_p1_rate_sel(data)                             (0x000E0000&((data)<<17))
#define  DFE_HDMI_RX_PHY_REGD5_reg_p1_kd(data)                                   (0x00010000&((data)<<16))
#define  DFE_HDMI_RX_PHY_REGD5_reg_p1_kp(data)                                   (0x0000FF00&((data)<<8))
#define  DFE_HDMI_RX_PHY_REGD5_reg_p1_ki(data)                                   (0x000000E0&((data)<<5))
#define  DFE_HDMI_RX_PHY_REGD5_reg_p1_bypass_sdm_int(data)                       (0x00000010&((data)<<4))
#define  DFE_HDMI_RX_PHY_REGD5_reg_p1_data_order(data)                           (0x00000008&((data)<<3))
#define  DFE_HDMI_RX_PHY_REGD5_reg_p1_infifo_cnt(data)                           (0x00000007&(data))
#define  DFE_HDMI_RX_PHY_REGD5_get_p1_r_dig_rst_n(data)                          ((0x80000000&(data))>>31)
#define  DFE_HDMI_RX_PHY_REGD5_get_p1_g_dig_rst_n(data)                          ((0x40000000&(data))>>30)
#define  DFE_HDMI_RX_PHY_REGD5_get_p1_b_dig_rst_n(data)                          ((0x20000000&(data))>>29)
#define  DFE_HDMI_RX_PHY_REGD5_get_p1_r_cdr_rst_n(data)                          ((0x10000000&(data))>>28)
#define  DFE_HDMI_RX_PHY_REGD5_get_p1_g_cdr_rst_n(data)                          ((0x08000000&(data))>>27)
#define  DFE_HDMI_RX_PHY_REGD5_get_p1_b_cdr_rst_n(data)                          ((0x04000000&(data))>>26)
#define  DFE_HDMI_RX_PHY_REGD5_get_reg_p1_cdr_ckinv_r(data)                      ((0x02000000&(data))>>25)
#define  DFE_HDMI_RX_PHY_REGD5_get_reg_p1_cdr_ckinv_g(data)                      ((0x01000000&(data))>>24)
#define  DFE_HDMI_RX_PHY_REGD5_get_reg_p1_cdr_ckinv_b(data)                      ((0x00800000&(data))>>23)
#define  DFE_HDMI_RX_PHY_REGD5_get_reg_p1_shift_inv_r(data)                      ((0x00400000&(data))>>22)
#define  DFE_HDMI_RX_PHY_REGD5_get_reg_p1_shift_inv_g(data)                      ((0x00200000&(data))>>21)
#define  DFE_HDMI_RX_PHY_REGD5_get_reg_p1_shift_inv_b(data)                      ((0x00100000&(data))>>20)
#define  DFE_HDMI_RX_PHY_REGD5_get_reg_p1_rate_sel(data)                         ((0x000E0000&(data))>>17)
#define  DFE_HDMI_RX_PHY_REGD5_get_reg_p1_kd(data)                               ((0x00010000&(data))>>16)
#define  DFE_HDMI_RX_PHY_REGD5_get_reg_p1_kp(data)                               ((0x0000FF00&(data))>>8)
#define  DFE_HDMI_RX_PHY_REGD5_get_reg_p1_ki(data)                               ((0x000000E0&(data))>>5)
#define  DFE_HDMI_RX_PHY_REGD5_get_reg_p1_bypass_sdm_int(data)                   ((0x00000010&(data))>>4)
#define  DFE_HDMI_RX_PHY_REGD5_get_reg_p1_data_order(data)                       ((0x00000008&(data))>>3)
#define  DFE_HDMI_RX_PHY_REGD5_get_reg_p1_infifo_cnt(data)                       (0x00000007&(data))

#define  DFE_HDMI_RX_PHY_REGD6                                                   0x1800DB34
#define  DFE_HDMI_RX_PHY_REGD6_reg_addr                                          "0xB800DB34"
#define  DFE_HDMI_RX_PHY_REGD6_reg                                               0xB800DB34
#define  DFE_HDMI_RX_PHY_REGD6_inst_addr                                         "0x0048"
#define  set_DFE_HDMI_RX_PHY_REGD6_reg(data)                                     (*((volatile unsigned int*)DFE_HDMI_RX_PHY_REGD6_reg)=data)
#define  get_DFE_HDMI_RX_PHY_REGD6_reg                                           (*((volatile unsigned int*)DFE_HDMI_RX_PHY_REGD6_reg))
#define  DFE_HDMI_RX_PHY_REGD6_reg_p1_int_init_shift                             (18)
#define  DFE_HDMI_RX_PHY_REGD6_reg_p1_acc2_period_shift                          (8)
#define  DFE_HDMI_RX_PHY_REGD6_reg_p1_squ_tri_shift                              (7)
#define  DFE_HDMI_RX_PHY_REGD6_reg_p1_acc2_manual_shift                          (6)
#define  DFE_HDMI_RX_PHY_REGD6_reg_p1_testout_sel_shift                          (4)
#define  DFE_HDMI_RX_PHY_REGD6_reg_p1_ercnt_en_shift                             (3)
#define  DFE_HDMI_RX_PHY_REGD6_reg_p1_edge_out_shift                             (2)
#define  DFE_HDMI_RX_PHY_REGD6_reg_p1_pi_m_mode_shift                            (1)
#define  DFE_HDMI_RX_PHY_REGD6_reg_p1_dyn_kp_en_shift                            (0)
#define  DFE_HDMI_RX_PHY_REGD6_reg_p1_int_init_mask                              (0xFFFC0000)
#define  DFE_HDMI_RX_PHY_REGD6_reg_p1_acc2_period_mask                           (0x0003FF00)
#define  DFE_HDMI_RX_PHY_REGD6_reg_p1_squ_tri_mask                               (0x00000080)
#define  DFE_HDMI_RX_PHY_REGD6_reg_p1_acc2_manual_mask                           (0x00000040)
#define  DFE_HDMI_RX_PHY_REGD6_reg_p1_testout_sel_mask                           (0x00000030)
#define  DFE_HDMI_RX_PHY_REGD6_reg_p1_ercnt_en_mask                              (0x00000008)
#define  DFE_HDMI_RX_PHY_REGD6_reg_p1_edge_out_mask                              (0x00000004)
#define  DFE_HDMI_RX_PHY_REGD6_reg_p1_pi_m_mode_mask                             (0x00000002)
#define  DFE_HDMI_RX_PHY_REGD6_reg_p1_dyn_kp_en_mask                             (0x00000001)
#define  DFE_HDMI_RX_PHY_REGD6_reg_p1_int_init(data)                             (0xFFFC0000&((data)<<18))
#define  DFE_HDMI_RX_PHY_REGD6_reg_p1_acc2_period(data)                          (0x0003FF00&((data)<<8))
#define  DFE_HDMI_RX_PHY_REGD6_reg_p1_squ_tri(data)                              (0x00000080&((data)<<7))
#define  DFE_HDMI_RX_PHY_REGD6_reg_p1_acc2_manual(data)                          (0x00000040&((data)<<6))
#define  DFE_HDMI_RX_PHY_REGD6_reg_p1_testout_sel(data)                          (0x00000030&((data)<<4))
#define  DFE_HDMI_RX_PHY_REGD6_reg_p1_ercnt_en(data)                             (0x00000008&((data)<<3))
#define  DFE_HDMI_RX_PHY_REGD6_reg_p1_edge_out(data)                             (0x00000004&((data)<<2))
#define  DFE_HDMI_RX_PHY_REGD6_reg_p1_pi_m_mode(data)                            (0x00000002&((data)<<1))
#define  DFE_HDMI_RX_PHY_REGD6_reg_p1_dyn_kp_en(data)                            (0x00000001&(data))
#define  DFE_HDMI_RX_PHY_REGD6_get_reg_p1_int_init(data)                         ((0xFFFC0000&(data))>>18)
#define  DFE_HDMI_RX_PHY_REGD6_get_reg_p1_acc2_period(data)                      ((0x0003FF00&(data))>>8)
#define  DFE_HDMI_RX_PHY_REGD6_get_reg_p1_squ_tri(data)                          ((0x00000080&(data))>>7)
#define  DFE_HDMI_RX_PHY_REGD6_get_reg_p1_acc2_manual(data)                      ((0x00000040&(data))>>6)
#define  DFE_HDMI_RX_PHY_REGD6_get_reg_p1_testout_sel(data)                      ((0x00000030&(data))>>4)
#define  DFE_HDMI_RX_PHY_REGD6_get_reg_p1_ercnt_en(data)                         ((0x00000008&(data))>>3)
#define  DFE_HDMI_RX_PHY_REGD6_get_reg_p1_edge_out(data)                         ((0x00000004&(data))>>2)
#define  DFE_HDMI_RX_PHY_REGD6_get_reg_p1_pi_m_mode(data)                        ((0x00000002&(data))>>1)
#define  DFE_HDMI_RX_PHY_REGD6_get_reg_p1_dyn_kp_en(data)                        (0x00000001&(data))

#define  DFE_HDMI_RX_PHY_REGD7                                                   0x1800DB38
#define  DFE_HDMI_RX_PHY_REGD7_reg_addr                                          "0xB800DB38"
#define  DFE_HDMI_RX_PHY_REGD7_reg                                               0xB800DB38
#define  DFE_HDMI_RX_PHY_REGD7_inst_addr                                         "0x0049"
#define  set_DFE_HDMI_RX_PHY_REGD7_reg(data)                                     (*((volatile unsigned int*)DFE_HDMI_RX_PHY_REGD7_reg)=data)
#define  get_DFE_HDMI_RX_PHY_REGD7_reg                                           (*((volatile unsigned int*)DFE_HDMI_RX_PHY_REGD7_reg))
#define  DFE_HDMI_RX_PHY_REGD7_reg_p1_en_m_value_shift                           (28)
#define  DFE_HDMI_RX_PHY_REGD7_reg_p1_st_m_value_shift                           (23)
#define  DFE_HDMI_RX_PHY_REGD7_reg_p1_timer_lpf_shift                            (18)
#define  DFE_HDMI_RX_PHY_REGD7_reg_p1_timer_eq_shift                             (13)
#define  DFE_HDMI_RX_PHY_REGD7_reg_p1_timer_ber_shift                            (8)
#define  DFE_HDMI_RX_PHY_REGD7_reg_p1_en_m_value_mask                            (0xF0000000)
#define  DFE_HDMI_RX_PHY_REGD7_reg_p1_st_m_value_mask                            (0x0F800000)
#define  DFE_HDMI_RX_PHY_REGD7_reg_p1_timer_lpf_mask                             (0x007C0000)
#define  DFE_HDMI_RX_PHY_REGD7_reg_p1_timer_eq_mask                              (0x0003E000)
#define  DFE_HDMI_RX_PHY_REGD7_reg_p1_timer_ber_mask                             (0x00001F00)
#define  DFE_HDMI_RX_PHY_REGD7_reg_p1_en_m_value(data)                           (0xF0000000&((data)<<28))
#define  DFE_HDMI_RX_PHY_REGD7_reg_p1_st_m_value(data)                           (0x0F800000&((data)<<23))
#define  DFE_HDMI_RX_PHY_REGD7_reg_p1_timer_lpf(data)                            (0x007C0000&((data)<<18))
#define  DFE_HDMI_RX_PHY_REGD7_reg_p1_timer_eq(data)                             (0x0003E000&((data)<<13))
#define  DFE_HDMI_RX_PHY_REGD7_reg_p1_timer_ber(data)                            (0x00001F00&((data)<<8))
#define  DFE_HDMI_RX_PHY_REGD7_get_reg_p1_en_m_value(data)                       ((0xF0000000&(data))>>28)
#define  DFE_HDMI_RX_PHY_REGD7_get_reg_p1_st_m_value(data)                       ((0x0F800000&(data))>>23)
#define  DFE_HDMI_RX_PHY_REGD7_get_reg_p1_timer_lpf(data)                        ((0x007C0000&(data))>>18)
#define  DFE_HDMI_RX_PHY_REGD7_get_reg_p1_timer_eq(data)                         ((0x0003E000&(data))>>13)
#define  DFE_HDMI_RX_PHY_REGD7_get_reg_p1_timer_ber(data)                        ((0x00001F00&(data))>>8)

#define  DFE_HDMI_RX_PHY_REGD8                                                   0x1800DB3C
#define  DFE_HDMI_RX_PHY_REGD8_reg_addr                                          "0xB800DB3C"
#define  DFE_HDMI_RX_PHY_REGD8_reg                                               0xB800DB3C
#define  DFE_HDMI_RX_PHY_REGD8_inst_addr                                         "0x004A"
#define  set_DFE_HDMI_RX_PHY_REGD8_reg(data)                                     (*((volatile unsigned int*)DFE_HDMI_RX_PHY_REGD8_reg)=data)
#define  get_DFE_HDMI_RX_PHY_REGD8_reg                                           (*((volatile unsigned int*)DFE_HDMI_RX_PHY_REGD8_reg))
#define  DFE_HDMI_RX_PHY_REGD8_p1_st_ro_r_shift                                  (24)
#define  DFE_HDMI_RX_PHY_REGD8_p1_en_ro_r_shift                                  (20)
#define  DFE_HDMI_RX_PHY_REGD8_p1_st_ro_g_shift                                  (14)
#define  DFE_HDMI_RX_PHY_REGD8_p1_en_ro_g_shift                                  (10)
#define  DFE_HDMI_RX_PHY_REGD8_p1_st_ro_b_shift                                  (4)
#define  DFE_HDMI_RX_PHY_REGD8_p1_en_ro_b_shift                                  (0)
#define  DFE_HDMI_RX_PHY_REGD8_p1_st_ro_r_mask                                   (0x1F000000)
#define  DFE_HDMI_RX_PHY_REGD8_p1_en_ro_r_mask                                   (0x00F00000)
#define  DFE_HDMI_RX_PHY_REGD8_p1_st_ro_g_mask                                   (0x0007C000)
#define  DFE_HDMI_RX_PHY_REGD8_p1_en_ro_g_mask                                   (0x00003C00)
#define  DFE_HDMI_RX_PHY_REGD8_p1_st_ro_b_mask                                   (0x000001F0)
#define  DFE_HDMI_RX_PHY_REGD8_p1_en_ro_b_mask                                   (0x0000000F)
#define  DFE_HDMI_RX_PHY_REGD8_p1_st_ro_r(data)                                  (0x1F000000&((data)<<24))
#define  DFE_HDMI_RX_PHY_REGD8_p1_en_ro_r(data)                                  (0x00F00000&((data)<<20))
#define  DFE_HDMI_RX_PHY_REGD8_p1_st_ro_g(data)                                  (0x0007C000&((data)<<14))
#define  DFE_HDMI_RX_PHY_REGD8_p1_en_ro_g(data)                                  (0x00003C00&((data)<<10))
#define  DFE_HDMI_RX_PHY_REGD8_p1_st_ro_b(data)                                  (0x000001F0&((data)<<4))
#define  DFE_HDMI_RX_PHY_REGD8_p1_en_ro_b(data)                                  (0x0000000F&(data))
#define  DFE_HDMI_RX_PHY_REGD8_get_p1_st_ro_r(data)                              ((0x1F000000&(data))>>24)
#define  DFE_HDMI_RX_PHY_REGD8_get_p1_en_ro_r(data)                              ((0x00F00000&(data))>>20)
#define  DFE_HDMI_RX_PHY_REGD8_get_p1_st_ro_g(data)                              ((0x0007C000&(data))>>14)
#define  DFE_HDMI_RX_PHY_REGD8_get_p1_en_ro_g(data)                              ((0x00003C00&(data))>>10)
#define  DFE_HDMI_RX_PHY_REGD8_get_p1_st_ro_b(data)                              ((0x000001F0&(data))>>4)
#define  DFE_HDMI_RX_PHY_REGD8_get_p1_en_ro_b(data)                              (0x0000000F&(data))

#define  DFE_HDMI_RX_PHY_REGD9                                                   0x1800DB40
#define  DFE_HDMI_RX_PHY_REGD9_reg_addr                                          "0xB800DB40"
#define  DFE_HDMI_RX_PHY_REGD9_reg                                               0xB800DB40
#define  DFE_HDMI_RX_PHY_REGD9_inst_addr                                         "0x004B"
#define  set_DFE_HDMI_RX_PHY_REGD9_reg(data)                                     (*((volatile unsigned int*)DFE_HDMI_RX_PHY_REGD9_reg)=data)
#define  get_DFE_HDMI_RX_PHY_REGD9_reg                                           (*((volatile unsigned int*)DFE_HDMI_RX_PHY_REGD9_reg))
#define  DFE_HDMI_RX_PHY_REGD9_p1_er_count_r_shift                               (20)
#define  DFE_HDMI_RX_PHY_REGD9_p1_er_count_g_shift                               (10)
#define  DFE_HDMI_RX_PHY_REGD9_p1_er_count_b_shift                               (0)
#define  DFE_HDMI_RX_PHY_REGD9_p1_er_count_r_mask                                (0x3FF00000)
#define  DFE_HDMI_RX_PHY_REGD9_p1_er_count_g_mask                                (0x000FFC00)
#define  DFE_HDMI_RX_PHY_REGD9_p1_er_count_b_mask                                (0x000003FF)
#define  DFE_HDMI_RX_PHY_REGD9_p1_er_count_r(data)                               (0x3FF00000&((data)<<20))
#define  DFE_HDMI_RX_PHY_REGD9_p1_er_count_g(data)                               (0x000FFC00&((data)<<10))
#define  DFE_HDMI_RX_PHY_REGD9_p1_er_count_b(data)                               (0x000003FF&(data))
#define  DFE_HDMI_RX_PHY_REGD9_get_p1_er_count_r(data)                           ((0x3FF00000&(data))>>20)
#define  DFE_HDMI_RX_PHY_REGD9_get_p1_er_count_g(data)                           ((0x000FFC00&(data))>>10)
#define  DFE_HDMI_RX_PHY_REGD9_get_p1_er_count_b(data)                           (0x000003FF&(data))

#define  DFE_HDMI_RX_PHY_REGD10                                                  0x1800DB44
#define  DFE_HDMI_RX_PHY_REGD10_reg_addr                                         "0xB800DB44"
#define  DFE_HDMI_RX_PHY_REGD10_reg                                              0xB800DB44
#define  DFE_HDMI_RX_PHY_REGD10_inst_addr                                        "0x004C"
#define  set_DFE_HDMI_RX_PHY_REGD10_reg(data)                                    (*((volatile unsigned int*)DFE_HDMI_RX_PHY_REGD10_reg)=data)
#define  get_DFE_HDMI_RX_PHY_REGD10_reg                                          (*((volatile unsigned int*)DFE_HDMI_RX_PHY_REGD10_reg))
#define  DFE_HDMI_RX_PHY_REGD10_p2_r_dig_rst_n_shift                             (31)
#define  DFE_HDMI_RX_PHY_REGD10_p2_g_dig_rst_n_shift                             (30)
#define  DFE_HDMI_RX_PHY_REGD10_p2_b_dig_rst_n_shift                             (29)
#define  DFE_HDMI_RX_PHY_REGD10_p2_r_cdr_rst_n_shift                             (28)
#define  DFE_HDMI_RX_PHY_REGD10_p2_g_cdr_rst_n_shift                             (27)
#define  DFE_HDMI_RX_PHY_REGD10_p2_b_cdr_rst_n_shift                             (26)
#define  DFE_HDMI_RX_PHY_REGD10_reg_p2_cdr_ckinv_r_shift                         (25)
#define  DFE_HDMI_RX_PHY_REGD10_reg_p2_cdr_ckinv_g_shift                         (24)
#define  DFE_HDMI_RX_PHY_REGD10_reg_p2_cdr_ckinv_b_shift                         (23)
#define  DFE_HDMI_RX_PHY_REGD10_reg_p2_shift_inv_r_shift                         (22)
#define  DFE_HDMI_RX_PHY_REGD10_reg_p2_shift_inv_g_shift                         (21)
#define  DFE_HDMI_RX_PHY_REGD10_reg_p2_shift_inv_b_shift                         (20)
#define  DFE_HDMI_RX_PHY_REGD10_reg_p2_rate_sel_shift                            (17)
#define  DFE_HDMI_RX_PHY_REGD10_reg_p2_kd_shift                                  (16)
#define  DFE_HDMI_RX_PHY_REGD10_reg_p2_kp_shift                                  (8)
#define  DFE_HDMI_RX_PHY_REGD10_reg_p2_ki_shift                                  (5)
#define  DFE_HDMI_RX_PHY_REGD10_reg_p2_bypass_sdm_int_shift                      (4)
#define  DFE_HDMI_RX_PHY_REGD10_reg_p2_data_order_shift                          (3)
#define  DFE_HDMI_RX_PHY_REGD10_reg_p2_infifo_cnt_shift                          (0)
#define  DFE_HDMI_RX_PHY_REGD10_p2_r_dig_rst_n_mask                              (0x80000000)
#define  DFE_HDMI_RX_PHY_REGD10_p2_g_dig_rst_n_mask                              (0x40000000)
#define  DFE_HDMI_RX_PHY_REGD10_p2_b_dig_rst_n_mask                              (0x20000000)
#define  DFE_HDMI_RX_PHY_REGD10_p2_r_cdr_rst_n_mask                              (0x10000000)
#define  DFE_HDMI_RX_PHY_REGD10_p2_g_cdr_rst_n_mask                              (0x08000000)
#define  DFE_HDMI_RX_PHY_REGD10_p2_b_cdr_rst_n_mask                              (0x04000000)
#define  DFE_HDMI_RX_PHY_REGD10_reg_p2_cdr_ckinv_r_mask                          (0x02000000)
#define  DFE_HDMI_RX_PHY_REGD10_reg_p2_cdr_ckinv_g_mask                          (0x01000000)
#define  DFE_HDMI_RX_PHY_REGD10_reg_p2_cdr_ckinv_b_mask                          (0x00800000)
#define  DFE_HDMI_RX_PHY_REGD10_reg_p2_shift_inv_r_mask                          (0x00400000)
#define  DFE_HDMI_RX_PHY_REGD10_reg_p2_shift_inv_g_mask                          (0x00200000)
#define  DFE_HDMI_RX_PHY_REGD10_reg_p2_shift_inv_b_mask                          (0x00100000)
#define  DFE_HDMI_RX_PHY_REGD10_reg_p2_rate_sel_mask                             (0x000E0000)
#define  DFE_HDMI_RX_PHY_REGD10_reg_p2_kd_mask                                   (0x00010000)
#define  DFE_HDMI_RX_PHY_REGD10_reg_p2_kp_mask                                   (0x0000FF00)
#define  DFE_HDMI_RX_PHY_REGD10_reg_p2_ki_mask                                   (0x000000E0)
#define  DFE_HDMI_RX_PHY_REGD10_reg_p2_bypass_sdm_int_mask                       (0x00000010)
#define  DFE_HDMI_RX_PHY_REGD10_reg_p2_data_order_mask                           (0x00000008)
#define  DFE_HDMI_RX_PHY_REGD10_reg_p2_infifo_cnt_mask                           (0x00000007)
#define  DFE_HDMI_RX_PHY_REGD10_p2_r_dig_rst_n(data)                             (0x80000000&((data)<<31))
#define  DFE_HDMI_RX_PHY_REGD10_p2_g_dig_rst_n(data)                             (0x40000000&((data)<<30))
#define  DFE_HDMI_RX_PHY_REGD10_p2_b_dig_rst_n(data)                             (0x20000000&((data)<<29))
#define  DFE_HDMI_RX_PHY_REGD10_p2_r_cdr_rst_n(data)                             (0x10000000&((data)<<28))
#define  DFE_HDMI_RX_PHY_REGD10_p2_g_cdr_rst_n(data)                             (0x08000000&((data)<<27))
#define  DFE_HDMI_RX_PHY_REGD10_p2_b_cdr_rst_n(data)                             (0x04000000&((data)<<26))
#define  DFE_HDMI_RX_PHY_REGD10_reg_p2_cdr_ckinv_r(data)                         (0x02000000&((data)<<25))
#define  DFE_HDMI_RX_PHY_REGD10_reg_p2_cdr_ckinv_g(data)                         (0x01000000&((data)<<24))
#define  DFE_HDMI_RX_PHY_REGD10_reg_p2_cdr_ckinv_b(data)                         (0x00800000&((data)<<23))
#define  DFE_HDMI_RX_PHY_REGD10_reg_p2_shift_inv_r(data)                         (0x00400000&((data)<<22))
#define  DFE_HDMI_RX_PHY_REGD10_reg_p2_shift_inv_g(data)                         (0x00200000&((data)<<21))
#define  DFE_HDMI_RX_PHY_REGD10_reg_p2_shift_inv_b(data)                         (0x00100000&((data)<<20))
#define  DFE_HDMI_RX_PHY_REGD10_reg_p2_rate_sel(data)                            (0x000E0000&((data)<<17))
#define  DFE_HDMI_RX_PHY_REGD10_reg_p2_kd(data)                                  (0x00010000&((data)<<16))
#define  DFE_HDMI_RX_PHY_REGD10_reg_p2_kp(data)                                  (0x0000FF00&((data)<<8))
#define  DFE_HDMI_RX_PHY_REGD10_reg_p2_ki(data)                                  (0x000000E0&((data)<<5))
#define  DFE_HDMI_RX_PHY_REGD10_reg_p2_bypass_sdm_int(data)                      (0x00000010&((data)<<4))
#define  DFE_HDMI_RX_PHY_REGD10_reg_p2_data_order(data)                          (0x00000008&((data)<<3))
#define  DFE_HDMI_RX_PHY_REGD10_reg_p2_infifo_cnt(data)                          (0x00000007&(data))
#define  DFE_HDMI_RX_PHY_REGD10_get_p2_r_dig_rst_n(data)                         ((0x80000000&(data))>>31)
#define  DFE_HDMI_RX_PHY_REGD10_get_p2_g_dig_rst_n(data)                         ((0x40000000&(data))>>30)
#define  DFE_HDMI_RX_PHY_REGD10_get_p2_b_dig_rst_n(data)                         ((0x20000000&(data))>>29)
#define  DFE_HDMI_RX_PHY_REGD10_get_p2_r_cdr_rst_n(data)                         ((0x10000000&(data))>>28)
#define  DFE_HDMI_RX_PHY_REGD10_get_p2_g_cdr_rst_n(data)                         ((0x08000000&(data))>>27)
#define  DFE_HDMI_RX_PHY_REGD10_get_p2_b_cdr_rst_n(data)                         ((0x04000000&(data))>>26)
#define  DFE_HDMI_RX_PHY_REGD10_get_reg_p2_cdr_ckinv_r(data)                     ((0x02000000&(data))>>25)
#define  DFE_HDMI_RX_PHY_REGD10_get_reg_p2_cdr_ckinv_g(data)                     ((0x01000000&(data))>>24)
#define  DFE_HDMI_RX_PHY_REGD10_get_reg_p2_cdr_ckinv_b(data)                     ((0x00800000&(data))>>23)
#define  DFE_HDMI_RX_PHY_REGD10_get_reg_p2_shift_inv_r(data)                     ((0x00400000&(data))>>22)
#define  DFE_HDMI_RX_PHY_REGD10_get_reg_p2_shift_inv_g(data)                     ((0x00200000&(data))>>21)
#define  DFE_HDMI_RX_PHY_REGD10_get_reg_p2_shift_inv_b(data)                     ((0x00100000&(data))>>20)
#define  DFE_HDMI_RX_PHY_REGD10_get_reg_p2_rate_sel(data)                        ((0x000E0000&(data))>>17)
#define  DFE_HDMI_RX_PHY_REGD10_get_reg_p2_kd(data)                              ((0x00010000&(data))>>16)
#define  DFE_HDMI_RX_PHY_REGD10_get_reg_p2_kp(data)                              ((0x0000FF00&(data))>>8)
#define  DFE_HDMI_RX_PHY_REGD10_get_reg_p2_ki(data)                              ((0x000000E0&(data))>>5)
#define  DFE_HDMI_RX_PHY_REGD10_get_reg_p2_bypass_sdm_int(data)                  ((0x00000010&(data))>>4)
#define  DFE_HDMI_RX_PHY_REGD10_get_reg_p2_data_order(data)                      ((0x00000008&(data))>>3)
#define  DFE_HDMI_RX_PHY_REGD10_get_reg_p2_infifo_cnt(data)                      (0x00000007&(data))

#define  DFE_HDMI_RX_PHY_REGD11                                                  0x1800DB48
#define  DFE_HDMI_RX_PHY_REGD11_reg_addr                                         "0xB800DB48"
#define  DFE_HDMI_RX_PHY_REGD11_reg                                              0xB800DB48
#define  DFE_HDMI_RX_PHY_REGD11_inst_addr                                        "0x004D"
#define  set_DFE_HDMI_RX_PHY_REGD11_reg(data)                                    (*((volatile unsigned int*)DFE_HDMI_RX_PHY_REGD11_reg)=data)
#define  get_DFE_HDMI_RX_PHY_REGD11_reg                                          (*((volatile unsigned int*)DFE_HDMI_RX_PHY_REGD11_reg))
#define  DFE_HDMI_RX_PHY_REGD11_reg_p2_int_init_shift                            (18)
#define  DFE_HDMI_RX_PHY_REGD11_reg_p2_acc2_period_shift                         (8)
#define  DFE_HDMI_RX_PHY_REGD11_reg_p2_squ_tri_shift                             (7)
#define  DFE_HDMI_RX_PHY_REGD11_reg_p2_acc2_manual_shift                         (6)
#define  DFE_HDMI_RX_PHY_REGD11_reg_p2_testout_sel_shift                         (4)
#define  DFE_HDMI_RX_PHY_REGD11_reg_p2_ercnt_en_shift                            (3)
#define  DFE_HDMI_RX_PHY_REGD11_reg_p2_edge_out_shift                            (2)
#define  DFE_HDMI_RX_PHY_REGD11_reg_p2_pi_m_mode_shift                           (1)
#define  DFE_HDMI_RX_PHY_REGD11_reg_p2_dyn_kp_en_shift                           (0)
#define  DFE_HDMI_RX_PHY_REGD11_reg_p2_int_init_mask                             (0xFFFC0000)
#define  DFE_HDMI_RX_PHY_REGD11_reg_p2_acc2_period_mask                          (0x0003FF00)
#define  DFE_HDMI_RX_PHY_REGD11_reg_p2_squ_tri_mask                              (0x00000080)
#define  DFE_HDMI_RX_PHY_REGD11_reg_p2_acc2_manual_mask                          (0x00000040)
#define  DFE_HDMI_RX_PHY_REGD11_reg_p2_testout_sel_mask                          (0x00000030)
#define  DFE_HDMI_RX_PHY_REGD11_reg_p2_ercnt_en_mask                             (0x00000008)
#define  DFE_HDMI_RX_PHY_REGD11_reg_p2_edge_out_mask                             (0x00000004)
#define  DFE_HDMI_RX_PHY_REGD11_reg_p2_pi_m_mode_mask                            (0x00000002)
#define  DFE_HDMI_RX_PHY_REGD11_reg_p2_dyn_kp_en_mask                            (0x00000001)
#define  DFE_HDMI_RX_PHY_REGD11_reg_p2_int_init(data)                            (0xFFFC0000&((data)<<18))
#define  DFE_HDMI_RX_PHY_REGD11_reg_p2_acc2_period(data)                         (0x0003FF00&((data)<<8))
#define  DFE_HDMI_RX_PHY_REGD11_reg_p2_squ_tri(data)                             (0x00000080&((data)<<7))
#define  DFE_HDMI_RX_PHY_REGD11_reg_p2_acc2_manual(data)                         (0x00000040&((data)<<6))
#define  DFE_HDMI_RX_PHY_REGD11_reg_p2_testout_sel(data)                         (0x00000030&((data)<<4))
#define  DFE_HDMI_RX_PHY_REGD11_reg_p2_ercnt_en(data)                            (0x00000008&((data)<<3))
#define  DFE_HDMI_RX_PHY_REGD11_reg_p2_edge_out(data)                            (0x00000004&((data)<<2))
#define  DFE_HDMI_RX_PHY_REGD11_reg_p2_pi_m_mode(data)                           (0x00000002&((data)<<1))
#define  DFE_HDMI_RX_PHY_REGD11_reg_p2_dyn_kp_en(data)                           (0x00000001&(data))
#define  DFE_HDMI_RX_PHY_REGD11_get_reg_p2_int_init(data)                        ((0xFFFC0000&(data))>>18)
#define  DFE_HDMI_RX_PHY_REGD11_get_reg_p2_acc2_period(data)                     ((0x0003FF00&(data))>>8)
#define  DFE_HDMI_RX_PHY_REGD11_get_reg_p2_squ_tri(data)                         ((0x00000080&(data))>>7)
#define  DFE_HDMI_RX_PHY_REGD11_get_reg_p2_acc2_manual(data)                     ((0x00000040&(data))>>6)
#define  DFE_HDMI_RX_PHY_REGD11_get_reg_p2_testout_sel(data)                     ((0x00000030&(data))>>4)
#define  DFE_HDMI_RX_PHY_REGD11_get_reg_p2_ercnt_en(data)                        ((0x00000008&(data))>>3)
#define  DFE_HDMI_RX_PHY_REGD11_get_reg_p2_edge_out(data)                        ((0x00000004&(data))>>2)
#define  DFE_HDMI_RX_PHY_REGD11_get_reg_p2_pi_m_mode(data)                       ((0x00000002&(data))>>1)
#define  DFE_HDMI_RX_PHY_REGD11_get_reg_p2_dyn_kp_en(data)                       (0x00000001&(data))

#define  DFE_HDMI_RX_PHY_REGD12                                                  0x1800DB4C
#define  DFE_HDMI_RX_PHY_REGD12_reg_addr                                         "0xB800DB4C"
#define  DFE_HDMI_RX_PHY_REGD12_reg                                              0xB800DB4C
#define  DFE_HDMI_RX_PHY_REGD12_inst_addr                                        "0x004E"
#define  set_DFE_HDMI_RX_PHY_REGD12_reg(data)                                    (*((volatile unsigned int*)DFE_HDMI_RX_PHY_REGD12_reg)=data)
#define  get_DFE_HDMI_RX_PHY_REGD12_reg                                          (*((volatile unsigned int*)DFE_HDMI_RX_PHY_REGD12_reg))
#define  DFE_HDMI_RX_PHY_REGD12_reg_p2_en_m_value_shift                          (28)
#define  DFE_HDMI_RX_PHY_REGD12_reg_p2_st_m_value_shift                          (23)
#define  DFE_HDMI_RX_PHY_REGD12_reg_p2_timer_lpf_shift                           (18)
#define  DFE_HDMI_RX_PHY_REGD12_reg_p2_timer_eq_shift                            (13)
#define  DFE_HDMI_RX_PHY_REGD12_reg_p2_timer_ber_shift                           (8)
#define  DFE_HDMI_RX_PHY_REGD12_reg_p2_en_m_value_mask                           (0xF0000000)
#define  DFE_HDMI_RX_PHY_REGD12_reg_p2_st_m_value_mask                           (0x0F800000)
#define  DFE_HDMI_RX_PHY_REGD12_reg_p2_timer_lpf_mask                            (0x007C0000)
#define  DFE_HDMI_RX_PHY_REGD12_reg_p2_timer_eq_mask                             (0x0003E000)
#define  DFE_HDMI_RX_PHY_REGD12_reg_p2_timer_ber_mask                            (0x00001F00)
#define  DFE_HDMI_RX_PHY_REGD12_reg_p2_en_m_value(data)                          (0xF0000000&((data)<<28))
#define  DFE_HDMI_RX_PHY_REGD12_reg_p2_st_m_value(data)                          (0x0F800000&((data)<<23))
#define  DFE_HDMI_RX_PHY_REGD12_reg_p2_timer_lpf(data)                           (0x007C0000&((data)<<18))
#define  DFE_HDMI_RX_PHY_REGD12_reg_p2_timer_eq(data)                            (0x0003E000&((data)<<13))
#define  DFE_HDMI_RX_PHY_REGD12_reg_p2_timer_ber(data)                           (0x00001F00&((data)<<8))
#define  DFE_HDMI_RX_PHY_REGD12_get_reg_p2_en_m_value(data)                      ((0xF0000000&(data))>>28)
#define  DFE_HDMI_RX_PHY_REGD12_get_reg_p2_st_m_value(data)                      ((0x0F800000&(data))>>23)
#define  DFE_HDMI_RX_PHY_REGD12_get_reg_p2_timer_lpf(data)                       ((0x007C0000&(data))>>18)
#define  DFE_HDMI_RX_PHY_REGD12_get_reg_p2_timer_eq(data)                        ((0x0003E000&(data))>>13)
#define  DFE_HDMI_RX_PHY_REGD12_get_reg_p2_timer_ber(data)                       ((0x00001F00&(data))>>8)

#define  DFE_HDMI_RX_PHY_REGD13                                                  0x1800DB50
#define  DFE_HDMI_RX_PHY_REGD13_reg_addr                                         "0xB800DB50"
#define  DFE_HDMI_RX_PHY_REGD13_reg                                              0xB800DB50
#define  DFE_HDMI_RX_PHY_REGD13_inst_addr                                        "0x004F"
#define  set_DFE_HDMI_RX_PHY_REGD13_reg(data)                                    (*((volatile unsigned int*)DFE_HDMI_RX_PHY_REGD13_reg)=data)
#define  get_DFE_HDMI_RX_PHY_REGD13_reg                                          (*((volatile unsigned int*)DFE_HDMI_RX_PHY_REGD13_reg))
#define  DFE_HDMI_RX_PHY_REGD13_p2_st_ro_r_shift                                 (24)
#define  DFE_HDMI_RX_PHY_REGD13_p2_en_ro_r_shift                                 (20)
#define  DFE_HDMI_RX_PHY_REGD13_p2_st_ro_g_shift                                 (14)
#define  DFE_HDMI_RX_PHY_REGD13_p2_en_ro_g_shift                                 (10)
#define  DFE_HDMI_RX_PHY_REGD13_p2_st_ro_b_shift                                 (4)
#define  DFE_HDMI_RX_PHY_REGD13_p2_en_ro_b_shift                                 (0)
#define  DFE_HDMI_RX_PHY_REGD13_p2_st_ro_r_mask                                  (0x1F000000)
#define  DFE_HDMI_RX_PHY_REGD13_p2_en_ro_r_mask                                  (0x00F00000)
#define  DFE_HDMI_RX_PHY_REGD13_p2_st_ro_g_mask                                  (0x0007C000)
#define  DFE_HDMI_RX_PHY_REGD13_p2_en_ro_g_mask                                  (0x00003C00)
#define  DFE_HDMI_RX_PHY_REGD13_p2_st_ro_b_mask                                  (0x000001F0)
#define  DFE_HDMI_RX_PHY_REGD13_p2_en_ro_b_mask                                  (0x0000000F)
#define  DFE_HDMI_RX_PHY_REGD13_p2_st_ro_r(data)                                 (0x1F000000&((data)<<24))
#define  DFE_HDMI_RX_PHY_REGD13_p2_en_ro_r(data)                                 (0x00F00000&((data)<<20))
#define  DFE_HDMI_RX_PHY_REGD13_p2_st_ro_g(data)                                 (0x0007C000&((data)<<14))
#define  DFE_HDMI_RX_PHY_REGD13_p2_en_ro_g(data)                                 (0x00003C00&((data)<<10))
#define  DFE_HDMI_RX_PHY_REGD13_p2_st_ro_b(data)                                 (0x000001F0&((data)<<4))
#define  DFE_HDMI_RX_PHY_REGD13_p2_en_ro_b(data)                                 (0x0000000F&(data))
#define  DFE_HDMI_RX_PHY_REGD13_get_p2_st_ro_r(data)                             ((0x1F000000&(data))>>24)
#define  DFE_HDMI_RX_PHY_REGD13_get_p2_en_ro_r(data)                             ((0x00F00000&(data))>>20)
#define  DFE_HDMI_RX_PHY_REGD13_get_p2_st_ro_g(data)                             ((0x0007C000&(data))>>14)
#define  DFE_HDMI_RX_PHY_REGD13_get_p2_en_ro_g(data)                             ((0x00003C00&(data))>>10)
#define  DFE_HDMI_RX_PHY_REGD13_get_p2_st_ro_b(data)                             ((0x000001F0&(data))>>4)
#define  DFE_HDMI_RX_PHY_REGD13_get_p2_en_ro_b(data)                             (0x0000000F&(data))

#define  DFE_HDMI_RX_PHY_REGD14                                                  0x1800DB54
#define  DFE_HDMI_RX_PHY_REGD14_reg_addr                                         "0xB800DB54"
#define  DFE_HDMI_RX_PHY_REGD14_reg                                              0xB800DB54
#define  DFE_HDMI_RX_PHY_REGD14_inst_addr                                        "0x0050"
#define  set_DFE_HDMI_RX_PHY_REGD14_reg(data)                                    (*((volatile unsigned int*)DFE_HDMI_RX_PHY_REGD14_reg)=data)
#define  get_DFE_HDMI_RX_PHY_REGD14_reg                                          (*((volatile unsigned int*)DFE_HDMI_RX_PHY_REGD14_reg))
#define  DFE_HDMI_RX_PHY_REGD14_p2_er_count_r_shift                              (20)
#define  DFE_HDMI_RX_PHY_REGD14_p2_er_count_g_shift                              (10)
#define  DFE_HDMI_RX_PHY_REGD14_p2_er_count_b_shift                              (0)
#define  DFE_HDMI_RX_PHY_REGD14_p2_er_count_r_mask                               (0x3FF00000)
#define  DFE_HDMI_RX_PHY_REGD14_p2_er_count_g_mask                               (0x000FFC00)
#define  DFE_HDMI_RX_PHY_REGD14_p2_er_count_b_mask                               (0x000003FF)
#define  DFE_HDMI_RX_PHY_REGD14_p2_er_count_r(data)                              (0x3FF00000&((data)<<20))
#define  DFE_HDMI_RX_PHY_REGD14_p2_er_count_g(data)                              (0x000FFC00&((data)<<10))
#define  DFE_HDMI_RX_PHY_REGD14_p2_er_count_b(data)                              (0x000003FF&(data))
#define  DFE_HDMI_RX_PHY_REGD14_get_p2_er_count_r(data)                          ((0x3FF00000&(data))>>20)
#define  DFE_HDMI_RX_PHY_REGD14_get_p2_er_count_g(data)                          ((0x000FFC00&(data))>>10)
#define  DFE_HDMI_RX_PHY_REGD14_get_p2_er_count_b(data)                          (0x000003FF&(data))

#define  DFE_HDMI_RX_PHY_REGD15                                                  0x1800DB58
#define  DFE_HDMI_RX_PHY_REGD15_reg_addr                                         "0xB800DB58"
#define  DFE_HDMI_RX_PHY_REGD15_reg                                              0xB800DB58
#define  DFE_HDMI_RX_PHY_REGD15_inst_addr                                        "0x0051"
#define  set_DFE_HDMI_RX_PHY_REGD15_reg(data)                                    (*((volatile unsigned int*)DFE_HDMI_RX_PHY_REGD15_reg)=data)
#define  get_DFE_HDMI_RX_PHY_REGD15_reg                                          (*((volatile unsigned int*)DFE_HDMI_RX_PHY_REGD15_reg))
#define  DFE_HDMI_RX_PHY_REGD15_reg_p0_bypass_clk_rdy_shift                      (31)
#define  DFE_HDMI_RX_PHY_REGD15_reg_p0_bypass_eqen_rdy_shift                     (30)
#define  DFE_HDMI_RX_PHY_REGD15_reg_p0_bypass_data_rdy_shift                     (29)
#define  DFE_HDMI_RX_PHY_REGD15_reg_p0_bypass_pi_shift                           (28)
#define  DFE_HDMI_RX_PHY_REGD15_reg_p0_data_rdy_time_shift                       (24)
#define  DFE_HDMI_RX_PHY_REGD15_reg_p0_en_clkout_manual_shift                    (23)
#define  DFE_HDMI_RX_PHY_REGD15_reg_p0_en_eqen_manual_shift                      (22)
#define  DFE_HDMI_RX_PHY_REGD15_reg_p0_en_data_manual_shift                      (21)
#define  DFE_HDMI_RX_PHY_REGD15_reg_p0_eqen_rdy_time_shift                       (17)
#define  DFE_HDMI_RX_PHY_REGD15_reg_p0_order_shift                               (16)
#define  DFE_HDMI_RX_PHY_REGD15_reg_p0_pll_wd_base_time_shift                    (13)
#define  DFE_HDMI_RX_PHY_REGD15_reg_p0_pll_wd_en_shift                           (12)
#define  DFE_HDMI_RX_PHY_REGD15_reg_p0_pll_wd_rst_wid_shift                      (10)
#define  DFE_HDMI_RX_PHY_REGD15_reg_p0_pll_wd_time_rdy_shift                     (8)
#define  DFE_HDMI_RX_PHY_REGD15_reg_p0_acdr_l0_en_shift                          (7)
#define  DFE_HDMI_RX_PHY_REGD15_reg_p0_bypass_eqen_rdy_l0_shift                  (6)
#define  DFE_HDMI_RX_PHY_REGD15_reg_p0_bypass_data_rdy_l0_shift                  (5)
#define  DFE_HDMI_RX_PHY_REGD15_reg_p0_en_eqen_manual_l0_shift                   (4)
#define  DFE_HDMI_RX_PHY_REGD15_reg_p0_en_data_manual_l0_shift                   (3)
#define  DFE_HDMI_RX_PHY_REGD15_p0_pll_wd_ckrdy_ro_shift                         (2)
#define  DFE_HDMI_RX_PHY_REGD15_p0_pll_wd_rst_wc_shift                           (1)
#define  DFE_HDMI_RX_PHY_REGD15_p0_wdog_rst_n_shift                              (0)
#define  DFE_HDMI_RX_PHY_REGD15_reg_p0_bypass_clk_rdy_mask                       (0x80000000)
#define  DFE_HDMI_RX_PHY_REGD15_reg_p0_bypass_eqen_rdy_mask                      (0x40000000)
#define  DFE_HDMI_RX_PHY_REGD15_reg_p0_bypass_data_rdy_mask                      (0x20000000)
#define  DFE_HDMI_RX_PHY_REGD15_reg_p0_bypass_pi_mask                            (0x10000000)
#define  DFE_HDMI_RX_PHY_REGD15_reg_p0_data_rdy_time_mask                        (0x0F000000)
#define  DFE_HDMI_RX_PHY_REGD15_reg_p0_en_clkout_manual_mask                     (0x00800000)
#define  DFE_HDMI_RX_PHY_REGD15_reg_p0_en_eqen_manual_mask                       (0x00400000)
#define  DFE_HDMI_RX_PHY_REGD15_reg_p0_en_data_manual_mask                       (0x00200000)
#define  DFE_HDMI_RX_PHY_REGD15_reg_p0_eqen_rdy_time_mask                        (0x001E0000)
#define  DFE_HDMI_RX_PHY_REGD15_reg_p0_order_mask                                (0x00010000)
#define  DFE_HDMI_RX_PHY_REGD15_reg_p0_pll_wd_base_time_mask                     (0x0000E000)
#define  DFE_HDMI_RX_PHY_REGD15_reg_p0_pll_wd_en_mask                            (0x00001000)
#define  DFE_HDMI_RX_PHY_REGD15_reg_p0_pll_wd_rst_wid_mask                       (0x00000C00)
#define  DFE_HDMI_RX_PHY_REGD15_reg_p0_pll_wd_time_rdy_mask                      (0x00000300)
#define  DFE_HDMI_RX_PHY_REGD15_reg_p0_acdr_l0_en_mask                           (0x00000080)
#define  DFE_HDMI_RX_PHY_REGD15_reg_p0_bypass_eqen_rdy_l0_mask                   (0x00000040)
#define  DFE_HDMI_RX_PHY_REGD15_reg_p0_bypass_data_rdy_l0_mask                   (0x00000020)
#define  DFE_HDMI_RX_PHY_REGD15_reg_p0_en_eqen_manual_l0_mask                    (0x00000010)
#define  DFE_HDMI_RX_PHY_REGD15_reg_p0_en_data_manual_l0_mask                    (0x00000008)
#define  DFE_HDMI_RX_PHY_REGD15_p0_pll_wd_ckrdy_ro_mask                          (0x00000004)
#define  DFE_HDMI_RX_PHY_REGD15_p0_pll_wd_rst_wc_mask                            (0x00000002)
#define  DFE_HDMI_RX_PHY_REGD15_p0_wdog_rst_n_mask                               (0x00000001)
#define  DFE_HDMI_RX_PHY_REGD15_reg_p0_bypass_clk_rdy(data)                      (0x80000000&((data)<<31))
#define  DFE_HDMI_RX_PHY_REGD15_reg_p0_bypass_eqen_rdy(data)                     (0x40000000&((data)<<30))
#define  DFE_HDMI_RX_PHY_REGD15_reg_p0_bypass_data_rdy(data)                     (0x20000000&((data)<<29))
#define  DFE_HDMI_RX_PHY_REGD15_reg_p0_bypass_pi(data)                           (0x10000000&((data)<<28))
#define  DFE_HDMI_RX_PHY_REGD15_reg_p0_data_rdy_time(data)                       (0x0F000000&((data)<<24))
#define  DFE_HDMI_RX_PHY_REGD15_reg_p0_en_clkout_manual(data)                    (0x00800000&((data)<<23))
#define  DFE_HDMI_RX_PHY_REGD15_reg_p0_en_eqen_manual(data)                      (0x00400000&((data)<<22))
#define  DFE_HDMI_RX_PHY_REGD15_reg_p0_en_data_manual(data)                      (0x00200000&((data)<<21))
#define  DFE_HDMI_RX_PHY_REGD15_reg_p0_eqen_rdy_time(data)                       (0x001E0000&((data)<<17))
#define  DFE_HDMI_RX_PHY_REGD15_reg_p0_order(data)                               (0x00010000&((data)<<16))
#define  DFE_HDMI_RX_PHY_REGD15_reg_p0_pll_wd_base_time(data)                    (0x0000E000&((data)<<13))
#define  DFE_HDMI_RX_PHY_REGD15_reg_p0_pll_wd_en(data)                           (0x00001000&((data)<<12))
#define  DFE_HDMI_RX_PHY_REGD15_reg_p0_pll_wd_rst_wid(data)                      (0x00000C00&((data)<<10))
#define  DFE_HDMI_RX_PHY_REGD15_reg_p0_pll_wd_time_rdy(data)                     (0x00000300&((data)<<8))
#define  DFE_HDMI_RX_PHY_REGD15_reg_p0_acdr_l0_en(data)                          (0x00000080&((data)<<7))
#define  DFE_HDMI_RX_PHY_REGD15_reg_p0_bypass_eqen_rdy_l0(data)                  (0x00000040&((data)<<6))
#define  DFE_HDMI_RX_PHY_REGD15_reg_p0_bypass_data_rdy_l0(data)                  (0x00000020&((data)<<5))
#define  DFE_HDMI_RX_PHY_REGD15_reg_p0_en_eqen_manual_l0(data)                   (0x00000010&((data)<<4))
#define  DFE_HDMI_RX_PHY_REGD15_reg_p0_en_data_manual_l0(data)                   (0x00000008&((data)<<3))
#define  DFE_HDMI_RX_PHY_REGD15_p0_pll_wd_ckrdy_ro(data)                         (0x00000004&((data)<<2))
#define  DFE_HDMI_RX_PHY_REGD15_p0_pll_wd_rst_wc(data)                           (0x00000002&((data)<<1))
#define  DFE_HDMI_RX_PHY_REGD15_p0_wdog_rst_n(data)                              (0x00000001&(data))
#define  DFE_HDMI_RX_PHY_REGD15_get_reg_p0_bypass_clk_rdy(data)                  ((0x80000000&(data))>>31)
#define  DFE_HDMI_RX_PHY_REGD15_get_reg_p0_bypass_eqen_rdy(data)                 ((0x40000000&(data))>>30)
#define  DFE_HDMI_RX_PHY_REGD15_get_reg_p0_bypass_data_rdy(data)                 ((0x20000000&(data))>>29)
#define  DFE_HDMI_RX_PHY_REGD15_get_reg_p0_bypass_pi(data)                       ((0x10000000&(data))>>28)
#define  DFE_HDMI_RX_PHY_REGD15_get_reg_p0_data_rdy_time(data)                   ((0x0F000000&(data))>>24)
#define  DFE_HDMI_RX_PHY_REGD15_get_reg_p0_en_clkout_manual(data)                ((0x00800000&(data))>>23)
#define  DFE_HDMI_RX_PHY_REGD15_get_reg_p0_en_eqen_manual(data)                  ((0x00400000&(data))>>22)
#define  DFE_HDMI_RX_PHY_REGD15_get_reg_p0_en_data_manual(data)                  ((0x00200000&(data))>>21)
#define  DFE_HDMI_RX_PHY_REGD15_get_reg_p0_eqen_rdy_time(data)                   ((0x001E0000&(data))>>17)
#define  DFE_HDMI_RX_PHY_REGD15_get_reg_p0_order(data)                           ((0x00010000&(data))>>16)
#define  DFE_HDMI_RX_PHY_REGD15_get_reg_p0_pll_wd_base_time(data)                ((0x0000E000&(data))>>13)
#define  DFE_HDMI_RX_PHY_REGD15_get_reg_p0_pll_wd_en(data)                       ((0x00001000&(data))>>12)
#define  DFE_HDMI_RX_PHY_REGD15_get_reg_p0_pll_wd_rst_wid(data)                  ((0x00000C00&(data))>>10)
#define  DFE_HDMI_RX_PHY_REGD15_get_reg_p0_pll_wd_time_rdy(data)                 ((0x00000300&(data))>>8)
#define  DFE_HDMI_RX_PHY_REGD15_get_reg_p0_acdr_l0_en(data)                      ((0x00000080&(data))>>7)
#define  DFE_HDMI_RX_PHY_REGD15_get_reg_p0_bypass_eqen_rdy_l0(data)              ((0x00000040&(data))>>6)
#define  DFE_HDMI_RX_PHY_REGD15_get_reg_p0_bypass_data_rdy_l0(data)              ((0x00000020&(data))>>5)
#define  DFE_HDMI_RX_PHY_REGD15_get_reg_p0_en_eqen_manual_l0(data)               ((0x00000010&(data))>>4)
#define  DFE_HDMI_RX_PHY_REGD15_get_reg_p0_en_data_manual_l0(data)               ((0x00000008&(data))>>3)
#define  DFE_HDMI_RX_PHY_REGD15_get_p0_pll_wd_ckrdy_ro(data)                     ((0x00000004&(data))>>2)
#define  DFE_HDMI_RX_PHY_REGD15_get_p0_pll_wd_rst_wc(data)                       ((0x00000002&(data))>>1)
#define  DFE_HDMI_RX_PHY_REGD15_get_p0_wdog_rst_n(data)                          (0x00000001&(data))

#define  DFE_HDMI_RX_PHY_REGD16                                                  0x1800DB5C
#define  DFE_HDMI_RX_PHY_REGD16_reg_addr                                         "0xB800DB5C"
#define  DFE_HDMI_RX_PHY_REGD16_reg                                              0xB800DB5C
#define  DFE_HDMI_RX_PHY_REGD16_inst_addr                                        "0x0052"
#define  set_DFE_HDMI_RX_PHY_REGD16_reg(data)                                    (*((volatile unsigned int*)DFE_HDMI_RX_PHY_REGD16_reg)=data)
#define  get_DFE_HDMI_RX_PHY_REGD16_reg                                          (*((volatile unsigned int*)DFE_HDMI_RX_PHY_REGD16_reg))
#define  DFE_HDMI_RX_PHY_REGD16_reg_p0_wd_sdm_en_shift                           (31)
#define  DFE_HDMI_RX_PHY_REGD16_reg_p0_f_code_shift                              (16)
#define  DFE_HDMI_RX_PHY_REGD16_reg_p0_n_code_shift                              (0)
#define  DFE_HDMI_RX_PHY_REGD16_reg_p0_wd_sdm_en_mask                            (0x80000000)
#define  DFE_HDMI_RX_PHY_REGD16_reg_p0_f_code_mask                               (0x0FFF0000)
#define  DFE_HDMI_RX_PHY_REGD16_reg_p0_n_code_mask                               (0x000001FF)
#define  DFE_HDMI_RX_PHY_REGD16_reg_p0_wd_sdm_en(data)                           (0x80000000&((data)<<31))
#define  DFE_HDMI_RX_PHY_REGD16_reg_p0_f_code(data)                              (0x0FFF0000&((data)<<16))
#define  DFE_HDMI_RX_PHY_REGD16_reg_p0_n_code(data)                              (0x000001FF&(data))
#define  DFE_HDMI_RX_PHY_REGD16_get_reg_p0_wd_sdm_en(data)                       ((0x80000000&(data))>>31)
#define  DFE_HDMI_RX_PHY_REGD16_get_reg_p0_f_code(data)                          ((0x0FFF0000&(data))>>16)
#define  DFE_HDMI_RX_PHY_REGD16_get_reg_p0_n_code(data)                          (0x000001FF&(data))

#define  DFE_HDMI_RX_PHY_REGD17                                                  0x1800DB60
#define  DFE_HDMI_RX_PHY_REGD17_reg_addr                                         "0xB800DB60"
#define  DFE_HDMI_RX_PHY_REGD17_reg                                              0xB800DB60
#define  DFE_HDMI_RX_PHY_REGD17_inst_addr                                        "0x0053"
#define  set_DFE_HDMI_RX_PHY_REGD17_reg(data)                                    (*((volatile unsigned int*)DFE_HDMI_RX_PHY_REGD17_reg)=data)
#define  get_DFE_HDMI_RX_PHY_REGD17_reg                                          (*((volatile unsigned int*)DFE_HDMI_RX_PHY_REGD17_reg))
#define  DFE_HDMI_RX_PHY_REGD17_reg_p1_bypass_clk_rdy_shift                      (31)
#define  DFE_HDMI_RX_PHY_REGD17_reg_p1_bypass_eqen_rdy_shift                     (30)
#define  DFE_HDMI_RX_PHY_REGD17_reg_p1_bypass_data_rdy_shift                     (29)
#define  DFE_HDMI_RX_PHY_REGD17_reg_p1_bypass_pi_shift                           (28)
#define  DFE_HDMI_RX_PHY_REGD17_reg_p1_data_rdy_time_shift                       (24)
#define  DFE_HDMI_RX_PHY_REGD17_reg_p1_en_clkout_manual_shift                    (23)
#define  DFE_HDMI_RX_PHY_REGD17_reg_p1_en_eqen_manual_shift                      (22)
#define  DFE_HDMI_RX_PHY_REGD17_reg_p1_en_data_manual_shift                      (21)
#define  DFE_HDMI_RX_PHY_REGD17_reg_p1_eqen_rdy_time_shift                       (17)
#define  DFE_HDMI_RX_PHY_REGD17_reg_p1_order_shift                               (16)
#define  DFE_HDMI_RX_PHY_REGD17_reg_p1_pll_wd_base_time_shift                    (13)
#define  DFE_HDMI_RX_PHY_REGD17_reg_p1_pll_wd_en_shift                           (12)
#define  DFE_HDMI_RX_PHY_REGD17_reg_p1_pll_wd_rst_wid_shift                      (10)
#define  DFE_HDMI_RX_PHY_REGD17_reg_p1_pll_wd_time_rdy_shift                     (8)
#define  DFE_HDMI_RX_PHY_REGD17_reg_p1_acdr_l0_en_shift                          (7)
#define  DFE_HDMI_RX_PHY_REGD17_reg_p1_bypass_eqen_rdy_l0_shift                  (6)
#define  DFE_HDMI_RX_PHY_REGD17_reg_p1_bypass_data_rdy_l0_shift                  (5)
#define  DFE_HDMI_RX_PHY_REGD17_reg_p1_en_eqen_manual_l0_shift                   (4)
#define  DFE_HDMI_RX_PHY_REGD17_reg_p1_en_data_manual_l0_shift                   (3)
#define  DFE_HDMI_RX_PHY_REGD17_p1_pll_wd_ckrdy_ro_shift                         (2)
#define  DFE_HDMI_RX_PHY_REGD17_p1_pll_wd_rst_wc_shift                           (1)
#define  DFE_HDMI_RX_PHY_REGD17_p1_wdog_rst_n_shift                              (0)
#define  DFE_HDMI_RX_PHY_REGD17_reg_p1_bypass_clk_rdy_mask                       (0x80000000)
#define  DFE_HDMI_RX_PHY_REGD17_reg_p1_bypass_eqen_rdy_mask                      (0x40000000)
#define  DFE_HDMI_RX_PHY_REGD17_reg_p1_bypass_data_rdy_mask                      (0x20000000)
#define  DFE_HDMI_RX_PHY_REGD17_reg_p1_bypass_pi_mask                            (0x10000000)
#define  DFE_HDMI_RX_PHY_REGD17_reg_p1_data_rdy_time_mask                        (0x0F000000)
#define  DFE_HDMI_RX_PHY_REGD17_reg_p1_en_clkout_manual_mask                     (0x00800000)
#define  DFE_HDMI_RX_PHY_REGD17_reg_p1_en_eqen_manual_mask                       (0x00400000)
#define  DFE_HDMI_RX_PHY_REGD17_reg_p1_en_data_manual_mask                       (0x00200000)
#define  DFE_HDMI_RX_PHY_REGD17_reg_p1_eqen_rdy_time_mask                        (0x001E0000)
#define  DFE_HDMI_RX_PHY_REGD17_reg_p1_order_mask                                (0x00010000)
#define  DFE_HDMI_RX_PHY_REGD17_reg_p1_pll_wd_base_time_mask                     (0x0000E000)
#define  DFE_HDMI_RX_PHY_REGD17_reg_p1_pll_wd_en_mask                            (0x00001000)
#define  DFE_HDMI_RX_PHY_REGD17_reg_p1_pll_wd_rst_wid_mask                       (0x00000C00)
#define  DFE_HDMI_RX_PHY_REGD17_reg_p1_pll_wd_time_rdy_mask                      (0x00000300)
#define  DFE_HDMI_RX_PHY_REGD17_reg_p1_acdr_l0_en_mask                           (0x00000080)
#define  DFE_HDMI_RX_PHY_REGD17_reg_p1_bypass_eqen_rdy_l0_mask                   (0x00000040)
#define  DFE_HDMI_RX_PHY_REGD17_reg_p1_bypass_data_rdy_l0_mask                   (0x00000020)
#define  DFE_HDMI_RX_PHY_REGD17_reg_p1_en_eqen_manual_l0_mask                    (0x00000010)
#define  DFE_HDMI_RX_PHY_REGD17_reg_p1_en_data_manual_l0_mask                    (0x00000008)
#define  DFE_HDMI_RX_PHY_REGD17_p1_pll_wd_ckrdy_ro_mask                          (0x00000004)
#define  DFE_HDMI_RX_PHY_REGD17_p1_pll_wd_rst_wc_mask                            (0x00000002)
#define  DFE_HDMI_RX_PHY_REGD17_p1_wdog_rst_n_mask                               (0x00000001)
#define  DFE_HDMI_RX_PHY_REGD17_reg_p1_bypass_clk_rdy(data)                      (0x80000000&((data)<<31))
#define  DFE_HDMI_RX_PHY_REGD17_reg_p1_bypass_eqen_rdy(data)                     (0x40000000&((data)<<30))
#define  DFE_HDMI_RX_PHY_REGD17_reg_p1_bypass_data_rdy(data)                     (0x20000000&((data)<<29))
#define  DFE_HDMI_RX_PHY_REGD17_reg_p1_bypass_pi(data)                           (0x10000000&((data)<<28))
#define  DFE_HDMI_RX_PHY_REGD17_reg_p1_data_rdy_time(data)                       (0x0F000000&((data)<<24))
#define  DFE_HDMI_RX_PHY_REGD17_reg_p1_en_clkout_manual(data)                    (0x00800000&((data)<<23))
#define  DFE_HDMI_RX_PHY_REGD17_reg_p1_en_eqen_manual(data)                      (0x00400000&((data)<<22))
#define  DFE_HDMI_RX_PHY_REGD17_reg_p1_en_data_manual(data)                      (0x00200000&((data)<<21))
#define  DFE_HDMI_RX_PHY_REGD17_reg_p1_eqen_rdy_time(data)                       (0x001E0000&((data)<<17))
#define  DFE_HDMI_RX_PHY_REGD17_reg_p1_order(data)                               (0x00010000&((data)<<16))
#define  DFE_HDMI_RX_PHY_REGD17_reg_p1_pll_wd_base_time(data)                    (0x0000E000&((data)<<13))
#define  DFE_HDMI_RX_PHY_REGD17_reg_p1_pll_wd_en(data)                           (0x00001000&((data)<<12))
#define  DFE_HDMI_RX_PHY_REGD17_reg_p1_pll_wd_rst_wid(data)                      (0x00000C00&((data)<<10))
#define  DFE_HDMI_RX_PHY_REGD17_reg_p1_pll_wd_time_rdy(data)                     (0x00000300&((data)<<8))
#define  DFE_HDMI_RX_PHY_REGD17_reg_p1_acdr_l0_en(data)                          (0x00000080&((data)<<7))
#define  DFE_HDMI_RX_PHY_REGD17_reg_p1_bypass_eqen_rdy_l0(data)                  (0x00000040&((data)<<6))
#define  DFE_HDMI_RX_PHY_REGD17_reg_p1_bypass_data_rdy_l0(data)                  (0x00000020&((data)<<5))
#define  DFE_HDMI_RX_PHY_REGD17_reg_p1_en_eqen_manual_l0(data)                   (0x00000010&((data)<<4))
#define  DFE_HDMI_RX_PHY_REGD17_reg_p1_en_data_manual_l0(data)                   (0x00000008&((data)<<3))
#define  DFE_HDMI_RX_PHY_REGD17_p1_pll_wd_ckrdy_ro(data)                         (0x00000004&((data)<<2))
#define  DFE_HDMI_RX_PHY_REGD17_p1_pll_wd_rst_wc(data)                           (0x00000002&((data)<<1))
#define  DFE_HDMI_RX_PHY_REGD17_p1_wdog_rst_n(data)                              (0x00000001&(data))
#define  DFE_HDMI_RX_PHY_REGD17_get_reg_p1_bypass_clk_rdy(data)                  ((0x80000000&(data))>>31)
#define  DFE_HDMI_RX_PHY_REGD17_get_reg_p1_bypass_eqen_rdy(data)                 ((0x40000000&(data))>>30)
#define  DFE_HDMI_RX_PHY_REGD17_get_reg_p1_bypass_data_rdy(data)                 ((0x20000000&(data))>>29)
#define  DFE_HDMI_RX_PHY_REGD17_get_reg_p1_bypass_pi(data)                       ((0x10000000&(data))>>28)
#define  DFE_HDMI_RX_PHY_REGD17_get_reg_p1_data_rdy_time(data)                   ((0x0F000000&(data))>>24)
#define  DFE_HDMI_RX_PHY_REGD17_get_reg_p1_en_clkout_manual(data)                ((0x00800000&(data))>>23)
#define  DFE_HDMI_RX_PHY_REGD17_get_reg_p1_en_eqen_manual(data)                  ((0x00400000&(data))>>22)
#define  DFE_HDMI_RX_PHY_REGD17_get_reg_p1_en_data_manual(data)                  ((0x00200000&(data))>>21)
#define  DFE_HDMI_RX_PHY_REGD17_get_reg_p1_eqen_rdy_time(data)                   ((0x001E0000&(data))>>17)
#define  DFE_HDMI_RX_PHY_REGD17_get_reg_p1_order(data)                           ((0x00010000&(data))>>16)
#define  DFE_HDMI_RX_PHY_REGD17_get_reg_p1_pll_wd_base_time(data)                ((0x0000E000&(data))>>13)
#define  DFE_HDMI_RX_PHY_REGD17_get_reg_p1_pll_wd_en(data)                       ((0x00001000&(data))>>12)
#define  DFE_HDMI_RX_PHY_REGD17_get_reg_p1_pll_wd_rst_wid(data)                  ((0x00000C00&(data))>>10)
#define  DFE_HDMI_RX_PHY_REGD17_get_reg_p1_pll_wd_time_rdy(data)                 ((0x00000300&(data))>>8)
#define  DFE_HDMI_RX_PHY_REGD17_get_reg_p1_acdr_l0_en(data)                      ((0x00000080&(data))>>7)
#define  DFE_HDMI_RX_PHY_REGD17_get_reg_p1_bypass_eqen_rdy_l0(data)              ((0x00000040&(data))>>6)
#define  DFE_HDMI_RX_PHY_REGD17_get_reg_p1_bypass_data_rdy_l0(data)              ((0x00000020&(data))>>5)
#define  DFE_HDMI_RX_PHY_REGD17_get_reg_p1_en_eqen_manual_l0(data)               ((0x00000010&(data))>>4)
#define  DFE_HDMI_RX_PHY_REGD17_get_reg_p1_en_data_manual_l0(data)               ((0x00000008&(data))>>3)
#define  DFE_HDMI_RX_PHY_REGD17_get_p1_pll_wd_ckrdy_ro(data)                     ((0x00000004&(data))>>2)
#define  DFE_HDMI_RX_PHY_REGD17_get_p1_pll_wd_rst_wc(data)                       ((0x00000002&(data))>>1)
#define  DFE_HDMI_RX_PHY_REGD17_get_p1_wdog_rst_n(data)                          (0x00000001&(data))

#define  DFE_HDMI_RX_PHY_REGD18                                                  0x1800DB64
#define  DFE_HDMI_RX_PHY_REGD18_reg_addr                                         "0xB800DB64"
#define  DFE_HDMI_RX_PHY_REGD18_reg                                              0xB800DB64
#define  DFE_HDMI_RX_PHY_REGD18_inst_addr                                        "0x0054"
#define  set_DFE_HDMI_RX_PHY_REGD18_reg(data)                                    (*((volatile unsigned int*)DFE_HDMI_RX_PHY_REGD18_reg)=data)
#define  get_DFE_HDMI_RX_PHY_REGD18_reg                                          (*((volatile unsigned int*)DFE_HDMI_RX_PHY_REGD18_reg))
#define  DFE_HDMI_RX_PHY_REGD18_reg_p1_wd_sdm_en_shift                           (31)
#define  DFE_HDMI_RX_PHY_REGD18_reg_p1_f_code_shift                              (16)
#define  DFE_HDMI_RX_PHY_REGD18_reg_p1_n_code_shift                              (0)
#define  DFE_HDMI_RX_PHY_REGD18_reg_p1_wd_sdm_en_mask                            (0x80000000)
#define  DFE_HDMI_RX_PHY_REGD18_reg_p1_f_code_mask                               (0x0FFF0000)
#define  DFE_HDMI_RX_PHY_REGD18_reg_p1_n_code_mask                               (0x000001FF)
#define  DFE_HDMI_RX_PHY_REGD18_reg_p1_wd_sdm_en(data)                           (0x80000000&((data)<<31))
#define  DFE_HDMI_RX_PHY_REGD18_reg_p1_f_code(data)                              (0x0FFF0000&((data)<<16))
#define  DFE_HDMI_RX_PHY_REGD18_reg_p1_n_code(data)                              (0x000001FF&(data))
#define  DFE_HDMI_RX_PHY_REGD18_get_reg_p1_wd_sdm_en(data)                       ((0x80000000&(data))>>31)
#define  DFE_HDMI_RX_PHY_REGD18_get_reg_p1_f_code(data)                          ((0x0FFF0000&(data))>>16)
#define  DFE_HDMI_RX_PHY_REGD18_get_reg_p1_n_code(data)                          (0x000001FF&(data))

#define  DFE_HDMI_RX_PHY_REGD19                                                  0x1800DB68
#define  DFE_HDMI_RX_PHY_REGD19_reg_addr                                         "0xB800DB68"
#define  DFE_HDMI_RX_PHY_REGD19_reg                                              0xB800DB68
#define  DFE_HDMI_RX_PHY_REGD19_inst_addr                                        "0x0055"
#define  set_DFE_HDMI_RX_PHY_REGD19_reg(data)                                    (*((volatile unsigned int*)DFE_HDMI_RX_PHY_REGD19_reg)=data)
#define  get_DFE_HDMI_RX_PHY_REGD19_reg                                          (*((volatile unsigned int*)DFE_HDMI_RX_PHY_REGD19_reg))
#define  DFE_HDMI_RX_PHY_REGD19_reg_p2_bypass_clk_rdy_shift                      (31)
#define  DFE_HDMI_RX_PHY_REGD19_reg_p2_bypass_eqen_rdy_shift                     (30)
#define  DFE_HDMI_RX_PHY_REGD19_reg_p2_bypass_data_rdy_shift                     (29)
#define  DFE_HDMI_RX_PHY_REGD19_reg_p2_bypass_pi_shift                           (28)
#define  DFE_HDMI_RX_PHY_REGD19_reg_p2_data_rdy_time_shift                       (24)
#define  DFE_HDMI_RX_PHY_REGD19_reg_p2_en_clkout_manual_shift                    (23)
#define  DFE_HDMI_RX_PHY_REGD19_reg_p2_en_eqen_manual_shift                      (22)
#define  DFE_HDMI_RX_PHY_REGD19_reg_p2_en_data_manual_shift                      (21)
#define  DFE_HDMI_RX_PHY_REGD19_reg_p2_eqen_rdy_time_shift                       (17)
#define  DFE_HDMI_RX_PHY_REGD19_reg_p2_order_shift                               (16)
#define  DFE_HDMI_RX_PHY_REGD19_reg_p2_pll_wd_base_time_shift                    (13)
#define  DFE_HDMI_RX_PHY_REGD19_reg_p2_pll_wd_en_shift                           (12)
#define  DFE_HDMI_RX_PHY_REGD19_reg_p2_pll_wd_rst_wid_shift                      (10)
#define  DFE_HDMI_RX_PHY_REGD19_reg_p2_pll_wd_time_rdy_shift                     (8)
#define  DFE_HDMI_RX_PHY_REGD19_reg_p2_acdr_l0_en_shift                          (7)
#define  DFE_HDMI_RX_PHY_REGD19_reg_p2_bypass_eqen_rdy_l0_shift                  (6)
#define  DFE_HDMI_RX_PHY_REGD19_reg_p2_bypass_data_rdy_l0_shift                  (5)
#define  DFE_HDMI_RX_PHY_REGD19_reg_p2_en_eqen_manual_l0_shift                   (4)
#define  DFE_HDMI_RX_PHY_REGD19_reg_p2_en_data_manual_l0_shift                   (3)
#define  DFE_HDMI_RX_PHY_REGD19_p2_pll_wd_ckrdy_ro_shift                         (2)
#define  DFE_HDMI_RX_PHY_REGD19_p2_pll_wd_rst_wc_shift                           (1)
#define  DFE_HDMI_RX_PHY_REGD19_p2_wdog_rst_n_shift                              (0)
#define  DFE_HDMI_RX_PHY_REGD19_reg_p2_bypass_clk_rdy_mask                       (0x80000000)
#define  DFE_HDMI_RX_PHY_REGD19_reg_p2_bypass_eqen_rdy_mask                      (0x40000000)
#define  DFE_HDMI_RX_PHY_REGD19_reg_p2_bypass_data_rdy_mask                      (0x20000000)
#define  DFE_HDMI_RX_PHY_REGD19_reg_p2_bypass_pi_mask                            (0x10000000)
#define  DFE_HDMI_RX_PHY_REGD19_reg_p2_data_rdy_time_mask                        (0x0F000000)
#define  DFE_HDMI_RX_PHY_REGD19_reg_p2_en_clkout_manual_mask                     (0x00800000)
#define  DFE_HDMI_RX_PHY_REGD19_reg_p2_en_eqen_manual_mask                       (0x00400000)
#define  DFE_HDMI_RX_PHY_REGD19_reg_p2_en_data_manual_mask                       (0x00200000)
#define  DFE_HDMI_RX_PHY_REGD19_reg_p2_eqen_rdy_time_mask                        (0x001E0000)
#define  DFE_HDMI_RX_PHY_REGD19_reg_p2_order_mask                                (0x00010000)
#define  DFE_HDMI_RX_PHY_REGD19_reg_p2_pll_wd_base_time_mask                     (0x0000E000)
#define  DFE_HDMI_RX_PHY_REGD19_reg_p2_pll_wd_en_mask                            (0x00001000)
#define  DFE_HDMI_RX_PHY_REGD19_reg_p2_pll_wd_rst_wid_mask                       (0x00000C00)
#define  DFE_HDMI_RX_PHY_REGD19_reg_p2_pll_wd_time_rdy_mask                      (0x00000300)
#define  DFE_HDMI_RX_PHY_REGD19_reg_p2_acdr_l0_en_mask                           (0x00000080)
#define  DFE_HDMI_RX_PHY_REGD19_reg_p2_bypass_eqen_rdy_l0_mask                   (0x00000040)
#define  DFE_HDMI_RX_PHY_REGD19_reg_p2_bypass_data_rdy_l0_mask                   (0x00000020)
#define  DFE_HDMI_RX_PHY_REGD19_reg_p2_en_eqen_manual_l0_mask                    (0x00000010)
#define  DFE_HDMI_RX_PHY_REGD19_reg_p2_en_data_manual_l0_mask                    (0x00000008)
#define  DFE_HDMI_RX_PHY_REGD19_p2_pll_wd_ckrdy_ro_mask                          (0x00000004)
#define  DFE_HDMI_RX_PHY_REGD19_p2_pll_wd_rst_wc_mask                            (0x00000002)
#define  DFE_HDMI_RX_PHY_REGD19_p2_wdog_rst_n_mask                               (0x00000001)
#define  DFE_HDMI_RX_PHY_REGD19_reg_p2_bypass_clk_rdy(data)                      (0x80000000&((data)<<31))
#define  DFE_HDMI_RX_PHY_REGD19_reg_p2_bypass_eqen_rdy(data)                     (0x40000000&((data)<<30))
#define  DFE_HDMI_RX_PHY_REGD19_reg_p2_bypass_data_rdy(data)                     (0x20000000&((data)<<29))
#define  DFE_HDMI_RX_PHY_REGD19_reg_p2_bypass_pi(data)                           (0x10000000&((data)<<28))
#define  DFE_HDMI_RX_PHY_REGD19_reg_p2_data_rdy_time(data)                       (0x0F000000&((data)<<24))
#define  DFE_HDMI_RX_PHY_REGD19_reg_p2_en_clkout_manual(data)                    (0x00800000&((data)<<23))
#define  DFE_HDMI_RX_PHY_REGD19_reg_p2_en_eqen_manual(data)                      (0x00400000&((data)<<22))
#define  DFE_HDMI_RX_PHY_REGD19_reg_p2_en_data_manual(data)                      (0x00200000&((data)<<21))
#define  DFE_HDMI_RX_PHY_REGD19_reg_p2_eqen_rdy_time(data)                       (0x001E0000&((data)<<17))
#define  DFE_HDMI_RX_PHY_REGD19_reg_p2_order(data)                               (0x00010000&((data)<<16))
#define  DFE_HDMI_RX_PHY_REGD19_reg_p2_pll_wd_base_time(data)                    (0x0000E000&((data)<<13))
#define  DFE_HDMI_RX_PHY_REGD19_reg_p2_pll_wd_en(data)                           (0x00001000&((data)<<12))
#define  DFE_HDMI_RX_PHY_REGD19_reg_p2_pll_wd_rst_wid(data)                      (0x00000C00&((data)<<10))
#define  DFE_HDMI_RX_PHY_REGD19_reg_p2_pll_wd_time_rdy(data)                     (0x00000300&((data)<<8))
#define  DFE_HDMI_RX_PHY_REGD19_reg_p2_acdr_l0_en(data)                          (0x00000080&((data)<<7))
#define  DFE_HDMI_RX_PHY_REGD19_reg_p2_bypass_eqen_rdy_l0(data)                  (0x00000040&((data)<<6))
#define  DFE_HDMI_RX_PHY_REGD19_reg_p2_bypass_data_rdy_l0(data)                  (0x00000020&((data)<<5))
#define  DFE_HDMI_RX_PHY_REGD19_reg_p2_en_eqen_manual_l0(data)                   (0x00000010&((data)<<4))
#define  DFE_HDMI_RX_PHY_REGD19_reg_p2_en_data_manual_l0(data)                   (0x00000008&((data)<<3))
#define  DFE_HDMI_RX_PHY_REGD19_p2_pll_wd_ckrdy_ro(data)                         (0x00000004&((data)<<2))
#define  DFE_HDMI_RX_PHY_REGD19_p2_pll_wd_rst_wc(data)                           (0x00000002&((data)<<1))
#define  DFE_HDMI_RX_PHY_REGD19_p2_wdog_rst_n(data)                              (0x00000001&(data))
#define  DFE_HDMI_RX_PHY_REGD19_get_reg_p2_bypass_clk_rdy(data)                  ((0x80000000&(data))>>31)
#define  DFE_HDMI_RX_PHY_REGD19_get_reg_p2_bypass_eqen_rdy(data)                 ((0x40000000&(data))>>30)
#define  DFE_HDMI_RX_PHY_REGD19_get_reg_p2_bypass_data_rdy(data)                 ((0x20000000&(data))>>29)
#define  DFE_HDMI_RX_PHY_REGD19_get_reg_p2_bypass_pi(data)                       ((0x10000000&(data))>>28)
#define  DFE_HDMI_RX_PHY_REGD19_get_reg_p2_data_rdy_time(data)                   ((0x0F000000&(data))>>24)
#define  DFE_HDMI_RX_PHY_REGD19_get_reg_p2_en_clkout_manual(data)                ((0x00800000&(data))>>23)
#define  DFE_HDMI_RX_PHY_REGD19_get_reg_p2_en_eqen_manual(data)                  ((0x00400000&(data))>>22)
#define  DFE_HDMI_RX_PHY_REGD19_get_reg_p2_en_data_manual(data)                  ((0x00200000&(data))>>21)
#define  DFE_HDMI_RX_PHY_REGD19_get_reg_p2_eqen_rdy_time(data)                   ((0x001E0000&(data))>>17)
#define  DFE_HDMI_RX_PHY_REGD19_get_reg_p2_order(data)                           ((0x00010000&(data))>>16)
#define  DFE_HDMI_RX_PHY_REGD19_get_reg_p2_pll_wd_base_time(data)                ((0x0000E000&(data))>>13)
#define  DFE_HDMI_RX_PHY_REGD19_get_reg_p2_pll_wd_en(data)                       ((0x00001000&(data))>>12)
#define  DFE_HDMI_RX_PHY_REGD19_get_reg_p2_pll_wd_rst_wid(data)                  ((0x00000C00&(data))>>10)
#define  DFE_HDMI_RX_PHY_REGD19_get_reg_p2_pll_wd_time_rdy(data)                 ((0x00000300&(data))>>8)
#define  DFE_HDMI_RX_PHY_REGD19_get_reg_p2_acdr_l0_en(data)                      ((0x00000080&(data))>>7)
#define  DFE_HDMI_RX_PHY_REGD19_get_reg_p2_bypass_eqen_rdy_l0(data)              ((0x00000040&(data))>>6)
#define  DFE_HDMI_RX_PHY_REGD19_get_reg_p2_bypass_data_rdy_l0(data)              ((0x00000020&(data))>>5)
#define  DFE_HDMI_RX_PHY_REGD19_get_reg_p2_en_eqen_manual_l0(data)               ((0x00000010&(data))>>4)
#define  DFE_HDMI_RX_PHY_REGD19_get_reg_p2_en_data_manual_l0(data)               ((0x00000008&(data))>>3)
#define  DFE_HDMI_RX_PHY_REGD19_get_p2_pll_wd_ckrdy_ro(data)                     ((0x00000004&(data))>>2)
#define  DFE_HDMI_RX_PHY_REGD19_get_p2_pll_wd_rst_wc(data)                       ((0x00000002&(data))>>1)
#define  DFE_HDMI_RX_PHY_REGD19_get_p2_wdog_rst_n(data)                          (0x00000001&(data))

#define  DFE_HDMI_RX_PHY_REGD20                                                  0x1800DB6C
#define  DFE_HDMI_RX_PHY_REGD20_reg_addr                                         "0xB800DB6C"
#define  DFE_HDMI_RX_PHY_REGD20_reg                                              0xB800DB6C
#define  DFE_HDMI_RX_PHY_REGD20_inst_addr                                        "0x0056"
#define  set_DFE_HDMI_RX_PHY_REGD20_reg(data)                                    (*((volatile unsigned int*)DFE_HDMI_RX_PHY_REGD20_reg)=data)
#define  get_DFE_HDMI_RX_PHY_REGD20_reg                                          (*((volatile unsigned int*)DFE_HDMI_RX_PHY_REGD20_reg))
#define  DFE_HDMI_RX_PHY_REGD20_reg_p2_wd_sdm_en_shift                           (31)
#define  DFE_HDMI_RX_PHY_REGD20_reg_p2_f_code_shift                              (16)
#define  DFE_HDMI_RX_PHY_REGD20_reg_p2_n_code_shift                              (0)
#define  DFE_HDMI_RX_PHY_REGD20_reg_p2_wd_sdm_en_mask                            (0x80000000)
#define  DFE_HDMI_RX_PHY_REGD20_reg_p2_f_code_mask                               (0x0FFF0000)
#define  DFE_HDMI_RX_PHY_REGD20_reg_p2_n_code_mask                               (0x000001FF)
#define  DFE_HDMI_RX_PHY_REGD20_reg_p2_wd_sdm_en(data)                           (0x80000000&((data)<<31))
#define  DFE_HDMI_RX_PHY_REGD20_reg_p2_f_code(data)                              (0x0FFF0000&((data)<<16))
#define  DFE_HDMI_RX_PHY_REGD20_reg_p2_n_code(data)                              (0x000001FF&(data))
#define  DFE_HDMI_RX_PHY_REGD20_get_reg_p2_wd_sdm_en(data)                       ((0x80000000&(data))>>31)
#define  DFE_HDMI_RX_PHY_REGD20_get_reg_p2_f_code(data)                          ((0x0FFF0000&(data))>>16)
#define  DFE_HDMI_RX_PHY_REGD20_get_reg_p2_n_code(data)                          (0x000001FF&(data))

#define  DFE_HDMI_RX_PHY_REGD21                                                  0x1800DB70
#define  DFE_HDMI_RX_PHY_REGD21_reg_addr                                         "0xB800DB70"
#define  DFE_HDMI_RX_PHY_REGD21_reg                                              0xB800DB70
#define  DFE_HDMI_RX_PHY_REGD21_inst_addr                                        "0x0057"
#define  set_DFE_HDMI_RX_PHY_REGD21_reg(data)                                    (*((volatile unsigned int*)DFE_HDMI_RX_PHY_REGD21_reg)=data)
#define  get_DFE_HDMI_RX_PHY_REGD21_reg                                          (*((volatile unsigned int*)DFE_HDMI_RX_PHY_REGD21_reg))
#define  DFE_HDMI_RX_PHY_REGD21_reg_p0_auto_mode_shift                           (31)
#define  DFE_HDMI_RX_PHY_REGD21_reg_p0_adp_en_manual_shift                       (30)
#define  DFE_HDMI_RX_PHY_REGD21_reg_p0_cp_en_manual_shift                        (29)
#define  DFE_HDMI_RX_PHY_REGD21_reg_p0_adap_eq_off_shift                         (28)
#define  DFE_HDMI_RX_PHY_REGD21_reg_p0_adp_time_shift                            (23)
#define  DFE_HDMI_RX_PHY_REGD21_reg_p0_calib_time_shift                          (20)
#define  DFE_HDMI_RX_PHY_REGD21_reg_p0_calib_manual_shift                        (19)
#define  DFE_HDMI_RX_PHY_REGD21_reg_p0_calib_late_shift                          (18)
#define  DFE_HDMI_RX_PHY_REGD21_reg_p0_vco_coarse_shift                          (11)
#define  DFE_HDMI_RX_PHY_REGD21_reg_p0_divide_num_shift                          (4)
#define  DFE_HDMI_RX_PHY_REGD21_reg_p0_init_time_shift                           (1)
#define  DFE_HDMI_RX_PHY_REGD21_reg_p0_auto_mode_mask                            (0x80000000)
#define  DFE_HDMI_RX_PHY_REGD21_reg_p0_adp_en_manual_mask                        (0x40000000)
#define  DFE_HDMI_RX_PHY_REGD21_reg_p0_cp_en_manual_mask                         (0x20000000)
#define  DFE_HDMI_RX_PHY_REGD21_reg_p0_adap_eq_off_mask                          (0x10000000)
#define  DFE_HDMI_RX_PHY_REGD21_reg_p0_adp_time_mask                             (0x0F800000)
#define  DFE_HDMI_RX_PHY_REGD21_reg_p0_calib_time_mask                           (0x00700000)
#define  DFE_HDMI_RX_PHY_REGD21_reg_p0_calib_manual_mask                         (0x00080000)
#define  DFE_HDMI_RX_PHY_REGD21_reg_p0_calib_late_mask                           (0x00040000)
#define  DFE_HDMI_RX_PHY_REGD21_reg_p0_vco_coarse_mask                           (0x0003F800)
#define  DFE_HDMI_RX_PHY_REGD21_reg_p0_divide_num_mask                           (0x000007F0)
#define  DFE_HDMI_RX_PHY_REGD21_reg_p0_init_time_mask                            (0x0000000E)
#define  DFE_HDMI_RX_PHY_REGD21_reg_p0_auto_mode(data)                           (0x80000000&((data)<<31))
#define  DFE_HDMI_RX_PHY_REGD21_reg_p0_adp_en_manual(data)                       (0x40000000&((data)<<30))
#define  DFE_HDMI_RX_PHY_REGD21_reg_p0_cp_en_manual(data)                        (0x20000000&((data)<<29))
#define  DFE_HDMI_RX_PHY_REGD21_reg_p0_adap_eq_off(data)                         (0x10000000&((data)<<28))
#define  DFE_HDMI_RX_PHY_REGD21_reg_p0_adp_time(data)                            (0x0F800000&((data)<<23))
#define  DFE_HDMI_RX_PHY_REGD21_reg_p0_calib_time(data)                          (0x00700000&((data)<<20))
#define  DFE_HDMI_RX_PHY_REGD21_reg_p0_calib_manual(data)                        (0x00080000&((data)<<19))
#define  DFE_HDMI_RX_PHY_REGD21_reg_p0_calib_late(data)                          (0x00040000&((data)<<18))
#define  DFE_HDMI_RX_PHY_REGD21_reg_p0_vco_coarse(data)                          (0x0003F800&((data)<<11))
#define  DFE_HDMI_RX_PHY_REGD21_reg_p0_divide_num(data)                          (0x000007F0&((data)<<4))
#define  DFE_HDMI_RX_PHY_REGD21_reg_p0_init_time(data)                           (0x0000000E&((data)<<1))
#define  DFE_HDMI_RX_PHY_REGD21_get_reg_p0_auto_mode(data)                       ((0x80000000&(data))>>31)
#define  DFE_HDMI_RX_PHY_REGD21_get_reg_p0_adp_en_manual(data)                   ((0x40000000&(data))>>30)
#define  DFE_HDMI_RX_PHY_REGD21_get_reg_p0_cp_en_manual(data)                    ((0x20000000&(data))>>29)
#define  DFE_HDMI_RX_PHY_REGD21_get_reg_p0_adap_eq_off(data)                     ((0x10000000&(data))>>28)
#define  DFE_HDMI_RX_PHY_REGD21_get_reg_p0_adp_time(data)                        ((0x0F800000&(data))>>23)
#define  DFE_HDMI_RX_PHY_REGD21_get_reg_p0_calib_time(data)                      ((0x00700000&(data))>>20)
#define  DFE_HDMI_RX_PHY_REGD21_get_reg_p0_calib_manual(data)                    ((0x00080000&(data))>>19)
#define  DFE_HDMI_RX_PHY_REGD21_get_reg_p0_calib_late(data)                      ((0x00040000&(data))>>18)
#define  DFE_HDMI_RX_PHY_REGD21_get_reg_p0_vco_coarse(data)                      ((0x0003F800&(data))>>11)
#define  DFE_HDMI_RX_PHY_REGD21_get_reg_p0_divide_num(data)                      ((0x000007F0&(data))>>4)
#define  DFE_HDMI_RX_PHY_REGD21_get_reg_p0_init_time(data)                       ((0x0000000E&(data))>>1)

#define  DFE_HDMI_RX_PHY_REGD22                                                  0x1800DB74
#define  DFE_HDMI_RX_PHY_REGD22_reg_addr                                         "0xB800DB74"
#define  DFE_HDMI_RX_PHY_REGD22_reg                                              0xB800DB74
#define  DFE_HDMI_RX_PHY_REGD22_inst_addr                                        "0x0058"
#define  set_DFE_HDMI_RX_PHY_REGD22_reg(data)                                    (*((volatile unsigned int*)DFE_HDMI_RX_PHY_REGD22_reg)=data)
#define  get_DFE_HDMI_RX_PHY_REGD22_reg                                          (*((volatile unsigned int*)DFE_HDMI_RX_PHY_REGD22_reg))
#define  DFE_HDMI_RX_PHY_REGD22_reg_p0_lock_up_limit_shift                       (16)
#define  DFE_HDMI_RX_PHY_REGD22_reg_p0_lock_dn_limit_shift                       (0)
#define  DFE_HDMI_RX_PHY_REGD22_reg_p0_lock_up_limit_mask                        (0x07FF0000)
#define  DFE_HDMI_RX_PHY_REGD22_reg_p0_lock_dn_limit_mask                        (0x000007FF)
#define  DFE_HDMI_RX_PHY_REGD22_reg_p0_lock_up_limit(data)                       (0x07FF0000&((data)<<16))
#define  DFE_HDMI_RX_PHY_REGD22_reg_p0_lock_dn_limit(data)                       (0x000007FF&(data))
#define  DFE_HDMI_RX_PHY_REGD22_get_reg_p0_lock_up_limit(data)                   ((0x07FF0000&(data))>>16)
#define  DFE_HDMI_RX_PHY_REGD22_get_reg_p0_lock_dn_limit(data)                   (0x000007FF&(data))

#define  DFE_HDMI_RX_PHY_REGD23                                                  0x1800DB78
#define  DFE_HDMI_RX_PHY_REGD23_reg_addr                                         "0xB800DB78"
#define  DFE_HDMI_RX_PHY_REGD23_reg                                              0xB800DB78
#define  DFE_HDMI_RX_PHY_REGD23_inst_addr                                        "0x0059"
#define  set_DFE_HDMI_RX_PHY_REGD23_reg(data)                                    (*((volatile unsigned int*)DFE_HDMI_RX_PHY_REGD23_reg)=data)
#define  get_DFE_HDMI_RX_PHY_REGD23_reg                                          (*((volatile unsigned int*)DFE_HDMI_RX_PHY_REGD23_reg))
#define  DFE_HDMI_RX_PHY_REGD23_reg_p0_cdr_cp_shift                              (12)
#define  DFE_HDMI_RX_PHY_REGD23_reg_p0_cdr_r_shift                               (6)
#define  DFE_HDMI_RX_PHY_REGD23_reg_p0_cdr_c_shift                               (4)
#define  DFE_HDMI_RX_PHY_REGD23_reg_p0_vc_sel_shift                              (2)
#define  DFE_HDMI_RX_PHY_REGD23_reg_p0_calib_reset_sel_shift                     (1)
#define  DFE_HDMI_RX_PHY_REGD23_reg_p0_cdr_cp_mask                               (0xFFFFF000)
#define  DFE_HDMI_RX_PHY_REGD23_reg_p0_cdr_r_mask                                (0x00000FC0)
#define  DFE_HDMI_RX_PHY_REGD23_reg_p0_cdr_c_mask                                (0x00000030)
#define  DFE_HDMI_RX_PHY_REGD23_reg_p0_vc_sel_mask                               (0x0000000C)
#define  DFE_HDMI_RX_PHY_REGD23_reg_p0_calib_reset_sel_mask                      (0x00000002)
#define  DFE_HDMI_RX_PHY_REGD23_reg_p0_cdr_cp(data)                              (0xFFFFF000&((data)<<12))
#define  DFE_HDMI_RX_PHY_REGD23_reg_p0_cdr_r(data)                               (0x00000FC0&((data)<<6))
#define  DFE_HDMI_RX_PHY_REGD23_reg_p0_cdr_c(data)                               (0x00000030&((data)<<4))
#define  DFE_HDMI_RX_PHY_REGD23_reg_p0_vc_sel(data)                              (0x0000000C&((data)<<2))
#define  DFE_HDMI_RX_PHY_REGD23_reg_p0_calib_reset_sel(data)                     (0x00000002&((data)<<1))
#define  DFE_HDMI_RX_PHY_REGD23_get_reg_p0_cdr_cp(data)                          ((0xFFFFF000&(data))>>12)
#define  DFE_HDMI_RX_PHY_REGD23_get_reg_p0_cdr_r(data)                           ((0x00000FC0&(data))>>6)
#define  DFE_HDMI_RX_PHY_REGD23_get_reg_p0_cdr_c(data)                           ((0x00000030&(data))>>4)
#define  DFE_HDMI_RX_PHY_REGD23_get_reg_p0_vc_sel(data)                          ((0x0000000C&(data))>>2)
#define  DFE_HDMI_RX_PHY_REGD23_get_reg_p0_calib_reset_sel(data)                 ((0x00000002&(data))>>1)

#define  DFE_HDMI_RX_PHY_REGD24                                                  0x1800DB7C
#define  DFE_HDMI_RX_PHY_REGD24_reg_addr                                         "0xB800DB7C"
#define  DFE_HDMI_RX_PHY_REGD24_reg                                              0xB800DB7C
#define  DFE_HDMI_RX_PHY_REGD24_inst_addr                                        "0x005A"
#define  set_DFE_HDMI_RX_PHY_REGD24_reg(data)                                    (*((volatile unsigned int*)DFE_HDMI_RX_PHY_REGD24_reg)=data)
#define  get_DFE_HDMI_RX_PHY_REGD24_reg                                          (*((volatile unsigned int*)DFE_HDMI_RX_PHY_REGD24_reg))
#define  DFE_HDMI_RX_PHY_REGD24_reg_p0_slope_lv_up_shift                         (21)
#define  DFE_HDMI_RX_PHY_REGD24_reg_p0_slope_lv_dn_shift                         (10)
#define  DFE_HDMI_RX_PHY_REGD24_reg_p0_cp_time_shift                             (5)
#define  DFE_HDMI_RX_PHY_REGD24_reg_p0_timer_4_shift                             (0)
#define  DFE_HDMI_RX_PHY_REGD24_reg_p0_slope_lv_up_mask                          (0xFFE00000)
#define  DFE_HDMI_RX_PHY_REGD24_reg_p0_slope_lv_dn_mask                          (0x001FFC00)
#define  DFE_HDMI_RX_PHY_REGD24_reg_p0_cp_time_mask                              (0x000003E0)
#define  DFE_HDMI_RX_PHY_REGD24_reg_p0_timer_4_mask                              (0x0000001F)
#define  DFE_HDMI_RX_PHY_REGD24_reg_p0_slope_lv_up(data)                         (0xFFE00000&((data)<<21))
#define  DFE_HDMI_RX_PHY_REGD24_reg_p0_slope_lv_dn(data)                         (0x001FFC00&((data)<<10))
#define  DFE_HDMI_RX_PHY_REGD24_reg_p0_cp_time(data)                             (0x000003E0&((data)<<5))
#define  DFE_HDMI_RX_PHY_REGD24_reg_p0_timer_4(data)                             (0x0000001F&(data))
#define  DFE_HDMI_RX_PHY_REGD24_get_reg_p0_slope_lv_up(data)                     ((0xFFE00000&(data))>>21)
#define  DFE_HDMI_RX_PHY_REGD24_get_reg_p0_slope_lv_dn(data)                     ((0x001FFC00&(data))>>10)
#define  DFE_HDMI_RX_PHY_REGD24_get_reg_p0_cp_time(data)                         ((0x000003E0&(data))>>5)
#define  DFE_HDMI_RX_PHY_REGD24_get_reg_p0_timer_4(data)                         (0x0000001F&(data))

#define  DFE_HDMI_RX_PHY_REGD25                                                  0x1800DB80
#define  DFE_HDMI_RX_PHY_REGD25_reg_addr                                         "0xB800DB80"
#define  DFE_HDMI_RX_PHY_REGD25_reg                                              0xB800DB80
#define  DFE_HDMI_RX_PHY_REGD25_inst_addr                                        "0x005B"
#define  set_DFE_HDMI_RX_PHY_REGD25_reg(data)                                    (*((volatile unsigned int*)DFE_HDMI_RX_PHY_REGD25_reg)=data)
#define  get_DFE_HDMI_RX_PHY_REGD25_reg                                          (*((volatile unsigned int*)DFE_HDMI_RX_PHY_REGD25_reg))
#define  DFE_HDMI_RX_PHY_REGD25_reg_p0_slope_hv_up_shift                         (21)
#define  DFE_HDMI_RX_PHY_REGD25_reg_p0_slope_hv_dn_shift                         (10)
#define  DFE_HDMI_RX_PHY_REGD25_reg_p0_timer_5_shift                             (9)
#define  DFE_HDMI_RX_PHY_REGD25_reg_p0_timer_6_shift                             (4)
#define  DFE_HDMI_RX_PHY_REGD25_reg_p0_slope_hv_up_mask                          (0xFFE00000)
#define  DFE_HDMI_RX_PHY_REGD25_reg_p0_slope_hv_dn_mask                          (0x001FFC00)
#define  DFE_HDMI_RX_PHY_REGD25_reg_p0_timer_5_mask                              (0x00000200)
#define  DFE_HDMI_RX_PHY_REGD25_reg_p0_timer_6_mask                              (0x000001F0)
#define  DFE_HDMI_RX_PHY_REGD25_reg_p0_slope_hv_up(data)                         (0xFFE00000&((data)<<21))
#define  DFE_HDMI_RX_PHY_REGD25_reg_p0_slope_hv_dn(data)                         (0x001FFC00&((data)<<10))
#define  DFE_HDMI_RX_PHY_REGD25_reg_p0_timer_5(data)                             (0x00000200&((data)<<9))
#define  DFE_HDMI_RX_PHY_REGD25_reg_p0_timer_6(data)                             (0x000001F0&((data)<<4))
#define  DFE_HDMI_RX_PHY_REGD25_get_reg_p0_slope_hv_up(data)                     ((0xFFE00000&(data))>>21)
#define  DFE_HDMI_RX_PHY_REGD25_get_reg_p0_slope_hv_dn(data)                     ((0x001FFC00&(data))>>10)
#define  DFE_HDMI_RX_PHY_REGD25_get_reg_p0_timer_5(data)                         ((0x00000200&(data))>>9)
#define  DFE_HDMI_RX_PHY_REGD25_get_reg_p0_timer_6(data)                         ((0x000001F0&(data))>>4)

#define  DFE_HDMI_RX_PHY_REGD26                                                  0x1800DB84
#define  DFE_HDMI_RX_PHY_REGD26_reg_addr                                         "0xB800DB84"
#define  DFE_HDMI_RX_PHY_REGD26_reg                                              0xB800DB84
#define  DFE_HDMI_RX_PHY_REGD26_inst_addr                                        "0x005C"
#define  set_DFE_HDMI_RX_PHY_REGD26_reg(data)                                    (*((volatile unsigned int*)DFE_HDMI_RX_PHY_REGD26_reg)=data)
#define  get_DFE_HDMI_RX_PHY_REGD26_reg                                          (*((volatile unsigned int*)DFE_HDMI_RX_PHY_REGD26_reg))
#define  DFE_HDMI_RX_PHY_REGD26_reg_p0_start_en_manual_shift                     (31)
#define  DFE_HDMI_RX_PHY_REGD26_reg_p0_pfd_en_manual_shift                       (30)
#define  DFE_HDMI_RX_PHY_REGD26_reg_p0_pfd_time_shift                            (25)
#define  DFE_HDMI_RX_PHY_REGD26_reg_p0_pfd_bypass_shift                          (24)
#define  DFE_HDMI_RX_PHY_REGD26_reg_p0_rxidle_bypass_shift                       (23)
#define  DFE_HDMI_RX_PHY_REGD26_reg_p0_slope_manual_shift                        (22)
#define  DFE_HDMI_RX_PHY_REGD26_reg_p0_slope_band_shift                          (17)
#define  DFE_HDMI_RX_PHY_REGD26_reg_p0_old_mode_shift                            (16)
#define  DFE_HDMI_RX_PHY_REGD26_reg_p0_start_en_manual_mask                      (0x80000000)
#define  DFE_HDMI_RX_PHY_REGD26_reg_p0_pfd_en_manual_mask                        (0x40000000)
#define  DFE_HDMI_RX_PHY_REGD26_reg_p0_pfd_time_mask                             (0x3E000000)
#define  DFE_HDMI_RX_PHY_REGD26_reg_p0_pfd_bypass_mask                           (0x01000000)
#define  DFE_HDMI_RX_PHY_REGD26_reg_p0_rxidle_bypass_mask                        (0x00800000)
#define  DFE_HDMI_RX_PHY_REGD26_reg_p0_slope_manual_mask                         (0x00400000)
#define  DFE_HDMI_RX_PHY_REGD26_reg_p0_slope_band_mask                           (0x003E0000)
#define  DFE_HDMI_RX_PHY_REGD26_reg_p0_old_mode_mask                             (0x00010000)
#define  DFE_HDMI_RX_PHY_REGD26_reg_p0_start_en_manual(data)                     (0x80000000&((data)<<31))
#define  DFE_HDMI_RX_PHY_REGD26_reg_p0_pfd_en_manual(data)                       (0x40000000&((data)<<30))
#define  DFE_HDMI_RX_PHY_REGD26_reg_p0_pfd_time(data)                            (0x3E000000&((data)<<25))
#define  DFE_HDMI_RX_PHY_REGD26_reg_p0_pfd_bypass(data)                          (0x01000000&((data)<<24))
#define  DFE_HDMI_RX_PHY_REGD26_reg_p0_rxidle_bypass(data)                       (0x00800000&((data)<<23))
#define  DFE_HDMI_RX_PHY_REGD26_reg_p0_slope_manual(data)                        (0x00400000&((data)<<22))
#define  DFE_HDMI_RX_PHY_REGD26_reg_p0_slope_band(data)                          (0x003E0000&((data)<<17))
#define  DFE_HDMI_RX_PHY_REGD26_reg_p0_old_mode(data)                            (0x00010000&((data)<<16))
#define  DFE_HDMI_RX_PHY_REGD26_get_reg_p0_start_en_manual(data)                 ((0x80000000&(data))>>31)
#define  DFE_HDMI_RX_PHY_REGD26_get_reg_p0_pfd_en_manual(data)                   ((0x40000000&(data))>>30)
#define  DFE_HDMI_RX_PHY_REGD26_get_reg_p0_pfd_time(data)                        ((0x3E000000&(data))>>25)
#define  DFE_HDMI_RX_PHY_REGD26_get_reg_p0_pfd_bypass(data)                      ((0x01000000&(data))>>24)
#define  DFE_HDMI_RX_PHY_REGD26_get_reg_p0_rxidle_bypass(data)                   ((0x00800000&(data))>>23)
#define  DFE_HDMI_RX_PHY_REGD26_get_reg_p0_slope_manual(data)                    ((0x00400000&(data))>>22)
#define  DFE_HDMI_RX_PHY_REGD26_get_reg_p0_slope_band(data)                      ((0x003E0000&(data))>>17)
#define  DFE_HDMI_RX_PHY_REGD26_get_reg_p0_old_mode(data)                        ((0x00010000&(data))>>16)

#define  DFE_HDMI_RX_PHY_REGD27                                                  0x1800DB88
#define  DFE_HDMI_RX_PHY_REGD27_reg_addr                                         "0xB800DB88"
#define  DFE_HDMI_RX_PHY_REGD27_reg                                              0xB800DB88
#define  DFE_HDMI_RX_PHY_REGD27_inst_addr                                        "0x005D"
#define  set_DFE_HDMI_RX_PHY_REGD27_reg(data)                                    (*((volatile unsigned int*)DFE_HDMI_RX_PHY_REGD27_reg)=data)
#define  get_DFE_HDMI_RX_PHY_REGD27_reg                                          (*((volatile unsigned int*)DFE_HDMI_RX_PHY_REGD27_reg))
#define  DFE_HDMI_RX_PHY_REGD27_p0_fld_st_reg_shift                              (27)
#define  DFE_HDMI_RX_PHY_REGD27_p0_adp_en_fsm_reg_shift                          (26)
#define  DFE_HDMI_RX_PHY_REGD27_p0_cp_en_fsm_reg_shift                           (25)
#define  DFE_HDMI_RX_PHY_REGD27_p0_coarse_fsm_reg_shift                          (18)
#define  DFE_HDMI_RX_PHY_REGD27_p0_pfd_en_fsm_reg_shift                          (17)
#define  DFE_HDMI_RX_PHY_REGD27_p0_slope_lv_reg_shift                            (12)
#define  DFE_HDMI_RX_PHY_REGD27_p0_slope_hv_reg_shift                            (7)
#define  DFE_HDMI_RX_PHY_REGD27_p0_slope_final_reg_shift                         (2)
#define  DFE_HDMI_RX_PHY_REGD27_p0_fld_st_reg_mask                               (0xF8000000)
#define  DFE_HDMI_RX_PHY_REGD27_p0_adp_en_fsm_reg_mask                           (0x04000000)
#define  DFE_HDMI_RX_PHY_REGD27_p0_cp_en_fsm_reg_mask                            (0x02000000)
#define  DFE_HDMI_RX_PHY_REGD27_p0_coarse_fsm_reg_mask                           (0x01FC0000)
#define  DFE_HDMI_RX_PHY_REGD27_p0_pfd_en_fsm_reg_mask                           (0x00020000)
#define  DFE_HDMI_RX_PHY_REGD27_p0_slope_lv_reg_mask                             (0x0001F000)
#define  DFE_HDMI_RX_PHY_REGD27_p0_slope_hv_reg_mask                             (0x00000F80)
#define  DFE_HDMI_RX_PHY_REGD27_p0_slope_final_reg_mask                          (0x0000007C)
#define  DFE_HDMI_RX_PHY_REGD27_p0_fld_st_reg(data)                              (0xF8000000&((data)<<27))
#define  DFE_HDMI_RX_PHY_REGD27_p0_adp_en_fsm_reg(data)                          (0x04000000&((data)<<26))
#define  DFE_HDMI_RX_PHY_REGD27_p0_cp_en_fsm_reg(data)                           (0x02000000&((data)<<25))
#define  DFE_HDMI_RX_PHY_REGD27_p0_coarse_fsm_reg(data)                          (0x01FC0000&((data)<<18))
#define  DFE_HDMI_RX_PHY_REGD27_p0_pfd_en_fsm_reg(data)                          (0x00020000&((data)<<17))
#define  DFE_HDMI_RX_PHY_REGD27_p0_slope_lv_reg(data)                            (0x0001F000&((data)<<12))
#define  DFE_HDMI_RX_PHY_REGD27_p0_slope_hv_reg(data)                            (0x00000F80&((data)<<7))
#define  DFE_HDMI_RX_PHY_REGD27_p0_slope_final_reg(data)                         (0x0000007C&((data)<<2))
#define  DFE_HDMI_RX_PHY_REGD27_get_p0_fld_st_reg(data)                          ((0xF8000000&(data))>>27)
#define  DFE_HDMI_RX_PHY_REGD27_get_p0_adp_en_fsm_reg(data)                      ((0x04000000&(data))>>26)
#define  DFE_HDMI_RX_PHY_REGD27_get_p0_cp_en_fsm_reg(data)                       ((0x02000000&(data))>>25)
#define  DFE_HDMI_RX_PHY_REGD27_get_p0_coarse_fsm_reg(data)                      ((0x01FC0000&(data))>>18)
#define  DFE_HDMI_RX_PHY_REGD27_get_p0_pfd_en_fsm_reg(data)                      ((0x00020000&(data))>>17)
#define  DFE_HDMI_RX_PHY_REGD27_get_p0_slope_lv_reg(data)                        ((0x0001F000&(data))>>12)
#define  DFE_HDMI_RX_PHY_REGD27_get_p0_slope_hv_reg(data)                        ((0x00000F80&(data))>>7)
#define  DFE_HDMI_RX_PHY_REGD27_get_p0_slope_final_reg(data)                     ((0x0000007C&(data))>>2)

#define  DFE_HDMI_RX_PHY_REGD28                                                  0x1800DB8C
#define  DFE_HDMI_RX_PHY_REGD28_reg_addr                                         "0xB800DB8C"
#define  DFE_HDMI_RX_PHY_REGD28_reg                                              0xB800DB8C
#define  DFE_HDMI_RX_PHY_REGD28_inst_addr                                        "0x005E"
#define  set_DFE_HDMI_RX_PHY_REGD28_reg(data)                                    (*((volatile unsigned int*)DFE_HDMI_RX_PHY_REGD28_reg)=data)
#define  get_DFE_HDMI_RX_PHY_REGD28_reg                                          (*((volatile unsigned int*)DFE_HDMI_RX_PHY_REGD28_reg))
#define  DFE_HDMI_RX_PHY_REGD28_reg_p1_auto_mode_shift                           (31)
#define  DFE_HDMI_RX_PHY_REGD28_reg_p1_adp_en_manual_shift                       (30)
#define  DFE_HDMI_RX_PHY_REGD28_reg_p1_cp_en_manual_shift                        (29)
#define  DFE_HDMI_RX_PHY_REGD28_reg_p1_adap_eq_off_shift                         (28)
#define  DFE_HDMI_RX_PHY_REGD28_reg_p1_adp_time_shift                            (23)
#define  DFE_HDMI_RX_PHY_REGD28_reg_p1_calib_time_shift                          (20)
#define  DFE_HDMI_RX_PHY_REGD28_reg_p1_calib_manual_shift                        (19)
#define  DFE_HDMI_RX_PHY_REGD28_reg_p1_calib_late_shift                          (18)
#define  DFE_HDMI_RX_PHY_REGD28_reg_p1_vco_coarse_shift                          (11)
#define  DFE_HDMI_RX_PHY_REGD28_reg_p1_divide_num_shift                          (4)
#define  DFE_HDMI_RX_PHY_REGD28_reg_p1_init_time_shift                           (1)
#define  DFE_HDMI_RX_PHY_REGD28_reg_p1_auto_mode_mask                            (0x80000000)
#define  DFE_HDMI_RX_PHY_REGD28_reg_p1_adp_en_manual_mask                        (0x40000000)
#define  DFE_HDMI_RX_PHY_REGD28_reg_p1_cp_en_manual_mask                         (0x20000000)
#define  DFE_HDMI_RX_PHY_REGD28_reg_p1_adap_eq_off_mask                          (0x10000000)
#define  DFE_HDMI_RX_PHY_REGD28_reg_p1_adp_time_mask                             (0x0F800000)
#define  DFE_HDMI_RX_PHY_REGD28_reg_p1_calib_time_mask                           (0x00700000)
#define  DFE_HDMI_RX_PHY_REGD28_reg_p1_calib_manual_mask                         (0x00080000)
#define  DFE_HDMI_RX_PHY_REGD28_reg_p1_calib_late_mask                           (0x00040000)
#define  DFE_HDMI_RX_PHY_REGD28_reg_p1_vco_coarse_mask                           (0x0003F800)
#define  DFE_HDMI_RX_PHY_REGD28_reg_p1_divide_num_mask                           (0x000007F0)
#define  DFE_HDMI_RX_PHY_REGD28_reg_p1_init_time_mask                            (0x0000000E)
#define  DFE_HDMI_RX_PHY_REGD28_reg_p1_auto_mode(data)                           (0x80000000&((data)<<31))
#define  DFE_HDMI_RX_PHY_REGD28_reg_p1_adp_en_manual(data)                       (0x40000000&((data)<<30))
#define  DFE_HDMI_RX_PHY_REGD28_reg_p1_cp_en_manual(data)                        (0x20000000&((data)<<29))
#define  DFE_HDMI_RX_PHY_REGD28_reg_p1_adap_eq_off(data)                         (0x10000000&((data)<<28))
#define  DFE_HDMI_RX_PHY_REGD28_reg_p1_adp_time(data)                            (0x0F800000&((data)<<23))
#define  DFE_HDMI_RX_PHY_REGD28_reg_p1_calib_time(data)                          (0x00700000&((data)<<20))
#define  DFE_HDMI_RX_PHY_REGD28_reg_p1_calib_manual(data)                        (0x00080000&((data)<<19))
#define  DFE_HDMI_RX_PHY_REGD28_reg_p1_calib_late(data)                          (0x00040000&((data)<<18))
#define  DFE_HDMI_RX_PHY_REGD28_reg_p1_vco_coarse(data)                          (0x0003F800&((data)<<11))
#define  DFE_HDMI_RX_PHY_REGD28_reg_p1_divide_num(data)                          (0x000007F0&((data)<<4))
#define  DFE_HDMI_RX_PHY_REGD28_reg_p1_init_time(data)                           (0x0000000E&((data)<<1))
#define  DFE_HDMI_RX_PHY_REGD28_get_reg_p1_auto_mode(data)                       ((0x80000000&(data))>>31)
#define  DFE_HDMI_RX_PHY_REGD28_get_reg_p1_adp_en_manual(data)                   ((0x40000000&(data))>>30)
#define  DFE_HDMI_RX_PHY_REGD28_get_reg_p1_cp_en_manual(data)                    ((0x20000000&(data))>>29)
#define  DFE_HDMI_RX_PHY_REGD28_get_reg_p1_adap_eq_off(data)                     ((0x10000000&(data))>>28)
#define  DFE_HDMI_RX_PHY_REGD28_get_reg_p1_adp_time(data)                        ((0x0F800000&(data))>>23)
#define  DFE_HDMI_RX_PHY_REGD28_get_reg_p1_calib_time(data)                      ((0x00700000&(data))>>20)
#define  DFE_HDMI_RX_PHY_REGD28_get_reg_p1_calib_manual(data)                    ((0x00080000&(data))>>19)
#define  DFE_HDMI_RX_PHY_REGD28_get_reg_p1_calib_late(data)                      ((0x00040000&(data))>>18)
#define  DFE_HDMI_RX_PHY_REGD28_get_reg_p1_vco_coarse(data)                      ((0x0003F800&(data))>>11)
#define  DFE_HDMI_RX_PHY_REGD28_get_reg_p1_divide_num(data)                      ((0x000007F0&(data))>>4)
#define  DFE_HDMI_RX_PHY_REGD28_get_reg_p1_init_time(data)                       ((0x0000000E&(data))>>1)

#define  DFE_HDMI_RX_PHY_REGD29                                                  0x1800DB90
#define  DFE_HDMI_RX_PHY_REGD29_reg_addr                                         "0xB800DB90"
#define  DFE_HDMI_RX_PHY_REGD29_reg                                              0xB800DB90
#define  DFE_HDMI_RX_PHY_REGD29_inst_addr                                        "0x005F"
#define  set_DFE_HDMI_RX_PHY_REGD29_reg(data)                                    (*((volatile unsigned int*)DFE_HDMI_RX_PHY_REGD29_reg)=data)
#define  get_DFE_HDMI_RX_PHY_REGD29_reg                                          (*((volatile unsigned int*)DFE_HDMI_RX_PHY_REGD29_reg))
#define  DFE_HDMI_RX_PHY_REGD29_reg_p1_lock_up_limit_shift                       (16)
#define  DFE_HDMI_RX_PHY_REGD29_reg_p1_lock_dn_limit_shift                       (0)
#define  DFE_HDMI_RX_PHY_REGD29_reg_p1_lock_up_limit_mask                        (0x07FF0000)
#define  DFE_HDMI_RX_PHY_REGD29_reg_p1_lock_dn_limit_mask                        (0x000007FF)
#define  DFE_HDMI_RX_PHY_REGD29_reg_p1_lock_up_limit(data)                       (0x07FF0000&((data)<<16))
#define  DFE_HDMI_RX_PHY_REGD29_reg_p1_lock_dn_limit(data)                       (0x000007FF&(data))
#define  DFE_HDMI_RX_PHY_REGD29_get_reg_p1_lock_up_limit(data)                   ((0x07FF0000&(data))>>16)
#define  DFE_HDMI_RX_PHY_REGD29_get_reg_p1_lock_dn_limit(data)                   (0x000007FF&(data))

#define  DFE_HDMI_RX_PHY_REGD30                                                  0x1800DB94
#define  DFE_HDMI_RX_PHY_REGD30_reg_addr                                         "0xB800DB94"
#define  DFE_HDMI_RX_PHY_REGD30_reg                                              0xB800DB94
#define  DFE_HDMI_RX_PHY_REGD30_inst_addr                                        "0x0060"
#define  set_DFE_HDMI_RX_PHY_REGD30_reg(data)                                    (*((volatile unsigned int*)DFE_HDMI_RX_PHY_REGD30_reg)=data)
#define  get_DFE_HDMI_RX_PHY_REGD30_reg                                          (*((volatile unsigned int*)DFE_HDMI_RX_PHY_REGD30_reg))
#define  DFE_HDMI_RX_PHY_REGD30_reg_p1_cdr_cp_shift                              (12)
#define  DFE_HDMI_RX_PHY_REGD30_reg_p1_cdr_r_shift                               (6)
#define  DFE_HDMI_RX_PHY_REGD30_reg_p1_cdr_c_shift                               (4)
#define  DFE_HDMI_RX_PHY_REGD30_reg_p1_vc_sel_shift                              (2)
#define  DFE_HDMI_RX_PHY_REGD30_reg_p1_calib_reset_sel_shift                     (1)
#define  DFE_HDMI_RX_PHY_REGD30_reg_p1_cdr_cp_mask                               (0xFFFFF000)
#define  DFE_HDMI_RX_PHY_REGD30_reg_p1_cdr_r_mask                                (0x00000FC0)
#define  DFE_HDMI_RX_PHY_REGD30_reg_p1_cdr_c_mask                                (0x00000030)
#define  DFE_HDMI_RX_PHY_REGD30_reg_p1_vc_sel_mask                               (0x0000000C)
#define  DFE_HDMI_RX_PHY_REGD30_reg_p1_calib_reset_sel_mask                      (0x00000002)
#define  DFE_HDMI_RX_PHY_REGD30_reg_p1_cdr_cp(data)                              (0xFFFFF000&((data)<<12))
#define  DFE_HDMI_RX_PHY_REGD30_reg_p1_cdr_r(data)                               (0x00000FC0&((data)<<6))
#define  DFE_HDMI_RX_PHY_REGD30_reg_p1_cdr_c(data)                               (0x00000030&((data)<<4))
#define  DFE_HDMI_RX_PHY_REGD30_reg_p1_vc_sel(data)                              (0x0000000C&((data)<<2))
#define  DFE_HDMI_RX_PHY_REGD30_reg_p1_calib_reset_sel(data)                     (0x00000002&((data)<<1))
#define  DFE_HDMI_RX_PHY_REGD30_get_reg_p1_cdr_cp(data)                          ((0xFFFFF000&(data))>>12)
#define  DFE_HDMI_RX_PHY_REGD30_get_reg_p1_cdr_r(data)                           ((0x00000FC0&(data))>>6)
#define  DFE_HDMI_RX_PHY_REGD30_get_reg_p1_cdr_c(data)                           ((0x00000030&(data))>>4)
#define  DFE_HDMI_RX_PHY_REGD30_get_reg_p1_vc_sel(data)                          ((0x0000000C&(data))>>2)
#define  DFE_HDMI_RX_PHY_REGD30_get_reg_p1_calib_reset_sel(data)                 ((0x00000002&(data))>>1)

#define  DFE_HDMI_RX_PHY_REGD31                                                  0x1800DB98
#define  DFE_HDMI_RX_PHY_REGD31_reg_addr                                         "0xB800DB98"
#define  DFE_HDMI_RX_PHY_REGD31_reg                                              0xB800DB98
#define  DFE_HDMI_RX_PHY_REGD31_inst_addr                                        "0x0061"
#define  set_DFE_HDMI_RX_PHY_REGD31_reg(data)                                    (*((volatile unsigned int*)DFE_HDMI_RX_PHY_REGD31_reg)=data)
#define  get_DFE_HDMI_RX_PHY_REGD31_reg                                          (*((volatile unsigned int*)DFE_HDMI_RX_PHY_REGD31_reg))
#define  DFE_HDMI_RX_PHY_REGD31_reg_p1_slope_lv_up_shift                         (21)
#define  DFE_HDMI_RX_PHY_REGD31_reg_p1_slope_lv_dn_shift                         (10)
#define  DFE_HDMI_RX_PHY_REGD31_reg_p1_cp_time_shift                             (5)
#define  DFE_HDMI_RX_PHY_REGD31_reg_p1_timer_4_shift                             (0)
#define  DFE_HDMI_RX_PHY_REGD31_reg_p1_slope_lv_up_mask                          (0xFFE00000)
#define  DFE_HDMI_RX_PHY_REGD31_reg_p1_slope_lv_dn_mask                          (0x001FFC00)
#define  DFE_HDMI_RX_PHY_REGD31_reg_p1_cp_time_mask                              (0x000003E0)
#define  DFE_HDMI_RX_PHY_REGD31_reg_p1_timer_4_mask                              (0x0000001F)
#define  DFE_HDMI_RX_PHY_REGD31_reg_p1_slope_lv_up(data)                         (0xFFE00000&((data)<<21))
#define  DFE_HDMI_RX_PHY_REGD31_reg_p1_slope_lv_dn(data)                         (0x001FFC00&((data)<<10))
#define  DFE_HDMI_RX_PHY_REGD31_reg_p1_cp_time(data)                             (0x000003E0&((data)<<5))
#define  DFE_HDMI_RX_PHY_REGD31_reg_p1_timer_4(data)                             (0x0000001F&(data))
#define  DFE_HDMI_RX_PHY_REGD31_get_reg_p1_slope_lv_up(data)                     ((0xFFE00000&(data))>>21)
#define  DFE_HDMI_RX_PHY_REGD31_get_reg_p1_slope_lv_dn(data)                     ((0x001FFC00&(data))>>10)
#define  DFE_HDMI_RX_PHY_REGD31_get_reg_p1_cp_time(data)                         ((0x000003E0&(data))>>5)
#define  DFE_HDMI_RX_PHY_REGD31_get_reg_p1_timer_4(data)                         (0x0000001F&(data))

#define  DFE_HDMI_RX_PHY_REGD32                                                  0x1800DB9C
#define  DFE_HDMI_RX_PHY_REGD32_reg_addr                                         "0xB800DB9C"
#define  DFE_HDMI_RX_PHY_REGD32_reg                                              0xB800DB9C
#define  DFE_HDMI_RX_PHY_REGD32_inst_addr                                        "0x0062"
#define  set_DFE_HDMI_RX_PHY_REGD32_reg(data)                                    (*((volatile unsigned int*)DFE_HDMI_RX_PHY_REGD32_reg)=data)
#define  get_DFE_HDMI_RX_PHY_REGD32_reg                                          (*((volatile unsigned int*)DFE_HDMI_RX_PHY_REGD32_reg))
#define  DFE_HDMI_RX_PHY_REGD32_reg_p1_slope_hv_up_shift                         (21)
#define  DFE_HDMI_RX_PHY_REGD32_reg_p1_slope_hv_dn_shift                         (10)
#define  DFE_HDMI_RX_PHY_REGD32_reg_p1_timer_5_shift                             (9)
#define  DFE_HDMI_RX_PHY_REGD32_reg_p1_timer_6_shift                             (4)
#define  DFE_HDMI_RX_PHY_REGD32_reg_p1_slope_hv_up_mask                          (0xFFE00000)
#define  DFE_HDMI_RX_PHY_REGD32_reg_p1_slope_hv_dn_mask                          (0x001FFC00)
#define  DFE_HDMI_RX_PHY_REGD32_reg_p1_timer_5_mask                              (0x00000200)
#define  DFE_HDMI_RX_PHY_REGD32_reg_p1_timer_6_mask                              (0x000001F0)
#define  DFE_HDMI_RX_PHY_REGD32_reg_p1_slope_hv_up(data)                         (0xFFE00000&((data)<<21))
#define  DFE_HDMI_RX_PHY_REGD32_reg_p1_slope_hv_dn(data)                         (0x001FFC00&((data)<<10))
#define  DFE_HDMI_RX_PHY_REGD32_reg_p1_timer_5(data)                             (0x00000200&((data)<<9))
#define  DFE_HDMI_RX_PHY_REGD32_reg_p1_timer_6(data)                             (0x000001F0&((data)<<4))
#define  DFE_HDMI_RX_PHY_REGD32_get_reg_p1_slope_hv_up(data)                     ((0xFFE00000&(data))>>21)
#define  DFE_HDMI_RX_PHY_REGD32_get_reg_p1_slope_hv_dn(data)                     ((0x001FFC00&(data))>>10)
#define  DFE_HDMI_RX_PHY_REGD32_get_reg_p1_timer_5(data)                         ((0x00000200&(data))>>9)
#define  DFE_HDMI_RX_PHY_REGD32_get_reg_p1_timer_6(data)                         ((0x000001F0&(data))>>4)

#define  DFE_HDMI_RX_PHY_REGD33                                                  0x1800DBA0
#define  DFE_HDMI_RX_PHY_REGD33_reg_addr                                         "0xB800DBA0"
#define  DFE_HDMI_RX_PHY_REGD33_reg                                              0xB800DBA0
#define  DFE_HDMI_RX_PHY_REGD33_inst_addr                                        "0x0063"
#define  set_DFE_HDMI_RX_PHY_REGD33_reg(data)                                    (*((volatile unsigned int*)DFE_HDMI_RX_PHY_REGD33_reg)=data)
#define  get_DFE_HDMI_RX_PHY_REGD33_reg                                          (*((volatile unsigned int*)DFE_HDMI_RX_PHY_REGD33_reg))
#define  DFE_HDMI_RX_PHY_REGD33_reg_p1_start_en_manual_shift                     (31)
#define  DFE_HDMI_RX_PHY_REGD33_reg_p1_pfd_en_manual_shift                       (30)
#define  DFE_HDMI_RX_PHY_REGD33_reg_p1_pfd_time_shift                            (25)
#define  DFE_HDMI_RX_PHY_REGD33_reg_p1_pfd_bypass_shift                          (24)
#define  DFE_HDMI_RX_PHY_REGD33_reg_p1_rxidle_bypass_shift                       (23)
#define  DFE_HDMI_RX_PHY_REGD33_reg_p1_slope_manual_shift                        (22)
#define  DFE_HDMI_RX_PHY_REGD33_reg_p1_slope_band_shift                          (17)
#define  DFE_HDMI_RX_PHY_REGD33_reg_p1_old_mode_shift                            (16)
#define  DFE_HDMI_RX_PHY_REGD33_reg_p1_start_en_manual_mask                      (0x80000000)
#define  DFE_HDMI_RX_PHY_REGD33_reg_p1_pfd_en_manual_mask                        (0x40000000)
#define  DFE_HDMI_RX_PHY_REGD33_reg_p1_pfd_time_mask                             (0x3E000000)
#define  DFE_HDMI_RX_PHY_REGD33_reg_p1_pfd_bypass_mask                           (0x01000000)
#define  DFE_HDMI_RX_PHY_REGD33_reg_p1_rxidle_bypass_mask                        (0x00800000)
#define  DFE_HDMI_RX_PHY_REGD33_reg_p1_slope_manual_mask                         (0x00400000)
#define  DFE_HDMI_RX_PHY_REGD33_reg_p1_slope_band_mask                           (0x003E0000)
#define  DFE_HDMI_RX_PHY_REGD33_reg_p1_old_mode_mask                             (0x00010000)
#define  DFE_HDMI_RX_PHY_REGD33_reg_p1_start_en_manual(data)                     (0x80000000&((data)<<31))
#define  DFE_HDMI_RX_PHY_REGD33_reg_p1_pfd_en_manual(data)                       (0x40000000&((data)<<30))
#define  DFE_HDMI_RX_PHY_REGD33_reg_p1_pfd_time(data)                            (0x3E000000&((data)<<25))
#define  DFE_HDMI_RX_PHY_REGD33_reg_p1_pfd_bypass(data)                          (0x01000000&((data)<<24))
#define  DFE_HDMI_RX_PHY_REGD33_reg_p1_rxidle_bypass(data)                       (0x00800000&((data)<<23))
#define  DFE_HDMI_RX_PHY_REGD33_reg_p1_slope_manual(data)                        (0x00400000&((data)<<22))
#define  DFE_HDMI_RX_PHY_REGD33_reg_p1_slope_band(data)                          (0x003E0000&((data)<<17))
#define  DFE_HDMI_RX_PHY_REGD33_reg_p1_old_mode(data)                            (0x00010000&((data)<<16))
#define  DFE_HDMI_RX_PHY_REGD33_get_reg_p1_start_en_manual(data)                 ((0x80000000&(data))>>31)
#define  DFE_HDMI_RX_PHY_REGD33_get_reg_p1_pfd_en_manual(data)                   ((0x40000000&(data))>>30)
#define  DFE_HDMI_RX_PHY_REGD33_get_reg_p1_pfd_time(data)                        ((0x3E000000&(data))>>25)
#define  DFE_HDMI_RX_PHY_REGD33_get_reg_p1_pfd_bypass(data)                      ((0x01000000&(data))>>24)
#define  DFE_HDMI_RX_PHY_REGD33_get_reg_p1_rxidle_bypass(data)                   ((0x00800000&(data))>>23)
#define  DFE_HDMI_RX_PHY_REGD33_get_reg_p1_slope_manual(data)                    ((0x00400000&(data))>>22)
#define  DFE_HDMI_RX_PHY_REGD33_get_reg_p1_slope_band(data)                      ((0x003E0000&(data))>>17)
#define  DFE_HDMI_RX_PHY_REGD33_get_reg_p1_old_mode(data)                        ((0x00010000&(data))>>16)

#define  DFE_HDMI_RX_PHY_REGD34                                                  0x1800DBA4
#define  DFE_HDMI_RX_PHY_REGD34_reg_addr                                         "0xB800DBA4"
#define  DFE_HDMI_RX_PHY_REGD34_reg                                              0xB800DBA4
#define  DFE_HDMI_RX_PHY_REGD34_inst_addr                                        "0x0064"
#define  set_DFE_HDMI_RX_PHY_REGD34_reg(data)                                    (*((volatile unsigned int*)DFE_HDMI_RX_PHY_REGD34_reg)=data)
#define  get_DFE_HDMI_RX_PHY_REGD34_reg                                          (*((volatile unsigned int*)DFE_HDMI_RX_PHY_REGD34_reg))
#define  DFE_HDMI_RX_PHY_REGD34_p1_fld_st_reg_shift                              (27)
#define  DFE_HDMI_RX_PHY_REGD34_p1_adp_en_fsm_reg_shift                          (26)
#define  DFE_HDMI_RX_PHY_REGD34_p1_cp_en_fsm_reg_shift                           (25)
#define  DFE_HDMI_RX_PHY_REGD34_p1_coarse_fsm_reg_shift                          (18)
#define  DFE_HDMI_RX_PHY_REGD34_p1_pfd_en_fsm_reg_shift                          (17)
#define  DFE_HDMI_RX_PHY_REGD34_p1_slope_lv_reg_shift                            (12)
#define  DFE_HDMI_RX_PHY_REGD34_p1_slope_hv_reg_shift                            (7)
#define  DFE_HDMI_RX_PHY_REGD34_p1_slope_final_reg_shift                         (2)
#define  DFE_HDMI_RX_PHY_REGD34_p1_fld_st_reg_mask                               (0xF8000000)
#define  DFE_HDMI_RX_PHY_REGD34_p1_adp_en_fsm_reg_mask                           (0x04000000)
#define  DFE_HDMI_RX_PHY_REGD34_p1_cp_en_fsm_reg_mask                            (0x02000000)
#define  DFE_HDMI_RX_PHY_REGD34_p1_coarse_fsm_reg_mask                           (0x01FC0000)
#define  DFE_HDMI_RX_PHY_REGD34_p1_pfd_en_fsm_reg_mask                           (0x00020000)
#define  DFE_HDMI_RX_PHY_REGD34_p1_slope_lv_reg_mask                             (0x0001F000)
#define  DFE_HDMI_RX_PHY_REGD34_p1_slope_hv_reg_mask                             (0x00000F80)
#define  DFE_HDMI_RX_PHY_REGD34_p1_slope_final_reg_mask                          (0x0000007C)
#define  DFE_HDMI_RX_PHY_REGD34_p1_fld_st_reg(data)                              (0xF8000000&((data)<<27))
#define  DFE_HDMI_RX_PHY_REGD34_p1_adp_en_fsm_reg(data)                          (0x04000000&((data)<<26))
#define  DFE_HDMI_RX_PHY_REGD34_p1_cp_en_fsm_reg(data)                           (0x02000000&((data)<<25))
#define  DFE_HDMI_RX_PHY_REGD34_p1_coarse_fsm_reg(data)                          (0x01FC0000&((data)<<18))
#define  DFE_HDMI_RX_PHY_REGD34_p1_pfd_en_fsm_reg(data)                          (0x00020000&((data)<<17))
#define  DFE_HDMI_RX_PHY_REGD34_p1_slope_lv_reg(data)                            (0x0001F000&((data)<<12))
#define  DFE_HDMI_RX_PHY_REGD34_p1_slope_hv_reg(data)                            (0x00000F80&((data)<<7))
#define  DFE_HDMI_RX_PHY_REGD34_p1_slope_final_reg(data)                         (0x0000007C&((data)<<2))
#define  DFE_HDMI_RX_PHY_REGD34_get_p1_fld_st_reg(data)                          ((0xF8000000&(data))>>27)
#define  DFE_HDMI_RX_PHY_REGD34_get_p1_adp_en_fsm_reg(data)                      ((0x04000000&(data))>>26)
#define  DFE_HDMI_RX_PHY_REGD34_get_p1_cp_en_fsm_reg(data)                       ((0x02000000&(data))>>25)
#define  DFE_HDMI_RX_PHY_REGD34_get_p1_coarse_fsm_reg(data)                      ((0x01FC0000&(data))>>18)
#define  DFE_HDMI_RX_PHY_REGD34_get_p1_pfd_en_fsm_reg(data)                      ((0x00020000&(data))>>17)
#define  DFE_HDMI_RX_PHY_REGD34_get_p1_slope_lv_reg(data)                        ((0x0001F000&(data))>>12)
#define  DFE_HDMI_RX_PHY_REGD34_get_p1_slope_hv_reg(data)                        ((0x00000F80&(data))>>7)
#define  DFE_HDMI_RX_PHY_REGD34_get_p1_slope_final_reg(data)                     ((0x0000007C&(data))>>2)

#define  DFE_HDMI_RX_PHY_REGD35                                                  0x1800DBA8
#define  DFE_HDMI_RX_PHY_REGD35_reg_addr                                         "0xB800DBA8"
#define  DFE_HDMI_RX_PHY_REGD35_reg                                              0xB800DBA8
#define  DFE_HDMI_RX_PHY_REGD35_inst_addr                                        "0x0065"
#define  set_DFE_HDMI_RX_PHY_REGD35_reg(data)                                    (*((volatile unsigned int*)DFE_HDMI_RX_PHY_REGD35_reg)=data)
#define  get_DFE_HDMI_RX_PHY_REGD35_reg                                          (*((volatile unsigned int*)DFE_HDMI_RX_PHY_REGD35_reg))
#define  DFE_HDMI_RX_PHY_REGD35_reg_p2_auto_mode_shift                           (31)
#define  DFE_HDMI_RX_PHY_REGD35_reg_p2_adp_en_manual_shift                       (30)
#define  DFE_HDMI_RX_PHY_REGD35_reg_p2_cp_en_manual_shift                        (29)
#define  DFE_HDMI_RX_PHY_REGD35_reg_p2_adap_eq_off_shift                         (28)
#define  DFE_HDMI_RX_PHY_REGD35_reg_p2_adp_time_shift                            (23)
#define  DFE_HDMI_RX_PHY_REGD35_reg_p2_calib_time_shift                          (20)
#define  DFE_HDMI_RX_PHY_REGD35_reg_p2_calib_manual_shift                        (19)
#define  DFE_HDMI_RX_PHY_REGD35_reg_p2_calib_late_shift                          (18)
#define  DFE_HDMI_RX_PHY_REGD35_reg_p2_vco_coarse_shift                          (11)
#define  DFE_HDMI_RX_PHY_REGD35_reg_p2_divide_num_shift                          (4)
#define  DFE_HDMI_RX_PHY_REGD35_reg_p2_init_time_shift                           (1)
#define  DFE_HDMI_RX_PHY_REGD35_reg_p2_auto_mode_mask                            (0x80000000)
#define  DFE_HDMI_RX_PHY_REGD35_reg_p2_adp_en_manual_mask                        (0x40000000)
#define  DFE_HDMI_RX_PHY_REGD35_reg_p2_cp_en_manual_mask                         (0x20000000)
#define  DFE_HDMI_RX_PHY_REGD35_reg_p2_adap_eq_off_mask                          (0x10000000)
#define  DFE_HDMI_RX_PHY_REGD35_reg_p2_adp_time_mask                             (0x0F800000)
#define  DFE_HDMI_RX_PHY_REGD35_reg_p2_calib_time_mask                           (0x00700000)
#define  DFE_HDMI_RX_PHY_REGD35_reg_p2_calib_manual_mask                         (0x00080000)
#define  DFE_HDMI_RX_PHY_REGD35_reg_p2_calib_late_mask                           (0x00040000)
#define  DFE_HDMI_RX_PHY_REGD35_reg_p2_vco_coarse_mask                           (0x0003F800)
#define  DFE_HDMI_RX_PHY_REGD35_reg_p2_divide_num_mask                           (0x000007F0)
#define  DFE_HDMI_RX_PHY_REGD35_reg_p2_init_time_mask                            (0x0000000E)
#define  DFE_HDMI_RX_PHY_REGD35_reg_p2_auto_mode(data)                           (0x80000000&((data)<<31))
#define  DFE_HDMI_RX_PHY_REGD35_reg_p2_adp_en_manual(data)                       (0x40000000&((data)<<30))
#define  DFE_HDMI_RX_PHY_REGD35_reg_p2_cp_en_manual(data)                        (0x20000000&((data)<<29))
#define  DFE_HDMI_RX_PHY_REGD35_reg_p2_adap_eq_off(data)                         (0x10000000&((data)<<28))
#define  DFE_HDMI_RX_PHY_REGD35_reg_p2_adp_time(data)                            (0x0F800000&((data)<<23))
#define  DFE_HDMI_RX_PHY_REGD35_reg_p2_calib_time(data)                          (0x00700000&((data)<<20))
#define  DFE_HDMI_RX_PHY_REGD35_reg_p2_calib_manual(data)                        (0x00080000&((data)<<19))
#define  DFE_HDMI_RX_PHY_REGD35_reg_p2_calib_late(data)                          (0x00040000&((data)<<18))
#define  DFE_HDMI_RX_PHY_REGD35_reg_p2_vco_coarse(data)                          (0x0003F800&((data)<<11))
#define  DFE_HDMI_RX_PHY_REGD35_reg_p2_divide_num(data)                          (0x000007F0&((data)<<4))
#define  DFE_HDMI_RX_PHY_REGD35_reg_p2_init_time(data)                           (0x0000000E&((data)<<1))
#define  DFE_HDMI_RX_PHY_REGD35_get_reg_p2_auto_mode(data)                       ((0x80000000&(data))>>31)
#define  DFE_HDMI_RX_PHY_REGD35_get_reg_p2_adp_en_manual(data)                   ((0x40000000&(data))>>30)
#define  DFE_HDMI_RX_PHY_REGD35_get_reg_p2_cp_en_manual(data)                    ((0x20000000&(data))>>29)
#define  DFE_HDMI_RX_PHY_REGD35_get_reg_p2_adap_eq_off(data)                     ((0x10000000&(data))>>28)
#define  DFE_HDMI_RX_PHY_REGD35_get_reg_p2_adp_time(data)                        ((0x0F800000&(data))>>23)
#define  DFE_HDMI_RX_PHY_REGD35_get_reg_p2_calib_time(data)                      ((0x00700000&(data))>>20)
#define  DFE_HDMI_RX_PHY_REGD35_get_reg_p2_calib_manual(data)                    ((0x00080000&(data))>>19)
#define  DFE_HDMI_RX_PHY_REGD35_get_reg_p2_calib_late(data)                      ((0x00040000&(data))>>18)
#define  DFE_HDMI_RX_PHY_REGD35_get_reg_p2_vco_coarse(data)                      ((0x0003F800&(data))>>11)
#define  DFE_HDMI_RX_PHY_REGD35_get_reg_p2_divide_num(data)                      ((0x000007F0&(data))>>4)
#define  DFE_HDMI_RX_PHY_REGD35_get_reg_p2_init_time(data)                       ((0x0000000E&(data))>>1)

#define  DFE_HDMI_RX_PHY_REGD36                                                  0x1800DBAC
#define  DFE_HDMI_RX_PHY_REGD36_reg_addr                                         "0xB800DBAC"
#define  DFE_HDMI_RX_PHY_REGD36_reg                                              0xB800DBAC
#define  DFE_HDMI_RX_PHY_REGD36_inst_addr                                        "0x0066"
#define  set_DFE_HDMI_RX_PHY_REGD36_reg(data)                                    (*((volatile unsigned int*)DFE_HDMI_RX_PHY_REGD36_reg)=data)
#define  get_DFE_HDMI_RX_PHY_REGD36_reg                                          (*((volatile unsigned int*)DFE_HDMI_RX_PHY_REGD36_reg))
#define  DFE_HDMI_RX_PHY_REGD36_reg_p2_lock_up_limit_shift                       (16)
#define  DFE_HDMI_RX_PHY_REGD36_reg_p2_lock_dn_limit_shift                       (0)
#define  DFE_HDMI_RX_PHY_REGD36_reg_p2_lock_up_limit_mask                        (0x07FF0000)
#define  DFE_HDMI_RX_PHY_REGD36_reg_p2_lock_dn_limit_mask                        (0x000007FF)
#define  DFE_HDMI_RX_PHY_REGD36_reg_p2_lock_up_limit(data)                       (0x07FF0000&((data)<<16))
#define  DFE_HDMI_RX_PHY_REGD36_reg_p2_lock_dn_limit(data)                       (0x000007FF&(data))
#define  DFE_HDMI_RX_PHY_REGD36_get_reg_p2_lock_up_limit(data)                   ((0x07FF0000&(data))>>16)
#define  DFE_HDMI_RX_PHY_REGD36_get_reg_p2_lock_dn_limit(data)                   (0x000007FF&(data))

#define  DFE_HDMI_RX_PHY_REGD37                                                  0x1800DBB0
#define  DFE_HDMI_RX_PHY_REGD37_reg_addr                                         "0xB800DBB0"
#define  DFE_HDMI_RX_PHY_REGD37_reg                                              0xB800DBB0
#define  DFE_HDMI_RX_PHY_REGD37_inst_addr                                        "0x0067"
#define  set_DFE_HDMI_RX_PHY_REGD37_reg(data)                                    (*((volatile unsigned int*)DFE_HDMI_RX_PHY_REGD37_reg)=data)
#define  get_DFE_HDMI_RX_PHY_REGD37_reg                                          (*((volatile unsigned int*)DFE_HDMI_RX_PHY_REGD37_reg))
#define  DFE_HDMI_RX_PHY_REGD37_reg_p2_cdr_cp_shift                              (12)
#define  DFE_HDMI_RX_PHY_REGD37_reg_p2_cdr_r_shift                               (6)
#define  DFE_HDMI_RX_PHY_REGD37_reg_p2_cdr_c_shift                               (4)
#define  DFE_HDMI_RX_PHY_REGD37_reg_p2_vc_sel_shift                              (2)
#define  DFE_HDMI_RX_PHY_REGD37_reg_p2_calib_reset_sel_shift                     (1)
#define  DFE_HDMI_RX_PHY_REGD37_reg_p2_cdr_cp_mask                               (0xFFFFF000)
#define  DFE_HDMI_RX_PHY_REGD37_reg_p2_cdr_r_mask                                (0x00000FC0)
#define  DFE_HDMI_RX_PHY_REGD37_reg_p2_cdr_c_mask                                (0x00000030)
#define  DFE_HDMI_RX_PHY_REGD37_reg_p2_vc_sel_mask                               (0x0000000C)
#define  DFE_HDMI_RX_PHY_REGD37_reg_p2_calib_reset_sel_mask                      (0x00000002)
#define  DFE_HDMI_RX_PHY_REGD37_reg_p2_cdr_cp(data)                              (0xFFFFF000&((data)<<12))
#define  DFE_HDMI_RX_PHY_REGD37_reg_p2_cdr_r(data)                               (0x00000FC0&((data)<<6))
#define  DFE_HDMI_RX_PHY_REGD37_reg_p2_cdr_c(data)                               (0x00000030&((data)<<4))
#define  DFE_HDMI_RX_PHY_REGD37_reg_p2_vc_sel(data)                              (0x0000000C&((data)<<2))
#define  DFE_HDMI_RX_PHY_REGD37_reg_p2_calib_reset_sel(data)                     (0x00000002&((data)<<1))
#define  DFE_HDMI_RX_PHY_REGD37_get_reg_p2_cdr_cp(data)                          ((0xFFFFF000&(data))>>12)
#define  DFE_HDMI_RX_PHY_REGD37_get_reg_p2_cdr_r(data)                           ((0x00000FC0&(data))>>6)
#define  DFE_HDMI_RX_PHY_REGD37_get_reg_p2_cdr_c(data)                           ((0x00000030&(data))>>4)
#define  DFE_HDMI_RX_PHY_REGD37_get_reg_p2_vc_sel(data)                          ((0x0000000C&(data))>>2)
#define  DFE_HDMI_RX_PHY_REGD37_get_reg_p2_calib_reset_sel(data)                 ((0x00000002&(data))>>1)

#define  DFE_HDMI_RX_PHY_REGD38                                                  0x1800DBB4
#define  DFE_HDMI_RX_PHY_REGD38_reg_addr                                         "0xB800DBB4"
#define  DFE_HDMI_RX_PHY_REGD38_reg                                              0xB800DBB4
#define  DFE_HDMI_RX_PHY_REGD38_inst_addr                                        "0x0068"
#define  set_DFE_HDMI_RX_PHY_REGD38_reg(data)                                    (*((volatile unsigned int*)DFE_HDMI_RX_PHY_REGD38_reg)=data)
#define  get_DFE_HDMI_RX_PHY_REGD38_reg                                          (*((volatile unsigned int*)DFE_HDMI_RX_PHY_REGD38_reg))
#define  DFE_HDMI_RX_PHY_REGD38_reg_p2_slope_lv_up_shift                         (21)
#define  DFE_HDMI_RX_PHY_REGD38_reg_p2_slope_lv_dn_shift                         (10)
#define  DFE_HDMI_RX_PHY_REGD38_reg_p2_cp_time_shift                             (5)
#define  DFE_HDMI_RX_PHY_REGD38_reg_p2_timer_4_shift                             (0)
#define  DFE_HDMI_RX_PHY_REGD38_reg_p2_slope_lv_up_mask                          (0xFFE00000)
#define  DFE_HDMI_RX_PHY_REGD38_reg_p2_slope_lv_dn_mask                          (0x001FFC00)
#define  DFE_HDMI_RX_PHY_REGD38_reg_p2_cp_time_mask                              (0x000003E0)
#define  DFE_HDMI_RX_PHY_REGD38_reg_p2_timer_4_mask                              (0x0000001F)
#define  DFE_HDMI_RX_PHY_REGD38_reg_p2_slope_lv_up(data)                         (0xFFE00000&((data)<<21))
#define  DFE_HDMI_RX_PHY_REGD38_reg_p2_slope_lv_dn(data)                         (0x001FFC00&((data)<<10))
#define  DFE_HDMI_RX_PHY_REGD38_reg_p2_cp_time(data)                             (0x000003E0&((data)<<5))
#define  DFE_HDMI_RX_PHY_REGD38_reg_p2_timer_4(data)                             (0x0000001F&(data))
#define  DFE_HDMI_RX_PHY_REGD38_get_reg_p2_slope_lv_up(data)                     ((0xFFE00000&(data))>>21)
#define  DFE_HDMI_RX_PHY_REGD38_get_reg_p2_slope_lv_dn(data)                     ((0x001FFC00&(data))>>10)
#define  DFE_HDMI_RX_PHY_REGD38_get_reg_p2_cp_time(data)                         ((0x000003E0&(data))>>5)
#define  DFE_HDMI_RX_PHY_REGD38_get_reg_p2_timer_4(data)                         (0x0000001F&(data))

#define  DFE_HDMI_RX_PHY_REGD39                                                  0x1800DBB8
#define  DFE_HDMI_RX_PHY_REGD39_reg_addr                                         "0xB800DBB8"
#define  DFE_HDMI_RX_PHY_REGD39_reg                                              0xB800DBB8
#define  DFE_HDMI_RX_PHY_REGD39_inst_addr                                        "0x0069"
#define  set_DFE_HDMI_RX_PHY_REGD39_reg(data)                                    (*((volatile unsigned int*)DFE_HDMI_RX_PHY_REGD39_reg)=data)
#define  get_DFE_HDMI_RX_PHY_REGD39_reg                                          (*((volatile unsigned int*)DFE_HDMI_RX_PHY_REGD39_reg))
#define  DFE_HDMI_RX_PHY_REGD39_reg_p2_slope_hv_up_shift                         (21)
#define  DFE_HDMI_RX_PHY_REGD39_reg_p2_slope_hv_dn_shift                         (10)
#define  DFE_HDMI_RX_PHY_REGD39_reg_p2_timer_5_shift                             (9)
#define  DFE_HDMI_RX_PHY_REGD39_reg_p2_timer_6_shift                             (4)
#define  DFE_HDMI_RX_PHY_REGD39_reg_p2_slope_hv_up_mask                          (0xFFE00000)
#define  DFE_HDMI_RX_PHY_REGD39_reg_p2_slope_hv_dn_mask                          (0x001FFC00)
#define  DFE_HDMI_RX_PHY_REGD39_reg_p2_timer_5_mask                              (0x00000200)
#define  DFE_HDMI_RX_PHY_REGD39_reg_p2_timer_6_mask                              (0x000001F0)
#define  DFE_HDMI_RX_PHY_REGD39_reg_p2_slope_hv_up(data)                         (0xFFE00000&((data)<<21))
#define  DFE_HDMI_RX_PHY_REGD39_reg_p2_slope_hv_dn(data)                         (0x001FFC00&((data)<<10))
#define  DFE_HDMI_RX_PHY_REGD39_reg_p2_timer_5(data)                             (0x00000200&((data)<<9))
#define  DFE_HDMI_RX_PHY_REGD39_reg_p2_timer_6(data)                             (0x000001F0&((data)<<4))
#define  DFE_HDMI_RX_PHY_REGD39_get_reg_p2_slope_hv_up(data)                     ((0xFFE00000&(data))>>21)
#define  DFE_HDMI_RX_PHY_REGD39_get_reg_p2_slope_hv_dn(data)                     ((0x001FFC00&(data))>>10)
#define  DFE_HDMI_RX_PHY_REGD39_get_reg_p2_timer_5(data)                         ((0x00000200&(data))>>9)
#define  DFE_HDMI_RX_PHY_REGD39_get_reg_p2_timer_6(data)                         ((0x000001F0&(data))>>4)

#define  DFE_HDMI_RX_PHY_REGD40                                                  0x1800DBBC
#define  DFE_HDMI_RX_PHY_REGD40_reg_addr                                         "0xB800DBBC"
#define  DFE_HDMI_RX_PHY_REGD40_reg                                              0xB800DBBC
#define  DFE_HDMI_RX_PHY_REGD40_inst_addr                                        "0x006A"
#define  set_DFE_HDMI_RX_PHY_REGD40_reg(data)                                    (*((volatile unsigned int*)DFE_HDMI_RX_PHY_REGD40_reg)=data)
#define  get_DFE_HDMI_RX_PHY_REGD40_reg                                          (*((volatile unsigned int*)DFE_HDMI_RX_PHY_REGD40_reg))
#define  DFE_HDMI_RX_PHY_REGD40_reg_p2_start_en_manual_shift                     (31)
#define  DFE_HDMI_RX_PHY_REGD40_reg_p2_pfd_en_manual_shift                       (30)
#define  DFE_HDMI_RX_PHY_REGD40_reg_p2_pfd_time_shift                            (25)
#define  DFE_HDMI_RX_PHY_REGD40_reg_p2_pfd_bypass_shift                          (24)
#define  DFE_HDMI_RX_PHY_REGD40_reg_p2_rxidle_bypass_shift                       (23)
#define  DFE_HDMI_RX_PHY_REGD40_reg_p2_slope_manual_shift                        (22)
#define  DFE_HDMI_RX_PHY_REGD40_reg_p2_slope_band_shift                          (17)
#define  DFE_HDMI_RX_PHY_REGD40_reg_p2_old_mode_shift                            (16)
#define  DFE_HDMI_RX_PHY_REGD40_reg_p2_start_en_manual_mask                      (0x80000000)
#define  DFE_HDMI_RX_PHY_REGD40_reg_p2_pfd_en_manual_mask                        (0x40000000)
#define  DFE_HDMI_RX_PHY_REGD40_reg_p2_pfd_time_mask                             (0x3E000000)
#define  DFE_HDMI_RX_PHY_REGD40_reg_p2_pfd_bypass_mask                           (0x01000000)
#define  DFE_HDMI_RX_PHY_REGD40_reg_p2_rxidle_bypass_mask                        (0x00800000)
#define  DFE_HDMI_RX_PHY_REGD40_reg_p2_slope_manual_mask                         (0x00400000)
#define  DFE_HDMI_RX_PHY_REGD40_reg_p2_slope_band_mask                           (0x003E0000)
#define  DFE_HDMI_RX_PHY_REGD40_reg_p2_old_mode_mask                             (0x00010000)
#define  DFE_HDMI_RX_PHY_REGD40_reg_p2_start_en_manual(data)                     (0x80000000&((data)<<31))
#define  DFE_HDMI_RX_PHY_REGD40_reg_p2_pfd_en_manual(data)                       (0x40000000&((data)<<30))
#define  DFE_HDMI_RX_PHY_REGD40_reg_p2_pfd_time(data)                            (0x3E000000&((data)<<25))
#define  DFE_HDMI_RX_PHY_REGD40_reg_p2_pfd_bypass(data)                          (0x01000000&((data)<<24))
#define  DFE_HDMI_RX_PHY_REGD40_reg_p2_rxidle_bypass(data)                       (0x00800000&((data)<<23))
#define  DFE_HDMI_RX_PHY_REGD40_reg_p2_slope_manual(data)                        (0x00400000&((data)<<22))
#define  DFE_HDMI_RX_PHY_REGD40_reg_p2_slope_band(data)                          (0x003E0000&((data)<<17))
#define  DFE_HDMI_RX_PHY_REGD40_reg_p2_old_mode(data)                            (0x00010000&((data)<<16))
#define  DFE_HDMI_RX_PHY_REGD40_get_reg_p2_start_en_manual(data)                 ((0x80000000&(data))>>31)
#define  DFE_HDMI_RX_PHY_REGD40_get_reg_p2_pfd_en_manual(data)                   ((0x40000000&(data))>>30)
#define  DFE_HDMI_RX_PHY_REGD40_get_reg_p2_pfd_time(data)                        ((0x3E000000&(data))>>25)
#define  DFE_HDMI_RX_PHY_REGD40_get_reg_p2_pfd_bypass(data)                      ((0x01000000&(data))>>24)
#define  DFE_HDMI_RX_PHY_REGD40_get_reg_p2_rxidle_bypass(data)                   ((0x00800000&(data))>>23)
#define  DFE_HDMI_RX_PHY_REGD40_get_reg_p2_slope_manual(data)                    ((0x00400000&(data))>>22)
#define  DFE_HDMI_RX_PHY_REGD40_get_reg_p2_slope_band(data)                      ((0x003E0000&(data))>>17)
#define  DFE_HDMI_RX_PHY_REGD40_get_reg_p2_old_mode(data)                        ((0x00010000&(data))>>16)

#define  DFE_HDMI_RX_PHY_REGD41                                                  0x1800DBC0
#define  DFE_HDMI_RX_PHY_REGD41_reg_addr                                         "0xB800DBC0"
#define  DFE_HDMI_RX_PHY_REGD41_reg                                              0xB800DBC0
#define  DFE_HDMI_RX_PHY_REGD41_inst_addr                                        "0x006B"
#define  set_DFE_HDMI_RX_PHY_REGD41_reg(data)                                    (*((volatile unsigned int*)DFE_HDMI_RX_PHY_REGD41_reg)=data)
#define  get_DFE_HDMI_RX_PHY_REGD41_reg                                          (*((volatile unsigned int*)DFE_HDMI_RX_PHY_REGD41_reg))
#define  DFE_HDMI_RX_PHY_REGD41_p2_fld_st_reg_shift                              (27)
#define  DFE_HDMI_RX_PHY_REGD41_p2_adp_en_fsm_reg_shift                          (26)
#define  DFE_HDMI_RX_PHY_REGD41_p2_cp_en_fsm_reg_shift                           (25)
#define  DFE_HDMI_RX_PHY_REGD41_p2_coarse_fsm_reg_shift                          (18)
#define  DFE_HDMI_RX_PHY_REGD41_p2_pfd_en_fsm_reg_shift                          (17)
#define  DFE_HDMI_RX_PHY_REGD41_p2_slope_lv_reg_shift                            (12)
#define  DFE_HDMI_RX_PHY_REGD41_p2_slope_hv_reg_shift                            (7)
#define  DFE_HDMI_RX_PHY_REGD41_p2_slope_final_reg_shift                         (2)
#define  DFE_HDMI_RX_PHY_REGD41_p2_fld_st_reg_mask                               (0xF8000000)
#define  DFE_HDMI_RX_PHY_REGD41_p2_adp_en_fsm_reg_mask                           (0x04000000)
#define  DFE_HDMI_RX_PHY_REGD41_p2_cp_en_fsm_reg_mask                            (0x02000000)
#define  DFE_HDMI_RX_PHY_REGD41_p2_coarse_fsm_reg_mask                           (0x01FC0000)
#define  DFE_HDMI_RX_PHY_REGD41_p2_pfd_en_fsm_reg_mask                           (0x00020000)
#define  DFE_HDMI_RX_PHY_REGD41_p2_slope_lv_reg_mask                             (0x0001F000)
#define  DFE_HDMI_RX_PHY_REGD41_p2_slope_hv_reg_mask                             (0x00000F80)
#define  DFE_HDMI_RX_PHY_REGD41_p2_slope_final_reg_mask                          (0x0000007C)
#define  DFE_HDMI_RX_PHY_REGD41_p2_fld_st_reg(data)                              (0xF8000000&((data)<<27))
#define  DFE_HDMI_RX_PHY_REGD41_p2_adp_en_fsm_reg(data)                          (0x04000000&((data)<<26))
#define  DFE_HDMI_RX_PHY_REGD41_p2_cp_en_fsm_reg(data)                           (0x02000000&((data)<<25))
#define  DFE_HDMI_RX_PHY_REGD41_p2_coarse_fsm_reg(data)                          (0x01FC0000&((data)<<18))
#define  DFE_HDMI_RX_PHY_REGD41_p2_pfd_en_fsm_reg(data)                          (0x00020000&((data)<<17))
#define  DFE_HDMI_RX_PHY_REGD41_p2_slope_lv_reg(data)                            (0x0001F000&((data)<<12))
#define  DFE_HDMI_RX_PHY_REGD41_p2_slope_hv_reg(data)                            (0x00000F80&((data)<<7))
#define  DFE_HDMI_RX_PHY_REGD41_p2_slope_final_reg(data)                         (0x0000007C&((data)<<2))
#define  DFE_HDMI_RX_PHY_REGD41_get_p2_fld_st_reg(data)                          ((0xF8000000&(data))>>27)
#define  DFE_HDMI_RX_PHY_REGD41_get_p2_adp_en_fsm_reg(data)                      ((0x04000000&(data))>>26)
#define  DFE_HDMI_RX_PHY_REGD41_get_p2_cp_en_fsm_reg(data)                       ((0x02000000&(data))>>25)
#define  DFE_HDMI_RX_PHY_REGD41_get_p2_coarse_fsm_reg(data)                      ((0x01FC0000&(data))>>18)
#define  DFE_HDMI_RX_PHY_REGD41_get_p2_pfd_en_fsm_reg(data)                      ((0x00020000&(data))>>17)
#define  DFE_HDMI_RX_PHY_REGD41_get_p2_slope_lv_reg(data)                        ((0x0001F000&(data))>>12)
#define  DFE_HDMI_RX_PHY_REGD41_get_p2_slope_hv_reg(data)                        ((0x00000F80&(data))>>7)
#define  DFE_HDMI_RX_PHY_REGD41_get_p2_slope_final_reg(data)                     ((0x0000007C&(data))>>2)

#define  DFE_HDMI_RX_PHY_REGD42                                                  0x1800DBC4
#define  DFE_HDMI_RX_PHY_REGD42_reg_addr                                         "0xB800DBC4"
#define  DFE_HDMI_RX_PHY_REGD42_reg                                              0xB800DBC4
#define  DFE_HDMI_RX_PHY_REGD42_inst_addr                                        "0x006C"
#define  set_DFE_HDMI_RX_PHY_REGD42_reg(data)                                    (*((volatile unsigned int*)DFE_HDMI_RX_PHY_REGD42_reg)=data)
#define  get_DFE_HDMI_RX_PHY_REGD42_reg                                          (*((volatile unsigned int*)DFE_HDMI_RX_PHY_REGD42_reg))
#define  DFE_HDMI_RX_PHY_REGD42_p0_ck_md_rstb_shift                              (31)
#define  DFE_HDMI_RX_PHY_REGD42_reg_p0_ck_md_threshold_shift                     (25)
#define  DFE_HDMI_RX_PHY_REGD42_reg_p0_ck_md_debounce_shift                      (18)
#define  DFE_HDMI_RX_PHY_REGD42_reg_p0_ck_md_sel_shift                           (16)
#define  DFE_HDMI_RX_PHY_REGD42_reg_p0_ck_md_auto_shift                          (15)
#define  DFE_HDMI_RX_PHY_REGD42_reg_p0_ck_md_adj_shift                           (11)
#define  DFE_HDMI_RX_PHY_REGD42_reg_p0_ck_error_limit_shift                      (6)
#define  DFE_HDMI_RX_PHY_REGD42_reg_p0_ck_md_reserved_shift                      (2)
#define  DFE_HDMI_RX_PHY_REGD42_p0_ck_md_rstb_mask                               (0x80000000)
#define  DFE_HDMI_RX_PHY_REGD42_reg_p0_ck_md_threshold_mask                      (0x7E000000)
#define  DFE_HDMI_RX_PHY_REGD42_reg_p0_ck_md_debounce_mask                       (0x01FC0000)
#define  DFE_HDMI_RX_PHY_REGD42_reg_p0_ck_md_sel_mask                            (0x00030000)
#define  DFE_HDMI_RX_PHY_REGD42_reg_p0_ck_md_auto_mask                           (0x00008000)
#define  DFE_HDMI_RX_PHY_REGD42_reg_p0_ck_md_adj_mask                            (0x00007800)
#define  DFE_HDMI_RX_PHY_REGD42_reg_p0_ck_error_limit_mask                       (0x000007C0)
#define  DFE_HDMI_RX_PHY_REGD42_reg_p0_ck_md_reserved_mask                       (0x0000003C)
#define  DFE_HDMI_RX_PHY_REGD42_p0_ck_md_rstb(data)                              (0x80000000&((data)<<31))
#define  DFE_HDMI_RX_PHY_REGD42_reg_p0_ck_md_threshold(data)                     (0x7E000000&((data)<<25))
#define  DFE_HDMI_RX_PHY_REGD42_reg_p0_ck_md_debounce(data)                      (0x01FC0000&((data)<<18))
#define  DFE_HDMI_RX_PHY_REGD42_reg_p0_ck_md_sel(data)                           (0x00030000&((data)<<16))
#define  DFE_HDMI_RX_PHY_REGD42_reg_p0_ck_md_auto(data)                          (0x00008000&((data)<<15))
#define  DFE_HDMI_RX_PHY_REGD42_reg_p0_ck_md_adj(data)                           (0x00007800&((data)<<11))
#define  DFE_HDMI_RX_PHY_REGD42_reg_p0_ck_error_limit(data)                      (0x000007C0&((data)<<6))
#define  DFE_HDMI_RX_PHY_REGD42_reg_p0_ck_md_reserved(data)                      (0x0000003C&((data)<<2))
#define  DFE_HDMI_RX_PHY_REGD42_get_p0_ck_md_rstb(data)                          ((0x80000000&(data))>>31)
#define  DFE_HDMI_RX_PHY_REGD42_get_reg_p0_ck_md_threshold(data)                 ((0x7E000000&(data))>>25)
#define  DFE_HDMI_RX_PHY_REGD42_get_reg_p0_ck_md_debounce(data)                  ((0x01FC0000&(data))>>18)
#define  DFE_HDMI_RX_PHY_REGD42_get_reg_p0_ck_md_sel(data)                       ((0x00030000&(data))>>16)
#define  DFE_HDMI_RX_PHY_REGD42_get_reg_p0_ck_md_auto(data)                      ((0x00008000&(data))>>15)
#define  DFE_HDMI_RX_PHY_REGD42_get_reg_p0_ck_md_adj(data)                       ((0x00007800&(data))>>11)
#define  DFE_HDMI_RX_PHY_REGD42_get_reg_p0_ck_error_limit(data)                  ((0x000007C0&(data))>>6)
#define  DFE_HDMI_RX_PHY_REGD42_get_reg_p0_ck_md_reserved(data)                  ((0x0000003C&(data))>>2)

#define  DFE_HDMI_RX_PHY_REGD43                                                  0x1800DBC8
#define  DFE_HDMI_RX_PHY_REGD43_reg_addr                                         "0xB800DBC8"
#define  DFE_HDMI_RX_PHY_REGD43_reg                                              0xB800DBC8
#define  DFE_HDMI_RX_PHY_REGD43_inst_addr                                        "0x006D"
#define  set_DFE_HDMI_RX_PHY_REGD43_reg(data)                                    (*((volatile unsigned int*)DFE_HDMI_RX_PHY_REGD43_reg)=data)
#define  get_DFE_HDMI_RX_PHY_REGD43_reg                                          (*((volatile unsigned int*)DFE_HDMI_RX_PHY_REGD43_reg))
#define  DFE_HDMI_RX_PHY_REGD43_p0_ck_md_count_shift                             (19)
#define  DFE_HDMI_RX_PHY_REGD43_p0_ck_rate_shift                                 (15)
#define  DFE_HDMI_RX_PHY_REGD43_p0_unstable_count_shift                          (10)
#define  DFE_HDMI_RX_PHY_REGD43_p0_ck_md_ok_shift                                (9)
#define  DFE_HDMI_RX_PHY_REGD43_p0_clock_unstable_flag_shift                     (8)
#define  DFE_HDMI_RX_PHY_REGD43_p0_ck_md_count_mask                              (0xFFF80000)
#define  DFE_HDMI_RX_PHY_REGD43_p0_ck_rate_mask                                  (0x00078000)
#define  DFE_HDMI_RX_PHY_REGD43_p0_unstable_count_mask                           (0x00007C00)
#define  DFE_HDMI_RX_PHY_REGD43_p0_ck_md_ok_mask                                 (0x00000200)
#define  DFE_HDMI_RX_PHY_REGD43_p0_clock_unstable_flag_mask                      (0x00000100)
#define  DFE_HDMI_RX_PHY_REGD43_p0_ck_md_count(data)                             (0xFFF80000&((data)<<19))
#define  DFE_HDMI_RX_PHY_REGD43_p0_ck_rate(data)                                 (0x00078000&((data)<<15))
#define  DFE_HDMI_RX_PHY_REGD43_p0_unstable_count(data)                          (0x00007C00&((data)<<10))
#define  DFE_HDMI_RX_PHY_REGD43_p0_ck_md_ok(data)                                (0x00000200&((data)<<9))
#define  DFE_HDMI_RX_PHY_REGD43_p0_clock_unstable_flag(data)                     (0x00000100&((data)<<8))
#define  DFE_HDMI_RX_PHY_REGD43_get_p0_ck_md_count(data)                         ((0xFFF80000&(data))>>19)
#define  DFE_HDMI_RX_PHY_REGD43_get_p0_ck_rate(data)                             ((0x00078000&(data))>>15)
#define  DFE_HDMI_RX_PHY_REGD43_get_p0_unstable_count(data)                      ((0x00007C00&(data))>>10)
#define  DFE_HDMI_RX_PHY_REGD43_get_p0_ck_md_ok(data)                            ((0x00000200&(data))>>9)
#define  DFE_HDMI_RX_PHY_REGD43_get_p0_clock_unstable_flag(data)                 ((0x00000100&(data))>>8)

#define  DFE_HDMI_RX_PHY_REGD44                                                  0x1800DBCC
#define  DFE_HDMI_RX_PHY_REGD44_reg_addr                                         "0xB800DBCC"
#define  DFE_HDMI_RX_PHY_REGD44_reg                                              0xB800DBCC
#define  DFE_HDMI_RX_PHY_REGD44_inst_addr                                        "0x006E"
#define  set_DFE_HDMI_RX_PHY_REGD44_reg(data)                                    (*((volatile unsigned int*)DFE_HDMI_RX_PHY_REGD44_reg)=data)
#define  get_DFE_HDMI_RX_PHY_REGD44_reg                                          (*((volatile unsigned int*)DFE_HDMI_RX_PHY_REGD44_reg))
#define  DFE_HDMI_RX_PHY_REGD44_p1_ck_md_rstb_shift                              (31)
#define  DFE_HDMI_RX_PHY_REGD44_reg_p1_ck_md_threshold_shift                     (25)
#define  DFE_HDMI_RX_PHY_REGD44_reg_p1_ck_md_debounce_shift                      (18)
#define  DFE_HDMI_RX_PHY_REGD44_reg_p1_ck_md_sel_shift                           (16)
#define  DFE_HDMI_RX_PHY_REGD44_reg_p1_ck_md_auto_shift                          (15)
#define  DFE_HDMI_RX_PHY_REGD44_reg_p1_ck_md_adj_shift                           (11)
#define  DFE_HDMI_RX_PHY_REGD44_reg_p1_ck_error_limit_shift                      (6)
#define  DFE_HDMI_RX_PHY_REGD44_reg_p1_ck_md_reserved_shift                      (2)
#define  DFE_HDMI_RX_PHY_REGD44_p1_ck_md_rstb_mask                               (0x80000000)
#define  DFE_HDMI_RX_PHY_REGD44_reg_p1_ck_md_threshold_mask                      (0x7E000000)
#define  DFE_HDMI_RX_PHY_REGD44_reg_p1_ck_md_debounce_mask                       (0x01FC0000)
#define  DFE_HDMI_RX_PHY_REGD44_reg_p1_ck_md_sel_mask                            (0x00030000)
#define  DFE_HDMI_RX_PHY_REGD44_reg_p1_ck_md_auto_mask                           (0x00008000)
#define  DFE_HDMI_RX_PHY_REGD44_reg_p1_ck_md_adj_mask                            (0x00007800)
#define  DFE_HDMI_RX_PHY_REGD44_reg_p1_ck_error_limit_mask                       (0x000007C0)
#define  DFE_HDMI_RX_PHY_REGD44_reg_p1_ck_md_reserved_mask                       (0x0000003C)
#define  DFE_HDMI_RX_PHY_REGD44_p1_ck_md_rstb(data)                              (0x80000000&((data)<<31))
#define  DFE_HDMI_RX_PHY_REGD44_reg_p1_ck_md_threshold(data)                     (0x7E000000&((data)<<25))
#define  DFE_HDMI_RX_PHY_REGD44_reg_p1_ck_md_debounce(data)                      (0x01FC0000&((data)<<18))
#define  DFE_HDMI_RX_PHY_REGD44_reg_p1_ck_md_sel(data)                           (0x00030000&((data)<<16))
#define  DFE_HDMI_RX_PHY_REGD44_reg_p1_ck_md_auto(data)                          (0x00008000&((data)<<15))
#define  DFE_HDMI_RX_PHY_REGD44_reg_p1_ck_md_adj(data)                           (0x00007800&((data)<<11))
#define  DFE_HDMI_RX_PHY_REGD44_reg_p1_ck_error_limit(data)                      (0x000007C0&((data)<<6))
#define  DFE_HDMI_RX_PHY_REGD44_reg_p1_ck_md_reserved(data)                      (0x0000003C&((data)<<2))
#define  DFE_HDMI_RX_PHY_REGD44_get_p1_ck_md_rstb(data)                          ((0x80000000&(data))>>31)
#define  DFE_HDMI_RX_PHY_REGD44_get_reg_p1_ck_md_threshold(data)                 ((0x7E000000&(data))>>25)
#define  DFE_HDMI_RX_PHY_REGD44_get_reg_p1_ck_md_debounce(data)                  ((0x01FC0000&(data))>>18)
#define  DFE_HDMI_RX_PHY_REGD44_get_reg_p1_ck_md_sel(data)                       ((0x00030000&(data))>>16)
#define  DFE_HDMI_RX_PHY_REGD44_get_reg_p1_ck_md_auto(data)                      ((0x00008000&(data))>>15)
#define  DFE_HDMI_RX_PHY_REGD44_get_reg_p1_ck_md_adj(data)                       ((0x00007800&(data))>>11)
#define  DFE_HDMI_RX_PHY_REGD44_get_reg_p1_ck_error_limit(data)                  ((0x000007C0&(data))>>6)
#define  DFE_HDMI_RX_PHY_REGD44_get_reg_p1_ck_md_reserved(data)                  ((0x0000003C&(data))>>2)

#define  DFE_HDMI_RX_PHY_REGD45                                                  0x1800DBD0
#define  DFE_HDMI_RX_PHY_REGD45_reg_addr                                         "0xB800DBD0"
#define  DFE_HDMI_RX_PHY_REGD45_reg                                              0xB800DBD0
#define  DFE_HDMI_RX_PHY_REGD45_inst_addr                                        "0x006F"
#define  set_DFE_HDMI_RX_PHY_REGD45_reg(data)                                    (*((volatile unsigned int*)DFE_HDMI_RX_PHY_REGD45_reg)=data)
#define  get_DFE_HDMI_RX_PHY_REGD45_reg                                          (*((volatile unsigned int*)DFE_HDMI_RX_PHY_REGD45_reg))
#define  DFE_HDMI_RX_PHY_REGD45_p1_ck_md_count_shift                             (19)
#define  DFE_HDMI_RX_PHY_REGD45_p1_ck_rate_shift                                 (15)
#define  DFE_HDMI_RX_PHY_REGD45_p1_unstable_count_shift                          (10)
#define  DFE_HDMI_RX_PHY_REGD45_p1_ck_md_ok_shift                                (9)
#define  DFE_HDMI_RX_PHY_REGD45_p1_clock_unstable_flag_shift                     (8)
#define  DFE_HDMI_RX_PHY_REGD45_p1_ck_md_count_mask                              (0xFFF80000)
#define  DFE_HDMI_RX_PHY_REGD45_p1_ck_rate_mask                                  (0x00078000)
#define  DFE_HDMI_RX_PHY_REGD45_p1_unstable_count_mask                           (0x00007C00)
#define  DFE_HDMI_RX_PHY_REGD45_p1_ck_md_ok_mask                                 (0x00000200)
#define  DFE_HDMI_RX_PHY_REGD45_p1_clock_unstable_flag_mask                      (0x00000100)
#define  DFE_HDMI_RX_PHY_REGD45_p1_ck_md_count(data)                             (0xFFF80000&((data)<<19))
#define  DFE_HDMI_RX_PHY_REGD45_p1_ck_rate(data)                                 (0x00078000&((data)<<15))
#define  DFE_HDMI_RX_PHY_REGD45_p1_unstable_count(data)                          (0x00007C00&((data)<<10))
#define  DFE_HDMI_RX_PHY_REGD45_p1_ck_md_ok(data)                                (0x00000200&((data)<<9))
#define  DFE_HDMI_RX_PHY_REGD45_p1_clock_unstable_flag(data)                     (0x00000100&((data)<<8))
#define  DFE_HDMI_RX_PHY_REGD45_get_p1_ck_md_count(data)                         ((0xFFF80000&(data))>>19)
#define  DFE_HDMI_RX_PHY_REGD45_get_p1_ck_rate(data)                             ((0x00078000&(data))>>15)
#define  DFE_HDMI_RX_PHY_REGD45_get_p1_unstable_count(data)                      ((0x00007C00&(data))>>10)
#define  DFE_HDMI_RX_PHY_REGD45_get_p1_ck_md_ok(data)                            ((0x00000200&(data))>>9)
#define  DFE_HDMI_RX_PHY_REGD45_get_p1_clock_unstable_flag(data)                 ((0x00000100&(data))>>8)

#define  DFE_HDMI_RX_PHY_REGD46                                                  0x1800DBD4
#define  DFE_HDMI_RX_PHY_REGD46_reg_addr                                         "0xB800DBD4"
#define  DFE_HDMI_RX_PHY_REGD46_reg                                              0xB800DBD4
#define  DFE_HDMI_RX_PHY_REGD46_inst_addr                                        "0x0070"
#define  set_DFE_HDMI_RX_PHY_REGD46_reg(data)                                    (*((volatile unsigned int*)DFE_HDMI_RX_PHY_REGD46_reg)=data)
#define  get_DFE_HDMI_RX_PHY_REGD46_reg                                          (*((volatile unsigned int*)DFE_HDMI_RX_PHY_REGD46_reg))
#define  DFE_HDMI_RX_PHY_REGD46_p2_ck_md_rstb_shift                              (31)
#define  DFE_HDMI_RX_PHY_REGD46_reg_p2_ck_md_threshold_shift                     (25)
#define  DFE_HDMI_RX_PHY_REGD46_reg_p2_ck_md_debounce_shift                      (18)
#define  DFE_HDMI_RX_PHY_REGD46_reg_p2_ck_md_sel_shift                           (16)
#define  DFE_HDMI_RX_PHY_REGD46_reg_p2_ck_md_auto_shift                          (15)
#define  DFE_HDMI_RX_PHY_REGD46_reg_p2_ck_md_adj_shift                           (11)
#define  DFE_HDMI_RX_PHY_REGD46_reg_p2_ck_error_limit_shift                      (6)
#define  DFE_HDMI_RX_PHY_REGD46_reg_p2_ck_md_reserved_shift                      (2)
#define  DFE_HDMI_RX_PHY_REGD46_p2_ck_md_rstb_mask                               (0x80000000)
#define  DFE_HDMI_RX_PHY_REGD46_reg_p2_ck_md_threshold_mask                      (0x7E000000)
#define  DFE_HDMI_RX_PHY_REGD46_reg_p2_ck_md_debounce_mask                       (0x01FC0000)
#define  DFE_HDMI_RX_PHY_REGD46_reg_p2_ck_md_sel_mask                            (0x00030000)
#define  DFE_HDMI_RX_PHY_REGD46_reg_p2_ck_md_auto_mask                           (0x00008000)
#define  DFE_HDMI_RX_PHY_REGD46_reg_p2_ck_md_adj_mask                            (0x00007800)
#define  DFE_HDMI_RX_PHY_REGD46_reg_p2_ck_error_limit_mask                       (0x000007C0)
#define  DFE_HDMI_RX_PHY_REGD46_reg_p2_ck_md_reserved_mask                       (0x0000003C)
#define  DFE_HDMI_RX_PHY_REGD46_p2_ck_md_rstb(data)                              (0x80000000&((data)<<31))
#define  DFE_HDMI_RX_PHY_REGD46_reg_p2_ck_md_threshold(data)                     (0x7E000000&((data)<<25))
#define  DFE_HDMI_RX_PHY_REGD46_reg_p2_ck_md_debounce(data)                      (0x01FC0000&((data)<<18))
#define  DFE_HDMI_RX_PHY_REGD46_reg_p2_ck_md_sel(data)                           (0x00030000&((data)<<16))
#define  DFE_HDMI_RX_PHY_REGD46_reg_p2_ck_md_auto(data)                          (0x00008000&((data)<<15))
#define  DFE_HDMI_RX_PHY_REGD46_reg_p2_ck_md_adj(data)                           (0x00007800&((data)<<11))
#define  DFE_HDMI_RX_PHY_REGD46_reg_p2_ck_error_limit(data)                      (0x000007C0&((data)<<6))
#define  DFE_HDMI_RX_PHY_REGD46_reg_p2_ck_md_reserved(data)                      (0x0000003C&((data)<<2))
#define  DFE_HDMI_RX_PHY_REGD46_get_p2_ck_md_rstb(data)                          ((0x80000000&(data))>>31)
#define  DFE_HDMI_RX_PHY_REGD46_get_reg_p2_ck_md_threshold(data)                 ((0x7E000000&(data))>>25)
#define  DFE_HDMI_RX_PHY_REGD46_get_reg_p2_ck_md_debounce(data)                  ((0x01FC0000&(data))>>18)
#define  DFE_HDMI_RX_PHY_REGD46_get_reg_p2_ck_md_sel(data)                       ((0x00030000&(data))>>16)
#define  DFE_HDMI_RX_PHY_REGD46_get_reg_p2_ck_md_auto(data)                      ((0x00008000&(data))>>15)
#define  DFE_HDMI_RX_PHY_REGD46_get_reg_p2_ck_md_adj(data)                       ((0x00007800&(data))>>11)
#define  DFE_HDMI_RX_PHY_REGD46_get_reg_p2_ck_error_limit(data)                  ((0x000007C0&(data))>>6)
#define  DFE_HDMI_RX_PHY_REGD46_get_reg_p2_ck_md_reserved(data)                  ((0x0000003C&(data))>>2)

#define  DFE_HDMI_RX_PHY_REGD47                                                  0x1800DBD8
#define  DFE_HDMI_RX_PHY_REGD47_reg_addr                                         "0xB800DBD8"
#define  DFE_HDMI_RX_PHY_REGD47_reg                                              0xB800DBD8
#define  DFE_HDMI_RX_PHY_REGD47_inst_addr                                        "0x0071"
#define  set_DFE_HDMI_RX_PHY_REGD47_reg(data)                                    (*((volatile unsigned int*)DFE_HDMI_RX_PHY_REGD47_reg)=data)
#define  get_DFE_HDMI_RX_PHY_REGD47_reg                                          (*((volatile unsigned int*)DFE_HDMI_RX_PHY_REGD47_reg))
#define  DFE_HDMI_RX_PHY_REGD47_p2_ck_md_count_shift                             (19)
#define  DFE_HDMI_RX_PHY_REGD47_p2_ck_rate_shift                                 (15)
#define  DFE_HDMI_RX_PHY_REGD47_p2_unstable_count_shift                          (10)
#define  DFE_HDMI_RX_PHY_REGD47_p2_ck_md_ok_shift                                (9)
#define  DFE_HDMI_RX_PHY_REGD47_p2_clock_unstable_flag_shift                     (8)
#define  DFE_HDMI_RX_PHY_REGD47_p2_ck_md_count_mask                              (0xFFF80000)
#define  DFE_HDMI_RX_PHY_REGD47_p2_ck_rate_mask                                  (0x00078000)
#define  DFE_HDMI_RX_PHY_REGD47_p2_unstable_count_mask                           (0x00007C00)
#define  DFE_HDMI_RX_PHY_REGD47_p2_ck_md_ok_mask                                 (0x00000200)
#define  DFE_HDMI_RX_PHY_REGD47_p2_clock_unstable_flag_mask                      (0x00000100)
#define  DFE_HDMI_RX_PHY_REGD47_p2_ck_md_count(data)                             (0xFFF80000&((data)<<19))
#define  DFE_HDMI_RX_PHY_REGD47_p2_ck_rate(data)                                 (0x00078000&((data)<<15))
#define  DFE_HDMI_RX_PHY_REGD47_p2_unstable_count(data)                          (0x00007C00&((data)<<10))
#define  DFE_HDMI_RX_PHY_REGD47_p2_ck_md_ok(data)                                (0x00000200&((data)<<9))
#define  DFE_HDMI_RX_PHY_REGD47_p2_clock_unstable_flag(data)                     (0x00000100&((data)<<8))
#define  DFE_HDMI_RX_PHY_REGD47_get_p2_ck_md_count(data)                         ((0xFFF80000&(data))>>19)
#define  DFE_HDMI_RX_PHY_REGD47_get_p2_ck_rate(data)                             ((0x00078000&(data))>>15)
#define  DFE_HDMI_RX_PHY_REGD47_get_p2_unstable_count(data)                      ((0x00007C00&(data))>>10)
#define  DFE_HDMI_RX_PHY_REGD47_get_p2_ck_md_ok(data)                            ((0x00000200&(data))>>9)
#define  DFE_HDMI_RX_PHY_REGD47_get_p2_clock_unstable_flag(data)                 ((0x00000100&(data))>>8)

#define  DFE_HDMI_RX_PHY_REGD48                                                  0x1800DBDC
#define  DFE_HDMI_RX_PHY_REGD48_reg_addr                                         "0xB800DBDC"
#define  DFE_HDMI_RX_PHY_REGD48_reg                                              0xB800DBDC
#define  DFE_HDMI_RX_PHY_REGD48_inst_addr                                        "0x0072"
#define  set_DFE_HDMI_RX_PHY_REGD48_reg(data)                                    (*((volatile unsigned int*)DFE_HDMI_RX_PHY_REGD48_reg)=data)
#define  get_DFE_HDMI_RX_PHY_REGD48_reg                                          (*((volatile unsigned int*)DFE_HDMI_RX_PHY_REGD48_reg))
#define  DFE_HDMI_RX_PHY_REGD48_reg_dig_debug_sel_shift                          (28)
#define  DFE_HDMI_RX_PHY_REGD48_reg_dig_reserved_0_shift                         (20)
#define  DFE_HDMI_RX_PHY_REGD48_reg_dig_reserved_1_shift                         (12)
#define  DFE_HDMI_RX_PHY_REGD48_reg_dig_reserved_2_shift                         (4)
#define  DFE_HDMI_RX_PHY_REGD48_reg_dig_debug_sel_mask                           (0xF0000000)
#define  DFE_HDMI_RX_PHY_REGD48_reg_dig_reserved_0_mask                          (0x0FF00000)
#define  DFE_HDMI_RX_PHY_REGD48_reg_dig_reserved_1_mask                          (0x000FF000)
#define  DFE_HDMI_RX_PHY_REGD48_reg_dig_reserved_2_mask                          (0x00000FF0)
#define  DFE_HDMI_RX_PHY_REGD48_reg_dig_debug_sel(data)                          (0xF0000000&((data)<<28))
#define  DFE_HDMI_RX_PHY_REGD48_reg_dig_reserved_0(data)                         (0x0FF00000&((data)<<20))
#define  DFE_HDMI_RX_PHY_REGD48_reg_dig_reserved_1(data)                         (0x000FF000&((data)<<12))
#define  DFE_HDMI_RX_PHY_REGD48_reg_dig_reserved_2(data)                         (0x00000FF0&((data)<<4))
#define  DFE_HDMI_RX_PHY_REGD48_get_reg_dig_debug_sel(data)                      ((0xF0000000&(data))>>28)
#define  DFE_HDMI_RX_PHY_REGD48_get_reg_dig_reserved_0(data)                     ((0x0FF00000&(data))>>20)
#define  DFE_HDMI_RX_PHY_REGD48_get_reg_dig_reserved_1(data)                     ((0x000FF000&(data))>>12)
#define  DFE_HDMI_RX_PHY_REGD48_get_reg_dig_reserved_2(data)                     ((0x00000FF0&(data))>>4)

#endif




// End of PHY
#ifdef HDMI_HAVE_HDMI_3D_TG
// HDMI 3D DMA register

#define HDMIDMA_LR_SEPARATE_CTRL1                                             0x18025800
#define HDMIDMA_LR_SEPARATE_CTRL1_reg_addr                                    "0xb8025800"
#define HDMIDMA_LR_SEPARATE_CTRL1_reg                                         0xb8025800
#define HDMIDMA_LR_SEPARATE_CTRL1_inst_addr                                   "0x0200"
#define HDMIDMA_LR_SEPARATE_CTRL1_inst                                        0x0200
#define HDMIDMA_LR_SEPARATE_CTRL1_dummy_lr_ctrl1_shift                        (26)
#define HDMIDMA_LR_SEPARATE_CTRL1_chess_board_format_shift                    (25)
#define HDMIDMA_LR_SEPARATE_CTRL1_hdmi_3d_sel_shift                           (24)
#define HDMIDMA_LR_SEPARATE_CTRL1_vs_inv_shift                                (23)
#define HDMIDMA_LR_SEPARATE_CTRL1_hs_inv_shift                                (22)
#define HDMIDMA_LR_SEPARATE_CTRL1_progressive_shift                           (20)
#define HDMIDMA_LR_SEPARATE_CTRL1_hdmi_3d_structure_shift                     (16)
#define HDMIDMA_LR_SEPARATE_CTRL1_fp_vact_space1_shift                        (8)
#define HDMIDMA_LR_SEPARATE_CTRL1_fp_vact_space2_shift                        (0)
#define HDMIDMA_LR_SEPARATE_CTRL1_dummy_lr_ctrl1_mask                         (0xFC000000)
#define HDMIDMA_LR_SEPARATE_CTRL1_chess_board_format_mask                     (0x02000000)
#define HDMIDMA_LR_SEPARATE_CTRL1_hdmi_3d_sel_mask                            (0x01000000)
#define HDMIDMA_LR_SEPARATE_CTRL1_vs_inv_mask                                 (0x00800000)
#define HDMIDMA_LR_SEPARATE_CTRL1_hs_inv_mask                                 (0x00400000)
#define HDMIDMA_LR_SEPARATE_CTRL1_progressive_mask                            (0x00100000)
#define HDMIDMA_LR_SEPARATE_CTRL1_hdmi_3d_structure_mask                      (0x000F0000)
#define HDMIDMA_LR_SEPARATE_CTRL1_fp_vact_space1_mask                         (0x0000FF00)
#define HDMIDMA_LR_SEPARATE_CTRL1_fp_vact_space2_mask                         (0x000000FF)
#define HDMIDMA_LR_SEPARATE_CTRL1_dummy_lr_ctrl1(data)                        (0xFC000000&((data)<<26))
#define HDMIDMA_LR_SEPARATE_CTRL1_chess_board_format(data)                    (0x02000000&((data)<<25))
#define HDMIDMA_LR_SEPARATE_CTRL1_hdmi_3d_sel(data)                           (0x01000000&((data)<<24))
#define HDMIDMA_LR_SEPARATE_CTRL1_vs_inv(data)                                (0x00800000&((data)<<23))
#define HDMIDMA_LR_SEPARATE_CTRL1_hs_inv(data)                                (0x00400000&((data)<<22))
#define HDMIDMA_LR_SEPARATE_CTRL1_progressive(data)                           (0x00100000&((data)<<20))
#define HDMIDMA_LR_SEPARATE_CTRL1_hdmi_3d_structure(data)                     (0x000F0000&((data)<<16))
#define HDMIDMA_LR_SEPARATE_CTRL1_fp_vact_space1(data)                        (0x0000FF00&((data)<<8))
#define HDMIDMA_LR_SEPARATE_CTRL1_fp_vact_space2(data)                        (0x000000FF&(data))
#define HDMIDMA_LR_SEPARATE_CTRL1_get_dummy_lr_ctrl1(data)                    ((0xFC000000&(data))>>26)
#define HDMIDMA_LR_SEPARATE_CTRL1_get_chess_board_format(data)                ((0x02000000&(data))>>25)
#define HDMIDMA_LR_SEPARATE_CTRL1_get_hdmi_3d_sel(data)                       ((0x01000000&(data))>>24)
#define HDMIDMA_LR_SEPARATE_CTRL1_get_vs_inv(data)                            ((0x00800000&(data))>>23)
#define HDMIDMA_LR_SEPARATE_CTRL1_get_hs_inv(data)                            ((0x00400000&(data))>>22)
#define HDMIDMA_LR_SEPARATE_CTRL1_get_progressive(data)                       ((0x00100000&(data))>>20)
#define HDMIDMA_LR_SEPARATE_CTRL1_get_hdmi_3d_structure(data)                 ((0x000F0000&(data))>>16)
#define HDMIDMA_LR_SEPARATE_CTRL1_get_fp_vact_space1(data)                    ((0x0000FF00&(data))>>8)
#define HDMIDMA_LR_SEPARATE_CTRL1_get_fp_vact_space2(data)                    (0x000000FF&(data))


#define HDMIDMA_LR_SEPARATE_CTRL2                                             0x18025804
#define HDMIDMA_LR_SEPARATE_CTRL2_reg_addr                                    "0xb8025804"
#define HDMIDMA_LR_SEPARATE_CTRL2_reg                                         0xb8025804
#define HDMIDMA_LR_SEPARATE_CTRL2_inst_addr                                   "0x0201"
#define HDMIDMA_LR_SEPARATE_CTRL2_inst                                        0x0201
#define HDMIDMA_LR_SEPARATE_CTRL2_vact_shift                                  (16)
#define HDMIDMA_LR_SEPARATE_CTRL2_hact_shift                                  (0)
#define HDMIDMA_LR_SEPARATE_CTRL2_vact_mask                                   (0xFFFF0000)
#define HDMIDMA_LR_SEPARATE_CTRL2_hact_mask                                   (0x00007FFF)
#define HDMIDMA_LR_SEPARATE_CTRL2_vact(data)                                  (0xFFFF0000&((data)<<16))
#define HDMIDMA_LR_SEPARATE_CTRL2_hact(data)                                  (0x00007FFF&(data))
#define HDMIDMA_LR_SEPARATE_CTRL2_get_vact(data)                              ((0xFFFF0000&(data))>>16)
#define HDMIDMA_LR_SEPARATE_CTRL2_get_hact(data)                              (0x00007FFF&(data))


#define HDMIDMA_LR_SEPARATE_INSERT_VS_START                                   0x18025808
#define HDMIDMA_LR_SEPARATE_INSERT_VS_START_reg_addr                          "0xb8025808"
#define HDMIDMA_LR_SEPARATE_INSERT_VS_START_reg                               0xb8025808
#define HDMIDMA_LR_SEPARATE_INSERT_VS_START_inst_addr                         "0x0202"
#define HDMIDMA_LR_SEPARATE_INSERT_VS_START_inst                              0x0202
#define HDMIDMA_LR_SEPARATE_INSERT_VS_START_hstart_shift                      (8)
#define HDMIDMA_LR_SEPARATE_INSERT_VS_START_vstart_shift                      (0)
#define HDMIDMA_LR_SEPARATE_INSERT_VS_START_hstart_mask                       (0x001FFF00)
#define HDMIDMA_LR_SEPARATE_INSERT_VS_START_vstart_mask                       (0x000000FF)
#define HDMIDMA_LR_SEPARATE_INSERT_VS_START_hstart(data)                      (0x001FFF00&((data)<<8))
#define HDMIDMA_LR_SEPARATE_INSERT_VS_START_vstart(data)                      (0x000000FF&(data))
#define HDMIDMA_LR_SEPARATE_INSERT_VS_START_get_hstart(data)                  ((0x001FFF00&(data))>>8)
#define HDMIDMA_LR_SEPARATE_INSERT_VS_START_get_vstart(data)                  (0x000000FF&(data))


#define HDMIDMA_LR_SEPARATE_INSERT_VS_END                                     0x1802580c
#define HDMIDMA_LR_SEPARATE_INSERT_VS_END_reg_addr                            "0xb802580c"
#define HDMIDMA_LR_SEPARATE_INSERT_VS_END_reg                                 0xb802580c
#define HDMIDMA_LR_SEPARATE_INSERT_VS_END_inst_addr                           "0x0203"
#define HDMIDMA_LR_SEPARATE_INSERT_VS_END_inst                                0x0203
#define HDMIDMA_LR_SEPARATE_INSERT_VS_END_hend_shift                          (8)
#define HDMIDMA_LR_SEPARATE_INSERT_VS_END_vend_shift                          (0)
#define HDMIDMA_LR_SEPARATE_INSERT_VS_END_hend_mask                           (0x001FFF00)
#define HDMIDMA_LR_SEPARATE_INSERT_VS_END_vend_mask                           (0x000000FF)
#define HDMIDMA_LR_SEPARATE_INSERT_VS_END_hend(data)                          (0x001FFF00&((data)<<8))
#define HDMIDMA_LR_SEPARATE_INSERT_VS_END_vend(data)                          (0x000000FF&(data))
#define HDMIDMA_LR_SEPARATE_INSERT_VS_END_get_hend(data)                      ((0x001FFF00&(data))>>8)
#define HDMIDMA_LR_SEPARATE_INSERT_VS_END_get_vend(data)                      (0x000000FF&(data))


// HDMI Timing Generator

#define HDMI_TG_V1_END                                                     0x1802583c
#define HDMI_TG_V1_END_reg_addr                                            "0xb802583c"
#define HDMI_TG_V1_END_reg                                                 0xb802583c
#define HDMI_TG_V1_END_inst_addr                                           "0x020F"
#define HDMI_TG_V1_END_inst                                                0x020F
#define HDMI_TG_V1_END_pullup_en_shift                                     (25)
#define HDMI_TG_V1_END_tg_hend1_shift                                      (8)
#define HDMI_TG_V1_END_tg_vend1_shift                                      (0)
#define HDMI_TG_V1_END_pullup_en_mask                                      (0x02000000)
#define HDMI_TG_V1_END_tg_hend1_mask                                       (0x001FFF00)
#define HDMI_TG_V1_END_tg_vend1_mask                                       (0x000000FF)
#define HDMI_TG_V1_END_pullup_en(data)                                     (0x02000000&((data)<<25))
#define HDMI_TG_V1_END_tg_hend1(data)                                      (0x001FFF00&((data)<<8))
#define HDMI_TG_V1_END_tg_vend1(data)                                      (0x000000FF&(data))
#define HDMI_TG_V1_END_get_pullup_en(data)                                 ((0x02000000&(data))>>25)
#define HDMI_TG_V1_END_get_tg_hend1(data)                                  ((0x001FFF00&(data))>>8)
#define HDMI_TG_V1_END_get_tg_vend1(data)                                  (0x000000FF&(data))


#define HDMI_TG_V2_START                                                   0x18025840
#define HDMI_TG_V2_START_reg_addr                                          "0xb8025840"
#define HDMI_TG_V2_START_reg                                               0xb8025840
#define HDMI_TG_V2_START_inst_addr                                         "0x0210"
#define HDMI_TG_V2_START_inst                                              0x0210
#define HDMI_TG_V2_START_tg_hstart2_shift                                  (16)
#define HDMI_TG_V2_START_tg_vstart2_shift                                  (0)
#define HDMI_TG_V2_START_tg_hstart2_mask                                   (0x1FFF0000)
#define HDMI_TG_V2_START_tg_vstart2_mask                                   (0x00001FFF)
#define HDMI_TG_V2_START_tg_hstart2(data)                                  (0x1FFF0000&((data)<<16))
#define HDMI_TG_V2_START_tg_vstart2(data)                                  (0x00001FFF&(data))
#define HDMI_TG_V2_START_get_tg_hstart2(data)                              ((0x1FFF0000&(data))>>16)
#define HDMI_TG_V2_START_get_tg_vstart2(data)                              (0x00001FFF&(data))


#define HDMI_TG_V2_END                                                     0x18025844
#define HDMI_TG_V2_END_reg_addr                                            "0xb8025844"
#define HDMI_TG_V2_END_reg                                                 0xb8025844
#define HDMI_TG_V2_END_inst_addr                                           "0x0211"
#define HDMI_TG_V2_END_inst                                                0x0211
#define HDMI_TG_V2_END_tg_hend2_shift                                      (16)
#define HDMI_TG_V2_END_tg_vend2_shift                                      (0)
#define HDMI_TG_V2_END_tg_hend2_mask                                       (0x1FFF0000)
#define HDMI_TG_V2_END_tg_vend2_mask                                       (0x00001FFF)
#define HDMI_TG_V2_END_tg_hend2(data)                                      (0x1FFF0000&((data)<<16))
#define HDMI_TG_V2_END_tg_vend2(data)                                      (0x00001FFF&(data))
#define HDMI_TG_V2_END_get_tg_hend2(data)                                  ((0x1FFF0000&(data))>>16)
#define HDMI_TG_V2_END_get_tg_vend2(data)                                  (0x00001FFF&(data))


#define HDMI_TG_V3_START                                                   0x18025848
#define HDMI_TG_V3_START_reg_addr                                          "0xb8025848"
#define HDMI_TG_V3_START_reg                                               0xb8025848
#define HDMI_TG_V3_START_inst_addr                                         "0x0212"
#define HDMI_TG_V3_START_inst                                              0x0212
#define HDMI_TG_V3_START_tg_hstart3_shift                                  (16)
#define HDMI_TG_V3_START_tg_vstart3_shift                                  (0)
#define HDMI_TG_V3_START_tg_hstart3_mask                                   (0x1FFF0000)
#define HDMI_TG_V3_START_tg_vstart3_mask                                   (0x00001FFF)
#define HDMI_TG_V3_START_tg_hstart3(data)                                  (0x1FFF0000&((data)<<16))
#define HDMI_TG_V3_START_tg_vstart3(data)                                  (0x00001FFF&(data))
#define HDMI_TG_V3_START_get_tg_hstart3(data)                              ((0x1FFF0000&(data))>>16)
#define HDMI_TG_V3_START_get_tg_vstart3(data)                              (0x00001FFF&(data))


#define HDMI_TG_V3_END                                                     0x1802584c
#define HDMI_TG_V3_END_reg_addr                                            "0xb802584c"
#define HDMI_TG_V3_END_reg                                                 0xb802584c
#define HDMI_TG_V3_END_inst_addr                                           "0x0213"
#define HDMI_TG_V3_END_inst                                                0x0213
#define HDMI_TG_V3_END_tg_hend3_shift                                      (16)
#define HDMI_TG_V3_END_tg_vend3_shift                                      (0)
#define HDMI_TG_V3_END_tg_hend3_mask                                       (0x1FFF0000)
#define HDMI_TG_V3_END_tg_vend3_mask                                       (0x00001FFF)
#define HDMI_TG_V3_END_tg_hend3(data)                                      (0x1FFF0000&((data)<<16))
#define HDMI_TG_V3_END_tg_vend3(data)                                      (0x00001FFF&(data))
#define HDMI_TG_V3_END_get_tg_hend3(data)                                  ((0x1FFF0000&(data))>>16)
#define HDMI_TG_V3_END_get_tg_vend3(data)                                  (0x00001FFF&(data))


#define HDMI_TG_V4_START                                                   0x18025850
#define HDMI_TG_V4_START_reg_addr                                          "0xb8025850"
#define HDMI_TG_V4_START_reg                                               0xb8025850
#define HDMI_TG_V4_START_inst_addr                                         "0x0214"
#define HDMI_TG_V4_START_inst                                              0x0214
#define HDMI_TG_V4_START_tg_hstart4_shift                                  (16)
#define HDMI_TG_V4_START_tg_vstart4_shift                                  (0)
#define HDMI_TG_V4_START_tg_hstart4_mask                                   (0x1FFF0000)
#define HDMI_TG_V4_START_tg_vstart4_mask                                   (0x00001FFF)
#define HDMI_TG_V4_START_tg_hstart4(data)                                  (0x1FFF0000&((data)<<16))
#define HDMI_TG_V4_START_tg_vstart4(data)                                  (0x00001FFF&(data))
#define HDMI_TG_V4_START_get_tg_hstart4(data)                              ((0x1FFF0000&(data))>>16)
#define HDMI_TG_V4_START_get_tg_vstart4(data)                              (0x00001FFF&(data))


#define HDMI_TG_V4_END                                                     0x18025854
#define HDMI_TG_V4_END_reg_addr                                            "0xb8025854"
#define HDMI_TG_V4_END_reg                                                 0xb8025854
#define HDMI_TG_V4_END_inst_addr                                           "0x0215"
#define HDMI_TG_V4_END_inst                                                0x0215
#define HDMI_TG_V4_END_tg_hend4_shift                                      (16)
#define HDMI_TG_V4_END_tg_vend4_shift                                      (0)
#define HDMI_TG_V4_END_tg_hend4_mask                                       (0x1FFF0000)
#define HDMI_TG_V4_END_tg_vend4_mask                                       (0x00001FFF)
#define HDMI_TG_V4_END_tg_hend4(data)                                      (0x1FFF0000&((data)<<16))
#define HDMI_TG_V4_END_tg_vend4(data)                                      (0x00001FFF&(data))
#define HDMI_TG_V4_END_get_tg_hend4(data)                                  ((0x1FFF0000&(data))>>16)
#define HDMI_TG_V4_END_get_tg_vend4(data)                                  (0x00001FFF&(data))

#endif         // end of 3DDMA

#ifdef HDMI_HAVE_HDMI_DMA
#define HDMIDMA_CAP_CTL0                                                      0x18025810
#define HDMIDMA_CAP_CTL0_reg_addr                                             "0xb8025810"
#define HDMIDMA_CAP_CTL0_reg                                                  0xb8025810
#define HDMIDMA_CAP_CTL0_inst_addr                                            "0x0204"
#define HDMIDMA_CAP_CTL0_inst                                                 0x0204
#define HDMIDMA_CAP_CTL0_triple_buf_en_shift                                  (31)
#define HDMIDMA_CAP_CTL0_cap_block_fw_shift                                   (29)
#define HDMIDMA_CAP_CTL0_set_block_sel_shift                                  (28)
#define HDMIDMA_CAP_CTL0_quad_buf_en_shift                                    (27)
#define HDMIDMA_CAP_CTL0_freeze_en_shift                                      (24)
#define HDMIDMA_CAP_CTL0_vs_fall_rst_en_shift                                 (23)
#define HDMIDMA_CAP_CTL0_auto_block_sel_en_shift                              (22)
#define HDMIDMA_CAP_CTL0_half_wr_en_shift                                     (21)
#define HDMIDMA_CAP_CTL0_half_wr_sel_shift                                    (20)
#define HDMIDMA_CAP_CTL0_cap_en_shift                                         (19)
#define HDMIDMA_CAP_CTL0_bit_sel_shift                                        (18)
#define HDMIDMA_CAP_CTL0_pixel_encoding_shift                                 (16)
#define HDMIDMA_CAP_CTL0_cap_write_len_shift                                  (8)
#define HDMIDMA_CAP_CTL0_cap_write_rem_shift                                  (0)
#define HDMIDMA_CAP_CTL0_triple_buf_en_mask                                   (0x80000000)
#define HDMIDMA_CAP_CTL0_cap_block_fw_mask                                    (0x60000000)
#define HDMIDMA_CAP_CTL0_set_block_sel_mask                                   (0x10000000)
#define HDMIDMA_CAP_CTL0_quad_buf_en_mask                                     (0x08000000)
#define HDMIDMA_CAP_CTL0_freeze_en_mask                                       (0x01000000)
#define HDMIDMA_CAP_CTL0_vs_fall_rst_en_mask                                  (0x00800000)
#define HDMIDMA_CAP_CTL0_auto_block_sel_en_mask                               (0x00400000)
#define HDMIDMA_CAP_CTL0_half_wr_en_mask                                      (0x00200000)
#define HDMIDMA_CAP_CTL0_half_wr_sel_mask                                     (0x00100000)
#define HDMIDMA_CAP_CTL0_cap_en_mask                                          (0x00080000)
#define HDMIDMA_CAP_CTL0_bit_sel_mask                                         (0x00040000)
#define HDMIDMA_CAP_CTL0_pixel_encoding_mask                                  (0x00030000)
#define HDMIDMA_CAP_CTL0_cap_write_len_mask                                   (0x00003F00)
#define HDMIDMA_CAP_CTL0_cap_write_rem_mask                                   (0x0000003F)
#define HDMIDMA_CAP_CTL0_triple_buf_en(data)                                  (0x80000000&((data)<<31))
#define HDMIDMA_CAP_CTL0_cap_block_fw(data)                                   (0x60000000&((data)<<29))
#define HDMIDMA_CAP_CTL0_set_block_sel(data)                                  (0x10000000&((data)<<28))
#define HDMIDMA_CAP_CTL0_quad_buf_en(data)                                    (0x08000000&((data)<<27))
#define HDMIDMA_CAP_CTL0_freeze_en(data)                                      (0x01000000&((data)<<24))
#define HDMIDMA_CAP_CTL0_vs_fall_rst_en(data)                                 (0x00800000&((data)<<23))
#define HDMIDMA_CAP_CTL0_auto_block_sel_en(data)                              (0x00400000&((data)<<22))
#define HDMIDMA_CAP_CTL0_half_wr_en(data)                                     (0x00200000&((data)<<21))
#define HDMIDMA_CAP_CTL0_half_wr_sel(data)                                    (0x00100000&((data)<<20))
#define HDMIDMA_CAP_CTL0_cap_en(data)                                         (0x00080000&((data)<<19))
#define HDMIDMA_CAP_CTL0_bit_sel(data)                                        (0x00040000&((data)<<18))
#define HDMIDMA_CAP_CTL0_pixel_encoding(data)                                 (0x00030000&((data)<<16))
#define HDMIDMA_CAP_CTL0_cap_write_len(data)                                  (0x00003F00&((data)<<8))
#define HDMIDMA_CAP_CTL0_cap_write_rem(data)                                  (0x0000003F&(data))
#define HDMIDMA_CAP_CTL0_get_triple_buf_en(data)                              ((0x80000000&(data))>>31)
#define HDMIDMA_CAP_CTL0_get_cap_block_fw(data)                               ((0x60000000&(data))>>29)
#define HDMIDMA_CAP_CTL0_get_set_block_sel(data)                              ((0x10000000&(data))>>28)
#define HDMIDMA_CAP_CTL0_get_quad_buf_en(data)                                ((0x08000000&(data))>>27)
#define HDMIDMA_CAP_CTL0_get_freeze_en(data)                                  ((0x01000000&(data))>>24)
#define HDMIDMA_CAP_CTL0_get_vs_fall_rst_en(data)                             ((0x00800000&(data))>>23)
#define HDMIDMA_CAP_CTL0_get_auto_block_sel_en(data)                          ((0x00400000&(data))>>22)
#define HDMIDMA_CAP_CTL0_get_half_wr_en(data)                                 ((0x00200000&(data))>>21)
#define HDMIDMA_CAP_CTL0_get_half_wr_sel(data)                                ((0x00100000&(data))>>20)
#define HDMIDMA_CAP_CTL0_get_cap_en(data)                                     ((0x00080000&(data))>>19)
#define HDMIDMA_CAP_CTL0_get_bit_sel(data)                                    ((0x00040000&(data))>>18)
#define HDMIDMA_CAP_CTL0_get_pixel_encoding(data)                             ((0x00030000&(data))>>16)
#define HDMIDMA_CAP_CTL0_get_cap_write_len(data)                              ((0x00003F00&(data))>>8)
#define HDMIDMA_CAP_CTL0_get_cap_write_rem(data)                              (0x0000003F&(data))


#define HDMIDMA_CAP_CTL1                                                      0x18025814
#define HDMIDMA_CAP_CTL1_reg_addr                                             "0xb8025814"
#define HDMIDMA_CAP_CTL1_reg                                                  0xb8025814
#define HDMIDMA_CAP_CTL1_inst_addr                                            "0x0205"
#define HDMIDMA_CAP_CTL1_inst                                                 0x0205
#define HDMIDMA_CAP_CTL1_dummy_cap_ctl1_shift                                 (15)
#define HDMIDMA_CAP_CTL1_cap_water_lv_shift                                   (8)
#define HDMIDMA_CAP_CTL1_cap_write_num_shift                                  (0)
#define HDMIDMA_CAP_CTL1_dummy_cap_ctl1_mask                                  (0xFFFF8000)
#define HDMIDMA_CAP_CTL1_cap_water_lv_mask                                    (0x00007F00)
#define HDMIDMA_CAP_CTL1_cap_write_num_mask                                   (0x000000FF)
#define HDMIDMA_CAP_CTL1_dummy_cap_ctl1(data)                                 (0xFFFF8000&((data)<<15))
#define HDMIDMA_CAP_CTL1_cap_water_lv(data)                                   (0x00007F00&((data)<<8))
#define HDMIDMA_CAP_CTL1_cap_write_num(data)                                  (0x000000FF&(data))
#define HDMIDMA_CAP_CTL1_get_dummy_cap_ctl1(data)                             ((0xFFFF8000&(data))>>15)
#define HDMIDMA_CAP_CTL1_get_cap_water_lv(data)                               ((0x00007F00&(data))>>8)
#define HDMIDMA_CAP_CTL1_get_cap_write_num(data)                              (0x000000FF&(data))


#define HDMIDMA_CAP_BOUNDARYADDR1                                             0x18025818
#define HDMIDMA_CAP_BOUNDARYADDR1_reg_addr                                    "0xb8025818"
#define HDMIDMA_CAP_BOUNDARYADDR1_reg                                         0xb8025818
#define HDMIDMA_CAP_BOUNDARYADDR1_inst_addr                                   "0x0206"
#define HDMIDMA_CAP_BOUNDARYADDR1_inst                                        0x0206
#define HDMIDMA_CAP_BOUNDARYADDR1_cap_mem_up_limit_shift                      (3)
#define HDMIDMA_CAP_BOUNDARYADDR1_cap_mem_up_limit_mask                       (0x7FFFFFF8)
#define HDMIDMA_CAP_BOUNDARYADDR1_cap_mem_up_limit(data)                      (0x7FFFFFF8&((data)<<3))
#define HDMIDMA_CAP_BOUNDARYADDR1_get_cap_mem_up_limit(data)                  ((0x7FFFFFF8&(data))>>3)


#define HDMIDMA_CAP_BOUNDARYADDR2                                             0x1802581c
#define HDMIDMA_CAP_BOUNDARYADDR2_reg_addr                                    "0xb802581c"
#define HDMIDMA_CAP_BOUNDARYADDR2_reg                                         0xb802581c
#define HDMIDMA_CAP_BOUNDARYADDR2_inst_addr                                   "0x0207"
#define HDMIDMA_CAP_BOUNDARYADDR2_inst                                        0x0207
#define HDMIDMA_CAP_BOUNDARYADDR2_cap_mem_low_limit_shift                     (3)
#define HDMIDMA_CAP_BOUNDARYADDR2_cap_mem_low_limit_mask                      (0x7FFFFFF8)
#define HDMIDMA_CAP_BOUNDARYADDR2_cap_mem_low_limit(data)                     (0x7FFFFFF8&((data)<<3))
#define HDMIDMA_CAP_BOUNDARYADDR2_get_cap_mem_low_limit(data)                 ((0x7FFFFFF8&(data))>>3)


#define HDMIDMA_CAP_L1_START                                                  0x18025820
#define HDMIDMA_CAP_L1_START_reg_addr                                         "0xb8025820"
#define HDMIDMA_CAP_L1_START_reg                                              0xb8025820
#define HDMIDMA_CAP_L1_START_inst_addr                                        "0x0208"
#define HDMIDMA_CAP_L1_START_inst                                             0x0208
#define HDMIDMA_CAP_L1_START_cap_l1_start_shift                               (3)
#define HDMIDMA_CAP_L1_START_cap_l1_start_mask                                (0x7FFFFFF8)
#define HDMIDMA_CAP_L1_START_cap_l1_start(data)                               (0x7FFFFFF8&((data)<<3))
#define HDMIDMA_CAP_L1_START_get_cap_l1_start(data)                           ((0x7FFFFFF8&(data))>>3)


#define HDMIDMA_CAP_L2_START                                                  0x18025824
#define HDMIDMA_CAP_L2_START_reg_addr                                         "0xb8025824"
#define HDMIDMA_CAP_L2_START_reg                                              0xb8025824
#define HDMIDMA_CAP_L2_START_inst_addr                                        "0x0209"
#define HDMIDMA_CAP_L2_START_inst                                             0x0209
#define HDMIDMA_CAP_L2_START_cap_l2_start_shift                               (3)
#define HDMIDMA_CAP_L2_START_cap_l2_start_mask                                (0x7FFFFFF8)
#define HDMIDMA_CAP_L2_START_cap_l2_start(data)                               (0x7FFFFFF8&((data)<<3))
#define HDMIDMA_CAP_L2_START_get_cap_l2_start(data)                           ((0x7FFFFFF8&(data))>>3)


#define HDMIDMA_CAP_R1_START                                                  0x18025828
#define HDMIDMA_CAP_R1_START_reg_addr                                         "0xb8025828"
#define HDMIDMA_CAP_R1_START_reg                                              0xb8025828
#define HDMIDMA_CAP_R1_START_inst_addr                                        "0x020A"
#define HDMIDMA_CAP_R1_START_inst                                             0x020A
#define HDMIDMA_CAP_R1_START_cap_r1_start_shift                               (3)
#define HDMIDMA_CAP_R1_START_cap_r1_start_mask                                (0x7FFFFFF8)
#define HDMIDMA_CAP_R1_START_cap_r1_start(data)                               (0x7FFFFFF8&((data)<<3))
#define HDMIDMA_CAP_R1_START_get_cap_r1_start(data)                           ((0x7FFFFFF8&(data))>>3)


#define HDMIDMA_CAP_R2_START                                                  0x1802582c
#define HDMIDMA_CAP_R2_START_reg_addr                                         "0xb802582c"
#define HDMIDMA_CAP_R2_START_reg                                              0xb802582c
#define HDMIDMA_CAP_R2_START_inst_addr                                        "0x020B"
#define HDMIDMA_CAP_R2_START_inst                                             0x020B
#define HDMIDMA_CAP_R2_START_cap_r2_start_shift                               (3)
#define HDMIDMA_CAP_R2_START_cap_r2_start_mask                                (0x7FFFFFF8)
#define HDMIDMA_CAP_R2_START_cap_r2_start(data)                               (0x7FFFFFF8&((data)<<3))
#define HDMIDMA_CAP_R2_START_get_cap_r2_start(data)                           ((0x7FFFFFF8&(data))>>3)


#define HDMIDMA_CAP_L1_START_DB                                               0x18025830
#define HDMIDMA_CAP_L1_START_DB_reg_addr                                      "0xb8025830"
#define HDMIDMA_CAP_L1_START_DB_reg                                           0xb8025830
#define HDMIDMA_CAP_L1_START_DB_inst_addr                                     "0x020C"
#define HDMIDMA_CAP_L1_START_DB_inst                                          0x020C
#define HDMIDMA_CAP_L1_START_DB_cap_l1_start_db_shift                         (3)
#define HDMIDMA_CAP_L1_START_DB_cap_l1_start_db_mask                          (0x7FFFFFF8)
#define HDMIDMA_CAP_L1_START_DB_cap_l1_start_db(data)                         (0x7FFFFFF8&((data)<<3))
#define HDMIDMA_CAP_L1_START_DB_get_cap_l1_start_db(data)                     ((0x7FFFFFF8&(data))>>3)


#define HDMIDMA_CAP_R1_START_DB                                               0x18025834
#define HDMIDMA_CAP_R1_START_DB_reg_addr                                      "0xb8025834"
#define HDMIDMA_CAP_R1_START_DB_reg                                           0xb8025834
#define HDMIDMA_CAP_R1_START_DB_inst_addr                                     "0x020D"
#define HDMIDMA_CAP_R1_START_DB_inst                                          0x020D
#define HDMIDMA_CAP_R1_START_DB_cap_r1_start_db_shift                         (3)
#define HDMIDMA_CAP_R1_START_DB_cap_r1_start_db_mask                          (0x7FFFFFF8)
#define HDMIDMA_CAP_R1_START_DB_cap_r1_start_db(data)                         (0x7FFFFFF8&((data)<<3))
#define HDMIDMA_CAP_R1_START_DB_get_cap_r1_start_db(data)                     ((0x7FFFFFF8&(data))>>3)


#define HDMIDMA_CAP_STATUS                                                    0x18025838
#define HDMIDMA_CAP_STATUS_reg_addr                                           "0xb8025838"
#define HDMIDMA_CAP_STATUS_reg                                                0xb8025838
#define HDMIDMA_CAP_STATUS_inst_addr                                          "0x020E"
#define HDMIDMA_CAP_STATUS_inst                                               0x020E
#define HDMIDMA_CAP_STATUS_dummy_cap_st_shift                                 (14)
#define HDMIDMA_CAP_STATUS_cap_block_2_shift                                  (12)
#define HDMIDMA_CAP_STATUS_cap_over_size_shift                                (11)
#define HDMIDMA_CAP_STATUS_cap_under_size_shift                               (10)
#define HDMIDMA_CAP_STATUS_freeze_ok_shift                                    (9)
#define HDMIDMA_CAP_STATUS_vs_rising_occur_shift                              (8)
#define HDMIDMA_CAP_STATUS_tg_l_flag_shift                                    (7)
#define HDMIDMA_CAP_STATUS_cap_block_shift                                    (6)
#define HDMIDMA_CAP_STATUS_cap_field_shift                                    (5)
#define HDMIDMA_CAP_STATUS_cap_fifo_full_shift                                (4)
#define HDMIDMA_CAP_STATUS_cap_fifo_empty_shift                               (3)
#define HDMIDMA_CAP_STATUS_cap_fifo_overflow_shift                            (2)
#define HDMIDMA_CAP_STATUS_cap_fifo_underflow_shift                           (1)
#define HDMIDMA_CAP_STATUS_cap_ddr_over_range_shift                           (0)
#define HDMIDMA_CAP_STATUS_dummy_cap_st_mask                                  (0xFFFFC000)
#define HDMIDMA_CAP_STATUS_cap_block_2_mask                                   (0x00003000)
#define HDMIDMA_CAP_STATUS_cap_over_size_mask                                 (0x00000800)
#define HDMIDMA_CAP_STATUS_cap_under_size_mask                                (0x00000400)
#define HDMIDMA_CAP_STATUS_freeze_ok_mask                                     (0x00000200)
#define HDMIDMA_CAP_STATUS_vs_rising_occur_mask                               (0x00000100)
#define HDMIDMA_CAP_STATUS_tg_l_flag_mask                                     (0x00000080)
#define HDMIDMA_CAP_STATUS_cap_block_mask                                     (0x00000040)
#define HDMIDMA_CAP_STATUS_cap_field_mask                                     (0x00000020)
#define HDMIDMA_CAP_STATUS_cap_fifo_full_mask                                 (0x00000010)
#define HDMIDMA_CAP_STATUS_cap_fifo_empty_mask                                (0x00000008)
#define HDMIDMA_CAP_STATUS_cap_fifo_overflow_mask                             (0x00000004)
#define HDMIDMA_CAP_STATUS_cap_fifo_underflow_mask                            (0x00000002)
#define HDMIDMA_CAP_STATUS_cap_ddr_over_range_mask                            (0x00000001)
#define HDMIDMA_CAP_STATUS_dummy_cap_st(data)                                 (0xFFFFC000&((data)<<14))
#define HDMIDMA_CAP_STATUS_cap_block_2(data)                                  (0x00003000&((data)<<12))
#define HDMIDMA_CAP_STATUS_cap_over_size(data)                                (0x00000800&((data)<<11))
#define HDMIDMA_CAP_STATUS_cap_under_size(data)                               (0x00000400&((data)<<10))
#define HDMIDMA_CAP_STATUS_freeze_ok(data)                                    (0x00000200&((data)<<9))
#define HDMIDMA_CAP_STATUS_vs_rising_occur(data)                              (0x00000100&((data)<<8))
#define HDMIDMA_CAP_STATUS_tg_l_flag(data)                                    (0x00000080&((data)<<7))
#define HDMIDMA_CAP_STATUS_cap_block(data)                                    (0x00000040&((data)<<6))
#define HDMIDMA_CAP_STATUS_cap_field(data)                                    (0x00000020&((data)<<5))
#define HDMIDMA_CAP_STATUS_cap_fifo_full(data)                                (0x00000010&((data)<<4))
#define HDMIDMA_CAP_STATUS_cap_fifo_empty(data)                               (0x00000008&((data)<<3))
#define HDMIDMA_CAP_STATUS_cap_fifo_overflow(data)                            (0x00000004&((data)<<2))
#define HDMIDMA_CAP_STATUS_cap_fifo_underflow(data)                           (0x00000002&((data)<<1))
#define HDMIDMA_CAP_STATUS_cap_ddr_over_range(data)                           (0x00000001&(data))
#define HDMIDMA_CAP_STATUS_get_dummy_cap_st(data)                             ((0xFFFFC000&(data))>>14)
#define HDMIDMA_CAP_STATUS_get_cap_block_2(data)                              ((0x00003000&(data))>>12)
#define HDMIDMA_CAP_STATUS_get_cap_over_size(data)                            ((0x00000800&(data))>>11)
#define HDMIDMA_CAP_STATUS_get_cap_under_size(data)                           ((0x00000400&(data))>>10)
#define HDMIDMA_CAP_STATUS_get_freeze_ok(data)                                ((0x00000200&(data))>>9)
#define HDMIDMA_CAP_STATUS_get_vs_rising_occur(data)                          ((0x00000100&(data))>>8)
#define HDMIDMA_CAP_STATUS_get_tg_l_flag(data)                                ((0x00000080&(data))>>7)
#define HDMIDMA_CAP_STATUS_get_cap_block(data)                                ((0x00000040&(data))>>6)
#define HDMIDMA_CAP_STATUS_get_cap_field(data)                                ((0x00000020&(data))>>5)
#define HDMIDMA_CAP_STATUS_get_cap_fifo_full(data)                            ((0x00000010&(data))>>4)
#define HDMIDMA_CAP_STATUS_get_cap_fifo_empty(data)                           ((0x00000008&(data))>>3)
#define HDMIDMA_CAP_STATUS_get_cap_fifo_overflow(data)                        ((0x00000004&(data))>>2)
#define HDMIDMA_CAP_STATUS_get_cap_fifo_underflow(data)                       ((0x00000002&(data))>>1)
#define HDMIDMA_CAP_STATUS_get_cap_ddr_over_range(data)                       (0x00000001&(data))



#define HDMIDMA_CTS_FIFO_CTRL                                                 0x1802585c
#define HDMIDMA_CTS_FIFO_CTRL_reg_addr                                        "0xb802585c"
#define HDMIDMA_CTS_FIFO_CTRL_reg                                             0xb802585c
#define HDMIDMA_CTS_FIFO_CTRL_inst_addr                                       "0x0217"
#define HDMIDMA_CTS_FIFO_CTRL_inst                                            0x0217
#define HDMIDMA_CTS_FIFO_CTRL_dummy_cts_fifo_shift                            (8)
#define HDMIDMA_CTS_FIFO_CTRL_force_ctsfifo_rstn_shift                        (2)
#define HDMIDMA_CTS_FIFO_CTRL_en_ctsfifo_vsrst_shift                          (1)
#define HDMIDMA_CTS_FIFO_CTRL_en_ctsfifo_bypass_shift                         (0)
#define HDMIDMA_CTS_FIFO_CTRL_dummy_cts_fifo_mask                             (0xFFFFFF00)
#define HDMIDMA_CTS_FIFO_CTRL_force_ctsfifo_rstn_mask                         (0x00000004)
#define HDMIDMA_CTS_FIFO_CTRL_en_ctsfifo_vsrst_mask                           (0x00000002)
#define HDMIDMA_CTS_FIFO_CTRL_en_ctsfifo_bypass_mask                          (0x00000001)
#define HDMIDMA_CTS_FIFO_CTRL_dummy_cts_fifo(data)                            (0xFFFFFF00&((data)<<8))
#define HDMIDMA_CTS_FIFO_CTRL_force_ctsfifo_rstn(data)                        (0x00000004&((data)<<2))
#define HDMIDMA_CTS_FIFO_CTRL_en_ctsfifo_vsrst(data)                          (0x00000002&((data)<<1))
#define HDMIDMA_CTS_FIFO_CTRL_en_ctsfifo_bypass(data)                         (0x00000001&(data))
#define HDMIDMA_CTS_FIFO_CTRL_get_dummy_cts_fifo(data)                        ((0xFFFFFF00&(data))>>8)
#define HDMIDMA_CTS_FIFO_CTRL_get_force_ctsfifo_rstn(data)                    ((0x00000004&(data))>>2)
#define HDMIDMA_CTS_FIFO_CTRL_get_en_ctsfifo_vsrst(data)                      ((0x00000002&(data))>>1)
#define HDMIDMA_CTS_FIFO_CTRL_get_en_ctsfifo_bypass(data)                     (0x00000001&(data))


#define HDMIDMA_LR_CRC_CTRL                                                   0x18025860
#define HDMIDMA_LR_CRC_CTRL_reg_addr                                          "0xb8025860"
#define HDMIDMA_LR_CRC_CTRL_reg                                               0xb8025860
#define HDMIDMA_LR_CRC_CTRL_inst_addr                                         "0x0218"
#define HDMIDMA_LR_CRC_CTRL_inst                                              0x0218
#define HDMIDMA_LR_CRC_CTRL_r_crc_conti_shift                                 (9)
#define HDMIDMA_LR_CRC_CTRL_r_crc_start_shift                                 (8)
#define HDMIDMA_LR_CRC_CTRL_l_crc_conti_shift                                 (1)
#define HDMIDMA_LR_CRC_CTRL_l_crc_start_shift                                 (0)
#define HDMIDMA_LR_CRC_CTRL_r_crc_conti_mask                                  (0x00000200)
#define HDMIDMA_LR_CRC_CTRL_r_crc_start_mask                                  (0x00000100)
#define HDMIDMA_LR_CRC_CTRL_l_crc_conti_mask                                  (0x00000002)
#define HDMIDMA_LR_CRC_CTRL_l_crc_start_mask                                  (0x00000001)
#define HDMIDMA_LR_CRC_CTRL_r_crc_conti(data)                                 (0x00000200&((data)<<9))
#define HDMIDMA_LR_CRC_CTRL_r_crc_start(data)                                 (0x00000100&((data)<<8))
#define HDMIDMA_LR_CRC_CTRL_l_crc_conti(data)                                 (0x00000002&((data)<<1))
#define HDMIDMA_LR_CRC_CTRL_l_crc_start(data)                                 (0x00000001&(data))
#define HDMIDMA_LR_CRC_CTRL_get_r_crc_conti(data)                             ((0x00000200&(data))>>9)
#define HDMIDMA_LR_CRC_CTRL_get_r_crc_start(data)                             ((0x00000100&(data))>>8)
#define HDMIDMA_LR_CRC_CTRL_get_l_crc_conti(data)                             ((0x00000002&(data))>>1)
#define HDMIDMA_LR_CRC_CTRL_get_l_crc_start(data)                             (0x00000001&(data))


#define HDMIDMA_CRC_L_RESULT                                                  0x18025864
#define HDMIDMA_CRC_L_RESULT_reg_addr                                         "0xb8025864"
#define HDMIDMA_CRC_L_RESULT_reg                                              0xb8025864
#define HDMIDMA_CRC_L_RESULT_inst_addr                                        "0x0219"
#define HDMIDMA_CRC_L_RESULT_inst                                             0x0219
#define HDMIDMA_CRC_L_RESULT_crc_l_result_shift                               (0)
#define HDMIDMA_CRC_L_RESULT_crc_l_result_mask                                (0xFFFFFFFF)
#define HDMIDMA_CRC_L_RESULT_crc_l_result(data)                               (0xFFFFFFFF&(data))
#define HDMIDMA_CRC_L_RESULT_get_crc_l_result(data)                           (0xFFFFFFFF&(data))


#define HDMIDMA_CRC_R_RESULT                                                  0x18025868
#define HDMIDMA_CRC_R_RESULT_reg_addr                                         "0xb8025868"
#define HDMIDMA_CRC_R_RESULT_reg                                              0xb8025868
#define HDMIDMA_CRC_R_RESULT_inst_addr                                        "0x021A"
#define HDMIDMA_CRC_R_RESULT_inst                                             0x021A
#define HDMIDMA_CRC_R_RESULT_crc_r_result_shift                               (0)
#define HDMIDMA_CRC_R_RESULT_crc_r_result_mask                                (0xFFFFFFFF)
#define HDMIDMA_CRC_R_RESULT_crc_r_result(data)                               (0xFFFFFFFF&(data))
#define HDMIDMA_CRC_R_RESULT_get_crc_r_result(data)                           (0xFFFFFFFF&(data))


#define HDMIDMA_INTERRUPT_ENABLE                                              0x1802586c
#define HDMIDMA_INTERRUPT_ENABLE_reg_addr                                     "0xb802586c"
#define HDMIDMA_INTERRUPT_ENABLE_reg                                          0xb802586c
#define HDMIDMA_INTERRUPT_ENABLE_inst_addr                                    "0x021B"
#define HDMIDMA_INTERRUPT_ENABLE_inst                                         0x021B
#define HDMIDMA_INTERRUPT_ENABLE_mem_err_ie_shift                             (2)
#define HDMIDMA_INTERRUPT_ENABLE_fifo_err_ie_shift                            (1)
#define HDMIDMA_INTERRUPT_ENABLE_vs_rising_ie_shift                           (0)
#define HDMIDMA_INTERRUPT_ENABLE_mem_err_ie_mask                              (0x00000004)
#define HDMIDMA_INTERRUPT_ENABLE_fifo_err_ie_mask                             (0x00000002)
#define HDMIDMA_INTERRUPT_ENABLE_vs_rising_ie_mask                            (0x00000001)
#define HDMIDMA_INTERRUPT_ENABLE_mem_err_ie(data)                             (0x00000004&((data)<<2))
#define HDMIDMA_INTERRUPT_ENABLE_fifo_err_ie(data)                            (0x00000002&((data)<<1))
#define HDMIDMA_INTERRUPT_ENABLE_vs_rising_ie(data)                           (0x00000001&(data))
#define HDMIDMA_INTERRUPT_ENABLE_get_mem_err_ie(data)                         ((0x00000004&(data))>>2)
#define HDMIDMA_INTERRUPT_ENABLE_get_fifo_err_ie(data)                        ((0x00000002&(data))>>1)
#define HDMIDMA_INTERRUPT_ENABLE_get_vs_rising_ie(data)                       (0x00000001&(data))


#define HDMIDMA_I3DDMA_ENABLE                                                 0x18025870
#define HDMIDMA_I3DDMA_ENABLE_reg_addr                                        "0xb8025870"
#define HDMIDMA_I3DDMA_ENABLE_reg                                             0xb8025870
#define HDMIDMA_I3DDMA_ENABLE_inst_addr                                       "0x021C"
#define HDMIDMA_I3DDMA_ENABLE_inst                                            0x021C
#define HDMIDMA_I3DDMA_ENABLE_frc_style_shift                                 (4)
#define HDMIDMA_I3DDMA_ENABLE_frc_en_shift                                    (3)
#define HDMIDMA_I3DDMA_ENABLE_tg_en_shift                                     (2)
#define HDMIDMA_I3DDMA_ENABLE_lr_separate_en_shift                            (1)
#define HDMIDMA_I3DDMA_ENABLE_cap_en_shift                                    (0)
#define HDMIDMA_I3DDMA_ENABLE_frc_style_mask                                  (0x00000010)
#define HDMIDMA_I3DDMA_ENABLE_frc_en_mask                                     (0x00000008)
#define HDMIDMA_I3DDMA_ENABLE_tg_en_mask                                      (0x00000004)
#define HDMIDMA_I3DDMA_ENABLE_lr_separate_en_mask                             (0x00000002)
#define HDMIDMA_I3DDMA_ENABLE_cap_en_mask                                     (0x00000001)
#define HDMIDMA_I3DDMA_ENABLE_frc_style(data)                                 (0x00000010&((data)<<4))
#define HDMIDMA_I3DDMA_ENABLE_frc_en(data)                                    (0x00000008&((data)<<3))
#define HDMIDMA_I3DDMA_ENABLE_tg_en(data)                                     (0x00000004&((data)<<2))
#define HDMIDMA_I3DDMA_ENABLE_lr_separate_en(data)                            (0x00000002&((data)<<1))
#define HDMIDMA_I3DDMA_ENABLE_cap_en(data)                                    (0x00000001&(data))
#define HDMIDMA_I3DDMA_ENABLE_get_frc_style(data)                             ((0x00000010&(data))>>4)
#define HDMIDMA_I3DDMA_ENABLE_get_frc_en(data)                                ((0x00000008&(data))>>3)
#define HDMIDMA_I3DDMA_ENABLE_get_tg_en(data)                                 ((0x00000004&(data))>>2)
#define HDMIDMA_I3DDMA_ENABLE_get_lr_separate_en(data)                        ((0x00000002&(data))>>1)
#define HDMIDMA_I3DDMA_ENABLE_get_cap_en(data)                                (0x00000001&(data))


#define HDMIDMA_I3DDMA_BYTE_CHANNEL_SWAP                                      0x18025874
#define HDMIDMA_I3DDMA_BYTE_CHANNEL_SWAP_reg_addr                             "0xb8025874"
#define HDMIDMA_I3DDMA_BYTE_CHANNEL_SWAP_reg                                  0xb8025874
#define HDMIDMA_I3DDMA_BYTE_CHANNEL_SWAP_inst_addr                            "0x021D"
#define HDMIDMA_I3DDMA_BYTE_CHANNEL_SWAP_inst                                 0x021D
#define HDMIDMA_I3DDMA_BYTE_CHANNEL_SWAP_dma_channel_swap_shift               (4)
#define HDMIDMA_I3DDMA_BYTE_CHANNEL_SWAP_dma_8byte_swap_shift                 (3)
#define HDMIDMA_I3DDMA_BYTE_CHANNEL_SWAP_dma_4byte_swap_shift                 (2)
#define HDMIDMA_I3DDMA_BYTE_CHANNEL_SWAP_dma_2byte_swap_shift                 (1)
#define HDMIDMA_I3DDMA_BYTE_CHANNEL_SWAP_dma_1byte_swap_shift                 (0)
#define HDMIDMA_I3DDMA_BYTE_CHANNEL_SWAP_dma_channel_swap_mask                (0x00000070)
#define HDMIDMA_I3DDMA_BYTE_CHANNEL_SWAP_dma_8byte_swap_mask                  (0x00000008)
#define HDMIDMA_I3DDMA_BYTE_CHANNEL_SWAP_dma_4byte_swap_mask                  (0x00000004)
#define HDMIDMA_I3DDMA_BYTE_CHANNEL_SWAP_dma_2byte_swap_mask                  (0x00000002)
#define HDMIDMA_I3DDMA_BYTE_CHANNEL_SWAP_dma_1byte_swap_mask                  (0x00000001)
#define HDMIDMA_I3DDMA_BYTE_CHANNEL_SWAP_dma_channel_swap(data)               (0x00000070&((data)<<4))
#define HDMIDMA_I3DDMA_BYTE_CHANNEL_SWAP_dma_8byte_swap(data)                 (0x00000008&((data)<<3))
#define HDMIDMA_I3DDMA_BYTE_CHANNEL_SWAP_dma_4byte_swap(data)                 (0x00000004&((data)<<2))
#define HDMIDMA_I3DDMA_BYTE_CHANNEL_SWAP_dma_2byte_swap(data)                 (0x00000002&((data)<<1))
#define HDMIDMA_I3DDMA_BYTE_CHANNEL_SWAP_dma_1byte_swap(data)                 (0x00000001&(data))
#define HDMIDMA_I3DDMA_BYTE_CHANNEL_SWAP_get_dma_channel_swap(data)           ((0x00000070&(data))>>4)
#define HDMIDMA_I3DDMA_BYTE_CHANNEL_SWAP_get_dma_8byte_swap(data)             ((0x00000008&(data))>>3)
#define HDMIDMA_I3DDMA_BYTE_CHANNEL_SWAP_get_dma_4byte_swap(data)             ((0x00000004&(data))>>2)
#define HDMIDMA_I3DDMA_BYTE_CHANNEL_SWAP_get_dma_2byte_swap(data)             ((0x00000002&(data))>>1)
#define HDMIDMA_I3DDMA_BYTE_CHANNEL_SWAP_get_dma_1byte_swap(data)             (0x00000001&(data))


#define HDMIDMA_CAP_L1_START_DB_2                                             0x18025878
#define HDMIDMA_CAP_L1_START_DB_2_reg_addr                                    "0xb8025878"
#define HDMIDMA_CAP_L1_START_DB_2_reg                                         0xb8025878
#define HDMIDMA_CAP_L1_START_DB_2_inst_addr                                   "0x021E"
#define HDMIDMA_CAP_L1_START_DB_2_inst                                        0x021E
#define HDMIDMA_CAP_L1_START_DB_2_cap2_l1_start_db_shift                      (3)
#define HDMIDMA_CAP_L1_START_DB_2_cap2_l1_start_db_mask                       (0x7FFFFFF8)
#define HDMIDMA_CAP_L1_START_DB_2_cap2_l1_start_db(data)                      (0x7FFFFFF8&((data)<<3))
#define HDMIDMA_CAP_L1_START_DB_2_get_cap2_l1_start_db(data)                  ((0x7FFFFFF8&(data))>>3)


#define HDMIDMA_CAP_R1_START_DB_2                                             0x1802587c
#define HDMIDMA_CAP_R1_START_DB_2_reg_addr                                    "0xb802587c"
#define HDMIDMA_CAP_R1_START_DB_2_reg                                         0xb802587c
#define HDMIDMA_CAP_R1_START_DB_2_inst_addr                                   "0x021F"
#define HDMIDMA_CAP_R1_START_DB_2_inst                                        0x021F
#define HDMIDMA_CAP_R1_START_DB_2_cap2_r1_start_db_shift                      (3)
#define HDMIDMA_CAP_R1_START_DB_2_cap2_r1_start_db_mask                       (0x7FFFFFF8)
#define HDMIDMA_CAP_R1_START_DB_2_cap2_r1_start_db(data)                      (0x7FFFFFF8&((data)<<3))
#define HDMIDMA_CAP_R1_START_DB_2_get_cap2_r1_start_db(data)                  ((0x7FFFFFF8&(data))>>3)


#define HDMIDMA_CAP_STATUS_2                                                  0x18025880
#define HDMIDMA_CAP_STATUS_2_reg_addr                                         "0xb8025880"
#define HDMIDMA_CAP_STATUS_2_reg                                              0xb8025880
#define HDMIDMA_CAP_STATUS_2_inst_addr                                        "0x0220"
#define HDMIDMA_CAP_STATUS_2_inst                                             0x0220
#define HDMIDMA_CAP_STATUS_2_cap2_block_shift                                 (6)
#define HDMIDMA_CAP_STATUS_2_cap2_fifo_full_shift                             (4)
#define HDMIDMA_CAP_STATUS_2_cap2_fifo_empty_shift                            (3)
#define HDMIDMA_CAP_STATUS_2_cap2_fifo_overflow_shift                         (2)
#define HDMIDMA_CAP_STATUS_2_cap2_fifo_underflow_shift                        (1)
#define HDMIDMA_CAP_STATUS_2_cap2_ddr_over_range_shift                        (0)
#define HDMIDMA_CAP_STATUS_2_cap2_block_mask                                  (0x00000040)
#define HDMIDMA_CAP_STATUS_2_cap2_fifo_full_mask                              (0x00000010)
#define HDMIDMA_CAP_STATUS_2_cap2_fifo_empty_mask                             (0x00000008)
#define HDMIDMA_CAP_STATUS_2_cap2_fifo_overflow_mask                          (0x00000004)
#define HDMIDMA_CAP_STATUS_2_cap2_fifo_underflow_mask                         (0x00000002)
#define HDMIDMA_CAP_STATUS_2_cap2_ddr_over_range_mask                         (0x00000001)
#define HDMIDMA_CAP_STATUS_2_cap2_block(data)                                 (0x00000040&((data)<<6))
#define HDMIDMA_CAP_STATUS_2_cap2_fifo_full(data)                             (0x00000010&((data)<<4))
#define HDMIDMA_CAP_STATUS_2_cap2_fifo_empty(data)                            (0x00000008&((data)<<3))
#define HDMIDMA_CAP_STATUS_2_cap2_fifo_overflow(data)                         (0x00000004&((data)<<2))
#define HDMIDMA_CAP_STATUS_2_cap2_fifo_underflow(data)                        (0x00000002&((data)<<1))
#define HDMIDMA_CAP_STATUS_2_cap2_ddr_over_range(data)                        (0x00000001&(data))
#define HDMIDMA_CAP_STATUS_2_get_cap2_block(data)                             ((0x00000040&(data))>>6)
#define HDMIDMA_CAP_STATUS_2_get_cap2_fifo_full(data)                         ((0x00000010&(data))>>4)
#define HDMIDMA_CAP_STATUS_2_get_cap2_fifo_empty(data)                        ((0x00000008&(data))>>3)
#define HDMIDMA_CAP_STATUS_2_get_cap2_fifo_overflow(data)                     ((0x00000004&(data))>>2)
#define HDMIDMA_CAP_STATUS_2_get_cap2_fifo_underflow(data)                    ((0x00000002&(data))>>1)
#define HDMIDMA_CAP_STATUS_2_get_cap2_ddr_over_range(data)                    (0x00000001&(data))


#define HDMIDMA_CAP_L3_START                                                  0x18025884
#define HDMIDMA_CAP_L3_START_reg_addr                                         "0xb8025884"
#define HDMIDMA_CAP_L3_START_reg                                              0xb8025884
#define HDMIDMA_CAP_L3_START_inst_addr                                        "0x0221"
#define HDMIDMA_CAP_L3_START_inst                                             0x0221
#define HDMIDMA_CAP_L3_START_cap_l3_start_shift                               (3)
#define HDMIDMA_CAP_L3_START_cap_l3_start_mask                                (0x7FFFFFF8)
#define HDMIDMA_CAP_L3_START_cap_l3_start(data)                               (0x7FFFFFF8&((data)<<3))
#define HDMIDMA_CAP_L3_START_get_cap_l3_start(data)                           ((0x7FFFFFF8&(data))>>3)


#define HDMIDMA_CAP_R3_START                                                  0x18025888
#define HDMIDMA_CAP_R3_START_reg_addr                                         "0xb8025888"
#define HDMIDMA_CAP_R3_START_reg                                              0xb8025888
#define HDMIDMA_CAP_R3_START_inst_addr                                        "0x0222"
#define HDMIDMA_CAP_R3_START_inst                                             0x0222
#define HDMIDMA_CAP_R3_START_cap_r3_start_shift                               (3)
#define HDMIDMA_CAP_R3_START_cap_r3_start_mask                                (0x7FFFFFF8)
#define HDMIDMA_CAP_R3_START_cap_r3_start(data)                               (0x7FFFFFF8&((data)<<3))
#define HDMIDMA_CAP_R3_START_get_cap_r3_start(data)                           ((0x7FFFFFF8&(data))>>3)


#define HDMIDMA_CAP_L4_START                                                  0x1802588c
#define HDMIDMA_CAP_L4_START_reg_addr                                         "0xb802588c"
#define HDMIDMA_CAP_L4_START_reg                                              0xb802588c
#define HDMIDMA_CAP_L4_START_inst_addr                                        "0x0223"
#define HDMIDMA_CAP_L4_START_inst                                             0x0223
#define HDMIDMA_CAP_L4_START_cap_l4_start_shift                               (3)
#define HDMIDMA_CAP_L4_START_cap_l4_start_mask                                (0x7FFFFFF8)
#define HDMIDMA_CAP_L4_START_cap_l4_start(data)                               (0x7FFFFFF8&((data)<<3))
#define HDMIDMA_CAP_L4_START_get_cap_l4_start(data)                           ((0x7FFFFFF8&(data))>>3)


#define HDMIDMA_CAP_R4_START                                                  0x18025890
#define HDMIDMA_CAP_R4_START_reg_addr                                         "0xb8025890"
#define HDMIDMA_CAP_R4_START_reg                                              0xb8025890
#define HDMIDMA_CAP_R4_START_inst_addr                                        "0x0224"
#define HDMIDMA_CAP_R4_START_inst                                             0x0224
#define HDMIDMA_CAP_R4_START_cap_r4_start_shift                               (3)
#define HDMIDMA_CAP_R4_START_cap_r4_start_mask                                (0x7FFFFFF8)
#define HDMIDMA_CAP_R4_START_cap_r4_start(data)                               (0x7FFFFFF8&((data)<<3))
#define HDMIDMA_CAP_R4_START_get_cap_r4_start(data)                           ((0x7FFFFFF8&(data))>>3)


#define HDMIDMA_I3DDMA_BIST_CAP_FAIL                                          0x180258d8
#define HDMIDMA_I3DDMA_BIST_CAP_FAIL_reg_addr                                 "0xb80258d8"
#define HDMIDMA_I3DDMA_BIST_CAP_FAIL_reg                                      0xb80258d8
#define HDMIDMA_I3DDMA_BIST_CAP_FAIL_inst_addr                                "0x0236"
#define HDMIDMA_I3DDMA_BIST_CAP_FAIL_inst                                     0x0236
#define HDMIDMA_I3DDMA_BIST_CAP_FAIL_i3ddma_bist_cap2_fail_shift              (1)
#define HDMIDMA_I3DDMA_BIST_CAP_FAIL_i3ddma_bist_cap_fail_shift               (0)
#define HDMIDMA_I3DDMA_BIST_CAP_FAIL_i3ddma_bist_cap2_fail_mask               (0x00000002)
#define HDMIDMA_I3DDMA_BIST_CAP_FAIL_i3ddma_bist_cap_fail_mask                (0x00000001)
#define HDMIDMA_I3DDMA_BIST_CAP_FAIL_i3ddma_bist_cap2_fail(data)              (0x00000002&((data)<<1))
#define HDMIDMA_I3DDMA_BIST_CAP_FAIL_i3ddma_bist_cap_fail(data)               (0x00000001&(data))
#define HDMIDMA_I3DDMA_BIST_CAP_FAIL_get_i3ddma_bist_cap2_fail(data)          ((0x00000002&(data))>>1)
#define HDMIDMA_I3DDMA_BIST_CAP_FAIL_get_i3ddma_bist_cap_fail(data)           (0x00000001&(data))


#define HDMIDMA_I3DDMA_DRF_CAP_FAIL                                           0x180258ec
#define HDMIDMA_I3DDMA_DRF_CAP_FAIL_reg_addr                                  "0xb80258ec"
#define HDMIDMA_I3DDMA_DRF_CAP_FAIL_reg                                       0xb80258ec
#define HDMIDMA_I3DDMA_DRF_CAP_FAIL_inst_addr                                 "0x023B"
#define HDMIDMA_I3DDMA_DRF_CAP_FAIL_inst                                      0x023B
#define HDMIDMA_I3DDMA_DRF_CAP_FAIL_i3ddma_drf_cap2_fail_shift                (1)
#define HDMIDMA_I3DDMA_DRF_CAP_FAIL_i3ddma_drf_cap_fail_shift                 (0)
#define HDMIDMA_I3DDMA_DRF_CAP_FAIL_i3ddma_drf_cap2_fail_mask                 (0x00000002)
#define HDMIDMA_I3DDMA_DRF_CAP_FAIL_i3ddma_drf_cap_fail_mask                  (0x00000001)
#define HDMIDMA_I3DDMA_DRF_CAP_FAIL_i3ddma_drf_cap2_fail(data)                (0x00000002&((data)<<1))
#define HDMIDMA_I3DDMA_DRF_CAP_FAIL_i3ddma_drf_cap_fail(data)                 (0x00000001&(data))
#define HDMIDMA_I3DDMA_DRF_CAP_FAIL_get_i3ddma_drf_cap2_fail(data)            ((0x00000002&(data))>>1)
#define HDMIDMA_I3DDMA_DRF_CAP_FAIL_get_i3ddma_drf_cap_fail(data)             (0x00000001&(data))


#define HDMIDMA_I3DDMA_DVS                                                    0x180258f0
#define HDMIDMA_I3DDMA_DVS_reg_addr                                           "0xb80258f0"
#define HDMIDMA_I3DDMA_DVS_reg                                                0xb80258f0
#define HDMIDMA_I3DDMA_DVS_inst_addr                                          "0x023C"
#define HDMIDMA_I3DDMA_DVS_inst                                               0x023C
#define HDMIDMA_I3DDMA_DVS_cap2_dvsb_shift                                    (12)
#define HDMIDMA_I3DDMA_DVS_cap2_dvsa_shift                                    (8)
#define HDMIDMA_I3DDMA_DVS_cap_dvsb_shift                                     (4)
#define HDMIDMA_I3DDMA_DVS_cap_dvsa_shift                                     (0)
#define HDMIDMA_I3DDMA_DVS_cap2_dvsb_mask                                     (0x0000F000)
#define HDMIDMA_I3DDMA_DVS_cap2_dvsa_mask                                     (0x00000F00)
#define HDMIDMA_I3DDMA_DVS_cap_dvsb_mask                                      (0x000000F0)
#define HDMIDMA_I3DDMA_DVS_cap_dvsa_mask                                      (0x0000000F)
#define HDMIDMA_I3DDMA_DVS_cap2_dvsb(data)                                    (0x0000F000&((data)<<12))
#define HDMIDMA_I3DDMA_DVS_cap2_dvsa(data)                                    (0x00000F00&((data)<<8))
#define HDMIDMA_I3DDMA_DVS_cap_dvsb(data)                                     (0x000000F0&((data)<<4))
#define HDMIDMA_I3DDMA_DVS_cap_dvsa(data)                                     (0x0000000F&(data))
#define HDMIDMA_I3DDMA_DVS_get_cap2_dvsb(data)                                ((0x0000F000&(data))>>12)
#define HDMIDMA_I3DDMA_DVS_get_cap2_dvsa(data)                                ((0x00000F00&(data))>>8)
#define HDMIDMA_I3DDMA_DVS_get_cap_dvsb(data)                                 ((0x000000F0&(data))>>4)
#define HDMIDMA_I3DDMA_DVS_get_cap_dvsa(data)                                 (0x0000000F&(data))


#define HDMIDMA_I3DDMA_DVSE                                                   0x180258f4
#define HDMIDMA_I3DDMA_DVSE_reg_addr                                          "0xb80258f4"
#define HDMIDMA_I3DDMA_DVSE_reg                                               0xb80258f4
#define HDMIDMA_I3DDMA_DVSE_inst_addr                                         "0x023D"
#define HDMIDMA_I3DDMA_DVSE_inst                                              0x023D
#define HDMIDMA_I3DDMA_DVSE_cap2_dvseb_shift                                  (3)
#define HDMIDMA_I3DDMA_DVSE_cap2_dvsea_shift                                  (2)
#define HDMIDMA_I3DDMA_DVSE_cap_dvseb_shift                                   (1)
#define HDMIDMA_I3DDMA_DVSE_cap_dvsea_shift                                   (0)
#define HDMIDMA_I3DDMA_DVSE_cap2_dvseb_mask                                   (0x00000008)
#define HDMIDMA_I3DDMA_DVSE_cap2_dvsea_mask                                   (0x00000004)
#define HDMIDMA_I3DDMA_DVSE_cap_dvseb_mask                                    (0x00000002)
#define HDMIDMA_I3DDMA_DVSE_cap_dvsea_mask                                    (0x00000001)
#define HDMIDMA_I3DDMA_DVSE_cap2_dvseb(data)                                  (0x00000008&((data)<<3))
#define HDMIDMA_I3DDMA_DVSE_cap2_dvsea(data)                                  (0x00000004&((data)<<2))
#define HDMIDMA_I3DDMA_DVSE_cap_dvseb(data)                                   (0x00000002&((data)<<1))
#define HDMIDMA_I3DDMA_DVSE_cap_dvsea(data)                                   (0x00000001&(data))
#define HDMIDMA_I3DDMA_DVSE_get_cap2_dvseb(data)                              ((0x00000008&(data))>>3)
#define HDMIDMA_I3DDMA_DVSE_get_cap2_dvsea(data)                              ((0x00000004&(data))>>2)
#define HDMIDMA_I3DDMA_DVSE_get_cap_dvseb(data)                               ((0x00000002&(data))>>1)
#define HDMIDMA_I3DDMA_DVSE_get_cap_dvsea(data)                               (0x00000001&(data))


#define HDMIDMA_I3DDMA_LS                                                     0x180258f8
#define HDMIDMA_I3DDMA_LS_reg_addr                                            "0xb80258f8"
#define HDMIDMA_I3DDMA_LS_reg                                                 0xb80258f8
#define HDMIDMA_I3DDMA_LS_inst_addr                                           "0x023E"
#define HDMIDMA_I3DDMA_LS_inst                                                0x023E
#define HDMIDMA_I3DDMA_LS_cap2_ls_shift                                       (1)
#define HDMIDMA_I3DDMA_LS_cap_ls_shift                                        (0)
#define HDMIDMA_I3DDMA_LS_cap2_ls_mask                                        (0x00000002)
#define HDMIDMA_I3DDMA_LS_cap_ls_mask                                         (0x00000001)
#define HDMIDMA_I3DDMA_LS_cap2_ls(data)                                       (0x00000002&((data)<<1))
#define HDMIDMA_I3DDMA_LS_cap_ls(data)                                        (0x00000001&(data))
#define HDMIDMA_I3DDMA_LS_get_cap2_ls(data)                                   ((0x00000002&(data))>>1)
#define HDMIDMA_I3DDMA_LS_get_cap_ls(data)                                    (0x00000001&(data))
#endif





// HDMI MEASUREMENT
// I domain on line measurasure spec

#define HDMI_ONMS_CTRL                                                     0x18021300
#define HDMI_ONMS_CTRL_reg_addr                                            "0xb8021300"
#define HDMI_ONMS_CTRL_reg                                                 0xb8021300
#define HDMI_ONMS_CTRL_inst_addr                                           "0x00C0"
#define HDMI_ONMS_CTRL_inst                                                0x00C0
#define HDMI_ONMS_CTRL_dummy_ctrl_shift                                    (28)
#define HDMI_ONMS_CTRL_pixel_get_en_shift                                  (27)
#define HDMI_ONMS_CTRL_pixel_get_sel_shift                                 (25)
#define HDMI_ONMS_CTRL_progressive_shift                                   (24)
#define HDMI_ONMS_CTRL_vtotal_max_delta_shift                              (20)
#define HDMI_ONMS_CTRL_htotal_max_delta_shift                              (16)
#define HDMI_ONMS_CTRL_pixel_encoding_shift                                (12)
#define HDMI_ONMS_CTRL_vact_space_threshold_shift                          (8)
#define HDMI_ONMS_CTRL_vact_space_meas_en_shift                            (7)
#define HDMI_ONMS_CTRL_meas_to_sel_shift                                   (6)
#define HDMI_ONMS_CTRL_sycms_clk_shift                                     (5)
#define HDMI_ONMS_CTRL_vs_meas_inv_shift                                   (4)
#define HDMI_ONMS_CTRL_hs_meas_inv_shift                                   (3)
#define HDMI_ONMS_CTRL_popup_meas_shift                                    (2)
#define HDMI_ONMS_CTRL_ms_conti_shift                                      (1)
#define HDMI_ONMS_CTRL_start_ms_shift                                      (0)
#define HDMI_ONMS_CTRL_dummy_ctrl_mask                                     (0xF0000000)
#define HDMI_ONMS_CTRL_pixel_get_en_mask                                   (0x08000000)
#define HDMI_ONMS_CTRL_pixel_get_sel_mask                                  (0x06000000)
#define HDMI_ONMS_CTRL_progressive_mask                                    (0x01000000)
#define HDMI_ONMS_CTRL_vtotal_max_delta_mask                               (0x00F00000)
#define HDMI_ONMS_CTRL_htotal_max_delta_mask                               (0x000F0000)
#define HDMI_ONMS_CTRL_pixel_encoding_mask                                 (0x00001000)
#define HDMI_ONMS_CTRL_vact_space_threshold_mask                           (0x00000F00)
#define HDMI_ONMS_CTRL_vact_space_meas_en_mask                             (0x00000080)
#define HDMI_ONMS_CTRL_meas_to_sel_mask                                    (0x00000040)
#define HDMI_ONMS_CTRL_sycms_clk_mask                                      (0x00000020)
#define HDMI_ONMS_CTRL_vs_meas_inv_mask                                    (0x00000010)
#define HDMI_ONMS_CTRL_hs_meas_inv_mask                                    (0x00000008)
#define HDMI_ONMS_CTRL_popup_meas_mask                                     (0x00000004)
#define HDMI_ONMS_CTRL_ms_conti_mask                                       (0x00000002)
#define HDMI_ONMS_CTRL_start_ms_mask                                       (0x00000001)
#define HDMI_ONMS_CTRL_dummy_ctrl(data)                                    (0xF0000000&((data)<<28))
#define HDMI_ONMS_CTRL_pixel_get_en(data)                                  (0x08000000&((data)<<27))
#define HDMI_ONMS_CTRL_pixel_get_sel(data)                                 (0x06000000&((data)<<25))
#define HDMI_ONMS_CTRL_progressive(data)                                   (0x01000000&((data)<<24))
#define HDMI_ONMS_CTRL_vtotal_max_delta(data)                              (0x00F00000&((data)<<20))
#define HDMI_ONMS_CTRL_htotal_max_delta(data)                              (0x000F0000&((data)<<16))
#define HDMI_ONMS_CTRL_pixel_encoding(data)                                (0x00001000&((data)<<12))
#define HDMI_ONMS_CTRL_vact_space_threshold(data)                          (0x00000F00&((data)<<8))
#define HDMI_ONMS_CTRL_vact_space_meas_en(data)                            (0x00000080&((data)<<7))
#define HDMI_ONMS_CTRL_meas_to_sel(data)                                   (0x00000040&((data)<<6))
#define HDMI_ONMS_CTRL_sycms_clk(data)                                     (0x00000020&((data)<<5))
#define HDMI_ONMS_CTRL_vs_meas_inv(data)                                   (0x00000010&((data)<<4))
#define HDMI_ONMS_CTRL_hs_meas_inv(data)                                   (0x00000008&((data)<<3))
#define HDMI_ONMS_CTRL_popup_meas(data)                                    (0x00000004&((data)<<2))
#define HDMI_ONMS_CTRL_ms_conti(data)                                      (0x00000002&((data)<<1))
#define HDMI_ONMS_CTRL_start_ms(data)                                      (0x00000001&(data))
#define HDMI_ONMS_CTRL_get_dummy_ctrl(data)                                ((0xF0000000&(data))>>28)
#define HDMI_ONMS_CTRL_get_pixel_get_en(data)                              ((0x08000000&(data))>>27)
#define HDMI_ONMS_CTRL_get_pixel_get_sel(data)                             ((0x06000000&(data))>>25)
#define HDMI_ONMS_CTRL_get_progressive(data)                               ((0x01000000&(data))>>24)
#define HDMI_ONMS_CTRL_get_vtotal_max_delta(data)                          ((0x00F00000&(data))>>20)
#define HDMI_ONMS_CTRL_get_htotal_max_delta(data)                          ((0x000F0000&(data))>>16)
#define HDMI_ONMS_CTRL_get_pixel_encoding(data)                            ((0x00001000&(data))>>12)
#define HDMI_ONMS_CTRL_get_vact_space_threshold(data)                      ((0x00000F00&(data))>>8)
#define HDMI_ONMS_CTRL_get_vact_space_meas_en(data)                        ((0x00000080&(data))>>7)
#define HDMI_ONMS_CTRL_get_meas_to_sel(data)                               ((0x00000040&(data))>>6)
#define HDMI_ONMS_CTRL_get_sycms_clk(data)                                 ((0x00000020&(data))>>5)
#define HDMI_ONMS_CTRL_get_vs_meas_inv(data)                               ((0x00000010&(data))>>4)
#define HDMI_ONMS_CTRL_get_hs_meas_inv(data)                               ((0x00000008&(data))>>3)
#define HDMI_ONMS_CTRL_get_popup_meas(data)                                ((0x00000004&(data))>>2)
#define HDMI_ONMS_CTRL_get_ms_conti(data)                                  ((0x00000002&(data))>>1)
#define HDMI_ONMS_CTRL_get_start_ms(data)                                  (0x00000001&(data))
/*
//This REG is not used by HDMI
#define HDMI_ONMS_BLANK_PIXEL_VALUE_GET_0                                  0x18021304
#define HDMI_ONMS_BLANK_PIXEL_VALUE_GET_0_reg_addr                         "0xb8021304"
#define HDMI_ONMS_BLANK_PIXEL_VALUE_GET_0_reg                              0xb8021304
#define HDMI_ONMS_BLANK_PIXEL_VALUE_GET_0_inst_addr                        "0x00C1"
#define HDMI_ONMS_BLANK_PIXEL_VALUE_GET_0_inst                             0x00C1
#define HDMI_ONMS_BLANK_PIXEL_VALUE_GET_0_pixel_ok_shift                   (24)
#define HDMI_ONMS_BLANK_PIXEL_VALUE_GET_0_get_r_value_shift                (12)
#define HDMI_ONMS_BLANK_PIXEL_VALUE_GET_0_get_g_value_shift                (0)
#define HDMI_ONMS_BLANK_PIXEL_VALUE_GET_0_pixel_ok_mask                    (0x01000000)
#define HDMI_ONMS_BLANK_PIXEL_VALUE_GET_0_get_r_value_mask                 (0x00FFF000)
#define HDMI_ONMS_BLANK_PIXEL_VALUE_GET_0_get_g_value_mask                 (0x00000FFF)
#define HDMI_ONMS_BLANK_PIXEL_VALUE_GET_0_pixel_ok(data)                   (0x01000000&((data)<<24))
#define HDMI_ONMS_BLANK_PIXEL_VALUE_GET_0_get_r_value(data)                (0x00FFF000&((data)<<12))
#define HDMI_ONMS_BLANK_PIXEL_VALUE_GET_0_get_g_value(data)                (0x00000FFF&(data))
#define HDMI_ONMS_BLANK_PIXEL_VALUE_GET_0_get_pixel_ok(data)               ((0x01000000&(data))>>24)
#define HDMI_ONMS_BLANK_PIXEL_VALUE_GET_0_get_get_r_value(data)            ((0x00FFF000&(data))>>12)
#define HDMI_ONMS_BLANK_PIXEL_VALUE_GET_0_get_get_g_value(data)            (0x00000FFF&(data))


#define HDMI_ONMS_BLANK_PIXEL_VALUE_GET_1                                  0x18021308
#define HDMI_ONMS_BLANK_PIXEL_VALUE_GET_1_reg_addr                         "0xb8021308"
#define HDMI_ONMS_BLANK_PIXEL_VALUE_GET_1_reg                              0xb8021308
#define HDMI_ONMS_BLANK_PIXEL_VALUE_GET_1_inst_addr                        "0x00C2"
#define HDMI_ONMS_BLANK_PIXEL_VALUE_GET_1_inst                             0x00C2
#define HDMI_ONMS_BLANK_PIXEL_VALUE_GET_1_get_b_value_shift                (0)
#define HDMI_ONMS_BLANK_PIXEL_VALUE_GET_1_get_b_value_mask                 (0x00000FFF)
#define HDMI_ONMS_BLANK_PIXEL_VALUE_GET_1_get_b_value(data)                (0x00000FFF&(data))
#define HDMI_ONMS_BLANK_PIXEL_VALUE_GET_1_get_get_b_value(data)            (0x00000FFF&(data))


#define HDMI_ONMS_BLANK_PIXEL_VALUE_0                                      0x1802130c
#define HDMI_ONMS_BLANK_PIXEL_VALUE_0_reg_addr                             "0xb802130c"
#define HDMI_ONMS_BLANK_PIXEL_VALUE_0_reg                                  0xb802130c
#define HDMI_ONMS_BLANK_PIXEL_VALUE_0_inst_addr                            "0x00C3"
#define HDMI_ONMS_BLANK_PIXEL_VALUE_0_inst                                 0x00C3
#define HDMI_ONMS_BLANK_PIXEL_VALUE_0_active_r_value_shift                 (12)
#define HDMI_ONMS_BLANK_PIXEL_VALUE_0_active_g_value_shift                 (0)
#define HDMI_ONMS_BLANK_PIXEL_VALUE_0_active_r_value_mask                  (0x00FFF000)
#define HDMI_ONMS_BLANK_PIXEL_VALUE_0_active_g_value_mask                  (0x00000FFF)
#define HDMI_ONMS_BLANK_PIXEL_VALUE_0_active_r_value(data)                 (0x00FFF000&((data)<<12))
#define HDMI_ONMS_BLANK_PIXEL_VALUE_0_active_g_value(data)                 (0x00000FFF&(data))
#define HDMI_ONMS_BLANK_PIXEL_VALUE_0_get_active_r_value(data)             ((0x00FFF000&(data))>>12)
#define HDMI_ONMS_BLANK_PIXEL_VALUE_0_get_active_g_value(data)             (0x00000FFF&(data))


#define HDMI_ONMS_BLANK_PIXEL_VALUE_1                                      0x18021310
#define HDMI_ONMS_BLANK_PIXEL_VALUE_1_reg_addr                             "0xb8021310"
#define HDMI_ONMS_BLANK_PIXEL_VALUE_1_reg                                  0xb8021310
#define HDMI_ONMS_BLANK_PIXEL_VALUE_1_inst_addr                            "0x00C4"
#define HDMI_ONMS_BLANK_PIXEL_VALUE_1_inst                                 0x00C4
#define HDMI_ONMS_BLANK_PIXEL_VALUE_1_active_b_value_shift                 (0)
#define HDMI_ONMS_BLANK_PIXEL_VALUE_1_active_b_value_mask                  (0x00000FFF)
#define HDMI_ONMS_BLANK_PIXEL_VALUE_1_active_b_value(data)                 (0x00000FFF&(data))
#define HDMI_ONMS_BLANK_PIXEL_VALUE_1_get_active_b_value(data)             (0x00000FFF&(data))


#define HDMI_ONMS_FP_VACT12                                                0x18021314
#define HDMI_ONMS_FP_VACT12_reg_addr                                       "0xb8021314"
#define HDMI_ONMS_FP_VACT12_reg                                            0xb8021314
#define HDMI_ONMS_FP_VACT12_inst_addr                                      "0x00C5"
#define HDMI_ONMS_FP_VACT12_inst                                           0x00C5
#define HDMI_ONMS_FP_VACT12_vact2_shift                                    (16)
#define HDMI_ONMS_FP_VACT12_vact1_shift                                    (0)
#define HDMI_ONMS_FP_VACT12_vact2_mask                                     (0x07FF0000)
#define HDMI_ONMS_FP_VACT12_vact1_mask                                     (0x000007FF)
#define HDMI_ONMS_FP_VACT12_vact2(data)                                    (0x07FF0000&((data)<<16))
#define HDMI_ONMS_FP_VACT12_vact1(data)                                    (0x000007FF&(data))
#define HDMI_ONMS_FP_VACT12_get_vact2(data)                                ((0x07FF0000&(data))>>16)
#define HDMI_ONMS_FP_VACT12_get_vact1(data)                                (0x000007FF&(data))


#define HDMI_ONMS_FP_VACT34                                                0x18021318
#define HDMI_ONMS_FP_VACT34_reg_addr                                       "0xb8021318"
#define HDMI_ONMS_FP_VACT34_reg                                            0xb8021318
#define HDMI_ONMS_FP_VACT34_inst_addr                                      "0x00C6"
#define HDMI_ONMS_FP_VACT34_inst                                           0x00C6
#define HDMI_ONMS_FP_VACT34_vact4_shift                                    (16)
#define HDMI_ONMS_FP_VACT34_vact3_shift                                    (0)
#define HDMI_ONMS_FP_VACT34_vact4_mask                                     (0x07FF0000)
#define HDMI_ONMS_FP_VACT34_vact3_mask                                     (0x000007FF)
#define HDMI_ONMS_FP_VACT34_vact4(data)                                    (0x07FF0000&((data)<<16))
#define HDMI_ONMS_FP_VACT34_vact3(data)                                    (0x000007FF&(data))
#define HDMI_ONMS_FP_VACT34_get_vact4(data)                                ((0x07FF0000&(data))>>16)
#define HDMI_ONMS_FP_VACT34_get_vact3(data)                                (0x000007FF&(data))


#define HDMI_ONMS_FP_VACT_SPACE                                            0x1802131c
#define HDMI_ONMS_FP_VACT_SPACE_reg_addr                                   "0xb802131c"
#define HDMI_ONMS_FP_VACT_SPACE_reg                                        0xb802131c
#define HDMI_ONMS_FP_VACT_SPACE_inst_addr                                  "0x00C7"
#define HDMI_ONMS_FP_VACT_SPACE_inst                                       0x00C7
#define HDMI_ONMS_FP_VACT_SPACE_fp_vact_space1_shift                       (20)
#define HDMI_ONMS_FP_VACT_SPACE_fp_vact_space2_shift                       (10)
#define HDMI_ONMS_FP_VACT_SPACE_fp_vact_space3_shift                       (0)
#define HDMI_ONMS_FP_VACT_SPACE_fp_vact_space1_mask                        (0x3FF00000)
#define HDMI_ONMS_FP_VACT_SPACE_fp_vact_space2_mask                        (0x000FFC00)
#define HDMI_ONMS_FP_VACT_SPACE_fp_vact_space3_mask                        (0x000003FF)
#define HDMI_ONMS_FP_VACT_SPACE_fp_vact_space1(data)                       (0x3FF00000&((data)<<20))
#define HDMI_ONMS_FP_VACT_SPACE_fp_vact_space2(data)                       (0x000FFC00&((data)<<10))
#define HDMI_ONMS_FP_VACT_SPACE_fp_vact_space3(data)                       (0x000003FF&(data))
#define HDMI_ONMS_FP_VACT_SPACE_get_fp_vact_space1(data)                   ((0x3FF00000&(data))>>20)
#define HDMI_ONMS_FP_VACT_SPACE_get_fp_vact_space2(data)                   ((0x000FFC00&(data))>>10)
#define HDMI_ONMS_FP_VACT_SPACE_get_fp_vact_space3(data)                   (0x000003FF&(data))


#define HDMI_ONMS_BLANK_LINE                                               0x18021320
#define HDMI_ONMS_BLANK_LINE_reg_addr                                      "0xb8021320"
#define HDMI_ONMS_BLANK_LINE_reg                                           0xb8021320
#define HDMI_ONMS_BLANK_LINE_inst_addr                                     "0x00C8"
#define HDMI_ONMS_BLANK_LINE_inst                                          0x00C8
#define HDMI_ONMS_BLANK_LINE_r_blank_line_start_shift                      (16)
#define HDMI_ONMS_BLANK_LINE_l_blank_line_end_shift                        (0)
#define HDMI_ONMS_BLANK_LINE_r_blank_line_start_mask                       (0x07FF0000)
#define HDMI_ONMS_BLANK_LINE_l_blank_line_end_mask                         (0x000007FF)
#define HDMI_ONMS_BLANK_LINE_r_blank_line_start(data)                      (0x07FF0000&((data)<<16))
#define HDMI_ONMS_BLANK_LINE_l_blank_line_end(data)                        (0x000007FF&(data))
#define HDMI_ONMS_BLANK_LINE_get_r_blank_line_start(data)                  ((0x07FF0000&(data))>>16)
#define HDMI_ONMS_BLANK_LINE_get_l_blank_line_end(data)                    (0x000007FF&(data))


#define HDMI_ONMS_ACTIVE_SPACE1_LINE_NUMBER                                0x18021324
#define HDMI_ONMS_ACTIVE_SPACE1_LINE_NUMBER_reg_addr                       "0xb8021324"
#define HDMI_ONMS_ACTIVE_SPACE1_LINE_NUMBER_reg                            0xb8021324
#define HDMI_ONMS_ACTIVE_SPACE1_LINE_NUMBER_inst_addr                      "0x00C9"
#define HDMI_ONMS_ACTIVE_SPACE1_LINE_NUMBER_inst                           0x00C9
#define HDMI_ONMS_ACTIVE_SPACE1_LINE_NUMBER_vact_space1_end_shift          (16)
#define HDMI_ONMS_ACTIVE_SPACE1_LINE_NUMBER_vact_space1_start_shift        (0)
#define HDMI_ONMS_ACTIVE_SPACE1_LINE_NUMBER_vact_space1_end_mask           (0x03FF0000)
#define HDMI_ONMS_ACTIVE_SPACE1_LINE_NUMBER_vact_space1_start_mask         (0x000003FF)
#define HDMI_ONMS_ACTIVE_SPACE1_LINE_NUMBER_vact_space1_end(data)          (0x03FF0000&((data)<<16))
#define HDMI_ONMS_ACTIVE_SPACE1_LINE_NUMBER_vact_space1_start(data)        (0x000003FF&(data))
#define HDMI_ONMS_ACTIVE_SPACE1_LINE_NUMBER_get_vact_space1_end(data)      ((0x03FF0000&(data))>>16)
#define HDMI_ONMS_ACTIVE_SPACE1_LINE_NUMBER_get_vact_space1_start(data)    (0x000003FF&(data))


#define HDMI_ONMS_ACTIVE_SPACE2_LINE_NUMBER                                0x18021328
#define HDMI_ONMS_ACTIVE_SPACE2_LINE_NUMBER_reg_addr                       "0xb8021328"
#define HDMI_ONMS_ACTIVE_SPACE2_LINE_NUMBER_reg                            0xb8021328
#define HDMI_ONMS_ACTIVE_SPACE2_LINE_NUMBER_inst_addr                      "0x00CA"
#define HDMI_ONMS_ACTIVE_SPACE2_LINE_NUMBER_inst                           0x00CA
#define HDMI_ONMS_ACTIVE_SPACE2_LINE_NUMBER_vact_space2_end_shift          (16)
#define HDMI_ONMS_ACTIVE_SPACE2_LINE_NUMBER_vact_space2_start_shift        (0)
#define HDMI_ONMS_ACTIVE_SPACE2_LINE_NUMBER_vact_space2_end_mask           (0x03FF0000)
#define HDMI_ONMS_ACTIVE_SPACE2_LINE_NUMBER_vact_space2_start_mask         (0x000003FF)
#define HDMI_ONMS_ACTIVE_SPACE2_LINE_NUMBER_vact_space2_end(data)          (0x03FF0000&((data)<<16))
#define HDMI_ONMS_ACTIVE_SPACE2_LINE_NUMBER_vact_space2_start(data)        (0x000003FF&(data))
#define HDMI_ONMS_ACTIVE_SPACE2_LINE_NUMBER_get_vact_space2_end(data)      ((0x03FF0000&(data))>>16)
#define HDMI_ONMS_ACTIVE_SPACE2_LINE_NUMBER_get_vact_space2_start(data)    (0x000003FF&(data))


#define HDMI_ONMS_ACTIVE_SPACE3_LINE_NUMBER                                0x1802132c
#define HDMI_ONMS_ACTIVE_SPACE3_LINE_NUMBER_reg_addr                       "0xb802132c"
#define HDMI_ONMS_ACTIVE_SPACE3_LINE_NUMBER_reg                            0xb802132c
#define HDMI_ONMS_ACTIVE_SPACE3_LINE_NUMBER_inst_addr                      "0x00CB"
#define HDMI_ONMS_ACTIVE_SPACE3_LINE_NUMBER_inst                           0x00CB
#define HDMI_ONMS_ACTIVE_SPACE3_LINE_NUMBER_vact_space3_end_shift          (16)
#define HDMI_ONMS_ACTIVE_SPACE3_LINE_NUMBER_vact_space3_start_shift        (0)
#define HDMI_ONMS_ACTIVE_SPACE3_LINE_NUMBER_vact_space3_end_mask           (0x03FF0000)
#define HDMI_ONMS_ACTIVE_SPACE3_LINE_NUMBER_vact_space3_start_mask         (0x000003FF)
#define HDMI_ONMS_ACTIVE_SPACE3_LINE_NUMBER_vact_space3_end(data)          (0x03FF0000&((data)<<16))
#define HDMI_ONMS_ACTIVE_SPACE3_LINE_NUMBER_vact_space3_start(data)        (0x000003FF&(data))
#define HDMI_ONMS_ACTIVE_SPACE3_LINE_NUMBER_get_vact_space3_end(data)      ((0x03FF0000&(data))>>16)
#define HDMI_ONMS_ACTIVE_SPACE3_LINE_NUMBER_get_vact_space3_start(data)    (0x000003FF&(data))
*/
//This REG is  used by HDMI
#define HDMI_ONMS_VS_PERIOD                                                0x18021330
#define HDMI_ONMS_VS_PERIOD_reg_addr                                       "0xb8021330"
#define HDMI_ONMS_VS_PERIOD_reg                                            0xb8021330
#define HDMI_ONMS_VS_PERIOD_inst_addr                                      "0x00CC"
#define HDMI_ONMS_VS_PERIOD_inst                                           0x00CC
#define HDMI_ONMS_VS_PERIOD_vtotalde_shift                                 (16)
#define HDMI_ONMS_VS_PERIOD_vtotal_shift                                   (0)
#define HDMI_ONMS_VS_PERIOD_vtotalde_mask                                  (0x1FFF0000)
#define HDMI_ONMS_VS_PERIOD_vtotal_mask                                    (0x00003FFF)
#define HDMI_ONMS_VS_PERIOD_vtotalde(data)                                 (0x1FFF0000&((data)<<16))
#define HDMI_ONMS_VS_PERIOD_vtotal(data)                                   (0x00003FFF&(data))
#define HDMI_ONMS_VS_PERIOD_get_vtotalde(data)                             ((0x1FFF0000&(data))>>16)
#define HDMI_ONMS_VS_PERIOD_get_vtotal(data)                               (0x00003FFF&(data))

//This REG is not used by HDMI
/*
#define HDMI_ONMS_VSHS_HIGH_PERIOD                                         0x18021334
#define HDMI_ONMS_VSHS_HIGH_PERIOD_reg_addr                                "0xb8021334"
#define HDMI_ONMS_VSHS_HIGH_PERIOD_reg                                     0xb8021334
#define HDMI_ONMS_VSHS_HIGH_PERIOD_inst_addr                               "0x00CD"
#define HDMI_ONMS_VSHS_HIGH_PERIOD_inst                                    0x00CD
#define HDMI_ONMS_VSHS_HIGH_PERIOD_hact_fract_shift                        (29)
#define HDMI_ONMS_VSHS_HIGH_PERIOD_htotal_fract_shift                      (26)
#define HDMI_ONMS_VSHS_HIGH_PERIOD_vs_high_period_shift                    (14)
#define HDMI_ONMS_VSHS_HIGH_PERIOD_hs_high_period_shift                    (0)
#define HDMI_ONMS_VSHS_HIGH_PERIOD_hact_fract_mask                         (0xE0000000)
#define HDMI_ONMS_VSHS_HIGH_PERIOD_htotal_fract_mask                       (0x1C000000)
#define HDMI_ONMS_VSHS_HIGH_PERIOD_vs_high_period_mask                     (0x03FFC000)
#define HDMI_ONMS_VSHS_HIGH_PERIOD_hs_high_period_mask                     (0x00003FFF)
#define HDMI_ONMS_VSHS_HIGH_PERIOD_hact_fract(data)                        (0xE0000000&((data)<<29))
#define HDMI_ONMS_VSHS_HIGH_PERIOD_htotal_fract(data)                      (0x1C000000&((data)<<26))
#define HDMI_ONMS_VSHS_HIGH_PERIOD_vs_high_period(data)                    (0x03FFC000&((data)<<14))
#define HDMI_ONMS_VSHS_HIGH_PERIOD_hs_high_period(data)                    (0x00003FFF&(data))
#define HDMI_ONMS_VSHS_HIGH_PERIOD_get_hact_fract(data)                    ((0xE0000000&(data))>>29)
#define HDMI_ONMS_VSHS_HIGH_PERIOD_get_htotal_fract(data)                  ((0x1C000000&(data))>>26)
#define HDMI_ONMS_VSHS_HIGH_PERIOD_get_vs_high_period(data)                ((0x03FFC000&(data))>>14)
#define HDMI_ONMS_VSHS_HIGH_PERIOD_get_hs_high_period(data)                (0x00003FFF&(data))
*/

#define HDMI_ONMS_HS_PERIOD                                                0x18021338
#define HDMI_ONMS_HS_PERIOD_reg_addr                                       "0xb8021338"
#define HDMI_ONMS_HS_PERIOD_reg                                            0xb8021338
#define HDMI_ONMS_HS_PERIOD_inst_addr                                      "0x00CE"
#define HDMI_ONMS_HS_PERIOD_inst                                           0x00CE
#define HDMI_ONMS_HS_PERIOD_hact_shift                                     (18)
#define HDMI_ONMS_HS_PERIOD_htotal_shift                                   (2)
#define HDMI_ONMS_HS_PERIOD_hact_mask                                      (0xFFFC0000)
#define HDMI_ONMS_HS_PERIOD_htotal_mask                                    (0x0000FFFC)
#define HDMI_ONMS_HS_PERIOD_hact(data)                                     (0xFFFC0000&((data)<<18))
#define HDMI_ONMS_HS_PERIOD_htotal(data)                                   (0x0000FFFC&((data)<<2))
#define HDMI_ONMS_HS_PERIOD_get_hact(data)                                 ((0xFFFC0000&(data))>>18)
#define HDMI_ONMS_HS_PERIOD_get_htotal(data)                               ((0x0000FFFC&(data))>>2)

#define ONMS1_HS_PERIOD                                               0x18021338
#define ONMS1_HS_PERIOD_reg_addr                                      "0xb8021338"
#define ONMS1_HS_PERIOD_reg                                           0xb8021338
#define ONMS1_HS_PERIOD_inst_addr                                     "0x00CE"
#define ONMS1_HS_PERIOD_inst                                          0x00CE
#define set_ONMS1_HS_PERIOD_reg(data)                                 (*((volatile unsigned int*)ONMS1_HS_PERIOD_reg)=data)
#define get_ONMS1_HS_PERIOD_reg                                       (*((volatile unsigned int*)ONMS1_HS_PERIOD_reg))
#define ONMS1_HS_PERIOD_on1_htotal_h12b_shift                         (4)
#define ONMS1_HS_PERIOD_on1_htotal_f4b_shift                          (0)
#define ONMS1_HS_PERIOD_on1_htotal_h12b_mask                          (0x0003FFF0)
#define ONMS1_HS_PERIOD_on1_htotal_f4b_mask                           (0x0000000F)
#define ONMS1_HS_PERIOD_on1_htotal_h12b(data)                         (0x0003FFF0&((data)<<4))
#define ONMS1_HS_PERIOD_on1_htotal_f4b(data)                          (0x0000000F&(data))
#define ONMS1_HS_PERIOD_get_on1_htotal_h12b(data)                     ((0x0003FFF0&(data))>>4)
#define ONMS1_HS_PERIOD_get_on1_htotal_f4b(data)                      (0x0000000F&(data))


#define HDMI_ONMS_VACT_STA                                                 0x1802133c
#define HDMI_ONMS_VACT_STA_reg_addr                                        "0xb802133c"
#define HDMI_ONMS_VACT_STA_reg                                             0xb802133c
#define HDMI_ONMS_VACT_STA_inst_addr                                       "0x00CF"
#define HDMI_ONMS_VACT_STA_inst                                            0x00CF
#define HDMI_ONMS_VACT_STA_vblank_len_shift                                (16)
#define HDMI_ONMS_VACT_STA_vact_start_shift                                (0)
#define HDMI_ONMS_VACT_STA_vblank_len_mask                                 (0x00FF0000)
#define HDMI_ONMS_VACT_STA_vact_start_mask                                 (0x00000FFF)
#define HDMI_ONMS_VACT_STA_vblank_len(data)                                (0x00FF0000&((data)<<16))
#define HDMI_ONMS_VACT_STA_vact_start(data)                                (0x00000FFF&(data))
#define HDMI_ONMS_VACT_STA_get_vblank_len(data)                            ((0x00FF0000&(data))>>16)
#define HDMI_ONMS_VACT_STA_get_vact_start(data)                            (0x00000FFF&(data))

//This REG is not used by HDMI

#define HDMI_ONMS_VACT_SPACE_MIN_VALUE                                     0x18021340
#define HDMI_ONMS_VACT_SPACE_MIN_VALUE_reg_addr                            "0xb8021340"
#define HDMI_ONMS_VACT_SPACE_MIN_VALUE_reg                                 0xb8021340
#define HDMI_ONMS_VACT_SPACE_MIN_VALUE_inst_addr                           "0x00D0"
#define HDMI_ONMS_VACT_SPACE_MIN_VALUE_inst                                0x00D0
#define HDMI_ONMS_VACT_SPACE_MIN_VALUE_vact_space3_min_shift               (20)
#define HDMI_ONMS_VACT_SPACE_MIN_VALUE_vact_space2_min_shift               (10)
#define HDMI_ONMS_VACT_SPACE_MIN_VALUE_vact_space1_min_shift               (0)
#define HDMI_ONMS_VACT_SPACE_MIN_VALUE_vact_space3_min_mask                (0x3FF00000)
#define HDMI_ONMS_VACT_SPACE_MIN_VALUE_vact_space2_min_mask                (0x000FFC00)
#define HDMI_ONMS_VACT_SPACE_MIN_VALUE_vact_space1_min_mask                (0x000003FF)
#define HDMI_ONMS_VACT_SPACE_MIN_VALUE_vact_space3_min(data)               (0x3FF00000&((data)<<20))
#define HDMI_ONMS_VACT_SPACE_MIN_VALUE_vact_space2_min(data)               (0x000FFC00&((data)<<10))
#define HDMI_ONMS_VACT_SPACE_MIN_VALUE_vact_space1_min(data)               (0x000003FF&(data))
#define HDMI_ONMS_VACT_SPACE_MIN_VALUE_get_vact_space3_min(data)           ((0x3FF00000&(data))>>20)
#define HDMI_ONMS_VACT_SPACE_MIN_VALUE_get_vact_space2_min(data)           ((0x000FFC00&(data))>>10)
#define HDMI_ONMS_VACT_SPACE_MIN_VALUE_get_vact_space1_min(data)           (0x000003FF&(data))

//This REG is not used by HDMI
#define HDMI_ONMS_VACT_SPACE1_MAX_INFO                                     0x18021344
#define HDMI_ONMS_VACT_SPACE1_MAX_INFO_reg_addr                            "0xb8021344"
#define HDMI_ONMS_VACT_SPACE1_MAX_INFO_reg                                 0xb8021344
#define HDMI_ONMS_VACT_SPACE1_MAX_INFO_inst_addr                           "0x00D1"
#define HDMI_ONMS_VACT_SPACE1_MAX_INFO_inst                                0x00D1
#define HDMI_ONMS_VACT_SPACE1_MAX_INFO_as1_max_end_shift                   (20)
#define HDMI_ONMS_VACT_SPACE1_MAX_INFO_as1_max_start_shift                 (10)
#define HDMI_ONMS_VACT_SPACE1_MAX_INFO_as1_max_diff_shift                  (0)
#define HDMI_ONMS_VACT_SPACE1_MAX_INFO_as1_max_end_mask                    (0x3FF00000)
#define HDMI_ONMS_VACT_SPACE1_MAX_INFO_as1_max_start_mask                  (0x000FFC00)
#define HDMI_ONMS_VACT_SPACE1_MAX_INFO_as1_max_diff_mask                   (0x000003FF)
#define HDMI_ONMS_VACT_SPACE1_MAX_INFO_as1_max_end(data)                   (0x3FF00000&((data)<<20))
#define HDMI_ONMS_VACT_SPACE1_MAX_INFO_as1_max_start(data)                 (0x000FFC00&((data)<<10))
#define HDMI_ONMS_VACT_SPACE1_MAX_INFO_as1_max_diff(data)                  (0x000003FF&(data))
#define HDMI_ONMS_VACT_SPACE1_MAX_INFO_get_as1_max_end(data)               ((0x3FF00000&(data))>>20)
#define HDMI_ONMS_VACT_SPACE1_MAX_INFO_get_as1_max_start(data)             ((0x000FFC00&(data))>>10)
#define HDMI_ONMS_VACT_SPACE1_MAX_INFO_get_as1_max_diff(data)              (0x000003FF&(data))

//This REG is not used by HDMI
#define HDMI_ONMS_VACT_SPACE2_MAX_INFO                                     0x18021348
#define HDMI_ONMS_VACT_SPACE2_MAX_INFO_reg_addr                            "0xb8021348"
#define HDMI_ONMS_VACT_SPACE2_MAX_INFO_reg                                 0xb8021348
#define HDMI_ONMS_VACT_SPACE2_MAX_INFO_inst_addr                           "0x00D2"
#define HDMI_ONMS_VACT_SPACE2_MAX_INFO_inst                                0x00D2
#define HDMI_ONMS_VACT_SPACE2_MAX_INFO_as2_max_end_shift                   (20)
#define HDMI_ONMS_VACT_SPACE2_MAX_INFO_as2_max_start_shift                 (10)
#define HDMI_ONMS_VACT_SPACE2_MAX_INFO_as2_max_diff_shift                  (0)
#define HDMI_ONMS_VACT_SPACE2_MAX_INFO_as2_max_end_mask                    (0x3FF00000)
#define HDMI_ONMS_VACT_SPACE2_MAX_INFO_as2_max_start_mask                  (0x000FFC00)
#define HDMI_ONMS_VACT_SPACE2_MAX_INFO_as2_max_diff_mask                   (0x000003FF)
#define HDMI_ONMS_VACT_SPACE2_MAX_INFO_as2_max_end(data)                   (0x3FF00000&((data)<<20))
#define HDMI_ONMS_VACT_SPACE2_MAX_INFO_as2_max_start(data)                 (0x000FFC00&((data)<<10))
#define HDMI_ONMS_VACT_SPACE2_MAX_INFO_as2_max_diff(data)                  (0x000003FF&(data))
#define HDMI_ONMS_VACT_SPACE2_MAX_INFO_get_as2_max_end(data)               ((0x3FF00000&(data))>>20)
#define HDMI_ONMS_VACT_SPACE2_MAX_INFO_get_as2_max_start(data)             ((0x000FFC00&(data))>>10)
#define HDMI_ONMS_VACT_SPACE2_MAX_INFO_get_as2_max_diff(data)              (0x000003FF&(data))

//This REG is not used by HDMI
#define HDMI_ONMS_VACT_SPACE3_MAX_INFO                                     0x1802134c
#define HDMI_ONMS_VACT_SPACE3_MAX_INFO_reg_addr                            "0xb802134c"
#define HDMI_ONMS_VACT_SPACE3_MAX_INFO_reg                                 0xb802134c
#define HDMI_ONMS_VACT_SPACE3_MAX_INFO_inst_addr                           "0x00D3"
#define HDMI_ONMS_VACT_SPACE3_MAX_INFO_inst                                0x00D3
#define HDMI_ONMS_VACT_SPACE3_MAX_INFO_as3_max_end_shift                   (20)
#define HDMI_ONMS_VACT_SPACE3_MAX_INFO_as3_max_start_shift                 (10)
#define HDMI_ONMS_VACT_SPACE3_MAX_INFO_as3_max_diff_shift                  (0)
#define HDMI_ONMS_VACT_SPACE3_MAX_INFO_as3_max_end_mask                    (0x3FF00000)
#define HDMI_ONMS_VACT_SPACE3_MAX_INFO_as3_max_start_mask                  (0x000FFC00)
#define HDMI_ONMS_VACT_SPACE3_MAX_INFO_as3_max_diff_mask                   (0x000003FF)
#define HDMI_ONMS_VACT_SPACE3_MAX_INFO_as3_max_end(data)                   (0x3FF00000&((data)<<20))
#define HDMI_ONMS_VACT_SPACE3_MAX_INFO_as3_max_start(data)                 (0x000FFC00&((data)<<10))
#define HDMI_ONMS_VACT_SPACE3_MAX_INFO_as3_max_diff(data)                  (0x000003FF&(data))
#define HDMI_ONMS_VACT_SPACE3_MAX_INFO_get_as3_max_end(data)               ((0x3FF00000&(data))>>20)
#define HDMI_ONMS_VACT_SPACE3_MAX_INFO_get_as3_max_start(data)             ((0x000FFC00&(data))>>10)
#define HDMI_ONMS_VACT_SPACE3_MAX_INFO_get_as3_max_diff(data)              (0x000003FF&(data))

//This REG is not used by HDMI
#define HDMI_ONMS_VACT_SPACE1_MIN_INFO                                     0x18021350
#define HDMI_ONMS_VACT_SPACE1_MIN_INFO_reg_addr                            "0xb8021350"
#define HDMI_ONMS_VACT_SPACE1_MIN_INFO_reg                                 0xb8021350
#define HDMI_ONMS_VACT_SPACE1_MIN_INFO_inst_addr                           "0x00D4"
#define HDMI_ONMS_VACT_SPACE1_MIN_INFO_inst                                0x00D4
#define HDMI_ONMS_VACT_SPACE1_MIN_INFO_as1_min_end_shift                   (20)
#define HDMI_ONMS_VACT_SPACE1_MIN_INFO_as1_min_start_shift                 (10)
#define HDMI_ONMS_VACT_SPACE1_MIN_INFO_as1_min_diff_shift                  (0)
#define HDMI_ONMS_VACT_SPACE1_MIN_INFO_as1_min_end_mask                    (0x3FF00000)
#define HDMI_ONMS_VACT_SPACE1_MIN_INFO_as1_min_start_mask                  (0x000FFC00)
#define HDMI_ONMS_VACT_SPACE1_MIN_INFO_as1_min_diff_mask                   (0x000003FF)
#define HDMI_ONMS_VACT_SPACE1_MIN_INFO_as1_min_end(data)                   (0x3FF00000&((data)<<20))
#define HDMI_ONMS_VACT_SPACE1_MIN_INFO_as1_min_start(data)                 (0x000FFC00&((data)<<10))
#define HDMI_ONMS_VACT_SPACE1_MIN_INFO_as1_min_diff(data)                  (0x000003FF&(data))
#define HDMI_ONMS_VACT_SPACE1_MIN_INFO_get_as1_min_end(data)               ((0x3FF00000&(data))>>20)
#define HDMI_ONMS_VACT_SPACE1_MIN_INFO_get_as1_min_start(data)             ((0x000FFC00&(data))>>10)
#define HDMI_ONMS_VACT_SPACE1_MIN_INFO_get_as1_min_diff(data)              (0x000003FF&(data))

//This REG is not used by HDMI
#define HDMI_ONMS_VACT_SPACE2_MIN_INFO                                     0x18021354
#define HDMI_ONMS_VACT_SPACE2_MIN_INFO_reg_addr                            "0xb8021354"
#define HDMI_ONMS_VACT_SPACE2_MIN_INFO_reg                                 0xb8021354
#define HDMI_ONMS_VACT_SPACE2_MIN_INFO_inst_addr                           "0x00D5"
#define HDMI_ONMS_VACT_SPACE2_MIN_INFO_inst                                0x00D5
#define HDMI_ONMS_VACT_SPACE2_MIN_INFO_as2_min_end_shift                   (20)
#define HDMI_ONMS_VACT_SPACE2_MIN_INFO_as2_min_start_shift                 (10)
#define HDMI_ONMS_VACT_SPACE2_MIN_INFO_as2_min_diff_shift                  (0)
#define HDMI_ONMS_VACT_SPACE2_MIN_INFO_as2_min_end_mask                    (0x3FF00000)
#define HDMI_ONMS_VACT_SPACE2_MIN_INFO_as2_min_start_mask                  (0x000FFC00)
#define HDMI_ONMS_VACT_SPACE2_MIN_INFO_as2_min_diff_mask                   (0x000003FF)
#define HDMI_ONMS_VACT_SPACE2_MIN_INFO_as2_min_end(data)                   (0x3FF00000&((data)<<20))
#define HDMI_ONMS_VACT_SPACE2_MIN_INFO_as2_min_start(data)                 (0x000FFC00&((data)<<10))
#define HDMI_ONMS_VACT_SPACE2_MIN_INFO_as2_min_diff(data)                  (0x000003FF&(data))
#define HDMI_ONMS_VACT_SPACE2_MIN_INFO_get_as2_min_end(data)               ((0x3FF00000&(data))>>20)
#define HDMI_ONMS_VACT_SPACE2_MIN_INFO_get_as2_min_start(data)             ((0x000FFC00&(data))>>10)
#define HDMI_ONMS_VACT_SPACE2_MIN_INFO_get_as2_min_diff(data)              (0x000003FF&(data))

//This REG is not used by HDMI
#define HDMI_ONMS_VACT_SPACE3_MIN_INFO                                     0x18021358
#define HDMI_ONMS_VACT_SPACE3_MIN_INFO_reg_addr                            "0xb8021358"
#define HDMI_ONMS_VACT_SPACE3_MIN_INFO_reg                                 0xb8021358
#define HDMI_ONMS_VACT_SPACE3_MIN_INFO_inst_addr                           "0x00D6"
#define HDMI_ONMS_VACT_SPACE3_MIN_INFO_inst                                0x00D6
#define HDMI_ONMS_VACT_SPACE3_MIN_INFO_as3_min_end_shift                   (20)
#define HDMI_ONMS_VACT_SPACE3_MIN_INFO_as3_min_start_shift                 (10)
#define HDMI_ONMS_VACT_SPACE3_MIN_INFO_as3_min_diff_shift                  (0)
#define HDMI_ONMS_VACT_SPACE3_MIN_INFO_as3_min_end_mask                    (0x3FF00000)
#define HDMI_ONMS_VACT_SPACE3_MIN_INFO_as3_min_start_mask                  (0x000FFC00)
#define HDMI_ONMS_VACT_SPACE3_MIN_INFO_as3_min_diff_mask                   (0x000003FF)
#define HDMI_ONMS_VACT_SPACE3_MIN_INFO_as3_min_end(data)                   (0x3FF00000&((data)<<20))
#define HDMI_ONMS_VACT_SPACE3_MIN_INFO_as3_min_start(data)                 (0x000FFC00&((data)<<10))
#define HDMI_ONMS_VACT_SPACE3_MIN_INFO_as3_min_diff(data)                  (0x000003FF&(data))
#define HDMI_ONMS_VACT_SPACE3_MIN_INFO_get_as3_min_end(data)               ((0x3FF00000&(data))>>20)
#define HDMI_ONMS_VACT_SPACE3_MIN_INFO_get_as3_min_start(data)             ((0x000FFC00&(data))>>10)
#define HDMI_ONMS_VACT_SPACE3_MIN_INFO_get_as3_min_diff(data)              (0x000003FF&(data))


#define HDMI_ONMS_STATUS                                                   0x1802135c
#define HDMI_ONMS_STATUS_reg_addr                                          "0xb802135c"
#define HDMI_ONMS_STATUS_reg                                               0xb802135c
#define HDMI_ONMS_STATUS_inst_addr                                         "0x00D7"
#define HDMI_ONMS_STATUS_inst                                              0x00D7
#define HDMI_ONMS_STATUS_blk_2frame_en_shift                               (18)
#define HDMI_ONMS_STATUS_vs_pol_out_shift                                  (17)
#define HDMI_ONMS_STATUS_hs_pol_out_shift                                  (16)
#define HDMI_ONMS_STATUS_vs_per_over_range_shift                           (15)
#define HDMI_ONMS_STATUS_hs_per_over_range_shift                           (14)
#define HDMI_ONMS_STATUS_vs_per_timeout_shift                              (13)
#define HDMI_ONMS_STATUS_vs_high_timeout_shift                             (12)
#define HDMI_ONMS_STATUS_vs_per_overflow_shift                             (11)
#define HDMI_ONMS_STATUS_hs_per_overflow_shift                             (10)
#define HDMI_ONMS_STATUS_vs_pol_chg_shift                                  (9)
#define HDMI_ONMS_STATUS_hs_pol_chg_shift                                  (8)
#define HDMI_ONMS_STATUS_vtotalde_chg_shift                                (7)
#define HDMI_ONMS_STATUS_vtotal_chg_shift                                  (6)
#define HDMI_ONMS_STATUS_hact_chg_shift                                    (5)
#define HDMI_ONMS_STATUS_htotal_chg_shift                                  (4)
#define HDMI_ONMS_STATUS_hs_active_pixel_var_shift                         (3)
#define HDMI_ONMS_STATUS_vact_space3_under_min_shift                       (2)
#define HDMI_ONMS_STATUS_vact_space2_under_min_shift                       (1)
#define HDMI_ONMS_STATUS_vact_space1_under_min_shift                       (0)
#define HDMI_ONMS_STATUS_blk_2frame_en_mask                                (0x00040000)
#define HDMI_ONMS_STATUS_vs_pol_out_mask                                   (0x00020000)
#define HDMI_ONMS_STATUS_hs_pol_out_mask                                   (0x00010000)
#define HDMI_ONMS_STATUS_vs_per_over_range_mask                            (0x00008000)
#define HDMI_ONMS_STATUS_hs_per_over_range_mask                            (0x00004000)
#define HDMI_ONMS_STATUS_vs_per_timeout_mask                               (0x00002000)
#define HDMI_ONMS_STATUS_vs_high_timeout_mask                              (0x00001000)
#define HDMI_ONMS_STATUS_vs_per_overflow_mask                              (0x00000800)
#define HDMI_ONMS_STATUS_hs_per_overflow_mask                              (0x00000400)
#define HDMI_ONMS_STATUS_vs_pol_chg_mask                                   (0x00000200)
#define HDMI_ONMS_STATUS_hs_pol_chg_mask                                   (0x00000100)
#define HDMI_ONMS_STATUS_vtotalde_chg_mask                                 (0x00000080)
#define HDMI_ONMS_STATUS_vtotal_chg_mask                                   (0x00000040)
#define HDMI_ONMS_STATUS_hact_chg_mask                                     (0x00000020)
#define HDMI_ONMS_STATUS_htotal_chg_mask                                   (0x00000010)
#define HDMI_ONMS_STATUS_hs_active_pixel_var_mask                          (0x00000008)
#define HDMI_ONMS_STATUS_vact_space3_under_min_mask                        (0x00000004)
#define HDMI_ONMS_STATUS_vact_space2_under_min_mask                        (0x00000002)
#define HDMI_ONMS_STATUS_vact_space1_under_min_mask                        (0x00000001)
#define HDMI_ONMS_STATUS_blk_2frame_en(data)                               (0x00040000&((data)<<18))
#define HDMI_ONMS_STATUS_vs_pol_out(data)                                  (0x00020000&((data)<<17))
#define HDMI_ONMS_STATUS_hs_pol_out(data)                                  (0x00010000&((data)<<16))
#define HDMI_ONMS_STATUS_vs_per_over_range(data)                           (0x00008000&((data)<<15))
#define HDMI_ONMS_STATUS_hs_per_over_range(data)                           (0x00004000&((data)<<14))
#define HDMI_ONMS_STATUS_vs_per_timeout(data)                              (0x00002000&((data)<<13))
#define HDMI_ONMS_STATUS_vs_high_timeout(data)                             (0x00001000&((data)<<12))
#define HDMI_ONMS_STATUS_vs_per_overflow(data)                             (0x00000800&((data)<<11))
#define HDMI_ONMS_STATUS_hs_per_overflow(data)                             (0x00000400&((data)<<10))
#define HDMI_ONMS_STATUS_vs_pol_chg(data)                                  (0x00000200&((data)<<9))
#define HDMI_ONMS_STATUS_hs_pol_chg(data)                                  (0x00000100&((data)<<8))
#define HDMI_ONMS_STATUS_vtotalde_chg(data)                                (0x00000080&((data)<<7))
#define HDMI_ONMS_STATUS_vtotal_chg(data)                                  (0x00000040&((data)<<6))
#define HDMI_ONMS_STATUS_hact_chg(data)                                    (0x00000020&((data)<<5))
#define HDMI_ONMS_STATUS_htotal_chg(data)                                  (0x00000010&((data)<<4))
#define HDMI_ONMS_STATUS_hs_active_pixel_var(data)                         (0x00000008&((data)<<3))
#define HDMI_ONMS_STATUS_vact_space3_under_min(data)                       (0x00000004&((data)<<2))
#define HDMI_ONMS_STATUS_vact_space2_under_min(data)                       (0x00000002&((data)<<1))
#define HDMI_ONMS_STATUS_vact_space1_under_min(data)                       (0x00000001&(data))
#define HDMI_ONMS_STATUS_get_blk_2frame_en(data)                           ((0x00040000&(data))>>18)
#define HDMI_ONMS_STATUS_get_vs_pol_out(data)                              ((0x00020000&(data))>>17)
#define HDMI_ONMS_STATUS_get_hs_pol_out(data)                              ((0x00010000&(data))>>16)
#define HDMI_ONMS_STATUS_get_vs_per_over_range(data)                       ((0x00008000&(data))>>15)
#define HDMI_ONMS_STATUS_get_hs_per_over_range(data)                       ((0x00004000&(data))>>14)
#define HDMI_ONMS_STATUS_get_vs_per_timeout(data)                          ((0x00002000&(data))>>13)
#define HDMI_ONMS_STATUS_get_vs_high_timeout(data)                         ((0x00001000&(data))>>12)
#define HDMI_ONMS_STATUS_get_vs_per_overflow(data)                         ((0x00000800&(data))>>11)
#define HDMI_ONMS_STATUS_get_hs_per_overflow(data)                         ((0x00000400&(data))>>10)
#define HDMI_ONMS_STATUS_get_vs_pol_chg(data)                              ((0x00000200&(data))>>9)
#define HDMI_ONMS_STATUS_get_hs_pol_chg(data)                              ((0x00000100&(data))>>8)
#define HDMI_ONMS_STATUS_get_vtotalde_chg(data)                            ((0x00000080&(data))>>7)
#define HDMI_ONMS_STATUS_get_vtotal_chg(data)                              ((0x00000040&(data))>>6)
#define HDMI_ONMS_STATUS_get_hact_chg(data)                                ((0x00000020&(data))>>5)
#define HDMI_ONMS_STATUS_get_htotal_chg(data)                              ((0x00000010&(data))>>4)
#define HDMI_ONMS_STATUS_get_hs_active_pixel_var(data)                     ((0x00000008&(data))>>3)
#define HDMI_ONMS_STATUS_get_vact_space3_under_min(data)                   ((0x00000004&(data))>>2)
#define HDMI_ONMS_STATUS_get_vact_space2_under_min(data)                   ((0x00000002&(data))>>1)
#define HDMI_ONMS_STATUS_get_vact_space1_under_min(data)                   (0x00000001&(data))


#define HDMI_ONMS_WATCHDOG_EN                                              0x18021360
#define HDMI_ONMS_WATCHDOG_EN_reg_addr                                     "0xb8021360"
#define HDMI_ONMS_WATCHDOG_EN_reg                                          0xb8021360
#define HDMI_ONMS_WATCHDOG_EN_inst_addr                                    "0x00D8"
#define HDMI_ONMS_WATCHDOG_EN_inst                                         0x00D8
#define HDMI_ONMS_WATCHDOG_EN_wd_vs_per_over_range_shift                   (15)
#define HDMI_ONMS_WATCHDOG_EN_wd_hs_per_over_range_shift                   (14)
#define HDMI_ONMS_WATCHDOG_EN_wd_vs_per_timeout_shift                      (13)
#define HDMI_ONMS_WATCHDOG_EN_wd_vs_high_timeout_shift                     (12)
#define HDMI_ONMS_WATCHDOG_EN_wd_vs_per_overflow_shift                     (11)
#define HDMI_ONMS_WATCHDOG_EN_wd_hs_per_overflow_shift                     (10)
#define HDMI_ONMS_WATCHDOG_EN_wd_vs_pol_chg_shift                          (9)
#define HDMI_ONMS_WATCHDOG_EN_wd_hs_pol_chg_shift                          (8)
#define HDMI_ONMS_WATCHDOG_EN_wd_vtotalde_chg_shift                        (7)
#define HDMI_ONMS_WATCHDOG_EN_wd_vtotal_chg_shift                          (6)
#define HDMI_ONMS_WATCHDOG_EN_wd_hact_chg_shift                            (5)
#define HDMI_ONMS_WATCHDOG_EN_wd_htotal_chg_shift                          (4)
#define HDMI_ONMS_WATCHDOG_EN_wd_hs_active_pixel_var_shift                 (3)
#define HDMI_ONMS_WATCHDOG_EN_wd_vact_space3_under_min_shift               (2)
#define HDMI_ONMS_WATCHDOG_EN_wd_vact_space2_under_min_shift               (1)
#define HDMI_ONMS_WATCHDOG_EN_wd_vact_space1_under_min_shift               (0)
#define HDMI_ONMS_WATCHDOG_EN_wd_vs_per_over_range_mask                    (0x00008000)
#define HDMI_ONMS_WATCHDOG_EN_wd_hs_per_over_range_mask                    (0x00004000)
#define HDMI_ONMS_WATCHDOG_EN_wd_vs_per_timeout_mask                       (0x00002000)
#define HDMI_ONMS_WATCHDOG_EN_wd_vs_high_timeout_mask                      (0x00001000)
#define HDMI_ONMS_WATCHDOG_EN_wd_vs_per_overflow_mask                      (0x00000800)
#define HDMI_ONMS_WATCHDOG_EN_wd_hs_per_overflow_mask                      (0x00000400)
#define HDMI_ONMS_WATCHDOG_EN_wd_vs_pol_chg_mask                           (0x00000200)
#define HDMI_ONMS_WATCHDOG_EN_wd_hs_pol_chg_mask                           (0x00000100)
#define HDMI_ONMS_WATCHDOG_EN_wd_vtotalde_chg_mask                         (0x00000080)
#define HDMI_ONMS_WATCHDOG_EN_wd_vtotal_chg_mask                           (0x00000040)
#define HDMI_ONMS_WATCHDOG_EN_wd_hact_chg_mask                             (0x00000020)
#define HDMI_ONMS_WATCHDOG_EN_wd_htotal_chg_mask                           (0x00000010)
#define HDMI_ONMS_WATCHDOG_EN_wd_hs_active_pixel_var_mask                  (0x00000008)
#define HDMI_ONMS_WATCHDOG_EN_wd_vact_space3_under_min_mask                (0x00000004)
#define HDMI_ONMS_WATCHDOG_EN_wd_vact_space2_under_min_mask                (0x00000002)
#define HDMI_ONMS_WATCHDOG_EN_wd_vact_space1_under_min_mask                (0x00000001)
#define HDMI_ONMS_WATCHDOG_EN_wd_vs_per_over_range(data)                   (0x00008000&((data)<<15))
#define HDMI_ONMS_WATCHDOG_EN_wd_hs_per_over_range(data)                   (0x00004000&((data)<<14))
#define HDMI_ONMS_WATCHDOG_EN_wd_vs_per_timeout(data)                      (0x00002000&((data)<<13))
#define HDMI_ONMS_WATCHDOG_EN_wd_vs_high_timeout(data)                     (0x00001000&((data)<<12))
#define HDMI_ONMS_WATCHDOG_EN_wd_vs_per_overflow(data)                     (0x00000800&((data)<<11))
#define HDMI_ONMS_WATCHDOG_EN_wd_hs_per_overflow(data)                     (0x00000400&((data)<<10))
#define HDMI_ONMS_WATCHDOG_EN_wd_vs_pol_chg(data)                          (0x00000200&((data)<<9))
#define HDMI_ONMS_WATCHDOG_EN_wd_hs_pol_chg(data)                          (0x00000100&((data)<<8))
#define HDMI_ONMS_WATCHDOG_EN_wd_vtotalde_chg(data)                        (0x00000080&((data)<<7))
#define HDMI_ONMS_WATCHDOG_EN_wd_vtotal_chg(data)                          (0x00000040&((data)<<6))
#define HDMI_ONMS_WATCHDOG_EN_wd_hact_chg(data)                            (0x00000020&((data)<<5))
#define HDMI_ONMS_WATCHDOG_EN_wd_htotal_chg(data)                          (0x00000010&((data)<<4))
#define HDMI_ONMS_WATCHDOG_EN_wd_hs_active_pixel_var(data)                 (0x00000008&((data)<<3))
#define HDMI_ONMS_WATCHDOG_EN_wd_vact_space3_under_min(data)               (0x00000004&((data)<<2))
#define HDMI_ONMS_WATCHDOG_EN_wd_vact_space2_under_min(data)               (0x00000002&((data)<<1))
#define HDMI_ONMS_WATCHDOG_EN_wd_vact_space1_under_min(data)               (0x00000001&(data))
#define HDMI_ONMS_WATCHDOG_EN_get_wd_vs_per_over_range(data)               ((0x00008000&(data))>>15)
#define HDMI_ONMS_WATCHDOG_EN_get_wd_hs_per_over_range(data)               ((0x00004000&(data))>>14)
#define HDMI_ONMS_WATCHDOG_EN_get_wd_vs_per_timeout(data)                  ((0x00002000&(data))>>13)
#define HDMI_ONMS_WATCHDOG_EN_get_wd_vs_high_timeout(data)                 ((0x00001000&(data))>>12)
#define HDMI_ONMS_WATCHDOG_EN_get_wd_vs_per_overflow(data)                 ((0x00000800&(data))>>11)
#define HDMI_ONMS_WATCHDOG_EN_get_wd_hs_per_overflow(data)                 ((0x00000400&(data))>>10)
#define HDMI_ONMS_WATCHDOG_EN_get_wd_vs_pol_chg(data)                      ((0x00000200&(data))>>9)
#define HDMI_ONMS_WATCHDOG_EN_get_wd_hs_pol_chg(data)                      ((0x00000100&(data))>>8)
#define HDMI_ONMS_WATCHDOG_EN_get_wd_vtotalde_chg(data)                    ((0x00000080&(data))>>7)
#define HDMI_ONMS_WATCHDOG_EN_get_wd_vtotal_chg(data)                      ((0x00000040&(data))>>6)
#define HDMI_ONMS_WATCHDOG_EN_get_wd_hact_chg(data)                        ((0x00000020&(data))>>5)
#define HDMI_ONMS_WATCHDOG_EN_get_wd_htotal_chg(data)                      ((0x00000010&(data))>>4)
#define HDMI_ONMS_WATCHDOG_EN_get_wd_hs_active_pixel_var(data)             ((0x00000008&(data))>>3)
#define HDMI_ONMS_WATCHDOG_EN_get_wd_vact_space3_under_min(data)           ((0x00000004&(data))>>2)
#define HDMI_ONMS_WATCHDOG_EN_get_wd_vact_space2_under_min(data)           ((0x00000002&(data))>>1)
#define HDMI_ONMS_WATCHDOG_EN_get_wd_vact_space1_under_min(data)           (0x00000001&(data))

//This REG is not used by HDMI
#define HDMI_ONMS_INTERRUPT_EN                                             0x18021364
#define HDMI_ONMS_INTERRUPT_EN_reg_addr                                    "0xb8021364"
#define HDMI_ONMS_INTERRUPT_EN_reg                                         0xb8021364
#define HDMI_ONMS_INTERRUPT_EN_inst_addr                                   "0x00D9"
#define HDMI_ONMS_INTERRUPT_EN_inst                                        0x00D9
#define HDMI_ONMS_INTERRUPT_EN_ie_vs_per_over_range_shift                  (15)
#define HDMI_ONMS_INTERRUPT_EN_ie_hs_per_over_range_shift                  (14)
#define HDMI_ONMS_INTERRUPT_EN_ie_vs_per_timeout_shift                     (13)
#define HDMI_ONMS_INTERRUPT_EN_ie_vs_high_timeout_shift                    (12)
#define HDMI_ONMS_INTERRUPT_EN_ie_vs_per_overflow_shift                    (11)
#define HDMI_ONMS_INTERRUPT_EN_ie_hs_per_overflow_shift                    (10)
#define HDMI_ONMS_INTERRUPT_EN_ie_vs_pol_chg_shift                         (9)
#define HDMI_ONMS_INTERRUPT_EN_ie_hs_pol_chg_shift                         (8)
#define HDMI_ONMS_INTERRUPT_EN_ie_vtotalde_chg_shift                       (7)
#define HDMI_ONMS_INTERRUPT_EN_ie_vtotal_chg_shift                         (6)
#define HDMI_ONMS_INTERRUPT_EN_ie_hact_chg_shift                           (5)
#define HDMI_ONMS_INTERRUPT_EN_ie_htotal_chg_shift                         (4)
#define HDMI_ONMS_INTERRUPT_EN_ie_hs_active_pixel_var_shift                (3)
#define HDMI_ONMS_INTERRUPT_EN_ie_vact_space3_under_min_shift              (2)
#define HDMI_ONMS_INTERRUPT_EN_ie_vact_space2_under_min_shift              (1)
#define HDMI_ONMS_INTERRUPT_EN_ie_vact_space1_under_min_shift              (0)
#define HDMI_ONMS_INTERRUPT_EN_ie_vs_per_over_range_mask                   (0x00008000)
#define HDMI_ONMS_INTERRUPT_EN_ie_hs_per_over_range_mask                   (0x00004000)
#define HDMI_ONMS_INTERRUPT_EN_ie_vs_per_timeout_mask                      (0x00002000)
#define HDMI_ONMS_INTERRUPT_EN_ie_vs_high_timeout_mask                     (0x00001000)
#define HDMI_ONMS_INTERRUPT_EN_ie_vs_per_overflow_mask                     (0x00000800)
#define HDMI_ONMS_INTERRUPT_EN_ie_hs_per_overflow_mask                     (0x00000400)
#define HDMI_ONMS_INTERRUPT_EN_ie_vs_pol_chg_mask                          (0x00000200)
#define HDMI_ONMS_INTERRUPT_EN_ie_hs_pol_chg_mask                          (0x00000100)
#define HDMI_ONMS_INTERRUPT_EN_ie_vtotalde_chg_mask                        (0x00000080)
#define HDMI_ONMS_INTERRUPT_EN_ie_vtotal_chg_mask                          (0x00000040)
#define HDMI_ONMS_INTERRUPT_EN_ie_hact_chg_mask                            (0x00000020)
#define HDMI_ONMS_INTERRUPT_EN_ie_htotal_chg_mask                          (0x00000010)
#define HDMI_ONMS_INTERRUPT_EN_ie_hs_active_pixel_var_mask                 (0x00000008)
#define HDMI_ONMS_INTERRUPT_EN_ie_vact_space3_under_min_mask               (0x00000004)
#define HDMI_ONMS_INTERRUPT_EN_ie_vact_space2_under_min_mask               (0x00000002)
#define HDMI_ONMS_INTERRUPT_EN_ie_vact_space1_under_min_mask               (0x00000001)
#define HDMI_ONMS_INTERRUPT_EN_ie_vs_per_over_range(data)                  (0x00008000&((data)<<15))
#define HDMI_ONMS_INTERRUPT_EN_ie_hs_per_over_range(data)                  (0x00004000&((data)<<14))
#define HDMI_ONMS_INTERRUPT_EN_ie_vs_per_timeout(data)                     (0x00002000&((data)<<13))
#define HDMI_ONMS_INTERRUPT_EN_ie_vs_high_timeout(data)                    (0x00001000&((data)<<12))
#define HDMI_ONMS_INTERRUPT_EN_ie_vs_per_overflow(data)                    (0x00000800&((data)<<11))
#define HDMI_ONMS_INTERRUPT_EN_ie_hs_per_overflow(data)                    (0x00000400&((data)<<10))
#define HDMI_ONMS_INTERRUPT_EN_ie_vs_pol_chg(data)                         (0x00000200&((data)<<9))
#define HDMI_ONMS_INTERRUPT_EN_ie_hs_pol_chg(data)                         (0x00000100&((data)<<8))
#define HDMI_ONMS_INTERRUPT_EN_ie_vtotalde_chg(data)                       (0x00000080&((data)<<7))
#define HDMI_ONMS_INTERRUPT_EN_ie_vtotal_chg(data)                         (0x00000040&((data)<<6))
#define HDMI_ONMS_INTERRUPT_EN_ie_hact_chg(data)                           (0x00000020&((data)<<5))
#define HDMI_ONMS_INTERRUPT_EN_ie_htotal_chg(data)                         (0x00000010&((data)<<4))
#define HDMI_ONMS_INTERRUPT_EN_ie_hs_active_pixel_var(data)                (0x00000008&((data)<<3))
#define HDMI_ONMS_INTERRUPT_EN_ie_vact_space3_under_min(data)              (0x00000004&((data)<<2))
#define HDMI_ONMS_INTERRUPT_EN_ie_vact_space2_under_min(data)              (0x00000002&((data)<<1))
#define HDMI_ONMS_INTERRUPT_EN_ie_vact_space1_under_min(data)              (0x00000001&(data))
#define HDMI_ONMS_INTERRUPT_EN_get_ie_vs_per_over_range(data)              ((0x00008000&(data))>>15)
#define HDMI_ONMS_INTERRUPT_EN_get_ie_hs_per_over_range(data)              ((0x00004000&(data))>>14)
#define HDMI_ONMS_INTERRUPT_EN_get_ie_vs_per_timeout(data)                 ((0x00002000&(data))>>13)
#define HDMI_ONMS_INTERRUPT_EN_get_ie_vs_high_timeout(data)                ((0x00001000&(data))>>12)
#define HDMI_ONMS_INTERRUPT_EN_get_ie_vs_per_overflow(data)                ((0x00000800&(data))>>11)
#define HDMI_ONMS_INTERRUPT_EN_get_ie_hs_per_overflow(data)                ((0x00000400&(data))>>10)
#define HDMI_ONMS_INTERRUPT_EN_get_ie_vs_pol_chg(data)                     ((0x00000200&(data))>>9)
#define HDMI_ONMS_INTERRUPT_EN_get_ie_hs_pol_chg(data)                     ((0x00000100&(data))>>8)
#define HDMI_ONMS_INTERRUPT_EN_get_ie_vtotalde_chg(data)                   ((0x00000080&(data))>>7)
#define HDMI_ONMS_INTERRUPT_EN_get_ie_vtotal_chg(data)                     ((0x00000040&(data))>>6)
#define HDMI_ONMS_INTERRUPT_EN_get_ie_hact_chg(data)                       ((0x00000020&(data))>>5)
#define HDMI_ONMS_INTERRUPT_EN_get_ie_htotal_chg(data)                     ((0x00000010&(data))>>4)
#define HDMI_ONMS_INTERRUPT_EN_get_ie_hs_active_pixel_var(data)            ((0x00000008&(data))>>3)
#define HDMI_ONMS_INTERRUPT_EN_get_ie_vact_space3_under_min(data)          ((0x00000004&(data))>>2)
#define HDMI_ONMS_INTERRUPT_EN_get_ie_vact_space2_under_min(data)          ((0x00000002&(data))>>1)
#define HDMI_ONMS_INTERRUPT_EN_get_ie_vact_space1_under_min(data)          (0x00000001&(data))


#define HDMI_ONMS_HACT_STA                                                 0x18021368
#define HDMI_ONMS_HACT_STA_reg_addr                                        "0xb8021368"
#define HDMI_ONMS_HACT_STA_reg                                             0xb8021368
#define HDMI_ONMS_HACT_STA_inst_addr                                       "0x00DA"
#define HDMI_ONMS_HACT_STA_inst                                            0x00DA
#define HDMI_ONMS_HACT_STA_hact_start_shift                                (0)
#define HDMI_ONMS_HACT_STA_hact_start_mask                                 (0x00003FFF)
#define HDMI_ONMS_HACT_STA_hact_start(data)                                (0x00003FFF&(data))
#define HDMI_ONMS_HACT_STA_get_hact_start(data)                            (0x00003FFF&(data))


//END OF On line measure

// HDMI DITHER : after rgb
// FOR   Magellan-DesignSpec-IDMA_HDMI_rgb2yuv_dither_4xxto4xx.doc
#define HDMI_DITHER_CTRL1                                             0x18025a00
#define HDMI_DITHER_CTRL1_reg_addr                                    "0xb8025a00"
#define HDMI_DITHER_CTRL1_reg                                         0xb8025a00
#define HDMI_DITHER_CTRL1_inst_addr                                   "0x0280"
#define HDMI_DITHER_CTRL1_inst                                        0x0280
#define HDMI_DITHER_CTRL1_dither_bit_sel_shift                        (10)
#define HDMI_DITHER_CTRL1_ch2_field_odd_temporal_offset_select_shift  (9)
#define HDMI_DITHER_CTRL1_ch2_field_even_temporal_offset_select_shift (8)
#define HDMI_DITHER_CTRL1_ch2_temporal_offset_separate_mode_shift     (7)
#define HDMI_DITHER_CTRL1_ch2_dithering_table_select_shift            (5)
#define HDMI_DITHER_CTRL1_ch2_temporal_enable_shift                   (4)
#define HDMI_DITHER_CTRL1_ch2_value_sign_shift                        (3)
#define HDMI_DITHER_CTRL1_ch2_dithering_mode_shift                    (2)
#define HDMI_DITHER_CTRL1_ch2_v_modulation_shift                      (1)
#define HDMI_DITHER_CTRL1_ch2_h_modulation_shift                      (0)
#define HDMI_DITHER_CTRL1_dither_bit_sel_mask                         (0x00000400)
#define HDMI_DITHER_CTRL1_ch2_field_odd_temporal_offset_select_mask   (0x00000200)
#define HDMI_DITHER_CTRL1_ch2_field_even_temporal_offset_select_mask  (0x00000100)
#define HDMI_DITHER_CTRL1_ch2_temporal_offset_separate_mode_mask      (0x00000080)
#define HDMI_DITHER_CTRL1_ch2_dithering_table_select_mask             (0x00000060)
#define HDMI_DITHER_CTRL1_ch2_temporal_enable_mask                    (0x00000010)
#define HDMI_DITHER_CTRL1_ch2_value_sign_mask                         (0x00000008)
#define HDMI_DITHER_CTRL1_ch2_dithering_mode_mask                     (0x00000004)
#define HDMI_DITHER_CTRL1_ch2_v_modulation_mask                       (0x00000002)
#define HDMI_DITHER_CTRL1_ch2_h_modulation_mask                       (0x00000001)
#define HDMI_DITHER_CTRL1_dither_bit_sel(data)                        (0x00000400&((data)<<10))
#define HDMI_DITHER_CTRL1_ch2_field_odd_temporal_offset_select(data)  (0x00000200&((data)<<9))
#define HDMI_DITHER_CTRL1_ch2_field_even_temporal_offset_select(data) (0x00000100&((data)<<8))
#define HDMI_DITHER_CTRL1_ch2_temporal_offset_separate_mode(data)     (0x00000080&((data)<<7))
#define HDMI_DITHER_CTRL1_ch2_dithering_table_select(data)            (0x00000060&((data)<<5))
#define HDMI_DITHER_CTRL1_ch2_temporal_enable(data)                   (0x00000010&((data)<<4))
#define HDMI_DITHER_CTRL1_ch2_value_sign(data)                        (0x00000008&((data)<<3))
#define HDMI_DITHER_CTRL1_ch2_dithering_mode(data)                    (0x00000004&((data)<<2))
#define HDMI_DITHER_CTRL1_ch2_v_modulation(data)                      (0x00000002&((data)<<1))
#define HDMI_DITHER_CTRL1_ch2_h_modulation(data)                      (0x00000001&(data))
#define HDMI_DITHER_CTRL1_get_dither_bit_sel(data)                    ((0x00000400&(data))>>10)
#define HDMI_DITHER_CTRL1_get_ch2_field_odd_temporal_offset_select(data)  ((0x00000200&(data))>>9)
#define HDMI_DITHER_CTRL1_get_ch2_field_even_temporal_offset_select(data)  ((0x00000100&(data))>>8)
#define HDMI_DITHER_CTRL1_get_ch2_temporal_offset_separate_mode(data) ((0x00000080&(data))>>7)
#define HDMI_DITHER_CTRL1_get_ch2_dithering_table_select(data)        ((0x00000060&(data))>>5)
#define HDMI_DITHER_CTRL1_get_ch2_temporal_enable(data)               ((0x00000010&(data))>>4)
#define HDMI_DITHER_CTRL1_get_ch2_value_sign(data)                    ((0x00000008&(data))>>3)
#define HDMI_DITHER_CTRL1_get_ch2_dithering_mode(data)                ((0x00000004&(data))>>2)
#define HDMI_DITHER_CTRL1_get_ch2_v_modulation(data)                  ((0x00000002&(data))>>1)
#define HDMI_DITHER_CTRL1_get_ch2_h_modulation(data)                  (0x00000001&(data))


#define HDMI_DITHER_SEQ_R_00_15                                       0x18025a04
#define HDMI_DITHER_SEQ_R_00_15_reg_addr                              "0xb8025a04"
#define HDMI_DITHER_SEQ_R_00_15_reg                                   0xb8025a04
#define HDMI_DITHER_SEQ_R_00_15_inst_addr                             "0x0281"
#define HDMI_DITHER_SEQ_R_00_15_inst                                  0x0281
#define HDMI_DITHER_SEQ_R_00_15_seq_r_15_shift                        (30)
#define HDMI_DITHER_SEQ_R_00_15_seq_r_14_shift                        (28)
#define HDMI_DITHER_SEQ_R_00_15_seq_r_13_shift                        (26)
#define HDMI_DITHER_SEQ_R_00_15_seq_r_12_shift                        (24)
#define HDMI_DITHER_SEQ_R_00_15_seq_r_11_shift                        (22)
#define HDMI_DITHER_SEQ_R_00_15_seq_r_10_shift                        (20)
#define HDMI_DITHER_SEQ_R_00_15_seq_r_9_shift                         (18)
#define HDMI_DITHER_SEQ_R_00_15_seq_r_8_shift                         (16)
#define HDMI_DITHER_SEQ_R_00_15_seq_r_7_shift                         (14)
#define HDMI_DITHER_SEQ_R_00_15_seq_r_6_shift                         (12)
#define HDMI_DITHER_SEQ_R_00_15_seq_r_5_shift                         (10)
#define HDMI_DITHER_SEQ_R_00_15_seq_r_4_shift                         (8)
#define HDMI_DITHER_SEQ_R_00_15_seq_r_3_shift                         (6)
#define HDMI_DITHER_SEQ_R_00_15_seq_r_2_shift                         (4)
#define HDMI_DITHER_SEQ_R_00_15_seq_r_1_shift                         (2)
#define HDMI_DITHER_SEQ_R_00_15_seq_r_0_shift                         (0)
#define HDMI_DITHER_SEQ_R_00_15_seq_r_15_mask                         (0xC0000000)
#define HDMI_DITHER_SEQ_R_00_15_seq_r_14_mask                         (0x30000000)
#define HDMI_DITHER_SEQ_R_00_15_seq_r_13_mask                         (0x0C000000)
#define HDMI_DITHER_SEQ_R_00_15_seq_r_12_mask                         (0x03000000)
#define HDMI_DITHER_SEQ_R_00_15_seq_r_11_mask                         (0x00C00000)
#define HDMI_DITHER_SEQ_R_00_15_seq_r_10_mask                         (0x00300000)
#define HDMI_DITHER_SEQ_R_00_15_seq_r_9_mask                          (0x000C0000)
#define HDMI_DITHER_SEQ_R_00_15_seq_r_8_mask                          (0x00030000)
#define HDMI_DITHER_SEQ_R_00_15_seq_r_7_mask                          (0x0000C000)
#define HDMI_DITHER_SEQ_R_00_15_seq_r_6_mask                          (0x00003000)
#define HDMI_DITHER_SEQ_R_00_15_seq_r_5_mask                          (0x00000C00)
#define HDMI_DITHER_SEQ_R_00_15_seq_r_4_mask                          (0x00000300)
#define HDMI_DITHER_SEQ_R_00_15_seq_r_3_mask                          (0x000000C0)
#define HDMI_DITHER_SEQ_R_00_15_seq_r_2_mask                          (0x00000030)
#define HDMI_DITHER_SEQ_R_00_15_seq_r_1_mask                          (0x0000000C)
#define HDMI_DITHER_SEQ_R_00_15_seq_r_0_mask                          (0x00000003)
#define HDMI_DITHER_SEQ_R_00_15_seq_r_15(data)                        (0xC0000000&((data)<<30))
#define HDMI_DITHER_SEQ_R_00_15_seq_r_14(data)                        (0x30000000&((data)<<28))
#define HDMI_DITHER_SEQ_R_00_15_seq_r_13(data)                        (0x0C000000&((data)<<26))
#define HDMI_DITHER_SEQ_R_00_15_seq_r_12(data)                        (0x03000000&((data)<<24))
#define HDMI_DITHER_SEQ_R_00_15_seq_r_11(data)                        (0x00C00000&((data)<<22))
#define HDMI_DITHER_SEQ_R_00_15_seq_r_10(data)                        (0x00300000&((data)<<20))
#define HDMI_DITHER_SEQ_R_00_15_seq_r_9(data)                         (0x000C0000&((data)<<18))
#define HDMI_DITHER_SEQ_R_00_15_seq_r_8(data)                         (0x00030000&((data)<<16))
#define HDMI_DITHER_SEQ_R_00_15_seq_r_7(data)                         (0x0000C000&((data)<<14))
#define HDMI_DITHER_SEQ_R_00_15_seq_r_6(data)                         (0x00003000&((data)<<12))
#define HDMI_DITHER_SEQ_R_00_15_seq_r_5(data)                         (0x00000C00&((data)<<10))
#define HDMI_DITHER_SEQ_R_00_15_seq_r_4(data)                         (0x00000300&((data)<<8))
#define HDMI_DITHER_SEQ_R_00_15_seq_r_3(data)                         (0x000000C0&((data)<<6))
#define HDMI_DITHER_SEQ_R_00_15_seq_r_2(data)                         (0x00000030&((data)<<4))
#define HDMI_DITHER_SEQ_R_00_15_seq_r_1(data)                         (0x0000000C&((data)<<2))
#define HDMI_DITHER_SEQ_R_00_15_seq_r_0(data)                         (0x00000003&(data))
#define HDMI_DITHER_SEQ_R_00_15_get_seq_r_15(data)                    ((0xC0000000&(data))>>30)
#define HDMI_DITHER_SEQ_R_00_15_get_seq_r_14(data)                    ((0x30000000&(data))>>28)
#define HDMI_DITHER_SEQ_R_00_15_get_seq_r_13(data)                    ((0x0C000000&(data))>>26)
#define HDMI_DITHER_SEQ_R_00_15_get_seq_r_12(data)                    ((0x03000000&(data))>>24)
#define HDMI_DITHER_SEQ_R_00_15_get_seq_r_11(data)                    ((0x00C00000&(data))>>22)
#define HDMI_DITHER_SEQ_R_00_15_get_seq_r_10(data)                    ((0x00300000&(data))>>20)
#define HDMI_DITHER_SEQ_R_00_15_get_seq_r_9(data)                     ((0x000C0000&(data))>>18)
#define HDMI_DITHER_SEQ_R_00_15_get_seq_r_8(data)                     ((0x00030000&(data))>>16)
#define HDMI_DITHER_SEQ_R_00_15_get_seq_r_7(data)                     ((0x0000C000&(data))>>14)
#define HDMI_DITHER_SEQ_R_00_15_get_seq_r_6(data)                     ((0x00003000&(data))>>12)
#define HDMI_DITHER_SEQ_R_00_15_get_seq_r_5(data)                     ((0x00000C00&(data))>>10)
#define HDMI_DITHER_SEQ_R_00_15_get_seq_r_4(data)                     ((0x00000300&(data))>>8)
#define HDMI_DITHER_SEQ_R_00_15_get_seq_r_3(data)                     ((0x000000C0&(data))>>6)
#define HDMI_DITHER_SEQ_R_00_15_get_seq_r_2(data)                     ((0x00000030&(data))>>4)
#define HDMI_DITHER_SEQ_R_00_15_get_seq_r_1(data)                     ((0x0000000C&(data))>>2)
#define HDMI_DITHER_SEQ_R_00_15_get_seq_r_0(data)                     (0x00000003&(data))


#define HDMI_DITHER_SEQ_R_16_31                                       0x18025a08
#define HDMI_DITHER_SEQ_R_16_31_reg_addr                              "0xb8025a08"
#define HDMI_DITHER_SEQ_R_16_31_reg                                   0xb8025a08
#define HDMI_DITHER_SEQ_R_16_31_inst_addr                             "0x0282"
#define HDMI_DITHER_SEQ_R_16_31_inst                                  0x0282
#define HDMI_DITHER_SEQ_R_16_31_seq_r_31_shift                        (30)
#define HDMI_DITHER_SEQ_R_16_31_seq_r_30_shift                        (28)
#define HDMI_DITHER_SEQ_R_16_31_seq_r_29_shift                        (26)
#define HDMI_DITHER_SEQ_R_16_31_seq_r_28_shift                        (24)
#define HDMI_DITHER_SEQ_R_16_31_seq_r_27_shift                        (22)
#define HDMI_DITHER_SEQ_R_16_31_seq_r_26_shift                        (20)
#define HDMI_DITHER_SEQ_R_16_31_seq_r_25_shift                        (18)
#define HDMI_DITHER_SEQ_R_16_31_seq_r_24_shift                        (16)
#define HDMI_DITHER_SEQ_R_16_31_seq_r_23_shift                        (14)
#define HDMI_DITHER_SEQ_R_16_31_seq_r_22_shift                        (12)
#define HDMI_DITHER_SEQ_R_16_31_seq_r_21_shift                        (10)
#define HDMI_DITHER_SEQ_R_16_31_seq_r_20_shift                        (8)
#define HDMI_DITHER_SEQ_R_16_31_seq_r_19_shift                        (6)
#define HDMI_DITHER_SEQ_R_16_31_seq_r_18_shift                        (4)
#define HDMI_DITHER_SEQ_R_16_31_seq_r_17_shift                        (2)
#define HDMI_DITHER_SEQ_R_16_31_seq_r_16_shift                        (0)
#define HDMI_DITHER_SEQ_R_16_31_seq_r_31_mask                         (0xC0000000)
#define HDMI_DITHER_SEQ_R_16_31_seq_r_30_mask                         (0x30000000)
#define HDMI_DITHER_SEQ_R_16_31_seq_r_29_mask                         (0x0C000000)
#define HDMI_DITHER_SEQ_R_16_31_seq_r_28_mask                         (0x03000000)
#define HDMI_DITHER_SEQ_R_16_31_seq_r_27_mask                         (0x00C00000)
#define HDMI_DITHER_SEQ_R_16_31_seq_r_26_mask                         (0x00300000)
#define HDMI_DITHER_SEQ_R_16_31_seq_r_25_mask                         (0x000C0000)
#define HDMI_DITHER_SEQ_R_16_31_seq_r_24_mask                         (0x00030000)
#define HDMI_DITHER_SEQ_R_16_31_seq_r_23_mask                         (0x0000C000)
#define HDMI_DITHER_SEQ_R_16_31_seq_r_22_mask                         (0x00003000)
#define HDMI_DITHER_SEQ_R_16_31_seq_r_21_mask                         (0x00000C00)
#define HDMI_DITHER_SEQ_R_16_31_seq_r_20_mask                         (0x00000300)
#define HDMI_DITHER_SEQ_R_16_31_seq_r_19_mask                         (0x000000C0)
#define HDMI_DITHER_SEQ_R_16_31_seq_r_18_mask                         (0x00000030)
#define HDMI_DITHER_SEQ_R_16_31_seq_r_17_mask                         (0x0000000C)
#define HDMI_DITHER_SEQ_R_16_31_seq_r_16_mask                         (0x00000003)
#define HDMI_DITHER_SEQ_R_16_31_seq_r_31(data)                        (0xC0000000&((data)<<30))
#define HDMI_DITHER_SEQ_R_16_31_seq_r_30(data)                        (0x30000000&((data)<<28))
#define HDMI_DITHER_SEQ_R_16_31_seq_r_29(data)                        (0x0C000000&((data)<<26))
#define HDMI_DITHER_SEQ_R_16_31_seq_r_28(data)                        (0x03000000&((data)<<24))
#define HDMI_DITHER_SEQ_R_16_31_seq_r_27(data)                        (0x00C00000&((data)<<22))
#define HDMI_DITHER_SEQ_R_16_31_seq_r_26(data)                        (0x00300000&((data)<<20))
#define HDMI_DITHER_SEQ_R_16_31_seq_r_25(data)                        (0x000C0000&((data)<<18))
#define HDMI_DITHER_SEQ_R_16_31_seq_r_24(data)                        (0x00030000&((data)<<16))
#define HDMI_DITHER_SEQ_R_16_31_seq_r_23(data)                        (0x0000C000&((data)<<14))
#define HDMI_DITHER_SEQ_R_16_31_seq_r_22(data)                        (0x00003000&((data)<<12))
#define HDMI_DITHER_SEQ_R_16_31_seq_r_21(data)                        (0x00000C00&((data)<<10))
#define HDMI_DITHER_SEQ_R_16_31_seq_r_20(data)                        (0x00000300&((data)<<8))
#define HDMI_DITHER_SEQ_R_16_31_seq_r_19(data)                        (0x000000C0&((data)<<6))
#define HDMI_DITHER_SEQ_R_16_31_seq_r_18(data)                        (0x00000030&((data)<<4))
#define HDMI_DITHER_SEQ_R_16_31_seq_r_17(data)                        (0x0000000C&((data)<<2))
#define HDMI_DITHER_SEQ_R_16_31_seq_r_16(data)                        (0x00000003&(data))
#define HDMI_DITHER_SEQ_R_16_31_get_seq_r_31(data)                    ((0xC0000000&(data))>>30)
#define HDMI_DITHER_SEQ_R_16_31_get_seq_r_30(data)                    ((0x30000000&(data))>>28)
#define HDMI_DITHER_SEQ_R_16_31_get_seq_r_29(data)                    ((0x0C000000&(data))>>26)
#define HDMI_DITHER_SEQ_R_16_31_get_seq_r_28(data)                    ((0x03000000&(data))>>24)
#define HDMI_DITHER_SEQ_R_16_31_get_seq_r_27(data)                    ((0x00C00000&(data))>>22)
#define HDMI_DITHER_SEQ_R_16_31_get_seq_r_26(data)                    ((0x00300000&(data))>>20)
#define HDMI_DITHER_SEQ_R_16_31_get_seq_r_25(data)                    ((0x000C0000&(data))>>18)
#define HDMI_DITHER_SEQ_R_16_31_get_seq_r_24(data)                    ((0x00030000&(data))>>16)
#define HDMI_DITHER_SEQ_R_16_31_get_seq_r_23(data)                    ((0x0000C000&(data))>>14)
#define HDMI_DITHER_SEQ_R_16_31_get_seq_r_22(data)                    ((0x00003000&(data))>>12)
#define HDMI_DITHER_SEQ_R_16_31_get_seq_r_21(data)                    ((0x00000C00&(data))>>10)
#define HDMI_DITHER_SEQ_R_16_31_get_seq_r_20(data)                    ((0x00000300&(data))>>8)
#define HDMI_DITHER_SEQ_R_16_31_get_seq_r_19(data)                    ((0x000000C0&(data))>>6)
#define HDMI_DITHER_SEQ_R_16_31_get_seq_r_18(data)                    ((0x00000030&(data))>>4)
#define HDMI_DITHER_SEQ_R_16_31_get_seq_r_17(data)                    ((0x0000000C&(data))>>2)
#define HDMI_DITHER_SEQ_R_16_31_get_seq_r_16(data)                    (0x00000003&(data))


#define HDMI_DITHER_SEQ_G_00_07                                       0x18025a0c
#define HDMI_DITHER_SEQ_G_00_07_reg_addr                              "0xb8025a0c"
#define HDMI_DITHER_SEQ_G_00_07_reg                                   0xb8025a0c
#define HDMI_DITHER_SEQ_G_00_07_inst_addr                             "0x0283"
#define HDMI_DITHER_SEQ_G_00_07_inst                                  0x0283
#define HDMI_DITHER_SEQ_G_00_07_seq_g_15_shift                        (30)
#define HDMI_DITHER_SEQ_G_00_07_seq_g_14_shift                        (28)
#define HDMI_DITHER_SEQ_G_00_07_seq_g_13_shift                        (26)
#define HDMI_DITHER_SEQ_G_00_07_seq_g_12_shift                        (24)
#define HDMI_DITHER_SEQ_G_00_07_seq_g_11_shift                        (22)
#define HDMI_DITHER_SEQ_G_00_07_seq_g_10_shift                        (20)
#define HDMI_DITHER_SEQ_G_00_07_seq_g_9_shift                         (18)
#define HDMI_DITHER_SEQ_G_00_07_seq_g_8_shift                         (16)
#define HDMI_DITHER_SEQ_G_00_07_seq_g_7_shift                         (14)
#define HDMI_DITHER_SEQ_G_00_07_seq_g_6_shift                         (12)
#define HDMI_DITHER_SEQ_G_00_07_seq_g_5_shift                         (10)
#define HDMI_DITHER_SEQ_G_00_07_seq_g_4_shift                         (8)
#define HDMI_DITHER_SEQ_G_00_07_seq_g_3_shift                         (6)
#define HDMI_DITHER_SEQ_G_00_07_seq_g_2_shift                         (4)
#define HDMI_DITHER_SEQ_G_00_07_seq_g_1_shift                         (2)
#define HDMI_DITHER_SEQ_G_00_07_seq_g_0_shift                         (0)
#define HDMI_DITHER_SEQ_G_00_07_seq_g_15_mask                         (0xC0000000)
#define HDMI_DITHER_SEQ_G_00_07_seq_g_14_mask                         (0x30000000)
#define HDMI_DITHER_SEQ_G_00_07_seq_g_13_mask                         (0x0C000000)
#define HDMI_DITHER_SEQ_G_00_07_seq_g_12_mask                         (0x03000000)
#define HDMI_DITHER_SEQ_G_00_07_seq_g_11_mask                         (0x00C00000)
#define HDMI_DITHER_SEQ_G_00_07_seq_g_10_mask                         (0x00300000)
#define HDMI_DITHER_SEQ_G_00_07_seq_g_9_mask                          (0x000C0000)
#define HDMI_DITHER_SEQ_G_00_07_seq_g_8_mask                          (0x00030000)
#define HDMI_DITHER_SEQ_G_00_07_seq_g_7_mask                          (0x0000C000)
#define HDMI_DITHER_SEQ_G_00_07_seq_g_6_mask                          (0x00003000)
#define HDMI_DITHER_SEQ_G_00_07_seq_g_5_mask                          (0x00000C00)
#define HDMI_DITHER_SEQ_G_00_07_seq_g_4_mask                          (0x00000300)
#define HDMI_DITHER_SEQ_G_00_07_seq_g_3_mask                          (0x000000C0)
#define HDMI_DITHER_SEQ_G_00_07_seq_g_2_mask                          (0x00000030)
#define HDMI_DITHER_SEQ_G_00_07_seq_g_1_mask                          (0x0000000C)
#define HDMI_DITHER_SEQ_G_00_07_seq_g_0_mask                          (0x00000003)
#define HDMI_DITHER_SEQ_G_00_07_seq_g_15(data)                        (0xC0000000&((data)<<30))
#define HDMI_DITHER_SEQ_G_00_07_seq_g_14(data)                        (0x30000000&((data)<<28))
#define HDMI_DITHER_SEQ_G_00_07_seq_g_13(data)                        (0x0C000000&((data)<<26))
#define HDMI_DITHER_SEQ_G_00_07_seq_g_12(data)                        (0x03000000&((data)<<24))
#define HDMI_DITHER_SEQ_G_00_07_seq_g_11(data)                        (0x00C00000&((data)<<22))
#define HDMI_DITHER_SEQ_G_00_07_seq_g_10(data)                        (0x00300000&((data)<<20))
#define HDMI_DITHER_SEQ_G_00_07_seq_g_9(data)                         (0x000C0000&((data)<<18))
#define HDMI_DITHER_SEQ_G_00_07_seq_g_8(data)                         (0x00030000&((data)<<16))
#define HDMI_DITHER_SEQ_G_00_07_seq_g_7(data)                         (0x0000C000&((data)<<14))
#define HDMI_DITHER_SEQ_G_00_07_seq_g_6(data)                         (0x00003000&((data)<<12))
#define HDMI_DITHER_SEQ_G_00_07_seq_g_5(data)                         (0x00000C00&((data)<<10))
#define HDMI_DITHER_SEQ_G_00_07_seq_g_4(data)                         (0x00000300&((data)<<8))
#define HDMI_DITHER_SEQ_G_00_07_seq_g_3(data)                         (0x000000C0&((data)<<6))
#define HDMI_DITHER_SEQ_G_00_07_seq_g_2(data)                         (0x00000030&((data)<<4))
#define HDMI_DITHER_SEQ_G_00_07_seq_g_1(data)                         (0x0000000C&((data)<<2))
#define HDMI_DITHER_SEQ_G_00_07_seq_g_0(data)                         (0x00000003&(data))
#define HDMI_DITHER_SEQ_G_00_07_get_seq_g_15(data)                    ((0xC0000000&(data))>>30)
#define HDMI_DITHER_SEQ_G_00_07_get_seq_g_14(data)                    ((0x30000000&(data))>>28)
#define HDMI_DITHER_SEQ_G_00_07_get_seq_g_13(data)                    ((0x0C000000&(data))>>26)
#define HDMI_DITHER_SEQ_G_00_07_get_seq_g_12(data)                    ((0x03000000&(data))>>24)
#define HDMI_DITHER_SEQ_G_00_07_get_seq_g_11(data)                    ((0x00C00000&(data))>>22)
#define HDMI_DITHER_SEQ_G_00_07_get_seq_g_10(data)                    ((0x00300000&(data))>>20)
#define HDMI_DITHER_SEQ_G_00_07_get_seq_g_9(data)                     ((0x000C0000&(data))>>18)
#define HDMI_DITHER_SEQ_G_00_07_get_seq_g_8(data)                     ((0x00030000&(data))>>16)
#define HDMI_DITHER_SEQ_G_00_07_get_seq_g_7(data)                     ((0x0000C000&(data))>>14)
#define HDMI_DITHER_SEQ_G_00_07_get_seq_g_6(data)                     ((0x00003000&(data))>>12)
#define HDMI_DITHER_SEQ_G_00_07_get_seq_g_5(data)                     ((0x00000C00&(data))>>10)
#define HDMI_DITHER_SEQ_G_00_07_get_seq_g_4(data)                     ((0x00000300&(data))>>8)
#define HDMI_DITHER_SEQ_G_00_07_get_seq_g_3(data)                     ((0x000000C0&(data))>>6)
#define HDMI_DITHER_SEQ_G_00_07_get_seq_g_2(data)                     ((0x00000030&(data))>>4)
#define HDMI_DITHER_SEQ_G_00_07_get_seq_g_1(data)                     ((0x0000000C&(data))>>2)
#define HDMI_DITHER_SEQ_G_00_07_get_seq_g_0(data)                     (0x00000003&(data))


#define HDMI_DITHER_SEQ_G_16_31                                       0x18025a10
#define HDMI_DITHER_SEQ_G_16_31_reg_addr                              "0xb8025a10"
#define HDMI_DITHER_SEQ_G_16_31_reg                                   0xb8025a10
#define HDMI_DITHER_SEQ_G_16_31_inst_addr                             "0x0284"
#define HDMI_DITHER_SEQ_G_16_31_inst                                  0x0284
#define HDMI_DITHER_SEQ_G_16_31_seq_g_31_shift                        (30)
#define HDMI_DITHER_SEQ_G_16_31_seq_g_30_shift                        (28)
#define HDMI_DITHER_SEQ_G_16_31_seq_g_29_shift                        (26)
#define HDMI_DITHER_SEQ_G_16_31_seq_g_28_shift                        (24)
#define HDMI_DITHER_SEQ_G_16_31_seq_g_27_shift                        (22)
#define HDMI_DITHER_SEQ_G_16_31_seq_g_26_shift                        (20)
#define HDMI_DITHER_SEQ_G_16_31_seq_g_25_shift                        (18)
#define HDMI_DITHER_SEQ_G_16_31_seq_g_24_shift                        (16)
#define HDMI_DITHER_SEQ_G_16_31_seq_g_23_shift                        (14)
#define HDMI_DITHER_SEQ_G_16_31_seq_g_22_shift                        (12)
#define HDMI_DITHER_SEQ_G_16_31_seq_g_21_shift                        (10)
#define HDMI_DITHER_SEQ_G_16_31_seq_g_20_shift                        (8)
#define HDMI_DITHER_SEQ_G_16_31_seq_g_19_shift                        (6)
#define HDMI_DITHER_SEQ_G_16_31_seq_g_18_shift                        (4)
#define HDMI_DITHER_SEQ_G_16_31_seq_g_17_shift                        (2)
#define HDMI_DITHER_SEQ_G_16_31_seq_g_16_shift                        (0)
#define HDMI_DITHER_SEQ_G_16_31_seq_g_31_mask                         (0xC0000000)
#define HDMI_DITHER_SEQ_G_16_31_seq_g_30_mask                         (0x30000000)
#define HDMI_DITHER_SEQ_G_16_31_seq_g_29_mask                         (0x0C000000)
#define HDMI_DITHER_SEQ_G_16_31_seq_g_28_mask                         (0x03000000)
#define HDMI_DITHER_SEQ_G_16_31_seq_g_27_mask                         (0x00C00000)
#define HDMI_DITHER_SEQ_G_16_31_seq_g_26_mask                         (0x00300000)
#define HDMI_DITHER_SEQ_G_16_31_seq_g_25_mask                         (0x000C0000)
#define HDMI_DITHER_SEQ_G_16_31_seq_g_24_mask                         (0x00030000)
#define HDMI_DITHER_SEQ_G_16_31_seq_g_23_mask                         (0x0000C000)
#define HDMI_DITHER_SEQ_G_16_31_seq_g_22_mask                         (0x00003000)
#define HDMI_DITHER_SEQ_G_16_31_seq_g_21_mask                         (0x00000C00)
#define HDMI_DITHER_SEQ_G_16_31_seq_g_20_mask                         (0x00000300)
#define HDMI_DITHER_SEQ_G_16_31_seq_g_19_mask                         (0x000000C0)
#define HDMI_DITHER_SEQ_G_16_31_seq_g_18_mask                         (0x00000030)
#define HDMI_DITHER_SEQ_G_16_31_seq_g_17_mask                         (0x0000000C)
#define HDMI_DITHER_SEQ_G_16_31_seq_g_16_mask                         (0x00000003)
#define HDMI_DITHER_SEQ_G_16_31_seq_g_31(data)                        (0xC0000000&((data)<<30))
#define HDMI_DITHER_SEQ_G_16_31_seq_g_30(data)                        (0x30000000&((data)<<28))
#define HDMI_DITHER_SEQ_G_16_31_seq_g_29(data)                        (0x0C000000&((data)<<26))
#define HDMI_DITHER_SEQ_G_16_31_seq_g_28(data)                        (0x03000000&((data)<<24))
#define HDMI_DITHER_SEQ_G_16_31_seq_g_27(data)                        (0x00C00000&((data)<<22))
#define HDMI_DITHER_SEQ_G_16_31_seq_g_26(data)                        (0x00300000&((data)<<20))
#define HDMI_DITHER_SEQ_G_16_31_seq_g_25(data)                        (0x000C0000&((data)<<18))
#define HDMI_DITHER_SEQ_G_16_31_seq_g_24(data)                        (0x00030000&((data)<<16))
#define HDMI_DITHER_SEQ_G_16_31_seq_g_23(data)                        (0x0000C000&((data)<<14))
#define HDMI_DITHER_SEQ_G_16_31_seq_g_22(data)                        (0x00003000&((data)<<12))
#define HDMI_DITHER_SEQ_G_16_31_seq_g_21(data)                        (0x00000C00&((data)<<10))
#define HDMI_DITHER_SEQ_G_16_31_seq_g_20(data)                        (0x00000300&((data)<<8))
#define HDMI_DITHER_SEQ_G_16_31_seq_g_19(data)                        (0x000000C0&((data)<<6))
#define HDMI_DITHER_SEQ_G_16_31_seq_g_18(data)                        (0x00000030&((data)<<4))
#define HDMI_DITHER_SEQ_G_16_31_seq_g_17(data)                        (0x0000000C&((data)<<2))
#define HDMI_DITHER_SEQ_G_16_31_seq_g_16(data)                        (0x00000003&(data))
#define HDMI_DITHER_SEQ_G_16_31_get_seq_g_31(data)                    ((0xC0000000&(data))>>30)
#define HDMI_DITHER_SEQ_G_16_31_get_seq_g_30(data)                    ((0x30000000&(data))>>28)
#define HDMI_DITHER_SEQ_G_16_31_get_seq_g_29(data)                    ((0x0C000000&(data))>>26)
#define HDMI_DITHER_SEQ_G_16_31_get_seq_g_28(data)                    ((0x03000000&(data))>>24)
#define HDMI_DITHER_SEQ_G_16_31_get_seq_g_27(data)                    ((0x00C00000&(data))>>22)
#define HDMI_DITHER_SEQ_G_16_31_get_seq_g_26(data)                    ((0x00300000&(data))>>20)
#define HDMI_DITHER_SEQ_G_16_31_get_seq_g_25(data)                    ((0x000C0000&(data))>>18)
#define HDMI_DITHER_SEQ_G_16_31_get_seq_g_24(data)                    ((0x00030000&(data))>>16)
#define HDMI_DITHER_SEQ_G_16_31_get_seq_g_23(data)                    ((0x0000C000&(data))>>14)
#define HDMI_DITHER_SEQ_G_16_31_get_seq_g_22(data)                    ((0x00003000&(data))>>12)
#define HDMI_DITHER_SEQ_G_16_31_get_seq_g_21(data)                    ((0x00000C00&(data))>>10)
#define HDMI_DITHER_SEQ_G_16_31_get_seq_g_20(data)                    ((0x00000300&(data))>>8)
#define HDMI_DITHER_SEQ_G_16_31_get_seq_g_19(data)                    ((0x000000C0&(data))>>6)
#define HDMI_DITHER_SEQ_G_16_31_get_seq_g_18(data)                    ((0x00000030&(data))>>4)
#define HDMI_DITHER_SEQ_G_16_31_get_seq_g_17(data)                    ((0x0000000C&(data))>>2)
#define HDMI_DITHER_SEQ_G_16_31_get_seq_g_16(data)                    (0x00000003&(data))


#define HDMI_DITHER_SEQ_B_00_15                                       0x18025a14
#define HDMI_DITHER_SEQ_B_00_15_reg_addr                              "0xb8025a14"
#define HDMI_DITHER_SEQ_B_00_15_reg                                   0xb8025a14
#define HDMI_DITHER_SEQ_B_00_15_inst_addr                             "0x0285"
#define HDMI_DITHER_SEQ_B_00_15_inst                                  0x0285
#define HDMI_DITHER_SEQ_B_00_15_seq_b_15_shift                        (30)
#define HDMI_DITHER_SEQ_B_00_15_seq_b_14_shift                        (28)
#define HDMI_DITHER_SEQ_B_00_15_seq_b_13_shift                        (26)
#define HDMI_DITHER_SEQ_B_00_15_seq_b_12_shift                        (24)
#define HDMI_DITHER_SEQ_B_00_15_seq_b_11_shift                        (22)
#define HDMI_DITHER_SEQ_B_00_15_seq_b_10_shift                        (20)
#define HDMI_DITHER_SEQ_B_00_15_seq_b_9_shift                         (18)
#define HDMI_DITHER_SEQ_B_00_15_seq_b_8_shift                         (16)
#define HDMI_DITHER_SEQ_B_00_15_seq_b_7_shift                         (14)
#define HDMI_DITHER_SEQ_B_00_15_seq_b_6_shift                         (12)
#define HDMI_DITHER_SEQ_B_00_15_seq_b_5_shift                         (10)
#define HDMI_DITHER_SEQ_B_00_15_seq_b_4_shift                         (8)
#define HDMI_DITHER_SEQ_B_00_15_seq_b_3_shift                         (6)
#define HDMI_DITHER_SEQ_B_00_15_seq_b_2_shift                         (4)
#define HDMI_DITHER_SEQ_B_00_15_seq_b_1_shift                         (2)
#define HDMI_DITHER_SEQ_B_00_15_seq_b_0_shift                         (0)
#define HDMI_DITHER_SEQ_B_00_15_seq_b_15_mask                         (0xC0000000)
#define HDMI_DITHER_SEQ_B_00_15_seq_b_14_mask                         (0x30000000)
#define HDMI_DITHER_SEQ_B_00_15_seq_b_13_mask                         (0x0C000000)
#define HDMI_DITHER_SEQ_B_00_15_seq_b_12_mask                         (0x03000000)
#define HDMI_DITHER_SEQ_B_00_15_seq_b_11_mask                         (0x00C00000)
#define HDMI_DITHER_SEQ_B_00_15_seq_b_10_mask                         (0x00300000)
#define HDMI_DITHER_SEQ_B_00_15_seq_b_9_mask                          (0x000C0000)
#define HDMI_DITHER_SEQ_B_00_15_seq_b_8_mask                          (0x00030000)
#define HDMI_DITHER_SEQ_B_00_15_seq_b_7_mask                          (0x0000C000)
#define HDMI_DITHER_SEQ_B_00_15_seq_b_6_mask                          (0x00003000)
#define HDMI_DITHER_SEQ_B_00_15_seq_b_5_mask                          (0x00000C00)
#define HDMI_DITHER_SEQ_B_00_15_seq_b_4_mask                          (0x00000300)
#define HDMI_DITHER_SEQ_B_00_15_seq_b_3_mask                          (0x000000C0)
#define HDMI_DITHER_SEQ_B_00_15_seq_b_2_mask                          (0x00000030)
#define HDMI_DITHER_SEQ_B_00_15_seq_b_1_mask                          (0x0000000C)
#define HDMI_DITHER_SEQ_B_00_15_seq_b_0_mask                          (0x00000003)
#define HDMI_DITHER_SEQ_B_00_15_seq_b_15(data)                        (0xC0000000&((data)<<30))
#define HDMI_DITHER_SEQ_B_00_15_seq_b_14(data)                        (0x30000000&((data)<<28))
#define HDMI_DITHER_SEQ_B_00_15_seq_b_13(data)                        (0x0C000000&((data)<<26))
#define HDMI_DITHER_SEQ_B_00_15_seq_b_12(data)                        (0x03000000&((data)<<24))
#define HDMI_DITHER_SEQ_B_00_15_seq_b_11(data)                        (0x00C00000&((data)<<22))
#define HDMI_DITHER_SEQ_B_00_15_seq_b_10(data)                        (0x00300000&((data)<<20))
#define HDMI_DITHER_SEQ_B_00_15_seq_b_9(data)                         (0x000C0000&((data)<<18))
#define HDMI_DITHER_SEQ_B_00_15_seq_b_8(data)                         (0x00030000&((data)<<16))
#define HDMI_DITHER_SEQ_B_00_15_seq_b_7(data)                         (0x0000C000&((data)<<14))
#define HDMI_DITHER_SEQ_B_00_15_seq_b_6(data)                         (0x00003000&((data)<<12))
#define HDMI_DITHER_SEQ_B_00_15_seq_b_5(data)                         (0x00000C00&((data)<<10))
#define HDMI_DITHER_SEQ_B_00_15_seq_b_4(data)                         (0x00000300&((data)<<8))
#define HDMI_DITHER_SEQ_B_00_15_seq_b_3(data)                         (0x000000C0&((data)<<6))
#define HDMI_DITHER_SEQ_B_00_15_seq_b_2(data)                         (0x00000030&((data)<<4))
#define HDMI_DITHER_SEQ_B_00_15_seq_b_1(data)                         (0x0000000C&((data)<<2))
#define HDMI_DITHER_SEQ_B_00_15_seq_b_0(data)                         (0x00000003&(data))
#define HDMI_DITHER_SEQ_B_00_15_get_seq_b_15(data)                    ((0xC0000000&(data))>>30)
#define HDMI_DITHER_SEQ_B_00_15_get_seq_b_14(data)                    ((0x30000000&(data))>>28)
#define HDMI_DITHER_SEQ_B_00_15_get_seq_b_13(data)                    ((0x0C000000&(data))>>26)
#define HDMI_DITHER_SEQ_B_00_15_get_seq_b_12(data)                    ((0x03000000&(data))>>24)
#define HDMI_DITHER_SEQ_B_00_15_get_seq_b_11(data)                    ((0x00C00000&(data))>>22)
#define HDMI_DITHER_SEQ_B_00_15_get_seq_b_10(data)                    ((0x00300000&(data))>>20)
#define HDMI_DITHER_SEQ_B_00_15_get_seq_b_9(data)                     ((0x000C0000&(data))>>18)
#define HDMI_DITHER_SEQ_B_00_15_get_seq_b_8(data)                     ((0x00030000&(data))>>16)
#define HDMI_DITHER_SEQ_B_00_15_get_seq_b_7(data)                     ((0x0000C000&(data))>>14)
#define HDMI_DITHER_SEQ_B_00_15_get_seq_b_6(data)                     ((0x00003000&(data))>>12)
#define HDMI_DITHER_SEQ_B_00_15_get_seq_b_5(data)                     ((0x00000C00&(data))>>10)
#define HDMI_DITHER_SEQ_B_00_15_get_seq_b_4(data)                     ((0x00000300&(data))>>8)
#define HDMI_DITHER_SEQ_B_00_15_get_seq_b_3(data)                     ((0x000000C0&(data))>>6)
#define HDMI_DITHER_SEQ_B_00_15_get_seq_b_2(data)                     ((0x00000030&(data))>>4)
#define HDMI_DITHER_SEQ_B_00_15_get_seq_b_1(data)                     ((0x0000000C&(data))>>2)
#define HDMI_DITHER_SEQ_B_00_15_get_seq_b_0(data)                     (0x00000003&(data))


#define HDMI_DITHER_SEQ_B_16_31                                       0x18025a18
#define HDMI_DITHER_SEQ_B_16_31_reg_addr                              "0xb8025a18"
#define HDMI_DITHER_SEQ_B_16_31_reg                                   0xb8025a18
#define HDMI_DITHER_SEQ_B_16_31_inst_addr                             "0x0286"
#define HDMI_DITHER_SEQ_B_16_31_inst                                  0x0286
#define HDMI_DITHER_SEQ_B_16_31_seq_b_31_shift                        (30)
#define HDMI_DITHER_SEQ_B_16_31_seq_b_30_shift                        (28)
#define HDMI_DITHER_SEQ_B_16_31_seq_b_29_shift                        (26)
#define HDMI_DITHER_SEQ_B_16_31_seq_b_28_shift                        (24)
#define HDMI_DITHER_SEQ_B_16_31_seq_b_27_shift                        (22)
#define HDMI_DITHER_SEQ_B_16_31_seq_b_26_shift                        (20)
#define HDMI_DITHER_SEQ_B_16_31_seq_b_25_shift                        (18)
#define HDMI_DITHER_SEQ_B_16_31_seq_b_24_shift                        (16)
#define HDMI_DITHER_SEQ_B_16_31_seq_b_23_shift                        (14)
#define HDMI_DITHER_SEQ_B_16_31_seq_b_22_shift                        (12)
#define HDMI_DITHER_SEQ_B_16_31_seq_b_21_shift                        (10)
#define HDMI_DITHER_SEQ_B_16_31_seq_b_20_shift                        (8)
#define HDMI_DITHER_SEQ_B_16_31_seq_b_19_shift                        (6)
#define HDMI_DITHER_SEQ_B_16_31_seq_b_18_shift                        (4)
#define HDMI_DITHER_SEQ_B_16_31_seq_b_17_shift                        (2)
#define HDMI_DITHER_SEQ_B_16_31_seq_b_16_shift                        (0)
#define HDMI_DITHER_SEQ_B_16_31_seq_b_31_mask                         (0xC0000000)
#define HDMI_DITHER_SEQ_B_16_31_seq_b_30_mask                         (0x30000000)
#define HDMI_DITHER_SEQ_B_16_31_seq_b_29_mask                         (0x0C000000)
#define HDMI_DITHER_SEQ_B_16_31_seq_b_28_mask                         (0x03000000)
#define HDMI_DITHER_SEQ_B_16_31_seq_b_27_mask                         (0x00C00000)
#define HDMI_DITHER_SEQ_B_16_31_seq_b_26_mask                         (0x00300000)
#define HDMI_DITHER_SEQ_B_16_31_seq_b_25_mask                         (0x000C0000)
#define HDMI_DITHER_SEQ_B_16_31_seq_b_24_mask                         (0x00030000)
#define HDMI_DITHER_SEQ_B_16_31_seq_b_23_mask                         (0x0000C000)
#define HDMI_DITHER_SEQ_B_16_31_seq_b_22_mask                         (0x00003000)
#define HDMI_DITHER_SEQ_B_16_31_seq_b_21_mask                         (0x00000C00)
#define HDMI_DITHER_SEQ_B_16_31_seq_b_20_mask                         (0x00000300)
#define HDMI_DITHER_SEQ_B_16_31_seq_b_19_mask                         (0x000000C0)
#define HDMI_DITHER_SEQ_B_16_31_seq_b_18_mask                         (0x00000030)
#define HDMI_DITHER_SEQ_B_16_31_seq_b_17_mask                         (0x0000000C)
#define HDMI_DITHER_SEQ_B_16_31_seq_b_16_mask                         (0x00000003)
#define HDMI_DITHER_SEQ_B_16_31_seq_b_31(data)                        (0xC0000000&((data)<<30))
#define HDMI_DITHER_SEQ_B_16_31_seq_b_30(data)                        (0x30000000&((data)<<28))
#define HDMI_DITHER_SEQ_B_16_31_seq_b_29(data)                        (0x0C000000&((data)<<26))
#define HDMI_DITHER_SEQ_B_16_31_seq_b_28(data)                        (0x03000000&((data)<<24))
#define HDMI_DITHER_SEQ_B_16_31_seq_b_27(data)                        (0x00C00000&((data)<<22))
#define HDMI_DITHER_SEQ_B_16_31_seq_b_26(data)                        (0x00300000&((data)<<20))
#define HDMI_DITHER_SEQ_B_16_31_seq_b_25(data)                        (0x000C0000&((data)<<18))
#define HDMI_DITHER_SEQ_B_16_31_seq_b_24(data)                        (0x00030000&((data)<<16))
#define HDMI_DITHER_SEQ_B_16_31_seq_b_23(data)                        (0x0000C000&((data)<<14))
#define HDMI_DITHER_SEQ_B_16_31_seq_b_22(data)                        (0x00003000&((data)<<12))
#define HDMI_DITHER_SEQ_B_16_31_seq_b_21(data)                        (0x00000C00&((data)<<10))
#define HDMI_DITHER_SEQ_B_16_31_seq_b_20(data)                        (0x00000300&((data)<<8))
#define HDMI_DITHER_SEQ_B_16_31_seq_b_19(data)                        (0x000000C0&((data)<<6))
#define HDMI_DITHER_SEQ_B_16_31_seq_b_18(data)                        (0x00000030&((data)<<4))
#define HDMI_DITHER_SEQ_B_16_31_seq_b_17(data)                        (0x0000000C&((data)<<2))
#define HDMI_DITHER_SEQ_B_16_31_seq_b_16(data)                        (0x00000003&(data))
#define HDMI_DITHER_SEQ_B_16_31_get_seq_b_31(data)                    ((0xC0000000&(data))>>30)
#define HDMI_DITHER_SEQ_B_16_31_get_seq_b_30(data)                    ((0x30000000&(data))>>28)
#define HDMI_DITHER_SEQ_B_16_31_get_seq_b_29(data)                    ((0x0C000000&(data))>>26)
#define HDMI_DITHER_SEQ_B_16_31_get_seq_b_28(data)                    ((0x03000000&(data))>>24)
#define HDMI_DITHER_SEQ_B_16_31_get_seq_b_27(data)                    ((0x00C00000&(data))>>22)
#define HDMI_DITHER_SEQ_B_16_31_get_seq_b_26(data)                    ((0x00300000&(data))>>20)
#define HDMI_DITHER_SEQ_B_16_31_get_seq_b_25(data)                    ((0x000C0000&(data))>>18)
#define HDMI_DITHER_SEQ_B_16_31_get_seq_b_24(data)                    ((0x00030000&(data))>>16)
#define HDMI_DITHER_SEQ_B_16_31_get_seq_b_23(data)                    ((0x0000C000&(data))>>14)
#define HDMI_DITHER_SEQ_B_16_31_get_seq_b_22(data)                    ((0x00003000&(data))>>12)
#define HDMI_DITHER_SEQ_B_16_31_get_seq_b_21(data)                    ((0x00000C00&(data))>>10)
#define HDMI_DITHER_SEQ_B_16_31_get_seq_b_20(data)                    ((0x00000300&(data))>>8)
#define HDMI_DITHER_SEQ_B_16_31_get_seq_b_19(data)                    ((0x000000C0&(data))>>6)
#define HDMI_DITHER_SEQ_B_16_31_get_seq_b_18(data)                    ((0x00000030&(data))>>4)
#define HDMI_DITHER_SEQ_B_16_31_get_seq_b_17(data)                    ((0x0000000C&(data))>>2)
#define HDMI_DITHER_SEQ_B_16_31_get_seq_b_16(data)                    (0x00000003&(data))


#define HDMI_DITHER_TB1_R_00                                          0x18025a1c
#define HDMI_DITHER_TB1_R_00_reg_addr                                 "0xb8025a1c"
#define HDMI_DITHER_TB1_R_00_reg                                      0xb8025a1c
#define HDMI_DITHER_TB1_R_00_inst_addr                                "0x0287"
#define HDMI_DITHER_TB1_R_00_inst                                     0x0287
#define HDMI_DITHER_TB1_R_00_tab1_r_13_shift                          (28)
#define HDMI_DITHER_TB1_R_00_tab1_r_12_shift                          (24)
#define HDMI_DITHER_TB1_R_00_tab1_r_11_shift                          (20)
#define HDMI_DITHER_TB1_R_00_tab1_r_10_shift                          (16)
#define HDMI_DITHER_TB1_R_00_tab1_r_03_shift                          (12)
#define HDMI_DITHER_TB1_R_00_tab1_r_02_shift                          (8)
#define HDMI_DITHER_TB1_R_00_tab1_r_01_shift                          (4)
#define HDMI_DITHER_TB1_R_00_tab1_r_00_shift                          (0)
#define HDMI_DITHER_TB1_R_00_tab1_r_13_mask                           (0xF0000000)
#define HDMI_DITHER_TB1_R_00_tab1_r_12_mask                           (0x0F000000)
#define HDMI_DITHER_TB1_R_00_tab1_r_11_mask                           (0x00F00000)
#define HDMI_DITHER_TB1_R_00_tab1_r_10_mask                           (0x000F0000)
#define HDMI_DITHER_TB1_R_00_tab1_r_03_mask                           (0x0000F000)
#define HDMI_DITHER_TB1_R_00_tab1_r_02_mask                           (0x00000F00)
#define HDMI_DITHER_TB1_R_00_tab1_r_01_mask                           (0x000000F0)
#define HDMI_DITHER_TB1_R_00_tab1_r_00_mask                           (0x0000000F)
#define HDMI_DITHER_TB1_R_00_tab1_r_13(data)                          (0xF0000000&((data)<<28))
#define HDMI_DITHER_TB1_R_00_tab1_r_12(data)                          (0x0F000000&((data)<<24))
#define HDMI_DITHER_TB1_R_00_tab1_r_11(data)                          (0x00F00000&((data)<<20))
#define HDMI_DITHER_TB1_R_00_tab1_r_10(data)                          (0x000F0000&((data)<<16))
#define HDMI_DITHER_TB1_R_00_tab1_r_03(data)                          (0x0000F000&((data)<<12))
#define HDMI_DITHER_TB1_R_00_tab1_r_02(data)                          (0x00000F00&((data)<<8))
#define HDMI_DITHER_TB1_R_00_tab1_r_01(data)                          (0x000000F0&((data)<<4))
#define HDMI_DITHER_TB1_R_00_tab1_r_00(data)                          (0x0000000F&(data))
#define HDMI_DITHER_TB1_R_00_get_tab1_r_13(data)                      ((0xF0000000&(data))>>28)
#define HDMI_DITHER_TB1_R_00_get_tab1_r_12(data)                      ((0x0F000000&(data))>>24)
#define HDMI_DITHER_TB1_R_00_get_tab1_r_11(data)                      ((0x00F00000&(data))>>20)
#define HDMI_DITHER_TB1_R_00_get_tab1_r_10(data)                      ((0x000F0000&(data))>>16)
#define HDMI_DITHER_TB1_R_00_get_tab1_r_03(data)                      ((0x0000F000&(data))>>12)
#define HDMI_DITHER_TB1_R_00_get_tab1_r_02(data)                      ((0x00000F00&(data))>>8)
#define HDMI_DITHER_TB1_R_00_get_tab1_r_01(data)                      ((0x000000F0&(data))>>4)
#define HDMI_DITHER_TB1_R_00_get_tab1_r_00(data)                      (0x0000000F&(data))


#define HDMI_DITHER_TB1_R_02                                          0x18025a20
#define HDMI_DITHER_TB1_R_02_reg_addr                                 "0xb8025a20"
#define HDMI_DITHER_TB1_R_02_reg                                      0xb8025a20
#define HDMI_DITHER_TB1_R_02_inst_addr                                "0x0288"
#define HDMI_DITHER_TB1_R_02_inst                                     0x0288
#define HDMI_DITHER_TB1_R_02_tab1_r_33_shift                          (28)
#define HDMI_DITHER_TB1_R_02_tab1_r_32_shift                          (24)
#define HDMI_DITHER_TB1_R_02_tab1_r_31_shift                          (20)
#define HDMI_DITHER_TB1_R_02_tab1_r_30_shift                          (16)
#define HDMI_DITHER_TB1_R_02_tab1_r_23_shift                          (12)
#define HDMI_DITHER_TB1_R_02_tab1_r_22_shift                          (8)
#define HDMI_DITHER_TB1_R_02_tab1_r_21_shift                          (4)
#define HDMI_DITHER_TB1_R_02_tab1_r_20_shift                          (0)
#define HDMI_DITHER_TB1_R_02_tab1_r_33_mask                           (0xF0000000)
#define HDMI_DITHER_TB1_R_02_tab1_r_32_mask                           (0x0F000000)
#define HDMI_DITHER_TB1_R_02_tab1_r_31_mask                           (0x00F00000)
#define HDMI_DITHER_TB1_R_02_tab1_r_30_mask                           (0x000F0000)
#define HDMI_DITHER_TB1_R_02_tab1_r_23_mask                           (0x0000F000)
#define HDMI_DITHER_TB1_R_02_tab1_r_22_mask                           (0x00000F00)
#define HDMI_DITHER_TB1_R_02_tab1_r_21_mask                           (0x000000F0)
#define HDMI_DITHER_TB1_R_02_tab1_r_20_mask                           (0x0000000F)
#define HDMI_DITHER_TB1_R_02_tab1_r_33(data)                          (0xF0000000&((data)<<28))
#define HDMI_DITHER_TB1_R_02_tab1_r_32(data)                          (0x0F000000&((data)<<24))
#define HDMI_DITHER_TB1_R_02_tab1_r_31(data)                          (0x00F00000&((data)<<20))
#define HDMI_DITHER_TB1_R_02_tab1_r_30(data)                          (0x000F0000&((data)<<16))
#define HDMI_DITHER_TB1_R_02_tab1_r_23(data)                          (0x0000F000&((data)<<12))
#define HDMI_DITHER_TB1_R_02_tab1_r_22(data)                          (0x00000F00&((data)<<8))
#define HDMI_DITHER_TB1_R_02_tab1_r_21(data)                          (0x000000F0&((data)<<4))
#define HDMI_DITHER_TB1_R_02_tab1_r_20(data)                          (0x0000000F&(data))
#define HDMI_DITHER_TB1_R_02_get_tab1_r_33(data)                      ((0xF0000000&(data))>>28)
#define HDMI_DITHER_TB1_R_02_get_tab1_r_32(data)                      ((0x0F000000&(data))>>24)
#define HDMI_DITHER_TB1_R_02_get_tab1_r_31(data)                      ((0x00F00000&(data))>>20)
#define HDMI_DITHER_TB1_R_02_get_tab1_r_30(data)                      ((0x000F0000&(data))>>16)
#define HDMI_DITHER_TB1_R_02_get_tab1_r_23(data)                      ((0x0000F000&(data))>>12)
#define HDMI_DITHER_TB1_R_02_get_tab1_r_22(data)                      ((0x00000F00&(data))>>8)
#define HDMI_DITHER_TB1_R_02_get_tab1_r_21(data)                      ((0x000000F0&(data))>>4)
#define HDMI_DITHER_TB1_R_02_get_tab1_r_20(data)                      (0x0000000F&(data))


#define HDMI_DITHER_TB1_G_00                                          0x18025a24
#define HDMI_DITHER_TB1_G_00_reg_addr                                 "0xb8025a24"
#define HDMI_DITHER_TB1_G_00_reg                                      0xb8025a24
#define HDMI_DITHER_TB1_G_00_inst_addr                                "0x0289"
#define HDMI_DITHER_TB1_G_00_inst                                     0x0289
#define HDMI_DITHER_TB1_G_00_tab1_g_13_shift                          (28)
#define HDMI_DITHER_TB1_G_00_tab1_g_12_shift                          (24)
#define HDMI_DITHER_TB1_G_00_tab1_g_11_shift                          (20)
#define HDMI_DITHER_TB1_G_00_tab1_g_10_shift                          (16)
#define HDMI_DITHER_TB1_G_00_tab1_g_03_shift                          (12)
#define HDMI_DITHER_TB1_G_00_tab1_g_02_shift                          (8)
#define HDMI_DITHER_TB1_G_00_tab1_g_01_shift                          (4)
#define HDMI_DITHER_TB1_G_00_tab1_g_00_shift                          (0)
#define HDMI_DITHER_TB1_G_00_tab1_g_13_mask                           (0xF0000000)
#define HDMI_DITHER_TB1_G_00_tab1_g_12_mask                           (0x0F000000)
#define HDMI_DITHER_TB1_G_00_tab1_g_11_mask                           (0x00F00000)
#define HDMI_DITHER_TB1_G_00_tab1_g_10_mask                           (0x000F0000)
#define HDMI_DITHER_TB1_G_00_tab1_g_03_mask                           (0x0000F000)
#define HDMI_DITHER_TB1_G_00_tab1_g_02_mask                           (0x00000F00)
#define HDMI_DITHER_TB1_G_00_tab1_g_01_mask                           (0x000000F0)
#define HDMI_DITHER_TB1_G_00_tab1_g_00_mask                           (0x0000000F)
#define HDMI_DITHER_TB1_G_00_tab1_g_13(data)                          (0xF0000000&((data)<<28))
#define HDMI_DITHER_TB1_G_00_tab1_g_12(data)                          (0x0F000000&((data)<<24))
#define HDMI_DITHER_TB1_G_00_tab1_g_11(data)                          (0x00F00000&((data)<<20))
#define HDMI_DITHER_TB1_G_00_tab1_g_10(data)                          (0x000F0000&((data)<<16))
#define HDMI_DITHER_TB1_G_00_tab1_g_03(data)                          (0x0000F000&((data)<<12))
#define HDMI_DITHER_TB1_G_00_tab1_g_02(data)                          (0x00000F00&((data)<<8))
#define HDMI_DITHER_TB1_G_00_tab1_g_01(data)                          (0x000000F0&((data)<<4))
#define HDMI_DITHER_TB1_G_00_tab1_g_00(data)                          (0x0000000F&(data))
#define HDMI_DITHER_TB1_G_00_get_tab1_g_13(data)                      ((0xF0000000&(data))>>28)
#define HDMI_DITHER_TB1_G_00_get_tab1_g_12(data)                      ((0x0F000000&(data))>>24)
#define HDMI_DITHER_TB1_G_00_get_tab1_g_11(data)                      ((0x00F00000&(data))>>20)
#define HDMI_DITHER_TB1_G_00_get_tab1_g_10(data)                      ((0x000F0000&(data))>>16)
#define HDMI_DITHER_TB1_G_00_get_tab1_g_03(data)                      ((0x0000F000&(data))>>12)
#define HDMI_DITHER_TB1_G_00_get_tab1_g_02(data)                      ((0x00000F00&(data))>>8)
#define HDMI_DITHER_TB1_G_00_get_tab1_g_01(data)                      ((0x000000F0&(data))>>4)
#define HDMI_DITHER_TB1_G_00_get_tab1_g_00(data)                      (0x0000000F&(data))


#define HDMI_DITHER_TB1_G_02                                          0x18025a28
#define HDMI_DITHER_TB1_G_02_reg_addr                                 "0xb8025a28"
#define HDMI_DITHER_TB1_G_02_reg                                      0xb8025a28
#define HDMI_DITHER_TB1_G_02_inst_addr                                "0x028A"
#define HDMI_DITHER_TB1_G_02_inst                                     0x028A
#define HDMI_DITHER_TB1_G_02_tab1_g_33_shift                          (28)
#define HDMI_DITHER_TB1_G_02_tab1_g_32_shift                          (24)
#define HDMI_DITHER_TB1_G_02_tab1_g_31_shift                          (20)
#define HDMI_DITHER_TB1_G_02_tab1_g_30_shift                          (16)
#define HDMI_DITHER_TB1_G_02_tab1_g_23_shift                          (12)
#define HDMI_DITHER_TB1_G_02_tab1_g_22_shift                          (8)
#define HDMI_DITHER_TB1_G_02_tab1_g_21_shift                          (4)
#define HDMI_DITHER_TB1_G_02_tab1_g_20_shift                          (0)
#define HDMI_DITHER_TB1_G_02_tab1_g_33_mask                           (0xF0000000)
#define HDMI_DITHER_TB1_G_02_tab1_g_32_mask                           (0x0F000000)
#define HDMI_DITHER_TB1_G_02_tab1_g_31_mask                           (0x00F00000)
#define HDMI_DITHER_TB1_G_02_tab1_g_30_mask                           (0x000F0000)
#define HDMI_DITHER_TB1_G_02_tab1_g_23_mask                           (0x0000F000)
#define HDMI_DITHER_TB1_G_02_tab1_g_22_mask                           (0x00000F00)
#define HDMI_DITHER_TB1_G_02_tab1_g_21_mask                           (0x000000F0)
#define HDMI_DITHER_TB1_G_02_tab1_g_20_mask                           (0x0000000F)
#define HDMI_DITHER_TB1_G_02_tab1_g_33(data)                          (0xF0000000&((data)<<28))
#define HDMI_DITHER_TB1_G_02_tab1_g_32(data)                          (0x0F000000&((data)<<24))
#define HDMI_DITHER_TB1_G_02_tab1_g_31(data)                          (0x00F00000&((data)<<20))
#define HDMI_DITHER_TB1_G_02_tab1_g_30(data)                          (0x000F0000&((data)<<16))
#define HDMI_DITHER_TB1_G_02_tab1_g_23(data)                          (0x0000F000&((data)<<12))
#define HDMI_DITHER_TB1_G_02_tab1_g_22(data)                          (0x00000F00&((data)<<8))
#define HDMI_DITHER_TB1_G_02_tab1_g_21(data)                          (0x000000F0&((data)<<4))
#define HDMI_DITHER_TB1_G_02_tab1_g_20(data)                          (0x0000000F&(data))
#define HDMI_DITHER_TB1_G_02_get_tab1_g_33(data)                      ((0xF0000000&(data))>>28)
#define HDMI_DITHER_TB1_G_02_get_tab1_g_32(data)                      ((0x0F000000&(data))>>24)
#define HDMI_DITHER_TB1_G_02_get_tab1_g_31(data)                      ((0x00F00000&(data))>>20)
#define HDMI_DITHER_TB1_G_02_get_tab1_g_30(data)                      ((0x000F0000&(data))>>16)
#define HDMI_DITHER_TB1_G_02_get_tab1_g_23(data)                      ((0x0000F000&(data))>>12)
#define HDMI_DITHER_TB1_G_02_get_tab1_g_22(data)                      ((0x00000F00&(data))>>8)
#define HDMI_DITHER_TB1_G_02_get_tab1_g_21(data)                      ((0x000000F0&(data))>>4)
#define HDMI_DITHER_TB1_G_02_get_tab1_g_20(data)                      (0x0000000F&(data))


#define HDMI_DITHER_TB1_B_00                                          0x18025a2c
#define HDMI_DITHER_TB1_B_00_reg_addr                                 "0xb8025a2c"
#define HDMI_DITHER_TB1_B_00_reg                                      0xb8025a2c
#define HDMI_DITHER_TB1_B_00_inst_addr                                "0x028B"
#define HDMI_DITHER_TB1_B_00_inst                                     0x028B
#define HDMI_DITHER_TB1_B_00_tab1_b_13_shift                          (28)
#define HDMI_DITHER_TB1_B_00_tab1_b_12_shift                          (24)
#define HDMI_DITHER_TB1_B_00_tab1_b_11_shift                          (20)
#define HDMI_DITHER_TB1_B_00_tab1_b_10_shift                          (16)
#define HDMI_DITHER_TB1_B_00_tab1_b_03_shift                          (12)
#define HDMI_DITHER_TB1_B_00_tab1_b_02_shift                          (8)
#define HDMI_DITHER_TB1_B_00_tab1_b_01_shift                          (4)
#define HDMI_DITHER_TB1_B_00_tab1_b_00_shift                          (0)
#define HDMI_DITHER_TB1_B_00_tab1_b_13_mask                           (0xF0000000)
#define HDMI_DITHER_TB1_B_00_tab1_b_12_mask                           (0x0F000000)
#define HDMI_DITHER_TB1_B_00_tab1_b_11_mask                           (0x00F00000)
#define HDMI_DITHER_TB1_B_00_tab1_b_10_mask                           (0x000F0000)
#define HDMI_DITHER_TB1_B_00_tab1_b_03_mask                           (0x0000F000)
#define HDMI_DITHER_TB1_B_00_tab1_b_02_mask                           (0x00000F00)
#define HDMI_DITHER_TB1_B_00_tab1_b_01_mask                           (0x000000F0)
#define HDMI_DITHER_TB1_B_00_tab1_b_00_mask                           (0x0000000F)
#define HDMI_DITHER_TB1_B_00_tab1_b_13(data)                          (0xF0000000&((data)<<28))
#define HDMI_DITHER_TB1_B_00_tab1_b_12(data)                          (0x0F000000&((data)<<24))
#define HDMI_DITHER_TB1_B_00_tab1_b_11(data)                          (0x00F00000&((data)<<20))
#define HDMI_DITHER_TB1_B_00_tab1_b_10(data)                          (0x000F0000&((data)<<16))
#define HDMI_DITHER_TB1_B_00_tab1_b_03(data)                          (0x0000F000&((data)<<12))
#define HDMI_DITHER_TB1_B_00_tab1_b_02(data)                          (0x00000F00&((data)<<8))
#define HDMI_DITHER_TB1_B_00_tab1_b_01(data)                          (0x000000F0&((data)<<4))
#define HDMI_DITHER_TB1_B_00_tab1_b_00(data)                          (0x0000000F&(data))
#define HDMI_DITHER_TB1_B_00_get_tab1_b_13(data)                      ((0xF0000000&(data))>>28)
#define HDMI_DITHER_TB1_B_00_get_tab1_b_12(data)                      ((0x0F000000&(data))>>24)
#define HDMI_DITHER_TB1_B_00_get_tab1_b_11(data)                      ((0x00F00000&(data))>>20)
#define HDMI_DITHER_TB1_B_00_get_tab1_b_10(data)                      ((0x000F0000&(data))>>16)
#define HDMI_DITHER_TB1_B_00_get_tab1_b_03(data)                      ((0x0000F000&(data))>>12)
#define HDMI_DITHER_TB1_B_00_get_tab1_b_02(data)                      ((0x00000F00&(data))>>8)
#define HDMI_DITHER_TB1_B_00_get_tab1_b_01(data)                      ((0x000000F0&(data))>>4)
#define HDMI_DITHER_TB1_B_00_get_tab1_b_00(data)                      (0x0000000F&(data))


#define HDMI_DITHER_TB1_B_02                                          0x18025a30
#define HDMI_DITHER_TB1_B_02_reg_addr                                 "0xb8025a30"
#define HDMI_DITHER_TB1_B_02_reg                                      0xb8025a30
#define HDMI_DITHER_TB1_B_02_inst_addr                                "0x028C"
#define HDMI_DITHER_TB1_B_02_inst                                     0x028C
#define HDMI_DITHER_TB1_B_02_tab1_b_33_shift                          (28)
#define HDMI_DITHER_TB1_B_02_tab1_b_32_shift                          (24)
#define HDMI_DITHER_TB1_B_02_tab1_b_31_shift                          (20)
#define HDMI_DITHER_TB1_B_02_tab1_b_30_shift                          (16)
#define HDMI_DITHER_TB1_B_02_tab1_b_23_shift                          (12)
#define HDMI_DITHER_TB1_B_02_tab1_b_22_shift                          (8)
#define HDMI_DITHER_TB1_B_02_tab1_b_21_shift                          (4)
#define HDMI_DITHER_TB1_B_02_tab1_b_20_shift                          (0)
#define HDMI_DITHER_TB1_B_02_tab1_b_33_mask                           (0xF0000000)
#define HDMI_DITHER_TB1_B_02_tab1_b_32_mask                           (0x0F000000)
#define HDMI_DITHER_TB1_B_02_tab1_b_31_mask                           (0x00F00000)
#define HDMI_DITHER_TB1_B_02_tab1_b_30_mask                           (0x000F0000)
#define HDMI_DITHER_TB1_B_02_tab1_b_23_mask                           (0x0000F000)
#define HDMI_DITHER_TB1_B_02_tab1_b_22_mask                           (0x00000F00)
#define HDMI_DITHER_TB1_B_02_tab1_b_21_mask                           (0x000000F0)
#define HDMI_DITHER_TB1_B_02_tab1_b_20_mask                           (0x0000000F)
#define HDMI_DITHER_TB1_B_02_tab1_b_33(data)                          (0xF0000000&((data)<<28))
#define HDMI_DITHER_TB1_B_02_tab1_b_32(data)                          (0x0F000000&((data)<<24))
#define HDMI_DITHER_TB1_B_02_tab1_b_31(data)                          (0x00F00000&((data)<<20))
#define HDMI_DITHER_TB1_B_02_tab1_b_30(data)                          (0x000F0000&((data)<<16))
#define HDMI_DITHER_TB1_B_02_tab1_b_23(data)                          (0x0000F000&((data)<<12))
#define HDMI_DITHER_TB1_B_02_tab1_b_22(data)                          (0x00000F00&((data)<<8))
#define HDMI_DITHER_TB1_B_02_tab1_b_21(data)                          (0x000000F0&((data)<<4))
#define HDMI_DITHER_TB1_B_02_tab1_b_20(data)                          (0x0000000F&(data))
#define HDMI_DITHER_TB1_B_02_get_tab1_b_33(data)                      ((0xF0000000&(data))>>28)
#define HDMI_DITHER_TB1_B_02_get_tab1_b_32(data)                      ((0x0F000000&(data))>>24)
#define HDMI_DITHER_TB1_B_02_get_tab1_b_31(data)                      ((0x00F00000&(data))>>20)
#define HDMI_DITHER_TB1_B_02_get_tab1_b_30(data)                      ((0x000F0000&(data))>>16)
#define HDMI_DITHER_TB1_B_02_get_tab1_b_23(data)                      ((0x0000F000&(data))>>12)
#define HDMI_DITHER_TB1_B_02_get_tab1_b_22(data)                      ((0x00000F00&(data))>>8)
#define HDMI_DITHER_TB1_B_02_get_tab1_b_21(data)                      ((0x000000F0&(data))>>4)
#define HDMI_DITHER_TB1_B_02_get_tab1_b_20(data)                      (0x0000000F&(data))


#define HDMI_DITHER_TEMP_TB1                                          0x18025a34
#define HDMI_DITHER_TEMP_TB1_reg_addr                                 "0xb8025a34"
#define HDMI_DITHER_TEMP_TB1_reg                                      0xb8025a34
#define HDMI_DITHER_TEMP_TB1_inst_addr                                "0x028D"
#define HDMI_DITHER_TEMP_TB1_inst                                     0x028D
#define HDMI_DITHER_TEMP_TB1_tab1_temp_offset_15_shift                (30)
#define HDMI_DITHER_TEMP_TB1_tab1_temp_offset_14_shift                (28)
#define HDMI_DITHER_TEMP_TB1_tab1_temp_offset_13_shift                (26)
#define HDMI_DITHER_TEMP_TB1_tab1_temp_offset_12_shift                (24)
#define HDMI_DITHER_TEMP_TB1_tab1_temp_offset_11_shift                (22)
#define HDMI_DITHER_TEMP_TB1_tab1_temp_offset_10_shift                (20)
#define HDMI_DITHER_TEMP_TB1_tab1_temp_offset_9_shift                 (18)
#define HDMI_DITHER_TEMP_TB1_tab1_temp_offset_8_shift                 (16)
#define HDMI_DITHER_TEMP_TB1_tab1_temp_offset_7_shift                 (14)
#define HDMI_DITHER_TEMP_TB1_tab1_temp_offset_6_shift                 (12)
#define HDMI_DITHER_TEMP_TB1_tab1_temp_offset_5_shift                 (10)
#define HDMI_DITHER_TEMP_TB1_tab1_temp_offset_4_shift                 (8)
#define HDMI_DITHER_TEMP_TB1_tab1_temp_offset_3_shift                 (6)
#define HDMI_DITHER_TEMP_TB1_tab1_temp_offset_2_shift                 (4)
#define HDMI_DITHER_TEMP_TB1_tab1_temp_offset_1_shift                 (2)
#define HDMI_DITHER_TEMP_TB1_tab1_temp_offset_0_shift                 (0)
#define HDMI_DITHER_TEMP_TB1_tab1_temp_offset_15_mask                 (0xC0000000)
#define HDMI_DITHER_TEMP_TB1_tab1_temp_offset_14_mask                 (0x30000000)
#define HDMI_DITHER_TEMP_TB1_tab1_temp_offset_13_mask                 (0x0C000000)
#define HDMI_DITHER_TEMP_TB1_tab1_temp_offset_12_mask                 (0x03000000)
#define HDMI_DITHER_TEMP_TB1_tab1_temp_offset_11_mask                 (0x00C00000)
#define HDMI_DITHER_TEMP_TB1_tab1_temp_offset_10_mask                 (0x00300000)
#define HDMI_DITHER_TEMP_TB1_tab1_temp_offset_9_mask                  (0x000C0000)
#define HDMI_DITHER_TEMP_TB1_tab1_temp_offset_8_mask                  (0x00030000)
#define HDMI_DITHER_TEMP_TB1_tab1_temp_offset_7_mask                  (0x0000C000)
#define HDMI_DITHER_TEMP_TB1_tab1_temp_offset_6_mask                  (0x00003000)
#define HDMI_DITHER_TEMP_TB1_tab1_temp_offset_5_mask                  (0x00000C00)
#define HDMI_DITHER_TEMP_TB1_tab1_temp_offset_4_mask                  (0x00000300)
#define HDMI_DITHER_TEMP_TB1_tab1_temp_offset_3_mask                  (0x000000C0)
#define HDMI_DITHER_TEMP_TB1_tab1_temp_offset_2_mask                  (0x00000030)
#define HDMI_DITHER_TEMP_TB1_tab1_temp_offset_1_mask                  (0x0000000C)
#define HDMI_DITHER_TEMP_TB1_tab1_temp_offset_0_mask                  (0x00000003)
#define HDMI_DITHER_TEMP_TB1_tab1_temp_offset_15(data)                (0xC0000000&((data)<<30))
#define HDMI_DITHER_TEMP_TB1_tab1_temp_offset_14(data)                (0x30000000&((data)<<28))
#define HDMI_DITHER_TEMP_TB1_tab1_temp_offset_13(data)                (0x0C000000&((data)<<26))
#define HDMI_DITHER_TEMP_TB1_tab1_temp_offset_12(data)                (0x03000000&((data)<<24))
#define HDMI_DITHER_TEMP_TB1_tab1_temp_offset_11(data)                (0x00C00000&((data)<<22))
#define HDMI_DITHER_TEMP_TB1_tab1_temp_offset_10(data)                (0x00300000&((data)<<20))
#define HDMI_DITHER_TEMP_TB1_tab1_temp_offset_9(data)                 (0x000C0000&((data)<<18))
#define HDMI_DITHER_TEMP_TB1_tab1_temp_offset_8(data)                 (0x00030000&((data)<<16))
#define HDMI_DITHER_TEMP_TB1_tab1_temp_offset_7(data)                 (0x0000C000&((data)<<14))
#define HDMI_DITHER_TEMP_TB1_tab1_temp_offset_6(data)                 (0x00003000&((data)<<12))
#define HDMI_DITHER_TEMP_TB1_tab1_temp_offset_5(data)                 (0x00000C00&((data)<<10))
#define HDMI_DITHER_TEMP_TB1_tab1_temp_offset_4(data)                 (0x00000300&((data)<<8))
#define HDMI_DITHER_TEMP_TB1_tab1_temp_offset_3(data)                 (0x000000C0&((data)<<6))
#define HDMI_DITHER_TEMP_TB1_tab1_temp_offset_2(data)                 (0x00000030&((data)<<4))
#define HDMI_DITHER_TEMP_TB1_tab1_temp_offset_1(data)                 (0x0000000C&((data)<<2))
#define HDMI_DITHER_TEMP_TB1_tab1_temp_offset_0(data)                 (0x00000003&(data))
#define HDMI_DITHER_TEMP_TB1_get_tab1_temp_offset_15(data)            ((0xC0000000&(data))>>30)
#define HDMI_DITHER_TEMP_TB1_get_tab1_temp_offset_14(data)            ((0x30000000&(data))>>28)
#define HDMI_DITHER_TEMP_TB1_get_tab1_temp_offset_13(data)            ((0x0C000000&(data))>>26)
#define HDMI_DITHER_TEMP_TB1_get_tab1_temp_offset_12(data)            ((0x03000000&(data))>>24)
#define HDMI_DITHER_TEMP_TB1_get_tab1_temp_offset_11(data)            ((0x00C00000&(data))>>22)
#define HDMI_DITHER_TEMP_TB1_get_tab1_temp_offset_10(data)            ((0x00300000&(data))>>20)
#define HDMI_DITHER_TEMP_TB1_get_tab1_temp_offset_9(data)             ((0x000C0000&(data))>>18)
#define HDMI_DITHER_TEMP_TB1_get_tab1_temp_offset_8(data)             ((0x00030000&(data))>>16)
#define HDMI_DITHER_TEMP_TB1_get_tab1_temp_offset_7(data)             ((0x0000C000&(data))>>14)
#define HDMI_DITHER_TEMP_TB1_get_tab1_temp_offset_6(data)             ((0x00003000&(data))>>12)
#define HDMI_DITHER_TEMP_TB1_get_tab1_temp_offset_5(data)             ((0x00000C00&(data))>>10)
#define HDMI_DITHER_TEMP_TB1_get_tab1_temp_offset_4(data)             ((0x00000300&(data))>>8)
#define HDMI_DITHER_TEMP_TB1_get_tab1_temp_offset_3(data)             ((0x000000C0&(data))>>6)
#define HDMI_DITHER_TEMP_TB1_get_tab1_temp_offset_2(data)             ((0x00000030&(data))>>4)
#define HDMI_DITHER_TEMP_TB1_get_tab1_temp_offset_1(data)             ((0x0000000C&(data))>>2)
#define HDMI_DITHER_TEMP_TB1_get_tab1_temp_offset_0(data)             (0x00000003&(data))


#define HDMI_DITHER_TB2_R_00                                          0x18025a38
#define HDMI_DITHER_TB2_R_00_reg_addr                                 "0xb8025a38"
#define HDMI_DITHER_TB2_R_00_reg                                      0xb8025a38
#define HDMI_DITHER_TB2_R_00_inst_addr                                "0x028E"
#define HDMI_DITHER_TB2_R_00_inst                                     0x028E
#define HDMI_DITHER_TB2_R_00_tab2_r_13_shift                          (28)
#define HDMI_DITHER_TB2_R_00_tab2_r_12_shift                          (24)
#define HDMI_DITHER_TB2_R_00_tab2_r_11_shift                          (20)
#define HDMI_DITHER_TB2_R_00_tab2_r_10_shift                          (16)
#define HDMI_DITHER_TB2_R_00_tab2_r_03_shift                          (12)
#define HDMI_DITHER_TB2_R_00_tab2_r_02_shift                          (8)
#define HDMI_DITHER_TB2_R_00_tab2_r_01_shift                          (4)
#define HDMI_DITHER_TB2_R_00_tab2_r_00_shift                          (0)
#define HDMI_DITHER_TB2_R_00_tab2_r_13_mask                           (0xF0000000)
#define HDMI_DITHER_TB2_R_00_tab2_r_12_mask                           (0x0F000000)
#define HDMI_DITHER_TB2_R_00_tab2_r_11_mask                           (0x00F00000)
#define HDMI_DITHER_TB2_R_00_tab2_r_10_mask                           (0x000F0000)
#define HDMI_DITHER_TB2_R_00_tab2_r_03_mask                           (0x0000F000)
#define HDMI_DITHER_TB2_R_00_tab2_r_02_mask                           (0x00000F00)
#define HDMI_DITHER_TB2_R_00_tab2_r_01_mask                           (0x000000F0)
#define HDMI_DITHER_TB2_R_00_tab2_r_00_mask                           (0x0000000F)
#define HDMI_DITHER_TB2_R_00_tab2_r_13(data)                          (0xF0000000&((data)<<28))
#define HDMI_DITHER_TB2_R_00_tab2_r_12(data)                          (0x0F000000&((data)<<24))
#define HDMI_DITHER_TB2_R_00_tab2_r_11(data)                          (0x00F00000&((data)<<20))
#define HDMI_DITHER_TB2_R_00_tab2_r_10(data)                          (0x000F0000&((data)<<16))
#define HDMI_DITHER_TB2_R_00_tab2_r_03(data)                          (0x0000F000&((data)<<12))
#define HDMI_DITHER_TB2_R_00_tab2_r_02(data)                          (0x00000F00&((data)<<8))
#define HDMI_DITHER_TB2_R_00_tab2_r_01(data)                          (0x000000F0&((data)<<4))
#define HDMI_DITHER_TB2_R_00_tab2_r_00(data)                          (0x0000000F&(data))
#define HDMI_DITHER_TB2_R_00_get_tab2_r_13(data)                      ((0xF0000000&(data))>>28)
#define HDMI_DITHER_TB2_R_00_get_tab2_r_12(data)                      ((0x0F000000&(data))>>24)
#define HDMI_DITHER_TB2_R_00_get_tab2_r_11(data)                      ((0x00F00000&(data))>>20)
#define HDMI_DITHER_TB2_R_00_get_tab2_r_10(data)                      ((0x000F0000&(data))>>16)
#define HDMI_DITHER_TB2_R_00_get_tab2_r_03(data)                      ((0x0000F000&(data))>>12)
#define HDMI_DITHER_TB2_R_00_get_tab2_r_02(data)                      ((0x00000F00&(data))>>8)
#define HDMI_DITHER_TB2_R_00_get_tab2_r_01(data)                      ((0x000000F0&(data))>>4)
#define HDMI_DITHER_TB2_R_00_get_tab2_r_00(data)                      (0x0000000F&(data))


#define HDMI_DITHER_TB2_R_02                                          0x18025a3c
#define HDMI_DITHER_TB2_R_02_reg_addr                                 "0xb8025a3c"
#define HDMI_DITHER_TB2_R_02_reg                                      0xb8025a3c
#define HDMI_DITHER_TB2_R_02_inst_addr                                "0x028F"
#define HDMI_DITHER_TB2_R_02_inst                                     0x028F
#define HDMI_DITHER_TB2_R_02_tab2_r_33_shift                          (28)
#define HDMI_DITHER_TB2_R_02_tab2_r_32_shift                          (24)
#define HDMI_DITHER_TB2_R_02_tab2_r_31_shift                          (20)
#define HDMI_DITHER_TB2_R_02_tab2_r_30_shift                          (16)
#define HDMI_DITHER_TB2_R_02_tab2_r_23_shift                          (12)
#define HDMI_DITHER_TB2_R_02_tab2_r_22_shift                          (8)
#define HDMI_DITHER_TB2_R_02_tab2_r_21_shift                          (4)
#define HDMI_DITHER_TB2_R_02_tab2_r_20_shift                          (0)
#define HDMI_DITHER_TB2_R_02_tab2_r_33_mask                           (0xF0000000)
#define HDMI_DITHER_TB2_R_02_tab2_r_32_mask                           (0x0F000000)
#define HDMI_DITHER_TB2_R_02_tab2_r_31_mask                           (0x00F00000)
#define HDMI_DITHER_TB2_R_02_tab2_r_30_mask                           (0x000F0000)
#define HDMI_DITHER_TB2_R_02_tab2_r_23_mask                           (0x0000F000)
#define HDMI_DITHER_TB2_R_02_tab2_r_22_mask                           (0x00000F00)
#define HDMI_DITHER_TB2_R_02_tab2_r_21_mask                           (0x000000F0)
#define HDMI_DITHER_TB2_R_02_tab2_r_20_mask                           (0x0000000F)
#define HDMI_DITHER_TB2_R_02_tab2_r_33(data)                          (0xF0000000&((data)<<28))
#define HDMI_DITHER_TB2_R_02_tab2_r_32(data)                          (0x0F000000&((data)<<24))
#define HDMI_DITHER_TB2_R_02_tab2_r_31(data)                          (0x00F00000&((data)<<20))
#define HDMI_DITHER_TB2_R_02_tab2_r_30(data)                          (0x000F0000&((data)<<16))
#define HDMI_DITHER_TB2_R_02_tab2_r_23(data)                          (0x0000F000&((data)<<12))
#define HDMI_DITHER_TB2_R_02_tab2_r_22(data)                          (0x00000F00&((data)<<8))
#define HDMI_DITHER_TB2_R_02_tab2_r_21(data)                          (0x000000F0&((data)<<4))
#define HDMI_DITHER_TB2_R_02_tab2_r_20(data)                          (0x0000000F&(data))
#define HDMI_DITHER_TB2_R_02_get_tab2_r_33(data)                      ((0xF0000000&(data))>>28)
#define HDMI_DITHER_TB2_R_02_get_tab2_r_32(data)                      ((0x0F000000&(data))>>24)
#define HDMI_DITHER_TB2_R_02_get_tab2_r_31(data)                      ((0x00F00000&(data))>>20)
#define HDMI_DITHER_TB2_R_02_get_tab2_r_30(data)                      ((0x000F0000&(data))>>16)
#define HDMI_DITHER_TB2_R_02_get_tab2_r_23(data)                      ((0x0000F000&(data))>>12)
#define HDMI_DITHER_TB2_R_02_get_tab2_r_22(data)                      ((0x00000F00&(data))>>8)
#define HDMI_DITHER_TB2_R_02_get_tab2_r_21(data)                      ((0x000000F0&(data))>>4)
#define HDMI_DITHER_TB2_R_02_get_tab2_r_20(data)                      (0x0000000F&(data))


#define HDMI_DITHER_TB2_G_00                                          0x18025a40
#define HDMI_DITHER_TB2_G_00_reg_addr                                 "0xb8025a40"
#define HDMI_DITHER_TB2_G_00_reg                                      0xb8025a40
#define HDMI_DITHER_TB2_G_00_inst_addr                                "0x0290"
#define HDMI_DITHER_TB2_G_00_inst                                     0x0290
#define HDMI_DITHER_TB2_G_00_tab2_g_13_shift                          (28)
#define HDMI_DITHER_TB2_G_00_tab2_g_12_shift                          (24)
#define HDMI_DITHER_TB2_G_00_tab2_g_11_shift                          (20)
#define HDMI_DITHER_TB2_G_00_tab2_g_10_shift                          (16)
#define HDMI_DITHER_TB2_G_00_tab2_g_03_shift                          (12)
#define HDMI_DITHER_TB2_G_00_tab2_g_02_shift                          (8)
#define HDMI_DITHER_TB2_G_00_tab2_g_01_shift                          (4)
#define HDMI_DITHER_TB2_G_00_tab2_g_00_shift                          (0)
#define HDMI_DITHER_TB2_G_00_tab2_g_13_mask                           (0xF0000000)
#define HDMI_DITHER_TB2_G_00_tab2_g_12_mask                           (0x0F000000)
#define HDMI_DITHER_TB2_G_00_tab2_g_11_mask                           (0x00F00000)
#define HDMI_DITHER_TB2_G_00_tab2_g_10_mask                           (0x000F0000)
#define HDMI_DITHER_TB2_G_00_tab2_g_03_mask                           (0x0000F000)
#define HDMI_DITHER_TB2_G_00_tab2_g_02_mask                           (0x00000F00)
#define HDMI_DITHER_TB2_G_00_tab2_g_01_mask                           (0x000000F0)
#define HDMI_DITHER_TB2_G_00_tab2_g_00_mask                           (0x0000000F)
#define HDMI_DITHER_TB2_G_00_tab2_g_13(data)                          (0xF0000000&((data)<<28))
#define HDMI_DITHER_TB2_G_00_tab2_g_12(data)                          (0x0F000000&((data)<<24))
#define HDMI_DITHER_TB2_G_00_tab2_g_11(data)                          (0x00F00000&((data)<<20))
#define HDMI_DITHER_TB2_G_00_tab2_g_10(data)                          (0x000F0000&((data)<<16))
#define HDMI_DITHER_TB2_G_00_tab2_g_03(data)                          (0x0000F000&((data)<<12))
#define HDMI_DITHER_TB2_G_00_tab2_g_02(data)                          (0x00000F00&((data)<<8))
#define HDMI_DITHER_TB2_G_00_tab2_g_01(data)                          (0x000000F0&((data)<<4))
#define HDMI_DITHER_TB2_G_00_tab2_g_00(data)                          (0x0000000F&(data))
#define HDMI_DITHER_TB2_G_00_get_tab2_g_13(data)                      ((0xF0000000&(data))>>28)
#define HDMI_DITHER_TB2_G_00_get_tab2_g_12(data)                      ((0x0F000000&(data))>>24)
#define HDMI_DITHER_TB2_G_00_get_tab2_g_11(data)                      ((0x00F00000&(data))>>20)
#define HDMI_DITHER_TB2_G_00_get_tab2_g_10(data)                      ((0x000F0000&(data))>>16)
#define HDMI_DITHER_TB2_G_00_get_tab2_g_03(data)                      ((0x0000F000&(data))>>12)
#define HDMI_DITHER_TB2_G_00_get_tab2_g_02(data)                      ((0x00000F00&(data))>>8)
#define HDMI_DITHER_TB2_G_00_get_tab2_g_01(data)                      ((0x000000F0&(data))>>4)
#define HDMI_DITHER_TB2_G_00_get_tab2_g_00(data)                      (0x0000000F&(data))


#define HDMI_DITHER_TB2_G_02                                          0x18025a44
#define HDMI_DITHER_TB2_G_02_reg_addr                                 "0xb8025a44"
#define HDMI_DITHER_TB2_G_02_reg                                      0xb8025a44
#define HDMI_DITHER_TB2_G_02_inst_addr                                "0x0291"
#define HDMI_DITHER_TB2_G_02_inst                                     0x0291
#define HDMI_DITHER_TB2_G_02_tab2_g_33_shift                          (28)
#define HDMI_DITHER_TB2_G_02_tab2_g_32_shift                          (24)
#define HDMI_DITHER_TB2_G_02_tab2_g_31_shift                          (20)
#define HDMI_DITHER_TB2_G_02_tab2_g_30_shift                          (16)
#define HDMI_DITHER_TB2_G_02_tab2_g_23_shift                          (12)
#define HDMI_DITHER_TB2_G_02_tab2_g_22_shift                          (8)
#define HDMI_DITHER_TB2_G_02_tab2_g_21_shift                          (4)
#define HDMI_DITHER_TB2_G_02_tab2_g_20_shift                          (0)
#define HDMI_DITHER_TB2_G_02_tab2_g_33_mask                           (0xF0000000)
#define HDMI_DITHER_TB2_G_02_tab2_g_32_mask                           (0x0F000000)
#define HDMI_DITHER_TB2_G_02_tab2_g_31_mask                           (0x00F00000)
#define HDMI_DITHER_TB2_G_02_tab2_g_30_mask                           (0x000F0000)
#define HDMI_DITHER_TB2_G_02_tab2_g_23_mask                           (0x0000F000)
#define HDMI_DITHER_TB2_G_02_tab2_g_22_mask                           (0x00000F00)
#define HDMI_DITHER_TB2_G_02_tab2_g_21_mask                           (0x000000F0)
#define HDMI_DITHER_TB2_G_02_tab2_g_20_mask                           (0x0000000F)
#define HDMI_DITHER_TB2_G_02_tab2_g_33(data)                          (0xF0000000&((data)<<28))
#define HDMI_DITHER_TB2_G_02_tab2_g_32(data)                          (0x0F000000&((data)<<24))
#define HDMI_DITHER_TB2_G_02_tab2_g_31(data)                          (0x00F00000&((data)<<20))
#define HDMI_DITHER_TB2_G_02_tab2_g_30(data)                          (0x000F0000&((data)<<16))
#define HDMI_DITHER_TB2_G_02_tab2_g_23(data)                          (0x0000F000&((data)<<12))
#define HDMI_DITHER_TB2_G_02_tab2_g_22(data)                          (0x00000F00&((data)<<8))
#define HDMI_DITHER_TB2_G_02_tab2_g_21(data)                          (0x000000F0&((data)<<4))
#define HDMI_DITHER_TB2_G_02_tab2_g_20(data)                          (0x0000000F&(data))
#define HDMI_DITHER_TB2_G_02_get_tab2_g_33(data)                      ((0xF0000000&(data))>>28)
#define HDMI_DITHER_TB2_G_02_get_tab2_g_32(data)                      ((0x0F000000&(data))>>24)
#define HDMI_DITHER_TB2_G_02_get_tab2_g_31(data)                      ((0x00F00000&(data))>>20)
#define HDMI_DITHER_TB2_G_02_get_tab2_g_30(data)                      ((0x000F0000&(data))>>16)
#define HDMI_DITHER_TB2_G_02_get_tab2_g_23(data)                      ((0x0000F000&(data))>>12)
#define HDMI_DITHER_TB2_G_02_get_tab2_g_22(data)                      ((0x00000F00&(data))>>8)
#define HDMI_DITHER_TB2_G_02_get_tab2_g_21(data)                      ((0x000000F0&(data))>>4)
#define HDMI_DITHER_TB2_G_02_get_tab2_g_20(data)                      (0x0000000F&(data))


#define HDMI_DITHER_TB2_B_00                                          0x18025a48
#define HDMI_DITHER_TB2_B_00_reg_addr                                 "0xb8025a48"
#define HDMI_DITHER_TB2_B_00_reg                                      0xb8025a48
#define HDMI_DITHER_TB2_B_00_inst_addr                                "0x0292"
#define HDMI_DITHER_TB2_B_00_inst                                     0x0292
#define HDMI_DITHER_TB2_B_00_tab2_b_13_shift                          (28)
#define HDMI_DITHER_TB2_B_00_tab2_b_12_shift                          (24)
#define HDMI_DITHER_TB2_B_00_tab2_b_11_shift                          (20)
#define HDMI_DITHER_TB2_B_00_tab2_b_10_shift                          (16)
#define HDMI_DITHER_TB2_B_00_tab2_b_03_shift                          (12)
#define HDMI_DITHER_TB2_B_00_tab2_b_02_shift                          (8)
#define HDMI_DITHER_TB2_B_00_tab2_b_01_shift                          (4)
#define HDMI_DITHER_TB2_B_00_tab2_b_00_shift                          (0)
#define HDMI_DITHER_TB2_B_00_tab2_b_13_mask                           (0xF0000000)
#define HDMI_DITHER_TB2_B_00_tab2_b_12_mask                           (0x0F000000)
#define HDMI_DITHER_TB2_B_00_tab2_b_11_mask                           (0x00F00000)
#define HDMI_DITHER_TB2_B_00_tab2_b_10_mask                           (0x000F0000)
#define HDMI_DITHER_TB2_B_00_tab2_b_03_mask                           (0x0000F000)
#define HDMI_DITHER_TB2_B_00_tab2_b_02_mask                           (0x00000F00)
#define HDMI_DITHER_TB2_B_00_tab2_b_01_mask                           (0x000000F0)
#define HDMI_DITHER_TB2_B_00_tab2_b_00_mask                           (0x0000000F)
#define HDMI_DITHER_TB2_B_00_tab2_b_13(data)                          (0xF0000000&((data)<<28))
#define HDMI_DITHER_TB2_B_00_tab2_b_12(data)                          (0x0F000000&((data)<<24))
#define HDMI_DITHER_TB2_B_00_tab2_b_11(data)                          (0x00F00000&((data)<<20))
#define HDMI_DITHER_TB2_B_00_tab2_b_10(data)                          (0x000F0000&((data)<<16))
#define HDMI_DITHER_TB2_B_00_tab2_b_03(data)                          (0x0000F000&((data)<<12))
#define HDMI_DITHER_TB2_B_00_tab2_b_02(data)                          (0x00000F00&((data)<<8))
#define HDMI_DITHER_TB2_B_00_tab2_b_01(data)                          (0x000000F0&((data)<<4))
#define HDMI_DITHER_TB2_B_00_tab2_b_00(data)                          (0x0000000F&(data))
#define HDMI_DITHER_TB2_B_00_get_tab2_b_13(data)                      ((0xF0000000&(data))>>28)
#define HDMI_DITHER_TB2_B_00_get_tab2_b_12(data)                      ((0x0F000000&(data))>>24)
#define HDMI_DITHER_TB2_B_00_get_tab2_b_11(data)                      ((0x00F00000&(data))>>20)
#define HDMI_DITHER_TB2_B_00_get_tab2_b_10(data)                      ((0x000F0000&(data))>>16)
#define HDMI_DITHER_TB2_B_00_get_tab2_b_03(data)                      ((0x0000F000&(data))>>12)
#define HDMI_DITHER_TB2_B_00_get_tab2_b_02(data)                      ((0x00000F00&(data))>>8)
#define HDMI_DITHER_TB2_B_00_get_tab2_b_01(data)                      ((0x000000F0&(data))>>4)
#define HDMI_DITHER_TB2_B_00_get_tab2_b_00(data)                      (0x0000000F&(data))


#define HDMI_DITHER_TB2_B_02                                          0x18025a4c
#define HDMI_DITHER_TB2_B_02_reg_addr                                 "0xb8025a4c"
#define HDMI_DITHER_TB2_B_02_reg                                      0xb8025a4c
#define HDMI_DITHER_TB2_B_02_inst_addr                                "0x0293"
#define HDMI_DITHER_TB2_B_02_inst                                     0x0293
#define HDMI_DITHER_TB2_B_02_tab2_b_33_shift                          (28)
#define HDMI_DITHER_TB2_B_02_tab2_b_32_shift                          (24)
#define HDMI_DITHER_TB2_B_02_tab2_b_31_shift                          (20)
#define HDMI_DITHER_TB2_B_02_tab2_b_30_shift                          (16)
#define HDMI_DITHER_TB2_B_02_tab2_b_23_shift                          (12)
#define HDMI_DITHER_TB2_B_02_tab2_b_22_shift                          (8)
#define HDMI_DITHER_TB2_B_02_tab2_b_21_shift                          (4)
#define HDMI_DITHER_TB2_B_02_tab2_b_20_shift                          (0)
#define HDMI_DITHER_TB2_B_02_tab2_b_33_mask                           (0xF0000000)
#define HDMI_DITHER_TB2_B_02_tab2_b_32_mask                           (0x0F000000)
#define HDMI_DITHER_TB2_B_02_tab2_b_31_mask                           (0x00F00000)
#define HDMI_DITHER_TB2_B_02_tab2_b_30_mask                           (0x000F0000)
#define HDMI_DITHER_TB2_B_02_tab2_b_23_mask                           (0x0000F000)
#define HDMI_DITHER_TB2_B_02_tab2_b_22_mask                           (0x00000F00)
#define HDMI_DITHER_TB2_B_02_tab2_b_21_mask                           (0x000000F0)
#define HDMI_DITHER_TB2_B_02_tab2_b_20_mask                           (0x0000000F)
#define HDMI_DITHER_TB2_B_02_tab2_b_33(data)                          (0xF0000000&((data)<<28))
#define HDMI_DITHER_TB2_B_02_tab2_b_32(data)                          (0x0F000000&((data)<<24))
#define HDMI_DITHER_TB2_B_02_tab2_b_31(data)                          (0x00F00000&((data)<<20))
#define HDMI_DITHER_TB2_B_02_tab2_b_30(data)                          (0x000F0000&((data)<<16))
#define HDMI_DITHER_TB2_B_02_tab2_b_23(data)                          (0x0000F000&((data)<<12))
#define HDMI_DITHER_TB2_B_02_tab2_b_22(data)                          (0x00000F00&((data)<<8))
#define HDMI_DITHER_TB2_B_02_tab2_b_21(data)                          (0x000000F0&((data)<<4))
#define HDMI_DITHER_TB2_B_02_tab2_b_20(data)                          (0x0000000F&(data))
#define HDMI_DITHER_TB2_B_02_get_tab2_b_33(data)                      ((0xF0000000&(data))>>28)
#define HDMI_DITHER_TB2_B_02_get_tab2_b_32(data)                      ((0x0F000000&(data))>>24)
#define HDMI_DITHER_TB2_B_02_get_tab2_b_31(data)                      ((0x00F00000&(data))>>20)
#define HDMI_DITHER_TB2_B_02_get_tab2_b_30(data)                      ((0x000F0000&(data))>>16)
#define HDMI_DITHER_TB2_B_02_get_tab2_b_23(data)                      ((0x0000F000&(data))>>12)
#define HDMI_DITHER_TB2_B_02_get_tab2_b_22(data)                      ((0x00000F00&(data))>>8)
#define HDMI_DITHER_TB2_B_02_get_tab2_b_21(data)                      ((0x000000F0&(data))>>4)
#define HDMI_DITHER_TB2_B_02_get_tab2_b_20(data)                      (0x0000000F&(data))


#define HDMI_DITHER_TEMP_TB2                                          0x18025a50
#define HDMI_DITHER_TEMP_TB2_reg_addr                                 "0xb8025a50"
#define HDMI_DITHER_TEMP_TB2_reg                                      0xb8025a50
#define HDMI_DITHER_TEMP_TB2_inst_addr                                "0x0294"
#define HDMI_DITHER_TEMP_TB2_inst                                     0x0294
#define HDMI_DITHER_TEMP_TB2_tab2_temp_offset_15_shift                (30)
#define HDMI_DITHER_TEMP_TB2_tab2_temp_offset_14_shift                (28)
#define HDMI_DITHER_TEMP_TB2_tab2_temp_offset_13_shift                (26)
#define HDMI_DITHER_TEMP_TB2_tab2_temp_offset_12_shift                (24)
#define HDMI_DITHER_TEMP_TB2_tab2_temp_offset_11_shift                (22)
#define HDMI_DITHER_TEMP_TB2_tab2_temp_offset_10_shift                (20)
#define HDMI_DITHER_TEMP_TB2_tab2_temp_offset_9_shift                 (18)
#define HDMI_DITHER_TEMP_TB2_tab2_temp_offset_8_shift                 (16)
#define HDMI_DITHER_TEMP_TB2_tab2_temp_offset_7_shift                 (14)
#define HDMI_DITHER_TEMP_TB2_tab2_temp_offset_6_shift                 (12)
#define HDMI_DITHER_TEMP_TB2_tab2_temp_offset_5_shift                 (10)
#define HDMI_DITHER_TEMP_TB2_tab2_temp_offset_4_shift                 (8)
#define HDMI_DITHER_TEMP_TB2_tab2_temp_offset_3_shift                 (6)
#define HDMI_DITHER_TEMP_TB2_tab2_temp_offset_2_shift                 (4)
#define HDMI_DITHER_TEMP_TB2_tab2_temp_offset_1_shift                 (2)
#define HDMI_DITHER_TEMP_TB2_tab2_temp_offset_0_shift                 (0)
#define HDMI_DITHER_TEMP_TB2_tab2_temp_offset_15_mask                 (0xC0000000)
#define HDMI_DITHER_TEMP_TB2_tab2_temp_offset_14_mask                 (0x30000000)
#define HDMI_DITHER_TEMP_TB2_tab2_temp_offset_13_mask                 (0x0C000000)
#define HDMI_DITHER_TEMP_TB2_tab2_temp_offset_12_mask                 (0x03000000)
#define HDMI_DITHER_TEMP_TB2_tab2_temp_offset_11_mask                 (0x00C00000)
#define HDMI_DITHER_TEMP_TB2_tab2_temp_offset_10_mask                 (0x00300000)
#define HDMI_DITHER_TEMP_TB2_tab2_temp_offset_9_mask                  (0x000C0000)
#define HDMI_DITHER_TEMP_TB2_tab2_temp_offset_8_mask                  (0x00030000)
#define HDMI_DITHER_TEMP_TB2_tab2_temp_offset_7_mask                  (0x0000C000)
#define HDMI_DITHER_TEMP_TB2_tab2_temp_offset_6_mask                  (0x00003000)
#define HDMI_DITHER_TEMP_TB2_tab2_temp_offset_5_mask                  (0x00000C00)
#define HDMI_DITHER_TEMP_TB2_tab2_temp_offset_4_mask                  (0x00000300)
#define HDMI_DITHER_TEMP_TB2_tab2_temp_offset_3_mask                  (0x000000C0)
#define HDMI_DITHER_TEMP_TB2_tab2_temp_offset_2_mask                  (0x00000030)
#define HDMI_DITHER_TEMP_TB2_tab2_temp_offset_1_mask                  (0x0000000C)
#define HDMI_DITHER_TEMP_TB2_tab2_temp_offset_0_mask                  (0x00000003)
#define HDMI_DITHER_TEMP_TB2_tab2_temp_offset_15(data)                (0xC0000000&((data)<<30))
#define HDMI_DITHER_TEMP_TB2_tab2_temp_offset_14(data)                (0x30000000&((data)<<28))
#define HDMI_DITHER_TEMP_TB2_tab2_temp_offset_13(data)                (0x0C000000&((data)<<26))
#define HDMI_DITHER_TEMP_TB2_tab2_temp_offset_12(data)                (0x03000000&((data)<<24))
#define HDMI_DITHER_TEMP_TB2_tab2_temp_offset_11(data)                (0x00C00000&((data)<<22))
#define HDMI_DITHER_TEMP_TB2_tab2_temp_offset_10(data)                (0x00300000&((data)<<20))
#define HDMI_DITHER_TEMP_TB2_tab2_temp_offset_9(data)                 (0x000C0000&((data)<<18))
#define HDMI_DITHER_TEMP_TB2_tab2_temp_offset_8(data)                 (0x00030000&((data)<<16))
#define HDMI_DITHER_TEMP_TB2_tab2_temp_offset_7(data)                 (0x0000C000&((data)<<14))
#define HDMI_DITHER_TEMP_TB2_tab2_temp_offset_6(data)                 (0x00003000&((data)<<12))
#define HDMI_DITHER_TEMP_TB2_tab2_temp_offset_5(data)                 (0x00000C00&((data)<<10))
#define HDMI_DITHER_TEMP_TB2_tab2_temp_offset_4(data)                 (0x00000300&((data)<<8))
#define HDMI_DITHER_TEMP_TB2_tab2_temp_offset_3(data)                 (0x000000C0&((data)<<6))
#define HDMI_DITHER_TEMP_TB2_tab2_temp_offset_2(data)                 (0x00000030&((data)<<4))
#define HDMI_DITHER_TEMP_TB2_tab2_temp_offset_1(data)                 (0x0000000C&((data)<<2))
#define HDMI_DITHER_TEMP_TB2_tab2_temp_offset_0(data)                 (0x00000003&(data))
#define HDMI_DITHER_TEMP_TB2_get_tab2_temp_offset_15(data)            ((0xC0000000&(data))>>30)
#define HDMI_DITHER_TEMP_TB2_get_tab2_temp_offset_14(data)            ((0x30000000&(data))>>28)
#define HDMI_DITHER_TEMP_TB2_get_tab2_temp_offset_13(data)            ((0x0C000000&(data))>>26)
#define HDMI_DITHER_TEMP_TB2_get_tab2_temp_offset_12(data)            ((0x03000000&(data))>>24)
#define HDMI_DITHER_TEMP_TB2_get_tab2_temp_offset_11(data)            ((0x00C00000&(data))>>22)
#define HDMI_DITHER_TEMP_TB2_get_tab2_temp_offset_10(data)            ((0x00300000&(data))>>20)
#define HDMI_DITHER_TEMP_TB2_get_tab2_temp_offset_9(data)             ((0x000C0000&(data))>>18)
#define HDMI_DITHER_TEMP_TB2_get_tab2_temp_offset_8(data)             ((0x00030000&(data))>>16)
#define HDMI_DITHER_TEMP_TB2_get_tab2_temp_offset_7(data)             ((0x0000C000&(data))>>14)
#define HDMI_DITHER_TEMP_TB2_get_tab2_temp_offset_6(data)             ((0x00003000&(data))>>12)
#define HDMI_DITHER_TEMP_TB2_get_tab2_temp_offset_5(data)             ((0x00000C00&(data))>>10)
#define HDMI_DITHER_TEMP_TB2_get_tab2_temp_offset_4(data)             ((0x00000300&(data))>>8)
#define HDMI_DITHER_TEMP_TB2_get_tab2_temp_offset_3(data)             ((0x000000C0&(data))>>6)
#define HDMI_DITHER_TEMP_TB2_get_tab2_temp_offset_2(data)             ((0x00000030&(data))>>4)
#define HDMI_DITHER_TEMP_TB2_get_tab2_temp_offset_1(data)             ((0x0000000C&(data))>>2)
#define HDMI_DITHER_TEMP_TB2_get_tab2_temp_offset_0(data)             (0x00000003&(data))

// HDMI RGB2YUV
#define HDMI_RGB2YUV_CTRL                                             0x18025a80
#define HDMI_RGB2YUV_CTRL_reg_addr                                    "0xb8025a80"
#define HDMI_RGB2YUV_CTRL_reg                                         0xb8025a80
#define HDMI_RGB2YUV_CTRL_inst_addr                                   "0x02A0"
#define HDMI_RGB2YUV_CTRL_inst                                        0x02A0
#define HDMI_RGB2YUV_CTRL_err_dif_bit_sel_shift                       (12)
#define HDMI_RGB2YUV_CTRL_err_dif_en_shift                            (11)
#define HDMI_RGB2YUV_CTRL_sel_2x_gain_shift                           (10)
#define HDMI_RGB2YUV_CTRL_sel_y_gain_shift                            (9)
#define HDMI_RGB2YUV_CTRL_matrix_bypass_shift                         (8)
#define HDMI_RGB2YUV_CTRL_sel_uv_off_shift                            (7)
#define HDMI_RGB2YUV_CTRL_set_uv_out_offset_shift                     (6)
#define HDMI_RGB2YUV_CTRL_set_r_in_offset_shift                       (5)
#define HDMI_RGB2YUV_CTRL_sel_rgb_shift                               (4)
#define HDMI_RGB2YUV_CTRL_sel_sign_shift                              (3)
#define HDMI_RGB2YUV_CTRL_en_rgb2yuv_shift                            (0)
#define HDMI_RGB2YUV_CTRL_err_dif_bit_sel_mask                        (0x00001000)
#define HDMI_RGB2YUV_CTRL_err_dif_en_mask                             (0x00000800)
#define HDMI_RGB2YUV_CTRL_sel_2x_gain_mask                            (0x00000400)
#define HDMI_RGB2YUV_CTRL_sel_y_gain_mask                             (0x00000200)
#define HDMI_RGB2YUV_CTRL_matrix_bypass_mask                          (0x00000100)
#define HDMI_RGB2YUV_CTRL_sel_uv_off_mask                             (0x00000080)
#define HDMI_RGB2YUV_CTRL_set_uv_out_offset_mask                      (0x00000040)
#define HDMI_RGB2YUV_CTRL_set_r_in_offset_mask                        (0x00000020)
#define HDMI_RGB2YUV_CTRL_sel_rgb_mask                                (0x00000010)
#define HDMI_RGB2YUV_CTRL_sel_sign_mask                               (0x00000008)
#define HDMI_RGB2YUV_CTRL_en_rgb2yuv_mask                             (0x00000003)
#define HDMI_RGB2YUV_CTRL_err_dif_bit_sel(data)                       (0x00001000&((data)<<12))
#define HDMI_RGB2YUV_CTRL_err_dif_en(data)                            (0x00000800&((data)<<11))
#define HDMI_RGB2YUV_CTRL_sel_2x_gain(data)                           (0x00000400&((data)<<10))
#define HDMI_RGB2YUV_CTRL_sel_y_gain(data)                            (0x00000200&((data)<<9))
#define HDMI_RGB2YUV_CTRL_matrix_bypass(data)                         (0x00000100&((data)<<8))
#define HDMI_RGB2YUV_CTRL_sel_uv_off(data)                            (0x00000080&((data)<<7))
#define HDMI_RGB2YUV_CTRL_set_uv_out_offset(data)                     (0x00000040&((data)<<6))
#define HDMI_RGB2YUV_CTRL_set_r_in_offset(data)                       (0x00000020&((data)<<5))
#define HDMI_RGB2YUV_CTRL_sel_rgb(data)                               (0x00000010&((data)<<4))
#define HDMI_RGB2YUV_CTRL_sel_sign(data)                              (0x00000008&((data)<<3))
#define HDMI_RGB2YUV_CTRL_en_rgb2yuv(data)                            (0x00000003&(data))
#define HDMI_RGB2YUV_CTRL_get_err_dif_bit_sel(data)                   ((0x00001000&(data))>>12)
#define HDMI_RGB2YUV_CTRL_get_err_dif_en(data)                        ((0x00000800&(data))>>11)
#define HDMI_RGB2YUV_CTRL_get_sel_2x_gain(data)                       ((0x00000400&(data))>>10)
#define HDMI_RGB2YUV_CTRL_get_sel_y_gain(data)                        ((0x00000200&(data))>>9)
#define HDMI_RGB2YUV_CTRL_get_matrix_bypass(data)                     ((0x00000100&(data))>>8)
#define HDMI_RGB2YUV_CTRL_get_sel_uv_off(data)                        ((0x00000080&(data))>>7)
#define HDMI_RGB2YUV_CTRL_get_set_uv_out_offset(data)                 ((0x00000040&(data))>>6)
#define HDMI_RGB2YUV_CTRL_get_set_r_in_offset(data)                   ((0x00000020&(data))>>5)
#define HDMI_RGB2YUV_CTRL_get_sel_rgb(data)                           ((0x00000010&(data))>>4)
#define HDMI_RGB2YUV_CTRL_get_sel_sign(data)                          ((0x00000008&(data))>>3)
#define HDMI_RGB2YUV_CTRL_get_en_rgb2yuv(data)                        (0x00000003&(data))


#define HDMI_RGB2YUV_TAB1_M1                                          0x18025a84
#define HDMI_RGB2YUV_TAB1_M1_reg_addr                                 "0xb8025a84"
#define HDMI_RGB2YUV_TAB1_M1_reg                                      0xb8025a84
#define HDMI_RGB2YUV_TAB1_M1_inst_addr                                "0x02A1"
#define HDMI_RGB2YUV_TAB1_M1_inst                                     0x02A1
#define HDMI_RGB2YUV_TAB1_M1_m13_shift                                (21)
#define HDMI_RGB2YUV_TAB1_M1_m12_shift                                (11)
#define HDMI_RGB2YUV_TAB1_M1_m11_shift                                (0)
#define HDMI_RGB2YUV_TAB1_M1_m13_mask                                 (0xFFE00000)
#define HDMI_RGB2YUV_TAB1_M1_m12_mask                                 (0x001FF800)
#define HDMI_RGB2YUV_TAB1_M1_m11_mask                                 (0x000007FF)
#define HDMI_RGB2YUV_TAB1_M1_m13(data)                                (0xFFE00000&((data)<<21))
#define HDMI_RGB2YUV_TAB1_M1_m12(data)                                (0x001FF800&((data)<<11))
#define HDMI_RGB2YUV_TAB1_M1_m11(data)                                (0x000007FF&(data))
#define HDMI_RGB2YUV_TAB1_M1_get_m13(data)                            ((0xFFE00000&(data))>>21)
#define HDMI_RGB2YUV_TAB1_M1_get_m12(data)                            ((0x001FF800&(data))>>11)
#define HDMI_RGB2YUV_TAB1_M1_get_m11(data)                            (0x000007FF&(data))


#define HDMI_RGB2YUV_TAB1_M2                                          0x18025a88
#define HDMI_RGB2YUV_TAB1_M2_reg_addr                                 "0xb8025a88"
#define HDMI_RGB2YUV_TAB1_M2_reg                                      0xb8025a88
#define HDMI_RGB2YUV_TAB1_M2_inst_addr                                "0x02A2"
#define HDMI_RGB2YUV_TAB1_M2_inst                                     0x02A2
#define HDMI_RGB2YUV_TAB1_M2_m23_shift                                (20)
#define HDMI_RGB2YUV_TAB1_M2_m22_shift                                (10)
#define HDMI_RGB2YUV_TAB1_M2_m21_shift                                (0)
#define HDMI_RGB2YUV_TAB1_M2_m23_mask                                 (0x1FF00000)
#define HDMI_RGB2YUV_TAB1_M2_m22_mask                                 (0x000FFC00)
#define HDMI_RGB2YUV_TAB1_M2_m21_mask                                 (0x000003FF)
#define HDMI_RGB2YUV_TAB1_M2_m23(data)                                (0x1FF00000&((data)<<20))
#define HDMI_RGB2YUV_TAB1_M2_m22(data)                                (0x000FFC00&((data)<<10))
#define HDMI_RGB2YUV_TAB1_M2_m21(data)                                (0x000003FF&(data))
#define HDMI_RGB2YUV_TAB1_M2_get_m23(data)                            ((0x1FF00000&(data))>>20)
#define HDMI_RGB2YUV_TAB1_M2_get_m22(data)                            ((0x000FFC00&(data))>>10)
#define HDMI_RGB2YUV_TAB1_M2_get_m21(data)                            (0x000003FF&(data))


#define HDMI_RGB2YUV_TAB1_M3                                          0x18025a8c
#define HDMI_RGB2YUV_TAB1_M3_reg_addr                                 "0xb8025a8c"
#define HDMI_RGB2YUV_TAB1_M3_reg                                      0xb8025a8c
#define HDMI_RGB2YUV_TAB1_M3_inst_addr                                "0x02A3"
#define HDMI_RGB2YUV_TAB1_M3_inst                                     0x02A3
#define HDMI_RGB2YUV_TAB1_M3_m33_shift                                (21)
#define HDMI_RGB2YUV_TAB1_M3_m32_shift                                (10)
#define HDMI_RGB2YUV_TAB1_M3_m31_shift                                (0)
#define HDMI_RGB2YUV_TAB1_M3_m33_mask                                 (0x7FE00000)
#define HDMI_RGB2YUV_TAB1_M3_m32_mask                                 (0x001FFC00)
#define HDMI_RGB2YUV_TAB1_M3_m31_mask                                 (0x000003FF)
#define HDMI_RGB2YUV_TAB1_M3_m33(data)                                (0x7FE00000&((data)<<21))
#define HDMI_RGB2YUV_TAB1_M3_m32(data)                                (0x001FFC00&((data)<<10))
#define HDMI_RGB2YUV_TAB1_M3_m31(data)                                (0x000003FF&(data))
#define HDMI_RGB2YUV_TAB1_M3_get_m33(data)                            ((0x7FE00000&(data))>>21)
#define HDMI_RGB2YUV_TAB1_M3_get_m32(data)                            ((0x001FFC00&(data))>>10)
#define HDMI_RGB2YUV_TAB1_M3_get_m31(data)                            (0x000003FF&(data))


#define HDMI_RGB2YUV_TAB1_Y                                           0x18025a90
#define HDMI_RGB2YUV_TAB1_Y_reg_addr                                  "0xb8025a90"
#define HDMI_RGB2YUV_TAB1_Y_reg                                       0xb8025a90
#define HDMI_RGB2YUV_TAB1_Y_inst_addr                                 "0x02A4"
#define HDMI_RGB2YUV_TAB1_Y_inst                                      0x02A4
#define HDMI_RGB2YUV_TAB1_Y_yo_gain_shift                             (22)
#define HDMI_RGB2YUV_TAB1_Y_yo_shift                                  (0)
#define HDMI_RGB2YUV_TAB1_Y_yo_gain_mask                              (0x7FC00000)
#define HDMI_RGB2YUV_TAB1_Y_yo_mask                                   (0x000007FF)
#define HDMI_RGB2YUV_TAB1_Y_yo_gain(data)                             (0x7FC00000&((data)<<22))
#define HDMI_RGB2YUV_TAB1_Y_yo(data)                                  (0x000007FF&(data))
#define HDMI_RGB2YUV_TAB1_Y_get_yo_gain(data)                         ((0x7FC00000&(data))>>22)
#define HDMI_RGB2YUV_TAB1_Y_get_yo(data)                              (0x000007FF&(data))


#define HDMI_4XXTO4XX_CTRL                                            0x18025ad0
#define HDMI_4XXTO4XX_CTRL_reg_addr                                   "0xb8025ad0"
#define HDMI_4XXTO4XX_CTRL_reg                                        0xb8025ad0
#define HDMI_4XXTO4XX_CTRL_inst_addr                                  "0x02B4"
#define HDMI_4XXTO4XX_CTRL_inst                                       0x02B4
#define HDMI_4XXTO4XX_CTRL_yuv_4xxto4xx_sel_shift                     (0)
#define HDMI_4XXTO4XX_CTRL_yuv_4xxto4xx_sel_mask                      (0x00000003)
#define HDMI_4XXTO4XX_CTRL_yuv_4xxto4xx_sel(data)                     (0x00000003&(data))
#define HDMI_4XXTO4XX_CTRL_get_yuv_4xxto4xx_sel(data)                 (0x00000003&(data))
// END of Magellan-DesignSpec-IDMA_HDMI_rgb2yuv_dither_4xxto4xx.doc



#define HDMI_HAVE_PTG 0
#if HDMI_HAVE_PTG
#define HDMI_PTG_TOTALHV                                              0x1800d500
#define HDMI_PTG_TOTALHV_reg_addr                                     "0xb800d500"
#define HDMI_PTG_TOTALHV_reg                                          0xb800d500
#define HDMI_PTG_TOTALHV_inst_addr                                    "0x0140"
#define HDMI_PTG_TOTALHV_inst                                         0x0140
#define HDMI_PTG_TOTALHV_totalh_pixel_shift                           (16)
#define HDMI_PTG_TOTALHV_dummy1800d500_15_13_shift                    (13)
#define HDMI_PTG_TOTALHV_totalv_line_shift                            (0)
#define HDMI_PTG_TOTALHV_totalh_pixel_mask                            (0x1FFF0000)
#define HDMI_PTG_TOTALHV_dummy1800d500_15_13_mask                     (0x0000E000)
#define HDMI_PTG_TOTALHV_totalv_line_mask                             (0x00001FFF)
#define HDMI_PTG_TOTALHV_totalh_pixel(data)                           (0x1FFF0000&((data)<<16))
#define HDMI_PTG_TOTALHV_dummy1800d500_15_13(data)                    (0x0000E000&((data)<<13))
#define HDMI_PTG_TOTALHV_totalv_line(data)                            (0x00001FFF&(data))
#define HDMI_PTG_TOTALHV_get_totalh_pixel(data)                       ((0x1FFF0000&(data))>>16)
#define HDMI_PTG_TOTALHV_get_dummy1800d500_15_13(data)                ((0x0000E000&(data))>>13)
#define HDMI_PTG_TOTALHV_get_totalv_line(data)                        (0x00001FFF&(data))


#define HDMI_PTG_ACT_H_START_WIDTH                                    0x1800d504
#define HDMI_PTG_ACT_H_START_WIDTH_reg_addr                           "0xb800d504"
#define HDMI_PTG_ACT_H_START_WIDTH_reg                                0xb800d504
#define HDMI_PTG_ACT_H_START_WIDTH_inst_addr                          "0x0141"
#define HDMI_PTG_ACT_H_START_WIDTH_inst                               0x0141
#define HDMI_PTG_ACT_H_START_WIDTH_act_h_sta_shift                    (16)
#define HDMI_PTG_ACT_H_START_WIDTH_dummy1800d504_15_13_shift          (13)
#define HDMI_PTG_ACT_H_START_WIDTH_act_wid_shift                      (0)
#define HDMI_PTG_ACT_H_START_WIDTH_act_h_sta_mask                     (0x1FFF0000)
#define HDMI_PTG_ACT_H_START_WIDTH_dummy1800d504_15_13_mask           (0x0000E000)
#define HDMI_PTG_ACT_H_START_WIDTH_act_wid_mask                       (0x00001FFF)
#define HDMI_PTG_ACT_H_START_WIDTH_act_h_sta(data)                    (0x1FFF0000&((data)<<16))
#define HDMI_PTG_ACT_H_START_WIDTH_dummy1800d504_15_13(data)          (0x0000E000&((data)<<13))
#define HDMI_PTG_ACT_H_START_WIDTH_act_wid(data)                      (0x00001FFF&(data))
#define HDMI_PTG_ACT_H_START_WIDTH_get_act_h_sta(data)                ((0x1FFF0000&(data))>>16)
#define HDMI_PTG_ACT_H_START_WIDTH_get_dummy1800d504_15_13(data)      ((0x0000E000&(data))>>13)
#define HDMI_PTG_ACT_H_START_WIDTH_get_act_wid(data)                  (0x00001FFF&(data))


#define HDMI_PTG_ACT_V_START_LENGTH                                   0x1800d508
#define HDMI_PTG_ACT_V_START_LENGTH_reg_addr                          "0xb800d508"
#define HDMI_PTG_ACT_V_START_LENGTH_reg                               0xb800d508
#define HDMI_PTG_ACT_V_START_LENGTH_inst_addr                         "0x0142"
#define HDMI_PTG_ACT_V_START_LENGTH_inst                              0x0142
#define HDMI_PTG_ACT_V_START_LENGTH_act_v_sta_shift                   (16)
#define HDMI_PTG_ACT_V_START_LENGTH_dummy1800d508_15_13_shift         (13)
#define HDMI_PTG_ACT_V_START_LENGTH_act_len_shift                     (0)
#define HDMI_PTG_ACT_V_START_LENGTH_act_v_sta_mask                    (0x1FFF0000)
#define HDMI_PTG_ACT_V_START_LENGTH_dummy1800d508_15_13_mask          (0x0000E000)
#define HDMI_PTG_ACT_V_START_LENGTH_act_len_mask                      (0x00001FFF)
#define HDMI_PTG_ACT_V_START_LENGTH_act_v_sta(data)                   (0x1FFF0000&((data)<<16))
#define HDMI_PTG_ACT_V_START_LENGTH_dummy1800d508_15_13(data)         (0x0000E000&((data)<<13))
#define HDMI_PTG_ACT_V_START_LENGTH_act_len(data)                     (0x00001FFF&(data))
#define HDMI_PTG_ACT_V_START_LENGTH_get_act_v_sta(data)               ((0x1FFF0000&(data))>>16)
#define HDMI_PTG_ACT_V_START_LENGTH_get_dummy1800d508_15_13(data)     ((0x0000E000&(data))>>13)
#define HDMI_PTG_ACT_V_START_LENGTH_get_act_len(data)                 (0x00001FFF&(data))


#define HDMI_PTG_TG                                                   0x1800d50c
#define HDMI_PTG_TG_reg_addr                                          "0xb800d50c"
#define HDMI_PTG_TG_reg                                               0xb800d50c
#define HDMI_PTG_TG_inst_addr                                         "0x0143"
#define HDMI_PTG_TG_inst                                              0x0143
#define HDMI_PTG_TG_sync_timing_sel_shift                             (12)
#define HDMI_PTG_TG_dummy1800d50c_11_10_shift                         (10)
#define HDMI_PTG_TG_hs_highpulse_wid_shift                            (8)
#define HDMI_PTG_TG_dummy1800d50c_7_shift                             (7)
#define HDMI_PTG_TG_fix_l_flag_shift                                  (6)
#define HDMI_PTG_TG_fix_l_flag_en_shift                               (5)
#define HDMI_PTG_TG_active_space_fix_en_shift                         (4)
#define HDMI_PTG_TG_tg_mode_sel_shift                                 (2)
#define HDMI_PTG_TG_tg_en_field_shift                                 (1)
#define HDMI_PTG_TG_tg_enable_shift                                   (0)
#define HDMI_PTG_TG_sync_timing_sel_mask                              (0x00001000)
#define HDMI_PTG_TG_dummy1800d50c_11_10_mask                          (0x00000C00)
#define HDMI_PTG_TG_hs_highpulse_wid_mask                             (0x00000300)
#define HDMI_PTG_TG_dummy1800d50c_7_mask                              (0x00000080)
#define HDMI_PTG_TG_fix_l_flag_mask                                   (0x00000040)
#define HDMI_PTG_TG_fix_l_flag_en_mask                                (0x00000020)
#define HDMI_PTG_TG_active_space_fix_en_mask                          (0x00000010)
#define HDMI_PTG_TG_tg_mode_sel_mask                                  (0x0000000C)
#define HDMI_PTG_TG_tg_en_field_mask                                  (0x00000002)
#define HDMI_PTG_TG_tg_enable_mask                                    (0x00000001)
#define HDMI_PTG_TG_sync_timing_sel(data)                             (0x00001000&((data)<<12))
#define HDMI_PTG_TG_dummy1800d50c_11_10(data)                         (0x00000C00&((data)<<10))
#define HDMI_PTG_TG_hs_highpulse_wid(data)                            (0x00000300&((data)<<8))
#define HDMI_PTG_TG_dummy1800d50c_7(data)                             (0x00000080&((data)<<7))
#define HDMI_PTG_TG_fix_l_flag(data)                                  (0x00000040&((data)<<6))
#define HDMI_PTG_TG_fix_l_flag_en(data)                               (0x00000020&((data)<<5))
#define HDMI_PTG_TG_active_space_fix_en(data)                         (0x00000010&((data)<<4))
#define HDMI_PTG_TG_tg_mode_sel(data)                                 (0x0000000C&((data)<<2))
#define HDMI_PTG_TG_tg_en_field(data)                                 (0x00000002&((data)<<1))
#define HDMI_PTG_TG_tg_enable(data)                                   (0x00000001&(data))
#define HDMI_PTG_TG_get_sync_timing_sel(data)                         ((0x00001000&(data))>>12)
#define HDMI_PTG_TG_get_dummy1800d50c_11_10(data)                     ((0x00000C00&(data))>>10)
#define HDMI_PTG_TG_get_hs_highpulse_wid(data)                        ((0x00000300&(data))>>8)
#define HDMI_PTG_TG_get_dummy1800d50c_7(data)                         ((0x00000080&(data))>>7)
#define HDMI_PTG_TG_get_fix_l_flag(data)                              ((0x00000040&(data))>>6)
#define HDMI_PTG_TG_get_fix_l_flag_en(data)                           ((0x00000020&(data))>>5)
#define HDMI_PTG_TG_get_active_space_fix_en(data)                     ((0x00000010&(data))>>4)
#define HDMI_PTG_TG_get_tg_mode_sel(data)                             ((0x0000000C&(data))>>2)
#define HDMI_PTG_TG_get_tg_en_field(data)                             ((0x00000002&(data))>>1)
#define HDMI_PTG_TG_get_tg_enable(data)                               (0x00000001&(data))


#define HDMI_PTG_TG_LINE                                              0x1800d510
#define HDMI_PTG_TG_LINE_reg_addr                                     "0xb800d510"
#define HDMI_PTG_TG_LINE_reg                                          0xb800d510
#define HDMI_PTG_TG_LINE_inst_addr                                    "0x0144"
#define HDMI_PTG_TG_LINE_inst                                         0x0144
#define HDMI_PTG_TG_LINE_popup_linecnt_shift                          (15)
#define HDMI_PTG_TG_LINE_cur_l_flag_out_shift                         (14)
#define HDMI_PTG_TG_LINE_cur_field_out_shift                          (13)
#define HDMI_PTG_TG_LINE_cur_linecnt_out_shift                        (0)
#define HDMI_PTG_TG_LINE_popup_linecnt_mask                           (0x00008000)
#define HDMI_PTG_TG_LINE_cur_l_flag_out_mask                          (0x00004000)
#define HDMI_PTG_TG_LINE_cur_field_out_mask                           (0x00002000)
#define HDMI_PTG_TG_LINE_cur_linecnt_out_mask                         (0x00001FFF)
#define HDMI_PTG_TG_LINE_popup_linecnt(data)                          (0x00008000&((data)<<15))
#define HDMI_PTG_TG_LINE_cur_l_flag_out(data)                         (0x00004000&((data)<<14))
#define HDMI_PTG_TG_LINE_cur_field_out(data)                          (0x00002000&((data)<<13))
#define HDMI_PTG_TG_LINE_cur_linecnt_out(data)                        (0x00001FFF&(data))
#define HDMI_PTG_TG_LINE_get_popup_linecnt(data)                      ((0x00008000&(data))>>15)
#define HDMI_PTG_TG_LINE_get_cur_l_flag_out(data)                     ((0x00004000&(data))>>14)
#define HDMI_PTG_TG_LINE_get_cur_field_out(data)                      ((0x00002000&(data))>>13)
#define HDMI_PTG_TG_LINE_get_cur_linecnt_out(data)                    (0x00001FFF&(data))


#define HDMI_PTG_PAT_HSTA_WIDTH                                       0x1800d514
#define HDMI_PTG_PAT_HSTA_WIDTH_reg_addr                              "0xb800d514"
#define HDMI_PTG_PAT_HSTA_WIDTH_reg                                   0xb800d514
#define HDMI_PTG_PAT_HSTA_WIDTH_inst_addr                             "0x0145"
#define HDMI_PTG_PAT_HSTA_WIDTH_inst                                  0x0145
#define HDMI_PTG_PAT_HSTA_WIDTH_pat_h_sta_shift                       (16)
#define HDMI_PTG_PAT_HSTA_WIDTH_dummy1800d514_15_13_shift             (13)
#define HDMI_PTG_PAT_HSTA_WIDTH_pat_wid_shift                         (0)
#define HDMI_PTG_PAT_HSTA_WIDTH_pat_h_sta_mask                        (0x1FFF0000)
#define HDMI_PTG_PAT_HSTA_WIDTH_dummy1800d514_15_13_mask              (0x0000E000)
#define HDMI_PTG_PAT_HSTA_WIDTH_pat_wid_mask                          (0x00001FFF)
#define HDMI_PTG_PAT_HSTA_WIDTH_pat_h_sta(data)                       (0x1FFF0000&((data)<<16))
#define HDMI_PTG_PAT_HSTA_WIDTH_dummy1800d514_15_13(data)             (0x0000E000&((data)<<13))
#define HDMI_PTG_PAT_HSTA_WIDTH_pat_wid(data)                         (0x00001FFF&(data))
#define HDMI_PTG_PAT_HSTA_WIDTH_get_pat_h_sta(data)                   ((0x1FFF0000&(data))>>16)
#define HDMI_PTG_PAT_HSTA_WIDTH_get_dummy1800d514_15_13(data)         ((0x0000E000&(data))>>13)
#define HDMI_PTG_PAT_HSTA_WIDTH_get_pat_wid(data)                     (0x00001FFF&(data))


#define HDMI_PTG_PAT_VSTA_LENGTH                                      0x1800d518
#define HDMI_PTG_PAT_VSTA_LENGTH_reg_addr                             "0xb800d518"
#define HDMI_PTG_PAT_VSTA_LENGTH_reg                                  0xb800d518
#define HDMI_PTG_PAT_VSTA_LENGTH_inst_addr                            "0x0146"
#define HDMI_PTG_PAT_VSTA_LENGTH_inst                                 0x0146
#define HDMI_PTG_PAT_VSTA_LENGTH_pat_v_sta_shift                      (16)
#define HDMI_PTG_PAT_VSTA_LENGTH_dummy1800d518_15_13_shift            (13)
#define HDMI_PTG_PAT_VSTA_LENGTH_pat_len_shift                        (0)
#define HDMI_PTG_PAT_VSTA_LENGTH_pat_v_sta_mask                       (0x1FFF0000)
#define HDMI_PTG_PAT_VSTA_LENGTH_dummy1800d518_15_13_mask             (0x0000E000)
#define HDMI_PTG_PAT_VSTA_LENGTH_pat_len_mask                         (0x00001FFF)
#define HDMI_PTG_PAT_VSTA_LENGTH_pat_v_sta(data)                      (0x1FFF0000&((data)<<16))
#define HDMI_PTG_PAT_VSTA_LENGTH_dummy1800d518_15_13(data)            (0x0000E000&((data)<<13))
#define HDMI_PTG_PAT_VSTA_LENGTH_pat_len(data)                        (0x00001FFF&(data))
#define HDMI_PTG_PAT_VSTA_LENGTH_get_pat_v_sta(data)                  ((0x1FFF0000&(data))>>16)
#define HDMI_PTG_PAT_VSTA_LENGTH_get_dummy1800d518_15_13(data)        ((0x0000E000&(data))>>13)
#define HDMI_PTG_PAT_VSTA_LENGTH_get_pat_len(data)                    (0x00001FFF&(data))


#define HDMI_PTG_L_CTRL                                               0x1800d520
#define HDMI_PTG_L_CTRL_reg_addr                                      "0xb800d520"
#define HDMI_PTG_L_CTRL_reg                                           0xb800d520
#define HDMI_PTG_L_CTRL_inst_addr                                     "0x0148"
#define HDMI_PTG_L_CTRL_inst                                          0x0148
#define HDMI_PTG_L_CTRL_en_rdm_bkg_l_shift                            (7)
#define HDMI_PTG_L_CTRL_xc_seq_l_shift                                (4)
#define HDMI_PTG_L_CTRL_en_xc_l_shift                                 (3)
#define HDMI_PTG_L_CTRL_pat_mode_l_shift                              (0)
#define HDMI_PTG_L_CTRL_en_rdm_bkg_l_mask                             (0x00000080)
#define HDMI_PTG_L_CTRL_xc_seq_l_mask                                 (0x00000070)
#define HDMI_PTG_L_CTRL_en_xc_l_mask                                  (0x00000008)
#define HDMI_PTG_L_CTRL_pat_mode_l_mask                               (0x00000007)
#define HDMI_PTG_L_CTRL_en_rdm_bkg_l(data)                            (0x00000080&((data)<<7))
#define HDMI_PTG_L_CTRL_xc_seq_l(data)                                (0x00000070&((data)<<4))
#define HDMI_PTG_L_CTRL_en_xc_l(data)                                 (0x00000008&((data)<<3))
#define HDMI_PTG_L_CTRL_pat_mode_l(data)                              (0x00000007&(data))
#define HDMI_PTG_L_CTRL_get_en_rdm_bkg_l(data)                        ((0x00000080&(data))>>7)
#define HDMI_PTG_L_CTRL_get_xc_seq_l(data)                            ((0x00000070&(data))>>4)
#define HDMI_PTG_L_CTRL_get_en_xc_l(data)                             ((0x00000008&(data))>>3)
#define HDMI_PTG_L_CTRL_get_pat_mode_l(data)                          (0x00000007&(data))


#define HDMI_PTG_L_BARW                                               0x1800d524
#define HDMI_PTG_L_BARW_reg_addr                                      "0xb800d524"
#define HDMI_PTG_L_BARW_reg                                           0xb800d524
#define HDMI_PTG_L_BARW_inst_addr                                     "0x0149"
#define HDMI_PTG_L_BARW_inst                                          0x0149
#define HDMI_PTG_L_BARW_auto_state_l_shift                            (14)
#define HDMI_PTG_L_BARW_hold_state_l_shift                            (12)
#define HDMI_PTG_L_BARW_hold_state_rdy_l_shift                        (11)
#define HDMI_PTG_L_BARW_barw_l_shift                                  (0)
#define HDMI_PTG_L_BARW_auto_state_l_mask                             (0x0000C000)
#define HDMI_PTG_L_BARW_hold_state_l_mask                             (0x00003000)
#define HDMI_PTG_L_BARW_hold_state_rdy_l_mask                         (0x00000800)
#define HDMI_PTG_L_BARW_barw_l_mask                                   (0x000007FF)
#define HDMI_PTG_L_BARW_auto_state_l(data)                            (0x0000C000&((data)<<14))
#define HDMI_PTG_L_BARW_hold_state_l(data)                            (0x00003000&((data)<<12))
#define HDMI_PTG_L_BARW_hold_state_rdy_l(data)                        (0x00000800&((data)<<11))
#define HDMI_PTG_L_BARW_barw_l(data)                                  (0x000007FF&(data))
#define HDMI_PTG_L_BARW_get_auto_state_l(data)                        ((0x0000C000&(data))>>14)
#define HDMI_PTG_L_BARW_get_hold_state_l(data)                        ((0x00003000&(data))>>12)
#define HDMI_PTG_L_BARW_get_hold_state_rdy_l(data)                    ((0x00000800&(data))>>11)
#define HDMI_PTG_L_BARW_get_barw_l(data)                              (0x000007FF&(data))


#define HDMI_PTG_L_C0Y_CB_CR                                          0x1800d528
#define HDMI_PTG_L_C0Y_CB_CR_reg_addr                                 "0xb800d528"
#define HDMI_PTG_L_C0Y_CB_CR_reg                                      0xb800d528
#define HDMI_PTG_L_C0Y_CB_CR_inst_addr                                "0x014A"
#define HDMI_PTG_L_C0Y_CB_CR_inst                                     0x014A
#define HDMI_PTG_L_C0Y_CB_CR_i_c0y_92b_l_shift                        (16)
#define HDMI_PTG_L_C0Y_CB_CR_i_c0cr_92b_l_shift                       (8)
#define HDMI_PTG_L_C0Y_CB_CR_i_c0cb_92b_l_shift                       (0)
#define HDMI_PTG_L_C0Y_CB_CR_i_c0y_92b_l_mask                         (0x00FF0000)
#define HDMI_PTG_L_C0Y_CB_CR_i_c0cr_92b_l_mask                        (0x0000FF00)
#define HDMI_PTG_L_C0Y_CB_CR_i_c0cb_92b_l_mask                        (0x000000FF)
#define HDMI_PTG_L_C0Y_CB_CR_i_c0y_92b_l(data)                        (0x00FF0000&((data)<<16))
#define HDMI_PTG_L_C0Y_CB_CR_i_c0cr_92b_l(data)                       (0x0000FF00&((data)<<8))
#define HDMI_PTG_L_C0Y_CB_CR_i_c0cb_92b_l(data)                       (0x000000FF&(data))
#define HDMI_PTG_L_C0Y_CB_CR_get_i_c0y_92b_l(data)                    ((0x00FF0000&(data))>>16)
#define HDMI_PTG_L_C0Y_CB_CR_get_i_c0cr_92b_l(data)                   ((0x0000FF00&(data))>>8)
#define HDMI_PTG_L_C0Y_CB_CR_get_i_c0cb_92b_l(data)                   (0x000000FF&(data))


#define HDMI_PTG_L_C1Y_CB_CR                                          0x1800d52c
#define HDMI_PTG_L_C1Y_CB_CR_reg_addr                                 "0xb800d52c"
#define HDMI_PTG_L_C1Y_CB_CR_reg                                      0xb800d52c
#define HDMI_PTG_L_C1Y_CB_CR_inst_addr                                "0x014B"
#define HDMI_PTG_L_C1Y_CB_CR_inst                                     0x014B
#define HDMI_PTG_L_C1Y_CB_CR_i_c1y_92b_l_shift                        (16)
#define HDMI_PTG_L_C1Y_CB_CR_i_c1cr_92b_l_shift                       (8)
#define HDMI_PTG_L_C1Y_CB_CR_i_c1cb_92b_l_shift                       (0)
#define HDMI_PTG_L_C1Y_CB_CR_i_c1y_92b_l_mask                         (0x00FF0000)
#define HDMI_PTG_L_C1Y_CB_CR_i_c1cr_92b_l_mask                        (0x0000FF00)
#define HDMI_PTG_L_C1Y_CB_CR_i_c1cb_92b_l_mask                        (0x000000FF)
#define HDMI_PTG_L_C1Y_CB_CR_i_c1y_92b_l(data)                        (0x00FF0000&((data)<<16))
#define HDMI_PTG_L_C1Y_CB_CR_i_c1cr_92b_l(data)                       (0x0000FF00&((data)<<8))
#define HDMI_PTG_L_C1Y_CB_CR_i_c1cb_92b_l(data)                       (0x000000FF&(data))
#define HDMI_PTG_L_C1Y_CB_CR_get_i_c1y_92b_l(data)                    ((0x00FF0000&(data))>>16)
#define HDMI_PTG_L_C1Y_CB_CR_get_i_c1cr_92b_l(data)                   ((0x0000FF00&(data))>>8)
#define HDMI_PTG_L_C1Y_CB_CR_get_i_c1cb_92b_l(data)                   (0x000000FF&(data))


#define HDMI_PTG_L_C2Y_CB_CR                                          0x1800d530
#define HDMI_PTG_L_C2Y_CB_CR_reg_addr                                 "0xb800d530"
#define HDMI_PTG_L_C2Y_CB_CR_reg                                      0xb800d530
#define HDMI_PTG_L_C2Y_CB_CR_inst_addr                                "0x014C"
#define HDMI_PTG_L_C2Y_CB_CR_inst                                     0x014C
#define HDMI_PTG_L_C2Y_CB_CR_i_c2y_92b_l_shift                        (16)
#define HDMI_PTG_L_C2Y_CB_CR_i_c2cr_92b_l_shift                       (8)
#define HDMI_PTG_L_C2Y_CB_CR_i_c2cb_92b_l_shift                       (0)
#define HDMI_PTG_L_C2Y_CB_CR_i_c2y_92b_l_mask                         (0x00FF0000)
#define HDMI_PTG_L_C2Y_CB_CR_i_c2cr_92b_l_mask                        (0x0000FF00)
#define HDMI_PTG_L_C2Y_CB_CR_i_c2cb_92b_l_mask                        (0x000000FF)
#define HDMI_PTG_L_C2Y_CB_CR_i_c2y_92b_l(data)                        (0x00FF0000&((data)<<16))
#define HDMI_PTG_L_C2Y_CB_CR_i_c2cr_92b_l(data)                       (0x0000FF00&((data)<<8))
#define HDMI_PTG_L_C2Y_CB_CR_i_c2cb_92b_l(data)                       (0x000000FF&(data))
#define HDMI_PTG_L_C2Y_CB_CR_get_i_c2y_92b_l(data)                    ((0x00FF0000&(data))>>16)
#define HDMI_PTG_L_C2Y_CB_CR_get_i_c2cr_92b_l(data)                   ((0x0000FF00&(data))>>8)
#define HDMI_PTG_L_C2Y_CB_CR_get_i_c2cb_92b_l(data)                   (0x000000FF&(data))


#define HDMI_PTG_L_C3Y_CB_CR                                          0x1800d534
#define HDMI_PTG_L_C3Y_CB_CR_reg_addr                                 "0xb800d534"
#define HDMI_PTG_L_C3Y_CB_CR_reg                                      0xb800d534
#define HDMI_PTG_L_C3Y_CB_CR_inst_addr                                "0x014D"
#define HDMI_PTG_L_C3Y_CB_CR_inst                                     0x014D
#define HDMI_PTG_L_C3Y_CB_CR_i_c3y_98b_l_shift                        (30)
#define HDMI_PTG_L_C3Y_CB_CR_i_c3y_72b_grady_l_shift                  (24)
#define HDMI_PTG_L_C3Y_CB_CR_i_c3cr_98b_l_shift                       (22)
#define HDMI_PTG_L_C3Y_CB_CR_i_c3cr_72b_gradcr_l_shift                (16)
#define HDMI_PTG_L_C3Y_CB_CR_i_c3cb_98b_l_shift                       (14)
#define HDMI_PTG_L_C3Y_CB_CR_i_c3cb_72b_gradcb_l_shift                (8)
#define HDMI_PTG_L_C3Y_CB_CR_dummy1800d534_7_0_shift                  (0)
#define HDMI_PTG_L_C3Y_CB_CR_i_c3y_98b_l_mask                         (0xC0000000)
#define HDMI_PTG_L_C3Y_CB_CR_i_c3y_72b_grady_l_mask                   (0x3F000000)
#define HDMI_PTG_L_C3Y_CB_CR_i_c3cr_98b_l_mask                        (0x00C00000)
#define HDMI_PTG_L_C3Y_CB_CR_i_c3cr_72b_gradcr_l_mask                 (0x003F0000)
#define HDMI_PTG_L_C3Y_CB_CR_i_c3cb_98b_l_mask                        (0x0000C000)
#define HDMI_PTG_L_C3Y_CB_CR_i_c3cb_72b_gradcb_l_mask                 (0x00003F00)
#define HDMI_PTG_L_C3Y_CB_CR_dummy1800d534_7_0_mask                   (0x000000FF)
#define HDMI_PTG_L_C3Y_CB_CR_i_c3y_98b_l(data)                        (0xC0000000&((data)<<30))
#define HDMI_PTG_L_C3Y_CB_CR_i_c3y_72b_grady_l(data)                  (0x3F000000&((data)<<24))
#define HDMI_PTG_L_C3Y_CB_CR_i_c3cr_98b_l(data)                       (0x00C00000&((data)<<22))
#define HDMI_PTG_L_C3Y_CB_CR_i_c3cr_72b_gradcr_l(data)                (0x003F0000&((data)<<16))
#define HDMI_PTG_L_C3Y_CB_CR_i_c3cb_98b_l(data)                       (0x0000C000&((data)<<14))
#define HDMI_PTG_L_C3Y_CB_CR_i_c3cb_72b_gradcb_l(data)                (0x00003F00&((data)<<8))
#define HDMI_PTG_L_C3Y_CB_CR_dummy1800d534_7_0(data)                  (0x000000FF&(data))
#define HDMI_PTG_L_C3Y_CB_CR_get_i_c3y_98b_l(data)                    ((0xC0000000&(data))>>30)
#define HDMI_PTG_L_C3Y_CB_CR_get_i_c3y_72b_grady_l(data)              ((0x3F000000&(data))>>24)
#define HDMI_PTG_L_C3Y_CB_CR_get_i_c3cr_98b_l(data)                   ((0x00C00000&(data))>>22)
#define HDMI_PTG_L_C3Y_CB_CR_get_i_c3cr_72b_gradcr_l(data)            ((0x003F0000&(data))>>16)
#define HDMI_PTG_L_C3Y_CB_CR_get_i_c3cb_98b_l(data)                   ((0x0000C000&(data))>>14)
#define HDMI_PTG_L_C3Y_CB_CR_get_i_c3cb_72b_gradcb_l(data)            ((0x00003F00&(data))>>8)
#define HDMI_PTG_L_C3Y_CB_CR_get_dummy1800d534_7_0(data)              (0x000000FF&(data))


#define HDMI_PTG_L_C4Y_CB_CR                                          0x1800d538
#define HDMI_PTG_L_C4Y_CB_CR_reg_addr                                 "0xb800d538"
#define HDMI_PTG_L_C4Y_CB_CR_reg                                      0xb800d538
#define HDMI_PTG_L_C4Y_CB_CR_inst_addr                                "0x014E"
#define HDMI_PTG_L_C4Y_CB_CR_inst                                     0x014E
#define HDMI_PTG_L_C4Y_CB_CR_i_c4y_96b_l_shift                        (28)
#define HDMI_PTG_L_C4Y_CB_CR_i_c4y_52b_step_hv_l_shift                (24)
#define HDMI_PTG_L_C4Y_CB_CR_i_c4cr_92b_l_shift                       (16)
#define HDMI_PTG_L_C4Y_CB_CR_i_c4cb_9b_l_shift                        (15)
#define HDMI_PTG_L_C4Y_CB_CR_i_c4cb_86b_bmp_w_l_shift                 (12)
#define HDMI_PTG_L_C4Y_CB_CR_i_c4cb_5b_l_shift                        (11)
#define HDMI_PTG_L_C4Y_CB_CR_i_c4cb_42b_bmp_h_l_shift                 (8)
#define HDMI_PTG_L_C4Y_CB_CR_i_c4y_96b_l_mask                         (0xF0000000)
#define HDMI_PTG_L_C4Y_CB_CR_i_c4y_52b_step_hv_l_mask                 (0x0F000000)
#define HDMI_PTG_L_C4Y_CB_CR_i_c4cr_92b_l_mask                        (0x00FF0000)
#define HDMI_PTG_L_C4Y_CB_CR_i_c4cb_9b_l_mask                         (0x00008000)
#define HDMI_PTG_L_C4Y_CB_CR_i_c4cb_86b_bmp_w_l_mask                  (0x00007000)
#define HDMI_PTG_L_C4Y_CB_CR_i_c4cb_5b_l_mask                         (0x00000800)
#define HDMI_PTG_L_C4Y_CB_CR_i_c4cb_42b_bmp_h_l_mask                  (0x00000700)
#define HDMI_PTG_L_C4Y_CB_CR_i_c4y_96b_l(data)                        (0xF0000000&((data)<<28))
#define HDMI_PTG_L_C4Y_CB_CR_i_c4y_52b_step_hv_l(data)                (0x0F000000&((data)<<24))
#define HDMI_PTG_L_C4Y_CB_CR_i_c4cr_92b_l(data)                       (0x00FF0000&((data)<<16))
#define HDMI_PTG_L_C4Y_CB_CR_i_c4cb_9b_l(data)                        (0x00008000&((data)<<15))
#define HDMI_PTG_L_C4Y_CB_CR_i_c4cb_86b_bmp_w_l(data)                 (0x00007000&((data)<<12))
#define HDMI_PTG_L_C4Y_CB_CR_i_c4cb_5b_l(data)                        (0x00000800&((data)<<11))
#define HDMI_PTG_L_C4Y_CB_CR_i_c4cb_42b_bmp_h_l(data)                 (0x00000700&((data)<<8))
#define HDMI_PTG_L_C4Y_CB_CR_get_i_c4y_96b_l(data)                    ((0xF0000000&(data))>>28)
#define HDMI_PTG_L_C4Y_CB_CR_get_i_c4y_52b_step_hv_l(data)            ((0x0F000000&(data))>>24)
#define HDMI_PTG_L_C4Y_CB_CR_get_i_c4cr_92b_l(data)                   ((0x00FF0000&(data))>>16)
#define HDMI_PTG_L_C4Y_CB_CR_get_i_c4cb_9b_l(data)                    ((0x00008000&(data))>>15)
#define HDMI_PTG_L_C4Y_CB_CR_get_i_c4cb_86b_bmp_w_l(data)             ((0x00007000&(data))>>12)
#define HDMI_PTG_L_C4Y_CB_CR_get_i_c4cb_5b_l(data)                    ((0x00000800&(data))>>11)
#define HDMI_PTG_L_C4Y_CB_CR_get_i_c4cb_42b_bmp_h_l(data)             ((0x00000700&(data))>>8)


#define HDMI_PTG_L_C5Y_CR_CB                                          0x1800d53c
#define HDMI_PTG_L_C5Y_CR_CB_reg_addr                                 "0xb800d53c"
#define HDMI_PTG_L_C5Y_CR_CB_reg                                      0xb800d53c
#define HDMI_PTG_L_C5Y_CR_CB_inst_addr                                "0x014F"
#define HDMI_PTG_L_C5Y_CR_CB_inst                                     0x014F
#define HDMI_PTG_L_C5Y_CR_CB_i_c5y_92b_bmptp_l_shift                  (24)
#define HDMI_PTG_L_C5Y_CR_CB_i_c5cr_92b_bmp0_l_shift                  (16)
#define HDMI_PTG_L_C5Y_CR_CB_i_c5cb_92b_bmp1_l_shift                  (8)
#define HDMI_PTG_L_C5Y_CR_CB_dummy1800d53c_7_0_shift                  (0)
#define HDMI_PTG_L_C5Y_CR_CB_i_c5y_92b_bmptp_l_mask                   (0xFF000000)
#define HDMI_PTG_L_C5Y_CR_CB_i_c5cr_92b_bmp0_l_mask                   (0x00FF0000)
#define HDMI_PTG_L_C5Y_CR_CB_i_c5cb_92b_bmp1_l_mask                   (0x0000FF00)
#define HDMI_PTG_L_C5Y_CR_CB_dummy1800d53c_7_0_mask                   (0x000000FF)
#define HDMI_PTG_L_C5Y_CR_CB_i_c5y_92b_bmptp_l(data)                  (0xFF000000&((data)<<24))
#define HDMI_PTG_L_C5Y_CR_CB_i_c5cr_92b_bmp0_l(data)                  (0x00FF0000&((data)<<16))
#define HDMI_PTG_L_C5Y_CR_CB_i_c5cb_92b_bmp1_l(data)                  (0x0000FF00&((data)<<8))
#define HDMI_PTG_L_C5Y_CR_CB_dummy1800d53c_7_0(data)                  (0x000000FF&(data))
#define HDMI_PTG_L_C5Y_CR_CB_get_i_c5y_92b_bmptp_l(data)              ((0xFF000000&(data))>>24)
#define HDMI_PTG_L_C5Y_CR_CB_get_i_c5cr_92b_bmp0_l(data)              ((0x00FF0000&(data))>>16)
#define HDMI_PTG_L_C5Y_CR_CB_get_i_c5cb_92b_bmp1_l(data)              ((0x0000FF00&(data))>>8)
#define HDMI_PTG_L_C5Y_CR_CB_get_dummy1800d53c_7_0(data)              (0x000000FF&(data))


#define HDMI_PTG_L_C6Y_CB_CR                                          0x1800d540
#define HDMI_PTG_L_C6Y_CB_CR_reg_addr                                 "0xb800d540"
#define HDMI_PTG_L_C6Y_CB_CR_reg                                      0xb800d540
#define HDMI_PTG_L_C6Y_CB_CR_inst_addr                                "0x0150"
#define HDMI_PTG_L_C6Y_CB_CR_inst                                     0x0150
#define HDMI_PTG_L_C6Y_CB_CR_i_c6y_92b_bmp2_l_shift                   (24)
#define HDMI_PTG_L_C6Y_CB_CR_i_c6cr_92b_bmp3_l_shift                  (16)
#define HDMI_PTG_L_C6Y_CB_CR_i_c6cb_92b_bmp4_l_shift                  (8)
#define HDMI_PTG_L_C6Y_CB_CR_nonactive_color_def_l_shift              (0)
#define HDMI_PTG_L_C6Y_CB_CR_i_c6y_92b_bmp2_l_mask                    (0xFF000000)
#define HDMI_PTG_L_C6Y_CB_CR_i_c6cr_92b_bmp3_l_mask                   (0x00FF0000)
#define HDMI_PTG_L_C6Y_CB_CR_i_c6cb_92b_bmp4_l_mask                   (0x0000FF00)
#define HDMI_PTG_L_C6Y_CB_CR_nonactive_color_def_l_mask               (0x000000FF)
#define HDMI_PTG_L_C6Y_CB_CR_i_c6y_92b_bmp2_l(data)                   (0xFF000000&((data)<<24))
#define HDMI_PTG_L_C6Y_CB_CR_i_c6cr_92b_bmp3_l(data)                  (0x00FF0000&((data)<<16))
#define HDMI_PTG_L_C6Y_CB_CR_i_c6cb_92b_bmp4_l(data)                  (0x0000FF00&((data)<<8))
#define HDMI_PTG_L_C6Y_CB_CR_nonactive_color_def_l(data)              (0x000000FF&(data))
#define HDMI_PTG_L_C6Y_CB_CR_get_i_c6y_92b_bmp2_l(data)               ((0xFF000000&(data))>>24)
#define HDMI_PTG_L_C6Y_CB_CR_get_i_c6cr_92b_bmp3_l(data)              ((0x00FF0000&(data))>>16)
#define HDMI_PTG_L_C6Y_CB_CR_get_i_c6cb_92b_bmp4_l(data)              ((0x0000FF00&(data))>>8)
#define HDMI_PTG_L_C6Y_CB_CR_get_nonactive_color_def_l(data)          (0x000000FF&(data))


#define HDMI_PTG_L_C7Y_CB_CR                                          0x1800d544
#define HDMI_PTG_L_C7Y_CB_CR_reg_addr                                 "0xb800d544"
#define HDMI_PTG_L_C7Y_CB_CR_reg                                      0xb800d544
#define HDMI_PTG_L_C7Y_CB_CR_inst_addr                                "0x0151"
#define HDMI_PTG_L_C7Y_CB_CR_inst                                     0x0151
#define HDMI_PTG_L_C7Y_CB_CR_i_c7y_92b_bmp5_l_shift                   (24)
#define HDMI_PTG_L_C7Y_CB_CR_i_c7cr_92b_bmp6_l_shift                  (16)
#define HDMI_PTG_L_C7Y_CB_CR_i_c7cb_92b_bmp7_l_shift                  (8)
#define HDMI_PTG_L_C7Y_CB_CR_dummy1800d544_7_0_shift                  (0)
#define HDMI_PTG_L_C7Y_CB_CR_i_c7y_92b_bmp5_l_mask                    (0xFF000000)
#define HDMI_PTG_L_C7Y_CB_CR_i_c7cr_92b_bmp6_l_mask                   (0x00FF0000)
#define HDMI_PTG_L_C7Y_CB_CR_i_c7cb_92b_bmp7_l_mask                   (0x0000FF00)
#define HDMI_PTG_L_C7Y_CB_CR_dummy1800d544_7_0_mask                   (0x000000FF)
#define HDMI_PTG_L_C7Y_CB_CR_i_c7y_92b_bmp5_l(data)                   (0xFF000000&((data)<<24))
#define HDMI_PTG_L_C7Y_CB_CR_i_c7cr_92b_bmp6_l(data)                  (0x00FF0000&((data)<<16))
#define HDMI_PTG_L_C7Y_CB_CR_i_c7cb_92b_bmp7_l(data)                  (0x0000FF00&((data)<<8))
#define HDMI_PTG_L_C7Y_CB_CR_dummy1800d544_7_0(data)                  (0x000000FF&(data))
#define HDMI_PTG_L_C7Y_CB_CR_get_i_c7y_92b_bmp5_l(data)               ((0xFF000000&(data))>>24)
#define HDMI_PTG_L_C7Y_CB_CR_get_i_c7cr_92b_bmp6_l(data)              ((0x00FF0000&(data))>>16)
#define HDMI_PTG_L_C7Y_CB_CR_get_i_c7cb_92b_bmp7_l(data)              ((0x0000FF00&(data))>>8)
#define HDMI_PTG_L_C7Y_CB_CR_get_dummy1800d544_7_0(data)              (0x000000FF&(data))


#define HDMI_PTG_L_MAX_COLOR_CTRL                                     0x1800d548
#define HDMI_PTG_L_MAX_COLOR_CTRL_reg_addr                            "0xb800d548"
#define HDMI_PTG_L_MAX_COLOR_CTRL_reg                                 0xb800d548
#define HDMI_PTG_L_MAX_COLOR_CTRL_inst_addr                           "0x0152"
#define HDMI_PTG_L_MAX_COLOR_CTRL_inst                                0x0152
#define HDMI_PTG_L_MAX_COLOR_CTRL_dummy1800d548_31_27_shift           (27)
#define HDMI_PTG_L_MAX_COLOR_CTRL_max_color_l_shift                   (24)
#define HDMI_PTG_L_MAX_COLOR_CTRL_mv_h_l_shift                        (20)
#define HDMI_PTG_L_MAX_COLOR_CTRL_mv_v_l_shift                        (16)
#define HDMI_PTG_L_MAX_COLOR_CTRL_mv_seq_type_l_shift                 (15)
#define HDMI_PTG_L_MAX_COLOR_CTRL_rdm_period_l_shift                  (12)
#define HDMI_PTG_L_MAX_COLOR_CTRL_mv_vs_num_l_shift                   (8)
#define HDMI_PTG_L_MAX_COLOR_CTRL_mp_adj_num_l_shift                  (0)
#define HDMI_PTG_L_MAX_COLOR_CTRL_dummy1800d548_31_27_mask            (0xF8000000)
#define HDMI_PTG_L_MAX_COLOR_CTRL_max_color_l_mask                    (0x07000000)
#define HDMI_PTG_L_MAX_COLOR_CTRL_mv_h_l_mask                         (0x00F00000)
#define HDMI_PTG_L_MAX_COLOR_CTRL_mv_v_l_mask                         (0x000F0000)
#define HDMI_PTG_L_MAX_COLOR_CTRL_mv_seq_type_l_mask                  (0x00008000)
#define HDMI_PTG_L_MAX_COLOR_CTRL_rdm_period_l_mask                   (0x00007000)
#define HDMI_PTG_L_MAX_COLOR_CTRL_mv_vs_num_l_mask                    (0x00000F00)
#define HDMI_PTG_L_MAX_COLOR_CTRL_mp_adj_num_l_mask                   (0x000000FF)
#define HDMI_PTG_L_MAX_COLOR_CTRL_dummy1800d548_31_27(data)           (0xF8000000&((data)<<27))
#define HDMI_PTG_L_MAX_COLOR_CTRL_max_color_l(data)                   (0x07000000&((data)<<24))
#define HDMI_PTG_L_MAX_COLOR_CTRL_mv_h_l(data)                        (0x00F00000&((data)<<20))
#define HDMI_PTG_L_MAX_COLOR_CTRL_mv_v_l(data)                        (0x000F0000&((data)<<16))
#define HDMI_PTG_L_MAX_COLOR_CTRL_mv_seq_type_l(data)                 (0x00008000&((data)<<15))
#define HDMI_PTG_L_MAX_COLOR_CTRL_rdm_period_l(data)                  (0x00007000&((data)<<12))
#define HDMI_PTG_L_MAX_COLOR_CTRL_mv_vs_num_l(data)                   (0x00000F00&((data)<<8))
#define HDMI_PTG_L_MAX_COLOR_CTRL_mp_adj_num_l(data)                  (0x000000FF&(data))
#define HDMI_PTG_L_MAX_COLOR_CTRL_get_dummy1800d548_31_27(data)       ((0xF8000000&(data))>>27)
#define HDMI_PTG_L_MAX_COLOR_CTRL_get_max_color_l(data)               ((0x07000000&(data))>>24)
#define HDMI_PTG_L_MAX_COLOR_CTRL_get_mv_h_l(data)                    ((0x00F00000&(data))>>20)
#define HDMI_PTG_L_MAX_COLOR_CTRL_get_mv_v_l(data)                    ((0x000F0000&(data))>>16)
#define HDMI_PTG_L_MAX_COLOR_CTRL_get_mv_seq_type_l(data)             ((0x00008000&(data))>>15)
#define HDMI_PTG_L_MAX_COLOR_CTRL_get_rdm_period_l(data)              ((0x00007000&(data))>>12)
#define HDMI_PTG_L_MAX_COLOR_CTRL_get_mv_vs_num_l(data)               ((0x00000F00&(data))>>8)
#define HDMI_PTG_L_MAX_COLOR_CTRL_get_mp_adj_num_l(data)              (0x000000FF&(data))


#define HDMI_PTG_R_CTRL                                               0x1800d550
#define HDMI_PTG_R_CTRL_reg_addr                                      "0xb800d550"
#define HDMI_PTG_R_CTRL_reg                                           0xb800d550
#define HDMI_PTG_R_CTRL_inst_addr                                     "0x0154"
#define HDMI_PTG_R_CTRL_inst                                          0x0154
#define HDMI_PTG_R_CTRL_en_rdm_bkg_r_shift                            (7)
#define HDMI_PTG_R_CTRL_xc_seq_r_shift                                (4)
#define HDMI_PTG_R_CTRL_en_xc_r_shift                                 (3)
#define HDMI_PTG_R_CTRL_pat_mode_r_shift                              (0)
#define HDMI_PTG_R_CTRL_en_rdm_bkg_r_mask                             (0x00000080)
#define HDMI_PTG_R_CTRL_xc_seq_r_mask                                 (0x00000070)
#define HDMI_PTG_R_CTRL_en_xc_r_mask                                  (0x00000008)
#define HDMI_PTG_R_CTRL_pat_mode_r_mask                               (0x00000007)
#define HDMI_PTG_R_CTRL_en_rdm_bkg_r(data)                            (0x00000080&((data)<<7))
#define HDMI_PTG_R_CTRL_xc_seq_r(data)                                (0x00000070&((data)<<4))
#define HDMI_PTG_R_CTRL_en_xc_r(data)                                 (0x00000008&((data)<<3))
#define HDMI_PTG_R_CTRL_pat_mode_r(data)                              (0x00000007&(data))
#define HDMI_PTG_R_CTRL_get_en_rdm_bkg_r(data)                        ((0x00000080&(data))>>7)
#define HDMI_PTG_R_CTRL_get_xc_seq_r(data)                            ((0x00000070&(data))>>4)
#define HDMI_PTG_R_CTRL_get_en_xc_r(data)                             ((0x00000008&(data))>>3)
#define HDMI_PTG_R_CTRL_get_pat_mode_r(data)                          (0x00000007&(data))


#define HDMI_PTG_R_BARW                                               0x1800d554
#define HDMI_PTG_R_BARW_reg_addr                                      "0xb800d554"
#define HDMI_PTG_R_BARW_reg                                           0xb800d554
#define HDMI_PTG_R_BARW_inst_addr                                     "0x0155"
#define HDMI_PTG_R_BARW_inst                                          0x0155
#define HDMI_PTG_R_BARW_auto_state_r_shift                            (14)
#define HDMI_PTG_R_BARW_hold_state_r_shift                            (12)
#define HDMI_PTG_R_BARW_hold_state_rdy_r_shift                        (11)
#define HDMI_PTG_R_BARW_barw_r_shift                                  (0)
#define HDMI_PTG_R_BARW_auto_state_r_mask                             (0x0000C000)
#define HDMI_PTG_R_BARW_hold_state_r_mask                             (0x00003000)
#define HDMI_PTG_R_BARW_hold_state_rdy_r_mask                         (0x00000800)
#define HDMI_PTG_R_BARW_barw_r_mask                                   (0x000007FF)
#define HDMI_PTG_R_BARW_auto_state_r(data)                            (0x0000C000&((data)<<14))
#define HDMI_PTG_R_BARW_hold_state_r(data)                            (0x00003000&((data)<<12))
#define HDMI_PTG_R_BARW_hold_state_rdy_r(data)                        (0x00000800&((data)<<11))
#define HDMI_PTG_R_BARW_barw_r(data)                                  (0x000007FF&(data))
#define HDMI_PTG_R_BARW_get_auto_state_r(data)                        ((0x0000C000&(data))>>14)
#define HDMI_PTG_R_BARW_get_hold_state_r(data)                        ((0x00003000&(data))>>12)
#define HDMI_PTG_R_BARW_get_hold_state_rdy_r(data)                    ((0x00000800&(data))>>11)
#define HDMI_PTG_R_BARW_get_barw_r(data)                              (0x000007FF&(data))


#define HDMI_PTG_R_C0Y_CB_CR                                          0x1800d558
#define HDMI_PTG_R_C0Y_CB_CR_reg_addr                                 "0xb800d558"
#define HDMI_PTG_R_C0Y_CB_CR_reg                                      0xb800d558
#define HDMI_PTG_R_C0Y_CB_CR_inst_addr                                "0x0156"
#define HDMI_PTG_R_C0Y_CB_CR_inst                                     0x0156
#define HDMI_PTG_R_C0Y_CB_CR_i_c0y_92b_r_shift                        (16)
#define HDMI_PTG_R_C0Y_CB_CR_i_c0cr_92b_r_shift                       (8)
#define HDMI_PTG_R_C0Y_CB_CR_i_c0cb_92b_r_shift                       (0)
#define HDMI_PTG_R_C0Y_CB_CR_i_c0y_92b_r_mask                         (0x00FF0000)
#define HDMI_PTG_R_C0Y_CB_CR_i_c0cr_92b_r_mask                        (0x0000FF00)
#define HDMI_PTG_R_C0Y_CB_CR_i_c0cb_92b_r_mask                        (0x000000FF)
#define HDMI_PTG_R_C0Y_CB_CR_i_c0y_92b_r(data)                        (0x00FF0000&((data)<<16))
#define HDMI_PTG_R_C0Y_CB_CR_i_c0cr_92b_r(data)                       (0x0000FF00&((data)<<8))
#define HDMI_PTG_R_C0Y_CB_CR_i_c0cb_92b_r(data)                       (0x000000FF&(data))
#define HDMI_PTG_R_C0Y_CB_CR_get_i_c0y_92b_r(data)                    ((0x00FF0000&(data))>>16)
#define HDMI_PTG_R_C0Y_CB_CR_get_i_c0cr_92b_r(data)                   ((0x0000FF00&(data))>>8)
#define HDMI_PTG_R_C0Y_CB_CR_get_i_c0cb_92b_r(data)                   (0x000000FF&(data))


#define HDMI_PTG_R_C1Y_CB_CR                                          0x1800d55c
#define HDMI_PTG_R_C1Y_CB_CR_reg_addr                                 "0xb800d55c"
#define HDMI_PTG_R_C1Y_CB_CR_reg                                      0xb800d55c
#define HDMI_PTG_R_C1Y_CB_CR_inst_addr                                "0x0157"
#define HDMI_PTG_R_C1Y_CB_CR_inst                                     0x0157
#define HDMI_PTG_R_C1Y_CB_CR_i_c1y_92b_r_shift                        (16)
#define HDMI_PTG_R_C1Y_CB_CR_i_c1cr_92b_r_shift                       (8)
#define HDMI_PTG_R_C1Y_CB_CR_i_c1cb_92b_r_shift                       (0)
#define HDMI_PTG_R_C1Y_CB_CR_i_c1y_92b_r_mask                         (0x00FF0000)
#define HDMI_PTG_R_C1Y_CB_CR_i_c1cr_92b_r_mask                        (0x0000FF00)
#define HDMI_PTG_R_C1Y_CB_CR_i_c1cb_92b_r_mask                        (0x000000FF)
#define HDMI_PTG_R_C1Y_CB_CR_i_c1y_92b_r(data)                        (0x00FF0000&((data)<<16))
#define HDMI_PTG_R_C1Y_CB_CR_i_c1cr_92b_r(data)                       (0x0000FF00&((data)<<8))
#define HDMI_PTG_R_C1Y_CB_CR_i_c1cb_92b_r(data)                       (0x000000FF&(data))
#define HDMI_PTG_R_C1Y_CB_CR_get_i_c1y_92b_r(data)                    ((0x00FF0000&(data))>>16)
#define HDMI_PTG_R_C1Y_CB_CR_get_i_c1cr_92b_r(data)                   ((0x0000FF00&(data))>>8)
#define HDMI_PTG_R_C1Y_CB_CR_get_i_c1cb_92b_r(data)                   (0x000000FF&(data))


#define HDMI_PTG_R_C2Y_CB_CR                                          0x1800d560
#define HDMI_PTG_R_C2Y_CB_CR_reg_addr                                 "0xb800d560"
#define HDMI_PTG_R_C2Y_CB_CR_reg                                      0xb800d560
#define HDMI_PTG_R_C2Y_CB_CR_inst_addr                                "0x0158"
#define HDMI_PTG_R_C2Y_CB_CR_inst                                     0x0158
#define HDMI_PTG_R_C2Y_CB_CR_i_c2y_92b_r_shift                        (16)
#define HDMI_PTG_R_C2Y_CB_CR_i_c2cr_92b_r_shift                       (8)
#define HDMI_PTG_R_C2Y_CB_CR_i_c2cb_92b_r_shift                       (0)
#define HDMI_PTG_R_C2Y_CB_CR_i_c2y_92b_r_mask                         (0x00FF0000)
#define HDMI_PTG_R_C2Y_CB_CR_i_c2cr_92b_r_mask                        (0x0000FF00)
#define HDMI_PTG_R_C2Y_CB_CR_i_c2cb_92b_r_mask                        (0x000000FF)
#define HDMI_PTG_R_C2Y_CB_CR_i_c2y_92b_r(data)                        (0x00FF0000&((data)<<16))
#define HDMI_PTG_R_C2Y_CB_CR_i_c2cr_92b_r(data)                       (0x0000FF00&((data)<<8))
#define HDMI_PTG_R_C2Y_CB_CR_i_c2cb_92b_r(data)                       (0x000000FF&(data))
#define HDMI_PTG_R_C2Y_CB_CR_get_i_c2y_92b_r(data)                    ((0x00FF0000&(data))>>16)
#define HDMI_PTG_R_C2Y_CB_CR_get_i_c2cr_92b_r(data)                   ((0x0000FF00&(data))>>8)
#define HDMI_PTG_R_C2Y_CB_CR_get_i_c2cb_92b_r(data)                   (0x000000FF&(data))


#define HDMI_PTG_R_C3Y_CB_CR                                          0x1800d564
#define HDMI_PTG_R_C3Y_CB_CR_reg_addr                                 "0xb800d564"
#define HDMI_PTG_R_C3Y_CB_CR_reg                                      0xb800d564
#define HDMI_PTG_R_C3Y_CB_CR_inst_addr                                "0x0159"
#define HDMI_PTG_R_C3Y_CB_CR_inst                                     0x0159
#define HDMI_PTG_R_C3Y_CB_CR_i_c3y_98b_r_shift                        (30)
#define HDMI_PTG_R_C3Y_CB_CR_i_c3y_72b_grady_r_shift                  (24)
#define HDMI_PTG_R_C3Y_CB_CR_i_c3cr_98b_r_shift                       (22)
#define HDMI_PTG_R_C3Y_CB_CR_i_c3cr_72b_gradcr_r_shift                (16)
#define HDMI_PTG_R_C3Y_CB_CR_i_c3cb_98b_r_shift                       (14)
#define HDMI_PTG_R_C3Y_CB_CR_i_c3cb_72b_gradcb_r_shift                (8)
#define HDMI_PTG_R_C3Y_CB_CR_dummy1800d564_7_0_shift                  (0)
#define HDMI_PTG_R_C3Y_CB_CR_i_c3y_98b_r_mask                         (0xC0000000)
#define HDMI_PTG_R_C3Y_CB_CR_i_c3y_72b_grady_r_mask                   (0x3F000000)
#define HDMI_PTG_R_C3Y_CB_CR_i_c3cr_98b_r_mask                        (0x00C00000)
#define HDMI_PTG_R_C3Y_CB_CR_i_c3cr_72b_gradcr_r_mask                 (0x003F0000)
#define HDMI_PTG_R_C3Y_CB_CR_i_c3cb_98b_r_mask                        (0x0000C000)
#define HDMI_PTG_R_C3Y_CB_CR_i_c3cb_72b_gradcb_r_mask                 (0x00003F00)
#define HDMI_PTG_R_C3Y_CB_CR_dummy1800d564_7_0_mask                   (0x000000FF)
#define HDMI_PTG_R_C3Y_CB_CR_i_c3y_98b_r(data)                        (0xC0000000&((data)<<30))
#define HDMI_PTG_R_C3Y_CB_CR_i_c3y_72b_grady_r(data)                  (0x3F000000&((data)<<24))
#define HDMI_PTG_R_C3Y_CB_CR_i_c3cr_98b_r(data)                       (0x00C00000&((data)<<22))
#define HDMI_PTG_R_C3Y_CB_CR_i_c3cr_72b_gradcr_r(data)                (0x003F0000&((data)<<16))
#define HDMI_PTG_R_C3Y_CB_CR_i_c3cb_98b_r(data)                       (0x0000C000&((data)<<14))
#define HDMI_PTG_R_C3Y_CB_CR_i_c3cb_72b_gradcb_r(data)                (0x00003F00&((data)<<8))
#define HDMI_PTG_R_C3Y_CB_CR_dummy1800d564_7_0(data)                  (0x000000FF&(data))
#define HDMI_PTG_R_C3Y_CB_CR_get_i_c3y_98b_r(data)                    ((0xC0000000&(data))>>30)
#define HDMI_PTG_R_C3Y_CB_CR_get_i_c3y_72b_grady_r(data)              ((0x3F000000&(data))>>24)
#define HDMI_PTG_R_C3Y_CB_CR_get_i_c3cr_98b_r(data)                   ((0x00C00000&(data))>>22)
#define HDMI_PTG_R_C3Y_CB_CR_get_i_c3cr_72b_gradcr_r(data)            ((0x003F0000&(data))>>16)
#define HDMI_PTG_R_C3Y_CB_CR_get_i_c3cb_98b_r(data)                   ((0x0000C000&(data))>>14)
#define HDMI_PTG_R_C3Y_CB_CR_get_i_c3cb_72b_gradcb_r(data)            ((0x00003F00&(data))>>8)
#define HDMI_PTG_R_C3Y_CB_CR_get_dummy1800d564_7_0(data)              (0x000000FF&(data))


#define HDMI_PTG_R_C4Y_CB_CR                                          0x1800d568
#define HDMI_PTG_R_C4Y_CB_CR_reg_addr                                 "0xb800d568"
#define HDMI_PTG_R_C4Y_CB_CR_reg                                      0xb800d568
#define HDMI_PTG_R_C4Y_CB_CR_inst_addr                                "0x015A"
#define HDMI_PTG_R_C4Y_CB_CR_inst                                     0x015A
#define HDMI_PTG_R_C4Y_CB_CR_i_c4y_96b_r_shift                        (28)
#define HDMI_PTG_R_C4Y_CB_CR_i_c4y_52b_step_hv_r_shift                (24)
#define HDMI_PTG_R_C4Y_CB_CR_i_c4cr_92b_r_shift                       (16)
#define HDMI_PTG_R_C4Y_CB_CR_i_c4cb_9b_r_shift                        (15)
#define HDMI_PTG_R_C4Y_CB_CR_i_c4cb_86b_bmp_w_r_shift                 (12)
#define HDMI_PTG_R_C4Y_CB_CR_i_c4cb_5b_r_shift                        (11)
#define HDMI_PTG_R_C4Y_CB_CR_i_c4cb_42b_bmp_h_r_shift                 (8)
#define HDMI_PTG_R_C4Y_CB_CR_i_c4y_96b_r_mask                         (0xF0000000)
#define HDMI_PTG_R_C4Y_CB_CR_i_c4y_52b_step_hv_r_mask                 (0x0F000000)
#define HDMI_PTG_R_C4Y_CB_CR_i_c4cr_92b_r_mask                        (0x00FF0000)
#define HDMI_PTG_R_C4Y_CB_CR_i_c4cb_9b_r_mask                         (0x00008000)
#define HDMI_PTG_R_C4Y_CB_CR_i_c4cb_86b_bmp_w_r_mask                  (0x00007000)
#define HDMI_PTG_R_C4Y_CB_CR_i_c4cb_5b_r_mask                         (0x00000800)
#define HDMI_PTG_R_C4Y_CB_CR_i_c4cb_42b_bmp_h_r_mask                  (0x00000700)
#define HDMI_PTG_R_C4Y_CB_CR_i_c4y_96b_r(data)                        (0xF0000000&((data)<<28))
#define HDMI_PTG_R_C4Y_CB_CR_i_c4y_52b_step_hv_r(data)                (0x0F000000&((data)<<24))
#define HDMI_PTG_R_C4Y_CB_CR_i_c4cr_92b_r(data)                       (0x00FF0000&((data)<<16))
#define HDMI_PTG_R_C4Y_CB_CR_i_c4cb_9b_r(data)                        (0x00008000&((data)<<15))
#define HDMI_PTG_R_C4Y_CB_CR_i_c4cb_86b_bmp_w_r(data)                 (0x00007000&((data)<<12))
#define HDMI_PTG_R_C4Y_CB_CR_i_c4cb_5b_r(data)                        (0x00000800&((data)<<11))
#define HDMI_PTG_R_C4Y_CB_CR_i_c4cb_42b_bmp_h_r(data)                 (0x00000700&((data)<<8))
#define HDMI_PTG_R_C4Y_CB_CR_get_i_c4y_96b_r(data)                    ((0xF0000000&(data))>>28)
#define HDMI_PTG_R_C4Y_CB_CR_get_i_c4y_52b_step_hv_r(data)            ((0x0F000000&(data))>>24)
#define HDMI_PTG_R_C4Y_CB_CR_get_i_c4cr_92b_r(data)                   ((0x00FF0000&(data))>>16)
#define HDMI_PTG_R_C4Y_CB_CR_get_i_c4cb_9b_r(data)                    ((0x00008000&(data))>>15)
#define HDMI_PTG_R_C4Y_CB_CR_get_i_c4cb_86b_bmp_w_r(data)             ((0x00007000&(data))>>12)
#define HDMI_PTG_R_C4Y_CB_CR_get_i_c4cb_5b_r(data)                    ((0x00000800&(data))>>11)
#define HDMI_PTG_R_C4Y_CB_CR_get_i_c4cb_42b_bmp_h_r(data)             ((0x00000700&(data))>>8)


#define HDMI_PTG_R_C5Y_CR_CB                                          0x1800d56c
#define HDMI_PTG_R_C5Y_CR_CB_reg_addr                                 "0xb800d56c"
#define HDMI_PTG_R_C5Y_CR_CB_reg                                      0xb800d56c
#define HDMI_PTG_R_C5Y_CR_CB_inst_addr                                "0x015B"
#define HDMI_PTG_R_C5Y_CR_CB_inst                                     0x015B
#define HDMI_PTG_R_C5Y_CR_CB_i_c5y_92b_bmptp_r_shift                  (24)
#define HDMI_PTG_R_C5Y_CR_CB_i_c5cr_92b_bmp0_r_shift                  (16)
#define HDMI_PTG_R_C5Y_CR_CB_i_c5cb_92b_bmp1_r_shift                  (8)
#define HDMI_PTG_R_C5Y_CR_CB_dummy1800d56c_7_0_shift                  (0)
#define HDMI_PTG_R_C5Y_CR_CB_i_c5y_92b_bmptp_r_mask                   (0xFF000000)
#define HDMI_PTG_R_C5Y_CR_CB_i_c5cr_92b_bmp0_r_mask                   (0x00FF0000)
#define HDMI_PTG_R_C5Y_CR_CB_i_c5cb_92b_bmp1_r_mask                   (0x0000FF00)
#define HDMI_PTG_R_C5Y_CR_CB_dummy1800d56c_7_0_mask                   (0x000000FF)
#define HDMI_PTG_R_C5Y_CR_CB_i_c5y_92b_bmptp_r(data)                  (0xFF000000&((data)<<24))
#define HDMI_PTG_R_C5Y_CR_CB_i_c5cr_92b_bmp0_r(data)                  (0x00FF0000&((data)<<16))
#define HDMI_PTG_R_C5Y_CR_CB_i_c5cb_92b_bmp1_r(data)                  (0x0000FF00&((data)<<8))
#define HDMI_PTG_R_C5Y_CR_CB_dummy1800d56c_7_0(data)                  (0x000000FF&(data))
#define HDMI_PTG_R_C5Y_CR_CB_get_i_c5y_92b_bmptp_r(data)              ((0xFF000000&(data))>>24)
#define HDMI_PTG_R_C5Y_CR_CB_get_i_c5cr_92b_bmp0_r(data)              ((0x00FF0000&(data))>>16)
#define HDMI_PTG_R_C5Y_CR_CB_get_i_c5cb_92b_bmp1_r(data)              ((0x0000FF00&(data))>>8)
#define HDMI_PTG_R_C5Y_CR_CB_get_dummy1800d56c_7_0(data)              (0x000000FF&(data))


#define HDMI_PTG_R_C6Y_CB_CR                                          0x1800d570
#define HDMI_PTG_R_C6Y_CB_CR_reg_addr                                 "0xb800d570"
#define HDMI_PTG_R_C6Y_CB_CR_reg                                      0xb800d570
#define HDMI_PTG_R_C6Y_CB_CR_inst_addr                                "0x015C"
#define HDMI_PTG_R_C6Y_CB_CR_inst                                     0x015C
#define HDMI_PTG_R_C6Y_CB_CR_i_c6y_92b_bmp2_r_shift                   (24)
#define HDMI_PTG_R_C6Y_CB_CR_i_c6cr_92b_bmp3_r_shift                  (16)
#define HDMI_PTG_R_C6Y_CB_CR_i_c6cb_92b_bmp4_r_shift                  (8)
#define HDMI_PTG_R_C6Y_CB_CR_nonactive_color_def_r_shift              (0)
#define HDMI_PTG_R_C6Y_CB_CR_i_c6y_92b_bmp2_r_mask                    (0xFF000000)
#define HDMI_PTG_R_C6Y_CB_CR_i_c6cr_92b_bmp3_r_mask                   (0x00FF0000)
#define HDMI_PTG_R_C6Y_CB_CR_i_c6cb_92b_bmp4_r_mask                   (0x0000FF00)
#define HDMI_PTG_R_C6Y_CB_CR_nonactive_color_def_r_mask               (0x000000FF)
#define HDMI_PTG_R_C6Y_CB_CR_i_c6y_92b_bmp2_r(data)                   (0xFF000000&((data)<<24))
#define HDMI_PTG_R_C6Y_CB_CR_i_c6cr_92b_bmp3_r(data)                  (0x00FF0000&((data)<<16))
#define HDMI_PTG_R_C6Y_CB_CR_i_c6cb_92b_bmp4_r(data)                  (0x0000FF00&((data)<<8))
#define HDMI_PTG_R_C6Y_CB_CR_nonactive_color_def_r(data)              (0x000000FF&(data))
#define HDMI_PTG_R_C6Y_CB_CR_get_i_c6y_92b_bmp2_r(data)               ((0xFF000000&(data))>>24)
#define HDMI_PTG_R_C6Y_CB_CR_get_i_c6cr_92b_bmp3_r(data)              ((0x00FF0000&(data))>>16)
#define HDMI_PTG_R_C6Y_CB_CR_get_i_c6cb_92b_bmp4_r(data)              ((0x0000FF00&(data))>>8)
#define HDMI_PTG_R_C6Y_CB_CR_get_nonactive_color_def_r(data)          (0x000000FF&(data))


#define HDMI_PTG_R_C7Y_CB_CR                                          0x1800d574
#define HDMI_PTG_R_C7Y_CB_CR_reg_addr                                 "0xb800d574"
#define HDMI_PTG_R_C7Y_CB_CR_reg                                      0xb800d574
#define HDMI_PTG_R_C7Y_CB_CR_inst_addr                                "0x015D"
#define HDMI_PTG_R_C7Y_CB_CR_inst                                     0x015D
#define HDMI_PTG_R_C7Y_CB_CR_i_c7y_92b_bmp5_r_shift                   (24)
#define HDMI_PTG_R_C7Y_CB_CR_i_c7cr_92b_bmp6_r_shift                  (16)
#define HDMI_PTG_R_C7Y_CB_CR_i_c7cb_92b_bmp7_r_shift                  (8)
#define HDMI_PTG_R_C7Y_CB_CR_dummy1800d574_7_0_shift                  (0)
#define HDMI_PTG_R_C7Y_CB_CR_i_c7y_92b_bmp5_r_mask                    (0xFF000000)
#define HDMI_PTG_R_C7Y_CB_CR_i_c7cr_92b_bmp6_r_mask                   (0x00FF0000)
#define HDMI_PTG_R_C7Y_CB_CR_i_c7cb_92b_bmp7_r_mask                   (0x0000FF00)
#define HDMI_PTG_R_C7Y_CB_CR_dummy1800d574_7_0_mask                   (0x000000FF)
#define HDMI_PTG_R_C7Y_CB_CR_i_c7y_92b_bmp5_r(data)                   (0xFF000000&((data)<<24))
#define HDMI_PTG_R_C7Y_CB_CR_i_c7cr_92b_bmp6_r(data)                  (0x00FF0000&((data)<<16))
#define HDMI_PTG_R_C7Y_CB_CR_i_c7cb_92b_bmp7_r(data)                  (0x0000FF00&((data)<<8))
#define HDMI_PTG_R_C7Y_CB_CR_dummy1800d574_7_0(data)                  (0x000000FF&(data))
#define HDMI_PTG_R_C7Y_CB_CR_get_i_c7y_92b_bmp5_r(data)               ((0xFF000000&(data))>>24)
#define HDMI_PTG_R_C7Y_CB_CR_get_i_c7cr_92b_bmp6_r(data)              ((0x00FF0000&(data))>>16)
#define HDMI_PTG_R_C7Y_CB_CR_get_i_c7cb_92b_bmp7_r(data)              ((0x0000FF00&(data))>>8)
#define HDMI_PTG_R_C7Y_CB_CR_get_dummy1800d574_7_0(data)              (0x000000FF&(data))


#define HDMI_PTG_R_MAX_COLOR_CTRL                                     0x1800d578
#define HDMI_PTG_R_MAX_COLOR_CTRL_reg_addr                            "0xb800d578"
#define HDMI_PTG_R_MAX_COLOR_CTRL_reg                                 0xb800d578
#define HDMI_PTG_R_MAX_COLOR_CTRL_inst_addr                           "0x015E"
#define HDMI_PTG_R_MAX_COLOR_CTRL_inst                                0x015E
#define HDMI_PTG_R_MAX_COLOR_CTRL_dummy1800d578_31_27_shift           (27)
#define HDMI_PTG_R_MAX_COLOR_CTRL_max_color_r_shift                   (24)
#define HDMI_PTG_R_MAX_COLOR_CTRL_mv_h_r_shift                        (20)
#define HDMI_PTG_R_MAX_COLOR_CTRL_mv_v_r_shift                        (16)
#define HDMI_PTG_R_MAX_COLOR_CTRL_mv_seq_type_r_shift                 (15)
#define HDMI_PTG_R_MAX_COLOR_CTRL_rdm_period_r_shift                  (12)
#define HDMI_PTG_R_MAX_COLOR_CTRL_mv_vs_num_r_shift                   (8)
#define HDMI_PTG_R_MAX_COLOR_CTRL_mp_adj_num_r_shift                  (0)
#define HDMI_PTG_R_MAX_COLOR_CTRL_dummy1800d578_31_27_mask            (0xF8000000)
#define HDMI_PTG_R_MAX_COLOR_CTRL_max_color_r_mask                    (0x07000000)
#define HDMI_PTG_R_MAX_COLOR_CTRL_mv_h_r_mask                         (0x00F00000)
#define HDMI_PTG_R_MAX_COLOR_CTRL_mv_v_r_mask                         (0x000F0000)
#define HDMI_PTG_R_MAX_COLOR_CTRL_mv_seq_type_r_mask                  (0x00008000)
#define HDMI_PTG_R_MAX_COLOR_CTRL_rdm_period_r_mask                   (0x00007000)
#define HDMI_PTG_R_MAX_COLOR_CTRL_mv_vs_num_r_mask                    (0x00000F00)
#define HDMI_PTG_R_MAX_COLOR_CTRL_mp_adj_num_r_mask                   (0x000000FF)
#define HDMI_PTG_R_MAX_COLOR_CTRL_dummy1800d578_31_27(data)           (0xF8000000&((data)<<27))
#define HDMI_PTG_R_MAX_COLOR_CTRL_max_color_r(data)                   (0x07000000&((data)<<24))
#define HDMI_PTG_R_MAX_COLOR_CTRL_mv_h_r(data)                        (0x00F00000&((data)<<20))
#define HDMI_PTG_R_MAX_COLOR_CTRL_mv_v_r(data)                        (0x000F0000&((data)<<16))
#define HDMI_PTG_R_MAX_COLOR_CTRL_mv_seq_type_r(data)                 (0x00008000&((data)<<15))
#define HDMI_PTG_R_MAX_COLOR_CTRL_rdm_period_r(data)                  (0x00007000&((data)<<12))
#define HDMI_PTG_R_MAX_COLOR_CTRL_mv_vs_num_r(data)                   (0x00000F00&((data)<<8))
#define HDMI_PTG_R_MAX_COLOR_CTRL_mp_adj_num_r(data)                  (0x000000FF&(data))
#define HDMI_PTG_R_MAX_COLOR_CTRL_get_dummy1800d578_31_27(data)       ((0xF8000000&(data))>>27)
#define HDMI_PTG_R_MAX_COLOR_CTRL_get_max_color_r(data)               ((0x07000000&(data))>>24)
#define HDMI_PTG_R_MAX_COLOR_CTRL_get_mv_h_r(data)                    ((0x00F00000&(data))>>20)
#define HDMI_PTG_R_MAX_COLOR_CTRL_get_mv_v_r(data)                    ((0x000F0000&(data))>>16)
#define HDMI_PTG_R_MAX_COLOR_CTRL_get_mv_seq_type_r(data)             ((0x00008000&(data))>>15)
#define HDMI_PTG_R_MAX_COLOR_CTRL_get_rdm_period_r(data)              ((0x00007000&(data))>>12)
#define HDMI_PTG_R_MAX_COLOR_CTRL_get_mv_vs_num_r(data)               ((0x00000F00&(data))>>8)
#define HDMI_PTG_R_MAX_COLOR_CTRL_get_mp_adj_num_r(data)              (0x000000FF&(data))


#define HDMI_CTS_FIFO_CTL                                             0x1800d580
#define HDMI_CTS_FIFO_CTL_reg_addr                                    "0xb800d580"
#define HDMI_CTS_FIFO_CTL_reg                                         0xb800d580
#define HDMI_CTS_FIFO_CTL_inst_addr                                   "0x0160"
#define HDMI_CTS_FIFO_CTL_inst                                        0x0160
#define HDMI_CTS_FIFO_CTL_hdmi_test_sel_shift                         (4)
#define HDMI_CTS_FIFO_CTL_hdmi_out_sel_shift                          (3)
#define HDMI_CTS_FIFO_CTL_force_ctsfifo_rstn_hdmi_shift               (2)
#define HDMI_CTS_FIFO_CTL_en_ctsfifo_vsrst_hdmi_shift                 (1)
#define HDMI_CTS_FIFO_CTL_en_ctsfifo_bypass_hdmi_shift                (0)
#define HDMI_CTS_FIFO_CTL_hdmi_test_sel_mask                          (0x00000070)
#define HDMI_CTS_FIFO_CTL_hdmi_out_sel_mask                           (0x00000008)
#define HDMI_CTS_FIFO_CTL_force_ctsfifo_rstn_hdmi_mask                (0x00000004)
#define HDMI_CTS_FIFO_CTL_en_ctsfifo_vsrst_hdmi_mask                  (0x00000002)
#define HDMI_CTS_FIFO_CTL_en_ctsfifo_bypass_hdmi_mask                 (0x00000001)
#define HDMI_CTS_FIFO_CTL_hdmi_test_sel(data)                         (0x00000070&((data)<<4))
#define HDMI_CTS_FIFO_CTL_hdmi_out_sel(data)                          (0x00000008&((data)<<3))
#define HDMI_CTS_FIFO_CTL_force_ctsfifo_rstn_hdmi(data)               (0x00000004&((data)<<2))
#define HDMI_CTS_FIFO_CTL_en_ctsfifo_vsrst_hdmi(data)                 (0x00000002&((data)<<1))
#define HDMI_CTS_FIFO_CTL_en_ctsfifo_bypass_hdmi(data)                (0x00000001&(data))
#define HDMI_CTS_FIFO_CTL_get_hdmi_test_sel(data)                     ((0x00000070&(data))>>4)
#define HDMI_CTS_FIFO_CTL_get_hdmi_out_sel(data)                      ((0x00000008&(data))>>3)
#define HDMI_CTS_FIFO_CTL_get_force_ctsfifo_rstn_hdmi(data)           ((0x00000004&(data))>>2)
#define HDMI_CTS_FIFO_CTL_get_en_ctsfifo_vsrst_hdmi(data)             ((0x00000002&(data))>>1)
#define HDMI_CTS_FIFO_CTL_get_en_ctsfifo_bypass_hdmi(data)            (0x00000001&(data))
#endif
/*

		VGIP

*/
#define V8_CTRL                                                       0x18022208
#define  V8_CTRL_reg_addr                                                       "0xB8022208"
#define  V8_CTRL_reg                                                            0xB8022208
#define  V8_CTRL_inst_addr                                                      "0x0002"
#define  V8_CTRL_inst                                                           0x0002
#define V8_CTRL_v8_dummy_shift                                        (8)
#define V8_CTRL_dummy18022208_7_2_shift                               (2)
#define V8_CTRL_smfit_vs_delay_sel_shift                              (1)
#define V8_CTRL_ch1_select_duplicate_lsb_shift                        (0)
#define V8_CTRL_v8_dummy_mask                                         (0x0000FF00)
#define V8_CTRL_dummy18022208_7_2_mask                                (0x000000FC)
#define V8_CTRL_smfit_vs_delay_sel_mask                               (0x00000002)
#define V8_CTRL_ch1_select_duplicate_lsb_mask                         (0x00000001)
#define V8_CTRL_v8_dummy(data)                                        (0x0000FF00&((data)<<8))
#define V8_CTRL_dummy18022208_7_2(data)                               (0x000000FC&((data)<<2))
#define V8_CTRL_smfit_vs_delay_sel(data)                              (0x00000002&((data)<<1))
#define V8_CTRL_ch1_select_duplicate_lsb(data)                        (0x00000001&(data))
#define V8_CTRL_get_v8_dummy(data)                                    ((0x0000FF00&(data))>>8)
#define V8_CTRL_get_dummy18022208_7_2(data)                           ((0x000000FC&(data))>>2)
#define V8_CTRL_get_smfit_vs_delay_sel(data)                          ((0x00000002&(data))>>1)
#define V8_CTRL_get_ch1_select_duplicate_lsb(data)                    (0x00000001&(data))

#define  VGIP_GLOBAL_CTRL                                                       0x1802220C
#define  VGIP_GLOBAL_CTRL_reg_addr                                              "0xB802220C"
#define  VGIP_GLOBAL_CTRL_reg                                                   0xB802220C
#define  VGIP_GLOBAL_CTRL_inst_addr                                             "0x0003"
#define  VGIP_GLOBAL_CTRL_inst                                                  0x0003
#define VGIP_GLOBAL_CTRL_auto_l_flag_delay_en_shift                   (31)
#define VGIP_GLOBAL_CTRL_auto_l_flag_delay_num_shift                  (16)
#define VGIP_GLOBAL_CTRL_l_flag_delay_en_shift                        (15)
#define VGIP_GLOBAL_CTRL_l_flag_delay_num_shift                       (0)
#define VGIP_GLOBAL_CTRL_auto_l_flag_delay_en_mask                    (0x80000000)
#define VGIP_GLOBAL_CTRL_auto_l_flag_delay_num_mask                   (0x1FFF0000)
#define VGIP_GLOBAL_CTRL_l_flag_delay_en_mask                         (0x00008000)
#define VGIP_GLOBAL_CTRL_l_flag_delay_num_mask                        (0x00001FFF)
#define VGIP_GLOBAL_CTRL_auto_l_flag_delay_en(data)                   (0x80000000&((data)<<31))
#define VGIP_GLOBAL_CTRL_auto_l_flag_delay_num(data)                  (0x1FFF0000&((data)<<16))
#define VGIP_GLOBAL_CTRL_l_flag_delay_en(data)                        (0x00008000&((data)<<15))
#define VGIP_GLOBAL_CTRL_l_flag_delay_num(data)                       (0x00001FFF&(data))
#define VGIP_GLOBAL_CTRL_get_auto_l_flag_delay_en(data)               ((0x80000000&(data))>>31)
#define VGIP_GLOBAL_CTRL_get_auto_l_flag_delay_num(data)              ((0x1FFF0000&(data))>>16)
#define VGIP_GLOBAL_CTRL_get_l_flag_delay_en(data)                    ((0x00008000&(data))>>15)
#define VGIP_GLOBAL_CTRL_get_l_flag_delay_num(data)                   (0x00001FFF&(data))

//   import use !!!!!!!!!!!!!!!!!!!!!!!!!!!
#define VGIP_CHN1_CTRL                                                0x18022210
#define  VGIP_CHN1_CTRL_reg_addr                                                "0xB8022210"
#define  VGIP_CHN1_CTRL_reg                                                     0xB8022210
#define  VGIP_CHN1_CTRL_inst_addr                                               "0x0004"
#define  VGIP_CHN1_CTRL_inst                                                    0x0004
#define VGIP_CHN1_CTRL_ch1_ivrun_shift                                (31)
#define VGIP_CHN1_CTRL_ch1_in_sel_shift                               (28)
#define VGIP_CHN1_CTRL_ch1_random_en_shift                            (27)
#define VGIP_CHN1_CTRL_ch1_fdrop_en_shift                             (26)
#define VGIP_CHN1_CTRL_ch1_vact_end_ie_shift                          (25)
#define VGIP_CHN1_CTRL_ch1_vact_start_ie_shift                        (24)
#define VGIP_CHN1_CTRL_ch1_field_hs_inv_shift                         (23)
#define VGIP_CHN1_CTRL_ch1_odd_vd_inv_shift                           (22)
#define VGIP_CHN1_CTRL_ch1_odd_vd_en_shift                            (21)
#define VGIP_CHN1_CTRL_ch1_3dleft_inv_shift                           (20)
#define VGIP_CHN1_CTRL_ch1_3dleft_sync_edge_shift                     (19)
#define VGIP_CHN1_CTRL_ch1_odd_inv_shift                              (18)
#define VGIP_CHN1_CTRL_ch1_odd_sync_edge_shift                        (17)
#define VGIP_CHN1_CTRL_ch1_odd_det_en_shift                           (16)
#define VGIP_CHN1_CTRL_ch1_hpact_is_hact_shift                        (15)
#define VGIP_CHN1_CTRL_ch1_fcap_str_odd_shift                         (14)
#define VGIP_CHN1_CTRL_ch1_mask_den_inv_shift                         (13)
#define VGIP_CHN1_CTRL_ch1_mask_den_1l_shift                          (12)
#define VGIP_CHN1_CTRL_ch1_3d_mode_en_shift                           (11)
#define VGIP_CHN1_CTRL_ch1_safe_odd_inv_shift                         (10)
#define VGIP_CHN1_CTRL_ch1_force_tog_shift                            (9)
#define VGIP_CHN1_CTRL_ch1_safe_mode_shift                            (8)
#define VGIP_CHN1_CTRL_ch1_3d_right_act_en_shift                      (7)
#define VGIP_CHN1_CTRL_ch1_hs_syncedge_shift                          (6)
#define VGIP_CHN1_CTRL_ch1_vs_syncedge_shift                          (5)
#define VGIP_CHN1_CTRL_ch1_vs_by_hs_en_n_shift                        (4)
#define VGIP_CHN1_CTRL_ch1_vs_inv_shift                               (3)
#define VGIP_CHN1_CTRL_ch1_hs_inv_shift                               (2)
#define VGIP_CHN1_CTRL_ch1_digital_mode_shift                         (1)
#define VGIP_CHN1_CTRL_ch1_in_clk_en_shift                            (0)
#define VGIP_CHN1_CTRL_ch1_ivrun_mask                                 (0x80000000)
#define VGIP_CHN1_CTRL_ch1_in_sel_mask                                (0x70000000)
#define VGIP_CHN1_CTRL_ch1_random_en_mask                             (0x08000000)
#define VGIP_CHN1_CTRL_ch1_fdrop_en_mask                              (0x04000000)
#define VGIP_CHN1_CTRL_ch1_vact_end_ie_mask                           (0x02000000)
#define VGIP_CHN1_CTRL_ch1_vact_start_ie_mask                         (0x01000000)
#define VGIP_CHN1_CTRL_ch1_field_hs_inv_mask                          (0x00800000)
#define VGIP_CHN1_CTRL_ch1_odd_vd_inv_mask                            (0x00400000)
#define VGIP_CHN1_CTRL_ch1_odd_vd_en_mask                             (0x00200000)
#define VGIP_CHN1_CTRL_ch1_3dleft_inv_mask                            (0x00100000)
#define VGIP_CHN1_CTRL_ch1_3dleft_sync_edge_mask                      (0x00080000)
#define VGIP_CHN1_CTRL_ch1_odd_inv_mask                               (0x00040000)
#define VGIP_CHN1_CTRL_ch1_odd_sync_edge_mask                         (0x00020000)
#define VGIP_CHN1_CTRL_ch1_odd_det_en_mask                            (0x00010000)
#define VGIP_CHN1_CTRL_ch1_hpact_is_hact_mask                         (0x00008000)
#define VGIP_CHN1_CTRL_ch1_fcap_str_odd_mask                          (0x00004000)
#define VGIP_CHN1_CTRL_ch1_mask_den_inv_mask                          (0x00002000)
#define VGIP_CHN1_CTRL_ch1_mask_den_1l_mask                           (0x00001000)
#define VGIP_CHN1_CTRL_ch1_3d_mode_en_mask                            (0x00000800)
#define VGIP_CHN1_CTRL_ch1_safe_odd_inv_mask                          (0x00000400)
#define VGIP_CHN1_CTRL_ch1_force_tog_mask                             (0x00000200)
#define VGIP_CHN1_CTRL_ch1_safe_mode_mask                             (0x00000100)
#define VGIP_CHN1_CTRL_ch1_3d_right_act_en_mask                       (0x00000080)
#define VGIP_CHN1_CTRL_ch1_hs_syncedge_mask                           (0x00000040)
#define VGIP_CHN1_CTRL_ch1_vs_syncedge_mask                           (0x00000020)
#define VGIP_CHN1_CTRL_ch1_vs_by_hs_en_n_mask                         (0x00000010)
#define VGIP_CHN1_CTRL_ch1_vs_inv_mask                                (0x00000008)
#define VGIP_CHN1_CTRL_ch1_hs_inv_mask                                (0x00000004)
#define VGIP_CHN1_CTRL_ch1_digital_mode_mask                          (0x00000002)
#define VGIP_CHN1_CTRL_ch1_in_clk_en_mask                             (0x00000001)
#define VGIP_CHN1_CTRL_ch1_ivrun(data)                                (0x80000000&((data)<<31))
#define VGIP_CHN1_CTRL_ch1_in_sel(data)                               (0x70000000&((data)<<28))
#define VGIP_CHN1_CTRL_ch1_random_en(data)                            (0x08000000&((data)<<27))
#define VGIP_CHN1_CTRL_ch1_fdrop_en(data)                             (0x04000000&((data)<<26))
#define VGIP_CHN1_CTRL_ch1_vact_end_ie(data)                          (0x02000000&((data)<<25))
#define VGIP_CHN1_CTRL_ch1_vact_start_ie(data)                        (0x01000000&((data)<<24))
#define VGIP_CHN1_CTRL_ch1_field_hs_inv(data)                         (0x00800000&((data)<<23))
#define VGIP_CHN1_CTRL_ch1_odd_vd_inv(data)                           (0x00400000&((data)<<22))
#define VGIP_CHN1_CTRL_ch1_odd_vd_en(data)                            (0x00200000&((data)<<21))
#define VGIP_CHN1_CTRL_ch1_3dleft_inv(data)                           (0x00100000&((data)<<20))
#define VGIP_CHN1_CTRL_ch1_3dleft_sync_edge(data)                     (0x00080000&((data)<<19))
#define VGIP_CHN1_CTRL_ch1_odd_inv(data)                              (0x00040000&((data)<<18))
#define VGIP_CHN1_CTRL_ch1_odd_sync_edge(data)                        (0x00020000&((data)<<17))
#define VGIP_CHN1_CTRL_ch1_odd_det_en(data)                           (0x00010000&((data)<<16))
#define VGIP_CHN1_CTRL_ch1_hpact_is_hact(data)                        (0x00008000&((data)<<15))
#define VGIP_CHN1_CTRL_ch1_fcap_str_odd(data)                         (0x00004000&((data)<<14))
#define VGIP_CHN1_CTRL_ch1_mask_den_inv(data)                         (0x00002000&((data)<<13))
#define VGIP_CHN1_CTRL_ch1_mask_den_1l(data)                          (0x00001000&((data)<<12))
#define VGIP_CHN1_CTRL_ch1_3d_mode_en(data)                           (0x00000800&((data)<<11))
#define VGIP_CHN1_CTRL_ch1_safe_odd_inv(data)                         (0x00000400&((data)<<10))
#define VGIP_CHN1_CTRL_ch1_force_tog(data)                            (0x00000200&((data)<<9))
#define VGIP_CHN1_CTRL_ch1_safe_mode(data)                            (0x00000100&((data)<<8))
#define VGIP_CHN1_CTRL_ch1_3d_right_act_en(data)                      (0x00000080&((data)<<7))
#define VGIP_CHN1_CTRL_ch1_hs_syncedge(data)                          (0x00000040&((data)<<6))
#define VGIP_CHN1_CTRL_ch1_vs_syncedge(data)                          (0x00000020&((data)<<5))
#define VGIP_CHN1_CTRL_ch1_vs_by_hs_en_n(data)                        (0x00000010&((data)<<4))
#define VGIP_CHN1_CTRL_ch1_vs_inv(data)                               (0x00000008&((data)<<3))
#define VGIP_CHN1_CTRL_ch1_hs_inv(data)                               (0x00000004&((data)<<2))
#define VGIP_CHN1_CTRL_ch1_digital_mode(data)                         (0x00000002&((data)<<1))
#define VGIP_CHN1_CTRL_ch1_in_clk_en(data)                            (0x00000001&(data))
#define VGIP_CHN1_CTRL_get_ch1_ivrun(data)                            ((0x80000000&(data))>>31)
#define VGIP_CHN1_CTRL_get_ch1_in_sel(data)                           ((0x70000000&(data))>>28)
#define VGIP_CHN1_CTRL_get_ch1_random_en(data)                        ((0x08000000&(data))>>27)
#define VGIP_CHN1_CTRL_get_ch1_fdrop_en(data)                         ((0x04000000&(data))>>26)
#define VGIP_CHN1_CTRL_get_ch1_vact_end_ie(data)                      ((0x02000000&(data))>>25)
#define VGIP_CHN1_CTRL_get_ch1_vact_start_ie(data)                    ((0x01000000&(data))>>24)
#define VGIP_CHN1_CTRL_get_ch1_field_hs_inv(data)                     ((0x00800000&(data))>>23)
#define VGIP_CHN1_CTRL_get_ch1_odd_vd_inv(data)                       ((0x00400000&(data))>>22)
#define VGIP_CHN1_CTRL_get_ch1_odd_vd_en(data)                        ((0x00200000&(data))>>21)
#define VGIP_CHN1_CTRL_get_ch1_3dleft_inv(data)                       ((0x00100000&(data))>>20)
#define VGIP_CHN1_CTRL_get_ch1_3dleft_sync_edge(data)                 ((0x00080000&(data))>>19)
#define VGIP_CHN1_CTRL_get_ch1_odd_inv(data)                          ((0x00040000&(data))>>18)
#define VGIP_CHN1_CTRL_get_ch1_odd_sync_edge(data)                    ((0x00020000&(data))>>17)
#define VGIP_CHN1_CTRL_get_ch1_odd_det_en(data)                       ((0x00010000&(data))>>16)
#define VGIP_CHN1_CTRL_get_ch1_hpact_is_hact(data)                    ((0x00008000&(data))>>15)
#define VGIP_CHN1_CTRL_get_ch1_fcap_str_odd(data)                     ((0x00004000&(data))>>14)
#define VGIP_CHN1_CTRL_get_ch1_mask_den_inv(data)                     ((0x00002000&(data))>>13)
#define VGIP_CHN1_CTRL_get_ch1_mask_den_1l(data)                      ((0x00001000&(data))>>12)
#define VGIP_CHN1_CTRL_get_ch1_3d_mode_en(data)                       ((0x00000800&(data))>>11)
#define VGIP_CHN1_CTRL_get_ch1_safe_odd_inv(data)                     ((0x00000400&(data))>>10)
#define VGIP_CHN1_CTRL_get_ch1_force_tog(data)                        ((0x00000200&(data))>>9)
#define VGIP_CHN1_CTRL_get_ch1_safe_mode(data)                        ((0x00000100&(data))>>8)
#define VGIP_CHN1_CTRL_get_ch1_3d_right_act_en(data)                  ((0x00000080&(data))>>7)
#define VGIP_CHN1_CTRL_get_ch1_hs_syncedge(data)                      ((0x00000040&(data))>>6)
#define VGIP_CHN1_CTRL_get_ch1_vs_syncedge(data)                      ((0x00000020&(data))>>5)
#define VGIP_CHN1_CTRL_get_ch1_vs_by_hs_en_n(data)                    ((0x00000010&(data))>>4)
#define VGIP_CHN1_CTRL_get_ch1_vs_inv(data)                           ((0x00000008&(data))>>3)
#define VGIP_CHN1_CTRL_get_ch1_hs_inv(data)                           ((0x00000004&(data))>>2)
#define VGIP_CHN1_CTRL_get_ch1_digital_mode(data)                     ((0x00000002&(data))>>1)
#define VGIP_CHN1_CTRL_get_ch1_in_clk_en(data)                        (0x00000001&(data))

//   import use !!!!!!!!!!!!!!!!!!!!!!!!!!!
#define VGIP_CHN1_STATUS                                              0x18022214
#define  VGIP_CHN1_STATUS_reg_addr                                              "0xB8022214"
#define  VGIP_CHN1_STATUS_reg                                                   0xB8022214
#define  VGIP_CHN1_STATUS_inst_addr                                             "0x0005"
#define  VGIP_CHN1_STATUS_inst                                                  0x0005
#define VGIP_CHN1_STATUS_ch1_vs_end_shift                             (27)
#define VGIP_CHN1_STATUS_ch1_vs_start_shift                           (26)
#define VGIP_CHN1_STATUS_ch1_vact_end_shift                           (25)
#define VGIP_CHN1_STATUS_ch1_vact_start_shift                         (24)
#define VGIP_CHN1_STATUS_dummy18022214_23_18_shift                    (18)
#define VGIP_CHN1_STATUS_ch1_vlc_status_shift                         (16)
#define VGIP_CHN1_STATUS_ch1_rl_err_shift                             (15)
#define VGIP_CHN1_STATUS_ch1_vs_err_shift                             (14)
#define VGIP_CHN1_STATUS_ch1_hs_err_shift                             (13)
#define VGIP_CHN1_STATUS_ch1_field_err_shift                          (12)
#define VGIP_CHN1_STATUS_ch1_rl_tog_shift                             (11)
#define VGIP_CHN1_STATUS_ch1_l_flag_pol_shift                         (10)
#define VGIP_CHN1_STATUS_ch1_vs_tog_shift                             (9)
#define VGIP_CHN1_STATUS_ch1_hs_tog_shift                             (8)
#define VGIP_CHN1_STATUS_ch1_field_pol_shift                          (7)
#define VGIP_CHN1_STATUS_ch1_field_tog_shift                          (6)
#define VGIP_CHN1_STATUS_ch1_field_vs_lsb_shift                       (4)
#define VGIP_CHN1_STATUS_ch1_more_1line_field_shift                   (3)
#define VGIP_CHN1_STATUS_ch1_bounce_status_2_shift                    (2)
#define VGIP_CHN1_STATUS_ch1_bounce_status_1_shift                    (1)
#define VGIP_CHN1_STATUS_ch1_bounce_status_0_shift                    (0)
#define VGIP_CHN1_STATUS_ch1_vs_end_mask                              (0x08000000)
#define VGIP_CHN1_STATUS_ch1_vs_start_mask                            (0x04000000)
#define VGIP_CHN1_STATUS_ch1_vact_end_mask                            (0x02000000)
#define VGIP_CHN1_STATUS_ch1_vact_start_mask                          (0x01000000)
#define VGIP_CHN1_STATUS_dummy18022214_23_18_mask                     (0x00FC0000)
#define VGIP_CHN1_STATUS_ch1_vlc_status_mask                          (0x00010000)
#define VGIP_CHN1_STATUS_ch1_rl_err_mask                              (0x00008000)
#define VGIP_CHN1_STATUS_ch1_vs_err_mask                              (0x00004000)
#define VGIP_CHN1_STATUS_ch1_hs_err_mask                              (0x00002000)
#define VGIP_CHN1_STATUS_ch1_field_err_mask                           (0x00001000)
#define VGIP_CHN1_STATUS_ch1_rl_tog_mask                              (0x00000800)
#define VGIP_CHN1_STATUS_ch1_l_flag_pol_mask                          (0x00000400)
#define VGIP_CHN1_STATUS_ch1_vs_tog_mask                              (0x00000200)
#define VGIP_CHN1_STATUS_ch1_hs_tog_mask                              (0x00000100)
#define VGIP_CHN1_STATUS_ch1_field_pol_mask                           (0x00000080)
#define VGIP_CHN1_STATUS_ch1_field_tog_mask                           (0x00000040)
#define VGIP_CHN1_STATUS_ch1_field_vs_lsb_mask                        (0x00000030)
#define VGIP_CHN1_STATUS_ch1_more_1line_field_mask                    (0x00000008)
#define VGIP_CHN1_STATUS_ch1_bounce_status_2_mask                     (0x00000004)
#define VGIP_CHN1_STATUS_ch1_bounce_status_1_mask                     (0x00000002)
#define VGIP_CHN1_STATUS_ch1_bounce_status_0_mask                     (0x00000001)
#define VGIP_CHN1_STATUS_ch1_vs_end(data)                             (0x08000000&((data)<<27))
#define VGIP_CHN1_STATUS_ch1_vs_start(data)                           (0x04000000&((data)<<26))
#define VGIP_CHN1_STATUS_ch1_vact_end(data)                           (0x02000000&((data)<<25))
#define VGIP_CHN1_STATUS_ch1_vact_start(data)                         (0x01000000&((data)<<24))
#define VGIP_CHN1_STATUS_dummy18022214_23_18(data)                    (0x00FC0000&((data)<<18))
#define VGIP_CHN1_STATUS_ch1_vlc_status(data)                         (0x00010000&((data)<<16))
#define VGIP_CHN1_STATUS_ch1_rl_err(data)                             (0x00008000&((data)<<15))
#define VGIP_CHN1_STATUS_ch1_vs_err(data)                             (0x00004000&((data)<<14))
#define VGIP_CHN1_STATUS_ch1_hs_err(data)                             (0x00002000&((data)<<13))
#define VGIP_CHN1_STATUS_ch1_field_err(data)                          (0x00001000&((data)<<12))
#define VGIP_CHN1_STATUS_ch1_rl_tog(data)                             (0x00000800&((data)<<11))
#define VGIP_CHN1_STATUS_ch1_l_flag_pol(data)                         (0x00000400&((data)<<10))
#define VGIP_CHN1_STATUS_ch1_vs_tog(data)                             (0x00000200&((data)<<9))
#define VGIP_CHN1_STATUS_ch1_hs_tog(data)                             (0x00000100&((data)<<8))
#define VGIP_CHN1_STATUS_ch1_field_pol(data)                          (0x00000080&((data)<<7))
#define VGIP_CHN1_STATUS_ch1_field_tog(data)                          (0x00000040&((data)<<6))
#define VGIP_CHN1_STATUS_ch1_field_vs_lsb(data)                       (0x00000030&((data)<<4))
#define VGIP_CHN1_STATUS_ch1_more_1line_field(data)                   (0x00000008&((data)<<3))
#define VGIP_CHN1_STATUS_ch1_bounce_status_2(data)                    (0x00000004&((data)<<2))
#define VGIP_CHN1_STATUS_ch1_bounce_status_1(data)                    (0x00000002&((data)<<1))
#define VGIP_CHN1_STATUS_ch1_bounce_status_0(data)                    (0x00000001&(data))
#define VGIP_CHN1_STATUS_get_ch1_vs_end(data)                         ((0x08000000&(data))>>27)
#define VGIP_CHN1_STATUS_get_ch1_vs_start(data)                       ((0x04000000&(data))>>26)
#define VGIP_CHN1_STATUS_get_ch1_vact_end(data)                       ((0x02000000&(data))>>25)
#define VGIP_CHN1_STATUS_get_ch1_vact_start(data)                     ((0x01000000&(data))>>24)
#define VGIP_CHN1_STATUS_get_dummy18022214_23_18(data)                ((0x00FC0000&(data))>>18)
#define VGIP_CHN1_STATUS_get_ch1_vlc_status(data)                     ((0x00010000&(data))>>16)
#define VGIP_CHN1_STATUS_get_ch1_rl_err(data)                         ((0x00008000&(data))>>15)
#define VGIP_CHN1_STATUS_get_ch1_vs_err(data)                         ((0x00004000&(data))>>14)
#define VGIP_CHN1_STATUS_get_ch1_hs_err(data)                         ((0x00002000&(data))>>13)
#define VGIP_CHN1_STATUS_get_ch1_field_err(data)                      ((0x00001000&(data))>>12)
#define VGIP_CHN1_STATUS_get_ch1_rl_tog(data)                         ((0x00000800&(data))>>11)
#define VGIP_CHN1_STATUS_get_ch1_l_flag_pol(data)                     ((0x00000400&(data))>>10)
#define VGIP_CHN1_STATUS_get_ch1_vs_tog(data)                         ((0x00000200&(data))>>9)
#define VGIP_CHN1_STATUS_get_ch1_hs_tog(data)                         ((0x00000100&(data))>>8)
#define VGIP_CHN1_STATUS_get_ch1_field_pol(data)                      ((0x00000080&(data))>>7)
#define VGIP_CHN1_STATUS_get_ch1_field_tog(data)                      ((0x00000040&(data))>>6)
#define VGIP_CHN1_STATUS_get_ch1_field_vs_lsb(data)                   ((0x00000030&(data))>>4)
#define VGIP_CHN1_STATUS_get_ch1_more_1line_field(data)               ((0x00000008&(data))>>3)
#define VGIP_CHN1_STATUS_get_ch1_bounce_status_2(data)                ((0x00000004&(data))>>2)
#define VGIP_CHN1_STATUS_get_ch1_bounce_status_1(data)                ((0x00000002&(data))>>1)
#define VGIP_CHN1_STATUS_get_ch1_bounce_status_0(data)                (0x00000001&(data))

//   import use !!!!!!!!!!!!!!!!!!!!!!!!!!!
#define VGIP_CHN1_ACT_HSTA_WIDTH                                      0x18022218
#define VGIP_CHN1_ACT_HSTA_WIDTH_reg_addr                             "0xb8022218"
#define VGIP_CHN1_ACT_HSTA_WIDTH_reg                                  0xb8022218
#define VGIP_CHN1_ACT_HSTA_WIDTH_inst_addr                            "0x0086"
#define VGIP_CHN1_ACT_HSTA_WIDTH_inst                                 0x0086
#define VGIP_CHN1_ACT_HSTA_WIDTH_ch1_db_rdy_shift                     (31)
#define VGIP_CHN1_ACT_HSTA_WIDTH_ch1_db_en_shift                      (30)
#define VGIP_CHN1_ACT_HSTA_WIDTH_ch1_ih_act_sta_shift                 (16)
#define VGIP_CHN1_ACT_HSTA_WIDTH_ch1_db_read_sel_shift                (15)
#define VGIP_CHN1_ACT_HSTA_WIDTH_ch1_ih_act_wid_shift                 (0)
#define VGIP_CHN1_ACT_HSTA_WIDTH_ch1_db_rdy_mask                      (0x80000000)
#define VGIP_CHN1_ACT_HSTA_WIDTH_ch1_db_en_mask                       (0x40000000)
#define VGIP_CHN1_ACT_HSTA_WIDTH_ch1_ih_act_sta_mask                  (0x3FFF0000)
#define VGIP_CHN1_ACT_HSTA_WIDTH_ch1_db_read_sel_mask                 (0x00008000)
#define VGIP_CHN1_ACT_HSTA_WIDTH_ch1_ih_act_wid_mask                  (0x00003FFF)
#define VGIP_CHN1_ACT_HSTA_WIDTH_ch1_db_rdy(data)                     (0x80000000&((data)<<31))
#define VGIP_CHN1_ACT_HSTA_WIDTH_ch1_db_en(data)                      (0x40000000&((data)<<30))
#define VGIP_CHN1_ACT_HSTA_WIDTH_ch1_ih_act_sta(data)                 (0x3FFF0000&((data)<<16))
#define VGIP_CHN1_ACT_HSTA_WIDTH_ch1_db_read_sel(data)                (0x00008000&((data)<<15))
#define VGIP_CHN1_ACT_HSTA_WIDTH_ch1_ih_act_wid(data)                 (0x00003FFF&(data))
#define VGIP_CHN1_ACT_HSTA_WIDTH_get_ch1_db_rdy(data)                 ((0x80000000&(data))>>31)
#define VGIP_CHN1_ACT_HSTA_WIDTH_get_ch1_db_en(data)                  ((0x40000000&(data))>>30)
#define VGIP_CHN1_ACT_HSTA_WIDTH_get_ch1_ih_act_sta(data)             ((0x3FFF0000&(data))>>16)
#define VGIP_CHN1_ACT_HSTA_WIDTH_get_ch1_db_read_sel(data)            ((0x00008000&(data))>>15)
#define VGIP_CHN1_ACT_HSTA_WIDTH_get_ch1_ih_act_wid(data)             (0x00003FFF&(data))

//   import use !!!!!!!!!!!!!!!!!!!!!!!!!!!
#define VGIP_CHN1_ACT_VSTA_LENGTH                                     0x1802221c
#define VGIP_CHN1_ACT_VSTA_LENGTH_reg_addr                            "0xb802221c"
#define VGIP_CHN1_ACT_VSTA_LENGTH_reg                                 0xb802221c
#define VGIP_CHN1_ACT_VSTA_LENGTH_inst_addr                           "0x0087"
#define VGIP_CHN1_ACT_VSTA_LENGTH_inst                                0x0087
#define VGIP_CHN1_ACT_VSTA_LENGTH_ch1_iv_act_sta_shift                (16)
#define VGIP_CHN1_ACT_VSTA_LENGTH_ch1_iv_act_len_shift                (0)
#define VGIP_CHN1_ACT_VSTA_LENGTH_ch1_iv_act_sta_mask                 (0x1FFF0000)
#define VGIP_CHN1_ACT_VSTA_LENGTH_ch1_iv_act_len_mask                 (0x00001FFF)
#define VGIP_CHN1_ACT_VSTA_LENGTH_ch1_iv_act_sta(data)                (0x1FFF0000&((data)<<16))
#define VGIP_CHN1_ACT_VSTA_LENGTH_ch1_iv_act_len(data)                (0x00001FFF&(data))
#define VGIP_CHN1_ACT_VSTA_LENGTH_get_ch1_iv_act_sta(data)            ((0x1FFF0000&(data))>>16)
#define VGIP_CHN1_ACT_VSTA_LENGTH_get_ch1_iv_act_len(data)            (0x00001FFF&(data))

//   import use !!!!!!!!!!!!!!!!!!!!!!!!!!!
#define VGIP_CHN1_DELAY                                               0x18022220
#define  VGIP_CHN1_DELAY_reg_addr                                               "0xB8022220"
#define  VGIP_CHN1_DELAY_reg                                                    0xB8022220
#define  VGIP_CHN1_DELAY_inst_addr                                              "0x0008"
#define  VGIP_CHN1_DELAY_inst                                                   0x0008
#define  VGIP_CHN1_DELAY_ch1_hs_width_shift                                     (30)
#define VGIP_CHN1_DELAY_ch1_ihs_dly_shift                             (16)
#define VGIP_CHN1_DELAY_ch1_ivs_dly_shift                             (0)
#define  VGIP_CHN1_DELAY_ch1_hs_width_mask                                      (0xC0000000)
#define VGIP_CHN1_DELAY_ch1_ihs_dly_mask                              (0x3FFF0000)
#define VGIP_CHN1_DELAY_ch1_ivs_dly_mask                              (0x00001FFF)
#define  VGIP_CHN1_DELAY_ch1_hs_width(data)                                     (0xC0000000&((data)<<30))
#define VGIP_CHN1_DELAY_ch1_ihs_dly(data)                             (0x3FFF0000&((data)<<16))
#define VGIP_CHN1_DELAY_ch1_ivs_dly(data)                             (0x00001FFF&(data))
#define  VGIP_CHN1_DELAY_get_ch1_hs_width(data)                                 ((0xC0000000&(data))>>30)
#define VGIP_CHN1_DELAY_get_ch1_ihs_dly(data)                         ((0x3FFF0000&(data))>>16)
#define VGIP_CHN1_DELAY_get_ch1_ivs_dly(data)                         (0x00001FFF&(data))

#define VGIP_CHN1_MISC                                                0x18022224
#define  VGIP_CHN1_MISC_reg_addr                                                "0xB8022224"
#define  VGIP_CHN1_MISC_reg                                                     0xB8022224
#define  VGIP_CHN1_MISC_inst_addr                                               "0x0009"
#define  VGIP_CHN1_MISC_inst                                                    0x0009
#define VGIP_CHN1_MISC_ch1_de_mask_en_shift                           (31)
#define VGIP_CHN1_MISC_ch1_hporch_num_sel_shift                       (24)
#define VGIP_CHN1_MISC_l_flag_force_tog_shift                         (21)
#define VGIP_CHN1_MISC_ch1_hporch_num_shift                           (8)
#define VGIP_CHN1_MISC_ch1_auto_ihs_dly_shift                         (6)
#define VGIP_CHN1_MISC_ch1_auto_ivs_dly_shift                         (4)
#define VGIP_CHN1_MISC_ch1_hdly_one_shift                             (3)
#define VGIP_CHN1_MISC_ch1_v1_v2_swap_shift                           (2)
#define VGIP_CHN1_MISC_ch1_v2_v3_swap_shift                           (1)
#define VGIP_CHN1_MISC_ch1_v1_v3_swap_shift                           (0)
#define VGIP_CHN1_MISC_ch1_de_mask_en_mask                            (0x80000000)
#define VGIP_CHN1_MISC_ch1_hporch_num_sel_mask                        (0x01000000)
#define VGIP_CHN1_MISC_l_flag_force_tog_mask                          (0x00200000)
#define VGIP_CHN1_MISC_ch1_hporch_num_mask                            (0x001FFF00)
#define VGIP_CHN1_MISC_ch1_auto_ihs_dly_mask                          (0x000000C0)
#define VGIP_CHN1_MISC_ch1_auto_ivs_dly_mask                          (0x00000030)
#define VGIP_CHN1_MISC_ch1_hdly_one_mask                              (0x00000008)
#define VGIP_CHN1_MISC_ch1_v1_v2_swap_mask                            (0x00000004)
#define VGIP_CHN1_MISC_ch1_v2_v3_swap_mask                            (0x00000002)
#define VGIP_CHN1_MISC_ch1_v1_v3_swap_mask                            (0x00000001)
#define VGIP_CHN1_MISC_ch1_de_mask_en(data)                           (0x80000000&((data)<<31))
#define VGIP_CHN1_MISC_ch1_hporch_num_sel(data)                       (0x01000000&((data)<<24))
#define VGIP_CHN1_MISC_l_flag_force_tog(data)                         (0x00200000&((data)<<21))
#define VGIP_CHN1_MISC_ch1_hporch_num(data)                           (0x001FFF00&((data)<<8))
#define VGIP_CHN1_MISC_ch1_auto_ihs_dly(data)                         (0x000000C0&((data)<<6))
#define VGIP_CHN1_MISC_ch1_auto_ivs_dly(data)                         (0x00000030&((data)<<4))
#define VGIP_CHN1_MISC_ch1_hdly_one(data)                             (0x00000008&((data)<<3))
#define VGIP_CHN1_MISC_ch1_v1_v2_swap(data)                           (0x00000004&((data)<<2))
#define VGIP_CHN1_MISC_ch1_v2_v3_swap(data)                           (0x00000002&((data)<<1))
#define VGIP_CHN1_MISC_ch1_v1_v3_swap(data)                           (0x00000001&(data))
#define VGIP_CHN1_MISC_get_ch1_de_mask_en(data)                       ((0x80000000&(data))>>31)
#define VGIP_CHN1_MISC_get_ch1_hporch_num_sel(data)                   ((0x01000000&(data))>>24)
#define VGIP_CHN1_MISC_get_l_flag_force_tog(data)                     ((0x00200000&(data))>>21)
#define VGIP_CHN1_MISC_get_ch1_hporch_num(data)                       ((0x001FFF00&(data))>>8)
#define VGIP_CHN1_MISC_get_ch1_auto_ihs_dly(data)                     ((0x000000C0&(data))>>6)
#define VGIP_CHN1_MISC_get_ch1_auto_ivs_dly(data)                     ((0x00000030&(data))>>4)
#define VGIP_CHN1_MISC_get_ch1_hdly_one(data)                         ((0x00000008&(data))>>3)
#define VGIP_CHN1_MISC_get_ch1_v1_v2_swap(data)                       ((0x00000004&(data))>>2)
#define VGIP_CHN1_MISC_get_ch1_v2_v3_swap(data)                       ((0x00000002&(data))>>1)
#define VGIP_CHN1_MISC_get_ch1_v1_v3_swap(data)                       (0x00000001&(data))

#define VGIP_CHN1_PTN_H_VI                                            0x18022228
#define  VGIP_CHN1_PTN_H_VI_reg_addr                                            "0xB8022228"
#define  VGIP_CHN1_PTN_H_VI_reg                                                 0xB8022228
#define  VGIP_CHN1_PTN_H_VI_inst_addr                                           "0x000A"
#define  VGIP_CHN1_PTN_H_VI_inst                                                0x000A
#define VGIP_CHN1_PTN_H_VI_ch1_captst_en_shift                        (31)
#define VGIP_CHN1_PTN_H_VI_ch1_captst_mode_shift                      (30)
#define VGIP_CHN1_PTN_H_VI_ch1_vcaptst_num_shift                      (16)
#define VGIP_CHN1_PTN_H_VI_ch1_hcaptst_num_shift                      (0)
#define VGIP_CHN1_PTN_H_VI_ch1_captst_en_mask                         (0x80000000)
#define VGIP_CHN1_PTN_H_VI_ch1_captst_mode_mask                       (0x40000000)
#define VGIP_CHN1_PTN_H_VI_ch1_vcaptst_num_mask                       (0x1FFF0000)
#define VGIP_CHN1_PTN_H_VI_ch1_hcaptst_num_mask                       (0x00003FFF)
#define VGIP_CHN1_PTN_H_VI_ch1_captst_en(data)                        (0x80000000&((data)<<31))
#define VGIP_CHN1_PTN_H_VI_ch1_captst_mode(data)                      (0x40000000&((data)<<30))
#define VGIP_CHN1_PTN_H_VI_ch1_vcaptst_num(data)                      (0x1FFF0000&((data)<<16))
#define VGIP_CHN1_PTN_H_VI_ch1_hcaptst_num(data)                      (0x00003FFF&(data))
#define VGIP_CHN1_PTN_H_VI_get_ch1_captst_en(data)                    ((0x80000000&(data))>>31)
#define VGIP_CHN1_PTN_H_VI_get_ch1_captst_mode(data)                  ((0x40000000&(data))>>30)
#define VGIP_CHN1_PTN_H_VI_get_ch1_vcaptst_num(data)                  ((0x1FFF0000&(data))>>16)
#define VGIP_CHN1_PTN_H_VI_get_ch1_hcaptst_num(data)                  (0x00003FFF&(data))

#define  VGIP_CHN1_PTN0                                                         0x1802222C
#define  VGIP_CHN1_PTN0_reg_addr                                                "0xB802222C"
#define  VGIP_CHN1_PTN0_reg                                                     0xB802222C
#define  VGIP_CHN1_PTN0_inst_addr                                               "0x000B"
#define  VGIP_CHN1_PTN0_inst                                                    0x000B
#define VGIP_CHN1_PTN0_ch1_captst_r_data_shift                        (16)
#define VGIP_CHN1_PTN0_ch1_captst_g_data_shift                        (0)
#define VGIP_CHN1_PTN0_ch1_captst_r_data_mask                         (0x0FFF0000)
#define VGIP_CHN1_PTN0_ch1_captst_g_data_mask                         (0x00000FFF)
#define VGIP_CHN1_PTN0_ch1_captst_r_data(data)                        (0x0FFF0000&((data)<<16))
#define VGIP_CHN1_PTN0_ch1_captst_g_data(data)                        (0x00000FFF&(data))
#define VGIP_CHN1_PTN0_get_ch1_captst_r_data(data)                    ((0x0FFF0000&(data))>>16)
#define VGIP_CHN1_PTN0_get_ch1_captst_g_data(data)                    (0x00000FFF&(data))

#define VGIP_CHN1_PTN1                                                0x18022230
#define  VGIP_CHN1_PTN1_reg_addr                                                "0xB8022230"
#define  VGIP_CHN1_PTN1_reg                                                     0xB8022230
#define  VGIP_CHN1_PTN1_inst_addr                                               "0x000C"
#define  VGIP_CHN1_PTN1_inst                                                    0x000C
#define VGIP_CHN1_PTN1_ch1_hporch_num_sel_shift                       (16)
#define VGIP_CHN1_PTN1_ch1_captst_b_data_shift                        (0)
#define VGIP_CHN1_PTN1_ch1_hporch_num_sel_mask                        (0x3FFF0000)
#define VGIP_CHN1_PTN1_ch1_captst_b_data_mask                         (0x00000FFF)
#define VGIP_CHN1_PTN1_ch1_hporch_num_sel(data)                       (0x3FFF0000&((data)<<16))
#define VGIP_CHN1_PTN1_ch1_captst_b_data(data)                        (0x00000FFF&(data))
#define VGIP_CHN1_PTN1_get_ch1_hporch_num_sel(data)                   ((0x3FFF0000&(data))>>16)
#define VGIP_CHN1_PTN1_get_ch1_captst_b_data(data)                    (0x00000FFF&(data))

#define VGIP_CHN1_LC                                                  0x18022234
#define  VGIP_CHN1_LC_reg_addr                                                  "0xB8022234"
#define  VGIP_CHN1_LC_reg                                                       0xB8022234
#define  VGIP_CHN1_LC_inst_addr                                                 "0x000D"
#define  VGIP_CHN1_LC_inst                                                      0x000D
#define VGIP_CHN1_LC_ch1_vlcen_shift                                  (31)
#define VGIP_CHN1_LC_ch1_vlc_mode_shift                               (30)
#define VGIP_CHN1_LC_ch1_vlc_ie_shift                                 (29)
#define VGIP_CHN1_LC_den_crc_sel_shift                                (28)
#define VGIP_CHN1_LC_ch1_line_cnt_shift                               (12)
#define VGIP_CHN1_LC_ch1_vln_shift                                    (0)
#define VGIP_CHN1_LC_ch1_vlcen_mask                                   (0x80000000)
#define VGIP_CHN1_LC_ch1_vlc_mode_mask                                (0x40000000)
#define VGIP_CHN1_LC_ch1_vlc_ie_mask                                  (0x20000000)
#define VGIP_CHN1_LC_den_crc_sel_mask                                 (0x10000000)
#define VGIP_CHN1_LC_ch1_line_cnt_mask                                (0x00FFF000)
#define VGIP_CHN1_LC_ch1_vln_mask                                     (0x00000FFF)
#define VGIP_CHN1_LC_ch1_vlcen(data)                                  (0x80000000&((data)<<31))
#define VGIP_CHN1_LC_ch1_vlc_mode(data)                               (0x40000000&((data)<<30))
#define VGIP_CHN1_LC_ch1_vlc_ie(data)                                 (0x20000000&((data)<<29))
#define VGIP_CHN1_LC_den_crc_sel(data)                                (0x10000000&((data)<<28))
#define VGIP_CHN1_LC_ch1_line_cnt(data)                               (0x00FFF000&((data)<<12))
#define VGIP_CHN1_LC_ch1_vln(data)                                    (0x00000FFF&(data))
#define VGIP_CHN1_LC_get_ch1_vlcen(data)                              ((0x80000000&(data))>>31)
#define VGIP_CHN1_LC_get_ch1_vlc_mode(data)                           ((0x40000000&(data))>>30)
#define VGIP_CHN1_LC_get_ch1_vlc_ie(data)                             ((0x20000000&(data))>>29)
#define VGIP_CHN1_LC_get_den_crc_sel(data)                            ((0x10000000&(data))>>28)
#define VGIP_CHN1_LC_get_ch1_line_cnt(data)                           ((0x00FFF000&(data))>>12)
#define VGIP_CHN1_LC_get_ch1_vln(data)                                (0x00000FFF&(data))

#define ICH1_VGIP_CRC_CTRL                                            0x18022238
#define  ICH1_VGIP_CRC_CTRL_reg_addr                                            "0xB8022238"
#define  ICH1_VGIP_CRC_CTRL_reg                                                 0xB8022238
#define  ICH1_VGIP_CRC_CTRL_inst_addr                                           "0x000E"
#define  ICH1_VGIP_CRC_CTRL_inst                                                0x000E
#define ICH1_VGIP_CRC_CTRL_ch1_crc_region_shift                       (5)
#define ICH1_VGIP_CRC_CTRL_ch1_crc_ctrl_in_shift                      (4)
#define ICH1_VGIP_CRC_CTRL_ch1_crc_field_edge_sel_shift               (3)
#define ICH1_VGIP_CRC_CTRL_ch1_crc_field_shift                        (2)
#define ICH1_VGIP_CRC_CTRL_ch1_crc_conti_shift                        (1)
#define ICH1_VGIP_CRC_CTRL_ch1_crc_start_shift                        (0)
#define ICH1_VGIP_CRC_CTRL_ch1_crc_region_mask                        (0x00000020)
#define ICH1_VGIP_CRC_CTRL_ch1_crc_ctrl_in_mask                       (0x00000010)
#define ICH1_VGIP_CRC_CTRL_ch1_crc_field_edge_sel_mask                (0x00000008)
#define ICH1_VGIP_CRC_CTRL_ch1_crc_field_mask                         (0x00000004)
#define ICH1_VGIP_CRC_CTRL_ch1_crc_conti_mask                         (0x00000002)
#define ICH1_VGIP_CRC_CTRL_ch1_crc_start_mask                         (0x00000001)
#define ICH1_VGIP_CRC_CTRL_ch1_crc_region(data)                       (0x00000020&((data)<<5))
#define ICH1_VGIP_CRC_CTRL_ch1_crc_ctrl_in(data)                      (0x00000010&((data)<<4))
#define ICH1_VGIP_CRC_CTRL_ch1_crc_field_edge_sel(data)               (0x00000008&((data)<<3))
#define ICH1_VGIP_CRC_CTRL_ch1_crc_field(data)                        (0x00000004&((data)<<2))
#define ICH1_VGIP_CRC_CTRL_ch1_crc_conti(data)                        (0x00000002&((data)<<1))
#define ICH1_VGIP_CRC_CTRL_ch1_crc_start(data)                        (0x00000001&(data))
#define ICH1_VGIP_CRC_CTRL_get_ch1_crc_region(data)                   ((0x00000020&(data))>>5)
#define ICH1_VGIP_CRC_CTRL_get_ch1_crc_ctrl_in(data)                  ((0x00000010&(data))>>4)
#define ICH1_VGIP_CRC_CTRL_get_ch1_crc_field_edge_sel(data)           ((0x00000008&(data))>>3)
#define ICH1_VGIP_CRC_CTRL_get_ch1_crc_field(data)                    ((0x00000004&(data))>>2)
#define ICH1_VGIP_CRC_CTRL_get_ch1_crc_conti(data)                    ((0x00000002&(data))>>1)
#define ICH1_VGIP_CRC_CTRL_get_ch1_crc_start(data)                    (0x00000001&(data))

#define ICH1_VGIP_CRC_RESULT                                          0x1802223C
#define ICH1_VGIP_CRC_RESULT_reg_addr                                 "0xB802223C"
#define ICH1_VGIP_CRC_RESULT_reg                                      0xB802223C
#define ICH1_VGIP_CRC_RESULT_inst_addr                                "0x000F"
#define ICH1_VGIP_CRC_RESULT_inst                                     0x000F
#define ICH1_VGIP_CRC_RESULT_ch1_crc_result_shift                     (0)
#define ICH1_VGIP_CRC_RESULT_ch1_crc_result_mask                      (0xFFFFFFFF)
#define ICH1_VGIP_CRC_RESULT_ch1_crc_result(data)                     (0xFFFFFFFF&(data))
#define ICH1_VGIP_CRC_RESULT_get_ch1_crc_result(data)                 (0xFFFFFFFF&(data))

// use import !!!!!!!!!
#define VGIP_CHN1_WDE                                                 0x18022240
#define  VGIP_CHN1_WDE_reg_addr                                                 "0xB8022240"
#define  VGIP_CHN1_WDE_reg                                                      0xB8022240
#define  VGIP_CHN1_WDE_inst_addr                                                "0x0010"
#define  VGIP_CHN1_WDE_inst                                                     0x0010
#define VGIP_CHN1_WDE_ch1_wd_to_main_shift                            (31)
#define VGIP_CHN1_WDE_ch1_wd_to_sub_shift                             (30)
#define VGIP_CHN1_WDE_dummy18022240_29_19_shift                       (19)
#define VGIP_CHN1_WDE_ch1_vs_err_wde_shift                            (18)
#define VGIP_CHN1_WDE_ch1_hs_err_wde_shift                            (17)
#define VGIP_CHN1_WDE_ch1_field_err_wde_shift                         (16)
#define VGIP_CHN1_WDE_ch1_rl_err_wde_shift                            (15)
#define VGIP_CHN1_WDE_dummy18022240_14_4_shift                        (4)
#define VGIP_CHN1_WDE_ch1_rl_err_ie_shift                             (3)
#define VGIP_CHN1_WDE_ch1_vs_err_ie_shift                             (2)
#define VGIP_CHN1_WDE_ch1_hs_err_ie_shift                             (1)
#define VGIP_CHN1_WDE_ch1_field_err_ie_shift                          (0)
#define VGIP_CHN1_WDE_ch1_wd_to_main_mask                             (0x80000000)
#define VGIP_CHN1_WDE_ch1_wd_to_sub_mask                              (0x40000000)
#define VGIP_CHN1_WDE_dummy18022240_29_19_mask                        (0x3FF80000)
#define VGIP_CHN1_WDE_ch1_vs_err_wde_mask                             (0x00040000)
#define VGIP_CHN1_WDE_ch1_hs_err_wde_mask                             (0x00020000)
#define VGIP_CHN1_WDE_ch1_field_err_wde_mask                          (0x00010000)
#define VGIP_CHN1_WDE_ch1_rl_err_wde_mask                             (0x00008000)
#define VGIP_CHN1_WDE_dummy18022240_14_4_mask                         (0x00007FF0)
#define VGIP_CHN1_WDE_ch1_rl_err_ie_mask                              (0x00000008)
#define VGIP_CHN1_WDE_ch1_vs_err_ie_mask                              (0x00000004)
#define VGIP_CHN1_WDE_ch1_hs_err_ie_mask                              (0x00000002)
#define VGIP_CHN1_WDE_ch1_field_err_ie_mask                           (0x00000001)
#define VGIP_CHN1_WDE_ch1_wd_to_main(data)                            (0x80000000&((data)<<31))
#define VGIP_CHN1_WDE_ch1_wd_to_sub(data)                             (0x40000000&((data)<<30))
#define VGIP_CHN1_WDE_dummy18022240_29_19(data)                       (0x3FF80000&((data)<<19))
#define VGIP_CHN1_WDE_ch1_vs_err_wde(data)                            (0x00040000&((data)<<18))
#define VGIP_CHN1_WDE_ch1_hs_err_wde(data)                            (0x00020000&((data)<<17))
#define VGIP_CHN1_WDE_ch1_field_err_wde(data)                         (0x00010000&((data)<<16))
#define VGIP_CHN1_WDE_ch1_rl_err_wde(data)                            (0x00008000&((data)<<15))
#define VGIP_CHN1_WDE_dummy18022240_14_4(data)                        (0x00007FF0&((data)<<4))
#define VGIP_CHN1_WDE_ch1_rl_err_ie(data)                             (0x00000008&((data)<<3))
#define VGIP_CHN1_WDE_ch1_vs_err_ie(data)                             (0x00000004&((data)<<2))
#define VGIP_CHN1_WDE_ch1_hs_err_ie(data)                             (0x00000002&((data)<<1))
#define VGIP_CHN1_WDE_ch1_field_err_ie(data)                          (0x00000001&(data))
#define VGIP_CHN1_WDE_get_ch1_wd_to_main(data)                        ((0x80000000&(data))>>31)
#define VGIP_CHN1_WDE_get_ch1_wd_to_sub(data)                         ((0x40000000&(data))>>30)
#define VGIP_CHN1_WDE_get_dummy18022240_29_19(data)                   ((0x3FF80000&(data))>>19)
#define VGIP_CHN1_WDE_get_ch1_vs_err_wde(data)                        ((0x00040000&(data))>>18)
#define VGIP_CHN1_WDE_get_ch1_hs_err_wde(data)                        ((0x00020000&(data))>>17)
#define VGIP_CHN1_WDE_get_ch1_field_err_wde(data)                     ((0x00010000&(data))>>16)
#define VGIP_CHN1_WDE_get_ch1_rl_err_wde(data)                        ((0x00008000&(data))>>15)
#define VGIP_CHN1_WDE_get_dummy18022240_14_4(data)                    ((0x00007FF0&(data))>>4)
#define VGIP_CHN1_WDE_get_ch1_rl_err_ie(data)                         ((0x00000008&(data))>>3)
#define VGIP_CHN1_WDE_get_ch1_vs_err_ie(data)                         ((0x00000004&(data))>>2)
#define VGIP_CHN1_WDE_get_ch1_hs_err_ie(data)                         ((0x00000002&(data))>>1)
#define VGIP_CHN1_WDE_get_ch1_field_err_ie(data)                      (0x00000001&(data))

#define SUB_VGIP_CHN1_CTRL                                            0x18022410
#define SUB_VGIP_CHN1_CTRL_reg_addr                                   "0xb8022410"
#define SUB_VGIP_CHN1_CTRL_reg                                        0xb8022410
#define SUB_VGIP_CHN1_CTRL_inst_addr                                  "0x0104"
#define SUB_VGIP_CHN1_CTRL_inst                                       0x0104
#define SUB_VGIP_CHN1_CTRL_ch2_ivrun_shift                            (31)
#define SUB_VGIP_CHN1_CTRL_ch2_in_sel_shift                           (28)
#define SUB_VGIP_CHN1_CTRL_ch2_random_en_shift                        (27)
#define SUB_VGIP_CHN1_CTRL_ch2_fdrop_en_shift                         (26)
#define SUB_VGIP_CHN1_CTRL_ch2_vact_end_ie_shift                      (25)
#define SUB_VGIP_CHN1_CTRL_ch2_vact_start_ie_shift                    (24)
#define SUB_VGIP_CHN1_CTRL_ch2_field_hs_inv_shift                     (23)
#define SUB_VGIP_CHN1_CTRL_ch2_odd_vd_inv_shift                       (22)
#define SUB_VGIP_CHN1_CTRL_ch2_odd_vd_en_shift                        (21)
#define SUB_VGIP_CHN1_CTRL_ch2_3dleft_inv_shift                       (20)
#define SUB_VGIP_CHN1_CTRL_ch2_3dleft_sync_edge_shift                 (19)
#define SUB_VGIP_CHN1_CTRL_ch2_odd_inv_shift                          (18)
#define SUB_VGIP_CHN1_CTRL_ch2_odd_sync_edge_shift                    (17)
#define SUB_VGIP_CHN1_CTRL_ch2_odd_det_en_shift                       (16)
#define SUB_VGIP_CHN1_CTRL_ch2_hpact_is_hact_shift                    (15)
#define SUB_VGIP_CHN1_CTRL_ch2_fcap_str_odd_shift                     (14)
#define SUB_VGIP_CHN1_CTRL_ch2_mask_den_inv_shift                     (13)
#define SUB_VGIP_CHN1_CTRL_ch2_mask_den_1l_shift                      (12)
#define SUB_VGIP_CHN1_CTRL_ch2_3d_mode_en_shift                       (11)
#define SUB_VGIP_CHN1_CTRL_ch2_safe_odd_inv_shift                     (10)
#define SUB_VGIP_CHN1_CTRL_ch2_force_tog_shift                        (9)
#define SUB_VGIP_CHN1_CTRL_ch2_safe_mode_shift                        (8)
#define SUB_VGIP_CHN1_CTRL_ch2_3d_right_act_en_shift                  (7)
#define SUB_VGIP_CHN1_CTRL_ch2_hs_syncedge_shift                      (6)
#define SUB_VGIP_CHN1_CTRL_ch2_vs_syncedge_shift                      (5)
#define SUB_VGIP_CHN1_CTRL_ch2_vs_by_hs_en_n_shift                    (4)
#define SUB_VGIP_CHN1_CTRL_ch2_vs_inv_shift                           (3)
#define SUB_VGIP_CHN1_CTRL_ch2_hs_inv_shift                           (2)
#define SUB_VGIP_CHN1_CTRL_ch2_digital_mode_shift                     (1)
#define SUB_VGIP_CHN1_CTRL_ch2_in_clk_en_shift                        (0)
#define SUB_VGIP_CHN1_CTRL_ch2_ivrun_mask                             (0x80000000)
#define SUB_VGIP_CHN1_CTRL_ch2_in_sel_mask                            (0x70000000)
#define SUB_VGIP_CHN1_CTRL_ch2_random_en_mask                         (0x08000000)
#define SUB_VGIP_CHN1_CTRL_ch2_fdrop_en_mask                          (0x04000000)
#define SUB_VGIP_CHN1_CTRL_ch2_vact_end_ie_mask                       (0x02000000)
#define SUB_VGIP_CHN1_CTRL_ch2_vact_start_ie_mask                     (0x01000000)
#define SUB_VGIP_CHN1_CTRL_ch2_field_hs_inv_mask                      (0x00800000)
#define SUB_VGIP_CHN1_CTRL_ch2_odd_vd_inv_mask                        (0x00400000)
#define SUB_VGIP_CHN1_CTRL_ch2_odd_vd_en_mask                         (0x00200000)
#define SUB_VGIP_CHN1_CTRL_ch2_3dleft_inv_mask                        (0x00100000)
#define SUB_VGIP_CHN1_CTRL_ch2_3dleft_sync_edge_mask                  (0x00080000)
#define SUB_VGIP_CHN1_CTRL_ch2_odd_inv_mask                           (0x00040000)
#define SUB_VGIP_CHN1_CTRL_ch2_odd_sync_edge_mask                     (0x00020000)
#define SUB_VGIP_CHN1_CTRL_ch2_odd_det_en_mask                        (0x00010000)
#define SUB_VGIP_CHN1_CTRL_ch2_hpact_is_hact_mask                     (0x00008000)
#define SUB_VGIP_CHN1_CTRL_ch2_fcap_str_odd_mask                      (0x00004000)
#define SUB_VGIP_CHN1_CTRL_ch2_mask_den_inv_mask                      (0x00002000)
#define SUB_VGIP_CHN1_CTRL_ch2_mask_den_1l_mask                       (0x00001000)
#define SUB_VGIP_CHN1_CTRL_ch2_3d_mode_en_mask                        (0x00000800)
#define SUB_VGIP_CHN1_CTRL_ch2_safe_odd_inv_mask                      (0x00000400)
#define SUB_VGIP_CHN1_CTRL_ch2_force_tog_mask                         (0x00000200)
#define SUB_VGIP_CHN1_CTRL_ch2_safe_mode_mask                         (0x00000100)
#define SUB_VGIP_CHN1_CTRL_ch2_3d_right_act_en_mask                   (0x00000080)
#define SUB_VGIP_CHN1_CTRL_ch2_hs_syncedge_mask                       (0x00000040)
#define SUB_VGIP_CHN1_CTRL_ch2_vs_syncedge_mask                       (0x00000020)
#define SUB_VGIP_CHN1_CTRL_ch2_vs_by_hs_en_n_mask                     (0x00000010)
#define SUB_VGIP_CHN1_CTRL_ch2_vs_inv_mask                            (0x00000008)
#define SUB_VGIP_CHN1_CTRL_ch2_hs_inv_mask                            (0x00000004)
#define SUB_VGIP_CHN1_CTRL_ch2_digital_mode_mask                      (0x00000002)
#define SUB_VGIP_CHN1_CTRL_ch2_in_clk_en_mask                         (0x00000001)
#define SUB_VGIP_CHN1_CTRL_ch2_ivrun(data)                            (0x80000000&((data)<<31))
#define SUB_VGIP_CHN1_CTRL_ch2_in_sel(data)                           (0x70000000&((data)<<28))
#define SUB_VGIP_CHN1_CTRL_ch2_random_en(data)                        (0x08000000&((data)<<27))
#define SUB_VGIP_CHN1_CTRL_ch2_fdrop_en(data)                         (0x04000000&((data)<<26))
#define SUB_VGIP_CHN1_CTRL_ch2_vact_end_ie(data)                      (0x02000000&((data)<<25))
#define SUB_VGIP_CHN1_CTRL_ch2_vact_start_ie(data)                    (0x01000000&((data)<<24))
#define SUB_VGIP_CHN1_CTRL_ch2_field_hs_inv(data)                     (0x00800000&((data)<<23))
#define SUB_VGIP_CHN1_CTRL_ch2_odd_vd_inv(data)                       (0x00400000&((data)<<22))
#define SUB_VGIP_CHN1_CTRL_ch2_odd_vd_en(data)                        (0x00200000&((data)<<21))
#define SUB_VGIP_CHN1_CTRL_ch2_3dleft_inv(data)                       (0x00100000&((data)<<20))
#define SUB_VGIP_CHN1_CTRL_ch2_3dleft_sync_edge(data)                 (0x00080000&((data)<<19))
#define SUB_VGIP_CHN1_CTRL_ch2_odd_inv(data)                          (0x00040000&((data)<<18))
#define SUB_VGIP_CHN1_CTRL_ch2_odd_sync_edge(data)                    (0x00020000&((data)<<17))
#define SUB_VGIP_CHN1_CTRL_ch2_odd_det_en(data)                       (0x00010000&((data)<<16))
#define SUB_VGIP_CHN1_CTRL_ch2_hpact_is_hact(data)                    (0x00008000&((data)<<15))
#define SUB_VGIP_CHN1_CTRL_ch2_fcap_str_odd(data)                     (0x00004000&((data)<<14))
#define SUB_VGIP_CHN1_CTRL_ch2_mask_den_inv(data)                     (0x00002000&((data)<<13))
#define SUB_VGIP_CHN1_CTRL_ch2_mask_den_1l(data)                      (0x00001000&((data)<<12))
#define SUB_VGIP_CHN1_CTRL_ch2_3d_mode_en(data)                       (0x00000800&((data)<<11))
#define SUB_VGIP_CHN1_CTRL_ch2_safe_odd_inv(data)                     (0x00000400&((data)<<10))
#define SUB_VGIP_CHN1_CTRL_ch2_force_tog(data)                        (0x00000200&((data)<<9))
#define SUB_VGIP_CHN1_CTRL_ch2_safe_mode(data)                        (0x00000100&((data)<<8))
#define SUB_VGIP_CHN1_CTRL_ch2_3d_right_act_en(data)                  (0x00000080&((data)<<7))
#define SUB_VGIP_CHN1_CTRL_ch2_hs_syncedge(data)                      (0x00000040&((data)<<6))
#define SUB_VGIP_CHN1_CTRL_ch2_vs_syncedge(data)                      (0x00000020&((data)<<5))
#define SUB_VGIP_CHN1_CTRL_ch2_vs_by_hs_en_n(data)                    (0x00000010&((data)<<4))
#define SUB_VGIP_CHN1_CTRL_ch2_vs_inv(data)                           (0x00000008&((data)<<3))
#define SUB_VGIP_CHN1_CTRL_ch2_hs_inv(data)                           (0x00000004&((data)<<2))
#define SUB_VGIP_CHN1_CTRL_ch2_digital_mode(data)                     (0x00000002&((data)<<1))
#define SUB_VGIP_CHN1_CTRL_ch2_in_clk_en(data)                        (0x00000001&(data))
#define SUB_VGIP_CHN1_CTRL_get_ch2_ivrun(data)                        ((0x80000000&(data))>>31)
#define SUB_VGIP_CHN1_CTRL_get_ch2_in_sel(data)                       ((0x70000000&(data))>>28)
#define SUB_VGIP_CHN1_CTRL_get_ch2_random_en(data)                    ((0x08000000&(data))>>27)
#define SUB_VGIP_CHN1_CTRL_get_ch2_fdrop_en(data)                     ((0x04000000&(data))>>26)
#define SUB_VGIP_CHN1_CTRL_get_ch2_vact_end_ie(data)                  ((0x02000000&(data))>>25)
#define SUB_VGIP_CHN1_CTRL_get_ch2_vact_start_ie(data)                ((0x01000000&(data))>>24)
#define SUB_VGIP_CHN1_CTRL_get_ch2_field_hs_inv(data)                 ((0x00800000&(data))>>23)
#define SUB_VGIP_CHN1_CTRL_get_ch2_odd_vd_inv(data)                   ((0x00400000&(data))>>22)
#define SUB_VGIP_CHN1_CTRL_get_ch2_odd_vd_en(data)                    ((0x00200000&(data))>>21)
#define SUB_VGIP_CHN1_CTRL_get_ch2_3dleft_inv(data)                   ((0x00100000&(data))>>20)
#define SUB_VGIP_CHN1_CTRL_get_ch2_3dleft_sync_edge(data)             ((0x00080000&(data))>>19)
#define SUB_VGIP_CHN1_CTRL_get_ch2_odd_inv(data)                      ((0x00040000&(data))>>18)
#define SUB_VGIP_CHN1_CTRL_get_ch2_odd_sync_edge(data)                ((0x00020000&(data))>>17)
#define SUB_VGIP_CHN1_CTRL_get_ch2_odd_det_en(data)                   ((0x00010000&(data))>>16)
#define SUB_VGIP_CHN1_CTRL_get_ch2_hpact_is_hact(data)                ((0x00008000&(data))>>15)
#define SUB_VGIP_CHN1_CTRL_get_ch2_fcap_str_odd(data)                 ((0x00004000&(data))>>14)
#define SUB_VGIP_CHN1_CTRL_get_ch2_mask_den_inv(data)                 ((0x00002000&(data))>>13)
#define SUB_VGIP_CHN1_CTRL_get_ch2_mask_den_1l(data)                  ((0x00001000&(data))>>12)
#define SUB_VGIP_CHN1_CTRL_get_ch2_3d_mode_en(data)                   ((0x00000800&(data))>>11)
#define SUB_VGIP_CHN1_CTRL_get_ch2_safe_odd_inv(data)                 ((0x00000400&(data))>>10)
#define SUB_VGIP_CHN1_CTRL_get_ch2_force_tog(data)                    ((0x00000200&(data))>>9)
#define SUB_VGIP_CHN1_CTRL_get_ch2_safe_mode(data)                    ((0x00000100&(data))>>8)
#define SUB_VGIP_CHN1_CTRL_get_ch2_3d_right_act_en(data)              ((0x00000080&(data))>>7)
#define SUB_VGIP_CHN1_CTRL_get_ch2_hs_syncedge(data)                  ((0x00000040&(data))>>6)
#define SUB_VGIP_CHN1_CTRL_get_ch2_vs_syncedge(data)                  ((0x00000020&(data))>>5)
#define SUB_VGIP_CHN1_CTRL_get_ch2_vs_by_hs_en_n(data)                ((0x00000010&(data))>>4)
#define SUB_VGIP_CHN1_CTRL_get_ch2_vs_inv(data)                       ((0x00000008&(data))>>3)
#define SUB_VGIP_CHN1_CTRL_get_ch2_hs_inv(data)                       ((0x00000004&(data))>>2)
#define SUB_VGIP_CHN1_CTRL_get_ch2_digital_mode(data)                 ((0x00000002&(data))>>1)
#define SUB_VGIP_CHN1_CTRL_get_ch2_in_clk_en(data)                    (0x00000001&(data))

#if 0
// NEED TO CHECK, Sirius already removed
//   import use !!!!!!!!!!!!!!!!!!!!!!!!!!!
#define VGIP_CHN2_CTRL                                                0x18022244
#define VGIP_CHN2_CTRL_reg_addr                                       "0xb8022244"
#define VGIP_CHN2_CTRL_reg                                            0xb8022244
#define VGIP_CHN2_CTRL_inst_addr                                      "0x0091"
#define VGIP_CHN2_CTRL_inst                                           0x0091
#define VGIP_CHN2_CTRL_ch2_ivrun_shift                                (31)
#define VGIP_CHN2_CTRL_ch2_in_sel_shift                               (28)
#define VGIP_CHN2_CTRL_ch2_random_en_shift                            (27)
#define VGIP_CHN2_CTRL_ch2_fdrop_en_shift                             (26)
#define VGIP_CHN2_CTRL_ch2_vact_end_ie_shift                          (25)
#define VGIP_CHN2_CTRL_ch2_vact_start_ie_shift                        (24)
#define VGIP_CHN2_CTRL_ch2_field_hs_inv_shift                         (23)
#define VGIP_CHN2_CTRL_ch2_odd_vd_inv_shift                           (22)
#define VGIP_CHN2_CTRL_ch2_odd_vd_en_shift                            (21)
#define VGIP_CHN2_CTRL_ch2_odd_inv_shift                              (18)
#define VGIP_CHN2_CTRL_ch2_odd_sync_edge_shift                        (17)
#define VGIP_CHN2_CTRL_ch2_odd_det_en_shift                           (16)
#define VGIP_CHN2_CTRL_ch2_hpact_is_hact_shift                        (15)
#define VGIP_CHN2_CTRL_ch2_fcap_str_odd_shift                         (14)
#define VGIP_CHN2_CTRL_ch2_mask_den_inv_shift                         (13)
#define VGIP_CHN2_CTRL_ch2_mask_den_1l_shift                          (12)
#define VGIP_CHN2_CTRL_dummy18022244_11_shift                         (11)
#define VGIP_CHN2_CTRL_ch2_safe_odd_inv_shift                         (10)
#define VGIP_CHN2_CTRL_ch2_force_tog_shift                            (9)
#define VGIP_CHN2_CTRL_ch2_safe_mode_shift                            (8)
#define VGIP_CHN2_CTRL_dummy18022244_7_shift                          (7)
#define VGIP_CHN2_CTRL_ch2_hs_syncedge_shift                          (6)
#define VGIP_CHN2_CTRL_ch2_vs_syncedge_shift                          (5)
#define VGIP_CHN2_CTRL_ch2_vs_by_hs_en_n_shift                        (4)
#define VGIP_CHN2_CTRL_ch2_vs_inv_shift                               (3)
#define VGIP_CHN2_CTRL_ch2_hs_inv_shift                               (2)
#define VGIP_CHN2_CTRL_ch2_digital_mode_shift                         (1)
#define VGIP_CHN2_CTRL_ch2_in_clk_en_shift                            (0)
#define VGIP_CHN2_CTRL_ch2_ivrun_mask                                 (0x80000000)
#define VGIP_CHN2_CTRL_ch2_in_sel_mask                                (0x70000000)
#define VGIP_CHN2_CTRL_ch2_random_en_mask                             (0x08000000)
#define VGIP_CHN2_CTRL_ch2_fdrop_en_mask                              (0x04000000)
#define VGIP_CHN2_CTRL_ch2_vact_end_ie_mask                           (0x02000000)
#define VGIP_CHN2_CTRL_ch2_vact_start_ie_mask                         (0x01000000)
#define VGIP_CHN2_CTRL_ch2_field_hs_inv_mask                          (0x00800000)
#define VGIP_CHN2_CTRL_ch2_odd_vd_inv_mask                            (0x00400000)
#define VGIP_CHN2_CTRL_ch2_odd_vd_en_mask                             (0x00200000)
#define VGIP_CHN2_CTRL_ch2_odd_inv_mask                               (0x00040000)
#define VGIP_CHN2_CTRL_ch2_odd_sync_edge_mask                         (0x00020000)
#define VGIP_CHN2_CTRL_ch2_odd_det_en_mask                            (0x00010000)
#define VGIP_CHN2_CTRL_ch2_hpact_is_hact_mask                         (0x00008000)
#define VGIP_CHN2_CTRL_ch2_fcap_str_odd_mask                          (0x00004000)
#define VGIP_CHN2_CTRL_ch2_mask_den_inv_mask                          (0x00002000)
#define VGIP_CHN2_CTRL_ch2_mask_den_1l_mask                           (0x00001000)
#define VGIP_CHN2_CTRL_dummy18022244_11_mask                          (0x00000800)
#define VGIP_CHN2_CTRL_ch2_safe_odd_inv_mask                          (0x00000400)
#define VGIP_CHN2_CTRL_ch2_force_tog_mask                             (0x00000200)
#define VGIP_CHN2_CTRL_ch2_safe_mode_mask                             (0x00000100)
#define VGIP_CHN2_CTRL_dummy18022244_7_mask                           (0x00000080)
#define VGIP_CHN2_CTRL_ch2_hs_syncedge_mask                           (0x00000040)
#define VGIP_CHN2_CTRL_ch2_vs_syncedge_mask                           (0x00000020)
#define VGIP_CHN2_CTRL_ch2_vs_by_hs_en_n_mask                         (0x00000010)
#define VGIP_CHN2_CTRL_ch2_vs_inv_mask                                (0x00000008)
#define VGIP_CHN2_CTRL_ch2_hs_inv_mask                                (0x00000004)
#define VGIP_CHN2_CTRL_ch2_digital_mode_mask                          (0x00000002)
#define VGIP_CHN2_CTRL_ch2_in_clk_en_mask                             (0x00000001)
#define VGIP_CHN2_CTRL_ch2_ivrun(data)                                (0x80000000&((data)<<31))
#define VGIP_CHN2_CTRL_ch2_in_sel(data)                               (0x70000000&((data)<<28))
#define VGIP_CHN2_CTRL_ch2_random_en(data)                            (0x08000000&((data)<<27))
#define VGIP_CHN2_CTRL_ch2_fdrop_en(data)                             (0x04000000&((data)<<26))
#define VGIP_CHN2_CTRL_ch2_vact_end_ie(data)                          (0x02000000&((data)<<25))
#define VGIP_CHN2_CTRL_ch2_vact_start_ie(data)                        (0x01000000&((data)<<24))
#define VGIP_CHN2_CTRL_ch2_field_hs_inv(data)                         (0x00800000&((data)<<23))
#define VGIP_CHN2_CTRL_ch2_odd_vd_inv(data)                           (0x00400000&((data)<<22))
#define VGIP_CHN2_CTRL_ch2_odd_vd_en(data)                            (0x00200000&((data)<<21))
#define VGIP_CHN2_CTRL_ch2_odd_inv(data)                              (0x00040000&((data)<<18))
#define VGIP_CHN2_CTRL_ch2_odd_sync_edge(data)                        (0x00020000&((data)<<17))
#define VGIP_CHN2_CTRL_ch2_odd_det_en(data)                           (0x00010000&((data)<<16))
#define VGIP_CHN2_CTRL_ch2_hpact_is_hact(data)                        (0x00008000&((data)<<15))
#define VGIP_CHN2_CTRL_ch2_fcap_str_odd(data)                         (0x00004000&((data)<<14))
#define VGIP_CHN2_CTRL_ch2_mask_den_inv(data)                         (0x00002000&((data)<<13))
#define VGIP_CHN2_CTRL_ch2_mask_den_1l(data)                          (0x00001000&((data)<<12))
#define VGIP_CHN2_CTRL_dummy18022244_11(data)                         (0x00000800&((data)<<11))
#define VGIP_CHN2_CTRL_ch2_safe_odd_inv(data)                         (0x00000400&((data)<<10))
#define VGIP_CHN2_CTRL_ch2_force_tog(data)                            (0x00000200&((data)<<9))
#define VGIP_CHN2_CTRL_ch2_safe_mode(data)                            (0x00000100&((data)<<8))
#define VGIP_CHN2_CTRL_dummy18022244_7(data)                          (0x00000080&((data)<<7))
#define VGIP_CHN2_CTRL_ch2_hs_syncedge(data)                          (0x00000040&((data)<<6))
#define VGIP_CHN2_CTRL_ch2_vs_syncedge(data)                          (0x00000020&((data)<<5))
#define VGIP_CHN2_CTRL_ch2_vs_by_hs_en_n(data)                        (0x00000010&((data)<<4))
#define VGIP_CHN2_CTRL_ch2_vs_inv(data)                               (0x00000008&((data)<<3))
#define VGIP_CHN2_CTRL_ch2_hs_inv(data)                               (0x00000004&((data)<<2))
#define VGIP_CHN2_CTRL_ch2_digital_mode(data)                         (0x00000002&((data)<<1))
#define VGIP_CHN2_CTRL_ch2_in_clk_en(data)                            (0x00000001&(data))
#define VGIP_CHN2_CTRL_get_ch2_ivrun(data)                            ((0x80000000&(data))>>31)
#define VGIP_CHN2_CTRL_get_ch2_in_sel(data)                           ((0x70000000&(data))>>28)
#define VGIP_CHN2_CTRL_get_ch2_random_en(data)                        ((0x08000000&(data))>>27)
#define VGIP_CHN2_CTRL_get_ch2_fdrop_en(data)                         ((0x04000000&(data))>>26)
#define VGIP_CHN2_CTRL_get_ch2_vact_end_ie(data)                      ((0x02000000&(data))>>25)
#define VGIP_CHN2_CTRL_get_ch2_vact_start_ie(data)                    ((0x01000000&(data))>>24)
#define VGIP_CHN2_CTRL_get_ch2_field_hs_inv(data)                     ((0x00800000&(data))>>23)
#define VGIP_CHN2_CTRL_get_ch2_odd_vd_inv(data)                       ((0x00400000&(data))>>22)
#define VGIP_CHN2_CTRL_get_ch2_odd_vd_en(data)                        ((0x00200000&(data))>>21)
#define VGIP_CHN2_CTRL_get_ch2_odd_inv(data)                          ((0x00040000&(data))>>18)
#define VGIP_CHN2_CTRL_get_ch2_odd_sync_edge(data)                    ((0x00020000&(data))>>17)
#define VGIP_CHN2_CTRL_get_ch2_odd_det_en(data)                       ((0x00010000&(data))>>16)
#define VGIP_CHN2_CTRL_get_ch2_hpact_is_hact(data)                    ((0x00008000&(data))>>15)
#define VGIP_CHN2_CTRL_get_ch2_fcap_str_odd(data)                     ((0x00004000&(data))>>14)
#define VGIP_CHN2_CTRL_get_ch2_mask_den_inv(data)                     ((0x00002000&(data))>>13)
#define VGIP_CHN2_CTRL_get_ch2_mask_den_1l(data)                      ((0x00001000&(data))>>12)
#define VGIP_CHN2_CTRL_get_dummy18022244_11(data)                     ((0x00000800&(data))>>11)
#define VGIP_CHN2_CTRL_get_ch2_safe_odd_inv(data)                     ((0x00000400&(data))>>10)
#define VGIP_CHN2_CTRL_get_ch2_force_tog(data)                        ((0x00000200&(data))>>9)
#define VGIP_CHN2_CTRL_get_ch2_safe_mode(data)                        ((0x00000100&(data))>>8)
#define VGIP_CHN2_CTRL_get_dummy18022244_7(data)                      ((0x00000080&(data))>>7)
#define VGIP_CHN2_CTRL_get_ch2_hs_syncedge(data)                      ((0x00000040&(data))>>6)
#define VGIP_CHN2_CTRL_get_ch2_vs_syncedge(data)                      ((0x00000020&(data))>>5)
#define VGIP_CHN2_CTRL_get_ch2_vs_by_hs_en_n(data)                    ((0x00000010&(data))>>4)
#define VGIP_CHN2_CTRL_get_ch2_vs_inv(data)                           ((0x00000008&(data))>>3)
#define VGIP_CHN2_CTRL_get_ch2_hs_inv(data)                           ((0x00000004&(data))>>2)
#define VGIP_CHN2_CTRL_get_ch2_digital_mode(data)                     ((0x00000002&(data))>>1)
#define VGIP_CHN2_CTRL_get_ch2_in_clk_en(data)                        (0x00000001&(data))


#define VGIP_CHN2_STATUS                                              0x18022248
#define VGIP_CHN2_STATUS_reg_addr                                     "0xb8022248"
#define VGIP_CHN2_STATUS_reg                                          0xb8022248
#define VGIP_CHN2_STATUS_inst_addr                                    "0x0092"
#define VGIP_CHN2_STATUS_inst                                         0x0092
#define VGIP_CHN2_STATUS_ch2_vs_end_shift                             (27)
#define VGIP_CHN2_STATUS_ch2_vs_start_shift                           (26)
#define VGIP_CHN2_STATUS_ch2_vact_end_shift                           (25)
#define VGIP_CHN2_STATUS_ch2_vact_start_shift                         (24)
#define VGIP_CHN2_STATUS_dummy18022248_23_15_shift                    (15)
#define VGIP_CHN2_STATUS_ch2_vs_err_shift                             (14)
#define VGIP_CHN2_STATUS_ch2_hs_err_shift                             (13)
#define VGIP_CHN2_STATUS_ch2_field_err_shift                          (12)
#define VGIP_CHN2_STATUS_dummy18022248_11_10_shift                    (10)
#define VGIP_CHN2_STATUS_ch2_vs_tog_shift                             (9)
#define VGIP_CHN2_STATUS_ch2_hs_tog_shift                             (8)
#define VGIP_CHN2_STATUS_ch2_field_pol_shift                          (7)
#define VGIP_CHN2_STATUS_ch2_field_tog_shift                          (6)
#define VGIP_CHN2_STATUS_ch2_field_vs_lsb_shift                       (4)
#define VGIP_CHN2_STATUS_ch2_more_1line_field_shift                   (3)
#define VGIP_CHN2_STATUS_ch2_bounce_status_2_shift                    (2)
#define VGIP_CHN2_STATUS_ch2_bounce_status_1_shift                    (1)
#define VGIP_CHN2_STATUS_ch2_bounce_status_0_shift                    (0)
#define VGIP_CHN2_STATUS_ch2_vs_end_mask                              (0x08000000)
#define VGIP_CHN2_STATUS_ch2_vs_start_mask                            (0x04000000)
#define VGIP_CHN2_STATUS_ch2_vact_end_mask                            (0x02000000)
#define VGIP_CHN2_STATUS_ch2_vact_start_mask                          (0x01000000)
#define VGIP_CHN2_STATUS_dummy18022248_23_15_mask                     (0x00FF8000)
#define VGIP_CHN2_STATUS_ch2_vs_err_mask                              (0x00004000)
#define VGIP_CHN2_STATUS_ch2_hs_err_mask                              (0x00002000)
#define VGIP_CHN2_STATUS_ch2_field_err_mask                           (0x00001000)
#define VGIP_CHN2_STATUS_dummy18022248_11_10_mask                     (0x00000C00)
#define VGIP_CHN2_STATUS_ch2_vs_tog_mask                              (0x00000200)
#define VGIP_CHN2_STATUS_ch2_hs_tog_mask                              (0x00000100)
#define VGIP_CHN2_STATUS_ch2_field_pol_mask                           (0x00000080)
#define VGIP_CHN2_STATUS_ch2_field_tog_mask                           (0x00000040)
#define VGIP_CHN2_STATUS_ch2_field_vs_lsb_mask                        (0x00000030)
#define VGIP_CHN2_STATUS_ch2_more_1line_field_mask                    (0x00000008)
#define VGIP_CHN2_STATUS_ch2_bounce_status_2_mask                     (0x00000004)
#define VGIP_CHN2_STATUS_ch2_bounce_status_1_mask                     (0x00000002)
#define VGIP_CHN2_STATUS_ch2_bounce_status_0_mask                     (0x00000001)
#define VGIP_CHN2_STATUS_ch2_vs_end(data)                             (0x08000000&((data)<<27))
#define VGIP_CHN2_STATUS_ch2_vs_start(data)                           (0x04000000&((data)<<26))
#define VGIP_CHN2_STATUS_ch2_vact_end(data)                           (0x02000000&((data)<<25))
#define VGIP_CHN2_STATUS_ch2_vact_start(data)                         (0x01000000&((data)<<24))
#define VGIP_CHN2_STATUS_dummy18022248_23_15(data)                    (0x00FF8000&((data)<<15))
#define VGIP_CHN2_STATUS_ch2_vs_err(data)                             (0x00004000&((data)<<14))
#define VGIP_CHN2_STATUS_ch2_hs_err(data)                             (0x00002000&((data)<<13))
#define VGIP_CHN2_STATUS_ch2_field_err(data)                          (0x00001000&((data)<<12))
#define VGIP_CHN2_STATUS_dummy18022248_11_10(data)                    (0x00000C00&((data)<<10))
#define VGIP_CHN2_STATUS_ch2_vs_tog(data)                             (0x00000200&((data)<<9))
#define VGIP_CHN2_STATUS_ch2_hs_tog(data)                             (0x00000100&((data)<<8))
#define VGIP_CHN2_STATUS_ch2_field_pol(data)                          (0x00000080&((data)<<7))
#define VGIP_CHN2_STATUS_ch2_field_tog(data)                          (0x00000040&((data)<<6))
#define VGIP_CHN2_STATUS_ch2_field_vs_lsb(data)                       (0x00000030&((data)<<4))
#define VGIP_CHN2_STATUS_ch2_more_1line_field(data)                   (0x00000008&((data)<<3))
#define VGIP_CHN2_STATUS_ch2_bounce_status_2(data)                    (0x00000004&((data)<<2))
#define VGIP_CHN2_STATUS_ch2_bounce_status_1(data)                    (0x00000002&((data)<<1))
#define VGIP_CHN2_STATUS_ch2_bounce_status_0(data)                    (0x00000001&(data))
#define VGIP_CHN2_STATUS_get_ch2_vs_end(data)                         ((0x08000000&(data))>>27)
#define VGIP_CHN2_STATUS_get_ch2_vs_start(data)                       ((0x04000000&(data))>>26)
#define VGIP_CHN2_STATUS_get_ch2_vact_end(data)                       ((0x02000000&(data))>>25)
#define VGIP_CHN2_STATUS_get_ch2_vact_start(data)                     ((0x01000000&(data))>>24)
#define VGIP_CHN2_STATUS_get_dummy18022248_23_15(data)                ((0x00FF8000&(data))>>15)
#define VGIP_CHN2_STATUS_get_ch2_vs_err(data)                         ((0x00004000&(data))>>14)
#define VGIP_CHN2_STATUS_get_ch2_hs_err(data)                         ((0x00002000&(data))>>13)
#define VGIP_CHN2_STATUS_get_ch2_field_err(data)                      ((0x00001000&(data))>>12)
#define VGIP_CHN2_STATUS_get_dummy18022248_11_10(data)                ((0x00000C00&(data))>>10)
#define VGIP_CHN2_STATUS_get_ch2_vs_tog(data)                         ((0x00000200&(data))>>9)
#define VGIP_CHN2_STATUS_get_ch2_hs_tog(data)                         ((0x00000100&(data))>>8)
#define VGIP_CHN2_STATUS_get_ch2_field_pol(data)                      ((0x00000080&(data))>>7)
#define VGIP_CHN2_STATUS_get_ch2_field_tog(data)                      ((0x00000040&(data))>>6)
#define VGIP_CHN2_STATUS_get_ch2_field_vs_lsb(data)                   ((0x00000030&(data))>>4)
#define VGIP_CHN2_STATUS_get_ch2_more_1line_field(data)               ((0x00000008&(data))>>3)
#define VGIP_CHN2_STATUS_get_ch2_bounce_status_2(data)                ((0x00000004&(data))>>2)
#define VGIP_CHN2_STATUS_get_ch2_bounce_status_1(data)                ((0x00000002&(data))>>1)
#define VGIP_CHN2_STATUS_get_ch2_bounce_status_0(data)                (0x00000001&(data))


#define VGIP_CHN2_ACT_HSTA_WIDTH                                      0x1802224c
#define VGIP_CHN2_ACT_HSTA_WIDTH_reg_addr                             "0xb802224c"
#define VGIP_CHN2_ACT_HSTA_WIDTH_reg                                  0xb802224c
#define VGIP_CHN2_ACT_HSTA_WIDTH_inst_addr                            "0x0093"
#define VGIP_CHN2_ACT_HSTA_WIDTH_inst                                 0x0093
#define VGIP_CHN2_ACT_HSTA_WIDTH_ch2_db_rdy_shift                     (31)
#define VGIP_CHN2_ACT_HSTA_WIDTH_ch2_db_en_shift                      (30)
#define VGIP_CHN2_ACT_HSTA_WIDTH_ch2_ih_act_sta_shift                 (16)
#define VGIP_CHN2_ACT_HSTA_WIDTH_ch2_ih_act_wid_shift                 (0)
#define VGIP_CHN2_ACT_HSTA_WIDTH_ch2_db_rdy_mask                      (0x80000000)
#define VGIP_CHN2_ACT_HSTA_WIDTH_ch2_db_en_mask                       (0x40000000)
#define VGIP_CHN2_ACT_HSTA_WIDTH_ch2_ih_act_sta_mask                  (0x0FFF0000)
#define VGIP_CHN2_ACT_HSTA_WIDTH_ch2_ih_act_wid_mask                  (0x00000FFF)
#define VGIP_CHN2_ACT_HSTA_WIDTH_ch2_db_rdy(data)                     (0x80000000&((data)<<31))
#define VGIP_CHN2_ACT_HSTA_WIDTH_ch2_db_en(data)                      (0x40000000&((data)<<30))
#define VGIP_CHN2_ACT_HSTA_WIDTH_ch2_ih_act_sta(data)                 (0x0FFF0000&((data)<<16))
#define VGIP_CHN2_ACT_HSTA_WIDTH_ch2_ih_act_wid(data)                 (0x00000FFF&(data))
#define VGIP_CHN2_ACT_HSTA_WIDTH_get_ch2_db_rdy(data)                 ((0x80000000&(data))>>31)
#define VGIP_CHN2_ACT_HSTA_WIDTH_get_ch2_db_en(data)                  ((0x40000000&(data))>>30)
#define VGIP_CHN2_ACT_HSTA_WIDTH_get_ch2_ih_act_sta(data)             ((0x0FFF0000&(data))>>16)
#define VGIP_CHN2_ACT_HSTA_WIDTH_get_ch2_ih_act_wid(data)             (0x00000FFF&(data))


#define VGIP_CHN2_ACT_VSTA_LENGTH                                     0x18022250
#define VGIP_CHN2_ACT_VSTA_LENGTH_reg_addr                            "0xb8022250"
#define VGIP_CHN2_ACT_VSTA_LENGTH_reg                                 0xb8022250
#define VGIP_CHN2_ACT_VSTA_LENGTH_inst_addr                           "0x0094"
#define VGIP_CHN2_ACT_VSTA_LENGTH_inst                                0x0094
#define VGIP_CHN2_ACT_VSTA_LENGTH_ch2_iv_act_sta_shift                (16)
#define VGIP_CHN2_ACT_VSTA_LENGTH_ch2_iv_act_len_shift                (0)
#define VGIP_CHN2_ACT_VSTA_LENGTH_ch2_iv_act_sta_mask                 (0x0FFF0000)
#define VGIP_CHN2_ACT_VSTA_LENGTH_ch2_iv_act_len_mask                 (0x00000FFF)
#define VGIP_CHN2_ACT_VSTA_LENGTH_ch2_iv_act_sta(data)                (0x0FFF0000&((data)<<16))
#define VGIP_CHN2_ACT_VSTA_LENGTH_ch2_iv_act_len(data)                (0x00000FFF&(data))
#define VGIP_CHN2_ACT_VSTA_LENGTH_get_ch2_iv_act_sta(data)            ((0x0FFF0000&(data))>>16)
#define VGIP_CHN2_ACT_VSTA_LENGTH_get_ch2_iv_act_len(data)            (0x00000FFF&(data))


#define VGIP_CHN2_DELAY                                               0x18022254
#define VGIP_CHN2_DELAY_reg_addr                                      "0xb8022254"
#define VGIP_CHN2_DELAY_reg                                           0xb8022254
#define VGIP_CHN2_DELAY_inst_addr                                     "0x0095"
#define VGIP_CHN2_DELAY_inst                                          0x0095
#define VGIP_CHN2_DELAY_ch2_ihs_dly_shift                             (16)
#define VGIP_CHN2_DELAY_ch2_ivs_dly_shift                             (0)
#define VGIP_CHN2_DELAY_ch2_ihs_dly_mask                              (0x0FFF0000)
#define VGIP_CHN2_DELAY_ch2_ivs_dly_mask                              (0x00000FFF)
#define VGIP_CHN2_DELAY_ch2_ihs_dly(data)                             (0x0FFF0000&((data)<<16))
#define VGIP_CHN2_DELAY_ch2_ivs_dly(data)                             (0x00000FFF&(data))
#define VGIP_CHN2_DELAY_get_ch2_ihs_dly(data)                         ((0x0FFF0000&(data))>>16)
#define VGIP_CHN2_DELAY_get_ch2_ivs_dly(data)                         (0x00000FFF&(data))


#define VGIP_CHN2_MISC                                                0x18022258
#define VGIP_CHN2_MISC_reg_addr                                       "0xb8022258"
#define VGIP_CHN2_MISC_reg                                            0xb8022258
#define VGIP_CHN2_MISC_inst_addr                                      "0x0096"
#define VGIP_CHN2_MISC_inst                                           0x0096
#define VGIP_CHN2_MISC_ch2_de_mask_en_shift                           (31)
#define VGIP_CHN2_MISC_ch2_hporch_num_shift                           (8)
#define VGIP_CHN2_MISC_ch2_auto_ihs_dly_shift                         (6)
#define VGIP_CHN2_MISC_ch2_auto_ivs_dly_shift                         (4)
#define VGIP_CHN2_MISC_ch2_hdly_one_shift                             (3)
#define VGIP_CHN2_MISC_ch2_v1_v2_swap_shift                           (2)
#define VGIP_CHN2_MISC_ch2_v2_v3_swap_shift                           (1)
#define VGIP_CHN2_MISC_ch2_v1_v3_swap_shift                           (0)
#define VGIP_CHN2_MISC_ch2_de_mask_en_mask                            (0x80000000)
#define VGIP_CHN2_MISC_ch2_hporch_num_mask                            (0x0007FF00)
#define VGIP_CHN2_MISC_ch2_auto_ihs_dly_mask                          (0x000000C0)
#define VGIP_CHN2_MISC_ch2_auto_ivs_dly_mask                          (0x00000030)
#define VGIP_CHN2_MISC_ch2_hdly_one_mask                              (0x00000008)
#define VGIP_CHN2_MISC_ch2_v1_v2_swap_mask                            (0x00000004)
#define VGIP_CHN2_MISC_ch2_v2_v3_swap_mask                            (0x00000002)
#define VGIP_CHN2_MISC_ch2_v1_v3_swap_mask                            (0x00000001)
#define VGIP_CHN2_MISC_ch2_de_mask_en(data)                           (0x80000000&((data)<<31))
#define VGIP_CHN2_MISC_ch2_hporch_num(data)                           (0x0007FF00&((data)<<8))
#define VGIP_CHN2_MISC_ch2_auto_ihs_dly(data)                         (0x000000C0&((data)<<6))
#define VGIP_CHN2_MISC_ch2_auto_ivs_dly(data)                         (0x00000030&((data)<<4))
#define VGIP_CHN2_MISC_ch2_hdly_one(data)                             (0x00000008&((data)<<3))
#define VGIP_CHN2_MISC_ch2_v1_v2_swap(data)                           (0x00000004&((data)<<2))
#define VGIP_CHN2_MISC_ch2_v2_v3_swap(data)                           (0x00000002&((data)<<1))
#define VGIP_CHN2_MISC_ch2_v1_v3_swap(data)                           (0x00000001&(data))
#define VGIP_CHN2_MISC_get_ch2_de_mask_en(data)                       ((0x80000000&(data))>>31)
#define VGIP_CHN2_MISC_get_ch2_hporch_num(data)                       ((0x0007FF00&(data))>>8)
#define VGIP_CHN2_MISC_get_ch2_auto_ihs_dly(data)                     ((0x000000C0&(data))>>6)
#define VGIP_CHN2_MISC_get_ch2_auto_ivs_dly(data)                     ((0x00000030&(data))>>4)
#define VGIP_CHN2_MISC_get_ch2_hdly_one(data)                         ((0x00000008&(data))>>3)
#define VGIP_CHN2_MISC_get_ch2_v1_v2_swap(data)                       ((0x00000004&(data))>>2)
#define VGIP_CHN2_MISC_get_ch2_v2_v3_swap(data)                       ((0x00000002&(data))>>1)
#define VGIP_CHN2_MISC_get_ch2_v1_v3_swap(data)                       (0x00000001&(data))


#define VGIP_CHN2_PTN_H_VI                                            0x1802225c
#define VGIP_CHN2_PTN_H_VI_reg_addr                                   "0xb802225c"
#define VGIP_CHN2_PTN_H_VI_reg                                        0xb802225c
#define VGIP_CHN2_PTN_H_VI_inst_addr                                  "0x0097"
#define VGIP_CHN2_PTN_H_VI_inst                                       0x0097
#define VGIP_CHN2_PTN_H_VI_ch2_captst_en_shift                        (31)
#define VGIP_CHN2_PTN_H_VI_ch2_captst_mode_shift                      (30)
#define VGIP_CHN2_PTN_H_VI_ch2_vcaptst_num_shift                      (16)
#define VGIP_CHN2_PTN_H_VI_ch2_hcaptst_num_shift                      (0)
#define VGIP_CHN2_PTN_H_VI_ch2_captst_en_mask                         (0x80000000)
#define VGIP_CHN2_PTN_H_VI_ch2_captst_mode_mask                       (0x40000000)
#define VGIP_CHN2_PTN_H_VI_ch2_vcaptst_num_mask                       (0x0FFF0000)
#define VGIP_CHN2_PTN_H_VI_ch2_hcaptst_num_mask                       (0x00000FFF)
#define VGIP_CHN2_PTN_H_VI_ch2_captst_en(data)                        (0x80000000&((data)<<31))
#define VGIP_CHN2_PTN_H_VI_ch2_captst_mode(data)                      (0x40000000&((data)<<30))
#define VGIP_CHN2_PTN_H_VI_ch2_vcaptst_num(data)                      (0x0FFF0000&((data)<<16))
#define VGIP_CHN2_PTN_H_VI_ch2_hcaptst_num(data)                      (0x00000FFF&(data))
#define VGIP_CHN2_PTN_H_VI_get_ch2_captst_en(data)                    ((0x80000000&(data))>>31)
#define VGIP_CHN2_PTN_H_VI_get_ch2_captst_mode(data)                  ((0x40000000&(data))>>30)
#define VGIP_CHN2_PTN_H_VI_get_ch2_vcaptst_num(data)                  ((0x0FFF0000&(data))>>16)
#define VGIP_CHN2_PTN_H_VI_get_ch2_hcaptst_num(data)                  (0x00000FFF&(data))


#define VGIP_CHN2_PTN0                                                0x18022260
#define VGIP_CHN2_PTN0_reg_addr                                       "0xb8022260"
#define VGIP_CHN2_PTN0_reg                                            0xb8022260
#define VGIP_CHN2_PTN0_inst_addr                                      "0x0098"
#define VGIP_CHN2_PTN0_inst                                           0x0098
#define VGIP_CHN2_PTN0_ch2_captst_r_data_shift                        (16)
#define VGIP_CHN2_PTN0_ch2_captst_g_data_shift                        (0)
#define VGIP_CHN2_PTN0_ch2_captst_r_data_mask                         (0x00FF0000)
#define VGIP_CHN2_PTN0_ch2_captst_g_data_mask                         (0x000000FF)
#define VGIP_CHN2_PTN0_ch2_captst_r_data(data)                        (0x00FF0000&((data)<<16))
#define VGIP_CHN2_PTN0_ch2_captst_g_data(data)                        (0x000000FF&(data))
#define VGIP_CHN2_PTN0_get_ch2_captst_r_data(data)                    ((0x00FF0000&(data))>>16)
#define VGIP_CHN2_PTN0_get_ch2_captst_g_data(data)                    (0x000000FF&(data))


#define VGIP_CHN2_PTN1                                                0x18022264
#define VGIP_CHN2_PTN1_reg_addr                                       "0xb8022264"
#define VGIP_CHN2_PTN1_reg                                            0xb8022264
#define VGIP_CHN2_PTN1_inst_addr                                      "0x0099"
#define VGIP_CHN2_PTN1_inst                                           0x0099
#define VGIP_CHN2_PTN1_ch2_captst_b_data_shift                        (0)
#define VGIP_CHN2_PTN1_ch2_captst_b_data_mask                         (0x000000FF)
#define VGIP_CHN2_PTN1_ch2_captst_b_data(data)                        (0x000000FF&(data))
#define VGIP_CHN2_PTN1_get_ch2_captst_b_data(data)                    (0x000000FF&(data))


#define VGIP_CHN2_LC                                                  0x18022268
#define VGIP_CHN2_LC_reg_addr                                         "0xb8022268"
#define VGIP_CHN2_LC_reg                                              0xb8022268
#define VGIP_CHN2_LC_inst_addr                                        "0x009A"
#define VGIP_CHN2_LC_inst                                             0x009A
#define VGIP_CHN2_LC_ch2_vlcen_shift                                  (31)
#define VGIP_CHN2_LC_ch2_vlc_mode_shift                               (30)
#define VGIP_CHN2_LC_ch2_vlc_ie_shift                                 (29)
#define VGIP_CHN2_LC_dummy18022268_28_shift                           (28)
#define VGIP_CHN2_LC_ch2_vlc_status_shift                             (27)
#define VGIP_CHN2_LC_dummy18022268_15_11_shift                        (11)
#define VGIP_CHN2_LC_ch2_vln_shift                                    (0)
#define VGIP_CHN2_LC_ch2_vlcen_mask                                   (0x80000000)
#define VGIP_CHN2_LC_ch2_vlc_mode_mask                                (0x40000000)
#define VGIP_CHN2_LC_ch2_vlc_ie_mask                                  (0x20000000)
#define VGIP_CHN2_LC_dummy18022268_28_mask                            (0x10000000)
#define VGIP_CHN2_LC_ch2_vlc_status_mask                              (0x08000000)
#define VGIP_CHN2_LC_dummy18022268_15_11_mask                         (0x0000F800)
#define VGIP_CHN2_LC_ch2_vln_mask                                     (0x000007FF)
#define VGIP_CHN2_LC_ch2_vlcen(data)                                  (0x80000000&((data)<<31))
#define VGIP_CHN2_LC_ch2_vlc_mode(data)                               (0x40000000&((data)<<30))
#define VGIP_CHN2_LC_ch2_vlc_ie(data)                                 (0x20000000&((data)<<29))
#define VGIP_CHN2_LC_dummy18022268_28(data)                           (0x10000000&((data)<<28))
#define VGIP_CHN2_LC_ch2_vlc_status(data)                             (0x08000000&((data)<<27))
#define VGIP_CHN2_LC_dummy18022268_15_11(data)                        (0x0000F800&((data)<<11))
#define VGIP_CHN2_LC_ch2_vln(data)                                    (0x000007FF&(data))
#define VGIP_CHN2_LC_get_ch2_vlcen(data)                              ((0x80000000&(data))>>31)
#define VGIP_CHN2_LC_get_ch2_vlc_mode(data)                           ((0x40000000&(data))>>30)
#define VGIP_CHN2_LC_get_ch2_vlc_ie(data)                             ((0x20000000&(data))>>29)
#define VGIP_CHN2_LC_get_dummy18022268_28(data)                       ((0x10000000&(data))>>28)
#define VGIP_CHN2_LC_get_ch2_vlc_status(data)                         ((0x08000000&(data))>>27)
#define VGIP_CHN2_LC_get_dummy18022268_15_11(data)                    ((0x0000F800&(data))>>11)
#define VGIP_CHN2_LC_get_ch2_vln(data)                                (0x000007FF&(data))
#else
#define SUB_VGIP_CHN1_STATUS                                              0x18022414
#define SUB_VGIP_CHN1_STATUS_reg_addr                                     "0xb8022414"
#define SUB_VGIP_CHN1_STATUS_reg                                          0xb8022414
#define SUB_VGIP_CHN1_STATUS_inst_addr                                    "0x0105"
#define SUB_VGIP_CHN1_STATUS_inst                                         0x0105
#define SUB_VGIP_CHN1_STATUS_ch2_vs_end_shift                             (27)
#define SUB_VGIP_CHN1_STATUS_ch2_vs_start_shift                           (26)
#define SUB_VGIP_CHN1_STATUS_ch2_vact_end_shift                           (25)
#define SUB_VGIP_CHN1_STATUS_ch2_vact_start_shift                         (24)
#define SUB_VGIP_CHN1_STATUS_dummy18022248_23_15_shift                    (15)
#define SUB_VGIP_CHN1_STATUS_ch2_vs_err_shift                             (14)
#define SUB_VGIP_CHN1_STATUS_ch2_hs_err_shift                             (13)
#define SUB_VGIP_CHN1_STATUS_ch2_field_err_shift                          (12)
#define SUB_VGIP_CHN1_STATUS_dummy18022248_11_10_shift                    (10)
#define SUB_VGIP_CHN1_STATUS_ch2_vs_tog_shift                             (9)
#define SUB_VGIP_CHN1_STATUS_ch2_hs_tog_shift                             (8)
#define SUB_VGIP_CHN1_STATUS_ch2_field_pol_shift                          (7)
#define SUB_VGIP_CHN1_STATUS_ch2_field_tog_shift                          (6)
#define SUB_VGIP_CHN1_STATUS_ch2_field_vs_lsb_shift                       (4)
#define SUB_VGIP_CHN1_STATUS_ch2_more_1line_field_shift                   (3)
#define SUB_VGIP_CHN1_STATUS_ch2_bounce_status_2_shift                    (2)
#define SUB_VGIP_CHN1_STATUS_ch2_bounce_status_1_shift                    (1)
#define SUB_VGIP_CHN1_STATUS_ch2_bounce_status_0_shift                    (0)
#define SUB_VGIP_CHN1_STATUS_ch2_vs_end_mask                              (0x08000000)
#define SUB_VGIP_CHN1_STATUS_ch2_vs_start_mask                            (0x04000000)
#define SUB_VGIP_CHN1_STATUS_ch2_vact_end_mask                            (0x02000000)
#define SUB_VGIP_CHN1_STATUS_ch2_vact_start_mask                          (0x01000000)
#define SUB_VGIP_CHN1_STATUS_dummy18022248_23_15_mask                     (0x00FF8000)
#define SUB_VGIP_CHN1_STATUS_ch2_vs_err_mask                              (0x00004000)
#define SUB_VGIP_CHN1_STATUS_ch2_hs_err_mask                              (0x00002000)
#define SUB_VGIP_CHN1_STATUS_ch2_field_err_mask                           (0x00001000)
#define SUB_VGIP_CHN1_STATUS_dummy18022248_11_10_mask                     (0x00000C00)
#define SUB_VGIP_CHN1_STATUS_ch2_vs_tog_mask                              (0x00000200)
#define SUB_VGIP_CHN1_STATUS_ch2_hs_tog_mask                              (0x00000100)
#define SUB_VGIP_CHN1_STATUS_ch2_field_pol_mask                           (0x00000080)
#define SUB_VGIP_CHN1_STATUS_ch2_field_tog_mask                           (0x00000040)
#define SUB_VGIP_CHN1_STATUS_ch2_field_vs_lsb_mask                        (0x00000030)
#define SUB_VGIP_CHN1_STATUS_ch2_more_1line_field_mask                    (0x00000008)
#define SUB_VGIP_CHN1_STATUS_ch2_bounce_status_2_mask                     (0x00000004)
#define SUB_VGIP_CHN1_STATUS_ch2_bounce_status_1_mask                     (0x00000002)
#define SUB_VGIP_CHN1_STATUS_ch2_bounce_status_0_mask                     (0x00000001)
#define SUB_VGIP_CHN1_STATUS_ch2_vs_end(data)                             (0x08000000&((data)<<27))
#define SUB_VGIP_CHN1_STATUS_ch2_vs_start(data)                           (0x04000000&((data)<<26))
#define SUB_VGIP_CHN1_STATUS_ch2_vact_end(data)                           (0x02000000&((data)<<25))
#define SUB_VGIP_CHN1_STATUS_ch2_vact_start(data)                         (0x01000000&((data)<<24))
#define SUB_VGIP_CHN1_STATUS_dummy18022248_23_15(data)                    (0x00FF8000&((data)<<15))
#define SUB_VGIP_CHN1_STATUS_ch2_vs_err(data)                             (0x00004000&((data)<<14))
#define SUB_VGIP_CHN1_STATUS_ch2_hs_err(data)                             (0x00002000&((data)<<13))
#define SUB_VGIP_CHN1_STATUS_ch2_field_err(data)                          (0x00001000&((data)<<12))
#define SUB_VGIP_CHN1_STATUS_dummy18022248_11_10(data)                    (0x00000C00&((data)<<10))
#define SUB_VGIP_CHN1_STATUS_ch2_vs_tog(data)                             (0x00000200&((data)<<9))
#define SUB_VGIP_CHN1_STATUS_ch2_hs_tog(data)                             (0x00000100&((data)<<8))
#define SUB_VGIP_CHN1_STATUS_ch2_field_pol(data)                          (0x00000080&((data)<<7))
#define SUB_VGIP_CHN1_STATUS_ch2_field_tog(data)                          (0x00000040&((data)<<6))
#define SUB_VGIP_CHN1_STATUS_ch2_field_vs_lsb(data)                       (0x00000030&((data)<<4))
#define SUB_VGIP_CHN1_STATUS_ch2_more_1line_field(data)                   (0x00000008&((data)<<3))
#define SUB_VGIP_CHN1_STATUS_ch2_bounce_status_2(data)                    (0x00000004&((data)<<2))
#define SUB_VGIP_CHN1_STATUS_ch2_bounce_status_1(data)                    (0x00000002&((data)<<1))
#define SUB_VGIP_CHN1_STATUS_ch2_bounce_status_0(data)                    (0x00000001&(data))
#define SUB_VGIP_CHN1_STATUS_get_ch2_vs_end(data)                         ((0x08000000&(data))>>27)
#define SUB_VGIP_CHN1_STATUS_get_ch2_vs_start(data)                       ((0x04000000&(data))>>26)
#define SUB_VGIP_CHN1_STATUS_get_ch2_vact_end(data)                       ((0x02000000&(data))>>25)
#define SUB_VGIP_CHN1_STATUS_get_ch2_vact_start(data)                     ((0x01000000&(data))>>24)
#define SUB_VGIP_CHN1_STATUS_get_dummy18022248_23_15(data)                ((0x00FF8000&(data))>>15)
#define SUB_VGIP_CHN1_STATUS_get_ch2_vs_err(data)                         ((0x00004000&(data))>>14)
#define SUB_VGIP_CHN1_STATUS_get_ch2_hs_err(data)                         ((0x00002000&(data))>>13)
#define SUB_VGIP_CHN1_STATUS_get_ch2_field_err(data)                      ((0x00001000&(data))>>12)
#define SUB_VGIP_CHN1_STATUS_get_dummy18022248_11_10(data)                ((0x00000C00&(data))>>10)
#define SUB_VGIP_CHN1_STATUS_get_ch2_vs_tog(data)                         ((0x00000200&(data))>>9)
#define SUB_VGIP_CHN1_STATUS_get_ch2_hs_tog(data)                         ((0x00000100&(data))>>8)
#define SUB_VGIP_CHN1_STATUS_get_ch2_field_pol(data)                      ((0x00000080&(data))>>7)
#define SUB_VGIP_CHN1_STATUS_get_ch2_field_tog(data)                      ((0x00000040&(data))>>6)
#define SUB_VGIP_CHN1_STATUS_get_ch2_field_vs_lsb(data)                   ((0x00000030&(data))>>4)
#define SUB_VGIP_CHN1_STATUS_get_ch2_more_1line_field(data)               ((0x00000008&(data))>>3)
#define SUB_VGIP_CHN1_STATUS_get_ch2_bounce_status_2(data)                ((0x00000004&(data))>>2)
#define SUB_VGIP_CHN1_STATUS_get_ch2_bounce_status_1(data)                ((0x00000002&(data))>>1)
#define SUB_VGIP_CHN1_STATUS_get_ch2_bounce_status_0(data)                (0x00000001&(data))


#define SUB_VGIP_CHN1_ACT_HSTA_WIDTH                                      0x18022418
#define SUB_VGIP_CHN1_ACT_HSTA_WIDTH_reg_addr                             "0xb8022418"
#define SUB_VGIP_CHN1_ACT_HSTA_WIDTH_reg                                  0xb8022418
#define SUB_VGIP_CHN1_ACT_HSTA_WIDTH_inst_addr                            "0x0106"
#define SUB_VGIP_CHN1_ACT_HSTA_WIDTH_inst                                 0x0106
#define SUB_VGIP_CHN1_ACT_HSTA_WIDTH_ch2_db_rdy_shift                     (31)
#define SUB_VGIP_CHN1_ACT_HSTA_WIDTH_ch2_db_en_shift                      (30)
#define SUB_VGIP_CHN1_ACT_HSTA_WIDTH_ch2_ih_act_sta_shift                 (16)
#define SUB_VGIP_CHN1_ACT_HSTA_WIDTH_ch2_ih_act_wid_shift                 (0)
#define SUB_VGIP_CHN1_ACT_HSTA_WIDTH_ch2_db_rdy_mask                      (0x80000000)
#define SUB_VGIP_CHN1_ACT_HSTA_WIDTH_ch2_db_en_mask                       (0x40000000)
#define SUB_VGIP_CHN1_ACT_HSTA_WIDTH_ch2_ih_act_sta_mask                  (0x0FFF0000)
#define SUB_VGIP_CHN1_ACT_HSTA_WIDTH_ch2_ih_act_wid_mask                  (0x00000FFF)
#define SUB_VGIP_CHN1_ACT_HSTA_WIDTH_ch2_db_rdy(data)                     (0x80000000&((data)<<31))
#define SUB_VGIP_CHN1_ACT_HSTA_WIDTH_ch2_db_en(data)                      (0x40000000&((data)<<30))
#define SUB_VGIP_CHN1_ACT_HSTA_WIDTH_ch2_ih_act_sta(data)                 (0x0FFF0000&((data)<<16))
#define SUB_VGIP_CHN1_ACT_HSTA_WIDTH_ch2_ih_act_wid(data)                 (0x00000FFF&(data))
#define SUB_VGIP_CHN1_ACT_HSTA_WIDTH_get_ch2_db_rdy(data)                 ((0x80000000&(data))>>31)
#define SUB_VGIP_CHN1_ACT_HSTA_WIDTH_get_ch2_db_en(data)                  ((0x40000000&(data))>>30)
#define SUB_VGIP_CHN1_ACT_HSTA_WIDTH_get_ch2_ih_act_sta(data)             ((0x0FFF0000&(data))>>16)
#define SUB_VGIP_CHN1_ACT_HSTA_WIDTH_get_ch2_ih_act_wid(data)             (0x00000FFF&(data))


#define SUB_VGIP_CHN1_ACT_VSTA_LENGTH                                     0x1802241c
#define SUB_VGIP_CHN1_ACT_VSTA_LENGTH_reg_addr                            "0xb802241c"
#define SUB_VGIP_CHN1_ACT_VSTA_LENGTH_reg                                 0xb802241c
#define SUB_VGIP_CHN1_ACT_VSTA_LENGTH_inst_addr                           "0x0107"
#define SUB_VGIP_CHN1_ACT_VSTA_LENGTH_inst                                0x0107
#define SUB_VGIP_CHN1_ACT_VSTA_LENGTH_ch2_iv_act_sta_shift                (16)
#define SUB_VGIP_CHN1_ACT_VSTA_LENGTH_ch2_iv_act_len_shift                (0)
#define SUB_VGIP_CHN1_ACT_VSTA_LENGTH_ch2_iv_act_sta_mask                 (0x0FFF0000)
#define SUB_VGIP_CHN1_ACT_VSTA_LENGTH_ch2_iv_act_len_mask                 (0x00000FFF)
#define SUB_VGIP_CHN1_ACT_VSTA_LENGTH_ch2_iv_act_sta(data)                (0x0FFF0000&((data)<<16))
#define SUB_VGIP_CHN1_ACT_VSTA_LENGTH_ch2_iv_act_len(data)                (0x00000FFF&(data))
#define SUB_VGIP_CHN1_ACT_VSTA_LENGTH_get_ch2_iv_act_sta(data)            ((0x0FFF0000&(data))>>16)
#define SUB_VGIP_CHN1_ACT_VSTA_LENGTH_get_ch2_iv_act_len(data)            (0x00000FFF&(data))


#define SUB_VGIP_CHN1_DELAY                                               0x18022420
#define SUB_VGIP_CHN1_DELAY_reg_addr                                      "0xb8022420"
#define SUB_VGIP_CHN1_DELAY_reg                                           0xb8022420
#define SUB_VGIP_CHN1_DELAY_inst_addr                                     "0x0108"
#define SUB_VGIP_CHN1_DELAY_inst                                          0x0108
#define SUB_VGIP_CHN1_DELAY_ch2_ihs_dly_shift                             (16)
#define SUB_VGIP_CHN1_DELAY_ch2_ivs_dly_shift                             (0)
#define SUB_VGIP_CHN1_DELAY_ch2_ihs_dly_mask                              (0x0FFF0000)
#define SUB_VGIP_CHN1_DELAY_ch2_ivs_dly_mask                              (0x00000FFF)
#define SUB_VGIP_CHN1_DELAY_ch2_ihs_dly(data)                             (0x0FFF0000&((data)<<16))
#define SUB_VGIP_CHN1_DELAY_ch2_ivs_dly(data)                             (0x00000FFF&(data))
#define SUB_VGIP_CHN1_DELAY_get_ch2_ihs_dly(data)                         ((0x0FFF0000&(data))>>16)
#define SUB_VGIP_CHN1_DELAY_get_ch2_ivs_dly(data)                         (0x00000FFF&(data))


#define SUB_VGIP_CHN1_MISC                                                0x18022424
#define SUB_VGIP_CHN1_MISC_reg_addr                                       "0xb8022424"
#define SUB_VGIP_CHN1_MISC_reg                                            0xb8022424
#define SUB_VGIP_CHN1_MISC_inst_addr                                      "0x0109"
#define SUB_VGIP_CHN1_MISC_inst                                           0x0109
#define SUB_VGIP_CHN1_MISC_ch2_de_mask_en_shift                           (31)
#define SUB_VGIP_CHN1_MISC_ch2_hporch_num_shift                           (8)
#define SUB_VGIP_CHN1_MISC_ch2_auto_ihs_dly_shift                         (6)
#define SUB_VGIP_CHN1_MISC_ch2_auto_ivs_dly_shift                         (4)
#define SUB_VGIP_CHN1_MISC_ch2_hdly_one_shift                             (3)
#define SUB_VGIP_CHN1_MISC_ch2_v1_v2_swap_shift                           (2)
#define SUB_VGIP_CHN1_MISC_ch2_v2_v3_swap_shift                           (1)
#define SUB_VGIP_CHN1_MISC_ch2_v1_v3_swap_shift                           (0)
#define SUB_VGIP_CHN1_MISC_ch2_de_mask_en_mask                            (0x80000000)
#define SUB_VGIP_CHN1_MISC_ch2_hporch_num_mask                            (0x0007FF00)
#define SUB_VGIP_CHN1_MISC_ch2_auto_ihs_dly_mask                          (0x000000C0)
#define SUB_VGIP_CHN1_MISC_ch2_auto_ivs_dly_mask                          (0x00000030)
#define SUB_VGIP_CHN1_MISC_ch2_hdly_one_mask                              (0x00000008)
#define SUB_VGIP_CHN1_MISC_ch2_v1_v2_swap_mask                            (0x00000004)
#define SUB_VGIP_CHN1_MISC_ch2_v2_v3_swap_mask                            (0x00000002)
#define SUB_VGIP_CHN1_MISC_ch2_v1_v3_swap_mask                            (0x00000001)
#define SUB_VGIP_CHN1_MISC_ch2_de_mask_en(data)                           (0x80000000&((data)<<31))
#define SUB_VGIP_CHN1_MISC_ch2_hporch_num(data)                           (0x0007FF00&((data)<<8))
#define SUB_VGIP_CHN1_MISC_ch2_auto_ihs_dly(data)                         (0x000000C0&((data)<<6))
#define SUB_VGIP_CHN1_MISC_ch2_auto_ivs_dly(data)                         (0x00000030&((data)<<4))
#define SUB_VGIP_CHN1_MISC_ch2_hdly_one(data)                             (0x00000008&((data)<<3))
#define SUB_VGIP_CHN1_MISC_ch2_v1_v2_swap(data)                           (0x00000004&((data)<<2))
#define SUB_VGIP_CHN1_MISC_ch2_v2_v3_swap(data)                           (0x00000002&((data)<<1))
#define SUB_VGIP_CHN1_MISC_ch2_v1_v3_swap(data)                           (0x00000001&(data))
#define SUB_VGIP_CHN1_MISC_get_ch2_de_mask_en(data)                       ((0x80000000&(data))>>31)
#define SUB_VGIP_CHN1_MISC_get_ch2_hporch_num(data)                       ((0x0007FF00&(data))>>8)
#define SUB_VGIP_CHN1_MISC_get_ch2_auto_ihs_dly(data)                     ((0x000000C0&(data))>>6)
#define SUB_VGIP_CHN1_MISC_get_ch2_auto_ivs_dly(data)                     ((0x00000030&(data))>>4)
#define SUB_VGIP_CHN1_MISC_get_ch2_hdly_one(data)                         ((0x00000008&(data))>>3)
#define SUB_VGIP_CHN1_MISC_get_ch2_v1_v2_swap(data)                       ((0x00000004&(data))>>2)
#define SUB_VGIP_CHN1_MISC_get_ch2_v2_v3_swap(data)                       ((0x00000002&(data))>>1)
#define SUB_VGIP_CHN1_MISC_get_ch2_v1_v3_swap(data)                       (0x00000001&(data))


#define SUB_VGIP_CHN1_PTN_H_VI                                            0x18022428
#define SUB_VGIP_CHN1_PTN_H_VI_reg_addr                                   "0xb8022428"
#define SUB_VGIP_CHN1_PTN_H_VI_reg                                        0xb8022428
#define SUB_VGIP_CHN1_PTN_H_VI_inst_addr                                  "0x010A"
#define SUB_VGIP_CHN1_PTN_H_VI_inst                                       0x010A
#define SUB_VGIP_CHN1_PTN_H_VI_ch2_captst_en_shift                        (31)
#define SUB_VGIP_CHN1_PTN_H_VI_ch2_captst_mode_shift                      (30)
#define SUB_VGIP_CHN1_PTN_H_VI_ch2_vcaptst_num_shift                      (16)
#define SUB_VGIP_CHN1_PTN_H_VI_ch2_hcaptst_num_shift                      (0)
#define SUB_VGIP_CHN1_PTN_H_VI_ch2_captst_en_mask                         (0x80000000)
#define SUB_VGIP_CHN1_PTN_H_VI_ch2_captst_mode_mask                       (0x40000000)
#define SUB_VGIP_CHN1_PTN_H_VI_ch2_vcaptst_num_mask                       (0x0FFF0000)
#define SUB_VGIP_CHN1_PTN_H_VI_ch2_hcaptst_num_mask                       (0x00000FFF)
#define SUB_VGIP_CHN1_PTN_H_VI_ch2_captst_en(data)                        (0x80000000&((data)<<31))
#define SUB_VGIP_CHN1_PTN_H_VI_ch2_captst_mode(data)                      (0x40000000&((data)<<30))
#define SUB_VGIP_CHN1_PTN_H_VI_ch2_vcaptst_num(data)                      (0x0FFF0000&((data)<<16))
#define SUB_VGIP_CHN1_PTN_H_VI_ch2_hcaptst_num(data)                      (0x00000FFF&(data))
#define SUB_VGIP_CHN1_PTN_H_VI_get_ch2_captst_en(data)                    ((0x80000000&(data))>>31)
#define SUB_VGIP_CHN1_PTN_H_VI_get_ch2_captst_mode(data)                  ((0x40000000&(data))>>30)
#define SUB_VGIP_CHN1_PTN_H_VI_get_ch2_vcaptst_num(data)                  ((0x0FFF0000&(data))>>16)
#define SUB_VGIP_CHN1_PTN_H_VI_get_ch2_hcaptst_num(data)                  (0x00000FFF&(data))


#define SUB_VGIP_CHN1_PTN0                                                0x1802242c
#define SUB_VGIP_CHN1_PTN0_reg_addr                                       "0xb802242c"
#define SUB_VGIP_CHN1_PTN0_reg                                            0xb802242c
#define SUB_VGIP_CHN1_PTN0_inst_addr                                      "0x010B"
#define SUB_VGIP_CHN1_PTN0_inst                                           0x010B
#define SUB_VGIP_CHN1_PTN0_ch2_captst_r_data_shift                        (16)
#define SUB_VGIP_CHN1_PTN0_ch2_captst_g_data_shift                        (0)
#define SUB_VGIP_CHN1_PTN0_ch2_captst_r_data_mask                         (0x00FF0000)
#define SUB_VGIP_CHN1_PTN0_ch2_captst_g_data_mask                         (0x000000FF)
#define SUB_VGIP_CHN1_PTN0_ch2_captst_r_data(data)                        (0x00FF0000&((data)<<16))
#define SUB_VGIP_CHN1_PTN0_ch2_captst_g_data(data)                        (0x000000FF&(data))
#define SUB_VGIP_CHN1_PTN0_get_ch2_captst_r_data(data)                    ((0x00FF0000&(data))>>16)
#define SUB_VGIP_CHN1_PTN0_get_ch2_captst_g_data(data)                    (0x000000FF&(data))


#define SUB_VGIP_CHN1_PTN1                                                0x18022430
#define SUB_VGIP_CHN1_PTN1_reg_addr                                       "0xb8022430"
#define SUB_VGIP_CHN1_PTN1_reg                                            0xb8022430
#define SUB_VGIP_CHN1_PTN1_inst_addr                                      "0x010C"
#define SUB_VGIP_CHN1_PTN1_inst                                           0x010C
#define SUB_VGIP_CHN1_PTN1_ch2_captst_b_data_shift                        (0)
#define SUB_VGIP_CHN1_PTN1_ch2_captst_b_data_mask                         (0x000000FF)
#define SUB_VGIP_CHN1_PTN1_ch2_captst_b_data(data)                        (0x000000FF&(data))
#define SUB_VGIP_CHN1_PTN1_get_ch2_captst_b_data(data)                    (0x000000FF&(data))


#define SUB_VGIP_CHN1_LC                                                  0x18022434
#define SUB_VGIP_CHN1_LC_reg_addr                                         "0xb8022434"
#define SUB_VGIP_CHN1_LC_reg                                              0xb8022434
#define SUB_VGIP_CHN1_LC_inst_addr                                        "0x010D"
#define SUB_VGIP_CHN1_LC_inst                                             0x010D
#define SUB_VGIP_CHN1_LC_ch2_vlcen_shift                                  (31)
#define SUB_VGIP_CHN1_LC_ch2_vlc_mode_shift                               (30)
#define SUB_VGIP_CHN1_LC_ch2_vlc_ie_shift                                 (29)
#define SUB_VGIP_CHN1_LC_dummy18022268_28_shift                           (28)
#define SUB_VGIP_CHN1_LC_ch2_vlc_status_shift                             (27)
#define SUB_VGIP_CHN1_LC_dummy18022268_15_11_shift                        (11)
#define SUB_VGIP_CHN1_LC_ch2_vln_shift                                    (0)
#define SUB_VGIP_CHN1_LC_ch2_vlcen_mask                                   (0x80000000)
#define SUB_VGIP_CHN1_LC_ch2_vlc_mode_mask                                (0x40000000)
#define SUB_VGIP_CHN1_LC_ch2_vlc_ie_mask                                  (0x20000000)
#define SUB_VGIP_CHN1_LC_dummy18022268_28_mask                            (0x10000000)
#define SUB_VGIP_CHN1_LC_ch2_vlc_status_mask                              (0x08000000)
#define SUB_VGIP_CHN1_LC_dummy18022268_15_11_mask                         (0x0000F800)
#define SUB_VGIP_CHN1_LC_ch2_vln_mask                                     (0x000007FF)
#define SUB_VGIP_CHN1_LC_ch2_vlcen(data)                                  (0x80000000&((data)<<31))
#define SUB_VGIP_CHN1_LC_ch2_vlc_mode(data)                               (0x40000000&((data)<<30))
#define SUB_VGIP_CHN1_LC_ch2_vlc_ie(data)                                 (0x20000000&((data)<<29))
#define SUB_VGIP_CHN1_LC_dummy18022268_28(data)                           (0x10000000&((data)<<28))
#define SUB_VGIP_CHN1_LC_ch2_vlc_status(data)                             (0x08000000&((data)<<27))
#define SUB_VGIP_CHN1_LC_dummy18022268_15_11(data)                        (0x0000F800&((data)<<11))
#define SUB_VGIP_CHN1_LC_ch2_vln(data)                                    (0x000007FF&(data))
#define SUB_VGIP_CHN1_LC_get_ch2_vlcen(data)                              ((0x80000000&(data))>>31)
#define SUB_VGIP_CHN1_LC_get_ch2_vlc_mode(data)                           ((0x40000000&(data))>>30)
#define SUB_VGIP_CHN1_LC_get_ch2_vlc_ie(data)                             ((0x20000000&(data))>>29)
#define SUB_VGIP_CHN1_LC_get_dummy18022268_28(data)                       ((0x10000000&(data))>>28)
#define SUB_VGIP_CHN1_LC_get_ch2_vlc_status(data)                         ((0x08000000&(data))>>27)
#define SUB_VGIP_CHN1_LC_get_dummy18022268_15_11(data)                    ((0x0000F800&(data))>>11)
#define SUB_VGIP_CHN1_LC_get_ch2_vln(data)                                (0x000007FF&(data))

#endif

#define PR_L_R_ONLY_CTRL                                              0x18022250
#define  PR_L_R_ONLY_CTRL_reg_addr                                              "0xB8022250"
#define  PR_L_R_ONLY_CTRL_reg                                                   0xB8022250
#define  PR_L_R_ONLY_CTRL_inst_addr                                             "0x0011"
#define  PR_L_R_ONLY_CTRL_inst                                                  0x0011
#define PR_L_R_ONLY_CTRL_ch1_pr_l_r_only_mask_hs_shift                (2)
#define PR_L_R_ONLY_CTRL_ch1_pr_l_r_only_rm_den_shift                 (1)
#define PR_L_R_ONLY_CTRL_ch1_pr_l_r_only_en_shift                     (0)
#define PR_L_R_ONLY_CTRL_ch1_pr_l_r_only_mask_hs_mask                 (0x00000004)
#define PR_L_R_ONLY_CTRL_ch1_pr_l_r_only_rm_den_mask                  (0x00000002)
#define PR_L_R_ONLY_CTRL_ch1_pr_l_r_only_en_mask                      (0x00000001)
#define PR_L_R_ONLY_CTRL_ch1_pr_l_r_only_mask_hs(data)                (0x00000004&((data)<<2))
#define PR_L_R_ONLY_CTRL_ch1_pr_l_r_only_rm_den(data)                 (0x00000002&((data)<<1))
#define PR_L_R_ONLY_CTRL_ch1_pr_l_r_only_en(data)                     (0x00000001&(data))
#define PR_L_R_ONLY_CTRL_get_ch1_pr_l_r_only_mask_hs(data)            ((0x00000004&(data))>>2)
#define PR_L_R_ONLY_CTRL_get_ch1_pr_l_r_only_rm_den(data)             ((0x00000002&(data))>>1)
#define PR_L_R_ONLY_CTRL_get_ch1_pr_l_r_only_en(data)                 (0x00000001&(data))


#define ADC_RAW_DATA_DMA                                              0x18022278
#define ADC_RAW_DATA_DMA_reg_addr                                     "0xB8022278"
#define ADC_RAW_DATA_DMA_reg                                          0xB8022278
#define ADC_RAW_DATA_DMA_inst_addr                                    "0x0012"
#define ADC_RAW_DATA_DMA_inst                                         0x0012
#define ADC_RAW_DATA_DMA_adc_test_dma_count_shift                     (4)
#define ADC_RAW_DATA_DMA_force_den_shift                              (2)
#define ADC_RAW_DATA_DMA_force_vsync_shift                            (1)
#define ADC_RAW_DATA_DMA_adc_test_dma_mode_shift                      (0)
#define ADC_RAW_DATA_DMA_adc_test_dma_count_mask                      (0xFFFFFFF0)
#define ADC_RAW_DATA_DMA_force_den_mask                               (0x00000004)
#define ADC_RAW_DATA_DMA_force_vsync_mask                             (0x00000002)
#define ADC_RAW_DATA_DMA_adc_test_dma_mode_mask                       (0x00000001)
#define ADC_RAW_DATA_DMA_adc_test_dma_count(data)                     (0xFFFFFFF0&((data)<<4))
#define ADC_RAW_DATA_DMA_force_den(data)                              (0x00000004&((data)<<2))
#define ADC_RAW_DATA_DMA_force_vsync(data)                            (0x00000002&((data)<<1))
#define ADC_RAW_DATA_DMA_adc_test_dma_mode(data)                      (0x00000001&(data))
#define ADC_RAW_DATA_DMA_get_adc_test_dma_count(data)                 ((0xFFFFFFF0&(data))>>4)
#define ADC_RAW_DATA_DMA_get_force_den(data)                          ((0x00000004&(data))>>2)
#define ADC_RAW_DATA_DMA_get_force_vsync(data)                        ((0x00000002&(data))>>1)
#define ADC_RAW_DATA_DMA_get_adc_test_dma_mode(data)                  (0x00000001&(data))


#define FRAMEPACKING_CTRL1                                            0x1802227C
#define FRAMEPACKING_CTRL1_reg_addr                                   "0xB802227C"
#define FRAMEPACKING_CTRL1_reg                                        0xB802227C
#define FRAMEPACKING_CTRL1_inst_addr                                  "0x0013"
#define FRAMEPACKING_CTRL1_inst                                       0x0013
#define FRAMEPACKING_CTRL1_vs_width_shift                             (16)
#define FRAMEPACKING_CTRL1_frame_packing_en_shift                     (13)
#define FRAMEPACKING_CTRL1_vs_position_shift                          (0)
#define FRAMEPACKING_CTRL1_vs_width_mask                              (0x1FFF0000)
#define FRAMEPACKING_CTRL1_frame_packing_en_mask                      (0x00002000)
#define FRAMEPACKING_CTRL1_vs_position_mask                           (0x00001FFF)
#define FRAMEPACKING_CTRL1_vs_width(data)                             (0x1FFF0000&((data)<<16))
#define FRAMEPACKING_CTRL1_frame_packing_en(data)                     (0x00002000&((data)<<13))
#define FRAMEPACKING_CTRL1_vs_position(data)                          (0x00001FFF&(data))
#define FRAMEPACKING_CTRL1_get_vs_width(data)                         ((0x1FFF0000&(data))>>16)
#define FRAMEPACKING_CTRL1_get_frame_packing_en(data)                 ((0x00002000&(data))>>13)
#define FRAMEPACKING_CTRL1_get_vs_position(data)                      (0x00001FFF&(data))

#define FRAMEPACKING_CTRL2                                            0x18022280
#define  FRAMEPACKING_CTRL2_reg_addr                                            "0xB8022280"
#define  FRAMEPACKING_CTRL2_reg                                                 0xB8022280
#define  FRAMEPACKING_CTRL2_inst_addr                                           "0x0014"
#define  FRAMEPACKING_CTRL2_inst                                                0x0014
#define FRAMEPACKING_CTRL2_den_mask_start_shift                       (16)
#define FRAMEPACKING_CTRL2_den_mask_end_shift                         (0)
#define FRAMEPACKING_CTRL2_den_mask_start_mask                        (0x1FFF0000)
#define FRAMEPACKING_CTRL2_den_mask_end_mask                          (0x00001FFF)
#define FRAMEPACKING_CTRL2_den_mask_start(data)                       (0x1FFF0000&((data)<<16))
#define FRAMEPACKING_CTRL2_den_mask_end(data)                         (0x00001FFF&(data))
#define FRAMEPACKING_CTRL2_get_den_mask_start(data)                   ((0x1FFF0000&(data))>>16)
#define FRAMEPACKING_CTRL2_get_den_mask_end(data)                     (0x00001FFF&(data))

#define  Data_Path_Select                                                       0x18022284
#define  Data_Path_Select_reg_addr                                              "0xB8022284"
#define  Data_Path_Select_reg                                                   0xB8022284
#define  Data_Path_Select_inst_addr                                             "0x0015"
#define  Data_Path_Select_inst                                                  0x0015
#define  Data_Path_Select_fsync_ch_sel_shift                                    (5)
#define  Data_Path_Select_adc_ch_sel_shift                                      (4)
#define  Data_Path_Select_xcdi_clk_en_shift                                     (3)
#define  Data_Path_Select_uzd1_in_sel_shift                                     (2)
#define  Data_Path_Select_uzd2_in_sel_shift                                     (1)
#define  Data_Path_Select_xcdi_in_sel_shift                                     (0)
#define  Data_Path_Select_fsync_ch_sel_mask                                     (0x00000020)
#define  Data_Path_Select_adc_ch_sel_mask                                       (0x00000010)
#define  Data_Path_Select_xcdi_clk_en_mask                                      (0x00000008)
#define  Data_Path_Select_uzd1_in_sel_mask                                      (0x00000004)
#define  Data_Path_Select_uzd2_in_sel_mask                                      (0x00000002)
#define  Data_Path_Select_xcdi_in_sel_mask                                      (0x00000001)
#define  Data_Path_Select_fsync_ch_sel(data)                                    (0x00000020&((data)<<5))
#define  Data_Path_Select_adc_ch_sel(data)                                      (0x00000010&((data)<<4))
#define  Data_Path_Select_xcdi_clk_en(data)                                     (0x00000008&((data)<<3))
#define  Data_Path_Select_uzd1_in_sel(data)                                     (0x00000004&((data)<<2))
#define  Data_Path_Select_uzd2_in_sel(data)                                     (0x00000002&((data)<<1))
#define  Data_Path_Select_xcdi_in_sel(data)                                     (0x00000001&(data))
#define  Data_Path_Select_get_fsync_ch_sel(data)                                ((0x00000020&(data))>>5)
#define  Data_Path_Select_get_adc_ch_sel(data)                                  ((0x00000010&(data))>>4)
#define  Data_Path_Select_get_xcdi_clk_en(data)                                 ((0x00000008&(data))>>3)
#define  Data_Path_Select_get_uzd1_in_sel(data)                                 ((0x00000004&(data))>>2)
#define  Data_Path_Select_get_uzd2_in_sel(data)                                 ((0x00000002&(data))>>1)
#define  Data_Path_Select_get_xcdi_in_sel(data)                                 (0x00000001&(data))

#define VGIP_VBISLI                                                   0x18022288
#define  VGIP_VBISLI_reg_addr                                                   "0xB8022288"
#define  VGIP_VBISLI_reg                                                        0xB8022288
#define  VGIP_VBISLI_inst_addr                                                  "0x0016"
#define  VGIP_VBISLI_inst                                                       0x0016
#define VGIP_VBISLI_vbisli_in_sel_shift                               (29)
#define VGIP_VBISLI_vbisli_ivs_dly_shift                              (16)
#define VGIP_VBISLI_vbisli_ihs_dly_shift                              (0)
#define  VGIP_VBISLI_vbisli_in_sel_mask                                         (0x20000000)
#define VGIP_VBISLI_vbisli_ivs_dly_mask                               (0x1FFF0000)
#define VGIP_VBISLI_vbisli_ihs_dly_mask                               (0x00003FFF)
#define  VGIP_VBISLI_vbisli_in_sel(data)                                        (0x20000000&((data)<<29))
#define VGIP_VBISLI_vbisli_ivs_dly(data)                              (0x1FFF0000&((data)<<16))
#define VGIP_VBISLI_vbisli_ihs_dly(data)                              (0x00003FFF&(data))
#define  VGIP_VBISLI_get_vbisli_in_sel(data)                                    ((0x20000000&(data))>>29)
#define VGIP_VBISLI_get_vbisli_ivs_dly(data)                          ((0x1FFF0000&(data))>>16)
#define VGIP_VBISLI_get_vbisli_ihs_dly(data)                          (0x00003FFF&(data))

#define  INT_CTL                                                                0x1802228C
#define  INT_CTL_reg_addr                                                       "0xB802228C"
#define  INT_CTL_reg                                                            0xB802228C
#define  INT_CTL_inst_addr                                                      "0x0017"
#define  INT_CTL_inst                                                           0x0017
#define INT_CTL_onms3_int_ie_shift                                    (9)
#define INT_CTL_offms_int_ie_shift                                    (8)
#define INT_CTL_onms2_int_ie_shift                                    (7)
#define INT_CTL_onms1_int_ie_shift                                    (6)
#define INT_CTL_hist_ch1_int_ie_shift                                 (5)
#define INT_CTL_hist_ch2_int_ie_shift                                 (4)
#define INT_CTL_vgip_int_ie_shift                                     (3)
#define INT_CTL_dispi_int_ie_shift                                    (0)
#define INT_CTL_onms3_int_ie_mask                                     (0x00000200)
#define INT_CTL_offms_int_ie_mask                                     (0x00000100)
#define INT_CTL_onms2_int_ie_mask                                     (0x00000080)
#define INT_CTL_onms1_int_ie_mask                                     (0x00000040)
#define INT_CTL_hist_ch1_int_ie_mask                                  (0x00000020)
#define INT_CTL_hist_ch2_int_ie_mask                                  (0x00000010)
#define INT_CTL_vgip_int_ie_mask                                      (0x00000008)
#define INT_CTL_dispi_int_ie_mask                                     (0x00000001)
#define INT_CTL_onms3_int_ie(data)                                    (0x00000200&((data)<<9))
#define INT_CTL_offms_int_ie(data)                                    (0x00000100&((data)<<8))
#define INT_CTL_onms2_int_ie(data)                                    (0x00000080&((data)<<7))
#define INT_CTL_onms1_int_ie(data)                                    (0x00000040&((data)<<6))
#define INT_CTL_hist_ch1_int_ie(data)                                 (0x00000020&((data)<<5))
#define INT_CTL_hist_ch2_int_ie(data)                                 (0x00000010&((data)<<4))
#define INT_CTL_vgip_int_ie(data)                                     (0x00000008&((data)<<3))
#define INT_CTL_dispi_int_ie(data)                                    (0x00000001&(data))
#define INT_CTL_get_onms3_int_ie(data)                                ((0x00000200&(data))>>9)
#define INT_CTL_get_offms_int_ie(data)                                ((0x00000100&(data))>>8)
#define INT_CTL_get_onms2_int_ie(data)                                ((0x00000080&(data))>>7)
#define INT_CTL_get_onms1_int_ie(data)                                ((0x00000040&(data))>>6)
#define INT_CTL_get_hist_ch1_int_ie(data)                             ((0x00000020&(data))>>5)
#define INT_CTL_get_hist_ch2_int_ie(data)                             ((0x00000010&(data))>>4)
#define INT_CTL_get_vgip_int_ie(data)                                 ((0x00000008&(data))>>3)
#define INT_CTL_get_dispi_int_ie(data)                                (0x00000001&(data))

// it is not used but there will be wrong ,cause there is the same reg name with HDMI spec
/*
#define CTS_FIFO_CTL                                                  0x18022290
#define  CTS_FIFO_CTL_reg_addr                                                  "0xB8022290"
#define  CTS_FIFO_CTL_reg                                                       0xB8022290
#define  CTS_FIFO_CTL_inst_addr                                                 "0x0018"
#define  CTS_FIFO_CTL_inst                                                      0x0018
#define CTS_FIFO_CTL_dummy_ctsfifo_sdnr_shift                         (11)
#define CTS_FIFO_CTL_force_ctsfifo_rstn_sdnr_shift                    (10)
#define CTS_FIFO_CTL_en_ctsfifo_vsrst_sdnr_shift                      (9)
#define CTS_FIFO_CTL_en_ctsfifo_bypass_sdnr_shift                     (8)
#define CTS_FIFO_CTL_dummy_ctsfifo_vgip_shift                         (3)
#define CTS_FIFO_CTL_force_ctsfifo_rstn_vgip_shift                    (2)
#define CTS_FIFO_CTL_en_ctsfifo_vsrst_vgip_shift                      (1)
#define CTS_FIFO_CTL_en_ctsfifo_bypass_vgip_shift                     (0)
#define CTS_FIFO_CTL_dummy_ctsfifo_sdnr_mask                          (0x00000800)
#define CTS_FIFO_CTL_force_ctsfifo_rstn_sdnr_mask                     (0x00000400)
#define CTS_FIFO_CTL_en_ctsfifo_vsrst_sdnr_mask                       (0x00000200)
#define CTS_FIFO_CTL_en_ctsfifo_bypass_sdnr_mask                      (0x00000100)
#define CTS_FIFO_CTL_dummy_ctsfifo_vgip_mask                          (0x00000008)
#define CTS_FIFO_CTL_force_ctsfifo_rstn_vgip_mask                     (0x00000004)
#define CTS_FIFO_CTL_en_ctsfifo_vsrst_vgip_mask                       (0x00000002)
#define CTS_FIFO_CTL_en_ctsfifo_bypass_vgip_mask                      (0x00000001)
#define CTS_FIFO_CTL_dummy_ctsfifo_sdnr(data)                         (0x00000800&((data)<<11))
#define CTS_FIFO_CTL_force_ctsfifo_rstn_sdnr(data)                    (0x00000400&((data)<<10))
#define CTS_FIFO_CTL_en_ctsfifo_vsrst_sdnr(data)                      (0x00000200&((data)<<9))
#define CTS_FIFO_CTL_en_ctsfifo_bypass_sdnr(data)                     (0x00000100&((data)<<8))
#define CTS_FIFO_CTL_dummy_ctsfifo_vgip(data)                         (0x00000008&((data)<<3))
#define CTS_FIFO_CTL_force_ctsfifo_rstn_vgip(data)                    (0x00000004&((data)<<2))
#define CTS_FIFO_CTL_en_ctsfifo_vsrst_vgip(data)                      (0x00000002&((data)<<1))
#define CTS_FIFO_CTL_en_ctsfifo_bypass_vgip(data)                     (0x00000001&(data))
#define CTS_FIFO_CTL_get_dummy_ctsfifo_sdnr(data)                     ((0x00000800&(data))>>11)
#define CTS_FIFO_CTL_get_force_ctsfifo_rstn_sdnr(data)                ((0x00000400&(data))>>10)
#define CTS_FIFO_CTL_get_en_ctsfifo_vsrst_sdnr(data)                  ((0x00000200&(data))>>9)
#define CTS_FIFO_CTL_get_en_ctsfifo_bypass_sdnr(data)                 ((0x00000100&(data))>>8)
#define CTS_FIFO_CTL_get_dummy_ctsfifo_vgip(data)                     ((0x00000008&(data))>>3)
#define CTS_FIFO_CTL_get_force_ctsfifo_rstn_vgip(data)                ((0x00000004&(data))>>2)
#define CTS_FIFO_CTL_get_en_ctsfifo_vsrst_vgip(data)                  ((0x00000002&(data))>>1)
#define CTS_FIFO_CTL_get_en_ctsfifo_bypass_vgip(data)                 (0x00000001&(data))
*/


#define  dispi_test_sel                                                         0x18022294
#define  dispi_test_sel_reg_addr                                                "0xB8022294"
#define  dispi_test_sel_reg                                                     0xB8022294
#define  dispi_test_sel_inst_addr                                               "0x0019"
#define  dispi_test_sel_inst                                                    0x0019
#define  dispi_test_sel_disp_testpinsel_shift                                   (0)
#define  dispi_test_sel_disp_testpinsel_mask                                    (0x0000003F)
#define  dispi_test_sel_disp_testpinsel(data)                                   (0x0000003F&(data))
#define  dispi_test_sel_get_disp_testpinsel(data)                               (0x0000003F&(data))

#define  VGIP_CHN1_3D_RIGHT_ACT_HSTA_Width                                      0x18022298
#define  VGIP_CHN1_3D_RIGHT_ACT_HSTA_Width_reg_addr                             "0xB8022298"
#define  VGIP_CHN1_3D_RIGHT_ACT_HSTA_Width_reg                                  0xB8022298
#define  VGIP_CHN1_3D_RIGHT_ACT_HSTA_Width_inst_addr                            "0x001A"
#define  VGIP_CHN1_3D_RIGHT_ACT_HSTA_Width_inst                                 0x001A
#define  VGIP_CHN1_3D_RIGHT_ACT_HSTA_Width_ch1_3d_right_ih_act_sta_shift        (16)
#define  VGIP_CHN1_3D_RIGHT_ACT_HSTA_Width_ch1_3d_right_ih_act_wid_shift        (0)
#define  VGIP_CHN1_3D_RIGHT_ACT_HSTA_Width_ch1_3d_right_ih_act_sta_mask         (0x3FFF0000)
#define  VGIP_CHN1_3D_RIGHT_ACT_HSTA_Width_ch1_3d_right_ih_act_wid_mask         (0x00003FFF)
#define  VGIP_CHN1_3D_RIGHT_ACT_HSTA_Width_ch1_3d_right_ih_act_sta(data)        (0x3FFF0000&((data)<<16))
#define  VGIP_CHN1_3D_RIGHT_ACT_HSTA_Width_ch1_3d_right_ih_act_wid(data)        (0x00003FFF&(data))
#define  VGIP_CHN1_3D_RIGHT_ACT_HSTA_Width_get_ch1_3d_right_ih_act_sta(data)    ((0x3FFF0000&(data))>>16)
#define  VGIP_CHN1_3D_RIGHT_ACT_HSTA_Width_get_ch1_3d_right_ih_act_wid(data)    (0x00003FFF&(data))

#define  VGIP_CHN1_3D_RIGHT_ACT_VSTA_Length                                     0x1802229C
#define  VGIP_CHN1_3D_RIGHT_ACT_VSTA_Length_reg_addr                            "0xB802229C"
#define  VGIP_CHN1_3D_RIGHT_ACT_VSTA_Length_reg                                 0xB802229C
#define  VGIP_CHN1_3D_RIGHT_ACT_VSTA_Length_inst_addr                           "0x001B"
#define  VGIP_CHN1_3D_RIGHT_ACT_VSTA_Length_inst                                0x001B
#define  VGIP_CHN1_3D_RIGHT_ACT_VSTA_Length_ch1_3d_right_iv_act_sta_shift       (16)
#define  VGIP_CHN1_3D_RIGHT_ACT_VSTA_Length_ch1_3d_right_iv_act_len_shift       (0)
#define  VGIP_CHN1_3D_RIGHT_ACT_VSTA_Length_ch1_3d_right_iv_act_sta_mask        (0x1FFF0000)
#define  VGIP_CHN1_3D_RIGHT_ACT_VSTA_Length_ch1_3d_right_iv_act_len_mask        (0x00001FFF)
#define  VGIP_CHN1_3D_RIGHT_ACT_VSTA_Length_ch1_3d_right_iv_act_sta(data)       (0x1FFF0000&((data)<<16))
#define  VGIP_CHN1_3D_RIGHT_ACT_VSTA_Length_ch1_3d_right_iv_act_len(data)       (0x00001FFF&(data))
#define  VGIP_CHN1_3D_RIGHT_ACT_VSTA_Length_get_ch1_3d_right_iv_act_sta(data)   ((0x1FFF0000&(data))>>16)
#define  VGIP_CHN1_3D_RIGHT_ACT_VSTA_Length_get_ch1_3d_right_iv_act_len(data)   (0x00001FFF&(data))

#define  FRAMEPACKING_INTERLACE_CTRL1                                           0x180222A8
#define  FRAMEPACKING_INTERLACE_CTRL1_reg_addr                                  "0xB80222A8"
#define  FRAMEPACKING_INTERLACE_CTRL1_reg                                       0xB80222A8
#define  FRAMEPACKING_INTERLACE_CTRL1_inst_addr                                 "0x001C"
#define  FRAMEPACKING_INTERLACE_CTRL1_inst                                      0x001C
#define FRAMEPACKING_INTERLACE_CTRL1_vs_width_r_odd_shift             (16)
#define FRAMEPACKING_INTERLACE_CTRL1_frame_packing_field_en_shift     (13)
#define FRAMEPACKING_INTERLACE_CTRL1_vs_position_r_odd_shift          (0)
#define FRAMEPACKING_INTERLACE_CTRL1_vs_width_r_odd_mask              (0x1FFF0000)
#define FRAMEPACKING_INTERLACE_CTRL1_frame_packing_field_en_mask      (0x00002000)
#define FRAMEPACKING_INTERLACE_CTRL1_vs_position_r_odd_mask           (0x00001FFF)
#define FRAMEPACKING_INTERLACE_CTRL1_vs_width_r_odd(data)             (0x1FFF0000&((data)<<16))
#define FRAMEPACKING_INTERLACE_CTRL1_frame_packing_field_en(data)     (0x00002000&((data)<<13))
#define FRAMEPACKING_INTERLACE_CTRL1_vs_position_r_odd(data)          (0x00001FFF&(data))
#define FRAMEPACKING_INTERLACE_CTRL1_get_vs_width_r_odd(data)         ((0x1FFF0000&(data))>>16)
#define FRAMEPACKING_INTERLACE_CTRL1_get_frame_packing_field_en(data) ((0x00002000&(data))>>13)
#define FRAMEPACKING_INTERLACE_CTRL1_get_vs_position_r_odd(data)      (0x00001FFF&(data))

#define  FRAMEPACKING_INTERLACE_CTRL2                                           0x180222AC
#define  FRAMEPACKING_INTERLACE_CTRL2_reg_addr                                  "0xB80222AC"
#define  FRAMEPACKING_INTERLACE_CTRL2_reg                                       0xB80222AC
#define  FRAMEPACKING_INTERLACE_CTRL2_inst_addr                                 "0x001D"
#define  FRAMEPACKING_INTERLACE_CTRL2_inst                                      0x001D
#define FRAMEPACKING_INTERLACE_CTRL2_den_mask_start_r_odd_shift       (16)
#define FRAMEPACKING_INTERLACE_CTRL2_den_mask_end_r_odd_shift         (0)
#define FRAMEPACKING_INTERLACE_CTRL2_den_mask_start_r_odd_mask        (0x1FFF0000)
#define FRAMEPACKING_INTERLACE_CTRL2_den_mask_end_r_odd_mask          (0x00001FFF)
#define FRAMEPACKING_INTERLACE_CTRL2_den_mask_start_r_odd(data)       (0x1FFF0000&((data)<<16))
#define FRAMEPACKING_INTERLACE_CTRL2_den_mask_end_r_odd(data)         (0x00001FFF&(data))
#define FRAMEPACKING_INTERLACE_CTRL2_get_den_mask_start_r_odd(data)   ((0x1FFF0000&(data))>>16)
#define FRAMEPACKING_INTERLACE_CTRL2_get_den_mask_end_r_odd(data)     (0x00001FFF&(data))

#define  FRAMEPACKING_INTERLACE_CTRL3                                           0x180222B0
#define  FRAMEPACKING_INTERLACE_CTRL3_reg_addr                                  "0xB80222B0"
#define  FRAMEPACKING_INTERLACE_CTRL3_reg                                       0xB80222B0
#define  FRAMEPACKING_INTERLACE_CTRL3_inst_addr                                 "0x001E"
#define  FRAMEPACKING_INTERLACE_CTRL3_inst                                      0x001E
#define  FRAMEPACKING_INTERLACE_CTRL3_vs_width_r_even_shift                     (16)
#define  FRAMEPACKING_INTERLACE_CTRL3_vs_position_r_even_shift                  (0)
#define  FRAMEPACKING_INTERLACE_CTRL3_vs_width_r_even_mask                      (0x1FFF0000)
#define  FRAMEPACKING_INTERLACE_CTRL3_vs_position_r_even_mask                   (0x00001FFF)
#define  FRAMEPACKING_INTERLACE_CTRL3_vs_width_r_even(data)                     (0x1FFF0000&((data)<<16))
#define  FRAMEPACKING_INTERLACE_CTRL3_vs_position_r_even(data)                  (0x00001FFF&(data))
#define  FRAMEPACKING_INTERLACE_CTRL3_get_vs_width_r_even(data)                 ((0x1FFF0000&(data))>>16)
#define  FRAMEPACKING_INTERLACE_CTRL3_get_vs_position_r_even(data)              (0x00001FFF&(data))

#define  FRAMEPACKING_INTERLACE_CTRL4                                           0x180222B4
#define  FRAMEPACKING_INTERLACE_CTRL4_reg_addr                                  "0xB80222B4"
#define  FRAMEPACKING_INTERLACE_CTRL4_reg                                       0xB80222B4
#define  FRAMEPACKING_INTERLACE_CTRL4_inst_addr                                 "0x001F"
#define  FRAMEPACKING_INTERLACE_CTRL4_inst                                      0x001F
#define  FRAMEPACKING_INTERLACE_CTRL4_den_mask_start_r_even_shift               (16)
#define  FRAMEPACKING_INTERLACE_CTRL4_den_mask_end_r_even_shift                 (0)
#define  FRAMEPACKING_INTERLACE_CTRL4_den_mask_start_r_even_mask                (0x1FFF0000)
#define  FRAMEPACKING_INTERLACE_CTRL4_den_mask_end_r_even_mask                  (0x00001FFF)
#define  FRAMEPACKING_INTERLACE_CTRL4_den_mask_start_r_even(data)               (0x1FFF0000&((data)<<16))
#define  FRAMEPACKING_INTERLACE_CTRL4_den_mask_end_r_even(data)                 (0x00001FFF&(data))
#define  FRAMEPACKING_INTERLACE_CTRL4_get_den_mask_start_r_even(data)           ((0x1FFF0000&(data))>>16)
#define  FRAMEPACKING_INTERLACE_CTRL4_get_den_mask_end_r_even(data)             (0x00001FFF&(data))

#define  L_R_ACTIVE_ENABLE_CTRL1                                                0x180222B8
#define  L_R_ACTIVE_ENABLE_CTRL1_reg_addr                                       "0xB80222B8"
#define  L_R_ACTIVE_ENABLE_CTRL1_reg                                            0xB80222B8
#define  L_R_ACTIVE_ENABLE_CTRL1_inst_addr                                      "0x0020"
#define  L_R_ACTIVE_ENABLE_CTRL1_inst                                           0x0020
#define  L_R_ACTIVE_ENABLE_CTRL1_end_l_shift                                    (16)
#define  L_R_ACTIVE_ENABLE_CTRL1_sta_l_shift                                    (0)
#define  L_R_ACTIVE_ENABLE_CTRL1_end_l_mask                                     (0x3FFF0000)
#define  L_R_ACTIVE_ENABLE_CTRL1_sta_l_mask                                     (0x00003FFF)
#define  L_R_ACTIVE_ENABLE_CTRL1_end_l(data)                                    (0x3FFF0000&((data)<<16))
#define  L_R_ACTIVE_ENABLE_CTRL1_sta_l(data)                                    (0x00003FFF&(data))
#define  L_R_ACTIVE_ENABLE_CTRL1_get_end_l(data)                                ((0x3FFF0000&(data))>>16)
#define  L_R_ACTIVE_ENABLE_CTRL1_get_sta_l(data)                                (0x00003FFF&(data))

#define  L_R_ACTIVE_ENABLE_CTRL2                                                0x180222BC
#define  L_R_ACTIVE_ENABLE_CTRL2_reg_addr                                       "0xB80222BC"
#define  L_R_ACTIVE_ENABLE_CTRL2_reg                                            0xB80222BC
#define  L_R_ACTIVE_ENABLE_CTRL2_inst_addr                                      "0x0021"
#define  L_R_ACTIVE_ENABLE_CTRL2_inst                                           0x0021
#define  L_R_ACTIVE_ENABLE_CTRL2_l_r_act_en_shift                               (31)
#define  L_R_ACTIVE_ENABLE_CTRL2_h_v_mode_shift                                 (30)
#define  L_R_ACTIVE_ENABLE_CTRL2_end_r_shift                                    (16)
#define  L_R_ACTIVE_ENABLE_CTRL2_sta_r_shift                                    (0)
#define  L_R_ACTIVE_ENABLE_CTRL2_l_r_act_en_mask                                (0x80000000)
#define  L_R_ACTIVE_ENABLE_CTRL2_h_v_mode_mask                                  (0x40000000)
#define  L_R_ACTIVE_ENABLE_CTRL2_end_r_mask                                     (0x3FFF0000)
#define  L_R_ACTIVE_ENABLE_CTRL2_sta_r_mask                                     (0x00003FFF)
#define  L_R_ACTIVE_ENABLE_CTRL2_l_r_act_en(data)                               (0x80000000&((data)<<31))
#define  L_R_ACTIVE_ENABLE_CTRL2_h_v_mode(data)                                 (0x40000000&((data)<<30))
#define  L_R_ACTIVE_ENABLE_CTRL2_end_r(data)                                    (0x3FFF0000&((data)<<16))
#define  L_R_ACTIVE_ENABLE_CTRL2_sta_r(data)                                    (0x00003FFF&(data))
#define  L_R_ACTIVE_ENABLE_CTRL2_get_l_r_act_en(data)                           ((0x80000000&(data))>>31)
#define  L_R_ACTIVE_ENABLE_CTRL2_get_h_v_mode(data)                             ((0x40000000&(data))>>30)
#define  L_R_ACTIVE_ENABLE_CTRL2_get_end_r(data)                                ((0x3FFF0000&(data))>>16)
#define  L_R_ACTIVE_ENABLE_CTRL2_get_sta_r(data)                                (0x00003FFF&(data))

/*

	Sync Processor Measurement

*/

#define SP_MS0CTRL                                                    0x18021100
#define SP_MS0CTRL_reg_addr                                           "0xb8021100"
#define SP_MS0CTRL_reg                                                0xb8021100
#define SP_MS0CTRL_inst_addr                                          "0x0040"
#define SP_MS0CTRL_inst                                               0x0040
#define SP_MS0CTRL_dummy18021100_31_29_shift                          (29)
#define SP_MS0CTRL_off_meas_source_shift                              (24)
#define SP_MS0CTRL_dummy18021100_23_shift                             (23)
#define SP_MS0CTRL_off_meas_to_sel_shift                              (22)
#define SP_MS0CTRL_off_ms_now_shift                                   (21)
#define SP_MS0CTRL_off_timeclk_test_mode_shift                        (20)
#define SP_MS0CTRL_off_meas_source_vgip_sel_shift                     (18)
#define SP_MS0CTRL_off_meas_source_hdmi_sel_shift                     (16)
#define SP_MS0CTRL_off_vs_meas_inv_shift                              (15)
#define SP_MS0CTRL_off_vsms_inv_shift                                 (14)
#define SP_MS0CTRL_off_sycms_mode_shift                               (13)
#define SP_MS0CTRL_off_popup_meas_shift                               (12)
#define SP_MS0CTRL_off_hsms_inv_shift                                 (11)
#define SP_MS0CTRL_off_online_en_shift                                (10)
#define SP_MS0CTRL_off_start_ms_shift                                 (9)
#define SP_MS0CTRL_off_hs_max_delta_shift                             (4)
#define SP_MS0CTRL_off_vs_max_delta_shift                             (0)
#define SP_MS0CTRL_dummy18021100_31_29_mask                           (0xE0000000)
#define SP_MS0CTRL_off_meas_source_mask                               (0x1F000000)
#define SP_MS0CTRL_dummy18021100_23_mask                              (0x00800000)
#define SP_MS0CTRL_off_meas_to_sel_mask                               (0x00400000)
#define SP_MS0CTRL_off_ms_now_mask                                    (0x00200000)
#define SP_MS0CTRL_off_timeclk_test_mode_mask                         (0x00100000)
#define SP_MS0CTRL_off_meas_source_vgip_sel_mask                      (0x000C0000)
#define SP_MS0CTRL_off_meas_source_hdmi_sel_mask                      (0x00030000)
#define SP_MS0CTRL_off_vs_meas_inv_mask                               (0x00008000)
#define SP_MS0CTRL_off_vsms_inv_mask                                  (0x00004000)
#define SP_MS0CTRL_off_sycms_mode_mask                                (0x00002000)
#define SP_MS0CTRL_off_popup_meas_mask                                (0x00001000)
#define SP_MS0CTRL_off_hsms_inv_mask                                  (0x00000800)
#define SP_MS0CTRL_off_online_en_mask                                 (0x00000400)
#define SP_MS0CTRL_off_start_ms_mask                                  (0x00000200)
#define SP_MS0CTRL_off_hs_max_delta_mask                              (0x000001F0)
#define SP_MS0CTRL_off_vs_max_delta_mask                              (0x0000000F)
#define SP_MS0CTRL_dummy18021100_31_29(data)                          (0xE0000000&((data)<<29))
#define SP_MS0CTRL_off_meas_source(data)                              (0x1F000000&((data)<<24))
#define SP_MS0CTRL_dummy18021100_23(data)                             (0x00800000&((data)<<23))
#define SP_MS0CTRL_off_meas_to_sel(data)                              (0x00400000&((data)<<22))
#define SP_MS0CTRL_off_ms_now(data)                                   (0x00200000&((data)<<21))
#define SP_MS0CTRL_off_timeclk_test_mode(data)                        (0x00100000&((data)<<20))
#define SP_MS0CTRL_off_meas_source_vgip_sel(data)                     (0x000C0000&((data)<<18))
#define SP_MS0CTRL_off_meas_source_hdmi_sel(data)                     (0x00030000&((data)<<16))
#define SP_MS0CTRL_off_vs_meas_inv(data)                              (0x00008000&((data)<<15))
#define SP_MS0CTRL_off_vsms_inv(data)                                 (0x00004000&((data)<<14))
#define SP_MS0CTRL_off_sycms_mode(data)                               (0x00002000&((data)<<13))
#define SP_MS0CTRL_off_popup_meas(data)                               (0x00001000&((data)<<12))
#define SP_MS0CTRL_off_hsms_inv(data)                                 (0x00000800&((data)<<11))
#define SP_MS0CTRL_off_online_en(data)                                (0x00000400&((data)<<10))
#define SP_MS0CTRL_off_start_ms(data)                                 (0x00000200&((data)<<9))
#define SP_MS0CTRL_off_hs_max_delta(data)                             (0x000001F0&((data)<<4))
#define SP_MS0CTRL_off_vs_max_delta(data)                             (0x0000000F&(data))
#define SP_MS0CTRL_get_dummy18021100_31_29(data)                      ((0xE0000000&(data))>>29)
#define SP_MS0CTRL_get_off_meas_source(data)                          ((0x1F000000&(data))>>24)
#define SP_MS0CTRL_get_dummy18021100_23(data)                         ((0x00800000&(data))>>23)
#define SP_MS0CTRL_get_off_meas_to_sel(data)                          ((0x00400000&(data))>>22)
#define SP_MS0CTRL_get_off_ms_now(data)                               ((0x00200000&(data))>>21)
#define SP_MS0CTRL_get_off_timeclk_test_mode(data)                    ((0x00100000&(data))>>20)
#define SP_MS0CTRL_get_off_meas_source_vgip_sel(data)                 ((0x000C0000&(data))>>18)
#define SP_MS0CTRL_get_off_meas_source_hdmi_sel(data)                 ((0x00030000&(data))>>16)
#define SP_MS0CTRL_get_off_vs_meas_inv(data)                          ((0x00008000&(data))>>15)
#define SP_MS0CTRL_get_off_vsms_inv(data)                             ((0x00004000&(data))>>14)
#define SP_MS0CTRL_get_off_sycms_mode(data)                           ((0x00002000&(data))>>13)
#define SP_MS0CTRL_get_off_popup_meas(data)                           ((0x00001000&(data))>>12)
#define SP_MS0CTRL_get_off_hsms_inv(data)                             ((0x00000800&(data))>>11)
#define SP_MS0CTRL_get_off_online_en(data)                            ((0x00000400&(data))>>10)
#define SP_MS0CTRL_get_off_start_ms(data)                             ((0x00000200&(data))>>9)
#define SP_MS0CTRL_get_off_hs_max_delta(data)                         ((0x000001F0&(data))>>4)
#define SP_MS0CTRL_get_off_vs_max_delta(data)                         (0x0000000F&(data))


#define SP_MS0RST0                                                    0x18021104
#define SP_MS0RST0_reg_addr                                           "0xb8021104"
#define SP_MS0RST0_reg                                                0xb8021104
#define SP_MS0RST0_inst_addr                                          "0x0041"
#define SP_MS0RST0_inst                                               0x0041
#define SP_MS0RST0_off_vs_period_out_shift                            (18)
#define SP_MS0RST0_off_hs_period_out_h12b_shift                       (4)
#define SP_MS0RST0_off_hs_period_out_f4b_shift                        (0)
#define SP_MS0RST0_off_vs_period_out_mask                             (0x7FFC0000)
#define SP_MS0RST0_off_hs_period_out_h12b_mask                        (0x0003FFF0)
#define SP_MS0RST0_off_hs_period_out_f4b_mask                         (0x0000000F)
#define SP_MS0RST0_off_vs_period_out(data)                            (0x7FFC0000&((data)<<18))
#define SP_MS0RST0_off_hs_period_out_h12b(data)                       (0x0003FFF0&((data)<<4))
#define SP_MS0RST0_off_hs_period_out_f4b(data)                        (0x0000000F&(data))
#define SP_MS0RST0_get_off_vs_period_out(data)                        ((0x7FFC0000&(data))>>18)
#define SP_MS0RST0_get_off_hs_period_out_h12b(data)                   ((0x0003FFF0&(data))>>4)
#define SP_MS0RST0_get_off_hs_period_out_f4b(data)                    (0x0000000F&(data))


#define SP_MS0RST1                                                    0x18021108
#define SP_MS0RST1_reg_addr                                           "0xb8021108"
#define SP_MS0RST1_reg                                                0xb8021108
#define SP_MS0RST1_inst_addr                                          "0x0042"
#define SP_MS0RST1_inst                                               0x0042
#define SP_MS0RST1_dummy18021108_31_29_shift                          (29)
#define SP_MS0RST1_off_vs_high_out_shift                              (16)
#define SP_MS0RST1_dummy18021108_15_14_shift                          (14)
#define SP_MS0RST1_off_hs_high_out_shift                              (0)
#define SP_MS0RST1_dummy18021108_31_29_mask                           (0xE0000000)
#define SP_MS0RST1_off_vs_high_out_mask                               (0x1FFF0000)
#define SP_MS0RST1_dummy18021108_15_14_mask                           (0x0000C000)
#define SP_MS0RST1_off_hs_high_out_mask                               (0x00003FFF)
#define SP_MS0RST1_dummy18021108_31_29(data)                          (0xE0000000&((data)<<29))
#define SP_MS0RST1_off_vs_high_out(data)                              (0x1FFF0000&((data)<<16))
#define SP_MS0RST1_dummy18021108_15_14(data)                          (0x0000C000&((data)<<14))
#define SP_MS0RST1_off_hs_high_out(data)                              (0x00003FFF&(data))
#define SP_MS0RST1_get_dummy18021108_31_29(data)                      ((0xE0000000&(data))>>29)
#define SP_MS0RST1_get_off_vs_high_out(data)                          ((0x1FFF0000&(data))>>16)
#define SP_MS0RST1_get_dummy18021108_15_14(data)                      ((0x0000C000&(data))>>14)
#define SP_MS0RST1_get_off_hs_high_out(data)                          (0x00003FFF&(data))


#define SP_MS0STUS                                                    0x1802110c
#define SP_MS0STUS_reg_addr                                           "0xb802110c"
#define SP_MS0STUS_reg                                                0xb802110c
#define SP_MS0STUS_inst_addr                                          "0x0043"
#define SP_MS0STUS_inst                                               0x0043
#define SP_MS0STUS_off_blk_2frame_en_shift                            (11)
#define SP_MS0STUS_off_vs_per_to_long_shift                           (10)
#define SP_MS0STUS_off_vs_pol_out_shift                               (9)
#define SP_MS0STUS_off_hs_pol_out_shift                               (8)
#define SP_MS0STUS_off_vs_per_to_shift                                (7)
#define SP_MS0STUS_off_vs_high_to_shift                               (6)
#define SP_MS0STUS_off_vs_per_of_shift                                (5)
#define SP_MS0STUS_off_vs_over_range_shift                            (4)
#define SP_MS0STUS_off_vs_pol_chg_shift                               (3)
#define SP_MS0STUS_off_hs_per_of_shift                                (2)
#define SP_MS0STUS_off_hs_over_range_shift                            (1)
#define SP_MS0STUS_off_hs_pol_chg_shift                               (0)
#define SP_MS0STUS_off_blk_2frame_en_mask                             (0x00000800)
#define SP_MS0STUS_off_vs_per_to_long_mask                            (0x00000400)
#define SP_MS0STUS_off_vs_pol_out_mask                                (0x00000200)
#define SP_MS0STUS_off_hs_pol_out_mask                                (0x00000100)
#define SP_MS0STUS_off_vs_per_to_mask                                 (0x00000080)
#define SP_MS0STUS_off_vs_high_to_mask                                (0x00000040)
#define SP_MS0STUS_off_vs_per_of_mask                                 (0x00000020)
#define SP_MS0STUS_off_vs_over_range_mask                             (0x00000010)
#define SP_MS0STUS_off_vs_pol_chg_mask                                (0x00000008)
#define SP_MS0STUS_off_hs_per_of_mask                                 (0x00000004)
#define SP_MS0STUS_off_hs_over_range_mask                             (0x00000002)
#define SP_MS0STUS_off_hs_pol_chg_mask                                (0x00000001)
#define SP_MS0STUS_off_blk_2frame_en(data)                            (0x00000800&((data)<<11))
#define SP_MS0STUS_off_vs_per_to_long(data)                           (0x00000400&((data)<<10))
#define SP_MS0STUS_off_vs_pol_out(data)                               (0x00000200&((data)<<9))
#define SP_MS0STUS_off_hs_pol_out(data)                               (0x00000100&((data)<<8))
#define SP_MS0STUS_off_vs_per_to(data)                                (0x00000080&((data)<<7))
#define SP_MS0STUS_off_vs_high_to(data)                               (0x00000040&((data)<<6))
#define SP_MS0STUS_off_vs_per_of(data)                                (0x00000020&((data)<<5))
#define SP_MS0STUS_off_vs_over_range(data)                            (0x00000010&((data)<<4))
#define SP_MS0STUS_off_vs_pol_chg(data)                               (0x00000008&((data)<<3))
#define SP_MS0STUS_off_hs_per_of(data)                                (0x00000004&((data)<<2))
#define SP_MS0STUS_off_hs_over_range(data)                            (0x00000002&((data)<<1))
#define SP_MS0STUS_off_hs_pol_chg(data)                               (0x00000001&(data))
#define SP_MS0STUS_get_off_blk_2frame_en(data)                        ((0x00000800&(data))>>11)
#define SP_MS0STUS_get_off_vs_per_to_long(data)                       ((0x00000400&(data))>>10)
#define SP_MS0STUS_get_off_vs_pol_out(data)                           ((0x00000200&(data))>>9)
#define SP_MS0STUS_get_off_hs_pol_out(data)                           ((0x00000100&(data))>>8)
#define SP_MS0STUS_get_off_vs_per_to(data)                            ((0x00000080&(data))>>7)
#define SP_MS0STUS_get_off_vs_high_to(data)                           ((0x00000040&(data))>>6)
#define SP_MS0STUS_get_off_vs_per_of(data)                            ((0x00000020&(data))>>5)
#define SP_MS0STUS_get_off_vs_over_range(data)                        ((0x00000010&(data))>>4)
#define SP_MS0STUS_get_off_vs_pol_chg(data)                           ((0x00000008&(data))>>3)
#define SP_MS0STUS_get_off_hs_per_of(data)                            ((0x00000004&(data))>>2)
#define SP_MS0STUS_get_off_hs_over_range(data)                        ((0x00000002&(data))>>1)
#define SP_MS0STUS_get_off_hs_pol_chg(data)                           (0x00000001&(data))


#define SP_MS0IE                                                      0x18021110
#define SP_MS0IE_reg_addr                                             "0xb8021110"
#define SP_MS0IE_reg                                                  0xb8021110
#define SP_MS0IE_inst_addr                                            "0x0044"
#define SP_MS0IE_inst                                                 0x0044
#define SP_MS0IE_ie_off_msdone_shift                                  (31)
#define SP_MS0IE_dummy18021110_11_8_shift                             (8)
#define SP_MS0IE_ie_off_vs_per_to_shift                               (7)
#define SP_MS0IE_ie_off_vs_high_to_shift                              (6)
#define SP_MS0IE_ie_off_vs_per_of_shift                               (5)
#define SP_MS0IE_ie_off_vs_over_range_shift                           (4)
#define SP_MS0IE_ie_off_vs_pol_chg_shift                              (3)
#define SP_MS0IE_ie_off_hs_per_of_shift                               (2)
#define SP_MS0IE_ie_off_hs_over_range_shift                           (1)
#define SP_MS0IE_ie_off_hs_pol_chg_shift                              (0)
#define SP_MS0IE_ie_off_msdone_mask                                   (0x80000000)
#define SP_MS0IE_dummy18021110_11_8_mask                              (0x00000F00)
#define SP_MS0IE_ie_off_vs_per_to_mask                                (0x00000080)
#define SP_MS0IE_ie_off_vs_high_to_mask                               (0x00000040)
#define SP_MS0IE_ie_off_vs_per_of_mask                                (0x00000020)
#define SP_MS0IE_ie_off_vs_over_range_mask                            (0x00000010)
#define SP_MS0IE_ie_off_vs_pol_chg_mask                               (0x00000008)
#define SP_MS0IE_ie_off_hs_per_of_mask                                (0x00000004)
#define SP_MS0IE_ie_off_hs_over_range_mask                            (0x00000002)
#define SP_MS0IE_ie_off_hs_pol_chg_mask                               (0x00000001)
#define SP_MS0IE_ie_off_msdone(data)                                  (0x80000000&((data)<<31))
#define SP_MS0IE_dummy18021110_11_8(data)                             (0x00000F00&((data)<<8))
#define SP_MS0IE_ie_off_vs_per_to(data)                               (0x00000080&((data)<<7))
#define SP_MS0IE_ie_off_vs_high_to(data)                              (0x00000040&((data)<<6))
#define SP_MS0IE_ie_off_vs_per_of(data)                               (0x00000020&((data)<<5))
#define SP_MS0IE_ie_off_vs_over_range(data)                           (0x00000010&((data)<<4))
#define SP_MS0IE_ie_off_vs_pol_chg(data)                              (0x00000008&((data)<<3))
#define SP_MS0IE_ie_off_hs_per_of(data)                               (0x00000004&((data)<<2))
#define SP_MS0IE_ie_off_hs_over_range(data)                           (0x00000002&((data)<<1))
#define SP_MS0IE_ie_off_hs_pol_chg(data)                              (0x00000001&(data))
#define SP_MS0IE_get_ie_off_msdone(data)                              ((0x80000000&(data))>>31)
#define SP_MS0IE_get_dummy18021110_11_8(data)                         ((0x00000F00&(data))>>8)
#define SP_MS0IE_get_ie_off_vs_per_to(data)                           ((0x00000080&(data))>>7)
#define SP_MS0IE_get_ie_off_vs_high_to(data)                          ((0x00000040&(data))>>6)
#define SP_MS0IE_get_ie_off_vs_per_of(data)                           ((0x00000020&(data))>>5)
#define SP_MS0IE_get_ie_off_vs_over_range(data)                       ((0x00000010&(data))>>4)
#define SP_MS0IE_get_ie_off_vs_pol_chg(data)                          ((0x00000008&(data))>>3)
#define SP_MS0IE_get_ie_off_hs_per_of(data)                           ((0x00000004&(data))>>2)
#define SP_MS0IE_get_ie_off_hs_over_range(data)                       ((0x00000002&(data))>>1)
#define SP_MS0IE_get_ie_off_hs_pol_chg(data)                          (0x00000001&(data))


#define RESERVED                                                      0x18021114
#define RESERVED_reg_addr                                             "0xb8021114"
#define RESERVED_reg                                                  0xb8021114
#define RESERVED_inst_addr                                            "0x0045"
#define RESERVED_inst                                                 0x0045


#define SP_MS0ENATVCTRL                                               0x18021118
#define SP_MS0ENATVCTRL_reg_addr                                      "0xb8021118"
#define SP_MS0ENATVCTRL_reg                                           0xb8021118
#define SP_MS0ENATVCTRL_inst_addr                                     "0x0046"
#define SP_MS0ENATVCTRL_inst                                          0x0046
#define SP_MS0ENATVCTRL_off_ena_source_shift                          (7)
#define SP_MS0ENATVCTRL_off_ms_act_en_shift                           (6)
#define SP_MS0ENATVCTRL_dummy18021118_5_0_shift                       (0)
#define SP_MS0ENATVCTRL_off_ena_source_mask                           (0x00000080)
#define SP_MS0ENATVCTRL_off_ms_act_en_mask                            (0x00000040)
#define SP_MS0ENATVCTRL_dummy18021118_5_0_mask                        (0x0000003F)
#define SP_MS0ENATVCTRL_off_ena_source(data)                          (0x00000080&((data)<<7))
#define SP_MS0ENATVCTRL_off_ms_act_en(data)                           (0x00000040&((data)<<6))
#define SP_MS0ENATVCTRL_dummy18021118_5_0(data)                       (0x0000003F&(data))
#define SP_MS0ENATVCTRL_get_off_ena_source(data)                      ((0x00000080&(data))>>7)
#define SP_MS0ENATVCTRL_get_off_ms_act_en(data)                       ((0x00000040&(data))>>6)
#define SP_MS0ENATVCTRL_get_dummy18021118_5_0(data)                   (0x0000003F&(data))


#define SP_MS0ENATV                                                   0x1802111c
#define SP_MS0ENATV_reg_addr                                          "0xb802111c"
#define SP_MS0ENATV_reg                                               0xb802111c
#define SP_MS0ENATV_inst_addr                                         "0x0047"
#define SP_MS0ENATV_inst                                              0x0047
#define SP_MS0ENATV_off_ena_region_out_shift                          (0)
#define SP_MS0ENATV_off_ena_region_out_mask                           (0x00FFFFFF)
#define SP_MS0ENATV_off_ena_region_out(data)                          (0x00FFFFFF&(data))
#define SP_MS0ENATV_get_off_ena_region_out(data)                      (0x00FFFFFF&(data))


#define SP_MS1CTRL                                                    0x18021200
#define SP_MS1CTRL_reg_addr                                           "0xb8021200"
#define SP_MS1CTRL_reg                                                0xb8021200
#define SP_MS1CTRL_inst_addr                                          "0x0080"
#define SP_MS1CTRL_inst                                               0x0080
#define SP_MS1CTRL_on1_4k2k_mode_shift                                (31)
#define SP_MS1CTRL_dummy18021200_19_18_shift                          (18)
#define SP_MS1CTRL_on1_meas_to_sel_shift                              (17)
#define SP_MS1CTRL_on1_sycms_clk_shift                                (16)
#define SP_MS1CTRL_on1_vs_meas_inv_shift                              (15)
#define SP_MS1CTRL_on1_vsms_inv_shift                                 (14)
#define SP_MS1CTRL_on1_sycms_mode_shift                               (13)
#define SP_MS1CTRL_on1_popup_meas_shift                               (12)
#define SP_MS1CTRL_on1_ms_src_sel_shift                               (11)
#define SP_MS1CTRL_on1_online_en_shift                                (10)
#define SP_MS1CTRL_on1_start_ms_shift                                 (9)
#define SP_MS1CTRL_on1_hs_max_delta_shift                             (4)
#define SP_MS1CTRL_on1_vs_max_delta_shift                             (0)
#define SP_MS1CTRL_on1_4k2k_mode_mask                                 (0x80000000)
#define SP_MS1CTRL_dummy18021200_19_18_mask                           (0x000C0000)
#define SP_MS1CTRL_on1_meas_to_sel_mask                               (0x00020000)
#define SP_MS1CTRL_on1_sycms_clk_mask                                 (0x00010000)
#define SP_MS1CTRL_on1_vs_meas_inv_mask                               (0x00008000)
#define SP_MS1CTRL_on1_vsms_inv_mask                                  (0x00004000)
#define SP_MS1CTRL_on1_sycms_mode_mask                                (0x00002000)
#define SP_MS1CTRL_on1_popup_meas_mask                                (0x00001000)
#define SP_MS1CTRL_on1_ms_src_sel_mask                                (0x00000800)
#define SP_MS1CTRL_on1_online_en_mask                                 (0x00000400)
#define SP_MS1CTRL_on1_start_ms_mask                                  (0x00000200)
#define SP_MS1CTRL_on1_hs_max_delta_mask                              (0x000001F0)
#define SP_MS1CTRL_on1_vs_max_delta_mask                              (0x0000000F)
#define SP_MS1CTRL_on1_4k2k_mode(data)                                (0x80000000&((data)<<31))
#define SP_MS1CTRL_dummy18021200_19_18(data)                          (0x000C0000&((data)<<18))
#define SP_MS1CTRL_on1_meas_to_sel(data)                              (0x00020000&((data)<<17))
#define SP_MS1CTRL_on1_sycms_clk(data)                                (0x00010000&((data)<<16))
#define SP_MS1CTRL_on1_vs_meas_inv(data)                              (0x00008000&((data)<<15))
#define SP_MS1CTRL_on1_vsms_inv(data)                                 (0x00004000&((data)<<14))
#define SP_MS1CTRL_on1_sycms_mode(data)                               (0x00002000&((data)<<13))
#define SP_MS1CTRL_on1_popup_meas(data)                               (0x00001000&((data)<<12))
#define SP_MS1CTRL_on1_ms_src_sel(data)                               (0x00000800&((data)<<11))
#define SP_MS1CTRL_on1_online_en(data)                                (0x00000400&((data)<<10))
#define SP_MS1CTRL_on1_start_ms(data)                                 (0x00000200&((data)<<9))
#define SP_MS1CTRL_on1_hs_max_delta(data)                             (0x000001F0&((data)<<4))
#define SP_MS1CTRL_on1_vs_max_delta(data)                             (0x0000000F&(data))
#define SP_MS1CTRL_get_on1_4k2k_mode(data)                            ((0x80000000&(data))>>31)
#define SP_MS1CTRL_get_dummy18021200_19_18(data)                      ((0x000C0000&(data))>>18)
#define SP_MS1CTRL_get_on1_meas_to_sel(data)                          ((0x00020000&(data))>>17)
#define SP_MS1CTRL_get_on1_sycms_clk(data)                            ((0x00010000&(data))>>16)
#define SP_MS1CTRL_get_on1_vs_meas_inv(data)                          ((0x00008000&(data))>>15)
#define SP_MS1CTRL_get_on1_vsms_inv(data)                             ((0x00004000&(data))>>14)
#define SP_MS1CTRL_get_on1_sycms_mode(data)                           ((0x00002000&(data))>>13)
#define SP_MS1CTRL_get_on1_popup_meas(data)                           ((0x00001000&(data))>>12)
#define SP_MS1CTRL_get_on1_ms_src_sel(data)                           ((0x00000800&(data))>>11)
#define SP_MS1CTRL_get_on1_online_en(data)                            ((0x00000400&(data))>>10)
#define SP_MS1CTRL_get_on1_start_ms(data)                             ((0x00000200&(data))>>9)
#define SP_MS1CTRL_get_on1_hs_max_delta(data)                         ((0x000001F0&(data))>>4)
#define SP_MS1CTRL_get_on1_vs_max_delta(data)                         (0x0000000F&(data))

// vs period out change from 20 to 18
#define SP_MS1RST0                                                    0x18021204
#define SP_MS1RST0_reg_addr                                           "0xb8021204"
#define SP_MS1RST0_reg                                                0xb8021204
#define SP_MS1RST0_inst_addr                                          "0x0081"
#define SP_MS1RST0_inst                                               0x0081
#define SP_MS1RST0_on1_vs_period_out_shift                            (18)
#define SP_MS1RST0_on1_hs_period_out_h12b_shift                       (4)
#define SP_MS1RST0_on1_hs_period_out_f4b_shift                        (0)
#define SP_MS1RST0_on1_vs_period_out_mask                             (0x7FFC0000)
#define SP_MS1RST0_on1_hs_period_out_h12b_mask                        (0x0003FFF0)
#define SP_MS1RST0_on1_hs_period_out_f4b_mask                         (0x0000000F)
#define SP_MS1RST0_on1_vs_period_out(data)                            (0x7FFC0000&((data)<<18))
#define SP_MS1RST0_on1_hs_period_out_h12b(data)                       (0x0003FFF0&((data)<<4))
#define SP_MS1RST0_on1_hs_period_out_f4b(data)                        (0x0000000F&(data))
#define SP_MS1RST0_get_on1_vs_period_out(data)                        ((0x7FFC0000&(data))>>18)
#define SP_MS1RST0_get_on1_hs_period_out_h12b(data)                   ((0x0003FFF0&(data))>>4)
#define SP_MS1RST0_get_on1_hs_period_out_f4b(data)                    (0x0000000F&(data))

// expend 1 bit
#define SP_MS1RST1                                                    0x18021208
#define SP_MS1RST1_reg_addr                                           "0xb8021208"
#define SP_MS1RST1_reg                                                0xb8021208
#define SP_MS1RST1_inst_addr                                          "0x0082"
#define SP_MS1RST1_inst                                               0x0082
#define SP_MS1RST1_dummy18021208_31_29_shift                          (29)
#define SP_MS1RST1_on1_vs_high_out_shift                              (16)
#define SP_MS1RST1_dummy18021208_15_14_shift                          (14)
#define SP_MS1RST1_on1_hs_high_out_shift                              (0)
#define SP_MS1RST1_dummy18021208_31_29_mask                           (0xE0000000)
#define SP_MS1RST1_on1_vs_high_out_mask                               (0x1FFF0000)
#define SP_MS1RST1_dummy18021208_15_14_mask                           (0x0000C000)
#define SP_MS1RST1_on1_hs_high_out_mask                               (0x00003FFF)
#define SP_MS1RST1_dummy18021208_31_29(data)                          (0xE0000000&((data)<<29))
#define SP_MS1RST1_on1_vs_high_out(data)                              (0x1FFF0000&((data)<<16))
#define SP_MS1RST1_dummy18021208_15_14(data)                          (0x0000C000&((data)<<14))
#define SP_MS1RST1_on1_hs_high_out(data)                              (0x00003FFF&(data))
#define SP_MS1RST1_get_dummy18021208_31_29(data)                      ((0xE0000000&(data))>>29)
#define SP_MS1RST1_get_on1_vs_high_out(data)                          ((0x1FFF0000&(data))>>16)
#define SP_MS1RST1_get_dummy18021208_15_14(data)                      ((0x0000C000&(data))>>14)
#define SP_MS1RST1_get_on1_hs_high_out(data)                          (0x00003FFF&(data))


#define SP_MS1STUS                                                    0x1802120c
#define SP_MS1STUS_reg_addr                                           "0xb802120c"
#define SP_MS1STUS_reg                                                0xb802120c
#define SP_MS1STUS_inst_addr                                          "0x0083"
#define SP_MS1STUS_inst                                               0x0083
#define SP_MS1STUS_on1_blk_2frame_en_shift                            (11)
#define SP_MS1STUS_on1_vs_per_to_long_shift                           (10)
#define SP_MS1STUS_on1_vs_pol_out_shift                               (9)
#define SP_MS1STUS_on1_hs_pol_out_shift                               (8)
#define SP_MS1STUS_on1_vs_per_to_shift                                (7)
#define SP_MS1STUS_on1_vs_high_to_shift                               (6)
#define SP_MS1STUS_on1_vs_per_of_shift                                (5)
#define SP_MS1STUS_on1_vs_over_range_shift                            (4)
#define SP_MS1STUS_on1_vs_pol_chg_shift                               (3)
#define SP_MS1STUS_on1_hs_per_of_shift                                (2)
#define SP_MS1STUS_on1_hs_over_range_shift                            (1)
#define SP_MS1STUS_on1_hs_pol_chg_shift                               (0)
#define SP_MS1STUS_on1_blk_2frame_en_mask                             (0x00000800)
#define SP_MS1STUS_on1_vs_per_to_long_mask                            (0x00000400)
#define SP_MS1STUS_on1_vs_pol_out_mask                                (0x00000200)
#define SP_MS1STUS_on1_hs_pol_out_mask                                (0x00000100)
#define SP_MS1STUS_on1_vs_per_to_mask                                 (0x00000080)
#define SP_MS1STUS_on1_vs_high_to_mask                                (0x00000040)
#define SP_MS1STUS_on1_vs_per_of_mask                                 (0x00000020)
#define SP_MS1STUS_on1_vs_over_range_mask                             (0x00000010)
#define SP_MS1STUS_on1_vs_pol_chg_mask                                (0x00000008)
#define SP_MS1STUS_on1_hs_per_of_mask                                 (0x00000004)
#define SP_MS1STUS_on1_hs_over_range_mask                             (0x00000002)
#define SP_MS1STUS_on1_hs_pol_chg_mask                                (0x00000001)
#define SP_MS1STUS_on1_blk_2frame_en(data)                            (0x00000800&((data)<<11))
#define SP_MS1STUS_on1_vs_per_to_long(data)                           (0x00000400&((data)<<10))
#define SP_MS1STUS_on1_vs_pol_out(data)                               (0x00000200&((data)<<9))
#define SP_MS1STUS_on1_hs_pol_out(data)                               (0x00000100&((data)<<8))
#define SP_MS1STUS_on1_vs_per_to(data)                                (0x00000080&((data)<<7))
#define SP_MS1STUS_on1_vs_high_to(data)                               (0x00000040&((data)<<6))
#define SP_MS1STUS_on1_vs_per_of(data)                                (0x00000020&((data)<<5))
#define SP_MS1STUS_on1_vs_over_range(data)                            (0x00000010&((data)<<4))
#define SP_MS1STUS_on1_vs_pol_chg(data)                               (0x00000008&((data)<<3))
#define SP_MS1STUS_on1_hs_per_of(data)                                (0x00000004&((data)<<2))
#define SP_MS1STUS_on1_hs_over_range(data)                            (0x00000002&((data)<<1))
#define SP_MS1STUS_on1_hs_pol_chg(data)                               (0x00000001&(data))
#define SP_MS1STUS_get_on1_blk_2frame_en(data)                        ((0x00000800&(data))>>11)
#define SP_MS1STUS_get_on1_vs_per_to_long(data)                       ((0x00000400&(data))>>10)
#define SP_MS1STUS_get_on1_vs_pol_out(data)                           ((0x00000200&(data))>>9)
#define SP_MS1STUS_get_on1_hs_pol_out(data)                           ((0x00000100&(data))>>8)
#define SP_MS1STUS_get_on1_vs_per_to(data)                            ((0x00000080&(data))>>7)
#define SP_MS1STUS_get_on1_vs_high_to(data)                           ((0x00000040&(data))>>6)
#define SP_MS1STUS_get_on1_vs_per_of(data)                            ((0x00000020&(data))>>5)
#define SP_MS1STUS_get_on1_vs_over_range(data)                        ((0x00000010&(data))>>4)
#define SP_MS1STUS_get_on1_vs_pol_chg(data)                           ((0x00000008&(data))>>3)
#define SP_MS1STUS_get_on1_hs_per_of(data)                            ((0x00000004&(data))>>2)
#define SP_MS1STUS_get_on1_hs_over_range(data)                        ((0x00000002&(data))>>1)
#define SP_MS1STUS_get_on1_hs_pol_chg(data)                           (0x00000001&(data))


#define SP_MS1IE                                                      0x18021210
#define SP_MS1IE_reg_addr                                             "0xb8021210"
#define SP_MS1IE_reg                                                  0xb8021210
#define SP_MS1IE_inst_addr                                            "0x0084"
#define SP_MS1IE_inst                                                 0x0084
#define SP_MS1IE_wd_on1_to_main_shift                                 (31)
#define SP_MS1IE_wd_on1_to_sub_shift                                  (30)
#define SP_MS1IE_dummy18021210_29_24_shift                            (24)
#define SP_MS1IE_wde_on1_vs_per_to_shift                              (23)
#define SP_MS1IE_wde_on1_vs_high_to_shift                             (22)
#define SP_MS1IE_wde_on1_vs_per_of_shift                              (21)
#define SP_MS1IE_wde_on1_vs_over_range_shift                          (20)
#define SP_MS1IE_wde_on1_vs_pol_chg_shift                             (19)
#define SP_MS1IE_wde_on1_hs_per_of_shift                              (18)
#define SP_MS1IE_wde_on1_hs_over_range_shift                          (17)
#define SP_MS1IE_wde_on1_hs_pol_chg_shift                             (16)
#define SP_MS1IE_dummy18021210_15_8_shift                             (8)
#define SP_MS1IE_on1_ie_vs_per_to_shift                               (7)
#define SP_MS1IE_on1_ie_vs_high_to_shift                              (6)
#define SP_MS1IE_on1_ie_vs_per_of_shift                               (5)
#define SP_MS1IE_on1_ie_vs_over_range_shift                           (4)
#define SP_MS1IE_on1_ie_vs_pol_chg_shift                              (3)
#define SP_MS1IE_on1_ie_hs_per_of_shift                               (2)
#define SP_MS1IE_on1_ie_hs_over_range_shift                           (1)
#define SP_MS1IE_on1_ie_hs_pol_chg_shift                              (0)
#define SP_MS1IE_wd_on1_to_main_mask                                  (0x80000000)
#define SP_MS1IE_wd_on1_to_sub_mask                                   (0x40000000)
#define SP_MS1IE_dummy18021210_29_24_mask                             (0x3F000000)
#define SP_MS1IE_wde_on1_vs_per_to_mask                               (0x00800000)
#define SP_MS1IE_wde_on1_vs_high_to_mask                              (0x00400000)
#define SP_MS1IE_wde_on1_vs_per_of_mask                               (0x00200000)
#define SP_MS1IE_wde_on1_vs_over_range_mask                           (0x00100000)
#define SP_MS1IE_wde_on1_vs_pol_chg_mask                              (0x00080000)
#define SP_MS1IE_wde_on1_hs_per_of_mask                               (0x00040000)
#define SP_MS1IE_wde_on1_hs_over_range_mask                           (0x00020000)
#define SP_MS1IE_wde_on1_hs_pol_chg_mask                              (0x00010000)
#define SP_MS1IE_dummy18021210_15_8_mask                              (0x0000FF00)
#define SP_MS1IE_on1_ie_vs_per_to_mask                                (0x00000080)
#define SP_MS1IE_on1_ie_vs_high_to_mask                               (0x00000040)
#define SP_MS1IE_on1_ie_vs_per_of_mask                                (0x00000020)
#define SP_MS1IE_on1_ie_vs_over_range_mask                            (0x00000010)
#define SP_MS1IE_on1_ie_vs_pol_chg_mask                               (0x00000008)
#define SP_MS1IE_on1_ie_hs_per_of_mask                                (0x00000004)
#define SP_MS1IE_on1_ie_hs_over_range_mask                            (0x00000002)
#define SP_MS1IE_on1_ie_hs_pol_chg_mask                               (0x00000001)
#define SP_MS1IE_wd_on1_to_main(data)                                 (0x80000000&((data)<<31))
#define SP_MS1IE_wd_on1_to_sub(data)                                  (0x40000000&((data)<<30))
#define SP_MS1IE_dummy18021210_29_24(data)                            (0x3F000000&((data)<<24))
#define SP_MS1IE_wde_on1_vs_per_to(data)                              (0x00800000&((data)<<23))
#define SP_MS1IE_wde_on1_vs_high_to(data)                             (0x00400000&((data)<<22))
#define SP_MS1IE_wde_on1_vs_per_of(data)                              (0x00200000&((data)<<21))
#define SP_MS1IE_wde_on1_vs_over_range(data)                          (0x00100000&((data)<<20))
#define SP_MS1IE_wde_on1_vs_pol_chg(data)                             (0x00080000&((data)<<19))
#define SP_MS1IE_wde_on1_hs_per_of(data)                              (0x00040000&((data)<<18))
#define SP_MS1IE_wde_on1_hs_over_range(data)                          (0x00020000&((data)<<17))
#define SP_MS1IE_wde_on1_hs_pol_chg(data)                             (0x00010000&((data)<<16))
#define SP_MS1IE_dummy18021210_15_8(data)                             (0x0000FF00&((data)<<8))
#define SP_MS1IE_on1_ie_vs_per_to(data)                               (0x00000080&((data)<<7))
#define SP_MS1IE_on1_ie_vs_high_to(data)                              (0x00000040&((data)<<6))
#define SP_MS1IE_on1_ie_vs_per_of(data)                               (0x00000020&((data)<<5))
#define SP_MS1IE_on1_ie_vs_over_range(data)                           (0x00000010&((data)<<4))
#define SP_MS1IE_on1_ie_vs_pol_chg(data)                              (0x00000008&((data)<<3))
#define SP_MS1IE_on1_ie_hs_per_of(data)                               (0x00000004&((data)<<2))
#define SP_MS1IE_on1_ie_hs_over_range(data)                           (0x00000002&((data)<<1))
#define SP_MS1IE_on1_ie_hs_pol_chg(data)                              (0x00000001&(data))
#define SP_MS1IE_get_wd_on1_to_main(data)                             ((0x80000000&(data))>>31)
#define SP_MS1IE_get_wd_on1_to_sub(data)                              ((0x40000000&(data))>>30)
#define SP_MS1IE_get_dummy18021210_29_24(data)                        ((0x3F000000&(data))>>24)
#define SP_MS1IE_get_wde_on1_vs_per_to(data)                          ((0x00800000&(data))>>23)
#define SP_MS1IE_get_wde_on1_vs_high_to(data)                         ((0x00400000&(data))>>22)
#define SP_MS1IE_get_wde_on1_vs_per_of(data)                          ((0x00200000&(data))>>21)
#define SP_MS1IE_get_wde_on1_vs_over_range(data)                      ((0x00100000&(data))>>20)
#define SP_MS1IE_get_wde_on1_vs_pol_chg(data)                         ((0x00080000&(data))>>19)
#define SP_MS1IE_get_wde_on1_hs_per_of(data)                          ((0x00040000&(data))>>18)
#define SP_MS1IE_get_wde_on1_hs_over_range(data)                      ((0x00020000&(data))>>17)
#define SP_MS1IE_get_wde_on1_hs_pol_chg(data)                         ((0x00010000&(data))>>16)
#define SP_MS1IE_get_dummy18021210_15_8(data)                         ((0x0000FF00&(data))>>8)
#define SP_MS1IE_get_on1_ie_vs_per_to(data)                           ((0x00000080&(data))>>7)
#define SP_MS1IE_get_on1_ie_vs_high_to(data)                          ((0x00000040&(data))>>6)
#define SP_MS1IE_get_on1_ie_vs_per_of(data)                           ((0x00000020&(data))>>5)
#define SP_MS1IE_get_on1_ie_vs_over_range(data)                       ((0x00000010&(data))>>4)
#define SP_MS1IE_get_on1_ie_vs_pol_chg(data)                          ((0x00000008&(data))>>3)
#define SP_MS1IE_get_on1_ie_hs_per_of(data)                           ((0x00000004&(data))>>2)
#define SP_MS1IE_get_on1_ie_hs_over_range(data)                       ((0x00000002&(data))>>1)
#define SP_MS1IE_get_on1_ie_hs_pol_chg(data)                          (0x00000001&(data))

// addr change from  1214 to 1220
#define SP_MS2CTRL                                                    0x18021220
#define SP_MS2CTRL_reg_addr                                           "0xb8021220"
#define SP_MS2CTRL_reg                                                0xb8021220
#define SP_MS2CTRL_inst_addr                                          "0x0088"
#define SP_MS2CTRL_inst                                               0x0088
#define SP_MS2CTRL_on2_4k2k_mode_shift                                (31)
#define SP_MS2CTRL_dummy18021220_19_18_shift                          (18)
#define SP_MS2CTRL_on2_meas_to_sel_shift                              (17)
#define SP_MS2CTRL_on2_sycms_clk_shift                                (16)
#define SP_MS2CTRL_on2_vs_meas_inv_shift                              (15)
#define SP_MS2CTRL_on2_vsms_inv_shift                                 (14)
#define SP_MS2CTRL_on2_sycms_mode_shift                               (13)
#define SP_MS2CTRL_on2_popup_meas_shift                               (12)
#define SP_MS2CTRL_on2_ms_src_sel_shift                               (11)
#define SP_MS2CTRL_on2_online_en_shift                                (10)
#define SP_MS2CTRL_on2_start_ms_shift                                 (9)
#define SP_MS2CTRL_on2_hs_max_delta_shift                             (4)
#define SP_MS2CTRL_on2_vs_max_delta_shift                             (0)
#define SP_MS2CTRL_on2_4k2k_mode_mask                                 (0x80000000)
#define SP_MS2CTRL_dummy18021220_19_18_mask                           (0x000C0000)
#define SP_MS2CTRL_on2_meas_to_sel_mask                               (0x00020000)
#define SP_MS2CTRL_on2_sycms_clk_mask                                 (0x00010000)
#define SP_MS2CTRL_on2_vs_meas_inv_mask                               (0x00008000)
#define SP_MS2CTRL_on2_vsms_inv_mask                                  (0x00004000)
#define SP_MS2CTRL_on2_sycms_mode_mask                                (0x00002000)
#define SP_MS2CTRL_on2_popup_meas_mask                                (0x00001000)
#define SP_MS2CTRL_on2_ms_src_sel_mask                                (0x00000800)
#define SP_MS2CTRL_on2_online_en_mask                                 (0x00000400)
#define SP_MS2CTRL_on2_start_ms_mask                                  (0x00000200)
#define SP_MS2CTRL_on2_hs_max_delta_mask                              (0x000001F0)
#define SP_MS2CTRL_on2_vs_max_delta_mask                              (0x0000000F)
#define SP_MS2CTRL_on2_4k2k_mode(data)                                (0x80000000&((data)<<31))
#define SP_MS2CTRL_dummy18021220_19_18(data)                          (0x000C0000&((data)<<18))
#define SP_MS2CTRL_on2_meas_to_sel(data)                              (0x00020000&((data)<<17))
#define SP_MS2CTRL_on2_sycms_clk(data)                                (0x00010000&((data)<<16))
#define SP_MS2CTRL_on2_vs_meas_inv(data)                              (0x00008000&((data)<<15))
#define SP_MS2CTRL_on2_vsms_inv(data)                                 (0x00004000&((data)<<14))
#define SP_MS2CTRL_on2_sycms_mode(data)                               (0x00002000&((data)<<13))
#define SP_MS2CTRL_on2_popup_meas(data)                               (0x00001000&((data)<<12))
#define SP_MS2CTRL_on2_ms_src_sel(data)                               (0x00000800&((data)<<11))
#define SP_MS2CTRL_on2_online_en(data)                                (0x00000400&((data)<<10))
#define SP_MS2CTRL_on2_start_ms(data)                                 (0x00000200&((data)<<9))
#define SP_MS2CTRL_on2_hs_max_delta(data)                             (0x000001F0&((data)<<4))
#define SP_MS2CTRL_on2_vs_max_delta(data)                             (0x0000000F&(data))
#define SP_MS2CTRL_get_on2_4k2k_mode(data)                            ((0x80000000&(data))>>31)
#define SP_MS2CTRL_get_dummy18021220_19_18(data)                      ((0x000C0000&(data))>>18)
#define SP_MS2CTRL_get_on2_meas_to_sel(data)                          ((0x00020000&(data))>>17)
#define SP_MS2CTRL_get_on2_sycms_clk(data)                            ((0x00010000&(data))>>16)
#define SP_MS2CTRL_get_on2_vs_meas_inv(data)                          ((0x00008000&(data))>>15)
#define SP_MS2CTRL_get_on2_vsms_inv(data)                             ((0x00004000&(data))>>14)
#define SP_MS2CTRL_get_on2_sycms_mode(data)                           ((0x00002000&(data))>>13)
#define SP_MS2CTRL_get_on2_popup_meas(data)                           ((0x00001000&(data))>>12)
#define SP_MS2CTRL_get_on2_ms_src_sel(data)                           ((0x00000800&(data))>>11)
#define SP_MS2CTRL_get_on2_online_en(data)                            ((0x00000400&(data))>>10)
#define SP_MS2CTRL_get_on2_start_ms(data)                             ((0x00000200&(data))>>9)
#define SP_MS2CTRL_get_on2_hs_max_delta(data)                         ((0x000001F0&(data))>>4)
#define SP_MS2CTRL_get_on2_vs_max_delta(data)                         (0x0000000F&(data))

// addr change from  1218 to 1224

#define SP_MS2RST0                                                    0x18021224
#define SP_MS2RST0_reg_addr                                           "0xb8021224"
#define SP_MS2RST0_reg                                                0xb8021224
#define SP_MS2RST0_inst_addr                                          "0x0089"
#define SP_MS2RST0_inst                                               0x0089
#define SP_MS2RST0_on2_vs_period_out_shift                            (18)
#define SP_MS2RST0_on2_hs_period_out_h12b_shift                       (4)
#define SP_MS2RST0_on2_hs_period_out_f4b_shift                        (0)
#define SP_MS2RST0_on2_vs_period_out_mask                             (0x7FFC0000)
#define SP_MS2RST0_on2_hs_period_out_h12b_mask                        (0x0003FFF0)
#define SP_MS2RST0_on2_hs_period_out_f4b_mask                         (0x0000000F)
#define SP_MS2RST0_on2_vs_period_out(data)                            (0x7FFC0000&((data)<<18))
#define SP_MS2RST0_on2_hs_period_out_h12b(data)                       (0x0003FFF0&((data)<<4))
#define SP_MS2RST0_on2_hs_period_out_f4b(data)                        (0x0000000F&(data))
#define SP_MS2RST0_get_on2_vs_period_out(data)                        ((0x7FFC0000&(data))>>18)
#define SP_MS2RST0_get_on2_hs_period_out_h12b(data)                   ((0x0003FFF0&(data))>>4)
#define SP_MS2RST0_get_on2_hs_period_out_f4b(data)                    (0x0000000F&(data))

// addr change from  121C to 1228

#define SP_MS2RST1                                                    0x18021228
#define SP_MS2RST1_reg_addr                                           "0xb8021228"
#define SP_MS2RST1_reg                                                0xb8021228
#define SP_MS2RST1_inst_addr                                          "0x008A"
#define SP_MS2RST1_inst                                               0x008A
#define SP_MS2RST1_dummy18021228_31_29_shift                          (29)
#define SP_MS2RST1_on2_vs_high_out_shift                              (16)
#define SP_MS2RST1_dummy18021228_15_14_shift                          (14)
#define SP_MS2RST1_on2_hs_high_out_shift                              (0)
#define SP_MS2RST1_dummy18021228_31_29_mask                           (0xE0000000)
#define SP_MS2RST1_on2_vs_high_out_mask                               (0x1FFF0000)
#define SP_MS2RST1_dummy18021228_15_14_mask                           (0x0000C000)
#define SP_MS2RST1_on2_hs_high_out_mask                               (0x00003FFF)
#define SP_MS2RST1_dummy18021228_31_29(data)                          (0xE0000000&((data)<<29))
#define SP_MS2RST1_on2_vs_high_out(data)                              (0x1FFF0000&((data)<<16))
#define SP_MS2RST1_dummy18021228_15_14(data)                          (0x0000C000&((data)<<14))
#define SP_MS2RST1_on2_hs_high_out(data)                              (0x00003FFF&(data))
#define SP_MS2RST1_get_dummy18021228_31_29(data)                      ((0xE0000000&(data))>>29)
#define SP_MS2RST1_get_on2_vs_high_out(data)                          ((0x1FFF0000&(data))>>16)
#define SP_MS2RST1_get_dummy18021228_15_14(data)                      ((0x0000C000&(data))>>14)
#define SP_MS2RST1_get_on2_hs_high_out(data)                          (0x00003FFF&(data))

// addr change from  1220 to 122C

#define SP_MS2STUS                                                    0x1802122c
#define SP_MS2STUS_reg_addr                                           "0xb802122c"
#define SP_MS2STUS_reg                                                0xb802122c
#define SP_MS2STUS_inst_addr                                          "0x008B"
#define SP_MS2STUS_inst                                               0x008B
#define SP_MS2STUS_on2_blk_2frame_en_shift                            (11)
#define SP_MS2STUS_on2_vs_per_to_long_shift                           (10)
#define SP_MS2STUS_on2_vs_pol_out_shift                               (9)
#define SP_MS2STUS_on2_hs_pol_out_shift                               (8)
#define SP_MS2STUS_on2_vs_per_to_shift                                (7)
#define SP_MS2STUS_on2_vs_high_to_shift                               (6)
#define SP_MS2STUS_on2_vs_per_of_shift                                (5)
#define SP_MS2STUS_on2_vs_over_range_shift                            (4)
#define SP_MS2STUS_on2_vs_pol_chg_shift                               (3)
#define SP_MS2STUS_on2_hs_per_of_shift                                (2)
#define SP_MS2STUS_on2_hs_over_range_shift                            (1)
#define SP_MS2STUS_on2_hs_pol_chg_shift                               (0)
#define SP_MS2STUS_on2_blk_2frame_en_mask                             (0x00000800)
#define SP_MS2STUS_on2_vs_per_to_long_mask                            (0x00000400)
#define SP_MS2STUS_on2_vs_pol_out_mask                                (0x00000200)
#define SP_MS2STUS_on2_hs_pol_out_mask                                (0x00000100)
#define SP_MS2STUS_on2_vs_per_to_mask                                 (0x00000080)
#define SP_MS2STUS_on2_vs_high_to_mask                                (0x00000040)
#define SP_MS2STUS_on2_vs_per_of_mask                                 (0x00000020)
#define SP_MS2STUS_on2_vs_over_range_mask                             (0x00000010)
#define SP_MS2STUS_on2_vs_pol_chg_mask                                (0x00000008)
#define SP_MS2STUS_on2_hs_per_of_mask                                 (0x00000004)
#define SP_MS2STUS_on2_hs_over_range_mask                             (0x00000002)
#define SP_MS2STUS_on2_hs_pol_chg_mask                                (0x00000001)
#define SP_MS2STUS_on2_blk_2frame_en(data)                            (0x00000800&((data)<<11))
#define SP_MS2STUS_on2_vs_per_to_long(data)                           (0x00000400&((data)<<10))
#define SP_MS2STUS_on2_vs_pol_out(data)                               (0x00000200&((data)<<9))
#define SP_MS2STUS_on2_hs_pol_out(data)                               (0x00000100&((data)<<8))
#define SP_MS2STUS_on2_vs_per_to(data)                                (0x00000080&((data)<<7))
#define SP_MS2STUS_on2_vs_high_to(data)                               (0x00000040&((data)<<6))
#define SP_MS2STUS_on2_vs_per_of(data)                                (0x00000020&((data)<<5))
#define SP_MS2STUS_on2_vs_over_range(data)                            (0x00000010&((data)<<4))
#define SP_MS2STUS_on2_vs_pol_chg(data)                               (0x00000008&((data)<<3))
#define SP_MS2STUS_on2_hs_per_of(data)                                (0x00000004&((data)<<2))
#define SP_MS2STUS_on2_hs_over_range(data)                            (0x00000002&((data)<<1))
#define SP_MS2STUS_on2_hs_pol_chg(data)                               (0x00000001&(data))
#define SP_MS2STUS_get_on2_blk_2frame_en(data)                        ((0x00000800&(data))>>11)
#define SP_MS2STUS_get_on2_vs_per_to_long(data)                       ((0x00000400&(data))>>10)
#define SP_MS2STUS_get_on2_vs_pol_out(data)                           ((0x00000200&(data))>>9)
#define SP_MS2STUS_get_on2_hs_pol_out(data)                           ((0x00000100&(data))>>8)
#define SP_MS2STUS_get_on2_vs_per_to(data)                            ((0x00000080&(data))>>7)
#define SP_MS2STUS_get_on2_vs_high_to(data)                           ((0x00000040&(data))>>6)
#define SP_MS2STUS_get_on2_vs_per_of(data)                            ((0x00000020&(data))>>5)
#define SP_MS2STUS_get_on2_vs_over_range(data)                        ((0x00000010&(data))>>4)
#define SP_MS2STUS_get_on2_vs_pol_chg(data)                           ((0x00000008&(data))>>3)
#define SP_MS2STUS_get_on2_hs_per_of(data)                            ((0x00000004&(data))>>2)
#define SP_MS2STUS_get_on2_hs_over_range(data)                        ((0x00000002&(data))>>1)
#define SP_MS2STUS_get_on2_hs_pol_chg(data)                           (0x00000001&(data))

// addr change from  1224 to 1230

#define SP_MS2IE                                                      0x18021230
#define SP_MS2IE_reg_addr                                             "0xb8021230"
#define SP_MS2IE_reg                                                  0xb8021230
#define SP_MS2IE_inst_addr                                            "0x008C"
#define SP_MS2IE_inst                                                 0x008C
#define SP_MS2IE_wd_on2_to_main_shift                                 (31)
#define SP_MS2IE_wd_on2_to_sub_shift                                  (30)
#define SP_MS2IE_dummy18021230_29_24_shift                            (24)
#define SP_MS2IE_wde_on2_vs_per_to_shift                              (23)
#define SP_MS2IE_wde_on2_vs_high_to_shift                             (22)
#define SP_MS2IE_wde_on2_vs_per_of_shift                              (21)
#define SP_MS2IE_wde_on2_vs_over_range_shift                          (20)
#define SP_MS2IE_wde_on2_vs_pol_chg_shift                             (19)
#define SP_MS2IE_wde_on2_hs_per_of_shift                              (18)
#define SP_MS2IE_wde_on2_hs_over_range_shift                          (17)
#define SP_MS2IE_wde_on2_hs_pol_chg_shift                             (16)
#define SP_MS2IE_dummy18021230_15_8_shift                             (8)
#define SP_MS2IE_on2_ie_vs_per_to_shift                               (7)
#define SP_MS2IE_on2_ie_vs_high_to_shift                              (6)
#define SP_MS2IE_on2_ie_vs_per_of_shift                               (5)
#define SP_MS2IE_on2_ie_vs_over_range_shift                           (4)
#define SP_MS2IE_on2_ie_vs_pol_chg_shift                              (3)
#define SP_MS2IE_on2_ie_hs_per_of_shift                               (2)
#define SP_MS2IE_on2_ie_hs_over_range_shift                           (1)
#define SP_MS2IE_on2_ie_hs_pol_chg_shift                              (0)
#define SP_MS2IE_wd_on2_to_main_mask                                  (0x80000000)
#define SP_MS2IE_wd_on2_to_sub_mask                                   (0x40000000)
#define SP_MS2IE_dummy18021230_29_24_mask                             (0x3F000000)
#define SP_MS2IE_wde_on2_vs_per_to_mask                               (0x00800000)
#define SP_MS2IE_wde_on2_vs_high_to_mask                              (0x00400000)
#define SP_MS2IE_wde_on2_vs_per_of_mask                               (0x00200000)
#define SP_MS2IE_wde_on2_vs_over_range_mask                           (0x00100000)
#define SP_MS2IE_wde_on2_vs_pol_chg_mask                              (0x00080000)
#define SP_MS2IE_wde_on2_hs_per_of_mask                               (0x00040000)
#define SP_MS2IE_wde_on2_hs_over_range_mask                           (0x00020000)
#define SP_MS2IE_wde_on2_hs_pol_chg_mask                              (0x00010000)
#define SP_MS2IE_dummy18021230_15_8_mask                              (0x0000FF00)
#define SP_MS2IE_on2_ie_vs_per_to_mask                                (0x00000080)
#define SP_MS2IE_on2_ie_vs_high_to_mask                               (0x00000040)
#define SP_MS2IE_on2_ie_vs_per_of_mask                                (0x00000020)
#define SP_MS2IE_on2_ie_vs_over_range_mask                            (0x00000010)
#define SP_MS2IE_on2_ie_vs_pol_chg_mask                               (0x00000008)
#define SP_MS2IE_on2_ie_hs_per_of_mask                                (0x00000004)
#define SP_MS2IE_on2_ie_hs_over_range_mask                            (0x00000002)
#define SP_MS2IE_on2_ie_hs_pol_chg_mask                               (0x00000001)
#define SP_MS2IE_wd_on2_to_main(data)                                 (0x80000000&((data)<<31))
#define SP_MS2IE_wd_on2_to_sub(data)                                  (0x40000000&((data)<<30))
#define SP_MS2IE_dummy18021230_29_24(data)                            (0x3F000000&((data)<<24))
#define SP_MS2IE_wde_on2_vs_per_to(data)                              (0x00800000&((data)<<23))
#define SP_MS2IE_wde_on2_vs_high_to(data)                             (0x00400000&((data)<<22))
#define SP_MS2IE_wde_on2_vs_per_of(data)                              (0x00200000&((data)<<21))
#define SP_MS2IE_wde_on2_vs_over_range(data)                          (0x00100000&((data)<<20))
#define SP_MS2IE_wde_on2_vs_pol_chg(data)                             (0x00080000&((data)<<19))
#define SP_MS2IE_wde_on2_hs_per_of(data)                              (0x00040000&((data)<<18))
#define SP_MS2IE_wde_on2_hs_over_range(data)                          (0x00020000&((data)<<17))
#define SP_MS2IE_wde_on2_hs_pol_chg(data)                             (0x00010000&((data)<<16))
#define SP_MS2IE_dummy18021230_15_8(data)                             (0x0000FF00&((data)<<8))
#define SP_MS2IE_on2_ie_vs_per_to(data)                               (0x00000080&((data)<<7))
#define SP_MS2IE_on2_ie_vs_high_to(data)                              (0x00000040&((data)<<6))
#define SP_MS2IE_on2_ie_vs_per_of(data)                               (0x00000020&((data)<<5))
#define SP_MS2IE_on2_ie_vs_over_range(data)                           (0x00000010&((data)<<4))
#define SP_MS2IE_on2_ie_vs_pol_chg(data)                              (0x00000008&((data)<<3))
#define SP_MS2IE_on2_ie_hs_per_of(data)                               (0x00000004&((data)<<2))
#define SP_MS2IE_on2_ie_hs_over_range(data)                           (0x00000002&((data)<<1))
#define SP_MS2IE_on2_ie_hs_pol_chg(data)                              (0x00000001&(data))
#define SP_MS2IE_get_wd_on2_to_main(data)                             ((0x80000000&(data))>>31)
#define SP_MS2IE_get_wd_on2_to_sub(data)                              ((0x40000000&(data))>>30)
#define SP_MS2IE_get_dummy18021230_29_24(data)                        ((0x3F000000&(data))>>24)
#define SP_MS2IE_get_wde_on2_vs_per_to(data)                          ((0x00800000&(data))>>23)
#define SP_MS2IE_get_wde_on2_vs_high_to(data)                         ((0x00400000&(data))>>22)
#define SP_MS2IE_get_wde_on2_vs_per_of(data)                          ((0x00200000&(data))>>21)
#define SP_MS2IE_get_wde_on2_vs_over_range(data)                      ((0x00100000&(data))>>20)
#define SP_MS2IE_get_wde_on2_vs_pol_chg(data)                         ((0x00080000&(data))>>19)
#define SP_MS2IE_get_wde_on2_hs_per_of(data)                          ((0x00040000&(data))>>18)
#define SP_MS2IE_get_wde_on2_hs_over_range(data)                      ((0x00020000&(data))>>17)
#define SP_MS2IE_get_wde_on2_hs_pol_chg(data)                         ((0x00010000&(data))>>16)
#define SP_MS2IE_get_dummy18021230_15_8(data)                         ((0x0000FF00&(data))>>8)
#define SP_MS2IE_get_on2_ie_vs_per_to(data)                           ((0x00000080&(data))>>7)
#define SP_MS2IE_get_on2_ie_vs_high_to(data)                          ((0x00000040&(data))>>6)
#define SP_MS2IE_get_on2_ie_vs_per_of(data)                           ((0x00000020&(data))>>5)
#define SP_MS2IE_get_on2_ie_vs_over_range(data)                       ((0x00000010&(data))>>4)
#define SP_MS2IE_get_on2_ie_vs_pol_chg(data)                          ((0x00000008&(data))>>3)
#define SP_MS2IE_get_on2_ie_hs_per_of(data)                           ((0x00000004&(data))>>2)
#define SP_MS2IE_get_on2_ie_hs_over_range(data)                       ((0x00000002&(data))>>1)
#define SP_MS2IE_get_on2_ie_hs_pol_chg(data)                          (0x00000001&(data))


//#define SP_MS3IE_SUB                                                      0x18021230
//#define SP_MS3IE_SUB_reg_addr                                             "0xb8021230"
//#define SP_MS3IE_SUB_reg                                                  0xb8021230
// END OF syncprocessor
#if 0
/*

	SMART FIT

*/
#define SMARTFIT_AUTO_FIELD                                                    0x18022000
#define SMARTFIT_AUTO_FIELD_reg_addr                                           "0xb8022000"
#define SMARTFIT_AUTO_FIELD_reg                                                0xb8022000
#define SMARTFIT_AUTO_FIELD_inst_addr                                          "0x0000"
#define SMARTFIT_AUTO_FIELD_inst                                               0x0000
#define SMARTFIT_AUTO_FIELD_adj_source_shift                                   (12)
#define SMARTFIT_AUTO_FIELD_dummy18022000_11_10_shift                          (10)
#define SMARTFIT_AUTO_FIELD_rl_sel_en_shift                                    (9)
#define SMARTFIT_AUTO_FIELD_rl_sel_shift                                       (8)
#define SMARTFIT_AUTO_FIELD_odd_sel_en_shift                                   (7)
#define SMARTFIT_AUTO_FIELD_odd_sel_shift                                      (6)
#define SMARTFIT_AUTO_FIELD_dummy18022000_5_shift                              (5)
#define SMARTFIT_AUTO_FIELD_rgb_in_one_en_shift                                (4)
#define SMARTFIT_AUTO_FIELD_square_en_shift                                    (3)
#define SMARTFIT_AUTO_FIELD_sum_pixel_num_shift                                (2)
#define SMARTFIT_AUTO_FIELD_filter_sel_shift                                   (0)
#define SMARTFIT_AUTO_FIELD_adj_source_mask                                    (0x00003000)
#define SMARTFIT_AUTO_FIELD_dummy18022000_11_10_mask                           (0x00000C00)
#define SMARTFIT_AUTO_FIELD_rl_sel_en_mask                                     (0x00000200)
#define SMARTFIT_AUTO_FIELD_rl_sel_mask                                        (0x00000100)
#define SMARTFIT_AUTO_FIELD_odd_sel_en_mask                                    (0x00000080)
#define SMARTFIT_AUTO_FIELD_odd_sel_mask                                       (0x00000040)
#define SMARTFIT_AUTO_FIELD_dummy18022000_5_mask                               (0x00000020)
#define SMARTFIT_AUTO_FIELD_rgb_in_one_en_mask                                 (0x00000010)
#define SMARTFIT_AUTO_FIELD_square_en_mask                                     (0x00000008)
#define SMARTFIT_AUTO_FIELD_sum_pixel_num_mask                                 (0x00000004)
#define SMARTFIT_AUTO_FIELD_filter_sel_mask                                    (0x00000003)
#define SMARTFIT_AUTO_FIELD_adj_source(data)                                   (0x00003000&((data)<<12))
#define SMARTFIT_AUTO_FIELD_dummy18022000_11_10(data)                          (0x00000C00&((data)<<10))
#define SMARTFIT_AUTO_FIELD_rl_sel_en(data)                                    (0x00000200&((data)<<9))
#define SMARTFIT_AUTO_FIELD_rl_sel(data)                                       (0x00000100&((data)<<8))
#define SMARTFIT_AUTO_FIELD_odd_sel_en(data)                                   (0x00000080&((data)<<7))
#define SMARTFIT_AUTO_FIELD_odd_sel(data)                                      (0x00000040&((data)<<6))
#define SMARTFIT_AUTO_FIELD_dummy18022000_5(data)                              (0x00000020&((data)<<5))
#define SMARTFIT_AUTO_FIELD_rgb_in_one_en(data)                                (0x00000010&((data)<<4))
#define SMARTFIT_AUTO_FIELD_square_en(data)                                    (0x00000008&((data)<<3))
#define SMARTFIT_AUTO_FIELD_sum_pixel_num(data)                                (0x00000004&((data)<<2))
#define SMARTFIT_AUTO_FIELD_filter_sel(data)                                   (0x00000003&(data))
#define SMARTFIT_AUTO_FIELD_get_adj_source(data)                               ((0x00003000&(data))>>12)
#define SMARTFIT_AUTO_FIELD_get_dummy18022000_11_10(data)                      ((0x00000C00&(data))>>10)
#define SMARTFIT_AUTO_FIELD_get_rl_sel_en(data)                                ((0x00000200&(data))>>9)
#define SMARTFIT_AUTO_FIELD_get_rl_sel(data)                                   ((0x00000100&(data))>>8)
#define SMARTFIT_AUTO_FIELD_get_odd_sel_en(data)                               ((0x00000080&(data))>>7)
#define SMARTFIT_AUTO_FIELD_get_odd_sel(data)                                  ((0x00000040&(data))>>6)
#define SMARTFIT_AUTO_FIELD_get_dummy18022000_5(data)                          ((0x00000020&(data))>>5)
#define SMARTFIT_AUTO_FIELD_get_rgb_in_one_en(data)                            ((0x00000010&(data))>>4)
#define SMARTFIT_AUTO_FIELD_get_square_en(data)                                ((0x00000008&(data))>>3)
#define SMARTFIT_AUTO_FIELD_get_sum_pixel_num(data)                            ((0x00000004&(data))>>2)
#define SMARTFIT_AUTO_FIELD_get_filter_sel(data)                               (0x00000003&(data))

// expand 1 bit
#define SMARTFIT_AUTO_H_BOUNDARY                                               0x18022004
#define SMARTFIT_AUTO_H_BOUNDARY_reg_addr                                      "0xb8022004"
#define SMARTFIT_AUTO_H_BOUNDARY_reg                                           0xb8022004
#define SMARTFIT_AUTO_H_BOUNDARY_inst_addr                                     "0x0001"
#define SMARTFIT_AUTO_H_BOUNDARY_inst                                          0x0001
#define SMARTFIT_AUTO_H_BOUNDARY_hb_sta_shift                                  (16)
#define SMARTFIT_AUTO_H_BOUNDARY_hb_end_shift                                  (0)
#define SMARTFIT_AUTO_H_BOUNDARY_hb_sta_mask                                   (0x3FFF0000)
#define SMARTFIT_AUTO_H_BOUNDARY_hb_end_mask                                   (0x00003FFF)
#define SMARTFIT_AUTO_H_BOUNDARY_hb_sta(data)                                  (0x3FFF0000&((data)<<16))
#define SMARTFIT_AUTO_H_BOUNDARY_hb_end(data)                                  (0x00003FFF&(data))
#define SMARTFIT_AUTO_H_BOUNDARY_get_hb_sta(data)                              ((0x3FFF0000&(data))>>16)
#define SMARTFIT_AUTO_H_BOUNDARY_get_hb_end(data)                              (0x00003FFF&(data))

// expand 1 bit

#define SMARTFIT_AUTO_V_BOUNDARY                                               0x18022008
#define SMARTFIT_AUTO_V_BOUNDARY_reg_addr                                      "0xb8022008"
#define SMARTFIT_AUTO_V_BOUNDARY_reg                                           0xb8022008
#define SMARTFIT_AUTO_V_BOUNDARY_inst_addr                                     "0x0002"
#define SMARTFIT_AUTO_V_BOUNDARY_inst                                          0x0002
#define SMARTFIT_AUTO_V_BOUNDARY_vb_sta_shift                                  (16)
#define SMARTFIT_AUTO_V_BOUNDARY_vb_end_shift                                  (0)
#define SMARTFIT_AUTO_V_BOUNDARY_vb_sta_mask                                   (0x1FFF0000)
#define SMARTFIT_AUTO_V_BOUNDARY_vb_end_mask                                   (0x00001FFF)
#define SMARTFIT_AUTO_V_BOUNDARY_vb_sta(data)                                  (0x1FFF0000&((data)<<16))
#define SMARTFIT_AUTO_V_BOUNDARY_vb_end(data)                                  (0x00001FFF&(data))
#define SMARTFIT_AUTO_V_BOUNDARY_get_vb_sta(data)                              ((0x1FFF0000&(data))>>16)
#define SMARTFIT_AUTO_V_BOUNDARY_get_vb_end(data)                              (0x00001FFF&(data))


#define SMARTFIT_AUTO_R_G_B_MARGIN                                             0x1802200c
#define SMARTFIT_AUTO_R_G_B_MARGIN_reg_addr                                    "0xb802200c"
#define SMARTFIT_AUTO_R_G_B_MARGIN_reg                                         0xb802200c
#define SMARTFIT_AUTO_R_G_B_MARGIN_inst_addr                                   "0x0003"
#define SMARTFIT_AUTO_R_G_B_MARGIN_inst                                        0x0003
#define SMARTFIT_AUTO_R_G_B_MARGIN_red_nm_shift                                (26)
#define SMARTFIT_AUTO_R_G_B_MARGIN_adj_even_odd_shift                          (25)
#define SMARTFIT_AUTO_R_G_B_MARGIN_adj_even_odd_en_shift                       (24)
#define SMARTFIT_AUTO_R_G_B_MARGIN_grn_nm_shift                                (18)
#define SMARTFIT_AUTO_R_G_B_MARGIN_vb_th_shift                                 (16)
#define SMARTFIT_AUTO_R_G_B_MARGIN_blu_nm_shift                                (10)
#define SMARTFIT_AUTO_R_G_B_MARGIN_color_sel_shift                             (8)
#define SMARTFIT_AUTO_R_G_B_MARGIN_diff_th_shift                               (0)
#define SMARTFIT_AUTO_R_G_B_MARGIN_red_nm_mask                                 (0xFC000000)
#define SMARTFIT_AUTO_R_G_B_MARGIN_adj_even_odd_mask                           (0x02000000)
#define SMARTFIT_AUTO_R_G_B_MARGIN_adj_even_odd_en_mask                        (0x01000000)
#define SMARTFIT_AUTO_R_G_B_MARGIN_grn_nm_mask                                 (0x00FC0000)
#define SMARTFIT_AUTO_R_G_B_MARGIN_vb_th_mask                                  (0x00030000)
#define SMARTFIT_AUTO_R_G_B_MARGIN_blu_nm_mask                                 (0x0000FC00)
#define SMARTFIT_AUTO_R_G_B_MARGIN_color_sel_mask                              (0x00000300)
#define SMARTFIT_AUTO_R_G_B_MARGIN_diff_th_mask                                (0x000000FF)
#define SMARTFIT_AUTO_R_G_B_MARGIN_red_nm(data)                                (0xFC000000&((data)<<26))
#define SMARTFIT_AUTO_R_G_B_MARGIN_adj_even_odd(data)                          (0x02000000&((data)<<25))
#define SMARTFIT_AUTO_R_G_B_MARGIN_adj_even_odd_en(data)                       (0x01000000&((data)<<24))
#define SMARTFIT_AUTO_R_G_B_MARGIN_grn_nm(data)                                (0x00FC0000&((data)<<18))
#define SMARTFIT_AUTO_R_G_B_MARGIN_vb_th(data)                                 (0x00030000&((data)<<16))
#define SMARTFIT_AUTO_R_G_B_MARGIN_blu_nm(data)                                (0x0000FC00&((data)<<10))
#define SMARTFIT_AUTO_R_G_B_MARGIN_color_sel(data)                             (0x00000300&((data)<<8))
#define SMARTFIT_AUTO_R_G_B_MARGIN_diff_th(data)                               (0x000000FF&(data))
#define SMARTFIT_AUTO_R_G_B_MARGIN_get_red_nm(data)                            ((0xFC000000&(data))>>26)
#define SMARTFIT_AUTO_R_G_B_MARGIN_get_adj_even_odd(data)                      ((0x02000000&(data))>>25)
#define SMARTFIT_AUTO_R_G_B_MARGIN_get_adj_even_odd_en(data)                   ((0x01000000&(data))>>24)
#define SMARTFIT_AUTO_R_G_B_MARGIN_get_grn_nm(data)                            ((0x00FC0000&(data))>>18)
#define SMARTFIT_AUTO_R_G_B_MARGIN_get_vb_th(data)                             ((0x00030000&(data))>>16)
#define SMARTFIT_AUTO_R_G_B_MARGIN_get_blu_nm(data)                            ((0x0000FC00&(data))>>10)
#define SMARTFIT_AUTO_R_G_B_MARGIN_get_color_sel(data)                         ((0x00000300&(data))>>8)
#define SMARTFIT_AUTO_R_G_B_MARGIN_get_diff_th(data)                           (0x000000FF&(data))


#define SMARTFIT_AUTO_ADJ                                                      0x18022010
#define SMARTFIT_AUTO_ADJ_reg_addr                                             "0xb8022010"
#define SMARTFIT_AUTO_ADJ_reg                                                  0xb8022010
#define SMARTFIT_AUTO_ADJ_inst_addr                                            "0x0004"
#define SMARTFIT_AUTO_ADJ_inst                                                 0x0004
#define SMARTFIT_AUTO_ADJ_m_vgen_en_shift                                      (7)
#define SMARTFIT_AUTO_ADJ_diff_pixel_sel_shift                                 (6)
#define SMARTFIT_AUTO_ADJ_force_flip__shift                                    (5)
#define SMARTFIT_AUTO_ADJ_sum_max_shift                                        (4)
#define SMARTFIT_AUTO_ADJ_pulse_det_en_shift                                   (3)
#define SMARTFIT_AUTO_ADJ_autophase_sel_tri_shift                              (2)
#define SMARTFIT_AUTO_ADJ_diff_en_shift                                        (1)
#define SMARTFIT_AUTO_ADJ_now_af_shift                                         (0)
#define SMARTFIT_AUTO_ADJ_m_vgen_en_mask                                       (0x00000080)
#define SMARTFIT_AUTO_ADJ_diff_pixel_sel_mask                                  (0x00000040)
#define SMARTFIT_AUTO_ADJ_force_flip__mask                                     (0x00000020)
#define SMARTFIT_AUTO_ADJ_sum_max_mask                                         (0x00000010)
#define SMARTFIT_AUTO_ADJ_pulse_det_en_mask                                    (0x00000008)
#define SMARTFIT_AUTO_ADJ_autophase_sel_tri_mask                               (0x00000004)
#define SMARTFIT_AUTO_ADJ_diff_en_mask                                         (0x00000002)
#define SMARTFIT_AUTO_ADJ_now_af_mask                                          (0x00000001)
#define SMARTFIT_AUTO_ADJ_m_vgen_en(data)                                      (0x00000080&((data)<<7))
#define SMARTFIT_AUTO_ADJ_diff_pixel_sel(data)                                 (0x00000040&((data)<<6))
#define SMARTFIT_AUTO_ADJ_force_flip_(data)                                    (0x00000020&((data)<<5))
#define SMARTFIT_AUTO_ADJ_sum_max(data)                                        (0x00000010&((data)<<4))
#define SMARTFIT_AUTO_ADJ_pulse_det_en(data)                                   (0x00000008&((data)<<3))
#define SMARTFIT_AUTO_ADJ_autophase_sel_tri(data)                              (0x00000004&((data)<<2))
#define SMARTFIT_AUTO_ADJ_diff_en(data)                                        (0x00000002&((data)<<1))
#define SMARTFIT_AUTO_ADJ_now_af(data)                                         (0x00000001&(data))
#define SMARTFIT_AUTO_ADJ_get_m_vgen_en(data)                                  ((0x00000080&(data))>>7)
#define SMARTFIT_AUTO_ADJ_get_diff_pixel_sel(data)                             ((0x00000040&(data))>>6)
#define SMARTFIT_AUTO_ADJ_get_force_flip_(data)                                ((0x00000020&(data))>>5)
#define SMARTFIT_AUTO_ADJ_get_sum_max(data)                                    ((0x00000010&(data))>>4)
#define SMARTFIT_AUTO_ADJ_get_pulse_det_en(data)                               ((0x00000008&(data))>>3)
#define SMARTFIT_AUTO_ADJ_get_autophase_sel_tri(data)                          ((0x00000004&(data))>>2)
#define SMARTFIT_AUTO_ADJ_get_diff_en(data)                                    ((0x00000002&(data))>>1)
#define SMARTFIT_AUTO_ADJ_get_now_af(data)                                     (0x00000001&(data))

// expand 1 bit

#define SMARTFIT_AUTO_RESULT_VSTA_END                                          0x18022014
#define SMARTFIT_AUTO_RESULT_VSTA_END_reg_addr                                 "0xb8022014"
#define SMARTFIT_AUTO_RESULT_VSTA_END_reg                                      0xb8022014
#define SMARTFIT_AUTO_RESULT_VSTA_END_inst_addr                                "0x0005"
#define SMARTFIT_AUTO_RESULT_VSTA_END_inst                                     0x0005
#define SMARTFIT_AUTO_RESULT_VSTA_END_vx_sta_shift                             (16)
#define SMARTFIT_AUTO_RESULT_VSTA_END_vx_end_shift                             (0)
#define SMARTFIT_AUTO_RESULT_VSTA_END_vx_sta_mask                              (0x1FFF0000)
#define SMARTFIT_AUTO_RESULT_VSTA_END_vx_end_mask                              (0x00001FFF)
#define SMARTFIT_AUTO_RESULT_VSTA_END_vx_sta(data)                             (0x1FFF0000&((data)<<16))
#define SMARTFIT_AUTO_RESULT_VSTA_END_vx_end(data)                             (0x00001FFF&(data))
#define SMARTFIT_AUTO_RESULT_VSTA_END_get_vx_sta(data)                         ((0x1FFF0000&(data))>>16)
#define SMARTFIT_AUTO_RESULT_VSTA_END_get_vx_end(data)                         (0x00001FFF&(data))


#define SMARTFIT_AUTO_RESULT_HSTA_END                                          0x18022018
#define SMARTFIT_AUTO_RESULT_HSTA_END_reg_addr                                 "0xb8022018"
#define SMARTFIT_AUTO_RESULT_HSTA_END_reg                                      0xb8022018
#define SMARTFIT_AUTO_RESULT_HSTA_END_inst_addr                                "0x0006"
#define SMARTFIT_AUTO_RESULT_HSTA_END_inst                                     0x0006
#define SMARTFIT_AUTO_RESULT_HSTA_END_hx_sta_shift                             (16)
#define SMARTFIT_AUTO_RESULT_HSTA_END_hx_end_shift                             (0)
#define SMARTFIT_AUTO_RESULT_HSTA_END_hx_sta_mask                              (0x3FFF0000)
#define SMARTFIT_AUTO_RESULT_HSTA_END_hx_end_mask                              (0x00003FFF)
#define SMARTFIT_AUTO_RESULT_HSTA_END_hx_sta(data)                             (0x3FFF0000&((data)<<16))
#define SMARTFIT_AUTO_RESULT_HSTA_END_hx_end(data)                             (0x00003FFF&(data))
#define SMARTFIT_AUTO_RESULT_HSTA_END_get_hx_sta(data)                         ((0x3FFF0000&(data))>>16)
#define SMARTFIT_AUTO_RESULT_HSTA_END_get_hx_end(data)                         (0x00003FFF&(data))


#define SMARTFIT_AUTO_RESULT_PHASE_M                                           0x1802201c
#define SMARTFIT_AUTO_RESULT_PHASE_M_reg_addr                                  "0xb802201c"
#define SMARTFIT_AUTO_RESULT_PHASE_M_reg                                       0xb802201c
#define SMARTFIT_AUTO_RESULT_PHASE_M_inst_addr                                 "0x0007"
#define SMARTFIT_AUTO_RESULT_PHASE_M_inst                                      0x0007
#define SMARTFIT_AUTO_RESULT_PHASE_M_acc_shift                                 (0)
#define SMARTFIT_AUTO_RESULT_PHASE_M_acc_mask                                  (0x0000000F)
#define SMARTFIT_AUTO_RESULT_PHASE_M_acc(data)                                 (0x0000000F&(data))
#define SMARTFIT_AUTO_RESULT_PHASE_M_get_acc(data)                             (0x0000000F&(data))


#define SMARTFIT_AUTO_RESULT_PHASE_L                                           0x18022020
#define SMARTFIT_AUTO_RESULT_PHASE_L_reg_addr                                  "0xb8022020"
#define SMARTFIT_AUTO_RESULT_PHASE_L_reg                                       0xb8022020
#define SMARTFIT_AUTO_RESULT_PHASE_L_inst_addr                                 "0x0008"
#define SMARTFIT_AUTO_RESULT_PHASE_L_inst                                      0x0008
#define SMARTFIT_AUTO_RESULT_PHASE_L_acc_shift                                 (0)
#define SMARTFIT_AUTO_RESULT_PHASE_L_acc_mask                                  (0xFFFFFFFF)
#define SMARTFIT_AUTO_RESULT_PHASE_L_acc(data)                                 (0xFFFFFFFF&(data))
#define SMARTFIT_AUTO_RESULT_PHASE_L_get_acc(data)                             (0xFFFFFFFF&(data))


#define SMARTFIT_AUTO_PHASE_CTRL0                                              0x18022024
#define SMARTFIT_AUTO_PHASE_CTRL0_reg_addr                                     "0xb8022024"
#define SMARTFIT_AUTO_PHASE_CTRL0_reg                                          0xb8022024
#define SMARTFIT_AUTO_PHASE_CTRL0_inst_addr                                    "0x0009"
#define SMARTFIT_AUTO_PHASE_CTRL0_inst                                         0x0009
#define SMARTFIT_AUTO_PHASE_CTRL0_autophase_en_shift                           (31)
#define SMARTFIT_AUTO_PHASE_CTRL0_autophase_step_2_shift                       (30)
#define SMARTFIT_AUTO_PHASE_CTRL0_autophase_step_shift                         (22)
#define SMARTFIT_AUTO_PHASE_CTRL0_init_phase_shift                             (16)
#define SMARTFIT_AUTO_PHASE_CTRL0_autophase_max_step_shift                     (8)
#define SMARTFIT_AUTO_PHASE_CTRL0_autophase_flg_shift                          (7)
#define SMARTFIT_AUTO_PHASE_CTRL0_autosod_step_num_shift                       (0)
#define SMARTFIT_AUTO_PHASE_CTRL0_autophase_en_mask                            (0x80000000)
#define SMARTFIT_AUTO_PHASE_CTRL0_autophase_step_2_mask                        (0x40000000)
#define SMARTFIT_AUTO_PHASE_CTRL0_autophase_step_mask                          (0x00C00000)
#define SMARTFIT_AUTO_PHASE_CTRL0_init_phase_mask                              (0x003F0000)
#define SMARTFIT_AUTO_PHASE_CTRL0_autophase_max_step_mask                      (0x00007F00)
#define SMARTFIT_AUTO_PHASE_CTRL0_autophase_flg_mask                           (0x00000080)
#define SMARTFIT_AUTO_PHASE_CTRL0_autosod_step_num_mask                        (0x0000007F)
#define SMARTFIT_AUTO_PHASE_CTRL0_autophase_en(data)                           (0x80000000&((data)<<31))
#define SMARTFIT_AUTO_PHASE_CTRL0_autophase_step_2(data)                       (0x40000000&((data)<<30))
#define SMARTFIT_AUTO_PHASE_CTRL0_autophase_step(data)                         (0x00C00000&((data)<<22))
#define SMARTFIT_AUTO_PHASE_CTRL0_init_phase(data)                             (0x003F0000&((data)<<16))
#define SMARTFIT_AUTO_PHASE_CTRL0_autophase_max_step(data)                     (0x00007F00&((data)<<8))
#define SMARTFIT_AUTO_PHASE_CTRL0_autophase_flg(data)                          (0x00000080&((data)<<7))
#define SMARTFIT_AUTO_PHASE_CTRL0_autosod_step_num(data)                       (0x0000007F&(data))
#define SMARTFIT_AUTO_PHASE_CTRL0_get_autophase_en(data)                       ((0x80000000&(data))>>31)
#define SMARTFIT_AUTO_PHASE_CTRL0_get_autophase_step_2(data)                   ((0x40000000&(data))>>30)
#define SMARTFIT_AUTO_PHASE_CTRL0_get_autophase_step(data)                     ((0x00C00000&(data))>>22)
#define SMARTFIT_AUTO_PHASE_CTRL0_get_init_phase(data)                         ((0x003F0000&(data))>>16)
#define SMARTFIT_AUTO_PHASE_CTRL0_get_autophase_max_step(data)                 ((0x00007F00&(data))>>8)
#define SMARTFIT_AUTO_PHASE_CTRL0_get_autophase_flg(data)                      ((0x00000080&(data))>>7)
#define SMARTFIT_AUTO_PHASE_CTRL0_get_autosod_step_num(data)                   (0x0000007F&(data))
// End of smart fit spec
#endif


//CRT Register

#define ST_SRST1_reg            0xb8060034
#define RSTN_HDMI_DET (_BIT8)
#define RSTN_CBUS_TX  (_BIT5)
#define RSTN_CBUS        (_BIT4)

#define ST_CLKEN1_reg         0xb8060044
#define CLKEN_CBUS_TX_IP   (_BIT17)
#define CLKEN_HDMI_DET   (_BIT8)
#define CLKEN_CBUS_TX        (_BIT5)
#define CLKEN_CBUS      (_BIT4)
#if 0
#define SOFT_RESET3_reg             0xb8000008
#define RSTN_TVSB2      (_BIT12)
#define RSTN_IFADC       (_BIT5)
#define RSTN_APLL_ADC        (_BIT4)
#define RSTN_DISPIM     (_BIT2)
#define RSTN_DISP (_BIT1)

#define CLOCK_ENABLE1_reg                0xb800000c
#define CLKEN_DCU       (_BIT18)
#endif
#define GROUP1_CK_EN_reg         0xb8000014
#define CLKEN_TVSB2            (_BIT30)
#define CLKEN_APLL_ADC              (_BIT24)
#define CLKEN_IFADC             (_BIT16)
#define CLKEN_DISPIM           (_BIT4)
#define CLKEN_DISP               (_BIT3)

//APLL_ADC Register
#define PLL_CTRL_reg            0xb8020104
#define APLLLDOPOW    (_BIT18)

#endif

