/**
* @file Merlin6-DesignSpec-D-Domain_SRNN
* RBus systemc program.
*
* @author RS_MM2_SD
* @email mm_mm2_rd_sw_kernel@realtek.com
* @ingroup model_rbus
 * @version { 1.0 }
 **
 */

#ifndef _RBUS_SRNN_REG_H_
#define _RBUS_SRNN_REG_H_

#include "rbus_types.h"



//  SRNN Register Address
#define  SRNN_SRNN_CTRL                                                         0x181AA000
#define  SRNN_SRNN_CTRL_reg_addr                                                 "0xB81AA000"
#define  SRNN_SRNN_CTRL_reg                                                      0xB81AA000
#define  SRNN_SRNN_CTRL_inst_addr                                                "0x0000"
#define  set_SRNN_SRNN_CTRL_reg(data)                                            (*((volatile unsigned int*)SRNN_SRNN_CTRL_reg)=data)
#define  get_SRNN_SRNN_CTRL_reg                                                  (*((volatile unsigned int*)SRNN_SRNN_CTRL_reg))
#define  SRNN_SRNN_CTRL_srnn_func_en_shift                                       (31)
#define  SRNN_SRNN_CTRL_bbbsr_en_shift                                           (28)
#define  SRNN_SRNN_CTRL_bbbsr_blend_diff_clip1_en_shift                          (27)
#define  SRNN_SRNN_CTRL_bbbsr_blend_diff_clip2_en_shift                          (26)
#define  SRNN_SRNN_CTRL_bbbsr_blend_diff_clip3_en_shift                          (25)
#define  SRNN_SRNN_CTRL_bbbsr_matrix33_select1_en_shift                          (24)
#define  SRNN_SRNN_CTRL_bbbsr_matrix33_select2_en_shift                          (23)
#define  SRNN_SRNN_CTRL_bbbsr_diff_max_flat_en_shift                             (22)
#define  SRNN_SRNN_CTRL_bbbsr_const_dirsu_wt_shift                               (16)
#define  SRNN_SRNN_CTRL_bbbsr_var_diff_clip_hith_shift                           (8)
#define  SRNN_SRNN_CTRL_bbbsr_var_diff_clip_loth_shift                           (0)
#define  SRNN_SRNN_CTRL_srnn_func_en_mask                                        (0x80000000)
#define  SRNN_SRNN_CTRL_bbbsr_en_mask                                            (0x30000000)
#define  SRNN_SRNN_CTRL_bbbsr_blend_diff_clip1_en_mask                           (0x08000000)
#define  SRNN_SRNN_CTRL_bbbsr_blend_diff_clip2_en_mask                           (0x04000000)
#define  SRNN_SRNN_CTRL_bbbsr_blend_diff_clip3_en_mask                           (0x02000000)
#define  SRNN_SRNN_CTRL_bbbsr_matrix33_select1_en_mask                           (0x01000000)
#define  SRNN_SRNN_CTRL_bbbsr_matrix33_select2_en_mask                           (0x00800000)
#define  SRNN_SRNN_CTRL_bbbsr_diff_max_flat_en_mask                              (0x00400000)
#define  SRNN_SRNN_CTRL_bbbsr_const_dirsu_wt_mask                                (0x003F0000)
#define  SRNN_SRNN_CTRL_bbbsr_var_diff_clip_hith_mask                            (0x0000FF00)
#define  SRNN_SRNN_CTRL_bbbsr_var_diff_clip_loth_mask                            (0x000000FF)
#define  SRNN_SRNN_CTRL_srnn_func_en(data)                                       (0x80000000&((data)<<31))
#define  SRNN_SRNN_CTRL_bbbsr_en(data)                                           (0x30000000&((data)<<28))
#define  SRNN_SRNN_CTRL_bbbsr_blend_diff_clip1_en(data)                          (0x08000000&((data)<<27))
#define  SRNN_SRNN_CTRL_bbbsr_blend_diff_clip2_en(data)                          (0x04000000&((data)<<26))
#define  SRNN_SRNN_CTRL_bbbsr_blend_diff_clip3_en(data)                          (0x02000000&((data)<<25))
#define  SRNN_SRNN_CTRL_bbbsr_matrix33_select1_en(data)                          (0x01000000&((data)<<24))
#define  SRNN_SRNN_CTRL_bbbsr_matrix33_select2_en(data)                          (0x00800000&((data)<<23))
#define  SRNN_SRNN_CTRL_bbbsr_diff_max_flat_en(data)                             (0x00400000&((data)<<22))
#define  SRNN_SRNN_CTRL_bbbsr_const_dirsu_wt(data)                               (0x003F0000&((data)<<16))
#define  SRNN_SRNN_CTRL_bbbsr_var_diff_clip_hith(data)                           (0x0000FF00&((data)<<8))
#define  SRNN_SRNN_CTRL_bbbsr_var_diff_clip_loth(data)                           (0x000000FF&(data))
#define  SRNN_SRNN_CTRL_get_srnn_func_en(data)                                   ((0x80000000&(data))>>31)
#define  SRNN_SRNN_CTRL_get_bbbsr_en(data)                                       ((0x30000000&(data))>>28)
#define  SRNN_SRNN_CTRL_get_bbbsr_blend_diff_clip1_en(data)                      ((0x08000000&(data))>>27)
#define  SRNN_SRNN_CTRL_get_bbbsr_blend_diff_clip2_en(data)                      ((0x04000000&(data))>>26)
#define  SRNN_SRNN_CTRL_get_bbbsr_blend_diff_clip3_en(data)                      ((0x02000000&(data))>>25)
#define  SRNN_SRNN_CTRL_get_bbbsr_matrix33_select1_en(data)                      ((0x01000000&(data))>>24)
#define  SRNN_SRNN_CTRL_get_bbbsr_matrix33_select2_en(data)                      ((0x00800000&(data))>>23)
#define  SRNN_SRNN_CTRL_get_bbbsr_diff_max_flat_en(data)                         ((0x00400000&(data))>>22)
#define  SRNN_SRNN_CTRL_get_bbbsr_const_dirsu_wt(data)                           ((0x003F0000&(data))>>16)
#define  SRNN_SRNN_CTRL_get_bbbsr_var_diff_clip_hith(data)                       ((0x0000FF00&(data))>>8)
#define  SRNN_SRNN_CTRL_get_bbbsr_var_diff_clip_loth(data)                       (0x000000FF&(data))

#define  SRNN_DIFF_CLIP                                                         0x181AA004
#define  SRNN_DIFF_CLIP_reg_addr                                                 "0xB81AA004"
#define  SRNN_DIFF_CLIP_reg                                                      0xB81AA004
#define  SRNN_DIFF_CLIP_inst_addr                                                "0x0001"
#define  set_SRNN_DIFF_CLIP_reg(data)                                            (*((volatile unsigned int*)SRNN_DIFF_CLIP_reg)=data)
#define  get_SRNN_DIFF_CLIP_reg                                                  (*((volatile unsigned int*)SRNN_DIFF_CLIP_reg))
#define  SRNN_DIFF_CLIP_bbbsr_clip_hi_method_shift                               (28)
#define  SRNN_DIFF_CLIP_bbbsr_slope_clip1_shift                                  (24)
#define  SRNN_DIFF_CLIP_bbbsr_min_var_diff_clip_hi_gain_shift                    (20)
#define  SRNN_DIFF_CLIP_bbbsr_min_var_diff_clip_hi_min_shift                     (12)
#define  SRNN_DIFF_CLIP_bbbsr_min_var_diff_th_shift                              (4)
#define  SRNN_DIFF_CLIP_bbbsr_max_min_var_gain_shift                             (0)
#define  SRNN_DIFF_CLIP_bbbsr_clip_hi_method_mask                                (0x30000000)
#define  SRNN_DIFF_CLIP_bbbsr_slope_clip1_mask                                   (0x0F000000)
#define  SRNN_DIFF_CLIP_bbbsr_min_var_diff_clip_hi_gain_mask                     (0x00F00000)
#define  SRNN_DIFF_CLIP_bbbsr_min_var_diff_clip_hi_min_mask                      (0x000FF000)
#define  SRNN_DIFF_CLIP_bbbsr_min_var_diff_th_mask                               (0x00000FF0)
#define  SRNN_DIFF_CLIP_bbbsr_max_min_var_gain_mask                              (0x0000000F)
#define  SRNN_DIFF_CLIP_bbbsr_clip_hi_method(data)                               (0x30000000&((data)<<28))
#define  SRNN_DIFF_CLIP_bbbsr_slope_clip1(data)                                  (0x0F000000&((data)<<24))
#define  SRNN_DIFF_CLIP_bbbsr_min_var_diff_clip_hi_gain(data)                    (0x00F00000&((data)<<20))
#define  SRNN_DIFF_CLIP_bbbsr_min_var_diff_clip_hi_min(data)                     (0x000FF000&((data)<<12))
#define  SRNN_DIFF_CLIP_bbbsr_min_var_diff_th(data)                              (0x00000FF0&((data)<<4))
#define  SRNN_DIFF_CLIP_bbbsr_max_min_var_gain(data)                             (0x0000000F&(data))
#define  SRNN_DIFF_CLIP_get_bbbsr_clip_hi_method(data)                           ((0x30000000&(data))>>28)
#define  SRNN_DIFF_CLIP_get_bbbsr_slope_clip1(data)                              ((0x0F000000&(data))>>24)
#define  SRNN_DIFF_CLIP_get_bbbsr_min_var_diff_clip_hi_gain(data)                ((0x00F00000&(data))>>20)
#define  SRNN_DIFF_CLIP_get_bbbsr_min_var_diff_clip_hi_min(data)                 ((0x000FF000&(data))>>12)
#define  SRNN_DIFF_CLIP_get_bbbsr_min_var_diff_th(data)                          ((0x00000FF0&(data))>>4)
#define  SRNN_DIFF_CLIP_get_bbbsr_max_min_var_gain(data)                         (0x0000000F&(data))

#define  SRNN_DIFF_CLIP2                                                        0x181AA008
#define  SRNN_DIFF_CLIP2_reg_addr                                                "0xB81AA008"
#define  SRNN_DIFF_CLIP2_reg                                                     0xB81AA008
#define  SRNN_DIFF_CLIP2_inst_addr                                               "0x0002"
#define  set_SRNN_DIFF_CLIP2_reg(data)                                           (*((volatile unsigned int*)SRNN_DIFF_CLIP2_reg)=data)
#define  get_SRNN_DIFF_CLIP2_reg                                                 (*((volatile unsigned int*)SRNN_DIFF_CLIP2_reg))
#define  SRNN_DIFF_CLIP2_bbbsr_slope_clip2_shift                                 (8)
#define  SRNN_DIFF_CLIP2_bbbsr_max_var_loth_shift                                (0)
#define  SRNN_DIFF_CLIP2_bbbsr_slope_clip2_mask                                  (0x0000FF00)
#define  SRNN_DIFF_CLIP2_bbbsr_max_var_loth_mask                                 (0x000000FF)
#define  SRNN_DIFF_CLIP2_bbbsr_slope_clip2(data)                                 (0x0000FF00&((data)<<8))
#define  SRNN_DIFF_CLIP2_bbbsr_max_var_loth(data)                                (0x000000FF&(data))
#define  SRNN_DIFF_CLIP2_get_bbbsr_slope_clip2(data)                             ((0x0000FF00&(data))>>8)
#define  SRNN_DIFF_CLIP2_get_bbbsr_max_var_loth(data)                            (0x000000FF&(data))

#define  SRNN_DIFF_CLIP3                                                        0x181AA00C
#define  SRNN_DIFF_CLIP3_reg_addr                                                "0xB81AA00C"
#define  SRNN_DIFF_CLIP3_reg                                                     0xB81AA00C
#define  SRNN_DIFF_CLIP3_inst_addr                                               "0x0003"
#define  set_SRNN_DIFF_CLIP3_reg(data)                                           (*((volatile unsigned int*)SRNN_DIFF_CLIP3_reg)=data)
#define  get_SRNN_DIFF_CLIP3_reg                                                 (*((volatile unsigned int*)SRNN_DIFF_CLIP3_reg))
#define  SRNN_DIFF_CLIP3_bbbsr_slope_clip3_weight_shift                          (16)
#define  SRNN_DIFF_CLIP3_bbbsr_slope_clip3_shift                                 (0)
#define  SRNN_DIFF_CLIP3_bbbsr_slope_clip3_weight_mask                           (0x00FF0000)
#define  SRNN_DIFF_CLIP3_bbbsr_slope_clip3_mask                                  (0x000000FF)
#define  SRNN_DIFF_CLIP3_bbbsr_slope_clip3_weight(data)                          (0x00FF0000&((data)<<16))
#define  SRNN_DIFF_CLIP3_bbbsr_slope_clip3(data)                                 (0x000000FF&(data))
#define  SRNN_DIFF_CLIP3_get_bbbsr_slope_clip3_weight(data)                      ((0x00FF0000&(data))>>16)
#define  SRNN_DIFF_CLIP3_get_bbbsr_slope_clip3(data)                             (0x000000FF&(data))

#define  SRNN_DIFF_CLIP4                                                        0x181AA038
#define  SRNN_DIFF_CLIP4_reg_addr                                                "0xB81AA038"
#define  SRNN_DIFF_CLIP4_reg                                                     0xB81AA038
#define  SRNN_DIFF_CLIP4_inst_addr                                               "0x0004"
#define  set_SRNN_DIFF_CLIP4_reg(data)                                           (*((volatile unsigned int*)SRNN_DIFF_CLIP4_reg)=data)
#define  get_SRNN_DIFF_CLIP4_reg                                                 (*((volatile unsigned int*)SRNN_DIFF_CLIP4_reg))
#define  SRNN_DIFF_CLIP4_bbbsr_max_var_loth2_shift                               (24)
#define  SRNN_DIFF_CLIP4_bbbsr_slope_weight_var_shift                            (8)
#define  SRNN_DIFF_CLIP4_bbbsr_dir_confid_loth_shift                             (0)
#define  SRNN_DIFF_CLIP4_bbbsr_max_var_loth2_mask                                (0xFF000000)
#define  SRNN_DIFF_CLIP4_bbbsr_slope_weight_var_mask                             (0x0000FF00)
#define  SRNN_DIFF_CLIP4_bbbsr_dir_confid_loth_mask                              (0x000000FF)
#define  SRNN_DIFF_CLIP4_bbbsr_max_var_loth2(data)                               (0xFF000000&((data)<<24))
#define  SRNN_DIFF_CLIP4_bbbsr_slope_weight_var(data)                            (0x0000FF00&((data)<<8))
#define  SRNN_DIFF_CLIP4_bbbsr_dir_confid_loth(data)                             (0x000000FF&(data))
#define  SRNN_DIFF_CLIP4_get_bbbsr_max_var_loth2(data)                           ((0xFF000000&(data))>>24)
#define  SRNN_DIFF_CLIP4_get_bbbsr_slope_weight_var(data)                        ((0x0000FF00&(data))>>8)
#define  SRNN_DIFF_CLIP4_get_bbbsr_dir_confid_loth(data)                         (0x000000FF&(data))

#define  SRNN_WEIGHT                                                            0x181AA010
#define  SRNN_WEIGHT_reg_addr                                                    "0xB81AA010"
#define  SRNN_WEIGHT_reg                                                         0xB81AA010
#define  SRNN_WEIGHT_inst_addr                                                   "0x0005"
#define  set_SRNN_WEIGHT_reg(data)                                               (*((volatile unsigned int*)SRNN_WEIGHT_reg)=data)
#define  get_SRNN_WEIGHT_reg                                                     (*((volatile unsigned int*)SRNN_WEIGHT_reg))
#define  SRNN_WEIGHT_bbbsr_var_cur_w_loth_shift                                  (16)
#define  SRNN_WEIGHT_bbbsr_var_cur_w_hith_shift                                  (8)
#define  SRNN_WEIGHT_bbbsr_var_cur_loth_shift                                    (0)
#define  SRNN_WEIGHT_bbbsr_var_cur_w_loth_mask                                   (0x003F0000)
#define  SRNN_WEIGHT_bbbsr_var_cur_w_hith_mask                                   (0x00003F00)
#define  SRNN_WEIGHT_bbbsr_var_cur_loth_mask                                     (0x000000FF)
#define  SRNN_WEIGHT_bbbsr_var_cur_w_loth(data)                                  (0x003F0000&((data)<<16))
#define  SRNN_WEIGHT_bbbsr_var_cur_w_hith(data)                                  (0x00003F00&((data)<<8))
#define  SRNN_WEIGHT_bbbsr_var_cur_loth(data)                                    (0x000000FF&(data))
#define  SRNN_WEIGHT_get_bbbsr_var_cur_w_loth(data)                              ((0x003F0000&(data))>>16)
#define  SRNN_WEIGHT_get_bbbsr_var_cur_w_hith(data)                              ((0x00003F00&(data))>>8)
#define  SRNN_WEIGHT_get_bbbsr_var_cur_loth(data)                                (0x000000FF&(data))

#define  SRNN_FLAT_CLIP                                                         0x181AA014
#define  SRNN_FLAT_CLIP_reg_addr                                                 "0xB81AA014"
#define  SRNN_FLAT_CLIP_reg                                                      0xB81AA014
#define  SRNN_FLAT_CLIP_inst_addr                                                "0x0006"
#define  set_SRNN_FLAT_CLIP_reg(data)                                            (*((volatile unsigned int*)SRNN_FLAT_CLIP_reg)=data)
#define  get_SRNN_FLAT_CLIP_reg                                                  (*((volatile unsigned int*)SRNN_FLAT_CLIP_reg))
#define  SRNN_FLAT_CLIP_bbbsr_diff_max_flat_gain_shift                           (8)
#define  SRNN_FLAT_CLIP_bbbsr_diff_max_flat_coring_shift                         (0)
#define  SRNN_FLAT_CLIP_bbbsr_diff_max_flat_gain_mask                            (0x00000F00)
#define  SRNN_FLAT_CLIP_bbbsr_diff_max_flat_coring_mask                          (0x000000FF)
#define  SRNN_FLAT_CLIP_bbbsr_diff_max_flat_gain(data)                           (0x00000F00&((data)<<8))
#define  SRNN_FLAT_CLIP_bbbsr_diff_max_flat_coring(data)                         (0x000000FF&(data))
#define  SRNN_FLAT_CLIP_get_bbbsr_diff_max_flat_gain(data)                       ((0x00000F00&(data))>>8)
#define  SRNN_FLAT_CLIP_get_bbbsr_diff_max_flat_coring(data)                     (0x000000FF&(data))

#define  SRNN_DEBUG                                                             0x181AA018
#define  SRNN_DEBUG_reg_addr                                                     "0xB81AA018"
#define  SRNN_DEBUG_reg                                                          0xB81AA018
#define  SRNN_DEBUG_inst_addr                                                    "0x0007"
#define  set_SRNN_DEBUG_reg(data)                                                (*((volatile unsigned int*)SRNN_DEBUG_reg)=data)
#define  get_SRNN_DEBUG_reg                                                      (*((volatile unsigned int*)SRNN_DEBUG_reg))
#define  SRNN_DEBUG_bbbsr_blend_debug_en_shift                                   (31)
#define  SRNN_DEBUG_bbbsr_blend_db_shift_bit_shift                               (4)
#define  SRNN_DEBUG_bbbsr_blend_debug_mode_shift                                 (0)
#define  SRNN_DEBUG_bbbsr_blend_debug_en_mask                                    (0x80000000)
#define  SRNN_DEBUG_bbbsr_blend_db_shift_bit_mask                                (0x00000070)
#define  SRNN_DEBUG_bbbsr_blend_debug_mode_mask                                  (0x00000007)
#define  SRNN_DEBUG_bbbsr_blend_debug_en(data)                                   (0x80000000&((data)<<31))
#define  SRNN_DEBUG_bbbsr_blend_db_shift_bit(data)                               (0x00000070&((data)<<4))
#define  SRNN_DEBUG_bbbsr_blend_debug_mode(data)                                 (0x00000007&(data))
#define  SRNN_DEBUG_get_bbbsr_blend_debug_en(data)                               ((0x80000000&(data))>>31)
#define  SRNN_DEBUG_get_bbbsr_blend_db_shift_bit(data)                           ((0x00000070&(data))>>4)
#define  SRNN_DEBUG_get_bbbsr_blend_debug_mode(data)                             (0x00000007&(data))

#define  SRNN_DIFF_GAIN                                                         0x181AA01C
#define  SRNN_DIFF_GAIN_reg_addr                                                 "0xB81AA01C"
#define  SRNN_DIFF_GAIN_reg                                                      0xB81AA01C
#define  SRNN_DIFF_GAIN_inst_addr                                                "0x0008"
#define  set_SRNN_DIFF_GAIN_reg(data)                                            (*((volatile unsigned int*)SRNN_DIFF_GAIN_reg)=data)
#define  get_SRNN_DIFF_GAIN_reg                                                  (*((volatile unsigned int*)SRNN_DIFF_GAIN_reg))
#define  SRNN_DIFF_GAIN_dummy_31_20_shift                                        (20)
#define  SRNN_DIFF_GAIN_bbbsr_dir_confid_len_shift                               (16)
#define  SRNN_DIFF_GAIN_bbbsr_diff_max_select_shift                              (12)
#define  SRNN_DIFF_GAIN_bbbsr_diff_delta_coring_shift                            (4)
#define  SRNN_DIFF_GAIN_bbbsr_diff_delta_gain_shift                              (0)
#define  SRNN_DIFF_GAIN_dummy_31_20_mask                                         (0xFFF00000)
#define  SRNN_DIFF_GAIN_bbbsr_dir_confid_len_mask                                (0x000F0000)
#define  SRNN_DIFF_GAIN_bbbsr_diff_max_select_mask                               (0x00001000)
#define  SRNN_DIFF_GAIN_bbbsr_diff_delta_coring_mask                             (0x00000FF0)
#define  SRNN_DIFF_GAIN_bbbsr_diff_delta_gain_mask                               (0x0000000F)
#define  SRNN_DIFF_GAIN_dummy_31_20(data)                                        (0xFFF00000&((data)<<20))
#define  SRNN_DIFF_GAIN_bbbsr_dir_confid_len(data)                               (0x000F0000&((data)<<16))
#define  SRNN_DIFF_GAIN_bbbsr_diff_max_select(data)                              (0x00001000&((data)<<12))
#define  SRNN_DIFF_GAIN_bbbsr_diff_delta_coring(data)                            (0x00000FF0&((data)<<4))
#define  SRNN_DIFF_GAIN_bbbsr_diff_delta_gain(data)                              (0x0000000F&(data))
#define  SRNN_DIFF_GAIN_get_dummy_31_20(data)                                    ((0xFFF00000&(data))>>20)
#define  SRNN_DIFF_GAIN_get_bbbsr_dir_confid_len(data)                           ((0x000F0000&(data))>>16)
#define  SRNN_DIFF_GAIN_get_bbbsr_diff_max_select(data)                          ((0x00001000&(data))>>12)
#define  SRNN_DIFF_GAIN_get_bbbsr_diff_delta_coring(data)                        ((0x00000FF0&(data))>>4)
#define  SRNN_DIFF_GAIN_get_bbbsr_diff_delta_gain(data)                          (0x0000000F&(data))

#define  SRNN_DIFF_GAIN_Y                                                       0x181AA020
#define  SRNN_DIFF_GAIN_Y_reg_addr                                               "0xB81AA020"
#define  SRNN_DIFF_GAIN_Y_reg                                                    0xB81AA020
#define  SRNN_DIFF_GAIN_Y_inst_addr                                              "0x0009"
#define  set_SRNN_DIFF_GAIN_Y_reg(data)                                          (*((volatile unsigned int*)SRNN_DIFF_GAIN_Y_reg)=data)
#define  get_SRNN_DIFF_GAIN_Y_reg                                                (*((volatile unsigned int*)SRNN_DIFF_GAIN_Y_reg))
#define  SRNN_DIFF_GAIN_Y_dummy_31_13_shift                                      (13)
#define  SRNN_DIFF_GAIN_Y_bbbsr_delta_y_gain_en_shift                            (12)
#define  SRNN_DIFF_GAIN_Y_bbbsr_delta_y_coring_shift                             (4)
#define  SRNN_DIFF_GAIN_Y_bbbsr_diff_delta_y_gain_shift                          (0)
#define  SRNN_DIFF_GAIN_Y_dummy_31_13_mask                                       (0xFFFFE000)
#define  SRNN_DIFF_GAIN_Y_bbbsr_delta_y_gain_en_mask                             (0x00001000)
#define  SRNN_DIFF_GAIN_Y_bbbsr_delta_y_coring_mask                              (0x00000FF0)
#define  SRNN_DIFF_GAIN_Y_bbbsr_diff_delta_y_gain_mask                           (0x0000000F)
#define  SRNN_DIFF_GAIN_Y_dummy_31_13(data)                                      (0xFFFFE000&((data)<<13))
#define  SRNN_DIFF_GAIN_Y_bbbsr_delta_y_gain_en(data)                            (0x00001000&((data)<<12))
#define  SRNN_DIFF_GAIN_Y_bbbsr_delta_y_coring(data)                             (0x00000FF0&((data)<<4))
#define  SRNN_DIFF_GAIN_Y_bbbsr_diff_delta_y_gain(data)                          (0x0000000F&(data))
#define  SRNN_DIFF_GAIN_Y_get_dummy_31_13(data)                                  ((0xFFFFE000&(data))>>13)
#define  SRNN_DIFF_GAIN_Y_get_bbbsr_delta_y_gain_en(data)                        ((0x00001000&(data))>>12)
#define  SRNN_DIFF_GAIN_Y_get_bbbsr_delta_y_coring(data)                         ((0x00000FF0&(data))>>4)
#define  SRNN_DIFF_GAIN_Y_get_bbbsr_diff_delta_y_gain(data)                      (0x0000000F&(data))

#define  SRNN_DEMO_1                                                            0x181AA024
#define  SRNN_DEMO_1_reg_addr                                                    "0xB81AA024"
#define  SRNN_DEMO_1_reg                                                         0xB81AA024
#define  SRNN_DEMO_1_inst_addr                                                   "0x000A"
#define  set_SRNN_DEMO_1_reg(data)                                               (*((volatile unsigned int*)SRNN_DEMO_1_reg)=data)
#define  get_SRNN_DEMO_1_reg                                                     (*((volatile unsigned int*)SRNN_DEMO_1_reg))
#define  SRNN_DEMO_1_demo_sr_v_sta_shift                                         (16)
#define  SRNN_DEMO_1_demo_sr_v_end_shift                                         (0)
#define  SRNN_DEMO_1_demo_sr_v_sta_mask                                          (0x1FFF0000)
#define  SRNN_DEMO_1_demo_sr_v_end_mask                                          (0x00001FFF)
#define  SRNN_DEMO_1_demo_sr_v_sta(data)                                         (0x1FFF0000&((data)<<16))
#define  SRNN_DEMO_1_demo_sr_v_end(data)                                         (0x00001FFF&(data))
#define  SRNN_DEMO_1_get_demo_sr_v_sta(data)                                     ((0x1FFF0000&(data))>>16)
#define  SRNN_DEMO_1_get_demo_sr_v_end(data)                                     (0x00001FFF&(data))

#define  SRNN_DEMO_2                                                            0x181AA028
#define  SRNN_DEMO_2_reg_addr                                                    "0xB81AA028"
#define  SRNN_DEMO_2_reg                                                         0xB81AA028
#define  SRNN_DEMO_2_inst_addr                                                   "0x000B"
#define  set_SRNN_DEMO_2_reg(data)                                               (*((volatile unsigned int*)SRNN_DEMO_2_reg)=data)
#define  get_SRNN_DEMO_2_reg                                                     (*((volatile unsigned int*)SRNN_DEMO_2_reg))
#define  SRNN_DEMO_2_demo_sr_h_sta_shift                                         (16)
#define  SRNN_DEMO_2_demo_sr_h_end_shift                                         (0)
#define  SRNN_DEMO_2_demo_sr_h_sta_mask                                          (0x1FFF0000)
#define  SRNN_DEMO_2_demo_sr_h_end_mask                                          (0x00001FFF)
#define  SRNN_DEMO_2_demo_sr_h_sta(data)                                         (0x1FFF0000&((data)<<16))
#define  SRNN_DEMO_2_demo_sr_h_end(data)                                         (0x00001FFF&(data))
#define  SRNN_DEMO_2_get_demo_sr_h_sta(data)                                     ((0x1FFF0000&(data))>>16)
#define  SRNN_DEMO_2_get_demo_sr_h_end(data)                                     (0x00001FFF&(data))

#define  SRNN_SRNN_BLEND                                                        0x181AA02C
#define  SRNN_SRNN_BLEND_reg_addr                                                "0xB81AA02C"
#define  SRNN_SRNN_BLEND_reg                                                     0xB81AA02C
#define  SRNN_SRNN_BLEND_inst_addr                                               "0x000C"
#define  set_SRNN_SRNN_BLEND_reg(data)                                           (*((volatile unsigned int*)SRNN_SRNN_BLEND_reg)=data)
#define  get_SRNN_SRNN_BLEND_reg                                                 (*((volatile unsigned int*)SRNN_SRNN_BLEND_reg))
#define  SRNN_SRNN_BLEND_wdsr_y_delta_gain_shift                                 (26)
#define  SRNN_SRNN_BLEND_wdsr_delta_y_mode_shift                                 (25)
#define  SRNN_SRNN_BLEND_sr_linebuf_pixel_delay_shift                            (0)
#define  SRNN_SRNN_BLEND_wdsr_y_delta_gain_mask                                  (0xFC000000)
#define  SRNN_SRNN_BLEND_wdsr_delta_y_mode_mask                                  (0x02000000)
#define  SRNN_SRNN_BLEND_sr_linebuf_pixel_delay_mask                             (0x00001FFF)
#define  SRNN_SRNN_BLEND_wdsr_y_delta_gain(data)                                 (0xFC000000&((data)<<26))
#define  SRNN_SRNN_BLEND_wdsr_delta_y_mode(data)                                 (0x02000000&((data)<<25))
#define  SRNN_SRNN_BLEND_sr_linebuf_pixel_delay(data)                            (0x00001FFF&(data))
#define  SRNN_SRNN_BLEND_get_wdsr_y_delta_gain(data)                             ((0xFC000000&(data))>>26)
#define  SRNN_SRNN_BLEND_get_wdsr_delta_y_mode(data)                             ((0x02000000&(data))>>25)
#define  SRNN_SRNN_BLEND_get_sr_linebuf_pixel_delay(data)                        (0x00001FFF&(data))

#define  SRNN_DM_SRNN_DB_CTRL                                                   0x181AA034
#define  SRNN_DM_SRNN_DB_CTRL_reg_addr                                           "0xB81AA034"
#define  SRNN_DM_SRNN_DB_CTRL_reg                                                0xB81AA034
#define  SRNN_DM_SRNN_DB_CTRL_inst_addr                                          "0x000D"
#define  set_SRNN_DM_SRNN_DB_CTRL_reg(data)                                      (*((volatile unsigned int*)SRNN_DM_SRNN_DB_CTRL_reg)=data)
#define  get_SRNN_DM_SRNN_DB_CTRL_reg                                            (*((volatile unsigned int*)SRNN_DM_SRNN_DB_CTRL_reg))
#define  SRNN_DM_SRNN_DB_CTRL_db_write_hold_cnt_shift                            (4)
#define  SRNN_DM_SRNN_DB_CTRL_db_en_shift                                        (2)
#define  SRNN_DM_SRNN_DB_CTRL_db_read_level_shift                                (1)
#define  SRNN_DM_SRNN_DB_CTRL_db_apply_shift                                     (0)
#define  SRNN_DM_SRNN_DB_CTRL_db_write_hold_cnt_mask                             (0x000000F0)
#define  SRNN_DM_SRNN_DB_CTRL_db_en_mask                                         (0x00000004)
#define  SRNN_DM_SRNN_DB_CTRL_db_read_level_mask                                 (0x00000002)
#define  SRNN_DM_SRNN_DB_CTRL_db_apply_mask                                      (0x00000001)
#define  SRNN_DM_SRNN_DB_CTRL_db_write_hold_cnt(data)                            (0x000000F0&((data)<<4))
#define  SRNN_DM_SRNN_DB_CTRL_db_en(data)                                        (0x00000004&((data)<<2))
#define  SRNN_DM_SRNN_DB_CTRL_db_read_level(data)                                (0x00000002&((data)<<1))
#define  SRNN_DM_SRNN_DB_CTRL_db_apply(data)                                     (0x00000001&(data))
#define  SRNN_DM_SRNN_DB_CTRL_get_db_write_hold_cnt(data)                        ((0x000000F0&(data))>>4)
#define  SRNN_DM_SRNN_DB_CTRL_get_db_en(data)                                    ((0x00000004&(data))>>2)
#define  SRNN_DM_SRNN_DB_CTRL_get_db_read_level(data)                            ((0x00000002&(data))>>1)
#define  SRNN_DM_SRNN_DB_CTRL_get_db_apply(data)                                 (0x00000001&(data))

#define  SRNN_DIFF_CLIP5                                                        0x181AA03C
#define  SRNN_DIFF_CLIP5_reg_addr                                                "0xB81AA03C"
#define  SRNN_DIFF_CLIP5_reg                                                     0xB81AA03C
#define  SRNN_DIFF_CLIP5_inst_addr                                               "0x000E"
#define  set_SRNN_DIFF_CLIP5_reg(data)                                           (*((volatile unsigned int*)SRNN_DIFF_CLIP5_reg)=data)
#define  get_SRNN_DIFF_CLIP5_reg                                                 (*((volatile unsigned int*)SRNN_DIFF_CLIP5_reg))
#define  SRNN_DIFF_CLIP5_bbbsr_dir_weight_dy_en_shift                            (31)
#define  SRNN_DIFF_CLIP5_bbbsr_dir_weight_dy_gain1_shift                         (27)
#define  SRNN_DIFF_CLIP5_bbbsr_dir_weight_dy_gain2_shift                         (23)
#define  SRNN_DIFF_CLIP5_bbbsr_dir_weight_dy_hith_shift                          (17)
#define  SRNN_DIFF_CLIP5_bbbsr_dir_weight_dy_th_shift                            (11)
#define  SRNN_DIFF_CLIP5_bbbsr_dir_weight_dy_loth_shift                          (0)
#define  SRNN_DIFF_CLIP5_bbbsr_dir_weight_dy_en_mask                             (0x80000000)
#define  SRNN_DIFF_CLIP5_bbbsr_dir_weight_dy_gain1_mask                          (0x78000000)
#define  SRNN_DIFF_CLIP5_bbbsr_dir_weight_dy_gain2_mask                          (0x07800000)
#define  SRNN_DIFF_CLIP5_bbbsr_dir_weight_dy_hith_mask                           (0x007E0000)
#define  SRNN_DIFF_CLIP5_bbbsr_dir_weight_dy_th_mask                             (0x0001F800)
#define  SRNN_DIFF_CLIP5_bbbsr_dir_weight_dy_loth_mask                           (0x000000FF)
#define  SRNN_DIFF_CLIP5_bbbsr_dir_weight_dy_en(data)                            (0x80000000&((data)<<31))
#define  SRNN_DIFF_CLIP5_bbbsr_dir_weight_dy_gain1(data)                         (0x78000000&((data)<<27))
#define  SRNN_DIFF_CLIP5_bbbsr_dir_weight_dy_gain2(data)                         (0x07800000&((data)<<23))
#define  SRNN_DIFF_CLIP5_bbbsr_dir_weight_dy_hith(data)                          (0x007E0000&((data)<<17))
#define  SRNN_DIFF_CLIP5_bbbsr_dir_weight_dy_th(data)                            (0x0001F800&((data)<<11))
#define  SRNN_DIFF_CLIP5_bbbsr_dir_weight_dy_loth(data)                          (0x000000FF&(data))
#define  SRNN_DIFF_CLIP5_get_bbbsr_dir_weight_dy_en(data)                        ((0x80000000&(data))>>31)
#define  SRNN_DIFF_CLIP5_get_bbbsr_dir_weight_dy_gain1(data)                     ((0x78000000&(data))>>27)
#define  SRNN_DIFF_CLIP5_get_bbbsr_dir_weight_dy_gain2(data)                     ((0x07800000&(data))>>23)
#define  SRNN_DIFF_CLIP5_get_bbbsr_dir_weight_dy_hith(data)                      ((0x007E0000&(data))>>17)
#define  SRNN_DIFF_CLIP5_get_bbbsr_dir_weight_dy_th(data)                        ((0x0001F800&(data))>>11)
#define  SRNN_DIFF_CLIP5_get_bbbsr_dir_weight_dy_loth(data)                      (0x000000FF&(data))

#define  SRNN_SRNN_Timing_0                                                     0x181AA040
#define  SRNN_SRNN_Timing_0_reg_addr                                             "0xB81AA040"
#define  SRNN_SRNN_Timing_0_reg                                                  0xB81AA040
#define  SRNN_SRNN_Timing_0_inst_addr                                            "0x000F"
#define  set_SRNN_SRNN_Timing_0_reg(data)                                        (*((volatile unsigned int*)SRNN_SRNN_Timing_0_reg)=data)
#define  get_SRNN_SRNN_Timing_0_reg                                              (*((volatile unsigned int*)SRNN_SRNN_Timing_0_reg))
#define  SRNN_SRNN_Timing_0_two_step_overflow_shift                              (27)
#define  SRNN_SRNN_Timing_0_srnn_pre_rd_udf_shift                                (26)
#define  SRNN_SRNN_Timing_0_smt_rd_conflict_err_shift                            (25)
#define  SRNN_SRNN_Timing_0_uzu_input_size_err_shift                             (24)
#define  SRNN_SRNN_Timing_0_srnn2wdsr_h_cnt_shift                                (12)
#define  SRNN_SRNN_Timing_0_srnn2wdsr_v_cnt_shift                                (0)
#define  SRNN_SRNN_Timing_0_two_step_overflow_mask                               (0x08000000)
#define  SRNN_SRNN_Timing_0_srnn_pre_rd_udf_mask                                 (0x04000000)
#define  SRNN_SRNN_Timing_0_smt_rd_conflict_err_mask                             (0x02000000)
#define  SRNN_SRNN_Timing_0_uzu_input_size_err_mask                              (0x01000000)
#define  SRNN_SRNN_Timing_0_srnn2wdsr_h_cnt_mask                                 (0x00FFF000)
#define  SRNN_SRNN_Timing_0_srnn2wdsr_v_cnt_mask                                 (0x00000FFF)
#define  SRNN_SRNN_Timing_0_two_step_overflow(data)                              (0x08000000&((data)<<27))
#define  SRNN_SRNN_Timing_0_srnn_pre_rd_udf(data)                                (0x04000000&((data)<<26))
#define  SRNN_SRNN_Timing_0_smt_rd_conflict_err(data)                            (0x02000000&((data)<<25))
#define  SRNN_SRNN_Timing_0_uzu_input_size_err(data)                             (0x01000000&((data)<<24))
#define  SRNN_SRNN_Timing_0_srnn2wdsr_h_cnt(data)                                (0x00FFF000&((data)<<12))
#define  SRNN_SRNN_Timing_0_srnn2wdsr_v_cnt(data)                                (0x00000FFF&(data))
#define  SRNN_SRNN_Timing_0_get_two_step_overflow(data)                          ((0x08000000&(data))>>27)
#define  SRNN_SRNN_Timing_0_get_srnn_pre_rd_udf(data)                            ((0x04000000&(data))>>26)
#define  SRNN_SRNN_Timing_0_get_smt_rd_conflict_err(data)                        ((0x02000000&(data))>>25)
#define  SRNN_SRNN_Timing_0_get_uzu_input_size_err(data)                         ((0x01000000&(data))>>24)
#define  SRNN_SRNN_Timing_0_get_srnn2wdsr_h_cnt(data)                            ((0x00FFF000&(data))>>12)
#define  SRNN_SRNN_Timing_0_get_srnn2wdsr_v_cnt(data)                            (0x00000FFF&(data))

#define  SRNN_SRNN_Timing_1                                                     0x181AA044
#define  SRNN_SRNN_Timing_1_reg_addr                                             "0xB81AA044"
#define  SRNN_SRNN_Timing_1_reg                                                  0xB81AA044
#define  SRNN_SRNN_Timing_1_inst_addr                                            "0x0010"
#define  set_SRNN_SRNN_Timing_1_reg(data)                                        (*((volatile unsigned int*)SRNN_SRNN_Timing_1_reg)=data)
#define  get_SRNN_SRNN_Timing_1_reg                                              (*((volatile unsigned int*)SRNN_SRNN_Timing_1_reg))
#define  SRNN_SRNN_Timing_1_wdsr2blend_h_cnt_shift                               (16)
#define  SRNN_SRNN_Timing_1_wdsr2blend_v_cnt_shift                               (0)
#define  SRNN_SRNN_Timing_1_wdsr2blend_h_cnt_mask                                (0x0FFF0000)
#define  SRNN_SRNN_Timing_1_wdsr2blend_v_cnt_mask                                (0x00000FFF)
#define  SRNN_SRNN_Timing_1_wdsr2blend_h_cnt(data)                               (0x0FFF0000&((data)<<16))
#define  SRNN_SRNN_Timing_1_wdsr2blend_v_cnt(data)                               (0x00000FFF&(data))
#define  SRNN_SRNN_Timing_1_get_wdsr2blend_h_cnt(data)                           ((0x0FFF0000&(data))>>16)
#define  SRNN_SRNN_Timing_1_get_wdsr2blend_v_cnt(data)                           (0x00000FFF&(data))

#define  SRNN_SRNN_Timing_2                                                     0x181AA048
#define  SRNN_SRNN_Timing_2_reg_addr                                             "0xB81AA048"
#define  SRNN_SRNN_Timing_2_reg                                                  0xB81AA048
#define  SRNN_SRNN_Timing_2_inst_addr                                            "0x0011"
#define  set_SRNN_SRNN_Timing_2_reg(data)                                        (*((volatile unsigned int*)SRNN_SRNN_Timing_2_reg)=data)
#define  get_SRNN_SRNN_Timing_2_reg                                              (*((volatile unsigned int*)SRNN_SRNN_Timing_2_reg))
#define  SRNN_SRNN_Timing_2_two_step_wr_rd_dbg_en_shift                          (24)
#define  SRNN_SRNN_Timing_2_two_step_wr_line_shift                               (12)
#define  SRNN_SRNN_Timing_2_two_step_wr_pixel_shift                              (0)
#define  SRNN_SRNN_Timing_2_two_step_wr_rd_dbg_en_mask                           (0x01000000)
#define  SRNN_SRNN_Timing_2_two_step_wr_line_mask                                (0x00FFF000)
#define  SRNN_SRNN_Timing_2_two_step_wr_pixel_mask                               (0x00000FFF)
#define  SRNN_SRNN_Timing_2_two_step_wr_rd_dbg_en(data)                          (0x01000000&((data)<<24))
#define  SRNN_SRNN_Timing_2_two_step_wr_line(data)                               (0x00FFF000&((data)<<12))
#define  SRNN_SRNN_Timing_2_two_step_wr_pixel(data)                              (0x00000FFF&(data))
#define  SRNN_SRNN_Timing_2_get_two_step_wr_rd_dbg_en(data)                      ((0x01000000&(data))>>24)
#define  SRNN_SRNN_Timing_2_get_two_step_wr_line(data)                           ((0x00FFF000&(data))>>12)
#define  SRNN_SRNN_Timing_2_get_two_step_wr_pixel(data)                          (0x00000FFF&(data))

#define  SRNN_SRNN_Timing_3                                                     0x181AA050
#define  SRNN_SRNN_Timing_3_reg_addr                                             "0xB81AA050"
#define  SRNN_SRNN_Timing_3_reg                                                  0xB81AA050
#define  SRNN_SRNN_Timing_3_inst_addr                                            "0x0012"
#define  set_SRNN_SRNN_Timing_3_reg(data)                                        (*((volatile unsigned int*)SRNN_SRNN_Timing_3_reg)=data)
#define  get_SRNN_SRNN_Timing_3_reg                                              (*((volatile unsigned int*)SRNN_SRNN_Timing_3_reg))
#define  SRNN_SRNN_Timing_3_two_tep_rd_line_shift                                (12)
#define  SRNN_SRNN_Timing_3_two_step_rd_pixel_shift                              (0)
#define  SRNN_SRNN_Timing_3_two_tep_rd_line_mask                                 (0x00FFF000)
#define  SRNN_SRNN_Timing_3_two_step_rd_pixel_mask                               (0x00000FFF)
#define  SRNN_SRNN_Timing_3_two_tep_rd_line(data)                                (0x00FFF000&((data)<<12))
#define  SRNN_SRNN_Timing_3_two_step_rd_pixel(data)                              (0x00000FFF&(data))
#define  SRNN_SRNN_Timing_3_get_two_tep_rd_line(data)                            ((0x00FFF000&(data))>>12)
#define  SRNN_SRNN_Timing_3_get_two_step_rd_pixel(data)                          (0x00000FFF&(data))

#define  SRNN_V8_Y_ph0_coeff00                                                  0x181AA0C0
#define  SRNN_V8_Y_ph0_coeff00_reg_addr                                          "0xB81AA0C0"
#define  SRNN_V8_Y_ph0_coeff00_reg                                               0xB81AA0C0
#define  SRNN_V8_Y_ph0_coeff00_inst_addr                                         "0x0013"
#define  set_SRNN_V8_Y_ph0_coeff00_reg(data)                                     (*((volatile unsigned int*)SRNN_V8_Y_ph0_coeff00_reg)=data)
#define  get_SRNN_V8_Y_ph0_coeff00_reg                                           (*((volatile unsigned int*)SRNN_V8_Y_ph0_coeff00_reg))
#define  SRNN_V8_Y_ph0_coeff00_v8_y_c0_1_shift                                   (16)
#define  SRNN_V8_Y_ph0_coeff00_v8_y_c0_0_shift                                   (0)
#define  SRNN_V8_Y_ph0_coeff00_v8_y_c0_1_mask                                    (0x0FFF0000)
#define  SRNN_V8_Y_ph0_coeff00_v8_y_c0_0_mask                                    (0x00000FFF)
#define  SRNN_V8_Y_ph0_coeff00_v8_y_c0_1(data)                                   (0x0FFF0000&((data)<<16))
#define  SRNN_V8_Y_ph0_coeff00_v8_y_c0_0(data)                                   (0x00000FFF&(data))
#define  SRNN_V8_Y_ph0_coeff00_get_v8_y_c0_1(data)                               ((0x0FFF0000&(data))>>16)
#define  SRNN_V8_Y_ph0_coeff00_get_v8_y_c0_0(data)                               (0x00000FFF&(data))

#define  SRNN_V8_Y_ph0_coeff01                                                  0x181AA0C4
#define  SRNN_V8_Y_ph0_coeff01_reg_addr                                          "0xB81AA0C4"
#define  SRNN_V8_Y_ph0_coeff01_reg                                               0xB81AA0C4
#define  SRNN_V8_Y_ph0_coeff01_inst_addr                                         "0x0014"
#define  set_SRNN_V8_Y_ph0_coeff01_reg(data)                                     (*((volatile unsigned int*)SRNN_V8_Y_ph0_coeff01_reg)=data)
#define  get_SRNN_V8_Y_ph0_coeff01_reg                                           (*((volatile unsigned int*)SRNN_V8_Y_ph0_coeff01_reg))
#define  SRNN_V8_Y_ph0_coeff01_v8_y_c0_3_shift                                   (16)
#define  SRNN_V8_Y_ph0_coeff01_v8_y_c0_2_shift                                   (0)
#define  SRNN_V8_Y_ph0_coeff01_v8_y_c0_3_mask                                    (0x0FFF0000)
#define  SRNN_V8_Y_ph0_coeff01_v8_y_c0_2_mask                                    (0x00000FFF)
#define  SRNN_V8_Y_ph0_coeff01_v8_y_c0_3(data)                                   (0x0FFF0000&((data)<<16))
#define  SRNN_V8_Y_ph0_coeff01_v8_y_c0_2(data)                                   (0x00000FFF&(data))
#define  SRNN_V8_Y_ph0_coeff01_get_v8_y_c0_3(data)                               ((0x0FFF0000&(data))>>16)
#define  SRNN_V8_Y_ph0_coeff01_get_v8_y_c0_2(data)                               (0x00000FFF&(data))

#define  SRNN_V8_Y_ph0_coeff02                                                  0x181AA0C8
#define  SRNN_V8_Y_ph0_coeff02_reg_addr                                          "0xB81AA0C8"
#define  SRNN_V8_Y_ph0_coeff02_reg                                               0xB81AA0C8
#define  SRNN_V8_Y_ph0_coeff02_inst_addr                                         "0x0015"
#define  set_SRNN_V8_Y_ph0_coeff02_reg(data)                                     (*((volatile unsigned int*)SRNN_V8_Y_ph0_coeff02_reg)=data)
#define  get_SRNN_V8_Y_ph0_coeff02_reg                                           (*((volatile unsigned int*)SRNN_V8_Y_ph0_coeff02_reg))
#define  SRNN_V8_Y_ph0_coeff02_v8_y_c0_5_shift                                   (16)
#define  SRNN_V8_Y_ph0_coeff02_v8_y_c0_4_shift                                   (0)
#define  SRNN_V8_Y_ph0_coeff02_v8_y_c0_5_mask                                    (0x0FFF0000)
#define  SRNN_V8_Y_ph0_coeff02_v8_y_c0_4_mask                                    (0x00000FFF)
#define  SRNN_V8_Y_ph0_coeff02_v8_y_c0_5(data)                                   (0x0FFF0000&((data)<<16))
#define  SRNN_V8_Y_ph0_coeff02_v8_y_c0_4(data)                                   (0x00000FFF&(data))
#define  SRNN_V8_Y_ph0_coeff02_get_v8_y_c0_5(data)                               ((0x0FFF0000&(data))>>16)
#define  SRNN_V8_Y_ph0_coeff02_get_v8_y_c0_4(data)                               (0x00000FFF&(data))

#define  SRNN_V8_Y_ph0_coeff03                                                  0x181AA0CC
#define  SRNN_V8_Y_ph0_coeff03_reg_addr                                          "0xB81AA0CC"
#define  SRNN_V8_Y_ph0_coeff03_reg                                               0xB81AA0CC
#define  SRNN_V8_Y_ph0_coeff03_inst_addr                                         "0x0016"
#define  set_SRNN_V8_Y_ph0_coeff03_reg(data)                                     (*((volatile unsigned int*)SRNN_V8_Y_ph0_coeff03_reg)=data)
#define  get_SRNN_V8_Y_ph0_coeff03_reg                                           (*((volatile unsigned int*)SRNN_V8_Y_ph0_coeff03_reg))
#define  SRNN_V8_Y_ph0_coeff03_v8_y_c0_7_shift                                   (16)
#define  SRNN_V8_Y_ph0_coeff03_v8_y_c0_6_shift                                   (0)
#define  SRNN_V8_Y_ph0_coeff03_v8_y_c0_7_mask                                    (0x0FFF0000)
#define  SRNN_V8_Y_ph0_coeff03_v8_y_c0_6_mask                                    (0x00000FFF)
#define  SRNN_V8_Y_ph0_coeff03_v8_y_c0_7(data)                                   (0x0FFF0000&((data)<<16))
#define  SRNN_V8_Y_ph0_coeff03_v8_y_c0_6(data)                                   (0x00000FFF&(data))
#define  SRNN_V8_Y_ph0_coeff03_get_v8_y_c0_7(data)                               ((0x0FFF0000&(data))>>16)
#define  SRNN_V8_Y_ph0_coeff03_get_v8_y_c0_6(data)                               (0x00000FFF&(data))

#define  SRNN_V8_Y_ph1_coeff00                                                  0x181AA0D0
#define  SRNN_V8_Y_ph1_coeff00_reg_addr                                          "0xB81AA0D0"
#define  SRNN_V8_Y_ph1_coeff00_reg                                               0xB81AA0D0
#define  SRNN_V8_Y_ph1_coeff00_inst_addr                                         "0x0017"
#define  set_SRNN_V8_Y_ph1_coeff00_reg(data)                                     (*((volatile unsigned int*)SRNN_V8_Y_ph1_coeff00_reg)=data)
#define  get_SRNN_V8_Y_ph1_coeff00_reg                                           (*((volatile unsigned int*)SRNN_V8_Y_ph1_coeff00_reg))
#define  SRNN_V8_Y_ph1_coeff00_v8_y_c1_1_shift                                   (16)
#define  SRNN_V8_Y_ph1_coeff00_v8_y_c1_0_shift                                   (0)
#define  SRNN_V8_Y_ph1_coeff00_v8_y_c1_1_mask                                    (0x0FFF0000)
#define  SRNN_V8_Y_ph1_coeff00_v8_y_c1_0_mask                                    (0x00000FFF)
#define  SRNN_V8_Y_ph1_coeff00_v8_y_c1_1(data)                                   (0x0FFF0000&((data)<<16))
#define  SRNN_V8_Y_ph1_coeff00_v8_y_c1_0(data)                                   (0x00000FFF&(data))
#define  SRNN_V8_Y_ph1_coeff00_get_v8_y_c1_1(data)                               ((0x0FFF0000&(data))>>16)
#define  SRNN_V8_Y_ph1_coeff00_get_v8_y_c1_0(data)                               (0x00000FFF&(data))

#define  SRNN_V8_Y_ph1_coeff01                                                  0x181AA0D4
#define  SRNN_V8_Y_ph1_coeff01_reg_addr                                          "0xB81AA0D4"
#define  SRNN_V8_Y_ph1_coeff01_reg                                               0xB81AA0D4
#define  SRNN_V8_Y_ph1_coeff01_inst_addr                                         "0x0018"
#define  set_SRNN_V8_Y_ph1_coeff01_reg(data)                                     (*((volatile unsigned int*)SRNN_V8_Y_ph1_coeff01_reg)=data)
#define  get_SRNN_V8_Y_ph1_coeff01_reg                                           (*((volatile unsigned int*)SRNN_V8_Y_ph1_coeff01_reg))
#define  SRNN_V8_Y_ph1_coeff01_v8_y_c1_3_shift                                   (16)
#define  SRNN_V8_Y_ph1_coeff01_v8_y_c1_2_shift                                   (0)
#define  SRNN_V8_Y_ph1_coeff01_v8_y_c1_3_mask                                    (0x0FFF0000)
#define  SRNN_V8_Y_ph1_coeff01_v8_y_c1_2_mask                                    (0x00000FFF)
#define  SRNN_V8_Y_ph1_coeff01_v8_y_c1_3(data)                                   (0x0FFF0000&((data)<<16))
#define  SRNN_V8_Y_ph1_coeff01_v8_y_c1_2(data)                                   (0x00000FFF&(data))
#define  SRNN_V8_Y_ph1_coeff01_get_v8_y_c1_3(data)                               ((0x0FFF0000&(data))>>16)
#define  SRNN_V8_Y_ph1_coeff01_get_v8_y_c1_2(data)                               (0x00000FFF&(data))

#define  SRNN_V8_Y_ph1_coeff02                                                  0x181AA0D8
#define  SRNN_V8_Y_ph1_coeff02_reg_addr                                          "0xB81AA0D8"
#define  SRNN_V8_Y_ph1_coeff02_reg                                               0xB81AA0D8
#define  SRNN_V8_Y_ph1_coeff02_inst_addr                                         "0x0019"
#define  set_SRNN_V8_Y_ph1_coeff02_reg(data)                                     (*((volatile unsigned int*)SRNN_V8_Y_ph1_coeff02_reg)=data)
#define  get_SRNN_V8_Y_ph1_coeff02_reg                                           (*((volatile unsigned int*)SRNN_V8_Y_ph1_coeff02_reg))
#define  SRNN_V8_Y_ph1_coeff02_v8_y_c1_5_shift                                   (16)
#define  SRNN_V8_Y_ph1_coeff02_v8_y_c1_4_shift                                   (0)
#define  SRNN_V8_Y_ph1_coeff02_v8_y_c1_5_mask                                    (0x0FFF0000)
#define  SRNN_V8_Y_ph1_coeff02_v8_y_c1_4_mask                                    (0x00000FFF)
#define  SRNN_V8_Y_ph1_coeff02_v8_y_c1_5(data)                                   (0x0FFF0000&((data)<<16))
#define  SRNN_V8_Y_ph1_coeff02_v8_y_c1_4(data)                                   (0x00000FFF&(data))
#define  SRNN_V8_Y_ph1_coeff02_get_v8_y_c1_5(data)                               ((0x0FFF0000&(data))>>16)
#define  SRNN_V8_Y_ph1_coeff02_get_v8_y_c1_4(data)                               (0x00000FFF&(data))

#define  SRNN_V8_Y_ph1_coeff03                                                  0x181AA0DC
#define  SRNN_V8_Y_ph1_coeff03_reg_addr                                          "0xB81AA0DC"
#define  SRNN_V8_Y_ph1_coeff03_reg                                               0xB81AA0DC
#define  SRNN_V8_Y_ph1_coeff03_inst_addr                                         "0x001A"
#define  set_SRNN_V8_Y_ph1_coeff03_reg(data)                                     (*((volatile unsigned int*)SRNN_V8_Y_ph1_coeff03_reg)=data)
#define  get_SRNN_V8_Y_ph1_coeff03_reg                                           (*((volatile unsigned int*)SRNN_V8_Y_ph1_coeff03_reg))
#define  SRNN_V8_Y_ph1_coeff03_v8_y_c1_7_shift                                   (16)
#define  SRNN_V8_Y_ph1_coeff03_v8_y_c1_6_shift                                   (0)
#define  SRNN_V8_Y_ph1_coeff03_v8_y_c1_7_mask                                    (0x0FFF0000)
#define  SRNN_V8_Y_ph1_coeff03_v8_y_c1_6_mask                                    (0x00000FFF)
#define  SRNN_V8_Y_ph1_coeff03_v8_y_c1_7(data)                                   (0x0FFF0000&((data)<<16))
#define  SRNN_V8_Y_ph1_coeff03_v8_y_c1_6(data)                                   (0x00000FFF&(data))
#define  SRNN_V8_Y_ph1_coeff03_get_v8_y_c1_7(data)                               ((0x0FFF0000&(data))>>16)
#define  SRNN_V8_Y_ph1_coeff03_get_v8_y_c1_6(data)                               (0x00000FFF&(data))

#define  SRNN_AccessData_CTRL_SRNN                                              0x181AA090
#define  SRNN_AccessData_CTRL_SRNN_reg_addr                                      "0xB81AA090"
#define  SRNN_AccessData_CTRL_SRNN_reg                                           0xB81AA090
#define  SRNN_AccessData_CTRL_SRNN_inst_addr                                     "0x001B"
#define  set_SRNN_AccessData_CTRL_SRNN_reg(data)                                 (*((volatile unsigned int*)SRNN_AccessData_CTRL_SRNN_reg)=data)
#define  get_SRNN_AccessData_CTRL_SRNN_reg                                       (*((volatile unsigned int*)SRNN_AccessData_CTRL_SRNN_reg))
#define  SRNN_AccessData_CTRL_SRNN_cross_bar_en_shift                            (3)
#define  SRNN_AccessData_CTRL_SRNN_ch_sel_shift                                  (2)
#define  SRNN_AccessData_CTRL_SRNN_write_en_shift                                (1)
#define  SRNN_AccessData_CTRL_SRNN_read_en_shift                                 (0)
#define  SRNN_AccessData_CTRL_SRNN_cross_bar_en_mask                             (0x00000008)
#define  SRNN_AccessData_CTRL_SRNN_ch_sel_mask                                   (0x00000004)
#define  SRNN_AccessData_CTRL_SRNN_write_en_mask                                 (0x00000002)
#define  SRNN_AccessData_CTRL_SRNN_read_en_mask                                  (0x00000001)
#define  SRNN_AccessData_CTRL_SRNN_cross_bar_en(data)                            (0x00000008&((data)<<3))
#define  SRNN_AccessData_CTRL_SRNN_ch_sel(data)                                  (0x00000004&((data)<<2))
#define  SRNN_AccessData_CTRL_SRNN_write_en(data)                                (0x00000002&((data)<<1))
#define  SRNN_AccessData_CTRL_SRNN_read_en(data)                                 (0x00000001&(data))
#define  SRNN_AccessData_CTRL_SRNN_get_cross_bar_en(data)                        ((0x00000008&(data))>>3)
#define  SRNN_AccessData_CTRL_SRNN_get_ch_sel(data)                              ((0x00000004&(data))>>2)
#define  SRNN_AccessData_CTRL_SRNN_get_write_en(data)                            ((0x00000002&(data))>>1)
#define  SRNN_AccessData_CTRL_SRNN_get_read_en(data)                             (0x00000001&(data))

#define  SRNN_AccessData_PosCtrl_SRNN                                           0x181AA094
#define  SRNN_AccessData_PosCtrl_SRNN_reg_addr                                   "0xB81AA094"
#define  SRNN_AccessData_PosCtrl_SRNN_reg                                        0xB81AA094
#define  SRNN_AccessData_PosCtrl_SRNN_inst_addr                                  "0x001C"
#define  set_SRNN_AccessData_PosCtrl_SRNN_reg(data)                              (*((volatile unsigned int*)SRNN_AccessData_PosCtrl_SRNN_reg)=data)
#define  get_SRNN_AccessData_PosCtrl_SRNN_reg                                    (*((volatile unsigned int*)SRNN_AccessData_PosCtrl_SRNN_reg))
#define  SRNN_AccessData_PosCtrl_SRNN_starty_shift                               (16)
#define  SRNN_AccessData_PosCtrl_SRNN_startx_shift                               (0)
#define  SRNN_AccessData_PosCtrl_SRNN_starty_mask                                (0x0FFF0000)
#define  SRNN_AccessData_PosCtrl_SRNN_startx_mask                                (0x00001FFF)
#define  SRNN_AccessData_PosCtrl_SRNN_starty(data)                               (0x0FFF0000&((data)<<16))
#define  SRNN_AccessData_PosCtrl_SRNN_startx(data)                               (0x00001FFF&(data))
#define  SRNN_AccessData_PosCtrl_SRNN_get_starty(data)                           ((0x0FFF0000&(data))>>16)
#define  SRNN_AccessData_PosCtrl_SRNN_get_startx(data)                           (0x00001FFF&(data))

#define  SRNN_ReadData_DATA_Y1_SRNN                                             0x181AA098
#define  SRNN_ReadData_DATA_Y1_SRNN_reg_addr                                     "0xB81AA098"
#define  SRNN_ReadData_DATA_Y1_SRNN_reg                                          0xB81AA098
#define  SRNN_ReadData_DATA_Y1_SRNN_inst_addr                                    "0x001D"
#define  set_SRNN_ReadData_DATA_Y1_SRNN_reg(data)                                (*((volatile unsigned int*)SRNN_ReadData_DATA_Y1_SRNN_reg)=data)
#define  get_SRNN_ReadData_DATA_Y1_SRNN_reg                                      (*((volatile unsigned int*)SRNN_ReadData_DATA_Y1_SRNN_reg))
#define  SRNN_ReadData_DATA_Y1_SRNN_y01_shift                                    (16)
#define  SRNN_ReadData_DATA_Y1_SRNN_y00_shift                                    (0)
#define  SRNN_ReadData_DATA_Y1_SRNN_y01_mask                                     (0x03FF0000)
#define  SRNN_ReadData_DATA_Y1_SRNN_y00_mask                                     (0x000003FF)
#define  SRNN_ReadData_DATA_Y1_SRNN_y01(data)                                    (0x03FF0000&((data)<<16))
#define  SRNN_ReadData_DATA_Y1_SRNN_y00(data)                                    (0x000003FF&(data))
#define  SRNN_ReadData_DATA_Y1_SRNN_get_y01(data)                                ((0x03FF0000&(data))>>16)
#define  SRNN_ReadData_DATA_Y1_SRNN_get_y00(data)                                (0x000003FF&(data))

#define  SRNN_ReadData_DATA_Y2_SRNN                                             0x181AA09C
#define  SRNN_ReadData_DATA_Y2_SRNN_reg_addr                                     "0xB81AA09C"
#define  SRNN_ReadData_DATA_Y2_SRNN_reg                                          0xB81AA09C
#define  SRNN_ReadData_DATA_Y2_SRNN_inst_addr                                    "0x001E"
#define  set_SRNN_ReadData_DATA_Y2_SRNN_reg(data)                                (*((volatile unsigned int*)SRNN_ReadData_DATA_Y2_SRNN_reg)=data)
#define  get_SRNN_ReadData_DATA_Y2_SRNN_reg                                      (*((volatile unsigned int*)SRNN_ReadData_DATA_Y2_SRNN_reg))
#define  SRNN_ReadData_DATA_Y2_SRNN_y11_shift                                    (16)
#define  SRNN_ReadData_DATA_Y2_SRNN_y10_shift                                    (0)
#define  SRNN_ReadData_DATA_Y2_SRNN_y11_mask                                     (0x03FF0000)
#define  SRNN_ReadData_DATA_Y2_SRNN_y10_mask                                     (0x000003FF)
#define  SRNN_ReadData_DATA_Y2_SRNN_y11(data)                                    (0x03FF0000&((data)<<16))
#define  SRNN_ReadData_DATA_Y2_SRNN_y10(data)                                    (0x000003FF&(data))
#define  SRNN_ReadData_DATA_Y2_SRNN_get_y11(data)                                ((0x03FF0000&(data))>>16)
#define  SRNN_ReadData_DATA_Y2_SRNN_get_y10(data)                                (0x000003FF&(data))

#define  SRNN_ReadData_DATA_C1_SRNN                                             0x181AA0A0
#define  SRNN_ReadData_DATA_C1_SRNN_reg_addr                                     "0xB81AA0A0"
#define  SRNN_ReadData_DATA_C1_SRNN_reg                                          0xB81AA0A0
#define  SRNN_ReadData_DATA_C1_SRNN_inst_addr                                    "0x001F"
#define  set_SRNN_ReadData_DATA_C1_SRNN_reg(data)                                (*((volatile unsigned int*)SRNN_ReadData_DATA_C1_SRNN_reg)=data)
#define  get_SRNN_ReadData_DATA_C1_SRNN_reg                                      (*((volatile unsigned int*)SRNN_ReadData_DATA_C1_SRNN_reg))
#define  SRNN_ReadData_DATA_C1_SRNN_v00_shift                                    (16)
#define  SRNN_ReadData_DATA_C1_SRNN_u00_shift                                    (0)
#define  SRNN_ReadData_DATA_C1_SRNN_v00_mask                                     (0x03FF0000)
#define  SRNN_ReadData_DATA_C1_SRNN_u00_mask                                     (0x000003FF)
#define  SRNN_ReadData_DATA_C1_SRNN_v00(data)                                    (0x03FF0000&((data)<<16))
#define  SRNN_ReadData_DATA_C1_SRNN_u00(data)                                    (0x000003FF&(data))
#define  SRNN_ReadData_DATA_C1_SRNN_get_v00(data)                                ((0x03FF0000&(data))>>16)
#define  SRNN_ReadData_DATA_C1_SRNN_get_u00(data)                                (0x000003FF&(data))

#define  SRNN_ReadData_DATA_C2_SRNN                                             0x181AA0A4
#define  SRNN_ReadData_DATA_C2_SRNN_reg_addr                                     "0xB81AA0A4"
#define  SRNN_ReadData_DATA_C2_SRNN_reg                                          0xB81AA0A4
#define  SRNN_ReadData_DATA_C2_SRNN_inst_addr                                    "0x0020"
#define  set_SRNN_ReadData_DATA_C2_SRNN_reg(data)                                (*((volatile unsigned int*)SRNN_ReadData_DATA_C2_SRNN_reg)=data)
#define  get_SRNN_ReadData_DATA_C2_SRNN_reg                                      (*((volatile unsigned int*)SRNN_ReadData_DATA_C2_SRNN_reg))
#define  SRNN_ReadData_DATA_C2_SRNN_v01_shift                                    (16)
#define  SRNN_ReadData_DATA_C2_SRNN_u01_shift                                    (0)
#define  SRNN_ReadData_DATA_C2_SRNN_v01_mask                                     (0x03FF0000)
#define  SRNN_ReadData_DATA_C2_SRNN_u01_mask                                     (0x000003FF)
#define  SRNN_ReadData_DATA_C2_SRNN_v01(data)                                    (0x03FF0000&((data)<<16))
#define  SRNN_ReadData_DATA_C2_SRNN_u01(data)                                    (0x000003FF&(data))
#define  SRNN_ReadData_DATA_C2_SRNN_get_v01(data)                                ((0x03FF0000&(data))>>16)
#define  SRNN_ReadData_DATA_C2_SRNN_get_u01(data)                                (0x000003FF&(data))

#define  SRNN_ReadData_DATA_C3_SRNN                                             0x181AA0A8
#define  SRNN_ReadData_DATA_C3_SRNN_reg_addr                                     "0xB81AA0A8"
#define  SRNN_ReadData_DATA_C3_SRNN_reg                                          0xB81AA0A8
#define  SRNN_ReadData_DATA_C3_SRNN_inst_addr                                    "0x0021"
#define  set_SRNN_ReadData_DATA_C3_SRNN_reg(data)                                (*((volatile unsigned int*)SRNN_ReadData_DATA_C3_SRNN_reg)=data)
#define  get_SRNN_ReadData_DATA_C3_SRNN_reg                                      (*((volatile unsigned int*)SRNN_ReadData_DATA_C3_SRNN_reg))
#define  SRNN_ReadData_DATA_C3_SRNN_v10_shift                                    (16)
#define  SRNN_ReadData_DATA_C3_SRNN_u10_shift                                    (0)
#define  SRNN_ReadData_DATA_C3_SRNN_v10_mask                                     (0x03FF0000)
#define  SRNN_ReadData_DATA_C3_SRNN_u10_mask                                     (0x000003FF)
#define  SRNN_ReadData_DATA_C3_SRNN_v10(data)                                    (0x03FF0000&((data)<<16))
#define  SRNN_ReadData_DATA_C3_SRNN_u10(data)                                    (0x000003FF&(data))
#define  SRNN_ReadData_DATA_C3_SRNN_get_v10(data)                                ((0x03FF0000&(data))>>16)
#define  SRNN_ReadData_DATA_C3_SRNN_get_u10(data)                                (0x000003FF&(data))

#define  SRNN_ReadData_DATA_C4_SRNN                                             0x181AA0AC
#define  SRNN_ReadData_DATA_C4_SRNN_reg_addr                                     "0xB81AA0AC"
#define  SRNN_ReadData_DATA_C4_SRNN_reg                                          0xB81AA0AC
#define  SRNN_ReadData_DATA_C4_SRNN_inst_addr                                    "0x0022"
#define  set_SRNN_ReadData_DATA_C4_SRNN_reg(data)                                (*((volatile unsigned int*)SRNN_ReadData_DATA_C4_SRNN_reg)=data)
#define  get_SRNN_ReadData_DATA_C4_SRNN_reg                                      (*((volatile unsigned int*)SRNN_ReadData_DATA_C4_SRNN_reg))
#define  SRNN_ReadData_DATA_C4_SRNN_v11_shift                                    (16)
#define  SRNN_ReadData_DATA_C4_SRNN_u11_shift                                    (0)
#define  SRNN_ReadData_DATA_C4_SRNN_v11_mask                                     (0x03FF0000)
#define  SRNN_ReadData_DATA_C4_SRNN_u11_mask                                     (0x000003FF)
#define  SRNN_ReadData_DATA_C4_SRNN_v11(data)                                    (0x03FF0000&((data)<<16))
#define  SRNN_ReadData_DATA_C4_SRNN_u11(data)                                    (0x000003FF&(data))
#define  SRNN_ReadData_DATA_C4_SRNN_get_v11(data)                                ((0x03FF0000&(data))>>16)
#define  SRNN_ReadData_DATA_C4_SRNN_get_u11(data)                                (0x000003FF&(data))

#define  SRNN_WriteData_DATA_SRNN                                               0x181AA0B0
#define  SRNN_WriteData_DATA_SRNN_reg_addr                                       "0xB81AA0B0"
#define  SRNN_WriteData_DATA_SRNN_reg                                            0xB81AA0B0
#define  SRNN_WriteData_DATA_SRNN_inst_addr                                      "0x0023"
#define  set_SRNN_WriteData_DATA_SRNN_reg(data)                                  (*((volatile unsigned int*)SRNN_WriteData_DATA_SRNN_reg)=data)
#define  get_SRNN_WriteData_DATA_SRNN_reg                                        (*((volatile unsigned int*)SRNN_WriteData_DATA_SRNN_reg))
#define  SRNN_WriteData_DATA_SRNN_v_shift                                        (8)
#define  SRNN_WriteData_DATA_SRNN_u_shift                                        (4)
#define  SRNN_WriteData_DATA_SRNN_y_shift                                        (0)
#define  SRNN_WriteData_DATA_SRNN_v_mask                                         (0x00000F00)
#define  SRNN_WriteData_DATA_SRNN_u_mask                                         (0x000000F0)
#define  SRNN_WriteData_DATA_SRNN_y_mask                                         (0x0000000F)
#define  SRNN_WriteData_DATA_SRNN_v(data)                                        (0x00000F00&((data)<<8))
#define  SRNN_WriteData_DATA_SRNN_u(data)                                        (0x000000F0&((data)<<4))
#define  SRNN_WriteData_DATA_SRNN_y(data)                                        (0x0000000F&(data))
#define  SRNN_WriteData_DATA_SRNN_get_v(data)                                    ((0x00000F00&(data))>>8)
#define  SRNN_WriteData_DATA_SRNN_get_u(data)                                    ((0x000000F0&(data))>>4)
#define  SRNN_WriteData_DATA_SRNN_get_y(data)                                    (0x0000000F&(data))

#define  SRNN_wdsr_layer1_3x3_weights_1_00                                      0x181AB000
#define  SRNN_wdsr_layer1_3x3_weights_1_00_reg_addr                              "0xB81AB000"
#define  SRNN_wdsr_layer1_3x3_weights_1_00_reg                                   0xB81AB000
#define  SRNN_wdsr_layer1_3x3_weights_1_00_inst_addr                             "0x0024"
#define  set_SRNN_wdsr_layer1_3x3_weights_1_00_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_1_00_reg)=data)
#define  get_SRNN_wdsr_layer1_3x3_weights_1_00_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_1_00_reg))
#define  SRNN_wdsr_layer1_3x3_weights_1_00_layer1_weight_00_shift                (0)
#define  SRNN_wdsr_layer1_3x3_weights_1_00_layer1_weight_00_mask                 (0x000007FF)
#define  SRNN_wdsr_layer1_3x3_weights_1_00_layer1_weight_00(data)                (0x000007FF&(data))
#define  SRNN_wdsr_layer1_3x3_weights_1_00_get_layer1_weight_00(data)            (0x000007FF&(data))

#define  SRNN_wdsr_layer1_3x3_weights_1_01                                      0x181AB004
#define  SRNN_wdsr_layer1_3x3_weights_1_01_reg_addr                              "0xB81AB004"
#define  SRNN_wdsr_layer1_3x3_weights_1_01_reg                                   0xB81AB004
#define  SRNN_wdsr_layer1_3x3_weights_1_01_inst_addr                             "0x0025"
#define  set_SRNN_wdsr_layer1_3x3_weights_1_01_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_1_01_reg)=data)
#define  get_SRNN_wdsr_layer1_3x3_weights_1_01_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_1_01_reg))
#define  SRNN_wdsr_layer1_3x3_weights_1_01_layer1_weight_01_shift                (0)
#define  SRNN_wdsr_layer1_3x3_weights_1_01_layer1_weight_01_mask                 (0x000007FF)
#define  SRNN_wdsr_layer1_3x3_weights_1_01_layer1_weight_01(data)                (0x000007FF&(data))
#define  SRNN_wdsr_layer1_3x3_weights_1_01_get_layer1_weight_01(data)            (0x000007FF&(data))

#define  SRNN_wdsr_layer1_3x3_weights_1_02                                      0x181AB008
#define  SRNN_wdsr_layer1_3x3_weights_1_02_reg_addr                              "0xB81AB008"
#define  SRNN_wdsr_layer1_3x3_weights_1_02_reg                                   0xB81AB008
#define  SRNN_wdsr_layer1_3x3_weights_1_02_inst_addr                             "0x0026"
#define  set_SRNN_wdsr_layer1_3x3_weights_1_02_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_1_02_reg)=data)
#define  get_SRNN_wdsr_layer1_3x3_weights_1_02_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_1_02_reg))
#define  SRNN_wdsr_layer1_3x3_weights_1_02_layer1_weight_02_shift                (0)
#define  SRNN_wdsr_layer1_3x3_weights_1_02_layer1_weight_02_mask                 (0x000007FF)
#define  SRNN_wdsr_layer1_3x3_weights_1_02_layer1_weight_02(data)                (0x000007FF&(data))
#define  SRNN_wdsr_layer1_3x3_weights_1_02_get_layer1_weight_02(data)            (0x000007FF&(data))

#define  SRNN_wdsr_layer1_3x3_weights_1_10                                      0x181AB00C
#define  SRNN_wdsr_layer1_3x3_weights_1_10_reg_addr                              "0xB81AB00C"
#define  SRNN_wdsr_layer1_3x3_weights_1_10_reg                                   0xB81AB00C
#define  SRNN_wdsr_layer1_3x3_weights_1_10_inst_addr                             "0x0027"
#define  set_SRNN_wdsr_layer1_3x3_weights_1_10_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_1_10_reg)=data)
#define  get_SRNN_wdsr_layer1_3x3_weights_1_10_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_1_10_reg))
#define  SRNN_wdsr_layer1_3x3_weights_1_10_layer1_weight_10_shift                (0)
#define  SRNN_wdsr_layer1_3x3_weights_1_10_layer1_weight_10_mask                 (0x000007FF)
#define  SRNN_wdsr_layer1_3x3_weights_1_10_layer1_weight_10(data)                (0x000007FF&(data))
#define  SRNN_wdsr_layer1_3x3_weights_1_10_get_layer1_weight_10(data)            (0x000007FF&(data))

#define  SRNN_wdsr_layer1_3x3_weights_1_11                                      0x181AB010
#define  SRNN_wdsr_layer1_3x3_weights_1_11_reg_addr                              "0xB81AB010"
#define  SRNN_wdsr_layer1_3x3_weights_1_11_reg                                   0xB81AB010
#define  SRNN_wdsr_layer1_3x3_weights_1_11_inst_addr                             "0x0028"
#define  set_SRNN_wdsr_layer1_3x3_weights_1_11_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_1_11_reg)=data)
#define  get_SRNN_wdsr_layer1_3x3_weights_1_11_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_1_11_reg))
#define  SRNN_wdsr_layer1_3x3_weights_1_11_layer1_weight_11_shift                (0)
#define  SRNN_wdsr_layer1_3x3_weights_1_11_layer1_weight_11_mask                 (0x000007FF)
#define  SRNN_wdsr_layer1_3x3_weights_1_11_layer1_weight_11(data)                (0x000007FF&(data))
#define  SRNN_wdsr_layer1_3x3_weights_1_11_get_layer1_weight_11(data)            (0x000007FF&(data))

#define  SRNN_wdsr_layer1_3x3_weights_1_12                                      0x181AB014
#define  SRNN_wdsr_layer1_3x3_weights_1_12_reg_addr                              "0xB81AB014"
#define  SRNN_wdsr_layer1_3x3_weights_1_12_reg                                   0xB81AB014
#define  SRNN_wdsr_layer1_3x3_weights_1_12_inst_addr                             "0x0029"
#define  set_SRNN_wdsr_layer1_3x3_weights_1_12_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_1_12_reg)=data)
#define  get_SRNN_wdsr_layer1_3x3_weights_1_12_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_1_12_reg))
#define  SRNN_wdsr_layer1_3x3_weights_1_12_layer1_weight_12_shift                (0)
#define  SRNN_wdsr_layer1_3x3_weights_1_12_layer1_weight_12_mask                 (0x000007FF)
#define  SRNN_wdsr_layer1_3x3_weights_1_12_layer1_weight_12(data)                (0x000007FF&(data))
#define  SRNN_wdsr_layer1_3x3_weights_1_12_get_layer1_weight_12(data)            (0x000007FF&(data))

#define  SRNN_wdsr_layer1_3x3_weights_1_20                                      0x181AB018
#define  SRNN_wdsr_layer1_3x3_weights_1_20_reg_addr                              "0xB81AB018"
#define  SRNN_wdsr_layer1_3x3_weights_1_20_reg                                   0xB81AB018
#define  SRNN_wdsr_layer1_3x3_weights_1_20_inst_addr                             "0x002A"
#define  set_SRNN_wdsr_layer1_3x3_weights_1_20_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_1_20_reg)=data)
#define  get_SRNN_wdsr_layer1_3x3_weights_1_20_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_1_20_reg))
#define  SRNN_wdsr_layer1_3x3_weights_1_20_layer1_weight_20_shift                (0)
#define  SRNN_wdsr_layer1_3x3_weights_1_20_layer1_weight_20_mask                 (0x000007FF)
#define  SRNN_wdsr_layer1_3x3_weights_1_20_layer1_weight_20(data)                (0x000007FF&(data))
#define  SRNN_wdsr_layer1_3x3_weights_1_20_get_layer1_weight_20(data)            (0x000007FF&(data))

#define  SRNN_wdsr_layer1_3x3_weights_1_21                                      0x181AB01C
#define  SRNN_wdsr_layer1_3x3_weights_1_21_reg_addr                              "0xB81AB01C"
#define  SRNN_wdsr_layer1_3x3_weights_1_21_reg                                   0xB81AB01C
#define  SRNN_wdsr_layer1_3x3_weights_1_21_inst_addr                             "0x002B"
#define  set_SRNN_wdsr_layer1_3x3_weights_1_21_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_1_21_reg)=data)
#define  get_SRNN_wdsr_layer1_3x3_weights_1_21_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_1_21_reg))
#define  SRNN_wdsr_layer1_3x3_weights_1_21_layer1_weight_21_shift                (0)
#define  SRNN_wdsr_layer1_3x3_weights_1_21_layer1_weight_21_mask                 (0x000007FF)
#define  SRNN_wdsr_layer1_3x3_weights_1_21_layer1_weight_21(data)                (0x000007FF&(data))
#define  SRNN_wdsr_layer1_3x3_weights_1_21_get_layer1_weight_21(data)            (0x000007FF&(data))

#define  SRNN_wdsr_layer1_3x3_weights_1_22                                      0x181AB020
#define  SRNN_wdsr_layer1_3x3_weights_1_22_reg_addr                              "0xB81AB020"
#define  SRNN_wdsr_layer1_3x3_weights_1_22_reg                                   0xB81AB020
#define  SRNN_wdsr_layer1_3x3_weights_1_22_inst_addr                             "0x002C"
#define  set_SRNN_wdsr_layer1_3x3_weights_1_22_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_1_22_reg)=data)
#define  get_SRNN_wdsr_layer1_3x3_weights_1_22_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_1_22_reg))
#define  SRNN_wdsr_layer1_3x3_weights_1_22_layer1_weight_22_shift                (0)
#define  SRNN_wdsr_layer1_3x3_weights_1_22_layer1_weight_22_mask                 (0x000007FF)
#define  SRNN_wdsr_layer1_3x3_weights_1_22_layer1_weight_22(data)                (0x000007FF&(data))
#define  SRNN_wdsr_layer1_3x3_weights_1_22_get_layer1_weight_22(data)            (0x000007FF&(data))

#define  SRNN_wdsr_layer1_3x3_weights_2_00                                      0x181AB024
#define  SRNN_wdsr_layer1_3x3_weights_2_00_reg_addr                              "0xB81AB024"
#define  SRNN_wdsr_layer1_3x3_weights_2_00_reg                                   0xB81AB024
#define  SRNN_wdsr_layer1_3x3_weights_2_00_inst_addr                             "0x002D"
#define  set_SRNN_wdsr_layer1_3x3_weights_2_00_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_2_00_reg)=data)
#define  get_SRNN_wdsr_layer1_3x3_weights_2_00_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_2_00_reg))
#define  SRNN_wdsr_layer1_3x3_weights_2_00_layer1_weight_00_shift                (0)
#define  SRNN_wdsr_layer1_3x3_weights_2_00_layer1_weight_00_mask                 (0x000007FF)
#define  SRNN_wdsr_layer1_3x3_weights_2_00_layer1_weight_00(data)                (0x000007FF&(data))
#define  SRNN_wdsr_layer1_3x3_weights_2_00_get_layer1_weight_00(data)            (0x000007FF&(data))

#define  SRNN_wdsr_layer1_3x3_weights_2_01                                      0x181AB028
#define  SRNN_wdsr_layer1_3x3_weights_2_01_reg_addr                              "0xB81AB028"
#define  SRNN_wdsr_layer1_3x3_weights_2_01_reg                                   0xB81AB028
#define  SRNN_wdsr_layer1_3x3_weights_2_01_inst_addr                             "0x002E"
#define  set_SRNN_wdsr_layer1_3x3_weights_2_01_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_2_01_reg)=data)
#define  get_SRNN_wdsr_layer1_3x3_weights_2_01_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_2_01_reg))
#define  SRNN_wdsr_layer1_3x3_weights_2_01_layer1_weight_01_shift                (0)
#define  SRNN_wdsr_layer1_3x3_weights_2_01_layer1_weight_01_mask                 (0x000007FF)
#define  SRNN_wdsr_layer1_3x3_weights_2_01_layer1_weight_01(data)                (0x000007FF&(data))
#define  SRNN_wdsr_layer1_3x3_weights_2_01_get_layer1_weight_01(data)            (0x000007FF&(data))

#define  SRNN_wdsr_layer1_3x3_weights_2_02                                      0x181AB02C
#define  SRNN_wdsr_layer1_3x3_weights_2_02_reg_addr                              "0xB81AB02C"
#define  SRNN_wdsr_layer1_3x3_weights_2_02_reg                                   0xB81AB02C
#define  SRNN_wdsr_layer1_3x3_weights_2_02_inst_addr                             "0x002F"
#define  set_SRNN_wdsr_layer1_3x3_weights_2_02_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_2_02_reg)=data)
#define  get_SRNN_wdsr_layer1_3x3_weights_2_02_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_2_02_reg))
#define  SRNN_wdsr_layer1_3x3_weights_2_02_layer1_weight_02_shift                (0)
#define  SRNN_wdsr_layer1_3x3_weights_2_02_layer1_weight_02_mask                 (0x000007FF)
#define  SRNN_wdsr_layer1_3x3_weights_2_02_layer1_weight_02(data)                (0x000007FF&(data))
#define  SRNN_wdsr_layer1_3x3_weights_2_02_get_layer1_weight_02(data)            (0x000007FF&(data))

#define  SRNN_wdsr_layer1_3x3_weights_2_10                                      0x181AB030
#define  SRNN_wdsr_layer1_3x3_weights_2_10_reg_addr                              "0xB81AB030"
#define  SRNN_wdsr_layer1_3x3_weights_2_10_reg                                   0xB81AB030
#define  SRNN_wdsr_layer1_3x3_weights_2_10_inst_addr                             "0x0030"
#define  set_SRNN_wdsr_layer1_3x3_weights_2_10_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_2_10_reg)=data)
#define  get_SRNN_wdsr_layer1_3x3_weights_2_10_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_2_10_reg))
#define  SRNN_wdsr_layer1_3x3_weights_2_10_layer1_weight_10_shift                (0)
#define  SRNN_wdsr_layer1_3x3_weights_2_10_layer1_weight_10_mask                 (0x000007FF)
#define  SRNN_wdsr_layer1_3x3_weights_2_10_layer1_weight_10(data)                (0x000007FF&(data))
#define  SRNN_wdsr_layer1_3x3_weights_2_10_get_layer1_weight_10(data)            (0x000007FF&(data))

#define  SRNN_wdsr_layer1_3x3_weights_2_11                                      0x181AB034
#define  SRNN_wdsr_layer1_3x3_weights_2_11_reg_addr                              "0xB81AB034"
#define  SRNN_wdsr_layer1_3x3_weights_2_11_reg                                   0xB81AB034
#define  SRNN_wdsr_layer1_3x3_weights_2_11_inst_addr                             "0x0031"
#define  set_SRNN_wdsr_layer1_3x3_weights_2_11_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_2_11_reg)=data)
#define  get_SRNN_wdsr_layer1_3x3_weights_2_11_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_2_11_reg))
#define  SRNN_wdsr_layer1_3x3_weights_2_11_layer1_weight_11_shift                (0)
#define  SRNN_wdsr_layer1_3x3_weights_2_11_layer1_weight_11_mask                 (0x000007FF)
#define  SRNN_wdsr_layer1_3x3_weights_2_11_layer1_weight_11(data)                (0x000007FF&(data))
#define  SRNN_wdsr_layer1_3x3_weights_2_11_get_layer1_weight_11(data)            (0x000007FF&(data))

#define  SRNN_wdsr_layer1_3x3_weights_2_12                                      0x181AB038
#define  SRNN_wdsr_layer1_3x3_weights_2_12_reg_addr                              "0xB81AB038"
#define  SRNN_wdsr_layer1_3x3_weights_2_12_reg                                   0xB81AB038
#define  SRNN_wdsr_layer1_3x3_weights_2_12_inst_addr                             "0x0032"
#define  set_SRNN_wdsr_layer1_3x3_weights_2_12_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_2_12_reg)=data)
#define  get_SRNN_wdsr_layer1_3x3_weights_2_12_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_2_12_reg))
#define  SRNN_wdsr_layer1_3x3_weights_2_12_layer1_weight_12_shift                (0)
#define  SRNN_wdsr_layer1_3x3_weights_2_12_layer1_weight_12_mask                 (0x000007FF)
#define  SRNN_wdsr_layer1_3x3_weights_2_12_layer1_weight_12(data)                (0x000007FF&(data))
#define  SRNN_wdsr_layer1_3x3_weights_2_12_get_layer1_weight_12(data)            (0x000007FF&(data))

#define  SRNN_wdsr_layer1_3x3_weights_2_20                                      0x181AB03C
#define  SRNN_wdsr_layer1_3x3_weights_2_20_reg_addr                              "0xB81AB03C"
#define  SRNN_wdsr_layer1_3x3_weights_2_20_reg                                   0xB81AB03C
#define  SRNN_wdsr_layer1_3x3_weights_2_20_inst_addr                             "0x0033"
#define  set_SRNN_wdsr_layer1_3x3_weights_2_20_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_2_20_reg)=data)
#define  get_SRNN_wdsr_layer1_3x3_weights_2_20_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_2_20_reg))
#define  SRNN_wdsr_layer1_3x3_weights_2_20_layer1_weight_20_shift                (0)
#define  SRNN_wdsr_layer1_3x3_weights_2_20_layer1_weight_20_mask                 (0x000007FF)
#define  SRNN_wdsr_layer1_3x3_weights_2_20_layer1_weight_20(data)                (0x000007FF&(data))
#define  SRNN_wdsr_layer1_3x3_weights_2_20_get_layer1_weight_20(data)            (0x000007FF&(data))

#define  SRNN_wdsr_layer1_3x3_weights_2_21                                      0x181AB040
#define  SRNN_wdsr_layer1_3x3_weights_2_21_reg_addr                              "0xB81AB040"
#define  SRNN_wdsr_layer1_3x3_weights_2_21_reg                                   0xB81AB040
#define  SRNN_wdsr_layer1_3x3_weights_2_21_inst_addr                             "0x0034"
#define  set_SRNN_wdsr_layer1_3x3_weights_2_21_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_2_21_reg)=data)
#define  get_SRNN_wdsr_layer1_3x3_weights_2_21_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_2_21_reg))
#define  SRNN_wdsr_layer1_3x3_weights_2_21_layer1_weight_21_shift                (0)
#define  SRNN_wdsr_layer1_3x3_weights_2_21_layer1_weight_21_mask                 (0x000007FF)
#define  SRNN_wdsr_layer1_3x3_weights_2_21_layer1_weight_21(data)                (0x000007FF&(data))
#define  SRNN_wdsr_layer1_3x3_weights_2_21_get_layer1_weight_21(data)            (0x000007FF&(data))

#define  SRNN_wdsr_layer1_3x3_weights_2_22                                      0x181AB044
#define  SRNN_wdsr_layer1_3x3_weights_2_22_reg_addr                              "0xB81AB044"
#define  SRNN_wdsr_layer1_3x3_weights_2_22_reg                                   0xB81AB044
#define  SRNN_wdsr_layer1_3x3_weights_2_22_inst_addr                             "0x0035"
#define  set_SRNN_wdsr_layer1_3x3_weights_2_22_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_2_22_reg)=data)
#define  get_SRNN_wdsr_layer1_3x3_weights_2_22_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_2_22_reg))
#define  SRNN_wdsr_layer1_3x3_weights_2_22_layer1_weight_22_shift                (0)
#define  SRNN_wdsr_layer1_3x3_weights_2_22_layer1_weight_22_mask                 (0x000007FF)
#define  SRNN_wdsr_layer1_3x3_weights_2_22_layer1_weight_22(data)                (0x000007FF&(data))
#define  SRNN_wdsr_layer1_3x3_weights_2_22_get_layer1_weight_22(data)            (0x000007FF&(data))

#define  SRNN_wdsr_layer1_3x3_weights_3_00                                      0x181AB048
#define  SRNN_wdsr_layer1_3x3_weights_3_00_reg_addr                              "0xB81AB048"
#define  SRNN_wdsr_layer1_3x3_weights_3_00_reg                                   0xB81AB048
#define  SRNN_wdsr_layer1_3x3_weights_3_00_inst_addr                             "0x0036"
#define  set_SRNN_wdsr_layer1_3x3_weights_3_00_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_3_00_reg)=data)
#define  get_SRNN_wdsr_layer1_3x3_weights_3_00_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_3_00_reg))
#define  SRNN_wdsr_layer1_3x3_weights_3_00_layer1_weight_00_shift                (0)
#define  SRNN_wdsr_layer1_3x3_weights_3_00_layer1_weight_00_mask                 (0x000007FF)
#define  SRNN_wdsr_layer1_3x3_weights_3_00_layer1_weight_00(data)                (0x000007FF&(data))
#define  SRNN_wdsr_layer1_3x3_weights_3_00_get_layer1_weight_00(data)            (0x000007FF&(data))

#define  SRNN_wdsr_layer1_3x3_weights_3_01                                      0x181AB04C
#define  SRNN_wdsr_layer1_3x3_weights_3_01_reg_addr                              "0xB81AB04C"
#define  SRNN_wdsr_layer1_3x3_weights_3_01_reg                                   0xB81AB04C
#define  SRNN_wdsr_layer1_3x3_weights_3_01_inst_addr                             "0x0037"
#define  set_SRNN_wdsr_layer1_3x3_weights_3_01_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_3_01_reg)=data)
#define  get_SRNN_wdsr_layer1_3x3_weights_3_01_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_3_01_reg))
#define  SRNN_wdsr_layer1_3x3_weights_3_01_layer1_weight_01_shift                (0)
#define  SRNN_wdsr_layer1_3x3_weights_3_01_layer1_weight_01_mask                 (0x000007FF)
#define  SRNN_wdsr_layer1_3x3_weights_3_01_layer1_weight_01(data)                (0x000007FF&(data))
#define  SRNN_wdsr_layer1_3x3_weights_3_01_get_layer1_weight_01(data)            (0x000007FF&(data))

#define  SRNN_wdsr_layer1_3x3_weights_3_02                                      0x181AB050
#define  SRNN_wdsr_layer1_3x3_weights_3_02_reg_addr                              "0xB81AB050"
#define  SRNN_wdsr_layer1_3x3_weights_3_02_reg                                   0xB81AB050
#define  SRNN_wdsr_layer1_3x3_weights_3_02_inst_addr                             "0x0038"
#define  set_SRNN_wdsr_layer1_3x3_weights_3_02_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_3_02_reg)=data)
#define  get_SRNN_wdsr_layer1_3x3_weights_3_02_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_3_02_reg))
#define  SRNN_wdsr_layer1_3x3_weights_3_02_layer1_weight_02_shift                (0)
#define  SRNN_wdsr_layer1_3x3_weights_3_02_layer1_weight_02_mask                 (0x000007FF)
#define  SRNN_wdsr_layer1_3x3_weights_3_02_layer1_weight_02(data)                (0x000007FF&(data))
#define  SRNN_wdsr_layer1_3x3_weights_3_02_get_layer1_weight_02(data)            (0x000007FF&(data))

#define  SRNN_wdsr_layer1_3x3_weights_3_10                                      0x181AB054
#define  SRNN_wdsr_layer1_3x3_weights_3_10_reg_addr                              "0xB81AB054"
#define  SRNN_wdsr_layer1_3x3_weights_3_10_reg                                   0xB81AB054
#define  SRNN_wdsr_layer1_3x3_weights_3_10_inst_addr                             "0x0039"
#define  set_SRNN_wdsr_layer1_3x3_weights_3_10_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_3_10_reg)=data)
#define  get_SRNN_wdsr_layer1_3x3_weights_3_10_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_3_10_reg))
#define  SRNN_wdsr_layer1_3x3_weights_3_10_layer1_weight_10_shift                (0)
#define  SRNN_wdsr_layer1_3x3_weights_3_10_layer1_weight_10_mask                 (0x000007FF)
#define  SRNN_wdsr_layer1_3x3_weights_3_10_layer1_weight_10(data)                (0x000007FF&(data))
#define  SRNN_wdsr_layer1_3x3_weights_3_10_get_layer1_weight_10(data)            (0x000007FF&(data))

#define  SRNN_wdsr_layer1_3x3_weights_3_11                                      0x181AB058
#define  SRNN_wdsr_layer1_3x3_weights_3_11_reg_addr                              "0xB81AB058"
#define  SRNN_wdsr_layer1_3x3_weights_3_11_reg                                   0xB81AB058
#define  SRNN_wdsr_layer1_3x3_weights_3_11_inst_addr                             "0x003A"
#define  set_SRNN_wdsr_layer1_3x3_weights_3_11_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_3_11_reg)=data)
#define  get_SRNN_wdsr_layer1_3x3_weights_3_11_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_3_11_reg))
#define  SRNN_wdsr_layer1_3x3_weights_3_11_layer1_weight_11_shift                (0)
#define  SRNN_wdsr_layer1_3x3_weights_3_11_layer1_weight_11_mask                 (0x000007FF)
#define  SRNN_wdsr_layer1_3x3_weights_3_11_layer1_weight_11(data)                (0x000007FF&(data))
#define  SRNN_wdsr_layer1_3x3_weights_3_11_get_layer1_weight_11(data)            (0x000007FF&(data))

#define  SRNN_wdsr_layer1_3x3_weights_3_12                                      0x181AB05C
#define  SRNN_wdsr_layer1_3x3_weights_3_12_reg_addr                              "0xB81AB05C"
#define  SRNN_wdsr_layer1_3x3_weights_3_12_reg                                   0xB81AB05C
#define  SRNN_wdsr_layer1_3x3_weights_3_12_inst_addr                             "0x003B"
#define  set_SRNN_wdsr_layer1_3x3_weights_3_12_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_3_12_reg)=data)
#define  get_SRNN_wdsr_layer1_3x3_weights_3_12_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_3_12_reg))
#define  SRNN_wdsr_layer1_3x3_weights_3_12_layer1_weight_12_shift                (0)
#define  SRNN_wdsr_layer1_3x3_weights_3_12_layer1_weight_12_mask                 (0x000007FF)
#define  SRNN_wdsr_layer1_3x3_weights_3_12_layer1_weight_12(data)                (0x000007FF&(data))
#define  SRNN_wdsr_layer1_3x3_weights_3_12_get_layer1_weight_12(data)            (0x000007FF&(data))

#define  SRNN_wdsr_layer1_3x3_weights_3_20                                      0x181AB060
#define  SRNN_wdsr_layer1_3x3_weights_3_20_reg_addr                              "0xB81AB060"
#define  SRNN_wdsr_layer1_3x3_weights_3_20_reg                                   0xB81AB060
#define  SRNN_wdsr_layer1_3x3_weights_3_20_inst_addr                             "0x003C"
#define  set_SRNN_wdsr_layer1_3x3_weights_3_20_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_3_20_reg)=data)
#define  get_SRNN_wdsr_layer1_3x3_weights_3_20_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_3_20_reg))
#define  SRNN_wdsr_layer1_3x3_weights_3_20_layer1_weight_20_shift                (0)
#define  SRNN_wdsr_layer1_3x3_weights_3_20_layer1_weight_20_mask                 (0x000007FF)
#define  SRNN_wdsr_layer1_3x3_weights_3_20_layer1_weight_20(data)                (0x000007FF&(data))
#define  SRNN_wdsr_layer1_3x3_weights_3_20_get_layer1_weight_20(data)            (0x000007FF&(data))

#define  SRNN_wdsr_layer1_3x3_weights_3_21                                      0x181AB064
#define  SRNN_wdsr_layer1_3x3_weights_3_21_reg_addr                              "0xB81AB064"
#define  SRNN_wdsr_layer1_3x3_weights_3_21_reg                                   0xB81AB064
#define  SRNN_wdsr_layer1_3x3_weights_3_21_inst_addr                             "0x003D"
#define  set_SRNN_wdsr_layer1_3x3_weights_3_21_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_3_21_reg)=data)
#define  get_SRNN_wdsr_layer1_3x3_weights_3_21_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_3_21_reg))
#define  SRNN_wdsr_layer1_3x3_weights_3_21_layer1_weight_21_shift                (0)
#define  SRNN_wdsr_layer1_3x3_weights_3_21_layer1_weight_21_mask                 (0x000007FF)
#define  SRNN_wdsr_layer1_3x3_weights_3_21_layer1_weight_21(data)                (0x000007FF&(data))
#define  SRNN_wdsr_layer1_3x3_weights_3_21_get_layer1_weight_21(data)            (0x000007FF&(data))

#define  SRNN_wdsr_layer1_3x3_weights_3_22                                      0x181AB068
#define  SRNN_wdsr_layer1_3x3_weights_3_22_reg_addr                              "0xB81AB068"
#define  SRNN_wdsr_layer1_3x3_weights_3_22_reg                                   0xB81AB068
#define  SRNN_wdsr_layer1_3x3_weights_3_22_inst_addr                             "0x003E"
#define  set_SRNN_wdsr_layer1_3x3_weights_3_22_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_3_22_reg)=data)
#define  get_SRNN_wdsr_layer1_3x3_weights_3_22_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_3_22_reg))
#define  SRNN_wdsr_layer1_3x3_weights_3_22_layer1_weight_22_shift                (0)
#define  SRNN_wdsr_layer1_3x3_weights_3_22_layer1_weight_22_mask                 (0x000007FF)
#define  SRNN_wdsr_layer1_3x3_weights_3_22_layer1_weight_22(data)                (0x000007FF&(data))
#define  SRNN_wdsr_layer1_3x3_weights_3_22_get_layer1_weight_22(data)            (0x000007FF&(data))

#define  SRNN_wdsr_layer1_3x3_weights_4_00                                      0x181AB06C
#define  SRNN_wdsr_layer1_3x3_weights_4_00_reg_addr                              "0xB81AB06C"
#define  SRNN_wdsr_layer1_3x3_weights_4_00_reg                                   0xB81AB06C
#define  SRNN_wdsr_layer1_3x3_weights_4_00_inst_addr                             "0x003F"
#define  set_SRNN_wdsr_layer1_3x3_weights_4_00_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_4_00_reg)=data)
#define  get_SRNN_wdsr_layer1_3x3_weights_4_00_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_4_00_reg))
#define  SRNN_wdsr_layer1_3x3_weights_4_00_layer1_weight_00_shift                (0)
#define  SRNN_wdsr_layer1_3x3_weights_4_00_layer1_weight_00_mask                 (0x000007FF)
#define  SRNN_wdsr_layer1_3x3_weights_4_00_layer1_weight_00(data)                (0x000007FF&(data))
#define  SRNN_wdsr_layer1_3x3_weights_4_00_get_layer1_weight_00(data)            (0x000007FF&(data))

#define  SRNN_wdsr_layer1_3x3_weights_4_01                                      0x181AB070
#define  SRNN_wdsr_layer1_3x3_weights_4_01_reg_addr                              "0xB81AB070"
#define  SRNN_wdsr_layer1_3x3_weights_4_01_reg                                   0xB81AB070
#define  SRNN_wdsr_layer1_3x3_weights_4_01_inst_addr                             "0x0040"
#define  set_SRNN_wdsr_layer1_3x3_weights_4_01_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_4_01_reg)=data)
#define  get_SRNN_wdsr_layer1_3x3_weights_4_01_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_4_01_reg))
#define  SRNN_wdsr_layer1_3x3_weights_4_01_layer1_weight_01_shift                (0)
#define  SRNN_wdsr_layer1_3x3_weights_4_01_layer1_weight_01_mask                 (0x000007FF)
#define  SRNN_wdsr_layer1_3x3_weights_4_01_layer1_weight_01(data)                (0x000007FF&(data))
#define  SRNN_wdsr_layer1_3x3_weights_4_01_get_layer1_weight_01(data)            (0x000007FF&(data))

#define  SRNN_wdsr_layer1_3x3_weights_4_02                                      0x181AB074
#define  SRNN_wdsr_layer1_3x3_weights_4_02_reg_addr                              "0xB81AB074"
#define  SRNN_wdsr_layer1_3x3_weights_4_02_reg                                   0xB81AB074
#define  SRNN_wdsr_layer1_3x3_weights_4_02_inst_addr                             "0x0041"
#define  set_SRNN_wdsr_layer1_3x3_weights_4_02_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_4_02_reg)=data)
#define  get_SRNN_wdsr_layer1_3x3_weights_4_02_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_4_02_reg))
#define  SRNN_wdsr_layer1_3x3_weights_4_02_layer1_weight_02_shift                (0)
#define  SRNN_wdsr_layer1_3x3_weights_4_02_layer1_weight_02_mask                 (0x000007FF)
#define  SRNN_wdsr_layer1_3x3_weights_4_02_layer1_weight_02(data)                (0x000007FF&(data))
#define  SRNN_wdsr_layer1_3x3_weights_4_02_get_layer1_weight_02(data)            (0x000007FF&(data))

#define  SRNN_wdsr_layer1_3x3_weights_4_10                                      0x181AB078
#define  SRNN_wdsr_layer1_3x3_weights_4_10_reg_addr                              "0xB81AB078"
#define  SRNN_wdsr_layer1_3x3_weights_4_10_reg                                   0xB81AB078
#define  SRNN_wdsr_layer1_3x3_weights_4_10_inst_addr                             "0x0042"
#define  set_SRNN_wdsr_layer1_3x3_weights_4_10_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_4_10_reg)=data)
#define  get_SRNN_wdsr_layer1_3x3_weights_4_10_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_4_10_reg))
#define  SRNN_wdsr_layer1_3x3_weights_4_10_layer1_weight_10_shift                (0)
#define  SRNN_wdsr_layer1_3x3_weights_4_10_layer1_weight_10_mask                 (0x000007FF)
#define  SRNN_wdsr_layer1_3x3_weights_4_10_layer1_weight_10(data)                (0x000007FF&(data))
#define  SRNN_wdsr_layer1_3x3_weights_4_10_get_layer1_weight_10(data)            (0x000007FF&(data))

#define  SRNN_wdsr_layer1_3x3_weights_4_11                                      0x181AB07C
#define  SRNN_wdsr_layer1_3x3_weights_4_11_reg_addr                              "0xB81AB07C"
#define  SRNN_wdsr_layer1_3x3_weights_4_11_reg                                   0xB81AB07C
#define  SRNN_wdsr_layer1_3x3_weights_4_11_inst_addr                             "0x0043"
#define  set_SRNN_wdsr_layer1_3x3_weights_4_11_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_4_11_reg)=data)
#define  get_SRNN_wdsr_layer1_3x3_weights_4_11_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_4_11_reg))
#define  SRNN_wdsr_layer1_3x3_weights_4_11_layer1_weight_11_shift                (0)
#define  SRNN_wdsr_layer1_3x3_weights_4_11_layer1_weight_11_mask                 (0x000007FF)
#define  SRNN_wdsr_layer1_3x3_weights_4_11_layer1_weight_11(data)                (0x000007FF&(data))
#define  SRNN_wdsr_layer1_3x3_weights_4_11_get_layer1_weight_11(data)            (0x000007FF&(data))

#define  SRNN_wdsr_layer1_3x3_weights_4_12                                      0x181AB080
#define  SRNN_wdsr_layer1_3x3_weights_4_12_reg_addr                              "0xB81AB080"
#define  SRNN_wdsr_layer1_3x3_weights_4_12_reg                                   0xB81AB080
#define  SRNN_wdsr_layer1_3x3_weights_4_12_inst_addr                             "0x0044"
#define  set_SRNN_wdsr_layer1_3x3_weights_4_12_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_4_12_reg)=data)
#define  get_SRNN_wdsr_layer1_3x3_weights_4_12_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_4_12_reg))
#define  SRNN_wdsr_layer1_3x3_weights_4_12_layer1_weight_12_shift                (0)
#define  SRNN_wdsr_layer1_3x3_weights_4_12_layer1_weight_12_mask                 (0x000007FF)
#define  SRNN_wdsr_layer1_3x3_weights_4_12_layer1_weight_12(data)                (0x000007FF&(data))
#define  SRNN_wdsr_layer1_3x3_weights_4_12_get_layer1_weight_12(data)            (0x000007FF&(data))

#define  SRNN_wdsr_layer1_3x3_weights_4_20                                      0x181AB084
#define  SRNN_wdsr_layer1_3x3_weights_4_20_reg_addr                              "0xB81AB084"
#define  SRNN_wdsr_layer1_3x3_weights_4_20_reg                                   0xB81AB084
#define  SRNN_wdsr_layer1_3x3_weights_4_20_inst_addr                             "0x0045"
#define  set_SRNN_wdsr_layer1_3x3_weights_4_20_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_4_20_reg)=data)
#define  get_SRNN_wdsr_layer1_3x3_weights_4_20_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_4_20_reg))
#define  SRNN_wdsr_layer1_3x3_weights_4_20_layer1_weight_20_shift                (0)
#define  SRNN_wdsr_layer1_3x3_weights_4_20_layer1_weight_20_mask                 (0x000007FF)
#define  SRNN_wdsr_layer1_3x3_weights_4_20_layer1_weight_20(data)                (0x000007FF&(data))
#define  SRNN_wdsr_layer1_3x3_weights_4_20_get_layer1_weight_20(data)            (0x000007FF&(data))

#define  SRNN_wdsr_layer1_3x3_weights_4_21                                      0x181AB088
#define  SRNN_wdsr_layer1_3x3_weights_4_21_reg_addr                              "0xB81AB088"
#define  SRNN_wdsr_layer1_3x3_weights_4_21_reg                                   0xB81AB088
#define  SRNN_wdsr_layer1_3x3_weights_4_21_inst_addr                             "0x0046"
#define  set_SRNN_wdsr_layer1_3x3_weights_4_21_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_4_21_reg)=data)
#define  get_SRNN_wdsr_layer1_3x3_weights_4_21_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_4_21_reg))
#define  SRNN_wdsr_layer1_3x3_weights_4_21_layer1_weight_21_shift                (0)
#define  SRNN_wdsr_layer1_3x3_weights_4_21_layer1_weight_21_mask                 (0x000007FF)
#define  SRNN_wdsr_layer1_3x3_weights_4_21_layer1_weight_21(data)                (0x000007FF&(data))
#define  SRNN_wdsr_layer1_3x3_weights_4_21_get_layer1_weight_21(data)            (0x000007FF&(data))

#define  SRNN_wdsr_layer1_3x3_weights_4_22                                      0x181AB08C
#define  SRNN_wdsr_layer1_3x3_weights_4_22_reg_addr                              "0xB81AB08C"
#define  SRNN_wdsr_layer1_3x3_weights_4_22_reg                                   0xB81AB08C
#define  SRNN_wdsr_layer1_3x3_weights_4_22_inst_addr                             "0x0047"
#define  set_SRNN_wdsr_layer1_3x3_weights_4_22_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_4_22_reg)=data)
#define  get_SRNN_wdsr_layer1_3x3_weights_4_22_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_4_22_reg))
#define  SRNN_wdsr_layer1_3x3_weights_4_22_layer1_weight_22_shift                (0)
#define  SRNN_wdsr_layer1_3x3_weights_4_22_layer1_weight_22_mask                 (0x000007FF)
#define  SRNN_wdsr_layer1_3x3_weights_4_22_layer1_weight_22(data)                (0x000007FF&(data))
#define  SRNN_wdsr_layer1_3x3_weights_4_22_get_layer1_weight_22(data)            (0x000007FF&(data))

#define  SRNN_wdsr_layer1_3x3_weights_5_00                                      0x181AB090
#define  SRNN_wdsr_layer1_3x3_weights_5_00_reg_addr                              "0xB81AB090"
#define  SRNN_wdsr_layer1_3x3_weights_5_00_reg                                   0xB81AB090
#define  SRNN_wdsr_layer1_3x3_weights_5_00_inst_addr                             "0x0048"
#define  set_SRNN_wdsr_layer1_3x3_weights_5_00_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_5_00_reg)=data)
#define  get_SRNN_wdsr_layer1_3x3_weights_5_00_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_5_00_reg))
#define  SRNN_wdsr_layer1_3x3_weights_5_00_layer1_weight_00_shift                (0)
#define  SRNN_wdsr_layer1_3x3_weights_5_00_layer1_weight_00_mask                 (0x000007FF)
#define  SRNN_wdsr_layer1_3x3_weights_5_00_layer1_weight_00(data)                (0x000007FF&(data))
#define  SRNN_wdsr_layer1_3x3_weights_5_00_get_layer1_weight_00(data)            (0x000007FF&(data))

#define  SRNN_wdsr_layer1_3x3_weights_5_01                                      0x181AB094
#define  SRNN_wdsr_layer1_3x3_weights_5_01_reg_addr                              "0xB81AB094"
#define  SRNN_wdsr_layer1_3x3_weights_5_01_reg                                   0xB81AB094
#define  SRNN_wdsr_layer1_3x3_weights_5_01_inst_addr                             "0x0049"
#define  set_SRNN_wdsr_layer1_3x3_weights_5_01_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_5_01_reg)=data)
#define  get_SRNN_wdsr_layer1_3x3_weights_5_01_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_5_01_reg))
#define  SRNN_wdsr_layer1_3x3_weights_5_01_layer1_weight_01_shift                (0)
#define  SRNN_wdsr_layer1_3x3_weights_5_01_layer1_weight_01_mask                 (0x000007FF)
#define  SRNN_wdsr_layer1_3x3_weights_5_01_layer1_weight_01(data)                (0x000007FF&(data))
#define  SRNN_wdsr_layer1_3x3_weights_5_01_get_layer1_weight_01(data)            (0x000007FF&(data))

#define  SRNN_wdsr_layer1_3x3_weights_5_02                                      0x181AB098
#define  SRNN_wdsr_layer1_3x3_weights_5_02_reg_addr                              "0xB81AB098"
#define  SRNN_wdsr_layer1_3x3_weights_5_02_reg                                   0xB81AB098
#define  SRNN_wdsr_layer1_3x3_weights_5_02_inst_addr                             "0x004A"
#define  set_SRNN_wdsr_layer1_3x3_weights_5_02_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_5_02_reg)=data)
#define  get_SRNN_wdsr_layer1_3x3_weights_5_02_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_5_02_reg))
#define  SRNN_wdsr_layer1_3x3_weights_5_02_layer1_weight_02_shift                (0)
#define  SRNN_wdsr_layer1_3x3_weights_5_02_layer1_weight_02_mask                 (0x000007FF)
#define  SRNN_wdsr_layer1_3x3_weights_5_02_layer1_weight_02(data)                (0x000007FF&(data))
#define  SRNN_wdsr_layer1_3x3_weights_5_02_get_layer1_weight_02(data)            (0x000007FF&(data))

#define  SRNN_wdsr_layer1_3x3_weights_5_10                                      0x181AB09C
#define  SRNN_wdsr_layer1_3x3_weights_5_10_reg_addr                              "0xB81AB09C"
#define  SRNN_wdsr_layer1_3x3_weights_5_10_reg                                   0xB81AB09C
#define  SRNN_wdsr_layer1_3x3_weights_5_10_inst_addr                             "0x004B"
#define  set_SRNN_wdsr_layer1_3x3_weights_5_10_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_5_10_reg)=data)
#define  get_SRNN_wdsr_layer1_3x3_weights_5_10_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_5_10_reg))
#define  SRNN_wdsr_layer1_3x3_weights_5_10_layer1_weight_10_shift                (0)
#define  SRNN_wdsr_layer1_3x3_weights_5_10_layer1_weight_10_mask                 (0x000007FF)
#define  SRNN_wdsr_layer1_3x3_weights_5_10_layer1_weight_10(data)                (0x000007FF&(data))
#define  SRNN_wdsr_layer1_3x3_weights_5_10_get_layer1_weight_10(data)            (0x000007FF&(data))

#define  SRNN_wdsr_layer1_3x3_weights_5_11                                      0x181AB0A0
#define  SRNN_wdsr_layer1_3x3_weights_5_11_reg_addr                              "0xB81AB0A0"
#define  SRNN_wdsr_layer1_3x3_weights_5_11_reg                                   0xB81AB0A0
#define  SRNN_wdsr_layer1_3x3_weights_5_11_inst_addr                             "0x004C"
#define  set_SRNN_wdsr_layer1_3x3_weights_5_11_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_5_11_reg)=data)
#define  get_SRNN_wdsr_layer1_3x3_weights_5_11_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_5_11_reg))
#define  SRNN_wdsr_layer1_3x3_weights_5_11_layer1_weight_11_shift                (0)
#define  SRNN_wdsr_layer1_3x3_weights_5_11_layer1_weight_11_mask                 (0x000007FF)
#define  SRNN_wdsr_layer1_3x3_weights_5_11_layer1_weight_11(data)                (0x000007FF&(data))
#define  SRNN_wdsr_layer1_3x3_weights_5_11_get_layer1_weight_11(data)            (0x000007FF&(data))

#define  SRNN_wdsr_layer1_3x3_weights_5_12                                      0x181AB0A4
#define  SRNN_wdsr_layer1_3x3_weights_5_12_reg_addr                              "0xB81AB0A4"
#define  SRNN_wdsr_layer1_3x3_weights_5_12_reg                                   0xB81AB0A4
#define  SRNN_wdsr_layer1_3x3_weights_5_12_inst_addr                             "0x004D"
#define  set_SRNN_wdsr_layer1_3x3_weights_5_12_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_5_12_reg)=data)
#define  get_SRNN_wdsr_layer1_3x3_weights_5_12_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_5_12_reg))
#define  SRNN_wdsr_layer1_3x3_weights_5_12_layer1_weight_12_shift                (0)
#define  SRNN_wdsr_layer1_3x3_weights_5_12_layer1_weight_12_mask                 (0x000007FF)
#define  SRNN_wdsr_layer1_3x3_weights_5_12_layer1_weight_12(data)                (0x000007FF&(data))
#define  SRNN_wdsr_layer1_3x3_weights_5_12_get_layer1_weight_12(data)            (0x000007FF&(data))

#define  SRNN_wdsr_layer1_3x3_weights_5_20                                      0x181AB0A8
#define  SRNN_wdsr_layer1_3x3_weights_5_20_reg_addr                              "0xB81AB0A8"
#define  SRNN_wdsr_layer1_3x3_weights_5_20_reg                                   0xB81AB0A8
#define  SRNN_wdsr_layer1_3x3_weights_5_20_inst_addr                             "0x004E"
#define  set_SRNN_wdsr_layer1_3x3_weights_5_20_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_5_20_reg)=data)
#define  get_SRNN_wdsr_layer1_3x3_weights_5_20_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_5_20_reg))
#define  SRNN_wdsr_layer1_3x3_weights_5_20_layer1_weight_20_shift                (0)
#define  SRNN_wdsr_layer1_3x3_weights_5_20_layer1_weight_20_mask                 (0x000007FF)
#define  SRNN_wdsr_layer1_3x3_weights_5_20_layer1_weight_20(data)                (0x000007FF&(data))
#define  SRNN_wdsr_layer1_3x3_weights_5_20_get_layer1_weight_20(data)            (0x000007FF&(data))

#define  SRNN_wdsr_layer1_3x3_weights_5_21                                      0x181AB0AC
#define  SRNN_wdsr_layer1_3x3_weights_5_21_reg_addr                              "0xB81AB0AC"
#define  SRNN_wdsr_layer1_3x3_weights_5_21_reg                                   0xB81AB0AC
#define  SRNN_wdsr_layer1_3x3_weights_5_21_inst_addr                             "0x004F"
#define  set_SRNN_wdsr_layer1_3x3_weights_5_21_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_5_21_reg)=data)
#define  get_SRNN_wdsr_layer1_3x3_weights_5_21_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_5_21_reg))
#define  SRNN_wdsr_layer1_3x3_weights_5_21_layer1_weight_21_shift                (0)
#define  SRNN_wdsr_layer1_3x3_weights_5_21_layer1_weight_21_mask                 (0x000007FF)
#define  SRNN_wdsr_layer1_3x3_weights_5_21_layer1_weight_21(data)                (0x000007FF&(data))
#define  SRNN_wdsr_layer1_3x3_weights_5_21_get_layer1_weight_21(data)            (0x000007FF&(data))

#define  SRNN_wdsr_layer1_3x3_weights_5_22                                      0x181AB0B0
#define  SRNN_wdsr_layer1_3x3_weights_5_22_reg_addr                              "0xB81AB0B0"
#define  SRNN_wdsr_layer1_3x3_weights_5_22_reg                                   0xB81AB0B0
#define  SRNN_wdsr_layer1_3x3_weights_5_22_inst_addr                             "0x0050"
#define  set_SRNN_wdsr_layer1_3x3_weights_5_22_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_5_22_reg)=data)
#define  get_SRNN_wdsr_layer1_3x3_weights_5_22_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_5_22_reg))
#define  SRNN_wdsr_layer1_3x3_weights_5_22_layer1_weight_22_shift                (0)
#define  SRNN_wdsr_layer1_3x3_weights_5_22_layer1_weight_22_mask                 (0x000007FF)
#define  SRNN_wdsr_layer1_3x3_weights_5_22_layer1_weight_22(data)                (0x000007FF&(data))
#define  SRNN_wdsr_layer1_3x3_weights_5_22_get_layer1_weight_22(data)            (0x000007FF&(data))

#define  SRNN_wdsr_layer1_3x3_weights_6_00                                      0x181AB0B4
#define  SRNN_wdsr_layer1_3x3_weights_6_00_reg_addr                              "0xB81AB0B4"
#define  SRNN_wdsr_layer1_3x3_weights_6_00_reg                                   0xB81AB0B4
#define  SRNN_wdsr_layer1_3x3_weights_6_00_inst_addr                             "0x0051"
#define  set_SRNN_wdsr_layer1_3x3_weights_6_00_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_6_00_reg)=data)
#define  get_SRNN_wdsr_layer1_3x3_weights_6_00_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_6_00_reg))
#define  SRNN_wdsr_layer1_3x3_weights_6_00_layer1_weight_00_shift                (0)
#define  SRNN_wdsr_layer1_3x3_weights_6_00_layer1_weight_00_mask                 (0x000007FF)
#define  SRNN_wdsr_layer1_3x3_weights_6_00_layer1_weight_00(data)                (0x000007FF&(data))
#define  SRNN_wdsr_layer1_3x3_weights_6_00_get_layer1_weight_00(data)            (0x000007FF&(data))

#define  SRNN_wdsr_layer1_3x3_weights_6_01                                      0x181AB0B8
#define  SRNN_wdsr_layer1_3x3_weights_6_01_reg_addr                              "0xB81AB0B8"
#define  SRNN_wdsr_layer1_3x3_weights_6_01_reg                                   0xB81AB0B8
#define  SRNN_wdsr_layer1_3x3_weights_6_01_inst_addr                             "0x0052"
#define  set_SRNN_wdsr_layer1_3x3_weights_6_01_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_6_01_reg)=data)
#define  get_SRNN_wdsr_layer1_3x3_weights_6_01_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_6_01_reg))
#define  SRNN_wdsr_layer1_3x3_weights_6_01_layer1_weight_01_shift                (0)
#define  SRNN_wdsr_layer1_3x3_weights_6_01_layer1_weight_01_mask                 (0x000007FF)
#define  SRNN_wdsr_layer1_3x3_weights_6_01_layer1_weight_01(data)                (0x000007FF&(data))
#define  SRNN_wdsr_layer1_3x3_weights_6_01_get_layer1_weight_01(data)            (0x000007FF&(data))

#define  SRNN_wdsr_layer1_3x3_weights_6_02                                      0x181AB0BC
#define  SRNN_wdsr_layer1_3x3_weights_6_02_reg_addr                              "0xB81AB0BC"
#define  SRNN_wdsr_layer1_3x3_weights_6_02_reg                                   0xB81AB0BC
#define  SRNN_wdsr_layer1_3x3_weights_6_02_inst_addr                             "0x0053"
#define  set_SRNN_wdsr_layer1_3x3_weights_6_02_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_6_02_reg)=data)
#define  get_SRNN_wdsr_layer1_3x3_weights_6_02_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_6_02_reg))
#define  SRNN_wdsr_layer1_3x3_weights_6_02_layer1_weight_02_shift                (0)
#define  SRNN_wdsr_layer1_3x3_weights_6_02_layer1_weight_02_mask                 (0x000007FF)
#define  SRNN_wdsr_layer1_3x3_weights_6_02_layer1_weight_02(data)                (0x000007FF&(data))
#define  SRNN_wdsr_layer1_3x3_weights_6_02_get_layer1_weight_02(data)            (0x000007FF&(data))

#define  SRNN_wdsr_layer1_3x3_weights_6_10                                      0x181AB0C0
#define  SRNN_wdsr_layer1_3x3_weights_6_10_reg_addr                              "0xB81AB0C0"
#define  SRNN_wdsr_layer1_3x3_weights_6_10_reg                                   0xB81AB0C0
#define  SRNN_wdsr_layer1_3x3_weights_6_10_inst_addr                             "0x0054"
#define  set_SRNN_wdsr_layer1_3x3_weights_6_10_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_6_10_reg)=data)
#define  get_SRNN_wdsr_layer1_3x3_weights_6_10_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_6_10_reg))
#define  SRNN_wdsr_layer1_3x3_weights_6_10_layer1_weight_10_shift                (0)
#define  SRNN_wdsr_layer1_3x3_weights_6_10_layer1_weight_10_mask                 (0x000007FF)
#define  SRNN_wdsr_layer1_3x3_weights_6_10_layer1_weight_10(data)                (0x000007FF&(data))
#define  SRNN_wdsr_layer1_3x3_weights_6_10_get_layer1_weight_10(data)            (0x000007FF&(data))

#define  SRNN_wdsr_layer1_3x3_weights_6_11                                      0x181AB0C4
#define  SRNN_wdsr_layer1_3x3_weights_6_11_reg_addr                              "0xB81AB0C4"
#define  SRNN_wdsr_layer1_3x3_weights_6_11_reg                                   0xB81AB0C4
#define  SRNN_wdsr_layer1_3x3_weights_6_11_inst_addr                             "0x0055"
#define  set_SRNN_wdsr_layer1_3x3_weights_6_11_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_6_11_reg)=data)
#define  get_SRNN_wdsr_layer1_3x3_weights_6_11_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_6_11_reg))
#define  SRNN_wdsr_layer1_3x3_weights_6_11_layer1_weight_11_shift                (0)
#define  SRNN_wdsr_layer1_3x3_weights_6_11_layer1_weight_11_mask                 (0x000007FF)
#define  SRNN_wdsr_layer1_3x3_weights_6_11_layer1_weight_11(data)                (0x000007FF&(data))
#define  SRNN_wdsr_layer1_3x3_weights_6_11_get_layer1_weight_11(data)            (0x000007FF&(data))

#define  SRNN_wdsr_layer1_3x3_weights_6_12                                      0x181AB0C8
#define  SRNN_wdsr_layer1_3x3_weights_6_12_reg_addr                              "0xB81AB0C8"
#define  SRNN_wdsr_layer1_3x3_weights_6_12_reg                                   0xB81AB0C8
#define  SRNN_wdsr_layer1_3x3_weights_6_12_inst_addr                             "0x0056"
#define  set_SRNN_wdsr_layer1_3x3_weights_6_12_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_6_12_reg)=data)
#define  get_SRNN_wdsr_layer1_3x3_weights_6_12_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_6_12_reg))
#define  SRNN_wdsr_layer1_3x3_weights_6_12_layer1_weight_12_shift                (0)
#define  SRNN_wdsr_layer1_3x3_weights_6_12_layer1_weight_12_mask                 (0x000007FF)
#define  SRNN_wdsr_layer1_3x3_weights_6_12_layer1_weight_12(data)                (0x000007FF&(data))
#define  SRNN_wdsr_layer1_3x3_weights_6_12_get_layer1_weight_12(data)            (0x000007FF&(data))

#define  SRNN_wdsr_layer1_3x3_weights_6_20                                      0x181AB0CC
#define  SRNN_wdsr_layer1_3x3_weights_6_20_reg_addr                              "0xB81AB0CC"
#define  SRNN_wdsr_layer1_3x3_weights_6_20_reg                                   0xB81AB0CC
#define  SRNN_wdsr_layer1_3x3_weights_6_20_inst_addr                             "0x0057"
#define  set_SRNN_wdsr_layer1_3x3_weights_6_20_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_6_20_reg)=data)
#define  get_SRNN_wdsr_layer1_3x3_weights_6_20_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_6_20_reg))
#define  SRNN_wdsr_layer1_3x3_weights_6_20_layer1_weight_20_shift                (0)
#define  SRNN_wdsr_layer1_3x3_weights_6_20_layer1_weight_20_mask                 (0x000007FF)
#define  SRNN_wdsr_layer1_3x3_weights_6_20_layer1_weight_20(data)                (0x000007FF&(data))
#define  SRNN_wdsr_layer1_3x3_weights_6_20_get_layer1_weight_20(data)            (0x000007FF&(data))

#define  SRNN_wdsr_layer1_3x3_weights_6_21                                      0x181AB0D0
#define  SRNN_wdsr_layer1_3x3_weights_6_21_reg_addr                              "0xB81AB0D0"
#define  SRNN_wdsr_layer1_3x3_weights_6_21_reg                                   0xB81AB0D0
#define  SRNN_wdsr_layer1_3x3_weights_6_21_inst_addr                             "0x0058"
#define  set_SRNN_wdsr_layer1_3x3_weights_6_21_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_6_21_reg)=data)
#define  get_SRNN_wdsr_layer1_3x3_weights_6_21_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_6_21_reg))
#define  SRNN_wdsr_layer1_3x3_weights_6_21_layer1_weight_21_shift                (0)
#define  SRNN_wdsr_layer1_3x3_weights_6_21_layer1_weight_21_mask                 (0x000007FF)
#define  SRNN_wdsr_layer1_3x3_weights_6_21_layer1_weight_21(data)                (0x000007FF&(data))
#define  SRNN_wdsr_layer1_3x3_weights_6_21_get_layer1_weight_21(data)            (0x000007FF&(data))

#define  SRNN_wdsr_layer1_3x3_weights_6_22                                      0x181AB0D4
#define  SRNN_wdsr_layer1_3x3_weights_6_22_reg_addr                              "0xB81AB0D4"
#define  SRNN_wdsr_layer1_3x3_weights_6_22_reg                                   0xB81AB0D4
#define  SRNN_wdsr_layer1_3x3_weights_6_22_inst_addr                             "0x0059"
#define  set_SRNN_wdsr_layer1_3x3_weights_6_22_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_6_22_reg)=data)
#define  get_SRNN_wdsr_layer1_3x3_weights_6_22_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_6_22_reg))
#define  SRNN_wdsr_layer1_3x3_weights_6_22_layer1_weight_22_shift                (0)
#define  SRNN_wdsr_layer1_3x3_weights_6_22_layer1_weight_22_mask                 (0x000007FF)
#define  SRNN_wdsr_layer1_3x3_weights_6_22_layer1_weight_22(data)                (0x000007FF&(data))
#define  SRNN_wdsr_layer1_3x3_weights_6_22_get_layer1_weight_22(data)            (0x000007FF&(data))

#define  SRNN_wdsr_layer1_3x3_weights_7_00                                      0x181AB0D8
#define  SRNN_wdsr_layer1_3x3_weights_7_00_reg_addr                              "0xB81AB0D8"
#define  SRNN_wdsr_layer1_3x3_weights_7_00_reg                                   0xB81AB0D8
#define  SRNN_wdsr_layer1_3x3_weights_7_00_inst_addr                             "0x005A"
#define  set_SRNN_wdsr_layer1_3x3_weights_7_00_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_7_00_reg)=data)
#define  get_SRNN_wdsr_layer1_3x3_weights_7_00_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_7_00_reg))
#define  SRNN_wdsr_layer1_3x3_weights_7_00_layer1_weight_00_shift                (0)
#define  SRNN_wdsr_layer1_3x3_weights_7_00_layer1_weight_00_mask                 (0x000007FF)
#define  SRNN_wdsr_layer1_3x3_weights_7_00_layer1_weight_00(data)                (0x000007FF&(data))
#define  SRNN_wdsr_layer1_3x3_weights_7_00_get_layer1_weight_00(data)            (0x000007FF&(data))

#define  SRNN_wdsr_layer1_3x3_weights_7_01                                      0x181AB0DC
#define  SRNN_wdsr_layer1_3x3_weights_7_01_reg_addr                              "0xB81AB0DC"
#define  SRNN_wdsr_layer1_3x3_weights_7_01_reg                                   0xB81AB0DC
#define  SRNN_wdsr_layer1_3x3_weights_7_01_inst_addr                             "0x005B"
#define  set_SRNN_wdsr_layer1_3x3_weights_7_01_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_7_01_reg)=data)
#define  get_SRNN_wdsr_layer1_3x3_weights_7_01_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_7_01_reg))
#define  SRNN_wdsr_layer1_3x3_weights_7_01_layer1_weight_01_shift                (0)
#define  SRNN_wdsr_layer1_3x3_weights_7_01_layer1_weight_01_mask                 (0x000007FF)
#define  SRNN_wdsr_layer1_3x3_weights_7_01_layer1_weight_01(data)                (0x000007FF&(data))
#define  SRNN_wdsr_layer1_3x3_weights_7_01_get_layer1_weight_01(data)            (0x000007FF&(data))

#define  SRNN_wdsr_layer1_3x3_weights_7_02                                      0x181AB0E0
#define  SRNN_wdsr_layer1_3x3_weights_7_02_reg_addr                              "0xB81AB0E0"
#define  SRNN_wdsr_layer1_3x3_weights_7_02_reg                                   0xB81AB0E0
#define  SRNN_wdsr_layer1_3x3_weights_7_02_inst_addr                             "0x005C"
#define  set_SRNN_wdsr_layer1_3x3_weights_7_02_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_7_02_reg)=data)
#define  get_SRNN_wdsr_layer1_3x3_weights_7_02_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_7_02_reg))
#define  SRNN_wdsr_layer1_3x3_weights_7_02_layer1_weight_02_shift                (0)
#define  SRNN_wdsr_layer1_3x3_weights_7_02_layer1_weight_02_mask                 (0x000007FF)
#define  SRNN_wdsr_layer1_3x3_weights_7_02_layer1_weight_02(data)                (0x000007FF&(data))
#define  SRNN_wdsr_layer1_3x3_weights_7_02_get_layer1_weight_02(data)            (0x000007FF&(data))

#define  SRNN_wdsr_layer1_3x3_weights_7_10                                      0x181AB0E4
#define  SRNN_wdsr_layer1_3x3_weights_7_10_reg_addr                              "0xB81AB0E4"
#define  SRNN_wdsr_layer1_3x3_weights_7_10_reg                                   0xB81AB0E4
#define  SRNN_wdsr_layer1_3x3_weights_7_10_inst_addr                             "0x005D"
#define  set_SRNN_wdsr_layer1_3x3_weights_7_10_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_7_10_reg)=data)
#define  get_SRNN_wdsr_layer1_3x3_weights_7_10_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_7_10_reg))
#define  SRNN_wdsr_layer1_3x3_weights_7_10_layer1_weight_10_shift                (0)
#define  SRNN_wdsr_layer1_3x3_weights_7_10_layer1_weight_10_mask                 (0x000007FF)
#define  SRNN_wdsr_layer1_3x3_weights_7_10_layer1_weight_10(data)                (0x000007FF&(data))
#define  SRNN_wdsr_layer1_3x3_weights_7_10_get_layer1_weight_10(data)            (0x000007FF&(data))

#define  SRNN_wdsr_layer1_3x3_weights_7_11                                      0x181AB0E8
#define  SRNN_wdsr_layer1_3x3_weights_7_11_reg_addr                              "0xB81AB0E8"
#define  SRNN_wdsr_layer1_3x3_weights_7_11_reg                                   0xB81AB0E8
#define  SRNN_wdsr_layer1_3x3_weights_7_11_inst_addr                             "0x005E"
#define  set_SRNN_wdsr_layer1_3x3_weights_7_11_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_7_11_reg)=data)
#define  get_SRNN_wdsr_layer1_3x3_weights_7_11_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_7_11_reg))
#define  SRNN_wdsr_layer1_3x3_weights_7_11_layer1_weight_11_shift                (0)
#define  SRNN_wdsr_layer1_3x3_weights_7_11_layer1_weight_11_mask                 (0x000007FF)
#define  SRNN_wdsr_layer1_3x3_weights_7_11_layer1_weight_11(data)                (0x000007FF&(data))
#define  SRNN_wdsr_layer1_3x3_weights_7_11_get_layer1_weight_11(data)            (0x000007FF&(data))

#define  SRNN_wdsr_layer1_3x3_weights_7_12                                      0x181AB0EC
#define  SRNN_wdsr_layer1_3x3_weights_7_12_reg_addr                              "0xB81AB0EC"
#define  SRNN_wdsr_layer1_3x3_weights_7_12_reg                                   0xB81AB0EC
#define  SRNN_wdsr_layer1_3x3_weights_7_12_inst_addr                             "0x005F"
#define  set_SRNN_wdsr_layer1_3x3_weights_7_12_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_7_12_reg)=data)
#define  get_SRNN_wdsr_layer1_3x3_weights_7_12_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_7_12_reg))
#define  SRNN_wdsr_layer1_3x3_weights_7_12_layer1_weight_12_shift                (0)
#define  SRNN_wdsr_layer1_3x3_weights_7_12_layer1_weight_12_mask                 (0x000007FF)
#define  SRNN_wdsr_layer1_3x3_weights_7_12_layer1_weight_12(data)                (0x000007FF&(data))
#define  SRNN_wdsr_layer1_3x3_weights_7_12_get_layer1_weight_12(data)            (0x000007FF&(data))

#define  SRNN_wdsr_layer1_3x3_weights_7_20                                      0x181AB0F0
#define  SRNN_wdsr_layer1_3x3_weights_7_20_reg_addr                              "0xB81AB0F0"
#define  SRNN_wdsr_layer1_3x3_weights_7_20_reg                                   0xB81AB0F0
#define  SRNN_wdsr_layer1_3x3_weights_7_20_inst_addr                             "0x0060"
#define  set_SRNN_wdsr_layer1_3x3_weights_7_20_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_7_20_reg)=data)
#define  get_SRNN_wdsr_layer1_3x3_weights_7_20_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_7_20_reg))
#define  SRNN_wdsr_layer1_3x3_weights_7_20_layer1_weight_20_shift                (0)
#define  SRNN_wdsr_layer1_3x3_weights_7_20_layer1_weight_20_mask                 (0x000007FF)
#define  SRNN_wdsr_layer1_3x3_weights_7_20_layer1_weight_20(data)                (0x000007FF&(data))
#define  SRNN_wdsr_layer1_3x3_weights_7_20_get_layer1_weight_20(data)            (0x000007FF&(data))

#define  SRNN_wdsr_layer1_3x3_weights_7_21                                      0x181AB0F4
#define  SRNN_wdsr_layer1_3x3_weights_7_21_reg_addr                              "0xB81AB0F4"
#define  SRNN_wdsr_layer1_3x3_weights_7_21_reg                                   0xB81AB0F4
#define  SRNN_wdsr_layer1_3x3_weights_7_21_inst_addr                             "0x0061"
#define  set_SRNN_wdsr_layer1_3x3_weights_7_21_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_7_21_reg)=data)
#define  get_SRNN_wdsr_layer1_3x3_weights_7_21_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_7_21_reg))
#define  SRNN_wdsr_layer1_3x3_weights_7_21_layer1_weight_21_shift                (0)
#define  SRNN_wdsr_layer1_3x3_weights_7_21_layer1_weight_21_mask                 (0x000007FF)
#define  SRNN_wdsr_layer1_3x3_weights_7_21_layer1_weight_21(data)                (0x000007FF&(data))
#define  SRNN_wdsr_layer1_3x3_weights_7_21_get_layer1_weight_21(data)            (0x000007FF&(data))

#define  SRNN_wdsr_layer1_3x3_weights_7_22                                      0x181AB0F8
#define  SRNN_wdsr_layer1_3x3_weights_7_22_reg_addr                              "0xB81AB0F8"
#define  SRNN_wdsr_layer1_3x3_weights_7_22_reg                                   0xB81AB0F8
#define  SRNN_wdsr_layer1_3x3_weights_7_22_inst_addr                             "0x0062"
#define  set_SRNN_wdsr_layer1_3x3_weights_7_22_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_7_22_reg)=data)
#define  get_SRNN_wdsr_layer1_3x3_weights_7_22_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_7_22_reg))
#define  SRNN_wdsr_layer1_3x3_weights_7_22_layer1_weight_22_shift                (0)
#define  SRNN_wdsr_layer1_3x3_weights_7_22_layer1_weight_22_mask                 (0x000007FF)
#define  SRNN_wdsr_layer1_3x3_weights_7_22_layer1_weight_22(data)                (0x000007FF&(data))
#define  SRNN_wdsr_layer1_3x3_weights_7_22_get_layer1_weight_22(data)            (0x000007FF&(data))

#define  SRNN_wdsr_layer1_3x3_weights_8_00                                      0x181AB0FC
#define  SRNN_wdsr_layer1_3x3_weights_8_00_reg_addr                              "0xB81AB0FC"
#define  SRNN_wdsr_layer1_3x3_weights_8_00_reg                                   0xB81AB0FC
#define  SRNN_wdsr_layer1_3x3_weights_8_00_inst_addr                             "0x0063"
#define  set_SRNN_wdsr_layer1_3x3_weights_8_00_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_8_00_reg)=data)
#define  get_SRNN_wdsr_layer1_3x3_weights_8_00_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_8_00_reg))
#define  SRNN_wdsr_layer1_3x3_weights_8_00_layer1_weight_00_shift                (0)
#define  SRNN_wdsr_layer1_3x3_weights_8_00_layer1_weight_00_mask                 (0x000007FF)
#define  SRNN_wdsr_layer1_3x3_weights_8_00_layer1_weight_00(data)                (0x000007FF&(data))
#define  SRNN_wdsr_layer1_3x3_weights_8_00_get_layer1_weight_00(data)            (0x000007FF&(data))

#define  SRNN_wdsr_layer1_3x3_weights_8_01                                      0x181AB100
#define  SRNN_wdsr_layer1_3x3_weights_8_01_reg_addr                              "0xB81AB100"
#define  SRNN_wdsr_layer1_3x3_weights_8_01_reg                                   0xB81AB100
#define  SRNN_wdsr_layer1_3x3_weights_8_01_inst_addr                             "0x0064"
#define  set_SRNN_wdsr_layer1_3x3_weights_8_01_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_8_01_reg)=data)
#define  get_SRNN_wdsr_layer1_3x3_weights_8_01_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_8_01_reg))
#define  SRNN_wdsr_layer1_3x3_weights_8_01_layer1_weight_01_shift                (0)
#define  SRNN_wdsr_layer1_3x3_weights_8_01_layer1_weight_01_mask                 (0x000007FF)
#define  SRNN_wdsr_layer1_3x3_weights_8_01_layer1_weight_01(data)                (0x000007FF&(data))
#define  SRNN_wdsr_layer1_3x3_weights_8_01_get_layer1_weight_01(data)            (0x000007FF&(data))

#define  SRNN_wdsr_layer1_3x3_weights_8_02                                      0x181AB104
#define  SRNN_wdsr_layer1_3x3_weights_8_02_reg_addr                              "0xB81AB104"
#define  SRNN_wdsr_layer1_3x3_weights_8_02_reg                                   0xB81AB104
#define  SRNN_wdsr_layer1_3x3_weights_8_02_inst_addr                             "0x0065"
#define  set_SRNN_wdsr_layer1_3x3_weights_8_02_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_8_02_reg)=data)
#define  get_SRNN_wdsr_layer1_3x3_weights_8_02_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_8_02_reg))
#define  SRNN_wdsr_layer1_3x3_weights_8_02_layer1_weight_02_shift                (0)
#define  SRNN_wdsr_layer1_3x3_weights_8_02_layer1_weight_02_mask                 (0x000007FF)
#define  SRNN_wdsr_layer1_3x3_weights_8_02_layer1_weight_02(data)                (0x000007FF&(data))
#define  SRNN_wdsr_layer1_3x3_weights_8_02_get_layer1_weight_02(data)            (0x000007FF&(data))

#define  SRNN_wdsr_layer1_3x3_weights_8_10                                      0x181AB108
#define  SRNN_wdsr_layer1_3x3_weights_8_10_reg_addr                              "0xB81AB108"
#define  SRNN_wdsr_layer1_3x3_weights_8_10_reg                                   0xB81AB108
#define  SRNN_wdsr_layer1_3x3_weights_8_10_inst_addr                             "0x0066"
#define  set_SRNN_wdsr_layer1_3x3_weights_8_10_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_8_10_reg)=data)
#define  get_SRNN_wdsr_layer1_3x3_weights_8_10_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_8_10_reg))
#define  SRNN_wdsr_layer1_3x3_weights_8_10_layer1_weight_10_shift                (0)
#define  SRNN_wdsr_layer1_3x3_weights_8_10_layer1_weight_10_mask                 (0x000007FF)
#define  SRNN_wdsr_layer1_3x3_weights_8_10_layer1_weight_10(data)                (0x000007FF&(data))
#define  SRNN_wdsr_layer1_3x3_weights_8_10_get_layer1_weight_10(data)            (0x000007FF&(data))

#define  SRNN_wdsr_layer1_3x3_weights_8_11                                      0x181AB10C
#define  SRNN_wdsr_layer1_3x3_weights_8_11_reg_addr                              "0xB81AB10C"
#define  SRNN_wdsr_layer1_3x3_weights_8_11_reg                                   0xB81AB10C
#define  SRNN_wdsr_layer1_3x3_weights_8_11_inst_addr                             "0x0067"
#define  set_SRNN_wdsr_layer1_3x3_weights_8_11_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_8_11_reg)=data)
#define  get_SRNN_wdsr_layer1_3x3_weights_8_11_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_8_11_reg))
#define  SRNN_wdsr_layer1_3x3_weights_8_11_layer1_weight_11_shift                (0)
#define  SRNN_wdsr_layer1_3x3_weights_8_11_layer1_weight_11_mask                 (0x000007FF)
#define  SRNN_wdsr_layer1_3x3_weights_8_11_layer1_weight_11(data)                (0x000007FF&(data))
#define  SRNN_wdsr_layer1_3x3_weights_8_11_get_layer1_weight_11(data)            (0x000007FF&(data))

#define  SRNN_wdsr_layer1_3x3_weights_8_12                                      0x181AB110
#define  SRNN_wdsr_layer1_3x3_weights_8_12_reg_addr                              "0xB81AB110"
#define  SRNN_wdsr_layer1_3x3_weights_8_12_reg                                   0xB81AB110
#define  SRNN_wdsr_layer1_3x3_weights_8_12_inst_addr                             "0x0068"
#define  set_SRNN_wdsr_layer1_3x3_weights_8_12_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_8_12_reg)=data)
#define  get_SRNN_wdsr_layer1_3x3_weights_8_12_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_8_12_reg))
#define  SRNN_wdsr_layer1_3x3_weights_8_12_layer1_weight_12_shift                (0)
#define  SRNN_wdsr_layer1_3x3_weights_8_12_layer1_weight_12_mask                 (0x000007FF)
#define  SRNN_wdsr_layer1_3x3_weights_8_12_layer1_weight_12(data)                (0x000007FF&(data))
#define  SRNN_wdsr_layer1_3x3_weights_8_12_get_layer1_weight_12(data)            (0x000007FF&(data))

#define  SRNN_wdsr_layer1_3x3_weights_8_20                                      0x181AB114
#define  SRNN_wdsr_layer1_3x3_weights_8_20_reg_addr                              "0xB81AB114"
#define  SRNN_wdsr_layer1_3x3_weights_8_20_reg                                   0xB81AB114
#define  SRNN_wdsr_layer1_3x3_weights_8_20_inst_addr                             "0x0069"
#define  set_SRNN_wdsr_layer1_3x3_weights_8_20_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_8_20_reg)=data)
#define  get_SRNN_wdsr_layer1_3x3_weights_8_20_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_8_20_reg))
#define  SRNN_wdsr_layer1_3x3_weights_8_20_layer1_weight_20_shift                (0)
#define  SRNN_wdsr_layer1_3x3_weights_8_20_layer1_weight_20_mask                 (0x000007FF)
#define  SRNN_wdsr_layer1_3x3_weights_8_20_layer1_weight_20(data)                (0x000007FF&(data))
#define  SRNN_wdsr_layer1_3x3_weights_8_20_get_layer1_weight_20(data)            (0x000007FF&(data))

#define  SRNN_wdsr_layer1_3x3_weights_8_21                                      0x181AB118
#define  SRNN_wdsr_layer1_3x3_weights_8_21_reg_addr                              "0xB81AB118"
#define  SRNN_wdsr_layer1_3x3_weights_8_21_reg                                   0xB81AB118
#define  SRNN_wdsr_layer1_3x3_weights_8_21_inst_addr                             "0x006A"
#define  set_SRNN_wdsr_layer1_3x3_weights_8_21_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_8_21_reg)=data)
#define  get_SRNN_wdsr_layer1_3x3_weights_8_21_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_8_21_reg))
#define  SRNN_wdsr_layer1_3x3_weights_8_21_layer1_weight_21_shift                (0)
#define  SRNN_wdsr_layer1_3x3_weights_8_21_layer1_weight_21_mask                 (0x000007FF)
#define  SRNN_wdsr_layer1_3x3_weights_8_21_layer1_weight_21(data)                (0x000007FF&(data))
#define  SRNN_wdsr_layer1_3x3_weights_8_21_get_layer1_weight_21(data)            (0x000007FF&(data))

#define  SRNN_wdsr_layer1_3x3_weights_8_22                                      0x181AB11C
#define  SRNN_wdsr_layer1_3x3_weights_8_22_reg_addr                              "0xB81AB11C"
#define  SRNN_wdsr_layer1_3x3_weights_8_22_reg                                   0xB81AB11C
#define  SRNN_wdsr_layer1_3x3_weights_8_22_inst_addr                             "0x006B"
#define  set_SRNN_wdsr_layer1_3x3_weights_8_22_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_8_22_reg)=data)
#define  get_SRNN_wdsr_layer1_3x3_weights_8_22_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_weights_8_22_reg))
#define  SRNN_wdsr_layer1_3x3_weights_8_22_layer1_weight_22_shift                (0)
#define  SRNN_wdsr_layer1_3x3_weights_8_22_layer1_weight_22_mask                 (0x000007FF)
#define  SRNN_wdsr_layer1_3x3_weights_8_22_layer1_weight_22(data)                (0x000007FF&(data))
#define  SRNN_wdsr_layer1_3x3_weights_8_22_get_layer1_weight_22(data)            (0x000007FF&(data))

#define  SRNN_wdsr_layer1_3x3_bias_1                                            0x181AB120
#define  SRNN_wdsr_layer1_3x3_bias_1_reg_addr                                    "0xB81AB120"
#define  SRNN_wdsr_layer1_3x3_bias_1_reg                                         0xB81AB120
#define  SRNN_wdsr_layer1_3x3_bias_1_inst_addr                                   "0x006C"
#define  set_SRNN_wdsr_layer1_3x3_bias_1_reg(data)                               (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_bias_1_reg)=data)
#define  get_SRNN_wdsr_layer1_3x3_bias_1_reg                                     (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_bias_1_reg))
#define  SRNN_wdsr_layer1_3x3_bias_1_layer1_bias_1_shift                         (0)
#define  SRNN_wdsr_layer1_3x3_bias_1_layer1_bias_1_mask                          (0x000001FF)
#define  SRNN_wdsr_layer1_3x3_bias_1_layer1_bias_1(data)                         (0x000001FF&(data))
#define  SRNN_wdsr_layer1_3x3_bias_1_get_layer1_bias_1(data)                     (0x000001FF&(data))

#define  SRNN_wdsr_layer1_3x3_bias_2                                            0x181AB124
#define  SRNN_wdsr_layer1_3x3_bias_2_reg_addr                                    "0xB81AB124"
#define  SRNN_wdsr_layer1_3x3_bias_2_reg                                         0xB81AB124
#define  SRNN_wdsr_layer1_3x3_bias_2_inst_addr                                   "0x006D"
#define  set_SRNN_wdsr_layer1_3x3_bias_2_reg(data)                               (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_bias_2_reg)=data)
#define  get_SRNN_wdsr_layer1_3x3_bias_2_reg                                     (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_bias_2_reg))
#define  SRNN_wdsr_layer1_3x3_bias_2_layer1_bias_2_shift                         (0)
#define  SRNN_wdsr_layer1_3x3_bias_2_layer1_bias_2_mask                          (0x000001FF)
#define  SRNN_wdsr_layer1_3x3_bias_2_layer1_bias_2(data)                         (0x000001FF&(data))
#define  SRNN_wdsr_layer1_3x3_bias_2_get_layer1_bias_2(data)                     (0x000001FF&(data))

#define  SRNN_wdsr_layer1_3x3_bias_3                                            0x181AB128
#define  SRNN_wdsr_layer1_3x3_bias_3_reg_addr                                    "0xB81AB128"
#define  SRNN_wdsr_layer1_3x3_bias_3_reg                                         0xB81AB128
#define  SRNN_wdsr_layer1_3x3_bias_3_inst_addr                                   "0x006E"
#define  set_SRNN_wdsr_layer1_3x3_bias_3_reg(data)                               (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_bias_3_reg)=data)
#define  get_SRNN_wdsr_layer1_3x3_bias_3_reg                                     (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_bias_3_reg))
#define  SRNN_wdsr_layer1_3x3_bias_3_layer1_bias_3_shift                         (0)
#define  SRNN_wdsr_layer1_3x3_bias_3_layer1_bias_3_mask                          (0x000001FF)
#define  SRNN_wdsr_layer1_3x3_bias_3_layer1_bias_3(data)                         (0x000001FF&(data))
#define  SRNN_wdsr_layer1_3x3_bias_3_get_layer1_bias_3(data)                     (0x000001FF&(data))

#define  SRNN_wdsr_layer1_3x3_bias_4                                            0x181AB12C
#define  SRNN_wdsr_layer1_3x3_bias_4_reg_addr                                    "0xB81AB12C"
#define  SRNN_wdsr_layer1_3x3_bias_4_reg                                         0xB81AB12C
#define  SRNN_wdsr_layer1_3x3_bias_4_inst_addr                                   "0x006F"
#define  set_SRNN_wdsr_layer1_3x3_bias_4_reg(data)                               (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_bias_4_reg)=data)
#define  get_SRNN_wdsr_layer1_3x3_bias_4_reg                                     (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_bias_4_reg))
#define  SRNN_wdsr_layer1_3x3_bias_4_layer1_bias_4_shift                         (0)
#define  SRNN_wdsr_layer1_3x3_bias_4_layer1_bias_4_mask                          (0x000001FF)
#define  SRNN_wdsr_layer1_3x3_bias_4_layer1_bias_4(data)                         (0x000001FF&(data))
#define  SRNN_wdsr_layer1_3x3_bias_4_get_layer1_bias_4(data)                     (0x000001FF&(data))

#define  SRNN_wdsr_layer1_3x3_bias_5                                            0x181AB130
#define  SRNN_wdsr_layer1_3x3_bias_5_reg_addr                                    "0xB81AB130"
#define  SRNN_wdsr_layer1_3x3_bias_5_reg                                         0xB81AB130
#define  SRNN_wdsr_layer1_3x3_bias_5_inst_addr                                   "0x0070"
#define  set_SRNN_wdsr_layer1_3x3_bias_5_reg(data)                               (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_bias_5_reg)=data)
#define  get_SRNN_wdsr_layer1_3x3_bias_5_reg                                     (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_bias_5_reg))
#define  SRNN_wdsr_layer1_3x3_bias_5_layer1_bias_5_shift                         (0)
#define  SRNN_wdsr_layer1_3x3_bias_5_layer1_bias_5_mask                          (0x000001FF)
#define  SRNN_wdsr_layer1_3x3_bias_5_layer1_bias_5(data)                         (0x000001FF&(data))
#define  SRNN_wdsr_layer1_3x3_bias_5_get_layer1_bias_5(data)                     (0x000001FF&(data))

#define  SRNN_wdsr_layer1_3x3_bias_6                                            0x181AB134
#define  SRNN_wdsr_layer1_3x3_bias_6_reg_addr                                    "0xB81AB134"
#define  SRNN_wdsr_layer1_3x3_bias_6_reg                                         0xB81AB134
#define  SRNN_wdsr_layer1_3x3_bias_6_inst_addr                                   "0x0071"
#define  set_SRNN_wdsr_layer1_3x3_bias_6_reg(data)                               (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_bias_6_reg)=data)
#define  get_SRNN_wdsr_layer1_3x3_bias_6_reg                                     (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_bias_6_reg))
#define  SRNN_wdsr_layer1_3x3_bias_6_layer1_bias_6_shift                         (0)
#define  SRNN_wdsr_layer1_3x3_bias_6_layer1_bias_6_mask                          (0x000001FF)
#define  SRNN_wdsr_layer1_3x3_bias_6_layer1_bias_6(data)                         (0x000001FF&(data))
#define  SRNN_wdsr_layer1_3x3_bias_6_get_layer1_bias_6(data)                     (0x000001FF&(data))

#define  SRNN_wdsr_layer1_3x3_bias_7                                            0x181AB138
#define  SRNN_wdsr_layer1_3x3_bias_7_reg_addr                                    "0xB81AB138"
#define  SRNN_wdsr_layer1_3x3_bias_7_reg                                         0xB81AB138
#define  SRNN_wdsr_layer1_3x3_bias_7_inst_addr                                   "0x0072"
#define  set_SRNN_wdsr_layer1_3x3_bias_7_reg(data)                               (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_bias_7_reg)=data)
#define  get_SRNN_wdsr_layer1_3x3_bias_7_reg                                     (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_bias_7_reg))
#define  SRNN_wdsr_layer1_3x3_bias_7_layer1_bias_7_shift                         (0)
#define  SRNN_wdsr_layer1_3x3_bias_7_layer1_bias_7_mask                          (0x000001FF)
#define  SRNN_wdsr_layer1_3x3_bias_7_layer1_bias_7(data)                         (0x000001FF&(data))
#define  SRNN_wdsr_layer1_3x3_bias_7_get_layer1_bias_7(data)                     (0x000001FF&(data))

#define  SRNN_wdsr_layer1_3x3_bias_8                                            0x181AB13C
#define  SRNN_wdsr_layer1_3x3_bias_8_reg_addr                                    "0xB81AB13C"
#define  SRNN_wdsr_layer1_3x3_bias_8_reg                                         0xB81AB13C
#define  SRNN_wdsr_layer1_3x3_bias_8_inst_addr                                   "0x0073"
#define  set_SRNN_wdsr_layer1_3x3_bias_8_reg(data)                               (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_bias_8_reg)=data)
#define  get_SRNN_wdsr_layer1_3x3_bias_8_reg                                     (*((volatile unsigned int*)SRNN_wdsr_layer1_3x3_bias_8_reg))
#define  SRNN_wdsr_layer1_3x3_bias_8_layer1_bias_8_shift                         (0)
#define  SRNN_wdsr_layer1_3x3_bias_8_layer1_bias_8_mask                          (0x000001FF)
#define  SRNN_wdsr_layer1_3x3_bias_8_layer1_bias_8(data)                         (0x000001FF&(data))
#define  SRNN_wdsr_layer1_3x3_bias_8_get_layer1_bias_8(data)                     (0x000001FF&(data))

#define  SRNN_wdsr_layer2_3x3_weights_1_00                                      0x181AB140
#define  SRNN_wdsr_layer2_3x3_weights_1_00_reg_addr                              "0xB81AB140"
#define  SRNN_wdsr_layer2_3x3_weights_1_00_reg                                   0xB81AB140
#define  SRNN_wdsr_layer2_3x3_weights_1_00_inst_addr                             "0x0074"
#define  set_SRNN_wdsr_layer2_3x3_weights_1_00_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_1_00_reg)=data)
#define  get_SRNN_wdsr_layer2_3x3_weights_1_00_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_1_00_reg))
#define  SRNN_wdsr_layer2_3x3_weights_1_00_layer2_weight_00_shift                (0)
#define  SRNN_wdsr_layer2_3x3_weights_1_00_layer2_weight_00_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer2_3x3_weights_1_00_layer2_weight_00(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer2_3x3_weights_1_00_get_layer2_weight_00(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer2_3x3_weights_1_01                                      0x181AB144
#define  SRNN_wdsr_layer2_3x3_weights_1_01_reg_addr                              "0xB81AB144"
#define  SRNN_wdsr_layer2_3x3_weights_1_01_reg                                   0xB81AB144
#define  SRNN_wdsr_layer2_3x3_weights_1_01_inst_addr                             "0x0075"
#define  set_SRNN_wdsr_layer2_3x3_weights_1_01_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_1_01_reg)=data)
#define  get_SRNN_wdsr_layer2_3x3_weights_1_01_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_1_01_reg))
#define  SRNN_wdsr_layer2_3x3_weights_1_01_layer2_weight_01_shift                (0)
#define  SRNN_wdsr_layer2_3x3_weights_1_01_layer2_weight_01_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer2_3x3_weights_1_01_layer2_weight_01(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer2_3x3_weights_1_01_get_layer2_weight_01(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer2_3x3_weights_1_02                                      0x181AB148
#define  SRNN_wdsr_layer2_3x3_weights_1_02_reg_addr                              "0xB81AB148"
#define  SRNN_wdsr_layer2_3x3_weights_1_02_reg                                   0xB81AB148
#define  SRNN_wdsr_layer2_3x3_weights_1_02_inst_addr                             "0x0076"
#define  set_SRNN_wdsr_layer2_3x3_weights_1_02_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_1_02_reg)=data)
#define  get_SRNN_wdsr_layer2_3x3_weights_1_02_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_1_02_reg))
#define  SRNN_wdsr_layer2_3x3_weights_1_02_layer2_weight_02_shift                (0)
#define  SRNN_wdsr_layer2_3x3_weights_1_02_layer2_weight_02_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer2_3x3_weights_1_02_layer2_weight_02(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer2_3x3_weights_1_02_get_layer2_weight_02(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer2_3x3_weights_1_10                                      0x181AB14C
#define  SRNN_wdsr_layer2_3x3_weights_1_10_reg_addr                              "0xB81AB14C"
#define  SRNN_wdsr_layer2_3x3_weights_1_10_reg                                   0xB81AB14C
#define  SRNN_wdsr_layer2_3x3_weights_1_10_inst_addr                             "0x0077"
#define  set_SRNN_wdsr_layer2_3x3_weights_1_10_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_1_10_reg)=data)
#define  get_SRNN_wdsr_layer2_3x3_weights_1_10_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_1_10_reg))
#define  SRNN_wdsr_layer2_3x3_weights_1_10_layer2_weight_10_shift                (0)
#define  SRNN_wdsr_layer2_3x3_weights_1_10_layer2_weight_10_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer2_3x3_weights_1_10_layer2_weight_10(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer2_3x3_weights_1_10_get_layer2_weight_10(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer2_3x3_weights_1_11                                      0x181AB150
#define  SRNN_wdsr_layer2_3x3_weights_1_11_reg_addr                              "0xB81AB150"
#define  SRNN_wdsr_layer2_3x3_weights_1_11_reg                                   0xB81AB150
#define  SRNN_wdsr_layer2_3x3_weights_1_11_inst_addr                             "0x0078"
#define  set_SRNN_wdsr_layer2_3x3_weights_1_11_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_1_11_reg)=data)
#define  get_SRNN_wdsr_layer2_3x3_weights_1_11_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_1_11_reg))
#define  SRNN_wdsr_layer2_3x3_weights_1_11_layer2_weight_11_shift                (0)
#define  SRNN_wdsr_layer2_3x3_weights_1_11_layer2_weight_11_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer2_3x3_weights_1_11_layer2_weight_11(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer2_3x3_weights_1_11_get_layer2_weight_11(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer2_3x3_weights_1_12                                      0x181AB154
#define  SRNN_wdsr_layer2_3x3_weights_1_12_reg_addr                              "0xB81AB154"
#define  SRNN_wdsr_layer2_3x3_weights_1_12_reg                                   0xB81AB154
#define  SRNN_wdsr_layer2_3x3_weights_1_12_inst_addr                             "0x0079"
#define  set_SRNN_wdsr_layer2_3x3_weights_1_12_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_1_12_reg)=data)
#define  get_SRNN_wdsr_layer2_3x3_weights_1_12_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_1_12_reg))
#define  SRNN_wdsr_layer2_3x3_weights_1_12_layer2_weight_12_shift                (0)
#define  SRNN_wdsr_layer2_3x3_weights_1_12_layer2_weight_12_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer2_3x3_weights_1_12_layer2_weight_12(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer2_3x3_weights_1_12_get_layer2_weight_12(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer2_3x3_weights_1_20                                      0x181AB158
#define  SRNN_wdsr_layer2_3x3_weights_1_20_reg_addr                              "0xB81AB158"
#define  SRNN_wdsr_layer2_3x3_weights_1_20_reg                                   0xB81AB158
#define  SRNN_wdsr_layer2_3x3_weights_1_20_inst_addr                             "0x007A"
#define  set_SRNN_wdsr_layer2_3x3_weights_1_20_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_1_20_reg)=data)
#define  get_SRNN_wdsr_layer2_3x3_weights_1_20_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_1_20_reg))
#define  SRNN_wdsr_layer2_3x3_weights_1_20_layer2_weight_20_shift                (0)
#define  SRNN_wdsr_layer2_3x3_weights_1_20_layer2_weight_20_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer2_3x3_weights_1_20_layer2_weight_20(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer2_3x3_weights_1_20_get_layer2_weight_20(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer2_3x3_weights_1_21                                      0x181AB15C
#define  SRNN_wdsr_layer2_3x3_weights_1_21_reg_addr                              "0xB81AB15C"
#define  SRNN_wdsr_layer2_3x3_weights_1_21_reg                                   0xB81AB15C
#define  SRNN_wdsr_layer2_3x3_weights_1_21_inst_addr                             "0x007B"
#define  set_SRNN_wdsr_layer2_3x3_weights_1_21_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_1_21_reg)=data)
#define  get_SRNN_wdsr_layer2_3x3_weights_1_21_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_1_21_reg))
#define  SRNN_wdsr_layer2_3x3_weights_1_21_layer2_weight_21_shift                (0)
#define  SRNN_wdsr_layer2_3x3_weights_1_21_layer2_weight_21_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer2_3x3_weights_1_21_layer2_weight_21(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer2_3x3_weights_1_21_get_layer2_weight_21(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer2_3x3_weights_1_22                                      0x181AB160
#define  SRNN_wdsr_layer2_3x3_weights_1_22_reg_addr                              "0xB81AB160"
#define  SRNN_wdsr_layer2_3x3_weights_1_22_reg                                   0xB81AB160
#define  SRNN_wdsr_layer2_3x3_weights_1_22_inst_addr                             "0x007C"
#define  set_SRNN_wdsr_layer2_3x3_weights_1_22_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_1_22_reg)=data)
#define  get_SRNN_wdsr_layer2_3x3_weights_1_22_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_1_22_reg))
#define  SRNN_wdsr_layer2_3x3_weights_1_22_layer2_weight_22_shift                (0)
#define  SRNN_wdsr_layer2_3x3_weights_1_22_layer2_weight_22_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer2_3x3_weights_1_22_layer2_weight_22(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer2_3x3_weights_1_22_get_layer2_weight_22(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer2_3x3_weights_2_00                                      0x181AB164
#define  SRNN_wdsr_layer2_3x3_weights_2_00_reg_addr                              "0xB81AB164"
#define  SRNN_wdsr_layer2_3x3_weights_2_00_reg                                   0xB81AB164
#define  SRNN_wdsr_layer2_3x3_weights_2_00_inst_addr                             "0x007D"
#define  set_SRNN_wdsr_layer2_3x3_weights_2_00_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_2_00_reg)=data)
#define  get_SRNN_wdsr_layer2_3x3_weights_2_00_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_2_00_reg))
#define  SRNN_wdsr_layer2_3x3_weights_2_00_layer2_weight_00_shift                (0)
#define  SRNN_wdsr_layer2_3x3_weights_2_00_layer2_weight_00_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer2_3x3_weights_2_00_layer2_weight_00(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer2_3x3_weights_2_00_get_layer2_weight_00(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer2_3x3_weights_2_01                                      0x181AB168
#define  SRNN_wdsr_layer2_3x3_weights_2_01_reg_addr                              "0xB81AB168"
#define  SRNN_wdsr_layer2_3x3_weights_2_01_reg                                   0xB81AB168
#define  SRNN_wdsr_layer2_3x3_weights_2_01_inst_addr                             "0x007E"
#define  set_SRNN_wdsr_layer2_3x3_weights_2_01_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_2_01_reg)=data)
#define  get_SRNN_wdsr_layer2_3x3_weights_2_01_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_2_01_reg))
#define  SRNN_wdsr_layer2_3x3_weights_2_01_layer2_weight_01_shift                (0)
#define  SRNN_wdsr_layer2_3x3_weights_2_01_layer2_weight_01_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer2_3x3_weights_2_01_layer2_weight_01(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer2_3x3_weights_2_01_get_layer2_weight_01(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer2_3x3_weights_2_02                                      0x181AB16C
#define  SRNN_wdsr_layer2_3x3_weights_2_02_reg_addr                              "0xB81AB16C"
#define  SRNN_wdsr_layer2_3x3_weights_2_02_reg                                   0xB81AB16C
#define  SRNN_wdsr_layer2_3x3_weights_2_02_inst_addr                             "0x007F"
#define  set_SRNN_wdsr_layer2_3x3_weights_2_02_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_2_02_reg)=data)
#define  get_SRNN_wdsr_layer2_3x3_weights_2_02_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_2_02_reg))
#define  SRNN_wdsr_layer2_3x3_weights_2_02_layer2_weight_02_shift                (0)
#define  SRNN_wdsr_layer2_3x3_weights_2_02_layer2_weight_02_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer2_3x3_weights_2_02_layer2_weight_02(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer2_3x3_weights_2_02_get_layer2_weight_02(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer2_3x3_weights_2_10                                      0x181AB170
#define  SRNN_wdsr_layer2_3x3_weights_2_10_reg_addr                              "0xB81AB170"
#define  SRNN_wdsr_layer2_3x3_weights_2_10_reg                                   0xB81AB170
#define  SRNN_wdsr_layer2_3x3_weights_2_10_inst_addr                             "0x0080"
#define  set_SRNN_wdsr_layer2_3x3_weights_2_10_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_2_10_reg)=data)
#define  get_SRNN_wdsr_layer2_3x3_weights_2_10_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_2_10_reg))
#define  SRNN_wdsr_layer2_3x3_weights_2_10_layer2_weight_10_shift                (0)
#define  SRNN_wdsr_layer2_3x3_weights_2_10_layer2_weight_10_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer2_3x3_weights_2_10_layer2_weight_10(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer2_3x3_weights_2_10_get_layer2_weight_10(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer2_3x3_weights_2_11                                      0x181AB174
#define  SRNN_wdsr_layer2_3x3_weights_2_11_reg_addr                              "0xB81AB174"
#define  SRNN_wdsr_layer2_3x3_weights_2_11_reg                                   0xB81AB174
#define  SRNN_wdsr_layer2_3x3_weights_2_11_inst_addr                             "0x0081"
#define  set_SRNN_wdsr_layer2_3x3_weights_2_11_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_2_11_reg)=data)
#define  get_SRNN_wdsr_layer2_3x3_weights_2_11_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_2_11_reg))
#define  SRNN_wdsr_layer2_3x3_weights_2_11_layer2_weight_11_shift                (0)
#define  SRNN_wdsr_layer2_3x3_weights_2_11_layer2_weight_11_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer2_3x3_weights_2_11_layer2_weight_11(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer2_3x3_weights_2_11_get_layer2_weight_11(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer2_3x3_weights_2_12                                      0x181AB178
#define  SRNN_wdsr_layer2_3x3_weights_2_12_reg_addr                              "0xB81AB178"
#define  SRNN_wdsr_layer2_3x3_weights_2_12_reg                                   0xB81AB178
#define  SRNN_wdsr_layer2_3x3_weights_2_12_inst_addr                             "0x0082"
#define  set_SRNN_wdsr_layer2_3x3_weights_2_12_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_2_12_reg)=data)
#define  get_SRNN_wdsr_layer2_3x3_weights_2_12_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_2_12_reg))
#define  SRNN_wdsr_layer2_3x3_weights_2_12_layer2_weight_12_shift                (0)
#define  SRNN_wdsr_layer2_3x3_weights_2_12_layer2_weight_12_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer2_3x3_weights_2_12_layer2_weight_12(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer2_3x3_weights_2_12_get_layer2_weight_12(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer2_3x3_weights_2_20                                      0x181AB17C
#define  SRNN_wdsr_layer2_3x3_weights_2_20_reg_addr                              "0xB81AB17C"
#define  SRNN_wdsr_layer2_3x3_weights_2_20_reg                                   0xB81AB17C
#define  SRNN_wdsr_layer2_3x3_weights_2_20_inst_addr                             "0x0083"
#define  set_SRNN_wdsr_layer2_3x3_weights_2_20_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_2_20_reg)=data)
#define  get_SRNN_wdsr_layer2_3x3_weights_2_20_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_2_20_reg))
#define  SRNN_wdsr_layer2_3x3_weights_2_20_layer2_weight_20_shift                (0)
#define  SRNN_wdsr_layer2_3x3_weights_2_20_layer2_weight_20_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer2_3x3_weights_2_20_layer2_weight_20(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer2_3x3_weights_2_20_get_layer2_weight_20(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer2_3x3_weights_2_21                                      0x181AB180
#define  SRNN_wdsr_layer2_3x3_weights_2_21_reg_addr                              "0xB81AB180"
#define  SRNN_wdsr_layer2_3x3_weights_2_21_reg                                   0xB81AB180
#define  SRNN_wdsr_layer2_3x3_weights_2_21_inst_addr                             "0x0084"
#define  set_SRNN_wdsr_layer2_3x3_weights_2_21_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_2_21_reg)=data)
#define  get_SRNN_wdsr_layer2_3x3_weights_2_21_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_2_21_reg))
#define  SRNN_wdsr_layer2_3x3_weights_2_21_layer2_weight_21_shift                (0)
#define  SRNN_wdsr_layer2_3x3_weights_2_21_layer2_weight_21_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer2_3x3_weights_2_21_layer2_weight_21(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer2_3x3_weights_2_21_get_layer2_weight_21(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer2_3x3_weights_2_22                                      0x181AB184
#define  SRNN_wdsr_layer2_3x3_weights_2_22_reg_addr                              "0xB81AB184"
#define  SRNN_wdsr_layer2_3x3_weights_2_22_reg                                   0xB81AB184
#define  SRNN_wdsr_layer2_3x3_weights_2_22_inst_addr                             "0x0085"
#define  set_SRNN_wdsr_layer2_3x3_weights_2_22_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_2_22_reg)=data)
#define  get_SRNN_wdsr_layer2_3x3_weights_2_22_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_2_22_reg))
#define  SRNN_wdsr_layer2_3x3_weights_2_22_layer2_weight_22_shift                (0)
#define  SRNN_wdsr_layer2_3x3_weights_2_22_layer2_weight_22_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer2_3x3_weights_2_22_layer2_weight_22(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer2_3x3_weights_2_22_get_layer2_weight_22(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer2_3x3_weights_3_00                                      0x181AB188
#define  SRNN_wdsr_layer2_3x3_weights_3_00_reg_addr                              "0xB81AB188"
#define  SRNN_wdsr_layer2_3x3_weights_3_00_reg                                   0xB81AB188
#define  SRNN_wdsr_layer2_3x3_weights_3_00_inst_addr                             "0x0086"
#define  set_SRNN_wdsr_layer2_3x3_weights_3_00_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_3_00_reg)=data)
#define  get_SRNN_wdsr_layer2_3x3_weights_3_00_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_3_00_reg))
#define  SRNN_wdsr_layer2_3x3_weights_3_00_layer2_weight_00_shift                (0)
#define  SRNN_wdsr_layer2_3x3_weights_3_00_layer2_weight_00_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer2_3x3_weights_3_00_layer2_weight_00(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer2_3x3_weights_3_00_get_layer2_weight_00(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer2_3x3_weights_3_01                                      0x181AB18C
#define  SRNN_wdsr_layer2_3x3_weights_3_01_reg_addr                              "0xB81AB18C"
#define  SRNN_wdsr_layer2_3x3_weights_3_01_reg                                   0xB81AB18C
#define  SRNN_wdsr_layer2_3x3_weights_3_01_inst_addr                             "0x0087"
#define  set_SRNN_wdsr_layer2_3x3_weights_3_01_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_3_01_reg)=data)
#define  get_SRNN_wdsr_layer2_3x3_weights_3_01_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_3_01_reg))
#define  SRNN_wdsr_layer2_3x3_weights_3_01_layer2_weight_01_shift                (0)
#define  SRNN_wdsr_layer2_3x3_weights_3_01_layer2_weight_01_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer2_3x3_weights_3_01_layer2_weight_01(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer2_3x3_weights_3_01_get_layer2_weight_01(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer2_3x3_weights_3_02                                      0x181AB190
#define  SRNN_wdsr_layer2_3x3_weights_3_02_reg_addr                              "0xB81AB190"
#define  SRNN_wdsr_layer2_3x3_weights_3_02_reg                                   0xB81AB190
#define  SRNN_wdsr_layer2_3x3_weights_3_02_inst_addr                             "0x0088"
#define  set_SRNN_wdsr_layer2_3x3_weights_3_02_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_3_02_reg)=data)
#define  get_SRNN_wdsr_layer2_3x3_weights_3_02_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_3_02_reg))
#define  SRNN_wdsr_layer2_3x3_weights_3_02_layer2_weight_02_shift                (0)
#define  SRNN_wdsr_layer2_3x3_weights_3_02_layer2_weight_02_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer2_3x3_weights_3_02_layer2_weight_02(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer2_3x3_weights_3_02_get_layer2_weight_02(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer2_3x3_weights_3_10                                      0x181AB194
#define  SRNN_wdsr_layer2_3x3_weights_3_10_reg_addr                              "0xB81AB194"
#define  SRNN_wdsr_layer2_3x3_weights_3_10_reg                                   0xB81AB194
#define  SRNN_wdsr_layer2_3x3_weights_3_10_inst_addr                             "0x0089"
#define  set_SRNN_wdsr_layer2_3x3_weights_3_10_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_3_10_reg)=data)
#define  get_SRNN_wdsr_layer2_3x3_weights_3_10_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_3_10_reg))
#define  SRNN_wdsr_layer2_3x3_weights_3_10_layer2_weight_10_shift                (0)
#define  SRNN_wdsr_layer2_3x3_weights_3_10_layer2_weight_10_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer2_3x3_weights_3_10_layer2_weight_10(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer2_3x3_weights_3_10_get_layer2_weight_10(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer2_3x3_weights_3_11                                      0x181AB198
#define  SRNN_wdsr_layer2_3x3_weights_3_11_reg_addr                              "0xB81AB198"
#define  SRNN_wdsr_layer2_3x3_weights_3_11_reg                                   0xB81AB198
#define  SRNN_wdsr_layer2_3x3_weights_3_11_inst_addr                             "0x008A"
#define  set_SRNN_wdsr_layer2_3x3_weights_3_11_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_3_11_reg)=data)
#define  get_SRNN_wdsr_layer2_3x3_weights_3_11_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_3_11_reg))
#define  SRNN_wdsr_layer2_3x3_weights_3_11_layer2_weight_11_shift                (0)
#define  SRNN_wdsr_layer2_3x3_weights_3_11_layer2_weight_11_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer2_3x3_weights_3_11_layer2_weight_11(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer2_3x3_weights_3_11_get_layer2_weight_11(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer2_3x3_weights_3_12                                      0x181AB19C
#define  SRNN_wdsr_layer2_3x3_weights_3_12_reg_addr                              "0xB81AB19C"
#define  SRNN_wdsr_layer2_3x3_weights_3_12_reg                                   0xB81AB19C
#define  SRNN_wdsr_layer2_3x3_weights_3_12_inst_addr                             "0x008B"
#define  set_SRNN_wdsr_layer2_3x3_weights_3_12_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_3_12_reg)=data)
#define  get_SRNN_wdsr_layer2_3x3_weights_3_12_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_3_12_reg))
#define  SRNN_wdsr_layer2_3x3_weights_3_12_layer2_weight_12_shift                (0)
#define  SRNN_wdsr_layer2_3x3_weights_3_12_layer2_weight_12_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer2_3x3_weights_3_12_layer2_weight_12(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer2_3x3_weights_3_12_get_layer2_weight_12(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer2_3x3_weights_3_20                                      0x181AB1A0
#define  SRNN_wdsr_layer2_3x3_weights_3_20_reg_addr                              "0xB81AB1A0"
#define  SRNN_wdsr_layer2_3x3_weights_3_20_reg                                   0xB81AB1A0
#define  SRNN_wdsr_layer2_3x3_weights_3_20_inst_addr                             "0x008C"
#define  set_SRNN_wdsr_layer2_3x3_weights_3_20_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_3_20_reg)=data)
#define  get_SRNN_wdsr_layer2_3x3_weights_3_20_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_3_20_reg))
#define  SRNN_wdsr_layer2_3x3_weights_3_20_layer2_weight_20_shift                (0)
#define  SRNN_wdsr_layer2_3x3_weights_3_20_layer2_weight_20_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer2_3x3_weights_3_20_layer2_weight_20(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer2_3x3_weights_3_20_get_layer2_weight_20(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer2_3x3_weights_3_21                                      0x181AB1A4
#define  SRNN_wdsr_layer2_3x3_weights_3_21_reg_addr                              "0xB81AB1A4"
#define  SRNN_wdsr_layer2_3x3_weights_3_21_reg                                   0xB81AB1A4
#define  SRNN_wdsr_layer2_3x3_weights_3_21_inst_addr                             "0x008D"
#define  set_SRNN_wdsr_layer2_3x3_weights_3_21_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_3_21_reg)=data)
#define  get_SRNN_wdsr_layer2_3x3_weights_3_21_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_3_21_reg))
#define  SRNN_wdsr_layer2_3x3_weights_3_21_layer2_weight_21_shift                (0)
#define  SRNN_wdsr_layer2_3x3_weights_3_21_layer2_weight_21_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer2_3x3_weights_3_21_layer2_weight_21(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer2_3x3_weights_3_21_get_layer2_weight_21(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer2_3x3_weights_3_22                                      0x181AB1A8
#define  SRNN_wdsr_layer2_3x3_weights_3_22_reg_addr                              "0xB81AB1A8"
#define  SRNN_wdsr_layer2_3x3_weights_3_22_reg                                   0xB81AB1A8
#define  SRNN_wdsr_layer2_3x3_weights_3_22_inst_addr                             "0x008E"
#define  set_SRNN_wdsr_layer2_3x3_weights_3_22_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_3_22_reg)=data)
#define  get_SRNN_wdsr_layer2_3x3_weights_3_22_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_3_22_reg))
#define  SRNN_wdsr_layer2_3x3_weights_3_22_layer2_weight_22_shift                (0)
#define  SRNN_wdsr_layer2_3x3_weights_3_22_layer2_weight_22_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer2_3x3_weights_3_22_layer2_weight_22(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer2_3x3_weights_3_22_get_layer2_weight_22(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer2_3x3_weights_4_00                                      0x181AB1AC
#define  SRNN_wdsr_layer2_3x3_weights_4_00_reg_addr                              "0xB81AB1AC"
#define  SRNN_wdsr_layer2_3x3_weights_4_00_reg                                   0xB81AB1AC
#define  SRNN_wdsr_layer2_3x3_weights_4_00_inst_addr                             "0x008F"
#define  set_SRNN_wdsr_layer2_3x3_weights_4_00_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_4_00_reg)=data)
#define  get_SRNN_wdsr_layer2_3x3_weights_4_00_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_4_00_reg))
#define  SRNN_wdsr_layer2_3x3_weights_4_00_layer2_weight_00_shift                (0)
#define  SRNN_wdsr_layer2_3x3_weights_4_00_layer2_weight_00_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer2_3x3_weights_4_00_layer2_weight_00(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer2_3x3_weights_4_00_get_layer2_weight_00(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer2_3x3_weights_4_01                                      0x181AB1B0
#define  SRNN_wdsr_layer2_3x3_weights_4_01_reg_addr                              "0xB81AB1B0"
#define  SRNN_wdsr_layer2_3x3_weights_4_01_reg                                   0xB81AB1B0
#define  SRNN_wdsr_layer2_3x3_weights_4_01_inst_addr                             "0x0090"
#define  set_SRNN_wdsr_layer2_3x3_weights_4_01_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_4_01_reg)=data)
#define  get_SRNN_wdsr_layer2_3x3_weights_4_01_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_4_01_reg))
#define  SRNN_wdsr_layer2_3x3_weights_4_01_layer2_weight_01_shift                (0)
#define  SRNN_wdsr_layer2_3x3_weights_4_01_layer2_weight_01_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer2_3x3_weights_4_01_layer2_weight_01(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer2_3x3_weights_4_01_get_layer2_weight_01(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer2_3x3_weights_4_02                                      0x181AB1B4
#define  SRNN_wdsr_layer2_3x3_weights_4_02_reg_addr                              "0xB81AB1B4"
#define  SRNN_wdsr_layer2_3x3_weights_4_02_reg                                   0xB81AB1B4
#define  SRNN_wdsr_layer2_3x3_weights_4_02_inst_addr                             "0x0091"
#define  set_SRNN_wdsr_layer2_3x3_weights_4_02_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_4_02_reg)=data)
#define  get_SRNN_wdsr_layer2_3x3_weights_4_02_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_4_02_reg))
#define  SRNN_wdsr_layer2_3x3_weights_4_02_layer2_weight_02_shift                (0)
#define  SRNN_wdsr_layer2_3x3_weights_4_02_layer2_weight_02_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer2_3x3_weights_4_02_layer2_weight_02(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer2_3x3_weights_4_02_get_layer2_weight_02(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer2_3x3_weights_4_10                                      0x181AB1B8
#define  SRNN_wdsr_layer2_3x3_weights_4_10_reg_addr                              "0xB81AB1B8"
#define  SRNN_wdsr_layer2_3x3_weights_4_10_reg                                   0xB81AB1B8
#define  SRNN_wdsr_layer2_3x3_weights_4_10_inst_addr                             "0x0092"
#define  set_SRNN_wdsr_layer2_3x3_weights_4_10_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_4_10_reg)=data)
#define  get_SRNN_wdsr_layer2_3x3_weights_4_10_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_4_10_reg))
#define  SRNN_wdsr_layer2_3x3_weights_4_10_layer2_weight_10_shift                (0)
#define  SRNN_wdsr_layer2_3x3_weights_4_10_layer2_weight_10_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer2_3x3_weights_4_10_layer2_weight_10(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer2_3x3_weights_4_10_get_layer2_weight_10(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer2_3x3_weights_4_11                                      0x181AB1BC
#define  SRNN_wdsr_layer2_3x3_weights_4_11_reg_addr                              "0xB81AB1BC"
#define  SRNN_wdsr_layer2_3x3_weights_4_11_reg                                   0xB81AB1BC
#define  SRNN_wdsr_layer2_3x3_weights_4_11_inst_addr                             "0x0093"
#define  set_SRNN_wdsr_layer2_3x3_weights_4_11_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_4_11_reg)=data)
#define  get_SRNN_wdsr_layer2_3x3_weights_4_11_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_4_11_reg))
#define  SRNN_wdsr_layer2_3x3_weights_4_11_layer2_weight_11_shift                (0)
#define  SRNN_wdsr_layer2_3x3_weights_4_11_layer2_weight_11_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer2_3x3_weights_4_11_layer2_weight_11(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer2_3x3_weights_4_11_get_layer2_weight_11(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer2_3x3_weights_4_12                                      0x181AB1C0
#define  SRNN_wdsr_layer2_3x3_weights_4_12_reg_addr                              "0xB81AB1C0"
#define  SRNN_wdsr_layer2_3x3_weights_4_12_reg                                   0xB81AB1C0
#define  SRNN_wdsr_layer2_3x3_weights_4_12_inst_addr                             "0x0094"
#define  set_SRNN_wdsr_layer2_3x3_weights_4_12_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_4_12_reg)=data)
#define  get_SRNN_wdsr_layer2_3x3_weights_4_12_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_4_12_reg))
#define  SRNN_wdsr_layer2_3x3_weights_4_12_layer2_weight_12_shift                (0)
#define  SRNN_wdsr_layer2_3x3_weights_4_12_layer2_weight_12_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer2_3x3_weights_4_12_layer2_weight_12(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer2_3x3_weights_4_12_get_layer2_weight_12(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer2_3x3_weights_4_20                                      0x181AB1C4
#define  SRNN_wdsr_layer2_3x3_weights_4_20_reg_addr                              "0xB81AB1C4"
#define  SRNN_wdsr_layer2_3x3_weights_4_20_reg                                   0xB81AB1C4
#define  SRNN_wdsr_layer2_3x3_weights_4_20_inst_addr                             "0x0095"
#define  set_SRNN_wdsr_layer2_3x3_weights_4_20_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_4_20_reg)=data)
#define  get_SRNN_wdsr_layer2_3x3_weights_4_20_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_4_20_reg))
#define  SRNN_wdsr_layer2_3x3_weights_4_20_layer2_weight_20_shift                (0)
#define  SRNN_wdsr_layer2_3x3_weights_4_20_layer2_weight_20_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer2_3x3_weights_4_20_layer2_weight_20(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer2_3x3_weights_4_20_get_layer2_weight_20(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer2_3x3_weights_4_21                                      0x181AB1C8
#define  SRNN_wdsr_layer2_3x3_weights_4_21_reg_addr                              "0xB81AB1C8"
#define  SRNN_wdsr_layer2_3x3_weights_4_21_reg                                   0xB81AB1C8
#define  SRNN_wdsr_layer2_3x3_weights_4_21_inst_addr                             "0x0096"
#define  set_SRNN_wdsr_layer2_3x3_weights_4_21_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_4_21_reg)=data)
#define  get_SRNN_wdsr_layer2_3x3_weights_4_21_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_4_21_reg))
#define  SRNN_wdsr_layer2_3x3_weights_4_21_layer2_weight_21_shift                (0)
#define  SRNN_wdsr_layer2_3x3_weights_4_21_layer2_weight_21_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer2_3x3_weights_4_21_layer2_weight_21(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer2_3x3_weights_4_21_get_layer2_weight_21(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer2_3x3_weights_4_22                                      0x181AB1CC
#define  SRNN_wdsr_layer2_3x3_weights_4_22_reg_addr                              "0xB81AB1CC"
#define  SRNN_wdsr_layer2_3x3_weights_4_22_reg                                   0xB81AB1CC
#define  SRNN_wdsr_layer2_3x3_weights_4_22_inst_addr                             "0x0097"
#define  set_SRNN_wdsr_layer2_3x3_weights_4_22_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_4_22_reg)=data)
#define  get_SRNN_wdsr_layer2_3x3_weights_4_22_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_4_22_reg))
#define  SRNN_wdsr_layer2_3x3_weights_4_22_layer2_weight_22_shift                (0)
#define  SRNN_wdsr_layer2_3x3_weights_4_22_layer2_weight_22_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer2_3x3_weights_4_22_layer2_weight_22(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer2_3x3_weights_4_22_get_layer2_weight_22(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer2_3x3_weights_5_00                                      0x181AB1D0
#define  SRNN_wdsr_layer2_3x3_weights_5_00_reg_addr                              "0xB81AB1D0"
#define  SRNN_wdsr_layer2_3x3_weights_5_00_reg                                   0xB81AB1D0
#define  SRNN_wdsr_layer2_3x3_weights_5_00_inst_addr                             "0x0098"
#define  set_SRNN_wdsr_layer2_3x3_weights_5_00_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_5_00_reg)=data)
#define  get_SRNN_wdsr_layer2_3x3_weights_5_00_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_5_00_reg))
#define  SRNN_wdsr_layer2_3x3_weights_5_00_layer2_weight_00_shift                (0)
#define  SRNN_wdsr_layer2_3x3_weights_5_00_layer2_weight_00_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer2_3x3_weights_5_00_layer2_weight_00(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer2_3x3_weights_5_00_get_layer2_weight_00(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer2_3x3_weights_5_01                                      0x181AB1D4
#define  SRNN_wdsr_layer2_3x3_weights_5_01_reg_addr                              "0xB81AB1D4"
#define  SRNN_wdsr_layer2_3x3_weights_5_01_reg                                   0xB81AB1D4
#define  SRNN_wdsr_layer2_3x3_weights_5_01_inst_addr                             "0x0099"
#define  set_SRNN_wdsr_layer2_3x3_weights_5_01_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_5_01_reg)=data)
#define  get_SRNN_wdsr_layer2_3x3_weights_5_01_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_5_01_reg))
#define  SRNN_wdsr_layer2_3x3_weights_5_01_layer2_weight_01_shift                (0)
#define  SRNN_wdsr_layer2_3x3_weights_5_01_layer2_weight_01_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer2_3x3_weights_5_01_layer2_weight_01(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer2_3x3_weights_5_01_get_layer2_weight_01(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer2_3x3_weights_5_02                                      0x181AB1D8
#define  SRNN_wdsr_layer2_3x3_weights_5_02_reg_addr                              "0xB81AB1D8"
#define  SRNN_wdsr_layer2_3x3_weights_5_02_reg                                   0xB81AB1D8
#define  SRNN_wdsr_layer2_3x3_weights_5_02_inst_addr                             "0x009A"
#define  set_SRNN_wdsr_layer2_3x3_weights_5_02_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_5_02_reg)=data)
#define  get_SRNN_wdsr_layer2_3x3_weights_5_02_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_5_02_reg))
#define  SRNN_wdsr_layer2_3x3_weights_5_02_layer2_weight_02_shift                (0)
#define  SRNN_wdsr_layer2_3x3_weights_5_02_layer2_weight_02_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer2_3x3_weights_5_02_layer2_weight_02(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer2_3x3_weights_5_02_get_layer2_weight_02(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer2_3x3_weights_5_10                                      0x181AB1DC
#define  SRNN_wdsr_layer2_3x3_weights_5_10_reg_addr                              "0xB81AB1DC"
#define  SRNN_wdsr_layer2_3x3_weights_5_10_reg                                   0xB81AB1DC
#define  SRNN_wdsr_layer2_3x3_weights_5_10_inst_addr                             "0x009B"
#define  set_SRNN_wdsr_layer2_3x3_weights_5_10_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_5_10_reg)=data)
#define  get_SRNN_wdsr_layer2_3x3_weights_5_10_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_5_10_reg))
#define  SRNN_wdsr_layer2_3x3_weights_5_10_layer2_weight_10_shift                (0)
#define  SRNN_wdsr_layer2_3x3_weights_5_10_layer2_weight_10_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer2_3x3_weights_5_10_layer2_weight_10(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer2_3x3_weights_5_10_get_layer2_weight_10(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer2_3x3_weights_5_11                                      0x181AB1E0
#define  SRNN_wdsr_layer2_3x3_weights_5_11_reg_addr                              "0xB81AB1E0"
#define  SRNN_wdsr_layer2_3x3_weights_5_11_reg                                   0xB81AB1E0
#define  SRNN_wdsr_layer2_3x3_weights_5_11_inst_addr                             "0x009C"
#define  set_SRNN_wdsr_layer2_3x3_weights_5_11_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_5_11_reg)=data)
#define  get_SRNN_wdsr_layer2_3x3_weights_5_11_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_5_11_reg))
#define  SRNN_wdsr_layer2_3x3_weights_5_11_layer2_weight_11_shift                (0)
#define  SRNN_wdsr_layer2_3x3_weights_5_11_layer2_weight_11_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer2_3x3_weights_5_11_layer2_weight_11(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer2_3x3_weights_5_11_get_layer2_weight_11(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer2_3x3_weights_5_12                                      0x181AB1E4
#define  SRNN_wdsr_layer2_3x3_weights_5_12_reg_addr                              "0xB81AB1E4"
#define  SRNN_wdsr_layer2_3x3_weights_5_12_reg                                   0xB81AB1E4
#define  SRNN_wdsr_layer2_3x3_weights_5_12_inst_addr                             "0x009D"
#define  set_SRNN_wdsr_layer2_3x3_weights_5_12_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_5_12_reg)=data)
#define  get_SRNN_wdsr_layer2_3x3_weights_5_12_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_5_12_reg))
#define  SRNN_wdsr_layer2_3x3_weights_5_12_layer2_weight_12_shift                (0)
#define  SRNN_wdsr_layer2_3x3_weights_5_12_layer2_weight_12_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer2_3x3_weights_5_12_layer2_weight_12(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer2_3x3_weights_5_12_get_layer2_weight_12(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer2_3x3_weights_5_20                                      0x181AB1E8
#define  SRNN_wdsr_layer2_3x3_weights_5_20_reg_addr                              "0xB81AB1E8"
#define  SRNN_wdsr_layer2_3x3_weights_5_20_reg                                   0xB81AB1E8
#define  SRNN_wdsr_layer2_3x3_weights_5_20_inst_addr                             "0x009E"
#define  set_SRNN_wdsr_layer2_3x3_weights_5_20_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_5_20_reg)=data)
#define  get_SRNN_wdsr_layer2_3x3_weights_5_20_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_5_20_reg))
#define  SRNN_wdsr_layer2_3x3_weights_5_20_layer2_weight_20_shift                (0)
#define  SRNN_wdsr_layer2_3x3_weights_5_20_layer2_weight_20_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer2_3x3_weights_5_20_layer2_weight_20(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer2_3x3_weights_5_20_get_layer2_weight_20(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer2_3x3_weights_5_21                                      0x181AB1EC
#define  SRNN_wdsr_layer2_3x3_weights_5_21_reg_addr                              "0xB81AB1EC"
#define  SRNN_wdsr_layer2_3x3_weights_5_21_reg                                   0xB81AB1EC
#define  SRNN_wdsr_layer2_3x3_weights_5_21_inst_addr                             "0x009F"
#define  set_SRNN_wdsr_layer2_3x3_weights_5_21_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_5_21_reg)=data)
#define  get_SRNN_wdsr_layer2_3x3_weights_5_21_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_5_21_reg))
#define  SRNN_wdsr_layer2_3x3_weights_5_21_layer2_weight_21_shift                (0)
#define  SRNN_wdsr_layer2_3x3_weights_5_21_layer2_weight_21_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer2_3x3_weights_5_21_layer2_weight_21(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer2_3x3_weights_5_21_get_layer2_weight_21(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer2_3x3_weights_5_22                                      0x181AB1F0
#define  SRNN_wdsr_layer2_3x3_weights_5_22_reg_addr                              "0xB81AB1F0"
#define  SRNN_wdsr_layer2_3x3_weights_5_22_reg                                   0xB81AB1F0
#define  SRNN_wdsr_layer2_3x3_weights_5_22_inst_addr                             "0x00A0"
#define  set_SRNN_wdsr_layer2_3x3_weights_5_22_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_5_22_reg)=data)
#define  get_SRNN_wdsr_layer2_3x3_weights_5_22_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_5_22_reg))
#define  SRNN_wdsr_layer2_3x3_weights_5_22_layer2_weight_22_shift                (0)
#define  SRNN_wdsr_layer2_3x3_weights_5_22_layer2_weight_22_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer2_3x3_weights_5_22_layer2_weight_22(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer2_3x3_weights_5_22_get_layer2_weight_22(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer2_3x3_weights_6_00                                      0x181AB1F4
#define  SRNN_wdsr_layer2_3x3_weights_6_00_reg_addr                              "0xB81AB1F4"
#define  SRNN_wdsr_layer2_3x3_weights_6_00_reg                                   0xB81AB1F4
#define  SRNN_wdsr_layer2_3x3_weights_6_00_inst_addr                             "0x00A1"
#define  set_SRNN_wdsr_layer2_3x3_weights_6_00_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_6_00_reg)=data)
#define  get_SRNN_wdsr_layer2_3x3_weights_6_00_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_6_00_reg))
#define  SRNN_wdsr_layer2_3x3_weights_6_00_layer2_weight_00_shift                (0)
#define  SRNN_wdsr_layer2_3x3_weights_6_00_layer2_weight_00_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer2_3x3_weights_6_00_layer2_weight_00(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer2_3x3_weights_6_00_get_layer2_weight_00(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer2_3x3_weights_6_01                                      0x181AB1F8
#define  SRNN_wdsr_layer2_3x3_weights_6_01_reg_addr                              "0xB81AB1F8"
#define  SRNN_wdsr_layer2_3x3_weights_6_01_reg                                   0xB81AB1F8
#define  SRNN_wdsr_layer2_3x3_weights_6_01_inst_addr                             "0x00A2"
#define  set_SRNN_wdsr_layer2_3x3_weights_6_01_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_6_01_reg)=data)
#define  get_SRNN_wdsr_layer2_3x3_weights_6_01_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_6_01_reg))
#define  SRNN_wdsr_layer2_3x3_weights_6_01_layer2_weight_01_shift                (0)
#define  SRNN_wdsr_layer2_3x3_weights_6_01_layer2_weight_01_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer2_3x3_weights_6_01_layer2_weight_01(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer2_3x3_weights_6_01_get_layer2_weight_01(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer2_3x3_weights_6_02                                      0x181AB1FC
#define  SRNN_wdsr_layer2_3x3_weights_6_02_reg_addr                              "0xB81AB1FC"
#define  SRNN_wdsr_layer2_3x3_weights_6_02_reg                                   0xB81AB1FC
#define  SRNN_wdsr_layer2_3x3_weights_6_02_inst_addr                             "0x00A3"
#define  set_SRNN_wdsr_layer2_3x3_weights_6_02_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_6_02_reg)=data)
#define  get_SRNN_wdsr_layer2_3x3_weights_6_02_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_6_02_reg))
#define  SRNN_wdsr_layer2_3x3_weights_6_02_layer2_weight_02_shift                (0)
#define  SRNN_wdsr_layer2_3x3_weights_6_02_layer2_weight_02_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer2_3x3_weights_6_02_layer2_weight_02(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer2_3x3_weights_6_02_get_layer2_weight_02(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer2_3x3_weights_6_10                                      0x181AB200
#define  SRNN_wdsr_layer2_3x3_weights_6_10_reg_addr                              "0xB81AB200"
#define  SRNN_wdsr_layer2_3x3_weights_6_10_reg                                   0xB81AB200
#define  SRNN_wdsr_layer2_3x3_weights_6_10_inst_addr                             "0x00A4"
#define  set_SRNN_wdsr_layer2_3x3_weights_6_10_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_6_10_reg)=data)
#define  get_SRNN_wdsr_layer2_3x3_weights_6_10_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_6_10_reg))
#define  SRNN_wdsr_layer2_3x3_weights_6_10_layer2_weight_10_shift                (0)
#define  SRNN_wdsr_layer2_3x3_weights_6_10_layer2_weight_10_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer2_3x3_weights_6_10_layer2_weight_10(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer2_3x3_weights_6_10_get_layer2_weight_10(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer2_3x3_weights_6_11                                      0x181AB204
#define  SRNN_wdsr_layer2_3x3_weights_6_11_reg_addr                              "0xB81AB204"
#define  SRNN_wdsr_layer2_3x3_weights_6_11_reg                                   0xB81AB204
#define  SRNN_wdsr_layer2_3x3_weights_6_11_inst_addr                             "0x00A5"
#define  set_SRNN_wdsr_layer2_3x3_weights_6_11_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_6_11_reg)=data)
#define  get_SRNN_wdsr_layer2_3x3_weights_6_11_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_6_11_reg))
#define  SRNN_wdsr_layer2_3x3_weights_6_11_layer2_weight_11_shift                (0)
#define  SRNN_wdsr_layer2_3x3_weights_6_11_layer2_weight_11_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer2_3x3_weights_6_11_layer2_weight_11(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer2_3x3_weights_6_11_get_layer2_weight_11(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer2_3x3_weights_6_12                                      0x181AB208
#define  SRNN_wdsr_layer2_3x3_weights_6_12_reg_addr                              "0xB81AB208"
#define  SRNN_wdsr_layer2_3x3_weights_6_12_reg                                   0xB81AB208
#define  SRNN_wdsr_layer2_3x3_weights_6_12_inst_addr                             "0x00A6"
#define  set_SRNN_wdsr_layer2_3x3_weights_6_12_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_6_12_reg)=data)
#define  get_SRNN_wdsr_layer2_3x3_weights_6_12_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_6_12_reg))
#define  SRNN_wdsr_layer2_3x3_weights_6_12_layer2_weight_12_shift                (0)
#define  SRNN_wdsr_layer2_3x3_weights_6_12_layer2_weight_12_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer2_3x3_weights_6_12_layer2_weight_12(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer2_3x3_weights_6_12_get_layer2_weight_12(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer2_3x3_weights_6_20                                      0x181AB20C
#define  SRNN_wdsr_layer2_3x3_weights_6_20_reg_addr                              "0xB81AB20C"
#define  SRNN_wdsr_layer2_3x3_weights_6_20_reg                                   0xB81AB20C
#define  SRNN_wdsr_layer2_3x3_weights_6_20_inst_addr                             "0x00A7"
#define  set_SRNN_wdsr_layer2_3x3_weights_6_20_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_6_20_reg)=data)
#define  get_SRNN_wdsr_layer2_3x3_weights_6_20_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_6_20_reg))
#define  SRNN_wdsr_layer2_3x3_weights_6_20_layer2_weight_20_shift                (0)
#define  SRNN_wdsr_layer2_3x3_weights_6_20_layer2_weight_20_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer2_3x3_weights_6_20_layer2_weight_20(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer2_3x3_weights_6_20_get_layer2_weight_20(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer2_3x3_weights_6_21                                      0x181AB210
#define  SRNN_wdsr_layer2_3x3_weights_6_21_reg_addr                              "0xB81AB210"
#define  SRNN_wdsr_layer2_3x3_weights_6_21_reg                                   0xB81AB210
#define  SRNN_wdsr_layer2_3x3_weights_6_21_inst_addr                             "0x00A8"
#define  set_SRNN_wdsr_layer2_3x3_weights_6_21_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_6_21_reg)=data)
#define  get_SRNN_wdsr_layer2_3x3_weights_6_21_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_6_21_reg))
#define  SRNN_wdsr_layer2_3x3_weights_6_21_layer2_weight_21_shift                (0)
#define  SRNN_wdsr_layer2_3x3_weights_6_21_layer2_weight_21_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer2_3x3_weights_6_21_layer2_weight_21(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer2_3x3_weights_6_21_get_layer2_weight_21(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer2_3x3_weights_6_22                                      0x181AB214
#define  SRNN_wdsr_layer2_3x3_weights_6_22_reg_addr                              "0xB81AB214"
#define  SRNN_wdsr_layer2_3x3_weights_6_22_reg                                   0xB81AB214
#define  SRNN_wdsr_layer2_3x3_weights_6_22_inst_addr                             "0x00A9"
#define  set_SRNN_wdsr_layer2_3x3_weights_6_22_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_6_22_reg)=data)
#define  get_SRNN_wdsr_layer2_3x3_weights_6_22_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_6_22_reg))
#define  SRNN_wdsr_layer2_3x3_weights_6_22_layer2_weight_22_shift                (0)
#define  SRNN_wdsr_layer2_3x3_weights_6_22_layer2_weight_22_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer2_3x3_weights_6_22_layer2_weight_22(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer2_3x3_weights_6_22_get_layer2_weight_22(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer2_3x3_weights_7_00                                      0x181AB218
#define  SRNN_wdsr_layer2_3x3_weights_7_00_reg_addr                              "0xB81AB218"
#define  SRNN_wdsr_layer2_3x3_weights_7_00_reg                                   0xB81AB218
#define  SRNN_wdsr_layer2_3x3_weights_7_00_inst_addr                             "0x00AA"
#define  set_SRNN_wdsr_layer2_3x3_weights_7_00_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_7_00_reg)=data)
#define  get_SRNN_wdsr_layer2_3x3_weights_7_00_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_7_00_reg))
#define  SRNN_wdsr_layer2_3x3_weights_7_00_layer2_weight_00_shift                (0)
#define  SRNN_wdsr_layer2_3x3_weights_7_00_layer2_weight_00_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer2_3x3_weights_7_00_layer2_weight_00(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer2_3x3_weights_7_00_get_layer2_weight_00(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer2_3x3_weights_7_01                                      0x181AB21C
#define  SRNN_wdsr_layer2_3x3_weights_7_01_reg_addr                              "0xB81AB21C"
#define  SRNN_wdsr_layer2_3x3_weights_7_01_reg                                   0xB81AB21C
#define  SRNN_wdsr_layer2_3x3_weights_7_01_inst_addr                             "0x00AB"
#define  set_SRNN_wdsr_layer2_3x3_weights_7_01_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_7_01_reg)=data)
#define  get_SRNN_wdsr_layer2_3x3_weights_7_01_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_7_01_reg))
#define  SRNN_wdsr_layer2_3x3_weights_7_01_layer2_weight_01_shift                (0)
#define  SRNN_wdsr_layer2_3x3_weights_7_01_layer2_weight_01_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer2_3x3_weights_7_01_layer2_weight_01(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer2_3x3_weights_7_01_get_layer2_weight_01(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer2_3x3_weights_7_02                                      0x181AB220
#define  SRNN_wdsr_layer2_3x3_weights_7_02_reg_addr                              "0xB81AB220"
#define  SRNN_wdsr_layer2_3x3_weights_7_02_reg                                   0xB81AB220
#define  SRNN_wdsr_layer2_3x3_weights_7_02_inst_addr                             "0x00AC"
#define  set_SRNN_wdsr_layer2_3x3_weights_7_02_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_7_02_reg)=data)
#define  get_SRNN_wdsr_layer2_3x3_weights_7_02_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_7_02_reg))
#define  SRNN_wdsr_layer2_3x3_weights_7_02_layer2_weight_02_shift                (0)
#define  SRNN_wdsr_layer2_3x3_weights_7_02_layer2_weight_02_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer2_3x3_weights_7_02_layer2_weight_02(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer2_3x3_weights_7_02_get_layer2_weight_02(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer2_3x3_weights_7_10                                      0x181AB224
#define  SRNN_wdsr_layer2_3x3_weights_7_10_reg_addr                              "0xB81AB224"
#define  SRNN_wdsr_layer2_3x3_weights_7_10_reg                                   0xB81AB224
#define  SRNN_wdsr_layer2_3x3_weights_7_10_inst_addr                             "0x00AD"
#define  set_SRNN_wdsr_layer2_3x3_weights_7_10_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_7_10_reg)=data)
#define  get_SRNN_wdsr_layer2_3x3_weights_7_10_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_7_10_reg))
#define  SRNN_wdsr_layer2_3x3_weights_7_10_layer2_weight_10_shift                (0)
#define  SRNN_wdsr_layer2_3x3_weights_7_10_layer2_weight_10_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer2_3x3_weights_7_10_layer2_weight_10(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer2_3x3_weights_7_10_get_layer2_weight_10(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer2_3x3_weights_7_11                                      0x181AB228
#define  SRNN_wdsr_layer2_3x3_weights_7_11_reg_addr                              "0xB81AB228"
#define  SRNN_wdsr_layer2_3x3_weights_7_11_reg                                   0xB81AB228
#define  SRNN_wdsr_layer2_3x3_weights_7_11_inst_addr                             "0x00AE"
#define  set_SRNN_wdsr_layer2_3x3_weights_7_11_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_7_11_reg)=data)
#define  get_SRNN_wdsr_layer2_3x3_weights_7_11_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_7_11_reg))
#define  SRNN_wdsr_layer2_3x3_weights_7_11_layer2_weight_11_shift                (0)
#define  SRNN_wdsr_layer2_3x3_weights_7_11_layer2_weight_11_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer2_3x3_weights_7_11_layer2_weight_11(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer2_3x3_weights_7_11_get_layer2_weight_11(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer2_3x3_weights_7_12                                      0x181AB22C
#define  SRNN_wdsr_layer2_3x3_weights_7_12_reg_addr                              "0xB81AB22C"
#define  SRNN_wdsr_layer2_3x3_weights_7_12_reg                                   0xB81AB22C
#define  SRNN_wdsr_layer2_3x3_weights_7_12_inst_addr                             "0x00AF"
#define  set_SRNN_wdsr_layer2_3x3_weights_7_12_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_7_12_reg)=data)
#define  get_SRNN_wdsr_layer2_3x3_weights_7_12_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_7_12_reg))
#define  SRNN_wdsr_layer2_3x3_weights_7_12_layer2_weight_12_shift                (0)
#define  SRNN_wdsr_layer2_3x3_weights_7_12_layer2_weight_12_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer2_3x3_weights_7_12_layer2_weight_12(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer2_3x3_weights_7_12_get_layer2_weight_12(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer2_3x3_weights_7_20                                      0x181AB230
#define  SRNN_wdsr_layer2_3x3_weights_7_20_reg_addr                              "0xB81AB230"
#define  SRNN_wdsr_layer2_3x3_weights_7_20_reg                                   0xB81AB230
#define  SRNN_wdsr_layer2_3x3_weights_7_20_inst_addr                             "0x00B0"
#define  set_SRNN_wdsr_layer2_3x3_weights_7_20_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_7_20_reg)=data)
#define  get_SRNN_wdsr_layer2_3x3_weights_7_20_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_7_20_reg))
#define  SRNN_wdsr_layer2_3x3_weights_7_20_layer2_weight_20_shift                (0)
#define  SRNN_wdsr_layer2_3x3_weights_7_20_layer2_weight_20_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer2_3x3_weights_7_20_layer2_weight_20(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer2_3x3_weights_7_20_get_layer2_weight_20(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer2_3x3_weights_7_21                                      0x181AB234
#define  SRNN_wdsr_layer2_3x3_weights_7_21_reg_addr                              "0xB81AB234"
#define  SRNN_wdsr_layer2_3x3_weights_7_21_reg                                   0xB81AB234
#define  SRNN_wdsr_layer2_3x3_weights_7_21_inst_addr                             "0x00B1"
#define  set_SRNN_wdsr_layer2_3x3_weights_7_21_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_7_21_reg)=data)
#define  get_SRNN_wdsr_layer2_3x3_weights_7_21_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_7_21_reg))
#define  SRNN_wdsr_layer2_3x3_weights_7_21_layer2_weight_21_shift                (0)
#define  SRNN_wdsr_layer2_3x3_weights_7_21_layer2_weight_21_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer2_3x3_weights_7_21_layer2_weight_21(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer2_3x3_weights_7_21_get_layer2_weight_21(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer2_3x3_weights_7_22                                      0x181AB238
#define  SRNN_wdsr_layer2_3x3_weights_7_22_reg_addr                              "0xB81AB238"
#define  SRNN_wdsr_layer2_3x3_weights_7_22_reg                                   0xB81AB238
#define  SRNN_wdsr_layer2_3x3_weights_7_22_inst_addr                             "0x00B2"
#define  set_SRNN_wdsr_layer2_3x3_weights_7_22_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_7_22_reg)=data)
#define  get_SRNN_wdsr_layer2_3x3_weights_7_22_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_7_22_reg))
#define  SRNN_wdsr_layer2_3x3_weights_7_22_layer2_weight_22_shift                (0)
#define  SRNN_wdsr_layer2_3x3_weights_7_22_layer2_weight_22_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer2_3x3_weights_7_22_layer2_weight_22(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer2_3x3_weights_7_22_get_layer2_weight_22(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer2_3x3_weights_8_00                                      0x181AB23C
#define  SRNN_wdsr_layer2_3x3_weights_8_00_reg_addr                              "0xB81AB23C"
#define  SRNN_wdsr_layer2_3x3_weights_8_00_reg                                   0xB81AB23C
#define  SRNN_wdsr_layer2_3x3_weights_8_00_inst_addr                             "0x00B3"
#define  set_SRNN_wdsr_layer2_3x3_weights_8_00_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_8_00_reg)=data)
#define  get_SRNN_wdsr_layer2_3x3_weights_8_00_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_8_00_reg))
#define  SRNN_wdsr_layer2_3x3_weights_8_00_layer2_weight_00_shift                (0)
#define  SRNN_wdsr_layer2_3x3_weights_8_00_layer2_weight_00_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer2_3x3_weights_8_00_layer2_weight_00(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer2_3x3_weights_8_00_get_layer2_weight_00(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer2_3x3_weights_8_01                                      0x181AB240
#define  SRNN_wdsr_layer2_3x3_weights_8_01_reg_addr                              "0xB81AB240"
#define  SRNN_wdsr_layer2_3x3_weights_8_01_reg                                   0xB81AB240
#define  SRNN_wdsr_layer2_3x3_weights_8_01_inst_addr                             "0x00B4"
#define  set_SRNN_wdsr_layer2_3x3_weights_8_01_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_8_01_reg)=data)
#define  get_SRNN_wdsr_layer2_3x3_weights_8_01_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_8_01_reg))
#define  SRNN_wdsr_layer2_3x3_weights_8_01_layer2_weight_01_shift                (0)
#define  SRNN_wdsr_layer2_3x3_weights_8_01_layer2_weight_01_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer2_3x3_weights_8_01_layer2_weight_01(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer2_3x3_weights_8_01_get_layer2_weight_01(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer2_3x3_weights_8_02                                      0x181AB244
#define  SRNN_wdsr_layer2_3x3_weights_8_02_reg_addr                              "0xB81AB244"
#define  SRNN_wdsr_layer2_3x3_weights_8_02_reg                                   0xB81AB244
#define  SRNN_wdsr_layer2_3x3_weights_8_02_inst_addr                             "0x00B5"
#define  set_SRNN_wdsr_layer2_3x3_weights_8_02_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_8_02_reg)=data)
#define  get_SRNN_wdsr_layer2_3x3_weights_8_02_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_8_02_reg))
#define  SRNN_wdsr_layer2_3x3_weights_8_02_layer2_weight_02_shift                (0)
#define  SRNN_wdsr_layer2_3x3_weights_8_02_layer2_weight_02_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer2_3x3_weights_8_02_layer2_weight_02(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer2_3x3_weights_8_02_get_layer2_weight_02(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer2_3x3_weights_8_10                                      0x181AB248
#define  SRNN_wdsr_layer2_3x3_weights_8_10_reg_addr                              "0xB81AB248"
#define  SRNN_wdsr_layer2_3x3_weights_8_10_reg                                   0xB81AB248
#define  SRNN_wdsr_layer2_3x3_weights_8_10_inst_addr                             "0x00B6"
#define  set_SRNN_wdsr_layer2_3x3_weights_8_10_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_8_10_reg)=data)
#define  get_SRNN_wdsr_layer2_3x3_weights_8_10_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_8_10_reg))
#define  SRNN_wdsr_layer2_3x3_weights_8_10_layer2_weight_10_shift                (0)
#define  SRNN_wdsr_layer2_3x3_weights_8_10_layer2_weight_10_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer2_3x3_weights_8_10_layer2_weight_10(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer2_3x3_weights_8_10_get_layer2_weight_10(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer2_3x3_weights_8_11                                      0x181AB24C
#define  SRNN_wdsr_layer2_3x3_weights_8_11_reg_addr                              "0xB81AB24C"
#define  SRNN_wdsr_layer2_3x3_weights_8_11_reg                                   0xB81AB24C
#define  SRNN_wdsr_layer2_3x3_weights_8_11_inst_addr                             "0x00B7"
#define  set_SRNN_wdsr_layer2_3x3_weights_8_11_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_8_11_reg)=data)
#define  get_SRNN_wdsr_layer2_3x3_weights_8_11_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_8_11_reg))
#define  SRNN_wdsr_layer2_3x3_weights_8_11_layer2_weight_11_shift                (0)
#define  SRNN_wdsr_layer2_3x3_weights_8_11_layer2_weight_11_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer2_3x3_weights_8_11_layer2_weight_11(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer2_3x3_weights_8_11_get_layer2_weight_11(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer2_3x3_weights_8_12                                      0x181AB250
#define  SRNN_wdsr_layer2_3x3_weights_8_12_reg_addr                              "0xB81AB250"
#define  SRNN_wdsr_layer2_3x3_weights_8_12_reg                                   0xB81AB250
#define  SRNN_wdsr_layer2_3x3_weights_8_12_inst_addr                             "0x00B8"
#define  set_SRNN_wdsr_layer2_3x3_weights_8_12_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_8_12_reg)=data)
#define  get_SRNN_wdsr_layer2_3x3_weights_8_12_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_8_12_reg))
#define  SRNN_wdsr_layer2_3x3_weights_8_12_layer2_weight_12_shift                (0)
#define  SRNN_wdsr_layer2_3x3_weights_8_12_layer2_weight_12_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer2_3x3_weights_8_12_layer2_weight_12(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer2_3x3_weights_8_12_get_layer2_weight_12(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer2_3x3_weights_8_20                                      0x181AB254
#define  SRNN_wdsr_layer2_3x3_weights_8_20_reg_addr                              "0xB81AB254"
#define  SRNN_wdsr_layer2_3x3_weights_8_20_reg                                   0xB81AB254
#define  SRNN_wdsr_layer2_3x3_weights_8_20_inst_addr                             "0x00B9"
#define  set_SRNN_wdsr_layer2_3x3_weights_8_20_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_8_20_reg)=data)
#define  get_SRNN_wdsr_layer2_3x3_weights_8_20_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_8_20_reg))
#define  SRNN_wdsr_layer2_3x3_weights_8_20_layer2_weight_20_shift                (0)
#define  SRNN_wdsr_layer2_3x3_weights_8_20_layer2_weight_20_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer2_3x3_weights_8_20_layer2_weight_20(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer2_3x3_weights_8_20_get_layer2_weight_20(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer2_3x3_weights_8_21                                      0x181AB258
#define  SRNN_wdsr_layer2_3x3_weights_8_21_reg_addr                              "0xB81AB258"
#define  SRNN_wdsr_layer2_3x3_weights_8_21_reg                                   0xB81AB258
#define  SRNN_wdsr_layer2_3x3_weights_8_21_inst_addr                             "0x00BA"
#define  set_SRNN_wdsr_layer2_3x3_weights_8_21_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_8_21_reg)=data)
#define  get_SRNN_wdsr_layer2_3x3_weights_8_21_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_8_21_reg))
#define  SRNN_wdsr_layer2_3x3_weights_8_21_layer2_weight_21_shift                (0)
#define  SRNN_wdsr_layer2_3x3_weights_8_21_layer2_weight_21_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer2_3x3_weights_8_21_layer2_weight_21(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer2_3x3_weights_8_21_get_layer2_weight_21(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer2_3x3_weights_8_22                                      0x181AB25C
#define  SRNN_wdsr_layer2_3x3_weights_8_22_reg_addr                              "0xB81AB25C"
#define  SRNN_wdsr_layer2_3x3_weights_8_22_reg                                   0xB81AB25C
#define  SRNN_wdsr_layer2_3x3_weights_8_22_inst_addr                             "0x00BB"
#define  set_SRNN_wdsr_layer2_3x3_weights_8_22_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_8_22_reg)=data)
#define  get_SRNN_wdsr_layer2_3x3_weights_8_22_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_weights_8_22_reg))
#define  SRNN_wdsr_layer2_3x3_weights_8_22_layer2_weight_22_shift                (0)
#define  SRNN_wdsr_layer2_3x3_weights_8_22_layer2_weight_22_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer2_3x3_weights_8_22_layer2_weight_22(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer2_3x3_weights_8_22_get_layer2_weight_22(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer2_3x3_bias_1                                            0x181AB260
#define  SRNN_wdsr_layer2_3x3_bias_1_reg_addr                                    "0xB81AB260"
#define  SRNN_wdsr_layer2_3x3_bias_1_reg                                         0xB81AB260
#define  SRNN_wdsr_layer2_3x3_bias_1_inst_addr                                   "0x00BC"
#define  set_SRNN_wdsr_layer2_3x3_bias_1_reg(data)                               (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_bias_1_reg)=data)
#define  get_SRNN_wdsr_layer2_3x3_bias_1_reg                                     (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_bias_1_reg))
#define  SRNN_wdsr_layer2_3x3_bias_1_layer2_bias_1_shift                         (0)
#define  SRNN_wdsr_layer2_3x3_bias_1_layer2_bias_1_mask                          (0x000001FF)
#define  SRNN_wdsr_layer2_3x3_bias_1_layer2_bias_1(data)                         (0x000001FF&(data))
#define  SRNN_wdsr_layer2_3x3_bias_1_get_layer2_bias_1(data)                     (0x000001FF&(data))

#define  SRNN_wdsr_layer2_3x3_bias_2                                            0x181AB264
#define  SRNN_wdsr_layer2_3x3_bias_2_reg_addr                                    "0xB81AB264"
#define  SRNN_wdsr_layer2_3x3_bias_2_reg                                         0xB81AB264
#define  SRNN_wdsr_layer2_3x3_bias_2_inst_addr                                   "0x00BD"
#define  set_SRNN_wdsr_layer2_3x3_bias_2_reg(data)                               (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_bias_2_reg)=data)
#define  get_SRNN_wdsr_layer2_3x3_bias_2_reg                                     (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_bias_2_reg))
#define  SRNN_wdsr_layer2_3x3_bias_2_layer2_bias_2_shift                         (0)
#define  SRNN_wdsr_layer2_3x3_bias_2_layer2_bias_2_mask                          (0x000001FF)
#define  SRNN_wdsr_layer2_3x3_bias_2_layer2_bias_2(data)                         (0x000001FF&(data))
#define  SRNN_wdsr_layer2_3x3_bias_2_get_layer2_bias_2(data)                     (0x000001FF&(data))

#define  SRNN_wdsr_layer2_3x3_bias_3                                            0x181AB268
#define  SRNN_wdsr_layer2_3x3_bias_3_reg_addr                                    "0xB81AB268"
#define  SRNN_wdsr_layer2_3x3_bias_3_reg                                         0xB81AB268
#define  SRNN_wdsr_layer2_3x3_bias_3_inst_addr                                   "0x00BE"
#define  set_SRNN_wdsr_layer2_3x3_bias_3_reg(data)                               (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_bias_3_reg)=data)
#define  get_SRNN_wdsr_layer2_3x3_bias_3_reg                                     (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_bias_3_reg))
#define  SRNN_wdsr_layer2_3x3_bias_3_layer2_bias_3_shift                         (0)
#define  SRNN_wdsr_layer2_3x3_bias_3_layer2_bias_3_mask                          (0x000001FF)
#define  SRNN_wdsr_layer2_3x3_bias_3_layer2_bias_3(data)                         (0x000001FF&(data))
#define  SRNN_wdsr_layer2_3x3_bias_3_get_layer2_bias_3(data)                     (0x000001FF&(data))

#define  SRNN_wdsr_layer2_3x3_bias_4                                            0x181AB26C
#define  SRNN_wdsr_layer2_3x3_bias_4_reg_addr                                    "0xB81AB26C"
#define  SRNN_wdsr_layer2_3x3_bias_4_reg                                         0xB81AB26C
#define  SRNN_wdsr_layer2_3x3_bias_4_inst_addr                                   "0x00BF"
#define  set_SRNN_wdsr_layer2_3x3_bias_4_reg(data)                               (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_bias_4_reg)=data)
#define  get_SRNN_wdsr_layer2_3x3_bias_4_reg                                     (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_bias_4_reg))
#define  SRNN_wdsr_layer2_3x3_bias_4_layer2_bias_4_shift                         (0)
#define  SRNN_wdsr_layer2_3x3_bias_4_layer2_bias_4_mask                          (0x000001FF)
#define  SRNN_wdsr_layer2_3x3_bias_4_layer2_bias_4(data)                         (0x000001FF&(data))
#define  SRNN_wdsr_layer2_3x3_bias_4_get_layer2_bias_4(data)                     (0x000001FF&(data))

#define  SRNN_wdsr_layer2_3x3_bias_5                                            0x181AB270
#define  SRNN_wdsr_layer2_3x3_bias_5_reg_addr                                    "0xB81AB270"
#define  SRNN_wdsr_layer2_3x3_bias_5_reg                                         0xB81AB270
#define  SRNN_wdsr_layer2_3x3_bias_5_inst_addr                                   "0x00C0"
#define  set_SRNN_wdsr_layer2_3x3_bias_5_reg(data)                               (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_bias_5_reg)=data)
#define  get_SRNN_wdsr_layer2_3x3_bias_5_reg                                     (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_bias_5_reg))
#define  SRNN_wdsr_layer2_3x3_bias_5_layer2_bias_5_shift                         (0)
#define  SRNN_wdsr_layer2_3x3_bias_5_layer2_bias_5_mask                          (0x000001FF)
#define  SRNN_wdsr_layer2_3x3_bias_5_layer2_bias_5(data)                         (0x000001FF&(data))
#define  SRNN_wdsr_layer2_3x3_bias_5_get_layer2_bias_5(data)                     (0x000001FF&(data))

#define  SRNN_wdsr_layer2_3x3_bias_6                                            0x181AB274
#define  SRNN_wdsr_layer2_3x3_bias_6_reg_addr                                    "0xB81AB274"
#define  SRNN_wdsr_layer2_3x3_bias_6_reg                                         0xB81AB274
#define  SRNN_wdsr_layer2_3x3_bias_6_inst_addr                                   "0x00C1"
#define  set_SRNN_wdsr_layer2_3x3_bias_6_reg(data)                               (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_bias_6_reg)=data)
#define  get_SRNN_wdsr_layer2_3x3_bias_6_reg                                     (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_bias_6_reg))
#define  SRNN_wdsr_layer2_3x3_bias_6_layer2_bias_6_shift                         (0)
#define  SRNN_wdsr_layer2_3x3_bias_6_layer2_bias_6_mask                          (0x000001FF)
#define  SRNN_wdsr_layer2_3x3_bias_6_layer2_bias_6(data)                         (0x000001FF&(data))
#define  SRNN_wdsr_layer2_3x3_bias_6_get_layer2_bias_6(data)                     (0x000001FF&(data))

#define  SRNN_wdsr_layer2_3x3_bias_7                                            0x181AB278
#define  SRNN_wdsr_layer2_3x3_bias_7_reg_addr                                    "0xB81AB278"
#define  SRNN_wdsr_layer2_3x3_bias_7_reg                                         0xB81AB278
#define  SRNN_wdsr_layer2_3x3_bias_7_inst_addr                                   "0x00C2"
#define  set_SRNN_wdsr_layer2_3x3_bias_7_reg(data)                               (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_bias_7_reg)=data)
#define  get_SRNN_wdsr_layer2_3x3_bias_7_reg                                     (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_bias_7_reg))
#define  SRNN_wdsr_layer2_3x3_bias_7_layer2_bias_7_shift                         (0)
#define  SRNN_wdsr_layer2_3x3_bias_7_layer2_bias_7_mask                          (0x000001FF)
#define  SRNN_wdsr_layer2_3x3_bias_7_layer2_bias_7(data)                         (0x000001FF&(data))
#define  SRNN_wdsr_layer2_3x3_bias_7_get_layer2_bias_7(data)                     (0x000001FF&(data))

#define  SRNN_wdsr_layer2_3x3_bias_8                                            0x181AB27C
#define  SRNN_wdsr_layer2_3x3_bias_8_reg_addr                                    "0xB81AB27C"
#define  SRNN_wdsr_layer2_3x3_bias_8_reg                                         0xB81AB27C
#define  SRNN_wdsr_layer2_3x3_bias_8_inst_addr                                   "0x00C3"
#define  set_SRNN_wdsr_layer2_3x3_bias_8_reg(data)                               (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_bias_8_reg)=data)
#define  get_SRNN_wdsr_layer2_3x3_bias_8_reg                                     (*((volatile unsigned int*)SRNN_wdsr_layer2_3x3_bias_8_reg))
#define  SRNN_wdsr_layer2_3x3_bias_8_layer2_bias_8_shift                         (0)
#define  SRNN_wdsr_layer2_3x3_bias_8_layer2_bias_8_mask                          (0x000001FF)
#define  SRNN_wdsr_layer2_3x3_bias_8_layer2_bias_8(data)                         (0x000001FF&(data))
#define  SRNN_wdsr_layer2_3x3_bias_8_get_layer2_bias_8(data)                     (0x000001FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_1_1                                       0x181AB280
#define  SRNN_wdsr_layer2_1x1_weights_1_1_reg_addr                               "0xB81AB280"
#define  SRNN_wdsr_layer2_1x1_weights_1_1_reg                                    0xB81AB280
#define  SRNN_wdsr_layer2_1x1_weights_1_1_inst_addr                              "0x00C4"
#define  set_SRNN_wdsr_layer2_1x1_weights_1_1_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_1_1_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_1_1_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_1_1_reg))
#define  SRNN_wdsr_layer2_1x1_weights_1_1_layer2_weight_1_shift                  (0)
#define  SRNN_wdsr_layer2_1x1_weights_1_1_layer2_weight_1_mask                   (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_1_1_layer2_weight_1(data)                  (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_1_1_get_layer2_weight_1(data)              (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_1_2                                       0x181AB284
#define  SRNN_wdsr_layer2_1x1_weights_1_2_reg_addr                               "0xB81AB284"
#define  SRNN_wdsr_layer2_1x1_weights_1_2_reg                                    0xB81AB284
#define  SRNN_wdsr_layer2_1x1_weights_1_2_inst_addr                              "0x00C5"
#define  set_SRNN_wdsr_layer2_1x1_weights_1_2_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_1_2_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_1_2_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_1_2_reg))
#define  SRNN_wdsr_layer2_1x1_weights_1_2_layer2_weight_2_shift                  (0)
#define  SRNN_wdsr_layer2_1x1_weights_1_2_layer2_weight_2_mask                   (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_1_2_layer2_weight_2(data)                  (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_1_2_get_layer2_weight_2(data)              (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_1_3                                       0x181AB288
#define  SRNN_wdsr_layer2_1x1_weights_1_3_reg_addr                               "0xB81AB288"
#define  SRNN_wdsr_layer2_1x1_weights_1_3_reg                                    0xB81AB288
#define  SRNN_wdsr_layer2_1x1_weights_1_3_inst_addr                              "0x00C6"
#define  set_SRNN_wdsr_layer2_1x1_weights_1_3_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_1_3_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_1_3_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_1_3_reg))
#define  SRNN_wdsr_layer2_1x1_weights_1_3_layer2_weight_3_shift                  (0)
#define  SRNN_wdsr_layer2_1x1_weights_1_3_layer2_weight_3_mask                   (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_1_3_layer2_weight_3(data)                  (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_1_3_get_layer2_weight_3(data)              (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_1_4                                       0x181AB28C
#define  SRNN_wdsr_layer2_1x1_weights_1_4_reg_addr                               "0xB81AB28C"
#define  SRNN_wdsr_layer2_1x1_weights_1_4_reg                                    0xB81AB28C
#define  SRNN_wdsr_layer2_1x1_weights_1_4_inst_addr                              "0x00C7"
#define  set_SRNN_wdsr_layer2_1x1_weights_1_4_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_1_4_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_1_4_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_1_4_reg))
#define  SRNN_wdsr_layer2_1x1_weights_1_4_layer2_weight_4_shift                  (0)
#define  SRNN_wdsr_layer2_1x1_weights_1_4_layer2_weight_4_mask                   (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_1_4_layer2_weight_4(data)                  (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_1_4_get_layer2_weight_4(data)              (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_1_5                                       0x181AB290
#define  SRNN_wdsr_layer2_1x1_weights_1_5_reg_addr                               "0xB81AB290"
#define  SRNN_wdsr_layer2_1x1_weights_1_5_reg                                    0xB81AB290
#define  SRNN_wdsr_layer2_1x1_weights_1_5_inst_addr                              "0x00C8"
#define  set_SRNN_wdsr_layer2_1x1_weights_1_5_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_1_5_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_1_5_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_1_5_reg))
#define  SRNN_wdsr_layer2_1x1_weights_1_5_layer2_weight_5_shift                  (0)
#define  SRNN_wdsr_layer2_1x1_weights_1_5_layer2_weight_5_mask                   (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_1_5_layer2_weight_5(data)                  (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_1_5_get_layer2_weight_5(data)              (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_1_6                                       0x181AB294
#define  SRNN_wdsr_layer2_1x1_weights_1_6_reg_addr                               "0xB81AB294"
#define  SRNN_wdsr_layer2_1x1_weights_1_6_reg                                    0xB81AB294
#define  SRNN_wdsr_layer2_1x1_weights_1_6_inst_addr                              "0x00C9"
#define  set_SRNN_wdsr_layer2_1x1_weights_1_6_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_1_6_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_1_6_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_1_6_reg))
#define  SRNN_wdsr_layer2_1x1_weights_1_6_layer2_weight_6_shift                  (0)
#define  SRNN_wdsr_layer2_1x1_weights_1_6_layer2_weight_6_mask                   (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_1_6_layer2_weight_6(data)                  (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_1_6_get_layer2_weight_6(data)              (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_1_7                                       0x181AB298
#define  SRNN_wdsr_layer2_1x1_weights_1_7_reg_addr                               "0xB81AB298"
#define  SRNN_wdsr_layer2_1x1_weights_1_7_reg                                    0xB81AB298
#define  SRNN_wdsr_layer2_1x1_weights_1_7_inst_addr                              "0x00CA"
#define  set_SRNN_wdsr_layer2_1x1_weights_1_7_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_1_7_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_1_7_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_1_7_reg))
#define  SRNN_wdsr_layer2_1x1_weights_1_7_layer2_weight_7_shift                  (0)
#define  SRNN_wdsr_layer2_1x1_weights_1_7_layer2_weight_7_mask                   (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_1_7_layer2_weight_7(data)                  (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_1_7_get_layer2_weight_7(data)              (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_1_8                                       0x181AB29C
#define  SRNN_wdsr_layer2_1x1_weights_1_8_reg_addr                               "0xB81AB29C"
#define  SRNN_wdsr_layer2_1x1_weights_1_8_reg                                    0xB81AB29C
#define  SRNN_wdsr_layer2_1x1_weights_1_8_inst_addr                              "0x00CB"
#define  set_SRNN_wdsr_layer2_1x1_weights_1_8_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_1_8_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_1_8_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_1_8_reg))
#define  SRNN_wdsr_layer2_1x1_weights_1_8_layer2_weight_8_shift                  (0)
#define  SRNN_wdsr_layer2_1x1_weights_1_8_layer2_weight_8_mask                   (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_1_8_layer2_weight_8(data)                  (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_1_8_get_layer2_weight_8(data)              (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_2_1                                       0x181AB2A0
#define  SRNN_wdsr_layer2_1x1_weights_2_1_reg_addr                               "0xB81AB2A0"
#define  SRNN_wdsr_layer2_1x1_weights_2_1_reg                                    0xB81AB2A0
#define  SRNN_wdsr_layer2_1x1_weights_2_1_inst_addr                              "0x00CC"
#define  set_SRNN_wdsr_layer2_1x1_weights_2_1_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_2_1_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_2_1_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_2_1_reg))
#define  SRNN_wdsr_layer2_1x1_weights_2_1_layer2_weight_1_shift                  (0)
#define  SRNN_wdsr_layer2_1x1_weights_2_1_layer2_weight_1_mask                   (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_2_1_layer2_weight_1(data)                  (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_2_1_get_layer2_weight_1(data)              (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_2_2                                       0x181AB2A4
#define  SRNN_wdsr_layer2_1x1_weights_2_2_reg_addr                               "0xB81AB2A4"
#define  SRNN_wdsr_layer2_1x1_weights_2_2_reg                                    0xB81AB2A4
#define  SRNN_wdsr_layer2_1x1_weights_2_2_inst_addr                              "0x00CD"
#define  set_SRNN_wdsr_layer2_1x1_weights_2_2_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_2_2_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_2_2_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_2_2_reg))
#define  SRNN_wdsr_layer2_1x1_weights_2_2_layer2_weight_2_shift                  (0)
#define  SRNN_wdsr_layer2_1x1_weights_2_2_layer2_weight_2_mask                   (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_2_2_layer2_weight_2(data)                  (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_2_2_get_layer2_weight_2(data)              (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_2_3                                       0x181AB2A8
#define  SRNN_wdsr_layer2_1x1_weights_2_3_reg_addr                               "0xB81AB2A8"
#define  SRNN_wdsr_layer2_1x1_weights_2_3_reg                                    0xB81AB2A8
#define  SRNN_wdsr_layer2_1x1_weights_2_3_inst_addr                              "0x00CE"
#define  set_SRNN_wdsr_layer2_1x1_weights_2_3_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_2_3_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_2_3_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_2_3_reg))
#define  SRNN_wdsr_layer2_1x1_weights_2_3_layer2_weight_3_shift                  (0)
#define  SRNN_wdsr_layer2_1x1_weights_2_3_layer2_weight_3_mask                   (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_2_3_layer2_weight_3(data)                  (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_2_3_get_layer2_weight_3(data)              (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_2_4                                       0x181AB2AC
#define  SRNN_wdsr_layer2_1x1_weights_2_4_reg_addr                               "0xB81AB2AC"
#define  SRNN_wdsr_layer2_1x1_weights_2_4_reg                                    0xB81AB2AC
#define  SRNN_wdsr_layer2_1x1_weights_2_4_inst_addr                              "0x00CF"
#define  set_SRNN_wdsr_layer2_1x1_weights_2_4_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_2_4_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_2_4_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_2_4_reg))
#define  SRNN_wdsr_layer2_1x1_weights_2_4_layer2_weight_4_shift                  (0)
#define  SRNN_wdsr_layer2_1x1_weights_2_4_layer2_weight_4_mask                   (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_2_4_layer2_weight_4(data)                  (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_2_4_get_layer2_weight_4(data)              (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_2_5                                       0x181AB2B0
#define  SRNN_wdsr_layer2_1x1_weights_2_5_reg_addr                               "0xB81AB2B0"
#define  SRNN_wdsr_layer2_1x1_weights_2_5_reg                                    0xB81AB2B0
#define  SRNN_wdsr_layer2_1x1_weights_2_5_inst_addr                              "0x00D0"
#define  set_SRNN_wdsr_layer2_1x1_weights_2_5_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_2_5_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_2_5_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_2_5_reg))
#define  SRNN_wdsr_layer2_1x1_weights_2_5_layer2_weight_5_shift                  (0)
#define  SRNN_wdsr_layer2_1x1_weights_2_5_layer2_weight_5_mask                   (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_2_5_layer2_weight_5(data)                  (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_2_5_get_layer2_weight_5(data)              (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_2_6                                       0x181AB2B4
#define  SRNN_wdsr_layer2_1x1_weights_2_6_reg_addr                               "0xB81AB2B4"
#define  SRNN_wdsr_layer2_1x1_weights_2_6_reg                                    0xB81AB2B4
#define  SRNN_wdsr_layer2_1x1_weights_2_6_inst_addr                              "0x00D1"
#define  set_SRNN_wdsr_layer2_1x1_weights_2_6_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_2_6_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_2_6_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_2_6_reg))
#define  SRNN_wdsr_layer2_1x1_weights_2_6_layer2_weight_6_shift                  (0)
#define  SRNN_wdsr_layer2_1x1_weights_2_6_layer2_weight_6_mask                   (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_2_6_layer2_weight_6(data)                  (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_2_6_get_layer2_weight_6(data)              (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_2_7                                       0x181AB2B8
#define  SRNN_wdsr_layer2_1x1_weights_2_7_reg_addr                               "0xB81AB2B8"
#define  SRNN_wdsr_layer2_1x1_weights_2_7_reg                                    0xB81AB2B8
#define  SRNN_wdsr_layer2_1x1_weights_2_7_inst_addr                              "0x00D2"
#define  set_SRNN_wdsr_layer2_1x1_weights_2_7_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_2_7_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_2_7_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_2_7_reg))
#define  SRNN_wdsr_layer2_1x1_weights_2_7_layer2_weight_7_shift                  (0)
#define  SRNN_wdsr_layer2_1x1_weights_2_7_layer2_weight_7_mask                   (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_2_7_layer2_weight_7(data)                  (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_2_7_get_layer2_weight_7(data)              (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_2_8                                       0x181AB2BC
#define  SRNN_wdsr_layer2_1x1_weights_2_8_reg_addr                               "0xB81AB2BC"
#define  SRNN_wdsr_layer2_1x1_weights_2_8_reg                                    0xB81AB2BC
#define  SRNN_wdsr_layer2_1x1_weights_2_8_inst_addr                              "0x00D3"
#define  set_SRNN_wdsr_layer2_1x1_weights_2_8_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_2_8_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_2_8_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_2_8_reg))
#define  SRNN_wdsr_layer2_1x1_weights_2_8_layer2_weight_8_shift                  (0)
#define  SRNN_wdsr_layer2_1x1_weights_2_8_layer2_weight_8_mask                   (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_2_8_layer2_weight_8(data)                  (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_2_8_get_layer2_weight_8(data)              (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_3_1                                       0x181AB2C0
#define  SRNN_wdsr_layer2_1x1_weights_3_1_reg_addr                               "0xB81AB2C0"
#define  SRNN_wdsr_layer2_1x1_weights_3_1_reg                                    0xB81AB2C0
#define  SRNN_wdsr_layer2_1x1_weights_3_1_inst_addr                              "0x00D4"
#define  set_SRNN_wdsr_layer2_1x1_weights_3_1_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_3_1_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_3_1_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_3_1_reg))
#define  SRNN_wdsr_layer2_1x1_weights_3_1_layer2_weight_1_shift                  (0)
#define  SRNN_wdsr_layer2_1x1_weights_3_1_layer2_weight_1_mask                   (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_3_1_layer2_weight_1(data)                  (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_3_1_get_layer2_weight_1(data)              (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_3_2                                       0x181AB2C4
#define  SRNN_wdsr_layer2_1x1_weights_3_2_reg_addr                               "0xB81AB2C4"
#define  SRNN_wdsr_layer2_1x1_weights_3_2_reg                                    0xB81AB2C4
#define  SRNN_wdsr_layer2_1x1_weights_3_2_inst_addr                              "0x00D5"
#define  set_SRNN_wdsr_layer2_1x1_weights_3_2_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_3_2_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_3_2_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_3_2_reg))
#define  SRNN_wdsr_layer2_1x1_weights_3_2_layer2_weight_2_shift                  (0)
#define  SRNN_wdsr_layer2_1x1_weights_3_2_layer2_weight_2_mask                   (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_3_2_layer2_weight_2(data)                  (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_3_2_get_layer2_weight_2(data)              (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_3_3                                       0x181AB2C8
#define  SRNN_wdsr_layer2_1x1_weights_3_3_reg_addr                               "0xB81AB2C8"
#define  SRNN_wdsr_layer2_1x1_weights_3_3_reg                                    0xB81AB2C8
#define  SRNN_wdsr_layer2_1x1_weights_3_3_inst_addr                              "0x00D6"
#define  set_SRNN_wdsr_layer2_1x1_weights_3_3_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_3_3_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_3_3_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_3_3_reg))
#define  SRNN_wdsr_layer2_1x1_weights_3_3_layer2_weight_3_shift                  (0)
#define  SRNN_wdsr_layer2_1x1_weights_3_3_layer2_weight_3_mask                   (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_3_3_layer2_weight_3(data)                  (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_3_3_get_layer2_weight_3(data)              (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_3_4                                       0x181AB2CC
#define  SRNN_wdsr_layer2_1x1_weights_3_4_reg_addr                               "0xB81AB2CC"
#define  SRNN_wdsr_layer2_1x1_weights_3_4_reg                                    0xB81AB2CC
#define  SRNN_wdsr_layer2_1x1_weights_3_4_inst_addr                              "0x00D7"
#define  set_SRNN_wdsr_layer2_1x1_weights_3_4_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_3_4_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_3_4_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_3_4_reg))
#define  SRNN_wdsr_layer2_1x1_weights_3_4_layer2_weight_4_shift                  (0)
#define  SRNN_wdsr_layer2_1x1_weights_3_4_layer2_weight_4_mask                   (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_3_4_layer2_weight_4(data)                  (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_3_4_get_layer2_weight_4(data)              (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_3_5                                       0x181AB2D0
#define  SRNN_wdsr_layer2_1x1_weights_3_5_reg_addr                               "0xB81AB2D0"
#define  SRNN_wdsr_layer2_1x1_weights_3_5_reg                                    0xB81AB2D0
#define  SRNN_wdsr_layer2_1x1_weights_3_5_inst_addr                              "0x00D8"
#define  set_SRNN_wdsr_layer2_1x1_weights_3_5_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_3_5_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_3_5_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_3_5_reg))
#define  SRNN_wdsr_layer2_1x1_weights_3_5_layer2_weight_5_shift                  (0)
#define  SRNN_wdsr_layer2_1x1_weights_3_5_layer2_weight_5_mask                   (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_3_5_layer2_weight_5(data)                  (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_3_5_get_layer2_weight_5(data)              (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_3_6                                       0x181AB2D4
#define  SRNN_wdsr_layer2_1x1_weights_3_6_reg_addr                               "0xB81AB2D4"
#define  SRNN_wdsr_layer2_1x1_weights_3_6_reg                                    0xB81AB2D4
#define  SRNN_wdsr_layer2_1x1_weights_3_6_inst_addr                              "0x00D9"
#define  set_SRNN_wdsr_layer2_1x1_weights_3_6_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_3_6_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_3_6_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_3_6_reg))
#define  SRNN_wdsr_layer2_1x1_weights_3_6_layer2_weight_6_shift                  (0)
#define  SRNN_wdsr_layer2_1x1_weights_3_6_layer2_weight_6_mask                   (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_3_6_layer2_weight_6(data)                  (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_3_6_get_layer2_weight_6(data)              (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_3_7                                       0x181AB2D8
#define  SRNN_wdsr_layer2_1x1_weights_3_7_reg_addr                               "0xB81AB2D8"
#define  SRNN_wdsr_layer2_1x1_weights_3_7_reg                                    0xB81AB2D8
#define  SRNN_wdsr_layer2_1x1_weights_3_7_inst_addr                              "0x00DA"
#define  set_SRNN_wdsr_layer2_1x1_weights_3_7_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_3_7_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_3_7_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_3_7_reg))
#define  SRNN_wdsr_layer2_1x1_weights_3_7_layer2_weight_7_shift                  (0)
#define  SRNN_wdsr_layer2_1x1_weights_3_7_layer2_weight_7_mask                   (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_3_7_layer2_weight_7(data)                  (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_3_7_get_layer2_weight_7(data)              (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_3_8                                       0x181AB2DC
#define  SRNN_wdsr_layer2_1x1_weights_3_8_reg_addr                               "0xB81AB2DC"
#define  SRNN_wdsr_layer2_1x1_weights_3_8_reg                                    0xB81AB2DC
#define  SRNN_wdsr_layer2_1x1_weights_3_8_inst_addr                              "0x00DB"
#define  set_SRNN_wdsr_layer2_1x1_weights_3_8_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_3_8_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_3_8_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_3_8_reg))
#define  SRNN_wdsr_layer2_1x1_weights_3_8_layer2_weight_8_shift                  (0)
#define  SRNN_wdsr_layer2_1x1_weights_3_8_layer2_weight_8_mask                   (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_3_8_layer2_weight_8(data)                  (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_3_8_get_layer2_weight_8(data)              (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_4_1                                       0x181AB2E0
#define  SRNN_wdsr_layer2_1x1_weights_4_1_reg_addr                               "0xB81AB2E0"
#define  SRNN_wdsr_layer2_1x1_weights_4_1_reg                                    0xB81AB2E0
#define  SRNN_wdsr_layer2_1x1_weights_4_1_inst_addr                              "0x00DC"
#define  set_SRNN_wdsr_layer2_1x1_weights_4_1_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_4_1_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_4_1_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_4_1_reg))
#define  SRNN_wdsr_layer2_1x1_weights_4_1_layer2_weight_1_shift                  (0)
#define  SRNN_wdsr_layer2_1x1_weights_4_1_layer2_weight_1_mask                   (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_4_1_layer2_weight_1(data)                  (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_4_1_get_layer2_weight_1(data)              (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_4_2                                       0x181AB2E4
#define  SRNN_wdsr_layer2_1x1_weights_4_2_reg_addr                               "0xB81AB2E4"
#define  SRNN_wdsr_layer2_1x1_weights_4_2_reg                                    0xB81AB2E4
#define  SRNN_wdsr_layer2_1x1_weights_4_2_inst_addr                              "0x00DD"
#define  set_SRNN_wdsr_layer2_1x1_weights_4_2_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_4_2_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_4_2_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_4_2_reg))
#define  SRNN_wdsr_layer2_1x1_weights_4_2_layer2_weight_2_shift                  (0)
#define  SRNN_wdsr_layer2_1x1_weights_4_2_layer2_weight_2_mask                   (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_4_2_layer2_weight_2(data)                  (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_4_2_get_layer2_weight_2(data)              (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_4_3                                       0x181AB2E8
#define  SRNN_wdsr_layer2_1x1_weights_4_3_reg_addr                               "0xB81AB2E8"
#define  SRNN_wdsr_layer2_1x1_weights_4_3_reg                                    0xB81AB2E8
#define  SRNN_wdsr_layer2_1x1_weights_4_3_inst_addr                              "0x00DE"
#define  set_SRNN_wdsr_layer2_1x1_weights_4_3_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_4_3_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_4_3_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_4_3_reg))
#define  SRNN_wdsr_layer2_1x1_weights_4_3_layer2_weight_3_shift                  (0)
#define  SRNN_wdsr_layer2_1x1_weights_4_3_layer2_weight_3_mask                   (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_4_3_layer2_weight_3(data)                  (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_4_3_get_layer2_weight_3(data)              (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_4_4                                       0x181AB2EC
#define  SRNN_wdsr_layer2_1x1_weights_4_4_reg_addr                               "0xB81AB2EC"
#define  SRNN_wdsr_layer2_1x1_weights_4_4_reg                                    0xB81AB2EC
#define  SRNN_wdsr_layer2_1x1_weights_4_4_inst_addr                              "0x00DF"
#define  set_SRNN_wdsr_layer2_1x1_weights_4_4_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_4_4_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_4_4_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_4_4_reg))
#define  SRNN_wdsr_layer2_1x1_weights_4_4_layer2_weight_4_shift                  (0)
#define  SRNN_wdsr_layer2_1x1_weights_4_4_layer2_weight_4_mask                   (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_4_4_layer2_weight_4(data)                  (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_4_4_get_layer2_weight_4(data)              (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_4_5                                       0x181AB2F0
#define  SRNN_wdsr_layer2_1x1_weights_4_5_reg_addr                               "0xB81AB2F0"
#define  SRNN_wdsr_layer2_1x1_weights_4_5_reg                                    0xB81AB2F0
#define  SRNN_wdsr_layer2_1x1_weights_4_5_inst_addr                              "0x00E0"
#define  set_SRNN_wdsr_layer2_1x1_weights_4_5_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_4_5_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_4_5_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_4_5_reg))
#define  SRNN_wdsr_layer2_1x1_weights_4_5_layer2_weight_5_shift                  (0)
#define  SRNN_wdsr_layer2_1x1_weights_4_5_layer2_weight_5_mask                   (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_4_5_layer2_weight_5(data)                  (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_4_5_get_layer2_weight_5(data)              (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_4_6                                       0x181AB2F4
#define  SRNN_wdsr_layer2_1x1_weights_4_6_reg_addr                               "0xB81AB2F4"
#define  SRNN_wdsr_layer2_1x1_weights_4_6_reg                                    0xB81AB2F4
#define  SRNN_wdsr_layer2_1x1_weights_4_6_inst_addr                              "0x00E1"
#define  set_SRNN_wdsr_layer2_1x1_weights_4_6_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_4_6_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_4_6_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_4_6_reg))
#define  SRNN_wdsr_layer2_1x1_weights_4_6_layer2_weight_6_shift                  (0)
#define  SRNN_wdsr_layer2_1x1_weights_4_6_layer2_weight_6_mask                   (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_4_6_layer2_weight_6(data)                  (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_4_6_get_layer2_weight_6(data)              (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_4_7                                       0x181AB2F8
#define  SRNN_wdsr_layer2_1x1_weights_4_7_reg_addr                               "0xB81AB2F8"
#define  SRNN_wdsr_layer2_1x1_weights_4_7_reg                                    0xB81AB2F8
#define  SRNN_wdsr_layer2_1x1_weights_4_7_inst_addr                              "0x00E2"
#define  set_SRNN_wdsr_layer2_1x1_weights_4_7_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_4_7_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_4_7_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_4_7_reg))
#define  SRNN_wdsr_layer2_1x1_weights_4_7_layer2_weight_7_shift                  (0)
#define  SRNN_wdsr_layer2_1x1_weights_4_7_layer2_weight_7_mask                   (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_4_7_layer2_weight_7(data)                  (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_4_7_get_layer2_weight_7(data)              (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_4_8                                       0x181AB2FC
#define  SRNN_wdsr_layer2_1x1_weights_4_8_reg_addr                               "0xB81AB2FC"
#define  SRNN_wdsr_layer2_1x1_weights_4_8_reg                                    0xB81AB2FC
#define  SRNN_wdsr_layer2_1x1_weights_4_8_inst_addr                              "0x00E3"
#define  set_SRNN_wdsr_layer2_1x1_weights_4_8_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_4_8_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_4_8_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_4_8_reg))
#define  SRNN_wdsr_layer2_1x1_weights_4_8_layer2_weight_8_shift                  (0)
#define  SRNN_wdsr_layer2_1x1_weights_4_8_layer2_weight_8_mask                   (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_4_8_layer2_weight_8(data)                  (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_4_8_get_layer2_weight_8(data)              (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_5_1                                       0x181AB300
#define  SRNN_wdsr_layer2_1x1_weights_5_1_reg_addr                               "0xB81AB300"
#define  SRNN_wdsr_layer2_1x1_weights_5_1_reg                                    0xB81AB300
#define  SRNN_wdsr_layer2_1x1_weights_5_1_inst_addr                              "0x00E4"
#define  set_SRNN_wdsr_layer2_1x1_weights_5_1_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_5_1_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_5_1_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_5_1_reg))
#define  SRNN_wdsr_layer2_1x1_weights_5_1_layer2_weight_1_shift                  (0)
#define  SRNN_wdsr_layer2_1x1_weights_5_1_layer2_weight_1_mask                   (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_5_1_layer2_weight_1(data)                  (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_5_1_get_layer2_weight_1(data)              (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_5_2                                       0x181AB304
#define  SRNN_wdsr_layer2_1x1_weights_5_2_reg_addr                               "0xB81AB304"
#define  SRNN_wdsr_layer2_1x1_weights_5_2_reg                                    0xB81AB304
#define  SRNN_wdsr_layer2_1x1_weights_5_2_inst_addr                              "0x00E5"
#define  set_SRNN_wdsr_layer2_1x1_weights_5_2_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_5_2_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_5_2_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_5_2_reg))
#define  SRNN_wdsr_layer2_1x1_weights_5_2_layer2_weight_2_shift                  (0)
#define  SRNN_wdsr_layer2_1x1_weights_5_2_layer2_weight_2_mask                   (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_5_2_layer2_weight_2(data)                  (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_5_2_get_layer2_weight_2(data)              (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_5_3                                       0x181AB308
#define  SRNN_wdsr_layer2_1x1_weights_5_3_reg_addr                               "0xB81AB308"
#define  SRNN_wdsr_layer2_1x1_weights_5_3_reg                                    0xB81AB308
#define  SRNN_wdsr_layer2_1x1_weights_5_3_inst_addr                              "0x00E6"
#define  set_SRNN_wdsr_layer2_1x1_weights_5_3_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_5_3_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_5_3_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_5_3_reg))
#define  SRNN_wdsr_layer2_1x1_weights_5_3_layer2_weight_3_shift                  (0)
#define  SRNN_wdsr_layer2_1x1_weights_5_3_layer2_weight_3_mask                   (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_5_3_layer2_weight_3(data)                  (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_5_3_get_layer2_weight_3(data)              (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_5_4                                       0x181AB30C
#define  SRNN_wdsr_layer2_1x1_weights_5_4_reg_addr                               "0xB81AB30C"
#define  SRNN_wdsr_layer2_1x1_weights_5_4_reg                                    0xB81AB30C
#define  SRNN_wdsr_layer2_1x1_weights_5_4_inst_addr                              "0x00E7"
#define  set_SRNN_wdsr_layer2_1x1_weights_5_4_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_5_4_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_5_4_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_5_4_reg))
#define  SRNN_wdsr_layer2_1x1_weights_5_4_layer2_weight_4_shift                  (0)
#define  SRNN_wdsr_layer2_1x1_weights_5_4_layer2_weight_4_mask                   (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_5_4_layer2_weight_4(data)                  (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_5_4_get_layer2_weight_4(data)              (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_5_5                                       0x181AB310
#define  SRNN_wdsr_layer2_1x1_weights_5_5_reg_addr                               "0xB81AB310"
#define  SRNN_wdsr_layer2_1x1_weights_5_5_reg                                    0xB81AB310
#define  SRNN_wdsr_layer2_1x1_weights_5_5_inst_addr                              "0x00E8"
#define  set_SRNN_wdsr_layer2_1x1_weights_5_5_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_5_5_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_5_5_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_5_5_reg))
#define  SRNN_wdsr_layer2_1x1_weights_5_5_layer2_weight_5_shift                  (0)
#define  SRNN_wdsr_layer2_1x1_weights_5_5_layer2_weight_5_mask                   (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_5_5_layer2_weight_5(data)                  (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_5_5_get_layer2_weight_5(data)              (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_5_6                                       0x181AB314
#define  SRNN_wdsr_layer2_1x1_weights_5_6_reg_addr                               "0xB81AB314"
#define  SRNN_wdsr_layer2_1x1_weights_5_6_reg                                    0xB81AB314
#define  SRNN_wdsr_layer2_1x1_weights_5_6_inst_addr                              "0x00E9"
#define  set_SRNN_wdsr_layer2_1x1_weights_5_6_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_5_6_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_5_6_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_5_6_reg))
#define  SRNN_wdsr_layer2_1x1_weights_5_6_layer2_weight_6_shift                  (0)
#define  SRNN_wdsr_layer2_1x1_weights_5_6_layer2_weight_6_mask                   (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_5_6_layer2_weight_6(data)                  (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_5_6_get_layer2_weight_6(data)              (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_5_7                                       0x181AB318
#define  SRNN_wdsr_layer2_1x1_weights_5_7_reg_addr                               "0xB81AB318"
#define  SRNN_wdsr_layer2_1x1_weights_5_7_reg                                    0xB81AB318
#define  SRNN_wdsr_layer2_1x1_weights_5_7_inst_addr                              "0x00EA"
#define  set_SRNN_wdsr_layer2_1x1_weights_5_7_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_5_7_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_5_7_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_5_7_reg))
#define  SRNN_wdsr_layer2_1x1_weights_5_7_layer2_weight_7_shift                  (0)
#define  SRNN_wdsr_layer2_1x1_weights_5_7_layer2_weight_7_mask                   (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_5_7_layer2_weight_7(data)                  (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_5_7_get_layer2_weight_7(data)              (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_5_8                                       0x181AB31C
#define  SRNN_wdsr_layer2_1x1_weights_5_8_reg_addr                               "0xB81AB31C"
#define  SRNN_wdsr_layer2_1x1_weights_5_8_reg                                    0xB81AB31C
#define  SRNN_wdsr_layer2_1x1_weights_5_8_inst_addr                              "0x00EB"
#define  set_SRNN_wdsr_layer2_1x1_weights_5_8_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_5_8_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_5_8_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_5_8_reg))
#define  SRNN_wdsr_layer2_1x1_weights_5_8_layer2_weight_8_shift                  (0)
#define  SRNN_wdsr_layer2_1x1_weights_5_8_layer2_weight_8_mask                   (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_5_8_layer2_weight_8(data)                  (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_5_8_get_layer2_weight_8(data)              (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_6_1                                       0x181AB320
#define  SRNN_wdsr_layer2_1x1_weights_6_1_reg_addr                               "0xB81AB320"
#define  SRNN_wdsr_layer2_1x1_weights_6_1_reg                                    0xB81AB320
#define  SRNN_wdsr_layer2_1x1_weights_6_1_inst_addr                              "0x00EC"
#define  set_SRNN_wdsr_layer2_1x1_weights_6_1_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_6_1_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_6_1_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_6_1_reg))
#define  SRNN_wdsr_layer2_1x1_weights_6_1_layer2_weight_1_shift                  (0)
#define  SRNN_wdsr_layer2_1x1_weights_6_1_layer2_weight_1_mask                   (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_6_1_layer2_weight_1(data)                  (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_6_1_get_layer2_weight_1(data)              (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_6_2                                       0x181AB324
#define  SRNN_wdsr_layer2_1x1_weights_6_2_reg_addr                               "0xB81AB324"
#define  SRNN_wdsr_layer2_1x1_weights_6_2_reg                                    0xB81AB324
#define  SRNN_wdsr_layer2_1x1_weights_6_2_inst_addr                              "0x00ED"
#define  set_SRNN_wdsr_layer2_1x1_weights_6_2_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_6_2_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_6_2_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_6_2_reg))
#define  SRNN_wdsr_layer2_1x1_weights_6_2_layer2_weight_2_shift                  (0)
#define  SRNN_wdsr_layer2_1x1_weights_6_2_layer2_weight_2_mask                   (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_6_2_layer2_weight_2(data)                  (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_6_2_get_layer2_weight_2(data)              (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_6_3                                       0x181AB328
#define  SRNN_wdsr_layer2_1x1_weights_6_3_reg_addr                               "0xB81AB328"
#define  SRNN_wdsr_layer2_1x1_weights_6_3_reg                                    0xB81AB328
#define  SRNN_wdsr_layer2_1x1_weights_6_3_inst_addr                              "0x00EE"
#define  set_SRNN_wdsr_layer2_1x1_weights_6_3_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_6_3_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_6_3_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_6_3_reg))
#define  SRNN_wdsr_layer2_1x1_weights_6_3_layer2_weight_3_shift                  (0)
#define  SRNN_wdsr_layer2_1x1_weights_6_3_layer2_weight_3_mask                   (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_6_3_layer2_weight_3(data)                  (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_6_3_get_layer2_weight_3(data)              (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_6_4                                       0x181AB32C
#define  SRNN_wdsr_layer2_1x1_weights_6_4_reg_addr                               "0xB81AB32C"
#define  SRNN_wdsr_layer2_1x1_weights_6_4_reg                                    0xB81AB32C
#define  SRNN_wdsr_layer2_1x1_weights_6_4_inst_addr                              "0x00EF"
#define  set_SRNN_wdsr_layer2_1x1_weights_6_4_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_6_4_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_6_4_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_6_4_reg))
#define  SRNN_wdsr_layer2_1x1_weights_6_4_layer2_weight_4_shift                  (0)
#define  SRNN_wdsr_layer2_1x1_weights_6_4_layer2_weight_4_mask                   (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_6_4_layer2_weight_4(data)                  (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_6_4_get_layer2_weight_4(data)              (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_6_5                                       0x181AB330
#define  SRNN_wdsr_layer2_1x1_weights_6_5_reg_addr                               "0xB81AB330"
#define  SRNN_wdsr_layer2_1x1_weights_6_5_reg                                    0xB81AB330
#define  SRNN_wdsr_layer2_1x1_weights_6_5_inst_addr                              "0x00F0"
#define  set_SRNN_wdsr_layer2_1x1_weights_6_5_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_6_5_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_6_5_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_6_5_reg))
#define  SRNN_wdsr_layer2_1x1_weights_6_5_layer2_weight_5_shift                  (0)
#define  SRNN_wdsr_layer2_1x1_weights_6_5_layer2_weight_5_mask                   (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_6_5_layer2_weight_5(data)                  (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_6_5_get_layer2_weight_5(data)              (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_6_6                                       0x181AB334
#define  SRNN_wdsr_layer2_1x1_weights_6_6_reg_addr                               "0xB81AB334"
#define  SRNN_wdsr_layer2_1x1_weights_6_6_reg                                    0xB81AB334
#define  SRNN_wdsr_layer2_1x1_weights_6_6_inst_addr                              "0x00F1"
#define  set_SRNN_wdsr_layer2_1x1_weights_6_6_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_6_6_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_6_6_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_6_6_reg))
#define  SRNN_wdsr_layer2_1x1_weights_6_6_layer2_weight_6_shift                  (0)
#define  SRNN_wdsr_layer2_1x1_weights_6_6_layer2_weight_6_mask                   (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_6_6_layer2_weight_6(data)                  (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_6_6_get_layer2_weight_6(data)              (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_6_7                                       0x181AB338
#define  SRNN_wdsr_layer2_1x1_weights_6_7_reg_addr                               "0xB81AB338"
#define  SRNN_wdsr_layer2_1x1_weights_6_7_reg                                    0xB81AB338
#define  SRNN_wdsr_layer2_1x1_weights_6_7_inst_addr                              "0x00F2"
#define  set_SRNN_wdsr_layer2_1x1_weights_6_7_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_6_7_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_6_7_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_6_7_reg))
#define  SRNN_wdsr_layer2_1x1_weights_6_7_layer2_weight_7_shift                  (0)
#define  SRNN_wdsr_layer2_1x1_weights_6_7_layer2_weight_7_mask                   (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_6_7_layer2_weight_7(data)                  (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_6_7_get_layer2_weight_7(data)              (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_6_8                                       0x181AB33C
#define  SRNN_wdsr_layer2_1x1_weights_6_8_reg_addr                               "0xB81AB33C"
#define  SRNN_wdsr_layer2_1x1_weights_6_8_reg                                    0xB81AB33C
#define  SRNN_wdsr_layer2_1x1_weights_6_8_inst_addr                              "0x00F3"
#define  set_SRNN_wdsr_layer2_1x1_weights_6_8_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_6_8_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_6_8_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_6_8_reg))
#define  SRNN_wdsr_layer2_1x1_weights_6_8_layer2_weight_8_shift                  (0)
#define  SRNN_wdsr_layer2_1x1_weights_6_8_layer2_weight_8_mask                   (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_6_8_layer2_weight_8(data)                  (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_6_8_get_layer2_weight_8(data)              (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_7_1                                       0x181AB340
#define  SRNN_wdsr_layer2_1x1_weights_7_1_reg_addr                               "0xB81AB340"
#define  SRNN_wdsr_layer2_1x1_weights_7_1_reg                                    0xB81AB340
#define  SRNN_wdsr_layer2_1x1_weights_7_1_inst_addr                              "0x00F4"
#define  set_SRNN_wdsr_layer2_1x1_weights_7_1_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_7_1_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_7_1_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_7_1_reg))
#define  SRNN_wdsr_layer2_1x1_weights_7_1_layer2_weight_1_shift                  (0)
#define  SRNN_wdsr_layer2_1x1_weights_7_1_layer2_weight_1_mask                   (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_7_1_layer2_weight_1(data)                  (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_7_1_get_layer2_weight_1(data)              (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_7_2                                       0x181AB344
#define  SRNN_wdsr_layer2_1x1_weights_7_2_reg_addr                               "0xB81AB344"
#define  SRNN_wdsr_layer2_1x1_weights_7_2_reg                                    0xB81AB344
#define  SRNN_wdsr_layer2_1x1_weights_7_2_inst_addr                              "0x00F5"
#define  set_SRNN_wdsr_layer2_1x1_weights_7_2_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_7_2_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_7_2_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_7_2_reg))
#define  SRNN_wdsr_layer2_1x1_weights_7_2_layer2_weight_2_shift                  (0)
#define  SRNN_wdsr_layer2_1x1_weights_7_2_layer2_weight_2_mask                   (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_7_2_layer2_weight_2(data)                  (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_7_2_get_layer2_weight_2(data)              (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_7_3                                       0x181AB348
#define  SRNN_wdsr_layer2_1x1_weights_7_3_reg_addr                               "0xB81AB348"
#define  SRNN_wdsr_layer2_1x1_weights_7_3_reg                                    0xB81AB348
#define  SRNN_wdsr_layer2_1x1_weights_7_3_inst_addr                              "0x00F6"
#define  set_SRNN_wdsr_layer2_1x1_weights_7_3_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_7_3_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_7_3_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_7_3_reg))
#define  SRNN_wdsr_layer2_1x1_weights_7_3_layer2_weight_3_shift                  (0)
#define  SRNN_wdsr_layer2_1x1_weights_7_3_layer2_weight_3_mask                   (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_7_3_layer2_weight_3(data)                  (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_7_3_get_layer2_weight_3(data)              (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_7_4                                       0x181AB34C
#define  SRNN_wdsr_layer2_1x1_weights_7_4_reg_addr                               "0xB81AB34C"
#define  SRNN_wdsr_layer2_1x1_weights_7_4_reg                                    0xB81AB34C
#define  SRNN_wdsr_layer2_1x1_weights_7_4_inst_addr                              "0x00F7"
#define  set_SRNN_wdsr_layer2_1x1_weights_7_4_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_7_4_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_7_4_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_7_4_reg))
#define  SRNN_wdsr_layer2_1x1_weights_7_4_layer2_weight_4_shift                  (0)
#define  SRNN_wdsr_layer2_1x1_weights_7_4_layer2_weight_4_mask                   (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_7_4_layer2_weight_4(data)                  (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_7_4_get_layer2_weight_4(data)              (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_7_5                                       0x181AB350
#define  SRNN_wdsr_layer2_1x1_weights_7_5_reg_addr                               "0xB81AB350"
#define  SRNN_wdsr_layer2_1x1_weights_7_5_reg                                    0xB81AB350
#define  SRNN_wdsr_layer2_1x1_weights_7_5_inst_addr                              "0x00F8"
#define  set_SRNN_wdsr_layer2_1x1_weights_7_5_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_7_5_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_7_5_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_7_5_reg))
#define  SRNN_wdsr_layer2_1x1_weights_7_5_layer2_weight_5_shift                  (0)
#define  SRNN_wdsr_layer2_1x1_weights_7_5_layer2_weight_5_mask                   (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_7_5_layer2_weight_5(data)                  (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_7_5_get_layer2_weight_5(data)              (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_7_6                                       0x181AB354
#define  SRNN_wdsr_layer2_1x1_weights_7_6_reg_addr                               "0xB81AB354"
#define  SRNN_wdsr_layer2_1x1_weights_7_6_reg                                    0xB81AB354
#define  SRNN_wdsr_layer2_1x1_weights_7_6_inst_addr                              "0x00F9"
#define  set_SRNN_wdsr_layer2_1x1_weights_7_6_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_7_6_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_7_6_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_7_6_reg))
#define  SRNN_wdsr_layer2_1x1_weights_7_6_layer2_weight_6_shift                  (0)
#define  SRNN_wdsr_layer2_1x1_weights_7_6_layer2_weight_6_mask                   (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_7_6_layer2_weight_6(data)                  (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_7_6_get_layer2_weight_6(data)              (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_7_7                                       0x181AB358
#define  SRNN_wdsr_layer2_1x1_weights_7_7_reg_addr                               "0xB81AB358"
#define  SRNN_wdsr_layer2_1x1_weights_7_7_reg                                    0xB81AB358
#define  SRNN_wdsr_layer2_1x1_weights_7_7_inst_addr                              "0x00FA"
#define  set_SRNN_wdsr_layer2_1x1_weights_7_7_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_7_7_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_7_7_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_7_7_reg))
#define  SRNN_wdsr_layer2_1x1_weights_7_7_layer2_weight_7_shift                  (0)
#define  SRNN_wdsr_layer2_1x1_weights_7_7_layer2_weight_7_mask                   (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_7_7_layer2_weight_7(data)                  (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_7_7_get_layer2_weight_7(data)              (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_7_8                                       0x181AB35C
#define  SRNN_wdsr_layer2_1x1_weights_7_8_reg_addr                               "0xB81AB35C"
#define  SRNN_wdsr_layer2_1x1_weights_7_8_reg                                    0xB81AB35C
#define  SRNN_wdsr_layer2_1x1_weights_7_8_inst_addr                              "0x00FB"
#define  set_SRNN_wdsr_layer2_1x1_weights_7_8_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_7_8_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_7_8_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_7_8_reg))
#define  SRNN_wdsr_layer2_1x1_weights_7_8_layer2_weight_8_shift                  (0)
#define  SRNN_wdsr_layer2_1x1_weights_7_8_layer2_weight_8_mask                   (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_7_8_layer2_weight_8(data)                  (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_7_8_get_layer2_weight_8(data)              (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_8_1                                       0x181AB360
#define  SRNN_wdsr_layer2_1x1_weights_8_1_reg_addr                               "0xB81AB360"
#define  SRNN_wdsr_layer2_1x1_weights_8_1_reg                                    0xB81AB360
#define  SRNN_wdsr_layer2_1x1_weights_8_1_inst_addr                              "0x00FC"
#define  set_SRNN_wdsr_layer2_1x1_weights_8_1_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_8_1_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_8_1_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_8_1_reg))
#define  SRNN_wdsr_layer2_1x1_weights_8_1_layer2_weight_1_shift                  (0)
#define  SRNN_wdsr_layer2_1x1_weights_8_1_layer2_weight_1_mask                   (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_8_1_layer2_weight_1(data)                  (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_8_1_get_layer2_weight_1(data)              (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_8_2                                       0x181AB364
#define  SRNN_wdsr_layer2_1x1_weights_8_2_reg_addr                               "0xB81AB364"
#define  SRNN_wdsr_layer2_1x1_weights_8_2_reg                                    0xB81AB364
#define  SRNN_wdsr_layer2_1x1_weights_8_2_inst_addr                              "0x00FD"
#define  set_SRNN_wdsr_layer2_1x1_weights_8_2_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_8_2_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_8_2_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_8_2_reg))
#define  SRNN_wdsr_layer2_1x1_weights_8_2_layer2_weight_2_shift                  (0)
#define  SRNN_wdsr_layer2_1x1_weights_8_2_layer2_weight_2_mask                   (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_8_2_layer2_weight_2(data)                  (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_8_2_get_layer2_weight_2(data)              (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_8_3                                       0x181AB368
#define  SRNN_wdsr_layer2_1x1_weights_8_3_reg_addr                               "0xB81AB368"
#define  SRNN_wdsr_layer2_1x1_weights_8_3_reg                                    0xB81AB368
#define  SRNN_wdsr_layer2_1x1_weights_8_3_inst_addr                              "0x00FE"
#define  set_SRNN_wdsr_layer2_1x1_weights_8_3_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_8_3_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_8_3_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_8_3_reg))
#define  SRNN_wdsr_layer2_1x1_weights_8_3_layer2_weight_3_shift                  (0)
#define  SRNN_wdsr_layer2_1x1_weights_8_3_layer2_weight_3_mask                   (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_8_3_layer2_weight_3(data)                  (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_8_3_get_layer2_weight_3(data)              (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_8_4                                       0x181AB36C
#define  SRNN_wdsr_layer2_1x1_weights_8_4_reg_addr                               "0xB81AB36C"
#define  SRNN_wdsr_layer2_1x1_weights_8_4_reg                                    0xB81AB36C
#define  SRNN_wdsr_layer2_1x1_weights_8_4_inst_addr                              "0x00FF"
#define  set_SRNN_wdsr_layer2_1x1_weights_8_4_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_8_4_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_8_4_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_8_4_reg))
#define  SRNN_wdsr_layer2_1x1_weights_8_4_layer2_weight_4_shift                  (0)
#define  SRNN_wdsr_layer2_1x1_weights_8_4_layer2_weight_4_mask                   (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_8_4_layer2_weight_4(data)                  (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_8_4_get_layer2_weight_4(data)              (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_8_5                                       0x181AB370
#define  SRNN_wdsr_layer2_1x1_weights_8_5_reg_addr                               "0xB81AB370"
#define  SRNN_wdsr_layer2_1x1_weights_8_5_reg                                    0xB81AB370
#define  SRNN_wdsr_layer2_1x1_weights_8_5_inst_addr                              "0x0100"
#define  set_SRNN_wdsr_layer2_1x1_weights_8_5_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_8_5_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_8_5_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_8_5_reg))
#define  SRNN_wdsr_layer2_1x1_weights_8_5_layer2_weight_5_shift                  (0)
#define  SRNN_wdsr_layer2_1x1_weights_8_5_layer2_weight_5_mask                   (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_8_5_layer2_weight_5(data)                  (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_8_5_get_layer2_weight_5(data)              (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_8_6                                       0x181AB374
#define  SRNN_wdsr_layer2_1x1_weights_8_6_reg_addr                               "0xB81AB374"
#define  SRNN_wdsr_layer2_1x1_weights_8_6_reg                                    0xB81AB374
#define  SRNN_wdsr_layer2_1x1_weights_8_6_inst_addr                              "0x0101"
#define  set_SRNN_wdsr_layer2_1x1_weights_8_6_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_8_6_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_8_6_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_8_6_reg))
#define  SRNN_wdsr_layer2_1x1_weights_8_6_layer2_weight_6_shift                  (0)
#define  SRNN_wdsr_layer2_1x1_weights_8_6_layer2_weight_6_mask                   (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_8_6_layer2_weight_6(data)                  (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_8_6_get_layer2_weight_6(data)              (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_8_7                                       0x181AB378
#define  SRNN_wdsr_layer2_1x1_weights_8_7_reg_addr                               "0xB81AB378"
#define  SRNN_wdsr_layer2_1x1_weights_8_7_reg                                    0xB81AB378
#define  SRNN_wdsr_layer2_1x1_weights_8_7_inst_addr                              "0x0102"
#define  set_SRNN_wdsr_layer2_1x1_weights_8_7_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_8_7_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_8_7_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_8_7_reg))
#define  SRNN_wdsr_layer2_1x1_weights_8_7_layer2_weight_7_shift                  (0)
#define  SRNN_wdsr_layer2_1x1_weights_8_7_layer2_weight_7_mask                   (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_8_7_layer2_weight_7(data)                  (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_8_7_get_layer2_weight_7(data)              (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_8_8                                       0x181AB37C
#define  SRNN_wdsr_layer2_1x1_weights_8_8_reg_addr                               "0xB81AB37C"
#define  SRNN_wdsr_layer2_1x1_weights_8_8_reg                                    0xB81AB37C
#define  SRNN_wdsr_layer2_1x1_weights_8_8_inst_addr                              "0x0103"
#define  set_SRNN_wdsr_layer2_1x1_weights_8_8_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_8_8_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_8_8_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_8_8_reg))
#define  SRNN_wdsr_layer2_1x1_weights_8_8_layer2_weight_8_shift                  (0)
#define  SRNN_wdsr_layer2_1x1_weights_8_8_layer2_weight_8_mask                   (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_8_8_layer2_weight_8(data)                  (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_8_8_get_layer2_weight_8(data)              (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_9_1                                       0x181AB380
#define  SRNN_wdsr_layer2_1x1_weights_9_1_reg_addr                               "0xB81AB380"
#define  SRNN_wdsr_layer2_1x1_weights_9_1_reg                                    0xB81AB380
#define  SRNN_wdsr_layer2_1x1_weights_9_1_inst_addr                              "0x0104"
#define  set_SRNN_wdsr_layer2_1x1_weights_9_1_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_9_1_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_9_1_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_9_1_reg))
#define  SRNN_wdsr_layer2_1x1_weights_9_1_layer2_weight_1_shift                  (0)
#define  SRNN_wdsr_layer2_1x1_weights_9_1_layer2_weight_1_mask                   (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_9_1_layer2_weight_1(data)                  (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_9_1_get_layer2_weight_1(data)              (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_9_2                                       0x181AB384
#define  SRNN_wdsr_layer2_1x1_weights_9_2_reg_addr                               "0xB81AB384"
#define  SRNN_wdsr_layer2_1x1_weights_9_2_reg                                    0xB81AB384
#define  SRNN_wdsr_layer2_1x1_weights_9_2_inst_addr                              "0x0105"
#define  set_SRNN_wdsr_layer2_1x1_weights_9_2_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_9_2_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_9_2_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_9_2_reg))
#define  SRNN_wdsr_layer2_1x1_weights_9_2_layer2_weight_2_shift                  (0)
#define  SRNN_wdsr_layer2_1x1_weights_9_2_layer2_weight_2_mask                   (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_9_2_layer2_weight_2(data)                  (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_9_2_get_layer2_weight_2(data)              (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_9_3                                       0x181AB388
#define  SRNN_wdsr_layer2_1x1_weights_9_3_reg_addr                               "0xB81AB388"
#define  SRNN_wdsr_layer2_1x1_weights_9_3_reg                                    0xB81AB388
#define  SRNN_wdsr_layer2_1x1_weights_9_3_inst_addr                              "0x0106"
#define  set_SRNN_wdsr_layer2_1x1_weights_9_3_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_9_3_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_9_3_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_9_3_reg))
#define  SRNN_wdsr_layer2_1x1_weights_9_3_layer2_weight_3_shift                  (0)
#define  SRNN_wdsr_layer2_1x1_weights_9_3_layer2_weight_3_mask                   (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_9_3_layer2_weight_3(data)                  (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_9_3_get_layer2_weight_3(data)              (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_9_4                                       0x181AB38C
#define  SRNN_wdsr_layer2_1x1_weights_9_4_reg_addr                               "0xB81AB38C"
#define  SRNN_wdsr_layer2_1x1_weights_9_4_reg                                    0xB81AB38C
#define  SRNN_wdsr_layer2_1x1_weights_9_4_inst_addr                              "0x0107"
#define  set_SRNN_wdsr_layer2_1x1_weights_9_4_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_9_4_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_9_4_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_9_4_reg))
#define  SRNN_wdsr_layer2_1x1_weights_9_4_layer2_weight_4_shift                  (0)
#define  SRNN_wdsr_layer2_1x1_weights_9_4_layer2_weight_4_mask                   (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_9_4_layer2_weight_4(data)                  (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_9_4_get_layer2_weight_4(data)              (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_9_5                                       0x181AB390
#define  SRNN_wdsr_layer2_1x1_weights_9_5_reg_addr                               "0xB81AB390"
#define  SRNN_wdsr_layer2_1x1_weights_9_5_reg                                    0xB81AB390
#define  SRNN_wdsr_layer2_1x1_weights_9_5_inst_addr                              "0x0108"
#define  set_SRNN_wdsr_layer2_1x1_weights_9_5_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_9_5_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_9_5_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_9_5_reg))
#define  SRNN_wdsr_layer2_1x1_weights_9_5_layer2_weight_5_shift                  (0)
#define  SRNN_wdsr_layer2_1x1_weights_9_5_layer2_weight_5_mask                   (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_9_5_layer2_weight_5(data)                  (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_9_5_get_layer2_weight_5(data)              (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_9_6                                       0x181AB394
#define  SRNN_wdsr_layer2_1x1_weights_9_6_reg_addr                               "0xB81AB394"
#define  SRNN_wdsr_layer2_1x1_weights_9_6_reg                                    0xB81AB394
#define  SRNN_wdsr_layer2_1x1_weights_9_6_inst_addr                              "0x0109"
#define  set_SRNN_wdsr_layer2_1x1_weights_9_6_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_9_6_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_9_6_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_9_6_reg))
#define  SRNN_wdsr_layer2_1x1_weights_9_6_layer2_weight_6_shift                  (0)
#define  SRNN_wdsr_layer2_1x1_weights_9_6_layer2_weight_6_mask                   (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_9_6_layer2_weight_6(data)                  (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_9_6_get_layer2_weight_6(data)              (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_9_7                                       0x181AB398
#define  SRNN_wdsr_layer2_1x1_weights_9_7_reg_addr                               "0xB81AB398"
#define  SRNN_wdsr_layer2_1x1_weights_9_7_reg                                    0xB81AB398
#define  SRNN_wdsr_layer2_1x1_weights_9_7_inst_addr                              "0x010A"
#define  set_SRNN_wdsr_layer2_1x1_weights_9_7_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_9_7_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_9_7_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_9_7_reg))
#define  SRNN_wdsr_layer2_1x1_weights_9_7_layer2_weight_7_shift                  (0)
#define  SRNN_wdsr_layer2_1x1_weights_9_7_layer2_weight_7_mask                   (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_9_7_layer2_weight_7(data)                  (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_9_7_get_layer2_weight_7(data)              (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_9_8                                       0x181AB39C
#define  SRNN_wdsr_layer2_1x1_weights_9_8_reg_addr                               "0xB81AB39C"
#define  SRNN_wdsr_layer2_1x1_weights_9_8_reg                                    0xB81AB39C
#define  SRNN_wdsr_layer2_1x1_weights_9_8_inst_addr                              "0x010B"
#define  set_SRNN_wdsr_layer2_1x1_weights_9_8_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_9_8_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_9_8_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_9_8_reg))
#define  SRNN_wdsr_layer2_1x1_weights_9_8_layer2_weight_8_shift                  (0)
#define  SRNN_wdsr_layer2_1x1_weights_9_8_layer2_weight_8_mask                   (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_9_8_layer2_weight_8(data)                  (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_9_8_get_layer2_weight_8(data)              (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_10_1                                      0x181AB3A0
#define  SRNN_wdsr_layer2_1x1_weights_10_1_reg_addr                              "0xB81AB3A0"
#define  SRNN_wdsr_layer2_1x1_weights_10_1_reg                                   0xB81AB3A0
#define  SRNN_wdsr_layer2_1x1_weights_10_1_inst_addr                             "0x010C"
#define  set_SRNN_wdsr_layer2_1x1_weights_10_1_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_10_1_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_10_1_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_10_1_reg))
#define  SRNN_wdsr_layer2_1x1_weights_10_1_layer2_weight_1_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_10_1_layer2_weight_1_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_10_1_layer2_weight_1(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_10_1_get_layer2_weight_1(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_10_2                                      0x181AB3A4
#define  SRNN_wdsr_layer2_1x1_weights_10_2_reg_addr                              "0xB81AB3A4"
#define  SRNN_wdsr_layer2_1x1_weights_10_2_reg                                   0xB81AB3A4
#define  SRNN_wdsr_layer2_1x1_weights_10_2_inst_addr                             "0x010D"
#define  set_SRNN_wdsr_layer2_1x1_weights_10_2_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_10_2_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_10_2_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_10_2_reg))
#define  SRNN_wdsr_layer2_1x1_weights_10_2_layer2_weight_2_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_10_2_layer2_weight_2_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_10_2_layer2_weight_2(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_10_2_get_layer2_weight_2(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_10_3                                      0x181AB3A8
#define  SRNN_wdsr_layer2_1x1_weights_10_3_reg_addr                              "0xB81AB3A8"
#define  SRNN_wdsr_layer2_1x1_weights_10_3_reg                                   0xB81AB3A8
#define  SRNN_wdsr_layer2_1x1_weights_10_3_inst_addr                             "0x010E"
#define  set_SRNN_wdsr_layer2_1x1_weights_10_3_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_10_3_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_10_3_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_10_3_reg))
#define  SRNN_wdsr_layer2_1x1_weights_10_3_layer2_weight_3_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_10_3_layer2_weight_3_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_10_3_layer2_weight_3(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_10_3_get_layer2_weight_3(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_10_4                                      0x181AB3AC
#define  SRNN_wdsr_layer2_1x1_weights_10_4_reg_addr                              "0xB81AB3AC"
#define  SRNN_wdsr_layer2_1x1_weights_10_4_reg                                   0xB81AB3AC
#define  SRNN_wdsr_layer2_1x1_weights_10_4_inst_addr                             "0x010F"
#define  set_SRNN_wdsr_layer2_1x1_weights_10_4_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_10_4_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_10_4_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_10_4_reg))
#define  SRNN_wdsr_layer2_1x1_weights_10_4_layer2_weight_4_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_10_4_layer2_weight_4_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_10_4_layer2_weight_4(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_10_4_get_layer2_weight_4(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_10_5                                      0x181AB3B0
#define  SRNN_wdsr_layer2_1x1_weights_10_5_reg_addr                              "0xB81AB3B0"
#define  SRNN_wdsr_layer2_1x1_weights_10_5_reg                                   0xB81AB3B0
#define  SRNN_wdsr_layer2_1x1_weights_10_5_inst_addr                             "0x0110"
#define  set_SRNN_wdsr_layer2_1x1_weights_10_5_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_10_5_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_10_5_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_10_5_reg))
#define  SRNN_wdsr_layer2_1x1_weights_10_5_layer2_weight_5_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_10_5_layer2_weight_5_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_10_5_layer2_weight_5(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_10_5_get_layer2_weight_5(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_10_6                                      0x181AB3B4
#define  SRNN_wdsr_layer2_1x1_weights_10_6_reg_addr                              "0xB81AB3B4"
#define  SRNN_wdsr_layer2_1x1_weights_10_6_reg                                   0xB81AB3B4
#define  SRNN_wdsr_layer2_1x1_weights_10_6_inst_addr                             "0x0111"
#define  set_SRNN_wdsr_layer2_1x1_weights_10_6_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_10_6_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_10_6_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_10_6_reg))
#define  SRNN_wdsr_layer2_1x1_weights_10_6_layer2_weight_6_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_10_6_layer2_weight_6_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_10_6_layer2_weight_6(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_10_6_get_layer2_weight_6(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_10_7                                      0x181AB3B8
#define  SRNN_wdsr_layer2_1x1_weights_10_7_reg_addr                              "0xB81AB3B8"
#define  SRNN_wdsr_layer2_1x1_weights_10_7_reg                                   0xB81AB3B8
#define  SRNN_wdsr_layer2_1x1_weights_10_7_inst_addr                             "0x0112"
#define  set_SRNN_wdsr_layer2_1x1_weights_10_7_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_10_7_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_10_7_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_10_7_reg))
#define  SRNN_wdsr_layer2_1x1_weights_10_7_layer2_weight_7_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_10_7_layer2_weight_7_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_10_7_layer2_weight_7(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_10_7_get_layer2_weight_7(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_10_8                                      0x181AB3BC
#define  SRNN_wdsr_layer2_1x1_weights_10_8_reg_addr                              "0xB81AB3BC"
#define  SRNN_wdsr_layer2_1x1_weights_10_8_reg                                   0xB81AB3BC
#define  SRNN_wdsr_layer2_1x1_weights_10_8_inst_addr                             "0x0113"
#define  set_SRNN_wdsr_layer2_1x1_weights_10_8_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_10_8_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_10_8_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_10_8_reg))
#define  SRNN_wdsr_layer2_1x1_weights_10_8_layer2_weight_8_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_10_8_layer2_weight_8_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_10_8_layer2_weight_8(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_10_8_get_layer2_weight_8(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_11_1                                      0x181AB3C0
#define  SRNN_wdsr_layer2_1x1_weights_11_1_reg_addr                              "0xB81AB3C0"
#define  SRNN_wdsr_layer2_1x1_weights_11_1_reg                                   0xB81AB3C0
#define  SRNN_wdsr_layer2_1x1_weights_11_1_inst_addr                             "0x0114"
#define  set_SRNN_wdsr_layer2_1x1_weights_11_1_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_11_1_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_11_1_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_11_1_reg))
#define  SRNN_wdsr_layer2_1x1_weights_11_1_layer2_weight_1_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_11_1_layer2_weight_1_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_11_1_layer2_weight_1(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_11_1_get_layer2_weight_1(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_11_2                                      0x181AB3C4
#define  SRNN_wdsr_layer2_1x1_weights_11_2_reg_addr                              "0xB81AB3C4"
#define  SRNN_wdsr_layer2_1x1_weights_11_2_reg                                   0xB81AB3C4
#define  SRNN_wdsr_layer2_1x1_weights_11_2_inst_addr                             "0x0115"
#define  set_SRNN_wdsr_layer2_1x1_weights_11_2_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_11_2_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_11_2_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_11_2_reg))
#define  SRNN_wdsr_layer2_1x1_weights_11_2_layer2_weight_2_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_11_2_layer2_weight_2_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_11_2_layer2_weight_2(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_11_2_get_layer2_weight_2(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_11_3                                      0x181AB3C8
#define  SRNN_wdsr_layer2_1x1_weights_11_3_reg_addr                              "0xB81AB3C8"
#define  SRNN_wdsr_layer2_1x1_weights_11_3_reg                                   0xB81AB3C8
#define  SRNN_wdsr_layer2_1x1_weights_11_3_inst_addr                             "0x0116"
#define  set_SRNN_wdsr_layer2_1x1_weights_11_3_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_11_3_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_11_3_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_11_3_reg))
#define  SRNN_wdsr_layer2_1x1_weights_11_3_layer2_weight_3_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_11_3_layer2_weight_3_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_11_3_layer2_weight_3(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_11_3_get_layer2_weight_3(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_11_4                                      0x181AB3CC
#define  SRNN_wdsr_layer2_1x1_weights_11_4_reg_addr                              "0xB81AB3CC"
#define  SRNN_wdsr_layer2_1x1_weights_11_4_reg                                   0xB81AB3CC
#define  SRNN_wdsr_layer2_1x1_weights_11_4_inst_addr                             "0x0117"
#define  set_SRNN_wdsr_layer2_1x1_weights_11_4_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_11_4_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_11_4_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_11_4_reg))
#define  SRNN_wdsr_layer2_1x1_weights_11_4_layer2_weight_4_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_11_4_layer2_weight_4_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_11_4_layer2_weight_4(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_11_4_get_layer2_weight_4(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_11_5                                      0x181AB3D0
#define  SRNN_wdsr_layer2_1x1_weights_11_5_reg_addr                              "0xB81AB3D0"
#define  SRNN_wdsr_layer2_1x1_weights_11_5_reg                                   0xB81AB3D0
#define  SRNN_wdsr_layer2_1x1_weights_11_5_inst_addr                             "0x0118"
#define  set_SRNN_wdsr_layer2_1x1_weights_11_5_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_11_5_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_11_5_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_11_5_reg))
#define  SRNN_wdsr_layer2_1x1_weights_11_5_layer2_weight_5_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_11_5_layer2_weight_5_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_11_5_layer2_weight_5(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_11_5_get_layer2_weight_5(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_11_6                                      0x181AB3D4
#define  SRNN_wdsr_layer2_1x1_weights_11_6_reg_addr                              "0xB81AB3D4"
#define  SRNN_wdsr_layer2_1x1_weights_11_6_reg                                   0xB81AB3D4
#define  SRNN_wdsr_layer2_1x1_weights_11_6_inst_addr                             "0x0119"
#define  set_SRNN_wdsr_layer2_1x1_weights_11_6_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_11_6_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_11_6_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_11_6_reg))
#define  SRNN_wdsr_layer2_1x1_weights_11_6_layer2_weight_6_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_11_6_layer2_weight_6_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_11_6_layer2_weight_6(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_11_6_get_layer2_weight_6(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_11_7                                      0x181AB3D8
#define  SRNN_wdsr_layer2_1x1_weights_11_7_reg_addr                              "0xB81AB3D8"
#define  SRNN_wdsr_layer2_1x1_weights_11_7_reg                                   0xB81AB3D8
#define  SRNN_wdsr_layer2_1x1_weights_11_7_inst_addr                             "0x011A"
#define  set_SRNN_wdsr_layer2_1x1_weights_11_7_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_11_7_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_11_7_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_11_7_reg))
#define  SRNN_wdsr_layer2_1x1_weights_11_7_layer2_weight_7_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_11_7_layer2_weight_7_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_11_7_layer2_weight_7(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_11_7_get_layer2_weight_7(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_11_8                                      0x181AB3DC
#define  SRNN_wdsr_layer2_1x1_weights_11_8_reg_addr                              "0xB81AB3DC"
#define  SRNN_wdsr_layer2_1x1_weights_11_8_reg                                   0xB81AB3DC
#define  SRNN_wdsr_layer2_1x1_weights_11_8_inst_addr                             "0x011B"
#define  set_SRNN_wdsr_layer2_1x1_weights_11_8_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_11_8_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_11_8_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_11_8_reg))
#define  SRNN_wdsr_layer2_1x1_weights_11_8_layer2_weight_8_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_11_8_layer2_weight_8_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_11_8_layer2_weight_8(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_11_8_get_layer2_weight_8(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_12_1                                      0x181AB3E0
#define  SRNN_wdsr_layer2_1x1_weights_12_1_reg_addr                              "0xB81AB3E0"
#define  SRNN_wdsr_layer2_1x1_weights_12_1_reg                                   0xB81AB3E0
#define  SRNN_wdsr_layer2_1x1_weights_12_1_inst_addr                             "0x011C"
#define  set_SRNN_wdsr_layer2_1x1_weights_12_1_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_12_1_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_12_1_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_12_1_reg))
#define  SRNN_wdsr_layer2_1x1_weights_12_1_layer2_weight_1_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_12_1_layer2_weight_1_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_12_1_layer2_weight_1(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_12_1_get_layer2_weight_1(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_12_2                                      0x181AB3E4
#define  SRNN_wdsr_layer2_1x1_weights_12_2_reg_addr                              "0xB81AB3E4"
#define  SRNN_wdsr_layer2_1x1_weights_12_2_reg                                   0xB81AB3E4
#define  SRNN_wdsr_layer2_1x1_weights_12_2_inst_addr                             "0x011D"
#define  set_SRNN_wdsr_layer2_1x1_weights_12_2_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_12_2_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_12_2_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_12_2_reg))
#define  SRNN_wdsr_layer2_1x1_weights_12_2_layer2_weight_2_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_12_2_layer2_weight_2_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_12_2_layer2_weight_2(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_12_2_get_layer2_weight_2(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_12_3                                      0x181AB3E8
#define  SRNN_wdsr_layer2_1x1_weights_12_3_reg_addr                              "0xB81AB3E8"
#define  SRNN_wdsr_layer2_1x1_weights_12_3_reg                                   0xB81AB3E8
#define  SRNN_wdsr_layer2_1x1_weights_12_3_inst_addr                             "0x011E"
#define  set_SRNN_wdsr_layer2_1x1_weights_12_3_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_12_3_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_12_3_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_12_3_reg))
#define  SRNN_wdsr_layer2_1x1_weights_12_3_layer2_weight_3_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_12_3_layer2_weight_3_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_12_3_layer2_weight_3(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_12_3_get_layer2_weight_3(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_12_4                                      0x181AB3EC
#define  SRNN_wdsr_layer2_1x1_weights_12_4_reg_addr                              "0xB81AB3EC"
#define  SRNN_wdsr_layer2_1x1_weights_12_4_reg                                   0xB81AB3EC
#define  SRNN_wdsr_layer2_1x1_weights_12_4_inst_addr                             "0x011F"
#define  set_SRNN_wdsr_layer2_1x1_weights_12_4_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_12_4_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_12_4_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_12_4_reg))
#define  SRNN_wdsr_layer2_1x1_weights_12_4_layer2_weight_4_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_12_4_layer2_weight_4_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_12_4_layer2_weight_4(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_12_4_get_layer2_weight_4(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_12_5                                      0x181AB3F0
#define  SRNN_wdsr_layer2_1x1_weights_12_5_reg_addr                              "0xB81AB3F0"
#define  SRNN_wdsr_layer2_1x1_weights_12_5_reg                                   0xB81AB3F0
#define  SRNN_wdsr_layer2_1x1_weights_12_5_inst_addr                             "0x0120"
#define  set_SRNN_wdsr_layer2_1x1_weights_12_5_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_12_5_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_12_5_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_12_5_reg))
#define  SRNN_wdsr_layer2_1x1_weights_12_5_layer2_weight_5_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_12_5_layer2_weight_5_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_12_5_layer2_weight_5(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_12_5_get_layer2_weight_5(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_12_6                                      0x181AB3F4
#define  SRNN_wdsr_layer2_1x1_weights_12_6_reg_addr                              "0xB81AB3F4"
#define  SRNN_wdsr_layer2_1x1_weights_12_6_reg                                   0xB81AB3F4
#define  SRNN_wdsr_layer2_1x1_weights_12_6_inst_addr                             "0x0121"
#define  set_SRNN_wdsr_layer2_1x1_weights_12_6_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_12_6_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_12_6_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_12_6_reg))
#define  SRNN_wdsr_layer2_1x1_weights_12_6_layer2_weight_6_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_12_6_layer2_weight_6_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_12_6_layer2_weight_6(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_12_6_get_layer2_weight_6(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_12_7                                      0x181AB3F8
#define  SRNN_wdsr_layer2_1x1_weights_12_7_reg_addr                              "0xB81AB3F8"
#define  SRNN_wdsr_layer2_1x1_weights_12_7_reg                                   0xB81AB3F8
#define  SRNN_wdsr_layer2_1x1_weights_12_7_inst_addr                             "0x0122"
#define  set_SRNN_wdsr_layer2_1x1_weights_12_7_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_12_7_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_12_7_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_12_7_reg))
#define  SRNN_wdsr_layer2_1x1_weights_12_7_layer2_weight_7_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_12_7_layer2_weight_7_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_12_7_layer2_weight_7(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_12_7_get_layer2_weight_7(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_12_8                                      0x181AB3FC
#define  SRNN_wdsr_layer2_1x1_weights_12_8_reg_addr                              "0xB81AB3FC"
#define  SRNN_wdsr_layer2_1x1_weights_12_8_reg                                   0xB81AB3FC
#define  SRNN_wdsr_layer2_1x1_weights_12_8_inst_addr                             "0x0123"
#define  set_SRNN_wdsr_layer2_1x1_weights_12_8_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_12_8_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_12_8_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_12_8_reg))
#define  SRNN_wdsr_layer2_1x1_weights_12_8_layer2_weight_8_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_12_8_layer2_weight_8_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_12_8_layer2_weight_8(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_12_8_get_layer2_weight_8(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_13_1                                      0x181AB400
#define  SRNN_wdsr_layer2_1x1_weights_13_1_reg_addr                              "0xB81AB400"
#define  SRNN_wdsr_layer2_1x1_weights_13_1_reg                                   0xB81AB400
#define  SRNN_wdsr_layer2_1x1_weights_13_1_inst_addr                             "0x0124"
#define  set_SRNN_wdsr_layer2_1x1_weights_13_1_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_13_1_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_13_1_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_13_1_reg))
#define  SRNN_wdsr_layer2_1x1_weights_13_1_layer2_weight_1_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_13_1_layer2_weight_1_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_13_1_layer2_weight_1(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_13_1_get_layer2_weight_1(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_13_2                                      0x181AB404
#define  SRNN_wdsr_layer2_1x1_weights_13_2_reg_addr                              "0xB81AB404"
#define  SRNN_wdsr_layer2_1x1_weights_13_2_reg                                   0xB81AB404
#define  SRNN_wdsr_layer2_1x1_weights_13_2_inst_addr                             "0x0125"
#define  set_SRNN_wdsr_layer2_1x1_weights_13_2_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_13_2_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_13_2_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_13_2_reg))
#define  SRNN_wdsr_layer2_1x1_weights_13_2_layer2_weight_2_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_13_2_layer2_weight_2_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_13_2_layer2_weight_2(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_13_2_get_layer2_weight_2(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_13_3                                      0x181AB408
#define  SRNN_wdsr_layer2_1x1_weights_13_3_reg_addr                              "0xB81AB408"
#define  SRNN_wdsr_layer2_1x1_weights_13_3_reg                                   0xB81AB408
#define  SRNN_wdsr_layer2_1x1_weights_13_3_inst_addr                             "0x0126"
#define  set_SRNN_wdsr_layer2_1x1_weights_13_3_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_13_3_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_13_3_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_13_3_reg))
#define  SRNN_wdsr_layer2_1x1_weights_13_3_layer2_weight_3_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_13_3_layer2_weight_3_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_13_3_layer2_weight_3(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_13_3_get_layer2_weight_3(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_13_4                                      0x181AB40C
#define  SRNN_wdsr_layer2_1x1_weights_13_4_reg_addr                              "0xB81AB40C"
#define  SRNN_wdsr_layer2_1x1_weights_13_4_reg                                   0xB81AB40C
#define  SRNN_wdsr_layer2_1x1_weights_13_4_inst_addr                             "0x0127"
#define  set_SRNN_wdsr_layer2_1x1_weights_13_4_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_13_4_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_13_4_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_13_4_reg))
#define  SRNN_wdsr_layer2_1x1_weights_13_4_layer2_weight_4_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_13_4_layer2_weight_4_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_13_4_layer2_weight_4(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_13_4_get_layer2_weight_4(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_13_5                                      0x181AB410
#define  SRNN_wdsr_layer2_1x1_weights_13_5_reg_addr                              "0xB81AB410"
#define  SRNN_wdsr_layer2_1x1_weights_13_5_reg                                   0xB81AB410
#define  SRNN_wdsr_layer2_1x1_weights_13_5_inst_addr                             "0x0128"
#define  set_SRNN_wdsr_layer2_1x1_weights_13_5_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_13_5_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_13_5_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_13_5_reg))
#define  SRNN_wdsr_layer2_1x1_weights_13_5_layer2_weight_5_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_13_5_layer2_weight_5_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_13_5_layer2_weight_5(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_13_5_get_layer2_weight_5(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_13_6                                      0x181AB414
#define  SRNN_wdsr_layer2_1x1_weights_13_6_reg_addr                              "0xB81AB414"
#define  SRNN_wdsr_layer2_1x1_weights_13_6_reg                                   0xB81AB414
#define  SRNN_wdsr_layer2_1x1_weights_13_6_inst_addr                             "0x0129"
#define  set_SRNN_wdsr_layer2_1x1_weights_13_6_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_13_6_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_13_6_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_13_6_reg))
#define  SRNN_wdsr_layer2_1x1_weights_13_6_layer2_weight_6_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_13_6_layer2_weight_6_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_13_6_layer2_weight_6(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_13_6_get_layer2_weight_6(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_13_7                                      0x181AB418
#define  SRNN_wdsr_layer2_1x1_weights_13_7_reg_addr                              "0xB81AB418"
#define  SRNN_wdsr_layer2_1x1_weights_13_7_reg                                   0xB81AB418
#define  SRNN_wdsr_layer2_1x1_weights_13_7_inst_addr                             "0x012A"
#define  set_SRNN_wdsr_layer2_1x1_weights_13_7_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_13_7_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_13_7_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_13_7_reg))
#define  SRNN_wdsr_layer2_1x1_weights_13_7_layer2_weight_7_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_13_7_layer2_weight_7_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_13_7_layer2_weight_7(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_13_7_get_layer2_weight_7(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_13_8                                      0x181AB41C
#define  SRNN_wdsr_layer2_1x1_weights_13_8_reg_addr                              "0xB81AB41C"
#define  SRNN_wdsr_layer2_1x1_weights_13_8_reg                                   0xB81AB41C
#define  SRNN_wdsr_layer2_1x1_weights_13_8_inst_addr                             "0x012B"
#define  set_SRNN_wdsr_layer2_1x1_weights_13_8_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_13_8_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_13_8_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_13_8_reg))
#define  SRNN_wdsr_layer2_1x1_weights_13_8_layer2_weight_8_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_13_8_layer2_weight_8_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_13_8_layer2_weight_8(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_13_8_get_layer2_weight_8(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_14_1                                      0x181AB420
#define  SRNN_wdsr_layer2_1x1_weights_14_1_reg_addr                              "0xB81AB420"
#define  SRNN_wdsr_layer2_1x1_weights_14_1_reg                                   0xB81AB420
#define  SRNN_wdsr_layer2_1x1_weights_14_1_inst_addr                             "0x012C"
#define  set_SRNN_wdsr_layer2_1x1_weights_14_1_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_14_1_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_14_1_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_14_1_reg))
#define  SRNN_wdsr_layer2_1x1_weights_14_1_layer2_weight_1_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_14_1_layer2_weight_1_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_14_1_layer2_weight_1(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_14_1_get_layer2_weight_1(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_14_2                                      0x181AB424
#define  SRNN_wdsr_layer2_1x1_weights_14_2_reg_addr                              "0xB81AB424"
#define  SRNN_wdsr_layer2_1x1_weights_14_2_reg                                   0xB81AB424
#define  SRNN_wdsr_layer2_1x1_weights_14_2_inst_addr                             "0x012D"
#define  set_SRNN_wdsr_layer2_1x1_weights_14_2_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_14_2_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_14_2_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_14_2_reg))
#define  SRNN_wdsr_layer2_1x1_weights_14_2_layer2_weight_2_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_14_2_layer2_weight_2_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_14_2_layer2_weight_2(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_14_2_get_layer2_weight_2(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_14_3                                      0x181AB428
#define  SRNN_wdsr_layer2_1x1_weights_14_3_reg_addr                              "0xB81AB428"
#define  SRNN_wdsr_layer2_1x1_weights_14_3_reg                                   0xB81AB428
#define  SRNN_wdsr_layer2_1x1_weights_14_3_inst_addr                             "0x012E"
#define  set_SRNN_wdsr_layer2_1x1_weights_14_3_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_14_3_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_14_3_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_14_3_reg))
#define  SRNN_wdsr_layer2_1x1_weights_14_3_layer2_weight_3_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_14_3_layer2_weight_3_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_14_3_layer2_weight_3(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_14_3_get_layer2_weight_3(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_14_4                                      0x181AB42C
#define  SRNN_wdsr_layer2_1x1_weights_14_4_reg_addr                              "0xB81AB42C"
#define  SRNN_wdsr_layer2_1x1_weights_14_4_reg                                   0xB81AB42C
#define  SRNN_wdsr_layer2_1x1_weights_14_4_inst_addr                             "0x012F"
#define  set_SRNN_wdsr_layer2_1x1_weights_14_4_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_14_4_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_14_4_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_14_4_reg))
#define  SRNN_wdsr_layer2_1x1_weights_14_4_layer2_weight_4_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_14_4_layer2_weight_4_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_14_4_layer2_weight_4(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_14_4_get_layer2_weight_4(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_14_5                                      0x181AB430
#define  SRNN_wdsr_layer2_1x1_weights_14_5_reg_addr                              "0xB81AB430"
#define  SRNN_wdsr_layer2_1x1_weights_14_5_reg                                   0xB81AB430
#define  SRNN_wdsr_layer2_1x1_weights_14_5_inst_addr                             "0x0130"
#define  set_SRNN_wdsr_layer2_1x1_weights_14_5_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_14_5_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_14_5_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_14_5_reg))
#define  SRNN_wdsr_layer2_1x1_weights_14_5_layer2_weight_5_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_14_5_layer2_weight_5_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_14_5_layer2_weight_5(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_14_5_get_layer2_weight_5(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_14_6                                      0x181AB434
#define  SRNN_wdsr_layer2_1x1_weights_14_6_reg_addr                              "0xB81AB434"
#define  SRNN_wdsr_layer2_1x1_weights_14_6_reg                                   0xB81AB434
#define  SRNN_wdsr_layer2_1x1_weights_14_6_inst_addr                             "0x0131"
#define  set_SRNN_wdsr_layer2_1x1_weights_14_6_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_14_6_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_14_6_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_14_6_reg))
#define  SRNN_wdsr_layer2_1x1_weights_14_6_layer2_weight_6_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_14_6_layer2_weight_6_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_14_6_layer2_weight_6(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_14_6_get_layer2_weight_6(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_14_7                                      0x181AB438
#define  SRNN_wdsr_layer2_1x1_weights_14_7_reg_addr                              "0xB81AB438"
#define  SRNN_wdsr_layer2_1x1_weights_14_7_reg                                   0xB81AB438
#define  SRNN_wdsr_layer2_1x1_weights_14_7_inst_addr                             "0x0132"
#define  set_SRNN_wdsr_layer2_1x1_weights_14_7_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_14_7_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_14_7_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_14_7_reg))
#define  SRNN_wdsr_layer2_1x1_weights_14_7_layer2_weight_7_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_14_7_layer2_weight_7_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_14_7_layer2_weight_7(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_14_7_get_layer2_weight_7(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_14_8                                      0x181AB43C
#define  SRNN_wdsr_layer2_1x1_weights_14_8_reg_addr                              "0xB81AB43C"
#define  SRNN_wdsr_layer2_1x1_weights_14_8_reg                                   0xB81AB43C
#define  SRNN_wdsr_layer2_1x1_weights_14_8_inst_addr                             "0x0133"
#define  set_SRNN_wdsr_layer2_1x1_weights_14_8_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_14_8_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_14_8_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_14_8_reg))
#define  SRNN_wdsr_layer2_1x1_weights_14_8_layer2_weight_8_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_14_8_layer2_weight_8_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_14_8_layer2_weight_8(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_14_8_get_layer2_weight_8(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_15_1                                      0x181AB440
#define  SRNN_wdsr_layer2_1x1_weights_15_1_reg_addr                              "0xB81AB440"
#define  SRNN_wdsr_layer2_1x1_weights_15_1_reg                                   0xB81AB440
#define  SRNN_wdsr_layer2_1x1_weights_15_1_inst_addr                             "0x0134"
#define  set_SRNN_wdsr_layer2_1x1_weights_15_1_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_15_1_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_15_1_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_15_1_reg))
#define  SRNN_wdsr_layer2_1x1_weights_15_1_layer2_weight_1_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_15_1_layer2_weight_1_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_15_1_layer2_weight_1(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_15_1_get_layer2_weight_1(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_15_2                                      0x181AB444
#define  SRNN_wdsr_layer2_1x1_weights_15_2_reg_addr                              "0xB81AB444"
#define  SRNN_wdsr_layer2_1x1_weights_15_2_reg                                   0xB81AB444
#define  SRNN_wdsr_layer2_1x1_weights_15_2_inst_addr                             "0x0135"
#define  set_SRNN_wdsr_layer2_1x1_weights_15_2_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_15_2_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_15_2_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_15_2_reg))
#define  SRNN_wdsr_layer2_1x1_weights_15_2_layer2_weight_2_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_15_2_layer2_weight_2_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_15_2_layer2_weight_2(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_15_2_get_layer2_weight_2(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_15_3                                      0x181AB448
#define  SRNN_wdsr_layer2_1x1_weights_15_3_reg_addr                              "0xB81AB448"
#define  SRNN_wdsr_layer2_1x1_weights_15_3_reg                                   0xB81AB448
#define  SRNN_wdsr_layer2_1x1_weights_15_3_inst_addr                             "0x0136"
#define  set_SRNN_wdsr_layer2_1x1_weights_15_3_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_15_3_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_15_3_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_15_3_reg))
#define  SRNN_wdsr_layer2_1x1_weights_15_3_layer2_weight_3_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_15_3_layer2_weight_3_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_15_3_layer2_weight_3(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_15_3_get_layer2_weight_3(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_15_4                                      0x181AB44C
#define  SRNN_wdsr_layer2_1x1_weights_15_4_reg_addr                              "0xB81AB44C"
#define  SRNN_wdsr_layer2_1x1_weights_15_4_reg                                   0xB81AB44C
#define  SRNN_wdsr_layer2_1x1_weights_15_4_inst_addr                             "0x0137"
#define  set_SRNN_wdsr_layer2_1x1_weights_15_4_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_15_4_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_15_4_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_15_4_reg))
#define  SRNN_wdsr_layer2_1x1_weights_15_4_layer2_weight_4_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_15_4_layer2_weight_4_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_15_4_layer2_weight_4(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_15_4_get_layer2_weight_4(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_15_5                                      0x181AB450
#define  SRNN_wdsr_layer2_1x1_weights_15_5_reg_addr                              "0xB81AB450"
#define  SRNN_wdsr_layer2_1x1_weights_15_5_reg                                   0xB81AB450
#define  SRNN_wdsr_layer2_1x1_weights_15_5_inst_addr                             "0x0138"
#define  set_SRNN_wdsr_layer2_1x1_weights_15_5_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_15_5_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_15_5_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_15_5_reg))
#define  SRNN_wdsr_layer2_1x1_weights_15_5_layer2_weight_5_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_15_5_layer2_weight_5_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_15_5_layer2_weight_5(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_15_5_get_layer2_weight_5(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_15_6                                      0x181AB454
#define  SRNN_wdsr_layer2_1x1_weights_15_6_reg_addr                              "0xB81AB454"
#define  SRNN_wdsr_layer2_1x1_weights_15_6_reg                                   0xB81AB454
#define  SRNN_wdsr_layer2_1x1_weights_15_6_inst_addr                             "0x0139"
#define  set_SRNN_wdsr_layer2_1x1_weights_15_6_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_15_6_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_15_6_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_15_6_reg))
#define  SRNN_wdsr_layer2_1x1_weights_15_6_layer2_weight_6_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_15_6_layer2_weight_6_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_15_6_layer2_weight_6(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_15_6_get_layer2_weight_6(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_15_7                                      0x181AB458
#define  SRNN_wdsr_layer2_1x1_weights_15_7_reg_addr                              "0xB81AB458"
#define  SRNN_wdsr_layer2_1x1_weights_15_7_reg                                   0xB81AB458
#define  SRNN_wdsr_layer2_1x1_weights_15_7_inst_addr                             "0x013A"
#define  set_SRNN_wdsr_layer2_1x1_weights_15_7_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_15_7_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_15_7_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_15_7_reg))
#define  SRNN_wdsr_layer2_1x1_weights_15_7_layer2_weight_7_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_15_7_layer2_weight_7_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_15_7_layer2_weight_7(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_15_7_get_layer2_weight_7(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_15_8                                      0x181AB45C
#define  SRNN_wdsr_layer2_1x1_weights_15_8_reg_addr                              "0xB81AB45C"
#define  SRNN_wdsr_layer2_1x1_weights_15_8_reg                                   0xB81AB45C
#define  SRNN_wdsr_layer2_1x1_weights_15_8_inst_addr                             "0x013B"
#define  set_SRNN_wdsr_layer2_1x1_weights_15_8_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_15_8_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_15_8_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_15_8_reg))
#define  SRNN_wdsr_layer2_1x1_weights_15_8_layer2_weight_8_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_15_8_layer2_weight_8_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_15_8_layer2_weight_8(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_15_8_get_layer2_weight_8(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_16_1                                      0x181AB460
#define  SRNN_wdsr_layer2_1x1_weights_16_1_reg_addr                              "0xB81AB460"
#define  SRNN_wdsr_layer2_1x1_weights_16_1_reg                                   0xB81AB460
#define  SRNN_wdsr_layer2_1x1_weights_16_1_inst_addr                             "0x013C"
#define  set_SRNN_wdsr_layer2_1x1_weights_16_1_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_16_1_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_16_1_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_16_1_reg))
#define  SRNN_wdsr_layer2_1x1_weights_16_1_layer2_weight_1_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_16_1_layer2_weight_1_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_16_1_layer2_weight_1(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_16_1_get_layer2_weight_1(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_16_2                                      0x181AB464
#define  SRNN_wdsr_layer2_1x1_weights_16_2_reg_addr                              "0xB81AB464"
#define  SRNN_wdsr_layer2_1x1_weights_16_2_reg                                   0xB81AB464
#define  SRNN_wdsr_layer2_1x1_weights_16_2_inst_addr                             "0x013D"
#define  set_SRNN_wdsr_layer2_1x1_weights_16_2_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_16_2_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_16_2_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_16_2_reg))
#define  SRNN_wdsr_layer2_1x1_weights_16_2_layer2_weight_2_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_16_2_layer2_weight_2_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_16_2_layer2_weight_2(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_16_2_get_layer2_weight_2(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_16_3                                      0x181AB468
#define  SRNN_wdsr_layer2_1x1_weights_16_3_reg_addr                              "0xB81AB468"
#define  SRNN_wdsr_layer2_1x1_weights_16_3_reg                                   0xB81AB468
#define  SRNN_wdsr_layer2_1x1_weights_16_3_inst_addr                             "0x013E"
#define  set_SRNN_wdsr_layer2_1x1_weights_16_3_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_16_3_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_16_3_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_16_3_reg))
#define  SRNN_wdsr_layer2_1x1_weights_16_3_layer2_weight_3_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_16_3_layer2_weight_3_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_16_3_layer2_weight_3(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_16_3_get_layer2_weight_3(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_16_4                                      0x181AB46C
#define  SRNN_wdsr_layer2_1x1_weights_16_4_reg_addr                              "0xB81AB46C"
#define  SRNN_wdsr_layer2_1x1_weights_16_4_reg                                   0xB81AB46C
#define  SRNN_wdsr_layer2_1x1_weights_16_4_inst_addr                             "0x013F"
#define  set_SRNN_wdsr_layer2_1x1_weights_16_4_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_16_4_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_16_4_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_16_4_reg))
#define  SRNN_wdsr_layer2_1x1_weights_16_4_layer2_weight_4_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_16_4_layer2_weight_4_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_16_4_layer2_weight_4(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_16_4_get_layer2_weight_4(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_16_5                                      0x181AB470
#define  SRNN_wdsr_layer2_1x1_weights_16_5_reg_addr                              "0xB81AB470"
#define  SRNN_wdsr_layer2_1x1_weights_16_5_reg                                   0xB81AB470
#define  SRNN_wdsr_layer2_1x1_weights_16_5_inst_addr                             "0x0140"
#define  set_SRNN_wdsr_layer2_1x1_weights_16_5_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_16_5_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_16_5_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_16_5_reg))
#define  SRNN_wdsr_layer2_1x1_weights_16_5_layer2_weight_5_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_16_5_layer2_weight_5_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_16_5_layer2_weight_5(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_16_5_get_layer2_weight_5(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_16_6                                      0x181AB474
#define  SRNN_wdsr_layer2_1x1_weights_16_6_reg_addr                              "0xB81AB474"
#define  SRNN_wdsr_layer2_1x1_weights_16_6_reg                                   0xB81AB474
#define  SRNN_wdsr_layer2_1x1_weights_16_6_inst_addr                             "0x0141"
#define  set_SRNN_wdsr_layer2_1x1_weights_16_6_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_16_6_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_16_6_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_16_6_reg))
#define  SRNN_wdsr_layer2_1x1_weights_16_6_layer2_weight_6_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_16_6_layer2_weight_6_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_16_6_layer2_weight_6(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_16_6_get_layer2_weight_6(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_16_7                                      0x181AB478
#define  SRNN_wdsr_layer2_1x1_weights_16_7_reg_addr                              "0xB81AB478"
#define  SRNN_wdsr_layer2_1x1_weights_16_7_reg                                   0xB81AB478
#define  SRNN_wdsr_layer2_1x1_weights_16_7_inst_addr                             "0x0142"
#define  set_SRNN_wdsr_layer2_1x1_weights_16_7_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_16_7_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_16_7_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_16_7_reg))
#define  SRNN_wdsr_layer2_1x1_weights_16_7_layer2_weight_7_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_16_7_layer2_weight_7_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_16_7_layer2_weight_7(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_16_7_get_layer2_weight_7(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_16_8                                      0x181AB47C
#define  SRNN_wdsr_layer2_1x1_weights_16_8_reg_addr                              "0xB81AB47C"
#define  SRNN_wdsr_layer2_1x1_weights_16_8_reg                                   0xB81AB47C
#define  SRNN_wdsr_layer2_1x1_weights_16_8_inst_addr                             "0x0143"
#define  set_SRNN_wdsr_layer2_1x1_weights_16_8_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_16_8_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_16_8_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_16_8_reg))
#define  SRNN_wdsr_layer2_1x1_weights_16_8_layer2_weight_8_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_16_8_layer2_weight_8_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_16_8_layer2_weight_8(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_16_8_get_layer2_weight_8(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_17_1                                      0x181AB480
#define  SRNN_wdsr_layer2_1x1_weights_17_1_reg_addr                              "0xB81AB480"
#define  SRNN_wdsr_layer2_1x1_weights_17_1_reg                                   0xB81AB480
#define  SRNN_wdsr_layer2_1x1_weights_17_1_inst_addr                             "0x0144"
#define  set_SRNN_wdsr_layer2_1x1_weights_17_1_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_17_1_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_17_1_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_17_1_reg))
#define  SRNN_wdsr_layer2_1x1_weights_17_1_layer2_weight_1_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_17_1_layer2_weight_1_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_17_1_layer2_weight_1(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_17_1_get_layer2_weight_1(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_17_2                                      0x181AB484
#define  SRNN_wdsr_layer2_1x1_weights_17_2_reg_addr                              "0xB81AB484"
#define  SRNN_wdsr_layer2_1x1_weights_17_2_reg                                   0xB81AB484
#define  SRNN_wdsr_layer2_1x1_weights_17_2_inst_addr                             "0x0145"
#define  set_SRNN_wdsr_layer2_1x1_weights_17_2_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_17_2_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_17_2_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_17_2_reg))
#define  SRNN_wdsr_layer2_1x1_weights_17_2_layer2_weight_2_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_17_2_layer2_weight_2_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_17_2_layer2_weight_2(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_17_2_get_layer2_weight_2(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_17_3                                      0x181AB488
#define  SRNN_wdsr_layer2_1x1_weights_17_3_reg_addr                              "0xB81AB488"
#define  SRNN_wdsr_layer2_1x1_weights_17_3_reg                                   0xB81AB488
#define  SRNN_wdsr_layer2_1x1_weights_17_3_inst_addr                             "0x0146"
#define  set_SRNN_wdsr_layer2_1x1_weights_17_3_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_17_3_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_17_3_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_17_3_reg))
#define  SRNN_wdsr_layer2_1x1_weights_17_3_layer2_weight_3_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_17_3_layer2_weight_3_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_17_3_layer2_weight_3(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_17_3_get_layer2_weight_3(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_17_4                                      0x181AB48C
#define  SRNN_wdsr_layer2_1x1_weights_17_4_reg_addr                              "0xB81AB48C"
#define  SRNN_wdsr_layer2_1x1_weights_17_4_reg                                   0xB81AB48C
#define  SRNN_wdsr_layer2_1x1_weights_17_4_inst_addr                             "0x0147"
#define  set_SRNN_wdsr_layer2_1x1_weights_17_4_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_17_4_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_17_4_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_17_4_reg))
#define  SRNN_wdsr_layer2_1x1_weights_17_4_layer2_weight_4_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_17_4_layer2_weight_4_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_17_4_layer2_weight_4(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_17_4_get_layer2_weight_4(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_17_5                                      0x181AB490
#define  SRNN_wdsr_layer2_1x1_weights_17_5_reg_addr                              "0xB81AB490"
#define  SRNN_wdsr_layer2_1x1_weights_17_5_reg                                   0xB81AB490
#define  SRNN_wdsr_layer2_1x1_weights_17_5_inst_addr                             "0x0148"
#define  set_SRNN_wdsr_layer2_1x1_weights_17_5_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_17_5_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_17_5_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_17_5_reg))
#define  SRNN_wdsr_layer2_1x1_weights_17_5_layer2_weight_5_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_17_5_layer2_weight_5_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_17_5_layer2_weight_5(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_17_5_get_layer2_weight_5(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_17_6                                      0x181AB494
#define  SRNN_wdsr_layer2_1x1_weights_17_6_reg_addr                              "0xB81AB494"
#define  SRNN_wdsr_layer2_1x1_weights_17_6_reg                                   0xB81AB494
#define  SRNN_wdsr_layer2_1x1_weights_17_6_inst_addr                             "0x0149"
#define  set_SRNN_wdsr_layer2_1x1_weights_17_6_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_17_6_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_17_6_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_17_6_reg))
#define  SRNN_wdsr_layer2_1x1_weights_17_6_layer2_weight_6_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_17_6_layer2_weight_6_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_17_6_layer2_weight_6(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_17_6_get_layer2_weight_6(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_17_7                                      0x181AB498
#define  SRNN_wdsr_layer2_1x1_weights_17_7_reg_addr                              "0xB81AB498"
#define  SRNN_wdsr_layer2_1x1_weights_17_7_reg                                   0xB81AB498
#define  SRNN_wdsr_layer2_1x1_weights_17_7_inst_addr                             "0x014A"
#define  set_SRNN_wdsr_layer2_1x1_weights_17_7_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_17_7_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_17_7_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_17_7_reg))
#define  SRNN_wdsr_layer2_1x1_weights_17_7_layer2_weight_7_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_17_7_layer2_weight_7_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_17_7_layer2_weight_7(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_17_7_get_layer2_weight_7(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_17_8                                      0x181AB49C
#define  SRNN_wdsr_layer2_1x1_weights_17_8_reg_addr                              "0xB81AB49C"
#define  SRNN_wdsr_layer2_1x1_weights_17_8_reg                                   0xB81AB49C
#define  SRNN_wdsr_layer2_1x1_weights_17_8_inst_addr                             "0x014B"
#define  set_SRNN_wdsr_layer2_1x1_weights_17_8_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_17_8_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_17_8_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_17_8_reg))
#define  SRNN_wdsr_layer2_1x1_weights_17_8_layer2_weight_8_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_17_8_layer2_weight_8_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_17_8_layer2_weight_8(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_17_8_get_layer2_weight_8(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_18_1                                      0x181AB4A0
#define  SRNN_wdsr_layer2_1x1_weights_18_1_reg_addr                              "0xB81AB4A0"
#define  SRNN_wdsr_layer2_1x1_weights_18_1_reg                                   0xB81AB4A0
#define  SRNN_wdsr_layer2_1x1_weights_18_1_inst_addr                             "0x014C"
#define  set_SRNN_wdsr_layer2_1x1_weights_18_1_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_18_1_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_18_1_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_18_1_reg))
#define  SRNN_wdsr_layer2_1x1_weights_18_1_layer2_weight_1_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_18_1_layer2_weight_1_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_18_1_layer2_weight_1(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_18_1_get_layer2_weight_1(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_18_2                                      0x181AB4A4
#define  SRNN_wdsr_layer2_1x1_weights_18_2_reg_addr                              "0xB81AB4A4"
#define  SRNN_wdsr_layer2_1x1_weights_18_2_reg                                   0xB81AB4A4
#define  SRNN_wdsr_layer2_1x1_weights_18_2_inst_addr                             "0x014D"
#define  set_SRNN_wdsr_layer2_1x1_weights_18_2_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_18_2_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_18_2_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_18_2_reg))
#define  SRNN_wdsr_layer2_1x1_weights_18_2_layer2_weight_2_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_18_2_layer2_weight_2_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_18_2_layer2_weight_2(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_18_2_get_layer2_weight_2(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_18_3                                      0x181AB4A8
#define  SRNN_wdsr_layer2_1x1_weights_18_3_reg_addr                              "0xB81AB4A8"
#define  SRNN_wdsr_layer2_1x1_weights_18_3_reg                                   0xB81AB4A8
#define  SRNN_wdsr_layer2_1x1_weights_18_3_inst_addr                             "0x014E"
#define  set_SRNN_wdsr_layer2_1x1_weights_18_3_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_18_3_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_18_3_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_18_3_reg))
#define  SRNN_wdsr_layer2_1x1_weights_18_3_layer2_weight_3_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_18_3_layer2_weight_3_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_18_3_layer2_weight_3(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_18_3_get_layer2_weight_3(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_18_4                                      0x181AB4AC
#define  SRNN_wdsr_layer2_1x1_weights_18_4_reg_addr                              "0xB81AB4AC"
#define  SRNN_wdsr_layer2_1x1_weights_18_4_reg                                   0xB81AB4AC
#define  SRNN_wdsr_layer2_1x1_weights_18_4_inst_addr                             "0x014F"
#define  set_SRNN_wdsr_layer2_1x1_weights_18_4_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_18_4_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_18_4_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_18_4_reg))
#define  SRNN_wdsr_layer2_1x1_weights_18_4_layer2_weight_4_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_18_4_layer2_weight_4_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_18_4_layer2_weight_4(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_18_4_get_layer2_weight_4(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_18_5                                      0x181AB4B0
#define  SRNN_wdsr_layer2_1x1_weights_18_5_reg_addr                              "0xB81AB4B0"
#define  SRNN_wdsr_layer2_1x1_weights_18_5_reg                                   0xB81AB4B0
#define  SRNN_wdsr_layer2_1x1_weights_18_5_inst_addr                             "0x0150"
#define  set_SRNN_wdsr_layer2_1x1_weights_18_5_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_18_5_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_18_5_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_18_5_reg))
#define  SRNN_wdsr_layer2_1x1_weights_18_5_layer2_weight_5_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_18_5_layer2_weight_5_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_18_5_layer2_weight_5(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_18_5_get_layer2_weight_5(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_18_6                                      0x181AB4B4
#define  SRNN_wdsr_layer2_1x1_weights_18_6_reg_addr                              "0xB81AB4B4"
#define  SRNN_wdsr_layer2_1x1_weights_18_6_reg                                   0xB81AB4B4
#define  SRNN_wdsr_layer2_1x1_weights_18_6_inst_addr                             "0x0151"
#define  set_SRNN_wdsr_layer2_1x1_weights_18_6_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_18_6_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_18_6_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_18_6_reg))
#define  SRNN_wdsr_layer2_1x1_weights_18_6_layer2_weight_6_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_18_6_layer2_weight_6_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_18_6_layer2_weight_6(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_18_6_get_layer2_weight_6(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_18_7                                      0x181AB4B8
#define  SRNN_wdsr_layer2_1x1_weights_18_7_reg_addr                              "0xB81AB4B8"
#define  SRNN_wdsr_layer2_1x1_weights_18_7_reg                                   0xB81AB4B8
#define  SRNN_wdsr_layer2_1x1_weights_18_7_inst_addr                             "0x0152"
#define  set_SRNN_wdsr_layer2_1x1_weights_18_7_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_18_7_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_18_7_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_18_7_reg))
#define  SRNN_wdsr_layer2_1x1_weights_18_7_layer2_weight_7_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_18_7_layer2_weight_7_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_18_7_layer2_weight_7(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_18_7_get_layer2_weight_7(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_18_8                                      0x181AB4BC
#define  SRNN_wdsr_layer2_1x1_weights_18_8_reg_addr                              "0xB81AB4BC"
#define  SRNN_wdsr_layer2_1x1_weights_18_8_reg                                   0xB81AB4BC
#define  SRNN_wdsr_layer2_1x1_weights_18_8_inst_addr                             "0x0153"
#define  set_SRNN_wdsr_layer2_1x1_weights_18_8_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_18_8_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_18_8_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_18_8_reg))
#define  SRNN_wdsr_layer2_1x1_weights_18_8_layer2_weight_8_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_18_8_layer2_weight_8_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_18_8_layer2_weight_8(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_18_8_get_layer2_weight_8(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_19_1                                      0x181AB4C0
#define  SRNN_wdsr_layer2_1x1_weights_19_1_reg_addr                              "0xB81AB4C0"
#define  SRNN_wdsr_layer2_1x1_weights_19_1_reg                                   0xB81AB4C0
#define  SRNN_wdsr_layer2_1x1_weights_19_1_inst_addr                             "0x0154"
#define  set_SRNN_wdsr_layer2_1x1_weights_19_1_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_19_1_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_19_1_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_19_1_reg))
#define  SRNN_wdsr_layer2_1x1_weights_19_1_layer2_weight_1_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_19_1_layer2_weight_1_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_19_1_layer2_weight_1(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_19_1_get_layer2_weight_1(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_19_2                                      0x181AB4C4
#define  SRNN_wdsr_layer2_1x1_weights_19_2_reg_addr                              "0xB81AB4C4"
#define  SRNN_wdsr_layer2_1x1_weights_19_2_reg                                   0xB81AB4C4
#define  SRNN_wdsr_layer2_1x1_weights_19_2_inst_addr                             "0x0155"
#define  set_SRNN_wdsr_layer2_1x1_weights_19_2_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_19_2_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_19_2_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_19_2_reg))
#define  SRNN_wdsr_layer2_1x1_weights_19_2_layer2_weight_2_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_19_2_layer2_weight_2_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_19_2_layer2_weight_2(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_19_2_get_layer2_weight_2(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_19_3                                      0x181AB4C8
#define  SRNN_wdsr_layer2_1x1_weights_19_3_reg_addr                              "0xB81AB4C8"
#define  SRNN_wdsr_layer2_1x1_weights_19_3_reg                                   0xB81AB4C8
#define  SRNN_wdsr_layer2_1x1_weights_19_3_inst_addr                             "0x0156"
#define  set_SRNN_wdsr_layer2_1x1_weights_19_3_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_19_3_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_19_3_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_19_3_reg))
#define  SRNN_wdsr_layer2_1x1_weights_19_3_layer2_weight_3_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_19_3_layer2_weight_3_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_19_3_layer2_weight_3(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_19_3_get_layer2_weight_3(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_19_4                                      0x181AB4CC
#define  SRNN_wdsr_layer2_1x1_weights_19_4_reg_addr                              "0xB81AB4CC"
#define  SRNN_wdsr_layer2_1x1_weights_19_4_reg                                   0xB81AB4CC
#define  SRNN_wdsr_layer2_1x1_weights_19_4_inst_addr                             "0x0157"
#define  set_SRNN_wdsr_layer2_1x1_weights_19_4_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_19_4_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_19_4_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_19_4_reg))
#define  SRNN_wdsr_layer2_1x1_weights_19_4_layer2_weight_4_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_19_4_layer2_weight_4_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_19_4_layer2_weight_4(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_19_4_get_layer2_weight_4(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_19_5                                      0x181AB4D0
#define  SRNN_wdsr_layer2_1x1_weights_19_5_reg_addr                              "0xB81AB4D0"
#define  SRNN_wdsr_layer2_1x1_weights_19_5_reg                                   0xB81AB4D0
#define  SRNN_wdsr_layer2_1x1_weights_19_5_inst_addr                             "0x0158"
#define  set_SRNN_wdsr_layer2_1x1_weights_19_5_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_19_5_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_19_5_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_19_5_reg))
#define  SRNN_wdsr_layer2_1x1_weights_19_5_layer2_weight_5_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_19_5_layer2_weight_5_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_19_5_layer2_weight_5(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_19_5_get_layer2_weight_5(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_19_6                                      0x181AB4D4
#define  SRNN_wdsr_layer2_1x1_weights_19_6_reg_addr                              "0xB81AB4D4"
#define  SRNN_wdsr_layer2_1x1_weights_19_6_reg                                   0xB81AB4D4
#define  SRNN_wdsr_layer2_1x1_weights_19_6_inst_addr                             "0x0159"
#define  set_SRNN_wdsr_layer2_1x1_weights_19_6_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_19_6_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_19_6_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_19_6_reg))
#define  SRNN_wdsr_layer2_1x1_weights_19_6_layer2_weight_6_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_19_6_layer2_weight_6_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_19_6_layer2_weight_6(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_19_6_get_layer2_weight_6(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_19_7                                      0x181AB4D8
#define  SRNN_wdsr_layer2_1x1_weights_19_7_reg_addr                              "0xB81AB4D8"
#define  SRNN_wdsr_layer2_1x1_weights_19_7_reg                                   0xB81AB4D8
#define  SRNN_wdsr_layer2_1x1_weights_19_7_inst_addr                             "0x015A"
#define  set_SRNN_wdsr_layer2_1x1_weights_19_7_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_19_7_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_19_7_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_19_7_reg))
#define  SRNN_wdsr_layer2_1x1_weights_19_7_layer2_weight_7_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_19_7_layer2_weight_7_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_19_7_layer2_weight_7(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_19_7_get_layer2_weight_7(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_19_8                                      0x181AB4DC
#define  SRNN_wdsr_layer2_1x1_weights_19_8_reg_addr                              "0xB81AB4DC"
#define  SRNN_wdsr_layer2_1x1_weights_19_8_reg                                   0xB81AB4DC
#define  SRNN_wdsr_layer2_1x1_weights_19_8_inst_addr                             "0x015B"
#define  set_SRNN_wdsr_layer2_1x1_weights_19_8_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_19_8_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_19_8_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_19_8_reg))
#define  SRNN_wdsr_layer2_1x1_weights_19_8_layer2_weight_8_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_19_8_layer2_weight_8_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_19_8_layer2_weight_8(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_19_8_get_layer2_weight_8(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_20_1                                      0x181AB4E0
#define  SRNN_wdsr_layer2_1x1_weights_20_1_reg_addr                              "0xB81AB4E0"
#define  SRNN_wdsr_layer2_1x1_weights_20_1_reg                                   0xB81AB4E0
#define  SRNN_wdsr_layer2_1x1_weights_20_1_inst_addr                             "0x015C"
#define  set_SRNN_wdsr_layer2_1x1_weights_20_1_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_20_1_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_20_1_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_20_1_reg))
#define  SRNN_wdsr_layer2_1x1_weights_20_1_layer2_weight_1_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_20_1_layer2_weight_1_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_20_1_layer2_weight_1(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_20_1_get_layer2_weight_1(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_20_2                                      0x181AB4E4
#define  SRNN_wdsr_layer2_1x1_weights_20_2_reg_addr                              "0xB81AB4E4"
#define  SRNN_wdsr_layer2_1x1_weights_20_2_reg                                   0xB81AB4E4
#define  SRNN_wdsr_layer2_1x1_weights_20_2_inst_addr                             "0x015D"
#define  set_SRNN_wdsr_layer2_1x1_weights_20_2_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_20_2_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_20_2_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_20_2_reg))
#define  SRNN_wdsr_layer2_1x1_weights_20_2_layer2_weight_2_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_20_2_layer2_weight_2_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_20_2_layer2_weight_2(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_20_2_get_layer2_weight_2(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_20_3                                      0x181AB4E8
#define  SRNN_wdsr_layer2_1x1_weights_20_3_reg_addr                              "0xB81AB4E8"
#define  SRNN_wdsr_layer2_1x1_weights_20_3_reg                                   0xB81AB4E8
#define  SRNN_wdsr_layer2_1x1_weights_20_3_inst_addr                             "0x015E"
#define  set_SRNN_wdsr_layer2_1x1_weights_20_3_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_20_3_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_20_3_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_20_3_reg))
#define  SRNN_wdsr_layer2_1x1_weights_20_3_layer2_weight_3_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_20_3_layer2_weight_3_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_20_3_layer2_weight_3(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_20_3_get_layer2_weight_3(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_20_4                                      0x181AB4EC
#define  SRNN_wdsr_layer2_1x1_weights_20_4_reg_addr                              "0xB81AB4EC"
#define  SRNN_wdsr_layer2_1x1_weights_20_4_reg                                   0xB81AB4EC
#define  SRNN_wdsr_layer2_1x1_weights_20_4_inst_addr                             "0x015F"
#define  set_SRNN_wdsr_layer2_1x1_weights_20_4_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_20_4_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_20_4_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_20_4_reg))
#define  SRNN_wdsr_layer2_1x1_weights_20_4_layer2_weight_4_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_20_4_layer2_weight_4_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_20_4_layer2_weight_4(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_20_4_get_layer2_weight_4(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_20_5                                      0x181AB4F0
#define  SRNN_wdsr_layer2_1x1_weights_20_5_reg_addr                              "0xB81AB4F0"
#define  SRNN_wdsr_layer2_1x1_weights_20_5_reg                                   0xB81AB4F0
#define  SRNN_wdsr_layer2_1x1_weights_20_5_inst_addr                             "0x0160"
#define  set_SRNN_wdsr_layer2_1x1_weights_20_5_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_20_5_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_20_5_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_20_5_reg))
#define  SRNN_wdsr_layer2_1x1_weights_20_5_layer2_weight_5_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_20_5_layer2_weight_5_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_20_5_layer2_weight_5(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_20_5_get_layer2_weight_5(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_20_6                                      0x181AB4F4
#define  SRNN_wdsr_layer2_1x1_weights_20_6_reg_addr                              "0xB81AB4F4"
#define  SRNN_wdsr_layer2_1x1_weights_20_6_reg                                   0xB81AB4F4
#define  SRNN_wdsr_layer2_1x1_weights_20_6_inst_addr                             "0x0161"
#define  set_SRNN_wdsr_layer2_1x1_weights_20_6_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_20_6_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_20_6_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_20_6_reg))
#define  SRNN_wdsr_layer2_1x1_weights_20_6_layer2_weight_6_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_20_6_layer2_weight_6_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_20_6_layer2_weight_6(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_20_6_get_layer2_weight_6(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_20_7                                      0x181AB4F8
#define  SRNN_wdsr_layer2_1x1_weights_20_7_reg_addr                              "0xB81AB4F8"
#define  SRNN_wdsr_layer2_1x1_weights_20_7_reg                                   0xB81AB4F8
#define  SRNN_wdsr_layer2_1x1_weights_20_7_inst_addr                             "0x0162"
#define  set_SRNN_wdsr_layer2_1x1_weights_20_7_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_20_7_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_20_7_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_20_7_reg))
#define  SRNN_wdsr_layer2_1x1_weights_20_7_layer2_weight_7_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_20_7_layer2_weight_7_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_20_7_layer2_weight_7(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_20_7_get_layer2_weight_7(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_20_8                                      0x181AB4FC
#define  SRNN_wdsr_layer2_1x1_weights_20_8_reg_addr                              "0xB81AB4FC"
#define  SRNN_wdsr_layer2_1x1_weights_20_8_reg                                   0xB81AB4FC
#define  SRNN_wdsr_layer2_1x1_weights_20_8_inst_addr                             "0x0163"
#define  set_SRNN_wdsr_layer2_1x1_weights_20_8_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_20_8_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_20_8_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_20_8_reg))
#define  SRNN_wdsr_layer2_1x1_weights_20_8_layer2_weight_8_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_20_8_layer2_weight_8_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_20_8_layer2_weight_8(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_20_8_get_layer2_weight_8(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_21_1                                      0x181AB500
#define  SRNN_wdsr_layer2_1x1_weights_21_1_reg_addr                              "0xB81AB500"
#define  SRNN_wdsr_layer2_1x1_weights_21_1_reg                                   0xB81AB500
#define  SRNN_wdsr_layer2_1x1_weights_21_1_inst_addr                             "0x0164"
#define  set_SRNN_wdsr_layer2_1x1_weights_21_1_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_21_1_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_21_1_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_21_1_reg))
#define  SRNN_wdsr_layer2_1x1_weights_21_1_layer2_weight_1_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_21_1_layer2_weight_1_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_21_1_layer2_weight_1(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_21_1_get_layer2_weight_1(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_21_2                                      0x181AB504
#define  SRNN_wdsr_layer2_1x1_weights_21_2_reg_addr                              "0xB81AB504"
#define  SRNN_wdsr_layer2_1x1_weights_21_2_reg                                   0xB81AB504
#define  SRNN_wdsr_layer2_1x1_weights_21_2_inst_addr                             "0x0165"
#define  set_SRNN_wdsr_layer2_1x1_weights_21_2_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_21_2_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_21_2_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_21_2_reg))
#define  SRNN_wdsr_layer2_1x1_weights_21_2_layer2_weight_2_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_21_2_layer2_weight_2_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_21_2_layer2_weight_2(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_21_2_get_layer2_weight_2(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_21_3                                      0x181AB508
#define  SRNN_wdsr_layer2_1x1_weights_21_3_reg_addr                              "0xB81AB508"
#define  SRNN_wdsr_layer2_1x1_weights_21_3_reg                                   0xB81AB508
#define  SRNN_wdsr_layer2_1x1_weights_21_3_inst_addr                             "0x0166"
#define  set_SRNN_wdsr_layer2_1x1_weights_21_3_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_21_3_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_21_3_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_21_3_reg))
#define  SRNN_wdsr_layer2_1x1_weights_21_3_layer2_weight_3_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_21_3_layer2_weight_3_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_21_3_layer2_weight_3(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_21_3_get_layer2_weight_3(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_21_4                                      0x181AB50C
#define  SRNN_wdsr_layer2_1x1_weights_21_4_reg_addr                              "0xB81AB50C"
#define  SRNN_wdsr_layer2_1x1_weights_21_4_reg                                   0xB81AB50C
#define  SRNN_wdsr_layer2_1x1_weights_21_4_inst_addr                             "0x0167"
#define  set_SRNN_wdsr_layer2_1x1_weights_21_4_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_21_4_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_21_4_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_21_4_reg))
#define  SRNN_wdsr_layer2_1x1_weights_21_4_layer2_weight_4_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_21_4_layer2_weight_4_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_21_4_layer2_weight_4(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_21_4_get_layer2_weight_4(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_21_5                                      0x181AB510
#define  SRNN_wdsr_layer2_1x1_weights_21_5_reg_addr                              "0xB81AB510"
#define  SRNN_wdsr_layer2_1x1_weights_21_5_reg                                   0xB81AB510
#define  SRNN_wdsr_layer2_1x1_weights_21_5_inst_addr                             "0x0168"
#define  set_SRNN_wdsr_layer2_1x1_weights_21_5_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_21_5_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_21_5_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_21_5_reg))
#define  SRNN_wdsr_layer2_1x1_weights_21_5_layer2_weight_5_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_21_5_layer2_weight_5_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_21_5_layer2_weight_5(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_21_5_get_layer2_weight_5(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_21_6                                      0x181AB514
#define  SRNN_wdsr_layer2_1x1_weights_21_6_reg_addr                              "0xB81AB514"
#define  SRNN_wdsr_layer2_1x1_weights_21_6_reg                                   0xB81AB514
#define  SRNN_wdsr_layer2_1x1_weights_21_6_inst_addr                             "0x0169"
#define  set_SRNN_wdsr_layer2_1x1_weights_21_6_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_21_6_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_21_6_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_21_6_reg))
#define  SRNN_wdsr_layer2_1x1_weights_21_6_layer2_weight_6_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_21_6_layer2_weight_6_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_21_6_layer2_weight_6(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_21_6_get_layer2_weight_6(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_21_7                                      0x181AB518
#define  SRNN_wdsr_layer2_1x1_weights_21_7_reg_addr                              "0xB81AB518"
#define  SRNN_wdsr_layer2_1x1_weights_21_7_reg                                   0xB81AB518
#define  SRNN_wdsr_layer2_1x1_weights_21_7_inst_addr                             "0x016A"
#define  set_SRNN_wdsr_layer2_1x1_weights_21_7_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_21_7_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_21_7_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_21_7_reg))
#define  SRNN_wdsr_layer2_1x1_weights_21_7_layer2_weight_7_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_21_7_layer2_weight_7_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_21_7_layer2_weight_7(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_21_7_get_layer2_weight_7(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_21_8                                      0x181AB51C
#define  SRNN_wdsr_layer2_1x1_weights_21_8_reg_addr                              "0xB81AB51C"
#define  SRNN_wdsr_layer2_1x1_weights_21_8_reg                                   0xB81AB51C
#define  SRNN_wdsr_layer2_1x1_weights_21_8_inst_addr                             "0x016B"
#define  set_SRNN_wdsr_layer2_1x1_weights_21_8_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_21_8_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_21_8_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_21_8_reg))
#define  SRNN_wdsr_layer2_1x1_weights_21_8_layer2_weight_8_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_21_8_layer2_weight_8_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_21_8_layer2_weight_8(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_21_8_get_layer2_weight_8(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_22_1                                      0x181AB520
#define  SRNN_wdsr_layer2_1x1_weights_22_1_reg_addr                              "0xB81AB520"
#define  SRNN_wdsr_layer2_1x1_weights_22_1_reg                                   0xB81AB520
#define  SRNN_wdsr_layer2_1x1_weights_22_1_inst_addr                             "0x016C"
#define  set_SRNN_wdsr_layer2_1x1_weights_22_1_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_22_1_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_22_1_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_22_1_reg))
#define  SRNN_wdsr_layer2_1x1_weights_22_1_layer2_weight_1_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_22_1_layer2_weight_1_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_22_1_layer2_weight_1(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_22_1_get_layer2_weight_1(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_22_2                                      0x181AB524
#define  SRNN_wdsr_layer2_1x1_weights_22_2_reg_addr                              "0xB81AB524"
#define  SRNN_wdsr_layer2_1x1_weights_22_2_reg                                   0xB81AB524
#define  SRNN_wdsr_layer2_1x1_weights_22_2_inst_addr                             "0x016D"
#define  set_SRNN_wdsr_layer2_1x1_weights_22_2_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_22_2_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_22_2_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_22_2_reg))
#define  SRNN_wdsr_layer2_1x1_weights_22_2_layer2_weight_2_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_22_2_layer2_weight_2_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_22_2_layer2_weight_2(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_22_2_get_layer2_weight_2(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_22_3                                      0x181AB528
#define  SRNN_wdsr_layer2_1x1_weights_22_3_reg_addr                              "0xB81AB528"
#define  SRNN_wdsr_layer2_1x1_weights_22_3_reg                                   0xB81AB528
#define  SRNN_wdsr_layer2_1x1_weights_22_3_inst_addr                             "0x016E"
#define  set_SRNN_wdsr_layer2_1x1_weights_22_3_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_22_3_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_22_3_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_22_3_reg))
#define  SRNN_wdsr_layer2_1x1_weights_22_3_layer2_weight_3_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_22_3_layer2_weight_3_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_22_3_layer2_weight_3(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_22_3_get_layer2_weight_3(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_22_4                                      0x181AB52C
#define  SRNN_wdsr_layer2_1x1_weights_22_4_reg_addr                              "0xB81AB52C"
#define  SRNN_wdsr_layer2_1x1_weights_22_4_reg                                   0xB81AB52C
#define  SRNN_wdsr_layer2_1x1_weights_22_4_inst_addr                             "0x016F"
#define  set_SRNN_wdsr_layer2_1x1_weights_22_4_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_22_4_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_22_4_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_22_4_reg))
#define  SRNN_wdsr_layer2_1x1_weights_22_4_layer2_weight_4_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_22_4_layer2_weight_4_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_22_4_layer2_weight_4(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_22_4_get_layer2_weight_4(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_22_5                                      0x181AB530
#define  SRNN_wdsr_layer2_1x1_weights_22_5_reg_addr                              "0xB81AB530"
#define  SRNN_wdsr_layer2_1x1_weights_22_5_reg                                   0xB81AB530
#define  SRNN_wdsr_layer2_1x1_weights_22_5_inst_addr                             "0x0170"
#define  set_SRNN_wdsr_layer2_1x1_weights_22_5_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_22_5_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_22_5_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_22_5_reg))
#define  SRNN_wdsr_layer2_1x1_weights_22_5_layer2_weight_5_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_22_5_layer2_weight_5_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_22_5_layer2_weight_5(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_22_5_get_layer2_weight_5(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_22_6                                      0x181AB534
#define  SRNN_wdsr_layer2_1x1_weights_22_6_reg_addr                              "0xB81AB534"
#define  SRNN_wdsr_layer2_1x1_weights_22_6_reg                                   0xB81AB534
#define  SRNN_wdsr_layer2_1x1_weights_22_6_inst_addr                             "0x0171"
#define  set_SRNN_wdsr_layer2_1x1_weights_22_6_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_22_6_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_22_6_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_22_6_reg))
#define  SRNN_wdsr_layer2_1x1_weights_22_6_layer2_weight_6_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_22_6_layer2_weight_6_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_22_6_layer2_weight_6(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_22_6_get_layer2_weight_6(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_22_7                                      0x181AB538
#define  SRNN_wdsr_layer2_1x1_weights_22_7_reg_addr                              "0xB81AB538"
#define  SRNN_wdsr_layer2_1x1_weights_22_7_reg                                   0xB81AB538
#define  SRNN_wdsr_layer2_1x1_weights_22_7_inst_addr                             "0x0172"
#define  set_SRNN_wdsr_layer2_1x1_weights_22_7_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_22_7_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_22_7_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_22_7_reg))
#define  SRNN_wdsr_layer2_1x1_weights_22_7_layer2_weight_7_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_22_7_layer2_weight_7_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_22_7_layer2_weight_7(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_22_7_get_layer2_weight_7(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_22_8                                      0x181AB53C
#define  SRNN_wdsr_layer2_1x1_weights_22_8_reg_addr                              "0xB81AB53C"
#define  SRNN_wdsr_layer2_1x1_weights_22_8_reg                                   0xB81AB53C
#define  SRNN_wdsr_layer2_1x1_weights_22_8_inst_addr                             "0x0173"
#define  set_SRNN_wdsr_layer2_1x1_weights_22_8_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_22_8_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_22_8_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_22_8_reg))
#define  SRNN_wdsr_layer2_1x1_weights_22_8_layer2_weight_8_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_22_8_layer2_weight_8_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_22_8_layer2_weight_8(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_22_8_get_layer2_weight_8(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_23_1                                      0x181AB540
#define  SRNN_wdsr_layer2_1x1_weights_23_1_reg_addr                              "0xB81AB540"
#define  SRNN_wdsr_layer2_1x1_weights_23_1_reg                                   0xB81AB540
#define  SRNN_wdsr_layer2_1x1_weights_23_1_inst_addr                             "0x0174"
#define  set_SRNN_wdsr_layer2_1x1_weights_23_1_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_23_1_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_23_1_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_23_1_reg))
#define  SRNN_wdsr_layer2_1x1_weights_23_1_layer2_weight_1_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_23_1_layer2_weight_1_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_23_1_layer2_weight_1(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_23_1_get_layer2_weight_1(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_23_2                                      0x181AB544
#define  SRNN_wdsr_layer2_1x1_weights_23_2_reg_addr                              "0xB81AB544"
#define  SRNN_wdsr_layer2_1x1_weights_23_2_reg                                   0xB81AB544
#define  SRNN_wdsr_layer2_1x1_weights_23_2_inst_addr                             "0x0175"
#define  set_SRNN_wdsr_layer2_1x1_weights_23_2_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_23_2_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_23_2_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_23_2_reg))
#define  SRNN_wdsr_layer2_1x1_weights_23_2_layer2_weight_2_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_23_2_layer2_weight_2_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_23_2_layer2_weight_2(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_23_2_get_layer2_weight_2(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_23_3                                      0x181AB548
#define  SRNN_wdsr_layer2_1x1_weights_23_3_reg_addr                              "0xB81AB548"
#define  SRNN_wdsr_layer2_1x1_weights_23_3_reg                                   0xB81AB548
#define  SRNN_wdsr_layer2_1x1_weights_23_3_inst_addr                             "0x0176"
#define  set_SRNN_wdsr_layer2_1x1_weights_23_3_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_23_3_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_23_3_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_23_3_reg))
#define  SRNN_wdsr_layer2_1x1_weights_23_3_layer2_weight_3_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_23_3_layer2_weight_3_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_23_3_layer2_weight_3(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_23_3_get_layer2_weight_3(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_23_4                                      0x181AB54C
#define  SRNN_wdsr_layer2_1x1_weights_23_4_reg_addr                              "0xB81AB54C"
#define  SRNN_wdsr_layer2_1x1_weights_23_4_reg                                   0xB81AB54C
#define  SRNN_wdsr_layer2_1x1_weights_23_4_inst_addr                             "0x0177"
#define  set_SRNN_wdsr_layer2_1x1_weights_23_4_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_23_4_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_23_4_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_23_4_reg))
#define  SRNN_wdsr_layer2_1x1_weights_23_4_layer2_weight_4_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_23_4_layer2_weight_4_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_23_4_layer2_weight_4(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_23_4_get_layer2_weight_4(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_23_5                                      0x181AB550
#define  SRNN_wdsr_layer2_1x1_weights_23_5_reg_addr                              "0xB81AB550"
#define  SRNN_wdsr_layer2_1x1_weights_23_5_reg                                   0xB81AB550
#define  SRNN_wdsr_layer2_1x1_weights_23_5_inst_addr                             "0x0178"
#define  set_SRNN_wdsr_layer2_1x1_weights_23_5_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_23_5_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_23_5_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_23_5_reg))
#define  SRNN_wdsr_layer2_1x1_weights_23_5_layer2_weight_5_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_23_5_layer2_weight_5_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_23_5_layer2_weight_5(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_23_5_get_layer2_weight_5(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_23_6                                      0x181AB554
#define  SRNN_wdsr_layer2_1x1_weights_23_6_reg_addr                              "0xB81AB554"
#define  SRNN_wdsr_layer2_1x1_weights_23_6_reg                                   0xB81AB554
#define  SRNN_wdsr_layer2_1x1_weights_23_6_inst_addr                             "0x0179"
#define  set_SRNN_wdsr_layer2_1x1_weights_23_6_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_23_6_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_23_6_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_23_6_reg))
#define  SRNN_wdsr_layer2_1x1_weights_23_6_layer2_weight_6_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_23_6_layer2_weight_6_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_23_6_layer2_weight_6(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_23_6_get_layer2_weight_6(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_23_7                                      0x181AB558
#define  SRNN_wdsr_layer2_1x1_weights_23_7_reg_addr                              "0xB81AB558"
#define  SRNN_wdsr_layer2_1x1_weights_23_7_reg                                   0xB81AB558
#define  SRNN_wdsr_layer2_1x1_weights_23_7_inst_addr                             "0x017A"
#define  set_SRNN_wdsr_layer2_1x1_weights_23_7_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_23_7_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_23_7_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_23_7_reg))
#define  SRNN_wdsr_layer2_1x1_weights_23_7_layer2_weight_7_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_23_7_layer2_weight_7_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_23_7_layer2_weight_7(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_23_7_get_layer2_weight_7(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_23_8                                      0x181AB55C
#define  SRNN_wdsr_layer2_1x1_weights_23_8_reg_addr                              "0xB81AB55C"
#define  SRNN_wdsr_layer2_1x1_weights_23_8_reg                                   0xB81AB55C
#define  SRNN_wdsr_layer2_1x1_weights_23_8_inst_addr                             "0x017B"
#define  set_SRNN_wdsr_layer2_1x1_weights_23_8_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_23_8_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_23_8_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_23_8_reg))
#define  SRNN_wdsr_layer2_1x1_weights_23_8_layer2_weight_8_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_23_8_layer2_weight_8_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_23_8_layer2_weight_8(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_23_8_get_layer2_weight_8(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_24_1                                      0x181AB560
#define  SRNN_wdsr_layer2_1x1_weights_24_1_reg_addr                              "0xB81AB560"
#define  SRNN_wdsr_layer2_1x1_weights_24_1_reg                                   0xB81AB560
#define  SRNN_wdsr_layer2_1x1_weights_24_1_inst_addr                             "0x017C"
#define  set_SRNN_wdsr_layer2_1x1_weights_24_1_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_24_1_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_24_1_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_24_1_reg))
#define  SRNN_wdsr_layer2_1x1_weights_24_1_layer2_weight_1_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_24_1_layer2_weight_1_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_24_1_layer2_weight_1(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_24_1_get_layer2_weight_1(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_24_2                                      0x181AB564
#define  SRNN_wdsr_layer2_1x1_weights_24_2_reg_addr                              "0xB81AB564"
#define  SRNN_wdsr_layer2_1x1_weights_24_2_reg                                   0xB81AB564
#define  SRNN_wdsr_layer2_1x1_weights_24_2_inst_addr                             "0x017D"
#define  set_SRNN_wdsr_layer2_1x1_weights_24_2_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_24_2_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_24_2_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_24_2_reg))
#define  SRNN_wdsr_layer2_1x1_weights_24_2_layer2_weight_2_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_24_2_layer2_weight_2_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_24_2_layer2_weight_2(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_24_2_get_layer2_weight_2(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_24_3                                      0x181AB568
#define  SRNN_wdsr_layer2_1x1_weights_24_3_reg_addr                              "0xB81AB568"
#define  SRNN_wdsr_layer2_1x1_weights_24_3_reg                                   0xB81AB568
#define  SRNN_wdsr_layer2_1x1_weights_24_3_inst_addr                             "0x017E"
#define  set_SRNN_wdsr_layer2_1x1_weights_24_3_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_24_3_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_24_3_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_24_3_reg))
#define  SRNN_wdsr_layer2_1x1_weights_24_3_layer2_weight_3_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_24_3_layer2_weight_3_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_24_3_layer2_weight_3(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_24_3_get_layer2_weight_3(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_24_4                                      0x181AB56C
#define  SRNN_wdsr_layer2_1x1_weights_24_4_reg_addr                              "0xB81AB56C"
#define  SRNN_wdsr_layer2_1x1_weights_24_4_reg                                   0xB81AB56C
#define  SRNN_wdsr_layer2_1x1_weights_24_4_inst_addr                             "0x017F"
#define  set_SRNN_wdsr_layer2_1x1_weights_24_4_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_24_4_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_24_4_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_24_4_reg))
#define  SRNN_wdsr_layer2_1x1_weights_24_4_layer2_weight_4_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_24_4_layer2_weight_4_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_24_4_layer2_weight_4(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_24_4_get_layer2_weight_4(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_24_5                                      0x181AB570
#define  SRNN_wdsr_layer2_1x1_weights_24_5_reg_addr                              "0xB81AB570"
#define  SRNN_wdsr_layer2_1x1_weights_24_5_reg                                   0xB81AB570
#define  SRNN_wdsr_layer2_1x1_weights_24_5_inst_addr                             "0x0180"
#define  set_SRNN_wdsr_layer2_1x1_weights_24_5_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_24_5_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_24_5_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_24_5_reg))
#define  SRNN_wdsr_layer2_1x1_weights_24_5_layer2_weight_5_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_24_5_layer2_weight_5_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_24_5_layer2_weight_5(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_24_5_get_layer2_weight_5(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_24_6                                      0x181AB574
#define  SRNN_wdsr_layer2_1x1_weights_24_6_reg_addr                              "0xB81AB574"
#define  SRNN_wdsr_layer2_1x1_weights_24_6_reg                                   0xB81AB574
#define  SRNN_wdsr_layer2_1x1_weights_24_6_inst_addr                             "0x0181"
#define  set_SRNN_wdsr_layer2_1x1_weights_24_6_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_24_6_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_24_6_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_24_6_reg))
#define  SRNN_wdsr_layer2_1x1_weights_24_6_layer2_weight_6_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_24_6_layer2_weight_6_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_24_6_layer2_weight_6(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_24_6_get_layer2_weight_6(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_24_7                                      0x181AB578
#define  SRNN_wdsr_layer2_1x1_weights_24_7_reg_addr                              "0xB81AB578"
#define  SRNN_wdsr_layer2_1x1_weights_24_7_reg                                   0xB81AB578
#define  SRNN_wdsr_layer2_1x1_weights_24_7_inst_addr                             "0x0182"
#define  set_SRNN_wdsr_layer2_1x1_weights_24_7_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_24_7_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_24_7_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_24_7_reg))
#define  SRNN_wdsr_layer2_1x1_weights_24_7_layer2_weight_7_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_24_7_layer2_weight_7_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_24_7_layer2_weight_7(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_24_7_get_layer2_weight_7(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_24_8                                      0x181AB57C
#define  SRNN_wdsr_layer2_1x1_weights_24_8_reg_addr                              "0xB81AB57C"
#define  SRNN_wdsr_layer2_1x1_weights_24_8_reg                                   0xB81AB57C
#define  SRNN_wdsr_layer2_1x1_weights_24_8_inst_addr                             "0x0183"
#define  set_SRNN_wdsr_layer2_1x1_weights_24_8_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_24_8_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_24_8_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_24_8_reg))
#define  SRNN_wdsr_layer2_1x1_weights_24_8_layer2_weight_8_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_24_8_layer2_weight_8_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_24_8_layer2_weight_8(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_24_8_get_layer2_weight_8(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_25_1                                      0x181AB580
#define  SRNN_wdsr_layer2_1x1_weights_25_1_reg_addr                              "0xB81AB580"
#define  SRNN_wdsr_layer2_1x1_weights_25_1_reg                                   0xB81AB580
#define  SRNN_wdsr_layer2_1x1_weights_25_1_inst_addr                             "0x0184"
#define  set_SRNN_wdsr_layer2_1x1_weights_25_1_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_25_1_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_25_1_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_25_1_reg))
#define  SRNN_wdsr_layer2_1x1_weights_25_1_layer2_weight_1_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_25_1_layer2_weight_1_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_25_1_layer2_weight_1(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_25_1_get_layer2_weight_1(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_25_2                                      0x181AB584
#define  SRNN_wdsr_layer2_1x1_weights_25_2_reg_addr                              "0xB81AB584"
#define  SRNN_wdsr_layer2_1x1_weights_25_2_reg                                   0xB81AB584
#define  SRNN_wdsr_layer2_1x1_weights_25_2_inst_addr                             "0x0185"
#define  set_SRNN_wdsr_layer2_1x1_weights_25_2_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_25_2_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_25_2_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_25_2_reg))
#define  SRNN_wdsr_layer2_1x1_weights_25_2_layer2_weight_2_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_25_2_layer2_weight_2_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_25_2_layer2_weight_2(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_25_2_get_layer2_weight_2(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_25_3                                      0x181AB588
#define  SRNN_wdsr_layer2_1x1_weights_25_3_reg_addr                              "0xB81AB588"
#define  SRNN_wdsr_layer2_1x1_weights_25_3_reg                                   0xB81AB588
#define  SRNN_wdsr_layer2_1x1_weights_25_3_inst_addr                             "0x0186"
#define  set_SRNN_wdsr_layer2_1x1_weights_25_3_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_25_3_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_25_3_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_25_3_reg))
#define  SRNN_wdsr_layer2_1x1_weights_25_3_layer2_weight_3_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_25_3_layer2_weight_3_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_25_3_layer2_weight_3(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_25_3_get_layer2_weight_3(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_25_4                                      0x181AB58C
#define  SRNN_wdsr_layer2_1x1_weights_25_4_reg_addr                              "0xB81AB58C"
#define  SRNN_wdsr_layer2_1x1_weights_25_4_reg                                   0xB81AB58C
#define  SRNN_wdsr_layer2_1x1_weights_25_4_inst_addr                             "0x0187"
#define  set_SRNN_wdsr_layer2_1x1_weights_25_4_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_25_4_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_25_4_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_25_4_reg))
#define  SRNN_wdsr_layer2_1x1_weights_25_4_layer2_weight_4_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_25_4_layer2_weight_4_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_25_4_layer2_weight_4(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_25_4_get_layer2_weight_4(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_25_5                                      0x181AB590
#define  SRNN_wdsr_layer2_1x1_weights_25_5_reg_addr                              "0xB81AB590"
#define  SRNN_wdsr_layer2_1x1_weights_25_5_reg                                   0xB81AB590
#define  SRNN_wdsr_layer2_1x1_weights_25_5_inst_addr                             "0x0188"
#define  set_SRNN_wdsr_layer2_1x1_weights_25_5_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_25_5_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_25_5_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_25_5_reg))
#define  SRNN_wdsr_layer2_1x1_weights_25_5_layer2_weight_5_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_25_5_layer2_weight_5_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_25_5_layer2_weight_5(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_25_5_get_layer2_weight_5(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_25_6                                      0x181AB594
#define  SRNN_wdsr_layer2_1x1_weights_25_6_reg_addr                              "0xB81AB594"
#define  SRNN_wdsr_layer2_1x1_weights_25_6_reg                                   0xB81AB594
#define  SRNN_wdsr_layer2_1x1_weights_25_6_inst_addr                             "0x0189"
#define  set_SRNN_wdsr_layer2_1x1_weights_25_6_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_25_6_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_25_6_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_25_6_reg))
#define  SRNN_wdsr_layer2_1x1_weights_25_6_layer2_weight_6_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_25_6_layer2_weight_6_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_25_6_layer2_weight_6(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_25_6_get_layer2_weight_6(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_25_7                                      0x181AB598
#define  SRNN_wdsr_layer2_1x1_weights_25_7_reg_addr                              "0xB81AB598"
#define  SRNN_wdsr_layer2_1x1_weights_25_7_reg                                   0xB81AB598
#define  SRNN_wdsr_layer2_1x1_weights_25_7_inst_addr                             "0x018A"
#define  set_SRNN_wdsr_layer2_1x1_weights_25_7_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_25_7_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_25_7_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_25_7_reg))
#define  SRNN_wdsr_layer2_1x1_weights_25_7_layer2_weight_7_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_25_7_layer2_weight_7_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_25_7_layer2_weight_7(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_25_7_get_layer2_weight_7(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_25_8                                      0x181AB59C
#define  SRNN_wdsr_layer2_1x1_weights_25_8_reg_addr                              "0xB81AB59C"
#define  SRNN_wdsr_layer2_1x1_weights_25_8_reg                                   0xB81AB59C
#define  SRNN_wdsr_layer2_1x1_weights_25_8_inst_addr                             "0x018B"
#define  set_SRNN_wdsr_layer2_1x1_weights_25_8_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_25_8_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_25_8_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_25_8_reg))
#define  SRNN_wdsr_layer2_1x1_weights_25_8_layer2_weight_8_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_25_8_layer2_weight_8_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_25_8_layer2_weight_8(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_25_8_get_layer2_weight_8(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_26_1                                      0x181AB5A0
#define  SRNN_wdsr_layer2_1x1_weights_26_1_reg_addr                              "0xB81AB5A0"
#define  SRNN_wdsr_layer2_1x1_weights_26_1_reg                                   0xB81AB5A0
#define  SRNN_wdsr_layer2_1x1_weights_26_1_inst_addr                             "0x018C"
#define  set_SRNN_wdsr_layer2_1x1_weights_26_1_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_26_1_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_26_1_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_26_1_reg))
#define  SRNN_wdsr_layer2_1x1_weights_26_1_layer2_weight_1_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_26_1_layer2_weight_1_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_26_1_layer2_weight_1(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_26_1_get_layer2_weight_1(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_26_2                                      0x181AB5A4
#define  SRNN_wdsr_layer2_1x1_weights_26_2_reg_addr                              "0xB81AB5A4"
#define  SRNN_wdsr_layer2_1x1_weights_26_2_reg                                   0xB81AB5A4
#define  SRNN_wdsr_layer2_1x1_weights_26_2_inst_addr                             "0x018D"
#define  set_SRNN_wdsr_layer2_1x1_weights_26_2_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_26_2_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_26_2_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_26_2_reg))
#define  SRNN_wdsr_layer2_1x1_weights_26_2_layer2_weight_2_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_26_2_layer2_weight_2_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_26_2_layer2_weight_2(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_26_2_get_layer2_weight_2(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_26_3                                      0x181AB5A8
#define  SRNN_wdsr_layer2_1x1_weights_26_3_reg_addr                              "0xB81AB5A8"
#define  SRNN_wdsr_layer2_1x1_weights_26_3_reg                                   0xB81AB5A8
#define  SRNN_wdsr_layer2_1x1_weights_26_3_inst_addr                             "0x018E"
#define  set_SRNN_wdsr_layer2_1x1_weights_26_3_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_26_3_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_26_3_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_26_3_reg))
#define  SRNN_wdsr_layer2_1x1_weights_26_3_layer2_weight_3_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_26_3_layer2_weight_3_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_26_3_layer2_weight_3(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_26_3_get_layer2_weight_3(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_26_4                                      0x181AB5AC
#define  SRNN_wdsr_layer2_1x1_weights_26_4_reg_addr                              "0xB81AB5AC"
#define  SRNN_wdsr_layer2_1x1_weights_26_4_reg                                   0xB81AB5AC
#define  SRNN_wdsr_layer2_1x1_weights_26_4_inst_addr                             "0x018F"
#define  set_SRNN_wdsr_layer2_1x1_weights_26_4_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_26_4_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_26_4_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_26_4_reg))
#define  SRNN_wdsr_layer2_1x1_weights_26_4_layer2_weight_4_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_26_4_layer2_weight_4_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_26_4_layer2_weight_4(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_26_4_get_layer2_weight_4(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_26_5                                      0x181AB5B0
#define  SRNN_wdsr_layer2_1x1_weights_26_5_reg_addr                              "0xB81AB5B0"
#define  SRNN_wdsr_layer2_1x1_weights_26_5_reg                                   0xB81AB5B0
#define  SRNN_wdsr_layer2_1x1_weights_26_5_inst_addr                             "0x0190"
#define  set_SRNN_wdsr_layer2_1x1_weights_26_5_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_26_5_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_26_5_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_26_5_reg))
#define  SRNN_wdsr_layer2_1x1_weights_26_5_layer2_weight_5_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_26_5_layer2_weight_5_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_26_5_layer2_weight_5(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_26_5_get_layer2_weight_5(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_26_6                                      0x181AB5B4
#define  SRNN_wdsr_layer2_1x1_weights_26_6_reg_addr                              "0xB81AB5B4"
#define  SRNN_wdsr_layer2_1x1_weights_26_6_reg                                   0xB81AB5B4
#define  SRNN_wdsr_layer2_1x1_weights_26_6_inst_addr                             "0x0191"
#define  set_SRNN_wdsr_layer2_1x1_weights_26_6_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_26_6_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_26_6_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_26_6_reg))
#define  SRNN_wdsr_layer2_1x1_weights_26_6_layer2_weight_6_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_26_6_layer2_weight_6_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_26_6_layer2_weight_6(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_26_6_get_layer2_weight_6(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_26_7                                      0x181AB5B8
#define  SRNN_wdsr_layer2_1x1_weights_26_7_reg_addr                              "0xB81AB5B8"
#define  SRNN_wdsr_layer2_1x1_weights_26_7_reg                                   0xB81AB5B8
#define  SRNN_wdsr_layer2_1x1_weights_26_7_inst_addr                             "0x0192"
#define  set_SRNN_wdsr_layer2_1x1_weights_26_7_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_26_7_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_26_7_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_26_7_reg))
#define  SRNN_wdsr_layer2_1x1_weights_26_7_layer2_weight_7_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_26_7_layer2_weight_7_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_26_7_layer2_weight_7(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_26_7_get_layer2_weight_7(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_26_8                                      0x181AB5BC
#define  SRNN_wdsr_layer2_1x1_weights_26_8_reg_addr                              "0xB81AB5BC"
#define  SRNN_wdsr_layer2_1x1_weights_26_8_reg                                   0xB81AB5BC
#define  SRNN_wdsr_layer2_1x1_weights_26_8_inst_addr                             "0x0193"
#define  set_SRNN_wdsr_layer2_1x1_weights_26_8_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_26_8_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_26_8_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_26_8_reg))
#define  SRNN_wdsr_layer2_1x1_weights_26_8_layer2_weight_8_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_26_8_layer2_weight_8_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_26_8_layer2_weight_8(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_26_8_get_layer2_weight_8(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_27_1                                      0x181AB5C0
#define  SRNN_wdsr_layer2_1x1_weights_27_1_reg_addr                              "0xB81AB5C0"
#define  SRNN_wdsr_layer2_1x1_weights_27_1_reg                                   0xB81AB5C0
#define  SRNN_wdsr_layer2_1x1_weights_27_1_inst_addr                             "0x0194"
#define  set_SRNN_wdsr_layer2_1x1_weights_27_1_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_27_1_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_27_1_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_27_1_reg))
#define  SRNN_wdsr_layer2_1x1_weights_27_1_layer2_weight_1_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_27_1_layer2_weight_1_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_27_1_layer2_weight_1(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_27_1_get_layer2_weight_1(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_27_2                                      0x181AB5C4
#define  SRNN_wdsr_layer2_1x1_weights_27_2_reg_addr                              "0xB81AB5C4"
#define  SRNN_wdsr_layer2_1x1_weights_27_2_reg                                   0xB81AB5C4
#define  SRNN_wdsr_layer2_1x1_weights_27_2_inst_addr                             "0x0195"
#define  set_SRNN_wdsr_layer2_1x1_weights_27_2_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_27_2_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_27_2_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_27_2_reg))
#define  SRNN_wdsr_layer2_1x1_weights_27_2_layer2_weight_2_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_27_2_layer2_weight_2_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_27_2_layer2_weight_2(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_27_2_get_layer2_weight_2(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_27_3                                      0x181AB5C8
#define  SRNN_wdsr_layer2_1x1_weights_27_3_reg_addr                              "0xB81AB5C8"
#define  SRNN_wdsr_layer2_1x1_weights_27_3_reg                                   0xB81AB5C8
#define  SRNN_wdsr_layer2_1x1_weights_27_3_inst_addr                             "0x0196"
#define  set_SRNN_wdsr_layer2_1x1_weights_27_3_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_27_3_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_27_3_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_27_3_reg))
#define  SRNN_wdsr_layer2_1x1_weights_27_3_layer2_weight_3_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_27_3_layer2_weight_3_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_27_3_layer2_weight_3(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_27_3_get_layer2_weight_3(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_27_4                                      0x181AB5CC
#define  SRNN_wdsr_layer2_1x1_weights_27_4_reg_addr                              "0xB81AB5CC"
#define  SRNN_wdsr_layer2_1x1_weights_27_4_reg                                   0xB81AB5CC
#define  SRNN_wdsr_layer2_1x1_weights_27_4_inst_addr                             "0x0197"
#define  set_SRNN_wdsr_layer2_1x1_weights_27_4_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_27_4_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_27_4_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_27_4_reg))
#define  SRNN_wdsr_layer2_1x1_weights_27_4_layer2_weight_4_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_27_4_layer2_weight_4_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_27_4_layer2_weight_4(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_27_4_get_layer2_weight_4(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_27_5                                      0x181AB5D0
#define  SRNN_wdsr_layer2_1x1_weights_27_5_reg_addr                              "0xB81AB5D0"
#define  SRNN_wdsr_layer2_1x1_weights_27_5_reg                                   0xB81AB5D0
#define  SRNN_wdsr_layer2_1x1_weights_27_5_inst_addr                             "0x0198"
#define  set_SRNN_wdsr_layer2_1x1_weights_27_5_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_27_5_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_27_5_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_27_5_reg))
#define  SRNN_wdsr_layer2_1x1_weights_27_5_layer2_weight_5_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_27_5_layer2_weight_5_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_27_5_layer2_weight_5(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_27_5_get_layer2_weight_5(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_27_6                                      0x181AB5D4
#define  SRNN_wdsr_layer2_1x1_weights_27_6_reg_addr                              "0xB81AB5D4"
#define  SRNN_wdsr_layer2_1x1_weights_27_6_reg                                   0xB81AB5D4
#define  SRNN_wdsr_layer2_1x1_weights_27_6_inst_addr                             "0x0199"
#define  set_SRNN_wdsr_layer2_1x1_weights_27_6_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_27_6_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_27_6_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_27_6_reg))
#define  SRNN_wdsr_layer2_1x1_weights_27_6_layer2_weight_6_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_27_6_layer2_weight_6_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_27_6_layer2_weight_6(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_27_6_get_layer2_weight_6(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_27_7                                      0x181AB5D8
#define  SRNN_wdsr_layer2_1x1_weights_27_7_reg_addr                              "0xB81AB5D8"
#define  SRNN_wdsr_layer2_1x1_weights_27_7_reg                                   0xB81AB5D8
#define  SRNN_wdsr_layer2_1x1_weights_27_7_inst_addr                             "0x019A"
#define  set_SRNN_wdsr_layer2_1x1_weights_27_7_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_27_7_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_27_7_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_27_7_reg))
#define  SRNN_wdsr_layer2_1x1_weights_27_7_layer2_weight_7_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_27_7_layer2_weight_7_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_27_7_layer2_weight_7(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_27_7_get_layer2_weight_7(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_27_8                                      0x181AB5DC
#define  SRNN_wdsr_layer2_1x1_weights_27_8_reg_addr                              "0xB81AB5DC"
#define  SRNN_wdsr_layer2_1x1_weights_27_8_reg                                   0xB81AB5DC
#define  SRNN_wdsr_layer2_1x1_weights_27_8_inst_addr                             "0x019B"
#define  set_SRNN_wdsr_layer2_1x1_weights_27_8_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_27_8_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_27_8_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_27_8_reg))
#define  SRNN_wdsr_layer2_1x1_weights_27_8_layer2_weight_8_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_27_8_layer2_weight_8_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_27_8_layer2_weight_8(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_27_8_get_layer2_weight_8(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_28_1                                      0x181AB5E0
#define  SRNN_wdsr_layer2_1x1_weights_28_1_reg_addr                              "0xB81AB5E0"
#define  SRNN_wdsr_layer2_1x1_weights_28_1_reg                                   0xB81AB5E0
#define  SRNN_wdsr_layer2_1x1_weights_28_1_inst_addr                             "0x019C"
#define  set_SRNN_wdsr_layer2_1x1_weights_28_1_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_28_1_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_28_1_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_28_1_reg))
#define  SRNN_wdsr_layer2_1x1_weights_28_1_layer2_weight_1_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_28_1_layer2_weight_1_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_28_1_layer2_weight_1(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_28_1_get_layer2_weight_1(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_28_2                                      0x181AB5E4
#define  SRNN_wdsr_layer2_1x1_weights_28_2_reg_addr                              "0xB81AB5E4"
#define  SRNN_wdsr_layer2_1x1_weights_28_2_reg                                   0xB81AB5E4
#define  SRNN_wdsr_layer2_1x1_weights_28_2_inst_addr                             "0x019D"
#define  set_SRNN_wdsr_layer2_1x1_weights_28_2_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_28_2_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_28_2_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_28_2_reg))
#define  SRNN_wdsr_layer2_1x1_weights_28_2_layer2_weight_2_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_28_2_layer2_weight_2_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_28_2_layer2_weight_2(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_28_2_get_layer2_weight_2(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_28_3                                      0x181AB5E8
#define  SRNN_wdsr_layer2_1x1_weights_28_3_reg_addr                              "0xB81AB5E8"
#define  SRNN_wdsr_layer2_1x1_weights_28_3_reg                                   0xB81AB5E8
#define  SRNN_wdsr_layer2_1x1_weights_28_3_inst_addr                             "0x019E"
#define  set_SRNN_wdsr_layer2_1x1_weights_28_3_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_28_3_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_28_3_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_28_3_reg))
#define  SRNN_wdsr_layer2_1x1_weights_28_3_layer2_weight_3_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_28_3_layer2_weight_3_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_28_3_layer2_weight_3(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_28_3_get_layer2_weight_3(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_28_4                                      0x181AB5EC
#define  SRNN_wdsr_layer2_1x1_weights_28_4_reg_addr                              "0xB81AB5EC"
#define  SRNN_wdsr_layer2_1x1_weights_28_4_reg                                   0xB81AB5EC
#define  SRNN_wdsr_layer2_1x1_weights_28_4_inst_addr                             "0x019F"
#define  set_SRNN_wdsr_layer2_1x1_weights_28_4_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_28_4_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_28_4_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_28_4_reg))
#define  SRNN_wdsr_layer2_1x1_weights_28_4_layer2_weight_4_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_28_4_layer2_weight_4_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_28_4_layer2_weight_4(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_28_4_get_layer2_weight_4(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_28_5                                      0x181AB5F0
#define  SRNN_wdsr_layer2_1x1_weights_28_5_reg_addr                              "0xB81AB5F0"
#define  SRNN_wdsr_layer2_1x1_weights_28_5_reg                                   0xB81AB5F0
#define  SRNN_wdsr_layer2_1x1_weights_28_5_inst_addr                             "0x01A0"
#define  set_SRNN_wdsr_layer2_1x1_weights_28_5_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_28_5_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_28_5_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_28_5_reg))
#define  SRNN_wdsr_layer2_1x1_weights_28_5_layer2_weight_5_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_28_5_layer2_weight_5_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_28_5_layer2_weight_5(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_28_5_get_layer2_weight_5(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_28_6                                      0x181AB5F4
#define  SRNN_wdsr_layer2_1x1_weights_28_6_reg_addr                              "0xB81AB5F4"
#define  SRNN_wdsr_layer2_1x1_weights_28_6_reg                                   0xB81AB5F4
#define  SRNN_wdsr_layer2_1x1_weights_28_6_inst_addr                             "0x01A1"
#define  set_SRNN_wdsr_layer2_1x1_weights_28_6_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_28_6_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_28_6_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_28_6_reg))
#define  SRNN_wdsr_layer2_1x1_weights_28_6_layer2_weight_6_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_28_6_layer2_weight_6_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_28_6_layer2_weight_6(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_28_6_get_layer2_weight_6(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_28_7                                      0x181AB5F8
#define  SRNN_wdsr_layer2_1x1_weights_28_7_reg_addr                              "0xB81AB5F8"
#define  SRNN_wdsr_layer2_1x1_weights_28_7_reg                                   0xB81AB5F8
#define  SRNN_wdsr_layer2_1x1_weights_28_7_inst_addr                             "0x01A2"
#define  set_SRNN_wdsr_layer2_1x1_weights_28_7_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_28_7_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_28_7_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_28_7_reg))
#define  SRNN_wdsr_layer2_1x1_weights_28_7_layer2_weight_7_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_28_7_layer2_weight_7_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_28_7_layer2_weight_7(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_28_7_get_layer2_weight_7(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_28_8                                      0x181AB5FC
#define  SRNN_wdsr_layer2_1x1_weights_28_8_reg_addr                              "0xB81AB5FC"
#define  SRNN_wdsr_layer2_1x1_weights_28_8_reg                                   0xB81AB5FC
#define  SRNN_wdsr_layer2_1x1_weights_28_8_inst_addr                             "0x01A3"
#define  set_SRNN_wdsr_layer2_1x1_weights_28_8_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_28_8_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_28_8_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_28_8_reg))
#define  SRNN_wdsr_layer2_1x1_weights_28_8_layer2_weight_8_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_28_8_layer2_weight_8_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_28_8_layer2_weight_8(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_28_8_get_layer2_weight_8(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_29_1                                      0x181AB600
#define  SRNN_wdsr_layer2_1x1_weights_29_1_reg_addr                              "0xB81AB600"
#define  SRNN_wdsr_layer2_1x1_weights_29_1_reg                                   0xB81AB600
#define  SRNN_wdsr_layer2_1x1_weights_29_1_inst_addr                             "0x01A4"
#define  set_SRNN_wdsr_layer2_1x1_weights_29_1_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_29_1_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_29_1_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_29_1_reg))
#define  SRNN_wdsr_layer2_1x1_weights_29_1_layer2_weight_1_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_29_1_layer2_weight_1_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_29_1_layer2_weight_1(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_29_1_get_layer2_weight_1(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_29_2                                      0x181AB604
#define  SRNN_wdsr_layer2_1x1_weights_29_2_reg_addr                              "0xB81AB604"
#define  SRNN_wdsr_layer2_1x1_weights_29_2_reg                                   0xB81AB604
#define  SRNN_wdsr_layer2_1x1_weights_29_2_inst_addr                             "0x01A5"
#define  set_SRNN_wdsr_layer2_1x1_weights_29_2_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_29_2_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_29_2_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_29_2_reg))
#define  SRNN_wdsr_layer2_1x1_weights_29_2_layer2_weight_2_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_29_2_layer2_weight_2_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_29_2_layer2_weight_2(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_29_2_get_layer2_weight_2(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_29_3                                      0x181AB608
#define  SRNN_wdsr_layer2_1x1_weights_29_3_reg_addr                              "0xB81AB608"
#define  SRNN_wdsr_layer2_1x1_weights_29_3_reg                                   0xB81AB608
#define  SRNN_wdsr_layer2_1x1_weights_29_3_inst_addr                             "0x01A6"
#define  set_SRNN_wdsr_layer2_1x1_weights_29_3_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_29_3_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_29_3_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_29_3_reg))
#define  SRNN_wdsr_layer2_1x1_weights_29_3_layer2_weight_3_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_29_3_layer2_weight_3_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_29_3_layer2_weight_3(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_29_3_get_layer2_weight_3(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_29_4                                      0x181AB60C
#define  SRNN_wdsr_layer2_1x1_weights_29_4_reg_addr                              "0xB81AB60C"
#define  SRNN_wdsr_layer2_1x1_weights_29_4_reg                                   0xB81AB60C
#define  SRNN_wdsr_layer2_1x1_weights_29_4_inst_addr                             "0x01A7"
#define  set_SRNN_wdsr_layer2_1x1_weights_29_4_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_29_4_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_29_4_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_29_4_reg))
#define  SRNN_wdsr_layer2_1x1_weights_29_4_layer2_weight_4_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_29_4_layer2_weight_4_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_29_4_layer2_weight_4(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_29_4_get_layer2_weight_4(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_29_5                                      0x181AB610
#define  SRNN_wdsr_layer2_1x1_weights_29_5_reg_addr                              "0xB81AB610"
#define  SRNN_wdsr_layer2_1x1_weights_29_5_reg                                   0xB81AB610
#define  SRNN_wdsr_layer2_1x1_weights_29_5_inst_addr                             "0x01A8"
#define  set_SRNN_wdsr_layer2_1x1_weights_29_5_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_29_5_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_29_5_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_29_5_reg))
#define  SRNN_wdsr_layer2_1x1_weights_29_5_layer2_weight_5_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_29_5_layer2_weight_5_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_29_5_layer2_weight_5(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_29_5_get_layer2_weight_5(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_29_6                                      0x181AB614
#define  SRNN_wdsr_layer2_1x1_weights_29_6_reg_addr                              "0xB81AB614"
#define  SRNN_wdsr_layer2_1x1_weights_29_6_reg                                   0xB81AB614
#define  SRNN_wdsr_layer2_1x1_weights_29_6_inst_addr                             "0x01A9"
#define  set_SRNN_wdsr_layer2_1x1_weights_29_6_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_29_6_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_29_6_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_29_6_reg))
#define  SRNN_wdsr_layer2_1x1_weights_29_6_layer2_weight_6_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_29_6_layer2_weight_6_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_29_6_layer2_weight_6(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_29_6_get_layer2_weight_6(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_29_7                                      0x181AB618
#define  SRNN_wdsr_layer2_1x1_weights_29_7_reg_addr                              "0xB81AB618"
#define  SRNN_wdsr_layer2_1x1_weights_29_7_reg                                   0xB81AB618
#define  SRNN_wdsr_layer2_1x1_weights_29_7_inst_addr                             "0x01AA"
#define  set_SRNN_wdsr_layer2_1x1_weights_29_7_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_29_7_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_29_7_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_29_7_reg))
#define  SRNN_wdsr_layer2_1x1_weights_29_7_layer2_weight_7_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_29_7_layer2_weight_7_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_29_7_layer2_weight_7(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_29_7_get_layer2_weight_7(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_29_8                                      0x181AB61C
#define  SRNN_wdsr_layer2_1x1_weights_29_8_reg_addr                              "0xB81AB61C"
#define  SRNN_wdsr_layer2_1x1_weights_29_8_reg                                   0xB81AB61C
#define  SRNN_wdsr_layer2_1x1_weights_29_8_inst_addr                             "0x01AB"
#define  set_SRNN_wdsr_layer2_1x1_weights_29_8_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_29_8_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_29_8_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_29_8_reg))
#define  SRNN_wdsr_layer2_1x1_weights_29_8_layer2_weight_8_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_29_8_layer2_weight_8_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_29_8_layer2_weight_8(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_29_8_get_layer2_weight_8(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_30_1                                      0x181AB620
#define  SRNN_wdsr_layer2_1x1_weights_30_1_reg_addr                              "0xB81AB620"
#define  SRNN_wdsr_layer2_1x1_weights_30_1_reg                                   0xB81AB620
#define  SRNN_wdsr_layer2_1x1_weights_30_1_inst_addr                             "0x01AC"
#define  set_SRNN_wdsr_layer2_1x1_weights_30_1_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_30_1_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_30_1_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_30_1_reg))
#define  SRNN_wdsr_layer2_1x1_weights_30_1_layer2_weight_1_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_30_1_layer2_weight_1_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_30_1_layer2_weight_1(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_30_1_get_layer2_weight_1(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_30_2                                      0x181AB624
#define  SRNN_wdsr_layer2_1x1_weights_30_2_reg_addr                              "0xB81AB624"
#define  SRNN_wdsr_layer2_1x1_weights_30_2_reg                                   0xB81AB624
#define  SRNN_wdsr_layer2_1x1_weights_30_2_inst_addr                             "0x01AD"
#define  set_SRNN_wdsr_layer2_1x1_weights_30_2_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_30_2_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_30_2_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_30_2_reg))
#define  SRNN_wdsr_layer2_1x1_weights_30_2_layer2_weight_2_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_30_2_layer2_weight_2_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_30_2_layer2_weight_2(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_30_2_get_layer2_weight_2(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_30_3                                      0x181AB628
#define  SRNN_wdsr_layer2_1x1_weights_30_3_reg_addr                              "0xB81AB628"
#define  SRNN_wdsr_layer2_1x1_weights_30_3_reg                                   0xB81AB628
#define  SRNN_wdsr_layer2_1x1_weights_30_3_inst_addr                             "0x01AE"
#define  set_SRNN_wdsr_layer2_1x1_weights_30_3_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_30_3_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_30_3_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_30_3_reg))
#define  SRNN_wdsr_layer2_1x1_weights_30_3_layer2_weight_3_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_30_3_layer2_weight_3_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_30_3_layer2_weight_3(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_30_3_get_layer2_weight_3(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_30_4                                      0x181AB62C
#define  SRNN_wdsr_layer2_1x1_weights_30_4_reg_addr                              "0xB81AB62C"
#define  SRNN_wdsr_layer2_1x1_weights_30_4_reg                                   0xB81AB62C
#define  SRNN_wdsr_layer2_1x1_weights_30_4_inst_addr                             "0x01AF"
#define  set_SRNN_wdsr_layer2_1x1_weights_30_4_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_30_4_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_30_4_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_30_4_reg))
#define  SRNN_wdsr_layer2_1x1_weights_30_4_layer2_weight_4_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_30_4_layer2_weight_4_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_30_4_layer2_weight_4(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_30_4_get_layer2_weight_4(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_30_5                                      0x181AB630
#define  SRNN_wdsr_layer2_1x1_weights_30_5_reg_addr                              "0xB81AB630"
#define  SRNN_wdsr_layer2_1x1_weights_30_5_reg                                   0xB81AB630
#define  SRNN_wdsr_layer2_1x1_weights_30_5_inst_addr                             "0x01B0"
#define  set_SRNN_wdsr_layer2_1x1_weights_30_5_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_30_5_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_30_5_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_30_5_reg))
#define  SRNN_wdsr_layer2_1x1_weights_30_5_layer2_weight_5_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_30_5_layer2_weight_5_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_30_5_layer2_weight_5(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_30_5_get_layer2_weight_5(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_30_6                                      0x181AB634
#define  SRNN_wdsr_layer2_1x1_weights_30_6_reg_addr                              "0xB81AB634"
#define  SRNN_wdsr_layer2_1x1_weights_30_6_reg                                   0xB81AB634
#define  SRNN_wdsr_layer2_1x1_weights_30_6_inst_addr                             "0x01B1"
#define  set_SRNN_wdsr_layer2_1x1_weights_30_6_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_30_6_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_30_6_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_30_6_reg))
#define  SRNN_wdsr_layer2_1x1_weights_30_6_layer2_weight_6_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_30_6_layer2_weight_6_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_30_6_layer2_weight_6(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_30_6_get_layer2_weight_6(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_30_7                                      0x181AB638
#define  SRNN_wdsr_layer2_1x1_weights_30_7_reg_addr                              "0xB81AB638"
#define  SRNN_wdsr_layer2_1x1_weights_30_7_reg                                   0xB81AB638
#define  SRNN_wdsr_layer2_1x1_weights_30_7_inst_addr                             "0x01B2"
#define  set_SRNN_wdsr_layer2_1x1_weights_30_7_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_30_7_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_30_7_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_30_7_reg))
#define  SRNN_wdsr_layer2_1x1_weights_30_7_layer2_weight_7_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_30_7_layer2_weight_7_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_30_7_layer2_weight_7(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_30_7_get_layer2_weight_7(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_30_8                                      0x181AB63C
#define  SRNN_wdsr_layer2_1x1_weights_30_8_reg_addr                              "0xB81AB63C"
#define  SRNN_wdsr_layer2_1x1_weights_30_8_reg                                   0xB81AB63C
#define  SRNN_wdsr_layer2_1x1_weights_30_8_inst_addr                             "0x01B3"
#define  set_SRNN_wdsr_layer2_1x1_weights_30_8_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_30_8_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_30_8_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_30_8_reg))
#define  SRNN_wdsr_layer2_1x1_weights_30_8_layer2_weight_8_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_30_8_layer2_weight_8_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_30_8_layer2_weight_8(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_30_8_get_layer2_weight_8(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_31_1                                      0x181AB640
#define  SRNN_wdsr_layer2_1x1_weights_31_1_reg_addr                              "0xB81AB640"
#define  SRNN_wdsr_layer2_1x1_weights_31_1_reg                                   0xB81AB640
#define  SRNN_wdsr_layer2_1x1_weights_31_1_inst_addr                             "0x01B4"
#define  set_SRNN_wdsr_layer2_1x1_weights_31_1_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_31_1_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_31_1_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_31_1_reg))
#define  SRNN_wdsr_layer2_1x1_weights_31_1_layer2_weight_1_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_31_1_layer2_weight_1_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_31_1_layer2_weight_1(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_31_1_get_layer2_weight_1(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_31_2                                      0x181AB644
#define  SRNN_wdsr_layer2_1x1_weights_31_2_reg_addr                              "0xB81AB644"
#define  SRNN_wdsr_layer2_1x1_weights_31_2_reg                                   0xB81AB644
#define  SRNN_wdsr_layer2_1x1_weights_31_2_inst_addr                             "0x01B5"
#define  set_SRNN_wdsr_layer2_1x1_weights_31_2_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_31_2_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_31_2_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_31_2_reg))
#define  SRNN_wdsr_layer2_1x1_weights_31_2_layer2_weight_2_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_31_2_layer2_weight_2_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_31_2_layer2_weight_2(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_31_2_get_layer2_weight_2(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_31_3                                      0x181AB648
#define  SRNN_wdsr_layer2_1x1_weights_31_3_reg_addr                              "0xB81AB648"
#define  SRNN_wdsr_layer2_1x1_weights_31_3_reg                                   0xB81AB648
#define  SRNN_wdsr_layer2_1x1_weights_31_3_inst_addr                             "0x01B6"
#define  set_SRNN_wdsr_layer2_1x1_weights_31_3_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_31_3_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_31_3_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_31_3_reg))
#define  SRNN_wdsr_layer2_1x1_weights_31_3_layer2_weight_3_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_31_3_layer2_weight_3_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_31_3_layer2_weight_3(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_31_3_get_layer2_weight_3(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_31_4                                      0x181AB64C
#define  SRNN_wdsr_layer2_1x1_weights_31_4_reg_addr                              "0xB81AB64C"
#define  SRNN_wdsr_layer2_1x1_weights_31_4_reg                                   0xB81AB64C
#define  SRNN_wdsr_layer2_1x1_weights_31_4_inst_addr                             "0x01B7"
#define  set_SRNN_wdsr_layer2_1x1_weights_31_4_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_31_4_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_31_4_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_31_4_reg))
#define  SRNN_wdsr_layer2_1x1_weights_31_4_layer2_weight_4_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_31_4_layer2_weight_4_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_31_4_layer2_weight_4(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_31_4_get_layer2_weight_4(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_31_5                                      0x181AB650
#define  SRNN_wdsr_layer2_1x1_weights_31_5_reg_addr                              "0xB81AB650"
#define  SRNN_wdsr_layer2_1x1_weights_31_5_reg                                   0xB81AB650
#define  SRNN_wdsr_layer2_1x1_weights_31_5_inst_addr                             "0x01B8"
#define  set_SRNN_wdsr_layer2_1x1_weights_31_5_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_31_5_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_31_5_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_31_5_reg))
#define  SRNN_wdsr_layer2_1x1_weights_31_5_layer2_weight_5_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_31_5_layer2_weight_5_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_31_5_layer2_weight_5(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_31_5_get_layer2_weight_5(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_31_6                                      0x181AB654
#define  SRNN_wdsr_layer2_1x1_weights_31_6_reg_addr                              "0xB81AB654"
#define  SRNN_wdsr_layer2_1x1_weights_31_6_reg                                   0xB81AB654
#define  SRNN_wdsr_layer2_1x1_weights_31_6_inst_addr                             "0x01B9"
#define  set_SRNN_wdsr_layer2_1x1_weights_31_6_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_31_6_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_31_6_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_31_6_reg))
#define  SRNN_wdsr_layer2_1x1_weights_31_6_layer2_weight_6_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_31_6_layer2_weight_6_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_31_6_layer2_weight_6(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_31_6_get_layer2_weight_6(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_31_7                                      0x181AB658
#define  SRNN_wdsr_layer2_1x1_weights_31_7_reg_addr                              "0xB81AB658"
#define  SRNN_wdsr_layer2_1x1_weights_31_7_reg                                   0xB81AB658
#define  SRNN_wdsr_layer2_1x1_weights_31_7_inst_addr                             "0x01BA"
#define  set_SRNN_wdsr_layer2_1x1_weights_31_7_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_31_7_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_31_7_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_31_7_reg))
#define  SRNN_wdsr_layer2_1x1_weights_31_7_layer2_weight_7_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_31_7_layer2_weight_7_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_31_7_layer2_weight_7(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_31_7_get_layer2_weight_7(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_31_8                                      0x181AB65C
#define  SRNN_wdsr_layer2_1x1_weights_31_8_reg_addr                              "0xB81AB65C"
#define  SRNN_wdsr_layer2_1x1_weights_31_8_reg                                   0xB81AB65C
#define  SRNN_wdsr_layer2_1x1_weights_31_8_inst_addr                             "0x01BB"
#define  set_SRNN_wdsr_layer2_1x1_weights_31_8_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_31_8_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_31_8_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_31_8_reg))
#define  SRNN_wdsr_layer2_1x1_weights_31_8_layer2_weight_8_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_31_8_layer2_weight_8_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_31_8_layer2_weight_8(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_31_8_get_layer2_weight_8(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_32_1                                      0x181AB660
#define  SRNN_wdsr_layer2_1x1_weights_32_1_reg_addr                              "0xB81AB660"
#define  SRNN_wdsr_layer2_1x1_weights_32_1_reg                                   0xB81AB660
#define  SRNN_wdsr_layer2_1x1_weights_32_1_inst_addr                             "0x01BC"
#define  set_SRNN_wdsr_layer2_1x1_weights_32_1_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_32_1_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_32_1_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_32_1_reg))
#define  SRNN_wdsr_layer2_1x1_weights_32_1_layer2_weight_1_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_32_1_layer2_weight_1_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_32_1_layer2_weight_1(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_32_1_get_layer2_weight_1(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_32_2                                      0x181AB664
#define  SRNN_wdsr_layer2_1x1_weights_32_2_reg_addr                              "0xB81AB664"
#define  SRNN_wdsr_layer2_1x1_weights_32_2_reg                                   0xB81AB664
#define  SRNN_wdsr_layer2_1x1_weights_32_2_inst_addr                             "0x01BD"
#define  set_SRNN_wdsr_layer2_1x1_weights_32_2_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_32_2_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_32_2_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_32_2_reg))
#define  SRNN_wdsr_layer2_1x1_weights_32_2_layer2_weight_2_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_32_2_layer2_weight_2_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_32_2_layer2_weight_2(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_32_2_get_layer2_weight_2(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_32_3                                      0x181AB668
#define  SRNN_wdsr_layer2_1x1_weights_32_3_reg_addr                              "0xB81AB668"
#define  SRNN_wdsr_layer2_1x1_weights_32_3_reg                                   0xB81AB668
#define  SRNN_wdsr_layer2_1x1_weights_32_3_inst_addr                             "0x01BE"
#define  set_SRNN_wdsr_layer2_1x1_weights_32_3_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_32_3_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_32_3_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_32_3_reg))
#define  SRNN_wdsr_layer2_1x1_weights_32_3_layer2_weight_3_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_32_3_layer2_weight_3_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_32_3_layer2_weight_3(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_32_3_get_layer2_weight_3(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_32_4                                      0x181AB66C
#define  SRNN_wdsr_layer2_1x1_weights_32_4_reg_addr                              "0xB81AB66C"
#define  SRNN_wdsr_layer2_1x1_weights_32_4_reg                                   0xB81AB66C
#define  SRNN_wdsr_layer2_1x1_weights_32_4_inst_addr                             "0x01BF"
#define  set_SRNN_wdsr_layer2_1x1_weights_32_4_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_32_4_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_32_4_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_32_4_reg))
#define  SRNN_wdsr_layer2_1x1_weights_32_4_layer2_weight_4_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_32_4_layer2_weight_4_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_32_4_layer2_weight_4(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_32_4_get_layer2_weight_4(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_32_5                                      0x181AB670
#define  SRNN_wdsr_layer2_1x1_weights_32_5_reg_addr                              "0xB81AB670"
#define  SRNN_wdsr_layer2_1x1_weights_32_5_reg                                   0xB81AB670
#define  SRNN_wdsr_layer2_1x1_weights_32_5_inst_addr                             "0x01C0"
#define  set_SRNN_wdsr_layer2_1x1_weights_32_5_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_32_5_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_32_5_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_32_5_reg))
#define  SRNN_wdsr_layer2_1x1_weights_32_5_layer2_weight_5_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_32_5_layer2_weight_5_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_32_5_layer2_weight_5(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_32_5_get_layer2_weight_5(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_32_6                                      0x181AB674
#define  SRNN_wdsr_layer2_1x1_weights_32_6_reg_addr                              "0xB81AB674"
#define  SRNN_wdsr_layer2_1x1_weights_32_6_reg                                   0xB81AB674
#define  SRNN_wdsr_layer2_1x1_weights_32_6_inst_addr                             "0x01C1"
#define  set_SRNN_wdsr_layer2_1x1_weights_32_6_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_32_6_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_32_6_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_32_6_reg))
#define  SRNN_wdsr_layer2_1x1_weights_32_6_layer2_weight_6_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_32_6_layer2_weight_6_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_32_6_layer2_weight_6(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_32_6_get_layer2_weight_6(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_32_7                                      0x181AB678
#define  SRNN_wdsr_layer2_1x1_weights_32_7_reg_addr                              "0xB81AB678"
#define  SRNN_wdsr_layer2_1x1_weights_32_7_reg                                   0xB81AB678
#define  SRNN_wdsr_layer2_1x1_weights_32_7_inst_addr                             "0x01C2"
#define  set_SRNN_wdsr_layer2_1x1_weights_32_7_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_32_7_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_32_7_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_32_7_reg))
#define  SRNN_wdsr_layer2_1x1_weights_32_7_layer2_weight_7_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_32_7_layer2_weight_7_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_32_7_layer2_weight_7(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_32_7_get_layer2_weight_7(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_weights_32_8                                      0x181AB67C
#define  SRNN_wdsr_layer2_1x1_weights_32_8_reg_addr                              "0xB81AB67C"
#define  SRNN_wdsr_layer2_1x1_weights_32_8_reg                                   0xB81AB67C
#define  SRNN_wdsr_layer2_1x1_weights_32_8_inst_addr                             "0x01C3"
#define  set_SRNN_wdsr_layer2_1x1_weights_32_8_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_32_8_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_weights_32_8_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_weights_32_8_reg))
#define  SRNN_wdsr_layer2_1x1_weights_32_8_layer2_weight_8_shift                 (0)
#define  SRNN_wdsr_layer2_1x1_weights_32_8_layer2_weight_8_mask                  (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_weights_32_8_layer2_weight_8(data)                 (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_weights_32_8_get_layer2_weight_8(data)             (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_bias_1                                            0x181AB680
#define  SRNN_wdsr_layer2_1x1_bias_1_reg_addr                                    "0xB81AB680"
#define  SRNN_wdsr_layer2_1x1_bias_1_reg                                         0xB81AB680
#define  SRNN_wdsr_layer2_1x1_bias_1_inst_addr                                   "0x01C4"
#define  set_SRNN_wdsr_layer2_1x1_bias_1_reg(data)                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_bias_1_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_bias_1_reg                                     (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_bias_1_reg))
#define  SRNN_wdsr_layer2_1x1_bias_1_layer2_bias_1_shift                         (0)
#define  SRNN_wdsr_layer2_1x1_bias_1_layer2_bias_1_mask                          (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_bias_1_layer2_bias_1(data)                         (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_bias_1_get_layer2_bias_1(data)                     (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_bias_2                                            0x181AB684
#define  SRNN_wdsr_layer2_1x1_bias_2_reg_addr                                    "0xB81AB684"
#define  SRNN_wdsr_layer2_1x1_bias_2_reg                                         0xB81AB684
#define  SRNN_wdsr_layer2_1x1_bias_2_inst_addr                                   "0x01C5"
#define  set_SRNN_wdsr_layer2_1x1_bias_2_reg(data)                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_bias_2_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_bias_2_reg                                     (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_bias_2_reg))
#define  SRNN_wdsr_layer2_1x1_bias_2_layer2_bias_2_shift                         (0)
#define  SRNN_wdsr_layer2_1x1_bias_2_layer2_bias_2_mask                          (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_bias_2_layer2_bias_2(data)                         (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_bias_2_get_layer2_bias_2(data)                     (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_bias_3                                            0x181AB688
#define  SRNN_wdsr_layer2_1x1_bias_3_reg_addr                                    "0xB81AB688"
#define  SRNN_wdsr_layer2_1x1_bias_3_reg                                         0xB81AB688
#define  SRNN_wdsr_layer2_1x1_bias_3_inst_addr                                   "0x01C6"
#define  set_SRNN_wdsr_layer2_1x1_bias_3_reg(data)                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_bias_3_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_bias_3_reg                                     (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_bias_3_reg))
#define  SRNN_wdsr_layer2_1x1_bias_3_layer2_bias_3_shift                         (0)
#define  SRNN_wdsr_layer2_1x1_bias_3_layer2_bias_3_mask                          (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_bias_3_layer2_bias_3(data)                         (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_bias_3_get_layer2_bias_3(data)                     (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_bias_4                                            0x181AB68C
#define  SRNN_wdsr_layer2_1x1_bias_4_reg_addr                                    "0xB81AB68C"
#define  SRNN_wdsr_layer2_1x1_bias_4_reg                                         0xB81AB68C
#define  SRNN_wdsr_layer2_1x1_bias_4_inst_addr                                   "0x01C7"
#define  set_SRNN_wdsr_layer2_1x1_bias_4_reg(data)                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_bias_4_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_bias_4_reg                                     (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_bias_4_reg))
#define  SRNN_wdsr_layer2_1x1_bias_4_layer2_bias_4_shift                         (0)
#define  SRNN_wdsr_layer2_1x1_bias_4_layer2_bias_4_mask                          (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_bias_4_layer2_bias_4(data)                         (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_bias_4_get_layer2_bias_4(data)                     (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_bias_5                                            0x181AB690
#define  SRNN_wdsr_layer2_1x1_bias_5_reg_addr                                    "0xB81AB690"
#define  SRNN_wdsr_layer2_1x1_bias_5_reg                                         0xB81AB690
#define  SRNN_wdsr_layer2_1x1_bias_5_inst_addr                                   "0x01C8"
#define  set_SRNN_wdsr_layer2_1x1_bias_5_reg(data)                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_bias_5_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_bias_5_reg                                     (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_bias_5_reg))
#define  SRNN_wdsr_layer2_1x1_bias_5_layer2_bias_5_shift                         (0)
#define  SRNN_wdsr_layer2_1x1_bias_5_layer2_bias_5_mask                          (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_bias_5_layer2_bias_5(data)                         (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_bias_5_get_layer2_bias_5(data)                     (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_bias_6                                            0x181AB694
#define  SRNN_wdsr_layer2_1x1_bias_6_reg_addr                                    "0xB81AB694"
#define  SRNN_wdsr_layer2_1x1_bias_6_reg                                         0xB81AB694
#define  SRNN_wdsr_layer2_1x1_bias_6_inst_addr                                   "0x01C9"
#define  set_SRNN_wdsr_layer2_1x1_bias_6_reg(data)                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_bias_6_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_bias_6_reg                                     (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_bias_6_reg))
#define  SRNN_wdsr_layer2_1x1_bias_6_layer2_bias_6_shift                         (0)
#define  SRNN_wdsr_layer2_1x1_bias_6_layer2_bias_6_mask                          (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_bias_6_layer2_bias_6(data)                         (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_bias_6_get_layer2_bias_6(data)                     (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_bias_7                                            0x181AB698
#define  SRNN_wdsr_layer2_1x1_bias_7_reg_addr                                    "0xB81AB698"
#define  SRNN_wdsr_layer2_1x1_bias_7_reg                                         0xB81AB698
#define  SRNN_wdsr_layer2_1x1_bias_7_inst_addr                                   "0x01CA"
#define  set_SRNN_wdsr_layer2_1x1_bias_7_reg(data)                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_bias_7_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_bias_7_reg                                     (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_bias_7_reg))
#define  SRNN_wdsr_layer2_1x1_bias_7_layer2_bias_7_shift                         (0)
#define  SRNN_wdsr_layer2_1x1_bias_7_layer2_bias_7_mask                          (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_bias_7_layer2_bias_7(data)                         (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_bias_7_get_layer2_bias_7(data)                     (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_bias_8                                            0x181AB69C
#define  SRNN_wdsr_layer2_1x1_bias_8_reg_addr                                    "0xB81AB69C"
#define  SRNN_wdsr_layer2_1x1_bias_8_reg                                         0xB81AB69C
#define  SRNN_wdsr_layer2_1x1_bias_8_inst_addr                                   "0x01CB"
#define  set_SRNN_wdsr_layer2_1x1_bias_8_reg(data)                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_bias_8_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_bias_8_reg                                     (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_bias_8_reg))
#define  SRNN_wdsr_layer2_1x1_bias_8_layer2_bias_8_shift                         (0)
#define  SRNN_wdsr_layer2_1x1_bias_8_layer2_bias_8_mask                          (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_bias_8_layer2_bias_8(data)                         (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_bias_8_get_layer2_bias_8(data)                     (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_bias_9                                            0x181AB6A0
#define  SRNN_wdsr_layer2_1x1_bias_9_reg_addr                                    "0xB81AB6A0"
#define  SRNN_wdsr_layer2_1x1_bias_9_reg                                         0xB81AB6A0
#define  SRNN_wdsr_layer2_1x1_bias_9_inst_addr                                   "0x01CC"
#define  set_SRNN_wdsr_layer2_1x1_bias_9_reg(data)                               (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_bias_9_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_bias_9_reg                                     (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_bias_9_reg))
#define  SRNN_wdsr_layer2_1x1_bias_9_layer2_bias_9_shift                         (0)
#define  SRNN_wdsr_layer2_1x1_bias_9_layer2_bias_9_mask                          (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_bias_9_layer2_bias_9(data)                         (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_bias_9_get_layer2_bias_9(data)                     (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_bias_10                                           0x181AB6A4
#define  SRNN_wdsr_layer2_1x1_bias_10_reg_addr                                   "0xB81AB6A4"
#define  SRNN_wdsr_layer2_1x1_bias_10_reg                                        0xB81AB6A4
#define  SRNN_wdsr_layer2_1x1_bias_10_inst_addr                                  "0x01CD"
#define  set_SRNN_wdsr_layer2_1x1_bias_10_reg(data)                              (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_bias_10_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_bias_10_reg                                    (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_bias_10_reg))
#define  SRNN_wdsr_layer2_1x1_bias_10_layer2_bias_10_shift                       (0)
#define  SRNN_wdsr_layer2_1x1_bias_10_layer2_bias_10_mask                        (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_bias_10_layer2_bias_10(data)                       (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_bias_10_get_layer2_bias_10(data)                   (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_bias_11                                           0x181AB6A8
#define  SRNN_wdsr_layer2_1x1_bias_11_reg_addr                                   "0xB81AB6A8"
#define  SRNN_wdsr_layer2_1x1_bias_11_reg                                        0xB81AB6A8
#define  SRNN_wdsr_layer2_1x1_bias_11_inst_addr                                  "0x01CE"
#define  set_SRNN_wdsr_layer2_1x1_bias_11_reg(data)                              (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_bias_11_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_bias_11_reg                                    (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_bias_11_reg))
#define  SRNN_wdsr_layer2_1x1_bias_11_layer2_bias_11_shift                       (0)
#define  SRNN_wdsr_layer2_1x1_bias_11_layer2_bias_11_mask                        (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_bias_11_layer2_bias_11(data)                       (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_bias_11_get_layer2_bias_11(data)                   (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_bias_12                                           0x181AB6AC
#define  SRNN_wdsr_layer2_1x1_bias_12_reg_addr                                   "0xB81AB6AC"
#define  SRNN_wdsr_layer2_1x1_bias_12_reg                                        0xB81AB6AC
#define  SRNN_wdsr_layer2_1x1_bias_12_inst_addr                                  "0x01CF"
#define  set_SRNN_wdsr_layer2_1x1_bias_12_reg(data)                              (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_bias_12_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_bias_12_reg                                    (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_bias_12_reg))
#define  SRNN_wdsr_layer2_1x1_bias_12_layer2_bias_12_shift                       (0)
#define  SRNN_wdsr_layer2_1x1_bias_12_layer2_bias_12_mask                        (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_bias_12_layer2_bias_12(data)                       (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_bias_12_get_layer2_bias_12(data)                   (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_bias_13                                           0x181AB6B0
#define  SRNN_wdsr_layer2_1x1_bias_13_reg_addr                                   "0xB81AB6B0"
#define  SRNN_wdsr_layer2_1x1_bias_13_reg                                        0xB81AB6B0
#define  SRNN_wdsr_layer2_1x1_bias_13_inst_addr                                  "0x01D0"
#define  set_SRNN_wdsr_layer2_1x1_bias_13_reg(data)                              (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_bias_13_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_bias_13_reg                                    (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_bias_13_reg))
#define  SRNN_wdsr_layer2_1x1_bias_13_layer2_bias_13_shift                       (0)
#define  SRNN_wdsr_layer2_1x1_bias_13_layer2_bias_13_mask                        (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_bias_13_layer2_bias_13(data)                       (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_bias_13_get_layer2_bias_13(data)                   (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_bias_14                                           0x181AB6B4
#define  SRNN_wdsr_layer2_1x1_bias_14_reg_addr                                   "0xB81AB6B4"
#define  SRNN_wdsr_layer2_1x1_bias_14_reg                                        0xB81AB6B4
#define  SRNN_wdsr_layer2_1x1_bias_14_inst_addr                                  "0x01D1"
#define  set_SRNN_wdsr_layer2_1x1_bias_14_reg(data)                              (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_bias_14_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_bias_14_reg                                    (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_bias_14_reg))
#define  SRNN_wdsr_layer2_1x1_bias_14_layer2_bias_14_shift                       (0)
#define  SRNN_wdsr_layer2_1x1_bias_14_layer2_bias_14_mask                        (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_bias_14_layer2_bias_14(data)                       (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_bias_14_get_layer2_bias_14(data)                   (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_bias_15                                           0x181AB6B8
#define  SRNN_wdsr_layer2_1x1_bias_15_reg_addr                                   "0xB81AB6B8"
#define  SRNN_wdsr_layer2_1x1_bias_15_reg                                        0xB81AB6B8
#define  SRNN_wdsr_layer2_1x1_bias_15_inst_addr                                  "0x01D2"
#define  set_SRNN_wdsr_layer2_1x1_bias_15_reg(data)                              (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_bias_15_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_bias_15_reg                                    (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_bias_15_reg))
#define  SRNN_wdsr_layer2_1x1_bias_15_layer2_bias_15_shift                       (0)
#define  SRNN_wdsr_layer2_1x1_bias_15_layer2_bias_15_mask                        (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_bias_15_layer2_bias_15(data)                       (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_bias_15_get_layer2_bias_15(data)                   (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_bias_16                                           0x181AB6BC
#define  SRNN_wdsr_layer2_1x1_bias_16_reg_addr                                   "0xB81AB6BC"
#define  SRNN_wdsr_layer2_1x1_bias_16_reg                                        0xB81AB6BC
#define  SRNN_wdsr_layer2_1x1_bias_16_inst_addr                                  "0x01D3"
#define  set_SRNN_wdsr_layer2_1x1_bias_16_reg(data)                              (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_bias_16_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_bias_16_reg                                    (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_bias_16_reg))
#define  SRNN_wdsr_layer2_1x1_bias_16_layer2_bias_16_shift                       (0)
#define  SRNN_wdsr_layer2_1x1_bias_16_layer2_bias_16_mask                        (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_bias_16_layer2_bias_16(data)                       (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_bias_16_get_layer2_bias_16(data)                   (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_bias_17                                           0x181AB6C0
#define  SRNN_wdsr_layer2_1x1_bias_17_reg_addr                                   "0xB81AB6C0"
#define  SRNN_wdsr_layer2_1x1_bias_17_reg                                        0xB81AB6C0
#define  SRNN_wdsr_layer2_1x1_bias_17_inst_addr                                  "0x01D4"
#define  set_SRNN_wdsr_layer2_1x1_bias_17_reg(data)                              (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_bias_17_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_bias_17_reg                                    (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_bias_17_reg))
#define  SRNN_wdsr_layer2_1x1_bias_17_layer2_bias_17_shift                       (0)
#define  SRNN_wdsr_layer2_1x1_bias_17_layer2_bias_17_mask                        (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_bias_17_layer2_bias_17(data)                       (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_bias_17_get_layer2_bias_17(data)                   (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_bias_18                                           0x181AB6C4
#define  SRNN_wdsr_layer2_1x1_bias_18_reg_addr                                   "0xB81AB6C4"
#define  SRNN_wdsr_layer2_1x1_bias_18_reg                                        0xB81AB6C4
#define  SRNN_wdsr_layer2_1x1_bias_18_inst_addr                                  "0x01D5"
#define  set_SRNN_wdsr_layer2_1x1_bias_18_reg(data)                              (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_bias_18_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_bias_18_reg                                    (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_bias_18_reg))
#define  SRNN_wdsr_layer2_1x1_bias_18_layer2_bias_18_shift                       (0)
#define  SRNN_wdsr_layer2_1x1_bias_18_layer2_bias_18_mask                        (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_bias_18_layer2_bias_18(data)                       (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_bias_18_get_layer2_bias_18(data)                   (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_bias_19                                           0x181AB6C8
#define  SRNN_wdsr_layer2_1x1_bias_19_reg_addr                                   "0xB81AB6C8"
#define  SRNN_wdsr_layer2_1x1_bias_19_reg                                        0xB81AB6C8
#define  SRNN_wdsr_layer2_1x1_bias_19_inst_addr                                  "0x01D6"
#define  set_SRNN_wdsr_layer2_1x1_bias_19_reg(data)                              (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_bias_19_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_bias_19_reg                                    (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_bias_19_reg))
#define  SRNN_wdsr_layer2_1x1_bias_19_layer2_bias_19_shift                       (0)
#define  SRNN_wdsr_layer2_1x1_bias_19_layer2_bias_19_mask                        (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_bias_19_layer2_bias_19(data)                       (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_bias_19_get_layer2_bias_19(data)                   (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_bias_20                                           0x181AB6CC
#define  SRNN_wdsr_layer2_1x1_bias_20_reg_addr                                   "0xB81AB6CC"
#define  SRNN_wdsr_layer2_1x1_bias_20_reg                                        0xB81AB6CC
#define  SRNN_wdsr_layer2_1x1_bias_20_inst_addr                                  "0x01D7"
#define  set_SRNN_wdsr_layer2_1x1_bias_20_reg(data)                              (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_bias_20_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_bias_20_reg                                    (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_bias_20_reg))
#define  SRNN_wdsr_layer2_1x1_bias_20_layer2_bias_20_shift                       (0)
#define  SRNN_wdsr_layer2_1x1_bias_20_layer2_bias_20_mask                        (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_bias_20_layer2_bias_20(data)                       (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_bias_20_get_layer2_bias_20(data)                   (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_bias_21                                           0x181AB6D0
#define  SRNN_wdsr_layer2_1x1_bias_21_reg_addr                                   "0xB81AB6D0"
#define  SRNN_wdsr_layer2_1x1_bias_21_reg                                        0xB81AB6D0
#define  SRNN_wdsr_layer2_1x1_bias_21_inst_addr                                  "0x01D8"
#define  set_SRNN_wdsr_layer2_1x1_bias_21_reg(data)                              (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_bias_21_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_bias_21_reg                                    (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_bias_21_reg))
#define  SRNN_wdsr_layer2_1x1_bias_21_layer2_bias_21_shift                       (0)
#define  SRNN_wdsr_layer2_1x1_bias_21_layer2_bias_21_mask                        (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_bias_21_layer2_bias_21(data)                       (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_bias_21_get_layer2_bias_21(data)                   (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_bias_22                                           0x181AB6D4
#define  SRNN_wdsr_layer2_1x1_bias_22_reg_addr                                   "0xB81AB6D4"
#define  SRNN_wdsr_layer2_1x1_bias_22_reg                                        0xB81AB6D4
#define  SRNN_wdsr_layer2_1x1_bias_22_inst_addr                                  "0x01D9"
#define  set_SRNN_wdsr_layer2_1x1_bias_22_reg(data)                              (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_bias_22_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_bias_22_reg                                    (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_bias_22_reg))
#define  SRNN_wdsr_layer2_1x1_bias_22_layer2_bias_22_shift                       (0)
#define  SRNN_wdsr_layer2_1x1_bias_22_layer2_bias_22_mask                        (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_bias_22_layer2_bias_22(data)                       (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_bias_22_get_layer2_bias_22(data)                   (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_bias_23                                           0x181AB6D8
#define  SRNN_wdsr_layer2_1x1_bias_23_reg_addr                                   "0xB81AB6D8"
#define  SRNN_wdsr_layer2_1x1_bias_23_reg                                        0xB81AB6D8
#define  SRNN_wdsr_layer2_1x1_bias_23_inst_addr                                  "0x01DA"
#define  set_SRNN_wdsr_layer2_1x1_bias_23_reg(data)                              (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_bias_23_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_bias_23_reg                                    (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_bias_23_reg))
#define  SRNN_wdsr_layer2_1x1_bias_23_layer2_bias_23_shift                       (0)
#define  SRNN_wdsr_layer2_1x1_bias_23_layer2_bias_23_mask                        (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_bias_23_layer2_bias_23(data)                       (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_bias_23_get_layer2_bias_23(data)                   (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_bias_24                                           0x181AB6DC
#define  SRNN_wdsr_layer2_1x1_bias_24_reg_addr                                   "0xB81AB6DC"
#define  SRNN_wdsr_layer2_1x1_bias_24_reg                                        0xB81AB6DC
#define  SRNN_wdsr_layer2_1x1_bias_24_inst_addr                                  "0x01DB"
#define  set_SRNN_wdsr_layer2_1x1_bias_24_reg(data)                              (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_bias_24_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_bias_24_reg                                    (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_bias_24_reg))
#define  SRNN_wdsr_layer2_1x1_bias_24_layer2_bias_24_shift                       (0)
#define  SRNN_wdsr_layer2_1x1_bias_24_layer2_bias_24_mask                        (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_bias_24_layer2_bias_24(data)                       (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_bias_24_get_layer2_bias_24(data)                   (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_bias_25                                           0x181AB6E0
#define  SRNN_wdsr_layer2_1x1_bias_25_reg_addr                                   "0xB81AB6E0"
#define  SRNN_wdsr_layer2_1x1_bias_25_reg                                        0xB81AB6E0
#define  SRNN_wdsr_layer2_1x1_bias_25_inst_addr                                  "0x01DC"
#define  set_SRNN_wdsr_layer2_1x1_bias_25_reg(data)                              (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_bias_25_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_bias_25_reg                                    (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_bias_25_reg))
#define  SRNN_wdsr_layer2_1x1_bias_25_layer2_bias_25_shift                       (0)
#define  SRNN_wdsr_layer2_1x1_bias_25_layer2_bias_25_mask                        (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_bias_25_layer2_bias_25(data)                       (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_bias_25_get_layer2_bias_25(data)                   (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_bias_26                                           0x181AB6E4
#define  SRNN_wdsr_layer2_1x1_bias_26_reg_addr                                   "0xB81AB6E4"
#define  SRNN_wdsr_layer2_1x1_bias_26_reg                                        0xB81AB6E4
#define  SRNN_wdsr_layer2_1x1_bias_26_inst_addr                                  "0x01DD"
#define  set_SRNN_wdsr_layer2_1x1_bias_26_reg(data)                              (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_bias_26_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_bias_26_reg                                    (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_bias_26_reg))
#define  SRNN_wdsr_layer2_1x1_bias_26_layer2_bias_26_shift                       (0)
#define  SRNN_wdsr_layer2_1x1_bias_26_layer2_bias_26_mask                        (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_bias_26_layer2_bias_26(data)                       (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_bias_26_get_layer2_bias_26(data)                   (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_bias_27                                           0x181AB6E8
#define  SRNN_wdsr_layer2_1x1_bias_27_reg_addr                                   "0xB81AB6E8"
#define  SRNN_wdsr_layer2_1x1_bias_27_reg                                        0xB81AB6E8
#define  SRNN_wdsr_layer2_1x1_bias_27_inst_addr                                  "0x01DE"
#define  set_SRNN_wdsr_layer2_1x1_bias_27_reg(data)                              (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_bias_27_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_bias_27_reg                                    (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_bias_27_reg))
#define  SRNN_wdsr_layer2_1x1_bias_27_layer2_bias_27_shift                       (0)
#define  SRNN_wdsr_layer2_1x1_bias_27_layer2_bias_27_mask                        (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_bias_27_layer2_bias_27(data)                       (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_bias_27_get_layer2_bias_27(data)                   (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_bias_28                                           0x181AB6EC
#define  SRNN_wdsr_layer2_1x1_bias_28_reg_addr                                   "0xB81AB6EC"
#define  SRNN_wdsr_layer2_1x1_bias_28_reg                                        0xB81AB6EC
#define  SRNN_wdsr_layer2_1x1_bias_28_inst_addr                                  "0x01DF"
#define  set_SRNN_wdsr_layer2_1x1_bias_28_reg(data)                              (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_bias_28_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_bias_28_reg                                    (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_bias_28_reg))
#define  SRNN_wdsr_layer2_1x1_bias_28_layer2_bias_28_shift                       (0)
#define  SRNN_wdsr_layer2_1x1_bias_28_layer2_bias_28_mask                        (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_bias_28_layer2_bias_28(data)                       (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_bias_28_get_layer2_bias_28(data)                   (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_bias_29                                           0x181AB6F0
#define  SRNN_wdsr_layer2_1x1_bias_29_reg_addr                                   "0xB81AB6F0"
#define  SRNN_wdsr_layer2_1x1_bias_29_reg                                        0xB81AB6F0
#define  SRNN_wdsr_layer2_1x1_bias_29_inst_addr                                  "0x01E0"
#define  set_SRNN_wdsr_layer2_1x1_bias_29_reg(data)                              (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_bias_29_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_bias_29_reg                                    (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_bias_29_reg))
#define  SRNN_wdsr_layer2_1x1_bias_29_layer2_bias_29_shift                       (0)
#define  SRNN_wdsr_layer2_1x1_bias_29_layer2_bias_29_mask                        (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_bias_29_layer2_bias_29(data)                       (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_bias_29_get_layer2_bias_29(data)                   (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_bias_30                                           0x181AB6F4
#define  SRNN_wdsr_layer2_1x1_bias_30_reg_addr                                   "0xB81AB6F4"
#define  SRNN_wdsr_layer2_1x1_bias_30_reg                                        0xB81AB6F4
#define  SRNN_wdsr_layer2_1x1_bias_30_inst_addr                                  "0x01E1"
#define  set_SRNN_wdsr_layer2_1x1_bias_30_reg(data)                              (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_bias_30_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_bias_30_reg                                    (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_bias_30_reg))
#define  SRNN_wdsr_layer2_1x1_bias_30_layer2_bias_30_shift                       (0)
#define  SRNN_wdsr_layer2_1x1_bias_30_layer2_bias_30_mask                        (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_bias_30_layer2_bias_30(data)                       (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_bias_30_get_layer2_bias_30(data)                   (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_bias_31                                           0x181AB6F8
#define  SRNN_wdsr_layer2_1x1_bias_31_reg_addr                                   "0xB81AB6F8"
#define  SRNN_wdsr_layer2_1x1_bias_31_reg                                        0xB81AB6F8
#define  SRNN_wdsr_layer2_1x1_bias_31_inst_addr                                  "0x01E2"
#define  set_SRNN_wdsr_layer2_1x1_bias_31_reg(data)                              (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_bias_31_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_bias_31_reg                                    (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_bias_31_reg))
#define  SRNN_wdsr_layer2_1x1_bias_31_layer2_bias_31_shift                       (0)
#define  SRNN_wdsr_layer2_1x1_bias_31_layer2_bias_31_mask                        (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_bias_31_layer2_bias_31(data)                       (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_bias_31_get_layer2_bias_31(data)                   (0x000007FF&(data))

#define  SRNN_wdsr_layer2_1x1_bias_32                                           0x181AB6FC
#define  SRNN_wdsr_layer2_1x1_bias_32_reg_addr                                   "0xB81AB6FC"
#define  SRNN_wdsr_layer2_1x1_bias_32_reg                                        0xB81AB6FC
#define  SRNN_wdsr_layer2_1x1_bias_32_inst_addr                                  "0x01E3"
#define  set_SRNN_wdsr_layer2_1x1_bias_32_reg(data)                              (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_bias_32_reg)=data)
#define  get_SRNN_wdsr_layer2_1x1_bias_32_reg                                    (*((volatile unsigned int*)SRNN_wdsr_layer2_1x1_bias_32_reg))
#define  SRNN_wdsr_layer2_1x1_bias_32_layer2_bias_32_shift                       (0)
#define  SRNN_wdsr_layer2_1x1_bias_32_layer2_bias_32_mask                        (0x000007FF)
#define  SRNN_wdsr_layer2_1x1_bias_32_layer2_bias_32(data)                       (0x000007FF&(data))
#define  SRNN_wdsr_layer2_1x1_bias_32_get_layer2_bias_32(data)                   (0x000007FF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_1_00                                      0x181AB700
#define  SRNN_wdsr_layer3_3x3_weights_1_00_reg_addr                              "0xB81AB700"
#define  SRNN_wdsr_layer3_3x3_weights_1_00_reg                                   0xB81AB700
#define  SRNN_wdsr_layer3_3x3_weights_1_00_inst_addr                             "0x01E4"
#define  set_SRNN_wdsr_layer3_3x3_weights_1_00_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_1_00_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_1_00_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_1_00_reg))
#define  SRNN_wdsr_layer3_3x3_weights_1_00_layer3_weight_00_shift                (0)
#define  SRNN_wdsr_layer3_3x3_weights_1_00_layer3_weight_00_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_1_00_layer3_weight_00(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_1_00_get_layer3_weight_00(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_1_01                                      0x181AB704
#define  SRNN_wdsr_layer3_3x3_weights_1_01_reg_addr                              "0xB81AB704"
#define  SRNN_wdsr_layer3_3x3_weights_1_01_reg                                   0xB81AB704
#define  SRNN_wdsr_layer3_3x3_weights_1_01_inst_addr                             "0x01E5"
#define  set_SRNN_wdsr_layer3_3x3_weights_1_01_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_1_01_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_1_01_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_1_01_reg))
#define  SRNN_wdsr_layer3_3x3_weights_1_01_layer3_weight_01_shift                (0)
#define  SRNN_wdsr_layer3_3x3_weights_1_01_layer3_weight_01_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_1_01_layer3_weight_01(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_1_01_get_layer3_weight_01(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_1_02                                      0x181AB708
#define  SRNN_wdsr_layer3_3x3_weights_1_02_reg_addr                              "0xB81AB708"
#define  SRNN_wdsr_layer3_3x3_weights_1_02_reg                                   0xB81AB708
#define  SRNN_wdsr_layer3_3x3_weights_1_02_inst_addr                             "0x01E6"
#define  set_SRNN_wdsr_layer3_3x3_weights_1_02_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_1_02_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_1_02_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_1_02_reg))
#define  SRNN_wdsr_layer3_3x3_weights_1_02_layer3_weight_02_shift                (0)
#define  SRNN_wdsr_layer3_3x3_weights_1_02_layer3_weight_02_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_1_02_layer3_weight_02(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_1_02_get_layer3_weight_02(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_1_10                                      0x181AB70C
#define  SRNN_wdsr_layer3_3x3_weights_1_10_reg_addr                              "0xB81AB70C"
#define  SRNN_wdsr_layer3_3x3_weights_1_10_reg                                   0xB81AB70C
#define  SRNN_wdsr_layer3_3x3_weights_1_10_inst_addr                             "0x01E7"
#define  set_SRNN_wdsr_layer3_3x3_weights_1_10_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_1_10_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_1_10_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_1_10_reg))
#define  SRNN_wdsr_layer3_3x3_weights_1_10_layer3_weight_10_shift                (0)
#define  SRNN_wdsr_layer3_3x3_weights_1_10_layer3_weight_10_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_1_10_layer3_weight_10(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_1_10_get_layer3_weight_10(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_1_11                                      0x181AB710
#define  SRNN_wdsr_layer3_3x3_weights_1_11_reg_addr                              "0xB81AB710"
#define  SRNN_wdsr_layer3_3x3_weights_1_11_reg                                   0xB81AB710
#define  SRNN_wdsr_layer3_3x3_weights_1_11_inst_addr                             "0x01E8"
#define  set_SRNN_wdsr_layer3_3x3_weights_1_11_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_1_11_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_1_11_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_1_11_reg))
#define  SRNN_wdsr_layer3_3x3_weights_1_11_layer3_weight_11_shift                (0)
#define  SRNN_wdsr_layer3_3x3_weights_1_11_layer3_weight_11_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_1_11_layer3_weight_11(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_1_11_get_layer3_weight_11(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_1_12                                      0x181AB714
#define  SRNN_wdsr_layer3_3x3_weights_1_12_reg_addr                              "0xB81AB714"
#define  SRNN_wdsr_layer3_3x3_weights_1_12_reg                                   0xB81AB714
#define  SRNN_wdsr_layer3_3x3_weights_1_12_inst_addr                             "0x01E9"
#define  set_SRNN_wdsr_layer3_3x3_weights_1_12_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_1_12_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_1_12_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_1_12_reg))
#define  SRNN_wdsr_layer3_3x3_weights_1_12_layer3_weight_12_shift                (0)
#define  SRNN_wdsr_layer3_3x3_weights_1_12_layer3_weight_12_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_1_12_layer3_weight_12(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_1_12_get_layer3_weight_12(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_1_20                                      0x181AB718
#define  SRNN_wdsr_layer3_3x3_weights_1_20_reg_addr                              "0xB81AB718"
#define  SRNN_wdsr_layer3_3x3_weights_1_20_reg                                   0xB81AB718
#define  SRNN_wdsr_layer3_3x3_weights_1_20_inst_addr                             "0x01EA"
#define  set_SRNN_wdsr_layer3_3x3_weights_1_20_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_1_20_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_1_20_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_1_20_reg))
#define  SRNN_wdsr_layer3_3x3_weights_1_20_layer3_weight_20_shift                (0)
#define  SRNN_wdsr_layer3_3x3_weights_1_20_layer3_weight_20_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_1_20_layer3_weight_20(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_1_20_get_layer3_weight_20(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_1_21                                      0x181AB71C
#define  SRNN_wdsr_layer3_3x3_weights_1_21_reg_addr                              "0xB81AB71C"
#define  SRNN_wdsr_layer3_3x3_weights_1_21_reg                                   0xB81AB71C
#define  SRNN_wdsr_layer3_3x3_weights_1_21_inst_addr                             "0x01EB"
#define  set_SRNN_wdsr_layer3_3x3_weights_1_21_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_1_21_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_1_21_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_1_21_reg))
#define  SRNN_wdsr_layer3_3x3_weights_1_21_layer3_weight_21_shift                (0)
#define  SRNN_wdsr_layer3_3x3_weights_1_21_layer3_weight_21_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_1_21_layer3_weight_21(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_1_21_get_layer3_weight_21(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_1_22                                      0x181AB720
#define  SRNN_wdsr_layer3_3x3_weights_1_22_reg_addr                              "0xB81AB720"
#define  SRNN_wdsr_layer3_3x3_weights_1_22_reg                                   0xB81AB720
#define  SRNN_wdsr_layer3_3x3_weights_1_22_inst_addr                             "0x01EC"
#define  set_SRNN_wdsr_layer3_3x3_weights_1_22_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_1_22_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_1_22_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_1_22_reg))
#define  SRNN_wdsr_layer3_3x3_weights_1_22_layer3_weight_22_shift                (0)
#define  SRNN_wdsr_layer3_3x3_weights_1_22_layer3_weight_22_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_1_22_layer3_weight_22(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_1_22_get_layer3_weight_22(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_2_00                                      0x181AB724
#define  SRNN_wdsr_layer3_3x3_weights_2_00_reg_addr                              "0xB81AB724"
#define  SRNN_wdsr_layer3_3x3_weights_2_00_reg                                   0xB81AB724
#define  SRNN_wdsr_layer3_3x3_weights_2_00_inst_addr                             "0x01ED"
#define  set_SRNN_wdsr_layer3_3x3_weights_2_00_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_2_00_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_2_00_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_2_00_reg))
#define  SRNN_wdsr_layer3_3x3_weights_2_00_layer3_weight_00_shift                (0)
#define  SRNN_wdsr_layer3_3x3_weights_2_00_layer3_weight_00_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_2_00_layer3_weight_00(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_2_00_get_layer3_weight_00(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_2_01                                      0x181AB728
#define  SRNN_wdsr_layer3_3x3_weights_2_01_reg_addr                              "0xB81AB728"
#define  SRNN_wdsr_layer3_3x3_weights_2_01_reg                                   0xB81AB728
#define  SRNN_wdsr_layer3_3x3_weights_2_01_inst_addr                             "0x01EE"
#define  set_SRNN_wdsr_layer3_3x3_weights_2_01_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_2_01_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_2_01_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_2_01_reg))
#define  SRNN_wdsr_layer3_3x3_weights_2_01_layer3_weight_01_shift                (0)
#define  SRNN_wdsr_layer3_3x3_weights_2_01_layer3_weight_01_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_2_01_layer3_weight_01(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_2_01_get_layer3_weight_01(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_2_02                                      0x181AB72C
#define  SRNN_wdsr_layer3_3x3_weights_2_02_reg_addr                              "0xB81AB72C"
#define  SRNN_wdsr_layer3_3x3_weights_2_02_reg                                   0xB81AB72C
#define  SRNN_wdsr_layer3_3x3_weights_2_02_inst_addr                             "0x01EF"
#define  set_SRNN_wdsr_layer3_3x3_weights_2_02_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_2_02_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_2_02_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_2_02_reg))
#define  SRNN_wdsr_layer3_3x3_weights_2_02_layer3_weight_02_shift                (0)
#define  SRNN_wdsr_layer3_3x3_weights_2_02_layer3_weight_02_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_2_02_layer3_weight_02(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_2_02_get_layer3_weight_02(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_2_10                                      0x181AB730
#define  SRNN_wdsr_layer3_3x3_weights_2_10_reg_addr                              "0xB81AB730"
#define  SRNN_wdsr_layer3_3x3_weights_2_10_reg                                   0xB81AB730
#define  SRNN_wdsr_layer3_3x3_weights_2_10_inst_addr                             "0x01F0"
#define  set_SRNN_wdsr_layer3_3x3_weights_2_10_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_2_10_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_2_10_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_2_10_reg))
#define  SRNN_wdsr_layer3_3x3_weights_2_10_layer3_weight_10_shift                (0)
#define  SRNN_wdsr_layer3_3x3_weights_2_10_layer3_weight_10_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_2_10_layer3_weight_10(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_2_10_get_layer3_weight_10(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_2_11                                      0x181AB734
#define  SRNN_wdsr_layer3_3x3_weights_2_11_reg_addr                              "0xB81AB734"
#define  SRNN_wdsr_layer3_3x3_weights_2_11_reg                                   0xB81AB734
#define  SRNN_wdsr_layer3_3x3_weights_2_11_inst_addr                             "0x01F1"
#define  set_SRNN_wdsr_layer3_3x3_weights_2_11_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_2_11_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_2_11_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_2_11_reg))
#define  SRNN_wdsr_layer3_3x3_weights_2_11_layer3_weight_11_shift                (0)
#define  SRNN_wdsr_layer3_3x3_weights_2_11_layer3_weight_11_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_2_11_layer3_weight_11(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_2_11_get_layer3_weight_11(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_2_12                                      0x181AB738
#define  SRNN_wdsr_layer3_3x3_weights_2_12_reg_addr                              "0xB81AB738"
#define  SRNN_wdsr_layer3_3x3_weights_2_12_reg                                   0xB81AB738
#define  SRNN_wdsr_layer3_3x3_weights_2_12_inst_addr                             "0x01F2"
#define  set_SRNN_wdsr_layer3_3x3_weights_2_12_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_2_12_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_2_12_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_2_12_reg))
#define  SRNN_wdsr_layer3_3x3_weights_2_12_layer3_weight_12_shift                (0)
#define  SRNN_wdsr_layer3_3x3_weights_2_12_layer3_weight_12_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_2_12_layer3_weight_12(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_2_12_get_layer3_weight_12(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_2_20                                      0x181AB73C
#define  SRNN_wdsr_layer3_3x3_weights_2_20_reg_addr                              "0xB81AB73C"
#define  SRNN_wdsr_layer3_3x3_weights_2_20_reg                                   0xB81AB73C
#define  SRNN_wdsr_layer3_3x3_weights_2_20_inst_addr                             "0x01F3"
#define  set_SRNN_wdsr_layer3_3x3_weights_2_20_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_2_20_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_2_20_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_2_20_reg))
#define  SRNN_wdsr_layer3_3x3_weights_2_20_layer3_weight_20_shift                (0)
#define  SRNN_wdsr_layer3_3x3_weights_2_20_layer3_weight_20_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_2_20_layer3_weight_20(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_2_20_get_layer3_weight_20(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_2_21                                      0x181AB740
#define  SRNN_wdsr_layer3_3x3_weights_2_21_reg_addr                              "0xB81AB740"
#define  SRNN_wdsr_layer3_3x3_weights_2_21_reg                                   0xB81AB740
#define  SRNN_wdsr_layer3_3x3_weights_2_21_inst_addr                             "0x01F4"
#define  set_SRNN_wdsr_layer3_3x3_weights_2_21_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_2_21_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_2_21_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_2_21_reg))
#define  SRNN_wdsr_layer3_3x3_weights_2_21_layer3_weight_21_shift                (0)
#define  SRNN_wdsr_layer3_3x3_weights_2_21_layer3_weight_21_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_2_21_layer3_weight_21(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_2_21_get_layer3_weight_21(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_2_22                                      0x181AB744
#define  SRNN_wdsr_layer3_3x3_weights_2_22_reg_addr                              "0xB81AB744"
#define  SRNN_wdsr_layer3_3x3_weights_2_22_reg                                   0xB81AB744
#define  SRNN_wdsr_layer3_3x3_weights_2_22_inst_addr                             "0x01F5"
#define  set_SRNN_wdsr_layer3_3x3_weights_2_22_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_2_22_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_2_22_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_2_22_reg))
#define  SRNN_wdsr_layer3_3x3_weights_2_22_layer3_weight_22_shift                (0)
#define  SRNN_wdsr_layer3_3x3_weights_2_22_layer3_weight_22_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_2_22_layer3_weight_22(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_2_22_get_layer3_weight_22(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_3_00                                      0x181AB748
#define  SRNN_wdsr_layer3_3x3_weights_3_00_reg_addr                              "0xB81AB748"
#define  SRNN_wdsr_layer3_3x3_weights_3_00_reg                                   0xB81AB748
#define  SRNN_wdsr_layer3_3x3_weights_3_00_inst_addr                             "0x01F6"
#define  set_SRNN_wdsr_layer3_3x3_weights_3_00_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_3_00_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_3_00_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_3_00_reg))
#define  SRNN_wdsr_layer3_3x3_weights_3_00_layer3_weight_00_shift                (0)
#define  SRNN_wdsr_layer3_3x3_weights_3_00_layer3_weight_00_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_3_00_layer3_weight_00(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_3_00_get_layer3_weight_00(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_3_01                                      0x181AB74C
#define  SRNN_wdsr_layer3_3x3_weights_3_01_reg_addr                              "0xB81AB74C"
#define  SRNN_wdsr_layer3_3x3_weights_3_01_reg                                   0xB81AB74C
#define  SRNN_wdsr_layer3_3x3_weights_3_01_inst_addr                             "0x01F7"
#define  set_SRNN_wdsr_layer3_3x3_weights_3_01_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_3_01_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_3_01_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_3_01_reg))
#define  SRNN_wdsr_layer3_3x3_weights_3_01_layer3_weight_01_shift                (0)
#define  SRNN_wdsr_layer3_3x3_weights_3_01_layer3_weight_01_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_3_01_layer3_weight_01(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_3_01_get_layer3_weight_01(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_3_02                                      0x181AB750
#define  SRNN_wdsr_layer3_3x3_weights_3_02_reg_addr                              "0xB81AB750"
#define  SRNN_wdsr_layer3_3x3_weights_3_02_reg                                   0xB81AB750
#define  SRNN_wdsr_layer3_3x3_weights_3_02_inst_addr                             "0x01F8"
#define  set_SRNN_wdsr_layer3_3x3_weights_3_02_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_3_02_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_3_02_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_3_02_reg))
#define  SRNN_wdsr_layer3_3x3_weights_3_02_layer3_weight_02_shift                (0)
#define  SRNN_wdsr_layer3_3x3_weights_3_02_layer3_weight_02_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_3_02_layer3_weight_02(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_3_02_get_layer3_weight_02(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_3_10                                      0x181AB754
#define  SRNN_wdsr_layer3_3x3_weights_3_10_reg_addr                              "0xB81AB754"
#define  SRNN_wdsr_layer3_3x3_weights_3_10_reg                                   0xB81AB754
#define  SRNN_wdsr_layer3_3x3_weights_3_10_inst_addr                             "0x01F9"
#define  set_SRNN_wdsr_layer3_3x3_weights_3_10_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_3_10_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_3_10_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_3_10_reg))
#define  SRNN_wdsr_layer3_3x3_weights_3_10_layer3_weight_10_shift                (0)
#define  SRNN_wdsr_layer3_3x3_weights_3_10_layer3_weight_10_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_3_10_layer3_weight_10(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_3_10_get_layer3_weight_10(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_3_11                                      0x181AB758
#define  SRNN_wdsr_layer3_3x3_weights_3_11_reg_addr                              "0xB81AB758"
#define  SRNN_wdsr_layer3_3x3_weights_3_11_reg                                   0xB81AB758
#define  SRNN_wdsr_layer3_3x3_weights_3_11_inst_addr                             "0x01FA"
#define  set_SRNN_wdsr_layer3_3x3_weights_3_11_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_3_11_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_3_11_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_3_11_reg))
#define  SRNN_wdsr_layer3_3x3_weights_3_11_layer3_weight_11_shift                (0)
#define  SRNN_wdsr_layer3_3x3_weights_3_11_layer3_weight_11_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_3_11_layer3_weight_11(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_3_11_get_layer3_weight_11(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_3_12                                      0x181AB75C
#define  SRNN_wdsr_layer3_3x3_weights_3_12_reg_addr                              "0xB81AB75C"
#define  SRNN_wdsr_layer3_3x3_weights_3_12_reg                                   0xB81AB75C
#define  SRNN_wdsr_layer3_3x3_weights_3_12_inst_addr                             "0x01FB"
#define  set_SRNN_wdsr_layer3_3x3_weights_3_12_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_3_12_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_3_12_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_3_12_reg))
#define  SRNN_wdsr_layer3_3x3_weights_3_12_layer3_weight_12_shift                (0)
#define  SRNN_wdsr_layer3_3x3_weights_3_12_layer3_weight_12_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_3_12_layer3_weight_12(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_3_12_get_layer3_weight_12(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_3_20                                      0x181AB760
#define  SRNN_wdsr_layer3_3x3_weights_3_20_reg_addr                              "0xB81AB760"
#define  SRNN_wdsr_layer3_3x3_weights_3_20_reg                                   0xB81AB760
#define  SRNN_wdsr_layer3_3x3_weights_3_20_inst_addr                             "0x01FC"
#define  set_SRNN_wdsr_layer3_3x3_weights_3_20_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_3_20_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_3_20_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_3_20_reg))
#define  SRNN_wdsr_layer3_3x3_weights_3_20_layer3_weight_20_shift                (0)
#define  SRNN_wdsr_layer3_3x3_weights_3_20_layer3_weight_20_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_3_20_layer3_weight_20(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_3_20_get_layer3_weight_20(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_3_21                                      0x181AB764
#define  SRNN_wdsr_layer3_3x3_weights_3_21_reg_addr                              "0xB81AB764"
#define  SRNN_wdsr_layer3_3x3_weights_3_21_reg                                   0xB81AB764
#define  SRNN_wdsr_layer3_3x3_weights_3_21_inst_addr                             "0x01FD"
#define  set_SRNN_wdsr_layer3_3x3_weights_3_21_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_3_21_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_3_21_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_3_21_reg))
#define  SRNN_wdsr_layer3_3x3_weights_3_21_layer3_weight_21_shift                (0)
#define  SRNN_wdsr_layer3_3x3_weights_3_21_layer3_weight_21_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_3_21_layer3_weight_21(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_3_21_get_layer3_weight_21(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_3_22                                      0x181AB768
#define  SRNN_wdsr_layer3_3x3_weights_3_22_reg_addr                              "0xB81AB768"
#define  SRNN_wdsr_layer3_3x3_weights_3_22_reg                                   0xB81AB768
#define  SRNN_wdsr_layer3_3x3_weights_3_22_inst_addr                             "0x01FE"
#define  set_SRNN_wdsr_layer3_3x3_weights_3_22_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_3_22_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_3_22_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_3_22_reg))
#define  SRNN_wdsr_layer3_3x3_weights_3_22_layer3_weight_22_shift                (0)
#define  SRNN_wdsr_layer3_3x3_weights_3_22_layer3_weight_22_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_3_22_layer3_weight_22(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_3_22_get_layer3_weight_22(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_4_00                                      0x181AB76C
#define  SRNN_wdsr_layer3_3x3_weights_4_00_reg_addr                              "0xB81AB76C"
#define  SRNN_wdsr_layer3_3x3_weights_4_00_reg                                   0xB81AB76C
#define  SRNN_wdsr_layer3_3x3_weights_4_00_inst_addr                             "0x01FF"
#define  set_SRNN_wdsr_layer3_3x3_weights_4_00_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_4_00_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_4_00_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_4_00_reg))
#define  SRNN_wdsr_layer3_3x3_weights_4_00_layer3_weight_00_shift                (0)
#define  SRNN_wdsr_layer3_3x3_weights_4_00_layer3_weight_00_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_4_00_layer3_weight_00(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_4_00_get_layer3_weight_00(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_4_01                                      0x181AB770
#define  SRNN_wdsr_layer3_3x3_weights_4_01_reg_addr                              "0xB81AB770"
#define  SRNN_wdsr_layer3_3x3_weights_4_01_reg                                   0xB81AB770
#define  SRNN_wdsr_layer3_3x3_weights_4_01_inst_addr                             "0x0200"
#define  set_SRNN_wdsr_layer3_3x3_weights_4_01_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_4_01_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_4_01_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_4_01_reg))
#define  SRNN_wdsr_layer3_3x3_weights_4_01_layer3_weight_01_shift                (0)
#define  SRNN_wdsr_layer3_3x3_weights_4_01_layer3_weight_01_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_4_01_layer3_weight_01(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_4_01_get_layer3_weight_01(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_4_02                                      0x181AB774
#define  SRNN_wdsr_layer3_3x3_weights_4_02_reg_addr                              "0xB81AB774"
#define  SRNN_wdsr_layer3_3x3_weights_4_02_reg                                   0xB81AB774
#define  SRNN_wdsr_layer3_3x3_weights_4_02_inst_addr                             "0x0201"
#define  set_SRNN_wdsr_layer3_3x3_weights_4_02_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_4_02_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_4_02_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_4_02_reg))
#define  SRNN_wdsr_layer3_3x3_weights_4_02_layer3_weight_02_shift                (0)
#define  SRNN_wdsr_layer3_3x3_weights_4_02_layer3_weight_02_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_4_02_layer3_weight_02(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_4_02_get_layer3_weight_02(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_4_10                                      0x181AB778
#define  SRNN_wdsr_layer3_3x3_weights_4_10_reg_addr                              "0xB81AB778"
#define  SRNN_wdsr_layer3_3x3_weights_4_10_reg                                   0xB81AB778
#define  SRNN_wdsr_layer3_3x3_weights_4_10_inst_addr                             "0x0202"
#define  set_SRNN_wdsr_layer3_3x3_weights_4_10_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_4_10_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_4_10_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_4_10_reg))
#define  SRNN_wdsr_layer3_3x3_weights_4_10_layer3_weight_10_shift                (0)
#define  SRNN_wdsr_layer3_3x3_weights_4_10_layer3_weight_10_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_4_10_layer3_weight_10(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_4_10_get_layer3_weight_10(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_4_11                                      0x181AB77C
#define  SRNN_wdsr_layer3_3x3_weights_4_11_reg_addr                              "0xB81AB77C"
#define  SRNN_wdsr_layer3_3x3_weights_4_11_reg                                   0xB81AB77C
#define  SRNN_wdsr_layer3_3x3_weights_4_11_inst_addr                             "0x0203"
#define  set_SRNN_wdsr_layer3_3x3_weights_4_11_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_4_11_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_4_11_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_4_11_reg))
#define  SRNN_wdsr_layer3_3x3_weights_4_11_layer3_weight_11_shift                (0)
#define  SRNN_wdsr_layer3_3x3_weights_4_11_layer3_weight_11_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_4_11_layer3_weight_11(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_4_11_get_layer3_weight_11(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_4_12                                      0x181AB780
#define  SRNN_wdsr_layer3_3x3_weights_4_12_reg_addr                              "0xB81AB780"
#define  SRNN_wdsr_layer3_3x3_weights_4_12_reg                                   0xB81AB780
#define  SRNN_wdsr_layer3_3x3_weights_4_12_inst_addr                             "0x0204"
#define  set_SRNN_wdsr_layer3_3x3_weights_4_12_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_4_12_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_4_12_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_4_12_reg))
#define  SRNN_wdsr_layer3_3x3_weights_4_12_layer3_weight_12_shift                (0)
#define  SRNN_wdsr_layer3_3x3_weights_4_12_layer3_weight_12_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_4_12_layer3_weight_12(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_4_12_get_layer3_weight_12(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_4_20                                      0x181AB784
#define  SRNN_wdsr_layer3_3x3_weights_4_20_reg_addr                              "0xB81AB784"
#define  SRNN_wdsr_layer3_3x3_weights_4_20_reg                                   0xB81AB784
#define  SRNN_wdsr_layer3_3x3_weights_4_20_inst_addr                             "0x0205"
#define  set_SRNN_wdsr_layer3_3x3_weights_4_20_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_4_20_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_4_20_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_4_20_reg))
#define  SRNN_wdsr_layer3_3x3_weights_4_20_layer3_weight_20_shift                (0)
#define  SRNN_wdsr_layer3_3x3_weights_4_20_layer3_weight_20_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_4_20_layer3_weight_20(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_4_20_get_layer3_weight_20(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_4_21                                      0x181AB788
#define  SRNN_wdsr_layer3_3x3_weights_4_21_reg_addr                              "0xB81AB788"
#define  SRNN_wdsr_layer3_3x3_weights_4_21_reg                                   0xB81AB788
#define  SRNN_wdsr_layer3_3x3_weights_4_21_inst_addr                             "0x0206"
#define  set_SRNN_wdsr_layer3_3x3_weights_4_21_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_4_21_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_4_21_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_4_21_reg))
#define  SRNN_wdsr_layer3_3x3_weights_4_21_layer3_weight_21_shift                (0)
#define  SRNN_wdsr_layer3_3x3_weights_4_21_layer3_weight_21_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_4_21_layer3_weight_21(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_4_21_get_layer3_weight_21(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_4_22                                      0x181AB78C
#define  SRNN_wdsr_layer3_3x3_weights_4_22_reg_addr                              "0xB81AB78C"
#define  SRNN_wdsr_layer3_3x3_weights_4_22_reg                                   0xB81AB78C
#define  SRNN_wdsr_layer3_3x3_weights_4_22_inst_addr                             "0x0207"
#define  set_SRNN_wdsr_layer3_3x3_weights_4_22_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_4_22_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_4_22_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_4_22_reg))
#define  SRNN_wdsr_layer3_3x3_weights_4_22_layer3_weight_22_shift                (0)
#define  SRNN_wdsr_layer3_3x3_weights_4_22_layer3_weight_22_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_4_22_layer3_weight_22(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_4_22_get_layer3_weight_22(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_5_00                                      0x181AB790
#define  SRNN_wdsr_layer3_3x3_weights_5_00_reg_addr                              "0xB81AB790"
#define  SRNN_wdsr_layer3_3x3_weights_5_00_reg                                   0xB81AB790
#define  SRNN_wdsr_layer3_3x3_weights_5_00_inst_addr                             "0x0208"
#define  set_SRNN_wdsr_layer3_3x3_weights_5_00_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_5_00_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_5_00_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_5_00_reg))
#define  SRNN_wdsr_layer3_3x3_weights_5_00_layer3_weight_00_shift                (0)
#define  SRNN_wdsr_layer3_3x3_weights_5_00_layer3_weight_00_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_5_00_layer3_weight_00(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_5_00_get_layer3_weight_00(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_5_01                                      0x181AB794
#define  SRNN_wdsr_layer3_3x3_weights_5_01_reg_addr                              "0xB81AB794"
#define  SRNN_wdsr_layer3_3x3_weights_5_01_reg                                   0xB81AB794
#define  SRNN_wdsr_layer3_3x3_weights_5_01_inst_addr                             "0x0209"
#define  set_SRNN_wdsr_layer3_3x3_weights_5_01_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_5_01_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_5_01_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_5_01_reg))
#define  SRNN_wdsr_layer3_3x3_weights_5_01_layer3_weight_01_shift                (0)
#define  SRNN_wdsr_layer3_3x3_weights_5_01_layer3_weight_01_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_5_01_layer3_weight_01(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_5_01_get_layer3_weight_01(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_5_02                                      0x181AB798
#define  SRNN_wdsr_layer3_3x3_weights_5_02_reg_addr                              "0xB81AB798"
#define  SRNN_wdsr_layer3_3x3_weights_5_02_reg                                   0xB81AB798
#define  SRNN_wdsr_layer3_3x3_weights_5_02_inst_addr                             "0x020A"
#define  set_SRNN_wdsr_layer3_3x3_weights_5_02_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_5_02_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_5_02_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_5_02_reg))
#define  SRNN_wdsr_layer3_3x3_weights_5_02_layer3_weight_02_shift                (0)
#define  SRNN_wdsr_layer3_3x3_weights_5_02_layer3_weight_02_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_5_02_layer3_weight_02(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_5_02_get_layer3_weight_02(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_5_10                                      0x181AB79C
#define  SRNN_wdsr_layer3_3x3_weights_5_10_reg_addr                              "0xB81AB79C"
#define  SRNN_wdsr_layer3_3x3_weights_5_10_reg                                   0xB81AB79C
#define  SRNN_wdsr_layer3_3x3_weights_5_10_inst_addr                             "0x020B"
#define  set_SRNN_wdsr_layer3_3x3_weights_5_10_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_5_10_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_5_10_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_5_10_reg))
#define  SRNN_wdsr_layer3_3x3_weights_5_10_layer3_weight_10_shift                (0)
#define  SRNN_wdsr_layer3_3x3_weights_5_10_layer3_weight_10_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_5_10_layer3_weight_10(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_5_10_get_layer3_weight_10(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_5_11                                      0x181AB7A0
#define  SRNN_wdsr_layer3_3x3_weights_5_11_reg_addr                              "0xB81AB7A0"
#define  SRNN_wdsr_layer3_3x3_weights_5_11_reg                                   0xB81AB7A0
#define  SRNN_wdsr_layer3_3x3_weights_5_11_inst_addr                             "0x020C"
#define  set_SRNN_wdsr_layer3_3x3_weights_5_11_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_5_11_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_5_11_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_5_11_reg))
#define  SRNN_wdsr_layer3_3x3_weights_5_11_layer3_weight_11_shift                (0)
#define  SRNN_wdsr_layer3_3x3_weights_5_11_layer3_weight_11_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_5_11_layer3_weight_11(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_5_11_get_layer3_weight_11(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_5_12                                      0x181AB7A4
#define  SRNN_wdsr_layer3_3x3_weights_5_12_reg_addr                              "0xB81AB7A4"
#define  SRNN_wdsr_layer3_3x3_weights_5_12_reg                                   0xB81AB7A4
#define  SRNN_wdsr_layer3_3x3_weights_5_12_inst_addr                             "0x020D"
#define  set_SRNN_wdsr_layer3_3x3_weights_5_12_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_5_12_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_5_12_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_5_12_reg))
#define  SRNN_wdsr_layer3_3x3_weights_5_12_layer3_weight_12_shift                (0)
#define  SRNN_wdsr_layer3_3x3_weights_5_12_layer3_weight_12_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_5_12_layer3_weight_12(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_5_12_get_layer3_weight_12(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_5_20                                      0x181AB7A8
#define  SRNN_wdsr_layer3_3x3_weights_5_20_reg_addr                              "0xB81AB7A8"
#define  SRNN_wdsr_layer3_3x3_weights_5_20_reg                                   0xB81AB7A8
#define  SRNN_wdsr_layer3_3x3_weights_5_20_inst_addr                             "0x020E"
#define  set_SRNN_wdsr_layer3_3x3_weights_5_20_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_5_20_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_5_20_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_5_20_reg))
#define  SRNN_wdsr_layer3_3x3_weights_5_20_layer3_weight_20_shift                (0)
#define  SRNN_wdsr_layer3_3x3_weights_5_20_layer3_weight_20_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_5_20_layer3_weight_20(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_5_20_get_layer3_weight_20(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_5_21                                      0x181AB7AC
#define  SRNN_wdsr_layer3_3x3_weights_5_21_reg_addr                              "0xB81AB7AC"
#define  SRNN_wdsr_layer3_3x3_weights_5_21_reg                                   0xB81AB7AC
#define  SRNN_wdsr_layer3_3x3_weights_5_21_inst_addr                             "0x020F"
#define  set_SRNN_wdsr_layer3_3x3_weights_5_21_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_5_21_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_5_21_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_5_21_reg))
#define  SRNN_wdsr_layer3_3x3_weights_5_21_layer3_weight_21_shift                (0)
#define  SRNN_wdsr_layer3_3x3_weights_5_21_layer3_weight_21_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_5_21_layer3_weight_21(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_5_21_get_layer3_weight_21(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_5_22                                      0x181AB7B0
#define  SRNN_wdsr_layer3_3x3_weights_5_22_reg_addr                              "0xB81AB7B0"
#define  SRNN_wdsr_layer3_3x3_weights_5_22_reg                                   0xB81AB7B0
#define  SRNN_wdsr_layer3_3x3_weights_5_22_inst_addr                             "0x0210"
#define  set_SRNN_wdsr_layer3_3x3_weights_5_22_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_5_22_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_5_22_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_5_22_reg))
#define  SRNN_wdsr_layer3_3x3_weights_5_22_layer3_weight_22_shift                (0)
#define  SRNN_wdsr_layer3_3x3_weights_5_22_layer3_weight_22_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_5_22_layer3_weight_22(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_5_22_get_layer3_weight_22(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_6_00                                      0x181AB7B4
#define  SRNN_wdsr_layer3_3x3_weights_6_00_reg_addr                              "0xB81AB7B4"
#define  SRNN_wdsr_layer3_3x3_weights_6_00_reg                                   0xB81AB7B4
#define  SRNN_wdsr_layer3_3x3_weights_6_00_inst_addr                             "0x0211"
#define  set_SRNN_wdsr_layer3_3x3_weights_6_00_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_6_00_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_6_00_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_6_00_reg))
#define  SRNN_wdsr_layer3_3x3_weights_6_00_layer3_weight_00_shift                (0)
#define  SRNN_wdsr_layer3_3x3_weights_6_00_layer3_weight_00_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_6_00_layer3_weight_00(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_6_00_get_layer3_weight_00(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_6_01                                      0x181AB7B8
#define  SRNN_wdsr_layer3_3x3_weights_6_01_reg_addr                              "0xB81AB7B8"
#define  SRNN_wdsr_layer3_3x3_weights_6_01_reg                                   0xB81AB7B8
#define  SRNN_wdsr_layer3_3x3_weights_6_01_inst_addr                             "0x0212"
#define  set_SRNN_wdsr_layer3_3x3_weights_6_01_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_6_01_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_6_01_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_6_01_reg))
#define  SRNN_wdsr_layer3_3x3_weights_6_01_layer3_weight_01_shift                (0)
#define  SRNN_wdsr_layer3_3x3_weights_6_01_layer3_weight_01_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_6_01_layer3_weight_01(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_6_01_get_layer3_weight_01(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_6_02                                      0x181AB7BC
#define  SRNN_wdsr_layer3_3x3_weights_6_02_reg_addr                              "0xB81AB7BC"
#define  SRNN_wdsr_layer3_3x3_weights_6_02_reg                                   0xB81AB7BC
#define  SRNN_wdsr_layer3_3x3_weights_6_02_inst_addr                             "0x0213"
#define  set_SRNN_wdsr_layer3_3x3_weights_6_02_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_6_02_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_6_02_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_6_02_reg))
#define  SRNN_wdsr_layer3_3x3_weights_6_02_layer3_weight_02_shift                (0)
#define  SRNN_wdsr_layer3_3x3_weights_6_02_layer3_weight_02_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_6_02_layer3_weight_02(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_6_02_get_layer3_weight_02(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_6_10                                      0x181AB7C0
#define  SRNN_wdsr_layer3_3x3_weights_6_10_reg_addr                              "0xB81AB7C0"
#define  SRNN_wdsr_layer3_3x3_weights_6_10_reg                                   0xB81AB7C0
#define  SRNN_wdsr_layer3_3x3_weights_6_10_inst_addr                             "0x0214"
#define  set_SRNN_wdsr_layer3_3x3_weights_6_10_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_6_10_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_6_10_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_6_10_reg))
#define  SRNN_wdsr_layer3_3x3_weights_6_10_layer3_weight_10_shift                (0)
#define  SRNN_wdsr_layer3_3x3_weights_6_10_layer3_weight_10_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_6_10_layer3_weight_10(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_6_10_get_layer3_weight_10(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_6_11                                      0x181AB7C4
#define  SRNN_wdsr_layer3_3x3_weights_6_11_reg_addr                              "0xB81AB7C4"
#define  SRNN_wdsr_layer3_3x3_weights_6_11_reg                                   0xB81AB7C4
#define  SRNN_wdsr_layer3_3x3_weights_6_11_inst_addr                             "0x0215"
#define  set_SRNN_wdsr_layer3_3x3_weights_6_11_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_6_11_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_6_11_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_6_11_reg))
#define  SRNN_wdsr_layer3_3x3_weights_6_11_layer3_weight_11_shift                (0)
#define  SRNN_wdsr_layer3_3x3_weights_6_11_layer3_weight_11_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_6_11_layer3_weight_11(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_6_11_get_layer3_weight_11(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_6_12                                      0x181AB7C8
#define  SRNN_wdsr_layer3_3x3_weights_6_12_reg_addr                              "0xB81AB7C8"
#define  SRNN_wdsr_layer3_3x3_weights_6_12_reg                                   0xB81AB7C8
#define  SRNN_wdsr_layer3_3x3_weights_6_12_inst_addr                             "0x0216"
#define  set_SRNN_wdsr_layer3_3x3_weights_6_12_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_6_12_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_6_12_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_6_12_reg))
#define  SRNN_wdsr_layer3_3x3_weights_6_12_layer3_weight_12_shift                (0)
#define  SRNN_wdsr_layer3_3x3_weights_6_12_layer3_weight_12_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_6_12_layer3_weight_12(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_6_12_get_layer3_weight_12(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_6_20                                      0x181AB7CC
#define  SRNN_wdsr_layer3_3x3_weights_6_20_reg_addr                              "0xB81AB7CC"
#define  SRNN_wdsr_layer3_3x3_weights_6_20_reg                                   0xB81AB7CC
#define  SRNN_wdsr_layer3_3x3_weights_6_20_inst_addr                             "0x0217"
#define  set_SRNN_wdsr_layer3_3x3_weights_6_20_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_6_20_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_6_20_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_6_20_reg))
#define  SRNN_wdsr_layer3_3x3_weights_6_20_layer3_weight_20_shift                (0)
#define  SRNN_wdsr_layer3_3x3_weights_6_20_layer3_weight_20_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_6_20_layer3_weight_20(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_6_20_get_layer3_weight_20(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_6_21                                      0x181AB7D0
#define  SRNN_wdsr_layer3_3x3_weights_6_21_reg_addr                              "0xB81AB7D0"
#define  SRNN_wdsr_layer3_3x3_weights_6_21_reg                                   0xB81AB7D0
#define  SRNN_wdsr_layer3_3x3_weights_6_21_inst_addr                             "0x0218"
#define  set_SRNN_wdsr_layer3_3x3_weights_6_21_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_6_21_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_6_21_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_6_21_reg))
#define  SRNN_wdsr_layer3_3x3_weights_6_21_layer3_weight_21_shift                (0)
#define  SRNN_wdsr_layer3_3x3_weights_6_21_layer3_weight_21_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_6_21_layer3_weight_21(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_6_21_get_layer3_weight_21(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_6_22                                      0x181AB7D4
#define  SRNN_wdsr_layer3_3x3_weights_6_22_reg_addr                              "0xB81AB7D4"
#define  SRNN_wdsr_layer3_3x3_weights_6_22_reg                                   0xB81AB7D4
#define  SRNN_wdsr_layer3_3x3_weights_6_22_inst_addr                             "0x0219"
#define  set_SRNN_wdsr_layer3_3x3_weights_6_22_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_6_22_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_6_22_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_6_22_reg))
#define  SRNN_wdsr_layer3_3x3_weights_6_22_layer3_weight_22_shift                (0)
#define  SRNN_wdsr_layer3_3x3_weights_6_22_layer3_weight_22_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_6_22_layer3_weight_22(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_6_22_get_layer3_weight_22(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_7_00                                      0x181AB7D8
#define  SRNN_wdsr_layer3_3x3_weights_7_00_reg_addr                              "0xB81AB7D8"
#define  SRNN_wdsr_layer3_3x3_weights_7_00_reg                                   0xB81AB7D8
#define  SRNN_wdsr_layer3_3x3_weights_7_00_inst_addr                             "0x021A"
#define  set_SRNN_wdsr_layer3_3x3_weights_7_00_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_7_00_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_7_00_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_7_00_reg))
#define  SRNN_wdsr_layer3_3x3_weights_7_00_layer3_weight_00_shift                (0)
#define  SRNN_wdsr_layer3_3x3_weights_7_00_layer3_weight_00_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_7_00_layer3_weight_00(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_7_00_get_layer3_weight_00(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_7_01                                      0x181AB7DC
#define  SRNN_wdsr_layer3_3x3_weights_7_01_reg_addr                              "0xB81AB7DC"
#define  SRNN_wdsr_layer3_3x3_weights_7_01_reg                                   0xB81AB7DC
#define  SRNN_wdsr_layer3_3x3_weights_7_01_inst_addr                             "0x021B"
#define  set_SRNN_wdsr_layer3_3x3_weights_7_01_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_7_01_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_7_01_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_7_01_reg))
#define  SRNN_wdsr_layer3_3x3_weights_7_01_layer3_weight_01_shift                (0)
#define  SRNN_wdsr_layer3_3x3_weights_7_01_layer3_weight_01_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_7_01_layer3_weight_01(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_7_01_get_layer3_weight_01(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_7_02                                      0x181AB7E0
#define  SRNN_wdsr_layer3_3x3_weights_7_02_reg_addr                              "0xB81AB7E0"
#define  SRNN_wdsr_layer3_3x3_weights_7_02_reg                                   0xB81AB7E0
#define  SRNN_wdsr_layer3_3x3_weights_7_02_inst_addr                             "0x021C"
#define  set_SRNN_wdsr_layer3_3x3_weights_7_02_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_7_02_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_7_02_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_7_02_reg))
#define  SRNN_wdsr_layer3_3x3_weights_7_02_layer3_weight_02_shift                (0)
#define  SRNN_wdsr_layer3_3x3_weights_7_02_layer3_weight_02_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_7_02_layer3_weight_02(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_7_02_get_layer3_weight_02(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_7_10                                      0x181AB7E4
#define  SRNN_wdsr_layer3_3x3_weights_7_10_reg_addr                              "0xB81AB7E4"
#define  SRNN_wdsr_layer3_3x3_weights_7_10_reg                                   0xB81AB7E4
#define  SRNN_wdsr_layer3_3x3_weights_7_10_inst_addr                             "0x021D"
#define  set_SRNN_wdsr_layer3_3x3_weights_7_10_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_7_10_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_7_10_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_7_10_reg))
#define  SRNN_wdsr_layer3_3x3_weights_7_10_layer3_weight_10_shift                (0)
#define  SRNN_wdsr_layer3_3x3_weights_7_10_layer3_weight_10_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_7_10_layer3_weight_10(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_7_10_get_layer3_weight_10(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_7_11                                      0x181AB7E8
#define  SRNN_wdsr_layer3_3x3_weights_7_11_reg_addr                              "0xB81AB7E8"
#define  SRNN_wdsr_layer3_3x3_weights_7_11_reg                                   0xB81AB7E8
#define  SRNN_wdsr_layer3_3x3_weights_7_11_inst_addr                             "0x021E"
#define  set_SRNN_wdsr_layer3_3x3_weights_7_11_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_7_11_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_7_11_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_7_11_reg))
#define  SRNN_wdsr_layer3_3x3_weights_7_11_layer3_weight_11_shift                (0)
#define  SRNN_wdsr_layer3_3x3_weights_7_11_layer3_weight_11_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_7_11_layer3_weight_11(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_7_11_get_layer3_weight_11(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_7_12                                      0x181AB7EC
#define  SRNN_wdsr_layer3_3x3_weights_7_12_reg_addr                              "0xB81AB7EC"
#define  SRNN_wdsr_layer3_3x3_weights_7_12_reg                                   0xB81AB7EC
#define  SRNN_wdsr_layer3_3x3_weights_7_12_inst_addr                             "0x021F"
#define  set_SRNN_wdsr_layer3_3x3_weights_7_12_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_7_12_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_7_12_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_7_12_reg))
#define  SRNN_wdsr_layer3_3x3_weights_7_12_layer3_weight_12_shift                (0)
#define  SRNN_wdsr_layer3_3x3_weights_7_12_layer3_weight_12_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_7_12_layer3_weight_12(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_7_12_get_layer3_weight_12(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_7_20                                      0x181AB7F0
#define  SRNN_wdsr_layer3_3x3_weights_7_20_reg_addr                              "0xB81AB7F0"
#define  SRNN_wdsr_layer3_3x3_weights_7_20_reg                                   0xB81AB7F0
#define  SRNN_wdsr_layer3_3x3_weights_7_20_inst_addr                             "0x0220"
#define  set_SRNN_wdsr_layer3_3x3_weights_7_20_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_7_20_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_7_20_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_7_20_reg))
#define  SRNN_wdsr_layer3_3x3_weights_7_20_layer3_weight_20_shift                (0)
#define  SRNN_wdsr_layer3_3x3_weights_7_20_layer3_weight_20_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_7_20_layer3_weight_20(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_7_20_get_layer3_weight_20(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_7_21                                      0x181AB7F4
#define  SRNN_wdsr_layer3_3x3_weights_7_21_reg_addr                              "0xB81AB7F4"
#define  SRNN_wdsr_layer3_3x3_weights_7_21_reg                                   0xB81AB7F4
#define  SRNN_wdsr_layer3_3x3_weights_7_21_inst_addr                             "0x0221"
#define  set_SRNN_wdsr_layer3_3x3_weights_7_21_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_7_21_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_7_21_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_7_21_reg))
#define  SRNN_wdsr_layer3_3x3_weights_7_21_layer3_weight_21_shift                (0)
#define  SRNN_wdsr_layer3_3x3_weights_7_21_layer3_weight_21_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_7_21_layer3_weight_21(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_7_21_get_layer3_weight_21(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_7_22                                      0x181AB7F8
#define  SRNN_wdsr_layer3_3x3_weights_7_22_reg_addr                              "0xB81AB7F8"
#define  SRNN_wdsr_layer3_3x3_weights_7_22_reg                                   0xB81AB7F8
#define  SRNN_wdsr_layer3_3x3_weights_7_22_inst_addr                             "0x0222"
#define  set_SRNN_wdsr_layer3_3x3_weights_7_22_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_7_22_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_7_22_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_7_22_reg))
#define  SRNN_wdsr_layer3_3x3_weights_7_22_layer3_weight_22_shift                (0)
#define  SRNN_wdsr_layer3_3x3_weights_7_22_layer3_weight_22_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_7_22_layer3_weight_22(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_7_22_get_layer3_weight_22(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_8_00                                      0x181AB7FC
#define  SRNN_wdsr_layer3_3x3_weights_8_00_reg_addr                              "0xB81AB7FC"
#define  SRNN_wdsr_layer3_3x3_weights_8_00_reg                                   0xB81AB7FC
#define  SRNN_wdsr_layer3_3x3_weights_8_00_inst_addr                             "0x0223"
#define  set_SRNN_wdsr_layer3_3x3_weights_8_00_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_8_00_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_8_00_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_8_00_reg))
#define  SRNN_wdsr_layer3_3x3_weights_8_00_layer3_weight_00_shift                (0)
#define  SRNN_wdsr_layer3_3x3_weights_8_00_layer3_weight_00_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_8_00_layer3_weight_00(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_8_00_get_layer3_weight_00(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_8_01                                      0x181AB800
#define  SRNN_wdsr_layer3_3x3_weights_8_01_reg_addr                              "0xB81AB800"
#define  SRNN_wdsr_layer3_3x3_weights_8_01_reg                                   0xB81AB800
#define  SRNN_wdsr_layer3_3x3_weights_8_01_inst_addr                             "0x0224"
#define  set_SRNN_wdsr_layer3_3x3_weights_8_01_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_8_01_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_8_01_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_8_01_reg))
#define  SRNN_wdsr_layer3_3x3_weights_8_01_layer3_weight_01_shift                (0)
#define  SRNN_wdsr_layer3_3x3_weights_8_01_layer3_weight_01_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_8_01_layer3_weight_01(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_8_01_get_layer3_weight_01(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_8_02                                      0x181AB804
#define  SRNN_wdsr_layer3_3x3_weights_8_02_reg_addr                              "0xB81AB804"
#define  SRNN_wdsr_layer3_3x3_weights_8_02_reg                                   0xB81AB804
#define  SRNN_wdsr_layer3_3x3_weights_8_02_inst_addr                             "0x0225"
#define  set_SRNN_wdsr_layer3_3x3_weights_8_02_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_8_02_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_8_02_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_8_02_reg))
#define  SRNN_wdsr_layer3_3x3_weights_8_02_layer3_weight_02_shift                (0)
#define  SRNN_wdsr_layer3_3x3_weights_8_02_layer3_weight_02_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_8_02_layer3_weight_02(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_8_02_get_layer3_weight_02(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_8_10                                      0x181AB808
#define  SRNN_wdsr_layer3_3x3_weights_8_10_reg_addr                              "0xB81AB808"
#define  SRNN_wdsr_layer3_3x3_weights_8_10_reg                                   0xB81AB808
#define  SRNN_wdsr_layer3_3x3_weights_8_10_inst_addr                             "0x0226"
#define  set_SRNN_wdsr_layer3_3x3_weights_8_10_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_8_10_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_8_10_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_8_10_reg))
#define  SRNN_wdsr_layer3_3x3_weights_8_10_layer3_weight_10_shift                (0)
#define  SRNN_wdsr_layer3_3x3_weights_8_10_layer3_weight_10_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_8_10_layer3_weight_10(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_8_10_get_layer3_weight_10(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_8_11                                      0x181AB80C
#define  SRNN_wdsr_layer3_3x3_weights_8_11_reg_addr                              "0xB81AB80C"
#define  SRNN_wdsr_layer3_3x3_weights_8_11_reg                                   0xB81AB80C
#define  SRNN_wdsr_layer3_3x3_weights_8_11_inst_addr                             "0x0227"
#define  set_SRNN_wdsr_layer3_3x3_weights_8_11_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_8_11_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_8_11_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_8_11_reg))
#define  SRNN_wdsr_layer3_3x3_weights_8_11_layer3_weight_11_shift                (0)
#define  SRNN_wdsr_layer3_3x3_weights_8_11_layer3_weight_11_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_8_11_layer3_weight_11(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_8_11_get_layer3_weight_11(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_8_12                                      0x181AB810
#define  SRNN_wdsr_layer3_3x3_weights_8_12_reg_addr                              "0xB81AB810"
#define  SRNN_wdsr_layer3_3x3_weights_8_12_reg                                   0xB81AB810
#define  SRNN_wdsr_layer3_3x3_weights_8_12_inst_addr                             "0x0228"
#define  set_SRNN_wdsr_layer3_3x3_weights_8_12_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_8_12_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_8_12_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_8_12_reg))
#define  SRNN_wdsr_layer3_3x3_weights_8_12_layer3_weight_12_shift                (0)
#define  SRNN_wdsr_layer3_3x3_weights_8_12_layer3_weight_12_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_8_12_layer3_weight_12(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_8_12_get_layer3_weight_12(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_8_20                                      0x181AB814
#define  SRNN_wdsr_layer3_3x3_weights_8_20_reg_addr                              "0xB81AB814"
#define  SRNN_wdsr_layer3_3x3_weights_8_20_reg                                   0xB81AB814
#define  SRNN_wdsr_layer3_3x3_weights_8_20_inst_addr                             "0x0229"
#define  set_SRNN_wdsr_layer3_3x3_weights_8_20_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_8_20_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_8_20_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_8_20_reg))
#define  SRNN_wdsr_layer3_3x3_weights_8_20_layer3_weight_20_shift                (0)
#define  SRNN_wdsr_layer3_3x3_weights_8_20_layer3_weight_20_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_8_20_layer3_weight_20(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_8_20_get_layer3_weight_20(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_8_21                                      0x181AB818
#define  SRNN_wdsr_layer3_3x3_weights_8_21_reg_addr                              "0xB81AB818"
#define  SRNN_wdsr_layer3_3x3_weights_8_21_reg                                   0xB81AB818
#define  SRNN_wdsr_layer3_3x3_weights_8_21_inst_addr                             "0x022A"
#define  set_SRNN_wdsr_layer3_3x3_weights_8_21_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_8_21_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_8_21_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_8_21_reg))
#define  SRNN_wdsr_layer3_3x3_weights_8_21_layer3_weight_21_shift                (0)
#define  SRNN_wdsr_layer3_3x3_weights_8_21_layer3_weight_21_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_8_21_layer3_weight_21(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_8_21_get_layer3_weight_21(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_8_22                                      0x181AB81C
#define  SRNN_wdsr_layer3_3x3_weights_8_22_reg_addr                              "0xB81AB81C"
#define  SRNN_wdsr_layer3_3x3_weights_8_22_reg                                   0xB81AB81C
#define  SRNN_wdsr_layer3_3x3_weights_8_22_inst_addr                             "0x022B"
#define  set_SRNN_wdsr_layer3_3x3_weights_8_22_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_8_22_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_8_22_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_8_22_reg))
#define  SRNN_wdsr_layer3_3x3_weights_8_22_layer3_weight_22_shift                (0)
#define  SRNN_wdsr_layer3_3x3_weights_8_22_layer3_weight_22_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_8_22_layer3_weight_22(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_8_22_get_layer3_weight_22(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_9_00                                      0x181AB820
#define  SRNN_wdsr_layer3_3x3_weights_9_00_reg_addr                              "0xB81AB820"
#define  SRNN_wdsr_layer3_3x3_weights_9_00_reg                                   0xB81AB820
#define  SRNN_wdsr_layer3_3x3_weights_9_00_inst_addr                             "0x022C"
#define  set_SRNN_wdsr_layer3_3x3_weights_9_00_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_9_00_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_9_00_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_9_00_reg))
#define  SRNN_wdsr_layer3_3x3_weights_9_00_layer3_weight_00_shift                (0)
#define  SRNN_wdsr_layer3_3x3_weights_9_00_layer3_weight_00_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_9_00_layer3_weight_00(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_9_00_get_layer3_weight_00(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_9_01                                      0x181AB824
#define  SRNN_wdsr_layer3_3x3_weights_9_01_reg_addr                              "0xB81AB824"
#define  SRNN_wdsr_layer3_3x3_weights_9_01_reg                                   0xB81AB824
#define  SRNN_wdsr_layer3_3x3_weights_9_01_inst_addr                             "0x022D"
#define  set_SRNN_wdsr_layer3_3x3_weights_9_01_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_9_01_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_9_01_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_9_01_reg))
#define  SRNN_wdsr_layer3_3x3_weights_9_01_layer3_weight_01_shift                (0)
#define  SRNN_wdsr_layer3_3x3_weights_9_01_layer3_weight_01_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_9_01_layer3_weight_01(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_9_01_get_layer3_weight_01(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_9_02                                      0x181AB828
#define  SRNN_wdsr_layer3_3x3_weights_9_02_reg_addr                              "0xB81AB828"
#define  SRNN_wdsr_layer3_3x3_weights_9_02_reg                                   0xB81AB828
#define  SRNN_wdsr_layer3_3x3_weights_9_02_inst_addr                             "0x022E"
#define  set_SRNN_wdsr_layer3_3x3_weights_9_02_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_9_02_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_9_02_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_9_02_reg))
#define  SRNN_wdsr_layer3_3x3_weights_9_02_layer3_weight_02_shift                (0)
#define  SRNN_wdsr_layer3_3x3_weights_9_02_layer3_weight_02_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_9_02_layer3_weight_02(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_9_02_get_layer3_weight_02(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_9_10                                      0x181AB82C
#define  SRNN_wdsr_layer3_3x3_weights_9_10_reg_addr                              "0xB81AB82C"
#define  SRNN_wdsr_layer3_3x3_weights_9_10_reg                                   0xB81AB82C
#define  SRNN_wdsr_layer3_3x3_weights_9_10_inst_addr                             "0x022F"
#define  set_SRNN_wdsr_layer3_3x3_weights_9_10_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_9_10_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_9_10_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_9_10_reg))
#define  SRNN_wdsr_layer3_3x3_weights_9_10_layer3_weight_10_shift                (0)
#define  SRNN_wdsr_layer3_3x3_weights_9_10_layer3_weight_10_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_9_10_layer3_weight_10(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_9_10_get_layer3_weight_10(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_9_11                                      0x181AB830
#define  SRNN_wdsr_layer3_3x3_weights_9_11_reg_addr                              "0xB81AB830"
#define  SRNN_wdsr_layer3_3x3_weights_9_11_reg                                   0xB81AB830
#define  SRNN_wdsr_layer3_3x3_weights_9_11_inst_addr                             "0x0230"
#define  set_SRNN_wdsr_layer3_3x3_weights_9_11_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_9_11_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_9_11_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_9_11_reg))
#define  SRNN_wdsr_layer3_3x3_weights_9_11_layer3_weight_11_shift                (0)
#define  SRNN_wdsr_layer3_3x3_weights_9_11_layer3_weight_11_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_9_11_layer3_weight_11(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_9_11_get_layer3_weight_11(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_9_12                                      0x181AB834
#define  SRNN_wdsr_layer3_3x3_weights_9_12_reg_addr                              "0xB81AB834"
#define  SRNN_wdsr_layer3_3x3_weights_9_12_reg                                   0xB81AB834
#define  SRNN_wdsr_layer3_3x3_weights_9_12_inst_addr                             "0x0231"
#define  set_SRNN_wdsr_layer3_3x3_weights_9_12_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_9_12_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_9_12_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_9_12_reg))
#define  SRNN_wdsr_layer3_3x3_weights_9_12_layer3_weight_12_shift                (0)
#define  SRNN_wdsr_layer3_3x3_weights_9_12_layer3_weight_12_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_9_12_layer3_weight_12(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_9_12_get_layer3_weight_12(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_9_20                                      0x181AB838
#define  SRNN_wdsr_layer3_3x3_weights_9_20_reg_addr                              "0xB81AB838"
#define  SRNN_wdsr_layer3_3x3_weights_9_20_reg                                   0xB81AB838
#define  SRNN_wdsr_layer3_3x3_weights_9_20_inst_addr                             "0x0232"
#define  set_SRNN_wdsr_layer3_3x3_weights_9_20_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_9_20_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_9_20_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_9_20_reg))
#define  SRNN_wdsr_layer3_3x3_weights_9_20_layer3_weight_20_shift                (0)
#define  SRNN_wdsr_layer3_3x3_weights_9_20_layer3_weight_20_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_9_20_layer3_weight_20(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_9_20_get_layer3_weight_20(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_9_21                                      0x181AB83C
#define  SRNN_wdsr_layer3_3x3_weights_9_21_reg_addr                              "0xB81AB83C"
#define  SRNN_wdsr_layer3_3x3_weights_9_21_reg                                   0xB81AB83C
#define  SRNN_wdsr_layer3_3x3_weights_9_21_inst_addr                             "0x0233"
#define  set_SRNN_wdsr_layer3_3x3_weights_9_21_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_9_21_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_9_21_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_9_21_reg))
#define  SRNN_wdsr_layer3_3x3_weights_9_21_layer3_weight_21_shift                (0)
#define  SRNN_wdsr_layer3_3x3_weights_9_21_layer3_weight_21_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_9_21_layer3_weight_21(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_9_21_get_layer3_weight_21(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_9_22                                      0x181AB840
#define  SRNN_wdsr_layer3_3x3_weights_9_22_reg_addr                              "0xB81AB840"
#define  SRNN_wdsr_layer3_3x3_weights_9_22_reg                                   0xB81AB840
#define  SRNN_wdsr_layer3_3x3_weights_9_22_inst_addr                             "0x0234"
#define  set_SRNN_wdsr_layer3_3x3_weights_9_22_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_9_22_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_9_22_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_9_22_reg))
#define  SRNN_wdsr_layer3_3x3_weights_9_22_layer3_weight_22_shift                (0)
#define  SRNN_wdsr_layer3_3x3_weights_9_22_layer3_weight_22_mask                 (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_9_22_layer3_weight_22(data)                (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_9_22_get_layer3_weight_22(data)            (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_10_00                                     0x181AB844
#define  SRNN_wdsr_layer3_3x3_weights_10_00_reg_addr                             "0xB81AB844"
#define  SRNN_wdsr_layer3_3x3_weights_10_00_reg                                  0xB81AB844
#define  SRNN_wdsr_layer3_3x3_weights_10_00_inst_addr                            "0x0235"
#define  set_SRNN_wdsr_layer3_3x3_weights_10_00_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_10_00_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_10_00_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_10_00_reg))
#define  SRNN_wdsr_layer3_3x3_weights_10_00_layer3_weight_00_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_10_00_layer3_weight_00_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_10_00_layer3_weight_00(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_10_00_get_layer3_weight_00(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_10_01                                     0x181AB848
#define  SRNN_wdsr_layer3_3x3_weights_10_01_reg_addr                             "0xB81AB848"
#define  SRNN_wdsr_layer3_3x3_weights_10_01_reg                                  0xB81AB848
#define  SRNN_wdsr_layer3_3x3_weights_10_01_inst_addr                            "0x0236"
#define  set_SRNN_wdsr_layer3_3x3_weights_10_01_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_10_01_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_10_01_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_10_01_reg))
#define  SRNN_wdsr_layer3_3x3_weights_10_01_layer3_weight_01_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_10_01_layer3_weight_01_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_10_01_layer3_weight_01(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_10_01_get_layer3_weight_01(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_10_02                                     0x181AB84C
#define  SRNN_wdsr_layer3_3x3_weights_10_02_reg_addr                             "0xB81AB84C"
#define  SRNN_wdsr_layer3_3x3_weights_10_02_reg                                  0xB81AB84C
#define  SRNN_wdsr_layer3_3x3_weights_10_02_inst_addr                            "0x0237"
#define  set_SRNN_wdsr_layer3_3x3_weights_10_02_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_10_02_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_10_02_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_10_02_reg))
#define  SRNN_wdsr_layer3_3x3_weights_10_02_layer3_weight_02_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_10_02_layer3_weight_02_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_10_02_layer3_weight_02(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_10_02_get_layer3_weight_02(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_10_10                                     0x181AB850
#define  SRNN_wdsr_layer3_3x3_weights_10_10_reg_addr                             "0xB81AB850"
#define  SRNN_wdsr_layer3_3x3_weights_10_10_reg                                  0xB81AB850
#define  SRNN_wdsr_layer3_3x3_weights_10_10_inst_addr                            "0x0238"
#define  set_SRNN_wdsr_layer3_3x3_weights_10_10_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_10_10_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_10_10_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_10_10_reg))
#define  SRNN_wdsr_layer3_3x3_weights_10_10_layer3_weight_10_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_10_10_layer3_weight_10_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_10_10_layer3_weight_10(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_10_10_get_layer3_weight_10(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_10_11                                     0x181AB854
#define  SRNN_wdsr_layer3_3x3_weights_10_11_reg_addr                             "0xB81AB854"
#define  SRNN_wdsr_layer3_3x3_weights_10_11_reg                                  0xB81AB854
#define  SRNN_wdsr_layer3_3x3_weights_10_11_inst_addr                            "0x0239"
#define  set_SRNN_wdsr_layer3_3x3_weights_10_11_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_10_11_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_10_11_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_10_11_reg))
#define  SRNN_wdsr_layer3_3x3_weights_10_11_layer3_weight_11_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_10_11_layer3_weight_11_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_10_11_layer3_weight_11(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_10_11_get_layer3_weight_11(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_10_12                                     0x181AB858
#define  SRNN_wdsr_layer3_3x3_weights_10_12_reg_addr                             "0xB81AB858"
#define  SRNN_wdsr_layer3_3x3_weights_10_12_reg                                  0xB81AB858
#define  SRNN_wdsr_layer3_3x3_weights_10_12_inst_addr                            "0x023A"
#define  set_SRNN_wdsr_layer3_3x3_weights_10_12_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_10_12_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_10_12_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_10_12_reg))
#define  SRNN_wdsr_layer3_3x3_weights_10_12_layer3_weight_12_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_10_12_layer3_weight_12_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_10_12_layer3_weight_12(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_10_12_get_layer3_weight_12(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_10_20                                     0x181AB85C
#define  SRNN_wdsr_layer3_3x3_weights_10_20_reg_addr                             "0xB81AB85C"
#define  SRNN_wdsr_layer3_3x3_weights_10_20_reg                                  0xB81AB85C
#define  SRNN_wdsr_layer3_3x3_weights_10_20_inst_addr                            "0x023B"
#define  set_SRNN_wdsr_layer3_3x3_weights_10_20_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_10_20_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_10_20_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_10_20_reg))
#define  SRNN_wdsr_layer3_3x3_weights_10_20_layer3_weight_20_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_10_20_layer3_weight_20_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_10_20_layer3_weight_20(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_10_20_get_layer3_weight_20(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_10_21                                     0x181AB860
#define  SRNN_wdsr_layer3_3x3_weights_10_21_reg_addr                             "0xB81AB860"
#define  SRNN_wdsr_layer3_3x3_weights_10_21_reg                                  0xB81AB860
#define  SRNN_wdsr_layer3_3x3_weights_10_21_inst_addr                            "0x023C"
#define  set_SRNN_wdsr_layer3_3x3_weights_10_21_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_10_21_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_10_21_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_10_21_reg))
#define  SRNN_wdsr_layer3_3x3_weights_10_21_layer3_weight_21_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_10_21_layer3_weight_21_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_10_21_layer3_weight_21(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_10_21_get_layer3_weight_21(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_10_22                                     0x181AB864
#define  SRNN_wdsr_layer3_3x3_weights_10_22_reg_addr                             "0xB81AB864"
#define  SRNN_wdsr_layer3_3x3_weights_10_22_reg                                  0xB81AB864
#define  SRNN_wdsr_layer3_3x3_weights_10_22_inst_addr                            "0x023D"
#define  set_SRNN_wdsr_layer3_3x3_weights_10_22_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_10_22_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_10_22_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_10_22_reg))
#define  SRNN_wdsr_layer3_3x3_weights_10_22_layer3_weight_22_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_10_22_layer3_weight_22_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_10_22_layer3_weight_22(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_10_22_get_layer3_weight_22(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_11_00                                     0x181AB868
#define  SRNN_wdsr_layer3_3x3_weights_11_00_reg_addr                             "0xB81AB868"
#define  SRNN_wdsr_layer3_3x3_weights_11_00_reg                                  0xB81AB868
#define  SRNN_wdsr_layer3_3x3_weights_11_00_inst_addr                            "0x023E"
#define  set_SRNN_wdsr_layer3_3x3_weights_11_00_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_11_00_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_11_00_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_11_00_reg))
#define  SRNN_wdsr_layer3_3x3_weights_11_00_layer3_weight_00_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_11_00_layer3_weight_00_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_11_00_layer3_weight_00(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_11_00_get_layer3_weight_00(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_11_01                                     0x181AB86C
#define  SRNN_wdsr_layer3_3x3_weights_11_01_reg_addr                             "0xB81AB86C"
#define  SRNN_wdsr_layer3_3x3_weights_11_01_reg                                  0xB81AB86C
#define  SRNN_wdsr_layer3_3x3_weights_11_01_inst_addr                            "0x023F"
#define  set_SRNN_wdsr_layer3_3x3_weights_11_01_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_11_01_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_11_01_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_11_01_reg))
#define  SRNN_wdsr_layer3_3x3_weights_11_01_layer3_weight_01_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_11_01_layer3_weight_01_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_11_01_layer3_weight_01(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_11_01_get_layer3_weight_01(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_11_02                                     0x181AB870
#define  SRNN_wdsr_layer3_3x3_weights_11_02_reg_addr                             "0xB81AB870"
#define  SRNN_wdsr_layer3_3x3_weights_11_02_reg                                  0xB81AB870
#define  SRNN_wdsr_layer3_3x3_weights_11_02_inst_addr                            "0x0240"
#define  set_SRNN_wdsr_layer3_3x3_weights_11_02_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_11_02_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_11_02_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_11_02_reg))
#define  SRNN_wdsr_layer3_3x3_weights_11_02_layer3_weight_02_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_11_02_layer3_weight_02_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_11_02_layer3_weight_02(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_11_02_get_layer3_weight_02(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_11_10                                     0x181AB874
#define  SRNN_wdsr_layer3_3x3_weights_11_10_reg_addr                             "0xB81AB874"
#define  SRNN_wdsr_layer3_3x3_weights_11_10_reg                                  0xB81AB874
#define  SRNN_wdsr_layer3_3x3_weights_11_10_inst_addr                            "0x0241"
#define  set_SRNN_wdsr_layer3_3x3_weights_11_10_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_11_10_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_11_10_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_11_10_reg))
#define  SRNN_wdsr_layer3_3x3_weights_11_10_layer3_weight_10_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_11_10_layer3_weight_10_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_11_10_layer3_weight_10(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_11_10_get_layer3_weight_10(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_11_11                                     0x181AB878
#define  SRNN_wdsr_layer3_3x3_weights_11_11_reg_addr                             "0xB81AB878"
#define  SRNN_wdsr_layer3_3x3_weights_11_11_reg                                  0xB81AB878
#define  SRNN_wdsr_layer3_3x3_weights_11_11_inst_addr                            "0x0242"
#define  set_SRNN_wdsr_layer3_3x3_weights_11_11_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_11_11_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_11_11_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_11_11_reg))
#define  SRNN_wdsr_layer3_3x3_weights_11_11_layer3_weight_11_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_11_11_layer3_weight_11_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_11_11_layer3_weight_11(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_11_11_get_layer3_weight_11(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_11_12                                     0x181AB87C
#define  SRNN_wdsr_layer3_3x3_weights_11_12_reg_addr                             "0xB81AB87C"
#define  SRNN_wdsr_layer3_3x3_weights_11_12_reg                                  0xB81AB87C
#define  SRNN_wdsr_layer3_3x3_weights_11_12_inst_addr                            "0x0243"
#define  set_SRNN_wdsr_layer3_3x3_weights_11_12_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_11_12_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_11_12_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_11_12_reg))
#define  SRNN_wdsr_layer3_3x3_weights_11_12_layer3_weight_12_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_11_12_layer3_weight_12_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_11_12_layer3_weight_12(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_11_12_get_layer3_weight_12(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_11_20                                     0x181AB880
#define  SRNN_wdsr_layer3_3x3_weights_11_20_reg_addr                             "0xB81AB880"
#define  SRNN_wdsr_layer3_3x3_weights_11_20_reg                                  0xB81AB880
#define  SRNN_wdsr_layer3_3x3_weights_11_20_inst_addr                            "0x0244"
#define  set_SRNN_wdsr_layer3_3x3_weights_11_20_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_11_20_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_11_20_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_11_20_reg))
#define  SRNN_wdsr_layer3_3x3_weights_11_20_layer3_weight_20_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_11_20_layer3_weight_20_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_11_20_layer3_weight_20(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_11_20_get_layer3_weight_20(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_11_21                                     0x181AB884
#define  SRNN_wdsr_layer3_3x3_weights_11_21_reg_addr                             "0xB81AB884"
#define  SRNN_wdsr_layer3_3x3_weights_11_21_reg                                  0xB81AB884
#define  SRNN_wdsr_layer3_3x3_weights_11_21_inst_addr                            "0x0245"
#define  set_SRNN_wdsr_layer3_3x3_weights_11_21_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_11_21_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_11_21_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_11_21_reg))
#define  SRNN_wdsr_layer3_3x3_weights_11_21_layer3_weight_21_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_11_21_layer3_weight_21_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_11_21_layer3_weight_21(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_11_21_get_layer3_weight_21(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_11_22                                     0x181AB888
#define  SRNN_wdsr_layer3_3x3_weights_11_22_reg_addr                             "0xB81AB888"
#define  SRNN_wdsr_layer3_3x3_weights_11_22_reg                                  0xB81AB888
#define  SRNN_wdsr_layer3_3x3_weights_11_22_inst_addr                            "0x0246"
#define  set_SRNN_wdsr_layer3_3x3_weights_11_22_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_11_22_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_11_22_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_11_22_reg))
#define  SRNN_wdsr_layer3_3x3_weights_11_22_layer3_weight_22_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_11_22_layer3_weight_22_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_11_22_layer3_weight_22(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_11_22_get_layer3_weight_22(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_12_00                                     0x181AB88C
#define  SRNN_wdsr_layer3_3x3_weights_12_00_reg_addr                             "0xB81AB88C"
#define  SRNN_wdsr_layer3_3x3_weights_12_00_reg                                  0xB81AB88C
#define  SRNN_wdsr_layer3_3x3_weights_12_00_inst_addr                            "0x0247"
#define  set_SRNN_wdsr_layer3_3x3_weights_12_00_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_12_00_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_12_00_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_12_00_reg))
#define  SRNN_wdsr_layer3_3x3_weights_12_00_layer3_weight_00_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_12_00_layer3_weight_00_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_12_00_layer3_weight_00(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_12_00_get_layer3_weight_00(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_12_01                                     0x181AB890
#define  SRNN_wdsr_layer3_3x3_weights_12_01_reg_addr                             "0xB81AB890"
#define  SRNN_wdsr_layer3_3x3_weights_12_01_reg                                  0xB81AB890
#define  SRNN_wdsr_layer3_3x3_weights_12_01_inst_addr                            "0x0248"
#define  set_SRNN_wdsr_layer3_3x3_weights_12_01_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_12_01_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_12_01_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_12_01_reg))
#define  SRNN_wdsr_layer3_3x3_weights_12_01_layer3_weight_01_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_12_01_layer3_weight_01_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_12_01_layer3_weight_01(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_12_01_get_layer3_weight_01(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_12_02                                     0x181AB894
#define  SRNN_wdsr_layer3_3x3_weights_12_02_reg_addr                             "0xB81AB894"
#define  SRNN_wdsr_layer3_3x3_weights_12_02_reg                                  0xB81AB894
#define  SRNN_wdsr_layer3_3x3_weights_12_02_inst_addr                            "0x0249"
#define  set_SRNN_wdsr_layer3_3x3_weights_12_02_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_12_02_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_12_02_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_12_02_reg))
#define  SRNN_wdsr_layer3_3x3_weights_12_02_layer3_weight_02_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_12_02_layer3_weight_02_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_12_02_layer3_weight_02(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_12_02_get_layer3_weight_02(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_12_10                                     0x181AB898
#define  SRNN_wdsr_layer3_3x3_weights_12_10_reg_addr                             "0xB81AB898"
#define  SRNN_wdsr_layer3_3x3_weights_12_10_reg                                  0xB81AB898
#define  SRNN_wdsr_layer3_3x3_weights_12_10_inst_addr                            "0x024A"
#define  set_SRNN_wdsr_layer3_3x3_weights_12_10_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_12_10_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_12_10_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_12_10_reg))
#define  SRNN_wdsr_layer3_3x3_weights_12_10_layer3_weight_10_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_12_10_layer3_weight_10_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_12_10_layer3_weight_10(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_12_10_get_layer3_weight_10(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_12_11                                     0x181AB89C
#define  SRNN_wdsr_layer3_3x3_weights_12_11_reg_addr                             "0xB81AB89C"
#define  SRNN_wdsr_layer3_3x3_weights_12_11_reg                                  0xB81AB89C
#define  SRNN_wdsr_layer3_3x3_weights_12_11_inst_addr                            "0x024B"
#define  set_SRNN_wdsr_layer3_3x3_weights_12_11_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_12_11_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_12_11_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_12_11_reg))
#define  SRNN_wdsr_layer3_3x3_weights_12_11_layer3_weight_11_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_12_11_layer3_weight_11_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_12_11_layer3_weight_11(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_12_11_get_layer3_weight_11(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_12_12                                     0x181AB8A0
#define  SRNN_wdsr_layer3_3x3_weights_12_12_reg_addr                             "0xB81AB8A0"
#define  SRNN_wdsr_layer3_3x3_weights_12_12_reg                                  0xB81AB8A0
#define  SRNN_wdsr_layer3_3x3_weights_12_12_inst_addr                            "0x024C"
#define  set_SRNN_wdsr_layer3_3x3_weights_12_12_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_12_12_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_12_12_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_12_12_reg))
#define  SRNN_wdsr_layer3_3x3_weights_12_12_layer3_weight_12_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_12_12_layer3_weight_12_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_12_12_layer3_weight_12(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_12_12_get_layer3_weight_12(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_12_20                                     0x181AB8A4
#define  SRNN_wdsr_layer3_3x3_weights_12_20_reg_addr                             "0xB81AB8A4"
#define  SRNN_wdsr_layer3_3x3_weights_12_20_reg                                  0xB81AB8A4
#define  SRNN_wdsr_layer3_3x3_weights_12_20_inst_addr                            "0x024D"
#define  set_SRNN_wdsr_layer3_3x3_weights_12_20_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_12_20_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_12_20_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_12_20_reg))
#define  SRNN_wdsr_layer3_3x3_weights_12_20_layer3_weight_20_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_12_20_layer3_weight_20_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_12_20_layer3_weight_20(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_12_20_get_layer3_weight_20(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_12_21                                     0x181AB8A8
#define  SRNN_wdsr_layer3_3x3_weights_12_21_reg_addr                             "0xB81AB8A8"
#define  SRNN_wdsr_layer3_3x3_weights_12_21_reg                                  0xB81AB8A8
#define  SRNN_wdsr_layer3_3x3_weights_12_21_inst_addr                            "0x024E"
#define  set_SRNN_wdsr_layer3_3x3_weights_12_21_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_12_21_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_12_21_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_12_21_reg))
#define  SRNN_wdsr_layer3_3x3_weights_12_21_layer3_weight_21_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_12_21_layer3_weight_21_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_12_21_layer3_weight_21(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_12_21_get_layer3_weight_21(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_12_22                                     0x181AB8AC
#define  SRNN_wdsr_layer3_3x3_weights_12_22_reg_addr                             "0xB81AB8AC"
#define  SRNN_wdsr_layer3_3x3_weights_12_22_reg                                  0xB81AB8AC
#define  SRNN_wdsr_layer3_3x3_weights_12_22_inst_addr                            "0x024F"
#define  set_SRNN_wdsr_layer3_3x3_weights_12_22_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_12_22_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_12_22_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_12_22_reg))
#define  SRNN_wdsr_layer3_3x3_weights_12_22_layer3_weight_22_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_12_22_layer3_weight_22_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_12_22_layer3_weight_22(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_12_22_get_layer3_weight_22(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_13_00                                     0x181AB8B0
#define  SRNN_wdsr_layer3_3x3_weights_13_00_reg_addr                             "0xB81AB8B0"
#define  SRNN_wdsr_layer3_3x3_weights_13_00_reg                                  0xB81AB8B0
#define  SRNN_wdsr_layer3_3x3_weights_13_00_inst_addr                            "0x0250"
#define  set_SRNN_wdsr_layer3_3x3_weights_13_00_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_13_00_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_13_00_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_13_00_reg))
#define  SRNN_wdsr_layer3_3x3_weights_13_00_layer3_weight_00_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_13_00_layer3_weight_00_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_13_00_layer3_weight_00(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_13_00_get_layer3_weight_00(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_13_01                                     0x181AB8B4
#define  SRNN_wdsr_layer3_3x3_weights_13_01_reg_addr                             "0xB81AB8B4"
#define  SRNN_wdsr_layer3_3x3_weights_13_01_reg                                  0xB81AB8B4
#define  SRNN_wdsr_layer3_3x3_weights_13_01_inst_addr                            "0x0251"
#define  set_SRNN_wdsr_layer3_3x3_weights_13_01_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_13_01_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_13_01_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_13_01_reg))
#define  SRNN_wdsr_layer3_3x3_weights_13_01_layer3_weight_01_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_13_01_layer3_weight_01_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_13_01_layer3_weight_01(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_13_01_get_layer3_weight_01(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_13_02                                     0x181AB8B8
#define  SRNN_wdsr_layer3_3x3_weights_13_02_reg_addr                             "0xB81AB8B8"
#define  SRNN_wdsr_layer3_3x3_weights_13_02_reg                                  0xB81AB8B8
#define  SRNN_wdsr_layer3_3x3_weights_13_02_inst_addr                            "0x0252"
#define  set_SRNN_wdsr_layer3_3x3_weights_13_02_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_13_02_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_13_02_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_13_02_reg))
#define  SRNN_wdsr_layer3_3x3_weights_13_02_layer3_weight_02_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_13_02_layer3_weight_02_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_13_02_layer3_weight_02(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_13_02_get_layer3_weight_02(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_13_10                                     0x181AB8BC
#define  SRNN_wdsr_layer3_3x3_weights_13_10_reg_addr                             "0xB81AB8BC"
#define  SRNN_wdsr_layer3_3x3_weights_13_10_reg                                  0xB81AB8BC
#define  SRNN_wdsr_layer3_3x3_weights_13_10_inst_addr                            "0x0253"
#define  set_SRNN_wdsr_layer3_3x3_weights_13_10_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_13_10_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_13_10_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_13_10_reg))
#define  SRNN_wdsr_layer3_3x3_weights_13_10_layer3_weight_10_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_13_10_layer3_weight_10_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_13_10_layer3_weight_10(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_13_10_get_layer3_weight_10(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_13_11                                     0x181AB8C0
#define  SRNN_wdsr_layer3_3x3_weights_13_11_reg_addr                             "0xB81AB8C0"
#define  SRNN_wdsr_layer3_3x3_weights_13_11_reg                                  0xB81AB8C0
#define  SRNN_wdsr_layer3_3x3_weights_13_11_inst_addr                            "0x0254"
#define  set_SRNN_wdsr_layer3_3x3_weights_13_11_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_13_11_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_13_11_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_13_11_reg))
#define  SRNN_wdsr_layer3_3x3_weights_13_11_layer3_weight_11_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_13_11_layer3_weight_11_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_13_11_layer3_weight_11(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_13_11_get_layer3_weight_11(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_13_12                                     0x181AB8C4
#define  SRNN_wdsr_layer3_3x3_weights_13_12_reg_addr                             "0xB81AB8C4"
#define  SRNN_wdsr_layer3_3x3_weights_13_12_reg                                  0xB81AB8C4
#define  SRNN_wdsr_layer3_3x3_weights_13_12_inst_addr                            "0x0255"
#define  set_SRNN_wdsr_layer3_3x3_weights_13_12_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_13_12_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_13_12_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_13_12_reg))
#define  SRNN_wdsr_layer3_3x3_weights_13_12_layer3_weight_12_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_13_12_layer3_weight_12_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_13_12_layer3_weight_12(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_13_12_get_layer3_weight_12(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_13_20                                     0x181AB8C8
#define  SRNN_wdsr_layer3_3x3_weights_13_20_reg_addr                             "0xB81AB8C8"
#define  SRNN_wdsr_layer3_3x3_weights_13_20_reg                                  0xB81AB8C8
#define  SRNN_wdsr_layer3_3x3_weights_13_20_inst_addr                            "0x0256"
#define  set_SRNN_wdsr_layer3_3x3_weights_13_20_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_13_20_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_13_20_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_13_20_reg))
#define  SRNN_wdsr_layer3_3x3_weights_13_20_layer3_weight_20_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_13_20_layer3_weight_20_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_13_20_layer3_weight_20(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_13_20_get_layer3_weight_20(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_13_21                                     0x181AB8CC
#define  SRNN_wdsr_layer3_3x3_weights_13_21_reg_addr                             "0xB81AB8CC"
#define  SRNN_wdsr_layer3_3x3_weights_13_21_reg                                  0xB81AB8CC
#define  SRNN_wdsr_layer3_3x3_weights_13_21_inst_addr                            "0x0257"
#define  set_SRNN_wdsr_layer3_3x3_weights_13_21_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_13_21_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_13_21_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_13_21_reg))
#define  SRNN_wdsr_layer3_3x3_weights_13_21_layer3_weight_21_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_13_21_layer3_weight_21_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_13_21_layer3_weight_21(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_13_21_get_layer3_weight_21(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_13_22                                     0x181AB8D0
#define  SRNN_wdsr_layer3_3x3_weights_13_22_reg_addr                             "0xB81AB8D0"
#define  SRNN_wdsr_layer3_3x3_weights_13_22_reg                                  0xB81AB8D0
#define  SRNN_wdsr_layer3_3x3_weights_13_22_inst_addr                            "0x0258"
#define  set_SRNN_wdsr_layer3_3x3_weights_13_22_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_13_22_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_13_22_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_13_22_reg))
#define  SRNN_wdsr_layer3_3x3_weights_13_22_layer3_weight_22_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_13_22_layer3_weight_22_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_13_22_layer3_weight_22(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_13_22_get_layer3_weight_22(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_14_00                                     0x181AB8D4
#define  SRNN_wdsr_layer3_3x3_weights_14_00_reg_addr                             "0xB81AB8D4"
#define  SRNN_wdsr_layer3_3x3_weights_14_00_reg                                  0xB81AB8D4
#define  SRNN_wdsr_layer3_3x3_weights_14_00_inst_addr                            "0x0259"
#define  set_SRNN_wdsr_layer3_3x3_weights_14_00_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_14_00_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_14_00_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_14_00_reg))
#define  SRNN_wdsr_layer3_3x3_weights_14_00_layer3_weight_00_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_14_00_layer3_weight_00_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_14_00_layer3_weight_00(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_14_00_get_layer3_weight_00(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_14_01                                     0x181AB8D8
#define  SRNN_wdsr_layer3_3x3_weights_14_01_reg_addr                             "0xB81AB8D8"
#define  SRNN_wdsr_layer3_3x3_weights_14_01_reg                                  0xB81AB8D8
#define  SRNN_wdsr_layer3_3x3_weights_14_01_inst_addr                            "0x025A"
#define  set_SRNN_wdsr_layer3_3x3_weights_14_01_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_14_01_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_14_01_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_14_01_reg))
#define  SRNN_wdsr_layer3_3x3_weights_14_01_layer3_weight_01_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_14_01_layer3_weight_01_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_14_01_layer3_weight_01(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_14_01_get_layer3_weight_01(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_14_02                                     0x181AB8DC
#define  SRNN_wdsr_layer3_3x3_weights_14_02_reg_addr                             "0xB81AB8DC"
#define  SRNN_wdsr_layer3_3x3_weights_14_02_reg                                  0xB81AB8DC
#define  SRNN_wdsr_layer3_3x3_weights_14_02_inst_addr                            "0x025B"
#define  set_SRNN_wdsr_layer3_3x3_weights_14_02_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_14_02_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_14_02_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_14_02_reg))
#define  SRNN_wdsr_layer3_3x3_weights_14_02_layer3_weight_02_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_14_02_layer3_weight_02_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_14_02_layer3_weight_02(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_14_02_get_layer3_weight_02(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_14_10                                     0x181AB8E0
#define  SRNN_wdsr_layer3_3x3_weights_14_10_reg_addr                             "0xB81AB8E0"
#define  SRNN_wdsr_layer3_3x3_weights_14_10_reg                                  0xB81AB8E0
#define  SRNN_wdsr_layer3_3x3_weights_14_10_inst_addr                            "0x025C"
#define  set_SRNN_wdsr_layer3_3x3_weights_14_10_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_14_10_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_14_10_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_14_10_reg))
#define  SRNN_wdsr_layer3_3x3_weights_14_10_layer3_weight_10_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_14_10_layer3_weight_10_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_14_10_layer3_weight_10(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_14_10_get_layer3_weight_10(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_14_11                                     0x181AB8E4
#define  SRNN_wdsr_layer3_3x3_weights_14_11_reg_addr                             "0xB81AB8E4"
#define  SRNN_wdsr_layer3_3x3_weights_14_11_reg                                  0xB81AB8E4
#define  SRNN_wdsr_layer3_3x3_weights_14_11_inst_addr                            "0x025D"
#define  set_SRNN_wdsr_layer3_3x3_weights_14_11_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_14_11_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_14_11_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_14_11_reg))
#define  SRNN_wdsr_layer3_3x3_weights_14_11_layer3_weight_11_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_14_11_layer3_weight_11_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_14_11_layer3_weight_11(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_14_11_get_layer3_weight_11(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_14_12                                     0x181AB8E8
#define  SRNN_wdsr_layer3_3x3_weights_14_12_reg_addr                             "0xB81AB8E8"
#define  SRNN_wdsr_layer3_3x3_weights_14_12_reg                                  0xB81AB8E8
#define  SRNN_wdsr_layer3_3x3_weights_14_12_inst_addr                            "0x025E"
#define  set_SRNN_wdsr_layer3_3x3_weights_14_12_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_14_12_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_14_12_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_14_12_reg))
#define  SRNN_wdsr_layer3_3x3_weights_14_12_layer3_weight_12_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_14_12_layer3_weight_12_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_14_12_layer3_weight_12(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_14_12_get_layer3_weight_12(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_14_20                                     0x181AB8EC
#define  SRNN_wdsr_layer3_3x3_weights_14_20_reg_addr                             "0xB81AB8EC"
#define  SRNN_wdsr_layer3_3x3_weights_14_20_reg                                  0xB81AB8EC
#define  SRNN_wdsr_layer3_3x3_weights_14_20_inst_addr                            "0x025F"
#define  set_SRNN_wdsr_layer3_3x3_weights_14_20_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_14_20_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_14_20_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_14_20_reg))
#define  SRNN_wdsr_layer3_3x3_weights_14_20_layer3_weight_20_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_14_20_layer3_weight_20_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_14_20_layer3_weight_20(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_14_20_get_layer3_weight_20(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_14_21                                     0x181AB8F0
#define  SRNN_wdsr_layer3_3x3_weights_14_21_reg_addr                             "0xB81AB8F0"
#define  SRNN_wdsr_layer3_3x3_weights_14_21_reg                                  0xB81AB8F0
#define  SRNN_wdsr_layer3_3x3_weights_14_21_inst_addr                            "0x0260"
#define  set_SRNN_wdsr_layer3_3x3_weights_14_21_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_14_21_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_14_21_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_14_21_reg))
#define  SRNN_wdsr_layer3_3x3_weights_14_21_layer3_weight_21_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_14_21_layer3_weight_21_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_14_21_layer3_weight_21(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_14_21_get_layer3_weight_21(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_14_22                                     0x181AB8F4
#define  SRNN_wdsr_layer3_3x3_weights_14_22_reg_addr                             "0xB81AB8F4"
#define  SRNN_wdsr_layer3_3x3_weights_14_22_reg                                  0xB81AB8F4
#define  SRNN_wdsr_layer3_3x3_weights_14_22_inst_addr                            "0x0261"
#define  set_SRNN_wdsr_layer3_3x3_weights_14_22_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_14_22_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_14_22_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_14_22_reg))
#define  SRNN_wdsr_layer3_3x3_weights_14_22_layer3_weight_22_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_14_22_layer3_weight_22_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_14_22_layer3_weight_22(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_14_22_get_layer3_weight_22(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_15_00                                     0x181AB8F8
#define  SRNN_wdsr_layer3_3x3_weights_15_00_reg_addr                             "0xB81AB8F8"
#define  SRNN_wdsr_layer3_3x3_weights_15_00_reg                                  0xB81AB8F8
#define  SRNN_wdsr_layer3_3x3_weights_15_00_inst_addr                            "0x0262"
#define  set_SRNN_wdsr_layer3_3x3_weights_15_00_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_15_00_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_15_00_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_15_00_reg))
#define  SRNN_wdsr_layer3_3x3_weights_15_00_layer3_weight_00_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_15_00_layer3_weight_00_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_15_00_layer3_weight_00(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_15_00_get_layer3_weight_00(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_15_01                                     0x181AB8FC
#define  SRNN_wdsr_layer3_3x3_weights_15_01_reg_addr                             "0xB81AB8FC"
#define  SRNN_wdsr_layer3_3x3_weights_15_01_reg                                  0xB81AB8FC
#define  SRNN_wdsr_layer3_3x3_weights_15_01_inst_addr                            "0x0263"
#define  set_SRNN_wdsr_layer3_3x3_weights_15_01_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_15_01_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_15_01_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_15_01_reg))
#define  SRNN_wdsr_layer3_3x3_weights_15_01_layer3_weight_01_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_15_01_layer3_weight_01_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_15_01_layer3_weight_01(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_15_01_get_layer3_weight_01(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_15_02                                     0x181AB900
#define  SRNN_wdsr_layer3_3x3_weights_15_02_reg_addr                             "0xB81AB900"
#define  SRNN_wdsr_layer3_3x3_weights_15_02_reg                                  0xB81AB900
#define  SRNN_wdsr_layer3_3x3_weights_15_02_inst_addr                            "0x0264"
#define  set_SRNN_wdsr_layer3_3x3_weights_15_02_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_15_02_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_15_02_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_15_02_reg))
#define  SRNN_wdsr_layer3_3x3_weights_15_02_layer3_weight_02_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_15_02_layer3_weight_02_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_15_02_layer3_weight_02(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_15_02_get_layer3_weight_02(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_15_10                                     0x181AB904
#define  SRNN_wdsr_layer3_3x3_weights_15_10_reg_addr                             "0xB81AB904"
#define  SRNN_wdsr_layer3_3x3_weights_15_10_reg                                  0xB81AB904
#define  SRNN_wdsr_layer3_3x3_weights_15_10_inst_addr                            "0x0265"
#define  set_SRNN_wdsr_layer3_3x3_weights_15_10_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_15_10_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_15_10_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_15_10_reg))
#define  SRNN_wdsr_layer3_3x3_weights_15_10_layer3_weight_10_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_15_10_layer3_weight_10_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_15_10_layer3_weight_10(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_15_10_get_layer3_weight_10(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_15_11                                     0x181AB908
#define  SRNN_wdsr_layer3_3x3_weights_15_11_reg_addr                             "0xB81AB908"
#define  SRNN_wdsr_layer3_3x3_weights_15_11_reg                                  0xB81AB908
#define  SRNN_wdsr_layer3_3x3_weights_15_11_inst_addr                            "0x0266"
#define  set_SRNN_wdsr_layer3_3x3_weights_15_11_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_15_11_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_15_11_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_15_11_reg))
#define  SRNN_wdsr_layer3_3x3_weights_15_11_layer3_weight_11_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_15_11_layer3_weight_11_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_15_11_layer3_weight_11(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_15_11_get_layer3_weight_11(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_15_12                                     0x181AB90C
#define  SRNN_wdsr_layer3_3x3_weights_15_12_reg_addr                             "0xB81AB90C"
#define  SRNN_wdsr_layer3_3x3_weights_15_12_reg                                  0xB81AB90C
#define  SRNN_wdsr_layer3_3x3_weights_15_12_inst_addr                            "0x0267"
#define  set_SRNN_wdsr_layer3_3x3_weights_15_12_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_15_12_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_15_12_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_15_12_reg))
#define  SRNN_wdsr_layer3_3x3_weights_15_12_layer3_weight_12_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_15_12_layer3_weight_12_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_15_12_layer3_weight_12(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_15_12_get_layer3_weight_12(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_15_20                                     0x181AB910
#define  SRNN_wdsr_layer3_3x3_weights_15_20_reg_addr                             "0xB81AB910"
#define  SRNN_wdsr_layer3_3x3_weights_15_20_reg                                  0xB81AB910
#define  SRNN_wdsr_layer3_3x3_weights_15_20_inst_addr                            "0x0268"
#define  set_SRNN_wdsr_layer3_3x3_weights_15_20_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_15_20_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_15_20_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_15_20_reg))
#define  SRNN_wdsr_layer3_3x3_weights_15_20_layer3_weight_20_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_15_20_layer3_weight_20_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_15_20_layer3_weight_20(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_15_20_get_layer3_weight_20(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_15_21                                     0x181AB914
#define  SRNN_wdsr_layer3_3x3_weights_15_21_reg_addr                             "0xB81AB914"
#define  SRNN_wdsr_layer3_3x3_weights_15_21_reg                                  0xB81AB914
#define  SRNN_wdsr_layer3_3x3_weights_15_21_inst_addr                            "0x0269"
#define  set_SRNN_wdsr_layer3_3x3_weights_15_21_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_15_21_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_15_21_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_15_21_reg))
#define  SRNN_wdsr_layer3_3x3_weights_15_21_layer3_weight_21_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_15_21_layer3_weight_21_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_15_21_layer3_weight_21(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_15_21_get_layer3_weight_21(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_15_22                                     0x181AB918
#define  SRNN_wdsr_layer3_3x3_weights_15_22_reg_addr                             "0xB81AB918"
#define  SRNN_wdsr_layer3_3x3_weights_15_22_reg                                  0xB81AB918
#define  SRNN_wdsr_layer3_3x3_weights_15_22_inst_addr                            "0x026A"
#define  set_SRNN_wdsr_layer3_3x3_weights_15_22_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_15_22_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_15_22_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_15_22_reg))
#define  SRNN_wdsr_layer3_3x3_weights_15_22_layer3_weight_22_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_15_22_layer3_weight_22_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_15_22_layer3_weight_22(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_15_22_get_layer3_weight_22(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_16_00                                     0x181AB91C
#define  SRNN_wdsr_layer3_3x3_weights_16_00_reg_addr                             "0xB81AB91C"
#define  SRNN_wdsr_layer3_3x3_weights_16_00_reg                                  0xB81AB91C
#define  SRNN_wdsr_layer3_3x3_weights_16_00_inst_addr                            "0x026B"
#define  set_SRNN_wdsr_layer3_3x3_weights_16_00_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_16_00_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_16_00_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_16_00_reg))
#define  SRNN_wdsr_layer3_3x3_weights_16_00_layer3_weight_00_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_16_00_layer3_weight_00_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_16_00_layer3_weight_00(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_16_00_get_layer3_weight_00(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_16_01                                     0x181AB920
#define  SRNN_wdsr_layer3_3x3_weights_16_01_reg_addr                             "0xB81AB920"
#define  SRNN_wdsr_layer3_3x3_weights_16_01_reg                                  0xB81AB920
#define  SRNN_wdsr_layer3_3x3_weights_16_01_inst_addr                            "0x026C"
#define  set_SRNN_wdsr_layer3_3x3_weights_16_01_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_16_01_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_16_01_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_16_01_reg))
#define  SRNN_wdsr_layer3_3x3_weights_16_01_layer3_weight_01_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_16_01_layer3_weight_01_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_16_01_layer3_weight_01(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_16_01_get_layer3_weight_01(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_16_02                                     0x181AB924
#define  SRNN_wdsr_layer3_3x3_weights_16_02_reg_addr                             "0xB81AB924"
#define  SRNN_wdsr_layer3_3x3_weights_16_02_reg                                  0xB81AB924
#define  SRNN_wdsr_layer3_3x3_weights_16_02_inst_addr                            "0x026D"
#define  set_SRNN_wdsr_layer3_3x3_weights_16_02_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_16_02_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_16_02_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_16_02_reg))
#define  SRNN_wdsr_layer3_3x3_weights_16_02_layer3_weight_02_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_16_02_layer3_weight_02_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_16_02_layer3_weight_02(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_16_02_get_layer3_weight_02(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_16_10                                     0x181AB928
#define  SRNN_wdsr_layer3_3x3_weights_16_10_reg_addr                             "0xB81AB928"
#define  SRNN_wdsr_layer3_3x3_weights_16_10_reg                                  0xB81AB928
#define  SRNN_wdsr_layer3_3x3_weights_16_10_inst_addr                            "0x026E"
#define  set_SRNN_wdsr_layer3_3x3_weights_16_10_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_16_10_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_16_10_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_16_10_reg))
#define  SRNN_wdsr_layer3_3x3_weights_16_10_layer3_weight_10_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_16_10_layer3_weight_10_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_16_10_layer3_weight_10(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_16_10_get_layer3_weight_10(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_16_11                                     0x181AB92C
#define  SRNN_wdsr_layer3_3x3_weights_16_11_reg_addr                             "0xB81AB92C"
#define  SRNN_wdsr_layer3_3x3_weights_16_11_reg                                  0xB81AB92C
#define  SRNN_wdsr_layer3_3x3_weights_16_11_inst_addr                            "0x026F"
#define  set_SRNN_wdsr_layer3_3x3_weights_16_11_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_16_11_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_16_11_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_16_11_reg))
#define  SRNN_wdsr_layer3_3x3_weights_16_11_layer3_weight_11_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_16_11_layer3_weight_11_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_16_11_layer3_weight_11(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_16_11_get_layer3_weight_11(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_16_12                                     0x181AB930
#define  SRNN_wdsr_layer3_3x3_weights_16_12_reg_addr                             "0xB81AB930"
#define  SRNN_wdsr_layer3_3x3_weights_16_12_reg                                  0xB81AB930
#define  SRNN_wdsr_layer3_3x3_weights_16_12_inst_addr                            "0x0270"
#define  set_SRNN_wdsr_layer3_3x3_weights_16_12_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_16_12_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_16_12_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_16_12_reg))
#define  SRNN_wdsr_layer3_3x3_weights_16_12_layer3_weight_12_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_16_12_layer3_weight_12_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_16_12_layer3_weight_12(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_16_12_get_layer3_weight_12(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_16_20                                     0x181AB934
#define  SRNN_wdsr_layer3_3x3_weights_16_20_reg_addr                             "0xB81AB934"
#define  SRNN_wdsr_layer3_3x3_weights_16_20_reg                                  0xB81AB934
#define  SRNN_wdsr_layer3_3x3_weights_16_20_inst_addr                            "0x0271"
#define  set_SRNN_wdsr_layer3_3x3_weights_16_20_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_16_20_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_16_20_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_16_20_reg))
#define  SRNN_wdsr_layer3_3x3_weights_16_20_layer3_weight_20_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_16_20_layer3_weight_20_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_16_20_layer3_weight_20(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_16_20_get_layer3_weight_20(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_16_21                                     0x181AB938
#define  SRNN_wdsr_layer3_3x3_weights_16_21_reg_addr                             "0xB81AB938"
#define  SRNN_wdsr_layer3_3x3_weights_16_21_reg                                  0xB81AB938
#define  SRNN_wdsr_layer3_3x3_weights_16_21_inst_addr                            "0x0272"
#define  set_SRNN_wdsr_layer3_3x3_weights_16_21_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_16_21_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_16_21_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_16_21_reg))
#define  SRNN_wdsr_layer3_3x3_weights_16_21_layer3_weight_21_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_16_21_layer3_weight_21_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_16_21_layer3_weight_21(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_16_21_get_layer3_weight_21(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_16_22                                     0x181AB93C
#define  SRNN_wdsr_layer3_3x3_weights_16_22_reg_addr                             "0xB81AB93C"
#define  SRNN_wdsr_layer3_3x3_weights_16_22_reg                                  0xB81AB93C
#define  SRNN_wdsr_layer3_3x3_weights_16_22_inst_addr                            "0x0273"
#define  set_SRNN_wdsr_layer3_3x3_weights_16_22_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_16_22_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_16_22_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_16_22_reg))
#define  SRNN_wdsr_layer3_3x3_weights_16_22_layer3_weight_22_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_16_22_layer3_weight_22_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_16_22_layer3_weight_22(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_16_22_get_layer3_weight_22(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_17_00                                     0x181AB940
#define  SRNN_wdsr_layer3_3x3_weights_17_00_reg_addr                             "0xB81AB940"
#define  SRNN_wdsr_layer3_3x3_weights_17_00_reg                                  0xB81AB940
#define  SRNN_wdsr_layer3_3x3_weights_17_00_inst_addr                            "0x0274"
#define  set_SRNN_wdsr_layer3_3x3_weights_17_00_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_17_00_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_17_00_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_17_00_reg))
#define  SRNN_wdsr_layer3_3x3_weights_17_00_layer3_weight_00_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_17_00_layer3_weight_00_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_17_00_layer3_weight_00(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_17_00_get_layer3_weight_00(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_17_01                                     0x181AB944
#define  SRNN_wdsr_layer3_3x3_weights_17_01_reg_addr                             "0xB81AB944"
#define  SRNN_wdsr_layer3_3x3_weights_17_01_reg                                  0xB81AB944
#define  SRNN_wdsr_layer3_3x3_weights_17_01_inst_addr                            "0x0275"
#define  set_SRNN_wdsr_layer3_3x3_weights_17_01_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_17_01_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_17_01_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_17_01_reg))
#define  SRNN_wdsr_layer3_3x3_weights_17_01_layer3_weight_01_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_17_01_layer3_weight_01_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_17_01_layer3_weight_01(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_17_01_get_layer3_weight_01(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_17_02                                     0x181AB948
#define  SRNN_wdsr_layer3_3x3_weights_17_02_reg_addr                             "0xB81AB948"
#define  SRNN_wdsr_layer3_3x3_weights_17_02_reg                                  0xB81AB948
#define  SRNN_wdsr_layer3_3x3_weights_17_02_inst_addr                            "0x0276"
#define  set_SRNN_wdsr_layer3_3x3_weights_17_02_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_17_02_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_17_02_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_17_02_reg))
#define  SRNN_wdsr_layer3_3x3_weights_17_02_layer3_weight_02_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_17_02_layer3_weight_02_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_17_02_layer3_weight_02(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_17_02_get_layer3_weight_02(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_17_10                                     0x181AB94C
#define  SRNN_wdsr_layer3_3x3_weights_17_10_reg_addr                             "0xB81AB94C"
#define  SRNN_wdsr_layer3_3x3_weights_17_10_reg                                  0xB81AB94C
#define  SRNN_wdsr_layer3_3x3_weights_17_10_inst_addr                            "0x0277"
#define  set_SRNN_wdsr_layer3_3x3_weights_17_10_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_17_10_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_17_10_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_17_10_reg))
#define  SRNN_wdsr_layer3_3x3_weights_17_10_layer3_weight_10_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_17_10_layer3_weight_10_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_17_10_layer3_weight_10(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_17_10_get_layer3_weight_10(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_17_11                                     0x181AB950
#define  SRNN_wdsr_layer3_3x3_weights_17_11_reg_addr                             "0xB81AB950"
#define  SRNN_wdsr_layer3_3x3_weights_17_11_reg                                  0xB81AB950
#define  SRNN_wdsr_layer3_3x3_weights_17_11_inst_addr                            "0x0278"
#define  set_SRNN_wdsr_layer3_3x3_weights_17_11_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_17_11_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_17_11_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_17_11_reg))
#define  SRNN_wdsr_layer3_3x3_weights_17_11_layer3_weight_11_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_17_11_layer3_weight_11_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_17_11_layer3_weight_11(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_17_11_get_layer3_weight_11(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_17_12                                     0x181AB954
#define  SRNN_wdsr_layer3_3x3_weights_17_12_reg_addr                             "0xB81AB954"
#define  SRNN_wdsr_layer3_3x3_weights_17_12_reg                                  0xB81AB954
#define  SRNN_wdsr_layer3_3x3_weights_17_12_inst_addr                            "0x0279"
#define  set_SRNN_wdsr_layer3_3x3_weights_17_12_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_17_12_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_17_12_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_17_12_reg))
#define  SRNN_wdsr_layer3_3x3_weights_17_12_layer3_weight_12_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_17_12_layer3_weight_12_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_17_12_layer3_weight_12(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_17_12_get_layer3_weight_12(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_17_20                                     0x181AB958
#define  SRNN_wdsr_layer3_3x3_weights_17_20_reg_addr                             "0xB81AB958"
#define  SRNN_wdsr_layer3_3x3_weights_17_20_reg                                  0xB81AB958
#define  SRNN_wdsr_layer3_3x3_weights_17_20_inst_addr                            "0x027A"
#define  set_SRNN_wdsr_layer3_3x3_weights_17_20_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_17_20_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_17_20_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_17_20_reg))
#define  SRNN_wdsr_layer3_3x3_weights_17_20_layer3_weight_20_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_17_20_layer3_weight_20_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_17_20_layer3_weight_20(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_17_20_get_layer3_weight_20(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_17_21                                     0x181AB95C
#define  SRNN_wdsr_layer3_3x3_weights_17_21_reg_addr                             "0xB81AB95C"
#define  SRNN_wdsr_layer3_3x3_weights_17_21_reg                                  0xB81AB95C
#define  SRNN_wdsr_layer3_3x3_weights_17_21_inst_addr                            "0x027B"
#define  set_SRNN_wdsr_layer3_3x3_weights_17_21_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_17_21_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_17_21_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_17_21_reg))
#define  SRNN_wdsr_layer3_3x3_weights_17_21_layer3_weight_21_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_17_21_layer3_weight_21_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_17_21_layer3_weight_21(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_17_21_get_layer3_weight_21(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_17_22                                     0x181AB960
#define  SRNN_wdsr_layer3_3x3_weights_17_22_reg_addr                             "0xB81AB960"
#define  SRNN_wdsr_layer3_3x3_weights_17_22_reg                                  0xB81AB960
#define  SRNN_wdsr_layer3_3x3_weights_17_22_inst_addr                            "0x027C"
#define  set_SRNN_wdsr_layer3_3x3_weights_17_22_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_17_22_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_17_22_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_17_22_reg))
#define  SRNN_wdsr_layer3_3x3_weights_17_22_layer3_weight_22_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_17_22_layer3_weight_22_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_17_22_layer3_weight_22(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_17_22_get_layer3_weight_22(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_18_00                                     0x181AB964
#define  SRNN_wdsr_layer3_3x3_weights_18_00_reg_addr                             "0xB81AB964"
#define  SRNN_wdsr_layer3_3x3_weights_18_00_reg                                  0xB81AB964
#define  SRNN_wdsr_layer3_3x3_weights_18_00_inst_addr                            "0x027D"
#define  set_SRNN_wdsr_layer3_3x3_weights_18_00_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_18_00_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_18_00_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_18_00_reg))
#define  SRNN_wdsr_layer3_3x3_weights_18_00_layer3_weight_00_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_18_00_layer3_weight_00_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_18_00_layer3_weight_00(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_18_00_get_layer3_weight_00(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_18_01                                     0x181AB968
#define  SRNN_wdsr_layer3_3x3_weights_18_01_reg_addr                             "0xB81AB968"
#define  SRNN_wdsr_layer3_3x3_weights_18_01_reg                                  0xB81AB968
#define  SRNN_wdsr_layer3_3x3_weights_18_01_inst_addr                            "0x027E"
#define  set_SRNN_wdsr_layer3_3x3_weights_18_01_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_18_01_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_18_01_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_18_01_reg))
#define  SRNN_wdsr_layer3_3x3_weights_18_01_layer3_weight_01_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_18_01_layer3_weight_01_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_18_01_layer3_weight_01(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_18_01_get_layer3_weight_01(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_18_02                                     0x181AB96C
#define  SRNN_wdsr_layer3_3x3_weights_18_02_reg_addr                             "0xB81AB96C"
#define  SRNN_wdsr_layer3_3x3_weights_18_02_reg                                  0xB81AB96C
#define  SRNN_wdsr_layer3_3x3_weights_18_02_inst_addr                            "0x027F"
#define  set_SRNN_wdsr_layer3_3x3_weights_18_02_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_18_02_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_18_02_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_18_02_reg))
#define  SRNN_wdsr_layer3_3x3_weights_18_02_layer3_weight_02_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_18_02_layer3_weight_02_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_18_02_layer3_weight_02(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_18_02_get_layer3_weight_02(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_18_10                                     0x181AB970
#define  SRNN_wdsr_layer3_3x3_weights_18_10_reg_addr                             "0xB81AB970"
#define  SRNN_wdsr_layer3_3x3_weights_18_10_reg                                  0xB81AB970
#define  SRNN_wdsr_layer3_3x3_weights_18_10_inst_addr                            "0x0280"
#define  set_SRNN_wdsr_layer3_3x3_weights_18_10_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_18_10_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_18_10_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_18_10_reg))
#define  SRNN_wdsr_layer3_3x3_weights_18_10_layer3_weight_10_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_18_10_layer3_weight_10_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_18_10_layer3_weight_10(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_18_10_get_layer3_weight_10(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_18_11                                     0x181AB974
#define  SRNN_wdsr_layer3_3x3_weights_18_11_reg_addr                             "0xB81AB974"
#define  SRNN_wdsr_layer3_3x3_weights_18_11_reg                                  0xB81AB974
#define  SRNN_wdsr_layer3_3x3_weights_18_11_inst_addr                            "0x0281"
#define  set_SRNN_wdsr_layer3_3x3_weights_18_11_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_18_11_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_18_11_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_18_11_reg))
#define  SRNN_wdsr_layer3_3x3_weights_18_11_layer3_weight_11_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_18_11_layer3_weight_11_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_18_11_layer3_weight_11(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_18_11_get_layer3_weight_11(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_18_12                                     0x181AB978
#define  SRNN_wdsr_layer3_3x3_weights_18_12_reg_addr                             "0xB81AB978"
#define  SRNN_wdsr_layer3_3x3_weights_18_12_reg                                  0xB81AB978
#define  SRNN_wdsr_layer3_3x3_weights_18_12_inst_addr                            "0x0282"
#define  set_SRNN_wdsr_layer3_3x3_weights_18_12_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_18_12_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_18_12_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_18_12_reg))
#define  SRNN_wdsr_layer3_3x3_weights_18_12_layer3_weight_12_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_18_12_layer3_weight_12_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_18_12_layer3_weight_12(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_18_12_get_layer3_weight_12(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_18_20                                     0x181AB97C
#define  SRNN_wdsr_layer3_3x3_weights_18_20_reg_addr                             "0xB81AB97C"
#define  SRNN_wdsr_layer3_3x3_weights_18_20_reg                                  0xB81AB97C
#define  SRNN_wdsr_layer3_3x3_weights_18_20_inst_addr                            "0x0283"
#define  set_SRNN_wdsr_layer3_3x3_weights_18_20_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_18_20_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_18_20_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_18_20_reg))
#define  SRNN_wdsr_layer3_3x3_weights_18_20_layer3_weight_20_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_18_20_layer3_weight_20_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_18_20_layer3_weight_20(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_18_20_get_layer3_weight_20(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_18_21                                     0x181AB980
#define  SRNN_wdsr_layer3_3x3_weights_18_21_reg_addr                             "0xB81AB980"
#define  SRNN_wdsr_layer3_3x3_weights_18_21_reg                                  0xB81AB980
#define  SRNN_wdsr_layer3_3x3_weights_18_21_inst_addr                            "0x0284"
#define  set_SRNN_wdsr_layer3_3x3_weights_18_21_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_18_21_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_18_21_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_18_21_reg))
#define  SRNN_wdsr_layer3_3x3_weights_18_21_layer3_weight_21_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_18_21_layer3_weight_21_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_18_21_layer3_weight_21(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_18_21_get_layer3_weight_21(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_18_22                                     0x181AB984
#define  SRNN_wdsr_layer3_3x3_weights_18_22_reg_addr                             "0xB81AB984"
#define  SRNN_wdsr_layer3_3x3_weights_18_22_reg                                  0xB81AB984
#define  SRNN_wdsr_layer3_3x3_weights_18_22_inst_addr                            "0x0285"
#define  set_SRNN_wdsr_layer3_3x3_weights_18_22_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_18_22_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_18_22_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_18_22_reg))
#define  SRNN_wdsr_layer3_3x3_weights_18_22_layer3_weight_22_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_18_22_layer3_weight_22_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_18_22_layer3_weight_22(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_18_22_get_layer3_weight_22(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_19_00                                     0x181AB988
#define  SRNN_wdsr_layer3_3x3_weights_19_00_reg_addr                             "0xB81AB988"
#define  SRNN_wdsr_layer3_3x3_weights_19_00_reg                                  0xB81AB988
#define  SRNN_wdsr_layer3_3x3_weights_19_00_inst_addr                            "0x0286"
#define  set_SRNN_wdsr_layer3_3x3_weights_19_00_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_19_00_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_19_00_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_19_00_reg))
#define  SRNN_wdsr_layer3_3x3_weights_19_00_layer3_weight_00_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_19_00_layer3_weight_00_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_19_00_layer3_weight_00(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_19_00_get_layer3_weight_00(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_19_01                                     0x181AB98C
#define  SRNN_wdsr_layer3_3x3_weights_19_01_reg_addr                             "0xB81AB98C"
#define  SRNN_wdsr_layer3_3x3_weights_19_01_reg                                  0xB81AB98C
#define  SRNN_wdsr_layer3_3x3_weights_19_01_inst_addr                            "0x0287"
#define  set_SRNN_wdsr_layer3_3x3_weights_19_01_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_19_01_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_19_01_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_19_01_reg))
#define  SRNN_wdsr_layer3_3x3_weights_19_01_layer3_weight_01_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_19_01_layer3_weight_01_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_19_01_layer3_weight_01(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_19_01_get_layer3_weight_01(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_19_02                                     0x181AB990
#define  SRNN_wdsr_layer3_3x3_weights_19_02_reg_addr                             "0xB81AB990"
#define  SRNN_wdsr_layer3_3x3_weights_19_02_reg                                  0xB81AB990
#define  SRNN_wdsr_layer3_3x3_weights_19_02_inst_addr                            "0x0288"
#define  set_SRNN_wdsr_layer3_3x3_weights_19_02_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_19_02_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_19_02_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_19_02_reg))
#define  SRNN_wdsr_layer3_3x3_weights_19_02_layer3_weight_02_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_19_02_layer3_weight_02_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_19_02_layer3_weight_02(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_19_02_get_layer3_weight_02(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_19_10                                     0x181AB994
#define  SRNN_wdsr_layer3_3x3_weights_19_10_reg_addr                             "0xB81AB994"
#define  SRNN_wdsr_layer3_3x3_weights_19_10_reg                                  0xB81AB994
#define  SRNN_wdsr_layer3_3x3_weights_19_10_inst_addr                            "0x0289"
#define  set_SRNN_wdsr_layer3_3x3_weights_19_10_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_19_10_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_19_10_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_19_10_reg))
#define  SRNN_wdsr_layer3_3x3_weights_19_10_layer3_weight_10_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_19_10_layer3_weight_10_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_19_10_layer3_weight_10(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_19_10_get_layer3_weight_10(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_19_11                                     0x181AB998
#define  SRNN_wdsr_layer3_3x3_weights_19_11_reg_addr                             "0xB81AB998"
#define  SRNN_wdsr_layer3_3x3_weights_19_11_reg                                  0xB81AB998
#define  SRNN_wdsr_layer3_3x3_weights_19_11_inst_addr                            "0x028A"
#define  set_SRNN_wdsr_layer3_3x3_weights_19_11_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_19_11_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_19_11_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_19_11_reg))
#define  SRNN_wdsr_layer3_3x3_weights_19_11_layer3_weight_11_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_19_11_layer3_weight_11_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_19_11_layer3_weight_11(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_19_11_get_layer3_weight_11(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_19_12                                     0x181AB99C
#define  SRNN_wdsr_layer3_3x3_weights_19_12_reg_addr                             "0xB81AB99C"
#define  SRNN_wdsr_layer3_3x3_weights_19_12_reg                                  0xB81AB99C
#define  SRNN_wdsr_layer3_3x3_weights_19_12_inst_addr                            "0x028B"
#define  set_SRNN_wdsr_layer3_3x3_weights_19_12_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_19_12_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_19_12_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_19_12_reg))
#define  SRNN_wdsr_layer3_3x3_weights_19_12_layer3_weight_12_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_19_12_layer3_weight_12_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_19_12_layer3_weight_12(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_19_12_get_layer3_weight_12(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_19_20                                     0x181AB9A0
#define  SRNN_wdsr_layer3_3x3_weights_19_20_reg_addr                             "0xB81AB9A0"
#define  SRNN_wdsr_layer3_3x3_weights_19_20_reg                                  0xB81AB9A0
#define  SRNN_wdsr_layer3_3x3_weights_19_20_inst_addr                            "0x028C"
#define  set_SRNN_wdsr_layer3_3x3_weights_19_20_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_19_20_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_19_20_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_19_20_reg))
#define  SRNN_wdsr_layer3_3x3_weights_19_20_layer3_weight_20_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_19_20_layer3_weight_20_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_19_20_layer3_weight_20(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_19_20_get_layer3_weight_20(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_19_21                                     0x181AB9A4
#define  SRNN_wdsr_layer3_3x3_weights_19_21_reg_addr                             "0xB81AB9A4"
#define  SRNN_wdsr_layer3_3x3_weights_19_21_reg                                  0xB81AB9A4
#define  SRNN_wdsr_layer3_3x3_weights_19_21_inst_addr                            "0x028D"
#define  set_SRNN_wdsr_layer3_3x3_weights_19_21_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_19_21_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_19_21_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_19_21_reg))
#define  SRNN_wdsr_layer3_3x3_weights_19_21_layer3_weight_21_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_19_21_layer3_weight_21_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_19_21_layer3_weight_21(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_19_21_get_layer3_weight_21(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_19_22                                     0x181AB9A8
#define  SRNN_wdsr_layer3_3x3_weights_19_22_reg_addr                             "0xB81AB9A8"
#define  SRNN_wdsr_layer3_3x3_weights_19_22_reg                                  0xB81AB9A8
#define  SRNN_wdsr_layer3_3x3_weights_19_22_inst_addr                            "0x028E"
#define  set_SRNN_wdsr_layer3_3x3_weights_19_22_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_19_22_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_19_22_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_19_22_reg))
#define  SRNN_wdsr_layer3_3x3_weights_19_22_layer3_weight_22_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_19_22_layer3_weight_22_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_19_22_layer3_weight_22(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_19_22_get_layer3_weight_22(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_20_00                                     0x181AB9AC
#define  SRNN_wdsr_layer3_3x3_weights_20_00_reg_addr                             "0xB81AB9AC"
#define  SRNN_wdsr_layer3_3x3_weights_20_00_reg                                  0xB81AB9AC
#define  SRNN_wdsr_layer3_3x3_weights_20_00_inst_addr                            "0x028F"
#define  set_SRNN_wdsr_layer3_3x3_weights_20_00_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_20_00_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_20_00_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_20_00_reg))
#define  SRNN_wdsr_layer3_3x3_weights_20_00_layer3_weight_00_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_20_00_layer3_weight_00_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_20_00_layer3_weight_00(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_20_00_get_layer3_weight_00(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_20_01                                     0x181AB9B0
#define  SRNN_wdsr_layer3_3x3_weights_20_01_reg_addr                             "0xB81AB9B0"
#define  SRNN_wdsr_layer3_3x3_weights_20_01_reg                                  0xB81AB9B0
#define  SRNN_wdsr_layer3_3x3_weights_20_01_inst_addr                            "0x0290"
#define  set_SRNN_wdsr_layer3_3x3_weights_20_01_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_20_01_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_20_01_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_20_01_reg))
#define  SRNN_wdsr_layer3_3x3_weights_20_01_layer3_weight_01_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_20_01_layer3_weight_01_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_20_01_layer3_weight_01(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_20_01_get_layer3_weight_01(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_20_02                                     0x181AB9B4
#define  SRNN_wdsr_layer3_3x3_weights_20_02_reg_addr                             "0xB81AB9B4"
#define  SRNN_wdsr_layer3_3x3_weights_20_02_reg                                  0xB81AB9B4
#define  SRNN_wdsr_layer3_3x3_weights_20_02_inst_addr                            "0x0291"
#define  set_SRNN_wdsr_layer3_3x3_weights_20_02_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_20_02_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_20_02_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_20_02_reg))
#define  SRNN_wdsr_layer3_3x3_weights_20_02_layer3_weight_02_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_20_02_layer3_weight_02_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_20_02_layer3_weight_02(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_20_02_get_layer3_weight_02(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_20_10                                     0x181AB9B8
#define  SRNN_wdsr_layer3_3x3_weights_20_10_reg_addr                             "0xB81AB9B8"
#define  SRNN_wdsr_layer3_3x3_weights_20_10_reg                                  0xB81AB9B8
#define  SRNN_wdsr_layer3_3x3_weights_20_10_inst_addr                            "0x0292"
#define  set_SRNN_wdsr_layer3_3x3_weights_20_10_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_20_10_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_20_10_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_20_10_reg))
#define  SRNN_wdsr_layer3_3x3_weights_20_10_layer3_weight_10_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_20_10_layer3_weight_10_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_20_10_layer3_weight_10(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_20_10_get_layer3_weight_10(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_20_11                                     0x181AB9BC
#define  SRNN_wdsr_layer3_3x3_weights_20_11_reg_addr                             "0xB81AB9BC"
#define  SRNN_wdsr_layer3_3x3_weights_20_11_reg                                  0xB81AB9BC
#define  SRNN_wdsr_layer3_3x3_weights_20_11_inst_addr                            "0x0293"
#define  set_SRNN_wdsr_layer3_3x3_weights_20_11_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_20_11_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_20_11_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_20_11_reg))
#define  SRNN_wdsr_layer3_3x3_weights_20_11_layer3_weight_11_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_20_11_layer3_weight_11_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_20_11_layer3_weight_11(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_20_11_get_layer3_weight_11(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_20_12                                     0x181AB9C0
#define  SRNN_wdsr_layer3_3x3_weights_20_12_reg_addr                             "0xB81AB9C0"
#define  SRNN_wdsr_layer3_3x3_weights_20_12_reg                                  0xB81AB9C0
#define  SRNN_wdsr_layer3_3x3_weights_20_12_inst_addr                            "0x0294"
#define  set_SRNN_wdsr_layer3_3x3_weights_20_12_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_20_12_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_20_12_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_20_12_reg))
#define  SRNN_wdsr_layer3_3x3_weights_20_12_layer3_weight_12_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_20_12_layer3_weight_12_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_20_12_layer3_weight_12(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_20_12_get_layer3_weight_12(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_20_20                                     0x181AB9C4
#define  SRNN_wdsr_layer3_3x3_weights_20_20_reg_addr                             "0xB81AB9C4"
#define  SRNN_wdsr_layer3_3x3_weights_20_20_reg                                  0xB81AB9C4
#define  SRNN_wdsr_layer3_3x3_weights_20_20_inst_addr                            "0x0295"
#define  set_SRNN_wdsr_layer3_3x3_weights_20_20_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_20_20_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_20_20_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_20_20_reg))
#define  SRNN_wdsr_layer3_3x3_weights_20_20_layer3_weight_20_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_20_20_layer3_weight_20_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_20_20_layer3_weight_20(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_20_20_get_layer3_weight_20(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_20_21                                     0x181AB9C8
#define  SRNN_wdsr_layer3_3x3_weights_20_21_reg_addr                             "0xB81AB9C8"
#define  SRNN_wdsr_layer3_3x3_weights_20_21_reg                                  0xB81AB9C8
#define  SRNN_wdsr_layer3_3x3_weights_20_21_inst_addr                            "0x0296"
#define  set_SRNN_wdsr_layer3_3x3_weights_20_21_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_20_21_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_20_21_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_20_21_reg))
#define  SRNN_wdsr_layer3_3x3_weights_20_21_layer3_weight_21_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_20_21_layer3_weight_21_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_20_21_layer3_weight_21(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_20_21_get_layer3_weight_21(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_20_22                                     0x181AB9CC
#define  SRNN_wdsr_layer3_3x3_weights_20_22_reg_addr                             "0xB81AB9CC"
#define  SRNN_wdsr_layer3_3x3_weights_20_22_reg                                  0xB81AB9CC
#define  SRNN_wdsr_layer3_3x3_weights_20_22_inst_addr                            "0x0297"
#define  set_SRNN_wdsr_layer3_3x3_weights_20_22_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_20_22_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_20_22_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_20_22_reg))
#define  SRNN_wdsr_layer3_3x3_weights_20_22_layer3_weight_22_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_20_22_layer3_weight_22_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_20_22_layer3_weight_22(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_20_22_get_layer3_weight_22(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_21_00                                     0x181AB9D0
#define  SRNN_wdsr_layer3_3x3_weights_21_00_reg_addr                             "0xB81AB9D0"
#define  SRNN_wdsr_layer3_3x3_weights_21_00_reg                                  0xB81AB9D0
#define  SRNN_wdsr_layer3_3x3_weights_21_00_inst_addr                            "0x0298"
#define  set_SRNN_wdsr_layer3_3x3_weights_21_00_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_21_00_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_21_00_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_21_00_reg))
#define  SRNN_wdsr_layer3_3x3_weights_21_00_layer3_weight_00_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_21_00_layer3_weight_00_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_21_00_layer3_weight_00(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_21_00_get_layer3_weight_00(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_21_01                                     0x181AB9D4
#define  SRNN_wdsr_layer3_3x3_weights_21_01_reg_addr                             "0xB81AB9D4"
#define  SRNN_wdsr_layer3_3x3_weights_21_01_reg                                  0xB81AB9D4
#define  SRNN_wdsr_layer3_3x3_weights_21_01_inst_addr                            "0x0299"
#define  set_SRNN_wdsr_layer3_3x3_weights_21_01_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_21_01_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_21_01_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_21_01_reg))
#define  SRNN_wdsr_layer3_3x3_weights_21_01_layer3_weight_01_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_21_01_layer3_weight_01_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_21_01_layer3_weight_01(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_21_01_get_layer3_weight_01(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_21_02                                     0x181AB9D8
#define  SRNN_wdsr_layer3_3x3_weights_21_02_reg_addr                             "0xB81AB9D8"
#define  SRNN_wdsr_layer3_3x3_weights_21_02_reg                                  0xB81AB9D8
#define  SRNN_wdsr_layer3_3x3_weights_21_02_inst_addr                            "0x029A"
#define  set_SRNN_wdsr_layer3_3x3_weights_21_02_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_21_02_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_21_02_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_21_02_reg))
#define  SRNN_wdsr_layer3_3x3_weights_21_02_layer3_weight_02_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_21_02_layer3_weight_02_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_21_02_layer3_weight_02(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_21_02_get_layer3_weight_02(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_21_10                                     0x181AB9DC
#define  SRNN_wdsr_layer3_3x3_weights_21_10_reg_addr                             "0xB81AB9DC"
#define  SRNN_wdsr_layer3_3x3_weights_21_10_reg                                  0xB81AB9DC
#define  SRNN_wdsr_layer3_3x3_weights_21_10_inst_addr                            "0x029B"
#define  set_SRNN_wdsr_layer3_3x3_weights_21_10_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_21_10_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_21_10_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_21_10_reg))
#define  SRNN_wdsr_layer3_3x3_weights_21_10_layer3_weight_10_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_21_10_layer3_weight_10_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_21_10_layer3_weight_10(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_21_10_get_layer3_weight_10(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_21_11                                     0x181AB9E0
#define  SRNN_wdsr_layer3_3x3_weights_21_11_reg_addr                             "0xB81AB9E0"
#define  SRNN_wdsr_layer3_3x3_weights_21_11_reg                                  0xB81AB9E0
#define  SRNN_wdsr_layer3_3x3_weights_21_11_inst_addr                            "0x029C"
#define  set_SRNN_wdsr_layer3_3x3_weights_21_11_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_21_11_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_21_11_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_21_11_reg))
#define  SRNN_wdsr_layer3_3x3_weights_21_11_layer3_weight_11_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_21_11_layer3_weight_11_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_21_11_layer3_weight_11(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_21_11_get_layer3_weight_11(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_21_12                                     0x181AB9E4
#define  SRNN_wdsr_layer3_3x3_weights_21_12_reg_addr                             "0xB81AB9E4"
#define  SRNN_wdsr_layer3_3x3_weights_21_12_reg                                  0xB81AB9E4
#define  SRNN_wdsr_layer3_3x3_weights_21_12_inst_addr                            "0x029D"
#define  set_SRNN_wdsr_layer3_3x3_weights_21_12_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_21_12_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_21_12_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_21_12_reg))
#define  SRNN_wdsr_layer3_3x3_weights_21_12_layer3_weight_12_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_21_12_layer3_weight_12_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_21_12_layer3_weight_12(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_21_12_get_layer3_weight_12(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_21_20                                     0x181AB9E8
#define  SRNN_wdsr_layer3_3x3_weights_21_20_reg_addr                             "0xB81AB9E8"
#define  SRNN_wdsr_layer3_3x3_weights_21_20_reg                                  0xB81AB9E8
#define  SRNN_wdsr_layer3_3x3_weights_21_20_inst_addr                            "0x029E"
#define  set_SRNN_wdsr_layer3_3x3_weights_21_20_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_21_20_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_21_20_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_21_20_reg))
#define  SRNN_wdsr_layer3_3x3_weights_21_20_layer3_weight_20_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_21_20_layer3_weight_20_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_21_20_layer3_weight_20(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_21_20_get_layer3_weight_20(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_21_21                                     0x181AB9EC
#define  SRNN_wdsr_layer3_3x3_weights_21_21_reg_addr                             "0xB81AB9EC"
#define  SRNN_wdsr_layer3_3x3_weights_21_21_reg                                  0xB81AB9EC
#define  SRNN_wdsr_layer3_3x3_weights_21_21_inst_addr                            "0x029F"
#define  set_SRNN_wdsr_layer3_3x3_weights_21_21_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_21_21_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_21_21_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_21_21_reg))
#define  SRNN_wdsr_layer3_3x3_weights_21_21_layer3_weight_21_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_21_21_layer3_weight_21_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_21_21_layer3_weight_21(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_21_21_get_layer3_weight_21(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_21_22                                     0x181AB9F0
#define  SRNN_wdsr_layer3_3x3_weights_21_22_reg_addr                             "0xB81AB9F0"
#define  SRNN_wdsr_layer3_3x3_weights_21_22_reg                                  0xB81AB9F0
#define  SRNN_wdsr_layer3_3x3_weights_21_22_inst_addr                            "0x02A0"
#define  set_SRNN_wdsr_layer3_3x3_weights_21_22_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_21_22_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_21_22_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_21_22_reg))
#define  SRNN_wdsr_layer3_3x3_weights_21_22_layer3_weight_22_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_21_22_layer3_weight_22_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_21_22_layer3_weight_22(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_21_22_get_layer3_weight_22(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_22_00                                     0x181AB9F4
#define  SRNN_wdsr_layer3_3x3_weights_22_00_reg_addr                             "0xB81AB9F4"
#define  SRNN_wdsr_layer3_3x3_weights_22_00_reg                                  0xB81AB9F4
#define  SRNN_wdsr_layer3_3x3_weights_22_00_inst_addr                            "0x02A1"
#define  set_SRNN_wdsr_layer3_3x3_weights_22_00_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_22_00_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_22_00_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_22_00_reg))
#define  SRNN_wdsr_layer3_3x3_weights_22_00_layer3_weight_00_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_22_00_layer3_weight_00_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_22_00_layer3_weight_00(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_22_00_get_layer3_weight_00(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_22_01                                     0x181AB9F8
#define  SRNN_wdsr_layer3_3x3_weights_22_01_reg_addr                             "0xB81AB9F8"
#define  SRNN_wdsr_layer3_3x3_weights_22_01_reg                                  0xB81AB9F8
#define  SRNN_wdsr_layer3_3x3_weights_22_01_inst_addr                            "0x02A2"
#define  set_SRNN_wdsr_layer3_3x3_weights_22_01_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_22_01_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_22_01_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_22_01_reg))
#define  SRNN_wdsr_layer3_3x3_weights_22_01_layer3_weight_01_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_22_01_layer3_weight_01_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_22_01_layer3_weight_01(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_22_01_get_layer3_weight_01(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_22_02                                     0x181AB9FC
#define  SRNN_wdsr_layer3_3x3_weights_22_02_reg_addr                             "0xB81AB9FC"
#define  SRNN_wdsr_layer3_3x3_weights_22_02_reg                                  0xB81AB9FC
#define  SRNN_wdsr_layer3_3x3_weights_22_02_inst_addr                            "0x02A3"
#define  set_SRNN_wdsr_layer3_3x3_weights_22_02_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_22_02_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_22_02_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_22_02_reg))
#define  SRNN_wdsr_layer3_3x3_weights_22_02_layer3_weight_02_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_22_02_layer3_weight_02_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_22_02_layer3_weight_02(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_22_02_get_layer3_weight_02(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_22_10                                     0x181ABA00
#define  SRNN_wdsr_layer3_3x3_weights_22_10_reg_addr                             "0xB81ABA00"
#define  SRNN_wdsr_layer3_3x3_weights_22_10_reg                                  0xB81ABA00
#define  SRNN_wdsr_layer3_3x3_weights_22_10_inst_addr                            "0x02A4"
#define  set_SRNN_wdsr_layer3_3x3_weights_22_10_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_22_10_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_22_10_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_22_10_reg))
#define  SRNN_wdsr_layer3_3x3_weights_22_10_layer3_weight_10_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_22_10_layer3_weight_10_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_22_10_layer3_weight_10(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_22_10_get_layer3_weight_10(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_22_11                                     0x181ABA04
#define  SRNN_wdsr_layer3_3x3_weights_22_11_reg_addr                             "0xB81ABA04"
#define  SRNN_wdsr_layer3_3x3_weights_22_11_reg                                  0xB81ABA04
#define  SRNN_wdsr_layer3_3x3_weights_22_11_inst_addr                            "0x02A5"
#define  set_SRNN_wdsr_layer3_3x3_weights_22_11_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_22_11_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_22_11_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_22_11_reg))
#define  SRNN_wdsr_layer3_3x3_weights_22_11_layer3_weight_11_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_22_11_layer3_weight_11_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_22_11_layer3_weight_11(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_22_11_get_layer3_weight_11(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_22_12                                     0x181ABA08
#define  SRNN_wdsr_layer3_3x3_weights_22_12_reg_addr                             "0xB81ABA08"
#define  SRNN_wdsr_layer3_3x3_weights_22_12_reg                                  0xB81ABA08
#define  SRNN_wdsr_layer3_3x3_weights_22_12_inst_addr                            "0x02A6"
#define  set_SRNN_wdsr_layer3_3x3_weights_22_12_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_22_12_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_22_12_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_22_12_reg))
#define  SRNN_wdsr_layer3_3x3_weights_22_12_layer3_weight_12_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_22_12_layer3_weight_12_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_22_12_layer3_weight_12(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_22_12_get_layer3_weight_12(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_22_20                                     0x181ABA0C
#define  SRNN_wdsr_layer3_3x3_weights_22_20_reg_addr                             "0xB81ABA0C"
#define  SRNN_wdsr_layer3_3x3_weights_22_20_reg                                  0xB81ABA0C
#define  SRNN_wdsr_layer3_3x3_weights_22_20_inst_addr                            "0x02A7"
#define  set_SRNN_wdsr_layer3_3x3_weights_22_20_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_22_20_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_22_20_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_22_20_reg))
#define  SRNN_wdsr_layer3_3x3_weights_22_20_layer3_weight_20_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_22_20_layer3_weight_20_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_22_20_layer3_weight_20(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_22_20_get_layer3_weight_20(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_22_21                                     0x181ABA10
#define  SRNN_wdsr_layer3_3x3_weights_22_21_reg_addr                             "0xB81ABA10"
#define  SRNN_wdsr_layer3_3x3_weights_22_21_reg                                  0xB81ABA10
#define  SRNN_wdsr_layer3_3x3_weights_22_21_inst_addr                            "0x02A8"
#define  set_SRNN_wdsr_layer3_3x3_weights_22_21_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_22_21_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_22_21_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_22_21_reg))
#define  SRNN_wdsr_layer3_3x3_weights_22_21_layer3_weight_21_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_22_21_layer3_weight_21_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_22_21_layer3_weight_21(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_22_21_get_layer3_weight_21(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_22_22                                     0x181ABA14
#define  SRNN_wdsr_layer3_3x3_weights_22_22_reg_addr                             "0xB81ABA14"
#define  SRNN_wdsr_layer3_3x3_weights_22_22_reg                                  0xB81ABA14
#define  SRNN_wdsr_layer3_3x3_weights_22_22_inst_addr                            "0x02A9"
#define  set_SRNN_wdsr_layer3_3x3_weights_22_22_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_22_22_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_22_22_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_22_22_reg))
#define  SRNN_wdsr_layer3_3x3_weights_22_22_layer3_weight_22_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_22_22_layer3_weight_22_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_22_22_layer3_weight_22(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_22_22_get_layer3_weight_22(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_23_00                                     0x181ABA18
#define  SRNN_wdsr_layer3_3x3_weights_23_00_reg_addr                             "0xB81ABA18"
#define  SRNN_wdsr_layer3_3x3_weights_23_00_reg                                  0xB81ABA18
#define  SRNN_wdsr_layer3_3x3_weights_23_00_inst_addr                            "0x02AA"
#define  set_SRNN_wdsr_layer3_3x3_weights_23_00_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_23_00_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_23_00_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_23_00_reg))
#define  SRNN_wdsr_layer3_3x3_weights_23_00_layer3_weight_00_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_23_00_layer3_weight_00_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_23_00_layer3_weight_00(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_23_00_get_layer3_weight_00(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_23_01                                     0x181ABA1C
#define  SRNN_wdsr_layer3_3x3_weights_23_01_reg_addr                             "0xB81ABA1C"
#define  SRNN_wdsr_layer3_3x3_weights_23_01_reg                                  0xB81ABA1C
#define  SRNN_wdsr_layer3_3x3_weights_23_01_inst_addr                            "0x02AB"
#define  set_SRNN_wdsr_layer3_3x3_weights_23_01_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_23_01_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_23_01_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_23_01_reg))
#define  SRNN_wdsr_layer3_3x3_weights_23_01_layer3_weight_01_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_23_01_layer3_weight_01_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_23_01_layer3_weight_01(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_23_01_get_layer3_weight_01(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_23_02                                     0x181ABA20
#define  SRNN_wdsr_layer3_3x3_weights_23_02_reg_addr                             "0xB81ABA20"
#define  SRNN_wdsr_layer3_3x3_weights_23_02_reg                                  0xB81ABA20
#define  SRNN_wdsr_layer3_3x3_weights_23_02_inst_addr                            "0x02AC"
#define  set_SRNN_wdsr_layer3_3x3_weights_23_02_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_23_02_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_23_02_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_23_02_reg))
#define  SRNN_wdsr_layer3_3x3_weights_23_02_layer3_weight_02_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_23_02_layer3_weight_02_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_23_02_layer3_weight_02(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_23_02_get_layer3_weight_02(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_23_10                                     0x181ABA24
#define  SRNN_wdsr_layer3_3x3_weights_23_10_reg_addr                             "0xB81ABA24"
#define  SRNN_wdsr_layer3_3x3_weights_23_10_reg                                  0xB81ABA24
#define  SRNN_wdsr_layer3_3x3_weights_23_10_inst_addr                            "0x02AD"
#define  set_SRNN_wdsr_layer3_3x3_weights_23_10_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_23_10_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_23_10_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_23_10_reg))
#define  SRNN_wdsr_layer3_3x3_weights_23_10_layer3_weight_10_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_23_10_layer3_weight_10_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_23_10_layer3_weight_10(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_23_10_get_layer3_weight_10(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_23_11                                     0x181ABA28
#define  SRNN_wdsr_layer3_3x3_weights_23_11_reg_addr                             "0xB81ABA28"
#define  SRNN_wdsr_layer3_3x3_weights_23_11_reg                                  0xB81ABA28
#define  SRNN_wdsr_layer3_3x3_weights_23_11_inst_addr                            "0x02AE"
#define  set_SRNN_wdsr_layer3_3x3_weights_23_11_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_23_11_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_23_11_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_23_11_reg))
#define  SRNN_wdsr_layer3_3x3_weights_23_11_layer3_weight_11_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_23_11_layer3_weight_11_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_23_11_layer3_weight_11(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_23_11_get_layer3_weight_11(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_23_12                                     0x181ABA2C
#define  SRNN_wdsr_layer3_3x3_weights_23_12_reg_addr                             "0xB81ABA2C"
#define  SRNN_wdsr_layer3_3x3_weights_23_12_reg                                  0xB81ABA2C
#define  SRNN_wdsr_layer3_3x3_weights_23_12_inst_addr                            "0x02AF"
#define  set_SRNN_wdsr_layer3_3x3_weights_23_12_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_23_12_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_23_12_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_23_12_reg))
#define  SRNN_wdsr_layer3_3x3_weights_23_12_layer3_weight_12_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_23_12_layer3_weight_12_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_23_12_layer3_weight_12(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_23_12_get_layer3_weight_12(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_23_20                                     0x181ABA30
#define  SRNN_wdsr_layer3_3x3_weights_23_20_reg_addr                             "0xB81ABA30"
#define  SRNN_wdsr_layer3_3x3_weights_23_20_reg                                  0xB81ABA30
#define  SRNN_wdsr_layer3_3x3_weights_23_20_inst_addr                            "0x02B0"
#define  set_SRNN_wdsr_layer3_3x3_weights_23_20_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_23_20_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_23_20_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_23_20_reg))
#define  SRNN_wdsr_layer3_3x3_weights_23_20_layer3_weight_20_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_23_20_layer3_weight_20_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_23_20_layer3_weight_20(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_23_20_get_layer3_weight_20(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_23_21                                     0x181ABA34
#define  SRNN_wdsr_layer3_3x3_weights_23_21_reg_addr                             "0xB81ABA34"
#define  SRNN_wdsr_layer3_3x3_weights_23_21_reg                                  0xB81ABA34
#define  SRNN_wdsr_layer3_3x3_weights_23_21_inst_addr                            "0x02B1"
#define  set_SRNN_wdsr_layer3_3x3_weights_23_21_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_23_21_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_23_21_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_23_21_reg))
#define  SRNN_wdsr_layer3_3x3_weights_23_21_layer3_weight_21_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_23_21_layer3_weight_21_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_23_21_layer3_weight_21(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_23_21_get_layer3_weight_21(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_23_22                                     0x181ABA38
#define  SRNN_wdsr_layer3_3x3_weights_23_22_reg_addr                             "0xB81ABA38"
#define  SRNN_wdsr_layer3_3x3_weights_23_22_reg                                  0xB81ABA38
#define  SRNN_wdsr_layer3_3x3_weights_23_22_inst_addr                            "0x02B2"
#define  set_SRNN_wdsr_layer3_3x3_weights_23_22_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_23_22_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_23_22_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_23_22_reg))
#define  SRNN_wdsr_layer3_3x3_weights_23_22_layer3_weight_22_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_23_22_layer3_weight_22_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_23_22_layer3_weight_22(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_23_22_get_layer3_weight_22(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_24_00                                     0x181ABA3C
#define  SRNN_wdsr_layer3_3x3_weights_24_00_reg_addr                             "0xB81ABA3C"
#define  SRNN_wdsr_layer3_3x3_weights_24_00_reg                                  0xB81ABA3C
#define  SRNN_wdsr_layer3_3x3_weights_24_00_inst_addr                            "0x02B3"
#define  set_SRNN_wdsr_layer3_3x3_weights_24_00_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_24_00_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_24_00_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_24_00_reg))
#define  SRNN_wdsr_layer3_3x3_weights_24_00_layer3_weight_00_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_24_00_layer3_weight_00_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_24_00_layer3_weight_00(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_24_00_get_layer3_weight_00(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_24_01                                     0x181ABA40
#define  SRNN_wdsr_layer3_3x3_weights_24_01_reg_addr                             "0xB81ABA40"
#define  SRNN_wdsr_layer3_3x3_weights_24_01_reg                                  0xB81ABA40
#define  SRNN_wdsr_layer3_3x3_weights_24_01_inst_addr                            "0x02B4"
#define  set_SRNN_wdsr_layer3_3x3_weights_24_01_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_24_01_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_24_01_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_24_01_reg))
#define  SRNN_wdsr_layer3_3x3_weights_24_01_layer3_weight_01_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_24_01_layer3_weight_01_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_24_01_layer3_weight_01(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_24_01_get_layer3_weight_01(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_24_02                                     0x181ABA44
#define  SRNN_wdsr_layer3_3x3_weights_24_02_reg_addr                             "0xB81ABA44"
#define  SRNN_wdsr_layer3_3x3_weights_24_02_reg                                  0xB81ABA44
#define  SRNN_wdsr_layer3_3x3_weights_24_02_inst_addr                            "0x02B5"
#define  set_SRNN_wdsr_layer3_3x3_weights_24_02_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_24_02_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_24_02_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_24_02_reg))
#define  SRNN_wdsr_layer3_3x3_weights_24_02_layer3_weight_02_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_24_02_layer3_weight_02_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_24_02_layer3_weight_02(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_24_02_get_layer3_weight_02(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_24_10                                     0x181ABA48
#define  SRNN_wdsr_layer3_3x3_weights_24_10_reg_addr                             "0xB81ABA48"
#define  SRNN_wdsr_layer3_3x3_weights_24_10_reg                                  0xB81ABA48
#define  SRNN_wdsr_layer3_3x3_weights_24_10_inst_addr                            "0x02B6"
#define  set_SRNN_wdsr_layer3_3x3_weights_24_10_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_24_10_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_24_10_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_24_10_reg))
#define  SRNN_wdsr_layer3_3x3_weights_24_10_layer3_weight_10_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_24_10_layer3_weight_10_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_24_10_layer3_weight_10(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_24_10_get_layer3_weight_10(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_24_11                                     0x181ABA4C
#define  SRNN_wdsr_layer3_3x3_weights_24_11_reg_addr                             "0xB81ABA4C"
#define  SRNN_wdsr_layer3_3x3_weights_24_11_reg                                  0xB81ABA4C
#define  SRNN_wdsr_layer3_3x3_weights_24_11_inst_addr                            "0x02B7"
#define  set_SRNN_wdsr_layer3_3x3_weights_24_11_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_24_11_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_24_11_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_24_11_reg))
#define  SRNN_wdsr_layer3_3x3_weights_24_11_layer3_weight_11_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_24_11_layer3_weight_11_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_24_11_layer3_weight_11(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_24_11_get_layer3_weight_11(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_24_12                                     0x181ABA50
#define  SRNN_wdsr_layer3_3x3_weights_24_12_reg_addr                             "0xB81ABA50"
#define  SRNN_wdsr_layer3_3x3_weights_24_12_reg                                  0xB81ABA50
#define  SRNN_wdsr_layer3_3x3_weights_24_12_inst_addr                            "0x02B8"
#define  set_SRNN_wdsr_layer3_3x3_weights_24_12_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_24_12_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_24_12_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_24_12_reg))
#define  SRNN_wdsr_layer3_3x3_weights_24_12_layer3_weight_12_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_24_12_layer3_weight_12_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_24_12_layer3_weight_12(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_24_12_get_layer3_weight_12(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_24_20                                     0x181ABA54
#define  SRNN_wdsr_layer3_3x3_weights_24_20_reg_addr                             "0xB81ABA54"
#define  SRNN_wdsr_layer3_3x3_weights_24_20_reg                                  0xB81ABA54
#define  SRNN_wdsr_layer3_3x3_weights_24_20_inst_addr                            "0x02B9"
#define  set_SRNN_wdsr_layer3_3x3_weights_24_20_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_24_20_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_24_20_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_24_20_reg))
#define  SRNN_wdsr_layer3_3x3_weights_24_20_layer3_weight_20_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_24_20_layer3_weight_20_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_24_20_layer3_weight_20(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_24_20_get_layer3_weight_20(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_24_21                                     0x181ABA58
#define  SRNN_wdsr_layer3_3x3_weights_24_21_reg_addr                             "0xB81ABA58"
#define  SRNN_wdsr_layer3_3x3_weights_24_21_reg                                  0xB81ABA58
#define  SRNN_wdsr_layer3_3x3_weights_24_21_inst_addr                            "0x02BA"
#define  set_SRNN_wdsr_layer3_3x3_weights_24_21_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_24_21_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_24_21_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_24_21_reg))
#define  SRNN_wdsr_layer3_3x3_weights_24_21_layer3_weight_21_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_24_21_layer3_weight_21_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_24_21_layer3_weight_21(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_24_21_get_layer3_weight_21(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_24_22                                     0x181ABA5C
#define  SRNN_wdsr_layer3_3x3_weights_24_22_reg_addr                             "0xB81ABA5C"
#define  SRNN_wdsr_layer3_3x3_weights_24_22_reg                                  0xB81ABA5C
#define  SRNN_wdsr_layer3_3x3_weights_24_22_inst_addr                            "0x02BB"
#define  set_SRNN_wdsr_layer3_3x3_weights_24_22_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_24_22_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_24_22_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_24_22_reg))
#define  SRNN_wdsr_layer3_3x3_weights_24_22_layer3_weight_22_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_24_22_layer3_weight_22_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_24_22_layer3_weight_22(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_24_22_get_layer3_weight_22(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_25_00                                     0x181ABA60
#define  SRNN_wdsr_layer3_3x3_weights_25_00_reg_addr                             "0xB81ABA60"
#define  SRNN_wdsr_layer3_3x3_weights_25_00_reg                                  0xB81ABA60
#define  SRNN_wdsr_layer3_3x3_weights_25_00_inst_addr                            "0x02BC"
#define  set_SRNN_wdsr_layer3_3x3_weights_25_00_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_25_00_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_25_00_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_25_00_reg))
#define  SRNN_wdsr_layer3_3x3_weights_25_00_layer3_weight_00_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_25_00_layer3_weight_00_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_25_00_layer3_weight_00(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_25_00_get_layer3_weight_00(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_25_01                                     0x181ABA64
#define  SRNN_wdsr_layer3_3x3_weights_25_01_reg_addr                             "0xB81ABA64"
#define  SRNN_wdsr_layer3_3x3_weights_25_01_reg                                  0xB81ABA64
#define  SRNN_wdsr_layer3_3x3_weights_25_01_inst_addr                            "0x02BD"
#define  set_SRNN_wdsr_layer3_3x3_weights_25_01_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_25_01_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_25_01_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_25_01_reg))
#define  SRNN_wdsr_layer3_3x3_weights_25_01_layer3_weight_01_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_25_01_layer3_weight_01_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_25_01_layer3_weight_01(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_25_01_get_layer3_weight_01(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_25_02                                     0x181ABA68
#define  SRNN_wdsr_layer3_3x3_weights_25_02_reg_addr                             "0xB81ABA68"
#define  SRNN_wdsr_layer3_3x3_weights_25_02_reg                                  0xB81ABA68
#define  SRNN_wdsr_layer3_3x3_weights_25_02_inst_addr                            "0x02BE"
#define  set_SRNN_wdsr_layer3_3x3_weights_25_02_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_25_02_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_25_02_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_25_02_reg))
#define  SRNN_wdsr_layer3_3x3_weights_25_02_layer3_weight_02_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_25_02_layer3_weight_02_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_25_02_layer3_weight_02(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_25_02_get_layer3_weight_02(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_25_10                                     0x181ABA6C
#define  SRNN_wdsr_layer3_3x3_weights_25_10_reg_addr                             "0xB81ABA6C"
#define  SRNN_wdsr_layer3_3x3_weights_25_10_reg                                  0xB81ABA6C
#define  SRNN_wdsr_layer3_3x3_weights_25_10_inst_addr                            "0x02BF"
#define  set_SRNN_wdsr_layer3_3x3_weights_25_10_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_25_10_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_25_10_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_25_10_reg))
#define  SRNN_wdsr_layer3_3x3_weights_25_10_layer3_weight_10_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_25_10_layer3_weight_10_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_25_10_layer3_weight_10(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_25_10_get_layer3_weight_10(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_25_11                                     0x181ABA70
#define  SRNN_wdsr_layer3_3x3_weights_25_11_reg_addr                             "0xB81ABA70"
#define  SRNN_wdsr_layer3_3x3_weights_25_11_reg                                  0xB81ABA70
#define  SRNN_wdsr_layer3_3x3_weights_25_11_inst_addr                            "0x02C0"
#define  set_SRNN_wdsr_layer3_3x3_weights_25_11_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_25_11_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_25_11_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_25_11_reg))
#define  SRNN_wdsr_layer3_3x3_weights_25_11_layer3_weight_11_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_25_11_layer3_weight_11_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_25_11_layer3_weight_11(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_25_11_get_layer3_weight_11(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_25_12                                     0x181ABA74
#define  SRNN_wdsr_layer3_3x3_weights_25_12_reg_addr                             "0xB81ABA74"
#define  SRNN_wdsr_layer3_3x3_weights_25_12_reg                                  0xB81ABA74
#define  SRNN_wdsr_layer3_3x3_weights_25_12_inst_addr                            "0x02C1"
#define  set_SRNN_wdsr_layer3_3x3_weights_25_12_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_25_12_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_25_12_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_25_12_reg))
#define  SRNN_wdsr_layer3_3x3_weights_25_12_layer3_weight_12_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_25_12_layer3_weight_12_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_25_12_layer3_weight_12(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_25_12_get_layer3_weight_12(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_25_20                                     0x181ABA78
#define  SRNN_wdsr_layer3_3x3_weights_25_20_reg_addr                             "0xB81ABA78"
#define  SRNN_wdsr_layer3_3x3_weights_25_20_reg                                  0xB81ABA78
#define  SRNN_wdsr_layer3_3x3_weights_25_20_inst_addr                            "0x02C2"
#define  set_SRNN_wdsr_layer3_3x3_weights_25_20_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_25_20_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_25_20_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_25_20_reg))
#define  SRNN_wdsr_layer3_3x3_weights_25_20_layer3_weight_20_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_25_20_layer3_weight_20_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_25_20_layer3_weight_20(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_25_20_get_layer3_weight_20(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_25_21                                     0x181ABA7C
#define  SRNN_wdsr_layer3_3x3_weights_25_21_reg_addr                             "0xB81ABA7C"
#define  SRNN_wdsr_layer3_3x3_weights_25_21_reg                                  0xB81ABA7C
#define  SRNN_wdsr_layer3_3x3_weights_25_21_inst_addr                            "0x02C3"
#define  set_SRNN_wdsr_layer3_3x3_weights_25_21_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_25_21_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_25_21_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_25_21_reg))
#define  SRNN_wdsr_layer3_3x3_weights_25_21_layer3_weight_21_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_25_21_layer3_weight_21_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_25_21_layer3_weight_21(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_25_21_get_layer3_weight_21(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_25_22                                     0x181ABA80
#define  SRNN_wdsr_layer3_3x3_weights_25_22_reg_addr                             "0xB81ABA80"
#define  SRNN_wdsr_layer3_3x3_weights_25_22_reg                                  0xB81ABA80
#define  SRNN_wdsr_layer3_3x3_weights_25_22_inst_addr                            "0x02C4"
#define  set_SRNN_wdsr_layer3_3x3_weights_25_22_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_25_22_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_25_22_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_25_22_reg))
#define  SRNN_wdsr_layer3_3x3_weights_25_22_layer3_weight_22_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_25_22_layer3_weight_22_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_25_22_layer3_weight_22(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_25_22_get_layer3_weight_22(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_26_00                                     0x181ABA84
#define  SRNN_wdsr_layer3_3x3_weights_26_00_reg_addr                             "0xB81ABA84"
#define  SRNN_wdsr_layer3_3x3_weights_26_00_reg                                  0xB81ABA84
#define  SRNN_wdsr_layer3_3x3_weights_26_00_inst_addr                            "0x02C5"
#define  set_SRNN_wdsr_layer3_3x3_weights_26_00_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_26_00_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_26_00_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_26_00_reg))
#define  SRNN_wdsr_layer3_3x3_weights_26_00_layer3_weight_00_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_26_00_layer3_weight_00_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_26_00_layer3_weight_00(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_26_00_get_layer3_weight_00(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_26_01                                     0x181ABA88
#define  SRNN_wdsr_layer3_3x3_weights_26_01_reg_addr                             "0xB81ABA88"
#define  SRNN_wdsr_layer3_3x3_weights_26_01_reg                                  0xB81ABA88
#define  SRNN_wdsr_layer3_3x3_weights_26_01_inst_addr                            "0x02C6"
#define  set_SRNN_wdsr_layer3_3x3_weights_26_01_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_26_01_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_26_01_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_26_01_reg))
#define  SRNN_wdsr_layer3_3x3_weights_26_01_layer3_weight_01_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_26_01_layer3_weight_01_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_26_01_layer3_weight_01(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_26_01_get_layer3_weight_01(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_26_02                                     0x181ABA8C
#define  SRNN_wdsr_layer3_3x3_weights_26_02_reg_addr                             "0xB81ABA8C"
#define  SRNN_wdsr_layer3_3x3_weights_26_02_reg                                  0xB81ABA8C
#define  SRNN_wdsr_layer3_3x3_weights_26_02_inst_addr                            "0x02C7"
#define  set_SRNN_wdsr_layer3_3x3_weights_26_02_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_26_02_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_26_02_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_26_02_reg))
#define  SRNN_wdsr_layer3_3x3_weights_26_02_layer3_weight_02_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_26_02_layer3_weight_02_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_26_02_layer3_weight_02(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_26_02_get_layer3_weight_02(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_26_10                                     0x181ABA90
#define  SRNN_wdsr_layer3_3x3_weights_26_10_reg_addr                             "0xB81ABA90"
#define  SRNN_wdsr_layer3_3x3_weights_26_10_reg                                  0xB81ABA90
#define  SRNN_wdsr_layer3_3x3_weights_26_10_inst_addr                            "0x02C8"
#define  set_SRNN_wdsr_layer3_3x3_weights_26_10_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_26_10_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_26_10_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_26_10_reg))
#define  SRNN_wdsr_layer3_3x3_weights_26_10_layer3_weight_10_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_26_10_layer3_weight_10_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_26_10_layer3_weight_10(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_26_10_get_layer3_weight_10(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_26_11                                     0x181ABA94
#define  SRNN_wdsr_layer3_3x3_weights_26_11_reg_addr                             "0xB81ABA94"
#define  SRNN_wdsr_layer3_3x3_weights_26_11_reg                                  0xB81ABA94
#define  SRNN_wdsr_layer3_3x3_weights_26_11_inst_addr                            "0x02C9"
#define  set_SRNN_wdsr_layer3_3x3_weights_26_11_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_26_11_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_26_11_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_26_11_reg))
#define  SRNN_wdsr_layer3_3x3_weights_26_11_layer3_weight_11_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_26_11_layer3_weight_11_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_26_11_layer3_weight_11(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_26_11_get_layer3_weight_11(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_26_12                                     0x181ABA98
#define  SRNN_wdsr_layer3_3x3_weights_26_12_reg_addr                             "0xB81ABA98"
#define  SRNN_wdsr_layer3_3x3_weights_26_12_reg                                  0xB81ABA98
#define  SRNN_wdsr_layer3_3x3_weights_26_12_inst_addr                            "0x02CA"
#define  set_SRNN_wdsr_layer3_3x3_weights_26_12_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_26_12_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_26_12_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_26_12_reg))
#define  SRNN_wdsr_layer3_3x3_weights_26_12_layer3_weight_12_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_26_12_layer3_weight_12_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_26_12_layer3_weight_12(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_26_12_get_layer3_weight_12(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_26_20                                     0x181ABA9C
#define  SRNN_wdsr_layer3_3x3_weights_26_20_reg_addr                             "0xB81ABA9C"
#define  SRNN_wdsr_layer3_3x3_weights_26_20_reg                                  0xB81ABA9C
#define  SRNN_wdsr_layer3_3x3_weights_26_20_inst_addr                            "0x02CB"
#define  set_SRNN_wdsr_layer3_3x3_weights_26_20_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_26_20_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_26_20_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_26_20_reg))
#define  SRNN_wdsr_layer3_3x3_weights_26_20_layer3_weight_20_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_26_20_layer3_weight_20_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_26_20_layer3_weight_20(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_26_20_get_layer3_weight_20(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_26_21                                     0x181ABAA0
#define  SRNN_wdsr_layer3_3x3_weights_26_21_reg_addr                             "0xB81ABAA0"
#define  SRNN_wdsr_layer3_3x3_weights_26_21_reg                                  0xB81ABAA0
#define  SRNN_wdsr_layer3_3x3_weights_26_21_inst_addr                            "0x02CC"
#define  set_SRNN_wdsr_layer3_3x3_weights_26_21_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_26_21_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_26_21_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_26_21_reg))
#define  SRNN_wdsr_layer3_3x3_weights_26_21_layer3_weight_21_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_26_21_layer3_weight_21_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_26_21_layer3_weight_21(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_26_21_get_layer3_weight_21(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_26_22                                     0x181ABAA4
#define  SRNN_wdsr_layer3_3x3_weights_26_22_reg_addr                             "0xB81ABAA4"
#define  SRNN_wdsr_layer3_3x3_weights_26_22_reg                                  0xB81ABAA4
#define  SRNN_wdsr_layer3_3x3_weights_26_22_inst_addr                            "0x02CD"
#define  set_SRNN_wdsr_layer3_3x3_weights_26_22_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_26_22_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_26_22_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_26_22_reg))
#define  SRNN_wdsr_layer3_3x3_weights_26_22_layer3_weight_22_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_26_22_layer3_weight_22_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_26_22_layer3_weight_22(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_26_22_get_layer3_weight_22(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_27_00                                     0x181ABAA8
#define  SRNN_wdsr_layer3_3x3_weights_27_00_reg_addr                             "0xB81ABAA8"
#define  SRNN_wdsr_layer3_3x3_weights_27_00_reg                                  0xB81ABAA8
#define  SRNN_wdsr_layer3_3x3_weights_27_00_inst_addr                            "0x02CE"
#define  set_SRNN_wdsr_layer3_3x3_weights_27_00_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_27_00_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_27_00_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_27_00_reg))
#define  SRNN_wdsr_layer3_3x3_weights_27_00_layer3_weight_00_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_27_00_layer3_weight_00_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_27_00_layer3_weight_00(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_27_00_get_layer3_weight_00(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_27_01                                     0x181ABAAC
#define  SRNN_wdsr_layer3_3x3_weights_27_01_reg_addr                             "0xB81ABAAC"
#define  SRNN_wdsr_layer3_3x3_weights_27_01_reg                                  0xB81ABAAC
#define  SRNN_wdsr_layer3_3x3_weights_27_01_inst_addr                            "0x02CF"
#define  set_SRNN_wdsr_layer3_3x3_weights_27_01_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_27_01_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_27_01_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_27_01_reg))
#define  SRNN_wdsr_layer3_3x3_weights_27_01_layer3_weight_01_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_27_01_layer3_weight_01_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_27_01_layer3_weight_01(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_27_01_get_layer3_weight_01(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_27_02                                     0x181ABAB0
#define  SRNN_wdsr_layer3_3x3_weights_27_02_reg_addr                             "0xB81ABAB0"
#define  SRNN_wdsr_layer3_3x3_weights_27_02_reg                                  0xB81ABAB0
#define  SRNN_wdsr_layer3_3x3_weights_27_02_inst_addr                            "0x02D0"
#define  set_SRNN_wdsr_layer3_3x3_weights_27_02_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_27_02_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_27_02_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_27_02_reg))
#define  SRNN_wdsr_layer3_3x3_weights_27_02_layer3_weight_02_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_27_02_layer3_weight_02_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_27_02_layer3_weight_02(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_27_02_get_layer3_weight_02(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_27_10                                     0x181ABAB4
#define  SRNN_wdsr_layer3_3x3_weights_27_10_reg_addr                             "0xB81ABAB4"
#define  SRNN_wdsr_layer3_3x3_weights_27_10_reg                                  0xB81ABAB4
#define  SRNN_wdsr_layer3_3x3_weights_27_10_inst_addr                            "0x02D1"
#define  set_SRNN_wdsr_layer3_3x3_weights_27_10_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_27_10_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_27_10_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_27_10_reg))
#define  SRNN_wdsr_layer3_3x3_weights_27_10_layer3_weight_10_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_27_10_layer3_weight_10_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_27_10_layer3_weight_10(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_27_10_get_layer3_weight_10(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_27_11                                     0x181ABAB8
#define  SRNN_wdsr_layer3_3x3_weights_27_11_reg_addr                             "0xB81ABAB8"
#define  SRNN_wdsr_layer3_3x3_weights_27_11_reg                                  0xB81ABAB8
#define  SRNN_wdsr_layer3_3x3_weights_27_11_inst_addr                            "0x02D2"
#define  set_SRNN_wdsr_layer3_3x3_weights_27_11_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_27_11_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_27_11_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_27_11_reg))
#define  SRNN_wdsr_layer3_3x3_weights_27_11_layer3_weight_11_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_27_11_layer3_weight_11_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_27_11_layer3_weight_11(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_27_11_get_layer3_weight_11(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_27_12                                     0x181ABABC
#define  SRNN_wdsr_layer3_3x3_weights_27_12_reg_addr                             "0xB81ABABC"
#define  SRNN_wdsr_layer3_3x3_weights_27_12_reg                                  0xB81ABABC
#define  SRNN_wdsr_layer3_3x3_weights_27_12_inst_addr                            "0x02D3"
#define  set_SRNN_wdsr_layer3_3x3_weights_27_12_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_27_12_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_27_12_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_27_12_reg))
#define  SRNN_wdsr_layer3_3x3_weights_27_12_layer3_weight_12_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_27_12_layer3_weight_12_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_27_12_layer3_weight_12(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_27_12_get_layer3_weight_12(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_27_20                                     0x181ABAC0
#define  SRNN_wdsr_layer3_3x3_weights_27_20_reg_addr                             "0xB81ABAC0"
#define  SRNN_wdsr_layer3_3x3_weights_27_20_reg                                  0xB81ABAC0
#define  SRNN_wdsr_layer3_3x3_weights_27_20_inst_addr                            "0x02D4"
#define  set_SRNN_wdsr_layer3_3x3_weights_27_20_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_27_20_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_27_20_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_27_20_reg))
#define  SRNN_wdsr_layer3_3x3_weights_27_20_layer3_weight_20_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_27_20_layer3_weight_20_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_27_20_layer3_weight_20(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_27_20_get_layer3_weight_20(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_27_21                                     0x181ABAC4
#define  SRNN_wdsr_layer3_3x3_weights_27_21_reg_addr                             "0xB81ABAC4"
#define  SRNN_wdsr_layer3_3x3_weights_27_21_reg                                  0xB81ABAC4
#define  SRNN_wdsr_layer3_3x3_weights_27_21_inst_addr                            "0x02D5"
#define  set_SRNN_wdsr_layer3_3x3_weights_27_21_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_27_21_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_27_21_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_27_21_reg))
#define  SRNN_wdsr_layer3_3x3_weights_27_21_layer3_weight_21_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_27_21_layer3_weight_21_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_27_21_layer3_weight_21(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_27_21_get_layer3_weight_21(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_27_22                                     0x181ABAC8
#define  SRNN_wdsr_layer3_3x3_weights_27_22_reg_addr                             "0xB81ABAC8"
#define  SRNN_wdsr_layer3_3x3_weights_27_22_reg                                  0xB81ABAC8
#define  SRNN_wdsr_layer3_3x3_weights_27_22_inst_addr                            "0x02D6"
#define  set_SRNN_wdsr_layer3_3x3_weights_27_22_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_27_22_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_27_22_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_27_22_reg))
#define  SRNN_wdsr_layer3_3x3_weights_27_22_layer3_weight_22_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_27_22_layer3_weight_22_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_27_22_layer3_weight_22(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_27_22_get_layer3_weight_22(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_28_00                                     0x181ABACC
#define  SRNN_wdsr_layer3_3x3_weights_28_00_reg_addr                             "0xB81ABACC"
#define  SRNN_wdsr_layer3_3x3_weights_28_00_reg                                  0xB81ABACC
#define  SRNN_wdsr_layer3_3x3_weights_28_00_inst_addr                            "0x02D7"
#define  set_SRNN_wdsr_layer3_3x3_weights_28_00_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_28_00_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_28_00_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_28_00_reg))
#define  SRNN_wdsr_layer3_3x3_weights_28_00_layer3_weight_00_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_28_00_layer3_weight_00_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_28_00_layer3_weight_00(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_28_00_get_layer3_weight_00(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_28_01                                     0x181ABAD0
#define  SRNN_wdsr_layer3_3x3_weights_28_01_reg_addr                             "0xB81ABAD0"
#define  SRNN_wdsr_layer3_3x3_weights_28_01_reg                                  0xB81ABAD0
#define  SRNN_wdsr_layer3_3x3_weights_28_01_inst_addr                            "0x02D8"
#define  set_SRNN_wdsr_layer3_3x3_weights_28_01_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_28_01_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_28_01_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_28_01_reg))
#define  SRNN_wdsr_layer3_3x3_weights_28_01_layer3_weight_01_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_28_01_layer3_weight_01_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_28_01_layer3_weight_01(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_28_01_get_layer3_weight_01(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_28_02                                     0x181ABAD4
#define  SRNN_wdsr_layer3_3x3_weights_28_02_reg_addr                             "0xB81ABAD4"
#define  SRNN_wdsr_layer3_3x3_weights_28_02_reg                                  0xB81ABAD4
#define  SRNN_wdsr_layer3_3x3_weights_28_02_inst_addr                            "0x02D9"
#define  set_SRNN_wdsr_layer3_3x3_weights_28_02_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_28_02_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_28_02_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_28_02_reg))
#define  SRNN_wdsr_layer3_3x3_weights_28_02_layer3_weight_02_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_28_02_layer3_weight_02_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_28_02_layer3_weight_02(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_28_02_get_layer3_weight_02(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_28_10                                     0x181ABAD8
#define  SRNN_wdsr_layer3_3x3_weights_28_10_reg_addr                             "0xB81ABAD8"
#define  SRNN_wdsr_layer3_3x3_weights_28_10_reg                                  0xB81ABAD8
#define  SRNN_wdsr_layer3_3x3_weights_28_10_inst_addr                            "0x02DA"
#define  set_SRNN_wdsr_layer3_3x3_weights_28_10_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_28_10_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_28_10_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_28_10_reg))
#define  SRNN_wdsr_layer3_3x3_weights_28_10_layer3_weight_10_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_28_10_layer3_weight_10_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_28_10_layer3_weight_10(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_28_10_get_layer3_weight_10(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_28_11                                     0x181ABADC
#define  SRNN_wdsr_layer3_3x3_weights_28_11_reg_addr                             "0xB81ABADC"
#define  SRNN_wdsr_layer3_3x3_weights_28_11_reg                                  0xB81ABADC
#define  SRNN_wdsr_layer3_3x3_weights_28_11_inst_addr                            "0x02DB"
#define  set_SRNN_wdsr_layer3_3x3_weights_28_11_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_28_11_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_28_11_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_28_11_reg))
#define  SRNN_wdsr_layer3_3x3_weights_28_11_layer3_weight_11_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_28_11_layer3_weight_11_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_28_11_layer3_weight_11(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_28_11_get_layer3_weight_11(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_28_12                                     0x181ABAE0
#define  SRNN_wdsr_layer3_3x3_weights_28_12_reg_addr                             "0xB81ABAE0"
#define  SRNN_wdsr_layer3_3x3_weights_28_12_reg                                  0xB81ABAE0
#define  SRNN_wdsr_layer3_3x3_weights_28_12_inst_addr                            "0x02DC"
#define  set_SRNN_wdsr_layer3_3x3_weights_28_12_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_28_12_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_28_12_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_28_12_reg))
#define  SRNN_wdsr_layer3_3x3_weights_28_12_layer3_weight_12_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_28_12_layer3_weight_12_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_28_12_layer3_weight_12(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_28_12_get_layer3_weight_12(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_28_20                                     0x181ABAE4
#define  SRNN_wdsr_layer3_3x3_weights_28_20_reg_addr                             "0xB81ABAE4"
#define  SRNN_wdsr_layer3_3x3_weights_28_20_reg                                  0xB81ABAE4
#define  SRNN_wdsr_layer3_3x3_weights_28_20_inst_addr                            "0x02DD"
#define  set_SRNN_wdsr_layer3_3x3_weights_28_20_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_28_20_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_28_20_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_28_20_reg))
#define  SRNN_wdsr_layer3_3x3_weights_28_20_layer3_weight_20_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_28_20_layer3_weight_20_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_28_20_layer3_weight_20(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_28_20_get_layer3_weight_20(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_28_21                                     0x181ABAE8
#define  SRNN_wdsr_layer3_3x3_weights_28_21_reg_addr                             "0xB81ABAE8"
#define  SRNN_wdsr_layer3_3x3_weights_28_21_reg                                  0xB81ABAE8
#define  SRNN_wdsr_layer3_3x3_weights_28_21_inst_addr                            "0x02DE"
#define  set_SRNN_wdsr_layer3_3x3_weights_28_21_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_28_21_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_28_21_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_28_21_reg))
#define  SRNN_wdsr_layer3_3x3_weights_28_21_layer3_weight_21_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_28_21_layer3_weight_21_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_28_21_layer3_weight_21(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_28_21_get_layer3_weight_21(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_28_22                                     0x181ABAEC
#define  SRNN_wdsr_layer3_3x3_weights_28_22_reg_addr                             "0xB81ABAEC"
#define  SRNN_wdsr_layer3_3x3_weights_28_22_reg                                  0xB81ABAEC
#define  SRNN_wdsr_layer3_3x3_weights_28_22_inst_addr                            "0x02DF"
#define  set_SRNN_wdsr_layer3_3x3_weights_28_22_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_28_22_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_28_22_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_28_22_reg))
#define  SRNN_wdsr_layer3_3x3_weights_28_22_layer3_weight_22_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_28_22_layer3_weight_22_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_28_22_layer3_weight_22(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_28_22_get_layer3_weight_22(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_29_00                                     0x181ABAF0
#define  SRNN_wdsr_layer3_3x3_weights_29_00_reg_addr                             "0xB81ABAF0"
#define  SRNN_wdsr_layer3_3x3_weights_29_00_reg                                  0xB81ABAF0
#define  SRNN_wdsr_layer3_3x3_weights_29_00_inst_addr                            "0x02E0"
#define  set_SRNN_wdsr_layer3_3x3_weights_29_00_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_29_00_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_29_00_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_29_00_reg))
#define  SRNN_wdsr_layer3_3x3_weights_29_00_layer3_weight_00_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_29_00_layer3_weight_00_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_29_00_layer3_weight_00(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_29_00_get_layer3_weight_00(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_29_01                                     0x181ABAF4
#define  SRNN_wdsr_layer3_3x3_weights_29_01_reg_addr                             "0xB81ABAF4"
#define  SRNN_wdsr_layer3_3x3_weights_29_01_reg                                  0xB81ABAF4
#define  SRNN_wdsr_layer3_3x3_weights_29_01_inst_addr                            "0x02E1"
#define  set_SRNN_wdsr_layer3_3x3_weights_29_01_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_29_01_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_29_01_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_29_01_reg))
#define  SRNN_wdsr_layer3_3x3_weights_29_01_layer3_weight_01_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_29_01_layer3_weight_01_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_29_01_layer3_weight_01(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_29_01_get_layer3_weight_01(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_29_02                                     0x181ABAF8
#define  SRNN_wdsr_layer3_3x3_weights_29_02_reg_addr                             "0xB81ABAF8"
#define  SRNN_wdsr_layer3_3x3_weights_29_02_reg                                  0xB81ABAF8
#define  SRNN_wdsr_layer3_3x3_weights_29_02_inst_addr                            "0x02E2"
#define  set_SRNN_wdsr_layer3_3x3_weights_29_02_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_29_02_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_29_02_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_29_02_reg))
#define  SRNN_wdsr_layer3_3x3_weights_29_02_layer3_weight_02_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_29_02_layer3_weight_02_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_29_02_layer3_weight_02(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_29_02_get_layer3_weight_02(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_29_10                                     0x181ABAFC
#define  SRNN_wdsr_layer3_3x3_weights_29_10_reg_addr                             "0xB81ABAFC"
#define  SRNN_wdsr_layer3_3x3_weights_29_10_reg                                  0xB81ABAFC
#define  SRNN_wdsr_layer3_3x3_weights_29_10_inst_addr                            "0x02E3"
#define  set_SRNN_wdsr_layer3_3x3_weights_29_10_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_29_10_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_29_10_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_29_10_reg))
#define  SRNN_wdsr_layer3_3x3_weights_29_10_layer3_weight_10_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_29_10_layer3_weight_10_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_29_10_layer3_weight_10(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_29_10_get_layer3_weight_10(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_29_11                                     0x181ABB00
#define  SRNN_wdsr_layer3_3x3_weights_29_11_reg_addr                             "0xB81ABB00"
#define  SRNN_wdsr_layer3_3x3_weights_29_11_reg                                  0xB81ABB00
#define  SRNN_wdsr_layer3_3x3_weights_29_11_inst_addr                            "0x02E4"
#define  set_SRNN_wdsr_layer3_3x3_weights_29_11_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_29_11_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_29_11_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_29_11_reg))
#define  SRNN_wdsr_layer3_3x3_weights_29_11_layer3_weight_11_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_29_11_layer3_weight_11_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_29_11_layer3_weight_11(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_29_11_get_layer3_weight_11(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_29_12                                     0x181ABB04
#define  SRNN_wdsr_layer3_3x3_weights_29_12_reg_addr                             "0xB81ABB04"
#define  SRNN_wdsr_layer3_3x3_weights_29_12_reg                                  0xB81ABB04
#define  SRNN_wdsr_layer3_3x3_weights_29_12_inst_addr                            "0x02E5"
#define  set_SRNN_wdsr_layer3_3x3_weights_29_12_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_29_12_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_29_12_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_29_12_reg))
#define  SRNN_wdsr_layer3_3x3_weights_29_12_layer3_weight_12_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_29_12_layer3_weight_12_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_29_12_layer3_weight_12(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_29_12_get_layer3_weight_12(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_29_20                                     0x181ABB08
#define  SRNN_wdsr_layer3_3x3_weights_29_20_reg_addr                             "0xB81ABB08"
#define  SRNN_wdsr_layer3_3x3_weights_29_20_reg                                  0xB81ABB08
#define  SRNN_wdsr_layer3_3x3_weights_29_20_inst_addr                            "0x02E6"
#define  set_SRNN_wdsr_layer3_3x3_weights_29_20_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_29_20_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_29_20_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_29_20_reg))
#define  SRNN_wdsr_layer3_3x3_weights_29_20_layer3_weight_20_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_29_20_layer3_weight_20_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_29_20_layer3_weight_20(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_29_20_get_layer3_weight_20(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_29_21                                     0x181ABB0C
#define  SRNN_wdsr_layer3_3x3_weights_29_21_reg_addr                             "0xB81ABB0C"
#define  SRNN_wdsr_layer3_3x3_weights_29_21_reg                                  0xB81ABB0C
#define  SRNN_wdsr_layer3_3x3_weights_29_21_inst_addr                            "0x02E7"
#define  set_SRNN_wdsr_layer3_3x3_weights_29_21_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_29_21_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_29_21_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_29_21_reg))
#define  SRNN_wdsr_layer3_3x3_weights_29_21_layer3_weight_21_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_29_21_layer3_weight_21_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_29_21_layer3_weight_21(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_29_21_get_layer3_weight_21(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_29_22                                     0x181ABB10
#define  SRNN_wdsr_layer3_3x3_weights_29_22_reg_addr                             "0xB81ABB10"
#define  SRNN_wdsr_layer3_3x3_weights_29_22_reg                                  0xB81ABB10
#define  SRNN_wdsr_layer3_3x3_weights_29_22_inst_addr                            "0x02E8"
#define  set_SRNN_wdsr_layer3_3x3_weights_29_22_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_29_22_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_29_22_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_29_22_reg))
#define  SRNN_wdsr_layer3_3x3_weights_29_22_layer3_weight_22_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_29_22_layer3_weight_22_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_29_22_layer3_weight_22(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_29_22_get_layer3_weight_22(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_30_00                                     0x181ABB14
#define  SRNN_wdsr_layer3_3x3_weights_30_00_reg_addr                             "0xB81ABB14"
#define  SRNN_wdsr_layer3_3x3_weights_30_00_reg                                  0xB81ABB14
#define  SRNN_wdsr_layer3_3x3_weights_30_00_inst_addr                            "0x02E9"
#define  set_SRNN_wdsr_layer3_3x3_weights_30_00_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_30_00_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_30_00_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_30_00_reg))
#define  SRNN_wdsr_layer3_3x3_weights_30_00_layer3_weight_00_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_30_00_layer3_weight_00_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_30_00_layer3_weight_00(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_30_00_get_layer3_weight_00(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_30_01                                     0x181ABB18
#define  SRNN_wdsr_layer3_3x3_weights_30_01_reg_addr                             "0xB81ABB18"
#define  SRNN_wdsr_layer3_3x3_weights_30_01_reg                                  0xB81ABB18
#define  SRNN_wdsr_layer3_3x3_weights_30_01_inst_addr                            "0x02EA"
#define  set_SRNN_wdsr_layer3_3x3_weights_30_01_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_30_01_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_30_01_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_30_01_reg))
#define  SRNN_wdsr_layer3_3x3_weights_30_01_layer3_weight_01_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_30_01_layer3_weight_01_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_30_01_layer3_weight_01(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_30_01_get_layer3_weight_01(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_30_02                                     0x181ABB1C
#define  SRNN_wdsr_layer3_3x3_weights_30_02_reg_addr                             "0xB81ABB1C"
#define  SRNN_wdsr_layer3_3x3_weights_30_02_reg                                  0xB81ABB1C
#define  SRNN_wdsr_layer3_3x3_weights_30_02_inst_addr                            "0x02EB"
#define  set_SRNN_wdsr_layer3_3x3_weights_30_02_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_30_02_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_30_02_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_30_02_reg))
#define  SRNN_wdsr_layer3_3x3_weights_30_02_layer3_weight_02_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_30_02_layer3_weight_02_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_30_02_layer3_weight_02(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_30_02_get_layer3_weight_02(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_30_10                                     0x181ABB20
#define  SRNN_wdsr_layer3_3x3_weights_30_10_reg_addr                             "0xB81ABB20"
#define  SRNN_wdsr_layer3_3x3_weights_30_10_reg                                  0xB81ABB20
#define  SRNN_wdsr_layer3_3x3_weights_30_10_inst_addr                            "0x02EC"
#define  set_SRNN_wdsr_layer3_3x3_weights_30_10_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_30_10_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_30_10_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_30_10_reg))
#define  SRNN_wdsr_layer3_3x3_weights_30_10_layer3_weight_10_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_30_10_layer3_weight_10_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_30_10_layer3_weight_10(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_30_10_get_layer3_weight_10(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_30_11                                     0x181ABB24
#define  SRNN_wdsr_layer3_3x3_weights_30_11_reg_addr                             "0xB81ABB24"
#define  SRNN_wdsr_layer3_3x3_weights_30_11_reg                                  0xB81ABB24
#define  SRNN_wdsr_layer3_3x3_weights_30_11_inst_addr                            "0x02ED"
#define  set_SRNN_wdsr_layer3_3x3_weights_30_11_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_30_11_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_30_11_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_30_11_reg))
#define  SRNN_wdsr_layer3_3x3_weights_30_11_layer3_weight_11_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_30_11_layer3_weight_11_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_30_11_layer3_weight_11(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_30_11_get_layer3_weight_11(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_30_12                                     0x181ABB28
#define  SRNN_wdsr_layer3_3x3_weights_30_12_reg_addr                             "0xB81ABB28"
#define  SRNN_wdsr_layer3_3x3_weights_30_12_reg                                  0xB81ABB28
#define  SRNN_wdsr_layer3_3x3_weights_30_12_inst_addr                            "0x02EE"
#define  set_SRNN_wdsr_layer3_3x3_weights_30_12_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_30_12_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_30_12_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_30_12_reg))
#define  SRNN_wdsr_layer3_3x3_weights_30_12_layer3_weight_12_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_30_12_layer3_weight_12_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_30_12_layer3_weight_12(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_30_12_get_layer3_weight_12(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_30_20                                     0x181ABB2C
#define  SRNN_wdsr_layer3_3x3_weights_30_20_reg_addr                             "0xB81ABB2C"
#define  SRNN_wdsr_layer3_3x3_weights_30_20_reg                                  0xB81ABB2C
#define  SRNN_wdsr_layer3_3x3_weights_30_20_inst_addr                            "0x02EF"
#define  set_SRNN_wdsr_layer3_3x3_weights_30_20_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_30_20_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_30_20_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_30_20_reg))
#define  SRNN_wdsr_layer3_3x3_weights_30_20_layer3_weight_20_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_30_20_layer3_weight_20_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_30_20_layer3_weight_20(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_30_20_get_layer3_weight_20(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_30_21                                     0x181ABB30
#define  SRNN_wdsr_layer3_3x3_weights_30_21_reg_addr                             "0xB81ABB30"
#define  SRNN_wdsr_layer3_3x3_weights_30_21_reg                                  0xB81ABB30
#define  SRNN_wdsr_layer3_3x3_weights_30_21_inst_addr                            "0x02F0"
#define  set_SRNN_wdsr_layer3_3x3_weights_30_21_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_30_21_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_30_21_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_30_21_reg))
#define  SRNN_wdsr_layer3_3x3_weights_30_21_layer3_weight_21_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_30_21_layer3_weight_21_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_30_21_layer3_weight_21(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_30_21_get_layer3_weight_21(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_30_22                                     0x181ABB34
#define  SRNN_wdsr_layer3_3x3_weights_30_22_reg_addr                             "0xB81ABB34"
#define  SRNN_wdsr_layer3_3x3_weights_30_22_reg                                  0xB81ABB34
#define  SRNN_wdsr_layer3_3x3_weights_30_22_inst_addr                            "0x02F1"
#define  set_SRNN_wdsr_layer3_3x3_weights_30_22_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_30_22_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_30_22_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_30_22_reg))
#define  SRNN_wdsr_layer3_3x3_weights_30_22_layer3_weight_22_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_30_22_layer3_weight_22_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_30_22_layer3_weight_22(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_30_22_get_layer3_weight_22(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_31_00                                     0x181ABB38
#define  SRNN_wdsr_layer3_3x3_weights_31_00_reg_addr                             "0xB81ABB38"
#define  SRNN_wdsr_layer3_3x3_weights_31_00_reg                                  0xB81ABB38
#define  SRNN_wdsr_layer3_3x3_weights_31_00_inst_addr                            "0x02F2"
#define  set_SRNN_wdsr_layer3_3x3_weights_31_00_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_31_00_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_31_00_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_31_00_reg))
#define  SRNN_wdsr_layer3_3x3_weights_31_00_layer3_weight_00_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_31_00_layer3_weight_00_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_31_00_layer3_weight_00(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_31_00_get_layer3_weight_00(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_31_01                                     0x181ABB3C
#define  SRNN_wdsr_layer3_3x3_weights_31_01_reg_addr                             "0xB81ABB3C"
#define  SRNN_wdsr_layer3_3x3_weights_31_01_reg                                  0xB81ABB3C
#define  SRNN_wdsr_layer3_3x3_weights_31_01_inst_addr                            "0x02F3"
#define  set_SRNN_wdsr_layer3_3x3_weights_31_01_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_31_01_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_31_01_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_31_01_reg))
#define  SRNN_wdsr_layer3_3x3_weights_31_01_layer3_weight_01_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_31_01_layer3_weight_01_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_31_01_layer3_weight_01(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_31_01_get_layer3_weight_01(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_31_02                                     0x181ABB40
#define  SRNN_wdsr_layer3_3x3_weights_31_02_reg_addr                             "0xB81ABB40"
#define  SRNN_wdsr_layer3_3x3_weights_31_02_reg                                  0xB81ABB40
#define  SRNN_wdsr_layer3_3x3_weights_31_02_inst_addr                            "0x02F4"
#define  set_SRNN_wdsr_layer3_3x3_weights_31_02_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_31_02_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_31_02_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_31_02_reg))
#define  SRNN_wdsr_layer3_3x3_weights_31_02_layer3_weight_02_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_31_02_layer3_weight_02_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_31_02_layer3_weight_02(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_31_02_get_layer3_weight_02(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_31_10                                     0x181ABB44
#define  SRNN_wdsr_layer3_3x3_weights_31_10_reg_addr                             "0xB81ABB44"
#define  SRNN_wdsr_layer3_3x3_weights_31_10_reg                                  0xB81ABB44
#define  SRNN_wdsr_layer3_3x3_weights_31_10_inst_addr                            "0x02F5"
#define  set_SRNN_wdsr_layer3_3x3_weights_31_10_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_31_10_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_31_10_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_31_10_reg))
#define  SRNN_wdsr_layer3_3x3_weights_31_10_layer3_weight_10_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_31_10_layer3_weight_10_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_31_10_layer3_weight_10(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_31_10_get_layer3_weight_10(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_31_11                                     0x181ABB48
#define  SRNN_wdsr_layer3_3x3_weights_31_11_reg_addr                             "0xB81ABB48"
#define  SRNN_wdsr_layer3_3x3_weights_31_11_reg                                  0xB81ABB48
#define  SRNN_wdsr_layer3_3x3_weights_31_11_inst_addr                            "0x02F6"
#define  set_SRNN_wdsr_layer3_3x3_weights_31_11_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_31_11_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_31_11_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_31_11_reg))
#define  SRNN_wdsr_layer3_3x3_weights_31_11_layer3_weight_11_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_31_11_layer3_weight_11_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_31_11_layer3_weight_11(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_31_11_get_layer3_weight_11(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_31_12                                     0x181ABB4C
#define  SRNN_wdsr_layer3_3x3_weights_31_12_reg_addr                             "0xB81ABB4C"
#define  SRNN_wdsr_layer3_3x3_weights_31_12_reg                                  0xB81ABB4C
#define  SRNN_wdsr_layer3_3x3_weights_31_12_inst_addr                            "0x02F7"
#define  set_SRNN_wdsr_layer3_3x3_weights_31_12_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_31_12_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_31_12_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_31_12_reg))
#define  SRNN_wdsr_layer3_3x3_weights_31_12_layer3_weight_12_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_31_12_layer3_weight_12_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_31_12_layer3_weight_12(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_31_12_get_layer3_weight_12(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_31_20                                     0x181ABB50
#define  SRNN_wdsr_layer3_3x3_weights_31_20_reg_addr                             "0xB81ABB50"
#define  SRNN_wdsr_layer3_3x3_weights_31_20_reg                                  0xB81ABB50
#define  SRNN_wdsr_layer3_3x3_weights_31_20_inst_addr                            "0x02F8"
#define  set_SRNN_wdsr_layer3_3x3_weights_31_20_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_31_20_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_31_20_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_31_20_reg))
#define  SRNN_wdsr_layer3_3x3_weights_31_20_layer3_weight_20_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_31_20_layer3_weight_20_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_31_20_layer3_weight_20(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_31_20_get_layer3_weight_20(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_31_21                                     0x181ABB54
#define  SRNN_wdsr_layer3_3x3_weights_31_21_reg_addr                             "0xB81ABB54"
#define  SRNN_wdsr_layer3_3x3_weights_31_21_reg                                  0xB81ABB54
#define  SRNN_wdsr_layer3_3x3_weights_31_21_inst_addr                            "0x02F9"
#define  set_SRNN_wdsr_layer3_3x3_weights_31_21_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_31_21_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_31_21_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_31_21_reg))
#define  SRNN_wdsr_layer3_3x3_weights_31_21_layer3_weight_21_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_31_21_layer3_weight_21_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_31_21_layer3_weight_21(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_31_21_get_layer3_weight_21(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_31_22                                     0x181ABB58
#define  SRNN_wdsr_layer3_3x3_weights_31_22_reg_addr                             "0xB81ABB58"
#define  SRNN_wdsr_layer3_3x3_weights_31_22_reg                                  0xB81ABB58
#define  SRNN_wdsr_layer3_3x3_weights_31_22_inst_addr                            "0x02FA"
#define  set_SRNN_wdsr_layer3_3x3_weights_31_22_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_31_22_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_31_22_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_31_22_reg))
#define  SRNN_wdsr_layer3_3x3_weights_31_22_layer3_weight_22_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_31_22_layer3_weight_22_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_31_22_layer3_weight_22(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_31_22_get_layer3_weight_22(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_32_00                                     0x181ABB5C
#define  SRNN_wdsr_layer3_3x3_weights_32_00_reg_addr                             "0xB81ABB5C"
#define  SRNN_wdsr_layer3_3x3_weights_32_00_reg                                  0xB81ABB5C
#define  SRNN_wdsr_layer3_3x3_weights_32_00_inst_addr                            "0x02FB"
#define  set_SRNN_wdsr_layer3_3x3_weights_32_00_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_32_00_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_32_00_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_32_00_reg))
#define  SRNN_wdsr_layer3_3x3_weights_32_00_layer3_weight_00_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_32_00_layer3_weight_00_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_32_00_layer3_weight_00(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_32_00_get_layer3_weight_00(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_32_01                                     0x181ABB60
#define  SRNN_wdsr_layer3_3x3_weights_32_01_reg_addr                             "0xB81ABB60"
#define  SRNN_wdsr_layer3_3x3_weights_32_01_reg                                  0xB81ABB60
#define  SRNN_wdsr_layer3_3x3_weights_32_01_inst_addr                            "0x02FC"
#define  set_SRNN_wdsr_layer3_3x3_weights_32_01_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_32_01_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_32_01_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_32_01_reg))
#define  SRNN_wdsr_layer3_3x3_weights_32_01_layer3_weight_01_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_32_01_layer3_weight_01_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_32_01_layer3_weight_01(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_32_01_get_layer3_weight_01(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_32_02                                     0x181ABB64
#define  SRNN_wdsr_layer3_3x3_weights_32_02_reg_addr                             "0xB81ABB64"
#define  SRNN_wdsr_layer3_3x3_weights_32_02_reg                                  0xB81ABB64
#define  SRNN_wdsr_layer3_3x3_weights_32_02_inst_addr                            "0x02FD"
#define  set_SRNN_wdsr_layer3_3x3_weights_32_02_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_32_02_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_32_02_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_32_02_reg))
#define  SRNN_wdsr_layer3_3x3_weights_32_02_layer3_weight_02_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_32_02_layer3_weight_02_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_32_02_layer3_weight_02(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_32_02_get_layer3_weight_02(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_32_10                                     0x181ABB68
#define  SRNN_wdsr_layer3_3x3_weights_32_10_reg_addr                             "0xB81ABB68"
#define  SRNN_wdsr_layer3_3x3_weights_32_10_reg                                  0xB81ABB68
#define  SRNN_wdsr_layer3_3x3_weights_32_10_inst_addr                            "0x02FE"
#define  set_SRNN_wdsr_layer3_3x3_weights_32_10_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_32_10_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_32_10_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_32_10_reg))
#define  SRNN_wdsr_layer3_3x3_weights_32_10_layer3_weight_10_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_32_10_layer3_weight_10_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_32_10_layer3_weight_10(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_32_10_get_layer3_weight_10(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_32_11                                     0x181ABB6C
#define  SRNN_wdsr_layer3_3x3_weights_32_11_reg_addr                             "0xB81ABB6C"
#define  SRNN_wdsr_layer3_3x3_weights_32_11_reg                                  0xB81ABB6C
#define  SRNN_wdsr_layer3_3x3_weights_32_11_inst_addr                            "0x02FF"
#define  set_SRNN_wdsr_layer3_3x3_weights_32_11_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_32_11_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_32_11_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_32_11_reg))
#define  SRNN_wdsr_layer3_3x3_weights_32_11_layer3_weight_11_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_32_11_layer3_weight_11_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_32_11_layer3_weight_11(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_32_11_get_layer3_weight_11(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_32_12                                     0x181ABB70
#define  SRNN_wdsr_layer3_3x3_weights_32_12_reg_addr                             "0xB81ABB70"
#define  SRNN_wdsr_layer3_3x3_weights_32_12_reg                                  0xB81ABB70
#define  SRNN_wdsr_layer3_3x3_weights_32_12_inst_addr                            "0x0300"
#define  set_SRNN_wdsr_layer3_3x3_weights_32_12_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_32_12_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_32_12_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_32_12_reg))
#define  SRNN_wdsr_layer3_3x3_weights_32_12_layer3_weight_12_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_32_12_layer3_weight_12_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_32_12_layer3_weight_12(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_32_12_get_layer3_weight_12(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_32_20                                     0x181ABB74
#define  SRNN_wdsr_layer3_3x3_weights_32_20_reg_addr                             "0xB81ABB74"
#define  SRNN_wdsr_layer3_3x3_weights_32_20_reg                                  0xB81ABB74
#define  SRNN_wdsr_layer3_3x3_weights_32_20_inst_addr                            "0x0301"
#define  set_SRNN_wdsr_layer3_3x3_weights_32_20_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_32_20_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_32_20_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_32_20_reg))
#define  SRNN_wdsr_layer3_3x3_weights_32_20_layer3_weight_20_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_32_20_layer3_weight_20_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_32_20_layer3_weight_20(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_32_20_get_layer3_weight_20(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_32_21                                     0x181ABB78
#define  SRNN_wdsr_layer3_3x3_weights_32_21_reg_addr                             "0xB81ABB78"
#define  SRNN_wdsr_layer3_3x3_weights_32_21_reg                                  0xB81ABB78
#define  SRNN_wdsr_layer3_3x3_weights_32_21_inst_addr                            "0x0302"
#define  set_SRNN_wdsr_layer3_3x3_weights_32_21_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_32_21_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_32_21_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_32_21_reg))
#define  SRNN_wdsr_layer3_3x3_weights_32_21_layer3_weight_21_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_32_21_layer3_weight_21_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_32_21_layer3_weight_21(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_32_21_get_layer3_weight_21(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_weights_32_22                                     0x181ABB7C
#define  SRNN_wdsr_layer3_3x3_weights_32_22_reg_addr                             "0xB81ABB7C"
#define  SRNN_wdsr_layer3_3x3_weights_32_22_reg                                  0xB81ABB7C
#define  SRNN_wdsr_layer3_3x3_weights_32_22_inst_addr                            "0x0303"
#define  set_SRNN_wdsr_layer3_3x3_weights_32_22_reg(data)                        (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_32_22_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_weights_32_22_reg                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_weights_32_22_reg))
#define  SRNN_wdsr_layer3_3x3_weights_32_22_layer3_weight_22_shift               (0)
#define  SRNN_wdsr_layer3_3x3_weights_32_22_layer3_weight_22_mask                (0x00000FFF)
#define  SRNN_wdsr_layer3_3x3_weights_32_22_layer3_weight_22(data)               (0x00000FFF&(data))
#define  SRNN_wdsr_layer3_3x3_weights_32_22_get_layer3_weight_22(data)           (0x00000FFF&(data))

#define  SRNN_wdsr_layer3_3x3_bias_1                                            0x181ABB80
#define  SRNN_wdsr_layer3_3x3_bias_1_reg_addr                                    "0xB81ABB80"
#define  SRNN_wdsr_layer3_3x3_bias_1_reg                                         0xB81ABB80
#define  SRNN_wdsr_layer3_3x3_bias_1_inst_addr                                   "0x0304"
#define  set_SRNN_wdsr_layer3_3x3_bias_1_reg(data)                               (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_bias_1_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_bias_1_reg                                     (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_bias_1_reg))
#define  SRNN_wdsr_layer3_3x3_bias_1_layer3_bias_1_shift                         (0)
#define  SRNN_wdsr_layer3_3x3_bias_1_layer3_bias_1_mask                          (0x000003FF)
#define  SRNN_wdsr_layer3_3x3_bias_1_layer3_bias_1(data)                         (0x000003FF&(data))
#define  SRNN_wdsr_layer3_3x3_bias_1_get_layer3_bias_1(data)                     (0x000003FF&(data))

#define  SRNN_wdsr_layer3_3x3_bias_2                                            0x181ABB84
#define  SRNN_wdsr_layer3_3x3_bias_2_reg_addr                                    "0xB81ABB84"
#define  SRNN_wdsr_layer3_3x3_bias_2_reg                                         0xB81ABB84
#define  SRNN_wdsr_layer3_3x3_bias_2_inst_addr                                   "0x0305"
#define  set_SRNN_wdsr_layer3_3x3_bias_2_reg(data)                               (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_bias_2_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_bias_2_reg                                     (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_bias_2_reg))
#define  SRNN_wdsr_layer3_3x3_bias_2_layer3_bias_2_shift                         (0)
#define  SRNN_wdsr_layer3_3x3_bias_2_layer3_bias_2_mask                          (0x000003FF)
#define  SRNN_wdsr_layer3_3x3_bias_2_layer3_bias_2(data)                         (0x000003FF&(data))
#define  SRNN_wdsr_layer3_3x3_bias_2_get_layer3_bias_2(data)                     (0x000003FF&(data))

#define  SRNN_wdsr_layer3_3x3_bias_3                                            0x181ABB88
#define  SRNN_wdsr_layer3_3x3_bias_3_reg_addr                                    "0xB81ABB88"
#define  SRNN_wdsr_layer3_3x3_bias_3_reg                                         0xB81ABB88
#define  SRNN_wdsr_layer3_3x3_bias_3_inst_addr                                   "0x0306"
#define  set_SRNN_wdsr_layer3_3x3_bias_3_reg(data)                               (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_bias_3_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_bias_3_reg                                     (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_bias_3_reg))
#define  SRNN_wdsr_layer3_3x3_bias_3_layer3_bias_3_shift                         (0)
#define  SRNN_wdsr_layer3_3x3_bias_3_layer3_bias_3_mask                          (0x000003FF)
#define  SRNN_wdsr_layer3_3x3_bias_3_layer3_bias_3(data)                         (0x000003FF&(data))
#define  SRNN_wdsr_layer3_3x3_bias_3_get_layer3_bias_3(data)                     (0x000003FF&(data))

#define  SRNN_wdsr_layer3_3x3_bias_4                                            0x181ABB8C
#define  SRNN_wdsr_layer3_3x3_bias_4_reg_addr                                    "0xB81ABB8C"
#define  SRNN_wdsr_layer3_3x3_bias_4_reg                                         0xB81ABB8C
#define  SRNN_wdsr_layer3_3x3_bias_4_inst_addr                                   "0x0307"
#define  set_SRNN_wdsr_layer3_3x3_bias_4_reg(data)                               (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_bias_4_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_bias_4_reg                                     (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_bias_4_reg))
#define  SRNN_wdsr_layer3_3x3_bias_4_layer3_bias_4_shift                         (0)
#define  SRNN_wdsr_layer3_3x3_bias_4_layer3_bias_4_mask                          (0x000003FF)
#define  SRNN_wdsr_layer3_3x3_bias_4_layer3_bias_4(data)                         (0x000003FF&(data))
#define  SRNN_wdsr_layer3_3x3_bias_4_get_layer3_bias_4(data)                     (0x000003FF&(data))

#define  SRNN_wdsr_layer3_3x3_bias_5                                            0x181ABB90
#define  SRNN_wdsr_layer3_3x3_bias_5_reg_addr                                    "0xB81ABB90"
#define  SRNN_wdsr_layer3_3x3_bias_5_reg                                         0xB81ABB90
#define  SRNN_wdsr_layer3_3x3_bias_5_inst_addr                                   "0x0308"
#define  set_SRNN_wdsr_layer3_3x3_bias_5_reg(data)                               (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_bias_5_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_bias_5_reg                                     (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_bias_5_reg))
#define  SRNN_wdsr_layer3_3x3_bias_5_layer3_bias_5_shift                         (0)
#define  SRNN_wdsr_layer3_3x3_bias_5_layer3_bias_5_mask                          (0x000003FF)
#define  SRNN_wdsr_layer3_3x3_bias_5_layer3_bias_5(data)                         (0x000003FF&(data))
#define  SRNN_wdsr_layer3_3x3_bias_5_get_layer3_bias_5(data)                     (0x000003FF&(data))

#define  SRNN_wdsr_layer3_3x3_bias_6                                            0x181ABB94
#define  SRNN_wdsr_layer3_3x3_bias_6_reg_addr                                    "0xB81ABB94"
#define  SRNN_wdsr_layer3_3x3_bias_6_reg                                         0xB81ABB94
#define  SRNN_wdsr_layer3_3x3_bias_6_inst_addr                                   "0x0309"
#define  set_SRNN_wdsr_layer3_3x3_bias_6_reg(data)                               (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_bias_6_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_bias_6_reg                                     (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_bias_6_reg))
#define  SRNN_wdsr_layer3_3x3_bias_6_layer3_bias_6_shift                         (0)
#define  SRNN_wdsr_layer3_3x3_bias_6_layer3_bias_6_mask                          (0x000003FF)
#define  SRNN_wdsr_layer3_3x3_bias_6_layer3_bias_6(data)                         (0x000003FF&(data))
#define  SRNN_wdsr_layer3_3x3_bias_6_get_layer3_bias_6(data)                     (0x000003FF&(data))

#define  SRNN_wdsr_layer3_3x3_bias_7                                            0x181ABB98
#define  SRNN_wdsr_layer3_3x3_bias_7_reg_addr                                    "0xB81ABB98"
#define  SRNN_wdsr_layer3_3x3_bias_7_reg                                         0xB81ABB98
#define  SRNN_wdsr_layer3_3x3_bias_7_inst_addr                                   "0x030A"
#define  set_SRNN_wdsr_layer3_3x3_bias_7_reg(data)                               (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_bias_7_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_bias_7_reg                                     (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_bias_7_reg))
#define  SRNN_wdsr_layer3_3x3_bias_7_layer3_bias_7_shift                         (0)
#define  SRNN_wdsr_layer3_3x3_bias_7_layer3_bias_7_mask                          (0x000003FF)
#define  SRNN_wdsr_layer3_3x3_bias_7_layer3_bias_7(data)                         (0x000003FF&(data))
#define  SRNN_wdsr_layer3_3x3_bias_7_get_layer3_bias_7(data)                     (0x000003FF&(data))

#define  SRNN_wdsr_layer3_3x3_bias_8                                            0x181ABB9C
#define  SRNN_wdsr_layer3_3x3_bias_8_reg_addr                                    "0xB81ABB9C"
#define  SRNN_wdsr_layer3_3x3_bias_8_reg                                         0xB81ABB9C
#define  SRNN_wdsr_layer3_3x3_bias_8_inst_addr                                   "0x030B"
#define  set_SRNN_wdsr_layer3_3x3_bias_8_reg(data)                               (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_bias_8_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_bias_8_reg                                     (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_bias_8_reg))
#define  SRNN_wdsr_layer3_3x3_bias_8_layer3_bias_8_shift                         (0)
#define  SRNN_wdsr_layer3_3x3_bias_8_layer3_bias_8_mask                          (0x000003FF)
#define  SRNN_wdsr_layer3_3x3_bias_8_layer3_bias_8(data)                         (0x000003FF&(data))
#define  SRNN_wdsr_layer3_3x3_bias_8_get_layer3_bias_8(data)                     (0x000003FF&(data))

#define  SRNN_wdsr_layer3_3x3_bias_9                                            0x181ABBA0
#define  SRNN_wdsr_layer3_3x3_bias_9_reg_addr                                    "0xB81ABBA0"
#define  SRNN_wdsr_layer3_3x3_bias_9_reg                                         0xB81ABBA0
#define  SRNN_wdsr_layer3_3x3_bias_9_inst_addr                                   "0x030C"
#define  set_SRNN_wdsr_layer3_3x3_bias_9_reg(data)                               (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_bias_9_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_bias_9_reg                                     (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_bias_9_reg))
#define  SRNN_wdsr_layer3_3x3_bias_9_layer3_bias_9_shift                         (0)
#define  SRNN_wdsr_layer3_3x3_bias_9_layer3_bias_9_mask                          (0x000003FF)
#define  SRNN_wdsr_layer3_3x3_bias_9_layer3_bias_9(data)                         (0x000003FF&(data))
#define  SRNN_wdsr_layer3_3x3_bias_9_get_layer3_bias_9(data)                     (0x000003FF&(data))

#define  SRNN_wdsr_layer3_3x3_bias_10                                           0x181ABBA4
#define  SRNN_wdsr_layer3_3x3_bias_10_reg_addr                                   "0xB81ABBA4"
#define  SRNN_wdsr_layer3_3x3_bias_10_reg                                        0xB81ABBA4
#define  SRNN_wdsr_layer3_3x3_bias_10_inst_addr                                  "0x030D"
#define  set_SRNN_wdsr_layer3_3x3_bias_10_reg(data)                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_bias_10_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_bias_10_reg                                    (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_bias_10_reg))
#define  SRNN_wdsr_layer3_3x3_bias_10_layer3_bias_10_shift                       (0)
#define  SRNN_wdsr_layer3_3x3_bias_10_layer3_bias_10_mask                        (0x000003FF)
#define  SRNN_wdsr_layer3_3x3_bias_10_layer3_bias_10(data)                       (0x000003FF&(data))
#define  SRNN_wdsr_layer3_3x3_bias_10_get_layer3_bias_10(data)                   (0x000003FF&(data))

#define  SRNN_wdsr_layer3_3x3_bias_11                                           0x181ABBA8
#define  SRNN_wdsr_layer3_3x3_bias_11_reg_addr                                   "0xB81ABBA8"
#define  SRNN_wdsr_layer3_3x3_bias_11_reg                                        0xB81ABBA8
#define  SRNN_wdsr_layer3_3x3_bias_11_inst_addr                                  "0x030E"
#define  set_SRNN_wdsr_layer3_3x3_bias_11_reg(data)                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_bias_11_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_bias_11_reg                                    (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_bias_11_reg))
#define  SRNN_wdsr_layer3_3x3_bias_11_layer3_bias_11_shift                       (0)
#define  SRNN_wdsr_layer3_3x3_bias_11_layer3_bias_11_mask                        (0x000003FF)
#define  SRNN_wdsr_layer3_3x3_bias_11_layer3_bias_11(data)                       (0x000003FF&(data))
#define  SRNN_wdsr_layer3_3x3_bias_11_get_layer3_bias_11(data)                   (0x000003FF&(data))

#define  SRNN_wdsr_layer3_3x3_bias_12                                           0x181ABBAC
#define  SRNN_wdsr_layer3_3x3_bias_12_reg_addr                                   "0xB81ABBAC"
#define  SRNN_wdsr_layer3_3x3_bias_12_reg                                        0xB81ABBAC
#define  SRNN_wdsr_layer3_3x3_bias_12_inst_addr                                  "0x030F"
#define  set_SRNN_wdsr_layer3_3x3_bias_12_reg(data)                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_bias_12_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_bias_12_reg                                    (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_bias_12_reg))
#define  SRNN_wdsr_layer3_3x3_bias_12_layer3_bias_12_shift                       (0)
#define  SRNN_wdsr_layer3_3x3_bias_12_layer3_bias_12_mask                        (0x000003FF)
#define  SRNN_wdsr_layer3_3x3_bias_12_layer3_bias_12(data)                       (0x000003FF&(data))
#define  SRNN_wdsr_layer3_3x3_bias_12_get_layer3_bias_12(data)                   (0x000003FF&(data))

#define  SRNN_wdsr_layer3_3x3_bias_13                                           0x181ABBB0
#define  SRNN_wdsr_layer3_3x3_bias_13_reg_addr                                   "0xB81ABBB0"
#define  SRNN_wdsr_layer3_3x3_bias_13_reg                                        0xB81ABBB0
#define  SRNN_wdsr_layer3_3x3_bias_13_inst_addr                                  "0x0310"
#define  set_SRNN_wdsr_layer3_3x3_bias_13_reg(data)                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_bias_13_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_bias_13_reg                                    (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_bias_13_reg))
#define  SRNN_wdsr_layer3_3x3_bias_13_layer3_bias_13_shift                       (0)
#define  SRNN_wdsr_layer3_3x3_bias_13_layer3_bias_13_mask                        (0x000003FF)
#define  SRNN_wdsr_layer3_3x3_bias_13_layer3_bias_13(data)                       (0x000003FF&(data))
#define  SRNN_wdsr_layer3_3x3_bias_13_get_layer3_bias_13(data)                   (0x000003FF&(data))

#define  SRNN_wdsr_layer3_3x3_bias_14                                           0x181ABBB4
#define  SRNN_wdsr_layer3_3x3_bias_14_reg_addr                                   "0xB81ABBB4"
#define  SRNN_wdsr_layer3_3x3_bias_14_reg                                        0xB81ABBB4
#define  SRNN_wdsr_layer3_3x3_bias_14_inst_addr                                  "0x0311"
#define  set_SRNN_wdsr_layer3_3x3_bias_14_reg(data)                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_bias_14_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_bias_14_reg                                    (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_bias_14_reg))
#define  SRNN_wdsr_layer3_3x3_bias_14_layer3_bias_14_shift                       (0)
#define  SRNN_wdsr_layer3_3x3_bias_14_layer3_bias_14_mask                        (0x000003FF)
#define  SRNN_wdsr_layer3_3x3_bias_14_layer3_bias_14(data)                       (0x000003FF&(data))
#define  SRNN_wdsr_layer3_3x3_bias_14_get_layer3_bias_14(data)                   (0x000003FF&(data))

#define  SRNN_wdsr_layer3_3x3_bias_15                                           0x181ABBB8
#define  SRNN_wdsr_layer3_3x3_bias_15_reg_addr                                   "0xB81ABBB8"
#define  SRNN_wdsr_layer3_3x3_bias_15_reg                                        0xB81ABBB8
#define  SRNN_wdsr_layer3_3x3_bias_15_inst_addr                                  "0x0312"
#define  set_SRNN_wdsr_layer3_3x3_bias_15_reg(data)                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_bias_15_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_bias_15_reg                                    (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_bias_15_reg))
#define  SRNN_wdsr_layer3_3x3_bias_15_layer3_bias_15_shift                       (0)
#define  SRNN_wdsr_layer3_3x3_bias_15_layer3_bias_15_mask                        (0x000003FF)
#define  SRNN_wdsr_layer3_3x3_bias_15_layer3_bias_15(data)                       (0x000003FF&(data))
#define  SRNN_wdsr_layer3_3x3_bias_15_get_layer3_bias_15(data)                   (0x000003FF&(data))

#define  SRNN_wdsr_layer3_3x3_bias_16                                           0x181ABBBC
#define  SRNN_wdsr_layer3_3x3_bias_16_reg_addr                                   "0xB81ABBBC"
#define  SRNN_wdsr_layer3_3x3_bias_16_reg                                        0xB81ABBBC
#define  SRNN_wdsr_layer3_3x3_bias_16_inst_addr                                  "0x0313"
#define  set_SRNN_wdsr_layer3_3x3_bias_16_reg(data)                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_bias_16_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_bias_16_reg                                    (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_bias_16_reg))
#define  SRNN_wdsr_layer3_3x3_bias_16_layer3_bias_16_shift                       (0)
#define  SRNN_wdsr_layer3_3x3_bias_16_layer3_bias_16_mask                        (0x000003FF)
#define  SRNN_wdsr_layer3_3x3_bias_16_layer3_bias_16(data)                       (0x000003FF&(data))
#define  SRNN_wdsr_layer3_3x3_bias_16_get_layer3_bias_16(data)                   (0x000003FF&(data))

#define  SRNN_wdsr_layer3_3x3_bias_17                                           0x181ABBC0
#define  SRNN_wdsr_layer3_3x3_bias_17_reg_addr                                   "0xB81ABBC0"
#define  SRNN_wdsr_layer3_3x3_bias_17_reg                                        0xB81ABBC0
#define  SRNN_wdsr_layer3_3x3_bias_17_inst_addr                                  "0x0314"
#define  set_SRNN_wdsr_layer3_3x3_bias_17_reg(data)                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_bias_17_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_bias_17_reg                                    (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_bias_17_reg))
#define  SRNN_wdsr_layer3_3x3_bias_17_layer3_bias_17_shift                       (0)
#define  SRNN_wdsr_layer3_3x3_bias_17_layer3_bias_17_mask                        (0x000003FF)
#define  SRNN_wdsr_layer3_3x3_bias_17_layer3_bias_17(data)                       (0x000003FF&(data))
#define  SRNN_wdsr_layer3_3x3_bias_17_get_layer3_bias_17(data)                   (0x000003FF&(data))

#define  SRNN_wdsr_layer3_3x3_bias_18                                           0x181ABBC4
#define  SRNN_wdsr_layer3_3x3_bias_18_reg_addr                                   "0xB81ABBC4"
#define  SRNN_wdsr_layer3_3x3_bias_18_reg                                        0xB81ABBC4
#define  SRNN_wdsr_layer3_3x3_bias_18_inst_addr                                  "0x0315"
#define  set_SRNN_wdsr_layer3_3x3_bias_18_reg(data)                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_bias_18_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_bias_18_reg                                    (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_bias_18_reg))
#define  SRNN_wdsr_layer3_3x3_bias_18_layer3_bias_18_shift                       (0)
#define  SRNN_wdsr_layer3_3x3_bias_18_layer3_bias_18_mask                        (0x000003FF)
#define  SRNN_wdsr_layer3_3x3_bias_18_layer3_bias_18(data)                       (0x000003FF&(data))
#define  SRNN_wdsr_layer3_3x3_bias_18_get_layer3_bias_18(data)                   (0x000003FF&(data))

#define  SRNN_wdsr_layer3_3x3_bias_19                                           0x181ABBC8
#define  SRNN_wdsr_layer3_3x3_bias_19_reg_addr                                   "0xB81ABBC8"
#define  SRNN_wdsr_layer3_3x3_bias_19_reg                                        0xB81ABBC8
#define  SRNN_wdsr_layer3_3x3_bias_19_inst_addr                                  "0x0316"
#define  set_SRNN_wdsr_layer3_3x3_bias_19_reg(data)                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_bias_19_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_bias_19_reg                                    (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_bias_19_reg))
#define  SRNN_wdsr_layer3_3x3_bias_19_layer3_bias_19_shift                       (0)
#define  SRNN_wdsr_layer3_3x3_bias_19_layer3_bias_19_mask                        (0x000003FF)
#define  SRNN_wdsr_layer3_3x3_bias_19_layer3_bias_19(data)                       (0x000003FF&(data))
#define  SRNN_wdsr_layer3_3x3_bias_19_get_layer3_bias_19(data)                   (0x000003FF&(data))

#define  SRNN_wdsr_layer3_3x3_bias_20                                           0x181ABBCC
#define  SRNN_wdsr_layer3_3x3_bias_20_reg_addr                                   "0xB81ABBCC"
#define  SRNN_wdsr_layer3_3x3_bias_20_reg                                        0xB81ABBCC
#define  SRNN_wdsr_layer3_3x3_bias_20_inst_addr                                  "0x0317"
#define  set_SRNN_wdsr_layer3_3x3_bias_20_reg(data)                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_bias_20_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_bias_20_reg                                    (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_bias_20_reg))
#define  SRNN_wdsr_layer3_3x3_bias_20_layer3_bias_20_shift                       (0)
#define  SRNN_wdsr_layer3_3x3_bias_20_layer3_bias_20_mask                        (0x000003FF)
#define  SRNN_wdsr_layer3_3x3_bias_20_layer3_bias_20(data)                       (0x000003FF&(data))
#define  SRNN_wdsr_layer3_3x3_bias_20_get_layer3_bias_20(data)                   (0x000003FF&(data))

#define  SRNN_wdsr_layer3_3x3_bias_21                                           0x181ABBD0
#define  SRNN_wdsr_layer3_3x3_bias_21_reg_addr                                   "0xB81ABBD0"
#define  SRNN_wdsr_layer3_3x3_bias_21_reg                                        0xB81ABBD0
#define  SRNN_wdsr_layer3_3x3_bias_21_inst_addr                                  "0x0318"
#define  set_SRNN_wdsr_layer3_3x3_bias_21_reg(data)                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_bias_21_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_bias_21_reg                                    (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_bias_21_reg))
#define  SRNN_wdsr_layer3_3x3_bias_21_layer3_bias_21_shift                       (0)
#define  SRNN_wdsr_layer3_3x3_bias_21_layer3_bias_21_mask                        (0x000003FF)
#define  SRNN_wdsr_layer3_3x3_bias_21_layer3_bias_21(data)                       (0x000003FF&(data))
#define  SRNN_wdsr_layer3_3x3_bias_21_get_layer3_bias_21(data)                   (0x000003FF&(data))

#define  SRNN_wdsr_layer3_3x3_bias_22                                           0x181ABBD4
#define  SRNN_wdsr_layer3_3x3_bias_22_reg_addr                                   "0xB81ABBD4"
#define  SRNN_wdsr_layer3_3x3_bias_22_reg                                        0xB81ABBD4
#define  SRNN_wdsr_layer3_3x3_bias_22_inst_addr                                  "0x0319"
#define  set_SRNN_wdsr_layer3_3x3_bias_22_reg(data)                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_bias_22_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_bias_22_reg                                    (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_bias_22_reg))
#define  SRNN_wdsr_layer3_3x3_bias_22_layer3_bias_22_shift                       (0)
#define  SRNN_wdsr_layer3_3x3_bias_22_layer3_bias_22_mask                        (0x000003FF)
#define  SRNN_wdsr_layer3_3x3_bias_22_layer3_bias_22(data)                       (0x000003FF&(data))
#define  SRNN_wdsr_layer3_3x3_bias_22_get_layer3_bias_22(data)                   (0x000003FF&(data))

#define  SRNN_wdsr_layer3_3x3_bias_23                                           0x181ABBD8
#define  SRNN_wdsr_layer3_3x3_bias_23_reg_addr                                   "0xB81ABBD8"
#define  SRNN_wdsr_layer3_3x3_bias_23_reg                                        0xB81ABBD8
#define  SRNN_wdsr_layer3_3x3_bias_23_inst_addr                                  "0x031A"
#define  set_SRNN_wdsr_layer3_3x3_bias_23_reg(data)                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_bias_23_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_bias_23_reg                                    (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_bias_23_reg))
#define  SRNN_wdsr_layer3_3x3_bias_23_layer3_bias_23_shift                       (0)
#define  SRNN_wdsr_layer3_3x3_bias_23_layer3_bias_23_mask                        (0x000003FF)
#define  SRNN_wdsr_layer3_3x3_bias_23_layer3_bias_23(data)                       (0x000003FF&(data))
#define  SRNN_wdsr_layer3_3x3_bias_23_get_layer3_bias_23(data)                   (0x000003FF&(data))

#define  SRNN_wdsr_layer3_3x3_bias_24                                           0x181ABBDC
#define  SRNN_wdsr_layer3_3x3_bias_24_reg_addr                                   "0xB81ABBDC"
#define  SRNN_wdsr_layer3_3x3_bias_24_reg                                        0xB81ABBDC
#define  SRNN_wdsr_layer3_3x3_bias_24_inst_addr                                  "0x031B"
#define  set_SRNN_wdsr_layer3_3x3_bias_24_reg(data)                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_bias_24_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_bias_24_reg                                    (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_bias_24_reg))
#define  SRNN_wdsr_layer3_3x3_bias_24_layer3_bias_24_shift                       (0)
#define  SRNN_wdsr_layer3_3x3_bias_24_layer3_bias_24_mask                        (0x000003FF)
#define  SRNN_wdsr_layer3_3x3_bias_24_layer3_bias_24(data)                       (0x000003FF&(data))
#define  SRNN_wdsr_layer3_3x3_bias_24_get_layer3_bias_24(data)                   (0x000003FF&(data))

#define  SRNN_wdsr_layer3_3x3_bias_25                                           0x181ABBE0
#define  SRNN_wdsr_layer3_3x3_bias_25_reg_addr                                   "0xB81ABBE0"
#define  SRNN_wdsr_layer3_3x3_bias_25_reg                                        0xB81ABBE0
#define  SRNN_wdsr_layer3_3x3_bias_25_inst_addr                                  "0x031C"
#define  set_SRNN_wdsr_layer3_3x3_bias_25_reg(data)                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_bias_25_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_bias_25_reg                                    (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_bias_25_reg))
#define  SRNN_wdsr_layer3_3x3_bias_25_layer3_bias_25_shift                       (0)
#define  SRNN_wdsr_layer3_3x3_bias_25_layer3_bias_25_mask                        (0x000003FF)
#define  SRNN_wdsr_layer3_3x3_bias_25_layer3_bias_25(data)                       (0x000003FF&(data))
#define  SRNN_wdsr_layer3_3x3_bias_25_get_layer3_bias_25(data)                   (0x000003FF&(data))

#define  SRNN_wdsr_layer3_3x3_bias_26                                           0x181ABBE4
#define  SRNN_wdsr_layer3_3x3_bias_26_reg_addr                                   "0xB81ABBE4"
#define  SRNN_wdsr_layer3_3x3_bias_26_reg                                        0xB81ABBE4
#define  SRNN_wdsr_layer3_3x3_bias_26_inst_addr                                  "0x031D"
#define  set_SRNN_wdsr_layer3_3x3_bias_26_reg(data)                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_bias_26_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_bias_26_reg                                    (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_bias_26_reg))
#define  SRNN_wdsr_layer3_3x3_bias_26_layer3_bias_26_shift                       (0)
#define  SRNN_wdsr_layer3_3x3_bias_26_layer3_bias_26_mask                        (0x000003FF)
#define  SRNN_wdsr_layer3_3x3_bias_26_layer3_bias_26(data)                       (0x000003FF&(data))
#define  SRNN_wdsr_layer3_3x3_bias_26_get_layer3_bias_26(data)                   (0x000003FF&(data))

#define  SRNN_wdsr_layer3_3x3_bias_27                                           0x181ABBE8
#define  SRNN_wdsr_layer3_3x3_bias_27_reg_addr                                   "0xB81ABBE8"
#define  SRNN_wdsr_layer3_3x3_bias_27_reg                                        0xB81ABBE8
#define  SRNN_wdsr_layer3_3x3_bias_27_inst_addr                                  "0x031E"
#define  set_SRNN_wdsr_layer3_3x3_bias_27_reg(data)                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_bias_27_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_bias_27_reg                                    (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_bias_27_reg))
#define  SRNN_wdsr_layer3_3x3_bias_27_layer3_bias_27_shift                       (0)
#define  SRNN_wdsr_layer3_3x3_bias_27_layer3_bias_27_mask                        (0x000003FF)
#define  SRNN_wdsr_layer3_3x3_bias_27_layer3_bias_27(data)                       (0x000003FF&(data))
#define  SRNN_wdsr_layer3_3x3_bias_27_get_layer3_bias_27(data)                   (0x000003FF&(data))

#define  SRNN_wdsr_layer3_3x3_bias_28                                           0x181ABBEC
#define  SRNN_wdsr_layer3_3x3_bias_28_reg_addr                                   "0xB81ABBEC"
#define  SRNN_wdsr_layer3_3x3_bias_28_reg                                        0xB81ABBEC
#define  SRNN_wdsr_layer3_3x3_bias_28_inst_addr                                  "0x031F"
#define  set_SRNN_wdsr_layer3_3x3_bias_28_reg(data)                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_bias_28_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_bias_28_reg                                    (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_bias_28_reg))
#define  SRNN_wdsr_layer3_3x3_bias_28_layer3_bias_28_shift                       (0)
#define  SRNN_wdsr_layer3_3x3_bias_28_layer3_bias_28_mask                        (0x000003FF)
#define  SRNN_wdsr_layer3_3x3_bias_28_layer3_bias_28(data)                       (0x000003FF&(data))
#define  SRNN_wdsr_layer3_3x3_bias_28_get_layer3_bias_28(data)                   (0x000003FF&(data))

#define  SRNN_wdsr_layer3_3x3_bias_29                                           0x181ABBF0
#define  SRNN_wdsr_layer3_3x3_bias_29_reg_addr                                   "0xB81ABBF0"
#define  SRNN_wdsr_layer3_3x3_bias_29_reg                                        0xB81ABBF0
#define  SRNN_wdsr_layer3_3x3_bias_29_inst_addr                                  "0x0320"
#define  set_SRNN_wdsr_layer3_3x3_bias_29_reg(data)                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_bias_29_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_bias_29_reg                                    (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_bias_29_reg))
#define  SRNN_wdsr_layer3_3x3_bias_29_layer3_bias_29_shift                       (0)
#define  SRNN_wdsr_layer3_3x3_bias_29_layer3_bias_29_mask                        (0x000003FF)
#define  SRNN_wdsr_layer3_3x3_bias_29_layer3_bias_29(data)                       (0x000003FF&(data))
#define  SRNN_wdsr_layer3_3x3_bias_29_get_layer3_bias_29(data)                   (0x000003FF&(data))

#define  SRNN_wdsr_layer3_3x3_bias_30                                           0x181ABBF4
#define  SRNN_wdsr_layer3_3x3_bias_30_reg_addr                                   "0xB81ABBF4"
#define  SRNN_wdsr_layer3_3x3_bias_30_reg                                        0xB81ABBF4
#define  SRNN_wdsr_layer3_3x3_bias_30_inst_addr                                  "0x0321"
#define  set_SRNN_wdsr_layer3_3x3_bias_30_reg(data)                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_bias_30_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_bias_30_reg                                    (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_bias_30_reg))
#define  SRNN_wdsr_layer3_3x3_bias_30_layer3_bias_30_shift                       (0)
#define  SRNN_wdsr_layer3_3x3_bias_30_layer3_bias_30_mask                        (0x000003FF)
#define  SRNN_wdsr_layer3_3x3_bias_30_layer3_bias_30(data)                       (0x000003FF&(data))
#define  SRNN_wdsr_layer3_3x3_bias_30_get_layer3_bias_30(data)                   (0x000003FF&(data))

#define  SRNN_wdsr_layer3_3x3_bias_31                                           0x181ABBF8
#define  SRNN_wdsr_layer3_3x3_bias_31_reg_addr                                   "0xB81ABBF8"
#define  SRNN_wdsr_layer3_3x3_bias_31_reg                                        0xB81ABBF8
#define  SRNN_wdsr_layer3_3x3_bias_31_inst_addr                                  "0x0322"
#define  set_SRNN_wdsr_layer3_3x3_bias_31_reg(data)                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_bias_31_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_bias_31_reg                                    (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_bias_31_reg))
#define  SRNN_wdsr_layer3_3x3_bias_31_layer3_bias_31_shift                       (0)
#define  SRNN_wdsr_layer3_3x3_bias_31_layer3_bias_31_mask                        (0x000003FF)
#define  SRNN_wdsr_layer3_3x3_bias_31_layer3_bias_31(data)                       (0x000003FF&(data))
#define  SRNN_wdsr_layer3_3x3_bias_31_get_layer3_bias_31(data)                   (0x000003FF&(data))

#define  SRNN_wdsr_layer3_3x3_bias_32                                           0x181ABBFC
#define  SRNN_wdsr_layer3_3x3_bias_32_reg_addr                                   "0xB81ABBFC"
#define  SRNN_wdsr_layer3_3x3_bias_32_reg                                        0xB81ABBFC
#define  SRNN_wdsr_layer3_3x3_bias_32_inst_addr                                  "0x0323"
#define  set_SRNN_wdsr_layer3_3x3_bias_32_reg(data)                              (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_bias_32_reg)=data)
#define  get_SRNN_wdsr_layer3_3x3_bias_32_reg                                    (*((volatile unsigned int*)SRNN_wdsr_layer3_3x3_bias_32_reg))
#define  SRNN_wdsr_layer3_3x3_bias_32_layer3_bias_32_shift                       (0)
#define  SRNN_wdsr_layer3_3x3_bias_32_layer3_bias_32_mask                        (0x000003FF)
#define  SRNN_wdsr_layer3_3x3_bias_32_layer3_bias_32(data)                       (0x000003FF&(data))
#define  SRNN_wdsr_layer3_3x3_bias_32_get_layer3_bias_32(data)                   (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_1_1                                       0x181ABC00
#define  SRNN_wdsr_layer3_1x1_weights_1_1_reg_addr                               "0xB81ABC00"
#define  SRNN_wdsr_layer3_1x1_weights_1_1_reg                                    0xB81ABC00
#define  SRNN_wdsr_layer3_1x1_weights_1_1_inst_addr                              "0x0324"
#define  set_SRNN_wdsr_layer3_1x1_weights_1_1_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_1_1_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_1_1_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_1_1_reg))
#define  SRNN_wdsr_layer3_1x1_weights_1_1_layer3_weight_1_shift                  (0)
#define  SRNN_wdsr_layer3_1x1_weights_1_1_layer3_weight_1_mask                   (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_1_1_layer3_weight_1(data)                  (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_1_1_get_layer3_weight_1(data)              (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_1_2                                       0x181ABC04
#define  SRNN_wdsr_layer3_1x1_weights_1_2_reg_addr                               "0xB81ABC04"
#define  SRNN_wdsr_layer3_1x1_weights_1_2_reg                                    0xB81ABC04
#define  SRNN_wdsr_layer3_1x1_weights_1_2_inst_addr                              "0x0325"
#define  set_SRNN_wdsr_layer3_1x1_weights_1_2_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_1_2_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_1_2_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_1_2_reg))
#define  SRNN_wdsr_layer3_1x1_weights_1_2_layer3_weight_2_shift                  (0)
#define  SRNN_wdsr_layer3_1x1_weights_1_2_layer3_weight_2_mask                   (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_1_2_layer3_weight_2(data)                  (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_1_2_get_layer3_weight_2(data)              (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_1_3                                       0x181ABC08
#define  SRNN_wdsr_layer3_1x1_weights_1_3_reg_addr                               "0xB81ABC08"
#define  SRNN_wdsr_layer3_1x1_weights_1_3_reg                                    0xB81ABC08
#define  SRNN_wdsr_layer3_1x1_weights_1_3_inst_addr                              "0x0326"
#define  set_SRNN_wdsr_layer3_1x1_weights_1_3_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_1_3_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_1_3_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_1_3_reg))
#define  SRNN_wdsr_layer3_1x1_weights_1_3_layer3_weight_3_shift                  (0)
#define  SRNN_wdsr_layer3_1x1_weights_1_3_layer3_weight_3_mask                   (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_1_3_layer3_weight_3(data)                  (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_1_3_get_layer3_weight_3(data)              (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_1_4                                       0x181ABC0C
#define  SRNN_wdsr_layer3_1x1_weights_1_4_reg_addr                               "0xB81ABC0C"
#define  SRNN_wdsr_layer3_1x1_weights_1_4_reg                                    0xB81ABC0C
#define  SRNN_wdsr_layer3_1x1_weights_1_4_inst_addr                              "0x0327"
#define  set_SRNN_wdsr_layer3_1x1_weights_1_4_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_1_4_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_1_4_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_1_4_reg))
#define  SRNN_wdsr_layer3_1x1_weights_1_4_layer3_weight_4_shift                  (0)
#define  SRNN_wdsr_layer3_1x1_weights_1_4_layer3_weight_4_mask                   (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_1_4_layer3_weight_4(data)                  (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_1_4_get_layer3_weight_4(data)              (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_1_5                                       0x181ABC10
#define  SRNN_wdsr_layer3_1x1_weights_1_5_reg_addr                               "0xB81ABC10"
#define  SRNN_wdsr_layer3_1x1_weights_1_5_reg                                    0xB81ABC10
#define  SRNN_wdsr_layer3_1x1_weights_1_5_inst_addr                              "0x0328"
#define  set_SRNN_wdsr_layer3_1x1_weights_1_5_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_1_5_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_1_5_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_1_5_reg))
#define  SRNN_wdsr_layer3_1x1_weights_1_5_layer3_weight_5_shift                  (0)
#define  SRNN_wdsr_layer3_1x1_weights_1_5_layer3_weight_5_mask                   (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_1_5_layer3_weight_5(data)                  (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_1_5_get_layer3_weight_5(data)              (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_1_6                                       0x181ABC14
#define  SRNN_wdsr_layer3_1x1_weights_1_6_reg_addr                               "0xB81ABC14"
#define  SRNN_wdsr_layer3_1x1_weights_1_6_reg                                    0xB81ABC14
#define  SRNN_wdsr_layer3_1x1_weights_1_6_inst_addr                              "0x0329"
#define  set_SRNN_wdsr_layer3_1x1_weights_1_6_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_1_6_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_1_6_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_1_6_reg))
#define  SRNN_wdsr_layer3_1x1_weights_1_6_layer3_weight_6_shift                  (0)
#define  SRNN_wdsr_layer3_1x1_weights_1_6_layer3_weight_6_mask                   (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_1_6_layer3_weight_6(data)                  (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_1_6_get_layer3_weight_6(data)              (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_1_7                                       0x181ABC18
#define  SRNN_wdsr_layer3_1x1_weights_1_7_reg_addr                               "0xB81ABC18"
#define  SRNN_wdsr_layer3_1x1_weights_1_7_reg                                    0xB81ABC18
#define  SRNN_wdsr_layer3_1x1_weights_1_7_inst_addr                              "0x032A"
#define  set_SRNN_wdsr_layer3_1x1_weights_1_7_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_1_7_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_1_7_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_1_7_reg))
#define  SRNN_wdsr_layer3_1x1_weights_1_7_layer3_weight_7_shift                  (0)
#define  SRNN_wdsr_layer3_1x1_weights_1_7_layer3_weight_7_mask                   (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_1_7_layer3_weight_7(data)                  (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_1_7_get_layer3_weight_7(data)              (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_1_8                                       0x181ABC1C
#define  SRNN_wdsr_layer3_1x1_weights_1_8_reg_addr                               "0xB81ABC1C"
#define  SRNN_wdsr_layer3_1x1_weights_1_8_reg                                    0xB81ABC1C
#define  SRNN_wdsr_layer3_1x1_weights_1_8_inst_addr                              "0x032B"
#define  set_SRNN_wdsr_layer3_1x1_weights_1_8_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_1_8_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_1_8_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_1_8_reg))
#define  SRNN_wdsr_layer3_1x1_weights_1_8_layer3_weight_8_shift                  (0)
#define  SRNN_wdsr_layer3_1x1_weights_1_8_layer3_weight_8_mask                   (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_1_8_layer3_weight_8(data)                  (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_1_8_get_layer3_weight_8(data)              (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_1_9                                       0x181ABC20
#define  SRNN_wdsr_layer3_1x1_weights_1_9_reg_addr                               "0xB81ABC20"
#define  SRNN_wdsr_layer3_1x1_weights_1_9_reg                                    0xB81ABC20
#define  SRNN_wdsr_layer3_1x1_weights_1_9_inst_addr                              "0x032C"
#define  set_SRNN_wdsr_layer3_1x1_weights_1_9_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_1_9_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_1_9_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_1_9_reg))
#define  SRNN_wdsr_layer3_1x1_weights_1_9_layer3_weight_9_shift                  (0)
#define  SRNN_wdsr_layer3_1x1_weights_1_9_layer3_weight_9_mask                   (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_1_9_layer3_weight_9(data)                  (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_1_9_get_layer3_weight_9(data)              (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_1_10                                      0x181ABC24
#define  SRNN_wdsr_layer3_1x1_weights_1_10_reg_addr                              "0xB81ABC24"
#define  SRNN_wdsr_layer3_1x1_weights_1_10_reg                                   0xB81ABC24
#define  SRNN_wdsr_layer3_1x1_weights_1_10_inst_addr                             "0x032D"
#define  set_SRNN_wdsr_layer3_1x1_weights_1_10_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_1_10_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_1_10_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_1_10_reg))
#define  SRNN_wdsr_layer3_1x1_weights_1_10_layer3_weight_10_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_1_10_layer3_weight_10_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_1_10_layer3_weight_10(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_1_10_get_layer3_weight_10(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_1_11                                      0x181ABC28
#define  SRNN_wdsr_layer3_1x1_weights_1_11_reg_addr                              "0xB81ABC28"
#define  SRNN_wdsr_layer3_1x1_weights_1_11_reg                                   0xB81ABC28
#define  SRNN_wdsr_layer3_1x1_weights_1_11_inst_addr                             "0x032E"
#define  set_SRNN_wdsr_layer3_1x1_weights_1_11_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_1_11_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_1_11_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_1_11_reg))
#define  SRNN_wdsr_layer3_1x1_weights_1_11_layer3_weight_11_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_1_11_layer3_weight_11_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_1_11_layer3_weight_11(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_1_11_get_layer3_weight_11(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_1_12                                      0x181ABC2C
#define  SRNN_wdsr_layer3_1x1_weights_1_12_reg_addr                              "0xB81ABC2C"
#define  SRNN_wdsr_layer3_1x1_weights_1_12_reg                                   0xB81ABC2C
#define  SRNN_wdsr_layer3_1x1_weights_1_12_inst_addr                             "0x032F"
#define  set_SRNN_wdsr_layer3_1x1_weights_1_12_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_1_12_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_1_12_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_1_12_reg))
#define  SRNN_wdsr_layer3_1x1_weights_1_12_layer3_weight_12_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_1_12_layer3_weight_12_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_1_12_layer3_weight_12(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_1_12_get_layer3_weight_12(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_1_13                                      0x181ABC30
#define  SRNN_wdsr_layer3_1x1_weights_1_13_reg_addr                              "0xB81ABC30"
#define  SRNN_wdsr_layer3_1x1_weights_1_13_reg                                   0xB81ABC30
#define  SRNN_wdsr_layer3_1x1_weights_1_13_inst_addr                             "0x0330"
#define  set_SRNN_wdsr_layer3_1x1_weights_1_13_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_1_13_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_1_13_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_1_13_reg))
#define  SRNN_wdsr_layer3_1x1_weights_1_13_layer3_weight_13_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_1_13_layer3_weight_13_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_1_13_layer3_weight_13(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_1_13_get_layer3_weight_13(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_1_14                                      0x181ABC34
#define  SRNN_wdsr_layer3_1x1_weights_1_14_reg_addr                              "0xB81ABC34"
#define  SRNN_wdsr_layer3_1x1_weights_1_14_reg                                   0xB81ABC34
#define  SRNN_wdsr_layer3_1x1_weights_1_14_inst_addr                             "0x0331"
#define  set_SRNN_wdsr_layer3_1x1_weights_1_14_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_1_14_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_1_14_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_1_14_reg))
#define  SRNN_wdsr_layer3_1x1_weights_1_14_layer3_weight_14_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_1_14_layer3_weight_14_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_1_14_layer3_weight_14(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_1_14_get_layer3_weight_14(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_1_15                                      0x181ABC38
#define  SRNN_wdsr_layer3_1x1_weights_1_15_reg_addr                              "0xB81ABC38"
#define  SRNN_wdsr_layer3_1x1_weights_1_15_reg                                   0xB81ABC38
#define  SRNN_wdsr_layer3_1x1_weights_1_15_inst_addr                             "0x0332"
#define  set_SRNN_wdsr_layer3_1x1_weights_1_15_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_1_15_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_1_15_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_1_15_reg))
#define  SRNN_wdsr_layer3_1x1_weights_1_15_layer3_weight_15_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_1_15_layer3_weight_15_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_1_15_layer3_weight_15(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_1_15_get_layer3_weight_15(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_1_16                                      0x181ABC3C
#define  SRNN_wdsr_layer3_1x1_weights_1_16_reg_addr                              "0xB81ABC3C"
#define  SRNN_wdsr_layer3_1x1_weights_1_16_reg                                   0xB81ABC3C
#define  SRNN_wdsr_layer3_1x1_weights_1_16_inst_addr                             "0x0333"
#define  set_SRNN_wdsr_layer3_1x1_weights_1_16_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_1_16_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_1_16_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_1_16_reg))
#define  SRNN_wdsr_layer3_1x1_weights_1_16_layer3_weight_16_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_1_16_layer3_weight_16_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_1_16_layer3_weight_16(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_1_16_get_layer3_weight_16(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_1_17                                      0x181ABC40
#define  SRNN_wdsr_layer3_1x1_weights_1_17_reg_addr                              "0xB81ABC40"
#define  SRNN_wdsr_layer3_1x1_weights_1_17_reg                                   0xB81ABC40
#define  SRNN_wdsr_layer3_1x1_weights_1_17_inst_addr                             "0x0334"
#define  set_SRNN_wdsr_layer3_1x1_weights_1_17_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_1_17_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_1_17_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_1_17_reg))
#define  SRNN_wdsr_layer3_1x1_weights_1_17_layer3_weight_17_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_1_17_layer3_weight_17_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_1_17_layer3_weight_17(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_1_17_get_layer3_weight_17(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_1_18                                      0x181ABC44
#define  SRNN_wdsr_layer3_1x1_weights_1_18_reg_addr                              "0xB81ABC44"
#define  SRNN_wdsr_layer3_1x1_weights_1_18_reg                                   0xB81ABC44
#define  SRNN_wdsr_layer3_1x1_weights_1_18_inst_addr                             "0x0335"
#define  set_SRNN_wdsr_layer3_1x1_weights_1_18_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_1_18_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_1_18_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_1_18_reg))
#define  SRNN_wdsr_layer3_1x1_weights_1_18_layer3_weight_18_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_1_18_layer3_weight_18_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_1_18_layer3_weight_18(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_1_18_get_layer3_weight_18(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_1_19                                      0x181ABC48
#define  SRNN_wdsr_layer3_1x1_weights_1_19_reg_addr                              "0xB81ABC48"
#define  SRNN_wdsr_layer3_1x1_weights_1_19_reg                                   0xB81ABC48
#define  SRNN_wdsr_layer3_1x1_weights_1_19_inst_addr                             "0x0336"
#define  set_SRNN_wdsr_layer3_1x1_weights_1_19_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_1_19_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_1_19_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_1_19_reg))
#define  SRNN_wdsr_layer3_1x1_weights_1_19_layer3_weight_19_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_1_19_layer3_weight_19_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_1_19_layer3_weight_19(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_1_19_get_layer3_weight_19(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_1_20                                      0x181ABC4C
#define  SRNN_wdsr_layer3_1x1_weights_1_20_reg_addr                              "0xB81ABC4C"
#define  SRNN_wdsr_layer3_1x1_weights_1_20_reg                                   0xB81ABC4C
#define  SRNN_wdsr_layer3_1x1_weights_1_20_inst_addr                             "0x0337"
#define  set_SRNN_wdsr_layer3_1x1_weights_1_20_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_1_20_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_1_20_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_1_20_reg))
#define  SRNN_wdsr_layer3_1x1_weights_1_20_layer3_weight_20_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_1_20_layer3_weight_20_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_1_20_layer3_weight_20(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_1_20_get_layer3_weight_20(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_1_21                                      0x181ABC50
#define  SRNN_wdsr_layer3_1x1_weights_1_21_reg_addr                              "0xB81ABC50"
#define  SRNN_wdsr_layer3_1x1_weights_1_21_reg                                   0xB81ABC50
#define  SRNN_wdsr_layer3_1x1_weights_1_21_inst_addr                             "0x0338"
#define  set_SRNN_wdsr_layer3_1x1_weights_1_21_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_1_21_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_1_21_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_1_21_reg))
#define  SRNN_wdsr_layer3_1x1_weights_1_21_layer3_weight_21_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_1_21_layer3_weight_21_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_1_21_layer3_weight_21(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_1_21_get_layer3_weight_21(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_1_22                                      0x181ABC54
#define  SRNN_wdsr_layer3_1x1_weights_1_22_reg_addr                              "0xB81ABC54"
#define  SRNN_wdsr_layer3_1x1_weights_1_22_reg                                   0xB81ABC54
#define  SRNN_wdsr_layer3_1x1_weights_1_22_inst_addr                             "0x0339"
#define  set_SRNN_wdsr_layer3_1x1_weights_1_22_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_1_22_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_1_22_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_1_22_reg))
#define  SRNN_wdsr_layer3_1x1_weights_1_22_layer3_weight_22_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_1_22_layer3_weight_22_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_1_22_layer3_weight_22(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_1_22_get_layer3_weight_22(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_1_23                                      0x181ABC58
#define  SRNN_wdsr_layer3_1x1_weights_1_23_reg_addr                              "0xB81ABC58"
#define  SRNN_wdsr_layer3_1x1_weights_1_23_reg                                   0xB81ABC58
#define  SRNN_wdsr_layer3_1x1_weights_1_23_inst_addr                             "0x033A"
#define  set_SRNN_wdsr_layer3_1x1_weights_1_23_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_1_23_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_1_23_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_1_23_reg))
#define  SRNN_wdsr_layer3_1x1_weights_1_23_layer3_weight_23_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_1_23_layer3_weight_23_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_1_23_layer3_weight_23(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_1_23_get_layer3_weight_23(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_1_24                                      0x181ABC5C
#define  SRNN_wdsr_layer3_1x1_weights_1_24_reg_addr                              "0xB81ABC5C"
#define  SRNN_wdsr_layer3_1x1_weights_1_24_reg                                   0xB81ABC5C
#define  SRNN_wdsr_layer3_1x1_weights_1_24_inst_addr                             "0x033B"
#define  set_SRNN_wdsr_layer3_1x1_weights_1_24_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_1_24_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_1_24_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_1_24_reg))
#define  SRNN_wdsr_layer3_1x1_weights_1_24_layer3_weight_24_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_1_24_layer3_weight_24_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_1_24_layer3_weight_24(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_1_24_get_layer3_weight_24(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_1_25                                      0x181ABC60
#define  SRNN_wdsr_layer3_1x1_weights_1_25_reg_addr                              "0xB81ABC60"
#define  SRNN_wdsr_layer3_1x1_weights_1_25_reg                                   0xB81ABC60
#define  SRNN_wdsr_layer3_1x1_weights_1_25_inst_addr                             "0x033C"
#define  set_SRNN_wdsr_layer3_1x1_weights_1_25_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_1_25_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_1_25_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_1_25_reg))
#define  SRNN_wdsr_layer3_1x1_weights_1_25_layer3_weight_25_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_1_25_layer3_weight_25_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_1_25_layer3_weight_25(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_1_25_get_layer3_weight_25(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_1_26                                      0x181ABC64
#define  SRNN_wdsr_layer3_1x1_weights_1_26_reg_addr                              "0xB81ABC64"
#define  SRNN_wdsr_layer3_1x1_weights_1_26_reg                                   0xB81ABC64
#define  SRNN_wdsr_layer3_1x1_weights_1_26_inst_addr                             "0x033D"
#define  set_SRNN_wdsr_layer3_1x1_weights_1_26_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_1_26_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_1_26_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_1_26_reg))
#define  SRNN_wdsr_layer3_1x1_weights_1_26_layer3_weight_26_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_1_26_layer3_weight_26_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_1_26_layer3_weight_26(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_1_26_get_layer3_weight_26(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_1_27                                      0x181ABC68
#define  SRNN_wdsr_layer3_1x1_weights_1_27_reg_addr                              "0xB81ABC68"
#define  SRNN_wdsr_layer3_1x1_weights_1_27_reg                                   0xB81ABC68
#define  SRNN_wdsr_layer3_1x1_weights_1_27_inst_addr                             "0x033E"
#define  set_SRNN_wdsr_layer3_1x1_weights_1_27_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_1_27_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_1_27_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_1_27_reg))
#define  SRNN_wdsr_layer3_1x1_weights_1_27_layer3_weight_27_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_1_27_layer3_weight_27_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_1_27_layer3_weight_27(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_1_27_get_layer3_weight_27(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_1_28                                      0x181ABC6C
#define  SRNN_wdsr_layer3_1x1_weights_1_28_reg_addr                              "0xB81ABC6C"
#define  SRNN_wdsr_layer3_1x1_weights_1_28_reg                                   0xB81ABC6C
#define  SRNN_wdsr_layer3_1x1_weights_1_28_inst_addr                             "0x033F"
#define  set_SRNN_wdsr_layer3_1x1_weights_1_28_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_1_28_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_1_28_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_1_28_reg))
#define  SRNN_wdsr_layer3_1x1_weights_1_28_layer3_weight_28_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_1_28_layer3_weight_28_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_1_28_layer3_weight_28(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_1_28_get_layer3_weight_28(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_1_29                                      0x181ABC70
#define  SRNN_wdsr_layer3_1x1_weights_1_29_reg_addr                              "0xB81ABC70"
#define  SRNN_wdsr_layer3_1x1_weights_1_29_reg                                   0xB81ABC70
#define  SRNN_wdsr_layer3_1x1_weights_1_29_inst_addr                             "0x0340"
#define  set_SRNN_wdsr_layer3_1x1_weights_1_29_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_1_29_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_1_29_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_1_29_reg))
#define  SRNN_wdsr_layer3_1x1_weights_1_29_layer3_weight_29_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_1_29_layer3_weight_29_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_1_29_layer3_weight_29(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_1_29_get_layer3_weight_29(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_1_30                                      0x181ABC74
#define  SRNN_wdsr_layer3_1x1_weights_1_30_reg_addr                              "0xB81ABC74"
#define  SRNN_wdsr_layer3_1x1_weights_1_30_reg                                   0xB81ABC74
#define  SRNN_wdsr_layer3_1x1_weights_1_30_inst_addr                             "0x0341"
#define  set_SRNN_wdsr_layer3_1x1_weights_1_30_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_1_30_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_1_30_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_1_30_reg))
#define  SRNN_wdsr_layer3_1x1_weights_1_30_layer3_weight_30_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_1_30_layer3_weight_30_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_1_30_layer3_weight_30(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_1_30_get_layer3_weight_30(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_1_31                                      0x181ABC78
#define  SRNN_wdsr_layer3_1x1_weights_1_31_reg_addr                              "0xB81ABC78"
#define  SRNN_wdsr_layer3_1x1_weights_1_31_reg                                   0xB81ABC78
#define  SRNN_wdsr_layer3_1x1_weights_1_31_inst_addr                             "0x0342"
#define  set_SRNN_wdsr_layer3_1x1_weights_1_31_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_1_31_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_1_31_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_1_31_reg))
#define  SRNN_wdsr_layer3_1x1_weights_1_31_layer3_weight_31_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_1_31_layer3_weight_31_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_1_31_layer3_weight_31(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_1_31_get_layer3_weight_31(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_1_32                                      0x181ABC7C
#define  SRNN_wdsr_layer3_1x1_weights_1_32_reg_addr                              "0xB81ABC7C"
#define  SRNN_wdsr_layer3_1x1_weights_1_32_reg                                   0xB81ABC7C
#define  SRNN_wdsr_layer3_1x1_weights_1_32_inst_addr                             "0x0343"
#define  set_SRNN_wdsr_layer3_1x1_weights_1_32_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_1_32_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_1_32_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_1_32_reg))
#define  SRNN_wdsr_layer3_1x1_weights_1_32_layer3_weight_32_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_1_32_layer3_weight_32_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_1_32_layer3_weight_32(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_1_32_get_layer3_weight_32(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_2_1                                       0x181ABC80
#define  SRNN_wdsr_layer3_1x1_weights_2_1_reg_addr                               "0xB81ABC80"
#define  SRNN_wdsr_layer3_1x1_weights_2_1_reg                                    0xB81ABC80
#define  SRNN_wdsr_layer3_1x1_weights_2_1_inst_addr                              "0x0344"
#define  set_SRNN_wdsr_layer3_1x1_weights_2_1_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_2_1_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_2_1_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_2_1_reg))
#define  SRNN_wdsr_layer3_1x1_weights_2_1_layer3_weight_1_shift                  (0)
#define  SRNN_wdsr_layer3_1x1_weights_2_1_layer3_weight_1_mask                   (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_2_1_layer3_weight_1(data)                  (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_2_1_get_layer3_weight_1(data)              (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_2_2                                       0x181ABC84
#define  SRNN_wdsr_layer3_1x1_weights_2_2_reg_addr                               "0xB81ABC84"
#define  SRNN_wdsr_layer3_1x1_weights_2_2_reg                                    0xB81ABC84
#define  SRNN_wdsr_layer3_1x1_weights_2_2_inst_addr                              "0x0345"
#define  set_SRNN_wdsr_layer3_1x1_weights_2_2_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_2_2_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_2_2_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_2_2_reg))
#define  SRNN_wdsr_layer3_1x1_weights_2_2_layer3_weight_2_shift                  (0)
#define  SRNN_wdsr_layer3_1x1_weights_2_2_layer3_weight_2_mask                   (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_2_2_layer3_weight_2(data)                  (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_2_2_get_layer3_weight_2(data)              (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_2_3                                       0x181ABC88
#define  SRNN_wdsr_layer3_1x1_weights_2_3_reg_addr                               "0xB81ABC88"
#define  SRNN_wdsr_layer3_1x1_weights_2_3_reg                                    0xB81ABC88
#define  SRNN_wdsr_layer3_1x1_weights_2_3_inst_addr                              "0x0346"
#define  set_SRNN_wdsr_layer3_1x1_weights_2_3_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_2_3_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_2_3_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_2_3_reg))
#define  SRNN_wdsr_layer3_1x1_weights_2_3_layer3_weight_3_shift                  (0)
#define  SRNN_wdsr_layer3_1x1_weights_2_3_layer3_weight_3_mask                   (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_2_3_layer3_weight_3(data)                  (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_2_3_get_layer3_weight_3(data)              (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_2_4                                       0x181ABC8C
#define  SRNN_wdsr_layer3_1x1_weights_2_4_reg_addr                               "0xB81ABC8C"
#define  SRNN_wdsr_layer3_1x1_weights_2_4_reg                                    0xB81ABC8C
#define  SRNN_wdsr_layer3_1x1_weights_2_4_inst_addr                              "0x0347"
#define  set_SRNN_wdsr_layer3_1x1_weights_2_4_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_2_4_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_2_4_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_2_4_reg))
#define  SRNN_wdsr_layer3_1x1_weights_2_4_layer3_weight_4_shift                  (0)
#define  SRNN_wdsr_layer3_1x1_weights_2_4_layer3_weight_4_mask                   (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_2_4_layer3_weight_4(data)                  (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_2_4_get_layer3_weight_4(data)              (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_2_5                                       0x181ABC90
#define  SRNN_wdsr_layer3_1x1_weights_2_5_reg_addr                               "0xB81ABC90"
#define  SRNN_wdsr_layer3_1x1_weights_2_5_reg                                    0xB81ABC90
#define  SRNN_wdsr_layer3_1x1_weights_2_5_inst_addr                              "0x0348"
#define  set_SRNN_wdsr_layer3_1x1_weights_2_5_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_2_5_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_2_5_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_2_5_reg))
#define  SRNN_wdsr_layer3_1x1_weights_2_5_layer3_weight_5_shift                  (0)
#define  SRNN_wdsr_layer3_1x1_weights_2_5_layer3_weight_5_mask                   (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_2_5_layer3_weight_5(data)                  (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_2_5_get_layer3_weight_5(data)              (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_2_6                                       0x181ABC94
#define  SRNN_wdsr_layer3_1x1_weights_2_6_reg_addr                               "0xB81ABC94"
#define  SRNN_wdsr_layer3_1x1_weights_2_6_reg                                    0xB81ABC94
#define  SRNN_wdsr_layer3_1x1_weights_2_6_inst_addr                              "0x0349"
#define  set_SRNN_wdsr_layer3_1x1_weights_2_6_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_2_6_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_2_6_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_2_6_reg))
#define  SRNN_wdsr_layer3_1x1_weights_2_6_layer3_weight_6_shift                  (0)
#define  SRNN_wdsr_layer3_1x1_weights_2_6_layer3_weight_6_mask                   (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_2_6_layer3_weight_6(data)                  (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_2_6_get_layer3_weight_6(data)              (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_2_7                                       0x181ABC98
#define  SRNN_wdsr_layer3_1x1_weights_2_7_reg_addr                               "0xB81ABC98"
#define  SRNN_wdsr_layer3_1x1_weights_2_7_reg                                    0xB81ABC98
#define  SRNN_wdsr_layer3_1x1_weights_2_7_inst_addr                              "0x034A"
#define  set_SRNN_wdsr_layer3_1x1_weights_2_7_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_2_7_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_2_7_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_2_7_reg))
#define  SRNN_wdsr_layer3_1x1_weights_2_7_layer3_weight_7_shift                  (0)
#define  SRNN_wdsr_layer3_1x1_weights_2_7_layer3_weight_7_mask                   (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_2_7_layer3_weight_7(data)                  (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_2_7_get_layer3_weight_7(data)              (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_2_8                                       0x181ABC9C
#define  SRNN_wdsr_layer3_1x1_weights_2_8_reg_addr                               "0xB81ABC9C"
#define  SRNN_wdsr_layer3_1x1_weights_2_8_reg                                    0xB81ABC9C
#define  SRNN_wdsr_layer3_1x1_weights_2_8_inst_addr                              "0x034B"
#define  set_SRNN_wdsr_layer3_1x1_weights_2_8_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_2_8_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_2_8_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_2_8_reg))
#define  SRNN_wdsr_layer3_1x1_weights_2_8_layer3_weight_8_shift                  (0)
#define  SRNN_wdsr_layer3_1x1_weights_2_8_layer3_weight_8_mask                   (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_2_8_layer3_weight_8(data)                  (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_2_8_get_layer3_weight_8(data)              (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_2_9                                       0x181ABCA0
#define  SRNN_wdsr_layer3_1x1_weights_2_9_reg_addr                               "0xB81ABCA0"
#define  SRNN_wdsr_layer3_1x1_weights_2_9_reg                                    0xB81ABCA0
#define  SRNN_wdsr_layer3_1x1_weights_2_9_inst_addr                              "0x034C"
#define  set_SRNN_wdsr_layer3_1x1_weights_2_9_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_2_9_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_2_9_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_2_9_reg))
#define  SRNN_wdsr_layer3_1x1_weights_2_9_layer3_weight_9_shift                  (0)
#define  SRNN_wdsr_layer3_1x1_weights_2_9_layer3_weight_9_mask                   (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_2_9_layer3_weight_9(data)                  (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_2_9_get_layer3_weight_9(data)              (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_2_10                                      0x181ABCA4
#define  SRNN_wdsr_layer3_1x1_weights_2_10_reg_addr                              "0xB81ABCA4"
#define  SRNN_wdsr_layer3_1x1_weights_2_10_reg                                   0xB81ABCA4
#define  SRNN_wdsr_layer3_1x1_weights_2_10_inst_addr                             "0x034D"
#define  set_SRNN_wdsr_layer3_1x1_weights_2_10_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_2_10_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_2_10_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_2_10_reg))
#define  SRNN_wdsr_layer3_1x1_weights_2_10_layer3_weight_10_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_2_10_layer3_weight_10_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_2_10_layer3_weight_10(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_2_10_get_layer3_weight_10(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_2_11                                      0x181ABCA8
#define  SRNN_wdsr_layer3_1x1_weights_2_11_reg_addr                              "0xB81ABCA8"
#define  SRNN_wdsr_layer3_1x1_weights_2_11_reg                                   0xB81ABCA8
#define  SRNN_wdsr_layer3_1x1_weights_2_11_inst_addr                             "0x034E"
#define  set_SRNN_wdsr_layer3_1x1_weights_2_11_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_2_11_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_2_11_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_2_11_reg))
#define  SRNN_wdsr_layer3_1x1_weights_2_11_layer3_weight_11_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_2_11_layer3_weight_11_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_2_11_layer3_weight_11(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_2_11_get_layer3_weight_11(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_2_12                                      0x181ABCAC
#define  SRNN_wdsr_layer3_1x1_weights_2_12_reg_addr                              "0xB81ABCAC"
#define  SRNN_wdsr_layer3_1x1_weights_2_12_reg                                   0xB81ABCAC
#define  SRNN_wdsr_layer3_1x1_weights_2_12_inst_addr                             "0x034F"
#define  set_SRNN_wdsr_layer3_1x1_weights_2_12_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_2_12_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_2_12_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_2_12_reg))
#define  SRNN_wdsr_layer3_1x1_weights_2_12_layer3_weight_12_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_2_12_layer3_weight_12_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_2_12_layer3_weight_12(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_2_12_get_layer3_weight_12(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_2_13                                      0x181ABCB0
#define  SRNN_wdsr_layer3_1x1_weights_2_13_reg_addr                              "0xB81ABCB0"
#define  SRNN_wdsr_layer3_1x1_weights_2_13_reg                                   0xB81ABCB0
#define  SRNN_wdsr_layer3_1x1_weights_2_13_inst_addr                             "0x0350"
#define  set_SRNN_wdsr_layer3_1x1_weights_2_13_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_2_13_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_2_13_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_2_13_reg))
#define  SRNN_wdsr_layer3_1x1_weights_2_13_layer3_weight_13_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_2_13_layer3_weight_13_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_2_13_layer3_weight_13(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_2_13_get_layer3_weight_13(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_2_14                                      0x181ABCB4
#define  SRNN_wdsr_layer3_1x1_weights_2_14_reg_addr                              "0xB81ABCB4"
#define  SRNN_wdsr_layer3_1x1_weights_2_14_reg                                   0xB81ABCB4
#define  SRNN_wdsr_layer3_1x1_weights_2_14_inst_addr                             "0x0351"
#define  set_SRNN_wdsr_layer3_1x1_weights_2_14_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_2_14_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_2_14_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_2_14_reg))
#define  SRNN_wdsr_layer3_1x1_weights_2_14_layer3_weight_14_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_2_14_layer3_weight_14_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_2_14_layer3_weight_14(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_2_14_get_layer3_weight_14(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_2_15                                      0x181ABCB8
#define  SRNN_wdsr_layer3_1x1_weights_2_15_reg_addr                              "0xB81ABCB8"
#define  SRNN_wdsr_layer3_1x1_weights_2_15_reg                                   0xB81ABCB8
#define  SRNN_wdsr_layer3_1x1_weights_2_15_inst_addr                             "0x0352"
#define  set_SRNN_wdsr_layer3_1x1_weights_2_15_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_2_15_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_2_15_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_2_15_reg))
#define  SRNN_wdsr_layer3_1x1_weights_2_15_layer3_weight_15_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_2_15_layer3_weight_15_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_2_15_layer3_weight_15(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_2_15_get_layer3_weight_15(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_2_16                                      0x181ABCBC
#define  SRNN_wdsr_layer3_1x1_weights_2_16_reg_addr                              "0xB81ABCBC"
#define  SRNN_wdsr_layer3_1x1_weights_2_16_reg                                   0xB81ABCBC
#define  SRNN_wdsr_layer3_1x1_weights_2_16_inst_addr                             "0x0353"
#define  set_SRNN_wdsr_layer3_1x1_weights_2_16_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_2_16_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_2_16_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_2_16_reg))
#define  SRNN_wdsr_layer3_1x1_weights_2_16_layer3_weight_16_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_2_16_layer3_weight_16_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_2_16_layer3_weight_16(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_2_16_get_layer3_weight_16(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_2_17                                      0x181ABCC0
#define  SRNN_wdsr_layer3_1x1_weights_2_17_reg_addr                              "0xB81ABCC0"
#define  SRNN_wdsr_layer3_1x1_weights_2_17_reg                                   0xB81ABCC0
#define  SRNN_wdsr_layer3_1x1_weights_2_17_inst_addr                             "0x0354"
#define  set_SRNN_wdsr_layer3_1x1_weights_2_17_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_2_17_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_2_17_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_2_17_reg))
#define  SRNN_wdsr_layer3_1x1_weights_2_17_layer3_weight_17_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_2_17_layer3_weight_17_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_2_17_layer3_weight_17(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_2_17_get_layer3_weight_17(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_2_18                                      0x181ABCC4
#define  SRNN_wdsr_layer3_1x1_weights_2_18_reg_addr                              "0xB81ABCC4"
#define  SRNN_wdsr_layer3_1x1_weights_2_18_reg                                   0xB81ABCC4
#define  SRNN_wdsr_layer3_1x1_weights_2_18_inst_addr                             "0x0355"
#define  set_SRNN_wdsr_layer3_1x1_weights_2_18_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_2_18_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_2_18_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_2_18_reg))
#define  SRNN_wdsr_layer3_1x1_weights_2_18_layer3_weight_18_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_2_18_layer3_weight_18_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_2_18_layer3_weight_18(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_2_18_get_layer3_weight_18(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_2_19                                      0x181ABCC8
#define  SRNN_wdsr_layer3_1x1_weights_2_19_reg_addr                              "0xB81ABCC8"
#define  SRNN_wdsr_layer3_1x1_weights_2_19_reg                                   0xB81ABCC8
#define  SRNN_wdsr_layer3_1x1_weights_2_19_inst_addr                             "0x0356"
#define  set_SRNN_wdsr_layer3_1x1_weights_2_19_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_2_19_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_2_19_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_2_19_reg))
#define  SRNN_wdsr_layer3_1x1_weights_2_19_layer3_weight_19_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_2_19_layer3_weight_19_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_2_19_layer3_weight_19(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_2_19_get_layer3_weight_19(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_2_20                                      0x181ABCCC
#define  SRNN_wdsr_layer3_1x1_weights_2_20_reg_addr                              "0xB81ABCCC"
#define  SRNN_wdsr_layer3_1x1_weights_2_20_reg                                   0xB81ABCCC
#define  SRNN_wdsr_layer3_1x1_weights_2_20_inst_addr                             "0x0357"
#define  set_SRNN_wdsr_layer3_1x1_weights_2_20_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_2_20_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_2_20_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_2_20_reg))
#define  SRNN_wdsr_layer3_1x1_weights_2_20_layer3_weight_20_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_2_20_layer3_weight_20_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_2_20_layer3_weight_20(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_2_20_get_layer3_weight_20(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_2_21                                      0x181ABCD0
#define  SRNN_wdsr_layer3_1x1_weights_2_21_reg_addr                              "0xB81ABCD0"
#define  SRNN_wdsr_layer3_1x1_weights_2_21_reg                                   0xB81ABCD0
#define  SRNN_wdsr_layer3_1x1_weights_2_21_inst_addr                             "0x0358"
#define  set_SRNN_wdsr_layer3_1x1_weights_2_21_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_2_21_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_2_21_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_2_21_reg))
#define  SRNN_wdsr_layer3_1x1_weights_2_21_layer3_weight_21_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_2_21_layer3_weight_21_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_2_21_layer3_weight_21(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_2_21_get_layer3_weight_21(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_2_22                                      0x181ABCD4
#define  SRNN_wdsr_layer3_1x1_weights_2_22_reg_addr                              "0xB81ABCD4"
#define  SRNN_wdsr_layer3_1x1_weights_2_22_reg                                   0xB81ABCD4
#define  SRNN_wdsr_layer3_1x1_weights_2_22_inst_addr                             "0x0359"
#define  set_SRNN_wdsr_layer3_1x1_weights_2_22_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_2_22_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_2_22_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_2_22_reg))
#define  SRNN_wdsr_layer3_1x1_weights_2_22_layer3_weight_22_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_2_22_layer3_weight_22_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_2_22_layer3_weight_22(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_2_22_get_layer3_weight_22(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_2_23                                      0x181ABCD8
#define  SRNN_wdsr_layer3_1x1_weights_2_23_reg_addr                              "0xB81ABCD8"
#define  SRNN_wdsr_layer3_1x1_weights_2_23_reg                                   0xB81ABCD8
#define  SRNN_wdsr_layer3_1x1_weights_2_23_inst_addr                             "0x035A"
#define  set_SRNN_wdsr_layer3_1x1_weights_2_23_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_2_23_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_2_23_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_2_23_reg))
#define  SRNN_wdsr_layer3_1x1_weights_2_23_layer3_weight_23_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_2_23_layer3_weight_23_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_2_23_layer3_weight_23(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_2_23_get_layer3_weight_23(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_2_24                                      0x181ABCDC
#define  SRNN_wdsr_layer3_1x1_weights_2_24_reg_addr                              "0xB81ABCDC"
#define  SRNN_wdsr_layer3_1x1_weights_2_24_reg                                   0xB81ABCDC
#define  SRNN_wdsr_layer3_1x1_weights_2_24_inst_addr                             "0x035B"
#define  set_SRNN_wdsr_layer3_1x1_weights_2_24_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_2_24_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_2_24_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_2_24_reg))
#define  SRNN_wdsr_layer3_1x1_weights_2_24_layer3_weight_24_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_2_24_layer3_weight_24_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_2_24_layer3_weight_24(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_2_24_get_layer3_weight_24(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_2_25                                      0x181ABCE0
#define  SRNN_wdsr_layer3_1x1_weights_2_25_reg_addr                              "0xB81ABCE0"
#define  SRNN_wdsr_layer3_1x1_weights_2_25_reg                                   0xB81ABCE0
#define  SRNN_wdsr_layer3_1x1_weights_2_25_inst_addr                             "0x035C"
#define  set_SRNN_wdsr_layer3_1x1_weights_2_25_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_2_25_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_2_25_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_2_25_reg))
#define  SRNN_wdsr_layer3_1x1_weights_2_25_layer3_weight_25_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_2_25_layer3_weight_25_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_2_25_layer3_weight_25(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_2_25_get_layer3_weight_25(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_2_26                                      0x181ABCE4
#define  SRNN_wdsr_layer3_1x1_weights_2_26_reg_addr                              "0xB81ABCE4"
#define  SRNN_wdsr_layer3_1x1_weights_2_26_reg                                   0xB81ABCE4
#define  SRNN_wdsr_layer3_1x1_weights_2_26_inst_addr                             "0x035D"
#define  set_SRNN_wdsr_layer3_1x1_weights_2_26_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_2_26_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_2_26_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_2_26_reg))
#define  SRNN_wdsr_layer3_1x1_weights_2_26_layer3_weight_26_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_2_26_layer3_weight_26_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_2_26_layer3_weight_26(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_2_26_get_layer3_weight_26(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_2_27                                      0x181ABCE8
#define  SRNN_wdsr_layer3_1x1_weights_2_27_reg_addr                              "0xB81ABCE8"
#define  SRNN_wdsr_layer3_1x1_weights_2_27_reg                                   0xB81ABCE8
#define  SRNN_wdsr_layer3_1x1_weights_2_27_inst_addr                             "0x035E"
#define  set_SRNN_wdsr_layer3_1x1_weights_2_27_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_2_27_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_2_27_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_2_27_reg))
#define  SRNN_wdsr_layer3_1x1_weights_2_27_layer3_weight_27_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_2_27_layer3_weight_27_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_2_27_layer3_weight_27(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_2_27_get_layer3_weight_27(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_2_28                                      0x181ABCEC
#define  SRNN_wdsr_layer3_1x1_weights_2_28_reg_addr                              "0xB81ABCEC"
#define  SRNN_wdsr_layer3_1x1_weights_2_28_reg                                   0xB81ABCEC
#define  SRNN_wdsr_layer3_1x1_weights_2_28_inst_addr                             "0x035F"
#define  set_SRNN_wdsr_layer3_1x1_weights_2_28_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_2_28_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_2_28_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_2_28_reg))
#define  SRNN_wdsr_layer3_1x1_weights_2_28_layer3_weight_28_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_2_28_layer3_weight_28_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_2_28_layer3_weight_28(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_2_28_get_layer3_weight_28(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_2_29                                      0x181ABCF0
#define  SRNN_wdsr_layer3_1x1_weights_2_29_reg_addr                              "0xB81ABCF0"
#define  SRNN_wdsr_layer3_1x1_weights_2_29_reg                                   0xB81ABCF0
#define  SRNN_wdsr_layer3_1x1_weights_2_29_inst_addr                             "0x0360"
#define  set_SRNN_wdsr_layer3_1x1_weights_2_29_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_2_29_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_2_29_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_2_29_reg))
#define  SRNN_wdsr_layer3_1x1_weights_2_29_layer3_weight_29_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_2_29_layer3_weight_29_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_2_29_layer3_weight_29(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_2_29_get_layer3_weight_29(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_2_30                                      0x181ABCF4
#define  SRNN_wdsr_layer3_1x1_weights_2_30_reg_addr                              "0xB81ABCF4"
#define  SRNN_wdsr_layer3_1x1_weights_2_30_reg                                   0xB81ABCF4
#define  SRNN_wdsr_layer3_1x1_weights_2_30_inst_addr                             "0x0361"
#define  set_SRNN_wdsr_layer3_1x1_weights_2_30_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_2_30_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_2_30_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_2_30_reg))
#define  SRNN_wdsr_layer3_1x1_weights_2_30_layer3_weight_30_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_2_30_layer3_weight_30_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_2_30_layer3_weight_30(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_2_30_get_layer3_weight_30(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_2_31                                      0x181ABCF8
#define  SRNN_wdsr_layer3_1x1_weights_2_31_reg_addr                              "0xB81ABCF8"
#define  SRNN_wdsr_layer3_1x1_weights_2_31_reg                                   0xB81ABCF8
#define  SRNN_wdsr_layer3_1x1_weights_2_31_inst_addr                             "0x0362"
#define  set_SRNN_wdsr_layer3_1x1_weights_2_31_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_2_31_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_2_31_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_2_31_reg))
#define  SRNN_wdsr_layer3_1x1_weights_2_31_layer3_weight_31_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_2_31_layer3_weight_31_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_2_31_layer3_weight_31(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_2_31_get_layer3_weight_31(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_2_32                                      0x181ABCFC
#define  SRNN_wdsr_layer3_1x1_weights_2_32_reg_addr                              "0xB81ABCFC"
#define  SRNN_wdsr_layer3_1x1_weights_2_32_reg                                   0xB81ABCFC
#define  SRNN_wdsr_layer3_1x1_weights_2_32_inst_addr                             "0x0363"
#define  set_SRNN_wdsr_layer3_1x1_weights_2_32_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_2_32_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_2_32_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_2_32_reg))
#define  SRNN_wdsr_layer3_1x1_weights_2_32_layer3_weight_32_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_2_32_layer3_weight_32_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_2_32_layer3_weight_32(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_2_32_get_layer3_weight_32(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_3_1                                       0x181ABD00
#define  SRNN_wdsr_layer3_1x1_weights_3_1_reg_addr                               "0xB81ABD00"
#define  SRNN_wdsr_layer3_1x1_weights_3_1_reg                                    0xB81ABD00
#define  SRNN_wdsr_layer3_1x1_weights_3_1_inst_addr                              "0x0364"
#define  set_SRNN_wdsr_layer3_1x1_weights_3_1_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_3_1_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_3_1_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_3_1_reg))
#define  SRNN_wdsr_layer3_1x1_weights_3_1_layer3_weight_1_shift                  (0)
#define  SRNN_wdsr_layer3_1x1_weights_3_1_layer3_weight_1_mask                   (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_3_1_layer3_weight_1(data)                  (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_3_1_get_layer3_weight_1(data)              (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_3_2                                       0x181ABD04
#define  SRNN_wdsr_layer3_1x1_weights_3_2_reg_addr                               "0xB81ABD04"
#define  SRNN_wdsr_layer3_1x1_weights_3_2_reg                                    0xB81ABD04
#define  SRNN_wdsr_layer3_1x1_weights_3_2_inst_addr                              "0x0365"
#define  set_SRNN_wdsr_layer3_1x1_weights_3_2_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_3_2_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_3_2_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_3_2_reg))
#define  SRNN_wdsr_layer3_1x1_weights_3_2_layer3_weight_2_shift                  (0)
#define  SRNN_wdsr_layer3_1x1_weights_3_2_layer3_weight_2_mask                   (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_3_2_layer3_weight_2(data)                  (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_3_2_get_layer3_weight_2(data)              (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_3_3                                       0x181ABD08
#define  SRNN_wdsr_layer3_1x1_weights_3_3_reg_addr                               "0xB81ABD08"
#define  SRNN_wdsr_layer3_1x1_weights_3_3_reg                                    0xB81ABD08
#define  SRNN_wdsr_layer3_1x1_weights_3_3_inst_addr                              "0x0366"
#define  set_SRNN_wdsr_layer3_1x1_weights_3_3_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_3_3_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_3_3_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_3_3_reg))
#define  SRNN_wdsr_layer3_1x1_weights_3_3_layer3_weight_3_shift                  (0)
#define  SRNN_wdsr_layer3_1x1_weights_3_3_layer3_weight_3_mask                   (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_3_3_layer3_weight_3(data)                  (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_3_3_get_layer3_weight_3(data)              (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_3_4                                       0x181ABD0C
#define  SRNN_wdsr_layer3_1x1_weights_3_4_reg_addr                               "0xB81ABD0C"
#define  SRNN_wdsr_layer3_1x1_weights_3_4_reg                                    0xB81ABD0C
#define  SRNN_wdsr_layer3_1x1_weights_3_4_inst_addr                              "0x0367"
#define  set_SRNN_wdsr_layer3_1x1_weights_3_4_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_3_4_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_3_4_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_3_4_reg))
#define  SRNN_wdsr_layer3_1x1_weights_3_4_layer3_weight_4_shift                  (0)
#define  SRNN_wdsr_layer3_1x1_weights_3_4_layer3_weight_4_mask                   (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_3_4_layer3_weight_4(data)                  (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_3_4_get_layer3_weight_4(data)              (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_3_5                                       0x181ABD10
#define  SRNN_wdsr_layer3_1x1_weights_3_5_reg_addr                               "0xB81ABD10"
#define  SRNN_wdsr_layer3_1x1_weights_3_5_reg                                    0xB81ABD10
#define  SRNN_wdsr_layer3_1x1_weights_3_5_inst_addr                              "0x0368"
#define  set_SRNN_wdsr_layer3_1x1_weights_3_5_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_3_5_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_3_5_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_3_5_reg))
#define  SRNN_wdsr_layer3_1x1_weights_3_5_layer3_weight_5_shift                  (0)
#define  SRNN_wdsr_layer3_1x1_weights_3_5_layer3_weight_5_mask                   (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_3_5_layer3_weight_5(data)                  (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_3_5_get_layer3_weight_5(data)              (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_3_6                                       0x181ABD14
#define  SRNN_wdsr_layer3_1x1_weights_3_6_reg_addr                               "0xB81ABD14"
#define  SRNN_wdsr_layer3_1x1_weights_3_6_reg                                    0xB81ABD14
#define  SRNN_wdsr_layer3_1x1_weights_3_6_inst_addr                              "0x0369"
#define  set_SRNN_wdsr_layer3_1x1_weights_3_6_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_3_6_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_3_6_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_3_6_reg))
#define  SRNN_wdsr_layer3_1x1_weights_3_6_layer3_weight_6_shift                  (0)
#define  SRNN_wdsr_layer3_1x1_weights_3_6_layer3_weight_6_mask                   (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_3_6_layer3_weight_6(data)                  (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_3_6_get_layer3_weight_6(data)              (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_3_7                                       0x181ABD18
#define  SRNN_wdsr_layer3_1x1_weights_3_7_reg_addr                               "0xB81ABD18"
#define  SRNN_wdsr_layer3_1x1_weights_3_7_reg                                    0xB81ABD18
#define  SRNN_wdsr_layer3_1x1_weights_3_7_inst_addr                              "0x036A"
#define  set_SRNN_wdsr_layer3_1x1_weights_3_7_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_3_7_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_3_7_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_3_7_reg))
#define  SRNN_wdsr_layer3_1x1_weights_3_7_layer3_weight_7_shift                  (0)
#define  SRNN_wdsr_layer3_1x1_weights_3_7_layer3_weight_7_mask                   (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_3_7_layer3_weight_7(data)                  (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_3_7_get_layer3_weight_7(data)              (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_3_8                                       0x181ABD1C
#define  SRNN_wdsr_layer3_1x1_weights_3_8_reg_addr                               "0xB81ABD1C"
#define  SRNN_wdsr_layer3_1x1_weights_3_8_reg                                    0xB81ABD1C
#define  SRNN_wdsr_layer3_1x1_weights_3_8_inst_addr                              "0x036B"
#define  set_SRNN_wdsr_layer3_1x1_weights_3_8_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_3_8_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_3_8_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_3_8_reg))
#define  SRNN_wdsr_layer3_1x1_weights_3_8_layer3_weight_8_shift                  (0)
#define  SRNN_wdsr_layer3_1x1_weights_3_8_layer3_weight_8_mask                   (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_3_8_layer3_weight_8(data)                  (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_3_8_get_layer3_weight_8(data)              (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_3_9                                       0x181ABD20
#define  SRNN_wdsr_layer3_1x1_weights_3_9_reg_addr                               "0xB81ABD20"
#define  SRNN_wdsr_layer3_1x1_weights_3_9_reg                                    0xB81ABD20
#define  SRNN_wdsr_layer3_1x1_weights_3_9_inst_addr                              "0x036C"
#define  set_SRNN_wdsr_layer3_1x1_weights_3_9_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_3_9_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_3_9_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_3_9_reg))
#define  SRNN_wdsr_layer3_1x1_weights_3_9_layer3_weight_9_shift                  (0)
#define  SRNN_wdsr_layer3_1x1_weights_3_9_layer3_weight_9_mask                   (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_3_9_layer3_weight_9(data)                  (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_3_9_get_layer3_weight_9(data)              (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_3_10                                      0x181ABD24
#define  SRNN_wdsr_layer3_1x1_weights_3_10_reg_addr                              "0xB81ABD24"
#define  SRNN_wdsr_layer3_1x1_weights_3_10_reg                                   0xB81ABD24
#define  SRNN_wdsr_layer3_1x1_weights_3_10_inst_addr                             "0x036D"
#define  set_SRNN_wdsr_layer3_1x1_weights_3_10_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_3_10_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_3_10_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_3_10_reg))
#define  SRNN_wdsr_layer3_1x1_weights_3_10_layer3_weight_10_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_3_10_layer3_weight_10_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_3_10_layer3_weight_10(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_3_10_get_layer3_weight_10(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_3_11                                      0x181ABD28
#define  SRNN_wdsr_layer3_1x1_weights_3_11_reg_addr                              "0xB81ABD28"
#define  SRNN_wdsr_layer3_1x1_weights_3_11_reg                                   0xB81ABD28
#define  SRNN_wdsr_layer3_1x1_weights_3_11_inst_addr                             "0x036E"
#define  set_SRNN_wdsr_layer3_1x1_weights_3_11_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_3_11_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_3_11_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_3_11_reg))
#define  SRNN_wdsr_layer3_1x1_weights_3_11_layer3_weight_11_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_3_11_layer3_weight_11_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_3_11_layer3_weight_11(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_3_11_get_layer3_weight_11(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_3_12                                      0x181ABD2C
#define  SRNN_wdsr_layer3_1x1_weights_3_12_reg_addr                              "0xB81ABD2C"
#define  SRNN_wdsr_layer3_1x1_weights_3_12_reg                                   0xB81ABD2C
#define  SRNN_wdsr_layer3_1x1_weights_3_12_inst_addr                             "0x036F"
#define  set_SRNN_wdsr_layer3_1x1_weights_3_12_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_3_12_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_3_12_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_3_12_reg))
#define  SRNN_wdsr_layer3_1x1_weights_3_12_layer3_weight_12_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_3_12_layer3_weight_12_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_3_12_layer3_weight_12(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_3_12_get_layer3_weight_12(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_3_13                                      0x181ABD30
#define  SRNN_wdsr_layer3_1x1_weights_3_13_reg_addr                              "0xB81ABD30"
#define  SRNN_wdsr_layer3_1x1_weights_3_13_reg                                   0xB81ABD30
#define  SRNN_wdsr_layer3_1x1_weights_3_13_inst_addr                             "0x0370"
#define  set_SRNN_wdsr_layer3_1x1_weights_3_13_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_3_13_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_3_13_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_3_13_reg))
#define  SRNN_wdsr_layer3_1x1_weights_3_13_layer3_weight_13_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_3_13_layer3_weight_13_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_3_13_layer3_weight_13(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_3_13_get_layer3_weight_13(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_3_14                                      0x181ABD34
#define  SRNN_wdsr_layer3_1x1_weights_3_14_reg_addr                              "0xB81ABD34"
#define  SRNN_wdsr_layer3_1x1_weights_3_14_reg                                   0xB81ABD34
#define  SRNN_wdsr_layer3_1x1_weights_3_14_inst_addr                             "0x0371"
#define  set_SRNN_wdsr_layer3_1x1_weights_3_14_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_3_14_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_3_14_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_3_14_reg))
#define  SRNN_wdsr_layer3_1x1_weights_3_14_layer3_weight_14_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_3_14_layer3_weight_14_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_3_14_layer3_weight_14(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_3_14_get_layer3_weight_14(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_3_15                                      0x181ABD38
#define  SRNN_wdsr_layer3_1x1_weights_3_15_reg_addr                              "0xB81ABD38"
#define  SRNN_wdsr_layer3_1x1_weights_3_15_reg                                   0xB81ABD38
#define  SRNN_wdsr_layer3_1x1_weights_3_15_inst_addr                             "0x0372"
#define  set_SRNN_wdsr_layer3_1x1_weights_3_15_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_3_15_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_3_15_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_3_15_reg))
#define  SRNN_wdsr_layer3_1x1_weights_3_15_layer3_weight_15_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_3_15_layer3_weight_15_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_3_15_layer3_weight_15(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_3_15_get_layer3_weight_15(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_3_16                                      0x181ABD3C
#define  SRNN_wdsr_layer3_1x1_weights_3_16_reg_addr                              "0xB81ABD3C"
#define  SRNN_wdsr_layer3_1x1_weights_3_16_reg                                   0xB81ABD3C
#define  SRNN_wdsr_layer3_1x1_weights_3_16_inst_addr                             "0x0373"
#define  set_SRNN_wdsr_layer3_1x1_weights_3_16_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_3_16_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_3_16_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_3_16_reg))
#define  SRNN_wdsr_layer3_1x1_weights_3_16_layer3_weight_16_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_3_16_layer3_weight_16_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_3_16_layer3_weight_16(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_3_16_get_layer3_weight_16(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_3_17                                      0x181ABD40
#define  SRNN_wdsr_layer3_1x1_weights_3_17_reg_addr                              "0xB81ABD40"
#define  SRNN_wdsr_layer3_1x1_weights_3_17_reg                                   0xB81ABD40
#define  SRNN_wdsr_layer3_1x1_weights_3_17_inst_addr                             "0x0374"
#define  set_SRNN_wdsr_layer3_1x1_weights_3_17_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_3_17_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_3_17_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_3_17_reg))
#define  SRNN_wdsr_layer3_1x1_weights_3_17_layer3_weight_17_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_3_17_layer3_weight_17_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_3_17_layer3_weight_17(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_3_17_get_layer3_weight_17(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_3_18                                      0x181ABD44
#define  SRNN_wdsr_layer3_1x1_weights_3_18_reg_addr                              "0xB81ABD44"
#define  SRNN_wdsr_layer3_1x1_weights_3_18_reg                                   0xB81ABD44
#define  SRNN_wdsr_layer3_1x1_weights_3_18_inst_addr                             "0x0375"
#define  set_SRNN_wdsr_layer3_1x1_weights_3_18_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_3_18_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_3_18_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_3_18_reg))
#define  SRNN_wdsr_layer3_1x1_weights_3_18_layer3_weight_18_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_3_18_layer3_weight_18_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_3_18_layer3_weight_18(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_3_18_get_layer3_weight_18(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_3_19                                      0x181ABD48
#define  SRNN_wdsr_layer3_1x1_weights_3_19_reg_addr                              "0xB81ABD48"
#define  SRNN_wdsr_layer3_1x1_weights_3_19_reg                                   0xB81ABD48
#define  SRNN_wdsr_layer3_1x1_weights_3_19_inst_addr                             "0x0376"
#define  set_SRNN_wdsr_layer3_1x1_weights_3_19_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_3_19_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_3_19_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_3_19_reg))
#define  SRNN_wdsr_layer3_1x1_weights_3_19_layer3_weight_19_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_3_19_layer3_weight_19_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_3_19_layer3_weight_19(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_3_19_get_layer3_weight_19(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_3_20                                      0x181ABD4C
#define  SRNN_wdsr_layer3_1x1_weights_3_20_reg_addr                              "0xB81ABD4C"
#define  SRNN_wdsr_layer3_1x1_weights_3_20_reg                                   0xB81ABD4C
#define  SRNN_wdsr_layer3_1x1_weights_3_20_inst_addr                             "0x0377"
#define  set_SRNN_wdsr_layer3_1x1_weights_3_20_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_3_20_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_3_20_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_3_20_reg))
#define  SRNN_wdsr_layer3_1x1_weights_3_20_layer3_weight_20_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_3_20_layer3_weight_20_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_3_20_layer3_weight_20(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_3_20_get_layer3_weight_20(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_3_21                                      0x181ABD50
#define  SRNN_wdsr_layer3_1x1_weights_3_21_reg_addr                              "0xB81ABD50"
#define  SRNN_wdsr_layer3_1x1_weights_3_21_reg                                   0xB81ABD50
#define  SRNN_wdsr_layer3_1x1_weights_3_21_inst_addr                             "0x0378"
#define  set_SRNN_wdsr_layer3_1x1_weights_3_21_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_3_21_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_3_21_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_3_21_reg))
#define  SRNN_wdsr_layer3_1x1_weights_3_21_layer3_weight_21_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_3_21_layer3_weight_21_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_3_21_layer3_weight_21(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_3_21_get_layer3_weight_21(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_3_22                                      0x181ABD54
#define  SRNN_wdsr_layer3_1x1_weights_3_22_reg_addr                              "0xB81ABD54"
#define  SRNN_wdsr_layer3_1x1_weights_3_22_reg                                   0xB81ABD54
#define  SRNN_wdsr_layer3_1x1_weights_3_22_inst_addr                             "0x0379"
#define  set_SRNN_wdsr_layer3_1x1_weights_3_22_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_3_22_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_3_22_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_3_22_reg))
#define  SRNN_wdsr_layer3_1x1_weights_3_22_layer3_weight_22_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_3_22_layer3_weight_22_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_3_22_layer3_weight_22(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_3_22_get_layer3_weight_22(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_3_23                                      0x181ABD58
#define  SRNN_wdsr_layer3_1x1_weights_3_23_reg_addr                              "0xB81ABD58"
#define  SRNN_wdsr_layer3_1x1_weights_3_23_reg                                   0xB81ABD58
#define  SRNN_wdsr_layer3_1x1_weights_3_23_inst_addr                             "0x037A"
#define  set_SRNN_wdsr_layer3_1x1_weights_3_23_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_3_23_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_3_23_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_3_23_reg))
#define  SRNN_wdsr_layer3_1x1_weights_3_23_layer3_weight_23_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_3_23_layer3_weight_23_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_3_23_layer3_weight_23(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_3_23_get_layer3_weight_23(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_3_24                                      0x181ABD5C
#define  SRNN_wdsr_layer3_1x1_weights_3_24_reg_addr                              "0xB81ABD5C"
#define  SRNN_wdsr_layer3_1x1_weights_3_24_reg                                   0xB81ABD5C
#define  SRNN_wdsr_layer3_1x1_weights_3_24_inst_addr                             "0x037B"
#define  set_SRNN_wdsr_layer3_1x1_weights_3_24_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_3_24_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_3_24_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_3_24_reg))
#define  SRNN_wdsr_layer3_1x1_weights_3_24_layer3_weight_24_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_3_24_layer3_weight_24_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_3_24_layer3_weight_24(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_3_24_get_layer3_weight_24(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_3_25                                      0x181ABD60
#define  SRNN_wdsr_layer3_1x1_weights_3_25_reg_addr                              "0xB81ABD60"
#define  SRNN_wdsr_layer3_1x1_weights_3_25_reg                                   0xB81ABD60
#define  SRNN_wdsr_layer3_1x1_weights_3_25_inst_addr                             "0x037C"
#define  set_SRNN_wdsr_layer3_1x1_weights_3_25_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_3_25_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_3_25_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_3_25_reg))
#define  SRNN_wdsr_layer3_1x1_weights_3_25_layer3_weight_25_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_3_25_layer3_weight_25_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_3_25_layer3_weight_25(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_3_25_get_layer3_weight_25(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_3_26                                      0x181ABD64
#define  SRNN_wdsr_layer3_1x1_weights_3_26_reg_addr                              "0xB81ABD64"
#define  SRNN_wdsr_layer3_1x1_weights_3_26_reg                                   0xB81ABD64
#define  SRNN_wdsr_layer3_1x1_weights_3_26_inst_addr                             "0x037D"
#define  set_SRNN_wdsr_layer3_1x1_weights_3_26_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_3_26_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_3_26_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_3_26_reg))
#define  SRNN_wdsr_layer3_1x1_weights_3_26_layer3_weight_26_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_3_26_layer3_weight_26_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_3_26_layer3_weight_26(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_3_26_get_layer3_weight_26(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_3_27                                      0x181ABD68
#define  SRNN_wdsr_layer3_1x1_weights_3_27_reg_addr                              "0xB81ABD68"
#define  SRNN_wdsr_layer3_1x1_weights_3_27_reg                                   0xB81ABD68
#define  SRNN_wdsr_layer3_1x1_weights_3_27_inst_addr                             "0x037E"
#define  set_SRNN_wdsr_layer3_1x1_weights_3_27_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_3_27_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_3_27_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_3_27_reg))
#define  SRNN_wdsr_layer3_1x1_weights_3_27_layer3_weight_27_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_3_27_layer3_weight_27_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_3_27_layer3_weight_27(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_3_27_get_layer3_weight_27(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_3_28                                      0x181ABD6C
#define  SRNN_wdsr_layer3_1x1_weights_3_28_reg_addr                              "0xB81ABD6C"
#define  SRNN_wdsr_layer3_1x1_weights_3_28_reg                                   0xB81ABD6C
#define  SRNN_wdsr_layer3_1x1_weights_3_28_inst_addr                             "0x037F"
#define  set_SRNN_wdsr_layer3_1x1_weights_3_28_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_3_28_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_3_28_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_3_28_reg))
#define  SRNN_wdsr_layer3_1x1_weights_3_28_layer3_weight_28_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_3_28_layer3_weight_28_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_3_28_layer3_weight_28(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_3_28_get_layer3_weight_28(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_3_29                                      0x181ABD70
#define  SRNN_wdsr_layer3_1x1_weights_3_29_reg_addr                              "0xB81ABD70"
#define  SRNN_wdsr_layer3_1x1_weights_3_29_reg                                   0xB81ABD70
#define  SRNN_wdsr_layer3_1x1_weights_3_29_inst_addr                             "0x0380"
#define  set_SRNN_wdsr_layer3_1x1_weights_3_29_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_3_29_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_3_29_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_3_29_reg))
#define  SRNN_wdsr_layer3_1x1_weights_3_29_layer3_weight_29_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_3_29_layer3_weight_29_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_3_29_layer3_weight_29(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_3_29_get_layer3_weight_29(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_3_30                                      0x181ABD74
#define  SRNN_wdsr_layer3_1x1_weights_3_30_reg_addr                              "0xB81ABD74"
#define  SRNN_wdsr_layer3_1x1_weights_3_30_reg                                   0xB81ABD74
#define  SRNN_wdsr_layer3_1x1_weights_3_30_inst_addr                             "0x0381"
#define  set_SRNN_wdsr_layer3_1x1_weights_3_30_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_3_30_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_3_30_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_3_30_reg))
#define  SRNN_wdsr_layer3_1x1_weights_3_30_layer3_weight_30_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_3_30_layer3_weight_30_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_3_30_layer3_weight_30(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_3_30_get_layer3_weight_30(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_3_31                                      0x181ABD78
#define  SRNN_wdsr_layer3_1x1_weights_3_31_reg_addr                              "0xB81ABD78"
#define  SRNN_wdsr_layer3_1x1_weights_3_31_reg                                   0xB81ABD78
#define  SRNN_wdsr_layer3_1x1_weights_3_31_inst_addr                             "0x0382"
#define  set_SRNN_wdsr_layer3_1x1_weights_3_31_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_3_31_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_3_31_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_3_31_reg))
#define  SRNN_wdsr_layer3_1x1_weights_3_31_layer3_weight_31_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_3_31_layer3_weight_31_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_3_31_layer3_weight_31(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_3_31_get_layer3_weight_31(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_3_32                                      0x181ABD7C
#define  SRNN_wdsr_layer3_1x1_weights_3_32_reg_addr                              "0xB81ABD7C"
#define  SRNN_wdsr_layer3_1x1_weights_3_32_reg                                   0xB81ABD7C
#define  SRNN_wdsr_layer3_1x1_weights_3_32_inst_addr                             "0x0383"
#define  set_SRNN_wdsr_layer3_1x1_weights_3_32_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_3_32_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_3_32_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_3_32_reg))
#define  SRNN_wdsr_layer3_1x1_weights_3_32_layer3_weight_32_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_3_32_layer3_weight_32_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_3_32_layer3_weight_32(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_3_32_get_layer3_weight_32(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_4_1                                       0x181ABD80
#define  SRNN_wdsr_layer3_1x1_weights_4_1_reg_addr                               "0xB81ABD80"
#define  SRNN_wdsr_layer3_1x1_weights_4_1_reg                                    0xB81ABD80
#define  SRNN_wdsr_layer3_1x1_weights_4_1_inst_addr                              "0x0384"
#define  set_SRNN_wdsr_layer3_1x1_weights_4_1_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_4_1_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_4_1_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_4_1_reg))
#define  SRNN_wdsr_layer3_1x1_weights_4_1_layer3_weight_1_shift                  (0)
#define  SRNN_wdsr_layer3_1x1_weights_4_1_layer3_weight_1_mask                   (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_4_1_layer3_weight_1(data)                  (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_4_1_get_layer3_weight_1(data)              (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_4_2                                       0x181ABD84
#define  SRNN_wdsr_layer3_1x1_weights_4_2_reg_addr                               "0xB81ABD84"
#define  SRNN_wdsr_layer3_1x1_weights_4_2_reg                                    0xB81ABD84
#define  SRNN_wdsr_layer3_1x1_weights_4_2_inst_addr                              "0x0385"
#define  set_SRNN_wdsr_layer3_1x1_weights_4_2_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_4_2_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_4_2_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_4_2_reg))
#define  SRNN_wdsr_layer3_1x1_weights_4_2_layer3_weight_2_shift                  (0)
#define  SRNN_wdsr_layer3_1x1_weights_4_2_layer3_weight_2_mask                   (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_4_2_layer3_weight_2(data)                  (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_4_2_get_layer3_weight_2(data)              (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_4_3                                       0x181ABD88
#define  SRNN_wdsr_layer3_1x1_weights_4_3_reg_addr                               "0xB81ABD88"
#define  SRNN_wdsr_layer3_1x1_weights_4_3_reg                                    0xB81ABD88
#define  SRNN_wdsr_layer3_1x1_weights_4_3_inst_addr                              "0x0386"
#define  set_SRNN_wdsr_layer3_1x1_weights_4_3_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_4_3_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_4_3_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_4_3_reg))
#define  SRNN_wdsr_layer3_1x1_weights_4_3_layer3_weight_3_shift                  (0)
#define  SRNN_wdsr_layer3_1x1_weights_4_3_layer3_weight_3_mask                   (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_4_3_layer3_weight_3(data)                  (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_4_3_get_layer3_weight_3(data)              (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_4_4                                       0x181ABD8C
#define  SRNN_wdsr_layer3_1x1_weights_4_4_reg_addr                               "0xB81ABD8C"
#define  SRNN_wdsr_layer3_1x1_weights_4_4_reg                                    0xB81ABD8C
#define  SRNN_wdsr_layer3_1x1_weights_4_4_inst_addr                              "0x0387"
#define  set_SRNN_wdsr_layer3_1x1_weights_4_4_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_4_4_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_4_4_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_4_4_reg))
#define  SRNN_wdsr_layer3_1x1_weights_4_4_layer3_weight_4_shift                  (0)
#define  SRNN_wdsr_layer3_1x1_weights_4_4_layer3_weight_4_mask                   (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_4_4_layer3_weight_4(data)                  (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_4_4_get_layer3_weight_4(data)              (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_4_5                                       0x181ABD90
#define  SRNN_wdsr_layer3_1x1_weights_4_5_reg_addr                               "0xB81ABD90"
#define  SRNN_wdsr_layer3_1x1_weights_4_5_reg                                    0xB81ABD90
#define  SRNN_wdsr_layer3_1x1_weights_4_5_inst_addr                              "0x0388"
#define  set_SRNN_wdsr_layer3_1x1_weights_4_5_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_4_5_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_4_5_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_4_5_reg))
#define  SRNN_wdsr_layer3_1x1_weights_4_5_layer3_weight_5_shift                  (0)
#define  SRNN_wdsr_layer3_1x1_weights_4_5_layer3_weight_5_mask                   (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_4_5_layer3_weight_5(data)                  (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_4_5_get_layer3_weight_5(data)              (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_4_6                                       0x181ABD94
#define  SRNN_wdsr_layer3_1x1_weights_4_6_reg_addr                               "0xB81ABD94"
#define  SRNN_wdsr_layer3_1x1_weights_4_6_reg                                    0xB81ABD94
#define  SRNN_wdsr_layer3_1x1_weights_4_6_inst_addr                              "0x0389"
#define  set_SRNN_wdsr_layer3_1x1_weights_4_6_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_4_6_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_4_6_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_4_6_reg))
#define  SRNN_wdsr_layer3_1x1_weights_4_6_layer3_weight_6_shift                  (0)
#define  SRNN_wdsr_layer3_1x1_weights_4_6_layer3_weight_6_mask                   (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_4_6_layer3_weight_6(data)                  (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_4_6_get_layer3_weight_6(data)              (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_4_7                                       0x181ABD98
#define  SRNN_wdsr_layer3_1x1_weights_4_7_reg_addr                               "0xB81ABD98"
#define  SRNN_wdsr_layer3_1x1_weights_4_7_reg                                    0xB81ABD98
#define  SRNN_wdsr_layer3_1x1_weights_4_7_inst_addr                              "0x038A"
#define  set_SRNN_wdsr_layer3_1x1_weights_4_7_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_4_7_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_4_7_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_4_7_reg))
#define  SRNN_wdsr_layer3_1x1_weights_4_7_layer3_weight_7_shift                  (0)
#define  SRNN_wdsr_layer3_1x1_weights_4_7_layer3_weight_7_mask                   (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_4_7_layer3_weight_7(data)                  (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_4_7_get_layer3_weight_7(data)              (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_4_8                                       0x181ABD9C
#define  SRNN_wdsr_layer3_1x1_weights_4_8_reg_addr                               "0xB81ABD9C"
#define  SRNN_wdsr_layer3_1x1_weights_4_8_reg                                    0xB81ABD9C
#define  SRNN_wdsr_layer3_1x1_weights_4_8_inst_addr                              "0x038B"
#define  set_SRNN_wdsr_layer3_1x1_weights_4_8_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_4_8_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_4_8_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_4_8_reg))
#define  SRNN_wdsr_layer3_1x1_weights_4_8_layer3_weight_8_shift                  (0)
#define  SRNN_wdsr_layer3_1x1_weights_4_8_layer3_weight_8_mask                   (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_4_8_layer3_weight_8(data)                  (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_4_8_get_layer3_weight_8(data)              (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_4_9                                       0x181ABDA0
#define  SRNN_wdsr_layer3_1x1_weights_4_9_reg_addr                               "0xB81ABDA0"
#define  SRNN_wdsr_layer3_1x1_weights_4_9_reg                                    0xB81ABDA0
#define  SRNN_wdsr_layer3_1x1_weights_4_9_inst_addr                              "0x038C"
#define  set_SRNN_wdsr_layer3_1x1_weights_4_9_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_4_9_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_4_9_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_4_9_reg))
#define  SRNN_wdsr_layer3_1x1_weights_4_9_layer3_weight_9_shift                  (0)
#define  SRNN_wdsr_layer3_1x1_weights_4_9_layer3_weight_9_mask                   (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_4_9_layer3_weight_9(data)                  (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_4_9_get_layer3_weight_9(data)              (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_4_10                                      0x181ABDA4
#define  SRNN_wdsr_layer3_1x1_weights_4_10_reg_addr                              "0xB81ABDA4"
#define  SRNN_wdsr_layer3_1x1_weights_4_10_reg                                   0xB81ABDA4
#define  SRNN_wdsr_layer3_1x1_weights_4_10_inst_addr                             "0x038D"
#define  set_SRNN_wdsr_layer3_1x1_weights_4_10_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_4_10_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_4_10_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_4_10_reg))
#define  SRNN_wdsr_layer3_1x1_weights_4_10_layer3_weight_10_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_4_10_layer3_weight_10_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_4_10_layer3_weight_10(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_4_10_get_layer3_weight_10(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_4_11                                      0x181ABDA8
#define  SRNN_wdsr_layer3_1x1_weights_4_11_reg_addr                              "0xB81ABDA8"
#define  SRNN_wdsr_layer3_1x1_weights_4_11_reg                                   0xB81ABDA8
#define  SRNN_wdsr_layer3_1x1_weights_4_11_inst_addr                             "0x038E"
#define  set_SRNN_wdsr_layer3_1x1_weights_4_11_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_4_11_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_4_11_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_4_11_reg))
#define  SRNN_wdsr_layer3_1x1_weights_4_11_layer3_weight_11_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_4_11_layer3_weight_11_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_4_11_layer3_weight_11(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_4_11_get_layer3_weight_11(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_4_12                                      0x181ABDAC
#define  SRNN_wdsr_layer3_1x1_weights_4_12_reg_addr                              "0xB81ABDAC"
#define  SRNN_wdsr_layer3_1x1_weights_4_12_reg                                   0xB81ABDAC
#define  SRNN_wdsr_layer3_1x1_weights_4_12_inst_addr                             "0x038F"
#define  set_SRNN_wdsr_layer3_1x1_weights_4_12_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_4_12_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_4_12_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_4_12_reg))
#define  SRNN_wdsr_layer3_1x1_weights_4_12_layer3_weight_12_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_4_12_layer3_weight_12_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_4_12_layer3_weight_12(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_4_12_get_layer3_weight_12(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_4_13                                      0x181ABDB0
#define  SRNN_wdsr_layer3_1x1_weights_4_13_reg_addr                              "0xB81ABDB0"
#define  SRNN_wdsr_layer3_1x1_weights_4_13_reg                                   0xB81ABDB0
#define  SRNN_wdsr_layer3_1x1_weights_4_13_inst_addr                             "0x0390"
#define  set_SRNN_wdsr_layer3_1x1_weights_4_13_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_4_13_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_4_13_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_4_13_reg))
#define  SRNN_wdsr_layer3_1x1_weights_4_13_layer3_weight_13_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_4_13_layer3_weight_13_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_4_13_layer3_weight_13(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_4_13_get_layer3_weight_13(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_4_14                                      0x181ABDB4
#define  SRNN_wdsr_layer3_1x1_weights_4_14_reg_addr                              "0xB81ABDB4"
#define  SRNN_wdsr_layer3_1x1_weights_4_14_reg                                   0xB81ABDB4
#define  SRNN_wdsr_layer3_1x1_weights_4_14_inst_addr                             "0x0391"
#define  set_SRNN_wdsr_layer3_1x1_weights_4_14_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_4_14_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_4_14_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_4_14_reg))
#define  SRNN_wdsr_layer3_1x1_weights_4_14_layer3_weight_14_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_4_14_layer3_weight_14_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_4_14_layer3_weight_14(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_4_14_get_layer3_weight_14(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_4_15                                      0x181ABDB8
#define  SRNN_wdsr_layer3_1x1_weights_4_15_reg_addr                              "0xB81ABDB8"
#define  SRNN_wdsr_layer3_1x1_weights_4_15_reg                                   0xB81ABDB8
#define  SRNN_wdsr_layer3_1x1_weights_4_15_inst_addr                             "0x0392"
#define  set_SRNN_wdsr_layer3_1x1_weights_4_15_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_4_15_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_4_15_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_4_15_reg))
#define  SRNN_wdsr_layer3_1x1_weights_4_15_layer3_weight_15_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_4_15_layer3_weight_15_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_4_15_layer3_weight_15(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_4_15_get_layer3_weight_15(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_4_16                                      0x181ABDBC
#define  SRNN_wdsr_layer3_1x1_weights_4_16_reg_addr                              "0xB81ABDBC"
#define  SRNN_wdsr_layer3_1x1_weights_4_16_reg                                   0xB81ABDBC
#define  SRNN_wdsr_layer3_1x1_weights_4_16_inst_addr                             "0x0393"
#define  set_SRNN_wdsr_layer3_1x1_weights_4_16_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_4_16_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_4_16_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_4_16_reg))
#define  SRNN_wdsr_layer3_1x1_weights_4_16_layer3_weight_16_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_4_16_layer3_weight_16_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_4_16_layer3_weight_16(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_4_16_get_layer3_weight_16(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_4_17                                      0x181ABDC0
#define  SRNN_wdsr_layer3_1x1_weights_4_17_reg_addr                              "0xB81ABDC0"
#define  SRNN_wdsr_layer3_1x1_weights_4_17_reg                                   0xB81ABDC0
#define  SRNN_wdsr_layer3_1x1_weights_4_17_inst_addr                             "0x0394"
#define  set_SRNN_wdsr_layer3_1x1_weights_4_17_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_4_17_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_4_17_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_4_17_reg))
#define  SRNN_wdsr_layer3_1x1_weights_4_17_layer3_weight_17_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_4_17_layer3_weight_17_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_4_17_layer3_weight_17(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_4_17_get_layer3_weight_17(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_4_18                                      0x181ABDC4
#define  SRNN_wdsr_layer3_1x1_weights_4_18_reg_addr                              "0xB81ABDC4"
#define  SRNN_wdsr_layer3_1x1_weights_4_18_reg                                   0xB81ABDC4
#define  SRNN_wdsr_layer3_1x1_weights_4_18_inst_addr                             "0x0395"
#define  set_SRNN_wdsr_layer3_1x1_weights_4_18_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_4_18_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_4_18_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_4_18_reg))
#define  SRNN_wdsr_layer3_1x1_weights_4_18_layer3_weight_18_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_4_18_layer3_weight_18_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_4_18_layer3_weight_18(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_4_18_get_layer3_weight_18(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_4_19                                      0x181ABDC8
#define  SRNN_wdsr_layer3_1x1_weights_4_19_reg_addr                              "0xB81ABDC8"
#define  SRNN_wdsr_layer3_1x1_weights_4_19_reg                                   0xB81ABDC8
#define  SRNN_wdsr_layer3_1x1_weights_4_19_inst_addr                             "0x0396"
#define  set_SRNN_wdsr_layer3_1x1_weights_4_19_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_4_19_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_4_19_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_4_19_reg))
#define  SRNN_wdsr_layer3_1x1_weights_4_19_layer3_weight_19_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_4_19_layer3_weight_19_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_4_19_layer3_weight_19(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_4_19_get_layer3_weight_19(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_4_20                                      0x181ABDCC
#define  SRNN_wdsr_layer3_1x1_weights_4_20_reg_addr                              "0xB81ABDCC"
#define  SRNN_wdsr_layer3_1x1_weights_4_20_reg                                   0xB81ABDCC
#define  SRNN_wdsr_layer3_1x1_weights_4_20_inst_addr                             "0x0397"
#define  set_SRNN_wdsr_layer3_1x1_weights_4_20_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_4_20_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_4_20_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_4_20_reg))
#define  SRNN_wdsr_layer3_1x1_weights_4_20_layer3_weight_20_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_4_20_layer3_weight_20_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_4_20_layer3_weight_20(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_4_20_get_layer3_weight_20(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_4_21                                      0x181ABDD0
#define  SRNN_wdsr_layer3_1x1_weights_4_21_reg_addr                              "0xB81ABDD0"
#define  SRNN_wdsr_layer3_1x1_weights_4_21_reg                                   0xB81ABDD0
#define  SRNN_wdsr_layer3_1x1_weights_4_21_inst_addr                             "0x0398"
#define  set_SRNN_wdsr_layer3_1x1_weights_4_21_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_4_21_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_4_21_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_4_21_reg))
#define  SRNN_wdsr_layer3_1x1_weights_4_21_layer3_weight_21_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_4_21_layer3_weight_21_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_4_21_layer3_weight_21(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_4_21_get_layer3_weight_21(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_4_22                                      0x181ABDD4
#define  SRNN_wdsr_layer3_1x1_weights_4_22_reg_addr                              "0xB81ABDD4"
#define  SRNN_wdsr_layer3_1x1_weights_4_22_reg                                   0xB81ABDD4
#define  SRNN_wdsr_layer3_1x1_weights_4_22_inst_addr                             "0x0399"
#define  set_SRNN_wdsr_layer3_1x1_weights_4_22_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_4_22_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_4_22_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_4_22_reg))
#define  SRNN_wdsr_layer3_1x1_weights_4_22_layer3_weight_22_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_4_22_layer3_weight_22_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_4_22_layer3_weight_22(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_4_22_get_layer3_weight_22(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_4_23                                      0x181ABDD8
#define  SRNN_wdsr_layer3_1x1_weights_4_23_reg_addr                              "0xB81ABDD8"
#define  SRNN_wdsr_layer3_1x1_weights_4_23_reg                                   0xB81ABDD8
#define  SRNN_wdsr_layer3_1x1_weights_4_23_inst_addr                             "0x039A"
#define  set_SRNN_wdsr_layer3_1x1_weights_4_23_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_4_23_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_4_23_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_4_23_reg))
#define  SRNN_wdsr_layer3_1x1_weights_4_23_layer3_weight_23_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_4_23_layer3_weight_23_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_4_23_layer3_weight_23(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_4_23_get_layer3_weight_23(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_4_24                                      0x181ABDDC
#define  SRNN_wdsr_layer3_1x1_weights_4_24_reg_addr                              "0xB81ABDDC"
#define  SRNN_wdsr_layer3_1x1_weights_4_24_reg                                   0xB81ABDDC
#define  SRNN_wdsr_layer3_1x1_weights_4_24_inst_addr                             "0x039B"
#define  set_SRNN_wdsr_layer3_1x1_weights_4_24_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_4_24_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_4_24_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_4_24_reg))
#define  SRNN_wdsr_layer3_1x1_weights_4_24_layer3_weight_24_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_4_24_layer3_weight_24_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_4_24_layer3_weight_24(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_4_24_get_layer3_weight_24(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_4_25                                      0x181ABDE0
#define  SRNN_wdsr_layer3_1x1_weights_4_25_reg_addr                              "0xB81ABDE0"
#define  SRNN_wdsr_layer3_1x1_weights_4_25_reg                                   0xB81ABDE0
#define  SRNN_wdsr_layer3_1x1_weights_4_25_inst_addr                             "0x039C"
#define  set_SRNN_wdsr_layer3_1x1_weights_4_25_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_4_25_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_4_25_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_4_25_reg))
#define  SRNN_wdsr_layer3_1x1_weights_4_25_layer3_weight_25_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_4_25_layer3_weight_25_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_4_25_layer3_weight_25(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_4_25_get_layer3_weight_25(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_4_26                                      0x181ABDE4
#define  SRNN_wdsr_layer3_1x1_weights_4_26_reg_addr                              "0xB81ABDE4"
#define  SRNN_wdsr_layer3_1x1_weights_4_26_reg                                   0xB81ABDE4
#define  SRNN_wdsr_layer3_1x1_weights_4_26_inst_addr                             "0x039D"
#define  set_SRNN_wdsr_layer3_1x1_weights_4_26_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_4_26_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_4_26_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_4_26_reg))
#define  SRNN_wdsr_layer3_1x1_weights_4_26_layer3_weight_26_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_4_26_layer3_weight_26_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_4_26_layer3_weight_26(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_4_26_get_layer3_weight_26(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_4_27                                      0x181ABDE8
#define  SRNN_wdsr_layer3_1x1_weights_4_27_reg_addr                              "0xB81ABDE8"
#define  SRNN_wdsr_layer3_1x1_weights_4_27_reg                                   0xB81ABDE8
#define  SRNN_wdsr_layer3_1x1_weights_4_27_inst_addr                             "0x039E"
#define  set_SRNN_wdsr_layer3_1x1_weights_4_27_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_4_27_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_4_27_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_4_27_reg))
#define  SRNN_wdsr_layer3_1x1_weights_4_27_layer3_weight_27_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_4_27_layer3_weight_27_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_4_27_layer3_weight_27(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_4_27_get_layer3_weight_27(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_4_28                                      0x181ABDEC
#define  SRNN_wdsr_layer3_1x1_weights_4_28_reg_addr                              "0xB81ABDEC"
#define  SRNN_wdsr_layer3_1x1_weights_4_28_reg                                   0xB81ABDEC
#define  SRNN_wdsr_layer3_1x1_weights_4_28_inst_addr                             "0x039F"
#define  set_SRNN_wdsr_layer3_1x1_weights_4_28_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_4_28_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_4_28_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_4_28_reg))
#define  SRNN_wdsr_layer3_1x1_weights_4_28_layer3_weight_28_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_4_28_layer3_weight_28_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_4_28_layer3_weight_28(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_4_28_get_layer3_weight_28(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_4_29                                      0x181ABDF0
#define  SRNN_wdsr_layer3_1x1_weights_4_29_reg_addr                              "0xB81ABDF0"
#define  SRNN_wdsr_layer3_1x1_weights_4_29_reg                                   0xB81ABDF0
#define  SRNN_wdsr_layer3_1x1_weights_4_29_inst_addr                             "0x03A0"
#define  set_SRNN_wdsr_layer3_1x1_weights_4_29_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_4_29_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_4_29_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_4_29_reg))
#define  SRNN_wdsr_layer3_1x1_weights_4_29_layer3_weight_29_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_4_29_layer3_weight_29_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_4_29_layer3_weight_29(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_4_29_get_layer3_weight_29(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_4_30                                      0x181ABDF4
#define  SRNN_wdsr_layer3_1x1_weights_4_30_reg_addr                              "0xB81ABDF4"
#define  SRNN_wdsr_layer3_1x1_weights_4_30_reg                                   0xB81ABDF4
#define  SRNN_wdsr_layer3_1x1_weights_4_30_inst_addr                             "0x03A1"
#define  set_SRNN_wdsr_layer3_1x1_weights_4_30_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_4_30_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_4_30_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_4_30_reg))
#define  SRNN_wdsr_layer3_1x1_weights_4_30_layer3_weight_30_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_4_30_layer3_weight_30_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_4_30_layer3_weight_30(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_4_30_get_layer3_weight_30(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_4_31                                      0x181ABDF8
#define  SRNN_wdsr_layer3_1x1_weights_4_31_reg_addr                              "0xB81ABDF8"
#define  SRNN_wdsr_layer3_1x1_weights_4_31_reg                                   0xB81ABDF8
#define  SRNN_wdsr_layer3_1x1_weights_4_31_inst_addr                             "0x03A2"
#define  set_SRNN_wdsr_layer3_1x1_weights_4_31_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_4_31_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_4_31_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_4_31_reg))
#define  SRNN_wdsr_layer3_1x1_weights_4_31_layer3_weight_31_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_4_31_layer3_weight_31_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_4_31_layer3_weight_31(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_4_31_get_layer3_weight_31(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_4_32                                      0x181ABDFC
#define  SRNN_wdsr_layer3_1x1_weights_4_32_reg_addr                              "0xB81ABDFC"
#define  SRNN_wdsr_layer3_1x1_weights_4_32_reg                                   0xB81ABDFC
#define  SRNN_wdsr_layer3_1x1_weights_4_32_inst_addr                             "0x03A3"
#define  set_SRNN_wdsr_layer3_1x1_weights_4_32_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_4_32_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_4_32_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_4_32_reg))
#define  SRNN_wdsr_layer3_1x1_weights_4_32_layer3_weight_32_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_4_32_layer3_weight_32_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_4_32_layer3_weight_32(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_4_32_get_layer3_weight_32(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_5_1                                       0x181ABE00
#define  SRNN_wdsr_layer3_1x1_weights_5_1_reg_addr                               "0xB81ABE00"
#define  SRNN_wdsr_layer3_1x1_weights_5_1_reg                                    0xB81ABE00
#define  SRNN_wdsr_layer3_1x1_weights_5_1_inst_addr                              "0x03A4"
#define  set_SRNN_wdsr_layer3_1x1_weights_5_1_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_5_1_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_5_1_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_5_1_reg))
#define  SRNN_wdsr_layer3_1x1_weights_5_1_layer3_weight_1_shift                  (0)
#define  SRNN_wdsr_layer3_1x1_weights_5_1_layer3_weight_1_mask                   (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_5_1_layer3_weight_1(data)                  (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_5_1_get_layer3_weight_1(data)              (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_5_2                                       0x181ABE04
#define  SRNN_wdsr_layer3_1x1_weights_5_2_reg_addr                               "0xB81ABE04"
#define  SRNN_wdsr_layer3_1x1_weights_5_2_reg                                    0xB81ABE04
#define  SRNN_wdsr_layer3_1x1_weights_5_2_inst_addr                              "0x03A5"
#define  set_SRNN_wdsr_layer3_1x1_weights_5_2_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_5_2_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_5_2_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_5_2_reg))
#define  SRNN_wdsr_layer3_1x1_weights_5_2_layer3_weight_2_shift                  (0)
#define  SRNN_wdsr_layer3_1x1_weights_5_2_layer3_weight_2_mask                   (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_5_2_layer3_weight_2(data)                  (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_5_2_get_layer3_weight_2(data)              (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_5_3                                       0x181ABE08
#define  SRNN_wdsr_layer3_1x1_weights_5_3_reg_addr                               "0xB81ABE08"
#define  SRNN_wdsr_layer3_1x1_weights_5_3_reg                                    0xB81ABE08
#define  SRNN_wdsr_layer3_1x1_weights_5_3_inst_addr                              "0x03A6"
#define  set_SRNN_wdsr_layer3_1x1_weights_5_3_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_5_3_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_5_3_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_5_3_reg))
#define  SRNN_wdsr_layer3_1x1_weights_5_3_layer3_weight_3_shift                  (0)
#define  SRNN_wdsr_layer3_1x1_weights_5_3_layer3_weight_3_mask                   (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_5_3_layer3_weight_3(data)                  (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_5_3_get_layer3_weight_3(data)              (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_5_4                                       0x181ABE0C
#define  SRNN_wdsr_layer3_1x1_weights_5_4_reg_addr                               "0xB81ABE0C"
#define  SRNN_wdsr_layer3_1x1_weights_5_4_reg                                    0xB81ABE0C
#define  SRNN_wdsr_layer3_1x1_weights_5_4_inst_addr                              "0x03A7"
#define  set_SRNN_wdsr_layer3_1x1_weights_5_4_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_5_4_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_5_4_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_5_4_reg))
#define  SRNN_wdsr_layer3_1x1_weights_5_4_layer3_weight_4_shift                  (0)
#define  SRNN_wdsr_layer3_1x1_weights_5_4_layer3_weight_4_mask                   (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_5_4_layer3_weight_4(data)                  (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_5_4_get_layer3_weight_4(data)              (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_5_5                                       0x181ABE10
#define  SRNN_wdsr_layer3_1x1_weights_5_5_reg_addr                               "0xB81ABE10"
#define  SRNN_wdsr_layer3_1x1_weights_5_5_reg                                    0xB81ABE10
#define  SRNN_wdsr_layer3_1x1_weights_5_5_inst_addr                              "0x03A8"
#define  set_SRNN_wdsr_layer3_1x1_weights_5_5_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_5_5_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_5_5_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_5_5_reg))
#define  SRNN_wdsr_layer3_1x1_weights_5_5_layer3_weight_5_shift                  (0)
#define  SRNN_wdsr_layer3_1x1_weights_5_5_layer3_weight_5_mask                   (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_5_5_layer3_weight_5(data)                  (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_5_5_get_layer3_weight_5(data)              (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_5_6                                       0x181ABE14
#define  SRNN_wdsr_layer3_1x1_weights_5_6_reg_addr                               "0xB81ABE14"
#define  SRNN_wdsr_layer3_1x1_weights_5_6_reg                                    0xB81ABE14
#define  SRNN_wdsr_layer3_1x1_weights_5_6_inst_addr                              "0x03A9"
#define  set_SRNN_wdsr_layer3_1x1_weights_5_6_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_5_6_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_5_6_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_5_6_reg))
#define  SRNN_wdsr_layer3_1x1_weights_5_6_layer3_weight_6_shift                  (0)
#define  SRNN_wdsr_layer3_1x1_weights_5_6_layer3_weight_6_mask                   (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_5_6_layer3_weight_6(data)                  (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_5_6_get_layer3_weight_6(data)              (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_5_7                                       0x181ABE18
#define  SRNN_wdsr_layer3_1x1_weights_5_7_reg_addr                               "0xB81ABE18"
#define  SRNN_wdsr_layer3_1x1_weights_5_7_reg                                    0xB81ABE18
#define  SRNN_wdsr_layer3_1x1_weights_5_7_inst_addr                              "0x03AA"
#define  set_SRNN_wdsr_layer3_1x1_weights_5_7_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_5_7_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_5_7_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_5_7_reg))
#define  SRNN_wdsr_layer3_1x1_weights_5_7_layer3_weight_7_shift                  (0)
#define  SRNN_wdsr_layer3_1x1_weights_5_7_layer3_weight_7_mask                   (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_5_7_layer3_weight_7(data)                  (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_5_7_get_layer3_weight_7(data)              (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_5_8                                       0x181ABE1C
#define  SRNN_wdsr_layer3_1x1_weights_5_8_reg_addr                               "0xB81ABE1C"
#define  SRNN_wdsr_layer3_1x1_weights_5_8_reg                                    0xB81ABE1C
#define  SRNN_wdsr_layer3_1x1_weights_5_8_inst_addr                              "0x03AB"
#define  set_SRNN_wdsr_layer3_1x1_weights_5_8_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_5_8_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_5_8_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_5_8_reg))
#define  SRNN_wdsr_layer3_1x1_weights_5_8_layer3_weight_8_shift                  (0)
#define  SRNN_wdsr_layer3_1x1_weights_5_8_layer3_weight_8_mask                   (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_5_8_layer3_weight_8(data)                  (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_5_8_get_layer3_weight_8(data)              (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_5_9                                       0x181ABE20
#define  SRNN_wdsr_layer3_1x1_weights_5_9_reg_addr                               "0xB81ABE20"
#define  SRNN_wdsr_layer3_1x1_weights_5_9_reg                                    0xB81ABE20
#define  SRNN_wdsr_layer3_1x1_weights_5_9_inst_addr                              "0x03AC"
#define  set_SRNN_wdsr_layer3_1x1_weights_5_9_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_5_9_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_5_9_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_5_9_reg))
#define  SRNN_wdsr_layer3_1x1_weights_5_9_layer3_weight_9_shift                  (0)
#define  SRNN_wdsr_layer3_1x1_weights_5_9_layer3_weight_9_mask                   (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_5_9_layer3_weight_9(data)                  (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_5_9_get_layer3_weight_9(data)              (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_5_10                                      0x181ABE24
#define  SRNN_wdsr_layer3_1x1_weights_5_10_reg_addr                              "0xB81ABE24"
#define  SRNN_wdsr_layer3_1x1_weights_5_10_reg                                   0xB81ABE24
#define  SRNN_wdsr_layer3_1x1_weights_5_10_inst_addr                             "0x03AD"
#define  set_SRNN_wdsr_layer3_1x1_weights_5_10_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_5_10_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_5_10_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_5_10_reg))
#define  SRNN_wdsr_layer3_1x1_weights_5_10_layer3_weight_10_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_5_10_layer3_weight_10_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_5_10_layer3_weight_10(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_5_10_get_layer3_weight_10(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_5_11                                      0x181ABE28
#define  SRNN_wdsr_layer3_1x1_weights_5_11_reg_addr                              "0xB81ABE28"
#define  SRNN_wdsr_layer3_1x1_weights_5_11_reg                                   0xB81ABE28
#define  SRNN_wdsr_layer3_1x1_weights_5_11_inst_addr                             "0x03AE"
#define  set_SRNN_wdsr_layer3_1x1_weights_5_11_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_5_11_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_5_11_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_5_11_reg))
#define  SRNN_wdsr_layer3_1x1_weights_5_11_layer3_weight_11_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_5_11_layer3_weight_11_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_5_11_layer3_weight_11(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_5_11_get_layer3_weight_11(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_5_12                                      0x181ABE2C
#define  SRNN_wdsr_layer3_1x1_weights_5_12_reg_addr                              "0xB81ABE2C"
#define  SRNN_wdsr_layer3_1x1_weights_5_12_reg                                   0xB81ABE2C
#define  SRNN_wdsr_layer3_1x1_weights_5_12_inst_addr                             "0x03AF"
#define  set_SRNN_wdsr_layer3_1x1_weights_5_12_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_5_12_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_5_12_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_5_12_reg))
#define  SRNN_wdsr_layer3_1x1_weights_5_12_layer3_weight_12_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_5_12_layer3_weight_12_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_5_12_layer3_weight_12(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_5_12_get_layer3_weight_12(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_5_13                                      0x181ABE30
#define  SRNN_wdsr_layer3_1x1_weights_5_13_reg_addr                              "0xB81ABE30"
#define  SRNN_wdsr_layer3_1x1_weights_5_13_reg                                   0xB81ABE30
#define  SRNN_wdsr_layer3_1x1_weights_5_13_inst_addr                             "0x03B0"
#define  set_SRNN_wdsr_layer3_1x1_weights_5_13_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_5_13_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_5_13_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_5_13_reg))
#define  SRNN_wdsr_layer3_1x1_weights_5_13_layer3_weight_13_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_5_13_layer3_weight_13_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_5_13_layer3_weight_13(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_5_13_get_layer3_weight_13(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_5_14                                      0x181ABE34
#define  SRNN_wdsr_layer3_1x1_weights_5_14_reg_addr                              "0xB81ABE34"
#define  SRNN_wdsr_layer3_1x1_weights_5_14_reg                                   0xB81ABE34
#define  SRNN_wdsr_layer3_1x1_weights_5_14_inst_addr                             "0x03B1"
#define  set_SRNN_wdsr_layer3_1x1_weights_5_14_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_5_14_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_5_14_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_5_14_reg))
#define  SRNN_wdsr_layer3_1x1_weights_5_14_layer3_weight_14_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_5_14_layer3_weight_14_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_5_14_layer3_weight_14(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_5_14_get_layer3_weight_14(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_5_15                                      0x181ABE38
#define  SRNN_wdsr_layer3_1x1_weights_5_15_reg_addr                              "0xB81ABE38"
#define  SRNN_wdsr_layer3_1x1_weights_5_15_reg                                   0xB81ABE38
#define  SRNN_wdsr_layer3_1x1_weights_5_15_inst_addr                             "0x03B2"
#define  set_SRNN_wdsr_layer3_1x1_weights_5_15_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_5_15_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_5_15_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_5_15_reg))
#define  SRNN_wdsr_layer3_1x1_weights_5_15_layer3_weight_15_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_5_15_layer3_weight_15_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_5_15_layer3_weight_15(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_5_15_get_layer3_weight_15(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_5_16                                      0x181ABE3C
#define  SRNN_wdsr_layer3_1x1_weights_5_16_reg_addr                              "0xB81ABE3C"
#define  SRNN_wdsr_layer3_1x1_weights_5_16_reg                                   0xB81ABE3C
#define  SRNN_wdsr_layer3_1x1_weights_5_16_inst_addr                             "0x03B3"
#define  set_SRNN_wdsr_layer3_1x1_weights_5_16_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_5_16_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_5_16_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_5_16_reg))
#define  SRNN_wdsr_layer3_1x1_weights_5_16_layer3_weight_16_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_5_16_layer3_weight_16_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_5_16_layer3_weight_16(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_5_16_get_layer3_weight_16(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_5_17                                      0x181ABE40
#define  SRNN_wdsr_layer3_1x1_weights_5_17_reg_addr                              "0xB81ABE40"
#define  SRNN_wdsr_layer3_1x1_weights_5_17_reg                                   0xB81ABE40
#define  SRNN_wdsr_layer3_1x1_weights_5_17_inst_addr                             "0x03B4"
#define  set_SRNN_wdsr_layer3_1x1_weights_5_17_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_5_17_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_5_17_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_5_17_reg))
#define  SRNN_wdsr_layer3_1x1_weights_5_17_layer3_weight_17_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_5_17_layer3_weight_17_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_5_17_layer3_weight_17(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_5_17_get_layer3_weight_17(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_5_18                                      0x181ABE44
#define  SRNN_wdsr_layer3_1x1_weights_5_18_reg_addr                              "0xB81ABE44"
#define  SRNN_wdsr_layer3_1x1_weights_5_18_reg                                   0xB81ABE44
#define  SRNN_wdsr_layer3_1x1_weights_5_18_inst_addr                             "0x03B5"
#define  set_SRNN_wdsr_layer3_1x1_weights_5_18_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_5_18_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_5_18_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_5_18_reg))
#define  SRNN_wdsr_layer3_1x1_weights_5_18_layer3_weight_18_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_5_18_layer3_weight_18_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_5_18_layer3_weight_18(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_5_18_get_layer3_weight_18(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_5_19                                      0x181ABE48
#define  SRNN_wdsr_layer3_1x1_weights_5_19_reg_addr                              "0xB81ABE48"
#define  SRNN_wdsr_layer3_1x1_weights_5_19_reg                                   0xB81ABE48
#define  SRNN_wdsr_layer3_1x1_weights_5_19_inst_addr                             "0x03B6"
#define  set_SRNN_wdsr_layer3_1x1_weights_5_19_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_5_19_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_5_19_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_5_19_reg))
#define  SRNN_wdsr_layer3_1x1_weights_5_19_layer3_weight_19_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_5_19_layer3_weight_19_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_5_19_layer3_weight_19(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_5_19_get_layer3_weight_19(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_5_20                                      0x181ABE4C
#define  SRNN_wdsr_layer3_1x1_weights_5_20_reg_addr                              "0xB81ABE4C"
#define  SRNN_wdsr_layer3_1x1_weights_5_20_reg                                   0xB81ABE4C
#define  SRNN_wdsr_layer3_1x1_weights_5_20_inst_addr                             "0x03B7"
#define  set_SRNN_wdsr_layer3_1x1_weights_5_20_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_5_20_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_5_20_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_5_20_reg))
#define  SRNN_wdsr_layer3_1x1_weights_5_20_layer3_weight_20_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_5_20_layer3_weight_20_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_5_20_layer3_weight_20(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_5_20_get_layer3_weight_20(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_5_21                                      0x181ABE50
#define  SRNN_wdsr_layer3_1x1_weights_5_21_reg_addr                              "0xB81ABE50"
#define  SRNN_wdsr_layer3_1x1_weights_5_21_reg                                   0xB81ABE50
#define  SRNN_wdsr_layer3_1x1_weights_5_21_inst_addr                             "0x03B8"
#define  set_SRNN_wdsr_layer3_1x1_weights_5_21_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_5_21_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_5_21_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_5_21_reg))
#define  SRNN_wdsr_layer3_1x1_weights_5_21_layer3_weight_21_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_5_21_layer3_weight_21_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_5_21_layer3_weight_21(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_5_21_get_layer3_weight_21(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_5_22                                      0x181ABE54
#define  SRNN_wdsr_layer3_1x1_weights_5_22_reg_addr                              "0xB81ABE54"
#define  SRNN_wdsr_layer3_1x1_weights_5_22_reg                                   0xB81ABE54
#define  SRNN_wdsr_layer3_1x1_weights_5_22_inst_addr                             "0x03B9"
#define  set_SRNN_wdsr_layer3_1x1_weights_5_22_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_5_22_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_5_22_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_5_22_reg))
#define  SRNN_wdsr_layer3_1x1_weights_5_22_layer3_weight_22_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_5_22_layer3_weight_22_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_5_22_layer3_weight_22(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_5_22_get_layer3_weight_22(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_5_23                                      0x181ABE58
#define  SRNN_wdsr_layer3_1x1_weights_5_23_reg_addr                              "0xB81ABE58"
#define  SRNN_wdsr_layer3_1x1_weights_5_23_reg                                   0xB81ABE58
#define  SRNN_wdsr_layer3_1x1_weights_5_23_inst_addr                             "0x03BA"
#define  set_SRNN_wdsr_layer3_1x1_weights_5_23_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_5_23_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_5_23_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_5_23_reg))
#define  SRNN_wdsr_layer3_1x1_weights_5_23_layer3_weight_23_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_5_23_layer3_weight_23_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_5_23_layer3_weight_23(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_5_23_get_layer3_weight_23(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_5_24                                      0x181ABE5C
#define  SRNN_wdsr_layer3_1x1_weights_5_24_reg_addr                              "0xB81ABE5C"
#define  SRNN_wdsr_layer3_1x1_weights_5_24_reg                                   0xB81ABE5C
#define  SRNN_wdsr_layer3_1x1_weights_5_24_inst_addr                             "0x03BB"
#define  set_SRNN_wdsr_layer3_1x1_weights_5_24_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_5_24_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_5_24_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_5_24_reg))
#define  SRNN_wdsr_layer3_1x1_weights_5_24_layer3_weight_24_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_5_24_layer3_weight_24_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_5_24_layer3_weight_24(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_5_24_get_layer3_weight_24(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_5_25                                      0x181ABE60
#define  SRNN_wdsr_layer3_1x1_weights_5_25_reg_addr                              "0xB81ABE60"
#define  SRNN_wdsr_layer3_1x1_weights_5_25_reg                                   0xB81ABE60
#define  SRNN_wdsr_layer3_1x1_weights_5_25_inst_addr                             "0x03BC"
#define  set_SRNN_wdsr_layer3_1x1_weights_5_25_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_5_25_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_5_25_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_5_25_reg))
#define  SRNN_wdsr_layer3_1x1_weights_5_25_layer3_weight_25_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_5_25_layer3_weight_25_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_5_25_layer3_weight_25(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_5_25_get_layer3_weight_25(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_5_26                                      0x181ABE64
#define  SRNN_wdsr_layer3_1x1_weights_5_26_reg_addr                              "0xB81ABE64"
#define  SRNN_wdsr_layer3_1x1_weights_5_26_reg                                   0xB81ABE64
#define  SRNN_wdsr_layer3_1x1_weights_5_26_inst_addr                             "0x03BD"
#define  set_SRNN_wdsr_layer3_1x1_weights_5_26_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_5_26_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_5_26_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_5_26_reg))
#define  SRNN_wdsr_layer3_1x1_weights_5_26_layer3_weight_26_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_5_26_layer3_weight_26_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_5_26_layer3_weight_26(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_5_26_get_layer3_weight_26(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_5_27                                      0x181ABE68
#define  SRNN_wdsr_layer3_1x1_weights_5_27_reg_addr                              "0xB81ABE68"
#define  SRNN_wdsr_layer3_1x1_weights_5_27_reg                                   0xB81ABE68
#define  SRNN_wdsr_layer3_1x1_weights_5_27_inst_addr                             "0x03BE"
#define  set_SRNN_wdsr_layer3_1x1_weights_5_27_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_5_27_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_5_27_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_5_27_reg))
#define  SRNN_wdsr_layer3_1x1_weights_5_27_layer3_weight_27_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_5_27_layer3_weight_27_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_5_27_layer3_weight_27(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_5_27_get_layer3_weight_27(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_5_28                                      0x181ABE6C
#define  SRNN_wdsr_layer3_1x1_weights_5_28_reg_addr                              "0xB81ABE6C"
#define  SRNN_wdsr_layer3_1x1_weights_5_28_reg                                   0xB81ABE6C
#define  SRNN_wdsr_layer3_1x1_weights_5_28_inst_addr                             "0x03BF"
#define  set_SRNN_wdsr_layer3_1x1_weights_5_28_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_5_28_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_5_28_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_5_28_reg))
#define  SRNN_wdsr_layer3_1x1_weights_5_28_layer3_weight_28_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_5_28_layer3_weight_28_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_5_28_layer3_weight_28(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_5_28_get_layer3_weight_28(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_5_29                                      0x181ABE70
#define  SRNN_wdsr_layer3_1x1_weights_5_29_reg_addr                              "0xB81ABE70"
#define  SRNN_wdsr_layer3_1x1_weights_5_29_reg                                   0xB81ABE70
#define  SRNN_wdsr_layer3_1x1_weights_5_29_inst_addr                             "0x03C0"
#define  set_SRNN_wdsr_layer3_1x1_weights_5_29_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_5_29_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_5_29_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_5_29_reg))
#define  SRNN_wdsr_layer3_1x1_weights_5_29_layer3_weight_29_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_5_29_layer3_weight_29_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_5_29_layer3_weight_29(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_5_29_get_layer3_weight_29(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_5_30                                      0x181ABE74
#define  SRNN_wdsr_layer3_1x1_weights_5_30_reg_addr                              "0xB81ABE74"
#define  SRNN_wdsr_layer3_1x1_weights_5_30_reg                                   0xB81ABE74
#define  SRNN_wdsr_layer3_1x1_weights_5_30_inst_addr                             "0x03C1"
#define  set_SRNN_wdsr_layer3_1x1_weights_5_30_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_5_30_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_5_30_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_5_30_reg))
#define  SRNN_wdsr_layer3_1x1_weights_5_30_layer3_weight_30_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_5_30_layer3_weight_30_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_5_30_layer3_weight_30(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_5_30_get_layer3_weight_30(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_5_31                                      0x181ABE78
#define  SRNN_wdsr_layer3_1x1_weights_5_31_reg_addr                              "0xB81ABE78"
#define  SRNN_wdsr_layer3_1x1_weights_5_31_reg                                   0xB81ABE78
#define  SRNN_wdsr_layer3_1x1_weights_5_31_inst_addr                             "0x03C2"
#define  set_SRNN_wdsr_layer3_1x1_weights_5_31_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_5_31_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_5_31_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_5_31_reg))
#define  SRNN_wdsr_layer3_1x1_weights_5_31_layer3_weight_31_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_5_31_layer3_weight_31_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_5_31_layer3_weight_31(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_5_31_get_layer3_weight_31(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_5_32                                      0x181ABE7C
#define  SRNN_wdsr_layer3_1x1_weights_5_32_reg_addr                              "0xB81ABE7C"
#define  SRNN_wdsr_layer3_1x1_weights_5_32_reg                                   0xB81ABE7C
#define  SRNN_wdsr_layer3_1x1_weights_5_32_inst_addr                             "0x03C3"
#define  set_SRNN_wdsr_layer3_1x1_weights_5_32_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_5_32_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_5_32_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_5_32_reg))
#define  SRNN_wdsr_layer3_1x1_weights_5_32_layer3_weight_32_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_5_32_layer3_weight_32_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_5_32_layer3_weight_32(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_5_32_get_layer3_weight_32(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_6_1                                       0x181ABE80
#define  SRNN_wdsr_layer3_1x1_weights_6_1_reg_addr                               "0xB81ABE80"
#define  SRNN_wdsr_layer3_1x1_weights_6_1_reg                                    0xB81ABE80
#define  SRNN_wdsr_layer3_1x1_weights_6_1_inst_addr                              "0x03C4"
#define  set_SRNN_wdsr_layer3_1x1_weights_6_1_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_6_1_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_6_1_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_6_1_reg))
#define  SRNN_wdsr_layer3_1x1_weights_6_1_layer3_weight_1_shift                  (0)
#define  SRNN_wdsr_layer3_1x1_weights_6_1_layer3_weight_1_mask                   (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_6_1_layer3_weight_1(data)                  (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_6_1_get_layer3_weight_1(data)              (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_6_2                                       0x181ABE84
#define  SRNN_wdsr_layer3_1x1_weights_6_2_reg_addr                               "0xB81ABE84"
#define  SRNN_wdsr_layer3_1x1_weights_6_2_reg                                    0xB81ABE84
#define  SRNN_wdsr_layer3_1x1_weights_6_2_inst_addr                              "0x03C5"
#define  set_SRNN_wdsr_layer3_1x1_weights_6_2_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_6_2_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_6_2_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_6_2_reg))
#define  SRNN_wdsr_layer3_1x1_weights_6_2_layer3_weight_2_shift                  (0)
#define  SRNN_wdsr_layer3_1x1_weights_6_2_layer3_weight_2_mask                   (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_6_2_layer3_weight_2(data)                  (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_6_2_get_layer3_weight_2(data)              (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_6_3                                       0x181ABE88
#define  SRNN_wdsr_layer3_1x1_weights_6_3_reg_addr                               "0xB81ABE88"
#define  SRNN_wdsr_layer3_1x1_weights_6_3_reg                                    0xB81ABE88
#define  SRNN_wdsr_layer3_1x1_weights_6_3_inst_addr                              "0x03C6"
#define  set_SRNN_wdsr_layer3_1x1_weights_6_3_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_6_3_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_6_3_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_6_3_reg))
#define  SRNN_wdsr_layer3_1x1_weights_6_3_layer3_weight_3_shift                  (0)
#define  SRNN_wdsr_layer3_1x1_weights_6_3_layer3_weight_3_mask                   (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_6_3_layer3_weight_3(data)                  (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_6_3_get_layer3_weight_3(data)              (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_6_4                                       0x181ABE8C
#define  SRNN_wdsr_layer3_1x1_weights_6_4_reg_addr                               "0xB81ABE8C"
#define  SRNN_wdsr_layer3_1x1_weights_6_4_reg                                    0xB81ABE8C
#define  SRNN_wdsr_layer3_1x1_weights_6_4_inst_addr                              "0x03C7"
#define  set_SRNN_wdsr_layer3_1x1_weights_6_4_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_6_4_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_6_4_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_6_4_reg))
#define  SRNN_wdsr_layer3_1x1_weights_6_4_layer3_weight_4_shift                  (0)
#define  SRNN_wdsr_layer3_1x1_weights_6_4_layer3_weight_4_mask                   (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_6_4_layer3_weight_4(data)                  (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_6_4_get_layer3_weight_4(data)              (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_6_5                                       0x181ABE90
#define  SRNN_wdsr_layer3_1x1_weights_6_5_reg_addr                               "0xB81ABE90"
#define  SRNN_wdsr_layer3_1x1_weights_6_5_reg                                    0xB81ABE90
#define  SRNN_wdsr_layer3_1x1_weights_6_5_inst_addr                              "0x03C8"
#define  set_SRNN_wdsr_layer3_1x1_weights_6_5_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_6_5_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_6_5_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_6_5_reg))
#define  SRNN_wdsr_layer3_1x1_weights_6_5_layer3_weight_5_shift                  (0)
#define  SRNN_wdsr_layer3_1x1_weights_6_5_layer3_weight_5_mask                   (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_6_5_layer3_weight_5(data)                  (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_6_5_get_layer3_weight_5(data)              (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_6_6                                       0x181ABE94
#define  SRNN_wdsr_layer3_1x1_weights_6_6_reg_addr                               "0xB81ABE94"
#define  SRNN_wdsr_layer3_1x1_weights_6_6_reg                                    0xB81ABE94
#define  SRNN_wdsr_layer3_1x1_weights_6_6_inst_addr                              "0x03C9"
#define  set_SRNN_wdsr_layer3_1x1_weights_6_6_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_6_6_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_6_6_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_6_6_reg))
#define  SRNN_wdsr_layer3_1x1_weights_6_6_layer3_weight_6_shift                  (0)
#define  SRNN_wdsr_layer3_1x1_weights_6_6_layer3_weight_6_mask                   (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_6_6_layer3_weight_6(data)                  (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_6_6_get_layer3_weight_6(data)              (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_6_7                                       0x181ABE98
#define  SRNN_wdsr_layer3_1x1_weights_6_7_reg_addr                               "0xB81ABE98"
#define  SRNN_wdsr_layer3_1x1_weights_6_7_reg                                    0xB81ABE98
#define  SRNN_wdsr_layer3_1x1_weights_6_7_inst_addr                              "0x03CA"
#define  set_SRNN_wdsr_layer3_1x1_weights_6_7_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_6_7_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_6_7_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_6_7_reg))
#define  SRNN_wdsr_layer3_1x1_weights_6_7_layer3_weight_7_shift                  (0)
#define  SRNN_wdsr_layer3_1x1_weights_6_7_layer3_weight_7_mask                   (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_6_7_layer3_weight_7(data)                  (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_6_7_get_layer3_weight_7(data)              (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_6_8                                       0x181ABE9C
#define  SRNN_wdsr_layer3_1x1_weights_6_8_reg_addr                               "0xB81ABE9C"
#define  SRNN_wdsr_layer3_1x1_weights_6_8_reg                                    0xB81ABE9C
#define  SRNN_wdsr_layer3_1x1_weights_6_8_inst_addr                              "0x03CB"
#define  set_SRNN_wdsr_layer3_1x1_weights_6_8_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_6_8_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_6_8_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_6_8_reg))
#define  SRNN_wdsr_layer3_1x1_weights_6_8_layer3_weight_8_shift                  (0)
#define  SRNN_wdsr_layer3_1x1_weights_6_8_layer3_weight_8_mask                   (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_6_8_layer3_weight_8(data)                  (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_6_8_get_layer3_weight_8(data)              (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_6_9                                       0x181ABEA0
#define  SRNN_wdsr_layer3_1x1_weights_6_9_reg_addr                               "0xB81ABEA0"
#define  SRNN_wdsr_layer3_1x1_weights_6_9_reg                                    0xB81ABEA0
#define  SRNN_wdsr_layer3_1x1_weights_6_9_inst_addr                              "0x03CC"
#define  set_SRNN_wdsr_layer3_1x1_weights_6_9_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_6_9_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_6_9_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_6_9_reg))
#define  SRNN_wdsr_layer3_1x1_weights_6_9_layer3_weight_9_shift                  (0)
#define  SRNN_wdsr_layer3_1x1_weights_6_9_layer3_weight_9_mask                   (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_6_9_layer3_weight_9(data)                  (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_6_9_get_layer3_weight_9(data)              (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_6_10                                      0x181ABEA4
#define  SRNN_wdsr_layer3_1x1_weights_6_10_reg_addr                              "0xB81ABEA4"
#define  SRNN_wdsr_layer3_1x1_weights_6_10_reg                                   0xB81ABEA4
#define  SRNN_wdsr_layer3_1x1_weights_6_10_inst_addr                             "0x03CD"
#define  set_SRNN_wdsr_layer3_1x1_weights_6_10_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_6_10_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_6_10_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_6_10_reg))
#define  SRNN_wdsr_layer3_1x1_weights_6_10_layer3_weight_10_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_6_10_layer3_weight_10_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_6_10_layer3_weight_10(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_6_10_get_layer3_weight_10(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_6_11                                      0x181ABEA8
#define  SRNN_wdsr_layer3_1x1_weights_6_11_reg_addr                              "0xB81ABEA8"
#define  SRNN_wdsr_layer3_1x1_weights_6_11_reg                                   0xB81ABEA8
#define  SRNN_wdsr_layer3_1x1_weights_6_11_inst_addr                             "0x03CE"
#define  set_SRNN_wdsr_layer3_1x1_weights_6_11_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_6_11_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_6_11_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_6_11_reg))
#define  SRNN_wdsr_layer3_1x1_weights_6_11_layer3_weight_11_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_6_11_layer3_weight_11_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_6_11_layer3_weight_11(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_6_11_get_layer3_weight_11(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_6_12                                      0x181ABEAC
#define  SRNN_wdsr_layer3_1x1_weights_6_12_reg_addr                              "0xB81ABEAC"
#define  SRNN_wdsr_layer3_1x1_weights_6_12_reg                                   0xB81ABEAC
#define  SRNN_wdsr_layer3_1x1_weights_6_12_inst_addr                             "0x03CF"
#define  set_SRNN_wdsr_layer3_1x1_weights_6_12_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_6_12_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_6_12_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_6_12_reg))
#define  SRNN_wdsr_layer3_1x1_weights_6_12_layer3_weight_12_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_6_12_layer3_weight_12_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_6_12_layer3_weight_12(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_6_12_get_layer3_weight_12(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_6_13                                      0x181ABEB0
#define  SRNN_wdsr_layer3_1x1_weights_6_13_reg_addr                              "0xB81ABEB0"
#define  SRNN_wdsr_layer3_1x1_weights_6_13_reg                                   0xB81ABEB0
#define  SRNN_wdsr_layer3_1x1_weights_6_13_inst_addr                             "0x03D0"
#define  set_SRNN_wdsr_layer3_1x1_weights_6_13_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_6_13_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_6_13_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_6_13_reg))
#define  SRNN_wdsr_layer3_1x1_weights_6_13_layer3_weight_13_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_6_13_layer3_weight_13_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_6_13_layer3_weight_13(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_6_13_get_layer3_weight_13(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_6_14                                      0x181ABEB4
#define  SRNN_wdsr_layer3_1x1_weights_6_14_reg_addr                              "0xB81ABEB4"
#define  SRNN_wdsr_layer3_1x1_weights_6_14_reg                                   0xB81ABEB4
#define  SRNN_wdsr_layer3_1x1_weights_6_14_inst_addr                             "0x03D1"
#define  set_SRNN_wdsr_layer3_1x1_weights_6_14_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_6_14_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_6_14_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_6_14_reg))
#define  SRNN_wdsr_layer3_1x1_weights_6_14_layer3_weight_14_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_6_14_layer3_weight_14_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_6_14_layer3_weight_14(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_6_14_get_layer3_weight_14(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_6_15                                      0x181ABEB8
#define  SRNN_wdsr_layer3_1x1_weights_6_15_reg_addr                              "0xB81ABEB8"
#define  SRNN_wdsr_layer3_1x1_weights_6_15_reg                                   0xB81ABEB8
#define  SRNN_wdsr_layer3_1x1_weights_6_15_inst_addr                             "0x03D2"
#define  set_SRNN_wdsr_layer3_1x1_weights_6_15_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_6_15_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_6_15_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_6_15_reg))
#define  SRNN_wdsr_layer3_1x1_weights_6_15_layer3_weight_15_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_6_15_layer3_weight_15_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_6_15_layer3_weight_15(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_6_15_get_layer3_weight_15(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_6_16                                      0x181ABEBC
#define  SRNN_wdsr_layer3_1x1_weights_6_16_reg_addr                              "0xB81ABEBC"
#define  SRNN_wdsr_layer3_1x1_weights_6_16_reg                                   0xB81ABEBC
#define  SRNN_wdsr_layer3_1x1_weights_6_16_inst_addr                             "0x03D3"
#define  set_SRNN_wdsr_layer3_1x1_weights_6_16_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_6_16_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_6_16_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_6_16_reg))
#define  SRNN_wdsr_layer3_1x1_weights_6_16_layer3_weight_16_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_6_16_layer3_weight_16_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_6_16_layer3_weight_16(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_6_16_get_layer3_weight_16(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_6_17                                      0x181ABEC0
#define  SRNN_wdsr_layer3_1x1_weights_6_17_reg_addr                              "0xB81ABEC0"
#define  SRNN_wdsr_layer3_1x1_weights_6_17_reg                                   0xB81ABEC0
#define  SRNN_wdsr_layer3_1x1_weights_6_17_inst_addr                             "0x03D4"
#define  set_SRNN_wdsr_layer3_1x1_weights_6_17_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_6_17_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_6_17_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_6_17_reg))
#define  SRNN_wdsr_layer3_1x1_weights_6_17_layer3_weight_17_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_6_17_layer3_weight_17_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_6_17_layer3_weight_17(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_6_17_get_layer3_weight_17(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_6_18                                      0x181ABEC4
#define  SRNN_wdsr_layer3_1x1_weights_6_18_reg_addr                              "0xB81ABEC4"
#define  SRNN_wdsr_layer3_1x1_weights_6_18_reg                                   0xB81ABEC4
#define  SRNN_wdsr_layer3_1x1_weights_6_18_inst_addr                             "0x03D5"
#define  set_SRNN_wdsr_layer3_1x1_weights_6_18_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_6_18_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_6_18_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_6_18_reg))
#define  SRNN_wdsr_layer3_1x1_weights_6_18_layer3_weight_18_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_6_18_layer3_weight_18_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_6_18_layer3_weight_18(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_6_18_get_layer3_weight_18(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_6_19                                      0x181ABEC8
#define  SRNN_wdsr_layer3_1x1_weights_6_19_reg_addr                              "0xB81ABEC8"
#define  SRNN_wdsr_layer3_1x1_weights_6_19_reg                                   0xB81ABEC8
#define  SRNN_wdsr_layer3_1x1_weights_6_19_inst_addr                             "0x03D6"
#define  set_SRNN_wdsr_layer3_1x1_weights_6_19_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_6_19_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_6_19_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_6_19_reg))
#define  SRNN_wdsr_layer3_1x1_weights_6_19_layer3_weight_19_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_6_19_layer3_weight_19_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_6_19_layer3_weight_19(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_6_19_get_layer3_weight_19(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_6_20                                      0x181ABECC
#define  SRNN_wdsr_layer3_1x1_weights_6_20_reg_addr                              "0xB81ABECC"
#define  SRNN_wdsr_layer3_1x1_weights_6_20_reg                                   0xB81ABECC
#define  SRNN_wdsr_layer3_1x1_weights_6_20_inst_addr                             "0x03D7"
#define  set_SRNN_wdsr_layer3_1x1_weights_6_20_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_6_20_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_6_20_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_6_20_reg))
#define  SRNN_wdsr_layer3_1x1_weights_6_20_layer3_weight_20_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_6_20_layer3_weight_20_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_6_20_layer3_weight_20(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_6_20_get_layer3_weight_20(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_6_21                                      0x181ABED0
#define  SRNN_wdsr_layer3_1x1_weights_6_21_reg_addr                              "0xB81ABED0"
#define  SRNN_wdsr_layer3_1x1_weights_6_21_reg                                   0xB81ABED0
#define  SRNN_wdsr_layer3_1x1_weights_6_21_inst_addr                             "0x03D8"
#define  set_SRNN_wdsr_layer3_1x1_weights_6_21_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_6_21_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_6_21_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_6_21_reg))
#define  SRNN_wdsr_layer3_1x1_weights_6_21_layer3_weight_21_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_6_21_layer3_weight_21_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_6_21_layer3_weight_21(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_6_21_get_layer3_weight_21(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_6_22                                      0x181ABED4
#define  SRNN_wdsr_layer3_1x1_weights_6_22_reg_addr                              "0xB81ABED4"
#define  SRNN_wdsr_layer3_1x1_weights_6_22_reg                                   0xB81ABED4
#define  SRNN_wdsr_layer3_1x1_weights_6_22_inst_addr                             "0x03D9"
#define  set_SRNN_wdsr_layer3_1x1_weights_6_22_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_6_22_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_6_22_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_6_22_reg))
#define  SRNN_wdsr_layer3_1x1_weights_6_22_layer3_weight_22_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_6_22_layer3_weight_22_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_6_22_layer3_weight_22(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_6_22_get_layer3_weight_22(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_6_23                                      0x181ABED8
#define  SRNN_wdsr_layer3_1x1_weights_6_23_reg_addr                              "0xB81ABED8"
#define  SRNN_wdsr_layer3_1x1_weights_6_23_reg                                   0xB81ABED8
#define  SRNN_wdsr_layer3_1x1_weights_6_23_inst_addr                             "0x03DA"
#define  set_SRNN_wdsr_layer3_1x1_weights_6_23_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_6_23_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_6_23_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_6_23_reg))
#define  SRNN_wdsr_layer3_1x1_weights_6_23_layer3_weight_23_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_6_23_layer3_weight_23_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_6_23_layer3_weight_23(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_6_23_get_layer3_weight_23(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_6_24                                      0x181ABEDC
#define  SRNN_wdsr_layer3_1x1_weights_6_24_reg_addr                              "0xB81ABEDC"
#define  SRNN_wdsr_layer3_1x1_weights_6_24_reg                                   0xB81ABEDC
#define  SRNN_wdsr_layer3_1x1_weights_6_24_inst_addr                             "0x03DB"
#define  set_SRNN_wdsr_layer3_1x1_weights_6_24_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_6_24_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_6_24_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_6_24_reg))
#define  SRNN_wdsr_layer3_1x1_weights_6_24_layer3_weight_24_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_6_24_layer3_weight_24_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_6_24_layer3_weight_24(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_6_24_get_layer3_weight_24(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_6_25                                      0x181ABEE0
#define  SRNN_wdsr_layer3_1x1_weights_6_25_reg_addr                              "0xB81ABEE0"
#define  SRNN_wdsr_layer3_1x1_weights_6_25_reg                                   0xB81ABEE0
#define  SRNN_wdsr_layer3_1x1_weights_6_25_inst_addr                             "0x03DC"
#define  set_SRNN_wdsr_layer3_1x1_weights_6_25_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_6_25_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_6_25_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_6_25_reg))
#define  SRNN_wdsr_layer3_1x1_weights_6_25_layer3_weight_25_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_6_25_layer3_weight_25_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_6_25_layer3_weight_25(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_6_25_get_layer3_weight_25(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_6_26                                      0x181ABEE4
#define  SRNN_wdsr_layer3_1x1_weights_6_26_reg_addr                              "0xB81ABEE4"
#define  SRNN_wdsr_layer3_1x1_weights_6_26_reg                                   0xB81ABEE4
#define  SRNN_wdsr_layer3_1x1_weights_6_26_inst_addr                             "0x03DD"
#define  set_SRNN_wdsr_layer3_1x1_weights_6_26_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_6_26_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_6_26_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_6_26_reg))
#define  SRNN_wdsr_layer3_1x1_weights_6_26_layer3_weight_26_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_6_26_layer3_weight_26_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_6_26_layer3_weight_26(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_6_26_get_layer3_weight_26(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_6_27                                      0x181ABEE8
#define  SRNN_wdsr_layer3_1x1_weights_6_27_reg_addr                              "0xB81ABEE8"
#define  SRNN_wdsr_layer3_1x1_weights_6_27_reg                                   0xB81ABEE8
#define  SRNN_wdsr_layer3_1x1_weights_6_27_inst_addr                             "0x03DE"
#define  set_SRNN_wdsr_layer3_1x1_weights_6_27_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_6_27_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_6_27_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_6_27_reg))
#define  SRNN_wdsr_layer3_1x1_weights_6_27_layer3_weight_27_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_6_27_layer3_weight_27_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_6_27_layer3_weight_27(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_6_27_get_layer3_weight_27(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_6_28                                      0x181ABEEC
#define  SRNN_wdsr_layer3_1x1_weights_6_28_reg_addr                              "0xB81ABEEC"
#define  SRNN_wdsr_layer3_1x1_weights_6_28_reg                                   0xB81ABEEC
#define  SRNN_wdsr_layer3_1x1_weights_6_28_inst_addr                             "0x03DF"
#define  set_SRNN_wdsr_layer3_1x1_weights_6_28_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_6_28_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_6_28_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_6_28_reg))
#define  SRNN_wdsr_layer3_1x1_weights_6_28_layer3_weight_28_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_6_28_layer3_weight_28_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_6_28_layer3_weight_28(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_6_28_get_layer3_weight_28(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_6_29                                      0x181ABEF0
#define  SRNN_wdsr_layer3_1x1_weights_6_29_reg_addr                              "0xB81ABEF0"
#define  SRNN_wdsr_layer3_1x1_weights_6_29_reg                                   0xB81ABEF0
#define  SRNN_wdsr_layer3_1x1_weights_6_29_inst_addr                             "0x03E0"
#define  set_SRNN_wdsr_layer3_1x1_weights_6_29_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_6_29_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_6_29_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_6_29_reg))
#define  SRNN_wdsr_layer3_1x1_weights_6_29_layer3_weight_29_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_6_29_layer3_weight_29_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_6_29_layer3_weight_29(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_6_29_get_layer3_weight_29(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_6_30                                      0x181ABEF4
#define  SRNN_wdsr_layer3_1x1_weights_6_30_reg_addr                              "0xB81ABEF4"
#define  SRNN_wdsr_layer3_1x1_weights_6_30_reg                                   0xB81ABEF4
#define  SRNN_wdsr_layer3_1x1_weights_6_30_inst_addr                             "0x03E1"
#define  set_SRNN_wdsr_layer3_1x1_weights_6_30_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_6_30_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_6_30_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_6_30_reg))
#define  SRNN_wdsr_layer3_1x1_weights_6_30_layer3_weight_30_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_6_30_layer3_weight_30_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_6_30_layer3_weight_30(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_6_30_get_layer3_weight_30(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_6_31                                      0x181ABEF8
#define  SRNN_wdsr_layer3_1x1_weights_6_31_reg_addr                              "0xB81ABEF8"
#define  SRNN_wdsr_layer3_1x1_weights_6_31_reg                                   0xB81ABEF8
#define  SRNN_wdsr_layer3_1x1_weights_6_31_inst_addr                             "0x03E2"
#define  set_SRNN_wdsr_layer3_1x1_weights_6_31_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_6_31_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_6_31_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_6_31_reg))
#define  SRNN_wdsr_layer3_1x1_weights_6_31_layer3_weight_31_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_6_31_layer3_weight_31_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_6_31_layer3_weight_31(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_6_31_get_layer3_weight_31(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_6_32                                      0x181ABEFC
#define  SRNN_wdsr_layer3_1x1_weights_6_32_reg_addr                              "0xB81ABEFC"
#define  SRNN_wdsr_layer3_1x1_weights_6_32_reg                                   0xB81ABEFC
#define  SRNN_wdsr_layer3_1x1_weights_6_32_inst_addr                             "0x03E3"
#define  set_SRNN_wdsr_layer3_1x1_weights_6_32_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_6_32_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_6_32_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_6_32_reg))
#define  SRNN_wdsr_layer3_1x1_weights_6_32_layer3_weight_32_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_6_32_layer3_weight_32_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_6_32_layer3_weight_32(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_6_32_get_layer3_weight_32(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_7_1                                       0x181ABF00
#define  SRNN_wdsr_layer3_1x1_weights_7_1_reg_addr                               "0xB81ABF00"
#define  SRNN_wdsr_layer3_1x1_weights_7_1_reg                                    0xB81ABF00
#define  SRNN_wdsr_layer3_1x1_weights_7_1_inst_addr                              "0x03E4"
#define  set_SRNN_wdsr_layer3_1x1_weights_7_1_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_7_1_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_7_1_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_7_1_reg))
#define  SRNN_wdsr_layer3_1x1_weights_7_1_layer3_weight_1_shift                  (0)
#define  SRNN_wdsr_layer3_1x1_weights_7_1_layer3_weight_1_mask                   (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_7_1_layer3_weight_1(data)                  (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_7_1_get_layer3_weight_1(data)              (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_7_2                                       0x181ABF04
#define  SRNN_wdsr_layer3_1x1_weights_7_2_reg_addr                               "0xB81ABF04"
#define  SRNN_wdsr_layer3_1x1_weights_7_2_reg                                    0xB81ABF04
#define  SRNN_wdsr_layer3_1x1_weights_7_2_inst_addr                              "0x03E5"
#define  set_SRNN_wdsr_layer3_1x1_weights_7_2_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_7_2_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_7_2_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_7_2_reg))
#define  SRNN_wdsr_layer3_1x1_weights_7_2_layer3_weight_2_shift                  (0)
#define  SRNN_wdsr_layer3_1x1_weights_7_2_layer3_weight_2_mask                   (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_7_2_layer3_weight_2(data)                  (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_7_2_get_layer3_weight_2(data)              (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_7_3                                       0x181ABF08
#define  SRNN_wdsr_layer3_1x1_weights_7_3_reg_addr                               "0xB81ABF08"
#define  SRNN_wdsr_layer3_1x1_weights_7_3_reg                                    0xB81ABF08
#define  SRNN_wdsr_layer3_1x1_weights_7_3_inst_addr                              "0x03E6"
#define  set_SRNN_wdsr_layer3_1x1_weights_7_3_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_7_3_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_7_3_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_7_3_reg))
#define  SRNN_wdsr_layer3_1x1_weights_7_3_layer3_weight_3_shift                  (0)
#define  SRNN_wdsr_layer3_1x1_weights_7_3_layer3_weight_3_mask                   (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_7_3_layer3_weight_3(data)                  (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_7_3_get_layer3_weight_3(data)              (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_7_4                                       0x181ABF0C
#define  SRNN_wdsr_layer3_1x1_weights_7_4_reg_addr                               "0xB81ABF0C"
#define  SRNN_wdsr_layer3_1x1_weights_7_4_reg                                    0xB81ABF0C
#define  SRNN_wdsr_layer3_1x1_weights_7_4_inst_addr                              "0x03E7"
#define  set_SRNN_wdsr_layer3_1x1_weights_7_4_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_7_4_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_7_4_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_7_4_reg))
#define  SRNN_wdsr_layer3_1x1_weights_7_4_layer3_weight_4_shift                  (0)
#define  SRNN_wdsr_layer3_1x1_weights_7_4_layer3_weight_4_mask                   (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_7_4_layer3_weight_4(data)                  (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_7_4_get_layer3_weight_4(data)              (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_7_5                                       0x181ABF10
#define  SRNN_wdsr_layer3_1x1_weights_7_5_reg_addr                               "0xB81ABF10"
#define  SRNN_wdsr_layer3_1x1_weights_7_5_reg                                    0xB81ABF10
#define  SRNN_wdsr_layer3_1x1_weights_7_5_inst_addr                              "0x03E8"
#define  set_SRNN_wdsr_layer3_1x1_weights_7_5_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_7_5_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_7_5_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_7_5_reg))
#define  SRNN_wdsr_layer3_1x1_weights_7_5_layer3_weight_5_shift                  (0)
#define  SRNN_wdsr_layer3_1x1_weights_7_5_layer3_weight_5_mask                   (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_7_5_layer3_weight_5(data)                  (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_7_5_get_layer3_weight_5(data)              (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_7_6                                       0x181ABF14
#define  SRNN_wdsr_layer3_1x1_weights_7_6_reg_addr                               "0xB81ABF14"
#define  SRNN_wdsr_layer3_1x1_weights_7_6_reg                                    0xB81ABF14
#define  SRNN_wdsr_layer3_1x1_weights_7_6_inst_addr                              "0x03E9"
#define  set_SRNN_wdsr_layer3_1x1_weights_7_6_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_7_6_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_7_6_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_7_6_reg))
#define  SRNN_wdsr_layer3_1x1_weights_7_6_layer3_weight_6_shift                  (0)
#define  SRNN_wdsr_layer3_1x1_weights_7_6_layer3_weight_6_mask                   (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_7_6_layer3_weight_6(data)                  (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_7_6_get_layer3_weight_6(data)              (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_7_7                                       0x181ABF18
#define  SRNN_wdsr_layer3_1x1_weights_7_7_reg_addr                               "0xB81ABF18"
#define  SRNN_wdsr_layer3_1x1_weights_7_7_reg                                    0xB81ABF18
#define  SRNN_wdsr_layer3_1x1_weights_7_7_inst_addr                              "0x03EA"
#define  set_SRNN_wdsr_layer3_1x1_weights_7_7_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_7_7_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_7_7_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_7_7_reg))
#define  SRNN_wdsr_layer3_1x1_weights_7_7_layer3_weight_7_shift                  (0)
#define  SRNN_wdsr_layer3_1x1_weights_7_7_layer3_weight_7_mask                   (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_7_7_layer3_weight_7(data)                  (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_7_7_get_layer3_weight_7(data)              (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_7_8                                       0x181ABF1C
#define  SRNN_wdsr_layer3_1x1_weights_7_8_reg_addr                               "0xB81ABF1C"
#define  SRNN_wdsr_layer3_1x1_weights_7_8_reg                                    0xB81ABF1C
#define  SRNN_wdsr_layer3_1x1_weights_7_8_inst_addr                              "0x03EB"
#define  set_SRNN_wdsr_layer3_1x1_weights_7_8_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_7_8_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_7_8_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_7_8_reg))
#define  SRNN_wdsr_layer3_1x1_weights_7_8_layer3_weight_8_shift                  (0)
#define  SRNN_wdsr_layer3_1x1_weights_7_8_layer3_weight_8_mask                   (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_7_8_layer3_weight_8(data)                  (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_7_8_get_layer3_weight_8(data)              (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_7_9                                       0x181ABF20
#define  SRNN_wdsr_layer3_1x1_weights_7_9_reg_addr                               "0xB81ABF20"
#define  SRNN_wdsr_layer3_1x1_weights_7_9_reg                                    0xB81ABF20
#define  SRNN_wdsr_layer3_1x1_weights_7_9_inst_addr                              "0x03EC"
#define  set_SRNN_wdsr_layer3_1x1_weights_7_9_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_7_9_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_7_9_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_7_9_reg))
#define  SRNN_wdsr_layer3_1x1_weights_7_9_layer3_weight_9_shift                  (0)
#define  SRNN_wdsr_layer3_1x1_weights_7_9_layer3_weight_9_mask                   (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_7_9_layer3_weight_9(data)                  (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_7_9_get_layer3_weight_9(data)              (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_7_10                                      0x181ABF24
#define  SRNN_wdsr_layer3_1x1_weights_7_10_reg_addr                              "0xB81ABF24"
#define  SRNN_wdsr_layer3_1x1_weights_7_10_reg                                   0xB81ABF24
#define  SRNN_wdsr_layer3_1x1_weights_7_10_inst_addr                             "0x03ED"
#define  set_SRNN_wdsr_layer3_1x1_weights_7_10_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_7_10_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_7_10_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_7_10_reg))
#define  SRNN_wdsr_layer3_1x1_weights_7_10_layer3_weight_10_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_7_10_layer3_weight_10_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_7_10_layer3_weight_10(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_7_10_get_layer3_weight_10(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_7_11                                      0x181ABF28
#define  SRNN_wdsr_layer3_1x1_weights_7_11_reg_addr                              "0xB81ABF28"
#define  SRNN_wdsr_layer3_1x1_weights_7_11_reg                                   0xB81ABF28
#define  SRNN_wdsr_layer3_1x1_weights_7_11_inst_addr                             "0x03EE"
#define  set_SRNN_wdsr_layer3_1x1_weights_7_11_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_7_11_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_7_11_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_7_11_reg))
#define  SRNN_wdsr_layer3_1x1_weights_7_11_layer3_weight_11_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_7_11_layer3_weight_11_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_7_11_layer3_weight_11(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_7_11_get_layer3_weight_11(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_7_12                                      0x181ABF2C
#define  SRNN_wdsr_layer3_1x1_weights_7_12_reg_addr                              "0xB81ABF2C"
#define  SRNN_wdsr_layer3_1x1_weights_7_12_reg                                   0xB81ABF2C
#define  SRNN_wdsr_layer3_1x1_weights_7_12_inst_addr                             "0x03EF"
#define  set_SRNN_wdsr_layer3_1x1_weights_7_12_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_7_12_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_7_12_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_7_12_reg))
#define  SRNN_wdsr_layer3_1x1_weights_7_12_layer3_weight_12_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_7_12_layer3_weight_12_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_7_12_layer3_weight_12(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_7_12_get_layer3_weight_12(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_7_13                                      0x181ABF30
#define  SRNN_wdsr_layer3_1x1_weights_7_13_reg_addr                              "0xB81ABF30"
#define  SRNN_wdsr_layer3_1x1_weights_7_13_reg                                   0xB81ABF30
#define  SRNN_wdsr_layer3_1x1_weights_7_13_inst_addr                             "0x03F0"
#define  set_SRNN_wdsr_layer3_1x1_weights_7_13_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_7_13_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_7_13_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_7_13_reg))
#define  SRNN_wdsr_layer3_1x1_weights_7_13_layer3_weight_13_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_7_13_layer3_weight_13_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_7_13_layer3_weight_13(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_7_13_get_layer3_weight_13(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_7_14                                      0x181ABF34
#define  SRNN_wdsr_layer3_1x1_weights_7_14_reg_addr                              "0xB81ABF34"
#define  SRNN_wdsr_layer3_1x1_weights_7_14_reg                                   0xB81ABF34
#define  SRNN_wdsr_layer3_1x1_weights_7_14_inst_addr                             "0x03F1"
#define  set_SRNN_wdsr_layer3_1x1_weights_7_14_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_7_14_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_7_14_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_7_14_reg))
#define  SRNN_wdsr_layer3_1x1_weights_7_14_layer3_weight_14_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_7_14_layer3_weight_14_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_7_14_layer3_weight_14(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_7_14_get_layer3_weight_14(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_7_15                                      0x181ABF38
#define  SRNN_wdsr_layer3_1x1_weights_7_15_reg_addr                              "0xB81ABF38"
#define  SRNN_wdsr_layer3_1x1_weights_7_15_reg                                   0xB81ABF38
#define  SRNN_wdsr_layer3_1x1_weights_7_15_inst_addr                             "0x03F2"
#define  set_SRNN_wdsr_layer3_1x1_weights_7_15_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_7_15_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_7_15_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_7_15_reg))
#define  SRNN_wdsr_layer3_1x1_weights_7_15_layer3_weight_15_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_7_15_layer3_weight_15_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_7_15_layer3_weight_15(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_7_15_get_layer3_weight_15(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_7_16                                      0x181ABF3C
#define  SRNN_wdsr_layer3_1x1_weights_7_16_reg_addr                              "0xB81ABF3C"
#define  SRNN_wdsr_layer3_1x1_weights_7_16_reg                                   0xB81ABF3C
#define  SRNN_wdsr_layer3_1x1_weights_7_16_inst_addr                             "0x03F3"
#define  set_SRNN_wdsr_layer3_1x1_weights_7_16_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_7_16_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_7_16_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_7_16_reg))
#define  SRNN_wdsr_layer3_1x1_weights_7_16_layer3_weight_16_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_7_16_layer3_weight_16_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_7_16_layer3_weight_16(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_7_16_get_layer3_weight_16(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_7_17                                      0x181ABF40
#define  SRNN_wdsr_layer3_1x1_weights_7_17_reg_addr                              "0xB81ABF40"
#define  SRNN_wdsr_layer3_1x1_weights_7_17_reg                                   0xB81ABF40
#define  SRNN_wdsr_layer3_1x1_weights_7_17_inst_addr                             "0x03F4"
#define  set_SRNN_wdsr_layer3_1x1_weights_7_17_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_7_17_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_7_17_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_7_17_reg))
#define  SRNN_wdsr_layer3_1x1_weights_7_17_layer3_weight_17_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_7_17_layer3_weight_17_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_7_17_layer3_weight_17(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_7_17_get_layer3_weight_17(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_7_18                                      0x181ABF44
#define  SRNN_wdsr_layer3_1x1_weights_7_18_reg_addr                              "0xB81ABF44"
#define  SRNN_wdsr_layer3_1x1_weights_7_18_reg                                   0xB81ABF44
#define  SRNN_wdsr_layer3_1x1_weights_7_18_inst_addr                             "0x03F5"
#define  set_SRNN_wdsr_layer3_1x1_weights_7_18_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_7_18_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_7_18_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_7_18_reg))
#define  SRNN_wdsr_layer3_1x1_weights_7_18_layer3_weight_18_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_7_18_layer3_weight_18_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_7_18_layer3_weight_18(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_7_18_get_layer3_weight_18(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_7_19                                      0x181ABF48
#define  SRNN_wdsr_layer3_1x1_weights_7_19_reg_addr                              "0xB81ABF48"
#define  SRNN_wdsr_layer3_1x1_weights_7_19_reg                                   0xB81ABF48
#define  SRNN_wdsr_layer3_1x1_weights_7_19_inst_addr                             "0x03F6"
#define  set_SRNN_wdsr_layer3_1x1_weights_7_19_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_7_19_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_7_19_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_7_19_reg))
#define  SRNN_wdsr_layer3_1x1_weights_7_19_layer3_weight_19_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_7_19_layer3_weight_19_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_7_19_layer3_weight_19(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_7_19_get_layer3_weight_19(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_7_20                                      0x181ABF4C
#define  SRNN_wdsr_layer3_1x1_weights_7_20_reg_addr                              "0xB81ABF4C"
#define  SRNN_wdsr_layer3_1x1_weights_7_20_reg                                   0xB81ABF4C
#define  SRNN_wdsr_layer3_1x1_weights_7_20_inst_addr                             "0x03F7"
#define  set_SRNN_wdsr_layer3_1x1_weights_7_20_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_7_20_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_7_20_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_7_20_reg))
#define  SRNN_wdsr_layer3_1x1_weights_7_20_layer3_weight_20_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_7_20_layer3_weight_20_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_7_20_layer3_weight_20(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_7_20_get_layer3_weight_20(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_7_21                                      0x181ABF50
#define  SRNN_wdsr_layer3_1x1_weights_7_21_reg_addr                              "0xB81ABF50"
#define  SRNN_wdsr_layer3_1x1_weights_7_21_reg                                   0xB81ABF50
#define  SRNN_wdsr_layer3_1x1_weights_7_21_inst_addr                             "0x03F8"
#define  set_SRNN_wdsr_layer3_1x1_weights_7_21_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_7_21_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_7_21_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_7_21_reg))
#define  SRNN_wdsr_layer3_1x1_weights_7_21_layer3_weight_21_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_7_21_layer3_weight_21_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_7_21_layer3_weight_21(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_7_21_get_layer3_weight_21(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_7_22                                      0x181ABF54
#define  SRNN_wdsr_layer3_1x1_weights_7_22_reg_addr                              "0xB81ABF54"
#define  SRNN_wdsr_layer3_1x1_weights_7_22_reg                                   0xB81ABF54
#define  SRNN_wdsr_layer3_1x1_weights_7_22_inst_addr                             "0x03F9"
#define  set_SRNN_wdsr_layer3_1x1_weights_7_22_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_7_22_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_7_22_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_7_22_reg))
#define  SRNN_wdsr_layer3_1x1_weights_7_22_layer3_weight_22_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_7_22_layer3_weight_22_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_7_22_layer3_weight_22(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_7_22_get_layer3_weight_22(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_7_23                                      0x181ABF58
#define  SRNN_wdsr_layer3_1x1_weights_7_23_reg_addr                              "0xB81ABF58"
#define  SRNN_wdsr_layer3_1x1_weights_7_23_reg                                   0xB81ABF58
#define  SRNN_wdsr_layer3_1x1_weights_7_23_inst_addr                             "0x03FA"
#define  set_SRNN_wdsr_layer3_1x1_weights_7_23_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_7_23_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_7_23_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_7_23_reg))
#define  SRNN_wdsr_layer3_1x1_weights_7_23_layer3_weight_23_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_7_23_layer3_weight_23_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_7_23_layer3_weight_23(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_7_23_get_layer3_weight_23(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_7_24                                      0x181ABF5C
#define  SRNN_wdsr_layer3_1x1_weights_7_24_reg_addr                              "0xB81ABF5C"
#define  SRNN_wdsr_layer3_1x1_weights_7_24_reg                                   0xB81ABF5C
#define  SRNN_wdsr_layer3_1x1_weights_7_24_inst_addr                             "0x03FB"
#define  set_SRNN_wdsr_layer3_1x1_weights_7_24_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_7_24_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_7_24_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_7_24_reg))
#define  SRNN_wdsr_layer3_1x1_weights_7_24_layer3_weight_24_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_7_24_layer3_weight_24_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_7_24_layer3_weight_24(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_7_24_get_layer3_weight_24(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_7_25                                      0x181ABF60
#define  SRNN_wdsr_layer3_1x1_weights_7_25_reg_addr                              "0xB81ABF60"
#define  SRNN_wdsr_layer3_1x1_weights_7_25_reg                                   0xB81ABF60
#define  SRNN_wdsr_layer3_1x1_weights_7_25_inst_addr                             "0x03FC"
#define  set_SRNN_wdsr_layer3_1x1_weights_7_25_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_7_25_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_7_25_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_7_25_reg))
#define  SRNN_wdsr_layer3_1x1_weights_7_25_layer3_weight_25_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_7_25_layer3_weight_25_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_7_25_layer3_weight_25(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_7_25_get_layer3_weight_25(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_7_26                                      0x181ABF64
#define  SRNN_wdsr_layer3_1x1_weights_7_26_reg_addr                              "0xB81ABF64"
#define  SRNN_wdsr_layer3_1x1_weights_7_26_reg                                   0xB81ABF64
#define  SRNN_wdsr_layer3_1x1_weights_7_26_inst_addr                             "0x03FD"
#define  set_SRNN_wdsr_layer3_1x1_weights_7_26_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_7_26_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_7_26_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_7_26_reg))
#define  SRNN_wdsr_layer3_1x1_weights_7_26_layer3_weight_26_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_7_26_layer3_weight_26_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_7_26_layer3_weight_26(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_7_26_get_layer3_weight_26(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_7_27                                      0x181ABF68
#define  SRNN_wdsr_layer3_1x1_weights_7_27_reg_addr                              "0xB81ABF68"
#define  SRNN_wdsr_layer3_1x1_weights_7_27_reg                                   0xB81ABF68
#define  SRNN_wdsr_layer3_1x1_weights_7_27_inst_addr                             "0x03FE"
#define  set_SRNN_wdsr_layer3_1x1_weights_7_27_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_7_27_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_7_27_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_7_27_reg))
#define  SRNN_wdsr_layer3_1x1_weights_7_27_layer3_weight_27_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_7_27_layer3_weight_27_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_7_27_layer3_weight_27(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_7_27_get_layer3_weight_27(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_7_28                                      0x181ABF6C
#define  SRNN_wdsr_layer3_1x1_weights_7_28_reg_addr                              "0xB81ABF6C"
#define  SRNN_wdsr_layer3_1x1_weights_7_28_reg                                   0xB81ABF6C
#define  SRNN_wdsr_layer3_1x1_weights_7_28_inst_addr                             "0x03FF"
#define  set_SRNN_wdsr_layer3_1x1_weights_7_28_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_7_28_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_7_28_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_7_28_reg))
#define  SRNN_wdsr_layer3_1x1_weights_7_28_layer3_weight_28_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_7_28_layer3_weight_28_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_7_28_layer3_weight_28(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_7_28_get_layer3_weight_28(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_7_29                                      0x181ABF70
#define  SRNN_wdsr_layer3_1x1_weights_7_29_reg_addr                              "0xB81ABF70"
#define  SRNN_wdsr_layer3_1x1_weights_7_29_reg                                   0xB81ABF70
#define  SRNN_wdsr_layer3_1x1_weights_7_29_inst_addr                             "0x0400"
#define  set_SRNN_wdsr_layer3_1x1_weights_7_29_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_7_29_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_7_29_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_7_29_reg))
#define  SRNN_wdsr_layer3_1x1_weights_7_29_layer3_weight_29_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_7_29_layer3_weight_29_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_7_29_layer3_weight_29(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_7_29_get_layer3_weight_29(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_7_30                                      0x181ABF74
#define  SRNN_wdsr_layer3_1x1_weights_7_30_reg_addr                              "0xB81ABF74"
#define  SRNN_wdsr_layer3_1x1_weights_7_30_reg                                   0xB81ABF74
#define  SRNN_wdsr_layer3_1x1_weights_7_30_inst_addr                             "0x0401"
#define  set_SRNN_wdsr_layer3_1x1_weights_7_30_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_7_30_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_7_30_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_7_30_reg))
#define  SRNN_wdsr_layer3_1x1_weights_7_30_layer3_weight_30_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_7_30_layer3_weight_30_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_7_30_layer3_weight_30(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_7_30_get_layer3_weight_30(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_7_31                                      0x181ABF78
#define  SRNN_wdsr_layer3_1x1_weights_7_31_reg_addr                              "0xB81ABF78"
#define  SRNN_wdsr_layer3_1x1_weights_7_31_reg                                   0xB81ABF78
#define  SRNN_wdsr_layer3_1x1_weights_7_31_inst_addr                             "0x0402"
#define  set_SRNN_wdsr_layer3_1x1_weights_7_31_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_7_31_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_7_31_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_7_31_reg))
#define  SRNN_wdsr_layer3_1x1_weights_7_31_layer3_weight_31_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_7_31_layer3_weight_31_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_7_31_layer3_weight_31(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_7_31_get_layer3_weight_31(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_7_32                                      0x181ABF7C
#define  SRNN_wdsr_layer3_1x1_weights_7_32_reg_addr                              "0xB81ABF7C"
#define  SRNN_wdsr_layer3_1x1_weights_7_32_reg                                   0xB81ABF7C
#define  SRNN_wdsr_layer3_1x1_weights_7_32_inst_addr                             "0x0403"
#define  set_SRNN_wdsr_layer3_1x1_weights_7_32_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_7_32_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_7_32_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_7_32_reg))
#define  SRNN_wdsr_layer3_1x1_weights_7_32_layer3_weight_32_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_7_32_layer3_weight_32_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_7_32_layer3_weight_32(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_7_32_get_layer3_weight_32(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_8_1                                       0x181ABF80
#define  SRNN_wdsr_layer3_1x1_weights_8_1_reg_addr                               "0xB81ABF80"
#define  SRNN_wdsr_layer3_1x1_weights_8_1_reg                                    0xB81ABF80
#define  SRNN_wdsr_layer3_1x1_weights_8_1_inst_addr                              "0x0404"
#define  set_SRNN_wdsr_layer3_1x1_weights_8_1_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_8_1_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_8_1_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_8_1_reg))
#define  SRNN_wdsr_layer3_1x1_weights_8_1_layer3_weight_1_shift                  (0)
#define  SRNN_wdsr_layer3_1x1_weights_8_1_layer3_weight_1_mask                   (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_8_1_layer3_weight_1(data)                  (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_8_1_get_layer3_weight_1(data)              (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_8_2                                       0x181ABF84
#define  SRNN_wdsr_layer3_1x1_weights_8_2_reg_addr                               "0xB81ABF84"
#define  SRNN_wdsr_layer3_1x1_weights_8_2_reg                                    0xB81ABF84
#define  SRNN_wdsr_layer3_1x1_weights_8_2_inst_addr                              "0x0405"
#define  set_SRNN_wdsr_layer3_1x1_weights_8_2_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_8_2_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_8_2_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_8_2_reg))
#define  SRNN_wdsr_layer3_1x1_weights_8_2_layer3_weight_2_shift                  (0)
#define  SRNN_wdsr_layer3_1x1_weights_8_2_layer3_weight_2_mask                   (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_8_2_layer3_weight_2(data)                  (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_8_2_get_layer3_weight_2(data)              (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_8_3                                       0x181ABF88
#define  SRNN_wdsr_layer3_1x1_weights_8_3_reg_addr                               "0xB81ABF88"
#define  SRNN_wdsr_layer3_1x1_weights_8_3_reg                                    0xB81ABF88
#define  SRNN_wdsr_layer3_1x1_weights_8_3_inst_addr                              "0x0406"
#define  set_SRNN_wdsr_layer3_1x1_weights_8_3_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_8_3_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_8_3_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_8_3_reg))
#define  SRNN_wdsr_layer3_1x1_weights_8_3_layer3_weight_3_shift                  (0)
#define  SRNN_wdsr_layer3_1x1_weights_8_3_layer3_weight_3_mask                   (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_8_3_layer3_weight_3(data)                  (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_8_3_get_layer3_weight_3(data)              (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_8_4                                       0x181ABF8C
#define  SRNN_wdsr_layer3_1x1_weights_8_4_reg_addr                               "0xB81ABF8C"
#define  SRNN_wdsr_layer3_1x1_weights_8_4_reg                                    0xB81ABF8C
#define  SRNN_wdsr_layer3_1x1_weights_8_4_inst_addr                              "0x0407"
#define  set_SRNN_wdsr_layer3_1x1_weights_8_4_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_8_4_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_8_4_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_8_4_reg))
#define  SRNN_wdsr_layer3_1x1_weights_8_4_layer3_weight_4_shift                  (0)
#define  SRNN_wdsr_layer3_1x1_weights_8_4_layer3_weight_4_mask                   (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_8_4_layer3_weight_4(data)                  (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_8_4_get_layer3_weight_4(data)              (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_8_5                                       0x181ABF90
#define  SRNN_wdsr_layer3_1x1_weights_8_5_reg_addr                               "0xB81ABF90"
#define  SRNN_wdsr_layer3_1x1_weights_8_5_reg                                    0xB81ABF90
#define  SRNN_wdsr_layer3_1x1_weights_8_5_inst_addr                              "0x0408"
#define  set_SRNN_wdsr_layer3_1x1_weights_8_5_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_8_5_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_8_5_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_8_5_reg))
#define  SRNN_wdsr_layer3_1x1_weights_8_5_layer3_weight_5_shift                  (0)
#define  SRNN_wdsr_layer3_1x1_weights_8_5_layer3_weight_5_mask                   (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_8_5_layer3_weight_5(data)                  (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_8_5_get_layer3_weight_5(data)              (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_8_6                                       0x181ABF94
#define  SRNN_wdsr_layer3_1x1_weights_8_6_reg_addr                               "0xB81ABF94"
#define  SRNN_wdsr_layer3_1x1_weights_8_6_reg                                    0xB81ABF94
#define  SRNN_wdsr_layer3_1x1_weights_8_6_inst_addr                              "0x0409"
#define  set_SRNN_wdsr_layer3_1x1_weights_8_6_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_8_6_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_8_6_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_8_6_reg))
#define  SRNN_wdsr_layer3_1x1_weights_8_6_layer3_weight_6_shift                  (0)
#define  SRNN_wdsr_layer3_1x1_weights_8_6_layer3_weight_6_mask                   (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_8_6_layer3_weight_6(data)                  (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_8_6_get_layer3_weight_6(data)              (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_8_7                                       0x181ABF98
#define  SRNN_wdsr_layer3_1x1_weights_8_7_reg_addr                               "0xB81ABF98"
#define  SRNN_wdsr_layer3_1x1_weights_8_7_reg                                    0xB81ABF98
#define  SRNN_wdsr_layer3_1x1_weights_8_7_inst_addr                              "0x040A"
#define  set_SRNN_wdsr_layer3_1x1_weights_8_7_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_8_7_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_8_7_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_8_7_reg))
#define  SRNN_wdsr_layer3_1x1_weights_8_7_layer3_weight_7_shift                  (0)
#define  SRNN_wdsr_layer3_1x1_weights_8_7_layer3_weight_7_mask                   (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_8_7_layer3_weight_7(data)                  (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_8_7_get_layer3_weight_7(data)              (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_8_8                                       0x181ABF9C
#define  SRNN_wdsr_layer3_1x1_weights_8_8_reg_addr                               "0xB81ABF9C"
#define  SRNN_wdsr_layer3_1x1_weights_8_8_reg                                    0xB81ABF9C
#define  SRNN_wdsr_layer3_1x1_weights_8_8_inst_addr                              "0x040B"
#define  set_SRNN_wdsr_layer3_1x1_weights_8_8_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_8_8_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_8_8_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_8_8_reg))
#define  SRNN_wdsr_layer3_1x1_weights_8_8_layer3_weight_8_shift                  (0)
#define  SRNN_wdsr_layer3_1x1_weights_8_8_layer3_weight_8_mask                   (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_8_8_layer3_weight_8(data)                  (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_8_8_get_layer3_weight_8(data)              (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_8_9                                       0x181ABFA0
#define  SRNN_wdsr_layer3_1x1_weights_8_9_reg_addr                               "0xB81ABFA0"
#define  SRNN_wdsr_layer3_1x1_weights_8_9_reg                                    0xB81ABFA0
#define  SRNN_wdsr_layer3_1x1_weights_8_9_inst_addr                              "0x040C"
#define  set_SRNN_wdsr_layer3_1x1_weights_8_9_reg(data)                          (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_8_9_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_8_9_reg                                (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_8_9_reg))
#define  SRNN_wdsr_layer3_1x1_weights_8_9_layer3_weight_9_shift                  (0)
#define  SRNN_wdsr_layer3_1x1_weights_8_9_layer3_weight_9_mask                   (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_8_9_layer3_weight_9(data)                  (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_8_9_get_layer3_weight_9(data)              (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_8_10                                      0x181ABFA4
#define  SRNN_wdsr_layer3_1x1_weights_8_10_reg_addr                              "0xB81ABFA4"
#define  SRNN_wdsr_layer3_1x1_weights_8_10_reg                                   0xB81ABFA4
#define  SRNN_wdsr_layer3_1x1_weights_8_10_inst_addr                             "0x040D"
#define  set_SRNN_wdsr_layer3_1x1_weights_8_10_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_8_10_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_8_10_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_8_10_reg))
#define  SRNN_wdsr_layer3_1x1_weights_8_10_layer3_weight_10_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_8_10_layer3_weight_10_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_8_10_layer3_weight_10(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_8_10_get_layer3_weight_10(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_8_11                                      0x181ABFA8
#define  SRNN_wdsr_layer3_1x1_weights_8_11_reg_addr                              "0xB81ABFA8"
#define  SRNN_wdsr_layer3_1x1_weights_8_11_reg                                   0xB81ABFA8
#define  SRNN_wdsr_layer3_1x1_weights_8_11_inst_addr                             "0x040E"
#define  set_SRNN_wdsr_layer3_1x1_weights_8_11_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_8_11_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_8_11_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_8_11_reg))
#define  SRNN_wdsr_layer3_1x1_weights_8_11_layer3_weight_11_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_8_11_layer3_weight_11_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_8_11_layer3_weight_11(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_8_11_get_layer3_weight_11(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_8_12                                      0x181ABFAC
#define  SRNN_wdsr_layer3_1x1_weights_8_12_reg_addr                              "0xB81ABFAC"
#define  SRNN_wdsr_layer3_1x1_weights_8_12_reg                                   0xB81ABFAC
#define  SRNN_wdsr_layer3_1x1_weights_8_12_inst_addr                             "0x040F"
#define  set_SRNN_wdsr_layer3_1x1_weights_8_12_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_8_12_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_8_12_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_8_12_reg))
#define  SRNN_wdsr_layer3_1x1_weights_8_12_layer3_weight_12_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_8_12_layer3_weight_12_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_8_12_layer3_weight_12(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_8_12_get_layer3_weight_12(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_8_13                                      0x181ABFB0
#define  SRNN_wdsr_layer3_1x1_weights_8_13_reg_addr                              "0xB81ABFB0"
#define  SRNN_wdsr_layer3_1x1_weights_8_13_reg                                   0xB81ABFB0
#define  SRNN_wdsr_layer3_1x1_weights_8_13_inst_addr                             "0x0410"
#define  set_SRNN_wdsr_layer3_1x1_weights_8_13_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_8_13_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_8_13_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_8_13_reg))
#define  SRNN_wdsr_layer3_1x1_weights_8_13_layer3_weight_13_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_8_13_layer3_weight_13_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_8_13_layer3_weight_13(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_8_13_get_layer3_weight_13(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_8_14                                      0x181ABFB4
#define  SRNN_wdsr_layer3_1x1_weights_8_14_reg_addr                              "0xB81ABFB4"
#define  SRNN_wdsr_layer3_1x1_weights_8_14_reg                                   0xB81ABFB4
#define  SRNN_wdsr_layer3_1x1_weights_8_14_inst_addr                             "0x0411"
#define  set_SRNN_wdsr_layer3_1x1_weights_8_14_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_8_14_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_8_14_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_8_14_reg))
#define  SRNN_wdsr_layer3_1x1_weights_8_14_layer3_weight_14_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_8_14_layer3_weight_14_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_8_14_layer3_weight_14(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_8_14_get_layer3_weight_14(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_8_15                                      0x181ABFB8
#define  SRNN_wdsr_layer3_1x1_weights_8_15_reg_addr                              "0xB81ABFB8"
#define  SRNN_wdsr_layer3_1x1_weights_8_15_reg                                   0xB81ABFB8
#define  SRNN_wdsr_layer3_1x1_weights_8_15_inst_addr                             "0x0412"
#define  set_SRNN_wdsr_layer3_1x1_weights_8_15_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_8_15_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_8_15_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_8_15_reg))
#define  SRNN_wdsr_layer3_1x1_weights_8_15_layer3_weight_15_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_8_15_layer3_weight_15_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_8_15_layer3_weight_15(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_8_15_get_layer3_weight_15(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_8_16                                      0x181ABFBC
#define  SRNN_wdsr_layer3_1x1_weights_8_16_reg_addr                              "0xB81ABFBC"
#define  SRNN_wdsr_layer3_1x1_weights_8_16_reg                                   0xB81ABFBC
#define  SRNN_wdsr_layer3_1x1_weights_8_16_inst_addr                             "0x0413"
#define  set_SRNN_wdsr_layer3_1x1_weights_8_16_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_8_16_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_8_16_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_8_16_reg))
#define  SRNN_wdsr_layer3_1x1_weights_8_16_layer3_weight_16_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_8_16_layer3_weight_16_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_8_16_layer3_weight_16(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_8_16_get_layer3_weight_16(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_8_17                                      0x181ABFC0
#define  SRNN_wdsr_layer3_1x1_weights_8_17_reg_addr                              "0xB81ABFC0"
#define  SRNN_wdsr_layer3_1x1_weights_8_17_reg                                   0xB81ABFC0
#define  SRNN_wdsr_layer3_1x1_weights_8_17_inst_addr                             "0x0414"
#define  set_SRNN_wdsr_layer3_1x1_weights_8_17_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_8_17_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_8_17_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_8_17_reg))
#define  SRNN_wdsr_layer3_1x1_weights_8_17_layer3_weight_17_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_8_17_layer3_weight_17_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_8_17_layer3_weight_17(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_8_17_get_layer3_weight_17(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_8_18                                      0x181ABFC4
#define  SRNN_wdsr_layer3_1x1_weights_8_18_reg_addr                              "0xB81ABFC4"
#define  SRNN_wdsr_layer3_1x1_weights_8_18_reg                                   0xB81ABFC4
#define  SRNN_wdsr_layer3_1x1_weights_8_18_inst_addr                             "0x0415"
#define  set_SRNN_wdsr_layer3_1x1_weights_8_18_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_8_18_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_8_18_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_8_18_reg))
#define  SRNN_wdsr_layer3_1x1_weights_8_18_layer3_weight_18_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_8_18_layer3_weight_18_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_8_18_layer3_weight_18(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_8_18_get_layer3_weight_18(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_8_19                                      0x181ABFC8
#define  SRNN_wdsr_layer3_1x1_weights_8_19_reg_addr                              "0xB81ABFC8"
#define  SRNN_wdsr_layer3_1x1_weights_8_19_reg                                   0xB81ABFC8
#define  SRNN_wdsr_layer3_1x1_weights_8_19_inst_addr                             "0x0416"
#define  set_SRNN_wdsr_layer3_1x1_weights_8_19_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_8_19_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_8_19_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_8_19_reg))
#define  SRNN_wdsr_layer3_1x1_weights_8_19_layer3_weight_19_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_8_19_layer3_weight_19_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_8_19_layer3_weight_19(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_8_19_get_layer3_weight_19(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_8_20                                      0x181ABFCC
#define  SRNN_wdsr_layer3_1x1_weights_8_20_reg_addr                              "0xB81ABFCC"
#define  SRNN_wdsr_layer3_1x1_weights_8_20_reg                                   0xB81ABFCC
#define  SRNN_wdsr_layer3_1x1_weights_8_20_inst_addr                             "0x0417"
#define  set_SRNN_wdsr_layer3_1x1_weights_8_20_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_8_20_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_8_20_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_8_20_reg))
#define  SRNN_wdsr_layer3_1x1_weights_8_20_layer3_weight_20_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_8_20_layer3_weight_20_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_8_20_layer3_weight_20(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_8_20_get_layer3_weight_20(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_8_21                                      0x181ABFD0
#define  SRNN_wdsr_layer3_1x1_weights_8_21_reg_addr                              "0xB81ABFD0"
#define  SRNN_wdsr_layer3_1x1_weights_8_21_reg                                   0xB81ABFD0
#define  SRNN_wdsr_layer3_1x1_weights_8_21_inst_addr                             "0x0418"
#define  set_SRNN_wdsr_layer3_1x1_weights_8_21_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_8_21_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_8_21_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_8_21_reg))
#define  SRNN_wdsr_layer3_1x1_weights_8_21_layer3_weight_21_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_8_21_layer3_weight_21_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_8_21_layer3_weight_21(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_8_21_get_layer3_weight_21(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_8_22                                      0x181ABFD4
#define  SRNN_wdsr_layer3_1x1_weights_8_22_reg_addr                              "0xB81ABFD4"
#define  SRNN_wdsr_layer3_1x1_weights_8_22_reg                                   0xB81ABFD4
#define  SRNN_wdsr_layer3_1x1_weights_8_22_inst_addr                             "0x0419"
#define  set_SRNN_wdsr_layer3_1x1_weights_8_22_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_8_22_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_8_22_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_8_22_reg))
#define  SRNN_wdsr_layer3_1x1_weights_8_22_layer3_weight_22_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_8_22_layer3_weight_22_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_8_22_layer3_weight_22(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_8_22_get_layer3_weight_22(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_8_23                                      0x181ABFD8
#define  SRNN_wdsr_layer3_1x1_weights_8_23_reg_addr                              "0xB81ABFD8"
#define  SRNN_wdsr_layer3_1x1_weights_8_23_reg                                   0xB81ABFD8
#define  SRNN_wdsr_layer3_1x1_weights_8_23_inst_addr                             "0x041A"
#define  set_SRNN_wdsr_layer3_1x1_weights_8_23_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_8_23_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_8_23_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_8_23_reg))
#define  SRNN_wdsr_layer3_1x1_weights_8_23_layer3_weight_23_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_8_23_layer3_weight_23_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_8_23_layer3_weight_23(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_8_23_get_layer3_weight_23(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_8_24                                      0x181ABFDC
#define  SRNN_wdsr_layer3_1x1_weights_8_24_reg_addr                              "0xB81ABFDC"
#define  SRNN_wdsr_layer3_1x1_weights_8_24_reg                                   0xB81ABFDC
#define  SRNN_wdsr_layer3_1x1_weights_8_24_inst_addr                             "0x041B"
#define  set_SRNN_wdsr_layer3_1x1_weights_8_24_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_8_24_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_8_24_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_8_24_reg))
#define  SRNN_wdsr_layer3_1x1_weights_8_24_layer3_weight_24_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_8_24_layer3_weight_24_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_8_24_layer3_weight_24(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_8_24_get_layer3_weight_24(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_8_25                                      0x181ABFE0
#define  SRNN_wdsr_layer3_1x1_weights_8_25_reg_addr                              "0xB81ABFE0"
#define  SRNN_wdsr_layer3_1x1_weights_8_25_reg                                   0xB81ABFE0
#define  SRNN_wdsr_layer3_1x1_weights_8_25_inst_addr                             "0x041C"
#define  set_SRNN_wdsr_layer3_1x1_weights_8_25_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_8_25_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_8_25_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_8_25_reg))
#define  SRNN_wdsr_layer3_1x1_weights_8_25_layer3_weight_25_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_8_25_layer3_weight_25_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_8_25_layer3_weight_25(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_8_25_get_layer3_weight_25(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_8_26                                      0x181ABFE4
#define  SRNN_wdsr_layer3_1x1_weights_8_26_reg_addr                              "0xB81ABFE4"
#define  SRNN_wdsr_layer3_1x1_weights_8_26_reg                                   0xB81ABFE4
#define  SRNN_wdsr_layer3_1x1_weights_8_26_inst_addr                             "0x041D"
#define  set_SRNN_wdsr_layer3_1x1_weights_8_26_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_8_26_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_8_26_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_8_26_reg))
#define  SRNN_wdsr_layer3_1x1_weights_8_26_layer3_weight_26_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_8_26_layer3_weight_26_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_8_26_layer3_weight_26(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_8_26_get_layer3_weight_26(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_8_27                                      0x181ABFE8
#define  SRNN_wdsr_layer3_1x1_weights_8_27_reg_addr                              "0xB81ABFE8"
#define  SRNN_wdsr_layer3_1x1_weights_8_27_reg                                   0xB81ABFE8
#define  SRNN_wdsr_layer3_1x1_weights_8_27_inst_addr                             "0x041E"
#define  set_SRNN_wdsr_layer3_1x1_weights_8_27_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_8_27_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_8_27_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_8_27_reg))
#define  SRNN_wdsr_layer3_1x1_weights_8_27_layer3_weight_27_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_8_27_layer3_weight_27_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_8_27_layer3_weight_27(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_8_27_get_layer3_weight_27(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_8_28                                      0x181ABFEC
#define  SRNN_wdsr_layer3_1x1_weights_8_28_reg_addr                              "0xB81ABFEC"
#define  SRNN_wdsr_layer3_1x1_weights_8_28_reg                                   0xB81ABFEC
#define  SRNN_wdsr_layer3_1x1_weights_8_28_inst_addr                             "0x041F"
#define  set_SRNN_wdsr_layer3_1x1_weights_8_28_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_8_28_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_8_28_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_8_28_reg))
#define  SRNN_wdsr_layer3_1x1_weights_8_28_layer3_weight_28_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_8_28_layer3_weight_28_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_8_28_layer3_weight_28(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_8_28_get_layer3_weight_28(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_8_29                                      0x181ABFF0
#define  SRNN_wdsr_layer3_1x1_weights_8_29_reg_addr                              "0xB81ABFF0"
#define  SRNN_wdsr_layer3_1x1_weights_8_29_reg                                   0xB81ABFF0
#define  SRNN_wdsr_layer3_1x1_weights_8_29_inst_addr                             "0x0420"
#define  set_SRNN_wdsr_layer3_1x1_weights_8_29_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_8_29_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_8_29_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_8_29_reg))
#define  SRNN_wdsr_layer3_1x1_weights_8_29_layer3_weight_29_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_8_29_layer3_weight_29_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_8_29_layer3_weight_29(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_8_29_get_layer3_weight_29(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_8_30                                      0x181ABFF4
#define  SRNN_wdsr_layer3_1x1_weights_8_30_reg_addr                              "0xB81ABFF4"
#define  SRNN_wdsr_layer3_1x1_weights_8_30_reg                                   0xB81ABFF4
#define  SRNN_wdsr_layer3_1x1_weights_8_30_inst_addr                             "0x0421"
#define  set_SRNN_wdsr_layer3_1x1_weights_8_30_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_8_30_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_8_30_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_8_30_reg))
#define  SRNN_wdsr_layer3_1x1_weights_8_30_layer3_weight_30_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_8_30_layer3_weight_30_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_8_30_layer3_weight_30(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_8_30_get_layer3_weight_30(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_8_31                                      0x181ABFF8
#define  SRNN_wdsr_layer3_1x1_weights_8_31_reg_addr                              "0xB81ABFF8"
#define  SRNN_wdsr_layer3_1x1_weights_8_31_reg                                   0xB81ABFF8
#define  SRNN_wdsr_layer3_1x1_weights_8_31_inst_addr                             "0x0422"
#define  set_SRNN_wdsr_layer3_1x1_weights_8_31_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_8_31_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_8_31_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_8_31_reg))
#define  SRNN_wdsr_layer3_1x1_weights_8_31_layer3_weight_31_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_8_31_layer3_weight_31_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_8_31_layer3_weight_31(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_8_31_get_layer3_weight_31(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_weights_8_32                                      0x181ABFFC
#define  SRNN_wdsr_layer3_1x1_weights_8_32_reg_addr                              "0xB81ABFFC"
#define  SRNN_wdsr_layer3_1x1_weights_8_32_reg                                   0xB81ABFFC
#define  SRNN_wdsr_layer3_1x1_weights_8_32_inst_addr                             "0x0423"
#define  set_SRNN_wdsr_layer3_1x1_weights_8_32_reg(data)                         (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_8_32_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_weights_8_32_reg                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_weights_8_32_reg))
#define  SRNN_wdsr_layer3_1x1_weights_8_32_layer3_weight_32_shift                (0)
#define  SRNN_wdsr_layer3_1x1_weights_8_32_layer3_weight_32_mask                 (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_weights_8_32_layer3_weight_32(data)                (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_weights_8_32_get_layer3_weight_32(data)            (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_bias_1                                            0x181AC000
#define  SRNN_wdsr_layer3_1x1_bias_1_reg_addr                                    "0xB81AC000"
#define  SRNN_wdsr_layer3_1x1_bias_1_reg                                         0xB81AC000
#define  SRNN_wdsr_layer3_1x1_bias_1_inst_addr                                   "0x0424"
#define  set_SRNN_wdsr_layer3_1x1_bias_1_reg(data)                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_bias_1_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_bias_1_reg                                     (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_bias_1_reg))
#define  SRNN_wdsr_layer3_1x1_bias_1_layer3_bias_1_shift                         (0)
#define  SRNN_wdsr_layer3_1x1_bias_1_layer3_bias_1_mask                          (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_bias_1_layer3_bias_1(data)                         (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_bias_1_get_layer3_bias_1(data)                     (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_bias_2                                            0x181AC004
#define  SRNN_wdsr_layer3_1x1_bias_2_reg_addr                                    "0xB81AC004"
#define  SRNN_wdsr_layer3_1x1_bias_2_reg                                         0xB81AC004
#define  SRNN_wdsr_layer3_1x1_bias_2_inst_addr                                   "0x0425"
#define  set_SRNN_wdsr_layer3_1x1_bias_2_reg(data)                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_bias_2_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_bias_2_reg                                     (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_bias_2_reg))
#define  SRNN_wdsr_layer3_1x1_bias_2_layer3_bias_2_shift                         (0)
#define  SRNN_wdsr_layer3_1x1_bias_2_layer3_bias_2_mask                          (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_bias_2_layer3_bias_2(data)                         (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_bias_2_get_layer3_bias_2(data)                     (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_bias_3                                            0x181AC008
#define  SRNN_wdsr_layer3_1x1_bias_3_reg_addr                                    "0xB81AC008"
#define  SRNN_wdsr_layer3_1x1_bias_3_reg                                         0xB81AC008
#define  SRNN_wdsr_layer3_1x1_bias_3_inst_addr                                   "0x0426"
#define  set_SRNN_wdsr_layer3_1x1_bias_3_reg(data)                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_bias_3_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_bias_3_reg                                     (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_bias_3_reg))
#define  SRNN_wdsr_layer3_1x1_bias_3_layer3_bias_3_shift                         (0)
#define  SRNN_wdsr_layer3_1x1_bias_3_layer3_bias_3_mask                          (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_bias_3_layer3_bias_3(data)                         (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_bias_3_get_layer3_bias_3(data)                     (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_bias_4                                            0x181AC00C
#define  SRNN_wdsr_layer3_1x1_bias_4_reg_addr                                    "0xB81AC00C"
#define  SRNN_wdsr_layer3_1x1_bias_4_reg                                         0xB81AC00C
#define  SRNN_wdsr_layer3_1x1_bias_4_inst_addr                                   "0x0427"
#define  set_SRNN_wdsr_layer3_1x1_bias_4_reg(data)                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_bias_4_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_bias_4_reg                                     (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_bias_4_reg))
#define  SRNN_wdsr_layer3_1x1_bias_4_layer3_bias_4_shift                         (0)
#define  SRNN_wdsr_layer3_1x1_bias_4_layer3_bias_4_mask                          (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_bias_4_layer3_bias_4(data)                         (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_bias_4_get_layer3_bias_4(data)                     (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_bias_5                                            0x181AC010
#define  SRNN_wdsr_layer3_1x1_bias_5_reg_addr                                    "0xB81AC010"
#define  SRNN_wdsr_layer3_1x1_bias_5_reg                                         0xB81AC010
#define  SRNN_wdsr_layer3_1x1_bias_5_inst_addr                                   "0x0428"
#define  set_SRNN_wdsr_layer3_1x1_bias_5_reg(data)                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_bias_5_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_bias_5_reg                                     (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_bias_5_reg))
#define  SRNN_wdsr_layer3_1x1_bias_5_layer3_bias_5_shift                         (0)
#define  SRNN_wdsr_layer3_1x1_bias_5_layer3_bias_5_mask                          (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_bias_5_layer3_bias_5(data)                         (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_bias_5_get_layer3_bias_5(data)                     (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_bias_6                                            0x181AC014
#define  SRNN_wdsr_layer3_1x1_bias_6_reg_addr                                    "0xB81AC014"
#define  SRNN_wdsr_layer3_1x1_bias_6_reg                                         0xB81AC014
#define  SRNN_wdsr_layer3_1x1_bias_6_inst_addr                                   "0x0429"
#define  set_SRNN_wdsr_layer3_1x1_bias_6_reg(data)                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_bias_6_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_bias_6_reg                                     (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_bias_6_reg))
#define  SRNN_wdsr_layer3_1x1_bias_6_layer3_bias_6_shift                         (0)
#define  SRNN_wdsr_layer3_1x1_bias_6_layer3_bias_6_mask                          (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_bias_6_layer3_bias_6(data)                         (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_bias_6_get_layer3_bias_6(data)                     (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_bias_7                                            0x181AC018
#define  SRNN_wdsr_layer3_1x1_bias_7_reg_addr                                    "0xB81AC018"
#define  SRNN_wdsr_layer3_1x1_bias_7_reg                                         0xB81AC018
#define  SRNN_wdsr_layer3_1x1_bias_7_inst_addr                                   "0x042A"
#define  set_SRNN_wdsr_layer3_1x1_bias_7_reg(data)                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_bias_7_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_bias_7_reg                                     (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_bias_7_reg))
#define  SRNN_wdsr_layer3_1x1_bias_7_layer3_bias_7_shift                         (0)
#define  SRNN_wdsr_layer3_1x1_bias_7_layer3_bias_7_mask                          (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_bias_7_layer3_bias_7(data)                         (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_bias_7_get_layer3_bias_7(data)                     (0x000003FF&(data))

#define  SRNN_wdsr_layer3_1x1_bias_8                                            0x181AC01C
#define  SRNN_wdsr_layer3_1x1_bias_8_reg_addr                                    "0xB81AC01C"
#define  SRNN_wdsr_layer3_1x1_bias_8_reg                                         0xB81AC01C
#define  SRNN_wdsr_layer3_1x1_bias_8_inst_addr                                   "0x042B"
#define  set_SRNN_wdsr_layer3_1x1_bias_8_reg(data)                               (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_bias_8_reg)=data)
#define  get_SRNN_wdsr_layer3_1x1_bias_8_reg                                     (*((volatile unsigned int*)SRNN_wdsr_layer3_1x1_bias_8_reg))
#define  SRNN_wdsr_layer3_1x1_bias_8_layer3_bias_8_shift                         (0)
#define  SRNN_wdsr_layer3_1x1_bias_8_layer3_bias_8_mask                          (0x000003FF)
#define  SRNN_wdsr_layer3_1x1_bias_8_layer3_bias_8(data)                         (0x000003FF&(data))
#define  SRNN_wdsr_layer3_1x1_bias_8_get_layer3_bias_8(data)                     (0x000003FF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_1_1_00                                    0x181AC020
#define  SRNN_wdsr_layer4_3x3_weights_1_1_00_reg_addr                            "0xB81AC020"
#define  SRNN_wdsr_layer4_3x3_weights_1_1_00_reg                                 0xB81AC020
#define  SRNN_wdsr_layer4_3x3_weights_1_1_00_inst_addr                           "0x042C"
#define  set_SRNN_wdsr_layer4_3x3_weights_1_1_00_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_1_00_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_1_1_00_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_1_00_reg))
#define  SRNN_wdsr_layer4_3x3_weights_1_1_00_layer4_weight_00_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_1_1_00_layer4_weight_00_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_1_1_00_layer4_weight_00(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_1_1_00_get_layer4_weight_00(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_1_1_01                                    0x181AC024
#define  SRNN_wdsr_layer4_3x3_weights_1_1_01_reg_addr                            "0xB81AC024"
#define  SRNN_wdsr_layer4_3x3_weights_1_1_01_reg                                 0xB81AC024
#define  SRNN_wdsr_layer4_3x3_weights_1_1_01_inst_addr                           "0x042D"
#define  set_SRNN_wdsr_layer4_3x3_weights_1_1_01_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_1_01_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_1_1_01_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_1_01_reg))
#define  SRNN_wdsr_layer4_3x3_weights_1_1_01_layer4_weight_01_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_1_1_01_layer4_weight_01_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_1_1_01_layer4_weight_01(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_1_1_01_get_layer4_weight_01(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_1_1_02                                    0x181AC028
#define  SRNN_wdsr_layer4_3x3_weights_1_1_02_reg_addr                            "0xB81AC028"
#define  SRNN_wdsr_layer4_3x3_weights_1_1_02_reg                                 0xB81AC028
#define  SRNN_wdsr_layer4_3x3_weights_1_1_02_inst_addr                           "0x042E"
#define  set_SRNN_wdsr_layer4_3x3_weights_1_1_02_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_1_02_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_1_1_02_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_1_02_reg))
#define  SRNN_wdsr_layer4_3x3_weights_1_1_02_layer4_weight_02_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_1_1_02_layer4_weight_02_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_1_1_02_layer4_weight_02(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_1_1_02_get_layer4_weight_02(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_1_1_10                                    0x181AC02C
#define  SRNN_wdsr_layer4_3x3_weights_1_1_10_reg_addr                            "0xB81AC02C"
#define  SRNN_wdsr_layer4_3x3_weights_1_1_10_reg                                 0xB81AC02C
#define  SRNN_wdsr_layer4_3x3_weights_1_1_10_inst_addr                           "0x042F"
#define  set_SRNN_wdsr_layer4_3x3_weights_1_1_10_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_1_10_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_1_1_10_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_1_10_reg))
#define  SRNN_wdsr_layer4_3x3_weights_1_1_10_layer4_weight_10_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_1_1_10_layer4_weight_10_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_1_1_10_layer4_weight_10(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_1_1_10_get_layer4_weight_10(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_1_1_11                                    0x181AC030
#define  SRNN_wdsr_layer4_3x3_weights_1_1_11_reg_addr                            "0xB81AC030"
#define  SRNN_wdsr_layer4_3x3_weights_1_1_11_reg                                 0xB81AC030
#define  SRNN_wdsr_layer4_3x3_weights_1_1_11_inst_addr                           "0x0430"
#define  set_SRNN_wdsr_layer4_3x3_weights_1_1_11_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_1_11_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_1_1_11_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_1_11_reg))
#define  SRNN_wdsr_layer4_3x3_weights_1_1_11_layer4_weight_11_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_1_1_11_layer4_weight_11_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_1_1_11_layer4_weight_11(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_1_1_11_get_layer4_weight_11(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_1_1_12                                    0x181AC034
#define  SRNN_wdsr_layer4_3x3_weights_1_1_12_reg_addr                            "0xB81AC034"
#define  SRNN_wdsr_layer4_3x3_weights_1_1_12_reg                                 0xB81AC034
#define  SRNN_wdsr_layer4_3x3_weights_1_1_12_inst_addr                           "0x0431"
#define  set_SRNN_wdsr_layer4_3x3_weights_1_1_12_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_1_12_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_1_1_12_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_1_12_reg))
#define  SRNN_wdsr_layer4_3x3_weights_1_1_12_layer4_weight_12_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_1_1_12_layer4_weight_12_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_1_1_12_layer4_weight_12(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_1_1_12_get_layer4_weight_12(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_1_1_20                                    0x181AC038
#define  SRNN_wdsr_layer4_3x3_weights_1_1_20_reg_addr                            "0xB81AC038"
#define  SRNN_wdsr_layer4_3x3_weights_1_1_20_reg                                 0xB81AC038
#define  SRNN_wdsr_layer4_3x3_weights_1_1_20_inst_addr                           "0x0432"
#define  set_SRNN_wdsr_layer4_3x3_weights_1_1_20_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_1_20_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_1_1_20_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_1_20_reg))
#define  SRNN_wdsr_layer4_3x3_weights_1_1_20_layer4_weight_20_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_1_1_20_layer4_weight_20_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_1_1_20_layer4_weight_20(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_1_1_20_get_layer4_weight_20(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_1_1_21                                    0x181AC03C
#define  SRNN_wdsr_layer4_3x3_weights_1_1_21_reg_addr                            "0xB81AC03C"
#define  SRNN_wdsr_layer4_3x3_weights_1_1_21_reg                                 0xB81AC03C
#define  SRNN_wdsr_layer4_3x3_weights_1_1_21_inst_addr                           "0x0433"
#define  set_SRNN_wdsr_layer4_3x3_weights_1_1_21_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_1_21_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_1_1_21_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_1_21_reg))
#define  SRNN_wdsr_layer4_3x3_weights_1_1_21_layer4_weight_21_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_1_1_21_layer4_weight_21_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_1_1_21_layer4_weight_21(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_1_1_21_get_layer4_weight_21(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_1_1_22                                    0x181AC040
#define  SRNN_wdsr_layer4_3x3_weights_1_1_22_reg_addr                            "0xB81AC040"
#define  SRNN_wdsr_layer4_3x3_weights_1_1_22_reg                                 0xB81AC040
#define  SRNN_wdsr_layer4_3x3_weights_1_1_22_inst_addr                           "0x0434"
#define  set_SRNN_wdsr_layer4_3x3_weights_1_1_22_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_1_22_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_1_1_22_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_1_22_reg))
#define  SRNN_wdsr_layer4_3x3_weights_1_1_22_layer4_weight_22_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_1_1_22_layer4_weight_22_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_1_1_22_layer4_weight_22(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_1_1_22_get_layer4_weight_22(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_1_2_00                                    0x181AC044
#define  SRNN_wdsr_layer4_3x3_weights_1_2_00_reg_addr                            "0xB81AC044"
#define  SRNN_wdsr_layer4_3x3_weights_1_2_00_reg                                 0xB81AC044
#define  SRNN_wdsr_layer4_3x3_weights_1_2_00_inst_addr                           "0x0435"
#define  set_SRNN_wdsr_layer4_3x3_weights_1_2_00_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_2_00_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_1_2_00_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_2_00_reg))
#define  SRNN_wdsr_layer4_3x3_weights_1_2_00_layer4_weight_00_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_1_2_00_layer4_weight_00_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_1_2_00_layer4_weight_00(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_1_2_00_get_layer4_weight_00(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_1_2_01                                    0x181AC048
#define  SRNN_wdsr_layer4_3x3_weights_1_2_01_reg_addr                            "0xB81AC048"
#define  SRNN_wdsr_layer4_3x3_weights_1_2_01_reg                                 0xB81AC048
#define  SRNN_wdsr_layer4_3x3_weights_1_2_01_inst_addr                           "0x0436"
#define  set_SRNN_wdsr_layer4_3x3_weights_1_2_01_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_2_01_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_1_2_01_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_2_01_reg))
#define  SRNN_wdsr_layer4_3x3_weights_1_2_01_layer4_weight_01_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_1_2_01_layer4_weight_01_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_1_2_01_layer4_weight_01(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_1_2_01_get_layer4_weight_01(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_1_2_02                                    0x181AC04C
#define  SRNN_wdsr_layer4_3x3_weights_1_2_02_reg_addr                            "0xB81AC04C"
#define  SRNN_wdsr_layer4_3x3_weights_1_2_02_reg                                 0xB81AC04C
#define  SRNN_wdsr_layer4_3x3_weights_1_2_02_inst_addr                           "0x0437"
#define  set_SRNN_wdsr_layer4_3x3_weights_1_2_02_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_2_02_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_1_2_02_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_2_02_reg))
#define  SRNN_wdsr_layer4_3x3_weights_1_2_02_layer4_weight_02_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_1_2_02_layer4_weight_02_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_1_2_02_layer4_weight_02(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_1_2_02_get_layer4_weight_02(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_1_2_10                                    0x181AC050
#define  SRNN_wdsr_layer4_3x3_weights_1_2_10_reg_addr                            "0xB81AC050"
#define  SRNN_wdsr_layer4_3x3_weights_1_2_10_reg                                 0xB81AC050
#define  SRNN_wdsr_layer4_3x3_weights_1_2_10_inst_addr                           "0x0438"
#define  set_SRNN_wdsr_layer4_3x3_weights_1_2_10_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_2_10_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_1_2_10_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_2_10_reg))
#define  SRNN_wdsr_layer4_3x3_weights_1_2_10_layer4_weight_10_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_1_2_10_layer4_weight_10_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_1_2_10_layer4_weight_10(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_1_2_10_get_layer4_weight_10(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_1_2_11                                    0x181AC054
#define  SRNN_wdsr_layer4_3x3_weights_1_2_11_reg_addr                            "0xB81AC054"
#define  SRNN_wdsr_layer4_3x3_weights_1_2_11_reg                                 0xB81AC054
#define  SRNN_wdsr_layer4_3x3_weights_1_2_11_inst_addr                           "0x0439"
#define  set_SRNN_wdsr_layer4_3x3_weights_1_2_11_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_2_11_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_1_2_11_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_2_11_reg))
#define  SRNN_wdsr_layer4_3x3_weights_1_2_11_layer4_weight_11_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_1_2_11_layer4_weight_11_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_1_2_11_layer4_weight_11(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_1_2_11_get_layer4_weight_11(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_1_2_12                                    0x181AC058
#define  SRNN_wdsr_layer4_3x3_weights_1_2_12_reg_addr                            "0xB81AC058"
#define  SRNN_wdsr_layer4_3x3_weights_1_2_12_reg                                 0xB81AC058
#define  SRNN_wdsr_layer4_3x3_weights_1_2_12_inst_addr                           "0x043A"
#define  set_SRNN_wdsr_layer4_3x3_weights_1_2_12_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_2_12_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_1_2_12_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_2_12_reg))
#define  SRNN_wdsr_layer4_3x3_weights_1_2_12_layer4_weight_12_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_1_2_12_layer4_weight_12_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_1_2_12_layer4_weight_12(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_1_2_12_get_layer4_weight_12(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_1_2_20                                    0x181AC05C
#define  SRNN_wdsr_layer4_3x3_weights_1_2_20_reg_addr                            "0xB81AC05C"
#define  SRNN_wdsr_layer4_3x3_weights_1_2_20_reg                                 0xB81AC05C
#define  SRNN_wdsr_layer4_3x3_weights_1_2_20_inst_addr                           "0x043B"
#define  set_SRNN_wdsr_layer4_3x3_weights_1_2_20_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_2_20_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_1_2_20_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_2_20_reg))
#define  SRNN_wdsr_layer4_3x3_weights_1_2_20_layer4_weight_20_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_1_2_20_layer4_weight_20_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_1_2_20_layer4_weight_20(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_1_2_20_get_layer4_weight_20(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_1_2_21                                    0x181AC060
#define  SRNN_wdsr_layer4_3x3_weights_1_2_21_reg_addr                            "0xB81AC060"
#define  SRNN_wdsr_layer4_3x3_weights_1_2_21_reg                                 0xB81AC060
#define  SRNN_wdsr_layer4_3x3_weights_1_2_21_inst_addr                           "0x043C"
#define  set_SRNN_wdsr_layer4_3x3_weights_1_2_21_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_2_21_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_1_2_21_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_2_21_reg))
#define  SRNN_wdsr_layer4_3x3_weights_1_2_21_layer4_weight_21_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_1_2_21_layer4_weight_21_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_1_2_21_layer4_weight_21(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_1_2_21_get_layer4_weight_21(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_1_2_22                                    0x181AC064
#define  SRNN_wdsr_layer4_3x3_weights_1_2_22_reg_addr                            "0xB81AC064"
#define  SRNN_wdsr_layer4_3x3_weights_1_2_22_reg                                 0xB81AC064
#define  SRNN_wdsr_layer4_3x3_weights_1_2_22_inst_addr                           "0x043D"
#define  set_SRNN_wdsr_layer4_3x3_weights_1_2_22_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_2_22_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_1_2_22_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_2_22_reg))
#define  SRNN_wdsr_layer4_3x3_weights_1_2_22_layer4_weight_22_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_1_2_22_layer4_weight_22_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_1_2_22_layer4_weight_22(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_1_2_22_get_layer4_weight_22(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_1_3_00                                    0x181AC068
#define  SRNN_wdsr_layer4_3x3_weights_1_3_00_reg_addr                            "0xB81AC068"
#define  SRNN_wdsr_layer4_3x3_weights_1_3_00_reg                                 0xB81AC068
#define  SRNN_wdsr_layer4_3x3_weights_1_3_00_inst_addr                           "0x043E"
#define  set_SRNN_wdsr_layer4_3x3_weights_1_3_00_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_3_00_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_1_3_00_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_3_00_reg))
#define  SRNN_wdsr_layer4_3x3_weights_1_3_00_layer4_weight_00_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_1_3_00_layer4_weight_00_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_1_3_00_layer4_weight_00(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_1_3_00_get_layer4_weight_00(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_1_3_01                                    0x181AC06C
#define  SRNN_wdsr_layer4_3x3_weights_1_3_01_reg_addr                            "0xB81AC06C"
#define  SRNN_wdsr_layer4_3x3_weights_1_3_01_reg                                 0xB81AC06C
#define  SRNN_wdsr_layer4_3x3_weights_1_3_01_inst_addr                           "0x043F"
#define  set_SRNN_wdsr_layer4_3x3_weights_1_3_01_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_3_01_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_1_3_01_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_3_01_reg))
#define  SRNN_wdsr_layer4_3x3_weights_1_3_01_layer4_weight_01_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_1_3_01_layer4_weight_01_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_1_3_01_layer4_weight_01(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_1_3_01_get_layer4_weight_01(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_1_3_02                                    0x181AC070
#define  SRNN_wdsr_layer4_3x3_weights_1_3_02_reg_addr                            "0xB81AC070"
#define  SRNN_wdsr_layer4_3x3_weights_1_3_02_reg                                 0xB81AC070
#define  SRNN_wdsr_layer4_3x3_weights_1_3_02_inst_addr                           "0x0440"
#define  set_SRNN_wdsr_layer4_3x3_weights_1_3_02_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_3_02_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_1_3_02_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_3_02_reg))
#define  SRNN_wdsr_layer4_3x3_weights_1_3_02_layer4_weight_02_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_1_3_02_layer4_weight_02_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_1_3_02_layer4_weight_02(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_1_3_02_get_layer4_weight_02(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_1_3_10                                    0x181AC074
#define  SRNN_wdsr_layer4_3x3_weights_1_3_10_reg_addr                            "0xB81AC074"
#define  SRNN_wdsr_layer4_3x3_weights_1_3_10_reg                                 0xB81AC074
#define  SRNN_wdsr_layer4_3x3_weights_1_3_10_inst_addr                           "0x0441"
#define  set_SRNN_wdsr_layer4_3x3_weights_1_3_10_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_3_10_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_1_3_10_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_3_10_reg))
#define  SRNN_wdsr_layer4_3x3_weights_1_3_10_layer4_weight_10_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_1_3_10_layer4_weight_10_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_1_3_10_layer4_weight_10(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_1_3_10_get_layer4_weight_10(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_1_3_11                                    0x181AC078
#define  SRNN_wdsr_layer4_3x3_weights_1_3_11_reg_addr                            "0xB81AC078"
#define  SRNN_wdsr_layer4_3x3_weights_1_3_11_reg                                 0xB81AC078
#define  SRNN_wdsr_layer4_3x3_weights_1_3_11_inst_addr                           "0x0442"
#define  set_SRNN_wdsr_layer4_3x3_weights_1_3_11_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_3_11_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_1_3_11_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_3_11_reg))
#define  SRNN_wdsr_layer4_3x3_weights_1_3_11_layer4_weight_11_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_1_3_11_layer4_weight_11_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_1_3_11_layer4_weight_11(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_1_3_11_get_layer4_weight_11(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_1_3_12                                    0x181AC07C
#define  SRNN_wdsr_layer4_3x3_weights_1_3_12_reg_addr                            "0xB81AC07C"
#define  SRNN_wdsr_layer4_3x3_weights_1_3_12_reg                                 0xB81AC07C
#define  SRNN_wdsr_layer4_3x3_weights_1_3_12_inst_addr                           "0x0443"
#define  set_SRNN_wdsr_layer4_3x3_weights_1_3_12_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_3_12_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_1_3_12_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_3_12_reg))
#define  SRNN_wdsr_layer4_3x3_weights_1_3_12_layer4_weight_12_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_1_3_12_layer4_weight_12_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_1_3_12_layer4_weight_12(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_1_3_12_get_layer4_weight_12(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_1_3_20                                    0x181AC080
#define  SRNN_wdsr_layer4_3x3_weights_1_3_20_reg_addr                            "0xB81AC080"
#define  SRNN_wdsr_layer4_3x3_weights_1_3_20_reg                                 0xB81AC080
#define  SRNN_wdsr_layer4_3x3_weights_1_3_20_inst_addr                           "0x0444"
#define  set_SRNN_wdsr_layer4_3x3_weights_1_3_20_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_3_20_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_1_3_20_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_3_20_reg))
#define  SRNN_wdsr_layer4_3x3_weights_1_3_20_layer4_weight_20_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_1_3_20_layer4_weight_20_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_1_3_20_layer4_weight_20(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_1_3_20_get_layer4_weight_20(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_1_3_21                                    0x181AC084
#define  SRNN_wdsr_layer4_3x3_weights_1_3_21_reg_addr                            "0xB81AC084"
#define  SRNN_wdsr_layer4_3x3_weights_1_3_21_reg                                 0xB81AC084
#define  SRNN_wdsr_layer4_3x3_weights_1_3_21_inst_addr                           "0x0445"
#define  set_SRNN_wdsr_layer4_3x3_weights_1_3_21_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_3_21_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_1_3_21_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_3_21_reg))
#define  SRNN_wdsr_layer4_3x3_weights_1_3_21_layer4_weight_21_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_1_3_21_layer4_weight_21_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_1_3_21_layer4_weight_21(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_1_3_21_get_layer4_weight_21(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_1_3_22                                    0x181AC088
#define  SRNN_wdsr_layer4_3x3_weights_1_3_22_reg_addr                            "0xB81AC088"
#define  SRNN_wdsr_layer4_3x3_weights_1_3_22_reg                                 0xB81AC088
#define  SRNN_wdsr_layer4_3x3_weights_1_3_22_inst_addr                           "0x0446"
#define  set_SRNN_wdsr_layer4_3x3_weights_1_3_22_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_3_22_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_1_3_22_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_3_22_reg))
#define  SRNN_wdsr_layer4_3x3_weights_1_3_22_layer4_weight_22_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_1_3_22_layer4_weight_22_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_1_3_22_layer4_weight_22(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_1_3_22_get_layer4_weight_22(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_1_4_00                                    0x181AC08C
#define  SRNN_wdsr_layer4_3x3_weights_1_4_00_reg_addr                            "0xB81AC08C"
#define  SRNN_wdsr_layer4_3x3_weights_1_4_00_reg                                 0xB81AC08C
#define  SRNN_wdsr_layer4_3x3_weights_1_4_00_inst_addr                           "0x0447"
#define  set_SRNN_wdsr_layer4_3x3_weights_1_4_00_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_4_00_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_1_4_00_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_4_00_reg))
#define  SRNN_wdsr_layer4_3x3_weights_1_4_00_layer4_weight_00_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_1_4_00_layer4_weight_00_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_1_4_00_layer4_weight_00(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_1_4_00_get_layer4_weight_00(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_1_4_01                                    0x181AC090
#define  SRNN_wdsr_layer4_3x3_weights_1_4_01_reg_addr                            "0xB81AC090"
#define  SRNN_wdsr_layer4_3x3_weights_1_4_01_reg                                 0xB81AC090
#define  SRNN_wdsr_layer4_3x3_weights_1_4_01_inst_addr                           "0x0448"
#define  set_SRNN_wdsr_layer4_3x3_weights_1_4_01_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_4_01_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_1_4_01_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_4_01_reg))
#define  SRNN_wdsr_layer4_3x3_weights_1_4_01_layer4_weight_01_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_1_4_01_layer4_weight_01_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_1_4_01_layer4_weight_01(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_1_4_01_get_layer4_weight_01(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_1_4_02                                    0x181AC094
#define  SRNN_wdsr_layer4_3x3_weights_1_4_02_reg_addr                            "0xB81AC094"
#define  SRNN_wdsr_layer4_3x3_weights_1_4_02_reg                                 0xB81AC094
#define  SRNN_wdsr_layer4_3x3_weights_1_4_02_inst_addr                           "0x0449"
#define  set_SRNN_wdsr_layer4_3x3_weights_1_4_02_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_4_02_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_1_4_02_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_4_02_reg))
#define  SRNN_wdsr_layer4_3x3_weights_1_4_02_layer4_weight_02_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_1_4_02_layer4_weight_02_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_1_4_02_layer4_weight_02(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_1_4_02_get_layer4_weight_02(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_1_4_10                                    0x181AC098
#define  SRNN_wdsr_layer4_3x3_weights_1_4_10_reg_addr                            "0xB81AC098"
#define  SRNN_wdsr_layer4_3x3_weights_1_4_10_reg                                 0xB81AC098
#define  SRNN_wdsr_layer4_3x3_weights_1_4_10_inst_addr                           "0x044A"
#define  set_SRNN_wdsr_layer4_3x3_weights_1_4_10_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_4_10_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_1_4_10_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_4_10_reg))
#define  SRNN_wdsr_layer4_3x3_weights_1_4_10_layer4_weight_10_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_1_4_10_layer4_weight_10_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_1_4_10_layer4_weight_10(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_1_4_10_get_layer4_weight_10(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_1_4_11                                    0x181AC09C
#define  SRNN_wdsr_layer4_3x3_weights_1_4_11_reg_addr                            "0xB81AC09C"
#define  SRNN_wdsr_layer4_3x3_weights_1_4_11_reg                                 0xB81AC09C
#define  SRNN_wdsr_layer4_3x3_weights_1_4_11_inst_addr                           "0x044B"
#define  set_SRNN_wdsr_layer4_3x3_weights_1_4_11_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_4_11_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_1_4_11_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_4_11_reg))
#define  SRNN_wdsr_layer4_3x3_weights_1_4_11_layer4_weight_11_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_1_4_11_layer4_weight_11_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_1_4_11_layer4_weight_11(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_1_4_11_get_layer4_weight_11(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_1_4_12                                    0x181AC0A0
#define  SRNN_wdsr_layer4_3x3_weights_1_4_12_reg_addr                            "0xB81AC0A0"
#define  SRNN_wdsr_layer4_3x3_weights_1_4_12_reg                                 0xB81AC0A0
#define  SRNN_wdsr_layer4_3x3_weights_1_4_12_inst_addr                           "0x044C"
#define  set_SRNN_wdsr_layer4_3x3_weights_1_4_12_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_4_12_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_1_4_12_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_4_12_reg))
#define  SRNN_wdsr_layer4_3x3_weights_1_4_12_layer4_weight_12_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_1_4_12_layer4_weight_12_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_1_4_12_layer4_weight_12(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_1_4_12_get_layer4_weight_12(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_1_4_20                                    0x181AC0A4
#define  SRNN_wdsr_layer4_3x3_weights_1_4_20_reg_addr                            "0xB81AC0A4"
#define  SRNN_wdsr_layer4_3x3_weights_1_4_20_reg                                 0xB81AC0A4
#define  SRNN_wdsr_layer4_3x3_weights_1_4_20_inst_addr                           "0x044D"
#define  set_SRNN_wdsr_layer4_3x3_weights_1_4_20_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_4_20_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_1_4_20_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_4_20_reg))
#define  SRNN_wdsr_layer4_3x3_weights_1_4_20_layer4_weight_20_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_1_4_20_layer4_weight_20_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_1_4_20_layer4_weight_20(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_1_4_20_get_layer4_weight_20(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_1_4_21                                    0x181AC0A8
#define  SRNN_wdsr_layer4_3x3_weights_1_4_21_reg_addr                            "0xB81AC0A8"
#define  SRNN_wdsr_layer4_3x3_weights_1_4_21_reg                                 0xB81AC0A8
#define  SRNN_wdsr_layer4_3x3_weights_1_4_21_inst_addr                           "0x044E"
#define  set_SRNN_wdsr_layer4_3x3_weights_1_4_21_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_4_21_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_1_4_21_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_4_21_reg))
#define  SRNN_wdsr_layer4_3x3_weights_1_4_21_layer4_weight_21_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_1_4_21_layer4_weight_21_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_1_4_21_layer4_weight_21(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_1_4_21_get_layer4_weight_21(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_1_4_22                                    0x181AC0AC
#define  SRNN_wdsr_layer4_3x3_weights_1_4_22_reg_addr                            "0xB81AC0AC"
#define  SRNN_wdsr_layer4_3x3_weights_1_4_22_reg                                 0xB81AC0AC
#define  SRNN_wdsr_layer4_3x3_weights_1_4_22_inst_addr                           "0x044F"
#define  set_SRNN_wdsr_layer4_3x3_weights_1_4_22_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_4_22_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_1_4_22_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_4_22_reg))
#define  SRNN_wdsr_layer4_3x3_weights_1_4_22_layer4_weight_22_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_1_4_22_layer4_weight_22_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_1_4_22_layer4_weight_22(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_1_4_22_get_layer4_weight_22(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_1_5_00                                    0x181AC0B0
#define  SRNN_wdsr_layer4_3x3_weights_1_5_00_reg_addr                            "0xB81AC0B0"
#define  SRNN_wdsr_layer4_3x3_weights_1_5_00_reg                                 0xB81AC0B0
#define  SRNN_wdsr_layer4_3x3_weights_1_5_00_inst_addr                           "0x0450"
#define  set_SRNN_wdsr_layer4_3x3_weights_1_5_00_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_5_00_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_1_5_00_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_5_00_reg))
#define  SRNN_wdsr_layer4_3x3_weights_1_5_00_layer4_weight_00_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_1_5_00_layer4_weight_00_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_1_5_00_layer4_weight_00(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_1_5_00_get_layer4_weight_00(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_1_5_01                                    0x181AC0B4
#define  SRNN_wdsr_layer4_3x3_weights_1_5_01_reg_addr                            "0xB81AC0B4"
#define  SRNN_wdsr_layer4_3x3_weights_1_5_01_reg                                 0xB81AC0B4
#define  SRNN_wdsr_layer4_3x3_weights_1_5_01_inst_addr                           "0x0451"
#define  set_SRNN_wdsr_layer4_3x3_weights_1_5_01_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_5_01_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_1_5_01_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_5_01_reg))
#define  SRNN_wdsr_layer4_3x3_weights_1_5_01_layer4_weight_01_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_1_5_01_layer4_weight_01_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_1_5_01_layer4_weight_01(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_1_5_01_get_layer4_weight_01(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_1_5_02                                    0x181AC0B8
#define  SRNN_wdsr_layer4_3x3_weights_1_5_02_reg_addr                            "0xB81AC0B8"
#define  SRNN_wdsr_layer4_3x3_weights_1_5_02_reg                                 0xB81AC0B8
#define  SRNN_wdsr_layer4_3x3_weights_1_5_02_inst_addr                           "0x0452"
#define  set_SRNN_wdsr_layer4_3x3_weights_1_5_02_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_5_02_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_1_5_02_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_5_02_reg))
#define  SRNN_wdsr_layer4_3x3_weights_1_5_02_layer4_weight_02_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_1_5_02_layer4_weight_02_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_1_5_02_layer4_weight_02(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_1_5_02_get_layer4_weight_02(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_1_5_10                                    0x181AC0BC
#define  SRNN_wdsr_layer4_3x3_weights_1_5_10_reg_addr                            "0xB81AC0BC"
#define  SRNN_wdsr_layer4_3x3_weights_1_5_10_reg                                 0xB81AC0BC
#define  SRNN_wdsr_layer4_3x3_weights_1_5_10_inst_addr                           "0x0453"
#define  set_SRNN_wdsr_layer4_3x3_weights_1_5_10_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_5_10_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_1_5_10_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_5_10_reg))
#define  SRNN_wdsr_layer4_3x3_weights_1_5_10_layer4_weight_10_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_1_5_10_layer4_weight_10_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_1_5_10_layer4_weight_10(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_1_5_10_get_layer4_weight_10(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_1_5_11                                    0x181AC0C0
#define  SRNN_wdsr_layer4_3x3_weights_1_5_11_reg_addr                            "0xB81AC0C0"
#define  SRNN_wdsr_layer4_3x3_weights_1_5_11_reg                                 0xB81AC0C0
#define  SRNN_wdsr_layer4_3x3_weights_1_5_11_inst_addr                           "0x0454"
#define  set_SRNN_wdsr_layer4_3x3_weights_1_5_11_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_5_11_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_1_5_11_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_5_11_reg))
#define  SRNN_wdsr_layer4_3x3_weights_1_5_11_layer4_weight_11_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_1_5_11_layer4_weight_11_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_1_5_11_layer4_weight_11(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_1_5_11_get_layer4_weight_11(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_1_5_12                                    0x181AC0C4
#define  SRNN_wdsr_layer4_3x3_weights_1_5_12_reg_addr                            "0xB81AC0C4"
#define  SRNN_wdsr_layer4_3x3_weights_1_5_12_reg                                 0xB81AC0C4
#define  SRNN_wdsr_layer4_3x3_weights_1_5_12_inst_addr                           "0x0455"
#define  set_SRNN_wdsr_layer4_3x3_weights_1_5_12_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_5_12_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_1_5_12_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_5_12_reg))
#define  SRNN_wdsr_layer4_3x3_weights_1_5_12_layer4_weight_12_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_1_5_12_layer4_weight_12_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_1_5_12_layer4_weight_12(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_1_5_12_get_layer4_weight_12(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_1_5_20                                    0x181AC0C8
#define  SRNN_wdsr_layer4_3x3_weights_1_5_20_reg_addr                            "0xB81AC0C8"
#define  SRNN_wdsr_layer4_3x3_weights_1_5_20_reg                                 0xB81AC0C8
#define  SRNN_wdsr_layer4_3x3_weights_1_5_20_inst_addr                           "0x0456"
#define  set_SRNN_wdsr_layer4_3x3_weights_1_5_20_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_5_20_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_1_5_20_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_5_20_reg))
#define  SRNN_wdsr_layer4_3x3_weights_1_5_20_layer4_weight_20_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_1_5_20_layer4_weight_20_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_1_5_20_layer4_weight_20(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_1_5_20_get_layer4_weight_20(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_1_5_21                                    0x181AC0CC
#define  SRNN_wdsr_layer4_3x3_weights_1_5_21_reg_addr                            "0xB81AC0CC"
#define  SRNN_wdsr_layer4_3x3_weights_1_5_21_reg                                 0xB81AC0CC
#define  SRNN_wdsr_layer4_3x3_weights_1_5_21_inst_addr                           "0x0457"
#define  set_SRNN_wdsr_layer4_3x3_weights_1_5_21_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_5_21_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_1_5_21_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_5_21_reg))
#define  SRNN_wdsr_layer4_3x3_weights_1_5_21_layer4_weight_21_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_1_5_21_layer4_weight_21_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_1_5_21_layer4_weight_21(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_1_5_21_get_layer4_weight_21(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_1_5_22                                    0x181AC0D0
#define  SRNN_wdsr_layer4_3x3_weights_1_5_22_reg_addr                            "0xB81AC0D0"
#define  SRNN_wdsr_layer4_3x3_weights_1_5_22_reg                                 0xB81AC0D0
#define  SRNN_wdsr_layer4_3x3_weights_1_5_22_inst_addr                           "0x0458"
#define  set_SRNN_wdsr_layer4_3x3_weights_1_5_22_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_5_22_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_1_5_22_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_5_22_reg))
#define  SRNN_wdsr_layer4_3x3_weights_1_5_22_layer4_weight_22_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_1_5_22_layer4_weight_22_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_1_5_22_layer4_weight_22(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_1_5_22_get_layer4_weight_22(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_1_6_00                                    0x181AC0D4
#define  SRNN_wdsr_layer4_3x3_weights_1_6_00_reg_addr                            "0xB81AC0D4"
#define  SRNN_wdsr_layer4_3x3_weights_1_6_00_reg                                 0xB81AC0D4
#define  SRNN_wdsr_layer4_3x3_weights_1_6_00_inst_addr                           "0x0459"
#define  set_SRNN_wdsr_layer4_3x3_weights_1_6_00_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_6_00_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_1_6_00_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_6_00_reg))
#define  SRNN_wdsr_layer4_3x3_weights_1_6_00_layer4_weight_00_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_1_6_00_layer4_weight_00_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_1_6_00_layer4_weight_00(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_1_6_00_get_layer4_weight_00(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_1_6_01                                    0x181AC0D8
#define  SRNN_wdsr_layer4_3x3_weights_1_6_01_reg_addr                            "0xB81AC0D8"
#define  SRNN_wdsr_layer4_3x3_weights_1_6_01_reg                                 0xB81AC0D8
#define  SRNN_wdsr_layer4_3x3_weights_1_6_01_inst_addr                           "0x045A"
#define  set_SRNN_wdsr_layer4_3x3_weights_1_6_01_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_6_01_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_1_6_01_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_6_01_reg))
#define  SRNN_wdsr_layer4_3x3_weights_1_6_01_layer4_weight_01_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_1_6_01_layer4_weight_01_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_1_6_01_layer4_weight_01(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_1_6_01_get_layer4_weight_01(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_1_6_02                                    0x181AC0DC
#define  SRNN_wdsr_layer4_3x3_weights_1_6_02_reg_addr                            "0xB81AC0DC"
#define  SRNN_wdsr_layer4_3x3_weights_1_6_02_reg                                 0xB81AC0DC
#define  SRNN_wdsr_layer4_3x3_weights_1_6_02_inst_addr                           "0x045B"
#define  set_SRNN_wdsr_layer4_3x3_weights_1_6_02_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_6_02_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_1_6_02_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_6_02_reg))
#define  SRNN_wdsr_layer4_3x3_weights_1_6_02_layer4_weight_02_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_1_6_02_layer4_weight_02_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_1_6_02_layer4_weight_02(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_1_6_02_get_layer4_weight_02(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_1_6_10                                    0x181AC0E0
#define  SRNN_wdsr_layer4_3x3_weights_1_6_10_reg_addr                            "0xB81AC0E0"
#define  SRNN_wdsr_layer4_3x3_weights_1_6_10_reg                                 0xB81AC0E0
#define  SRNN_wdsr_layer4_3x3_weights_1_6_10_inst_addr                           "0x045C"
#define  set_SRNN_wdsr_layer4_3x3_weights_1_6_10_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_6_10_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_1_6_10_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_6_10_reg))
#define  SRNN_wdsr_layer4_3x3_weights_1_6_10_layer4_weight_10_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_1_6_10_layer4_weight_10_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_1_6_10_layer4_weight_10(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_1_6_10_get_layer4_weight_10(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_1_6_11                                    0x181AC0E4
#define  SRNN_wdsr_layer4_3x3_weights_1_6_11_reg_addr                            "0xB81AC0E4"
#define  SRNN_wdsr_layer4_3x3_weights_1_6_11_reg                                 0xB81AC0E4
#define  SRNN_wdsr_layer4_3x3_weights_1_6_11_inst_addr                           "0x045D"
#define  set_SRNN_wdsr_layer4_3x3_weights_1_6_11_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_6_11_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_1_6_11_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_6_11_reg))
#define  SRNN_wdsr_layer4_3x3_weights_1_6_11_layer4_weight_11_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_1_6_11_layer4_weight_11_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_1_6_11_layer4_weight_11(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_1_6_11_get_layer4_weight_11(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_1_6_12                                    0x181AC0E8
#define  SRNN_wdsr_layer4_3x3_weights_1_6_12_reg_addr                            "0xB81AC0E8"
#define  SRNN_wdsr_layer4_3x3_weights_1_6_12_reg                                 0xB81AC0E8
#define  SRNN_wdsr_layer4_3x3_weights_1_6_12_inst_addr                           "0x045E"
#define  set_SRNN_wdsr_layer4_3x3_weights_1_6_12_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_6_12_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_1_6_12_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_6_12_reg))
#define  SRNN_wdsr_layer4_3x3_weights_1_6_12_layer4_weight_12_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_1_6_12_layer4_weight_12_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_1_6_12_layer4_weight_12(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_1_6_12_get_layer4_weight_12(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_1_6_20                                    0x181AC0EC
#define  SRNN_wdsr_layer4_3x3_weights_1_6_20_reg_addr                            "0xB81AC0EC"
#define  SRNN_wdsr_layer4_3x3_weights_1_6_20_reg                                 0xB81AC0EC
#define  SRNN_wdsr_layer4_3x3_weights_1_6_20_inst_addr                           "0x045F"
#define  set_SRNN_wdsr_layer4_3x3_weights_1_6_20_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_6_20_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_1_6_20_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_6_20_reg))
#define  SRNN_wdsr_layer4_3x3_weights_1_6_20_layer4_weight_20_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_1_6_20_layer4_weight_20_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_1_6_20_layer4_weight_20(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_1_6_20_get_layer4_weight_20(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_1_6_21                                    0x181AC0F0
#define  SRNN_wdsr_layer4_3x3_weights_1_6_21_reg_addr                            "0xB81AC0F0"
#define  SRNN_wdsr_layer4_3x3_weights_1_6_21_reg                                 0xB81AC0F0
#define  SRNN_wdsr_layer4_3x3_weights_1_6_21_inst_addr                           "0x0460"
#define  set_SRNN_wdsr_layer4_3x3_weights_1_6_21_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_6_21_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_1_6_21_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_6_21_reg))
#define  SRNN_wdsr_layer4_3x3_weights_1_6_21_layer4_weight_21_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_1_6_21_layer4_weight_21_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_1_6_21_layer4_weight_21(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_1_6_21_get_layer4_weight_21(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_1_6_22                                    0x181AC0F4
#define  SRNN_wdsr_layer4_3x3_weights_1_6_22_reg_addr                            "0xB81AC0F4"
#define  SRNN_wdsr_layer4_3x3_weights_1_6_22_reg                                 0xB81AC0F4
#define  SRNN_wdsr_layer4_3x3_weights_1_6_22_inst_addr                           "0x0461"
#define  set_SRNN_wdsr_layer4_3x3_weights_1_6_22_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_6_22_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_1_6_22_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_6_22_reg))
#define  SRNN_wdsr_layer4_3x3_weights_1_6_22_layer4_weight_22_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_1_6_22_layer4_weight_22_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_1_6_22_layer4_weight_22(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_1_6_22_get_layer4_weight_22(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_1_7_00                                    0x181AC0F8
#define  SRNN_wdsr_layer4_3x3_weights_1_7_00_reg_addr                            "0xB81AC0F8"
#define  SRNN_wdsr_layer4_3x3_weights_1_7_00_reg                                 0xB81AC0F8
#define  SRNN_wdsr_layer4_3x3_weights_1_7_00_inst_addr                           "0x0462"
#define  set_SRNN_wdsr_layer4_3x3_weights_1_7_00_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_7_00_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_1_7_00_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_7_00_reg))
#define  SRNN_wdsr_layer4_3x3_weights_1_7_00_layer4_weight_00_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_1_7_00_layer4_weight_00_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_1_7_00_layer4_weight_00(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_1_7_00_get_layer4_weight_00(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_1_7_01                                    0x181AC0FC
#define  SRNN_wdsr_layer4_3x3_weights_1_7_01_reg_addr                            "0xB81AC0FC"
#define  SRNN_wdsr_layer4_3x3_weights_1_7_01_reg                                 0xB81AC0FC
#define  SRNN_wdsr_layer4_3x3_weights_1_7_01_inst_addr                           "0x0463"
#define  set_SRNN_wdsr_layer4_3x3_weights_1_7_01_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_7_01_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_1_7_01_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_7_01_reg))
#define  SRNN_wdsr_layer4_3x3_weights_1_7_01_layer4_weight_01_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_1_7_01_layer4_weight_01_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_1_7_01_layer4_weight_01(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_1_7_01_get_layer4_weight_01(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_1_7_02                                    0x181AC100
#define  SRNN_wdsr_layer4_3x3_weights_1_7_02_reg_addr                            "0xB81AC100"
#define  SRNN_wdsr_layer4_3x3_weights_1_7_02_reg                                 0xB81AC100
#define  SRNN_wdsr_layer4_3x3_weights_1_7_02_inst_addr                           "0x0464"
#define  set_SRNN_wdsr_layer4_3x3_weights_1_7_02_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_7_02_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_1_7_02_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_7_02_reg))
#define  SRNN_wdsr_layer4_3x3_weights_1_7_02_layer4_weight_02_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_1_7_02_layer4_weight_02_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_1_7_02_layer4_weight_02(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_1_7_02_get_layer4_weight_02(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_1_7_10                                    0x181AC104
#define  SRNN_wdsr_layer4_3x3_weights_1_7_10_reg_addr                            "0xB81AC104"
#define  SRNN_wdsr_layer4_3x3_weights_1_7_10_reg                                 0xB81AC104
#define  SRNN_wdsr_layer4_3x3_weights_1_7_10_inst_addr                           "0x0465"
#define  set_SRNN_wdsr_layer4_3x3_weights_1_7_10_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_7_10_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_1_7_10_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_7_10_reg))
#define  SRNN_wdsr_layer4_3x3_weights_1_7_10_layer4_weight_10_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_1_7_10_layer4_weight_10_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_1_7_10_layer4_weight_10(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_1_7_10_get_layer4_weight_10(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_1_7_11                                    0x181AC108
#define  SRNN_wdsr_layer4_3x3_weights_1_7_11_reg_addr                            "0xB81AC108"
#define  SRNN_wdsr_layer4_3x3_weights_1_7_11_reg                                 0xB81AC108
#define  SRNN_wdsr_layer4_3x3_weights_1_7_11_inst_addr                           "0x0466"
#define  set_SRNN_wdsr_layer4_3x3_weights_1_7_11_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_7_11_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_1_7_11_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_7_11_reg))
#define  SRNN_wdsr_layer4_3x3_weights_1_7_11_layer4_weight_11_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_1_7_11_layer4_weight_11_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_1_7_11_layer4_weight_11(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_1_7_11_get_layer4_weight_11(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_1_7_12                                    0x181AC10C
#define  SRNN_wdsr_layer4_3x3_weights_1_7_12_reg_addr                            "0xB81AC10C"
#define  SRNN_wdsr_layer4_3x3_weights_1_7_12_reg                                 0xB81AC10C
#define  SRNN_wdsr_layer4_3x3_weights_1_7_12_inst_addr                           "0x0467"
#define  set_SRNN_wdsr_layer4_3x3_weights_1_7_12_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_7_12_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_1_7_12_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_7_12_reg))
#define  SRNN_wdsr_layer4_3x3_weights_1_7_12_layer4_weight_12_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_1_7_12_layer4_weight_12_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_1_7_12_layer4_weight_12(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_1_7_12_get_layer4_weight_12(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_1_7_20                                    0x181AC110
#define  SRNN_wdsr_layer4_3x3_weights_1_7_20_reg_addr                            "0xB81AC110"
#define  SRNN_wdsr_layer4_3x3_weights_1_7_20_reg                                 0xB81AC110
#define  SRNN_wdsr_layer4_3x3_weights_1_7_20_inst_addr                           "0x0468"
#define  set_SRNN_wdsr_layer4_3x3_weights_1_7_20_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_7_20_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_1_7_20_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_7_20_reg))
#define  SRNN_wdsr_layer4_3x3_weights_1_7_20_layer4_weight_20_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_1_7_20_layer4_weight_20_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_1_7_20_layer4_weight_20(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_1_7_20_get_layer4_weight_20(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_1_7_21                                    0x181AC114
#define  SRNN_wdsr_layer4_3x3_weights_1_7_21_reg_addr                            "0xB81AC114"
#define  SRNN_wdsr_layer4_3x3_weights_1_7_21_reg                                 0xB81AC114
#define  SRNN_wdsr_layer4_3x3_weights_1_7_21_inst_addr                           "0x0469"
#define  set_SRNN_wdsr_layer4_3x3_weights_1_7_21_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_7_21_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_1_7_21_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_7_21_reg))
#define  SRNN_wdsr_layer4_3x3_weights_1_7_21_layer4_weight_21_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_1_7_21_layer4_weight_21_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_1_7_21_layer4_weight_21(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_1_7_21_get_layer4_weight_21(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_1_7_22                                    0x181AC118
#define  SRNN_wdsr_layer4_3x3_weights_1_7_22_reg_addr                            "0xB81AC118"
#define  SRNN_wdsr_layer4_3x3_weights_1_7_22_reg                                 0xB81AC118
#define  SRNN_wdsr_layer4_3x3_weights_1_7_22_inst_addr                           "0x046A"
#define  set_SRNN_wdsr_layer4_3x3_weights_1_7_22_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_7_22_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_1_7_22_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_7_22_reg))
#define  SRNN_wdsr_layer4_3x3_weights_1_7_22_layer4_weight_22_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_1_7_22_layer4_weight_22_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_1_7_22_layer4_weight_22(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_1_7_22_get_layer4_weight_22(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_1_8_00                                    0x181AC11C
#define  SRNN_wdsr_layer4_3x3_weights_1_8_00_reg_addr                            "0xB81AC11C"
#define  SRNN_wdsr_layer4_3x3_weights_1_8_00_reg                                 0xB81AC11C
#define  SRNN_wdsr_layer4_3x3_weights_1_8_00_inst_addr                           "0x046B"
#define  set_SRNN_wdsr_layer4_3x3_weights_1_8_00_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_8_00_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_1_8_00_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_8_00_reg))
#define  SRNN_wdsr_layer4_3x3_weights_1_8_00_layer4_weight_00_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_1_8_00_layer4_weight_00_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_1_8_00_layer4_weight_00(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_1_8_00_get_layer4_weight_00(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_1_8_01                                    0x181AC120
#define  SRNN_wdsr_layer4_3x3_weights_1_8_01_reg_addr                            "0xB81AC120"
#define  SRNN_wdsr_layer4_3x3_weights_1_8_01_reg                                 0xB81AC120
#define  SRNN_wdsr_layer4_3x3_weights_1_8_01_inst_addr                           "0x046C"
#define  set_SRNN_wdsr_layer4_3x3_weights_1_8_01_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_8_01_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_1_8_01_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_8_01_reg))
#define  SRNN_wdsr_layer4_3x3_weights_1_8_01_layer4_weight_01_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_1_8_01_layer4_weight_01_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_1_8_01_layer4_weight_01(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_1_8_01_get_layer4_weight_01(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_1_8_02                                    0x181AC124
#define  SRNN_wdsr_layer4_3x3_weights_1_8_02_reg_addr                            "0xB81AC124"
#define  SRNN_wdsr_layer4_3x3_weights_1_8_02_reg                                 0xB81AC124
#define  SRNN_wdsr_layer4_3x3_weights_1_8_02_inst_addr                           "0x046D"
#define  set_SRNN_wdsr_layer4_3x3_weights_1_8_02_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_8_02_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_1_8_02_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_8_02_reg))
#define  SRNN_wdsr_layer4_3x3_weights_1_8_02_layer4_weight_02_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_1_8_02_layer4_weight_02_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_1_8_02_layer4_weight_02(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_1_8_02_get_layer4_weight_02(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_1_8_10                                    0x181AC128
#define  SRNN_wdsr_layer4_3x3_weights_1_8_10_reg_addr                            "0xB81AC128"
#define  SRNN_wdsr_layer4_3x3_weights_1_8_10_reg                                 0xB81AC128
#define  SRNN_wdsr_layer4_3x3_weights_1_8_10_inst_addr                           "0x046E"
#define  set_SRNN_wdsr_layer4_3x3_weights_1_8_10_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_8_10_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_1_8_10_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_8_10_reg))
#define  SRNN_wdsr_layer4_3x3_weights_1_8_10_layer4_weight_10_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_1_8_10_layer4_weight_10_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_1_8_10_layer4_weight_10(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_1_8_10_get_layer4_weight_10(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_1_8_11                                    0x181AC12C
#define  SRNN_wdsr_layer4_3x3_weights_1_8_11_reg_addr                            "0xB81AC12C"
#define  SRNN_wdsr_layer4_3x3_weights_1_8_11_reg                                 0xB81AC12C
#define  SRNN_wdsr_layer4_3x3_weights_1_8_11_inst_addr                           "0x046F"
#define  set_SRNN_wdsr_layer4_3x3_weights_1_8_11_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_8_11_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_1_8_11_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_8_11_reg))
#define  SRNN_wdsr_layer4_3x3_weights_1_8_11_layer4_weight_11_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_1_8_11_layer4_weight_11_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_1_8_11_layer4_weight_11(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_1_8_11_get_layer4_weight_11(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_1_8_12                                    0x181AC130
#define  SRNN_wdsr_layer4_3x3_weights_1_8_12_reg_addr                            "0xB81AC130"
#define  SRNN_wdsr_layer4_3x3_weights_1_8_12_reg                                 0xB81AC130
#define  SRNN_wdsr_layer4_3x3_weights_1_8_12_inst_addr                           "0x0470"
#define  set_SRNN_wdsr_layer4_3x3_weights_1_8_12_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_8_12_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_1_8_12_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_8_12_reg))
#define  SRNN_wdsr_layer4_3x3_weights_1_8_12_layer4_weight_12_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_1_8_12_layer4_weight_12_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_1_8_12_layer4_weight_12(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_1_8_12_get_layer4_weight_12(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_1_8_20                                    0x181AC134
#define  SRNN_wdsr_layer4_3x3_weights_1_8_20_reg_addr                            "0xB81AC134"
#define  SRNN_wdsr_layer4_3x3_weights_1_8_20_reg                                 0xB81AC134
#define  SRNN_wdsr_layer4_3x3_weights_1_8_20_inst_addr                           "0x0471"
#define  set_SRNN_wdsr_layer4_3x3_weights_1_8_20_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_8_20_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_1_8_20_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_8_20_reg))
#define  SRNN_wdsr_layer4_3x3_weights_1_8_20_layer4_weight_20_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_1_8_20_layer4_weight_20_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_1_8_20_layer4_weight_20(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_1_8_20_get_layer4_weight_20(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_1_8_21                                    0x181AC138
#define  SRNN_wdsr_layer4_3x3_weights_1_8_21_reg_addr                            "0xB81AC138"
#define  SRNN_wdsr_layer4_3x3_weights_1_8_21_reg                                 0xB81AC138
#define  SRNN_wdsr_layer4_3x3_weights_1_8_21_inst_addr                           "0x0472"
#define  set_SRNN_wdsr_layer4_3x3_weights_1_8_21_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_8_21_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_1_8_21_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_8_21_reg))
#define  SRNN_wdsr_layer4_3x3_weights_1_8_21_layer4_weight_21_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_1_8_21_layer4_weight_21_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_1_8_21_layer4_weight_21(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_1_8_21_get_layer4_weight_21(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_1_8_22                                    0x181AC13C
#define  SRNN_wdsr_layer4_3x3_weights_1_8_22_reg_addr                            "0xB81AC13C"
#define  SRNN_wdsr_layer4_3x3_weights_1_8_22_reg                                 0xB81AC13C
#define  SRNN_wdsr_layer4_3x3_weights_1_8_22_inst_addr                           "0x0473"
#define  set_SRNN_wdsr_layer4_3x3_weights_1_8_22_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_8_22_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_1_8_22_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_1_8_22_reg))
#define  SRNN_wdsr_layer4_3x3_weights_1_8_22_layer4_weight_22_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_1_8_22_layer4_weight_22_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_1_8_22_layer4_weight_22(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_1_8_22_get_layer4_weight_22(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_2_1_00                                    0x181AC140
#define  SRNN_wdsr_layer4_3x3_weights_2_1_00_reg_addr                            "0xB81AC140"
#define  SRNN_wdsr_layer4_3x3_weights_2_1_00_reg                                 0xB81AC140
#define  SRNN_wdsr_layer4_3x3_weights_2_1_00_inst_addr                           "0x0474"
#define  set_SRNN_wdsr_layer4_3x3_weights_2_1_00_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_1_00_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_2_1_00_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_1_00_reg))
#define  SRNN_wdsr_layer4_3x3_weights_2_1_00_layer4_weight_00_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_2_1_00_layer4_weight_00_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_2_1_00_layer4_weight_00(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_2_1_00_get_layer4_weight_00(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_2_1_01                                    0x181AC144
#define  SRNN_wdsr_layer4_3x3_weights_2_1_01_reg_addr                            "0xB81AC144"
#define  SRNN_wdsr_layer4_3x3_weights_2_1_01_reg                                 0xB81AC144
#define  SRNN_wdsr_layer4_3x3_weights_2_1_01_inst_addr                           "0x0475"
#define  set_SRNN_wdsr_layer4_3x3_weights_2_1_01_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_1_01_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_2_1_01_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_1_01_reg))
#define  SRNN_wdsr_layer4_3x3_weights_2_1_01_layer4_weight_01_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_2_1_01_layer4_weight_01_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_2_1_01_layer4_weight_01(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_2_1_01_get_layer4_weight_01(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_2_1_02                                    0x181AC148
#define  SRNN_wdsr_layer4_3x3_weights_2_1_02_reg_addr                            "0xB81AC148"
#define  SRNN_wdsr_layer4_3x3_weights_2_1_02_reg                                 0xB81AC148
#define  SRNN_wdsr_layer4_3x3_weights_2_1_02_inst_addr                           "0x0476"
#define  set_SRNN_wdsr_layer4_3x3_weights_2_1_02_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_1_02_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_2_1_02_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_1_02_reg))
#define  SRNN_wdsr_layer4_3x3_weights_2_1_02_layer4_weight_02_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_2_1_02_layer4_weight_02_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_2_1_02_layer4_weight_02(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_2_1_02_get_layer4_weight_02(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_2_1_10                                    0x181AC14C
#define  SRNN_wdsr_layer4_3x3_weights_2_1_10_reg_addr                            "0xB81AC14C"
#define  SRNN_wdsr_layer4_3x3_weights_2_1_10_reg                                 0xB81AC14C
#define  SRNN_wdsr_layer4_3x3_weights_2_1_10_inst_addr                           "0x0477"
#define  set_SRNN_wdsr_layer4_3x3_weights_2_1_10_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_1_10_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_2_1_10_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_1_10_reg))
#define  SRNN_wdsr_layer4_3x3_weights_2_1_10_layer4_weight_10_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_2_1_10_layer4_weight_10_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_2_1_10_layer4_weight_10(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_2_1_10_get_layer4_weight_10(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_2_1_11                                    0x181AC150
#define  SRNN_wdsr_layer4_3x3_weights_2_1_11_reg_addr                            "0xB81AC150"
#define  SRNN_wdsr_layer4_3x3_weights_2_1_11_reg                                 0xB81AC150
#define  SRNN_wdsr_layer4_3x3_weights_2_1_11_inst_addr                           "0x0478"
#define  set_SRNN_wdsr_layer4_3x3_weights_2_1_11_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_1_11_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_2_1_11_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_1_11_reg))
#define  SRNN_wdsr_layer4_3x3_weights_2_1_11_layer4_weight_11_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_2_1_11_layer4_weight_11_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_2_1_11_layer4_weight_11(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_2_1_11_get_layer4_weight_11(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_2_1_12                                    0x181AC154
#define  SRNN_wdsr_layer4_3x3_weights_2_1_12_reg_addr                            "0xB81AC154"
#define  SRNN_wdsr_layer4_3x3_weights_2_1_12_reg                                 0xB81AC154
#define  SRNN_wdsr_layer4_3x3_weights_2_1_12_inst_addr                           "0x0479"
#define  set_SRNN_wdsr_layer4_3x3_weights_2_1_12_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_1_12_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_2_1_12_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_1_12_reg))
#define  SRNN_wdsr_layer4_3x3_weights_2_1_12_layer4_weight_12_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_2_1_12_layer4_weight_12_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_2_1_12_layer4_weight_12(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_2_1_12_get_layer4_weight_12(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_2_1_20                                    0x181AC158
#define  SRNN_wdsr_layer4_3x3_weights_2_1_20_reg_addr                            "0xB81AC158"
#define  SRNN_wdsr_layer4_3x3_weights_2_1_20_reg                                 0xB81AC158
#define  SRNN_wdsr_layer4_3x3_weights_2_1_20_inst_addr                           "0x047A"
#define  set_SRNN_wdsr_layer4_3x3_weights_2_1_20_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_1_20_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_2_1_20_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_1_20_reg))
#define  SRNN_wdsr_layer4_3x3_weights_2_1_20_layer4_weight_20_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_2_1_20_layer4_weight_20_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_2_1_20_layer4_weight_20(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_2_1_20_get_layer4_weight_20(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_2_1_21                                    0x181AC15C
#define  SRNN_wdsr_layer4_3x3_weights_2_1_21_reg_addr                            "0xB81AC15C"
#define  SRNN_wdsr_layer4_3x3_weights_2_1_21_reg                                 0xB81AC15C
#define  SRNN_wdsr_layer4_3x3_weights_2_1_21_inst_addr                           "0x047B"
#define  set_SRNN_wdsr_layer4_3x3_weights_2_1_21_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_1_21_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_2_1_21_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_1_21_reg))
#define  SRNN_wdsr_layer4_3x3_weights_2_1_21_layer4_weight_21_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_2_1_21_layer4_weight_21_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_2_1_21_layer4_weight_21(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_2_1_21_get_layer4_weight_21(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_2_1_22                                    0x181AC160
#define  SRNN_wdsr_layer4_3x3_weights_2_1_22_reg_addr                            "0xB81AC160"
#define  SRNN_wdsr_layer4_3x3_weights_2_1_22_reg                                 0xB81AC160
#define  SRNN_wdsr_layer4_3x3_weights_2_1_22_inst_addr                           "0x047C"
#define  set_SRNN_wdsr_layer4_3x3_weights_2_1_22_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_1_22_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_2_1_22_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_1_22_reg))
#define  SRNN_wdsr_layer4_3x3_weights_2_1_22_layer4_weight_22_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_2_1_22_layer4_weight_22_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_2_1_22_layer4_weight_22(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_2_1_22_get_layer4_weight_22(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_2_2_00                                    0x181AC164
#define  SRNN_wdsr_layer4_3x3_weights_2_2_00_reg_addr                            "0xB81AC164"
#define  SRNN_wdsr_layer4_3x3_weights_2_2_00_reg                                 0xB81AC164
#define  SRNN_wdsr_layer4_3x3_weights_2_2_00_inst_addr                           "0x047D"
#define  set_SRNN_wdsr_layer4_3x3_weights_2_2_00_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_2_00_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_2_2_00_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_2_00_reg))
#define  SRNN_wdsr_layer4_3x3_weights_2_2_00_layer4_weight_00_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_2_2_00_layer4_weight_00_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_2_2_00_layer4_weight_00(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_2_2_00_get_layer4_weight_00(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_2_2_01                                    0x181AC168
#define  SRNN_wdsr_layer4_3x3_weights_2_2_01_reg_addr                            "0xB81AC168"
#define  SRNN_wdsr_layer4_3x3_weights_2_2_01_reg                                 0xB81AC168
#define  SRNN_wdsr_layer4_3x3_weights_2_2_01_inst_addr                           "0x047E"
#define  set_SRNN_wdsr_layer4_3x3_weights_2_2_01_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_2_01_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_2_2_01_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_2_01_reg))
#define  SRNN_wdsr_layer4_3x3_weights_2_2_01_layer4_weight_01_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_2_2_01_layer4_weight_01_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_2_2_01_layer4_weight_01(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_2_2_01_get_layer4_weight_01(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_2_2_02                                    0x181AC16C
#define  SRNN_wdsr_layer4_3x3_weights_2_2_02_reg_addr                            "0xB81AC16C"
#define  SRNN_wdsr_layer4_3x3_weights_2_2_02_reg                                 0xB81AC16C
#define  SRNN_wdsr_layer4_3x3_weights_2_2_02_inst_addr                           "0x047F"
#define  set_SRNN_wdsr_layer4_3x3_weights_2_2_02_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_2_02_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_2_2_02_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_2_02_reg))
#define  SRNN_wdsr_layer4_3x3_weights_2_2_02_layer4_weight_02_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_2_2_02_layer4_weight_02_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_2_2_02_layer4_weight_02(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_2_2_02_get_layer4_weight_02(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_2_2_10                                    0x181AC170
#define  SRNN_wdsr_layer4_3x3_weights_2_2_10_reg_addr                            "0xB81AC170"
#define  SRNN_wdsr_layer4_3x3_weights_2_2_10_reg                                 0xB81AC170
#define  SRNN_wdsr_layer4_3x3_weights_2_2_10_inst_addr                           "0x0480"
#define  set_SRNN_wdsr_layer4_3x3_weights_2_2_10_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_2_10_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_2_2_10_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_2_10_reg))
#define  SRNN_wdsr_layer4_3x3_weights_2_2_10_layer4_weight_10_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_2_2_10_layer4_weight_10_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_2_2_10_layer4_weight_10(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_2_2_10_get_layer4_weight_10(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_2_2_11                                    0x181AC174
#define  SRNN_wdsr_layer4_3x3_weights_2_2_11_reg_addr                            "0xB81AC174"
#define  SRNN_wdsr_layer4_3x3_weights_2_2_11_reg                                 0xB81AC174
#define  SRNN_wdsr_layer4_3x3_weights_2_2_11_inst_addr                           "0x0481"
#define  set_SRNN_wdsr_layer4_3x3_weights_2_2_11_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_2_11_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_2_2_11_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_2_11_reg))
#define  SRNN_wdsr_layer4_3x3_weights_2_2_11_layer4_weight_11_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_2_2_11_layer4_weight_11_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_2_2_11_layer4_weight_11(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_2_2_11_get_layer4_weight_11(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_2_2_12                                    0x181AC178
#define  SRNN_wdsr_layer4_3x3_weights_2_2_12_reg_addr                            "0xB81AC178"
#define  SRNN_wdsr_layer4_3x3_weights_2_2_12_reg                                 0xB81AC178
#define  SRNN_wdsr_layer4_3x3_weights_2_2_12_inst_addr                           "0x0482"
#define  set_SRNN_wdsr_layer4_3x3_weights_2_2_12_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_2_12_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_2_2_12_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_2_12_reg))
#define  SRNN_wdsr_layer4_3x3_weights_2_2_12_layer4_weight_12_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_2_2_12_layer4_weight_12_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_2_2_12_layer4_weight_12(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_2_2_12_get_layer4_weight_12(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_2_2_20                                    0x181AC17C
#define  SRNN_wdsr_layer4_3x3_weights_2_2_20_reg_addr                            "0xB81AC17C"
#define  SRNN_wdsr_layer4_3x3_weights_2_2_20_reg                                 0xB81AC17C
#define  SRNN_wdsr_layer4_3x3_weights_2_2_20_inst_addr                           "0x0483"
#define  set_SRNN_wdsr_layer4_3x3_weights_2_2_20_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_2_20_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_2_2_20_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_2_20_reg))
#define  SRNN_wdsr_layer4_3x3_weights_2_2_20_layer4_weight_20_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_2_2_20_layer4_weight_20_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_2_2_20_layer4_weight_20(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_2_2_20_get_layer4_weight_20(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_2_2_21                                    0x181AC180
#define  SRNN_wdsr_layer4_3x3_weights_2_2_21_reg_addr                            "0xB81AC180"
#define  SRNN_wdsr_layer4_3x3_weights_2_2_21_reg                                 0xB81AC180
#define  SRNN_wdsr_layer4_3x3_weights_2_2_21_inst_addr                           "0x0484"
#define  set_SRNN_wdsr_layer4_3x3_weights_2_2_21_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_2_21_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_2_2_21_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_2_21_reg))
#define  SRNN_wdsr_layer4_3x3_weights_2_2_21_layer4_weight_21_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_2_2_21_layer4_weight_21_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_2_2_21_layer4_weight_21(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_2_2_21_get_layer4_weight_21(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_2_2_22                                    0x181AC184
#define  SRNN_wdsr_layer4_3x3_weights_2_2_22_reg_addr                            "0xB81AC184"
#define  SRNN_wdsr_layer4_3x3_weights_2_2_22_reg                                 0xB81AC184
#define  SRNN_wdsr_layer4_3x3_weights_2_2_22_inst_addr                           "0x0485"
#define  set_SRNN_wdsr_layer4_3x3_weights_2_2_22_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_2_22_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_2_2_22_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_2_22_reg))
#define  SRNN_wdsr_layer4_3x3_weights_2_2_22_layer4_weight_22_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_2_2_22_layer4_weight_22_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_2_2_22_layer4_weight_22(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_2_2_22_get_layer4_weight_22(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_2_3_00                                    0x181AC188
#define  SRNN_wdsr_layer4_3x3_weights_2_3_00_reg_addr                            "0xB81AC188"
#define  SRNN_wdsr_layer4_3x3_weights_2_3_00_reg                                 0xB81AC188
#define  SRNN_wdsr_layer4_3x3_weights_2_3_00_inst_addr                           "0x0486"
#define  set_SRNN_wdsr_layer4_3x3_weights_2_3_00_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_3_00_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_2_3_00_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_3_00_reg))
#define  SRNN_wdsr_layer4_3x3_weights_2_3_00_layer4_weight_00_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_2_3_00_layer4_weight_00_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_2_3_00_layer4_weight_00(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_2_3_00_get_layer4_weight_00(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_2_3_01                                    0x181AC18C
#define  SRNN_wdsr_layer4_3x3_weights_2_3_01_reg_addr                            "0xB81AC18C"
#define  SRNN_wdsr_layer4_3x3_weights_2_3_01_reg                                 0xB81AC18C
#define  SRNN_wdsr_layer4_3x3_weights_2_3_01_inst_addr                           "0x0487"
#define  set_SRNN_wdsr_layer4_3x3_weights_2_3_01_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_3_01_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_2_3_01_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_3_01_reg))
#define  SRNN_wdsr_layer4_3x3_weights_2_3_01_layer4_weight_01_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_2_3_01_layer4_weight_01_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_2_3_01_layer4_weight_01(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_2_3_01_get_layer4_weight_01(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_2_3_02                                    0x181AC190
#define  SRNN_wdsr_layer4_3x3_weights_2_3_02_reg_addr                            "0xB81AC190"
#define  SRNN_wdsr_layer4_3x3_weights_2_3_02_reg                                 0xB81AC190
#define  SRNN_wdsr_layer4_3x3_weights_2_3_02_inst_addr                           "0x0488"
#define  set_SRNN_wdsr_layer4_3x3_weights_2_3_02_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_3_02_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_2_3_02_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_3_02_reg))
#define  SRNN_wdsr_layer4_3x3_weights_2_3_02_layer4_weight_02_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_2_3_02_layer4_weight_02_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_2_3_02_layer4_weight_02(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_2_3_02_get_layer4_weight_02(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_2_3_10                                    0x181AC194
#define  SRNN_wdsr_layer4_3x3_weights_2_3_10_reg_addr                            "0xB81AC194"
#define  SRNN_wdsr_layer4_3x3_weights_2_3_10_reg                                 0xB81AC194
#define  SRNN_wdsr_layer4_3x3_weights_2_3_10_inst_addr                           "0x0489"
#define  set_SRNN_wdsr_layer4_3x3_weights_2_3_10_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_3_10_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_2_3_10_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_3_10_reg))
#define  SRNN_wdsr_layer4_3x3_weights_2_3_10_layer4_weight_10_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_2_3_10_layer4_weight_10_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_2_3_10_layer4_weight_10(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_2_3_10_get_layer4_weight_10(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_2_3_11                                    0x181AC198
#define  SRNN_wdsr_layer4_3x3_weights_2_3_11_reg_addr                            "0xB81AC198"
#define  SRNN_wdsr_layer4_3x3_weights_2_3_11_reg                                 0xB81AC198
#define  SRNN_wdsr_layer4_3x3_weights_2_3_11_inst_addr                           "0x048A"
#define  set_SRNN_wdsr_layer4_3x3_weights_2_3_11_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_3_11_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_2_3_11_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_3_11_reg))
#define  SRNN_wdsr_layer4_3x3_weights_2_3_11_layer4_weight_11_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_2_3_11_layer4_weight_11_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_2_3_11_layer4_weight_11(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_2_3_11_get_layer4_weight_11(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_2_3_12                                    0x181AC19C
#define  SRNN_wdsr_layer4_3x3_weights_2_3_12_reg_addr                            "0xB81AC19C"
#define  SRNN_wdsr_layer4_3x3_weights_2_3_12_reg                                 0xB81AC19C
#define  SRNN_wdsr_layer4_3x3_weights_2_3_12_inst_addr                           "0x048B"
#define  set_SRNN_wdsr_layer4_3x3_weights_2_3_12_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_3_12_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_2_3_12_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_3_12_reg))
#define  SRNN_wdsr_layer4_3x3_weights_2_3_12_layer4_weight_12_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_2_3_12_layer4_weight_12_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_2_3_12_layer4_weight_12(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_2_3_12_get_layer4_weight_12(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_2_3_20                                    0x181AC1A0
#define  SRNN_wdsr_layer4_3x3_weights_2_3_20_reg_addr                            "0xB81AC1A0"
#define  SRNN_wdsr_layer4_3x3_weights_2_3_20_reg                                 0xB81AC1A0
#define  SRNN_wdsr_layer4_3x3_weights_2_3_20_inst_addr                           "0x048C"
#define  set_SRNN_wdsr_layer4_3x3_weights_2_3_20_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_3_20_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_2_3_20_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_3_20_reg))
#define  SRNN_wdsr_layer4_3x3_weights_2_3_20_layer4_weight_20_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_2_3_20_layer4_weight_20_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_2_3_20_layer4_weight_20(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_2_3_20_get_layer4_weight_20(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_2_3_21                                    0x181AC1A4
#define  SRNN_wdsr_layer4_3x3_weights_2_3_21_reg_addr                            "0xB81AC1A4"
#define  SRNN_wdsr_layer4_3x3_weights_2_3_21_reg                                 0xB81AC1A4
#define  SRNN_wdsr_layer4_3x3_weights_2_3_21_inst_addr                           "0x048D"
#define  set_SRNN_wdsr_layer4_3x3_weights_2_3_21_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_3_21_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_2_3_21_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_3_21_reg))
#define  SRNN_wdsr_layer4_3x3_weights_2_3_21_layer4_weight_21_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_2_3_21_layer4_weight_21_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_2_3_21_layer4_weight_21(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_2_3_21_get_layer4_weight_21(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_2_3_22                                    0x181AC1A8
#define  SRNN_wdsr_layer4_3x3_weights_2_3_22_reg_addr                            "0xB81AC1A8"
#define  SRNN_wdsr_layer4_3x3_weights_2_3_22_reg                                 0xB81AC1A8
#define  SRNN_wdsr_layer4_3x3_weights_2_3_22_inst_addr                           "0x048E"
#define  set_SRNN_wdsr_layer4_3x3_weights_2_3_22_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_3_22_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_2_3_22_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_3_22_reg))
#define  SRNN_wdsr_layer4_3x3_weights_2_3_22_layer4_weight_22_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_2_3_22_layer4_weight_22_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_2_3_22_layer4_weight_22(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_2_3_22_get_layer4_weight_22(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_2_4_00                                    0x181AC1AC
#define  SRNN_wdsr_layer4_3x3_weights_2_4_00_reg_addr                            "0xB81AC1AC"
#define  SRNN_wdsr_layer4_3x3_weights_2_4_00_reg                                 0xB81AC1AC
#define  SRNN_wdsr_layer4_3x3_weights_2_4_00_inst_addr                           "0x048F"
#define  set_SRNN_wdsr_layer4_3x3_weights_2_4_00_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_4_00_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_2_4_00_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_4_00_reg))
#define  SRNN_wdsr_layer4_3x3_weights_2_4_00_layer4_weight_00_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_2_4_00_layer4_weight_00_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_2_4_00_layer4_weight_00(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_2_4_00_get_layer4_weight_00(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_2_4_01                                    0x181AC1B0
#define  SRNN_wdsr_layer4_3x3_weights_2_4_01_reg_addr                            "0xB81AC1B0"
#define  SRNN_wdsr_layer4_3x3_weights_2_4_01_reg                                 0xB81AC1B0
#define  SRNN_wdsr_layer4_3x3_weights_2_4_01_inst_addr                           "0x0490"
#define  set_SRNN_wdsr_layer4_3x3_weights_2_4_01_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_4_01_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_2_4_01_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_4_01_reg))
#define  SRNN_wdsr_layer4_3x3_weights_2_4_01_layer4_weight_01_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_2_4_01_layer4_weight_01_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_2_4_01_layer4_weight_01(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_2_4_01_get_layer4_weight_01(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_2_4_02                                    0x181AC1B4
#define  SRNN_wdsr_layer4_3x3_weights_2_4_02_reg_addr                            "0xB81AC1B4"
#define  SRNN_wdsr_layer4_3x3_weights_2_4_02_reg                                 0xB81AC1B4
#define  SRNN_wdsr_layer4_3x3_weights_2_4_02_inst_addr                           "0x0491"
#define  set_SRNN_wdsr_layer4_3x3_weights_2_4_02_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_4_02_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_2_4_02_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_4_02_reg))
#define  SRNN_wdsr_layer4_3x3_weights_2_4_02_layer4_weight_02_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_2_4_02_layer4_weight_02_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_2_4_02_layer4_weight_02(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_2_4_02_get_layer4_weight_02(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_2_4_10                                    0x181AC1B8
#define  SRNN_wdsr_layer4_3x3_weights_2_4_10_reg_addr                            "0xB81AC1B8"
#define  SRNN_wdsr_layer4_3x3_weights_2_4_10_reg                                 0xB81AC1B8
#define  SRNN_wdsr_layer4_3x3_weights_2_4_10_inst_addr                           "0x0492"
#define  set_SRNN_wdsr_layer4_3x3_weights_2_4_10_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_4_10_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_2_4_10_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_4_10_reg))
#define  SRNN_wdsr_layer4_3x3_weights_2_4_10_layer4_weight_10_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_2_4_10_layer4_weight_10_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_2_4_10_layer4_weight_10(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_2_4_10_get_layer4_weight_10(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_2_4_11                                    0x181AC1BC
#define  SRNN_wdsr_layer4_3x3_weights_2_4_11_reg_addr                            "0xB81AC1BC"
#define  SRNN_wdsr_layer4_3x3_weights_2_4_11_reg                                 0xB81AC1BC
#define  SRNN_wdsr_layer4_3x3_weights_2_4_11_inst_addr                           "0x0493"
#define  set_SRNN_wdsr_layer4_3x3_weights_2_4_11_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_4_11_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_2_4_11_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_4_11_reg))
#define  SRNN_wdsr_layer4_3x3_weights_2_4_11_layer4_weight_11_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_2_4_11_layer4_weight_11_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_2_4_11_layer4_weight_11(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_2_4_11_get_layer4_weight_11(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_2_4_12                                    0x181AC1C0
#define  SRNN_wdsr_layer4_3x3_weights_2_4_12_reg_addr                            "0xB81AC1C0"
#define  SRNN_wdsr_layer4_3x3_weights_2_4_12_reg                                 0xB81AC1C0
#define  SRNN_wdsr_layer4_3x3_weights_2_4_12_inst_addr                           "0x0494"
#define  set_SRNN_wdsr_layer4_3x3_weights_2_4_12_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_4_12_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_2_4_12_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_4_12_reg))
#define  SRNN_wdsr_layer4_3x3_weights_2_4_12_layer4_weight_12_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_2_4_12_layer4_weight_12_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_2_4_12_layer4_weight_12(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_2_4_12_get_layer4_weight_12(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_2_4_20                                    0x181AC1C4
#define  SRNN_wdsr_layer4_3x3_weights_2_4_20_reg_addr                            "0xB81AC1C4"
#define  SRNN_wdsr_layer4_3x3_weights_2_4_20_reg                                 0xB81AC1C4
#define  SRNN_wdsr_layer4_3x3_weights_2_4_20_inst_addr                           "0x0495"
#define  set_SRNN_wdsr_layer4_3x3_weights_2_4_20_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_4_20_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_2_4_20_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_4_20_reg))
#define  SRNN_wdsr_layer4_3x3_weights_2_4_20_layer4_weight_20_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_2_4_20_layer4_weight_20_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_2_4_20_layer4_weight_20(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_2_4_20_get_layer4_weight_20(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_2_4_21                                    0x181AC1C8
#define  SRNN_wdsr_layer4_3x3_weights_2_4_21_reg_addr                            "0xB81AC1C8"
#define  SRNN_wdsr_layer4_3x3_weights_2_4_21_reg                                 0xB81AC1C8
#define  SRNN_wdsr_layer4_3x3_weights_2_4_21_inst_addr                           "0x0496"
#define  set_SRNN_wdsr_layer4_3x3_weights_2_4_21_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_4_21_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_2_4_21_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_4_21_reg))
#define  SRNN_wdsr_layer4_3x3_weights_2_4_21_layer4_weight_21_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_2_4_21_layer4_weight_21_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_2_4_21_layer4_weight_21(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_2_4_21_get_layer4_weight_21(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_2_4_22                                    0x181AC1CC
#define  SRNN_wdsr_layer4_3x3_weights_2_4_22_reg_addr                            "0xB81AC1CC"
#define  SRNN_wdsr_layer4_3x3_weights_2_4_22_reg                                 0xB81AC1CC
#define  SRNN_wdsr_layer4_3x3_weights_2_4_22_inst_addr                           "0x0497"
#define  set_SRNN_wdsr_layer4_3x3_weights_2_4_22_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_4_22_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_2_4_22_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_4_22_reg))
#define  SRNN_wdsr_layer4_3x3_weights_2_4_22_layer4_weight_22_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_2_4_22_layer4_weight_22_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_2_4_22_layer4_weight_22(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_2_4_22_get_layer4_weight_22(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_2_5_00                                    0x181AC1D0
#define  SRNN_wdsr_layer4_3x3_weights_2_5_00_reg_addr                            "0xB81AC1D0"
#define  SRNN_wdsr_layer4_3x3_weights_2_5_00_reg                                 0xB81AC1D0
#define  SRNN_wdsr_layer4_3x3_weights_2_5_00_inst_addr                           "0x0498"
#define  set_SRNN_wdsr_layer4_3x3_weights_2_5_00_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_5_00_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_2_5_00_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_5_00_reg))
#define  SRNN_wdsr_layer4_3x3_weights_2_5_00_layer4_weight_00_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_2_5_00_layer4_weight_00_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_2_5_00_layer4_weight_00(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_2_5_00_get_layer4_weight_00(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_2_5_01                                    0x181AC1D4
#define  SRNN_wdsr_layer4_3x3_weights_2_5_01_reg_addr                            "0xB81AC1D4"
#define  SRNN_wdsr_layer4_3x3_weights_2_5_01_reg                                 0xB81AC1D4
#define  SRNN_wdsr_layer4_3x3_weights_2_5_01_inst_addr                           "0x0499"
#define  set_SRNN_wdsr_layer4_3x3_weights_2_5_01_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_5_01_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_2_5_01_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_5_01_reg))
#define  SRNN_wdsr_layer4_3x3_weights_2_5_01_layer4_weight_01_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_2_5_01_layer4_weight_01_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_2_5_01_layer4_weight_01(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_2_5_01_get_layer4_weight_01(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_2_5_02                                    0x181AC1D8
#define  SRNN_wdsr_layer4_3x3_weights_2_5_02_reg_addr                            "0xB81AC1D8"
#define  SRNN_wdsr_layer4_3x3_weights_2_5_02_reg                                 0xB81AC1D8
#define  SRNN_wdsr_layer4_3x3_weights_2_5_02_inst_addr                           "0x049A"
#define  set_SRNN_wdsr_layer4_3x3_weights_2_5_02_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_5_02_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_2_5_02_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_5_02_reg))
#define  SRNN_wdsr_layer4_3x3_weights_2_5_02_layer4_weight_02_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_2_5_02_layer4_weight_02_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_2_5_02_layer4_weight_02(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_2_5_02_get_layer4_weight_02(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_2_5_10                                    0x181AC1DC
#define  SRNN_wdsr_layer4_3x3_weights_2_5_10_reg_addr                            "0xB81AC1DC"
#define  SRNN_wdsr_layer4_3x3_weights_2_5_10_reg                                 0xB81AC1DC
#define  SRNN_wdsr_layer4_3x3_weights_2_5_10_inst_addr                           "0x049B"
#define  set_SRNN_wdsr_layer4_3x3_weights_2_5_10_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_5_10_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_2_5_10_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_5_10_reg))
#define  SRNN_wdsr_layer4_3x3_weights_2_5_10_layer4_weight_10_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_2_5_10_layer4_weight_10_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_2_5_10_layer4_weight_10(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_2_5_10_get_layer4_weight_10(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_2_5_11                                    0x181AC1E0
#define  SRNN_wdsr_layer4_3x3_weights_2_5_11_reg_addr                            "0xB81AC1E0"
#define  SRNN_wdsr_layer4_3x3_weights_2_5_11_reg                                 0xB81AC1E0
#define  SRNN_wdsr_layer4_3x3_weights_2_5_11_inst_addr                           "0x049C"
#define  set_SRNN_wdsr_layer4_3x3_weights_2_5_11_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_5_11_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_2_5_11_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_5_11_reg))
#define  SRNN_wdsr_layer4_3x3_weights_2_5_11_layer4_weight_11_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_2_5_11_layer4_weight_11_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_2_5_11_layer4_weight_11(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_2_5_11_get_layer4_weight_11(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_2_5_12                                    0x181AC1E4
#define  SRNN_wdsr_layer4_3x3_weights_2_5_12_reg_addr                            "0xB81AC1E4"
#define  SRNN_wdsr_layer4_3x3_weights_2_5_12_reg                                 0xB81AC1E4
#define  SRNN_wdsr_layer4_3x3_weights_2_5_12_inst_addr                           "0x049D"
#define  set_SRNN_wdsr_layer4_3x3_weights_2_5_12_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_5_12_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_2_5_12_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_5_12_reg))
#define  SRNN_wdsr_layer4_3x3_weights_2_5_12_layer4_weight_12_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_2_5_12_layer4_weight_12_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_2_5_12_layer4_weight_12(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_2_5_12_get_layer4_weight_12(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_2_5_20                                    0x181AC1E8
#define  SRNN_wdsr_layer4_3x3_weights_2_5_20_reg_addr                            "0xB81AC1E8"
#define  SRNN_wdsr_layer4_3x3_weights_2_5_20_reg                                 0xB81AC1E8
#define  SRNN_wdsr_layer4_3x3_weights_2_5_20_inst_addr                           "0x049E"
#define  set_SRNN_wdsr_layer4_3x3_weights_2_5_20_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_5_20_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_2_5_20_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_5_20_reg))
#define  SRNN_wdsr_layer4_3x3_weights_2_5_20_layer4_weight_20_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_2_5_20_layer4_weight_20_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_2_5_20_layer4_weight_20(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_2_5_20_get_layer4_weight_20(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_2_5_21                                    0x181AC1EC
#define  SRNN_wdsr_layer4_3x3_weights_2_5_21_reg_addr                            "0xB81AC1EC"
#define  SRNN_wdsr_layer4_3x3_weights_2_5_21_reg                                 0xB81AC1EC
#define  SRNN_wdsr_layer4_3x3_weights_2_5_21_inst_addr                           "0x049F"
#define  set_SRNN_wdsr_layer4_3x3_weights_2_5_21_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_5_21_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_2_5_21_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_5_21_reg))
#define  SRNN_wdsr_layer4_3x3_weights_2_5_21_layer4_weight_21_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_2_5_21_layer4_weight_21_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_2_5_21_layer4_weight_21(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_2_5_21_get_layer4_weight_21(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_2_5_22                                    0x181AC1F0
#define  SRNN_wdsr_layer4_3x3_weights_2_5_22_reg_addr                            "0xB81AC1F0"
#define  SRNN_wdsr_layer4_3x3_weights_2_5_22_reg                                 0xB81AC1F0
#define  SRNN_wdsr_layer4_3x3_weights_2_5_22_inst_addr                           "0x04A0"
#define  set_SRNN_wdsr_layer4_3x3_weights_2_5_22_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_5_22_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_2_5_22_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_5_22_reg))
#define  SRNN_wdsr_layer4_3x3_weights_2_5_22_layer4_weight_22_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_2_5_22_layer4_weight_22_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_2_5_22_layer4_weight_22(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_2_5_22_get_layer4_weight_22(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_2_6_00                                    0x181AC1F4
#define  SRNN_wdsr_layer4_3x3_weights_2_6_00_reg_addr                            "0xB81AC1F4"
#define  SRNN_wdsr_layer4_3x3_weights_2_6_00_reg                                 0xB81AC1F4
#define  SRNN_wdsr_layer4_3x3_weights_2_6_00_inst_addr                           "0x04A1"
#define  set_SRNN_wdsr_layer4_3x3_weights_2_6_00_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_6_00_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_2_6_00_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_6_00_reg))
#define  SRNN_wdsr_layer4_3x3_weights_2_6_00_layer4_weight_00_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_2_6_00_layer4_weight_00_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_2_6_00_layer4_weight_00(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_2_6_00_get_layer4_weight_00(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_2_6_01                                    0x181AC1F8
#define  SRNN_wdsr_layer4_3x3_weights_2_6_01_reg_addr                            "0xB81AC1F8"
#define  SRNN_wdsr_layer4_3x3_weights_2_6_01_reg                                 0xB81AC1F8
#define  SRNN_wdsr_layer4_3x3_weights_2_6_01_inst_addr                           "0x04A2"
#define  set_SRNN_wdsr_layer4_3x3_weights_2_6_01_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_6_01_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_2_6_01_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_6_01_reg))
#define  SRNN_wdsr_layer4_3x3_weights_2_6_01_layer4_weight_01_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_2_6_01_layer4_weight_01_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_2_6_01_layer4_weight_01(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_2_6_01_get_layer4_weight_01(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_2_6_02                                    0x181AC1FC
#define  SRNN_wdsr_layer4_3x3_weights_2_6_02_reg_addr                            "0xB81AC1FC"
#define  SRNN_wdsr_layer4_3x3_weights_2_6_02_reg                                 0xB81AC1FC
#define  SRNN_wdsr_layer4_3x3_weights_2_6_02_inst_addr                           "0x04A3"
#define  set_SRNN_wdsr_layer4_3x3_weights_2_6_02_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_6_02_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_2_6_02_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_6_02_reg))
#define  SRNN_wdsr_layer4_3x3_weights_2_6_02_layer4_weight_02_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_2_6_02_layer4_weight_02_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_2_6_02_layer4_weight_02(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_2_6_02_get_layer4_weight_02(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_2_6_10                                    0x181AC200
#define  SRNN_wdsr_layer4_3x3_weights_2_6_10_reg_addr                            "0xB81AC200"
#define  SRNN_wdsr_layer4_3x3_weights_2_6_10_reg                                 0xB81AC200
#define  SRNN_wdsr_layer4_3x3_weights_2_6_10_inst_addr                           "0x04A4"
#define  set_SRNN_wdsr_layer4_3x3_weights_2_6_10_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_6_10_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_2_6_10_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_6_10_reg))
#define  SRNN_wdsr_layer4_3x3_weights_2_6_10_layer4_weight_10_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_2_6_10_layer4_weight_10_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_2_6_10_layer4_weight_10(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_2_6_10_get_layer4_weight_10(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_2_6_11                                    0x181AC204
#define  SRNN_wdsr_layer4_3x3_weights_2_6_11_reg_addr                            "0xB81AC204"
#define  SRNN_wdsr_layer4_3x3_weights_2_6_11_reg                                 0xB81AC204
#define  SRNN_wdsr_layer4_3x3_weights_2_6_11_inst_addr                           "0x04A5"
#define  set_SRNN_wdsr_layer4_3x3_weights_2_6_11_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_6_11_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_2_6_11_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_6_11_reg))
#define  SRNN_wdsr_layer4_3x3_weights_2_6_11_layer4_weight_11_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_2_6_11_layer4_weight_11_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_2_6_11_layer4_weight_11(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_2_6_11_get_layer4_weight_11(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_2_6_12                                    0x181AC208
#define  SRNN_wdsr_layer4_3x3_weights_2_6_12_reg_addr                            "0xB81AC208"
#define  SRNN_wdsr_layer4_3x3_weights_2_6_12_reg                                 0xB81AC208
#define  SRNN_wdsr_layer4_3x3_weights_2_6_12_inst_addr                           "0x04A6"
#define  set_SRNN_wdsr_layer4_3x3_weights_2_6_12_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_6_12_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_2_6_12_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_6_12_reg))
#define  SRNN_wdsr_layer4_3x3_weights_2_6_12_layer4_weight_12_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_2_6_12_layer4_weight_12_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_2_6_12_layer4_weight_12(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_2_6_12_get_layer4_weight_12(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_2_6_20                                    0x181AC20C
#define  SRNN_wdsr_layer4_3x3_weights_2_6_20_reg_addr                            "0xB81AC20C"
#define  SRNN_wdsr_layer4_3x3_weights_2_6_20_reg                                 0xB81AC20C
#define  SRNN_wdsr_layer4_3x3_weights_2_6_20_inst_addr                           "0x04A7"
#define  set_SRNN_wdsr_layer4_3x3_weights_2_6_20_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_6_20_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_2_6_20_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_6_20_reg))
#define  SRNN_wdsr_layer4_3x3_weights_2_6_20_layer4_weight_20_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_2_6_20_layer4_weight_20_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_2_6_20_layer4_weight_20(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_2_6_20_get_layer4_weight_20(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_2_6_21                                    0x181AC210
#define  SRNN_wdsr_layer4_3x3_weights_2_6_21_reg_addr                            "0xB81AC210"
#define  SRNN_wdsr_layer4_3x3_weights_2_6_21_reg                                 0xB81AC210
#define  SRNN_wdsr_layer4_3x3_weights_2_6_21_inst_addr                           "0x04A8"
#define  set_SRNN_wdsr_layer4_3x3_weights_2_6_21_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_6_21_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_2_6_21_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_6_21_reg))
#define  SRNN_wdsr_layer4_3x3_weights_2_6_21_layer4_weight_21_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_2_6_21_layer4_weight_21_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_2_6_21_layer4_weight_21(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_2_6_21_get_layer4_weight_21(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_2_6_22                                    0x181AC214
#define  SRNN_wdsr_layer4_3x3_weights_2_6_22_reg_addr                            "0xB81AC214"
#define  SRNN_wdsr_layer4_3x3_weights_2_6_22_reg                                 0xB81AC214
#define  SRNN_wdsr_layer4_3x3_weights_2_6_22_inst_addr                           "0x04A9"
#define  set_SRNN_wdsr_layer4_3x3_weights_2_6_22_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_6_22_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_2_6_22_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_6_22_reg))
#define  SRNN_wdsr_layer4_3x3_weights_2_6_22_layer4_weight_22_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_2_6_22_layer4_weight_22_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_2_6_22_layer4_weight_22(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_2_6_22_get_layer4_weight_22(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_2_7_00                                    0x181AC218
#define  SRNN_wdsr_layer4_3x3_weights_2_7_00_reg_addr                            "0xB81AC218"
#define  SRNN_wdsr_layer4_3x3_weights_2_7_00_reg                                 0xB81AC218
#define  SRNN_wdsr_layer4_3x3_weights_2_7_00_inst_addr                           "0x04AA"
#define  set_SRNN_wdsr_layer4_3x3_weights_2_7_00_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_7_00_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_2_7_00_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_7_00_reg))
#define  SRNN_wdsr_layer4_3x3_weights_2_7_00_layer4_weight_00_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_2_7_00_layer4_weight_00_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_2_7_00_layer4_weight_00(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_2_7_00_get_layer4_weight_00(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_2_7_01                                    0x181AC21C
#define  SRNN_wdsr_layer4_3x3_weights_2_7_01_reg_addr                            "0xB81AC21C"
#define  SRNN_wdsr_layer4_3x3_weights_2_7_01_reg                                 0xB81AC21C
#define  SRNN_wdsr_layer4_3x3_weights_2_7_01_inst_addr                           "0x04AB"
#define  set_SRNN_wdsr_layer4_3x3_weights_2_7_01_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_7_01_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_2_7_01_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_7_01_reg))
#define  SRNN_wdsr_layer4_3x3_weights_2_7_01_layer4_weight_01_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_2_7_01_layer4_weight_01_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_2_7_01_layer4_weight_01(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_2_7_01_get_layer4_weight_01(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_2_7_02                                    0x181AC220
#define  SRNN_wdsr_layer4_3x3_weights_2_7_02_reg_addr                            "0xB81AC220"
#define  SRNN_wdsr_layer4_3x3_weights_2_7_02_reg                                 0xB81AC220
#define  SRNN_wdsr_layer4_3x3_weights_2_7_02_inst_addr                           "0x04AC"
#define  set_SRNN_wdsr_layer4_3x3_weights_2_7_02_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_7_02_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_2_7_02_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_7_02_reg))
#define  SRNN_wdsr_layer4_3x3_weights_2_7_02_layer4_weight_02_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_2_7_02_layer4_weight_02_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_2_7_02_layer4_weight_02(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_2_7_02_get_layer4_weight_02(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_2_7_10                                    0x181AC224
#define  SRNN_wdsr_layer4_3x3_weights_2_7_10_reg_addr                            "0xB81AC224"
#define  SRNN_wdsr_layer4_3x3_weights_2_7_10_reg                                 0xB81AC224
#define  SRNN_wdsr_layer4_3x3_weights_2_7_10_inst_addr                           "0x04AD"
#define  set_SRNN_wdsr_layer4_3x3_weights_2_7_10_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_7_10_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_2_7_10_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_7_10_reg))
#define  SRNN_wdsr_layer4_3x3_weights_2_7_10_layer4_weight_10_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_2_7_10_layer4_weight_10_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_2_7_10_layer4_weight_10(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_2_7_10_get_layer4_weight_10(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_2_7_11                                    0x181AC228
#define  SRNN_wdsr_layer4_3x3_weights_2_7_11_reg_addr                            "0xB81AC228"
#define  SRNN_wdsr_layer4_3x3_weights_2_7_11_reg                                 0xB81AC228
#define  SRNN_wdsr_layer4_3x3_weights_2_7_11_inst_addr                           "0x04AE"
#define  set_SRNN_wdsr_layer4_3x3_weights_2_7_11_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_7_11_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_2_7_11_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_7_11_reg))
#define  SRNN_wdsr_layer4_3x3_weights_2_7_11_layer4_weight_11_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_2_7_11_layer4_weight_11_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_2_7_11_layer4_weight_11(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_2_7_11_get_layer4_weight_11(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_2_7_12                                    0x181AC22C
#define  SRNN_wdsr_layer4_3x3_weights_2_7_12_reg_addr                            "0xB81AC22C"
#define  SRNN_wdsr_layer4_3x3_weights_2_7_12_reg                                 0xB81AC22C
#define  SRNN_wdsr_layer4_3x3_weights_2_7_12_inst_addr                           "0x04AF"
#define  set_SRNN_wdsr_layer4_3x3_weights_2_7_12_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_7_12_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_2_7_12_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_7_12_reg))
#define  SRNN_wdsr_layer4_3x3_weights_2_7_12_layer4_weight_12_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_2_7_12_layer4_weight_12_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_2_7_12_layer4_weight_12(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_2_7_12_get_layer4_weight_12(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_2_7_20                                    0x181AC230
#define  SRNN_wdsr_layer4_3x3_weights_2_7_20_reg_addr                            "0xB81AC230"
#define  SRNN_wdsr_layer4_3x3_weights_2_7_20_reg                                 0xB81AC230
#define  SRNN_wdsr_layer4_3x3_weights_2_7_20_inst_addr                           "0x04B0"
#define  set_SRNN_wdsr_layer4_3x3_weights_2_7_20_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_7_20_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_2_7_20_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_7_20_reg))
#define  SRNN_wdsr_layer4_3x3_weights_2_7_20_layer4_weight_20_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_2_7_20_layer4_weight_20_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_2_7_20_layer4_weight_20(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_2_7_20_get_layer4_weight_20(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_2_7_21                                    0x181AC234
#define  SRNN_wdsr_layer4_3x3_weights_2_7_21_reg_addr                            "0xB81AC234"
#define  SRNN_wdsr_layer4_3x3_weights_2_7_21_reg                                 0xB81AC234
#define  SRNN_wdsr_layer4_3x3_weights_2_7_21_inst_addr                           "0x04B1"
#define  set_SRNN_wdsr_layer4_3x3_weights_2_7_21_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_7_21_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_2_7_21_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_7_21_reg))
#define  SRNN_wdsr_layer4_3x3_weights_2_7_21_layer4_weight_21_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_2_7_21_layer4_weight_21_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_2_7_21_layer4_weight_21(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_2_7_21_get_layer4_weight_21(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_2_7_22                                    0x181AC238
#define  SRNN_wdsr_layer4_3x3_weights_2_7_22_reg_addr                            "0xB81AC238"
#define  SRNN_wdsr_layer4_3x3_weights_2_7_22_reg                                 0xB81AC238
#define  SRNN_wdsr_layer4_3x3_weights_2_7_22_inst_addr                           "0x04B2"
#define  set_SRNN_wdsr_layer4_3x3_weights_2_7_22_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_7_22_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_2_7_22_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_7_22_reg))
#define  SRNN_wdsr_layer4_3x3_weights_2_7_22_layer4_weight_22_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_2_7_22_layer4_weight_22_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_2_7_22_layer4_weight_22(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_2_7_22_get_layer4_weight_22(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_2_8_00                                    0x181AC23C
#define  SRNN_wdsr_layer4_3x3_weights_2_8_00_reg_addr                            "0xB81AC23C"
#define  SRNN_wdsr_layer4_3x3_weights_2_8_00_reg                                 0xB81AC23C
#define  SRNN_wdsr_layer4_3x3_weights_2_8_00_inst_addr                           "0x04B3"
#define  set_SRNN_wdsr_layer4_3x3_weights_2_8_00_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_8_00_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_2_8_00_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_8_00_reg))
#define  SRNN_wdsr_layer4_3x3_weights_2_8_00_layer4_weight_00_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_2_8_00_layer4_weight_00_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_2_8_00_layer4_weight_00(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_2_8_00_get_layer4_weight_00(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_2_8_01                                    0x181AC240
#define  SRNN_wdsr_layer4_3x3_weights_2_8_01_reg_addr                            "0xB81AC240"
#define  SRNN_wdsr_layer4_3x3_weights_2_8_01_reg                                 0xB81AC240
#define  SRNN_wdsr_layer4_3x3_weights_2_8_01_inst_addr                           "0x04B4"
#define  set_SRNN_wdsr_layer4_3x3_weights_2_8_01_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_8_01_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_2_8_01_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_8_01_reg))
#define  SRNN_wdsr_layer4_3x3_weights_2_8_01_layer4_weight_01_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_2_8_01_layer4_weight_01_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_2_8_01_layer4_weight_01(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_2_8_01_get_layer4_weight_01(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_2_8_02                                    0x181AC244
#define  SRNN_wdsr_layer4_3x3_weights_2_8_02_reg_addr                            "0xB81AC244"
#define  SRNN_wdsr_layer4_3x3_weights_2_8_02_reg                                 0xB81AC244
#define  SRNN_wdsr_layer4_3x3_weights_2_8_02_inst_addr                           "0x04B5"
#define  set_SRNN_wdsr_layer4_3x3_weights_2_8_02_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_8_02_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_2_8_02_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_8_02_reg))
#define  SRNN_wdsr_layer4_3x3_weights_2_8_02_layer4_weight_02_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_2_8_02_layer4_weight_02_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_2_8_02_layer4_weight_02(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_2_8_02_get_layer4_weight_02(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_2_8_10                                    0x181AC248
#define  SRNN_wdsr_layer4_3x3_weights_2_8_10_reg_addr                            "0xB81AC248"
#define  SRNN_wdsr_layer4_3x3_weights_2_8_10_reg                                 0xB81AC248
#define  SRNN_wdsr_layer4_3x3_weights_2_8_10_inst_addr                           "0x04B6"
#define  set_SRNN_wdsr_layer4_3x3_weights_2_8_10_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_8_10_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_2_8_10_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_8_10_reg))
#define  SRNN_wdsr_layer4_3x3_weights_2_8_10_layer4_weight_10_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_2_8_10_layer4_weight_10_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_2_8_10_layer4_weight_10(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_2_8_10_get_layer4_weight_10(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_2_8_11                                    0x181AC24C
#define  SRNN_wdsr_layer4_3x3_weights_2_8_11_reg_addr                            "0xB81AC24C"
#define  SRNN_wdsr_layer4_3x3_weights_2_8_11_reg                                 0xB81AC24C
#define  SRNN_wdsr_layer4_3x3_weights_2_8_11_inst_addr                           "0x04B7"
#define  set_SRNN_wdsr_layer4_3x3_weights_2_8_11_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_8_11_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_2_8_11_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_8_11_reg))
#define  SRNN_wdsr_layer4_3x3_weights_2_8_11_layer4_weight_11_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_2_8_11_layer4_weight_11_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_2_8_11_layer4_weight_11(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_2_8_11_get_layer4_weight_11(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_2_8_12                                    0x181AC250
#define  SRNN_wdsr_layer4_3x3_weights_2_8_12_reg_addr                            "0xB81AC250"
#define  SRNN_wdsr_layer4_3x3_weights_2_8_12_reg                                 0xB81AC250
#define  SRNN_wdsr_layer4_3x3_weights_2_8_12_inst_addr                           "0x04B8"
#define  set_SRNN_wdsr_layer4_3x3_weights_2_8_12_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_8_12_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_2_8_12_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_8_12_reg))
#define  SRNN_wdsr_layer4_3x3_weights_2_8_12_layer4_weight_12_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_2_8_12_layer4_weight_12_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_2_8_12_layer4_weight_12(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_2_8_12_get_layer4_weight_12(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_2_8_20                                    0x181AC254
#define  SRNN_wdsr_layer4_3x3_weights_2_8_20_reg_addr                            "0xB81AC254"
#define  SRNN_wdsr_layer4_3x3_weights_2_8_20_reg                                 0xB81AC254
#define  SRNN_wdsr_layer4_3x3_weights_2_8_20_inst_addr                           "0x04B9"
#define  set_SRNN_wdsr_layer4_3x3_weights_2_8_20_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_8_20_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_2_8_20_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_8_20_reg))
#define  SRNN_wdsr_layer4_3x3_weights_2_8_20_layer4_weight_20_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_2_8_20_layer4_weight_20_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_2_8_20_layer4_weight_20(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_2_8_20_get_layer4_weight_20(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_2_8_21                                    0x181AC258
#define  SRNN_wdsr_layer4_3x3_weights_2_8_21_reg_addr                            "0xB81AC258"
#define  SRNN_wdsr_layer4_3x3_weights_2_8_21_reg                                 0xB81AC258
#define  SRNN_wdsr_layer4_3x3_weights_2_8_21_inst_addr                           "0x04BA"
#define  set_SRNN_wdsr_layer4_3x3_weights_2_8_21_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_8_21_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_2_8_21_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_8_21_reg))
#define  SRNN_wdsr_layer4_3x3_weights_2_8_21_layer4_weight_21_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_2_8_21_layer4_weight_21_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_2_8_21_layer4_weight_21(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_2_8_21_get_layer4_weight_21(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_2_8_22                                    0x181AC25C
#define  SRNN_wdsr_layer4_3x3_weights_2_8_22_reg_addr                            "0xB81AC25C"
#define  SRNN_wdsr_layer4_3x3_weights_2_8_22_reg                                 0xB81AC25C
#define  SRNN_wdsr_layer4_3x3_weights_2_8_22_inst_addr                           "0x04BB"
#define  set_SRNN_wdsr_layer4_3x3_weights_2_8_22_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_8_22_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_2_8_22_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_2_8_22_reg))
#define  SRNN_wdsr_layer4_3x3_weights_2_8_22_layer4_weight_22_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_2_8_22_layer4_weight_22_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_2_8_22_layer4_weight_22(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_2_8_22_get_layer4_weight_22(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_3_1_00                                    0x181AC260
#define  SRNN_wdsr_layer4_3x3_weights_3_1_00_reg_addr                            "0xB81AC260"
#define  SRNN_wdsr_layer4_3x3_weights_3_1_00_reg                                 0xB81AC260
#define  SRNN_wdsr_layer4_3x3_weights_3_1_00_inst_addr                           "0x04BC"
#define  set_SRNN_wdsr_layer4_3x3_weights_3_1_00_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_1_00_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_3_1_00_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_1_00_reg))
#define  SRNN_wdsr_layer4_3x3_weights_3_1_00_layer4_weight_00_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_3_1_00_layer4_weight_00_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_3_1_00_layer4_weight_00(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_3_1_00_get_layer4_weight_00(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_3_1_01                                    0x181AC264
#define  SRNN_wdsr_layer4_3x3_weights_3_1_01_reg_addr                            "0xB81AC264"
#define  SRNN_wdsr_layer4_3x3_weights_3_1_01_reg                                 0xB81AC264
#define  SRNN_wdsr_layer4_3x3_weights_3_1_01_inst_addr                           "0x04BD"
#define  set_SRNN_wdsr_layer4_3x3_weights_3_1_01_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_1_01_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_3_1_01_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_1_01_reg))
#define  SRNN_wdsr_layer4_3x3_weights_3_1_01_layer4_weight_01_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_3_1_01_layer4_weight_01_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_3_1_01_layer4_weight_01(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_3_1_01_get_layer4_weight_01(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_3_1_02                                    0x181AC268
#define  SRNN_wdsr_layer4_3x3_weights_3_1_02_reg_addr                            "0xB81AC268"
#define  SRNN_wdsr_layer4_3x3_weights_3_1_02_reg                                 0xB81AC268
#define  SRNN_wdsr_layer4_3x3_weights_3_1_02_inst_addr                           "0x04BE"
#define  set_SRNN_wdsr_layer4_3x3_weights_3_1_02_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_1_02_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_3_1_02_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_1_02_reg))
#define  SRNN_wdsr_layer4_3x3_weights_3_1_02_layer4_weight_02_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_3_1_02_layer4_weight_02_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_3_1_02_layer4_weight_02(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_3_1_02_get_layer4_weight_02(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_3_1_10                                    0x181AC26C
#define  SRNN_wdsr_layer4_3x3_weights_3_1_10_reg_addr                            "0xB81AC26C"
#define  SRNN_wdsr_layer4_3x3_weights_3_1_10_reg                                 0xB81AC26C
#define  SRNN_wdsr_layer4_3x3_weights_3_1_10_inst_addr                           "0x04BF"
#define  set_SRNN_wdsr_layer4_3x3_weights_3_1_10_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_1_10_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_3_1_10_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_1_10_reg))
#define  SRNN_wdsr_layer4_3x3_weights_3_1_10_layer4_weight_10_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_3_1_10_layer4_weight_10_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_3_1_10_layer4_weight_10(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_3_1_10_get_layer4_weight_10(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_3_1_11                                    0x181AC270
#define  SRNN_wdsr_layer4_3x3_weights_3_1_11_reg_addr                            "0xB81AC270"
#define  SRNN_wdsr_layer4_3x3_weights_3_1_11_reg                                 0xB81AC270
#define  SRNN_wdsr_layer4_3x3_weights_3_1_11_inst_addr                           "0x04C0"
#define  set_SRNN_wdsr_layer4_3x3_weights_3_1_11_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_1_11_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_3_1_11_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_1_11_reg))
#define  SRNN_wdsr_layer4_3x3_weights_3_1_11_layer4_weight_11_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_3_1_11_layer4_weight_11_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_3_1_11_layer4_weight_11(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_3_1_11_get_layer4_weight_11(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_3_1_12                                    0x181AC274
#define  SRNN_wdsr_layer4_3x3_weights_3_1_12_reg_addr                            "0xB81AC274"
#define  SRNN_wdsr_layer4_3x3_weights_3_1_12_reg                                 0xB81AC274
#define  SRNN_wdsr_layer4_3x3_weights_3_1_12_inst_addr                           "0x04C1"
#define  set_SRNN_wdsr_layer4_3x3_weights_3_1_12_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_1_12_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_3_1_12_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_1_12_reg))
#define  SRNN_wdsr_layer4_3x3_weights_3_1_12_layer4_weight_12_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_3_1_12_layer4_weight_12_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_3_1_12_layer4_weight_12(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_3_1_12_get_layer4_weight_12(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_3_1_20                                    0x181AC278
#define  SRNN_wdsr_layer4_3x3_weights_3_1_20_reg_addr                            "0xB81AC278"
#define  SRNN_wdsr_layer4_3x3_weights_3_1_20_reg                                 0xB81AC278
#define  SRNN_wdsr_layer4_3x3_weights_3_1_20_inst_addr                           "0x04C2"
#define  set_SRNN_wdsr_layer4_3x3_weights_3_1_20_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_1_20_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_3_1_20_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_1_20_reg))
#define  SRNN_wdsr_layer4_3x3_weights_3_1_20_layer4_weight_20_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_3_1_20_layer4_weight_20_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_3_1_20_layer4_weight_20(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_3_1_20_get_layer4_weight_20(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_3_1_21                                    0x181AC27C
#define  SRNN_wdsr_layer4_3x3_weights_3_1_21_reg_addr                            "0xB81AC27C"
#define  SRNN_wdsr_layer4_3x3_weights_3_1_21_reg                                 0xB81AC27C
#define  SRNN_wdsr_layer4_3x3_weights_3_1_21_inst_addr                           "0x04C3"
#define  set_SRNN_wdsr_layer4_3x3_weights_3_1_21_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_1_21_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_3_1_21_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_1_21_reg))
#define  SRNN_wdsr_layer4_3x3_weights_3_1_21_layer4_weight_21_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_3_1_21_layer4_weight_21_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_3_1_21_layer4_weight_21(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_3_1_21_get_layer4_weight_21(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_3_1_22                                    0x181AC280
#define  SRNN_wdsr_layer4_3x3_weights_3_1_22_reg_addr                            "0xB81AC280"
#define  SRNN_wdsr_layer4_3x3_weights_3_1_22_reg                                 0xB81AC280
#define  SRNN_wdsr_layer4_3x3_weights_3_1_22_inst_addr                           "0x04C4"
#define  set_SRNN_wdsr_layer4_3x3_weights_3_1_22_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_1_22_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_3_1_22_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_1_22_reg))
#define  SRNN_wdsr_layer4_3x3_weights_3_1_22_layer4_weight_22_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_3_1_22_layer4_weight_22_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_3_1_22_layer4_weight_22(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_3_1_22_get_layer4_weight_22(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_3_2_00                                    0x181AC284
#define  SRNN_wdsr_layer4_3x3_weights_3_2_00_reg_addr                            "0xB81AC284"
#define  SRNN_wdsr_layer4_3x3_weights_3_2_00_reg                                 0xB81AC284
#define  SRNN_wdsr_layer4_3x3_weights_3_2_00_inst_addr                           "0x04C5"
#define  set_SRNN_wdsr_layer4_3x3_weights_3_2_00_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_2_00_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_3_2_00_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_2_00_reg))
#define  SRNN_wdsr_layer4_3x3_weights_3_2_00_layer4_weight_00_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_3_2_00_layer4_weight_00_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_3_2_00_layer4_weight_00(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_3_2_00_get_layer4_weight_00(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_3_2_01                                    0x181AC288
#define  SRNN_wdsr_layer4_3x3_weights_3_2_01_reg_addr                            "0xB81AC288"
#define  SRNN_wdsr_layer4_3x3_weights_3_2_01_reg                                 0xB81AC288
#define  SRNN_wdsr_layer4_3x3_weights_3_2_01_inst_addr                           "0x04C6"
#define  set_SRNN_wdsr_layer4_3x3_weights_3_2_01_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_2_01_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_3_2_01_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_2_01_reg))
#define  SRNN_wdsr_layer4_3x3_weights_3_2_01_layer4_weight_01_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_3_2_01_layer4_weight_01_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_3_2_01_layer4_weight_01(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_3_2_01_get_layer4_weight_01(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_3_2_02                                    0x181AC28C
#define  SRNN_wdsr_layer4_3x3_weights_3_2_02_reg_addr                            "0xB81AC28C"
#define  SRNN_wdsr_layer4_3x3_weights_3_2_02_reg                                 0xB81AC28C
#define  SRNN_wdsr_layer4_3x3_weights_3_2_02_inst_addr                           "0x04C7"
#define  set_SRNN_wdsr_layer4_3x3_weights_3_2_02_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_2_02_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_3_2_02_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_2_02_reg))
#define  SRNN_wdsr_layer4_3x3_weights_3_2_02_layer4_weight_02_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_3_2_02_layer4_weight_02_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_3_2_02_layer4_weight_02(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_3_2_02_get_layer4_weight_02(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_3_2_10                                    0x181AC290
#define  SRNN_wdsr_layer4_3x3_weights_3_2_10_reg_addr                            "0xB81AC290"
#define  SRNN_wdsr_layer4_3x3_weights_3_2_10_reg                                 0xB81AC290
#define  SRNN_wdsr_layer4_3x3_weights_3_2_10_inst_addr                           "0x04C8"
#define  set_SRNN_wdsr_layer4_3x3_weights_3_2_10_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_2_10_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_3_2_10_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_2_10_reg))
#define  SRNN_wdsr_layer4_3x3_weights_3_2_10_layer4_weight_10_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_3_2_10_layer4_weight_10_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_3_2_10_layer4_weight_10(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_3_2_10_get_layer4_weight_10(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_3_2_11                                    0x181AC294
#define  SRNN_wdsr_layer4_3x3_weights_3_2_11_reg_addr                            "0xB81AC294"
#define  SRNN_wdsr_layer4_3x3_weights_3_2_11_reg                                 0xB81AC294
#define  SRNN_wdsr_layer4_3x3_weights_3_2_11_inst_addr                           "0x04C9"
#define  set_SRNN_wdsr_layer4_3x3_weights_3_2_11_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_2_11_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_3_2_11_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_2_11_reg))
#define  SRNN_wdsr_layer4_3x3_weights_3_2_11_layer4_weight_11_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_3_2_11_layer4_weight_11_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_3_2_11_layer4_weight_11(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_3_2_11_get_layer4_weight_11(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_3_2_12                                    0x181AC298
#define  SRNN_wdsr_layer4_3x3_weights_3_2_12_reg_addr                            "0xB81AC298"
#define  SRNN_wdsr_layer4_3x3_weights_3_2_12_reg                                 0xB81AC298
#define  SRNN_wdsr_layer4_3x3_weights_3_2_12_inst_addr                           "0x04CA"
#define  set_SRNN_wdsr_layer4_3x3_weights_3_2_12_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_2_12_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_3_2_12_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_2_12_reg))
#define  SRNN_wdsr_layer4_3x3_weights_3_2_12_layer4_weight_12_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_3_2_12_layer4_weight_12_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_3_2_12_layer4_weight_12(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_3_2_12_get_layer4_weight_12(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_3_2_20                                    0x181AC29C
#define  SRNN_wdsr_layer4_3x3_weights_3_2_20_reg_addr                            "0xB81AC29C"
#define  SRNN_wdsr_layer4_3x3_weights_3_2_20_reg                                 0xB81AC29C
#define  SRNN_wdsr_layer4_3x3_weights_3_2_20_inst_addr                           "0x04CB"
#define  set_SRNN_wdsr_layer4_3x3_weights_3_2_20_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_2_20_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_3_2_20_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_2_20_reg))
#define  SRNN_wdsr_layer4_3x3_weights_3_2_20_layer4_weight_20_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_3_2_20_layer4_weight_20_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_3_2_20_layer4_weight_20(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_3_2_20_get_layer4_weight_20(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_3_2_21                                    0x181AC2A0
#define  SRNN_wdsr_layer4_3x3_weights_3_2_21_reg_addr                            "0xB81AC2A0"
#define  SRNN_wdsr_layer4_3x3_weights_3_2_21_reg                                 0xB81AC2A0
#define  SRNN_wdsr_layer4_3x3_weights_3_2_21_inst_addr                           "0x04CC"
#define  set_SRNN_wdsr_layer4_3x3_weights_3_2_21_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_2_21_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_3_2_21_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_2_21_reg))
#define  SRNN_wdsr_layer4_3x3_weights_3_2_21_layer4_weight_21_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_3_2_21_layer4_weight_21_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_3_2_21_layer4_weight_21(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_3_2_21_get_layer4_weight_21(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_3_2_22                                    0x181AC2A4
#define  SRNN_wdsr_layer4_3x3_weights_3_2_22_reg_addr                            "0xB81AC2A4"
#define  SRNN_wdsr_layer4_3x3_weights_3_2_22_reg                                 0xB81AC2A4
#define  SRNN_wdsr_layer4_3x3_weights_3_2_22_inst_addr                           "0x04CD"
#define  set_SRNN_wdsr_layer4_3x3_weights_3_2_22_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_2_22_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_3_2_22_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_2_22_reg))
#define  SRNN_wdsr_layer4_3x3_weights_3_2_22_layer4_weight_22_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_3_2_22_layer4_weight_22_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_3_2_22_layer4_weight_22(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_3_2_22_get_layer4_weight_22(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_3_3_00                                    0x181AC2A8
#define  SRNN_wdsr_layer4_3x3_weights_3_3_00_reg_addr                            "0xB81AC2A8"
#define  SRNN_wdsr_layer4_3x3_weights_3_3_00_reg                                 0xB81AC2A8
#define  SRNN_wdsr_layer4_3x3_weights_3_3_00_inst_addr                           "0x04CE"
#define  set_SRNN_wdsr_layer4_3x3_weights_3_3_00_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_3_00_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_3_3_00_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_3_00_reg))
#define  SRNN_wdsr_layer4_3x3_weights_3_3_00_layer4_weight_00_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_3_3_00_layer4_weight_00_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_3_3_00_layer4_weight_00(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_3_3_00_get_layer4_weight_00(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_3_3_01                                    0x181AC2AC
#define  SRNN_wdsr_layer4_3x3_weights_3_3_01_reg_addr                            "0xB81AC2AC"
#define  SRNN_wdsr_layer4_3x3_weights_3_3_01_reg                                 0xB81AC2AC
#define  SRNN_wdsr_layer4_3x3_weights_3_3_01_inst_addr                           "0x04CF"
#define  set_SRNN_wdsr_layer4_3x3_weights_3_3_01_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_3_01_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_3_3_01_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_3_01_reg))
#define  SRNN_wdsr_layer4_3x3_weights_3_3_01_layer4_weight_01_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_3_3_01_layer4_weight_01_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_3_3_01_layer4_weight_01(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_3_3_01_get_layer4_weight_01(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_3_3_02                                    0x181AC2B0
#define  SRNN_wdsr_layer4_3x3_weights_3_3_02_reg_addr                            "0xB81AC2B0"
#define  SRNN_wdsr_layer4_3x3_weights_3_3_02_reg                                 0xB81AC2B0
#define  SRNN_wdsr_layer4_3x3_weights_3_3_02_inst_addr                           "0x04D0"
#define  set_SRNN_wdsr_layer4_3x3_weights_3_3_02_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_3_02_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_3_3_02_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_3_02_reg))
#define  SRNN_wdsr_layer4_3x3_weights_3_3_02_layer4_weight_02_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_3_3_02_layer4_weight_02_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_3_3_02_layer4_weight_02(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_3_3_02_get_layer4_weight_02(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_3_3_10                                    0x181AC2B4
#define  SRNN_wdsr_layer4_3x3_weights_3_3_10_reg_addr                            "0xB81AC2B4"
#define  SRNN_wdsr_layer4_3x3_weights_3_3_10_reg                                 0xB81AC2B4
#define  SRNN_wdsr_layer4_3x3_weights_3_3_10_inst_addr                           "0x04D1"
#define  set_SRNN_wdsr_layer4_3x3_weights_3_3_10_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_3_10_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_3_3_10_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_3_10_reg))
#define  SRNN_wdsr_layer4_3x3_weights_3_3_10_layer4_weight_10_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_3_3_10_layer4_weight_10_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_3_3_10_layer4_weight_10(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_3_3_10_get_layer4_weight_10(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_3_3_11                                    0x181AC2B8
#define  SRNN_wdsr_layer4_3x3_weights_3_3_11_reg_addr                            "0xB81AC2B8"
#define  SRNN_wdsr_layer4_3x3_weights_3_3_11_reg                                 0xB81AC2B8
#define  SRNN_wdsr_layer4_3x3_weights_3_3_11_inst_addr                           "0x04D2"
#define  set_SRNN_wdsr_layer4_3x3_weights_3_3_11_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_3_11_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_3_3_11_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_3_11_reg))
#define  SRNN_wdsr_layer4_3x3_weights_3_3_11_layer4_weight_11_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_3_3_11_layer4_weight_11_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_3_3_11_layer4_weight_11(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_3_3_11_get_layer4_weight_11(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_3_3_12                                    0x181AC2BC
#define  SRNN_wdsr_layer4_3x3_weights_3_3_12_reg_addr                            "0xB81AC2BC"
#define  SRNN_wdsr_layer4_3x3_weights_3_3_12_reg                                 0xB81AC2BC
#define  SRNN_wdsr_layer4_3x3_weights_3_3_12_inst_addr                           "0x04D3"
#define  set_SRNN_wdsr_layer4_3x3_weights_3_3_12_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_3_12_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_3_3_12_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_3_12_reg))
#define  SRNN_wdsr_layer4_3x3_weights_3_3_12_layer4_weight_12_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_3_3_12_layer4_weight_12_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_3_3_12_layer4_weight_12(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_3_3_12_get_layer4_weight_12(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_3_3_20                                    0x181AC2C0
#define  SRNN_wdsr_layer4_3x3_weights_3_3_20_reg_addr                            "0xB81AC2C0"
#define  SRNN_wdsr_layer4_3x3_weights_3_3_20_reg                                 0xB81AC2C0
#define  SRNN_wdsr_layer4_3x3_weights_3_3_20_inst_addr                           "0x04D4"
#define  set_SRNN_wdsr_layer4_3x3_weights_3_3_20_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_3_20_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_3_3_20_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_3_20_reg))
#define  SRNN_wdsr_layer4_3x3_weights_3_3_20_layer4_weight_20_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_3_3_20_layer4_weight_20_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_3_3_20_layer4_weight_20(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_3_3_20_get_layer4_weight_20(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_3_3_21                                    0x181AC2C4
#define  SRNN_wdsr_layer4_3x3_weights_3_3_21_reg_addr                            "0xB81AC2C4"
#define  SRNN_wdsr_layer4_3x3_weights_3_3_21_reg                                 0xB81AC2C4
#define  SRNN_wdsr_layer4_3x3_weights_3_3_21_inst_addr                           "0x04D5"
#define  set_SRNN_wdsr_layer4_3x3_weights_3_3_21_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_3_21_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_3_3_21_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_3_21_reg))
#define  SRNN_wdsr_layer4_3x3_weights_3_3_21_layer4_weight_21_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_3_3_21_layer4_weight_21_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_3_3_21_layer4_weight_21(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_3_3_21_get_layer4_weight_21(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_3_3_22                                    0x181AC2C8
#define  SRNN_wdsr_layer4_3x3_weights_3_3_22_reg_addr                            "0xB81AC2C8"
#define  SRNN_wdsr_layer4_3x3_weights_3_3_22_reg                                 0xB81AC2C8
#define  SRNN_wdsr_layer4_3x3_weights_3_3_22_inst_addr                           "0x04D6"
#define  set_SRNN_wdsr_layer4_3x3_weights_3_3_22_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_3_22_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_3_3_22_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_3_22_reg))
#define  SRNN_wdsr_layer4_3x3_weights_3_3_22_layer4_weight_22_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_3_3_22_layer4_weight_22_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_3_3_22_layer4_weight_22(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_3_3_22_get_layer4_weight_22(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_3_4_00                                    0x181AC2CC
#define  SRNN_wdsr_layer4_3x3_weights_3_4_00_reg_addr                            "0xB81AC2CC"
#define  SRNN_wdsr_layer4_3x3_weights_3_4_00_reg                                 0xB81AC2CC
#define  SRNN_wdsr_layer4_3x3_weights_3_4_00_inst_addr                           "0x04D7"
#define  set_SRNN_wdsr_layer4_3x3_weights_3_4_00_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_4_00_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_3_4_00_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_4_00_reg))
#define  SRNN_wdsr_layer4_3x3_weights_3_4_00_layer4_weight_00_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_3_4_00_layer4_weight_00_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_3_4_00_layer4_weight_00(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_3_4_00_get_layer4_weight_00(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_3_4_01                                    0x181AC2D0
#define  SRNN_wdsr_layer4_3x3_weights_3_4_01_reg_addr                            "0xB81AC2D0"
#define  SRNN_wdsr_layer4_3x3_weights_3_4_01_reg                                 0xB81AC2D0
#define  SRNN_wdsr_layer4_3x3_weights_3_4_01_inst_addr                           "0x04D8"
#define  set_SRNN_wdsr_layer4_3x3_weights_3_4_01_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_4_01_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_3_4_01_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_4_01_reg))
#define  SRNN_wdsr_layer4_3x3_weights_3_4_01_layer4_weight_01_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_3_4_01_layer4_weight_01_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_3_4_01_layer4_weight_01(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_3_4_01_get_layer4_weight_01(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_3_4_02                                    0x181AC2D4
#define  SRNN_wdsr_layer4_3x3_weights_3_4_02_reg_addr                            "0xB81AC2D4"
#define  SRNN_wdsr_layer4_3x3_weights_3_4_02_reg                                 0xB81AC2D4
#define  SRNN_wdsr_layer4_3x3_weights_3_4_02_inst_addr                           "0x04D9"
#define  set_SRNN_wdsr_layer4_3x3_weights_3_4_02_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_4_02_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_3_4_02_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_4_02_reg))
#define  SRNN_wdsr_layer4_3x3_weights_3_4_02_layer4_weight_02_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_3_4_02_layer4_weight_02_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_3_4_02_layer4_weight_02(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_3_4_02_get_layer4_weight_02(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_3_4_10                                    0x181AC2D8
#define  SRNN_wdsr_layer4_3x3_weights_3_4_10_reg_addr                            "0xB81AC2D8"
#define  SRNN_wdsr_layer4_3x3_weights_3_4_10_reg                                 0xB81AC2D8
#define  SRNN_wdsr_layer4_3x3_weights_3_4_10_inst_addr                           "0x04DA"
#define  set_SRNN_wdsr_layer4_3x3_weights_3_4_10_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_4_10_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_3_4_10_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_4_10_reg))
#define  SRNN_wdsr_layer4_3x3_weights_3_4_10_layer4_weight_10_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_3_4_10_layer4_weight_10_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_3_4_10_layer4_weight_10(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_3_4_10_get_layer4_weight_10(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_3_4_11                                    0x181AC2DC
#define  SRNN_wdsr_layer4_3x3_weights_3_4_11_reg_addr                            "0xB81AC2DC"
#define  SRNN_wdsr_layer4_3x3_weights_3_4_11_reg                                 0xB81AC2DC
#define  SRNN_wdsr_layer4_3x3_weights_3_4_11_inst_addr                           "0x04DB"
#define  set_SRNN_wdsr_layer4_3x3_weights_3_4_11_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_4_11_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_3_4_11_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_4_11_reg))
#define  SRNN_wdsr_layer4_3x3_weights_3_4_11_layer4_weight_11_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_3_4_11_layer4_weight_11_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_3_4_11_layer4_weight_11(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_3_4_11_get_layer4_weight_11(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_3_4_12                                    0x181AC2E0
#define  SRNN_wdsr_layer4_3x3_weights_3_4_12_reg_addr                            "0xB81AC2E0"
#define  SRNN_wdsr_layer4_3x3_weights_3_4_12_reg                                 0xB81AC2E0
#define  SRNN_wdsr_layer4_3x3_weights_3_4_12_inst_addr                           "0x04DC"
#define  set_SRNN_wdsr_layer4_3x3_weights_3_4_12_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_4_12_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_3_4_12_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_4_12_reg))
#define  SRNN_wdsr_layer4_3x3_weights_3_4_12_layer4_weight_12_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_3_4_12_layer4_weight_12_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_3_4_12_layer4_weight_12(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_3_4_12_get_layer4_weight_12(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_3_4_20                                    0x181AC2E4
#define  SRNN_wdsr_layer4_3x3_weights_3_4_20_reg_addr                            "0xB81AC2E4"
#define  SRNN_wdsr_layer4_3x3_weights_3_4_20_reg                                 0xB81AC2E4
#define  SRNN_wdsr_layer4_3x3_weights_3_4_20_inst_addr                           "0x04DD"
#define  set_SRNN_wdsr_layer4_3x3_weights_3_4_20_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_4_20_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_3_4_20_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_4_20_reg))
#define  SRNN_wdsr_layer4_3x3_weights_3_4_20_layer4_weight_20_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_3_4_20_layer4_weight_20_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_3_4_20_layer4_weight_20(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_3_4_20_get_layer4_weight_20(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_3_4_21                                    0x181AC2E8
#define  SRNN_wdsr_layer4_3x3_weights_3_4_21_reg_addr                            "0xB81AC2E8"
#define  SRNN_wdsr_layer4_3x3_weights_3_4_21_reg                                 0xB81AC2E8
#define  SRNN_wdsr_layer4_3x3_weights_3_4_21_inst_addr                           "0x04DE"
#define  set_SRNN_wdsr_layer4_3x3_weights_3_4_21_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_4_21_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_3_4_21_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_4_21_reg))
#define  SRNN_wdsr_layer4_3x3_weights_3_4_21_layer4_weight_21_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_3_4_21_layer4_weight_21_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_3_4_21_layer4_weight_21(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_3_4_21_get_layer4_weight_21(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_3_4_22                                    0x181AC2EC
#define  SRNN_wdsr_layer4_3x3_weights_3_4_22_reg_addr                            "0xB81AC2EC"
#define  SRNN_wdsr_layer4_3x3_weights_3_4_22_reg                                 0xB81AC2EC
#define  SRNN_wdsr_layer4_3x3_weights_3_4_22_inst_addr                           "0x04DF"
#define  set_SRNN_wdsr_layer4_3x3_weights_3_4_22_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_4_22_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_3_4_22_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_4_22_reg))
#define  SRNN_wdsr_layer4_3x3_weights_3_4_22_layer4_weight_22_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_3_4_22_layer4_weight_22_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_3_4_22_layer4_weight_22(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_3_4_22_get_layer4_weight_22(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_3_5_00                                    0x181AC2F0
#define  SRNN_wdsr_layer4_3x3_weights_3_5_00_reg_addr                            "0xB81AC2F0"
#define  SRNN_wdsr_layer4_3x3_weights_3_5_00_reg                                 0xB81AC2F0
#define  SRNN_wdsr_layer4_3x3_weights_3_5_00_inst_addr                           "0x04E0"
#define  set_SRNN_wdsr_layer4_3x3_weights_3_5_00_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_5_00_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_3_5_00_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_5_00_reg))
#define  SRNN_wdsr_layer4_3x3_weights_3_5_00_layer4_weight_00_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_3_5_00_layer4_weight_00_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_3_5_00_layer4_weight_00(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_3_5_00_get_layer4_weight_00(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_3_5_01                                    0x181AC2F4
#define  SRNN_wdsr_layer4_3x3_weights_3_5_01_reg_addr                            "0xB81AC2F4"
#define  SRNN_wdsr_layer4_3x3_weights_3_5_01_reg                                 0xB81AC2F4
#define  SRNN_wdsr_layer4_3x3_weights_3_5_01_inst_addr                           "0x04E1"
#define  set_SRNN_wdsr_layer4_3x3_weights_3_5_01_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_5_01_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_3_5_01_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_5_01_reg))
#define  SRNN_wdsr_layer4_3x3_weights_3_5_01_layer4_weight_01_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_3_5_01_layer4_weight_01_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_3_5_01_layer4_weight_01(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_3_5_01_get_layer4_weight_01(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_3_5_02                                    0x181AC2F8
#define  SRNN_wdsr_layer4_3x3_weights_3_5_02_reg_addr                            "0xB81AC2F8"
#define  SRNN_wdsr_layer4_3x3_weights_3_5_02_reg                                 0xB81AC2F8
#define  SRNN_wdsr_layer4_3x3_weights_3_5_02_inst_addr                           "0x04E2"
#define  set_SRNN_wdsr_layer4_3x3_weights_3_5_02_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_5_02_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_3_5_02_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_5_02_reg))
#define  SRNN_wdsr_layer4_3x3_weights_3_5_02_layer4_weight_02_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_3_5_02_layer4_weight_02_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_3_5_02_layer4_weight_02(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_3_5_02_get_layer4_weight_02(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_3_5_10                                    0x181AC2FC
#define  SRNN_wdsr_layer4_3x3_weights_3_5_10_reg_addr                            "0xB81AC2FC"
#define  SRNN_wdsr_layer4_3x3_weights_3_5_10_reg                                 0xB81AC2FC
#define  SRNN_wdsr_layer4_3x3_weights_3_5_10_inst_addr                           "0x04E3"
#define  set_SRNN_wdsr_layer4_3x3_weights_3_5_10_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_5_10_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_3_5_10_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_5_10_reg))
#define  SRNN_wdsr_layer4_3x3_weights_3_5_10_layer4_weight_10_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_3_5_10_layer4_weight_10_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_3_5_10_layer4_weight_10(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_3_5_10_get_layer4_weight_10(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_3_5_11                                    0x181AC300
#define  SRNN_wdsr_layer4_3x3_weights_3_5_11_reg_addr                            "0xB81AC300"
#define  SRNN_wdsr_layer4_3x3_weights_3_5_11_reg                                 0xB81AC300
#define  SRNN_wdsr_layer4_3x3_weights_3_5_11_inst_addr                           "0x04E4"
#define  set_SRNN_wdsr_layer4_3x3_weights_3_5_11_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_5_11_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_3_5_11_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_5_11_reg))
#define  SRNN_wdsr_layer4_3x3_weights_3_5_11_layer4_weight_11_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_3_5_11_layer4_weight_11_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_3_5_11_layer4_weight_11(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_3_5_11_get_layer4_weight_11(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_3_5_12                                    0x181AC304
#define  SRNN_wdsr_layer4_3x3_weights_3_5_12_reg_addr                            "0xB81AC304"
#define  SRNN_wdsr_layer4_3x3_weights_3_5_12_reg                                 0xB81AC304
#define  SRNN_wdsr_layer4_3x3_weights_3_5_12_inst_addr                           "0x04E5"
#define  set_SRNN_wdsr_layer4_3x3_weights_3_5_12_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_5_12_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_3_5_12_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_5_12_reg))
#define  SRNN_wdsr_layer4_3x3_weights_3_5_12_layer4_weight_12_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_3_5_12_layer4_weight_12_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_3_5_12_layer4_weight_12(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_3_5_12_get_layer4_weight_12(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_3_5_20                                    0x181AC308
#define  SRNN_wdsr_layer4_3x3_weights_3_5_20_reg_addr                            "0xB81AC308"
#define  SRNN_wdsr_layer4_3x3_weights_3_5_20_reg                                 0xB81AC308
#define  SRNN_wdsr_layer4_3x3_weights_3_5_20_inst_addr                           "0x04E6"
#define  set_SRNN_wdsr_layer4_3x3_weights_3_5_20_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_5_20_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_3_5_20_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_5_20_reg))
#define  SRNN_wdsr_layer4_3x3_weights_3_5_20_layer4_weight_20_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_3_5_20_layer4_weight_20_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_3_5_20_layer4_weight_20(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_3_5_20_get_layer4_weight_20(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_3_5_21                                    0x181AC30C
#define  SRNN_wdsr_layer4_3x3_weights_3_5_21_reg_addr                            "0xB81AC30C"
#define  SRNN_wdsr_layer4_3x3_weights_3_5_21_reg                                 0xB81AC30C
#define  SRNN_wdsr_layer4_3x3_weights_3_5_21_inst_addr                           "0x04E7"
#define  set_SRNN_wdsr_layer4_3x3_weights_3_5_21_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_5_21_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_3_5_21_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_5_21_reg))
#define  SRNN_wdsr_layer4_3x3_weights_3_5_21_layer4_weight_21_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_3_5_21_layer4_weight_21_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_3_5_21_layer4_weight_21(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_3_5_21_get_layer4_weight_21(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_3_5_22                                    0x181AC310
#define  SRNN_wdsr_layer4_3x3_weights_3_5_22_reg_addr                            "0xB81AC310"
#define  SRNN_wdsr_layer4_3x3_weights_3_5_22_reg                                 0xB81AC310
#define  SRNN_wdsr_layer4_3x3_weights_3_5_22_inst_addr                           "0x04E8"
#define  set_SRNN_wdsr_layer4_3x3_weights_3_5_22_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_5_22_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_3_5_22_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_5_22_reg))
#define  SRNN_wdsr_layer4_3x3_weights_3_5_22_layer4_weight_22_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_3_5_22_layer4_weight_22_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_3_5_22_layer4_weight_22(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_3_5_22_get_layer4_weight_22(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_3_6_00                                    0x181AC314
#define  SRNN_wdsr_layer4_3x3_weights_3_6_00_reg_addr                            "0xB81AC314"
#define  SRNN_wdsr_layer4_3x3_weights_3_6_00_reg                                 0xB81AC314
#define  SRNN_wdsr_layer4_3x3_weights_3_6_00_inst_addr                           "0x04E9"
#define  set_SRNN_wdsr_layer4_3x3_weights_3_6_00_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_6_00_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_3_6_00_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_6_00_reg))
#define  SRNN_wdsr_layer4_3x3_weights_3_6_00_layer4_weight_00_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_3_6_00_layer4_weight_00_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_3_6_00_layer4_weight_00(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_3_6_00_get_layer4_weight_00(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_3_6_01                                    0x181AC318
#define  SRNN_wdsr_layer4_3x3_weights_3_6_01_reg_addr                            "0xB81AC318"
#define  SRNN_wdsr_layer4_3x3_weights_3_6_01_reg                                 0xB81AC318
#define  SRNN_wdsr_layer4_3x3_weights_3_6_01_inst_addr                           "0x04EA"
#define  set_SRNN_wdsr_layer4_3x3_weights_3_6_01_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_6_01_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_3_6_01_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_6_01_reg))
#define  SRNN_wdsr_layer4_3x3_weights_3_6_01_layer4_weight_01_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_3_6_01_layer4_weight_01_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_3_6_01_layer4_weight_01(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_3_6_01_get_layer4_weight_01(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_3_6_02                                    0x181AC31C
#define  SRNN_wdsr_layer4_3x3_weights_3_6_02_reg_addr                            "0xB81AC31C"
#define  SRNN_wdsr_layer4_3x3_weights_3_6_02_reg                                 0xB81AC31C
#define  SRNN_wdsr_layer4_3x3_weights_3_6_02_inst_addr                           "0x04EB"
#define  set_SRNN_wdsr_layer4_3x3_weights_3_6_02_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_6_02_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_3_6_02_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_6_02_reg))
#define  SRNN_wdsr_layer4_3x3_weights_3_6_02_layer4_weight_02_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_3_6_02_layer4_weight_02_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_3_6_02_layer4_weight_02(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_3_6_02_get_layer4_weight_02(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_3_6_10                                    0x181AC320
#define  SRNN_wdsr_layer4_3x3_weights_3_6_10_reg_addr                            "0xB81AC320"
#define  SRNN_wdsr_layer4_3x3_weights_3_6_10_reg                                 0xB81AC320
#define  SRNN_wdsr_layer4_3x3_weights_3_6_10_inst_addr                           "0x04EC"
#define  set_SRNN_wdsr_layer4_3x3_weights_3_6_10_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_6_10_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_3_6_10_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_6_10_reg))
#define  SRNN_wdsr_layer4_3x3_weights_3_6_10_layer4_weight_10_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_3_6_10_layer4_weight_10_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_3_6_10_layer4_weight_10(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_3_6_10_get_layer4_weight_10(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_3_6_11                                    0x181AC324
#define  SRNN_wdsr_layer4_3x3_weights_3_6_11_reg_addr                            "0xB81AC324"
#define  SRNN_wdsr_layer4_3x3_weights_3_6_11_reg                                 0xB81AC324
#define  SRNN_wdsr_layer4_3x3_weights_3_6_11_inst_addr                           "0x04ED"
#define  set_SRNN_wdsr_layer4_3x3_weights_3_6_11_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_6_11_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_3_6_11_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_6_11_reg))
#define  SRNN_wdsr_layer4_3x3_weights_3_6_11_layer4_weight_11_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_3_6_11_layer4_weight_11_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_3_6_11_layer4_weight_11(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_3_6_11_get_layer4_weight_11(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_3_6_12                                    0x181AC328
#define  SRNN_wdsr_layer4_3x3_weights_3_6_12_reg_addr                            "0xB81AC328"
#define  SRNN_wdsr_layer4_3x3_weights_3_6_12_reg                                 0xB81AC328
#define  SRNN_wdsr_layer4_3x3_weights_3_6_12_inst_addr                           "0x04EE"
#define  set_SRNN_wdsr_layer4_3x3_weights_3_6_12_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_6_12_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_3_6_12_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_6_12_reg))
#define  SRNN_wdsr_layer4_3x3_weights_3_6_12_layer4_weight_12_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_3_6_12_layer4_weight_12_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_3_6_12_layer4_weight_12(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_3_6_12_get_layer4_weight_12(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_3_6_20                                    0x181AC32C
#define  SRNN_wdsr_layer4_3x3_weights_3_6_20_reg_addr                            "0xB81AC32C"
#define  SRNN_wdsr_layer4_3x3_weights_3_6_20_reg                                 0xB81AC32C
#define  SRNN_wdsr_layer4_3x3_weights_3_6_20_inst_addr                           "0x04EF"
#define  set_SRNN_wdsr_layer4_3x3_weights_3_6_20_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_6_20_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_3_6_20_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_6_20_reg))
#define  SRNN_wdsr_layer4_3x3_weights_3_6_20_layer4_weight_20_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_3_6_20_layer4_weight_20_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_3_6_20_layer4_weight_20(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_3_6_20_get_layer4_weight_20(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_3_6_21                                    0x181AC330
#define  SRNN_wdsr_layer4_3x3_weights_3_6_21_reg_addr                            "0xB81AC330"
#define  SRNN_wdsr_layer4_3x3_weights_3_6_21_reg                                 0xB81AC330
#define  SRNN_wdsr_layer4_3x3_weights_3_6_21_inst_addr                           "0x04F0"
#define  set_SRNN_wdsr_layer4_3x3_weights_3_6_21_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_6_21_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_3_6_21_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_6_21_reg))
#define  SRNN_wdsr_layer4_3x3_weights_3_6_21_layer4_weight_21_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_3_6_21_layer4_weight_21_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_3_6_21_layer4_weight_21(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_3_6_21_get_layer4_weight_21(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_3_6_22                                    0x181AC334
#define  SRNN_wdsr_layer4_3x3_weights_3_6_22_reg_addr                            "0xB81AC334"
#define  SRNN_wdsr_layer4_3x3_weights_3_6_22_reg                                 0xB81AC334
#define  SRNN_wdsr_layer4_3x3_weights_3_6_22_inst_addr                           "0x04F1"
#define  set_SRNN_wdsr_layer4_3x3_weights_3_6_22_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_6_22_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_3_6_22_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_6_22_reg))
#define  SRNN_wdsr_layer4_3x3_weights_3_6_22_layer4_weight_22_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_3_6_22_layer4_weight_22_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_3_6_22_layer4_weight_22(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_3_6_22_get_layer4_weight_22(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_3_7_00                                    0x181AC338
#define  SRNN_wdsr_layer4_3x3_weights_3_7_00_reg_addr                            "0xB81AC338"
#define  SRNN_wdsr_layer4_3x3_weights_3_7_00_reg                                 0xB81AC338
#define  SRNN_wdsr_layer4_3x3_weights_3_7_00_inst_addr                           "0x04F2"
#define  set_SRNN_wdsr_layer4_3x3_weights_3_7_00_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_7_00_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_3_7_00_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_7_00_reg))
#define  SRNN_wdsr_layer4_3x3_weights_3_7_00_layer4_weight_00_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_3_7_00_layer4_weight_00_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_3_7_00_layer4_weight_00(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_3_7_00_get_layer4_weight_00(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_3_7_01                                    0x181AC33C
#define  SRNN_wdsr_layer4_3x3_weights_3_7_01_reg_addr                            "0xB81AC33C"
#define  SRNN_wdsr_layer4_3x3_weights_3_7_01_reg                                 0xB81AC33C
#define  SRNN_wdsr_layer4_3x3_weights_3_7_01_inst_addr                           "0x04F3"
#define  set_SRNN_wdsr_layer4_3x3_weights_3_7_01_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_7_01_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_3_7_01_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_7_01_reg))
#define  SRNN_wdsr_layer4_3x3_weights_3_7_01_layer4_weight_01_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_3_7_01_layer4_weight_01_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_3_7_01_layer4_weight_01(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_3_7_01_get_layer4_weight_01(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_3_7_02                                    0x181AC340
#define  SRNN_wdsr_layer4_3x3_weights_3_7_02_reg_addr                            "0xB81AC340"
#define  SRNN_wdsr_layer4_3x3_weights_3_7_02_reg                                 0xB81AC340
#define  SRNN_wdsr_layer4_3x3_weights_3_7_02_inst_addr                           "0x04F4"
#define  set_SRNN_wdsr_layer4_3x3_weights_3_7_02_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_7_02_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_3_7_02_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_7_02_reg))
#define  SRNN_wdsr_layer4_3x3_weights_3_7_02_layer4_weight_02_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_3_7_02_layer4_weight_02_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_3_7_02_layer4_weight_02(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_3_7_02_get_layer4_weight_02(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_3_7_10                                    0x181AC344
#define  SRNN_wdsr_layer4_3x3_weights_3_7_10_reg_addr                            "0xB81AC344"
#define  SRNN_wdsr_layer4_3x3_weights_3_7_10_reg                                 0xB81AC344
#define  SRNN_wdsr_layer4_3x3_weights_3_7_10_inst_addr                           "0x04F5"
#define  set_SRNN_wdsr_layer4_3x3_weights_3_7_10_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_7_10_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_3_7_10_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_7_10_reg))
#define  SRNN_wdsr_layer4_3x3_weights_3_7_10_layer4_weight_10_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_3_7_10_layer4_weight_10_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_3_7_10_layer4_weight_10(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_3_7_10_get_layer4_weight_10(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_3_7_11                                    0x181AC348
#define  SRNN_wdsr_layer4_3x3_weights_3_7_11_reg_addr                            "0xB81AC348"
#define  SRNN_wdsr_layer4_3x3_weights_3_7_11_reg                                 0xB81AC348
#define  SRNN_wdsr_layer4_3x3_weights_3_7_11_inst_addr                           "0x04F6"
#define  set_SRNN_wdsr_layer4_3x3_weights_3_7_11_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_7_11_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_3_7_11_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_7_11_reg))
#define  SRNN_wdsr_layer4_3x3_weights_3_7_11_layer4_weight_11_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_3_7_11_layer4_weight_11_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_3_7_11_layer4_weight_11(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_3_7_11_get_layer4_weight_11(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_3_7_12                                    0x181AC34C
#define  SRNN_wdsr_layer4_3x3_weights_3_7_12_reg_addr                            "0xB81AC34C"
#define  SRNN_wdsr_layer4_3x3_weights_3_7_12_reg                                 0xB81AC34C
#define  SRNN_wdsr_layer4_3x3_weights_3_7_12_inst_addr                           "0x04F7"
#define  set_SRNN_wdsr_layer4_3x3_weights_3_7_12_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_7_12_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_3_7_12_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_7_12_reg))
#define  SRNN_wdsr_layer4_3x3_weights_3_7_12_layer4_weight_12_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_3_7_12_layer4_weight_12_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_3_7_12_layer4_weight_12(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_3_7_12_get_layer4_weight_12(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_3_7_20                                    0x181AC350
#define  SRNN_wdsr_layer4_3x3_weights_3_7_20_reg_addr                            "0xB81AC350"
#define  SRNN_wdsr_layer4_3x3_weights_3_7_20_reg                                 0xB81AC350
#define  SRNN_wdsr_layer4_3x3_weights_3_7_20_inst_addr                           "0x04F8"
#define  set_SRNN_wdsr_layer4_3x3_weights_3_7_20_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_7_20_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_3_7_20_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_7_20_reg))
#define  SRNN_wdsr_layer4_3x3_weights_3_7_20_layer4_weight_20_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_3_7_20_layer4_weight_20_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_3_7_20_layer4_weight_20(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_3_7_20_get_layer4_weight_20(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_3_7_21                                    0x181AC354
#define  SRNN_wdsr_layer4_3x3_weights_3_7_21_reg_addr                            "0xB81AC354"
#define  SRNN_wdsr_layer4_3x3_weights_3_7_21_reg                                 0xB81AC354
#define  SRNN_wdsr_layer4_3x3_weights_3_7_21_inst_addr                           "0x04F9"
#define  set_SRNN_wdsr_layer4_3x3_weights_3_7_21_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_7_21_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_3_7_21_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_7_21_reg))
#define  SRNN_wdsr_layer4_3x3_weights_3_7_21_layer4_weight_21_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_3_7_21_layer4_weight_21_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_3_7_21_layer4_weight_21(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_3_7_21_get_layer4_weight_21(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_3_7_22                                    0x181AC358
#define  SRNN_wdsr_layer4_3x3_weights_3_7_22_reg_addr                            "0xB81AC358"
#define  SRNN_wdsr_layer4_3x3_weights_3_7_22_reg                                 0xB81AC358
#define  SRNN_wdsr_layer4_3x3_weights_3_7_22_inst_addr                           "0x04FA"
#define  set_SRNN_wdsr_layer4_3x3_weights_3_7_22_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_7_22_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_3_7_22_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_7_22_reg))
#define  SRNN_wdsr_layer4_3x3_weights_3_7_22_layer4_weight_22_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_3_7_22_layer4_weight_22_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_3_7_22_layer4_weight_22(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_3_7_22_get_layer4_weight_22(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_3_8_00                                    0x181AC35C
#define  SRNN_wdsr_layer4_3x3_weights_3_8_00_reg_addr                            "0xB81AC35C"
#define  SRNN_wdsr_layer4_3x3_weights_3_8_00_reg                                 0xB81AC35C
#define  SRNN_wdsr_layer4_3x3_weights_3_8_00_inst_addr                           "0x04FB"
#define  set_SRNN_wdsr_layer4_3x3_weights_3_8_00_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_8_00_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_3_8_00_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_8_00_reg))
#define  SRNN_wdsr_layer4_3x3_weights_3_8_00_layer4_weight_00_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_3_8_00_layer4_weight_00_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_3_8_00_layer4_weight_00(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_3_8_00_get_layer4_weight_00(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_3_8_01                                    0x181AC360
#define  SRNN_wdsr_layer4_3x3_weights_3_8_01_reg_addr                            "0xB81AC360"
#define  SRNN_wdsr_layer4_3x3_weights_3_8_01_reg                                 0xB81AC360
#define  SRNN_wdsr_layer4_3x3_weights_3_8_01_inst_addr                           "0x04FC"
#define  set_SRNN_wdsr_layer4_3x3_weights_3_8_01_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_8_01_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_3_8_01_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_8_01_reg))
#define  SRNN_wdsr_layer4_3x3_weights_3_8_01_layer4_weight_01_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_3_8_01_layer4_weight_01_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_3_8_01_layer4_weight_01(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_3_8_01_get_layer4_weight_01(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_3_8_02                                    0x181AC364
#define  SRNN_wdsr_layer4_3x3_weights_3_8_02_reg_addr                            "0xB81AC364"
#define  SRNN_wdsr_layer4_3x3_weights_3_8_02_reg                                 0xB81AC364
#define  SRNN_wdsr_layer4_3x3_weights_3_8_02_inst_addr                           "0x04FD"
#define  set_SRNN_wdsr_layer4_3x3_weights_3_8_02_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_8_02_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_3_8_02_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_8_02_reg))
#define  SRNN_wdsr_layer4_3x3_weights_3_8_02_layer4_weight_02_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_3_8_02_layer4_weight_02_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_3_8_02_layer4_weight_02(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_3_8_02_get_layer4_weight_02(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_3_8_10                                    0x181AC368
#define  SRNN_wdsr_layer4_3x3_weights_3_8_10_reg_addr                            "0xB81AC368"
#define  SRNN_wdsr_layer4_3x3_weights_3_8_10_reg                                 0xB81AC368
#define  SRNN_wdsr_layer4_3x3_weights_3_8_10_inst_addr                           "0x04FE"
#define  set_SRNN_wdsr_layer4_3x3_weights_3_8_10_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_8_10_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_3_8_10_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_8_10_reg))
#define  SRNN_wdsr_layer4_3x3_weights_3_8_10_layer4_weight_10_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_3_8_10_layer4_weight_10_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_3_8_10_layer4_weight_10(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_3_8_10_get_layer4_weight_10(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_3_8_11                                    0x181AC36C
#define  SRNN_wdsr_layer4_3x3_weights_3_8_11_reg_addr                            "0xB81AC36C"
#define  SRNN_wdsr_layer4_3x3_weights_3_8_11_reg                                 0xB81AC36C
#define  SRNN_wdsr_layer4_3x3_weights_3_8_11_inst_addr                           "0x04FF"
#define  set_SRNN_wdsr_layer4_3x3_weights_3_8_11_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_8_11_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_3_8_11_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_8_11_reg))
#define  SRNN_wdsr_layer4_3x3_weights_3_8_11_layer4_weight_11_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_3_8_11_layer4_weight_11_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_3_8_11_layer4_weight_11(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_3_8_11_get_layer4_weight_11(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_3_8_12                                    0x181AC370
#define  SRNN_wdsr_layer4_3x3_weights_3_8_12_reg_addr                            "0xB81AC370"
#define  SRNN_wdsr_layer4_3x3_weights_3_8_12_reg                                 0xB81AC370
#define  SRNN_wdsr_layer4_3x3_weights_3_8_12_inst_addr                           "0x0500"
#define  set_SRNN_wdsr_layer4_3x3_weights_3_8_12_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_8_12_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_3_8_12_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_8_12_reg))
#define  SRNN_wdsr_layer4_3x3_weights_3_8_12_layer4_weight_12_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_3_8_12_layer4_weight_12_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_3_8_12_layer4_weight_12(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_3_8_12_get_layer4_weight_12(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_3_8_20                                    0x181AC374
#define  SRNN_wdsr_layer4_3x3_weights_3_8_20_reg_addr                            "0xB81AC374"
#define  SRNN_wdsr_layer4_3x3_weights_3_8_20_reg                                 0xB81AC374
#define  SRNN_wdsr_layer4_3x3_weights_3_8_20_inst_addr                           "0x0501"
#define  set_SRNN_wdsr_layer4_3x3_weights_3_8_20_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_8_20_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_3_8_20_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_8_20_reg))
#define  SRNN_wdsr_layer4_3x3_weights_3_8_20_layer4_weight_20_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_3_8_20_layer4_weight_20_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_3_8_20_layer4_weight_20(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_3_8_20_get_layer4_weight_20(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_3_8_21                                    0x181AC378
#define  SRNN_wdsr_layer4_3x3_weights_3_8_21_reg_addr                            "0xB81AC378"
#define  SRNN_wdsr_layer4_3x3_weights_3_8_21_reg                                 0xB81AC378
#define  SRNN_wdsr_layer4_3x3_weights_3_8_21_inst_addr                           "0x0502"
#define  set_SRNN_wdsr_layer4_3x3_weights_3_8_21_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_8_21_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_3_8_21_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_8_21_reg))
#define  SRNN_wdsr_layer4_3x3_weights_3_8_21_layer4_weight_21_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_3_8_21_layer4_weight_21_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_3_8_21_layer4_weight_21(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_3_8_21_get_layer4_weight_21(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_3_8_22                                    0x181AC37C
#define  SRNN_wdsr_layer4_3x3_weights_3_8_22_reg_addr                            "0xB81AC37C"
#define  SRNN_wdsr_layer4_3x3_weights_3_8_22_reg                                 0xB81AC37C
#define  SRNN_wdsr_layer4_3x3_weights_3_8_22_inst_addr                           "0x0503"
#define  set_SRNN_wdsr_layer4_3x3_weights_3_8_22_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_8_22_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_3_8_22_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_3_8_22_reg))
#define  SRNN_wdsr_layer4_3x3_weights_3_8_22_layer4_weight_22_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_3_8_22_layer4_weight_22_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_3_8_22_layer4_weight_22(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_3_8_22_get_layer4_weight_22(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_4_1_00                                    0x181AC380
#define  SRNN_wdsr_layer4_3x3_weights_4_1_00_reg_addr                            "0xB81AC380"
#define  SRNN_wdsr_layer4_3x3_weights_4_1_00_reg                                 0xB81AC380
#define  SRNN_wdsr_layer4_3x3_weights_4_1_00_inst_addr                           "0x0504"
#define  set_SRNN_wdsr_layer4_3x3_weights_4_1_00_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_1_00_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_4_1_00_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_1_00_reg))
#define  SRNN_wdsr_layer4_3x3_weights_4_1_00_layer4_weight_00_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_4_1_00_layer4_weight_00_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_4_1_00_layer4_weight_00(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_4_1_00_get_layer4_weight_00(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_4_1_01                                    0x181AC384
#define  SRNN_wdsr_layer4_3x3_weights_4_1_01_reg_addr                            "0xB81AC384"
#define  SRNN_wdsr_layer4_3x3_weights_4_1_01_reg                                 0xB81AC384
#define  SRNN_wdsr_layer4_3x3_weights_4_1_01_inst_addr                           "0x0505"
#define  set_SRNN_wdsr_layer4_3x3_weights_4_1_01_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_1_01_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_4_1_01_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_1_01_reg))
#define  SRNN_wdsr_layer4_3x3_weights_4_1_01_layer4_weight_01_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_4_1_01_layer4_weight_01_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_4_1_01_layer4_weight_01(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_4_1_01_get_layer4_weight_01(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_4_1_02                                    0x181AC388
#define  SRNN_wdsr_layer4_3x3_weights_4_1_02_reg_addr                            "0xB81AC388"
#define  SRNN_wdsr_layer4_3x3_weights_4_1_02_reg                                 0xB81AC388
#define  SRNN_wdsr_layer4_3x3_weights_4_1_02_inst_addr                           "0x0506"
#define  set_SRNN_wdsr_layer4_3x3_weights_4_1_02_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_1_02_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_4_1_02_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_1_02_reg))
#define  SRNN_wdsr_layer4_3x3_weights_4_1_02_layer4_weight_02_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_4_1_02_layer4_weight_02_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_4_1_02_layer4_weight_02(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_4_1_02_get_layer4_weight_02(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_4_1_10                                    0x181AC38C
#define  SRNN_wdsr_layer4_3x3_weights_4_1_10_reg_addr                            "0xB81AC38C"
#define  SRNN_wdsr_layer4_3x3_weights_4_1_10_reg                                 0xB81AC38C
#define  SRNN_wdsr_layer4_3x3_weights_4_1_10_inst_addr                           "0x0507"
#define  set_SRNN_wdsr_layer4_3x3_weights_4_1_10_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_1_10_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_4_1_10_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_1_10_reg))
#define  SRNN_wdsr_layer4_3x3_weights_4_1_10_layer4_weight_10_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_4_1_10_layer4_weight_10_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_4_1_10_layer4_weight_10(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_4_1_10_get_layer4_weight_10(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_4_1_11                                    0x181AC390
#define  SRNN_wdsr_layer4_3x3_weights_4_1_11_reg_addr                            "0xB81AC390"
#define  SRNN_wdsr_layer4_3x3_weights_4_1_11_reg                                 0xB81AC390
#define  SRNN_wdsr_layer4_3x3_weights_4_1_11_inst_addr                           "0x0508"
#define  set_SRNN_wdsr_layer4_3x3_weights_4_1_11_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_1_11_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_4_1_11_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_1_11_reg))
#define  SRNN_wdsr_layer4_3x3_weights_4_1_11_layer4_weight_11_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_4_1_11_layer4_weight_11_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_4_1_11_layer4_weight_11(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_4_1_11_get_layer4_weight_11(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_4_1_12                                    0x181AC394
#define  SRNN_wdsr_layer4_3x3_weights_4_1_12_reg_addr                            "0xB81AC394"
#define  SRNN_wdsr_layer4_3x3_weights_4_1_12_reg                                 0xB81AC394
#define  SRNN_wdsr_layer4_3x3_weights_4_1_12_inst_addr                           "0x0509"
#define  set_SRNN_wdsr_layer4_3x3_weights_4_1_12_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_1_12_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_4_1_12_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_1_12_reg))
#define  SRNN_wdsr_layer4_3x3_weights_4_1_12_layer4_weight_12_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_4_1_12_layer4_weight_12_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_4_1_12_layer4_weight_12(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_4_1_12_get_layer4_weight_12(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_4_1_20                                    0x181AC398
#define  SRNN_wdsr_layer4_3x3_weights_4_1_20_reg_addr                            "0xB81AC398"
#define  SRNN_wdsr_layer4_3x3_weights_4_1_20_reg                                 0xB81AC398
#define  SRNN_wdsr_layer4_3x3_weights_4_1_20_inst_addr                           "0x050A"
#define  set_SRNN_wdsr_layer4_3x3_weights_4_1_20_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_1_20_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_4_1_20_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_1_20_reg))
#define  SRNN_wdsr_layer4_3x3_weights_4_1_20_layer4_weight_20_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_4_1_20_layer4_weight_20_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_4_1_20_layer4_weight_20(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_4_1_20_get_layer4_weight_20(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_4_1_21                                    0x181AC39C
#define  SRNN_wdsr_layer4_3x3_weights_4_1_21_reg_addr                            "0xB81AC39C"
#define  SRNN_wdsr_layer4_3x3_weights_4_1_21_reg                                 0xB81AC39C
#define  SRNN_wdsr_layer4_3x3_weights_4_1_21_inst_addr                           "0x050B"
#define  set_SRNN_wdsr_layer4_3x3_weights_4_1_21_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_1_21_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_4_1_21_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_1_21_reg))
#define  SRNN_wdsr_layer4_3x3_weights_4_1_21_layer4_weight_21_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_4_1_21_layer4_weight_21_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_4_1_21_layer4_weight_21(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_4_1_21_get_layer4_weight_21(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_4_1_22                                    0x181AC3A0
#define  SRNN_wdsr_layer4_3x3_weights_4_1_22_reg_addr                            "0xB81AC3A0"
#define  SRNN_wdsr_layer4_3x3_weights_4_1_22_reg                                 0xB81AC3A0
#define  SRNN_wdsr_layer4_3x3_weights_4_1_22_inst_addr                           "0x050C"
#define  set_SRNN_wdsr_layer4_3x3_weights_4_1_22_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_1_22_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_4_1_22_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_1_22_reg))
#define  SRNN_wdsr_layer4_3x3_weights_4_1_22_layer4_weight_22_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_4_1_22_layer4_weight_22_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_4_1_22_layer4_weight_22(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_4_1_22_get_layer4_weight_22(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_4_2_00                                    0x181AC3A4
#define  SRNN_wdsr_layer4_3x3_weights_4_2_00_reg_addr                            "0xB81AC3A4"
#define  SRNN_wdsr_layer4_3x3_weights_4_2_00_reg                                 0xB81AC3A4
#define  SRNN_wdsr_layer4_3x3_weights_4_2_00_inst_addr                           "0x050D"
#define  set_SRNN_wdsr_layer4_3x3_weights_4_2_00_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_2_00_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_4_2_00_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_2_00_reg))
#define  SRNN_wdsr_layer4_3x3_weights_4_2_00_layer4_weight_00_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_4_2_00_layer4_weight_00_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_4_2_00_layer4_weight_00(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_4_2_00_get_layer4_weight_00(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_4_2_01                                    0x181AC3A8
#define  SRNN_wdsr_layer4_3x3_weights_4_2_01_reg_addr                            "0xB81AC3A8"
#define  SRNN_wdsr_layer4_3x3_weights_4_2_01_reg                                 0xB81AC3A8
#define  SRNN_wdsr_layer4_3x3_weights_4_2_01_inst_addr                           "0x050E"
#define  set_SRNN_wdsr_layer4_3x3_weights_4_2_01_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_2_01_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_4_2_01_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_2_01_reg))
#define  SRNN_wdsr_layer4_3x3_weights_4_2_01_layer4_weight_01_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_4_2_01_layer4_weight_01_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_4_2_01_layer4_weight_01(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_4_2_01_get_layer4_weight_01(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_4_2_02                                    0x181AC3AC
#define  SRNN_wdsr_layer4_3x3_weights_4_2_02_reg_addr                            "0xB81AC3AC"
#define  SRNN_wdsr_layer4_3x3_weights_4_2_02_reg                                 0xB81AC3AC
#define  SRNN_wdsr_layer4_3x3_weights_4_2_02_inst_addr                           "0x050F"
#define  set_SRNN_wdsr_layer4_3x3_weights_4_2_02_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_2_02_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_4_2_02_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_2_02_reg))
#define  SRNN_wdsr_layer4_3x3_weights_4_2_02_layer4_weight_02_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_4_2_02_layer4_weight_02_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_4_2_02_layer4_weight_02(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_4_2_02_get_layer4_weight_02(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_4_2_10                                    0x181AC3B0
#define  SRNN_wdsr_layer4_3x3_weights_4_2_10_reg_addr                            "0xB81AC3B0"
#define  SRNN_wdsr_layer4_3x3_weights_4_2_10_reg                                 0xB81AC3B0
#define  SRNN_wdsr_layer4_3x3_weights_4_2_10_inst_addr                           "0x0510"
#define  set_SRNN_wdsr_layer4_3x3_weights_4_2_10_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_2_10_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_4_2_10_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_2_10_reg))
#define  SRNN_wdsr_layer4_3x3_weights_4_2_10_layer4_weight_10_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_4_2_10_layer4_weight_10_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_4_2_10_layer4_weight_10(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_4_2_10_get_layer4_weight_10(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_4_2_11                                    0x181AC3B4
#define  SRNN_wdsr_layer4_3x3_weights_4_2_11_reg_addr                            "0xB81AC3B4"
#define  SRNN_wdsr_layer4_3x3_weights_4_2_11_reg                                 0xB81AC3B4
#define  SRNN_wdsr_layer4_3x3_weights_4_2_11_inst_addr                           "0x0511"
#define  set_SRNN_wdsr_layer4_3x3_weights_4_2_11_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_2_11_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_4_2_11_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_2_11_reg))
#define  SRNN_wdsr_layer4_3x3_weights_4_2_11_layer4_weight_11_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_4_2_11_layer4_weight_11_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_4_2_11_layer4_weight_11(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_4_2_11_get_layer4_weight_11(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_4_2_12                                    0x181AC3B8
#define  SRNN_wdsr_layer4_3x3_weights_4_2_12_reg_addr                            "0xB81AC3B8"
#define  SRNN_wdsr_layer4_3x3_weights_4_2_12_reg                                 0xB81AC3B8
#define  SRNN_wdsr_layer4_3x3_weights_4_2_12_inst_addr                           "0x0512"
#define  set_SRNN_wdsr_layer4_3x3_weights_4_2_12_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_2_12_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_4_2_12_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_2_12_reg))
#define  SRNN_wdsr_layer4_3x3_weights_4_2_12_layer4_weight_12_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_4_2_12_layer4_weight_12_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_4_2_12_layer4_weight_12(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_4_2_12_get_layer4_weight_12(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_4_2_20                                    0x181AC3BC
#define  SRNN_wdsr_layer4_3x3_weights_4_2_20_reg_addr                            "0xB81AC3BC"
#define  SRNN_wdsr_layer4_3x3_weights_4_2_20_reg                                 0xB81AC3BC
#define  SRNN_wdsr_layer4_3x3_weights_4_2_20_inst_addr                           "0x0513"
#define  set_SRNN_wdsr_layer4_3x3_weights_4_2_20_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_2_20_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_4_2_20_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_2_20_reg))
#define  SRNN_wdsr_layer4_3x3_weights_4_2_20_layer4_weight_20_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_4_2_20_layer4_weight_20_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_4_2_20_layer4_weight_20(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_4_2_20_get_layer4_weight_20(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_4_2_21                                    0x181AC3C0
#define  SRNN_wdsr_layer4_3x3_weights_4_2_21_reg_addr                            "0xB81AC3C0"
#define  SRNN_wdsr_layer4_3x3_weights_4_2_21_reg                                 0xB81AC3C0
#define  SRNN_wdsr_layer4_3x3_weights_4_2_21_inst_addr                           "0x0514"
#define  set_SRNN_wdsr_layer4_3x3_weights_4_2_21_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_2_21_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_4_2_21_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_2_21_reg))
#define  SRNN_wdsr_layer4_3x3_weights_4_2_21_layer4_weight_21_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_4_2_21_layer4_weight_21_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_4_2_21_layer4_weight_21(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_4_2_21_get_layer4_weight_21(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_4_2_22                                    0x181AC3C4
#define  SRNN_wdsr_layer4_3x3_weights_4_2_22_reg_addr                            "0xB81AC3C4"
#define  SRNN_wdsr_layer4_3x3_weights_4_2_22_reg                                 0xB81AC3C4
#define  SRNN_wdsr_layer4_3x3_weights_4_2_22_inst_addr                           "0x0515"
#define  set_SRNN_wdsr_layer4_3x3_weights_4_2_22_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_2_22_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_4_2_22_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_2_22_reg))
#define  SRNN_wdsr_layer4_3x3_weights_4_2_22_layer4_weight_22_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_4_2_22_layer4_weight_22_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_4_2_22_layer4_weight_22(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_4_2_22_get_layer4_weight_22(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_4_3_00                                    0x181AC3C8
#define  SRNN_wdsr_layer4_3x3_weights_4_3_00_reg_addr                            "0xB81AC3C8"
#define  SRNN_wdsr_layer4_3x3_weights_4_3_00_reg                                 0xB81AC3C8
#define  SRNN_wdsr_layer4_3x3_weights_4_3_00_inst_addr                           "0x0516"
#define  set_SRNN_wdsr_layer4_3x3_weights_4_3_00_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_3_00_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_4_3_00_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_3_00_reg))
#define  SRNN_wdsr_layer4_3x3_weights_4_3_00_layer4_weight_00_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_4_3_00_layer4_weight_00_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_4_3_00_layer4_weight_00(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_4_3_00_get_layer4_weight_00(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_4_3_01                                    0x181AC3CC
#define  SRNN_wdsr_layer4_3x3_weights_4_3_01_reg_addr                            "0xB81AC3CC"
#define  SRNN_wdsr_layer4_3x3_weights_4_3_01_reg                                 0xB81AC3CC
#define  SRNN_wdsr_layer4_3x3_weights_4_3_01_inst_addr                           "0x0517"
#define  set_SRNN_wdsr_layer4_3x3_weights_4_3_01_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_3_01_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_4_3_01_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_3_01_reg))
#define  SRNN_wdsr_layer4_3x3_weights_4_3_01_layer4_weight_01_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_4_3_01_layer4_weight_01_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_4_3_01_layer4_weight_01(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_4_3_01_get_layer4_weight_01(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_4_3_02                                    0x181AC3D0
#define  SRNN_wdsr_layer4_3x3_weights_4_3_02_reg_addr                            "0xB81AC3D0"
#define  SRNN_wdsr_layer4_3x3_weights_4_3_02_reg                                 0xB81AC3D0
#define  SRNN_wdsr_layer4_3x3_weights_4_3_02_inst_addr                           "0x0518"
#define  set_SRNN_wdsr_layer4_3x3_weights_4_3_02_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_3_02_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_4_3_02_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_3_02_reg))
#define  SRNN_wdsr_layer4_3x3_weights_4_3_02_layer4_weight_02_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_4_3_02_layer4_weight_02_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_4_3_02_layer4_weight_02(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_4_3_02_get_layer4_weight_02(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_4_3_10                                    0x181AC3D4
#define  SRNN_wdsr_layer4_3x3_weights_4_3_10_reg_addr                            "0xB81AC3D4"
#define  SRNN_wdsr_layer4_3x3_weights_4_3_10_reg                                 0xB81AC3D4
#define  SRNN_wdsr_layer4_3x3_weights_4_3_10_inst_addr                           "0x0519"
#define  set_SRNN_wdsr_layer4_3x3_weights_4_3_10_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_3_10_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_4_3_10_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_3_10_reg))
#define  SRNN_wdsr_layer4_3x3_weights_4_3_10_layer4_weight_10_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_4_3_10_layer4_weight_10_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_4_3_10_layer4_weight_10(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_4_3_10_get_layer4_weight_10(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_4_3_11                                    0x181AC3D8
#define  SRNN_wdsr_layer4_3x3_weights_4_3_11_reg_addr                            "0xB81AC3D8"
#define  SRNN_wdsr_layer4_3x3_weights_4_3_11_reg                                 0xB81AC3D8
#define  SRNN_wdsr_layer4_3x3_weights_4_3_11_inst_addr                           "0x051A"
#define  set_SRNN_wdsr_layer4_3x3_weights_4_3_11_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_3_11_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_4_3_11_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_3_11_reg))
#define  SRNN_wdsr_layer4_3x3_weights_4_3_11_layer4_weight_11_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_4_3_11_layer4_weight_11_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_4_3_11_layer4_weight_11(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_4_3_11_get_layer4_weight_11(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_4_3_12                                    0x181AC3DC
#define  SRNN_wdsr_layer4_3x3_weights_4_3_12_reg_addr                            "0xB81AC3DC"
#define  SRNN_wdsr_layer4_3x3_weights_4_3_12_reg                                 0xB81AC3DC
#define  SRNN_wdsr_layer4_3x3_weights_4_3_12_inst_addr                           "0x051B"
#define  set_SRNN_wdsr_layer4_3x3_weights_4_3_12_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_3_12_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_4_3_12_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_3_12_reg))
#define  SRNN_wdsr_layer4_3x3_weights_4_3_12_layer4_weight_12_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_4_3_12_layer4_weight_12_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_4_3_12_layer4_weight_12(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_4_3_12_get_layer4_weight_12(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_4_3_20                                    0x181AC3E0
#define  SRNN_wdsr_layer4_3x3_weights_4_3_20_reg_addr                            "0xB81AC3E0"
#define  SRNN_wdsr_layer4_3x3_weights_4_3_20_reg                                 0xB81AC3E0
#define  SRNN_wdsr_layer4_3x3_weights_4_3_20_inst_addr                           "0x051C"
#define  set_SRNN_wdsr_layer4_3x3_weights_4_3_20_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_3_20_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_4_3_20_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_3_20_reg))
#define  SRNN_wdsr_layer4_3x3_weights_4_3_20_layer4_weight_20_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_4_3_20_layer4_weight_20_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_4_3_20_layer4_weight_20(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_4_3_20_get_layer4_weight_20(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_4_3_21                                    0x181AC3E4
#define  SRNN_wdsr_layer4_3x3_weights_4_3_21_reg_addr                            "0xB81AC3E4"
#define  SRNN_wdsr_layer4_3x3_weights_4_3_21_reg                                 0xB81AC3E4
#define  SRNN_wdsr_layer4_3x3_weights_4_3_21_inst_addr                           "0x051D"
#define  set_SRNN_wdsr_layer4_3x3_weights_4_3_21_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_3_21_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_4_3_21_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_3_21_reg))
#define  SRNN_wdsr_layer4_3x3_weights_4_3_21_layer4_weight_21_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_4_3_21_layer4_weight_21_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_4_3_21_layer4_weight_21(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_4_3_21_get_layer4_weight_21(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_4_3_22                                    0x181AC3E8
#define  SRNN_wdsr_layer4_3x3_weights_4_3_22_reg_addr                            "0xB81AC3E8"
#define  SRNN_wdsr_layer4_3x3_weights_4_3_22_reg                                 0xB81AC3E8
#define  SRNN_wdsr_layer4_3x3_weights_4_3_22_inst_addr                           "0x051E"
#define  set_SRNN_wdsr_layer4_3x3_weights_4_3_22_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_3_22_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_4_3_22_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_3_22_reg))
#define  SRNN_wdsr_layer4_3x3_weights_4_3_22_layer4_weight_22_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_4_3_22_layer4_weight_22_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_4_3_22_layer4_weight_22(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_4_3_22_get_layer4_weight_22(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_4_4_00                                    0x181AC3EC
#define  SRNN_wdsr_layer4_3x3_weights_4_4_00_reg_addr                            "0xB81AC3EC"
#define  SRNN_wdsr_layer4_3x3_weights_4_4_00_reg                                 0xB81AC3EC
#define  SRNN_wdsr_layer4_3x3_weights_4_4_00_inst_addr                           "0x051F"
#define  set_SRNN_wdsr_layer4_3x3_weights_4_4_00_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_4_00_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_4_4_00_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_4_00_reg))
#define  SRNN_wdsr_layer4_3x3_weights_4_4_00_layer4_weight_00_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_4_4_00_layer4_weight_00_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_4_4_00_layer4_weight_00(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_4_4_00_get_layer4_weight_00(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_4_4_01                                    0x181AC3F0
#define  SRNN_wdsr_layer4_3x3_weights_4_4_01_reg_addr                            "0xB81AC3F0"
#define  SRNN_wdsr_layer4_3x3_weights_4_4_01_reg                                 0xB81AC3F0
#define  SRNN_wdsr_layer4_3x3_weights_4_4_01_inst_addr                           "0x0520"
#define  set_SRNN_wdsr_layer4_3x3_weights_4_4_01_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_4_01_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_4_4_01_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_4_01_reg))
#define  SRNN_wdsr_layer4_3x3_weights_4_4_01_layer4_weight_01_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_4_4_01_layer4_weight_01_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_4_4_01_layer4_weight_01(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_4_4_01_get_layer4_weight_01(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_4_4_02                                    0x181AC3F4
#define  SRNN_wdsr_layer4_3x3_weights_4_4_02_reg_addr                            "0xB81AC3F4"
#define  SRNN_wdsr_layer4_3x3_weights_4_4_02_reg                                 0xB81AC3F4
#define  SRNN_wdsr_layer4_3x3_weights_4_4_02_inst_addr                           "0x0521"
#define  set_SRNN_wdsr_layer4_3x3_weights_4_4_02_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_4_02_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_4_4_02_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_4_02_reg))
#define  SRNN_wdsr_layer4_3x3_weights_4_4_02_layer4_weight_02_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_4_4_02_layer4_weight_02_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_4_4_02_layer4_weight_02(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_4_4_02_get_layer4_weight_02(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_4_4_10                                    0x181AC3F8
#define  SRNN_wdsr_layer4_3x3_weights_4_4_10_reg_addr                            "0xB81AC3F8"
#define  SRNN_wdsr_layer4_3x3_weights_4_4_10_reg                                 0xB81AC3F8
#define  SRNN_wdsr_layer4_3x3_weights_4_4_10_inst_addr                           "0x0522"
#define  set_SRNN_wdsr_layer4_3x3_weights_4_4_10_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_4_10_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_4_4_10_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_4_10_reg))
#define  SRNN_wdsr_layer4_3x3_weights_4_4_10_layer4_weight_10_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_4_4_10_layer4_weight_10_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_4_4_10_layer4_weight_10(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_4_4_10_get_layer4_weight_10(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_4_4_11                                    0x181AC3FC
#define  SRNN_wdsr_layer4_3x3_weights_4_4_11_reg_addr                            "0xB81AC3FC"
#define  SRNN_wdsr_layer4_3x3_weights_4_4_11_reg                                 0xB81AC3FC
#define  SRNN_wdsr_layer4_3x3_weights_4_4_11_inst_addr                           "0x0523"
#define  set_SRNN_wdsr_layer4_3x3_weights_4_4_11_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_4_11_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_4_4_11_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_4_11_reg))
#define  SRNN_wdsr_layer4_3x3_weights_4_4_11_layer4_weight_11_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_4_4_11_layer4_weight_11_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_4_4_11_layer4_weight_11(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_4_4_11_get_layer4_weight_11(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_4_4_12                                    0x181AC400
#define  SRNN_wdsr_layer4_3x3_weights_4_4_12_reg_addr                            "0xB81AC400"
#define  SRNN_wdsr_layer4_3x3_weights_4_4_12_reg                                 0xB81AC400
#define  SRNN_wdsr_layer4_3x3_weights_4_4_12_inst_addr                           "0x0524"
#define  set_SRNN_wdsr_layer4_3x3_weights_4_4_12_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_4_12_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_4_4_12_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_4_12_reg))
#define  SRNN_wdsr_layer4_3x3_weights_4_4_12_layer4_weight_12_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_4_4_12_layer4_weight_12_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_4_4_12_layer4_weight_12(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_4_4_12_get_layer4_weight_12(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_4_4_20                                    0x181AC404
#define  SRNN_wdsr_layer4_3x3_weights_4_4_20_reg_addr                            "0xB81AC404"
#define  SRNN_wdsr_layer4_3x3_weights_4_4_20_reg                                 0xB81AC404
#define  SRNN_wdsr_layer4_3x3_weights_4_4_20_inst_addr                           "0x0525"
#define  set_SRNN_wdsr_layer4_3x3_weights_4_4_20_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_4_20_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_4_4_20_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_4_20_reg))
#define  SRNN_wdsr_layer4_3x3_weights_4_4_20_layer4_weight_20_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_4_4_20_layer4_weight_20_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_4_4_20_layer4_weight_20(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_4_4_20_get_layer4_weight_20(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_4_4_21                                    0x181AC408
#define  SRNN_wdsr_layer4_3x3_weights_4_4_21_reg_addr                            "0xB81AC408"
#define  SRNN_wdsr_layer4_3x3_weights_4_4_21_reg                                 0xB81AC408
#define  SRNN_wdsr_layer4_3x3_weights_4_4_21_inst_addr                           "0x0526"
#define  set_SRNN_wdsr_layer4_3x3_weights_4_4_21_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_4_21_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_4_4_21_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_4_21_reg))
#define  SRNN_wdsr_layer4_3x3_weights_4_4_21_layer4_weight_21_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_4_4_21_layer4_weight_21_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_4_4_21_layer4_weight_21(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_4_4_21_get_layer4_weight_21(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_4_4_22                                    0x181AC40C
#define  SRNN_wdsr_layer4_3x3_weights_4_4_22_reg_addr                            "0xB81AC40C"
#define  SRNN_wdsr_layer4_3x3_weights_4_4_22_reg                                 0xB81AC40C
#define  SRNN_wdsr_layer4_3x3_weights_4_4_22_inst_addr                           "0x0527"
#define  set_SRNN_wdsr_layer4_3x3_weights_4_4_22_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_4_22_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_4_4_22_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_4_22_reg))
#define  SRNN_wdsr_layer4_3x3_weights_4_4_22_layer4_weight_22_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_4_4_22_layer4_weight_22_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_4_4_22_layer4_weight_22(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_4_4_22_get_layer4_weight_22(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_4_5_00                                    0x181AC410
#define  SRNN_wdsr_layer4_3x3_weights_4_5_00_reg_addr                            "0xB81AC410"
#define  SRNN_wdsr_layer4_3x3_weights_4_5_00_reg                                 0xB81AC410
#define  SRNN_wdsr_layer4_3x3_weights_4_5_00_inst_addr                           "0x0528"
#define  set_SRNN_wdsr_layer4_3x3_weights_4_5_00_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_5_00_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_4_5_00_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_5_00_reg))
#define  SRNN_wdsr_layer4_3x3_weights_4_5_00_layer4_weight_00_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_4_5_00_layer4_weight_00_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_4_5_00_layer4_weight_00(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_4_5_00_get_layer4_weight_00(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_4_5_01                                    0x181AC414
#define  SRNN_wdsr_layer4_3x3_weights_4_5_01_reg_addr                            "0xB81AC414"
#define  SRNN_wdsr_layer4_3x3_weights_4_5_01_reg                                 0xB81AC414
#define  SRNN_wdsr_layer4_3x3_weights_4_5_01_inst_addr                           "0x0529"
#define  set_SRNN_wdsr_layer4_3x3_weights_4_5_01_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_5_01_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_4_5_01_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_5_01_reg))
#define  SRNN_wdsr_layer4_3x3_weights_4_5_01_layer4_weight_01_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_4_5_01_layer4_weight_01_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_4_5_01_layer4_weight_01(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_4_5_01_get_layer4_weight_01(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_4_5_02                                    0x181AC418
#define  SRNN_wdsr_layer4_3x3_weights_4_5_02_reg_addr                            "0xB81AC418"
#define  SRNN_wdsr_layer4_3x3_weights_4_5_02_reg                                 0xB81AC418
#define  SRNN_wdsr_layer4_3x3_weights_4_5_02_inst_addr                           "0x052A"
#define  set_SRNN_wdsr_layer4_3x3_weights_4_5_02_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_5_02_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_4_5_02_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_5_02_reg))
#define  SRNN_wdsr_layer4_3x3_weights_4_5_02_layer4_weight_02_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_4_5_02_layer4_weight_02_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_4_5_02_layer4_weight_02(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_4_5_02_get_layer4_weight_02(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_4_5_10                                    0x181AC41C
#define  SRNN_wdsr_layer4_3x3_weights_4_5_10_reg_addr                            "0xB81AC41C"
#define  SRNN_wdsr_layer4_3x3_weights_4_5_10_reg                                 0xB81AC41C
#define  SRNN_wdsr_layer4_3x3_weights_4_5_10_inst_addr                           "0x052B"
#define  set_SRNN_wdsr_layer4_3x3_weights_4_5_10_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_5_10_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_4_5_10_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_5_10_reg))
#define  SRNN_wdsr_layer4_3x3_weights_4_5_10_layer4_weight_10_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_4_5_10_layer4_weight_10_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_4_5_10_layer4_weight_10(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_4_5_10_get_layer4_weight_10(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_4_5_11                                    0x181AC420
#define  SRNN_wdsr_layer4_3x3_weights_4_5_11_reg_addr                            "0xB81AC420"
#define  SRNN_wdsr_layer4_3x3_weights_4_5_11_reg                                 0xB81AC420
#define  SRNN_wdsr_layer4_3x3_weights_4_5_11_inst_addr                           "0x052C"
#define  set_SRNN_wdsr_layer4_3x3_weights_4_5_11_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_5_11_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_4_5_11_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_5_11_reg))
#define  SRNN_wdsr_layer4_3x3_weights_4_5_11_layer4_weight_11_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_4_5_11_layer4_weight_11_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_4_5_11_layer4_weight_11(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_4_5_11_get_layer4_weight_11(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_4_5_12                                    0x181AC424
#define  SRNN_wdsr_layer4_3x3_weights_4_5_12_reg_addr                            "0xB81AC424"
#define  SRNN_wdsr_layer4_3x3_weights_4_5_12_reg                                 0xB81AC424
#define  SRNN_wdsr_layer4_3x3_weights_4_5_12_inst_addr                           "0x052D"
#define  set_SRNN_wdsr_layer4_3x3_weights_4_5_12_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_5_12_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_4_5_12_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_5_12_reg))
#define  SRNN_wdsr_layer4_3x3_weights_4_5_12_layer4_weight_12_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_4_5_12_layer4_weight_12_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_4_5_12_layer4_weight_12(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_4_5_12_get_layer4_weight_12(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_4_5_20                                    0x181AC428
#define  SRNN_wdsr_layer4_3x3_weights_4_5_20_reg_addr                            "0xB81AC428"
#define  SRNN_wdsr_layer4_3x3_weights_4_5_20_reg                                 0xB81AC428
#define  SRNN_wdsr_layer4_3x3_weights_4_5_20_inst_addr                           "0x052E"
#define  set_SRNN_wdsr_layer4_3x3_weights_4_5_20_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_5_20_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_4_5_20_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_5_20_reg))
#define  SRNN_wdsr_layer4_3x3_weights_4_5_20_layer4_weight_20_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_4_5_20_layer4_weight_20_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_4_5_20_layer4_weight_20(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_4_5_20_get_layer4_weight_20(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_4_5_21                                    0x181AC42C
#define  SRNN_wdsr_layer4_3x3_weights_4_5_21_reg_addr                            "0xB81AC42C"
#define  SRNN_wdsr_layer4_3x3_weights_4_5_21_reg                                 0xB81AC42C
#define  SRNN_wdsr_layer4_3x3_weights_4_5_21_inst_addr                           "0x052F"
#define  set_SRNN_wdsr_layer4_3x3_weights_4_5_21_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_5_21_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_4_5_21_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_5_21_reg))
#define  SRNN_wdsr_layer4_3x3_weights_4_5_21_layer4_weight_21_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_4_5_21_layer4_weight_21_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_4_5_21_layer4_weight_21(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_4_5_21_get_layer4_weight_21(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_4_5_22                                    0x181AC430
#define  SRNN_wdsr_layer4_3x3_weights_4_5_22_reg_addr                            "0xB81AC430"
#define  SRNN_wdsr_layer4_3x3_weights_4_5_22_reg                                 0xB81AC430
#define  SRNN_wdsr_layer4_3x3_weights_4_5_22_inst_addr                           "0x0530"
#define  set_SRNN_wdsr_layer4_3x3_weights_4_5_22_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_5_22_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_4_5_22_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_5_22_reg))
#define  SRNN_wdsr_layer4_3x3_weights_4_5_22_layer4_weight_22_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_4_5_22_layer4_weight_22_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_4_5_22_layer4_weight_22(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_4_5_22_get_layer4_weight_22(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_4_6_00                                    0x181AC434
#define  SRNN_wdsr_layer4_3x3_weights_4_6_00_reg_addr                            "0xB81AC434"
#define  SRNN_wdsr_layer4_3x3_weights_4_6_00_reg                                 0xB81AC434
#define  SRNN_wdsr_layer4_3x3_weights_4_6_00_inst_addr                           "0x0531"
#define  set_SRNN_wdsr_layer4_3x3_weights_4_6_00_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_6_00_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_4_6_00_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_6_00_reg))
#define  SRNN_wdsr_layer4_3x3_weights_4_6_00_layer4_weight_00_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_4_6_00_layer4_weight_00_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_4_6_00_layer4_weight_00(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_4_6_00_get_layer4_weight_00(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_4_6_01                                    0x181AC438
#define  SRNN_wdsr_layer4_3x3_weights_4_6_01_reg_addr                            "0xB81AC438"
#define  SRNN_wdsr_layer4_3x3_weights_4_6_01_reg                                 0xB81AC438
#define  SRNN_wdsr_layer4_3x3_weights_4_6_01_inst_addr                           "0x0532"
#define  set_SRNN_wdsr_layer4_3x3_weights_4_6_01_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_6_01_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_4_6_01_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_6_01_reg))
#define  SRNN_wdsr_layer4_3x3_weights_4_6_01_layer4_weight_01_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_4_6_01_layer4_weight_01_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_4_6_01_layer4_weight_01(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_4_6_01_get_layer4_weight_01(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_4_6_02                                    0x181AC43C
#define  SRNN_wdsr_layer4_3x3_weights_4_6_02_reg_addr                            "0xB81AC43C"
#define  SRNN_wdsr_layer4_3x3_weights_4_6_02_reg                                 0xB81AC43C
#define  SRNN_wdsr_layer4_3x3_weights_4_6_02_inst_addr                           "0x0533"
#define  set_SRNN_wdsr_layer4_3x3_weights_4_6_02_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_6_02_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_4_6_02_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_6_02_reg))
#define  SRNN_wdsr_layer4_3x3_weights_4_6_02_layer4_weight_02_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_4_6_02_layer4_weight_02_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_4_6_02_layer4_weight_02(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_4_6_02_get_layer4_weight_02(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_4_6_10                                    0x181AC440
#define  SRNN_wdsr_layer4_3x3_weights_4_6_10_reg_addr                            "0xB81AC440"
#define  SRNN_wdsr_layer4_3x3_weights_4_6_10_reg                                 0xB81AC440
#define  SRNN_wdsr_layer4_3x3_weights_4_6_10_inst_addr                           "0x0534"
#define  set_SRNN_wdsr_layer4_3x3_weights_4_6_10_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_6_10_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_4_6_10_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_6_10_reg))
#define  SRNN_wdsr_layer4_3x3_weights_4_6_10_layer4_weight_10_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_4_6_10_layer4_weight_10_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_4_6_10_layer4_weight_10(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_4_6_10_get_layer4_weight_10(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_4_6_11                                    0x181AC444
#define  SRNN_wdsr_layer4_3x3_weights_4_6_11_reg_addr                            "0xB81AC444"
#define  SRNN_wdsr_layer4_3x3_weights_4_6_11_reg                                 0xB81AC444
#define  SRNN_wdsr_layer4_3x3_weights_4_6_11_inst_addr                           "0x0535"
#define  set_SRNN_wdsr_layer4_3x3_weights_4_6_11_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_6_11_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_4_6_11_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_6_11_reg))
#define  SRNN_wdsr_layer4_3x3_weights_4_6_11_layer4_weight_11_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_4_6_11_layer4_weight_11_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_4_6_11_layer4_weight_11(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_4_6_11_get_layer4_weight_11(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_4_6_12                                    0x181AC448
#define  SRNN_wdsr_layer4_3x3_weights_4_6_12_reg_addr                            "0xB81AC448"
#define  SRNN_wdsr_layer4_3x3_weights_4_6_12_reg                                 0xB81AC448
#define  SRNN_wdsr_layer4_3x3_weights_4_6_12_inst_addr                           "0x0536"
#define  set_SRNN_wdsr_layer4_3x3_weights_4_6_12_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_6_12_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_4_6_12_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_6_12_reg))
#define  SRNN_wdsr_layer4_3x3_weights_4_6_12_layer4_weight_12_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_4_6_12_layer4_weight_12_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_4_6_12_layer4_weight_12(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_4_6_12_get_layer4_weight_12(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_4_6_20                                    0x181AC44C
#define  SRNN_wdsr_layer4_3x3_weights_4_6_20_reg_addr                            "0xB81AC44C"
#define  SRNN_wdsr_layer4_3x3_weights_4_6_20_reg                                 0xB81AC44C
#define  SRNN_wdsr_layer4_3x3_weights_4_6_20_inst_addr                           "0x0537"
#define  set_SRNN_wdsr_layer4_3x3_weights_4_6_20_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_6_20_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_4_6_20_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_6_20_reg))
#define  SRNN_wdsr_layer4_3x3_weights_4_6_20_layer4_weight_20_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_4_6_20_layer4_weight_20_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_4_6_20_layer4_weight_20(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_4_6_20_get_layer4_weight_20(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_4_6_21                                    0x181AC450
#define  SRNN_wdsr_layer4_3x3_weights_4_6_21_reg_addr                            "0xB81AC450"
#define  SRNN_wdsr_layer4_3x3_weights_4_6_21_reg                                 0xB81AC450
#define  SRNN_wdsr_layer4_3x3_weights_4_6_21_inst_addr                           "0x0538"
#define  set_SRNN_wdsr_layer4_3x3_weights_4_6_21_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_6_21_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_4_6_21_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_6_21_reg))
#define  SRNN_wdsr_layer4_3x3_weights_4_6_21_layer4_weight_21_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_4_6_21_layer4_weight_21_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_4_6_21_layer4_weight_21(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_4_6_21_get_layer4_weight_21(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_4_6_22                                    0x181AC454
#define  SRNN_wdsr_layer4_3x3_weights_4_6_22_reg_addr                            "0xB81AC454"
#define  SRNN_wdsr_layer4_3x3_weights_4_6_22_reg                                 0xB81AC454
#define  SRNN_wdsr_layer4_3x3_weights_4_6_22_inst_addr                           "0x0539"
#define  set_SRNN_wdsr_layer4_3x3_weights_4_6_22_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_6_22_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_4_6_22_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_6_22_reg))
#define  SRNN_wdsr_layer4_3x3_weights_4_6_22_layer4_weight_22_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_4_6_22_layer4_weight_22_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_4_6_22_layer4_weight_22(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_4_6_22_get_layer4_weight_22(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_4_7_00                                    0x181AC458
#define  SRNN_wdsr_layer4_3x3_weights_4_7_00_reg_addr                            "0xB81AC458"
#define  SRNN_wdsr_layer4_3x3_weights_4_7_00_reg                                 0xB81AC458
#define  SRNN_wdsr_layer4_3x3_weights_4_7_00_inst_addr                           "0x053A"
#define  set_SRNN_wdsr_layer4_3x3_weights_4_7_00_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_7_00_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_4_7_00_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_7_00_reg))
#define  SRNN_wdsr_layer4_3x3_weights_4_7_00_layer4_weight_00_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_4_7_00_layer4_weight_00_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_4_7_00_layer4_weight_00(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_4_7_00_get_layer4_weight_00(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_4_7_01                                    0x181AC45C
#define  SRNN_wdsr_layer4_3x3_weights_4_7_01_reg_addr                            "0xB81AC45C"
#define  SRNN_wdsr_layer4_3x3_weights_4_7_01_reg                                 0xB81AC45C
#define  SRNN_wdsr_layer4_3x3_weights_4_7_01_inst_addr                           "0x053B"
#define  set_SRNN_wdsr_layer4_3x3_weights_4_7_01_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_7_01_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_4_7_01_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_7_01_reg))
#define  SRNN_wdsr_layer4_3x3_weights_4_7_01_layer4_weight_01_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_4_7_01_layer4_weight_01_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_4_7_01_layer4_weight_01(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_4_7_01_get_layer4_weight_01(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_4_7_02                                    0x181AC460
#define  SRNN_wdsr_layer4_3x3_weights_4_7_02_reg_addr                            "0xB81AC460"
#define  SRNN_wdsr_layer4_3x3_weights_4_7_02_reg                                 0xB81AC460
#define  SRNN_wdsr_layer4_3x3_weights_4_7_02_inst_addr                           "0x053C"
#define  set_SRNN_wdsr_layer4_3x3_weights_4_7_02_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_7_02_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_4_7_02_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_7_02_reg))
#define  SRNN_wdsr_layer4_3x3_weights_4_7_02_layer4_weight_02_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_4_7_02_layer4_weight_02_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_4_7_02_layer4_weight_02(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_4_7_02_get_layer4_weight_02(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_4_7_10                                    0x181AC464
#define  SRNN_wdsr_layer4_3x3_weights_4_7_10_reg_addr                            "0xB81AC464"
#define  SRNN_wdsr_layer4_3x3_weights_4_7_10_reg                                 0xB81AC464
#define  SRNN_wdsr_layer4_3x3_weights_4_7_10_inst_addr                           "0x053D"
#define  set_SRNN_wdsr_layer4_3x3_weights_4_7_10_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_7_10_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_4_7_10_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_7_10_reg))
#define  SRNN_wdsr_layer4_3x3_weights_4_7_10_layer4_weight_10_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_4_7_10_layer4_weight_10_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_4_7_10_layer4_weight_10(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_4_7_10_get_layer4_weight_10(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_4_7_11                                    0x181AC468
#define  SRNN_wdsr_layer4_3x3_weights_4_7_11_reg_addr                            "0xB81AC468"
#define  SRNN_wdsr_layer4_3x3_weights_4_7_11_reg                                 0xB81AC468
#define  SRNN_wdsr_layer4_3x3_weights_4_7_11_inst_addr                           "0x053E"
#define  set_SRNN_wdsr_layer4_3x3_weights_4_7_11_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_7_11_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_4_7_11_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_7_11_reg))
#define  SRNN_wdsr_layer4_3x3_weights_4_7_11_layer4_weight_11_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_4_7_11_layer4_weight_11_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_4_7_11_layer4_weight_11(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_4_7_11_get_layer4_weight_11(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_4_7_12                                    0x181AC46C
#define  SRNN_wdsr_layer4_3x3_weights_4_7_12_reg_addr                            "0xB81AC46C"
#define  SRNN_wdsr_layer4_3x3_weights_4_7_12_reg                                 0xB81AC46C
#define  SRNN_wdsr_layer4_3x3_weights_4_7_12_inst_addr                           "0x053F"
#define  set_SRNN_wdsr_layer4_3x3_weights_4_7_12_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_7_12_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_4_7_12_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_7_12_reg))
#define  SRNN_wdsr_layer4_3x3_weights_4_7_12_layer4_weight_12_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_4_7_12_layer4_weight_12_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_4_7_12_layer4_weight_12(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_4_7_12_get_layer4_weight_12(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_4_7_20                                    0x181AC470
#define  SRNN_wdsr_layer4_3x3_weights_4_7_20_reg_addr                            "0xB81AC470"
#define  SRNN_wdsr_layer4_3x3_weights_4_7_20_reg                                 0xB81AC470
#define  SRNN_wdsr_layer4_3x3_weights_4_7_20_inst_addr                           "0x0540"
#define  set_SRNN_wdsr_layer4_3x3_weights_4_7_20_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_7_20_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_4_7_20_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_7_20_reg))
#define  SRNN_wdsr_layer4_3x3_weights_4_7_20_layer4_weight_20_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_4_7_20_layer4_weight_20_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_4_7_20_layer4_weight_20(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_4_7_20_get_layer4_weight_20(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_4_7_21                                    0x181AC474
#define  SRNN_wdsr_layer4_3x3_weights_4_7_21_reg_addr                            "0xB81AC474"
#define  SRNN_wdsr_layer4_3x3_weights_4_7_21_reg                                 0xB81AC474
#define  SRNN_wdsr_layer4_3x3_weights_4_7_21_inst_addr                           "0x0541"
#define  set_SRNN_wdsr_layer4_3x3_weights_4_7_21_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_7_21_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_4_7_21_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_7_21_reg))
#define  SRNN_wdsr_layer4_3x3_weights_4_7_21_layer4_weight_21_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_4_7_21_layer4_weight_21_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_4_7_21_layer4_weight_21(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_4_7_21_get_layer4_weight_21(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_4_7_22                                    0x181AC478
#define  SRNN_wdsr_layer4_3x3_weights_4_7_22_reg_addr                            "0xB81AC478"
#define  SRNN_wdsr_layer4_3x3_weights_4_7_22_reg                                 0xB81AC478
#define  SRNN_wdsr_layer4_3x3_weights_4_7_22_inst_addr                           "0x0542"
#define  set_SRNN_wdsr_layer4_3x3_weights_4_7_22_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_7_22_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_4_7_22_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_7_22_reg))
#define  SRNN_wdsr_layer4_3x3_weights_4_7_22_layer4_weight_22_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_4_7_22_layer4_weight_22_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_4_7_22_layer4_weight_22(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_4_7_22_get_layer4_weight_22(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_4_8_00                                    0x181AC47C
#define  SRNN_wdsr_layer4_3x3_weights_4_8_00_reg_addr                            "0xB81AC47C"
#define  SRNN_wdsr_layer4_3x3_weights_4_8_00_reg                                 0xB81AC47C
#define  SRNN_wdsr_layer4_3x3_weights_4_8_00_inst_addr                           "0x0543"
#define  set_SRNN_wdsr_layer4_3x3_weights_4_8_00_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_8_00_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_4_8_00_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_8_00_reg))
#define  SRNN_wdsr_layer4_3x3_weights_4_8_00_layer4_weight_00_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_4_8_00_layer4_weight_00_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_4_8_00_layer4_weight_00(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_4_8_00_get_layer4_weight_00(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_4_8_01                                    0x181AC480
#define  SRNN_wdsr_layer4_3x3_weights_4_8_01_reg_addr                            "0xB81AC480"
#define  SRNN_wdsr_layer4_3x3_weights_4_8_01_reg                                 0xB81AC480
#define  SRNN_wdsr_layer4_3x3_weights_4_8_01_inst_addr                           "0x0544"
#define  set_SRNN_wdsr_layer4_3x3_weights_4_8_01_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_8_01_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_4_8_01_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_8_01_reg))
#define  SRNN_wdsr_layer4_3x3_weights_4_8_01_layer4_weight_01_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_4_8_01_layer4_weight_01_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_4_8_01_layer4_weight_01(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_4_8_01_get_layer4_weight_01(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_4_8_02                                    0x181AC484
#define  SRNN_wdsr_layer4_3x3_weights_4_8_02_reg_addr                            "0xB81AC484"
#define  SRNN_wdsr_layer4_3x3_weights_4_8_02_reg                                 0xB81AC484
#define  SRNN_wdsr_layer4_3x3_weights_4_8_02_inst_addr                           "0x0545"
#define  set_SRNN_wdsr_layer4_3x3_weights_4_8_02_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_8_02_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_4_8_02_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_8_02_reg))
#define  SRNN_wdsr_layer4_3x3_weights_4_8_02_layer4_weight_02_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_4_8_02_layer4_weight_02_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_4_8_02_layer4_weight_02(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_4_8_02_get_layer4_weight_02(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_4_8_10                                    0x181AC488
#define  SRNN_wdsr_layer4_3x3_weights_4_8_10_reg_addr                            "0xB81AC488"
#define  SRNN_wdsr_layer4_3x3_weights_4_8_10_reg                                 0xB81AC488
#define  SRNN_wdsr_layer4_3x3_weights_4_8_10_inst_addr                           "0x0546"
#define  set_SRNN_wdsr_layer4_3x3_weights_4_8_10_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_8_10_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_4_8_10_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_8_10_reg))
#define  SRNN_wdsr_layer4_3x3_weights_4_8_10_layer4_weight_10_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_4_8_10_layer4_weight_10_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_4_8_10_layer4_weight_10(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_4_8_10_get_layer4_weight_10(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_4_8_11                                    0x181AC48C
#define  SRNN_wdsr_layer4_3x3_weights_4_8_11_reg_addr                            "0xB81AC48C"
#define  SRNN_wdsr_layer4_3x3_weights_4_8_11_reg                                 0xB81AC48C
#define  SRNN_wdsr_layer4_3x3_weights_4_8_11_inst_addr                           "0x0547"
#define  set_SRNN_wdsr_layer4_3x3_weights_4_8_11_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_8_11_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_4_8_11_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_8_11_reg))
#define  SRNN_wdsr_layer4_3x3_weights_4_8_11_layer4_weight_11_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_4_8_11_layer4_weight_11_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_4_8_11_layer4_weight_11(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_4_8_11_get_layer4_weight_11(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_4_8_12                                    0x181AC490
#define  SRNN_wdsr_layer4_3x3_weights_4_8_12_reg_addr                            "0xB81AC490"
#define  SRNN_wdsr_layer4_3x3_weights_4_8_12_reg                                 0xB81AC490
#define  SRNN_wdsr_layer4_3x3_weights_4_8_12_inst_addr                           "0x0548"
#define  set_SRNN_wdsr_layer4_3x3_weights_4_8_12_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_8_12_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_4_8_12_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_8_12_reg))
#define  SRNN_wdsr_layer4_3x3_weights_4_8_12_layer4_weight_12_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_4_8_12_layer4_weight_12_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_4_8_12_layer4_weight_12(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_4_8_12_get_layer4_weight_12(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_4_8_20                                    0x181AC494
#define  SRNN_wdsr_layer4_3x3_weights_4_8_20_reg_addr                            "0xB81AC494"
#define  SRNN_wdsr_layer4_3x3_weights_4_8_20_reg                                 0xB81AC494
#define  SRNN_wdsr_layer4_3x3_weights_4_8_20_inst_addr                           "0x0549"
#define  set_SRNN_wdsr_layer4_3x3_weights_4_8_20_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_8_20_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_4_8_20_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_8_20_reg))
#define  SRNN_wdsr_layer4_3x3_weights_4_8_20_layer4_weight_20_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_4_8_20_layer4_weight_20_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_4_8_20_layer4_weight_20(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_4_8_20_get_layer4_weight_20(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_4_8_21                                    0x181AC498
#define  SRNN_wdsr_layer4_3x3_weights_4_8_21_reg_addr                            "0xB81AC498"
#define  SRNN_wdsr_layer4_3x3_weights_4_8_21_reg                                 0xB81AC498
#define  SRNN_wdsr_layer4_3x3_weights_4_8_21_inst_addr                           "0x054A"
#define  set_SRNN_wdsr_layer4_3x3_weights_4_8_21_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_8_21_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_4_8_21_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_8_21_reg))
#define  SRNN_wdsr_layer4_3x3_weights_4_8_21_layer4_weight_21_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_4_8_21_layer4_weight_21_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_4_8_21_layer4_weight_21(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_4_8_21_get_layer4_weight_21(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_weights_4_8_22                                    0x181AC49C
#define  SRNN_wdsr_layer4_3x3_weights_4_8_22_reg_addr                            "0xB81AC49C"
#define  SRNN_wdsr_layer4_3x3_weights_4_8_22_reg                                 0xB81AC49C
#define  SRNN_wdsr_layer4_3x3_weights_4_8_22_inst_addr                           "0x054B"
#define  set_SRNN_wdsr_layer4_3x3_weights_4_8_22_reg(data)                       (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_8_22_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_weights_4_8_22_reg                             (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_weights_4_8_22_reg))
#define  SRNN_wdsr_layer4_3x3_weights_4_8_22_layer4_weight_22_shift              (0)
#define  SRNN_wdsr_layer4_3x3_weights_4_8_22_layer4_weight_22_mask               (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_weights_4_8_22_layer4_weight_22(data)              (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_weights_4_8_22_get_layer4_weight_22(data)          (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_bias_1                                            0x181AC4A0
#define  SRNN_wdsr_layer4_3x3_bias_1_reg_addr                                    "0xB81AC4A0"
#define  SRNN_wdsr_layer4_3x3_bias_1_reg                                         0xB81AC4A0
#define  SRNN_wdsr_layer4_3x3_bias_1_inst_addr                                   "0x054C"
#define  set_SRNN_wdsr_layer4_3x3_bias_1_reg(data)                               (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_bias_1_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_bias_1_reg                                     (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_bias_1_reg))
#define  SRNN_wdsr_layer4_3x3_bias_1_layer4_bias_1_shift                         (0)
#define  SRNN_wdsr_layer4_3x3_bias_1_layer4_bias_1_mask                          (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_bias_1_layer4_bias_1(data)                         (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_bias_1_get_layer4_bias_1(data)                     (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_bias_2                                            0x181AC4A4
#define  SRNN_wdsr_layer4_3x3_bias_2_reg_addr                                    "0xB81AC4A4"
#define  SRNN_wdsr_layer4_3x3_bias_2_reg                                         0xB81AC4A4
#define  SRNN_wdsr_layer4_3x3_bias_2_inst_addr                                   "0x054D"
#define  set_SRNN_wdsr_layer4_3x3_bias_2_reg(data)                               (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_bias_2_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_bias_2_reg                                     (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_bias_2_reg))
#define  SRNN_wdsr_layer4_3x3_bias_2_layer4_bias_2_shift                         (0)
#define  SRNN_wdsr_layer4_3x3_bias_2_layer4_bias_2_mask                          (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_bias_2_layer4_bias_2(data)                         (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_bias_2_get_layer4_bias_2(data)                     (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_bias_3                                            0x181AC4A8
#define  SRNN_wdsr_layer4_3x3_bias_3_reg_addr                                    "0xB81AC4A8"
#define  SRNN_wdsr_layer4_3x3_bias_3_reg                                         0xB81AC4A8
#define  SRNN_wdsr_layer4_3x3_bias_3_inst_addr                                   "0x054E"
#define  set_SRNN_wdsr_layer4_3x3_bias_3_reg(data)                               (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_bias_3_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_bias_3_reg                                     (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_bias_3_reg))
#define  SRNN_wdsr_layer4_3x3_bias_3_layer4_bias_3_shift                         (0)
#define  SRNN_wdsr_layer4_3x3_bias_3_layer4_bias_3_mask                          (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_bias_3_layer4_bias_3(data)                         (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_bias_3_get_layer4_bias_3(data)                     (0x00001FFF&(data))

#define  SRNN_wdsr_layer4_3x3_bias_4                                            0x181AC4AC
#define  SRNN_wdsr_layer4_3x3_bias_4_reg_addr                                    "0xB81AC4AC"
#define  SRNN_wdsr_layer4_3x3_bias_4_reg                                         0xB81AC4AC
#define  SRNN_wdsr_layer4_3x3_bias_4_inst_addr                                   "0x054F"
#define  set_SRNN_wdsr_layer4_3x3_bias_4_reg(data)                               (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_bias_4_reg)=data)
#define  get_SRNN_wdsr_layer4_3x3_bias_4_reg                                     (*((volatile unsigned int*)SRNN_wdsr_layer4_3x3_bias_4_reg))
#define  SRNN_wdsr_layer4_3x3_bias_4_layer4_bias_4_shift                         (0)
#define  SRNN_wdsr_layer4_3x3_bias_4_layer4_bias_4_mask                          (0x00001FFF)
#define  SRNN_wdsr_layer4_3x3_bias_4_layer4_bias_4(data)                         (0x00001FFF&(data))
#define  SRNN_wdsr_layer4_3x3_bias_4_get_layer4_bias_4(data)                     (0x00001FFF&(data))

#define  SRNN_SSRS_RM                                                           0x181AA060
#define  SRNN_SSRS_RM_reg_addr                                                   "0xB81AA060"
#define  SRNN_SSRS_RM_reg                                                        0xB81AA060
#define  SRNN_SSRS_RM_inst_addr                                                  "0x0550"
#define  set_SRNN_SSRS_RM_reg(data)                                              (*((volatile unsigned int*)SRNN_SSRS_RM_reg)=data)
#define  get_SRNN_SSRS_RM_reg                                                    (*((volatile unsigned int*)SRNN_SSRS_RM_reg))
#define  SRNN_SSRS_RM_ssrs_rm_4_0_shift                                          (28)
#define  SRNN_SSRS_RM_ssrs_rm_3_0_shift                                          (24)
#define  SRNN_SSRS_RM_ssrs_rm_2_1_shift                                          (20)
#define  SRNN_SSRS_RM_ssrs_rm_2_0_shift                                          (16)
#define  SRNN_SSRS_RM_ssrs_rm_1_2_shift                                          (12)
#define  SRNN_SSRS_RM_ssrs_rm_1_1_shift                                          (8)
#define  SRNN_SSRS_RM_ssrs_rm_1_0_shift                                          (4)
#define  SRNN_SSRS_RM_ssrs_rm_0_0_shift                                          (0)
#define  SRNN_SSRS_RM_ssrs_rm_4_0_mask                                           (0xF0000000)
#define  SRNN_SSRS_RM_ssrs_rm_3_0_mask                                           (0x0F000000)
#define  SRNN_SSRS_RM_ssrs_rm_2_1_mask                                           (0x00F00000)
#define  SRNN_SSRS_RM_ssrs_rm_2_0_mask                                           (0x000F0000)
#define  SRNN_SSRS_RM_ssrs_rm_1_2_mask                                           (0x0000F000)
#define  SRNN_SSRS_RM_ssrs_rm_1_1_mask                                           (0x00000F00)
#define  SRNN_SSRS_RM_ssrs_rm_1_0_mask                                           (0x000000F0)
#define  SRNN_SSRS_RM_ssrs_rm_0_0_mask                                           (0x0000000F)
#define  SRNN_SSRS_RM_ssrs_rm_4_0(data)                                          (0xF0000000&((data)<<28))
#define  SRNN_SSRS_RM_ssrs_rm_3_0(data)                                          (0x0F000000&((data)<<24))
#define  SRNN_SSRS_RM_ssrs_rm_2_1(data)                                          (0x00F00000&((data)<<20))
#define  SRNN_SSRS_RM_ssrs_rm_2_0(data)                                          (0x000F0000&((data)<<16))
#define  SRNN_SSRS_RM_ssrs_rm_1_2(data)                                          (0x0000F000&((data)<<12))
#define  SRNN_SSRS_RM_ssrs_rm_1_1(data)                                          (0x00000F00&((data)<<8))
#define  SRNN_SSRS_RM_ssrs_rm_1_0(data)                                          (0x000000F0&((data)<<4))
#define  SRNN_SSRS_RM_ssrs_rm_0_0(data)                                          (0x0000000F&(data))
#define  SRNN_SSRS_RM_get_ssrs_rm_4_0(data)                                      ((0xF0000000&(data))>>28)
#define  SRNN_SSRS_RM_get_ssrs_rm_3_0(data)                                      ((0x0F000000&(data))>>24)
#define  SRNN_SSRS_RM_get_ssrs_rm_2_1(data)                                      ((0x00F00000&(data))>>20)
#define  SRNN_SSRS_RM_get_ssrs_rm_2_0(data)                                      ((0x000F0000&(data))>>16)
#define  SRNN_SSRS_RM_get_ssrs_rm_1_2(data)                                      ((0x0000F000&(data))>>12)
#define  SRNN_SSRS_RM_get_ssrs_rm_1_1(data)                                      ((0x00000F00&(data))>>8)
#define  SRNN_SSRS_RM_get_ssrs_rm_1_0(data)                                      ((0x000000F0&(data))>>4)
#define  SRNN_SSRS_RM_get_ssrs_rm_0_0(data)                                      (0x0000000F&(data))

#define  SRNN_SSRS_RME_LS                                                       0x181AA064
#define  SRNN_SSRS_RME_LS_reg_addr                                               "0xB81AA064"
#define  SRNN_SSRS_RME_LS_reg                                                    0xB81AA064
#define  SRNN_SSRS_RME_LS_inst_addr                                              "0x0551"
#define  set_SRNN_SSRS_RME_LS_reg(data)                                          (*((volatile unsigned int*)SRNN_SSRS_RME_LS_reg)=data)
#define  get_SRNN_SSRS_RME_LS_reg                                                (*((volatile unsigned int*)SRNN_SSRS_RME_LS_reg))
#define  SRNN_SSRS_RME_LS_ssrs_ls_4_0_shift                                      (23)
#define  SRNN_SSRS_RME_LS_ssrs_ls_3_0_shift                                      (22)
#define  SRNN_SSRS_RME_LS_ssrs_ls_2_1_shift                                      (21)
#define  SRNN_SSRS_RME_LS_ssrs_ls_2_0_shift                                      (20)
#define  SRNN_SSRS_RME_LS_ssrs_ls_1_2_shift                                      (19)
#define  SRNN_SSRS_RME_LS_ssrs_ls_1_1_shift                                      (18)
#define  SRNN_SSRS_RME_LS_ssrs_ls_1_0_shift                                      (17)
#define  SRNN_SSRS_RME_LS_ssrs_ls_0_0_shift                                      (16)
#define  SRNN_SSRS_RME_LS_ssrs_rme_4_0_shift                                     (7)
#define  SRNN_SSRS_RME_LS_ssrs_rme_3_0_shift                                     (6)
#define  SRNN_SSRS_RME_LS_ssrs_rme_2_1_shift                                     (5)
#define  SRNN_SSRS_RME_LS_ssrs_rme_2_0_shift                                     (4)
#define  SRNN_SSRS_RME_LS_ssrs_rme_1_2_shift                                     (3)
#define  SRNN_SSRS_RME_LS_ssrs_rme_1_1_shift                                     (2)
#define  SRNN_SSRS_RME_LS_ssrs_rme_1_0_shift                                     (1)
#define  SRNN_SSRS_RME_LS_ssrs_rme_0_0_shift                                     (0)
#define  SRNN_SSRS_RME_LS_ssrs_ls_4_0_mask                                       (0x00800000)
#define  SRNN_SSRS_RME_LS_ssrs_ls_3_0_mask                                       (0x00400000)
#define  SRNN_SSRS_RME_LS_ssrs_ls_2_1_mask                                       (0x00200000)
#define  SRNN_SSRS_RME_LS_ssrs_ls_2_0_mask                                       (0x00100000)
#define  SRNN_SSRS_RME_LS_ssrs_ls_1_2_mask                                       (0x00080000)
#define  SRNN_SSRS_RME_LS_ssrs_ls_1_1_mask                                       (0x00040000)
#define  SRNN_SSRS_RME_LS_ssrs_ls_1_0_mask                                       (0x00020000)
#define  SRNN_SSRS_RME_LS_ssrs_ls_0_0_mask                                       (0x00010000)
#define  SRNN_SSRS_RME_LS_ssrs_rme_4_0_mask                                      (0x00000080)
#define  SRNN_SSRS_RME_LS_ssrs_rme_3_0_mask                                      (0x00000040)
#define  SRNN_SSRS_RME_LS_ssrs_rme_2_1_mask                                      (0x00000020)
#define  SRNN_SSRS_RME_LS_ssrs_rme_2_0_mask                                      (0x00000010)
#define  SRNN_SSRS_RME_LS_ssrs_rme_1_2_mask                                      (0x00000008)
#define  SRNN_SSRS_RME_LS_ssrs_rme_1_1_mask                                      (0x00000004)
#define  SRNN_SSRS_RME_LS_ssrs_rme_1_0_mask                                      (0x00000002)
#define  SRNN_SSRS_RME_LS_ssrs_rme_0_0_mask                                      (0x00000001)
#define  SRNN_SSRS_RME_LS_ssrs_ls_4_0(data)                                      (0x00800000&((data)<<23))
#define  SRNN_SSRS_RME_LS_ssrs_ls_3_0(data)                                      (0x00400000&((data)<<22))
#define  SRNN_SSRS_RME_LS_ssrs_ls_2_1(data)                                      (0x00200000&((data)<<21))
#define  SRNN_SSRS_RME_LS_ssrs_ls_2_0(data)                                      (0x00100000&((data)<<20))
#define  SRNN_SSRS_RME_LS_ssrs_ls_1_2(data)                                      (0x00080000&((data)<<19))
#define  SRNN_SSRS_RME_LS_ssrs_ls_1_1(data)                                      (0x00040000&((data)<<18))
#define  SRNN_SSRS_RME_LS_ssrs_ls_1_0(data)                                      (0x00020000&((data)<<17))
#define  SRNN_SSRS_RME_LS_ssrs_ls_0_0(data)                                      (0x00010000&((data)<<16))
#define  SRNN_SSRS_RME_LS_ssrs_rme_4_0(data)                                     (0x00000080&((data)<<7))
#define  SRNN_SSRS_RME_LS_ssrs_rme_3_0(data)                                     (0x00000040&((data)<<6))
#define  SRNN_SSRS_RME_LS_ssrs_rme_2_1(data)                                     (0x00000020&((data)<<5))
#define  SRNN_SSRS_RME_LS_ssrs_rme_2_0(data)                                     (0x00000010&((data)<<4))
#define  SRNN_SSRS_RME_LS_ssrs_rme_1_2(data)                                     (0x00000008&((data)<<3))
#define  SRNN_SSRS_RME_LS_ssrs_rme_1_1(data)                                     (0x00000004&((data)<<2))
#define  SRNN_SSRS_RME_LS_ssrs_rme_1_0(data)                                     (0x00000002&((data)<<1))
#define  SRNN_SSRS_RME_LS_ssrs_rme_0_0(data)                                     (0x00000001&(data))
#define  SRNN_SSRS_RME_LS_get_ssrs_ls_4_0(data)                                  ((0x00800000&(data))>>23)
#define  SRNN_SSRS_RME_LS_get_ssrs_ls_3_0(data)                                  ((0x00400000&(data))>>22)
#define  SRNN_SSRS_RME_LS_get_ssrs_ls_2_1(data)                                  ((0x00200000&(data))>>21)
#define  SRNN_SSRS_RME_LS_get_ssrs_ls_2_0(data)                                  ((0x00100000&(data))>>20)
#define  SRNN_SSRS_RME_LS_get_ssrs_ls_1_2(data)                                  ((0x00080000&(data))>>19)
#define  SRNN_SSRS_RME_LS_get_ssrs_ls_1_1(data)                                  ((0x00040000&(data))>>18)
#define  SRNN_SSRS_RME_LS_get_ssrs_ls_1_0(data)                                  ((0x00020000&(data))>>17)
#define  SRNN_SSRS_RME_LS_get_ssrs_ls_0_0(data)                                  ((0x00010000&(data))>>16)
#define  SRNN_SSRS_RME_LS_get_ssrs_rme_4_0(data)                                 ((0x00000080&(data))>>7)
#define  SRNN_SSRS_RME_LS_get_ssrs_rme_3_0(data)                                 ((0x00000040&(data))>>6)
#define  SRNN_SSRS_RME_LS_get_ssrs_rme_2_1(data)                                 ((0x00000020&(data))>>5)
#define  SRNN_SSRS_RME_LS_get_ssrs_rme_2_0(data)                                 ((0x00000010&(data))>>4)
#define  SRNN_SSRS_RME_LS_get_ssrs_rme_1_2(data)                                 ((0x00000008&(data))>>3)
#define  SRNN_SSRS_RME_LS_get_ssrs_rme_1_1(data)                                 ((0x00000004&(data))>>2)
#define  SRNN_SSRS_RME_LS_get_ssrs_rme_1_0(data)                                 ((0x00000002&(data))>>1)
#define  SRNN_SSRS_RME_LS_get_ssrs_rme_0_0(data)                                 (0x00000001&(data))

#define  SRNN_SSRS_TEST1                                                        0x181AA068
#define  SRNN_SSRS_TEST1_reg_addr                                                "0xB81AA068"
#define  SRNN_SSRS_TEST1_reg                                                     0xB81AA068
#define  SRNN_SSRS_TEST1_inst_addr                                               "0x0552"
#define  set_SRNN_SSRS_TEST1_reg(data)                                           (*((volatile unsigned int*)SRNN_SSRS_TEST1_reg)=data)
#define  get_SRNN_SSRS_TEST1_reg                                                 (*((volatile unsigned int*)SRNN_SSRS_TEST1_reg))
#define  SRNN_SSRS_TEST1_ssrs_test1_4_0_shift                                    (7)
#define  SRNN_SSRS_TEST1_ssrs_test1_3_0_shift                                    (6)
#define  SRNN_SSRS_TEST1_ssrs_test1_2_1_shift                                    (5)
#define  SRNN_SSRS_TEST1_ssrs_test1_2_0_shift                                    (4)
#define  SRNN_SSRS_TEST1_ssrs_test1_1_2_shift                                    (3)
#define  SRNN_SSRS_TEST1_ssrs_test1_1_1_shift                                    (2)
#define  SRNN_SSRS_TEST1_ssrs_test1_1_0_shift                                    (1)
#define  SRNN_SSRS_TEST1_ssrs_test1_0_0_shift                                    (0)
#define  SRNN_SSRS_TEST1_ssrs_test1_4_0_mask                                     (0x00000080)
#define  SRNN_SSRS_TEST1_ssrs_test1_3_0_mask                                     (0x00000040)
#define  SRNN_SSRS_TEST1_ssrs_test1_2_1_mask                                     (0x00000020)
#define  SRNN_SSRS_TEST1_ssrs_test1_2_0_mask                                     (0x00000010)
#define  SRNN_SSRS_TEST1_ssrs_test1_1_2_mask                                     (0x00000008)
#define  SRNN_SSRS_TEST1_ssrs_test1_1_1_mask                                     (0x00000004)
#define  SRNN_SSRS_TEST1_ssrs_test1_1_0_mask                                     (0x00000002)
#define  SRNN_SSRS_TEST1_ssrs_test1_0_0_mask                                     (0x00000001)
#define  SRNN_SSRS_TEST1_ssrs_test1_4_0(data)                                    (0x00000080&((data)<<7))
#define  SRNN_SSRS_TEST1_ssrs_test1_3_0(data)                                    (0x00000040&((data)<<6))
#define  SRNN_SSRS_TEST1_ssrs_test1_2_1(data)                                    (0x00000020&((data)<<5))
#define  SRNN_SSRS_TEST1_ssrs_test1_2_0(data)                                    (0x00000010&((data)<<4))
#define  SRNN_SSRS_TEST1_ssrs_test1_1_2(data)                                    (0x00000008&((data)<<3))
#define  SRNN_SSRS_TEST1_ssrs_test1_1_1(data)                                    (0x00000004&((data)<<2))
#define  SRNN_SSRS_TEST1_ssrs_test1_1_0(data)                                    (0x00000002&((data)<<1))
#define  SRNN_SSRS_TEST1_ssrs_test1_0_0(data)                                    (0x00000001&(data))
#define  SRNN_SSRS_TEST1_get_ssrs_test1_4_0(data)                                ((0x00000080&(data))>>7)
#define  SRNN_SSRS_TEST1_get_ssrs_test1_3_0(data)                                ((0x00000040&(data))>>6)
#define  SRNN_SSRS_TEST1_get_ssrs_test1_2_1(data)                                ((0x00000020&(data))>>5)
#define  SRNN_SSRS_TEST1_get_ssrs_test1_2_0(data)                                ((0x00000010&(data))>>4)
#define  SRNN_SSRS_TEST1_get_ssrs_test1_1_2(data)                                ((0x00000008&(data))>>3)
#define  SRNN_SSRS_TEST1_get_ssrs_test1_1_1(data)                                ((0x00000004&(data))>>2)
#define  SRNN_SSRS_TEST1_get_ssrs_test1_1_0(data)                                ((0x00000002&(data))>>1)
#define  SRNN_SSRS_TEST1_get_ssrs_test1_0_0(data)                                (0x00000001&(data))

#define  SRNN_SSRS_Bist_0                                                       0x181AA06C
#define  SRNN_SSRS_Bist_0_reg_addr                                               "0xB81AA06C"
#define  SRNN_SSRS_Bist_0_reg                                                    0xB81AA06C
#define  SRNN_SSRS_Bist_0_inst_addr                                              "0x0553"
#define  set_SRNN_SSRS_Bist_0_reg(data)                                          (*((volatile unsigned int*)SRNN_SSRS_Bist_0_reg)=data)
#define  get_SRNN_SSRS_Bist_0_reg                                                (*((volatile unsigned int*)SRNN_SSRS_Bist_0_reg))
#define  SRNN_SSRS_Bist_0_ssrs_0_0_0_drf_bist_fail_shift                         (27)
#define  SRNN_SSRS_Bist_0_ssrs_0_0_1_drf_bist_fail_shift                         (26)
#define  SRNN_SSRS_Bist_0_ssrs_0_0_2_drf_bist_fail_shift                         (25)
#define  SRNN_SSRS_Bist_0_ssrs_0_0_3_drf_bist_fail_shift                         (24)
#define  SRNN_SSRS_Bist_0_ssrs_1_0_0_drf_bist_fail_shift                         (23)
#define  SRNN_SSRS_Bist_0_ssrs_1_0_1_drf_bist_fail_shift                         (22)
#define  SRNN_SSRS_Bist_0_ssrs_1_0_2_drf_bist_fail_shift                         (21)
#define  SRNN_SSRS_Bist_0_ssrs_1_0_3_drf_bist_fail_shift                         (20)
#define  SRNN_SSRS_Bist_0_ssrs_1_0_4_drf_bist_fail_shift                         (19)
#define  SRNN_SSRS_Bist_0_ssrs_1_0_5_drf_bist_fail_shift                         (18)
#define  SRNN_SSRS_Bist_0_ssrs_1_0_6_drf_bist_fail_shift                         (17)
#define  SRNN_SSRS_Bist_0_ssrs_1_0_7_drf_bist_fail_shift                         (16)
#define  SRNN_SSRS_Bist_0_ssrs_1_1_0_drf_bist_fail_shift                         (15)
#define  SRNN_SSRS_Bist_0_ssrs_1_1_1_drf_bist_fail_shift                         (14)
#define  SRNN_SSRS_Bist_0_ssrs_1_1_2_drf_bist_fail_shift                         (13)
#define  SRNN_SSRS_Bist_0_ssrs_1_1_3_drf_bist_fail_shift                         (12)
#define  SRNN_SSRS_Bist_0_ssrs_1_1_4_drf_bist_fail_shift                         (11)
#define  SRNN_SSRS_Bist_0_ssrs_1_1_5_drf_bist_fail_shift                         (10)
#define  SRNN_SSRS_Bist_0_ssrs_1_1_6_drf_bist_fail_shift                         (9)
#define  SRNN_SSRS_Bist_0_ssrs_1_1_7_drf_bist_fail_shift                         (8)
#define  SRNN_SSRS_Bist_0_ssrs_1_2_0_drf_bist_fail_shift                         (7)
#define  SRNN_SSRS_Bist_0_ssrs_1_2_1_drf_bist_fail_shift                         (6)
#define  SRNN_SSRS_Bist_0_ssrs_1_2_2_drf_bist_fail_shift                         (5)
#define  SRNN_SSRS_Bist_0_ssrs_1_2_3_drf_bist_fail_shift                         (4)
#define  SRNN_SSRS_Bist_0_ssrs_1_2_4_drf_bist_fail_shift                         (3)
#define  SRNN_SSRS_Bist_0_ssrs_1_2_5_drf_bist_fail_shift                         (2)
#define  SRNN_SSRS_Bist_0_ssrs_1_2_6_drf_bist_fail_shift                         (1)
#define  SRNN_SSRS_Bist_0_ssrs_1_2_7_drf_bist_fail_shift                         (0)
#define  SRNN_SSRS_Bist_0_ssrs_0_0_0_drf_bist_fail_mask                          (0x08000000)
#define  SRNN_SSRS_Bist_0_ssrs_0_0_1_drf_bist_fail_mask                          (0x04000000)
#define  SRNN_SSRS_Bist_0_ssrs_0_0_2_drf_bist_fail_mask                          (0x02000000)
#define  SRNN_SSRS_Bist_0_ssrs_0_0_3_drf_bist_fail_mask                          (0x01000000)
#define  SRNN_SSRS_Bist_0_ssrs_1_0_0_drf_bist_fail_mask                          (0x00800000)
#define  SRNN_SSRS_Bist_0_ssrs_1_0_1_drf_bist_fail_mask                          (0x00400000)
#define  SRNN_SSRS_Bist_0_ssrs_1_0_2_drf_bist_fail_mask                          (0x00200000)
#define  SRNN_SSRS_Bist_0_ssrs_1_0_3_drf_bist_fail_mask                          (0x00100000)
#define  SRNN_SSRS_Bist_0_ssrs_1_0_4_drf_bist_fail_mask                          (0x00080000)
#define  SRNN_SSRS_Bist_0_ssrs_1_0_5_drf_bist_fail_mask                          (0x00040000)
#define  SRNN_SSRS_Bist_0_ssrs_1_0_6_drf_bist_fail_mask                          (0x00020000)
#define  SRNN_SSRS_Bist_0_ssrs_1_0_7_drf_bist_fail_mask                          (0x00010000)
#define  SRNN_SSRS_Bist_0_ssrs_1_1_0_drf_bist_fail_mask                          (0x00008000)
#define  SRNN_SSRS_Bist_0_ssrs_1_1_1_drf_bist_fail_mask                          (0x00004000)
#define  SRNN_SSRS_Bist_0_ssrs_1_1_2_drf_bist_fail_mask                          (0x00002000)
#define  SRNN_SSRS_Bist_0_ssrs_1_1_3_drf_bist_fail_mask                          (0x00001000)
#define  SRNN_SSRS_Bist_0_ssrs_1_1_4_drf_bist_fail_mask                          (0x00000800)
#define  SRNN_SSRS_Bist_0_ssrs_1_1_5_drf_bist_fail_mask                          (0x00000400)
#define  SRNN_SSRS_Bist_0_ssrs_1_1_6_drf_bist_fail_mask                          (0x00000200)
#define  SRNN_SSRS_Bist_0_ssrs_1_1_7_drf_bist_fail_mask                          (0x00000100)
#define  SRNN_SSRS_Bist_0_ssrs_1_2_0_drf_bist_fail_mask                          (0x00000080)
#define  SRNN_SSRS_Bist_0_ssrs_1_2_1_drf_bist_fail_mask                          (0x00000040)
#define  SRNN_SSRS_Bist_0_ssrs_1_2_2_drf_bist_fail_mask                          (0x00000020)
#define  SRNN_SSRS_Bist_0_ssrs_1_2_3_drf_bist_fail_mask                          (0x00000010)
#define  SRNN_SSRS_Bist_0_ssrs_1_2_4_drf_bist_fail_mask                          (0x00000008)
#define  SRNN_SSRS_Bist_0_ssrs_1_2_5_drf_bist_fail_mask                          (0x00000004)
#define  SRNN_SSRS_Bist_0_ssrs_1_2_6_drf_bist_fail_mask                          (0x00000002)
#define  SRNN_SSRS_Bist_0_ssrs_1_2_7_drf_bist_fail_mask                          (0x00000001)
#define  SRNN_SSRS_Bist_0_ssrs_0_0_0_drf_bist_fail(data)                         (0x08000000&((data)<<27))
#define  SRNN_SSRS_Bist_0_ssrs_0_0_1_drf_bist_fail(data)                         (0x04000000&((data)<<26))
#define  SRNN_SSRS_Bist_0_ssrs_0_0_2_drf_bist_fail(data)                         (0x02000000&((data)<<25))
#define  SRNN_SSRS_Bist_0_ssrs_0_0_3_drf_bist_fail(data)                         (0x01000000&((data)<<24))
#define  SRNN_SSRS_Bist_0_ssrs_1_0_0_drf_bist_fail(data)                         (0x00800000&((data)<<23))
#define  SRNN_SSRS_Bist_0_ssrs_1_0_1_drf_bist_fail(data)                         (0x00400000&((data)<<22))
#define  SRNN_SSRS_Bist_0_ssrs_1_0_2_drf_bist_fail(data)                         (0x00200000&((data)<<21))
#define  SRNN_SSRS_Bist_0_ssrs_1_0_3_drf_bist_fail(data)                         (0x00100000&((data)<<20))
#define  SRNN_SSRS_Bist_0_ssrs_1_0_4_drf_bist_fail(data)                         (0x00080000&((data)<<19))
#define  SRNN_SSRS_Bist_0_ssrs_1_0_5_drf_bist_fail(data)                         (0x00040000&((data)<<18))
#define  SRNN_SSRS_Bist_0_ssrs_1_0_6_drf_bist_fail(data)                         (0x00020000&((data)<<17))
#define  SRNN_SSRS_Bist_0_ssrs_1_0_7_drf_bist_fail(data)                         (0x00010000&((data)<<16))
#define  SRNN_SSRS_Bist_0_ssrs_1_1_0_drf_bist_fail(data)                         (0x00008000&((data)<<15))
#define  SRNN_SSRS_Bist_0_ssrs_1_1_1_drf_bist_fail(data)                         (0x00004000&((data)<<14))
#define  SRNN_SSRS_Bist_0_ssrs_1_1_2_drf_bist_fail(data)                         (0x00002000&((data)<<13))
#define  SRNN_SSRS_Bist_0_ssrs_1_1_3_drf_bist_fail(data)                         (0x00001000&((data)<<12))
#define  SRNN_SSRS_Bist_0_ssrs_1_1_4_drf_bist_fail(data)                         (0x00000800&((data)<<11))
#define  SRNN_SSRS_Bist_0_ssrs_1_1_5_drf_bist_fail(data)                         (0x00000400&((data)<<10))
#define  SRNN_SSRS_Bist_0_ssrs_1_1_6_drf_bist_fail(data)                         (0x00000200&((data)<<9))
#define  SRNN_SSRS_Bist_0_ssrs_1_1_7_drf_bist_fail(data)                         (0x00000100&((data)<<8))
#define  SRNN_SSRS_Bist_0_ssrs_1_2_0_drf_bist_fail(data)                         (0x00000080&((data)<<7))
#define  SRNN_SSRS_Bist_0_ssrs_1_2_1_drf_bist_fail(data)                         (0x00000040&((data)<<6))
#define  SRNN_SSRS_Bist_0_ssrs_1_2_2_drf_bist_fail(data)                         (0x00000020&((data)<<5))
#define  SRNN_SSRS_Bist_0_ssrs_1_2_3_drf_bist_fail(data)                         (0x00000010&((data)<<4))
#define  SRNN_SSRS_Bist_0_ssrs_1_2_4_drf_bist_fail(data)                         (0x00000008&((data)<<3))
#define  SRNN_SSRS_Bist_0_ssrs_1_2_5_drf_bist_fail(data)                         (0x00000004&((data)<<2))
#define  SRNN_SSRS_Bist_0_ssrs_1_2_6_drf_bist_fail(data)                         (0x00000002&((data)<<1))
#define  SRNN_SSRS_Bist_0_ssrs_1_2_7_drf_bist_fail(data)                         (0x00000001&(data))
#define  SRNN_SSRS_Bist_0_get_ssrs_0_0_0_drf_bist_fail(data)                     ((0x08000000&(data))>>27)
#define  SRNN_SSRS_Bist_0_get_ssrs_0_0_1_drf_bist_fail(data)                     ((0x04000000&(data))>>26)
#define  SRNN_SSRS_Bist_0_get_ssrs_0_0_2_drf_bist_fail(data)                     ((0x02000000&(data))>>25)
#define  SRNN_SSRS_Bist_0_get_ssrs_0_0_3_drf_bist_fail(data)                     ((0x01000000&(data))>>24)
#define  SRNN_SSRS_Bist_0_get_ssrs_1_0_0_drf_bist_fail(data)                     ((0x00800000&(data))>>23)
#define  SRNN_SSRS_Bist_0_get_ssrs_1_0_1_drf_bist_fail(data)                     ((0x00400000&(data))>>22)
#define  SRNN_SSRS_Bist_0_get_ssrs_1_0_2_drf_bist_fail(data)                     ((0x00200000&(data))>>21)
#define  SRNN_SSRS_Bist_0_get_ssrs_1_0_3_drf_bist_fail(data)                     ((0x00100000&(data))>>20)
#define  SRNN_SSRS_Bist_0_get_ssrs_1_0_4_drf_bist_fail(data)                     ((0x00080000&(data))>>19)
#define  SRNN_SSRS_Bist_0_get_ssrs_1_0_5_drf_bist_fail(data)                     ((0x00040000&(data))>>18)
#define  SRNN_SSRS_Bist_0_get_ssrs_1_0_6_drf_bist_fail(data)                     ((0x00020000&(data))>>17)
#define  SRNN_SSRS_Bist_0_get_ssrs_1_0_7_drf_bist_fail(data)                     ((0x00010000&(data))>>16)
#define  SRNN_SSRS_Bist_0_get_ssrs_1_1_0_drf_bist_fail(data)                     ((0x00008000&(data))>>15)
#define  SRNN_SSRS_Bist_0_get_ssrs_1_1_1_drf_bist_fail(data)                     ((0x00004000&(data))>>14)
#define  SRNN_SSRS_Bist_0_get_ssrs_1_1_2_drf_bist_fail(data)                     ((0x00002000&(data))>>13)
#define  SRNN_SSRS_Bist_0_get_ssrs_1_1_3_drf_bist_fail(data)                     ((0x00001000&(data))>>12)
#define  SRNN_SSRS_Bist_0_get_ssrs_1_1_4_drf_bist_fail(data)                     ((0x00000800&(data))>>11)
#define  SRNN_SSRS_Bist_0_get_ssrs_1_1_5_drf_bist_fail(data)                     ((0x00000400&(data))>>10)
#define  SRNN_SSRS_Bist_0_get_ssrs_1_1_6_drf_bist_fail(data)                     ((0x00000200&(data))>>9)
#define  SRNN_SSRS_Bist_0_get_ssrs_1_1_7_drf_bist_fail(data)                     ((0x00000100&(data))>>8)
#define  SRNN_SSRS_Bist_0_get_ssrs_1_2_0_drf_bist_fail(data)                     ((0x00000080&(data))>>7)
#define  SRNN_SSRS_Bist_0_get_ssrs_1_2_1_drf_bist_fail(data)                     ((0x00000040&(data))>>6)
#define  SRNN_SSRS_Bist_0_get_ssrs_1_2_2_drf_bist_fail(data)                     ((0x00000020&(data))>>5)
#define  SRNN_SSRS_Bist_0_get_ssrs_1_2_3_drf_bist_fail(data)                     ((0x00000010&(data))>>4)
#define  SRNN_SSRS_Bist_0_get_ssrs_1_2_4_drf_bist_fail(data)                     ((0x00000008&(data))>>3)
#define  SRNN_SSRS_Bist_0_get_ssrs_1_2_5_drf_bist_fail(data)                     ((0x00000004&(data))>>2)
#define  SRNN_SSRS_Bist_0_get_ssrs_1_2_6_drf_bist_fail(data)                     ((0x00000002&(data))>>1)
#define  SRNN_SSRS_Bist_0_get_ssrs_1_2_7_drf_bist_fail(data)                     (0x00000001&(data))

#define  SRNN_SSRS_Bist_1                                                       0x181AA070
#define  SRNN_SSRS_Bist_1_reg_addr                                               "0xB81AA070"
#define  SRNN_SSRS_Bist_1_reg                                                    0xB81AA070
#define  SRNN_SSRS_Bist_1_inst_addr                                              "0x0554"
#define  set_SRNN_SSRS_Bist_1_reg(data)                                          (*((volatile unsigned int*)SRNN_SSRS_Bist_1_reg)=data)
#define  get_SRNN_SSRS_Bist_1_reg                                                (*((volatile unsigned int*)SRNN_SSRS_Bist_1_reg))
#define  SRNN_SSRS_Bist_1_ssrs_2_0_0_drf_bist_fail_shift                         (18)
#define  SRNN_SSRS_Bist_1_ssrs_2_0_1_drf_bist_fail_shift                         (17)
#define  SRNN_SSRS_Bist_1_ssrs_2_0_2_drf_bist_fail_shift                         (16)
#define  SRNN_SSRS_Bist_1_ssrs_2_0_3_drf_bist_fail_shift                         (15)
#define  SRNN_SSRS_Bist_1_ssrs_2_0_4_drf_bist_fail_shift                         (14)
#define  SRNN_SSRS_Bist_1_ssrs_2_0_5_drf_bist_fail_shift                         (13)
#define  SRNN_SSRS_Bist_1_ssrs_2_0_6_drf_bist_fail_shift                         (12)
#define  SRNN_SSRS_Bist_1_ssrs_2_1_0_drf_bist_fail_shift                         (11)
#define  SRNN_SSRS_Bist_1_ssrs_2_1_1_drf_bist_fail_shift                         (10)
#define  SRNN_SSRS_Bist_1_ssrs_2_1_2_drf_bist_fail_shift                         (9)
#define  SRNN_SSRS_Bist_1_ssrs_2_1_3_drf_bist_fail_shift                         (8)
#define  SRNN_SSRS_Bist_1_ssrs_2_1_4_drf_bist_fail_shift                         (7)
#define  SRNN_SSRS_Bist_1_ssrs_2_1_5_drf_bist_fail_shift                         (6)
#define  SRNN_SSRS_Bist_1_ssrs_2_1_6_drf_bist_fail_shift                         (5)
#define  SRNN_SSRS_Bist_1_ssrs_3_0_0_drf_bist_fail_shift                         (4)
#define  SRNN_SSRS_Bist_1_ssrs_4_0_0_drf_bist_fail_shift                         (3)
#define  SRNN_SSRS_Bist_1_ssrs_4_0_1_drf_bist_fail_shift                         (2)
#define  SRNN_SSRS_Bist_1_ssrs_4_0_2_drf_bist_fail_shift                         (1)
#define  SRNN_SSRS_Bist_1_ssrs_4_0_3_drf_bist_fail_shift                         (0)
#define  SRNN_SSRS_Bist_1_ssrs_2_0_0_drf_bist_fail_mask                          (0x00040000)
#define  SRNN_SSRS_Bist_1_ssrs_2_0_1_drf_bist_fail_mask                          (0x00020000)
#define  SRNN_SSRS_Bist_1_ssrs_2_0_2_drf_bist_fail_mask                          (0x00010000)
#define  SRNN_SSRS_Bist_1_ssrs_2_0_3_drf_bist_fail_mask                          (0x00008000)
#define  SRNN_SSRS_Bist_1_ssrs_2_0_4_drf_bist_fail_mask                          (0x00004000)
#define  SRNN_SSRS_Bist_1_ssrs_2_0_5_drf_bist_fail_mask                          (0x00002000)
#define  SRNN_SSRS_Bist_1_ssrs_2_0_6_drf_bist_fail_mask                          (0x00001000)
#define  SRNN_SSRS_Bist_1_ssrs_2_1_0_drf_bist_fail_mask                          (0x00000800)
#define  SRNN_SSRS_Bist_1_ssrs_2_1_1_drf_bist_fail_mask                          (0x00000400)
#define  SRNN_SSRS_Bist_1_ssrs_2_1_2_drf_bist_fail_mask                          (0x00000200)
#define  SRNN_SSRS_Bist_1_ssrs_2_1_3_drf_bist_fail_mask                          (0x00000100)
#define  SRNN_SSRS_Bist_1_ssrs_2_1_4_drf_bist_fail_mask                          (0x00000080)
#define  SRNN_SSRS_Bist_1_ssrs_2_1_5_drf_bist_fail_mask                          (0x00000040)
#define  SRNN_SSRS_Bist_1_ssrs_2_1_6_drf_bist_fail_mask                          (0x00000020)
#define  SRNN_SSRS_Bist_1_ssrs_3_0_0_drf_bist_fail_mask                          (0x00000010)
#define  SRNN_SSRS_Bist_1_ssrs_4_0_0_drf_bist_fail_mask                          (0x00000008)
#define  SRNN_SSRS_Bist_1_ssrs_4_0_1_drf_bist_fail_mask                          (0x00000004)
#define  SRNN_SSRS_Bist_1_ssrs_4_0_2_drf_bist_fail_mask                          (0x00000002)
#define  SRNN_SSRS_Bist_1_ssrs_4_0_3_drf_bist_fail_mask                          (0x00000001)
#define  SRNN_SSRS_Bist_1_ssrs_2_0_0_drf_bist_fail(data)                         (0x00040000&((data)<<18))
#define  SRNN_SSRS_Bist_1_ssrs_2_0_1_drf_bist_fail(data)                         (0x00020000&((data)<<17))
#define  SRNN_SSRS_Bist_1_ssrs_2_0_2_drf_bist_fail(data)                         (0x00010000&((data)<<16))
#define  SRNN_SSRS_Bist_1_ssrs_2_0_3_drf_bist_fail(data)                         (0x00008000&((data)<<15))
#define  SRNN_SSRS_Bist_1_ssrs_2_0_4_drf_bist_fail(data)                         (0x00004000&((data)<<14))
#define  SRNN_SSRS_Bist_1_ssrs_2_0_5_drf_bist_fail(data)                         (0x00002000&((data)<<13))
#define  SRNN_SSRS_Bist_1_ssrs_2_0_6_drf_bist_fail(data)                         (0x00001000&((data)<<12))
#define  SRNN_SSRS_Bist_1_ssrs_2_1_0_drf_bist_fail(data)                         (0x00000800&((data)<<11))
#define  SRNN_SSRS_Bist_1_ssrs_2_1_1_drf_bist_fail(data)                         (0x00000400&((data)<<10))
#define  SRNN_SSRS_Bist_1_ssrs_2_1_2_drf_bist_fail(data)                         (0x00000200&((data)<<9))
#define  SRNN_SSRS_Bist_1_ssrs_2_1_3_drf_bist_fail(data)                         (0x00000100&((data)<<8))
#define  SRNN_SSRS_Bist_1_ssrs_2_1_4_drf_bist_fail(data)                         (0x00000080&((data)<<7))
#define  SRNN_SSRS_Bist_1_ssrs_2_1_5_drf_bist_fail(data)                         (0x00000040&((data)<<6))
#define  SRNN_SSRS_Bist_1_ssrs_2_1_6_drf_bist_fail(data)                         (0x00000020&((data)<<5))
#define  SRNN_SSRS_Bist_1_ssrs_3_0_0_drf_bist_fail(data)                         (0x00000010&((data)<<4))
#define  SRNN_SSRS_Bist_1_ssrs_4_0_0_drf_bist_fail(data)                         (0x00000008&((data)<<3))
#define  SRNN_SSRS_Bist_1_ssrs_4_0_1_drf_bist_fail(data)                         (0x00000004&((data)<<2))
#define  SRNN_SSRS_Bist_1_ssrs_4_0_2_drf_bist_fail(data)                         (0x00000002&((data)<<1))
#define  SRNN_SSRS_Bist_1_ssrs_4_0_3_drf_bist_fail(data)                         (0x00000001&(data))
#define  SRNN_SSRS_Bist_1_get_ssrs_2_0_0_drf_bist_fail(data)                     ((0x00040000&(data))>>18)
#define  SRNN_SSRS_Bist_1_get_ssrs_2_0_1_drf_bist_fail(data)                     ((0x00020000&(data))>>17)
#define  SRNN_SSRS_Bist_1_get_ssrs_2_0_2_drf_bist_fail(data)                     ((0x00010000&(data))>>16)
#define  SRNN_SSRS_Bist_1_get_ssrs_2_0_3_drf_bist_fail(data)                     ((0x00008000&(data))>>15)
#define  SRNN_SSRS_Bist_1_get_ssrs_2_0_4_drf_bist_fail(data)                     ((0x00004000&(data))>>14)
#define  SRNN_SSRS_Bist_1_get_ssrs_2_0_5_drf_bist_fail(data)                     ((0x00002000&(data))>>13)
#define  SRNN_SSRS_Bist_1_get_ssrs_2_0_6_drf_bist_fail(data)                     ((0x00001000&(data))>>12)
#define  SRNN_SSRS_Bist_1_get_ssrs_2_1_0_drf_bist_fail(data)                     ((0x00000800&(data))>>11)
#define  SRNN_SSRS_Bist_1_get_ssrs_2_1_1_drf_bist_fail(data)                     ((0x00000400&(data))>>10)
#define  SRNN_SSRS_Bist_1_get_ssrs_2_1_2_drf_bist_fail(data)                     ((0x00000200&(data))>>9)
#define  SRNN_SSRS_Bist_1_get_ssrs_2_1_3_drf_bist_fail(data)                     ((0x00000100&(data))>>8)
#define  SRNN_SSRS_Bist_1_get_ssrs_2_1_4_drf_bist_fail(data)                     ((0x00000080&(data))>>7)
#define  SRNN_SSRS_Bist_1_get_ssrs_2_1_5_drf_bist_fail(data)                     ((0x00000040&(data))>>6)
#define  SRNN_SSRS_Bist_1_get_ssrs_2_1_6_drf_bist_fail(data)                     ((0x00000020&(data))>>5)
#define  SRNN_SSRS_Bist_1_get_ssrs_3_0_0_drf_bist_fail(data)                     ((0x00000010&(data))>>4)
#define  SRNN_SSRS_Bist_1_get_ssrs_4_0_0_drf_bist_fail(data)                     ((0x00000008&(data))>>3)
#define  SRNN_SSRS_Bist_1_get_ssrs_4_0_1_drf_bist_fail(data)                     ((0x00000004&(data))>>2)
#define  SRNN_SSRS_Bist_1_get_ssrs_4_0_2_drf_bist_fail(data)                     ((0x00000002&(data))>>1)
#define  SRNN_SSRS_Bist_1_get_ssrs_4_0_3_drf_bist_fail(data)                     (0x00000001&(data))

#define  SRNN_SSRS_Bist_2                                                       0x181AA074
#define  SRNN_SSRS_Bist_2_reg_addr                                               "0xB81AA074"
#define  SRNN_SSRS_Bist_2_reg                                                    0xB81AA074
#define  SRNN_SSRS_Bist_2_inst_addr                                              "0x0555"
#define  set_SRNN_SSRS_Bist_2_reg(data)                                          (*((volatile unsigned int*)SRNN_SSRS_Bist_2_reg)=data)
#define  get_SRNN_SSRS_Bist_2_reg                                                (*((volatile unsigned int*)SRNN_SSRS_Bist_2_reg))
#define  SRNN_SSRS_Bist_2_ssrs_0_0_0_bist_fail_shift                             (27)
#define  SRNN_SSRS_Bist_2_ssrs_0_0_1_bist_fail_shift                             (26)
#define  SRNN_SSRS_Bist_2_ssrs_0_0_2_bist_fail_shift                             (25)
#define  SRNN_SSRS_Bist_2_ssrs_0_0_3_bist_fail_shift                             (24)
#define  SRNN_SSRS_Bist_2_ssrs_1_0_0_bist_fail_shift                             (23)
#define  SRNN_SSRS_Bist_2_ssrs_1_0_1_bist_fail_shift                             (22)
#define  SRNN_SSRS_Bist_2_ssrs_1_0_2_bist_fail_shift                             (21)
#define  SRNN_SSRS_Bist_2_ssrs_1_0_3_bist_fail_shift                             (20)
#define  SRNN_SSRS_Bist_2_ssrs_1_0_4_bist_fail_shift                             (19)
#define  SRNN_SSRS_Bist_2_ssrs_1_0_5_bist_fail_shift                             (18)
#define  SRNN_SSRS_Bist_2_ssrs_1_0_6_bist_fail_shift                             (17)
#define  SRNN_SSRS_Bist_2_ssrs_1_0_7_bist_fail_shift                             (16)
#define  SRNN_SSRS_Bist_2_ssrs_1_1_0_bist_fail_shift                             (15)
#define  SRNN_SSRS_Bist_2_ssrs_1_1_1_bist_fail_shift                             (14)
#define  SRNN_SSRS_Bist_2_ssrs_1_1_2_bist_fail_shift                             (13)
#define  SRNN_SSRS_Bist_2_ssrs_1_1_3_bist_fail_shift                             (12)
#define  SRNN_SSRS_Bist_2_ssrs_1_1_4_bist_fail_shift                             (11)
#define  SRNN_SSRS_Bist_2_ssrs_1_1_5_bist_fail_shift                             (10)
#define  SRNN_SSRS_Bist_2_ssrs_1_1_6_bist_fail_shift                             (9)
#define  SRNN_SSRS_Bist_2_ssrs_1_1_7_bist_fail_shift                             (8)
#define  SRNN_SSRS_Bist_2_ssrs_1_2_0_bist_fail_shift                             (7)
#define  SRNN_SSRS_Bist_2_ssrs_1_2_1_bist_fail_shift                             (6)
#define  SRNN_SSRS_Bist_2_ssrs_1_2_2_bist_fail_shift                             (5)
#define  SRNN_SSRS_Bist_2_ssrs_1_2_3_bist_fail_shift                             (4)
#define  SRNN_SSRS_Bist_2_ssrs_1_2_4_bist_fail_shift                             (3)
#define  SRNN_SSRS_Bist_2_ssrs_1_2_5_bist_fail_shift                             (2)
#define  SRNN_SSRS_Bist_2_ssrs_1_2_6_bist_fail_shift                             (1)
#define  SRNN_SSRS_Bist_2_ssrs_1_2_7_bist_fail_shift                             (0)
#define  SRNN_SSRS_Bist_2_ssrs_0_0_0_bist_fail_mask                              (0x08000000)
#define  SRNN_SSRS_Bist_2_ssrs_0_0_1_bist_fail_mask                              (0x04000000)
#define  SRNN_SSRS_Bist_2_ssrs_0_0_2_bist_fail_mask                              (0x02000000)
#define  SRNN_SSRS_Bist_2_ssrs_0_0_3_bist_fail_mask                              (0x01000000)
#define  SRNN_SSRS_Bist_2_ssrs_1_0_0_bist_fail_mask                              (0x00800000)
#define  SRNN_SSRS_Bist_2_ssrs_1_0_1_bist_fail_mask                              (0x00400000)
#define  SRNN_SSRS_Bist_2_ssrs_1_0_2_bist_fail_mask                              (0x00200000)
#define  SRNN_SSRS_Bist_2_ssrs_1_0_3_bist_fail_mask                              (0x00100000)
#define  SRNN_SSRS_Bist_2_ssrs_1_0_4_bist_fail_mask                              (0x00080000)
#define  SRNN_SSRS_Bist_2_ssrs_1_0_5_bist_fail_mask                              (0x00040000)
#define  SRNN_SSRS_Bist_2_ssrs_1_0_6_bist_fail_mask                              (0x00020000)
#define  SRNN_SSRS_Bist_2_ssrs_1_0_7_bist_fail_mask                              (0x00010000)
#define  SRNN_SSRS_Bist_2_ssrs_1_1_0_bist_fail_mask                              (0x00008000)
#define  SRNN_SSRS_Bist_2_ssrs_1_1_1_bist_fail_mask                              (0x00004000)
#define  SRNN_SSRS_Bist_2_ssrs_1_1_2_bist_fail_mask                              (0x00002000)
#define  SRNN_SSRS_Bist_2_ssrs_1_1_3_bist_fail_mask                              (0x00001000)
#define  SRNN_SSRS_Bist_2_ssrs_1_1_4_bist_fail_mask                              (0x00000800)
#define  SRNN_SSRS_Bist_2_ssrs_1_1_5_bist_fail_mask                              (0x00000400)
#define  SRNN_SSRS_Bist_2_ssrs_1_1_6_bist_fail_mask                              (0x00000200)
#define  SRNN_SSRS_Bist_2_ssrs_1_1_7_bist_fail_mask                              (0x00000100)
#define  SRNN_SSRS_Bist_2_ssrs_1_2_0_bist_fail_mask                              (0x00000080)
#define  SRNN_SSRS_Bist_2_ssrs_1_2_1_bist_fail_mask                              (0x00000040)
#define  SRNN_SSRS_Bist_2_ssrs_1_2_2_bist_fail_mask                              (0x00000020)
#define  SRNN_SSRS_Bist_2_ssrs_1_2_3_bist_fail_mask                              (0x00000010)
#define  SRNN_SSRS_Bist_2_ssrs_1_2_4_bist_fail_mask                              (0x00000008)
#define  SRNN_SSRS_Bist_2_ssrs_1_2_5_bist_fail_mask                              (0x00000004)
#define  SRNN_SSRS_Bist_2_ssrs_1_2_6_bist_fail_mask                              (0x00000002)
#define  SRNN_SSRS_Bist_2_ssrs_1_2_7_bist_fail_mask                              (0x00000001)
#define  SRNN_SSRS_Bist_2_ssrs_0_0_0_bist_fail(data)                             (0x08000000&((data)<<27))
#define  SRNN_SSRS_Bist_2_ssrs_0_0_1_bist_fail(data)                             (0x04000000&((data)<<26))
#define  SRNN_SSRS_Bist_2_ssrs_0_0_2_bist_fail(data)                             (0x02000000&((data)<<25))
#define  SRNN_SSRS_Bist_2_ssrs_0_0_3_bist_fail(data)                             (0x01000000&((data)<<24))
#define  SRNN_SSRS_Bist_2_ssrs_1_0_0_bist_fail(data)                             (0x00800000&((data)<<23))
#define  SRNN_SSRS_Bist_2_ssrs_1_0_1_bist_fail(data)                             (0x00400000&((data)<<22))
#define  SRNN_SSRS_Bist_2_ssrs_1_0_2_bist_fail(data)                             (0x00200000&((data)<<21))
#define  SRNN_SSRS_Bist_2_ssrs_1_0_3_bist_fail(data)                             (0x00100000&((data)<<20))
#define  SRNN_SSRS_Bist_2_ssrs_1_0_4_bist_fail(data)                             (0x00080000&((data)<<19))
#define  SRNN_SSRS_Bist_2_ssrs_1_0_5_bist_fail(data)                             (0x00040000&((data)<<18))
#define  SRNN_SSRS_Bist_2_ssrs_1_0_6_bist_fail(data)                             (0x00020000&((data)<<17))
#define  SRNN_SSRS_Bist_2_ssrs_1_0_7_bist_fail(data)                             (0x00010000&((data)<<16))
#define  SRNN_SSRS_Bist_2_ssrs_1_1_0_bist_fail(data)                             (0x00008000&((data)<<15))
#define  SRNN_SSRS_Bist_2_ssrs_1_1_1_bist_fail(data)                             (0x00004000&((data)<<14))
#define  SRNN_SSRS_Bist_2_ssrs_1_1_2_bist_fail(data)                             (0x00002000&((data)<<13))
#define  SRNN_SSRS_Bist_2_ssrs_1_1_3_bist_fail(data)                             (0x00001000&((data)<<12))
#define  SRNN_SSRS_Bist_2_ssrs_1_1_4_bist_fail(data)                             (0x00000800&((data)<<11))
#define  SRNN_SSRS_Bist_2_ssrs_1_1_5_bist_fail(data)                             (0x00000400&((data)<<10))
#define  SRNN_SSRS_Bist_2_ssrs_1_1_6_bist_fail(data)                             (0x00000200&((data)<<9))
#define  SRNN_SSRS_Bist_2_ssrs_1_1_7_bist_fail(data)                             (0x00000100&((data)<<8))
#define  SRNN_SSRS_Bist_2_ssrs_1_2_0_bist_fail(data)                             (0x00000080&((data)<<7))
#define  SRNN_SSRS_Bist_2_ssrs_1_2_1_bist_fail(data)                             (0x00000040&((data)<<6))
#define  SRNN_SSRS_Bist_2_ssrs_1_2_2_bist_fail(data)                             (0x00000020&((data)<<5))
#define  SRNN_SSRS_Bist_2_ssrs_1_2_3_bist_fail(data)                             (0x00000010&((data)<<4))
#define  SRNN_SSRS_Bist_2_ssrs_1_2_4_bist_fail(data)                             (0x00000008&((data)<<3))
#define  SRNN_SSRS_Bist_2_ssrs_1_2_5_bist_fail(data)                             (0x00000004&((data)<<2))
#define  SRNN_SSRS_Bist_2_ssrs_1_2_6_bist_fail(data)                             (0x00000002&((data)<<1))
#define  SRNN_SSRS_Bist_2_ssrs_1_2_7_bist_fail(data)                             (0x00000001&(data))
#define  SRNN_SSRS_Bist_2_get_ssrs_0_0_0_bist_fail(data)                         ((0x08000000&(data))>>27)
#define  SRNN_SSRS_Bist_2_get_ssrs_0_0_1_bist_fail(data)                         ((0x04000000&(data))>>26)
#define  SRNN_SSRS_Bist_2_get_ssrs_0_0_2_bist_fail(data)                         ((0x02000000&(data))>>25)
#define  SRNN_SSRS_Bist_2_get_ssrs_0_0_3_bist_fail(data)                         ((0x01000000&(data))>>24)
#define  SRNN_SSRS_Bist_2_get_ssrs_1_0_0_bist_fail(data)                         ((0x00800000&(data))>>23)
#define  SRNN_SSRS_Bist_2_get_ssrs_1_0_1_bist_fail(data)                         ((0x00400000&(data))>>22)
#define  SRNN_SSRS_Bist_2_get_ssrs_1_0_2_bist_fail(data)                         ((0x00200000&(data))>>21)
#define  SRNN_SSRS_Bist_2_get_ssrs_1_0_3_bist_fail(data)                         ((0x00100000&(data))>>20)
#define  SRNN_SSRS_Bist_2_get_ssrs_1_0_4_bist_fail(data)                         ((0x00080000&(data))>>19)
#define  SRNN_SSRS_Bist_2_get_ssrs_1_0_5_bist_fail(data)                         ((0x00040000&(data))>>18)
#define  SRNN_SSRS_Bist_2_get_ssrs_1_0_6_bist_fail(data)                         ((0x00020000&(data))>>17)
#define  SRNN_SSRS_Bist_2_get_ssrs_1_0_7_bist_fail(data)                         ((0x00010000&(data))>>16)
#define  SRNN_SSRS_Bist_2_get_ssrs_1_1_0_bist_fail(data)                         ((0x00008000&(data))>>15)
#define  SRNN_SSRS_Bist_2_get_ssrs_1_1_1_bist_fail(data)                         ((0x00004000&(data))>>14)
#define  SRNN_SSRS_Bist_2_get_ssrs_1_1_2_bist_fail(data)                         ((0x00002000&(data))>>13)
#define  SRNN_SSRS_Bist_2_get_ssrs_1_1_3_bist_fail(data)                         ((0x00001000&(data))>>12)
#define  SRNN_SSRS_Bist_2_get_ssrs_1_1_4_bist_fail(data)                         ((0x00000800&(data))>>11)
#define  SRNN_SSRS_Bist_2_get_ssrs_1_1_5_bist_fail(data)                         ((0x00000400&(data))>>10)
#define  SRNN_SSRS_Bist_2_get_ssrs_1_1_6_bist_fail(data)                         ((0x00000200&(data))>>9)
#define  SRNN_SSRS_Bist_2_get_ssrs_1_1_7_bist_fail(data)                         ((0x00000100&(data))>>8)
#define  SRNN_SSRS_Bist_2_get_ssrs_1_2_0_bist_fail(data)                         ((0x00000080&(data))>>7)
#define  SRNN_SSRS_Bist_2_get_ssrs_1_2_1_bist_fail(data)                         ((0x00000040&(data))>>6)
#define  SRNN_SSRS_Bist_2_get_ssrs_1_2_2_bist_fail(data)                         ((0x00000020&(data))>>5)
#define  SRNN_SSRS_Bist_2_get_ssrs_1_2_3_bist_fail(data)                         ((0x00000010&(data))>>4)
#define  SRNN_SSRS_Bist_2_get_ssrs_1_2_4_bist_fail(data)                         ((0x00000008&(data))>>3)
#define  SRNN_SSRS_Bist_2_get_ssrs_1_2_5_bist_fail(data)                         ((0x00000004&(data))>>2)
#define  SRNN_SSRS_Bist_2_get_ssrs_1_2_6_bist_fail(data)                         ((0x00000002&(data))>>1)
#define  SRNN_SSRS_Bist_2_get_ssrs_1_2_7_bist_fail(data)                         (0x00000001&(data))

#define  SRNN_SSRS_Bist_3                                                       0x181AA078
#define  SRNN_SSRS_Bist_3_reg_addr                                               "0xB81AA078"
#define  SRNN_SSRS_Bist_3_reg                                                    0xB81AA078
#define  SRNN_SSRS_Bist_3_inst_addr                                              "0x0556"
#define  set_SRNN_SSRS_Bist_3_reg(data)                                          (*((volatile unsigned int*)SRNN_SSRS_Bist_3_reg)=data)
#define  get_SRNN_SSRS_Bist_3_reg                                                (*((volatile unsigned int*)SRNN_SSRS_Bist_3_reg))
#define  SRNN_SSRS_Bist_3_ssrs_2_0_0_bist_fail_shift                             (18)
#define  SRNN_SSRS_Bist_3_ssrs_2_0_1_bist_fail_shift                             (17)
#define  SRNN_SSRS_Bist_3_ssrs_2_0_2_bist_fail_shift                             (16)
#define  SRNN_SSRS_Bist_3_ssrs_2_0_3_bist_fail_shift                             (15)
#define  SRNN_SSRS_Bist_3_ssrs_2_0_4_bist_fail_shift                             (14)
#define  SRNN_SSRS_Bist_3_ssrs_2_0_5_bist_fail_shift                             (13)
#define  SRNN_SSRS_Bist_3_ssrs_2_0_6_bist_fail_shift                             (12)
#define  SRNN_SSRS_Bist_3_ssrs_2_1_0_bist_fail_shift                             (11)
#define  SRNN_SSRS_Bist_3_ssrs_2_1_1_bist_fail_shift                             (10)
#define  SRNN_SSRS_Bist_3_ssrs_2_1_2_bist_fail_shift                             (9)
#define  SRNN_SSRS_Bist_3_ssrs_2_1_3_bist_fail_shift                             (8)
#define  SRNN_SSRS_Bist_3_ssrs_2_1_4_bist_fail_shift                             (7)
#define  SRNN_SSRS_Bist_3_ssrs_2_1_5_bist_fail_shift                             (6)
#define  SRNN_SSRS_Bist_3_ssrs_2_1_6_bist_fail_shift                             (5)
#define  SRNN_SSRS_Bist_3_ssrs_3_0_0_bist_fail_shift                             (4)
#define  SRNN_SSRS_Bist_3_ssrs_4_0_0_bist_fail_shift                             (3)
#define  SRNN_SSRS_Bist_3_ssrs_4_0_1_bist_fail_shift                             (2)
#define  SRNN_SSRS_Bist_3_ssrs_4_0_2_bist_fail_shift                             (1)
#define  SRNN_SSRS_Bist_3_ssrs_4_0_3_bist_fail_shift                             (0)
#define  SRNN_SSRS_Bist_3_ssrs_2_0_0_bist_fail_mask                              (0x00040000)
#define  SRNN_SSRS_Bist_3_ssrs_2_0_1_bist_fail_mask                              (0x00020000)
#define  SRNN_SSRS_Bist_3_ssrs_2_0_2_bist_fail_mask                              (0x00010000)
#define  SRNN_SSRS_Bist_3_ssrs_2_0_3_bist_fail_mask                              (0x00008000)
#define  SRNN_SSRS_Bist_3_ssrs_2_0_4_bist_fail_mask                              (0x00004000)
#define  SRNN_SSRS_Bist_3_ssrs_2_0_5_bist_fail_mask                              (0x00002000)
#define  SRNN_SSRS_Bist_3_ssrs_2_0_6_bist_fail_mask                              (0x00001000)
#define  SRNN_SSRS_Bist_3_ssrs_2_1_0_bist_fail_mask                              (0x00000800)
#define  SRNN_SSRS_Bist_3_ssrs_2_1_1_bist_fail_mask                              (0x00000400)
#define  SRNN_SSRS_Bist_3_ssrs_2_1_2_bist_fail_mask                              (0x00000200)
#define  SRNN_SSRS_Bist_3_ssrs_2_1_3_bist_fail_mask                              (0x00000100)
#define  SRNN_SSRS_Bist_3_ssrs_2_1_4_bist_fail_mask                              (0x00000080)
#define  SRNN_SSRS_Bist_3_ssrs_2_1_5_bist_fail_mask                              (0x00000040)
#define  SRNN_SSRS_Bist_3_ssrs_2_1_6_bist_fail_mask                              (0x00000020)
#define  SRNN_SSRS_Bist_3_ssrs_3_0_0_bist_fail_mask                              (0x00000010)
#define  SRNN_SSRS_Bist_3_ssrs_4_0_0_bist_fail_mask                              (0x00000008)
#define  SRNN_SSRS_Bist_3_ssrs_4_0_1_bist_fail_mask                              (0x00000004)
#define  SRNN_SSRS_Bist_3_ssrs_4_0_2_bist_fail_mask                              (0x00000002)
#define  SRNN_SSRS_Bist_3_ssrs_4_0_3_bist_fail_mask                              (0x00000001)
#define  SRNN_SSRS_Bist_3_ssrs_2_0_0_bist_fail(data)                             (0x00040000&((data)<<18))
#define  SRNN_SSRS_Bist_3_ssrs_2_0_1_bist_fail(data)                             (0x00020000&((data)<<17))
#define  SRNN_SSRS_Bist_3_ssrs_2_0_2_bist_fail(data)                             (0x00010000&((data)<<16))
#define  SRNN_SSRS_Bist_3_ssrs_2_0_3_bist_fail(data)                             (0x00008000&((data)<<15))
#define  SRNN_SSRS_Bist_3_ssrs_2_0_4_bist_fail(data)                             (0x00004000&((data)<<14))
#define  SRNN_SSRS_Bist_3_ssrs_2_0_5_bist_fail(data)                             (0x00002000&((data)<<13))
#define  SRNN_SSRS_Bist_3_ssrs_2_0_6_bist_fail(data)                             (0x00001000&((data)<<12))
#define  SRNN_SSRS_Bist_3_ssrs_2_1_0_bist_fail(data)                             (0x00000800&((data)<<11))
#define  SRNN_SSRS_Bist_3_ssrs_2_1_1_bist_fail(data)                             (0x00000400&((data)<<10))
#define  SRNN_SSRS_Bist_3_ssrs_2_1_2_bist_fail(data)                             (0x00000200&((data)<<9))
#define  SRNN_SSRS_Bist_3_ssrs_2_1_3_bist_fail(data)                             (0x00000100&((data)<<8))
#define  SRNN_SSRS_Bist_3_ssrs_2_1_4_bist_fail(data)                             (0x00000080&((data)<<7))
#define  SRNN_SSRS_Bist_3_ssrs_2_1_5_bist_fail(data)                             (0x00000040&((data)<<6))
#define  SRNN_SSRS_Bist_3_ssrs_2_1_6_bist_fail(data)                             (0x00000020&((data)<<5))
#define  SRNN_SSRS_Bist_3_ssrs_3_0_0_bist_fail(data)                             (0x00000010&((data)<<4))
#define  SRNN_SSRS_Bist_3_ssrs_4_0_0_bist_fail(data)                             (0x00000008&((data)<<3))
#define  SRNN_SSRS_Bist_3_ssrs_4_0_1_bist_fail(data)                             (0x00000004&((data)<<2))
#define  SRNN_SSRS_Bist_3_ssrs_4_0_2_bist_fail(data)                             (0x00000002&((data)<<1))
#define  SRNN_SSRS_Bist_3_ssrs_4_0_3_bist_fail(data)                             (0x00000001&(data))
#define  SRNN_SSRS_Bist_3_get_ssrs_2_0_0_bist_fail(data)                         ((0x00040000&(data))>>18)
#define  SRNN_SSRS_Bist_3_get_ssrs_2_0_1_bist_fail(data)                         ((0x00020000&(data))>>17)
#define  SRNN_SSRS_Bist_3_get_ssrs_2_0_2_bist_fail(data)                         ((0x00010000&(data))>>16)
#define  SRNN_SSRS_Bist_3_get_ssrs_2_0_3_bist_fail(data)                         ((0x00008000&(data))>>15)
#define  SRNN_SSRS_Bist_3_get_ssrs_2_0_4_bist_fail(data)                         ((0x00004000&(data))>>14)
#define  SRNN_SSRS_Bist_3_get_ssrs_2_0_5_bist_fail(data)                         ((0x00002000&(data))>>13)
#define  SRNN_SSRS_Bist_3_get_ssrs_2_0_6_bist_fail(data)                         ((0x00001000&(data))>>12)
#define  SRNN_SSRS_Bist_3_get_ssrs_2_1_0_bist_fail(data)                         ((0x00000800&(data))>>11)
#define  SRNN_SSRS_Bist_3_get_ssrs_2_1_1_bist_fail(data)                         ((0x00000400&(data))>>10)
#define  SRNN_SSRS_Bist_3_get_ssrs_2_1_2_bist_fail(data)                         ((0x00000200&(data))>>9)
#define  SRNN_SSRS_Bist_3_get_ssrs_2_1_3_bist_fail(data)                         ((0x00000100&(data))>>8)
#define  SRNN_SSRS_Bist_3_get_ssrs_2_1_4_bist_fail(data)                         ((0x00000080&(data))>>7)
#define  SRNN_SSRS_Bist_3_get_ssrs_2_1_5_bist_fail(data)                         ((0x00000040&(data))>>6)
#define  SRNN_SSRS_Bist_3_get_ssrs_2_1_6_bist_fail(data)                         ((0x00000020&(data))>>5)
#define  SRNN_SSRS_Bist_3_get_ssrs_3_0_0_bist_fail(data)                         ((0x00000010&(data))>>4)
#define  SRNN_SSRS_Bist_3_get_ssrs_4_0_0_bist_fail(data)                         ((0x00000008&(data))>>3)
#define  SRNN_SSRS_Bist_3_get_ssrs_4_0_1_bist_fail(data)                         ((0x00000004&(data))>>2)
#define  SRNN_SSRS_Bist_3_get_ssrs_4_0_2_bist_fail(data)                         ((0x00000002&(data))>>1)
#define  SRNN_SSRS_Bist_3_get_ssrs_4_0_3_bist_fail(data)                         (0x00000001&(data))

#ifndef LITTLE_ENDIAN //apply BIG_ENDIAN

//======SRNN register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  srnn_func_en:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  bbbsr_en:2;
        RBus_UInt32  bbbsr_blend_diff_clip1_en:1;
        RBus_UInt32  bbbsr_blend_diff_clip2_en:1;
        RBus_UInt32  bbbsr_blend_diff_clip3_en:1;
        RBus_UInt32  bbbsr_matrix33_select1_en:1;
        RBus_UInt32  bbbsr_matrix33_select2_en:1;
        RBus_UInt32  bbbsr_diff_max_flat_en:1;
        RBus_UInt32  bbbsr_const_dirsu_wt:6;
        RBus_UInt32  bbbsr_var_diff_clip_hith:8;
        RBus_UInt32  bbbsr_var_diff_clip_loth:8;
    };
}srnn_srnn_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  bbbsr_clip_hi_method:2;
        RBus_UInt32  bbbsr_slope_clip1:4;
        RBus_UInt32  bbbsr_min_var_diff_clip_hi_gain:4;
        RBus_UInt32  bbbsr_min_var_diff_clip_hi_min:8;
        RBus_UInt32  bbbsr_min_var_diff_th:8;
        RBus_UInt32  bbbsr_max_min_var_gain:4;
    };
}srnn_diff_clip_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  bbbsr_slope_clip2:8;
        RBus_UInt32  bbbsr_max_var_loth:8;
    };
}srnn_diff_clip2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  bbbsr_slope_clip3_weight:8;
        RBus_UInt32  res2:8;
        RBus_UInt32  bbbsr_slope_clip3:8;
    };
}srnn_diff_clip3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  bbbsr_max_var_loth2:8;
        RBus_UInt32  res1:8;
        RBus_UInt32  bbbsr_slope_weight_var:8;
        RBus_UInt32  bbbsr_dir_confid_loth:8;
    };
}srnn_diff_clip4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:10;
        RBus_UInt32  bbbsr_var_cur_w_loth:6;
        RBus_UInt32  res2:2;
        RBus_UInt32  bbbsr_var_cur_w_hith:6;
        RBus_UInt32  bbbsr_var_cur_loth:8;
    };
}srnn_weight_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  bbbsr_diff_max_flat_gain:4;
        RBus_UInt32  bbbsr_diff_max_flat_coring:8;
    };
}srnn_flat_clip_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  bbbsr_blend_debug_en:1;
        RBus_UInt32  res1:24;
        RBus_UInt32  bbbsr_blend_db_shift_bit:3;
        RBus_UInt32  res2:1;
        RBus_UInt32  bbbsr_blend_debug_mode:3;
    };
}srnn_debug_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy181aa01c_31_20:12;
        RBus_UInt32  bbbsr_dir_confid_len:4;
        RBus_UInt32  res1:3;
        RBus_UInt32  bbbsr_diff_max_select:1;
        RBus_UInt32  bbbsr_diff_delta_coring:8;
        RBus_UInt32  bbbsr_diff_delta_gain:4;
    };
}srnn_diff_gain_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy181aa020_31_13:19;
        RBus_UInt32  bbbsr_delta_y_gain_en:1;
        RBus_UInt32  bbbsr_delta_y_coring:8;
        RBus_UInt32  bbbsr_diff_delta_y_gain:4;
    };
}srnn_diff_gain_y_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  demo_sr_v_sta:13;
        RBus_UInt32  res2:3;
        RBus_UInt32  demo_sr_v_end:13;
    };
}srnn_demo_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  demo_sr_h_sta:13;
        RBus_UInt32  res2:3;
        RBus_UInt32  demo_sr_h_end:13;
    };
}srnn_demo_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  wdsr_y_delta_gain:6;
        RBus_UInt32  wdsr_delta_y_mode:1;
        RBus_UInt32  res1:12;
        RBus_UInt32  sr_linebuf_pixel_delay:13;
    };
}srnn_srnn_blend_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  db_write_hold_cnt:4;
        RBus_UInt32  res2:1;
        RBus_UInt32  db_en:1;
        RBus_UInt32  db_read_level:1;
        RBus_UInt32  db_apply:1;
    };
}srnn_dm_srnn_db_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  bbbsr_dir_weight_dy_en:1;
        RBus_UInt32  bbbsr_dir_weight_dy_gain1:4;
        RBus_UInt32  bbbsr_dir_weight_dy_gain2:4;
        RBus_UInt32  bbbsr_dir_weight_dy_hith:6;
        RBus_UInt32  bbbsr_dir_weight_dy_th:6;
        RBus_UInt32  res1:3;
        RBus_UInt32  bbbsr_dir_weight_dy_loth:8;
    };
}srnn_diff_clip5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  two_step_overflow:1;
        RBus_UInt32  srnn_pre_rd_udf:1;
        RBus_UInt32  smt_rd_conflict_err:1;
        RBus_UInt32  uzu_input_size_err:1;
        RBus_UInt32  srnn2wdsr_h_cnt:12;
        RBus_UInt32  srnn2wdsr_v_cnt:12;
    };
}srnn_srnn_timing_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  wdsr2blend_h_cnt:12;
        RBus_UInt32  res2:4;
        RBus_UInt32  wdsr2blend_v_cnt:12;
    };
}srnn_srnn_timing_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:7;
        RBus_UInt32  two_step_wr_rd_dbg_en:1;
        RBus_UInt32  two_step_wr_line:12;
        RBus_UInt32  two_step_wr_pixel:12;
    };
}srnn_srnn_timing_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  two_tep_rd_line:12;
        RBus_UInt32  two_step_rd_pixel:12;
    };
}srnn_srnn_timing_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  v8_y_c0_1:12;
        RBus_UInt32  res2:4;
        RBus_UInt32  v8_y_c0_0:12;
    };
}srnn_v8_y_ph0_coeff00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  v8_y_c0_3:12;
        RBus_UInt32  res2:4;
        RBus_UInt32  v8_y_c0_2:12;
    };
}srnn_v8_y_ph0_coeff01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  v8_y_c0_5:12;
        RBus_UInt32  res2:4;
        RBus_UInt32  v8_y_c0_4:12;
    };
}srnn_v8_y_ph0_coeff02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  v8_y_c0_7:12;
        RBus_UInt32  res2:4;
        RBus_UInt32  v8_y_c0_6:12;
    };
}srnn_v8_y_ph0_coeff03_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  v8_y_c1_1:12;
        RBus_UInt32  res2:4;
        RBus_UInt32  v8_y_c1_0:12;
    };
}srnn_v8_y_ph1_coeff00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  v8_y_c1_3:12;
        RBus_UInt32  res2:4;
        RBus_UInt32  v8_y_c1_2:12;
    };
}srnn_v8_y_ph1_coeff01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  v8_y_c1_5:12;
        RBus_UInt32  res2:4;
        RBus_UInt32  v8_y_c1_4:12;
    };
}srnn_v8_y_ph1_coeff02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  v8_y_c1_7:12;
        RBus_UInt32  res2:4;
        RBus_UInt32  v8_y_c1_6:12;
    };
}srnn_v8_y_ph1_coeff03_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  cross_bar_en:1;
        RBus_UInt32  ch_sel:1;
        RBus_UInt32  write_en:1;
        RBus_UInt32  read_en:1;
    };
}srnn_accessdata_ctrl_srnn_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  starty:12;
        RBus_UInt32  res2:3;
        RBus_UInt32  startx:13;
    };
}srnn_accessdata_posctrl_srnn_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:6;
        RBus_UInt32  y01:10;
        RBus_UInt32  res2:6;
        RBus_UInt32  y00:10;
    };
}srnn_readdata_data_y1_srnn_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:6;
        RBus_UInt32  y11:10;
        RBus_UInt32  res2:6;
        RBus_UInt32  y10:10;
    };
}srnn_readdata_data_y2_srnn_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:6;
        RBus_UInt32  v00:10;
        RBus_UInt32  res2:6;
        RBus_UInt32  u00:10;
    };
}srnn_readdata_data_c1_srnn_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:6;
        RBus_UInt32  v01:10;
        RBus_UInt32  res2:6;
        RBus_UInt32  u01:10;
    };
}srnn_readdata_data_c2_srnn_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:6;
        RBus_UInt32  v10:10;
        RBus_UInt32  res2:6;
        RBus_UInt32  u10:10;
    };
}srnn_readdata_data_c3_srnn_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:6;
        RBus_UInt32  v11:10;
        RBus_UInt32  res2:6;
        RBus_UInt32  u11:10;
    };
}srnn_readdata_data_c4_srnn_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  v:4;
        RBus_UInt32  u:4;
        RBus_UInt32  y:4;
    };
}srnn_writedata_data_srnn_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer1_weight_00:11;
    };
}srnn_wdsr_layer1_3x3_weights_1_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer1_weight_01:11;
    };
}srnn_wdsr_layer1_3x3_weights_1_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer1_weight_02:11;
    };
}srnn_wdsr_layer1_3x3_weights_1_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer1_weight_10:11;
    };
}srnn_wdsr_layer1_3x3_weights_1_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer1_weight_11:11;
    };
}srnn_wdsr_layer1_3x3_weights_1_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer1_weight_12:11;
    };
}srnn_wdsr_layer1_3x3_weights_1_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer1_weight_20:11;
    };
}srnn_wdsr_layer1_3x3_weights_1_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer1_weight_21:11;
    };
}srnn_wdsr_layer1_3x3_weights_1_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer1_weight_22:11;
    };
}srnn_wdsr_layer1_3x3_weights_1_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer1_weight_00:11;
    };
}srnn_wdsr_layer1_3x3_weights_2_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer1_weight_01:11;
    };
}srnn_wdsr_layer1_3x3_weights_2_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer1_weight_02:11;
    };
}srnn_wdsr_layer1_3x3_weights_2_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer1_weight_10:11;
    };
}srnn_wdsr_layer1_3x3_weights_2_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer1_weight_11:11;
    };
}srnn_wdsr_layer1_3x3_weights_2_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer1_weight_12:11;
    };
}srnn_wdsr_layer1_3x3_weights_2_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer1_weight_20:11;
    };
}srnn_wdsr_layer1_3x3_weights_2_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer1_weight_21:11;
    };
}srnn_wdsr_layer1_3x3_weights_2_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer1_weight_22:11;
    };
}srnn_wdsr_layer1_3x3_weights_2_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer1_weight_00:11;
    };
}srnn_wdsr_layer1_3x3_weights_3_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer1_weight_01:11;
    };
}srnn_wdsr_layer1_3x3_weights_3_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer1_weight_02:11;
    };
}srnn_wdsr_layer1_3x3_weights_3_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer1_weight_10:11;
    };
}srnn_wdsr_layer1_3x3_weights_3_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer1_weight_11:11;
    };
}srnn_wdsr_layer1_3x3_weights_3_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer1_weight_12:11;
    };
}srnn_wdsr_layer1_3x3_weights_3_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer1_weight_20:11;
    };
}srnn_wdsr_layer1_3x3_weights_3_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer1_weight_21:11;
    };
}srnn_wdsr_layer1_3x3_weights_3_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer1_weight_22:11;
    };
}srnn_wdsr_layer1_3x3_weights_3_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer1_weight_00:11;
    };
}srnn_wdsr_layer1_3x3_weights_4_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer1_weight_01:11;
    };
}srnn_wdsr_layer1_3x3_weights_4_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer1_weight_02:11;
    };
}srnn_wdsr_layer1_3x3_weights_4_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer1_weight_10:11;
    };
}srnn_wdsr_layer1_3x3_weights_4_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer1_weight_11:11;
    };
}srnn_wdsr_layer1_3x3_weights_4_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer1_weight_12:11;
    };
}srnn_wdsr_layer1_3x3_weights_4_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer1_weight_20:11;
    };
}srnn_wdsr_layer1_3x3_weights_4_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer1_weight_21:11;
    };
}srnn_wdsr_layer1_3x3_weights_4_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer1_weight_22:11;
    };
}srnn_wdsr_layer1_3x3_weights_4_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer1_weight_00:11;
    };
}srnn_wdsr_layer1_3x3_weights_5_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer1_weight_01:11;
    };
}srnn_wdsr_layer1_3x3_weights_5_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer1_weight_02:11;
    };
}srnn_wdsr_layer1_3x3_weights_5_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer1_weight_10:11;
    };
}srnn_wdsr_layer1_3x3_weights_5_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer1_weight_11:11;
    };
}srnn_wdsr_layer1_3x3_weights_5_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer1_weight_12:11;
    };
}srnn_wdsr_layer1_3x3_weights_5_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer1_weight_20:11;
    };
}srnn_wdsr_layer1_3x3_weights_5_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer1_weight_21:11;
    };
}srnn_wdsr_layer1_3x3_weights_5_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer1_weight_22:11;
    };
}srnn_wdsr_layer1_3x3_weights_5_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer1_weight_00:11;
    };
}srnn_wdsr_layer1_3x3_weights_6_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer1_weight_01:11;
    };
}srnn_wdsr_layer1_3x3_weights_6_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer1_weight_02:11;
    };
}srnn_wdsr_layer1_3x3_weights_6_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer1_weight_10:11;
    };
}srnn_wdsr_layer1_3x3_weights_6_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer1_weight_11:11;
    };
}srnn_wdsr_layer1_3x3_weights_6_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer1_weight_12:11;
    };
}srnn_wdsr_layer1_3x3_weights_6_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer1_weight_20:11;
    };
}srnn_wdsr_layer1_3x3_weights_6_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer1_weight_21:11;
    };
}srnn_wdsr_layer1_3x3_weights_6_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer1_weight_22:11;
    };
}srnn_wdsr_layer1_3x3_weights_6_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer1_weight_00:11;
    };
}srnn_wdsr_layer1_3x3_weights_7_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer1_weight_01:11;
    };
}srnn_wdsr_layer1_3x3_weights_7_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer1_weight_02:11;
    };
}srnn_wdsr_layer1_3x3_weights_7_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer1_weight_10:11;
    };
}srnn_wdsr_layer1_3x3_weights_7_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer1_weight_11:11;
    };
}srnn_wdsr_layer1_3x3_weights_7_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer1_weight_12:11;
    };
}srnn_wdsr_layer1_3x3_weights_7_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer1_weight_20:11;
    };
}srnn_wdsr_layer1_3x3_weights_7_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer1_weight_21:11;
    };
}srnn_wdsr_layer1_3x3_weights_7_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer1_weight_22:11;
    };
}srnn_wdsr_layer1_3x3_weights_7_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer1_weight_00:11;
    };
}srnn_wdsr_layer1_3x3_weights_8_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer1_weight_01:11;
    };
}srnn_wdsr_layer1_3x3_weights_8_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer1_weight_02:11;
    };
}srnn_wdsr_layer1_3x3_weights_8_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer1_weight_10:11;
    };
}srnn_wdsr_layer1_3x3_weights_8_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer1_weight_11:11;
    };
}srnn_wdsr_layer1_3x3_weights_8_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer1_weight_12:11;
    };
}srnn_wdsr_layer1_3x3_weights_8_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer1_weight_20:11;
    };
}srnn_wdsr_layer1_3x3_weights_8_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer1_weight_21:11;
    };
}srnn_wdsr_layer1_3x3_weights_8_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer1_weight_22:11;
    };
}srnn_wdsr_layer1_3x3_weights_8_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:23;
        RBus_UInt32  layer1_bias_1:9;
    };
}srnn_wdsr_layer1_3x3_bias_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:23;
        RBus_UInt32  layer1_bias_2:9;
    };
}srnn_wdsr_layer1_3x3_bias_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:23;
        RBus_UInt32  layer1_bias_3:9;
    };
}srnn_wdsr_layer1_3x3_bias_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:23;
        RBus_UInt32  layer1_bias_4:9;
    };
}srnn_wdsr_layer1_3x3_bias_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:23;
        RBus_UInt32  layer1_bias_5:9;
    };
}srnn_wdsr_layer1_3x3_bias_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:23;
        RBus_UInt32  layer1_bias_6:9;
    };
}srnn_wdsr_layer1_3x3_bias_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:23;
        RBus_UInt32  layer1_bias_7:9;
    };
}srnn_wdsr_layer1_3x3_bias_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:23;
        RBus_UInt32  layer1_bias_8:9;
    };
}srnn_wdsr_layer1_3x3_bias_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer2_weight_00:12;
    };
}srnn_wdsr_layer2_3x3_weights_1_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer2_weight_01:12;
    };
}srnn_wdsr_layer2_3x3_weights_1_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer2_weight_02:12;
    };
}srnn_wdsr_layer2_3x3_weights_1_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer2_weight_10:12;
    };
}srnn_wdsr_layer2_3x3_weights_1_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer2_weight_11:12;
    };
}srnn_wdsr_layer2_3x3_weights_1_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer2_weight_12:12;
    };
}srnn_wdsr_layer2_3x3_weights_1_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer2_weight_20:12;
    };
}srnn_wdsr_layer2_3x3_weights_1_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer2_weight_21:12;
    };
}srnn_wdsr_layer2_3x3_weights_1_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer2_weight_22:12;
    };
}srnn_wdsr_layer2_3x3_weights_1_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer2_weight_00:12;
    };
}srnn_wdsr_layer2_3x3_weights_2_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer2_weight_01:12;
    };
}srnn_wdsr_layer2_3x3_weights_2_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer2_weight_02:12;
    };
}srnn_wdsr_layer2_3x3_weights_2_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer2_weight_10:12;
    };
}srnn_wdsr_layer2_3x3_weights_2_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer2_weight_11:12;
    };
}srnn_wdsr_layer2_3x3_weights_2_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer2_weight_12:12;
    };
}srnn_wdsr_layer2_3x3_weights_2_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer2_weight_20:12;
    };
}srnn_wdsr_layer2_3x3_weights_2_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer2_weight_21:12;
    };
}srnn_wdsr_layer2_3x3_weights_2_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer2_weight_22:12;
    };
}srnn_wdsr_layer2_3x3_weights_2_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer2_weight_00:12;
    };
}srnn_wdsr_layer2_3x3_weights_3_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer2_weight_01:12;
    };
}srnn_wdsr_layer2_3x3_weights_3_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer2_weight_02:12;
    };
}srnn_wdsr_layer2_3x3_weights_3_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer2_weight_10:12;
    };
}srnn_wdsr_layer2_3x3_weights_3_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer2_weight_11:12;
    };
}srnn_wdsr_layer2_3x3_weights_3_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer2_weight_12:12;
    };
}srnn_wdsr_layer2_3x3_weights_3_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer2_weight_20:12;
    };
}srnn_wdsr_layer2_3x3_weights_3_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer2_weight_21:12;
    };
}srnn_wdsr_layer2_3x3_weights_3_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer2_weight_22:12;
    };
}srnn_wdsr_layer2_3x3_weights_3_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer2_weight_00:12;
    };
}srnn_wdsr_layer2_3x3_weights_4_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer2_weight_01:12;
    };
}srnn_wdsr_layer2_3x3_weights_4_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer2_weight_02:12;
    };
}srnn_wdsr_layer2_3x3_weights_4_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer2_weight_10:12;
    };
}srnn_wdsr_layer2_3x3_weights_4_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer2_weight_11:12;
    };
}srnn_wdsr_layer2_3x3_weights_4_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer2_weight_12:12;
    };
}srnn_wdsr_layer2_3x3_weights_4_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer2_weight_20:12;
    };
}srnn_wdsr_layer2_3x3_weights_4_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer2_weight_21:12;
    };
}srnn_wdsr_layer2_3x3_weights_4_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer2_weight_22:12;
    };
}srnn_wdsr_layer2_3x3_weights_4_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer2_weight_00:12;
    };
}srnn_wdsr_layer2_3x3_weights_5_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer2_weight_01:12;
    };
}srnn_wdsr_layer2_3x3_weights_5_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer2_weight_02:12;
    };
}srnn_wdsr_layer2_3x3_weights_5_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer2_weight_10:12;
    };
}srnn_wdsr_layer2_3x3_weights_5_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer2_weight_11:12;
    };
}srnn_wdsr_layer2_3x3_weights_5_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer2_weight_12:12;
    };
}srnn_wdsr_layer2_3x3_weights_5_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer2_weight_20:12;
    };
}srnn_wdsr_layer2_3x3_weights_5_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer2_weight_21:12;
    };
}srnn_wdsr_layer2_3x3_weights_5_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer2_weight_22:12;
    };
}srnn_wdsr_layer2_3x3_weights_5_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer2_weight_00:12;
    };
}srnn_wdsr_layer2_3x3_weights_6_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer2_weight_01:12;
    };
}srnn_wdsr_layer2_3x3_weights_6_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer2_weight_02:12;
    };
}srnn_wdsr_layer2_3x3_weights_6_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer2_weight_10:12;
    };
}srnn_wdsr_layer2_3x3_weights_6_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer2_weight_11:12;
    };
}srnn_wdsr_layer2_3x3_weights_6_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer2_weight_12:12;
    };
}srnn_wdsr_layer2_3x3_weights_6_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer2_weight_20:12;
    };
}srnn_wdsr_layer2_3x3_weights_6_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer2_weight_21:12;
    };
}srnn_wdsr_layer2_3x3_weights_6_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer2_weight_22:12;
    };
}srnn_wdsr_layer2_3x3_weights_6_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer2_weight_00:12;
    };
}srnn_wdsr_layer2_3x3_weights_7_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer2_weight_01:12;
    };
}srnn_wdsr_layer2_3x3_weights_7_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer2_weight_02:12;
    };
}srnn_wdsr_layer2_3x3_weights_7_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer2_weight_10:12;
    };
}srnn_wdsr_layer2_3x3_weights_7_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer2_weight_11:12;
    };
}srnn_wdsr_layer2_3x3_weights_7_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer2_weight_12:12;
    };
}srnn_wdsr_layer2_3x3_weights_7_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer2_weight_20:12;
    };
}srnn_wdsr_layer2_3x3_weights_7_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer2_weight_21:12;
    };
}srnn_wdsr_layer2_3x3_weights_7_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer2_weight_22:12;
    };
}srnn_wdsr_layer2_3x3_weights_7_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer2_weight_00:12;
    };
}srnn_wdsr_layer2_3x3_weights_8_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer2_weight_01:12;
    };
}srnn_wdsr_layer2_3x3_weights_8_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer2_weight_02:12;
    };
}srnn_wdsr_layer2_3x3_weights_8_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer2_weight_10:12;
    };
}srnn_wdsr_layer2_3x3_weights_8_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer2_weight_11:12;
    };
}srnn_wdsr_layer2_3x3_weights_8_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer2_weight_12:12;
    };
}srnn_wdsr_layer2_3x3_weights_8_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer2_weight_20:12;
    };
}srnn_wdsr_layer2_3x3_weights_8_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer2_weight_21:12;
    };
}srnn_wdsr_layer2_3x3_weights_8_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer2_weight_22:12;
    };
}srnn_wdsr_layer2_3x3_weights_8_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:23;
        RBus_UInt32  layer2_bias_1:9;
    };
}srnn_wdsr_layer2_3x3_bias_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:23;
        RBus_UInt32  layer2_bias_2:9;
    };
}srnn_wdsr_layer2_3x3_bias_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:23;
        RBus_UInt32  layer2_bias_3:9;
    };
}srnn_wdsr_layer2_3x3_bias_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:23;
        RBus_UInt32  layer2_bias_4:9;
    };
}srnn_wdsr_layer2_3x3_bias_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:23;
        RBus_UInt32  layer2_bias_5:9;
    };
}srnn_wdsr_layer2_3x3_bias_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:23;
        RBus_UInt32  layer2_bias_6:9;
    };
}srnn_wdsr_layer2_3x3_bias_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:23;
        RBus_UInt32  layer2_bias_7:9;
    };
}srnn_wdsr_layer2_3x3_bias_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:23;
        RBus_UInt32  layer2_bias_8:9;
    };
}srnn_wdsr_layer2_3x3_bias_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_1:11;
    };
}srnn_wdsr_layer2_1x1_weights_1_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_2:11;
    };
}srnn_wdsr_layer2_1x1_weights_1_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_3:11;
    };
}srnn_wdsr_layer2_1x1_weights_1_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_4:11;
    };
}srnn_wdsr_layer2_1x1_weights_1_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_5:11;
    };
}srnn_wdsr_layer2_1x1_weights_1_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_6:11;
    };
}srnn_wdsr_layer2_1x1_weights_1_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_7:11;
    };
}srnn_wdsr_layer2_1x1_weights_1_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_8:11;
    };
}srnn_wdsr_layer2_1x1_weights_1_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_1:11;
    };
}srnn_wdsr_layer2_1x1_weights_2_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_2:11;
    };
}srnn_wdsr_layer2_1x1_weights_2_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_3:11;
    };
}srnn_wdsr_layer2_1x1_weights_2_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_4:11;
    };
}srnn_wdsr_layer2_1x1_weights_2_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_5:11;
    };
}srnn_wdsr_layer2_1x1_weights_2_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_6:11;
    };
}srnn_wdsr_layer2_1x1_weights_2_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_7:11;
    };
}srnn_wdsr_layer2_1x1_weights_2_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_8:11;
    };
}srnn_wdsr_layer2_1x1_weights_2_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_1:11;
    };
}srnn_wdsr_layer2_1x1_weights_3_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_2:11;
    };
}srnn_wdsr_layer2_1x1_weights_3_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_3:11;
    };
}srnn_wdsr_layer2_1x1_weights_3_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_4:11;
    };
}srnn_wdsr_layer2_1x1_weights_3_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_5:11;
    };
}srnn_wdsr_layer2_1x1_weights_3_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_6:11;
    };
}srnn_wdsr_layer2_1x1_weights_3_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_7:11;
    };
}srnn_wdsr_layer2_1x1_weights_3_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_8:11;
    };
}srnn_wdsr_layer2_1x1_weights_3_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_1:11;
    };
}srnn_wdsr_layer2_1x1_weights_4_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_2:11;
    };
}srnn_wdsr_layer2_1x1_weights_4_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_3:11;
    };
}srnn_wdsr_layer2_1x1_weights_4_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_4:11;
    };
}srnn_wdsr_layer2_1x1_weights_4_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_5:11;
    };
}srnn_wdsr_layer2_1x1_weights_4_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_6:11;
    };
}srnn_wdsr_layer2_1x1_weights_4_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_7:11;
    };
}srnn_wdsr_layer2_1x1_weights_4_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_8:11;
    };
}srnn_wdsr_layer2_1x1_weights_4_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_1:11;
    };
}srnn_wdsr_layer2_1x1_weights_5_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_2:11;
    };
}srnn_wdsr_layer2_1x1_weights_5_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_3:11;
    };
}srnn_wdsr_layer2_1x1_weights_5_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_4:11;
    };
}srnn_wdsr_layer2_1x1_weights_5_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_5:11;
    };
}srnn_wdsr_layer2_1x1_weights_5_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_6:11;
    };
}srnn_wdsr_layer2_1x1_weights_5_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_7:11;
    };
}srnn_wdsr_layer2_1x1_weights_5_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_8:11;
    };
}srnn_wdsr_layer2_1x1_weights_5_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_1:11;
    };
}srnn_wdsr_layer2_1x1_weights_6_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_2:11;
    };
}srnn_wdsr_layer2_1x1_weights_6_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_3:11;
    };
}srnn_wdsr_layer2_1x1_weights_6_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_4:11;
    };
}srnn_wdsr_layer2_1x1_weights_6_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_5:11;
    };
}srnn_wdsr_layer2_1x1_weights_6_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_6:11;
    };
}srnn_wdsr_layer2_1x1_weights_6_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_7:11;
    };
}srnn_wdsr_layer2_1x1_weights_6_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_8:11;
    };
}srnn_wdsr_layer2_1x1_weights_6_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_1:11;
    };
}srnn_wdsr_layer2_1x1_weights_7_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_2:11;
    };
}srnn_wdsr_layer2_1x1_weights_7_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_3:11;
    };
}srnn_wdsr_layer2_1x1_weights_7_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_4:11;
    };
}srnn_wdsr_layer2_1x1_weights_7_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_5:11;
    };
}srnn_wdsr_layer2_1x1_weights_7_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_6:11;
    };
}srnn_wdsr_layer2_1x1_weights_7_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_7:11;
    };
}srnn_wdsr_layer2_1x1_weights_7_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_8:11;
    };
}srnn_wdsr_layer2_1x1_weights_7_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_1:11;
    };
}srnn_wdsr_layer2_1x1_weights_8_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_2:11;
    };
}srnn_wdsr_layer2_1x1_weights_8_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_3:11;
    };
}srnn_wdsr_layer2_1x1_weights_8_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_4:11;
    };
}srnn_wdsr_layer2_1x1_weights_8_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_5:11;
    };
}srnn_wdsr_layer2_1x1_weights_8_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_6:11;
    };
}srnn_wdsr_layer2_1x1_weights_8_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_7:11;
    };
}srnn_wdsr_layer2_1x1_weights_8_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_8:11;
    };
}srnn_wdsr_layer2_1x1_weights_8_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_1:11;
    };
}srnn_wdsr_layer2_1x1_weights_9_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_2:11;
    };
}srnn_wdsr_layer2_1x1_weights_9_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_3:11;
    };
}srnn_wdsr_layer2_1x1_weights_9_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_4:11;
    };
}srnn_wdsr_layer2_1x1_weights_9_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_5:11;
    };
}srnn_wdsr_layer2_1x1_weights_9_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_6:11;
    };
}srnn_wdsr_layer2_1x1_weights_9_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_7:11;
    };
}srnn_wdsr_layer2_1x1_weights_9_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_8:11;
    };
}srnn_wdsr_layer2_1x1_weights_9_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_1:11;
    };
}srnn_wdsr_layer2_1x1_weights_10_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_2:11;
    };
}srnn_wdsr_layer2_1x1_weights_10_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_3:11;
    };
}srnn_wdsr_layer2_1x1_weights_10_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_4:11;
    };
}srnn_wdsr_layer2_1x1_weights_10_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_5:11;
    };
}srnn_wdsr_layer2_1x1_weights_10_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_6:11;
    };
}srnn_wdsr_layer2_1x1_weights_10_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_7:11;
    };
}srnn_wdsr_layer2_1x1_weights_10_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_8:11;
    };
}srnn_wdsr_layer2_1x1_weights_10_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_1:11;
    };
}srnn_wdsr_layer2_1x1_weights_11_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_2:11;
    };
}srnn_wdsr_layer2_1x1_weights_11_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_3:11;
    };
}srnn_wdsr_layer2_1x1_weights_11_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_4:11;
    };
}srnn_wdsr_layer2_1x1_weights_11_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_5:11;
    };
}srnn_wdsr_layer2_1x1_weights_11_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_6:11;
    };
}srnn_wdsr_layer2_1x1_weights_11_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_7:11;
    };
}srnn_wdsr_layer2_1x1_weights_11_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_8:11;
    };
}srnn_wdsr_layer2_1x1_weights_11_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_1:11;
    };
}srnn_wdsr_layer2_1x1_weights_12_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_2:11;
    };
}srnn_wdsr_layer2_1x1_weights_12_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_3:11;
    };
}srnn_wdsr_layer2_1x1_weights_12_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_4:11;
    };
}srnn_wdsr_layer2_1x1_weights_12_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_5:11;
    };
}srnn_wdsr_layer2_1x1_weights_12_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_6:11;
    };
}srnn_wdsr_layer2_1x1_weights_12_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_7:11;
    };
}srnn_wdsr_layer2_1x1_weights_12_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_8:11;
    };
}srnn_wdsr_layer2_1x1_weights_12_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_1:11;
    };
}srnn_wdsr_layer2_1x1_weights_13_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_2:11;
    };
}srnn_wdsr_layer2_1x1_weights_13_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_3:11;
    };
}srnn_wdsr_layer2_1x1_weights_13_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_4:11;
    };
}srnn_wdsr_layer2_1x1_weights_13_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_5:11;
    };
}srnn_wdsr_layer2_1x1_weights_13_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_6:11;
    };
}srnn_wdsr_layer2_1x1_weights_13_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_7:11;
    };
}srnn_wdsr_layer2_1x1_weights_13_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_8:11;
    };
}srnn_wdsr_layer2_1x1_weights_13_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_1:11;
    };
}srnn_wdsr_layer2_1x1_weights_14_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_2:11;
    };
}srnn_wdsr_layer2_1x1_weights_14_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_3:11;
    };
}srnn_wdsr_layer2_1x1_weights_14_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_4:11;
    };
}srnn_wdsr_layer2_1x1_weights_14_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_5:11;
    };
}srnn_wdsr_layer2_1x1_weights_14_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_6:11;
    };
}srnn_wdsr_layer2_1x1_weights_14_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_7:11;
    };
}srnn_wdsr_layer2_1x1_weights_14_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_8:11;
    };
}srnn_wdsr_layer2_1x1_weights_14_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_1:11;
    };
}srnn_wdsr_layer2_1x1_weights_15_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_2:11;
    };
}srnn_wdsr_layer2_1x1_weights_15_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_3:11;
    };
}srnn_wdsr_layer2_1x1_weights_15_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_4:11;
    };
}srnn_wdsr_layer2_1x1_weights_15_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_5:11;
    };
}srnn_wdsr_layer2_1x1_weights_15_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_6:11;
    };
}srnn_wdsr_layer2_1x1_weights_15_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_7:11;
    };
}srnn_wdsr_layer2_1x1_weights_15_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_8:11;
    };
}srnn_wdsr_layer2_1x1_weights_15_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_1:11;
    };
}srnn_wdsr_layer2_1x1_weights_16_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_2:11;
    };
}srnn_wdsr_layer2_1x1_weights_16_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_3:11;
    };
}srnn_wdsr_layer2_1x1_weights_16_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_4:11;
    };
}srnn_wdsr_layer2_1x1_weights_16_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_5:11;
    };
}srnn_wdsr_layer2_1x1_weights_16_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_6:11;
    };
}srnn_wdsr_layer2_1x1_weights_16_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_7:11;
    };
}srnn_wdsr_layer2_1x1_weights_16_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_8:11;
    };
}srnn_wdsr_layer2_1x1_weights_16_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_1:11;
    };
}srnn_wdsr_layer2_1x1_weights_17_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_2:11;
    };
}srnn_wdsr_layer2_1x1_weights_17_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_3:11;
    };
}srnn_wdsr_layer2_1x1_weights_17_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_4:11;
    };
}srnn_wdsr_layer2_1x1_weights_17_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_5:11;
    };
}srnn_wdsr_layer2_1x1_weights_17_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_6:11;
    };
}srnn_wdsr_layer2_1x1_weights_17_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_7:11;
    };
}srnn_wdsr_layer2_1x1_weights_17_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_8:11;
    };
}srnn_wdsr_layer2_1x1_weights_17_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_1:11;
    };
}srnn_wdsr_layer2_1x1_weights_18_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_2:11;
    };
}srnn_wdsr_layer2_1x1_weights_18_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_3:11;
    };
}srnn_wdsr_layer2_1x1_weights_18_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_4:11;
    };
}srnn_wdsr_layer2_1x1_weights_18_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_5:11;
    };
}srnn_wdsr_layer2_1x1_weights_18_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_6:11;
    };
}srnn_wdsr_layer2_1x1_weights_18_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_7:11;
    };
}srnn_wdsr_layer2_1x1_weights_18_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_8:11;
    };
}srnn_wdsr_layer2_1x1_weights_18_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_1:11;
    };
}srnn_wdsr_layer2_1x1_weights_19_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_2:11;
    };
}srnn_wdsr_layer2_1x1_weights_19_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_3:11;
    };
}srnn_wdsr_layer2_1x1_weights_19_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_4:11;
    };
}srnn_wdsr_layer2_1x1_weights_19_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_5:11;
    };
}srnn_wdsr_layer2_1x1_weights_19_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_6:11;
    };
}srnn_wdsr_layer2_1x1_weights_19_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_7:11;
    };
}srnn_wdsr_layer2_1x1_weights_19_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_8:11;
    };
}srnn_wdsr_layer2_1x1_weights_19_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_1:11;
    };
}srnn_wdsr_layer2_1x1_weights_20_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_2:11;
    };
}srnn_wdsr_layer2_1x1_weights_20_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_3:11;
    };
}srnn_wdsr_layer2_1x1_weights_20_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_4:11;
    };
}srnn_wdsr_layer2_1x1_weights_20_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_5:11;
    };
}srnn_wdsr_layer2_1x1_weights_20_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_6:11;
    };
}srnn_wdsr_layer2_1x1_weights_20_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_7:11;
    };
}srnn_wdsr_layer2_1x1_weights_20_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_8:11;
    };
}srnn_wdsr_layer2_1x1_weights_20_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_1:11;
    };
}srnn_wdsr_layer2_1x1_weights_21_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_2:11;
    };
}srnn_wdsr_layer2_1x1_weights_21_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_3:11;
    };
}srnn_wdsr_layer2_1x1_weights_21_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_4:11;
    };
}srnn_wdsr_layer2_1x1_weights_21_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_5:11;
    };
}srnn_wdsr_layer2_1x1_weights_21_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_6:11;
    };
}srnn_wdsr_layer2_1x1_weights_21_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_7:11;
    };
}srnn_wdsr_layer2_1x1_weights_21_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_8:11;
    };
}srnn_wdsr_layer2_1x1_weights_21_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_1:11;
    };
}srnn_wdsr_layer2_1x1_weights_22_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_2:11;
    };
}srnn_wdsr_layer2_1x1_weights_22_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_3:11;
    };
}srnn_wdsr_layer2_1x1_weights_22_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_4:11;
    };
}srnn_wdsr_layer2_1x1_weights_22_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_5:11;
    };
}srnn_wdsr_layer2_1x1_weights_22_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_6:11;
    };
}srnn_wdsr_layer2_1x1_weights_22_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_7:11;
    };
}srnn_wdsr_layer2_1x1_weights_22_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_8:11;
    };
}srnn_wdsr_layer2_1x1_weights_22_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_1:11;
    };
}srnn_wdsr_layer2_1x1_weights_23_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_2:11;
    };
}srnn_wdsr_layer2_1x1_weights_23_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_3:11;
    };
}srnn_wdsr_layer2_1x1_weights_23_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_4:11;
    };
}srnn_wdsr_layer2_1x1_weights_23_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_5:11;
    };
}srnn_wdsr_layer2_1x1_weights_23_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_6:11;
    };
}srnn_wdsr_layer2_1x1_weights_23_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_7:11;
    };
}srnn_wdsr_layer2_1x1_weights_23_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_8:11;
    };
}srnn_wdsr_layer2_1x1_weights_23_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_1:11;
    };
}srnn_wdsr_layer2_1x1_weights_24_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_2:11;
    };
}srnn_wdsr_layer2_1x1_weights_24_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_3:11;
    };
}srnn_wdsr_layer2_1x1_weights_24_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_4:11;
    };
}srnn_wdsr_layer2_1x1_weights_24_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_5:11;
    };
}srnn_wdsr_layer2_1x1_weights_24_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_6:11;
    };
}srnn_wdsr_layer2_1x1_weights_24_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_7:11;
    };
}srnn_wdsr_layer2_1x1_weights_24_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_8:11;
    };
}srnn_wdsr_layer2_1x1_weights_24_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_1:11;
    };
}srnn_wdsr_layer2_1x1_weights_25_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_2:11;
    };
}srnn_wdsr_layer2_1x1_weights_25_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_3:11;
    };
}srnn_wdsr_layer2_1x1_weights_25_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_4:11;
    };
}srnn_wdsr_layer2_1x1_weights_25_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_5:11;
    };
}srnn_wdsr_layer2_1x1_weights_25_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_6:11;
    };
}srnn_wdsr_layer2_1x1_weights_25_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_7:11;
    };
}srnn_wdsr_layer2_1x1_weights_25_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_8:11;
    };
}srnn_wdsr_layer2_1x1_weights_25_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_1:11;
    };
}srnn_wdsr_layer2_1x1_weights_26_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_2:11;
    };
}srnn_wdsr_layer2_1x1_weights_26_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_3:11;
    };
}srnn_wdsr_layer2_1x1_weights_26_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_4:11;
    };
}srnn_wdsr_layer2_1x1_weights_26_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_5:11;
    };
}srnn_wdsr_layer2_1x1_weights_26_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_6:11;
    };
}srnn_wdsr_layer2_1x1_weights_26_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_7:11;
    };
}srnn_wdsr_layer2_1x1_weights_26_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_8:11;
    };
}srnn_wdsr_layer2_1x1_weights_26_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_1:11;
    };
}srnn_wdsr_layer2_1x1_weights_27_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_2:11;
    };
}srnn_wdsr_layer2_1x1_weights_27_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_3:11;
    };
}srnn_wdsr_layer2_1x1_weights_27_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_4:11;
    };
}srnn_wdsr_layer2_1x1_weights_27_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_5:11;
    };
}srnn_wdsr_layer2_1x1_weights_27_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_6:11;
    };
}srnn_wdsr_layer2_1x1_weights_27_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_7:11;
    };
}srnn_wdsr_layer2_1x1_weights_27_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_8:11;
    };
}srnn_wdsr_layer2_1x1_weights_27_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_1:11;
    };
}srnn_wdsr_layer2_1x1_weights_28_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_2:11;
    };
}srnn_wdsr_layer2_1x1_weights_28_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_3:11;
    };
}srnn_wdsr_layer2_1x1_weights_28_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_4:11;
    };
}srnn_wdsr_layer2_1x1_weights_28_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_5:11;
    };
}srnn_wdsr_layer2_1x1_weights_28_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_6:11;
    };
}srnn_wdsr_layer2_1x1_weights_28_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_7:11;
    };
}srnn_wdsr_layer2_1x1_weights_28_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_8:11;
    };
}srnn_wdsr_layer2_1x1_weights_28_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_1:11;
    };
}srnn_wdsr_layer2_1x1_weights_29_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_2:11;
    };
}srnn_wdsr_layer2_1x1_weights_29_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_3:11;
    };
}srnn_wdsr_layer2_1x1_weights_29_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_4:11;
    };
}srnn_wdsr_layer2_1x1_weights_29_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_5:11;
    };
}srnn_wdsr_layer2_1x1_weights_29_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_6:11;
    };
}srnn_wdsr_layer2_1x1_weights_29_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_7:11;
    };
}srnn_wdsr_layer2_1x1_weights_29_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_8:11;
    };
}srnn_wdsr_layer2_1x1_weights_29_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_1:11;
    };
}srnn_wdsr_layer2_1x1_weights_30_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_2:11;
    };
}srnn_wdsr_layer2_1x1_weights_30_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_3:11;
    };
}srnn_wdsr_layer2_1x1_weights_30_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_4:11;
    };
}srnn_wdsr_layer2_1x1_weights_30_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_5:11;
    };
}srnn_wdsr_layer2_1x1_weights_30_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_6:11;
    };
}srnn_wdsr_layer2_1x1_weights_30_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_7:11;
    };
}srnn_wdsr_layer2_1x1_weights_30_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_8:11;
    };
}srnn_wdsr_layer2_1x1_weights_30_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_1:11;
    };
}srnn_wdsr_layer2_1x1_weights_31_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_2:11;
    };
}srnn_wdsr_layer2_1x1_weights_31_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_3:11;
    };
}srnn_wdsr_layer2_1x1_weights_31_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_4:11;
    };
}srnn_wdsr_layer2_1x1_weights_31_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_5:11;
    };
}srnn_wdsr_layer2_1x1_weights_31_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_6:11;
    };
}srnn_wdsr_layer2_1x1_weights_31_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_7:11;
    };
}srnn_wdsr_layer2_1x1_weights_31_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_8:11;
    };
}srnn_wdsr_layer2_1x1_weights_31_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_1:11;
    };
}srnn_wdsr_layer2_1x1_weights_32_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_2:11;
    };
}srnn_wdsr_layer2_1x1_weights_32_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_3:11;
    };
}srnn_wdsr_layer2_1x1_weights_32_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_4:11;
    };
}srnn_wdsr_layer2_1x1_weights_32_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_5:11;
    };
}srnn_wdsr_layer2_1x1_weights_32_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_6:11;
    };
}srnn_wdsr_layer2_1x1_weights_32_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_7:11;
    };
}srnn_wdsr_layer2_1x1_weights_32_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_weight_8:11;
    };
}srnn_wdsr_layer2_1x1_weights_32_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_bias_1:11;
    };
}srnn_wdsr_layer2_1x1_bias_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_bias_2:11;
    };
}srnn_wdsr_layer2_1x1_bias_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_bias_3:11;
    };
}srnn_wdsr_layer2_1x1_bias_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_bias_4:11;
    };
}srnn_wdsr_layer2_1x1_bias_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_bias_5:11;
    };
}srnn_wdsr_layer2_1x1_bias_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_bias_6:11;
    };
}srnn_wdsr_layer2_1x1_bias_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_bias_7:11;
    };
}srnn_wdsr_layer2_1x1_bias_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_bias_8:11;
    };
}srnn_wdsr_layer2_1x1_bias_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_bias_9:11;
    };
}srnn_wdsr_layer2_1x1_bias_9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_bias_10:11;
    };
}srnn_wdsr_layer2_1x1_bias_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_bias_11:11;
    };
}srnn_wdsr_layer2_1x1_bias_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_bias_12:11;
    };
}srnn_wdsr_layer2_1x1_bias_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_bias_13:11;
    };
}srnn_wdsr_layer2_1x1_bias_13_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_bias_14:11;
    };
}srnn_wdsr_layer2_1x1_bias_14_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_bias_15:11;
    };
}srnn_wdsr_layer2_1x1_bias_15_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_bias_16:11;
    };
}srnn_wdsr_layer2_1x1_bias_16_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_bias_17:11;
    };
}srnn_wdsr_layer2_1x1_bias_17_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_bias_18:11;
    };
}srnn_wdsr_layer2_1x1_bias_18_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_bias_19:11;
    };
}srnn_wdsr_layer2_1x1_bias_19_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_bias_20:11;
    };
}srnn_wdsr_layer2_1x1_bias_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_bias_21:11;
    };
}srnn_wdsr_layer2_1x1_bias_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_bias_22:11;
    };
}srnn_wdsr_layer2_1x1_bias_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_bias_23:11;
    };
}srnn_wdsr_layer2_1x1_bias_23_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_bias_24:11;
    };
}srnn_wdsr_layer2_1x1_bias_24_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_bias_25:11;
    };
}srnn_wdsr_layer2_1x1_bias_25_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_bias_26:11;
    };
}srnn_wdsr_layer2_1x1_bias_26_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_bias_27:11;
    };
}srnn_wdsr_layer2_1x1_bias_27_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_bias_28:11;
    };
}srnn_wdsr_layer2_1x1_bias_28_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_bias_29:11;
    };
}srnn_wdsr_layer2_1x1_bias_29_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_bias_30:11;
    };
}srnn_wdsr_layer2_1x1_bias_30_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_bias_31:11;
    };
}srnn_wdsr_layer2_1x1_bias_31_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  layer2_bias_32:11;
    };
}srnn_wdsr_layer2_1x1_bias_32_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_00:12;
    };
}srnn_wdsr_layer3_3x3_weights_1_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_01:12;
    };
}srnn_wdsr_layer3_3x3_weights_1_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_02:12;
    };
}srnn_wdsr_layer3_3x3_weights_1_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_10:12;
    };
}srnn_wdsr_layer3_3x3_weights_1_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_11:12;
    };
}srnn_wdsr_layer3_3x3_weights_1_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_12:12;
    };
}srnn_wdsr_layer3_3x3_weights_1_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_20:12;
    };
}srnn_wdsr_layer3_3x3_weights_1_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_21:12;
    };
}srnn_wdsr_layer3_3x3_weights_1_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_22:12;
    };
}srnn_wdsr_layer3_3x3_weights_1_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_00:12;
    };
}srnn_wdsr_layer3_3x3_weights_2_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_01:12;
    };
}srnn_wdsr_layer3_3x3_weights_2_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_02:12;
    };
}srnn_wdsr_layer3_3x3_weights_2_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_10:12;
    };
}srnn_wdsr_layer3_3x3_weights_2_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_11:12;
    };
}srnn_wdsr_layer3_3x3_weights_2_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_12:12;
    };
}srnn_wdsr_layer3_3x3_weights_2_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_20:12;
    };
}srnn_wdsr_layer3_3x3_weights_2_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_21:12;
    };
}srnn_wdsr_layer3_3x3_weights_2_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_22:12;
    };
}srnn_wdsr_layer3_3x3_weights_2_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_00:12;
    };
}srnn_wdsr_layer3_3x3_weights_3_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_01:12;
    };
}srnn_wdsr_layer3_3x3_weights_3_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_02:12;
    };
}srnn_wdsr_layer3_3x3_weights_3_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_10:12;
    };
}srnn_wdsr_layer3_3x3_weights_3_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_11:12;
    };
}srnn_wdsr_layer3_3x3_weights_3_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_12:12;
    };
}srnn_wdsr_layer3_3x3_weights_3_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_20:12;
    };
}srnn_wdsr_layer3_3x3_weights_3_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_21:12;
    };
}srnn_wdsr_layer3_3x3_weights_3_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_22:12;
    };
}srnn_wdsr_layer3_3x3_weights_3_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_00:12;
    };
}srnn_wdsr_layer3_3x3_weights_4_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_01:12;
    };
}srnn_wdsr_layer3_3x3_weights_4_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_02:12;
    };
}srnn_wdsr_layer3_3x3_weights_4_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_10:12;
    };
}srnn_wdsr_layer3_3x3_weights_4_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_11:12;
    };
}srnn_wdsr_layer3_3x3_weights_4_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_12:12;
    };
}srnn_wdsr_layer3_3x3_weights_4_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_20:12;
    };
}srnn_wdsr_layer3_3x3_weights_4_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_21:12;
    };
}srnn_wdsr_layer3_3x3_weights_4_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_22:12;
    };
}srnn_wdsr_layer3_3x3_weights_4_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_00:12;
    };
}srnn_wdsr_layer3_3x3_weights_5_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_01:12;
    };
}srnn_wdsr_layer3_3x3_weights_5_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_02:12;
    };
}srnn_wdsr_layer3_3x3_weights_5_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_10:12;
    };
}srnn_wdsr_layer3_3x3_weights_5_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_11:12;
    };
}srnn_wdsr_layer3_3x3_weights_5_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_12:12;
    };
}srnn_wdsr_layer3_3x3_weights_5_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_20:12;
    };
}srnn_wdsr_layer3_3x3_weights_5_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_21:12;
    };
}srnn_wdsr_layer3_3x3_weights_5_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_22:12;
    };
}srnn_wdsr_layer3_3x3_weights_5_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_00:12;
    };
}srnn_wdsr_layer3_3x3_weights_6_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_01:12;
    };
}srnn_wdsr_layer3_3x3_weights_6_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_02:12;
    };
}srnn_wdsr_layer3_3x3_weights_6_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_10:12;
    };
}srnn_wdsr_layer3_3x3_weights_6_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_11:12;
    };
}srnn_wdsr_layer3_3x3_weights_6_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_12:12;
    };
}srnn_wdsr_layer3_3x3_weights_6_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_20:12;
    };
}srnn_wdsr_layer3_3x3_weights_6_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_21:12;
    };
}srnn_wdsr_layer3_3x3_weights_6_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_22:12;
    };
}srnn_wdsr_layer3_3x3_weights_6_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_00:12;
    };
}srnn_wdsr_layer3_3x3_weights_7_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_01:12;
    };
}srnn_wdsr_layer3_3x3_weights_7_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_02:12;
    };
}srnn_wdsr_layer3_3x3_weights_7_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_10:12;
    };
}srnn_wdsr_layer3_3x3_weights_7_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_11:12;
    };
}srnn_wdsr_layer3_3x3_weights_7_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_12:12;
    };
}srnn_wdsr_layer3_3x3_weights_7_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_20:12;
    };
}srnn_wdsr_layer3_3x3_weights_7_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_21:12;
    };
}srnn_wdsr_layer3_3x3_weights_7_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_22:12;
    };
}srnn_wdsr_layer3_3x3_weights_7_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_00:12;
    };
}srnn_wdsr_layer3_3x3_weights_8_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_01:12;
    };
}srnn_wdsr_layer3_3x3_weights_8_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_02:12;
    };
}srnn_wdsr_layer3_3x3_weights_8_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_10:12;
    };
}srnn_wdsr_layer3_3x3_weights_8_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_11:12;
    };
}srnn_wdsr_layer3_3x3_weights_8_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_12:12;
    };
}srnn_wdsr_layer3_3x3_weights_8_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_20:12;
    };
}srnn_wdsr_layer3_3x3_weights_8_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_21:12;
    };
}srnn_wdsr_layer3_3x3_weights_8_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_22:12;
    };
}srnn_wdsr_layer3_3x3_weights_8_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_00:12;
    };
}srnn_wdsr_layer3_3x3_weights_9_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_01:12;
    };
}srnn_wdsr_layer3_3x3_weights_9_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_02:12;
    };
}srnn_wdsr_layer3_3x3_weights_9_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_10:12;
    };
}srnn_wdsr_layer3_3x3_weights_9_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_11:12;
    };
}srnn_wdsr_layer3_3x3_weights_9_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_12:12;
    };
}srnn_wdsr_layer3_3x3_weights_9_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_20:12;
    };
}srnn_wdsr_layer3_3x3_weights_9_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_21:12;
    };
}srnn_wdsr_layer3_3x3_weights_9_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_22:12;
    };
}srnn_wdsr_layer3_3x3_weights_9_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_00:12;
    };
}srnn_wdsr_layer3_3x3_weights_10_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_01:12;
    };
}srnn_wdsr_layer3_3x3_weights_10_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_02:12;
    };
}srnn_wdsr_layer3_3x3_weights_10_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_10:12;
    };
}srnn_wdsr_layer3_3x3_weights_10_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_11:12;
    };
}srnn_wdsr_layer3_3x3_weights_10_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_12:12;
    };
}srnn_wdsr_layer3_3x3_weights_10_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_20:12;
    };
}srnn_wdsr_layer3_3x3_weights_10_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_21:12;
    };
}srnn_wdsr_layer3_3x3_weights_10_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_22:12;
    };
}srnn_wdsr_layer3_3x3_weights_10_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_00:12;
    };
}srnn_wdsr_layer3_3x3_weights_11_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_01:12;
    };
}srnn_wdsr_layer3_3x3_weights_11_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_02:12;
    };
}srnn_wdsr_layer3_3x3_weights_11_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_10:12;
    };
}srnn_wdsr_layer3_3x3_weights_11_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_11:12;
    };
}srnn_wdsr_layer3_3x3_weights_11_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_12:12;
    };
}srnn_wdsr_layer3_3x3_weights_11_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_20:12;
    };
}srnn_wdsr_layer3_3x3_weights_11_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_21:12;
    };
}srnn_wdsr_layer3_3x3_weights_11_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_22:12;
    };
}srnn_wdsr_layer3_3x3_weights_11_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_00:12;
    };
}srnn_wdsr_layer3_3x3_weights_12_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_01:12;
    };
}srnn_wdsr_layer3_3x3_weights_12_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_02:12;
    };
}srnn_wdsr_layer3_3x3_weights_12_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_10:12;
    };
}srnn_wdsr_layer3_3x3_weights_12_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_11:12;
    };
}srnn_wdsr_layer3_3x3_weights_12_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_12:12;
    };
}srnn_wdsr_layer3_3x3_weights_12_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_20:12;
    };
}srnn_wdsr_layer3_3x3_weights_12_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_21:12;
    };
}srnn_wdsr_layer3_3x3_weights_12_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_22:12;
    };
}srnn_wdsr_layer3_3x3_weights_12_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_00:12;
    };
}srnn_wdsr_layer3_3x3_weights_13_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_01:12;
    };
}srnn_wdsr_layer3_3x3_weights_13_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_02:12;
    };
}srnn_wdsr_layer3_3x3_weights_13_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_10:12;
    };
}srnn_wdsr_layer3_3x3_weights_13_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_11:12;
    };
}srnn_wdsr_layer3_3x3_weights_13_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_12:12;
    };
}srnn_wdsr_layer3_3x3_weights_13_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_20:12;
    };
}srnn_wdsr_layer3_3x3_weights_13_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_21:12;
    };
}srnn_wdsr_layer3_3x3_weights_13_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_22:12;
    };
}srnn_wdsr_layer3_3x3_weights_13_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_00:12;
    };
}srnn_wdsr_layer3_3x3_weights_14_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_01:12;
    };
}srnn_wdsr_layer3_3x3_weights_14_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_02:12;
    };
}srnn_wdsr_layer3_3x3_weights_14_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_10:12;
    };
}srnn_wdsr_layer3_3x3_weights_14_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_11:12;
    };
}srnn_wdsr_layer3_3x3_weights_14_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_12:12;
    };
}srnn_wdsr_layer3_3x3_weights_14_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_20:12;
    };
}srnn_wdsr_layer3_3x3_weights_14_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_21:12;
    };
}srnn_wdsr_layer3_3x3_weights_14_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_22:12;
    };
}srnn_wdsr_layer3_3x3_weights_14_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_00:12;
    };
}srnn_wdsr_layer3_3x3_weights_15_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_01:12;
    };
}srnn_wdsr_layer3_3x3_weights_15_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_02:12;
    };
}srnn_wdsr_layer3_3x3_weights_15_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_10:12;
    };
}srnn_wdsr_layer3_3x3_weights_15_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_11:12;
    };
}srnn_wdsr_layer3_3x3_weights_15_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_12:12;
    };
}srnn_wdsr_layer3_3x3_weights_15_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_20:12;
    };
}srnn_wdsr_layer3_3x3_weights_15_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_21:12;
    };
}srnn_wdsr_layer3_3x3_weights_15_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_22:12;
    };
}srnn_wdsr_layer3_3x3_weights_15_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_00:12;
    };
}srnn_wdsr_layer3_3x3_weights_16_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_01:12;
    };
}srnn_wdsr_layer3_3x3_weights_16_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_02:12;
    };
}srnn_wdsr_layer3_3x3_weights_16_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_10:12;
    };
}srnn_wdsr_layer3_3x3_weights_16_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_11:12;
    };
}srnn_wdsr_layer3_3x3_weights_16_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_12:12;
    };
}srnn_wdsr_layer3_3x3_weights_16_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_20:12;
    };
}srnn_wdsr_layer3_3x3_weights_16_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_21:12;
    };
}srnn_wdsr_layer3_3x3_weights_16_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_22:12;
    };
}srnn_wdsr_layer3_3x3_weights_16_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_00:12;
    };
}srnn_wdsr_layer3_3x3_weights_17_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_01:12;
    };
}srnn_wdsr_layer3_3x3_weights_17_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_02:12;
    };
}srnn_wdsr_layer3_3x3_weights_17_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_10:12;
    };
}srnn_wdsr_layer3_3x3_weights_17_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_11:12;
    };
}srnn_wdsr_layer3_3x3_weights_17_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_12:12;
    };
}srnn_wdsr_layer3_3x3_weights_17_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_20:12;
    };
}srnn_wdsr_layer3_3x3_weights_17_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_21:12;
    };
}srnn_wdsr_layer3_3x3_weights_17_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_22:12;
    };
}srnn_wdsr_layer3_3x3_weights_17_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_00:12;
    };
}srnn_wdsr_layer3_3x3_weights_18_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_01:12;
    };
}srnn_wdsr_layer3_3x3_weights_18_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_02:12;
    };
}srnn_wdsr_layer3_3x3_weights_18_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_10:12;
    };
}srnn_wdsr_layer3_3x3_weights_18_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_11:12;
    };
}srnn_wdsr_layer3_3x3_weights_18_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_12:12;
    };
}srnn_wdsr_layer3_3x3_weights_18_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_20:12;
    };
}srnn_wdsr_layer3_3x3_weights_18_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_21:12;
    };
}srnn_wdsr_layer3_3x3_weights_18_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_22:12;
    };
}srnn_wdsr_layer3_3x3_weights_18_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_00:12;
    };
}srnn_wdsr_layer3_3x3_weights_19_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_01:12;
    };
}srnn_wdsr_layer3_3x3_weights_19_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_02:12;
    };
}srnn_wdsr_layer3_3x3_weights_19_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_10:12;
    };
}srnn_wdsr_layer3_3x3_weights_19_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_11:12;
    };
}srnn_wdsr_layer3_3x3_weights_19_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_12:12;
    };
}srnn_wdsr_layer3_3x3_weights_19_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_20:12;
    };
}srnn_wdsr_layer3_3x3_weights_19_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_21:12;
    };
}srnn_wdsr_layer3_3x3_weights_19_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_22:12;
    };
}srnn_wdsr_layer3_3x3_weights_19_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_00:12;
    };
}srnn_wdsr_layer3_3x3_weights_20_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_01:12;
    };
}srnn_wdsr_layer3_3x3_weights_20_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_02:12;
    };
}srnn_wdsr_layer3_3x3_weights_20_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_10:12;
    };
}srnn_wdsr_layer3_3x3_weights_20_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_11:12;
    };
}srnn_wdsr_layer3_3x3_weights_20_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_12:12;
    };
}srnn_wdsr_layer3_3x3_weights_20_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_20:12;
    };
}srnn_wdsr_layer3_3x3_weights_20_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_21:12;
    };
}srnn_wdsr_layer3_3x3_weights_20_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_22:12;
    };
}srnn_wdsr_layer3_3x3_weights_20_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_00:12;
    };
}srnn_wdsr_layer3_3x3_weights_21_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_01:12;
    };
}srnn_wdsr_layer3_3x3_weights_21_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_02:12;
    };
}srnn_wdsr_layer3_3x3_weights_21_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_10:12;
    };
}srnn_wdsr_layer3_3x3_weights_21_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_11:12;
    };
}srnn_wdsr_layer3_3x3_weights_21_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_12:12;
    };
}srnn_wdsr_layer3_3x3_weights_21_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_20:12;
    };
}srnn_wdsr_layer3_3x3_weights_21_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_21:12;
    };
}srnn_wdsr_layer3_3x3_weights_21_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_22:12;
    };
}srnn_wdsr_layer3_3x3_weights_21_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_00:12;
    };
}srnn_wdsr_layer3_3x3_weights_22_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_01:12;
    };
}srnn_wdsr_layer3_3x3_weights_22_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_02:12;
    };
}srnn_wdsr_layer3_3x3_weights_22_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_10:12;
    };
}srnn_wdsr_layer3_3x3_weights_22_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_11:12;
    };
}srnn_wdsr_layer3_3x3_weights_22_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_12:12;
    };
}srnn_wdsr_layer3_3x3_weights_22_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_20:12;
    };
}srnn_wdsr_layer3_3x3_weights_22_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_21:12;
    };
}srnn_wdsr_layer3_3x3_weights_22_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_22:12;
    };
}srnn_wdsr_layer3_3x3_weights_22_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_00:12;
    };
}srnn_wdsr_layer3_3x3_weights_23_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_01:12;
    };
}srnn_wdsr_layer3_3x3_weights_23_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_02:12;
    };
}srnn_wdsr_layer3_3x3_weights_23_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_10:12;
    };
}srnn_wdsr_layer3_3x3_weights_23_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_11:12;
    };
}srnn_wdsr_layer3_3x3_weights_23_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_12:12;
    };
}srnn_wdsr_layer3_3x3_weights_23_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_20:12;
    };
}srnn_wdsr_layer3_3x3_weights_23_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_21:12;
    };
}srnn_wdsr_layer3_3x3_weights_23_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_22:12;
    };
}srnn_wdsr_layer3_3x3_weights_23_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_00:12;
    };
}srnn_wdsr_layer3_3x3_weights_24_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_01:12;
    };
}srnn_wdsr_layer3_3x3_weights_24_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_02:12;
    };
}srnn_wdsr_layer3_3x3_weights_24_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_10:12;
    };
}srnn_wdsr_layer3_3x3_weights_24_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_11:12;
    };
}srnn_wdsr_layer3_3x3_weights_24_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_12:12;
    };
}srnn_wdsr_layer3_3x3_weights_24_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_20:12;
    };
}srnn_wdsr_layer3_3x3_weights_24_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_21:12;
    };
}srnn_wdsr_layer3_3x3_weights_24_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_22:12;
    };
}srnn_wdsr_layer3_3x3_weights_24_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_00:12;
    };
}srnn_wdsr_layer3_3x3_weights_25_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_01:12;
    };
}srnn_wdsr_layer3_3x3_weights_25_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_02:12;
    };
}srnn_wdsr_layer3_3x3_weights_25_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_10:12;
    };
}srnn_wdsr_layer3_3x3_weights_25_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_11:12;
    };
}srnn_wdsr_layer3_3x3_weights_25_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_12:12;
    };
}srnn_wdsr_layer3_3x3_weights_25_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_20:12;
    };
}srnn_wdsr_layer3_3x3_weights_25_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_21:12;
    };
}srnn_wdsr_layer3_3x3_weights_25_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_22:12;
    };
}srnn_wdsr_layer3_3x3_weights_25_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_00:12;
    };
}srnn_wdsr_layer3_3x3_weights_26_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_01:12;
    };
}srnn_wdsr_layer3_3x3_weights_26_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_02:12;
    };
}srnn_wdsr_layer3_3x3_weights_26_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_10:12;
    };
}srnn_wdsr_layer3_3x3_weights_26_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_11:12;
    };
}srnn_wdsr_layer3_3x3_weights_26_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_12:12;
    };
}srnn_wdsr_layer3_3x3_weights_26_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_20:12;
    };
}srnn_wdsr_layer3_3x3_weights_26_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_21:12;
    };
}srnn_wdsr_layer3_3x3_weights_26_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_22:12;
    };
}srnn_wdsr_layer3_3x3_weights_26_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_00:12;
    };
}srnn_wdsr_layer3_3x3_weights_27_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_01:12;
    };
}srnn_wdsr_layer3_3x3_weights_27_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_02:12;
    };
}srnn_wdsr_layer3_3x3_weights_27_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_10:12;
    };
}srnn_wdsr_layer3_3x3_weights_27_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_11:12;
    };
}srnn_wdsr_layer3_3x3_weights_27_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_12:12;
    };
}srnn_wdsr_layer3_3x3_weights_27_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_20:12;
    };
}srnn_wdsr_layer3_3x3_weights_27_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_21:12;
    };
}srnn_wdsr_layer3_3x3_weights_27_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_22:12;
    };
}srnn_wdsr_layer3_3x3_weights_27_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_00:12;
    };
}srnn_wdsr_layer3_3x3_weights_28_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_01:12;
    };
}srnn_wdsr_layer3_3x3_weights_28_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_02:12;
    };
}srnn_wdsr_layer3_3x3_weights_28_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_10:12;
    };
}srnn_wdsr_layer3_3x3_weights_28_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_11:12;
    };
}srnn_wdsr_layer3_3x3_weights_28_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_12:12;
    };
}srnn_wdsr_layer3_3x3_weights_28_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_20:12;
    };
}srnn_wdsr_layer3_3x3_weights_28_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_21:12;
    };
}srnn_wdsr_layer3_3x3_weights_28_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_22:12;
    };
}srnn_wdsr_layer3_3x3_weights_28_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_00:12;
    };
}srnn_wdsr_layer3_3x3_weights_29_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_01:12;
    };
}srnn_wdsr_layer3_3x3_weights_29_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_02:12;
    };
}srnn_wdsr_layer3_3x3_weights_29_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_10:12;
    };
}srnn_wdsr_layer3_3x3_weights_29_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_11:12;
    };
}srnn_wdsr_layer3_3x3_weights_29_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_12:12;
    };
}srnn_wdsr_layer3_3x3_weights_29_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_20:12;
    };
}srnn_wdsr_layer3_3x3_weights_29_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_21:12;
    };
}srnn_wdsr_layer3_3x3_weights_29_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_22:12;
    };
}srnn_wdsr_layer3_3x3_weights_29_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_00:12;
    };
}srnn_wdsr_layer3_3x3_weights_30_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_01:12;
    };
}srnn_wdsr_layer3_3x3_weights_30_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_02:12;
    };
}srnn_wdsr_layer3_3x3_weights_30_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_10:12;
    };
}srnn_wdsr_layer3_3x3_weights_30_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_11:12;
    };
}srnn_wdsr_layer3_3x3_weights_30_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_12:12;
    };
}srnn_wdsr_layer3_3x3_weights_30_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_20:12;
    };
}srnn_wdsr_layer3_3x3_weights_30_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_21:12;
    };
}srnn_wdsr_layer3_3x3_weights_30_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_22:12;
    };
}srnn_wdsr_layer3_3x3_weights_30_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_00:12;
    };
}srnn_wdsr_layer3_3x3_weights_31_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_01:12;
    };
}srnn_wdsr_layer3_3x3_weights_31_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_02:12;
    };
}srnn_wdsr_layer3_3x3_weights_31_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_10:12;
    };
}srnn_wdsr_layer3_3x3_weights_31_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_11:12;
    };
}srnn_wdsr_layer3_3x3_weights_31_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_12:12;
    };
}srnn_wdsr_layer3_3x3_weights_31_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_20:12;
    };
}srnn_wdsr_layer3_3x3_weights_31_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_21:12;
    };
}srnn_wdsr_layer3_3x3_weights_31_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_22:12;
    };
}srnn_wdsr_layer3_3x3_weights_31_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_00:12;
    };
}srnn_wdsr_layer3_3x3_weights_32_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_01:12;
    };
}srnn_wdsr_layer3_3x3_weights_32_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_02:12;
    };
}srnn_wdsr_layer3_3x3_weights_32_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_10:12;
    };
}srnn_wdsr_layer3_3x3_weights_32_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_11:12;
    };
}srnn_wdsr_layer3_3x3_weights_32_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_12:12;
    };
}srnn_wdsr_layer3_3x3_weights_32_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_20:12;
    };
}srnn_wdsr_layer3_3x3_weights_32_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_21:12;
    };
}srnn_wdsr_layer3_3x3_weights_32_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  layer3_weight_22:12;
    };
}srnn_wdsr_layer3_3x3_weights_32_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_bias_1:10;
    };
}srnn_wdsr_layer3_3x3_bias_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_bias_2:10;
    };
}srnn_wdsr_layer3_3x3_bias_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_bias_3:10;
    };
}srnn_wdsr_layer3_3x3_bias_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_bias_4:10;
    };
}srnn_wdsr_layer3_3x3_bias_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_bias_5:10;
    };
}srnn_wdsr_layer3_3x3_bias_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_bias_6:10;
    };
}srnn_wdsr_layer3_3x3_bias_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_bias_7:10;
    };
}srnn_wdsr_layer3_3x3_bias_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_bias_8:10;
    };
}srnn_wdsr_layer3_3x3_bias_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_bias_9:10;
    };
}srnn_wdsr_layer3_3x3_bias_9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_bias_10:10;
    };
}srnn_wdsr_layer3_3x3_bias_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_bias_11:10;
    };
}srnn_wdsr_layer3_3x3_bias_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_bias_12:10;
    };
}srnn_wdsr_layer3_3x3_bias_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_bias_13:10;
    };
}srnn_wdsr_layer3_3x3_bias_13_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_bias_14:10;
    };
}srnn_wdsr_layer3_3x3_bias_14_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_bias_15:10;
    };
}srnn_wdsr_layer3_3x3_bias_15_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_bias_16:10;
    };
}srnn_wdsr_layer3_3x3_bias_16_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_bias_17:10;
    };
}srnn_wdsr_layer3_3x3_bias_17_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_bias_18:10;
    };
}srnn_wdsr_layer3_3x3_bias_18_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_bias_19:10;
    };
}srnn_wdsr_layer3_3x3_bias_19_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_bias_20:10;
    };
}srnn_wdsr_layer3_3x3_bias_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_bias_21:10;
    };
}srnn_wdsr_layer3_3x3_bias_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_bias_22:10;
    };
}srnn_wdsr_layer3_3x3_bias_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_bias_23:10;
    };
}srnn_wdsr_layer3_3x3_bias_23_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_bias_24:10;
    };
}srnn_wdsr_layer3_3x3_bias_24_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_bias_25:10;
    };
}srnn_wdsr_layer3_3x3_bias_25_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_bias_26:10;
    };
}srnn_wdsr_layer3_3x3_bias_26_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_bias_27:10;
    };
}srnn_wdsr_layer3_3x3_bias_27_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_bias_28:10;
    };
}srnn_wdsr_layer3_3x3_bias_28_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_bias_29:10;
    };
}srnn_wdsr_layer3_3x3_bias_29_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_bias_30:10;
    };
}srnn_wdsr_layer3_3x3_bias_30_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_bias_31:10;
    };
}srnn_wdsr_layer3_3x3_bias_31_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_bias_32:10;
    };
}srnn_wdsr_layer3_3x3_bias_32_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_1:10;
    };
}srnn_wdsr_layer3_1x1_weights_1_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_2:10;
    };
}srnn_wdsr_layer3_1x1_weights_1_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_3:10;
    };
}srnn_wdsr_layer3_1x1_weights_1_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_4:10;
    };
}srnn_wdsr_layer3_1x1_weights_1_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_5:10;
    };
}srnn_wdsr_layer3_1x1_weights_1_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_6:10;
    };
}srnn_wdsr_layer3_1x1_weights_1_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_7:10;
    };
}srnn_wdsr_layer3_1x1_weights_1_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_8:10;
    };
}srnn_wdsr_layer3_1x1_weights_1_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_9:10;
    };
}srnn_wdsr_layer3_1x1_weights_1_9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_10:10;
    };
}srnn_wdsr_layer3_1x1_weights_1_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_11:10;
    };
}srnn_wdsr_layer3_1x1_weights_1_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_12:10;
    };
}srnn_wdsr_layer3_1x1_weights_1_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_13:10;
    };
}srnn_wdsr_layer3_1x1_weights_1_13_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_14:10;
    };
}srnn_wdsr_layer3_1x1_weights_1_14_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_15:10;
    };
}srnn_wdsr_layer3_1x1_weights_1_15_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_16:10;
    };
}srnn_wdsr_layer3_1x1_weights_1_16_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_17:10;
    };
}srnn_wdsr_layer3_1x1_weights_1_17_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_18:10;
    };
}srnn_wdsr_layer3_1x1_weights_1_18_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_19:10;
    };
}srnn_wdsr_layer3_1x1_weights_1_19_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_20:10;
    };
}srnn_wdsr_layer3_1x1_weights_1_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_21:10;
    };
}srnn_wdsr_layer3_1x1_weights_1_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_22:10;
    };
}srnn_wdsr_layer3_1x1_weights_1_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_23:10;
    };
}srnn_wdsr_layer3_1x1_weights_1_23_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_24:10;
    };
}srnn_wdsr_layer3_1x1_weights_1_24_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_25:10;
    };
}srnn_wdsr_layer3_1x1_weights_1_25_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_26:10;
    };
}srnn_wdsr_layer3_1x1_weights_1_26_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_27:10;
    };
}srnn_wdsr_layer3_1x1_weights_1_27_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_28:10;
    };
}srnn_wdsr_layer3_1x1_weights_1_28_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_29:10;
    };
}srnn_wdsr_layer3_1x1_weights_1_29_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_30:10;
    };
}srnn_wdsr_layer3_1x1_weights_1_30_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_31:10;
    };
}srnn_wdsr_layer3_1x1_weights_1_31_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_32:10;
    };
}srnn_wdsr_layer3_1x1_weights_1_32_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_1:10;
    };
}srnn_wdsr_layer3_1x1_weights_2_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_2:10;
    };
}srnn_wdsr_layer3_1x1_weights_2_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_3:10;
    };
}srnn_wdsr_layer3_1x1_weights_2_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_4:10;
    };
}srnn_wdsr_layer3_1x1_weights_2_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_5:10;
    };
}srnn_wdsr_layer3_1x1_weights_2_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_6:10;
    };
}srnn_wdsr_layer3_1x1_weights_2_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_7:10;
    };
}srnn_wdsr_layer3_1x1_weights_2_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_8:10;
    };
}srnn_wdsr_layer3_1x1_weights_2_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_9:10;
    };
}srnn_wdsr_layer3_1x1_weights_2_9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_10:10;
    };
}srnn_wdsr_layer3_1x1_weights_2_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_11:10;
    };
}srnn_wdsr_layer3_1x1_weights_2_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_12:10;
    };
}srnn_wdsr_layer3_1x1_weights_2_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_13:10;
    };
}srnn_wdsr_layer3_1x1_weights_2_13_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_14:10;
    };
}srnn_wdsr_layer3_1x1_weights_2_14_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_15:10;
    };
}srnn_wdsr_layer3_1x1_weights_2_15_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_16:10;
    };
}srnn_wdsr_layer3_1x1_weights_2_16_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_17:10;
    };
}srnn_wdsr_layer3_1x1_weights_2_17_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_18:10;
    };
}srnn_wdsr_layer3_1x1_weights_2_18_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_19:10;
    };
}srnn_wdsr_layer3_1x1_weights_2_19_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_20:10;
    };
}srnn_wdsr_layer3_1x1_weights_2_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_21:10;
    };
}srnn_wdsr_layer3_1x1_weights_2_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_22:10;
    };
}srnn_wdsr_layer3_1x1_weights_2_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_23:10;
    };
}srnn_wdsr_layer3_1x1_weights_2_23_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_24:10;
    };
}srnn_wdsr_layer3_1x1_weights_2_24_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_25:10;
    };
}srnn_wdsr_layer3_1x1_weights_2_25_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_26:10;
    };
}srnn_wdsr_layer3_1x1_weights_2_26_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_27:10;
    };
}srnn_wdsr_layer3_1x1_weights_2_27_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_28:10;
    };
}srnn_wdsr_layer3_1x1_weights_2_28_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_29:10;
    };
}srnn_wdsr_layer3_1x1_weights_2_29_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_30:10;
    };
}srnn_wdsr_layer3_1x1_weights_2_30_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_31:10;
    };
}srnn_wdsr_layer3_1x1_weights_2_31_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_32:10;
    };
}srnn_wdsr_layer3_1x1_weights_2_32_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_1:10;
    };
}srnn_wdsr_layer3_1x1_weights_3_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_2:10;
    };
}srnn_wdsr_layer3_1x1_weights_3_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_3:10;
    };
}srnn_wdsr_layer3_1x1_weights_3_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_4:10;
    };
}srnn_wdsr_layer3_1x1_weights_3_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_5:10;
    };
}srnn_wdsr_layer3_1x1_weights_3_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_6:10;
    };
}srnn_wdsr_layer3_1x1_weights_3_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_7:10;
    };
}srnn_wdsr_layer3_1x1_weights_3_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_8:10;
    };
}srnn_wdsr_layer3_1x1_weights_3_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_9:10;
    };
}srnn_wdsr_layer3_1x1_weights_3_9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_10:10;
    };
}srnn_wdsr_layer3_1x1_weights_3_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_11:10;
    };
}srnn_wdsr_layer3_1x1_weights_3_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_12:10;
    };
}srnn_wdsr_layer3_1x1_weights_3_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_13:10;
    };
}srnn_wdsr_layer3_1x1_weights_3_13_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_14:10;
    };
}srnn_wdsr_layer3_1x1_weights_3_14_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_15:10;
    };
}srnn_wdsr_layer3_1x1_weights_3_15_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_16:10;
    };
}srnn_wdsr_layer3_1x1_weights_3_16_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_17:10;
    };
}srnn_wdsr_layer3_1x1_weights_3_17_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_18:10;
    };
}srnn_wdsr_layer3_1x1_weights_3_18_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_19:10;
    };
}srnn_wdsr_layer3_1x1_weights_3_19_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_20:10;
    };
}srnn_wdsr_layer3_1x1_weights_3_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_21:10;
    };
}srnn_wdsr_layer3_1x1_weights_3_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_22:10;
    };
}srnn_wdsr_layer3_1x1_weights_3_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_23:10;
    };
}srnn_wdsr_layer3_1x1_weights_3_23_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_24:10;
    };
}srnn_wdsr_layer3_1x1_weights_3_24_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_25:10;
    };
}srnn_wdsr_layer3_1x1_weights_3_25_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_26:10;
    };
}srnn_wdsr_layer3_1x1_weights_3_26_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_27:10;
    };
}srnn_wdsr_layer3_1x1_weights_3_27_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_28:10;
    };
}srnn_wdsr_layer3_1x1_weights_3_28_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_29:10;
    };
}srnn_wdsr_layer3_1x1_weights_3_29_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_30:10;
    };
}srnn_wdsr_layer3_1x1_weights_3_30_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_31:10;
    };
}srnn_wdsr_layer3_1x1_weights_3_31_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_32:10;
    };
}srnn_wdsr_layer3_1x1_weights_3_32_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_1:10;
    };
}srnn_wdsr_layer3_1x1_weights_4_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_2:10;
    };
}srnn_wdsr_layer3_1x1_weights_4_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_3:10;
    };
}srnn_wdsr_layer3_1x1_weights_4_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_4:10;
    };
}srnn_wdsr_layer3_1x1_weights_4_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_5:10;
    };
}srnn_wdsr_layer3_1x1_weights_4_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_6:10;
    };
}srnn_wdsr_layer3_1x1_weights_4_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_7:10;
    };
}srnn_wdsr_layer3_1x1_weights_4_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_8:10;
    };
}srnn_wdsr_layer3_1x1_weights_4_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_9:10;
    };
}srnn_wdsr_layer3_1x1_weights_4_9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_10:10;
    };
}srnn_wdsr_layer3_1x1_weights_4_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_11:10;
    };
}srnn_wdsr_layer3_1x1_weights_4_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_12:10;
    };
}srnn_wdsr_layer3_1x1_weights_4_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_13:10;
    };
}srnn_wdsr_layer3_1x1_weights_4_13_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_14:10;
    };
}srnn_wdsr_layer3_1x1_weights_4_14_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_15:10;
    };
}srnn_wdsr_layer3_1x1_weights_4_15_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_16:10;
    };
}srnn_wdsr_layer3_1x1_weights_4_16_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_17:10;
    };
}srnn_wdsr_layer3_1x1_weights_4_17_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_18:10;
    };
}srnn_wdsr_layer3_1x1_weights_4_18_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_19:10;
    };
}srnn_wdsr_layer3_1x1_weights_4_19_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_20:10;
    };
}srnn_wdsr_layer3_1x1_weights_4_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_21:10;
    };
}srnn_wdsr_layer3_1x1_weights_4_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_22:10;
    };
}srnn_wdsr_layer3_1x1_weights_4_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_23:10;
    };
}srnn_wdsr_layer3_1x1_weights_4_23_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_24:10;
    };
}srnn_wdsr_layer3_1x1_weights_4_24_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_25:10;
    };
}srnn_wdsr_layer3_1x1_weights_4_25_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_26:10;
    };
}srnn_wdsr_layer3_1x1_weights_4_26_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_27:10;
    };
}srnn_wdsr_layer3_1x1_weights_4_27_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_28:10;
    };
}srnn_wdsr_layer3_1x1_weights_4_28_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_29:10;
    };
}srnn_wdsr_layer3_1x1_weights_4_29_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_30:10;
    };
}srnn_wdsr_layer3_1x1_weights_4_30_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_31:10;
    };
}srnn_wdsr_layer3_1x1_weights_4_31_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_32:10;
    };
}srnn_wdsr_layer3_1x1_weights_4_32_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_1:10;
    };
}srnn_wdsr_layer3_1x1_weights_5_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_2:10;
    };
}srnn_wdsr_layer3_1x1_weights_5_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_3:10;
    };
}srnn_wdsr_layer3_1x1_weights_5_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_4:10;
    };
}srnn_wdsr_layer3_1x1_weights_5_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_5:10;
    };
}srnn_wdsr_layer3_1x1_weights_5_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_6:10;
    };
}srnn_wdsr_layer3_1x1_weights_5_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_7:10;
    };
}srnn_wdsr_layer3_1x1_weights_5_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_8:10;
    };
}srnn_wdsr_layer3_1x1_weights_5_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_9:10;
    };
}srnn_wdsr_layer3_1x1_weights_5_9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_10:10;
    };
}srnn_wdsr_layer3_1x1_weights_5_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_11:10;
    };
}srnn_wdsr_layer3_1x1_weights_5_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_12:10;
    };
}srnn_wdsr_layer3_1x1_weights_5_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_13:10;
    };
}srnn_wdsr_layer3_1x1_weights_5_13_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_14:10;
    };
}srnn_wdsr_layer3_1x1_weights_5_14_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_15:10;
    };
}srnn_wdsr_layer3_1x1_weights_5_15_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_16:10;
    };
}srnn_wdsr_layer3_1x1_weights_5_16_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_17:10;
    };
}srnn_wdsr_layer3_1x1_weights_5_17_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_18:10;
    };
}srnn_wdsr_layer3_1x1_weights_5_18_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_19:10;
    };
}srnn_wdsr_layer3_1x1_weights_5_19_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_20:10;
    };
}srnn_wdsr_layer3_1x1_weights_5_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_21:10;
    };
}srnn_wdsr_layer3_1x1_weights_5_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_22:10;
    };
}srnn_wdsr_layer3_1x1_weights_5_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_23:10;
    };
}srnn_wdsr_layer3_1x1_weights_5_23_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_24:10;
    };
}srnn_wdsr_layer3_1x1_weights_5_24_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_25:10;
    };
}srnn_wdsr_layer3_1x1_weights_5_25_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_26:10;
    };
}srnn_wdsr_layer3_1x1_weights_5_26_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_27:10;
    };
}srnn_wdsr_layer3_1x1_weights_5_27_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_28:10;
    };
}srnn_wdsr_layer3_1x1_weights_5_28_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_29:10;
    };
}srnn_wdsr_layer3_1x1_weights_5_29_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_30:10;
    };
}srnn_wdsr_layer3_1x1_weights_5_30_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_31:10;
    };
}srnn_wdsr_layer3_1x1_weights_5_31_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_32:10;
    };
}srnn_wdsr_layer3_1x1_weights_5_32_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_1:10;
    };
}srnn_wdsr_layer3_1x1_weights_6_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_2:10;
    };
}srnn_wdsr_layer3_1x1_weights_6_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_3:10;
    };
}srnn_wdsr_layer3_1x1_weights_6_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_4:10;
    };
}srnn_wdsr_layer3_1x1_weights_6_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_5:10;
    };
}srnn_wdsr_layer3_1x1_weights_6_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_6:10;
    };
}srnn_wdsr_layer3_1x1_weights_6_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_7:10;
    };
}srnn_wdsr_layer3_1x1_weights_6_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_8:10;
    };
}srnn_wdsr_layer3_1x1_weights_6_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_9:10;
    };
}srnn_wdsr_layer3_1x1_weights_6_9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_10:10;
    };
}srnn_wdsr_layer3_1x1_weights_6_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_11:10;
    };
}srnn_wdsr_layer3_1x1_weights_6_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_12:10;
    };
}srnn_wdsr_layer3_1x1_weights_6_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_13:10;
    };
}srnn_wdsr_layer3_1x1_weights_6_13_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_14:10;
    };
}srnn_wdsr_layer3_1x1_weights_6_14_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_15:10;
    };
}srnn_wdsr_layer3_1x1_weights_6_15_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_16:10;
    };
}srnn_wdsr_layer3_1x1_weights_6_16_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_17:10;
    };
}srnn_wdsr_layer3_1x1_weights_6_17_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_18:10;
    };
}srnn_wdsr_layer3_1x1_weights_6_18_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_19:10;
    };
}srnn_wdsr_layer3_1x1_weights_6_19_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_20:10;
    };
}srnn_wdsr_layer3_1x1_weights_6_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_21:10;
    };
}srnn_wdsr_layer3_1x1_weights_6_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_22:10;
    };
}srnn_wdsr_layer3_1x1_weights_6_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_23:10;
    };
}srnn_wdsr_layer3_1x1_weights_6_23_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_24:10;
    };
}srnn_wdsr_layer3_1x1_weights_6_24_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_25:10;
    };
}srnn_wdsr_layer3_1x1_weights_6_25_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_26:10;
    };
}srnn_wdsr_layer3_1x1_weights_6_26_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_27:10;
    };
}srnn_wdsr_layer3_1x1_weights_6_27_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_28:10;
    };
}srnn_wdsr_layer3_1x1_weights_6_28_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_29:10;
    };
}srnn_wdsr_layer3_1x1_weights_6_29_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_30:10;
    };
}srnn_wdsr_layer3_1x1_weights_6_30_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_31:10;
    };
}srnn_wdsr_layer3_1x1_weights_6_31_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_32:10;
    };
}srnn_wdsr_layer3_1x1_weights_6_32_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_1:10;
    };
}srnn_wdsr_layer3_1x1_weights_7_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_2:10;
    };
}srnn_wdsr_layer3_1x1_weights_7_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_3:10;
    };
}srnn_wdsr_layer3_1x1_weights_7_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_4:10;
    };
}srnn_wdsr_layer3_1x1_weights_7_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_5:10;
    };
}srnn_wdsr_layer3_1x1_weights_7_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_6:10;
    };
}srnn_wdsr_layer3_1x1_weights_7_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_7:10;
    };
}srnn_wdsr_layer3_1x1_weights_7_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_8:10;
    };
}srnn_wdsr_layer3_1x1_weights_7_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_9:10;
    };
}srnn_wdsr_layer3_1x1_weights_7_9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_10:10;
    };
}srnn_wdsr_layer3_1x1_weights_7_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_11:10;
    };
}srnn_wdsr_layer3_1x1_weights_7_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_12:10;
    };
}srnn_wdsr_layer3_1x1_weights_7_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_13:10;
    };
}srnn_wdsr_layer3_1x1_weights_7_13_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_14:10;
    };
}srnn_wdsr_layer3_1x1_weights_7_14_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_15:10;
    };
}srnn_wdsr_layer3_1x1_weights_7_15_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_16:10;
    };
}srnn_wdsr_layer3_1x1_weights_7_16_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_17:10;
    };
}srnn_wdsr_layer3_1x1_weights_7_17_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_18:10;
    };
}srnn_wdsr_layer3_1x1_weights_7_18_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_19:10;
    };
}srnn_wdsr_layer3_1x1_weights_7_19_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_20:10;
    };
}srnn_wdsr_layer3_1x1_weights_7_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_21:10;
    };
}srnn_wdsr_layer3_1x1_weights_7_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_22:10;
    };
}srnn_wdsr_layer3_1x1_weights_7_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_23:10;
    };
}srnn_wdsr_layer3_1x1_weights_7_23_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_24:10;
    };
}srnn_wdsr_layer3_1x1_weights_7_24_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_25:10;
    };
}srnn_wdsr_layer3_1x1_weights_7_25_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_26:10;
    };
}srnn_wdsr_layer3_1x1_weights_7_26_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_27:10;
    };
}srnn_wdsr_layer3_1x1_weights_7_27_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_28:10;
    };
}srnn_wdsr_layer3_1x1_weights_7_28_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_29:10;
    };
}srnn_wdsr_layer3_1x1_weights_7_29_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_30:10;
    };
}srnn_wdsr_layer3_1x1_weights_7_30_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_31:10;
    };
}srnn_wdsr_layer3_1x1_weights_7_31_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_32:10;
    };
}srnn_wdsr_layer3_1x1_weights_7_32_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_1:10;
    };
}srnn_wdsr_layer3_1x1_weights_8_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_2:10;
    };
}srnn_wdsr_layer3_1x1_weights_8_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_3:10;
    };
}srnn_wdsr_layer3_1x1_weights_8_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_4:10;
    };
}srnn_wdsr_layer3_1x1_weights_8_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_5:10;
    };
}srnn_wdsr_layer3_1x1_weights_8_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_6:10;
    };
}srnn_wdsr_layer3_1x1_weights_8_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_7:10;
    };
}srnn_wdsr_layer3_1x1_weights_8_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_8:10;
    };
}srnn_wdsr_layer3_1x1_weights_8_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_9:10;
    };
}srnn_wdsr_layer3_1x1_weights_8_9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_10:10;
    };
}srnn_wdsr_layer3_1x1_weights_8_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_11:10;
    };
}srnn_wdsr_layer3_1x1_weights_8_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_12:10;
    };
}srnn_wdsr_layer3_1x1_weights_8_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_13:10;
    };
}srnn_wdsr_layer3_1x1_weights_8_13_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_14:10;
    };
}srnn_wdsr_layer3_1x1_weights_8_14_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_15:10;
    };
}srnn_wdsr_layer3_1x1_weights_8_15_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_16:10;
    };
}srnn_wdsr_layer3_1x1_weights_8_16_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_17:10;
    };
}srnn_wdsr_layer3_1x1_weights_8_17_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_18:10;
    };
}srnn_wdsr_layer3_1x1_weights_8_18_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_19:10;
    };
}srnn_wdsr_layer3_1x1_weights_8_19_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_20:10;
    };
}srnn_wdsr_layer3_1x1_weights_8_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_21:10;
    };
}srnn_wdsr_layer3_1x1_weights_8_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_22:10;
    };
}srnn_wdsr_layer3_1x1_weights_8_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_23:10;
    };
}srnn_wdsr_layer3_1x1_weights_8_23_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_24:10;
    };
}srnn_wdsr_layer3_1x1_weights_8_24_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_25:10;
    };
}srnn_wdsr_layer3_1x1_weights_8_25_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_26:10;
    };
}srnn_wdsr_layer3_1x1_weights_8_26_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_27:10;
    };
}srnn_wdsr_layer3_1x1_weights_8_27_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_28:10;
    };
}srnn_wdsr_layer3_1x1_weights_8_28_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_29:10;
    };
}srnn_wdsr_layer3_1x1_weights_8_29_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_30:10;
    };
}srnn_wdsr_layer3_1x1_weights_8_30_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_31:10;
    };
}srnn_wdsr_layer3_1x1_weights_8_31_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_weight_32:10;
    };
}srnn_wdsr_layer3_1x1_weights_8_32_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_bias_1:10;
    };
}srnn_wdsr_layer3_1x1_bias_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_bias_2:10;
    };
}srnn_wdsr_layer3_1x1_bias_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_bias_3:10;
    };
}srnn_wdsr_layer3_1x1_bias_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_bias_4:10;
    };
}srnn_wdsr_layer3_1x1_bias_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_bias_5:10;
    };
}srnn_wdsr_layer3_1x1_bias_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_bias_6:10;
    };
}srnn_wdsr_layer3_1x1_bias_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_bias_7:10;
    };
}srnn_wdsr_layer3_1x1_bias_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  layer3_bias_8:10;
    };
}srnn_wdsr_layer3_1x1_bias_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_00:13;
    };
}srnn_wdsr_layer4_3x3_weights_1_1_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_01:13;
    };
}srnn_wdsr_layer4_3x3_weights_1_1_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_02:13;
    };
}srnn_wdsr_layer4_3x3_weights_1_1_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_10:13;
    };
}srnn_wdsr_layer4_3x3_weights_1_1_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_11:13;
    };
}srnn_wdsr_layer4_3x3_weights_1_1_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_12:13;
    };
}srnn_wdsr_layer4_3x3_weights_1_1_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_20:13;
    };
}srnn_wdsr_layer4_3x3_weights_1_1_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_21:13;
    };
}srnn_wdsr_layer4_3x3_weights_1_1_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_22:13;
    };
}srnn_wdsr_layer4_3x3_weights_1_1_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_00:13;
    };
}srnn_wdsr_layer4_3x3_weights_1_2_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_01:13;
    };
}srnn_wdsr_layer4_3x3_weights_1_2_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_02:13;
    };
}srnn_wdsr_layer4_3x3_weights_1_2_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_10:13;
    };
}srnn_wdsr_layer4_3x3_weights_1_2_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_11:13;
    };
}srnn_wdsr_layer4_3x3_weights_1_2_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_12:13;
    };
}srnn_wdsr_layer4_3x3_weights_1_2_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_20:13;
    };
}srnn_wdsr_layer4_3x3_weights_1_2_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_21:13;
    };
}srnn_wdsr_layer4_3x3_weights_1_2_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_22:13;
    };
}srnn_wdsr_layer4_3x3_weights_1_2_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_00:13;
    };
}srnn_wdsr_layer4_3x3_weights_1_3_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_01:13;
    };
}srnn_wdsr_layer4_3x3_weights_1_3_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_02:13;
    };
}srnn_wdsr_layer4_3x3_weights_1_3_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_10:13;
    };
}srnn_wdsr_layer4_3x3_weights_1_3_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_11:13;
    };
}srnn_wdsr_layer4_3x3_weights_1_3_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_12:13;
    };
}srnn_wdsr_layer4_3x3_weights_1_3_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_20:13;
    };
}srnn_wdsr_layer4_3x3_weights_1_3_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_21:13;
    };
}srnn_wdsr_layer4_3x3_weights_1_3_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_22:13;
    };
}srnn_wdsr_layer4_3x3_weights_1_3_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_00:13;
    };
}srnn_wdsr_layer4_3x3_weights_1_4_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_01:13;
    };
}srnn_wdsr_layer4_3x3_weights_1_4_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_02:13;
    };
}srnn_wdsr_layer4_3x3_weights_1_4_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_10:13;
    };
}srnn_wdsr_layer4_3x3_weights_1_4_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_11:13;
    };
}srnn_wdsr_layer4_3x3_weights_1_4_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_12:13;
    };
}srnn_wdsr_layer4_3x3_weights_1_4_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_20:13;
    };
}srnn_wdsr_layer4_3x3_weights_1_4_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_21:13;
    };
}srnn_wdsr_layer4_3x3_weights_1_4_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_22:13;
    };
}srnn_wdsr_layer4_3x3_weights_1_4_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_00:13;
    };
}srnn_wdsr_layer4_3x3_weights_1_5_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_01:13;
    };
}srnn_wdsr_layer4_3x3_weights_1_5_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_02:13;
    };
}srnn_wdsr_layer4_3x3_weights_1_5_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_10:13;
    };
}srnn_wdsr_layer4_3x3_weights_1_5_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_11:13;
    };
}srnn_wdsr_layer4_3x3_weights_1_5_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_12:13;
    };
}srnn_wdsr_layer4_3x3_weights_1_5_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_20:13;
    };
}srnn_wdsr_layer4_3x3_weights_1_5_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_21:13;
    };
}srnn_wdsr_layer4_3x3_weights_1_5_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_22:13;
    };
}srnn_wdsr_layer4_3x3_weights_1_5_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_00:13;
    };
}srnn_wdsr_layer4_3x3_weights_1_6_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_01:13;
    };
}srnn_wdsr_layer4_3x3_weights_1_6_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_02:13;
    };
}srnn_wdsr_layer4_3x3_weights_1_6_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_10:13;
    };
}srnn_wdsr_layer4_3x3_weights_1_6_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_11:13;
    };
}srnn_wdsr_layer4_3x3_weights_1_6_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_12:13;
    };
}srnn_wdsr_layer4_3x3_weights_1_6_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_20:13;
    };
}srnn_wdsr_layer4_3x3_weights_1_6_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_21:13;
    };
}srnn_wdsr_layer4_3x3_weights_1_6_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_22:13;
    };
}srnn_wdsr_layer4_3x3_weights_1_6_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_00:13;
    };
}srnn_wdsr_layer4_3x3_weights_1_7_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_01:13;
    };
}srnn_wdsr_layer4_3x3_weights_1_7_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_02:13;
    };
}srnn_wdsr_layer4_3x3_weights_1_7_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_10:13;
    };
}srnn_wdsr_layer4_3x3_weights_1_7_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_11:13;
    };
}srnn_wdsr_layer4_3x3_weights_1_7_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_12:13;
    };
}srnn_wdsr_layer4_3x3_weights_1_7_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_20:13;
    };
}srnn_wdsr_layer4_3x3_weights_1_7_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_21:13;
    };
}srnn_wdsr_layer4_3x3_weights_1_7_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_22:13;
    };
}srnn_wdsr_layer4_3x3_weights_1_7_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_00:13;
    };
}srnn_wdsr_layer4_3x3_weights_1_8_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_01:13;
    };
}srnn_wdsr_layer4_3x3_weights_1_8_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_02:13;
    };
}srnn_wdsr_layer4_3x3_weights_1_8_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_10:13;
    };
}srnn_wdsr_layer4_3x3_weights_1_8_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_11:13;
    };
}srnn_wdsr_layer4_3x3_weights_1_8_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_12:13;
    };
}srnn_wdsr_layer4_3x3_weights_1_8_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_20:13;
    };
}srnn_wdsr_layer4_3x3_weights_1_8_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_21:13;
    };
}srnn_wdsr_layer4_3x3_weights_1_8_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_22:13;
    };
}srnn_wdsr_layer4_3x3_weights_1_8_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_00:13;
    };
}srnn_wdsr_layer4_3x3_weights_2_1_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_01:13;
    };
}srnn_wdsr_layer4_3x3_weights_2_1_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_02:13;
    };
}srnn_wdsr_layer4_3x3_weights_2_1_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_10:13;
    };
}srnn_wdsr_layer4_3x3_weights_2_1_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_11:13;
    };
}srnn_wdsr_layer4_3x3_weights_2_1_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_12:13;
    };
}srnn_wdsr_layer4_3x3_weights_2_1_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_20:13;
    };
}srnn_wdsr_layer4_3x3_weights_2_1_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_21:13;
    };
}srnn_wdsr_layer4_3x3_weights_2_1_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_22:13;
    };
}srnn_wdsr_layer4_3x3_weights_2_1_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_00:13;
    };
}srnn_wdsr_layer4_3x3_weights_2_2_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_01:13;
    };
}srnn_wdsr_layer4_3x3_weights_2_2_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_02:13;
    };
}srnn_wdsr_layer4_3x3_weights_2_2_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_10:13;
    };
}srnn_wdsr_layer4_3x3_weights_2_2_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_11:13;
    };
}srnn_wdsr_layer4_3x3_weights_2_2_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_12:13;
    };
}srnn_wdsr_layer4_3x3_weights_2_2_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_20:13;
    };
}srnn_wdsr_layer4_3x3_weights_2_2_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_21:13;
    };
}srnn_wdsr_layer4_3x3_weights_2_2_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_22:13;
    };
}srnn_wdsr_layer4_3x3_weights_2_2_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_00:13;
    };
}srnn_wdsr_layer4_3x3_weights_2_3_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_01:13;
    };
}srnn_wdsr_layer4_3x3_weights_2_3_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_02:13;
    };
}srnn_wdsr_layer4_3x3_weights_2_3_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_10:13;
    };
}srnn_wdsr_layer4_3x3_weights_2_3_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_11:13;
    };
}srnn_wdsr_layer4_3x3_weights_2_3_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_12:13;
    };
}srnn_wdsr_layer4_3x3_weights_2_3_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_20:13;
    };
}srnn_wdsr_layer4_3x3_weights_2_3_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_21:13;
    };
}srnn_wdsr_layer4_3x3_weights_2_3_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_22:13;
    };
}srnn_wdsr_layer4_3x3_weights_2_3_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_00:13;
    };
}srnn_wdsr_layer4_3x3_weights_2_4_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_01:13;
    };
}srnn_wdsr_layer4_3x3_weights_2_4_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_02:13;
    };
}srnn_wdsr_layer4_3x3_weights_2_4_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_10:13;
    };
}srnn_wdsr_layer4_3x3_weights_2_4_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_11:13;
    };
}srnn_wdsr_layer4_3x3_weights_2_4_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_12:13;
    };
}srnn_wdsr_layer4_3x3_weights_2_4_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_20:13;
    };
}srnn_wdsr_layer4_3x3_weights_2_4_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_21:13;
    };
}srnn_wdsr_layer4_3x3_weights_2_4_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_22:13;
    };
}srnn_wdsr_layer4_3x3_weights_2_4_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_00:13;
    };
}srnn_wdsr_layer4_3x3_weights_2_5_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_01:13;
    };
}srnn_wdsr_layer4_3x3_weights_2_5_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_02:13;
    };
}srnn_wdsr_layer4_3x3_weights_2_5_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_10:13;
    };
}srnn_wdsr_layer4_3x3_weights_2_5_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_11:13;
    };
}srnn_wdsr_layer4_3x3_weights_2_5_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_12:13;
    };
}srnn_wdsr_layer4_3x3_weights_2_5_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_20:13;
    };
}srnn_wdsr_layer4_3x3_weights_2_5_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_21:13;
    };
}srnn_wdsr_layer4_3x3_weights_2_5_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_22:13;
    };
}srnn_wdsr_layer4_3x3_weights_2_5_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_00:13;
    };
}srnn_wdsr_layer4_3x3_weights_2_6_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_01:13;
    };
}srnn_wdsr_layer4_3x3_weights_2_6_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_02:13;
    };
}srnn_wdsr_layer4_3x3_weights_2_6_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_10:13;
    };
}srnn_wdsr_layer4_3x3_weights_2_6_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_11:13;
    };
}srnn_wdsr_layer4_3x3_weights_2_6_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_12:13;
    };
}srnn_wdsr_layer4_3x3_weights_2_6_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_20:13;
    };
}srnn_wdsr_layer4_3x3_weights_2_6_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_21:13;
    };
}srnn_wdsr_layer4_3x3_weights_2_6_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_22:13;
    };
}srnn_wdsr_layer4_3x3_weights_2_6_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_00:13;
    };
}srnn_wdsr_layer4_3x3_weights_2_7_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_01:13;
    };
}srnn_wdsr_layer4_3x3_weights_2_7_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_02:13;
    };
}srnn_wdsr_layer4_3x3_weights_2_7_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_10:13;
    };
}srnn_wdsr_layer4_3x3_weights_2_7_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_11:13;
    };
}srnn_wdsr_layer4_3x3_weights_2_7_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_12:13;
    };
}srnn_wdsr_layer4_3x3_weights_2_7_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_20:13;
    };
}srnn_wdsr_layer4_3x3_weights_2_7_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_21:13;
    };
}srnn_wdsr_layer4_3x3_weights_2_7_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_22:13;
    };
}srnn_wdsr_layer4_3x3_weights_2_7_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_00:13;
    };
}srnn_wdsr_layer4_3x3_weights_2_8_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_01:13;
    };
}srnn_wdsr_layer4_3x3_weights_2_8_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_02:13;
    };
}srnn_wdsr_layer4_3x3_weights_2_8_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_10:13;
    };
}srnn_wdsr_layer4_3x3_weights_2_8_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_11:13;
    };
}srnn_wdsr_layer4_3x3_weights_2_8_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_12:13;
    };
}srnn_wdsr_layer4_3x3_weights_2_8_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_20:13;
    };
}srnn_wdsr_layer4_3x3_weights_2_8_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_21:13;
    };
}srnn_wdsr_layer4_3x3_weights_2_8_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_22:13;
    };
}srnn_wdsr_layer4_3x3_weights_2_8_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_00:13;
    };
}srnn_wdsr_layer4_3x3_weights_3_1_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_01:13;
    };
}srnn_wdsr_layer4_3x3_weights_3_1_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_02:13;
    };
}srnn_wdsr_layer4_3x3_weights_3_1_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_10:13;
    };
}srnn_wdsr_layer4_3x3_weights_3_1_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_11:13;
    };
}srnn_wdsr_layer4_3x3_weights_3_1_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_12:13;
    };
}srnn_wdsr_layer4_3x3_weights_3_1_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_20:13;
    };
}srnn_wdsr_layer4_3x3_weights_3_1_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_21:13;
    };
}srnn_wdsr_layer4_3x3_weights_3_1_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_22:13;
    };
}srnn_wdsr_layer4_3x3_weights_3_1_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_00:13;
    };
}srnn_wdsr_layer4_3x3_weights_3_2_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_01:13;
    };
}srnn_wdsr_layer4_3x3_weights_3_2_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_02:13;
    };
}srnn_wdsr_layer4_3x3_weights_3_2_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_10:13;
    };
}srnn_wdsr_layer4_3x3_weights_3_2_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_11:13;
    };
}srnn_wdsr_layer4_3x3_weights_3_2_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_12:13;
    };
}srnn_wdsr_layer4_3x3_weights_3_2_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_20:13;
    };
}srnn_wdsr_layer4_3x3_weights_3_2_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_21:13;
    };
}srnn_wdsr_layer4_3x3_weights_3_2_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_22:13;
    };
}srnn_wdsr_layer4_3x3_weights_3_2_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_00:13;
    };
}srnn_wdsr_layer4_3x3_weights_3_3_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_01:13;
    };
}srnn_wdsr_layer4_3x3_weights_3_3_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_02:13;
    };
}srnn_wdsr_layer4_3x3_weights_3_3_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_10:13;
    };
}srnn_wdsr_layer4_3x3_weights_3_3_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_11:13;
    };
}srnn_wdsr_layer4_3x3_weights_3_3_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_12:13;
    };
}srnn_wdsr_layer4_3x3_weights_3_3_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_20:13;
    };
}srnn_wdsr_layer4_3x3_weights_3_3_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_21:13;
    };
}srnn_wdsr_layer4_3x3_weights_3_3_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_22:13;
    };
}srnn_wdsr_layer4_3x3_weights_3_3_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_00:13;
    };
}srnn_wdsr_layer4_3x3_weights_3_4_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_01:13;
    };
}srnn_wdsr_layer4_3x3_weights_3_4_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_02:13;
    };
}srnn_wdsr_layer4_3x3_weights_3_4_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_10:13;
    };
}srnn_wdsr_layer4_3x3_weights_3_4_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_11:13;
    };
}srnn_wdsr_layer4_3x3_weights_3_4_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_12:13;
    };
}srnn_wdsr_layer4_3x3_weights_3_4_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_20:13;
    };
}srnn_wdsr_layer4_3x3_weights_3_4_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_21:13;
    };
}srnn_wdsr_layer4_3x3_weights_3_4_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_22:13;
    };
}srnn_wdsr_layer4_3x3_weights_3_4_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_00:13;
    };
}srnn_wdsr_layer4_3x3_weights_3_5_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_01:13;
    };
}srnn_wdsr_layer4_3x3_weights_3_5_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_02:13;
    };
}srnn_wdsr_layer4_3x3_weights_3_5_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_10:13;
    };
}srnn_wdsr_layer4_3x3_weights_3_5_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_11:13;
    };
}srnn_wdsr_layer4_3x3_weights_3_5_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_12:13;
    };
}srnn_wdsr_layer4_3x3_weights_3_5_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_20:13;
    };
}srnn_wdsr_layer4_3x3_weights_3_5_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_21:13;
    };
}srnn_wdsr_layer4_3x3_weights_3_5_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_22:13;
    };
}srnn_wdsr_layer4_3x3_weights_3_5_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_00:13;
    };
}srnn_wdsr_layer4_3x3_weights_3_6_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_01:13;
    };
}srnn_wdsr_layer4_3x3_weights_3_6_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_02:13;
    };
}srnn_wdsr_layer4_3x3_weights_3_6_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_10:13;
    };
}srnn_wdsr_layer4_3x3_weights_3_6_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_11:13;
    };
}srnn_wdsr_layer4_3x3_weights_3_6_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_12:13;
    };
}srnn_wdsr_layer4_3x3_weights_3_6_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_20:13;
    };
}srnn_wdsr_layer4_3x3_weights_3_6_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_21:13;
    };
}srnn_wdsr_layer4_3x3_weights_3_6_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_22:13;
    };
}srnn_wdsr_layer4_3x3_weights_3_6_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_00:13;
    };
}srnn_wdsr_layer4_3x3_weights_3_7_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_01:13;
    };
}srnn_wdsr_layer4_3x3_weights_3_7_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_02:13;
    };
}srnn_wdsr_layer4_3x3_weights_3_7_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_10:13;
    };
}srnn_wdsr_layer4_3x3_weights_3_7_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_11:13;
    };
}srnn_wdsr_layer4_3x3_weights_3_7_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_12:13;
    };
}srnn_wdsr_layer4_3x3_weights_3_7_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_20:13;
    };
}srnn_wdsr_layer4_3x3_weights_3_7_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_21:13;
    };
}srnn_wdsr_layer4_3x3_weights_3_7_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_22:13;
    };
}srnn_wdsr_layer4_3x3_weights_3_7_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_00:13;
    };
}srnn_wdsr_layer4_3x3_weights_3_8_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_01:13;
    };
}srnn_wdsr_layer4_3x3_weights_3_8_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_02:13;
    };
}srnn_wdsr_layer4_3x3_weights_3_8_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_10:13;
    };
}srnn_wdsr_layer4_3x3_weights_3_8_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_11:13;
    };
}srnn_wdsr_layer4_3x3_weights_3_8_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_12:13;
    };
}srnn_wdsr_layer4_3x3_weights_3_8_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_20:13;
    };
}srnn_wdsr_layer4_3x3_weights_3_8_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_21:13;
    };
}srnn_wdsr_layer4_3x3_weights_3_8_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_22:13;
    };
}srnn_wdsr_layer4_3x3_weights_3_8_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_00:13;
    };
}srnn_wdsr_layer4_3x3_weights_4_1_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_01:13;
    };
}srnn_wdsr_layer4_3x3_weights_4_1_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_02:13;
    };
}srnn_wdsr_layer4_3x3_weights_4_1_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_10:13;
    };
}srnn_wdsr_layer4_3x3_weights_4_1_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_11:13;
    };
}srnn_wdsr_layer4_3x3_weights_4_1_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_12:13;
    };
}srnn_wdsr_layer4_3x3_weights_4_1_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_20:13;
    };
}srnn_wdsr_layer4_3x3_weights_4_1_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_21:13;
    };
}srnn_wdsr_layer4_3x3_weights_4_1_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_22:13;
    };
}srnn_wdsr_layer4_3x3_weights_4_1_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_00:13;
    };
}srnn_wdsr_layer4_3x3_weights_4_2_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_01:13;
    };
}srnn_wdsr_layer4_3x3_weights_4_2_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_02:13;
    };
}srnn_wdsr_layer4_3x3_weights_4_2_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_10:13;
    };
}srnn_wdsr_layer4_3x3_weights_4_2_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_11:13;
    };
}srnn_wdsr_layer4_3x3_weights_4_2_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_12:13;
    };
}srnn_wdsr_layer4_3x3_weights_4_2_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_20:13;
    };
}srnn_wdsr_layer4_3x3_weights_4_2_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_21:13;
    };
}srnn_wdsr_layer4_3x3_weights_4_2_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_22:13;
    };
}srnn_wdsr_layer4_3x3_weights_4_2_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_00:13;
    };
}srnn_wdsr_layer4_3x3_weights_4_3_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_01:13;
    };
}srnn_wdsr_layer4_3x3_weights_4_3_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_02:13;
    };
}srnn_wdsr_layer4_3x3_weights_4_3_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_10:13;
    };
}srnn_wdsr_layer4_3x3_weights_4_3_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_11:13;
    };
}srnn_wdsr_layer4_3x3_weights_4_3_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_12:13;
    };
}srnn_wdsr_layer4_3x3_weights_4_3_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_20:13;
    };
}srnn_wdsr_layer4_3x3_weights_4_3_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_21:13;
    };
}srnn_wdsr_layer4_3x3_weights_4_3_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_22:13;
    };
}srnn_wdsr_layer4_3x3_weights_4_3_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_00:13;
    };
}srnn_wdsr_layer4_3x3_weights_4_4_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_01:13;
    };
}srnn_wdsr_layer4_3x3_weights_4_4_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_02:13;
    };
}srnn_wdsr_layer4_3x3_weights_4_4_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_10:13;
    };
}srnn_wdsr_layer4_3x3_weights_4_4_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_11:13;
    };
}srnn_wdsr_layer4_3x3_weights_4_4_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_12:13;
    };
}srnn_wdsr_layer4_3x3_weights_4_4_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_20:13;
    };
}srnn_wdsr_layer4_3x3_weights_4_4_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_21:13;
    };
}srnn_wdsr_layer4_3x3_weights_4_4_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_22:13;
    };
}srnn_wdsr_layer4_3x3_weights_4_4_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_00:13;
    };
}srnn_wdsr_layer4_3x3_weights_4_5_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_01:13;
    };
}srnn_wdsr_layer4_3x3_weights_4_5_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_02:13;
    };
}srnn_wdsr_layer4_3x3_weights_4_5_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_10:13;
    };
}srnn_wdsr_layer4_3x3_weights_4_5_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_11:13;
    };
}srnn_wdsr_layer4_3x3_weights_4_5_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_12:13;
    };
}srnn_wdsr_layer4_3x3_weights_4_5_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_20:13;
    };
}srnn_wdsr_layer4_3x3_weights_4_5_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_21:13;
    };
}srnn_wdsr_layer4_3x3_weights_4_5_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_22:13;
    };
}srnn_wdsr_layer4_3x3_weights_4_5_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_00:13;
    };
}srnn_wdsr_layer4_3x3_weights_4_6_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_01:13;
    };
}srnn_wdsr_layer4_3x3_weights_4_6_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_02:13;
    };
}srnn_wdsr_layer4_3x3_weights_4_6_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_10:13;
    };
}srnn_wdsr_layer4_3x3_weights_4_6_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_11:13;
    };
}srnn_wdsr_layer4_3x3_weights_4_6_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_12:13;
    };
}srnn_wdsr_layer4_3x3_weights_4_6_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_20:13;
    };
}srnn_wdsr_layer4_3x3_weights_4_6_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_21:13;
    };
}srnn_wdsr_layer4_3x3_weights_4_6_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_22:13;
    };
}srnn_wdsr_layer4_3x3_weights_4_6_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_00:13;
    };
}srnn_wdsr_layer4_3x3_weights_4_7_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_01:13;
    };
}srnn_wdsr_layer4_3x3_weights_4_7_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_02:13;
    };
}srnn_wdsr_layer4_3x3_weights_4_7_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_10:13;
    };
}srnn_wdsr_layer4_3x3_weights_4_7_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_11:13;
    };
}srnn_wdsr_layer4_3x3_weights_4_7_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_12:13;
    };
}srnn_wdsr_layer4_3x3_weights_4_7_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_20:13;
    };
}srnn_wdsr_layer4_3x3_weights_4_7_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_21:13;
    };
}srnn_wdsr_layer4_3x3_weights_4_7_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_22:13;
    };
}srnn_wdsr_layer4_3x3_weights_4_7_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_00:13;
    };
}srnn_wdsr_layer4_3x3_weights_4_8_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_01:13;
    };
}srnn_wdsr_layer4_3x3_weights_4_8_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_02:13;
    };
}srnn_wdsr_layer4_3x3_weights_4_8_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_10:13;
    };
}srnn_wdsr_layer4_3x3_weights_4_8_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_11:13;
    };
}srnn_wdsr_layer4_3x3_weights_4_8_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_12:13;
    };
}srnn_wdsr_layer4_3x3_weights_4_8_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_20:13;
    };
}srnn_wdsr_layer4_3x3_weights_4_8_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_21:13;
    };
}srnn_wdsr_layer4_3x3_weights_4_8_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_weight_22:13;
    };
}srnn_wdsr_layer4_3x3_weights_4_8_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_bias_1:13;
    };
}srnn_wdsr_layer4_3x3_bias_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_bias_2:13;
    };
}srnn_wdsr_layer4_3x3_bias_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_bias_3:13;
    };
}srnn_wdsr_layer4_3x3_bias_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  layer4_bias_4:13;
    };
}srnn_wdsr_layer4_3x3_bias_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ssrs_rm_4_0:4;
        RBus_UInt32  ssrs_rm_3_0:4;
        RBus_UInt32  ssrs_rm_2_1:4;
        RBus_UInt32  ssrs_rm_2_0:4;
        RBus_UInt32  ssrs_rm_1_2:4;
        RBus_UInt32  ssrs_rm_1_1:4;
        RBus_UInt32  ssrs_rm_1_0:4;
        RBus_UInt32  ssrs_rm_0_0:4;
    };
}srnn_ssrs_rm_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  ssrs_ls_4_0:1;
        RBus_UInt32  ssrs_ls_3_0:1;
        RBus_UInt32  ssrs_ls_2_1:1;
        RBus_UInt32  ssrs_ls_2_0:1;
        RBus_UInt32  ssrs_ls_1_2:1;
        RBus_UInt32  ssrs_ls_1_1:1;
        RBus_UInt32  ssrs_ls_1_0:1;
        RBus_UInt32  ssrs_ls_0_0:1;
        RBus_UInt32  res2:8;
        RBus_UInt32  ssrs_rme_4_0:1;
        RBus_UInt32  ssrs_rme_3_0:1;
        RBus_UInt32  ssrs_rme_2_1:1;
        RBus_UInt32  ssrs_rme_2_0:1;
        RBus_UInt32  ssrs_rme_1_2:1;
        RBus_UInt32  ssrs_rme_1_1:1;
        RBus_UInt32  ssrs_rme_1_0:1;
        RBus_UInt32  ssrs_rme_0_0:1;
    };
}srnn_ssrs_rme_ls_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ssrs_test1_4_0:1;
        RBus_UInt32  ssrs_test1_3_0:1;
        RBus_UInt32  ssrs_test1_2_1:1;
        RBus_UInt32  ssrs_test1_2_0:1;
        RBus_UInt32  ssrs_test1_1_2:1;
        RBus_UInt32  ssrs_test1_1_1:1;
        RBus_UInt32  ssrs_test1_1_0:1;
        RBus_UInt32  ssrs_test1_0_0:1;
    };
}srnn_ssrs_test1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  ssrs_0_0_0_drf_bist_fail:1;
        RBus_UInt32  ssrs_0_0_1_drf_bist_fail:1;
        RBus_UInt32  ssrs_0_0_2_drf_bist_fail:1;
        RBus_UInt32  ssrs_0_0_3_drf_bist_fail:1;
        RBus_UInt32  ssrs_1_0_0_drf_bist_fail:1;
        RBus_UInt32  ssrs_1_0_1_drf_bist_fail:1;
        RBus_UInt32  ssrs_1_0_2_drf_bist_fail:1;
        RBus_UInt32  ssrs_1_0_3_drf_bist_fail:1;
        RBus_UInt32  ssrs_1_0_4_drf_bist_fail:1;
        RBus_UInt32  ssrs_1_0_5_drf_bist_fail:1;
        RBus_UInt32  ssrs_1_0_6_drf_bist_fail:1;
        RBus_UInt32  ssrs_1_0_7_drf_bist_fail:1;
        RBus_UInt32  ssrs_1_1_0_drf_bist_fail:1;
        RBus_UInt32  ssrs_1_1_1_drf_bist_fail:1;
        RBus_UInt32  ssrs_1_1_2_drf_bist_fail:1;
        RBus_UInt32  ssrs_1_1_3_drf_bist_fail:1;
        RBus_UInt32  ssrs_1_1_4_drf_bist_fail:1;
        RBus_UInt32  ssrs_1_1_5_drf_bist_fail:1;
        RBus_UInt32  ssrs_1_1_6_drf_bist_fail:1;
        RBus_UInt32  ssrs_1_1_7_drf_bist_fail:1;
        RBus_UInt32  ssrs_1_2_0_drf_bist_fail:1;
        RBus_UInt32  ssrs_1_2_1_drf_bist_fail:1;
        RBus_UInt32  ssrs_1_2_2_drf_bist_fail:1;
        RBus_UInt32  ssrs_1_2_3_drf_bist_fail:1;
        RBus_UInt32  ssrs_1_2_4_drf_bist_fail:1;
        RBus_UInt32  ssrs_1_2_5_drf_bist_fail:1;
        RBus_UInt32  ssrs_1_2_6_drf_bist_fail:1;
        RBus_UInt32  ssrs_1_2_7_drf_bist_fail:1;
    };
}srnn_ssrs_bist_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:13;
        RBus_UInt32  ssrs_2_0_0_drf_bist_fail:1;
        RBus_UInt32  ssrs_2_0_1_drf_bist_fail:1;
        RBus_UInt32  ssrs_2_0_2_drf_bist_fail:1;
        RBus_UInt32  ssrs_2_0_3_drf_bist_fail:1;
        RBus_UInt32  ssrs_2_0_4_drf_bist_fail:1;
        RBus_UInt32  ssrs_2_0_5_drf_bist_fail:1;
        RBus_UInt32  ssrs_2_0_6_drf_bist_fail:1;
        RBus_UInt32  ssrs_2_1_0_drf_bist_fail:1;
        RBus_UInt32  ssrs_2_1_1_drf_bist_fail:1;
        RBus_UInt32  ssrs_2_1_2_drf_bist_fail:1;
        RBus_UInt32  ssrs_2_1_3_drf_bist_fail:1;
        RBus_UInt32  ssrs_2_1_4_drf_bist_fail:1;
        RBus_UInt32  ssrs_2_1_5_drf_bist_fail:1;
        RBus_UInt32  ssrs_2_1_6_drf_bist_fail:1;
        RBus_UInt32  ssrs_3_0_0_drf_bist_fail:1;
        RBus_UInt32  ssrs_4_0_0_drf_bist_fail:1;
        RBus_UInt32  ssrs_4_0_1_drf_bist_fail:1;
        RBus_UInt32  ssrs_4_0_2_drf_bist_fail:1;
        RBus_UInt32  ssrs_4_0_3_drf_bist_fail:1;
    };
}srnn_ssrs_bist_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  ssrs_0_0_0_bist_fail:1;
        RBus_UInt32  ssrs_0_0_1_bist_fail:1;
        RBus_UInt32  ssrs_0_0_2_bist_fail:1;
        RBus_UInt32  ssrs_0_0_3_bist_fail:1;
        RBus_UInt32  ssrs_1_0_0_bist_fail:1;
        RBus_UInt32  ssrs_1_0_1_bist_fail:1;
        RBus_UInt32  ssrs_1_0_2_bist_fail:1;
        RBus_UInt32  ssrs_1_0_3_bist_fail:1;
        RBus_UInt32  ssrs_1_0_4_bist_fail:1;
        RBus_UInt32  ssrs_1_0_5_bist_fail:1;
        RBus_UInt32  ssrs_1_0_6_bist_fail:1;
        RBus_UInt32  ssrs_1_0_7_bist_fail:1;
        RBus_UInt32  ssrs_1_1_0_bist_fail:1;
        RBus_UInt32  ssrs_1_1_1_bist_fail:1;
        RBus_UInt32  ssrs_1_1_2_bist_fail:1;
        RBus_UInt32  ssrs_1_1_3_bist_fail:1;
        RBus_UInt32  ssrs_1_1_4_bist_fail:1;
        RBus_UInt32  ssrs_1_1_5_bist_fail:1;
        RBus_UInt32  ssrs_1_1_6_bist_fail:1;
        RBus_UInt32  ssrs_1_1_7_bist_fail:1;
        RBus_UInt32  ssrs_1_2_0_bist_fail:1;
        RBus_UInt32  ssrs_1_2_1_bist_fail:1;
        RBus_UInt32  ssrs_1_2_2_bist_fail:1;
        RBus_UInt32  ssrs_1_2_3_bist_fail:1;
        RBus_UInt32  ssrs_1_2_4_bist_fail:1;
        RBus_UInt32  ssrs_1_2_5_bist_fail:1;
        RBus_UInt32  ssrs_1_2_6_bist_fail:1;
        RBus_UInt32  ssrs_1_2_7_bist_fail:1;
    };
}srnn_ssrs_bist_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:13;
        RBus_UInt32  ssrs_2_0_0_bist_fail:1;
        RBus_UInt32  ssrs_2_0_1_bist_fail:1;
        RBus_UInt32  ssrs_2_0_2_bist_fail:1;
        RBus_UInt32  ssrs_2_0_3_bist_fail:1;
        RBus_UInt32  ssrs_2_0_4_bist_fail:1;
        RBus_UInt32  ssrs_2_0_5_bist_fail:1;
        RBus_UInt32  ssrs_2_0_6_bist_fail:1;
        RBus_UInt32  ssrs_2_1_0_bist_fail:1;
        RBus_UInt32  ssrs_2_1_1_bist_fail:1;
        RBus_UInt32  ssrs_2_1_2_bist_fail:1;
        RBus_UInt32  ssrs_2_1_3_bist_fail:1;
        RBus_UInt32  ssrs_2_1_4_bist_fail:1;
        RBus_UInt32  ssrs_2_1_5_bist_fail:1;
        RBus_UInt32  ssrs_2_1_6_bist_fail:1;
        RBus_UInt32  ssrs_3_0_0_bist_fail:1;
        RBus_UInt32  ssrs_4_0_0_bist_fail:1;
        RBus_UInt32  ssrs_4_0_1_bist_fail:1;
        RBus_UInt32  ssrs_4_0_2_bist_fail:1;
        RBus_UInt32  ssrs_4_0_3_bist_fail:1;
    };
}srnn_ssrs_bist_3_RBUS;

#else //apply LITTLE_ENDIAN

//======SRNN register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  bbbsr_var_diff_clip_loth:8;
        RBus_UInt32  bbbsr_var_diff_clip_hith:8;
        RBus_UInt32  bbbsr_const_dirsu_wt:6;
        RBus_UInt32  bbbsr_diff_max_flat_en:1;
        RBus_UInt32  bbbsr_matrix33_select2_en:1;
        RBus_UInt32  bbbsr_matrix33_select1_en:1;
        RBus_UInt32  bbbsr_blend_diff_clip3_en:1;
        RBus_UInt32  bbbsr_blend_diff_clip2_en:1;
        RBus_UInt32  bbbsr_blend_diff_clip1_en:1;
        RBus_UInt32  bbbsr_en:2;
        RBus_UInt32  res1:1;
        RBus_UInt32  srnn_func_en:1;
    };
}srnn_srnn_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  bbbsr_max_min_var_gain:4;
        RBus_UInt32  bbbsr_min_var_diff_th:8;
        RBus_UInt32  bbbsr_min_var_diff_clip_hi_min:8;
        RBus_UInt32  bbbsr_min_var_diff_clip_hi_gain:4;
        RBus_UInt32  bbbsr_slope_clip1:4;
        RBus_UInt32  bbbsr_clip_hi_method:2;
        RBus_UInt32  res1:2;
    };
}srnn_diff_clip_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  bbbsr_max_var_loth:8;
        RBus_UInt32  bbbsr_slope_clip2:8;
        RBus_UInt32  res1:16;
    };
}srnn_diff_clip2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  bbbsr_slope_clip3:8;
        RBus_UInt32  res1:8;
        RBus_UInt32  bbbsr_slope_clip3_weight:8;
        RBus_UInt32  res2:8;
    };
}srnn_diff_clip3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  bbbsr_dir_confid_loth:8;
        RBus_UInt32  bbbsr_slope_weight_var:8;
        RBus_UInt32  res1:8;
        RBus_UInt32  bbbsr_max_var_loth2:8;
    };
}srnn_diff_clip4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  bbbsr_var_cur_loth:8;
        RBus_UInt32  bbbsr_var_cur_w_hith:6;
        RBus_UInt32  res1:2;
        RBus_UInt32  bbbsr_var_cur_w_loth:6;
        RBus_UInt32  res2:10;
    };
}srnn_weight_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  bbbsr_diff_max_flat_coring:8;
        RBus_UInt32  bbbsr_diff_max_flat_gain:4;
        RBus_UInt32  res1:20;
    };
}srnn_flat_clip_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  bbbsr_blend_debug_mode:3;
        RBus_UInt32  res1:1;
        RBus_UInt32  bbbsr_blend_db_shift_bit:3;
        RBus_UInt32  res2:24;
        RBus_UInt32  bbbsr_blend_debug_en:1;
    };
}srnn_debug_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  bbbsr_diff_delta_gain:4;
        RBus_UInt32  bbbsr_diff_delta_coring:8;
        RBus_UInt32  bbbsr_diff_max_select:1;
        RBus_UInt32  res1:3;
        RBus_UInt32  bbbsr_dir_confid_len:4;
        RBus_UInt32  dummy181aa01c_31_20:12;
    };
}srnn_diff_gain_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  bbbsr_diff_delta_y_gain:4;
        RBus_UInt32  bbbsr_delta_y_coring:8;
        RBus_UInt32  bbbsr_delta_y_gain_en:1;
        RBus_UInt32  dummy181aa020_31_13:19;
    };
}srnn_diff_gain_y_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  demo_sr_v_end:13;
        RBus_UInt32  res1:3;
        RBus_UInt32  demo_sr_v_sta:13;
        RBus_UInt32  res2:3;
    };
}srnn_demo_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  demo_sr_h_end:13;
        RBus_UInt32  res1:3;
        RBus_UInt32  demo_sr_h_sta:13;
        RBus_UInt32  res2:3;
    };
}srnn_demo_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sr_linebuf_pixel_delay:13;
        RBus_UInt32  res1:12;
        RBus_UInt32  wdsr_delta_y_mode:1;
        RBus_UInt32  wdsr_y_delta_gain:6;
    };
}srnn_srnn_blend_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  db_apply:1;
        RBus_UInt32  db_read_level:1;
        RBus_UInt32  db_en:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  db_write_hold_cnt:4;
        RBus_UInt32  res2:24;
    };
}srnn_dm_srnn_db_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  bbbsr_dir_weight_dy_loth:8;
        RBus_UInt32  res1:3;
        RBus_UInt32  bbbsr_dir_weight_dy_th:6;
        RBus_UInt32  bbbsr_dir_weight_dy_hith:6;
        RBus_UInt32  bbbsr_dir_weight_dy_gain2:4;
        RBus_UInt32  bbbsr_dir_weight_dy_gain1:4;
        RBus_UInt32  bbbsr_dir_weight_dy_en:1;
    };
}srnn_diff_clip5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  srnn2wdsr_v_cnt:12;
        RBus_UInt32  srnn2wdsr_h_cnt:12;
        RBus_UInt32  uzu_input_size_err:1;
        RBus_UInt32  smt_rd_conflict_err:1;
        RBus_UInt32  srnn_pre_rd_udf:1;
        RBus_UInt32  two_step_overflow:1;
        RBus_UInt32  res1:4;
    };
}srnn_srnn_timing_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  wdsr2blend_v_cnt:12;
        RBus_UInt32  res1:4;
        RBus_UInt32  wdsr2blend_h_cnt:12;
        RBus_UInt32  res2:4;
    };
}srnn_srnn_timing_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  two_step_wr_pixel:12;
        RBus_UInt32  two_step_wr_line:12;
        RBus_UInt32  two_step_wr_rd_dbg_en:1;
        RBus_UInt32  res1:7;
    };
}srnn_srnn_timing_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  two_step_rd_pixel:12;
        RBus_UInt32  two_tep_rd_line:12;
        RBus_UInt32  res1:8;
    };
}srnn_srnn_timing_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  v8_y_c0_0:12;
        RBus_UInt32  res1:4;
        RBus_UInt32  v8_y_c0_1:12;
        RBus_UInt32  res2:4;
    };
}srnn_v8_y_ph0_coeff00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  v8_y_c0_2:12;
        RBus_UInt32  res1:4;
        RBus_UInt32  v8_y_c0_3:12;
        RBus_UInt32  res2:4;
    };
}srnn_v8_y_ph0_coeff01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  v8_y_c0_4:12;
        RBus_UInt32  res1:4;
        RBus_UInt32  v8_y_c0_5:12;
        RBus_UInt32  res2:4;
    };
}srnn_v8_y_ph0_coeff02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  v8_y_c0_6:12;
        RBus_UInt32  res1:4;
        RBus_UInt32  v8_y_c0_7:12;
        RBus_UInt32  res2:4;
    };
}srnn_v8_y_ph0_coeff03_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  v8_y_c1_0:12;
        RBus_UInt32  res1:4;
        RBus_UInt32  v8_y_c1_1:12;
        RBus_UInt32  res2:4;
    };
}srnn_v8_y_ph1_coeff00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  v8_y_c1_2:12;
        RBus_UInt32  res1:4;
        RBus_UInt32  v8_y_c1_3:12;
        RBus_UInt32  res2:4;
    };
}srnn_v8_y_ph1_coeff01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  v8_y_c1_4:12;
        RBus_UInt32  res1:4;
        RBus_UInt32  v8_y_c1_5:12;
        RBus_UInt32  res2:4;
    };
}srnn_v8_y_ph1_coeff02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  v8_y_c1_6:12;
        RBus_UInt32  res1:4;
        RBus_UInt32  v8_y_c1_7:12;
        RBus_UInt32  res2:4;
    };
}srnn_v8_y_ph1_coeff03_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  read_en:1;
        RBus_UInt32  write_en:1;
        RBus_UInt32  ch_sel:1;
        RBus_UInt32  cross_bar_en:1;
        RBus_UInt32  res1:28;
    };
}srnn_accessdata_ctrl_srnn_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  startx:13;
        RBus_UInt32  res1:3;
        RBus_UInt32  starty:12;
        RBus_UInt32  res2:4;
    };
}srnn_accessdata_posctrl_srnn_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  y00:10;
        RBus_UInt32  res1:6;
        RBus_UInt32  y01:10;
        RBus_UInt32  res2:6;
    };
}srnn_readdata_data_y1_srnn_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  y10:10;
        RBus_UInt32  res1:6;
        RBus_UInt32  y11:10;
        RBus_UInt32  res2:6;
    };
}srnn_readdata_data_y2_srnn_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  u00:10;
        RBus_UInt32  res1:6;
        RBus_UInt32  v00:10;
        RBus_UInt32  res2:6;
    };
}srnn_readdata_data_c1_srnn_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  u01:10;
        RBus_UInt32  res1:6;
        RBus_UInt32  v01:10;
        RBus_UInt32  res2:6;
    };
}srnn_readdata_data_c2_srnn_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  u10:10;
        RBus_UInt32  res1:6;
        RBus_UInt32  v10:10;
        RBus_UInt32  res2:6;
    };
}srnn_readdata_data_c3_srnn_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  u11:10;
        RBus_UInt32  res1:6;
        RBus_UInt32  v11:10;
        RBus_UInt32  res2:6;
    };
}srnn_readdata_data_c4_srnn_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  y:4;
        RBus_UInt32  u:4;
        RBus_UInt32  v:4;
        RBus_UInt32  res1:20;
    };
}srnn_writedata_data_srnn_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer1_weight_00:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer1_3x3_weights_1_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer1_weight_01:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer1_3x3_weights_1_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer1_weight_02:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer1_3x3_weights_1_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer1_weight_10:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer1_3x3_weights_1_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer1_weight_11:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer1_3x3_weights_1_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer1_weight_12:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer1_3x3_weights_1_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer1_weight_20:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer1_3x3_weights_1_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer1_weight_21:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer1_3x3_weights_1_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer1_weight_22:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer1_3x3_weights_1_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer1_weight_00:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer1_3x3_weights_2_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer1_weight_01:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer1_3x3_weights_2_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer1_weight_02:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer1_3x3_weights_2_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer1_weight_10:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer1_3x3_weights_2_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer1_weight_11:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer1_3x3_weights_2_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer1_weight_12:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer1_3x3_weights_2_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer1_weight_20:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer1_3x3_weights_2_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer1_weight_21:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer1_3x3_weights_2_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer1_weight_22:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer1_3x3_weights_2_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer1_weight_00:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer1_3x3_weights_3_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer1_weight_01:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer1_3x3_weights_3_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer1_weight_02:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer1_3x3_weights_3_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer1_weight_10:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer1_3x3_weights_3_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer1_weight_11:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer1_3x3_weights_3_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer1_weight_12:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer1_3x3_weights_3_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer1_weight_20:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer1_3x3_weights_3_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer1_weight_21:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer1_3x3_weights_3_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer1_weight_22:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer1_3x3_weights_3_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer1_weight_00:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer1_3x3_weights_4_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer1_weight_01:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer1_3x3_weights_4_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer1_weight_02:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer1_3x3_weights_4_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer1_weight_10:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer1_3x3_weights_4_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer1_weight_11:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer1_3x3_weights_4_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer1_weight_12:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer1_3x3_weights_4_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer1_weight_20:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer1_3x3_weights_4_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer1_weight_21:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer1_3x3_weights_4_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer1_weight_22:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer1_3x3_weights_4_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer1_weight_00:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer1_3x3_weights_5_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer1_weight_01:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer1_3x3_weights_5_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer1_weight_02:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer1_3x3_weights_5_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer1_weight_10:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer1_3x3_weights_5_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer1_weight_11:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer1_3x3_weights_5_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer1_weight_12:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer1_3x3_weights_5_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer1_weight_20:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer1_3x3_weights_5_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer1_weight_21:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer1_3x3_weights_5_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer1_weight_22:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer1_3x3_weights_5_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer1_weight_00:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer1_3x3_weights_6_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer1_weight_01:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer1_3x3_weights_6_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer1_weight_02:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer1_3x3_weights_6_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer1_weight_10:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer1_3x3_weights_6_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer1_weight_11:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer1_3x3_weights_6_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer1_weight_12:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer1_3x3_weights_6_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer1_weight_20:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer1_3x3_weights_6_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer1_weight_21:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer1_3x3_weights_6_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer1_weight_22:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer1_3x3_weights_6_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer1_weight_00:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer1_3x3_weights_7_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer1_weight_01:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer1_3x3_weights_7_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer1_weight_02:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer1_3x3_weights_7_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer1_weight_10:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer1_3x3_weights_7_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer1_weight_11:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer1_3x3_weights_7_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer1_weight_12:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer1_3x3_weights_7_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer1_weight_20:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer1_3x3_weights_7_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer1_weight_21:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer1_3x3_weights_7_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer1_weight_22:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer1_3x3_weights_7_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer1_weight_00:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer1_3x3_weights_8_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer1_weight_01:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer1_3x3_weights_8_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer1_weight_02:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer1_3x3_weights_8_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer1_weight_10:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer1_3x3_weights_8_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer1_weight_11:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer1_3x3_weights_8_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer1_weight_12:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer1_3x3_weights_8_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer1_weight_20:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer1_3x3_weights_8_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer1_weight_21:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer1_3x3_weights_8_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer1_weight_22:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer1_3x3_weights_8_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer1_bias_1:9;
        RBus_UInt32  res1:23;
    };
}srnn_wdsr_layer1_3x3_bias_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer1_bias_2:9;
        RBus_UInt32  res1:23;
    };
}srnn_wdsr_layer1_3x3_bias_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer1_bias_3:9;
        RBus_UInt32  res1:23;
    };
}srnn_wdsr_layer1_3x3_bias_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer1_bias_4:9;
        RBus_UInt32  res1:23;
    };
}srnn_wdsr_layer1_3x3_bias_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer1_bias_5:9;
        RBus_UInt32  res1:23;
    };
}srnn_wdsr_layer1_3x3_bias_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer1_bias_6:9;
        RBus_UInt32  res1:23;
    };
}srnn_wdsr_layer1_3x3_bias_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer1_bias_7:9;
        RBus_UInt32  res1:23;
    };
}srnn_wdsr_layer1_3x3_bias_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer1_bias_8:9;
        RBus_UInt32  res1:23;
    };
}srnn_wdsr_layer1_3x3_bias_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_00:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer2_3x3_weights_1_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_01:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer2_3x3_weights_1_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_02:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer2_3x3_weights_1_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_10:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer2_3x3_weights_1_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_11:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer2_3x3_weights_1_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_12:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer2_3x3_weights_1_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_20:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer2_3x3_weights_1_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_21:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer2_3x3_weights_1_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_22:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer2_3x3_weights_1_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_00:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer2_3x3_weights_2_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_01:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer2_3x3_weights_2_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_02:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer2_3x3_weights_2_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_10:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer2_3x3_weights_2_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_11:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer2_3x3_weights_2_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_12:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer2_3x3_weights_2_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_20:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer2_3x3_weights_2_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_21:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer2_3x3_weights_2_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_22:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer2_3x3_weights_2_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_00:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer2_3x3_weights_3_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_01:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer2_3x3_weights_3_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_02:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer2_3x3_weights_3_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_10:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer2_3x3_weights_3_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_11:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer2_3x3_weights_3_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_12:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer2_3x3_weights_3_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_20:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer2_3x3_weights_3_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_21:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer2_3x3_weights_3_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_22:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer2_3x3_weights_3_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_00:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer2_3x3_weights_4_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_01:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer2_3x3_weights_4_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_02:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer2_3x3_weights_4_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_10:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer2_3x3_weights_4_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_11:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer2_3x3_weights_4_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_12:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer2_3x3_weights_4_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_20:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer2_3x3_weights_4_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_21:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer2_3x3_weights_4_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_22:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer2_3x3_weights_4_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_00:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer2_3x3_weights_5_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_01:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer2_3x3_weights_5_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_02:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer2_3x3_weights_5_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_10:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer2_3x3_weights_5_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_11:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer2_3x3_weights_5_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_12:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer2_3x3_weights_5_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_20:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer2_3x3_weights_5_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_21:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer2_3x3_weights_5_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_22:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer2_3x3_weights_5_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_00:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer2_3x3_weights_6_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_01:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer2_3x3_weights_6_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_02:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer2_3x3_weights_6_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_10:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer2_3x3_weights_6_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_11:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer2_3x3_weights_6_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_12:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer2_3x3_weights_6_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_20:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer2_3x3_weights_6_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_21:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer2_3x3_weights_6_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_22:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer2_3x3_weights_6_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_00:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer2_3x3_weights_7_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_01:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer2_3x3_weights_7_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_02:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer2_3x3_weights_7_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_10:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer2_3x3_weights_7_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_11:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer2_3x3_weights_7_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_12:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer2_3x3_weights_7_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_20:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer2_3x3_weights_7_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_21:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer2_3x3_weights_7_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_22:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer2_3x3_weights_7_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_00:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer2_3x3_weights_8_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_01:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer2_3x3_weights_8_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_02:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer2_3x3_weights_8_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_10:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer2_3x3_weights_8_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_11:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer2_3x3_weights_8_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_12:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer2_3x3_weights_8_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_20:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer2_3x3_weights_8_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_21:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer2_3x3_weights_8_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_22:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer2_3x3_weights_8_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_bias_1:9;
        RBus_UInt32  res1:23;
    };
}srnn_wdsr_layer2_3x3_bias_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_bias_2:9;
        RBus_UInt32  res1:23;
    };
}srnn_wdsr_layer2_3x3_bias_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_bias_3:9;
        RBus_UInt32  res1:23;
    };
}srnn_wdsr_layer2_3x3_bias_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_bias_4:9;
        RBus_UInt32  res1:23;
    };
}srnn_wdsr_layer2_3x3_bias_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_bias_5:9;
        RBus_UInt32  res1:23;
    };
}srnn_wdsr_layer2_3x3_bias_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_bias_6:9;
        RBus_UInt32  res1:23;
    };
}srnn_wdsr_layer2_3x3_bias_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_bias_7:9;
        RBus_UInt32  res1:23;
    };
}srnn_wdsr_layer2_3x3_bias_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_bias_8:9;
        RBus_UInt32  res1:23;
    };
}srnn_wdsr_layer2_3x3_bias_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_1:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_1_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_2:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_1_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_3:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_1_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_4:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_1_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_5:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_1_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_6:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_1_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_7:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_1_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_8:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_1_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_1:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_2_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_2:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_2_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_3:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_2_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_4:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_2_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_5:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_2_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_6:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_2_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_7:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_2_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_8:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_2_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_1:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_3_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_2:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_3_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_3:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_3_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_4:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_3_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_5:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_3_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_6:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_3_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_7:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_3_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_8:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_3_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_1:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_4_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_2:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_4_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_3:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_4_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_4:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_4_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_5:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_4_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_6:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_4_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_7:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_4_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_8:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_4_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_1:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_5_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_2:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_5_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_3:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_5_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_4:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_5_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_5:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_5_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_6:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_5_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_7:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_5_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_8:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_5_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_1:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_6_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_2:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_6_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_3:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_6_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_4:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_6_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_5:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_6_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_6:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_6_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_7:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_6_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_8:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_6_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_1:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_7_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_2:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_7_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_3:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_7_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_4:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_7_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_5:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_7_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_6:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_7_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_7:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_7_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_8:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_7_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_1:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_8_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_2:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_8_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_3:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_8_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_4:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_8_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_5:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_8_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_6:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_8_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_7:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_8_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_8:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_8_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_1:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_9_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_2:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_9_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_3:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_9_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_4:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_9_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_5:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_9_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_6:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_9_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_7:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_9_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_8:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_9_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_1:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_10_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_2:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_10_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_3:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_10_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_4:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_10_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_5:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_10_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_6:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_10_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_7:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_10_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_8:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_10_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_1:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_11_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_2:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_11_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_3:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_11_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_4:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_11_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_5:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_11_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_6:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_11_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_7:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_11_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_8:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_11_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_1:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_12_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_2:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_12_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_3:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_12_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_4:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_12_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_5:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_12_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_6:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_12_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_7:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_12_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_8:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_12_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_1:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_13_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_2:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_13_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_3:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_13_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_4:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_13_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_5:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_13_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_6:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_13_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_7:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_13_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_8:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_13_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_1:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_14_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_2:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_14_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_3:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_14_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_4:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_14_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_5:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_14_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_6:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_14_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_7:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_14_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_8:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_14_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_1:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_15_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_2:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_15_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_3:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_15_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_4:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_15_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_5:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_15_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_6:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_15_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_7:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_15_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_8:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_15_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_1:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_16_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_2:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_16_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_3:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_16_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_4:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_16_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_5:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_16_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_6:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_16_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_7:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_16_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_8:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_16_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_1:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_17_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_2:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_17_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_3:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_17_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_4:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_17_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_5:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_17_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_6:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_17_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_7:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_17_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_8:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_17_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_1:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_18_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_2:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_18_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_3:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_18_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_4:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_18_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_5:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_18_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_6:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_18_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_7:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_18_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_8:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_18_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_1:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_19_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_2:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_19_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_3:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_19_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_4:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_19_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_5:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_19_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_6:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_19_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_7:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_19_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_8:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_19_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_1:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_20_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_2:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_20_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_3:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_20_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_4:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_20_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_5:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_20_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_6:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_20_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_7:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_20_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_8:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_20_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_1:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_21_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_2:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_21_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_3:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_21_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_4:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_21_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_5:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_21_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_6:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_21_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_7:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_21_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_8:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_21_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_1:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_22_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_2:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_22_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_3:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_22_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_4:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_22_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_5:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_22_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_6:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_22_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_7:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_22_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_8:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_22_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_1:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_23_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_2:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_23_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_3:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_23_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_4:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_23_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_5:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_23_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_6:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_23_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_7:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_23_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_8:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_23_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_1:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_24_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_2:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_24_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_3:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_24_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_4:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_24_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_5:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_24_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_6:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_24_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_7:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_24_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_8:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_24_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_1:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_25_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_2:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_25_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_3:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_25_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_4:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_25_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_5:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_25_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_6:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_25_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_7:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_25_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_8:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_25_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_1:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_26_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_2:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_26_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_3:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_26_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_4:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_26_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_5:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_26_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_6:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_26_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_7:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_26_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_8:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_26_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_1:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_27_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_2:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_27_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_3:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_27_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_4:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_27_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_5:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_27_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_6:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_27_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_7:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_27_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_8:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_27_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_1:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_28_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_2:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_28_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_3:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_28_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_4:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_28_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_5:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_28_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_6:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_28_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_7:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_28_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_8:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_28_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_1:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_29_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_2:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_29_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_3:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_29_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_4:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_29_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_5:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_29_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_6:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_29_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_7:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_29_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_8:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_29_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_1:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_30_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_2:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_30_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_3:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_30_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_4:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_30_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_5:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_30_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_6:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_30_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_7:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_30_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_8:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_30_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_1:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_31_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_2:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_31_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_3:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_31_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_4:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_31_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_5:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_31_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_6:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_31_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_7:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_31_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_8:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_31_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_1:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_32_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_2:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_32_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_3:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_32_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_4:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_32_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_5:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_32_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_6:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_32_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_7:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_32_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_weight_8:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_weights_32_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_bias_1:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_bias_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_bias_2:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_bias_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_bias_3:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_bias_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_bias_4:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_bias_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_bias_5:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_bias_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_bias_6:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_bias_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_bias_7:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_bias_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_bias_8:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_bias_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_bias_9:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_bias_9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_bias_10:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_bias_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_bias_11:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_bias_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_bias_12:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_bias_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_bias_13:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_bias_13_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_bias_14:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_bias_14_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_bias_15:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_bias_15_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_bias_16:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_bias_16_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_bias_17:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_bias_17_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_bias_18:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_bias_18_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_bias_19:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_bias_19_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_bias_20:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_bias_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_bias_21:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_bias_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_bias_22:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_bias_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_bias_23:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_bias_23_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_bias_24:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_bias_24_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_bias_25:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_bias_25_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_bias_26:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_bias_26_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_bias_27:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_bias_27_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_bias_28:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_bias_28_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_bias_29:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_bias_29_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_bias_30:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_bias_30_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_bias_31:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_bias_31_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer2_bias_32:11;
        RBus_UInt32  res1:21;
    };
}srnn_wdsr_layer2_1x1_bias_32_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_00:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_1_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_01:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_1_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_02:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_1_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_10:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_1_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_11:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_1_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_12:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_1_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_20:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_1_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_21:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_1_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_22:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_1_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_00:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_2_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_01:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_2_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_02:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_2_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_10:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_2_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_11:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_2_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_12:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_2_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_20:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_2_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_21:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_2_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_22:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_2_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_00:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_3_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_01:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_3_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_02:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_3_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_10:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_3_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_11:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_3_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_12:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_3_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_20:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_3_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_21:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_3_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_22:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_3_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_00:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_4_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_01:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_4_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_02:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_4_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_10:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_4_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_11:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_4_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_12:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_4_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_20:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_4_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_21:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_4_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_22:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_4_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_00:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_5_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_01:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_5_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_02:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_5_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_10:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_5_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_11:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_5_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_12:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_5_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_20:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_5_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_21:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_5_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_22:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_5_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_00:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_6_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_01:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_6_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_02:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_6_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_10:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_6_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_11:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_6_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_12:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_6_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_20:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_6_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_21:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_6_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_22:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_6_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_00:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_7_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_01:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_7_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_02:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_7_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_10:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_7_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_11:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_7_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_12:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_7_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_20:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_7_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_21:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_7_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_22:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_7_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_00:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_8_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_01:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_8_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_02:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_8_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_10:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_8_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_11:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_8_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_12:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_8_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_20:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_8_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_21:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_8_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_22:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_8_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_00:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_9_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_01:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_9_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_02:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_9_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_10:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_9_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_11:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_9_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_12:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_9_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_20:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_9_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_21:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_9_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_22:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_9_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_00:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_10_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_01:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_10_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_02:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_10_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_10:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_10_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_11:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_10_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_12:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_10_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_20:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_10_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_21:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_10_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_22:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_10_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_00:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_11_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_01:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_11_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_02:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_11_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_10:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_11_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_11:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_11_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_12:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_11_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_20:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_11_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_21:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_11_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_22:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_11_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_00:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_12_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_01:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_12_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_02:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_12_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_10:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_12_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_11:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_12_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_12:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_12_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_20:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_12_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_21:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_12_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_22:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_12_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_00:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_13_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_01:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_13_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_02:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_13_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_10:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_13_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_11:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_13_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_12:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_13_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_20:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_13_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_21:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_13_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_22:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_13_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_00:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_14_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_01:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_14_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_02:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_14_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_10:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_14_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_11:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_14_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_12:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_14_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_20:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_14_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_21:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_14_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_22:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_14_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_00:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_15_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_01:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_15_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_02:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_15_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_10:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_15_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_11:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_15_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_12:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_15_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_20:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_15_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_21:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_15_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_22:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_15_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_00:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_16_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_01:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_16_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_02:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_16_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_10:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_16_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_11:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_16_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_12:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_16_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_20:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_16_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_21:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_16_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_22:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_16_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_00:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_17_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_01:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_17_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_02:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_17_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_10:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_17_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_11:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_17_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_12:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_17_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_20:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_17_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_21:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_17_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_22:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_17_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_00:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_18_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_01:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_18_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_02:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_18_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_10:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_18_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_11:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_18_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_12:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_18_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_20:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_18_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_21:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_18_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_22:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_18_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_00:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_19_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_01:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_19_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_02:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_19_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_10:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_19_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_11:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_19_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_12:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_19_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_20:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_19_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_21:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_19_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_22:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_19_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_00:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_20_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_01:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_20_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_02:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_20_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_10:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_20_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_11:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_20_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_12:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_20_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_20:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_20_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_21:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_20_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_22:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_20_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_00:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_21_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_01:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_21_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_02:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_21_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_10:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_21_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_11:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_21_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_12:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_21_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_20:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_21_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_21:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_21_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_22:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_21_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_00:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_22_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_01:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_22_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_02:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_22_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_10:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_22_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_11:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_22_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_12:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_22_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_20:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_22_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_21:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_22_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_22:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_22_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_00:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_23_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_01:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_23_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_02:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_23_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_10:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_23_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_11:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_23_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_12:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_23_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_20:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_23_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_21:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_23_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_22:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_23_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_00:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_24_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_01:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_24_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_02:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_24_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_10:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_24_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_11:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_24_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_12:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_24_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_20:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_24_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_21:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_24_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_22:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_24_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_00:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_25_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_01:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_25_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_02:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_25_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_10:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_25_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_11:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_25_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_12:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_25_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_20:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_25_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_21:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_25_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_22:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_25_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_00:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_26_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_01:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_26_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_02:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_26_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_10:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_26_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_11:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_26_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_12:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_26_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_20:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_26_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_21:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_26_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_22:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_26_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_00:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_27_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_01:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_27_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_02:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_27_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_10:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_27_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_11:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_27_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_12:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_27_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_20:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_27_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_21:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_27_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_22:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_27_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_00:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_28_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_01:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_28_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_02:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_28_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_10:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_28_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_11:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_28_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_12:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_28_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_20:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_28_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_21:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_28_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_22:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_28_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_00:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_29_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_01:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_29_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_02:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_29_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_10:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_29_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_11:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_29_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_12:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_29_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_20:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_29_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_21:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_29_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_22:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_29_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_00:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_30_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_01:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_30_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_02:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_30_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_10:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_30_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_11:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_30_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_12:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_30_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_20:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_30_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_21:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_30_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_22:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_30_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_00:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_31_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_01:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_31_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_02:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_31_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_10:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_31_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_11:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_31_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_12:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_31_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_20:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_31_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_21:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_31_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_22:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_31_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_00:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_32_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_01:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_32_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_02:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_32_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_10:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_32_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_11:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_32_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_12:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_32_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_20:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_32_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_21:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_32_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_22:12;
        RBus_UInt32  res1:20;
    };
}srnn_wdsr_layer3_3x3_weights_32_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_bias_1:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_3x3_bias_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_bias_2:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_3x3_bias_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_bias_3:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_3x3_bias_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_bias_4:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_3x3_bias_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_bias_5:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_3x3_bias_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_bias_6:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_3x3_bias_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_bias_7:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_3x3_bias_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_bias_8:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_3x3_bias_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_bias_9:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_3x3_bias_9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_bias_10:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_3x3_bias_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_bias_11:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_3x3_bias_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_bias_12:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_3x3_bias_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_bias_13:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_3x3_bias_13_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_bias_14:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_3x3_bias_14_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_bias_15:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_3x3_bias_15_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_bias_16:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_3x3_bias_16_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_bias_17:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_3x3_bias_17_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_bias_18:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_3x3_bias_18_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_bias_19:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_3x3_bias_19_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_bias_20:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_3x3_bias_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_bias_21:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_3x3_bias_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_bias_22:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_3x3_bias_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_bias_23:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_3x3_bias_23_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_bias_24:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_3x3_bias_24_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_bias_25:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_3x3_bias_25_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_bias_26:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_3x3_bias_26_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_bias_27:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_3x3_bias_27_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_bias_28:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_3x3_bias_28_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_bias_29:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_3x3_bias_29_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_bias_30:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_3x3_bias_30_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_bias_31:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_3x3_bias_31_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_bias_32:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_3x3_bias_32_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_1:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_1_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_2:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_1_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_3:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_1_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_4:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_1_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_5:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_1_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_6:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_1_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_7:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_1_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_8:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_1_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_9:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_1_9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_10:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_1_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_11:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_1_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_12:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_1_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_13:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_1_13_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_14:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_1_14_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_15:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_1_15_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_16:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_1_16_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_17:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_1_17_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_18:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_1_18_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_19:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_1_19_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_20:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_1_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_21:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_1_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_22:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_1_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_23:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_1_23_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_24:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_1_24_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_25:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_1_25_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_26:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_1_26_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_27:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_1_27_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_28:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_1_28_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_29:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_1_29_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_30:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_1_30_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_31:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_1_31_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_32:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_1_32_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_1:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_2_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_2:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_2_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_3:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_2_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_4:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_2_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_5:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_2_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_6:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_2_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_7:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_2_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_8:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_2_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_9:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_2_9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_10:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_2_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_11:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_2_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_12:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_2_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_13:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_2_13_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_14:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_2_14_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_15:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_2_15_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_16:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_2_16_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_17:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_2_17_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_18:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_2_18_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_19:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_2_19_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_20:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_2_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_21:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_2_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_22:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_2_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_23:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_2_23_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_24:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_2_24_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_25:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_2_25_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_26:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_2_26_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_27:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_2_27_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_28:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_2_28_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_29:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_2_29_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_30:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_2_30_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_31:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_2_31_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_32:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_2_32_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_1:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_3_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_2:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_3_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_3:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_3_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_4:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_3_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_5:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_3_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_6:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_3_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_7:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_3_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_8:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_3_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_9:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_3_9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_10:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_3_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_11:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_3_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_12:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_3_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_13:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_3_13_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_14:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_3_14_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_15:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_3_15_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_16:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_3_16_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_17:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_3_17_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_18:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_3_18_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_19:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_3_19_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_20:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_3_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_21:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_3_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_22:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_3_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_23:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_3_23_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_24:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_3_24_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_25:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_3_25_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_26:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_3_26_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_27:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_3_27_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_28:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_3_28_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_29:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_3_29_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_30:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_3_30_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_31:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_3_31_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_32:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_3_32_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_1:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_4_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_2:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_4_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_3:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_4_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_4:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_4_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_5:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_4_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_6:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_4_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_7:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_4_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_8:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_4_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_9:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_4_9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_10:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_4_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_11:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_4_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_12:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_4_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_13:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_4_13_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_14:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_4_14_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_15:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_4_15_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_16:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_4_16_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_17:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_4_17_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_18:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_4_18_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_19:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_4_19_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_20:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_4_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_21:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_4_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_22:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_4_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_23:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_4_23_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_24:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_4_24_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_25:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_4_25_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_26:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_4_26_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_27:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_4_27_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_28:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_4_28_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_29:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_4_29_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_30:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_4_30_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_31:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_4_31_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_32:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_4_32_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_1:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_5_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_2:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_5_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_3:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_5_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_4:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_5_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_5:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_5_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_6:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_5_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_7:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_5_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_8:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_5_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_9:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_5_9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_10:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_5_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_11:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_5_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_12:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_5_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_13:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_5_13_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_14:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_5_14_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_15:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_5_15_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_16:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_5_16_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_17:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_5_17_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_18:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_5_18_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_19:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_5_19_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_20:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_5_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_21:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_5_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_22:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_5_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_23:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_5_23_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_24:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_5_24_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_25:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_5_25_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_26:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_5_26_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_27:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_5_27_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_28:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_5_28_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_29:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_5_29_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_30:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_5_30_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_31:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_5_31_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_32:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_5_32_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_1:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_6_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_2:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_6_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_3:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_6_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_4:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_6_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_5:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_6_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_6:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_6_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_7:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_6_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_8:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_6_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_9:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_6_9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_10:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_6_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_11:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_6_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_12:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_6_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_13:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_6_13_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_14:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_6_14_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_15:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_6_15_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_16:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_6_16_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_17:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_6_17_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_18:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_6_18_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_19:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_6_19_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_20:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_6_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_21:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_6_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_22:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_6_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_23:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_6_23_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_24:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_6_24_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_25:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_6_25_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_26:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_6_26_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_27:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_6_27_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_28:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_6_28_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_29:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_6_29_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_30:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_6_30_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_31:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_6_31_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_32:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_6_32_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_1:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_7_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_2:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_7_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_3:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_7_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_4:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_7_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_5:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_7_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_6:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_7_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_7:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_7_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_8:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_7_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_9:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_7_9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_10:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_7_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_11:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_7_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_12:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_7_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_13:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_7_13_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_14:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_7_14_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_15:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_7_15_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_16:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_7_16_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_17:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_7_17_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_18:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_7_18_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_19:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_7_19_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_20:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_7_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_21:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_7_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_22:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_7_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_23:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_7_23_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_24:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_7_24_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_25:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_7_25_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_26:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_7_26_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_27:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_7_27_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_28:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_7_28_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_29:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_7_29_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_30:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_7_30_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_31:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_7_31_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_32:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_7_32_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_1:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_8_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_2:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_8_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_3:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_8_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_4:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_8_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_5:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_8_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_6:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_8_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_7:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_8_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_8:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_8_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_9:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_8_9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_10:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_8_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_11:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_8_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_12:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_8_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_13:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_8_13_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_14:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_8_14_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_15:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_8_15_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_16:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_8_16_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_17:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_8_17_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_18:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_8_18_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_19:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_8_19_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_20:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_8_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_21:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_8_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_22:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_8_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_23:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_8_23_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_24:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_8_24_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_25:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_8_25_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_26:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_8_26_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_27:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_8_27_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_28:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_8_28_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_29:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_8_29_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_30:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_8_30_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_31:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_8_31_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_weight_32:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_weights_8_32_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_bias_1:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_bias_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_bias_2:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_bias_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_bias_3:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_bias_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_bias_4:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_bias_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_bias_5:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_bias_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_bias_6:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_bias_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_bias_7:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_bias_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer3_bias_8:10;
        RBus_UInt32  res1:22;
    };
}srnn_wdsr_layer3_1x1_bias_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_00:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_1_1_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_01:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_1_1_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_02:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_1_1_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_10:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_1_1_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_11:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_1_1_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_12:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_1_1_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_20:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_1_1_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_21:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_1_1_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_22:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_1_1_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_00:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_1_2_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_01:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_1_2_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_02:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_1_2_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_10:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_1_2_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_11:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_1_2_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_12:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_1_2_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_20:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_1_2_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_21:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_1_2_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_22:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_1_2_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_00:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_1_3_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_01:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_1_3_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_02:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_1_3_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_10:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_1_3_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_11:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_1_3_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_12:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_1_3_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_20:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_1_3_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_21:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_1_3_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_22:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_1_3_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_00:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_1_4_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_01:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_1_4_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_02:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_1_4_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_10:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_1_4_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_11:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_1_4_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_12:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_1_4_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_20:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_1_4_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_21:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_1_4_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_22:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_1_4_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_00:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_1_5_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_01:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_1_5_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_02:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_1_5_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_10:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_1_5_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_11:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_1_5_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_12:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_1_5_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_20:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_1_5_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_21:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_1_5_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_22:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_1_5_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_00:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_1_6_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_01:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_1_6_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_02:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_1_6_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_10:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_1_6_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_11:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_1_6_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_12:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_1_6_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_20:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_1_6_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_21:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_1_6_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_22:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_1_6_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_00:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_1_7_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_01:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_1_7_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_02:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_1_7_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_10:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_1_7_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_11:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_1_7_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_12:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_1_7_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_20:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_1_7_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_21:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_1_7_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_22:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_1_7_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_00:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_1_8_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_01:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_1_8_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_02:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_1_8_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_10:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_1_8_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_11:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_1_8_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_12:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_1_8_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_20:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_1_8_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_21:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_1_8_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_22:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_1_8_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_00:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_2_1_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_01:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_2_1_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_02:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_2_1_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_10:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_2_1_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_11:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_2_1_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_12:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_2_1_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_20:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_2_1_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_21:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_2_1_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_22:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_2_1_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_00:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_2_2_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_01:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_2_2_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_02:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_2_2_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_10:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_2_2_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_11:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_2_2_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_12:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_2_2_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_20:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_2_2_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_21:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_2_2_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_22:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_2_2_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_00:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_2_3_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_01:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_2_3_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_02:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_2_3_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_10:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_2_3_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_11:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_2_3_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_12:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_2_3_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_20:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_2_3_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_21:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_2_3_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_22:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_2_3_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_00:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_2_4_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_01:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_2_4_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_02:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_2_4_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_10:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_2_4_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_11:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_2_4_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_12:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_2_4_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_20:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_2_4_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_21:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_2_4_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_22:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_2_4_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_00:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_2_5_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_01:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_2_5_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_02:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_2_5_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_10:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_2_5_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_11:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_2_5_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_12:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_2_5_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_20:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_2_5_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_21:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_2_5_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_22:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_2_5_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_00:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_2_6_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_01:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_2_6_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_02:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_2_6_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_10:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_2_6_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_11:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_2_6_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_12:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_2_6_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_20:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_2_6_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_21:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_2_6_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_22:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_2_6_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_00:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_2_7_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_01:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_2_7_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_02:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_2_7_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_10:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_2_7_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_11:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_2_7_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_12:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_2_7_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_20:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_2_7_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_21:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_2_7_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_22:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_2_7_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_00:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_2_8_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_01:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_2_8_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_02:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_2_8_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_10:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_2_8_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_11:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_2_8_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_12:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_2_8_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_20:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_2_8_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_21:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_2_8_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_22:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_2_8_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_00:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_3_1_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_01:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_3_1_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_02:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_3_1_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_10:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_3_1_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_11:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_3_1_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_12:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_3_1_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_20:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_3_1_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_21:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_3_1_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_22:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_3_1_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_00:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_3_2_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_01:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_3_2_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_02:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_3_2_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_10:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_3_2_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_11:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_3_2_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_12:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_3_2_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_20:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_3_2_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_21:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_3_2_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_22:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_3_2_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_00:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_3_3_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_01:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_3_3_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_02:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_3_3_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_10:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_3_3_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_11:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_3_3_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_12:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_3_3_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_20:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_3_3_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_21:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_3_3_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_22:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_3_3_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_00:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_3_4_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_01:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_3_4_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_02:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_3_4_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_10:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_3_4_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_11:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_3_4_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_12:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_3_4_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_20:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_3_4_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_21:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_3_4_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_22:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_3_4_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_00:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_3_5_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_01:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_3_5_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_02:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_3_5_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_10:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_3_5_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_11:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_3_5_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_12:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_3_5_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_20:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_3_5_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_21:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_3_5_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_22:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_3_5_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_00:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_3_6_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_01:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_3_6_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_02:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_3_6_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_10:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_3_6_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_11:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_3_6_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_12:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_3_6_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_20:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_3_6_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_21:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_3_6_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_22:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_3_6_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_00:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_3_7_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_01:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_3_7_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_02:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_3_7_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_10:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_3_7_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_11:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_3_7_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_12:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_3_7_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_20:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_3_7_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_21:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_3_7_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_22:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_3_7_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_00:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_3_8_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_01:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_3_8_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_02:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_3_8_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_10:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_3_8_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_11:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_3_8_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_12:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_3_8_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_20:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_3_8_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_21:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_3_8_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_22:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_3_8_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_00:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_4_1_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_01:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_4_1_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_02:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_4_1_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_10:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_4_1_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_11:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_4_1_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_12:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_4_1_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_20:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_4_1_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_21:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_4_1_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_22:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_4_1_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_00:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_4_2_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_01:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_4_2_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_02:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_4_2_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_10:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_4_2_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_11:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_4_2_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_12:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_4_2_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_20:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_4_2_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_21:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_4_2_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_22:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_4_2_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_00:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_4_3_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_01:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_4_3_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_02:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_4_3_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_10:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_4_3_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_11:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_4_3_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_12:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_4_3_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_20:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_4_3_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_21:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_4_3_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_22:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_4_3_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_00:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_4_4_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_01:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_4_4_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_02:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_4_4_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_10:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_4_4_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_11:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_4_4_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_12:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_4_4_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_20:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_4_4_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_21:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_4_4_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_22:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_4_4_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_00:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_4_5_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_01:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_4_5_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_02:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_4_5_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_10:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_4_5_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_11:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_4_5_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_12:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_4_5_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_20:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_4_5_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_21:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_4_5_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_22:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_4_5_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_00:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_4_6_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_01:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_4_6_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_02:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_4_6_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_10:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_4_6_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_11:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_4_6_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_12:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_4_6_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_20:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_4_6_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_21:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_4_6_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_22:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_4_6_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_00:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_4_7_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_01:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_4_7_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_02:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_4_7_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_10:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_4_7_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_11:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_4_7_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_12:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_4_7_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_20:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_4_7_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_21:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_4_7_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_22:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_4_7_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_00:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_4_8_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_01:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_4_8_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_02:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_4_8_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_10:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_4_8_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_11:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_4_8_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_12:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_4_8_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_20:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_4_8_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_21:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_4_8_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_weight_22:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_weights_4_8_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_bias_1:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_bias_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_bias_2:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_bias_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_bias_3:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_bias_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  layer4_bias_4:13;
        RBus_UInt32  res1:19;
    };
}srnn_wdsr_layer4_3x3_bias_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ssrs_rm_0_0:4;
        RBus_UInt32  ssrs_rm_1_0:4;
        RBus_UInt32  ssrs_rm_1_1:4;
        RBus_UInt32  ssrs_rm_1_2:4;
        RBus_UInt32  ssrs_rm_2_0:4;
        RBus_UInt32  ssrs_rm_2_1:4;
        RBus_UInt32  ssrs_rm_3_0:4;
        RBus_UInt32  ssrs_rm_4_0:4;
    };
}srnn_ssrs_rm_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ssrs_rme_0_0:1;
        RBus_UInt32  ssrs_rme_1_0:1;
        RBus_UInt32  ssrs_rme_1_1:1;
        RBus_UInt32  ssrs_rme_1_2:1;
        RBus_UInt32  ssrs_rme_2_0:1;
        RBus_UInt32  ssrs_rme_2_1:1;
        RBus_UInt32  ssrs_rme_3_0:1;
        RBus_UInt32  ssrs_rme_4_0:1;
        RBus_UInt32  res1:8;
        RBus_UInt32  ssrs_ls_0_0:1;
        RBus_UInt32  ssrs_ls_1_0:1;
        RBus_UInt32  ssrs_ls_1_1:1;
        RBus_UInt32  ssrs_ls_1_2:1;
        RBus_UInt32  ssrs_ls_2_0:1;
        RBus_UInt32  ssrs_ls_2_1:1;
        RBus_UInt32  ssrs_ls_3_0:1;
        RBus_UInt32  ssrs_ls_4_0:1;
        RBus_UInt32  res2:8;
    };
}srnn_ssrs_rme_ls_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ssrs_test1_0_0:1;
        RBus_UInt32  ssrs_test1_1_0:1;
        RBus_UInt32  ssrs_test1_1_1:1;
        RBus_UInt32  ssrs_test1_1_2:1;
        RBus_UInt32  ssrs_test1_2_0:1;
        RBus_UInt32  ssrs_test1_2_1:1;
        RBus_UInt32  ssrs_test1_3_0:1;
        RBus_UInt32  ssrs_test1_4_0:1;
        RBus_UInt32  res1:24;
    };
}srnn_ssrs_test1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ssrs_1_2_7_drf_bist_fail:1;
        RBus_UInt32  ssrs_1_2_6_drf_bist_fail:1;
        RBus_UInt32  ssrs_1_2_5_drf_bist_fail:1;
        RBus_UInt32  ssrs_1_2_4_drf_bist_fail:1;
        RBus_UInt32  ssrs_1_2_3_drf_bist_fail:1;
        RBus_UInt32  ssrs_1_2_2_drf_bist_fail:1;
        RBus_UInt32  ssrs_1_2_1_drf_bist_fail:1;
        RBus_UInt32  ssrs_1_2_0_drf_bist_fail:1;
        RBus_UInt32  ssrs_1_1_7_drf_bist_fail:1;
        RBus_UInt32  ssrs_1_1_6_drf_bist_fail:1;
        RBus_UInt32  ssrs_1_1_5_drf_bist_fail:1;
        RBus_UInt32  ssrs_1_1_4_drf_bist_fail:1;
        RBus_UInt32  ssrs_1_1_3_drf_bist_fail:1;
        RBus_UInt32  ssrs_1_1_2_drf_bist_fail:1;
        RBus_UInt32  ssrs_1_1_1_drf_bist_fail:1;
        RBus_UInt32  ssrs_1_1_0_drf_bist_fail:1;
        RBus_UInt32  ssrs_1_0_7_drf_bist_fail:1;
        RBus_UInt32  ssrs_1_0_6_drf_bist_fail:1;
        RBus_UInt32  ssrs_1_0_5_drf_bist_fail:1;
        RBus_UInt32  ssrs_1_0_4_drf_bist_fail:1;
        RBus_UInt32  ssrs_1_0_3_drf_bist_fail:1;
        RBus_UInt32  ssrs_1_0_2_drf_bist_fail:1;
        RBus_UInt32  ssrs_1_0_1_drf_bist_fail:1;
        RBus_UInt32  ssrs_1_0_0_drf_bist_fail:1;
        RBus_UInt32  ssrs_0_0_3_drf_bist_fail:1;
        RBus_UInt32  ssrs_0_0_2_drf_bist_fail:1;
        RBus_UInt32  ssrs_0_0_1_drf_bist_fail:1;
        RBus_UInt32  ssrs_0_0_0_drf_bist_fail:1;
        RBus_UInt32  res1:4;
    };
}srnn_ssrs_bist_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ssrs_4_0_3_drf_bist_fail:1;
        RBus_UInt32  ssrs_4_0_2_drf_bist_fail:1;
        RBus_UInt32  ssrs_4_0_1_drf_bist_fail:1;
        RBus_UInt32  ssrs_4_0_0_drf_bist_fail:1;
        RBus_UInt32  ssrs_3_0_0_drf_bist_fail:1;
        RBus_UInt32  ssrs_2_1_6_drf_bist_fail:1;
        RBus_UInt32  ssrs_2_1_5_drf_bist_fail:1;
        RBus_UInt32  ssrs_2_1_4_drf_bist_fail:1;
        RBus_UInt32  ssrs_2_1_3_drf_bist_fail:1;
        RBus_UInt32  ssrs_2_1_2_drf_bist_fail:1;
        RBus_UInt32  ssrs_2_1_1_drf_bist_fail:1;
        RBus_UInt32  ssrs_2_1_0_drf_bist_fail:1;
        RBus_UInt32  ssrs_2_0_6_drf_bist_fail:1;
        RBus_UInt32  ssrs_2_0_5_drf_bist_fail:1;
        RBus_UInt32  ssrs_2_0_4_drf_bist_fail:1;
        RBus_UInt32  ssrs_2_0_3_drf_bist_fail:1;
        RBus_UInt32  ssrs_2_0_2_drf_bist_fail:1;
        RBus_UInt32  ssrs_2_0_1_drf_bist_fail:1;
        RBus_UInt32  ssrs_2_0_0_drf_bist_fail:1;
        RBus_UInt32  res1:13;
    };
}srnn_ssrs_bist_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ssrs_1_2_7_bist_fail:1;
        RBus_UInt32  ssrs_1_2_6_bist_fail:1;
        RBus_UInt32  ssrs_1_2_5_bist_fail:1;
        RBus_UInt32  ssrs_1_2_4_bist_fail:1;
        RBus_UInt32  ssrs_1_2_3_bist_fail:1;
        RBus_UInt32  ssrs_1_2_2_bist_fail:1;
        RBus_UInt32  ssrs_1_2_1_bist_fail:1;
        RBus_UInt32  ssrs_1_2_0_bist_fail:1;
        RBus_UInt32  ssrs_1_1_7_bist_fail:1;
        RBus_UInt32  ssrs_1_1_6_bist_fail:1;
        RBus_UInt32  ssrs_1_1_5_bist_fail:1;
        RBus_UInt32  ssrs_1_1_4_bist_fail:1;
        RBus_UInt32  ssrs_1_1_3_bist_fail:1;
        RBus_UInt32  ssrs_1_1_2_bist_fail:1;
        RBus_UInt32  ssrs_1_1_1_bist_fail:1;
        RBus_UInt32  ssrs_1_1_0_bist_fail:1;
        RBus_UInt32  ssrs_1_0_7_bist_fail:1;
        RBus_UInt32  ssrs_1_0_6_bist_fail:1;
        RBus_UInt32  ssrs_1_0_5_bist_fail:1;
        RBus_UInt32  ssrs_1_0_4_bist_fail:1;
        RBus_UInt32  ssrs_1_0_3_bist_fail:1;
        RBus_UInt32  ssrs_1_0_2_bist_fail:1;
        RBus_UInt32  ssrs_1_0_1_bist_fail:1;
        RBus_UInt32  ssrs_1_0_0_bist_fail:1;
        RBus_UInt32  ssrs_0_0_3_bist_fail:1;
        RBus_UInt32  ssrs_0_0_2_bist_fail:1;
        RBus_UInt32  ssrs_0_0_1_bist_fail:1;
        RBus_UInt32  ssrs_0_0_0_bist_fail:1;
        RBus_UInt32  res1:4;
    };
}srnn_ssrs_bist_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ssrs_4_0_3_bist_fail:1;
        RBus_UInt32  ssrs_4_0_2_bist_fail:1;
        RBus_UInt32  ssrs_4_0_1_bist_fail:1;
        RBus_UInt32  ssrs_4_0_0_bist_fail:1;
        RBus_UInt32  ssrs_3_0_0_bist_fail:1;
        RBus_UInt32  ssrs_2_1_6_bist_fail:1;
        RBus_UInt32  ssrs_2_1_5_bist_fail:1;
        RBus_UInt32  ssrs_2_1_4_bist_fail:1;
        RBus_UInt32  ssrs_2_1_3_bist_fail:1;
        RBus_UInt32  ssrs_2_1_2_bist_fail:1;
        RBus_UInt32  ssrs_2_1_1_bist_fail:1;
        RBus_UInt32  ssrs_2_1_0_bist_fail:1;
        RBus_UInt32  ssrs_2_0_6_bist_fail:1;
        RBus_UInt32  ssrs_2_0_5_bist_fail:1;
        RBus_UInt32  ssrs_2_0_4_bist_fail:1;
        RBus_UInt32  ssrs_2_0_3_bist_fail:1;
        RBus_UInt32  ssrs_2_0_2_bist_fail:1;
        RBus_UInt32  ssrs_2_0_1_bist_fail:1;
        RBus_UInt32  ssrs_2_0_0_bist_fail:1;
        RBus_UInt32  res1:13;
    };
}srnn_ssrs_bist_3_RBUS;




#endif 


#endif 
